/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DFmode
      || !register_operand (operands[0], E_DFmode)
      || GET_MODE (x1) != E_DFmode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], E_SFmode))
    return -1;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x4;
      if (!reg_or_0_operand (operands[2], E_DFmode))
        return -1;
      return 0;

    case FLOAT_EXTEND:
      if (GET_MODE (x4) != E_DFmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!reg_or_0_operand (operands[2], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != IF_THEN_ELSE)
    return -1;
  x5 = XEXP (x4, 0);
  if (!alpha_zero_comparison_operator (x5, E_VOIDmode))
    return -1;
  operands[1] = x5;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  return 0;
}

int
pattern29 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !add_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 26)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XVECEXP (x3, 0, 1);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[4] = x11;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x4, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x2, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern35 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern35 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!memory_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_SFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern78 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!reg_or_0_operand (operands[3], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  if (!reg_or_0_operand (operands[4], E_DImode)
      || !add_operand (operands[1], i1)
      || !add_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!reg_or_0_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XEXP (x3, 1);
  operands[4] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  if (!scratch_operand (operands[5], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern86 (x3, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern86 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_8bit_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_8bit_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  return pattern103 (x5, 
i1, 
i2); /* [-1, 0] */
}

int
pattern113 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !and_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (!alpha_fp_comparison_operator (x2, E_DFmode))
    return -1;
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x3;
      if (!reg_or_0_operand (operands[2], E_DFmode))
        return -1;
      x4 = XEXP (x2, 1);
      switch (pattern73 (x4))
        {
        case 0:
          if (!
#line 2608 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 175; /* *cmpdf_internal */

        case 1:
          if (!
#line 2637 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
            return -1;
          return 177; /* *cmpdf_ext2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!reg_or_0_operand (operands[2], E_SFmode))
        return -1;
      x4 = XEXP (x2, 1);
      switch (pattern73 (x4))
        {
        case 0:
          if (!
#line 2625 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
            return -1;
          return 176; /* *cmpdf_ext1 */

        case 1:
          if (!
#line 2650 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
            return -1;
          return 178; /* *cmpdf_ext3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1, pnum_clobbers))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !reg_or_0_operand (operands[1], E_SImode)
                  || !add_operand (operands[2], E_SImode))
                return -1;
              return 3; /* addsi3 */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode)
                return -1;
              if (register_operand (operands[1], E_DImode)
                  && add_operand (operands[2], E_DImode))
                return 13; /* *adddi_internal */
              if (!reg_no_subreg_operand (operands[1], E_DImode)
                  || !const_int_operand (operands[2], E_DImode)
                  || !
#line 469 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(NONSTRICT_REG_OK_FP_BASE_P (operands[1])
   && INTVAL (operands[2]) >= 0
   /* This is the largest constant an lda+ldah pair can add, minus
      an upper bound on the displacement between SP and AP during
      register elimination.  See INITIAL_ELIMINATION_OFFSET.  */
   && INTVAL (operands[2])
	< (0x7fff8000
	   - FIRST_PSEUDO_REGISTER * UNITS_PER_WORD
	   - ALPHA_ROUND(crtl->outgoing_args_size)
	   - (ALPHA_ROUND (get_frame_size ()
			   + max_reg_num () * UNITS_PER_WORD
			   + crtl->args.pretend_args_size)
	      - crtl->args.pretend_args_size))))
                return -1;
              return 14; /* *adddi_fp_hack */

            case E_SFmode:
              if (pattern4 (x2, 
E_SFmode) != 0
                  || !
#line 1664 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                return -1;
              return 110; /* addsf3 */

            case E_DFmode:
              if (pattern4 (x2, 
E_DFmode) != 0
                  || !
#line 1664 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                return -1;
              return 111; /* adddf3 */

            default:
              return -1;
            }

        case HIGH:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (dtp32_symbolic_operand (operands[2], E_DImode))
            return 7; /* *adddi_er_hi32_dtp */
          if (tp32_symbolic_operand (operands[2], E_DImode))
            return 10; /* *adddi_er_hi32_tp */
          if (!local_symbolic_operand (operands[2], E_DImode)
              || !
#line 422 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && reload_completed))
            return -1;
          return 12; /* *adddi_er_high_l */

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern57 (x2, 
E_SImode) != 0)
        return -1;
      return 15; /* *saddl */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern57 (x2, 
E_DImode) != 0)
        return -1;
      return 16; /* *saddq */

    case 3:
      if (!
#line 1681 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
        return -1;
      return 112; /* *adddf_ext1 */

    case 4:
      if (!
#line 1694 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
        return -1;
      return 113; /* *adddf_ext2 */

    case 5:
      x2 = XEXP (x1, 1);
      if (pattern101 (x2, 
E_DImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 187; /* *cmp_sadd_di */

    case 6:
      x2 = XEXP (x1, 1);
      if (pattern101 (x2, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 188; /* *cmp_sadd_si */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_21 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return recog_20 (x1, insn, pnum_clobbers);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x3 = XEXP (x2, 0);
              operands[0] = x3;
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case SIGN_EXTEND:
                  if (pattern26 (x4) != 0
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x5 = XEXP (x4, 0);
                  x6 = XEXP (x5, 0);
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x8 = XEXP (x5, 1);
                  x9 = XEXP (x8, 0);
                  operands[2] = x9;
                  if (!register_operand (operands[2], E_DImode))
                    return -1;
                  switch (pattern98 (x1, pnum_clobbers))
                    {
                    case 0:
                      if (
#line 761 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                        return 40; /* *divmodsi_internal_er */
                      return 42; /* *divmodsi_internal */

                    case 1:
                      if (!
#line 806 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                        return -1;
                      *pnum_clobbers = 2;
                      return 41; /* *divmodsi_internal_er_1 */

                    default:
                      return -1;
                    }

                case DIV:
                case MOD:
                case UDIV:
                case UMOD:
                  operands[3] = x4;
                  if (!divmod_operator (operands[3], E_DImode)
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x10 = XEXP (x4, 1);
                  operands[2] = x10;
                  if (!register_operand (operands[2], E_DImode))
                    return -1;
                  switch (pattern98 (x1, pnum_clobbers))
                    {
                    case 0:
                      if (
#line 831 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                        return 43; /* *divmoddi_internal_er */
                      return 45; /* *divmoddi_internal */

                    case 1:
                      if (!
#line 875 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                        return -1;
                      *pnum_clobbers = 2;
                      return 44; /* *divmoddi_internal_er_1 */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                case MEM:
                  x11 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x11) != CLOBBER)
                    return -1;
                  if (GET_CODE (x4) == SUBREG
                      && known_eq (SUBREG_BYTE (x4), 0)
                      && GET_MODE (x4) == E_SImode)
                    {
                      x5 = XEXP (x4, 0);
                      if (fix_operator (x5, E_DImode))
                        {
                          operands[4] = x5;
                          x12 = XVECEXP (x1, 0, 1);
                          if (GET_CODE (x12) == CLOBBER)
                            {
                              switch (pattern94 (x1))
                                {
                                case 0:
                                  if (
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU))
                                    return 131; /* *fix_truncdfsi_ieee */
                                  break;

                                case 1:
                                  if (
#line 1985 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU))
                                    return 134; /* *fix_truncsfsi_ieee */
                                  break;

                                default:
                                  break;
                                }
                            }
                        }
                    }
                  operands[1] = x4;
                  x12 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x12) == SET)
                    {
                      switch (pattern67 (x1))
                        {
                        case 0:
                          return 300; /* atomic_exchangesi */

                        case 1:
                          return 301; /* atomic_exchangedi */

                        case 2:
                          return 316; /* atomic_fetch_addsi */

                        case 3:
                          return 321; /* atomic_fetch_adddi */

                        case 4:
                          return 317; /* atomic_fetch_subsi */

                        case 5:
                          return 322; /* atomic_fetch_subdi */

                        case 6:
                          return 318; /* atomic_fetch_orsi */

                        case 7:
                          return 323; /* atomic_fetch_ordi */

                        case 8:
                          return 319; /* atomic_fetch_xorsi */

                        case 9:
                          return 324; /* atomic_fetch_xordi */

                        case 10:
                          return 320; /* atomic_fetch_andsi */

                        case 11:
                          return 325; /* atomic_fetch_anddi */

                        case 12:
                          return 326; /* atomic_fetch_nandsi */

                        case 13:
                          return 327; /* atomic_fetch_nanddi */

                        default:
                          break;
                        }
                    }
                  if (GET_CODE (x12) != CLOBBER)
                    return -1;
                  switch (pattern68 (x1))
                    {
                    case 0:
                      if (!
#line 4416 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(!TARGET_BWX && (reload_in_progress || reload_completed)))
                        return -1;
                      return 227; /* reload_outqi_aligned */

                    case 1:
                      if (!
#line 4416 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(!TARGET_BWX && (reload_in_progress || reload_completed)))
                        return -1;
                      return 228; /* reload_outhi_aligned */

                    default:
                      return -1;
                    }

                case FLOAT:
                  x12 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x12) != CLOBBER)
                    return -1;
                  x11 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x11) != CLOBBER)
                    return -1;
                  switch (pattern54 (x1))
                    {
                    case 0:
                      if (!
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU))
                        return -1;
                      return 138; /* *floatsisf2_ieee */

                    case 1:
                      if (!
#line 2116 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU))
                        return -1;
                      return 141; /* *floatsidf2_ieee */

                    default:
                      return -1;
                    }

                case UNSPEC_VOLATILE:
                  if (XVECLEN (x4, 0) != 1
                      || XINT (x4, 1) != 17
                      || GET_MODE (x4) != E_DImode)
                    return -1;
                  x13 = XVECEXP (x4, 0, 0);
                  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x12 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x12) != SET)
                    return -1;
                  x11 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x11) != SET)
                    return -1;
                  x14 = XEXP (x11, 1);
                  if (GET_CODE (x14) != UNSPEC_VOLATILE
                      || XINT (x14, 1) != 17
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x15 = XEXP (x12, 0);
                  operands[1] = x15;
                  x16 = XEXP (x11, 0);
                  operands[2] = x16;
                  x17 = XEXP (x12, 1);
                  switch (GET_CODE (x17))
                    {
                    case UNSPEC_VOLATILE:
                      if (XVECLEN (x17, 0) != 1
                          || XINT (x17, 1) != 17)
                        return -1;
                      x18 = XVECEXP (x17, 0, 0);
                      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                          || XVECLEN (x14, 0) != 6)
                        return -1;
                      switch (pattern121 (x1))
                        {
                        case 0:
                          return 296; /* *atomic_compare_and_swapsi */

                        case 1:
                          return 297; /* *atomic_compare_and_swapdi */

                        default:
                          return -1;
                        }

                    case ZERO_EXTEND:
                      if (pnum_clobbers == NULL
                          || GET_MODE (x17) != E_DImode)
                        return -1;
                      x19 = XEXP (x17, 0);
                      if (GET_CODE (x19) != UNSPEC_VOLATILE
                          || XVECLEN (x19, 0) != 1
                          || XINT (x19, 1) != 17)
                        return -1;
                      x20 = XVECEXP (x19, 0, 0);
                      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                          || XVECLEN (x14, 0) != 7
                          || !register_operand (operands[1], E_DImode))
                        return -1;
                      x21 = XVECEXP (x14, 0, 1);
                      operands[3] = x21;
                      if (!reg_or_8bit_operand (operands[3], E_DImode))
                        return -1;
                      x22 = XVECEXP (x14, 0, 2);
                      operands[4] = x22;
                      if (!reg_or_0_operand (operands[4], E_DImode))
                        return -1;
                      x23 = XVECEXP (x14, 0, 3);
                      operands[5] = x23;
                      if (!register_operand (operands[5], E_DImode))
                        return -1;
                      x24 = XVECEXP (x14, 0, 4);
                      operands[6] = x24;
                      if (!const_int_operand (operands[6], E_SImode))
                        return -1;
                      x25 = XVECEXP (x14, 0, 5);
                      operands[7] = x25;
                      if (!const_int_operand (operands[7], E_SImode))
                        return -1;
                      x26 = XVECEXP (x14, 0, 6);
                      operands[8] = x26;
                      if (!const_int_operand (operands[8], E_SImode))
                        return -1;
                      switch (pattern122 (x1))
                        {
                        case 0:
                          *pnum_clobbers = 1;
                          return 298; /* atomic_compare_and_swapqi_1 */

                        case 1:
                          *pnum_clobbers = 1;
                          return 299; /* atomic_compare_and_swaphi_1 */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern28 (x1))
                    {
                    case 0:
                      return 302; /* atomic_exchangeqi_1 */

                    case 1:
                      return 303; /* atomic_exchangehi_1 */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern30 (x1))
                    {
                    case 0:
                      return 328; /* atomic_add_fetchsi */

                    case 1:
                      return 333; /* atomic_add_fetchdi */

                    default:
                      return -1;
                    }

                case MINUS:
                  switch (pattern32 (x1))
                    {
                    case 0:
                      return 329; /* atomic_sub_fetchsi */

                    case 1:
                      return 334; /* atomic_sub_fetchdi */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern34 (x1, 
IOR))
                    {
                    case 0:
                      return 330; /* atomic_or_fetchsi */

                    case 1:
                      return 335; /* atomic_or_fetchdi */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern34 (x1, 
XOR))
                    {
                    case 0:
                      return 331; /* atomic_xor_fetchsi */

                    case 1:
                      return 336; /* atomic_xor_fetchdi */

                    default:
                      return -1;
                    }

                case AND:
                  switch (pattern36 (x1))
                    {
                    case 0:
                      return 332; /* atomic_and_fetchsi */

                    case 1:
                      return 337; /* atomic_and_fetchdi */

                    default:
                      return -1;
                    }

                case NOT:
                  switch (pattern38 (x1))
                    {
                    case 0:
                      return 338; /* atomic_nand_fetchsi */

                    case 1:
                      return 339; /* atomic_nand_fetchdi */

                    default:
                      return -1;
                    }

                case CALL:
                  x5 = XEXP (x4, 0);
                  if (GET_CODE (x5) != MEM
                      || GET_MODE (x5) != E_DImode)
                    return -1;
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (call_operand (operands[1], E_DImode))
                    {
                      x12 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x12) == USE
                          && pattern7 (x1, 
26, 
29) == 0)
                        {
                          x10 = XEXP (x4, 1);
                          operands[2] = x10;
                          if (
#line 5773 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                            return 340; /* *call_value_osf_1_er_noreturn */
                          if (
#line 5788 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                            return 341; /* *call_value_osf_1_er */
                          if (
#line 5903 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                            return 344; /* *call_value_osf_1_noreturn */
                          if (
#line 6000 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                            return 347; /* *call_value_osf_1 */
                        }
                    }
                  if (pnum_clobbers == NULL
                      || pattern76 (x1) != 0)
                    return -1;
                  x11 = XVECEXP (x1, 0, 2);
                  if (pattern6 (x11, 
29, 
USE) != 0)
                    return -1;
                  x12 = XVECEXP (x1, 0, 1);
                  x27 = XVECEXP (x12, 0, 0);
                  operands[2] = x27;
                  if (!const_int_operand (operands[2], E_DImode))
                    return -1;
                  switch (XINT (x12, 1))
                    {
                    case 12:
                      *pnum_clobbers = 1;
                      return 345; /* call_value_osf_tlsgd */

                    case 13:
                      *pnum_clobbers = 1;
                      return 346; /* call_value_osf_tlsldm */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case CALL:
              x3 = XEXP (x2, 0);
              if (GET_CODE (x3) != MEM
                  || GET_MODE (x3) != E_DImode)
                return -1;
              x12 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x12) != USE
                  || pattern7 (x1, 
26, 
29) != 0)
                return -1;
              x28 = XEXP (x3, 0);
              operands[0] = x28;
              if (!call_operand (operands[0], E_DImode))
                return -1;
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              if (
#line 3371 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return 193; /* *call_osf_1_er_noreturn */
              if (
#line 3385 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                return 194; /* *call_osf_1_er */
              if (
#line 3493 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return 197; /* *call_osf_1_noreturn */
              if (!
#line 3507 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                return -1;
              return 198; /* *call_osf_1 */

            default:
              return -1;
            }

        case 5:
          x11 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x11) != USE)
            return -1;
          x29 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x29) != CLOBBER)
            return -1;
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != REG
              || GET_MODE (x30) != E_DImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x3 = XEXP (x2, 0);
              operands[0] = x3;
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case SIGN_EXTEND:
                  if (pattern26 (x4) != 0
                      || pattern90 (x1) != 0
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x5 = XEXP (x4, 0);
                  x6 = XEXP (x5, 0);
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x8 = XEXP (x5, 1);
                  x9 = XEXP (x8, 0);
                  operands[2] = x9;
                  if (!register_operand (operands[2], E_DImode))
                    return -1;
                  x12 = XVECEXP (x1, 0, 1);
                  x15 = XEXP (x12, 0);
                  operands[4] = x15;
                  if (!register_operand (operands[4], E_DImode))
                    return -1;
                  x16 = XEXP (x11, 0);
                  operands[5] = x16;
                  if (!const_int_operand (operands[5], E_VOIDmode)
                      || !
#line 806 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                    return -1;
                  return 41; /* *divmodsi_internal_er_1 */

                case DIV:
                case MOD:
                case UDIV:
                case UMOD:
                  operands[3] = x4;
                  if (!divmod_operator (operands[3], E_DImode)
                      || pattern90 (x1) != 0
                      || !register_operand (operands[0], E_DImode))
                    return -1;
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x10 = XEXP (x4, 1);
                  operands[2] = x10;
                  if (!register_operand (operands[2], E_DImode))
                    return -1;
                  x12 = XVECEXP (x1, 0, 1);
                  x15 = XEXP (x12, 0);
                  operands[4] = x15;
                  if (!register_operand (operands[4], E_DImode))
                    return -1;
                  x16 = XEXP (x11, 0);
                  operands[5] = x16;
                  if (!const_int_operand (operands[5], E_VOIDmode)
                      || !
#line 875 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                    return -1;
                  return 44; /* *divmoddi_internal_er_1 */

                case CALL:
                  x5 = XEXP (x4, 0);
                  if (GET_CODE (x5) != MEM
                      || GET_MODE (x5) != E_DImode)
                    return -1;
                  x31 = XVECEXP (x1, 0, 3);
                  if (GET_CODE (x31) != USE
                      || REGNO (x30) != 26)
                    return -1;
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  switch (pattern100 (x1))
                    {
                    case 0:
                      if (!
#line 5877 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                        return -1;
                      return 342; /* *call_value_osf_2_er_nogp */

                    case 1:
                      if (!
#line 5891 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                        return -1;
                      return 343; /* *call_value_osf_2_er */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case CALL:
              x3 = XEXP (x2, 0);
              if (GET_CODE (x3) != MEM
                  || GET_MODE (x3) != E_DImode)
                return -1;
              x31 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x31) != USE
                  || REGNO (x30) != 26)
                return -1;
              switch (pattern69 (x1))
                {
                case 0:
                  if (!
#line 3469 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                    return -1;
                  return 195; /* *call_osf_2_er_nogp */

                case 1:
                  if (!
#line 3482 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                    return -1;
                  return 196; /* *call_osf_2_er */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case CALL:
              if (pnum_clobbers == NULL)
                return -1;
              x3 = XEXP (x2, 0);
              if (GET_CODE (x3) != MEM
                  || GET_MODE (x3) != E_DImode)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != USE)
                return -1;
              x31 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x31) != USE)
                return -1;
              switch (pattern69 (x1))
                {
                case 0:
                  if (!
#line 3469 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                    return -1;
                  *pnum_clobbers = 1;
                  return 195; /* *call_osf_2_er_nogp */

                case 1:
                  if (!
#line 3482 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                    return -1;
                  *pnum_clobbers = 1;
                  return 196; /* *call_osf_2_er */

                default:
                  return -1;
                }

            case SET:
              x3 = XEXP (x2, 0);
              operands[0] = x3;
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case UNSPEC_VOLATILE:
                  if (pattern22 (x1) != 0)
                    return -1;
                  switch (pattern123 (x1))
                    {
                    case 0:
                      return 298; /* atomic_compare_and_swapqi_1 */

                    case 1:
                      return 299; /* atomic_compare_and_swaphi_1 */

                    default:
                      return -1;
                    }

                case CALL:
                  x5 = XEXP (x4, 0);
                  if (GET_CODE (x5) != MEM
                      || GET_MODE (x5) != E_DImode)
                    return -1;
                  x11 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x11) != USE)
                    return -1;
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  switch (GET_CODE (operands[1]))
                    {
                    case REG:
                    case SUBREG:
                      if (pnum_clobbers == NULL
                          || !register_operand (operands[1], E_DImode))
                        return -1;
                      x31 = XVECEXP (x1, 0, 3);
                      if (GET_CODE (x31) != USE)
                        return -1;
                      switch (pattern100 (x1))
                        {
                        case 0:
                          if (!
#line 5877 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                            return -1;
                          *pnum_clobbers = 1;
                          return 342; /* *call_value_osf_2_er_nogp */

                        case 1:
                          if (!
#line 5891 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                            return -1;
                          *pnum_clobbers = 1;
                          return 343; /* *call_value_osf_2_er */

                        default:
                          return -1;
                        }

                    case CONST:
                    case LABEL_REF:
                    case SYMBOL_REF:
                      if (pattern76 (x1) != 0
                          || pattern84 (x1) != 0)
                        return -1;
                      x12 = XVECEXP (x1, 0, 1);
                      x27 = XVECEXP (x12, 0, 0);
                      operands[2] = x27;
                      if (!const_int_operand (operands[2], E_DImode))
                        return -1;
                      switch (XINT (x12, 1))
                        {
                        case 12:
                          return 345; /* call_value_osf_tlsgd */

                        case 13:
                          return 346; /* call_value_osf_tlsldm */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 1:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 201; /* blockage */

            case 0:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 206; /* imb */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != REG
                  || REGNO (x2) != 16
                  || GET_MODE (x2) != E_DImode)
                return -1;
              return 209; /* *set_tp */

            case 8:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 267; /* prologue_mcount */

            case 2:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              return 270; /* *builtin_setjmp_receiver_1 */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!
#line 5079 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_ABI_OSF && TARGET_EXPLICIT_RELOCS))
                return -1;
              return 271; /* *builtin_setjmp_receiver_er_sl_1 */

            case 7:
              x2 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x2))
                {
                case SUBREG:
                case MEM:
                  operands[0] = x2;
                  if (!memory_operand (operands[0], E_DImode)
                      || !
#line 5101 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_ABI_OSF && flag_reorder_blocks_and_partition))
                    return -1;
                  return 272; /* *exception_receiver_2 */

                case CONST_INT:
                  if (XWINT (x2, 0) != 0L)
                    return -1;
                  return 273; /* *exception_receiver_1 */

                default:
                  return -1;
                }

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 275; /* trapb */

            case 6:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_VOIDmode))
                return -1;
              return 279; /* realign */

            default:
              return -1;
            }

        case 2:
          if (XINT (x1, 1) != 5)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          operands[1] = x12;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 261; /* prologue_stack_probe_loop */

        default:
          return -1;
        }

    case RETURN:
      if (!
#line 3617 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(reload_completed))
        return -1;
      return 203; /* *return_internal */

    case PREFETCH:
      x32 = XEXP (x1, 0);
      operands[0] = x32;
      if (!address_operand (operands[0], E_DImode))
        return -1;
      x33 = XEXP (x1, 1);
      operands[1] = x33;
      if (!const_int_operand (operands[1], E_DImode))
        return -1;
      x34 = XEXP (x1, 2);
      operands[2] = x34;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      return 274; /* prefetch */

    case CONST_INT:
      switch (XWINT (x1, 0))
        {
        case 0L:
          return 276; /* nop */

        case 1L:
          if (!
#line 5218 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 277; /* fnop */

        case 2L:
          return 278; /* unop */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
