/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case TRAP_IF:
          return 0;

        case SET:
          return 1;

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x8 = XEXP (x5, 0);
      if (!alpha_zero_comparison_operator (x8, E_VOIDmode))
        return -1;
      operands[1] = x8;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x5, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 26)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 3
      || XINT (x5, 1) != 28)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER
      || !register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  x8 = XVECEXP (x5, 0, 0);
  operands[2] = x8;
  if (!reg_or_8bit_operand (operands[2], E_DImode))
    return -1;
  x9 = XVECEXP (x5, 0, 1);
  operands[3] = x9;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x5, 0, 2);
  operands[4] = x10;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x11 = XEXP (x6, 0);
  operands[5] = x11;
  if (!scratch_operand (operands[5], E_DImode))
    return -1;
  return pattern27 (x4); /* [-1, 1] */
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_DImode)
      || !symbolic_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  return 0;
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern67 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (XINT (x3, 1))
    {
    case 28:
      x8 = XVECEXP (x3, 0, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern60 (x3, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern60 (x3, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 26:
      x8 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x8))
        {
        case PLUS:
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern61 (x3, 
E_SImode) != 0)
                return -1;
              return 2;

            case E_DImode:
              if (pattern61 (x3, 
E_DImode) != 0)
                return -1;
              return 3;

            default:
              return -1;
            }

        case MINUS:
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern62 (x3, 
E_SImode) != 0)
                return -1;
              return 4;

            case E_DImode:
              if (pattern62 (x3, 
E_DImode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        case IOR:
          res = pattern64 (x3);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case XOR:
          res = pattern64 (x3);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case AND:
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern65 (x3, 
E_SImode) != 0)
                return -1;
              return 10;

            case E_DImode:
              if (pattern65 (x3, 
E_DImode) != 0)
                return -1;
              return 11;

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x8, 0);
          if (GET_CODE (x10) != AND)
            return -1;
          x11 = XEXP (x10, 1);
          operands[2] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern66 (x3, 
E_SImode) != 0)
                return -1;
              return 12;

            case E_DImode:
              if (pattern66 (x3, 
E_DImode) != 0)
                return -1;
              return 13;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 1);
  operands[3] = x7;
  if (!reg_or_8bit_operand (operands[3], E_DImode))
    return -1;
  x8 = XVECEXP (x6, 0, 2);
  operands[4] = x8;
  if (!reg_or_0_operand (operands[4], E_DImode))
    return -1;
  x9 = XVECEXP (x6, 0, 3);
  operands[5] = x9;
  if (!register_operand (operands[5], E_DImode))
    return -1;
  x10 = XVECEXP (x6, 0, 4);
  operands[6] = x10;
  if (!const_int_operand (operands[6], E_SImode))
    return -1;
  x11 = XVECEXP (x6, 0, 5);
  operands[7] = x11;
  if (!const_int_operand (operands[7], E_SImode))
    return -1;
  x12 = XVECEXP (x6, 0, 6);
  operands[8] = x12;
  if (!const_int_operand (operands[8], E_SImode))
    return -1;
  x13 = XVECEXP (x1, 0, 3);
  x14 = XEXP (x13, 0);
  operands[9] = x14;
  if (!scratch_operand (operands[9], E_DImode))
    return -1;
  return pattern122 (x1); /* [-1, 1] */
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !reg_or_bwx_memory_operand (operands[1], E_QImode))
            return -1;
          return 48; /* zero_extendqihi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!reg_or_bwx_memory_operand (operands[1], E_QImode))
                return -1;
              return 49; /* zero_extendqisi2 */

            case E_HImode:
              if (!reg_or_bwx_memory_operand (operands[1], E_HImode))
                return -1;
              return 51; /* zero_extendhisi2 */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!reg_or_bwx_memory_operand (operands[1], E_QImode))
                return -1;
              return 50; /* zero_extendqidi2 */

            case E_HImode:
              if (!reg_or_bwx_memory_operand (operands[1], E_HImode))
                return -1;
              return 52; /* zero_extendhidi2 */

            case E_SImode:
              if (!register_operand (operands[1], E_SImode))
                return -1;
              return 53; /* zero_extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!reg_or_0_operand (operands[1], E_V8QImode))
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || GET_MODE (x4) != E_V2QImode
              || !
#line 5732 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 289; /* *unpkbl */

        case 4:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x9 = XVECEXP (x5, 0, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x10 = XVECEXP (x5, 0, 3);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || !register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || GET_MODE (x4) != E_V4QImode
              || !
#line 5758 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 290; /* *unpkbw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (register_operand (operands[0], E_VOIDmode))
    {
      x3 = XEXP (x1, 1);
      if (alpha_comparison_operator (x3, E_VOIDmode))
        {
          operands[1] = x3;
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (register_operand (operands[2], E_DImode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (reg_or_8bit_operand (operands[3], E_DImode)
                  && 
#line 2267 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(GET_MODE_CLASS (GET_MODE (operands[0])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[0])) <= 8
   && GET_MODE (operands[0]) == GET_MODE (operands[1])))
                return 146; /* *setcc_internal */
            }
        }
    }
  if (register_operand (operands[0], E_DFmode))
    {
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!register_operand (operands[0], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  if (alpha_swapped_comparison_operator (operands[1], E_VOIDmode))
    {
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (reg_or_0_operand (operands[3], E_DImode)
          && 
#line 2281 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(GET_MODE_CLASS (GET_MODE (operands[0])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[0])) <= 8
   && GET_MODE (operands[0]) == GET_MODE (operands[1])))
        return 147; /* *setcc_swapped_internal */
    }
  if (!signed_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(GET_MODE_CLASS (GET_MODE (operands[0])) == MODE_INT
   && GET_MODE_SIZE (GET_MODE (operands[0])) <= 8
   && GET_CODE (operands[1]) == NE
   && GET_MODE (operands[0]) == GET_MODE (operands[1])))
    return -1;
  return 148; /* *setne_internal */
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      if (peep2_current_count < 2)
        return NULL;
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      if (!hard_int_register_operand (operands[0], E_SImode))
        return NULL;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x4) != SET)
        return NULL;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!hard_int_register_operand (operands[2], E_DImode))
        return NULL;
      x7 = XEXP (x5, 0);
      if (!rtx_equal_p (x7, operands[0])
          || !
#line 278 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(true_regnum (operands[0]) == true_regnum (operands[2])
   || peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_1 (insn, operands);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != USE
              || pattern7 (x1, 
26, 
29) != 0)
            return NULL;
          x9 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x9))
            {
            case CALL:
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != MEM
                  || GET_MODE (x10) != E_DImode)
                return NULL;
              x11 = XEXP (x10, 0);
              operands[0] = x11;
              if (!call_operand (operands[0], E_DImode))
                return NULL;
              x12 = XEXP (x9, 1);
              operands[1] = x12;
              if (
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF && reload_completed
   && ! samegp_function_operand (operands[0], Pmode)
   && (peep2_regno_dead_p (1, 29)
       || find_reg_note (insn, REG_NORETURN, NULL_RTX))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_2 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!
#line 3431 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF && reload_completed
   && ! samegp_function_operand (operands[0], Pmode)
   && ! (peep2_regno_dead_p (1, 29)
         || find_reg_note (insn, REG_NORETURN, NULL_RTX))))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_3 (insn, operands);

            case SET:
              x12 = XEXP (x9, 1);
              if (GET_CODE (x12) != CALL)
                return NULL;
              x13 = XEXP (x12, 0);
              if (GET_CODE (x13) != MEM
                  || GET_MODE (x13) != E_DImode)
                return NULL;
              x10 = XEXP (x9, 0);
              operands[0] = x10;
              x14 = XEXP (x13, 0);
              operands[1] = x14;
              if (!call_operand (operands[1], E_DImode))
                return NULL;
              x15 = XEXP (x12, 1);
              operands[2] = x15;
              if (
#line 5804 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF && reload_completed
   && ! samegp_function_operand (operands[1], Pmode)
   && (peep2_regno_dead_p (1, 29)
       || find_reg_note (insn, REG_NORETURN, NULL_RTX))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_4 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!
#line 5837 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF && reload_completed
   && ! samegp_function_operand (operands[1], Pmode)
   && ! (peep2_regno_dead_p (1, 29)
         || find_reg_note (insn, REG_NORETURN, NULL_RTX))))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_5 (insn, operands);

            default:
              return NULL;
            }

        case 4:
          x9 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x9) != SET)
            return NULL;
          x12 = XEXP (x9, 1);
          if (GET_CODE (x12) != CALL)
            return NULL;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != MEM
              || GET_MODE (x13) != E_DImode)
            return NULL;
          x15 = XEXP (x12, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1)
            return NULL;
          x16 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x16) != USE
              || pattern84 (x1) != 0)
            return NULL;
          x10 = XEXP (x9, 0);
          operands[0] = x10;
          x14 = XEXP (x13, 0);
          operands[1] = x14;
          if (!symbolic_operand (operands[1], E_DImode))
            return NULL;
          x17 = XVECEXP (x8, 0, 0);
          operands[2] = x17;
          if (!const_int_operand (operands[2], E_DImode))
            return NULL;
          switch (XINT (x8, 1))
            {
            case 12:
              if (
#line 5943 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(HAVE_AS_TLS && reload_completed
   && peep2_regno_dead_p (1, 29)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_6 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!
#line 5972 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(HAVE_AS_TLS && reload_completed
   && !peep2_regno_dead_p (1, 29)))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_8 (insn, operands);

            case 13:
              if (
#line 5943 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(HAVE_AS_TLS && reload_completed
   && peep2_regno_dead_p (1, 29)))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_7 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (!
#line 5972 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(HAVE_AS_TLS && reload_completed
   && !peep2_regno_dead_p (1, 29)))
                return NULL;
              *pmatch_len_ = 0;
              return gen_peephole2_9 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
