/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      return 0;

    case ASHIFT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return 1;

        case E_DImode:
          return 2;

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      res = pattern0 (x3);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    case IF_THEN_ELSE:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      if (!alpha_zero_comparison_operator (x5, E_VOIDmode))
        return -1;
      operands[1] = x5;
      x8 = XEXP (x5, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x5, 0);
      operands[2] = x10;
      if (!reg_or_0_operand (operands[2], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x3, 1);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          return 5;

        case E_SImode:
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !reg_or_8bit_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != 26)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_CODE (x7) != NOT)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != AND)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x4, 0);
  operands[1] = x10;
  x11 = XEXP (x4, 1);
  operands[2] = x11;
  x12 = XVECEXP (x6, 0, 1);
  operands[3] = x12;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x13 = XEXP (x9, 0);
  operands[4] = x13;
  x14 = XEXP (x8, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x8, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x5, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern37 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern37 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !add_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!symbolic_operand (operands[1], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1)
    return -1;
  return 0;
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          return pattern80 (x2, 
E_QImode); /* [-1, 0] */

        case E_HImode:
          if (pattern80 (x2, 
E_HImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern80 (x2, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern80 (x2, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case LABEL_REF:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      return 4;

    default:
      return -1;
    }
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  x9 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x9))
    {
    case USE:
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 29
          || GET_MODE (x10) != E_DImode)
        return -1;
      return 0;

    case SET:
      x11 = XEXP (x9, 1);
      if (GET_CODE (x11) != UNSPEC
          || XVECLEN (x11, 0) != 2
          || XINT (x11, 1) != 2
          || GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 29
          || GET_MODE (x12) != E_DImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 29
          || GET_MODE (x10) != E_DImode)
        return -1;
      x13 = XVECEXP (x11, 0, 1);
      operands[5] = x13;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  if (!divmod_operator (operands[3], E_DImode))
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  if (
#line 831 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
    {
      *pnum_clobbers = 2;
      return 43; /* *divmoddi_internal_er */
    }
  *pnum_clobbers = 2;
  return 45; /* *divmoddi_internal */
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern49 (x3, 
E_SImode) != 0)
            return -1;
          return 46; /* *andsi_internal */

        case E_DImode:
          if (pattern49 (x3, 
E_DImode) != 0)
            return -1;
          return 47; /* anddi3 */

        case E_V8QImode:
          if (pattern46 (x3, 
E_V8QImode) != 0)
            return -1;
          return 243; /* andv8qi3 */

        case E_V4HImode:
          if (pattern46 (x3, 
E_V4HImode) != 0)
            return -1;
          return 244; /* andv4hi3 */

        case E_V2SImode:
          if (pattern46 (x3, 
E_V2SImode) != 0)
            return -1;
          return 245; /* andv2si3 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x6;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern50 (x3, 
E_SImode) != 0)
                return -1;
              return 54; /* andnotsi3 */

            case E_DImode:
              if (pattern50 (x3, 
E_DImode) != 0)
                return -1;
              return 55; /* andnotdi3 */

            case E_V8QImode:
              if (pattern59 (x3, 
E_V8QImode) != 0)
                return -1;
              return 246; /* *andnotv8qi3 */

            case E_V4HImode:
              if (pattern59 (x3, 
E_V4HImode) != 0)
                return -1;
              return 247; /* *andnotv4hi3 */

            case E_V2SImode:
              if (pattern59 (x3, 
E_V2SImode) != 0)
                return -1;
              return 248; /* *andnotv2si3 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != ASHIFT
              || GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x6, 0);
          operands[2] = x9;
          if (!mode_mask_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x7, 0);
          operands[3] = x10;
          if (!reg_or_8bit_operand (operands[3], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!reg_or_0_operand (operands[1], E_DImode))
            return -1;
          return 95; /* mskxl */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != ASHIFT
          || GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x11, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x13 = XEXP (x11, 0);
      operands[2] = x13;
      if (!reg_or_8bit_operand (operands[2], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!mode_mask_operand (operands[3], E_DImode))
        return -1;
      return 81; /* *extxl_1 */

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x11 = XEXP (x4, 1);
      operands[2] = x11;
      if (!mul8_operand (operands[2], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_DImode)
          || !
#line 1498 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(((unsigned HOST_WIDE_INT) 0xff << INTVAL (operands[2])
    == (unsigned HOST_WIDE_INT) INTVAL (operands[3]))
    || ((unsigned HOST_WIDE_INT) 0xffff << INTVAL (operands[2])
        == (unsigned HOST_WIDE_INT) INTVAL (operands[3]))
    || ((unsigned HOST_WIDE_INT) 0xffffffff << INTVAL (operands[2])
        == (unsigned HOST_WIDE_INT) INTVAL (operands[3]))))
        return -1;
      return 93; /* *insxl */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 20
          || GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x14 = XVECEXP (x4, 0, 0);
      switch (GET_CODE (x14))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x14;
          if (!reg_or_cint_operand (operands[2], E_QImode)
              || !reg_or_cint_operand (operands[1], E_DImode))
            return -1;
          return 281; /* *builtin_zap_1 */

        case NOT:
          if (GET_MODE (x14) != E_QImode)
            return -1;
          x15 = XEXP (x14, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_QImode)
              || !reg_or_0_operand (operands[1], E_DImode))
            return -1;
          return 282; /* *builtin_zapnot_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SIGN_EXTEND:
          if (pattern10 (x1) != 0)
            return NULL;
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              x5 = XEXP (x4, 0);
              switch (GET_CODE (x5))
                {
                case REG:
                case SUBREG:
                  operands[1] = x5;
                  if (!reg_not_elim_operand (operands[1], E_SImode))
                    return NULL;
                  x6 = XEXP (x4, 1);
                  operands[2] = x6;
                  if (!const_int_operand (operands[2], E_SImode))
                    return NULL;
                  x7 = XVECEXP (x1, 0, 1);
                  x8 = XEXP (x7, 0);
                  operands[3] = x8;
                  if (!reg_not_elim_operand (operands[3], E_SImode)
                      || !
#line 337 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! sext_add_operand (operands[2], SImode) && INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) % 4 == 0))
                    return NULL;
                  return gen_split_3 (insn, operands);

                case NE:
                case EQ:
                case GE:
                case GT:
                case LE:
                case LT:
                case LTGT:
                case GEU:
                case GTU:
                case LEU:
                case LTU:
                case UNORDERED:
                case ORDERED:
                case UNEQ:
                case UNGE:
                case UNGT:
                case UNLE:
                case UNLT:
                  operands[1] = x5;
                  if (!comparison_operator (operands[1], E_SImode))
                    return NULL;
                  x9 = XEXP (x5, 0);
                  operands[2] = x9;
                  x10 = XEXP (x5, 1);
                  operands[3] = x10;
                  x6 = XEXP (x4, 1);
                  operands[4] = x6;
                  if (!add_operand (operands[4], E_SImode))
                    return NULL;
                  x7 = XVECEXP (x1, 0, 1);
                  x8 = XEXP (x7, 0);
                  operands[5] = x8;
                  if (!register_operand (operands[5], E_DImode))
                    return NULL;
                  return gen_split_4 (insn, operands);

                case ASHIFT:
                  if (GET_MODE (x5) != E_SImode)
                    return NULL;
                  x9 = XEXP (x5, 0);
                  if (!comparison_operator (x9, E_SImode))
                    return NULL;
                  operands[1] = x9;
                  x11 = XEXP (x9, 0);
                  operands[2] = x11;
                  x12 = XEXP (x9, 1);
                  operands[3] = x12;
                  x10 = XEXP (x5, 1);
                  operands[4] = x10;
                  if (!const23_operand (operands[4], E_SImode))
                    return NULL;
                  x6 = XEXP (x4, 1);
                  operands[5] = x6;
                  if (!sext_add_operand (operands[5], E_SImode))
                    return NULL;
                  x7 = XVECEXP (x1, 0, 1);
                  x8 = XEXP (x7, 0);
                  operands[6] = x8;
                  if (!reg_not_elim_operand (operands[6], E_DImode))
                    return NULL;
                  return gen_split_7 (insn, operands);

                case IF_THEN_ELSE:
                  if (pattern91 (x4) != 0)
                    return NULL;
                  x7 = XVECEXP (x1, 0, 1);
                  x8 = XEXP (x7, 0);
                  operands[5] = x8;
                  if (!scratch_operand (operands[5], E_DImode))
                    return NULL;
                  return gen_split_37 (insn, operands);

                default:
                  return NULL;
                }

            case MINUS:
              if (pattern83 (x4) != 0)
                return NULL;
              x7 = XVECEXP (x1, 0, 1);
              x8 = XEXP (x7, 0);
              operands[5] = x8;
              if (!scratch_operand (operands[5], E_DImode))
                return NULL;
              return gen_split_40 (insn, operands);

            default:
              return NULL;
            }

        case ABS:
          x13 = XEXP (x2, 0);
          operands[0] = x13;
          x7 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x7))
            {
            case USE:
              if (!register_operand (operands[0], E_TFmode)
                  || GET_MODE (x3) != E_TFmode)
                return NULL;
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              if (!reg_or_0_operand (operands[1], E_TFmode))
                return NULL;
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_DImode)
                  || !(
#line 1611 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_HAS_XFLOATING_LIBS) && 
#line 1613 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
                return NULL;
              return gen_split_12 (insn, operands);

            case CLOBBER:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x4 = XEXP (x3, 0);
              if (!rtx_equal_p (x4, operands[0]))
                return NULL;
              return gen_split_22 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          x13 = XEXP (x2, 0);
          operands[0] = x13;
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!reg_or_0_operand (operands[1], E_TFmode))
                return NULL;
              x7 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x7) != USE
                  || !register_operand (operands[0], E_TFmode)
                  || GET_MODE (x3) != E_TFmode)
                return NULL;
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_DImode)
                  || !(
#line 1635 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_HAS_XFLOATING_LIBS) && 
#line 1637 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
                return NULL;
              return gen_split_13 (insn, operands);

            case ABS:
              if (GET_MODE (x4) != E_DImode)
                return NULL;
              x7 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x7) != CLOBBER
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x5 = XEXP (x4, 0);
              if (!rtx_equal_p (x5, operands[0]))
                return NULL;
              return gen_split_24 (insn, operands);

            default:
              return NULL;
            }

        case SUBREG:
          if (maybe_ne (SUBREG_BYTE (x3), 0)
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XEXP (x3, 0);
          if (!fix_operator (x4, E_DImode))
            return NULL;
          operands[3] = x4;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return NULL;
          x13 = XEXP (x2, 0);
          operands[0] = x13;
          if (!memory_operand (operands[0], E_SImode))
            return NULL;
          switch (pattern93 (x1))
            {
            case 0:
              if (!(
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU) && 
#line 1938 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
                return NULL;
              return gen_split_15 (insn, operands);

            case 1:
              if (!(
#line 2002 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU) && 
#line 2004 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
                return NULL;
              return gen_split_17 (insn, operands);

            default:
              return NULL;
            }

        case SMAX:
          if (pattern20 (x1) != 0
              || !
#line 2442 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(operands[2] != const0_rtx))
            return NULL;
          return gen_split_26 (insn, operands);

        case SMIN:
          if (pattern20 (x1) != 0
              || !
#line 2470 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(operands[2] != const0_rtx))
            return NULL;
          return gen_split_27 (insn, operands);

        case UMAX:
          if (pattern20 (x1) != 0
              || !
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(operands[2] != const0_rtx))
            return NULL;
          return gen_split_28 (insn, operands);

        case UMIN:
          if (pattern20 (x1) != 0
              || !
#line 2518 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(operands[2] != const0_rtx))
            return NULL;
          return gen_split_29 (insn, operands);

        case IF_THEN_ELSE:
          x4 = XEXP (x3, 0);
          if (!comparison_operator (x4, E_VOIDmode))
            return NULL;
          operands[1] = x4;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return NULL;
          x8 = XEXP (x7, 0);
          if (!register_operand (x8, E_DImode))
            return NULL;
          x5 = XEXP (x4, 0);
          switch (GET_CODE (x5))
            {
            case ZERO_EXTRACT:
              if (GET_MODE (x5) != E_DImode)
                return NULL;
              x10 = XEXP (x5, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x6 = XEXP (x4, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x14 = XEXP (x3, 1);
              if (GET_CODE (x14) != LABEL_REF)
                return NULL;
              x15 = XEXP (x3, 2);
              if (GET_CODE (x15) != PC)
                return NULL;
              x13 = XEXP (x2, 0);
              if (GET_CODE (x13) != PC)
                return NULL;
              x9 = XEXP (x5, 0);
              operands[2] = x9;
              if (!register_operand (operands[2], E_DImode))
                return NULL;
              x16 = XEXP (x5, 2);
              operands[3] = x16;
              if (!const_int_operand (operands[3], E_DImode))
                return NULL;
              x17 = XEXP (x14, 0);
              operands[0] = x17;
              operands[4] = x8;
              if (!
#line 2586 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(INTVAL (operands[3]) != 0))
                return NULL;
              return gen_split_30 (insn, operands);

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              operands[2] = x5;
              x13 = XEXP (x2, 0);
              operands[0] = x13;
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              x6 = XEXP (x4, 1);
              operands[3] = x6;
              if (reg_or_cint_operand (operands[3], E_DImode)
                  && reg_or_0_operand (operands[2], E_DImode))
                {
                  x14 = XEXP (x3, 1);
                  operands[4] = x14;
                  if (reg_or_cint_operand (operands[4], E_DImode))
                    {
                      x15 = XEXP (x3, 2);
                      operands[5] = x15;
                      if (reg_or_cint_operand (operands[5], E_DImode))
                        {
                          operands[6] = x8;
                          if (
#line 2926 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(operands[3] != const0_rtx))
                            return gen_split_31 (insn, operands);
                        }
                    }
                }
              if (!reg_or_cint_operand (operands[3], E_SImode)
                  || !reg_or_0_operand (operands[2], E_SImode))
                return NULL;
              x14 = XEXP (x3, 1);
              operands[4] = x14;
              if (!reg_or_8bit_operand (operands[4], E_DImode))
                return NULL;
              x15 = XEXP (x3, 2);
              operands[5] = x15;
              if (!reg_or_8bit_operand (operands[5], E_DImode))
                return NULL;
              operands[6] = x8;
              if (!
#line 2983 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(operands[3] != const0_rtx
   && (GET_CODE (operands[1]) == EQ || GET_CODE (operands[1]) == NE)))
                return NULL;
              return gen_split_32 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          if (pattern21 (x1) != 0)
            return NULL;
          switch (pattern87 (x1))
            {
            case 0:
              return gen_split_35 (insn, operands);

            case 1:
              return gen_split_36 (insn, operands);

            default:
              return NULL;
            }

        case MINUS:
          if (pattern21 (x1) != 0)
            return NULL;
          switch (pattern89 (x1))
            {
            case 0:
              return gen_split_38 (insn, operands);

            case 1:
              return gen_split_39 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 3:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return NULL;
      x18 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x18) != CLOBBER)
        return NULL;
      x13 = XEXP (x2, 0);
      operands[0] = x13;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SIGN_EXTEND:
          if (pattern26 (x3) != 0
              || pattern77 (x1) != 0
              || !register_operand (operands[0], E_DImode))
            return NULL;
          x4 = XEXP (x3, 0);
          x5 = XEXP (x4, 0);
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_DImode))
            return NULL;
          x6 = XEXP (x4, 1);
          x19 = XEXP (x6, 0);
          operands[2] = x19;
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 761 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF) && 
#line 763 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
            return NULL;
          return gen_split_8 (insn, operands);

        case DIV:
        case MOD:
        case UDIV:
        case UMOD:
          operands[3] = x3;
          if (!divmod_operator (operands[3], E_DImode)
              || pattern77 (x1) != 0
              || !register_operand (operands[0], E_DImode))
            return NULL;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode))
            return NULL;
          x14 = XEXP (x3, 1);
          operands[2] = x14;
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 831 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF) && 
#line 833 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
            return NULL;
          return gen_split_9 (insn, operands);

        case SUBREG:
          if (maybe_ne (SUBREG_BYTE (x3), 0)
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XEXP (x3, 0);
          if (!fix_operator (x4, E_DImode))
            return NULL;
          operands[4] = x4;
          switch (pattern94 (x1))
            {
            case 0:
              if (!(
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU) && 
#line 1920 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
                return NULL;
              return gen_split_14 (insn, operands);

            case 1:
              if (!(
#line 1985 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU) && 
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
                return NULL;
              return gen_split_16 (insn, operands);

            default:
              return NULL;
            }

        case FLOAT:
          switch (pattern54 (x1))
            {
            case 0:
              if (!(
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU) && 
#line 2076 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
                return NULL;
              return gen_split_18 (insn, operands);

            case 1:
              if (!(
#line 2116 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU) && 
#line 2118 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
                return NULL;
              return gen_split_20 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
