/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !reg_or_0_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !reg_or_0_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !and_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern3 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern3 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_SFmode:
      if (pattern4 (x1, 
E_SFmode) != 0)
        return -1;
      return 2;

    case E_DFmode:
      if (pattern4 (x1, 
E_DFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 26)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XVECEXP (x3, 0, 1);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[4] = x11;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x4, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x2, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern29 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern29 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DFmode
      || !register_operand (operands[0], E_DFmode)
      || GET_MODE (x1) != E_DFmode
      || !reg_or_0_operand (operands[1], E_DFmode))
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!reg_or_0_operand (operands[2], E_SFmode))
    return -1;
  return 0;
}

int
pattern53 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case USE:
      if (pnum_clobbers == NULL)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 29
          || GET_MODE (x2) != E_DImode)
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 10)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 29
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !and_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[3] = x1;
      if (!reg_or_0_operand (operands[3], E_DFmode))
        return -1;
      return 0;

    case FLOAT_EXTEND:
      if (GET_MODE (x1) != E_DFmode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      if (!reg_or_0_operand (operands[3], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SIGN_EXTEND)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 23
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  x6 = XEXP (x5, 0);
  if (REGNO (x6) != 28)
    return -1;
  return 0;
}

int
pattern98 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      return pattern7 (x1, 
28, 
23); /* [-1, 0] */

    case USE:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XEXP (x2, 0);
      operands[4] = x4;
      if (!register_operand (operands[4], E_DImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[5] = x5;
      if (!const_int_operand (operands[5], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !reg_or_8bit_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      operands[2] = x4;
      if (GET_CODE (x5) != PC)
        return -1;
      operands[1] = x3;
      x6 = XEXP (x3, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case LABEL_REF:
              x8 = XEXP (x2, 2);
              if (GET_CODE (x8) == PC
                  && reg_or_0_operand (operands[2], E_DImode))
                {
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  return 171; /* *bcc_normal */
                }
              break;

            case PC:
              x8 = XEXP (x2, 2);
              if (GET_CODE (x8) == LABEL_REF
                  && register_operand (operands[2], E_DImode))
                {
                  x10 = XEXP (x8, 0);
                  operands[0] = x10;
                  return 172; /* *bcc_reverse */
                }
              break;

            default:
              break;
            }
        }
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC
          || !reg_or_0_operand (operands[2], E_DFmode))
        return -1;
      operands[3] = x6;
      if (!const0_operand (operands[3], E_DFmode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!
#line 2789 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
        return -1;
      return 185; /* *fbcc_normal */

    case FLOAT_EXTEND:
      if (GET_MODE (x4) != E_DFmode)
        return -1;
      x11 = XEXP (x4, 0);
      if (!reg_or_0_operand (x11, E_SFmode))
        return -1;
      x6 = XEXP (x3, 1);
      if (!const0_operand (x6, E_DFmode))
        return -1;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x7;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          operands[3] = x3;
          operands[4] = x11;
          operands[2] = x6;
          x8 = XEXP (x2, 2);
          operands[5] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern108 (x2, 
E_DFmode) != 0
                  || !
#line 2693 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
                return -1;
              return 182; /* *movdfcc_ext2 */

            case E_SFmode:
              if (pattern108 (x2, 
E_SFmode) != 0
                  || !
#line 2708 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
                return -1;
              return 183; /* *movdfcc_ext3 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          if (GET_MODE (x7) != E_DFmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode)
            return -1;
          operands[3] = x3;
          operands[4] = x11;
          operands[2] = x6;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!reg_or_0_operand (operands[1], E_SFmode))
            return -1;
          x8 = XEXP (x2, 2);
          operands[5] = x8;
          if (!reg_or_0_operand (operands[5], E_DFmode)
              || !
#line 2723 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
            return -1;
          return 184; /* *movdfcc_ext4 */

        case LABEL_REF:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) != PC)
            return -1;
          operands[1] = x3;
          operands[2] = x11;
          operands[3] = x6;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!
#line 2802 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 186; /* *fbcc_ext_normal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !reg_or_8bit_operand (operands[1], E_SImode))
            return -1;
          return 58; /* *one_cmplsi_internal */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !reg_or_8bit_operand (operands[1], E_DImode))
            return -1;
          return 59; /* one_cmpldi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode))
            return -1;
          return 240; /* one_cmplv8qi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode))
            return -1;
          return 241; /* one_cmplv4hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode))
            return -1;
          return 242; /* one_cmplv2si2 */

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern52 (x3, 
E_SImode) != 0)
            return -1;
          return 64; /* *xornotsi3 */

        case E_DImode:
          if (pattern52 (x3, 
E_DImode) != 0)
            return -1;
          return 65; /* *xornotdi3 */

        case E_V8QImode:
          if (pattern52 (x3, 
E_V8QImode) != 0)
            return -1;
          return 258; /* *xornotv8qi3 */

        case E_V4HImode:
          if (pattern52 (x3, 
E_V4HImode) != 0)
            return -1;
          return 259; /* *xornotv4hi3 */

        case E_V2SImode:
          if (pattern52 (x3, 
E_V2SImode) != 0)
            return -1;
          return 260; /* *xornotv2si3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
