/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_8bit_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !add_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern24 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != NE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != SIGN_EXTEND)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x1, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !or_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!reg_or_0_operand (operands[1], E_DImode)
      || !reg_or_8bit_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !and_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_not_elim_operand (operands[1], i1)
      || !const23_operand (operands[2], i1)
      || !sext_add_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern63 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern63 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 26)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  return pattern74 (x1); /* [-1, 1] */
}

int
pattern80 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_8bit_operand (operands[1], i1)
      || !reg_or_8bit_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !const48_operand (operands[3], i1)
      || !sext_add_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!reg_or_0_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case FLOAT_EXTEND:
      if (GET_MODE (x1) != E_DFmode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      if (!reg_or_0_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern106 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern106 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern116 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !add_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  operands[5] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern78 (x2, 
E_QImode) != 0
              || !
#line 2316 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
((operands[3] == const0_rtx) ^ (operands[4] == const0_rtx)))
            return -1;
          return 149; /* *movqicc_internal */

        case E_HImode:
          if (pattern78 (x2, 
E_HImode) != 0
              || !
#line 2316 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
((operands[3] == const0_rtx) ^ (operands[4] == const0_rtx)))
            return -1;
          return 150; /* *movhicc_internal */

        case E_SImode:
          if (pattern78 (x2, 
E_SImode) != 0
              || !
#line 2316 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
((operands[3] == const0_rtx) ^ (operands[4] == const0_rtx)))
            return -1;
          return 151; /* *movsicc_internal */

        case E_DImode:
          if (pattern78 (x2, 
E_DImode) != 0
              || !
#line 2316 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
((operands[3] == const0_rtx) ^ (operands[4] == const0_rtx)))
            return -1;
          return 152; /* *movdicc_internal */

        case E_SFmode:
          if (pattern79 (x2, 
E_SFmode) != 0
              || !
#line 2664 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 179; /* *movsfcc_internal */

        case E_DFmode:
          if (pattern79 (x2, 
E_DFmode) != 0
              || !
#line 2664 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 180; /* *movdfcc_internal */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x4) != E_DFmode
          || !register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      if (!reg_or_0_operand (operands[4], E_DFmode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!const0_operand (operands[2], E_DFmode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!reg_or_0_operand (operands[1], E_SFmode)
          || !reg_or_0_operand (operands[5], E_DFmode)
          || !
#line 2678 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
        return -1;
      return 181; /* *movdfcc_ext1 */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 9:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 221; /* force_movdi */

        case 3:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          return 269; /* builtin_longjmp_internal */

        case 13:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          return 285; /* builtin_rpcc */

        case 15:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !memory_operand (operands[1], E_SImode))
                return -1;
              return 292; /* load_locked_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !memory_operand (operands[1], E_DImode))
                return -1;
              return 293; /* load_locked_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 10:
          if (
#line 4920 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
            return 262; /* *ldgp_er_1 */
          return 265; /* *prologue_ldgp_1 */

        case 11:
          if (
#line 4938 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
            return 264; /* *prologue_ldgp_er_2 */
          return 266; /* *prologue_ldgp_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      return recog_7 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_8 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_13 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (dtp16_symbolic_operand (operands[2], E_DImode))
        return 6; /* *adddi_er_lo16_dtp */
      if (dtp32_symbolic_operand (operands[2], E_DImode))
        return 8; /* *adddi_er_lo32_dtp */
      if (tp16_symbolic_operand (operands[2], E_DImode))
        return 9; /* *adddi_er_lo16_tp */
      if (tp32_symbolic_operand (operands[2], E_DImode))
        return 11; /* *adddi_er_lo32_tp */
      if (!local_symbolic_operand (operands[2], E_DImode)
          || !
#line 3857 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS))
        return -1;
      return 214; /* *movdi_er_low_l */

    case NEG:
      return recog_14 (x1, insn, pnum_clobbers);

    case MINUS:
      switch (pattern1 (x1, pnum_clobbers))
        {
        case 0:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              switch (pattern23 (x2))
                {
                case 0:
                  return 25; /* subsi3 */

                case 1:
                  return 26; /* subdi3 */

                case 2:
                  if (!
#line 1712 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                    return -1;
                  return 114; /* subsf3 */

                case 3:
                  if (!
#line 1712 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                    return -1;
                  return 115; /* subdf3 */

                default:
                  return -1;
                }

            case FLOAT_EXTEND:
              if (pattern44 (x2) != 0
                  || !
#line 1741 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
                return -1;
              return 117; /* *subdf_ext2 */

            default:
              return -1;
            }

        case 1:
          if (pattern58 (x2, 
E_SImode) != 0)
            return -1;
          return 29; /* *ssubl */

        case 2:
          if (pattern58 (x2, 
E_DImode) != 0)
            return -1;
          return 30; /* *ssubq */

        case 3:
          if (!
#line 1729 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
            return -1;
          return 116; /* *subdf_ext1 */

        case 4:
          if (!
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
            return -1;
          return 118; /* *subdf_ext3 */

        case 5:
          if (pattern102 (x2, 
E_DImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 190; /* *cmp_ssub_di */

        case 6:
          if (pattern102 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 191; /* *cmp_ssub_si */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern23 (x2))
            {
            case 0:
              return 34; /* mulsi3 */

            case 1:
              return 35; /* muldi3 */

            case 2:
              if (!
#line 1772 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                return -1;
              return 119; /* mulsf3 */

            case 3:
              if (!
#line 1772 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                return -1;
              return 120; /* muldf3 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          switch (pattern0 (x2))
            {
            case 0:
              if (!
#line 1789 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
                return -1;
              return 121; /* *muldf_ext1 */

            case 1:
              if (!
#line 1802 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
                return -1;
              return 122; /* *muldf_ext2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UMUL_HIGHPART:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!reg_or_8bit_operand (operands[2], E_DImode))
        return -1;
      return 39; /* umuldi3_highpart */

    case DIV:
    case MOD:
    case UDIV:
    case UMOD:
      if (pnum_clobbers != NULL)
        {
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x2) != DIV)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern4 (x2, 
E_SFmode) != 0
                      || !
#line 1820 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                    return -1;
                  return 123; /* divsf3 */

                case E_DFmode:
                  if (pattern4 (x2, 
E_DFmode) != 0
                      || !
#line 1820 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                    return -1;
                  return 124; /* divdf3 */

                default:
                  return -1;
                }

            case FLOAT_EXTEND:
              if (pattern44 (x2) != 0
                  || !
#line 1849 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
                return -1;
              return 126; /* *divdf_ext2 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          switch (pattern0 (x2))
            {
            case 0:
              if (!
#line 1837 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
                return -1;
              return 125; /* *divdf_ext1 */

            case 1:
              if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
                return -1;
              return 127; /* *divdf_ext3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      return recog_9 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_12 (x1, insn, pnum_clobbers);

    case IOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern45 (x2, 
E_SImode) != 0)
                return -1;
              return 56; /* *iorsi_internal */

            case E_DImode:
              if (pattern45 (x2, 
E_DImode) != 0)
                return -1;
              return 57; /* iordi3 */

            case E_V8QImode:
              if (pattern46 (x2, 
E_V8QImode) != 0)
                return -1;
              return 249; /* iorv8qi3 */

            case E_V4HImode:
              if (pattern46 (x2, 
E_V4HImode) != 0)
                return -1;
              return 250; /* iorv4hi3 */

            case E_V2SImode:
              if (pattern46 (x2, 
E_V2SImode) != 0)
                return -1;
              return 251; /* iorv2si3 */

            default:
              return -1;
            }

        case NOT:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern50 (x2, 
E_SImode) != 0)
                return -1;
              return 60; /* *iornotsi3 */

            case E_DImode:
              if (pattern50 (x2, 
E_DImode) != 0)
                return -1;
              return 61; /* *iornotdi3 */

            case E_V8QImode:
              if (pattern51 (x2, 
E_V8QImode) != 0)
                return -1;
              return 252; /* *iornotv8qi3 */

            case E_V4HImode:
              if (pattern51 (x2, 
E_V4HImode) != 0)
                return -1;
              return 253; /* *iornotv4hi3 */

            case E_V2SImode:
              if (pattern51 (x2, 
E_V2SImode) != 0)
                return -1;
              return 254; /* *iornotv2si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      return recog_16 (x1, insn, pnum_clobbers);

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern45 (x2, 
E_SImode) != 0)
            return -1;
          return 62; /* *xorsi_internal */

        case E_DImode:
          if (pattern45 (x2, 
E_DImode) != 0)
            return -1;
          return 63; /* xordi3 */

        case E_V8QImode:
          if (pattern46 (x2, 
E_V8QImode) != 0)
            return -1;
          return 255; /* xorv8qi3 */

        case E_V4HImode:
          if (pattern46 (x2, 
E_V4HImode) != 0)
            return -1;
          return 256; /* xorv4hi3 */

        case E_V2SImode:
          if (pattern46 (x2, 
E_V2SImode) != 0)
            return -1;
          return 257; /* xorv2si3 */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_CIX))
        return -1;
      return 66; /* clzdi2 */

    case CTZ:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_CIX))
        return -1;
      return 67; /* ctzdi2 */

    case POPCOUNT:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 1091 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_CIX))
        return -1;
      return 68; /* popcountdi2 */

    case ASHIFT:
      return recog_11 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          if (!reg_or_6bit_operand (operands[2], E_DImode))
            return -1;
          return 72; /* lshrdi3 */

        case ASHIFT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x7 = XEXP (x5, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!reg_or_8bit_operand (operands[2], E_DImode))
            return -1;
          return 82; /* *extql_2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!reg_or_6bit_operand (operands[2], E_DImode))
        return -1;
      return 73; /* ashrdi3 */

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (mode_width_operand (operands[2], E_DImode))
        {
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x5, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x2, 2);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 1568 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[2]) < 8))
        return -1;
      return 97; /* *ze_and_ne */

    case ABS:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1588 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 98; /* abssf2 */

        case 1:
          if (!
#line 1588 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 99; /* absdf2 */

        default:
          return -1;
        }

    case SQRT:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && TARGET_FIX))
            return -1;
          return 128; /* sqrtsf2 */

        case 1:
          if (!
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && TARGET_FIX))
            return -1;
          return 129; /* sqrtdf2 */

        default:
          return -1;
        }

    case FIX:
    case UNSIGNED_FIX:
      operands[2] = x2;
      if (!fix_operator (operands[2], E_DImode))
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!reg_no_subreg_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!reg_or_0_operand (operands[1], E_DFmode)
              || !
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 133; /* *fix_truncdfdi2 */

        case FLOAT_EXTEND:
          if (GET_MODE (x4) != E_DFmode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!reg_or_0_operand (operands[1], E_SFmode)
              || !
#line 2019 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 136; /* *fix_truncsfdi2 */

        default:
          return -1;
        }

    case FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
          if (!reg_no_subreg_operand (operands[1], E_DImode))
            return -1;
          switch (pattern39 (x2))
            {
            case 0:
              if (!
#line 2057 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                return -1;
              return 137; /* floatdisf2 */

            case 1:
              if (!
#line 2099 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                return -1;
              return 140; /* floatdidf2 */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          switch (pattern39 (x2))
            {
            case 0:
              if (pnum_clobbers != NULL
                  && 
#line 2074 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU))
                {
                  *pnum_clobbers = 2;
                  return 138; /* *floatsisf2_ieee */
                }
              if (!
#line 2085 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                return -1;
              return 139; /* *floatsisf2 */

            case 1:
              if (pnum_clobbers != NULL
                  && 
#line 2116 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU))
                {
                  *pnum_clobbers = 2;
                  return 141; /* *floatsidf2_ieee */
                }
              if (!
#line 2127 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                return -1;
              return 142; /* *floatsidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (register_operand (operands[1], E_SFmode)
          && 
#line 2178 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU))
        return 143; /* *extendsfdf2_ieee */
      if (!nonimmediate_operand (operands[1], E_SFmode)
          || !
#line 2186 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
        return -1;
      return 144; /* *extendsfdf2_internal */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_DFmode)
          || !
#line 2216 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
        return -1;
      return 145; /* truncdfsf2 */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
      return recog_17 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          if (signed_comparison_operator (x4, E_VOIDmode))
            {
              res = recog_5 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != ZERO_EXTRACT
              || GET_MODE (x6) != E_DImode)
            return -1;
          x10 = XEXP (x6, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x11 = XEXP (x6, 2);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XEXP (x4, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x13 = XEXP (x6, 0);
          if (!reg_or_0_operand (x13, E_DImode))
            return -1;
          switch (GET_CODE (x4))
            {
            case EQ:
              switch (pattern81 (x1))
                {
                case 0:
                  return 153; /* *movqicc_lbc */

                case 1:
                  return 154; /* *movhicc_lbc */

                case 2:
                  return 155; /* *movsicc_lbc */

                case 3:
                  return 156; /* *movdicc_lbc */

                case 4:
                  return 174; /* *blbc_normal */

                default:
                  return -1;
                }

            case NE:
              switch (pattern81 (x1))
                {
                case 0:
                  return 157; /* *movqicc_lbs */

                case 1:
                  return 158; /* *movhicc_lbs */

                case 2:
                  return 159; /* *movsicc_lbs */

                case 3:
                  return 160; /* *movdicc_lbs */

                case 4:
                  return 173; /* *blbs_normal */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern3 (x2, 
E_QImode) == 0
              && 
#line 2423 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return 161; /* smaxqi3 */
          break;

        case E_HImode:
          if (pattern3 (x2, 
E_HImode) == 0
              && 
#line 2423 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return 165; /* smaxhi3 */
          break;

        case E_V8QImode:
          if (pattern4 (x2, 
E_V8QImode) == 0
              && 
#line 4487 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return 232; /* smaxv8qi3 */
          break;

        case E_V4HImode:
          if (pattern4 (x2, 
E_V4HImode) == 0
              && 
#line 4487 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return 236; /* smaxv4hi3 */
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_DImode)
          || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      return 169; /* *smax_const0 */

    case SMIN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern3 (x2, 
E_QImode) == 0
              && 
#line 2423 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return 162; /* sminqi3 */
          break;

        case E_HImode:
          if (pattern3 (x2, 
E_HImode) == 0
              && 
#line 2423 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return 166; /* sminhi3 */
          break;

        case E_V8QImode:
          if (pattern4 (x2, 
E_V8QImode) == 0
              && 
#line 4487 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return 233; /* sminv8qi3 */
          break;

        case E_V4HImode:
          if (pattern4 (x2, 
E_V4HImode) == 0
              && 
#line 4487 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return 237; /* sminv4hi3 */
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_DImode)
          || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      return 170; /* *smin_const0 */

    case UMAX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 2423 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 163; /* umaxqi3 */

        case 1:
          if (!
#line 2423 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 167; /* umaxhi3 */

        case 2:
          if (!
#line 4487 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 234; /* umaxv8qi3 */

        case 3:
          if (!
#line 4487 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 238; /* umaxv4hi3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 2423 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 164; /* uminqi3 */

        case 1:
          if (!
#line 2423 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 168; /* uminhi3 */

        case 2:
          if (!
#line 4487 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 235; /* uminv8qi3 */

        case 3:
          if (!
#line 4487 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 239; /* uminv4hi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_10 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_15 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_V4QImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (!const0_operand (x5, E_V4QImode))
        return -1;
      switch (GET_CODE (x4))
        {
        case VEC_CONCAT:
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != TRUNCATE
              || GET_MODE (x6) != E_V2QImode)
            return -1;
          x13 = XEXP (x6, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          x12 = XEXP (x4, 1);
          operands[2] = x12;
          if (!const0_operand (operands[2], E_V2QImode))
            return -1;
          operands[3] = x5;
          if (!
#line 5691 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 287; /* *pklb */

        case TRUNCATE:
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          operands[2] = x5;
          if (!
#line 5712 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 288; /* *pkwb */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
