/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!reg_or_0_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!reg_or_8bit_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!mem_noofs_operand (operands[1], E_QImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!mem_noofs_operand (operands[1], E_HImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern56 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x2;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      return 0;

    case ASHIFT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_not_elim_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const23_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[3] = x3;
      return 1;

    case IF_THEN_ELSE:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (!alpha_zero_comparison_operator (x4, E_VOIDmode))
        return -1;
      operands[1] = x4;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!reg_or_0_operand (operands[2], E_DImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!const48_operand (operands[3], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[4] = x3;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  return pattern92 (x7); /* [-1, 1] */
}

int
pattern97 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !and_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern103 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern112 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_8bit_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !sext_add_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  return pattern103 (x5, 
i1, 
i2); /* [-1, 0] */
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (!fix_operator (x3, E_DImode))
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_DFmode))
        return -1;
      operands[4] = x3;
      if (
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU))
        {
          *pnum_clobbers = 2;
          return 131; /* *fix_truncdfsi_ieee */
        }
      operands[3] = x3;
      if (!
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
        return -1;
      *pnum_clobbers = 1;
      return 132; /* *fix_truncdfsi_internal */

    case FLOAT_EXTEND:
      if (GET_MODE (x5) != E_DFmode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!reg_or_0_operand (operands[1], E_SFmode))
        return -1;
      operands[4] = x3;
      if (
#line 1985 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm >= ALPHA_FPTM_SU))
        {
          *pnum_clobbers = 2;
          return 134; /* *fix_truncsfsi_ieee */
        }
      operands[3] = x3;
      if (!
#line 2002 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
        return -1;
      *pnum_clobbers = 1;
      return 135; /* *fix_truncsfsi_internal */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !reg_or_8bit_operand (operands[1], E_SImode))
            return -1;
          return 20; /* negsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !reg_or_8bit_operand (operands[1], E_DImode))
            return -1;
          return 21; /* negdi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !reg_or_0_operand (operands[1], E_SFmode)
              || !
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 103; /* negsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !reg_or_0_operand (operands[1], E_DFmode)
              || !
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 104; /* negdf2 */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern43 (x3, 
E_SFmode) != 0
              || !
#line 1596 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 100; /* *nabssf2 */

        case E_DFmode:
          if (pattern43 (x3, 
E_DFmode) != 0
              || !
#line 1596 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 101; /* *nabsdf2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 24)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x4, 0, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern72 (x3, 
E_SFmode) != 0
              || !
#line 1656 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 108; /* *ncopysignsf3 */

        case E_DFmode:
          if (pattern72 (x3, 
E_DFmode) != 0
              || !
#line 1656 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 109; /* *ncopysigndf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (!fix_operator (x4, E_DImode))
    return -1;
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  switch (pattern93 (x1))
    {
    case 0:
      if (!
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
        return -1;
      return 132; /* *fix_truncdfsi_internal */

    case 1:
      if (!
#line 2002 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP && alpha_fptm < ALPHA_FPTM_SU))
        return -1;
      return 135; /* *fix_truncsfsi_internal */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case PLUS:
          switch (pattern9 (x1))
            {
            case 0:
              x4 = XVECEXP (x1, 0, 1);
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != NE)
                return -1;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != PLUS)
                return -1;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != SIGN_EXTEND)
                return -1;
              x8 = XEXP (x6, 1);
              if (GET_CODE (x8) != SIGN_EXTEND
                  || pattern82 (x4, 
PLUS) != 0)
                return -1;
              x9 = XEXP (x8, 0);
              if (!rtx_equal_p (x9, operands[2]))
                return -1;
              x10 = XEXP (x5, 1);
              x11 = XEXP (x10, 0);
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              x13 = XEXP (x11, 1);
              if (!rtx_equal_p (x13, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern118 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 18; /* addvsi3 */

                case E_DImode:
                  if (pattern118 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 19; /* addvdi3 */

                default:
                  return -1;
                }

            case 1:
              x4 = XVECEXP (x1, 0, 1);
              switch (pattern75 (x4, pnum_clobbers, 
PLUS))
                {
                case 0:
                  if (pattern116 (x1, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 328; /* atomic_add_fetchsi */

                case 1:
                  if (pattern116 (x1, 
E_DImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 333; /* atomic_add_fetchdi */

                default:
                  return -1;
                }

            case 2:
              switch (pattern87 (x1))
                {
                case 0:
                  return 187; /* *cmp_sadd_di */

                case 1:
                  return 188; /* *cmp_sadd_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          x15 = XEXP (x3, 0);
          operands[1] = x15;
          x4 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x4))
            {
            case TRAP_IF:
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != NE)
                return -1;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != NEG)
                return -1;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != SIGN_EXTEND
                  || pattern82 (x4, 
NEG) != 0)
                return -1;
              x10 = XEXP (x5, 1);
              x11 = XEXP (x10, 0);
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern109 (x1, 
E_SImode, 
E_DImode) != 0)
                    return -1;
                  return 23; /* negvsi2 */

                case E_DImode:
                  if (pattern109 (x1, 
E_DImode, 
E_TImode) != 0)
                    return -1;
                  return 24; /* negvdi2 */

                default:
                  return -1;
                }

            case USE:
              if (!register_operand (operands[0], E_TFmode)
                  || GET_MODE (x3) != E_TFmode
                  || !reg_or_0_operand (operands[1], E_TFmode))
                return -1;
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 1635 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_HAS_XFLOATING_LIBS))
                return -1;
              return 105; /* *negtf_internal */

            default:
              return -1;
            }

        case MINUS:
          switch (pattern9 (x1))
            {
            case 0:
              x4 = XVECEXP (x1, 0, 1);
              if (pattern24 (x4, 
MINUS) != 0)
                return -1;
              switch (pattern105 (x1))
                {
                case 0:
                  return 32; /* subvsi3 */

                case 1:
                  return 33; /* subvdi3 */

                default:
                  return -1;
                }

            case 1:
              x4 = XVECEXP (x1, 0, 1);
              switch (pattern75 (x4, pnum_clobbers, 
MINUS))
                {
                case 0:
                  if (pattern117 (x1, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 329; /* atomic_sub_fetchsi */

                case 1:
                  if (pattern117 (x1, 
E_DImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 334; /* atomic_sub_fetchdi */

                default:
                  return -1;
                }

            case 2:
              switch (pattern89 (x1))
                {
                case 0:
                  return 190; /* *cmp_ssub_di */

                case 1:
                  return 191; /* *cmp_ssub_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MULT:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != TRAP_IF
              || pattern24 (x4, 
MULT) != 0)
            return -1;
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          x15 = XEXP (x3, 0);
          operands[1] = x15;
          x16 = XEXP (x3, 1);
          operands[2] = x16;
          switch (pattern105 (x1))
            {
            case 0:
              return 37; /* mulvsi3 */

            case 1:
              return 38; /* mulvdi3 */

            default:
              return -1;
            }

        case ABS:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return -1;
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          if (!register_operand (operands[0], E_TFmode))
            return -1;
          x15 = XEXP (x3, 0);
          operands[1] = x15;
          if (!reg_or_0_operand (operands[1], E_TFmode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 1611 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_HAS_XFLOATING_LIBS))
            return -1;
          return 102; /* *abstf_internal */

        case REG:
        case SUBREG:
        case MEM:
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!register_operand (x3, E_DImode))
            return -1;
          switch (GET_CODE (x14))
            {
            case PC:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != USE)
                return -1;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != LABEL_REF)
                return -1;
              operands[0] = x3;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              return 205; /* *tablejump_internal */

            case REG:
            case SUBREG:
              operands[0] = x14;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_BLKmode)
                return -1;
              operands[1] = x3;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!register_operand (operands[2], E_DImode))
                return -1;
              return 268; /* init_fp */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern10 (x1) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x5 = XEXP (x4, 0);
          operands[5] = x5;
          if (!scratch_operand (operands[5], E_DImode))
            return -1;
          x15 = XEXP (x3, 0);
          switch (GET_CODE (x15))
            {
            case PLUS:
              x17 = XEXP (x15, 0);
              if (GET_CODE (x17) != IF_THEN_ELSE
                  || pattern91 (x15) != 0)
                return -1;
              return 189; /* *cmp_sadd_sidi */

            case MINUS:
              if (pattern83 (x15) != 0)
                return -1;
              return 192; /* *cmp_ssub_sidi */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 16
              || GET_MODE (x3) != E_DImode)
            return -1;
          x18 = XVECEXP (x3, 0, 0);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x19 = XEXP (x4, 1);
          operands[2] = x19;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!memory_operand (operands[1], E_SImode)
                  || !reg_or_0_operand (operands[2], E_SImode))
                return -1;
              return 294; /* store_conditional_si */

            case E_DImode:
              if (!memory_operand (operands[1], E_DImode)
                  || !reg_or_0_operand (operands[2], E_DImode))
                return -1;
              return 295; /* store_conditional_di */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x19 = XEXP (x4, 1);
          if (GET_CODE (x19) != UNSPEC
              || XVECLEN (x19, 0) != 3
              || XINT (x19, 1) != 28)
            return -1;
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x15 = XEXP (x3, 0);
          operands[1] = x15;
          x20 = XVECEXP (x19, 0, 0);
          operands[2] = x20;
          if (!reg_or_8bit_operand (operands[2], E_DImode))
            return -1;
          x21 = XVECEXP (x19, 0, 1);
          operands[3] = x21;
          if (!register_operand (operands[3], E_DImode))
            return -1;
          x22 = XVECEXP (x19, 0, 2);
          operands[4] = x22;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (pattern27 (x4))
            {
            case 0:
              *pnum_clobbers = 1;
              return 302; /* atomic_exchangeqi_1 */

            case 1:
              *pnum_clobbers = 1;
              return 303; /* atomic_exchangehi_1 */

            default:
              return -1;
            }

        case UNSPEC:
          switch (pattern17 (x1))
            {
            case 0:
              return 304; /* atomic_addsi */

            case 1:
              return 309; /* atomic_adddi */

            case 2:
              return 305; /* atomic_subsi */

            case 3:
              return 310; /* atomic_subdi */

            case 4:
              return 306; /* atomic_orsi */

            case 5:
              return 311; /* atomic_ordi */

            case 6:
              return 307; /* atomic_xorsi */

            case 7:
              return 312; /* atomic_xordi */

            case 8:
              return 308; /* atomic_andsi */

            case 9:
              return 313; /* atomic_anddi */

            case 10:
              return 314; /* atomic_nandsi */

            case 11:
              return 315; /* atomic_nanddi */

            default:
              return -1;
            }

        case IOR:
          switch (pattern19 (x1, pnum_clobbers, 
IOR))
            {
            case 0:
              *pnum_clobbers = 1;
              return 330; /* atomic_or_fetchsi */

            case 1:
              *pnum_clobbers = 1;
              return 335; /* atomic_or_fetchdi */

            default:
              return -1;
            }

        case XOR:
          switch (pattern19 (x1, pnum_clobbers, 
XOR))
            {
            case 0:
              *pnum_clobbers = 1;
              return 331; /* atomic_xor_fetchsi */

            case 1:
              *pnum_clobbers = 1;
              return 336; /* atomic_xor_fetchdi */

            default:
              return -1;
            }

        case AND:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern25 (x4, 
AND) != 0)
            return -1;
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          x15 = XEXP (x3, 0);
          operands[1] = x15;
          x16 = XEXP (x3, 1);
          operands[2] = x16;
          switch (pattern74 (x4))
            {
            case 0:
              if (pattern115 (x1, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 332; /* atomic_and_fetchsi */

            case 1:
              if (pattern115 (x1, 
E_DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 337; /* atomic_and_fetchdi */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x15 = XEXP (x3, 0);
          if (GET_CODE (x15) != AND)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern25 (x4, 
NOT) != 0)
            return -1;
          x19 = XEXP (x4, 1);
          x20 = XVECEXP (x19, 0, 0);
          x23 = XEXP (x20, 0);
          if (GET_CODE (x23) != AND)
            return -1;
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          x17 = XEXP (x15, 0);
          operands[1] = x17;
          x24 = XEXP (x15, 1);
          operands[2] = x24;
          x21 = XVECEXP (x19, 0, 1);
          operands[3] = x21;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x25 = XEXP (x23, 0);
          if (!rtx_equal_p (x25, operands[1]))
            return -1;
          x26 = XEXP (x23, 1);
          if (!rtx_equal_p (x26, operands[2]))
            return -1;
          x5 = XEXP (x4, 0);
          if (!rtx_equal_p (x5, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern119 (x1, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 338; /* atomic_nand_fetchsi */

            case E_DImode:
              if (pattern119 (x1, 
E_DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 339; /* atomic_nand_fetchdi */

            default:
              return -1;
            }

        case CALL:
          x15 = XEXP (x3, 0);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_DImode)
            return -1;
          x14 = XEXP (x2, 0);
          operands[0] = x14;
          x17 = XEXP (x15, 0);
          operands[1] = x17;
          x16 = XEXP (x3, 1);
          operands[2] = x16;
          x4 = XVECEXP (x1, 0, 1);
          switch (pattern53 (x4, pnum_clobbers))
            {
            case 0:
              if (!call_operand (operands[1], E_DImode))
                return -1;
              if (
#line 5773 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                {
                  *pnum_clobbers = 1;
                  return 340; /* *call_value_osf_1_er_noreturn */
                }
              if (
#line 5788 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                {
                  *pnum_clobbers = 1;
                  return 341; /* *call_value_osf_1_er */
                }
              if (
#line 5903 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                {
                  *pnum_clobbers = 1;
                  return 344; /* *call_value_osf_1_noreturn */
                }
              if (!
#line 6000 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                return -1;
              *pnum_clobbers = 1;
              return 347; /* *call_value_osf_1 */

            case 1:
              if (!symbolic_operand (operands[1], E_DImode))
                return -1;
              if (
#line 6013 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                return 348; /* *sibcall_value_osf_1_er */
              if (!
#line 6025 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
                return -1;
              return 349; /* *sibcall_value_osf_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x14 = XEXP (x2, 0);
      if (GET_CODE (x14) != MEM
          || GET_MODE (x14) != E_DImode)
        return -1;
      x27 = XEXP (x14, 0);
      operands[0] = x27;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x4 = XVECEXP (x1, 0, 1);
      switch (pattern53 (x4, pnum_clobbers))
        {
        case 0:
          if (!call_operand (operands[0], E_DImode))
            return -1;
          if (
#line 3371 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
            {
              *pnum_clobbers = 1;
              return 193; /* *call_osf_1_er_noreturn */
            }
          if (
#line 3385 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
            {
              *pnum_clobbers = 1;
              return 194; /* *call_osf_1_er */
            }
          if (
#line 3493 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
            {
              *pnum_clobbers = 1;
              return 197; /* *call_osf_1_noreturn */
            }
          if (!
#line 3507 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
            return -1;
          *pnum_clobbers = 1;
          return 198; /* *call_osf_1 */

        case 1:
          if (!symbolic_operand (operands[0], E_DImode))
            return -1;
          if (
#line 3519 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
            return 199; /* *sibcall_osf_1_er */
          if (!
#line 3532 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
            return -1;
          return 200; /* *sibcall_osf_1 */

        default:
          return -1;
        }

    case TRAP_IF:
      x14 = XEXP (x2, 0);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 29
          || GET_MODE (x5) != E_DImode)
        return -1;
      return 207; /* trap */

    default:
      return -1;
    }
}
