/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern3 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern3 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern4 (x3, 
E_V8QImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern4 (x3, 
E_V4HImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 26)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x8))
    {
    case PLUS:
      x9 = XEXP (x8, 1);
      operands[1] = x9;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern11 (x3, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern11 (x3, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case MINUS:
      x9 = XEXP (x8, 1);
      operands[1] = x9;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern12 (x3, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern12 (x3, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case IOR:
      res = pattern14 (x3);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case XOR:
      res = pattern14 (x3);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    case AND:
      x9 = XEXP (x8, 1);
      operands[1] = x9;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern15 (x3, 
E_SImode) != 0)
            return -1;
          return 8;

        case E_DImode:
          if (pattern15 (x3, 
E_DImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case NOT:
      x10 = XEXP (x8, 0);
      if (GET_CODE (x10) != AND)
        return -1;
      x11 = XEXP (x10, 1);
      operands[1] = x11;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[0]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern16 (x3, 
E_SImode) != 0)
            return -1;
          return 10;

        case E_DImode:
          if (pattern16 (x3, 
E_DImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !or_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern70 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern70 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 23
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 28
      || GET_MODE (x5) != E_DImode)
    return -1;
  return 0;
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != IF_THEN_ELSE
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (!alpha_zero_comparison_operator (x3, E_VOIDmode))
    return -1;
  operands[1] = x3;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!reg_or_0_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[3] = x7;
  if (!const48_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[4] = x8;
  if (!reg_or_8bit_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !add_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern101 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !const48_operand (operands[3], i1)
      || !sext_add_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  switch (GET_MODE (x7))
    {
    case E_QImode:
      if (!mem_noofs_operand (operands[2], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!mem_noofs_operand (operands[2], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x3) == E_DImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SImode:
                  if (nonimmediate_operand (operands[1], E_SImode))
                    return 2; /* *extendsidi2_1 */
                  break;

                case E_QImode:
                  if (register_operand (operands[1], E_QImode)
                      && 
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_BWX))
                    return 76; /* *extendqidi2_bwx */
                  break;

                case E_HImode:
                  if (register_operand (operands[1], E_HImode)
                      && 
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_BWX))
                    return 78; /* *extendhidi2_bwx */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && GET_MODE (x3) == E_HImode
              && register_operand (operands[1], E_QImode)
              && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_BWX))
            return 74; /* extendqihi2 */
          break;

        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (register_operand (operands[1], E_QImode)
                      && 
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_BWX))
                    return 75; /* extendqisi2 */
                  break;

                case E_HImode:
                  if (register_operand (operands[1], E_HImode)
                      && 
#line 1263 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_BWX))
                    return 77; /* extendhisi2 */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      switch (GET_CODE (x5))
        {
        case PLUS:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!reg_or_0_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!sext_add_operand (operands[2], E_DImode))
            return -1;
          return 5; /* *addsi_se2 */

        case MINUS:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!reg_or_0_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!reg_or_8bit_operand (operands[2], E_DImode))
            return -1;
          return 28; /* *subsi_se2 */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (!sext_add_operand (x8, E_SImode))
        return -1;
      switch (pattern56 (x4, pnum_clobbers))
        {
        case 0:
          return 4; /* *addsi_se */

        case 1:
          return 17; /* *saddl_se */

        case 2:
          *pnum_clobbers = 1;
          return 189; /* *cmp_sadd_sidi */

        default:
          return -1;
        }

    case NEG:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_8bit_operand (operands[1], E_SImode))
        return -1;
      return 22; /* *negsi_se */

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (!reg_or_8bit_operand (x8, E_SImode))
        return -1;
      switch (pattern56 (x4, pnum_clobbers))
        {
        case 0:
          return 27; /* *subsi_se */

        case 1:
          return 31; /* *ssubl_se */

        case 2:
          *pnum_clobbers = 1;
          return 192; /* *cmp_ssub_sidi */

        default:
          return -1;
        }

    case MULT:
      if (pattern8 (x3) != 0
          || !reg_or_8bit_operand (operands[2], E_SImode))
        return -1;
      return 36; /* *mulsi_se */

    case DIV:
    case MOD:
    case UDIV:
    case UMOD:
      if (pnum_clobbers == NULL)
        return -1;
      operands[3] = x4;
      if (!divmod_operator (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != TRUNCATE
          || GET_MODE (x5) != E_SImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != TRUNCATE
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      if (
#line 761 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
        {
          *pnum_clobbers = 2;
          return 40; /* *divmodsi_internal_er */
        }
      *pnum_clobbers = 2;
      return 42; /* *divmodsi_internal */

    case ASHIFT:
      if (pattern8 (x3) != 0
          || !const123_operand (operands[2], E_SImode))
        return -1;
      return 71; /* *ashlsi_se */

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case PARALLEL:
      res = split_2 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  operands[0] = x1;
  if (some_small_symbolic_operand (operands[0], E_VOIDmode))
    return gen_split_45 (insn, operands);
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          switch (GET_CODE (operands[1]))
            {
            case CONST:
            case SYMBOL_REF:
              if (register_operand (operands[0], E_DImode))
                {
                  if (global_symbolic_operand (operands[1], E_DImode)
                      && 
#line 3911 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && reload_completed))
                    return gen_split_46 (insn, operands);
                  if (gotdtp_symbolic_operand (operands[1], E_DImode)
                      && 
#line 3960 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(HAVE_AS_TLS && reload_completed))
                    return gen_split_47 (insn, operands);
                  if (gottp_symbolic_operand (operands[1], E_DImode)
                      && 
#line 3982 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(HAVE_AS_TLS && reload_completed))
                    return gen_split_48 (insn, operands);
                }
              break;

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && non_add_const_operand (operands[1], E_DImode))
                    return gen_split_49 (insn, operands);
                  break;

                case E_V8QImode:
                  if (register_operand (operands[0], E_V8QImode)
                      && non_zero_const_operand (operands[1], E_V8QImode))
                    return gen_split_55 (insn, operands);
                  break;

                case E_V4HImode:
                  if (register_operand (operands[0], E_V4HImode)
                      && non_zero_const_operand (operands[1], E_V4HImode))
                    return gen_split_56 (insn, operands);
                  break;

                case E_V2SImode:
                  if (register_operand (operands[0], E_V2SImode)
                      && non_zero_const_operand (operands[1], E_V2SImode))
                    return gen_split_57 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case SUBREG:
            case MEM:
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (register_operand (operands[0], E_QImode)
                      && memory_operand (operands[1], E_QImode)
                      && 
#line 4400 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(!TARGET_BWX && reload_completed))
                    return gen_split_51 (insn, operands);
                  break;

                case E_HImode:
                  if (register_operand (operands[0], E_HImode)
                      && memory_operand (operands[1], E_HImode)
                      && 
#line 4400 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(!TARGET_BWX && reload_completed))
                    return gen_split_52 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          if (!input_operand (operands[1], E_TImode)
              || !nonimmediate_operand (operands[0], E_TImode)
              || !
#line 4069 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(reload_completed))
            return NULL;
          return gen_split_50 (insn, operands);

        case AND:
          if (GET_MODE (x3) != E_DImode)
            return NULL;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != UNSPEC
              || XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 20
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return NULL;
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_QImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          switch (GET_CODE (operands[1]))
            {
            case CONST_INT:
              if (!const_int_operand (operands[1], E_DImode))
                return NULL;
              return gen_split_60 (insn, operands);

            case REG:
            case SUBREG:
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x7 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x7) != SET)
            return NULL;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          x9 = XEXP (x7, 1);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
            case MEM:
              operands[1] = x9;
              x10 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x10) != CLOBBER)
                return NULL;
              x11 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x11))
                {
                case CLOBBER:
                  switch (pattern68 (x1))
                    {
                    case 0:
                      if (!
#line 4418 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(!TARGET_BWX && reload_completed))
                        return NULL;
                      return gen_split_53 (insn, operands);

                    case 1:
                      if (!
#line 4418 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(!TARGET_BWX && reload_completed))
                        return NULL;
                      return gen_split_54 (insn, operands);

                    default:
                      return NULL;
                    }

                case SET:
                  switch (pattern67 (x1))
                    {
                    case 0:
                      if (!
#line 173 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_66 (insn, operands);

                    case 1:
                      if (!
#line 173 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_67 (insn, operands);

                    case 2:
                      if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_82 (insn, operands);

                    case 3:
                      if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_87 (insn, operands);

                    case 4:
                      if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_83 (insn, operands);

                    case 5:
                      if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_88 (insn, operands);

                    case 6:
                      if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_84 (insn, operands);

                    case 7:
                      if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_89 (insn, operands);

                    case 8:
                      if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_85 (insn, operands);

                    case 9:
                      if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_90 (insn, operands);

                    case 10:
                      if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_86 (insn, operands);

                    case 11:
                      if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_91 (insn, operands);

                    case 12:
                      if (!
#line 289 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_92 (insn, operands);

                    case 13:
                      if (!
#line 289 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                        return NULL;
                      return gen_split_93 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x9, 0) != 1
                  || XINT (x9, 1) != 17
                  || GET_MODE (x9) != E_DImode)
                return NULL;
              x12 = XVECEXP (x9, 0, 0);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x11 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x11) != SET)
                return NULL;
              x13 = XEXP (x11, 1);
              if (GET_CODE (x13) != UNSPEC_VOLATILE
                  || XVECLEN (x13, 0) != 1
                  || XINT (x13, 1) != 17)
                return NULL;
              x14 = XVECEXP (x13, 0, 0);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x10 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x10) != SET)
                return NULL;
              x15 = XEXP (x10, 1);
              if (GET_CODE (x15) != UNSPEC_VOLATILE
                  || XVECLEN (x15, 0) != 6
                  || XINT (x15, 1) != 17
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x16 = XEXP (x11, 0);
              operands[1] = x16;
              x17 = XEXP (x10, 0);
              operands[2] = x17;
              switch (pattern121 (x1))
                {
                case 0:
                  if (!
#line 112 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_62 (insn, operands);

                case 1:
                  if (!
#line 112 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_63 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              switch (pattern28 (x1))
                {
                case 0:
                  if (!
#line 205 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_68 (insn, operands);

                case 1:
                  if (!
#line 205 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_69 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              switch (pattern30 (x1))
                {
                case 0:
                  if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_94 (insn, operands);

                case 1:
                  if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_99 (insn, operands);

                default:
                  return NULL;
                }

            case MINUS:
              switch (pattern32 (x1))
                {
                case 0:
                  if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_95 (insn, operands);

                case 1:
                  if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_100 (insn, operands);

                default:
                  return NULL;
                }

            case IOR:
              switch (pattern34 (x1, 
IOR))
                {
                case 0:
                  if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_96 (insn, operands);

                case 1:
                  if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_101 (insn, operands);

                default:
                  return NULL;
                }

            case XOR:
              switch (pattern34 (x1, 
XOR))
                {
                case 0:
                  if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_97 (insn, operands);

                case 1:
                  if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_102 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              switch (pattern36 (x1))
                {
                case 0:
                  if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_98 (insn, operands);

                case 1:
                  if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_103 (insn, operands);

                default:
                  return NULL;
                }

            case NOT:
              switch (pattern38 (x1))
                {
                case 0:
                  if (!
#line 335 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_104 (insn, operands);

                case 1:
                  if (!
#line 335 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                    return NULL;
                  return gen_split_105 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 4:
          x7 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x7) != SET)
            return NULL;
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != UNSPEC_VOLATILE
              || pattern22 (x1) != 0)
            return NULL;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (pattern123 (x1))
            {
            case 0:
              if (!
#line 154 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_64 (insn, operands);

            case 1:
              if (!
#line 154 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_65 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          x7 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x7) != SET)
            return NULL;
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != UNSPEC)
            return NULL;
          switch (pattern17 (x1))
            {
            case 0:
              if (!
#line 223 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_70 (insn, operands);

            case 1:
              if (!
#line 223 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_75 (insn, operands);

            case 2:
              if (!
#line 223 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_71 (insn, operands);

            case 3:
              if (!
#line 223 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_76 (insn, operands);

            case 4:
              if (!
#line 223 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_72 (insn, operands);

            case 5:
              if (!
#line 223 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_77 (insn, operands);

            case 6:
              if (!
#line 223 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_73 (insn, operands);

            case 7:
              if (!
#line 223 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_78 (insn, operands);

            case 8:
              if (!
#line 223 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_74 (insn, operands);

            case 9:
              if (!
#line 223 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_79 (insn, operands);

            case 10:
              if (!
#line 244 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_80 (insn, operands);

            case 11:
              if (!
#line 244 "../../gcc-15.0.1-20250313/gcc/config/alpha/sync.md"
(epilogue_completed))
                return NULL;
              return gen_split_81 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return NULL;
      switch (XINT (x1, 1))
        {
        case 2:
          x7 = XVECEXP (x1, 0, 0);
          operands[0] = x7;
          if (!(
#line 5054 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_ABI_OSF) && 
#line 5061 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( TARGET_EXPLICIT_RELOCS && reload_completed)))
            return NULL;
          return gen_split_58 (insn, operands);

        case 7:
          x7 = XVECEXP (x1, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !(
#line 5107 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_ABI_OSF) && 
#line 5114 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( TARGET_EXPLICIT_RELOCS && reload_completed)))
            return NULL;
          return gen_split_59 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
