/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_8bit_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern18 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !or_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (!divmod_operator (x2, E_SImode))
    return -1;
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != TRUNCATE
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != TRUNCATE
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 26)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != MINUS)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XVECEXP (x3, 0, 1);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[4] = x11;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x4, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x2, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern31 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern31 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !or_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !add_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x10))
    {
    case USE:
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 29
          || GET_MODE (x11) != E_DImode)
        return -1;
      return 0;

    case SET:
      x12 = XEXP (x10, 1);
      if (GET_CODE (x12) != UNSPEC
          || XVECLEN (x12, 0) != 2
          || XINT (x12, 1) != 2
          || GET_MODE (x12) != E_DImode)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 29
          || GET_MODE (x13) != E_DImode)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 29
          || GET_MODE (x11) != E_DImode)
        return -1;
      x14 = XVECEXP (x12, 0, 1);
      operands[4] = x14;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!reg_or_0_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XEXP (x3, 1);
  operands[4] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  if (!scratch_operand (operands[5], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern88 (x3, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern88 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern102 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !const48_operand (operands[3], i1)
      || !reg_or_8bit_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[3] = x4;
  if (!reg_or_8bit_operand (operands[3], E_DImode))
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[4] = x5;
  if (!add_operand (operands[4], E_DImode))
    return -1;
  x6 = XVECEXP (x3, 0, 3);
  operands[5] = x6;
  if (!const_int_operand (operands[5], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 4);
  operands[6] = x7;
  if (!const_int_operand (operands[6], E_SImode))
    return -1;
  x8 = XVECEXP (x3, 0, 5);
  operands[7] = x8;
  if (!const_int_operand (operands[7], E_SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      return pattern120 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern120 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers != NULL)
        {
          res = recog_6 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x2;
      if (register_operand (operands[0], E_DImode))
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            return 204; /* indirect_jump */
        }
      break;

    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 202; /* jump */
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !input_operand (operands[1], E_SFmode)
          || !
#line 3744 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(register_operand (operands[0], SFmode)
   || reg_or_0_operand (operands[1], SFmode)))
        return -1;
      return 210; /* *movsf */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !input_operand (operands[1], E_DFmode)
          || !
#line 3771 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(register_operand (operands[0], DFmode)
   || reg_or_0_operand (operands[1], DFmode)))
        return -1;
      return 211; /* *movdf */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !input_operand (operands[1], E_TFmode)
          || !
#line 3802 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(register_operand (operands[0], TFmode)
   || reg_or_0_operand (operands[1], TFmode)))
        return -1;
      return 212; /* *movtf_internal */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !input_operand (operands[1], E_SImode)
          || !
#line 3825 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(register_operand (operands[0], SImode)
   || reg_or_0_operand (operands[1], SImode)))
        return -1;
      return 213; /* *movsi */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !input_operand (operands[1], E_DImode)
          || !
#line 3996 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(register_operand (operands[0], DImode)
   || reg_or_0_operand (operands[1], DImode)))
        return -1;
      return 220; /* *movdi */

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || !input_operand (operands[1], E_TImode)
          || !
#line 4064 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
((register_operand (operands[0], TImode)
    /* Prevent rematerialization of constants.  */
    && ! CONSTANT_P (operands[1]))
   || reg_or_0_operand (operands[1], TImode)))
        return -1;
      return 222; /* *movti_internal */

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && input_operand (operands[1], E_QImode)
          && 
#line 4248 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(register_operand (operands[0], QImode)
   || reg_or_0_operand (operands[1], QImode)))
        return 223; /* *movqi */
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || !
#line 4398 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(!TARGET_BWX && (reload_in_progress || reload_completed)))
        return -1;
      return 225; /* reload_inqi_aligned */

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && input_operand (operands[1], E_HImode)
          && 
#line 4261 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(register_operand (operands[0], HImode)
   || reg_or_0_operand (operands[1], HImode)))
        return 224; /* *movhi */
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_HImode)
          || !
#line 4398 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(!TARGET_BWX && (reload_in_progress || reload_completed)))
        return -1;
      return 226; /* reload_inhi_aligned */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !input_operand (operands[1], E_V8QImode)
          || !
#line 4467 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(register_operand (operands[0], V8QImode)
   || reg_or_0_operand (operands[1], V8QImode)))
        return -1;
      return 229; /* *movv8qi_fix */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !input_operand (operands[1], E_V4HImode)
          || !
#line 4467 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(register_operand (operands[0], V4HImode)
   || reg_or_0_operand (operands[1], V4HImode)))
        return -1;
      return 230; /* *movv4hi_fix */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !input_operand (operands[1], E_V2SImode)
          || !
#line 4467 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(register_operand (operands[0], V2SImode)
   || reg_or_0_operand (operands[1], V2SImode)))
        return -1;
      return 231; /* *movv2si_fix */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode
          || !hard_fp_register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_SImode)
          || !
#line 262 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(reload_completed))
        return NULL;
      return gen_split_1 (insn, operands);

    case PLUS:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern48 (x3, 
E_SImode) != 0
              || !
#line 298 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! add_operand (operands[2], SImode)))
            return NULL;
          return gen_split_2 (insn, operands);

        case E_DImode:
          if (pattern48 (x3, 
E_DImode) != 0
              || !
#line 493 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! add_operand (operands[2], DImode)
   && operands[0] != stack_pointer_rtx
   && operands[1] != frame_pointer_rtx
   && operands[1] != arg_pointer_rtx))
            return NULL;
          return gen_split_6 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x3))
        {
        case HIGH:
          if (GET_MODE (x3) == E_DImode
              && register_operand (operands[0], E_DImode))
            {
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              if (local_symbolic_operand (operands[1], E_DImode)
                  && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && reload_completed))
                return gen_split_5 (insn, operands);
            }
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[1] = x3;
          if (non_add_const_operand (operands[1], E_SImode)
              && register_operand (operands[0], E_SImode))
            return gen_split_42 (insn, operands);
          break;

        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x3;
          if (register_operand (operands[0], E_DImode))
            {
              if (small_symbolic_operand (operands[1], E_DImode)
                  && 
#line 3869 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && reload_completed))
                return gen_split_43 (insn, operands);
              if (local_symbolic_operand (operands[1], E_DImode)
                  && 
#line 3877 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && reload_completed))
                return gen_split_44 (insn, operands);
            }
          break;

        default:
          break;
        }
      operands[1] = x3;
      if (!input_operand (operands[1], E_TFmode)
          || !nonimmediate_operand (operands[0], E_TFmode)
          || !
#line 3805 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(reload_completed))
        return NULL;
      return gen_split_41 (insn, operands);

    case AND:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_DImode)
          || !
#line 928 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! and_operand (operands[2], DImode)))
        return NULL;
      return gen_split_10 (insn, operands);

    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return NULL;
      x6 = XEXP (x3, 2);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 1570 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
((unsigned HOST_WIDE_INT) INTVAL (operands[2]) < 8))
        return NULL;
      return gen_split_11 (insn, operands);

    case FLOAT:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_SImode))
        return NULL;
      switch (pattern39 (x3))
        {
        case 0:
          if (!(
#line 2085 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP) && 
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
            return NULL;
          return gen_split_19 (insn, operands);

        case 1:
          if (!(
#line 2127 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP) && 
#line 2129 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
( reload_completed)))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case ABS:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 2396 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! rtx_equal_p (operands[0], operands[1])))
        return NULL;
      return gen_split_23 (insn, operands);

    case NEG:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != ABS
          || GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 2413 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(! rtx_equal_p (operands[0], operands[1])))
        return NULL;
      return gen_split_25 (insn, operands);

    case IF_THEN_ELSE:
      x4 = XEXP (x3, 0);
      if (!signed_comparison_operator (x4, E_VOIDmode))
        return NULL;
      operands[1] = x4;
      if (!register_operand (operands[0], E_VOIDmode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return NULL;
      x6 = XEXP (x3, 2);
      operands[4] = x6;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return NULL;
      x8 = XEXP (x4, 1);
      if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (reg_or_0_operand (operands[2], E_DImode))
            return gen_split_33 (insn, operands);
        }
      x7 = XEXP (x4, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      operands[2] = x8;
      if (!reg_or_0_operand (operands[2], E_DImode))
        return NULL;
      return gen_split_34 (insn, operands);

    default:
      return NULL;
    }
}
