/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, unsigned int i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern6 (x4, 
i1, 
CLOBBER); /* [-1, 0] */
}

int
pattern13 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !or_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 26)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XVECEXP (x3, 0, 1);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x4, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x4, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x2, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern18 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern18 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 26)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XVECEXP (x3, 0, 1);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[4] = x11;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x4, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x2, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern33 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern33 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_8bit_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_not_elim_operand (operands[1], i1)
      || !const23_operand (operands[2], i1)
      || !reg_or_8bit_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!memory_operand (operands[0], E_HImode)
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  if (!reg_or_0_operand (operands[4], E_DFmode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const0_operand (operands[2], E_DFmode)
      || !reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !const48_operand (operands[3], i1)
      || !reg_or_8bit_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!scratch_operand (operands[2], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!scratch_operand (operands[3], E_SFmode))
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  return pattern92 (x9); /* [-1, 1] */
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x4, 1);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x3, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x10, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern104 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_DImode:
      if (pattern104 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 6:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!reg_or_0_operand (operands[1], E_SFmode))
            return -1;
          return 1; /* *cvtlq */

        case 5:
          if (GET_MODE (x3) != E_SFmode
              || !register_operand (operands[0], E_SFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!reg_or_0_operand (operands[1], E_DImode)
              || !
#line 1905 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
            return -1;
          return 130; /* *cvtql */

        case 18:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode))
            return -1;
          return 208; /* get_thread_pointerdi */

        case 21:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!reg_or_8bit_operand (operands[1], E_DImode))
            return -1;
          return 283; /* builtin_amask */

        case 22:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode))
            return -1;
          return 284; /* builtin_implver */

        case 25:
          if (GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[0]))
            return -1;
          return 291; /* *memory_barrier */

        default:
          return -1;
        }

    case 3:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (XINT (x3, 1))
        {
        case 3:
          if (!mode_width_operand (operands[2], E_DImode)
              || !reg_or_8bit_operand (operands[3], E_DImode))
            return -1;
          return 94; /* insxh */

        case 4:
          if (!mode_width_operand (operands[2], E_DImode)
              || !reg_or_8bit_operand (operands[3], E_DImode))
            return -1;
          return 96; /* mskxh */

        case 8:
          if (!symbolic_operand (operands[2], E_DImode)
              || !const_int_operand (operands[3], E_VOIDmode)
              || !
#line 3898 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS))
            return -1;
          return 215; /* movdi_er_high_g */

        case 14:
          if (!symbolic_operand (operands[2], E_DImode)
              || !const_int_operand (operands[3], E_VOIDmode))
            return -1;
          return 216; /* movdi_er_tlsgd */

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 24:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern55 (x3, 
E_SFmode) != 0
                  || !
#line 1646 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                return -1;
              return 106; /* copysignsf3 */

            case E_DFmode:
              if (pattern55 (x3, 
E_DFmode) != 0
                  || !
#line 1646 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_FP))
                return -1;
              return 107; /* copysigndf3 */

            default:
              return -1;
            }

        case 15:
          if (pattern40 (x3) != 0)
            return -1;
          return 217; /* movdi_er_tlsldm */

        case 16:
          if (pattern41 (x3) != 0)
            return -1;
          return 218; /* *movdi_er_gotdtp */

        case 17:
          if (pattern41 (x3) != 0)
            return -1;
          return 219; /* *movdi_er_gottp */

        case 7:
          if (pattern40 (x3) != 0
              || !
#line 4929 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_EXPLICIT_RELOCS && TARGET_ABI_OSF))
            return -1;
          return 263; /* *ldgp_er_2 */

        case 19:
          if (pattern42 (x3) != 0)
            return -1;
          return 280; /* builtin_cmpbge */

        case 23:
          if (pattern42 (x3) != 0
              || !
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/alpha/alpha.md"
(TARGET_MAX))
            return -1;
          return 286; /* builtin_perr */

        case 26:
          if (pnum_clobbers == NULL
              || !const_int_operand (operands[2], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              if (!rtx_equal_p (x8, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern95 (x3, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 304; /* atomic_addsi */

                case E_DImode:
                  if (pattern95 (x3, 
E_DImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 309; /* atomic_adddi */

                default:
                  return -1;
                }

            case MINUS:
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              if (!rtx_equal_p (x8, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern96 (x3, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 305; /* atomic_subsi */

                case E_DImode:
                  if (pattern96 (x3, 
E_DImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 310; /* atomic_subdi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern71 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 306; /* atomic_orsi */

                case 1:
                  *pnum_clobbers = 1;
                  return 311; /* atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern71 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 307; /* atomic_xorsi */

                case 1:
                  *pnum_clobbers = 1;
                  return 312; /* atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              if (!rtx_equal_p (x8, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern97 (x3, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 308; /* atomic_andsi */

                case E_DImode:
                  if (pattern97 (x3, 
E_DImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 313; /* atomic_anddi */

                default:
                  return -1;
                }

            case NOT:
              x8 = XEXP (x4, 0);
              if (GET_CODE (x8) != AND)
                return -1;
              x9 = XEXP (x8, 1);
              operands[1] = x9;
              x10 = XEXP (x8, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern99 (x3, 
E_SImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 314; /* atomic_nandsi */

                case E_DImode:
                  if (pattern99 (x3, 
E_DImode) != 0)
                    return -1;
                  *pnum_clobbers = 1;
                  return 315; /* atomic_nanddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
