/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!reg_or_0_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern13 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern13 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 17
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != ZERO_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != UNSPEC_VOLATILE
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 17)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != UNSPEC_VOLATILE
      || XVECLEN (x10, 0) != 7
      || XINT (x10, 1) != 17)
    return -1;
  x11 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  return 0;
}

int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !and_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_DImode)
      || !const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_8bit_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !or_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[3] = x3;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x1, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 29
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 26
      || GET_MODE (x5) != E_DImode)
    return -1;
  return 0;
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (!alpha_zero_comparison_operator (x3, E_VOIDmode))
    return -1;
  operands[1] = x3;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!reg_or_0_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[3] = x7;
  if (!const48_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[4] = x8;
  if (!sext_add_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !or_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern110 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1)
      || !and_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!reg_or_0_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 2);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      operands[3] = x5;
      if (!mul8_operand (operands[3], E_DImode))
        return -1;
      return 79; /* *extxl_const */

    case ASHIFT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      if (!reg_or_8bit_operand (operands[3], E_DImode))
        return -1;
      return 80; /* extxl */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !reg_or_0_operand (operands[1], E_DImode)
                  || !reg_or_6bit_operand (operands[2], E_DImode))
                return -1;
              return 69; /* ashldi3 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !reg_or_0_operand (operands[1], E_SImode)
                  || !const123_operand (operands[2], E_SImode))
                return -1;
              return 70; /* ashlsi3 */

            default:
              return -1;
            }

        case MINUS:
          if (pattern47 (x5) != 0
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !reg_or_0_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x5, 1);
          x7 = XEXP (x6, 0);
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!reg_or_8bit_operand (operands[2], E_DImode))
            return -1;
          return 83; /* extqh */

        case ASHIFT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!reg_or_8bit_operand (operands[2], E_DImode))
            return -1;
          return 92; /* insql */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x10 = XEXP (x4, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != MINUS
          || pattern47 (x5) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      if (!reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x5, 1);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!reg_or_8bit_operand (operands[2], E_DImode))
        return -1;
      switch (XWINT (x10, 0))
        {
        case 65535L:
          return 84; /* extwh */

        case 2147483647L:
          return 85; /* extlh */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x11 = XEXP (x4, 0);
      operands[1] = x11;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          operands[2] = x5;
          if (!mul8_operand (operands[2], E_DImode))
            return -1;
          switch (pattern85 ())
            {
            case 0:
              return 86; /* insbl_const */

            case 1:
              return 87; /* inswl_const */

            case 2:
              return 88; /* insll_const */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!reg_or_8bit_operand (operands[2], E_DImode))
            return -1;
          switch (pattern85 ())
            {
            case 0:
              return 89; /* insbl */

            case 1:
              return 90; /* inswl */

            case 2:
              return 91; /* insll */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (memory_operand (operands[0], E_SImode))
    {
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x2, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (XINT (x3, 1))
    {
    case 28:
      x8 = XVECEXP (x3, 0, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern110 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 300; /* atomic_exchangesi */

        case E_DImode:
          if (pattern110 (x3, 
E_DImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 301; /* atomic_exchangedi */

        default:
          return -1;
        }

    case 26:
      x8 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x8))
        {
        case PLUS:
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern111 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 316; /* atomic_fetch_addsi */

            case E_DImode:
              if (pattern111 (x3, 
E_DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 321; /* atomic_fetch_adddi */

            default:
              return -1;
            }

        case MINUS:
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern112 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 317; /* atomic_fetch_subsi */

            case E_DImode:
              if (pattern112 (x3, 
E_DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 322; /* atomic_fetch_subdi */

            default:
              return -1;
            }

        case IOR:
          switch (pattern107 (x3))
            {
            case 0:
              *pnum_clobbers = 1;
              return 318; /* atomic_fetch_orsi */

            case 1:
              *pnum_clobbers = 1;
              return 323; /* atomic_fetch_ordi */

            default:
              return -1;
            }

        case XOR:
          switch (pattern107 (x3))
            {
            case 0:
              *pnum_clobbers = 1;
              return 319; /* atomic_fetch_xorsi */

            case 1:
              *pnum_clobbers = 1;
              return 324; /* atomic_fetch_xordi */

            default:
              return -1;
            }

        case AND:
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern113 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 320; /* atomic_fetch_andsi */

            case E_DImode:
              if (pattern113 (x3, 
E_DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 325; /* atomic_fetch_anddi */

            default:
              return -1;
            }

        case NOT:
          x10 = XEXP (x8, 0);
          if (GET_CODE (x10) != AND)
            return -1;
          x11 = XEXP (x10, 1);
          operands[2] = x11;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern114 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 326; /* atomic_fetch_nandsi */

            case E_DImode:
              if (pattern114 (x3, 
E_DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 327; /* atomic_fetch_nanddi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
