/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-15.0.1-20250313/gcc/config/arc/arc.md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "emit-rtl.h"
#include "tm-constrs.h"
#include "target.h"


struct target_constraints default_target_constraints;
#if SWITCHABLE_TARGET
struct target_constraints *this_target_constraints = &default_target_constraints;
#endif
static inline bool
aligned_register_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 25 "../../gcc-15.0.1-20250313/gcc/common.md"
{
  /* Require the offset in a non-paradoxical subreg to be naturally aligned.
     For example, if we have a subreg of something that is double the size of
     this operand, the offset must select the first or second half of it.  */
  if (SUBREG_P (op)
      && multiple_p (SUBREG_BYTE (op), GET_MODE_SIZE (GET_MODE (op))))
    op = SUBREG_REG (op);
  if (!REG_P (op))
    return false;

  if (HARD_REGISTER_P (op))
    {
      if (!in_hard_reg_set_p (operand_reg_set, GET_MODE (op), REGNO (op)))
	return false;

      /* Reject hard registers that would need reloading, so that the reload
	 is visible to IRA and to pre-RA optimizers.  */
      if (REGNO (op) % REG_NREGS (op) != 0)
	return false;
    }
  return true;
}

bool
aligned_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
      break;
    default:
      return false;
    }
  return (
(aligned_register_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
dest_reg_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 22 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  return register_operand (op, mode);
}

bool
dest_reg_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
      break;
    default:
      return false;
    }
  return (
(dest_reg_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
symbolic_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF:
    case LABEL_REF:
    case CONST:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode);
}

bool
call_address_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST_INT || GET_CODE (op) == REG) || ((symbolic_operand (op, mode)) || (
#line 35 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(CONSTANT_P (op)
		    && arc_legitimate_constant_p (VOIDmode, op))))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
call_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (
#line 41 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(call_address_operand (XEXP (op, 0), mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
u6_immediate_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 47 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(UNSIGNED_INT6 (INTVAL (op))));
}

bool
short_immediate_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 53 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(SMALL_INT (INTVAL (op))));
}

bool
p2_immediate_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && ((
#line 58 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(((INTVAL (op) - 1) & INTVAL (op)) == 0)) && (
#line 59 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(INTVAL (op))));
}

static inline bool
long_immediate_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 66 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF :
    case LABEL_REF :
    case CONST :
      return 1;
    case CONST_INT :
      return !SIGNED_INT12 (INTVAL (op));
    case CONST_DOUBLE :
      /* These can happen because large unsigned 32 bit constants are
	 represented this way (the multiplication patterns can cause these
	 to be generated).  They also occur for SFmode values.  */
      return 1;
    default:
      break;
    }
  return 0;
}

bool
long_immediate_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF:
    case LABEL_REF:
    case CONST:
    case CONST_DOUBLE:
    case CONST_INT:
      break;
    default:
      return false;
    }
  return (
(long_immediate_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

static inline bool
long_immediate_loadstore_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 94 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  int size = GET_MODE_SIZE (GET_MODE (op));

  op = XEXP (op, 0);
  if (TARGET_NPS_CMEM && cmem_address (op, SImode))
    return 0;
  switch (GET_CODE (op))
    {
    case SYMBOL_REF :
    case LABEL_REF :
    case CONST :
      return 1;
    case CONST_INT :
      /* This must be handled as "st c,[limm]".  Ditto for load.
	 Technically, the assembler could translate some possibilities to
	 "st c,[limm/2 + limm/2]" if limm/2 will fit in a shimm, but we don't
	 assume that it does.  */
      return 1;
    case CONST_DOUBLE :
      /* These can happen because large unsigned 32 bit constants are
	 represented this way (the multiplication patterns can cause these
	 to be generated).  They also occur for SFmode values.  */
      return 1;
    case REG :
      return 0;
    case PLUS :
      {
	rtx x = XEXP (op, 1);

	if ((GET_CODE (XEXP (op, 0)) == MULT)
	    && REG_P (XEXP (XEXP (op, 0), 0))
	    && CONSTANT_P (x))
	  return 1;

	if (GET_CODE (x) == CONST)
	  {
	    x = XEXP (x, 0);
	    if (GET_CODE (x) == PLUS)
	      x = XEXP (x, 0);
	  }
	if (CONST_INT_P (x))
	  return (!SMALL_INT (INTVAL (x))
		  && (size <= 1 || size > 4
		      || (INTVAL (x) & (size - 1)) != 0
		      || !SMALL_INT (INTVAL (x) / size)));
	else if (GET_CODE (x) == SYMBOL_REF)
	  return TARGET_NO_SDATA_SET || !SYMBOL_REF_SMALL_P (x);
	return 0;
      }
    default:
      break;
    }
  return 0;
}

bool
long_immediate_loadstore_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (
(long_immediate_loadstore_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
compact_register_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 154 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
     if ((GET_MODE (op) != mode) && (mode != VOIDmode))
	 return 0;

      return (GET_CODE (op) == REG)
      && (REGNO (op) >= FIRST_PSEUDO_REGISTER
		|| COMPACT_GP_REG_P (REGNO (op))) ;
  }

bool
compact_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
      break;
    default:
      return false;
    }
  return (
(compact_register_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
compact_hreg_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 166 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
     if ((GET_MODE (op) != mode) && (mode != VOIDmode))
	 return 0;

      return (GET_CODE (op) == REG)
      && (REGNO (op) >= FIRST_PSEUDO_REGISTER
		|| (TARGET_V2 && REGNO (op) <= 31 && REGNO (op) != 30)
		|| !TARGET_V2);
  }

bool
compact_hreg_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
      break;
    default:
      return false;
    }
  return (
(compact_hreg_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
compact_store_memory_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 181 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  rtx addr, plus0, plus1;
  int size, off;

  if (mode == VOIDmode)
    mode = GET_MODE (op);

  /* .di instructions have no 16-bit form.  */
  if (MEM_VOLATILE_P (op) && !TARGET_VOLATILE_CACHE_SET)
     return 0;

  /* likewise for uncached types.  */
  if (arc_is_uncached_mem_p (op))
     return 0;

  size = GET_MODE_SIZE (mode);

  /* dword operations really put out 2 instructions, so eliminate them.  */
  if (size > UNITS_PER_WORD)
    return 0;

  /* Decode the address now.  */
  addr = XEXP (op, 0);
  switch (GET_CODE (addr))
    {
    case REG:
      return (REGNO (addr) >= FIRST_PSEUDO_REGISTER
		|| COMPACT_GP_REG_P (REGNO (addr))
	      || (SP_REG_P (REGNO (addr)) && (size != 2)));
	/* stw_s does not support SP as a parameter.  */
    case PLUS:
      plus0 = XEXP (addr, 0);
      plus1 = XEXP (addr, 1);

      if ((GET_CODE (plus0) == REG)
	  && ((REGNO (plus0) >= FIRST_PSEUDO_REGISTER)
	      || COMPACT_GP_REG_P (REGNO (plus0)))
	  && (GET_CODE (plus1) == CONST_INT))
	{
	  off = INTVAL (plus1);

	  /* Negative offset is not supported in 16-bit load/store insns.  */
	  if (off < 0)
	    return 0;

	  switch (size)
	    {
	    case 1:
	      return (off < 32);
	    case 2:
	      return ((off < 64) && (off % 2 == 0));
	    case 4:
	      return ((off < 128) && (off % 4 == 0));
	    }
	}

      if ((GET_CODE (plus0) == REG)
	  && ((REGNO (plus0) >= FIRST_PSEUDO_REGISTER)
	      || SP_REG_P (REGNO (plus0)))
	  && (GET_CODE (plus1) == CONST_INT))
	{
	  off = INTVAL (plus1);

	  return ((size != 2) && (off >= 0 && off < 128) && (off % 4 == 0));
	}
    default:
      break;
    }
  return 0;
  }

bool
compact_store_memory_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (
(compact_store_memory_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
move_src_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 257 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF :
      if (SYMBOL_REF_TLS_MODEL (op))
	return 0;
      return 1;
    case LABEL_REF :
      return 1;
    case CONST :
      return arc_legitimate_constant_p (mode, op);
    case CONST_INT :
      return (LARGE_INT (INTVAL (op)));
    case CONST_DOUBLE :
      /* We can handle DImode integer constants in SImode if the value
	 (signed or unsigned) will fit in 32 bits.  This is needed because
	 large unsigned 32 bit constants are represented as CONST_DOUBLEs.  */
      if (mode == SImode)
	return arc_double_limm_p (op);
      /* We can handle 32 bit floating point constants.  */
      if (mode == SFmode)
	return GET_MODE (op) == SFmode;
      return 0;
    case REG :
      if (REGNO (op) == LP_COUNT)
	return 1;
      return register_operand (op, mode);
    case SUBREG :
      /* (subreg (mem ...) ...) can occur here if the inner part was once a
	 pseudo-reg and is now a stack slot.  */
      if (GET_CODE (SUBREG_REG (op)) == MEM)
	return address_operand (XEXP (SUBREG_REG (op), 0), mode);
      else
	return register_operand (op, mode);
    case MEM :
      return address_operand (XEXP (op, 0), mode);
    default :
      return 0;
    }
}

bool
move_src_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF:
    case LABEL_REF:
    case CONST:
    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      break;
    default:
      return false;
    }
  return (
(move_src_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

static inline bool
move_double_src_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 303 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  switch (GET_CODE (op))
    {
    case REG :
      return register_operand (op, mode);
    case SUBREG :
      /* (subreg (mem ...) ...) can occur here if the inner part was once a
	 pseudo-reg and is now a stack slot.  */
      if (GET_CODE (SUBREG_REG (op)) == MEM)
	return address_operand (XEXP (SUBREG_REG (op), 0), mode);
      else
	return register_operand (op, mode);
    case MEM :
      return address_operand (XEXP (op, 0), mode);
    case CONST_INT :
    case CONST_DOUBLE :
      return 1;
    default :
      return 0;
    }
}

bool
move_double_src_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
    case MEM:
    case CONST_INT:
    case CONST_DOUBLE:
      break;
    default:
      return false;
    }
  return (
(move_double_src_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

static inline bool
move_dest_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 329 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  switch (GET_CODE (op))
    {
    case REG :
     /* Program Counter register cannot be the target of a move.  It is
	 a readonly register.  */
      if (REGNO (op) == PCL_REG)
	return 0;
      else if (TARGET_MULMAC_32BY16_SET
	       && (REGNO (op) == MUL32x16_REG || REGNO (op) == R57_REG))
	return 0;
      else if (TARGET_MUL64_SET
	       && (REGNO (op) == R57_REG || REGNO (op) == MUL64_OUT_REG
		   || REGNO (op) == R59_REG))
	return 0;
      else if (REGNO (op) == LP_COUNT)
        return 1;
      else
	return dest_reg_operand (op, mode);
    case SUBREG :
      /* (subreg (mem ...) ...) can occur here if the inner part was once a
	 pseudo-reg and is now a stack slot.  */
      if (GET_CODE (SUBREG_REG (op)) == MEM)
	return address_operand (XEXP (SUBREG_REG (op), 0), mode);
      else
	return dest_reg_operand (op, mode);
    case MEM :
      {
	rtx addr = XEXP (op, 0);

	if (GET_CODE (addr) == PLUS
	    && (GET_CODE (XEXP (addr, 0)) == MULT
		|| (!CONST_INT_P (XEXP (addr, 1))
		    && (TARGET_NO_SDATA_SET
			|| GET_CODE (XEXP (addr, 1)) != SYMBOL_REF
			|| !SYMBOL_REF_SMALL_P (XEXP (addr, 1))))))
	  return 0;
	if ((GET_CODE (addr) == PRE_MODIFY || GET_CODE (addr) == POST_MODIFY)
	    && (GET_CODE (XEXP (addr, 1)) != PLUS
		|| !CONST_INT_P (XEXP (XEXP (addr, 1), 1))))
	  return 0;
	/* CONST_INT / CONST_DOUBLE is fine, but the PIC CONST ([..] UNSPEC))
	   constructs are effectively indexed.  */
	if (flag_pic)
	  {
	    rtx ad0 = addr;
	    while (GET_CODE (ad0) == PLUS)
	      ad0 = XEXP (ad0, 0);
	    if (GET_CODE (ad0) == CONST || GET_CODE (ad0) == UNSPEC)
	      return 0;
	  }
	return address_operand (addr, mode);
      }
    default :
      return 0;
    }

}

bool
move_dest_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
    case MEM:
      break;
    default:
      return false;
    }
  return (
(move_dest_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
nonvol_nonimm_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case SUBREG:
    case REG:
    case MEM:
      break;
    default:
      return false;
    }
  return ((
#line 394 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
((GET_CODE (op) != MEM || !MEM_VOLATILE_P (op)) && nonimmediate_operand (op, mode))) && (
#line 395 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(!arc_is_uncached_mem_p (op)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
proper_comparison_operator_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 403 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  enum rtx_code code = GET_CODE (op);

  if (!COMPARISON_P (op))
    return 0;

  /* After generic flag-setting insns, we can use eq / ne / pl / mi / pnz .
     There are some creative uses for hi / ls after shifts, but these are
     hard to understand for the compiler and could be at best the target of
     a peephole.  */
  switch (GET_MODE (XEXP (op, 0)))
    {
    case E_CC_ZNmode:
      return (code == EQ || code == NE || code == GE || code == LT
	      || code == GT);
    case E_CC_Zmode:
      return code == EQ || code == NE;
    case E_CC_Cmode:
      return code == LTU || code == GEU;
    case E_CC_FP_GTmode:
      return code == GT || code == UNLE;
    case E_CC_FP_GEmode:
      return code == GE || code == UNLT;
    case E_CC_FP_ORDmode:
      return code == ORDERED || code == UNORDERED;
    case E_CC_FP_UNEQmode:
      return code == UNEQ || code == LTGT;
    case E_CC_FPXmode:
      return (code == EQ || code == NE || code == UNEQ || code == LTGT
	      || code == ORDERED || code == UNORDERED);

    case E_CC_FPUmode:
    case E_CC_FPUEmode:
      return 1;
    case E_CC_FPU_UNEQmode:
      return 1;

    case E_CCmode:
    case E_SImode: /* Used for BRcc.  */
      return 1;
    /* From combiner.  */
    case E_QImode: case E_HImode: case E_DImode: case E_SFmode: case E_DFmode:
      return 0;
    case E_VOIDmode:
      return 0;
    default:
      gcc_unreachable ();
  }
}

bool
proper_comparison_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
    case LE:
    case LT:
    case GE:
    case GT:
    case LEU:
    case LTU:
    case GEU:
    case GTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case LTGT:
      break;
    default:
      return false;
    }
  return (
(proper_comparison_operator_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
equality_comparison_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
ge_lt_comparison_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case GE:
    case LT:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
brcc_nolimm_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((
#line 460 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(REG_P (XEXP (op, 1)))) || (((GET_CODE (op) == EQ || GET_CODE (op) == NE || GET_CODE (op) == LT || GET_CODE (op) == GE || GET_CODE (op) == LTU || GET_CODE (op) == GEU) && ((
#line 462 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(CONST_INT_P (XEXP (op, 1)))) && (
#line 463 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(u6_immediate_operand (XEXP (op, 1), SImode))))) || ((GET_CODE (op) == LE || GET_CODE (op) == GT || GET_CODE (op) == LEU || GET_CODE (op) == GTU) && ((
#line 465 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(CONST_INT_P (XEXP (op, 1)))) && (
#line 466 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(UNSIGNED_INT6 (INTVAL (XEXP (op, 1)) + 1))))))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

static inline bool
cc_register_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 472 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  if (mode == VOIDmode)
    {
      mode = GET_MODE (op);
      if (GET_MODE_CLASS (mode) != MODE_CC)
	return FALSE;
    }

  if (mode == GET_MODE (op) && GET_CODE (op) == REG && REGNO (op) == CC_REG)
    return TRUE;

  return FALSE;
}

bool
cc_register (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == REG) && (
(cc_register_1 (op, mode)));
}

static inline bool
cc_set_register_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 491 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  machine_mode rmode = GET_MODE (op);

  if (mode == VOIDmode)
    {
      mode = rmode;
      if (GET_MODE_CLASS (mode) != MODE_CC)
	return FALSE;
    }

  if (REGNO (op) != CC_REG)
    return FALSE;
  if (mode == rmode
      || (mode == CC_ZNmode && rmode == CC_Zmode)
      || (mode == CCmode && rmode == CC_Zmode)
      || (mode == CCmode && rmode == CC_ZNmode)
      || (mode == CCmode && rmode == CC_Cmode))
    return TRUE;

  return FALSE;
}

bool
cc_set_register (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == REG) && (
(cc_set_register_1 (op, mode)));
}

static inline bool
cc_use_register_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 516 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  if (REGNO (op) != CC_REG)
    return 0;
  if (GET_MODE (op) == mode)
    return 1;
  switch (mode)
    {
    case E_CC_Zmode:
      if (GET_MODE (op) == CC_ZNmode)
	return 1;
      /* Fall through.  */
    case E_CC_ZNmode: case E_CC_Cmode:
      return GET_MODE (op) == CCmode;
    default:
      gcc_unreachable ();
    }
}

bool
cc_use_register (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == REG) && (
(cc_use_register_1 (op, mode)));
}

static inline bool
zn_compare_operator_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 536 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  return GET_MODE (op) == CC_ZNmode || GET_MODE (op) == CC_Zmode;
}

bool
zn_compare_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == COMPARE) && (
(zn_compare_operator_1 (op, mode)));
}

bool
shift_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case ASHIFTRT:
    case LSHIFTRT:
    case ASHIFT:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
mult_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MULT) && (
#line 546 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(TARGET_MPY))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
commutative_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PLUS || GET_CODE (op) == IOR || GET_CODE (op) == XOR || GET_CODE (op) == AND) || ((mult_operator (op, mode)) || ((GET_CODE (op) == SS_PLUS) && (
#line 553 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(TARGET_ARC700 || TARGET_EA_SET))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
commutative_operator_sans_mult (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PLUS || GET_CODE (op) == IOR || GET_CODE (op) == XOR || GET_CODE (op) == AND) || ((GET_CODE (op) == SS_PLUS) && (
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(TARGET_ARC700 || TARGET_EA_SET)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
noncommutative_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (((GET_CODE (op) == ASHIFT || GET_CODE (op) == ASHIFTRT || GET_CODE (op) == LSHIFTRT || GET_CODE (op) == ROTATERT) && (
#line 564 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(TARGET_BARREL_SHIFTER))) || ((GET_CODE (op) == MINUS) || ((GET_CODE (op) == SS_MINUS) && (
#line 567 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(TARGET_ARC700 || TARGET_EA_SET))))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
unary_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == ABS || GET_CODE (op) == NEG || GET_CODE (op) == NOT || GET_CODE (op) == SIGN_EXTEND || GET_CODE (op) == ZERO_EXTEND) || (((GET_CODE (op) == SS_NEG) || ((GET_CODE (op) == SS_TRUNCATE) && (
#line 574 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(GET_MODE (XEXP (op, 0)) == HImode)))) && (
#line 575 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(TARGET_ARC700 || TARGET_EA_SET)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
_1_2_3_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 580 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(INTVAL (op) == 1 || INTVAL (op) == 2 || INTVAL (op) == 3));
}

bool
_2_4_8_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 585 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(INTVAL (op) == 2 || INTVAL (op) == 4 || INTVAL (op) == 8));
}

static inline bool
arc_double_register_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 590 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  if ((GET_MODE (op) != mode) && (mode != VOIDmode))
    return 0;

  return (GET_CODE (op) == REG
		   && (REGNO (op) >= FIRST_PSEUDO_REGISTER
			     || REGNO_REG_CLASS (REGNO (op)) == DOUBLE_REGS));
}

bool
arc_double_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
(arc_double_register_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
shouldbe_register_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 601 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  return ((reload_in_progress || reload_completed)
	  ? general_operand : register_operand) (op, mode);
}

bool
shouldbe_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
    case MEM:
      break;
    default:
      return false;
    }
  return (
(shouldbe_register_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
vector_register_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 608 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  if ((GET_MODE (op) != mode) && (mode != VOIDmode))
    return 0;

  return (GET_CODE (op) == REG
	  && (REGNO (op) >= FIRST_PSEUDO_REGISTER
	      || REGNO_REG_CLASS (REGNO (op)) == SIMD_VR_REGS));
}

bool
vector_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
(vector_register_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
vector_register_or_memory_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 620 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  if ((GET_MODE (op) != mode) && (mode != VOIDmode))
    return 0;

  if ((GET_CODE (op) == MEM)
      && (mode == V8HImode)
      && GET_CODE (XEXP (op,0)) == REG)
    return 1;

  return (GET_CODE (op) == REG
	  && (REGNO (op) >= FIRST_PSEUDO_REGISTER
	      || REGNO_REG_CLASS (REGNO (op)) == SIMD_VR_REGS));
}

bool
vector_register_or_memory_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (((GET_CODE (op) == REG) || (GET_CODE (op) == MEM)) && (
(vector_register_or_memory_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
arc_dpfp_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case PLUS:
    case MULT:
    case MINUS:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

static inline bool
arc_simd_dma_register_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 640 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  if ((GET_MODE (op) != mode) && (mode != VOIDmode))
    return 0;

  return (GET_CODE (op) == REG
	  && (REGNO (op) >= FIRST_PSEUDO_REGISTER
	      || REGNO_REG_CLASS (REGNO (op)) == SIMD_DMA_CONFIG_REGS));
}

bool
arc_simd_dma_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
(arc_simd_dma_register_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
acc1_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 651 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(REGNO (op) == (TARGET_BIG_ENDIAN ? 56 : 57)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
acc2_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 655 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(REGNO (op) == (TARGET_BIG_ENDIAN ? 57 : 56)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
mlo_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 659 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(REGNO (op) == R58_REG))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
mhi_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 663 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(REGNO (op) == R59_REG))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
accl_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && ((
#line 667 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(REGNO (op) == (TARGET_BIG_ENDIAN ? 59 : 58))) && (
#line 668 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(TARGET_V2)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
extend_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || ((immediate_operand (op, mode)) && ((!(const_int_operand (op, mode))) || (
#line 677 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(reload_in_progress || reload_completed))));
}

static inline bool
millicode_store_operation_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 681 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  return arc_check_millicode (op, 0, 0);
}

bool
millicode_store_operation (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PARALLEL) && (
(millicode_store_operation_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
millicode_load_operation_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 687 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  return arc_check_millicode (op, 2, 2);
}

bool
millicode_load_operation (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PARALLEL) && (
(millicode_load_operation_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
millicode_load_clob_operation_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 693 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
  return arc_check_millicode (op, 0, 1);
}

bool
millicode_load_clob_operation (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PARALLEL) && (
(millicode_load_clob_operation_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
immediate_usidi_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) ? (
#line 700 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(INTVAL (op) >= 0)) : ((
#line 701 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(const_double_operand (op, mode))) && (
#line 702 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(CONST_DOUBLE_HIGH (op) == 0)));
}

bool
short_const_int_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_int_operand (op, mode)) && (
#line 706 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(satisfies_constraint_C16 (op)));
}

bool
mem_noofs_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && (GET_CODE (XEXP (op, 0)) == REG)) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
any_mem_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == MEM) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
even_register_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 718 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
   if ((GET_MODE (op) != mode) && (mode != VOIDmode))
      return 0;

   return (REG_P (op) && ((REGNO (op) >= FIRST_PSEUDO_REGISTER)
			  || ((REGNO (op) & 1) == 0)));
  }

bool
even_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
(even_register_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
double_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((
#line 727 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(even_register_operand (op, mode))) || (
#line 728 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(arc_double_register_operand (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
cmem_address_0 (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SYMBOL_REF) && (
#line 732 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(SYMBOL_REF_FLAGS (op) & SYMBOL_FLAG_CMEM))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
cmem_address_1 (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == PLUS) && (
#line 736 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(cmem_address_0 (XEXP (op, 0), SImode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
cmem_address_2 (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == CONST) && (
#line 740 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(cmem_address_1 (XEXP (op, 0), SImode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
cmem_address (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((cmem_address_0 (op, SImode)) || ((cmem_address_1 (op, SImode)) || (cmem_address_2 (op, SImode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
short_unsigned_const_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(satisfies_constraint_J16 (op)));
}

bool
arc_short_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((
#line 752 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(register_operand (op, mode))) || (
#line 753 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(short_unsigned_const_operand (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

static inline bool
push_multi_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 757 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
   return arc_check_multi (op, true);
}

bool
push_multi_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == PARALLEL) && (
(push_multi_operand_1 (op, mode)));
}

static inline bool
pop_multi_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 763 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
{
   return arc_check_multi (op, false);
}

bool
pop_multi_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == PARALLEL) && (
(pop_multi_operand_1 (op, mode)));
}

bool
arc_nonmemory_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((
#line 768 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(register_operand (op, mode))) || ((GET_CODE (op) == CONST_INT || GET_CODE (op) == SYMBOL_REF) && (
#line 770 "../../gcc-15.0.1-20250313/gcc/config/arc/predicates.md"
(!optimize_size)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

enum constraint_num
lookup_constraint_1 (const char *str)
{
  switch (str[0])
    {
    case ':':
      return CONSTRAINT__c;
    case '<':
      return CONSTRAINT__l;
    case '>':
      return CONSTRAINT__g;
    case 'A':
      if (!strncmp (str + 1, "TO", 2))
        return CONSTRAINT_ATO;
      break;
    case 'C':
      if (!strncmp (str + 1, "16", 2))
        return CONSTRAINT_C16;
      if (!strncmp (str + 1, "_0", 2))
        return CONSTRAINT_C__0;
      if (!strncmp (str + 1, "n0", 2))
        return CONSTRAINT_Cn0;
      if (!strncmp (str + 1, "M4", 2))
        return CONSTRAINT_CM4;
      if (!strncmp (str + 1, "P4", 2))
        return CONSTRAINT_CP4;
      if (!strncmp (str + 1, "0p", 2))
        return CONSTRAINT_C0p;
      if (!strncmp (str + 1, "1p", 2))
        return CONSTRAINT_C1p;
      if (!strncmp (str + 1, "2p", 2))
        return CONSTRAINT_C2p;
      if (!strncmp (str + 1, "3p", 2))
        return CONSTRAINT_C3p;
      if (!strncmp (str + 1, "cp", 2))
        return CONSTRAINT_Ccp;
      if (!strncmp (str + 1, "ux", 2))
        return CONSTRAINT_Cux;
      if (!strncmp (str + 1, "hs", 2))
        return CONSTRAINT_Chs;
      if (!strncmp (str + 1, "lo", 2))
        return CONSTRAINT_Clo;
      if (!strncmp (str + 1, "hi", 2))
        return CONSTRAINT_Chi;
      if (!strncmp (str + 1, "bf", 2))
        return CONSTRAINT_Cbf;
      if (!strncmp (str + 1, "bn", 2))
        return CONSTRAINT_Cbn;
      if (!strncmp (str + 1, "18", 2))
        return CONSTRAINT_C18;
      if (!strncmp (str + 1, "bi", 2))
        return CONSTRAINT_Cbi;
      if (!strncmp (str + 1, "0x", 2))
        return CONSTRAINT_C0x;
      if (!strncmp (str + 1, "ax", 2))
        return CONSTRAINT_Cax;
      if (!strncmp (str + 1, "fZ", 2))
        return CONSTRAINT_CfZ;
      if (!strncmp (str + 1, "br", 2))
        return CONSTRAINT_Cbr;
      if (!strncmp (str + 1, "bp", 2))
        return CONSTRAINT_Cbp;
      if (!strncmp (str + 1, "ji", 2))
        return CONSTRAINT_Cji;
      if (!strncmp (str + 1, "sc", 2))
        return CONSTRAINT_Csc;
      if (!strncmp (str + 1, "pc", 2))
        return CONSTRAINT_Cpc;
      if (!strncmp (str + 1, "lb", 2))
        return CONSTRAINT_Clb;
      if (!strncmp (str + 1, "al", 2))
        return CONSTRAINT_Cal;
      if (!strncmp (str + 1, "32", 2))
        return CONSTRAINT_C32;
      if (!strncmp (str + 1, "sz", 2))
        return CONSTRAINT_Csz;
      if (!strncmp (str + 1, "m1", 2))
        return CONSTRAINT_Cm1;
      if (!strncmp (str + 1, "m2", 2))
        return CONSTRAINT_Cm2;
      if (!strncmp (str + 1, "m3", 2))
        return CONSTRAINT_Cm3;
      if (!strncmp (str + 1, "62", 2))
        return CONSTRAINT_C62;
      if (!strncmp (str + 1, "6u", 2))
        return CONSTRAINT_C6u;
      if (!strncmp (str + 1, "6n", 2))
        return CONSTRAINT_C6n;
      if (!strncmp (str + 1, "Is", 2))
        return CONSTRAINT_CIs;
      if (!strncmp (str + 1, "4p", 2))
        return CONSTRAINT_C4p;
      if (!strncmp (str + 1, "nL", 2))
        return CONSTRAINT_CnL;
      break;
    case 'D':
      return CONSTRAINT_D;
    case 'E':
      return CONSTRAINT_E;
    case 'F':
      return CONSTRAINT_F;
    case 'G':
      return CONSTRAINT_G;
    case 'H':
      return CONSTRAINT_H;
    case 'I':
      return CONSTRAINT_I;
    case 'J':
      if (!strncmp (str + 1, "16", 2))
        return CONSTRAINT_J16;
      if (!strncmp (str + 1, "12", 2))
        return CONSTRAINT_J12;
      break;
    case 'K':
      return CONSTRAINT_K;
    case 'L':
      return CONSTRAINT_L;
    case 'M':
      return CONSTRAINT_M;
    case 'N':
      return CONSTRAINT_N;
    case 'O':
      return CONSTRAINT_O;
    case 'P':
      return CONSTRAINT_P;
    case 'Q':
      return CONSTRAINT_Q;
    case 'R':
      if (!strncmp (str + 1, "rq", 2))
        return CONSTRAINT_Rrq;
      if (!strncmp (str + 1, "sc", 2))
        return CONSTRAINT_Rsc;
      if (!strncmp (str + 1, "cb", 2))
        return CONSTRAINT_Rcb;
      if (!strncmp (str + 1, "ck", 2))
        return CONSTRAINT_Rck;
      if (!strncmp (str + 1, "cc", 2))
        return CONSTRAINT_Rcc;
      if (!strncmp (str + 1, "al", 2))
        return CONSTRAINT_Ral;
      if (!strncmp (str + 1, "cd", 2))
        return CONSTRAINT_Rcd;
      if (!strncmp (str + 1, "sd", 2))
        return CONSTRAINT_Rsd;
      if (!strncmp (str + 1, "zd", 2))
        return CONSTRAINT_Rzd;
      if (!strncmp (str + 1, "ac", 2))
        return CONSTRAINT_Rac;
      break;
    case 'S':
      return CONSTRAINT_S;
    case 'T':
      return CONSTRAINT_T;
    case 'U':
      if (!strncmp (str + 1, "ex", 2))
        return CONSTRAINT_Uex;
      if (!strncmp (str + 1, "sd", 2))
        return CONSTRAINT_Usd;
      if (!strncmp (str + 1, "sc", 2))
        return CONSTRAINT_Usc;
      if (!strncmp (str + 1, "s<", 2))
        return CONSTRAINT_Us_l;
      if (!strncmp (str + 1, "s>", 2))
        return CONSTRAINT_Us_g;
      if (!strncmp (str + 1, "cm", 2))
        return CONSTRAINT_Ucm;
      if (!strncmp (str + 1, "cd", 2))
        return CONSTRAINT_Ucd;
      if (!strncmp (str + 1, "ts", 2))
        return CONSTRAINT_Uts;
      break;
    case 'V':
      return CONSTRAINT_V;
    case 'W':
      return CONSTRAINT_W;
    case 'X':
      return CONSTRAINT_X;
    case 'c':
      return CONSTRAINT_c;
    case 'd':
      return CONSTRAINT_d;
    case 'h':
      return CONSTRAINT_h;
    case 'i':
      return CONSTRAINT_i;
    case 'l':
      return CONSTRAINT_l;
    case 'm':
      return CONSTRAINT_m;
    case 'n':
      return CONSTRAINT_n;
    case 'o':
      return CONSTRAINT_o;
    case 'p':
      return CONSTRAINT_p;
    case 'q':
      return CONSTRAINT_q;
    case 'r':
      return CONSTRAINT_r;
    case 's':
      return CONSTRAINT_s;
    case 'v':
      return CONSTRAINT_v;
    case 'w':
      return CONSTRAINT_w;
    case 'x':
      return CONSTRAINT_x;
    default: break;
    }
  return CONSTRAINT__UNKNOWN;
}

const unsigned char lookup_constraint_array[] = {
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__c, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__l, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__g, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  UCHAR_MAX,
  CONSTRAINT__UNKNOWN,
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_D, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_E, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_F, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_G, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_H, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_I, (int) UCHAR_MAX),
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_K, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_L, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_M, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_N, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_O, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_P, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_Q, (int) UCHAR_MAX),
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_S, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_T, (int) UCHAR_MAX),
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_V, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_W, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_X, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_c, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_d, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_h, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_i, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_l, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_m, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_n, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_o, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_p, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_q, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_r, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_s, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_v, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_w, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_x, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN
};

enum reg_class
reg_class_for_constraint_1 (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_r: return GENERAL_REGS;
    case CONSTRAINT_c: return GENERAL_REGS;
    case CONSTRAINT_Rac: return GENERAL_REGS;
    case CONSTRAINT_w: return GENERAL_REGS;
    case CONSTRAINT_W: return GENERAL_REGS;
    case CONSTRAINT_x: return R0_REGS;
    case CONSTRAINT_q: return ARCOMPACT16_REGS;
    case CONSTRAINT_Rrq: return TARGET_RRQ_CLASS ? ARCOMPACT16_REGS : NO_REGS;
    case CONSTRAINT_D: return DOUBLE_REGS;
    case CONSTRAINT_d: return SIMD_DMA_CONFIG_REGS;
    case CONSTRAINT_v: return SIMD_VR_REGS;
    case CONSTRAINT_Rsc: return SIBCALL_REGS;
    case CONSTRAINT_h: return TARGET_V2 ? AC16_H_REGS : NO_REGS;
    case CONSTRAINT_Rcd: return TARGET_CODE_DENSITY ? R0R3_CD_REGS : NO_REGS;
    case CONSTRAINT_Rsd: return TARGET_CODE_DENSITY ? R0R1_CD_REGS : NO_REGS;
    case CONSTRAINT_Rzd: return TARGET_CODE_DENSITY ? R0_REGS : NO_REGS;
    default: break;
    }
  return NO_REGS;
}

bool (*constraint_satisfied_p_array[]) (rtx) = {
  satisfies_constraint_I,
  satisfies_constraint_K,
  satisfies_constraint_L,
  satisfies_constraint_M,
  satisfies_constraint_N,
  satisfies_constraint_O,
  satisfies_constraint_P,
  satisfies_constraint_J12,
  satisfies_constraint_J16,
  satisfies_constraint_m,
  satisfies_constraint_o,
  satisfies_constraint_T,
  satisfies_constraint_Uts,
  satisfies_constraint_S,
  satisfies_constraint_Uex,
  satisfies_constraint_Usd,
  satisfies_constraint_Usc,
  satisfies_constraint_ATO,
  satisfies_constraint_Ucd,
  satisfies_constraint_p,
  satisfies_constraint_CnL,
  satisfies_constraint_C16,
  satisfies_constraint_C__0,
  satisfies_constraint_Cn0,
  satisfies_constraint_CM4,
  satisfies_constraint_CP4,
  satisfies_constraint_C0p,
  satisfies_constraint_C1p,
  satisfies_constraint_C2p,
  satisfies_constraint_C3p,
  satisfies_constraint_Ccp,
  satisfies_constraint_Cux,
  satisfies_constraint_Chs,
  satisfies_constraint_Clo,
  satisfies_constraint_Chi,
  satisfies_constraint_Cbf,
  satisfies_constraint_Cbn,
  satisfies_constraint_C18,
  satisfies_constraint_Cbi,
  satisfies_constraint_C0x,
  satisfies_constraint_Cax,
  satisfies_constraint_G,
  satisfies_constraint_H,
  satisfies_constraint_CfZ,
  satisfies_constraint_Cbr,
  satisfies_constraint_Cbp,
  satisfies_constraint_Cji,
  satisfies_constraint_Csc,
  satisfies_constraint_Clb,
  satisfies_constraint_Q,
  satisfies_constraint_Cm1,
  satisfies_constraint_Cm2,
  satisfies_constraint_Cm3,
  satisfies_constraint_C62,
  satisfies_constraint_C6u,
  satisfies_constraint_C6n,
  satisfies_constraint_CIs,
  satisfies_constraint_C4p,
  satisfies_constraint_l,
  satisfies_constraint_Rcb,
  satisfies_constraint_Rck,
  satisfies_constraint_Rcc,
  satisfies_constraint_Ral,
  satisfies_constraint_V,
  satisfies_constraint__l,
  satisfies_constraint__g,
  satisfies_constraint_Us_l,
  satisfies_constraint_Us_g,
  satisfies_constraint_Ucm,
  satisfies_constraint_i,
  satisfies_constraint_s,
  satisfies_constraint__c,
  satisfies_constraint_n,
  satisfies_constraint_E,
  satisfies_constraint_F,
  satisfies_constraint_X,
  satisfies_constraint_Cpc,
  satisfies_constraint_Cal,
  satisfies_constraint_C32,
  satisfies_constraint_Csz
};

bool
insn_const_int_ok_for_constraint (HOST_WIDE_INT ival, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_I:
      return 
#line 95 "../../gcc-15.0.1-20250313/gcc/config/arc/constraints.md"
(SIGNED_INT12 (ival));

    case CONSTRAINT_K:
      return 
#line 101 "../../gcc-15.0.1-20250313/gcc/config/arc/constraints.md"
(UNSIGNED_INT3 (ival));

    case CONSTRAINT_L:
      return 
#line 107 "../../gcc-15.0.1-20250313/gcc/config/arc/constraints.md"
(UNSIGNED_INT6 (ival));

    case CONSTRAINT_M:
      return 
#line 125 "../../gcc-15.0.1-20250313/gcc/config/arc/constraints.md"
(UNSIGNED_INT5 (ival));

    case CONSTRAINT_N:
      return 
#line 131 "../../gcc-15.0.1-20250313/gcc/config/arc/constraints.md"
(IS_ONE (ival));

    case CONSTRAINT_O:
      return 
#line 137 "../../gcc-15.0.1-20250313/gcc/config/arc/constraints.md"
(UNSIGNED_INT7 (ival));

    case CONSTRAINT_P:
      return 
#line 143 "../../gcc-15.0.1-20250313/gcc/config/arc/constraints.md"
(UNSIGNED_INT8 (ival));

    case CONSTRAINT_J12:
      return 
#line 468 "../../gcc-15.0.1-20250313/gcc/config/arc/constraints.md"
(UNSIGNED_INT12 (ival));

    case CONSTRAINT_J16:
      return 
#line 474 "../../gcc-15.0.1-20250313/gcc/config/arc/constraints.md"
(UNSIGNED_INT16 (ival));

    default: break;
    }
  return false;
}


void
init_reg_class_start_regs ()
{
}
