/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2SImode
      || !register_operand (operands[0], E_V2SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_V2SImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!nonmemory_operand (operands[2], E_V2SImode))
    return -1;
  return 0;
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!dest_reg_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonvol_nonimm_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!dest_reg_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonvol_nonimm_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonvol_nonimm_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 61
      || GET_MODE (x5) != E_CC_ZNmode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 61
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!cc_set_register (operands[0], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != i2)
    return -1;
  return 0;
}

int
pattern59 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 58
      || GET_MODE (x2) != E_DImode
      || !even_register_operand (operands[0], E_V2SImode)
      || !register_operand (operands[1], E_V2HImode)
      || !register_operand (operands[2], E_V2HImode))
    return -1;
  return 0;
}

int
pattern67 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!dest_reg_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case ASHIFT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x6, 1);
      operands[1] = x8;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x6;
      x9 = XEXP (x3, 1);
      switch (GET_CODE (x9))
        {
        case ASHIFT:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !nonmemory_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x9, 1);
          operands[2] = x11;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          return 1;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x9;
          if (!nonmemory_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern92 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != MULT)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 58)
    return -1;
  x7 = XEXP (x1, 0);
  operands[3] = x7;
  x8 = XVECEXP (x2, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  x10 = XEXP (x8, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  switch (GET_CODE (x12))
    {
    case REG:
      operands[1] = x12;
      if (!even_register_operand (operands[1], E_SImode)
          || !even_register_operand (operands[0], E_DImode)
          || GET_MODE (x10) != E_DImode
          || GET_MODE (x11) != E_DImode
          || GET_MODE (x6) != E_DImode
          || GET_MODE (x4) != E_DImode
          || GET_MODE (x5) != E_DImode)
        return -1;
      x13 = XEXP (x5, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      return 0;

    case VEC_SELECT:
      if (GET_MODE (x12) != E_V2HImode)
        return -1;
      x14 = XEXP (x12, 1);
      if (GET_CODE (x14) != PARALLEL
          || XVECLEN (x14, 0) != 2)
        return -1;
      x15 = XVECEXP (x14, 0, 0);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x14, 0, 1);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XEXP (x10, 1);
      if (GET_CODE (x17) != i1
          || GET_MODE (x17) != E_V2SImode)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != VEC_SELECT
          || GET_MODE (x18) != E_V2HImode)
        return -1;
      x19 = XEXP (x18, 1);
      if (GET_CODE (x19) != PARALLEL
          || XVECLEN (x19, 0) != 2)
        return -1;
      x20 = XVECEXP (x19, 0, 0);
      if (GET_CODE (x20) != CONST_INT)
        return -1;
      x21 = XVECEXP (x19, 0, 1);
      if (GET_CODE (x21) != CONST_INT)
        return -1;
      x13 = XEXP (x5, 0);
      if (GET_CODE (x13) != VEC_SELECT
          || GET_MODE (x13) != E_V2HImode)
        return -1;
      x22 = XEXP (x13, 1);
      if (GET_CODE (x22) != PARALLEL
          || XVECLEN (x22, 0) != 2)
        return -1;
      x23 = XVECEXP (x22, 0, 0);
      if (GET_CODE (x23) != CONST_INT)
        return -1;
      x24 = XVECEXP (x22, 0, 1);
      if (GET_CODE (x24) != CONST_INT)
        return -1;
      x25 = XEXP (x4, 1);
      if (GET_CODE (x25) != i1
          || GET_MODE (x25) != E_V2SImode)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != VEC_SELECT
          || GET_MODE (x26) != E_V2HImode)
        return -1;
      x27 = XEXP (x26, 1);
      if (GET_CODE (x27) != PARALLEL
          || XVECLEN (x27, 0) != 2)
        return -1;
      x28 = XVECEXP (x27, 0, 0);
      if (GET_CODE (x28) != CONST_INT)
        return -1;
      x29 = XVECEXP (x27, 0, 1);
      if (GET_CODE (x29) != CONST_INT
          || !even_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x10) != E_V2SImode
          || GET_MODE (x11) != E_V2SImode)
        return -1;
      x30 = XEXP (x12, 0);
      operands[1] = x30;
      if (!even_register_operand (operands[1], E_V4HImode))
        return -1;
      x31 = XEXP (x18, 0);
      operands[2] = x31;
      if (!even_register_operand (operands[2], E_V4HImode)
          || GET_MODE (x6) != E_V2SImode
          || GET_MODE (x4) != E_V2SImode
          || GET_MODE (x5) != E_V2SImode)
        return -1;
      x32 = XEXP (x13, 0);
      if (!rtx_equal_p (x32, operands[1]))
        return -1;
      x33 = XEXP (x26, 0);
      if (!rtx_equal_p (x33, operands[2]))
        return -1;
      switch (XWINT (x15, 0))
        {
        case 0L:
          if (XWINT (x16, 0) != 1L
              || XWINT (x20, 0) != 0L
              || XWINT (x21, 0) != 1L
              || XWINT (x23, 0) != 0L
              || XWINT (x24, 0) != 1L
              || XWINT (x28, 0) != 0L
              || XWINT (x29, 0) != 1L)
            return -1;
          return 1;

        case 2L:
          if (XWINT (x16, 0) != 3L
              || XWINT (x20, 0) != 2L
              || XWINT (x21, 0) != 3L
              || XWINT (x23, 0) != 2L
              || XWINT (x24, 0) != 3L
              || XWINT (x28, 0) != 2L
              || XWINT (x29, 0) != 3L)
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode)
              || !cc_register (operands[0], E_VOIDmode))
            return -1;
          if (pnum_clobbers != NULL)
            {
              operands[4] = x2;
              if (zn_compare_operator (operands[4], E_VOIDmode)
                  && 
#line 964 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS))
                {
                  *pnum_clobbers = 1;
                  return 19; /* *tst_movb */
                }
            }
          operands[3] = x2;
          if (!zn_compare_operator (operands[3], E_VOIDmode)
              || !
#line 980 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   || !satisfies_constraint_Cbf (operands[2])
   || satisfies_constraint_C0p (operands[2])
   || satisfies_constraint_I (operands[2])
   || satisfies_constraint_C1p (operands[2])
   || satisfies_constraint_Chs (operands[2])))
            return -1;
          return 20; /* *tst */

        case NOT:
          if (GET_MODE (x7) != E_SImode
              || !cc_set_register (operands[0], E_VOIDmode)
              || GET_MODE (x2) != E_CC_ZNmode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!nonmemory_operand (operands[1], E_SImode)
              || !
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[1], SImode)
   || register_operand (operands[2], SImode)))
            return -1;
          return 36; /* *bic_cmp0_noout */

        default:
          return -1;
        }

    case PLUS:
      if (pattern33 (x1, 
E_CC_Cmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (nonmemory_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x2, 1);
          if (rtx_equal_p (x4, operands[0]))
            return 27; /* addsi_compare_2 */
        }
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      return 28; /* *addsi_compare_3 */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      operands[2] = x4;
      if (const_int_operand (operands[2], E_SImode))
        {
          res = recog_4 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x4, 0) != 1L)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern33 (x1, 
E_CC_ZNmode) != 0)
        return -1;
      x6 = XEXP (x3, 2);
      operands[1] = x6;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 149; /* *btst */

    case NEG:
    case NOT:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case ABS:
    case SS_NEG:
    case SS_TRUNCATE:
      if (GET_MODE (x2) == E_CC_ZNmode
          && GET_MODE (x3) == E_SImode)
        {
          switch (GET_CODE (x3))
            {
            case SIGN_EXTEND:
              switch (pattern44 (x1))
                {
                case 0:
                  return 6; /* *sexxtb_cmp0_noout */

                case 1:
                  return 8; /* *sexxt%__cmp0_noout */

                default:
                  break;
                }
              break;

            case ZERO_EXTEND:
              switch (pattern44 (x1))
                {
                case 0:
                  return 7; /* *extxtb_cmp0_noout */

                case 1:
                  return 9; /* *extxt%__cmp0_noout */

                default:
                  break;
                }
              break;

            case NEG:
              x7 = XEXP (x1, 0);
              if (GET_CODE (x7) == REG
                  && REGNO (x7) == 61
                  && GET_MODE (x7) == E_CC_ZNmode)
                {
                  x8 = XEXP (x3, 0);
                  operands[0] = x8;
                  if (register_operand (operands[0], E_SImode))
                    {
                      x5 = XEXP (x2, 1);
                      operands[1] = x5;
                      if (register_operand (operands[1], E_SImode))
                        return 26; /* *addsi_compare */
                    }
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x3;
      if (!unary_operator (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!cc_set_register (operands[0], E_CC_ZNmode))
        return -1;
      operands[3] = x2;
      if (!zn_compare_operator (operands[3], E_CC_ZNmode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 17; /* unary_comparison */

    case PLUS:
    case MULT:
    case AND:
    case IOR:
    case XOR:
    case SS_PLUS:
      if (GET_MODE (x3) == E_SImode)
        {
          res = recog_5 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[3] = x3;
      if (!commutative_operator (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!cc_set_register (operands[0], E_VOIDmode))
        return -1;
      operands[4] = x2;
      if (!zn_compare_operator (operands[4], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 24; /* *commutative_binary_cmp0_noout */

    case MINUS:
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
    case SS_MINUS:
      operands[4] = x3;
      if (noncommutative_operator (operands[4], E_SImode))
        {
          x5 = XEXP (x2, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x7 = XEXP (x1, 0);
              operands[0] = x7;
              if (cc_set_register (operands[0], E_VOIDmode))
                {
                  operands[3] = x2;
                  if (zn_compare_operator (operands[3], E_VOIDmode))
                    {
                      x8 = XEXP (x3, 0);
                      operands[1] = x8;
                      if (register_operand (operands[1], E_SImode))
                        {
                          x4 = XEXP (x3, 1);
                          operands[2] = x4;
                          if (nonmemory_operand (operands[2], E_SImode))
                            return 32; /* *noncommutative_binary_cmp0_noout */
                        }
                    }
                }
            }
        }
      if (GET_CODE (x3) != MINUS
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      if (!cc_set_register (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x2;
          if (!zn_compare_operator (operands[3], E_VOIDmode)
              || !nonmemory_operand (operands[1], E_SImode))
            return -1;
          return 34; /* *rsub_cmp0_noout */

        case ASHIFT:
          if (GET_MODE (x4) != E_SImode
              || GET_MODE (x2) != E_CCmode
              || !register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          if (!_1_2_3_operand (operands[3], E_SImode))
            return -1;
          return 295; /* *sub_shift_cmp0_noout */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x5;
          res = recog_6 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
              && pattern34 (x1, 
61, 
E_CC_ZNmode) == 0)
            {
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                return 148; /* *cmpsi_cc_zn_insn */
            }
          break;

        case ASHIFT:
          res = recog_7 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 61)
        return -1;
      if (GET_CODE (x3) == REG)
        {
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      operands[1] = x5;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      switch (GET_MODE (x7))
        {
        case E_CC_FP_GTmode:
          if (GET_MODE (x2) != E_CC_FP_GTmode
              || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
            return -1;
          *pnum_clobbers = 1;
          return 322; /* *cmpsf_quark_gt */

        case E_CC_FP_GEmode:
          if (GET_MODE (x2) != E_CC_FP_GEmode
              || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
            return -1;
          *pnum_clobbers = 1;
          return 323; /* *cmpsf_quark_ge */

        case E_CC_FP_ORDmode:
          if (GET_MODE (x2) != E_CC_FP_ORDmode
              || !
#line 646 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
            return -1;
          *pnum_clobbers = 1;
          return 324; /* *cmpsf_quark_ord */

        case E_CC_FP_UNEQmode:
          if (GET_MODE (x2) != E_CC_FP_UNEQmode
              || !
#line 658 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
            return -1;
          *pnum_clobbers = 1;
          return 325; /* *cmpsf_quark_uneq */

        case E_CC_Zmode:
          if (GET_MODE (x2) != E_CC_Zmode
              || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
            return -1;
          *pnum_clobbers = 1;
          return 326; /* *cmpsf_quark_eq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern48 (x3, 
E_SImode) != 0
          || !
#line 5484 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DIVREM))
        return -1;
      return 233; /* divsi3 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      if (register_operand (operands[1], E_SFmode)
          && register_operand (operands[2], E_SFmode)
          && 
#line 681 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
        return 327; /* *divsf3_quark */
      if (!nonmemory_operand (operands[1], E_SFmode)
          || !nonmemory_operand (operands[2], E_SFmode)
          || !
#line 206 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_SQRT
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode))))
        return -1;
      return 340; /* *divsf3_fpu */

    case E_DFmode:
      if (pattern49 (x3) != 0
          || !
#line 322 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_SQRT))
        return -1;
      return 348; /* divdf3 */

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0
          || !
#line 1404 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_DIVREM))
        return -1;
      return 517; /* divv2si3 */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x4, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x3, 1);
  if (GET_CODE (x8) != LABEL_REF)
    return -1;
  x9 = XEXP (x3, 2);
  if (GET_CODE (x9) != PC)
    return -1;
  x10 = XEXP (x2, 0);
  if (GET_CODE (x10) != PC)
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (pattern78 (x11, 
E_CC_ZNmode, 
61) != 0)
    return -1;
  x12 = XEXP (x5, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x13 = XEXP (x5, 2);
  operands[2] = x13;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x14 = XEXP (x8, 0);
  operands[0] = x14;
  if (!
#line 5121 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!CROSSING_JUMP_P (insn)))
    return -1;
  return 209; /* *bbit */
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!arc_double_register_operand (operands[0], E_DFmode))
    return -1;
  x8 = XEXP (x2, 1);
  if (GET_MODE (x8) != E_DFmode)
    return -1;
  x9 = XEXP (x3, 0);
  operands[3] = x9;
  x10 = XEXP (x4, 0);
  operands[4] = x10;
  x11 = XEXP (x5, 0);
  operands[5] = x11;
  x12 = XEXP (x6, 0);
  operands[6] = x12;
  if (!register_operand (operands[6], E_DFmode))
    return -1;
  x13 = XEXP (x6, 1);
  if (GET_MODE (x13) != E_DFmode)
    return -1;
  switch (GET_CODE (x8))
    {
    case PLUS:
      if (pattern114 (x1, 
PLUS) != 0
          || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP &&
   !(GET_CODE(operands[2]) == CONST_DOUBLE && GET_CODE(operands[3]) == CONST_INT)))
        return -1;
      return 319; /* *daddh_peep2_insn */

    case MULT:
      if (pattern114 (x1, 
MULT) != 0
          || !
#line 578 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP &&
   !(GET_CODE(operands[2]) == CONST_DOUBLE && GET_CODE(operands[3]) == CONST_INT)))
        return -1;
      return 320; /* *dmulh_peep2_insn */

    case MINUS:
      if (GET_CODE (x13) != MINUS)
        return -1;
      x14 = XEXP (x8, 0);
      operands[1] = x14;
      if (!nonmemory_operand (operands[1], E_DFmode))
        return -1;
      x15 = XEXP (x8, 1);
      operands[2] = x15;
      if (!nonmemory_operand (operands[2], E_DFmode))
        return -1;
      x16 = XEXP (x13, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x17 = XEXP (x13, 1);
      if (!rtx_equal_p (x17, operands[2])
          || !
#line 606 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP &&
   !(GET_CODE(operands[2]) == CONST_DOUBLE && GET_CODE(operands[3]) == CONST_INT)  &&
   !(GET_CODE(operands[1]) == CONST_DOUBLE && GET_CODE(operands[3]) == CONST_INT)))
        return -1;
      return 321; /* *dsubh_peep2_insn */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          operands[2] = x5;
          if (!short_const_int_operand (operands[2], E_HImode)
              || pattern88 (x1) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2032 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPYW)))
            return -1;
          return 678; /* *p mulhisi3_imm */

        case SIGN_EXTEND:
          if (GET_MODE (x5) == E_SImode
              && pattern88 (x1) == 0)
            {
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (nonmemory_operand (operands[2], E_HImode)
                  && (
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2045 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPYW)))
                return 679; /* *p mulhisi3_reg */
            }
          if (GET_MODE (x5) != E_DImode
              || pattern89 (x1, 
58) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2243 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET)))
            return -1;
          return 684; /* *p mul64 */

        case ZERO_EXTRACT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x7 = XEXP (x5, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x8 = XEXP (x5, 2);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern89 (x1, 
56) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2402 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET)))
            return -1;
          return 688; /* *p mul64_600 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          operands[2] = x5;
          if (!short_unsigned_const_operand (operands[2], E_HImode)
              || pattern88 (x1) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2072 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPYW)))
            return -1;
          return 680; /* *p umulhisi3_imm */

        case ZERO_EXTEND:
          if (GET_MODE (x5) == E_SImode
              && pattern88 (x1) == 0)
            {
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (register_operand (operands[2], E_HImode)
                  && (
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2085 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPYW)))
                return 681; /* *p umulhisi3_reg */
            }
          if (GET_MODE (x5) != E_DImode
              || pattern89 (x1, 
58) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2278 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET)))
            return -1;
          return 685; /* *p mulu64 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x9 = XEXP (x1, 0);
      operands[3] = x9;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern108 (x3) != 0)
            return -1;
          if ((
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2298 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_ARC700_MPY)))
            return 686; /* *p mulsi3_700 */
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULTI)))
            return -1;
          return 687; /* *p mulsi3_v2 */

        case E_SFmode:
          if (pattern104 (x3, 
E_SFmode) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 44 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)))))
            return -1;
          return 765; /* *p *mulsf3_fpu */

        case E_DFmode:
          if (pattern105 (x3) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE)))
            return -1;
          return 775; /* *p *muldf3_fpu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_56 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_42 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_43 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_44 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_45 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[0] = x1;
      if (XVECLEN (operands[0], 0) >= 1)
        {
          res = recog_46 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 3)
        {
          res = recog_47 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) < 2)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PLUS
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 28
          || GET_MODE (x4) != E_SImode
          || pattern79 (x1, 
E_SImode, 
28) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (GET_CODE (x8))
        {
        case REG:
          if (GET_CODE (x7) != MEM)
            return -1;
          x9 = XEXP (x7, 0);
          if (GET_CODE (x9) != PLUS
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 28
              || GET_MODE (x10) != E_SImode
              || !push_multi_operand (operands[0], E_VOIDmode))
            return -1;
          x11 = XEXP (x9, 1);
          operands[2] = x11;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          switch (REGNO (x8))
            {
            case 13:
              if (!
#line 6755 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_CODE_DENSITY))
                return -1;
              return 297; /* *push_multi_fp */

            case 31:
              if (!
#line 6783 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_CODE_DENSITY))
                return -1;
              return 298; /* *push_multi_fp_blink */

            default:
              return -1;
            }

        case MEM:
          x12 = XEXP (x8, 0);
          if (pattern110 (x12, 
28) != 0
              || GET_CODE (x7) != REG
              || !pop_multi_operand (operands[0], E_VOIDmode))
            return -1;
          x13 = XEXP (x12, 1);
          operands[2] = x13;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          switch (REGNO (x7))
            {
            case 13:
              if (!
#line 6812 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_CODE_DENSITY))
                return -1;
              return 299; /* *pop_multi_fp */

            case 31:
              if (!
#line 6842 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_CODE_DENSITY))
                return -1;
              return 300; /* *pop_multi_fp_blink */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case COND_EXEC:
      x14 = XEXP (x1, 0);
      switch (GET_CODE (x14))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          if (GET_CODE (x14) == NE)
            {
              x16 = XEXP (x1, 1);
              if (GET_CODE (x16) == SET)
                {
                  x17 = XEXP (x14, 0);
                  operands[2] = x17;
                  if (cc_use_register (operands[2], E_CC_Zmode))
                    {
                      x18 = XEXP (x16, 0);
                      operands[0] = x18;
                      if (dest_reg_operand (operands[0], E_SImode))
                        {
                          x19 = XEXP (x16, 1);
                          operands[1] = x19;
                          if (nonmemory_operand (operands[1], E_SImode))
                            return 155; /* *movsi_ne */
                        }
                    }
                }
            }
          x17 = XEXP (x14, 0);
          if (GET_CODE (x17) != REG)
            return -1;
          return recog_55 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x14 = XEXP (x1, 0);
      if (GET_CODE (x14) != MEM
          || GET_MODE (x14) != E_SImode)
        return -1;
      x17 = XEXP (x14, 0);
      operands[0] = x17;
      if (!call_address_operand (operands[0], E_SImode))
        return -1;
      x16 = XEXP (x1, 1);
      operands[1] = x16;
      *pnum_clobbers = 1;
      return 167; /* *call_i */

    case TRAP_IF:
      x14 = XEXP (x1, 0);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x16 = XEXP (x1, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !
#line 4372 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_ARC600_FAMILY))
        return -1;
      return 169; /* trap */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 170; /* nop */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 49:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 171; /* nopv */

            case 58:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 172; /* blockage */

            case 61:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 4404 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET))
                return -1;
              return 173; /* arc600_stall */

            case 37:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_SImode))
                return -1;
              return 181; /* flag */

            case 36:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_SImode))
                return -1;
              return 182; /* brk */

            case 35:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_SImode))
                return -1;
              return 184; /* sync */

            case 39:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_SImode))
                return -1;
              return 185; /* swi */

            case 38:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_SImode))
                return -1;
              return 186; /* sleep */

            case 44:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_SImode)
                  || !
#line 4855 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_ARC600_FAMILY))
                return -1;
              return 201; /* trap_s */

            case 45:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!immediate_operand (operands[0], E_SImode)
                  || !
#line 4873 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_ARC600_FAMILY))
                return -1;
              return 202; /* unimp_s */

            case 46:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_SImode)
                  || !
#line 5664 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2))
                return -1;
              return 248; /* kflag */

            case 48:
              if (GET_MODE (x1) != E_SImode)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_SImode)
                  || !
#line 5731 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2))
                return -1;
              return 253; /* seti */

            case 50:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              return 273; /* stack_irq_dwarf */

            case 59:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 303; /* eh_return */

            case 152:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_SImode)
                  || !
#line 1212 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
                return -1;
              return 464; /* vrec_insn */

            case 153:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_SImode)
                  || !
#line 1221 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
                return -1;
              return 465; /* vrun_insn */

            case 154:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_SImode)
                  || !
#line 1230 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
                return -1;
              return 466; /* vrecrun_insn */

            case 155:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_SImode)
                  || !
#line 1239 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
                return -1;
              return 467; /* vendrec_insn */

            case 157:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!nonmemory_operand (operands[0], E_SImode)
                  || !
#line 1381 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
                return -1;
              return 475; /* vinti_insn */

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          switch (XINT (x1, 1))
            {
            case 41:
              if (!general_operand (operands[0], E_SImode)
                  || !general_operand (operands[1], E_SImode))
                return -1;
              return 188; /* core_write */

            case 43:
              if (!general_operand (operands[0], E_SImode)
                  || !general_operand (operands[1], E_SImode))
                return -1;
              return 190; /* sr */

            case 63:
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (!memory_operand (operands[0], E_QImode)
                      || !nonmemory_operand (operands[1], E_QImode))
                    return -1;
                  return 195; /* stdiqi */

                case E_HImode:
                  if (!memory_operand (operands[0], E_HImode)
                      || !nonmemory_operand (operands[1], E_HImode))
                    return -1;
                  return 196; /* stdihi */

                case E_SImode:
                  if (!memory_operand (operands[0], E_SImode)
                      || !nonmemory_operand (operands[1], E_SImode))
                    return -1;
                  return 197; /* stdisi */

                case E_DImode:
                  if (!memory_operand (operands[0], E_DImode))
                    return -1;
                  if (nonmemory_operand (operands[1], E_DImode)
                      && 
#line 4794 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_LL64))
                    return 198; /* stdidi */
                  if (!register_operand (operands[1], E_DImode)
                      || !
#line 4818 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_LL64))
                    return -1;
                  return 199; /* *stdidi_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIMPLE_RETURN:
      return 205; /* simple_return */

    case PREFETCH:
      x16 = XEXP (x1, 1);
      if (!const_int_operand (x16, E_SImode))
        return -1;
      x20 = XEXP (x1, 2);
      if (!const_int_operand (x20, E_SImode))
        return -1;
      x14 = XEXP (x1, 0);
      switch (GET_CODE (x14))
        {
        case REG:
        case SUBREG:
          operands[0] = x14;
          if (register_operand (operands[0], E_SImode))
            {
              operands[1] = x16;
              operands[2] = x20;
              if (
#line 5440 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_HS))
                return 230; /* prefetch_1 */
            }
          break;

        case PLUS:
          if (GET_MODE (x14) == E_SImode)
            {
              x17 = XEXP (x14, 0);
              operands[0] = x17;
              if (register_operand (operands[0], E_SImode))
                {
                  x15 = XEXP (x14, 1);
                  operands[1] = x15;
                  if (nonmemory_operand (operands[1], E_SImode))
                    {
                      operands[2] = x16;
                      operands[3] = x20;
                      if (
#line 5455 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_HS))
                        return 231; /* prefetch_2 */
                    }
                }
            }
          break;

        default:
          break;
        }
      operands[2] = x20;
      operands[0] = x14;
      if (!address_operand (operands[0], E_SImode))
        return -1;
      operands[1] = x16;
      if (!
#line 5469 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_HS))
        return -1;
      return 232; /* prefetch_3 */

    default:
      return -1;
    }
}
