/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !dest_reg_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vector_register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vector_register_operand (operands[1], E_V8HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vector_register_operand (operands[2], E_V8HImode))
    return -1;
  return 0;
}

int
pattern20 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!arc_double_register_operand (operands[0], E_DFmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!arc_double_register_operand (operands[1], E_DFmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  if (!nonmemory_operand (operands[2], E_DFmode))
    return -1;
  x10 = XEXP (x4, 0);
  operands[3] = x10;
  x11 = XEXP (x5, 0);
  operands[4] = x11;
  x12 = XEXP (x6, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  return 0;
}

int
pattern39 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XWINT (x2, 0))
    {
    case 16L:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case 1L:
      if (pattern37 (x1, pnum_clobbers) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != 58)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 58)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || GET_MODE (x5) != E_DImode
          || GET_MODE (x6) != E_DImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x8) != E_DImode
          || !extend_operand (operands[1], E_SImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_V2SImode:
      if (GET_MODE (x2) != E_V2SImode
          || GET_MODE (x5) != E_V2SImode
          || GET_MODE (x6) != E_V2SImode
          || !register_operand (operands[0], E_V2HImode)
          || GET_MODE (x8) != E_V2SImode
          || !register_operand (operands[1], E_V2HImode)
          || GET_MODE (x3) != E_V2SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!dest_reg_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern81 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 0);
  switch (GET_MODE (x5))
    {
    case E_CC_Zmode:
      if (GET_MODE (x2) != E_CC_Zmode)
        return -1;
      return 0;

    case E_CC_FP_GTmode:
      if (GET_MODE (x2) != E_CC_FP_GTmode)
        return -1;
      return 1;

    case E_CC_FP_GEmode:
      if (GET_MODE (x2) != E_CC_FP_GEmode)
        return -1;
      return 2;

    case E_CC_FP_UNEQmode:
      if (GET_MODE (x2) != E_CC_FP_UNEQmode)
        return -1;
      return 3;

    case E_CC_FP_ORDmode:
      if (GET_MODE (x2) != E_CC_FP_ORDmode)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern98 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XVECEXP (x2, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != REG)
        return -1;
      return 0;

    case VEC_SELECT:
      if (GET_MODE (x9) != E_HImode)
        return -1;
      x11 = XEXP (x9, 1);
      if (GET_CODE (x11) != PARALLEL
          || XVECLEN (x11, 0) != 1)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x7, 1);
      if (GET_CODE (x13) != i1
          || GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != VEC_SELECT
          || GET_MODE (x14) != E_HImode)
        return -1;
      x15 = XEXP (x14, 1);
      if (GET_CODE (x15) != PARALLEL
          || XVECLEN (x15, 0) != 1)
        return -1;
      x16 = XVECEXP (x15, 0, 0);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != MULT
          || GET_MODE (x10) != E_SImode)
        return -1;
      x17 = XEXP (x10, 0);
      if (GET_CODE (x17) != i1
          || GET_MODE (x17) != E_SImode)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != VEC_SELECT
          || GET_MODE (x18) != E_HImode)
        return -1;
      x19 = XEXP (x18, 1);
      if (GET_CODE (x19) != PARALLEL
          || XVECLEN (x19, 0) != 1)
        return -1;
      x20 = XVECEXP (x19, 0, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x21 = XEXP (x10, 1);
      if (GET_CODE (x21) != i1
          || GET_MODE (x21) != E_SImode)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != VEC_SELECT
          || GET_MODE (x22) != E_HImode)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != PARALLEL
          || XVECLEN (x23, 0) != 1)
        return -1;
      x24 = XVECEXP (x23, 0, 0);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x25 = XEXP (x3, 1);
      if (GET_CODE (x25) != ZERO_EXTEND
          || GET_MODE (x25) != E_DImode)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != PLUS
          || GET_MODE (x26) != E_SImode)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != MULT
          || GET_MODE (x27) != E_SImode)
        return -1;
      x28 = XEXP (x27, 0);
      if (GET_CODE (x28) != i1
          || GET_MODE (x28) != E_SImode)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != VEC_SELECT
          || GET_MODE (x29) != E_HImode)
        return -1;
      x30 = XEXP (x29, 1);
      if (GET_CODE (x30) != PARALLEL
          || XVECLEN (x30, 0) != 1)
        return -1;
      x31 = XVECEXP (x30, 0, 0);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x32 = XEXP (x27, 1);
      if (GET_CODE (x32) != i1
          || GET_MODE (x32) != E_SImode)
        return -1;
      x33 = XEXP (x32, 0);
      if (GET_CODE (x33) != VEC_SELECT
          || GET_MODE (x33) != E_HImode)
        return -1;
      x34 = XEXP (x33, 1);
      if (GET_CODE (x34) != PARALLEL
          || XVECLEN (x34, 0) != 1)
        return -1;
      x35 = XVECEXP (x34, 0, 0);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x36 = XEXP (x26, 1);
      if (GET_CODE (x36) != MULT
          || GET_MODE (x36) != E_SImode)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != i1
          || GET_MODE (x37) != E_SImode)
        return -1;
      x38 = XEXP (x37, 0);
      if (GET_CODE (x38) != VEC_SELECT
          || GET_MODE (x38) != E_HImode)
        return -1;
      x39 = XEXP (x38, 1);
      if (GET_CODE (x39) != PARALLEL
          || XVECLEN (x39, 0) != 1)
        return -1;
      x40 = XVECEXP (x39, 0, 0);
      if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x41 = XEXP (x36, 1);
      if (GET_CODE (x41) != i1
          || GET_MODE (x41) != E_SImode)
        return -1;
      x42 = XEXP (x41, 0);
      if (GET_CODE (x42) != VEC_SELECT
          || GET_MODE (x42) != E_HImode)
        return -1;
      x43 = XEXP (x42, 1);
      if (GET_CODE (x43) != PARALLEL
          || XVECLEN (x43, 0) != 1)
        return -1;
      x44 = XVECEXP (x43, 0, 0);
      if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x45 = XEXP (x3, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 58
          || GET_MODE (x45) != E_DImode)
        return -1;
      x46 = XEXP (x5, 0);
      operands[0] = x46;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || GET_MODE (x7) != E_SImode
          || GET_MODE (x8) != E_SImode)
        return -1;
      x47 = XEXP (x9, 0);
      operands[1] = x47;
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      x48 = XEXP (x14, 0);
      operands[2] = x48;
      if (!register_operand (operands[2], E_V2HImode))
        return -1;
      x49 = XEXP (x18, 0);
      if (!rtx_equal_p (x49, operands[1]))
        return -1;
      x50 = XEXP (x22, 0);
      if (!rtx_equal_p (x50, operands[2]))
        return -1;
      x51 = XEXP (x29, 0);
      if (!rtx_equal_p (x51, operands[1]))
        return -1;
      x52 = XEXP (x33, 0);
      if (!rtx_equal_p (x52, operands[2]))
        return -1;
      x53 = XEXP (x38, 0);
      if (!rtx_equal_p (x53, operands[1]))
        return -1;
      x54 = XEXP (x42, 0);
      if (!rtx_equal_p (x54, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT)
    {
      switch (pattern38 (x2, pnum_clobbers))
        {
        case 0:
          if (
#line 3466 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_SWAP && TARGET_V2))
            return 125; /* ashlsi2_cnt16 */
          break;

        case 1:
          if (
#line 3549 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 138; /* *ashldi3_cnt1 */
            }
          break;

        default:
          break;
        }
    }
  if (!register_operand (operands[1], E_SImode)
      || !dest_reg_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  operands[2] = x3;
  if (nonmemory_operand (operands[2], E_SImode))
    {
      if (
#line 3504 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx
   && arc_pre_reload_split ()))
        return 128; /* *ashlsi3_nobs */
      if (pnum_clobbers != NULL
          && 
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx))
        {
          *pnum_clobbers = 2;
          return 133; /* ashlsi3_loop */
        }
    }
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 266; /* ashlsi3_cnt1 */
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern7 (x1, 
SIGN_EXTEND))
        {
        case 0:
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case CONST_INT:
              operands[2] = x4;
              if (!short_const_int_operand (operands[2], E_HImode)
                  || pattern61 (x1) != 0
                  || !
#line 2032 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPYW))
                return -1;
              return 68; /* mulhisi3_imm */

            case SIGN_EXTEND:
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern76 (x2, 
E_HImode, 
E_SImode) == 0
                      && 
#line 2045 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPYW))
                    return 69; /* mulhisi3_reg */
                  break;

                case E_DImode:
                  if (pnum_clobbers != NULL
                      && pattern76 (x2, 
E_SImode, 
E_DImode) == 0
                      && 
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET))
                    {
                      *pnum_clobbers = 1;
                      return 77; /* mulsidi_600 */
                    }
                  break;

                default:
                  break;
                }
              if (GET_MODE (x4) != E_DImode
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (x6, E_SImode))
                return -1;
              operands[0] = x6;
              if (pattern83 (x1) == 0
                  && 
#line 2243 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET))
                return 78; /* mul64 */
              operands[1] = x6;
              operands[0] = x5;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              operands[2] = x7;
              if (!extend_operand (operands[2], E_SImode))
                return -1;
              if (pnum_clobbers != NULL
                  && 
#line 2376 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
                {
                  *pnum_clobbers = 1;
                  return 83; /* mulsidi64 */
                }
              if (!
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPY && !TARGET_PLUS_MACD))
                return -1;
              return 86; /* mulsidi3_700 */

            case ZERO_EXTRACT:
              if (pattern35 (x1) != 0
                  || !
#line 2402 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
                return -1;
              return 84; /* mul64_600 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
            return -1;
          return 496; /* arc_vec_smultacc_lo_v4hi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern7 (x1, 
ZERO_EXTEND))
        {
        case 0:
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case CONST_INT:
              operands[2] = x4;
              if (!short_unsigned_const_operand (operands[2], E_HImode)
                  || pattern61 (x1) != 0
                  || !
#line 2072 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPYW))
                return -1;
              return 70; /* umulhisi3_imm */

            case ZERO_EXTEND:
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              res = recog_11 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              if (GET_MODE (x4) != E_DImode
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x3) != E_DImode)
                return -1;
              x6 = XEXP (x3, 0);
              if (!register_operand (x6, E_SImode))
                return -1;
              operands[0] = x6;
              if (pattern83 (x1) == 0
                  && 
#line 2278 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET))
                return 80; /* mulu64 */
              operands[1] = x6;
              operands[0] = x5;
              if (pnum_clobbers != NULL
                  && register_operand (operands[0], E_DImode))
                {
                  x7 = XEXP (x4, 0);
                  operands[2] = x7;
                  if (extend_operand (operands[2], E_SImode)
                      && 
#line 2589 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
                    {
                      *pnum_clobbers = 1;
                      return 90; /* umulsidi64 */
                    }
                }
              if (!dest_reg_operand (operands[0], E_DImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!extend_operand (operands[2], E_SImode)
                  || !
#line 2656 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPY && !TARGET_PLUS_MACD))
                return -1;
              return 93; /* umulsidi3_700 */

            case ZERO_EXTRACT:
              if (pattern35 (x1) != 0
                  || !
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
                return -1;
              return 91; /* umul64_600 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
            return -1;
          return 497; /* arc_vec_umultacc_lo_v4hi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern0 (x2, 
E_SImode) != 0)
            return -1;
          if (pnum_clobbers != NULL)
            {
              if (
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
                {
                  *pnum_clobbers = 1;
                  return 72; /* mulsi32x16 */
                }
              if (
#line 2189 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET))
                {
                  *pnum_clobbers = 1;
                  return 75; /* mulsi64 */
                }
            }
          if (
#line 2298 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_ARC700_MPY))
            return 81; /* mulsi3_700 */
          if (!
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULTI))
            return -1;
          return 82; /* mulsi3_v2 */

        case E_SFmode:
          if (pattern48 (x2, 
E_SFmode) != 0)
            return -1;
          if (
#line 88 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_SPFP))
            return 306; /* *mulsf3_fpx */
          if (!
#line 44 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode))))
            return -1;
          return 333; /* *mulsf3_fpu */

        case E_DFmode:
          if (pattern49 (x2) != 0
              || !
#line 308 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE))
            return -1;
          return 347; /* *muldf3_fpu */

        case E_V2SImode:
          if (pattern0 (x2, 
E_V2SImode) != 0
              || !
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_MPYW))
            return -1;
          return 516; /* mulv2si3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      switch (pattern39 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 3457 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_SWAP))
            return 124; /* rotrsi2_cnt16 */
          break;

        case 1:
          if (
#line 3743 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 146; /* *rotrdi3_cnt1 */
            }
          break;

        default:
          break;
        }
    }
  if (GET_MODE (x3) != E_SImode)
    return -1;
  if (dest_reg_operand (operands[0], E_SImode))
    {
      operands[2] = x5;
      if (nonmemory_operand (operands[2], E_SImode))
        {
          if (register_operand (operands[1], E_SImode))
            {
              if (
#line 3504 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx
   && arc_pre_reload_split ()))
                return 132; /* *rotrsi3_nobs */
              if (pnum_clobbers != NULL
                  && 
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx))
                {
                  *pnum_clobbers = 2;
                  return 137; /* rotrsi3_loop */
                }
            }
          if (arc_nonmemory_operand (operands[1], E_SImode)
              && 
#line 3625 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER))
            return 141; /* rotrsi3_insn */
        }
    }
  if (GET_CODE (x5) != CONST_INT
      || !nonmemory_operand (operands[1], E_SImode))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 1L:
      if (!dest_reg_operand (operands[0], E_SImode))
        return -1;
      return 264; /* rotrsi3_cnt1 */

    case 8L:
      if (!register_operand (operands[0], E_SImode)
          || !
#line 6178 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER && TARGET_V2))
        return -1;
      return 265; /* *rotrsi3_cnt8 */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case COMPARE:
          return recog_38 (x1, insn, pnum_clobbers);

        case REG:
        case SUBREG:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[0] = x4;
              if (!register_operand (operands[0], E_DFmode))
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != USE)
                return -1;
              operands[1] = x3;
              if (!arc_double_register_operand (operands[1], E_DFmode))
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!
#line 1377 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DPFP && TARGET_DPFP_DISABLE_LRSR))
                return -1;
              return 41; /* *movdf_insn_nolrsr */

            case MEM:
              operands[4] = x4;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != PLUS
                  || GET_MODE (x7) != E_SImode)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != SET)
                return -1;
              x8 = XEXP (x5, 1);
              if (GET_CODE (x8) != PLUS
                  || GET_MODE (x8) != E_SImode)
                return -1;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x7, 1);
              operands[2] = x10;
              if (!short_immediate_operand (operands[2], E_SImode))
                return -1;
              operands[3] = x3;
              x6 = XEXP (x5, 0);
              operands[0] = x6;
              if (!dest_reg_operand (operands[0], E_SImode))
                return -1;
              x11 = XEXP (x8, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x12 = XEXP (x8, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (GET_MODE (operands[4]))
                {
                case E_QImode:
                  if (!any_mem_operand (operands[4], E_QImode)
                      || !register_operand (operands[3], E_QImode))
                    return -1;
                  return 45; /* *storeqi_update */

                case E_HImode:
                  if (!any_mem_operand (operands[4], E_HImode)
                      || !register_operand (operands[3], E_HImode))
                    return -1;
                  return 49; /* *storehi_update */

                case E_SImode:
                  if (!any_mem_operand (operands[4], E_SImode)
                      || !register_operand (operands[3], E_SImode))
                    return -1;
                  return 51; /* *storesi_update */

                case E_SFmode:
                  if (!any_mem_operand (operands[4], E_SFmode)
                      || !register_operand (operands[3], E_SFmode))
                    return -1;
                  return 53; /* *storesf_update */

                default:
                  return -1;
                }

            case PC:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != USE)
                return -1;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != LABEL_REF)
                return -1;
              operands[0] = x3;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x13 = XEXP (x6, 0);
              operands[1] = x13;
              return 166; /* casesi_jump */

            default:
              return -1;
            }

        case MEM:
          x14 = XEXP (x3, 0);
          if (GET_MODE (x14) != E_SImode)
            return -1;
          switch (GET_CODE (x14))
            {
            case PLUS:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != SET)
                return -1;
              x8 = XEXP (x5, 1);
              if (GET_CODE (x8) != PLUS
                  || GET_MODE (x8) != E_SImode)
                return -1;
              x4 = XEXP (x2, 0);
              operands[3] = x4;
              operands[4] = x3;
              x15 = XEXP (x14, 0);
              operands[1] = x15;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x16 = XEXP (x14, 1);
              operands[2] = x16;
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              x6 = XEXP (x5, 0);
              operands[0] = x6;
              if (!dest_reg_operand (operands[0], E_SImode))
                return -1;
              x11 = XEXP (x8, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              x12 = XEXP (x8, 1);
              if (!rtx_equal_p (x12, operands[2]))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_QImode:
                  if (!dest_reg_operand (operands[3], E_QImode)
                      || !any_mem_operand (operands[4], E_QImode))
                    return -1;
                  return 42; /* *loadqi_update */

                case E_HImode:
                  if (!dest_reg_operand (operands[3], E_HImode)
                      || !any_mem_operand (operands[4], E_HImode))
                    return -1;
                  return 46; /* *loadhi_update */

                case E_SImode:
                  if (!dest_reg_operand (operands[3], E_SImode)
                      || !any_mem_operand (operands[4], E_SImode))
                    return -1;
                  return 50; /* *loadsi_update */

                case E_SFmode:
                  if (!dest_reg_operand (operands[3], E_SFmode)
                      || !any_mem_operand (operands[4], E_SFmode))
                    return -1;
                  return 52; /* *loadsf_update */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x14, 0) != 2
                  || XINT (x14, 1) != 16)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != USE)
                return -1;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != LABEL_REF)
                return -1;
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x17 = XVECEXP (x14, 0, 0);
              operands[1] = x17;
              if (!nonmemory_operand (operands[1], E_SImode))
                return -1;
              x18 = XVECEXP (x14, 0, 1);
              operands[2] = x18;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x13 = XEXP (x6, 0);
              operands[3] = x13;
              return 165; /* casesi_load */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern22 (x1))
            {
            case 0:
              return 43; /* *load_zeroextendqisi_update */

            case 1:
              return 47; /* *load_zeroextendhisi_update */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern22 (x1))
            {
            case 0:
              return 44; /* *load_signextendqisi_update */

            case 1:
              return 48; /* *load_signextendhisi_update */

            default:
              return -1;
            }

        case MULT:
          return recog_41 (x1, insn, pnum_clobbers);

        case PLUS:
          return recog_40 (x1, insn, pnum_clobbers);

        case ASHIFT:
          if (pattern24 (x1) != 0
              || !
#line 3549 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
            return -1;
          return 138; /* *ashldi3_cnt1 */

        case ASHIFTRT:
          if (pattern24 (x1) != 0
              || !
#line 3575 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
            return -1;
          return 139; /* *ashrdi3_cnt1 */

        case LSHIFTRT:
          if (pattern24 (x1) != 0
              || !
#line 3606 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
            return -1;
          return 140; /* *lshrdi3_cnt1 */

        case UNSPEC:
          return recog_39 (x1, insn, pnum_clobbers);

        case ROTATE:
          if (pattern24 (x1) != 0
              || !
#line 3710 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
            return -1;
          return 145; /* *rotldi3_cnt1 */

        case ROTATERT:
          if (pattern24 (x1) != 0
              || !
#line 3743 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
            return -1;
          return 146; /* *rotrdi3_cnt1 */

        case CALL:
          x14 = XEXP (x3, 0);
          if (GET_CODE (x14) != MEM
              || GET_MODE (x14) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern43 (x5, 
E_SImode, 
31) != 0)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!dest_reg_operand (operands[0], E_VOIDmode))
            return -1;
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          if (!call_address_operand (operands[1], E_SImode))
            return -1;
          x19 = XEXP (x3, 1);
          operands[2] = x19;
          return 168; /* *call_value_i */

        case CLRSB:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != COMPARE
              || GET_MODE (x8) != E_CC_ZNmode)
            return -1;
          x12 = XEXP (x8, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 61
              || GET_MODE (x6) != E_CC_ZNmode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!dest_reg_operand (operands[0], E_SImode))
            return -1;
          x14 = XEXP (x3, 0);
          operands[1] = x14;
          if (!general_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x8, 0);
          if (!rtx_equal_p (x11, operands[1])
              || !
#line 4558 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM))
            return -1;
          return 175; /* norm_f */

        case CLZ:
          if (GET_MODE (x3) != E_SImode
              || pattern23 (x1, 
E_SImode, 
E_CC_ZNmode) != 0
              || !
#line 4605 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM))
            return -1;
          return 178; /* *arc_clzsi2 */

        case IF_THEN_ELSE:
          x14 = XEXP (x3, 0);
          switch (GET_CODE (x14))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case LTGT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNEQ:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              operands[0] = x14;
              if (proper_comparison_operator (operands[0], E_VOIDmode))
                {
                  res = recog_36 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              switch (GET_CODE (x14))
                {
                case NE:
                case EQ:
                  operands[3] = x14;
                  if (equality_comparison_operator (operands[3], E_VOIDmode))
                    {
                      res = recog_37 (x1, insn, pnum_clobbers);
                      if (res >= 0)
                        return res;
                    }
                  if (pnum_clobbers == NULL
                      || pattern32 (x1) != 0)
                    return -1;
                  x15 = XEXP (x14, 0);
                  x20 = XEXP (x15, 0);
                  operands[0] = x20;
                  if (!nonimmediate_operand (operands[0], E_SImode))
                    return -1;
                  x19 = XEXP (x3, 1);
                  x21 = XEXP (x19, 0);
                  operands[1] = x21;
                  x5 = XVECEXP (x1, 0, 1);
                  x8 = XEXP (x5, 1);
                  x11 = XEXP (x8, 0);
                  if (!rtx_equal_p (x11, operands[0]))
                    return -1;
                  x6 = XEXP (x5, 0);
                  if (!rtx_equal_p (x6, operands[0])
                      || !
#line 5241 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DBNZ))
                    return -1;
                  *pnum_clobbers = 1;
                  return 213; /* dbnz */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != ZERO_EXTRACT
              || pattern54 (x1, 
ZERO_EXTRACT, 
E_SImode) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != ZERO_EXTRACT
              || GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x22 = XEXP (x4, 1);
          operands[1] = x22;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x23 = XEXP (x4, 2);
          operands[2] = x23;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x24 = XEXP (x3, 2);
          operands[3] = x24;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x25 = XEXP (x6, 1);
          operands[4] = x25;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          x26 = XEXP (x6, 2);
          operands[5] = x26;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x8 = XEXP (x5, 1);
          x11 = XEXP (x8, 0);
          operands[6] = x11;
          if (!register_operand (operands[6], E_SImode))
            return -1;
          x27 = XEXP (x8, 2);
          operands[7] = x27;
          if (!const_int_operand (operands[7], E_SImode))
            return -1;
          x14 = XEXP (x3, 0);
          if (!rtx_equal_p (x14, operands[0]))
            return -1;
          x19 = XEXP (x3, 1);
          if (!rtx_equal_p (x19, operands[1]))
            return -1;
          x12 = XEXP (x8, 1);
          if (!rtx_equal_p (x12, operands[4]))
            return -1;
          x13 = XEXP (x6, 0);
          if (!rtx_equal_p (x13, operands[0])
              || !
#line 6048 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS))
            return -1;
          return 260; /* *mrgb */

        case TRUNCATE:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x14 = XEXP (x3, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != MULT
              || GET_MODE (x15) != E_DImode)
            return -1;
          x16 = XEXP (x14, 1);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 58
              || GET_MODE (x16) != E_DImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 58
              || GET_MODE (x6) != E_DImode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x20 = XEXP (x15, 0);
          if (GET_MODE (x20) != E_DImode)
            return -1;
          x28 = XEXP (x15, 1);
          if (GET_MODE (x28) != E_DImode)
            return -1;
          switch (GET_CODE (x20))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x28) != SIGN_EXTEND)
                return -1;
              x29 = XEXP (x20, 0);
              operands[1] = x29;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x30 = XEXP (x28, 0);
              operands[2] = x30;
              if (!extend_operand (operands[2], E_SImode)
                  || !
#line 6437 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
                return -1;
              return 279; /* mac_r */

            case ZERO_EXTEND:
              if (GET_CODE (x28) != ZERO_EXTEND)
                return -1;
              x29 = XEXP (x20, 0);
              operands[1] = x29;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x30 = XEXP (x28, 0);
              operands[2] = x30;
              if (!extend_operand (operands[2], E_SImode)
                  || !
#line 6539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
                return -1;
              return 283; /* macu_r */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (GET_MODE (x3) != E_SImode)
            return -1;
          switch (XVECLEN (x3, 0))
            {
            case 2:
              if (XINT (x3, 1) != 51)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER
                  || !dest_reg_operand (operands[0], E_SImode))
                return -1;
              x31 = XVECEXP (x3, 0, 0);
              operands[1] = x31;
              if (!shouldbe_register_operand (operands[1], E_SImode))
                return -1;
              x32 = XVECEXP (x3, 0, 1);
              operands[2] = x32;
              if (!shouldbe_register_operand (operands[2], E_SImode))
                return -1;
              x6 = XEXP (x5, 0);
              operands[3] = x6;
              if (!arc_double_register_operand (operands[3], E_DFmode)
                  || !
#line 178 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP))
                return -1;
              return 313; /* *dexcl_3op_peep2_insn */

            case 1:
              x31 = XVECEXP (x3, 0, 0);
              operands[1] = x31;
              switch (XINT (x3, 1))
                {
                case 42:
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != SET
                      || !register_operand (operands[0], E_SImode)
                      || !arc_double_register_operand (operands[1], E_DFmode))
                    return -1;
                  x8 = XEXP (x5, 1);
                  operands[2] = x8;
                  if (!register_operand (operands[2], E_DFmode))
                    return -1;
                  x6 = XEXP (x5, 0);
                  if (!rtx_equal_p (x6, operands[1])
                      || !
#line 205 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP && !TARGET_DPFP_DISABLE_LRSR))
                    return -1;
                  return 315; /* *dexcl_3op_peep2_insn_lr */

                case 56:
                  x5 = XVECEXP (x1, 0, 1);
                  if (pattern78 (x5, 
E_CC_Zmode, 
61) != 0
                      || !mem_noofs_operand (operands[0], E_SImode)
                      || !register_operand (operands[1], E_SImode)
                      || !
#line 111 "../../gcc-15.0.1-20250313/gcc/config/arc/atomic.md"
(TARGET_ATOMIC))
                    return -1;
                  return 530; /* arc_store_exclusivesi */

                case 54:
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != SET
                      || !register_operand (operands[0], E_SImode)
                      || !mem_noofs_operand (operands[1], E_SImode))
                    return -1;
                  x8 = XEXP (x5, 1);
                  operands[2] = x8;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x6 = XEXP (x5, 0);
                  if (!rtx_equal_p (x6, operands[1]))
                    return -1;
                  return 531; /* exchangesi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case FMA:
          switch (pattern25 (x1))
            {
            case 0:
              if (!
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_FUSED))
                return -1;
              return 336; /* fmadf4_split */

            case 1:
              if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_FUSED))
                return -1;
              return 337; /* fnmadf4_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern43 (x5, 
E_SImode, 
31) != 0)
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      if (!call_address_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      return 167; /* *call_i */

    case RETURN:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || XVECLEN (x5, 0) != 1)
        return -1;
      switch (XINT (x5, 1))
        {
        case 34:
          x33 = XVECEXP (x5, 0, 0);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 4713 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_ARC600_FAMILY))
            return -1;
          return 183; /* rtie */

        case 60:
          x33 = XVECEXP (x5, 0, 0);
          operands[0] = x33;
          if (!pmode_register_operand (operands[0], E_VOIDmode)
              || !
#line 5007 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_ARC600_FAMILY))
            return -1;
          return 206; /* arc600_rtie */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
