/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!dest_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!even_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!even_register_operand (operands[1], E_V4HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!even_register_operand (operands[2], E_V4HImode))
    return -1;
  return 0;
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 58
      || GET_MODE (x5) != E_DFmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!even_register_operand (operands[0], E_DFmode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!even_register_operand (operands[2], E_DFmode))
    return -1;
  x8 = XEXP (x3, 2);
  operands[3] = x8;
  if (!even_register_operand (operands[3], E_DFmode))
    return -1;
  x9 = XEXP (x3, 0);
  switch (GET_CODE (x9))
    {
    case REG:
      operands[1] = x9;
      if (!even_register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case NEG:
      if (GET_MODE (x9) != E_DFmode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!even_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 56
      || GET_MODE (x6) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  operands[1] = x9;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (XWINT (x4, 0) != 0L)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!cc_set_register (operands[2], E_VOIDmode))
    return -1;
  operands[3] = x3;
  if (!zn_compare_operator (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern58 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 58
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !nonmemory_operand (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!_1_2_3_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!even_register_operand (operands[0], E_DFmode))
        return -1;
      return pattern70 (x5, 
E_DFmode); /* [-1, 1] */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      res = pattern70 (x5, 
E_SFmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern93 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern96 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  return 0;
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2SImode
      || !even_register_operand (operands[0], E_V2SImode)
      || !register_operand (operands[1], E_V2HImode)
      || !register_operand (operands[2], E_V2HImode))
    return -1;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonmemory_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 58)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MULT)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x6, 1);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 58)
    return -1;
  x11 = XEXP (x5, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 58)
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  x13 = XEXP (x3, 0);
  x14 = XEXP (x13, 1);
  x15 = XEXP (x14, 0);
  operands[2] = x15;
  x16 = XEXP (x8, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x9, 0);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!even_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x13) != E_DImode)
        return -1;
      x18 = XEXP (x13, 0);
      if (GET_MODE (x18) != E_DImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x14) != E_DImode
          || !extend_operand (operands[2], E_SImode)
          || pattern118 (x1, 
E_DImode) != 0)
        return -1;
      return 0;

    case E_V2SImode:
      if (!even_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || GET_MODE (x13) != E_V2SImode)
        return -1;
      x18 = XEXP (x13, 0);
      if (GET_MODE (x18) != E_V2SImode
          || !register_operand (operands[1], E_V2HImode)
          || GET_MODE (x14) != E_V2SImode
          || !register_operand (operands[2], E_V2HImode)
          || pattern118 (x1, 
E_V2SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 61)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  switch (GET_MODE (x2))
    {
    case E_CCmode:
      if (GET_MODE (x3) != E_CCmode
          || !register_operand (operands[0], E_SImode)
          || !nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 147; /* cmpsi_cc_insn_mixed */

    case E_CC_Zmode:
      if (GET_MODE (x3) != E_CC_Zmode
          || !register_operand (operands[0], E_SImode)
          || !p2_immediate_operand (operands[1], E_SImode))
        return -1;
      return 150; /* *cmpsi_cc_z_insn */

    case E_CC_Cmode:
      if (GET_MODE (x3) != E_CC_Cmode
          || !register_operand (operands[0], E_SImode)
          || !nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 151; /* *cmpsi_cc_c_insn */

    case E_CC_FPXmode:
      if (GET_MODE (x3) != E_CC_FPXmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !register_operand (operands[1], E_SFmode)
              || !
#line 109 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_ARGONAUT_SET && TARGET_SPFP))
            return -1;
          return 307; /* cmpsfpx_raw */

        case E_DFmode:
          if (pnum_clobbers == NULL
              || !nonmemory_operand (operands[0], E_DFmode)
              || !nonmemory_operand (operands[1], E_DFmode)
              || !
#line 124 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_ARGONAUT_SET && TARGET_DPFP))
            return -1;
          *pnum_clobbers = 1;
          return 308; /* cmpdfpx_raw */

        default:
          return -1;
        }

    case E_CC_FPUmode:
      switch (pattern75 (x3, 
E_CC_FPUmode))
        {
        case 0:
          if (!
#line 237 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE))
            return -1;
          return 342; /* *cmpsf_fpu */

        case 1:
          if (!
#line 345 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE))
            return -1;
          return 350; /* *cmpdf_fpu */

        default:
          return -1;
        }

    case E_CC_FPUEmode:
      switch (pattern75 (x3, 
E_CC_FPUEmode))
        {
        case 0:
          if (!
#line 249 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE))
            return -1;
          return 343; /* *cmpsf_fpu_trap */

        case 1:
          if (!
#line 357 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE))
            return -1;
          return 351; /* *cmpdf_fpu_trap */

        default:
          return -1;
        }

    case E_CC_FPU_UNEQmode:
      switch (pattern75 (x3, 
E_CC_FPU_UNEQmode))
        {
        case 0:
          if (!
#line 262 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE))
            return -1;
          return 344; /* *cmpsf_fpu_uneq */

        case 1:
          if (!
#line 370 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE))
            return -1;
          return 352; /* *cmpdf_fpu_uneq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 40:
          if (GET_MODE (x3) != E_SImode
              || !dest_reg_operand (operands[0], E_SImode)
              || !general_operand (operands[1], E_SImode))
            return -1;
          return 187; /* core_read */

        case 42:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (dest_reg_operand (operands[0], E_SImode)
              && general_operand (operands[1], E_SImode))
            return 189; /* lr */
          if (!register_operand (operands[0], E_SImode)
              || !arc_double_register_operand (operands[1], E_DFmode)
              || !
#line 155 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP && !TARGET_DPFP_DISABLE_LRSR))
            return -1;
          return 311; /* *lr_double_lower */

        case 62:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !memory_operand (operands[1], E_QImode))
                return -1;
              return 191; /* lddiqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !memory_operand (operands[1], E_HImode))
                return -1;
              return 192; /* lddihi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !memory_operand (operands[1], E_SImode))
                return -1;
              return 193; /* lddisi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !memory_operand (operands[1], E_DImode))
                return -1;
              if (
#line 4794 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_LL64))
                return 194; /* lddidi */
              if (!
#line 4837 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_LL64))
                return -1;
              return 200; /* *lddidi_split */

            default:
              return -1;
            }

        case 47:
          if (GET_MODE (x3) != E_SImode
              || !dest_reg_operand (operands[0], E_SImode)
              || !immediate_operand (operands[1], E_SImode)
              || !
#line 5678 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2))
            return -1;
          return 249; /* clri */

        case 53:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || !arc_double_register_operand (operands[1], E_DFmode)
              || !
#line 165 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP && !TARGET_DPFP_DISABLE_LRSR))
            return -1;
          return 312; /* *lr_double_higher */

        case 150:
          if (GET_MODE (x3) != E_SImode
              || !arc_simd_dma_register_operand (operands[0], E_SImode)
              || !nonmemory_operand (operands[1], E_SImode)
              || !
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 462; /* vdiwr_insn */

        case 151:
          if (GET_MODE (x3) != E_SImode
              || !arc_simd_dma_register_operand (operands[0], E_SImode)
              || !nonmemory_operand (operands[1], E_SImode)
              || !
#line 1202 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 463; /* vdowr_insn */

        case 57:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || !mem_noofs_operand (operands[1], E_SImode)
              || !
#line 99 "../../gcc-15.0.1-20250313/gcc/config/arc/atomic.md"
(TARGET_ATOMIC))
            return -1;
          return 529; /* arc_load_exclusivesi */

        case 56:
          if (pnum_clobbers == NULL
              || GET_MODE (x3) != E_SImode
              || !mem_noofs_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode)
              || !
#line 111 "../../gcc-15.0.1-20250313/gcc/config/arc/atomic.md"
(TARGET_ATOMIC))
            return -1;
          *pnum_clobbers = 1;
          return 530; /* arc_store_exclusivesi */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 52:
          if (GET_MODE (x3) != E_DFmode
              || !arc_double_register_operand (operands[0], E_DFmode)
              || !shouldbe_register_operand (operands[1], E_SImode)
              || !shouldbe_register_operand (operands[2], E_SImode)
              || !
#line 192 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP))
            return -1;
          return 314; /* dexcl_2op */

        case 148:
          if (pattern63 (x3) != 0
              || !
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 460; /* vdirun_insn */

        case 149:
          if (pattern63 (x3) != 0
              || !
#line 1182 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 461; /* vdorun_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == REG
      && REGNO (x3) == 61)
    {
      x4 = XEXP (x2, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (dest_reg_operand (operands[0], E_SImode))
            {
              if (GET_CODE (x2) == LTU
                  && GET_MODE (x2) == E_SImode)
                {
                  switch (GET_MODE (x3))
                    {
                    case E_CC_Cmode:
                      return 152; /* scc_ltu_cc_c */

                    case E_CCmode:
                      return 153; /* scc_ltu_cc */

                    default:
                      break;
                    }
                }
              operands[1] = x2;
              if (proper_comparison_operator (operands[1], E_SImode))
                return 154; /* *scc_insn */
            }
        }
    }
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (x2))
    {
    case EQ:
      if (!
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY))
        return -1;
      return 237; /* arcseteq */

    case NE:
      if (!
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY))
        return -1;
      return 238; /* arcsetne */

    case GT:
      if (!
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY))
        return -1;
      return 239; /* arcsetgt */

    case LT:
      if (!
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY))
        return -1;
      return 240; /* arcsetlt */

    case GE:
      if (!
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY))
        return -1;
      return 241; /* arcsetge */

    case LE:
      if (!
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY))
        return -1;
      return 242; /* arcsetle */

    case LTU:
      if (!
#line 5552 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY))
        return -1;
      return 243; /* arcsetltu */

    case GEU:
      if (!
#line 5565 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY))
        return -1;
      return 244; /* arcsetgeu */

    case GTU:
      if (!
#line 5579 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY))
        return -1;
      return 245; /* arcsethi */

    case LEU:
      if (!
#line 5602 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY))
        return -1;
      return 246; /* arcsetls */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!cc_set_register (operands[0], E_VOIDmode)
          || GET_MODE (x3) != E_CC_ZNmode)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      switch (pattern112 (x6))
        {
        case 0:
          return 10; /* *sexxtb_cmp0 */

        case 1:
          return 12; /* *sexxt%__cmp0 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x9 = XEXP (x4, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[1] = x9;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!cc_set_register (operands[0], E_VOIDmode)
              || GET_MODE (x3) != E_CC_ZNmode
              || GET_MODE (x4) != E_SImode)
            return -1;
          switch (pattern112 (x6))
            {
            case 0:
              return 11; /* *extxtb_cmp0 */

            case 1:
              return 13; /* *extxt%__cmp0 */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != PLUS
              || GET_MODE (x10) != E_SImode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != LTU
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 61
              || GET_MODE (x12) != E_CC_Cmode)
            return -1;
          x13 = XEXP (x11, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != PLUS
              || GET_MODE (x5) != E_DImode)
            return -1;
          x14 = XEXP (x5, 0);
          if (GET_CODE (x14) != LTU
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != REG
              || REGNO (x15) != 61
              || GET_MODE (x15) != E_CC_Cmode)
            return -1;
          x16 = XEXP (x14, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x17 = XEXP (x5, 1);
          if (GET_CODE (x17) != ZERO_EXTEND
              || GET_MODE (x17) != E_DImode)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 61
              || GET_MODE (x8) != E_CC_Cmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PLUS)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS
              || GET_MODE (x18) != E_SImode)
            return -1;
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != LTU
              || GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XEXP (x19, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 61
              || GET_MODE (x20) != E_CC_Cmode)
            return -1;
          x21 = XEXP (x19, 1);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CC_Cmode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x22 = XEXP (x10, 1);
          operands[1] = x22;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x23 = XEXP (x9, 1);
          operands[2] = x23;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x24 = XEXP (x6, 0);
          operands[0] = x24;
          x25 = XEXP (x17, 0);
          if (!rtx_equal_p (x25, operands[1]))
            return -1;
          x26 = XEXP (x18, 1);
          if (!rtx_equal_p (x26, operands[1]))
            return -1;
          x27 = XEXP (x7, 1);
          if (!rtx_equal_p (x27, operands[2]))
            return -1;
          return 98; /* adc_f */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x1, 0);
  if (!proper_comparison_operator (x3, E_VOIDmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!dest_reg_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      operands[3] = x3;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      return 156; /* *movsi_cond_exec */

    case PLUS:
    case MULT:
    case AND:
    case IOR:
    case XOR:
    case SS_PLUS:
      operands[3] = x5;
      if (!commutative_operator (operands[3], E_SImode))
        return -1;
      operands[5] = x3;
      x6 = XEXP (x3, 0);
      operands[4] = x6;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 157; /* *commutative_cond_exec */

    case MINUS:
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
    case SS_MINUS:
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (nonmemory_operand (operands[1], E_SImode)
          && GET_CODE (x5) == MINUS
          && GET_MODE (x5) == E_SImode)
        {
          operands[4] = x3;
          x6 = XEXP (x3, 0);
          operands[3] = x6;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          if (nonmemory_operand (operands[2], E_SImode))
            return 158; /* *sub_cond_exec */
        }
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[5] = x3;
      x6 = XEXP (x3, 0);
      operands[4] = x6;
      operands[3] = x5;
      if (!noncommutative_operator (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 159; /* *noncommutative_cond_exec */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x6;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!dest_reg_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !nonmemory_operand (operands[1], E_SImode)
              || !nonmemory_operand (operands[2], E_SImode)
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2892 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[1], SImode)
   || register_operand (operands[2], SImode))))
            return -1;
          return 694; /* *p subsi3_insn */

        case E_SFmode:
          if (pattern104 (x4, 
E_SFmode) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 28 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)))))
            return -1;
          return 764; /* *p *subsf3_fpu */

        case E_DFmode:
          if (pattern105 (x4) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 294 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE)))
            return -1;
          return 774; /* *p *subdf3_fpu */

        case E_V2HImode:
          if (pattern109 (x4, 
E_V2HImode) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY)))
            return -1;
          return 801; /* *p subv2hi3 */

        case E_V4HImode:
          if (pattern109 (x4, 
E_V4HImode) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && (
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY) && 
#line 1399 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))))
            return -1;
          return 802; /* *p subv4hi3 */

        case E_V2SImode:
          if (pattern109 (x4, 
E_V2SImode) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && (
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY) && 
#line 1400 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))))
            return -1;
          return 803; /* *p subv2si3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[4] = x7;
      if (pattern103 (x4) != 0)
        return -1;
      if (dest_reg_operand (operands[0], E_SImode))
        return 696; /* *p *sub_n */
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 762; /* *p *sub_shift */

    case MULT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[4] = x7;
      if (!dest_reg_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode
          || !nonmemory_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[3] = x9;
      if (!_2_4_8_operand (operands[3], E_SImode))
        return -1;
      return 697; /* *p *sub_n */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!move_dest_operand (operands[0], E_SImode)
              || !move_src_operand (operands[1], E_SImode)
              || !
#line 794 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   && GET_CODE (PATTERN (insn)) != COND_EXEC
   && register_operand (operands[0], SImode)
   && IN_RANGE (REGNO (operands[0]) ^ 4, 4, 11)
   && satisfies_constraint_Cax (operands[1])))
            return NULL;
          return gen_split_1 (insn, operands);

        case E_DImode:
          if (!move_dest_operand (operands[0], E_DImode)
              || !move_double_src_operand (operands[1], E_DImode)
              || !(
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[0], DImode)
   || register_operand (operands[1], DImode)
   || (satisfies_constraint_Cm3 (operands[1])
       && memory_operand (operands[0], DImode))) && 
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( reload_completed && arc_split_move_p (operands))))
            return NULL;
          return gen_split_4 (insn, operands);

        case E_DFmode:
          if (!move_dest_operand (operands[0], E_DFmode)
              || !move_double_src_operand (operands[1], E_DFmode)
              || !(
#line 1354 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
((register_operand (operands[0], DFmode)
    || register_operand (operands[1], DFmode))) && 
#line 1363 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( reload_completed && arc_split_move_p (operands))))
            return NULL;
          return gen_split_5 (insn, operands);

        case E_V2HImode:
          if (!move_dest_operand (operands[0], E_V2HImode)
              || !general_operand (operands[1], E_V2HImode)
              || !
#line 1438 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(reload_completed && GET_CODE (operands[1]) == CONST_VECTOR))
            return NULL;
          return gen_split_52 (insn, operands);

        case E_V4HImode:
          if (!move_dest_operand (operands[0], E_V4HImode)
              || !general_operand (operands[1], E_V4HImode)
              || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
((register_operand (operands[0], V4HImode)
       || register_operand (operands[1], V4HImode))) && 
#line 1480 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
( reload_completed && arc_split_move_p (operands))))
            return NULL;
          return gen_split_53 (insn, operands);

        case E_V2SImode:
          if (!move_dest_operand (operands[0], E_V2SImode)
              || !general_operand (operands[1], E_V2SImode)
              || !(
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
((register_operand (operands[0], V2SImode)
       || register_operand (operands[1], V2SImode))) && 
#line 1480 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
( reload_completed && arc_split_move_p (operands))))
            return NULL;
          return gen_split_54 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != SIGN_EXTEND
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return NULL;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!extend_operand (operands[2], E_SImode)
              || !(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPY && !TARGET_PLUS_MACD) && 
#line 2445 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( reload_completed)))
            return NULL;
          return gen_split_12 (insn, operands);

        case ZERO_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return NULL;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND
              || GET_MODE (x5) != E_DImode
              || !dest_reg_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return NULL;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!extend_operand (operands[2], E_SImode)
              || !
#line 2658 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPY && !TARGET_PLUS_MACD && reload_completed))
            return NULL;
          return gen_split_14 (insn, operands);

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode)
            return NULL;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_V2SImode)
              || !(
#line 2011 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(reload_completed) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_MPYW)))
            return NULL;
          return gen_split_55 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      if (GET_MODE (x3) != E_SImode
          || !dest_reg_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!nonmemory_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed && get_attr_length (insn) == 8
   && satisfies_constraint_I (operands[1])
   && GET_CODE (PATTERN (insn)) != COND_EXEC))
        return NULL;
      return gen_split_17 (insn, operands);

    case IOR:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !dest_reg_operand (operands[0], E_SImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SImode)
              || !
#line 3312 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   && GET_CODE (PATTERN (insn)) != COND_EXEC
   && register_operand (operands[0], SImode)
   && IN_RANGE (REGNO (operands[0]) ^ 4, 4, 11)
   && satisfies_constraint_C0x (operands[2])))
            return NULL;
          return gen_split_19 (insn, operands);

        case ASHIFT:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x7 = XEXP (x5, 0);
          operands[3] = x7;
          if (!
#line 6028 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS
   && GET_MODE_BITSIZE (GET_MODE (operands[3])) <= INTVAL (operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
            return NULL;
          return gen_split_43 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      if (GET_MODE (x3) != E_DImode
          || !dest_reg_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 3373 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( reload_completed))
        return NULL;
      return gen_split_20 (insn, operands);

    case ASHIFT:
      if (GET_MODE (x3) != E_SImode
          || !dest_reg_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x3, 1);
      if (!nonmemory_operand (x5, E_SImode))
        return NULL;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
          if (XWINT (x4, 0) != 1L)
            return NULL;
          operands[1] = x5;
          if (!(
#line 3489 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && arc_pre_reload_split ()) && 
#line 3492 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
            return NULL;
          return gen_split_21 (insn, operands);

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          operands[2] = x5;
          if (!(
#line 3504 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx
   && arc_pre_reload_split ()) && 
#line 3508 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
            return NULL;
          return gen_split_22 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      if (pattern9 (x3) != 0
          || !(
#line 3504 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx
   && arc_pre_reload_split ()) && 
#line 3508 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
        return NULL;
      return gen_split_23 (insn, operands);

    case LSHIFTRT:
      if (pattern9 (x3) != 0
          || !(
#line 3504 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx
   && arc_pre_reload_split ()) && 
#line 3508 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
        return NULL;
      return gen_split_24 (insn, operands);

    case ROTATE:
      if (GET_MODE (x3) != E_SImode
          || !dest_reg_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_operand (operands[2], E_SImode))
        {
          if ((
#line 3504 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx
   && arc_pre_reload_split ()) && 
#line 3508 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
            return gen_split_25 (insn, operands);
          if ((
#line 3635 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER
   && arc_pre_reload_split ()) && 
#line 3638 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
            return gen_split_30 (insn, operands);
        }
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !(
#line 6154 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER) && 
#line 6156 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
        return NULL;
      return gen_split_46 (insn, operands);

    case ROTATERT:
      if (pattern9 (x3) != 0
          || !(
#line 3504 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx
   && arc_pre_reload_split ()) && 
#line 3508 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
        return NULL;
      return gen_split_26 (insn, operands);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      if (proper_comparison_operator (operands[1], E_SImode))
        {
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 61)
            {
              x5 = XEXP (x3, 1);
              if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  && dest_reg_operand (operands[0], E_SImode)
                  && 
#line 3909 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   && GET_CODE (operands[1]) != LTU))
                return gen_split_33 (insn, operands);
            }
        }
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!nonmemory_operand (operands[2], E_SImode))
        return NULL;
      switch (GET_CODE (x3))
        {
        case GTU:
          if (!
#line 5581 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   && CONST_INT_P (operands[2])
   && satisfies_constraint_C62 (operands[2])))
            return NULL;
          return gen_split_41 (insn, operands);

        case LEU:
          if (!
#line 5604 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   && CONST_INT_P (operands[2])
   && satisfies_constraint_C62 (operands[2])))
            return NULL;
          return gen_split_42 (insn, operands);

        default:
          return NULL;
        }

    case CLRSB:
      if (GET_MODE (x3) != E_HImode
          || !dest_reg_operand (operands[0], E_HImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!general_operand (operands[1], E_HImode)
          || !
#line 4568 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed))
        return NULL;
      return gen_split_34 (insn, operands);

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 62
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x9 = XVECEXP (x3, 0, 0);
      operands[1] = x9;
      if (!memory_operand (operands[1], E_DImode)
          || !(
#line 4837 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_LL64) && 
#line 4839 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( reload_completed)))
        return NULL;
      return gen_split_38 (insn, operands);

    case SIGN_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return NULL;
      x10 = XEXP (x3, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      if (XWINT (x5, 0) == 1L
          && (
#line 6122 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER) && 
#line 6124 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
        return gen_split_44 (insn, operands);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_QImode)
          || !(
#line 6135 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && IN_RANGE (INTVAL (operands[2]), 2,
		(optimize_insn_for_size_p () ? 28 : 30))) && 
#line 6139 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
        return NULL;
      return gen_split_45 (insn, operands);

    case DIV:
      if (pattern10 (x3) != 0
          || !(
#line 2011 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(reload_completed) && 
#line 1404 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_DIVREM)))
        return NULL;
      return gen_split_56 (insn, operands);

    case SMAX:
      if (pattern10 (x3) != 0
          || !
#line 2011 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(reload_completed))
        return NULL;
      return gen_split_57 (insn, operands);

    case SMIN:
      if (pattern10 (x3) != 0
          || !
#line 2011 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(reload_completed))
        return NULL;
      return gen_split_58 (insn, operands);

    case VEC_DUPLICATE:
      switch (pattern8 (x3))
        {
        case 0:
          if (!
#line 2067 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(reload_completed))
            return NULL;
          return gen_split_59 (insn, operands);

        case 1:
          if (!
#line 2085 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(reload_completed))
            return NULL;
          return gen_split_60 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
