/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!dest_reg_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case ASHIFT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !nonmemory_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[2] = x9;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          return 1;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x7;
          if (!nonmemory_operand (operands[2], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x7 = XEXP (x4, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern31 (x1) != 0)
    return -1;
  return 0;
}

int
pattern38 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XWINT (x2, 0))
    {
    case 16L:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case 1L:
      if (pattern37 (x1, pnum_clobbers) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x7) != E_SImode
          || !register_operand (operands[2], E_HImode)
          || !accl_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_DImode
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x7) != E_DImode
          || !extend_operand (operands[2], E_SImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!even_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern80 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  switch (REGNO (x9))
    {
    case 58:
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case 56:
      if (!extend_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern97 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 58)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MULT)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x6, 1);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 58)
    return -1;
  x11 = XEXP (x5, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 58)
    return -1;
  x12 = XEXP (x8, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x9, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!even_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x14 = XEXP (x3, 0);
      if (GET_MODE (x14) != E_DImode)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_MODE (x15) != E_DImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      x16 = XEXP (x14, 1);
      if (GET_MODE (x16) != E_DImode
          || !extend_operand (operands[2], E_SImode)
          || pattern96 (x1, 
E_DImode) != 0)
        return -1;
      return 0;

    case E_V2SImode:
      if (!even_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode)
        return -1;
      x14 = XEXP (x3, 0);
      if (GET_MODE (x14) != E_V2SImode)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_MODE (x15) != E_V2SImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      x16 = XEXP (x14, 1);
      if (GET_MODE (x16) != E_V2SImode
          || !register_operand (operands[2], E_V2HImode)
          || pattern96 (x1, 
E_V2SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x7, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (move_dest_operand (operands[0], E_QImode)
          && move_src_operand (operands[1], E_QImode)
          && 
#line 664 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[0], QImode)
   || register_operand (operands[1], QImode)
   || (CONSTANT_P (operands[1])
       && (!satisfies_constraint_I (operands[1]) || !optimize_size)
       && satisfies_constraint_Usc (operands[0]))
   || (satisfies_constraint_Cm3 (operands[1])
       && memory_operand (operands[0], QImode))))
        return 1; /* *movqi_insn */
      break;

    case E_HImode:
      if (move_dest_operand (operands[0], E_HImode)
          && move_src_operand (operands[1], E_HImode)
          && 
#line 706 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[0], HImode)
   || register_operand (operands[1], HImode)
   || (CONSTANT_P (operands[1])
       /* Don't use a LIMM that we could load with a single insn - we loose
	  delay-slot filling opportunities.  */
       && !satisfies_constraint_I (operands[1])
       && satisfies_constraint_Usc (operands[0]))
   || (satisfies_constraint_Cm3 (operands[1])
       && memory_operand (operands[0], HImode))))
        return 2; /* *movhi_insn */
      break;

    case E_SImode:
      if (move_dest_operand (operands[0], E_SImode)
          && move_src_operand (operands[1], E_SImode)
          && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[0], SImode)
   || register_operand (operands[1], SImode)
   || (CONSTANT_P (operands[1])
       && (!satisfies_constraint_I (operands[1]) || !optimize_size)
       && satisfies_constraint_Usc (operands[0]))
   || (satisfies_constraint_Cm3 (operands[1])
      && memory_operand (operands[0], SImode))))
        return 3; /* *movsi_insn */
      break;

    case E_DImode:
      if (move_dest_operand (operands[0], E_DImode)
          && move_double_src_operand (operands[1], E_DImode)
          && 
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[0], DImode)
   || register_operand (operands[1], DImode)
   || (satisfies_constraint_Cm3 (operands[1])
       && memory_operand (operands[0], DImode))))
        return 38; /* *movdi_insn */
      break;

    case E_SFmode:
      if (move_dest_operand (operands[0], E_SFmode)
          && move_src_operand (operands[1], E_SFmode)
          && 
#line 1325 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[0], SFmode)
   || register_operand (operands[1], SFmode)
   || (CONSTANT_P (operands[1])
       && (!satisfies_constraint_I (operands[1]) || !optimize_size)
       && satisfies_constraint_Usc (operands[0]))))
        return 39; /* *movsf_insn */
      break;

    case E_DFmode:
      if (move_dest_operand (operands[0], E_DFmode)
          && move_double_src_operand (operands[1], E_DFmode)
          && 
#line 1354 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
((register_operand (operands[0], DFmode)
    || register_operand (operands[1], DFmode))))
        return 40; /* *movdf_insn */
      break;

    case E_TImode:
      if (vector_register_or_memory_operand (operands[0], E_TImode)
          && vector_register_or_memory_operand (operands[1], E_TImode))
        return 375; /* movti_insn */
      break;

    case E_V2HImode:
      if (move_dest_operand (operands[0], E_V2HImode)
          && general_operand (operands[1], E_V2HImode)
          && 
#line 1431 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
((register_operand (operands[0], V2HImode)
    || register_operand (operands[1], V2HImode))))
        return 476; /* *movv2hi_insn */
      break;

    case E_V4HImode:
      if (move_dest_operand (operands[0], E_V4HImode)
          && general_operand (operands[1], E_V4HImode)
          && 
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
((register_operand (operands[0], V4HImode)
       || register_operand (operands[1], V4HImode))))
        return 477; /* *movv4hi_insn */
      break;

    case E_V2SImode:
      if (move_dest_operand (operands[0], E_V2SImode)
          && general_operand (operands[1], E_V2SImode)
          && 
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
((register_operand (operands[0], V2SImode)
       || register_operand (operands[1], V2SImode))))
        return 478; /* *movv2si_insn */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_V8HImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (pattern55 (x5) != 0)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!vector_register_operand (operands[0], E_V8HImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XVECEXP (x8, 0, 0);
  operands[1] = x9;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x4, 1);
  operands[2] = x10;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  operands[3] = x3;
  if (!vector_register_operand (operands[3], E_V8HImode)
      || !
#line 188 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
    return -1;
  return 372; /* vst128_insn */
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!dest_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !nonmemory_operand (operands[1], E_SImode)
                  || !nonmemory_operand (operands[2], E_SImode)
                  || !
#line 2892 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[1], SImode)
   || register_operand (operands[2], SImode)))
                return -1;
              return 99; /* subsi3_insn */

            case E_SFmode:
              if (pattern48 (x3, 
E_SFmode) != 0)
                return -1;
              if (
#line 73 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_SPFP))
                return 305; /* *subsf3_fpx */
              if (!
#line 28 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode))))
                return -1;
              return 332; /* *subsf3_fpu */

            case E_DFmode:
              if (pattern49 (x3) != 0
                  || !
#line 294 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE))
                return -1;
              return 346; /* *subdf3_fpu */

            case E_V2HImode:
              if (pattern65 (x3, 
E_V2HImode) != 0
                  || !
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
                return -1;
              return 483; /* subv2hi3 */

            case E_V4HImode:
              if (pattern65 (x3, 
E_V4HImode) != 0
                  || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY) && 
#line 1399 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                return -1;
              return 484; /* subv4hi3 */

            case E_V2SImode:
              if (pattern65 (x3, 
E_V2SImode) != 0
                  || !(
#line 1522 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY) && 
#line 1400 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                return -1;
              return 485; /* subv2si3 */

            default:
              return -1;
            }

        case LTU:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !dest_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!cc_use_register (operands[2], E_CC_Cmode))
            return -1;
          return 100; /* *sbc_0 */

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode
              || pattern62 (x3) != 0)
            return -1;
          if (dest_reg_operand (operands[0], E_SImode))
            return 104; /* *sub_n */
          if (!register_operand (operands[0], E_SImode))
            return -1;
          return 294; /* *sub_shift */

        case MULT:
          if (GET_MODE (x5) != E_SImode
              || !dest_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonmemory_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x5, 1);
          operands[3] = x6;
          if (!_2_4_8_operand (operands[3], E_SImode))
            return -1;
          return 105; /* *sub_n */

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (pattern36 (x8, 
E_CC_Cmode, 
61, 
LTU) != 0)
        return -1;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !dest_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !
#line 2969 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[1], SImode)
   || register_operand (operands[2], SImode)))
        return -1;
      return 101; /* sbc */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == E_SImode)
    {
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[0] = x3;
          if (dest_reg_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (nonmemory_operand (operands[1], E_SImode))
                {
                  x5 = XEXP (x2, 1);
                  operands[2] = x5;
                  if (nonmemory_operand (operands[2], E_SImode)
                      && 
#line 3439 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER
   && (register_operand (operands[1], SImode)
       || register_operand (operands[2], SImode))))
                    return 122; /* *lshrsi3_insn */
                }
            }
          break;

        case ZERO_EXTRACT:
          if (pattern19 (x1) == 0
              && 
#line 6002 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS
   && INTVAL (operands[4]) + INTVAL (operands[1]) <= 32))
            return 258; /* *movb_high */
          break;

        default:
          break;
        }
    }
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) == CONST_INT)
    {
      switch (pattern38 (x2, pnum_clobbers))
        {
        case 0:
          if (
#line 3477 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_SWAP && TARGET_V2))
            return 126; /* lshrsi2_cnt16 */
          break;

        case 1:
          if (
#line 3606 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
            {
              *pnum_clobbers = 1;
              return 140; /* *lshrdi3_cnt1 */
            }
          break;

        default:
          break;
        }
    }
  if (!register_operand (operands[1], E_SImode)
      || !dest_reg_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  operands[2] = x5;
  if (nonmemory_operand (operands[2], E_SImode))
    {
      if (
#line 3504 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx
   && arc_pre_reload_split ()))
        return 130; /* *lshrsi3_nobs */
      if (pnum_clobbers != NULL
          && 
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx))
        {
          *pnum_clobbers = 2;
          return 135; /* lshrsi3_loop */
        }
    }
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return 268; /* lshrsi3_cnt1 */
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SFmode))
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 61)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SFmode))
    return -1;
  x8 = XEXP (x6, 0);
  operands[2] = x8;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_CC_FP_GTmode:
      if (GET_MODE (x3) != E_CC_FP_GTmode
          || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
        return -1;
      return 322; /* *cmpsf_quark_gt */

    case E_CC_FP_GEmode:
      if (GET_MODE (x3) != E_CC_FP_GEmode
          || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
        return -1;
      return 323; /* *cmpsf_quark_ge */

    case E_CC_FP_ORDmode:
      if (GET_MODE (x3) != E_CC_FP_ORDmode
          || !
#line 646 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
        return -1;
      return 324; /* *cmpsf_quark_ord */

    case E_CC_FP_UNEQmode:
      if (GET_MODE (x3) != E_CC_FP_UNEQmode
          || !
#line 658 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
        return -1;
      return 325; /* *cmpsf_quark_uneq */

    case E_CC_Zmode:
      if (GET_MODE (x3) != E_CC_Zmode
          || !
#line 670 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
        return -1;
      return 326; /* *cmpsf_quark_eq */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      if (!register_operand (x4, E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (!nonmemory_operand (x6, E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != REG)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (register_operand (operands[0], E_SImode))
            {
              res = recog_35 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[3] = x7;
          if (!mhi_operand (operands[3], E_SImode))
            return -1;
          operands[2] = x8;
          if (!mlo_operand (operands[2], E_SImode))
            return -1;
          operands[0] = x4;
          operands[1] = x6;
          if (!
#line 2208 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET))
            return -1;
          return 76; /* mulsi_600 */

        case ZERO_EXTRACT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x10 = XEXP (x6, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!acc2_operand (operands[2], E_SImode))
            return -1;
          operands[0] = x4;
          x11 = XEXP (x6, 0);
          operands[1] = x11;
          if (!nonmemory_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[3] = x7;
          if (!acc1_operand (operands[3], E_SImode)
              || !
#line 2156 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
            return -1;
          return 73; /* umul_600 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern41 (x1, 
SIGN_EXTEND))
        {
        case 0:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern86 (x1, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2221 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET))
                    return -1;
                  return 77; /* mulsidi_600 */

                case 1:
                  if (!
#line 2376 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
                    return -1;
                  return 83; /* mulsidi64 */

                case 2:
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 6554 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                    return 284; /* mpyd_arcv2hs */
                  if (!even_register_operand (operands[1], E_SImode)
                      || !
#line 6570 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                    return -1;
                  return 286; /* *pmpyd_arcv2hs */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (pattern87 (x1, 
SIGN_EXTEND) != 0)
                return -1;
              if (register_operand (operands[1], E_SImode)
                  && 
#line 6584 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                return 288; /* mpyd_imm_arcv2hs */
              if (!even_register_operand (operands[1], E_SImode)
                  || !
#line 6599 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                return -1;
              return 290; /* *pmpyd_imm_arcv2hs */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1726 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
            return -1;
          return 494; /* arc_vec_smult_lo_v4hi */

        case 2:
          if (!
#line 1782 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 498; /* arc_vec_smult_hi_v4hi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern41 (x1, 
ZERO_EXTEND))
        {
        case 0:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern86 (x1, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2256 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET))
                    return -1;
                  return 79; /* umulsidi_600 */

                case 1:
                  if (!
#line 2589 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
                    return -1;
                  return 90; /* umulsidi64 */

                case 2:
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 6554 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                    return 285; /* mpydu_arcv2hs */
                  if (!even_register_operand (operands[1], E_SImode)
                      || !
#line 6570 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                    return -1;
                  return 287; /* *pmpydu_arcv2hs */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (pattern87 (x1, 
ZERO_EXTEND) != 0)
                return -1;
              if (register_operand (operands[1], E_SImode)
                  && 
#line 6584 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                return 289; /* mpydu_imm_arcv2hs */
              if (!even_register_operand (operands[1], E_SImode)
                  || !
#line 6599 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                return -1;
              return 291; /* *pmpydu_imm_arcv2hs */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1726 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
            return -1;
          return 495; /* arc_vec_umult_lo_v4hi */

        case 2:
          if (!
#line 1782 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 499; /* arc_vec_umult_hi_v4hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 2);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x7;
      if (nonmemory_operand (operands[1], E_SFmode))
        {
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          if (register_operand (operands[0], E_SFmode)
              && GET_MODE (x3) == E_SFmode
              && nonmemory_operand (operands[2], E_SFmode))
            {
              operands[3] = x4;
              if (accl_operand (operands[3], E_SFmode)
                  && (
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 93 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_FUSED
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)))))
                return 766; /* *p fmasf4_fpu */
            }
        }
      if (!even_register_operand (operands[1], E_DFmode)
          || pattern106 (x1) != 0
          || !even_register_operand (operands[2], E_DFmode)
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_FUSED)))
        return -1;
      return 768; /* *p fmadf4_fpu */

    case NEG:
      if (GET_MODE (x7) == E_SFmode)
        {
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          if (register_operand (operands[0], E_SFmode)
              && GET_MODE (x3) == E_SFmode)
            {
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (nonmemory_operand (operands[1], E_SFmode)
                  && nonmemory_operand (operands[2], E_SFmode))
                {
                  operands[3] = x4;
                  if (accl_operand (operands[3], E_SFmode)
                      && (
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 108 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_FUSED
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)))))
                    return 767; /* *p fnmasf4_fpu */
                }
            }
        }
      if (GET_MODE (x7) != E_DFmode
          || pattern106 (x1) != 0)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!even_register_operand (operands[1], E_DFmode)
          || !even_register_operand (operands[2], E_DFmode)
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 193 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_FUSED)))
        return -1;
      return 769; /* *p fnmadf4_fpu */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 4)
    return NULL;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return NULL;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_SImode)
    return NULL;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != ZERO_EXTRACT
      || GET_MODE (x6) != E_SImode)
    return NULL;
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return NULL;
  x8 = XEXP (x6, 2);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode))
    return NULL;
  x9 = XEXP (x5, 2);
  operands[4] = x9;
  if (!const_int_operand (operands[4], E_SImode))
    return NULL;
  x10 = XEXP (x5, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return NULL;
  x11 = XEXP (x5, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return NULL;
  x12 = XEXP (x6, 0);
  if (!rtx_equal_p (x12, operands[0]))
    return NULL;
  x13 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x13) != SET)
    return NULL;
  x14 = XEXP (x13, 1);
  if (GET_CODE (x14) != ZERO_EXTRACT
      || GET_MODE (x14) != E_SImode)
    return NULL;
  x15 = XEXP (x13, 0);
  if (GET_CODE (x15) != ZERO_EXTRACT
      || GET_MODE (x15) != E_SImode)
    return NULL;
  x16 = XEXP (x15, 1);
  operands[5] = x16;
  if (!const_int_operand (operands[5], E_SImode))
    return NULL;
  x17 = XEXP (x15, 2);
  operands[6] = x17;
  if (!const_int_operand (operands[6], E_SImode))
    return NULL;
  x18 = XEXP (x14, 2);
  if (!const_int_operand (x18, E_SImode))
    return NULL;
  operands[8] = x18;
  x19 = PATTERN (peep2_next_insn (2));
  operands[9] = x19;
  x20 = XEXP (x14, 0);
  operands[7] = x20;
  if (register_operand (operands[7], E_SImode))
    {
      x21 = XEXP (x14, 1);
      if (rtx_equal_p (x21, operands[5]))
        {
          x22 = XEXP (x15, 0);
          if (rtx_equal_p (x22, operands[0])
              && 
#line 6078 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS
   // Check that the second movb doesn't clobber an input of the extra insn.
   && !reg_overlap_mentioned_p (operands[0], operands[9])
   // And vice versa.
   && !reg_set_p (operands[0], operands[9])
   && !reg_set_p (operands[7], operands[9])))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  operands[7] = x18;
  if (GET_CODE (x19) != SET)
    return NULL;
  x23 = XEXP (x19, 1);
  operands[8] = x23;
  x24 = XEXP (x19, 0);
  if (!rtx_equal_p (x24, operands[1])
      || !rtx_equal_p (x20, operands[1]))
    return NULL;
  x21 = XEXP (x14, 1);
  if (!rtx_equal_p (x21, operands[5]))
    return NULL;
  x22 = XEXP (x15, 0);
  if (!rtx_equal_p (x22, operands[0])
      || !
#line 6106 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS
   && !reg_overlap_mentioned_p (operands[0], operands[8])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_11 (insn, operands);
}
