/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vector_register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vector_register_operand (operands[1], E_V8HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern21 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x1, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != VEC_SELECT)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 1)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XEXP (x9, 1);
  if (GET_CODE (x13) != VEC_SELECT)
    return -1;
  x14 = XEXP (x13, 1);
  if (GET_CODE (x14) != PARALLEL
      || XVECLEN (x14, 0) != 1)
    return -1;
  x15 = XVECEXP (x14, 0, 0);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x16 = XEXP (x3, 0);
  operands[1] = x16;
  x17 = XEXP (x6, 0);
  operands[2] = x17;
  x18 = XEXP (x10, 0);
  if (!rtx_equal_p (x18, operands[1]))
    return -1;
  x19 = XEXP (x13, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HImode:
      return pattern20 (x1, 
E_HImode, 
E_V2HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern20 (x1, 
E_SImode, 
E_V2SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (GET_MODE (x4) != E_DImode
          || GET_MODE (x5) != E_DImode)
        return -1;
      return 0;

    case VEC_SELECT:
      if (GET_MODE (x6) != E_V2HImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 2)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x7, 0, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XEXP (x4, 1);
      if (GET_CODE (x10) != i1
          || GET_MODE (x10) != E_V2SImode)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != VEC_SELECT
          || GET_MODE (x11) != E_V2HImode)
        return -1;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != PARALLEL
          || XVECLEN (x12, 0) != 2)
        return -1;
      x13 = XVECEXP (x12, 0, 0);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x14 = XVECEXP (x12, 0, 1);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x15) != SET)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != MULT
          || GET_MODE (x16) != E_V2SImode)
        return -1;
      x17 = XEXP (x16, 0);
      if (GET_CODE (x17) != i1
          || GET_MODE (x17) != E_V2SImode)
        return -1;
      x18 = XEXP (x17, 0);
      if (GET_CODE (x18) != VEC_SELECT
          || GET_MODE (x18) != E_V2HImode)
        return -1;
      x19 = XEXP (x18, 1);
      if (GET_CODE (x19) != PARALLEL
          || XVECLEN (x19, 0) != 2)
        return -1;
      x20 = XVECEXP (x19, 0, 0);
      if (GET_CODE (x20) != CONST_INT)
        return -1;
      x21 = XVECEXP (x19, 0, 1);
      if (GET_CODE (x21) != CONST_INT)
        return -1;
      x22 = XEXP (x16, 1);
      if (GET_CODE (x22) != i1
          || GET_MODE (x22) != E_V2SImode)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != VEC_SELECT
          || GET_MODE (x23) != E_V2HImode)
        return -1;
      x24 = XEXP (x23, 1);
      if (GET_CODE (x24) != PARALLEL
          || XVECLEN (x24, 0) != 2)
        return -1;
      x25 = XVECEXP (x24, 0, 0);
      if (GET_CODE (x25) != CONST_INT)
        return -1;
      x26 = XVECEXP (x24, 0, 1);
      if (GET_CODE (x26) != CONST_INT)
        return -1;
      x27 = XEXP (x15, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 58
          || GET_MODE (x27) != E_V2SImode
          || !even_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x4) != E_V2SImode
          || GET_MODE (x5) != E_V2SImode)
        return -1;
      x28 = XEXP (x6, 0);
      operands[1] = x28;
      if (!even_register_operand (operands[1], E_V4HImode))
        return -1;
      x29 = XEXP (x11, 0);
      operands[2] = x29;
      if (!even_register_operand (operands[2], E_V4HImode))
        return -1;
      x30 = XEXP (x18, 0);
      if (!rtx_equal_p (x30, operands[1]))
        return -1;
      x31 = XEXP (x23, 0);
      if (!rtx_equal_p (x31, operands[2]))
        return -1;
      switch (XWINT (x8, 0))
        {
        case 0L:
          if (XWINT (x9, 0) != 1L
              || XWINT (x13, 0) != 0L
              || XWINT (x14, 0) != 1L
              || XWINT (x20, 0) != 0L
              || XWINT (x21, 0) != 1L
              || XWINT (x25, 0) != 0L
              || XWINT (x26, 0) != 1L)
            return -1;
          return 1;

        case 2L:
          if (XWINT (x9, 0) != 3L
              || XWINT (x13, 0) != 2L
              || XWINT (x14, 0) != 3L
              || XWINT (x20, 0) != 2L
              || XWINT (x21, 0) != 3L
              || XWINT (x25, 0) != 2L
              || XWINT (x26, 0) != 3L)
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 58
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_MODE (x8) != E_SImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_MODE (x9) != E_SImode
          || !register_operand (operands[2], E_HImode)
          || !accl_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_MODE (x8) != E_DImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_MODE (x9) != E_DImode
          || !extend_operand (operands[2], E_SImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 0);
  switch (GET_MODE (x5))
    {
    case E_CC_Zmode:
      if (GET_MODE (x2) != E_CC_Zmode)
        return -1;
      return 0;

    case E_CC_FP_GTmode:
      if (GET_MODE (x2) != E_CC_FP_GTmode)
        return -1;
      return 1;

    case E_CC_FP_GEmode:
      if (GET_MODE (x2) != E_CC_FP_GEmode)
        return -1;
      return 2;

    case E_CC_FP_UNEQmode:
      if (GET_MODE (x2) != E_CC_FP_UNEQmode)
        return -1;
      return 3;

    case E_CC_FP_ORDmode:
      if (GET_MODE (x2) != E_CC_FP_ORDmode)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_V2HImode)
      || !register_operand (operands[2], E_V2HImode))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PRE_MODIFY:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 28
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (pattern36 (x6, 
E_SImode, 
28, 
PLUS) != 0
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x6, 1);
      operands[1] = x7;
      if (!immediate_operand (operands[1], E_VOIDmode)
          || !
#line 820 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed))
        return -1;
      return 4; /* *movsi_pre_mod */

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (pattern40 (x5, 
PARALLEL, 
E_HImode, 
VEC_SELECT, 
E_SImode, 
ZERO_EXTEND) != 0)
        return -1;
      x8 = XEXP (x5, 0);
      x9 = XEXP (x8, 1);
      if (XVECLEN (x9, 0) != 1
          || !vector_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      x10 = XEXP (x8, 0);
      operands[1] = x10;
      if (!vector_register_operand (operands[1], E_V8HImode))
        return -1;
      x11 = XVECEXP (x9, 0, 0);
      operands[2] = x11;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!immediate_operand (operands[3], E_SImode)
          || !
#line 176 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 371; /* vld128_insn */

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (REGNO (x3))
    {
    case 0:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != REG)
        return -1;
      switch (REGNO (x4))
        {
        case 1:
          switch (pattern81 (x1, 
E_SFmode))
            {
            case 0:
              if (!
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE))
                return -1;
              *pnum_clobbers = 2;
              return 214; /* *cmpsf_eq */

            case 1:
              if (!
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE))
                return -1;
              *pnum_clobbers = 2;
              return 215; /* *cmpsf_gt */

            case 2:
              if (!
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE))
                return -1;
              *pnum_clobbers = 2;
              return 216; /* *cmpsf_ge */

            case 3:
              if (!
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE))
                return -1;
              *pnum_clobbers = 2;
              return 217; /* *cmpsf_uneq */

            case 4:
              if (!
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE))
                return -1;
              *pnum_clobbers = 2;
              return 218; /* *cmpsf_ord */

            default:
              return -1;
            }

        case 2:
          switch (pattern81 (x1, 
E_DFmode))
            {
            case 0:
              if (!
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE))
                return -1;
              *pnum_clobbers = 2;
              return 219; /* *cmpdf_eq */

            case 1:
              if (!
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE))
                return -1;
              *pnum_clobbers = 2;
              return 220; /* *cmpdf_gt */

            case 2:
              if (!
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE))
                return -1;
              *pnum_clobbers = 2;
              return 221; /* *cmpdf_ge */

            case 3:
              if (!
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE))
                return -1;
              *pnum_clobbers = 2;
              return 222; /* *cmpdf_uneq */

            case 4:
              if (!
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE))
                return -1;
              *pnum_clobbers = 2;
              return 223; /* *cmpdf_ord */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 61:
      if (GET_MODE (x3) != E_CC_FPXmode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_CC_FP_GTmode:
          if (GET_MODE (x2) != E_CC_FP_GTmode
              || !
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_ARGONAUT_SET))
            return -1;
          return 309; /* *cmpfpx_gt */

        case E_CC_FP_GEmode:
          if (GET_MODE (x2) != E_CC_FP_GEmode
              || !
#line 144 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_ARGONAUT_SET))
            return -1;
          return 310; /* *cmpfpx_ge */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != SIGN_EXTEND
              || GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!extend_operand (operands[2], E_SImode)
              || !
#line 2467 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPY))
            return -1;
          return 87; /* mulsi3_highpart */

        case ZERO_EXTEND:
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) == ZERO_EXTEND
              && GET_MODE (x8) == E_DImode)
            {
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (extend_operand (operands[2], E_SImode)
                  && 
#line 2484 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPY))
                return 88; /* *umulsi3_highpart_i */
            }
          operands[2] = x8;
          if (!immediate_usidi_operand (operands[2], E_DImode)
              || !
#line 2502 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPY))
            return -1;
          return 89; /* umulsi3_highpart_int */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 58
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x8) != SIGN_EXTEND)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!extend_operand (operands[2], E_SImode)
              || !
#line 6437 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
            return -1;
          *pnum_clobbers = 1;
          return 279; /* mac_r */

        case ZERO_EXTEND:
          if (GET_CODE (x8) != ZERO_EXTEND)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!extend_operand (operands[2], E_SImode)
              || !
#line 6539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
            return -1;
          *pnum_clobbers = 1;
          return 283; /* macu_r */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!dest_reg_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (!nonmemory_operand (x5, E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x6, 1);
          if (!nonmemory_operand (x8, E_SImode))
            return -1;
          operands[1] = x8;
          operands[2] = x5;
          return 108; /* *bclr */
          operands[2] = x8;
          operands[1] = x5;
          return 111; /* *bclr_insn */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x6;
          if (!nonmemory_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x5;
          return 114; /* *bicsi3_insn */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case PLUS:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != ASHIFT
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x11 = XEXP (x9, 1);
          if (GET_CODE (x11) != PLUS
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x11, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x13 = XEXP (x5, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
              || !nonmemory_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          return 112; /* *bmsk_insn */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SImode)
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 3196 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
((register_operand (operands[1], SImode)
    && nonmemory_operand (operands[2], SImode))
   || (memory_operand (operands[1], SImode)
       && satisfies_constraint_Cux (operands[2]))))
            return -1;
          return 113; /* andsi3_i */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[4] = x3;
      if (!zn_compare_operator (operands[4], E_VOIDmode))
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!cc_register (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[3] = x9;
          if (!scratch_operand (operands[3], E_SImode)
              || !
#line 964 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS))
            return -1;
          return 19; /* *tst_movb */

        case NOT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) != AND
              || GET_MODE (x10) != E_SImode)
            return -1;
          x11 = XEXP (x10, 1);
          if (GET_CODE (x11) != NOT
              || GET_MODE (x11) != E_SImode)
            return -1;
          x8 = XEXP (x2, 0);
          operands[3] = x8;
          if (!cc_set_register (operands[3], E_VOIDmode))
            return -1;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x14 = XEXP (x11, 0);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          return 35; /* *bic_f */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x10 = XEXP (x7, 1);
      if (GET_CODE (x10) != AND
          || GET_MODE (x10) != E_SImode)
        return -1;
      x13 = XEXP (x10, 0);
      if (GET_CODE (x13) != NOT
          || GET_MODE (x13) != E_SImode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!cc_set_register (operands[0], E_VOIDmode)
          || GET_MODE (x3) != E_CC_ZNmode)
        return -1;
      x15 = XEXP (x5, 0);
      operands[1] = x15;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[3] = x9;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x16 = XEXP (x13, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x11 = XEXP (x10, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 1277 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[1], SImode)
   || register_operand (operands[2], SImode)))
        return -1;
      return 37; /* *bic_cmp0 */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case REG:
      if (REGNO (x4) != 13
          || GET_CODE (x3) != MEM)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 28
          || GET_MODE (x5) != E_SImode
          || !millicode_store_operation (operands[0], E_VOIDmode))
        return -1;
      return 226; /* *millicode_thunk_st */

    case MEM:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 28
          || GET_MODE (x6) != E_SImode
          || GET_CODE (x3) != REG
          || REGNO (x3) != 13
          || !millicode_load_clob_operation (operands[0], E_VOIDmode))
        return -1;
      return 227; /* *millicode_thunk_ld */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!cc_register (operands[0], E_VOIDmode))
        return -1;
      operands[3] = x3;
      if (!zn_compare_operator (operands[3], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 980 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   || !satisfies_constraint_Cbf (operands[2])
   || satisfies_constraint_C0p (operands[2])
   || satisfies_constraint_I (operands[2])
   || satisfies_constraint_C1p (operands[2])
   || satisfies_constraint_Chs (operands[2]))))
        return -1;
      return 668; /* *p *tst */

    case REG:
    case SUBREG:
      operands[0] = x4;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 61)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (x7))
        {
        case E_CCmode:
          if (GET_MODE (x3) == E_CCmode
              && register_operand (operands[0], E_SImode)
              && nonmemory_operand (operands[1], E_SImode))
            return 714; /* *p cmpsi_cc_insn_mixed */
          break;

        case E_CC_FPUmode:
          switch (pattern111 (x3, 
E_CC_FPUmode))
            {
            case 0:
              if ((
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE)))
                return 771; /* *p *cmpsf_fpu */
              break;

            case 1:
              if ((
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 345 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE)))
                return 777; /* *p *cmpdf_fpu */
              break;

            default:
              break;
            }
          break;

        case E_CC_FPUEmode:
          switch (pattern111 (x3, 
E_CC_FPUEmode))
            {
            case 0:
              if ((
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 249 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE)))
                return 772; /* *p *cmpsf_fpu_trap */
              break;

            case 1:
              if ((
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 357 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE)))
                return 778; /* *p *cmpdf_fpu_trap */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_MODE (x7) != E_CC_ZNmode
          || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x6;
      if (GET_MODE (x3) != E_CC_ZNmode
          || !register_operand (operands[0], E_SImode))
        return -1;
      return 715; /* *p *cmpsi_cc_zn_insn */

    case ZERO_EXTRACT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 61
          || GET_MODE (x7) != E_CC_ZNmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      if (GET_MODE (x3) != E_CC_ZNmode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x4, 2);
      operands[1] = x10;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 716; /* *p *btst */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (cc_register (x3, E_VOIDmode))
    {
      res = recog_48 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (REGNO (x3) != 61
      || !proper_comparison_operator (x2, E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case SET:
      return recog_54 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x5))
            {
            case SET:
              x6 = XEXP (x5, 1);
              switch (GET_CODE (x6))
                {
                case COMPARE:
                  x7 = XEXP (x6, 1);
                  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x8 = XVECEXP (x4, 0, 1);
                  if (GET_CODE (x8) != SET)
                    return -1;
                  x9 = XEXP (x5, 0);
                  if (!cc_set_register (x9, E_VOIDmode))
                    return -1;
                  x10 = XEXP (x8, 0);
                  operands[0] = x10;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x11 = XEXP (x6, 0);
                  switch (GET_CODE (x11))
                    {
                    case ZERO_EXTRACT:
                      if (GET_MODE (x11) != E_SImode)
                        return -1;
                      x12 = XEXP (x8, 1);
                      if (GET_CODE (x12) != ZERO_EXTRACT
                          || GET_MODE (x12) != E_SImode)
                        return -1;
                      operands[5] = x2;
                      operands[4] = x9;
                      if (GET_MODE (x6) != E_CC_Zmode)
                        return -1;
                      x13 = XEXP (x11, 0);
                      operands[1] = x13;
                      if (!register_operand (operands[1], E_SImode))
                        return -1;
                      x14 = XEXP (x11, 1);
                      operands[2] = x14;
                      if (!const_int_operand (operands[2], E_SImode))
                        return -1;
                      x15 = XEXP (x11, 2);
                      operands[3] = x15;
                      if (!const_int_operand (operands[3], E_SImode))
                        return -1;
                      x16 = XEXP (x12, 0);
                      if (!rtx_equal_p (x16, operands[1]))
                        return -1;
                      x17 = XEXP (x12, 1);
                      if (!rtx_equal_p (x17, operands[2]))
                        return -1;
                      x18 = XEXP (x12, 2);
                      if (!rtx_equal_p (x18, operands[3])
                          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 895 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_HS && TARGET_BARREL_SHIFTER)))
                        return -1;
                      return 666; /* *p *xbfu_cmp0 */

                    case CONST_INT:
                    case CONST_WIDE_INT:
                    case CONST_POLY_INT:
                    case CONST_FIXED:
                    case CONST_DOUBLE:
                    case CONST_VECTOR:
                    case CONST:
                    case REG:
                    case SUBREG:
                    case LABEL_REF:
                    case SYMBOL_REF:
                    case HIGH:
                      operands[1] = x11;
                      if (!nonmemory_operand (operands[1], E_SImode))
                        return -1;
                      operands[4] = x2;
                      operands[2] = x9;
                      operands[3] = x6;
                      if (!zn_compare_operator (operands[3], E_VOIDmode))
                        return -1;
                      x12 = XEXP (x8, 1);
                      if (!rtx_equal_p (x12, operands[1]))
                        return -1;
                      return 667; /* *p *movsi_set_cc_insn */

                    case PLUS:
                    case MULT:
                    case AND:
                    case IOR:
                    case XOR:
                    case SS_PLUS:
                      operands[4] = x11;
                      if (!commutative_operator (operands[4], E_SImode)
                          || pattern116 (x1) != 0)
                        return -1;
                      return 669; /* *p *commutative_binary_cmp0 */

                    case MINUS:
                    case ASHIFT:
                    case ASHIFTRT:
                    case LSHIFTRT:
                    case ROTATERT:
                    case SS_MINUS:
                      operands[4] = x11;
                      if (!noncommutative_operator (operands[4], E_SImode)
                          || pattern116 (x1) != 0)
                        return -1;
                      return 670; /* *p *noncommutative_binary_cmp0 */

                    default:
                      return -1;
                    }

                case PLUS:
                  x11 = XEXP (x6, 0);
                  switch (GET_CODE (x11))
                    {
                    case MULT:
                      x13 = XEXP (x11, 0);
                      switch (GET_CODE (x13))
                        {
                        case REG:
                        case SUBREG:
                          operands[0] = x13;
                          if (!register_operand (operands[0], E_SImode))
                            return -1;
                          x14 = XEXP (x11, 1);
                          if (GET_CODE (x14) != ASHIFT
                              || GET_MODE (x14) != E_SImode)
                            return -1;
                          x19 = XEXP (x14, 0);
                          if (GET_CODE (x19) != ZERO_EXTRACT
                              || GET_MODE (x19) != E_SImode)
                            return -1;
                          x20 = XEXP (x19, 1);
                          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                            return -1;
                          x21 = XEXP (x19, 2);
                          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                            return -1;
                          x22 = XEXP (x14, 1);
                          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                            return -1;
                          x8 = XVECEXP (x4, 0, 1);
                          if (GET_CODE (x8) != CLOBBER)
                            return -1;
                          operands[4] = x2;
                          x9 = XEXP (x5, 0);
                          operands[2] = x9;
                          if (!acc2_operand (operands[2], E_SImode)
                              || GET_MODE (x6) != E_SImode
                              || GET_MODE (x11) != E_SImode)
                            return -1;
                          x23 = XEXP (x19, 0);
                          operands[1] = x23;
                          if (!nonmemory_operand (operands[1], E_SImode))
                            return -1;
                          x10 = XEXP (x8, 0);
                          operands[3] = x10;
                          if (!acc1_operand (operands[3], E_SImode))
                            return -1;
                          x7 = XEXP (x6, 1);
                          if (!rtx_equal_p (x7, operands[2])
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2174 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET)))
                            return -1;
                          return 682; /* *p mac_600 */

                        case SIGN_EXTEND:
                          switch (pattern98 (x1, 
SIGN_EXTEND))
                            {
                            case 0:
                              x14 = XEXP (x11, 1);
                              switch (GET_CODE (x14))
                                {
                                case ASHIFT:
                                  if (pattern117 (x4, 
SIGN_EXTRACT, 
SIGN_EXTEND) != 0
                                      || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2430 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET)))
                                    return -1;
                                  return 689; /* *p mac64_600 */

                                case SIGN_EXTEND:
                                  switch (pattern119 (x4, 
SIGN_EXTEND))
                                    {
                                    case 0:
                                      if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 6394 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD)))
                                        return -1;
                                      return 754; /* *p macd */

                                    case 1:
                                      if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1819 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD)))
                                        return -1;
                                      return 816; /* *p arc_vec_smac_v2hiv2si */

                                    default:
                                      return -1;
                                    }

                                default:
                                  return -1;
                                }

                            case 1:
                              if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1637 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY)))
                                return -1;
                              return 810; /* *p dmpyh */

                            default:
                              return -1;
                            }

                        case ZERO_EXTEND:
                          switch (pattern98 (x1, 
ZERO_EXTEND))
                            {
                            case 0:
                              x14 = XEXP (x11, 1);
                              switch (GET_CODE (x14))
                                {
                                case ASHIFT:
                                  if (pattern117 (x4, 
ZERO_EXTRACT, 
ZERO_EXTEND) != 0
                                      || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2644 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET)))
                                    return -1;
                                  return 693; /* *p umac64_600 */

                                case ZERO_EXTEND:
                                  switch (pattern119 (x4, 
ZERO_EXTEND))
                                    {
                                    case 0:
                                      if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 6496 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD)))
                                        return -1;
                                      return 755; /* *p macdu */

                                    case 1:
                                      if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1819 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD)))
                                        return -1;
                                      return 817; /* *p arc_vec_umac_v2hiv2si */

                                    default:
                                      return -1;
                                    }

                                default:
                                  return -1;
                                }

                            case 1:
                              if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1637 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY)))
                                return -1;
                              return 811; /* *p dmpyhu */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case REG:
                      if (REGNO (x11) != 60
                          || GET_MODE (x11) != E_SImode)
                        return -1;
                      x7 = XEXP (x6, 1);
                      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
                        return -1;
                      x9 = XEXP (x5, 0);
                      if (GET_CODE (x9) != REG
                          || REGNO (x9) != 60
                          || GET_MODE (x9) != E_SImode)
                        return -1;
                      x8 = XVECEXP (x4, 0, 1);
                      if (GET_CODE (x8) != SET)
                        return -1;
                      x12 = XEXP (x8, 1);
                      if (GET_CODE (x12) != COMPARE
                          || GET_MODE (x12) != E_CC_ZNmode)
                        return -1;
                      x16 = XEXP (x12, 0);
                      if (GET_CODE (x16) != PLUS
                          || GET_MODE (x16) != E_SImode)
                        return -1;
                      x24 = XEXP (x16, 0);
                      if (GET_CODE (x24) != REG
                          || REGNO (x24) != 60
                          || GET_MODE (x24) != E_SImode)
                        return -1;
                      x25 = XEXP (x16, 1);
                      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
                        return -1;
                      x17 = XEXP (x12, 1);
                      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                        return -1;
                      x10 = XEXP (x8, 0);
                      if (GET_CODE (x10) != REG
                          || REGNO (x10) != 61
                          || GET_MODE (x10) != E_CC_ZNmode)
                        return -1;
                      operands[0] = x2;
                      if (GET_MODE (x6) != E_SImode)
                        return -1;
                      return 722; /* *p loop_fail */

                    default:
                      return -1;
                    }

                case MULT:
                  x11 = XEXP (x6, 0);
                  switch (GET_CODE (x11))
                    {
                    case REG:
                    case SUBREG:
                      operands[0] = x11;
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      x8 = XVECEXP (x4, 0, 1);
                      if (GET_CODE (x8) != CLOBBER)
                        return -1;
                      operands[4] = x2;
                      x9 = XEXP (x5, 0);
                      operands[2] = x9;
                      if (!mlo_operand (operands[2], E_SImode)
                          || GET_MODE (x6) != E_SImode)
                        return -1;
                      x7 = XEXP (x6, 1);
                      operands[1] = x7;
                      if (!nonmemory_operand (operands[1], E_SImode))
                        return -1;
                      x10 = XEXP (x8, 0);
                      operands[3] = x10;
                      if (!mhi_operand (operands[3], E_SImode)
                          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2208 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET)))
                        return -1;
                      return 683; /* *p mulsi_600 */

                    case SIGN_EXTEND:
                      switch (pattern92 (x1, 
SIGN_EXTEND))
                        {
                        case 0:
                          x7 = XEXP (x6, 1);
                          switch (GET_CODE (x7))
                            {
                            case SIGN_EXTEND:
                              if (pattern125 (x4, 
SIGN_EXTEND) != 0
                                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 6570 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD)))
                                return -1;
                              return 756; /* *p *pmpyd_arcv2hs */

                            case CONST_INT:
                            case CONST_WIDE_INT:
                            case CONST_POLY_INT:
                            case CONST_FIXED:
                            case CONST_DOUBLE:
                            case CONST_VECTOR:
                            case CONST:
                            case LABEL_REF:
                            case SYMBOL_REF:
                            case HIGH:
                              operands[2] = x7;
                              if (!immediate_operand (operands[2], E_VOIDmode))
                                return -1;
                              x8 = XVECEXP (x4, 0, 1);
                              x12 = XEXP (x8, 1);
                              x17 = XEXP (x12, 1);
                              if (!rtx_equal_p (x17, operands[2])
                                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 6599 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD)))
                                return -1;
                              return 758; /* *p *pmpyd_imm_arcv2hs */

                            default:
                              return -1;
                            }

                        case 1:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1726 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD)))
                            return -1;
                          return 812; /* *p arc_vec_smult_lo_v4hi */

                        case 2:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1782 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                            return -1;
                          return 814; /* *p arc_vec_smult_hi_v4hi */

                        default:
                          return -1;
                        }

                    case ZERO_EXTEND:
                      switch (pattern92 (x1, 
ZERO_EXTEND))
                        {
                        case 0:
                          x7 = XEXP (x6, 1);
                          switch (GET_CODE (x7))
                            {
                            case ZERO_EXTEND:
                              if (pattern125 (x4, 
ZERO_EXTEND) != 0
                                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 6570 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD)))
                                return -1;
                              return 757; /* *p *pmpydu_arcv2hs */

                            case CONST_INT:
                            case CONST_WIDE_INT:
                            case CONST_POLY_INT:
                            case CONST_FIXED:
                            case CONST_DOUBLE:
                            case CONST_VECTOR:
                            case CONST:
                            case LABEL_REF:
                            case SYMBOL_REF:
                            case HIGH:
                              operands[2] = x7;
                              if (!immediate_operand (operands[2], E_VOIDmode))
                                return -1;
                              x8 = XVECEXP (x4, 0, 1);
                              x12 = XEXP (x8, 1);
                              x17 = XEXP (x12, 1);
                              if (!rtx_equal_p (x17, operands[2])
                                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 6599 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD)))
                                return -1;
                              return 759; /* *p *pmpydu_imm_arcv2hs */

                            default:
                              return -1;
                            }

                        case 1:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1726 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD)))
                            return -1;
                          return 813; /* *p arc_vec_umult_lo_v4hi */

                        case 2:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1782 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                            return -1;
                          return 815; /* *p arc_vec_umult_hi_v4hi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case CALL:
                  x11 = XEXP (x6, 0);
                  if (GET_CODE (x11) != MEM
                      || GET_MODE (x11) != E_SImode
                      || pattern85 (x1, 
E_SImode, 
31) != 0)
                    return -1;
                  x9 = XEXP (x5, 0);
                  operands[0] = x9;
                  if (!dest_reg_operand (operands[0], E_VOIDmode))
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[1] = x13;
                  if (!call_address_operand (operands[1], E_SImode))
                    return -1;
                  x7 = XEXP (x6, 1);
                  operands[2] = x7;
                  return 718; /* *p *call_value_i */

                case UNSPEC:
                  if (pattern85 (x1, 
E_DImode, 
58) != 0)
                    return -1;
                  x9 = XEXP (x5, 0);
                  operands[0] = x9;
                  switch (XVECLEN (x6, 0))
                    {
                    case 3:
                      x26 = XVECEXP (x6, 0, 2);
                      if (GET_CODE (x26) != REG
                          || REGNO (x26) != 58
                          || GET_MODE (x26) != E_DImode)
                        return -1;
                      x27 = XVECEXP (x6, 0, 0);
                      operands[1] = x27;
                      x28 = XVECEXP (x6, 0, 1);
                      operands[2] = x28;
                      switch (XINT (x6, 1))
                        {
                        case 20:
                          if (pattern123 (x6) != 0
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1847 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY)))
                            return -1;
                          return 818; /* *p dmach */

                        case 21:
                          if (pattern123 (x6) != 0
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1861 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY)))
                            return -1;
                          return 819; /* *p dmachu */

                        case 22:
                          if (GET_MODE (x6) != E_DImode
                              || !even_register_operand (operands[0], E_DImode)
                              || !even_register_operand (operands[1], E_V2SImode)
                              || !register_operand (operands[2], E_V2HImode)
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1875 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                            return -1;
                          return 820; /* *p dmacwh */

                        case 23:
                          if (GET_MODE (x6) != E_DImode
                              || !register_operand (operands[0], E_DImode)
                              || !even_register_operand (operands[1], E_V2SImode)
                              || !register_operand (operands[2], E_V2HImode)
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1889 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                            return -1;
                          return 821; /* *p dmacwhu */

                        case 29:
                          if (pattern120 (x6) != 0
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1903 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD)))
                            return -1;
                          return 822; /* *p vmac2h */

                        case 30:
                          if (pattern120 (x6) != 0
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1917 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD)))
                            return -1;
                          return 823; /* *p vmac2hu */

                        case 25:
                          if (pattern121 (x6) != 0
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1957 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                            return -1;
                          return 826; /* *p qmach */

                        case 26:
                          if (pattern121 (x6) != 0
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                            return -1;
                          return 827; /* *p qmachu */

                        default:
                          return -1;
                        }

                    case 2:
                      x27 = XVECEXP (x6, 0, 0);
                      operands[1] = x27;
                      x28 = XVECEXP (x6, 0, 1);
                      operands[2] = x28;
                      switch (XINT (x6, 1))
                        {
                        case 31:
                          if (pattern120 (x6) != 0
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1930 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD)))
                            return -1;
                          return 824; /* *p vmpy2h */

                        case 32:
                          if (pattern120 (x6) != 0
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1943 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD)))
                            return -1;
                          return 825; /* *p vmpy2hu */

                        case 27:
                          if (pattern121 (x6) != 0
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                            return -1;
                          return 828; /* *p qmpyh */

                        case 28:
                          if (pattern121 (x6) != 0
                              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1997 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                            return -1;
                          return 829; /* *p qmpyhu */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case CALL:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != MEM
                  || GET_MODE (x9) != E_SImode)
                return -1;
              x8 = XVECEXP (x4, 0, 1);
              if (pattern93 (x8, 
E_SImode, 
31) != 0)
                return -1;
              operands[2] = x2;
              x29 = XEXP (x9, 0);
              operands[0] = x29;
              if (!call_address_operand (operands[0], E_SImode))
                return -1;
              x6 = XEXP (x5, 1);
              operands[1] = x6;
              return 717; /* *p *call_i */

            default:
              return -1;
            }

        case 3:
          x5 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x5))
            {
            case CALL:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != MEM
                  || GET_MODE (x9) != E_SImode)
                return -1;
              x8 = XVECEXP (x4, 0, 1);
              if (GET_CODE (x8) != SIMPLE_RETURN)
                return -1;
              x30 = XVECEXP (x4, 0, 2);
              if (GET_CODE (x30) != USE)
                return -1;
              operands[3] = x2;
              x29 = XEXP (x9, 0);
              operands[0] = x29;
              if (!call_address_operand (operands[0], E_SImode))
                return -1;
              x6 = XEXP (x5, 1);
              operands[1] = x6;
              x31 = XEXP (x30, 0);
              operands[2] = x31;
              return 720; /* *p *sibcall_insn */

            case SET:
              x6 = XEXP (x5, 1);
              switch (GET_CODE (x6))
                {
                case CALL:
                  x11 = XEXP (x6, 0);
                  if (GET_CODE (x11) != MEM
                      || GET_MODE (x11) != E_SImode)
                    return -1;
                  x8 = XVECEXP (x4, 0, 1);
                  if (GET_CODE (x8) != SIMPLE_RETURN)
                    return -1;
                  x30 = XVECEXP (x4, 0, 2);
                  if (GET_CODE (x30) != USE)
                    return -1;
                  operands[4] = x2;
                  x9 = XEXP (x5, 0);
                  operands[0] = x9;
                  if (!dest_reg_operand (operands[0], E_VOIDmode))
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[1] = x13;
                  if (!call_address_operand (operands[1], E_SImode))
                    return -1;
                  x7 = XEXP (x6, 1);
                  operands[2] = x7;
                  x31 = XEXP (x30, 0);
                  operands[3] = x31;
                  return 721; /* *p *sibcall_value_insn */

                case COMPARE:
                  x11 = XEXP (x6, 0);
                  if (GET_CODE (x11) != REG
                      || REGNO (x11) != 0)
                    return -1;
                  x7 = XEXP (x6, 1);
                  if (GET_CODE (x7) != REG)
                    return -1;
                  x9 = XEXP (x5, 0);
                  if (GET_CODE (x9) != REG
                      || REGNO (x9) != 61)
                    return -1;
                  x8 = XVECEXP (x4, 0, 1);
                  if (pattern93 (x8, 
E_SImode, 
31) != 0)
                    return -1;
                  x30 = XVECEXP (x4, 0, 2);
                  if (GET_CODE (x30) != CLOBBER)
                    return -1;
                  x31 = XEXP (x30, 0);
                  if (GET_CODE (x31) != REG
                      || REGNO (x31) != 12
                      || GET_MODE (x31) != E_SImode)
                    return -1;
                  operands[0] = x2;
                  switch (REGNO (x7))
                    {
                    case 1:
                      switch (pattern124 (x5, 
E_SFmode))
                        {
                        case 0:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE)))
                            return -1;
                          return 723; /* *p *cmpsf_eq */

                        case 1:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE)))
                            return -1;
                          return 724; /* *p *cmpsf_gt */

                        case 2:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE)))
                            return -1;
                          return 725; /* *p *cmpsf_ge */

                        case 3:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE)))
                            return -1;
                          return 726; /* *p *cmpsf_uneq */

                        case 4:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE)))
                            return -1;
                          return 727; /* *p *cmpsf_ord */

                        default:
                          return -1;
                        }

                    case 2:
                      switch (pattern124 (x5, 
E_DFmode))
                        {
                        case 0:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE)))
                            return -1;
                          return 728; /* *p *cmpdf_eq */

                        case 1:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE)))
                            return -1;
                          return 729; /* *p *cmpdf_gt */

                        case 2:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE)))
                            return -1;
                          return 730; /* *p *cmpdf_ge */

                        case 3:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE)))
                            return -1;
                          return 731; /* *p *cmpdf_uneq */

                        case 4:
                          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE)))
                            return -1;
                          return 732; /* *p *cmpdf_ord */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x4, 0) != 1)
        return -1;
      operands[1] = x2;
      x5 = XVECEXP (x4, 0, 0);
      operands[0] = x5;
      if (!nonmemory_operand (operands[0], E_SImode))
        return -1;
      switch (XINT (x4, 1))
        {
        case 37:
          return 719; /* *p flag */

        case 46:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5664 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2)))
            return -1;
          return 750; /* *p kflag */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
