/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vector_register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern23 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 61
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != UNSPEC
      || XVECLEN (x12, 0) != 1
      || XINT (x12, 1) != 15
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x4, 0);
  operands[0] = x15;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x16 = XEXP (x6, 0);
  operands[1] = x16;
  x17 = XEXP (x14, 0);
  operands[2] = x17;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  x18 = XEXP (x10, 0);
  if (!rtx_equal_p (x18, operands[0]))
    return -1;
  x19 = XEXP (x9, 0);
  if (!rtx_equal_p (x19, operands[0]))
    return -1;
  return 0;
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!even_register_operand (operands[0], E_DFmode)
      || GET_MODE (x1) != E_DFmode
      || !even_register_operand (operands[1], E_DFmode)
      || !even_register_operand (operands[2], E_DFmode))
    return -1;
  return 0;
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ZERO_EXTEND
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  return 0;
}

int
pattern60 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 58
      || GET_MODE (x2) != E_DImode
      || !even_register_operand (operands[0], E_DImode)
      || !even_register_operand (operands[1], E_V4HImode)
      || !even_register_operand (operands[2], E_V4HImode))
    return -1;
  return 0;
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern76 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1
      || GET_MODE (x2) != i1)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!immediate_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!vector_register_operand (operands[1], E_V8HImode))
    return -1;
  x9 = XVECEXP (x6, 0, 0);
  operands[2] = x9;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x1, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern91 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 1)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x1, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != VEC_SELECT)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 1)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XEXP (x9, 1);
  if (GET_CODE (x13) != VEC_SELECT)
    return -1;
  x14 = XEXP (x13, 1);
  if (GET_CODE (x14) != PARALLEL
      || XVECLEN (x14, 0) != 1)
    return -1;
  x15 = XVECEXP (x14, 0, 0);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x16 = XEXP (x3, 0);
  operands[1] = x16;
  x17 = XEXP (x6, 0);
  operands[2] = x17;
  x18 = XEXP (x10, 0);
  if (!rtx_equal_p (x18, operands[1]))
    return -1;
  x19 = XEXP (x13, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HImode:
      return pattern90 (x1, 
E_HImode, 
E_V2HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern90 (x1, 
E_SImode, 
E_V2SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 2);
  if (REGNO (x4) != 58
      || GET_MODE (x4) != E_DFmode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  if (!even_register_operand (operands[0], E_DFmode)
      || GET_MODE (x3) != E_DFmode)
    return -1;
  return 0;
}

int
pattern114 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!arc_double_register_operand (operands[1], E_DFmode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  if (!nonmemory_operand (operands[2], E_DFmode))
    return -1;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  return 0;
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !even_register_operand (operands[0], E_DImode)
      || !even_register_operand (operands[1], E_V4HImode)
      || !even_register_operand (operands[2], E_V4HImode))
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 0);
  switch (GET_MODE (x5))
    {
    case E_CC_Zmode:
      if (GET_MODE (x2) != E_CC_Zmode)
        return -1;
      return 0;

    case E_CC_FP_GTmode:
      if (GET_MODE (x2) != E_CC_FP_GTmode)
        return -1;
      return 1;

    case E_CC_FP_GEmode:
      if (GET_MODE (x2) != E_CC_FP_GEmode)
        return -1;
      return 2;

    case E_CC_FP_UNEQmode:
      if (GET_MODE (x2) != E_CC_FP_UNEQmode)
        return -1;
      return 3;

    case E_CC_FP_ORDmode:
      if (GET_MODE (x2) != E_CC_FP_ORDmode)
        return -1;
      return 4;

    default:
      return -1;
    }
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x5, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  if (cc_set_register (operands[0], E_VOIDmode)
      && GET_MODE (x2) == E_CC_Zmode
      && 
#line 873 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_HS && TARGET_BARREL_SHIFTER))
    return 14; /* *xbfu_cmp0_noout */
  if (!cc_set_register (operands[0], E_CC_ZNmode)
      || !zn_compare_operator (x2, E_VOIDmode))
    return -1;
  operands[4] = x2;
  if (
#line 1025 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(INTVAL (operands[2]) > 1
   && (INTVAL (operands[3]) + INTVAL (operands[2]) <= 11
       || (INTVAL (operands[3]) <= 11
	   && INTVAL (operands[3]) + INTVAL (operands[2]) == 32))))
    return 21; /* *tst_bitfield_tst */
  if (
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(INTVAL (operands[2]) > 1
   && INTVAL (operands[3]) + INTVAL (operands[2]) == 32))
    return 22; /* *tst_bitfield_asr */
  if (pnum_clobbers == NULL)
    return -1;
  operands[5] = x2;
  *pnum_clobbers = 1;
  return 23; /* *tst_bitfield */
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  operands[4] = x4;
  if (cc_register (operands[4], E_VOIDmode))
    {
      res = recog_9 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (REGNO (x4) != 61)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      operands[1] = x3;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      return 160; /* *branch_insn */

    case PC:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      operands[1] = x3;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      return 161; /* *rev_branch_insn */

    case SIMPLE_RETURN:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      operands[0] = x3;
      if (!
#line 5018 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed))
        return -1;
      return 207; /* p_return_i */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_V4HImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (pattern40 (x5, 
ZERO_EXTEND, 
E_SImode, 
PLUS, 
E_V4QImode, 
MEM) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != VEC_SELECT
          || GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x10 = XEXP (x3, 1);
      if (GET_CODE (x10) != VEC_SELECT
          || GET_MODE (x10) != E_V4HImode)
        return -1;
      x11 = XEXP (x10, 1);
      if (GET_CODE (x11) != PARALLEL
          || XVECLEN (x11, 0) != 4)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XVECEXP (x11, 0, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x14 = XVECEXP (x11, 0, 2);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x15 = XVECEXP (x11, 0, 3);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || !vector_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      x16 = XEXP (x6, 0);
      operands[1] = x16;
      if (!immediate_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x8, 0);
      operands[2] = x17;
      if (!vector_register_operand (operands[2], E_V8HImode))
        return -1;
      x18 = XVECEXP (x9, 0, 0);
      operands[3] = x18;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x19 = XEXP (x10, 0);
      if (!rtx_equal_p (x19, operands[0])
          || !
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 468; /* vld32wh_insn */

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V4HImode)
        return -1;
      x20 = XEXP (x4, 1);
      if (GET_CODE (x20) != PARALLEL
          || XVECLEN (x20, 0) != 4)
        return -1;
      x21 = XVECEXP (x20, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x22 = XVECEXP (x20, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x23 = XVECEXP (x20, 0, 2);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x24 = XVECEXP (x20, 0, 3);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || !vector_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      x10 = XEXP (x3, 1);
      if (GET_MODE (x10) != E_V4HImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      switch (GET_CODE (x10))
        {
        case ZERO_EXTEND:
          x19 = XEXP (x10, 0);
          if (GET_CODE (x19) != MEM
              || GET_MODE (x19) != E_V4QImode)
            return -1;
          x25 = XEXP (x19, 0);
          if (GET_CODE (x25) != PLUS
              || GET_MODE (x25) != E_SImode)
            return -1;
          x26 = XEXP (x25, 1);
          if (GET_CODE (x26) != ZERO_EXTEND
              || GET_MODE (x26) != E_SImode)
            return -1;
          x27 = XEXP (x26, 0);
          if (GET_CODE (x27) != VEC_SELECT
              || GET_MODE (x27) != E_HImode)
            return -1;
          x28 = XEXP (x27, 1);
          if (GET_CODE (x28) != PARALLEL
              || XVECLEN (x28, 0) != 1)
            return -1;
          x29 = XEXP (x25, 0);
          operands[1] = x29;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x30 = XEXP (x27, 0);
          operands[2] = x30;
          if (!vector_register_operand (operands[2], E_V8HImode))
            return -1;
          x31 = XVECEXP (x28, 0, 0);
          operands[3] = x31;
          if (!immediate_operand (operands[3], E_SImode)
              || !
#line 1281 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 469; /* vld32wl_insn */

        case MEM:
          x19 = XEXP (x10, 0);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != E_SImode)
            return -1;
          x32 = XEXP (x19, 1);
          if (GET_CODE (x32) != ZERO_EXTEND
              || GET_MODE (x32) != E_SImode)
            return -1;
          x33 = XEXP (x32, 0);
          if (GET_CODE (x33) != VEC_SELECT
              || GET_MODE (x33) != E_HImode)
            return -1;
          x34 = XEXP (x33, 1);
          if (GET_CODE (x34) != PARALLEL
              || XVECLEN (x34, 0) != 1)
            return -1;
          x25 = XEXP (x19, 0);
          operands[1] = x25;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x35 = XEXP (x33, 0);
          operands[2] = x35;
          if (!vector_register_operand (operands[2], E_V8HImode))
            return -1;
          x36 = XVECEXP (x34, 0, 0);
          operands[3] = x36;
          if (!immediate_operand (operands[3], E_SImode)
              || !
#line 1317 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 471; /* vld64_insn */

        case VEC_CONCAT:
          x19 = XEXP (x10, 0);
          if (GET_CODE (x19) != VEC_SELECT
              || GET_MODE (x19) != E_V2HImode)
            return -1;
          x32 = XEXP (x19, 1);
          if (GET_CODE (x32) != PARALLEL
              || XVECLEN (x32, 0) != 2)
            return -1;
          x37 = XVECEXP (x32, 0, 0);
          if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x38 = XVECEXP (x32, 0, 1);
          if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x11 = XEXP (x10, 1);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_V2HImode)
            return -1;
          x39 = XEXP (x11, 0);
          if (GET_CODE (x39) != PLUS
              || GET_MODE (x39) != E_SImode)
            return -1;
          x40 = XEXP (x39, 1);
          if (GET_CODE (x40) != ZERO_EXTEND
              || GET_MODE (x40) != E_SImode)
            return -1;
          x41 = XEXP (x40, 0);
          if (GET_CODE (x41) != VEC_SELECT
              || GET_MODE (x41) != E_HImode)
            return -1;
          x42 = XEXP (x41, 1);
          if (GET_CODE (x42) != PARALLEL
              || XVECLEN (x42, 0) != 1)
            return -1;
          x43 = XEXP (x39, 0);
          operands[1] = x43;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x44 = XEXP (x41, 0);
          operands[2] = x44;
          if (!vector_register_operand (operands[2], E_V8HImode))
            return -1;
          x45 = XVECEXP (x42, 0, 0);
          operands[3] = x45;
          if (!immediate_operand (operands[3], E_SImode))
            return -1;
          x25 = XEXP (x19, 0);
          if (!rtx_equal_p (x25, operands[0])
              || !
#line 1340 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 472; /* vld32_insn */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern21 (x3, 
MINUS))
        {
        case 0:
          if (!
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
            return -1;
          return 486; /* addsubv2hi3 */

        case 1:
          if (!
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
            return -1;
          return 487; /* addsubv2si3 */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern21 (x3, 
PLUS))
        {
        case 0:
          if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
            return -1;
          return 488; /* subaddv2hi3 */

        case 1:
          if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
            return -1;
          return 489; /* subaddv2si3 */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (GET_MODE (x4) != E_V2HImode)
        return -1;
      x10 = XEXP (x3, 1);
      if (GET_CODE (x10) != VEC_CONCAT
          || GET_MODE (x10) != E_V2HImode
          || !even_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x20 = XEXP (x4, 1);
      if (GET_MODE (x20) != E_HImode)
        return -1;
      x19 = XEXP (x10, 0);
      if (GET_MODE (x19) != E_HImode)
        return -1;
      x11 = XEXP (x10, 1);
      if (GET_MODE (x11) != E_HImode)
        return -1;
      switch (GET_CODE (x5))
        {
        case PLUS:
          if (pattern107 (x3, 
MINUS, 
PLUS) != 0
              || !
#line 1583 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 490; /* addsubv4hi3 */

        case MINUS:
          if (pattern107 (x3, 
PLUS, 
MINUS) != 0
              || !
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 491; /* subaddv4hi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!dest_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 117; /* negsi2 */

    case E_SFmode:
      if (!dest_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 225; /* negsf2 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !
#line 2036 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
        return -1;
      return 520; /* *negv2hi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !(
#line 2036 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY) && 
#line 1399 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
        return -1;
      return 521; /* *negv4hi2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !(
#line 2036 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY) && 
#line 1400 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
        return -1;
      return 522; /* *negv2si2 */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ZERO_EXTRACT
              || GET_MODE (x10) != E_SImode)
            return -1;
          x11 = XEXP (x2, 0);
          operands[4] = x11;
          if (!cc_set_register (operands[4], E_VOIDmode)
              || GET_MODE (x3) != E_CC_Zmode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          x15 = XEXP (x10, 2);
          if (!rtx_equal_p (x15, operands[3])
              || !
#line 895 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_HS && TARGET_BARREL_SHIFTER))
            return -1;
          return 15; /* *xbfu_cmp0 */

        case CLOBBER:
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          if (!cc_set_register (operands[0], E_CC_ZNmode))
            return -1;
          operands[5] = x3;
          if (!zn_compare_operator (operands[5], E_VOIDmode))
            return -1;
          x12 = XEXP (x9, 0);
          operands[4] = x12;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          return 23; /* *tst_bitfield */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (pattern51 (x1) == 0)
            {
              operands[1] = x4;
              if (nonmemory_operand (operands[1], E_SImode))
                {
                  x9 = XVECEXP (x1, 0, 1);
                  x12 = XEXP (x9, 0);
                  operands[0] = x12;
                  if (register_operand (operands[0], E_SImode))
                    {
                      x10 = XEXP (x9, 1);
                      if (rtx_equal_p (x10, operands[1]))
                        return 16; /* *movsi_set_cc_insn */
                    }
                }
            }
          break;

        case REG:
        case SUBREG:
          res = recog_32 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 61)
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != MINUS
              || GET_MODE (x10) != E_SImode
              || GET_MODE (x11) != E_CCmode
              || GET_MODE (x3) != E_CCmode)
            return -1;
          operands[1] = x4;
          if (!nonmemory_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!dest_reg_operand (operands[0], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2])
              || !
#line 2988 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[1], SImode)
   || register_operand (operands[2], SImode)))
            return -1;
          return 102; /* sub_f */

        case CLOBBER:
          if (GET_MODE (x11) != E_CC_FPXmode
              || GET_MODE (x3) != E_CC_FPXmode)
            return -1;
          operands[0] = x4;
          if (!nonmemory_operand (operands[0], E_DFmode))
            return -1;
          operands[1] = x5;
          if (!nonmemory_operand (operands[1], E_DFmode))
            return -1;
          x12 = XEXP (x9, 0);
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_DFmode)
              || !
#line 124 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_ARGONAUT_SET && TARGET_DPFP))
            return -1;
          return 308; /* cmpdfpx_raw */

        default:
          return -1;
        }

    case NEG:
    case NOT:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case ABS:
    case SS_NEG:
    case SS_TRUNCATE:
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x12 = XEXP (x9, 0);
      if (!register_operand (x12, E_SImode))
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_MODE (x10) == E_SImode)
        {
          res = recog_33 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x12;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XEXP (x2, 0);
      operands[2] = x11;
      if (!cc_register (operands[2], E_VOIDmode))
        return -1;
      operands[4] = x3;
      if (!zn_compare_operator (operands[4], E_VOIDmode))
        return -1;
      operands[3] = x4;
      if (!unary_operator (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode)
          || !rtx_equal_p (x10, operands[3]))
        return -1;
      return 18; /* *unary_comparison_result_used */

    case PLUS:
    case MULT:
    case AND:
    case IOR:
    case XOR:
    case SS_PLUS:
      x5 = XEXP (x3, 1);
      if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          if (GET_CODE (x4) == AND
              && GET_MODE (x4) == E_SImode)
            {
              res = recog_34 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) == SET)
            {
              x11 = XEXP (x2, 0);
              operands[3] = x11;
              if (cc_set_register (operands[3], E_VOIDmode))
                {
                  operands[5] = x3;
                  if (zn_compare_operator (operands[5], E_VOIDmode))
                    {
                      operands[4] = x4;
                      if (commutative_operator (operands[4], E_SImode)
                          && pattern99 (x1) == 0)
                        return 25; /* *commutative_binary_cmp0 */
                    }
                }
            }
        }
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      switch (GET_CODE (x4))
        {
        case PLUS:
        case AND:
        case IOR:
        case XOR:
        case SS_PLUS:
          operands[4] = x4;
          if (commutative_operator_sans_mult (operands[4], E_SImode)
              && pattern100 (x1) == 0)
            return 29; /* *commutative_binary_comparison_result_used */
          if (GET_CODE (x4) != PLUS
              || GET_MODE (x4) != E_SImode)
            return -1;
          x11 = XEXP (x2, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 61
              || GET_MODE (x11) != E_CC_Cmode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS
              || GET_MODE (x10) != E_SImode
              || GET_MODE (x3) != E_CC_Cmode
              || !dest_reg_operand (operands[0], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x14 = XEXP (x10, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          if (nonmemory_operand (operands[1], E_SImode)
              && rtx_equal_p (x5, operands[1])
              && 
#line 2745 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[1], SImode)
   || register_operand (operands[2], SImode)))
            return 95; /* add_f */
          if (!register_operand (operands[1], E_SImode)
              || !rtx_equal_p (x5, operands[2]))
            return -1;
          return 96; /* *add_f_2 */

        case MULT:
          operands[4] = x4;
          if (!mult_operator (operands[4], E_SImode)
              || pattern100 (x1) != 0
              || !
#line 1166 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_ARC600_FAMILY))
            return -1;
          return 30; /* *commutative_binary_mult_comparison_result_used */

        default:
          return -1;
        }

    case MINUS:
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
    case SS_MINUS:
      operands[4] = x4;
      if (noncommutative_operator (operands[4], E_SImode))
        {
          x5 = XEXP (x3, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x9 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x9) == SET)
                {
                  x11 = XEXP (x2, 0);
                  operands[3] = x11;
                  if (cc_set_register (operands[3], E_VOIDmode))
                    {
                      operands[5] = x3;
                      if (zn_compare_operator (operands[5], E_VOIDmode)
                          && pattern99 (x1) == 0)
                        return 31; /* *noncommutative_binary_cmp0 */
                    }
                }
            }
        }
      if (GET_CODE (x4) != MINUS
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != MINUS
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XEXP (x2, 0);
      operands[4] = x11;
      if (!cc_set_register (operands[4], E_VOIDmode))
        return -1;
      operands[3] = x3;
      if (!zn_compare_operator (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x9, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x10, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x10, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      return 33; /* *rsub_cmp0 */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2)
    return NULL;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case SIGN_EXTEND:
          if (peep2_current_count < 3
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!any_mem_operand (operands[1], E_QImode))
            return NULL;
          x6 = XEXP (x2, 1);
          if (GET_CODE (x6) != COMPARE
              || GET_MODE (x6) != E_CC_ZNmode)
            return NULL;
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 61
              || GET_MODE (x8) != E_CC_ZNmode)
            return NULL;
          x9 = XEXP (x6, 0);
          if (!rtx_equal_p (x9, operands[0]))
            return NULL;
          x10 = PATTERN (peep2_next_insn (2));
          if (GET_CODE (x10) != SET)
            return NULL;
          x11 = XEXP (x10, 1);
          if (GET_CODE (x11) != IF_THEN_ELSE)
            return NULL;
          x12 = XEXP (x11, 0);
          if (!ge_lt_comparison_operator (x12, E_VOIDmode))
            return NULL;
          operands[2] = x12;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 61
              || GET_MODE (x13) != E_CC_ZNmode)
            return NULL;
          x14 = XEXP (x12, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != PC)
            return NULL;
          x16 = XEXP (x11, 1);
          operands[3] = x16;
          x17 = XEXP (x11, 2);
          operands[4] = x17;
          if (!
#line 1675 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_CMEM
   && cmem_address (XEXP (operands[1], 0), SImode)
   && peep2_reg_dead_p (2, operands[0])
   && peep2_regno_dead_p (3, CC_REG)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_1 (insn, operands);

        case CONST_INT:
          operands[1] = x3;
          if (!const_int_operand (operands[1], E_SImode))
            return NULL;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!compact_register_operand (operands[0], E_SImode))
            return NULL;
          x6 = XEXP (x2, 1);
          if (GET_CODE (x6) != IF_THEN_ELSE
              || GET_MODE (x6) != E_SImode)
            return NULL;
          x9 = XEXP (x6, 0);
          if (!proper_comparison_operator (x9, E_VOIDmode))
            return NULL;
          operands[3] = x9;
          x18 = XEXP (x9, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x19 = XEXP (x9, 0);
          operands[4] = x19;
          if (!cc_register (operands[4], E_VOIDmode))
            return NULL;
          x7 = XEXP (x6, 1);
          operands[2] = x7;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x20 = XEXP (x6, 2);
          if (!rtx_equal_p (x20, operands[0]))
            return NULL;
          x8 = XEXP (x2, 0);
          if (!rtx_equal_p (x8, operands[0])
              || !
#line 1707 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!satisfies_constraint_P (operands[1])
   && satisfies_constraint_P (operands[2])
   && UNSIGNED_INT6 (INTVAL (operands[2]) - INTVAL (operands[1]))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_2 (insn, operands);

        case PLUS:
          x5 = XEXP (x3, 0);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[1] = x5;
              if (!register_operand (operands[1], E_SImode))
                return NULL;
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              if (!dest_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return NULL;
              x21 = XEXP (x3, 1);
              operands[2] = x21;
              if (!nonmemory_operand (operands[2], E_SImode)
                  || pattern94 (x2, 
E_CC_Cmode) != 0)
                return NULL;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 1);
              operands[3] = x7;
              if (!nonmemory_operand (operands[3], E_SImode))
                return NULL;
              x9 = XEXP (x6, 0);
              if (!rtx_equal_p (x9, operands[0])
                  || !
#line 2836 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(rtx_equal_p (operands[1], operands[3])
   || rtx_equal_p (operands[2], operands[3])))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_3 (insn, operands);

            case MULT:
              if (GET_MODE (x5) != E_DImode)
                return NULL;
              x21 = XEXP (x3, 1);
              if (GET_CODE (x21) != REG
                  || REGNO (x21) != 58
                  || GET_MODE (x21) != E_DImode
                  || pattern34 (x1, 
58, 
E_DImode) != 0)
                return NULL;
              x22 = XEXP (x5, 0);
              if (GET_MODE (x22) != E_DImode)
                return NULL;
              x23 = XEXP (x5, 1);
              if (GET_MODE (x23) != E_DImode)
                return NULL;
              x8 = XEXP (x2, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x6 = XEXP (x2, 1);
              operands[3] = x6;
              if (!accl_operand (operands[3], E_SImode))
                return NULL;
              switch (GET_CODE (x22))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x23) != SIGN_EXTEND)
                    return NULL;
                  x24 = XEXP (x22, 0);
                  operands[0] = x24;
                  if (!register_operand (operands[0], E_SImode))
                    return NULL;
                  x25 = XEXP (x23, 0);
                  operands[1] = x25;
                  if (!extend_operand (operands[1], E_SImode)
                      || !
#line 6422 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_13 (insn, operands);

                case ZERO_EXTEND:
                  if (GET_CODE (x23) != ZERO_EXTEND)
                    return NULL;
                  x24 = XEXP (x22, 0);
                  operands[0] = x24;
                  if (!register_operand (operands[0], E_SImode))
                    return NULL;
                  x25 = XEXP (x23, 0);
                  operands[1] = x25;
                  if (!extend_operand (operands[1], E_SImode)
                      || !
#line 6524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_14 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case COMPARE:
          if (GET_MODE (x3) != E_CCmode)
            return NULL;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 61
              || GET_MODE (x4) != E_CCmode)
            return NULL;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x21 = XEXP (x3, 1);
          operands[2] = x21;
          if (!nonmemory_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x2, 1);
          if (GET_CODE (x6) == MINUS
              && GET_MODE (x6) == E_SImode)
            {
              x8 = XEXP (x2, 0);
              operands[0] = x8;
              if (dest_reg_operand (operands[0], E_SImode))
                {
                  x9 = XEXP (x6, 0);
                  if (rtx_equal_p (x9, operands[1]))
                    {
                      x7 = XEXP (x6, 1);
                      if (rtx_equal_p (x7, operands[2]))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_4 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          if (peep2_current_count < 3)
            return NULL;
          x8 = XEXP (x2, 0);
          operands[3] = x8;
          operands[4] = x6;
          x10 = PATTERN (peep2_next_insn (2));
          if (GET_CODE (x10) != SET)
            return NULL;
          x11 = XEXP (x10, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x11) != E_SImode)
            return NULL;
          x15 = XEXP (x10, 0);
          operands[0] = x15;
          if (!dest_reg_operand (operands[0], E_SImode))
            return NULL;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return NULL;
          x16 = XEXP (x11, 1);
          if (!rtx_equal_p (x16, operands[2])
              || !
#line 3020 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!reg_overlap_mentioned_p (operands[3], operands[1])
   && !reg_overlap_mentioned_p (operands[3], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[4])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_5 (insn, operands);

        case ASHIFT:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x21 = XEXP (x3, 1);
          operands[2] = x21;
          if (dest_reg_operand (operands[0], E_SImode))
            {
              x8 = XEXP (x2, 0);
              operands[3] = x8;
              if (dest_reg_operand (operands[3], E_SImode))
                {
                  x6 = XEXP (x2, 1);
                  if (GET_MODE (x6) == E_SImode)
                    {
                      if (GET_CODE (x6) == PLUS
                          && _1_2_3_operand (operands[2], E_SImode))
                        {
                          x9 = XEXP (x6, 0);
                          operands[4] = x9;
                          if (arc_nonmemory_operand (operands[4], E_SImode))
                            {
                              x7 = XEXP (x6, 1);
                              operands[5] = x7;
                              if (arc_nonmemory_operand (operands[5], E_SImode)
                                  && 
#line 4439 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
((true_regnum (operands[4]) == true_regnum (operands[0])
       || true_regnum (operands[5]) == true_regnum (operands[0]))
   && (peep2_reg_dead_p (2, operands[0])
       || (true_regnum (operands[3]) == true_regnum (operands[0])))))
                                {
                                  *pmatch_len_ = 1;
                                  res = gen_peephole2_6 (insn, operands);
                                  if (res != NULL_RTX)
                                    return res;
                                }
                            }
                        }
                      if (GET_CODE (x6) == MINUS
                          && const_int_operand (operands[2], E_SImode))
                        {
                          x9 = XEXP (x6, 0);
                          operands[4] = x9;
                          if (nonmemory_operand (operands[4], E_SImode))
                            {
                              x7 = XEXP (x6, 1);
                              if (rtx_equal_p (x7, operands[0])
                                  && 
#line 4475 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
((INTVAL (operands[2]) == 1
    || INTVAL (operands[2]) == 2
    || INTVAL (operands[2]) == 3)
   && (peep2_reg_dead_p (2, operands[0])
       || (true_regnum (operands[3]) == true_regnum (operands[0])))))
                                {
                                  *pmatch_len_ = 1;
                                  res = gen_peephole2_7 (insn, operands);
                                  if (res != NULL_RTX)
                                    return res;
                                }
                            }
                        }
                    }
                }
            }
          if (!_1_2_3_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || pattern94 (x2, 
E_CCmode) != 0)
            return NULL;
          x6 = XEXP (x2, 1);
          x9 = XEXP (x6, 0);
          operands[3] = x9;
          if (!register_operand (operands[3], E_SImode))
            return NULL;
          x7 = XEXP (x6, 1);
          if (!rtx_equal_p (x7, operands[0])
              || !
#line 6673 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_15 (insn, operands);

        case LSHIFTRT:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x21 = XEXP (x3, 1);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
            return NULL;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!dest_reg_operand (operands[0], E_SImode))
            return NULL;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x2, 1);
          if (GET_CODE (x6) != MULT
              || GET_MODE (x6) != E_SImode)
            return NULL;
          x8 = XEXP (x2, 0);
          operands[4] = x8;
          if (!register_operand (operands[4], E_SImode))
            return NULL;
          x9 = XEXP (x6, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return NULL;
          x7 = XEXP (x6, 1);
          operands[3] = x7;
          if (!nonmemory_operand (operands[3], E_SImode))
            return NULL;
          if (
#line 4499 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_ARC700_MPY
   && (rtx_equal_p (operands[0], operands[2])
       || rtx_equal_p (operands[0], operands[3]))
   && peep2_regno_dead_p (0, CC_REG)
   && (rtx_equal_p (operands[0], operands[4])
       || (peep2_reg_dead_p (2, operands[0])
	  && peep2_reg_dead_p (1, operands[4])))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_8 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!
#line 4529 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_ARC700_MPY
   && (rtx_equal_p (operands[0], operands[2])
       || rtx_equal_p (operands[0], operands[3]))
   && peep2_regno_dead_p (2, CC_REG)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_9 (insn, operands);

        case REG:
        case SUBREG:
        case MEM:
          if (peep2_current_count >= 3)
            {
              res = peephole2_1 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x1, 0);
              operands[2] = x4;
              if (memory_operand (operands[2], E_SImode))
                {
                  x8 = XEXP (x2, 0);
                  operands[3] = x8;
                  if (memory_operand (operands[3], E_SImode))
                    {
                      x6 = XEXP (x2, 1);
                      operands[1] = x6;
                      if (register_operand (operands[1], E_SImode)
                          && 
#line 6682 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_LL64))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_16 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          operands[2] = x3;
          if (!memory_operand (operands[2], E_SImode))
            return NULL;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x8 = XEXP (x2, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (!memory_operand (operands[3], E_SImode))
            return NULL;
          if (
#line 6698 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_LL64))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_17 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 3)
            return NULL;
          x10 = PATTERN (peep2_next_insn (2));
          if (GET_CODE (x10) != SET)
            return NULL;
          x11 = XEXP (x10, 1);
          if (!commutative_operator (x11, E_SImode))
            return NULL;
          operands[5] = x11;
          x15 = XEXP (x10, 0);
          operands[4] = x15;
          if (!register_operand (operands[4], E_SImode))
            return NULL;
          x12 = XEXP (x11, 0);
          operands[6] = x12;
          if (!register_operand (operands[6], E_VOIDmode))
            return NULL;
          x16 = XEXP (x11, 1);
          operands[7] = x16;
          if (!register_operand (operands[7], E_VOIDmode)
              || !
#line 6722 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_LL64
   && (((rtx_equal_p (operands[0], operands[6]))
	 && (rtx_equal_p (operands[1], operands[7])))
	|| ((rtx_equal_p (operands[0], operands[7]))
	     && (rtx_equal_p (operands[1], operands[6]))))
   && (peep2_reg_dead_p (3, operands[0])
       || rtx_equal_p (operands[0], operands[4]))
   && (peep2_reg_dead_p (3, operands[1])
       || rtx_equal_p (operands[1], operands[4]))))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_18 (insn, operands);

        case ZERO_EXTRACT:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x21 = XEXP (x3, 1);
          operands[1] = x21;
          if (!const_int_operand (operands[1], E_SImode))
            return NULL;
          x26 = XEXP (x3, 2);
          operands[2] = x26;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x5 = XEXP (x3, 0);
          if (!rtx_equal_p (x5, operands[0]))
            return NULL;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != ZERO_EXTRACT
              || GET_MODE (x8) != E_SImode)
            return NULL;
          x27 = XEXP (x8, 0);
          operands[3] = x27;
          if (!register_operand (operands[3], E_SImode))
            return NULL;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[0]))
            return NULL;
          x28 = XEXP (x8, 1);
          if (!rtx_equal_p (x28, operands[1]))
            return NULL;
          x29 = XEXP (x8, 2);
          if (!rtx_equal_p (x29, operands[2])
              || !
#line 6269 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_12 (insn, operands);

        default:
          return NULL;
        }

    case PARALLEL:
      if (XVECLEN (x1, 0) != 4)
        return NULL;
      x30 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x30) != SET)
        return NULL;
      x31 = XEXP (x30, 1);
      if (!arc_dpfp_operator (x31, E_DFmode))
        return NULL;
      operands[1] = x31;
      x32 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x32) != USE)
        return NULL;
      x33 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x33) != USE)
        return NULL;
      x34 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x34) != USE)
        return NULL;
      x35 = XEXP (x30, 0);
      operands[0] = x35;
      if (!register_operand (operands[0], E_DFmode))
        return NULL;
      x36 = XEXP (x31, 0);
      operands[2] = x36;
      if (!nonmemory_operand (operands[2], E_DFmode))
        return NULL;
      x37 = XEXP (x31, 1);
      operands[3] = x37;
      if (!nonmemory_operand (operands[3], E_DFmode))
        return NULL;
      x38 = XEXP (x32, 0);
      operands[4] = x38;
      x39 = XEXP (x33, 0);
      operands[5] = x39;
      x40 = XEXP (x34, 0);
      operands[6] = x40;
      x8 = XEXP (x2, 0);
      operands[7] = x8;
      if (!register_operand (operands[7], E_DFmode))
        return NULL;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[0]))
        return NULL;
      if (peep2_current_count >= 3)
        {
          x10 = PATTERN (peep2_next_insn (2));
          if (GET_CODE (x10) == SET)
            {
              x11 = XEXP (x10, 1);
              operands[8] = x11;
              if (register_operand (operands[8], E_DFmode))
                {
                  x15 = XEXP (x10, 0);
                  if (rtx_equal_p (x15, operands[0])
                      && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP && !TARGET_DPFP_DISABLE_LRSR))
                    {
                      *pmatch_len_ = 2;
                      res = gen_peephole2_19 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
      if (!
#line 505 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP  && !TARGET_DPFP_DISABLE_LRSR))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_20 (insn, operands);

    default:
      return NULL;
    }
}
