/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!vector_register_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!vector_register_operand (operands[1], E_V8HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[3] = x8;
  if (!dest_reg_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x5, 1);
  operands[2] = x10;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x11 = XEXP (x6, 0);
  operands[0] = x11;
  if (!dest_reg_operand (operands[0], E_SImode))
    return -1;
  x12 = XEXP (x7, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x7, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  switch (GET_MODE (operands[4]))
    {
    case E_QImode:
      if (!any_mem_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!any_mem_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 58
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[2] = x8;
  return 0;
}

int
pattern52 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      return 0;

    case VEC_SELECT:
      if (GET_MODE (x6) != E_HImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != i1
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != VEC_SELECT
          || GET_MODE (x10) != E_HImode)
        return -1;
      x11 = XEXP (x10, 1);
      if (GET_CODE (x11) != PARALLEL
          || XVECLEN (x11, 0) != 1)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x3, 1);
      if (GET_CODE (x13) != MULT
          || GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != i1
          || GET_MODE (x14) != E_SImode)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != VEC_SELECT
          || GET_MODE (x15) != E_HImode)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != PARALLEL
          || XVECLEN (x16, 0) != 1)
        return -1;
      x17 = XVECEXP (x16, 0, 0);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x18 = XEXP (x13, 1);
      if (GET_CODE (x18) != i1
          || GET_MODE (x18) != E_SImode)
        return -1;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != VEC_SELECT
          || GET_MODE (x19) != E_HImode)
        return -1;
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != PARALLEL
          || XVECLEN (x20, 0) != 1)
        return -1;
      x21 = XVECEXP (x20, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x22) != SET)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != ZERO_EXTEND
          || GET_MODE (x23) != E_DImode)
        return -1;
      x24 = XEXP (x23, 0);
      if (GET_CODE (x24) != PLUS
          || GET_MODE (x24) != E_SImode)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != MULT
          || GET_MODE (x25) != E_SImode)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != i1
          || GET_MODE (x26) != E_SImode)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != VEC_SELECT
          || GET_MODE (x27) != E_HImode)
        return -1;
      x28 = XEXP (x27, 1);
      if (GET_CODE (x28) != PARALLEL
          || XVECLEN (x28, 0) != 1)
        return -1;
      x29 = XVECEXP (x28, 0, 0);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x30 = XEXP (x25, 1);
      if (GET_CODE (x30) != i1
          || GET_MODE (x30) != E_SImode)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != VEC_SELECT
          || GET_MODE (x31) != E_HImode)
        return -1;
      x32 = XEXP (x31, 1);
      if (GET_CODE (x32) != PARALLEL
          || XVECLEN (x32, 0) != 1)
        return -1;
      x33 = XVECEXP (x32, 0, 0);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x34 = XEXP (x24, 1);
      if (GET_CODE (x34) != MULT
          || GET_MODE (x34) != E_SImode)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != i1
          || GET_MODE (x35) != E_SImode)
        return -1;
      x36 = XEXP (x35, 0);
      if (GET_CODE (x36) != VEC_SELECT
          || GET_MODE (x36) != E_HImode)
        return -1;
      x37 = XEXP (x36, 1);
      if (GET_CODE (x37) != PARALLEL
          || XVECLEN (x37, 0) != 1)
        return -1;
      x38 = XVECEXP (x37, 0, 0);
      if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x39 = XEXP (x34, 1);
      if (GET_CODE (x39) != i1
          || GET_MODE (x39) != E_SImode)
        return -1;
      x40 = XEXP (x39, 0);
      if (GET_CODE (x40) != VEC_SELECT
          || GET_MODE (x40) != E_HImode)
        return -1;
      x41 = XEXP (x40, 1);
      if (GET_CODE (x41) != PARALLEL
          || XVECLEN (x41, 0) != 1)
        return -1;
      x42 = XVECEXP (x41, 0, 0);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x43 = XEXP (x22, 0);
      if (GET_CODE (x43) != REG
          || REGNO (x43) != 58
          || GET_MODE (x43) != E_DImode)
        return -1;
      x44 = XEXP (x2, 0);
      operands[0] = x44;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode)
        return -1;
      x45 = XEXP (x6, 0);
      operands[1] = x45;
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      x46 = XEXP (x10, 0);
      operands[2] = x46;
      if (!register_operand (operands[2], E_V2HImode))
        return -1;
      x47 = XEXP (x15, 0);
      if (!rtx_equal_p (x47, operands[1]))
        return -1;
      x48 = XEXP (x19, 0);
      if (!rtx_equal_p (x48, operands[2]))
        return -1;
      x49 = XEXP (x27, 0);
      if (!rtx_equal_p (x49, operands[1]))
        return -1;
      x50 = XEXP (x31, 0);
      if (!rtx_equal_p (x50, operands[2]))
        return -1;
      x51 = XEXP (x36, 0);
      if (!rtx_equal_p (x51, operands[1]))
        return -1;
      x52 = XEXP (x40, 0);
      if (!rtx_equal_p (x52, operands[2]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2SImode
      || !even_register_operand (operands[0], E_V2SImode)
      || !register_operand (operands[1], E_V2HImode)
      || !register_operand (operands[2], E_V2HImode))
    return -1;
  return 0;
}

int
pattern122 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != VEC_SELECT
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PARALLEL
      || XVECLEN (x8, 0) != 1)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x2, 1);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != VEC_SELECT
      || GET_MODE (x11) != E_HImode)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != PARALLEL
      || XVECLEN (x12, 0) != 1)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XEXP (x10, 1);
  if (GET_CODE (x14) != VEC_SELECT
      || GET_MODE (x14) != E_HImode)
    return -1;
  x15 = XEXP (x14, 1);
  if (GET_CODE (x15) != PARALLEL
      || XVECLEN (x15, 0) != 1)
    return -1;
  x16 = XVECEXP (x15, 0, 0);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x17 = XEXP (x1, 1);
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != i2)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != VEC_SELECT
      || GET_MODE (x19) != E_HImode)
    return -1;
  x20 = XEXP (x19, 1);
  if (GET_CODE (x20) != PARALLEL
      || XVECLEN (x20, 0) != 1)
    return -1;
  x21 = XVECEXP (x20, 0, 0);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x22 = XEXP (x18, 1);
  if (GET_CODE (x22) != VEC_SELECT
      || GET_MODE (x22) != E_HImode)
    return -1;
  x23 = XEXP (x22, 1);
  if (GET_CODE (x23) != PARALLEL
      || XVECLEN (x23, 0) != 1)
    return -1;
  x24 = XVECEXP (x23, 0, 0);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x25 = XEXP (x17, 1);
  if (GET_CODE (x25) != i1)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != VEC_SELECT
      || GET_MODE (x26) != E_HImode)
    return -1;
  x27 = XEXP (x26, 1);
  if (GET_CODE (x27) != PARALLEL
      || XVECLEN (x27, 0) != 1)
    return -1;
  x28 = XVECEXP (x27, 0, 0);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x29 = XEXP (x25, 1);
  if (GET_CODE (x29) != VEC_SELECT
      || GET_MODE (x29) != E_HImode)
    return -1;
  x30 = XEXP (x29, 1);
  if (GET_CODE (x30) != PARALLEL
      || XVECLEN (x30, 0) != 1)
    return -1;
  x31 = XVECEXP (x30, 0, 0);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x32 = XEXP (x4, 0);
  operands[1] = x32;
  if (!even_register_operand (operands[1], E_V4HImode))
    return -1;
  x33 = XEXP (x7, 0);
  operands[2] = x33;
  if (!even_register_operand (operands[2], E_V4HImode))
    return -1;
  x34 = XEXP (x11, 0);
  if (!rtx_equal_p (x34, operands[1]))
    return -1;
  x35 = XEXP (x14, 0);
  if (!rtx_equal_p (x35, operands[2]))
    return -1;
  x36 = XEXP (x19, 0);
  if (!rtx_equal_p (x36, operands[1]))
    return -1;
  x37 = XEXP (x22, 0);
  if (!rtx_equal_p (x37, operands[2]))
    return -1;
  x38 = XEXP (x26, 0);
  if (!rtx_equal_p (x38, operands[1]))
    return -1;
  x39 = XEXP (x29, 0);
  if (!rtx_equal_p (x39, operands[2]))
    return -1;
  return 0;
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[0] = x2;
      if (!dest_reg_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      if (arc_nonmemory_operand (operands[1], E_SImode)
          && 
#line 3426 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER
   && (register_operand (operands[1], SImode)
       || register_operand (operands[2], SImode))))
        return 121; /* *ashrsi3_insn */
      if (!register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 3504 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx
   && arc_pre_reload_split ()))
        return 129; /* *ashrsi3_nobs */
      if (pnum_clobbers == NULL
          || !
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx))
        return -1;
      *pnum_clobbers = 2;
      return 134; /* ashrsi3_loop */

    case ZERO_EXTRACT:
      if (pattern19 (x1) != 0
          || !
#line 6017 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS
   && INTVAL (operands[4]) + INTVAL (operands[1]) <= 32))
        return -1;
      return 259; /* *movb_high_signed */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x6;
      operands[3] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (register_operand (operands[0], E_SFmode)
              && GET_MODE (x2) == E_SFmode
              && nonmemory_operand (operands[1], E_SFmode)
              && nonmemory_operand (operands[2], E_SFmode)
              && accl_operand (operands[3], E_SFmode)
              && 
#line 93 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_FUSED
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode))))
            return 334; /* fmasf4_fpu */
          break;

        case E_DFmode:
          if (pnum_clobbers != NULL
              && even_register_operand (operands[0], E_DFmode)
              && GET_MODE (x2) == E_DFmode
              && even_register_operand (operands[1], E_DFmode)
              && even_register_operand (operands[2], E_DFmode)
              && even_register_operand (operands[3], E_DFmode)
              && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_FUSED))
            {
              *pnum_clobbers = 1;
              return 336; /* fmadf4_split */
            }
          break;

        default:
          break;
        }
      if (!even_register_operand (operands[1], E_DFmode)
          || REGNO (x3) != 58
          || GET_MODE (x3) != E_DFmode
          || !even_register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || !even_register_operand (operands[2], E_DFmode)
          || !
#line 180 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_FUSED))
        return -1;
      return 338; /* fmadf4_fpu */

    case NEG:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      operands[3] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (register_operand (operands[0], E_SFmode)
              && GET_MODE (x2) == E_SFmode
              && GET_MODE (x6) == E_SFmode
              && nonmemory_operand (operands[1], E_SFmode)
              && nonmemory_operand (operands[2], E_SFmode)
              && accl_operand (operands[3], E_SFmode)
              && 
#line 108 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_FUSED
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode))))
            return 335; /* fnmasf4_fpu */
          break;

        case E_DFmode:
          if (pnum_clobbers != NULL
              && even_register_operand (operands[0], E_DFmode)
              && GET_MODE (x2) == E_DFmode
              && GET_MODE (x6) == E_DFmode
              && even_register_operand (operands[1], E_DFmode)
              && even_register_operand (operands[2], E_DFmode)
              && even_register_operand (operands[3], E_DFmode)
              && 
#line 164 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_FUSED))
            {
              *pnum_clobbers = 1;
              return 337; /* fnmadf4_split */
            }
          break;

        default:
          break;
        }
      if (!even_register_operand (operands[1], E_DFmode)
          || REGNO (x3) != 58
          || GET_MODE (x3) != E_DFmode
          || !even_register_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode
          || GET_MODE (x6) != E_DFmode
          || !even_register_operand (operands[2], E_DFmode)
          || !
#line 193 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_FUSED))
        return -1;
      return 339; /* fnmadf4_fpu */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case REG:
      operands[3] = x6;
      if (!vector_register_operand (operands[3], E_V8HImode))
        return -1;
      switch (XVECLEN (x3, 0))
        {
        case 4:
          x7 = XVECEXP (x3, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x3, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x9 = XVECEXP (x3, 0, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x10 = XVECEXP (x3, 0, 3);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x11 = XEXP (x5, 0);
          if (pattern55 (x11) != 0
              || GET_MODE (x4) != E_V4HImode)
            return -1;
          x12 = XEXP (x11, 0);
          x13 = XEXP (x12, 0);
          operands[0] = x13;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x14 = XEXP (x12, 1);
          x15 = XVECEXP (x14, 0, 0);
          operands[1] = x15;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x16 = XEXP (x5, 1);
          operands[2] = x16;
          if (!immediate_operand (operands[2], E_SImode)
              || GET_MODE (x2) != E_V4HImode
              || !
#line 206 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 373; /* vst64_insn */

        case 1:
          if (pattern84 (x1, 
E_HImode) != 0)
            return -1;
          x7 = XVECEXP (x3, 0, 0);
          operands[4] = x7;
          if (!immediate_operand (operands[4], E_SImode)
              || !
#line 1355 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 473; /* vst16_n_insn */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 156
          || GET_MODE (x6) != E_V4SImode
          || XVECLEN (x3, 0) != 1
          || pattern84 (x1, 
E_SImode) != 0)
        return -1;
      x17 = XVECEXP (x6, 0, 0);
      operands[3] = x17;
      if (!vector_register_operand (operands[3], E_V8HImode))
        return -1;
      x7 = XVECEXP (x3, 0, 0);
      operands[4] = x7;
      if (!immediate_operand (operands[4], E_SImode)
          || !
#line 1371 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 474; /* vst32_n_insn */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern18 (x3))
        {
        case 0:
          return 58; /* *zero_extendqihi2_i */

        case 1:
          return 59; /* *zero_extendqisi2_ac */

        case 2:
          return 60; /* *zero_extendhisi2_i */

        default:
          break;
        }
      if (GET_CODE (x4) != MEM
          || pattern6 (x4, 
ZERO_EXTEND, 
PLUS, 
E_V4HImode) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != VEC_SELECT
          || GET_MODE (x7) != E_HImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1
          || !vector_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!vector_register_operand (operands[1], E_V8HImode))
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      operands[2] = x10;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[3] = x11;
      if (!immediate_operand (operands[3], E_SImode)
          || !
#line 1296 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 470; /* vld64w_insn */

    case CLRSB:
      if (GET_MODE (x4) != E_HImode
          || !dest_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!general_operand (operands[1], E_HImode)
          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM))
        return -1;
      return 177; /* normw */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  switch (REGNO (x7))
    {
    case 56:
      if (!
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
        return -1;
      return 72; /* mulsi32x16 */

    case 58:
      if (!
#line 2189 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET))
        return -1;
      return 75; /* mulsi64 */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x3, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x11 = XEXP (x4, 0);
  operands[3] = x11;
  x12 = XEXP (x7, 0);
  operands[4] = x12;
  if (!cc_register (operands[4], E_VOIDmode)
      || !
#line 5051 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
((reload_completed
     || (TARGET_EARLY_CBRANCHSI
	 && brcc_nolimm_operator (operands[0], VOIDmode)))
    && !CROSSING_JUMP_P (insn)))
    return -1;
  return 208; /* cbranchsi4_scratch */
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case IF_THEN_ELSE:
      if (pattern29 (x1) != 0)
        return -1;
      return 211; /* loop_end */

    case PLUS:
      if (pattern30 (x1) != 0
          || !
#line 241 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP &&
   !(GET_CODE(operands[2]) == CONST_DOUBLE && GET_CODE(operands[3]) == CONST_INT)))
        return -1;
      return 316; /* adddf3_insn */

    case MULT:
      if (pattern30 (x1) != 0
          || !
#line 265 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP &&
   !(GET_CODE(operands[2]) == CONST_DOUBLE && GET_CODE(operands[3]) == CONST_INT)))
        return -1;
      return 317; /* muldf3_insn */

    case MINUS:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!arc_double_register_operand (operands[0], E_DFmode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!nonmemory_operand (operands[1], E_DFmode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!nonmemory_operand (operands[2], E_DFmode))
        return -1;
      x10 = XEXP (x4, 0);
      operands[3] = x10;
      x11 = XEXP (x5, 0);
      operands[4] = x11;
      x12 = XEXP (x6, 0);
      if (!rtx_equal_p (x12, operands[2])
          || !
#line 296 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_DPFP &&
   !(GET_CODE(operands[2]) == CONST_DOUBLE && GET_CODE(operands[3]) == CONST_INT) &&
   !(GET_CODE(operands[1]) == CONST_DOUBLE && GET_CODE(operands[3]) == CONST_INT)))
        return -1;
      return 318; /* subdf3_insn */

    default:
      return -1;
    }
}

 int
recog_47 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != RETURN)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 28
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 28
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != MEM
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x7, 0);
  if (GET_CODE (x9) != REG
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x8, 0);
  if (GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x4, 1);
  switch (GET_CODE (x11))
    {
    case REG:
      if (REGNO (x11) != 12
          || GET_MODE (x11) != E_SImode
          || GET_CODE (x10) != REG
          || REGNO (x10) != 28
          || REGNO (x9) != 13
          || !millicode_load_operation (operands[0], E_VOIDmode))
        return -1;
      return 228; /* *millicode_sibthunk_ld */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x11;
      if (!immediate_operand (operands[1], E_VOIDmode)
          || GET_CODE (x10) != PLUS)
        return -1;
      x12 = XEXP (x10, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 28
          || GET_MODE (x12) != E_SImode
          || !pop_multi_operand (operands[0], E_VOIDmode))
        return -1;
      x13 = XEXP (x10, 1);
      operands[2] = x13;
      if (!immediate_operand (operands[2], E_VOIDmode))
        return -1;
      switch (REGNO (x9))
        {
        case 13:
          if (!
#line 6873 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_CODE_DENSITY))
            return -1;
          return 301; /* *pop_multi_fp_ret */

        case 31:
          if (!
#line 6904 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_CODE_DENSITY))
            return -1;
          return 302; /* *pop_multi_fp_blink_ret */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          x7 = XEXP (x1, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern108 (x4) != 0)
                return -1;
              return 677; /* *p *addsi3_mixed */

            case E_SFmode:
              if (pattern104 (x4, 
E_SFmode) != 0
                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 12 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)))))
                return -1;
              return 763; /* *p *addsf3_fpu */

            case E_DFmode:
              if (pattern105 (x4) != 0
                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 280 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE)))
                return -1;
              return 773; /* *p *adddf3_fpu */

            case E_V2HImode:
              if (pattern109 (x4, 
E_V2HImode) != 0
                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY)))
                return -1;
              return 798; /* *p addv2hi3 */

            case E_V4HImode:
              if (pattern109 (x4, 
E_V4HImode) != 0
                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && (
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY) && 
#line 1399 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))))
                return -1;
              return 799; /* *p addv4hi3 */

            case E_V2SImode:
              if (pattern109 (x4, 
E_V2SImode) != 0
                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && (
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY) && 
#line 1400 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))))
                return -1;
              return 800; /* *p addv2si3 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          if (!register_operand (operands[0], E_SImode)
              || pattern103 (x4) != 0)
            return -1;
          return 761; /* *p *add_shift2 */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[4] = x7;
      if (!dest_reg_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      if (!_2_4_8_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!arc_nonmemory_operand (operands[3], E_SImode))
        return -1;
      return 695; /* *p *add_n */

    case ASHIFT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[4] = x7;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      if (!_1_2_3_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!arc_nonmemory_operand (operands[3], E_SImode))
        return -1;
      return 760; /* *p add_shift */

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_1 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case COMPARE:
              x4 = XEXP (x3, 1);
              if (GET_CODE (x4) != CONST_INT)
                return NULL;
              x5 = XEXP (x3, 0);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[1] = x5;
                  if (!nonmemory_operand (operands[1], E_SImode)
                      || pattern51 (x1) != 0)
                    return NULL;
                  x6 = XVECEXP (x1, 0, 1);
                  x7 = XEXP (x6, 0);
                  operands[0] = x7;
                  if (!register_operand (operands[0], E_SImode))
                    return NULL;
                  x8 = XEXP (x6, 1);
                  if (!rtx_equal_p (x8, operands[1])
                      || !
#line 917 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed && operands_match_p (operands[0], operands[1])))
                    return NULL;
                  return gen_split_2 (insn, operands);

                case AND:
                  if (GET_MODE (x5) != E_SImode)
                    return NULL;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != CLOBBER)
                    return NULL;
                  x9 = XEXP (x5, 0);
                  if (!register_operand (x9, E_SImode))
                    return NULL;
                  operands[1] = x9;
                  if (XWINT (x4, 0) == 0L)
                    {
                      x10 = XEXP (x2, 0);
                      operands[0] = x10;
                      if (cc_register (operands[0], E_VOIDmode))
                        {
                          operands[4] = x3;
                          if (zn_compare_operator (operands[4], E_VOIDmode))
                            {
                              x11 = XEXP (x5, 1);
                              operands[2] = x11;
                              if (nonmemory_operand (operands[2], E_SImode))
                                {
                                  x7 = XEXP (x6, 0);
                                  operands[3] = x7;
                                  if (scratch_operand (operands[3], E_SImode)
                                      && 
#line 966 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS && reload_completed
   && (extract_constrain_insn_cached (insn), (which_alternative & ~1) != 6)))
                                    return gen_split_3 (insn, operands);
                                }
                            }
                        }
                    }
                  operands[0] = x9;
                  x10 = XEXP (x2, 0);
                  if (GET_CODE (x10) != REG
                      || REGNO (x10) != 61
                      || GET_MODE (x10) != E_CC_Zmode
                      || GET_MODE (x3) != E_CC_Zmode)
                    return NULL;
                  x11 = XEXP (x5, 1);
                  operands[1] = x11;
                  if (!const_int_operand (operands[1], E_VOIDmode))
                    return NULL;
                  operands[2] = x4;
                  if (!const_int_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x7 = XEXP (x6, 0);
                  operands[3] = x7;
                  if (!register_operand (operands[3], E_SImode)
                      || !
#line 3266 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(((INTVAL (operands[1]) + 1) & INTVAL (operands[1])) == 0))
                    return NULL;
                  return gen_split_18 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
              operands[1] = x3;
              if (!arc_double_register_operand (operands[1], E_DFmode))
                return NULL;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != USE)
                return NULL;
              x10 = XEXP (x2, 0);
              operands[0] = x10;
              if (!register_operand (operands[0], E_DFmode))
                return NULL;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!(
#line 1377 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DPFP && TARGET_DPFP_DISABLE_LRSR) && 
#line 1379 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
                return NULL;
              return gen_split_6 (insn, operands);

            case MULT:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return NULL;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || GET_MODE (x7) != E_DImode)
                return NULL;
              x10 = XEXP (x2, 0);
              operands[0] = x10;
              x5 = XEXP (x3, 0);
              switch (GET_CODE (x5))
                {
                case REG:
                case SUBREG:
                  operands[1] = x5;
                  if (!register_operand (operands[1], E_SImode)
                      || !register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return NULL;
                  x4 = XEXP (x3, 1);
                  operands[2] = x4;
                  if (!nonmemory_operand (operands[2], E_SImode))
                    return NULL;
                  switch (REGNO (x7))
                    {
                    case 56:
                      if (!
#line 2122 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET && reload_completed))
                        return NULL;
                      return gen_split_7 (insn, operands);

                    case 58:
                      if (!
#line 2191 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET && reload_completed))
                        return NULL;
                      return gen_split_8 (insn, operands);

                    default:
                      return NULL;
                    }

                case SIGN_EXTEND:
                  switch (pattern80 (x1, 
SIGN_EXTEND))
                    {
                    case 0:
                      if (!
#line 2223 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET && reload_completed))
                        return NULL;
                      return gen_split_9 (insn, operands);

                    case 1:
                      if (!
#line 2378 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET && reload_completed))
                        return NULL;
                      return gen_split_11 (insn, operands);

                    default:
                      return NULL;
                    }

                case ZERO_EXTEND:
                  switch (pattern80 (x1, 
ZERO_EXTEND))
                    {
                    case 0:
                      if (!
#line 2258 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET && reload_completed))
                        return NULL;
                      return gen_split_10 (insn, operands);

                    case 1:
                      if (!
#line 2591 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET && reload_completed))
                        return NULL;
                      return gen_split_13 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case PLUS:
              if (GET_MODE (x3) != E_DImode)
                return NULL;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return NULL;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG)
                return NULL;
              x10 = XEXP (x2, 0);
              operands[0] = x10;
              if (!register_operand (operands[0], E_DImode))
                return NULL;
              x5 = XEXP (x3, 0);
              switch (GET_CODE (x5))
                {
                case REG:
                case SUBREG:
                  operands[1] = x5;
                  if (!register_operand (operands[1], E_DImode)
                      || REGNO (x7) != 61
                      || GET_MODE (x7) != E_CCmode)
                    return NULL;
                  x4 = XEXP (x3, 1);
                  operands[2] = x4;
                  if (!nonmemory_operand (operands[2], E_DImode)
                      || !(
#line 2694 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()) && 
#line 2696 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
                    return NULL;
                  return gen_split_15 (insn, operands);

                case MULT:
                  if (GET_MODE (x5) != E_DImode
                      || REGNO (x7) != 58
                      || GET_MODE (x7) != E_DImode)
                    return NULL;
                  x9 = XEXP (x5, 0);
                  if (GET_MODE (x9) != E_DImode)
                    return NULL;
                  x11 = XEXP (x5, 1);
                  if (GET_MODE (x11) != E_DImode)
                    return NULL;
                  x4 = XEXP (x3, 1);
                  operands[3] = x4;
                  if (!register_operand (operands[3], E_DImode))
                    return NULL;
                  switch (GET_CODE (x9))
                    {
                    case SIGN_EXTEND:
                      if (GET_CODE (x11) != SIGN_EXTEND)
                        return NULL;
                      x12 = XEXP (x9, 0);
                      operands[1] = x12;
                      if (!register_operand (operands[1], E_SImode))
                        return NULL;
                      x13 = XEXP (x11, 0);
                      operands[2] = x13;
                      if (!extend_operand (operands[2], E_SImode)
                          || !
#line 6363 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY && reload_completed))
                        return NULL;
                      return gen_split_47 (insn, operands);

                    case ZERO_EXTEND:
                      if (GET_CODE (x11) != ZERO_EXTEND)
                        return NULL;
                      x12 = XEXP (x9, 0);
                      operands[1] = x12;
                      if (!register_operand (operands[1], E_SImode))
                        return NULL;
                      x13 = XEXP (x11, 0);
                      operands[2] = x13;
                      if (!extend_operand (operands[2], E_SImode)
                          || !
#line 6465 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY && reload_completed))
                        return NULL;
                      return gen_split_48 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case GTU:
              if (GET_MODE (x3) != E_SImode)
                return NULL;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return NULL;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 61)
                return NULL;
              x10 = XEXP (x2, 0);
              operands[0] = x10;
              if (!dest_reg_operand (operands[0], E_SImode))
                return NULL;
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_SImode))
                return NULL;
              x4 = XEXP (x3, 1);
              operands[2] = x4;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              return gen_split_16 (insn, operands);

            case ASHIFT:
              if (pattern24 (x1) != 0
                  || !(
#line 3549 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()) && 
#line 3551 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
                return NULL;
              return gen_split_27 (insn, operands);

            case ASHIFTRT:
              if (pattern24 (x1) != 0
                  || !(
#line 3575 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()) && 
#line 3577 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
                return NULL;
              return gen_split_28 (insn, operands);

            case LSHIFTRT:
              if (pattern24 (x1) != 0
                  || !(
#line 3606 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()) && 
#line 3608 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
                return NULL;
              return gen_split_29 (insn, operands);

            case ROTATE:
              if (pattern24 (x1) != 0
                  || !(
#line 3710 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()) && 
#line 3712 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
                return NULL;
              return gen_split_31 (insn, operands);

            case ROTATERT:
              if (pattern24 (x1) != 0
                  || !(
#line 3743 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()) && 
#line 3745 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( 1)))
                return NULL;
              return gen_split_32 (insn, operands);

            case CLZ:
              if (GET_MODE (x3) != E_SImode
                  || pattern23 (x1, 
E_SImode, 
E_CC_ZNmode) != 0
                  || !
#line 4607 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed))
                return NULL;
              return gen_split_35 (insn, operands);

            case FMA:
              switch (pattern25 (x1))
                {
                case 0:
                  if (!
#line 137 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_FUSED))
                    return NULL;
                  return gen_split_50 (insn, operands);

                case 1:
                  if (!
#line 166 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_FUSED))
                    return NULL;
                  return gen_split_51 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case CTZ:
              if (pattern27 (x1) != 0
                  || !
#line 4647 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed))
                return NULL;
              return gen_split_36 (insn, operands);

            case IF_THEN_ELSE:
              if (pattern32 (x1) != 0)
                return NULL;
              x14 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x14) != CLOBBER)
                return NULL;
              x5 = XEXP (x3, 0);
              x9 = XEXP (x5, 0);
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!nonimmediate_operand (operands[0], E_SImode))
                return NULL;
              x4 = XEXP (x3, 1);
              x15 = XEXP (x4, 0);
              operands[1] = x15;
              x16 = XEXP (x14, 0);
              operands[2] = x16;
              if (!scratch_operand (operands[2], E_SImode))
                return NULL;
              x6 = XVECEXP (x1, 0, 1);
              x8 = XEXP (x6, 1);
              x17 = XEXP (x8, 0);
              if (!rtx_equal_p (x17, operands[0]))
                return NULL;
              x7 = XEXP (x6, 0);
              if (!rtx_equal_p (x7, operands[0])
                  || !
#line 5245 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DBNZ && reload_completed && memory_operand (operands[0], SImode)))
                return NULL;
              return gen_split_40 (insn, operands);

            case UNSPEC_VOLATILE:
              if (pattern28 (x1) != 0
                  || !(
#line 85 "../../gcc-15.0.1-20250313/gcc/config/arc/atomic.md"
(TARGET_ATOMIC) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/arc/atomic.md"
( reload_completed)))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != IF_THEN_ELSE
              || pattern29 (x1) != 0
              || !
#line 5197 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed && memory_operand (operands[0], Pmode)))
            return NULL;
          return gen_split_39 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          if (XINT (x1, 1) != 63)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!memory_operand (operands[0], E_DImode))
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 4818 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_LL64) && 
#line 4820 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
( reload_completed)))
            return NULL;
          return gen_split_37 (insn, operands);

        case 1:
          if (XINT (x1, 1) != 59)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 6930 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed))
            return NULL;
          return gen_split_49 (insn, operands);

        default:
          return NULL;
        }

    case COND_EXEC:
      x18 = XEXP (x1, 0);
      if (!proper_comparison_operator (x18, E_VOIDmode))
        return NULL;
      x19 = XEXP (x18, 0);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 61)
        return NULL;
      x20 = XEXP (x18, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x21 = XEXP (x1, 1);
      switch (GET_CODE (x21))
        {
        case SET:
          x22 = XEXP (x21, 0);
          operands[0] = x22;
          x23 = XEXP (x21, 1);
          switch (GET_CODE (x23))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[1] = x23;
              operands[2] = x18;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!move_dest_operand (operands[0], E_SImode)
                      || !move_src_operand (operands[1], E_SImode)
                      || !
#line 794 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   && GET_CODE (PATTERN (insn)) != COND_EXEC
   && register_operand (operands[0], SImode)
   && IN_RANGE (REGNO (operands[0]) ^ 4, 4, 11)
   && satisfies_constraint_Cax (operands[1])))
                    return NULL;
                  return gen_split_62 (insn, operands);

                case E_V2HImode:
                  if (!move_dest_operand (operands[0], E_V2HImode)
                      || !general_operand (operands[1], E_V2HImode)
                      || !
#line 1438 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(reload_completed && GET_CODE (operands[1]) == CONST_VECTOR))
                    return NULL;
                  return gen_split_68 (insn, operands);

                default:
                  return NULL;
                }

            case MINUS:
              if (GET_MODE (x23) != E_SImode)
                return NULL;
              operands[3] = x18;
              if (!dest_reg_operand (operands[0], E_SImode))
                return NULL;
              x24 = XEXP (x23, 0);
              operands[1] = x24;
              if (!nonmemory_operand (operands[1], E_SImode))
                return NULL;
              x25 = XEXP (x23, 1);
              operands[2] = x25;
              if (!nonmemory_operand (operands[2], E_SImode)
                  || !
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed && get_attr_length (insn) == 8
   && satisfies_constraint_I (operands[1])
   && GET_CODE (PATTERN (insn)) != COND_EXEC))
                return NULL;
              return gen_split_64 (insn, operands);

            case IOR:
              if (GET_MODE (x23) != E_SImode)
                return NULL;
              operands[3] = x18;
              if (!dest_reg_operand (operands[0], E_SImode))
                return NULL;
              x24 = XEXP (x23, 0);
              operands[1] = x24;
              if (!register_operand (operands[1], E_SImode))
                return NULL;
              x25 = XEXP (x23, 1);
              operands[2] = x25;
              if (!nonmemory_operand (operands[2], E_SImode)
                  || !
#line 3312 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   && GET_CODE (PATTERN (insn)) != COND_EXEC
   && register_operand (operands[0], SImode)
   && IN_RANGE (REGNO (operands[0]) ^ 4, 4, 11)
   && satisfies_constraint_C0x (operands[2])))
                return NULL;
              return gen_split_65 (insn, operands);

            case GTU:
              if (pattern74 (x1) != 0
                  || !
#line 5581 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   && CONST_INT_P (operands[2])
   && satisfies_constraint_C62 (operands[2])))
                return NULL;
              return gen_split_66 (insn, operands);

            case LEU:
              if (pattern74 (x1) != 0
                  || !
#line 5604 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed
   && CONST_INT_P (operands[2])
   && satisfies_constraint_C62 (operands[2])))
                return NULL;
              return gen_split_67 (insn, operands);

            default:
              return NULL;
            }

        case PARALLEL:
          if (XVECLEN (x21, 0) != 2)
            return NULL;
          x26 = XVECEXP (x21, 0, 0);
          if (GET_CODE (x26) != SET)
            return NULL;
          x27 = XEXP (x26, 1);
          if (!zn_compare_operator (x27, E_VOIDmode))
            return NULL;
          operands[3] = x27;
          x28 = XEXP (x27, 1);
          if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x29 = XVECEXP (x21, 0, 1);
          if (GET_CODE (x29) != SET)
            return NULL;
          operands[4] = x18;
          x30 = XEXP (x26, 0);
          operands[2] = x30;
          if (!cc_set_register (operands[2], E_VOIDmode))
            return NULL;
          x31 = XEXP (x27, 0);
          operands[1] = x31;
          if (!nonmemory_operand (operands[1], E_SImode))
            return NULL;
          x32 = XEXP (x29, 0);
          operands[0] = x32;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x33 = XEXP (x29, 1);
          if (!rtx_equal_p (x33, operands[1])
              || !
#line 917 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(reload_completed && operands_match_p (operands[0], operands[1])))
            return NULL;
          return gen_split_63 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
