/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, rtx_code i1, rtx_code i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern11 (rtx x1, int *pnum_clobbers, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!even_register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!even_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 55
      || GET_MODE (x3) != E_CC_Zmode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 61
      || GET_MODE (x5) != E_CC_Zmode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != UNSPEC_VOLATILE
      || XVECLEN (x8, 0) != 5
      || XINT (x8, 1) != 55
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x6, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x10 = XEXP (x6, 1);
  operands[1] = x10;
  if (!mem_noofs_operand (operands[1], E_SImode))
    return -1;
  x11 = XVECEXP (x8, 0, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x12 = XVECEXP (x8, 0, 1);
  operands[3] = x12;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x13 = XVECEXP (x8, 0, 2);
  operands[4] = x13;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x14 = XVECEXP (x8, 0, 3);
  operands[5] = x14;
  if (!const_int_operand (operands[5], E_SImode))
    return -1;
  x15 = XVECEXP (x8, 0, 4);
  operands[6] = x15;
  if (!const_int_operand (operands[6], E_SImode))
    return -1;
  x16 = XEXP (x7, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!even_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 58
      || GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_V2HImode)
      || !register_operand (operands[2], E_V2HImode))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!even_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != FIX)
    return -1;
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!even_register_operand (operands[0], E_DImode))
        return -1;
      return pattern72 (x3, 
E_DImode); /* [-1, 1] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      res = pattern72 (x3, 
E_SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!dest_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!nonmemory_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern87 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!immediate_operand (operands[2], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != MULT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x5, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 58
      || GET_MODE (x8) != E_DImode
      || !even_register_operand (operands[0], E_DImode))
    return -1;
  x9 = XEXP (x7, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return 0;
}

int
pattern94 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 61
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x7, 1);
  if (!rtx_equal_p (x9, operands[4]))
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !even_register_operand (operands[0], E_DImode)
      || !even_register_operand (operands[1], E_V4HImode)
      || !even_register_operand (operands[2], E_V4HImode))
    return -1;
  return 0;
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!even_register_operand (operands[0], E_DFmode)
      || GET_MODE (x1) != E_DFmode
      || !even_register_operand (operands[1], E_DFmode)
      || !even_register_operand (operands[2], E_DFmode))
    return -1;
  return 0;
}

int
pattern111 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !nonmemory_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!even_register_operand (operands[0], E_DFmode)
          || !even_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern117 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XEXP (x6, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x10 = XEXP (x3, 1);
  if (REGNO (x10) != 56
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XEXP (x2, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 56
      || GET_MODE (x11) != E_DImode)
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != ZERO_EXTRACT
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS
      || GET_MODE (x14) != E_DImode)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != MULT
      || GET_MODE (x15) != E_DImode)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != i2
      || GET_MODE (x16) != E_DImode)
    return -1;
  x17 = XEXP (x15, 1);
  if (GET_CODE (x17) != ASHIFT
      || GET_MODE (x17) != E_DImode)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != i1
      || GET_MODE (x18) != E_DImode)
    return -1;
  x19 = XEXP (x18, 1);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x20 = XEXP (x18, 2);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x21 = XEXP (x17, 1);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x22 = XEXP (x14, 1);
  if (GET_CODE (x22) != REG
      || REGNO (x22) != 56
      || GET_MODE (x22) != E_DImode)
    return -1;
  x23 = XEXP (x13, 1);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x24 = XEXP (x13, 2);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x25 = XEXP (x4, 0);
  if (GET_MODE (x25) != E_DImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  x26 = XEXP (x6, 0);
  operands[2] = x26;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x27 = XEXP (x12, 0);
  operands[0] = x27;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x28 = XEXP (x16, 0);
  if (!rtx_equal_p (x28, operands[1]))
    return -1;
  x29 = XEXP (x18, 0);
  if (!rtx_equal_p (x29, operands[2]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!cc_set_register (operands[0], E_VOIDmode)
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!_1_2_3_operand (operands[3], E_SImode))
    return -1;
  return 296; /* *compare_si_ashiftsi */
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[2], E_HImode)
          || !
#line 2085 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPYW))
        return -1;
      return 71; /* umulhisi3_reg */

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern76 (x2, 
E_SImode, 
E_DImode) != 0
          || !
#line 2256 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MUL64_SET))
        return -1;
      *pnum_clobbers = 1;
      return 79; /* umulsidi_600 */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern0 (x2, 
E_SImode) != 0)
                return -1;
              return 67; /* *addsi3_mixed */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern0 (x2, 
E_DImode) != 0
                  || !
#line 2694 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 94; /* *adddi3 */

            case E_SFmode:
              if (pattern48 (x2, 
E_SFmode) != 0)
                return -1;
              if (
#line 58 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_SPFP))
                return 304; /* *addsf3_fpx */
              if (!
#line 12 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_BASE
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode))))
                return -1;
              return 331; /* *addsf3_fpu */

            case E_DFmode:
              if (pattern49 (x2) != 0
                  || !
#line 280 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_BASE))
                return -1;
              return 345; /* *adddf3_fpu */

            case E_V2HImode:
              if (pattern65 (x2, 
E_V2HImode) != 0
                  || !
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
                return -1;
              return 480; /* addv2hi3 */

            case E_V4HImode:
              if (pattern65 (x2, 
E_V4HImode) != 0
                  || !(
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY) && 
#line 1399 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                return -1;
              return 481; /* addv4hi3 */

            case E_V2SImode:
              if (pattern65 (x2, 
E_V2SImode) != 0
                  || !(
#line 1511 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY) && 
#line 1400 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                return -1;
              return 482; /* addv2si3 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || pattern62 (x2) != 0)
            return -1;
          return 293; /* *add_shift2 */

        default:
          return -1;
        }

    case PLUS:
      if (pattern6 (x3, 
REG, 
LTU, 
E_SImode) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 61
          || GET_MODE (x7) != E_CC_Cmode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x9 = XEXP (x3, 1);
      operands[1] = x9;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !
#line 2779 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[1], SImode)
   || register_operand (operands[2], SImode)))
        return -1;
      return 97; /* adc */

    case MULT:
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!dest_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          if (!_2_4_8_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!arc_nonmemory_operand (operands[3], E_SImode))
            return -1;
          return 103; /* *add_n */

        case SIGN_EXTEND:
          x9 = XEXP (x3, 1);
          if (GET_CODE (x9) != SIGN_EXTEND)
            return -1;
          if (pnum_clobbers != NULL)
            {
              switch (pattern45 (x1))
                {
                case 0:
                  if (
#line 6306 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                    {
                      *pnum_clobbers = 1;
                      return 274; /* machi */
                    }
                  break;

                case 1:
                  if (
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
                    {
                      *pnum_clobbers = 1;
                      return 276; /* maddsidi4_split */
                    }
                  break;

                default:
                  break;
                }
            }
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (pattern46 (x1))
            {
            case 0:
              if (!
#line 6407 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
                return -1;
              return 278; /* mac */

            case 1:
              if (!
#line 1834 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
                return -1;
              return 502; /* arc_vec_smac_v2hiv2si_zero */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x9 = XEXP (x3, 1);
          if (GET_CODE (x9) != ZERO_EXTEND)
            return -1;
          if (pnum_clobbers != NULL)
            {
              switch (pattern45 (x1))
                {
                case 0:
                  if (
#line 6335 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                    {
                      *pnum_clobbers = 1;
                      return 275; /* umachi */
                    }
                  break;

                case 1:
                  if (
#line 6463 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
                    {
                      *pnum_clobbers = 1;
                      return 280; /* umaddsidi4_split */
                    }
                  break;

                default:
                  break;
                }
            }
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (pattern46 (x1))
            {
            case 0:
              if (!
#line 6509 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
                return -1;
              return 282; /* macu */

            case 1:
              if (!
#line 1834 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
                return -1;
              return 503; /* arc_vec_umac_v2hiv2si_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x9 = XEXP (x3, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != ASHIFT
          || pattern47 (x5, 
REG, 
E_SImode, 
LTU) != 0)
        return -1;
      x10 = XEXP (x5, 0);
      x11 = XEXP (x10, 0);
      if (REGNO (x11) != 61
          || GET_MODE (x11) != E_CC_Cmode)
        return -1;
      x12 = XEXP (x10, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x5, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!dest_reg_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 143; /* rrcsi2 */

    case ASHIFT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!_1_2_3_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!arc_nonmemory_operand (operands[3], E_SImode))
        return -1;
      return 292; /* add_shift */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) == E_SImode)
    {
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (dest_reg_operand (operands[0], E_SImode))
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (arc_nonmemory_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (nonmemory_operand (operands[2], E_SImode)
                  && 
#line 3413 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER
   && (register_operand (operands[1], SImode)
       || register_operand (operands[2], SImode))))
                return 120; /* *ashlsi3_insn */
            }
        }
    }
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  res = recog_12 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (dest_reg_operand (operands[0], E_SImode)
      && x4 == const_int_rtx[MAX_SAVED_CONST_INT + 1]
      && GET_MODE (x2) == E_SImode)
    {
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (nonmemory_operand (operands[1], E_SImode)
          && 
#line 3489 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && arc_pre_reload_split ()))
        return 127; /* *ashlsi3_1 */
    }
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
      || GET_MODE (x2) != E_SImode)
    return -1;
  operands[1] = x4;
  if (!nonmemory_operand (operands[1], E_SImode)
      || !
#line 6199 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER && TARGET_V2))
    return -1;
  return 267; /* *ashlsi2_cnt8 */
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 33:
          if (GET_MODE (x3) != E_CC_Cmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x4) != AND
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern79 (x1, 
E_CC_Cmode, 
61) != 0)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!dest_reg_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_MODE (x9) != E_SImode)
            return -1;
          switch (GET_CODE (x9))
            {
            case PLUS:
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != LSHIFTRT
                  || GET_MODE (x10) != E_SImode)
                return -1;
              x11 = XEXP (x10, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x12 = XEXP (x9, 1);
              if (GET_CODE (x12) != ASHIFT
                  || GET_MODE (x12) != E_SImode)
                return -1;
              x13 = XEXP (x12, 0);
              if (GET_CODE (x13) != LTU
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != REG
                  || REGNO (x14) != 61
                  || GET_MODE (x14) != E_CC_Cmode)
                return -1;
              x15 = XEXP (x13, 1);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x16 = XEXP (x12, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
                return -1;
              x17 = XEXP (x10, 0);
              if (!rtx_equal_p (x17, operands[1]))
                return -1;
              return 144; /* rrcsi2_carry */

            case LSHIFTRT:
              x12 = XEXP (x9, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              return 269; /* lshrsi3_cnt1_carry */

            case ASHIFTRT:
              x12 = XEXP (x9, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              return 271; /* ashrsi3_cnt1_carry */

            default:
              return -1;
            }

        case 17:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != COMPARE
              || GET_MODE (x9) != E_CC_ZNmode)
            return -1;
          x12 = XEXP (x9, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 61
              || GET_MODE (x8) != E_CC_ZNmode)
            return -1;
          x18 = XEXP (x2, 0);
          operands[0] = x18;
          if (!dest_reg_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!general_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1])
              || !
#line 5698 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM && TARGET_V2))
            return -1;
          return 251; /* ffs_f */

        case 27:
          if (pattern53 (x1, 
E_V4HImode, 
E_HImode) != 0
              || !
#line 2046 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 523; /* reduc_plus_scal_v4hi */

        case 24:
          if (pattern53 (x1, 
E_V2SImode, 
E_SImode) != 0
              || !
#line 2056 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
            return -1;
          return 524; /* reduc_plus_scal_v2si */

        default:
          return -1;
        }

    case 3:
      x19 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x19) != REG
          || REGNO (x19) != 58
          || GET_MODE (x19) != E_DImode
          || pattern42 (x1) != 0)
        return -1;
      switch (XINT (x3, 1))
        {
        case 20:
          if (pattern113 (x3) != 0
              || !
#line 1847 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
            return -1;
          return 504; /* dmach */

        case 21:
          if (pattern113 (x3) != 0
              || !
#line 1861 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
            return -1;
          return 505; /* dmachu */

        case 22:
          if (GET_MODE (x3) != E_DImode
              || !even_register_operand (operands[0], E_DImode)
              || !even_register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2HImode)
              || !
#line 1875 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 506; /* dmacwh */

        case 23:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !even_register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2HImode)
              || !
#line 1889 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 507; /* dmacwhu */

        case 29:
          if (pattern101 (x3) != 0
              || !
#line 1903 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
            return -1;
          return 508; /* vmac2h */

        case 30:
          if (pattern101 (x3) != 0
              || !
#line 1917 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
            return -1;
          return 509; /* vmac2hu */

        case 25:
          if (pattern102 (x3) != 0
              || !
#line 1957 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 512; /* qmach */

        case 26:
          if (pattern102 (x3) != 0
              || !
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 513; /* qmachu */

        default:
          return -1;
        }

    case 2:
      if (pattern42 (x1) != 0)
        return -1;
      switch (XINT (x3, 1))
        {
        case 31:
          if (pattern101 (x3) != 0
              || !
#line 1930 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
            return -1;
          return 510; /* vmpy2h */

        case 32:
          if (pattern101 (x3) != 0
              || !
#line 1943 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
            return -1;
          return 511; /* vmpy2hu */

        case 27:
          if (pattern102 (x3) != 0
              || !
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 514; /* qmpyh */

        case 28:
          if (pattern102 (x3) != 0
              || !
#line 1997 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          return 515; /* qmpyhu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!move_dest_operand (operands[0], E_QImode)
              || !move_src_operand (operands[1], E_QImode)
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 664 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[0], QImode)
   || register_operand (operands[1], QImode)
   || (CONSTANT_P (operands[1])
       && (!satisfies_constraint_I (operands[1]) || !optimize_size)
       && satisfies_constraint_Usc (operands[0]))
   || (satisfies_constraint_Cm3 (operands[1])
       && memory_operand (operands[0], QImode)))))
            return -1;
          return 663; /* *p *movqi_insn */

        case E_HImode:
          if (!move_dest_operand (operands[0], E_HImode)
              || !move_src_operand (operands[1], E_HImode)
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 706 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[0], HImode)
   || register_operand (operands[1], HImode)
   || (CONSTANT_P (operands[1])
       /* Don't use a LIMM that we could load with a single insn - we loose
	  delay-slot filling opportunities.  */
       && !satisfies_constraint_I (operands[1])
       && satisfies_constraint_Usc (operands[0]))
   || (satisfies_constraint_Cm3 (operands[1])
       && memory_operand (operands[0], HImode)))))
            return -1;
          return 664; /* *p *movhi_insn */

        case E_SImode:
          if (!move_dest_operand (operands[0], E_SImode)
              || !move_src_operand (operands[1], E_SImode)
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 757 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[0], SImode)
   || register_operand (operands[1], SImode)
   || (CONSTANT_P (operands[1])
       && (!satisfies_constraint_I (operands[1]) || !optimize_size)
       && satisfies_constraint_Usc (operands[0]))
   || (satisfies_constraint_Cm3 (operands[1])
      && memory_operand (operands[0], SImode)))))
            return -1;
          return 665; /* *p *movsi_insn */

        case E_SFmode:
          if (!move_dest_operand (operands[0], E_SFmode)
              || !move_src_operand (operands[1], E_SFmode)
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1325 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(register_operand (operands[0], SFmode)
   || register_operand (operands[1], SFmode)
   || (CONSTANT_P (operands[1])
       && (!satisfies_constraint_I (operands[1]) || !optimize_size)
       && satisfies_constraint_Usc (operands[0])))))
            return -1;
          return 671; /* *p *movsf_insn */

        case E_V2HImode:
          if (!move_dest_operand (operands[0], E_V2HImode)
              || !general_operand (operands[1], E_V2HImode)
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1431 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
((register_operand (operands[0], V2HImode)
    || register_operand (operands[1], V2HImode)))))
            return -1;
          return 797; /* *p *movv2hi_insn */

        default:
          return -1;
        }

    case COMPARE:
      return recog_50 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!dest_reg_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonvol_nonimm_operand (operands[1], E_QImode))
            return -1;
          return 672; /* *p *zero_extendqihi2_i */

        case E_SImode:
          if (!dest_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!nonvol_nonimm_operand (operands[1], E_QImode))
                return -1;
              return 673; /* *p *zero_extendqisi2_ac */

            case E_HImode:
              if (!nonvol_nonimm_operand (operands[1], E_HImode))
                return -1;
              return 674; /* *p *zero_extendhisi2_i */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      if (pattern66 (x1) != 0)
        return -1;
      return 675; /* *p smaxsi3 */

    case SMIN:
      if (pattern66 (x1) != 0)
        return -1;
      return 676; /* *p sminsi3 */

    case PLUS:
      return recog_51 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_49 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      if (pattern47 (x3, 
MULT, 
E_DImode, 
LSHIFTRT) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      x7 = XEXP (x6, 0);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_MODE (x9) != E_DImode)
        return -1;
      switch (GET_CODE (x9))
        {
        case SIGN_EXTEND:
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) != SIGN_EXTEND
              || GET_MODE (x10) != E_DImode)
            return -1;
          x11 = XEXP (x9, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x10, 0);
          operands[2] = x12;
          if (!extend_operand (operands[2], E_SImode)
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2467 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPY)))
            return -1;
          return 690; /* *p mulsi3_highpart */

        case ZERO_EXTEND:
          x11 = XEXP (x9, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) == ZERO_EXTEND
              && GET_MODE (x10) == E_DImode)
            {
              x12 = XEXP (x10, 0);
              operands[2] = x12;
              if (extend_operand (operands[2], E_SImode)
                  && (
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2484 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPY)))
                return 691; /* *p *umulsi3_highpart_i */
            }
          operands[2] = x10;
          if (!immediate_usidi_operand (operands[2], E_DImode)
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 2502 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MPY)))
            return -1;
          return 692; /* *p umulsi3_highpart_int */

        default:
          return -1;
        }

    case MINUS:
      return recog_52 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern67 (x1))
        {
        case 0:
          return 698; /* *p *bset */

        case 1:
          return 701; /* *p *bset_insn */

        case 2:
          return 707; /* *p iorsi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern67 (x1))
        {
        case 0:
          return 699; /* *p *bxor */

        case 1:
          return 702; /* *p *bxor_insn */

        case 2:
          return 708; /* *p xorsi3 */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!dest_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case NOT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x13 = XEXP (x3, 1);
          if (!nonmemory_operand (x13, E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case ASHIFT:
              if (GET_MODE (x7) != E_SImode)
                return -1;
              x9 = XEXP (x7, 0);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x10 = XEXP (x7, 1);
              if (!nonmemory_operand (x10, E_SImode))
                return -1;
              operands[1] = x10;
              operands[2] = x13;
              return 700; /* *p *bclr */
              operands[2] = x10;
              operands[1] = x13;
              return 703; /* *p *bclr_insn */

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[1] = x7;
              if (!nonmemory_operand (operands[1], E_SImode))
                return -1;
              operands[2] = x13;
              return 706; /* *p *bicsi3_insn */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x6;
          x13 = XEXP (x3, 1);
          switch (GET_CODE (x13))
            {
            case PLUS:
              if (GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != ASHIFT
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x16 = XEXP (x14, 1);
              if (GET_CODE (x16) != PLUS
                  || GET_MODE (x16) != E_SImode)
                return -1;
              x17 = XEXP (x16, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x18 = XEXP (x13, 1);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
                  || !nonmemory_operand (operands[1], E_SImode))
                return -1;
              x19 = XEXP (x16, 0);
              operands[2] = x19;
              if (!nonmemory_operand (operands[2], E_SImode))
                return -1;
              return 704; /* *p *bmsk_insn */

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[2] = x13;
              if (!nonmemory_operand (operands[2], E_SImode)
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 3196 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
((register_operand (operands[1], SImode)
    && nonmemory_operand (operands[2], SImode))
   || (memory_operand (operands[1], SImode)
       && satisfies_constraint_Cux (operands[2])))))
                return -1;
              return 705; /* *p andsi3_i */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!dest_reg_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 709; /* *p negsi2 */

        case E_SFmode:
          if (!dest_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          return 734; /* *p negsf2 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!dest_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (arc_nonmemory_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x1, 0);
          operands[3] = x4;
          x13 = XEXP (x3, 1);
          operands[2] = x13;
          if (nonmemory_operand (operands[2], E_SImode)
              && (
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 3413 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER
   && (register_operand (operands[1], SImode)
       || register_operand (operands[2], SImode)))))
            return 710; /* *p *ashlsi3_insn */
        }
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x3, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      return 751; /* *p ashlsi3_cnt1 */

    case ASHIFTRT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!dest_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (arc_nonmemory_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x1, 0);
          operands[3] = x4;
          x13 = XEXP (x3, 1);
          operands[2] = x13;
          if (nonmemory_operand (operands[2], E_SImode)
              && (
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 3426 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER
   && (register_operand (operands[1], SImode)
       || register_operand (operands[2], SImode)))))
            return 711; /* *p *ashrsi3_insn */
        }
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x3, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      return 753; /* *p ashrsi3_cnt1 */

    case LSHIFTRT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!dest_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (nonmemory_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x1, 0);
          operands[3] = x4;
          x13 = XEXP (x3, 1);
          operands[2] = x13;
          if (nonmemory_operand (operands[2], E_SImode)
              && (
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 3439 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER
   && (register_operand (operands[1], SImode)
       || register_operand (operands[2], SImode)))))
            return 712; /* *p *lshrsi3_insn */
        }
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x3, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      return 752; /* *p lshrsi3_cnt1 */

    case ROTATERT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!dest_reg_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!arc_nonmemory_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 3625 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER)))
        return -1;
      return 713; /* *p rotrsi3_insn */

    case ABS:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!dest_reg_operand (operands[0], E_SFmode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 733; /* *p abssf2 */

    case DIV:
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern104 (x3, 
E_SImode) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5484 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DIVREM)))
            return -1;
          return 735; /* *p divsi3 */

        case E_SFmode:
          if (pattern104 (x3, 
E_SFmode) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 206 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_SQRT
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)))))
            return -1;
          return 770; /* *p *divsf3_fpu */

        case E_DFmode:
          if (pattern105 (x3) != 0
              || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_SQRT)))
            return -1;
          return 776; /* *p divdf3 */

        default:
          return -1;
        }

    case UDIV:
      if (pattern68 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5497 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DIVREM)))
        return -1;
      return 736; /* *p udivsi3 */

    case MOD:
      if (pattern68 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5510 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DIVREM)))
        return -1;
      return 737; /* *p modsi3 */

    case UMOD:
      if (pattern68 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5523 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DIVREM)))
        return -1;
      return 738; /* *p umodsi3 */

    case EQ:
      if (pattern69 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY)))
        return -1;
      return 739; /* *p arcseteq */

    case NE:
      if (pattern69 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY)))
        return -1;
      return 740; /* *p arcsetne */

    case GT:
      if (pattern69 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY)))
        return -1;
      return 741; /* *p arcsetgt */

    case LT:
      if (pattern69 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY)))
        return -1;
      return 742; /* *p arcsetlt */

    case GE:
      if (pattern69 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY)))
        return -1;
      return 743; /* *p arcsetge */

    case LE:
      if (pattern69 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5539 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY)))
        return -1;
      return 744; /* *p arcsetle */

    case LTU:
      if (pattern69 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5552 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY)))
        return -1;
      return 745; /* *p arcsetltu */

    case GEU:
      if (pattern69 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5565 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY)))
        return -1;
      return 746; /* *p arcsetgeu */

    case GTU:
      if (pattern69 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5579 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY)))
        return -1;
      return 747; /* *p arcsethi */

    case LEU:
      if (pattern69 (x1) != 0
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5602 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_CODE_DENSITY)))
        return -1;
      return 748; /* *p arcsetls */

    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[4] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x3, 1);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x20 = XEXP (x3, 2);
      operands[3] = x20;
      if (!const_int_operand (operands[3], E_SImode)
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 5649 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_HS && TARGET_BARREL_SHIFTER)))
        return -1;
      return 749; /* *p extzvsi */

    case FMA:
      return recog_53 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!even_register_operand (operands[0], E_DFmode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SFmode)
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 387 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
        return -1;
      return 779; /* *p extendsfdf2 */

    case FLOAT:
      switch (pattern71 (x1))
        {
        case 0:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 399 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 780; /* *p floatsidf2 */

        case 1:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 495 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 788; /* *p floatdidf2 */

        case 2:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 447 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_CONV)))
            return -1;
          return 784; /* *p floatsisf2_fpu */

        case 3:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 555 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 793; /* *p floatdisf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern71 (x1))
        {
        case 0:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 411 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 781; /* *p floatunssidf2 */

        case 1:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 507 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 789; /* *p floatunsdidf2 */

        case 2:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_CONV)))
            return -1;
          return 785; /* *p floatunssisf2 */

        case 3:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 567 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 794; /* *p floatunsdisf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern73 (x1))
        {
        case 0:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 423 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 782; /* *p fixuns_truncsfdi2 */

        case 1:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 519 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 790; /* *p fixuns_truncdfdi2 */

        case 2:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 471 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_CONV)))
            return -1;
          return 786; /* *p fixuns_truncsfsi2 */

        case 3:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 579 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 795; /* *p fixuns_truncdfsi2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern73 (x1))
        {
        case 0:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 435 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 783; /* *p fix_truncsfdi2 */

        case 1:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 531 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 791; /* *p fix_truncdfdi2 */

        case 2:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 483 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_CONV)))
            return -1;
          return 787; /* *p fix_truncsfsi2_fpu */

        case 3:
          if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
            return -1;
          return 796; /* *p fix_truncdfsi2 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!even_register_operand (operands[1], E_DFmode)
          || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV)))
        return -1;
      return 792; /* *p truncdfsf2 */

    case VEC_CONCAT:
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case PLUS:
          switch (pattern91 (x3, 
MINUS))
            {
            case 0:
              if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY)))
                return -1;
              return 804; /* *p addsubv2hi3 */

            case 1:
              if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY)))
                return -1;
              return 805; /* *p addsubv2si3 */

            default:
              return -1;
            }

        case MINUS:
          switch (pattern91 (x3, 
PLUS))
            {
            case 0:
              if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY)))
                return -1;
              return 806; /* *p subaddv2hi3 */

            case 1:
              if (!(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY)))
                return -1;
              return 807; /* *p subaddv2si3 */

            default:
              return -1;
            }

        case VEC_CONCAT:
          if (GET_MODE (x6) != E_V2HImode)
            return -1;
          x13 = XEXP (x3, 1);
          if (GET_CODE (x13) != VEC_CONCAT
              || GET_MODE (x13) != E_V2HImode
              || !even_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_MODE (x7) != E_HImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_MODE (x8) != E_HImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_MODE (x14) != E_HImode)
            return -1;
          x18 = XEXP (x13, 1);
          if (GET_MODE (x18) != E_HImode)
            return -1;
          switch (GET_CODE (x7))
            {
            case PLUS:
              if (pattern122 (x3, 
MINUS, 
PLUS) != 0
                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1583 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                return -1;
              return 808; /* *p addsubv4hi3 */

            case MINUS:
              if (pattern122 (x3, 
PLUS, 
MINUS) != 0
                  || !(
#line 428 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(true) && 
#line 1607 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW)))
                return -1;
              return 809; /* *p subaddv4hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
