/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V2HImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 2)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != i1
          || GET_MODE (x8) != E_V2SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != VEC_SELECT
          || GET_MODE (x9) != E_V2HImode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 2)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x12 = XVECEXP (x10, 0, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x13 = XEXP (x1, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 58
          || GET_MODE (x13) != E_V2SImode
          || GET_MODE (x2) != E_V2SImode
          || GET_MODE (x3) != E_V2SImode)
        return -1;
      x14 = XEXP (x4, 0);
      operands[0] = x14;
      if (!even_register_operand (operands[0], E_V4HImode))
        return -1;
      x15 = XEXP (x9, 0);
      operands[1] = x15;
      if (!even_register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  return 0;
}

int
pattern34 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  return 0;
}

int
pattern40 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3, machine_mode i4, rtx_code i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i5
      || GET_MODE (x1) != i4)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonmemory_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern53 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 58
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!even_register_operand (operands[0], i2))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[1] = x7;
  if (!even_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !arc_simd_dma_register_operand (operands[0], E_SImode)
      || !nonmemory_operand (operands[1], E_SImode)
      || !nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!even_register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !nonmemory_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!even_register_operand (operands[0], E_DFmode)
          || !even_register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 58
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case CLOBBER:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || !register_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x7) != E_DImode)
        return -1;
      switch (REGNO (x7))
        {
        case 58:
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case 56:
          if (!extend_operand (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != MULT
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != i1
          || GET_MODE (x9) != E_DImode)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != i1
          || GET_MODE (x10) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 58
          || GET_MODE (x7) != E_DImode
          || !even_register_operand (operands[0], E_DImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x9, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_register (operands[3], E_VOIDmode))
    return -1;
  operands[5] = x3;
  if (!zn_compare_operator (operands[5], E_VOIDmode)
      || !register_operand (operands[1], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (!rtx_equal_p (x7, operands[4]))
    return -1;
  return 0;
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !register_operand (operands[1], E_SImode)
      || !nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_V2HImode)
      || !register_operand (operands[2], E_V2HImode))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[6] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x4, 1);
  operands[5] = x6;
  if (!zn_compare_operator (operands[5], E_VOIDmode))
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x10 = XVECEXP (x3, 0, 1);
  x11 = XEXP (x10, 1);
  if (!rtx_equal_p (x11, operands[4]))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x7, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 16:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x3) != LABEL_REF)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!
#line 4190 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BI_BIH))
        return -1;
      return 164; /* casesi_dispatch */

    case 64:
      if (pattern12 (x1) != 0
          || !
#line 243 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 376; /* vaddaw_insn */

    case 65:
      if (pattern12 (x1) != 0
          || !
#line 254 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 377; /* vaddw_insn */

    case 66:
      if (pattern12 (x1) != 0
          || !
#line 265 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 378; /* vavb_insn */

    case 67:
      if (pattern12 (x1) != 0
          || !
#line 276 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 379; /* vavrb_insn */

    case 68:
      if (pattern12 (x1) != 0
          || !
#line 287 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 380; /* vdifaw_insn */

    case 69:
      if (pattern12 (x1) != 0
          || !
#line 298 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 381; /* vdifw_insn */

    case 70:
      if (pattern12 (x1) != 0
          || !
#line 309 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 382; /* vmaxaw_insn */

    case 71:
      if (pattern12 (x1) != 0
          || !
#line 320 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 383; /* vmaxw_insn */

    case 72:
      if (pattern12 (x1) != 0
          || !
#line 331 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 384; /* vminaw_insn */

    case 73:
      if (pattern12 (x1) != 0
          || !
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 385; /* vminw_insn */

    case 74:
      if (pattern12 (x1) != 0
          || !
#line 353 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 386; /* vmulaw_insn */

    case 75:
      if (pattern12 (x1) != 0
          || !
#line 364 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 387; /* vmulfaw_insn */

    case 76:
      if (pattern12 (x1) != 0
          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 388; /* vmulfw_insn */

    case 77:
      if (pattern12 (x1) != 0
          || !
#line 386 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 389; /* vmulw_insn */

    case 78:
      if (pattern12 (x1) != 0
          || !
#line 397 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 390; /* vsubaw_insn */

    case 79:
      if (pattern12 (x1) != 0
          || !
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 391; /* vsubw_insn */

    case 80:
      if (pattern12 (x1) != 0
          || !
#line 419 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 392; /* vsummw_insn */

    case 81:
      if (pattern12 (x1) != 0
          || !
#line 430 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 393; /* vand_insn */

    case 82:
      if (pattern12 (x1) != 0
          || !
#line 441 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 394; /* vandaw_insn */

    case 83:
      if (pattern12 (x1) != 0
          || !
#line 452 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 395; /* vbic_insn */

    case 84:
      if (pattern12 (x1) != 0
          || !
#line 463 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 396; /* vbicaw_insn */

    case 85:
      if (pattern12 (x1) != 0
          || !
#line 474 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 397; /* vor_insn */

    case 86:
      if (pattern12 (x1) != 0
          || !
#line 485 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 398; /* vxor_insn */

    case 87:
      if (pattern12 (x1) != 0
          || !
#line 496 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 399; /* vxoraw_insn */

    case 88:
      if (pattern12 (x1) != 0
          || !
#line 507 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 400; /* veqw_insn */

    case 89:
      if (pattern12 (x1) != 0
          || !
#line 518 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 401; /* vlew_insn */

    case 90:
      if (pattern12 (x1) != 0
          || !
#line 529 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 402; /* vltw_insn */

    case 91:
      if (pattern12 (x1) != 0
          || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 403; /* vnew_insn */

    case 92:
      if (pattern12 (x1) != 0
          || !
#line 551 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 404; /* vmr1aw_insn */

    case 93:
      if (pattern12 (x1) != 0
          || !
#line 562 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 405; /* vmr1w_insn */

    case 94:
      if (pattern12 (x1) != 0
          || !
#line 573 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 406; /* vmr2aw_insn */

    case 95:
      if (pattern12 (x1) != 0
          || !
#line 584 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 407; /* vmr2w_insn */

    case 96:
      if (pattern12 (x1) != 0
          || !
#line 595 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 408; /* vmr3aw_insn */

    case 97:
      if (pattern12 (x1) != 0
          || !
#line 606 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 409; /* vmr3w_insn */

    case 98:
      if (pattern12 (x1) != 0
          || !
#line 617 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 410; /* vmr4aw_insn */

    case 99:
      if (pattern12 (x1) != 0
          || !
#line 628 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 411; /* vmr4w_insn */

    case 100:
      if (pattern12 (x1) != 0
          || !
#line 639 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 412; /* vmr5aw_insn */

    case 101:
      if (pattern12 (x1) != 0
          || !
#line 650 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 413; /* vmr5w_insn */

    case 102:
      if (pattern12 (x1) != 0
          || !
#line 661 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 414; /* vmr6aw_insn */

    case 103:
      if (pattern12 (x1) != 0
          || !
#line 672 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 415; /* vmr6w_insn */

    case 104:
      if (pattern12 (x1) != 0
          || !
#line 683 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 416; /* vmr7aw_insn */

    case 105:
      if (pattern12 (x1) != 0
          || !
#line 694 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 417; /* vmr7w_insn */

    case 106:
      if (pattern12 (x1) != 0
          || !
#line 705 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 418; /* vmrb_insn */

    case 107:
      if (pattern12 (x1) != 0
          || !
#line 716 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 419; /* vh264f_insn */

    case 108:
      if (pattern12 (x1) != 0
          || !
#line 727 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 420; /* vh264ft_insn */

    case 109:
      if (pattern12 (x1) != 0
          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 421; /* vh264fw_insn */

    case 110:
      if (pattern12 (x1) != 0
          || !
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 422; /* vvc1f_insn */

    case 111:
      if (pattern12 (x1) != 0
          || !
#line 760 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 423; /* vvc1ft_insn */

    case 112:
      if (pattern13 (x1) != 0
          || !
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 424; /* vbaddw_insn */

    case 113:
      if (pattern13 (x1) != 0
          || !
#line 786 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 425; /* vbmaxw_insn */

    case 114:
      if (pattern13 (x1) != 0
          || !
#line 797 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 426; /* vbminw_insn */

    case 115:
      if (pattern13 (x1) != 0
          || !
#line 808 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 427; /* vbmulaw_insn */

    case 116:
      if (pattern13 (x1) != 0
          || !
#line 819 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 428; /* vbmulfw_insn */

    case 117:
      if (pattern13 (x1) != 0
          || !
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 429; /* vbmulw_insn */

    case 118:
      if (pattern13 (x1) != 0
          || !
#line 841 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 430; /* vbrsubw_insn */

    case 119:
      if (pattern13 (x1) != 0
          || !
#line 852 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 431; /* vbsubw_insn */

    case 123:
      if (pattern14 (x1) != 0
          || !
#line 865 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 432; /* vasrrwi_insn */

    case 124:
      if (pattern14 (x1) != 0
          || !
#line 876 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 433; /* vasrsrwi_insn */

    case 125:
      if (pattern14 (x1) != 0
          || !
#line 887 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 434; /* vasrwi_insn */

    case 126:
      if (pattern14 (x1) != 0
          || !
#line 898 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 435; /* vasrpwbi_insn */

    case 127:
      if (pattern14 (x1) != 0
          || !
#line 909 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 436; /* vasrrpwbi_insn */

    case 128:
      if (pattern14 (x1) != 0
          || !
#line 920 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 437; /* vsr8awi_insn */

    case 129:
      if (pattern14 (x1) != 0
          || !
#line 931 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 438; /* vsr8i_insn */

    case 130:
      if (pattern14 (x1) != 0
          || !
#line 944 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 439; /* vmvaw_insn */

    case 131:
      if (pattern14 (x1) != 0
          || !
#line 955 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 440; /* vmvw_insn */

    case 132:
      if (pattern14 (x1) != 0
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 441; /* vmvzw_insn */

    case 133:
      if (pattern14 (x1) != 0
          || !
#line 977 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 442; /* vd6tapf_insn */

    case 134:
      if (pattern15 (x1) != 0
          || !
#line 989 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 443; /* vmovaw_insn */

    case 135:
      if (pattern15 (x1) != 0
          || !
#line 1000 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 444; /* vmovw_insn */

    case 136:
      if (pattern15 (x1) != 0
          || !
#line 1011 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
        return -1;
      return 445; /* vmovzw_insn */

    case 31:
      if (pattern16 (x1, pnum_clobbers) != 0
          || !
#line 1930 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
        return -1;
      *pnum_clobbers = 1;
      return 510; /* vmpy2h */

    case 32:
      if (pattern16 (x1, pnum_clobbers) != 0
          || !
#line 1943 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
        return -1;
      *pnum_clobbers = 1;
      return 511; /* vmpy2hu */

    case 27:
      if (pattern17 (x1, pnum_clobbers) != 0
          || !
#line 1984 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
        return -1;
      *pnum_clobbers = 1;
      return 514; /* qmpyh */

    case 28:
      if (pattern17 (x1, pnum_clobbers) != 0
          || !
#line 1997 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
        return -1;
      *pnum_clobbers = 1;
      return 515; /* qmpyhu */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ASHIFT
              || GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != ZERO_EXTRACT
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x9 = XEXP (x7, 2);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x10 = XEXP (x6, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x11 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x11) != CLOBBER)
            return -1;
          x12 = XEXP (x2, 0);
          operands[2] = x12;
          if (!acc2_operand (operands[2], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x13 = XEXP (x7, 0);
          operands[1] = x13;
          if (!nonmemory_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[3] = x14;
          if (!acc1_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x3, 1);
          if (!rtx_equal_p (x15, operands[2])
              || !
#line 2174 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
            return -1;
          return 74; /* mac_600 */

        case SIGN_EXTEND:
          switch (pattern52 (x1, 
SIGN_EXTEND))
            {
            case 0:
              x6 = XEXP (x4, 1);
              switch (GET_CODE (x6))
                {
                case ASHIFT:
                  if (pattern77 (x1, 
SIGN_EXTRACT, 
SIGN_EXTEND) != 0
                      || !
#line 2430 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
                    return -1;
                  return 85; /* mac64_600 */

                case SIGN_EXTEND:
                  x12 = XEXP (x2, 0);
                  operands[0] = x12;
                  x7 = XEXP (x6, 0);
                  operands[2] = x7;
                  x11 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x11) == CLOBBER)
                    {
                      switch (pattern95 (x1))
                        {
                        case 0:
                          if (
#line 6306 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                            return 274; /* machi */
                          break;

                        case 1:
                          if (
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
                            return 276; /* maddsidi4_split */
                          break;

                        default:
                          break;
                        }
                    }
                  x15 = XEXP (x3, 1);
                  if (GET_CODE (x15) != REG)
                    return -1;
                  switch (pattern97 (x1, 
SIGN_EXTEND))
                    {
                    case 0:
                      if (!
#line 6394 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                        return -1;
                      return 277; /* macd */

                    case 1:
                      if (!
#line 1819 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
                        return -1;
                      return 500; /* arc_vec_smac_v2hiv2si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 1:
              if (!
#line 1637 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
                return -1;
              return 492; /* dmpyh */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern52 (x1, 
ZERO_EXTEND))
            {
            case 0:
              x6 = XEXP (x4, 1);
              switch (GET_CODE (x6))
                {
                case ASHIFT:
                  if (pattern77 (x1, 
ZERO_EXTRACT, 
ZERO_EXTEND) != 0
                      || !
#line 2644 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_MULMAC_32BY16_SET))
                    return -1;
                  return 92; /* umac64_600 */

                case ZERO_EXTEND:
                  x12 = XEXP (x2, 0);
                  operands[0] = x12;
                  x7 = XEXP (x6, 0);
                  operands[2] = x7;
                  x11 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x11) == CLOBBER)
                    {
                      switch (pattern95 (x1))
                        {
                        case 0:
                          if (
#line 6335 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                            return 275; /* umachi */
                          break;

                        case 1:
                          if (
#line 6463 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_DMPY))
                            return 280; /* umaddsidi4_split */
                          break;

                        default:
                          break;
                        }
                    }
                  x15 = XEXP (x3, 1);
                  if (GET_CODE (x15) != REG)
                    return -1;
                  switch (pattern97 (x1, 
ZERO_EXTEND))
                    {
                    case 0:
                      if (!
#line 6496 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_PLUS_MACD))
                        return -1;
                      return 281; /* macdu */

                    case 1:
                      if (!
#line 1819 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
                        return -1;
                      return 501; /* arc_vec_umac_v2hiv2si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 1:
              if (!
#line 1637 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
                return -1;
              return 493; /* dmpyhu */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (register_operand (operands[1], E_DImode))
        {
          x11 = XVECEXP (x1, 0, 1);
          if (pattern43 (x11, 
E_CCmode, 
61) == 0)
            {
              x12 = XEXP (x2, 0);
              operands[0] = x12;
              if (register_operand (operands[0], E_DImode)
                  && GET_MODE (x3) == E_DImode)
                {
                  x15 = XEXP (x3, 1);
                  operands[2] = x15;
                  if (nonmemory_operand (operands[2], E_DImode)
                      && 
#line 2694 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
                    return 94; /* *adddi3 */
                }
            }
        }
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 60
          || GET_MODE (x4) != E_SImode)
        return -1;
      x15 = XEXP (x3, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x12 = XEXP (x2, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 60
          || pattern54 (x1, 
COMPARE, 
E_CC_ZNmode) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 1);
      x16 = XEXP (x11, 1);
      x17 = XEXP (x16, 0);
      if (pattern110 (x17, 
60) != 0)
        return -1;
      x18 = XEXP (x17, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x19 = XEXP (x16, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x11, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 61
          || GET_MODE (x14) != E_CC_ZNmode
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 212; /* loop_fail */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ZERO_EXTRACT:
          if (pattern5 (x3) == 0)
            {
              operands[3] = x2;
              if (nonmemory_operand (operands[3], E_SImode)
                  && 
#line 5963 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS
   && (register_operand (operands[3], SImode)
       || satisfies_constraint_C18 (operands[1]))))
                return 255; /* *insv_i */
            }
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case MEM:
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (GET_CODE (x3) == PC)
            {
              if (GET_CODE (x2) == LABEL_REF)
                {
                  x4 = XEXP (x2, 0);
                  operands[0] = x4;
                  if (
#line 4110 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_LONG_CALLS_SET || !CROSSING_JUMP_P (insn)))
                    return 162; /* jump_i */
                }
              operands[0] = x2;
              if (nonmemory_operand (operands[0], E_SImode))
                return 163; /* indirect_jump */
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      if (!vector_register_or_memory_operand (operands[1], E_V8HImode))
        return -1;
      operands[0] = x3;
      if (!vector_register_or_memory_operand (operands[0], E_V8HImode)
          || !
#line 216 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET && !(GET_CODE (operands[0]) == MEM && GET_CODE(operands[1]) == MEM)))
        return -1;
      return 374; /* movv8hi_insn */

    case UNSPEC:
      return recog_14 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_17 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (proper_comparison_operator (x4, E_VOIDmode))
            {
              res = recog_10 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (pnum_clobbers == NULL
              || !equality_comparison_operator (x4, E_VOIDmode))
            return -1;
          operands[3] = x4;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != ZERO_EXTRACT
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XEXP (x2, 1);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x9 = XEXP (x2, 2);
          if (GET_CODE (x9) != PC)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x5, 2);
          operands[2] = x11;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x8, 0);
          operands[0] = x12;
          if (!
#line 5121 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!CROSSING_JUMP_P (insn)))
            return -1;
          *pnum_clobbers = 1;
          return 209; /* *bbit */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_27 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern18 (x2))
        {
        case 0:
          return 61; /* *extendqihi2_i */

        case 1:
          return 62; /* *extendqisi2_ac */

        case 2:
          return 63; /* *extendhisi2_i */

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!dest_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nonmemory_operand (operands[1], E_SImode))
            return -1;
          return 64; /* abssi2 */

        case E_SFmode:
          if (!dest_reg_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          return 224; /* abssf2 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern1 (x1))
        {
        case 0:
          return 65; /* smaxsi3 */

        case 1:
          return 518; /* smaxv2si3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern1 (x1))
        {
        case 0:
          return 66; /* sminsi3 */

        case 1:
          return 519; /* sminv2si3 */

        default:
          return -1;
        }

    case PLUS:
      return recog_16 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_19 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_22 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_21 (x1, insn, pnum_clobbers);

    case IOR:
      switch (pattern2 (x1))
        {
        case 0:
          return 106; /* *bset */

        case 1:
          return 109; /* *bset_insn */

        case 2:
          return 115; /* iorsi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern2 (x1))
        {
        case 0:
          return 107; /* *bxor */

        case 1:
          return 110; /* *bxor_insn */

        case 2:
          return 116; /* xorsi3 */

        default:
          return -1;
        }

    case AND:
      return recog_24 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_29 (x1, insn, pnum_clobbers);

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!dest_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 118; /* one_cmplsi2 */

        case E_DImode:
          if (!dest_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 119; /* one_cmpldi2 */

        default:
          return -1;
        }

    case ASHIFT:
      return recog_31 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      if (GET_MODE (x2) == E_SImode)
        {
          res = recog_13 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x8 = XEXP (x2, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern37 (x2, pnum_clobbers) != 0
              || !
#line 3575 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 139; /* *ashrdi3_cnt1 */

        case E_SImode:
          if (!dest_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 270; /* ashrsi3_cnt1 */

        default:
          return -1;
        }

    case LSHIFTRT:
      return recog_26 (x1, insn, pnum_clobbers);

    case ROTATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) == CONST_INT)
        {
          switch (pattern39 (x2, pnum_clobbers))
            {
            case 0:
              if (
#line 3457 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_SWAP))
                return 123; /* rotlsi2_cnt16 */
              break;

            case 1:
              if (
#line 3710 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(arc_pre_reload_split ()))
                {
                  *pnum_clobbers = 1;
                  return 145; /* *rotldi3_cnt1 */
                }
              break;

            default:
              break;
            }
        }
      if (!register_operand (operands[1], E_SImode)
          || !dest_reg_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      operands[2] = x8;
      if (nonmemory_operand (operands[2], E_SImode))
        {
          if (
#line 3504 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx
   && arc_pre_reload_split ()))
            return 131; /* *rotlsi3_nobs */
          if (pnum_clobbers != NULL
              && 
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx))
            {
              *pnum_clobbers = 2;
              return 136; /* rotlsi3_loop */
            }
          if (
#line 3635 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_BARREL_SHIFTER
   && arc_pre_reload_split ()))
            return 142; /* *rotlsi3 */
        }
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !
#line 6154 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER))
        return -1;
      return 263; /* rotlsi3_cnt1 */

    case ROTATERT:
      return recog_28 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_25 (x1, insn, pnum_clobbers);

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!dest_reg_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!call_address_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      *pnum_clobbers = 1;
      return 168; /* *call_value_i */

    case CLRSB:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!dest_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !general_operand (operands[1], E_SImode)
              || !
#line 4548 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM))
            return -1;
          return 174; /* clrsbsi2 */

        case E_HImode:
          if (!dest_reg_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !general_operand (operands[1], E_HImode)
              || !
#line 4566 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM))
            return -1;
          return 176; /* clrsbhi2 */

        default:
          return -1;
        }

    case CLZ:
      if (pattern3 (x1, pnum_clobbers) != 0
          || !
#line 4605 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM))
        return -1;
      *pnum_clobbers = 1;
      return 178; /* *arc_clzsi2 */

    case CTZ:
      if (pattern3 (x1, pnum_clobbers) != 0
          || !
#line 4645 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM))
        return -1;
      *pnum_clobbers = 2;
      return 179; /* arc_ctzsi2 */

    case UNSPEC_VOLATILE:
      return recog_18 (x1, insn, pnum_clobbers);

    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nonmemory_operand (operands[1], E_SImode)
              || !
#line 5424 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_V2 && TARGET_SWAP))
            return -1;
          return 229; /* bswapsi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x2) != E_V2HImode
              || !nonmemory_operand (operands[1], E_V2HImode)
              || !
#line 1501 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_V2 && TARGET_SWAP))
            return -1;
          return 479; /* bswapv2hi2 */

        default:
          return -1;
        }

    case DIV:
      return recog_30 (x1, insn, pnum_clobbers);

    case UDIV:
      if (pattern4 (x1) != 0
          || !
#line 5497 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DIVREM))
        return -1;
      return 234; /* udivsi3 */

    case MOD:
      if (pattern4 (x1) != 0
          || !
#line 5510 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DIVREM))
        return -1;
      return 235; /* modsi3 */

    case UMOD:
      if (pattern4 (x1) != 0
          || !
#line 5523 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DIVREM))
        return -1;
      return 236; /* umodsi3 */

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (!register_operand (x4, E_SImode))
        return -1;
      x9 = XEXP (x2, 2);
      if (!const_int_operand (x9, E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          operands[1] = x4;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x9;
          if (
#line 5649 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_HS && TARGET_BARREL_SHIFTER))
            return 247; /* extzvsi */
          if (!
#line 5940 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32))
            return -1;
          return 254; /* *extzv_i */

        case ZERO_EXTRACT:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x13 = XEXP (x3, 0);
          operands[0] = x13;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x14 = XEXP (x3, 1);
          operands[1] = x14;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x3, 2);
          operands[2] = x15;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x4;
          operands[4] = x9;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1])
              || !
#line 5979 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS))
            return -1;
          return 256; /* *movb */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x4 = XEXP (x2, 0);
      if (!register_operand (x4, E_SImode))
        return -1;
      operands[3] = x4;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == ZERO_EXTRACT
          && pattern5 (x3) == 0)
        {
          x9 = XEXP (x2, 2);
          operands[4] = x9;
          if (const_int_operand (operands[4], E_SImode)
              && rtx_equal_p (x8, operands[1])
              && 
#line 5991 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NPS_BITOPS))
            return 257; /* *movb_signed */
        }
      operands[1] = x4;
      x9 = XEXP (x2, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (XWINT (x8, 0) == 1L
          && 
#line 6122 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER))
        return 261; /* *extvsi_1_0 */
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_QImode)
          || !
#line 6135 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && IN_RANGE (INTVAL (operands[2]), 2,
		(optimize_insn_for_size_p () ? 28 : 30))))
        return -1;
      return 262; /* *extvsi_n_0 */

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          if (register_operand (operands[1], E_SFmode)
              && 
#line 690 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
            return 328; /* *sqrtsf2_quark */
          if (!nonmemory_operand (operands[1], E_SFmode)
              || !
#line 227 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_SQRT))
            return -1;
          return 341; /* sqrtsf2_fpu */

        case E_DFmode:
          if (!even_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !even_register_operand (operands[1], E_DFmode)
              || !
#line 335 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_SQRT))
            return -1;
          return 349; /* sqrtdf2 */

        default:
          return -1;
        }

    case FIX:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != FIX)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          switch (pattern64 (x2, 
E_SImode))
            {
            case 0:
              if (
#line 700 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
                return 329; /* *fix_truncsfsi2_quark */
              if (!
#line 483 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_CONV))
                return -1;
              return 361; /* fix_truncsfsi2_fpu */

            case 1:
              if (!
#line 591 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 370; /* fix_truncdfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          if (!even_register_operand (operands[0], E_DImode))
            return -1;
          switch (pattern64 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 435 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 357; /* fix_truncsfdi2 */

            case 1:
              if (!
#line 531 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 365; /* fix_truncdfdi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          switch (pattern50 (x2, 
E_SFmode))
            {
            case 0:
              if (
#line 710 "../../gcc-15.0.1-20250313/gcc/config/arc/fpx.md"
(TARGET_FPX_QUARK))
                return 330; /* *floatsisf2_quark */
              if (!
#line 447 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_CONV))
                return -1;
              return 358; /* floatsisf2_fpu */

            case 1:
              if (!
#line 555 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 367; /* floatdisf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!even_register_operand (operands[0], E_DFmode))
            return -1;
          switch (pattern50 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 399 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 354; /* floatsidf2 */

            case 1:
              if (!
#line 495 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 362; /* floatdidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FMA:
      return recog_20 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!even_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 387 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
        return -1;
      return 353; /* extendsfdf2 */

    case UNSIGNED_FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!even_register_operand (operands[0], E_DFmode))
            return -1;
          switch (pattern50 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 411 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 355; /* floatunssidf2 */

            case 1:
              if (!
#line 507 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 363; /* floatunsdidf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          switch (pattern50 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_CONV))
                return -1;
              return 359; /* floatunssisf2 */

            case 1:
              if (!
#line 567 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 368; /* floatunsdisf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != FIX)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!even_register_operand (operands[0], E_DImode))
            return -1;
          switch (pattern64 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 423 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 356; /* fixuns_truncsfdi2 */

            case 1:
              if (!
#line 519 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 364; /* fixuns_truncdfdi2 */

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          switch (pattern64 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 471 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_SP_CONV))
                return -1;
              return 360; /* fixuns_truncsfsi2 */

            case 1:
              if (!
#line 579 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
                return -1;
              return 369; /* fixuns_truncdfsi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!even_register_operand (operands[1], E_DFmode)
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/arc/fpu.md"
(TARGET_FP_DP_CONV))
        return -1;
      return 366; /* truncdfsf2 */

    case VEC_SELECT:
      return recog_23 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_15 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern8 (x2))
        {
        case 0:
          return 525; /* vec_duplicatev2si */

        case 1:
          if (!
#line 2083 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_BARREL_SHIFTER))
            return -1;
          return 526; /* vec_duplicatev4hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
