/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !nonmemory_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !nonmemory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!even_register_operand (operands[0], E_V2SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern23 (x1, 
E_DImode, 
E_CCmode) != 0)
    return -1;
  return 0;
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 60
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 61
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!dest_reg_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern37 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern43 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern47 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V8HImode
      || !vector_register_operand (operands[0], E_V8HImode)
      || !vector_register_operand (operands[1], E_V8HImode)
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  operands[3] = x2;
  if (!vector_register_operand (operands[3], E_V8HImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern77 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XEXP (x6, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x10 = XEXP (x3, 1);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 56
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XEXP (x2, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 56
      || GET_MODE (x11) != E_DImode)
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != ZERO_EXTRACT
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS
      || GET_MODE (x14) != E_DImode)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != MULT
      || GET_MODE (x15) != E_DImode)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != i2
      || GET_MODE (x16) != E_DImode)
    return -1;
  x17 = XEXP (x15, 1);
  if (GET_CODE (x17) != ASHIFT
      || GET_MODE (x17) != E_DImode)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != i1
      || GET_MODE (x18) != E_DImode)
    return -1;
  x19 = XEXP (x18, 1);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x20 = XEXP (x18, 2);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x21 = XEXP (x17, 1);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x22 = XEXP (x14, 1);
  if (GET_CODE (x22) != REG
      || REGNO (x22) != 56
      || GET_MODE (x22) != E_DImode)
    return -1;
  x23 = XEXP (x13, 1);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x24 = XEXP (x13, 2);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x25 = XEXP (x4, 0);
  if (GET_MODE (x25) != E_DImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  x26 = XEXP (x6, 0);
  operands[2] = x26;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x27 = XEXP (x12, 0);
  operands[0] = x27;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x28 = XEXP (x16, 0);
  if (!rtx_equal_p (x28, operands[1]))
    return -1;
  x29 = XEXP (x18, 0);
  if (!rtx_equal_p (x29, operands[2]))
    return -1;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !nonmemory_operand (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!_1_2_3_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern107 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != VEC_SELECT
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PARALLEL
      || XVECLEN (x8, 0) != 1)
    return -1;
  x9 = XVECEXP (x8, 0, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x2, 1);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != VEC_SELECT
      || GET_MODE (x11) != E_HImode)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != PARALLEL
      || XVECLEN (x12, 0) != 1)
    return -1;
  x13 = XVECEXP (x12, 0, 0);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XEXP (x10, 1);
  if (GET_CODE (x14) != VEC_SELECT
      || GET_MODE (x14) != E_HImode)
    return -1;
  x15 = XEXP (x14, 1);
  if (GET_CODE (x15) != PARALLEL
      || XVECLEN (x15, 0) != 1)
    return -1;
  x16 = XVECEXP (x15, 0, 0);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x17 = XEXP (x1, 1);
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != i2)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != VEC_SELECT
      || GET_MODE (x19) != E_HImode)
    return -1;
  x20 = XEXP (x19, 1);
  if (GET_CODE (x20) != PARALLEL
      || XVECLEN (x20, 0) != 1)
    return -1;
  x21 = XVECEXP (x20, 0, 0);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x22 = XEXP (x18, 1);
  if (GET_CODE (x22) != VEC_SELECT
      || GET_MODE (x22) != E_HImode)
    return -1;
  x23 = XEXP (x22, 1);
  if (GET_CODE (x23) != PARALLEL
      || XVECLEN (x23, 0) != 1)
    return -1;
  x24 = XVECEXP (x23, 0, 0);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x25 = XEXP (x17, 1);
  if (GET_CODE (x25) != i1)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != VEC_SELECT
      || GET_MODE (x26) != E_HImode)
    return -1;
  x27 = XEXP (x26, 1);
  if (GET_CODE (x27) != PARALLEL
      || XVECLEN (x27, 0) != 1)
    return -1;
  x28 = XVECEXP (x27, 0, 0);
  if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x29 = XEXP (x25, 1);
  if (GET_CODE (x29) != VEC_SELECT
      || GET_MODE (x29) != E_HImode)
    return -1;
  x30 = XEXP (x29, 1);
  if (GET_CODE (x30) != PARALLEL
      || XVECLEN (x30, 0) != 1)
    return -1;
  x31 = XVECEXP (x30, 0, 0);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x32 = XEXP (x4, 0);
  operands[1] = x32;
  if (!even_register_operand (operands[1], E_V4HImode))
    return -1;
  x33 = XEXP (x7, 0);
  operands[2] = x33;
  if (!even_register_operand (operands[2], E_V4HImode))
    return -1;
  x34 = XEXP (x11, 0);
  if (!rtx_equal_p (x34, operands[1]))
    return -1;
  x35 = XEXP (x14, 0);
  if (!rtx_equal_p (x35, operands[2]))
    return -1;
  x36 = XEXP (x19, 0);
  if (!rtx_equal_p (x36, operands[1]))
    return -1;
  x37 = XEXP (x22, 0);
  if (!rtx_equal_p (x37, operands[2]))
    return -1;
  x38 = XEXP (x26, 0);
  if (!rtx_equal_p (x38, operands[1]))
    return -1;
  x39 = XEXP (x29, 0);
  if (!rtx_equal_p (x39, operands[2]))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern82 (x2, 
E_SImode) != 0)
        return -1;
      return 54; /* *movsicc_insn */

    case E_DImode:
      if (pattern82 (x2, 
E_DImode) != 0)
        return -1;
      return 55; /* *movdicc_insn */

    case E_SFmode:
      if (pattern82 (x2, 
E_SFmode) != 0)
        return -1;
      return 56; /* *movsfcc_insn */

    case E_DFmode:
      if (!dest_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode)
        return -1;
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!nonmemory_operand (operands[2], E_DFmode))
        return -1;
      x7 = XEXP (x2, 2);
      operands[3] = x7;
      if (!register_operand (operands[3], E_DFmode))
        return -1;
      return 57; /* *movdfcc_insn */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 14:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!move_dest_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 5; /* store_direct */

        case 13:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != DIV
              || GET_MODE (x4) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!dest_reg_operand (operands[0], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!general_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!general_operand (operands[2], E_SImode)
              || !
#line 4681 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_ARC700 || TARGET_EA_SET))
            return -1;
          return 180; /* divaw */

        case 17:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!dest_reg_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!general_operand (operands[1], E_SImode)
              || !
#line 5687 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM && TARGET_V2))
            return -1;
          return 250; /* ffs */

        case 18:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!nonmemory_operand (operands[1], E_SImode)
              || !
#line 5723 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM && TARGET_V2))
            return -1;
          return 252; /* fls */

        case 33:
          if (GET_MODE (x2) != E_CC_Cmode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != AND
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 61
              || GET_MODE (x3) != E_CC_Cmode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          return 272; /* btst_0_carry */

        case 137:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 449; /* vabsaw_insn */

        case 138:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 450; /* vabsw_insn */

        case 139:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 451; /* vaddsuw_insn */

        case 140:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1089 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 452; /* vsignw_insn */

        case 141:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1099 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 453; /* vexch1_insn */

        case 142:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1109 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 454; /* vexch2_insn */

        case 143:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 455; /* vexch4_insn */

        case 144:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 456; /* vupbaw_insn */

        case 145:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1139 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 457; /* vupbw_insn */

        case 146:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1149 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 458; /* vupsbaw_insn */

        case 147:
          if (GET_MODE (x2) != E_V8HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!vector_register_operand (operands[0], E_V8HImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!vector_register_operand (operands[1], E_V8HImode)
              || !
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 459; /* vupsbw_insn */

        case 27:
          if (pattern11 (x1, pnum_clobbers, 
E_V4HImode, 
E_HImode) != 0
              || !
#line 2046 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          *pnum_clobbers = 1;
          return 523; /* reduc_plus_scal_v4hi */

        case 24:
          if (pattern11 (x1, pnum_clobbers, 
E_V2SImode, 
E_SImode) != 0
              || !
#line 2056 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
            return -1;
          *pnum_clobbers = 1;
          return 524; /* reduc_plus_scal_v2si */

        case 19:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          if (!rtx_equal_p (x4, operands[0]))
            return -1;
          return 527; /* *memory_barrier */

        default:
          return -1;
        }

    case 2:
      return recog_3 (x1, insn, pnum_clobbers);

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x7 = XVECEXP (x2, 0, 1);
      operands[2] = x7;
      switch (XINT (x2, 1))
        {
        case 121:
          if (pattern56 (x2) != 0
              || !
#line 1024 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 446; /* vsr8_insn */

        case 120:
          if (pattern56 (x2) != 0
              || !
#line 1036 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 447; /* vasrw_insn */

        case 122:
          if (pattern56 (x2) != 0
              || !
#line 1048 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_SIMD_SET))
            return -1;
          return 448; /* vsr8aw_insn */

        case 20:
          if (pattern57 (x2, pnum_clobbers) != 0
              || !
#line 1847 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
            return -1;
          *pnum_clobbers = 1;
          return 504; /* dmach */

        case 21:
          if (pattern57 (x2, pnum_clobbers) != 0
              || !
#line 1861 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_DMPY))
            return -1;
          *pnum_clobbers = 1;
          return 505; /* dmachu */

        case 22:
          if (pattern58 (x2, pnum_clobbers) != 0
              || !even_register_operand (operands[0], E_DImode)
              || !even_register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2HImode)
              || !
#line 1875 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          *pnum_clobbers = 1;
          return 506; /* dmacwh */

        case 23:
          if (pattern58 (x2, pnum_clobbers) != 0
              || !register_operand (operands[0], E_DImode)
              || !even_register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2HImode)
              || !
#line 1889 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          *pnum_clobbers = 1;
          return 507; /* dmacwhu */

        case 29:
          if (pattern59 (x2, pnum_clobbers) != 0
              || !
#line 1903 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
            return -1;
          *pnum_clobbers = 1;
          return 508; /* vmac2h */

        case 30:
          if (pattern59 (x2, pnum_clobbers) != 0
              || !
#line 1917 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_MACD))
            return -1;
          *pnum_clobbers = 1;
          return 509; /* vmac2hu */

        case 25:
          if (pattern60 (x2, pnum_clobbers) != 0
              || !
#line 1957 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          *pnum_clobbers = 1;
          return 512; /* qmach */

        case 26:
          if (pattern60 (x2, pnum_clobbers) != 0
              || !
#line 1971 "../../gcc-15.0.1-20250313/gcc/config/arc/simdext.md"
(TARGET_PLUS_QMACW))
            return -1;
          *pnum_clobbers = 1;
          return 513; /* qmachu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case ASHIFT:
          if (pattern26 (x1) != 0
              || !
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx))
            return -1;
          return 133; /* ashlsi3_loop */

        case ASHIFTRT:
          if (pattern26 (x1) != 0
              || !
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx))
            return -1;
          return 134; /* ashrsi3_loop */

        case LSHIFTRT:
          if (pattern26 (x1) != 0
              || !
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx))
            return -1;
          return 135; /* lshrsi3_loop */

        case ROTATE:
          if (pattern26 (x1) != 0
              || !
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx))
            return -1;
          return 136; /* rotlsi3_loop */

        case ROTATERT:
          if (pattern26 (x1) != 0
              || !
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(!TARGET_BARREL_SHIFTER
   && operands[2] != const1_rtx))
            return -1;
          return 137; /* rotrsi3_loop */

        case CTZ:
          if (pattern27 (x1) != 0
              || !
#line 4645 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_NORM))
            return -1;
          return 179; /* arc_ctzsi2 */

        case CALL:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SIMPLE_RETURN)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != USE)
            return -1;
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          if (!dest_reg_operand (operands[0], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!call_address_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          x10 = XEXP (x6, 0);
          operands[3] = x10;
          return 204; /* *sibcall_value_insn */

        case IF_THEN_ELSE:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != NE)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != CONST_INT
              || pattern31 (x1) != 0)
            return -1;
          x9 = XEXP (x3, 1);
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          x8 = XEXP (x4, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
            case MEM:
              if (pnum_clobbers == NULL)
                return -1;
              operands[0] = x8;
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || XWINT (x11, 0) != 1L)
                return -1;
              x6 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x6) != UNSPEC
                  || XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 15
                  || GET_MODE (x6) != E_SImode)
                return -1;
              x13 = XVECEXP (x6, 0, 0);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              x14 = XEXP (x5, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[0]))
                return -1;
              x16 = XEXP (x5, 0);
              if (!rtx_equal_p (x16, operands[0]))
                return -1;
              *pnum_clobbers = 1;
              return 211; /* loop_end */

            case PLUS:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              x17 = XEXP (x8, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
                  || XWINT (x11, 0) != 0L)
                return -1;
              x6 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x18 = XEXP (x8, 0);
              operands[0] = x18;
              if (!nonimmediate_operand (operands[0], E_SImode))
                return -1;
              x10 = XEXP (x6, 0);
              operands[2] = x10;
              if (!scratch_operand (operands[2], E_SImode))
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              x14 = XEXP (x5, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[0]))
                return -1;
              x16 = XEXP (x5, 0);
              if (!rtx_equal_p (x16, operands[0])
                  || !
#line 5241 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_DBNZ))
                return -1;
              return 213; /* dbnz */

            default:
              return -1;
            }

        case COMPARE:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 0)
            return -1;
          x9 = XEXP (x3, 1);
          if (GET_CODE (x9) != REG)
            return -1;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 61)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x16 = XEXP (x5, 0);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 31
              || GET_MODE (x16) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x10 = XEXP (x6, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 12
              || GET_MODE (x10) != E_SImode)
            return -1;
          switch (REGNO (x9))
            {
            case 1:
              switch (pattern115 (x2, 
E_SFmode))
                {
                case 0:
                  if (!
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE))
                    return -1;
                  return 214; /* *cmpsf_eq */

                case 1:
                  if (!
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE))
                    return -1;
                  return 215; /* *cmpsf_gt */

                case 2:
                  if (!
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE))
                    return -1;
                  return 216; /* *cmpsf_ge */

                case 3:
                  if (!
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE))
                    return -1;
                  return 217; /* *cmpsf_uneq */

                case 4:
                  if (!
#line 5304 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_SPFP)
   && SFUNC_CHECK_PREDICABLE))
                    return -1;
                  return 218; /* *cmpsf_ord */

                default:
                  return -1;
                }

            case 2:
              switch (pattern115 (x2, 
E_DFmode))
                {
                case 0:
                  if (!
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE))
                    return -1;
                  return 219; /* *cmpdf_eq */

                case 1:
                  if (!
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE))
                    return -1;
                  return 220; /* *cmpdf_gt */

                case 2:
                  if (!
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE))
                    return -1;
                  return 221; /* *cmpdf_ge */

                case 3:
                  if (!
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE))
                    return -1;
                  return 222; /* *cmpdf_uneq */

                case 4:
                  if (!
#line 5317 "../../gcc-15.0.1-20250313/gcc/config/arc/arc.md"
(TARGET_OPTFPE && (!TARGET_ARGONAUT_SET || !TARGET_DPFP)
   && SFUNC_CHECK_PREDICABLE))
                    return -1;
                  return 223; /* *cmpdf_ord */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (pattern28 (x1) != 0
              || !
#line 85 "../../gcc-15.0.1-20250313/gcc/config/arc/atomic.md"
(TARGET_ATOMIC))
            return -1;
          return 528; /* atomic_compare_and_swapsi_1 */

        default:
          return -1;
        }

    case CALL:
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SIMPLE_RETURN)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != USE)
        return -1;
      x19 = XEXP (x7, 0);
      operands[0] = x19;
      if (!call_address_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x10 = XEXP (x6, 0);
      operands[2] = x10;
      return 203; /* *sibcall_insn */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 15
          || GET_MODE (x2) != E_SImode)
        return -1;
      x20 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x20) != REG
          || REGNO (x20) != 60
          || GET_MODE (x20) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x16 = XEXP (x5, 0);
      if (GET_CODE (x16) != LABEL_REF)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != USE)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != LABEL_REF)
        return -1;
      x21 = XEXP (x16, 0);
      operands[0] = x21;
      x22 = XEXP (x10, 0);
      operands[1] = x22;
      return 210; /* arc_lp */

    default:
      return -1;
    }
}
