/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_PDImode:
      if (!register_operand (operands[0], E_PDImode)
          || GET_MODE (x3) != E_PDImode
          || !register_operand (operands[1], E_PDImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  return 0;
}

int
pattern25 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XEXP (x2, 0);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x10 = XEXP (x3, 0);
  operands[3] = x10;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x11 = XVECEXP (x4, 0, 0);
  operands[5] = x11;
  if (!const01_operand (operands[5], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  return 0;
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PDImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[4] = x5;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XVECEXP (x8, 0, 0);
  operands[6] = x9;
  if (!const01_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  operands[10] = x10;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case HIGH:
      if (GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              switch (GET_CODE (x4))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[1] = x4;
                  if (immediate_operand (operands[1], E_SImode)
                      && 
#line 460 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
                    return 7; /* movsi_high */
                  break;

                case UNSPEC:
                  if (XVECLEN (x4, 0) == 1
                      && XINT (x4, 1) == 3
                      && GET_MODE (x4) == E_SImode)
                    {
                      x5 = XVECEXP (x4, 0, 0);
                      operands[1] = x5;
                      return 10; /* movsi_high_pic */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 92; /* jump */
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (!immediate_operand (operands[1], E_HImode))
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != STRICT_LOW_PART)
    return -1;
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  return 27; /* movstricthi_1 */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (pattern3 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  x11 = XEXP (x10, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x12 = XEXP (x8, 1);
  x13 = XEXP (x12, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  return 95; /* loop_end */
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case IF_THEN_ELSE:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != NE)
            return -1;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x7 = XEXP (x3, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x11 = XEXP (x10, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x12 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x12) != UNSPEC
              || XVECLEN (x12, 0) != 1
              || XINT (x12, 1) != 10)
            return -1;
          x13 = XVECEXP (x12, 0, 0);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x14 = XEXP (x4, 0);
          operands[2] = x14;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x16 = XEXP (x9, 0);
          operands[0] = x16;
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          x17 = XEXP (x10, 0);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          *pnum_clobbers = 2;
          return 95; /* loop_end */

        case LABEL_REF:
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!lt_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          x16 = XEXP (x9, 0);
          operands[2] = x16;
          if (!lb_register_operand (operands[2], E_SImode))
            return -1;
          x17 = XEXP (x10, 0);
          operands[3] = x17;
          x12 = XVECEXP (x1, 0, 2);
          switch (GET_CODE (x12))
            {
            case SET:
              x18 = XEXP (x12, 0);
              operands[4] = x18;
              if (!lc_register_operand (operands[4], E_SImode))
                return -1;
              x19 = XEXP (x12, 1);
              operands[5] = x19;
              if (!register_operand (operands[5], E_SImode))
                return -1;
              return 96; /* lsetup_with_autoinit */

            case USE:
              x18 = XEXP (x12, 0);
              operands[4] = x18;
              if (!lc_register_operand (operands[4], E_SImode))
                return -1;
              return 97; /* lsetup_without_autoinit */

            default:
              return -1;
            }

        case CALL:
          switch (pattern14 (x1))
            {
            case 0:
              x12 = XVECEXP (x1, 0, 2);
              switch (pattern41 (x12, pnum_clobbers))
                {
                case 0:
                  if (!
#line 2133 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[4]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 101; /* *call_value_symbol_fdpic */

                case 1:
                  if (!
#line 2232 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[3]))))
                    return -1;
                  return 109; /* *call_value_symbol */

                case 2:
                  if (!
#line 2246 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[3]))))
                    return -1;
                  return 110; /* *sibcall_value_symbol */

                default:
                  return -1;
                }

            case 1:
              x12 = XVECEXP (x1, 0, 2);
              switch (pattern41 (x12, pnum_clobbers))
                {
                case 0:
                  if (!
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 105; /* *call_value_insn_fdpic */

                case 1:
                  if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                    return -1;
                  return 113; /* *call_value_insn */

                case 2:
                  if (!
#line 2291 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)))
                    return -1;
                  return 114; /* *sibcall_value_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 3
              || XINT (x3, 1) != 6
              || pattern24 (x3) != 0)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != UNSPEC
              || XVECLEN (x10, 0) != 5
              || XINT (x10, 1) != 7
              || pattern46 (x10) != 0)
            return -1;
          x12 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x12) != SET)
            return -1;
          x19 = XEXP (x12, 1);
          if (GET_CODE (x19) != AND
              || GET_MODE (x19) != E_BImode)
            return -1;
          x20 = XEXP (x19, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 34
              || GET_MODE (x20) != E_BImode)
            return -1;
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != UNSPEC
              || XVECLEN (x21, 0) != 3
              || XINT (x21, 1) != 6
              || GET_MODE (x21) != E_BImode)
            return -1;
          x22 = XVECEXP (x21, 0, 0);
          if (GET_CODE (x22) != VEC_SELECT
              || GET_MODE (x22) != E_HImode)
            return -1;
          x23 = XEXP (x22, 1);
          if (GET_CODE (x23) != PARALLEL
              || XVECLEN (x23, 0) != 1)
            return -1;
          x24 = XVECEXP (x21, 0, 1);
          if (GET_CODE (x24) != VEC_SELECT
              || GET_MODE (x24) != E_HImode)
            return -1;
          x25 = XEXP (x24, 1);
          if (GET_CODE (x25) != PARALLEL
              || XVECLEN (x25, 0) != 1)
            return -1;
          x18 = XEXP (x12, 0);
          if (GET_CODE (x18) != REG
              || REGNO (x18) != 34
              || GET_MODE (x18) != E_BImode)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (pattern51 (x3) != 0
              || !const_int_operand (operands[10], E_VOIDmode)
              || pattern54 (x9) != 0)
            return -1;
          x26 = XEXP (x22, 0);
          if (!rtx_equal_p (x26, operands[2]))
            return -1;
          x27 = XVECEXP (x23, 0, 0);
          if (!rtx_equal_p (x27, operands[4]))
            return -1;
          x28 = XEXP (x24, 0);
          if (!rtx_equal_p (x28, operands[3]))
            return -1;
          x29 = XVECEXP (x25, 0, 0);
          if (!rtx_equal_p (x29, operands[6]))
            return -1;
          x30 = XVECEXP (x21, 0, 2);
          if (!rtx_equal_p (x30, operands[10])
              || !
#line 2438 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(MACFLAGS_MATCH_P (INTVAL (operands[10]), INTVAL (operands[11]))))
            return -1;
          return 122; /* flag_mul_macv2hi_parts_acconly_andcc0 */

        case MEM:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x16 = XEXP (x9, 0);
          if (GET_MODE (x16) != E_SImode)
            return -1;
          if (GET_CODE (x16) == REG
              && REGNO (x16) == 35)
            {
              res = recog_14 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (GET_CODE (x16) != MEM)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != UNSPEC
              || XVECLEN (x10, 0) != 4
              || XINT (x10, 1) != 13
              || GET_MODE (x10) != E_SImode)
            return -1;
          x31 = XVECEXP (x10, 0, 0);
          if (GET_CODE (x31) != MEM
              || GET_MODE (x31) != E_SImode)
            return -1;
          x12 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x12) != CLOBBER)
            return -1;
          x18 = XEXP (x12, 0);
          if (GET_CODE (x18) != REG
              || REGNO (x18) != 35
              || GET_MODE (x18) != E_SImode)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || pattern47 (x10) != 0)
            return -1;
          x32 = XEXP (x16, 0);
          if (!rtx_equal_p (x32, operands[1]))
            return -1;
          return 259; /* sync_compare_and_swapsi_internal */

        default:
          return -1;
        }

    case CALL:
      switch (pattern6 (x1))
        {
        case 0:
          x12 = XVECEXP (x1, 0, 2);
          switch (pattern35 (x12, pnum_clobbers))
            {
            case 0:
              if (!
#line 2106 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[3]))))
                return -1;
              *pnum_clobbers = 1;
              return 99; /* *call_symbol_fdpic */

            case 1:
              if (!
#line 2205 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[2]))))
                return -1;
              return 107; /* *call_symbol */

            case 2:
              if (!
#line 2218 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[2]))))
                return -1;
              return 108; /* *sibcall_symbol */

            default:
              return -1;
            }

        case 1:
          x12 = XVECEXP (x1, 0, 2);
          switch (pattern35 (x12, pnum_clobbers))
            {
            case 0:
              if (!
#line 2160 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                return -1;
              *pnum_clobbers = 1;
              return 103; /* *call_insn_fdpic */

            case 1:
              if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                return -1;
              return 111; /* *call_insn */

            case 2:
              if (!
#line 2269 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)))
                return -1;
              return 112; /* *sibcall_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
