/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 3
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (pattern4 (x1, 
E_V2HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_PDImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V2HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != VEC_CONCAT
      || GET_MODE (x7) != E_V2HImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XEXP (x7, 1);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_HImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  return 0;
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_PDImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[5] = x6;
  if (!const01_operand (operands[5], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XVECEXP (x8, 0, 0);
  operands[7] = x9;
  if (!const01_operand (operands[7], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x3, 0, 2);
  operands[8] = x10;
  if (!register_operand (operands[8], E_PDImode))
    return -1;
  x11 = XVECEXP (x3, 0, 3);
  operands[9] = x11;
  if (!const01_operand (operands[9], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x3, 0, 4);
  operands[11] = x12;
  if (!const_int_operand (operands[11], E_VOIDmode))
    return -1;
  x13 = XEXP (x4, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[3]))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case MEM:
      if (GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x2, 0);
          if (GET_CODE (x3) == POST_INC
              && GET_MODE (x3) == E_SImode)
            {
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) == REG
                  && REGNO (x4) == 14
                  && GET_MODE (x4) == E_SImode)
                {
                  x5 = XEXP (x1, 0);
                  operands[0] = x5;
                  if (register_operand (operands[0], E_SImode))
                    return 18; /* *popsi_insn */
                }
            }
        }
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && general_operand (operands[1], E_DImode)
          && 
#line 507 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 12; /* movdi_insn */
      break;

    case E_BImode:
      if (nonimmediate_operand (operands[0], E_BImode)
          && general_operand (operands[1], E_BImode))
        return 13; /* movbi */
      break;

    case E_PDImode:
      if (nonimmediate_operand (operands[0], E_PDImode)
          && general_operand (operands[1], E_PDImode))
        return 14; /* movpdi */
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && general_operand (operands[1], E_SImode)
          && 
#line 609 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 19; /* *movsi_insn */
      break;

    case E_V2HImode:
      if (nonimmediate_operand (operands[0], E_V2HImode)
          && general_operand (operands[1], E_V2HImode)
          && 
#line 649 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 21; /* *movv2hi_insn */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode)
          && 
#line 671 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 22; /* *movhi_insn */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && general_operand (operands[1], E_QImode)
          && 
#line 695 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 23; /* *movqi_insn */
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && general_operand (operands[1], E_SFmode)
          && 
#line 708 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 24; /* *movsf_insn */
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode)
          && 
#line 719 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) == REG))
        return 25; /* movdf_insn */
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
    return -1;
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 243; /* loadbytes */
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && general_operand (operands[1], E_DImode)
                  && 
#line 509 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
                return gen_split_1 (insn, operands);
              break;

            case E_SImode:
              if (d_register_operand (operands[0], E_SImode)
                  && d_register_operand (operands[1], E_SImode)
                  && 
#line 642 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(splitting_for_sched && !optimize_size))
                return gen_split_4 (insn, operands);
              break;

            case E_V2HImode:
              if (nonimmediate_operand (operands[0], E_V2HImode)
                  && general_operand (operands[1], E_V2HImode)
                  && 
#line 655 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed && GET_CODE (operands[1]) == CONST_VECTOR))
                return gen_split_5 (insn, operands);
              break;

            case E_DFmode:
              if (nonimmediate_operand (operands[0], E_DFmode)
                  && general_operand (operands[1], E_DFmode)
                  && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
                return gen_split_6 (insn, operands);
              break;

            case E_SFmode:
              if (register_operand (operands[0], E_SFmode)
                  && immediate_operand (operands[1], E_SFmode)
                  && 
#line 847 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
                return gen_split_8 (insn, operands);
              break;

            default:
              break;
            }
          if (x3 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
              && d_register_operand (operands[0], E_SImode)
              && 
#line 636 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(splitting_for_sched && !optimize_size))
            return gen_split_3 (insn, operands);
          operands[1] = x3;
          if (!symbolic_or_const_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !
#line 828 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed
   /* Always split symbolic operands; split integer constants that are
      too large for a single instruction.  */
   && (GET_CODE (operands[1]) != CONST_INT
       || (INTVAL (operands[1]) < -32768
 	   || INTVAL (operands[1]) >= 65536
	   || (INTVAL (operands[1]) >= 32768 && PREG_P (operands[0]))))))
            return NULL;
          return gen_split_7 (insn, operands);

        case SIGN_EXTEND:
          x4 = XEXP (x3, 0);
          switch (GET_CODE (x4))
            {
            case VEC_CONCAT:
              if (pattern7 (x3) != 0
                  || !
#line 576 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
                return NULL;
              return gen_split_2 (insn, operands);

            case REG:
            case SUBREG:
            case MEM:
              operands[1] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode
                      || !nonimmediate_operand (operands[1], E_HImode)
                      || !
#line 890 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed && bfin_dsp_memref_p (operands[1])))
                    return NULL;
                  return gen_split_9 (insn, operands);

                case E_DImode:
                  switch (pattern17 (x3))
                    {
                    case 0:
                      if (!
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
                        return NULL;
                      return gen_split_11 (insn, operands);

                    case 1:
                      if (!
#line 1028 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
                        return NULL;
                      return gen_split_12 (insn, operands);

                    case 2:
                      if (!
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
                        return NULL;
                      return gen_split_13 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!nonimmediate_operand (operands[1], E_HImode)
              || !
#line 905 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed && bfin_dsp_memref_p (operands[1])))
            return NULL;
          return gen_split_10 (insn, operands);

        case ASHIFT:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SImode)
              || !
#line 1686 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(PREG_P (operands[0]) && INTVAL (operands[2]) > 2))
            return NULL;
          return gen_split_16 (insn, operands);

        case UNSPEC_VOLATILE:
          if (pattern1 (x3) != 0
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x6 = XVECEXP (x3, 0, 0);
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!address_operand (operands[1], E_SImode)
              || !
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
            return NULL;
          return gen_split_18 (insn, operands);

        case NE:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_BImode))
            return NULL;
          return gen_split_19 (insn, operands);

        case VEC_CONCAT:
          if (GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[0], E_V2HImode))
            return NULL;
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_HImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_HImode)
              || !
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x8 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x8) != SET)
            return NULL;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != ZERO_EXTRACT)
            return NULL;
          switch (pattern13 (x1))
            {
            case 0:
              return gen_split_14 (insn, operands);

            case 1:
              return gen_split_15 (insn, operands);

            default:
              return NULL;
            }

        case 5:
          if (pattern3 (x1) != 0)
            return NULL;
          x8 = XVECEXP (x1, 0, 0);
          x9 = XEXP (x8, 1);
          x10 = XEXP (x9, 0);
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!nondp_reg_or_memory_operand (operands[0], E_SImode))
            return NULL;
          x12 = XEXP (x9, 1);
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          x14 = XVECEXP (x1, 0, 3);
          x15 = XEXP (x14, 0);
          operands[2] = x15;
          if (!scratch_operand (operands[2], E_SImode))
            return NULL;
          x16 = XVECEXP (x1, 0, 1);
          x17 = XEXP (x16, 1);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[0]))
            return NULL;
          x19 = XEXP (x16, 0);
          if (!rtx_equal_p (x19, operands[0])
              || !
#line 2008 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(memory_operand (operands[0], SImode) || splitting_loops))
            return NULL;
          return gen_split_17 (insn, operands);

        default:
          return NULL;
        }

    case EH_RETURN:
      if (!
#line 2700 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(epilogue_completed))
        return NULL;
      return gen_split_20 (insn, operands);

    default:
      return NULL;
    }
}
