/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_BImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!reg_or_const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_VOIDmode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!general_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  switch (GET_CODE (operands[1]))
    {
    case SYMBOL_REF:
      if (!symbol_ref_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_no_elim_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 35
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

int
pattern35 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case USE:
      if (pnum_clobbers == NULL
          || !register_operand (operands[2], E_SImode))
        return -1;
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      return 0;

    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 35
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    case RETURN:
      return 2;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case CLOBBER:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 35
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case RETURN:
      return 1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[3] = x3;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  operands[4] = x4;
  if (!register_no_elim_operand (operands[4], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  return 0;
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 0L:
      return 0;

    case 1L:
      return 1;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
      operands[0] = x2;
      if (register_operand (operands[0], E_SImode))
        {
          x3 = XEXP (x1, 0);
          switch (GET_CODE (x3))
            {
            case MEM:
              if (GET_MODE (x3) == E_SImode)
                {
                  x4 = XEXP (x3, 0);
                  if (GET_CODE (x4) == PRE_DEC
                      && GET_MODE (x4) == E_SImode)
                    {
                      x5 = XEXP (x4, 0);
                      if (GET_CODE (x5) == REG
                          && REGNO (x5) == 14
                          && GET_MODE (x5) == E_SImode)
                        return 17; /* *pushsi_insn */
                    }
                }
              break;

            case PC:
              return 93; /* indirect_jump */

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XEXP (x3, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_VOIDmode))
    return -1;
  return 26; /* *movsi_insv */
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case PLUS:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (pattern23 (x5, 
LTU, 
NOT, 
E_BImode) != 0
              || pattern30 (x1) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x8 = XEXP (x5, 1);
          if (!rtx_equal_p (x8, operands[2]))
            return -1;
          return 40; /* add_with_carry */

        case MINUS:
          if (pattern12 (x1, 
E_BImode, 
LEU) != 0
              || pattern30 (x1) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          x8 = XEXP (x5, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return -1;
          return 41; /* sub_with_carry */

        case SS_TRUNCATE:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != SS_PLUS
              || GET_MODE (x9) != E_PDImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != SS_PLUS
              || GET_MODE (x5) != E_PDImode)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_PDImode))
            return -1;
          x12 = XEXP (x9, 1);
          operands[3] = x12;
          if (!register_operand (operands[3], E_PDImode))
            return -1;
          x13 = XEXP (x4, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_PDImode))
            return -1;
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          x8 = XEXP (x5, 1);
          if (!rtx_equal_p (x8, operands[3]))
            return -1;
          return 55; /* sum_of_accumulators */

        case ZERO_EXTRACT:
          switch (pattern13 (x1))
            {
            case 0:
              return 59; /* *bit_extract */

            case 1:
              return 60; /* *not_bit_extract */

            default:
              return -1;
            }

        case IOR:
          if (pattern12 (x1, 
E_BImode, 
ZERO_EXTRACT) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x5 = XEXP (x4, 1);
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x14 = XEXP (x5, 2);
          if (GET_CODE (x14) != CONST_INT)
            return -1;
          x13 = XEXP (x4, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 34
              || GET_MODE (x13) != E_BImode)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x15 = XEXP (x3, 1);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          switch (GET_CODE (x9))
            {
            case LSHIFTRT:
              x12 = XEXP (x9, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || GET_CODE (x15) != ASHIFT)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != ZERO_EXTEND
                  || GET_MODE (x16) != E_SImode)
                return -1;
              x17 = XEXP (x16, 0);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 34
                  || GET_MODE (x17) != E_BImode)
                return -1;
              x18 = XEXP (x15, 1);
              if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
                  || XWINT (x14, 0) != 0L)
                return -1;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x5, 0);
              if (!rtx_equal_p (x6, operands[1]))
                return -1;
              return 83; /* ror_one */

            case ASHIFT:
              x12 = XEXP (x9, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || GET_CODE (x15) != ZERO_EXTEND)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 34
                  || GET_MODE (x16) != E_BImode
                  || XWINT (x14, 0) != 31L)
                return -1;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x5, 0);
              if (!rtx_equal_p (x6, operands[1]))
                return -1;
              return 84; /* rol_one */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x10 = XEXP (x2, 0);
          switch (GET_CODE (x10))
            {
            case REG:
            case SUBREG:
            case MEM:
              res = recog_10 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case PC:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) == USE)
                {
                  x13 = XEXP (x4, 0);
                  if (GET_CODE (x13) == LABEL_REF)
                    {
                      operands[0] = x3;
                      if (register_operand (operands[0], E_SImode))
                        {
                          x19 = XEXP (x13, 0);
                          operands[1] = x19;
                          return 94; /* *tablejump_internal */
                        }
                    }
                }
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL
              || GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XINT (x5, 1) != 13)
            return -1;
          x13 = XEXP (x4, 0);
          if (GET_CODE (x13) != MEM
              || GET_MODE (x13) != E_SImode)
            return -1;
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x3, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || GET_MODE (x5) != E_SImode)
            return -1;
          x19 = XEXP (x13, 0);
          if (!rtx_equal_p (x19, operands[1]))
            return -1;
          switch (XVECLEN (x5, 0))
            {
            case 2:
              x20 = XVECEXP (x5, 0, 0);
              if (GET_MODE (x20) != E_SImode)
                return -1;
              x21 = XVECEXP (x5, 0, 1);
              operands[3] = x21;
              if (!register_no_elim_operand (operands[3], E_SImode))
                return -1;
              switch (GET_CODE (x20))
                {
                case PLUS:
                  if (pattern48 (x20) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 249; /* sync_old_addsi_internal */

                case MINUS:
                  if (pattern48 (x20) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 250; /* sync_old_subsi_internal */

                case IOR:
                  if (pattern48 (x20) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 251; /* sync_old_iorsi_internal */

                case AND:
                  if (pattern48 (x20) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 252; /* sync_old_andsi_internal */

                case XOR:
                  if (pattern48 (x20) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 253; /* sync_old_xorsi_internal */

                default:
                  return -1;
                }

            case 4:
              x20 = XVECEXP (x5, 0, 0);
              if (GET_CODE (x20) != MEM
                  || GET_MODE (x20) != E_SImode
                  || pattern47 (x5) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 259; /* sync_compare_and_swapsi_internal */

            default:
              return -1;
            }

        case CALL:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern14 (x1))
            {
            case 0:
              if (!
#line 2232 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[3]))))
                return -1;
              *pnum_clobbers = 1;
              return 109; /* *call_value_symbol */

            case 1:
              if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                return -1;
              *pnum_clobbers = 1;
              return 113; /* *call_value_insn */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x9 = XEXP (x3, 0);
          if (!bfin_bimode_comparison_operator (x9, E_VOIDmode))
            return -1;
          operands[0] = x9;
          x15 = XEXP (x3, 1);
          if (GET_CODE (x15) != LABEL_REF)
            return -1;
          x22 = XEXP (x3, 2);
          if (GET_CODE (x22) != PC)
            return -1;
          x10 = XEXP (x2, 0);
          if (GET_CODE (x10) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != UNSPEC
              || XVECLEN (x4, 0) != 1)
            return -1;
          x11 = XEXP (x9, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          x12 = XEXP (x9, 1);
          operands[2] = x12;
          if (!immediate_operand (operands[2], E_BImode))
            return -1;
          x16 = XEXP (x15, 0);
          operands[3] = x16;
          switch (XINT (x4, 1))
            {
            case 0:
              x23 = XVECEXP (x4, 0, 0);
              if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 124; /* cbranch_predicted_taken */

            case 1:
              x23 = XVECEXP (x4, 0, 0);
              operands[4] = x23;
              if (!immediate_operand (operands[4], E_VOIDmode)
                  || !
#line 2531 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
                return -1;
              return 125; /* cbranch_with_nops */

            default:
              return -1;
            }

        case UNSPEC:
          return recog_11 (x1, insn, pnum_clobbers);

        case MULT:
          if (pattern12 (x1, 
E_SImode, 
MULT) != 0)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x15 = XEXP (x3, 1);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x4, 0);
          operands[3] = x13;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x8 = XEXP (x5, 1);
          if (GET_MODE (x8) != E_SImode)
            return -1;
          switch (GET_CODE (x9))
            {
            case SIGN_EXTEND:
              if (pattern44 (x1, 
SIGN_EXTEND) != 0)
                return -1;
              x11 = XEXP (x9, 0);
              x24 = XEXP (x11, 0);
              operands[1] = x24;
              if (!register_operand (operands[1], E_V2HImode))
                return -1;
              x16 = XEXP (x15, 0);
              x17 = XEXP (x16, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_V2HImode))
                return -1;
              x7 = XEXP (x6, 0);
              x25 = XEXP (x7, 0);
              if (!rtx_equal_p (x25, operands[1]))
                return -1;
              x26 = XEXP (x11, 1);
              x27 = XVECEXP (x26, 0, 0);
              switch (XWINT (x27, 0))
                {
                case 0L:
                  x28 = XEXP (x16, 1);
                  x29 = XVECEXP (x28, 0, 0);
                  switch (XWINT (x29, 0))
                    {
                    case 0L:
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      switch (XWINT (x31, 0))
                        {
                        case 0L:
                          switch (pattern56 (x8))
                            {
                            case 0:
                              return 208; /* mulhisi_ll_lh */

                            case 1:
                              return 220; /* usmulhisi_ll_lul */

                            case 2:
                              return 221; /* usmulhisi_ll_luh */

                            default:
                              return -1;
                            }

                        case 1L:
                          switch (GET_CODE (x8))
                            {
                            case SIGN_EXTEND:
                              x32 = XEXP (x8, 0);
                              switch (pattern55 (x32))
                                {
                                case 0:
                                  return 210; /* mulhisi_ll_hl */

                                case 1:
                                  return 212; /* mulhisi_ll_hh */

                                default:
                                  return -1;
                                }

                            case ZERO_EXTEND:
                              x32 = XEXP (x8, 0);
                              switch (pattern55 (x32))
                                {
                                case 0:
                                  return 222; /* usmulhisi_ll_hul */

                                case 1:
                                  return 223; /* usmulhisi_ll_huh */

                                default:
                                  return -1;
                                }

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case 1L:
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      switch (XWINT (x31, 0))
                        {
                        case 1L:
                          switch (GET_CODE (x8))
                            {
                            case SIGN_EXTEND:
                              x32 = XEXP (x8, 0);
                              switch (pattern55 (x32))
                                {
                                case 0:
                                  return 214; /* mulhisi_lh_hl */

                                case 1:
                                  return 216; /* mulhisi_lh_hh */

                                default:
                                  return -1;
                                }

                            case ZERO_EXTEND:
                              x32 = XEXP (x8, 0);
                              switch (pattern55 (x32))
                                {
                                case 0:
                                  return 226; /* usmulhisi_lh_hul */

                                case 1:
                                  return 227; /* usmulhisi_lh_huh */

                                default:
                                  return -1;
                                }

                            default:
                              return -1;
                            }

                        case 0L:
                          if (GET_CODE (x8) != ZERO_EXTEND)
                            return -1;
                          x32 = XEXP (x8, 0);
                          switch (pattern55 (x32))
                            {
                            case 0:
                              return 224; /* usmulhisi_lh_lul */

                            case 1:
                              return 225; /* usmulhisi_lh_luh */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1L:
                  x28 = XEXP (x16, 1);
                  x29 = XVECEXP (x28, 0, 0);
                  switch (XWINT (x29, 0))
                    {
                    case 0L:
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      switch (XWINT (x31, 0))
                        {
                        case 1L:
                          switch (pattern56 (x8))
                            {
                            case 0:
                              return 218; /* mulhisi_hl_hh */

                            case 1:
                              return 230; /* usmulhisi_hl_hul */

                            case 2:
                              return 231; /* usmulhisi_hl_huh */

                            default:
                              return -1;
                            }

                        case 0L:
                          if (GET_CODE (x8) != ZERO_EXTEND)
                            return -1;
                          x32 = XEXP (x8, 0);
                          switch (pattern55 (x32))
                            {
                            case 0:
                              return 228; /* usmulhisi_hl_lul */

                            case 1:
                              return 229; /* usmulhisi_hl_luh */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case 1L:
                      if (pattern52 (x8) != 0)
                        return -1;
                      x32 = XEXP (x8, 0);
                      x33 = XEXP (x32, 0);
                      if (!rtx_equal_p (x33, operands[2]))
                        return -1;
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      switch (XWINT (x31, 0))
                        {
                        case 0L:
                          x34 = XEXP (x32, 1);
                          x35 = XVECEXP (x34, 0, 0);
                          switch (XWINT (x35, 0))
                            {
                            case 0L:
                              return 232; /* usmulhisi_hh_lul */

                            case 1L:
                              return 233; /* usmulhisi_hh_luh */

                            default:
                              return -1;
                            }

                        case 1L:
                          x34 = XEXP (x32, 1);
                          x35 = XVECEXP (x34, 0, 0);
                          switch (XWINT (x35, 0))
                            {
                            case 0L:
                              return 234; /* usmulhisi_hh_hul */

                            case 1L:
                              return 235; /* usmulhisi_hh_huh */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern44 (x1, 
ZERO_EXTEND) != 0
                  || pattern52 (x8) != 0)
                return -1;
              x11 = XEXP (x9, 0);
              x24 = XEXP (x11, 0);
              operands[1] = x24;
              if (!register_operand (operands[1], E_V2HImode))
                return -1;
              x16 = XEXP (x15, 0);
              x17 = XEXP (x16, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_V2HImode))
                return -1;
              x7 = XEXP (x6, 0);
              x25 = XEXP (x7, 0);
              if (!rtx_equal_p (x25, operands[1]))
                return -1;
              x32 = XEXP (x8, 0);
              x33 = XEXP (x32, 0);
              if (!rtx_equal_p (x33, operands[2]))
                return -1;
              x26 = XEXP (x11, 1);
              x27 = XVECEXP (x26, 0, 0);
              switch (XWINT (x27, 0))
                {
                case 0L:
                  x28 = XEXP (x16, 1);
                  x29 = XVECEXP (x28, 0, 0);
                  switch (XWINT (x29, 0))
                    {
                    case 0L:
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      switch (XWINT (x31, 0))
                        {
                        case 0L:
                          x34 = XEXP (x32, 1);
                          x35 = XVECEXP (x34, 0, 0);
                          if (XWINT (x35, 0) != 1L)
                            return -1;
                          return 209; /* umulhisi_ll_lh */

                        case 1L:
                          x34 = XEXP (x32, 1);
                          x35 = XVECEXP (x34, 0, 0);
                          switch (XWINT (x35, 0))
                            {
                            case 0L:
                              return 211; /* umulhisi_ll_hl */

                            case 1L:
                              return 213; /* umulhisi_ll_hh */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case 1L:
                      x30 = XEXP (x7, 1);
                      x31 = XVECEXP (x30, 0, 0);
                      if (XWINT (x31, 0) != 1L)
                        return -1;
                      x34 = XEXP (x32, 1);
                      x35 = XVECEXP (x34, 0, 0);
                      switch (XWINT (x35, 0))
                        {
                        case 0L:
                          return 215; /* umulhisi_lh_hl */

                        case 1L:
                          return 217; /* umulhisi_lh_hh */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1L:
                  x28 = XEXP (x16, 1);
                  x29 = XVECEXP (x28, 0, 0);
                  if (XWINT (x29, 0) != 0L)
                    return -1;
                  x30 = XEXP (x7, 1);
                  x31 = XVECEXP (x30, 0, 0);
                  if (XWINT (x31, 0) != 1L)
                    return -1;
                  x34 = XEXP (x32, 1);
                  x35 = XVECEXP (x34, 0, 0);
                  if (XWINT (x35, 0) != 1L)
                    return -1;
                  return 219; /* umulhisi_hl_hh */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 2205 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && (!TARGET_ID_SHARED_LIBRARY || TARGET_LEAF_ID_SHARED_LIBRARY)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 107; /* *call_symbol */

        case 1:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
            return -1;
          *pnum_clobbers = 1;
          return 111; /* *call_insn */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x36 = XVECEXP (x2, 0, 0);
      operands[1] = x36;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x4, 0);
      operands[0] = x13;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      return 135; /* eh_store_handler */

    case RETURN:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x13 = XEXP (x4, 0);
      operands[0] = x13;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 2749 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
        return -1;
      return 141; /* return_internal */

    default:
      return -1;
    }
}
