/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  return pattern9 (x1); /* [-1, 1] */
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V2HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != VEC_CONCAT
      || GET_MODE (x7) != E_V2HImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XEXP (x7, 1);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_HImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x12 = XEXP (x3, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x13 = XVECEXP (x4, 0, 0);
  operands[3] = x13;
  if (!const01_operand (operands[3], E_VOIDmode))
    return -1;
  x14 = XVECEXP (x6, 0, 0);
  operands[4] = x14;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x15 = XEXP (x8, 0);
  operands[2] = x15;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x16 = XVECEXP (x9, 0, 0);
  operands[5] = x16;
  if (!const01_operand (operands[5], E_VOIDmode))
    return -1;
  x17 = XVECEXP (x11, 0, 0);
  operands[6] = x17;
  if (!const01_operand (operands[6], E_VOIDmode))
    return -1;
  x18 = XVECEXP (x1, 0, 2);
  operands[7] = x18;
  x19 = XEXP (x5, 0);
  if (!rtx_equal_p (x19, operands[1]))
    return -1;
  x20 = XEXP (x10, 0);
  if (!rtx_equal_p (x20, operands[2]))
    return -1;
  return 0;
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SIGN_EXTEND:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != VEC_SELECT
          || GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 1)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 0);
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      return 0;

    case ZERO_EXTEND:
      x2 = XEXP (x1, 0);
      res = pattern55 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 47; /* mulhisi3 */

        case VEC_SELECT:
          if (pattern19 (x6) != 0)
            return -1;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != VEC_SELECT
              || GET_MODE (x7) != E_HImode)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != PARALLEL
              || XVECLEN (x8, 0) != 1)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          x10 = XEXP (x6, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          x11 = XEXP (x7, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          x12 = XEXP (x6, 1);
          x13 = XVECEXP (x12, 0, 0);
          switch (XWINT (x13, 0))
            {
            case 0L:
              switch (XWINT (x9, 0))
                {
                case 0L:
                  return 196; /* mulhisi_ll */

                case 1L:
                  return 198; /* mulhisi_lh */

                default:
                  return -1;
                }

            case 1L:
              switch (XWINT (x9, 0))
                {
                case 0L:
                  return 200; /* mulhisi_hl */

                case 1L:
                  return 202; /* mulhisi_hh */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          switch (GET_CODE (x5))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x5, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 48; /* umulhisi3 */

            case SIGN_EXTEND:
              x7 = XEXP (x5, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 49; /* usmulhisi3 */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern19 (x6) != 0)
            return -1;
          x10 = XEXP (x6, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          x12 = XEXP (x6, 1);
          x13 = XVECEXP (x12, 0, 0);
          switch (XWINT (x13, 0))
            {
            case 0L:
              switch (GET_CODE (x5))
                {
                case ZERO_EXTEND:
                  x7 = XEXP (x5, 0);
                  switch (pattern43 (x7))
                    {
                    case 0:
                      return 197; /* umulhisi_ll */

                    case 1:
                      return 199; /* umulhisi_lh */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  x7 = XEXP (x5, 0);
                  switch (pattern43 (x7))
                    {
                    case 0:
                      return 204; /* usmulhisi_ull */

                    case 1:
                      return 205; /* usmulhisi_ulh */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 1L:
              switch (GET_CODE (x5))
                {
                case ZERO_EXTEND:
                  x7 = XEXP (x5, 0);
                  switch (pattern43 (x7))
                    {
                    case 0:
                      return 201; /* umulhisi_hl */

                    case 1:
                      return 203; /* umulhisi_hh */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  x7 = XEXP (x5, 0);
                  switch (pattern43 (x7))
                    {
                    case 0:
                      return 206; /* usmulhisi_uhl */

                    case 1:
                      return 207; /* usmulhisi_uhh */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern4 (x3, 
E_SImode) != 0)
            return -1;
          return 79; /* mulsi3 */

        case E_V2HImode:
          if (pattern4 (x3, 
E_V2HImode) != 0)
            return -1;
          return 188; /* mulv2hi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
