/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern4 (x1, 
E_SImode); /* [-1, 0] */

    case E_HImode:
      if (pattern4 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern4 (x1, 
E_V2HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != ASHIFT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PLUS
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != ASHIFT
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XEXP (x9, 1);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x14) != SET)
    return -1;
  x15 = XEXP (x14, 1);
  if (GET_CODE (x15) != MEM
      || GET_MODE (x15) != E_BLKmode)
    return -1;
  x16 = XEXP (x14, 0);
  if (GET_CODE (x16) != MEM)
    return -1;
  return 0;
}

int
pattern36 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vec_shift_operand (operands[2], E_HImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[4] = x7;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_V2HImode))
    return -1;
  x9 = XVECEXP (x5, 0, 0);
  operands[5] = x9;
  if (!const01_operand (operands[5], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[4]))
    return -1;
  x10 = XEXP (x7, 0);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XVECEXP (x1, 0, 0);
  x15 = XEXP (x14, 1);
  x16 = XEXP (x15, 0);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 1);
  switch (XWINT (x18, 0))
    {
    case 2L:
      x19 = XEXP (x15, 1);
      if (XWINT (x19, 0) != 4L)
        return -1;
      x20 = XEXP (x5, 1);
      if (XWINT (x20, 0) != 2L)
        return -1;
      x21 = XEXP (x3, 1);
      if (XWINT (x21, 0) != 4L)
        return -1;
      return 0;

    case 1L:
      x19 = XEXP (x15, 1);
      if (XWINT (x19, 0) != 2L)
        return -1;
      x20 = XEXP (x5, 1);
      if (XWINT (x20, 0) != 1L)
        return -1;
      x21 = XEXP (x3, 1);
      if (XWINT (x21, 0) != 2L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2HImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          if (GET_MODE (x5) != E_HImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XVECEXP (x6, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          return 148; /* movhiv2hi_low */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 150; /* composev2hi */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (pattern11 (x4) != 0)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      x10 = XEXP (x4, 1);
      x11 = XVECEXP (x10, 0, 0);
      if (XWINT (x11, 0) == 0L)
        {
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[2] = x5;
              if (register_operand (operands[2], E_HImode))
                return 149; /* movhiv2hi_high */
              break;

            case SS_PLUS:
              if (pattern40 (x5) == 0)
                return 157; /* ssaddhi3_low_parts */
              break;

            case SS_MINUS:
              if (pattern40 (x5) == 0)
                return 158; /* sssubhi3_low_parts */
              break;

            default:
              break;
            }
        }
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != VEC_SELECT
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 1)
        return -1;
      operands[3] = x11;
      if (!const01_operand (operands[3], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_V2HImode))
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      if (!const01_operand (operands[4], E_VOIDmode))
        return -1;
      return 151; /* packv2hi */

    case SS_PLUS:
      if (pattern20 (x4) != 0)
        return -1;
      x9 = XEXP (x4, 0);
      x12 = XEXP (x9, 1);
      x13 = XVECEXP (x12, 0, 0);
      operands[4] = x13;
      if (pattern37 (x2) == 0)
        return 159; /* ssaddhi3_high_parts */
      if (XWINT (x13, 0) != 0L
          || pattern21 (x2, 
SS_MINUS) != 0)
        return -1;
      return 168; /* sssubaddv2hi3 */

    case SS_MINUS:
      if (pattern20 (x4) != 0)
        return -1;
      x9 = XEXP (x4, 0);
      x12 = XEXP (x9, 1);
      x13 = XVECEXP (x12, 0, 0);
      operands[4] = x13;
      if (pattern37 (x2) == 0)
        return 160; /* sssubhi3_high_parts */
      if (XWINT (x13, 0) != 0L
          || pattern21 (x2, 
SS_PLUS) != 0)
        return -1;
      return 167; /* ssaddsubv2hi3 */

    case MINUS:
      if (pattern22 (x2, 
PLUS) != 0)
        return -1;
      return 165; /* addsubv2hi3 */

    case PLUS:
      if (pattern22 (x2, 
MINUS) != 0)
        return -1;
      return 166; /* subaddv2hi3 */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_18 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_13 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_15 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_16 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_17 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 1)
        return -1;
      operands[0] = x1;
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case UNSPEC:
          if (XVECLEN (x2, 0) != 1
              || XINT (x2, 1) != 5
              || !push_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          return 139; /* push_multiple */

        case SET:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != PLUS
              || GET_MODE (x4) != E_SImode
              || pattern25 (x2, 
14) != 0
              || !pop_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          return 140; /* pop_multiple */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 126; /* nop */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x1, 1))
        {
        case 12:
          return 127; /* forced_nop */

        case 11:
          return 128; /* mnop */

        default:
          return -1;
        }

    case EH_RETURN:
      return 136; /* eh_return_internal */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          if (XINT (x1, 1) != 5)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_VOIDmode))
            return -1;
          return 142; /* dummy_load */

        case 1:
          switch (XINT (x1, 1))
            {
            case 6:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 143; /* stall */

            case 1:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 144; /* csync */

            case 2:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 145; /* ssync */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x7 = XEXP (x1, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XEXP (x1, 0);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          if (XWINT (x8, 0) != 1L)
            return -1;
          return 146; /* trap */

        case REG:
          if (REGNO (x8) != 34
              || GET_MODE (x8) != E_BImode)
            return -1;
          return 147; /* trapifcc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
