/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  if (!general_operand (operands[1], E_VOIDmode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_CODE (operands[0]))
    {
    case SYMBOL_REF:
      if (!symbol_ref_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_no_elim_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern23 (rtx x1, rtx_code i1, rtx_code i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i1
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 13
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern34 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern38 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern45 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (!register_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 0);
  switch (GET_CODE (x7))
    {
    case MEM:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      operands[1] = x6;
      x10 = XVECEXP (x3, 0, 1);
      operands[2] = x10;
      x11 = XEXP (x8, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      x12 = XEXP (x5, 0);
      if (!rtx_equal_p (x12, operands[0]))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != UNSPEC
          || XVECLEN (x13, 0) != 2
          || XINT (x13, 1) != 13
          || GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XVECEXP (x13, 0, 0);
      if (GET_CODE (x14) != i1
          || GET_MODE (x14) != E_SImode)
        return -1;
      x15 = XEXP (x14, 0);
      if (GET_CODE (x15) != MEM
          || GET_MODE (x15) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != MEM
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x5, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x6;
      x10 = XVECEXP (x3, 0, 1);
      operands[3] = x10;
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x17 = XEXP (x14, 1);
      if (!rtx_equal_p (x17, operands[2]))
        return -1;
      x18 = XVECEXP (x13, 0, 1);
      if (!rtx_equal_p (x18, operands[3]))
        return -1;
      x19 = XEXP (x11, 0);
      if (!rtx_equal_p (x19, operands[1]))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT
          || XWINT (x5, 0) != 65535L)
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!immediate_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x4, 0);
      if (!rtx_equal_p (x7, operands[0])
          || !
#line 469 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
        return -1;
      return 8; /* movstricthi_high */

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!regorlog2_operand (operands[2], E_SImode))
        return -1;
      return 62; /* iorsi3 */

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 24L:
          if (XWINT (x8, 0) != 8L)
            return -1;
          return 132; /* *bfin.md:2631 */

        case 16L:
          if (XWINT (x8, 0) != 16L)
            return -1;
          return 133; /* *bfin.md:2641 */

        case 8L:
          if (XWINT (x8, 0) != 24L)
            return -1;
          return 134; /* *bfin.md:2651 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      if (!general_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      switch (GET_CODE (operands[0]))
        {
        case SYMBOL_REF:
          if (!symbol_ref_operand (operands[0], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          switch (pattern42 (x10))
            {
            case 0:
              if (!
#line 2106 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[3]))))
                return -1;
              return 99; /* *call_symbol_fdpic */

            case 1:
              if (!
#line 2119 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !bfin_longcall_p (operands[0], INTVAL (operands[3]))))
                return -1;
              return 100; /* *sibcall_symbol_fdpic */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (!register_no_elim_operand (operands[0], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          switch (pattern42 (x10))
            {
            case 0:
              if (!
#line 2160 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                return -1;
              return 103; /* *call_insn_fdpic */

            case 1:
              if (!
#line 2171 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)))
                return -1;
              return 104; /* *sibcall_insn_fdpic */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CALL:
          x11 = XEXP (x7, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != USE)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x12 = XEXP (x11, 0);
          operands[1] = x12;
          x13 = XEXP (x7, 1);
          operands[2] = x13;
          if (!general_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[3] = x8;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[4] = x9;
          switch (GET_CODE (operands[1]))
            {
            case SYMBOL_REF:
              if (!symbol_ref_operand (operands[1], E_SImode))
                return -1;
              x10 = XVECEXP (x1, 0, 3);
              switch (pattern42 (x10))
                {
                case 0:
                  if (!
#line 2133 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[4]))))
                    return -1;
                  return 101; /* *call_value_symbol_fdpic */

                case 1:
                  if (!
#line 2147 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !bfin_longcall_p (operands[1], INTVAL (operands[4]))))
                    return -1;
                  return 102; /* *sibcall_value_symbol_fdpic */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (!register_no_elim_operand (operands[1], E_SImode))
                return -1;
              x10 = XVECEXP (x1, 0, 3);
              switch (pattern42 (x10))
                {
                case 0:
                  if (!
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(! SIBLING_CALL_P (insn)))
                    return -1;
                  return 105; /* *call_value_insn_fdpic */

                case 1:
                  if (!
#line 2195 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(SIBLING_CALL_P (insn)))
                    return -1;
                  return 106; /* *sibcall_value_insn_fdpic */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (pnum_clobbers == NULL
              || pattern15 (x1) != 0)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x9 = XEXP (x5, 0);
          if (GET_MODE (x9) != E_BLKmode)
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x10) != USE
              || pattern50 (x1) != 0)
            return -1;
          switch (pattern53 (x1))
            {
            case 0:
              *pnum_clobbers = 4;
              return 115; /* rep_movsi */

            case 1:
              *pnum_clobbers = 4;
              return 116; /* rep_movhi */

            default:
              return -1;
            }

        case REG:
          if (REGNO (x7) != 35
              || GET_MODE (x7) != E_SImode)
            return -1;
          x3 = XEXP (x2, 0);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != PLUS
              || GET_MODE (x6) != E_SImode)
            return -1;
          x14 = XEXP (x6, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 14
              || GET_MODE (x14) != E_SImode)
            return -1;
          x15 = XEXP (x6, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x16 = XEXP (x4, 1);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 15
              || GET_MODE (x16) != E_SImode)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode)
            return -1;
          x17 = XEXP (x8, 0);
          if (GET_CODE (x17) != PLUS
              || GET_MODE (x17) != E_SImode)
            return -1;
          x18 = XEXP (x17, 0);
          if (GET_CODE (x18) != REG
              || REGNO (x18) != 14
              || GET_MODE (x18) != E_SImode)
            return -1;
          x19 = XEXP (x17, 1);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + -8])
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != SET)
            return -1;
          x20 = XEXP (x5, 1);
          if (GET_CODE (x20) != PLUS
              || GET_MODE (x20) != E_SImode)
            return -1;
          x21 = XEXP (x20, 0);
          if (GET_CODE (x21) != REG
              || REGNO (x21) != 14
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XEXP (x20, 1);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + -8])
            return -1;
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 15
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x10) != SET)
            return -1;
          x23 = XEXP (x10, 1);
          if (GET_CODE (x23) != PLUS
              || GET_MODE (x23) != E_SImode)
            return -1;
          x24 = XEXP (x23, 0);
          if (GET_CODE (x24) != REG
              || REGNO (x24) != 14
              || GET_MODE (x24) != E_SImode)
            return -1;
          x25 = XEXP (x10, 0);
          if (GET_CODE (x25) != REG
              || REGNO (x25) != 14
              || GET_MODE (x25) != E_SImode)
            return -1;
          x26 = XEXP (x23, 1);
          operands[0] = x26;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          return 137; /* link */

        case UNSPEC:
          if (XVECLEN (x7, 0) != 2
              || XINT (x7, 1) != 13
              || GET_MODE (x7) != E_SImode
              || pattern28 (x1) != 0)
            return -1;
          x27 = XVECEXP (x7, 0, 0);
          if (GET_MODE (x27) != E_SImode)
            return -1;
          x28 = XVECEXP (x7, 0, 1);
          if (!register_no_elim_operand (x28, E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x9 = XEXP (x5, 0);
          operands[4] = x9;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          switch (GET_CODE (x27))
            {
            case PLUS:
              switch (pattern45 (x1, 
PLUS))
                {
                case 0:
                  return 244; /* sync_addsi_internal */

                case 1:
                  return 254; /* sync_new_addsi_internal */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern45 (x1, 
MINUS))
                {
                case 0:
                  return 245; /* sync_subsi_internal */

                case 1:
                  return 255; /* sync_new_subsi_internal */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern45 (x1, 
IOR))
                {
                case 0:
                  return 246; /* sync_iorsi_internal */

                case 1:
                  return 256; /* sync_new_iorsi_internal */

                default:
                  return -1;
                }

            case AND:
              switch (pattern45 (x1, 
AND))
                {
                case 0:
                  return 247; /* sync_andsi_internal */

                case 1:
                  return 257; /* sync_new_andsi_internal */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern45 (x1, 
XOR))
                {
                case 0:
                  return 248; /* sync_xorsi_internal */

                case 1:
                  return 258; /* sync_new_xorsi_internal */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MEM:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x16 = XEXP (x4, 1);
          if (GET_CODE (x16) != UNSPEC
              || pattern29 (x4) != 0
              || pattern28 (x1) != 0)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x7, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x29 = XVECEXP (x16, 0, 0);
          if (GET_MODE (x29) != E_SImode)
            return -1;
          x30 = XVECEXP (x16, 0, 1);
          operands[3] = x30;
          if (!register_no_elim_operand (operands[3], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x9 = XEXP (x5, 0);
          operands[4] = x9;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x8 = XEXP (x4, 0);
          x17 = XEXP (x8, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_CODE (x29))
            {
            case PLUS:
              if (pattern48 (x29) != 0)
                return -1;
              return 249; /* sync_old_addsi_internal */

            case MINUS:
              if (pattern48 (x29) != 0)
                return -1;
              return 250; /* sync_old_subsi_internal */

            case IOR:
              if (pattern48 (x29) != 0)
                return -1;
              return 251; /* sync_old_iorsi_internal */

            case AND:
              if (pattern48 (x29) != 0)
                return -1;
              return 252; /* sync_old_andsi_internal */

            case XOR:
              if (pattern48 (x29) != 0)
                return -1;
              return 253; /* sync_old_xorsi_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
