/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode
      || !register_operand (operands[0], E_V2PDImode)
      || GET_MODE (x1) != E_V2PDImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 34
      || GET_MODE (x6) != E_BImode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 2);
  operands[2] = x8;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case NOT:
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_BImode))
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_PDImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != VEC_SELECT
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  return 0;
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != ZERO_EXTEND)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  return 0;
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x5 = XEXP (x3, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[3] = x6;
  if (!const01_operand (operands[3], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XEXP (x7, 1);
  x9 = XVECEXP (x8, 0, 0);
  operands[4] = x9;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[2] = x12;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x13 = XEXP (x11, 1);
  x14 = XVECEXP (x13, 0, 0);
  operands[5] = x14;
  if (!const01_operand (operands[5], E_VOIDmode))
    return -1;
  x15 = XEXP (x10, 1);
  x16 = XEXP (x15, 1);
  x17 = XVECEXP (x16, 0, 0);
  operands[6] = x17;
  if (!const01_operand (operands[6], E_VOIDmode))
    return -1;
  x18 = XVECEXP (x1, 0, 2);
  operands[7] = x18;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x3;
      if (!bfin_bimode_comparison_operator (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_BImode))
        return -1;
      operands[2] = x4;
      if (!immediate_operand (operands[2], E_BImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[3] = x9;
      return 123; /* cbranchbi4 */

    case LT:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      operands[2] = x8;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case ASHIFTRT:
          x6 = XEXP (x2, 2);
          if (GET_CODE (x6) != SS_ASHIFT)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          x10 = XEXP (x5, 1);
          if (!rtx_equal_p (x10, operands[2]))
            return -1;
          x11 = XEXP (x6, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x6, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HImode:
              if (pattern36 (x2, 
E_V2HImode) != 0)
                return -1;
              return 238; /* ssashiftv2hi3 */

            case E_HImode:
              if (pattern36 (x2, 
E_HImode) != 0)
                return -1;
              return 239; /* ssashifthi3 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !reg_or_const_int_operand (operands[2], E_HImode)
                  || GET_MODE (x5) != E_SImode
                  || !register_operand (operands[1], E_HImode)
                  || GET_MODE (x6) != E_SImode)
                return -1;
              return 240; /* ssashiftsi3 */

            default:
              return -1;
            }

        case LSHIFTRT:
          x6 = XEXP (x2, 2);
          if (GET_CODE (x6) != ASHIFT
              || !vec_shift_operand (operands[2], E_HImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          x10 = XEXP (x5, 1);
          if (!rtx_equal_p (x10, operands[2]))
            return -1;
          x11 = XEXP (x6, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x6, 1);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HImode:
              if (pattern38 (x2, 
E_V2HImode) != 0)
                return -1;
              return 241; /* lshiftv2hi3 */

            case E_HImode:
              if (pattern38 (x2, 
E_HImode) != 0)
                return -1;
              return 242; /* lshifthi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IF_THEN_ELSE:
      return recog_8 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_6 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_9 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          if (!immediate_operand (operands[2], E_SImode)
              || !
#line 478 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(reload_completed))
            return -1;
          return 9; /* movsi_low */

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 3
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[2] = x6;
          return 11; /* movsi_low_pic */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_PDImode:
              if (!register_operand (operands[0], E_PDImode)
                  || GET_MODE (x2) != E_PDImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 15; /* load_accumulator */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (!nonimmediate_operand (operands[1], E_HImode))
                    return -1;
                  return 28; /* extendhisi2 */

                case E_QImode:
                  if (!nonimmediate_operand (operands[1], E_QImode))
                    return -1;
                  return 32; /* extendqisi2 */

                default:
                  return -1;
                }

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !nonimmediate_operand (operands[1], E_QImode))
                return -1;
              return 31; /* extendqihi2 */

            case E_DImode:
              switch (pattern17 (x2))
                {
                case 0:
                  return 37; /* extendsidi2 */

                case 1:
                  return 38; /* extendqidi2 */

                case 2:
                  return 39; /* extendhidi2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_CONCAT:
          if (pattern7 (x2) != 0)
            return -1;
          return 16; /* load_accumulator_pair */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_4 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode))
                return -1;
              return 29; /* zero_extendhisi2 */

            case E_BImode:
              if (!nonimmediate_operand (operands[1], E_BImode))
                return -1;
              return 30; /* zero_extendbisi2 */

            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode))
                return -1;
              return 34; /* zero_extendqisi2 */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 33; /* zero_extendqihi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 35; /* zero_extendqidi2 */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 36; /* zero_extendhidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!pos_scale_operand (operands[3], E_SImode))
            return -1;
          return 42; /* *bfin.md:1144 */

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          return 80; /* *ashlsi3_insn */

        default:
          return -1;
        }

    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case MULT:
              if (pattern18 (x2) != 0
                  || !scale_by_operand (operands[3], E_SImode))
                return -1;
              return 43; /* *bfin.md:1153 */

            case ASHIFT:
              if (pattern18 (x2) != 0
                  || !pos_scale_operand (operands[3], E_SImode))
                return -1;
              return 44; /* *bfin.md:1162 */

            case CONST_INT:
            case REG:
            case SUBREG:
              switch (pattern16 (x2))
                {
                case 0:
                  if (!reg_or_7bit_operand (operands[2], E_SImode))
                    return -1;
                  return 50; /* addsi3 */

                case 1:
                  return 161; /* addv2hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MULT:
          if (pattern8 (x2) != 0
              || !scale_by_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 45; /* *bfin.md:1171 */

        case ASHIFT:
          if (pattern8 (x2) != 0
              || !pos_scale_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 46; /* *bfin.md:1180 */

        case VEC_SELECT:
          switch (pattern10 (x2))
            {
            case 0:
              return 173; /* addlohiv2hi3 */

            case 1:
              return 174; /* addhilov2hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      return recog_5 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern4 (x2, 
E_SImode) != 0)
                return -1;
              return 51; /* ssaddsi3 */

            case E_PDImode:
              if (!register_operand (operands[0], E_PDImode)
                  || GET_MODE (x2) != E_PDImode
                  || !register_operand (operands[1], E_PDImode)
                  || !nonmemory_operand (operands[2], E_PDImode))
                return -1;
              return 54; /* addpdi3 */

            case E_HImode:
              if (pattern4 (x2, 
E_HImode) != 0)
                return -1;
              return 153; /* ssaddhi3 */

            case E_V2HImode:
              if (pattern4 (x2, 
E_V2HImode) != 0)
                return -1;
              return 162; /* ssaddv2hi3 */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern11 (x4) != 0)
            return -1;
          x8 = XEXP (x4, 1);
          x9 = XVECEXP (x8, 0, 0);
          operands[3] = x9;
          if (pattern31 (x2) == 0)
            return 155; /* ssaddhi3_parts */
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != VEC_SELECT)
            return -1;
          switch (pattern9 (x2))
            {
            case 0:
              return 175; /* ssaddlohiv2hi3 */

            case 1:
              return 176; /* ssaddhilov2hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern16 (x2))
            {
            case 0:
              if (!reg_or_neg7bit_operand (operands[2], E_SImode))
                return -1;
              return 52; /* subsi3 */

            case 1:
              return 163; /* subv2hi3 */

            default:
              return -1;
            }

        case VEC_SELECT:
          switch (pattern10 (x2))
            {
            case 0:
              return 169; /* sublohiv2hi3 */

            case 1:
              return 170; /* subhilov2hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern5 (x2))
            {
            case 0:
              return 53; /* sssubsi3 */

            case 1:
              return 154; /* sssubhi3 */

            case 2:
              return 164; /* sssubv2hi3 */

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern11 (x4) != 0)
            return -1;
          x8 = XEXP (x4, 1);
          x9 = XVECEXP (x8, 0, 0);
          operands[3] = x9;
          if (pattern31 (x2) == 0)
            return 156; /* sssubhi3_parts */
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != VEC_SELECT)
            return -1;
          switch (pattern9 (x2))
            {
            case 0:
              return 171; /* sssublohiv2hi3 */

            case 1:
              return 172; /* sssubhilov2hi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case US_TRUNCATE:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_PDImode))
        return -1;
      return 56; /* us_truncpdisi2 */

    case EQ:
      if (GET_MODE (x2) != E_BImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_BImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x4, 2);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          return 57; /* *not_bittst */

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (reg_or_const_int_operand (operands[2], E_SImode))
                return 117; /* compare_eq */
            }
          if (!register_operand (operands[1], E_BImode))
            return -1;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 131; /* notbi */

        default:
          return -1;
        }

    case NE:
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_BImode)
              || GET_MODE (x2) != E_BImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x4, 2);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          return 58; /* *bittst */

        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_BImode:
              if (!register_operand (operands[0], E_BImode)
                  || GET_MODE (x2) != E_BImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 129; /* movsibi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_BImode))
                return -1;
              return 130; /* movbisi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x2, 2);
      operands[2] = x11;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 59; /* *bit_extract */

        case NOT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 60; /* *not_bit_extract */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!rhs_andsi3_operand (operands[2], E_SImode))
        return -1;
      return 61; /* *andsi_insn */

    case XOR:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!regorlog2_operand (operands[2], E_SImode))
        return -1;
      return 63; /* xorsi3 */

    case TRUNCATE:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case POPCOUNT:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 64; /* ones */

        case CLRSB:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 71; /* signbitssi2 */

        case LSHIFTRT:
          x7 = XEXP (x4, 0);
          if (GET_CODE (x7) != SS_PLUS
              || GET_MODE (x7) != E_SImode)
            return -1;
          x12 = XEXP (x7, 1);
          if (GET_CODE (x12) != CONST_INT
              || XWINT (x12, 0) != 32768L)
            return -1;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x13 = XEXP (x7, 0);
          operands[1] = x13;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 72; /* ssroundsi2 */

        default:
          return -1;
        }

    case SMAX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern5 (x2))
        {
        case 0:
          return 65; /* smaxsi3 */

        case 1:
          return 73; /* smaxhi3 */

        case 2:
          return 178; /* smaxv2hi3 */

        default:
          return -1;
        }

    case SMIN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern5 (x2))
        {
        case 0:
          return 66; /* sminsi3 */

        case 1:
          return 74; /* sminhi3 */

        case 2:
          return 177; /* sminv2hi3 */

        default:
          return -1;
        }

    case SS_ABS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 67; /* ssabssi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x2) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode))
            return -1;
          return 237; /* ssabsv2hi2 */

        default:
          return -1;
        }

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 68; /* negsi2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 76; /* neghi2 */

        default:
          return -1;
        }

    case SS_NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 69; /* ssnegsi2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 77; /* ssneghi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x2) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode))
            return -1;
          return 236; /* ssnegv2hi2 */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 70; /* one_cmplsi2 */

    case ABS:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 75; /* abshi2 */

    case CLRSB:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 78; /* clrsbhi2 */

    case ASHIFTRT:
      switch (pattern0 (x1))
        {
        case 0:
          return 81; /* ashrsi3 */

        case 1:
          return 87; /* ashrpdi3 */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 82; /* rotl16 */

    case LSHIFTRT:
      switch (pattern0 (x1))
        {
        case 0:
          return 85; /* lshrsi3 */

        case 1:
          return 86; /* lshrpdi3 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (pattern1 (x2) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x14 = XVECEXP (x2, 0, 0);
      x15 = XEXP (x14, 0);
      operands[1] = x15;
      if (!address_operand (operands[1], E_SImode))
        return -1;
      return 98; /* load_funcdescsi */

    case LT:
      if (pattern2 (x1) != 0)
        return -1;
      return 118; /* compare_lt */

    case LE:
      if (pattern2 (x1) != 0)
        return -1;
      return 119; /* compare_le */

    case LEU:
      if (pattern2 (x1) != 0)
        return -1;
      return 120; /* compare_leu */

    case LTU:
      if (pattern2 (x1) != 0)
        return -1;
      return 121; /* compare_ltu */

    case VEC_CONCAT:
      return recog_7 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2HImode))
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      if (!const01_operand (operands[2], E_VOIDmode))
        return -1;
      return 152; /* movv2hi_hi */

    default:
      return -1;
    }
}
