/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || pattern19 (x2) != 0)
    return -1;
  return 0;
}

int
pattern22 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern21 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!const01_operand (operands[3], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 1
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_V2HImode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[4] = x7;
  if (!const01_operand (operands[4], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 0L:
      return 0;

    case 1L:
      return 1;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x9, 1);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_BImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_BImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  switch (GET_CODE (x4))
    {
    case EQ:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern34 (x3, 
E_QImode) != 0)
            return -1;
          return 1; /* *movqicc_insn1 */

        case E_HImode:
          if (pattern34 (x3, 
E_HImode) != 0)
            return -1;
          return 2; /* *movhicc_insn1 */

        case E_SImode:
          if (pattern34 (x3, 
E_SImode) != 0)
            return -1;
          return 3; /* *movsicc_insn1 */

        default:
          return -1;
        }

    case NE:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern34 (x3, 
E_QImode) != 0)
            return -1;
          return 4; /* *movqicc_insn2 */

        case E_HImode:
          if (pattern34 (x3, 
E_HImode) != 0)
            return -1;
          return 5; /* *movhicc_insn2 */

        case E_SImode:
          if (pattern34 (x3, 
E_SImode) != 0)
            return -1;
          return 6; /* *movsicc_insn2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  switch (XVECLEN (x6, 0))
    {
    case 5:
      if (XINT (x6, 1) != 7
          || GET_MODE (x6) != E_HImode
          || XVECLEN (x3, 0) != 5
          || XINT (x3, 1) != 7
          || GET_MODE (x3) != E_PDImode
          || !register_operand (operands[0], E_HImode))
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      operands[3] = x8;
      if (!register_operand (operands[3], E_HImode))
        return -1;
      x9 = XVECEXP (x6, 0, 2);
      operands[4] = x9;
      if (!register_operand (operands[4], E_VOIDmode))
        return -1;
      x10 = XVECEXP (x6, 0, 3);
      operands[5] = x10;
      if (!const01_operand (operands[5], E_VOIDmode))
        return -1;
      x11 = XVECEXP (x6, 0, 4);
      operands[6] = x11;
      if (!const_int_operand (operands[6], E_VOIDmode))
        return -1;
      x12 = XEXP (x2, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_PDImode))
        return -1;
      x13 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XVECEXP (x3, 0, 2);
      if (!rtx_equal_p (x15, operands[3]))
        return -1;
      x16 = XVECEXP (x3, 0, 3);
      if (!rtx_equal_p (x16, operands[4]))
        return -1;
      x17 = XVECEXP (x3, 0, 4);
      if (!rtx_equal_p (x17, operands[5]))
        return -1;
      return 183; /* flag_machi */

    case 3:
      if (XINT (x3, 1) != 7)
        return -1;
      x9 = XVECEXP (x6, 0, 2);
      if (!const_int_operand (x9, E_VOIDmode))
        return -1;
      switch (XINT (x6, 1))
        {
        case 7:
          if (XVECLEN (x3, 0) != 3)
            return -1;
          x7 = XVECEXP (x6, 0, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_HImode)
                  || !register_operand (operands[0], E_HImode)
                  || GET_MODE (x6) != E_HImode)
                return -1;
              x8 = XVECEXP (x6, 0, 1);
              operands[2] = x8;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              operands[3] = x9;
              x12 = XEXP (x2, 0);
              operands[4] = x12;
              if (!register_operand (operands[4], E_PDImode)
                  || GET_MODE (x3) != E_PDImode)
                return -1;
              x13 = XVECEXP (x3, 0, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XVECEXP (x3, 0, 1);
              if (!rtx_equal_p (x14, operands[2]))
                return -1;
              x15 = XVECEXP (x3, 0, 2);
              if (!rtx_equal_p (x15, operands[3]))
                return -1;
              return 186; /* flag_macinithi */

            case VEC_CONCAT:
              if (pattern33 (x6) != 0)
                return -1;
              x13 = XVECEXP (x3, 0, 0);
              if (GET_CODE (x13) != VEC_CONCAT
                  || GET_MODE (x13) != E_V2HImode)
                return -1;
              x18 = XEXP (x13, 0);
              if (GET_CODE (x18) != VEC_SELECT
                  || GET_MODE (x18) != E_HImode)
                return -1;
              x19 = XEXP (x18, 1);
              if (GET_CODE (x19) != PARALLEL
                  || XVECLEN (x19, 0) != 1)
                return -1;
              x20 = XEXP (x13, 1);
              if (GET_CODE (x20) != VEC_SELECT
                  || GET_MODE (x20) != E_HImode)
                return -1;
              x21 = XEXP (x20, 1);
              if (GET_CODE (x21) != PARALLEL
                  || XVECLEN (x21, 0) != 1)
                return -1;
              x14 = XVECEXP (x3, 0, 1);
              if (GET_CODE (x14) != VEC_CONCAT
                  || GET_MODE (x14) != E_V2HImode)
                return -1;
              x22 = XEXP (x14, 0);
              if (GET_CODE (x22) != VEC_SELECT
                  || GET_MODE (x22) != E_HImode)
                return -1;
              x23 = XEXP (x22, 1);
              if (GET_CODE (x23) != PARALLEL
                  || XVECLEN (x23, 0) != 1)
                return -1;
              x24 = XEXP (x14, 1);
              if (GET_CODE (x24) != VEC_SELECT
                  || GET_MODE (x24) != E_HImode)
                return -1;
              x25 = XEXP (x24, 1);
              if (GET_CODE (x25) != PARALLEL
                  || XVECLEN (x25, 0) != 1
                  || !register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x6) != E_V2HImode
                  || pattern57 (x6) != 0)
                return -1;
              x12 = XEXP (x2, 0);
              operands[8] = x12;
              if (!register_operand (operands[8], E_V2PDImode)
                  || GET_MODE (x3) != E_V2PDImode
                  || pattern58 (x1) != 0)
                return -1;
              return 193; /* flag_macinitv2hi_parts */

            default:
              return -1;
            }

        case 6:
          if (pattern24 (x6) != 0
              || XVECLEN (x3, 0) != 5
              || pattern46 (x3) != 0
              || pattern51 (x6) != 0
              || pattern54 (x2) != 0
              || !
#line 3612 "../../gcc-15.0.1-20250313/gcc/config/bfin/bfin.md"
(MACFLAGS_MATCH_P (INTVAL (operands[10]), INTVAL (operands[11]))))
            return -1;
          return 195; /* flag_mul_macv2hi_parts_acconly */

        default:
          return -1;
        }

    case 6:
      if (XINT (x6, 1) != 7
          || GET_MODE (x6) != E_V2HImode)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != VEC_CONCAT
          || pattern33 (x6) != 0
          || XVECLEN (x3, 0) != 6
          || XINT (x3, 1) != 7
          || GET_MODE (x3) != E_V2PDImode)
        return -1;
      x13 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x13) != VEC_CONCAT
          || GET_MODE (x13) != E_V2HImode)
        return -1;
      x18 = XEXP (x13, 0);
      if (GET_CODE (x18) != VEC_SELECT
          || GET_MODE (x18) != E_HImode)
        return -1;
      x19 = XEXP (x18, 1);
      if (GET_CODE (x19) != PARALLEL
          || XVECLEN (x19, 0) != 1)
        return -1;
      x20 = XEXP (x13, 1);
      if (GET_CODE (x20) != VEC_SELECT
          || GET_MODE (x20) != E_HImode)
        return -1;
      x21 = XEXP (x20, 1);
      if (GET_CODE (x21) != PARALLEL
          || XVECLEN (x21, 0) != 1)
        return -1;
      x14 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x14) != VEC_CONCAT
          || GET_MODE (x14) != E_V2HImode)
        return -1;
      x22 = XEXP (x14, 0);
      if (GET_CODE (x22) != VEC_SELECT
          || GET_MODE (x22) != E_HImode)
        return -1;
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != PARALLEL
          || XVECLEN (x23, 0) != 1)
        return -1;
      x24 = XEXP (x14, 1);
      if (GET_CODE (x24) != VEC_SELECT
          || GET_MODE (x24) != E_HImode)
        return -1;
      x25 = XEXP (x24, 1);
      if (GET_CODE (x25) != PARALLEL
          || XVECLEN (x25, 0) != 1
          || !register_operand (operands[0], E_V2HImode)
          || pattern57 (x6) != 0
          || !register_operand (operands[7], E_V2PDImode))
        return -1;
      x10 = XVECEXP (x6, 0, 3);
      operands[8] = x10;
      if (!const01_operand (operands[8], E_VOIDmode))
        return -1;
      x11 = XVECEXP (x6, 0, 4);
      operands[9] = x11;
      if (!const01_operand (operands[9], E_VOIDmode))
        return -1;
      x26 = XVECEXP (x6, 0, 5);
      operands[10] = x26;
      if (!const_int_operand (operands[10], E_VOIDmode))
        return -1;
      x12 = XEXP (x2, 0);
      operands[11] = x12;
      if (!register_operand (operands[11], E_V2PDImode)
          || pattern58 (x1) != 0)
        return -1;
      x16 = XVECEXP (x3, 0, 3);
      if (!rtx_equal_p (x16, operands[8]))
        return -1;
      x17 = XVECEXP (x3, 0, 4);
      if (!rtx_equal_p (x17, operands[9]))
        return -1;
      x27 = XVECEXP (x3, 0, 5);
      if (!rtx_equal_p (x27, operands[10]))
        return -1;
      return 191; /* flag_macv2hi_parts */

    case 2:
      if (pnum_clobbers == NULL
          || XINT (x6, 1) != 13
          || GET_MODE (x6) != E_SImode
          || pattern29 (x2) != 0
          || !register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      operands[3] = x8;
      if (!register_no_elim_operand (operands[3], E_SImode))
        return -1;
      x13 = XVECEXP (x3, 0, 0);
      if (GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x14, operands[3]))
        return -1;
      switch (GET_CODE (x7))
        {
        case PLUS:
          if (pattern49 (x1, 
PLUS) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 254; /* sync_new_addsi_internal */

        case MINUS:
          if (pattern49 (x1, 
MINUS) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 255; /* sync_new_subsi_internal */

        case IOR:
          if (pattern49 (x1, 
IOR) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 256; /* sync_new_iorsi_internal */

        case AND:
          if (pattern49 (x1, 
AND) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 257; /* sync_new_andsi_internal */

        case XOR:
          if (pattern49 (x1, 
XOR) != 0)
            return -1;
          *pnum_clobbers = 2;
          return 258; /* sync_new_xorsi_internal */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
