/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "memmodel.h"
#include "tm_p.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "emit-rtl.h"
#include "tm-constrs.h"
#include "target.h"


struct target_constraints default_target_constraints;
#if SWITCHABLE_TARGET
struct target_constraints *this_target_constraints = &default_target_constraints;
#endif
static inline bool
aligned_register_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 25 "../../gcc-15.0.1-20250313/gcc/common.md"
{
  /* Require the offset in a non-paradoxical subreg to be naturally aligned.
     For example, if we have a subreg of something that is double the size of
     this operand, the offset must select the first or second half of it.  */
  if (SUBREG_P (op)
      && multiple_p (SUBREG_BYTE (op), GET_MODE_SIZE (GET_MODE (op))))
    op = SUBREG_REG (op);
  if (!REG_P (op))
    return false;

  if (HARD_REGISTER_P (op))
    {
      if (!in_hard_reg_set_p (operand_reg_set, GET_MODE (op), REGNO (op)))
	return false;

      /* Reject hard registers that would need reloading, so that the reload
	 is visible to IRA and to pre-RA optimizers.  */
      if (REGNO (op) % REG_NREGS (op) != 0)
	return false;
    }
  return true;
}

bool
aligned_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case REG:
    case SUBREG:
      break;
    default:
      return false;
    }
  return (
(aligned_register_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
reg_or_const_int_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (const_int_operand (op, mode));
}

bool
const_vector_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_VECTOR) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
scst5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_int_operand (op, mode)) && (
#line 31 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(satisfies_constraint_Is5 (op)));
}

bool
reg_or_ucst4_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || ((const_int_operand (op, mode)) && (
#line 36 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(satisfies_constraint_Iu4 (op))));
}

bool
reg_or_scst5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || (scst5_operand (op, mode));
}

bool
reg_or_ucst5_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || ((const_int_operand (op, mode)) && (
#line 45 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(satisfies_constraint_Iu5 (op))));
}

bool
addsi_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (register_operand (op, mode)) || ((const_int_operand (op, mode)) && (
#line 50 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(satisfies_constraint_IsB (op))));
}

bool
andsi_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (reg_or_scst5_operand (op, mode)) || ((const_int_operand (op, mode)) && (
#line 55 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(satisfies_constraint_Jc (op))));
}

bool
iorsi_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (reg_or_scst5_operand (op, mode)) || ((const_int_operand (op, mode)) && (
#line 60 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(satisfies_constraint_Js (op))));
}

bool
insv_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (const_int_operand (op, mode)) && (
#line 64 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(INTVAL (op) == 0 || INTVAL (op) == -1));
}

bool
c6x_jump_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case LABEL_REF:
    case SYMBOL_REF:
    case REG:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode);
}

static inline bool
c6x_call_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 73 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
{
  /* The linker transforms jumps to undefined weak symbols in a way that
     is incompatible with our code generation.  */
  return (GET_CODE (op) != SYMBOL_REF
	  || (!SYMBOL_REF_WEAK (op)
	      && !c6x_long_call_p (op)));
}

bool
c6x_call_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (((GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == REG) || ((GET_CODE (op) == SUBREG) && (
#line 72 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(GET_CODE (XEXP (op, 0)) == REG)))) && (
(c6x_call_operand_1 (op, mode)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
symbolic_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == LABEL_REF) || ((GET_CODE (op) == CONST) && (
#line 86 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(GET_CODE (XEXP (op,0)) == PLUS
			 && (GET_CODE (XEXP (XEXP (op, 0), 0)) == SYMBOL_REF
			     || GET_CODE (XEXP (XEXP (op, 0), 0)) == LABEL_REF)
			 && GET_CODE (XEXP (XEXP (op, 0), 1)) == CONST_INT)))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
const_int_or_symbolic_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (symbolic_operand (op, mode)) || (const_int_operand (op, mode));
}

bool
adda_scale_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 98 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(INTVAL (op) == 2 || INTVAL (op) == 4
 		    || ((TARGET_INSNS_64 || TARGET_INSNS_67)
 			&& INTVAL (op) == 8)));
}

bool
suba_scale_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (GET_CODE (op) == CONST_INT) && (
#line 105 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(INTVAL (op) == 2 || INTVAL (op) == 4));
}

bool
predicate_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
c6x_comparison_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case LTU:
    case GTU:
    case LT:
    case GT:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
non_c6x_comparison_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case NE:
    case LEU:
    case GEU:
    case LE:
    case GE:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
c6x_fp_comparison_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == EQ || GET_CODE (op) == LT || GET_CODE (op) == GT || GET_CODE (op) == LE || GET_CODE (op) == GE) || ((
#line 120 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(TARGET_FP)) && (GET_CODE (op) == LTGT || GET_CODE (op) == UNEQ || GET_CODE (op) == UNLT || GET_CODE (op) == UNGT || GET_CODE (op) == UNLE || GET_CODE (op) == UNGE || GET_CODE (op) == ORDERED || GET_CODE (op) == UNORDERED))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
c6x_any_comparison_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 125 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
{
  rtx op0 = XEXP (op, 0);
  rtx op1 = XEXP (op, 1);
  if (ltugtu_operator (op, SImode)
      && register_operand (op0, SImode)
      && ((TARGET_INSNS_64 && reg_or_ucst5_operand (op1, SImode))
	  || (!TARGET_INSNS_64 && reg_or_ucst4_operand (op1, SImode))))
    return true;
  if (eqltgt_operator (op, SImode)
      && register_operand (op0, SImode)
      && reg_or_scst5_operand (op1, SImode))
    return true;
  if (!TARGET_FP)
    return false;
  if (!eqltgt_operator (op, SFmode) && !eqltgt_operator (op, DFmode))
    return false;
  if (register_operand (op0, GET_MODE (op))
      && register_operand (op1, GET_MODE (op)))
    return true;
  return false;
}

bool
c6x_any_comparison_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case LT:
    case GT:
    case LE:
    case GE:
    case LTU:
    case GTU:
      break;
    default:
      return false;
    }
  return (
(c6x_any_comparison_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
ltugtu_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case LTU:
    case GTU:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
eqltgt_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case LT:
    case GT:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
eqne_operator (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

bool
predicate_register (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && ((
#line 158 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(REGNO_REG_CLASS (REGNO (op)) == PREDICATE_A_REGS)) || (
#line 159 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(REGNO_REG_CLASS (REGNO (op)) == PREDICATE_B_REGS)))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

bool
a_register (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (((GET_CODE (op) == REG) && (
#line 164 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(A_REGNO_P (REGNO (op))))) || ((GET_CODE (op) == CONST_INT) && (
#line 166 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(A_REGNO_P (INTVAL (op)))))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
b_register (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return (((GET_CODE (op) == REG) && (
#line 170 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(B_REGNO_P (REGNO (op))))) || ((GET_CODE (op) == CONST_INT) && (
#line 172 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(B_REGNO_P (INTVAL (op)))))) && (
(mode == VOIDmode || GET_MODE (op) == mode || GET_MODE (op) == VOIDmode));
}

bool
pic_register_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == REG) && (
#line 176 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
(op == pic_offset_table_rtx))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

static inline bool
sdata_symbolic_operand_1 (rtx op ATTRIBUTE_UNUSED, machine_mode mode ATTRIBUTE_UNUSED)
#line 181 "../../gcc-15.0.1-20250313/gcc/config/c6x/predicates.md"
{
  HOST_WIDE_INT offset = 0, size = 0;
  tree t;

  switch (GET_CODE (op))
    {
    case CONST:
      op = XEXP (op, 0);
      if (GET_CODE (op) != PLUS
	  || GET_CODE (XEXP (op, 0)) != SYMBOL_REF
	  || GET_CODE (XEXP (op, 1)) != CONST_INT)
	return false;
      offset = INTVAL (XEXP (op, 1));
      op = XEXP (op, 0);
      /* FALLTHRU */

    case SYMBOL_REF:
      /* For shared libraries, only allow symbols we know are local.
         For executables, the linker knows to create copy relocs if
	 necessary so we can use DP-relative addressing for all small
	 objects.  */
      if ((c6x_initial_flag_pic && !SYMBOL_REF_LOCAL_P (op))
	  || !SYMBOL_REF_SMALL_P (op))
	return false;

     /* Note that in addition to DECLs, we can get various forms
	of constants here.  */
      t = SYMBOL_REF_DECL (op);
      if (DECL_P (t))
        t = DECL_SIZE_UNIT (t);
      else
	t = TYPE_SIZE_UNIT (TREE_TYPE (t));
      if (t && tree_fits_shwi_p (t))
	{
	  size = tree_to_shwi (t);
	  if (size < 0)
	    size = 0;
	}

      /* Don't allow addressing outside the object.  */
      return (offset >= 0 && offset <= size);

    default:
      gcc_unreachable ();
    }
}

bool
sdata_symbolic_operand (rtx op, machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case SYMBOL_REF:
    case CONST:
      break;
    default:
      return false;
    }
  return (
(sdata_symbolic_operand_1 (op, mode))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

enum constraint_num
lookup_constraint_1 (const char *str)
{
  switch (str[0])
    {
    case ':':
      return CONSTRAINT__c;
    case '<':
      return CONSTRAINT__l;
    case '>':
      return CONSTRAINT__g;
    case 'A':
      return CONSTRAINT_A;
    case 'B':
      return CONSTRAINT_B;
    case 'C':
      return CONSTRAINT_C;
    case 'D':
      if (str[1] == 'b')
        return CONSTRAINT_Db;
      if (str[1] == 'a')
        return CONSTRAINT_Da;
      break;
    case 'E':
      return CONSTRAINT_E;
    case 'F':
      return CONSTRAINT_F;
    case 'I':
      if (!strncmp (str + 1, "u5", 2))
        return CONSTRAINT_Iu5;
      if (!strncmp (str + 1, "n5", 2))
        return CONSTRAINT_In5;
      if (!strncmp (str + 1, "s5", 2))
        return CONSTRAINT_Is5;
      if (!strncmp (str + 1, "5x", 2))
        return CONSTRAINT_I5x;
      if (!strncmp (str + 1, "ux", 2))
        return CONSTRAINT_Iux;
      if (!strncmp (str + 1, "uB", 2))
        return CONSTRAINT_IuB;
      if (!strncmp (str + 1, "sB", 2))
        return CONSTRAINT_IsB;
      if (!strncmp (str + 1, "sC", 2))
        return CONSTRAINT_IsC;
      if (!strncmp (str + 1, "u4", 2))
        return CONSTRAINT_Iu4;
      break;
    case 'J':
      if (str[1] == 'B')
        return CONSTRAINT_JB;
      if (str[1] == 'c')
        return CONSTRAINT_Jc;
      if (str[1] == 's')
        return CONSTRAINT_Js;
      if (str[1] == 'A')
        return CONSTRAINT_JA;
      break;
    case 'Q':
      return CONSTRAINT_Q;
    case 'R':
      return CONSTRAINT_R;
    case 'S':
      if (str[1] == '1')
        return CONSTRAINT_S1;
      if (str[1] == '2')
        return CONSTRAINT_S2;
      if (str[1] == '3')
        return CONSTRAINT_S3;
      if (str[1] == 'i')
        return CONSTRAINT_Si;
      if (str[1] == '0')
        return CONSTRAINT_S0;
      break;
    case 'T':
      return CONSTRAINT_T;
    case 'V':
      return CONSTRAINT_V;
    case 'W':
      return CONSTRAINT_W;
    case 'X':
      return CONSTRAINT_X;
    case 'Z':
      return CONSTRAINT_Z;
    case 'a':
      return CONSTRAINT_a;
    case 'b':
      return CONSTRAINT_b;
    case 'i':
      return CONSTRAINT_i;
    case 'm':
      return CONSTRAINT_m;
    case 'n':
      return CONSTRAINT_n;
    case 'o':
      return CONSTRAINT_o;
    case 'p':
      return CONSTRAINT_p;
    case 'r':
      return CONSTRAINT_r;
    case 's':
      return CONSTRAINT_s;
    case 'z':
      return CONSTRAINT_z;
    default: break;
    }
  return CONSTRAINT__UNKNOWN;
}

const unsigned char lookup_constraint_array[] = {
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__c, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__l, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT__g, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_A, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_B, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_C, (int) UCHAR_MAX),
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_E, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_F, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  UCHAR_MAX,
  UCHAR_MAX,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_Q, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_R, (int) UCHAR_MAX),
  UCHAR_MAX,
  MIN ((int) CONSTRAINT_T, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_V, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_W, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_X, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_Z, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_a, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_b, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_i, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_m, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_n, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_o, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_p, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_r, (int) UCHAR_MAX),
  MIN ((int) CONSTRAINT_s, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  MIN ((int) CONSTRAINT_z, (int) UCHAR_MAX),
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN,
  CONSTRAINT__UNKNOWN
};

enum reg_class
reg_class_for_constraint_1 (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_r: return GENERAL_REGS;
    case CONSTRAINT_a: return A_REGS;
    case CONSTRAINT_b: return B_REGS;
    case CONSTRAINT_A: return PREDICATE_A_REGS;
    case CONSTRAINT_B: return PREDICATE_B_REGS;
    case CONSTRAINT_C: return CALL_USED_B_REGS;
    case CONSTRAINT_Da: return NONPREDICATE_A_REGS;
    case CONSTRAINT_Db: return NONPREDICATE_B_REGS;
    case CONSTRAINT_Z: return PICREG;
    case CONSTRAINT_z: return SPREG;
    default: break;
    }
  return NO_REGS;
}

bool (*constraint_satisfied_p_array[]) (rtx) = {
  satisfies_constraint_Iu4,
  satisfies_constraint_Iu5,
  satisfies_constraint_In5,
  satisfies_constraint_Is5,
  satisfies_constraint_I5x,
  satisfies_constraint_Iux,
  satisfies_constraint_IuB,
  satisfies_constraint_IsB,
  satisfies_constraint_IsC,
  satisfies_constraint_JA,
  satisfies_constraint_JB,
  satisfies_constraint_Jc,
  satisfies_constraint_Js,
  satisfies_constraint_m,
  satisfies_constraint_o,
  satisfies_constraint_Q,
  satisfies_constraint_R,
  satisfies_constraint_T,
  satisfies_constraint_W,
  satisfies_constraint_p,
  satisfies_constraint_S0,
  satisfies_constraint_S1,
  satisfies_constraint_S2,
  satisfies_constraint_Si,
  satisfies_constraint_V,
  satisfies_constraint__l,
  satisfies_constraint__g,
  satisfies_constraint_i,
  satisfies_constraint_s,
  satisfies_constraint__c,
  satisfies_constraint_n,
  satisfies_constraint_E,
  satisfies_constraint_F,
  satisfies_constraint_X,
  satisfies_constraint_S3
};

bool
insn_const_int_ok_for_constraint (HOST_WIDE_INT ival, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_Iu4:
      return 
#line 55 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(ival >= 0 && ival <= 15);

    case CONSTRAINT_Iu5:
      return 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(ival >= 0 && ival <= 31);

    case CONSTRAINT_In5:
      return 
#line 65 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(ival >= -31 && ival <= 0);

    case CONSTRAINT_Is5:
      return 
#line 70 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(ival >= -16 && ival <= 15);

    case CONSTRAINT_I5x:
      return 
#line 75 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
((ival >= -31 && ival <= 31)
		    || ((ival & 1) == 0 && ival >= -62 && ival <= 62)
		    || ((ival & 3) == 0 && ival >= -124 && ival <= 124)
		    || ((TARGET_INSNS_64 || TARGET_INSNS_67)
 			&& (ival & 7) == 0 && ival > 0 && ival <= 248));

    case CONSTRAINT_Iux:
      return (
#line 85 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(TARGET_INSNS_64PLUS)) && (
#line 86 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(ival >= 0
 			 && (ival < 32768
		     	     || ((ival & 1) == 0 && ival < 65536)
			     || ((ival & 3) == 0 && ival < 131072))));

    case CONSTRAINT_IuB:
      return 
#line 94 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(ival >= 0 && ival <= 65535);

    case CONSTRAINT_IsB:
      return 
#line 99 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(ival >= -32768 && ival <= 32767);

    case CONSTRAINT_IsC:
      return 
#line 104 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(ival >= -0x100000 && ival <= 0xfffff);

    case CONSTRAINT_JA:
      return 
#line 111 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(ival >= 0 && ival < 32);

    case CONSTRAINT_JB:
      return 
#line 118 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(ival >= 32 && ival < 64);

    case CONSTRAINT_Jc:
      return 
#line 123 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(c6x_valid_mask_p (ival));

    case CONSTRAINT_Js:
      return 
#line 128 "../../gcc-15.0.1-20250313/gcc/config/c6x/constraints.md"
(c6x_valid_mask_p (~ival));

    default: break;
    }
  return false;
}


void
init_reg_class_start_regs ()
{
}
