/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 4
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!reg_or_const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!scst5_operand (operands[2], i1)
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 4
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  return pattern50 (x7, 
i1); /* [-1, 1] */
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_HImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode
      || !reg_or_scst5_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!memory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 17)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x1, 0);
  operands[4] = x8;
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  x10 = XEXP (x3, 0);
  operands[0] = x10;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x11 = XEXP (x4, 0);
  operands[1] = x11;
  if (!memory_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x4, 1);
  operands[2] = x12;
  if (!reg_or_scst5_operand (operands[2], E_SImode))
    return -1;
  x13 = XVECEXP (x2, 0, 2);
  x14 = XEXP (x13, 0);
  operands[3] = x14;
  x15 = XEXP (x7, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x7, 1);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  x17 = XEXP (x5, 0);
  if (!rtx_equal_p (x17, operands[1]))
    return -1;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 47
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -24])
    return -1;
  return 0;
}

int
pattern108 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 6);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 7);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 8);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3)
    return -1;
  x8 = XVECEXP (x1, 0, 9);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 10);
  x11 = XEXP (x10, 0);
  if (REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x4, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[1] = x9;
  if (!
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(flag_pic && TARGET_INSNS_64))
    return -1;
  *pnum_clobbers = 2;
  return 73; /* casesi_internal */
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case UNSPEC:
          if (XVECLEN (x3, 0) != 1)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          switch (XINT (x3, 1))
            {
            case 2:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x6 = XVECEXP (x3, 0, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 0);
              operands[2] = x7;
              if (!scratch_operand (operands[2], E_SImode))
                return -1;
              switch (pattern70 (x3))
                {
                case 0:
                  if (!
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                    return -1;
                  return 34; /* movmisalignsi_store */

                case 1:
                  if (!
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                    return -1;
                  return 35; /* movmisaligndi_store */

                case 2:
                  if (!
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                    return -1;
                  return 36; /* movmisalignv2hi_store */

                case 3:
                  if (!
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                    return -1;
                  return 37; /* movmisalignv4qi_store */

                default:
                  return -1;
                }

            case 3:
              if (GET_MODE (x3) != E_SImode)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != UNSPEC
                  || XVECLEN (x5, 0) != 1
                  || XINT (x5, 1) != 0
                  || !register_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x3, 0, 0);
              operands[1] = x6;
              x8 = XVECEXP (x5, 0, 0);
              operands[2] = x8;
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 2091 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 123; /* addkpc */

            case 17:
              if (GET_MODE (x3) != E_SImode)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER
                  || !memory_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x3, 0, 0);
              if (GET_MODE (x6) != E_SImode)
                return -1;
              x7 = XEXP (x5, 0);
              operands[2] = x7;
              if (!scratch_operand (operands[2], E_SImode))
                return -1;
              switch (GET_CODE (x6))
                {
                case PLUS:
                  x9 = XEXP (x6, 1);
                  operands[1] = x9;
                  if (!reg_or_scst5_operand (operands[1], E_SImode))
                    return -1;
                  x10 = XEXP (x6, 0);
                  if (!rtx_equal_p (x10, operands[0]))
                    return -1;
                  return 252; /* sync_addsi_insn */

                case MINUS:
                  x9 = XEXP (x6, 1);
                  operands[1] = x9;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x10 = XEXP (x6, 0);
                  if (!rtx_equal_p (x10, operands[0]))
                    return -1;
                  return 253; /* sync_subsi_insn */

                case IOR:
                  x9 = XEXP (x6, 1);
                  operands[1] = x9;
                  if (!reg_or_scst5_operand (operands[1], E_SImode))
                    return -1;
                  x10 = XEXP (x6, 0);
                  if (!rtx_equal_p (x10, operands[0]))
                    return -1;
                  return 254; /* sync_iorsi_insn */

                case XOR:
                  x9 = XEXP (x6, 1);
                  operands[1] = x9;
                  if (!reg_or_scst5_operand (operands[1], E_SImode))
                    return -1;
                  x10 = XEXP (x6, 0);
                  if (!rtx_equal_p (x10, operands[0]))
                    return -1;
                  return 255; /* sync_xorsi_insn */

                case AND:
                  x9 = XEXP (x6, 1);
                  operands[1] = x9;
                  if (!reg_or_scst5_operand (operands[1], E_SImode))
                    return -1;
                  x10 = XEXP (x6, 0);
                  if (!rtx_equal_p (x10, operands[0]))
                    return -1;
                  return 256; /* sync_andsi_insn */

                case NOT:
                  x10 = XEXP (x6, 0);
                  if (GET_CODE (x10) != AND
                      || GET_MODE (x10) != E_SImode)
                    return -1;
                  x11 = XEXP (x10, 1);
                  operands[1] = x11;
                  if (!reg_or_scst5_operand (operands[1], E_SImode))
                    return -1;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[0]))
                    return -1;
                  return 267; /* sync_nandsi_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case PC:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != USE)
                return -1;
              x7 = XEXP (x5, 0);
              if (GET_CODE (x7) != LABEL_REF)
                return -1;
              operands[0] = x3;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x13 = XEXP (x7, 0);
              operands[1] = x13;
              if (!
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!flag_pic || !TARGET_INSNS_64))
                return -1;
              return 72; /* *tablejump_internal */

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != SET)
                return -1;
              switch (pattern63 (x1))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 251; /* *sync_compare_and_swapsi */

                case 1:
                  x14 = XEXP (x5, 1);
                  x15 = XVECEXP (x14, 0, 0);
                  switch (pattern90 (x15))
                    {
                    case 0:
                      *pnum_clobbers = 1;
                      return 257; /* sync_old_addsi_insn */

                    case 1:
                      *pnum_clobbers = 1;
                      return 258; /* sync_old_subsi_insn */

                    case 2:
                      *pnum_clobbers = 1;
                      return 259; /* sync_old_iorsi_insn */

                    case 3:
                      *pnum_clobbers = 1;
                      return 260; /* sync_old_xorsi_insn */

                    case 4:
                      *pnum_clobbers = 1;
                      return 261; /* sync_old_andsi_insn */

                    case 5:
                      *pnum_clobbers = 1;
                      return 268; /* sync_old_nandsi_insn */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          if (pnum_clobbers == NULL)
            return -1;
          x16 = XEXP (x3, 0);
          if (GET_CODE (x16) != NE)
            return -1;
          x17 = XEXP (x16, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x18 = XEXP (x3, 1);
          if (GET_CODE (x18) != LABEL_REF)
            return -1;
          x19 = XEXP (x3, 2);
          if (GET_CODE (x19) != PC)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != PC)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x14 = XEXP (x5, 1);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x20 = XEXP (x14, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x21 = XEXP (x16, 0);
          operands[3] = x21;
          if (!nonimmediate_operand (operands[3], E_SImode))
            return -1;
          x22 = XEXP (x18, 0);
          operands[1] = x22;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          x23 = XEXP (x14, 0);
          if (!rtx_equal_p (x23, operands[3])
              || !
#line 1488 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS && optimize))
            return -1;
          *pnum_clobbers = 1;
          return 80; /* loop_end */

        case CALL:
          x16 = XEXP (x3, 0);
          if (GET_CODE (x16) != MEM)
            return -1;
          x18 = XEXP (x3, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern26 (x5) != 0)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          if (!c6x_call_operand (operands[1], E_SImode)
              || !
#line 2070 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!SIBLING_CALL_P (insn)))
            return -1;
          return 121; /* callp_value */

        case DIV:
          if (pnum_clobbers == NULL
              || GET_MODE (x3) != E_SImode)
            return -1;
          x16 = XEXP (x3, 0);
          if (GET_CODE (x16) == REG)
            {
              switch (pattern51 (x1, 
MOD))
                {
                case 0:
                  *pnum_clobbers = 12;
                  return 137; /* divsi3_insn_indcall */

                case 1:
                  *pnum_clobbers = 10;
                  return 142; /* divmodsi4_insn */

                default:
                  break;
                }
            }
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET
              || pattern52 (x1, 
MOD) != 0)
            return -1;
          *pnum_clobbers = 14;
          return 148; /* divmodsi4 */

        case UDIV:
          if (pnum_clobbers == NULL
              || GET_MODE (x3) != E_SImode)
            return -1;
          x16 = XEXP (x3, 0);
          if (GET_CODE (x16) == REG)
            {
              switch (pattern51 (x1, 
UMOD))
                {
                case 0:
                  *pnum_clobbers = 11;
                  return 139; /* udivsi3_insn_indcall */

                case 1:
                  *pnum_clobbers = 11;
                  return 146; /* udivmodsi4_insn */

                default:
                  break;
                }
            }
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET
              || pattern52 (x1, 
UMOD) != 0)
            return -1;
          *pnum_clobbers = 14;
          return 149; /* udivmodsi4 */

        case MOD:
          if (pattern16 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 11;
          return 141; /* modsi3_insn_indcall */

        case UMOD:
          if (pattern16 (x1, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 10;
          return 145; /* umodsi3_insn_indcall */

        case PLUS:
          if (pattern17 (x1, pnum_clobbers, 
PLUS) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 262; /* sync_new_addsi_insn */

        case MINUS:
          if (pnum_clobbers == NULL
              || pattern22 (x1) != 0)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x16 = XEXP (x3, 0);
          operands[1] = x16;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x3, 1);
          operands[2] = x18;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x14 = XEXP (x5, 1);
          x15 = XVECEXP (x14, 0, 0);
          x24 = XEXP (x15, 0);
          if (!rtx_equal_p (x24, operands[1]))
            return -1;
          x25 = XEXP (x15, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x7 = XEXP (x5, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          *pnum_clobbers = 1;
          return 263; /* sync_new_subsi_insn */

        case IOR:
          if (pattern17 (x1, pnum_clobbers, 
IOR) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 264; /* sync_new_iorsi_insn */

        case XOR:
          if (pattern17 (x1, pnum_clobbers, 
XOR) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 265; /* sync_new_xorsi_insn */

        case AND:
          if (pattern17 (x1, pnum_clobbers, 
AND) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 266; /* sync_new_andsi_insn */

        case NOT:
          if (pnum_clobbers == NULL
              || pattern23 (x1) != 0)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x16 = XEXP (x3, 0);
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x17 = XEXP (x16, 1);
          operands[2] = x17;
          if (!reg_or_scst5_operand (operands[2], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          x14 = XEXP (x5, 1);
          x15 = XVECEXP (x14, 0, 0);
          x24 = XEXP (x15, 0);
          x26 = XEXP (x24, 0);
          if (!rtx_equal_p (x26, operands[1]))
            return -1;
          x27 = XEXP (x24, 1);
          if (!rtx_equal_p (x27, operands[2]))
            return -1;
          x7 = XEXP (x5, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          *pnum_clobbers = 1;
          return 269; /* sync_new_nandsi_insn */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 3)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x28 = XVECEXP (x2, 0, 0);
      operands[0] = x28;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!scratch_operand (operands[1], E_SImode))
        return -1;
      return 76; /* eh_return */

    case UNSPEC:
      switch (XVECLEN (x2, 0))
        {
        case 2:
          if (XINT (x2, 1) != 10)
            return -1;
          x29 = XVECEXP (x2, 0, 1);
          if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 35
              || GET_MODE (x7) != E_SImode)
            return -1;
          x28 = XVECEXP (x2, 0, 0);
          operands[0] = x28;
          if (!c6x_call_operand (operands[0], E_VOIDmode))
            return -1;
          return 82; /* real_call */

        case 1:
          if (XINT (x2, 1) != 13)
            return -1;
          x28 = XVECEXP (x2, 0, 0);
          if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != RETURN)
            return -1;
          return 93; /* return_shadow */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM)
        return -1;
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern26 (x5) != 0)
        return -1;
      x30 = XEXP (x4, 0);
      operands[0] = x30;
      if (!c6x_call_operand (operands[0], E_SImode)
          || !
#line 2057 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!SIBLING_CALL_P (insn)))
        return -1;
      return 120; /* callp */

    case RETURN:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 2081 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
        return -1;
      return 122; /* return_internal */

    default:
      return -1;
    }
}
