/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern7 (x3, 
E_QImode); /* [-1, 0] */

    case E_V4QImode:
      if (pattern7 (x3, 
E_V4QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (pattern7 (x1, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern7 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 17
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (GET_CODE (x7) != NOT
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != AND
      || GET_MODE (x8) != E_SImode)
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG)
    return -1;
  return 0;
}

int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 2);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[4]))
    return -1;
  switch (GET_CODE (operands[1]))
    {
    case EQ:
    case GT:
    case LT:
      if (!eqltgt_operator (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !reg_or_scst5_operand (operands[3], E_SImode))
            return -1;
          return 0;

        case E_SFmode:
          if (!register_operand (operands[2], E_SFmode)
              || !register_operand (operands[3], E_SFmode))
            return -1;
          return 1;

        case E_DFmode:
          if (!register_operand (operands[2], E_DFmode)
              || !register_operand (operands[3], E_DFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case GTU:
    case LTU:
      if (!ltugtu_operator (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      return 3;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || pattern83 (x1, 
E_HImode, 
E_SImode) != 0)
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_scst5_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case MINUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 1;

    case IOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_scst5_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 2;

    case XOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_scst5_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 3;

    case AND:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_scst5_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 4;

    case NOT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != AND
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!reg_or_scst5_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (XWINT (x4, 0) != 0L)
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[4] = x5;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      switch (pattern62 (x1))
        {
        case 0:
          return 58; /* *scmpsi_and_insn */

        case 1:
          if (!
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 66; /* *cmpsf_and_insn */

        case 2:
          if (!
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 68; /* *cmpdf_and_insn */

        case 3:
          if (reg_or_ucst5_operand (operands[3], E_SImode)
              && 
#line 1086 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return 60; /* *ucmpsi_and_insn_64 */
          if (!reg_or_ucst4_operand (operands[3], E_SImode)
              || !
#line 1101 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!TARGET_INSNS_64))
            return -1;
          return 62; /* *ucmpsi_and_insn */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 13)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x2, 1);
      operands[0] = x9;
      return 92; /* condjump_shadow */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  if (pattern10 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || pattern81 (x1, 
32) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 34
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 35
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 36
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 62
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 63
      || GET_MODE (x19) != E_SImode)
    return -1;
  x20 = XVECEXP (x1, 0, 0);
  x21 = XEXP (x20, 1);
  if (GET_MODE (x21) != E_SImode)
    return -1;
  switch (GET_CODE (x21))
    {
    case UDIV:
      if (pattern101 (x1, 
2, 
1, 
0) != 0)
        return -1;
      return 138; /* udivsi3_insn */

    case MOD:
      if (pattern101 (x1, 
5, 
2, 
1) != 0)
        return -1;
      return 140; /* modsi3_insn */

    case DIV:
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 4
          || GET_MODE (x22) != E_SImode)
        return -1;
      x23 = XEXP (x21, 1);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 36
          || GET_MODE (x23) != E_SImode)
        return -1;
      x24 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x24) != SET)
        return -1;
      x25 = XEXP (x24, 1);
      if (GET_CODE (x25) != MOD
          || GET_MODE (x25) != E_SImode)
        return -1;
      x26 = XEXP (x25, 0);
      if (GET_CODE (x26) != REG
          || REGNO (x26) != 4
          || GET_MODE (x26) != E_SImode)
        return -1;
      x27 = XEXP (x25, 1);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 36
          || GET_MODE (x27) != E_SImode
          || pattern100 (x1, 
2, 
1, 
5) != 0)
        return -1;
      return 142; /* divmodsi4_insn */

    case UMOD:
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 4
          || GET_MODE (x22) != E_SImode)
        return -1;
      x23 = XEXP (x21, 1);
      if (GET_CODE (x23) != REG
          || REGNO (x23) != 36
          || GET_MODE (x23) != E_SImode)
        return -1;
      x24 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x24) != USE)
        return -1;
      x28 = XVECEXP (x1, 0, 2);
      x29 = XEXP (x28, 0);
      if (REGNO (x29) != 1
          || REGNO (x3) != 5
          || REGNO (x5) != 7)
        return -1;
      x30 = XEXP (x24, 0);
      operands[0] = x30;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 145; /* umodsi3_insn_indcall */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60, x61, x62, x63, x64, x65;
  rtx x66, x67, x68, x69, x70, x71, x72, x73;
  rtx x74, x75;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XVECEXP (x2, 0, 5);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XVECEXP (x2, 0, 6);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XVECEXP (x2, 0, 7);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PLUS
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 47
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XEXP (x10, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != 47
      || GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XEXP (x1, 0);
  operands[0] = x15;
  x16 = XEXP (x15, 0);
  operands[1] = x16;
  x17 = XEXP (x3, 0);
  if (GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XEXP (x3, 1);
  if (GET_MODE (x18) != E_SImode)
    return -1;
  x19 = XEXP (x4, 0);
  if (GET_MODE (x19) != E_DImode)
    return -1;
  x20 = XEXP (x4, 1);
  if (GET_MODE (x20) != E_DImode)
    return -1;
  x21 = XEXP (x5, 0);
  if (GET_MODE (x21) != E_DImode)
    return -1;
  x22 = XEXP (x5, 1);
  if (GET_MODE (x22) != E_DImode)
    return -1;
  x23 = XEXP (x6, 0);
  if (GET_MODE (x23) != E_DImode)
    return -1;
  x24 = XEXP (x6, 1);
  if (GET_MODE (x24) != E_DImode)
    return -1;
  x25 = XEXP (x7, 0);
  if (GET_MODE (x25) != E_DImode)
    return -1;
  x26 = XEXP (x7, 1);
  if (GET_MODE (x26) != E_DImode)
    return -1;
  x27 = XEXP (x8, 0);
  if (GET_MODE (x27) != E_DImode)
    return -1;
  x28 = XEXP (x8, 1);
  if (GET_MODE (x28) != E_DImode)
    return -1;
  x29 = XEXP (x9, 0);
  if (GET_MODE (x29) != E_DImode)
    return -1;
  x30 = XEXP (x9, 1);
  if (GET_MODE (x30) != E_DImode)
    return -1;
  switch (GET_CODE (x18))
    {
    case REG:
      if (REGNO (x18) != 46
          || GET_CODE (x17) != MEM)
        return -1;
      x31 = XEXP (x17, 0);
      if (GET_CODE (x31) != REG
          || REGNO (x31) != 47
          || GET_MODE (x31) != E_SImode
          || GET_CODE (x20) != REG
          || REGNO (x20) != 14
          || GET_CODE (x19) != MEM)
        return -1;
      x32 = XEXP (x19, 0);
      if (GET_CODE (x32) != PLUS
          || GET_MODE (x32) != E_SImode)
        return -1;
      x33 = XEXP (x32, 0);
      if (GET_CODE (x33) != REG
          || REGNO (x33) != 47
          || GET_MODE (x33) != E_SImode)
        return -1;
      x34 = XEXP (x32, 1);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + -8]
          || GET_CODE (x22) != REG
          || REGNO (x22) != 44
          || GET_CODE (x21) != MEM)
        return -1;
      x35 = XEXP (x21, 0);
      if (GET_CODE (x35) != PLUS
          || GET_MODE (x35) != E_SImode)
        return -1;
      x36 = XEXP (x35, 0);
      if (GET_CODE (x36) != REG
          || REGNO (x36) != 47
          || GET_MODE (x36) != E_SImode)
        return -1;
      x37 = XEXP (x35, 1);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + -16]
          || GET_CODE (x24) != REG
          || REGNO (x24) != 12
          || GET_CODE (x23) != MEM)
        return -1;
      x38 = XEXP (x23, 0);
      if (GET_CODE (x38) != PLUS
          || GET_MODE (x38) != E_SImode)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != REG
          || REGNO (x39) != 47
          || GET_MODE (x39) != E_SImode)
        return -1;
      x40 = XEXP (x38, 1);
      if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + -24]
          || GET_CODE (x26) != REG
          || REGNO (x26) != 42
          || GET_CODE (x25) != MEM)
        return -1;
      x41 = XEXP (x25, 0);
      if (GET_CODE (x41) != PLUS
          || GET_MODE (x41) != E_SImode)
        return -1;
      x42 = XEXP (x41, 0);
      if (GET_CODE (x42) != REG
          || REGNO (x42) != 47
          || GET_MODE (x42) != E_SImode)
        return -1;
      x43 = XEXP (x41, 1);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + -32]
          || GET_CODE (x28) != REG
          || REGNO (x28) != 10
          || GET_CODE (x27) != MEM)
        return -1;
      x44 = XEXP (x27, 0);
      if (GET_CODE (x44) != PLUS
          || GET_MODE (x44) != E_SImode)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 47
          || GET_MODE (x45) != E_SImode)
        return -1;
      x46 = XEXP (x44, 1);
      if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + -40]
          || GET_CODE (x30) != REG
          || REGNO (x30) != 34
          || GET_CODE (x29) != MEM)
        return -1;
      x47 = XEXP (x29, 0);
      if (GET_CODE (x47) != PLUS
          || GET_MODE (x47) != E_SImode)
        return -1;
      x48 = XEXP (x47, 0);
      if (GET_CODE (x48) != REG
          || REGNO (x48) != 47
          || GET_MODE (x48) != E_SImode)
        return -1;
      x49 = XEXP (x47, 1);
      if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + -48]
          || XWINT (x13, 0) != -56L)
        return -1;
      x50 = XVECEXP (x2, 0, 8);
      if (GET_CODE (x50) != UNSPEC_VOLATILE
          || XVECLEN (x50, 0) != 1
          || XINT (x50, 1) != 0)
        return -1;
      x51 = XVECEXP (x50, 0, 0);
      if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x52 = XVECEXP (x2, 0, 9);
      if (GET_CODE (x52) != CLOBBER)
        return -1;
      x53 = XEXP (x52, 0);
      if (GET_CODE (x53) != REG
          || REGNO (x53) != 3
          || GET_MODE (x53) != E_SImode
          || !
#line 2889 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS))
        return -1;
      return 473; /* *p push_rts */

    case MEM:
      x54 = XEXP (x18, 0);
      if (GET_CODE (x54) != PLUS
          || GET_MODE (x54) != E_SImode)
        return -1;
      x55 = XEXP (x54, 0);
      if (GET_CODE (x55) != REG
          || REGNO (x55) != 47
          || GET_MODE (x55) != E_SImode)
        return -1;
      x56 = XEXP (x54, 1);
      if (x56 != const_int_rtx[MAX_SAVED_CONST_INT + 56]
          || GET_CODE (x17) != REG
          || REGNO (x17) != 46
          || GET_CODE (x20) != MEM)
        return -1;
      x57 = XEXP (x20, 0);
      if (GET_CODE (x57) != PLUS
          || GET_MODE (x57) != E_SImode)
        return -1;
      x58 = XEXP (x57, 0);
      if (GET_CODE (x58) != REG
          || REGNO (x58) != 47
          || GET_MODE (x58) != E_SImode)
        return -1;
      x59 = XEXP (x57, 1);
      if (x59 != const_int_rtx[MAX_SAVED_CONST_INT + 48]
          || GET_CODE (x19) != REG
          || REGNO (x19) != 14
          || GET_CODE (x22) != MEM)
        return -1;
      x60 = XEXP (x22, 0);
      if (GET_CODE (x60) != PLUS
          || GET_MODE (x60) != E_SImode)
        return -1;
      x61 = XEXP (x60, 0);
      if (GET_CODE (x61) != REG
          || REGNO (x61) != 47
          || GET_MODE (x61) != E_SImode)
        return -1;
      x62 = XEXP (x60, 1);
      if (x62 != const_int_rtx[MAX_SAVED_CONST_INT + 40]
          || GET_CODE (x21) != REG
          || REGNO (x21) != 44
          || GET_CODE (x24) != MEM)
        return -1;
      x63 = XEXP (x24, 0);
      if (GET_CODE (x63) != PLUS
          || GET_MODE (x63) != E_SImode)
        return -1;
      x64 = XEXP (x63, 0);
      if (GET_CODE (x64) != REG
          || REGNO (x64) != 47
          || GET_MODE (x64) != E_SImode)
        return -1;
      x65 = XEXP (x63, 1);
      if (x65 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
          || GET_CODE (x23) != REG
          || REGNO (x23) != 12
          || GET_CODE (x26) != MEM)
        return -1;
      x66 = XEXP (x26, 0);
      if (GET_CODE (x66) != PLUS
          || GET_MODE (x66) != E_SImode)
        return -1;
      x67 = XEXP (x66, 0);
      if (GET_CODE (x67) != REG
          || REGNO (x67) != 47
          || GET_MODE (x67) != E_SImode)
        return -1;
      x68 = XEXP (x66, 1);
      if (x68 != const_int_rtx[MAX_SAVED_CONST_INT + 24]
          || GET_CODE (x25) != REG
          || REGNO (x25) != 42
          || GET_CODE (x28) != MEM)
        return -1;
      x69 = XEXP (x28, 0);
      if (GET_CODE (x69) != PLUS
          || GET_MODE (x69) != E_SImode)
        return -1;
      x70 = XEXP (x69, 0);
      if (GET_CODE (x70) != REG
          || REGNO (x70) != 47
          || GET_MODE (x70) != E_SImode)
        return -1;
      x71 = XEXP (x69, 1);
      if (x71 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || GET_CODE (x27) != REG
          || REGNO (x27) != 10
          || GET_CODE (x30) != MEM)
        return -1;
      x72 = XEXP (x30, 0);
      if (GET_CODE (x72) != PLUS
          || GET_MODE (x72) != E_SImode)
        return -1;
      x73 = XEXP (x72, 0);
      if (GET_CODE (x73) != REG
          || REGNO (x73) != 47
          || GET_MODE (x73) != E_SImode)
        return -1;
      x74 = XEXP (x72, 1);
      if (x74 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
          || GET_CODE (x29) != REG
          || REGNO (x29) != 34
          || XWINT (x13, 0) != 56L)
        return -1;
      x50 = XVECEXP (x2, 0, 8);
      if (GET_CODE (x50) != CLOBBER)
        return -1;
      x75 = XEXP (x50, 0);
      if (GET_CODE (x75) != REG
          || REGNO (x75) != 3
          || GET_MODE (x75) != E_SImode)
        return -1;
      x52 = XVECEXP (x2, 0, 9);
      if (GET_CODE (x52) != RETURN
          || !
#line 2907 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS))
        return -1;
      return 474; /* *p pop_rts */

    default:
      return -1;
    }
}
