/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern17 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 17
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  if (!reg_or_scst5_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x6, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !const_int_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!reg_or_ucst5_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 0
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 1
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 2
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XVECEXP (x2, 0, 5);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 4
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XVECEXP (x2, 0, 6);
  if (GET_CODE (x13) != CLOBBER)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != 5
      || GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XVECEXP (x2, 0, 7);
  if (GET_CODE (x15) != CLOBBER)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != REG
      || REGNO (x16) != 6
      || GET_MODE (x16) != E_SImode)
    return -1;
  x17 = XVECEXP (x2, 0, 8);
  if (GET_CODE (x17) != CLOBBER)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != REG
      || GET_MODE (x18) != E_SImode)
    return -1;
  x19 = XVECEXP (x2, 0, 9);
  if (GET_CODE (x19) != CLOBBER)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != REG
      || GET_MODE (x20) != E_SImode)
    return -1;
  x21 = XVECEXP (x2, 0, 10);
  if (GET_CODE (x21) != CLOBBER)
    return -1;
  x22 = XEXP (x21, 0);
  if (GET_CODE (x22) != REG
      || GET_MODE (x22) != E_SImode)
    return -1;
  x23 = XVECEXP (x2, 0, 11);
  if (GET_CODE (x23) != CLOBBER)
    return -1;
  x24 = XEXP (x23, 0);
  if (GET_CODE (x24) != REG
      || GET_MODE (x24) != E_SImode)
    return -1;
  x25 = XVECEXP (x2, 0, 12);
  if (GET_CODE (x25) != CLOBBER)
    return -1;
  x26 = XEXP (x25, 0);
  if (GET_CODE (x26) != REG
      || GET_MODE (x26) != E_SImode)
    return -1;
  x27 = XVECEXP (x2, 0, 13);
  if (GET_CODE (x27) != CLOBBER)
    return -1;
  x28 = XEXP (x27, 0);
  if (GET_CODE (x28) != REG
      || GET_MODE (x28) != E_SImode)
    return -1;
  x29 = XVECEXP (x2, 0, 14);
  if (GET_CODE (x29) != CLOBBER)
    return -1;
  x30 = XEXP (x29, 0);
  if (GET_CODE (x30) != REG
      || REGNO (x30) != 62
      || GET_MODE (x30) != E_SImode)
    return -1;
  x31 = XVECEXP (x2, 0, 15);
  if (GET_CODE (x31) != CLOBBER)
    return -1;
  x32 = XEXP (x31, 0);
  if (GET_CODE (x32) != REG
      || REGNO (x32) != 63
      || GET_MODE (x32) != E_SImode)
    return -1;
  x33 = XEXP (x1, 0);
  operands[4] = x33;
  x34 = XEXP (x33, 0);
  operands[5] = x34;
  x35 = XEXP (x3, 0);
  operands[0] = x35;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x36 = XEXP (x3, 1);
  if (GET_MODE (x36) != E_SImode)
    return -1;
  x37 = XEXP (x4, 0);
  operands[3] = x37;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x38 = XEXP (x4, 1);
  if (GET_MODE (x38) != E_SImode)
    return -1;
  switch (GET_CODE (x36))
    {
    case DIV:
      if (GET_CODE (x38) != MOD
          || REGNO (x18) != 32
          || pattern47 (x2, 
37, 
36, 
35, 
34, 
33) != 0)
        return -1;
      return 0;

    case UDIV:
      if (GET_CODE (x38) != UMOD
          || REGNO (x18) != 7
          || pattern47 (x2, 
36, 
35, 
34, 
33, 
32) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 4
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x7) != CLOBBER
      || pattern105 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern114 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 6)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 32)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != 33)
    return -1;
  x10 = XVECEXP (x1, 0, 9);
  x11 = XEXP (x10, 0);
  if (REGNO (x11) != 34)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  x13 = XEXP (x12, 0);
  if (REGNO (x13) != 35)
    return -1;
  x14 = XVECEXP (x1, 0, 11);
  x15 = XEXP (x14, 0);
  if (REGNO (x15) != 36)
    return -1;
  x16 = XVECEXP (x1, 0, 2);
  x17 = XEXP (x16, 0);
  operands[0] = x17;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (pattern64 (x9) != 0)
    return -1;
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XEXP (x9, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 47
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XEXP (x2, 0);
  if (GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x2, 1);
  if (GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XEXP (x3, 0);
  if (GET_MODE (x15) != E_DImode)
    return -1;
  x16 = XEXP (x3, 1);
  if (GET_MODE (x16) != E_DImode)
    return -1;
  x17 = XEXP (x4, 0);
  if (GET_MODE (x17) != E_DImode)
    return -1;
  x18 = XEXP (x4, 1);
  if (GET_MODE (x18) != E_DImode)
    return -1;
  x19 = XEXP (x5, 0);
  if (GET_MODE (x19) != E_DImode)
    return -1;
  x20 = XEXP (x5, 1);
  if (GET_MODE (x20) != E_DImode)
    return -1;
  x21 = XEXP (x6, 0);
  if (GET_MODE (x21) != E_DImode)
    return -1;
  x22 = XEXP (x6, 1);
  if (GET_MODE (x22) != E_DImode)
    return -1;
  x23 = XEXP (x7, 0);
  if (GET_MODE (x23) != E_DImode)
    return -1;
  x24 = XEXP (x7, 1);
  if (GET_MODE (x24) != E_DImode)
    return -1;
  x25 = XEXP (x8, 0);
  if (GET_MODE (x25) != E_DImode)
    return -1;
  x26 = XEXP (x8, 1);
  if (GET_MODE (x26) != E_DImode)
    return -1;
  switch (GET_CODE (x14))
    {
    case REG:
      if (REGNO (x14) != 46
          || GET_CODE (x13) != MEM)
        return -1;
      x27 = XEXP (x13, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 47
          || GET_MODE (x27) != E_SImode
          || GET_CODE (x16) != REG
          || REGNO (x16) != 14
          || GET_CODE (x15) != MEM)
        return -1;
      x28 = XEXP (x15, 0);
      if (pattern92 (x28) != 0
          || GET_CODE (x18) != REG
          || REGNO (x18) != 44
          || GET_CODE (x17) != MEM)
        return -1;
      x29 = XEXP (x17, 0);
      if (pattern96 (x29) != 0
          || GET_CODE (x20) != REG
          || REGNO (x20) != 12
          || GET_CODE (x19) != MEM)
        return -1;
      x30 = XEXP (x19, 0);
      if (pattern99 (x30) != 0
          || GET_CODE (x22) != REG
          || REGNO (x22) != 42
          || GET_CODE (x21) != MEM)
        return -1;
      x31 = XEXP (x21, 0);
      if (pattern110 (x31) != 0
          || GET_CODE (x24) != REG
          || REGNO (x24) != 10
          || GET_CODE (x23) != MEM)
        return -1;
      x32 = XEXP (x23, 0);
      if (pattern113 (x32) != 0
          || GET_CODE (x26) != REG
          || REGNO (x26) != 34
          || GET_CODE (x25) != MEM)
        return -1;
      x33 = XEXP (x25, 0);
      if (pattern115 (x33) != 0
          || XWINT (x11, 0) != -56L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      if (pattern116 (x34) != 0)
        return -1;
      x35 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x35) != CLOBBER)
        return -1;
      x36 = XEXP (x35, 0);
      if (GET_CODE (x36) != REG
          || REGNO (x36) != 3
          || GET_MODE (x36) != E_SImode
          || !
#line 2889 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS))
        return -1;
      return 157; /* push_rts */

    case MEM:
      x37 = XEXP (x14, 0);
      if (GET_CODE (x37) != PLUS
          || GET_MODE (x37) != E_SImode)
        return -1;
      x38 = XEXP (x37, 0);
      if (GET_CODE (x38) != REG
          || REGNO (x38) != 47
          || GET_MODE (x38) != E_SImode)
        return -1;
      x39 = XEXP (x37, 1);
      if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 56]
          || GET_CODE (x13) != REG
          || REGNO (x13) != 46
          || GET_CODE (x16) != MEM)
        return -1;
      x40 = XEXP (x16, 0);
      if (GET_CODE (x40) != PLUS
          || GET_MODE (x40) != E_SImode)
        return -1;
      x41 = XEXP (x40, 0);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 47
          || GET_MODE (x41) != E_SImode)
        return -1;
      x42 = XEXP (x40, 1);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 48]
          || GET_CODE (x15) != REG
          || REGNO (x15) != 14
          || GET_CODE (x18) != MEM)
        return -1;
      x43 = XEXP (x18, 0);
      if (GET_CODE (x43) != PLUS
          || GET_MODE (x43) != E_SImode)
        return -1;
      x44 = XEXP (x43, 0);
      if (GET_CODE (x44) != REG
          || REGNO (x44) != 47
          || GET_MODE (x44) != E_SImode)
        return -1;
      x45 = XEXP (x43, 1);
      if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 40]
          || GET_CODE (x17) != REG
          || REGNO (x17) != 44
          || GET_CODE (x20) != MEM)
        return -1;
      x46 = XEXP (x20, 0);
      if (GET_CODE (x46) != PLUS
          || GET_MODE (x46) != E_SImode)
        return -1;
      x47 = XEXP (x46, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 47
          || GET_MODE (x47) != E_SImode)
        return -1;
      x48 = XEXP (x46, 1);
      if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
          || GET_CODE (x19) != REG
          || REGNO (x19) != 12
          || GET_CODE (x22) != MEM)
        return -1;
      x49 = XEXP (x22, 0);
      if (GET_CODE (x49) != PLUS
          || GET_MODE (x49) != E_SImode)
        return -1;
      x50 = XEXP (x49, 0);
      if (GET_CODE (x50) != REG
          || REGNO (x50) != 47
          || GET_MODE (x50) != E_SImode)
        return -1;
      x51 = XEXP (x49, 1);
      if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 24]
          || GET_CODE (x21) != REG
          || REGNO (x21) != 42
          || GET_CODE (x24) != MEM)
        return -1;
      x52 = XEXP (x24, 0);
      if (GET_CODE (x52) != PLUS
          || GET_MODE (x52) != E_SImode)
        return -1;
      x53 = XEXP (x52, 0);
      if (GET_CODE (x53) != REG
          || REGNO (x53) != 47
          || GET_MODE (x53) != E_SImode)
        return -1;
      x54 = XEXP (x52, 1);
      if (x54 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || GET_CODE (x23) != REG
          || REGNO (x23) != 10
          || GET_CODE (x26) != MEM)
        return -1;
      x55 = XEXP (x26, 0);
      if (GET_CODE (x55) != PLUS
          || GET_MODE (x55) != E_SImode)
        return -1;
      x56 = XEXP (x55, 0);
      if (GET_CODE (x56) != REG
          || REGNO (x56) != 47
          || GET_MODE (x56) != E_SImode)
        return -1;
      x57 = XEXP (x55, 1);
      if (x57 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
          || GET_CODE (x25) != REG
          || REGNO (x25) != 34
          || XWINT (x11, 0) != 56L)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x34) != CLOBBER)
        return -1;
      x58 = XEXP (x34, 0);
      if (GET_CODE (x58) != REG
          || REGNO (x58) != 3
          || GET_MODE (x58) != E_SImode)
        return -1;
      x35 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x35) != RETURN
          || !
#line 2907 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS))
        return -1;
      return 158; /* pop_rts */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LO_SUM:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x8;
          if (!const_int_or_symbolic_operand (operands[2], E_SImode)
              || !
#line 399 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
            return -1;
          return 343; /* *p movsi_lo_sum */

        case UNSPEC:
          if (XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 8
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          operands[2] = x9;
          if (!symbolic_operand (operands[2], E_SImode)
              || !
#line 415 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(flag_pic == 2))
            return -1;
          return 345; /* *p movsi_gotoff_lo_sum */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_18 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_17 (x1, insn, pnum_clobbers);

    case IOR:
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case AND:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x10 = XEXP (x7, 1);
          if (GET_CODE (x10) != CONST_INT
              || XWINT (x10, 0) != 65535L)
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != ASHIFT
              || GET_MODE (x8) != E_SImode)
            return -1;
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x4 = XEXP (x1, 0);
          operands[2] = x4;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x12 = XEXP (x8, 0);
          operands[1] = x12;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x7, 0);
          if (!rtx_equal_p (x13, operands[0])
              || !
#line 447 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
            return -1;
          return 348; /* *p *movstricthi_high */

        case REG:
        case SUBREG:
          operands[1] = x7;
          x4 = XEXP (x1, 0);
          operands[3] = x4;
          x5 = XEXP (x4, 0);
          operands[4] = x5;
          switch (pattern38 (x3))
            {
            case 0:
              if (!iorsi_operand (operands[2], E_SImode))
                return -1;
              return 425; /* *p iorsi3 */

            case 1:
              return 478; /* *p iorv2hi3 */

            case 2:
              return 481; /* *p iorv4qi3 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x10 = XEXP (x7, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != LSHIFTRT
              || GET_MODE (x8) != E_SImode)
            return -1;
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 24]
              || pattern71 (x1, 
E_SImode) != 0
              || !
#line 2207 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 450; /* *p shlmbsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern35 (x1))
        {
        case 0:
          return 381; /* *p zero_extendqisi2 */

        case 1:
          return 383; /* *p zero_extendhisi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern35 (x1))
        {
        case 0:
          return 382; /* *p sign_extendqisi2 */

        case 1:
          return 384; /* *p sign_extendhisi2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pattern36 (x1) != 0
          || !
#line 904 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(INTVAL (operands[3]) >= 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32))
        return -1;
      return 385; /* *p *extzv_const */

    case SIGN_EXTRACT:
      if (pattern36 (x1) != 0
          || !
#line 904 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(INTVAL (operands[3]) >= 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32))
        return -1;
      return 386; /* *p *extv_const */

    case EQ:
    case GT:
    case LT:
      operands[1] = x3;
      if (!eqltgt_operator (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x1, 0);
      operands[4] = x4;
      x5 = XEXP (x4, 0);
      operands[5] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !reg_or_scst5_operand (operands[3], E_SImode))
            return -1;
          return 394; /* *p scmpsi_insn */

        case E_SFmode:
          if (!register_operand (operands[2], E_SFmode)
              || !register_operand (operands[3], E_SFmode)
              || !
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 397; /* *p *cmpsf_insn */

        case E_DFmode:
          if (!register_operand (operands[2], E_DFmode)
              || !register_operand (operands[3], E_DFmode)
              || !
#line 1137 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 398; /* *p *cmpdf_insn */

        default:
          return -1;
        }

    case GTU:
    case LTU:
      operands[1] = x3;
      if (!ltugtu_operator (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x1, 0);
      operands[4] = x4;
      x5 = XEXP (x4, 0);
      operands[5] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (reg_or_ucst5_operand (operands[3], E_SImode)
          && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
        return 395; /* *p *ucmpsi_insn_64 */
      if (!reg_or_ucst4_operand (operands[3], E_SImode)
          || !
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!TARGET_INSNS_64))
        return -1;
      return 396; /* *p *ucmpsi_insn */

    case CALL:
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 13)
        return -1;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x14 = XVECEXP (x7, 0, 0);
      if (GET_CODE (x14) == PC)
        {
          x4 = XEXP (x1, 0);
          operands[1] = x4;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          return 406; /* *p indirect_call_value_shadow */
        }
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      operands[1] = x14;
      return 409; /* *p call_value_shadow */

    case IF_THEN_ELSE:
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != EQ)
        return -1;
      x13 = XEXP (x7, 0);
      if (GET_CODE (x13) != UNSPEC
          || XVECLEN (x13, 0) != 1
          || XINT (x13, 1) != 13)
        return -1;
      x15 = XVECEXP (x13, 0, 0);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x7, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x16 = XEXP (x3, 2);
      if (GET_CODE (x16) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x4 = XEXP (x1, 0);
      operands[1] = x4;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x8 = XEXP (x3, 1);
      operands[0] = x8;
      return 413; /* *p condjump_shadow */

    case PLUS:
      return recog_16 (x1, insn, pnum_clobbers);

    case MINUS:
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[2] = x8;
          x4 = XEXP (x1, 0);
          operands[3] = x4;
          x5 = XEXP (x4, 0);
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern75 (x3) != 0)
                return -1;
              return 416; /* *p subsi3 */

            case E_SFmode:
              if (pattern37 (x3, 
E_SFmode) != 0
                  || !
#line 1806 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
                return -1;
              return 422; /* *p subsf3 */

            case E_DFmode:
              if (pattern37 (x3, 
E_DFmode) != 0
                  || !
#line 1818 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
                return -1;
              return 423; /* *p subdf3 */

            case E_V2HImode:
              if (pattern37 (x3, 
E_V2HImode) != 0)
                return -1;
              return 484; /* *p subv2hi3 */

            case E_V4QImode:
              if (pattern37 (x3, 
E_V4QImode) != 0
                  || !
#line 2996 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 486; /* *p subv4qi3 */

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[4] = x4;
          x5 = XEXP (x4, 0);
          operands[5] = x5;
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x8, 0);
          operands[2] = x12;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x8, 1);
          operands[3] = x11;
          if (!suba_scale_operand (operands[3], E_SImode))
            return -1;
          return 418; /* *p *subshiftsi */

        default:
          return -1;
        }

    case AND:
      switch (pattern39 (x1))
        {
        case 0:
          if (!andsi_operand (operands[2], E_SImode))
            return -1;
          return 424; /* *p andsi3 */

        case 1:
          return 477; /* *p andv2hi3 */

        case 2:
          return 480; /* *p andv4qi3 */

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern74 (x3, 
E_SImode) != 0)
            return -1;
          return 426; /* *p xorsi3 */

        case E_V2HImode:
          if (pattern37 (x3, 
E_V2HImode) != 0)
            return -1;
          return 479; /* *p xorv2hi3 */

        case E_V4QImode:
          if (pattern37 (x3, 
E_V4QImode) != 0)
            return -1;
          return 482; /* *p xorv4qi3 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 1877 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
        return -1;
      return 427; /* *p extendsfdf2 */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 1886 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
        return -1;
      return 428; /* *p truncdfsf2 */

    case FLOAT:
      switch (pattern40 (x1))
        {
        case 0:
          if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 429; /* *p floatsisf2 */

        case 1:
          if (!
#line 1914 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 431; /* *p floatsidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern40 (x1))
        {
        case 0:
          if (!
#line 1905 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 430; /* *p floatunssisf2 */

        case 1:
          if (!
#line 1923 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 432; /* *p floatunssidf2 */

        default:
          return -1;
        }

    case FIX:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 1932 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 433; /* *p fix_truncsfsi2 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 1941 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 434; /* *p fix_truncdfsi2 */

        default:
          return -1;
        }

    case SS_PLUS:
      switch (pattern39 (x1))
        {
        case 0:
          if (!reg_or_const_int_operand (operands[2], E_SImode))
            return -1;
          return 435; /* *p saddsi3 */

        case 1:
          if (!
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 487; /* *p ss_addv2hi3 */

        case 2:
          if (!
#line 3023 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 489; /* *p us_addv4qi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern75 (x3) != 0)
            return -1;
          return 436; /* *p ssubsi3 */

        case E_V2HImode:
          if (pattern37 (x3, 
E_V2HImode) != 0
              || !
#line 3014 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 488; /* *p ss_subv2hi3 */

        default:
          return -1;
        }

    case NEG:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 440; /* *p negsi2 */

    case NOT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 441; /* *p one_cmplsi2 */

    case CLRSB:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 442; /* *p clrsbsi2 */

    case CLZ:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 443; /* *p clzsi2 */

    case SS_ABS:
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      switch (pattern42 (x3))
        {
        case 0:
          return 444; /* *p ssabssi2 */

        case 1:
          if (!
#line 3105 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 500; /* *p ssabsv2hi2 */

        default:
          return -1;
        }

    case SS_ASHIFT:
      if (pattern41 (x1) != 0)
        return -1;
      return 445; /* *p ss_ashlsi3 */

    case ASHIFT:
      if (pattern41 (x1) != 0)
        return -1;
      return 446; /* *p ashlsi3 */

    case ASHIFTRT:
      switch (pattern43 (x1))
        {
        case 0:
          return 447; /* *p ashrsi3 */

        case 1:
          if (!
#line 3077 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 498; /* *p ashrv2hi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern43 (x1))
        {
        case 0:
          return 448; /* *p lshrsi3 */

        case 1:
          if (!
#line 3077 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 499; /* *p lshrv2hi3 */

        default:
          return -1;
        }

    case ROTATERT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 2196 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS))
        return -1;
      return 449; /* *p rotrdi3_16 */

    case BSWAP:
      if (GET_MODE (x3) != E_V2HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_V2HImode)
          || !
#line 2255 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
        return -1;
      return 451; /* *p bswapv2hi2 */

    case MULT:
      return recog_15 (x1, insn, pnum_clobbers);

    case SMAX:
      switch (pattern44 (x1))
        {
        case 0:
          if (!
#line 3037 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 490; /* *p smaxhi3 */

        case 1:
          if (!
#line 3037 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 491; /* *p smaxv2hi3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern44 (x1))
        {
        case 0:
          if (!
#line 3047 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 492; /* *p sminhi3 */

        case 1:
          if (!
#line 3047 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 493; /* *p sminv2hi3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 3057 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 494; /* *p umaxqi3 */

        case 1:
          if (!
#line 3057 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 495; /* *p umaxv4qi3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 3066 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 496; /* *p uminqi3 */

        case 1:
          if (!
#line 3066 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 497; /* *p uminv4qi3 */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern41 (x1) != 0
          || !
#line 34 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
        return -1;
      return 503; /* *p rotlsi3 */

    case SS_MULT:
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != FRACT_CONVERT)
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != FRACT_CONVERT)
        return -1;
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x13 = XEXP (x7, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
          operands[1] = x13;
          x12 = XEXP (x8, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              operands[2] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SQmode:
                  if (pattern87 (x3, 
E_V2HQmode, 
E_V2SQmode) != 0)
                    return -1;
                  return 530; /* *p mulv2hqv2sq3 */

                case E_SQmode:
                  if (pattern87 (x3, 
E_HQmode, 
E_SQmode) != 0)
                    return -1;
                  return 531; /* *p mulhqsq3 */

                default:
                  return -1;
                }

            case TRUNCATE:
              if (GET_MODE (x12) != E_HQmode
                  || !register_operand (operands[0], E_SQmode)
                  || GET_MODE (x3) != E_SQmode
                  || GET_MODE (x7) != E_SQmode
                  || !register_operand (operands[1], E_HQmode)
                  || GET_MODE (x8) != E_SQmode)
                return -1;
              x17 = XEXP (x12, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_SQmode))
                return -1;
              return 532; /* *p mulhqsq3_lh */

            default:
              return -1;
            }

        case TRUNCATE:
          if (GET_MODE (x13) != E_HQmode
              || !register_operand (operands[0], E_SQmode)
              || GET_MODE (x3) != E_SQmode
              || GET_MODE (x7) != E_SQmode)
            return -1;
          x18 = XEXP (x13, 0);
          operands[1] = x18;
          if (!register_operand (operands[1], E_SQmode)
              || GET_MODE (x8) != E_SQmode)
            return -1;
          x12 = XEXP (x8, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              operands[2] = x12;
              if (!register_operand (operands[2], E_HQmode))
                return -1;
              return 533; /* *p mulhqsq3_hl */

            case TRUNCATE:
              if (GET_MODE (x12) != E_HQmode)
                return -1;
              x17 = XEXP (x12, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_SQmode))
                return -1;
              return 534; /* *p mulhqsq3_hh */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
