/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1, int *pnum_clobbers, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 4
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 4
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 36
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x7, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 5
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != USE)
    return -1;
  x13 = XEXP (x12, 0);
  operands[0] = x13;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x3, 2);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 4
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!scst5_operand (operands[2], i1)
      || !const_int_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern58 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  operands[2] = x7;
  if (!reg_or_const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !const_int_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern81 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1)
    return -1;
  return 0;
}

int
pattern87 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern95 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern102 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern109 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != 6
      || pattern108 (x1, 
36, 
35, 
34, 
33, 
32) != 0)
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[4] = x4;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (XWINT (x5, 0) != 0L)
        return -1;
      switch (pattern62 (x1))
        {
        case 0:
          return 59; /* *scmpsi_ior_insn */

        case 1:
          if (!
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 67; /* *cmpsf_ior_insn */

        case 2:
          if (!
#line 1181 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 69; /* *cmpdf_ior_insn */

        case 3:
          if (reg_or_ucst5_operand (operands[3], E_SImode)
              && 
#line 1086 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return 61; /* *ucmpsi_ior_insn_64 */
          if (!reg_or_ucst4_operand (operands[3], E_SImode)
              || !
#line 1101 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!TARGET_INSNS_64))
            return -1;
          return 63; /* *ucmpsi_ior_insn */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 2
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (XWINT (x5, 0) != 1L)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XVECEXP (x4, 0, 0);
      operands[0] = x9;
      if (!const_int_operand (operands[0], E_SImode))
        return -1;
      x10 = XVECEXP (x4, 0, 1);
      operands[1] = x10;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x6, 0);
      operands[2] = x11;
      if (!
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS))
        return -1;
      return 79; /* spkernel */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x6 = XEXP (x1, 0);
  operands[2] = x6;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x3, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode)
      || !
#line 3117 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
    return -1;
  return 501; /* *p *packv2hi_insv */
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XINT (x3, 1))
        {
        case 8:
          if (pattern65 (x1) != 0
              || !
#line 434 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(flag_pic == 2))
            return -1;
          return 347; /* *p load_got_gotoff */

        case 19:
          if (pattern66 (x1) != 0)
            return -1;
          return 392; /* *p extr */

        case 20:
          if (pattern66 (x1) != 0)
            return -1;
          return 393; /* *p extru */

        case 21:
          if (pattern65 (x1) != 0)
            return -1;
          return 437; /* *p subcsi3 */

        case 4:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (!pic_register_operand (operands[0], E_SImode))
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[1] = x7;
          if (!symbolic_operand (operands[1], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x8, operands[0])
              || !
#line 2937 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_DSBT))
            return -1;
          return 475; /* *p setup_dsbt */

        case 22:
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x6 = XEXP (x5, 0);
          operands[4] = x6;
          x8 = XVECEXP (x3, 0, 0);
          operands[1] = x8;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HImode:
              if (pattern85 (x3, 
E_V2HImode) != 0
                  || !
#line 56 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                return -1;
              return 505; /* *p avgv2hi3 */

            case E_V4QImode:
              if (pattern85 (x3, 
E_V4QImode) != 0
                  || !
#line 66 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                return -1;
              return 506; /* *p uavgv4qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (XINT (x3, 1))
        {
        case 14:
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          return 371; /* *p load_shadow */

        case 15:
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          return 372; /* *p mult_shadow */

        case 2:
          switch (pattern59 (x1))
            {
            case 0:
              if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 377; /* *p movmisalignsi_load */

            case 1:
              if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 378; /* *p movmisaligndi_load */

            case 2:
              if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 379; /* *p movmisalignv2hi_load */

            case 3:
              if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 380; /* *p movmisalignv4qi_load */

            default:
              return -1;
            }

        case 13:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != PC)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
            {
              x5 = XEXP (x1, 0);
              operands[0] = x5;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              return 405; /* *p indirect_jump_shadow */
            }
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          operands[0] = x8;
          return 412; /* *p jump_shadow */

        case 1:
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x8 = XVECEXP (x3, 0, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x3) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !
#line 2783 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
                return -1;
              return 470; /* *p rcpsf2 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x3) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 2792 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
                return -1;
              return 471; /* *p rcpdf2 */

            default:
              return -1;
            }

        case 16:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 476; /* *p epilogue_barrier */

        case 7:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 44 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
            return -1;
          return 504; /* *p bitrevsi2 */

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 18
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XVECEXP (x3, 0, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x3, 0, 2);
      operands[3] = x9;
      if (!reg_or_const_int_operand (operands[3], E_SImode))
        return -1;
      return 391; /* *p clrr */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LO_SUM:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[2] = x5;
          if (!const_int_or_symbolic_operand (operands[2], E_SImode)
              || !
#line 399 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
            return -1;
          return 3; /* movsi_lo_sum */

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 8
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[2] = x6;
          if (!symbolic_operand (operands[2], E_SImode)
              || !
#line 415 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(flag_pic == 2))
            return -1;
          return 5; /* movsi_gotoff_lo_sum */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_8 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_5 (x1, insn, pnum_clobbers);

    case IOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST_INT
              || XWINT (x7, 0) != 65535L)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != ASHIFT
              || GET_MODE (x5) != E_SImode)
            return -1;
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x4, 0);
          if (!rtx_equal_p (x10, operands[0])
              || !
#line 447 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
            return -1;
          return 8; /* *movstricthi_high */

        case REG:
        case SUBREG:
          switch (pattern13 (x2))
            {
            case 0:
              if (!iorsi_operand (operands[2], E_SImode))
                return -1;
              return 104; /* iorsi3 */

            case 1:
              return 162; /* iorv2hi3 */

            case 2:
              return 165; /* iorv4qi3 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != LSHIFTRT
              || GET_MODE (x5) != E_SImode)
            return -1;
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 24]
              || pattern49 (x2, 
E_SImode) != 0
              || !
#line 2207 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 134; /* shlmbsi3 */

        default:
          return -1;
        }

    case PLUS:
      return recog_6 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      switch (pattern0 (x1))
        {
        case 0:
          return 42; /* zero_extendqisi2 */

        case 1:
          return 44; /* zero_extendhisi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern0 (x1))
        {
        case 0:
          return 43; /* sign_extendqisi2 */

        case 1:
          return 45; /* sign_extendhisi2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pattern1 (x1) != 0
          || !
#line 904 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(INTVAL (operands[3]) >= 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32))
        return -1;
      return 46; /* *extzv_const */

    case SIGN_EXTRACT:
      if (pattern1 (x1) != 0
          || !
#line 904 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(INTVAL (operands[3]) >= 0
   && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32))
        return -1;
      return 47; /* *extv_const */

    case EQ:
    case GT:
    case LT:
      operands[1] = x2;
      if (!eqltgt_operator (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !reg_or_scst5_operand (operands[3], E_SImode))
            return -1;
          return 55; /* scmpsi_insn */

        case E_SFmode:
          if (!register_operand (operands[2], E_SFmode)
              || !register_operand (operands[3], E_SFmode)
              || !
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 64; /* *cmpsf_insn */

        case E_DFmode:
          if (!register_operand (operands[2], E_DFmode)
              || !register_operand (operands[3], E_DFmode)
              || !
#line 1137 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 65; /* *cmpdf_insn */

        default:
          return -1;
        }

    case GTU:
    case LTU:
      operands[1] = x2;
      if (!ltugtu_operator (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (reg_or_ucst5_operand (operands[3], E_SImode)
          && 
#line 1041 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
        return 56; /* *ucmpsi_insn_64 */
      if (!reg_or_ucst4_operand (operands[3], E_SImode)
          || !
#line 1052 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!TARGET_INSNS_64))
        return -1;
      return 57; /* *ucmpsi_insn */

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          switch (GET_CODE (x4))
            {
            case EQ:
              res = recog_3 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case NE:
              res = recog_4 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          if (XWINT (x7, 0) != 0L)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          operands[0] = x4;
          if (!predicate_operator (operands[0], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case LABEL_REF:
              x11 = XEXP (x2, 2);
              if (GET_CODE (x11) != PC)
                return -1;
              x9 = XEXP (x5, 0);
              operands[2] = x9;
              return 74; /* br_true */

            case PC:
              x11 = XEXP (x2, 2);
              if (GET_CODE (x11) != LABEL_REF)
                return -1;
              x12 = XEXP (x11, 0);
              operands[2] = x12;
              return 75; /* br_false */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case UNSPEC:
          if (XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 13)
            return -1;
          x13 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x13) == PC)
            return 85; /* indirect_call_value_shadow */
          operands[1] = x13;
          return 88; /* call_value_shadow */

        case MEM:
          x10 = XEXP (x4, 0);
          operands[1] = x10;
          if (!c6x_call_operand (operands[1], E_SImode))
            return -1;
          return 118; /* call_value_internal */

        default:
          return -1;
        }

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern31 (x2) != 0)
                return -1;
              return 95; /* subsi3 */

            case E_SFmode:
              if (pattern7 (x2, 
E_SFmode) != 0
                  || !
#line 1806 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
                return -1;
              return 101; /* subsf3 */

            case E_DFmode:
              if (pattern7 (x2, 
E_DFmode) != 0
                  || !
#line 1818 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
                return -1;
              return 102; /* subdf3 */

            case E_V2HImode:
              if (pattern7 (x2, 
E_V2HImode) != 0)
                return -1;
              return 168; /* subv2hi3 */

            case E_V4QImode:
              if (pattern7 (x2, 
E_V4QImode) != 0
                  || !
#line 2996 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 170; /* subv4qi3 */

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x5, 1);
          operands[3] = x8;
          if (!suba_scale_operand (operands[3], E_SImode))
            return -1;
          return 97; /* *subshiftsi */

        default:
          return -1;
        }

    case AND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern13 (x2))
        {
        case 0:
          if (!andsi_operand (operands[2], E_SImode))
            return -1;
          return 103; /* andsi3 */

        case 1:
          return 161; /* andv2hi3 */

        case 2:
          return 164; /* andv4qi3 */

        default:
          return -1;
        }

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern30 (x2, 
E_SImode) != 0)
            return -1;
          return 105; /* xorsi3 */

        case E_V2HImode:
          if (pattern7 (x2, 
E_V2HImode) != 0)
            return -1;
          return 163; /* xorv2hi3 */

        case E_V4QImode:
          if (pattern7 (x2, 
E_V4QImode) != 0)
            return -1;
          return 166; /* xorv4qi3 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 1877 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
        return -1;
      return 106; /* extendsfdf2 */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 1886 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
        return -1;
      return 107; /* truncdfsf2 */

    case FLOAT:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 108; /* floatsisf2 */

        case 1:
          if (!
#line 1914 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 110; /* floatsidf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1905 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 109; /* floatunssisf2 */

        case 1:
          if (!
#line 1923 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 111; /* floatunssidf2 */

        default:
          return -1;
        }

    case FIX:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 1932 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 112; /* fix_truncsfsi2 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 1941 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 113; /* fix_truncdfsi2 */

        default:
          return -1;
        }

    case SS_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern13 (x2))
        {
        case 0:
          if (!reg_or_const_int_operand (operands[2], E_SImode))
            return -1;
          return 114; /* saddsi3 */

        case 1:
          if (!
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 171; /* ss_addv2hi3 */

        case 2:
          if (!
#line 3023 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 173; /* us_addv4qi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x2) != 0)
            return -1;
          return 115; /* ssubsi3 */

        case E_V2HImode:
          if (pattern7 (x2, 
E_V2HImode) != 0
              || !
#line 3014 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 172; /* ss_subv2hi3 */

        default:
          return -1;
        }

    case NEG:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 124; /* negsi2 */

    case NOT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 125; /* one_cmplsi2 */

    case CLRSB:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 126; /* clrsbsi2 */

    case CLZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 127; /* clzsi2 */

    case SS_ABS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern4 (x2))
        {
        case 0:
          return 128; /* ssabssi2 */

        case 1:
          if (!
#line 3105 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 184; /* ssabsv2hi2 */

        default:
          return -1;
        }

    case SS_ASHIFT:
      if (pattern3 (x1) != 0)
        return -1;
      return 129; /* ss_ashlsi3 */

    case ASHIFT:
      if (pattern3 (x1) != 0)
        return -1;
      return 130; /* ashlsi3 */

    case ASHIFTRT:
      switch (pattern5 (x1))
        {
        case 0:
          return 131; /* ashrsi3 */

        case 1:
          if (!
#line 3077 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 182; /* ashrv2hi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern5 (x1))
        {
        case 0:
          return 132; /* lshrsi3 */

        case 1:
          if (!
#line 3077 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 183; /* lshrv2hi3 */

        default:
          return -1;
        }

    case ROTATERT:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 2196 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS))
        return -1;
      return 133; /* rotrdi3_16 */

    case BSWAP:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2HImode)
          || !
#line 2255 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
        return -1;
      return 135; /* bswapv2hi2 */

    case DIV:
      if (pattern6 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 12;
      return 136; /* divsi3_insn */

    case UDIV:
      if (pattern6 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 11;
      return 138; /* udivsi3_insn */

    case MOD:
      if (pattern6 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 11;
      return 140; /* modsi3_insn */

    case UMOD:
      if (pattern6 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 10;
      return 144; /* umodsi3_insn */

    case MULT:
      return recog_7 (x1, insn, pnum_clobbers);

    case SMAX:
      switch (pattern8 (x1))
        {
        case 0:
          if (!
#line 3037 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 174; /* smaxhi3 */

        case 1:
          if (!
#line 3037 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 175; /* smaxv2hi3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern8 (x1))
        {
        case 0:
          if (!
#line 3047 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 176; /* sminhi3 */

        case 1:
          if (!
#line 3047 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 177; /* sminv2hi3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern9 (x1))
        {
        case 0:
          if (!
#line 3057 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 178; /* umaxqi3 */

        case 1:
          if (!
#line 3057 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 179; /* umaxv4qi3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern9 (x1))
        {
        case 0:
          if (!
#line 3066 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 180; /* uminqi3 */

        case 1:
          if (!
#line 3066 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
            return -1;
          return 181; /* uminv4qi3 */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern3 (x1) != 0
          || !
#line 34 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
        return -1;
      return 187; /* rotlsi3 */

    case SS_MULT:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != FRACT_CONVERT)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != FRACT_CONVERT)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          x9 = XEXP (x5, 0);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SQmode:
                  if (pattern58 (x2, 
E_V2HQmode, 
E_V2SQmode) != 0)
                    return -1;
                  return 214; /* mulv2hqv2sq3 */

                case E_SQmode:
                  if (pattern58 (x2, 
E_HQmode, 
E_SQmode) != 0)
                    return -1;
                  return 215; /* mulhqsq3 */

                default:
                  return -1;
                }

            case TRUNCATE:
              if (GET_MODE (x9) != E_HQmode
                  || !register_operand (operands[0], E_SQmode)
                  || GET_MODE (x2) != E_SQmode
                  || GET_MODE (x4) != E_SQmode
                  || !register_operand (operands[1], E_HQmode)
                  || GET_MODE (x5) != E_SQmode)
                return -1;
              x14 = XEXP (x9, 0);
              operands[2] = x14;
              if (!register_operand (operands[2], E_SQmode))
                return -1;
              return 216; /* mulhqsq3_lh */

            default:
              return -1;
            }

        case TRUNCATE:
          if (GET_MODE (x10) != E_HQmode
              || !register_operand (operands[0], E_SQmode)
              || GET_MODE (x2) != E_SQmode
              || GET_MODE (x4) != E_SQmode)
            return -1;
          x15 = XEXP (x10, 0);
          operands[1] = x15;
          if (!register_operand (operands[1], E_SQmode)
              || GET_MODE (x5) != E_SQmode)
            return -1;
          x9 = XEXP (x5, 0);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[2] = x9;
              if (!register_operand (operands[2], E_HQmode))
                return -1;
              return 217; /* mulhqsq3_hl */

            case TRUNCATE:
              if (GET_MODE (x9) != E_HQmode)
                return -1;
              x14 = XEXP (x9, 0);
              operands[2] = x14;
              if (!register_operand (operands[2], E_SQmode))
                return -1;
              return 218; /* mulhqsq3_hh */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
