/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!reg_or_ucst5_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!c6x_any_comparison_operand (operands[1], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!c6x_any_comparison_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern21 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 17
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  operands[1] = x9;
  if (!memory_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  if (!reg_or_scst5_operand (operands[2], E_SImode)
      || pattern20 (x1) != 0)
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern37 (x6, 
E_QImode); /* [-1, 0] */

    case E_V4QImode:
      if (pattern37 (x6, 
E_V4QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode
          || !memory_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x6) != E_V2HImode
          || !memory_operand (operands[1], E_V2HImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x6) != E_V4QImode
          || !memory_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !reg_or_scst5_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern80 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 17)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern86 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_HImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode
      || !reg_or_scst5_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

int
pattern94 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern100 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != 6)
    return -1;
  return 0;
}

int
pattern110 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 47
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -32])
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC_VOLATILE
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern7 (x3, 
E_SFmode) != 0
              || !
#line 2737 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 150; /* mulsf3 */

        case E_DFmode:
          if (pattern7 (x3, 
E_DFmode) != 0
              || !
#line 2747 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 151; /* muldf3 */

        case E_HImode:
          if (pattern30 (x3, 
E_HImode) != 0)
            return -1;
          return 191; /* mulhi3 */

        case E_SImode:
          if (pattern7 (x3, 
E_SImode) != 0
              || !
#line 270 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
            return -1;
          return 206; /* mulsi3_insn */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x4) != E_DFmode
          || !register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          if (!register_operand (operands[2], E_DFmode)
              || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP_EXT))
            return -1;
          return 152; /* *muldf_ext1 */

        case FLOAT_EXTEND:
          if (GET_MODE (x5) != E_DFmode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SFmode)
              || !
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP_EXT))
            return -1;
          return 153; /* *muldf_ext2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (pattern32 (x3, 
E_HImode) != 0)
            return -1;
          return 192; /* mulhisi3_const */

        case SIGN_EXTEND:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern57 (x3) != 0)
                return -1;
              return 193; /* *mulhisi3_insn */

            case E_DImode:
              if (pattern58 (x3, 
E_SImode, 
E_DImode) != 0
                  || !
#line 282 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                return -1;
              return 208; /* mulsidi3 */

            case E_V2SImode:
              if (pattern58 (x3, 
E_V2HImode, 
E_V2SImode) != 0
                  || !
#line 307 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                return -1;
              return 210; /* mulv2hiv2si3 */

            default:
              return -1;
            }

        case ASHIFTRT:
          if (pattern33 (x3) != 0)
            return -1;
          return 194; /* mulhisi3_lh */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern15 (x3) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 195; /* mulhisi3_hl */

        case ASHIFTRT:
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 196; /* mulhisi3_hh */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern58 (x3, 
E_HImode, 
E_SImode) != 0)
                return -1;
              return 197; /* umulhisi3 */

            case E_DImode:
              if (pattern58 (x3, 
E_SImode, 
E_DImode) != 0
                  || !
#line 282 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                return -1;
              return 207; /* umulsidi3 */

            case E_V4HImode:
              if (pattern58 (x3, 
E_V4QImode, 
E_V4HImode) != 0
                  || !
#line 318 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                return -1;
              return 211; /* umulv4qiv4hi3 */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern33 (x3) != 0)
            return -1;
          return 198; /* umulhisi3_lh */

        case CONST_INT:
          if (pattern32 (x3, 
E_SImode) != 0)
            return -1;
          return 201; /* usmulhisi3_const */

        case SIGN_EXTEND:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern57 (x3) != 0)
                return -1;
              return 202; /* *usmulhisi3_insn */

            case E_DImode:
              if (pattern58 (x3, 
E_SImode, 
E_DImode) != 0
                  || !
#line 294 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                return -1;
              return 209; /* usmulsidi3 */

            case E_V4HImode:
              if (pattern58 (x3, 
E_V4QImode, 
E_V4HImode) != 0
                  || !
#line 329 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                return -1;
              return 212; /* usmulv4qiv4hi3 */

            default:
              return -1;
            }

        case ASHIFTRT:
          if (pattern33 (x3) != 0)
            return -1;
          return 203; /* usmulhisi3_lh */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pattern15 (x3) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 199; /* umulhisi3_hl */

        case LSHIFTRT:
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 200; /* umulhisi3_hh */

        case SIGN_EXTEND:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 204; /* usmulhisi3_hl */

        case ASHIFTRT:
          x8 = XEXP (x5, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 205; /* usmulhisi3_hh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern46 (x2) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || pattern93 (x2, 
32) != 0)
    return -1;
  x7 = XVECEXP (x2, 0, 5);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x2, 0, 6);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 33
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XVECEXP (x2, 0, 7);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 34
      || GET_MODE (x12) != E_SImode)
    return -1;
  x13 = XVECEXP (x2, 0, 8);
  if (GET_CODE (x13) != CLOBBER)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != 35
      || GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XVECEXP (x2, 0, 9);
  if (GET_CODE (x15) != CLOBBER)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != REG
      || REGNO (x16) != 36
      || GET_MODE (x16) != E_SImode)
    return -1;
  x17 = XVECEXP (x2, 0, 10);
  if (GET_CODE (x17) != CLOBBER)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != REG
      || REGNO (x18) != 62
      || GET_MODE (x18) != E_SImode)
    return -1;
  x19 = XVECEXP (x2, 0, 11);
  if (GET_CODE (x19) != CLOBBER)
    return -1;
  x20 = XEXP (x19, 0);
  if (GET_CODE (x20) != REG
      || REGNO (x20) != 63
      || GET_MODE (x20) != E_SImode)
    return -1;
  x21 = XVECEXP (x2, 0, 0);
  x22 = XEXP (x21, 1);
  if (GET_MODE (x22) != E_SImode)
    return -1;
  switch (GET_CODE (x22))
    {
    case UDIV:
      if (pattern106 (x1, 
2, 
1, 
0) != 0)
        return -1;
      return 454; /* *p udivsi3_insn */

    case MOD:
      if (pattern106 (x1, 
5, 
2, 
1) != 0)
        return -1;
      return 456; /* *p modsi3_insn */

    case DIV:
      if (pattern102 (x2, 
SET) != 0)
        return -1;
      x23 = XVECEXP (x2, 0, 1);
      x24 = XEXP (x23, 1);
      if (GET_CODE (x24) != MOD
          || GET_MODE (x24) != E_SImode)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 4
          || GET_MODE (x25) != E_SImode)
        return -1;
      x26 = XEXP (x24, 1);
      if (GET_CODE (x26) != REG
          || REGNO (x26) != 36
          || GET_MODE (x26) != E_SImode
          || pattern105 (x1, 
2, 
1, 
5) != 0)
        return -1;
      return 458; /* *p divmodsi4_insn */

    case UMOD:
      x27 = XEXP (x22, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 4
          || GET_MODE (x27) != E_SImode)
        return -1;
      x28 = XEXP (x22, 1);
      if (GET_CODE (x28) != REG
          || REGNO (x28) != 36
          || GET_MODE (x28) != E_SImode)
        return -1;
      x23 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x23) != USE)
        return -1;
      x29 = XVECEXP (x2, 0, 2);
      x30 = XEXP (x29, 0);
      if (REGNO (x30) != 1
          || REGNO (x4) != 5
          || REGNO (x6) != 7)
        return -1;
      x31 = XEXP (x1, 0);
      operands[1] = x31;
      x32 = XEXP (x31, 0);
      operands[2] = x32;
      x33 = XEXP (x23, 0);
      operands[0] = x33;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 461; /* *p umodsi3_insn_indcall */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 1; /* nop */

    case UNSPEC:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          if (XINT (x1, 1) != 0)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], E_VOIDmode))
            return -1;
          return 2; /* nop_count */

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          switch (XINT (x1, 1))
            {
            case 11:
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              x3 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x3))
                {
                case SUBREG:
                case MEM:
                  operands[1] = x3;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_QImode:
                      if (!memory_operand (operands[1], E_QImode))
                        return -1;
                      return 21; /* real_loadqi */

                    case E_HImode:
                      if (!memory_operand (operands[1], E_HImode))
                        return -1;
                      return 22; /* real_loadhi */

                    case E_SImode:
                      if (!memory_operand (operands[1], E_SImode))
                        return -1;
                      return 23; /* real_loadsi */

                    case E_SFmode:
                      if (!memory_operand (operands[1], E_SFmode))
                        return -1;
                      return 24; /* real_loadsf */

                    case E_V2HImode:
                      if (!memory_operand (operands[1], E_V2HImode))
                        return -1;
                      return 25; /* real_loadv2hi */

                    case E_V4QImode:
                      if (!memory_operand (operands[1], E_V4QImode))
                        return -1;
                      return 26; /* real_loadv4qi */

                    case E_DImode:
                      if (!memory_operand (operands[1], E_DImode)
                          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_LDDW))
                        return -1;
                      return 27; /* real_loaddi */

                    case E_DFmode:
                      if (!memory_operand (operands[1], E_DFmode)
                          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_LDDW))
                        return -1;
                      return 28; /* real_loaddf */

                    case E_V2SImode:
                      if (!memory_operand (operands[1], E_V2SImode)
                          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_LDDW))
                        return -1;
                      return 29; /* real_loadv2si */

                    case E_V4HImode:
                      if (!memory_operand (operands[1], E_V4HImode)
                          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_LDDW))
                        return -1;
                      return 30; /* real_loadv4hi */

                    case E_V8QImode:
                      if (!memory_operand (operands[1], E_V8QImode)
                          || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_LDDW))
                        return -1;
                      return 31; /* real_loadv8qi */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern28 (x3))
                    {
                    case 0:
                      return 48; /* real_zero_extendqi */

                    case 1:
                      return 50; /* real_zero_extendhi */

                    default:
                      return -1;
                    }

                case SIGN_EXTEND:
                  switch (pattern28 (x3))
                    {
                    case 0:
                      return 49; /* real_sign_extendqi */

                    case 1:
                      return 51; /* real_sign_extendhi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 10:
              x3 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x3) != CONST_INT)
                return -1;
              switch (XWINT (x3, 0))
                {
                case 0L:
                  if (!c6x_jump_operand (operands[0], E_VOIDmode))
                    return -1;
                  return 81; /* real_jump */

                case 1L:
                  if (pnum_clobbers == NULL
                      || !c6x_call_operand (operands[0], E_VOIDmode))
                    return -1;
                  *pnum_clobbers = 1;
                  return 82; /* real_call */

                case 2L:
                  if (!register_operand (operands[0], E_VOIDmode))
                    return -1;
                  return 83; /* real_ret */

                default:
                  return -1;
                }

            case 12:
              x3 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x3))
                {
                case ROTATE:
                  if (GET_MODE (x3) != E_SImode
                      || !const_int_operand (operands[0], E_SImode))
                    return -1;
                  x4 = XEXP (x3, 0);
                  operands[1] = x4;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x5 = XEXP (x3, 1);
                  operands[2] = x5;
                  if (!reg_or_ucst5_operand (operands[2], E_SImode)
                      || !
#line 455 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                    return -1;
                  return 219; /* rotlsi3_real */

                case UNSPEC:
                  if (!const_int_operand (operands[0], E_SImode))
                    return -1;
                  switch (XVECLEN (x3, 0))
                    {
                    case 1:
                      if (XINT (x3, 1) != 7
                          || GET_MODE (x3) != E_SImode)
                        return -1;
                      x6 = XVECEXP (x3, 0, 0);
                      operands[1] = x6;
                      if (!register_operand (operands[1], E_SImode)
                          || !
#line 465 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                        return -1;
                      return 220; /* bitrevsi2_real */

                    case 2:
                      if (XINT (x3, 1) != 22)
                        return -1;
                      x6 = XVECEXP (x3, 0, 0);
                      operands[1] = x6;
                      x7 = XVECEXP (x3, 0, 1);
                      operands[2] = x7;
                      switch (GET_MODE (x3))
                        {
                        case E_V2HImode:
                          if (!register_operand (operands[1], E_V2HImode)
                              || !register_operand (operands[2], E_V2HImode)
                              || !
#line 477 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                            return -1;
                          return 221; /* avgv2hi3_real */

                        case E_V4QImode:
                          if (!register_operand (operands[1], E_V4QImode)
                              || !register_operand (operands[2], E_V4QImode)
                              || !
#line 487 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                            return -1;
                          return 222; /* uavgv4qi3_real */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case MULT:
                  x4 = XEXP (x3, 0);
                  switch (GET_CODE (x4))
                    {
                    case REG:
                    case SUBREG:
                      operands[1] = x4;
                      if (register_operand (operands[1], E_HImode)
                          && const_int_operand (operands[0], E_HImode)
                          && GET_MODE (x3) == E_HImode)
                        {
                          x5 = XEXP (x3, 1);
                          operands[2] = x5;
                          if (reg_or_scst5_operand (operands[2], E_HImode))
                            return 223; /* mulhi3_real */
                        }
                      if (!register_operand (operands[1], E_SImode)
                          || !const_int_operand (operands[0], E_SImode)
                          || GET_MODE (x3) != E_SImode)
                        return -1;
                      x5 = XEXP (x3, 1);
                      operands[2] = x5;
                      if (!register_operand (operands[2], E_SImode)
                          || !
#line 691 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                        return -1;
                      return 238; /* mulsi3_insn_real */

                    case SIGN_EXTEND:
                      x8 = XEXP (x4, 0);
                      operands[1] = x8;
                      x5 = XEXP (x3, 1);
                      switch (GET_CODE (x5))
                        {
                        case CONST_INT:
                          if (pattern53 (x3, 
E_HImode) != 0)
                            return -1;
                          return 224; /* mulhisi3_const_real */

                        case SIGN_EXTEND:
                          if (GET_MODE (x5) == E_SImode
                              && pattern60 (x3) == 0)
                            return 225; /* *mulhisi3_insn_real */
                          if (GET_MODE (x5) == E_DImode
                              && pattern54 (x3, 
E_SImode, 
E_DImode) == 0
                              && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                            return 240; /* mulsidi3_real */
                          if (GET_MODE (x5) != E_V2SImode
                              || pattern61 (x3, 
E_V2HImode, 
E_V2SImode) != 0
                              || !
#line 728 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                            return -1;
                          return 242; /* mulv2hiv2si3_real */

                        case ASHIFTRT:
                          if (pattern55 (x3) != 0)
                            return -1;
                          return 226; /* mulhisi3_lh_real */

                        default:
                          return -1;
                        }

                    case ASHIFTRT:
                      if (pattern29 (x3) != 0)
                        return -1;
                      x5 = XEXP (x3, 1);
                      switch (GET_CODE (x5))
                        {
                        case SIGN_EXTEND:
                          x9 = XEXP (x5, 0);
                          operands[2] = x9;
                          if (!register_operand (operands[2], E_HImode))
                            return -1;
                          return 227; /* mulhisi3_hl_real */

                        case ASHIFTRT:
                          x10 = XEXP (x5, 1);
                          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                            return -1;
                          x9 = XEXP (x5, 0);
                          operands[2] = x9;
                          if (!register_operand (operands[2], E_SImode))
                            return -1;
                          return 228; /* mulhisi3_hh_real */

                        default:
                          return -1;
                        }

                    case ZERO_EXTEND:
                      x8 = XEXP (x4, 0);
                      operands[1] = x8;
                      x5 = XEXP (x3, 1);
                      switch (GET_CODE (x5))
                        {
                        case ZERO_EXTEND:
                          if (GET_MODE (x5) == E_SImode
                              && pattern61 (x3, 
E_HImode, 
E_SImode) == 0)
                            return 229; /* umulhisi3_real */
                          if (GET_MODE (x5) == E_DImode
                              && pattern54 (x3, 
E_SImode, 
E_DImode) == 0
                              && 
#line 703 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                            return 239; /* umulsidi3_real */
                          if (GET_MODE (x5) != E_V4HImode
                              || pattern61 (x3, 
E_V4QImode, 
E_V4HImode) != 0
                              || !
#line 739 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                            return -1;
                          return 243; /* umulv4qiv4hi3_real */

                        case LSHIFTRT:
                          if (pattern55 (x3) != 0)
                            return -1;
                          return 230; /* umulhisi3_lh_real */

                        case CONST_INT:
                          if (pattern53 (x3, 
E_SImode) != 0)
                            return -1;
                          return 233; /* usmulhisi3_const_real */

                        case SIGN_EXTEND:
                          if (GET_MODE (x5) == E_SImode
                              && pattern60 (x3) == 0)
                            return 234; /* *usmulhisi3_insn_real */
                          if (GET_MODE (x5) == E_DImode
                              && pattern54 (x3, 
E_SImode, 
E_DImode) == 0
                              && 
#line 715 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                            return 241; /* usmulsidi3_real */
                          if (GET_MODE (x5) != E_V4HImode
                              || pattern61 (x3, 
E_V4QImode, 
E_V4HImode) != 0
                              || !
#line 750 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                            return -1;
                          return 244; /* usmulv4qiv4hi3_real */

                        case ASHIFTRT:
                          if (pattern55 (x3) != 0)
                            return -1;
                          return 235; /* usmulhisi3_lh_real */

                        default:
                          return -1;
                        }

                    case LSHIFTRT:
                      if (pattern29 (x3) != 0)
                        return -1;
                      x5 = XEXP (x3, 1);
                      switch (GET_CODE (x5))
                        {
                        case ZERO_EXTEND:
                          x9 = XEXP (x5, 0);
                          operands[2] = x9;
                          if (!register_operand (operands[2], E_HImode))
                            return -1;
                          return 231; /* umulhisi3_hl_real */

                        case LSHIFTRT:
                          x10 = XEXP (x5, 1);
                          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                            return -1;
                          x9 = XEXP (x5, 0);
                          operands[2] = x9;
                          if (!register_operand (operands[2], E_SImode))
                            return -1;
                          return 232; /* umulhisi3_hh_real */

                        case SIGN_EXTEND:
                          x9 = XEXP (x5, 0);
                          operands[2] = x9;
                          if (!register_operand (operands[2], E_HImode))
                            return -1;
                          return 236; /* usmulhisi3_hl_real */

                        case ASHIFTRT:
                          x10 = XEXP (x5, 1);
                          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                            return -1;
                          x9 = XEXP (x5, 0);
                          operands[2] = x9;
                          if (!register_operand (operands[2], E_SImode))
                            return -1;
                          return 237; /* usmulhisi3_hh_real */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case PLUS:
                  if (GET_MODE (x3) != E_SImode)
                    return -1;
                  x4 = XEXP (x3, 0);
                  if (GET_CODE (x4) != MULT
                      || GET_MODE (x4) != E_SImode)
                    return -1;
                  x8 = XEXP (x4, 0);
                  if (GET_CODE (x8) != SIGN_EXTEND
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x11 = XEXP (x8, 0);
                  if (GET_CODE (x11) != VEC_SELECT
                      || GET_MODE (x11) != E_HImode)
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (GET_CODE (x12) != PARALLEL
                      || XVECLEN (x12, 0) != 1)
                    return -1;
                  x13 = XVECEXP (x12, 0, 0);
                  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x14 = XEXP (x4, 1);
                  if (GET_CODE (x14) != SIGN_EXTEND
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x15 = XEXP (x14, 0);
                  if (GET_CODE (x15) != VEC_SELECT
                      || GET_MODE (x15) != E_HImode)
                    return -1;
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != PARALLEL
                      || XVECLEN (x16, 0) != 1)
                    return -1;
                  x17 = XVECEXP (x16, 0, 0);
                  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x5 = XEXP (x3, 1);
                  if (GET_CODE (x5) != MULT
                      || GET_MODE (x5) != E_SImode)
                    return -1;
                  x9 = XEXP (x5, 0);
                  if (GET_CODE (x9) != SIGN_EXTEND
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x18 = XEXP (x9, 0);
                  if (GET_CODE (x18) != VEC_SELECT
                      || GET_MODE (x18) != E_HImode)
                    return -1;
                  x19 = XEXP (x18, 1);
                  if (GET_CODE (x19) != PARALLEL
                      || XVECLEN (x19, 0) != 1)
                    return -1;
                  x20 = XVECEXP (x19, 0, 0);
                  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return -1;
                  x10 = XEXP (x5, 1);
                  if (GET_CODE (x10) != SIGN_EXTEND
                      || GET_MODE (x10) != E_SImode)
                    return -1;
                  x21 = XEXP (x10, 0);
                  if (GET_CODE (x21) != VEC_SELECT
                      || GET_MODE (x21) != E_HImode)
                    return -1;
                  x22 = XEXP (x21, 1);
                  if (GET_CODE (x22) != PARALLEL
                      || XVECLEN (x22, 0) != 1)
                    return -1;
                  x23 = XVECEXP (x22, 0, 0);
                  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                      || !const_int_operand (operands[0], E_SImode))
                    return -1;
                  x24 = XEXP (x11, 0);
                  operands[1] = x24;
                  if (!register_operand (operands[1], E_V2HImode))
                    return -1;
                  x25 = XEXP (x15, 0);
                  operands[2] = x25;
                  if (!register_operand (operands[2], E_V2HImode))
                    return -1;
                  x26 = XEXP (x18, 0);
                  if (!rtx_equal_p (x26, operands[1]))
                    return -1;
                  x27 = XEXP (x21, 0);
                  if (!rtx_equal_p (x27, operands[2])
                      || !
#line 773 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                    return -1;
                  return 245; /* dotv2hi_real */

                case SS_MULT:
                  x4 = XEXP (x3, 0);
                  if (GET_CODE (x4) != FRACT_CONVERT)
                    return -1;
                  x5 = XEXP (x3, 1);
                  if (GET_CODE (x5) != FRACT_CONVERT
                      || !const_int_operand (operands[0], E_SImode))
                    return -1;
                  x8 = XEXP (x4, 0);
                  switch (GET_CODE (x8))
                    {
                    case REG:
                    case SUBREG:
                      operands[1] = x8;
                      x9 = XEXP (x5, 0);
                      switch (GET_CODE (x9))
                        {
                        case REG:
                        case SUBREG:
                          operands[2] = x9;
                          switch (GET_MODE (x3))
                            {
                            case E_V2SQmode:
                              if (pattern79 (x3, 
E_V2HQmode, 
E_V2SQmode) != 0)
                                return -1;
                              return 246; /* mulv2hqv2sq3_real */

                            case E_SQmode:
                              if (pattern79 (x3, 
E_HQmode, 
E_SQmode) != 0)
                                return -1;
                              return 247; /* mulhqsq3_real */

                            default:
                              return -1;
                            }

                        case TRUNCATE:
                          if (GET_MODE (x9) != E_HQmode
                              || GET_MODE (x3) != E_SQmode
                              || GET_MODE (x4) != E_SQmode
                              || !register_operand (operands[1], E_HQmode)
                              || GET_MODE (x5) != E_SQmode)
                            return -1;
                          x18 = XEXP (x9, 0);
                          operands[2] = x18;
                          if (!register_operand (operands[2], E_SQmode))
                            return -1;
                          return 248; /* mulhqsq3_lh_real */

                        default:
                          return -1;
                        }

                    case TRUNCATE:
                      if (GET_MODE (x8) != E_HQmode
                          || GET_MODE (x3) != E_SQmode
                          || GET_MODE (x4) != E_SQmode)
                        return -1;
                      x11 = XEXP (x8, 0);
                      operands[1] = x11;
                      if (!register_operand (operands[1], E_SQmode)
                          || GET_MODE (x5) != E_SQmode)
                        return -1;
                      x9 = XEXP (x5, 0);
                      switch (GET_CODE (x9))
                        {
                        case REG:
                        case SUBREG:
                          operands[2] = x9;
                          if (!register_operand (operands[2], E_HQmode))
                            return -1;
                          return 249; /* mulhqsq3_hl_real */

                        case TRUNCATE:
                          if (GET_MODE (x9) != E_HQmode)
                            return -1;
                          x18 = XEXP (x9, 0);
                          operands[2] = x18;
                          if (!register_operand (operands[2], E_SQmode))
                            return -1;
                          return 250; /* mulhqsq3_hh_real */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      return recog_24 (x1, insn, pnum_clobbers);

    case PARALLEL:
      return recog_25 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 3:
              if (pnum_clobbers == NULL)
                return -1;
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 1;
              return 76; /* eh_return */

            case 0:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 156; /* blockage */

            default:
              return -1;
            }

        case 2:
          if (XINT (x1, 1) != 1)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 66
              || GET_MODE (x3) != E_SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], E_SImode)
              || !
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS))
            return -1;
          return 78; /* sploop */

        default:
          return -1;
        }

    case CALL:
      x28 = XEXP (x1, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x29 = XEXP (x1, 0);
      switch (GET_CODE (x29))
        {
        case UNSPEC:
          if (XVECLEN (x29, 0) != 1
              || XINT (x29, 1) != 13)
            return -1;
          x30 = XVECEXP (x29, 0, 0);
          if (GET_CODE (x30) == PC)
            {
              if (
#line 1581 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(SIBLING_CALL_P (insn)))
                return 86; /* indirect_sibcall_shadow */
              return 87; /* indirect_call_shadow */
            }
          operands[0] = x30;
          if (
#line 1603 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!SIBLING_CALL_P (insn)))
            return 89; /* call_shadow */
          if (!
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 90; /* sibcall_shadow */

        case MEM:
          x31 = XEXP (x29, 0);
          operands[0] = x31;
          if (!c6x_call_operand (operands[0], E_SImode))
            return -1;
          if (
#line 2023 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!SIBLING_CALL_P (insn)))
            return 117; /* call_internal */
          if (!
#line 2046 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 119; /* sibcall_internal */

        default:
          return -1;
        }

    case COND_EXEC:
      return recog_26 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}
