/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 17
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != MINUS
      || GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!memory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  return pattern38 (x6); /* [-1, 2] */
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern37 (x6, 
E_HImode); /* [-1, 0] */

    case E_V2HImode:
      if (pattern37 (x6, 
E_V2HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 47
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!memory_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!memory_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V2HImode:
      if (!memory_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!memory_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!scst5_operand (operands[2], i1)
      || !const_int_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern89 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern97 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 11);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern104 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != 6
      || pattern103 (x1, 
36, 
35, 
34, 
33, 
32) != 0)
    return -1;
  return 0;
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 47
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + -40])
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 8:
          if (pattern24 (x2) != 0
              || !
#line 434 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(flag_pic == 2))
            return -1;
          return 7; /* load_got_gotoff */

        case 19:
          if (pattern25 (x2) != 0)
            return -1;
          return 53; /* extr */

        case 20:
          if (pattern25 (x2) != 0)
            return -1;
          return 54; /* extru */

        case 21:
          if (pattern24 (x2) != 0)
            return -1;
          return 116; /* subcsi3 */

        case 4:
          if (GET_MODE (x2) != E_SImode
              || !pic_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 1);
          operands[1] = x4;
          if (!symbolic_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          if (!rtx_equal_p (x5, operands[0])
              || !
#line 2937 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_DSBT))
            return -1;
          return 159; /* setup_dsbt */

        case 22:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x4 = XVECEXP (x2, 0, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HImode:
              if (pattern56 (x2, 
E_V2HImode) != 0
                  || !
#line 56 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                return -1;
              return 189; /* avgv2hi3 */

            case E_V4QImode:
              if (pattern56 (x2, 
E_V4QImode) != 0
                  || !
#line 66 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                return -1;
              return 190; /* uavgv4qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (XINT (x2, 1))
        {
        case 14:
          x5 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x5) != PC)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          return 32; /* load_shadow */

        case 15:
          x5 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x5) != PC)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          return 33; /* mult_shadow */

        case 2:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pnum_clobbers != NULL
                  && memory_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && register_operand (operands[1], E_SImode)
                  && 
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                {
                  *pnum_clobbers = 1;
                  return 34; /* movmisalignsi_store */
                }
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !memory_operand (operands[1], E_SImode)
                  || !
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 38; /* movmisalignsi_load */

            case E_DImode:
              if (pnum_clobbers != NULL
                  && memory_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && register_operand (operands[1], E_DImode)
                  && 
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                {
                  *pnum_clobbers = 1;
                  return 35; /* movmisaligndi_store */
                }
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !memory_operand (operands[1], E_DImode)
                  || !
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 39; /* movmisaligndi_load */

            case E_V2HImode:
              if (pnum_clobbers != NULL
                  && memory_operand (operands[0], E_V2HImode)
                  && GET_MODE (x2) == E_V2HImode
                  && register_operand (operands[1], E_V2HImode)
                  && 
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                {
                  *pnum_clobbers = 1;
                  return 36; /* movmisalignv2hi_store */
                }
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x2) != E_V2HImode
                  || !memory_operand (operands[1], E_V2HImode)
                  || !
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 40; /* movmisalignv2hi_load */

            case E_V4QImode:
              if (pnum_clobbers != NULL
                  && memory_operand (operands[0], E_V4QImode)
                  && GET_MODE (x2) == E_V4QImode
                  && register_operand (operands[1], E_V4QImode)
                  && 
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                {
                  *pnum_clobbers = 1;
                  return 37; /* movmisalignv4qi_store */
                }
              if (!register_operand (operands[0], E_V4QImode)
                  || GET_MODE (x2) != E_V4QImode
                  || !memory_operand (operands[1], E_V4QImode)
                  || !
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 41; /* movmisalignv4qi_load */

            default:
              return -1;
            }

        case 9:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 66
              || GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS))
            return -1;
          return 77; /* mvilc */

        case 13:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return 84; /* indirect_jump_shadow */
          operands[0] = x5;
          return 91; /* jump_shadow */

        case 1:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || GET_MODE (x2) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !
#line 2783 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
                return -1;
              return 154; /* rcpsf2 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 2792 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
                return -1;
              return 155; /* rcpdf2 */

            default:
              return -1;
            }

        case 16:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 160; /* epilogue_barrier */

        case 7:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 44 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
            return -1;
          return 188; /* bitrevsi2 */

        case 17:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!memory_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          if (GET_MODE (x5) != E_SImode)
            return -1;
          switch (GET_CODE (x5))
            {
            case PLUS:
              x6 = XEXP (x5, 1);
              operands[1] = x6;
              if (!reg_or_scst5_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[0]))
                return -1;
              *pnum_clobbers = 1;
              return 252; /* sync_addsi_insn */

            case MINUS:
              x6 = XEXP (x5, 1);
              operands[1] = x6;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[0]))
                return -1;
              *pnum_clobbers = 1;
              return 253; /* sync_subsi_insn */

            case IOR:
              x6 = XEXP (x5, 1);
              operands[1] = x6;
              if (!reg_or_scst5_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[0]))
                return -1;
              *pnum_clobbers = 1;
              return 254; /* sync_iorsi_insn */

            case XOR:
              x6 = XEXP (x5, 1);
              operands[1] = x6;
              if (!reg_or_scst5_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[0]))
                return -1;
              *pnum_clobbers = 1;
              return 255; /* sync_xorsi_insn */

            case AND:
              x6 = XEXP (x5, 1);
              operands[1] = x6;
              if (!reg_or_scst5_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[0]))
                return -1;
              *pnum_clobbers = 1;
              return 256; /* sync_andsi_insn */

            case NOT:
              x7 = XEXP (x5, 0);
              if (GET_CODE (x7) != AND
                  || GET_MODE (x7) != E_SImode)
                return -1;
              x8 = XEXP (x7, 1);
              operands[1] = x8;
              if (!reg_or_scst5_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x7, 0);
              if (!rtx_equal_p (x9, operands[0]))
                return -1;
              *pnum_clobbers = 1;
              return 267; /* sync_nandsi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x2, 1) != 18
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x10 = XVECEXP (x2, 0, 2);
      operands[3] = x10;
      if (!reg_or_const_int_operand (operands[3], E_SImode))
        return -1;
      return 52; /* clrr */

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          switch (GET_CODE (operands[1]))
            {
            case CONST_INT:
              if (const_int_operand (operands[1], E_SImode)
                  && register_operand (operands[0], E_SImode)
                  && 
#line 456 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed
   && !satisfies_constraint_IsB (operands[1])))
                return gen_split_1 (insn, operands);
              break;

            case CONST_VECTOR:
              switch (GET_MODE (operands[0]))
                {
                case E_V2HImode:
                  if (register_operand (operands[0], E_V2HImode)
                      && const_vector_operand (operands[1], E_V2HImode)
                      && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
                    return gen_split_2 (insn, operands);
                  break;

                case E_V4QImode:
                  if (register_operand (operands[0], E_V4QImode)
                      && const_vector_operand (operands[1], E_V4QImode)
                      && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
                    return gen_split_3 (insn, operands);
                  break;

                case E_V2SImode:
                  if (register_operand (operands[0], E_V2SImode)
                      && const_vector_operand (operands[1], E_V2SImode)
                      && 
#line 503 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
                    return gen_split_4 (insn, operands);
                  break;

                case E_V4HImode:
                  if (register_operand (operands[0], E_V4HImode)
                      && const_vector_operand (operands[1], E_V4HImode)
                      && 
#line 503 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
                    return gen_split_5 (insn, operands);
                  break;

                case E_V8QImode:
                  if (register_operand (operands[0], E_V8QImode)
                      && const_vector_operand (operands[1], E_V8QImode)
                      && 
#line 503 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
                    return gen_split_6 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
              if (symbolic_operand (operands[1], E_SImode)
                  && register_operand (operands[0], E_SImode)
                  && 
#line 572 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed
   && (!TARGET_INSNS_64PLUS
       || !sdata_symbolic_operand (operands[1], SImode))))
                return gen_split_8 (insn, operands);
              break;

            default:
              break;
            }
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !immediate_operand (operands[1], E_SFmode)
                  || !
#line 548 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
                return NULL;
              return gen_split_7 (insn, operands);

            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !general_operand (operands[1], E_DImode)
                  || !
#line 691 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed
   && !((MEM_P (operands[0]) && TARGET_STDW)
 	|| (MEM_P (operands[1]) && TARGET_LDDW))
   && !const_vector_operand (operands[1], DImode)
   && !(TARGET_INSNS_64PLUS && REG_P (operands[0]) && REG_P (operands[1])
	&& A_REGNO_P (REGNO (operands[0])) == A_REGNO_P (REGNO (operands[1])))))
                return NULL;
              return gen_split_9 (insn, operands);

            case E_DFmode:
              if (!nonimmediate_operand (operands[0], E_DFmode)
                  || !general_operand (operands[1], E_DFmode)
                  || !
#line 691 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed
   && !((MEM_P (operands[0]) && TARGET_STDW)
 	|| (MEM_P (operands[1]) && TARGET_LDDW))
   && !const_vector_operand (operands[1], DFmode)
   && !(TARGET_INSNS_64PLUS && REG_P (operands[0]) && REG_P (operands[1])
	&& A_REGNO_P (REGNO (operands[0])) == A_REGNO_P (REGNO (operands[1])))))
                return NULL;
              return gen_split_10 (insn, operands);

            case E_V2SImode:
              if (!nonimmediate_operand (operands[0], E_V2SImode)
                  || !general_operand (operands[1], E_V2SImode)
                  || !
#line 691 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed
   && !((MEM_P (operands[0]) && TARGET_STDW)
 	|| (MEM_P (operands[1]) && TARGET_LDDW))
   && !const_vector_operand (operands[1], V2SImode)
   && !(TARGET_INSNS_64PLUS && REG_P (operands[0]) && REG_P (operands[1])
	&& A_REGNO_P (REGNO (operands[0])) == A_REGNO_P (REGNO (operands[1])))))
                return NULL;
              return gen_split_11 (insn, operands);

            case E_V4HImode:
              if (!nonimmediate_operand (operands[0], E_V4HImode)
                  || !general_operand (operands[1], E_V4HImode)
                  || !
#line 691 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed
   && !((MEM_P (operands[0]) && TARGET_STDW)
 	|| (MEM_P (operands[1]) && TARGET_LDDW))
   && !const_vector_operand (operands[1], V4HImode)
   && !(TARGET_INSNS_64PLUS && REG_P (operands[0]) && REG_P (operands[1])
	&& A_REGNO_P (REGNO (operands[0])) == A_REGNO_P (REGNO (operands[1])))))
                return NULL;
              return gen_split_12 (insn, operands);

            case E_V8QImode:
              if (!nonimmediate_operand (operands[0], E_V8QImode)
                  || !general_operand (operands[1], E_V8QImode)
                  || !
#line 691 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed
   && !((MEM_P (operands[0]) && TARGET_STDW)
 	|| (MEM_P (operands[1]) && TARGET_LDDW))
   && !const_vector_operand (operands[1], V8QImode)
   && !(TARGET_INSNS_64PLUS && REG_P (operands[0]) && REG_P (operands[1])
	&& A_REGNO_P (REGNO (operands[0])) == A_REGNO_P (REGNO (operands[1])))))
                return NULL;
              return gen_split_13 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 2)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !memory_operand (operands[1], E_SImode)
                  || !(
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[1]))))
                return NULL;
              return gen_split_18 (insn, operands);

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !memory_operand (operands[1], E_DImode)
                  || !(
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[1]))))
                return NULL;
              return gen_split_19 (insn, operands);

            case E_V2HImode:
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x3) != E_V2HImode
                  || !memory_operand (operands[1], E_V2HImode)
                  || !(
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[1]))))
                return NULL;
              return gen_split_20 (insn, operands);

            case E_V4QImode:
              if (!register_operand (operands[0], E_V4QImode)
                  || GET_MODE (x3) != E_V4QImode
                  || !memory_operand (operands[1], E_V4QImode)
                  || !(
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[1]))))
                return NULL;
              return gen_split_21 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          if (pattern14 (x3) != 0
              || !
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!reg_overlap_mentioned_p (operands[0], operands[2])))
            return NULL;
          return gen_split_22 (insn, operands);

        case AND:
          if (pattern14 (x3) != 0
              || !
#line 1203 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(!reg_overlap_mentioned_p (operands[0], operands[2])))
            return NULL;
          return gen_split_23 (insn, operands);

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return NULL;
          x6 = XEXP (x5, 0);
          if (!scratch_operand (x6, E_SImode))
            return NULL;
          x7 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x7))
            {
            case SET:
              x8 = XEXP (x7, 1);
              if (GET_CODE (x8) != UNSPEC
                  || XVECLEN (x8, 0) != 1
                  || XINT (x8, 1) != 2)
                return NULL;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              x10 = XVECEXP (x8, 0, 0);
              operands[1] = x10;
              operands[2] = x6;
              switch (pattern70 (x8))
                {
                case 0:
                  if (!(
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 797 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[0]))))
                    return NULL;
                  return gen_split_14 (insn, operands);

                case 1:
                  if (!(
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 797 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[0]))))
                    return NULL;
                  return gen_split_15 (insn, operands);

                case 2:
                  if (!(
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 797 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[0]))))
                    return NULL;
                  return gen_split_16 (insn, operands);

                case 3:
                  if (!(
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 797 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[0]))))
                    return NULL;
                  return gen_split_17 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x7, 0) != 1
                  || XINT (x7, 1) != 3)
                return NULL;
              x11 = XVECEXP (x7, 0, 0);
              operands[0] = x11;
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              operands[1] = x6;
              if (!
#line 1410 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed))
                return NULL;
              return gen_split_24 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          x7 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x7) != SET)
            return NULL;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != IF_THEN_ELSE
              || pattern18 (x1) != 0)
            return NULL;
          x12 = XEXP (x8, 0);
          x13 = XEXP (x12, 0);
          operands[3] = x13;
          if (!nonimmediate_operand (operands[3], E_SImode))
            return NULL;
          x14 = XEXP (x8, 1);
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          x5 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x5, 0);
          operands[0] = x6;
          if (!memory_operand (operands[0], E_SImode))
            return NULL;
          x16 = XVECEXP (x1, 0, 2);
          x17 = XEXP (x16, 0);
          operands[2] = x17;
          if (!scratch_operand (operands[2], E_VOIDmode))
            return NULL;
          x18 = XEXP (x5, 1);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[3]))
            return NULL;
          return gen_split_25 (insn, operands);

        case 16:
          switch (pattern12 (x1))
            {
            case 0:
              return gen_split_26 (insn, operands);

            case 1:
              return gen_split_27 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COND_EXEC:
      x2 = XEXP (x1, 0);
      if (!eqne_operator (x2, E_VOIDmode))
        return NULL;
      x20 = XEXP (x2, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x21 = XEXP (x2, 0);
      if (!predicate_register (x21, E_VOIDmode))
        return NULL;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case PARALLEL:
          switch (XVECLEN (x3, 0))
            {
            case 2:
              x22 = XVECEXP (x3, 0, 1);
              if (GET_CODE (x22) != CLOBBER)
                return NULL;
              x23 = XEXP (x22, 0);
              if (!scratch_operand (x23, E_SImode))
                return NULL;
              x4 = XVECEXP (x3, 0, 0);
              switch (GET_CODE (x4))
                {
                case SET:
                  x24 = XEXP (x4, 1);
                  if (GET_CODE (x24) != UNSPEC
                      || XVECLEN (x24, 0) != 1
                      || XINT (x24, 1) != 2)
                    return NULL;
                  operands[3] = x2;
                  operands[4] = x21;
                  x25 = XEXP (x4, 0);
                  operands[0] = x25;
                  x26 = XVECEXP (x24, 0, 0);
                  operands[1] = x26;
                  operands[2] = x23;
                  switch (pattern91 (x24))
                    {
                    case 0:
                      if (!(
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 797 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[0]))))
                        return NULL;
                      return gen_split_28 (insn, operands);

                    case 1:
                      if (!(
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 797 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[0]))))
                        return NULL;
                      return gen_split_29 (insn, operands);

                    case 2:
                      if (!(
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 797 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[0]))))
                        return NULL;
                      return gen_split_30 (insn, operands);

                    case 3:
                      if (!(
#line 790 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 797 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[0]))))
                        return NULL;
                      return gen_split_31 (insn, operands);

                    default:
                      return NULL;
                    }

                case UNSPEC_VOLATILE:
                  if (XVECLEN (x4, 0) != 1
                      || XINT (x4, 1) != 3)
                    return NULL;
                  operands[2] = x2;
                  operands[3] = x21;
                  x27 = XVECEXP (x4, 0, 0);
                  operands[0] = x27;
                  if (!register_operand (operands[0], E_SImode))
                    return NULL;
                  operands[1] = x23;
                  if (!
#line 1410 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed))
                    return NULL;
                  return gen_split_36 (insn, operands);

                default:
                  return NULL;
                }

            case 16:
              switch (pattern48 (x1))
                {
                case 0:
                  return gen_split_37 (insn, operands);

                case 1:
                  return gen_split_38 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SET:
          x28 = XEXP (x3, 1);
          if (GET_CODE (x28) != UNSPEC
              || XVECLEN (x28, 0) != 1
              || XINT (x28, 1) != 2)
            return NULL;
          switch (pattern59 (x1))
            {
            case 0:
              if (!(
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[1]))))
                return NULL;
              return gen_split_32 (insn, operands);

            case 1:
              if (!(
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[1]))))
                return NULL;
              return gen_split_33 (insn, operands);

            case 2:
              if (!(
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[1]))))
                return NULL;
              return gen_split_34 (insn, operands);

            case 3:
              if (!(
#line 830 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
( reload_completed && satisfies_constraint_W (operands[1]))))
                return NULL;
              return gen_split_35 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
