/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 4
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 4
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  return 0;
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !reg_or_scst5_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (pattern37 (x1, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern37 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4)
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3)
    return -1;
  x8 = XVECEXP (x1, 0, 12);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 13);
  x11 = XEXP (x10, 0);
  if (REGNO (x11) != i1)
    return -1;
  x12 = XVECEXP (x1, 0, 0);
  x13 = XEXP (x12, 1);
  x14 = XEXP (x13, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x13, 1);
  operands[2] = x15;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x16 = XVECEXP (x1, 0, 1);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 0);
  if (!rtx_equal_p (x18, operands[1]))
    return -1;
  x19 = XEXP (x17, 1);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!memory_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_CODE (x5))
    {
    case UNSPEC_VOLATILE:
      if (XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 4)
        return -1;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x5, 0, 1);
      operands[3] = x8;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 17)
        return -1;
      x7 = XVECEXP (x5, 0, 0);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!scst5_operand (operands[2], i1)
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!memory_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!memory_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V2HImode:
      if (!memory_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 2;

    case E_V4QImode:
      if (!memory_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 5
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != USE)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case HIGH:
      if (GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              switch (GET_CODE (x4))
                {
                case CONST_INT:
                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                  operands[1] = x4;
                  if (const_int_or_symbolic_operand (operands[1], E_SImode)
                      && 
#line 406 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(reload_completed))
                    return 4; /* movsi_high */
                  break;

                case UNSPEC:
                  if (XVECLEN (x4, 0) == 1
                      && XINT (x4, 1) == 8
                      && GET_MODE (x4) == E_SImode)
                    {
                      x5 = XVECEXP (x4, 0, 0);
                      operands[1] = x5;
                      if (symbolic_operand (operands[1], E_SImode)
                          && 
#line 423 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(flag_pic == 2))
                        return 6; /* movsi_gotoff_high */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      break;

    case REG:
    case SUBREG:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case PC:
          operands[0] = x2;
          if (register_operand (operands[0], E_SImode))
            return 70; /* indirect_jump */
          break;

        case STRICT_LOW_PART:
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (register_operand (operands[0], E_HImode))
            {
              operands[1] = x2;
              if (register_operand (operands[1], E_HImode)
                  && 
#line 3130 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return 186; /* movstricthi */
            }
          break;

        default:
          break;
        }
      break;

    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 71; /* jump */
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x7 = XEXP (x3, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x8 = XEXP (x3, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode)
      || !
#line 3117 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
    return -1;
  return 185; /* *packv2hi_insv */
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern37 (x6, 
E_SFmode) != 0
              || !
#line 2737 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 466; /* *p mulsf3 */

        case E_DFmode:
          if (pattern37 (x6, 
E_DFmode) != 0
              || !
#line 2747 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
            return -1;
          return 467; /* *p muldf3 */

        case E_HImode:
          if (pattern74 (x6, 
E_HImode) != 0)
            return -1;
          return 507; /* *p mulhi3 */

        case E_SImode:
          if (pattern37 (x6, 
E_SImode) != 0
              || !
#line 270 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
            return -1;
          return 522; /* *p mulsi3_insn */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x7) != E_DFmode
          || !register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      x8 = XEXP (x6, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[2] = x8;
          if (!register_operand (operands[2], E_DFmode)
              || !
#line 2759 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP_EXT))
            return -1;
          return 468; /* *p *muldf_ext1 */

        case FLOAT_EXTEND:
          if (GET_MODE (x8) != E_DFmode)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SFmode)
              || !
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP_EXT))
            return -1;
          return 469; /* *p *muldf_ext2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      x8 = XEXP (x6, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          if (pattern76 (x6, 
E_HImode) != 0)
            return -1;
          return 508; /* *p mulhisi3_const */

        case SIGN_EXTEND:
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern86 (x6) != 0)
                return -1;
              return 509; /* *p *mulhisi3_insn */

            case E_DImode:
              if (pattern87 (x6, 
E_SImode, 
E_DImode) != 0
                  || !
#line 282 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                return -1;
              return 524; /* *p mulsidi3 */

            case E_V2SImode:
              if (pattern87 (x6, 
E_V2HImode, 
E_V2SImode) != 0
                  || !
#line 307 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                return -1;
              return 526; /* *p mulv2hiv2si3 */

            default:
              return -1;
            }

        case ASHIFTRT:
          if (pattern77 (x6) != 0)
            return -1;
          return 510; /* *p mulhisi3_lh */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern68 (x6) != 0)
        return -1;
      x8 = XEXP (x6, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 511; /* *p mulhisi3_hl */

        case ASHIFTRT:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 512; /* *p mulhisi3_hh */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      x8 = XEXP (x6, 1);
      switch (GET_CODE (x8))
        {
        case ZERO_EXTEND:
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern87 (x6, 
E_HImode, 
E_SImode) != 0)
                return -1;
              return 513; /* *p umulhisi3 */

            case E_DImode:
              if (pattern87 (x6, 
E_SImode, 
E_DImode) != 0
                  || !
#line 282 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                return -1;
              return 523; /* *p umulsidi3 */

            case E_V4HImode:
              if (pattern87 (x6, 
E_V4QImode, 
E_V4HImode) != 0
                  || !
#line 318 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                return -1;
              return 527; /* *p umulv4qiv4hi3 */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (pattern77 (x6) != 0)
            return -1;
          return 514; /* *p umulhisi3_lh */

        case CONST_INT:
          if (pattern76 (x6, 
E_SImode) != 0)
            return -1;
          return 517; /* *p usmulhisi3_const */

        case SIGN_EXTEND:
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern86 (x6) != 0)
                return -1;
              return 518; /* *p *usmulhisi3_insn */

            case E_DImode:
              if (pattern87 (x6, 
E_SImode, 
E_DImode) != 0
                  || !
#line 294 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_MPY32))
                return -1;
              return 525; /* *p usmulsidi3 */

            case E_V4HImode:
              if (pattern87 (x6, 
E_V4QImode, 
E_V4HImode) != 0
                  || !
#line 329 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
                return -1;
              return 528; /* *p usmulv4qiv4hi3 */

            default:
              return -1;
            }

        case ASHIFTRT:
          if (pattern77 (x6) != 0)
            return -1;
          return 519; /* *p usmulhisi3_lh */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pattern68 (x6) != 0)
        return -1;
      x8 = XEXP (x6, 1);
      switch (GET_CODE (x8))
        {
        case ZERO_EXTEND:
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 515; /* *p umulhisi3_hl */

        case LSHIFTRT:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 516; /* *p umulhisi3_hh */

        case SIGN_EXTEND:
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 520; /* *p usmulhisi3_hl */

        case ASHIFTRT:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 521; /* *p usmulhisi3_hh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      return recog_11 (x1, insn, pnum_clobbers);

    case 3:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
        case MEM:
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XEXP (x4, 0);
          if (!scratch_operand (x5, E_SImode))
            return -1;
          operands[3] = x5;
          res = recog_9 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          switch (pattern63 (x1))
            {
            case 0:
              operands[4] = x5;
              return 251; /* *sync_compare_and_swapsi */

            case 1:
              operands[3] = x5;
              x8 = XEXP (x6, 1);
              x9 = XVECEXP (x8, 0, 0);
              switch (pattern90 (x9))
                {
                case 0:
                  return 257; /* sync_old_addsi_insn */

                case 1:
                  return 258; /* sync_old_subsi_insn */

                case 2:
                  return 259; /* sync_old_iorsi_insn */

                case 3:
                  return 260; /* sync_old_xorsi_insn */

                case 4:
                  return 261; /* sync_old_andsi_insn */

                case 5:
                  return 268; /* sync_old_nandsi_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          if (pattern18 (x1) != 0)
            return -1;
          x10 = XEXP (x3, 0);
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (!nonimmediate_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x3, 1);
          x13 = XEXP (x12, 0);
          operands[1] = x13;
          x6 = XVECEXP (x1, 0, 1);
          x14 = XEXP (x6, 0);
          operands[0] = x14;
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 2);
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (!scratch_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          x15 = XEXP (x8, 0);
          if (!rtx_equal_p (x15, operands[3])
              || !
#line 1488 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS && optimize))
            return -1;
          return 80; /* loop_end */

        case DIV:
          if (pattern19 (x1, pnum_clobbers, 
MOD) != 0)
            return -1;
          *pnum_clobbers = 11;
          return 143; /* divmodsi4_insn_indcall */

        case UDIV:
          if (pattern19 (x1, pnum_clobbers, 
UMOD) != 0)
            return -1;
          *pnum_clobbers = 11;
          return 147; /* udivmodsi4_insn_indcall */

        case PLUS:
          if (pattern21 (x1, 
PLUS) != 0)
            return -1;
          return 262; /* sync_new_addsi_insn */

        case MINUS:
          if (pattern22 (x1) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x10 = XEXP (x3, 0);
          operands[1] = x10;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x3, 1);
          operands[2] = x12;
          if (!register_operand (operands[2], E_SImode)
              || pattern20 (x1) != 0)
            return -1;
          return 263; /* sync_new_subsi_insn */

        case IOR:
          if (pattern21 (x1, 
IOR) != 0)
            return -1;
          return 264; /* sync_new_iorsi_insn */

        case XOR:
          if (pattern21 (x1, 
XOR) != 0)
            return -1;
          return 265; /* sync_new_xorsi_insn */

        case AND:
          if (pattern21 (x1, 
AND) != 0)
            return -1;
          return 266; /* sync_new_andsi_insn */

        case NOT:
          if (pattern23 (x1) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x10 = XEXP (x3, 0);
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x16 = XEXP (x10, 1);
          operands[2] = x16;
          if (!reg_or_scst5_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x8 = XEXP (x6, 1);
          x9 = XVECEXP (x8, 0, 0);
          x17 = XEXP (x9, 0);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          x19 = XEXP (x17, 1);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          x14 = XEXP (x6, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          return 269; /* sync_new_nandsi_insn */

        default:
          return -1;
        }

    case 13:
      if (pattern10 (x1) != 0
          || pattern34 (x1) != 0)
        return -1;
      x20 = XVECEXP (x1, 0, 11);
      x21 = XEXP (x20, 0);
      if (REGNO (x21) != 62
          || pattern97 (x1, 
63) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_CODE (x3))
        {
        case DIV:
          if (pattern101 (x1, 
2, 
1, 
0) != 0)
            return -1;
          x22 = XVECEXP (x1, 0, 5);
          x23 = XEXP (x22, 0);
          if (REGNO (x23) != 32
              || pattern103 (x1, 
37, 
36, 
35, 
34, 
33) != 0)
            return -1;
          return 136; /* divsi3_insn */

        case UDIV:
          if (pattern27 (x3) != 0
              || pattern104 (x1, 
2, 
1, 
0) != 0)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          switch (pattern50 (x6, 
UMOD))
            {
            case 0:
              return 139; /* udivsi3_insn_indcall */

            case 1:
              return 146; /* udivmodsi4_insn */

            default:
              return -1;
            }

        case MOD:
          if (pattern27 (x3) != 0)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE
              || pattern104 (x1, 
5, 
2, 
1) != 0)
            return -1;
          x14 = XEXP (x6, 0);
          operands[0] = x14;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          return 141; /* modsi3_insn_indcall */

        default:
          return -1;
        }

    case 14:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 4
          || GET_MODE (x7) != E_SImode
          || pattern34 (x1) != 0
          || pattern97 (x1, 
62) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x24) != CLOBBER)
        return -1;
      x25 = XEXP (x24, 0);
      if (GET_CODE (x25) != REG
          || REGNO (x25) != 63
          || GET_MODE (x25) != E_SImode)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_CODE (x3))
        {
        case DIV:
          if (pattern27 (x3) != 0)
            return -1;
          x26 = XVECEXP (x1, 0, 3);
          x27 = XEXP (x26, 0);
          if (REGNO (x27) != 1)
            return -1;
          x28 = XVECEXP (x1, 0, 4);
          x29 = XEXP (x28, 0);
          if (REGNO (x29) != 2)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case USE:
              x4 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 0
                  || GET_MODE (x5) != E_SImode)
                return -1;
              x22 = XVECEXP (x1, 0, 5);
              x23 = XEXP (x22, 0);
              if (REGNO (x23) != 6
                  || pattern103 (x1, 
36, 
35, 
34, 
33, 
32) != 0)
                return -1;
              x20 = XVECEXP (x1, 0, 11);
              x21 = XEXP (x20, 0);
              if (REGNO (x21) != 37)
                return -1;
              x14 = XEXP (x6, 0);
              operands[0] = x14;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 137; /* divsi3_insn_indcall */

            case SET:
              if (pattern107 (x1, 
MOD) != 0
                  || pattern112 (x1, 
5) != 0)
                return -1;
              return 143; /* divmodsi4_insn_indcall */

            default:
              return -1;
            }

        case UDIV:
          if (pattern27 (x3) != 0)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET
              || pattern107 (x1, 
UMOD) != 0)
            return -1;
          x26 = XVECEXP (x1, 0, 3);
          x27 = XEXP (x26, 0);
          if (REGNO (x27) != 0)
            return -1;
          x28 = XVECEXP (x1, 0, 4);
          x29 = XEXP (x28, 0);
          if (REGNO (x29) != 1
              || pattern112 (x1, 
2) != 0)
            return -1;
          return 147; /* udivmodsi4_insn_indcall */

        default:
          return -1;
        }

    case 12:
      return recog_12 (x1, insn, pnum_clobbers);

    case 11:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UMOD
          || GET_MODE (x3) != E_SImode
          || pattern27 (x3) != 0)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 4
          || GET_MODE (x7) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x14 = XEXP (x6, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 1
          || GET_MODE (x14) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 5
          || GET_MODE (x5) != E_SImode)
        return -1;
      x26 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x26) != CLOBBER)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 7
          || GET_MODE (x27) != E_SImode)
        return -1;
      x28 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x28) != CLOBBER)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 32
          || pattern81 (x1, 
33) != 0)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      x23 = XEXP (x22, 0);
      if (GET_MODE (x23) != E_SImode)
        return -1;
      x30 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x30) != CLOBBER)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != REG
          || REGNO (x31) != 34
          || GET_MODE (x31) != E_SImode)
        return -1;
      x32 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x32) != CLOBBER)
        return -1;
      x33 = XEXP (x32, 0);
      if (GET_CODE (x33) != REG
          || REGNO (x33) != 35
          || GET_MODE (x33) != E_SImode)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x34) != CLOBBER)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 36
          || GET_MODE (x35) != E_SImode)
        return -1;
      x36 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x36) != CLOBBER)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 62
          || GET_MODE (x37) != E_SImode)
        return -1;
      x38 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x38) != CLOBBER)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != REG
          || REGNO (x39) != 63
          || GET_MODE (x39) != E_SImode)
        return -1;
      return 144; /* umodsi3_insn */

    case 16:
      switch (pattern12 (x1))
        {
        case 0:
          return 148; /* divmodsi4 */

        case 1:
          return 149; /* udivmodsi4 */

        default:
          return -1;
        }

    case 10:
      return recog_10 (x1, insn, pnum_clobbers);

    case 9:
      if (pnum_clobbers == NULL)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 46
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_SImode)
        return -1;
      x40 = XEXP (x7, 0);
      if (GET_CODE (x40) != REG
          || REGNO (x40) != 47
          || GET_MODE (x40) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 14
          || GET_MODE (x8) != E_DImode)
        return -1;
      x14 = XEXP (x6, 0);
      if (GET_CODE (x14) != MEM
          || GET_MODE (x14) != E_DImode)
        return -1;
      x41 = XEXP (x14, 0);
      if (pattern92 (x41) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x42 = XEXP (x4, 1);
      if (GET_CODE (x42) != REG
          || REGNO (x42) != 44
          || GET_MODE (x42) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_DImode)
        return -1;
      x43 = XEXP (x5, 0);
      if (pattern96 (x43) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x26) != SET)
        return -1;
      x44 = XEXP (x26, 1);
      if (GET_CODE (x44) != REG
          || REGNO (x44) != 12
          || GET_MODE (x44) != E_DImode)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != MEM
          || GET_MODE (x27) != E_DImode)
        return -1;
      x45 = XEXP (x27, 0);
      if (pattern99 (x45) != 0)
        return -1;
      x28 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x28) != SET)
        return -1;
      x46 = XEXP (x28, 1);
      if (GET_CODE (x46) != REG
          || REGNO (x46) != 42
          || GET_MODE (x46) != E_DImode)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != MEM
          || GET_MODE (x29) != E_DImode)
        return -1;
      x47 = XEXP (x29, 0);
      if (pattern110 (x47) != 0)
        return -1;
      x22 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x22) != SET)
        return -1;
      x48 = XEXP (x22, 1);
      if (GET_CODE (x48) != REG
          || REGNO (x48) != 10
          || GET_MODE (x48) != E_DImode)
        return -1;
      x23 = XEXP (x22, 0);
      if (GET_CODE (x23) != MEM
          || GET_MODE (x23) != E_DImode)
        return -1;
      x49 = XEXP (x23, 0);
      if (pattern113 (x49) != 0)
        return -1;
      x30 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x30) != SET)
        return -1;
      x50 = XEXP (x30, 1);
      if (GET_CODE (x50) != REG
          || REGNO (x50) != 34
          || GET_MODE (x50) != E_DImode)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != MEM
          || GET_MODE (x31) != E_DImode)
        return -1;
      x51 = XEXP (x31, 0);
      if (pattern115 (x51) != 0)
        return -1;
      x32 = XVECEXP (x1, 0, 7);
      if (pattern64 (x32) != 0)
        return -1;
      x52 = XEXP (x32, 1);
      x53 = XEXP (x52, 1);
      if (x53 != const_int_rtx[MAX_SAVED_CONST_INT + -56])
        return -1;
      x33 = XEXP (x32, 0);
      if (GET_CODE (x33) != REG
          || REGNO (x33) != 47
          || GET_MODE (x33) != E_SImode)
        return -1;
      x34 = XVECEXP (x1, 0, 8);
      if (pattern116 (x34) != 0
          || !
#line 2889 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS))
        return -1;
      *pnum_clobbers = 1;
      return 157; /* push_rts */

    default:
      return -1;
    }
}
