/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 4
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_scst5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case USE:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case SET:
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != i1
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 4
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 36
          || GET_MODE (x5) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 5
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern61 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG)
    return -1;
  return 0;
}

int
pattern93 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1)
    return -1;
  return 0;
}

int
pattern101 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER
      || pattern100 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern111 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 4
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 5
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != USE)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 6
              || GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !pic_register_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[2] = x6;
          if (!sdata_symbolic_operand (operands[2], E_SImode)
              || !
#line 587 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(flag_pic))
            return -1;
          return 9; /* load_sdata_pic */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !addsi_operand (operands[2], E_SImode))
                return -1;
              return 94; /* addsi3 */

            case E_SFmode:
              if (pattern7 (x3, 
E_SFmode) != 0
                  || !
#line 1782 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
                return -1;
              return 99; /* addsf3 */

            case E_DFmode:
              if (pattern7 (x3, 
E_DFmode) != 0
                  || !
#line 1794 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_FP))
                return -1;
              return 100; /* adddf3 */

            case E_V2HImode:
              if (pattern7 (x3, 
E_V2HImode) != 0)
                return -1;
              return 167; /* addv2hi3 */

            case E_V4QImode:
              if (pattern7 (x3, 
E_V4QImode) != 0
                  || !
#line 2996 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64))
                return -1;
              return 169; /* addv4qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          if (!adda_scale_operand (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 96; /* *addshiftsi */

        case SIGN_EXTEND:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x9 = XEXP (x7, 0);
          if (GET_CODE (x9) != VEC_SELECT
              || GET_MODE (x9) != E_HImode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return -1;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XEXP (x4, 1);
          if (GET_CODE (x8) != SIGN_EXTEND
              || GET_MODE (x8) != E_SImode)
            return -1;
          x12 = XEXP (x8, 0);
          if (GET_CODE (x12) != VEC_SELECT
              || GET_MODE (x12) != E_HImode)
            return -1;
          x13 = XEXP (x12, 1);
          if (GET_CODE (x13) != PARALLEL
              || XVECLEN (x13, 0) != 1)
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != MULT
              || GET_MODE (x5) != E_SImode)
            return -1;
          x15 = XEXP (x5, 0);
          if (GET_CODE (x15) != SIGN_EXTEND
              || GET_MODE (x15) != E_SImode)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != VEC_SELECT
              || GET_MODE (x16) != E_HImode)
            return -1;
          x17 = XEXP (x16, 1);
          if (GET_CODE (x17) != PARALLEL
              || XVECLEN (x17, 0) != 1)
            return -1;
          x18 = XVECEXP (x17, 0, 0);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x19 = XEXP (x5, 1);
          if (pattern95 (x19, 
E_HImode, 
VEC_SELECT, 
SIGN_EXTEND) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          x21 = XEXP (x20, 1);
          if (GET_CODE (x21) != PARALLEL
              || XVECLEN (x21, 0) != 1)
            return -1;
          x22 = XVECEXP (x21, 0, 0);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x23 = XEXP (x9, 0);
          operands[1] = x23;
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          x24 = XEXP (x12, 0);
          operands[2] = x24;
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          x25 = XEXP (x16, 0);
          if (!rtx_equal_p (x25, operands[1]))
            return -1;
          x26 = XEXP (x20, 0);
          if (!rtx_equal_p (x26, operands[2])
              || !
#line 352 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x-mult.md"
(TARGET_INSNS_64))
            return -1;
          return 213; /* dotv2hi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != ZERO_EXTEND
          || GET_MODE (x5) != E_DImode
          || pattern49 (x3, 
E_DImode) != 0)
        return -1;
      return 98; /* addsidi3_widen */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x5, 0);
  if (!scratch_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  switch (GET_CODE (x8))
    {
    case IF_THEN_ELSE:
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != NE)
        return -1;
      x10 = XEXP (x9, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XEXP (x8, 1);
      if (GET_CODE (x11) != LABEL_REF)
        return -1;
      x12 = XEXP (x8, 2);
      if (GET_CODE (x12) != PC)
        return -1;
      x13 = XEXP (x3, 0);
      if (GET_CODE (x13) != PC
          || GET_CODE (x6) != PLUS)
        return -1;
      x14 = XEXP (x6, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x15 = XEXP (x1, 0);
      operands[4] = x15;
      x16 = XEXP (x15, 0);
      operands[5] = x16;
      x17 = XEXP (x9, 0);
      operands[3] = x17;
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      x18 = XEXP (x11, 0);
      operands[1] = x18;
      x19 = XEXP (x4, 0);
      operands[0] = x19;
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      operands[2] = x7;
      x20 = XEXP (x6, 0);
      if (!rtx_equal_p (x20, operands[3])
          || !
#line 1488 "../../gcc-15.0.1-20250313/gcc/config/c6x/c6x.md"
(TARGET_INSNS_64PLUS && optimize))
        return -1;
      return 402; /* *p loop_end */

    case SUBREG:
    case MEM:
      operands[1] = x8;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x3, 0);
      operands[0] = x13;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x19 = XEXP (x4, 0);
      if (!rtx_equal_p (x19, operands[1]))
        return -1;
      switch (GET_CODE (x6))
        {
        case UNSPEC_VOLATILE:
          if (XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 4)
            return -1;
          x15 = XEXP (x1, 0);
          operands[5] = x15;
          x16 = XEXP (x15, 0);
          operands[6] = x16;
          x21 = XVECEXP (x6, 0, 0);
          operands[2] = x21;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x22 = XVECEXP (x6, 0, 1);
          operands[3] = x22;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          operands[4] = x7;
          return 567; /* *p *sync_compare_and_swapsi */

        case UNSPEC:
          if (XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 17)
            return -1;
          x15 = XEXP (x1, 0);
          operands[4] = x15;
          x16 = XEXP (x15, 0);
          operands[5] = x16;
          x21 = XVECEXP (x6, 0, 0);
          if (GET_MODE (x21) != E_SImode)
            return -1;
          operands[3] = x7;
          switch (GET_CODE (x21))
            {
            case PLUS:
              x23 = XEXP (x21, 1);
              operands[2] = x23;
              if (!reg_or_scst5_operand (operands[2], E_SImode))
                return -1;
              x24 = XEXP (x21, 0);
              if (!rtx_equal_p (x24, operands[1]))
                return -1;
              return 573; /* *p sync_old_addsi_insn */

            case MINUS:
              x23 = XEXP (x21, 1);
              operands[2] = x23;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x24 = XEXP (x21, 0);
              if (!rtx_equal_p (x24, operands[1]))
                return -1;
              return 574; /* *p sync_old_subsi_insn */

            case IOR:
              x23 = XEXP (x21, 1);
              operands[2] = x23;
              if (!reg_or_scst5_operand (operands[2], E_SImode))
                return -1;
              x24 = XEXP (x21, 0);
              if (!rtx_equal_p (x24, operands[1]))
                return -1;
              return 575; /* *p sync_old_iorsi_insn */

            case XOR:
              x23 = XEXP (x21, 1);
              operands[2] = x23;
              if (!reg_or_scst5_operand (operands[2], E_SImode))
                return -1;
              x24 = XEXP (x21, 0);
              if (!rtx_equal_p (x24, operands[1]))
                return -1;
              return 576; /* *p sync_old_xorsi_insn */

            case AND:
              x23 = XEXP (x21, 1);
              operands[2] = x23;
              if (!reg_or_scst5_operand (operands[2], E_SImode))
                return -1;
              x24 = XEXP (x21, 0);
              if (!rtx_equal_p (x24, operands[1]))
                return -1;
              return 577; /* *p sync_old_andsi_insn */

            case NOT:
              x24 = XEXP (x21, 0);
              if (GET_CODE (x24) != AND
                  || GET_MODE (x24) != E_SImode)
                return -1;
              x25 = XEXP (x24, 1);
              operands[2] = x25;
              if (!reg_or_scst5_operand (operands[2], E_SImode))
                return -1;
              x26 = XEXP (x24, 0);
              if (!rtx_equal_p (x26, operands[1]))
                return -1;
              return 584; /* *p sync_old_nandsi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (pattern78 (x1, 
PLUS) != 0)
        return -1;
      return 578; /* *p sync_new_addsi_insn */

    case MINUS:
      if (GET_MODE (x8) != E_SImode
          || pattern80 (x6, 
MINUS) != 0)
        return -1;
      x15 = XEXP (x1, 0);
      operands[4] = x15;
      x16 = XEXP (x15, 0);
      operands[5] = x16;
      x13 = XEXP (x3, 0);
      operands[0] = x13;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x8, 1);
      operands[2] = x11;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x7;
      x21 = XVECEXP (x6, 0, 0);
      x24 = XEXP (x21, 0);
      if (!rtx_equal_p (x24, operands[1]))
        return -1;
      x23 = XEXP (x21, 1);
      if (!rtx_equal_p (x23, operands[2]))
        return -1;
      x19 = XEXP (x4, 0);
      if (!rtx_equal_p (x19, operands[1]))
        return -1;
      return 579; /* *p sync_new_subsi_insn */

    case IOR:
      if (pattern78 (x1, 
IOR) != 0)
        return -1;
      return 580; /* *p sync_new_iorsi_insn */

    case XOR:
      if (pattern78 (x1, 
XOR) != 0)
        return -1;
      return 581; /* *p sync_new_xorsi_insn */

    case AND:
      if (pattern78 (x1, 
AND) != 0)
        return -1;
      return 582; /* *p sync_new_andsi_insn */

    case NOT:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != AND
          || GET_MODE (x9) != E_SImode
          || pattern80 (x6, 
NOT) != 0)
        return -1;
      x21 = XVECEXP (x6, 0, 0);
      x24 = XEXP (x21, 0);
      if (GET_CODE (x24) != AND
          || GET_MODE (x24) != E_SImode)
        return -1;
      x15 = XEXP (x1, 0);
      operands[4] = x15;
      x16 = XEXP (x15, 0);
      operands[5] = x16;
      x13 = XEXP (x3, 0);
      operands[0] = x13;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x17 = XEXP (x9, 0);
      operands[1] = x17;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x9, 1);
      operands[2] = x10;
      if (!reg_or_scst5_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x7;
      x26 = XEXP (x24, 0);
      if (!rtx_equal_p (x26, operands[1]))
        return -1;
      x25 = XEXP (x24, 1);
      if (!rtx_equal_p (x25, operands[2]))
        return -1;
      x19 = XEXP (x4, 0);
      if (!rtx_equal_p (x19, operands[1]))
        return -1;
      return 585; /* *p sync_new_nandsi_insn */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
