/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!integer_register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !gpr_or_memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!integer_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!gpr_or_memory_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!gpr_or_memory_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!icc_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !integer_register_operand (operands[1], E_SImode)
      || !gpr_or_int10_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern31 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!icc_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !integer_register_operand (operands[3], E_SImode)
      || !reg_or_0_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!integer_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpr_or_int_operand (operands[3], i1)
      || !gpr_or_int_operand (operands[4], i1))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 9:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!memory_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          return 24; /* optional_membar_qi */

        case E_HImode:
          if (!memory_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          return 25; /* optional_membar_hi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          return 26; /* optional_membar_si */

        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          return 27; /* optional_membar_di */

        default:
          return -1;
        }

    case 8:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 0
          || GET_MODE (x5) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fdpic_fptr_operand (operands[0], E_DImode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!ldd_address_operand (operands[1], E_SImode))
        return -1;
      return 150; /* movdi_ldd */

    case 102:
      if (pattern5 (x1, 
E_SImode) != 0
          || !
#line 5644 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
        return -1;
      return 176; /* maveh */

    case 106:
      if (pattern5 (x1, 
E_HImode) != 0
          || !
#line 5873 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
        return -1;
      return 182; /* mpackh */

    case 108:
      if (pattern6 (x1) != 0
          || !
#line 5896 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
        return -1;
      return 184; /* mdpackh */

    case 113:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!uint1_operand (operands[2], E_SImode)
          || !
#line 6046 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
        return -1;
      return 191; /* mexpdhw */

    case 114:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!even_fpr_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!uint1_operand (operands[2], E_SImode)
          || !
#line 6072 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
        return -1;
      return 193; /* mexpdhd */

    case 115:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!fpr_or_int6_operand (operands[2], E_SImode)
          || !
#line 6098 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
        return -1;
      return 195; /* mwcut */

    case 133:
      if (pattern5 (x1, 
E_SImode) != 0
          || !
#line 6901 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV1))
        return -1;
      return 219; /* mcop1 */

    case 134:
      if (pattern5 (x1, 
E_SImode) != 0
          || !
#line 6911 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV1))
        return -1;
      return 220; /* mcop2 */

    case 143:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!even_fpr_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!even_fpr_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!uint5_operand (operands[2], E_SImode)
          || !
#line 7186 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
        return -1;
      return 231; /* mdrotli */

    case 144:
      if (pattern7 (x1, 
E_DImode) != 0
          || !
#line 7198 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
        return -1;
      return 232; /* mcplhi */

    case 145:
      if (pattern8 (x1, 
E_DImode) != 0
          || !
#line 7208 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
        return -1;
      return 233; /* mcpli */

    case 147:
      if (pattern6 (x1) != 0
          || !
#line 7233 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
        return -1;
      return 235; /* mqsaths */

    case 154:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (even_fpr_operand (operands[1], E_DImode)
          && even_fpr_operand (operands[0], E_DImode))
        {
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (even_fpr_operand (operands[2], E_DImode)
              && 
#line 7245 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_FR450))
            return 236; /* mqlclrhs */
        }
      if (!integer_register_operand (operands[1], E_SImode)
          || !integer_register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!integer_register_operand (operands[2], E_SImode))
        return -1;
      return 246; /* smul */

    case 155:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (even_fpr_operand (operands[1], E_DImode)
          && even_fpr_operand (operands[0], E_DImode))
        {
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (even_fpr_operand (operands[2], E_DImode)
              && 
#line 7255 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_FR450))
            return 237; /* mqlmths */
        }
      if (!integer_register_operand (operands[1], E_SImode)
          || !integer_register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!integer_register_operand (operands[2], E_SImode))
        return -1;
      return 247; /* umul */

    case 156:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          operands[2] = x5;
          if (!int6_operand (operands[2], E_SImode))
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!even_fpr_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!even_fpr_operand (operands[1], E_DImode)
              || !
#line 7265 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_FR450))
            return -1;
          return 238; /* mqsllhi */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!integer_register_operand (operands[1], E_SImode))
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 171
              || GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          if (!integer_register_operand (operands[0], E_SImode)
              || !
#line 7575 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FR405_BUILTINS))
            return -1;
          return 250; /* smu */

        default:
          return -1;
        }

    case 157:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          if (!int6_operand (operands[2], E_SImode)
              || !even_fpr_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !even_fpr_operand (operands[1], E_DImode)
              || !
#line 7275 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_FR450))
            return -1;
          return 239; /* mqsrahi */

        case REG:
        case SUBREG:
          if (!integer_register_operand (operands[2], E_SImode)
              || !integer_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !integer_register_operand (operands[1], E_SImode)
              || !
#line 7585 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FR405_BUILTINS))
            return -1;
          return 251; /* addss */

        default:
          return -1;
        }

    case 148:
      if (pattern9 (x1) != 0
          || !
#line 7287 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
        return -1;
      return 240; /* mhsetlos */

    case 149:
      if (pattern10 (x1) != 0
          || !
#line 7297 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
        return -1;
      return 241; /* mhsetloh */

    case 150:
      if (pattern9 (x1) != 0
          || !
#line 7307 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
        return -1;
      return 242; /* mhsethis */

    case 151:
      if (pattern10 (x1) != 0
          || !
#line 7317 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
        return -1;
      return 243; /* mhsethih */

    case 153:
      if (pattern10 (x1) != 0
          || !
#line 7336 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
        return -1;
      return 245; /* mhdseth */

    case 158:
      if (pattern11 (x1) != 0
          || !
#line 7595 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FR405_BUILTINS))
        return -1;
      return 252; /* subss */

    case 159:
      if (pattern11 (x1) != 0
          || !
#line 7605 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FR405_BUILTINS))
        return -1;
      return 253; /* slass */

    case 160:
      if (pattern11 (x1) != 0)
        return -1;
      return 254; /* scan */

    case 162:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 171
          || GET_MODE (x5) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!integer_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!integer_register_operand (operands[1], E_SImode)
          || !
#line 7625 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FR405_BUILTINS))
        return -1;
      return 255; /* scutss */

    case 201:
      if (pattern12 (x1, 
E_SImode) != 0)
        return -1;
      return 260; /* tls_load_gottlsoff12 */

    case 206:
      if (pattern12 (x1, 
E_DImode) != 0)
        return -1;
      return 263; /* tls_lddi */

    default:
      return -1;
    }
}
