/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!fpr_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!int12_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!integer_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!integer_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!integer_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern25 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != i2
      || GET_MODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SFmode)
      || GET_MODE (x1) != E_SFmode
      || !register_operand (operands[3], E_SFmode)
      || !register_operand (operands[4], E_SFmode))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!icc_operand (operands[1], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      return 97; /* *branch_int_true */

    case PC:
      x8 = XEXP (x2, 2);
      switch (GET_CODE (x8))
        {
        case LABEL_REF:
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          return 98; /* *branch_int_false */

        case RETURN:
          if (!
#line 5182 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(direct_return_p ()))
            return -1;
          return 162; /* *return_false */

        default:
          return -1;
        }

    case RETURN:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC
          || !
#line 5170 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(direct_return_p ()))
        return -1;
      return 161; /* *return_true */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case PC:
          operands[0] = x2;
          if (register_operand (operands[0], E_SImode))
            return 165; /* indirect_jump */
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case LABEL_REF:
          if (GET_CODE (x3) != PC)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 164; /* jump */

        case MEM:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != UNSPEC
              || XVECLEN (x4, 0) != 3
              || XINT (x4, 1) != 205
              || GET_MODE (x4) != E_SImode)
            return -1;
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          operands[3] = x7;
          if (!symbolic_operand (operands[3], E_SImode))
            return -1;
          return 262; /* tls_tlsoff_ld */

        default:
          return -1;
        }

    case HIGH:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!integer_register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !int_2word_operand (operands[1], E_HImode))
            return -1;
          return 5; /* movhi_high */

        case E_SImode:
          if (!integer_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          if (const_unspec_operand (operands[1], E_SImode))
            return 9; /* *movsi_high_got */
          if (!int_2word_operand (operands[1], E_SImode))
            return -1;
          return 13; /* movsi_high */

        case E_SFmode:
          if (!integer_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !int_2word_operand (operands[1], E_SFmode))
            return -1;
          return 20; /* movsf_high */

        default:
          return -1;
        }

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern4 (x2, 
E_HImode) != 0)
            return -1;
          return 6; /* movhi_lo_sum */

        case E_SImode:
          if (!integer_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (integer_register_operand (operands[1], E_SImode))
            {
              x8 = XEXP (x2, 1);
              operands[2] = x8;
              if (const_unspec_operand (operands[2], E_SImode))
                return 10; /* *movsi_lo_sum_got */
            }
          x8 = XEXP (x2, 1);
          operands[1] = x8;
          if (!int_2word_operand (operands[1], E_SImode)
              || !rtx_equal_p (x4, operands[0]))
            return -1;
          return 14; /* movsi_lo_sum */

        case E_SFmode:
          if (pattern4 (x2, 
E_SFmode) != 0)
            return -1;
          return 21; /* movsf_lo_sum */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_5 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      switch (pattern0 (x1))
        {
        case 0:
          return 35; /* extendqihi2 */

        case 1:
          return 36; /* extendqisi2 */

        case 2:
          return 37; /* extendhisi2 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern0 (x1))
        {
        case 0:
          return 38; /* zero_extendqihi2 */

        case 1:
          return 39; /* zero_extendqisi2 */

        case 2:
          return 40; /* zero_extendhisi2 */

        default:
          return -1;
        }

    case FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!fpr_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fpr_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !
#line 2555 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 41; /* floatsisf2 */

        case E_DFmode:
          if (!fpr_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE))
            return -1;
          return 42; /* floatsidf2 */

        default:
          return -1;
        }

    case FIX:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!fpr_operand (operands[1], E_SFmode)
              || !
#line 2585 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 43; /* fix_truncsfsi2 */

        case E_DFmode:
          if (!fpr_operand (operands[1], E_DFmode)
              || !
#line 2593 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE))
            return -1;
          return 44; /* fix_truncdfsi2 */

        default:
          return -1;
        }

    case PLUS:
      return recog_7 (x1, insn, pnum_clobbers);

    case MINUS:
      switch (pattern1 (x1))
        {
        case 0:
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[2] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!integer_register_operand (operands[0], E_SImode)
                      || GET_MODE (x2) != E_SImode
                      || !gpr_no_subreg_operand (operands[1], E_SImode)
                      || !gpr_no_subreg_operand (operands[2], E_SImode))
                    return -1;
                  return 46; /* subsi3 */

                case E_DImode:
                  if (pattern16 (x2, pnum_clobbers) != 0
                      || !integer_register_operand (operands[2], E_DImode))
                    return -1;
                  *pnum_clobbers = 1;
                  return 55; /* subdi3 */

                case E_SFmode:
                  if (pattern18 (x2) != 0
                      || !
#line 3006 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 62; /* subsf3 */

                case E_DFmode:
                  if (pattern19 (x2) != 0
                      || !
#line 3101 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE))
                    return -1;
                  return 71; /* subdf3 */

                default:
                  return -1;
                }

            case MINUS:
              if (pattern17 (x2) != 0)
                return -1;
              x9 = XEXP (x8, 0);
              operands[2] = x9;
              if (!integer_register_operand (operands[2], E_SImode))
                return -1;
              x10 = XEXP (x8, 1);
              operands[3] = x10;
              if (!icc_operand (operands[3], E_CCmode))
                return -1;
              return 59; /* subdi3_upper */

            default:
              return -1;
            }

        case 1:
          if (!
#line 3132 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE && TARGET_MULADD))
            return -1;
          return 74; /* *mulsubdf4 */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          if (pattern15 (x2) != 0)
            return -1;
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x8) != E_DImode)
                return -1;
              x9 = XEXP (x8, 0);
              operands[2] = x9;
              if (!integer_register_operand (operands[2], E_SImode))
                return -1;
              return 47; /* *mulsidi3_reg */

            case CONST_INT:
              operands[2] = x8;
              if (!int12_operand (operands[2], E_SImode))
                return -1;
              return 48; /* mulsidi3_const */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern15 (x2) != 0)
            return -1;
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x8) != E_DImode)
                return -1;
              x9 = XEXP (x8, 0);
              operands[2] = x9;
              if (!integer_register_operand (operands[2], E_SImode))
                return -1;
              return 49; /* *mulsidi3_reg */

            case CONST_INT:
              operands[2] = x8;
              if (!int12_operand (operands[2], E_SImode))
                return -1;
              return 50; /* umulsidi3_const */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x4;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern18 (x2) != 0
                  || !
#line 3016 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 63; /* mulsf3 */

            case E_DFmode:
              if (pattern19 (x2) != 0
                  || !
#line 3111 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE))
                return -1;
              return 72; /* muldf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !gpr_or_int12_operand (operands[2], E_SImode))
            return -1;
          return 51; /* divsi3 */

        case E_SFmode:
          if (pattern18 (x2) != 0
              || !
#line 3047 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 66; /* divsf3 */

        case E_DFmode:
          if (pattern19 (x2) != 0
              || !
#line 3142 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE))
            return -1;
          return 75; /* divdf3 */

        default:
          return -1;
        }

    case UDIV:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!gpr_or_int12_operand (operands[2], E_SImode))
        return -1;
      return 52; /* udivsi3 */

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!integer_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !integer_register_operand (operands[1], E_SImode))
            return -1;
          return 53; /* negsi2 */

        case E_DImode:
          if (pattern16 (x2, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 60; /* negdi2 */

        case E_SFmode:
          if (!fpr_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !fpr_operand (operands[1], E_SFmode)
              || !
#line 3056 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 67; /* negsf2 */

        case E_DFmode:
          if (!even_fpr_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !fpr_operand (operands[1], E_DFmode)
              || !
#line 3151 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE))
            return -1;
          return 76; /* negdf2 */

        default:
          return -1;
        }

    case FMA:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!fpr_operand (operands[1], E_SFmode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!fpr_operand (operands[2], E_SFmode))
        return -1;
      x11 = XEXP (x2, 2);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[3] = x11;
          if (!fpr_operand (operands[3], E_SFmode)
              || !
#line 3027 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_MULADD))
            return -1;
          return 64; /* fmasf4 */

        case NEG:
          if (GET_MODE (x11) != E_SFmode)
            return -1;
          x12 = XEXP (x11, 0);
          operands[3] = x12;
          if (!fpr_operand (operands[3], E_SFmode)
              || !
#line 3037 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_MULADD))
            return -1;
          return 65; /* fmssf4 */

        default:
          return -1;
        }

    case ABS:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 3065 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 68; /* abssf2 */

        case 1:
          if (!
#line 3160 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE))
            return -1;
          return 77; /* absdf2 */

        default:
          return -1;
        }

    case SQRT:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 3074 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 69; /* sqrtsf2 */

        case 1:
          if (!
#line 3169 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE))
            return -1;
          return 78; /* sqrtdf2 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern3 (x1) != 0)
        return -1;
      return 79; /* ashlsi3 */

    case ASHIFTRT:
      if (pattern3 (x1) != 0)
        return -1;
      return 80; /* ashrsi3 */

    case LSHIFTRT:
      if (pattern3 (x1) != 0)
        return -1;
      return 81; /* lshrsi3 */

    case AND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (gpr_or_fpr_operand (operands[1], E_SImode)
          && gpr_or_fpr_operand (operands[0], E_SImode))
        {
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (gpr_fpr_or_int12_operand (operands[2], E_SImode)
              && 
#line 3293 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return 82; /* andsi3_media */
        }
      if (!integer_register_operand (operands[1], E_SImode)
          || !integer_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!gpr_or_int12_operand (operands[2], E_SImode)
          || !
#line 3304 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(!TARGET_MEDIA))
        return -1;
      return 83; /* andsi3_nomedia */

    case IOR:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (gpr_or_fpr_operand (operands[1], E_SImode)
          && gpr_or_fpr_operand (operands[0], E_SImode))
        {
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (gpr_fpr_or_int12_operand (operands[2], E_SImode)
              && 
#line 3321 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return 84; /* iorsi3_media */
        }
      if (!integer_register_operand (operands[1], E_SImode)
          || !integer_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!gpr_or_int12_operand (operands[2], E_SImode)
          || !
#line 3332 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(!TARGET_MEDIA))
        return -1;
      return 85; /* iorsi3_nomedia */

    case XOR:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (gpr_or_fpr_operand (operands[1], E_SImode)
          && gpr_or_fpr_operand (operands[0], E_SImode))
        {
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (gpr_fpr_or_int12_operand (operands[2], E_SImode)
              && 
#line 3349 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return 86; /* xorsi3_media */
        }
      if (!integer_register_operand (operands[1], E_SImode)
          || !integer_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!gpr_or_int12_operand (operands[2], E_SImode)
          || !
#line 3360 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(!TARGET_MEDIA))
        return -1;
      return 87; /* xorsi3_nomedia */

    case NOT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (gpr_or_fpr_operand (operands[1], E_SImode)
          && gpr_or_fpr_operand (operands[0], E_SImode)
          && 
#line 3376 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
        return 88; /* one_cmplsi2_media */
      if (!integer_register_operand (operands[1], E_SImode)
          || !integer_register_operand (operands[0], E_SImode)
          || !
#line 3386 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(!TARGET_MEDIA))
        return -1;
      return 89; /* one_cmplsi2_nomedia */

    case COMPARE:
      return recog_6 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[0] = x4;
          if (integer_relational_operator (operands[0], E_VOIDmode))
            {
              res = recog_3 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
              operands[0] = x4;
              if (float_relational_operator (operands[0], E_CC_FPmode))
                {
                  res = recog_4 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (!ccr_eqne_operator (x4, E_VOIDmode))
                return -1;
              operands[1] = x4;
              x13 = XEXP (x4, 1);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x8 = XEXP (x2, 1);
              if (!relational_operator (x8, E_VOIDmode))
                return -1;
              operands[3] = x8;
              x10 = XEXP (x8, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x11 = XEXP (x2, 2);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (!cr_operand (operands[0], E_CC_CCRmode)
                  || GET_MODE (x2) != E_CC_CCRmode)
                return -1;
              x14 = XEXP (x4, 0);
              operands[2] = x14;
              if (!cr_operand (operands[2], E_VOIDmode))
                return -1;
              x9 = XEXP (x8, 0);
              operands[4] = x9;
              if (!cc_operand (operands[4], E_VOIDmode))
                return -1;
              return 107; /* cond_exec_ck */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[1] = x2;
      if (integer_relational_operator (operands[1], E_CC_CCRmode))
        {
          x8 = XEXP (x2, 1);
          if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (icr_operand (operands[0], E_CC_CCRmode))
                {
                  x4 = XEXP (x2, 0);
                  operands[2] = x4;
                  if (icc_operand (operands[2], E_VOIDmode))
                    return 105; /* *ck_signed */
                }
            }
        }
      if (!float_relational_operator (operands[1], E_CC_CCRmode))
        return -1;
      x8 = XEXP (x2, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fcr_operand (operands[0], E_CC_CCRmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!fcc_operand (operands[2], E_CC_FPmode)
          || !
#line 3845 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HAS_FPRS))
        return -1;
      return 106; /* *fck_float */

    default:
      return -1;
    }
}
