/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return 0;

    case MULT:
      if (GET_MODE (x4) != E_DFmode
          || !fpr_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!fpr_operand (operands[1], E_DFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!fpr_operand (operands[2], E_DFmode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (!fpr_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_operand (operands[0], E_SFmode)
      || GET_MODE (x1) != E_SFmode
      || !fpr_operand (operands[1], E_SFmode)
      || !fpr_operand (operands[2], E_SFmode))
    return -1;
  return 0;
}

int
pattern27 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fpr_operand (operands[0], i1)
      || !minmax_operator (operands[1], i1)
      || !fpr_operand (operands[2], i1)
      || !fpr_operand (operands[3], i1)
      || !fcc_operand (operands[4], E_CC_FPmode)
      || !fcr_operand (operands[5], E_CC_CCRmode))
    return -1;
  return 0;
}

int
pattern34 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XINT (x5, 1) != i1
      || GET_MODE (x5) != E_V4QImode
      || !quad_acc_operand (operands[0], E_V4SImode)
      || !even_fpr_operand (operands[1], E_DImode)
      || !even_fpr_operand (operands[2], E_DImode)
      || !accg_operand (operands[4], E_V4QImode))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST:
        case REG:
        case SUBREG:
          operands[2] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!integer_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !integer_register_operand (operands[1], E_SImode)
                  || !gpr_or_int12_operand (operands[2], E_SImode))
                return -1;
              return 45; /* addsi3 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || !integer_register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !integer_register_operand (operands[1], E_DImode)
                  || !gpr_or_int10_operand (operands[2], E_DImode))
                return -1;
              *pnum_clobbers = 1;
              return 54; /* adddi3 */

            case E_SFmode:
              if (pattern18 (x2) != 0
                  || !
#line 2996 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 61; /* addsf3 */

            case E_DFmode:
              if (pattern19 (x2) != 0
                  || !
#line 3091 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE))
                return -1;
              return 70; /* adddf3 */

            default:
              return -1;
            }

        case PLUS:
          if (pattern17 (x2) != 0)
            return -1;
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (!gpr_or_int10_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!icc_operand (operands[3], E_CCmode))
            return -1;
          return 57; /* adddi3_upper */

        default:
          return -1;
        }

    case 1:
      if (!
#line 3122 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE && TARGET_MULADD))
        return -1;
      return 73; /* *muladddf4 */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_12 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return recog_11 (x1, insn, pnum_clobbers);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x3 = XEXP (x2, 0);
              operands[0] = x3;
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case ABS:
                  if (GET_MODE (x4) != E_SImode)
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != CLOBBER)
                    return -1;
                  x6 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x6) != CLOBBER
                      || pattern26 (x1) != 0
                      || !
#line 4677 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_COND_MOVE))
                    return -1;
                  return 144; /* *abssi2_internal */

                case SMIN:
                case SMAX:
                case UMIN:
                case UMAX:
                  operands[1] = x4;
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != CLOBBER)
                    return -1;
                  x6 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x6) != CLOBBER)
                    return -1;
                  switch (pattern28 (x1))
                    {
                    case 0:
                      if (!
#line 4718 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_COND_MOVE))
                        return -1;
                      return 145; /* *minmax_si_signed */

                    case 1:
                      if (!
#line 4759 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_COND_MOVE))
                        return -1;
                      return 146; /* *minmax_si_unsigned */

                    case 2:
                      if (!
#line 4800 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_COND_MOVE && TARGET_HARD_FLOAT))
                        return -1;
                      return 147; /* *minmax_sf */

                    case 3:
                      if (!
#line 4841 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_COND_MOVE && TARGET_HARD_FLOAT && TARGET_DOUBLE))
                        return -1;
                      return 148; /* *minmax_df */

                    default:
                      return -1;
                    }

                case CALL:
                  x7 = XEXP (x4, 0);
                  if (GET_CODE (x7) != MEM
                      || GET_MODE (x7) != E_QImode)
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != USE
                      || !register_operand (operands[0], E_VOIDmode))
                    return -1;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  x9 = XEXP (x4, 1);
                  operands[2] = x9;
                  x10 = XEXP (x5, 0);
                  operands[3] = x10;
                  x6 = XVECEXP (x1, 0, 2);
                  switch (GET_CODE (x6))
                    {
                    case CLOBBER:
                      if (!call_operand (operands[1], E_SImode))
                        return -1;
                      x11 = XEXP (x6, 0);
                      operands[4] = x11;
                      if (!lr_operand (operands[4], E_SImode)
                          || !
#line 5053 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(! TARGET_FDPIC))
                        return -1;
                      return 155; /* call_value_internal */

                    case RETURN:
                      if (!sibcall_operand (operands[1], E_SImode)
                          || !
#line 5118 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(! TARGET_FDPIC))
                        return -1;
                      return 158; /* sibcall_value_internal */

                    default:
                      return -1;
                    }

                case UNSPEC_VOLATILE:
                  if (XVECLEN (x4, 0) != 1
                      || XINT (x4, 1) != 3
                      || GET_MODE (x4) != E_SImode)
                    return -1;
                  x12 = XVECEXP (x4, 0, 0);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != CLOBBER)
                    return -1;
                  x6 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x6) != CLOBBER
                      || !integer_register_operand (operands[0], E_SImode))
                    return -1;
                  x10 = XEXP (x5, 0);
                  operands[1] = x10;
                  if (!lr_operand (operands[1], E_SImode))
                    return -1;
                  x11 = XEXP (x6, 0);
                  operands[2] = x11;
                  if (!integer_register_operand (operands[2], E_SImode))
                    return -1;
                  return 167; /* pic_prologue */

                default:
                  return -1;
                }

            case CALL:
              x3 = XEXP (x2, 0);
              if (GET_CODE (x3) != MEM
                  || GET_MODE (x3) != E_QImode)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != USE)
                return -1;
              x13 = XEXP (x3, 0);
              operands[0] = x13;
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              x6 = XVECEXP (x1, 0, 2);
              switch (GET_CODE (x6))
                {
                case CLOBBER:
                  if (!call_operand (operands[0], E_SImode))
                    return -1;
                  x11 = XEXP (x6, 0);
                  operands[3] = x11;
                  if (!lr_operand (operands[3], E_SImode)
                      || !
#line 4899 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(! TARGET_FDPIC))
                    return -1;
                  return 149; /* call_internal */

                case RETURN:
                  if (!sibcall_operand (operands[0], E_SImode)
                      || !
#line 4995 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(! TARGET_FDPIC))
                    return -1;
                  return 153; /* sibcall_internal */

                default:
                  return -1;
                }

            case RETURN:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != USE)
                return -1;
              x6 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x6) != USE)
                return -1;
              x10 = XEXP (x5, 0);
              operands[0] = x10;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x11 = XEXP (x6, 0);
              operands[1] = x11;
              if (!immediate_operand (operands[1], E_SImode))
                return -1;
              return 160; /* *return_internal */

            default:
              return -1;
            }

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case CALL:
              x3 = XEXP (x2, 0);
              if (GET_CODE (x3) != MEM
                  || GET_MODE (x3) != E_QImode)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != USE)
                return -1;
              x6 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x6) != USE)
                return -1;
              x14 = XVECEXP (x1, 0, 3);
              if (GET_CODE (x14) != CLOBBER)
                return -1;
              x13 = XEXP (x3, 0);
              operands[0] = x13;
              if (!call_operand (operands[0], E_SImode))
                return -1;
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              if (!fdpic_operand (operands[3], E_SImode))
                return -1;
              x15 = XEXP (x14, 0);
              operands[4] = x15;
              if (!lr_operand (operands[4], E_SImode)
                  || !
#line 4945 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FDPIC))
                return -1;
              return 152; /* call_fdpicsi */

            case SET:
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case CALL:
                  x7 = XEXP (x4, 0);
                  if (GET_CODE (x7) != MEM
                      || GET_MODE (x7) != E_QImode)
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != USE)
                    return -1;
                  x6 = XVECEXP (x1, 0, 2);
                  if (GET_CODE (x6) != USE)
                    return -1;
                  x14 = XVECEXP (x1, 0, 3);
                  if (GET_CODE (x14) != CLOBBER)
                    return -1;
                  x3 = XEXP (x2, 0);
                  operands[0] = x3;
                  if (!register_operand (operands[0], E_VOIDmode))
                    return -1;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!call_operand (operands[1], E_SImode))
                    return -1;
                  x9 = XEXP (x4, 1);
                  operands[2] = x9;
                  x10 = XEXP (x5, 0);
                  operands[3] = x10;
                  x11 = XEXP (x6, 0);
                  operands[4] = x11;
                  if (!fdpic_operand (operands[4], E_SImode))
                    return -1;
                  x15 = XEXP (x14, 0);
                  operands[5] = x15;
                  if (!lr_operand (operands[5], E_SImode)
                      || !
#line 5077 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FDPIC))
                    return -1;
                  return 157; /* call_value_fdpicsi */

                case UNSPEC:
                  switch (XVECLEN (x4, 0))
                    {
                    case 1:
                      x3 = XEXP (x2, 0);
                      operands[0] = x3;
                      switch (XINT (x4, 1))
                        {
                        case 132:
                          if (GET_MODE (x4) != E_V4SImode
                              || pattern25 (x1, 
E_V4SImode, 
132) != 0)
                            return -1;
                          x6 = XVECEXP (x1, 0, 2);
                          if (GET_CODE (x6) != SET)
                            return -1;
                          x16 = XEXP (x6, 1);
                          if (GET_CODE (x16) != UNSPEC
                              || XVECLEN (x16, 0) != 1
                              || XINT (x16, 1) != 132
                              || GET_MODE (x16) != E_V4QImode)
                            return -1;
                          x17 = XVECEXP (x16, 0, 0);
                          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                            return -1;
                          x14 = XVECEXP (x1, 0, 3);
                          if (GET_CODE (x14) != SET)
                            return -1;
                          x18 = XEXP (x14, 1);
                          if (GET_CODE (x18) != UNSPEC
                              || XVECLEN (x18, 0) != 1
                              || XINT (x18, 1) != 132
                              || GET_MODE (x18) != E_V4QImode)
                            return -1;
                          x19 = XVECEXP (x18, 0, 0);
                          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                              || !quad_acc_operand (operands[0], E_V4SImode))
                            return -1;
                          x5 = XVECEXP (x1, 0, 1);
                          x10 = XEXP (x5, 0);
                          operands[1] = x10;
                          if (!quad_acc_operand (operands[1], E_V4SImode))
                            return -1;
                          x11 = XEXP (x6, 0);
                          operands[2] = x11;
                          if (!accg_operand (operands[2], E_V4QImode))
                            return -1;
                          x15 = XEXP (x14, 0);
                          operands[3] = x15;
                          if (!accg_operand (operands[3], E_V4QImode)
                              || !
#line 6858 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA && TARGET_ACC_8))
                            return -1;
                          return 217; /* mclracca8_internal */

                        case 200:
                          if (GET_MODE (x4) != E_SImode
                              || pattern29 (x1) != 0
                              || !register_operand (operands[0], E_SImode))
                            return -1;
                          x12 = XVECEXP (x4, 0, 0);
                          operands[1] = x12;
                          if (!symbolic_operand (operands[1], E_SImode))
                            return -1;
                          x14 = XVECEXP (x1, 0, 3);
                          x15 = XEXP (x14, 0);
                          operands[2] = x15;
                          if (!register_operand (operands[2], E_SImode))
                            return -1;
                          return 258; /* call_gettlsoff */

                        default:
                          return -1;
                        }

                    case 2:
                      if (XINT (x4, 1) != 202
                          || GET_MODE (x4) != E_SImode)
                        return -1;
                      x20 = XVECEXP (x4, 0, 1);
                      if (GET_CODE (x20) != REG
                          || REGNO (x20) != 8
                          || GET_MODE (x20) != E_DImode)
                        return -1;
                      x3 = XEXP (x2, 0);
                      if (GET_CODE (x3) != REG
                          || REGNO (x3) != 9
                          || GET_MODE (x3) != E_SImode
                          || pattern29 (x1) != 0)
                        return -1;
                      x12 = XVECEXP (x4, 0, 0);
                      operands[0] = x12;
                      if (!symbolic_operand (operands[0], E_SImode))
                        return -1;
                      x14 = XVECEXP (x1, 0, 3);
                      x15 = XEXP (x14, 0);
                      operands[1] = x15;
                      if (!register_operand (operands[1], E_SImode))
                        return -1;
                      return 259; /* *tls_indirect_call */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case COND_EXEC:
      return recog_13 (x1, insn, pnum_clobbers);

    case CONST_INT:
      switch (XWINT (x1, 0))
        {
        case 0L:
          return 168; /* nop */

        case 1L:
          return 169; /* fnop */

        case 2L:
          return 170; /* mnop */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x1, 1))
        {
        case 0:
          return 171; /* blockage */

        case 130:
          if (!
#line 6816 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 215; /* mtrap */

        default:
          return -1;
        }

    case PREFETCH:
      x21 = XEXP (x1, 0);
      if (GET_CODE (x21) != UNSPEC
          || XVECLEN (x21, 0) != 1)
        return -1;
      x22 = XEXP (x1, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XEXP (x1, 2);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x21) != E_SImode)
        return -1;
      x24 = XVECEXP (x21, 0, 0);
      operands[0] = x24;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (XINT (x21, 1))
        {
        case 163:
          return 256; /* frv_prefetch0 */

        case 164:
          if (!
#line 7644 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FR500_FR550_BUILTINS))
            return -1;
          return 257; /* frv_prefetch */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
