/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!fpr_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !fpr_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!even_fpr_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !fpr_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !integer_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !integer_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern23 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != i2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_HImode
      || !even_acc_operand (operands[0], E_DImode))
    return -1;
  return 0;
}

int
pattern33 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XINT (x5, 1) != i2
      || GET_MODE (x5) != E_HImode
      || !even_acc_operand (operands[0], E_DImode)
      || !fpr_operand (operands[1], i1)
      || !fpr_operand (operands[2], i1)
      || !accg_operand (operands[4], E_HImode))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      if (!intop_compare_operator (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !icc_operand (operands[0], E_CC_NZmode)
          || GET_MODE (x3) != E_CC_NZmode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!integer_register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      if (!gpr_or_int10_operand (operands[3], E_SImode))
        return -1;
      return 90; /* *combo_intop_compare1 */

    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_CCmode:
          if (pattern22 (x3, 
E_CCmode) == 0)
            return 92; /* cmpsi_cc */
          break;

        case E_CC_UNSmode:
          if (pattern22 (x3, 
E_CC_UNSmode) == 0)
            return 93; /* *cmpsi_cc_uns */
          break;

        case E_CC_FPmode:
          if (fcc_operand (operands[0], E_CC_FPmode)
              && GET_MODE (x3) == E_CC_FPmode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (fpr_operand (operands[1], E_SFmode)
                      && fpr_operand (operands[2], E_SFmode)
                      && 
#line 3519 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                    return 95; /* *cmpsf_cc_fp */
                  break;

                case E_DFmode:
                  if (even_fpr_operand (operands[1], E_DFmode)
                      && even_fpr_operand (operands[2], E_DFmode)
                      && 
#line 3528 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE))
                    return 96; /* *cmpdf_cc_fp */
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      if (!integer_register_operand (operands[1], E_SImode)
          || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !nonimmediate_operand (operands[0], E_CC_NZmode)
          || GET_MODE (x3) != E_CC_NZmode)
        return -1;
      return 94; /* *cmpsi_cc_nz */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  return NULL;
}
