/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!integer_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!integer_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!gpr_or_int12_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !integer_register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !integer_register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!even_fpr_operand (operands[0], E_DFmode)
      || GET_MODE (x1) != E_DFmode
      || !fpr_operand (operands[1], E_DFmode)
      || !fpr_operand (operands[2], E_DFmode))
    return -1;
  return 0;
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!integer_register_operand (operands[0], E_SImode)
          || !minmax_operator (operands[1], E_SImode)
          || !integer_register_operand (operands[2], E_SImode)
          || !gpr_or_int10_operand (operands[3], E_SImode)
          || !icr_operand (operands[5], E_CC_CCRmode))
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_CCmode:
          if (!icc_operand (operands[4], E_CCmode))
            return -1;
          return 0;

        case E_CC_UNSmode:
          if (!icc_operand (operands[4], E_CC_UNSmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SFmode:
      if (pattern27 (
E_SFmode) != 0)
        return -1;
      return 2;

    case E_DFmode:
      if (pattern27 (
E_DFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x3;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!scratch_operand (operands[2], E_CC_CCRmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_CCmode:
          if (!move_destination_operand (operands[0], E_CCmode)
              || !move_source_operand (operands[1], E_CCmode)
              || !
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_in_progress || reload_completed))
            return -1;
          return 28; /* *internal_movcc */

        case E_CC_UNSmode:
          if (!move_destination_operand (operands[0], E_CC_UNSmode)
              || !move_source_operand (operands[1], E_CC_UNSmode)
              || !
#line 2035 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_in_progress || reload_completed))
            return -1;
          return 29; /* *internal_movcc_uns */

        case E_CC_NZmode:
          if (!move_destination_operand (operands[0], E_CC_NZmode)
              || !move_source_operand (operands[1], E_CC_NZmode)
              || !
#line 2100 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_in_progress || reload_completed))
            return -1;
          return 30; /* *internal_movcc_nz */

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x4 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x4))
        {
        case CLOBBER:
          if (!integer_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !integer_register_operand (operands[1], E_DImode)
              || !gpr_or_int10_operand (operands[2], E_DImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!scratch_operand (operands[3], E_CCmode))
            return -1;
          return 54; /* adddi3 */

        case SET:
          x8 = XEXP (x4, 1);
          if (pattern30 (x8) != 0
              || !integer_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !integer_register_operand (operands[1], E_SImode)
              || !gpr_or_int10_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!icc_operand (operands[3], E_CCmode))
            return -1;
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XEXP (x9, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          return 56; /* adddi3_lower */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 5)
            return -1;
          x12 = XVECEXP (x4, 0, 0);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !general_operand (operands[2], E_SImode))
            return -1;
          return 163; /* stack_adjust */

        default:
          return -1;
        }

    case MINUS:
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x4 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x4))
        {
        case CLOBBER:
          if (!integer_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !integer_register_operand (operands[1], E_DImode)
              || !integer_register_operand (operands[2], E_DImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!scratch_operand (operands[3], E_CCmode))
            return -1;
          return 55; /* subdi3 */

        case SET:
          x8 = XEXP (x4, 1);
          if (pattern30 (x8) != 0
              || !integer_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !integer_register_operand (operands[1], E_SImode)
              || !integer_register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!icc_operand (operands[3], E_CCmode))
            return -1;
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XEXP (x9, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          return 58; /* subdi3_lower */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
