/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!integer_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (!int_2word_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!fpr_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!int5_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      if (!integer_register_operand (operands[1], E_DImode)
          || !integer_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!scratch_operand (operands[2], E_CCmode))
        return -1;
      return 0;

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      return 1;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!integer_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      return recog_2 (x1, insn, pnum_clobbers);

    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 1:
          if (GET_MODE (x2) != E_SImode
              || !integer_register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!fcc_operand (operands[1], E_CC_FPmode)
              || !
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HAS_FPRS))
            return -1;
          return 32; /* read_fcc */

        case 101:
          if (GET_MODE (x2) != E_SImode
              || !fpr_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!fpr_operand (operands[1], E_SImode)
              || !
#line 5620 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 174; /* mnot */

        case 107:
          if (GET_MODE (x2) != E_DImode
              || !even_fpr_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!fpr_operand (operands[1], E_SImode)
              || !
#line 5884 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 183; /* munpackh */

        case 109:
          if (GET_MODE (x2) != E_DImode
              || !even_fpr_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!fpr_operand (operands[1], E_SImode)
              || !
#line 5907 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 185; /* mbtoh */

        case 110:
          if (GET_MODE (x2) != E_SImode
              || !fpr_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!even_fpr_operand (operands[1], E_DImode)
              || !
#line 5929 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 187; /* mhtob */

        case 126:
          if (GET_MODE (x2) != E_SImode
              || !fpr_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!acc_operand (operands[1], E_SImode)
              || !
#line 6781 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 211; /* mrdacc */

        case 127:
          if (GET_MODE (x2) != E_SImode
              || !fpr_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!accg_operand (operands[1], E_QImode)
              || !
#line 6789 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 212; /* mrdaccg */

        case 128:
          if (GET_MODE (x2) != E_SImode
              || !acc_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!fpr_operand (operands[1], E_SImode)
              || !
#line 6799 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 213; /* mwtacc */

        case 129:
          if (GET_MODE (x2) != E_QImode
              || !accg_operand (operands[0], E_QImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!fpr_operand (operands[1], E_SImode)
              || !
#line 6807 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 214; /* mwtaccg */

        case 136:
          if (GET_MODE (x2) != E_V4SImode
              || !quad_fpr_operand (operands[0], E_V4SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!even_fpr_operand (operands[1], E_DImode)
              || !
#line 6921 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV1))
            return -1;
          return 221; /* *mdunpackh_internal */

        case 135:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_V4SImode
              || !memory_operand (operands[0], E_V4SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!even_fpr_operand (operands[1], E_DImode)
              || !
#line 6931 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV1))
            return -1;
          *pnum_clobbers = 1;
          return 222; /* mdunpackh */

        case 138:
          if (GET_MODE (x2) != E_V4SImode
              || !quad_fpr_operand (operands[0], E_V4SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!fpr_operand (operands[1], E_SImode)
              || !
#line 6954 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV1))
            return -1;
          return 223; /* *mbtohe_internal */

        case 137:
          if (pnum_clobbers == NULL
              || GET_MODE (x2) != E_V4SImode
              || !memory_operand (operands[0], E_V4SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!fpr_operand (operands[1], E_SImode)
              || !
#line 6964 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV1))
            return -1;
          *pnum_clobbers = 1;
          return 224; /* mbtohe */

        case 142:
          if (GET_MODE (x2) != E_SImode
              || !fpr_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!fpr_operand (operands[1], E_SImode)
              || !
#line 7174 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
            return -1;
          return 230; /* mabshs */

        case 152:
          if (GET_MODE (x2) != E_SImode
              || !fpr_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!int12_operand (operands[1], E_SImode)
              || !
#line 7326 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
            return -1;
          return 244; /* mhdsets */

        case 203:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 3
              || XINT (x5, 1) != 204
              || GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x7 = XVECEXP (x5, 0, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XVECEXP (x5, 0, 2);
          operands[3] = x8;
          if (!symbolic_operand (operands[3], E_SImode))
            return -1;
          return 261; /* tls_tlsdesc_ldd */

        default:
          return -1;
        }

    case 3:
      switch (XINT (x2, 1))
        {
        case 4:
          if (GET_MODE (x2) != E_CC_CCRmode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!cr_operand (operands[0], E_CC_CCRmode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!cr_operand (operands[1], E_CC_CCRmode))
            return -1;
          x9 = XVECEXP (x2, 0, 1);
          operands[2] = x9;
          if (!cr_operand (operands[2], E_CC_CCRmode))
            return -1;
          x10 = XVECEXP (x2, 0, 2);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          return 128; /* *logical_cr */

        case 100:
          if (pattern13 (x1) != 0
              || !
#line 5573 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 172; /* *mlogic */

        case 103:
          if (pattern13 (x1) != 0
              || !
#line 5675 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 177; /* *msath */

        case 104:
          if (pattern13 (x1) != 0
              || !
#line 5734 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 178; /* *maddh */

        case 105:
          if (pattern6 (x1) != 0)
            return -1;
          x10 = XVECEXP (x2, 0, 2);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_SImode)
              || !
#line 5822 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 180; /* *mqaddh */

        case 111:
          if (pattern8 (x1, 
E_SImode) != 0)
            return -1;
          x10 = XVECEXP (x2, 0, 2);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_SImode)
              || !
#line 5973 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 189; /* *mrot */

        case 112:
          if (pattern7 (x1, 
E_SImode) != 0)
            return -1;
          x10 = XVECEXP (x2, 0, 2);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_SImode)
              || !
#line 6023 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
            return -1;
          return 190; /* *mshift */

        case 146:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!even_fpr_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!even_acc_operand (operands[1], E_DImode))
            return -1;
          x9 = XVECEXP (x2, 0, 1);
          operands[2] = x9;
          if (!int6_operand (operands[2], E_SImode))
            return -1;
          x10 = XVECEXP (x2, 0, 2);
          operands[3] = x10;
          if (!accg_operand (operands[3], E_HImode)
              || !
#line 7221 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
            return -1;
          return 234; /* mdcutssi */

        case 169:
          if (pattern14 (x1) != 0
              || !
#line 7554 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FR405_BUILTINS))
            return -1;
          return 248; /* smass */

        case 170:
          if (pattern14 (x1) != 0
              || !
#line 7565 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FR405_BUILTINS))
            return -1;
          return 249; /* smsss */

        default:
          return -1;
        }

    case 4:
      if (XINT (x2, 1) != 125
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!acc_operand (operands[1], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      operands[2] = x9;
      if (!fpr_or_int6_operand (operands[2], E_SImode))
        return -1;
      x10 = XVECEXP (x2, 0, 2);
      operands[3] = x10;
      if (!accg_operand (operands[3], E_QImode))
        return -1;
      x11 = XVECEXP (x2, 0, 3);
      operands[4] = x11;
      if (!const_int_operand (operands[4], E_SImode)
          || !
#line 6761 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
        return -1;
      return 210; /* *mcut */

    default:
      return -1;
    }
}
