/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!fpr_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!fpr_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!symbolic_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern24 (rtx x1, int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != i1)
    return -1;
  return 0;
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !fpr_operand (operands[2], E_SImode)
      || !fpr_operand (operands[3], E_SImode)
      || !fpr_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern39 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XINT (x5, 1) != i1
      || GET_MODE (x5) != E_HImode
      || !even_acc_operand (operands[0], E_DImode)
      || !fpr_operand (operands[1], E_SImode)
      || !fpr_operand (operands[2], E_SImode)
      || !accg_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 2);
  operands[4] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[5] = x7;
  if (!icr_operand (operands[5], E_CC_CCRmode))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern38 (x3, 
E_QImode) != 0
              || !
#line 4374 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
((INTVAL (operands[3]) == 0
    || INTVAL (operands[4]) == 0
    || (IN_RANGE (INTVAL (operands[3]), -2048, 2047)
        && IN_RANGE (INTVAL (operands[4]) - INTVAL (operands[3]), -2048, 2047)))))
            return -1;
          return 131; /* *movqicc_internal2_int */

        case E_HImode:
          if (pattern38 (x3, 
E_HImode) != 0
              || !
#line 4459 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
((INTVAL (operands[3]) == 0
    || INTVAL (operands[4]) == 0
    || (IN_RANGE (INTVAL (operands[3]), -2048, 2047)
        && IN_RANGE (INTVAL (operands[4]) - INTVAL (operands[3]), -2048, 2047)))))
            return -1;
          return 135; /* *movhicc_internal2_int */

        case E_SImode:
          if (pattern38 (x3, 
E_SImode) != 0
              || !
#line 4544 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
((INTVAL (operands[3]) == 0
    || INTVAL (operands[4]) == 0
    || (IN_RANGE (INTVAL (operands[3]), -2048, 2047)
        && IN_RANGE (INTVAL (operands[4]) - INTVAL (operands[3]), -2048, 2047)))))
            return -1;
          return 139; /* *movsicc_internal2_int */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      if (!integer_register_operand (operands[3], E_SFmode)
          || !integer_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !integer_register_operand (operands[4], E_SFmode)
          || !
#line 4629 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(! TARGET_HAS_FPRS))
        return -1;
      return 143; /* *movsfcc_no_fprs_int */

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x3;
          switch (GET_CODE (operands[1]))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (integer_register_operand (operands[0], E_HImode)
                      && int_2word_operand (operands[1], E_HImode)
                      && 
#line 1404 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return gen_split_1 (insn, operands);
                  break;

                case E_SImode:
                  if (integer_register_operand (operands[0], E_SImode)
                      && int_2word_operand (operands[1], E_SImode)
                      && 
#line 1507 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return gen_split_2 (insn, operands);
                  break;

                case E_SFmode:
                  if (integer_register_operand (operands[0], E_SFmode)
                      && int_2word_operand (operands[1], E_SFmode)
                      && 
#line 1686 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return gen_split_10 (insn, operands);
                  break;

                case E_CC_CCRmode:
                  if (cr_operand (operands[0], E_CC_CCRmode)
                      && const_int_operand (operands[1], E_CC_CCRmode)
                      && 
#line 2339 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return gen_split_23 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case SUBREG:
            case MEM:
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && dbl_memory_two_insn_operand (operands[1], E_DImode)
                      && 
#line 1563 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return gen_split_3 (insn, operands);
                  if (odd_reg_operand (operands[0], E_DImode)
                      && memory_operand (operands[1], E_DImode)
                      && 
#line 1570 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return gen_split_4 (insn, operands);
                  break;

                case E_DFmode:
                  if (register_operand (operands[0], E_DFmode)
                      && dbl_memory_two_insn_operand (operands[1], E_DFmode)
                      && 
#line 1770 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return gen_split_11 (insn, operands);
                  if (odd_reg_operand (operands[0], E_DFmode)
                      && memory_operand (operands[1], E_DFmode)
                      && 
#line 1777 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return gen_split_12 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case REG:
              switch (GET_MODE (operands[0]))
                {
                case E_CC_FPmode:
                  if (integer_register_operand (operands[0], E_CC_FPmode)
                      && fcc_operand (operands[1], E_CC_FPmode)
                      && 
#line 2233 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed && TARGET_HAS_FPRS))
                    return gen_split_21 (insn, operands);
                  break;

                case E_CC_CCRmode:
                  if (integer_register_operand (operands[0], E_CC_CCRmode)
                      && cr_operand (operands[1], E_CC_CCRmode)
                      && 
#line 2318 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return gen_split_22 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (dbl_memory_two_insn_operand (operands[0], E_DImode)
                  && reg_or_0_operand (operands[1], E_DImode)
                  && 
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return gen_split_5 (insn, operands);
              if (memory_operand (operands[0], E_DImode)
                  && odd_reg_operand (operands[1], E_DImode)
                  && 
#line 1584 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return gen_split_6 (insn, operands);
              if (!register_operand (operands[0], E_DImode))
                return NULL;
              if (register_operand (operands[1], E_DImode)
                  && 
#line 1591 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed
   && (odd_reg_operand (operands[0], DImode)
       || odd_reg_operand (operands[1], DImode)
       || (integer_register_operand (operands[0], DImode)
	   && integer_register_operand (operands[1], DImode))
       || (!TARGET_DOUBLE
	   && fpr_operand (operands[0], DImode)
	   && fpr_operand (operands[1], DImode)))))
                return gen_split_7 (insn, operands);
              if (const_int_operand (operands[1], E_DImode)
                  && 
#line 1633 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return gen_split_8 (insn, operands);
              if (!const_double_operand (operands[1], E_DImode)
                  || !
#line 1658 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return NULL;
              return gen_split_9 (insn, operands);

            case E_DFmode:
              if (dbl_memory_two_insn_operand (operands[0], E_DFmode)
                  && reg_or_0_operand (operands[1], E_DFmode)
                  && 
#line 1784 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return gen_split_13 (insn, operands);
              if (memory_operand (operands[0], E_DFmode)
                  && odd_reg_operand (operands[1], E_DFmode)
                  && 
#line 1791 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return gen_split_14 (insn, operands);
              if (!register_operand (operands[0], E_DFmode))
                return NULL;
              if (register_operand (operands[1], E_DFmode)
                  && 
#line 1798 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed
   && (odd_reg_operand (operands[0], DFmode)
       || odd_reg_operand (operands[1], DFmode)
       || (integer_register_operand (operands[0], DFmode)
	   && integer_register_operand (operands[1], DFmode))
       || (!TARGET_DOUBLE
	   && fpr_operand (operands[0], DFmode)
	   && fpr_operand (operands[1], DFmode)))))
                return gen_split_15 (insn, operands);
              if (const_int_operand (operands[1], E_DFmode)
                  && 
#line 1840 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return gen_split_16 (insn, operands);
              if (!const_double_operand (operands[1], E_DFmode)
                  || !
#line 1867 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return NULL;
              return gen_split_17 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!integer_register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !integer_register_operand (operands[1], E_QImode)
                  || !
#line 2390 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return NULL;
              return gen_split_24 (insn, operands);

            case E_SImode:
              if (!integer_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return NULL;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (!integer_register_operand (operands[1], E_QImode)
                      || !
#line 2416 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_25 (insn, operands);

                case E_HImode:
                  if (!integer_register_operand (operands[1], E_HImode)
                      || !
#line 2449 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_26 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x5 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x5) != SET)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          x8 = XEXP (x5, 1);
          switch (GET_CODE (x8))
            {
            case REG:
              operands[1] = x8;
              x9 = XEXP (x6, 0);
              operands[2] = x9;
              if (!icr_operand (operands[2], E_CC_CCRmode))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_CCmode:
                  if (!integer_register_operand (operands[0], E_CCmode)
                      || !icc_operand (operands[1], E_CCmode)
                      || !
#line 1987 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_in_progress || reload_completed))
                    return NULL;
                  return gen_split_18 (insn, operands);

                case E_CC_UNSmode:
                  if (!integer_register_operand (operands[0], E_CC_UNSmode)
                      || !icc_operand (operands[1], E_CC_UNSmode)
                      || !
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_in_progress || reload_completed))
                    return NULL;
                  return gen_split_19 (insn, operands);

                case E_CC_NZmode:
                  if (!integer_register_operand (operands[0], E_CC_NZmode)
                      || !icc_operand (operands[1], E_CC_NZmode)
                      || !
#line 2123 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_in_progress || reload_completed))
                    return NULL;
                  return gen_split_20 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (GET_MODE (x8) != E_DImode
                  || !integer_register_operand (operands[0], E_DImode))
                return NULL;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (!integer_register_operand (operands[1], E_DImode))
                return NULL;
              x11 = XEXP (x8, 1);
              operands[2] = x11;
              if (!gpr_or_int10_operand (operands[2], E_DImode))
                return NULL;
              x9 = XEXP (x6, 0);
              operands[3] = x9;
              if (!scratch_operand (operands[3], E_CCmode)
                  || !
#line 2820 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return NULL;
              return gen_split_27 (insn, operands);

            case MINUS:
              if (GET_MODE (x8) != E_DImode
                  || !integer_register_operand (operands[0], E_DImode))
                return NULL;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (!integer_register_operand (operands[1], E_DImode))
                return NULL;
              x11 = XEXP (x8, 1);
              operands[2] = x11;
              if (!integer_register_operand (operands[2], E_DImode))
                return NULL;
              x9 = XEXP (x6, 0);
              operands[3] = x9;
              if (!scratch_operand (operands[3], E_CCmode)
                  || !
#line 2850 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return NULL;
              return gen_split_28 (insn, operands);

            case NEG:
              switch (pattern21 (x1))
                {
                case 0:
                  if (!
#line 2922 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_29 (insn, operands);

                case 1:
                  if (!relational_operator (operands[1], E_SImode))
                    return NULL;
                  x10 = XEXP (x8, 0);
                  x12 = XEXP (x10, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                      || !integer_register_operand (operands[0], E_SImode)
                      || GET_MODE (x8) != E_SImode)
                    return NULL;
                  x13 = XEXP (x10, 0);
                  operands[2] = x13;
                  if (!cc_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x9 = XEXP (x6, 0);
                  operands[3] = x9;
                  if (!cr_operand (operands[3], E_VOIDmode)
                      || !
#line 3817 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_31 (insn, operands);

                default:
                  return NULL;
                }

            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              operands[1] = x8;
              if (!relational_operator (operands[1], E_SImode))
                return NULL;
              x11 = XEXP (x8, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !integer_register_operand (operands[0], E_SImode))
                return NULL;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!cc_operand (operands[2], E_VOIDmode))
                return NULL;
              x9 = XEXP (x6, 0);
              operands[3] = x9;
              if (!cr_operand (operands[3], E_VOIDmode)
                  || !
#line 3784 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return NULL;
              return gen_split_30 (insn, operands);

            case IF_THEN_ELSE:
              x10 = XEXP (x8, 0);
              if (!relational_operator (x10, E_VOIDmode))
                return NULL;
              operands[1] = x10;
              x12 = XEXP (x10, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x13 = XEXP (x10, 0);
              operands[2] = x13;
              if (!cc_operand (operands[2], E_VOIDmode))
                return NULL;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              x14 = XEXP (x8, 2);
              operands[4] = x14;
              x9 = XEXP (x6, 0);
              operands[5] = x9;
              if (!cr_operand (operands[5], E_CC_CCRmode))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern35 (x8, 
E_QImode) != 0
                      || !
#line 4407 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_32 (insn, operands);

                case E_HImode:
                  if (pattern35 (x8, 
E_HImode) != 0
                      || !
#line 4492 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_33 (insn, operands);

                case E_SImode:
                  if (pattern35 (x8, 
E_SImode) != 0
                      || !
#line 4577 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_34 (insn, operands);

                case E_SFmode:
                  if (pattern36 (x8) != 0
                      || !
#line 4642 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_35 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC:
              if (XVECLEN (x8, 0) != 1
                  || !memory_operand (operands[0], E_V4SImode)
                  || GET_MODE (x8) != E_V4SImode)
                return NULL;
              x15 = XVECEXP (x8, 0, 0);
              operands[1] = x15;
              x9 = XEXP (x6, 0);
              operands[2] = x9;
              if (!scratch_operand (operands[2], E_V4SImode))
                return NULL;
              switch (XINT (x8, 1))
                {
                case 135:
                  if (!even_fpr_operand (operands[1], E_DImode)
                      || !
#line 6933 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_41 (insn, operands);

                case 137:
                  if (!fpr_operand (operands[1], E_SImode)
                      || !
#line 6966 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_42 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 3:
          x5 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x5) != SET)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x16 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x16) != CLOBBER)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          x8 = XEXP (x5, 1);
          switch (GET_CODE (x8))
            {
            case ABS:
              if (GET_MODE (x8) != E_SImode
                  || pattern26 (x1) != 0
                  || !
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                return NULL;
              return gen_split_36 (insn, operands);

            case SMIN:
            case SMAX:
            case UMIN:
            case UMAX:
              operands[1] = x8;
              switch (pattern28 (x1))
                {
                case 0:
                  if (!
#line 4720 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_37 (insn, operands);

                case 1:
                  if (!
#line 4761 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_38 (insn, operands);

                case 2:
                  if (!
#line 4802 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_39 (insn, operands);

                case 3:
                  if (!
#line 4843 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed))
                    return NULL;
                  return gen_split_40 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
