/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!even_fpr_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!even_fpr_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!even_fpr_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !even_gpr_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!integer_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != COMPARE
      || GET_MODE (x1) != E_CCmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!integer_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!fcc_operand (operands[1], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      return 99; /* *branch_fp_true */

    case PC:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      return 100; /* *branch_fp_false */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case UNSPEC:
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          switch (XVECLEN (x3, 0))
            {
            case 2:
              if (XINT (x3, 1) != 2
                  || GET_MODE (x3) != E_CC_FPmode)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER
                  || !fcc_operand (operands[0], E_CC_FPmode))
                return -1;
              x6 = XVECEXP (x3, 0, 0);
              operands[1] = x6;
              if (!integer_register_operand (operands[1], E_SImode))
                return -1;
              x7 = XVECEXP (x3, 0, 1);
              operands[2] = x7;
              if (!integer_register_operand (operands[2], E_SImode))
                return -1;
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              if (!integer_register_operand (operands[3], E_SImode)
                  || !
#line 2263 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HAS_FPRS))
                return -1;
              return 33; /* update_fcc */

            case 3:
              x5 = XVECEXP (x1, 0, 1);
              if (pattern20 (x5) != 0)
                return -1;
              x6 = XVECEXP (x3, 0, 0);
              operands[1] = x6;
              x7 = XVECEXP (x3, 0, 1);
              operands[2] = x7;
              x9 = XVECEXP (x3, 0, 2);
              operands[3] = x9;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x5, 0);
              operands[4] = x8;
              switch (XINT (x3, 1))
                {
                case 116:
                  if (pattern33 (x1, 
E_SImode, 
116) != 0
                      || !
#line 6135 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 196; /* *mmulh */

                case 117:
                  if (pattern33 (x1, 
E_SImode, 
117) != 0
                      || !
#line 6209 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 198; /* *mmulxh */

                case 120:
                  if (pattern34 (x1, 
120) != 0
                      || !
#line 6390 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 202; /* *mqmulh */

                case 121:
                  if (pattern34 (x1, 
121) != 0
                      || !
#line 6464 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 204; /* *mqmulxh */

                case 123:
                  if (GET_MODE (x3) != E_SImode)
                    return -1;
                  x10 = XEXP (x5, 1);
                  if (XINT (x10, 1) != 123
                      || GET_MODE (x10) != E_QImode
                      || !acc_operand (operands[0], E_SImode)
                      || !fpr_operand (operands[1], E_SImode)
                      || !fpr_operand (operands[2], E_SImode)
                      || !accg_operand (operands[4], E_QImode)
                      || !
#line 6615 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 207; /* *mcpx */

                case 124:
                  if (pattern33 (x1, 
E_DImode, 
124) != 0
                      || !
#line 6715 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 209; /* *mqcpx */

                default:
                  return -1;
                }

            case 5:
              x5 = XVECEXP (x1, 0, 1);
              if (pattern20 (x5) != 0)
                return -1;
              x7 = XVECEXP (x3, 0, 1);
              operands[1] = x7;
              x9 = XVECEXP (x3, 0, 2);
              operands[2] = x9;
              x11 = XVECEXP (x3, 0, 3);
              operands[3] = x11;
              x12 = XVECEXP (x3, 0, 4);
              operands[4] = x12;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x6 = XVECEXP (x3, 0, 0);
              if (!rtx_equal_p (x6, operands[0]))
                return -1;
              x8 = XEXP (x5, 0);
              if (!rtx_equal_p (x8, operands[3]))
                return -1;
              switch (XINT (x3, 1))
                {
                case 118:
                  if (pattern39 (x1, 
118) != 0
                      || !
#line 6261 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 199; /* *mmach */

                case 119:
                  if (pattern39 (x1, 
119) != 0
                      || !
#line 6343 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 201; /* *mmrdh */

                case 122:
                  if (GET_MODE (x3) != E_V4SImode)
                    return -1;
                  x10 = XEXP (x5, 1);
                  if (XINT (x10, 1) != 122
                      || GET_MODE (x10) != E_V4QImode
                      || !even_acc_operand (operands[0], E_V4SImode)
                      || !even_fpr_operand (operands[1], E_DImode)
                      || !even_fpr_operand (operands[2], E_DImode)
                      || !accg_operand (operands[3], E_V4QImode)
                      || !
#line 6517 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 205; /* *mqmach */

                case 139:
                  if (GET_MODE (x3) != E_V4SImode)
                    return -1;
                  x10 = XEXP (x5, 1);
                  if (XINT (x10, 1) != 139
                      || GET_MODE (x10) != E_V4QImode
                      || !quad_acc_operand (operands[0], E_V4SImode)
                      || !even_fpr_operand (operands[1], E_DImode)
                      || !even_fpr_operand (operands[2], E_DImode)
                      || !accg_operand (operands[3], E_V4QImode)
                      || !
#line 7035 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
                    return -1;
                  return 225; /* *mqmach2 */

                default:
                  return -1;
                }

            case 1:
              switch (XINT (x3, 1))
                {
                case 131:
                  if (GET_MODE (x3) != E_SImode
                      || pattern25 (x1, 
E_QImode, 
131) != 0
                      || !acc_operand (operands[0], E_SImode))
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  x8 = XEXP (x5, 0);
                  operands[1] = x8;
                  if (!accg_operand (operands[1], E_QImode)
                      || !
#line 6828 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 216; /* mclracc_internal */

                case 132:
                  if (GET_MODE (x3) != E_V4SImode
                      || pattern25 (x1, 
E_V4QImode, 
132) != 0
                      || !quad_acc_operand (operands[0], E_V4SImode))
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  x8 = XEXP (x5, 0);
                  operands[1] = x8;
                  if (!accg_operand (operands[1], E_V4QImode)
                      || !
#line 6868 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA && TARGET_ACC_4))
                    return -1;
                  return 218; /* mclracca4_internal */

                case 135:
                  if (GET_MODE (x3) != E_V4SImode)
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != CLOBBER
                      || !memory_operand (operands[0], E_V4SImode))
                    return -1;
                  x6 = XVECEXP (x3, 0, 0);
                  operands[1] = x6;
                  if (!even_fpr_operand (operands[1], E_DImode))
                    return -1;
                  x8 = XEXP (x5, 0);
                  operands[2] = x8;
                  if (!scratch_operand (operands[2], E_V4SImode)
                      || !
#line 6931 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV1))
                    return -1;
                  return 222; /* mdunpackh */

                case 137:
                  if (GET_MODE (x3) != E_V4SImode)
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) != CLOBBER
                      || !memory_operand (operands[0], E_V4SImode))
                    return -1;
                  x6 = XVECEXP (x3, 0, 0);
                  operands[1] = x6;
                  if (!fpr_operand (operands[1], E_SImode))
                    return -1;
                  x8 = XEXP (x5, 0);
                  operands[2] = x8;
                  if (!scratch_operand (operands[2], E_V4SImode)
                      || !
#line 6964 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV1))
                    return -1;
                  return 224; /* mbtohe */

                case 158:
                  if (pattern23 (x1, 
158, 
1) != 0)
                    return -1;
                  x6 = XVECEXP (x3, 0, 0);
                  operands[1] = x6;
                  if (!even_acc_operand (operands[1], E_DImode))
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  x8 = XEXP (x5, 0);
                  operands[2] = x8;
                  if (!accg_operand (operands[2], E_HImode))
                    return -1;
                  x10 = XEXP (x5, 1);
                  x13 = XVECEXP (x10, 0, 0);
                  operands[3] = x13;
                  if (!accg_operand (operands[3], E_HImode)
                      || !
#line 7082 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
                    return -1;
                  return 226; /* masaccs */

                case 140:
                  if (pattern24 (x1, 
2, 
E_SImode) != 0)
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  x10 = XEXP (x5, 1);
                  if (XINT (x10, 1) != 140
                      || GET_MODE (x10) != E_QImode
                      || !acc_operand (operands[0], E_SImode))
                    return -1;
                  x6 = XVECEXP (x3, 0, 0);
                  operands[1] = x6;
                  if (!even_acc_operand (operands[1], E_DImode))
                    return -1;
                  x8 = XEXP (x5, 0);
                  operands[2] = x8;
                  if (!accg_operand (operands[2], E_QImode))
                    return -1;
                  x13 = XVECEXP (x10, 0, 0);
                  operands[3] = x13;
                  if (!accg_operand (operands[3], E_HImode))
                    return -1;
                  x14 = XVECEXP (x10, 0, 1);
                  operands[4] = x14;
                  if (!const_int_operand (operands[4], E_SImode)
                      || !
#line 7095 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
                    return -1;
                  return 227; /* *maddacc */

                case 159:
                  if (pattern24 (x1, 
1, 
E_V4SImode) != 0)
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  x10 = XEXP (x5, 1);
                  if (XINT (x10, 1) != 159
                      || GET_MODE (x10) != E_V4QImode
                      || !quad_acc_operand (operands[0], E_V4SImode))
                    return -1;
                  x6 = XVECEXP (x3, 0, 0);
                  operands[1] = x6;
                  if (!quad_acc_operand (operands[1], E_V4SImode))
                    return -1;
                  x8 = XEXP (x5, 0);
                  operands[2] = x8;
                  if (!accg_operand (operands[2], E_V4QImode))
                    return -1;
                  x13 = XVECEXP (x10, 0, 0);
                  operands[3] = x13;
                  if (!accg_operand (operands[3], E_V4QImode)
                      || !
#line 7141 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
                    return -1;
                  return 228; /* mdasaccs */

                case 141:
                  if (pattern23 (x1, 
141, 
2) != 0)
                    return -1;
                  x6 = XVECEXP (x3, 0, 0);
                  operands[1] = x6;
                  if (!quad_acc_operand (operands[1], E_V4SImode))
                    return -1;
                  x5 = XVECEXP (x1, 0, 1);
                  x8 = XEXP (x5, 0);
                  operands[2] = x8;
                  if (!accg_operand (operands[2], E_HImode))
                    return -1;
                  x10 = XEXP (x5, 1);
                  x13 = XVECEXP (x10, 0, 0);
                  operands[3] = x13;
                  if (!accg_operand (operands[3], E_V4QImode))
                    return -1;
                  x14 = XVECEXP (x10, 0, 1);
                  operands[4] = x14;
                  if (!const_int_operand (operands[4], E_SImode)
                      || !
#line 7154 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA_REV2))
                    return -1;
                  return 229; /* *mdaddacc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          switch (pattern21 (x1))
            {
            case 0:
              return 60; /* negdi2 */

            case 1:
              if (integer_relational_operator (operands[1], E_SImode))
                {
                  x15 = XEXP (x3, 0);
                  x16 = XEXP (x15, 1);
                  if (x16 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
                      && integer_register_operand (operands[0], E_SImode)
                      && GET_MODE (x3) == E_SImode)
                    {
                      x17 = XEXP (x15, 0);
                      operands[2] = x17;
                      if (icc_operand (operands[2], E_VOIDmode))
                        {
                          x8 = XEXP (x5, 0);
                          operands[3] = x8;
                          if (icr_operand (operands[3], E_CC_CCRmode))
                            return 103; /* *scc_neg1_int */
                        }
                    }
                }
              if (!float_relational_operator (operands[1], E_SImode))
                return -1;
              x15 = XEXP (x3, 0);
              x16 = XEXP (x15, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !integer_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x17 = XEXP (x15, 0);
              operands[2] = x17;
              if (!fcc_operand (operands[2], E_CC_FPmode))
                return -1;
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              if (!fcr_operand (operands[3], E_CC_CCRmode))
                return -1;
              return 104; /* *scc_neg1_float */

            default:
              return -1;
            }

        case COMPARE:
          if (GET_MODE (x3) != E_CC_NZmode)
            return -1;
          x15 = XEXP (x3, 0);
          if (!intop_compare_operator (x15, E_SImode))
            return -1;
          operands[1] = x15;
          x18 = XEXP (x3, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x10 = XEXP (x5, 1);
          if (!intop_compare_operator (x10, E_SImode))
            return -1;
          operands[5] = x10;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!icc_operand (operands[0], E_CC_NZmode))
            return -1;
          x17 = XEXP (x15, 0);
          operands[2] = x17;
          if (!integer_register_operand (operands[2], E_SImode))
            return -1;
          x16 = XEXP (x15, 1);
          operands[3] = x16;
          if (!gpr_or_int10_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x5, 0);
          operands[4] = x8;
          if (!integer_register_operand (operands[4], E_SImode))
            return -1;
          x19 = XEXP (x10, 0);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          x20 = XEXP (x10, 1);
          if (!rtx_equal_p (x20, operands[3])
              || !
#line 3469 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(GET_CODE (operands[1]) == GET_CODE (operands[5])))
            return -1;
          return 91; /* *combo_intop_compare2 */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[1] = x3;
          if (integer_relational_operator (operands[1], E_SImode))
            {
              x18 = XEXP (x3, 1);
              if (x18 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x5 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x5) == CLOBBER)
                    {
                      x4 = XEXP (x2, 0);
                      operands[0] = x4;
                      if (integer_register_operand (operands[0], E_SImode))
                        {
                          x15 = XEXP (x3, 0);
                          operands[2] = x15;
                          if (icc_operand (operands[2], E_VOIDmode))
                            {
                              x8 = XEXP (x5, 0);
                              operands[3] = x8;
                              if (icr_operand (operands[3], E_CC_CCRmode))
                                return 101; /* *scc_int */
                            }
                        }
                    }
                }
            }
          if (!float_relational_operator (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x3, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!integer_register_operand (operands[0], E_SImode))
            return -1;
          x15 = XEXP (x3, 0);
          operands[2] = x15;
          if (!fcc_operand (operands[2], E_CC_FPmode))
            return -1;
          x8 = XEXP (x5, 0);
          operands[3] = x8;
          if (!fcr_operand (operands[3], E_CC_CCRmode))
            return -1;
          return 102; /* *scc_float */

        case IF_THEN_ELSE:
          x15 = XEXP (x3, 0);
          switch (GET_CODE (x15))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              operands[1] = x15;
              if (integer_relational_operator (operands[1], E_VOIDmode))
                {
                  res = recog_8 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              x16 = XEXP (x15, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              x17 = XEXP (x15, 0);
              operands[2] = x17;
              if (fcc_operand (operands[2], E_CC_FPmode)
                  && float_relational_operator (operands[1], E_CC_FPmode))
                {
                  x18 = XEXP (x3, 1);
                  operands[3] = x18;
                  x21 = XEXP (x3, 2);
                  operands[4] = x21;
                  x8 = XEXP (x5, 0);
                  operands[5] = x8;
                  if (fcr_operand (operands[5], E_CC_CCRmode))
                    {
                      switch (GET_MODE (operands[0]))
                        {
                        case E_QImode:
                          if (pattern37 (x3, 
E_QImode) == 0
                              && 
#line 4361 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                            return 130; /* *movqicc_internal1_float */
                          break;

                        case E_HImode:
                          if (pattern37 (x3, 
E_HImode) == 0
                              && 
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                            return 134; /* *movhicc_internal1_float */
                          break;

                        case E_SImode:
                          if (pattern37 (x3, 
E_SImode) == 0
                              && 
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                            return 138; /* *movsicc_internal1_float */
                          break;

                        case E_SFmode:
                          if (pattern36 (x3) == 0
                              && 
#line 4616 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                            return 142; /* *movsfcc_hardfloat_float */
                          break;

                        default:
                          break;
                        }
                    }
                }
              if (icc_operand (operands[2], E_VOIDmode)
                  && integer_relational_operator (operands[1], E_VOIDmode))
                {
                  res = recog_9 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (!fcc_operand (operands[2], E_CC_FPmode)
                  || !float_relational_operator (operands[1], E_CC_FPmode))
                return -1;
              x18 = XEXP (x3, 1);
              operands[3] = x18;
              x21 = XEXP (x3, 2);
              operands[4] = x21;
              x8 = XEXP (x5, 0);
              operands[5] = x8;
              if (!fcr_operand (operands[5], E_CC_CCRmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern38 (x3, 
E_QImode) != 0
                      || !
#line 4390 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT
   && (INTVAL (operands[3]) == 0
       || INTVAL (operands[4]) == 0
       || (IN_RANGE (INTVAL (operands[3]), -2048, 2047)
	   && IN_RANGE (INTVAL (operands[4]) - INTVAL (operands[3]), -2048, 2047)))))
                    return -1;
                  return 132; /* *movqicc_internal2_float */

                case E_HImode:
                  if (pattern38 (x3, 
E_HImode) != 0
                      || !
#line 4475 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT
   && (INTVAL (operands[3]) == 0
       || INTVAL (operands[4]) == 0
       || (IN_RANGE (INTVAL (operands[3]), -2048, 2047)
	   && IN_RANGE (INTVAL (operands[4]) - INTVAL (operands[3]), -2048, 2047)))))
                    return -1;
                  return 136; /* *movhicc_internal2_float */

                case E_SImode:
                  if (pattern38 (x3, 
E_SImode) != 0
                      || !
#line 4560 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT
   && (INTVAL (operands[3]) == 0
       || INTVAL (operands[4]) == 0
       || (IN_RANGE (INTVAL (operands[3]), -2048, 2047)
	   && IN_RANGE (INTVAL (operands[4]) - INTVAL (operands[3]), -2048, 2047)))))
                    return -1;
                  return 140; /* *movsicc_internal2_float */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CALL:
          x15 = XEXP (x3, 0);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_QImode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x17 = XEXP (x15, 0);
          operands[1] = x17;
          if (!fdpic_fptr_operand (operands[1], E_DImode))
            return -1;
          x18 = XEXP (x3, 1);
          operands[2] = x18;
          x5 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x5))
            {
            case CLOBBER:
              x8 = XEXP (x5, 0);
              operands[3] = x8;
              if (!lr_operand (operands[3], E_SImode)
                  || !
#line 5065 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FDPIC))
                return -1;
              return 156; /* call_value_fdpicdi */

            case RETURN:
              if (!
#line 5128 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FDPIC))
                return -1;
              return 159; /* sibcall_value_fdpicdi */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          res = recog_10 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          operands[0] = x3;
          if (!address_operand (operands[0], E_SImode)
              || GET_CODE (x4) != PC)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != USE)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x22 = XEXP (x8, 0);
          operands[1] = x22;
          return 166; /* tablejump_insn */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x23 = XEXP (x4, 0);
      operands[0] = x23;
      if (!fdpic_fptr_operand (operands[0], E_DImode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case CLOBBER:
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!lr_operand (operands[2], E_SImode)
              || !
#line 4934 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FDPIC))
            return -1;
          return 151; /* call_fdpicdi */

        case RETURN:
          if (!
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_FDPIC))
            return -1;
          return 154; /* sibcall_fdpicdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
