/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!fpr_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!uint4_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!fpr_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!fpr_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!integer_register_operand (operands[0], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!integer_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!icc_operand (operands[2], E_CCmode))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!icr_operand (operands[3], E_CC_CCRmode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1, machine_mode i1, machine_mode i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XINT (x5, 1) != i3
      || GET_MODE (x5) != i2
      || !even_acc_operand (operands[2], i1))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!icc_operand (operands[2], E_VOIDmode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  x10 = XEXP (x3, 2);
  operands[4] = x10;
  x11 = XEXP (x6, 0);
  operands[5] = x11;
  if (!icr_operand (operands[5], E_CC_CCRmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern37 (x3, 
E_QImode) != 0)
        return -1;
      return 129; /* *movqicc_internal1_int */

    case E_HImode:
      if (pattern37 (x3, 
E_HImode) != 0)
        return -1;
      return 133; /* *movhicc_internal1_int */

    case E_SImode:
      if (pattern37 (x3, 
E_SImode) != 0)
        return -1;
      return 137; /* *movsicc_internal1_int */

    case E_SFmode:
      if (pattern36 (x3) != 0
          || !
#line 4603 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HAS_FPRS))
        return -1;
      return 141; /* *movsfcc_has_fprs_int */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!ccr_eqne_operator (x2, E_VOIDmode))
    return -1;
  operands[0] = x2;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!cr_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case SET:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x7;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!condexec_dest_operand (operands[2], E_QImode)
                  || !condexec_source_operand (operands[3], E_QImode)
                  || !
#line 3876 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(register_operand(operands[2], QImode) || reg_or_0_operand (operands[3], QImode)))
                return -1;
              return 108; /* *cond_exec_movqi */

            case E_HImode:
              if (!condexec_dest_operand (operands[2], E_HImode)
                  || !condexec_source_operand (operands[3], E_HImode)
                  || !
#line 3888 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(register_operand(operands[2], HImode) || reg_or_0_operand (operands[3], HImode)))
                return -1;
              return 109; /* *cond_exec_movhi */

            case E_SImode:
              if (!condexec_dest_operand (operands[2], E_SImode)
                  || !condexec_source_operand (operands[3], E_SImode)
                  || !
#line 3900 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(register_operand(operands[2], SImode) || reg_or_0_operand (operands[3], SImode)))
                return -1;
              return 110; /* *cond_exec_movsi */

            case E_SFmode:
              if (!condexec_dest_operand (operands[2], E_SFmode)
                  || !condexec_source_operand (operands[3], E_SFmode))
                return -1;
              if (
#line 3913 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HAS_FPRS))
                return 111; /* *cond_exec_movsf_has_fprs */
              if (!
#line 3925 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(! TARGET_HAS_FPRS))
                return -1;
              return 112; /* *cond_exec_movsf_no_fprs */

            default:
              return -1;
            }

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
        case ASHIFT:
        case ASHIFTRT:
        case LSHIFTRT:
          operands[3] = x7;
          if (condexec_si_binary_operator (operands[3], E_SImode)
              && integer_register_operand (operands[2], E_SImode))
            {
              x8 = XEXP (x7, 0);
              operands[4] = x8;
              if (integer_register_operand (operands[4], E_SImode))
                {
                  x9 = XEXP (x7, 1);
                  operands[5] = x9;
                  if (integer_register_operand (operands[5], E_SImode))
                    return 113; /* *cond_exec_si_binary1 */
                }
            }
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x9 = XEXP (x7, 1);
          operands[5] = x9;
          switch (GET_CODE (operands[3]))
            {
            case AND:
            case IOR:
            case XOR:
              if (!condexec_si_media_operator (operands[3], E_SImode)
                  || !fpr_operand (operands[2], E_SImode)
                  || !fpr_operand (operands[4], E_SImode)
                  || !fpr_operand (operands[5], E_SImode)
                  || !
#line 3967 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                return -1;
              return 114; /* *cond_exec_si_binary2 */

            case PLUS:
            case MINUS:
              if (!condexec_sf_add_operator (operands[3], E_SFmode)
                  || !fpr_operand (operands[2], E_SFmode)
                  || !fpr_operand (operands[4], E_SFmode)
                  || !fpr_operand (operands[5], E_SFmode)
                  || !
#line 4127 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 123; /* *cond_exec_sf_add */

            default:
              return -1;
            }

        case MULT:
          x8 = XEXP (x7, 0);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x8) != E_DImode)
                return -1;
              x9 = XEXP (x7, 1);
              if (GET_CODE (x9) != SIGN_EXTEND
                  || GET_MODE (x9) != E_DImode
                  || !even_gpr_operand (operands[2], E_DImode)
                  || GET_MODE (x7) != E_DImode)
                return -1;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              if (!integer_register_operand (operands[3], E_SImode))
                return -1;
              x11 = XEXP (x9, 0);
              operands[4] = x11;
              if (!integer_register_operand (operands[4], E_SImode))
                return -1;
              return 115; /* *cond_exec_si_smul */

            case REG:
            case SUBREG:
              operands[3] = x8;
              if (!fpr_operand (operands[3], E_SFmode)
                  || !fpr_operand (operands[2], E_SFmode)
                  || GET_MODE (x7) != E_SFmode)
                return -1;
              x9 = XEXP (x7, 1);
              operands[4] = x9;
              if (!fpr_operand (operands[4], E_SFmode)
                  || !
#line 4148 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 124; /* *cond_exec_sf_mul */

            default:
              return -1;
            }

        case DIV:
        case UDIV:
          operands[3] = x7;
          if (condexec_si_divide_operator (operands[3], E_SImode)
              && integer_register_operand (operands[2], E_SImode))
            {
              x8 = XEXP (x7, 0);
              operands[4] = x8;
              if (integer_register_operand (operands[4], E_SImode))
                {
                  x9 = XEXP (x7, 1);
                  operands[5] = x9;
                  if (integer_register_operand (operands[5], E_SImode))
                    return 116; /* *cond_exec_si_divide */
                }
            }
          if (GET_CODE (x7) != DIV
              || GET_MODE (x7) != E_SFmode
              || !fpr_operand (operands[2], E_SFmode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!fpr_operand (operands[3], E_SFmode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[4] = x9;
          if (!fpr_operand (operands[4], E_SFmode)
              || !
#line 4161 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 125; /* *cond_exec_sf_div */

        case NEG:
        case NOT:
        case ABS:
          if (condexec_si_unary_operator (x7, E_SImode))
            {
              operands[3] = x7;
              if (integer_register_operand (operands[2], E_SImode))
                {
                  x8 = XEXP (x7, 0);
                  operands[4] = x8;
                  if (integer_register_operand (operands[4], E_SImode))
                    return 117; /* *cond_exec_si_unary1 */
                }
            }
          switch (GET_CODE (x7))
            {
            case NOT:
              if (GET_MODE (x7) != E_SImode
                  || !fpr_operand (operands[2], E_SImode))
                return -1;
              x8 = XEXP (x7, 0);
              operands[3] = x8;
              if (!fpr_operand (operands[3], E_SImode)
                  || !
#line 4050 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                return -1;
              return 118; /* *cond_exec_si_unary2 */

            case NEG:
            case ABS:
              operands[3] = x7;
              if (!condexec_sf_conv_operator (operands[3], E_SFmode)
                  || !fpr_operand (operands[2], E_SFmode))
                return -1;
              x8 = XEXP (x7, 0);
              operands[4] = x8;
              if (!fpr_operand (operands[4], E_SFmode)
                  || !
#line 4105 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 122; /* *cond_exec_sf_conv */

            default:
              return -1;
            }

        case COMPARE:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          x9 = XEXP (x7, 1);
          operands[4] = x9;
          switch (GET_MODE (operands[2]))
            {
            case E_CCmode:
              if (pattern31 (x7, 
E_CCmode) == 0
                  && 
#line 4063 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed
   && REGNO (operands[1]) == REGNO (operands[2]) - ICC_FIRST + ICR_FIRST))
                return 119; /* *cond_exec_cmpsi_cc */
              break;

            case E_CC_UNSmode:
              if (pattern31 (x7, 
E_CC_UNSmode) == 0
                  && 
#line 4077 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed
   && REGNO (operands[1]) == REGNO (operands[2]) - ICC_FIRST + ICR_FIRST))
                return 120; /* *cond_exec_cmpsi_cc_uns */
              break;

            case E_CC_FPmode:
              if (fcc_operand (operands[2], E_CC_FPmode)
                  && GET_MODE (x7) == E_CC_FPmode
                  && fpr_operand (operands[3], E_SFmode)
                  && fpr_operand (operands[4], E_SFmode)
                  && 
#line 4186 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed && TARGET_HARD_FLOAT
   && REGNO (operands[1]) == REGNO (operands[2]) - FCC_FIRST + FCR_FIRST))
                return 127; /* *cond_exec_cmpsi_cc_fp */
              break;

            default:
              break;
            }
          if (!integer_register_operand (operands[3], E_SImode)
              || x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !icc_operand (operands[2], E_CC_NZmode)
              || GET_MODE (x7) != E_CC_NZmode
              || !
#line 4091 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_completed
   && REGNO (operands[1]) == REGNO (operands[2]) - ICC_FIRST + ICR_FIRST))
            return -1;
          return 121; /* *cond_exec_cmpsi_cc_nz */

        case SQRT:
          if (GET_MODE (x7) != E_SFmode
              || !fpr_operand (operands[2], E_SFmode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!fpr_operand (operands[3], E_SFmode)
              || !
#line 4173 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 126; /* *cond_exec_sf_sqrt */

        case UNSPEC:
          switch (XVECLEN (x7, 0))
            {
            case 3:
              x12 = XVECEXP (x7, 0, 0);
              operands[3] = x12;
              x13 = XVECEXP (x7, 0, 1);
              operands[4] = x13;
              x14 = XVECEXP (x7, 0, 2);
              operands[5] = x14;
              if (!const_int_operand (operands[5], E_SImode))
                return -1;
              switch (XINT (x7, 1))
                {
                case 100:
                  if (pattern32 (x7) != 0
                      || !
#line 5599 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 173; /* *cond_exec_mlogic */

                case 104:
                  if (pattern32 (x7) != 0
                      || !
#line 5761 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 179; /* *cond_exec_maddh */

                case 105:
                  if (GET_MODE (x7) != E_DImode
                      || !even_fpr_operand (operands[2], E_DImode)
                      || !even_fpr_operand (operands[3], E_DImode)
                      || !even_fpr_operand (operands[4], E_DImode)
                      || !
#line 5849 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 181; /* *cond_exec_mqaddh */

                default:
                  return -1;
                }

            case 1:
              x12 = XVECEXP (x7, 0, 0);
              operands[3] = x12;
              switch (XINT (x7, 1))
                {
                case 101:
                  if (GET_MODE (x7) != E_SImode
                      || !fpr_operand (operands[2], E_SImode)
                      || !fpr_operand (operands[3], E_SImode)
                      || !
#line 5632 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 175; /* *cond_exec_mnot */

                case 109:
                  if (GET_MODE (x7) != E_DImode
                      || !even_fpr_operand (operands[2], E_DImode)
                      || !fpr_operand (operands[3], E_SImode)
                      || !
#line 5920 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 186; /* *cond_exec_mbtoh */

                case 110:
                  if (GET_MODE (x7) != E_SImode
                      || !fpr_operand (operands[2], E_SImode)
                      || !even_fpr_operand (operands[3], E_DImode)
                      || !
#line 5942 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 188; /* *cond_exec_mhtob */

                default:
                  return -1;
                }

            case 2:
              x12 = XVECEXP (x7, 0, 0);
              operands[3] = x12;
              if (!fpr_operand (operands[3], E_SImode))
                return -1;
              x13 = XVECEXP (x7, 0, 1);
              operands[4] = x13;
              if (!uint1_operand (operands[4], E_SImode))
                return -1;
              switch (XINT (x7, 1))
                {
                case 113:
                  if (GET_MODE (x7) != E_SImode
                      || !fpr_operand (operands[2], E_SImode)
                      || !
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 192; /* *cond_exec_mexpdhw */

                case 114:
                  if (GET_MODE (x7) != E_DImode
                      || !even_fpr_operand (operands[2], E_DImode)
                      || !
#line 6086 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                    return -1;
                  return 194; /* *cond_exec_mexpdhd */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PARALLEL:
      if (XVECLEN (x5, 0) != 2)
        return -1;
      x15 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x15) != SET)
        return -1;
      x16 = XEXP (x15, 1);
      if (GET_CODE (x16) != UNSPEC)
        return -1;
      x17 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x17) != SET)
        return -1;
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != UNSPEC
          || XVECLEN (x18, 0) != 1)
        return -1;
      x19 = XVECEXP (x18, 0, 0);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XEXP (x15, 0);
      operands[2] = x20;
      switch (XVECLEN (x16, 0))
        {
        case 3:
          x21 = XVECEXP (x16, 0, 0);
          operands[3] = x21;
          x22 = XVECEXP (x16, 0, 1);
          operands[4] = x22;
          x23 = XVECEXP (x16, 0, 2);
          operands[5] = x23;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x24 = XEXP (x17, 0);
          operands[6] = x24;
          switch (XINT (x16, 1))
            {
            case 116:
              if (pattern40 (x5, 
E_DImode, 
E_HImode, 
116) != 0
                  || !fpr_operand (operands[3], E_SImode)
                  || !fpr_operand (operands[4], E_SImode)
                  || !accg_operand (operands[6], E_HImode)
                  || !
#line 6162 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                return -1;
              return 197; /* *cond_exec_mmulh */

            case 120:
              if (GET_MODE (x16) != E_V4SImode
                  || XINT (x18, 1) != 120
                  || GET_MODE (x18) != E_V4QImode
                  || !quad_acc_operand (operands[2], E_V4SImode)
                  || !even_fpr_operand (operands[3], E_DImode)
                  || !even_fpr_operand (operands[4], E_DImode)
                  || !accg_operand (operands[6], E_V4QImode)
                  || !
#line 6417 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                return -1;
              return 203; /* *cond_exec_mqmulh */

            case 123:
              if (GET_MODE (x16) != E_SImode
                  || XINT (x18, 1) != 123
                  || GET_MODE (x18) != E_QImode
                  || !acc_operand (operands[2], E_SImode)
                  || !fpr_operand (operands[3], E_SImode)
                  || !fpr_operand (operands[4], E_SImode)
                  || !accg_operand (operands[6], E_QImode)
                  || !
#line 6644 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                return -1;
              return 208; /* *cond_exec_mcpx */

            default:
              return -1;
            }

        case 5:
          x22 = XVECEXP (x16, 0, 1);
          operands[3] = x22;
          x23 = XVECEXP (x16, 0, 2);
          operands[4] = x23;
          x25 = XVECEXP (x16, 0, 3);
          operands[5] = x25;
          x26 = XVECEXP (x16, 0, 4);
          operands[6] = x26;
          if (!const_int_operand (operands[6], E_SImode))
            return -1;
          x21 = XVECEXP (x16, 0, 0);
          if (!rtx_equal_p (x21, operands[2]))
            return -1;
          x24 = XEXP (x17, 0);
          if (!rtx_equal_p (x24, operands[5]))
            return -1;
          switch (XINT (x16, 1))
            {
            case 118:
              if (pattern40 (x5, 
E_DImode, 
E_HImode, 
118) != 0
                  || !fpr_operand (operands[3], E_SImode)
                  || !fpr_operand (operands[4], E_SImode)
                  || !accg_operand (operands[5], E_HImode)
                  || !
#line 6290 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                return -1;
              return 200; /* *cond_exec_mmach */

            case 122:
              if (pattern40 (x5, 
E_V4SImode, 
E_V4QImode, 
122) != 0
                  || !even_fpr_operand (operands[3], E_DImode)
                  || !even_fpr_operand (operands[4], E_DImode)
                  || !accg_operand (operands[5], E_V4QImode)
                  || !
#line 6546 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_MEDIA))
                return -1;
              return 206; /* *cond_exec_mqmach */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
