/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fpr_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!fpr_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!uint5_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 171
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 171
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!integer_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!integer_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 8
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 169
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (register_operand (operands[0], E_QImode)
          && frv_load_operand (operands[1], E_QImode))
        return 1; /* *movqi_load */
      if (!move_destination_operand (operands[0], E_QImode)
          || !move_source_operand (operands[1], E_QImode)
          || !
#line 1373 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(register_operand(operands[0], QImode) || reg_or_0_operand (operands[1], QImode)))
        return -1;
      return 2; /* *movqi_internal */

    case E_HImode:
      if (register_operand (operands[0], E_HImode)
          && frv_load_operand (operands[1], E_HImode))
        return 3; /* *movhi_load */
      if (!move_destination_operand (operands[0], E_HImode)
          || !move_source_operand (operands[1], E_HImode)
          || !
#line 1395 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(register_operand(operands[0], HImode) || reg_or_0_operand (operands[1], HImode)))
        return -1;
      return 4; /* *movhi_internal */

    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && frv_load_operand (operands[1], E_SImode))
        return 7; /* *movsi_load */
      if (integer_register_operand (operands[0], E_SImode)
          && got12_operand (operands[1], E_SImode))
        return 8; /* *movsi_got */
      if (move_destination_operand (operands[0], E_SImode)
          && move_source_operand (operands[1], E_SImode)
          && 
#line 1496 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(register_operand (operands[0], SImode) || reg_or_0_operand (operands[1], SImode)))
        return 11; /* *movsi_internal */
      if (!integer_register_operand (operands[0], E_SImode)
          || !int_2word_operand (operands[1], E_SImode))
        return -1;
      return 12; /* *movsi_2word */

    case E_DImode:
      if (!move_destination_operand (operands[0], E_DImode)
          || !move_source_operand (operands[1], E_DImode))
        return -1;
      if (
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_DOUBLE
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
        return 15; /* *movdi_double */
      if (!
#line 1553 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(!TARGET_DOUBLE
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
        return -1;
      return 16; /* *movdi_nodouble */

    case E_SFmode:
      if (register_operand (operands[0], E_SFmode)
          && frv_load_operand (operands[1], E_SFmode)
          && 
#line 1697 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HAS_FPRS))
        return 17; /* *movsf_load_has_fprs */
      if (!move_destination_operand (operands[0], E_SFmode)
          || !move_source_operand (operands[1], E_SFmode))
        return -1;
      if (
#line 1705 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HAS_FPRS
   && (register_operand (operands[0], SFmode) || reg_or_0_operand (operands[1], SFmode))))
        return 18; /* *movsf_internal_has_fprs */
      if (!
#line 1716 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(!TARGET_HAS_FPRS
   && (register_operand (operands[0], SFmode) || reg_or_0_operand (operands[1], SFmode))))
        return -1;
      return 19; /* *movsf_internal_no_fprs */

    case E_DFmode:
      if (!move_destination_operand (operands[0], E_DFmode)
          || !move_source_operand (operands[1], E_DFmode))
        return -1;
      if (
#line 1748 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_DOUBLE
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
        return 22; /* *movdf_double */
      if (!
#line 1760 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(!TARGET_DOUBLE
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
        return -1;
      return 23; /* *movdf_nodouble */

    case E_CCmode:
      if (pnum_clobbers == NULL
          || !move_destination_operand (operands[0], E_CCmode)
          || !move_source_operand (operands[1], E_CCmode)
          || !
#line 1969 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_in_progress || reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 28; /* *internal_movcc */

    case E_CC_UNSmode:
      if (pnum_clobbers == NULL
          || !move_destination_operand (operands[0], E_CC_UNSmode)
          || !move_source_operand (operands[1], E_CC_UNSmode)
          || !
#line 2035 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_in_progress || reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 29; /* *internal_movcc_uns */

    case E_CC_NZmode:
      if (pnum_clobbers == NULL
          || !move_destination_operand (operands[0], E_CC_NZmode)
          || !move_source_operand (operands[1], E_CC_NZmode)
          || !
#line 2100 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(reload_in_progress || reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 30; /* *internal_movcc_nz */

    case E_CC_FPmode:
      if (!movcc_fp_destination_operand (operands[0], E_CC_FPmode)
          || !move_source_operand (operands[1], E_CC_FPmode)
          || !
#line 2159 "../../gcc-15.0.1-20250313/gcc/config/frv/frv.md"
(TARGET_HAS_FPRS && (reload_in_progress || reload_completed)))
        return -1;
      return 31; /* *movcc_fp_internal */

    case E_CC_CCRmode:
      if (!move_destination_operand (operands[0], E_CC_CCRmode)
          || !move_source_operand (operands[1], E_CC_CCRmode))
        return -1;
      return 34; /* movcc_ccr */

    default:
      return -1;
    }
}
