/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!h8300_dst_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !h8300_dst_operand (operands[1], i1)
      || !h8300_src_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!general_operand_dst (operands[0], E_QImode)
          || !general_operand_src (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!general_operand_dst (operands[0], E_HImode)
          || !general_operand_src (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 12
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PRE_MODIFY)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != PLUS)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 7)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
    return -1;
  x8 = XEXP (x1, 1);
  operands[0] = x8;
  switch (GET_MODE (x2))
    {
    case E_QImode:
      return pattern20 (x3, 
E_QImode); /* [-1, 1] */

    case E_HImode:
      res = pattern20 (x3, 
E_HImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x2, 0);
  operands[3] = x7;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  x10 = XEXP (x5, 0);
  operands[0] = x10;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x6, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x6, 1);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_QImode:
      return pattern30 (x3, 
E_QImode); /* [-1, 2] */

    case E_HImode:
      res = pattern30 (x3, 
E_HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_SImode:
      res = pattern30 (x3, 
E_SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 0);
  operands[3] = x6;
  x7 = XEXP (x4, 1);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case UDIV:
      return pattern44 (x1, 
ZERO_EXTEND, 
UMOD); /* [-1, 1] */

    case DIV:
      res = pattern44 (x1, 
SIGN_EXTEND, 
MOD);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !register_operand (operands[0], E_SImode)
      || !iorxor_operator (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode)
      || !register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern77 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !nonmemory_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (pattern77 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern98 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    case E_SImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode
      || !memory_operand (operands[1], E_HImode)
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern135 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern139 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  switch (GET_MODE (x8))
    {
    case E_QImode:
      return pattern138 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern138 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern138 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_MODE (x5) != E_CCCmode
          || !
#line 266 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
        return -1;
      return 147; /* *store_neg_c_qi */

    case E_HImode:
      switch (pattern82 (x2, 
E_HImode))
        {
        case 0:
          if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
            return -1;
          return 148; /* *store_neg_c_hi */

        case 1:
          if (!
#line 558 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 246; /* *store_z_hi_neg */

        default:
          return -1;
        }

    case E_SImode:
      switch (pattern82 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 266 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
            return -1;
          return 149; /* *store_neg_c_si */

        case 1:
          if (!
#line 558 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 248; /* *store_z_si_neg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (XWINT (x6, 0))
            {
            case 2L:
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern100 (x3, 
E_QImode) != 0
                      || !
#line 25 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 41; /* *mova.md:20 */

                case E_HImode:
                  if (pattern100 (x3, 
E_HImode) != 0
                      || !
#line 517 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 95; /* *mova.md:512 */

                default:
                  return -1;
                }

            case 4L:
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern100 (x3, 
E_QImode) != 0
                      || !
#line 43 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 43; /* *mova.md:38 */

                case E_HImode:
                  if (pattern100 (x3, 
E_HImode) != 0
                      || !
#line 535 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 97; /* *mova.md:530 */

                default:
                  return -1;
                }

            case 65536L:
              if (pattern90 (x3) != 0)
                return -1;
              return 570; /* *addsi3_upper */

            case 8388608L:
              if (pnum_clobbers == NULL
                  || pattern90 (x3) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 617; /* *addsi3_shift */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (XWINT (x6, 0))
            {
            case 2L:
              switch (pattern91 (x3))
                {
                case 0:
                  if (!
#line 77 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 47; /* *mova.md:72 */

                case 1:
                  if (!
#line 305 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 72; /* *mova.md:300 */

                case 2:
                  if (!
#line 569 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 101; /* *mova.md:564 */

                default:
                  return -1;
                }

            case 4L:
              switch (pattern91 (x3))
                {
                case 0:
                  if (!
#line 187 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 59; /* *mova.md:182 */

                case 1:
                  if (!
#line 415 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 84; /* *mova.md:410 */

                case 2:
                  if (!
#line 679 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 113; /* *mova.md:674 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_HImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != POST_INC
              || GET_MODE (x9) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SIGN_EXTEND
              || GET_MODE (x6) != E_SImode)
            return -1;
          x10 = XEXP (x6, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_HImode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != POST_INC
              || GET_MODE (x11) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x11, 0);
          operands[2] = x13;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 258 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_MAC))
            return -1;
          return 329; /* *multiply.md:250 */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          switch (XWINT (x6, 0))
            {
            case 1L:
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern100 (x3, 
E_QImode) != 0
                      || !
#line 34 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 42; /* *mova.md:29 */

                case E_HImode:
                  if (pattern100 (x3, 
E_HImode) != 0
                      || !
#line 526 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 96; /* *mova.md:521 */

                default:
                  return -1;
                }

            case 2L:
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern100 (x3, 
E_QImode) != 0
                      || !
#line 52 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 44; /* *mova.md:47 */

                case E_HImode:
                  if (pattern100 (x3, 
E_HImode) != 0
                      || !
#line 544 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 98; /* *mova.md:539 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          switch (XWINT (x6, 0))
            {
            case 1L:
              switch (pattern91 (x3))
                {
                case 0:
                  if (!
#line 132 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 53; /* *mova.md:127 */

                case 1:
                  if (!
#line 360 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 78; /* *mova.md:355 */

                case 2:
                  if (!
#line 624 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 107; /* *mova.md:619 */

                default:
                  return -1;
                }

            case 2L:
              switch (pattern91 (x3))
                {
                case 0:
                  if (!
#line 242 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 65; /* *mova.md:237 */

                case 1:
                  if (!
#line 470 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 90; /* *mova.md:465 */

                case 2:
                  if (!
#line 734 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 119; /* *mova.md:729 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern74 (x3) != 0
              || !immediate_operand (operands[2], E_HImode)
              || !
#line 60 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
            return -1;
          return 45; /* *mova.md:56 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!h8300_dst_operand (operands[1], E_QImode)
                  || !
#line 288 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 70; /* *mova.md:284 */

            case E_HImode:
              if (!h8300_dst_operand (operands[1], E_HImode)
                  || !
#line 552 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 99; /* *mova.md:548 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case MULT:
          x14 = XEXP (x5, 1);
          if (GET_CODE (x14) != CONST_INT)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) == SUBREG
              && known_eq (SUBREG_BYTE (x8), 0))
            {
              res = recog_1 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x8;
          switch (XWINT (x14, 0))
            {
            case 2L:
              switch (XWINT (x6, 0))
                {
                case 510L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern107 (x3, 
E_HImode) != 0
                          || !
#line 115 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return -1;
                      return 51; /* *mova.md:109 */

                    case E_SImode:
                      if (pattern107 (x3, 
E_SImode) != 0
                          || !
#line 343 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return -1;
                      return 76; /* *mova.md:337 */

                    default:
                      return -1;
                    }

                case 131070L:
                  if (pattern107 (x3, 
E_SImode) != 0
                      || !
#line 607 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 105; /* *mova.md:601 */

                default:
                  return -1;
                }

            case 4L:
              switch (XWINT (x6, 0))
                {
                case 1020L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern107 (x3, 
E_HImode) != 0
                          || !
#line 225 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return -1;
                      return 63; /* *mova.md:219 */

                    case E_SImode:
                      if (pattern107 (x3, 
E_SImode) != 0
                          || !
#line 453 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return -1;
                      return 88; /* *mova.md:447 */

                    default:
                      return -1;
                    }

                case 262140L:
                  if (pattern107 (x3, 
E_SImode) != 0
                      || !
#line 717 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 117; /* *mova.md:711 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFT:
          x14 = XEXP (x5, 1);
          if (GET_CODE (x14) != CONST_INT)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) == SUBREG
              && known_eq (SUBREG_BYTE (x8), 0))
            {
              res = recog_2 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x8;
          switch (XWINT (x14, 0))
            {
            case 1L:
              switch (XWINT (x6, 0))
                {
                case 510L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern107 (x3, 
E_HImode) != 0
                          || !
#line 170 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return -1;
                      return 57; /* *mova.md:164 */

                    case E_SImode:
                      if (pattern107 (x3, 
E_SImode) != 0
                          || !
#line 398 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return -1;
                      return 82; /* *mova.md:392 */

                    default:
                      return -1;
                    }

                case 131070L:
                  if (pattern107 (x3, 
E_SImode) != 0
                      || !
#line 662 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 111; /* *mova.md:656 */

                default:
                  return -1;
                }

            case 2L:
              switch (XWINT (x6, 0))
                {
                case 1020L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern107 (x3, 
E_HImode) != 0
                          || !
#line 280 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return -1;
                      return 69; /* *mova.md:274 */

                    case E_SImode:
                      if (pattern107 (x3, 
E_SImode) != 0
                          || !
#line 508 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return -1;
                      return 94; /* *mova.md:502 */

                    default:
                      return -1;
                    }

                case 262140L:
                  if (pattern107 (x3, 
E_SImode) != 0
                      || !
#line 772 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 123; /* *mova.md:766 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern0 (x3, 
E_QImode) != 0)
            return -1;
          if (
#line 16 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(h8300_operands_match_p (operands)))
            return 255; /* *addqi3 */
          if (pnum_clobbers == NULL
              || !
#line 27 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 256; /* *addqi3_flags */

        case E_HImode:
          if (GET_MODE (x3) != E_HImode
              || !h8300_src_operand (operands[2], E_HImode))
            return -1;
          if (register_operand (operands[0], E_HImode)
              && register_operand (operands[1], E_HImode))
            {
              if (
#line 35 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(!TARGET_H8300SX))
                return 258; /* *addhi */
              if (pnum_clobbers != NULL
                  && 
#line 46 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && !TARGET_H8300SX))
                {
                  *pnum_clobbers = 1;
                  return 259; /* *addhi3_flags */
                }
            }
          if (!h8300_dst_operand (operands[0], E_HImode)
              || !h8300_dst_operand (operands[1], E_HImode))
            return -1;
          if (
#line 82 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(TARGET_H8300SX && h8300_operands_match_p (operands)))
            return 261; /* *addhi3_h8sx */
          if (pnum_clobbers == NULL
              || !
#line 93 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && TARGET_H8300SX && h8300_operands_match_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 262; /* *addhi3_h8sx_flags */

        case E_SImode:
          if (pattern0 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 118 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(h8300_operands_match_p (operands)))
            return 264; /* *addsi */
          if (pnum_clobbers == NULL
              || !
#line 129 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 265; /* *addsi_flags */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pattern22 (x3) != 0)
        return -1;
      return 572; /* *addsi3_lshiftrt_16_zexthi */

    default:
      return -1;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      return split_6 (x1, insn);

    case GEU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern15 (x2))
        {
        case 0:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_15 (insn, operands);

        case 1:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_17 (insn, operands);

        case 2:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_19 (insn, operands);

        case 3:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_21 (insn, operands);

        case 4:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_23 (insn, operands);

        case 5:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_25 (insn, operands);

        case 6:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_27 (insn, operands);

        case 7:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_29 (insn, operands);

        case 8:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_31 (insn, operands);

        default:
          return NULL;
        }

    case LTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern15 (x2))
        {
        case 0:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_16 (insn, operands);

        case 1:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_18 (insn, operands);

        case 2:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_20 (insn, operands);

        case 3:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_22 (insn, operands);

        case 4:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_24 (insn, operands);

        case 5:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_26 (insn, operands);

        case 6:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_28 (insn, operands);

        case 7:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_30 (insn, operands);

        case 8:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
            return NULL;
          return gen_split_32 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case LTU:
          switch (pattern24 (x2))
            {
            case 0:
              if (!
#line 369 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
                return NULL;
              return gen_split_33 (insn, operands);

            case 1:
              if (!
#line 369 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
                return NULL;
              return gen_split_34 (insn, operands);

            case 2:
              if (!
#line 369 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
                return NULL;
              return gen_split_35 (insn, operands);

            case 3:
              if (!
#line 369 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
                return NULL;
              return gen_split_36 (insn, operands);

            case 4:
              if (!
#line 369 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
                return NULL;
              return gen_split_37 (insn, operands);

            case 5:
              if (!
#line 369 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
                return NULL;
              return gen_split_38 (insn, operands);

            case 6:
              if (!
#line 369 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
                return NULL;
              return gen_split_39 (insn, operands);

            case 7:
              if (!
#line 369 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
                return NULL;
              return gen_split_40 (insn, operands);

            case 8:
              if (!
#line 369 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed))
                return NULL;
              return gen_split_41 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (pattern52 (x2))
            {
            case 0:
              if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return NULL;
              return gen_split_78 (insn, operands);

            case 1:
              if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return NULL;
              return gen_split_82 (insn, operands);

            case 2:
              if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return NULL;
              return gen_split_80 (insn, operands);

            case 3:
              if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return NULL;
              return gen_split_84 (insn, operands);

            default:
              return NULL;
            }

        case NE:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          switch (pattern52 (x2))
            {
            case 0:
              if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return NULL;
              return gen_split_79 (insn, operands);

            case 1:
              if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return NULL;
              return gen_split_83 (insn, operands);

            case 2:
              if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return NULL;
              return gen_split_81 (insn, operands);

            case 3:
              if (!(
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 478 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return NULL;
              return gen_split_85 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern25 (x2))
            {
            case 0:
              if (!
#line 206 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                return NULL;
              return gen_split_105 (insn, operands);

            case 1:
              if (!
#line 206 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                return NULL;
              return gen_split_106 (insn, operands);

            case 2:
              if (!
#line 206 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                return NULL;
              return gen_split_107 (insn, operands);

            case 3:
              if (!
#line 231 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                return NULL;
              return gen_split_108 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
      return split_4 (x1, insn);

    case EQ:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 401 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(TARGET_H8300S || !optimize_size) && 
#line 403 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_60 (insn, operands);

        case 1:
          if (!(
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_62 (insn, operands);

        case 2:
          if (!(
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_66 (insn, operands);

        case 3:
          if (!(
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_64 (insn, operands);

        case 4:
          if (!(
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_68 (insn, operands);

        case 5:
          if (!(
#line 614 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 616 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_94 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(TARGET_H8300S) && 
#line 415 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_61 (insn, operands);

        case 1:
          if (!(
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_63 (insn, operands);

        case 2:
          if (!(
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_67 (insn, operands);

        case 3:
          if (!(
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_65 (insn, operands);

        case 4:
          if (!(
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 450 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_69 (insn, operands);

        case 5:
          if (!(
#line 614 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 616 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_95 (insn, operands);

        default:
          return NULL;
        }

    case PLUS:
      return split_5 (x1, insn);

    case MINUS:
      switch (pattern1 (x1))
        {
        case 0:
          if (!(
#line 151 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(h8300_operands_match_p (operands)) && 
#line 153 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed)))
            return NULL;
          return gen_split_102 (insn, operands);

        case 1:
          if (!(
#line 170 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(h8300_operands_match_p (operands)) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed)))
            return NULL;
          return gen_split_103 (insn, operands);

        case 2:
          if (!(
#line 170 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(h8300_operands_match_p (operands)) && 
#line 172 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed)))
            return NULL;
          return gen_split_104 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          switch (pattern41 (x2))
            {
            case 0:
              if (!(
#line 22 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX) && 
#line 24 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
( reload_completed)))
                return NULL;
              return gen_split_118 (insn, operands);

            case 1:
              if (!(
#line 74 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
( reload_completed)))
                return NULL;
              return gen_split_120 (insn, operands);

            case 2:
              if (!
#line 44 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
( reload_completed))
                return NULL;
              return gen_split_119 (insn, operands);

            case 3:
              if (!
#line 96 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
( reload_completed))
                return NULL;
              return gen_split_121 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          switch (pattern17 (x2))
            {
            case 0:
              if (!(
#line 173 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX) && 
#line 175 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
( reload_completed)))
                return NULL;
              return gen_split_122 (insn, operands);

            case 1:
              if (!(
#line 173 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX) && 
#line 175 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
( reload_completed)))
                return NULL;
              return gen_split_123 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case TRUNCATE:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != LSHIFTRT
          || GET_MODE (x4) != E_DImode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || GET_MODE (x5) != E_DImode)
        return NULL;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_DImode)
        return NULL;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != SIGN_EXTEND
          || GET_MODE (x7) != E_DImode)
        return NULL;
      x8 = XEXP (x4, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      if (!reg_or_nibble_operand (operands[2], E_SImode)
          || !(
#line 196 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SXMUL) && 
#line 198 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
( reload_completed)))
        return NULL;
      return gen_split_124 (insn, operands);

    case UDIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern17 (x2))
        {
        case 0:
          if (!(
#line 9 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX) && 
#line 11 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
( reload_completed)))
            return NULL;
          return gen_split_125 (insn, operands);

        case 1:
          if (!(
#line 9 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX) && 
#line 11 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
( reload_completed)))
            return NULL;
          return gen_split_126 (insn, operands);

        default:
          return NULL;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern17 (x2))
        {
        case 0:
          if (!(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX) && 
#line 30 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
( reload_completed)))
            return NULL;
          return gen_split_127 (insn, operands);

        case 1:
          if (!(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX) && 
#line 30 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
( reload_completed)))
            return NULL;
          return gen_split_128 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 244 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed))
            return NULL;
          return gen_split_150 (insn, operands);

        case 1:
          if (!
#line 244 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed))
            return NULL;
          return gen_split_151 (insn, operands);

        case 2:
          if (!
#line 244 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed))
            return NULL;
          return gen_split_152 (insn, operands);

        default:
          return NULL;
        }

    case ABS:
      if (GET_MODE (x2) != E_SFmode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 10 "../../gcc-15.0.1-20250313/gcc/config/h8300/other.md"
( reload_completed))
        return NULL;
      return gen_split_153 (insn, operands);

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[0] = x4;
          switch (pattern26 (x1))
            {
            case 0:
              if (
#line 25 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
( reload_completed))
                return gen_split_154 (insn, operands);
              break;

            case 1:
              if (
#line 25 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
( reload_completed))
                return gen_split_155 (insn, operands);
              break;

            case 2:
              if (
#line 25 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
( reload_completed))
                return gen_split_156 (insn, operands);
              break;

            default:
              break;
            }
          if (!eqne_operator (x4, E_VOIDmode))
            return NULL;
          switch (pattern27 (x1))
            {
            case 0:
              if (!(
#line 155 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(INTVAL (operands[2]) < 16) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
( reload_completed)))
                return NULL;
              return gen_split_157 (insn, operands);

            case 1:
              if (!(
#line 155 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(INTVAL (operands[2]) < 16) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
( reload_completed)))
                return NULL;
              return gen_split_158 (insn, operands);

            case 2:
              if (!(
#line 155 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(INTVAL (operands[2]) < 16) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
( reload_completed)))
                return NULL;
              return gen_split_159 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 19 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
( reload_completed))
            return NULL;
          return gen_split_161 (insn, operands);

        case 1:
          if (general_operand_src (operands[1], E_QImode))
            {
              if (
#line 80 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(!TARGET_H8300SX
    && reg_overlap_mentioned_p (operands[0], operands[1])
    && reload_completed))
                return gen_split_164 (insn, operands);
              if (
#line 97 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(!TARGET_H8300SX
    && !reg_overlap_mentioned_p (operands[0], operands[1])
    && reload_completed))
                return gen_split_165 (insn, operands);
            }
          if (register_operand (operands[1], E_QImode)
              && (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(TARGET_H8300SX) && 
#line 113 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
( reload_completed)))
            return gen_split_166 (insn, operands);
          if (!register_operand (operands[1], E_HImode)
              || !
#line 136 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
( reload_completed))
            return NULL;
          return gen_split_167 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
( reload_completed))
            return NULL;
          return gen_split_168 (insn, operands);

        case 1:
          if ((
#line 178 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(!TARGET_H8300SX) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
( reload_completed)))
            return gen_split_169 (insn, operands);
          if (!(
#line 192 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(TARGET_H8300SX) && 
#line 194 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
( reload_completed)))
            return NULL;
          return gen_split_170 (insn, operands);

        case 2:
          if (!
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
( reload_completed))
            return NULL;
          return gen_split_171 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      switch (pattern5 (x1))
        {
        case 0:
          if (!(
#line 24 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
((TARGET_H8300SX)
    && (1 << INTVAL (operands[2])) == INTVAL (operands[3])) && 
#line 27 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
( reload_completed)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 1:
          if (!(
#line 84 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(INTVAL (operands[2]) < 16
    && (1 << INTVAL (operands[2])) == INTVAL (operands[3])) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
( reload_completed)))
            return NULL;
          return gen_split_204 (insn, operands);

        case 2:
          x11 = XEXP (x2, 1);
          switch (XWINT (x11, 0))
            {
            case 1L:
              x12 = XEXP (x2, 2);
              operands[2] = x12;
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !(
#line 55 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(INTVAL (operands[2]) < 16) && 
#line 57 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
( reload_completed)))
                return NULL;
              return gen_split_203 (insn, operands);

            case 8L:
              x12 = XEXP (x2, 2);
              if (GET_CODE (x12) != CONST_INT)
                return NULL;
              switch (XWINT (x12, 0))
                {
                case 8L:
                  if (!
#line 132 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                    return NULL;
                  return gen_split_215 (insn, operands);

                case 16L:
                  if (!
#line 156 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                    return NULL;
                  return gen_split_216 (insn, operands);

                case 23L:
                  if (!
#line 204 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                    return NULL;
                  return gen_split_218 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 3:
          if (!(
#line 294 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(TARGET_H8300SX && INTVAL (operands[2]) + INTVAL (operands[3]) <= 8) && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
( reload_completed)))
            return NULL;
          return gen_split_208 (insn, operands);

        default:
          return NULL;
        }

    case AND:
    case IOR:
    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case AND:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case IOR:
        case XOR:
          switch (GET_CODE (x2))
            {
            case IOR:
              res = split_3 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case XOR:
              switch (pattern53 (x2))
                {
                case 0:
                  if (bit_operand (operands[0], E_QImode)
                      && bit_operand (operands[1], E_QImode)
                      && (
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX || register_operand (operands[0], QImode)
   || single_one_operand (operands[2], QImode)) && 
#line 165 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed && !single_one_operand (operands[2], QImode))))
                    return gen_split_140 (insn, operands);
                  if (h8300_dst_operand (operands[0], E_QImode)
                      && h8300_dst_operand (operands[1], E_QImode)
                      && (
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
                    return gen_split_142 (insn, operands);
                  break;

                case 1:
                  if ((
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
                    return gen_split_145 (insn, operands);
                  break;

                case 2:
                  if ((
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
                    return gen_split_148 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          operands[1] = x2;
          switch (pattern58 (x2))
            {
            case 0:
              if (
#line 419 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                return gen_split_225 (insn, operands);
              break;

            case 1:
              if (
#line 445 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                return gen_split_226 (insn, operands);
              break;

            case 2:
              if (
#line 468 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                return gen_split_227 (insn, operands);
              break;

            case 3:
              if (
#line 492 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                return gen_split_228 (insn, operands);
              break;

            case 4:
              if (
#line 517 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                return gen_split_229 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (!bit_operand (operands[0], E_HImode))
        return NULL;
      switch (pattern28 (x2))
        {
        case 0:
          if (!
#line 234 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
( reload_completed))
            return NULL;
          return gen_split_206 (insn, operands);

        case 1:
          if (!
#line 265 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
( reload_completed))
            return NULL;
          return gen_split_207 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x11 = XEXP (x2, 1);
      if (GET_CODE (x11) != CONST_INT)
        return NULL;
      operands[2] = x11;
      if (pattern59 (x1) == 0)
        {
          x12 = XEXP (x2, 2);
          if (XWINT (x12, 0) == 0L
              && (
#line 1280 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[2]) > 1
   && INTVAL (operands[2]) < (TARGET_H8300S ? 26 - TARGET_H8300SX : 29)
   && (!TARGET_H8300SX || (INTVAL (operands[2]) != 24 && INTVAL (operands[2]) != 17))) && 
#line 1284 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
            return gen_split_258 (insn, operands);
          operands[3] = x12;
          if (const_int_operand (operands[3], E_VOIDmode)
              && (
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
((!h8300_shift_needs_scratch_p (INTVAL (operands[3]), SImode, LSHIFTRT)
    && use_extvsi (INTVAL (operands[2]), INTVAL (operands[3])))) && 
#line 1305 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
            return gen_split_259 (insn, operands);
        }
      if (XWINT (x11, 0) != 1L)
        return NULL;
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
            return NULL;
          return gen_split_260 (insn, operands);

        case 1:
          if (!(
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
            return NULL;
          return gen_split_261 (insn, operands);

        case 2:
          if (!(
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
            return NULL;
          return gen_split_262 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
