/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      return pattern7 (x3); /* [-1, 4] */

    case AND:
      if (pattern8 (x3) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  switch (GET_CODE (operands[0]))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      switch (XWINT (x4, 0))
        {
        case 1L:
          x5 = XEXP (x2, 2);
          operands[1] = x5;
          x6 = XEXP (x1, 1);
          operands[2] = x6;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || !immediate_operand (operands[1], E_HImode)
                  || !register_operand (operands[2], E_HImode))
                return -1;
              return 0;

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !const_int_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case 8L:
          x5 = XEXP (x2, 2);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x1, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case MEM:
      if (!bit_memory_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!immediate_operand (operands[2], E_QImode))
        return -1;
      x5 = XEXP (x2, 2);
      operands[3] = x5;
      if (!immediate_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!eqne_operator (x4, E_VOIDmode))
    return -1;
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XEXP (x4, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x3, 1);
  if (GET_CODE (x8) != LABEL_REF)
    return -1;
  x9 = XEXP (x3, 2);
  if (GET_CODE (x9) != PC)
    return -1;
  x10 = XEXP (x2, 0);
  if (GET_CODE (x10) != PC)
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x5, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x13 = XEXP (x5, 2);
  operands[2] = x13;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x14 = XEXP (x8, 0);
  operands[0] = x14;
  x15 = XEXP (x11, 0);
  operands[4] = x15;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern51 (x1, 
E_HImode); /* [-1, 1] */

    case E_SImode:
      res = pattern51 (x1, 
E_SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 12
      || GET_MODE (x4) != E_CCZNmode)
    return -1;
  return 0;
}

int
pattern67 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  if (!register_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  switch (XWINT (x7, 0))
    {
    case 16L:
      if (XWINT (x3, 0) != 1L)
        return -1;
      x8 = XEXP (x2, 2);
      operands[1] = x8;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x6;
      return 0;

    case 8L:
      if (XWINT (x3, 0) != 8L)
        return -1;
      x8 = XEXP (x2, 2);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      operands[1] = x6;
      return 1;

    default:
      return -1;
    }
}

int
pattern80 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MULT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!reg_or_nibble_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_HImode
          || !h8300_dst_operand (operands[1], E_QImode)
          || !immediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!h8300_dst_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!h8300_dst_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_QImode:
      if (!h8300_dst_operand (operands[1], E_QImode)
          || !h8300_dst_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!h8300_dst_operand (operands[1], E_HImode)
          || !h8300_dst_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!h8300_dst_operand (operands[1], E_SImode)
          || !h8300_dst_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
      || !register_operand (operands[0], E_SImode)
      || !iorxor_operator (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_SImode)
      || !register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !single_one_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  switch (XWINT (x7, 0))
    {
    case 1L:
      x8 = XEXP (x3, 1);
      switch (XWINT (x8, 0))
        {
        case 510L:
          switch (pattern123 (x2))
            {
            case 0:
              if (!
#line 151 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 55; /* *mova.md:145 */

            case 1:
              if (!
#line 379 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 80; /* *mova.md:373 */

            default:
              return -1;
            }

        case 131070L:
          if (pattern124 (x2) != 0
              || !
#line 643 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
            return -1;
          return 109; /* *mova.md:637 */

        default:
          return -1;
        }

    case 2L:
      x8 = XEXP (x3, 1);
      switch (XWINT (x8, 0))
        {
        case 1020L:
          switch (pattern123 (x2))
            {
            case 0:
              if (!
#line 261 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 67; /* *mova.md:255 */

            case 1:
              if (!
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 92; /* *mova.md:483 */

            default:
              return -1;
            }

        case 262140L:
          if (pattern124 (x2) != 0
              || !
#line 753 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
            return -1;
          return 121; /* *mova.md:747 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (pattern19 (x3))
        {
        case 0:
          if (
#line 10 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX && h8300_move_ok (operands[0], operands[1])))
            return 1; /* *movqi */
          if (pnum_clobbers != NULL
              && 
#line 20 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX && h8300_move_ok (operands[0], operands[1])))
            {
              *pnum_clobbers = 1;
              return 2; /* *movqi */
            }
          if (
#line 40 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
            return 4; /* *movqi_h8sx */
          if (pnum_clobbers != NULL
              && 
#line 50 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
            {
              *pnum_clobbers = 1;
              return 5; /* *movqi_h8sx */
            }
          break;

        case 1:
          if (
#line 100 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX
    && h8300_move_ok (operands[0], operands[1])))
            return 10; /* *movhi */
          if (pnum_clobbers != NULL
              && 
#line 111 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX
    && h8300_move_ok (operands[0], operands[1])))
            {
              *pnum_clobbers = 1;
              return 11; /* *movhi */
            }
          if (
#line 132 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
            return 13; /* *movhi_h8sx */
          if (pnum_clobbers != NULL
              && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
            {
              *pnum_clobbers = 1;
              return 14; /* *movhi_h8sx */
            }
          break;

        case 2:
          if (
#line 177 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
((TARGET_H8300S || TARGET_H8300H) && !TARGET_H8300SX
    && h8300_move_ok (operands[0], operands[1])))
            return 19; /* *movsi */
          if (pnum_clobbers != NULL
              && 
#line 188 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
((TARGET_H8300S || TARGET_H8300H) && !TARGET_H8300SX
    && h8300_move_ok (operands[0], operands[1])))
            {
              *pnum_clobbers = 1;
              return 20; /* *movsi_clobber_flags */
            }
          if (
#line 281 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
            return 22; /* *movsi_h8sx */
          if (pnum_clobbers != NULL
              && 
#line 291 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
            {
              *pnum_clobbers = 1;
              return 23; /* *movsi_h8sx_clobber_flags */
            }
          break;

        case 3:
          if (
#line 322 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
            return 25; /* *movsf_h8sx */
          if (pnum_clobbers != NULL
              && 
#line 332 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
            {
              *pnum_clobbers = 1;
              return 26; /* *movsf_h8sx_clobber_flags */
            }
          if (
#line 342 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX
    && (register_operand (operands[0], SFmode)
	|| register_operand (operands[1], SFmode))))
            return 27; /* *movsf */
          if (pnum_clobbers != NULL
              && 
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX
    && (register_operand (operands[0], SFmode)
	|| register_operand (operands[1], SFmode))))
            {
              *pnum_clobbers = 1;
              return 28; /* *movsf_clobber_flags */
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x2) == MEM)
        {
          switch (pattern21 (x1))
            {
            case 0:
              if (
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode))
                return 29; /* *push1_qi */
              if (pnum_clobbers != NULL
                  && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode))
                {
                  *pnum_clobbers = 1;
                  return 33; /* *push1_qi */
                }
              break;

            case 1:
              if (
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode))
                return 31; /* *push1_qi */
              if (pnum_clobbers != NULL
                  && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode))
                {
                  *pnum_clobbers = 1;
                  return 37; /* *push1_qi */
                }
              break;

            case 2:
              if (
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode))
                return 30; /* *push1_hi */
              if (pnum_clobbers != NULL
                  && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode))
                {
                  *pnum_clobbers = 1;
                  return 35; /* *push1_hi */
                }
              break;

            case 3:
              if (
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode))
                return 32; /* *push1_hi */
              if (pnum_clobbers != NULL
                  && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode))
                {
                  *pnum_clobbers = 1;
                  return 39; /* *push1_hi */
                }
              break;

            default:
              break;
            }
        }
      break;

    case STRICT_LOW_PART:
      switch (pattern10 (x1))
        {
        case 0:
          return 7; /* movstrictqi */

        case 1:
          return 16; /* movstricthi */

        default:
          break;
        }
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (jump_address_operand (operands[0], E_HImode)
              && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode))
            return 428; /* *indirect_jump_hi */
          break;

        case E_SImode:
          if (jump_address_operand (operands[0], E_SImode)
              && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode))
            return 429; /* *indirect_jump_si */
          break;

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      switch (pattern11 (x1))
        {
        case 0:
          return 538; /* *bitfield.md:155 */

        case 1:
          if (
#line 12 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16))
            return 548; /* *insv_si_1_n */
          if (pnum_clobbers != NULL
              && 
#line 25 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16))
            {
              *pnum_clobbers = 1;
              return 549; /* *insv_si_1_n_clobber_flags */
            }
          break;

        case 2:
          return 554; /* *insv_si_8_8 */

        case 3:
          if (
#line 320 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(TARGET_H8300SX && INTVAL (operands[2]) + INTVAL (operands[3]) <= 8))
            return 546; /* bfst */
          if (pnum_clobbers != NULL
              && 
#line 333 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(TARGET_H8300SX && INTVAL (operands[2]) + INTVAL (operands[3]) <= 8))
            {
              *pnum_clobbers = 1;
              return 547; /* bfst_clobber_flags */
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      if (GET_CODE (x2) != PC)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      return 425; /* jump */

    case SUBREG:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != LSHIFTRT)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[0] = x2;
      if (!general_operand_dst (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (SUBREG_BYTE (x3))
        {
        case 1:
          if (XWINT (x5, 0) != 8L
              || GET_MODE (x4) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 619; /* *combiner.md:1144 */

        case 3:
          if (GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x5, 0))
            {
            case 8L:
              return 621; /* *combiner.md:1166 */

            case 16L:
              if (pnum_clobbers == NULL)
                return -1;
              *pnum_clobbers = 1;
              return 623; /* *combiner.md:1186 */

            case 24L:
              if (pnum_clobbers == NULL)
                return -1;
              *pnum_clobbers = 1;
              return 625; /* *combiner.md:1209 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  res = recog_26 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  switch (GET_CODE (x3))
    {
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      operands[3] = x3;
      res = recog_27 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      switch (GET_CODE (x3))
        {
        case ASHIFT:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) == REG)
            {
              switch (pattern115 (x1))
                {
                case 0:
                  if (
#line 172 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode, ASHIFT))))
                    return 484; /* *shiftqi_noscratch_clobber_flags */
                  break;

                case 1:
                  if (
#line 244 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, ASHIFT))))
                    return 499; /* *shifthi_noscratch_clobber_flags */
                  break;

                case 2:
                  if (
#line 314 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, ASHIFT))))
                    return 514; /* *shiftsi_noscratch_clobber_flags */
                  break;

                default:
                  break;
                }
            }
          if (!nonmemory_operand (operands[2], E_QImode))
            return -1;
          switch (pattern88 (x1))
            {
            case 0:
              return 490; /* *shiftqi */

            case 1:
              return 505; /* *shifthi */

            case 2:
              return 520; /* *shiftsi */

            default:
              return -1;
            }

        case ASHIFTRT:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) == REG)
            {
              switch (pattern115 (x1))
                {
                case 0:
                  if (
#line 172 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode, ASHIFTRT))))
                    return 485; /* *shiftqi_noscratch_clobber_flags */
                  break;

                case 1:
                  if (
#line 244 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, ASHIFTRT))))
                    return 500; /* *shifthi_noscratch_clobber_flags */
                  break;

                case 2:
                  if (
#line 314 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, ASHIFTRT))))
                    return 515; /* *shiftsi_noscratch_clobber_flags */
                  break;

                default:
                  break;
                }
            }
          if (!nonmemory_operand (operands[2], E_QImode))
            return -1;
          switch (pattern88 (x1))
            {
            case 0:
              return 491; /* *shiftqi */

            case 1:
              return 506; /* *shifthi */

            case 2:
              return 521; /* *shiftsi */

            default:
              return -1;
            }

        case LSHIFTRT:
          x5 = XEXP (x2, 0);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              res = recog_28 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case ZERO_EXTRACT:
              res = recog_29 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != CONST_INT
              || GET_CODE (x5) != ZERO_EXTRACT
              || GET_MODE (x5) != E_SImode)
            return -1;
          x9 = XEXP (x5, 1);
          if (GET_CODE (x9) != CONST_INT
              || pattern104 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          if (!register_operand (x6, E_SImode))
            return -1;
          switch (XWINT (x7, 0))
            {
            case 16L:
              if (XWINT (x9, 0) != 1L)
                return -1;
              x10 = XEXP (x5, 2);
              operands[1] = x10;
              if (!const_int_operand (operands[1], E_SImode))
                return -1;
              operands[2] = x6;
              if (!
#line 73 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16))
                return -1;
              return 553; /* *insv_si_1_n_lshiftrt_16_clobber_flags */

            case 8L:
              if (XWINT (x9, 0) != 8L)
                return -1;
              x10 = XEXP (x5, 2);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
                return -1;
              operands[1] = x6;
              return 557; /* *insv_si_8_8_lshiftrt_8_clobber_flags */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ROTATE:
      x8 = XEXP (x4, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 12
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!immediate_operand (operands[2], E_QImode))
        return -1;
      switch (pattern87 (x3))
        {
        case 0:
          return 529; /* rotlqi3_1_clobber_flags */

        case 1:
          return 530; /* rotlhi3_1_clobber_flags */

        case 2:
          return 531; /* rotlsi3_1_clobber_flags */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (pattern19 (x3))
        {
        case 0:
          if ((
#line 10 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX && h8300_move_ok (operands[0], operands[1])) && 
#line 12 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
            return gen_split_1 (insn, operands);
          if ((
#line 40 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX) && 
#line 42 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
            return gen_split_2 (insn, operands);
          break;

        case 1:
          if ((
#line 100 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX
    && h8300_move_ok (operands[0], operands[1])) && 
#line 103 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
            return gen_split_4 (insn, operands);
          if ((
#line 132 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX) && 
#line 134 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
            return gen_split_5 (insn, operands);
          break;

        case 2:
          if ((
#line 177 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
((TARGET_H8300S || TARGET_H8300H) && !TARGET_H8300SX
    && h8300_move_ok (operands[0], operands[1])) && 
#line 180 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
            return gen_split_7 (insn, operands);
          if ((
#line 281 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
            return gen_split_8 (insn, operands);
          break;

        case 3:
          if ((
#line 322 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX) && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
            return gen_split_9 (insn, operands);
          if ((
#line 342 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX
    && (register_operand (operands[0], SFmode)
	|| register_operand (operands[1], SFmode))) && 
#line 346 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
            return gen_split_10 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x2) == MEM)
        {
          switch (pattern21 (x1))
            {
            case 0:
              if ((
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode) && 
#line 385 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
                return gen_split_11 (insn, operands);
              break;

            case 1:
              if ((
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode) && 
#line 385 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
                return gen_split_13 (insn, operands);
              break;

            case 2:
              if ((
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode) && 
#line 385 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
                return gen_split_12 (insn, operands);
              break;

            case 3:
              if ((
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode) && 
#line 385 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed)))
                return gen_split_14 (insn, operands);
              break;

            default:
              break;
            }
        }
      break;

    case STRICT_LOW_PART:
      switch (pattern10 (x1))
        {
        case 0:
          if (
#line 79 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed))
            return gen_split_3 (insn, operands);
          break;

        case 1:
          if (
#line 157 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
( reload_completed))
            return gen_split_6 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      switch (pattern11 (x1))
        {
        case 0:
          if (
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
( reload_completed))
            return gen_split_205 (insn, operands);
          break;

        case 1:
          if ((
#line 12 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16) && 
#line 14 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
            return gen_split_210 (insn, operands);
          break;

        case 2:
          if (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
            return gen_split_213 (insn, operands);
          break;

        case 3:
          if ((
#line 320 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(TARGET_H8300SX && INTVAL (operands[2]) + INTVAL (operands[3]) <= 8) && 
#line 322 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
( reload_completed)))
            return gen_split_209 (insn, operands);
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SUBREG)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT)
    return NULL;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return NULL;
  operands[0] = x2;
  if (!general_operand_dst (operands[0], E_QImode)
      || GET_MODE (x3) != E_QImode)
    return NULL;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  switch (SUBREG_BYTE (x3))
    {
    case 1:
      if (GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !
#line 1150 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_254 (insn, operands);

    case 3:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 1172 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_255 (insn, operands);

    default:
      return NULL;
    }
}
