/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!h8300_dst_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !h8300_dst_operand (operands[1], E_QImode)
          || !h8300_dst_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (pattern0 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern0 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_nibble_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_no_sp_elim_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !bit_operator (x1, E_HImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_HImode))
    return -1;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x6;
      if (!bit_operand (operands[3], E_HImode))
        return -1;
      operands[4] = x1;
      return 0;

    case ZERO_EXTRACT:
      if (GET_MODE (x6) != E_HImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      operands[5] = x1;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      if (!register_operand (operands[3], E_HImode))
        return -1;
      x9 = XEXP (x6, 2);
      operands[4] = x9;
      if (!immediate_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern44 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x4, 0);
  operands[1] = x10;
  x11 = XEXP (x5, 0);
  operands[2] = x11;
  return pattern43 (x1); /* [-1, 1] */
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!h8300_dst_operand (operands[0], E_QImode)
          || !h8300_src_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!h8300_dst_operand (operands[0], E_HImode)
          || !h8300_src_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!h8300_dst_operand (operands[0], E_SImode)
          || !h8300_src_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern77 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern86 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 12
      || GET_MODE (x6) != E_CCmode)
    return -1;
  return pattern85 (x3); /* [-1, 2] */
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !single_one_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern100 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !h8300_dst_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern111 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!h8300_dst_operand (operands[1], i1)
      || !h8300_src_operand (operands[2], i1)
      || !h8300_dst_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern122 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern122 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (XWINT (x4, 0) != 8L)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != 65280L)
    return -1;
  x6 = XEXP (x1, 1);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_MODE (x5) == E_CCCmode)
    {
      switch (pattern92 (x2))
        {
        case 0:
          if (
#line 287 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
((reload_completed
    && (INTVAL (operands[1]) == 31 || INTVAL (operands[1]) <= 15))))
            return 150; /* *store_shifted_cqi */
          break;

        case 1:
          if (
#line 287 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
((reload_completed
    && (INTVAL (operands[1]) == 31 || INTVAL (operands[1]) <= 15))))
            return 152; /* *store_shifted_chi */
          break;

        case 2:
          if (
#line 287 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
((reload_completed
    && (INTVAL (operands[1]) == 31 || INTVAL (operands[1]) <= 15))))
            return 154; /* *store_shifted_csi */
          break;

        default:
          break;
        }
    }
  x6 = XEXP (x2, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
      || GET_MODE (x5) != E_CCZmode)
    return -1;
  switch (pattern83 (x2))
    {
    case 0:
      if (!
#line 534 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
        return -1;
      return 241; /* *store_z_hi_sb */

    case 1:
      if (!
#line 534 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
        return -1;
      return 243; /* *store_z_si_sb */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (pattern132 (x2) == 0)
    return 355; /* *andorsi3_shift_8 */
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!single_one_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x2, 1);
  operands[4] = x8;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  if (
#line 783 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
((INTVAL (operands[3]) & ~0xffff) == 0))
    return 602; /* *iorsi3_and_ashift */
  if (pnum_clobbers == NULL
      || !
#line 799 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
((INTVAL (operands[3]) & ~0xffff) == 0))
    return -1;
  *pnum_clobbers = 1;
  return 603; /* *iorsi3_and_ashift_clobber_flags */
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern63 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!general_operand_dst (operands[0], E_QImode)
          || !general_operand_src (operands[1], E_QImode))
        return -1;
      if (
#line 20 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX && h8300_move_ok (operands[0], operands[1])))
        return 2; /* *movqi */
      if (!
#line 50 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
        return -1;
      return 5; /* *movqi_h8sx */

    case E_HImode:
      if (!general_operand_dst (operands[0], E_HImode)
          || !general_operand_src (operands[1], E_HImode))
        return -1;
      if (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX
    && h8300_move_ok (operands[0], operands[1])))
        return 11; /* *movhi */
      if (!
#line 142 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
        return -1;
      return 14; /* *movhi_h8sx */

    case E_SImode:
      if (!general_operand_dst (operands[0], E_SImode)
          || !general_operand_src (operands[1], E_SImode))
        return -1;
      if (
#line 188 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
((TARGET_H8300S || TARGET_H8300H) && !TARGET_H8300SX
    && h8300_move_ok (operands[0], operands[1])))
        return 20; /* *movsi_clobber_flags */
      if (!
#line 291 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
        return -1;
      return 23; /* *movsi_h8sx_clobber_flags */

    case E_SFmode:
      if (!general_operand_dst (operands[0], E_SFmode)
          || !general_operand_src (operands[1], E_SFmode))
        return -1;
      if (
#line 332 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
        return 26; /* *movsf_h8sx_clobber_flags */
      if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX
    && (register_operand (operands[0], SFmode)
	|| register_operand (operands[1], SFmode))))
        return -1;
      return 28; /* *movsf_clobber_flags */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  res = recog_20 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PRE_MODIFY)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 7)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 7)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (pattern63 (x9) != 0)
    return -1;
  x10 = XEXP (x2, 1);
  operands[0] = x10;
  switch (GET_MODE (x3))
    {
    case E_QImode:
      switch (pattern143 (x4, 
E_QImode))
        {
        case 0:
          if (!
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode))
            return -1;
          return 33; /* *push1_qi */

        case 1:
          if (!
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode))
            return -1;
          return 37; /* *push1_qi */

        default:
          return -1;
        }

    case E_HImode:
      switch (pattern143 (x4, 
E_HImode))
        {
        case 0:
          if (!
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode))
            return -1;
          return 35; /* *push1_hi */

        case 1:
          if (!
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode))
            return -1;
          return 39; /* *push1_hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
      if (!rtx_equal_p (x3, operands[3]))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      switch (GET_MODE (operands[3]))
        {
        case E_QImode:
          if (!h8sx_unary_shift_operator (operands[3], E_QImode)
              || !h8300_dst_operand (operands[1], E_QImode)
              || !h8300_dst_operand (operands[0], E_QImode)
              || !
#line 91 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 469; /* *shiftrotate.md:82 */

        case E_HImode:
          if (!h8sx_unary_shift_operator (operands[3], E_HImode)
              || !h8300_dst_operand (operands[1], E_HImode)
              || !h8300_dst_operand (operands[0], E_HImode)
              || !
#line 91 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 470; /* *shiftrotate.md:82 */

        case E_SImode:
          if (!h8sx_unary_shift_operator (operands[3], E_SImode)
              || !h8300_dst_operand (operands[1], E_SImode)
              || !h8300_dst_operand (operands[0], E_SImode)
              || !
#line 91 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 471; /* *shiftrotate.md:82 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern86 (x1))
        {
        case 0:
          if (bit_operand (operands[0], E_QImode)
              && bit_operand (operands[1], E_QImode)
              && 
#line 49 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
            return 347; /* *andqi3_2_clobber_flags */
          if (register_operand (operands[0], E_QImode)
              && register_operand (operands[1], E_QImode))
            return 371; /* *andqi3_1 */
          if (!h8300_dst_operand (operands[0], E_QImode)
              || !h8300_dst_operand (operands[1], E_QImode)
              || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 386; /* *andqi3 */

        case 1:
          if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 392; /* *andhi3 */

        case 2:
          if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 398; /* *andsi3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || pattern105 (x1) != 0
          || !
#line 247 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[2]) <= 15
   && UINTVAL (operands[3]) == ((HOST_WIDE_INT_M1U << INTVAL (operands[2]))
				& 0xffff)))
        return -1;
      return 566; /* *andsi3_ashift_n_lower */

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[3] = x5;
      if (single_one_operand (operands[3], E_SImode))
        {
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) == REG
              && REGNO (x7) == 12
              && GET_MODE (x7) == E_CCmode
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              x8 = XEXP (x4, 0);
              operands[1] = x8;
              if (register_operand (operands[1], E_SImode))
                {
                  x9 = XEXP (x4, 1);
                  operands[2] = x9;
                  if (const_int_operand (operands[2], E_SImode)
                      && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(exact_log2 (INTVAL (operands[3])) < 16
   && INTVAL (operands[2]) + exact_log2 (INTVAL (operands[3])) == 31))
                    return 568; /* *andsi3_lshiftrt_n_sb */
                }
            }
        }
      if (XWINT (x5, 0) != 1L
          || pattern113 (x1) != 0)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      if (!immediate_operand (operands[2], E_VOIDmode)
          || !
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX && INTVAL (operands[2]) >= 16))
        return -1;
      return 636; /* *combiner.md:1424 */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      return recog_16 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_15 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_18 (x1, insn, pnum_clobbers);

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
      return recog_17 (x1, insn, pnum_clobbers);

    case EQ:
      return recog_19 (x1, insn, pnum_clobbers);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 12)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          x5 = XEXP (x2, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
              && GET_MODE (x3) == E_CCZNmode
              && GET_MODE (x2) == E_CCZNmode)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (register_operand (operands[0], E_QImode))
                    return 126; /* *tstqi */
                  break;

                case E_HImode:
                  if (register_operand (operands[0], E_HImode))
                    return 127; /* *tsthi */
                  break;

                case E_SImode:
                  if (register_operand (operands[0], E_SImode))
                    return 128; /* *tstsi */
                  break;

                default:
                  break;
                }
            }
          if (GET_MODE (x3) != E_CCmode)
            return -1;
          switch (pattern68 (x5))
            {
            case 0:
              if (!
#line 126 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                return -1;
              return 138; /* *cmpqi */

            case 1:
              if (!
#line 134 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                return -1;
              return 139; /* *cmphi */

            case 2:
              if (!
#line 155 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                return -1;
              return 140; /* cmpsi */

            default:
              return -1;
            }

        case AND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x4, 0);
          operands[0] = x7;
          switch (XWINT (x6, 0))
            {
            case -256L:
              if (GET_MODE (x4) != E_HImode
                  || !register_operand (operands[0], E_HImode))
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCZNmode:
                  if (!
#line 60 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                    return -1;
                  return 129; /* *tsthi_upper */

                case E_CCZmode:
                  if (!
#line 69 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                    return -1;
                  return 130; /* *tsthi_upper_z */

                default:
                  return -1;
                }

            case -65536L:
              if (GET_MODE (x3) != E_CCZNmode
                  || GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || !
#line 78 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                return -1;
              return 131; /* *tstsi_upper */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 12
          && GET_MODE (x3) == E_CCCmode)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x5 = XEXP (x2, 1);
          switch (pattern68 (x5))
            {
            case 0:
              if (
#line 86 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                return 132; /* *cmpqi_c */
              break;

            case 1:
              if (
#line 86 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                return 133; /* *cmphi_c */
              break;

            case 2:
              if (
#line 86 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                return 134; /* *cmpsi_c */
              break;

            default:
              break;
            }
        }
      operands[0] = x3;
      switch (pattern15 (x2))
        {
        case 0:
          return 157; /* *store_c */

        case 1:
          return 159; /* *store_c */

        case 2:
          return 161; /* *store_c */

        case 3:
          return 163; /* *store_c */

        case 4:
          return 165; /* *store_c */

        case 5:
          return 167; /* *store_c */

        case 6:
          return 169; /* *store_c */

        case 7:
          return 171; /* *store_c */

        case 8:
          return 173; /* *store_c */

        default:
          return -1;
        }

    case NE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          if (GET_CODE (x4) == REG
              && REGNO (x4) == 12)
            {
              x5 = XEXP (x2, 1);
              if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern79 (x2))
                    {
                    case 0:
                      if (
#line 235 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                        return 142; /* *store_c_qi */
                      break;

                    case 1:
                      if (
#line 424 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
((TARGET_H8300S || !optimize_size) && reload_completed))
                        return 203; /* *store_z_qi */
                      break;

                    case 2:
                      if (
#line 235 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                        return 144; /* *store_c_hi */
                      break;

                    case 3:
                      if (
#line 501 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                        return 238; /* *store_z_hi */
                      break;

                    case 4:
                      if (
#line 235 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                        return 146; /* *store_c_si */
                      break;

                    case 5:
                      if (
#line 501 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                        return 240; /* *store_z_si */
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[1] = x4;
          switch (pattern7 (x2))
            {
            case 0:
              if (!
#line 413 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(TARGET_H8300S))
                return -1;
              return 202; /* *store_z_i_qi */

            case 1:
              if (!
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return -1;
              return 206; /* *store_z_hi */

            case 2:
              if (!
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return -1;
              return 210; /* *store_z_hi */

            case 3:
              if (!
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return -1;
              return 208; /* *store_z_hi */

            case 4:
              if (!
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return -1;
              return 212; /* *store_z_hi */

            default:
              return -1;
            }

        case AND:
          if (pattern8 (x2) != 0
              || !
#line 614 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 254; /* *store_z */

        default:
          return -1;
        }

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
          x7 = XEXP (x4, 0);
          if (GET_CODE (x7) == REG
              && REGNO (x7) == 12)
            {
              res = recog_7 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x7;
          switch (pattern52 (x2))
            {
            case 0:
              if (!
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return -1;
              return 222; /* *store_z_hi_neg */

            case 1:
              if (!
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return -1;
              return 226; /* *store_z_hi_neg */

            case 2:
              if (!
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return -1;
              return 224; /* *store_z_hi_neg */

            case 3:
              if (!
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return -1;
              return 228; /* *store_z_hi_neg */

            default:
              return -1;
            }

        case LTU:
          switch (pattern24 (x2))
            {
            case 0:
              return 174; /* *store_neg_c */

            case 1:
              return 175; /* *store_neg_c */

            case 2:
              return 176; /* *store_neg_c */

            case 3:
              return 177; /* *store_neg_c */

            case 4:
              return 178; /* *store_neg_c */

            case 5:
              return 179; /* *store_neg_c */

            case 6:
              return 180; /* *store_neg_c */

            case 7:
              return 181; /* *store_neg_c */

            case 8:
              return 182; /* *store_neg_c */

            default:
              return -1;
            }

        case EQ:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (pattern52 (x2))
            {
            case 0:
              if (
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return 221; /* *store_z_hi_neg */
              break;

            case 1:
              if (
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return 225; /* *store_z_hi_neg */
              break;

            case 2:
              if (
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return 223; /* *store_z_hi_neg */
              break;

            case 3:
              if (
#line 476 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return 227; /* *store_z_hi_neg */
              break;

            default:
              break;
            }
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 12
              || GET_MODE (x7) != E_CCZmode)
            return -1;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern83 (x2))
            {
            case 0:
              if (!
#line 558 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return -1;
              return 245; /* *store_z_hi_neg */

            case 1:
              if (!
#line 558 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
                return -1;
              return 247; /* *store_z_si_neg */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (pattern25 (x2))
            {
            case 0:
              return 276; /* *negqi2 */

            case 1:
              return 277; /* *neghi2 */

            case 2:
              return 278; /* *negsi2 */

            case 3:
              return 285; /* *negsf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern15 (x2))
        {
        case 0:
          return 156; /* *store_c */

        case 1:
          return 158; /* *store_c */

        case 2:
          return 160; /* *store_c */

        case 3:
          return 162; /* *store_c */

        case 4:
          return 164; /* *store_c */

        case 5:
          return 166; /* *store_c */

        case 6:
          return 168; /* *store_c */

        case 7:
          return 170; /* *store_c */

        case 8:
          return 172; /* *store_c */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern1 (x1))
        {
        case 0:
          if (
#line 151 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(h8300_operands_match_p (operands)))
            return 267; /* *subqi3 */
          if (pnum_clobbers == NULL
              || !
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 268; /* *subqi3_flags */

        case 1:
          if (
#line 170 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(h8300_operands_match_p (operands)))
            return 270; /* *subhi3 */
          if (pnum_clobbers == NULL
              || !
#line 181 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 272; /* *subhi3_flags */

        case 2:
          if (
#line 170 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(h8300_operands_match_p (operands)))
            return 271; /* *subsi3 */
          if (pnum_clobbers == NULL
              || !
#line 181 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 274; /* *subsi3_flags */

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case LSHIFTRT:
          if (pattern80 (x4, 
SIGN_EXTEND) != 0)
            return -1;
          if (
#line 196 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SXMUL))
            return 325; /* smulsi3_highpart */
          if (pnum_clobbers == NULL
              || !
#line 215 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SXMUL))
            return -1;
          *pnum_clobbers = 1;
          return 326; /* smulsi3_highpart_clobber_flags */

        case ASHIFTRT:
          if (pattern80 (x4, 
ZERO_EXTEND) != 0
              || !
#line 227 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
            return -1;
          return 327; /* umulsi3_highpart */

        default:
          return -1;
        }

    case UDIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern17 (x2))
        {
        case 0:
          if (
#line 9 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return 330; /* udivhi3 */
          if (pnum_clobbers == NULL
              || !
#line 20 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return -1;
          *pnum_clobbers = 1;
          return 332; /* udivhi3_clobber_flags */

        case 1:
          if (
#line 9 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return 331; /* udivsi3 */
          if (pnum_clobbers == NULL
              || !
#line 20 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return -1;
          *pnum_clobbers = 1;
          return 333; /* udivsi3_clobber_flags */

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern17 (x2))
        {
        case 0:
          if (
#line 28 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return 334; /* divhi3 */
          if (pnum_clobbers == NULL
              || !
#line 39 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return -1;
          *pnum_clobbers = 1;
          return 336; /* divhi3_clobber_flags */

        case 1:
          if (
#line 28 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return 335; /* divsi3 */
          if (pnum_clobbers == NULL
              || !
#line 39 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return -1;
          *pnum_clobbers = 1;
          return 337; /* divsi3_clobber_flags */

        default:
          return -1;
        }

    case NOT:
      switch (pattern2 (x1))
        {
        case 0:
          return 400; /* one_cmplqi2 */

        case 1:
          return 401; /* one_cmplhi2 */

        case 2:
          return 402; /* one_cmplsi2 */

        default:
          return -1;
        }

    case ABS:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 409; /* abssf2 */

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[0] = x4;
          switch (pattern26 (x1))
            {
            case 0:
              return 412; /* *branch */

            case 1:
              return 413; /* *branch */

            case 2:
              return 414; /* *branch */

            default:
              break;
            }
          operands[1] = x4;
          if (comparison_operator (operands[1], E_VOIDmode))
            {
              res = recog_8 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (!eqne_operator (x4, E_VOIDmode))
            return -1;
          switch (pattern27 (x1))
            {
            case 0:
              if (!
#line 155 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(INTVAL (operands[2]) < 16))
                return -1;
              return 421; /* *jumpcall.md:146 */

            case 1:
              if (!
#line 155 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(INTVAL (operands[2]) < 16))
                return -1;
              return 422; /* *jumpcall.md:146 */

            case 2:
              if (
#line 155 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(INTVAL (operands[2]) < 16))
                return 423; /* *jumpcall.md:146 */
              if (pnum_clobbers == NULL
                  || !
#line 176 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(INTVAL (operands[2]) >= 16))
                return -1;
              *pnum_clobbers = 1;
              return 424; /* *jumpcall.md:166 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!call_insn_operand (operands[1], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (general_operand (operands[2], E_HImode)
          && (
#line 331 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(!SIBLING_CALL_P (insn)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode)))
        return 432; /* call_value_insn_hi */
      if (general_operand (operands[2], E_SImode)
          && (
#line 331 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(!SIBLING_CALL_P (insn)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode)))
        return 433; /* call_value_insn_si */
      if (general_operand (operands[2], E_HImode)
          && (
#line 401 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(SIBLING_CALL_P (insn)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode)))
        return 436; /* sibcall_value_insn_hi */
      if (!general_operand (operands[2], E_SImode)
          || !(
#line 401 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(SIBLING_CALL_P (insn)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode)))
        return -1;
      return 437; /* sibcall_value_insn_si */

    case ZERO_EXTEND:
      switch (pattern3 (x1))
        {
        case 0:
          return 443; /* *zero_extendqihi2 */

        case 1:
          if (general_operand_src (operands[1], E_QImode)
              && 
#line 72 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(!reload_completed && !TARGET_H8300SX))
            return 446; /* *zero_extendqisi2 */
          if (register_operand (operands[1], E_QImode))
            {
              if (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(TARGET_H8300SX))
                return 447; /* *zero_extendqisi2_h8sx */
              if (pnum_clobbers != NULL
                  && 
#line 121 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(TARGET_H8300SX))
                {
                  *pnum_clobbers = 1;
                  return 448; /* *zero_extendqisi2_h8sx */
                }
            }
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 450; /* *zero_extendhisi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern4 (x1))
        {
        case 0:
          return 453; /* *extendqihi2 */

        case 1:
          if (
#line 178 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(!TARGET_H8300SX))
            return 456; /* *extendqisi2 */
          if (
#line 192 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(TARGET_H8300SX))
            return 457; /* *extendqisi2_h8sx */
          if (pnum_clobbers == NULL
              || !
#line 202 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(TARGET_H8300SX))
            return -1;
          *pnum_clobbers = 1;
          return 458; /* *extendqisi2_h8sx */

        case 2:
          return 460; /* *extendhisi2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern5 (x1))
        {
        case 0:
          if (
#line 24 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
((TARGET_H8300SX)
    && (1 << INTVAL (operands[2])) == INTVAL (operands[3])))
            return 532; /* *bitfield.md:18 */
          if (pnum_clobbers == NULL
              || !
#line 41 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
((TARGET_H8300SX)
    && (1 << INTVAL (operands[2])) == INTVAL (operands[3])))
            return -1;
          *pnum_clobbers = 1;
          return 533; /* *bitfield.md:34 */

        case 1:
          if (
#line 84 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(INTVAL (operands[2]) < 16
    && (1 << INTVAL (operands[2])) == INTVAL (operands[3])))
            return 536; /* *extzv_1_r_inv */
          if (pnum_clobbers == NULL
              || !
#line 101 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(INTVAL (operands[2]) < 16
    && (1 << INTVAL (operands[2])) == INTVAL (operands[3])))
            return -1;
          *pnum_clobbers = 1;
          return 537; /* *extzv_1_r_inv_clobber_flags */

        case 2:
          x5 = XEXP (x2, 1);
          switch (XWINT (x5, 0))
            {
            case 1L:
              x8 = XEXP (x2, 2);
              operands[2] = x8;
              if (!const_int_operand (operands[2], E_VOIDmode))
                return -1;
              if (
#line 55 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(INTVAL (operands[2]) < 16))
                return 534; /* *extzv_1_r */
              if (pnum_clobbers == NULL
                  || !
#line 68 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(INTVAL (operands[2]) < 16))
                return -1;
              *pnum_clobbers = 1;
              return 535; /* *extzv_1_r_clobber_flags */

            case 8L:
              x8 = XEXP (x2, 2);
              if (GET_CODE (x8) != CONST_INT)
                return -1;
              switch (XWINT (x8, 0))
                {
                case 8L:
                  return 558; /* *extzv_8_8 */

                case 16L:
                  return 560; /* *extzv_8_16 */

                case 23L:
                  return 564; /* *extzv_8_23 */

                default:
                  return -1;
                }

            case 16L:
              if (pnum_clobbers == NULL)
                return -1;
              x8 = XEXP (x2, 2);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
                  || !
#line 177 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(TARGET_H8300H))
                return -1;
              *pnum_clobbers = 1;
              return 562; /* *extzv_16_8 */

            default:
              return -1;
            }

        case 3:
          if (
#line 294 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(TARGET_H8300SX && INTVAL (operands[2]) + INTVAL (operands[3]) <= 8))
            return 544; /* bfld */
          if (pnum_clobbers == NULL
              || !
#line 307 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(TARGET_H8300SX && INTVAL (operands[2]) + INTVAL (operands[3]) <= 8))
            return -1;
          *pnum_clobbers = 1;
          return 545; /* bfld_clobber_flags */

        default:
          return -1;
        }

    case AND:
    case IOR:
    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_CODE (x2))
        {
        case AND:
          res = recog_11 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case IOR:
        case XOR:
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!bit_operand (operands[0], E_HImode))
        return -1;
      switch (pattern28 (x2))
        {
        case 0:
          return 540; /* *bitfield.md:225 */

        case 1:
          return 542; /* *bitfield.md:254 */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (pattern59 (x1) == 0)
        {
          x8 = XEXP (x2, 2);
          if (XWINT (x8, 0) == 0L
              && 
#line 1280 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[2]) > 1
   && INTVAL (operands[2]) < (TARGET_H8300S ? 26 - TARGET_H8300SX : 29)
   && (!TARGET_H8300SX || (INTVAL (operands[2]) != 24 && INTVAL (operands[2]) != 17))))
            return 627; /* *extvsi_n_0 */
          operands[3] = x8;
          if (const_int_operand (operands[3], E_VOIDmode)
              && 
#line 1302 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
((!h8300_shift_needs_scratch_p (INTVAL (operands[3]), SImode, LSHIFTRT)
    && use_extvsi (INTVAL (operands[2]), INTVAL (operands[3])))))
            return 628; /* *extvsi_n_n */
        }
      if (XWINT (x5, 0) != 1L)
        return -1;
      switch (pattern60 (x1))
        {
        case 0:
          if (
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX))
            return 629; /* *combiner.md:1323 */
          if (pnum_clobbers == NULL
              || !
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX))
            return -1;
          *pnum_clobbers = 1;
          return 632; /* *combiner.md:1335 */

        case 1:
          if (
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX))
            return 630; /* *combiner.md:1323 */
          if (pnum_clobbers == NULL
              || !
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX))
            return -1;
          *pnum_clobbers = 1;
          return 633; /* *combiner.md:1335 */

        case 2:
          if (
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX))
            return 631; /* *combiner.md:1323 */
          if (pnum_clobbers == NULL
              || !
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX))
            return -1;
          *pnum_clobbers = 1;
          return 634; /* *combiner.md:1335 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
