/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!h8300_dst_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !h8300_dst_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!h8300_dst_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !h8300_dst_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!h8300_dst_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !h8300_dst_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern16 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern16 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  return pattern34 (x6); /* [-1, 1] */
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      operands[2] = x4;
      return pattern38 (x1); /* [-1, 1] */

    case SIGN_EXTEND:
      res = pattern40 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!immediate_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern23 (x1, 
E_QImode); /* [-1, 2] */

    case E_HImode:
      res = pattern23 (x1, 
E_HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_SImode:
      res = pattern23 (x1, 
E_SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 2);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 12
      || GET_MODE (x3) != E_CCZmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern71 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern71 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_CCCmode:
      return 0;

    case E_CCZmode:
      return 1;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode
      || !register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != LSHIFTRT
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != 4194304L)
    return -1;
  return 0;
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != 255L)
    return -1;
  return 0;
}

int
pattern141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_MODE (x5) == E_CCCmode)
    {
      switch (pattern92 (x2))
        {
        case 0:
          if (
#line 287 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
((reload_completed
    && (INTVAL (operands[1]) == 31 || INTVAL (operands[1]) <= 15))))
            return 151; /* *store_shifted_cqi */
          break;

        case 1:
          if (
#line 287 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
((reload_completed
    && (INTVAL (operands[1]) == 31 || INTVAL (operands[1]) <= 15))))
            return 153; /* *store_shifted_chi */
          break;

        case 2:
          if (
#line 287 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
((reload_completed
    && (INTVAL (operands[1]) == 31 || INTVAL (operands[1]) <= 15))))
            return 155; /* *store_shifted_csi */
          break;

        default:
          break;
        }
    }
  x6 = XEXP (x2, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
      || GET_MODE (x5) != E_CCZmode)
    return -1;
  switch (pattern83 (x2))
    {
    case 0:
      if (!
#line 534 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
        return -1;
      return 242; /* *store_z_hi_sb */

    case 1:
      if (!
#line 534 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
        return -1;
      return 244; /* *store_z_si_sb */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern56 (x2))
    {
    case 0:
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 1);
      operands[3] = x4;
      switch (pattern94 (x2))
        {
        case 0:
          return 349; /* *andorqi3 */

        case 1:
          return 350; /* *andorhi3 */

        case 2:
          if (
#line 76 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
((SImode == QImode
    || SImode == HImode
    || (SImode == SImode
	&& (INTVAL (operands[3]) & 0xffff) != 0))))
            return 351; /* *andorsi3 */
          if (pnum_clobbers != NULL
              && 
#line 93 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
((SImode == QImode
    || SImode == HImode
    || (SImode == SImode
	&& (INTVAL (operands[3]) & 0xffff) != 0))))
            {
              *pnum_clobbers = 1;
              return 354; /* *andorsi3_clobber_flags */
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern95 (x2))
        {
        case 0:
          return 595; /* *iorsi3_e2f */

        case 1:
          return 598; /* *iorsi3_w */

        case 2:
          return 613; /* *iorsi2_and_1_lshiftrt_1 */

        default:
          return -1;
        }

    case 1:
      x3 = XEXP (x2, 0);
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 0);
      if (register_operand (x6, E_SImode))
        {
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x6) != SUBREG
          || pattern125 (x2) != 0)
        return -1;
      return 616; /* *iorsi3_ashift_16_ashift_24_mem */

    case 2:
      x3 = XEXP (x2, 0);
      x5 = XEXP (x3, 0);
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (pattern102 (x2) == 0)
        {
          if (
#line 816 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(((INTVAL (operands[3]) << INTVAL (operands[2])) & ~0xffff) == 0))
            return 604; /* *iorsi3_and_lshiftrt */
          if (pnum_clobbers != NULL
              && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(((INTVAL (operands[3]) << INTVAL (operands[2])) & ~0xffff) == 0))
            {
              *pnum_clobbers = 1;
              return 605; /* *iorsi3_and_lshiftrt_clobber_flags */
            }
        }
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT
          || pattern103 (x2) != 0)
        return -1;
      switch (XWINT (x7, 0))
        {
        case 30L:
          if (XWINT (x4, 0) != 2L)
            return -1;
          return 608; /* *iorsi3_and_lshiftrt_n_sb */

        case 9L:
          if (pnum_clobbers == NULL
              || XWINT (x4, 0) != 4194304L)
            return -1;
          *pnum_clobbers = 1;
          return 610; /* *iorsi3_and_lshiftrt_9_sb */

        default:
          return -1;
        }

    case 3:
      if (bit_operand (operands[0], E_QImode)
          && bit_operand (operands[1], E_QImode))
        {
          if (
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX || register_operand (operands[0], QImode)
   || single_one_operand (operands[2], QImode)))
            return 357; /* iorqi3_1 */
          if (pnum_clobbers != NULL
              && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
            {
              *pnum_clobbers = 1;
              return 359; /* *iorqi3_1 */
            }
        }
      if (pnum_clobbers != NULL
          && register_operand (operands[0], E_QImode)
          && register_operand (operands[1], E_QImode))
        {
          if (
#line 186 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
            {
              *pnum_clobbers = 1;
              return 363; /* *iorqi3_1 */
            }
          *pnum_clobbers = 1;
          return 367; /* *iorqi3_1 */
        }
      if (!h8300_dst_operand (operands[0], E_QImode)
          || !h8300_dst_operand (operands[1], E_QImode))
        return -1;
      if (
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
        return 373; /* *logicalqi3 */
      if (pnum_clobbers == NULL
          || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 382; /* *iorqi3 */

    case 4:
      if (
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
        return 376; /* *logicalhi3 */
      if (pnum_clobbers == NULL
          || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 388; /* *iorhi3 */

    case 5:
      if (
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
        return 379; /* *logicalsi3 */
      if (pnum_clobbers == NULL
          || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 394; /* *iorsi3 */

    case 6:
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 1);
      switch (XWINT (x4, 0))
        {
        case 8L:
          if (pattern96 (x2, 
E_HImode) != 0)
            return -1;
          return 584; /* *iorhi3_ashift_8 */

        case 31L:
          if (pattern96 (x2, 
E_SImode) != 0)
            return -1;
          return 600; /* *iorsi3_ashift_31 */

        case 23L:
          if (pnum_clobbers == NULL
              || pattern96 (x2, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 612; /* *iorsi3_shift */

        case 16L:
          if (pattern97 (x2) != 0)
            return -1;
          return 615; /* *iorsi3_ashift_16_ashift_24 */

        default:
          return -1;
        }

    case 7:
      return 586; /* *iorhi3_lshiftrt_8 */

    case 8:
      x8 = XEXP (x2, 1);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      x10 = XEXP (x8, 1);
      switch (XWINT (x10, 0))
        {
        case 8L:
          if (pattern120 (x2, 
E_HImode, 
E_QImode) == 0)
            return 588; /* *iorhi3_two_qi */
          break;

        case 16L:
          if (pattern120 (x2, 
E_SImode, 
E_HImode) == 0)
            return 592; /* *iorsi3_two_hi */
          break;

        default:
          break;
        }
      if (GET_CODE (x9) != SUBREG
          || pattern108 (x2) != 0)
        return -1;
      return 590; /* *iorhi3_two_qi_mem */

    case 9:
      return 597; /* *iorsi3_two_qi_sext */

    case 10:
      return 594; /* *iorsi3_two_qi_zext */

    case 11:
      if (
#line 849 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[2]) < 16))
        return 606; /* *iorsi3_zero_extract */
      if (pnum_clobbers == NULL
          || !
#line 866 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[2]) < 16))
        return -1;
      *pnum_clobbers = 1;
      return 607; /* *iorsi3_zero_extract_clobber_flags */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) == REG)
    {
      switch (pattern115 (x1))
        {
        case 0:
          if (
#line 172 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode, LSHIFTRT))))
            return 486; /* *shiftqi_noscratch_clobber_flags */
          break;

        case 1:
          if (
#line 244 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, LSHIFTRT))))
            return 501; /* *shifthi_noscratch_clobber_flags */
          break;

        case 2:
          if (
#line 314 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, LSHIFTRT))))
            return 516; /* *shiftsi_noscratch_clobber_flags */
          break;

        default:
          break;
        }
    }
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  switch (pattern88 (x1))
    {
    case 0:
      return 492; /* *shiftqi */

    case 1:
      return 507; /* *shifthi */

    case 2:
      return 522; /* *shiftsi */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case XOR:
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 12
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      x11 = XEXP (x5, 2);
      operands[2] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern128 (x5, 
E_HImode) != 0
              || !const_int_operand (operands[3], E_HImode)
              || !const_int_operand (operands[2], E_HImode)
              || !
#line 41 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
((TARGET_H8300SX)
    && (1 << INTVAL (operands[2])) == INTVAL (operands[3])))
            return -1;
          return 533; /* *bitfield.md:34 */

        case E_SImode:
          if (pattern128 (x5, 
E_SImode) != 0
              || !const_int_operand (operands[3], E_VOIDmode)
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 101 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(INTVAL (operands[2]) < 16
    && (1 << INTVAL (operands[2])) == INTVAL (operands[3])))
            return -1;
          return 537; /* *extzv_1_r_inv_clobber_flags */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode)
        return -1;
      switch (XWINT (x7, 0))
        {
        case 1L:
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 12
              || GET_MODE (x8) != E_CCmode)
            return -1;
          x11 = XEXP (x5, 2);
          operands[2] = x11;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 68 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(INTVAL (operands[2]) < 16))
            return -1;
          return 535; /* *extzv_1_r_clobber_flags */

        case 8L:
          x11 = XEXP (x5, 2);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 12
              || GET_MODE (x8) != E_CCmode)
            return -1;
          switch (XWINT (x11, 0))
            {
            case 8L:
              return 559; /* *extzv_8_8_clobber_flags */

            case 16L:
              return 561; /* *extzv_8_16_clobber_flags */

            default:
              return -1;
            }

        case 16L:
          x11 = XEXP (x5, 2);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 177 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(TARGET_H8300H))
            return -1;
          return 562; /* *extzv_16_8 */

        default:
          return -1;
        }

    case MEM:
      operands[1] = x6;
      if (!bit_memory_operand (operands[1], E_QImode)
          || pattern99 (x1, 
E_QImode) != 0)
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!immediate_operand (operands[2], E_QImode))
        return -1;
      x11 = XEXP (x5, 2);
      operands[3] = x11;
      if (!immediate_operand (operands[3], E_QImode)
          || !
#line 307 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(TARGET_H8300SX && INTVAL (operands[2]) + INTVAL (operands[3]) <= 8))
        return -1;
      return 545; /* bfld_clobber_flags */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return NULL;
  operands[3] = x3;
  if (pattern66 (x1) == 0
      && (
#line 35 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16 && INTVAL (operands[3]) < 16) && 
#line 37 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
    return gen_split_211 (insn, operands);
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return NULL;
  switch (pattern67 (x1))
    {
    case 0:
      if (!(
#line 59 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16) && 
#line 61 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
        return NULL;
      return gen_split_212 (insn, operands);

    case 1:
      if (!
#line 107 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_214 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern56 (x2))
    {
    case 0:
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 1);
      operands[3] = x4;
      switch (pattern94 (x2))
        {
        case 0:
          if ((
#line 76 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
((QImode == QImode
    || QImode == HImode
    || (QImode == SImode
	&& (INTVAL (operands[3]) & 0xffff) != 0))) && 
#line 81 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
            return gen_split_135 (insn, operands);
          break;

        case 1:
          if ((
#line 76 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
((HImode == QImode
    || HImode == HImode
    || (HImode == SImode
	&& (INTVAL (operands[3]) & 0xffff) != 0))) && 
#line 81 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
            return gen_split_136 (insn, operands);
          break;

        case 2:
          if ((
#line 76 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
((SImode == QImode
    || SImode == HImode
    || (SImode == SImode
	&& (INTVAL (operands[3]) & 0xffff) != 0))) && 
#line 81 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
            return gen_split_137 (insn, operands);
          break;

        default:
          break;
        }
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      switch (pattern95 (x2))
        {
        case 0:
          if (!
#line 695 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
            return NULL;
          return gen_split_237 (insn, operands);

        case 1:
          if (!
#line 738 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
            return NULL;
          return gen_split_239 (insn, operands);

        case 2:
          if (!
#line 996 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
            return NULL;
          return gen_split_248 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x3 = XEXP (x2, 0);
      x5 = XEXP (x3, 0);
      x6 = XEXP (x5, 0);
      if (register_operand (x6, E_SImode))
        {
          operands[2] = x6;
          if (pattern132 (x2) == 0
              && 
#line 136 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed))
            return gen_split_138 (insn, operands);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (const_int_operand (operands[2], E_SImode))
            {
              x4 = XEXP (x3, 1);
              operands[3] = x4;
              if (single_one_operand (operands[3], E_SImode))
                {
                  x8 = XEXP (x2, 1);
                  operands[4] = x8;
                  if (register_operand (operands[4], E_SImode)
                      && (
#line 783 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
((INTVAL (operands[3]) & ~0xffff) == 0) && 
#line 785 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
                    return gen_split_241 (insn, operands);
                }
            }
        }
      if (GET_CODE (x6) != SUBREG
          || pattern125 (x2) != 0
          || !
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_250 (insn, operands);

    case 2:
      x3 = XEXP (x2, 0);
      x5 = XEXP (x3, 0);
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (pattern102 (x2) == 0
          && (
#line 816 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(((INTVAL (operands[3]) << INTVAL (operands[2])) & ~0xffff) == 0) && 
#line 818 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
        return gen_split_242 (insn, operands);
      if (XWINT (x7, 0) != 30L)
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || pattern103 (x2) != 0
          || !
#line 878 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_244 (insn, operands);

    case 3:
      if (bit_operand (operands[0], E_QImode)
          && bit_operand (operands[1], E_QImode)
          && (
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX || register_operand (operands[0], QImode)
   || single_one_operand (operands[2], QImode)) && 
#line 165 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed && !single_one_operand (operands[2], QImode))))
        return gen_split_139 (insn, operands);
      if (!h8300_dst_operand (operands[0], E_QImode)
          || !h8300_dst_operand (operands[1], E_QImode)
          || !(
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
        return NULL;
      return gen_split_141 (insn, operands);

    case 4:
      if (!(
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
        return NULL;
      return gen_split_144 (insn, operands);

    case 5:
      if (!(
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
        return NULL;
      return gen_split_147 (insn, operands);

    case 6:
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 1);
      switch (XWINT (x4, 0))
        {
        case 8L:
          if (pattern96 (x2, 
E_HImode) != 0
              || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
            return NULL;
          return gen_split_230 (insn, operands);

        case 31L:
          if (pattern96 (x2, 
E_SImode) != 0
              || !
#line 761 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
            return NULL;
          return gen_split_240 (insn, operands);

        case 16L:
          if (pattern97 (x2) != 0
              || !
#line 1021 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
            return NULL;
          return gen_split_249 (insn, operands);

        default:
          return NULL;
        }

    case 7:
      if (!
#line 566 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_231 (insn, operands);

    case 8:
      x8 = XEXP (x2, 1);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      x10 = XEXP (x8, 1);
      switch (XWINT (x10, 0))
        {
        case 8L:
          if (pattern120 (x2, 
E_HImode, 
E_QImode) == 0
              && 
#line 589 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
            return gen_split_232 (insn, operands);
          break;

        case 16L:
          if (pattern120 (x2, 
E_SImode, 
E_HImode) == 0
              && 
#line 651 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
            return gen_split_235 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x9) != SUBREG
          || pattern108 (x2) != 0)
        return NULL;
      if (
#line 612 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return gen_split_233 (insn, operands);
      if (!
#line 634 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(reload_completed
   && byte_accesses_mergeable_p (XEXP (operands[2], 0), XEXP (operands[1], 0))))
        return NULL;
      return gen_split_234 (insn, operands);

    case 9:
      if (!
#line 719 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_238 (insn, operands);

    case 10:
      if (!
#line 675 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_236 (insn, operands);

    case 11:
      if (!(
#line 849 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[2]) < 16) && 
#line 851 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
        return NULL;
      return gen_split_243 (insn, operands);

    default:
      return NULL;
    }
}
