/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !general_operand_src (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern23 (x1, 
E_QImode); /* [-1, 2] */

    case E_HImode:
      res = pattern23 (x1, 
E_HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_SImode:
      res = pattern23 (x1, 
E_SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_QImode)
          || !register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode)
          || !register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (GET_MODE (x1) != E_QImode
          || !h8300_src_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (pattern0 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern0 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern52 (x1); /* [-1, 3] */
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern74 (x1); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!h8300_dst_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!h8300_dst_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (GET_MODE (x1) != E_QImode
          || !h8300_src_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (pattern84 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern84 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern93 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern93 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern93 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_SImode)
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  if (!single_one_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern112 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[0] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_QImode:
      if (!h8300_src_operand (operands[2], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (pattern111 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern111 (x3, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_QImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      return pattern135 (x6, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern135 (x6, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (pattern135 (x6, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XWINT (x5, 0))
        {
        case 1L:
          switch (pattern75 (x3))
            {
            case 0:
              if (!
#line 123 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 52; /* *mova.md:119 */

            case 1:
              if (!
#line 351 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 77; /* *mova.md:347 */

            case 2:
              if (!
#line 615 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 106; /* *mova.md:611 */

            default:
              return -1;
            }

        case 2L:
          switch (pattern75 (x3))
            {
            case 0:
              if (!
#line 233 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 64; /* *mova.md:229 */

            case 1:
              if (!
#line 461 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 89; /* *mova.md:457 */

            case 2:
              if (!
#line 725 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 118; /* *mova.md:721 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 12)
        {
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      operands[1] = x6;
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 213; /* *store_z_hi_sb */

        case 1:
          if (!
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 217; /* *store_z_hi_sb */

        case 2:
          if (!
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 215; /* *store_z_hi_sb */

        case 3:
          if (!
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 219; /* *store_z_hi_sb */

        default:
          return -1;
        }

    case NE:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 12)
        {
          res = recog_4 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      operands[1] = x6;
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 214; /* *store_z_hi_sb */

        case 1:
          if (!
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 218; /* *store_z_hi_sb */

        case 2:
          if (!
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 216; /* *store_z_hi_sb */

        case 3:
          if (!
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 220; /* *store_z_hi_sb */

        default:
          return -1;
        }

    case GEU:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 183; /* *store_shifted_c */

        case 1:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 185; /* *store_shifted_c */

        case 2:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 187; /* *store_shifted_c */

        case 3:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 189; /* *store_shifted_c */

        case 4:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 191; /* *store_shifted_c */

        case 5:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 193; /* *store_shifted_c */

        case 6:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 195; /* *store_shifted_c */

        case 7:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 197; /* *store_shifted_c */

        case 8:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 199; /* *store_shifted_c */

        default:
          return -1;
        }

    case LTU:
      switch (pattern48 (x3))
        {
        case 0:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 184; /* *store_shifted_c */

        case 1:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 186; /* *store_shifted_c */

        case 2:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 188; /* *store_shifted_c */

        case 3:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 190; /* *store_shifted_c */

        case 4:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 192; /* *store_shifted_c */

        case 5:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 194; /* *store_shifted_c */

        case 6:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 196; /* *store_shifted_c */

        case 7:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 198; /* *store_shifted_c */

        case 8:
          if (!
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15))
            return -1;
          return 200; /* *store_shifted_c */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern49 (x3) != 0)
        return -1;
      return 618; /* *ashiftsi_sextqi_7 */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern63 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!h8300_dst_operand (operands[0], E_QImode)
          || !h8sx_unary_shift_operator (operands[3], E_QImode)
          || !h8300_dst_operand (operands[1], E_QImode)
          || !
#line 70 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
        return -1;
      return 466; /* *shiftrotate.md:64 */

    case E_HImode:
      if (!h8300_dst_operand (operands[0], E_HImode)
          || !h8sx_unary_shift_operator (operands[3], E_HImode)
          || !h8300_dst_operand (operands[1], E_HImode)
          || !
#line 70 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
        return -1;
      return 467; /* *shiftrotate.md:64 */

    case E_SImode:
      if (!h8300_dst_operand (operands[0], E_SImode)
          || !h8sx_unary_shift_operator (operands[3], E_SImode)
          || !h8300_dst_operand (operands[1], E_SImode)
          || !
#line 70 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
        return -1;
      return 468; /* *shiftrotate.md:64 */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCZNmode
      || pattern62 (x2) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x6;
          operands[1] = x5;
          x7 = XEXP (x4, 1);
          if (rtx_equal_p (x7, operands[1]))
            {
              if (general_operand_src (operands[1], E_QImode)
                  && general_operand_dst (operands[0], E_QImode))
                {
                  if (
#line 20 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX && h8300_move_ok (operands[0], operands[1])))
                    return 3; /* *movqi_cczn */
                  if (
#line 50 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
                    return 6; /* *movqi_h8sx_cczn */
                }
              if (general_operand_src (operands[1], E_HImode)
                  && general_operand_dst (operands[0], E_HImode))
                {
                  if (
#line 111 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(!TARGET_H8300SX
    && h8300_move_ok (operands[0], operands[1])))
                    return 12; /* *movhi_cczn */
                  if (
#line 142 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
                    return 15; /* *movhi_h8sx_cczn */
                }
              if (general_operand_src (operands[1], E_SImode)
                  && general_operand_dst (operands[0], E_SImode))
                {
                  if (
#line 259 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
((TARGET_H8300S || TARGET_H8300H) && !TARGET_H8300SX
    && h8300_move_ok (operands[0], operands[1])))
                    return 21; /* *movsi_cczn */
                  if (
#line 310 "../../gcc-15.0.1-20250313/gcc/config/h8300/movepush.md"
(TARGET_H8300SX))
                    return 24; /* *movsi_h8sx_ccnz */
                }
            }
          if (GET_CODE (x6) != MEM)
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != PRE_MODIFY)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 7)
            return -1;
          x10 = XEXP (x8, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 7)
            return -1;
          x12 = XEXP (x10, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          operands[0] = x5;
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              switch (pattern146 (x6, 
E_QImode))
                {
                case 0:
                  if (!
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode))
                    return -1;
                  return 34; /* *push1_qi_cczn */

                case 1:
                  if (!
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode))
                    return -1;
                  return 38; /* *push1_qi_cczn */

                default:
                  return -1;
                }

            case E_HImode:
              switch (pattern146 (x6, 
E_HImode))
                {
                case 0:
                  if (!
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode))
                    return -1;
                  return 36; /* *push1_hi_cczn */

                case 1:
                  if (!
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode))
                    return -1;
                  return 40; /* *push1_hi_cczn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          operands[1] = x5;
          x8 = XEXP (x6, 0);
          operands[0] = x8;
          if (general_operand_dst (operands[0], E_QImode)
              && general_operand_src (operands[1], E_QImode))
            {
              x7 = XEXP (x4, 1);
              if (rtx_equal_p (x7, operands[1]))
                return 9; /* *movstrictqi_cczn */
            }
          if (!general_operand_dst (operands[0], E_HImode)
              || !general_operand_src (operands[1], E_HImode))
            return -1;
          x7 = XEXP (x4, 1);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          return 18; /* *movstricthi_cczn */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern109 (x1, 
PLUS))
        {
        case 0:
          x7 = XEXP (x4, 1);
          if (pattern111 (x7, 
E_QImode) != 0
              || !
#line 27 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          return 257; /* *addqi3_flags_cczn */

        case 1:
          if (!h8300_src_operand (operands[2], E_HImode))
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_MODE (x7) != E_HImode)
            return -1;
          if (register_operand (operands[1], E_HImode)
              && register_operand (operands[0], E_HImode)
              && 
#line 46 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && !TARGET_H8300SX))
            return 260; /* *addhi3_flags_cczn */
          if (!h8300_dst_operand (operands[1], E_HImode)
              || !h8300_dst_operand (operands[0], E_HImode)
              || !
#line 93 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && TARGET_H8300SX && h8300_operands_match_p (operands)))
            return -1;
          return 263; /* *addhi3_h8sx_flags_cczn */

        case 2:
          x7 = XEXP (x4, 1);
          if (pattern111 (x7, 
E_SImode) != 0
              || !
#line 129 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          return 266; /* *addsi_flags_cczn */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern109 (x1, 
MINUS))
        {
        case 0:
          if (!h8300_dst_operand (operands[1], E_QImode)
              || !h8300_dst_operand (operands[2], E_QImode)
              || !h8300_dst_operand (operands[0], E_QImode))
            return -1;
          x7 = XEXP (x4, 1);
          if (GET_MODE (x7) != E_QImode
              || !
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          return 269; /* *subqi3_flags_cczn */

        case 1:
          x7 = XEXP (x4, 1);
          if (pattern111 (x7, 
E_HImode) != 0
              || !
#line 181 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          return 273; /* *subhi3_flags_cczn */

        case 2:
          x7 = XEXP (x4, 1);
          if (pattern111 (x7, 
E_SImode) != 0
              || !
#line 181 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          return 275; /* *subsi3_flags_cczn */

        default:
          return -1;
        }

    case NEG:
      switch (pattern110 (x1, 
NEG))
        {
        case 0:
          if (!
#line 214 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed))
            return -1;
          return 280; /* *negqi2_flags_cczn */

        case 1:
          if (!
#line 214 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed))
            return -1;
          return 282; /* *neghi2_flags_cczn */

        case 2:
          if (!
#line 214 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed))
            return -1;
          return 284; /* *negsi2_flags_cczn */

        default:
          return -1;
        }

    case MULT:
      x13 = XEXP (x5, 0);
      if (GET_CODE (x13) != SIGN_EXTEND)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != MULT)
        return -1;
      x14 = XEXP (x7, 0);
      if (GET_CODE (x14) != SIGN_EXTEND)
        return -1;
      x15 = XEXP (x13, 0);
      operands[1] = x15;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x16 = XEXP (x14, 0);
      if (!rtx_equal_p (x16, operands[1]))
        return -1;
      x17 = XEXP (x5, 1);
      switch (GET_CODE (x17))
        {
        case CONST_INT:
          operands[2] = x17;
          x18 = XEXP (x7, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (GET_MODE (x13) != E_HImode
                  || !register_operand (operands[1], E_QImode)
                  || !nibble_operand (operands[2], E_QImode)
                  || !register_operand (operands[0], E_HImode)
                  || GET_MODE (x7) != E_HImode
                  || GET_MODE (x14) != E_HImode
                  || !
#line 34 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                return -1;
              return 307; /* *mulqihi3_const_cczn */

            case E_SImode:
              if (GET_MODE (x13) != E_SImode
                  || !register_operand (operands[1], E_HImode)
                  || !nibble_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x7) != E_SImode
                  || GET_MODE (x14) != E_SImode
                  || !
#line 86 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                return -1;
              return 313; /* *mulhisi3_const_cczn */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x18 = XEXP (x7, 1);
          if (GET_CODE (x18) != SIGN_EXTEND)
            return -1;
          x19 = XEXP (x17, 0);
          operands[2] = x19;
          x20 = XEXP (x18, 0);
          if (!rtx_equal_p (x20, operands[2]))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern145 (x1, 
E_HImode, 
E_QImode) != 0)
                return -1;
              return 310; /* *mulqihi3_cczn */

            case E_SImode:
              if (pattern145 (x1, 
E_SImode, 
E_HImode) != 0)
                return -1;
              return 316; /* *mulhisi3_cczn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern112 (x1, 
IOR))
        {
        case 0:
          if (bit_operand (operands[1], E_QImode)
              && bit_operand (operands[0], E_QImode)
              && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
            return 360; /* *iorqi3_1_cczn */
          if (register_operand (operands[1], E_QImode)
              && register_operand (operands[0], E_QImode))
            {
              if (
#line 186 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
                return 364; /* *iorqi3_1_cczn */
              return 368; /* *iorqi3_1_cczn */
            }
          if (!h8300_dst_operand (operands[1], E_QImode)
              || !h8300_dst_operand (operands[0], E_QImode)
              || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 383; /* *iorqi3_cczn */

        case 1:
          if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 389; /* *iorhi3_cczn */

        case 2:
          if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 395; /* *iorsi3_cczn */

        default:
          return -1;
        }

    case XOR:
      switch (pattern112 (x1, 
XOR))
        {
        case 0:
          if (bit_operand (operands[1], E_QImode)
              && bit_operand (operands[0], E_QImode)
              && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
            return 362; /* *xorqi3_1_cczn */
          if (register_operand (operands[1], E_QImode)
              && register_operand (operands[0], E_QImode))
            {
              if (
#line 186 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
                return 366; /* *xorqi3_1_cczn */
              return 370; /* *xorqi3_1_cczn */
            }
          if (!h8300_dst_operand (operands[1], E_QImode)
              || !h8300_dst_operand (operands[0], E_QImode)
              || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 385; /* *xorqi3_cczn */

        case 1:
          if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 391; /* *xorhi3_cczn */

        case 2:
          if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 397; /* *xorsi3_cczn */

        default:
          return -1;
        }

    case AND:
      switch (pattern112 (x1, 
AND))
        {
        case 0:
          if (register_operand (operands[1], E_QImode)
              && register_operand (operands[0], E_QImode))
            return 372; /* *andqi3_1_cczn */
          if (!h8300_dst_operand (operands[1], E_QImode)
              || !h8300_dst_operand (operands[0], E_QImode)
              || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 387; /* *andqi3_cczn */

        case 1:
          if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 393; /* *andhi3_cczn */

        case 2:
          if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 399; /* *andsi3_cczn */

        default:
          return -1;
        }

    case NOT:
      switch (pattern110 (x1, 
NOT))
        {
        case 0:
          return 404; /* one_cmplqi2__cczn */

        case 1:
          return 406; /* one_cmplhi2__cczn */

        case 2:
          return 408; /* one_cmplsi2__cczn */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != ZERO_EXTEND)
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x14 = XEXP (x7, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      switch (GET_MODE (x5))
        {
        case E_HImode:
          if (!general_operand_src (operands[1], E_QImode)
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x7) != E_HImode)
            return -1;
          return 445; /* *zero_extendqihi2_cczn */

        case E_SImode:
          switch (pattern137 (x7))
            {
            case 0:
              if (!
#line 121 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(TARGET_H8300SX))
                return -1;
              return 449; /* *zero_extendqisi2_h8sx_cczn */

            case 1:
              return 452; /* *zero_extendhisi2_cczn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      x14 = XEXP (x7, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      switch (GET_MODE (x5))
        {
        case E_HImode:
          if (!register_operand (operands[1], E_QImode)
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x7) != E_HImode)
            return -1;
          return 455; /* *extendqihi2_cczn */

        case E_SImode:
          switch (pattern137 (x7))
            {
            case 0:
              if (!
#line 202 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(TARGET_H8300SX))
                return -1;
              return 459; /* *extendqisi2_h8sx_cczn */

            case 1:
              return 462; /* *extendhisi2_cczn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
      operands[3] = x5;
      res = recog_24 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      switch (GET_CODE (x5))
        {
        case ASHIFT:
        case ASHIFTRT:
        case LSHIFTRT:
          operands[3] = x5;
          res = recog_25 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          x13 = XEXP (x5, 0);
          operands[1] = x13;
          x17 = XEXP (x5, 1);
          operands[2] = x17;
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          switch (GET_CODE (x5))
            {
            case ASHIFT:
              switch (pattern139 (x1, 
ASHIFT))
                {
                case 0:
                  if (!
#line 189 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode, ASHIFT)
    && compute_a_shift_cc (operands, ASHIFT))))
                    return -1;
                  return 487; /* *shiftqi_noscratch_set_flags */

                case 1:
                  if (!
#line 260 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, ASHIFT)
    && compute_a_shift_cc (operands, ASHIFT))))
                    return -1;
                  return 502; /* *shifthi_noscratch_setzn */

                case 2:
                  if (!
#line 331 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, ASHIFT)
    && compute_a_shift_cc (operands, ASHIFT))))
                    return -1;
                  return 517; /* *shiftsi_noscratch_cczn */

                default:
                  return -1;
                }

            case ASHIFTRT:
              switch (pattern139 (x1, 
ASHIFTRT))
                {
                case 0:
                  if (!
#line 189 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode, ASHIFTRT)
    && compute_a_shift_cc (operands, ASHIFTRT))))
                    return -1;
                  return 488; /* *shiftqi_noscratch_set_flags */

                case 1:
                  if (!
#line 260 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, ASHIFTRT)
    && compute_a_shift_cc (operands, ASHIFTRT))))
                    return -1;
                  return 503; /* *shifthi_noscratch_setzn */

                case 2:
                  if (!
#line 331 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, ASHIFTRT)
    && compute_a_shift_cc (operands, ASHIFTRT))))
                    return -1;
                  return 518; /* *shiftsi_noscratch_cczn */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern139 (x1, 
LSHIFTRT))
                {
                case 0:
                  if (!
#line 189 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode, LSHIFTRT)
    && compute_a_shift_cc (operands, LSHIFTRT))))
                    return -1;
                  return 489; /* *shiftqi_noscratch_set_flags */

                case 1:
                  if (!
#line 260 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, LSHIFTRT)
    && compute_a_shift_cc (operands, LSHIFTRT))))
                    return -1;
                  return 504; /* *shifthi_noscratch_setzn */

                case 2:
                  if (!
#line 331 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, LSHIFTRT)
    && compute_a_shift_cc (operands, LSHIFTRT))))
                    return -1;
                  return 519; /* *shiftsi_noscratch_cczn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
