/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!general_operand_dst (operands[0], E_QImode)
          || !general_operand_src (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!general_operand_dst (operands[0], E_HImode)
          || !general_operand_src (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!general_operand_dst (operands[0], E_SImode)
          || !general_operand_src (operands[1], E_SImode))
        return -1;
      return 2;

    case E_SFmode:
      if (!general_operand_dst (operands[0], E_SFmode)
          || !general_operand_src (operands[1], E_SFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x8 = XEXP (x2, 2);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XEXP (x1, 0);
  if (GET_CODE (x9) != PC)
    return -1;
  x10 = XEXP (x4, 0);
  operands[1] = x10;
  x11 = XEXP (x4, 2);
  operands[2] = x11;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x12 = XEXP (x7, 0);
  operands[0] = x12;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern42 (x1, 
E_HImode, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern42 (x1, 
E_SImode, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern50 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern69 (x1, 
E_HImode); /* [-1, 1] */

    case E_SImode:
      res = pattern69 (x1, 
E_SImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern76 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !h8sx_binary_shift_operator (operands[3], E_QImode)
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !h8sx_binary_shift_operator (operands[3], E_HImode)
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !h8sx_binary_shift_operator (operands[3], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return pattern88 (x1); /* [-1, 2] */
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 24]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_SImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  return 0;
}

int
pattern116 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern122 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern133 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_no_sp_elim_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  switch (XWINT (x6, 0))
    {
    case 1L:
      x7 = XEXP (x2, 1);
      switch (XWINT (x7, 0))
        {
        case 510L:
          switch (pattern118 (x2))
            {
            case 0:
              if (!
#line 141 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 54; /* *mova.md:136 */

            case 1:
              if (!
#line 369 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 79; /* *mova.md:364 */

            default:
              return -1;
            }

        case 131070L:
          if (pattern119 (x2) != 0
              || !
#line 633 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
            return -1;
          return 108; /* *mova.md:628 */

        default:
          return -1;
        }

    case 2L:
      x7 = XEXP (x2, 1);
      switch (XWINT (x7, 0))
        {
        case 1020L:
          switch (pattern118 (x2))
            {
            case 0:
              if (!
#line 251 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 66; /* *mova.md:246 */

            case 1:
              if (!
#line 479 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 91; /* *mova.md:474 */

            default:
              return -1;
            }

        case 262140L:
          if (pattern119 (x2) != 0
              || !
#line 743 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
            return -1;
          return 120; /* *mova.md:738 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 12
          || GET_MODE (x6) != E_CCZmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 2);
      operands[1] = x8;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !
#line 35 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[1]) < 16))
            return -1;
          return 124; /* *testcompare.md:29 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 35 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[1]) < 16))
            return -1;
          return 125; /* *testcompare.md:29 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 12
          && GET_MODE (x6) == E_CCZmode)
        {
          x5 = XEXP (x2, 1);
          switch (pattern68 (x5))
            {
            case 0:
              if (
#line 102 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                return 135; /* *cmpqi_z */
              break;

            case 1:
              if (
#line 110 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                return 136; /* *cmphi_z */
              break;

            case 2:
              if (
#line 118 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
                return 137; /* *cmpsi_z */
              break;

            default:
              break;
            }
        }
      operands[1] = x3;
      operands[0] = x6;
      switch (pattern7 (x2))
        {
        case 0:
          if (
#line 401 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(TARGET_H8300S || !optimize_size))
            return 201; /* *store_z_qi */
          break;

        case 1:
          if (
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 205; /* *store_z_hi */
          break;

        case 2:
          if (
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 209; /* *store_z_hi */
          break;

        case 3:
          if (
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 207; /* *store_z_hi */
          break;

        case 4:
          if (
#line 448 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 211; /* *store_z_hi */
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 12)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x6;
      switch (pattern79 (x2))
        {
        case 0:
          if (!
#line 235 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
            return -1;
          return 141; /* *store_c_qi */

        case 1:
          if (!
#line 436 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
((TARGET_H8300S || !optimize_size) && reload_completed))
            return -1;
          return 204; /* *store_z_i_qi */

        case 2:
          if (!
#line 235 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
            return -1;
          return 143; /* *store_c_hi */

        case 3:
          if (!
#line 501 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 237; /* *store_z_hi */

        case 4:
          if (!
#line 235 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(reload_completed))
            return -1;
          return 145; /* *store_c_si */

        case 5:
          if (!
#line 501 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 239; /* *store_z_si */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT
          || XWINT (x4, 0) != -256L)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_HImode)
          || !
#line 614 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
        return -1;
      return 253; /* *store_z */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      if (!rtx_equal_p (x3, operands[3]))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!nonmemory_operand (operands[2], E_QImode))
        return -1;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      switch (GET_MODE (operands[3]))
        {
        case E_QImode:
          if (!h8sx_binary_shift_operator (operands[3], E_QImode)
              || !register_operand (operands[1], E_QImode)
              || !register_operand (operands[0], E_QImode))
            return -1;
          return 478; /* *shiftrotate.md:132 */

        case E_HImode:
          if (!h8sx_binary_shift_operator (operands[3], E_HImode)
              || !register_operand (operands[1], E_HImode)
              || !register_operand (operands[0], E_HImode))
            return -1;
          return 479; /* *shiftrotate.md:132 */

        case E_SImode:
          if (!h8sx_binary_shift_operator (operands[3], E_SImode)
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode))
            return -1;
          return 480; /* *shiftrotate.md:132 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          operands[3] = x6;
          x7 = XVECEXP (x1, 0, 1);
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) == REG
              && REGNO (x8) == 12
              && GET_MODE (x8) == E_CCmode)
            {
              operands[2] = x5;
              x9 = XEXP (x3, 1);
              operands[1] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern142 (x3, 
E_QImode) == 0)
                    return 352; /* *andorqi3_clobber_flags */
                  break;

                case E_HImode:
                  if (pattern142 (x3, 
E_HImode) == 0)
                    return 353; /* *andorhi3_clobber_flags */
                  break;

                case E_SImode:
                  if (pattern142 (x3, 
E_SImode) == 0
                      && 
#line 93 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
((SImode == QImode
    || SImode == HImode
    || (SImode == SImode
	&& (INTVAL (operands[3]) & 0xffff) != 0))))
                    return 354; /* *andorsi3_clobber_flags */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x8) != REG
              || pattern121 (x1) != 0)
            return -1;
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          if (GET_MODE (x9) != E_SImode)
            return -1;
          switch (XWINT (x6, 0))
            {
            case -65536L:
              if (GET_CODE (x9) != LSHIFTRT)
                return -1;
              x10 = XEXP (x9, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              return 596; /* *iorsi3_e2f_clobber_flags */

            case -256L:
              if (GET_CODE (x9) != ZERO_EXTEND)
                return -1;
              x11 = XEXP (x9, 0);
              operands[2] = x11;
              if (!general_operand_src (operands[2], E_QImode))
                return -1;
              return 599; /* *iorsi3_w_clobber_flags */

            case 1L:
              if (GET_CODE (x9) != LSHIFTRT)
                return -1;
              x10 = XEXP (x9, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x11 = XEXP (x9, 0);
              if (!rtx_equal_p (x11, operands[1]))
                return -1;
              return 614; /* *iorsi2_and_1_lshiftrt_1_clobber_flags */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x12 = XEXP (x5, 1);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || pattern121 (x1) != 0)
            return -1;
          x13 = XEXP (x5, 0);
          if (!register_operand (x13, E_SImode))
            return -1;
          operands[2] = x13;
          if (XWINT (x12, 0) == 8L)
            {
              x6 = XEXP (x4, 1);
              if (GET_CODE (x6) == CONST_INT
                  && XWINT (x6, 0) == 65280L)
                {
                  x9 = XEXP (x3, 1);
                  operands[1] = x9;
                  if (register_operand (operands[1], E_SImode))
                    return 356; /* *andorsi3_shift_8_clobber_flags */
                }
            }
          operands[1] = x13;
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!single_one_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x3, 1);
          operands[4] = x9;
          if (!register_operand (operands[4], E_SImode)
              || !
#line 799 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
((INTVAL (operands[3]) & ~0xffff) == 0))
            return -1;
          return 603; /* *iorsi3_and_ashift_clobber_flags */

        case LSHIFTRT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x12 = XEXP (x5, 1);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          operands[2] = x12;
          if (const_int_operand (operands[2], E_SImode))
            {
              x7 = XVECEXP (x1, 0, 1);
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) == REG
                  && REGNO (x8) == 12
                  && GET_MODE (x8) == E_CCmode
                  && pattern126 (x3) == 0)
                {
                  x6 = XEXP (x4, 1);
                  operands[3] = x6;
                  if (single_one_operand (operands[3], E_SImode))
                    {
                      x9 = XEXP (x3, 1);
                      operands[4] = x9;
                      if (register_operand (operands[4], E_SImode)
                          && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(((INTVAL (operands[3]) << INTVAL (operands[2])) & ~0xffff) == 0))
                        return 605; /* *iorsi3_and_lshiftrt_clobber_flags */
                    }
                }
            }
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != CONST_INT
              || pattern126 (x3) != 0)
            return -1;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          switch (XWINT (x12, 0))
            {
            case 30L:
              if (XWINT (x6, 0) != 2L)
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 12
                  || GET_MODE (x8) != E_CCmode)
                return -1;
              return 609; /* *iorsi3_and_lshiftrt_n_sb_clobber_flags */

            case 9L:
              if (XWINT (x6, 0) != 4194304L)
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              x8 = XEXP (x7, 0);
              operands[3] = x8;
              if (!scratch_operand (operands[3], E_HImode))
                return -1;
              return 610; /* *iorsi3_and_lshiftrt_9_sb */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern86 (x1))
        {
        case 0:
          if (bit_operand (operands[0], E_QImode)
              && bit_operand (operands[1], E_QImode)
              && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
            return 359; /* *iorqi3_1 */
          if (register_operand (operands[0], E_QImode)
              && register_operand (operands[1], E_QImode))
            {
              if (
#line 186 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
                return 363; /* *iorqi3_1 */
              return 367; /* *iorqi3_1 */
            }
          if (!h8300_dst_operand (operands[0], E_QImode)
              || !h8300_dst_operand (operands[1], E_QImode)
              || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 382; /* *iorqi3 */

        case 1:
          if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 388; /* *iorhi3 */

        case 2:
          if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          return 394; /* *iorsi3 */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      switch (XWINT (x6, 0))
        {
        case 8L:
          if (pattern127 (x1, 
E_HImode) != 0)
            return -1;
          return 585; /* *iorhi3_ashift_8_clobber_flags */

        case 31L:
          if (pattern127 (x1, 
E_SImode) != 0)
            return -1;
          return 601; /* *iorsi3_ashift_31_clobber_flags */

        case 23L:
          if (pattern128 (x3, 
E_SImode) != 0
              || !register_operand (operands[2], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          return 612; /* *iorsi3_shift */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 12
          || GET_MODE (x8) != E_CCmode
          || pattern98 (x3, 
E_HImode) != 0)
        return -1;
      return 587; /* *iorhi3_lshiftrt_8_clobber_flags */

    case ZERO_EXTEND:
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != ASHIFT)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 12
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x11 = XEXP (x9, 0);
      operands[2] = x11;
      switch (XWINT (x10, 0))
        {
        case 8L:
          if (pattern140 (x3, 
E_HImode, 
E_QImode) == 0)
            return 589; /* *iorhi3_two_qi_clobber_flags */
          break;

        case 16L:
          if (pattern140 (x3, 
E_SImode, 
E_HImode) == 0)
            return 593; /* *iorsi3_two_hi_clobber_flags */
          break;

        default:
          break;
        }
      if (!memory_operand (operands[1], E_QImode)
          || GET_CODE (x11) != SUBREG
          || maybe_ne (SUBREG_BYTE (x11), 0)
          || GET_MODE (x11) != E_HImode
          || XWINT (x10, 0) != 8L
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || GET_MODE (x4) != E_HImode
          || GET_MODE (x9) != E_HImode)
        return -1;
      x14 = XEXP (x11, 0);
      operands[2] = x14;
      if (!memory_operand (operands[2], E_QImode))
        return -1;
      return 591; /* *iorhi3_two_qi_mem_clobber_flags */

    case ZERO_EXTRACT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern99 (x1, 
E_SImode) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x15 = XEXP (x4, 2);
      operands[2] = x15;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 866 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[2]) < 16))
        return -1;
      return 607; /* *iorsi3_zero_extract_clobber_flags */

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_7 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case LTU:
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != PLUS)
                return NULL;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != SET)
                return NULL;
              x6 = XEXP (x5, 1);
              if (GET_CODE (x6) != PLUS)
                return NULL;
              x7 = XEXP (x2, 0);
              operands[3] = x7;
              x8 = XEXP (x4, 0);
              operands[1] = x8;
              x9 = XEXP (x4, 1);
              operands[2] = x9;
              x10 = XEXP (x5, 0);
              operands[0] = x10;
              x11 = XEXP (x3, 1);
              if (!rtx_equal_p (x11, operands[1]))
                return NULL;
              x12 = XEXP (x6, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return NULL;
              x13 = XEXP (x6, 1);
              if (!rtx_equal_p (x13, operands[2]))
                return NULL;
              switch (GET_MODE (operands[3]))
                {
                case E_QImode:
                  switch (pattern136 (x1, 
E_QImode))
                    {
                    case 0:
                      if (!
#line 262 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                        return NULL;
                      return gen_split_109 (insn, operands);

                    case 1:
                      if (!
#line 262 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                        return NULL;
                      return gen_split_112 (insn, operands);

                    case 2:
                      if (!
#line 262 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                        return NULL;
                      return gen_split_115 (insn, operands);

                    default:
                      return NULL;
                    }

                case E_HImode:
                  switch (pattern136 (x1, 
E_HImode))
                    {
                    case 0:
                      if (!
#line 262 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                        return NULL;
                      return gen_split_110 (insn, operands);

                    case 1:
                      if (!
#line 262 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                        return NULL;
                      return gen_split_113 (insn, operands);

                    case 2:
                      if (!
#line 262 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                        return NULL;
                      return gen_split_116 (insn, operands);

                    default:
                      return NULL;
                    }

                case E_SImode:
                  switch (pattern136 (x1, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 262 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                        return NULL;
                      return gen_split_111 (insn, operands);

                    case 1:
                      if (!
#line 262 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                        return NULL;
                      return gen_split_114 (insn, operands);

                    case 2:
                      if (!
#line 262 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed))
                        return NULL;
                      return gen_split_117 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case TRUNCATE:
              switch (pattern45 (x1))
                {
                case 0:
                  if (!
#line 56 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
( reload_completed))
                    return NULL;
                  return gen_split_129 (insn, operands);

                case 1:
                  if (!
#line 143 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
( reload_completed))
                    return NULL;
                  return gen_split_131 (insn, operands);

                case 2:
                  if (!
#line 100 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
( reload_completed))
                    return NULL;
                  return gen_split_130 (insn, operands);

                case 3:
                  if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
( reload_completed))
                    return NULL;
                  return gen_split_132 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              if (pattern36 (x1) != 0
                  || !(
#line 176 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(INTVAL (operands[2]) >= 16) && 
#line 178 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
( reload_completed)))
                return NULL;
              return gen_split_160 (insn, operands);

            case ZERO_EXTEND:
              if (GET_MODE (x3) != E_HImode
                  || pattern65 (x1, 
E_HImode) != 0
                  || !general_operand_src (operands[1], E_QImode)
                  || !
#line 43 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(reload_completed))
                return NULL;
              return gen_split_162 (insn, operands);

            case COMPARE:
              if (GET_MODE (x3) != E_CCZNmode)
                return NULL;
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != ZERO_EXTEND
                  || GET_MODE (x4) != E_HImode
                  || pattern62 (x2) != 0)
                return NULL;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != SET)
                return NULL;
              x6 = XEXP (x5, 1);
              if (GET_CODE (x6) != ZERO_EXTEND
                  || GET_MODE (x6) != E_HImode)
                return NULL;
              x8 = XEXP (x4, 0);
              operands[1] = x8;
              if (!general_operand_src (operands[1], E_QImode))
                return NULL;
              x10 = XEXP (x5, 0);
              operands[0] = x10;
              if (!register_operand (operands[0], E_HImode))
                return NULL;
              x12 = XEXP (x6, 0);
              if (!rtx_equal_p (x12, operands[1])
                  || !
#line 59 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(!REG_P (operands[1]) && reload_completed))
                return NULL;
              return gen_split_163 (insn, operands);

            case ASHIFT:
            case ASHIFTRT:
            case LSHIFTRT:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x7 = XEXP (x2, 0);
              operands[0] = x7;
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              x11 = XEXP (x3, 1);
              operands[2] = x11;
              if (!nonmemory_operand (operands[2], E_QImode))
                return NULL;
              x10 = XEXP (x5, 0);
              operands[3] = x10;
              if (scratch_operand (operands[3], E_QImode))
                {
                  switch (GET_CODE (x3))
                    {
                    case ASHIFT:
                      switch (pattern87 (x3))
                        {
                        case 0:
                          if (
#line 207 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
                            return gen_split_181 (insn, operands);
                          break;

                        case 1:
                          if (
#line 277 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
                            return gen_split_187 (insn, operands);
                          break;

                        case 2:
                          if (
#line 352 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
                            return gen_split_193 (insn, operands);
                          break;

                        default:
                          break;
                        }
                      break;

                    case ASHIFTRT:
                      switch (pattern87 (x3))
                        {
                        case 0:
                          if (
#line 207 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
                            return gen_split_182 (insn, operands);
                          break;

                        case 1:
                          if (
#line 277 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
                            return gen_split_188 (insn, operands);
                          break;

                        case 2:
                          if (
#line 352 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
                            return gen_split_194 (insn, operands);
                          break;

                        default:
                          break;
                        }
                      break;

                    case LSHIFTRT:
                      switch (pattern87 (x3))
                        {
                        case 0:
                          if (
#line 207 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
                            return gen_split_183 (insn, operands);
                          break;

                        case 1:
                          if (
#line 277 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
                            return gen_split_189 (insn, operands);
                          break;

                        case 2:
                          if (
#line 352 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
                            return gen_split_195 (insn, operands);
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              operands[3] = x3;
              if (!nshift_operator (operands[3], E_SImode)
                  || !register_operand (operands[1], E_SImode))
                return NULL;
              operands[4] = x10;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 451 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(reload_completed))
                return NULL;
              return gen_split_198 (insn, operands);

            case ZERO_EXTRACT:
              if (pattern46 (x1) != 0
                  || !(
#line 177 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(TARGET_H8300H) && 
#line 179 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
                return NULL;
              return gen_split_217 (insn, operands);

            case AND:
              if (GET_MODE (x3) != E_SImode)
                return NULL;
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != ASHIFT
                  || GET_MODE (x4) != E_SImode)
                return NULL;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x7 = XEXP (x2, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_SImode)
                  || pattern105 (x1) != 0
                  || !(
#line 247 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[2]) <= 15
   && UINTVAL (operands[3]) == ((HOST_WIDE_INT_M1U << INTVAL (operands[2]))
				& 0xffff)) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
                return NULL;
              return gen_split_220 (insn, operands);

            case IOR:
              if (GET_MODE (x3) != E_SImode)
                return NULL;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x7 = XEXP (x2, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              x4 = XEXP (x3, 0);
              if (GET_MODE (x4) != E_SImode)
                return NULL;
              switch (GET_CODE (x4))
                {
                case AND:
                  if (pattern106 (x4) != 0)
                    return NULL;
                  x8 = XEXP (x4, 0);
                  x14 = XEXP (x8, 0);
                  operands[1] = x14;
                  if (!register_operand (operands[1], E_SImode))
                    return NULL;
                  x11 = XEXP (x3, 1);
                  operands[2] = x11;
                  if (!register_operand (operands[2], E_SImode))
                    return NULL;
                  x10 = XEXP (x5, 0);
                  operands[3] = x10;
                  if (!scratch_operand (operands[3], E_HImode)
                      || !
#line 905 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                    return NULL;
                  return gen_split_245 (insn, operands);

                case ASHIFT:
                  x9 = XEXP (x4, 1);
                  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 23])
                    return NULL;
                  x8 = XEXP (x4, 0);
                  operands[1] = x8;
                  if (!register_operand (operands[1], E_SImode))
                    return NULL;
                  x10 = XEXP (x5, 0);
                  operands[2] = x10;
                  if (!register_operand (operands[2], E_SImode))
                    return NULL;
                  x11 = XEXP (x3, 1);
                  if (!rtx_equal_p (x11, operands[0]))
                    return NULL;
                  if (
#line 948 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(epilogue_completed
   && find_regno_note (insn, REG_DEAD, REGNO (operands[1]))
   && REGNO (operands[0]) != REGNO (operands[1])))
                    return gen_split_246 (insn, operands);
                  if (!
#line 970 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(epilogue_completed
   && !(find_regno_note (insn, REG_DEAD, REGNO (operands[1]))
	&& REGNO (operands[0]) != REGNO (operands[1]))))
                    return NULL;
                  return gen_split_247 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (GET_MODE (x3) != E_SImode)
                return NULL;
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != MULT
                  || GET_MODE (x4) != E_SImode)
                return NULL;
              x9 = XEXP (x4, 1);
              if (GET_CODE (x9) != CONST_INT
                  || XWINT (x9, 0) != 8388608L)
                return NULL;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return NULL;
              x7 = XEXP (x2, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              x8 = XEXP (x4, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_SImode))
                return NULL;
              x10 = XEXP (x5, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x11 = XEXP (x3, 1);
              if (!rtx_equal_p (x11, operands[0]))
                return NULL;
              if (
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(epilogue_completed
   && find_regno_note (insn, REG_DEAD, REGNO (operands[1]))
   && REGNO (operands[0]) != REGNO (operands[1])))
                return gen_split_251 (insn, operands);
              if (!
#line 1099 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(epilogue_completed
   && !(find_regno_note (insn, REG_DEAD, REGNO (operands[1]))
	&& REGNO (operands[0]) != REGNO (operands[1]))))
                return NULL;
              return gen_split_252 (insn, operands);

            case SUBREG:
              switch (pattern47 (x1))
                {
                case 0:
                  if (!
#line 1193 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                    return NULL;
                  return gen_split_256 (insn, operands);

                case 1:
                  if (!
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                    return NULL;
                  return gen_split_257 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          if (!nshift_operator (x3, E_VOIDmode))
            return NULL;
          operands[2] = x3;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return NULL;
          x15 = XVECEXP (x1, 0, 2);
          if (pattern18 (x15) != 0)
            return NULL;
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x11 = XEXP (x3, 1);
          operands[1] = x11;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x10 = XEXP (x5, 0);
          operands[3] = x10;
          if (!register_operand (operands[3], E_QImode))
            return NULL;
          x4 = XEXP (x3, 0);
          if (!rtx_equal_p (x4, operands[0]))
            return NULL;
          if (
#line 378 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(epilogue_completed
   && find_regno_note (insn, REG_DEAD, REGNO (operands[1]))))
            return gen_split_196 (insn, operands);
          if (!
#line 414 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(epilogue_completed
   && !find_regno_note (insn, REG_DEAD, REGNO (operands[1]))))
            return NULL;
          return gen_split_197 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
