/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      x8 = XEXP (x3, 2);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || !const_int_operand (operands[3], E_HImode)
              || !const_int_operand (operands[2], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !const_int_operand (operands[3], E_VOIDmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 2;

    case MEM:
      operands[1] = x4;
      if (!bit_memory_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_QImode))
        return -1;
      x8 = XEXP (x3, 2);
      operands[3] = x8;
      if (!immediate_operand (operands[3], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return 0;
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x6) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return pattern50 (); /* [-1, 1] */
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case AND:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT)
            return -1;
          return 0;

        case ASHIFT:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST_INT
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x2) != E_SImode)
            return -1;
          return 1;

        case LSHIFTRT:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST_INT)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      res = pattern53 (x1);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case ASHIFT:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      return 6;

    case LSHIFTRT:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
          || pattern55 (x1, 
E_HImode) != 0)
        return -1;
      return 7;

    case ZERO_EXTEND:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x1, 1);
      switch (GET_CODE (x6))
        {
        case ASHIFT:
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              return 8;

            case SIGN_EXTEND:
              if (GET_MODE (x8) != E_SImode
                  || XWINT (x7, 0) != 8L
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x1) != E_SImode
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_QImode)
                  || GET_MODE (x6) != E_SImode)
                return -1;
              x9 = XEXP (x8, 0);
              operands[2] = x9;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 9;

            default:
              return -1;
            }

        case AND:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != ASHIFT
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != SUBREG
              || maybe_ne (SUBREG_BYTE (x9), 0)
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x8, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != CONST_INT
              || XWINT (x7, 0) != 65280L
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x2) != E_SImode
              || !memory_operand (operands[1], E_QImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[2] = x11;
          if (!memory_operand (operands[2], E_QImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x2, 2);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[3] = x6;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCZNmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 12
      || GET_MODE (x4) != E_CCZNmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_no_sp_elim_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 12)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      switch (GET_MODE (x4))
        {
        case E_CCmode:
          if (!
#line 59 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(reload_completed))
            return -1;
          return 415; /* *branch_1 */

        case E_CCZNmode:
          if (!
#line 59 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(reload_completed))
            return -1;
          return 416; /* *branch_1 */

        case E_CCZmode:
          if (!
#line 59 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(reload_completed))
            return -1;
          return 417; /* *branch_1 */

        default:
          return -1;
        }

    case PC:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      switch (GET_MODE (x4))
        {
        case E_CCmode:
          if (!
#line 77 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(reload_completed))
            return -1;
          return 418; /* *branch_1_false */

        case E_CCZNmode:
          if (!
#line 77 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(reload_completed))
            return -1;
          return 419; /* *branch_1_false */

        case E_CCZmode:
          if (!
#line 77 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(reload_completed))
            return -1;
          return 420; /* *branch_1_false */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          switch (XWINT (x6, 0))
            {
            case 2L:
              switch (pattern75 (x3))
                {
                case 0:
                  if (
#line 68 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return 46; /* *mova.md:64 */
                  break;

                case 1:
                  if (
#line 296 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return 71; /* *mova.md:292 */
                  break;

                case 2:
                  if (
#line 560 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return 100; /* *mova.md:556 */
                  break;

                default:
                  break;
                }
              break;

            case 4L:
              switch (pattern75 (x3))
                {
                case 0:
                  if (
#line 178 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return 58; /* *mova.md:174 */
                  break;

                case 1:
                  if (
#line 406 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return 83; /* *mova.md:402 */
                  break;

                case 2:
                  if (
#line 670 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return 112; /* *mova.md:666 */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          operands[2] = x6;
          switch (pattern38 (x3))
            {
            case 0:
              if (!
#line 126 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                return -1;
              return 317; /* *umulqihi3_const */

            case 1:
              if (!
#line 153 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                return -1;
              return 319; /* *umulhisi3_const */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern40 (x3))
            {
            case 0:
              return 318; /* *umulqihi3 */

            case 1:
              return 320; /* *umulhisi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern41 (x3))
            {
            case 0:
              if (
#line 22 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                return 305; /* *mulqihi3_const */
              if (pnum_clobbers == NULL
                  || !
#line 34 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                return -1;
              *pnum_clobbers = 1;
              return 306; /* *mulqihi3_const */

            case 1:
              if (
#line 74 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                return 311; /* *mulhisi3_const */
              if (pnum_clobbers == NULL
                  || !
#line 86 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                return -1;
              *pnum_clobbers = 1;
              return 312; /* *mulhisi3_const */

            case 2:
              return 308; /* *mulqihi3 */

            case 3:
              return 314; /* *mulhisi3 */

            default:
              return -1;
            }

        case MEM:
          if (GET_MODE (x5) != E_HImode)
            return -1;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != POST_INC
              || GET_MODE (x7) != E_SImode)
            return -1;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != SIGN_EXTEND
              || GET_MODE (x6) != E_SImode)
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_HImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != POST_INC
              || GET_MODE (x9) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 246 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_MAC))
            return -1;
          return 328; /* *multiply.md:239 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern17 (x3))
        {
        case 0:
          if (
#line 173 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
            return 321; /* mulhi3 */
          if (pnum_clobbers == NULL
              || !
#line 184 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
            return -1;
          *pnum_clobbers = 1;
          return 323; /* mulhi3_clobber_flags */

        case 1:
          if (
#line 173 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
            return 322; /* mulsi3 */
          if (pnum_clobbers == NULL
              || !
#line 184 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
            return -1;
          *pnum_clobbers = 1;
          return 324; /* mulsi3_clobber_flags */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !h8sx_binary_shift_operator (operands[3], E_QImode)
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 475; /* *shiftrotate.md:114 */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !h8sx_binary_shift_operator (operands[3], E_HImode)
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 476; /* *shiftrotate.md:114 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !h8sx_binary_shift_operator (operands[3], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 477; /* *shiftrotate.md:114 */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case IOR:
      res = recog_31 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      res = recog_32 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 12
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case ZERO_EXTEND:
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !iorxor_operator (operands[1], E_HImode)
              || GET_MODE (x7) != E_HImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_HImode))
            return -1;
          return 575; /* *ixorhi3_zext_clobber_flags */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !iorxor_operator (operands[1], E_SImode)
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 577; /* *ixorsi3_zext_qi_clobber_flags */

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 579; /* *ixorsi3_zext_hi_clobber_flags */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern129 (x7) != 0)
        return -1;
      return 581; /* *ixorsi3_ashift_16_clobber_flags */

    case LSHIFTRT:
      if (pattern129 (x7) != 0)
        return -1;
      return 583; /* *ixorsi3_lshiftrt_16_clobber_flags */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (pattern18 (x3) != 0)
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case LTU:
      switch (pattern31 (x1))
        {
        case 0:
          return 296; /* *uaddv */

        case 1:
          return 299; /* *uaddv */

        case 2:
          return 302; /* *uaddv */

        case 3:
          return 297; /* *uaddv */

        case 4:
          return 300; /* *uaddv */

        case 5:
          return 303; /* *uaddv */

        case 6:
          return 298; /* *uaddv */

        case 7:
          return 301; /* *uaddv */

        case 8:
          return 304; /* *uaddv */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern45 (x1))
        {
        case 0:
          return 339; /* udivmodqi4_clobber_flags */

        case 1:
          return 343; /* udivmodhi4_clobber_flags */

        case 2:
          return 341; /* divmodqi4_clobber_flags */

        case 3:
          return 345; /* divmodhi4_clobber_flags */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern89 (x1))
        {
        case 0:
          return 493; /* *shiftqi_clobber_flags */

        case 1:
          return 508; /* *shifthi_clobber_flags */

        case 2:
          return 523; /* *shiftsi_clobber_flags */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern89 (x1))
        {
        case 0:
          return 494; /* *shiftqi_clobber_flags */

        case 1:
          return 509; /* *shifthi_clobber_flags */

        case 2:
          return 524; /* *shiftsi_clobber_flags */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern89 (x1))
        {
        case 0:
          return 495; /* *shiftqi_clobber_flags */

        case 1:
          return 510; /* *shifthi_clobber_flags */

        case 2:
          return 525; /* *shiftsi_clobber_flags */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pattern46 (x1) != 0
          || !
#line 191 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(TARGET_H8300H))
        return -1;
      return 563; /* *extzv_16_8_clobber_flags */

    case IOR:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != AND
          || GET_MODE (x5) != E_SImode
          || pattern106 (x5) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x5, 0);
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x6, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_HImode))
        return -1;
      return 611; /* *iorsi3_and_lshiftrt_9_sb_clobber_flags */

    case SUBREG:
      switch (pattern47 (x1))
        {
        case 0:
          return 624; /* *combiner.md:1199 */

        case 1:
          return 626; /* *combiner.md:1222 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case GEU:
          switch (pattern48 (x2))
            {
            case 0:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_42 (insn, operands);
              break;

            case 1:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_44 (insn, operands);
              break;

            case 2:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_46 (insn, operands);
              break;

            case 3:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_48 (insn, operands);
              break;

            case 4:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_50 (insn, operands);
              break;

            case 5:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_52 (insn, operands);
              break;

            case 6:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_54 (insn, operands);
              break;

            case 7:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_56 (insn, operands);
              break;

            case 8:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_58 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case LTU:
          switch (pattern48 (x2))
            {
            case 0:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_43 (insn, operands);
              break;

            case 1:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_45 (insn, operands);
              break;

            case 2:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_47 (insn, operands);
              break;

            case 3:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_49 (insn, operands);
              break;

            case 4:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_51 (insn, operands);
              break;

            case 5:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_53 (insn, operands);
              break;

            case 6:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_55 (insn, operands);
              break;

            case 7:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_57 (insn, operands);
              break;

            case 8:
              if ((
#line 382 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(INTVAL (operands[3]) == 31 || INTVAL (operands[3]) <= 15) && 
#line 384 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_59 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case EQ:
          switch (pattern64 (x2))
            {
            case 0:
              if ((
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 464 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_70 (insn, operands);
              break;

            case 1:
              if ((
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 464 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_74 (insn, operands);
              break;

            case 2:
              if ((
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 464 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_72 (insn, operands);
              break;

            case 3:
              if ((
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 464 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_76 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case NE:
          switch (pattern64 (x2))
            {
            case 0:
              if ((
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 464 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_71 (insn, operands);
              break;

            case 1:
              if ((
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 464 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_75 (insn, operands);
              break;

            case 2:
              if ((
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 464 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_73 (insn, operands);
              break;

            case 3:
              if ((
#line 462 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 464 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
                return gen_split_77 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case SIGN_EXTEND:
          if (pattern49 (x2) == 0
              && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
            return gen_split_253 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case LSHIFTRT:
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  operands[3] = x2;
  switch (pattern12 (x1))
    {
    case 0:
      if ((
#line 58 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
        return gen_split_172 (insn, operands);
      break;

    case 1:
      if ((
#line 58 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
        return gen_split_173 (insn, operands);
      break;

    case 2:
      if ((
#line 58 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
        return gen_split_174 (insn, operands);
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (pattern13 (x2))
    {
    case 0:
      operands[3] = x2;
      switch (pattern76 ())
        {
        case 0:
          if (
#line 110 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
            return gen_split_175 (insn, operands);
          break;

        case 1:
          if (
#line 110 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
            return gen_split_176 (insn, operands);
          break;

        case 2:
          if (
#line 110 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
            return gen_split_177 (insn, operands);
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case ASHIFT:
          switch (pattern81 (x2))
            {
            case 0:
              if (!(
#line 158 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode,
				     ASHIFT))) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
                return NULL;
              return gen_split_178 (insn, operands);

            case 1:
              if (!(
#line 231 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, ASHIFT))) && 
#line 234 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
                return NULL;
              return gen_split_184 (insn, operands);

            case 2:
              if (!(
#line 301 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, ASHIFT))) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
                return NULL;
              return gen_split_190 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern81 (x2))
            {
            case 0:
              if (!(
#line 158 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode,
				     ASHIFTRT))) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
                return NULL;
              return gen_split_179 (insn, operands);

            case 1:
              if (!(
#line 231 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, ASHIFTRT))) && 
#line 234 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
                return NULL;
              return gen_split_185 (insn, operands);

            case 2:
              if (!(
#line 301 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, ASHIFTRT))) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
                return NULL;
              return gen_split_191 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern81 (x2))
            {
            case 0:
              if (!(
#line 158 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode,
				     LSHIFTRT))) && 
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
                return NULL;
              return gen_split_180 (insn, operands);

            case 1:
              if (!(
#line 231 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, LSHIFTRT))) && 
#line 234 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
                return NULL;
              return gen_split_186 (insn, operands);

            case 2:
              if (!(
#line 301 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, LSHIFTRT))) && 
#line 304 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed)))
                return NULL;
              return gen_split_192 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 1:
      if (!
#line 477 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
        return NULL;
      return gen_split_199 (insn, operands);

    case 2:
      if (!
#line 477 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
        return NULL;
      return gen_split_200 (insn, operands);

    case 3:
      if (!
#line 477 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
( reload_completed))
        return NULL;
      return gen_split_201 (insn, operands);

    default:
      return NULL;
    }
}
