/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_CODE (x1))
    {
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      return 0;

    case ROTATE:
      if (!immediate_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x1) != E_QImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!comparison_operator (operands[0], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x3, 0);
  operands[3] = x9;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!h8300_dst_operand (operands[1], E_QImode)
          || !h8300_src_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!h8300_dst_operand (operands[1], E_HImode)
          || !h8300_src_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!h8300_dst_operand (operands[1], E_SImode)
          || !h8300_src_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !iorxor_operator (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_HImode))
            return -1;
          return 0;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !iorxor_operator (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 1;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern57 (x3) != 0)
        return -1;
      return 3;

    case LSHIFTRT:
      if (pattern57 (x3) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (!immediate_operand (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern114 (x5, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern114 (x5, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern114 (x5, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode
      || !register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  switch (XWINT (x7, 0))
    {
    case 2L:
      x8 = XEXP (x3, 1);
      switch (XWINT (x8, 0))
        {
        case 510L:
          switch (pattern123 (x2))
            {
            case 0:
              if (!
#line 96 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 49; /* *mova.md:90 */

            case 1:
              if (!
#line 324 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 74; /* *mova.md:318 */

            default:
              return -1;
            }

        case 131070L:
          if (pattern124 (x2) != 0
              || !
#line 588 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
            return -1;
          return 103; /* *mova.md:582 */

        default:
          return -1;
        }

    case 4L:
      x8 = XEXP (x3, 1);
      switch (XWINT (x8, 0))
        {
        case 1020L:
          switch (pattern123 (x2))
            {
            case 0:
              if (!
#line 206 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 61; /* *mova.md:200 */

            case 1:
              if (!
#line 434 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 86; /* *mova.md:428 */

            default:
              return -1;
            }

        case 262140L:
          if (pattern124 (x2) != 0
              || !
#line 698 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
            return -1;
          return 115; /* *mova.md:692 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IOR:
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      switch (pattern53 (x2))
        {
        case 0:
          if (bit_operand (operands[0], E_QImode)
              && bit_operand (operands[1], E_QImode))
            {
              if (
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX || register_operand (operands[0], QImode)
   || single_one_operand (operands[2], QImode)))
                return 358; /* xorqi3_1 */
              if (pnum_clobbers != NULL
                  && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
                {
                  *pnum_clobbers = 1;
                  return 361; /* *xorqi3_1 */
                }
            }
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_QImode)
              && register_operand (operands[1], E_QImode))
            {
              if (
#line 186 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
                {
                  *pnum_clobbers = 1;
                  return 365; /* *xorqi3_1 */
                }
              *pnum_clobbers = 1;
              return 369; /* *xorqi3_1 */
            }
          if (h8300_dst_operand (operands[0], E_QImode)
              && h8300_dst_operand (operands[1], E_QImode))
            {
              if (
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
                return 374; /* *logicalqi3 */
              if (pnum_clobbers != NULL
                  && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 384; /* *xorqi3 */
                }
            }
          break;

        case 1:
          if (
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return 377; /* *logicalhi3 */
          if (pnum_clobbers != NULL
              && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            {
              *pnum_clobbers = 1;
              return 390; /* *xorhi3 */
            }
          break;

        case 2:
          if (
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return 380; /* *logicalsi3 */
          if (pnum_clobbers != NULL
              && 
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            {
              *pnum_clobbers = 1;
              return 396; /* *xorsi3 */
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  switch (pattern58 (x2))
    {
    case 0:
      return 574; /* *ixorhi3_zext */

    case 1:
      return 576; /* *ixorsi3_zext_qi */

    case 2:
      return 578; /* *ixorsi3_zext_hi */

    case 3:
      return 580; /* *ixorsi3_ashift_16 */

    case 4:
      return 582; /* *ixorsi3_lshiftrt_16 */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode))
        return -1;
      return 426; /* tablejumphi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode))
        return -1;
      return 427; /* tablejumpsi */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pattern61 (x1) != 0)
    return -1;
  switch (GET_CODE (operands[0]))
    {
    case REG:
    case SUBREG:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      switch (XWINT (x4, 0))
        {
        case 1L:
          x5 = XEXP (x3, 2);
          operands[1] = x5;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (x3))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || !immediate_operand (operands[1], E_HImode)
                  || !register_operand (operands[2], E_HImode))
                return -1;
              return 539; /* *bitfield.md:167 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !const_int_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 25 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16))
                return -1;
              return 549; /* *insv_si_1_n_clobber_flags */

            default:
              return -1;
            }

        case 8L:
          x5 = XEXP (x3, 2);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 555; /* *insv_si_8_8_clobber_flags */

        default:
          return -1;
        }

    case MEM:
      if (!bit_memory_operand (operands[0], E_QImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!immediate_operand (operands[2], E_QImode))
        return -1;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      if (!immediate_operand (operands[3], E_QImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 333 "../../gcc-15.0.1-20250313/gcc/config/h8300/bitfield.md"
(TARGET_H8300SX && INTVAL (operands[2]) + INTVAL (operands[3]) <= 8))
        return -1;
      return 547; /* bfst_clobber_flags */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || pattern104 (x1) != 0)
    return -1;
  x5 = XEXP (x3, 2);
  operands[1] = x5;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode)
      || !
#line 49 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16 && INTVAL (operands[3]) < 16))
    return -1;
  return 551; /* *insv_si_1_n_lshiftrt_clobber_flags */
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  switch (pattern85 (x5))
    {
    case 0:
      if (bit_operand (operands[0], E_QImode)
          && bit_operand (operands[1], E_QImode)
          && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
        return 361; /* *xorqi3_1 */
      if (register_operand (operands[0], E_QImode)
          && register_operand (operands[1], E_QImode))
        {
          if (
#line 186 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
            return 365; /* *xorqi3_1 */
          return 369; /* *xorqi3_1 */
        }
      if (!h8300_dst_operand (operands[0], E_QImode)
          || !h8300_dst_operand (operands[1], E_QImode)
          || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
        return -1;
      return 384; /* *xorqi3 */

    case 1:
      if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
        return -1;
      return 390; /* *xorhi3 */

    case 2:
      if (!
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
        return -1;
      return 396; /* *xorsi3 */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          res = recog_21 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case STRICT_LOW_PART:
          if (pattern61 (x1) == 0)
            {
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (general_operand_dst (operands[0], E_QImode)
                      && general_operand_src (operands[1], E_QImode))
                    return 8; /* *movstrictqi */
                  break;

                case E_HImode:
                  if (general_operand_dst (operands[0], E_HImode)
                      && general_operand_src (operands[1], E_HImode))
                    return 17; /* *movstricthi */
                  break;

                default:
                  break;
                }
            }
          break;

        case PC:
          res = recog_22 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ZERO_EXTRACT:
          res = recog_23 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != SUBREG)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != LSHIFTRT)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      operands[0] = x4;
      if (!general_operand_dst (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      switch (SUBREG_BYTE (x3))
        {
        case 1:
          if (XWINT (x6, 0) != 8L)
            return -1;
          x9 = XEXP (x7, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 12
              || GET_MODE (x9) != E_CCmode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 620; /* *combiner.md:1155 */

        case 3:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x6, 0))
            {
            case 8L:
              x9 = XEXP (x7, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 12
                  || GET_MODE (x9) != E_CCmode)
                return -1;
              return 622; /* *combiner.md:1177 */

            case 16L:
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!scratch_operand (operands[2], E_SImode))
                return -1;
              return 623; /* *combiner.md:1186 */

            case 24L:
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!scratch_operand (operands[2], E_SImode))
                return -1;
              return 625; /* *combiner.md:1209 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case COMPARE:
      return recog_34 (x1, insn, pnum_clobbers);

    case PLUS:
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          x9 = XEXP (x7, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 12
              || GET_MODE (x9) != E_CCmode)
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern84 (x3, 
E_QImode) != 0
                  || !
#line 27 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
                return -1;
              return 256; /* *addqi3_flags */

            case E_HImode:
              if (GET_MODE (x3) != E_HImode
                  || !h8300_src_operand (operands[2], E_HImode))
                return -1;
              if (register_operand (operands[0], E_HImode)
                  && register_operand (operands[1], E_HImode)
                  && 
#line 46 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && !TARGET_H8300SX))
                return 259; /* *addhi3_flags */
              if (!h8300_dst_operand (operands[0], E_HImode)
                  || !h8300_dst_operand (operands[1], E_HImode)
                  || !
#line 93 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && TARGET_H8300SX && h8300_operands_match_p (operands)))
                return -1;
              return 262; /* *addhi3_h8sx_flags */

            case E_SImode:
              if (pattern84 (x3, 
E_SImode) != 0
                  || !
#line 129 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
                return -1;
              return 265; /* *addsi_flags */

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != CONST_INT
              || pattern98 (x3, 
E_SImode) != 0)
            return -1;
          switch (XWINT (x6, 0))
            {
            case 65536L:
              x9 = XEXP (x7, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 12
                  || GET_MODE (x9) != E_CCmode)
                return -1;
              return 571; /* *addsi3_upper_clobber_regs */

            case 8388608L:
              x9 = XEXP (x7, 0);
              operands[3] = x9;
              if (!scratch_operand (operands[3], E_SImode))
                return -1;
              return 617; /* *addsi3_shift */

            default:
              return -1;
            }

        case LSHIFTRT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != ZERO_EXTEND
              || GET_MODE (x10) != E_SImode
              || pattern113 (x1) != 0)
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 573; /* *addsi3_lshiftrt_16_zexthi_clobber_flags */

        default:
          return -1;
        }

    case MINUS:
      if (pattern29 (x1) != 0)
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!h8300_dst_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !h8300_dst_operand (operands[1], E_QImode)
              || !h8300_dst_operand (operands[2], E_QImode)
              || !
#line 162 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          return 268; /* *subqi3_flags */

        case E_HImode:
          if (pattern84 (x3, 
E_HImode) != 0
              || !
#line 181 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          return 272; /* *subhi3_flags */

        case E_SImode:
          if (pattern84 (x3, 
E_SImode) != 0
              || !
#line 181 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed && h8300_operands_match_p (operands)))
            return -1;
          return 274; /* *subsi3_flags */

        default:
          return -1;
        }

    case NEG:
      if (pattern29 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!h8300_dst_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !h8300_dst_operand (operands[1], E_QImode)
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed))
            return -1;
          return 279; /* *negqi2_flags */

        case E_HImode:
          if (!h8300_dst_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !h8300_dst_operand (operands[1], E_HImode)
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed))
            return -1;
          return 281; /* *neghi2_flags */

        case E_SImode:
          if (!h8300_dst_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !h8300_dst_operand (operands[1], E_SImode)
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed))
            return -1;
          return 283; /* *negsi2_flags */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 239 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(reload_completed))
            return -1;
          return 286; /* *negsf2_clobber_flags */

        default:
          return -1;
        }

    case LTU:
      switch (pattern31 (x1))
        {
        case 0:
          x7 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x7, 1);
          if (GET_MODE (x12) == E_QImode)
            return 287; /* *uaddv */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 296; /* *uaddv */

        case 1:
          x7 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x7, 1);
          if (GET_MODE (x12) == E_HImode)
            return 290; /* *uaddv */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 299; /* *uaddv */

        case 2:
          x7 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x7, 1);
          if (GET_MODE (x12) == E_SImode)
            return 293; /* *uaddv */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 302; /* *uaddv */

        case 3:
          x7 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x7, 1);
          if (GET_MODE (x12) == E_QImode)
            return 288; /* *uaddv */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 297; /* *uaddv */

        case 4:
          x7 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x7, 1);
          if (GET_MODE (x12) == E_HImode)
            return 291; /* *uaddv */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 300; /* *uaddv */

        case 5:
          x7 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x7, 1);
          if (GET_MODE (x12) == E_SImode)
            return 294; /* *uaddv */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 303; /* *uaddv */

        case 6:
          x7 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x7, 1);
          if (GET_MODE (x12) == E_QImode)
            return 289; /* *uaddv */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 298; /* *uaddv */

        case 7:
          x7 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x7, 1);
          if (GET_MODE (x12) == E_HImode)
            return 292; /* *uaddv */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 301; /* *uaddv */

        case 8:
          x7 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x7, 1);
          if (GET_MODE (x12) == E_SImode)
            return 295; /* *uaddv */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 304; /* *uaddv */

        default:
          return -1;
        }

    case MULT:
      if (pattern32 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          x10 = XEXP (x3, 1);
          switch (GET_CODE (x10))
            {
            case CONST_INT:
              operands[2] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern133 (x3, 
E_QImode, 
E_HImode) != 0
                      || !nibble_operand (operands[2], E_QImode)
                      || !
#line 34 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                    return -1;
                  return 306; /* *mulqihi3_const */

                case E_SImode:
                  if (pattern133 (x3, 
E_HImode, 
E_SImode) != 0
                      || !nibble_operand (operands[2], E_SImode)
                      || !
#line 86 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                    return -1;
                  return 312; /* *mulhisi3_const */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              x11 = XEXP (x10, 0);
              operands[2] = x11;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern134 (x3, 
E_QImode, 
E_HImode) != 0)
                    return -1;
                  return 309; /* *mulqihi3 */

                case E_SImode:
                  if (pattern134 (x3, 
E_HImode, 
E_SImode) != 0)
                    return -1;
                  return 315; /* *mulhisi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern34 (x3))
            {
            case 0:
              if (!
#line 184 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                return -1;
              return 323; /* mulhi3_clobber_flags */

            case 1:
              if (!
#line 184 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SX))
                return -1;
              return 324; /* mulsi3_clobber_flags */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != MULT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x13 = XEXP (x8, 0);
          if (GET_CODE (x13) != SIGN_EXTEND
              || GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x8, 1);
          if (GET_CODE (x14) != SIGN_EXTEND
              || GET_MODE (x14) != E_DImode)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER
              || pattern99 (x1, 
E_SImode) != 0)
            return -1;
          x15 = XEXP (x13, 0);
          operands[1] = x15;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x16 = XEXP (x14, 0);
          operands[2] = x16;
          if (!reg_or_nibble_operand (operands[2], E_SImode)
              || !
#line 215 "../../gcc-15.0.1-20250313/gcc/config/h8300/multiply.md"
(TARGET_H8300SXMUL))
            return -1;
          return 326; /* smulsi3_highpart_clobber_flags */

        case UDIV:
          switch (pattern73 (x1, 
ZERO_EXTEND, 
UMOD))
            {
            case 0:
              return 338; /* udivmodqi4 */

            case 1:
              return 342; /* udivmodhi4 */

            default:
              return -1;
            }

        case DIV:
          switch (pattern73 (x1, 
SIGN_EXTEND, 
MOD))
            {
            case 0:
              return 340; /* divmodqi4 */

            case 1:
              return 344; /* divmodhi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UDIV:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 20 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return -1;
          return 332; /* udivhi3_clobber_flags */

        case 1:
          if (!
#line 20 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return -1;
          return 333; /* udivsi3_clobber_flags */

        default:
          return -1;
        }

    case DIV:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return -1;
          return 336; /* divhi3_clobber_flags */

        case 1:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/h8300/divmod.md"
(TARGET_H8300SX))
            return -1;
          return 337; /* divsi3_clobber_flags */

        default:
          return -1;
        }

    case NOT:
      if (pattern29 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!h8300_dst_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !h8300_dst_operand (operands[1], E_QImode))
            return -1;
          return 403; /* one_cmplqi2_ */

        case E_HImode:
          if (!h8300_dst_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !h8300_dst_operand (operands[1], E_HImode))
            return -1;
          return 405; /* one_cmplhi2_ */

        case E_SImode:
          if (!h8300_dst_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !h8300_dst_operand (operands[1], E_SImode))
            return -1;
          return 407; /* one_cmplsi2_ */

        default:
          return -1;
        }

    case ABS:
      if (GET_MODE (x3) != E_SFmode
          || pattern32 (x1) != 0
          || !register_operand (operands[0], E_SFmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 410; /* abssf2_clobber_flags */

    case IF_THEN_ELSE:
      if (pattern36 (x1) != 0
          || !
#line 176 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(INTVAL (operands[2]) >= 16))
        return -1;
      return 424; /* *jumpcall.md:166 */

    case ZERO_EXTEND:
      switch (pattern37 (x1))
        {
        case 0:
          if (!general_operand_src (operands[1], E_QImode))
            return -1;
          return 444; /* *zero_extendqihi2 */

        case 1:
          if (!
#line 121 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(TARGET_H8300SX))
            return -1;
          return 448; /* *zero_extendqisi2_h8sx */

        case 2:
          return 451; /* *zero_extendhisi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern37 (x1))
        {
        case 0:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 454; /* *extendqihi2 */

        case 1:
          if (!
#line 202 "../../gcc-15.0.1-20250313/gcc/config/h8300/extensions.md"
(TARGET_H8300SX))
            return -1;
          return 458; /* *extendqisi2_h8sx */

        case 2:
          return 461; /* *extendhisi2 */

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
      return recog_36 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      return recog_35 (x1, insn, pnum_clobbers);

    case AND:
    case IOR:
    case XOR:
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_CODE (x3))
        {
        case AND:
          res = recog_30 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case IOR:
        case XOR:
          res = recog_33 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!bit_operand (operands[0], E_HImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != ZERO_EXTRACT
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 12
          || GET_MODE (x9) != E_CCmode
          || !bit_operator (x3, E_HImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x17 = XEXP (x5, 2);
      operands[2] = x17;
      if (!immediate_operand (operands[2], E_HImode))
        return -1;
      x10 = XEXP (x3, 1);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x10;
          if (!bit_operand (operands[3], E_HImode))
            return -1;
          operands[4] = x3;
          return 541; /* *bitfield.md:242 */

        case ZERO_EXTRACT:
          if (GET_MODE (x10) != E_HImode)
            return -1;
          x18 = XEXP (x10, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          operands[5] = x3;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (!register_operand (operands[3], E_HImode))
            return -1;
          x19 = XEXP (x10, 2);
          operands[4] = x19;
          if (!immediate_operand (operands[4], E_HImode))
            return -1;
          return 543; /* *bitfield.md:275 */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XEXP (x3, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern65 (x1, 
E_SImode) != 0)
        return -1;
      x20 = XEXP (x3, 2);
      operands[2] = x20;
      if (!immediate_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode)
              || !
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX))
            return -1;
          return 632; /* *combiner.md:1335 */

        case E_HImode:
          if (!register_operand (operands[1], E_HImode)
              || !
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX))
            return -1;
          return 633; /* *combiner.md:1335 */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX))
            return -1;
          return 634; /* *combiner.md:1335 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
