/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_HImode:
      res = pattern6 (x1, 
E_HImode);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern6 (x1, 
E_SImode);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern14 (x1, 
E_QImode); /* [-1, 2] */

    case E_HImode:
      res = pattern14 (x1, 
E_HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_SImode:
      res = pattern14 (x1, 
E_SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_nibble_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern33 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern33 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern39 (x1, 
E_QImode, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern39 (x1, 
E_HImode, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 3)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!general_operand_dst (operands[0], E_QImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 16L:
      return 0;

    case 24L:
      return 1;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 12
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern69 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return pattern50 (); /* [-1, 1] */
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode
      || !h8300_dst_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_CCCmode:
          return 0;

        case E_CCZmode:
          return 1;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_CCCmode:
          return 2;

        case E_CCZmode:
          return 3;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_CCCmode:
          return 4;

        case E_CCZmode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern96 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern101 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (XWINT (x4, 0) != 8L
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_MODE (x5) != E_HImode
      || !memory_operand (operands[1], E_QImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!memory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern118 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern117 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern117 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (XWINT (x5, 0) != 16L)
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != CONST_INT
      || XWINT (x6, 0) != 16711680L)
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_CODE (x7) != ASHIFT
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != SUBREG
      || maybe_ne (SUBREG_BYTE (x8), 0)
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x7, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
    return -1;
  x10 = XEXP (x4, 0);
  operands[1] = x10;
  if (!memory_operand (operands[1], E_QImode))
    return -1;
  x11 = XEXP (x8, 0);
  operands[2] = x11;
  if (!memory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern145 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  switch (XWINT (x6, 0))
    {
    case 2L:
      x7 = XEXP (x2, 1);
      switch (XWINT (x7, 0))
        {
        case 510L:
          switch (pattern118 (x2))
            {
            case 0:
              if (!
#line 86 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 48; /* *mova.md:81 */

            case 1:
              if (!
#line 314 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 73; /* *mova.md:309 */

            default:
              return -1;
            }

        case 131070L:
          if (pattern119 (x2) != 0
              || !
#line 578 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
            return -1;
          return 102; /* *mova.md:573 */

        default:
          return -1;
        }

    case 4L:
      x7 = XEXP (x2, 1);
      switch (XWINT (x7, 0))
        {
        case 1020L:
          switch (pattern118 (x2))
            {
            case 0:
              if (!
#line 196 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 60; /* *mova.md:191 */

            case 1:
              if (!
#line 424 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 85; /* *mova.md:419 */

            default:
              return -1;
            }

        case 262140L:
          if (pattern119 (x2) != 0
              || !
#line 688 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
            return -1;
          return 114; /* *mova.md:683 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case ASHIFT:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LSHIFTRT:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[3] = x2;
  switch (pattern12 (x1))
    {
    case 0:
      if (
#line 58 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
        return 463; /* *shiftrotate.md:53 */
      if (pnum_clobbers != NULL
          && 
#line 70 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
        {
          *pnum_clobbers = 1;
          return 466; /* *shiftrotate.md:64 */
        }
      break;

    case 1:
      if (
#line 58 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
        return 464; /* *shiftrotate.md:53 */
      if (pnum_clobbers != NULL
          && 
#line 70 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
        {
          *pnum_clobbers = 1;
          return 467; /* *shiftrotate.md:64 */
        }
      break;

    case 2:
      if (
#line 58 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
        return 465; /* *shiftrotate.md:53 */
      if (pnum_clobbers != NULL
          && 
#line 70 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
(h8300_operands_match_p (operands)))
        {
          *pnum_clobbers = 1;
          return 468; /* *shiftrotate.md:64 */
        }
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (pattern13 (x2))
    {
    case 0:
      operands[3] = x2;
      switch (pattern76 ())
        {
        case 0:
          return 472; /* *shiftrotate.md:103 */

        case 1:
          return 473; /* *shiftrotate.md:103 */

        case 2:
          return 474; /* *shiftrotate.md:103 */

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case ASHIFT:
          switch (pattern78 (x2))
            {
            case 0:
              if (
#line 158 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode,
				     ASHIFT))))
                return 481; /* *shiftqi_noscratch */
              if (pnum_clobbers == NULL)
                return -1;
              if (
#line 172 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode, ASHIFT))))
                {
                  *pnum_clobbers = 1;
                  return 484; /* *shiftqi_noscratch_clobber_flags */
                }
              *pnum_clobbers = 1;
              return 490; /* *shiftqi */

            case 1:
              if (nonmemory_operand (operands[2], E_HImode))
                {
                  if (
#line 231 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, ASHIFT))))
                    return 496; /* *shifthi_noscratch */
                  if (pnum_clobbers != NULL
                      && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, ASHIFT))))
                    {
                      *pnum_clobbers = 1;
                      return 499; /* *shifthi_noscratch_clobber_flags */
                    }
                }
              if (pnum_clobbers == NULL
                  || !nonmemory_operand (operands[2], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 505; /* *shifthi */

            case 2:
              if (nonmemory_operand (operands[2], E_QImode)
                  && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, ASHIFT))))
                return 511; /* *shiftsi_noscratch */
              if (pnum_clobbers == NULL)
                return -1;
              if (nonmemory_operand (operands[2], E_SImode)
                  && 
#line 314 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, ASHIFT))))
                {
                  *pnum_clobbers = 1;
                  return 514; /* *shiftsi_noscratch_clobber_flags */
                }
              if (!nonmemory_operand (operands[2], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 520; /* *shiftsi */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern78 (x2))
            {
            case 0:
              if (
#line 158 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode,
				     ASHIFTRT))))
                return 482; /* *shiftqi_noscratch */
              if (pnum_clobbers == NULL)
                return -1;
              if (
#line 172 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode, ASHIFTRT))))
                {
                  *pnum_clobbers = 1;
                  return 485; /* *shiftqi_noscratch_clobber_flags */
                }
              *pnum_clobbers = 1;
              return 491; /* *shiftqi */

            case 1:
              if (nonmemory_operand (operands[2], E_HImode))
                {
                  if (
#line 231 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, ASHIFTRT))))
                    return 497; /* *shifthi_noscratch */
                  if (pnum_clobbers != NULL
                      && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, ASHIFTRT))))
                    {
                      *pnum_clobbers = 1;
                      return 500; /* *shifthi_noscratch_clobber_flags */
                    }
                }
              if (pnum_clobbers == NULL
                  || !nonmemory_operand (operands[2], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 506; /* *shifthi */

            case 2:
              if (nonmemory_operand (operands[2], E_QImode)
                  && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, ASHIFTRT))))
                return 512; /* *shiftsi_noscratch */
              if (pnum_clobbers == NULL)
                return -1;
              if (nonmemory_operand (operands[2], E_SImode)
                  && 
#line 314 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, ASHIFTRT))))
                {
                  *pnum_clobbers = 1;
                  return 515; /* *shiftsi_noscratch_clobber_flags */
                }
              if (!nonmemory_operand (operands[2], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 521; /* *shiftsi */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern78 (x2))
            {
            case 0:
              if (
#line 158 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode,
				     LSHIFTRT))))
                return 483; /* *shiftqi_noscratch */
              if (pnum_clobbers == NULL)
                return -1;
              if (
#line 172 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), QImode, LSHIFTRT))))
                {
                  *pnum_clobbers = 1;
                  return 486; /* *shiftqi_noscratch_clobber_flags */
                }
              *pnum_clobbers = 1;
              return 492; /* *shiftqi */

            case 1:
              if (nonmemory_operand (operands[2], E_HImode))
                {
                  if (
#line 231 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, LSHIFTRT))))
                    return 498; /* *shifthi_noscratch */
                  if (pnum_clobbers != NULL
                      && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), HImode, LSHIFTRT))))
                    {
                      *pnum_clobbers = 1;
                      return 501; /* *shifthi_noscratch_clobber_flags */
                    }
                }
              if (pnum_clobbers == NULL
                  || !nonmemory_operand (operands[2], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 507; /* *shifthi */

            case 2:
              if (nonmemory_operand (operands[2], E_QImode)
                  && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, LSHIFTRT))))
                return 513; /* *shiftsi_noscratch */
              if (pnum_clobbers == NULL)
                return -1;
              if (nonmemory_operand (operands[2], E_SImode)
                  && 
#line 314 "../../gcc-15.0.1-20250313/gcc/config/h8300/shiftrotate.md"
((GET_CODE (operands[2]) == CONST_INT
    && !h8300_shift_needs_scratch_p (INTVAL (operands[2]), SImode, LSHIFTRT))))
                {
                  *pnum_clobbers = 1;
                  return 516; /* *shiftsi_noscratch_clobber_flags */
                }
              if (!nonmemory_operand (operands[2], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 522; /* *shiftsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return 526; /* rotlqi3_1 */

    case 2:
      return 527; /* rotlhi3_1 */

    case 3:
      return 528; /* rotlsi3_1 */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_39 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_37 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_38 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[0] = x1;
      if (XVECLEN (operands[0], 0) >= 1)
        {
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == SET)
            {
              x3 = XEXP (x2, 0);
              operands[1] = x3;
              if (register_operand (operands[1], E_SImode)
                  && h8300_ldm_parallel (operands[0], E_VOIDmode))
                {
                  x4 = XEXP (x2, 1);
                  operands[2] = x4;
                  if (memory_operand (operands[2], E_SImode)
                      && 
#line 33 "../../gcc-15.0.1-20250313/gcc/config/h8300/proepi.md"
(TARGET_H8300S))
                    return 438; /* ldm_h8300sx */
                }
              if (memory_operand (operands[1], E_SImode)
                  && h8300_stm_parallel (operands[0], E_VOIDmode))
                {
                  x4 = XEXP (x2, 1);
                  operands[2] = x4;
                  if (register_operand (operands[2], E_SImode)
                      && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/h8300/proepi.md"
(TARGET_H8300S))
                    return 439; /* stm_h8300sx */
                }
            }
        }
      if (XVECLEN (operands[0], 0) < 2
          || !h8300_return_parallel (operands[0], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != RETURN)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!memory_operand (operands[2], E_SImode)
          || !
#line 58 "../../gcc-15.0.1-20250313/gcc/config/h8300/proepi.md"
(TARGET_H8300SX))
        return -1;
      return 440; /* return_h8sx */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 411; /* nop */

    case CALL:
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_QImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      if (!call_insn_operand (operands[0], E_VOIDmode))
        return -1;
      x10 = XEXP (x1, 1);
      operands[1] = x10;
      if (general_operand (operands[1], E_HImode)
          && (
#line 293 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(!SIBLING_CALL_P (insn)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode)))
        return 430; /* call_insn_hi */
      if (general_operand (operands[1], E_SImode)
          && (
#line 293 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(!SIBLING_CALL_P (insn)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode)))
        return 431; /* call_insn_si */
      if (general_operand (operands[1], E_HImode)
          && (
#line 363 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(SIBLING_CALL_P (insn)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == HImode)))
        return 434; /* sibcall_insn_hi */
      if (!general_operand (operands[1], E_SImode)
          || !(
#line 363 "../../gcc-15.0.1-20250313/gcc/config/h8300/jumpcall.md"
(SIBLING_CALL_P (insn)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/h8300.md"
(Pmode == SImode)))
        return -1;
      return 435; /* sibcall_insn_si */

    case RETURN:
      if (!
#line 78 "../../gcc-15.0.1-20250313/gcc/config/h8300/proepi.md"
(reload_completed))
        return -1;
      return 441; /* *return_1 */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 1)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 442; /* monitor_prologue */

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!h8300_dst_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode)
            return NULL;
          operands[1] = x4;
          if (!h8300_dst_operand (operands[1], E_QImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!h8300_src_operand (operands[2], E_QImode)
              || !(
#line 16 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(h8300_operands_match_p (operands)) && 
#line 18 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed)))
            return NULL;
          return gen_split_96 (insn, operands);

        case E_HImode:
          if (GET_MODE (x3) != E_HImode)
            return NULL;
          operands[1] = x4;
          if (register_operand (operands[1], E_HImode)
              && register_operand (operands[0], E_HImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (h8300_src_operand (operands[2], E_HImode)
                  && (
#line 35 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(!TARGET_H8300SX) && 
#line 37 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed)))
                return gen_split_97 (insn, operands);
            }
          if (h8300_dst_operand (operands[1], E_HImode)
              && h8300_dst_operand (operands[0], E_HImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (h8300_src_operand (operands[2], E_HImode)
                  && (
#line 82 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(TARGET_H8300SX && h8300_operands_match_p (operands)) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed)))
                return gen_split_98 (insn, operands);
            }
          if (!register_operand (operands[0], E_HImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!two_insn_adds_subs_operand (operands[1], E_HImode)
              || !rtx_equal_p (x4, operands[0])
              || !
#line 106 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(!reload_completed))
            return NULL;
          return gen_split_99 (insn, operands);

        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          if (register_operand (operands[0], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[1] = x5;
              if (two_insn_adds_subs_operand (operands[1], E_SImode)
                  && rtx_equal_p (x4, operands[0])
                  && 
#line 106 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(!reload_completed))
                return gen_split_100 (insn, operands);
            }
          if (!h8300_dst_operand (operands[0], E_SImode))
            return NULL;
          operands[1] = x4;
          if (!h8300_dst_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (!h8300_src_operand (operands[2], E_SImode)
              || !(
#line 118 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
(h8300_operands_match_p (operands)) && 
#line 120 "../../gcc-15.0.1-20250313/gcc/config/h8300/addsub.md"
( reload_completed)))
            return NULL;
          return gen_split_101 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      if (GET_MODE (x4) != E_SImode)
        return NULL;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT
          || XWINT (x6, 0) != 65536L
          || pattern55 (x3, 
E_SImode) != 0
          || !
#line 321 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_223 (insn, operands);

    case LSHIFTRT:
      if (pattern22 (x3) != 0
          || !
#line 344 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_224 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != COMPARE)
        return NULL;
      x3 = XEXP (x2, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 12
          || GET_MODE (x4) != E_CCmode)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!memory_operand (operands[0], E_QImode))
            return NULL;
          if (
#line 181 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!mode_dependent_address_p (XEXP (operands[0], 0), MEM_ADDR_SPACE (operands[0]))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_1 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!
#line 192 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(mode_dependent_address_p (XEXP (operands[0], 0), MEM_ADDR_SPACE (operands[0]))))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_4 (insn, operands);

        case E_HImode:
          if (!memory_operand (operands[0], E_HImode))
            return NULL;
          if (
#line 181 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!mode_dependent_address_p (XEXP (operands[0], 0), MEM_ADDR_SPACE (operands[0]))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_2 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!
#line 192 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(mode_dependent_address_p (XEXP (operands[0], 0), MEM_ADDR_SPACE (operands[0]))))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_5 (insn, operands);

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode))
            return NULL;
          if (
#line 181 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!mode_dependent_address_p (XEXP (operands[0], 0), MEM_ADDR_SPACE (operands[0]))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_3 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!
#line 192 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(mode_dependent_address_p (XEXP (operands[0], 0), MEM_ADDR_SPACE (operands[0]))))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_6 (insn, operands);

        default:
          return NULL;
        }

    case PARALLEL:
      if (peep2_current_count < 2
          || XVECLEN (x1, 0) != 2)
        return NULL;
      x6 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x6) != SET
          || pattern32 (x1) != 0)
        return NULL;
      x7 = XEXP (x6, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (register_operand (operands[0], E_QImode))
            {
              if (simple_memory_operand (operands[1], E_QImode))
                {
                  x8 = PATTERN (peep2_next_insn (1));
                  if (pattern130 (x8) == 0)
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_7 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (general_operand (operands[1], E_QImode))
                {
                  x8 = PATTERN (peep2_next_insn (1));
                  if (pattern131 (x8) == 0
                      && pattern141 (x8) == 0)
                    {
                      x9 = XVECEXP (x8, 0, 0);
                      x10 = XEXP (x9, 1);
                      x11 = XEXP (x10, 0);
                      if (rtx_equal_p (x11, operands[2])
                          && 
#line 282 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(!reg_overlap_mentioned_p (operands[2], operands[1])
   && REGNO (operands[0]) == REGNO (operands[2])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_10 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && simple_memory_operand (operands[1], E_HImode))
            {
              x8 = PATTERN (peep2_next_insn (1));
              if (pattern130 (x8) == 0)
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_8 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          break;

        case E_SImode:
          if (register_operand (operands[0], E_SImode))
            {
              if (simple_memory_operand (operands[1], E_SImode))
                {
                  x8 = PATTERN (peep2_next_insn (1));
                  if (pattern130 (x8) == 0)
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_9 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              if (nonimmediate_operand (operands[1], E_SImode))
                {
                  x8 = PATTERN (peep2_next_insn (1));
                  if (pattern131 (x8) == 0
                      && pattern144 (x8) == 0
                      && 
#line 296 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && !(GET_CODE (operands[1]) == MEM && !offsettable_memref_p (operands[1]))
   && !(GET_CODE (operands[1]) == MEM && MEM_VOLATILE_P (operands[1]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_11 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          break;

        default:
          break;
        }
      if (nonimmediate_operand (operands[1], E_VOIDmode))
        {
          x8 = PATTERN (peep2_next_insn (1));
          if (pattern116 (x8, 
E_VOIDmode) == 0
              && pattern141 (x8) == 0)
            {
              x9 = XVECEXP (x8, 0, 0);
              x10 = XEXP (x9, 1);
              x12 = XEXP (x10, 1);
              operands[3] = x12;
              if (const_int_qi_operand (operands[3], E_SImode))
                {
                  x11 = XEXP (x10, 0);
                  if (rtx_equal_p (x11, operands[2])
                      && 
#line 316 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
((GET_MODE (operands[0]) == QImode
    || GET_MODE (operands[0]) == HImode
    || GET_MODE (operands[0]) == SImode)
   && GET_MODE (operands[0]) == GET_MODE (operands[1])
   && REGNO (operands[0]) == REGNO (operands[2])
   && !reg_overlap_mentioned_p (operands[2], operands[1])
   && !(GET_MODE (operands[1]) != QImode
	&& GET_CODE (operands[1]) == MEM
	&& !offsettable_memref_p (operands[1]))
   && !(GET_MODE (operands[1]) != QImode
	&& GET_CODE (operands[1]) == MEM
	&& MEM_VOLATILE_P (operands[1]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_12 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x8 = PATTERN (peep2_next_insn (1));
      if (pattern116 (x8, 
E_SImode) != 0)
        return NULL;
      x9 = XVECEXP (x8, 0, 0);
      x10 = XEXP (x9, 1);
      x12 = XEXP (x10, 1);
      if (GET_CODE (x12) != CONST_INT
          || XWINT (x12, 0) != 65280L
          || pattern144 (x8) != 0
          || !
#line 346 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_13 (insn, operands);

    default:
      return NULL;
    }
}
