/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT
      || XWINT (x3, 0) != -256L)
    return -1;
  x4 = XEXP (x1, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!h8300_dst_operand (operands[0], E_QImode)
          || !h8sx_unary_shift_operator (operands[3], E_QImode)
          || !h8300_dst_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!h8300_dst_operand (operands[0], E_HImode)
          || !h8sx_unary_shift_operator (operands[3], E_HImode)
          || !h8300_dst_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!h8300_dst_operand (operands[0], E_SImode)
          || !h8sx_unary_shift_operator (operands[3], E_SImode)
          || !h8300_dst_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!h8300_dst_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !h8300_dst_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!h8300_dst_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !h8300_dst_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!h8300_dst_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !h8300_dst_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !nibble_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_HImode)
          || !nibble_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern65 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  return 0;
}

int
pattern73 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != TRUNCATE)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x4, 0);
  operands[1] = x10;
  x11 = XEXP (x5, 0);
  operands[2] = x11;
  x12 = XEXP (x6, 0);
  operands[3] = x12;
  return pattern43 (x1); /* [-1, 1] */
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!h8300_dst_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !h8300_dst_operand (operands[1], i1)
      || !h8300_src_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern87 (x5); /* [-1, 2] */
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 1);
  switch (XWINT (x5, 0))
    {
    case -65536L:
      if (GET_CODE (x4) != LSHIFTRT)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case -256L:
      if (GET_CODE (x4) != ZERO_EXTEND)
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!general_operand_src (operands[2], E_QImode))
        return -1;
      return 1;

    case 1L:
      if (GET_CODE (x4) != LSHIFTRT)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x4, 0);
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !memory_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern134 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 12
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x4, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[3] = x3;
  if (pattern66 (x1) == 0)
    {
      if (
#line 35 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16 && INTVAL (operands[3]) < 16))
        return 550; /* *insv_si_1_n_lshiftrt */
      if (pnum_clobbers != NULL
          && 
#line 49 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16 && INTVAL (operands[3]) < 16))
        {
          *pnum_clobbers = 1;
          return 551; /* *insv_si_1_n_lshiftrt_clobber_flags */
        }
    }
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return -1;
  switch (pattern67 (x1))
    {
    case 0:
      if (
#line 59 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16))
        return 552; /* *insv_si_1_n_lshiftrt_16 */
      if (pnum_clobbers == NULL
          || !
#line 73 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[1]) < 16))
        return -1;
      *pnum_clobbers = 1;
      return 553; /* *insv_si_1_n_lshiftrt_16_clobber_flags */

    case 1:
      return 556; /* *insv_si_8_8_lshiftrt_8 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MULT:
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) == SUBREG
          && known_eq (SUBREG_BYTE (x6), 0))
        {
          res = recog_9 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x6;
      switch (XWINT (x4, 0))
        {
        case 2L:
          switch (XWINT (x5, 0))
            {
            case 510L:
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern101 (x2, 
E_HImode) != 0
                      || !
#line 105 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 50; /* *mova.md:100 */

                case E_SImode:
                  if (pattern101 (x2, 
E_SImode) != 0
                      || !
#line 333 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 75; /* *mova.md:328 */

                default:
                  return -1;
                }

            case 131070L:
              if (pattern101 (x2, 
E_SImode) != 0
                  || !
#line 597 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 104; /* *mova.md:592 */

            default:
              return -1;
            }

        case 4L:
          switch (XWINT (x5, 0))
            {
            case 1020L:
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern101 (x2, 
E_HImode) != 0
                      || !
#line 215 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 62; /* *mova.md:210 */

                case E_SImode:
                  if (pattern101 (x2, 
E_SImode) != 0
                      || !
#line 443 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return -1;
                  return 87; /* *mova.md:438 */

                default:
                  return -1;
                }

            case 262140L:
              if (pattern101 (x2, 
E_SImode) != 0
                  || !
#line 707 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                return -1;
              return 116; /* *mova.md:702 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) == CONST_INT)
        {
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) == SUBREG
              && known_eq (SUBREG_BYTE (x6), 0))
            {
              res = recog_10 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x6;
          switch (XWINT (x4, 0))
            {
            case 1L:
              switch (XWINT (x5, 0))
                {
                case 510L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern101 (x2, 
E_HImode) == 0
                          && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return 56; /* *mova.md:155 */
                      break;

                    case E_SImode:
                      if (pattern101 (x2, 
E_SImode) == 0
                          && 
#line 388 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return 81; /* *mova.md:383 */
                      break;

                    default:
                      break;
                    }
                  break;

                case 131070L:
                  if (pattern101 (x2, 
E_SImode) == 0
                      && 
#line 652 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return 110; /* *mova.md:647 */
                  break;

                default:
                  break;
                }
              break;

            case 2L:
              switch (XWINT (x5, 0))
                {
                case 1020L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_HImode:
                      if (pattern101 (x2, 
E_HImode) == 0
                          && 
#line 270 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return 68; /* *mova.md:265 */
                      break;

                    case E_SImode:
                      if (pattern101 (x2, 
E_SImode) == 0
                          && 
#line 498 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                        return 93; /* *mova.md:493 */
                      break;

                    default:
                      break;
                    }
                  break;

                case 262140L:
                  if (pattern101 (x2, 
E_SImode) == 0
                      && 
#line 762 "../../gcc-15.0.1-20250313/gcc/config/h8300/mova.md"
(TARGET_H8300SX))
                    return 122; /* *mova.md:757 */
                  break;

                default:
                  break;
                }
              break;

            case 15L:
              if (XWINT (x5, 0) == 2147450880L
                  && pattern101 (x2, 
E_SImode) == 0)
                return 565; /* *twoshifts_l16_r1 */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x4;
      if (!const_int_operand (operands[2], E_QImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 247 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(INTVAL (operands[2]) <= 15
   && UINTVAL (operands[3]) == ((HOST_WIDE_INT_M1U << INTVAL (operands[2]))
				& 0xffff)))
        return -1;
      *pnum_clobbers = 1;
      return 566; /* *andsi3_ashift_n_lower */

    case EQ:
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (pattern70 (x2))
        {
        case 0:
          if (
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 229; /* *store_z_hi_and */
          break;

        case 1:
          if (
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 233; /* *store_z_hi_and */
          break;

        case 2:
          if (
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 231; /* *store_z_hi_and */
          break;

        case 3:
          if (
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 235; /* *store_z_hi_and */
          break;

        default:
          break;
        }
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern72 (x2))
        {
        case 0:
          if (!
#line 583 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 249; /* *store_z_hi_and */

        case 1:
          if (!
#line 583 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 251; /* *store_z_si_and */

        default:
          return -1;
        }

    case NE:
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (pattern70 (x2))
        {
        case 0:
          if (
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 230; /* *store_z_hi_and */
          break;

        case 1:
          if (
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 234; /* *store_z_hi_and */
          break;

        case 2:
          if (
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 232; /* *store_z_hi_and */
          break;

        case 3:
          if (
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return 236; /* *store_z_hi_and */
          break;

        default:
          break;
        }
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern72 (x2))
        {
        case 0:
          if (!
#line 583 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 250; /* *store_z_hi_and */

        case 1:
          if (!
#line 583 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX))
            return -1;
          return 252; /* *store_z_si_and */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern53 (x2))
        {
        case 0:
          if (bit_operand (operands[0], E_QImode)
              && bit_operand (operands[1], E_QImode))
            {
              if (
#line 38 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
                return 346; /* *andqi3_2 */
              if (pnum_clobbers != NULL
                  && 
#line 49 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX))
                {
                  *pnum_clobbers = 1;
                  return 347; /* *andqi3_2_clobber_flags */
                }
              if (
#line 61 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(register_operand (operands[0], QImode)
   || single_zero_operand (operands[2], QImode)))
                return 348; /* andqi3_1 */
            }
          if (pnum_clobbers != NULL
              && register_operand (operands[0], E_QImode)
              && register_operand (operands[1], E_QImode))
            {
              *pnum_clobbers = 1;
              return 371; /* *andqi3_1 */
            }
          if (!h8300_dst_operand (operands[0], E_QImode)
              || !h8300_dst_operand (operands[1], E_QImode))
            return -1;
          if (
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return 375; /* *logicalqi3 */
          if (pnum_clobbers == NULL
              || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 386; /* *andqi3 */

        case 1:
          if (
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return 378; /* *logicalhi3 */
          if (pnum_clobbers == NULL
              || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 392; /* *andhi3 */

        case 2:
          if (
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return 381; /* *logicalsi3 */
          if (pnum_clobbers == NULL
              || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)))
            return -1;
          *pnum_clobbers = 1;
          return 398; /* *andsi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pattern54 (x2) != 0)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) == CONST_INT)
        {
          operands[2] = x4;
          if (const_int_operand (operands[2], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (single_one_operand (operands[3], E_SImode))
                {
                  if (
#line 271 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(exact_log2 (INTVAL (operands[3])) < 16
   && INTVAL (operands[2]) + exact_log2 (INTVAL (operands[3])) == 31))
                    return 567; /* *andsi3_lshiftrt_n_sb */
                  if (pnum_clobbers != NULL
                      && 
#line 286 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(exact_log2 (INTVAL (operands[3])) < 16
   && INTVAL (operands[2]) + exact_log2 (INTVAL (operands[3])) == 31))
                    {
                      *pnum_clobbers = 1;
                      return 568; /* *andsi3_lshiftrt_n_sb */
                    }
                }
            }
          if (XWINT (x4, 0) == 9L)
            {
              x5 = XEXP (x2, 1);
              if (GET_CODE (x5) == CONST_INT
                  && XWINT (x5, 0) == 4194304L)
                return 569; /* *andsi3_lshiftrt_9_sb */
            }
        }
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      operands[2] = x4;
      if (!immediate_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 1417 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX && INTVAL (operands[2]) >= 16))
        return 635; /* *combiner.md:1412 */
      if (pnum_clobbers == NULL
          || !
#line 1430 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX && INTVAL (operands[2]) >= 16))
        return -1;
      *pnum_clobbers = 1;
      return 636; /* *combiner.md:1424 */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case EQ:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern70 (x2))
        {
        case 0:
          if (!(
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 491 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_86 (insn, operands);

        case 1:
          if (!(
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 491 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_90 (insn, operands);

        case 2:
          if (!(
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 491 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_88 (insn, operands);

        case 3:
          if (!(
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 491 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_92 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern70 (x2))
        {
        case 0:
          if (!(
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 491 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_87 (insn, operands);

        case 1:
          if (!(
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 491 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_91 (insn, operands);

        case 2:
          if (!(
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 491 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_89 (insn, operands);

        case 3:
          if (!(
#line 489 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
(!TARGET_H8300SX) && 
#line 491 "../../gcc-15.0.1-20250313/gcc/config/h8300/testcompare.md"
( reload_completed)))
            return NULL;
          return gen_split_93 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern53 (x2))
        {
        case 0:
          if (bit_operand (operands[0], E_QImode)
              && bit_operand (operands[1], E_QImode))
            {
              if ((
#line 38 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(TARGET_H8300SX) && 
#line 40 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
                return gen_split_133 (insn, operands);
              if ((
#line 61 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(register_operand (operands[0], QImode)
   || single_zero_operand (operands[2], QImode)) && 
#line 64 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed && !single_zero_operand (operands[2], QImode))))
                return gen_split_134 (insn, operands);
            }
          if (!h8300_dst_operand (operands[0], E_QImode)
              || !h8300_dst_operand (operands[1], E_QImode)
              || !(
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
            return NULL;
          return gen_split_143 (insn, operands);

        case 1:
          if (!(
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
            return NULL;
          return gen_split_146 (insn, operands);

        case 2:
          if (!(
#line 217 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
(h8300_operands_match_p (operands)) && 
#line 219 "../../gcc-15.0.1-20250313/gcc/config/h8300/logical.md"
( reload_completed)))
            return NULL;
          return gen_split_149 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_SImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return NULL;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != CONST_INT
          || XWINT (x6, 0) != 2147450880L
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 227 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
        return NULL;
      return gen_split_219 (insn, operands);

    case LSHIFTRT:
      if (pattern54 (x2) != 0)
        return NULL;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) == CONST_INT)
        {
          operands[2] = x5;
          if (const_int_operand (operands[2], E_SImode))
            {
              x6 = XEXP (x2, 1);
              operands[3] = x6;
              if (single_one_operand (operands[3], E_SImode)
                  && (
#line 271 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(exact_log2 (INTVAL (operands[3])) < 16
   && INTVAL (operands[2]) + exact_log2 (INTVAL (operands[3])) == 31) && 
#line 274 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
                return gen_split_221 (insn, operands);
            }
          if (XWINT (x5, 0) == 9L)
            {
              x6 = XEXP (x2, 1);
              if (GET_CODE (x6) == CONST_INT
                  && XWINT (x6, 0) == 4194304L
                  && 
#line 301 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed))
                return gen_split_222 (insn, operands);
            }
        }
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_VOIDmode)
          || !(
#line 1417 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
(!TARGET_H8300SX && INTVAL (operands[2]) >= 16) && 
#line 1419 "../../gcc-15.0.1-20250313/gcc/config/h8300/combiner.md"
( reload_completed)))
        return NULL;
      return gen_split_263 (insn, operands);

    default:
      return NULL;
    }
}
