/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern12 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 29
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!r26_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[0] = x7;
  if (!div_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern26 (rtx x1, rtx_code i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 2);
  operands[1] = x6;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!uint5_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x1, 1);
      switch (GET_CODE (x7))
        {
        case LABEL_REF:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          return 0;

        case PC:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          return 1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x1, 1);
      switch (GET_CODE (x7))
        {
        case LABEL_REF:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          return 2;

        case PC:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[0], i1)
      || !scratch_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x6;
      if (!call_operand_address (operands[1], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x1, 0, 5);
      x8 = XEXP (x7, 0);
      if (XWINT (x8, 0) != 0L)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      return 0;

    case REG:
      if (REGNO (x6) != 22
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 5);
      x8 = XEXP (x7, 0);
      if (XWINT (x8, 0) != 1L)
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      return 1;

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST:
    case LABEL_REF:
      operands[1] = x2;
      if (pic_label_operand (operands[1], E_VOIDmode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (pmode_register_operand (operands[0], E_VOIDmode))
            {
              if (
#line 2620 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20))
                return 51; /* *pa.md:2617 */
              if (
#line 2670 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_PA_20))
                return 52; /* *pa.md:2667 */
            }
        }
      if (GET_CODE (x2) == LABEL_REF)
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              return 199; /* jump */
            }
        }
      break;

    case HIGH:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern14 (x2))
        {
        case 0:
          if (
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(symbolic_operand (operands[1], Pmode)
   && ! function_label_operand (operands[1], Pmode)
   && ! read_only_operand (operands[1], Pmode)
   && ! flag_pic))
            return 57; /* *pa.md:2759 */
          if (
#line 2810 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((!flag_pic || !symbolic_operand (operands[1], Pmode))
    && !pa_is_function_label_plus_const (operands[1])))
            return 59; /* *pa.md:2807 */
          break;

        case 1:
          return 80; /* *pa.md:4214 */

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (general_operand (operands[1], E_DImode))
    {
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (move_dest_operand (operands[0], E_DImode)
          && 
#line 4406 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && !TARGET_64BIT
   && TARGET_SOFT_FLOAT))
        return 84; /* *pa.md:4401 */
    }
  if (pnum_clobbers != NULL
      && reg_or_0_operand (operands[1], E_DImode))
    {
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == MEM
          && GET_MODE (x3) == E_DImode)
        {
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          if (register_operand (operands[0], E_SImode)
              && 
#line 10786 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_SOFT_FLOAT))
            {
              *pnum_clobbers = 1;
              return 266; /* atomic_storedi_1 */
            }
        }
    }
  if (pnum_clobbers == NULL
      || GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode)
      || !
#line 10733 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_64BIT && !TARGET_SOFT_FLOAT))
    return -1;
  *pnum_clobbers = 1;
  return 265; /* atomic_loaddi_1 */
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[2] = x2;
      if (comparison_operator (operands[2], E_CCFPmode))
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == REG
              && REGNO (x3) == 0
              && GET_MODE (x3) == E_CCFPmode)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (reg_or_0_operand (operands[0], E_SFmode)
                      && reg_or_0_operand (operands[1], E_SFmode)
                      && 
#line 714 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                    return 1; /* *pa.md:709 */
                  break;

                case E_DFmode:
                  if (reg_or_0_operand (operands[0], E_DFmode)
                      && reg_or_0_operand (operands[1], E_DFmode)
                      && 
#line 724 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                    return 2; /* *pa.md:719 */
                  break;

                default:
                  break;
                }
            }
        }
      if (!ordered_comparison_operator (x2, E_SImode))
        return -1;
      operands[3] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!arith11_operand (operands[2], E_SImode))
        return -1;
      return 5; /* scc */

    case NEG:
      return recog_9 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_7 (x1, insn, pnum_clobbers);

    case SMIN:
      if (pattern0 (x1) != 0)
        return -1;
      return 19; /* sminsi3 */

    case UMIN:
      if (pattern0 (x1) != 0)
        return -1;
      return 20; /* uminsi3 */

    case SMAX:
      if (pattern0 (x1) != 0)
        return -1;
      return 21; /* smaxsi3 */

    case UMAX:
      if (pattern0 (x1) != 0)
        return -1;
      return 22; /* umaxsi3 */

    case ABS:
      return recog_11 (x1, insn, pnum_clobbers);

    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 26; /* bswaphi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 27; /* bswapsi2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_13 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 2)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern42 (x2, 
E_SImode) != 0
                  || !
#line 2737 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && flag_pic))
                return -1;
              return 55; /* *pa.md:2733 */

            case E_DImode:
              if (pattern42 (x2, 
E_DImode) != 0
                  || !
#line 2748 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && TARGET_64BIT
   && flag_pic))
                return -1;
              return 56; /* *pa.md:2744 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern31 (x2, 
E_SImode) != 0
                  || !
#line 2843 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!pa_is_function_label_plus_const (operands[2])))
                return -1;
              return 60; /* *pa.md:2839 */

            case E_DImode:
              if (pattern31 (x2, 
E_DImode) != 0)
                return -1;
              return 85; /* *pa.md:4417 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_10 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !move_src_operand (operands[1], E_QImode)
              || !
#line 4758 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
            return -1;
          return 91; /* *pa.md:4754 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          if (move_src_operand (operands[1], E_QImode)
              && 
#line 4776 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
            return 92; /* *pa.md:4772 */
          if (!move_src_operand (operands[1], E_HImode)
              || !
#line 4794 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
            return -1;
          return 93; /* *pa.md:4790 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 94; /* extendhisi2 */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 96; /* extendqisi2 */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          return 95; /* extendqihi2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 4912 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 97; /* extendsfdf2 */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 4921 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 98; /* truncdfsf2 */

    case FLOAT:
      return recog_12 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 5030 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 105; /* fix_truncsfsi2 */

        case 1:
          if (!
#line 5038 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 106; /* fix_truncdfsi2 */

        case 2:
          if (!
#line 5046 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 107; /* fix_truncsfdi2 */

        case 3:
          if (!
#line 5054 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 108; /* fix_truncdfdi2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern15 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 5062 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 109; /* floatunssidf2_pa20 */

            case 1:
              if (!
#line 5086 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 112; /* floatunsdidf2 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern15 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 5070 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 110; /* floatunssisf2_pa20 */

            case 1:
              if (!
#line 5078 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 111; /* floatunsdisf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 5094 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 113; /* fixuns_truncsfsi2 */

        case 1:
          if (!
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 114; /* fixuns_truncdfsi2 */

        case 2:
          if (!
#line 5110 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 115; /* fixuns_truncsfdi2 */

        case 3:
          if (!
#line 5118 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 116; /* fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != ZERO_EXTEND
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 5629 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT && ! TARGET_SOFT_MULT))
            return -1;
          return 128; /* umulsidi3 */

        case REG:
        case SUBREG:
          switch (pattern6 (x2))
            {
            case 0:
              if (!
#line 6227 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 149; /* muldf3 */

            case 1:
              if (!
#line 6237 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 150; /* mulsf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!and_operand (operands[2], E_SImode))
            return -1;
          return 134; /* andsi3 */

        case NOT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 135; /* *pa.md:5973 */

        case ROTATE:
          if (pattern22 (x2) != 0
              || !
#line 6702 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(INTVAL (operands[1]) == -2))
            return -1;
          return 181; /* vdepi_and */

        case ASHIFT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!const_int_operand (operands[3], E_SImode)
              || !
#line 7185 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(exact_log2 (1 + (INTVAL (operands[3]) >> (INTVAL (operands[2]) & 31))) > 0))
            return -1;
          return 191; /* *pa.md:7180 */

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 143; /* *pa.md:6157 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 144; /* one_cmplsi2 */

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern6 (x2))
        {
        case 0:
          if (!
#line 6247 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 151; /* divdf3 */

        case 1:
          if (!
#line 6256 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 152; /* divsf3 */

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 159; /* sqrtdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6369 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 160; /* sqrtsf2 */

        default:
          return -1;
        }

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x10 = XEXP (x2, 2);
      operands[3] = x10;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern37 (x2, 
E_DFmode) != 0
                  || !
#line 6382 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 161; /* fmadf4 */

            case E_SFmode:
              if (pattern37 (x2, 
E_SFmode) != 0
                  || !
#line 6392 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 162; /* fmasf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern38 (x2, 
E_DFmode) != 0
                  || !
#line 6403 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 163; /* fnmadf4 */

            case E_SFmode:
              if (pattern38 (x2, 
E_SFmode) != 0
                  || !
#line 6413 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 164; /* fnmasf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (memory_operand (operands[1], E_SImode))
        {
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) == CONST_INT)
            {
              switch (XWINT (x5, 0))
                {
                case 24L:
                  return 173; /* *pa.md:6545 */

                case 16L:
                  return 174; /* *pa.md:6554 */

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!shift5_operand (operands[2], E_SImode))
        return -1;
      return 184; /* lshrsi3 */

    case ASHIFT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (pattern23 (x5))
        {
        case 0:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 177; /* *pa.md:6635 */

        case 1:
          if (arith5_operand (operands[1], E_SImode))
            return 178; /* zvdep32 */
          if (!lhs_lshift_cint_operand (operands[1], E_SImode))
            return -1;
          return 179; /* zvdep_imm32 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (pattern23 (x5))
        {
        case 0:
          return 182; /* *pa.md:6886 */

        case 1:
          return 183; /* vextrs32 */

        default:
          return -1;
        }

    case PLUS:
    case IOR:
    case XOR:
      return recog_8 (x1, insn, pnum_clobbers);

    case ROTATERT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!shift5_operand (operands[2], E_SImode))
        return -1;
      return 187; /* rotrsi3 */

    case ROTATE:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 188; /* *rotlsi3_internal */

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (pattern17 (x1) == 0
          && 
#line 9229 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(UINTVAL (operands[2]) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[3]) <= 32))
        return 226; /* extzv_32 */
      if (XWINT (x5, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 227; /* *pa.md:9235 */

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (pattern17 (x1) == 0
          && 
#line 9329 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(UINTVAL (operands[2]) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[3]) <= 32))
        return 228; /* extv_32 */
      if (XWINT (x5, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 229; /* *pa.md:9335 */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 3)
        return -1;
      x11 = XVECEXP (x2, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern14 (x2))
        {
        case 0:
          if (!
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == SImode))
            return -1;
          return 258; /* tp_loadsi */

        case 1:
          if (!
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == DImode))
            return -1;
          return 259; /* tp_loaddi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 6
          || GET_MODE (x2) != E_SImode)
        return -1;
      x11 = XVECEXP (x2, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 10876 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && !TARGET_64BIT))
        return -1;
      return 269; /* get_fpsr_32 */

    default:
      return -1;
    }
}
