/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != USE)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != USE)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x11 = XEXP (x2, 1);
  operands[1] = x11;
  if (!memory_operand (operands[1], E_BLKmode)
      || pattern3 (x1) != 0)
    return -1;
  return 0;
}

int
pattern20 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern38 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != i2)
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_0_operand (operands[1], i1)
      || !arith11_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  return pattern61 (x5, 
i1, 
i2); /* [-1, 0] */
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          if (GET_MODE (x5) == E_SImode)
            {
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (register_operand (operands[2], E_SImode))
                {
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  switch (GET_CODE (x5))
                    {
                    case GTU:
                      if (arith11_operand (operands[3], E_SImode))
                        return 12; /* *pa.md:941 */
                      break;

                    case LTU:
                      if (register_operand (operands[3], E_SImode))
                        return 14; /* *pa.md:985 */
                      break;

                    case LEU:
                      if (int11_operand (operands[3], E_SImode))
                        return 16; /* *pa.md:1030 */
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[4] = x5;
          if (!ordered_comparison_operator (operands[4], E_SImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          if (!arith11_operand (operands[3], E_SImode))
            return -1;
          return 18; /* decscc */

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !arith11_operand (operands[1], E_DImode)
                  || !reg_or_0_operand (operands[2], E_DImode))
                return -1;
              return 122; /* *pa.md:5349 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !arith11_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              if (
#line 5447 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_PA_20))
                return 124; /* *pa.md:5443 */
              if (!
#line 5458 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20))
                return -1;
              return 125; /* *pa.md:5454 */

            case E_DFmode:
              if (pattern5 (x3, 
E_DFmode) != 0
                  || !
#line 6207 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 147; /* subdf3 */

            case E_SFmode:
              if (pattern5 (x3, 
E_SFmode) != 0
                  || !
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 148; /* subsf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      switch (GET_CODE (x9))
        {
        case GTU:
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 1);
          operands[3] = x11;
          if (!arith11_operand (operands[3], E_SImode))
            return -1;
          return 13; /* *pa.md:961 */

        case LTU:
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 1);
          operands[3] = x11;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          return 15; /* *pa.md:1005 */

        case LEU:
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 1);
          operands[3] = x11;
          if (!int11_operand (operands[3], E_SImode))
            return -1;
          return 17; /* *pa.md:1050 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      if (peep2_current_count < 2)
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != PLUS
          || GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x4) != SET)
        return NULL;
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (!register_operand (x5, E_SImode))
            return NULL;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case CONST_INT:
              operands[2] = x6;
              if (!const_int_operand (operands[2], E_SImode))
                return NULL;
              operands[1] = x5;
              x7 = XEXP (x4, 1);
              switch (GET_CODE (x7))
                {
                case REG:
                case SUBREG:
                  operands[3] = x7;
                  x8 = XEXP (x4, 0);
                  if (GET_CODE (x8) != MEM)
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (!rtx_equal_p (x9, operands[0]))
                    return NULL;
                  switch (GET_MODE (x8))
                    {
                    case E_SImode:
                      if (!register_operand (operands[3], E_SImode)
                          || !
#line 2293 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_64BIT
   && !INT14_OK_STRICT
   && GENERAL_REGNO_P (REGNO (operands[0]))
   && GENERAL_REGNO_P (REGNO (operands[3]))
   && REGNO (operands[0]) != REGNO (operands[3])
   && base14_operand (operands[2], E_SImode)))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_1 (insn, operands);

                    case E_SFmode:
                      if (!register_operand (operands[3], E_SFmode)
                          || !
#line 4576 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_64BIT
   && !INT14_OK_STRICT
   && GENERAL_REGNO_P (REGNO (operands[0]))
   && GENERAL_REGNO_P (REGNO (operands[3]))
   && REGNO (operands[0]) != REGNO (operands[3])
   && base14_operand (operands[2], E_SImode)))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_13 (insn, operands);

                    default:
                      return NULL;
                    }

                case MEM:
                  x8 = XEXP (x4, 0);
                  operands[3] = x8;
                  x10 = XEXP (x7, 0);
                  if (!rtx_equal_p (x10, operands[0]))
                    return NULL;
                  switch (GET_MODE (operands[3]))
                    {
                    case E_SImode:
                      if (!register_operand (operands[3], E_SImode)
                          || GET_MODE (x7) != E_SImode)
                        return NULL;
                      if (
#line 2311 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_64BIT
   && !INT14_OK_STRICT
   && GENERAL_REGNO_P (REGNO (operands[0]))
   && GENERAL_REGNO_P (REGNO (operands[3]))
   && REGNO (operands[0]) != REGNO (operands[3])
   && REGNO (operands[1]) != REGNO (operands[3])
   && base14_operand (operands[2], E_SImode)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_2 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (!
#line 2328 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_64BIT
   && !INT14_OK_STRICT
   && GENERAL_REGNO_P (REGNO (operands[0]))
   && GENERAL_REGNO_P (REGNO (operands[3]))
   && REGNO (operands[0]) == REGNO (operands[3])
   && base14_operand (operands[2], E_SImode)))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_3 (insn, operands);

                    case E_SFmode:
                      if (!register_operand (operands[3], E_SFmode)
                          || GET_MODE (x7) != E_SFmode)
                        return NULL;
                      if (
#line 4592 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_64BIT
   && !INT14_OK_STRICT
   && GENERAL_REGNO_P (REGNO (operands[0]))
   && GENERAL_REGNO_P (REGNO (operands[3]))
   && REGNO (operands[0]) != REGNO (operands[3])
   && REGNO (operands[1]) != REGNO (operands[3])
   && base14_operand (operands[2], E_SImode)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_14 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (!
#line 4609 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_64BIT
   && !INT14_OK_STRICT
   && GENERAL_REGNO_P (REGNO (operands[0]))
   && GENERAL_REGNO_P (REGNO (operands[3]))
   && REGNO (operands[0]) == REGNO (operands[3])
   && base14_operand (operands[2], E_SImode)))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_15 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[2] = x6;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              operands[1] = x5;
              x8 = XEXP (x4, 0);
              if (GET_CODE (x8) != MEM)
                return NULL;
              x7 = XEXP (x4, 1);
              operands[3] = x7;
              x9 = XEXP (x8, 0);
              if (!rtx_equal_p (x9, operands[0]))
                return NULL;
              switch (GET_MODE (x8))
                {
                case E_SImode:
                  if (!register_operand (operands[3], E_SImode))
                    return NULL;
                  if (
#line 2380 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_5 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!
#line 2397 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_6 (insn, operands);

                case E_DFmode:
                  if (!register_operand (operands[3], E_DFmode))
                    return NULL;
                  if (
#line 4030 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_11 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!
#line 4047 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_12 (insn, operands);

                case E_SFmode:
                  if (!register_operand (operands[3], E_SFmode))
                    return NULL;
                  if (
#line 4659 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_17 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if (!
#line 4676 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_18 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFT:
              if (GET_MODE (x6) != E_SImode)
                return NULL;
              x11 = XEXP (x6, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              operands[2] = x5;
              x12 = XEXP (x6, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return NULL;
              x8 = XEXP (x4, 0);
              if (GET_CODE (x8) != MEM
                  || GET_MODE (x8) != E_DFmode)
                return NULL;
              x7 = XEXP (x4, 1);
              operands[3] = x7;
              if (!register_operand (operands[3], E_DFmode))
                return NULL;
              x9 = XEXP (x8, 0);
              if (!rtx_equal_p (x9, operands[0])
                  || !
#line 3978 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_10 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          x13 = XEXP (x5, 1);
          if (GET_CODE (x13) != CONST_INT)
            return NULL;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return NULL;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != MEM)
            return NULL;
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          x9 = XEXP (x8, 0);
          if (!rtx_equal_p (x9, operands[0]))
            return NULL;
          switch (XWINT (x13, 0))
            {
            case 2L:
              switch (GET_MODE (x8))
                {
                case E_SImode:
                  if (!register_operand (operands[3], E_SImode)
                      || !
#line 2346 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_4 (insn, operands);

                case E_SFmode:
                  if (!register_operand (operands[3], E_SFmode)
                      || !
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_16 (insn, operands);

                default:
                  return NULL;
                }

            case 3L:
              if (GET_MODE (x8) != E_DFmode
                  || !register_operand (operands[3], E_DFmode)
                  || !
#line 3961 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_9 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 8:
          if (pattern4 (x1) != 0
              || !
#line 3392 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_64BIT
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)
   && GET_CODE (operands[1]) == MEM
   && register_operand (XEXP (operands[1], 0), SImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_7 (insn, operands);

        case 5:
          x15 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x15) != SET)
            return NULL;
          x16 = XEXP (x15, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x17 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x17) != CLOBBER)
            return NULL;
          x18 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x18) != CLOBBER)
            return NULL;
          x19 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x19) != USE)
            return NULL;
          x20 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x20) != USE
              || pattern41 (x1) != 0
              || !
#line 3711 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_64BIT
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_8 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
