/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern11 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case TRAP_IF:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != NE)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != i1)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTEND)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != i1)
        return -1;
      x9 = XEXP (x2, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      operands[1] = x13;
      x14 = XEXP (x12, 1);
      operands[2] = x14;
      x15 = XEXP (x5, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x16 = XEXP (x6, 0);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      x17 = XEXP (x8, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x18 = XEXP (x8, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          return 0;

        case E_SImode:
          return 1;

        default:
          return -1;
        }

    case SET:
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != MULT)
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      if (!register_operand (operands[3], E_VOIDmode))
        return -1;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_VOIDmode))
        return -1;
      x14 = XEXP (x12, 1);
      operands[5] = x14;
      if (!register_operand (operands[5], E_VOIDmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x19 = XEXP (x9, 0);
      operands[1] = x19;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      x20 = XEXP (x9, 1);
      operands[2] = x20;
      if (!register_operand (operands[2], E_VOIDmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x5;
      if (!call_operand_address (operands[1], E_VOIDmode))
        return -1;
      return 0;

    case REG:
      if (REGNO (x5) != 22
          || GET_MODE (x5) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case IOR:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      if (GET_MODE (x3) == E_SImode
          && register_operand (operands[0], E_SImode))
        {
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_SImode))
                return 138; /* xorsi3 */
            }
        }
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_SImode)
      || !plus_xor_ior_operator (x3, E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      if (GET_CODE (x5) != LSHIFTRT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case MINUS:
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          operands[4] = x3;
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          return 185; /* *shrpsi4_1 */

        case CONST_INT:
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          operands[5] = x3;
          x11 = XEXP (x5, 1);
          operands[4] = x11;
          if (!const_int_operand (operands[4], E_SImode)
              || !
#line 7145 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(INTVAL (operands[3]) + INTVAL (operands[4]) == 32))
            return -1;
          return 189; /* *pa.md:7138 */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_CODE (x5) != ASHIFT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x5, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          operands[4] = x3;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          return 186; /* *shrpsi4_2 */

        case CONST_INT:
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          operands[5] = x3;
          x11 = XEXP (x5, 1);
          operands[3] = x11;
          if (!const_int_operand (operands[3], E_SImode)
              || !
#line 7157 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(INTVAL (operands[3]) + INTVAL (operands[4]) == 32))
            return -1;
          return 190; /* *pa.md:7150 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case RETURN:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER
          || pattern10 (x1, 
1, 
2, 
USE) != 0
          || !
#line 7231 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_NO_SPACE_REGS
   && !TARGET_PA_20
   && flag_pic && crtl->calls_eh_return))
        return -1;
      return 194; /* return_external_pic */

    case SET:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case MEM:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != PLUS)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MULT)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) != PC)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x11 = XEXP (x6, 0);
          operands[0] = x11;
          x12 = XEXP (x8, 0);
          operands[1] = x12;
          x13 = XEXP (x3, 0);
          operands[2] = x13;
          x14 = XEXP (x10, 0);
          operands[3] = x14;
          switch (XWINT (x7, 0))
            {
            case 4L:
              if (pattern59 (x4, 
E_SImode) != 0
                  || !
#line 7499 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(flag_pic))
                return -1;
              return 203; /* casesi32p */

            case 8L:
              if (pattern59 (x4, 
E_DImode) != 0)
                return -1;
              return 204; /* casesi64p */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x5 = XEXP (x4, 0);
          if (!ordered_comparison_operator (x5, E_VOIDmode))
            return -1;
          operands[2] = x5;
          if (pattern27 (x1) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          x11 = XEXP (x6, 0);
          operands[0] = x11;
          if (!reg_before_reload_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x6, 1);
          operands[1] = x7;
          if (!int5_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x4, 1);
          x16 = XEXP (x15, 0);
          operands[3] = x16;
          x14 = XEXP (x10, 0);
          operands[4] = x14;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          x17 = XEXP (x3, 1);
          x18 = XEXP (x17, 0);
          if (!rtx_equal_p (x18, operands[0]))
            return -1;
          x19 = XEXP (x17, 1);
          if (!rtx_equal_p (x19, operands[1]))
            return -1;
          x13 = XEXP (x3, 0);
          if (!rtx_equal_p (x13, operands[0]))
            return -1;
          return 232; /* decrement_and_branch_until_zero */

        case UNSPEC:
          if (XVECLEN (x4, 0) != 1)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          x13 = XEXP (x3, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 1)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != USE)
            return -1;
          x14 = XEXP (x10, 0);
          if (GET_CODE (x14) != REG)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x20 = XVECEXP (x4, 0, 0);
          operands[1] = x20;
          switch (XINT (x4, 1))
            {
            case 4:
              if (pattern51 (x1, 
27) != 0)
                return -1;
              return 252; /* tgd_load */

            case 10:
              if (pattern51 (x1, 
19) != 0)
                return -1;
              return 253; /* tgd_load_picsi */

            case 5:
              if (pattern52 (x1, 
27) != 0)
                return -1;
              return 254; /* tld_load */

            case 11:
              if (pattern52 (x1, 
19) != 0)
                return -1;
              return 255; /* tld_load_picsi */

            case 8:
              if (GET_MODE (x4) != E_SImode
                  || REGNO (x14) != 27
                  || GET_MODE (x14) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || !tie_symbolic_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x13) != E_SImode)
                return -1;
              return 260; /* tie_load */

            case 12:
              if (!tie_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              switch (REGNO (x14))
                {
                case 19:
                  if (pattern56 (x1, 
E_SImode) != 0)
                    return -1;
                  return 261; /* tie_load_picsi */

                case 27:
                  if (pattern56 (x1, 
E_DImode) != 0)
                    return -1;
                  return 262; /* tie_load_picdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x9 = XEXP (x2, 0);
      if (GET_CODE (x9) != MEM
          || GET_MODE (x9) != E_SImode)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET
          || pattern28 (x1) != 0)
        return -1;
      x21 = XEXP (x9, 0);
      operands[0] = x21;
      if (!call_operand_address (operands[0], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      x17 = XEXP (x3, 1);
      x19 = XEXP (x17, 1);
      x22 = XEXP (x19, 0);
      operands[2] = x22;
      if (!
#line 8783 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT))
        return -1;
      return 217; /* call_mcount_nonpic */

    case UNSPEC_VOLATILE:
      if (pnum_clobbers == NULL
          || XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 4)
        return -1;
      x23 = XVECEXP (x2, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != USE
          || pattern10 (x1, 
29, 
28, 
USE) != 0)
        return -1;
      *pnum_clobbers = 7;
      return 249; /* outline_epilogue_call */

    default:
      return -1;
    }
}
