/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith11_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      return pattern14 (x1); /* [-1, 1] */

    case MINUS:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (XWINT (x4, 0))
        {
        case 31L:
          return 2;

        case 63L:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x8 = XEXP (x3, 2);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XEXP (x2, 0);
  if (GET_CODE (x9) != PC)
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PLUS
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !uint5_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !uint32_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith14_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !arith11_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !arith11_operand (operands[4], i1)
      || !reg_or_cint_move_operand (operands[1], i1)
      || !reg_or_cint_move_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern78 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 27
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 29)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  x9 = XEXP (x8, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[2] = x11;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !arith11_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  return pattern91 (x5, 
i1, 
i2); /* [-1, 0] */
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_CODE (x3))
        {
        case LEU:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern64 (x2, 
E_SImode) == 0)
                return 11; /* *pa.md:850 */
              break;

            case E_DImode:
              if (pattern64 (x2, 
E_DImode) == 0)
                return 12; /* *pa.md:860 */
              break;

            default:
              break;
            }
          break;

        case GEU:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern65 (x2, 
E_SImode) == 0)
                return 13; /* *pa.md:872 */
              break;

            case E_DImode:
              if (pattern65 (x2, 
E_DImode) == 0)
                return 14; /* *pa.md:882 */
              break;

            default:
              break;
            }
          break;

        case GTU:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern66 (x2, 
E_SImode) == 0)
                return 15; /* *pa.md:895 */
              break;

            case E_DImode:
              if (pattern66 (x2, 
E_DImode) == 0)
                return 16; /* *pa.md:905 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[4] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern67 (x2, 
E_SImode) != 0)
            return -1;
          return 17; /* incscc */

        case E_DImode:
          if (pattern67 (x2, 
E_DImode) != 0)
            return -1;
          return 18; /* *pa.md:928 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case HIGH:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern50 (x2, 
E_SImode) != 0)
                return -1;
              if (
#line 2714 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && flag_pic))
                return 90; /* *pa.md:2710 */
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 2789 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(reload_completed))
                return -1;
              return 95; /* *pa.md:2785 */

            case E_DImode:
              if (pattern50 (x2, 
E_DImode) != 0)
                return -1;
              if (
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && TARGET_64BIT
   && flag_pic))
                return 91; /* *pa.md:2721 */
              if (!const_int_operand (operands[2], E_VOIDmode)
                  || !
#line 2800 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(reload_completed && TARGET_64BIT))
                return -1;
              return 96; /* *pa.md:2796 */

            default:
              return -1;
            }

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern53 (x2, 
E_HImode) != 0)
                return -1;
              return 109; /* addhi3 */

            case E_DImode:
              if (pattern53 (x2, 
E_DImode) != 0)
                return -1;
              return 171; /* *pa.md:5152 */

            case E_SImode:
              if (pattern53 (x2, 
E_SImode) != 0)
                return -1;
              return 175; /* addsi3 */

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) != 0)
                return -1;
              return 181; /* addti3 */

            case E_DFmode:
              if (pattern10 (x2, 
E_DFmode) != 0
                  || !
#line 6187 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 210; /* adddf3 */

            case E_SFmode:
              if (pattern10 (x2, 
E_SFmode) != 0
                  || !
#line 6197 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 211; /* addsf3 */

            default:
              return -1;
            }

        case MINUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != LABEL_REF
              || GET_MODE (x8) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          return 273; /* load_offset_label_address */

        default:
          return -1;
        }

    case NOT:
      switch (pattern19 (x2))
        {
        case 0:
          return 172; /* *pa.md:5164 */

        case 1:
          return 173; /* *pa.md:5173 */

        default:
          return -1;
        }

    case ASHIFT:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern54 (x2, 
E_SImode) != 0)
            return -1;
          return 238; /* *pa.md:6563 */

        case E_DImode:
          if (pattern54 (x2, 
E_DImode) != 0)
            return -1;
          return 240; /* *pa.md:6588 */

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern55 (x2, 
E_SImode) != 0)
            return -1;
          return 239; /* *pa.md:6573 */

        case E_DImode:
          if (pattern55 (x2, 
E_DImode) != 0)
            return -1;
          return 241; /* *pa.md:6598 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x3, 0) != 1)
        return -1;
      x10 = XVECEXP (x3, 0, 0);
      operands[1] = x10;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (XINT (x3, 1))
        {
        case 6:
          if (!tld_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern71 (x2, 
E_SImode) != 0
                  || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == SImode))
                return -1;
              *pnum_clobbers = 1;
              return 329; /* tld_offset_loadsi */

            case E_DImode:
              if (pattern71 (x2, 
E_DImode) != 0
                  || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 330; /* tld_offset_loaddi */

            default:
              return -1;
            }

        case 9:
          if (!tle_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern71 (x2, 
E_SImode) != 0
                  || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == SImode))
                return -1;
              *pnum_clobbers = 1;
              return 333; /* tle_loadsi */

            case E_DImode:
              if (pattern71 (x2, 
E_DImode) != 0
                  || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 334; /* tle_loaddi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
