/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 2
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 27
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x9) != USE)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 29
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x11) != USE)
    return -1;
  x12 = XEXP (x11, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern24 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 29
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!r26_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[0] = x7;
  if (!div_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern36 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern42 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !arith11_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern65 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern73 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !plus_xor_ior_operator (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !int5_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !int5_operand (operands[2], E_DImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[3] = x4;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern41 (x3, 
E_SImode) != 0)
            return -1;
          return 9; /* negscc */

        case E_DImode:
          if (pattern41 (x3, 
E_DImode) != 0)
            return -1;
          return 10; /* *pa.md:834 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 202; /* *pa.md:6072 */

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode))
            return -1;
          return 203; /* negti2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 206; /* negsi2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 6297 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
            return -1;
          return 218; /* negdf2_fast */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6331 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
            return -1;
          return 219; /* negsf2_fast */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern32 (x3, 
E_DFmode) != 0
              || !
#line 6422 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 228; /* *pa.md:6419 */

        case E_SFmode:
          if (pattern32 (x3, 
E_SFmode) != 0
              || !
#line 6430 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 229; /* *pa.md:6427 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern34 (x3, 
E_DFmode) != 0
              || !
#line 6479 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
            return -1;
          return 232; /* *pa.md:6475 */

        case E_SFmode:
          if (pattern34 (x3, 
E_SFmode) != 0
              || !
#line 6488 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
            return -1;
          return 233; /* *pa.md:6484 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
          if (XWINT (x4, 0) != 0L)
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_BLKmode)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != USE)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != USE)
            return -1;
          x9 = XEXP (x5, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_DImode)
              || pattern7 (x1) != 0)
            return -1;
          return 122; /* clrmemdi_prereload */

        case MULT:
          if (pattern29 (x1) != 0)
            return -1;
          return 187; /* *pa.md:5649 */

        case DIV:
          if (pattern30 (x1) != 0)
            return -1;
          return 188; /* *pa.md:5774 */

        case UDIV:
          if (pattern30 (x1) != 0)
            return -1;
          return 189; /* *pa.md:5823 */

        case MOD:
          if (pattern29 (x1) != 0)
            return -1;
          return 190; /* *pa.md:5870 */

        case UMOD:
          if (pattern29 (x1) != 0)
            return -1;
          return 191; /* *pa.md:5917 */

        case CALL:
          x10 = XEXP (x4, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_SImode)
            return -1;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 2
              || GET_MODE (x11) != E_DImode)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != USE)
            return -1;
          x12 = XEXP (x6, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 27
              || GET_MODE (x12) != E_DImode)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != USE)
            return -1;
          x13 = XEXP (x7, 0);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 29
              || GET_MODE (x13) != E_DImode)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != USE)
            return -1;
          x14 = XEXP (x8, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x15 = XEXP (x10, 0);
          operands[1] = x15;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x16 = XEXP (x4, 1);
          operands[2] = x16;
          return 289; /* *call_val_reg_64bit_post_reload */

        default:
          return -1;
        }

    case CALL:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x7) != USE)
        return -1;
      x13 = XEXP (x7, 0);
      if (GET_CODE (x13) != REG
          || GET_MODE (x13) != E_DImode)
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x8) != USE)
        return -1;
      x9 = XEXP (x5, 0);
      operands[0] = x9;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (GET_CODE (operands[0]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER
              || pattern80 (x1, 
29, 
27, 
USE, 
E_DImode, 
2) != 0)
            return -1;
          x14 = XEXP (x8, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          return 285; /* *call_reg_64bit_post_reload */

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (!call_operand_address (operands[0], E_VOIDmode))
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != SET)
            return -1;
          x17 = XEXP (x3, 1);
          if (GET_CODE (x17) != PLUS
              || GET_MODE (x17) != E_SImode)
            return -1;
          x18 = XEXP (x17, 0);
          if (GET_CODE (x18) != REG
              || REGNO (x18) != 2
              || GET_MODE (x18) != E_SImode)
            return -1;
          x19 = XEXP (x17, 1);
          if (GET_CODE (x19) != MINUS
              || GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XEXP (x19, 1);
          if (GET_CODE (x20) != PLUS
              || GET_MODE (x20) != E_SImode)
            return -1;
          x21 = XEXP (x20, 0);
          if (GET_CODE (x21) != PC)
            return -1;
          x22 = XEXP (x20, 1);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
              || pattern80 (x1, 
27, 
2, 
CLOBBER, 
E_SImode, 
25) != 0)
            return -1;
          x14 = XEXP (x8, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 29
              || GET_MODE (x14) != E_DImode)
            return -1;
          x23 = XEXP (x19, 0);
          operands[2] = x23;
          return 291; /* *call_mcount_64bit_post_reload */

        default:
          return -1;
        }

    case CONST_INT:
      if (pnum_clobbers == NULL
          || XWINT (x2, 0) != 1L)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (pattern28 (x3, 
1) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x7) != USE)
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x8) != USE)
        return -1;
      x12 = XEXP (x6, 0);
      operands[0] = x12;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      x13 = XEXP (x7, 0);
      operands[1] = x13;
      if (!pmode_register_operand (operands[1], E_VOIDmode))
        return -1;
      x14 = XEXP (x8, 0);
      operands[2] = x14;
      if (!pmode_register_operand (operands[2], E_VOIDmode))
        return -1;
      if (
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == SImode))
        {
          *pnum_clobbers = 1;
          return 320; /* dcacheflushsi */
        }
      if (!
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == DImode))
        return -1;
      *pnum_clobbers = 1;
      return 321; /* dcacheflushdi */

    default:
      return -1;
    }
}
