/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern0 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern0 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern18 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern38 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern60 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !ordered_comparison_operator (operands[4], i1)
      || !register_operand (operands[2], i1)
      || !arith11_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, unsigned int i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i5
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i4
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i3
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i2
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      x8 = XEXP (x2, 2);
      if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern69 (x2, 
E_SImode) == 0)
                return 48; /* *pa.md:1274 */
              break;

            case E_DImode:
              if (pattern69 (x2, 
E_DImode) == 0)
                return 50; /* *pa.md:1328 */
              break;

            default:
              break;
            }
        }
      operands[5] = x5;
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern70 (x2, 
E_SImode) != 0)
            return -1;
          return 49; /* *pa.md:1291 */

        case E_DImode:
          if (pattern70 (x2, 
E_DImode) != 0)
            return -1;
          return 51; /* *pa.md:1346 */

        default:
          return -1;
        }

    case LABEL_REF:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (arith5_operand (operands[2], E_SImode)
          && reg_or_0_operand (operands[1], E_SImode))
        {
          x9 = XEXP (x3, 0);
          operands[0] = x9;
          return 52; /* *pa.md:1423 */
        }
      if (!reg_or_0_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      return 54; /* *pa.md:1479 */

    case PC:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (arith5_operand (operands[2], E_SImode)
          && reg_or_0_operand (operands[1], E_SImode))
        {
          x10 = XEXP (x8, 0);
          operands[0] = x10;
          return 53; /* *pa.md:1452 */
        }
      if (!reg_or_0_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      return 55; /* *pa.md:1508 */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      if (ordered_comparison_operator (x3, E_VOIDmode))
        {
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GTU:
        case LEU:
          operands[3] = x3;
          if (cmpib_comparison_operator (operands[3], E_VOIDmode))
            {
              res = recog_2 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x4 = XEXP (x3, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) != PC)
            return -1;
          switch (GET_CODE (x3))
            {
            case NE:
              x6 = XEXP (x3, 0);
              switch (GET_CODE (x6))
                {
                case ZERO_EXTRACT:
                  switch (pattern45 (x2))
                    {
                    case 0:
                      return 58; /* *pa.md:1591 */

                    case 1:
                      return 59; /* *pa.md:1619 */

                    case 2:
                      return 60; /* *pa.md:1647 */

                    case 3:
                      return 61; /* *pa.md:1675 */

                    case 4:
                      return 66; /* *pa.md:1816 */

                    case 5:
                      return 67; /* *pa.md:1844 */

                    case 6:
                      return 68; /* *pa.md:1872 */

                    case 7:
                      return 69; /* *pa.md:1900 */

                    default:
                      return -1;
                    }

                case REG:
                  if (REGNO (x6) != 0
                      || GET_MODE (x6) != E_CCFPmode)
                    return -1;
                  x7 = XEXP (x2, 1);
                  switch (GET_CODE (x7))
                    {
                    case LABEL_REF:
                      x8 = XEXP (x2, 2);
                      if (GET_CODE (x8) != PC)
                        return -1;
                      x9 = XEXP (x7, 0);
                      operands[0] = x9;
                      if (!
#line 2049 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
                        return -1;
                      return 74; /* *pa.md:2045 */

                    case PC:
                      x8 = XEXP (x2, 2);
                      if (GET_CODE (x8) != LABEL_REF)
                        return -1;
                      x10 = XEXP (x8, 0);
                      operands[0] = x10;
                      if (!
#line 2093 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
                        return -1;
                      return 75; /* *pa.md:2089 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case EQ:
              x6 = XEXP (x3, 0);
              if (GET_CODE (x6) != ZERO_EXTRACT)
                return -1;
              switch (pattern45 (x2))
                {
                case 0:
                  return 62; /* *pa.md:1703 */

                case 1:
                  return 63; /* *pa.md:1731 */

                case 2:
                  return 64; /* *pa.md:1759 */

                case 3:
                  return 65; /* *pa.md:1787 */

                case 4:
                  return 70; /* *pa.md:1928 */

                case 5:
                  return 71; /* *pa.md:1956 */

                case 6:
                  return 72; /* *pa.md:1984 */

                case 7:
                  return 73; /* *pa.md:2012 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      if (peep2_current_count < 2)
        return NULL;
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != PLUS)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x4) != SET)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MEM)
        return NULL;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x5, 0);
      if (!rtx_equal_p (x7, operands[0]))
        return NULL;
      x8 = XEXP (x2, 0);
      switch (GET_CODE (x8))
        {
        case ASHIFT:
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != CONST_INT)
            return NULL;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          x11 = XEXP (x2, 1);
          operands[2] = x11;
          switch (XWINT (x9, 0))
            {
            case 2L:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  switch (pattern81 (x2, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 2346 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_1 (insn, operands);

                    case 1:
                      if (!
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_20 (insn, operands);

                    default:
                      return NULL;
                    }

                case E_DImode:
                  switch (pattern81 (x2, 
E_DImode))
                    {
                    case 0:
                      if (!
#line 2363 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_2 (insn, operands);

                    case 1:
                      if (!
#line 4642 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_21 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case 3L:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern18 (x2, 
E_SImode) != 0
                      || GET_MODE (x5) != E_DFmode
                      || !register_operand (operands[3], E_DFmode)
                      || !
#line 3961 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_9 (insn, operands);

                case E_DImode:
                  if (pattern18 (x2, 
E_DImode) != 0)
                    return NULL;
                  switch (GET_MODE (x5))
                    {
                    case E_DFmode:
                      if (!register_operand (operands[3], E_DFmode)
                          || !
#line 3995 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_11 (insn, operands);

                    case E_DImode:
                      if (!register_operand (operands[3], E_DImode)
                          || !
#line 4354 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_17 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          x11 = XEXP (x2, 1);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[2] = x11;
              operands[1] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern10 (x2, 
E_SImode) != 0)
                    return NULL;
                  switch (GET_MODE (x5))
                    {
                    case E_SImode:
                      if (!register_operand (operands[3], E_SImode))
                        return NULL;
                      if (
#line 2380 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_3 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (!
#line 2397 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_4 (insn, operands);

                    case E_DFmode:
                      if (!register_operand (operands[3], E_DFmode))
                        return NULL;
                      if (
#line 4030 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_13 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (!
#line 4047 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_14 (insn, operands);

                    case E_SFmode:
                      if (!register_operand (operands[3], E_SFmode))
                        return NULL;
                      if (
#line 4659 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_22 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (!
#line 4676 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_23 (insn, operands);

                    default:
                      return NULL;
                    }

                case E_DImode:
                  if (pattern10 (x2, 
E_DImode) != 0)
                    return NULL;
                  switch (GET_MODE (x5))
                    {
                    case E_SImode:
                      if (!register_operand (operands[3], E_SImode))
                        return NULL;
                      if (
#line 2414 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_5 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (!
#line 2432 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_6 (insn, operands);

                    case E_DFmode:
                      if (!register_operand (operands[3], E_DFmode))
                        return NULL;
                      if (
#line 4064 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_15 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (!
#line 4082 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_16 (insn, operands);

                    case E_DImode:
                      if (!register_operand (operands[3], E_DImode))
                        return NULL;
                      if (
#line 4371 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_18 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (!
#line 4389 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_19 (insn, operands);

                    case E_SFmode:
                      if (!register_operand (operands[3], E_SFmode))
                        return NULL;
                      if (
#line 4693 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_INDEX_P (operands[1])
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_24 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (!
#line 4711 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && TARGET_NO_SPACE_REGS
   && REG_OK_FOR_BASE_P (operands[1])
   && REG_OK_FOR_INDEX_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                        return NULL;
                      *pmatch_len_ = 1;
                      return gen_peephole2_25 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case ASHIFT:
              x12 = XEXP (x11, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              operands[2] = x8;
              x13 = XEXP (x11, 0);
              operands[1] = x13;
              if (GET_MODE (x5) != E_DFmode
                  || !register_operand (operands[3], E_DFmode))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern88 (x2, 
E_SImode) != 0
                      || !
#line 3978 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_10 (insn, operands);

                case E_DImode:
                  if (pattern88 (x2, 
E_DImode) != 0
                      || !
#line 4013 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && TARGET_64BIT
   && REG_OK_FOR_BASE_P (operands[2])
   && FP_REGNO_P (REGNO (operands[3]))))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_12 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 8:
          if (pattern6 (x1) != 0
              || !
#line 3580 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), DImode)
   && GET_CODE (operands[1]) == MEM
   && register_operand (XEXP (operands[1], 0), DImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_7 (insn, operands);

        case 5:
          if (pattern8 (x1) != 0
              || !
#line 3825 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), DImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_8 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
