/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      return pattern10 (x1, 
E_DFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern10 (x1, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern18 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern18 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 29
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 25
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 2
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x3, 0);
  operands[1] = x11;
  if (!r26_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[0] = x12;
  if (!r25_operand (operands[0], E_SImode))
    return -1;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[2] = x14;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern56 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != i2)
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !int11_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern74 (rtx x1, int i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 27
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 29)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  x9 = XEXP (x8, 0);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern87 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[0], i1)
      || !scratch_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 27)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 29
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  x11 = XEXP (x2, 0);
  operands[3] = x11;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          switch (GET_CODE (x5))
            {
            case GTU:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern57 (x3, 
E_SImode) == 0)
                    return 19; /* *pa.md:941 */
                  break;

                case E_DImode:
                  if (pattern57 (x3, 
E_DImode) == 0)
                    return 20; /* *pa.md:951 */
                  break;

                default:
                  break;
                }
              break;

            case LTU:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern58 (x3, 
E_SImode) == 0)
                    return 23; /* *pa.md:985 */
                  break;

                case E_DImode:
                  if (pattern58 (x3, 
E_DImode) == 0)
                    return 24; /* *pa.md:995 */
                  break;

                default:
                  break;
                }
              break;

            case LEU:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern59 (x3, 
E_SImode) == 0)
                    return 27; /* *pa.md:1030 */
                  break;

                case E_DImode:
                  if (pattern59 (x3, 
E_DImode) == 0)
                    return 28; /* *pa.md:1040 */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern60 (x3, 
E_SImode) != 0)
                return -1;
              return 31; /* decscc */

            case E_DImode:
              if (pattern60 (x3, 
E_DImode) != 0)
                return -1;
              return 32; /* *pa.md:1085 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern42 (x3, 
E_DImode) != 0)
                return -1;
              return 177; /* *pa.md:5337 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !arith11_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              return 179; /* *pa.md:5454 */

            case E_TImode:
              if (pattern42 (x3, 
E_TImode) != 0)
                return -1;
              return 183; /* subti3 */

            case E_DFmode:
              if (pattern10 (x3, 
E_DFmode) != 0
                  || !
#line 6207 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 212; /* subdf3 */

            case E_SFmode:
              if (pattern10 (x3, 
E_SFmode) != 0
                  || !
#line 6217 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 213; /* subsf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x5 = XEXP (x3, 1);
      operands[4] = x5;
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case GTU:
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          x11 = XEXP (x9, 1);
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern61 (x3, 
E_SImode) != 0)
                return -1;
              return 21; /* *pa.md:961 */

            case E_DImode:
              if (pattern61 (x3, 
E_DImode) != 0)
                return -1;
              return 22; /* *pa.md:972 */

            default:
              return -1;
            }

        case LTU:
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          x11 = XEXP (x9, 1);
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern62 (x3, 
E_SImode) != 0)
                return -1;
              return 25; /* *pa.md:1005 */

            case E_DImode:
              if (pattern62 (x3, 
E_DImode) != 0)
                return -1;
              return 26; /* *pa.md:1016 */

            default:
              return -1;
            }

        case LEU:
          x10 = XEXP (x9, 0);
          operands[2] = x10;
          x11 = XEXP (x9, 1);
          operands[3] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern63 (x3, 
E_SImode) != 0)
                return -1;
              return 29; /* *pa.md:1050 */

            case E_DImode:
              if (pattern63 (x3, 
E_DImode) != 0)
                return -1;
              return 30; /* *pa.md:1061 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != PARALLEL)
    return NULL;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x3;
          if (!symbolic_operand (operands[1], E_SImode))
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 2865 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! (flag_pic && pic_label_operand (operands[1], SImode))))
            return NULL;
          return gen_split_1 (insn, operands);

        case REG:
        case SUBREG:
          operands[4] = x3;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != MEM)
            return NULL;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != E_SImode)
            return NULL;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != MULT
              || GET_MODE (x8) != E_SImode)
            return NULL;
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != PLUS
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x10 = XEXP (x8, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x8, 1);
          operands[1] = x11;
          if (!mem_shadd_operand (operands[1], E_SImode))
            return NULL;
          x12 = XEXP (x9, 0);
          operands[2] = x12;
          if (!register_operand (operands[2], E_SImode))
            return NULL;
          x13 = XEXP (x9, 1);
          operands[3] = x13;
          if (!const_int_operand (operands[3], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[5] = x6;
          if (!register_operand (operands[5], E_SImode))
            return NULL;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[4], E_SImode))
                return NULL;
              return gen_split_2 (insn, operands);

            case E_HImode:
              if (!register_operand (operands[4], E_HImode))
                return NULL;
              return gen_split_3 (insn, operands);

            case E_QImode:
              if (!register_operand (operands[4], E_QImode))
                return NULL;
              return gen_split_4 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x14 = XEXP (x3, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (!register_operand (operands[4], E_SImode))
            return NULL;
          if (
#line 5244 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! pa_cint_ok_for_move (UINTVAL (operands[2]))
   && VAL_14_BITS_P (INTVAL (operands[2]) >> 1)))
            return gen_split_7 (insn, operands);
          if (!
#line 5263 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! pa_cint_ok_for_move (UINTVAL (operands[2]))))
            return NULL;
          return gen_split_8 (insn, operands);

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x14 = XEXP (x3, 0);
          switch (GET_CODE (x14))
            {
            case ABS:
              switch (pattern37 (x1))
                {
                case 0:
                  if (!
#line 6449 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                    return NULL;
                  return gen_split_9 (insn, operands);

                case 1:
                  if (!
#line 6468 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                    return NULL;
                  return gen_split_10 (insn, operands);

                default:
                  return NULL;
                }

            case MULT:
              switch (pattern39 (x1))
                {
                case 0:
                  if (!
#line 6512 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
                    return NULL;
                  return gen_split_11 (insn, operands);

                case 1:
                  if (!
#line 6536 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20&& !flag_signed_zeros))
                    return NULL;
                  return gen_split_12 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 8:
      if (pattern6 (x1) != 0
          || !
#line 3546 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed && !flag_peephole2
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), DImode)
   && GET_CODE (operands[1]) == MEM
   && register_operand (XEXP (operands[1], 0), DImode)))
        return NULL;
      return gen_split_5 (insn, operands);

    case 5:
      if (pattern8 (x1) != 0
          || !
#line 3802 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed && !flag_peephole2
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), DImode)))
        return NULL;
      return gen_split_6 (insn, operands);

    case 7:
      if (pattern9 (x1) != 0)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case CALL:
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!call_operand_address (operands[0], E_VOIDmode))
            return NULL;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x16 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x16, 0);
          operands[2] = x17;
          if (
#line 7799 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
            return gen_split_13 (insn, operands);
          if (!
#line 7820 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed))
            return NULL;
          return gen_split_14 (insn, operands);

        case SET:
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != CALL)
            return NULL;
          x14 = XEXP (x3, 0);
          if (GET_CODE (x14) != MEM
              || GET_MODE (x14) != E_SImode)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x18 = XEXP (x14, 0);
          operands[1] = x18;
          if (!call_operand_address (operands[1], E_VOIDmode))
            return NULL;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          x16 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x16, 0);
          operands[3] = x17;
          if (
#line 8404 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
            return gen_split_17 (insn, operands);
          if (!
#line 8427 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed))
            return NULL;
          return gen_split_18 (insn, operands);

        default:
          return NULL;
        }

    case 6:
      x19 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x19) != CLOBBER)
        return NULL;
      x20 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x20) != USE)
        return NULL;
      x21 = XEXP (x20, 0);
      if (GET_CODE (x21) != REG
          || GET_MODE (x21) != E_DImode)
        return NULL;
      x22 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x22) != USE)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case CALL:
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          switch (GET_CODE (operands[0]))
            {
            case REG:
            case SUBREG:
              if (pattern78 (x1, 
E_VOIDmode) != 0)
                return NULL;
              if (
#line 7973 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_15 (insn, operands);
              if (!
#line 7992 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_16 (insn, operands);

            case CONST_INT:
            case CONST_DOUBLE:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (!call_operand_address (operands[0], E_VOIDmode))
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET
                  || pattern85 (x4) != 0)
                return NULL;
              x23 = XEXP (x19, 0);
              if (GET_CODE (x23) != REG
                  || REGNO (x23) != 2
                  || GET_MODE (x23) != E_DImode
                  || pattern93 (x1) != 0
                  || !
#line 8871 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_21 (insn, operands);

            default:
              return NULL;
            }

        case SET:
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != CALL)
            return NULL;
          x14 = XEXP (x3, 0);
          if (GET_CODE (x14) != MEM
              || GET_MODE (x14) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER
              || pattern74 (x1, 
1, 
2) != 0)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x18 = XEXP (x14, 0);
          operands[1] = x18;
          if (!register_operand (operands[1], E_DImode))
            return NULL;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          x23 = XEXP (x19, 0);
          operands[3] = x23;
          if (
#line 8685 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
            return gen_split_19 (insn, operands);
          if (!
#line 8706 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed))
            return NULL;
          return gen_split_20 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
