/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern2 (x3, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern2 (x3, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !shift5_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !shift6_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 29
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!r26_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[0] = x7;
  if (!r25_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != ABS)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x2, 0);
  operands[2] = x8;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      return pattern36 (x1, 
E_DFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern36 (x1, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !arith11_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !arith11_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern79 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !reg_or_0_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !post_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != MINUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 25
      || GET_MODE (x8) != E_SImode)
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 0
          && GET_MODE (x3) == E_CCFPmode)
        {
          switch (XWINT (x2, 0))
            {
            case 0L:
              if (
#line 750 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return 3; /* *movccfp0 */
              break;

            case 1L:
              if (
#line 758 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return 4; /* *movccfp1 */
              break;

            default:
              break;
            }
        }
      break;

    case REG:
    case SUBREG:
      operands[0] = x2;
      if (pmode_register_operand (operands[0], E_VOIDmode))
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            return 277; /* indirect_jump */
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  switch (GET_MODE (x3))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !uint5_operand (operands[1], E_SImode)
          || !uint5_operand (operands[2], E_SImode))
        return -1;
      if (arith5_operand (operands[3], E_SImode)
          && 
#line 9429 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(UINTVAL (operands[1]) > 0
   && UINTVAL (operands[1]) + UINTVAL (operands[2]) <= 32))
        return 303; /* insv_32 */
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 9443 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((INTVAL (operands[3]) & 0x10) != 0 &&
   (~INTVAL (operands[3]) & ((1L << INTVAL (operands[1])) - 1) & ~0xf) == 0))
        return -1;
      return 304; /* *pa.md:9438 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !uint6_operand (operands[1], E_DImode)
          || !uint6_operand (operands[2], E_DImode))
        return -1;
      if (arith5_operand (operands[3], E_DImode)
          && 
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT
   && UINTVAL (operands[1]) > 0
   && UINTVAL (operands[1]) + UINTVAL (operands[2]) <= 64))
        return 305; /* insv_64 */
      if (!const_int_operand (operands[3], E_DImode)
          || !
#line 9501 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((INTVAL (operands[3]) & 0x10) != 0
   && TARGET_64BIT
   && (~INTVAL (operands[3]) & ((1L << INTVAL (operands[1])) - 1) & ~0xf) == 0))
        return -1;
      return 306; /* *pa.md:9496 */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern35 (x3, 
E_DImode) != 0)
            return -1;
          return 192; /* *pa.md:5944 */

        case E_SImode:
          if (pattern35 (x3, 
E_SImode) != 0)
            return -1;
          return 193; /* andsi3 */

        default:
          return -1;
        }

    case NOT:
      switch (pattern19 (x3))
        {
        case 0:
          return 194; /* *pa.md:5964 */

        case 1:
          return 195; /* *pa.md:5973 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern21 (x3))
        {
        case 0:
          if (!
#line 6702 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(INTVAL (operands[1]) == -2))
            return -1;
          return 246; /* vdepi_and */

        case 1:
          if (!
#line 6860 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && INTVAL (operands[1]) == -2))
            return -1;
          return 251; /* *pa.md:6853 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 7185 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(exact_log2 (1 + (INTVAL (operands[3]) >> (INTVAL (operands[2]) & 31))) > 0))
        return -1;
      return 270; /* *pa.md:7180 */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[2] = x2;
      if (comparison_operator (operands[2], E_CCFPmode))
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == REG
              && REGNO (x3) == 0
              && GET_MODE (x3) == E_CCFPmode)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (reg_or_0_operand (operands[0], E_SFmode)
                      && reg_or_0_operand (operands[1], E_SFmode)
                      && 
#line 714 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                    return 1; /* *pa.md:709 */
                  break;

                case E_DFmode:
                  if (reg_or_0_operand (operands[0], E_DFmode)
                      && reg_or_0_operand (operands[1], E_DFmode)
                      && 
#line 724 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                    return 2; /* *pa.md:719 */
                  break;

                default:
                  break;
                }
            }
        }
      switch (GET_CODE (x2))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[3] = x2;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern40 (
E_SImode) != 0)
                return -1;
              return 5; /* scc */

            case E_DImode:
              if (pattern40 (
E_DImode) != 0)
                return -1;
              return 6; /* *pa.md:786 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      return recog_10 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_9 (x1, insn, pnum_clobbers);

    case SMIN:
      switch (pattern1 (x1))
        {
        case 0:
          return 33; /* sminsi3 */

        case 1:
          return 34; /* smindi3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern1 (x1))
        {
        case 0:
          return 35; /* uminsi3 */

        case 1:
          return 36; /* umindi3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern1 (x1))
        {
        case 0:
          return 37; /* smaxsi3 */

        case 1:
          return 38; /* smaxdi3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern1 (x1))
        {
        case 0:
          return 39; /* umaxsi3 */

        case 1:
          return 40; /* umaxdi3 */

        default:
          return -1;
        }

    case ABS:
      return recog_11 (x1, insn, pnum_clobbers);

    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 45; /* bswaphi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 46; /* bswapsi2 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          *pnum_clobbers = 1;
          return 47; /* bswapdi2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_13 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 2)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern50 (x2, 
E_SImode) != 0
                  || !
#line 2737 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && flag_pic))
                return -1;
              return 92; /* *pa.md:2733 */

            case E_DImode:
              if (pattern50 (x2, 
E_DImode) != 0
                  || !
#line 2748 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(symbolic_operand (operands[2], Pmode)
   && ! function_label_operand (operands[2], Pmode)
   && TARGET_64BIT
   && flag_pic))
                return -1;
              return 93; /* *pa.md:2744 */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern13 (x2, 
E_DImode) != 0)
                return -1;
              return 99; /* *pa.md:2830 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !immediate_operand (operands[2], E_SImode)
                  || !
#line 2843 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!pa_is_function_label_plus_const (operands[2])))
                return -1;
              return 100; /* *pa.md:2839 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
        case MEM:
          res = recog_5 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST:
        case LABEL_REF:
          operands[1] = x2;
          if (pic_label_operand (operands[1], E_VOIDmode))
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (pmode_register_operand (operands[0], E_VOIDmode))
                return 89; /* *pa.md:2617 */
            }
          if (GET_CODE (x2) == LABEL_REF)
            {
              x3 = XEXP (x1, 0);
              if (GET_CODE (x3) == PC)
                {
                  x4 = XEXP (x2, 0);
                  operands[0] = x4;
                  return 276; /* jump */
                }
            }
          break;

        case HIGH:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          switch (pattern25 (x2))
            {
            case 0:
              if (
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(symbolic_operand (operands[1], Pmode)
   && ! function_label_operand (operands[1], Pmode)
   && ! read_only_operand (operands[1], Pmode)
   && ! flag_pic))
                return 94; /* *pa.md:2759 */
              if (
#line 2810 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((!flag_pic || !symbolic_operand (operands[1], Pmode))
    && !pa_is_function_label_plus_const (operands[1])))
                return 97; /* *pa.md:2807 */
              break;

            case 1:
              if (const_int_operand (operands[1], E_VOIDmode))
                return 98; /* *pa.md:2822 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      if (!general_operand (operands[1], E_DImode))
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!move_dest_operand (operands[0], E_DImode)
          || !
#line 4406 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && !TARGET_64BIT
   && TARGET_SOFT_FLOAT))
        return -1;
      return 133; /* *pa.md:4401 */

    case ZERO_EXTEND:
      return recog_12 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 145; /* extendhisi2 */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 147; /* extendqisi2 */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          return 146; /* extendqihi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 148; /* extendqidi2 */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 149; /* extendhidi2 */

            case E_SImode:
              if (!register_operand (operands[1], E_SImode))
                return -1;
              return 150; /* extendsidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 4912 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 151; /* extendsfdf2 */

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 4921 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 152; /* truncdfsf2 */

    case FLOAT:
      return recog_14 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 5030 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 159; /* fix_truncsfsi2 */

        case 1:
          if (!
#line 5038 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 160; /* fix_truncdfsi2 */

        case 2:
          if (!
#line 5046 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 161; /* fix_truncsfdi2 */

        case 3:
          if (!
#line 5054 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
            return -1;
          return 162; /* fix_truncdfdi2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern26 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 5062 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 163; /* floatunssidf2_pa20 */

            case 1:
              if (!
#line 5086 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 166; /* floatunsdidf2 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern26 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 5070 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 164; /* floatunssisf2_pa20 */

            case 1:
              if (!
#line 5078 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                return -1;
              return 165; /* floatunsdisf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 5094 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 167; /* fixuns_truncsfsi2 */

        case 1:
          if (!
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 168; /* fixuns_truncdfsi2 */

        case 2:
          if (!
#line 5110 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 169; /* fixuns_truncsfdi2 */

        case 3:
          if (!
#line 5118 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
            return -1;
          return 170; /* fixuns_truncdfdi2 */

        default:
          return -1;
        }

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != ZERO_EXTEND
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 5629 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT && ! TARGET_SOFT_MULT))
            return -1;
          return 186; /* umulsidi3 */

        case REG:
        case SUBREG:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 6227 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 214; /* muldf3 */

            case 1:
              if (!
#line 6237 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 215; /* mulsf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      return recog_15 (x1, insn, pnum_clobbers);

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 208; /* *pa.md:6165 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 209; /* one_cmplsi2 */

        default:
          return -1;
        }

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern11 (x2))
        {
        case 0:
          if (!
#line 6247 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 216; /* divdf3 */

        case 1:
          if (!
#line 6256 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 217; /* divsf3 */

        default:
          return -1;
        }

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 6361 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 222; /* sqrtdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6369 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 223; /* sqrtsf2 */

        default:
          return -1;
        }

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern46 (x2, 
E_DFmode) != 0
                  || !
#line 6382 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 224; /* fmadf4 */

            case E_SFmode:
              if (pattern46 (x2, 
E_SFmode) != 0
                  || !
#line 6392 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 225; /* fmasf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern47 (x2, 
E_DFmode) != 0
                  || !
#line 6403 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 226; /* fnmadf4 */

            case E_SFmode:
              if (pattern47 (x2, 
E_SFmode) != 0
                  || !
#line 6413 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_20 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 227; /* fnmasf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (GET_MODE (x2) == E_SImode)
        {
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) == CONST_INT)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x2, 0);
                  operands[1] = x4;
                  if (memory_operand (operands[1], E_SImode))
                    {
                      switch (XWINT (x5, 0))
                        {
                        case 24L:
                          return 236; /* *pa.md:6545 */

                        case 16L:
                          return 237; /* *pa.md:6554 */

                        default:
                          break;
                        }
                    }
                }
            }
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern12 (x2))
        {
        case 0:
          return 256; /* lshrsi3 */

        case 1:
          return 257; /* lshrdi3 */

        default:
          return -1;
        }

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          switch (pattern15 (x2))
            {
            case 0:
              return 242; /* *pa.md:6635 */

            case 1:
              return 247; /* *pa.md:6793 */

            case 2:
              if (pattern51 (x2, 
E_SImode) != 0)
                return -1;
              if (arith5_operand (operands[1], E_SImode))
                return 243; /* zvdep32 */
              if (!lhs_lshift_cint_operand (operands[1], E_SImode))
                return -1;
              return 244; /* zvdep_imm32 */

            case 3:
              if (pattern51 (x2, 
E_DImode) != 0)
                return -1;
              if (arith5_operand (operands[1], E_DImode))
                return 248; /* zvdep64 */
              if (!lhs_lshift_cint_operand (operands[1], E_DImode))
                return -1;
              return 249; /* zvdep_imm64 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 307; /* *pa.md:9512 */

        default:
          return -1;
        }

    case ASHIFTRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern15 (x2))
        {
        case 0:
          return 252; /* *pa.md:6886 */

        case 1:
          return 254; /* *pa.md:6921 */

        case 2:
          if (pattern48 (x2, 
E_SImode) != 0)
            return -1;
          return 253; /* vextrs32 */

        case 3:
          if (pattern48 (x2, 
E_DImode) != 0)
            return -1;
          return 255; /* vextrs64 */

        default:
          return -1;
        }

    case PLUS:
    case IOR:
    case XOR:
      return recog_8 (x1, insn, pnum_clobbers);

    case ROTATERT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern12 (x2))
        {
        case 0:
          return 264; /* rotrsi3 */

        case 1:
          return 266; /* rotrdi3 */

        default:
          return -1;
        }

    case ROTATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern14 (x2))
        {
        case 0:
          return 265; /* *rotlsi3_internal */

        case 1:
          return 267; /* *rotldi3_internal */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      switch (pattern22 (x1))
        {
        case 0:
          if (
#line 9229 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(UINTVAL (operands[2]) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[3]) <= 32))
            return 296; /* extzv_32 */
          break;

        case 1:
          if (
#line 9278 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT
   && UINTVAL (operands[2]) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[3]) <= 64))
            return 298; /* extzv_64 */
          break;

        default:
          break;
        }
      if (XWINT (x5, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x9 = XEXP (x2, 2);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern49 (x2, 
E_SImode) != 0)
            return -1;
          return 297; /* *pa.md:9235 */

        case E_DImode:
          if (pattern49 (x2, 
E_DImode) != 0)
            return -1;
          return 299; /* *pa.md:9285 */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      switch (pattern22 (x1))
        {
        case 0:
          if (
#line 9329 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(UINTVAL (operands[2]) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[3]) <= 32))
            return 300; /* extv_32 */
          break;

        case 1:
          if (
#line 9378 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT
   && UINTVAL (operands[2]) > 0
   && UINTVAL (operands[2]) + UINTVAL (operands[3]) <= 64))
            return 301; /* extv_64 */
          break;

        default:
          break;
        }
      if (XWINT (x5, 0) != 1L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x2, 2);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 302; /* *pa.md:9385 */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 3)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern25 (x2))
        {
        case 0:
          if (!
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == SImode))
            return -1;
          return 331; /* tp_loadsi */

        case 1:
          if (!
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == DImode))
            return -1;
          return 332; /* tp_loaddi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (pnum_clobbers == NULL
          || XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 6
          || GET_MODE (x2) != E_SImode)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 10889 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 338; /* get_fpsr_64 */

    default:
      return -1;
    }
}
