/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i4)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern13 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern13 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  switch (XWINT (x4, 0))
    {
    case 31L:
      return pattern20 (x1, 
E_SImode); /* [-1, 0] */

    case 63L:
      if (pattern20 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  return 0;
}

int
pattern40 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !ordered_comparison_operator (operands[3], i1)
      || !reg_or_0_operand (operands[1], i1)
      || !arith11_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !shadd_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !plus_xor_ior_operator (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !int5_operand (operands[2], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !int5_operand (operands[2], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x4, 0);
  operands[0] = x8;
  x9 = XEXP (x6, 0);
  operands[1] = x9;
  switch (XWINT (x5, 0))
    {
    case 4L:
      if (pattern75 (x2, 
E_SImode) != 0)
        return -1;
      if (
#line 7486 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!flag_pic))
        {
          *pnum_clobbers = 1;
          return 279; /* casesi32 */
        }
      if (!
#line 7499 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(flag_pic))
        return -1;
      *pnum_clobbers = 2;
      return 280; /* casesi32p */

    case 8L:
      if (pattern75 (x2, 
E_DImode) != 0)
        return -1;
      *pnum_clobbers = 2;
      return 281; /* casesi64p */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !move_src_operand (operands[1], E_QImode)
          || !
#line 4758 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
        return -1;
      return 139; /* *pa.md:4754 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (move_src_operand (operands[1], E_QImode)
          && 
#line 4776 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
        return 140; /* *pa.md:4772 */
      if (!move_src_operand (operands[1], E_HImode)
          || !
#line 4794 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(GET_CODE (operands[1]) != CONST_INT))
        return -1;
      return 141; /* *pa.md:4790 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      if (move_src_operand (operands[1], E_QImode)
          && 
#line 4812 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && GET_CODE (operands[1]) != CONST_INT))
        return 142; /* *pa.md:4808 */
      if (move_src_operand (operands[1], E_HImode)
          && 
#line 4830 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && GET_CODE (operands[1]) != CONST_INT))
        return 143; /* *pa.md:4826 */
      if (!move_src_operand (operands[1], E_SImode)
          || !
#line 4848 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && GET_CODE (operands[1]) != CONST_INT))
        return -1;
      return 144; /* *pa.md:4844 */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XEXP (x7, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x12 = XEXP (x6, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (!register_operand (operands[1], E_DImode)
                      || !int5_operand (operands[2], E_DImode)
                      || GET_MODE (x7) != E_DImode)
                    return -1;
                  return 81; /* *pa.md:2467 */

                case E_SImode:
                  if (!register_operand (operands[1], E_SImode)
                      || !pre_cint_operand (operands[2], E_SImode)
                      || GET_MODE (x7) != E_SImode)
                    return -1;
                  return 83; /* pre_ldw */

                default:
                  return -1;
                }

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !pre_cint_operand (operands[2], E_DImode)
                  || GET_MODE (x7) != E_DImode)
                return -1;
              return 84; /* pre_ldd */

            case E_HImode:
              switch (pattern82 (x1, 
E_HImode))
                {
                case 0:
                  return 102; /* *pa.md:2992 */

                case 1:
                  return 103; /* *pa.md:3003 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern82 (x1, 
E_QImode))
                {
                case 0:
                  return 111; /* *pa.md:3152 */

                case 1:
                  return 112; /* *pa.md:3162 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x13 = XEXP (x5, 1);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_CODE (x9) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x14 = XEXP (x5, 0);
          operands[0] = x14;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x15 = XEXP (x9, 0);
          operands[1] = x15;
          x12 = XEXP (x6, 0);
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 7486 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!flag_pic))
            return -1;
          return 279; /* casesi32 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != PLUS
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x11 = XEXP (x7, 1);
      operands[2] = x11;
      if (!post_cint_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x7, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x12 = XEXP (x6, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      return 86; /* *pa.md:2553 */

    default:
      return -1;
    }
}
