/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != USE)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != USE)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x11 = XEXP (x2, 1);
  operands[1] = x11;
  if (!memory_operand (operands[1], E_BLKmode)
      || pattern5 (x1) != 0)
    return -1;
  return 0;
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !const_int_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 29
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 25
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 2
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x3, 0);
  operands[1] = x11;
  if (!r26_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[0] = x12;
  if (!div_operand (operands[0], E_SImode))
    return -1;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[2] = x14;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !mem_shadd_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !int11_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern76 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !ordered_comparison_operator (operands[3], i1)
      || !reg_or_0_operand (operands[1], i1)
      || !arith11_operand (operands[2], i1)
      || !ordered_comparison_operator (operands[6], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !arith11_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_0_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !int5_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !int5_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!reg_or_0_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!arith5_operand (operands[2], E_DImode))
    return -1;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      return 56; /* *pa.md:1534 */

    case PC:
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      return 57; /* *pa.md:1563 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 41; /* absqi2 */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 42; /* abshi2 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 43; /* abssi2 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 44; /* absdi2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 6345 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 220; /* absdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 6353 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
        return -1;
      return 221; /* abssf2 */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 4940 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 153; /* *pa.md:4937 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 4959 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
            return -1;
          return 155; /* *pa.md:4956 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern26 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 4948 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 154; /* floatsisf2 */

            case 1:
              if (!
#line 5011 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 157; /* floatdisf2 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern26 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 4967 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return -1;
              return 156; /* floatsidf2 */

            case 1:
              if (!
#line 5019 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_PA_11 && ! TARGET_SOFT_FLOAT))
                return -1;
              return 158; /* floatdidf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      return recog_18 (x1, insn, pnum_clobbers);

    case 8:
      x2 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x2) != CLOBBER)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_BLKmode)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_BLKmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || pattern56 (x1, 
USE, 
CLOBBER) != 0)
            return -1;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode)
              || pattern5 (x1) != 0)
            return -1;
          return 120; /* cpymemdi_prereload */

        case CONST_INT:
          if (XWINT (x3, 0) != 2L)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern28 (x6, 
2) != 0
              || pattern56 (x1, 
CLOBBER, 
USE) != 0
              || pattern86 (x1) != 0)
            return -1;
          x9 = XVECEXP (x1, 0, 7);
          x10 = XEXP (x9, 0);
          operands[5] = x10;
          switch (GET_MODE (operands[5]))
            {
            case E_SImode:
              if (!scratch_operand (operands[5], E_SImode)
                  || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == SImode))
                return -1;
              return 322; /* icacheflushsi */

            case E_DImode:
              if (!scratch_operand (operands[5], E_DImode)
                  || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == DImode))
                return -1;
              return 323; /* icacheflushdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 9:
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_BLKmode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x11) != CLOBBER)
        return -1;
      x12 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x12) != CLOBBER)
        return -1;
      x13 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x13) != CLOBBER)
        return -1;
      x2 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x2) != CLOBBER)
        return -1;
      x14 = XVECEXP (x1, 0, 6);
      if (GET_CODE (x14) != USE)
        return -1;
      x9 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x9) != USE)
        return -1;
      x15 = XVECEXP (x1, 0, 8);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x16 = XEXP (x6, 0);
      operands[2] = x16;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x17 = XEXP (x11, 0);
      operands[3] = x17;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      x18 = XEXP (x12, 0);
      operands[6] = x18;
      if (!register_operand (operands[6], E_DImode))
        return -1;
      x19 = XEXP (x14, 0);
      operands[4] = x19;
      if (!arith14_operand (operands[4], E_DImode))
        return -1;
      x10 = XEXP (x9, 0);
      operands[5] = x10;
      if (!const_int_operand (operands[5], E_DImode))
        return -1;
      x20 = XEXP (x13, 0);
      if (!rtx_equal_p (x20, operands[0]))
        return -1;
      x21 = XEXP (x2, 0);
      if (!rtx_equal_p (x21, operands[1])
          || !
#line 3626 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed))
        return -1;
      return 121; /* cpymemdi_postreload */

    case 5:
      return recog_19 (x1, insn, pnum_clobbers);

    case 6:
      x13 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x13) != USE)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x11) != CLOBBER)
            return -1;
          x12 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x12) != USE)
            return -1;
          x4 = XEXP (x3, 1);
          switch (GET_CODE (x4))
            {
            case CONST_INT:
              if (XWINT (x4, 0) != 0L)
                return -1;
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != MEM
                  || GET_MODE (x5) != E_BLKmode)
                return -1;
              x2 = XVECEXP (x1, 0, 5);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x7 = XEXP (x5, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x16 = XEXP (x6, 0);
              operands[1] = x16;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x18 = XEXP (x12, 0);
              operands[2] = x18;
              if (!arith14_operand (operands[2], E_DImode))
                return -1;
              x20 = XEXP (x13, 0);
              operands[3] = x20;
              if (!const_int_operand (operands[3], E_DImode))
                return -1;
              x17 = XEXP (x11, 0);
              if (!rtx_equal_p (x17, operands[0])
                  || !
#line 3854 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT && reload_completed))
                return -1;
              return 123; /* clrmemdi_postreload */

            case CALL:
              x8 = XEXP (x4, 0);
              if (GET_CODE (x8) != MEM
                  || GET_MODE (x8) != E_SImode)
                return -1;
              x16 = XEXP (x6, 0);
              if (GET_CODE (x16) != REG
                  || GET_MODE (x16) != E_DImode)
                return -1;
              x18 = XEXP (x12, 0);
              if (GET_CODE (x18) != REG
                  || REGNO (x18) != 27
                  || GET_MODE (x18) != E_DImode)
                return -1;
              x20 = XEXP (x13, 0);
              if (GET_CODE (x20) != REG
                  || REGNO (x20) != 29
                  || GET_MODE (x20) != E_DImode)
                return -1;
              x2 = XVECEXP (x1, 0, 5);
              if (GET_CODE (x2) != USE)
                return -1;
              x21 = XEXP (x2, 0);
              if (GET_CODE (x21) != CONST_INT)
                return -1;
              x5 = XEXP (x3, 0);
              operands[0] = x5;
              x22 = XEXP (x8, 0);
              operands[1] = x22;
              x23 = XEXP (x4, 1);
              operands[2] = x23;
              switch (GET_CODE (operands[1]))
                {
                case CONST_INT:
                case CONST_DOUBLE:
                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  if (!call_operand_address (operands[1], E_VOIDmode)
                      || REGNO (x16) != 1)
                    return -1;
                  x17 = XEXP (x11, 0);
                  if (GET_CODE (x17) != REG
                      || REGNO (x17) != 2
                      || GET_MODE (x17) != E_DImode
                      || XWINT (x21, 0) != 0L)
                    return -1;
                  return 287; /* *call_val_symref_64bit_post_reload */

                case REG:
                case SUBREG:
                  if (!register_operand (operands[1], E_DImode)
                      || REGNO (x16) != 2
                      || XWINT (x21, 0) != 1L)
                    return -1;
                  x17 = XEXP (x11, 0);
                  operands[3] = x17;
                  return 288; /* call_val_reg_64bit */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CALL:
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x11) != CLOBBER)
            return -1;
          x20 = XEXP (x13, 0);
          if (GET_CODE (x20) != REG
              || GET_MODE (x20) != E_DImode)
            return -1;
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != USE)
            return -1;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          x4 = XEXP (x3, 1);
          operands[1] = x4;
          switch (GET_CODE (operands[0]))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              if (!call_operand_address (operands[0], E_VOIDmode))
                return -1;
              x17 = XEXP (x11, 0);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 2
                  || GET_MODE (x17) != E_DImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x6))
                {
                case CLOBBER:
                  if (pattern74 (x1, 
0, 
1) != 0)
                    return -1;
                  return 283; /* *call_symref_64bit_post_reload */

                case SET:
                  if (pattern85 (x6) != 0
                      || pattern93 (x1) != 0)
                    return -1;
                  return 290; /* call_mcount_64bit */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (pattern78 (x1, 
E_DImode) != 0)
                return -1;
              return 284; /* call_reg_64bit */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x3, 0) != 1L
              || pattern31 (x1, 
1) != 0)
            return -1;
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x11 = XVECEXP (x1, 0, 2);
          x17 = XEXP (x11, 0);
          operands[0] = x17;
          if (!pmode_register_operand (operands[0], E_VOIDmode))
            return -1;
          x12 = XVECEXP (x1, 0, 3);
          x18 = XEXP (x12, 0);
          operands[1] = x18;
          if (!pmode_register_operand (operands[1], E_VOIDmode))
            return -1;
          x20 = XEXP (x13, 0);
          operands[2] = x20;
          if (!pmode_register_operand (operands[2], E_VOIDmode))
            return -1;
          x21 = XEXP (x2, 0);
          operands[3] = x21;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (!scratch_operand (operands[3], E_SImode)
                  || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == SImode))
                return -1;
              return 320; /* dcacheflushsi */

            case E_DImode:
              if (!scratch_operand (operands[3], E_DImode)
                  || !
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == DImode))
                return -1;
              return 321; /* dcacheflushdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x4 = XEXP (x3, 1);
          switch (GET_CODE (x4))
            {
            case MEM:
              x8 = XEXP (x4, 0);
              if (GET_CODE (x8) != PLUS)
                return -1;
              x22 = XEXP (x8, 0);
              if (GET_CODE (x22) != MULT)
                return -1;
              x24 = XEXP (x22, 1);
              if (GET_CODE (x24) != CONST_INT)
                return -1;
              x25 = XEXP (x8, 1);
              if (GET_CODE (x25) != LABEL_REF)
                return -1;
              x5 = XEXP (x3, 0);
              if (GET_CODE (x5) != PC)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != CLOBBER)
                return -1;
              x26 = XEXP (x22, 0);
              operands[0] = x26;
              x27 = XEXP (x25, 0);
              operands[1] = x27;
              x16 = XEXP (x6, 0);
              operands[2] = x16;
              x17 = XEXP (x11, 0);
              operands[3] = x17;
              switch (XWINT (x24, 0))
                {
                case 4L:
                  if (pattern87 (x4, 
E_SImode) != 0
                      || !
#line 7499 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(flag_pic))
                    return -1;
                  return 280; /* casesi32p */

                case 8L:
                  if (pattern87 (x4, 
E_DImode) != 0)
                    return -1;
                  return 281; /* casesi64p */

                default:
                  return -1;
                }

            case IF_THEN_ELSE:
              x8 = XEXP (x4, 0);
              if (!ordered_comparison_operator (x8, E_VOIDmode))
                return -1;
              operands[2] = x8;
              if (pattern33 (x1) != 0)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != CLOBBER)
                return -1;
              x22 = XEXP (x8, 0);
              x26 = XEXP (x22, 0);
              operands[0] = x26;
              if (!reg_before_reload_operand (operands[0], E_SImode))
                return -1;
              x24 = XEXP (x22, 1);
              operands[1] = x24;
              if (!int5_operand (operands[1], E_SImode))
                return -1;
              x23 = XEXP (x4, 1);
              x28 = XEXP (x23, 0);
              operands[3] = x28;
              x17 = XEXP (x11, 0);
              operands[4] = x17;
              if (!scratch_operand (operands[4], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x29 = XEXP (x6, 1);
              x30 = XEXP (x29, 0);
              if (!rtx_equal_p (x30, operands[0]))
                return -1;
              x31 = XEXP (x29, 1);
              if (!rtx_equal_p (x31, operands[1]))
                return -1;
              x16 = XEXP (x6, 0);
              if (!rtx_equal_p (x16, operands[0]))
                return -1;
              return 308; /* decrement_and_branch_until_zero */

            case UNSPEC:
              if (XVECLEN (x4, 0) != 1
                  || pattern4 (x1, 
E_DImode, 
27, 
1, 
CLOBBER) != 0)
                return -1;
              x5 = XEXP (x3, 0);
              operands[0] = x5;
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x4) != E_DImode)
                return -1;
              x32 = XVECEXP (x4, 0, 0);
              operands[1] = x32;
              switch (XINT (x4, 1))
                {
                case 10:
                  if (!tgd_symbolic_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 327; /* tgd_load_picdi */

                case 11:
                  if (!tld_symbolic_operand (operands[1], E_VOIDmode))
                    return -1;
                  return 328; /* tld_load_picdi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 1)
            return -1;
          switch (XINT (x3, 1))
            {
            case 4:
              if (pnum_clobbers == NULL)
                return -1;
              x33 = XVECEXP (x3, 0, 0);
              if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || pattern4 (x1, 
E_SImode, 
28, 
29, 
USE) != 0)
                return -1;
              *pnum_clobbers = 7;
              return 325; /* outline_epilogue_call */

            case 7:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != CLOBBER)
                return -1;
              x11 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x11) != CLOBBER)
                return -1;
              x33 = XVECEXP (x3, 0, 0);
              operands[0] = x33;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x16 = XEXP (x6, 0);
              operands[1] = x16;
              if (!scratch_operand (operands[1], E_DImode))
                return -1;
              x17 = XEXP (x11, 0);
              operands[2] = x17;
              if (!scratch_operand (operands[2], E_SImode)
                  || !
#line 10924 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_64BIT))
                return -1;
              return 339; /* set_fpsr_64 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 7:
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case CALL:
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode
              || pattern9 (x1) != 0)
            return -1;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!call_operand_address (operands[0], E_VOIDmode))
            return -1;
          x4 = XEXP (x3, 1);
          operands[1] = x4;
          x12 = XVECEXP (x1, 0, 3);
          x18 = XEXP (x12, 0);
          operands[2] = x18;
          return 282; /* call_symref_64bit */

        case SET:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != CALL)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode
              || pattern9 (x1) != 0)
            return -1;
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          x22 = XEXP (x8, 0);
          operands[1] = x22;
          if (!call_operand_address (operands[1], E_VOIDmode))
            return -1;
          x23 = XEXP (x4, 1);
          operands[2] = x23;
          x12 = XVECEXP (x1, 0, 3);
          x18 = XEXP (x12, 0);
          operands[3] = x18;
          return 286; /* call_val_symref_64bit */

        case CONST_INT:
          if (pnum_clobbers == NULL
              || XWINT (x3, 0) != 2L
              || pattern31 (x1, 
2) != 0)
            return -1;
          x13 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x13) != USE)
            return -1;
          x2 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x14 = XVECEXP (x1, 0, 6);
          if (GET_CODE (x14) != CLOBBER
              || pattern86 (x1) != 0)
            return -1;
          if (
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == SImode))
            {
              *pnum_clobbers = 1;
              return 322; /* icacheflushsi */
            }
          if (!
#line 125 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(Pmode == DImode))
            return -1;
          *pnum_clobbers = 1;
          return 323; /* icacheflushdi */

        case UNSPEC_VOLATILE:
          if (pattern17 (x1, 
CLOBBER, 
31, 
0, 
3) != 0
              || pattern68 (x1, 
1, 
19, 
20, 
21, 
22) != 0)
            return -1;
          return 324; /* outline_prologue_call */

        default:
          return -1;
        }

    case 4:
      if (pattern4 (x1, 
E_DImode, 
2, 
1, 
CLOBBER) != 0)
        return -1;
      x12 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x12) != USE)
        return -1;
      x18 = XEXP (x12, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case CALL:
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!call_operand_address (operands[0], E_VOIDmode))
            return -1;
          x4 = XEXP (x3, 1);
          operands[1] = x4;
          return 292; /* sibcall_internal_symref_64bit */

        case SET:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != CALL)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode)
            return -1;
          x5 = XEXP (x3, 0);
          operands[0] = x5;
          x22 = XEXP (x8, 0);
          operands[1] = x22;
          if (!call_operand_address (operands[1], E_VOIDmode))
            return -1;
          x23 = XEXP (x4, 1);
          operands[2] = x23;
          return 293; /* sibcall_value_internal_symref_64bit */

        default:
          return -1;
        }

    case 10:
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != UNSPEC_VOLATILE
          || pattern17 (x1, 
USE, 
29, 
1, 
4) != 0
          || pattern68 (x1, 
20, 
21, 
22, 
31, 
28) != 0)
        return -1;
      x9 = XVECEXP (x1, 0, 7);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 19
          || GET_MODE (x10) != E_SImode)
        return -1;
      x15 = XVECEXP (x1, 0, 8);
      if (GET_CODE (x15) != CLOBBER)
        return -1;
      x34 = XEXP (x15, 0);
      if (GET_CODE (x34) != REG
          || REGNO (x34) != 2
          || GET_MODE (x34) != E_SImode)
        return -1;
      x35 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x35) != CLOBBER)
        return -1;
      x36 = XEXP (x35, 0);
      if (GET_CODE (x36) != REG
          || REGNO (x36) != 1
          || GET_MODE (x36) != E_SImode)
        return -1;
      return 325; /* outline_epilogue_call */

    default:
      return -1;
    }
}
