/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!register_operand (operands[4], E_DImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!arith14_operand (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 2);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !uint5_operand (operands[2], E_SImode)
          || !uint5_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !uint6_operand (operands[2], E_DImode)
          || !uint6_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !and_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !ordered_comparison_operator (operands[3], i1)
      || !reg_or_0_operand (operands[1], i1)
      || !arith11_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 2);
  operands[1] = x6;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
    case CONST_DOUBLE:
      x7 = XEXP (x1, 1);
      switch (GET_CODE (x7))
        {
        case LABEL_REF:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          return pattern43 (x3); /* [-1, 1] */

        case PC:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          res = pattern43 (x3);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      x7 = XEXP (x1, 1);
      switch (GET_CODE (x7))
        {
        case LABEL_REF:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          res = pattern44 (x3);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case PC:
          x8 = XEXP (x1, 2);
          if (GET_CODE (x8) != LABEL_REF)
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          res = pattern44 (x3);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern80 (rtx x1, unsigned int i1, unsigned int i2, rtx_code i3, machine_mode i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i5
      || GET_MODE (x3) != i4)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i1)
    return -1;
  return 0;
}

int
pattern89 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case IOR:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PLUS:
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case XOR:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern10 (x3, 
E_DImode) == 0)
            return 200; /* *pa.md:6040 */
          break;

        case E_SImode:
          if (pattern10 (x3, 
E_SImode) == 0)
            return 201; /* xorsi3 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ASHIFT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != LSHIFTRT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case MINUS:
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          operands[4] = x3;
          x10 = XEXP (x8, 1);
          operands[3] = x10;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          switch (XWINT (x9, 0))
            {
            case 32L:
              if (pattern77 (x3, 
E_SImode) != 0)
                return -1;
              return 258; /* *shrpsi4_1 */

            case 64L:
              if (pattern77 (x3, 
E_DImode) != 0)
                return -1;
              return 260; /* *shrpdi4_1 */

            default:
              return -1;
            }

        case CONST_INT:
          operands[3] = x8;
          operands[5] = x3;
          x11 = XEXP (x5, 1);
          operands[4] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern72 (x3, 
E_DImode) != 0
                  || !
#line 7023 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT
   && INTVAL (operands[3]) + INTVAL (operands[4]) == 64))
                return -1;
              return 262; /* *shrpdi4_3 */

            case E_SImode:
              if (pattern72 (x3, 
E_SImode) != 0
                  || !
#line 7145 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(INTVAL (operands[3]) + INTVAL (operands[4]) == 32))
                return -1;
              return 268; /* *pa.md:7138 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != ASHIFT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x11 = XEXP (x5, 1);
      switch (GET_CODE (x11))
        {
        case MINUS:
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          operands[4] = x3;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          switch (XWINT (x12, 0))
            {
            case 32L:
              if (!register_operand (operands[0], E_SImode)
                  || !plus_xor_ior_operator (operands[4], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !register_operand (operands[2], E_SImode)
                  || !register_operand (operands[3], E_SImode)
                  || GET_MODE (x5) != E_SImode
                  || GET_MODE (x11) != E_SImode)
                return -1;
              return 259; /* *shrpsi4_2 */

            case 64L:
              if (!register_operand (operands[0], E_DImode)
                  || !plus_xor_ior_operator (operands[4], E_DImode)
                  || GET_MODE (x4) != E_DImode
                  || !register_operand (operands[2], E_DImode)
                  || !shift6_operand (operands[3], E_DImode)
                  || GET_MODE (x5) != E_DImode
                  || GET_MODE (x11) != E_DImode)
                return -1;
              return 261; /* *shrpdi4_2 */

            default:
              return -1;
            }

        case CONST_INT:
          operands[3] = x11;
          operands[5] = x3;
          x8 = XEXP (x4, 1);
          operands[4] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern73 (x3, 
E_DImode) != 0
                  || !
#line 7036 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(TARGET_64BIT
   && INTVAL (operands[3]) + INTVAL (operands[4]) == 64))
                return -1;
              return 263; /* *shrpdi4_4 */

            case E_SImode:
              if (pattern73 (x3, 
E_SImode) != 0
                  || !
#line 7157 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(INTVAL (operands[3]) + INTVAL (operands[4]) == 32))
                return -1;
              return 269; /* *pa.md:7150 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_21 (x1, insn, pnum_clobbers);

    case PARALLEL:
      return recog_20 (x1, insn, pnum_clobbers);

    case TRAP_IF:
      x2 = XEXP (x1, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 185; /* trap */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 0:
          x4 = XVECEXP (x1, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          return 275; /* blockage */

        case 3:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          *pnum_clobbers = 6;
          return 324; /* outline_prologue_call */

        case 7:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 10924 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_64BIT))
            return -1;
          *pnum_clobbers = 2;
          return 339; /* set_fpsr_64 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 1)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 7406 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(GET_MODE (operands[0]) == word_mode))
        return -1;
      return 278; /* indirect_goto */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 294; /* nop */

    case PREFETCH:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      if (!pmode_register_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x1, 2);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 326; /* prefetch_20 */

    default:
      return -1;
    }
}
