/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!memory_operand (operands[0], E_BLKmode)
      || pattern7 (x1) != 0)
    return -1;
  return 0;
}

int
pattern17 (rtx x1, rtx_code i1, unsigned int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i4)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern28 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC_VOLATILE
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

int
pattern34 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      return pattern38 (x1, 
E_DFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern38 (x1, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !cint_ior_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !int11_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern69 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !arith11_operand (operands[4], i1)
      || !reg_or_cint_move_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !plus_xor_ior_operator (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!pmode_register_operand (operands[0], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!pmode_register_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!pmode_register_operand (operands[2], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!pmode_register_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!pmode_register_operand (operands[4], E_VOIDmode))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case MEM:
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case REG:
    case SUBREG:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (move_dest_operand (operands[0], E_SImode)
          && move_src_operand (operands[1], E_SImode))
        {
          if (
#line 2200 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && !TARGET_SOFT_FLOAT
   && !TARGET_64BIT))
            return 76; /* *pa.md:2195 */
          if (
#line 2228 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && !TARGET_SOFT_FLOAT
   && TARGET_64BIT))
            return 77; /* *pa.md:2223 */
          if (
#line 2256 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && TARGET_SOFT_FLOAT
   && TARGET_64BIT))
            return 78; /* *pa.md:2251 */
        }
      if (indexed_memory_operand (operands[0], E_SImode)
          && register_operand (operands[1], E_SImode)
          && 
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && reload_completed))
        return 79; /* *pa.md:2274 */
      if (!move_dest_operand (operands[0], E_SImode)
          || !move_src_operand (operands[1], E_SImode)
          || !
#line 2449 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && TARGET_SOFT_FLOAT))
        return -1;
      return 80; /* *pa.md:2444 */

    case E_HImode:
      if (!move_dest_operand (operands[0], E_HImode)
          || !move_src_operand (operands[1], E_HImode)
          || !
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))))
        return -1;
      return 101; /* *pa.md:2972 */

    case E_QImode:
      if (!move_dest_operand (operands[0], E_QImode)
          || !move_src_operand (operands[1], E_QImode)
          || !
#line 3137 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))))
        return -1;
      return 110; /* *pa.md:3132 */

    case E_DFmode:
      if (move_dest_operand (operands[0], E_DFmode)
          && reg_or_0_or_mem_operand (operands[1], E_DFmode)
          && 
#line 3925 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && !(GET_CODE (operands[1]) == CONST_DOUBLE
	&& GET_CODE (operands[0]) == MEM)
   && !TARGET_64BIT
   && !TARGET_SOFT_FLOAT))
        return 124; /* *pa.md:3920 */
      if (indexed_memory_operand (operands[0], E_DFmode)
          && reg_or_0_operand (operands[1], E_DFmode)
          && 
#line 3946 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && reload_completed))
        return 125; /* *pa.md:3943 */
      if (!move_dest_operand (operands[0], E_DFmode))
        return -1;
      if (reg_or_0_or_mem_operand (operands[1], E_DFmode)
          && 
#line 4099 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && !TARGET_64BIT
   && TARGET_SOFT_FLOAT))
        return 126; /* *pa.md:4094 */
      if (!move_src_operand (operands[1], E_DFmode))
        return -1;
      if (
#line 4115 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && !TARGET_SOFT_FLOAT && TARGET_64BIT))
        return 127; /* *pa.md:4110 */
      if (!
#line 4139 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], DFmode)
    || reg_or_0_operand (operands[1], DFmode))
   && TARGET_SOFT_FLOAT && TARGET_64BIT))
        return -1;
      return 128; /* *pa.md:4134 */

    case E_DImode:
      if (move_dest_operand (operands[0], E_DImode)
          && move_src_operand (operands[1], E_DImode))
        {
          if (
#line 4269 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && !TARGET_64BIT
   && !TARGET_SOFT_FLOAT))
            return 129; /* *pa.md:4264 */
          if (
#line 4291 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && !TARGET_SOFT_FLOAT && TARGET_64BIT))
            return 130; /* *pa.md:4286 */
          if (
#line 4318 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], DImode)
    || reg_or_0_operand (operands[1], DImode))
   && TARGET_SOFT_FLOAT && TARGET_64BIT))
            return 131; /* *pa.md:4313 */
        }
      if (!indexed_memory_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_DImode)
          || !
#line 4338 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && TARGET_64BIT
   && !TARGET_DISABLE_INDEXING
   && reload_completed))
        return -1;
      return 132; /* *pa.md:4335 */

    case E_SFmode:
      if (move_dest_operand (operands[0], E_SFmode)
          && reg_or_0_or_mem_operand (operands[1], E_SFmode))
        {
          if (
#line 4503 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && !TARGET_SOFT_FLOAT
   && !TARGET_64BIT))
            return 134; /* *pa.md:4498 */
          if (
#line 4525 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && !TARGET_SOFT_FLOAT
   && TARGET_64BIT))
            return 135; /* *pa.md:4520 */
          if (
#line 4547 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && TARGET_SOFT_FLOAT
   && TARGET_64BIT))
            return 136; /* *pa.md:4542 */
        }
      if (indexed_memory_operand (operands[0], E_SFmode)
          && register_operand (operands[1], E_SFmode)
          && 
#line 4562 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT
   && !TARGET_DISABLE_INDEXING
   && reload_completed))
        return 137; /* *pa.md:4559 */
      if (!move_dest_operand (operands[0], E_SFmode)
          || !reg_or_0_or_mem_operand (operands[1], E_SFmode)
          || !
#line 4728 "../../gcc-15.0.1-20250313/gcc/config/pa/pa.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && TARGET_SOFT_FLOAT))
        return -1;
      return 138; /* *pa.md:4723 */

    default:
      return -1;
    }
}
