/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!fr_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_XFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_XFmode))
        return -1;
      return 2;

    case E_RFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_RFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!gr_register_operand (operands[0], E_BImode)
          || GET_MODE (x1) != E_BImode
          || !memory_operand (operands[1], E_BImode))
        return -1;
      return 0;

    case E_QImode:
      if (!gr_register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !memory_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!gr_register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !memory_operand (operands[1], E_HImode))
        return -1;
      return 2;

    case E_SImode:
      if (!gr_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (!grfr_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !memory_operand (operands[1], E_DImode))
        return -1;
      return 4;

    case E_SFmode:
      if (!grfr_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !memory_operand (operands[1], E_SFmode))
        return -1;
      return 5;

    case E_DFmode:
      if (!grfr_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !memory_operand (operands[1], E_DFmode))
        return -1;
      return 6;

    case E_XFmode:
      if (!fr_register_operand (operands[0], E_XFmode)
          || GET_MODE (x1) != E_XFmode
          || !memory_operand (operands[1], E_XFmode))
        return -1;
      return 7;

    case E_TImode:
      if (!fr_register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !memory_operand (operands[1], E_TImode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!gr_register_operand (operands[0], E_TImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!gr_register_operand (operands[1], E_TImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!dshift_count_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gr_reg_or_8bit_operand (operands[1], i1)
      || !gr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  if (!signed_inequality_operator (operands[3], E_BImode))
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[4] = x6;
  x7 = XEXP (x6, 0);
  operands[5] = x7;
  if (!register_operand (operands[0], E_BImode)
      || GET_MODE (x3) != E_BImode)
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  x9 = XEXP (x3, 1);
  operands[1] = x9;
  if (!register_operand (operands[1], E_BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!gr_register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gr_register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gr_register_operand (operands[1], i1)
      || !gr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern89 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gr_reg_or_0_operand (operands[1], i1)
      || !gr_reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern94 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], E_V2SFmode)
      || GET_MODE (x1) != E_V2SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode
      || !fr_register_operand (operands[1], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x3, 2);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x3, 1);
  switch (GET_CODE (x8))
    {
    case SUBREG:
    case MEM:
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_BImode:
          if (!gr_register_operand (operands[0], E_BImode)
              || GET_MODE (x3) != E_BImode
              || !memory_operand (operands[1], E_BImode))
            return -1;
          return 0;

        case E_QImode:
          if (!gr_register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !memory_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!gr_register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !memory_operand (operands[1], E_HImode))
            return -1;
          return 2;

        case E_SImode:
          if (!gr_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 3;

        case E_DImode:
          if (!grfr_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 4;

        case E_SFmode:
          if (!grfr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !memory_operand (operands[1], E_SFmode))
            return -1;
          return 5;

        case E_DFmode:
          if (!grfr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !memory_operand (operands[1], E_DFmode))
            return -1;
          return 6;

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode
              || !memory_operand (operands[1], E_XFmode))
            return -1;
          return 7;

        case E_TImode:
          if (!fr_register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !memory_operand (operands[1], E_TImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x8) != E_DImode
          || !gr_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!memory_operand (operands[1], E_QImode))
            return -1;
          return 9;

        case E_HImode:
          if (!memory_operand (operands[1], E_HImode))
            return -1;
          return 10;

        case E_SImode:
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (XVECLEN (x3, 0))
        {
        case 8:
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x9) != CONST_INT
              || pattern76 (x3) != 0
              || pattern89 (x2, 
E_V8QImode, 
E_V16QImode) != 0)
            return -1;
          switch (XWINT (x8, 0))
            {
            case 0L:
              if (XWINT (x9, 0) != 8L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              switch (XWINT (x10, 0))
                {
                case 1L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 9L)
                    return -1;
                  x12 = XVECEXP (x3, 0, 4);
                  if (XWINT (x12, 0) != 2L)
                    return -1;
                  x13 = XVECEXP (x3, 0, 5);
                  if (XWINT (x13, 0) != 10L)
                    return -1;
                  x14 = XVECEXP (x3, 0, 6);
                  if (XWINT (x14, 0) != 3L)
                    return -1;
                  x15 = XVECEXP (x3, 0, 7);
                  if (XWINT (x15, 0) != 11L)
                    return -1;
                  return 439; /* *vec_interleave_lowv8qi */

                case 2L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 10L)
                    return -1;
                  x12 = XVECEXP (x3, 0, 4);
                  if (XWINT (x12, 0) != 4L)
                    return -1;
                  x13 = XVECEXP (x3, 0, 5);
                  if (XWINT (x13, 0) != 12L)
                    return -1;
                  x14 = XVECEXP (x3, 0, 6);
                  if (XWINT (x14, 0) != 6L)
                    return -1;
                  x15 = XVECEXP (x3, 0, 7);
                  if (XWINT (x15, 0) != 14L)
                    return -1;
                  return 441; /* *mix1_even */

                default:
                  return -1;
                }

            case 4L:
              if (XWINT (x9, 0) != 12L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 5L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 13L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 6L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 14L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 7L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 15L)
                return -1;
              return 440; /* *vec_interleave_highv8qi */

            case 1L:
              if (XWINT (x9, 0) != 9L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 11L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 5L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 13L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 7L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 15L)
                return -1;
              return 442; /* *mix1_odd */

            default:
              return -1;
            }

        case 4:
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (GET_CODE (x11) != CONST_INT
              || pattern89 (x2, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          switch (XWINT (x8, 0))
            {
            case 0L:
              if (XWINT (x9, 0) != 4L)
                return -1;
              switch (XWINT (x10, 0))
                {
                case 1L:
                  if (XWINT (x11, 0) != 5L)
                    return -1;
                  return 449; /* *vec_interleave_lowv4hi */

                case 2L:
                  if (XWINT (x11, 0) != 6L)
                    return -1;
                  return 451; /* mix2_even */

                default:
                  return -1;
                }

            case 2L:
              if (XWINT (x9, 0) != 6L
                  || XWINT (x10, 0) != 3L
                  || XWINT (x11, 0) != 7L)
                return -1;
              return 450; /* *vec_interleave_highv4hi */

            case 1L:
              if (XWINT (x9, 0) != 5L
                  || XWINT (x10, 0) != 3L
                  || XWINT (x11, 0) != 7L)
                return -1;
              return 452; /* mix2_odd */

            default:
              return -1;
            }

        case 2:
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          switch (XWINT (x8, 0))
            {
            case 0L:
              switch (XWINT (x9, 0))
                {
                case 2L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2SImode:
                      if (pattern89 (x2, 
E_V2SImode, 
E_V4SImode) != 0)
                        return -1;
                      return 455; /* *vec_interleave_lowv2si */

                    case E_V2SFmode:
                      if (pattern90 (x2) != 0)
                        return -1;
                      return 474; /* *vec_interleave_lowv2sf */

                    default:
                      return -1;
                    }

                case 3L:
                  if (pattern90 (x2) != 0)
                    return -1;
                  return 475; /* fmix_lr */

                default:
                  return -1;
                }

            case 1L:
              switch (XWINT (x9, 0))
                {
                case 3L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2SImode:
                      if (pattern89 (x2, 
E_V2SImode, 
E_V4SImode) != 0)
                        return -1;
                      return 456; /* *vec_interleave_highv2si */

                    case E_V2SFmode:
                      if (pattern90 (x2) != 0)
                        return -1;
                      return 473; /* *vec_interleave_highv2sf */

                    default:
                      return -1;
                    }

                case 2L:
                  if (pattern90 (x2) != 0)
                    return -1;
                  return 472; /* fswap */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (XVECLEN (x3, 0))
        {
        case 8:
          x8 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x9) == CONST_INT)
            {
              res = recog_8 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[2] = x8;
          if (!mux1_brcst_element (operands[2], E_VOIDmode)
              || !gr_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !gr_register_operand (operands[1], E_V8QImode)
              || !rtx_equal_p (x9, operands[2]))
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (!rtx_equal_p (x10, operands[2]))
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          x12 = XVECEXP (x3, 0, 4);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          x13 = XVECEXP (x3, 0, 5);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x14 = XVECEXP (x3, 0, 6);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          x15 = XVECEXP (x3, 0, 7);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          return 447; /* *mux1_brcst_v8qi */

        case 4:
          if (!gr_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !gr_register_operand (operands[1], E_V4HImode))
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          operands[2] = x8;
          if (!const_int_2bit_operand (operands[2], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          operands[3] = x9;
          if (!const_int_2bit_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          operands[4] = x10;
          if (!const_int_2bit_operand (operands[4], E_VOIDmode))
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          operands[5] = x11;
          if (!const_int_2bit_operand (operands[5], E_VOIDmode))
            return -1;
          return 453; /* *mux2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      if (GET_CODE (x5) == REG
          && REGNO (x5) == 1
          && GET_MODE (x5) == E_DImode)
        {
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x4) == E_DImode)
            {
              x8 = XEXP (x4, 1);
              operands[1] = x8;
              if (function_operand (operands[1], E_VOIDmode)
                  && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return 878; /* *p *load_fptr_internal1 */
              if (sdata_symbolic_operand (operands[1], E_VOIDmode)
                  && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return 879; /* *p load_gprel */
            }
        }
      operands[1] = x5;
      if (xfreg_or_fp01_operand (operands[1], E_XFmode))
        {
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x6, 0);
          operands[4] = x7;
          if (fr_register_operand (operands[0], E_XFmode)
              && GET_MODE (x4) == E_XFmode)
            {
              x8 = XEXP (x4, 1);
              operands[2] = x8;
              if (xfreg_or_signed_fp01_operand (operands[2], E_XFmode))
                return 1031; /* *p addxf3 */
            }
        }
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern104 (x4, 
E_SImode) != 0)
            return -1;
          return 968; /* *p addsi3 */

        case E_DImode:
          if (pattern104 (x4, 
E_DImode) != 0)
            return -1;
          return 977; /* *p adddi3 */

        case E_SFmode:
          if (pattern105 (x4, 
E_SFmode) != 0)
            return -1;
          return 996; /* *p addsf3 */

        case E_DFmode:
          if (pattern105 (x4, 
E_DFmode) != 0)
            return -1;
          return 1010; /* *p adddf3 */

        case E_V8QImode:
          if (pattern44 (x4, 
E_V8QImode) != 0)
            return -1;
          return 1145; /* *p addv8qi3 */

        case E_V4HImode:
          if (pattern44 (x4, 
E_V4HImode) != 0)
            return -1;
          return 1146; /* *p addv4hi3 */

        case E_V2SImode:
          if (pattern44 (x4, 
E_V2SImode) != 0)
            return -1;
          return 1147; /* *p addv2si3 */

        default:
          return -1;
        }

    case HIGH:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!got_symbolic_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 772 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
        return -1;
      return 882; /* *p *load_symptr_high */

    case UNSPEC:
      if (XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || GET_MODE (x5) != E_DImode)
        return -1;
      x10 = XVECEXP (x5, 0, 0);
      operands[1] = x10;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      switch (XINT (x5, 1))
        {
        case 0:
          if (!tls_symbolic_operand (operands[1], E_VOIDmode)
              || !
#line 815 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return -1;
          return 885; /* *p *load_ltoff_dtpmod */

        case 1:
          if (!tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          return 889; /* *p *load_ltoff_dtprel */

        case 2:
          if (!ld_tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          if (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS14))
            return 890; /* *p *add_dtprel14 */
          if (!
#line 889 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS22))
            return -1;
          return 891; /* *p *add_dtprel22 */

        case 3:
          if (!ie_tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          return 895; /* *p *load_ltoff_tprel */

        case 4:
          if (!le_tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          if (
#line 954 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS14))
            return 896; /* *p *add_tprel14 */
          if (!
#line 963 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS22))
            return -1;
          return 897; /* *p *add_tprel22 */

        default:
          return -1;
        }

    case PLUS:
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[1] = x9;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x6, 0);
          operands[4] = x7;
          x11 = XEXP (x5, 1);
          operands[2] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern122 (x4, 
E_SImode) != 0)
                return -1;
              return 969; /* *p *addsi3_plus1 */

            case E_DImode:
              if (pattern122 (x4, 
E_DImode) != 0)
                return -1;
              return 978; /* *p *adddi3_plus1 */

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x9) != E_DImode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[5] = x6;
          x7 = XEXP (x6, 0);
          operands[6] = x7;
          if (!gr_register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode
              || pattern123 (x4) != 0
              || !
#line 3410 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(lra_in_progress))
            return -1;
          return 1064; /* *p *shladd_elim */

        default:
          return -1;
        }

    case MULT:
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x11 = XEXP (x5, 1);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
          if (XWINT (x11, 0) == 2L)
            {
              x8 = XEXP (x4, 1);
              if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
                {
                  x6 = XEXP (x1, 0);
                  operands[2] = x6;
                  x7 = XEXP (x6, 0);
                  operands[3] = x7;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern124 (x4, 
E_SImode) == 0)
                        return 970; /* *p *addsi3_plus1_alt */
                      break;

                    case E_DImode:
                      if (pattern124 (x4, 
E_DImode) == 0)
                        return 979; /* *p *adddi3_plus1_alt */
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[2] = x11;
          x6 = XEXP (x1, 0);
          operands[4] = x6;
          x7 = XEXP (x6, 0);
          operands[5] = x7;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern125 (x4, 
E_SImode) != 0)
                return -1;
              return 971; /* *p *addsi3_shladd */

            case E_DImode:
              if (pattern125 (x4, 
E_DImode) != 0)
                return -1;
              return 1063; /* *p *shladd */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x11;
          if (!grfr_register_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[4] = x6;
          x7 = XEXP (x6, 0);
          operands[5] = x7;
          if (!fr_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x5) != E_SImode
              || !grfr_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          if (!grfr_register_operand (operands[3], E_SImode))
            return -1;
          return 975; /* *p maddsi4 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern106 (x4, 
E_SImode) != 0)
            return -1;
          return 973; /* *p *subsi3_minus1 */

        case E_DImode:
          if (pattern106 (x4, 
E_DImode) != 0)
            return -1;
          return 981; /* *p *subdi3_minus1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!predicate_operator (x2, E_VOIDmode))
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  if (!register_operand (x4, E_BImode))
    return -1;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case PARALLEL:
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x6 = XVECEXP (x5, 0, 0);
          switch (GET_CODE (x6))
            {
            case SET:
              x7 = XEXP (x6, 1);
              switch (GET_CODE (x7))
                {
                case PLUS:
                  x8 = XEXP (x7, 0);
                  switch (GET_CODE (x8))
                    {
                    case REG:
                    case SUBREG:
                      x9 = XVECEXP (x5, 0, 1);
                      switch (GET_CODE (x9))
                        {
                        case SET:
                          operands[0] = x2;
                          operands[1] = x4;
                          x10 = XEXP (x6, 0);
                          operands[2] = x10;
                          if (!register_operand (operands[2], E_DImode)
                              || GET_MODE (x7) != E_DImode)
                            return -1;
                          operands[3] = x8;
                          if (!register_operand (operands[3], E_DImode))
                            return -1;
                          x11 = XEXP (x7, 1);
                          operands[4] = x11;
                          if (!gr_reg_or_22bit_operand (operands[4], E_DImode))
                            return -1;
                          x12 = XEXP (x9, 0);
                          operands[5] = x12;
                          if (!register_operand (operands[5], E_DImode))
                            return -1;
                          x13 = XEXP (x9, 1);
                          if (!rtx_equal_p (x13, operands[5]))
                            return -1;
                          return 343; /* prologue_allocate_stack_pr */

                        case CLOBBER:
                          operands[4] = x2;
                          operands[5] = x4;
                          x10 = XEXP (x6, 0);
                          operands[0] = x10;
                          if (!gr_register_operand (operands[0], E_TImode)
                              || GET_MODE (x7) != E_TImode)
                            return -1;
                          operands[1] = x8;
                          if (!gr_register_operand (operands[1], E_TImode))
                            return -1;
                          x11 = XEXP (x7, 1);
                          operands[2] = x11;
                          if (!gr_reg_or_14bit_operand (operands[2], E_TImode))
                            return -1;
                          x12 = XEXP (x9, 0);
                          operands[3] = x12;
                          if (!scratch_operand (operands[3], E_BImode))
                            return -1;
                          return 991; /* *p addti3 */

                        default:
                          return -1;
                        }

                    case MULT:
                      if (GET_MODE (x8) != E_DImode)
                        return -1;
                      x9 = XVECEXP (x5, 0, 1);
                      if (GET_CODE (x9) != CLOBBER)
                        return -1;
                      operands[5] = x2;
                      operands[6] = x4;
                      x10 = XEXP (x6, 0);
                      operands[0] = x10;
                      if (!fr_register_operand (operands[0], E_DImode)
                          || GET_MODE (x7) != E_DImode)
                        return -1;
                      x14 = XEXP (x8, 0);
                      operands[1] = x14;
                      if (!grfr_register_operand (operands[1], E_DImode))
                        return -1;
                      x15 = XEXP (x8, 1);
                      operands[2] = x15;
                      if (!grfr_register_operand (operands[2], E_DImode))
                        return -1;
                      x11 = XEXP (x7, 1);
                      operands[3] = x11;
                      if (!grfr_register_operand (operands[3], E_DImode))
                        return -1;
                      x12 = XEXP (x9, 0);
                      operands[4] = x12;
                      if (!scratch_operand (operands[4], E_DImode))
                        return -1;
                      return 983; /* *p madddi4 */

                    case PLUS:
                      if (GET_MODE (x8) != E_DImode)
                        return -1;
                      x14 = XEXP (x8, 0);
                      if (GET_CODE (x14) != MULT
                          || GET_MODE (x14) != E_DImode)
                        return -1;
                      x9 = XVECEXP (x5, 0, 1);
                      if (GET_CODE (x9) != CLOBBER)
                        return -1;
                      operands[6] = x2;
                      operands[7] = x4;
                      x10 = XEXP (x6, 0);
                      operands[0] = x10;
                      if (!register_operand (operands[0], E_DImode)
                          || GET_MODE (x7) != E_DImode)
                        return -1;
                      x16 = XEXP (x14, 0);
                      operands[1] = x16;
                      if (!register_operand (operands[1], E_DImode))
                        return -1;
                      x17 = XEXP (x14, 1);
                      operands[2] = x17;
                      if (!register_operand (operands[2], E_DImode))
                        return -1;
                      x15 = XEXP (x8, 1);
                      operands[3] = x15;
                      if (!register_operand (operands[3], E_DImode))
                        return -1;
                      x11 = XEXP (x7, 1);
                      operands[4] = x11;
                      if (!nonmemory_operand (operands[4], E_DImode))
                        return -1;
                      x12 = XEXP (x9, 0);
                      operands[5] = x12;
                      if (!scratch_operand (operands[5], E_DImode)
                          || !
#line 2321 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(lra_in_progress))
                        return -1;
                      return 984; /* *p *madddi4_elim */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                case MEM:
                  x10 = XEXP (x6, 0);
                  switch (GET_CODE (x10))
                    {
                    case REG:
                    case SUBREG:
                      x9 = XVECEXP (x5, 0, 1);
                      if (GET_CODE (x9) != SET)
                        return -1;
                      x13 = XEXP (x9, 1);
                      switch (GET_CODE (x13))
                        {
                        case CONST_INT:
                        case CONST_DOUBLE:
                        case CONST_VECTOR:
                        case REG:
                        case SUBREG:
                          operands[0] = x2;
                          operands[1] = x4;
                          operands[2] = x10;
                          if (register_operand (operands[2], E_DImode))
                            {
                              operands[3] = x7;
                              if (register_operand (operands[3], E_DImode)
                                  && rtx_equal_p (x13, operands[3]))
                                {
                                  x12 = XEXP (x9, 0);
                                  if (rtx_equal_p (x12, operands[3]))
                                    return 345; /* epilogue_deallocate_stack_pr */
                                }
                            }
                          operands[2] = x13;
                          operands[3] = x2;
                          operands[4] = x4;
                          operands[0] = x10;
                          operands[1] = x7;
                          x12 = XEXP (x9, 0);
                          if (!rtx_equal_p (x12, operands[1]))
                            return -1;
                          switch (GET_MODE (operands[0]))
                            {
                            case E_QImode:
                              if (!gr_register_operand (operands[0], E_QImode)
                                  || !not_postinc_memory_operand (operands[1], E_QImode)
                                  || !gr_reg_or_0_operand (operands[2], E_QImode))
                                return -1;
                              return 1233; /* *p xchg_acq_qi */

                            case E_HImode:
                              if (!gr_register_operand (operands[0], E_HImode)
                                  || !not_postinc_memory_operand (operands[1], E_HImode)
                                  || !gr_reg_or_0_operand (operands[2], E_HImode))
                                return -1;
                              return 1234; /* *p xchg_acq_hi */

                            case E_SImode:
                              if (!gr_register_operand (operands[0], E_SImode)
                                  || !not_postinc_memory_operand (operands[1], E_SImode)
                                  || !gr_reg_or_0_operand (operands[2], E_SImode))
                                return -1;
                              return 1235; /* *p xchg_acq_si */

                            case E_DImode:
                              if (!gr_register_operand (operands[0], E_DImode)
                                  || !not_postinc_memory_operand (operands[1], E_DImode)
                                  || !gr_reg_or_0_operand (operands[2], E_DImode))
                                return -1;
                              return 1236; /* *p xchg_acq_di */

                            default:
                              return -1;
                            }

                        case UNSPEC:
                          operands[0] = x10;
                          operands[1] = x7;
                          x12 = XEXP (x9, 0);
                          if (!rtx_equal_p (x12, operands[1]))
                            return -1;
                          switch (XVECLEN (x13, 0))
                            {
                            case 3:
                              operands[4] = x2;
                              operands[5] = x4;
                              if (!gr_register_operand (operands[0], E_DImode)
                                  || !not_postinc_memory_operand (operands[1], E_DImode)
                                  || GET_MODE (x13) != E_DImode)
                                return -1;
                              x18 = XVECEXP (x13, 0, 1);
                              operands[2] = x18;
                              if (!ar_ccv_reg_operand (operands[2], E_DImode))
                                return -1;
                              x19 = XVECEXP (x13, 0, 2);
                              operands[3] = x19;
                              if (!gr_reg_or_0_operand (operands[3], E_DImode))
                                return -1;
                              x20 = XVECEXP (x13, 0, 0);
                              if (!rtx_equal_p (x20, operands[1]))
                                return -1;
                              switch (XINT (x13, 1))
                                {
                                case 16:
                                  return 1231; /* *p cmpxchg_acq_di */

                                case 17:
                                  return 1232; /* *p cmpxchg_rel_di */

                                default:
                                  return -1;
                                }

                            case 2:
                              operands[3] = x2;
                              operands[4] = x4;
                              x18 = XVECEXP (x13, 0, 1);
                              operands[2] = x18;
                              x20 = XVECEXP (x13, 0, 0);
                              if (!rtx_equal_p (x20, operands[1]))
                                return -1;
                              switch (XINT (x13, 1))
                                {
                                case 18:
                                  switch (GET_MODE (operands[0]))
                                    {
                                    case E_SImode:
                                      if (pattern136 (x13, 
E_SImode) != 0)
                                        return -1;
                                      return 1237; /* *p fetchadd_acq_si */

                                    case E_DImode:
                                      if (pattern136 (x13, 
E_DImode) != 0)
                                        return -1;
                                      return 1238; /* *p fetchadd_acq_di */

                                    default:
                                      return -1;
                                    }

                                case 19:
                                  switch (GET_MODE (operands[0]))
                                    {
                                    case E_SImode:
                                      if (pattern136 (x13, 
E_SImode) != 0)
                                        return -1;
                                      return 1239; /* *p fetchadd_rel_si */

                                    case E_DImode:
                                      if (pattern136 (x13, 
E_DImode) != 0)
                                        return -1;
                                      return 1240; /* *p fetchadd_rel_di */

                                    default:
                                      return -1;
                                    }

                                default:
                                  return -1;
                                }

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    case ZERO_EXTRACT:
                      if (GET_MODE (x10) != E_DImode)
                        return -1;
                      x21 = XEXP (x10, 1);
                      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
                        return -1;
                      x22 = XEXP (x10, 2);
                      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                        return -1;
                      x9 = XVECEXP (x5, 0, 1);
                      if (GET_CODE (x9) != CLOBBER)
                        return -1;
                      operands[3] = x2;
                      operands[4] = x4;
                      x23 = XEXP (x10, 0);
                      operands[0] = x23;
                      if (!gr_register_operand (operands[0], E_DImode))
                        return -1;
                      operands[1] = x7;
                      if (!gr_register_operand (operands[1], E_DImode))
                        return -1;
                      x12 = XEXP (x9, 0);
                      operands[2] = x12;
                      if (!gr_register_operand (operands[2], E_DImode))
                        return -1;
                      return 934; /* *p shift_mix4left */

                    case PC:
                      x9 = XVECEXP (x5, 0, 1);
                      if (GET_CODE (x9) != USE)
                        return -1;
                      x12 = XEXP (x9, 0);
                      if (GET_CODE (x12) != LABEL_REF)
                        return -1;
                      operands[2] = x2;
                      operands[3] = x4;
                      operands[0] = x7;
                      if (!register_operand (operands[0], E_DImode))
                        return -1;
                      x24 = XEXP (x12, 0);
                      operands[1] = x24;
                      return 1101; /* *p *tablejump_internal */

                    default:
                      return -1;
                    }

                case NOT:
                  if (GET_MODE (x7) != E_BImode)
                    return -1;
                  x9 = XVECEXP (x5, 0, 1);
                  if (GET_CODE (x9) != CLOBBER)
                    return -1;
                  operands[3] = x2;
                  operands[4] = x4;
                  x10 = XEXP (x6, 0);
                  operands[0] = x10;
                  if (!register_operand (operands[0], E_BImode))
                    return -1;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!register_operand (operands[1], E_BImode))
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[2] = x12;
                  if (!scratch_operand (operands[2], E_BImode))
                    return -1;
                  return 942; /* *p one_cmplbi2 */

                case MINUS:
                  if (GET_MODE (x7) != E_TImode)
                    return -1;
                  x9 = XVECEXP (x5, 0, 1);
                  if (GET_CODE (x9) != CLOBBER)
                    return -1;
                  operands[4] = x2;
                  operands[5] = x4;
                  x10 = XEXP (x6, 0);
                  operands[0] = x10;
                  if (!gr_register_operand (operands[0], E_TImode))
                    return -1;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!gr_reg_or_8bit_operand (operands[1], E_TImode))
                    return -1;
                  x11 = XEXP (x7, 1);
                  operands[2] = x11;
                  if (!gr_register_operand (operands[2], E_TImode))
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[3] = x12;
                  if (!scratch_operand (operands[3], E_BImode))
                    return -1;
                  return 992; /* *p subti3 */

                case NEG:
                  if (GET_MODE (x7) != E_TImode)
                    return -1;
                  x9 = XVECEXP (x5, 0, 1);
                  if (GET_CODE (x9) != CLOBBER)
                    return -1;
                  operands[3] = x2;
                  operands[4] = x4;
                  x10 = XEXP (x6, 0);
                  operands[0] = x10;
                  if (!gr_register_operand (operands[0], E_TImode))
                    return -1;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  if (!gr_register_operand (operands[1], E_TImode))
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[2] = x12;
                  if (!scratch_operand (operands[2], E_BImode))
                    return -1;
                  return 995; /* *p negti2 */

                case CALL:
                  x8 = XEXP (x7, 0);
                  if (GET_CODE (x8) != MEM
                      || GET_MODE (x8) != E_DImode)
                    return -1;
                  x11 = XEXP (x7, 1);
                  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x9 = XVECEXP (x5, 0, 1);
                  if (GET_CODE (x9) != CLOBBER)
                    return -1;
                  operands[3] = x2;
                  operands[4] = x4;
                  x10 = XEXP (x6, 0);
                  operands[0] = x10;
                  x14 = XEXP (x8, 0);
                  operands[1] = x14;
                  if (!call_operand (operands[1], E_DImode))
                    return -1;
                  x12 = XEXP (x9, 0);
                  operands[2] = x12;
                  if (!register_operand (operands[2], E_DImode))
                    return -1;
                  return 1092; /* *p call_value_nogp */

                case UNSPEC:
                  if (XVECLEN (x7, 0) != 2)
                    return -1;
                  operands[4] = x2;
                  operands[5] = x4;
                  x10 = XEXP (x6, 0);
                  operands[0] = x10;
                  if (GET_MODE (x7) != E_DImode)
                    return -1;
                  x25 = XVECEXP (x7, 0, 0);
                  operands[1] = x25;
                  x26 = XVECEXP (x7, 0, 1);
                  operands[2] = x26;
                  if (!const_int_operand (operands[2], E_DImode))
                    return -1;
                  switch (XINT (x7, 1))
                    {
                    case 7:
                      x9 = XVECEXP (x5, 0, 1);
                      if (GET_CODE (x9) != CLOBBER
                          || !destination_operand (operands[0], E_DImode)
                          || !register_operand (operands[1], E_DImode))
                        return -1;
                      x12 = XEXP (x9, 0);
                      operands[3] = x12;
                      if (!register_operand (operands[3], E_DImode))
                        return -1;
                      return 1102; /* *p gr_spill_internal */

                    case 8:
                      x9 = XVECEXP (x5, 0, 1);
                      if (GET_CODE (x9) != USE
                          || !register_operand (operands[0], E_DImode)
                          || !memory_operand (operands[1], E_DImode))
                        return -1;
                      x12 = XEXP (x9, 0);
                      operands[3] = x12;
                      if (!register_operand (operands[3], E_DImode))
                        return -1;
                      return 1103; /* *p gr_restore_internal */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  if (GET_MODE (x7) != E_DImode)
                    return -1;
                  x9 = XVECEXP (x5, 0, 1);
                  if (GET_CODE (x9) != SET)
                    return -1;
                  x13 = XEXP (x9, 1);
                  if (GET_CODE (x13) != UNSPEC
                      || XVECLEN (x13, 0) != 3)
                    return -1;
                  operands[4] = x2;
                  operands[5] = x4;
                  x10 = XEXP (x6, 0);
                  operands[0] = x10;
                  if (!gr_register_operand (operands[0], E_DImode))
                    return -1;
                  x8 = XEXP (x7, 0);
                  operands[1] = x8;
                  x18 = XVECEXP (x13, 0, 1);
                  operands[2] = x18;
                  if (!ar_ccv_reg_operand (operands[2], E_DImode))
                    return -1;
                  x19 = XVECEXP (x13, 0, 2);
                  operands[3] = x19;
                  x20 = XVECEXP (x13, 0, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x12 = XEXP (x9, 0);
                  if (!rtx_equal_p (x12, operands[1]))
                    return -1;
                  switch (XINT (x13, 1))
                    {
                    case 16:
                      switch (pattern137 (x13))
                        {
                        case 0:
                          return 1225; /* *p cmpxchg_acq_qi */

                        case 1:
                          return 1226; /* *p cmpxchg_acq_hi */

                        case 2:
                          return 1227; /* *p cmpxchg_acq_si */

                        default:
                          return -1;
                        }

                    case 17:
                      switch (pattern137 (x13))
                        {
                        case 0:
                          return 1228; /* *p cmpxchg_rel_qi */

                        case 1:
                          return 1229; /* *p cmpxchg_rel_hi */

                        case 2:
                          return 1230; /* *p cmpxchg_rel_si */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case FIX:
                  if (pattern65 (x1) != 0)
                    return -1;
                  return 1247; /* *p fix_truncrfdi2_alts */

                case UNSIGNED_FIX:
                  if (pattern65 (x1) != 0)
                    return -1;
                  return 1248; /* *p fixuns_truncrfdi2_alts */

                default:
                  return -1;
                }

            case CALL:
              x10 = XEXP (x6, 0);
              if (GET_CODE (x10) != MEM
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x9 = XVECEXP (x5, 0, 1);
              if (GET_CODE (x9) != CLOBBER)
                return -1;
              operands[2] = x2;
              operands[3] = x4;
              x23 = XEXP (x10, 0);
              operands[0] = x23;
              if (!call_operand (operands[0], E_DImode))
                return -1;
              x12 = XEXP (x9, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              return 1091; /* *p call_nogp */

            case RETURN:
              x9 = XVECEXP (x5, 0, 1);
              if (GET_CODE (x9) != USE)
                return -1;
              operands[1] = x2;
              operands[2] = x4;
              x12 = XEXP (x9, 0);
              operands[0] = x12;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              return 1097; /* *p return_internal */

            default:
              return -1;
            }

        case 4:
          x9 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x27 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x27) != CLOBBER)
            return -1;
          x28 = XVECEXP (x5, 0, 3);
          if (GET_CODE (x28) != CLOBBER)
            return -1;
          x12 = XEXP (x9, 0);
          if (!register_operand (x12, E_DImode))
            return -1;
          x29 = XEXP (x27, 0);
          if (!scratch_operand (x29, E_DImode))
            return -1;
          x30 = XEXP (x28, 0);
          if (!scratch_operand (x30, E_DImode))
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          switch (GET_CODE (x6))
            {
            case CALL:
              x10 = XEXP (x6, 0);
              if (GET_CODE (x10) != MEM
                  || GET_MODE (x10) != E_DImode)
                return -1;
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              operands[4] = x2;
              operands[5] = x4;
              x23 = XEXP (x10, 0);
              operands[0] = x23;
              if (!call_operand (operands[0], E_DImode))
                return -1;
              operands[1] = x12;
              operands[2] = x29;
              operands[3] = x30;
              return 1094; /* *p call_gp */

            case SET:
              x7 = XEXP (x6, 1);
              if (GET_CODE (x7) != CALL)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != MEM
                  || GET_MODE (x8) != E_DImode)
                return -1;
              x11 = XEXP (x7, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              operands[5] = x2;
              operands[6] = x4;
              x10 = XEXP (x6, 0);
              operands[0] = x10;
              x14 = XEXP (x8, 0);
              operands[1] = x14;
              if (!call_operand (operands[1], E_DImode))
                return -1;
              operands[2] = x12;
              operands[3] = x29;
              operands[4] = x30;
              return 1095; /* *p call_value_gp */

            default:
              return -1;
            }

        case 3:
          if (pattern35 (x5) != 0)
            return -1;
          operands[3] = x2;
          operands[4] = x4;
          x6 = XVECEXP (x5, 0, 0);
          x10 = XEXP (x6, 0);
          x23 = XEXP (x10, 0);
          operands[0] = x23;
          if (!call_operand (operands[0], E_DImode))
            return -1;
          x9 = XVECEXP (x5, 0, 1);
          x12 = XEXP (x9, 0);
          operands[1] = x12;
          if (!scratch_operand (operands[1], E_DImode))
            return -1;
          x27 = XVECEXP (x5, 0, 2);
          x29 = XEXP (x27, 0);
          operands[2] = x29;
          if (!scratch_operand (operands[2], E_DImode))
            return -1;
          return 1096; /* *p sibcall_gp */

        default:
          return -1;
        }

    case SET:
      return recog_40 (x1, insn, pnum_clobbers);

    case CALL:
      x31 = XEXP (x5, 0);
      if (GET_CODE (x31) != MEM
          || GET_MODE (x31) != E_DImode)
        return -1;
      x32 = XEXP (x5, 1);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x2;
      operands[2] = x4;
      x33 = XEXP (x31, 0);
      operands[0] = x33;
      if (!call_operand (operands[0], E_DImode))
        return -1;
      return 1093; /* *p sibcall_nogp */

    case RETURN:
      operands[0] = x2;
      operands[1] = x4;
      if (!
#line 4538 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_direct_return ()))
        return -1;
      return 1098; /* *p return */

    case CONST_INT:
      operands[0] = x2;
      operands[1] = x4;
      switch (XWINT (x5, 0))
        {
        case 0L:
          return 1107; /* *p nop */

        case 1L:
          return 1108; /* *p nop_m */

        case 2L:
          return 1109; /* *p nop_i */

        case 3L:
          return 1110; /* *p nop_f */

        case 4L:
          return 1111; /* *p nop_b */

        case 5L:
          return 1112; /* *p nop_x */

        case 6L:
          return 1113; /* *p pre_cycle */

        default:
          return -1;
        }

    case TRAP_IF:
      x31 = XEXP (x5, 0);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      operands[1] = x2;
      operands[2] = x4;
      x32 = XEXP (x5, 1);
      operands[0] = x32;
      if (!const_int_operand (operands[0], E_VOIDmode))
        return -1;
      return 1114; /* *p *trap */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x5, 0) != 1)
        return -1;
      switch (XINT (x5, 1))
        {
        case 3:
          x6 = XVECEXP (x5, 0, 0);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[0] = x2;
          operands[1] = x4;
          return 1115; /* *p break_f */

        case 8:
          x6 = XVECEXP (x5, 0, 0);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[0] = x2;
          operands[1] = x4;
          return 1117; /* *p nonlocal_goto_receiver */

        case 7:
          operands[1] = x2;
          operands[2] = x4;
          x6 = XVECEXP (x5, 0, 0);
          operands[0] = x6;
          return 1118; /* *p builtin_setjmp_receiver */

        case 9:
          operands[1] = x2;
          operands[2] = x4;
          x6 = XVECEXP (x5, 0, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          return 1123; /* *p probe_stack_address */

        default:
          return -1;
        }

    case PREFETCH:
      operands[3] = x2;
      operands[4] = x4;
      x31 = XEXP (x5, 0);
      operands[0] = x31;
      if (!address_operand (operands[0], E_DImode))
        return -1;
      x32 = XEXP (x5, 1);
      operands[1] = x32;
      if (!const_int_operand (operands[1], E_DImode))
        return -1;
      x34 = XEXP (x5, 2);
      operands[2] = x34;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      return 1116; /* *p prefetch */

    default:
      return -1;
    }
}
