/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern8 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern8 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!fr_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_DFmode:
          if (!fr_reg_or_fp01_operand (operands[1], E_DFmode)
              || !fr_reg_or_signed_fp01_operand (operands[2], E_DFmode))
            return -1;
          return 0;

        case E_XFmode:
          if (!xfreg_or_fp01_operand (operands[1], E_XFmode)
              || !xfreg_or_signed_fp01_operand (operands[2], E_XFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DFmode:
      if (!fr_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x2) != E_XFmode
          || !xfreg_or_fp01_operand (operands[1], E_XFmode)
          || !xfreg_or_signed_fp01_operand (operands[2], E_XFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CALL)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern44 (x6, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern44 (x6, 
E_V4HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern60 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gr_register_operand (operands[1], i1)
      || !gr_reg_or_22bit_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gr_reg_or_0_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !gr_reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern73 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !fr_reg_or_signed_fp01_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!gr_register_operand (operands[0], E_BImode)
          || GET_MODE (x5) != E_BImode
          || !memory_operand (operands[1], E_BImode))
        return -1;
      return 0;

    case E_QImode:
      if (!gr_register_operand (operands[0], E_QImode)
          || GET_MODE (x5) != E_QImode
          || !memory_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!gr_register_operand (operands[0], E_HImode)
          || GET_MODE (x5) != E_HImode
          || !memory_operand (operands[1], E_HImode))
        return -1;
      return 2;

    case E_SImode:
      if (!gr_register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (!grfr_register_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || !memory_operand (operands[1], E_DImode))
        return -1;
      return 4;

    case E_SFmode:
      if (!grfr_register_operand (operands[0], E_SFmode)
          || GET_MODE (x5) != E_SFmode
          || !memory_operand (operands[1], E_SFmode))
        return -1;
      return 5;

    case E_DFmode:
      if (!grfr_register_operand (operands[0], E_DFmode)
          || GET_MODE (x5) != E_DFmode
          || !memory_operand (operands[1], E_DFmode))
        return -1;
      return 6;

    case E_XFmode:
      if (!fr_register_operand (operands[0], E_XFmode)
          || GET_MODE (x5) != E_XFmode
          || !memory_operand (operands[1], E_XFmode))
        return -1;
      return 7;

    case E_TImode:
      if (!fr_register_operand (operands[0], E_TImode)
          || GET_MODE (x5) != E_TImode
          || !memory_operand (operands[1], E_TImode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!grfr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !grfr_register_operand (operands[1], i1)
      || !grfr_reg_or_8bit_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gr_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!not_postinc_memory_operand (operands[1], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !gr_reg_or_0_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!not_postinc_memory_operand (operands[1], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !gr_reg_or_0_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!not_postinc_memory_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !gr_reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern76 (x3) != 0
      || !gr_register_operand (operands[0], E_V8QImode)
      || GET_MODE (x2) != E_V8QImode
      || !gr_register_operand (operands[1], E_V8QImode))
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 7L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 6L)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 5L)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 4L)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 3L)
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (XWINT (x9, 0) != 2L)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 1L)
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 0L)
        return -1;
      return 443; /* *mux1_rev */

    case 0L:
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 7L)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      switch (XWINT (x5, 0))
        {
        case 4L:
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 3L)
            return -1;
          x6 = XVECEXP (x3, 0, 2);
          switch (XWINT (x6, 0))
            {
            case 2L:
              x7 = XVECEXP (x3, 0, 3);
              if (XWINT (x7, 0) != 6L)
                return -1;
              x8 = XVECEXP (x3, 0, 4);
              if (XWINT (x8, 0) != 1L)
                return -1;
              x9 = XVECEXP (x3, 0, 5);
              if (XWINT (x9, 0) != 5L)
                return -1;
              return 444; /* *mux1_mix */

            case 1L:
              x7 = XVECEXP (x3, 0, 3);
              if (XWINT (x7, 0) != 5L)
                return -1;
              x8 = XVECEXP (x3, 0, 4);
              if (XWINT (x8, 0) != 2L)
                return -1;
              x9 = XVECEXP (x3, 0, 5);
              if (XWINT (x9, 0) != 6L)
                return -1;
              return 445; /* *mux1_shuf */

            default:
              return -1;
            }

        case 2L:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 4L)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 6L)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 1L)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 3L)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 5L)
            return -1;
          return 446; /* *mux1_alt */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gr_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !gr_register_operand (operands[1], E_SImode))
            return -1;
          return 205; /* negsi2 */

        case E_DImode:
          if (!gr_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !gr_register_operand (operands[1], E_DImode))
            return -1;
          return 216; /* negdi2 */

        case E_TImode:
          if (pattern26 (x3, pnum_clobbers) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 224; /* negti2 */

        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !fr_reg_or_fp01_operand (operands[1], E_SFmode))
            return -1;
          return 229; /* negsf2 */

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !fr_reg_or_fp01_operand (operands[1], E_DFmode))
            return -1;
          return 246; /* negdf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode
              || !xfreg_or_fp01_operand (operands[1], E_XFmode))
            return -1;
          return 270; /* negxf2 */

        case E_V8QImode:
          if (!gr_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !gr_register_operand (operands[1], E_V8QImode))
            return -1;
          return 398; /* negv8qi2 */

        case E_V4HImode:
          if (!gr_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !gr_register_operand (operands[1], E_V4HImode))
            return -1;
          return 399; /* negv4hi2 */

        case E_V2SImode:
          if (!gr_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !gr_register_operand (operands[1], E_V2SImode))
            return -1;
          return 400; /* negv2si2 */

        case E_V2SFmode:
          if (!fr_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !fr_register_operand (operands[1], E_V2SFmode))
            return -1;
          return 460; /* negv2sf2 */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern27 (x3, 
E_SFmode) != 0)
            return -1;
          return 230; /* *nabssf2 */

        case E_DFmode:
          if (pattern27 (x3, 
E_DFmode) != 0)
            return -1;
          return 247; /* *nabsdf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode
              || GET_MODE (x4) != E_XFmode
              || !xfreg_or_fp01_operand (operands[1], E_XFmode))
            return -1;
          return 271; /* *nabsxf2 */

        case E_V2SFmode:
          if (pattern28 (x3) != 0)
            return -1;
          return 461; /* *negabsv2sf2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 29)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x4, 0, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern71 (x3, 
E_SFmode) != 0)
            return -1;
          return 232; /* *ncopysignsf3 */

        case E_DFmode:
          if (pattern71 (x3, 
E_DFmode) != 0)
            return -1;
          return 249; /* *ncopysigndf3 */

        case E_XFmode:
          if (pattern71 (x3, 
E_XFmode) != 0)
            return -1;
          return 273; /* *ncopysignxf3 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern50 (x3, 
E_SFmode) != 0)
            return -1;
          return 235; /* *nmulsf3 */

        case E_DFmode:
          if (pattern50 (x3, 
E_DFmode) != 0)
            return -1;
          return 252; /* *nmuldf3 */

        case E_XFmode:
          if (pattern48 (x3, 
E_XFmode) != 0)
            return -1;
          return 276; /* *nmulxf3 */

        case E_V2SFmode:
          if (pattern28 (x3) != 0
              || !fr_register_operand (operands[2], E_V2SFmode))
            return -1;
          return 465; /* *fpnmpy */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  operands[1] = x4;
  if (const_int_operand (operands[1], E_DImode))
    {
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (gr_register_operand (operands[0], E_DImode))
        {
          x8 = XEXP (x3, 2);
          operands[2] = x8;
          if (const_int_operand (operands[2], E_DImode))
            {
              x9 = XEXP (x2, 1);
              operands[3] = x9;
              if (nonmemory_operand (operands[3], E_DImode)
                  && 
#line 1479 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
((gr_register_operand (operands[3], DImode) && INTVAL (operands[1]) <= 16)
   || operands[3] == const0_rtx || operands[3] == constm1_rtx))
                return 931; /* *p *insv_internal */
            }
        }
    }
  if (XWINT (x4, 0) != 32L)
    return -1;
  x8 = XEXP (x3, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!gr_register_operand (operands[0], E_DImode))
    return -1;
  x9 = XEXP (x2, 1);
  operands[1] = x9;
  if (!gr_reg_or_0_operand (operands[1], E_DImode))
    return -1;
  return 936; /* *p mix4right */
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (pattern112 (x4) != 0)
    return -1;
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!gr_register_operand (operands[0], E_V8QImode)
      || GET_MODE (x3) != E_V8QImode
      || !gr_register_operand (operands[1], E_V8QImode))
    return -1;
  x7 = XVECEXP (x4, 0, 0);
  switch (XWINT (x7, 0))
    {
    case 7L:
      x8 = XVECEXP (x4, 0, 1);
      if (XWINT (x8, 0) != 6L)
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (XWINT (x9, 0) != 5L)
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (XWINT (x10, 0) != 4L)
        return -1;
      x11 = XVECEXP (x4, 0, 4);
      if (XWINT (x11, 0) != 3L)
        return -1;
      x12 = XVECEXP (x4, 0, 5);
      if (XWINT (x12, 0) != 2L)
        return -1;
      x13 = XVECEXP (x4, 0, 6);
      if (XWINT (x13, 0) != 1L)
        return -1;
      x14 = XVECEXP (x4, 0, 7);
      if (XWINT (x14, 0) != 0L)
        return -1;
      return 1187; /* *p *mux1_rev */

    case 0L:
      x14 = XVECEXP (x4, 0, 7);
      if (XWINT (x14, 0) != 7L)
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      switch (XWINT (x8, 0))
        {
        case 4L:
          x13 = XVECEXP (x4, 0, 6);
          if (XWINT (x13, 0) != 3L)
            return -1;
          x9 = XVECEXP (x4, 0, 2);
          switch (XWINT (x9, 0))
            {
            case 2L:
              x10 = XVECEXP (x4, 0, 3);
              if (XWINT (x10, 0) != 6L)
                return -1;
              x11 = XVECEXP (x4, 0, 4);
              if (XWINT (x11, 0) != 1L)
                return -1;
              x12 = XVECEXP (x4, 0, 5);
              if (XWINT (x12, 0) != 5L)
                return -1;
              return 1188; /* *p *mux1_mix */

            case 1L:
              x10 = XVECEXP (x4, 0, 3);
              if (XWINT (x10, 0) != 5L)
                return -1;
              x11 = XVECEXP (x4, 0, 4);
              if (XWINT (x11, 0) != 2L)
                return -1;
              x12 = XVECEXP (x4, 0, 5);
              if (XWINT (x12, 0) != 6L)
                return -1;
              return 1189; /* *p *mux1_shuf */

            default:
              return -1;
            }

        case 2L:
          x9 = XVECEXP (x4, 0, 2);
          if (XWINT (x9, 0) != 4L)
            return -1;
          x10 = XVECEXP (x4, 0, 3);
          if (XWINT (x10, 0) != 6L)
            return -1;
          x11 = XVECEXP (x4, 0, 4);
          if (XWINT (x11, 0) != 1L)
            return -1;
          x12 = XVECEXP (x4, 0, 5);
          if (XWINT (x12, 0) != 3L)
            return -1;
          x13 = XVECEXP (x4, 0, 6);
          if (XWINT (x13, 0) != 5L)
            return -1;
          return 1190; /* *p *mux1_alt */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ASHIFT:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      if (!gr_register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      x10 = XEXP (x4, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      if (shladd_log2_operand (operands[2], E_DImode)
          && 
#line 1490 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_depz_field_mask (operands[3], operands[2]) + INTVAL (operands[2]) == 32))
        return 932; /* *p *shladdp4_internal */
      if (!const_int_operand (operands[2], E_DImode)
          || !
#line 1499 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(satisfies_constraint_M (operands[2])
   && ia64_depz_field_mask (operands[3], operands[2]) > 0))
        return -1;
      return 933; /* *p *depz_internal */

    case REG:
    case SUBREG:
      switch (pattern68 (x1))
        {
        case 0:
          return 938; /* *p andbi3 */

        case 1:
          return 1075; /* *p anddi3 */

        case 2:
          return 1130; /* *p andv8qi3 */

        case 3:
          return 1131; /* *p andv4hi3 */

        case 4:
          return 1132; /* *p andv2si3 */

        default:
          return -1;
        }

    case NOT:
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x6, 0);
          operands[4] = x7;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_BImode:
              if (!register_operand (operands[0], E_BImode)
                  || GET_MODE (x4) != E_BImode
                  || GET_MODE (x5) != E_BImode
                  || !register_operand (operands[1], E_BImode)
                  || !register_operand (operands[2], E_BImode))
                return -1;
              return 939; /* *p *andcmbi3 */

            case E_DImode:
              if (pattern117 (x4, 
E_DImode) != 0)
                return -1;
              return 1076; /* *p *andnot */

            case E_V8QImode:
              if (pattern117 (x4, 
E_V8QImode) != 0)
                return -1;
              return 1133; /* *p *andnotv8qi */

            case E_V4HImode:
              if (pattern117 (x4, 
E_V4HImode) != 0)
                return -1;
              return 1134; /* *p *andnotv4hi */

            case E_V2SImode:
              if (pattern117 (x4, 
E_V2SImode) != 0)
                return -1;
              return 1135; /* *p *andnotv2si */

            default:
              return -1;
            }

        case NE:
        case EQ:
          operands[4] = x8;
          if (!predicate_operator (operands[4], E_BImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[5] = x6;
          x7 = XEXP (x6, 0);
          operands[6] = x7;
          if (!register_operand (operands[0], E_BImode)
              || GET_MODE (x4) != E_BImode
              || GET_MODE (x5) != E_BImode)
            return -1;
          x11 = XEXP (x8, 0);
          operands[2] = x11;
          x12 = XEXP (x8, 1);
          operands[3] = x12;
          if (gr_reg_or_8bit_operand (operands[3], E_SImode)
              && gr_reg_or_0_operand (operands[2], E_SImode))
            {
              x10 = XEXP (x4, 1);
              operands[1] = x10;
              if (register_operand (operands[1], E_BImode))
                return 945; /* *p *cmpsi_andnot_0 */
            }
          if (!gr_reg_or_8bit_operand (operands[3], E_DImode)
              || !gr_register_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          return 949; /* *p *cmpdi_andnot_0 */

        case GE:
        case GT:
        case LE:
        case LT:
          operands[3] = x8;
          if (!signed_inequality_operator (operands[3], E_BImode))
            return -1;
          x12 = XEXP (x8, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x1, 0);
          operands[4] = x6;
          x7 = XEXP (x6, 0);
          operands[5] = x7;
          if (!register_operand (operands[0], E_BImode)
              || GET_MODE (x4) != E_BImode
              || GET_MODE (x5) != E_BImode)
            return -1;
          x11 = XEXP (x8, 0);
          operands[2] = x11;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (!gr_register_operand (operands[2], E_SImode))
                return -1;
              return 946; /* *p *cmpsi_andnot_1 */

            case E_DImode:
              if (!gr_register_operand (operands[2], E_DImode))
                return -1;
              return 950; /* *p *cmpdi_andnot_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
      operands[4] = x5;
      if (predicate_operator (operands[4], E_BImode))
        {
          res = recog_21 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x9 = XEXP (x5, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern80 (x1))
        {
        case 0:
          return 951; /* *p *tbit_and_0 */

        case 1:
          return 953; /* *p *tbit_and_2 */

        case 2:
          return 952; /* *p *tbit_and_1 */

        case 3:
          return 954; /* *p *tbit_and_3 */

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
      switch (pattern69 (x1))
        {
        case 0:
          return 944; /* *p *cmpsi_and_1 */

        case 1:
          return 948; /* *p *cmpdi_and_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ZERO_EXTRACT:
          res = recog_20 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case PC:
          x5 = XEXP (x1, 0);
          operands[1] = x5;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          operands[0] = x3;
          if (register_operand (operands[0], E_DImode))
            return 1100; /* *p indirect_jump */
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != LABEL_REF
          || GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      operands[1] = x5;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      return 1099; /* *p jump */

    case UNSPEC:
      return recog_28 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case UNSPEC:
          if (XVECLEN (x7, 0) != 1
              || !gr_register_operand (operands[0], E_DImode))
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          switch (XINT (x7, 1))
            {
            case 31:
              switch (pattern121 (x7))
                {
                case 0:
                  return 788; /* *p zero_extendqidi2_advanced */

                case 1:
                  return 789; /* *p zero_extendhidi2_advanced */

                case 2:
                  return 790; /* *p zero_extendsidi2_advanced */

                default:
                  return -1;
                }

            case 32:
              switch (pattern121 (x7))
                {
                case 0:
                  return 800; /* *p zero_extendqidi2_speculative */

                case 1:
                  return 801; /* *p zero_extendhidi2_speculative */

                case 2:
                  return 802; /* *p zero_extendsidi2_speculative */

                default:
                  return -1;
                }

            case 34:
              switch (pattern121 (x7))
                {
                case 0:
                  return 821; /* *p zero_extendqidi2_speculative_advanced */

                case 1:
                  return 822; /* *p zero_extendhidi2_speculative_advanced */

                case 2:
                  return 823; /* *p zero_extendsidi2_speculative_advanced */

                default:
                  return -1;
                }

            case 33:
              switch (pattern121 (x7))
                {
                case 0:
                  return 824; /* *p zero_extendqidi2_speculative_a */

                case 1:
                  return 825; /* *p zero_extendhidi2_speculative_a */

                case 2:
                  return 826; /* *p zero_extendsidi2_speculative_a */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x7;
          if (gr_register_operand (operands[0], E_DImode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (gr_nonimmediate_operand (operands[1], E_QImode))
                    return 906; /* *p zero_extendqidi2 */
                  break;

                case E_HImode:
                  if (gr_nonimmediate_operand (operands[1], E_HImode))
                    return 907; /* *p zero_extendhidi2 */
                  break;

                default:
                  break;
                }
            }
          if (!grfr_nonimmediate_operand (operands[1], E_SImode)
              || !grfr_register_operand (operands[0], E_DImode))
            return -1;
          return 908; /* *p zero_extendsidi2 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_36 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_30 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_39 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_DImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!got_symbolic_operand (operands[2], E_VOIDmode)
          || !
#line 785 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
        return -1;
      return 883; /* *p *load_symptr_low */

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (gr_register_operand (operands[0], E_DImode))
        {
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (gr_register_operand (operands[1], E_QImode))
                return 903; /* *p extendqidi2 */
              break;

            case E_HImode:
              if (gr_register_operand (operands[1], E_HImode))
                return 904; /* *p extendhidi2 */
              break;

            default:
              break;
            }
        }
      if (!grfr_register_operand (operands[1], E_SImode)
          || !grfr_register_operand (operands[0], E_DImode))
        return -1;
      return 905; /* *p extendsidi2 */

    case FLOAT_EXTEND:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !fr_reg_or_fp01_operand (operands[1], E_SFmode))
            return -1;
          return 909; /* *p extendsfdf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_SFmode))
                return -1;
              return 910; /* *p extendsfxf2 */

            case E_DFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_DFmode))
                return -1;
              return 911; /* *p extenddfxf2 */

            default:
              return -1;
            }

        case E_RFmode:
          if (!fr_register_operand (operands[0], E_RFmode)
              || GET_MODE (x3) != E_RFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_SFmode))
                return -1;
              return 1241; /* *p extendsfrf2 */

            case E_DFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_DFmode))
                return -1;
              return 1242; /* *p extenddfrf2 */

            case E_XFmode:
              if (!fr_reg_or_fp01_operand (operands[1], E_XFmode))
                return -1;
              return 1243; /* *p extendxfrf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      return recog_31 (x1, insn, pnum_clobbers);

    case FLOAT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_RFmode:
          if (!fr_register_operand (operands[0], E_RFmode)
              || GET_MODE (x3) != E_RFmode)
            return -1;
          return 915; /* *p floatdirf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode)
            return -1;
          return 916; /* *p floatdixf2 */

        default:
          return -1;
        }

    case FIX:
      switch (pattern36 (x1))
        {
        case 0:
          return 917; /* *p fix_truncsfdi2 */

        case 1:
          return 918; /* *p fix_truncdfdi2 */

        case 2:
          return 919; /* *p fix_truncxfdi2 */

        case 3:
          return 920; /* *p fix_truncrfdi2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode)
            return -1;
          return 921; /* *p floatunsdisf2 */

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          return 922; /* *p floatunsdidf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode)
            return -1;
          return 923; /* *p floatunsdixf2 */

        case E_RFmode:
          if (!fr_register_operand (operands[0], E_RFmode)
              || GET_MODE (x3) != E_RFmode)
            return -1;
          return 924; /* *p floatunsdirf2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern36 (x1))
        {
        case 0:
          return 925; /* *p fixuns_truncsfdi2 */

        case 1:
          return 926; /* *p fixuns_truncdfdi2 */

        case 2:
          return 927; /* *p fixuns_truncxfdi2 */

        case 3:
          return 928; /* *p fixuns_truncrfdi2 */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (pattern37 (x1) != 0)
        return -1;
      return 929; /* *p extv */

    case ZERO_EXTRACT:
      if (pattern37 (x1) != 0)
        return -1;
      return 930; /* *p extzv */

    case AND:
      return recog_33 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      x10 = XEXP (x3, 1);
      if (GET_CODE (x10) == CONST_INT)
        {
          if (XWINT (x10, 0) == 32L)
            {
              res = recog_22 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[2] = x10;
          if (dshift_count_operand (operands[2], E_DImode))
            {
              x5 = XEXP (x1, 0);
              operands[3] = x5;
              x6 = XEXP (x5, 0);
              operands[4] = x6;
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              if (gr_register_operand (operands[0], E_TImode)
                  && GET_MODE (x3) == E_TImode
                  && gr_register_operand (operands[1], E_TImode))
                return 1071; /* *p *lshrti3_internal */
            }
        }
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern91 (x3) != 0)
            return -1;
          return 1066; /* *p lshrdi3 */

        case E_V4HImode:
          if (pattern92 (x3, 
E_V4HImode) != 0)
            return -1;
          return 1172; /* *p lshrv4hi3 */

        case E_V2SImode:
          if (pattern92 (x3, 
E_V2SImode) != 0)
            return -1;
          return 1173; /* *p lshrv2si3 */

        default:
          return -1;
        }

    case IOR:
      return recog_37 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_34 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_32 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_35 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!gr_register_operand (operands[0], E_DImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      return 988; /* *p popcountdi2 */

    case BSWAP:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!gr_register_operand (operands[0], E_DImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      return 989; /* *p bswapdi2 */

    case ABS:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !fr_reg_or_fp01_operand (operands[1], E_SFmode))
            return -1;
          return 999; /* *p abssf2 */

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !fr_reg_or_fp01_operand (operands[1], E_DFmode))
            return -1;
          return 1016; /* *p absdf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode
              || !xfreg_or_fp01_operand (operands[1], E_XFmode))
            return -1;
          return 1040; /* *p absxf2 */

        case E_V2SFmode:
          if (!fr_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !fr_register_operand (operands[1], E_V2SFmode))
            return -1;
          return 1203; /* *p absv2sf2 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern43 (x1))
        {
        case 0:
          return 1004; /* *p sminsf3 */

        case 1:
          return 1021; /* *p smindf3 */

        case 2:
          return 1045; /* *p sminxf3 */

        case 3:
          return 1167; /* *p *sminv4hi3 */

        case 4:
          return 1212; /* *p sminv2sf3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern43 (x1))
        {
        case 0:
          return 1005; /* *p smaxsf3 */

        case 1:
          return 1022; /* *p smaxdf3 */

        case 2:
          return 1046; /* *p smaxxf3 */

        case 3:
          return 1165; /* *p *smaxv4hi3 */

        case 4:
          return 1211; /* *p smaxv2sf3 */

        default:
          return -1;
        }

    case FMA:
      return recog_38 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern92 (x3, 
E_SImode) != 0)
            return -1;
          return 1059; /* *p *ashlsi3_internal */

        case E_DImode:
          if (pattern91 (x3) != 0)
            return -1;
          return 1062; /* *p ashldi3 */

        case E_TImode:
          if (pattern95 (x3) != 0)
            return -1;
          return 1069; /* *p *ashlti3_internal */

        case E_V4HImode:
          if (pattern92 (x3, 
E_V4HImode) != 0)
            return -1;
          return 1168; /* *p ashlv4hi3 */

        case E_V2SImode:
          if (pattern92 (x3, 
E_V2SImode) != 0)
            return -1;
          return 1169; /* *p ashlv2si3 */

        default:
          return -1;
        }

    case ROTATERT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern92 (x3, 
E_SImode) != 0)
            return -1;
          return 1060; /* *p *rotrsi3_internal */

        case E_DImode:
          if (pattern96 (x3) != 0)
            return -1;
          return 1067; /* *p *rotrdi3_internal */

        default:
          return -1;
        }

    case ROTATE:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern97 (x3) != 0)
            return -1;
          return 1061; /* *p *rotlsi3_internal */

        case E_DImode:
          if (pattern96 (x3) != 0)
            return -1;
          return 1068; /* *p *rotldi3_internal */

        case E_TImode:
          if (pattern95 (x3) != 0)
            return -1;
          return 1072; /* *p *rotlti3_internal */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern91 (x3) != 0)
            return -1;
          return 1065; /* *p ashrdi3 */

        case E_TImode:
          if (pattern95 (x3) != 0)
            return -1;
          return 1070; /* *p *ashrti3_internal */

        case E_V4HImode:
          if (pattern92 (x3, 
E_V4HImode) != 0)
            return -1;
          return 1170; /* *p ashrv4hi3 */

        case E_V2SImode:
          if (pattern92 (x3, 
E_V2SImode) != 0)
            return -1;
          return 1171; /* *p ashrv2si3 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gr_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !gr_register_operand (operands[1], E_SImode))
            return -1;
          return 1074; /* *p one_cmplsi2 */

        case E_DImode:
          if (!gr_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !gr_register_operand (operands[1], E_DImode))
            return -1;
          return 1079; /* *p one_cmpldi2 */

        case E_V8QImode:
          if (!gr_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !gr_register_operand (operands[1], E_V8QImode))
            return -1;
          return 1127; /* *p one_cmplv8qi2 */

        case E_V4HImode:
          if (!gr_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !gr_register_operand (operands[1], E_V4HImode))
            return -1;
          return 1128; /* *p one_cmplv4hi2 */

        case E_V2SImode:
          if (!gr_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !gr_register_operand (operands[1], E_V2SImode))
            return -1;
          return 1129; /* *p one_cmplv2si2 */

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern67 (x3, 
E_DImode) != 0)
            return -1;
          return 1078; /* *p xordi3 */

        case E_V8QImode:
          if (pattern67 (x3, 
E_V8QImode) != 0)
            return -1;
          return 1139; /* *p xorv8qi3 */

        case E_V4HImode:
          if (pattern67 (x3, 
E_V4HImode) != 0)
            return -1;
          return 1140; /* *p xorv4hi3 */

        case E_V2SImode:
          if (pattern67 (x3, 
E_V2SImode) != 0)
            return -1;
          return 1141; /* *p xorv2si3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GT:
        case LE:
        case GTU:
        case LEU:
          res = recog_25 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case GE:
        case LT:
        case GEU:
        case LTU:
          res = recog_26 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_BImode:
          if (!register_operand (operands[0], E_BImode))
            return -1;
          operands[1] = x3;
          if (!comparison_operator (operands[1], E_BImode))
            return -1;
          x7 = XEXP (x3, 0);
          operands[2] = x7;
          x10 = XEXP (x3, 1);
          operands[3] = x10;
          switch (GET_MODE (operands[2]))
            {
            case E_SFmode:
              if (!fr_reg_or_fp01_operand (operands[2], E_SFmode)
                  || !fr_reg_or_fp01_operand (operands[3], E_SFmode))
                return -1;
              return 1084; /* *p *cmpsf_internal */

            case E_DFmode:
              if (!fr_reg_or_fp01_operand (operands[2], E_DFmode)
                  || !fr_reg_or_fp01_operand (operands[3], E_DFmode))
                return -1;
              return 1085; /* *p *cmpdf_internal */

            case E_XFmode:
              if (!xfreg_or_fp01_operand (operands[2], E_XFmode)
                  || !xfreg_or_fp01_operand (operands[3], E_XFmode))
                return -1;
              return 1086; /* *p *cmpxf_internal */

            default:
              return -1;
            }

        case E_V2SFmode:
          if (!fr_register_operand (operands[0], E_V2SFmode))
            return -1;
          operands[3] = x3;
          if (!comparison_operator (operands[3], E_V2SFmode))
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!fr_reg_or_0_operand (operands[1], E_V2SFmode))
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!fr_reg_or_0_operand (operands[2], E_V2SFmode))
            return -1;
          return 1213; /* *p *fpcmp */

        default:
          return -1;
        }

    case PC:
      x5 = XEXP (x1, 0);
      operands[1] = x5;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1122; /* *p ip_value */

    case SS_PLUS:
      switch (pattern45 (x1))
        {
        case 0:
          return 1148; /* *p *ssaddv8qi3 */

        case 1:
          return 1149; /* *p *ssaddv4hi3 */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern45 (x1))
        {
        case 0:
          return 1150; /* *p *usaddv8qi3 */

        case 1:
          return 1151; /* *p *usaddv4hi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern45 (x1))
        {
        case 0:
          return 1155; /* *p *sssubv8qi3 */

        case 1:
          return 1156; /* *p *sssubv4hi3 */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern45 (x1))
        {
        case 0:
          return 1157; /* *p *ussubv8qi3 */

        case 1:
          return 1158; /* *p *ussubv4hi3 */

        default:
          return -1;
        }

    case UMAX:
      if (pattern46 (x1) != 0)
        return -1;
      return 1164; /* *p *umaxv8qi3 */

    case UMIN:
      if (pattern46 (x1) != 0)
        return -1;
      return 1166; /* *p *uminv8qi3 */

    case VEC_CONCAT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case SS_TRUNCATE:
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != SS_TRUNCATE)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern119 (x3, 
E_V4HImode, 
E_V4QImode, 
E_V8QImode) != 0)
                return -1;
              return 1180; /* *p vec_pack_ssat_v4hi */

            case E_V4HImode:
              if (pattern119 (x3, 
E_V2SImode, 
E_V2HImode, 
E_V4HImode) != 0)
                return -1;
              return 1182; /* *p vec_pack_ssat_v2si */

            default:
              return -1;
            }

        case US_TRUNCATE:
          if (GET_MODE (x7) != E_V4QImode)
            return -1;
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != US_TRUNCATE
              || GET_MODE (x10) != E_V4QImode
              || !gr_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!gr_reg_or_0_operand (operands[1], E_V4HImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!gr_reg_or_0_operand (operands[2], E_V4HImode))
            return -1;
          return 1181; /* *p vec_pack_usat_v4hi */

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x7;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (!gr_register_operand (operands[0], E_V2SImode)
                  || GET_MODE (x3) != E_V2SImode
                  || !gr_reg_or_0_operand (operands[1], E_SImode)
                  || !gr_reg_or_0_operand (operands[2], E_SImode))
                return -1;
              return 1201; /* *p *vecinit_v2si */

            case E_V2SFmode:
              if (pattern38 (x3, 
E_V2SFmode) != 0)
                return -1;
              return 1215; /* *p fpack */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_29 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!gr_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !gr_register_operand (operands[1], E_QImode))
            return -1;
          return 1192; /* *p mux1_brcst_qi */

        case E_V4HImode:
          if (!gr_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !gr_register_operand (operands[1], E_HImode))
            return -1;
          return 1198; /* *p *mux2_brcst_hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
