/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gr_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!gr_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!extr_len_operand (operands[2], E_DImode))
    return -1;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  if (!shift_count_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern17 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_TImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_TImode
      || !fr_register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!fr_reg_or_fp01_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_BImode)
      || GET_MODE (x1) != E_BImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_BImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (!register_operand (x4, E_BImode))
    return -1;
  switch (GET_CODE (x2))
    {
    case NE:
      return pattern32 (x1); /* [-1, 1] */

    case EQ:
      res = pattern32 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern44 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gr_register_operand (operands[1], i1)
      || !gr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x3, 2);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x3, 1);
  switch (GET_CODE (x8))
    {
    case SUBREG:
    case MEM:
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_BImode:
          if (!gr_register_operand (operands[0], E_BImode)
              || GET_MODE (x3) != E_BImode
              || !memory_operand (operands[1], E_BImode))
            return -1;
          return 0;

        case E_QImode:
          if (!gr_register_operand (operands[0], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !memory_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!gr_register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !memory_operand (operands[1], E_HImode))
            return -1;
          return 2;

        case E_SImode:
          if (!gr_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 3;

        case E_DImode:
          if (!grfr_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 4;

        case E_SFmode:
          if (!grfr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !memory_operand (operands[1], E_SFmode))
            return -1;
          return 5;

        case E_DFmode:
          if (!grfr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !memory_operand (operands[1], E_DFmode))
            return -1;
          return 6;

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode
              || !memory_operand (operands[1], E_XFmode))
            return -1;
          return 7;

        case E_TImode:
          if (!fr_register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !memory_operand (operands[1], E_TImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x8) != E_DImode
          || !gr_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!memory_operand (operands[1], E_QImode))
            return -1;
          return 9;

        case E_HImode:
          if (!memory_operand (operands[1], E_HImode))
            return -1;
          return 10;

        case E_SImode:
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !grfr_register_operand (operands[1], i1)
      || !grfr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (XWINT (x1, 0))
    {
    case 0L:
      if (!nonimmediate_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case 1L:
      if (!register_operand (operands[0], E_SFmode)
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!memory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1)
      || !fr_reg_or_signed_fp01_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) == 32L)
    {
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) == ZERO_EXTRACT
          && GET_MODE (x4) == E_DImode)
        {
          x5 = XEXP (x4, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 32])
            {
              x6 = XEXP (x4, 2);
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x7 = XEXP (x4, 0);
                  operands[0] = x7;
                  if (gr_register_operand (operands[0], E_DImode)
                      && GET_MODE (x2) == E_DImode
                      && gr_register_operand (operands[1], E_DImode))
                    return 164; /* *mix4left */
                }
            }
        }
    }
  operands[2] = x3;
  if (!dshift_count_operand (operands[2], E_DImode))
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!gr_register_operand (operands[0], E_TImode)
      || GET_MODE (x2) != E_TImode
      || !gr_register_operand (operands[1], E_TImode))
    return -1;
  return 300; /* *lshrti3_internal */
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 31:
          switch (pattern20 (x3))
            {
            case 0:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 7; /* movbi_advanced */

            case 1:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 8; /* movqi_advanced */

            case 2:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 9; /* movhi_advanced */

            case 3:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 10; /* movsi_advanced */

            case 4:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 11; /* movdi_advanced */

            case 5:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 12; /* movsf_advanced */

            case 6:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 13; /* movdf_advanced */

            case 7:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 14; /* movxf_advanced */

            case 8:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 15; /* movti_advanced */

            default:
              return -1;
            }

        case 32:
          switch (pattern20 (x3))
            {
            case 0:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 19; /* movbi_speculative */

            case 1:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 20; /* movqi_speculative */

            case 2:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 21; /* movhi_speculative */

            case 3:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 22; /* movsi_speculative */

            case 4:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 23; /* movdi_speculative */

            case 5:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 24; /* movsf_speculative */

            case 6:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 25; /* movdf_speculative */

            case 7:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 26; /* movxf_speculative */

            case 8:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 27; /* movti_speculative */

            default:
              return -1;
            }

        case 34:
          switch (pattern20 (x3))
            {
            case 0:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 31; /* movbi_speculative_advanced */

            case 1:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 32; /* movqi_speculative_advanced */

            case 2:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 33; /* movhi_speculative_advanced */

            case 3:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 34; /* movsi_speculative_advanced */

            case 4:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 35; /* movdi_speculative_advanced */

            case 5:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 36; /* movsf_speculative_advanced */

            case 6:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 37; /* movdf_speculative_advanced */

            case 7:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 38; /* movxf_speculative_advanced */

            case 8:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 39; /* movti_speculative_advanced */

            default:
              return -1;
            }

        case 33:
          switch (pattern20 (x3))
            {
            case 0:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 40; /* movbi_speculative_a */

            case 1:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 41; /* movqi_speculative_a */

            case 2:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 42; /* movhi_speculative_a */

            case 3:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 43; /* movsi_speculative_a */

            case 4:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 44; /* movdi_speculative_a */

            case 5:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 45; /* movsf_speculative_a */

            case 6:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 46; /* movdf_speculative_a */

            case 7:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 47; /* movxf_speculative_a */

            case 8:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 48; /* movti_speculative_a */

            default:
              return -1;
            }

        case 25:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode))
            return -1;
          return 109; /* *movdi_ret_addr */

        case 5:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          return 112; /* load_dtpmod */

        case 2:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (ld_tls_symbolic_operand (operands[1], E_VOIDmode))
            {
              if (
#line 830 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS64))
                return 114; /* *load_dtprel64 */
              return 115; /* *load_dtprel22 */
            }
          if (!tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          return 116; /* *load_dtprel_gd */

        case 4:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (le_tls_symbolic_operand (operands[1], E_VOIDmode))
            {
              if (
#line 904 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS64))
                return 120; /* *load_tprel64 */
              return 121; /* *load_tprel22 */
            }
          if (!ie_tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          return 122; /* *load_tprel_ie */

        case 13:
          if (GET_MODE (x3) != E_DImode
              || !gr_register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!fr_reg_or_fp01_operand (operands[1], E_XFmode))
            return -1;
          return 219; /* *getf_exp_xf */

        case 9:
          if (GET_MODE (x3) != E_XFmode
              || !destination_operand (operands[0], E_XFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_XFmode))
            return -1;
          return 350; /* fr_spill */

        case 10:
          if (GET_MODE (x3) != E_XFmode
              || !register_operand (operands[0], E_XFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!memory_operand (operands[1], E_XFmode))
            return -1;
          return 351; /* fr_restore */

        case 20:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode))
            return -1;
          return 352; /* bsp_value */

        case 12:
          if (GET_MODE (x3) != E_BImode
              || !register_operand (operands[0], E_BImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[0]))
            return -1;
          return 371; /* pred_rel_mutex */

        case 23:
          if (GET_MODE (x3) != E_DImode
              || !gr_register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!gr_register_operand (operands[1], E_SImode))
                return -1;
              return 374; /* ptr_extend */

            case PLUS:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              x6 = XEXP (x4, 1);
              operands[2] = x6;
              if (gr_reg_or_14bit_operand (operands[2], E_SImode)
                  && basereg_operand (operands[1], E_SImode)
                  && 
#line 5197 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(addp4_optimize_ok (operands[1], operands[2])))
                return 375; /* ptr_extend_plus_imm */
              if (!basereg_operand (operands[2], E_SImode)
                  || !gr_register_operand (operands[1], E_SImode)
                  || !
#line 5207 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(addp4_optimize_ok (operands[1], operands[2])))
                return -1;
              return 376; /* *ptr_extend_plus_2 */

            default:
              return -1;
            }

        case 15:
          if (GET_MODE (x3) != E_BLKmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x4, operands[0]))
            return -1;
          return 480; /* *memory_barrier */

        case 26:
          if (GET_MODE (x3) != E_RFmode
              || !fr_register_operand (operands[0], E_RFmode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 513; /* setf_exp_rf */

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 29:
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern54 (x3, 
E_SFmode) != 0)
                return -1;
              return 231; /* copysignsf3 */

            case E_DFmode:
              if (pattern54 (x3, 
E_DFmode) != 0)
                return -1;
              return 248; /* copysigndf3 */

            case E_XFmode:
              if (pattern54 (x3, 
E_XFmode) != 0)
                return -1;
              return 272; /* copysignxf3 */

            default:
              return -1;
            }

        case 30:
          if (GET_MODE (x3) != E_SFmode)
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          switch (pattern55 (x7))
            {
            case 0:
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && 
#line 1423 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(!TARGET_BIG_ENDIAN))
                return 476; /* *vec_extractv2sf_0_le */
              if (!register_operand (operands[0], E_SFmode)
                  || !
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(TARGET_BIG_ENDIAN))
                return -1;
              return 477; /* *vec_extractv2sf_0_be */

            case 1:
              if (
#line 1460 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(!TARGET_BIG_ENDIAN))
                return 478; /* *vec_extractv2sf_1_le */
              if (!
#line 1476 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(TARGET_BIG_ENDIAN))
                return -1;
              return 479; /* *vec_extractv2sf_1_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 28
          || GET_MODE (x3) != E_DImode
          || !gr_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      operands[2] = x7;
      if (!gr_register_operand (operands[2], E_DImode))
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      operands[3] = x8;
      if (!shift_count_operand (operands[3], E_DImode))
        return -1;
      return 302; /* shrp */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      operands[2] = x7;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (XINT (x5, 1))
        {
        case 35:
          switch (pattern102 (x2))
            {
            case 0:
              if (!
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 827; /* *p movbi_clr */

            case 1:
              if (!
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 828; /* *p movqi_clr */

            case 2:
              if (!
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 829; /* *p movhi_clr */

            case 3:
              if (!
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 830; /* *p movsi_clr */

            case 4:
              if (!
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 831; /* *p movdi_clr */

            case 5:
              if (!
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 832; /* *p movsf_clr */

            case 6:
              if (!
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 833; /* *p movdf_clr */

            case 7:
              if (!
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 834; /* *p movxf_clr */

            case 8:
              if (!
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 835; /* *p movti_clr */

            case 9:
              return 845; /* *p zero_extendqidi2_clr */

            case 10:
              return 846; /* *p zero_extendhidi2_clr */

            case 11:
              return 847; /* *p zero_extendsidi2_clr */

            default:
              return -1;
            }

        case 36:
          switch (pattern102 (x2))
            {
            case 0:
              if (!
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 836; /* *p movbi_nc */

            case 1:
              if (!
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 837; /* *p movqi_nc */

            case 2:
              if (!
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 838; /* *p movhi_nc */

            case 3:
              if (!
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 839; /* *p movsi_nc */

            case 4:
              if (!
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 840; /* *p movdi_nc */

            case 5:
              if (!
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 841; /* *p movsf_nc */

            case 6:
              if (!
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 842; /* *p movdf_nc */

            case 7:
              if (!
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 843; /* *p movxf_nc */

            case 8:
              if (!
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 844; /* *p movti_nc */

            case 9:
              return 848; /* *p zero_extendqidi2_nc */

            case 10:
              return 849; /* *p zero_extendhidi2_nc */

            case 11:
              return 850; /* *p zero_extendsidi2_nc */

            default:
              return -1;
            }

        case 37:
          switch (pattern103 (x2))
            {
            case 0:
              return 851; /* *p advanced_load_check_clr_bi */

            case 1:
              return 852; /* *p advanced_load_check_clr_qi */

            case 2:
              return 853; /* *p advanced_load_check_clr_hi */

            case 3:
              return 854; /* *p advanced_load_check_clr_si */

            case 4:
              return 855; /* *p advanced_load_check_clr_di */

            case 5:
              return 856; /* *p advanced_load_check_clr_sf */

            case 6:
              return 857; /* *p advanced_load_check_clr_df */

            case 7:
              return 858; /* *p advanced_load_check_clr_xf */

            case 8:
              return 859; /* *p advanced_load_check_clr_ti */

            default:
              return -1;
            }

        case 38:
          switch (pattern103 (x2))
            {
            case 0:
              return 860; /* *p advanced_load_check_nc_bi */

            case 1:
              return 861; /* *p advanced_load_check_nc_qi */

            case 2:
              return 862; /* *p advanced_load_check_nc_hi */

            case 3:
              return 863; /* *p advanced_load_check_nc_si */

            case 4:
              return 864; /* *p advanced_load_check_nc_di */

            case 5:
              return 865; /* *p advanced_load_check_nc_sf */

            case 6:
              return 866; /* *p advanced_load_check_nc_df */

            case 7:
              return 867; /* *p advanced_load_check_nc_xf */

            case 8:
              return 868; /* *p advanced_load_check_nc_ti */

            default:
              return -1;
            }

        case 39:
          switch (pattern103 (x2))
            {
            case 0:
              return 869; /* *p speculation_check_bi */

            case 1:
              return 870; /* *p speculation_check_qi */

            case 2:
              return 871; /* *p speculation_check_hi */

            case 3:
              return 872; /* *p speculation_check_si */

            case 4:
              return 873; /* *p speculation_check_di */

            case 5:
              return 874; /* *p speculation_check_sf */

            case 6:
              return 875; /* *p speculation_check_df */

            case 7:
              return 876; /* *p speculation_check_xf */

            case 8:
              return 877; /* *p speculation_check_ti */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!fr_register_operand (operands[1], E_V2SFmode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[4] = x7;
      x8 = XEXP (x7, 0);
      operands[5] = x8;
      x9 = XEXP (x2, 0);
      operands[0] = x9;
      if (!fr_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode)
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!fr_reg_or_0_operand (operands[2], E_V2SFmode))
        return -1;
      x11 = XEXP (x3, 2);
      operands[3] = x11;
      if (!fr_reg_or_0_operand (operands[3], E_V2SFmode))
        return -1;
      return 1214; /* *p *fselect */

    default:
      return -1;
    }
}
