/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], E_SFmode)
      || !fr_reg_or_fp01_operand (operands[2], E_SFmode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_TImode
      || !gr_register_operand (operands[0], E_TImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!gr_register_operand (operands[1], E_TImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!dshift_count_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_BImode
      || !register_operand (operands[0], E_BImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!register_operand (operands[2], E_BImode))
    return -1;
  x3 = XEXP (x1, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_BImode))
        return -1;
      return 0;

    case NOT:
      if (GET_MODE (x3) != E_BImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern32 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[2] = x6;
      return 0;

    case ZERO_EXTRACT:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x3, 2);
      operands[2] = x7;
      if (!shift_count_operand (operands[2], E_DImode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[3] = x6;
      return 1;

    default:
      return -1;
    }
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V8QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!gr_register_operand (operands[0], E_V8QImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!gr_register_operand (operands[1], E_V8QImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!gr_register_operand (operands[2], E_V8QImode))
    return -1;
  return 0;
}

int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1)
      || !fr_reg_or_signed_fp01_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!fr_register_operand (operands[0], E_SFmode)
          || GET_MODE (x5) != E_SFmode)
        return -1;
      switch (GET_MODE (x6))
        {
        case E_DFmode:
          if (!fr_reg_or_fp01_operand (operands[1], E_DFmode)
              || !fr_reg_or_signed_fp01_operand (operands[2], E_DFmode))
            return -1;
          return 0;

        case E_XFmode:
          if (!xfreg_or_fp01_operand (operands[1], E_XFmode)
              || !xfreg_or_signed_fp01_operand (operands[2], E_XFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DFmode:
      if (!fr_register_operand (operands[0], E_DFmode)
          || GET_MODE (x5) != E_DFmode
          || GET_MODE (x6) != E_XFmode
          || !xfreg_or_fp01_operand (operands[1], E_XFmode)
          || !xfreg_or_signed_fp01_operand (operands[2], E_XFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !grfr_register_operand (operands[1], i1)
      || !grfr_register_operand (operands[2], i1)
      || !grfr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !gr_register_operand (operands[1], E_DImode)
      || !gr_reg_or_6bit_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode
      || !gr_register_operand (operands[1], E_TImode)
      || !dshift_count_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XVECEXP (x7, 0, 0);
  operands[0] = x8;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!gr_register_operand (operands[0], E_BImode))
        return -1;
      return 0;

    case E_QImode:
      if (!gr_register_operand (operands[0], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!gr_register_operand (operands[0], E_HImode))
        return -1;
      return 2;

    case E_SImode:
      if (!gr_register_operand (operands[0], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (!grfr_register_operand (operands[0], E_DImode))
        return -1;
      return 4;

    case E_SFmode:
      if (!grfr_register_operand (operands[0], E_SFmode))
        return -1;
      return 5;

    case E_DFmode:
      if (!grfr_register_operand (operands[0], E_DFmode))
        return -1;
      return 6;

    case E_XFmode:
      if (!fr_register_operand (operands[0], E_XFmode))
        return -1;
      return 7;

    case E_TImode:
      if (!fr_register_operand (operands[0], E_TImode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], E_V2SFmode)
      || GET_MODE (x1) != E_V2SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4SFmode
      || !fr_reg_or_0_operand (operands[1], E_V2SFmode)
      || !fr_reg_or_0_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 1
          && GET_MODE (x3) == E_DImode
          && register_operand (operands[0], E_DImode)
          && GET_MODE (x2) == E_DImode)
        {
          x4 = XEXP (x2, 1);
          operands[1] = x4;
          if (function_operand (operands[1], E_VOIDmode)
              && 
#line 721 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return 106; /* *load_fptr_internal1 */
          if (sdata_symbolic_operand (operands[1], E_VOIDmode)
              && 
#line 728 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return 107; /* load_gprel */
        }
      operands[1] = x3;
      if (xfreg_or_fp01_operand (operands[1], E_XFmode)
          && fr_register_operand (operands[0], E_XFmode)
          && GET_MODE (x2) == E_XFmode)
        {
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (xfreg_or_signed_fp01_operand (operands[2], E_XFmode))
            return 260; /* addxf3 */
        }
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern60 (x2, 
E_SImode) != 0)
            return -1;
          return 197; /* addsi3 */

        case E_DImode:
          if (pattern60 (x2, 
E_DImode) != 0)
            return -1;
          return 206; /* adddi3 */

        case E_TImode:
          if (pattern26 (x2, pnum_clobbers) != 0
              || !gr_reg_or_14bit_operand (operands[2], E_TImode))
            return -1;
          *pnum_clobbers = 1;
          return 220; /* addti3 */

        case E_SFmode:
          if (pattern61 (x2, 
E_SFmode) != 0)
            return -1;
          return 225; /* addsf3 */

        case E_DFmode:
          if (pattern61 (x2, 
E_DFmode) != 0)
            return -1;
          return 239; /* adddf3 */

        case E_V8QImode:
          if (pattern8 (x2, 
E_V8QImode) != 0)
            return -1;
          return 401; /* addv8qi3 */

        case E_V4HImode:
          if (pattern8 (x2, 
E_V4HImode) != 0)
            return -1;
          return 402; /* addv4hi3 */

        case E_V2SImode:
          if (pattern8 (x2, 
E_V2SImode) != 0)
            return -1;
          return 403; /* addv2si3 */

        default:
          return -1;
        }

    case HIGH:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!got_symbolic_operand (operands[1], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 772 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
        return -1;
      return 110; /* *load_symptr_high */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 0:
          if (!tls_symbolic_operand (operands[1], E_VOIDmode)
              || !
#line 815 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return -1;
          return 113; /* *load_ltoff_dtpmod */

        case 1:
          if (!tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          return 117; /* *load_ltoff_dtprel */

        case 2:
          if (!ld_tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          if (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS14))
            return 118; /* *add_dtprel14 */
          if (!
#line 889 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS22))
            return -1;
          return 119; /* *add_dtprel22 */

        case 3:
          if (!ie_tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          return 123; /* *load_ltoff_tprel */

        case 4:
          if (!le_tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          if (
#line 954 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS14))
            return 124; /* *add_tprel14 */
          if (!
#line 963 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS22))
            return -1;
          return 125; /* *add_tprel22 */

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern82 (x2, 
E_SImode) != 0)
                return -1;
              return 198; /* *addsi3_plus1 */

            case E_DImode:
              if (pattern82 (x2, 
E_DImode) != 0)
                return -1;
              return 207; /* *adddi3_plus1 */

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x5) != E_DImode
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          x9 = XEXP (x5, 1);
          operands[2] = x9;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          x4 = XEXP (x2, 1);
          operands[4] = x4;
          if (!nonmemory_operand (operands[4], E_DImode))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL
                  || !register_operand (operands[2], E_DImode)
                  || !register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[3], E_DImode)
                  || !
#line 2321 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(lra_in_progress))
                return -1;
              *pnum_clobbers = 1;
              return 213; /* *madddi4_elim */

            case CONST_INT:
              if (!shladd_operand (operands[2], E_DImode)
                  || !gr_register_operand (operands[0], E_DImode)
                  || !gr_register_operand (operands[1], E_DImode)
                  || !nonmemory_operand (operands[3], E_DImode)
                  || !
#line 3410 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(lra_in_progress))
                return -1;
              return 293; /* *shladd_elim */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) == 2L)
            {
              x4 = XEXP (x2, 1);
              if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern83 (x2, 
E_SImode) == 0)
                        return 199; /* *addsi3_plus1_alt */
                      break;

                    case E_DImode:
                      if (pattern83 (x2, 
E_DImode) == 0)
                        return 208; /* *adddi3_plus1_alt */
                      break;

                    default:
                      break;
                    }
                }
            }
          operands[2] = x7;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern84 (x2, 
E_SImode) != 0)
                return -1;
              return 200; /* *addsi3_shladd */

            case E_DImode:
              if (pattern84 (x2, 
E_DImode) != 0)
                return -1;
              return 292; /* *shladd */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x7;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern85 (x2, 
E_SImode) != 0)
                return -1;
              return 204; /* maddsi4 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern85 (x2, 
E_DImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 212; /* madddi4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern62 (x2, 
E_SImode) != 0)
            return -1;
          return 202; /* *subsi3_minus1 */

        case E_DImode:
          if (pattern62 (x2, 
E_DImode) != 0)
            return -1;
          return 210; /* *subdi3_minus1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[5] = x2;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!register_operand (operands[0], E_BImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_BImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (gr_reg_or_8bit_operand (operands[3], E_SImode)
      && gr_reg_or_0_operand (operands[2], E_SImode))
    {
      x9 = XEXP (x5, 1);
      operands[1] = x9;
      if (register_operand (operands[1], E_BImode))
        return 955; /* *p *cmpsi_or_0 */
    }
  if (!gr_reg_or_8bit_operand (operands[3], E_DImode)
      || !gr_register_operand (operands[2], E_DImode))
    return -1;
  x9 = XEXP (x5, 1);
  operands[1] = x9;
  if (!register_operand (operands[1], E_BImode))
    return -1;
  return 959; /* *p *cmpdi_or_0 */
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 31:
          switch (pattern78 (x1))
            {
            case 0:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 779; /* *p movbi_advanced */

            case 1:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 780; /* *p movqi_advanced */

            case 2:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 781; /* *p movhi_advanced */

            case 3:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 782; /* *p movsi_advanced */

            case 4:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 783; /* *p movdi_advanced */

            case 5:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 784; /* *p movsf_advanced */

            case 6:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 785; /* *p movdf_advanced */

            case 7:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 786; /* *p movxf_advanced */

            case 8:
              if (!
#line 564 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 787; /* *p movti_advanced */

            default:
              return -1;
            }

        case 32:
          switch (pattern78 (x1))
            {
            case 0:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 791; /* *p movbi_speculative */

            case 1:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 792; /* *p movqi_speculative */

            case 2:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 793; /* *p movhi_speculative */

            case 3:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 794; /* *p movsi_speculative */

            case 4:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 795; /* *p movdi_speculative */

            case 5:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 796; /* *p movsf_speculative */

            case 6:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 797; /* *p movdf_speculative */

            case 7:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 798; /* *p movxf_speculative */

            case 8:
              if (!
#line 580 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 799; /* *p movti_speculative */

            default:
              return -1;
            }

        case 34:
          switch (pattern78 (x1))
            {
            case 0:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 803; /* *p movbi_speculative_advanced */

            case 1:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 804; /* *p movqi_speculative_advanced */

            case 2:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 805; /* *p movhi_speculative_advanced */

            case 3:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 806; /* *p movsi_speculative_advanced */

            case 4:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 807; /* *p movdi_speculative_advanced */

            case 5:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 808; /* *p movsf_speculative_advanced */

            case 6:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 809; /* *p movdf_speculative_advanced */

            case 7:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 810; /* *p movxf_speculative_advanced */

            case 8:
              if (!
#line 596 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 811; /* *p movti_speculative_advanced */

            default:
              return -1;
            }

        case 33:
          switch (pattern78 (x1))
            {
            case 0:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 812; /* *p movbi_speculative_a */

            case 1:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 813; /* *p movqi_speculative_a */

            case 2:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 814; /* *p movhi_speculative_a */

            case 3:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 815; /* *p movsi_speculative_a */

            case 4:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 816; /* *p movdi_speculative_a */

            case 5:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 817; /* *p movsf_speculative_a */

            case 6:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 818; /* *p movdf_speculative_a */

            case 7:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 819; /* *p movxf_speculative_a */

            case 8:
              if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                return -1;
              return 820; /* *p movti_speculative_a */

            default:
              return -1;
            }

        case 25:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x1, 0);
          operands[1] = x6;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          return 881; /* *p *movdi_ret_addr */

        case 5:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          return 884; /* *p load_dtpmod */

        case 2:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (ld_tls_symbolic_operand (operands[1], E_VOIDmode))
            {
              if (
#line 830 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS64))
                return 886; /* *p *load_dtprel64 */
              return 887; /* *p *load_dtprel22 */
            }
          if (!tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          return 888; /* *p *load_dtprel_gd */

        case 4:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (le_tls_symbolic_operand (operands[1], E_VOIDmode))
            {
              if (
#line 904 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(TARGET_TLS64))
                return 892; /* *p *load_tprel64 */
              return 893; /* *p *load_tprel22 */
            }
          if (!ie_tls_symbolic_operand (operands[1], E_VOIDmode))
            return -1;
          return 894; /* *p *load_tprel_ie */

        case 13:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!gr_register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!fr_reg_or_fp01_operand (operands[1], E_XFmode))
            return -1;
          return 990; /* *p *getf_exp_xf */

        case 9:
          if (GET_MODE (x4) != E_XFmode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!destination_operand (operands[0], E_XFmode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_XFmode))
            return -1;
          return 1104; /* *p fr_spill */

        case 10:
          if (GET_MODE (x4) != E_XFmode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!register_operand (operands[0], E_XFmode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!memory_operand (operands[1], E_XFmode))
            return -1;
          return 1105; /* *p fr_restore */

        case 20:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x1, 0);
          operands[1] = x6;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          return 1106; /* *p bsp_value */

        case 23:
          if (GET_MODE (x4) != E_DImode
              || !gr_register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[1] = x5;
              if (!gr_register_operand (operands[1], E_SImode))
                return -1;
              x6 = XEXP (x1, 0);
              operands[2] = x6;
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              return 1119; /* *p ptr_extend */

            case PLUS:
              if (GET_MODE (x5) != E_SImode)
                return -1;
              x6 = XEXP (x1, 0);
              operands[3] = x6;
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              x8 = XEXP (x5, 0);
              operands[1] = x8;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (gr_reg_or_14bit_operand (operands[2], E_SImode)
                  && basereg_operand (operands[1], E_SImode)
                  && 
#line 5197 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(addp4_optimize_ok (operands[1], operands[2])))
                return 1120; /* *p ptr_extend_plus_imm */
              if (!basereg_operand (operands[2], E_SImode)
                  || !gr_register_operand (operands[1], E_SImode)
                  || !
#line 5207 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(addp4_optimize_ok (operands[1], operands[2])))
                return -1;
              return 1121; /* *p *ptr_extend_plus_2 */

            default:
              return -1;
            }

        case 15:
          if (GET_MODE (x4) != E_BLKmode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[1] = x6;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          x5 = XVECEXP (x4, 0, 0);
          if (!rtx_equal_p (x5, operands[0]))
            return -1;
          return 1224; /* *p *memory_barrier */

        case 26:
          if (GET_MODE (x4) != E_RFmode)
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!fr_register_operand (operands[0], E_RFmode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 1249; /* *p setf_exp_rf */

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      switch (XINT (x4, 1))
        {
        case 29:
          x6 = XEXP (x1, 0);
          operands[3] = x6;
          x7 = XEXP (x6, 0);
          operands[4] = x7;
          x10 = XVECEXP (x4, 0, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern114 (x4, 
E_SFmode) != 0)
                return -1;
              return 1002; /* *p copysignsf3 */

            case E_DFmode:
              if (pattern114 (x4, 
E_DFmode) != 0)
                return -1;
              return 1019; /* *p copysigndf3 */

            case E_XFmode:
              if (pattern114 (x4, 
E_XFmode) != 0)
                return -1;
              return 1043; /* *p copysignxf3 */

            default:
              return -1;
            }

        case 30:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x10 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (pattern115 (x10))
            {
            case 0:
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && 
#line 1423 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(!TARGET_BIG_ENDIAN))
                return 1220; /* *p *vec_extractv2sf_0_le */
              if (!register_operand (operands[0], E_SFmode)
                  || !
#line 1441 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(TARGET_BIG_ENDIAN))
                return -1;
              return 1221; /* *p *vec_extractv2sf_0_be */

            case 1:
              if (
#line 1460 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(!TARGET_BIG_ENDIAN))
                return 1222; /* *p *vec_extractv2sf_1_le */
              if (!
#line 1476 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(TARGET_BIG_ENDIAN))
                return -1;
              return 1223; /* *p *vec_extractv2sf_1_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x4, 1) != 28
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      if (!gr_register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      x10 = XVECEXP (x4, 0, 1);
      operands[2] = x10;
      if (!gr_register_operand (operands[2], E_DImode))
        return -1;
      x11 = XVECEXP (x4, 0, 2);
      operands[3] = x11;
      if (!shift_count_operand (operands[3], E_DImode))
        return -1;
      return 1073; /* *p shrp */

    default:
      return -1;
    }
}
