/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], E_DFmode)
      || GET_MODE (x1) != E_DFmode
      || !fr_reg_or_fp01_operand (operands[1], E_DFmode)
      || !fr_reg_or_fp01_operand (operands[2], E_DFmode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != NE
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_BImode)
      || GET_MODE (x1) != E_BImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_BImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  if (!signed_inequality_operator (operands[3], E_BImode))
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !register_operand (operands[0], E_BImode)
      || GET_MODE (x1) != E_BImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], E_BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!gr_register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gr_register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], E_DFmode)
      || GET_MODE (x1) != E_DFmode
      || !fr_reg_or_fp01_operand (operands[1], E_DFmode)
      || !fr_reg_or_fp01_operand (operands[2], E_DFmode))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], E_V2SFmode)
      || GET_MODE (x1) != E_V2SFmode
      || !fr_register_operand (operands[1], E_V2SFmode)
      || !fr_register_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_XFmode
      || !xfreg_or_fp01_operand (operands[1], E_XFmode)
      || !xfreg_or_fp01_operand (operands[2], E_XFmode))
    return -1;
  return 0;
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (XWINT (x1, 0))
    {
    case 0L:
      if (!nonimmediate_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case 1L:
      if (!register_operand (operands[0], E_SFmode)
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_signed_fp01_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!register_operand (operands[0], E_BImode)
          || GET_MODE (x3) != E_BImode
          || !register_operand (operands[1], E_BImode)
          || !register_operand (operands[2], E_BImode))
        return -1;
      return 0;

    case E_DImode:
      if (pattern67 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern67 (x3, 
E_V8QImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern67 (x3, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern67 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gr_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !gr_register_operand (operands[1], E_SImode)
      || !shift_32bit_count_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern105 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_signed_fp01_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  return 0;
}

int
pattern122 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gr_register_operand (operands[1], i1)
      || !gr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!not_postinc_memory_operand (operands[1], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !gr_reg_or_0_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!not_postinc_memory_operand (operands[1], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !gr_reg_or_0_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!not_postinc_memory_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !gr_reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ASHIFT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != ZERO_EXTEND
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
          || !gr_register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[1] = x7;
      if (!gr_register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!gr_register_operand (operands[2], E_SImode))
        return -1;
      return 166; /* *mix4right_3op */

    case REG:
    case SUBREG:
      switch (pattern22 (x2))
        {
        case 0:
          return 169; /* iorbi3 */

        case 1:
          return 306; /* iordi3 */

        case 2:
          return 392; /* iorv8qi3 */

        case 3:
          return 393; /* iorv4hi3 */

        case 4:
          return 394; /* iorv2si3 */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x3) != E_BImode
          || !register_operand (operands[0], E_BImode)
          || GET_MODE (x2) != E_BImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (!register_operand (x4, E_BImode))
        return -1;
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          operands[2] = x4;
          return 170; /* *iorcmbi3 */

        case NE:
        case EQ:
          operands[4] = x7;
          if (!predicate_operator (operands[4], E_BImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          x10 = XEXP (x7, 1);
          operands[3] = x10;
          if (gr_reg_or_8bit_operand (operands[3], E_SImode)
              && gr_reg_or_0_operand (operands[2], E_SImode))
            {
              operands[1] = x4;
              return 186; /* *cmpsi_orcm_0 */
            }
          if (!gr_reg_or_8bit_operand (operands[3], E_DImode)
              || !gr_register_operand (operands[2], E_DImode))
            return -1;
          operands[1] = x4;
          return 190; /* *cmpdi_orcm_0 */

        case GE:
        case GT:
        case LE:
        case LT:
          operands[3] = x7;
          if (!signed_inequality_operator (operands[3], E_BImode))
            return -1;
          x10 = XEXP (x7, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          operands[1] = x4;
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (!gr_register_operand (operands[2], E_SImode))
                return -1;
              return 187; /* *cmpsi_orcm_1 */

            case E_DImode:
              if (!gr_register_operand (operands[2], E_DImode))
                return -1;
              return 191; /* *cmpdi_orcm_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
      operands[4] = x3;
      if (predicate_operator (operands[4], E_BImode)
          && register_operand (operands[0], E_BImode)
          && GET_MODE (x2) == E_BImode)
        {
          x7 = XEXP (x3, 0);
          operands[2] = x7;
          x11 = XEXP (x3, 1);
          operands[3] = x11;
          if (gr_reg_or_8bit_operand (operands[3], E_SImode)
              && gr_reg_or_0_operand (operands[2], E_SImode))
            {
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              if (register_operand (operands[1], E_BImode))
                return 184; /* *cmpsi_or_0 */
            }
          if (gr_reg_or_8bit_operand (operands[3], E_DImode)
              && gr_register_operand (operands[2], E_DImode))
            {
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              if (register_operand (operands[1], E_BImode))
                return 188; /* *cmpdi_or_0 */
            }
        }
      x11 = XEXP (x3, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern33 (x2))
        {
        case 0:
          return 192; /* *tbit_or_0 */

        case 1:
          return 194; /* *tbit_or_2 */

        case 2:
          return 193; /* *tbit_or_1 */

        case 3:
          return 195; /* *tbit_or_3 */

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
      switch (pattern23 (x2))
        {
        case 0:
          return 185; /* *cmpsi_or_1 */

        case 1:
          return 189; /* *cmpdi_or_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern8 (x3, 
E_HImode) != 0)
            return -1;
          return 196; /* mulhi3 */

        case E_SImode:
          if (pattern49 (x3, 
E_SImode) != 0)
            return -1;
          return 203; /* mulsi3 */

        case E_DImode:
          if (pattern49 (x3, 
E_DImode) != 0)
            return -1;
          return 211; /* muldi3 */

        case E_SFmode:
          if (pattern2 (x3, 
E_SFmode) != 0)
            return -1;
          return 227; /* mulsf3 */

        case E_DFmode:
          if (pattern3 (x3) != 0)
            return -1;
          return 243; /* muldf3 */

        case E_XFmode:
          if (pattern4 (x3) != 0)
            return -1;
          return 266; /* mulxf3 */

        case E_V4HImode:
          if (pattern8 (x3, 
E_V4HImode) != 0)
            return -1;
          return 415; /* mulv4hi3 */

        case E_V2SFmode:
          if (pattern6 (x3) != 0)
            return -1;
          return 462; /* mulv2sf3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern17 (x3, 
SIGN_EXTEND) != 0)
        return -1;
      return 222; /* *mulditi3_internal */

    case ZERO_EXTEND:
      if (pattern17 (x3, 
ZERO_EXTEND) != 0)
        return -1;
      return 223; /* *umulditi3_internal */

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V2SImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_V4SImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 2)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x7, 0, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != VEC_SELECT
          || GET_MODE (x5) != E_V2SImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != SIGN_EXTEND
          || GET_MODE (x10) != E_V4SImode)
        return -1;
      x11 = XEXP (x5, 1);
      if (GET_CODE (x11) != PARALLEL
          || XVECLEN (x11, 0) != 2)
        return -1;
      x12 = XVECEXP (x11, 0, 0);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x11, 0, 1);
      if (GET_CODE (x13) != CONST_INT
          || !gr_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode)
        return -1;
      x14 = XEXP (x6, 0);
      operands[1] = x14;
      if (!gr_register_operand (operands[1], E_V4HImode))
        return -1;
      x15 = XEXP (x10, 0);
      operands[2] = x15;
      if (!gr_register_operand (operands[2], E_V4HImode))
        return -1;
      switch (XWINT (x8, 0))
        {
        case 0L:
          if (XWINT (x9, 0) != 2L
              || XWINT (x12, 0) != 0L
              || XWINT (x13, 0) != 2L)
            return -1;
          return 418; /* vec_widen_smult_even_v4hi */

        case 1L:
          if (XWINT (x9, 0) != 3L
              || XWINT (x12, 0) != 1L
              || XWINT (x13, 0) != 3L)
            return -1;
          return 419; /* vec_widen_smult_odd_v4hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[5] = x2;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!register_operand (operands[0], E_BImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_BImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (gr_reg_or_8bit_operand (operands[3], E_SImode)
      && gr_reg_or_0_operand (operands[2], E_SImode))
    {
      x9 = XEXP (x5, 1);
      operands[1] = x9;
      if (register_operand (operands[1], E_BImode))
        return 943; /* *p *cmpsi_and_0 */
    }
  if (!gr_reg_or_8bit_operand (operands[3], E_DImode)
      || !gr_register_operand (operands[2], E_DImode))
    return -1;
  x9 = XEXP (x5, 1);
  operands[1] = x9;
  if (!register_operand (operands[1], E_BImode))
    return -1;
  return 947; /* *p *cmpdi_and_0 */
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (normal_comparison_operator (operands[1], E_BImode))
    {
      x4 = XEXP (x1, 0);
      operands[4] = x4;
      x5 = XEXP (x4, 0);
      operands[5] = x5;
      if (register_operand (operands[0], E_BImode))
        {
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          if (gr_reg_or_8bit_operand (operands[3], E_SImode)
              && gr_register_operand (operands[2], E_SImode))
            return 1080; /* *p *cmpsi_normal */
          if (gr_reg_or_8bit_operand (operands[3], E_DImode)
              && gr_reg_or_0_operand (operands[2], E_DImode))
            return 1082; /* *p *cmpdi_normal */
        }
    }
  switch (GET_CODE (x3))
    {
    case EQ:
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern111 (x1) != 0)
            return -1;
          return 1087; /* *p *bit_zero */

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (register_operand (operands[1], E_BImode))
            {
              x7 = XEXP (x3, 1);
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x4 = XEXP (x1, 0);
                  operands[2] = x4;
                  x5 = XEXP (x4, 0);
                  operands[3] = x5;
                  if (gr_register_operand (operands[0], E_DImode)
                      && GET_MODE (x3) == E_DImode)
                    return 1090; /* *p *seq_internal */
                }
            }
          x4 = XEXP (x1, 0);
          operands[3] = x4;
          x5 = XEXP (x4, 0);
          operands[4] = x5;
          switch (pattern98 (x3))
            {
            case 0:
              return 1174; /* *p *cmpeq_v8qi */

            case 1:
              return 1175; /* *p *cmpeq_v4hi */

            case 2:
              return 1176; /* *p *cmpeq_v2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern111 (x1) != 0)
            return -1;
          return 1088; /* *p *bit_one */

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          x4 = XEXP (x1, 0);
          operands[2] = x4;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!gr_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          return 1089; /* *p *sne_internal */

        default:
          return -1;
        }

    case GT:
      x4 = XEXP (x1, 0);
      operands[3] = x4;
      x5 = XEXP (x4, 0);
      operands[4] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (pattern98 (x3))
        {
        case 0:
          return 1177; /* *p *cmpgt_v8qi */

        case 1:
          return 1178; /* *p *cmpgt_v4hi */

        case 2:
          return 1179; /* *p *cmpgt_v2si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern44 (x6, 
E_HImode) != 0)
            return -1;
          return 967; /* *p mulhi3 */

        case E_SImode:
          if (pattern109 (x6, 
E_SImode) != 0)
            return -1;
          return 974; /* *p mulsi3 */

        case E_DImode:
          if (pattern109 (x6, 
E_DImode) != 0)
            return -1;
          return 982; /* *p muldi3 */

        case E_SFmode:
          if (pattern38 (x6, 
E_SFmode) != 0)
            return -1;
          return 998; /* *p mulsf3 */

        case E_DFmode:
          if (pattern39 (x6) != 0)
            return -1;
          return 1014; /* *p muldf3 */

        case E_XFmode:
          if (pattern40 (x6) != 0)
            return -1;
          return 1037; /* *p mulxf3 */

        case E_V4HImode:
          if (pattern44 (x6, 
E_V4HImode) != 0)
            return -1;
          return 1159; /* *p mulv4hi3 */

        case E_V2SFmode:
          if (pattern42 (x6) != 0)
            return -1;
          return 1206; /* *p mulv2sf3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern87 (x6, 
SIGN_EXTEND) != 0)
        return -1;
      return 993; /* *p *mulditi3_internal */

    case ZERO_EXTEND:
      if (pattern87 (x6, 
ZERO_EXTEND) != 0)
        return -1;
      return 994; /* *p *umulditi3_internal */

    case VEC_SELECT:
      if (GET_MODE (x7) != E_V2SImode)
        return -1;
      x9 = XEXP (x7, 0);
      if (GET_CODE (x9) != SIGN_EXTEND
          || GET_MODE (x9) != E_V4SImode)
        return -1;
      x10 = XEXP (x7, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 2)
        return -1;
      x11 = XVECEXP (x10, 0, 0);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x10, 0, 1);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != VEC_SELECT
          || GET_MODE (x8) != E_V2SImode)
        return -1;
      x13 = XEXP (x8, 0);
      if (GET_CODE (x13) != SIGN_EXTEND
          || GET_MODE (x13) != E_V4SImode)
        return -1;
      x14 = XEXP (x8, 1);
      if (GET_CODE (x14) != PARALLEL
          || XVECLEN (x14, 0) != 2)
        return -1;
      x15 = XVECEXP (x14, 0, 0);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x14, 0, 1);
      if (GET_CODE (x16) != CONST_INT
          || !gr_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x6) != E_V2SImode)
        return -1;
      x17 = XEXP (x9, 0);
      operands[1] = x17;
      if (!gr_register_operand (operands[1], E_V4HImode))
        return -1;
      x18 = XEXP (x13, 0);
      operands[2] = x18;
      if (!gr_register_operand (operands[2], E_V4HImode))
        return -1;
      switch (XWINT (x11, 0))
        {
        case 0L:
          if (XWINT (x12, 0) != 2L
              || XWINT (x15, 0) != 0L
              || XWINT (x16, 0) != 2L)
            return -1;
          return 1162; /* *p vec_widen_smult_even_v4hi */

        case 1L:
          if (XWINT (x12, 0) != 3L
              || XWINT (x15, 0) != 1L
              || XWINT (x16, 0) != 3L)
            return -1;
          return 1163; /* *p vec_widen_smult_odd_v4hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != ZERO_EXTEND
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x9 = XEXP (x1, 0);
      operands[3] = x9;
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      if (!gr_register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      if (!gr_register_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x7, 0);
      operands[2] = x12;
      if (!gr_register_operand (operands[2], E_SImode))
        return -1;
      return 937; /* *p *mix4right_3op */

    case REG:
    case SUBREG:
      switch (pattern68 (x1))
        {
        case 0:
          return 940; /* *p iorbi3 */

        case 1:
          return 1077; /* *p iordi3 */

        case 2:
          return 1136; /* *p iorv8qi3 */

        case 3:
          return 1137; /* *p iorv4hi3 */

        case 4:
          return 1138; /* *p iorv2si3 */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x5) != E_BImode
          || !register_operand (operands[0], E_BImode)
          || GET_MODE (x4) != E_BImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (!register_operand (x6, E_BImode))
        return -1;
      x11 = XEXP (x5, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[1] = x11;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          x9 = XEXP (x1, 0);
          operands[3] = x9;
          x10 = XEXP (x9, 0);
          operands[4] = x10;
          operands[2] = x6;
          return 941; /* *p *iorcmbi3 */

        case NE:
        case EQ:
          operands[4] = x11;
          if (!predicate_operator (operands[4], E_BImode))
            return -1;
          x9 = XEXP (x1, 0);
          operands[5] = x9;
          x10 = XEXP (x9, 0);
          operands[6] = x10;
          x13 = XEXP (x11, 0);
          operands[2] = x13;
          x14 = XEXP (x11, 1);
          operands[3] = x14;
          if (gr_reg_or_8bit_operand (operands[3], E_SImode)
              && gr_reg_or_0_operand (operands[2], E_SImode))
            {
              operands[1] = x6;
              return 957; /* *p *cmpsi_orcm_0 */
            }
          if (!gr_reg_or_8bit_operand (operands[3], E_DImode)
              || !gr_register_operand (operands[2], E_DImode))
            return -1;
          operands[1] = x6;
          return 961; /* *p *cmpdi_orcm_0 */

        case GE:
        case GT:
        case LE:
        case LT:
          operands[3] = x11;
          if (!signed_inequality_operator (operands[3], E_BImode))
            return -1;
          x14 = XEXP (x11, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x1, 0);
          operands[4] = x9;
          x10 = XEXP (x9, 0);
          operands[5] = x10;
          x13 = XEXP (x11, 0);
          operands[2] = x13;
          operands[1] = x6;
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (!gr_register_operand (operands[2], E_SImode))
                return -1;
              return 958; /* *p *cmpsi_orcm_1 */

            case E_DImode:
              if (!gr_register_operand (operands[2], E_DImode))
                return -1;
              return 962; /* *p *cmpdi_orcm_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
      operands[4] = x5;
      if (predicate_operator (operands[4], E_BImode))
        {
          res = recog_23 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x15 = XEXP (x5, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern80 (x1))
        {
        case 0:
          return 963; /* *p *tbit_or_0 */

        case 1:
          return 965; /* *p *tbit_or_2 */

        case 2:
          return 964; /* *p *tbit_or_1 */

        case 3:
          return 966; /* *p *tbit_or_3 */

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
      switch (pattern69 (x1))
        {
        case 0:
          return 956; /* *p *cmpsi_or_1 */

        case 1:
          return 960; /* *p *cmpdi_or_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || peep2_current_count < 3
      || peep2_current_count < 4
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_BImode))
    return NULL;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!comparison_operator (operands[1], E_BImode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_CCImode))
    return NULL;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_CCImode))
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!register_operand (operands[4], E_CCImode))
    return NULL;
  x9 = XEXP (x7, 1);
  operands[5] = x9;
  if (!register_operand (operands[5], E_CCImode))
    return NULL;
  x10 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x10) != SET)
    return NULL;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != UNSPEC
      || XVECLEN (x11, 0) != 1
      || XINT (x11, 1) != 12
      || GET_MODE (x11) != E_BImode)
    return NULL;
  x12 = XEXP (x10, 0);
  operands[6] = x12;
  if (!register_operand (operands[6], E_BImode))
    return NULL;
  x13 = XVECEXP (x11, 0, 0);
  if (!rtx_equal_p (x13, operands[6])
      || !
#line 2062 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(REGNO (operands[3]) == REGNO (operands[0])
   && REGNO (operands[4]) == REGNO (operands[0]) + 1
   && REGNO (operands[4]) == REGNO (operands[2]) + 1
   && REGNO (operands[6]) == REGNO (operands[2])))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_1 (insn, operands);
}
