/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gr_reg_or_0_operand (operands[1], i1)
      || !gr_reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gr_register_operand (operands[0], E_V8QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!gr_register_operand (operands[1], E_V8QImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!gr_register_operand (operands[2], E_V8QImode))
    return -1;
  return 0;
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!grfr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !grfr_register_operand (operands[1], i1)
      || !grfr_reg_or_8bit_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern26 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !gr_register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode
      || !gr_register_operand (operands[1], E_TImode))
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !gr_register_operand (operands[1], E_SImode)
      || !shift_32bit_count_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern38 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], E_SFmode)
      || !fr_reg_or_fp01_operand (operands[2], E_SFmode))
    return -1;
  return 0;
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gr_reg_or_0_operand (operands[1], i1)
      || !gr_reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern47 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_XFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_XFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XVECEXP (x7, 0, 0);
  operands[0] = x8;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!gr_register_operand (operands[0], E_BImode))
        return -1;
      return 0;

    case E_QImode:
      if (!gr_register_operand (operands[0], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!gr_register_operand (operands[0], E_HImode))
        return -1;
      return 2;

    case E_SImode:
      if (!gr_register_operand (operands[0], E_SImode))
        return -1;
      return 3;

    case E_DImode:
      if (!grfr_register_operand (operands[0], E_DImode))
        return -1;
      return 4;

    case E_SFmode:
      if (!grfr_register_operand (operands[0], E_SFmode))
        return -1;
      return 5;

    case E_DFmode:
      if (!grfr_register_operand (operands[0], E_DFmode))
        return -1;
      return 6;

    case E_XFmode:
      if (!fr_register_operand (operands[0], E_XFmode))
        return -1;
      return 7;

    case E_TImode:
      if (!fr_register_operand (operands[0], E_TImode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      return 0;

    case ZERO_EXTRACT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x1, 0);
      operands[4] = x7;
      x8 = XEXP (x7, 0);
      operands[5] = x8;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      x11 = XEXP (x5, 2);
      operands[2] = x11;
      if (!shift_count_operand (operands[2], E_DImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[3] = x10;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern41 (x1, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern41 (x1, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1)
      || !fr_reg_or_signed_fp01_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gr_register_operand (operands[1], i1)
      || !shladd_operand (operands[2], i1)
      || !gr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gr_reg_or_0_operand (operands[1], i1)
      || !gr_reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (normal_comparison_operator (operands[1], E_BImode)
      && register_operand (operands[0], E_BImode))
    {
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      if (gr_reg_or_8bit_operand (operands[3], E_SImode)
          && gr_register_operand (operands[2], E_SImode))
        return 309; /* *cmpsi_normal */
      if (gr_reg_or_8bit_operand (operands[3], E_DImode)
          && gr_reg_or_0_operand (operands[2], E_DImode))
        return 311; /* *cmpdi_normal */
    }
  switch (GET_CODE (x2))
    {
    case EQ:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern74 (x2) != 0)
            return -1;
          return 316; /* *bit_zero */

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[1] = x3;
          if (register_operand (operands[1], E_BImode))
            {
              x4 = XEXP (x2, 1);
              if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  && gr_register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode)
                return 322; /* *seq_internal */
            }
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern5 (x2, 
E_V8QImode) != 0)
                return -1;
              return 430; /* *cmpeq_v8qi */

            case E_V4HImode:
              if (pattern5 (x2, 
E_V4HImode) != 0)
                return -1;
              return 431; /* *cmpeq_v4hi */

            case E_V2SImode:
              if (pattern5 (x2, 
E_V2SImode) != 0)
                return -1;
              return 432; /* *cmpeq_v2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern74 (x2) != 0)
            return -1;
          return 317; /* *bit_one */

        case REG:
        case SUBREG:
          operands[1] = x3;
          if (!register_operand (operands[1], E_BImode)
              || !gr_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          return 321; /* *sne_internal */

        default:
          return -1;
        }

    case GT:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern5 (x2, 
E_V8QImode) != 0)
            return -1;
          return 433; /* *cmpgt_v8qi */

        case E_V4HImode:
          if (pattern5 (x2, 
E_V4HImode) != 0)
            return -1;
          return 434; /* *cmpgt_v4hi */

        case E_V2SImode:
          if (pattern5 (x2, 
E_V2SImode) != 0)
            return -1;
          return 435; /* *cmpgt_v2si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x7) != E_TImode)
            return -1;
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != SIGN_EXTEND
              || GET_MODE (x8) != E_TImode
              || XWINT (x6, 0) != 64L
              || !fr_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_TImode
              || GET_MODE (x5) != E_TImode)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!fr_reg_or_fp01_operand (operands[2], E_DImode))
            return -1;
          return 214; /* smuldi3_highpart */

        case ZERO_EXTEND:
          x8 = XEXP (x5, 1);
          if (GET_CODE (x8) != ZERO_EXTEND)
            return -1;
          if (GET_MODE (x8) == E_TImode
              && XWINT (x6, 0) == 64L
              && fr_register_operand (operands[0], E_DImode)
              && pattern81 (x3, 
E_TImode, 
E_DImode) == 0)
            {
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (fr_reg_or_fp01_operand (operands[1], E_DImode))
                {
                  x10 = XEXP (x8, 0);
                  operands[2] = x10;
                  if (fr_reg_or_fp01_operand (operands[2], E_DImode))
                    return 215; /* umuldi3_highpart */
                }
            }
          if (GET_MODE (x8) != E_V4SImode
              || !gr_register_operand (operands[0], E_V4HImode)
              || pattern81 (x3, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!gr_register_operand (operands[1], E_V4HImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!gr_register_operand (operands[2], E_V4HImode))
            return -1;
          operands[3] = x6;
          if (!pmpyshr_operand (operands[3], E_SImode))
            return -1;
          return 417; /* pmpyshr2_u */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || GET_MODE (x5) != E_V4SImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != SIGN_EXTEND
          || GET_MODE (x7) != E_V4SImode)
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_CODE (x8) != SIGN_EXTEND
          || GET_MODE (x8) != E_V4SImode
          || !gr_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!gr_register_operand (operands[1], E_V4HImode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!gr_register_operand (operands[2], E_V4HImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!pmpyshr_operand (operands[3], E_SImode))
        return -1;
      return 416; /* pmpyshr2 */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case ZERO_EXTRACT:
              if (GET_MODE (x4) != E_DImode)
                return -1;
              x5 = XEXP (x4, 1);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
                return -1;
              x6 = XEXP (x4, 2);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x7) != CLOBBER)
                return -1;
              x8 = XEXP (x4, 0);
              operands[0] = x8;
              if (!gr_register_operand (operands[0], E_DImode))
                return -1;
              operands[1] = x3;
              if (!gr_register_operand (operands[1], E_DImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[2] = x9;
              if (!gr_register_operand (operands[2], E_DImode))
                return -1;
              return 163; /* shift_mix4left */

            case PC:
              x7 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x7) != USE)
                return -1;
              x9 = XEXP (x7, 0);
              if (GET_CODE (x9) != LABEL_REF)
                return -1;
              operands[0] = x3;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              operands[1] = x10;
              return 341; /* *tablejump_internal */

            case REG:
            case SUBREG:
              operands[0] = x4;
              x7 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x7) != SET)
                return -1;
              operands[1] = x3;
              x9 = XEXP (x7, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              x11 = XEXP (x7, 1);
              switch (GET_CODE (x11))
                {
                case CONST_INT:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case REG:
                case SUBREG:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_DImode:
                      if (register_operand (operands[0], E_DImode)
                          && register_operand (operands[1], E_DImode)
                          && rtx_equal_p (x11, operands[1]))
                        return 344; /* epilogue_deallocate_stack */
                      if (!gr_register_operand (operands[0], E_DImode)
                          || !not_postinc_memory_operand (operands[1], E_DImode))
                        return -1;
                      operands[2] = x11;
                      if (!gr_reg_or_0_operand (operands[2], E_DImode))
                        return -1;
                      return 492; /* xchg_acq_di */

                    case E_QImode:
                      if (!gr_register_operand (operands[0], E_QImode)
                          || !not_postinc_memory_operand (operands[1], E_QImode))
                        return -1;
                      operands[2] = x11;
                      if (!gr_reg_or_0_operand (operands[2], E_QImode))
                        return -1;
                      return 489; /* xchg_acq_qi */

                    case E_HImode:
                      if (!gr_register_operand (operands[0], E_HImode)
                          || !not_postinc_memory_operand (operands[1], E_HImode))
                        return -1;
                      operands[2] = x11;
                      if (!gr_reg_or_0_operand (operands[2], E_HImode))
                        return -1;
                      return 490; /* xchg_acq_hi */

                    case E_SImode:
                      if (!gr_register_operand (operands[0], E_SImode)
                          || !not_postinc_memory_operand (operands[1], E_SImode))
                        return -1;
                      operands[2] = x11;
                      if (!gr_reg_or_0_operand (operands[2], E_SImode))
                        return -1;
                      return 491; /* xchg_acq_si */

                    default:
                      return -1;
                    }

                case UNSPEC:
                  switch (XVECLEN (x11, 0))
                    {
                    case 3:
                      if (!gr_register_operand (operands[0], E_DImode)
                          || !not_postinc_memory_operand (operands[1], E_DImode)
                          || GET_MODE (x11) != E_DImode)
                        return -1;
                      x12 = XVECEXP (x11, 0, 1);
                      operands[2] = x12;
                      if (!ar_ccv_reg_operand (operands[2], E_DImode))
                        return -1;
                      x13 = XVECEXP (x11, 0, 2);
                      operands[3] = x13;
                      if (!gr_reg_or_0_operand (operands[3], E_DImode))
                        return -1;
                      x14 = XVECEXP (x11, 0, 0);
                      if (!rtx_equal_p (x14, operands[1]))
                        return -1;
                      switch (XINT (x11, 1))
                        {
                        case 16:
                          return 487; /* cmpxchg_acq_di */

                        case 17:
                          return 488; /* cmpxchg_rel_di */

                        default:
                          return -1;
                        }

                    case 2:
                      x12 = XVECEXP (x11, 0, 1);
                      operands[2] = x12;
                      x14 = XVECEXP (x11, 0, 0);
                      if (!rtx_equal_p (x14, operands[1]))
                        return -1;
                      switch (XINT (x11, 1))
                        {
                        case 18:
                          switch (GET_MODE (operands[0]))
                            {
                            case E_SImode:
                              if (pattern120 (x11, 
E_SImode) != 0)
                                return -1;
                              return 493; /* fetchadd_acq_si */

                            case E_DImode:
                              if (pattern120 (x11, 
E_DImode) != 0)
                                return -1;
                              return 494; /* fetchadd_acq_di */

                            default:
                              return -1;
                            }

                        case 19:
                          switch (GET_MODE (operands[0]))
                            {
                            case E_SImode:
                              if (pattern120 (x11, 
E_SImode) != 0)
                                return -1;
                              return 495; /* fetchadd_rel_si */

                            case E_DImode:
                              if (pattern120 (x11, 
E_DImode) != 0)
                                return -1;
                              return 496; /* fetchadd_rel_di */

                            default:
                              return -1;
                            }

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x3) != E_BImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_BImode))
            return -1;
          x15 = XEXP (x3, 0);
          operands[1] = x15;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!scratch_operand (operands[2], E_BImode))
            return -1;
          return 171; /* one_cmplbi2 */

        case PLUS:
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x15 = XEXP (x3, 0);
          switch (GET_CODE (x15))
            {
            case MULT:
              if (GET_MODE (x15) != E_DImode)
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x7) != CLOBBER
                  || !fr_register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              x16 = XEXP (x15, 0);
              operands[1] = x16;
              if (!grfr_register_operand (operands[1], E_DImode))
                return -1;
              x17 = XEXP (x15, 1);
              operands[2] = x17;
              if (!grfr_register_operand (operands[2], E_DImode))
                return -1;
              x18 = XEXP (x3, 1);
              operands[3] = x18;
              if (!grfr_register_operand (operands[3], E_DImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[4] = x9;
              if (!scratch_operand (operands[4], E_DImode))
                return -1;
              return 212; /* madddi4 */

            case PLUS:
              if (GET_MODE (x15) != E_DImode)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != MULT
                  || GET_MODE (x16) != E_DImode)
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x7) != CLOBBER
                  || pattern86 (x3) != 0
                  || !nonmemory_operand (operands[4], E_DImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[5] = x9;
              if (!scratch_operand (operands[5], E_DImode)
                  || !
#line 2321 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(lra_in_progress))
                return -1;
              return 213; /* *madddi4_elim */

            case REG:
            case SUBREG:
              operands[1] = x15;
              x18 = XEXP (x3, 1);
              operands[2] = x18;
              x7 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x7))
                {
                case CLOBBER:
                  if (!gr_register_operand (operands[0], E_TImode)
                      || GET_MODE (x3) != E_TImode
                      || !gr_register_operand (operands[1], E_TImode)
                      || !gr_reg_or_14bit_operand (operands[2], E_TImode))
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[3] = x9;
                  if (!scratch_operand (operands[3], E_BImode))
                    return -1;
                  return 220; /* addti3 */

                case SET:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !register_operand (operands[1], E_DImode)
                      || !gr_reg_or_22bit_operand (operands[2], E_DImode))
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[3] = x9;
                  if (!register_operand (operands[3], E_DImode))
                    return -1;
                  x11 = XEXP (x7, 1);
                  if (!rtx_equal_p (x11, operands[3]))
                    return -1;
                  return 342; /* prologue_allocate_stack */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          if (GET_MODE (x3) != E_TImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!gr_register_operand (operands[0], E_TImode))
            return -1;
          x15 = XEXP (x3, 0);
          operands[1] = x15;
          if (!gr_reg_or_8bit_operand (operands[1], E_TImode))
            return -1;
          x18 = XEXP (x3, 1);
          operands[2] = x18;
          if (!gr_register_operand (operands[2], E_TImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[3] = x9;
          if (!scratch_operand (operands[3], E_BImode))
            return -1;
          return 221; /* subti3 */

        case NEG:
          if (GET_MODE (x3) != E_TImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!gr_register_operand (operands[0], E_TImode))
            return -1;
          x15 = XEXP (x3, 0);
          operands[1] = x15;
          if (!gr_register_operand (operands[1], E_TImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!scratch_operand (operands[2], E_BImode))
            return -1;
          return 224; /* negti2 */

        case IF_THEN_ELSE:
          x15 = XEXP (x3, 0);
          if (GET_CODE (x15) != NE)
            return -1;
          x17 = XEXP (x15, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x18 = XEXP (x3, 1);
          if (GET_CODE (x18) != LABEL_REF)
            return -1;
          x19 = XEXP (x3, 2);
          if (GET_CODE (x19) != PC)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != PC)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != IF_THEN_ELSE
              || GET_MODE (x11) != E_DImode)
            return -1;
          x20 = XEXP (x11, 0);
          if (GET_CODE (x20) != NE)
            return -1;
          x21 = XEXP (x20, 1);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x22 = XEXP (x11, 1);
          if (GET_CODE (x22) != PLUS
              || GET_MODE (x22) != E_DImode)
            return -1;
          x23 = XEXP (x22, 1);
          if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x16 = XEXP (x15, 0);
          operands[0] = x16;
          if (!ar_lc_reg_operand (operands[0], E_DImode))
            return -1;
          x24 = XEXP (x18, 0);
          operands[1] = x24;
          x25 = XEXP (x20, 0);
          if (!rtx_equal_p (x25, operands[0]))
            return -1;
          x26 = XEXP (x22, 0);
          if (!rtx_equal_p (x26, operands[0]))
            return -1;
          x27 = XEXP (x11, 2);
          if (!rtx_equal_p (x27, operands[0]))
            return -1;
          x9 = XEXP (x7, 0);
          if (!rtx_equal_p (x9, operands[0]))
            return -1;
          return 320; /* doloop_end_internal */

        case CALL:
          x15 = XEXP (x3, 0);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_DImode)
            return -1;
          x18 = XEXP (x3, 1);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x16 = XEXP (x15, 0);
          operands[1] = x16;
          if (!call_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          switch (XWINT (x18, 0))
            {
            case 0L:
              return 330; /* call_value_nogp */

            case 1L:
              if (pnum_clobbers == NULL)
                return -1;
              *pnum_clobbers = 2;
              return 333; /* call_value_gp */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 2)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x28 = XVECEXP (x3, 0, 0);
          operands[1] = x28;
          x29 = XVECEXP (x3, 0, 1);
          operands[2] = x29;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          switch (XINT (x3, 1))
            {
            case 7:
              x7 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x7) != CLOBBER
                  || !destination_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[3] = x9;
              if (!register_operand (operands[3], E_DImode))
                return -1;
              return 348; /* gr_spill_internal */

            case 8:
              x7 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x7) != USE
                  || !register_operand (operands[0], E_DImode)
                  || !memory_operand (operands[1], E_DImode))
                return -1;
              x9 = XEXP (x7, 0);
              operands[3] = x9;
              if (!register_operand (operands[3], E_DImode))
                return -1;
              return 349; /* gr_restore_internal */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != UNSPEC
              || XVECLEN (x11, 0) != 3)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!gr_register_operand (operands[0], E_DImode))
            return -1;
          x15 = XEXP (x3, 0);
          operands[1] = x15;
          x12 = XVECEXP (x11, 0, 1);
          operands[2] = x12;
          if (!ar_ccv_reg_operand (operands[2], E_DImode))
            return -1;
          x13 = XVECEXP (x11, 0, 2);
          operands[3] = x13;
          x14 = XVECEXP (x11, 0, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x9 = XEXP (x7, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (XINT (x11, 1))
            {
            case 16:
              switch (pattern130 (x11))
                {
                case 0:
                  return 481; /* cmpxchg_acq_qi */

                case 1:
                  return 482; /* cmpxchg_acq_hi */

                case 2:
                  return 483; /* cmpxchg_acq_si */

                default:
                  return -1;
                }

            case 17:
              switch (pattern130 (x11))
                {
                case 0:
                  return 484; /* cmpxchg_rel_qi */

                case 1:
                  return 485; /* cmpxchg_rel_hi */

                case 2:
                  return 486; /* cmpxchg_rel_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case FIX:
          if (pattern18 (x1) != 0)
            return -1;
          return 511; /* fix_truncrfdi2_alts */

        case UNSIGNED_FIX:
          if (pattern18 (x1) != 0)
            return -1;
          return 512; /* fixuns_truncrfdi2_alts */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_DImode)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != CONST_INT)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      if (!call_operand (operands[0], E_DImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (XWINT (x3, 0))
        {
        case 0L:
          return 329; /* call_nogp */

        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 2;
          return 332; /* call_gp */

        default:
          return -1;
        }

    case RETURN:
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != USE)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 335; /* return_internal */

    default:
      return -1;
    }
}
