/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], E_V2SFmode)
      || GET_MODE (x1) != E_V2SFmode
      || !fr_register_operand (operands[1], E_V2SFmode)
      || !fr_register_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XEXP (x1, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return pattern13 (x1); /* [-1, 0] */

    case IOR:
      if (pattern13 (x1) != 0)
        return -1;
      return 1;

    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!register_operand (operands[1], E_BImode)
          || !gr_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!register_operand (operands[0], E_BImode)
          || GET_MODE (x1) != E_BImode
          || !register_operand (operands[1], E_BImode)
          || !register_operand (operands[2], E_BImode))
        return -1;
      return 0;

    case E_DImode:
      if (pattern21 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern21 (x1, 
E_V8QImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern21 (x1, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern21 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], E_XFmode)
      || GET_MODE (x1) != E_XFmode
      || !xfreg_or_fp01_operand (operands[1], E_XFmode)
      || !xfreg_or_fp01_operand (operands[2], E_XFmode))
    return -1;
  return 0;
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern38 (x6, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern39 (x6) != 0)
        return -1;
      return 1;

    case E_XFmode:
      if (pattern40 (x6) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern41 (x6, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V2SFmode:
      if (pattern42 (x6) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!fr_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_DFmode:
          return 0;

        case E_XFmode:
          return 1;

        default:
          return -1;
        }

    case E_DFmode:
      if (!fr_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_BImode)
      || GET_MODE (x1) != E_BImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!gr_register_operand (operands[1], E_DImode))
    return -1;
  x4 = XEXP (x2, 2);
  operands[2] = x4;
  if (!shift_count_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern81 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1)
      || !fr_reg_or_signed_fp01_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern101 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_signed_fp01_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern107 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gr_reg_or_8bit_operand (operands[1], i1)
      || !gr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern113 (rtx x1, int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XVECLEN (x5, 0) != i2
      || XINT (x5, 1) != i1)
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[1] = x6;
  if (!fr_reg_or_fp01_operand (operands[1], E_RFmode))
    return -1;
  return 0;
}

int
pattern120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || !not_postinc_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !fetchadd_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern126 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern135 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_signed_fp01_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_CODE (operands[1]))
    {
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
      if (!symbolic_operand (operands[1], E_DImode))
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 1
          || GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || !
#line 735 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
        return -1;
      return 108; /* *gprel64_offset */

    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern63 (x2, 
E_SImode) != 0)
            return -1;
          return 201; /* subsi3 */

        case E_DImode:
          if (pattern63 (x2, 
E_DImode) != 0)
            return -1;
          return 209; /* subdi3 */

        case E_TImode:
          if (pnum_clobbers == NULL
              || pattern63 (x2, 
E_TImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 221; /* subti3 */

        case E_SFmode:
          if (pattern61 (x2, 
E_SFmode) != 0)
            return -1;
          return 226; /* subsf3 */

        case E_DFmode:
          if (pattern61 (x2, 
E_DFmode) != 0)
            return -1;
          return 241; /* subdf3 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode
              || !xfreg_or_fp01_operand (operands[1], E_XFmode)
              || !xfreg_or_signed_fp01_operand (operands[2], E_XFmode))
            return -1;
          return 263; /* subxf3 */

        case E_V8QImode:
          if (pattern8 (x2, 
E_V8QImode) != 0)
            return -1;
          return 408; /* subv8qi3 */

        case E_V4HImode:
          if (pattern8 (x2, 
E_V4HImode) != 0)
            return -1;
          return 409; /* subv4hi3 */

        case E_V2SImode:
          if (pattern8 (x2, 
E_V2SImode) != 0)
            return -1;
          return 410; /* subv2si3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_CCImode:
          if (destination_operand (operands[0], E_CCImode)
              && move_operand (operands[1], E_CCImode))
            return 1; /* movcci */
          break;

        case E_BImode:
          if (destination_operand (operands[0], E_BImode)
              && move_operand (operands[1], E_BImode))
            return 2; /* movbi */
          break;

        case E_QImode:
          if (destination_operand (operands[0], E_QImode)
              && move_operand (operands[1], E_QImode)
              && 
#line 319 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
            return 3; /* movqi_internal */
          break;

        case E_HImode:
          if (destination_operand (operands[0], E_HImode)
              && move_operand (operands[1], E_HImode)
              && 
#line 346 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
            return 4; /* movhi_internal */
          break;

        case E_SImode:
          if (destination_operand (operands[0], E_SImode)
              && move_operand (operands[1], E_SImode)
              && 
#line 373 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
            return 5; /* movsi_internal */
          break;

        case E_DImode:
          if (destination_operand (operands[0], E_DImode)
              && move_operand (operands[1], E_DImode)
              && 
#line 407 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
            return 6; /* movdi_internal */
          break;

        case E_TImode:
          if (destination_operand (operands[0], E_TImode)
              && general_operand (operands[1], E_TImode)
              && 
#line 985 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
            return 126; /* movti_internal */
          break;

        case E_SFmode:
          if (destination_operand (operands[0], E_SFmode)
              && general_operand (operands[1], E_SFmode)
              && 
#line 1021 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
            return 127; /* movsf_internal */
          break;

        case E_DFmode:
          if (destination_operand (operands[0], E_DFmode)
              && general_operand (operands[1], E_DFmode)
              && 
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
            return 128; /* movdf_internal */
          break;

        case E_XFmode:
          if (destination_operand (operands[0], E_XFmode)
              && general_operand (operands[1], E_XFmode)
              && 
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
            return 129; /* movxf_internal */
          break;

        case E_RFmode:
          if (destination_operand (operands[0], E_RFmode)
              && general_operand (operands[1], E_RFmode)
              && 
#line 1103 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
            return 130; /* *movrf_internal */
          break;

        case E_TFmode:
          if (destination_operand (operands[0], E_TFmode)
              && general_operand (operands[1], E_TFmode)
              && 
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
            return 131; /* *movtf_internal */
          break;

        case E_V8QImode:
          if (destination_operand (operands[0], E_V8QImode)
              && move_operand (operands[1], E_V8QImode)
              && 
#line 48 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(ia64_move_ok (operands[0], operands[1])))
            return 380; /* *movv8qi_internal */
          break;

        case E_V4HImode:
          if (destination_operand (operands[0], E_V4HImode)
              && move_operand (operands[1], E_V4HImode)
              && 
#line 48 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(ia64_move_ok (operands[0], operands[1])))
            return 381; /* *movv4hi_internal */
          break;

        case E_V2SImode:
          if (destination_operand (operands[0], E_V2SImode)
              && move_operand (operands[1], E_V2SImode)
              && 
#line 48 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(ia64_move_ok (operands[0], operands[1])))
            return 382; /* *movv2si_internal */
          break;

        case E_V2SFmode:
          if (destination_operand (operands[0], E_V2SFmode)
              && move_operand (operands[1], E_V2SFmode)
              && 
#line 1086 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(ia64_move_ok (operands[0], operands[1])))
            return 458; /* *movv2sf_internal */
          break;

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      if (register_operand (operands[0], E_DImode))
        return 340; /* indirect_jump */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LABEL_REF
      || GET_CODE (x2) != PC)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  return 339; /* jump */
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_BImode:
      if (!destination_operand (operands[0], E_BImode)
          || !move_operand (operands[1], E_BImode))
        return -1;
      return 774; /* *p movbi */

    case E_QImode:
      if (!destination_operand (operands[0], E_QImode)
          || !move_operand (operands[1], E_QImode)
          || !
#line 319 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 775; /* *p movqi_internal */

    case E_HImode:
      if (!destination_operand (operands[0], E_HImode)
          || !move_operand (operands[1], E_HImode)
          || !
#line 346 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 776; /* *p movhi_internal */

    case E_SImode:
      if (!destination_operand (operands[0], E_SImode)
          || !move_operand (operands[1], E_SImode)
          || !
#line 373 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 777; /* *p movsi_internal */

    case E_DImode:
      if (!destination_operand (operands[0], E_DImode)
          || !move_operand (operands[1], E_DImode)
          || !
#line 407 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 778; /* *p movdi_internal */

    case E_TImode:
      if (!destination_operand (operands[0], E_TImode)
          || !general_operand (operands[1], E_TImode)
          || !
#line 985 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 898; /* *p movti_internal */

    case E_SFmode:
      if (!destination_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode)
          || !
#line 1021 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 899; /* *p movsf_internal */

    case E_DFmode:
      if (!destination_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 900; /* *p movdf_internal */

    case E_XFmode:
      if (!destination_operand (operands[0], E_XFmode)
          || !general_operand (operands[1], E_XFmode)
          || !
#line 1081 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 901; /* *p movxf_internal */

    case E_RFmode:
      if (!destination_operand (operands[0], E_RFmode)
          || !general_operand (operands[1], E_RFmode)
          || !
#line 1103 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 902; /* *p *movrf_internal */

    case E_V8QImode:
      if (!destination_operand (operands[0], E_V8QImode)
          || !move_operand (operands[1], E_V8QImode)
          || !
#line 48 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 1124; /* *p *movv8qi_internal */

    case E_V4HImode:
      if (!destination_operand (operands[0], E_V4HImode)
          || !move_operand (operands[1], E_V4HImode)
          || !
#line 48 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 1125; /* *p *movv4hi_internal */

    case E_V2SImode:
      if (!destination_operand (operands[0], E_V2SImode)
          || !move_operand (operands[1], E_V2SImode)
          || !
#line 48 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 1126; /* *p *movv2si_internal */

    case E_V2SFmode:
      if (!destination_operand (operands[0], E_V2SFmode)
          || !move_operand (operands[1], E_V2SFmode)
          || !
#line 1086 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(ia64_move_ok (operands[0], operands[1])))
        return -1;
      return 1202; /* *p *movv2sf_internal */

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!gr_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !gr_register_operand (operands[1], E_SImode))
            return -1;
          return 976; /* *p negsi2 */

        case E_DImode:
          if (!gr_register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !gr_register_operand (operands[1], E_DImode))
            return -1;
          return 987; /* *p negdi2 */

        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x4) != E_SFmode
              || !fr_reg_or_fp01_operand (operands[1], E_SFmode))
            return -1;
          return 1000; /* *p negsf2 */

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x4) != E_DFmode
              || !fr_reg_or_fp01_operand (operands[1], E_DFmode))
            return -1;
          return 1017; /* *p negdf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x4) != E_XFmode
              || !xfreg_or_fp01_operand (operands[1], E_XFmode))
            return -1;
          return 1041; /* *p negxf2 */

        case E_V8QImode:
          if (!gr_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x4) != E_V8QImode
              || !gr_register_operand (operands[1], E_V8QImode))
            return -1;
          return 1142; /* *p negv8qi2 */

        case E_V4HImode:
          if (!gr_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x4) != E_V4HImode
              || !gr_register_operand (operands[1], E_V4HImode))
            return -1;
          return 1143; /* *p negv4hi2 */

        case E_V2SImode:
          if (!gr_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x4) != E_V2SImode
              || !gr_register_operand (operands[1], E_V2SImode))
            return -1;
          return 1144; /* *p negv2si2 */

        case E_V2SFmode:
          if (!fr_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x4) != E_V2SFmode
              || !fr_register_operand (operands[1], E_V2SFmode))
            return -1;
          return 1204; /* *p negv2sf2 */

        default:
          return -1;
        }

    case ABS:
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern93 (x4, 
E_SFmode) != 0)
            return -1;
          return 1001; /* *p *nabssf2 */

        case E_DFmode:
          if (pattern93 (x4, 
E_DFmode) != 0)
            return -1;
          return 1018; /* *p *nabsdf2 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x4) != E_XFmode
              || GET_MODE (x5) != E_XFmode
              || !xfreg_or_fp01_operand (operands[1], E_XFmode))
            return -1;
          return 1042; /* *p *nabsxf2 */

        case E_V2SFmode:
          if (pattern94 (x4) != 0)
            return -1;
          return 1205; /* *p *negabsv2sf2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 29)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x9 = XVECEXP (x5, 0, 0);
      operands[1] = x9;
      x10 = XVECEXP (x5, 0, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern126 (x4, 
E_SFmode) != 0)
            return -1;
          return 1003; /* *p *ncopysignsf3 */

        case E_DFmode:
          if (pattern126 (x4, 
E_DFmode) != 0)
            return -1;
          return 1020; /* *p *ncopysigndf3 */

        case E_XFmode:
          if (pattern126 (x4, 
E_XFmode) != 0)
            return -1;
          return 1044; /* *p *ncopysignxf3 */

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x11 = XEXP (x5, 1);
      operands[2] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern110 (x4, 
E_SFmode) != 0)
            return -1;
          return 1006; /* *p *nmulsf3 */

        case E_DFmode:
          if (pattern110 (x4, 
E_DFmode) != 0)
            return -1;
          return 1023; /* *p *nmuldf3 */

        case E_XFmode:
          if (pattern108 (x4, 
E_XFmode) != 0)
            return -1;
          return 1047; /* *p *nmulxf3 */

        case E_V2SFmode:
          if (pattern94 (x4) != 0
              || !fr_register_operand (operands[2], E_V2SFmode))
            return -1;
          return 1209; /* *p *fpnmpy */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      operands[1] = x8;
      x9 = XEXP (x6, 2);
      switch (GET_CODE (x9))
        {
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern127 (x6, 
E_SFmode) != 0)
                return -1;
              return 1007; /* *p fmasf4 */

            case E_DFmode:
              if (pattern127 (x6, 
E_DFmode) != 0)
                return -1;
              return 1025; /* *p fmadf4 */

            case E_XFmode:
              if (pattern127 (x6, 
E_XFmode) != 0)
                return -1;
              return 1050; /* *p fmaxf4 */

            case E_V2SFmode:
              if (!fr_register_operand (operands[0], E_V2SFmode)
                  || GET_MODE (x6) != E_V2SFmode
                  || !fr_register_operand (operands[1], E_V2SFmode)
                  || !fr_register_operand (operands[2], E_V2SFmode)
                  || !fr_register_operand (operands[3], E_V2SFmode))
                return -1;
              return 1207; /* *p fmav2sf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern128 (x6, 
E_SFmode) != 0)
                return -1;
              return 1008; /* *p fmssf4 */

            case E_DFmode:
              if (pattern128 (x6, 
E_DFmode) != 0)
                return -1;
              return 1027; /* *p fmsdf4 */

            case E_XFmode:
              if (pattern128 (x6, 
E_XFmode) != 0)
                return -1;
              return 1053; /* *p fmsxf4 */

            case E_V2SFmode:
              if (pattern42 (x6) != 0
                  || GET_MODE (x9) != E_V2SFmode
                  || !fr_register_operand (operands[3], E_V2SFmode))
                return -1;
              return 1208; /* *p fmsv2sf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      x9 = XEXP (x6, 2);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern118 (x6, 
E_SFmode) != 0)
            return -1;
          return 1009; /* *p fnmasf4 */

        case E_DFmode:
          if (pattern118 (x6, 
E_DFmode) != 0)
            return -1;
          return 1029; /* *p fnmadf4 */

        case E_XFmode:
          if (pattern118 (x6, 
E_XFmode) != 0)
            return -1;
          return 1056; /* *p fnmaxf4 */

        case E_V2SFmode:
          if (pattern94 (x6) != 0
              || !fr_register_operand (operands[2], E_V2SFmode)
              || !fr_register_operand (operands[3], E_V2SFmode))
            return -1;
          return 1210; /* *p fnmav2sf4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_DImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_DImode
      || !gr_register_operand (operands[0], E_DImode))
    return NULL;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!gr_register_operand (operands[1], E_DImode))
    return NULL;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!shladd_operand (operands[2], E_DImode))
    return NULL;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!nonmemory_operand (operands[3], E_DImode))
    return NULL;
  x8 = XEXP (x2, 1);
  operands[4] = x8;
  if (!nonmemory_operand (operands[4], E_DImode)
      || !
#line 3412 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
    return NULL;
  return gen_split_32 (insn, operands);
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_2 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x5 = XEXP (x2, 0);
              if (GET_CODE (x5) != ZERO_EXTRACT
                  || GET_MODE (x5) != E_DImode)
                return NULL;
              x6 = XEXP (x5, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
                return NULL;
              x7 = XEXP (x5, 2);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x8 = XEXP (x5, 0);
              operands[0] = x8;
              if (!register_operand (operands[0], E_DImode))
                return NULL;
              x9 = XEXP (x3, 0);
              operands[2] = x9;
              if (!register_operand (operands[2], E_DImode))
                return NULL;
              return gen_split_11 (insn, operands);

            case NOT:
              if (GET_MODE (x4) != E_BImode)
                return NULL;
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              if (!register_operand (operands[0], E_BImode))
                return NULL;
              x10 = XEXP (x4, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_BImode))
                return NULL;
              x9 = XEXP (x3, 0);
              operands[2] = x9;
              if (!scratch_operand (operands[2], E_BImode))
                return NULL;
              if (
#line 1650 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && rtx_equal_p (operands[0], operands[1])))
                return gen_split_16 (insn, operands);
              if (!
#line 1665 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && PR_REGNO_P (REGNO (operands[1]))
   && ! rtx_equal_p (operands[0], operands[1])))
                return NULL;
              return gen_split_17 (insn, operands);

            case PLUS:
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              x10 = XEXP (x4, 0);
              switch (GET_CODE (x10))
                {
                case PLUS:
                  if (GET_MODE (x10) != E_DImode)
                    return NULL;
                  x11 = XEXP (x10, 0);
                  if (GET_CODE (x11) != MULT
                      || GET_MODE (x11) != E_DImode
                      || pattern86 (x4) != 0
                      || !gr_reg_or_14bit_operand (operands[4], E_DImode))
                    return NULL;
                  x9 = XEXP (x3, 0);
                  operands[5] = x9;
                  if (!scratch_operand (operands[5], E_DImode)
                      || !
#line 2332 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                    return NULL;
                  return gen_split_22 (insn, operands);

                case REG:
                case SUBREG:
                  operands[1] = x10;
                  if (!register_operand (operands[1], E_TImode)
                      || !register_operand (operands[0], E_TImode)
                      || GET_MODE (x4) != E_TImode)
                    return NULL;
                  x12 = XEXP (x4, 1);
                  operands[2] = x12;
                  x9 = XEXP (x3, 0);
                  operands[3] = x9;
                  if (!scratch_operand (operands[3], E_BImode))
                    return NULL;
                  switch (GET_CODE (operands[2]))
                    {
                    case REG:
                    case SUBREG:
                      if (!register_operand (operands[2], E_TImode)
                          || !
#line 2514 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                        return NULL;
                      return gen_split_23 (insn, operands);

                    case CONST_INT:
                    case CONST_WIDE_INT:
                    case CONST_POLY_INT:
                    case CONST_FIXED:
                    case CONST_DOUBLE:
                    case CONST_VECTOR:
                    case CONST:
                    case LABEL_REF:
                    case SYMBOL_REF:
                    case HIGH:
                      if (!immediate_operand (operands[2], E_TImode)
                          || !
#line 2537 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                        return NULL;
                      return gen_split_24 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case MINUS:
              if (GET_MODE (x4) != E_TImode)
                return NULL;
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              if (!register_operand (operands[0], E_TImode))
                return NULL;
              x10 = XEXP (x4, 0);
              operands[1] = x10;
              x12 = XEXP (x4, 1);
              operands[2] = x12;
              if (!register_operand (operands[2], E_TImode))
                return NULL;
              x9 = XEXP (x3, 0);
              operands[3] = x9;
              if (!scratch_operand (operands[3], E_BImode))
                return NULL;
              switch (GET_CODE (operands[1]))
                {
                case REG:
                case SUBREG:
                  if (!register_operand (operands[1], E_TImode)
                      || !
#line 2569 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                    return NULL;
                  return gen_split_25 (insn, operands);

                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  if (!immediate_operand (operands[1], E_TImode)
                      || !
#line 2591 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed && satisfies_constraint_K (operands[1])))
                    return NULL;
                  return gen_split_26 (insn, operands);

                default:
                  return NULL;
                }

            case NEG:
              if (GET_MODE (x4) != E_TImode)
                return NULL;
              x5 = XEXP (x2, 0);
              operands[0] = x5;
              if (!gr_register_operand (operands[0], E_TImode))
                return NULL;
              x10 = XEXP (x4, 0);
              operands[1] = x10;
              if (!gr_register_operand (operands[1], E_TImode))
                return NULL;
              x9 = XEXP (x3, 0);
              operands[2] = x9;
              if (!scratch_operand (operands[2], E_BImode)
                  || !
#line 2673 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_29 (insn, operands);

            default:
              return NULL;
            }

        case 4:
          switch (pattern11 (x1))
            {
            case 0:
              x2 = XVECEXP (x1, 0, 0);
              x5 = XEXP (x2, 0);
              if (GET_CODE (x5) != MEM)
                return NULL;
              x4 = XEXP (x2, 1);
              if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x8 = XEXP (x5, 0);
              operands[0] = x8;
              if (!call_operand (operands[0], E_VOIDmode))
                return NULL;
              x3 = XVECEXP (x1, 0, 1);
              x9 = XEXP (x3, 0);
              operands[1] = x9;
              x13 = XVECEXP (x1, 0, 2);
              x14 = XEXP (x13, 0);
              operands[2] = x14;
              x15 = XVECEXP (x1, 0, 3);
              x16 = XEXP (x15, 0);
              operands[3] = x16;
              if (
#line 4450 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_46 (insn, operands);
              if (!
#line 4464 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_47 (insn, operands);

            case 1:
              if (pattern77 (x1) != 0)
                return NULL;
              if (
#line 4490 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_48 (insn, operands);
              if (!
#line 4505 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_49 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != CALL
              || pattern12 (x1) != 0
              || !
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_50 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return NULL;
      switch (XINT (x1, 1))
        {
        case 8:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 5084 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_51 (insn, operands);

        case 7:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!
#line 5095 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_52 (insn, operands);

        default:
          return NULL;
        }

    case COND_EXEC:
      x17 = XEXP (x1, 0);
      if (!predicate_operator (x17, E_VOIDmode))
        return NULL;
      x18 = XEXP (x17, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x19 = XEXP (x17, 0);
      if (!register_operand (x19, E_BImode))
        return NULL;
      x20 = XEXP (x1, 1);
      switch (GET_CODE (x20))
        {
        case SET:
          x21 = XEXP (x20, 0);
          operands[0] = x21;
          x22 = XEXP (x20, 1);
          switch (GET_CODE (x22))
            {
            case UNSPEC:
              switch (XVECLEN (x22, 0))
                {
                case 1:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x22) != E_DImode)
                    return NULL;
                  switch (XINT (x22, 1))
                    {
                    case 25:
                      x23 = XVECEXP (x22, 0, 0);
                      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                        return NULL;
                      operands[1] = x17;
                      operands[2] = x19;
                      if (!
#line 760 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                        return NULL;
                      return gen_split_63 (insn, operands);

                    case 5:
                      operands[2] = x17;
                      operands[3] = x19;
                      x23 = XVECEXP (x22, 0, 0);
                      operands[1] = x23;
                      if (!tls_symbolic_operand (operands[1], E_VOIDmode)
                          || !
#line 800 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                        return NULL;
                      return gen_split_64 (insn, operands);

                    case 2:
                      operands[2] = x17;
                      operands[3] = x19;
                      x23 = XVECEXP (x22, 0, 0);
                      operands[1] = x23;
                      if (!tls_symbolic_operand (operands[1], E_VOIDmode)
                          || !
#line 848 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                        return NULL;
                      return gen_split_65 (insn, operands);

                    case 4:
                      operands[2] = x17;
                      operands[3] = x19;
                      x23 = XVECEXP (x22, 0, 0);
                      operands[1] = x23;
                      if (!ie_tls_symbolic_operand (operands[1], E_VOIDmode)
                          || !
#line 922 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                        return NULL;
                      return gen_split_66 (insn, operands);

                    default:
                      return NULL;
                    }

                case 2:
                  if (XINT (x22, 1) != 30
                      || GET_MODE (x22) != E_SFmode)
                    return NULL;
                  x24 = XVECEXP (x22, 0, 1);
                  if (GET_CODE (x24) != CONST_INT)
                    return NULL;
                  operands[2] = x17;
                  operands[3] = x19;
                  x23 = XVECEXP (x22, 0, 0);
                  operands[1] = x23;
                  switch (pattern115 (x24))
                    {
                    case 0:
                      if (nonimmediate_operand (operands[0], E_SFmode)
                          && 
#line 1425 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(reload_completed))
                        return gen_split_87 (insn, operands);
                      if (!register_operand (operands[0], E_SFmode)
                          || !
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(reload_completed))
                        return NULL;
                      return gen_split_88 (insn, operands);

                    case 1:
                      if ((
#line 1460 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(!TARGET_BIG_ENDIAN) && 
#line 1462 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
( reload_completed)))
                        return gen_split_89 (insn, operands);
                      if (!(
#line 1476 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(TARGET_BIG_ENDIAN) && 
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
( reload_completed)))
                        return NULL;
                      return gen_split_90 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case HIGH:
              operands[1] = x22;
              if (!general_operand (operands[1], E_TImode))
                return NULL;
              operands[2] = x17;
              operands[3] = x19;
              if (!destination_operand (operands[0], E_TImode)
                  || !
#line 992 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed && !ia64_load_pair_ok(operands[0], operands[1])))
                return NULL;
              return gen_split_67 (insn, operands);

            case AND:
              switch (pattern51 (x1))
                {
                case 0:
                  if (!
#line 1572 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[2]) == REG && PR_REGNO_P (REGNO (operands[2]))))
                    return NULL;
                  return gen_split_68 (insn, operands);

                case 1:
                  if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && PR_REGNO_P (REGNO (operands[1]))))
                    return NULL;
                  return gen_split_69 (insn, operands);

                default:
                  return NULL;
                }

            case IOR:
              switch (pattern51 (x1))
                {
                case 0:
                  if (!
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[2]) == REG && PR_REGNO_P (REGNO (operands[2]))))
                    return NULL;
                  return gen_split_70 (insn, operands);

                case 1:
                  if (!
#line 1625 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && PR_REGNO_P (REGNO (operands[1]))))
                    return NULL;
                  return gen_split_71 (insn, operands);

                default:
                  return NULL;
                }

            case MULT:
              if (GET_MODE (x22) != E_TImode)
                return NULL;
              operands[3] = x17;
              operands[4] = x19;
              if (!fr_register_operand (operands[0], E_TImode))
                return NULL;
              x25 = XEXP (x22, 0);
              if (GET_MODE (x25) != E_TImode)
                return NULL;
              x26 = XEXP (x22, 1);
              if (GET_MODE (x26) != E_TImode)
                return NULL;
              switch (GET_CODE (x25))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x26) != SIGN_EXTEND)
                    return NULL;
                  x27 = XEXP (x25, 0);
                  operands[1] = x27;
                  if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
                    return NULL;
                  x28 = XEXP (x26, 0);
                  operands[2] = x28;
                  if (!fr_reg_or_fp01_operand (operands[2], E_DImode)
                      || !
#line 2624 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                    return NULL;
                  return gen_split_72 (insn, operands);

                case ZERO_EXTEND:
                  if (GET_CODE (x26) != ZERO_EXTEND)
                    return NULL;
                  x27 = XEXP (x25, 0);
                  operands[1] = x27;
                  if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
                    return NULL;
                  x28 = XEXP (x26, 0);
                  operands[2] = x28;
                  if (!fr_reg_or_fp01_operand (operands[2], E_DImode)
                      || !
#line 2654 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                    return NULL;
                  return gen_split_73 (insn, operands);

                default:
                  return NULL;
                }

            case ROTATERT:
              if (GET_MODE (x22) != E_SImode)
                return NULL;
              operands[3] = x17;
              operands[4] = x19;
              if (!gr_register_operand (operands[0], E_SImode))
                return NULL;
              x25 = XEXP (x22, 0);
              operands[1] = x25;
              if (!gr_register_operand (operands[1], E_SImode))
                return NULL;
              x26 = XEXP (x22, 1);
              operands[2] = x26;
              if (!gr_reg_or_5bit_operand (operands[2], E_DImode)
                  || !
#line 3327 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_75 (insn, operands);

            case ROTATE:
              operands[3] = x17;
              operands[4] = x19;
              x25 = XEXP (x22, 0);
              operands[1] = x25;
              x26 = XEXP (x22, 1);
              operands[2] = x26;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern97 (x22) != 0
                      || !
#line 3356 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed && INTVAL (operands[2]) != 16))
                    return NULL;
                  return gen_split_76 (insn, operands);

                case E_TImode:
                  if (pattern95 (x22) != 0
                      || !
#line 3631 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                    return NULL;
                  return gen_split_81 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (GET_MODE (x22) != E_DImode)
                return NULL;
              x25 = XEXP (x22, 0);
              if (GET_CODE (x25) != PLUS
                  || GET_MODE (x25) != E_DImode)
                return NULL;
              x27 = XEXP (x25, 0);
              if (GET_CODE (x27) != MULT
                  || GET_MODE (x27) != E_DImode)
                return NULL;
              operands[5] = x17;
              operands[6] = x19;
              if (!gr_register_operand (operands[0], E_DImode)
                  || pattern123 (x22) != 0
                  || !
#line 3412 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_77 (insn, operands);

            case ASHIFT:
              if (pattern52 (x1) != 0
                  || !
#line 3502 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_78 (insn, operands);

            case ASHIFTRT:
              if (pattern52 (x1) != 0
                  || !
#line 3545 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_79 (insn, operands);

            case LSHIFTRT:
              if (pattern52 (x1) != 0
                  || !
#line 3588 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_80 (insn, operands);

            case NE:
              if (pattern53 (x1) != 0
                  || !
#line 4054 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_82 (insn, operands);

            case EQ:
              if (pattern53 (x1) != 0
                  || !
#line 4068 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_83 (insn, operands);

            default:
              return NULL;
            }

        case PARALLEL:
          operands[3] = x17;
          operands[4] = x19;
          switch (XVECLEN (x20, 0))
            {
            case 2:
              x29 = XVECEXP (x20, 0, 0);
              if (GET_CODE (x29) != SET)
                return NULL;
              x30 = XEXP (x29, 1);
              if (GET_CODE (x30) != NEG
                  || GET_MODE (x30) != E_TImode)
                return NULL;
              x31 = XVECEXP (x20, 0, 1);
              if (GET_CODE (x31) != CLOBBER)
                return NULL;
              x32 = XEXP (x29, 0);
              operands[0] = x32;
              if (!gr_register_operand (operands[0], E_TImode))
                return NULL;
              x33 = XEXP (x30, 0);
              operands[1] = x33;
              if (!gr_register_operand (operands[1], E_TImode))
                return NULL;
              x34 = XEXP (x31, 0);
              operands[2] = x34;
              if (!scratch_operand (operands[2], E_BImode)
                  || !
#line 2673 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_74 (insn, operands);

            case 3:
              if (pattern35 (x20) != 0)
                return NULL;
              x29 = XVECEXP (x20, 0, 0);
              x32 = XEXP (x29, 0);
              x35 = XEXP (x32, 0);
              operands[0] = x35;
              if (!call_operand (operands[0], E_DImode))
                return NULL;
              x31 = XVECEXP (x20, 0, 1);
              x34 = XEXP (x31, 0);
              operands[1] = x34;
              if (!scratch_operand (operands[1], E_DImode))
                return NULL;
              x36 = XVECEXP (x20, 0, 2);
              x37 = XEXP (x36, 0);
              operands[2] = x37;
              if (!scratch_operand (operands[2], E_DImode)
                  || !
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_84 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x20, 0) != 1)
            return NULL;
          switch (XINT (x20, 1))
            {
            case 8:
              x29 = XVECEXP (x20, 0, 0);
              if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              operands[0] = x17;
              operands[1] = x19;
              if (!
#line 5084 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_85 (insn, operands);

            case 7:
              operands[1] = x17;
              operands[2] = x19;
              x29 = XVECEXP (x20, 0, 0);
              operands[0] = x29;
              if (!
#line 5095 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_86 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
