/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern2 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern3 (x3) != 0)
        return -1;
      return 1;

    case E_XFmode:
      if (pattern4 (x3) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern5 (x3, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V2SFmode:
      if (pattern6 (x3) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!fr_register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!fr_register_operand (operands[1], E_RFmode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode
      || !gr_register_operand (operands[1], E_TImode)
      || !dshift_count_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case IF_THEN_ELSE:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (!predicate_operator (x3, E_VOIDmode))
        return -1;
      operands[6] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_BImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!gr_register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x2, 2);
      operands[3] = x7;
      if (!gr_register_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x1, 1);
      operands[4] = x8;
      if (!gr_register_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[4] = x2;
      if (!gr_register_operand (operands[4], E_SImode))
        return -1;
      x8 = XEXP (x1, 1);
      if (GET_CODE (x8) != IF_THEN_ELSE
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (!predicate_operator (x9, E_VOIDmode))
        return -1;
      operands[6] = x9;
      x10 = XEXP (x9, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x11 = XEXP (x9, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_BImode))
        return -1;
      x12 = XEXP (x8, 1);
      operands[2] = x12;
      if (!gr_register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x8, 2);
      operands[3] = x13;
      if (!gr_register_operand (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x1, 0);
  operands[3] = x6;
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  x8 = XEXP (x3, 0);
  operands[0] = x8;
  if (!fr_register_operand (operands[0], E_DImode))
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  if (!fr_register_operand (operands[1], E_RFmode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  return 0;
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gr_register_operand (operands[1], i1)
      || !shladd_operand (operands[2], i1)
      || !gr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], E_V2SFmode)
      || GET_MODE (x1) != E_V2SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4SFmode
      || !fr_reg_or_0_operand (operands[1], E_V2SFmode)
      || !fr_reg_or_0_operand (operands[2], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern99 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !gr_reg_or_22bit_operand (operands[2], i1)
      || !gr_reg_or_22bit_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_XFmode
      || !xfreg_or_fp01_operand (operands[1], E_XFmode)
      || !xfreg_or_fp01_operand (operands[2], E_XFmode))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!fr_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      x2 = XEXP (x1, 0);
      switch (GET_MODE (x2))
        {
        case E_DFmode:
          return 0;

        case E_XFmode:
          return 1;

        default:
          return -1;
        }

    case E_DFmode:
      if (!fr_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1)
      || !fr_reg_or_signed_fp01_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || !not_postinc_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !fetchadd_operand (operands[2], i1))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      if (GET_MODE (x3) != E_DImode
          || !gr_register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!gr_register_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      if (shladd_log2_operand (operands[2], E_DImode)
          && 
#line 1490 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_depz_field_mask (operands[3], operands[2]) + INTVAL (operands[2]) == 32))
        return 161; /* *shladdp4_internal */
      if (!const_int_operand (operands[2], E_DImode)
          || !
#line 1499 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(satisfies_constraint_M (operands[2])
   && ia64_depz_field_mask (operands[3], operands[2]) > 0))
        return -1;
      return 162; /* *depz_internal */

    case REG:
    case SUBREG:
      switch (pattern22 (x2))
        {
        case 0:
          return 167; /* andbi3 */

        case 1:
          return 304; /* anddi3 */

        case 2:
          return 386; /* andv8qi3 */

        case 3:
          return 387; /* andv4hi3 */

        case 4:
          return 388; /* andv2si3 */

        default:
          return -1;
        }

    case NOT:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_BImode:
              if (!register_operand (operands[0], E_BImode)
                  || GET_MODE (x2) != E_BImode
                  || GET_MODE (x3) != E_BImode
                  || !register_operand (operands[1], E_BImode)
                  || !register_operand (operands[2], E_BImode))
                return -1;
              return 168; /* *andcmbi3 */

            case E_DImode:
              if (pattern75 (x2, 
E_DImode) != 0)
                return -1;
              return 305; /* *andnot */

            case E_V8QImode:
              if (pattern75 (x2, 
E_V8QImode) != 0)
                return -1;
              return 389; /* *andnotv8qi */

            case E_V4HImode:
              if (pattern75 (x2, 
E_V4HImode) != 0)
                return -1;
              return 390; /* *andnotv4hi */

            case E_V2SImode:
              if (pattern75 (x2, 
E_V2SImode) != 0)
                return -1;
              return 391; /* *andnotv2si */

            default:
              return -1;
            }

        case NE:
        case EQ:
          operands[4] = x4;
          if (!predicate_operator (operands[4], E_BImode)
              || !register_operand (operands[0], E_BImode)
              || GET_MODE (x2) != E_BImode
              || GET_MODE (x3) != E_BImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          if (gr_reg_or_8bit_operand (operands[3], E_SImode)
              && gr_reg_or_0_operand (operands[2], E_SImode))
            {
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (register_operand (operands[1], E_BImode))
                return 174; /* *cmpsi_andnot_0 */
            }
          if (!gr_reg_or_8bit_operand (operands[3], E_DImode)
              || !gr_register_operand (operands[2], E_DImode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          return 178; /* *cmpdi_andnot_0 */

        case GE:
        case GT:
        case LE:
        case LT:
          operands[3] = x4;
          if (!signed_inequality_operator (operands[3], E_BImode))
            return -1;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_BImode)
              || GET_MODE (x2) != E_BImode
              || GET_MODE (x3) != E_BImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (!gr_register_operand (operands[2], E_SImode))
                return -1;
              return 175; /* *cmpsi_andnot_1 */

            case E_DImode:
              if (!gr_register_operand (operands[2], E_DImode))
                return -1;
              return 179; /* *cmpdi_andnot_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
      operands[4] = x3;
      if (predicate_operator (operands[4], E_BImode)
          && register_operand (operands[0], E_BImode)
          && GET_MODE (x2) == E_BImode)
        {
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (gr_reg_or_8bit_operand (operands[3], E_SImode)
              && gr_reg_or_0_operand (operands[2], E_SImode))
            {
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (register_operand (operands[1], E_BImode))
                return 172; /* *cmpsi_and_0 */
            }
          if (gr_reg_or_8bit_operand (operands[3], E_DImode)
              && gr_register_operand (operands[2], E_DImode))
            {
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (register_operand (operands[1], E_BImode))
                return 176; /* *cmpdi_and_0 */
            }
        }
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern33 (x2))
        {
        case 0:
          return 180; /* *tbit_and_0 */

        case 1:
          return 182; /* *tbit_and_2 */

        case 2:
          return 181; /* *tbit_and_1 */

        case 3:
          return 183; /* *tbit_and_3 */

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
      switch (pattern23 (x2))
        {
        case 0:
          return 173; /* *cmpsi_and_1 */

        case 1:
          return 177; /* *cmpdi_and_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern72 (x3, 
E_SFmode) != 0)
                return -1;
              return 236; /* fmasf4 */

            case E_DFmode:
              if (pattern72 (x3, 
E_DFmode) != 0)
                return -1;
              return 254; /* fmadf4 */

            case E_XFmode:
              if (pattern72 (x3, 
E_XFmode) != 0)
                return -1;
              return 279; /* fmaxf4 */

            case E_V2SFmode:
              if (!fr_register_operand (operands[0], E_V2SFmode)
                  || GET_MODE (x3) != E_V2SFmode
                  || !fr_register_operand (operands[1], E_V2SFmode)
                  || !fr_register_operand (operands[2], E_V2SFmode)
                  || !fr_register_operand (operands[3], E_V2SFmode))
                return -1;
              return 463; /* fmav2sf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern73 (x3, 
E_SFmode) != 0)
                return -1;
              return 237; /* fmssf4 */

            case E_DFmode:
              if (pattern73 (x3, 
E_DFmode) != 0)
                return -1;
              return 256; /* fmsdf4 */

            case E_XFmode:
              if (pattern73 (x3, 
E_XFmode) != 0)
                return -1;
              return 282; /* fmsxf4 */

            case E_V2SFmode:
              if (pattern6 (x3) != 0
                  || GET_MODE (x6) != E_V2SFmode
                  || !fr_register_operand (operands[3], E_V2SFmode))
                return -1;
              return 464; /* fmsv2sf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x6 = XEXP (x3, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern59 (x3, 
E_SFmode) != 0)
            return -1;
          return 238; /* fnmasf4 */

        case E_DFmode:
          if (pattern59 (x3, 
E_DFmode) != 0)
            return -1;
          return 258; /* fnmadf4 */

        case E_XFmode:
          if (pattern59 (x3, 
E_XFmode) != 0)
            return -1;
          return 285; /* fnmaxf4 */

        case E_V2SFmode:
          if (pattern28 (x3) != 0
              || !fr_register_operand (operands[2], E_V2SFmode)
              || !fr_register_operand (operands[3], E_V2SFmode))
            return -1;
          return 466; /* fnmav2sf4 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (XWINT (x5, 0) != 64L)
    return -1;
  x6 = XEXP (x1, 0);
  operands[3] = x6;
  x7 = XEXP (x6, 0);
  operands[4] = x7;
  if (!fr_register_operand (operands[0], E_DImode)
      || pattern129 (x3, 
E_TImode, 
E_DImode) != 0)
    return -1;
  x8 = XEXP (x4, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
    return -1;
  x11 = XEXP (x8, 1);
  x12 = XEXP (x11, 0);
  operands[2] = x12;
  if (!fr_reg_or_fp01_operand (operands[2], E_DImode))
    return -1;
  return 986; /* *p umuldi3_highpart */
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case VEC_CONCAT:
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      x10 = XEXP (x6, 1);
      operands[2] = x10;
      switch (XVECLEN (x4, 0))
        {
        case 8:
          x11 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          x12 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x12) != CONST_INT
              || pattern112 (x4) != 0
              || pattern132 (x3, 
E_V8QImode, 
E_V16QImode) != 0)
            return -1;
          switch (XWINT (x11, 0))
            {
            case 0L:
              if (XWINT (x12, 0) != 8L)
                return -1;
              x13 = XVECEXP (x4, 0, 2);
              switch (XWINT (x13, 0))
                {
                case 1L:
                  x14 = XVECEXP (x4, 0, 3);
                  if (XWINT (x14, 0) != 9L)
                    return -1;
                  x15 = XVECEXP (x4, 0, 4);
                  if (XWINT (x15, 0) != 2L)
                    return -1;
                  x16 = XVECEXP (x4, 0, 5);
                  if (XWINT (x16, 0) != 10L)
                    return -1;
                  x17 = XVECEXP (x4, 0, 6);
                  if (XWINT (x17, 0) != 3L)
                    return -1;
                  x18 = XVECEXP (x4, 0, 7);
                  if (XWINT (x18, 0) != 11L)
                    return -1;
                  return 1183; /* *p *vec_interleave_lowv8qi */

                case 2L:
                  x14 = XVECEXP (x4, 0, 3);
                  if (XWINT (x14, 0) != 10L)
                    return -1;
                  x15 = XVECEXP (x4, 0, 4);
                  if (XWINT (x15, 0) != 4L)
                    return -1;
                  x16 = XVECEXP (x4, 0, 5);
                  if (XWINT (x16, 0) != 12L)
                    return -1;
                  x17 = XVECEXP (x4, 0, 6);
                  if (XWINT (x17, 0) != 6L)
                    return -1;
                  x18 = XVECEXP (x4, 0, 7);
                  if (XWINT (x18, 0) != 14L)
                    return -1;
                  return 1185; /* *p *mix1_even */

                default:
                  return -1;
                }

            case 4L:
              if (XWINT (x12, 0) != 12L)
                return -1;
              x13 = XVECEXP (x4, 0, 2);
              if (XWINT (x13, 0) != 5L)
                return -1;
              x14 = XVECEXP (x4, 0, 3);
              if (XWINT (x14, 0) != 13L)
                return -1;
              x15 = XVECEXP (x4, 0, 4);
              if (XWINT (x15, 0) != 6L)
                return -1;
              x16 = XVECEXP (x4, 0, 5);
              if (XWINT (x16, 0) != 14L)
                return -1;
              x17 = XVECEXP (x4, 0, 6);
              if (XWINT (x17, 0) != 7L)
                return -1;
              x18 = XVECEXP (x4, 0, 7);
              if (XWINT (x18, 0) != 15L)
                return -1;
              return 1184; /* *p *vec_interleave_highv8qi */

            case 1L:
              if (XWINT (x12, 0) != 9L)
                return -1;
              x13 = XVECEXP (x4, 0, 2);
              if (XWINT (x13, 0) != 3L)
                return -1;
              x14 = XVECEXP (x4, 0, 3);
              if (XWINT (x14, 0) != 11L)
                return -1;
              x15 = XVECEXP (x4, 0, 4);
              if (XWINT (x15, 0) != 5L)
                return -1;
              x16 = XVECEXP (x4, 0, 5);
              if (XWINT (x16, 0) != 13L)
                return -1;
              x17 = XVECEXP (x4, 0, 6);
              if (XWINT (x17, 0) != 7L)
                return -1;
              x18 = XVECEXP (x4, 0, 7);
              if (XWINT (x18, 0) != 15L)
                return -1;
              return 1186; /* *p *mix1_odd */

            default:
              return -1;
            }

        case 4:
          x11 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          x12 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          x13 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x13) != CONST_INT)
            return -1;
          x14 = XVECEXP (x4, 0, 3);
          if (GET_CODE (x14) != CONST_INT
              || pattern132 (x3, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          switch (XWINT (x11, 0))
            {
            case 0L:
              if (XWINT (x12, 0) != 4L)
                return -1;
              switch (XWINT (x13, 0))
                {
                case 1L:
                  if (XWINT (x14, 0) != 5L)
                    return -1;
                  return 1193; /* *p *vec_interleave_lowv4hi */

                case 2L:
                  if (XWINT (x14, 0) != 6L)
                    return -1;
                  return 1195; /* *p mix2_even */

                default:
                  return -1;
                }

            case 2L:
              if (XWINT (x12, 0) != 6L
                  || XWINT (x13, 0) != 3L
                  || XWINT (x14, 0) != 7L)
                return -1;
              return 1194; /* *p *vec_interleave_highv4hi */

            case 1L:
              if (XWINT (x12, 0) != 5L
                  || XWINT (x13, 0) != 3L
                  || XWINT (x14, 0) != 7L)
                return -1;
              return 1196; /* *p mix2_odd */

            default:
              return -1;
            }

        case 2:
          x11 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          x12 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          switch (XWINT (x11, 0))
            {
            case 0L:
              switch (XWINT (x12, 0))
                {
                case 2L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2SImode:
                      if (pattern132 (x3, 
E_V2SImode, 
E_V4SImode) != 0)
                        return -1;
                      return 1199; /* *p *vec_interleave_lowv2si */

                    case E_V2SFmode:
                      if (pattern133 (x3) != 0)
                        return -1;
                      return 1218; /* *p *vec_interleave_lowv2sf */

                    default:
                      return -1;
                    }

                case 3L:
                  if (pattern133 (x3) != 0)
                    return -1;
                  return 1219; /* *p fmix_lr */

                default:
                  return -1;
                }

            case 1L:
              switch (XWINT (x12, 0))
                {
                case 3L:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V2SImode:
                      if (pattern132 (x3, 
E_V2SImode, 
E_V4SImode) != 0)
                        return -1;
                      return 1200; /* *p *vec_interleave_highv2si */

                    case E_V2SFmode:
                      if (pattern133 (x3) != 0)
                        return -1;
                      return 1217; /* *p *vec_interleave_highv2sf */

                    default:
                      return -1;
                    }

                case 2L:
                  if (pattern133 (x3) != 0)
                    return -1;
                  return 1216; /* *p fswap */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x6;
      switch (XVECLEN (x4, 0))
        {
        case 8:
          x11 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          x12 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x12) == CONST_INT)
            {
              res = recog_27 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[2] = x11;
          if (!mux1_brcst_element (operands[2], E_VOIDmode))
            return -1;
          x7 = XEXP (x1, 0);
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          if (!gr_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !gr_register_operand (operands[1], E_V8QImode)
              || !rtx_equal_p (x12, operands[2]))
            return -1;
          x13 = XVECEXP (x4, 0, 2);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x14 = XVECEXP (x4, 0, 3);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          x15 = XVECEXP (x4, 0, 4);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          x16 = XVECEXP (x4, 0, 5);
          if (!rtx_equal_p (x16, operands[2]))
            return -1;
          x17 = XVECEXP (x4, 0, 6);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XVECEXP (x4, 0, 7);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          return 1191; /* *p *mux1_brcst_v8qi */

        case 4:
          x7 = XEXP (x1, 0);
          operands[6] = x7;
          x8 = XEXP (x7, 0);
          operands[7] = x8;
          if (!gr_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !gr_register_operand (operands[1], E_V4HImode))
            return -1;
          x11 = XVECEXP (x4, 0, 0);
          operands[2] = x11;
          if (!const_int_2bit_operand (operands[2], E_VOIDmode))
            return -1;
          x12 = XVECEXP (x4, 0, 1);
          operands[3] = x12;
          if (!const_int_2bit_operand (operands[3], E_VOIDmode))
            return -1;
          x13 = XVECEXP (x4, 0, 2);
          operands[4] = x13;
          if (!const_int_2bit_operand (operands[4], E_VOIDmode))
            return -1;
          x14 = XVECEXP (x4, 0, 3);
          operands[5] = x14;
          if (!const_int_2bit_operand (operands[5], E_VOIDmode))
            return -1;
          return 1197; /* *p *mux2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_41 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return recog_18 (x1, insn, pnum_clobbers);

        case 4:
          switch (pattern11 (x1))
            {
            case 0:
              x2 = XVECEXP (x1, 0, 0);
              x3 = XEXP (x2, 0);
              if (GET_CODE (x3) != MEM
                  || GET_MODE (x3) != E_DImode)
                return -1;
              x4 = XEXP (x2, 1);
              if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              x5 = XEXP (x3, 0);
              operands[0] = x5;
              if (!call_operand (operands[0], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              x8 = XVECEXP (x1, 0, 2);
              x9 = XEXP (x8, 0);
              operands[2] = x9;
              x10 = XVECEXP (x1, 0, 3);
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              return 332; /* call_gp */

            case 1:
              if (pattern77 (x1) != 0)
                return -1;
              return 333; /* call_value_gp */

            default:
              return -1;
            }

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case CALL:
              if (pattern12 (x1) != 0)
                return -1;
              return 334; /* sibcall_gp */

            case SET:
              x8 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x8) != USE)
                return -1;
              x3 = XEXP (x2, 0);
              operands[0] = x3;
              if (!fr_register_operand (operands[0], E_RFmode))
                return -1;
              x4 = XEXP (x2, 1);
              if (GET_MODE (x4) != E_RFmode)
                return -1;
              x9 = XEXP (x8, 0);
              if (!const_int_operand (x9, E_SImode))
                return -1;
              switch (GET_CODE (x4))
                {
                case IF_THEN_ELSE:
                  x12 = XEXP (x4, 0);
                  if (GET_CODE (x12) != NE
                      || GET_MODE (x12) != E_RFmode)
                    return -1;
                  x13 = XEXP (x12, 1);
                  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != USE)
                    return -1;
                  x14 = XEXP (x12, 0);
                  operands[1] = x14;
                  if (!register_operand (operands[1], E_CCImode))
                    return -1;
                  x15 = XEXP (x4, 1);
                  if (GET_MODE (x15) != E_RFmode)
                    return -1;
                  x16 = XEXP (x4, 2);
                  if (!fr_reg_or_0_operand (x16, E_RFmode))
                    return -1;
                  x7 = XEXP (x6, 0);
                  if (!const_int_operand (x7, E_SImode))
                    return -1;
                  switch (GET_CODE (x15))
                    {
                    case PLUS:
                      switch (pattern134 (x1))
                        {
                        case 0:
                          return 497; /* addrf3_cond */

                        case 1:
                          return 503; /* m2addrf4_cond */

                        case 2:
                          return 501; /* m1addrf4_cond */

                        default:
                          return -1;
                        }

                    case MINUS:
                      switch (pattern134 (x1))
                        {
                        case 0:
                          return 498; /* subrf3_cond */

                        case 1:
                          return 504; /* m2subrf4_cond */

                        case 2:
                          return 502; /* m1subrf4_cond */

                        default:
                          return -1;
                        }

                    case MULT:
                      x17 = XEXP (x15, 0);
                      operands[2] = x17;
                      if (!fr_reg_or_fp01_operand (operands[2], E_RFmode))
                        return -1;
                      x18 = XEXP (x15, 1);
                      operands[3] = x18;
                      if (!fr_reg_or_fp01_operand (operands[3], E_RFmode))
                        return -1;
                      operands[4] = x16;
                      operands[5] = x7;
                      operands[6] = x9;
                      return 499; /* mulrf3_cond */

                    case NEG:
                      x17 = XEXP (x15, 0);
                      if (GET_CODE (x17) != MULT
                          || GET_MODE (x17) != E_RFmode)
                        return -1;
                      x19 = XEXP (x17, 0);
                      operands[2] = x19;
                      if (!fr_reg_or_fp01_operand (operands[2], E_RFmode))
                        return -1;
                      x20 = XEXP (x17, 1);
                      operands[3] = x20;
                      if (!fr_reg_or_fp01_operand (operands[3], E_RFmode))
                        return -1;
                      operands[4] = x16;
                      operands[5] = x7;
                      operands[6] = x9;
                      return 500; /* nmulrf3_cond */

                    default:
                      return -1;
                    }

                case UNSPEC:
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != SET)
                    return -1;
                  x21 = XEXP (x6, 1);
                  if (GET_CODE (x21) != UNSPEC
                      || GET_MODE (x21) != E_CCImode)
                    return -1;
                  x7 = XEXP (x6, 0);
                  if (!register_operand (x7, E_CCImode))
                    return -1;
                  switch (XVECLEN (x4, 0))
                    {
                    case 2:
                      if (pattern113 (x1, 
11, 
2, 
40) != 0)
                        return -1;
                      x22 = XVECEXP (x4, 0, 1);
                      operands[2] = x22;
                      if (!fr_reg_or_fp01_operand (operands[2], E_RFmode))
                        return -1;
                      operands[3] = x7;
                      operands[4] = x9;
                      x23 = XVECEXP (x21, 0, 0);
                      if (!rtx_equal_p (x23, operands[1]))
                        return -1;
                      x24 = XVECEXP (x21, 0, 1);
                      if (!rtx_equal_p (x24, operands[2]))
                        return -1;
                      return 514; /* recip_approx_rf */

                    case 1:
                      if (pattern113 (x1, 
27, 
1, 
41) != 0)
                        return -1;
                      operands[2] = x7;
                      operands[3] = x9;
                      x23 = XVECEXP (x21, 0, 0);
                      if (!rtx_equal_p (x23, operands[1]))
                        return -1;
                      return 515; /* sqrt_approx_rf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != UNSPEC_VOLATILE
              || XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 0
              || GET_MODE (x4) != E_DImode)
            return -1;
          x25 = XVECEXP (x4, 0, 0);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != USE)
            return -1;
          x10 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x10) != USE)
            return -1;
          x26 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x26) != USE)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!const_int_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x27 = XEXP (x26, 0);
          operands[4] = x27;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          return 347; /* alloc */

        default:
          return -1;
        }

    case CALL:
      x28 = XEXP (x1, 0);
      if (GET_CODE (x28) != MEM
          || GET_MODE (x28) != E_DImode)
        return -1;
      x29 = XEXP (x1, 1);
      if (GET_CODE (x29) != CONST_INT)
        return -1;
      x30 = XEXP (x28, 0);
      operands[0] = x30;
      if (!call_operand (operands[0], E_DImode))
        return -1;
      switch (XWINT (x29, 0))
        {
        case 0L:
          return 331; /* sibcall_nogp */

        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 2;
          return 334; /* sibcall_gp */

        default:
          return -1;
        }

    case RETURN:
      if (!
#line 4538 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_direct_return ()))
        return -1;
      return 336; /* return */

    case COND_EXEC:
      return recog_42 (x1, insn, pnum_clobbers);

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 24:
          if (GET_MODE (x1) != E_DImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          return 346; /* prologue_use */

        case 21:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 354; /* flushrs */

        case 22:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], E_VOIDmode))
            return -1;
          return 362; /* bundle_selector */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 4:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          return 353; /* set_bsp */

        case 1:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 363; /* blockage */

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!const_int_operand (operands[0], E_VOIDmode))
            return -1;
          return 364; /* insn_group_barrier */

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 367; /* break_f */

        case 8:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 369; /* nonlocal_goto_receiver */

        case 7:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 370; /* builtin_setjmp_receiver */

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 372; /* safe_across_calls_all */

        case 6:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 373; /* safe_across_calls_normal */

        case 9:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          return 378; /* probe_stack_address */

        default:
          return -1;
        }

    case CONST_INT:
      switch (XWINT (x1, 0))
        {
        case 0L:
          return 355; /* nop */

        case 1L:
          return 356; /* nop_m */

        case 2L:
          return 357; /* nop_i */

        case 3L:
          return 358; /* nop_f */

        case 4L:
          return 359; /* nop_b */

        case 5L:
          return 360; /* nop_x */

        case 6L:
          return 361; /* pre_cycle */

        default:
          return -1;
        }

    case TRAP_IF:
      x29 = XEXP (x1, 1);
      if (!const_int_operand (x29, E_VOIDmode))
        return -1;
      x28 = XEXP (x1, 0);
      switch (GET_CODE (x28))
        {
        case CONST_INT:
          if (XWINT (x28, 0) != 1L)
            return -1;
          operands[0] = x29;
          return 365; /* *trap */

        case NE:
        case EQ:
          operands[0] = x28;
          if (!predicate_operator (operands[0], E_VOIDmode))
            return -1;
          x31 = XEXP (x28, 1);
          if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x30 = XEXP (x28, 0);
          operands[1] = x30;
          if (!register_operand (operands[1], E_BImode))
            return -1;
          operands[2] = x29;
          return 366; /* *conditional_trap */

        default:
          return -1;
        }

    case PREFETCH:
      x28 = XEXP (x1, 0);
      operands[0] = x28;
      if (!address_operand (operands[0], E_DImode))
        return -1;
      x29 = XEXP (x1, 1);
      operands[1] = x29;
      if (!const_int_operand (operands[1], E_DImode))
        return -1;
      x32 = XEXP (x1, 2);
      operands[2] = x32;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      return 368; /* prefetch */

    default:
      return -1;
    }
}
