/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gr_register_operand (operands[1], i1)
      || !gr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  if (!register_operand (x5, E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  if (!scratch_operand (x6, E_DImode))
    return -1;
  x7 = XEXP (x4, 0);
  if (!scratch_operand (x7, E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x8))
    {
    case CALL:
      return 0;

    case SET:
      return 1;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !gr_register_operand (operands[1], E_DImode)
      || !gr_reg_or_6bit_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], E_V2SFmode)
      || GET_MODE (x1) != E_V2SFmode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SFmode
      || !fr_register_operand (operands[1], E_V2SFmode))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!fr_register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_XFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_XFmode))
        return -1;
      return 2;

    case E_RFmode:
      if (!fr_reg_or_fp01_operand (operands[1], E_RFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  if (!register_operand (operands[0], E_BImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_BImode))
    return -1;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_BImode))
        return -1;
      return 0;

    case NOT:
      if (GET_MODE (x7) != E_BImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!grfr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !grfr_register_operand (operands[1], i1)
      || !grfr_reg_or_8bit_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !fr_reg_or_fp01_operand (operands[1], i1)
      || !fr_reg_or_fp01_operand (operands[2], i1)
      || !fr_reg_or_signed_fp01_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CALL)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!call_operand (operands[1], E_DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[3] = x11;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  return 0;
}

int
pattern87 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_TImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_TImode
      || !fr_register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!fr_reg_or_fp01_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !gr_register_operand (operands[1], E_DImode)
      || !shift_count_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gr_register_operand (operands[1], i1)
      || !gr_reg_or_22bit_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  if (!register_operand (operands[0], E_BImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_BImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!gr_register_operand (operands[1], E_DImode))
    return -1;
  x8 = XEXP (x6, 2);
  operands[2] = x8;
  if (!shift_count_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!gr_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!shladd_operand (operands[2], E_DImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!nonmemory_operand (operands[3], E_DImode))
    return -1;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  if (!nonmemory_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      operands[2] = x5;
      if (!fr_reg_or_fp01_operand (operands[2], E_RFmode))
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          operands[3] = x6;
          if (!fr_reg_or_fp01_operand (operands[3], E_RFmode))
            return -1;
          x7 = XEXP (x3, 2);
          operands[4] = x7;
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 0);
          operands[5] = x9;
          x10 = XVECEXP (x1, 0, 2);
          x11 = XEXP (x10, 0);
          operands[6] = x11;
          return 0;

        case MULT:
          if (GET_MODE (x6) != E_RFmode)
            return -1;
          x12 = XEXP (x6, 0);
          operands[3] = x12;
          if (!fr_reg_or_fp01_operand (operands[3], E_RFmode))
            return -1;
          x13 = XEXP (x6, 1);
          operands[4] = x13;
          if (!fr_reg_or_fp01_operand (operands[4], E_RFmode))
            return -1;
          x7 = XEXP (x3, 2);
          operands[5] = x7;
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 0);
          operands[6] = x9;
          x10 = XVECEXP (x1, 0, 2);
          x11 = XEXP (x10, 0);
          operands[7] = x11;
          return 1;

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x5) != E_RFmode)
        return -1;
      x14 = XEXP (x5, 0);
      operands[2] = x14;
      if (!fr_reg_or_fp01_operand (operands[2], E_RFmode))
        return -1;
      x15 = XEXP (x5, 1);
      operands[3] = x15;
      if (!fr_reg_or_fp01_operand (operands[3], E_RFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[4] = x6;
      if (!fr_reg_or_fp01_operand (operands[4], E_RFmode))
        return -1;
      x7 = XEXP (x3, 2);
      operands[5] = x7;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 0);
      operands[6] = x9;
      x10 = XVECEXP (x1, 0, 2);
      x11 = XEXP (x10, 0);
      operands[7] = x11;
      return 2;

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      if (GET_CODE (x3) == NE)
        {
          x5 = XEXP (x3, 0);
          if (GET_CODE (x5) == UNSPEC
              && XVECLEN (x5, 0) == 1)
            {
              switch (XINT (x5, 1))
                {
                case 35:
                  switch (pattern56 (x1))
                    {
                    case 0:
                      if (
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 55; /* movbi_clr */
                      break;

                    case 1:
                      if (
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 56; /* movqi_clr */
                      break;

                    case 2:
                      if (
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 57; /* movhi_clr */
                      break;

                    case 3:
                      if (
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 58; /* movsi_clr */
                      break;

                    case 4:
                      if (
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 59; /* movdi_clr */
                      break;

                    case 5:
                      if (
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 60; /* movsf_clr */
                      break;

                    case 6:
                      if (
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 61; /* movdf_clr */
                      break;

                    case 7:
                      if (
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 62; /* movxf_clr */
                      break;

                    case 8:
                      if (
#line 634 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 63; /* movti_clr */
                      break;

                    case 9:
                      return 73; /* zero_extendqidi2_clr */

                    case 10:
                      return 74; /* zero_extendhidi2_clr */

                    case 11:
                      return 75; /* zero_extendsidi2_clr */

                    default:
                      break;
                    }
                  break;

                case 36:
                  switch (pattern56 (x1))
                    {
                    case 0:
                      if (
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 64; /* movbi_nc */
                      break;

                    case 1:
                      if (
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 65; /* movqi_nc */
                      break;

                    case 2:
                      if (
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 66; /* movhi_nc */
                      break;

                    case 3:
                      if (
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 67; /* movsi_nc */
                      break;

                    case 4:
                      if (
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 68; /* movdi_nc */
                      break;

                    case 5:
                      if (
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 69; /* movsf_nc */
                      break;

                    case 6:
                      if (
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 70; /* movdf_nc */
                      break;

                    case 7:
                      if (
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 71; /* movxf_nc */
                      break;

                    case 8:
                      if (
#line 644 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[1])))
                        return 72; /* movti_nc */
                      break;

                    case 9:
                      return 76; /* zero_extendqidi2_nc */

                    case 10:
                      return 77; /* zero_extendhidi2_nc */

                    case 11:
                      return 78; /* zero_extendsidi2_nc */

                    default:
                      break;
                    }
                  break;

                case 37:
                  switch (pattern57 (x1))
                    {
                    case 0:
                      return 79; /* advanced_load_check_clr_bi */

                    case 1:
                      return 80; /* advanced_load_check_clr_qi */

                    case 2:
                      return 81; /* advanced_load_check_clr_hi */

                    case 3:
                      return 82; /* advanced_load_check_clr_si */

                    case 4:
                      return 83; /* advanced_load_check_clr_di */

                    case 5:
                      return 84; /* advanced_load_check_clr_sf */

                    case 6:
                      return 85; /* advanced_load_check_clr_df */

                    case 7:
                      return 86; /* advanced_load_check_clr_xf */

                    case 8:
                      return 87; /* advanced_load_check_clr_ti */

                    default:
                      break;
                    }
                  break;

                case 38:
                  switch (pattern57 (x1))
                    {
                    case 0:
                      return 88; /* advanced_load_check_nc_bi */

                    case 1:
                      return 89; /* advanced_load_check_nc_qi */

                    case 2:
                      return 90; /* advanced_load_check_nc_hi */

                    case 3:
                      return 91; /* advanced_load_check_nc_si */

                    case 4:
                      return 92; /* advanced_load_check_nc_di */

                    case 5:
                      return 93; /* advanced_load_check_nc_sf */

                    case 6:
                      return 94; /* advanced_load_check_nc_df */

                    case 7:
                      return 95; /* advanced_load_check_nc_xf */

                    case 8:
                      return 96; /* advanced_load_check_nc_ti */

                    default:
                      break;
                    }
                  break;

                case 39:
                  switch (pattern57 (x1))
                    {
                    case 0:
                      return 97; /* speculation_check_bi */

                    case 1:
                      return 98; /* speculation_check_qi */

                    case 2:
                      return 99; /* speculation_check_hi */

                    case 3:
                      return 100; /* speculation_check_si */

                    case 4:
                      return 101; /* speculation_check_di */

                    case 5:
                      return 102; /* speculation_check_sf */

                    case 6:
                      return 103; /* speculation_check_df */

                    case 7:
                      return 104; /* speculation_check_xf */

                    case 8:
                      return 105; /* speculation_check_ti */

                    default:
                      break;
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (!predicate_operator (x3, E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_BImode))
        return -1;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (GET_CODE (x6) == LABEL_REF)
            {
              x7 = XEXP (x2, 2);
              if (GET_CODE (x7) == PC)
                {
                  x8 = XEXP (x1, 0);
                  if (GET_CODE (x8) == PC)
                    {
                      operands[0] = x3;
                      x9 = XEXP (x6, 0);
                      operands[2] = x9;
                      return 318; /* *br_true */
                    }
                }
            }
          operands[2] = x6;
          x8 = XEXP (x1, 0);
          operands[0] = x8;
          operands[4] = x3;
          x7 = XEXP (x2, 2);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern100 (x2, 
E_DImode) != 0
                  || !
#line 4100 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[2])
   && ia64_move_ok (operands[0], operands[3])))
                return -1;
              return 323; /* *cmovdi_internal */

            case E_SImode:
              if (pattern100 (x2, 
E_SImode) != 0
                  || !
#line 4204 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_move_ok (operands[0], operands[2])
   && ia64_move_ok (operands[0], operands[3])))
                return -1;
              return 325; /* *cmovsi_internal */

            default:
              return -1;
            }

        case PC:
          x8 = XEXP (x1, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          x7 = XEXP (x2, 2);
          switch (GET_CODE (x7))
            {
            case LABEL_REF:
              x10 = XEXP (x7, 0);
              operands[2] = x10;
              return 319; /* *br_false */

            case RETURN:
              if (!
#line 4561 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_direct_return ()))
                return -1;
              return 338; /* *return_false */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x1, 0);
          operands[0] = x8;
          operands[4] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!gr_register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || GET_MODE (x6) != E_DImode)
                return -1;
              x9 = XEXP (x6, 0);
              operands[2] = x9;
              if (!gr_reg_or_22bit_operand (operands[2], E_DImode))
                return -1;
              x7 = XEXP (x2, 2);
              operands[3] = x7;
              if (!gr_reg_or_22bit_operand (operands[3], E_DImode))
                return -1;
              return 324; /* *absdi2_internal */

            case E_SImode:
              if (!gr_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x6) != E_SImode)
                return -1;
              x9 = XEXP (x6, 0);
              operands[3] = x9;
              if (!gr_reg_or_22bit_operand (operands[3], E_SImode))
                return -1;
              x7 = XEXP (x2, 2);
              operands[2] = x7;
              if (!gr_reg_or_22bit_operand (operands[2], E_SImode))
                return -1;
              return 326; /* *abssi2_internal */

            default:
              return -1;
            }

        case RETURN:
          x7 = XEXP (x2, 2);
          if (GET_CODE (x7) != PC)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 4549 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(ia64_direct_return ()))
            return -1;
          return 337; /* *return_true */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      if (!fr_register_operand (operands[1], E_V2SFmode))
        return -1;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      if (!fr_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode)
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!fr_reg_or_0_operand (operands[2], E_V2SFmode))
        return -1;
      x7 = XEXP (x2, 2);
      operands[3] = x7;
      if (!fr_reg_or_0_operand (operands[3], E_V2SFmode))
        return -1;
      return 470; /* *fselect */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case LSHIFTRT:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MULT)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x8) != E_TImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != SIGN_EXTEND
              || GET_MODE (x9) != E_TImode
              || XWINT (x7, 0) != 64L)
            return -1;
          x10 = XEXP (x1, 0);
          operands[3] = x10;
          x11 = XEXP (x10, 0);
          operands[4] = x11;
          if (!fr_register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_TImode
              || GET_MODE (x6) != E_TImode)
            return -1;
          x12 = XEXP (x8, 0);
          operands[1] = x12;
          if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
            return -1;
          x13 = XEXP (x9, 0);
          operands[2] = x13;
          if (!fr_reg_or_fp01_operand (operands[2], E_DImode))
            return -1;
          return 985; /* *p smuldi3_highpart */

        case ZERO_EXTEND:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != ZERO_EXTEND)
            return -1;
          if (GET_MODE (x9) == E_TImode)
            {
              res = recog_24 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (GET_MODE (x9) != E_V4SImode)
            return -1;
          x10 = XEXP (x1, 0);
          operands[4] = x10;
          x11 = XEXP (x10, 0);
          operands[5] = x11;
          if (!gr_register_operand (operands[0], E_V4HImode)
              || pattern129 (x4, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          x12 = XEXP (x8, 0);
          operands[1] = x12;
          if (!gr_register_operand (operands[1], E_V4HImode))
            return -1;
          x13 = XEXP (x9, 0);
          operands[2] = x13;
          if (!gr_register_operand (operands[2], E_V4HImode))
            return -1;
          operands[3] = x7;
          if (!pmpyshr_operand (operands[3], E_SImode))
            return -1;
          return 1161; /* *p pmpyshr2_u */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x5) != E_V4SImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MULT
          || GET_MODE (x6) != E_V4SImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != SIGN_EXTEND
          || GET_MODE (x8) != E_V4SImode)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != SIGN_EXTEND
          || GET_MODE (x9) != E_V4SImode)
        return -1;
      x10 = XEXP (x1, 0);
      operands[4] = x10;
      x11 = XEXP (x10, 0);
      operands[5] = x11;
      if (!gr_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x4) != E_V4HImode)
        return -1;
      x12 = XEXP (x8, 0);
      operands[1] = x12;
      if (!gr_register_operand (operands[1], E_V4HImode))
        return -1;
      x13 = XEXP (x9, 0);
      operands[2] = x13;
      if (!gr_register_operand (operands[2], E_V4HImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!pmpyshr_operand (operands[3], E_SImode))
        return -1;
      return 1160; /* *p pmpyshr2 */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_CODE (operands[1]))
    {
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
      if (!symbolic_operand (operands[1], E_DImode))
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 1
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[2] = x7;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode
          || !
#line 735 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
        return -1;
      return 880; /* *p *gprel64_offset */

    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern107 (x4, 
E_SImode) != 0)
            return -1;
          return 972; /* *p subsi3 */

        case E_DImode:
          if (pattern107 (x4, 
E_DImode) != 0)
            return -1;
          return 980; /* *p subdi3 */

        case E_SFmode:
          if (pattern105 (x4, 
E_SFmode) != 0)
            return -1;
          return 997; /* *p subsf3 */

        case E_DFmode:
          if (pattern105 (x4, 
E_DFmode) != 0)
            return -1;
          return 1012; /* *p subdf3 */

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x4) != E_XFmode
              || !xfreg_or_fp01_operand (operands[1], E_XFmode)
              || !xfreg_or_signed_fp01_operand (operands[2], E_XFmode))
            return -1;
          return 1034; /* *p subxf3 */

        case E_V8QImode:
          if (pattern44 (x4, 
E_V8QImode) != 0)
            return -1;
          return 1152; /* *p subv8qi3 */

        case E_V4HImode:
          if (pattern44 (x4, 
E_V4HImode) != 0)
            return -1;
          return 1153; /* *p subv4hi3 */

        case E_V2SImode:
          if (pattern44 (x4, 
E_V2SImode) != 0)
            return -1;
          return 1154; /* *p subv2si3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return NULL;
          switch (XINT (x3, 1))
            {
            case 25:
              x4 = XVECEXP (x3, 0, 0);
              if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 760 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_5 (insn, operands);

            case 5:
              x4 = XVECEXP (x3, 0, 0);
              operands[1] = x4;
              if (!tls_symbolic_operand (operands[1], E_VOIDmode)
                  || !
#line 800 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_6 (insn, operands);

            case 2:
              x4 = XVECEXP (x3, 0, 0);
              operands[1] = x4;
              if (!tls_symbolic_operand (operands[1], E_VOIDmode)
                  || !
#line 848 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_7 (insn, operands);

            case 4:
              x4 = XVECEXP (x3, 0, 0);
              operands[1] = x4;
              if (!ie_tls_symbolic_operand (operands[1], E_VOIDmode)
                  || !
#line 922 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          if (XINT (x3, 1) != 30
              || GET_MODE (x3) != E_SFmode)
            return NULL;
          x5 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x5) != CONST_INT)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (pattern55 (x5))
            {
            case 0:
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && 
#line 1425 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(reload_completed))
                return gen_split_53 (insn, operands);
              if (!register_operand (operands[0], E_SFmode)
                  || !
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(reload_completed))
                return NULL;
              return gen_split_54 (insn, operands);

            case 1:
              if ((
#line 1460 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(!TARGET_BIG_ENDIAN) && 
#line 1462 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
( reload_completed)))
                return gen_split_55 (insn, operands);
              if (!(
#line 1476 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
(TARGET_BIG_ENDIAN) && 
#line 1478 "../../gcc-15.0.1-20250313/gcc/config/ia64/vect.md"
( reload_completed)))
                return NULL;
              return gen_split_56 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_CCImode:
              if (register_operand (operands[0], E_CCImode)
                  && register_operand (operands[1], E_CCImode)
                  && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && GR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && PR_REGNO_P (REGNO (operands[1]))))
                return gen_split_1 (insn, operands);
              break;

            case E_BImode:
              if (register_operand (operands[0], E_BImode)
                  && register_operand (operands[1], E_BImode))
                {
                  if (
#line 282 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && GR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && PR_REGNO_P (REGNO (operands[1]))))
                    return gen_split_2 (insn, operands);
                  if (
#line 294 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && PR_REGNO_P (REGNO (operands[1]))))
                    return gen_split_3 (insn, operands);
                }
              break;

            default:
              break;
            }
          break;

        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          if (symbolic_operand (operands[1], E_VOIDmode)
              && register_operand (operands[0], E_VOIDmode)
              && 
#line 699 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return gen_split_4 (insn, operands);
          break;

        default:
          break;
        }
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!destination_operand (operands[0], E_TImode)
              || !general_operand (operands[1], E_TImode)
              || !
#line 992 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed && !ia64_load_pair_ok(operands[0], operands[1])))
            return NULL;
          return gen_split_9 (insn, operands);

        case E_TFmode:
          if (!destination_operand (operands[0], E_TFmode)
              || !general_operand (operands[1], E_TFmode)
              || !
#line 1128 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_10 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      switch (pattern14 (x3))
        {
        case 0:
          return gen_split_18 (insn, operands);

        case 1:
          return gen_split_20 (insn, operands);

        case 2:
          if (!
#line 4054 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_37 (insn, operands);

        default:
          return NULL;
        }

    case EQ:
      switch (pattern14 (x3))
        {
        case 0:
          return gen_split_19 (insn, operands);

        case 1:
          return gen_split_21 (insn, operands);

        case 2:
          if (!
#line 4068 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_38 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      if (GET_MODE (x3) != E_TImode
          || !fr_register_operand (operands[0], E_TImode))
        return NULL;
      x6 = XEXP (x3, 0);
      if (GET_MODE (x6) != E_TImode)
        return NULL;
      x7 = XEXP (x3, 1);
      if (GET_MODE (x7) != E_TImode)
        return NULL;
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x7) != SIGN_EXTEND)
            return NULL;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
            return NULL;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!fr_reg_or_fp01_operand (operands[2], E_DImode)
              || !
#line 2624 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_27 (insn, operands);

        case ZERO_EXTEND:
          if (GET_CODE (x7) != ZERO_EXTEND)
            return NULL;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!fr_reg_or_fp01_operand (operands[1], E_DImode))
            return NULL;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          if (!fr_reg_or_fp01_operand (operands[2], E_DImode)
              || !
#line 2654 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_28 (insn, operands);

        default:
          return NULL;
        }

    case ROTATERT:
      if (GET_MODE (x3) != E_SImode
          || !gr_register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!gr_register_operand (operands[1], E_SImode))
        return NULL;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!gr_reg_or_5bit_operand (operands[2], E_DImode)
          || !
#line 3327 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
        return NULL;
      return gen_split_30 (insn, operands);

    case ROTATE:
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x3) != 0
              || !
#line 3356 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed && INTVAL (operands[2]) != 16))
            return NULL;
          return gen_split_31 (insn, operands);

        case E_TImode:
          if (pattern29 (x3) != 0
              || !
#line 3631 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_36 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      if (pattern15 (x3) != 0
          || !
#line 3502 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
        return NULL;
      return gen_split_33 (insn, operands);

    case ASHIFTRT:
      if (pattern15 (x3) != 0
          || !
#line 3545 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
        return NULL;
      return gen_split_34 (insn, operands);

    case LSHIFTRT:
      if (pattern15 (x3) != 0
          || !
#line 3588 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
        return NULL;
      return gen_split_35 (insn, operands);

    case IF_THEN_ELSE:
      x6 = XEXP (x3, 0);
      if (!predicate_operator (x6, E_VOIDmode))
        return NULL;
      operands[4] = x6;
      x10 = XEXP (x6, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_BImode))
        return NULL;
      x11 = XEXP (x3, 2);
      operands[3] = x11;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x7;
          if (!not_postinc_move_operand (operands[2], E_VOIDmode)
              || !not_postinc_destination_operand (operands[0], E_VOIDmode)
              || !not_postinc_move_operand (operands[3], E_VOIDmode)
              || !
#line 4113 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_39 (insn, operands);

        case NEG:
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern99 (x3, 
E_DImode) != 0)
                return NULL;
              if (
#line 4162 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed && rtx_equal_p (operands[0], operands[3])))
                return gen_split_40 (insn, operands);
              if (!
#line 4177 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_41 (insn, operands);

            case E_SImode:
              if (pattern99 (x3, 
E_SImode) != 0)
                return NULL;
              if (
#line 4230 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed && rtx_equal_p (operands[0], operands[3])))
                return gen_split_42 (insn, operands);
              if (!
#line 4245 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
                return NULL;
              return gen_split_43 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      switch (GET_CODE (x3))
        {
        case AND:
          switch (pattern19 (x3))
            {
            case 0:
              if (
#line 1572 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[2]) == REG && PR_REGNO_P (REGNO (operands[2]))))
                return gen_split_12 (insn, operands);
              break;

            case 1:
              if (
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && PR_REGNO_P (REGNO (operands[1]))))
                return gen_split_13 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case IOR:
          switch (pattern19 (x3))
            {
            case 0:
              if (
#line 1608 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[2]) == REG && PR_REGNO_P (REGNO (operands[2]))))
                return gen_split_14 (insn, operands);
              break;

            case 1:
              if (
#line 1625 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed
   && GET_CODE (operands[0]) == REG && PR_REGNO_P (REGNO (operands[0]))
   && GET_CODE (operands[1]) == REG && PR_REGNO_P (REGNO (operands[1]))))
                return gen_split_15 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case PLUS:
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[5] = x3;
      if (!condop_operator (operands[5], E_SImode)
          || !gr_register_operand (operands[0], E_SImode))
        return NULL;
      switch (pattern34 (x3))
        {
        case 0:
          if (!
#line 4269 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_44 (insn, operands);

        case 1:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/ia64/ia64.md"
(reload_completed))
            return NULL;
          return gen_split_45 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_EXTEND:
      if (GET_MODE (x3) != E_RFmode
          || !fr_register_operand (operands[0], E_RFmode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (pattern47 ())
        {
        case 0:
          if (!
#line 191 "../../gcc-15.0.1-20250313/gcc/config/ia64/div.md"
(reload_completed))
            return NULL;
          return gen_split_57 (insn, operands);

        case 1:
          if (!
#line 191 "../../gcc-15.0.1-20250313/gcc/config/ia64/div.md"
(reload_completed))
            return NULL;
          return gen_split_58 (insn, operands);

        case 2:
          if (!
#line 191 "../../gcc-15.0.1-20250313/gcc/config/ia64/div.md"
(reload_completed))
            return NULL;
          return gen_split_59 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_TRUNCATE:
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!fr_reg_or_fp01_operand (operands[1], E_RFmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!fr_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/ia64/div.md"
(reload_completed))
            return NULL;
          return gen_split_60 (insn, operands);

        case E_DFmode:
          if (!fr_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/ia64/div.md"
(reload_completed))
            return NULL;
          return gen_split_61 (insn, operands);

        case E_XFmode:
          if (!fr_register_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/ia64/div.md"
(reload_completed))
            return NULL;
          return gen_split_62 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
