/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_vector_same_val_operand (operands[2], i1)
      || !const_uimm3_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_uimm5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern20 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern20 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || pattern26 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          return 0;

        case E_QImode:
          return 1;

        case E_HImode:
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          return 3;

        case E_HImode:
          return 4;

        case E_SImode:
          if (!mem_simple_ldst_operand (operands[1], E_SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !symbolic_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !symbolic_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !const_uimm5_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V2DImode)
          || !const_uimm6_operand (operands[2], E_VOIDmode))
        return -1;
      return 0;

    case E_V8HImode:
      if (pattern68 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern69 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern98 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern97 (x6, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern97 (x6, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern97 (x6, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern97 (x6, 
E_V16QImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern97 (x6, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V8SImode:
      if (pattern97 (x6, 
E_V8SImode) != 0)
        return -1;
      return 5;

    case E_V16HImode:
      if (pattern97 (x6, 
E_V16HImode) != 0)
        return -1;
      return 6;

    case E_V32QImode:
      if (pattern97 (x6, 
E_V32QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !reg_or_0_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8SImode)
      || GET_MODE (x1) != E_V8SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode)
          || !register_operand (operands[2], E_V8SFmode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode)
          || !reg_or_vector_same_simm5_operand (operands[2], E_V8SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_vector_1_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern135 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      x3 = XEXP (x1, 2);
      if (GET_CODE (x3) != PC)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      return pattern147 (); /* [-1, 1] */

    case PC:
      x3 = XEXP (x1, 2);
      if (GET_CODE (x3) != LABEL_REF)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      res = pattern147 ();
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !symbolic_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern165 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern171 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !const_exp_8_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern179 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[4], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i4)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern202 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 2;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 3;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 4;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (pattern80 (x3))
    {
    case 0:
      if (!
#line 2687 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2008; /* lasx_xvmskltz_d */

    case 1:
      if (!
#line 2687 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2009; /* lasx_xvmskltz_w */

    case 2:
      if (!
#line 2687 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2010; /* lasx_xvmskltz_h */

    case 3:
      if (!
#line 2687 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2011; /* lasx_xvmskltz_b */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern50 (x1))
    {
    case 0:
      if (!(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (11 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && 
#line 409 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 200; /* lceilsfsi2 */

    case 1:
      if (!(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (11 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && (
#line 409 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))))
        return -1;
      return 206; /* lceildfsi2 */

    case 2:
      if (!(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (11 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && (
#line 410 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))))
        return -1;
      return 203; /* lceilsfdi2 */

    case 3:
      if (!(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (11 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && 
#line 410 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 209; /* lceildfdi2 */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  switch (pattern136 (x5))
    {
    case 0:
      return 447; /* loongarch_crcc_w_b_w */

    case 1:
      return 449; /* loongarch_crcc_w_h_w */

    case 2:
      return 451; /* loongarch_crcc_w_w_w */

    case 3:
      if (
#line 401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return 453; /* loongarch_crcc_w_d_w */
      break;

    default:
      break;
    }
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern138 (x2))
    {
    case 0:
      if (!
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 463; /* *crc_combine */

    case 1:
      if (!
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 465; /* *crc_combine */

    case 2:
      if (!
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 467; /* *crc_combine */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 1970 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1835; /* lasx_xvsat_s_d */

    case 1:
      if (!
#line 1970 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1836; /* lasx_xvsat_s_w */

    case 2:
      if (!
#line 1970 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1837; /* lasx_xvsat_s_h */

    case 3:
      if (!
#line 1970 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1838; /* lasx_xvsat_s_b */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1096 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1682; /* lasx_xvavgr_s_d */

    case 1:
      if (!
#line 1096 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1683; /* lasx_xvavgr_s_w */

    case 2:
      if (!
#line 1096 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1684; /* lasx_xvavgr_s_h */

    case 3:
      if (!
#line 1096 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1685; /* lasx_xvavgr_s_b */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern67 (x1))
    {
    case 0:
      if (!
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1113; /* lsx_vbitseti_d */

    case 1:
      if (!
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1114; /* lsx_vbitseti_w */

    case 2:
      if (!
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1115; /* lsx_vbitseti_h */

    case 3:
      if (!
#line 1050 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1116; /* lsx_vbitseti_b */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1072; /* lsx_vavg_s_d */

    case 1:
      if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1073; /* lsx_vavg_s_w */

    case 2:
      if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1074; /* lsx_vavg_s_h */

    case 3:
      if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1075; /* lsx_vavg_s_b */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern87 (x1, pnum_clobbers))
    {
    case 0:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
        {
          x5 = XEXP (x3, 2);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
              && register_operand (operands[1], E_FCCmode))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && GET_MODE (x3) == E_SImode
                      && (
#line 2479 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
                    return 164; /* fcc_to_si */
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && GET_MODE (x3) == E_DImode
                      && (
#line 2479 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                    return 165; /* fcc_to_di */
                  break;

                default:
                  break;
                }
            }
        }
      operands[2] = x4;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern189 (x3, 
E_SImode))
            {
            case 0:
              if (!(
#line 2518 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
                return -1;
              return 167; /* *selnesi_using_si */

            case 1:
              if (!(
#line 2518 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 171; /* *selnesi_using_di */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern189 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 2518 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && ((((
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))))
                return -1;
              return 169; /* *selnedi_using_si */

            case 1:
              if (!(
#line 2518 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 173; /* *selnedi_using_di */

            default:
              return -1;
            }

        case E_SFmode:
          if (pattern190 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 174; /* *selsf */

        case E_DFmode:
          if (pattern190 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 175; /* *seldf */

        default:
          return -1;
        }

    case 1:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1289; /* lsx_bnz_d */

    case 2:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1291; /* lsx_bnz_w */

    case 3:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1293; /* lsx_bnz_h */

    case 4:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1295; /* lsx_bnz_b */

    case 5:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1297; /* lsx_bnz_d_f */

    case 6:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1299; /* lsx_bnz_w_f */

    case 7:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1301; /* lsx_bnz_v_d */

    case 8:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1303; /* lsx_bnz_v_w */

    case 9:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1305; /* lsx_bnz_v_h */

    case 10:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1307; /* lsx_bnz_v_b */

    case 11:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1309; /* lsx_bnz_v_d_f */

    case 12:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1311; /* lsx_bnz_v_w_f */

    case 13:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1900; /* lasx_xbnz_d */

    case 14:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1902; /* lasx_xbnz_w */

    case 15:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1904; /* lasx_xbnz_h */

    case 16:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1906; /* lasx_xbnz_b */

    case 17:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1908; /* lasx_xbnz_d_f */

    case 18:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1910; /* lasx_xbnz_w_f */

    case 19:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1912; /* lasx_xbnz_v_d */

    case 20:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1914; /* lasx_xbnz_v_w */

    case 21:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1916; /* lasx_xbnz_v_h */

    case 22:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1918; /* lasx_xbnz_v_b */

    case 23:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1920; /* lasx_xbnz_v_d_f */

    case 24:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1922; /* lasx_xbnz_v_w_f */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      return recog_70 (x1, insn, pnum_clobbers);

    case 2:
      return recog_71 (x1, insn, pnum_clobbers);

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x2, 1))
        {
        case 29:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern159 (x2, 
E_SImode) != 0
                  || !(
#line 2674 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(HAVE_AS_TLS_LE_RELAXATION) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return -1;
              return 190; /* add_tls_le_relaxsi */

            case E_DImode:
              if (pattern159 (x2, 
E_DImode) != 0
                  || !(
#line 2674 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(HAVE_AS_TLS_LE_RELAXATION) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return -1;
              return 191; /* add_tls_le_relaxdi */

            default:
              return -1;
            }

        case 91:
          return recog_69 (x1, insn, pnum_clobbers);

        case 106:
          if (!const_uimm5_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern58 (x2, 
E_V8HImode) != 0
                  || !
#line 2215 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1375; /* lsx_vfrstpi_h */

            case E_V16QImode:
              if (pattern58 (x2, 
E_V16QImode) != 0
                  || !
#line 2215 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1376; /* lsx_vfrstpi_b */

            default:
              return -1;
            }

        case 107:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern160 (x2, 
E_V8HImode) != 0
                  || !
#line 2226 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1377; /* lsx_vfrstp_h */

            case E_V16QImode:
              if (pattern160 (x2, 
E_V16QImode) != 0
                  || !
#line 2226 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1378; /* lsx_vfrstp_b */

            default:
              return -1;
            }

        case 108:
          if (pattern143 (x2, 
E_V2DImode) != 0
              || !
#line 2237 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1379; /* lsx_vshuf4i_d */

        case 111:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1390; /* lsx_vextrins_d */

            case 1:
              if (!
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1391; /* lsx_vextrins_w */

            case 2:
              if (!
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1392; /* lsx_vextrins_h */

            case 3:
              if (!
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1393; /* lsx_vextrins_b */

            default:
              return -1;
            }

        case 132:
          if (pattern145 (x2, 
E_V16QImode) != 0
              || !
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1465; /* lsx_vshuf_b */

        case 143:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3070 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1482; /* lsx_vsrlni_d_q */

            case 1:
              if (!
#line 3070 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1483; /* lsx_vsrlni_w_d */

            case 2:
              if (!
#line 3070 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1484; /* lsx_vsrlni_h_w */

            case 3:
              if (!
#line 3070 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1485; /* lsx_vsrlni_b_h */

            default:
              return -1;
            }

        case 144:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3081 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1486; /* lsx_vsrlrni_d_q */

            case 1:
              if (!
#line 3081 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1487; /* lsx_vsrlrni_w_d */

            case 2:
              if (!
#line 3081 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1488; /* lsx_vsrlrni_h_w */

            case 3:
              if (!
#line 3081 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1489; /* lsx_vsrlrni_b_h */

            default:
              return -1;
            }

        case 145:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3092 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1490; /* lsx_vssrlni_d_q */

            case 1:
              if (!
#line 3092 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1491; /* lsx_vssrlni_w_d */

            case 2:
              if (!
#line 3092 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1492; /* lsx_vssrlni_h_w */

            case 3:
              if (!
#line 3092 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1493; /* lsx_vssrlni_b_h */

            default:
              return -1;
            }

        case 146:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3103 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1494; /* lsx_vssrlni_du_q */

            case 1:
              if (!
#line 3103 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1495; /* lsx_vssrlni_wu_d */

            case 2:
              if (!
#line 3103 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1496; /* lsx_vssrlni_hu_w */

            case 3:
              if (!
#line 3103 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1497; /* lsx_vssrlni_bu_h */

            default:
              return -1;
            }

        case 147:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1498; /* lsx_vssrlrni_d_q */

            case 1:
              if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1499; /* lsx_vssrlrni_w_d */

            case 2:
              if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1500; /* lsx_vssrlrni_h_w */

            case 3:
              if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1501; /* lsx_vssrlrni_b_h */

            default:
              return -1;
            }

        case 148:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3125 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1502; /* lsx_vssrlrni_du_q */

            case 1:
              if (!
#line 3125 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1503; /* lsx_vssrlrni_wu_d */

            case 2:
              if (!
#line 3125 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1504; /* lsx_vssrlrni_hu_w */

            case 3:
              if (!
#line 3125 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1505; /* lsx_vssrlrni_bu_h */

            default:
              return -1;
            }

        case 149:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3136 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1506; /* lsx_vsrani_d_q */

            case 1:
              if (!
#line 3136 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1507; /* lsx_vsrani_w_d */

            case 2:
              if (!
#line 3136 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1508; /* lsx_vsrani_h_w */

            case 3:
              if (!
#line 3136 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1509; /* lsx_vsrani_b_h */

            default:
              return -1;
            }

        case 150:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3147 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1510; /* lsx_vsrarni_d_q */

            case 1:
              if (!
#line 3147 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1511; /* lsx_vsrarni_w_d */

            case 2:
              if (!
#line 3147 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1512; /* lsx_vsrarni_h_w */

            case 3:
              if (!
#line 3147 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1513; /* lsx_vsrarni_b_h */

            default:
              return -1;
            }

        case 151:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3158 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1514; /* lsx_vssrani_d_q */

            case 1:
              if (!
#line 3158 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1515; /* lsx_vssrani_w_d */

            case 2:
              if (!
#line 3158 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1516; /* lsx_vssrani_h_w */

            case 3:
              if (!
#line 3158 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1517; /* lsx_vssrani_b_h */

            default:
              return -1;
            }

        case 152:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3169 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1518; /* lsx_vssrani_du_q */

            case 1:
              if (!
#line 3169 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1519; /* lsx_vssrani_wu_d */

            case 2:
              if (!
#line 3169 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1520; /* lsx_vssrani_hu_w */

            case 3:
              if (!
#line 3169 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1521; /* lsx_vssrani_bu_h */

            default:
              return -1;
            }

        case 153:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1522; /* lsx_vssrarni_d_q */

            case 1:
              if (!
#line 3180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1523; /* lsx_vssrarni_w_d */

            case 2:
              if (!
#line 3180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1524; /* lsx_vssrarni_h_w */

            case 3:
              if (!
#line 3180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1525; /* lsx_vssrarni_b_h */

            default:
              return -1;
            }

        case 154:
          switch (pattern144 (x2))
            {
            case 0:
              if (!
#line 3191 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1526; /* lsx_vssrarni_du_q */

            case 1:
              if (!
#line 3191 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1527; /* lsx_vssrarni_wu_d */

            case 2:
              if (!
#line 3191 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1528; /* lsx_vssrarni_hu_w */

            case 3:
              if (!
#line 3191 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1529; /* lsx_vssrarni_bu_h */

            default:
              return -1;
            }

        case 155:
          if (pattern143 (x2, 
E_V4SImode) != 0
              || !
#line 3202 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1530; /* lsx_vpermi_w */

        case 226:
          return recog_67 (x1, insn, pnum_clobbers);

        case 256:
          return recog_66 (x1, insn, pnum_clobbers);

        case 257:
          switch (GET_MODE (operands[0]))
            {
            case E_V16HImode:
              if (pattern161 (x2, 
E_V16HImode, 
E_HImode) != 0
                  || !const_exp_16_operand (operands[3], E_VOIDmode)
                  || !
#line 591 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1566; /* lasx_xvinsgr2vr_v8hi_internal */

            case E_V32QImode:
              if (pattern161 (x2, 
E_V32QImode, 
E_QImode) != 0
                  || !const_exp_32_operand (operands[3], E_VOIDmode)
                  || !
#line 591 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1567; /* lasx_xvinsgr2vr_v16qi_internal */

            default:
              return -1;
            }

        case 182:
          return recog_68 (x1, insn, pnum_clobbers);

        case 183:
          if (pattern145 (x2, 
E_V32QImode) != 0
              || !
#line 2080 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1870; /* lasx_xvshuf_b */

        case 198:
          if (!const_uimm5_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16HImode:
              if (pattern58 (x2, 
E_V16HImode) != 0
                  || !
#line 2625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1991; /* lasx_xvfrstpi_h */

            case E_V32QImode:
              if (pattern58 (x2, 
E_V32QImode) != 0
                  || !
#line 2625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1992; /* lasx_xvfrstpi_b */

            default:
              return -1;
            }

        case 199:
          switch (GET_MODE (operands[0]))
            {
            case E_V16HImode:
              if (pattern160 (x2, 
E_V16HImode) != 0
                  || !
#line 2636 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1993; /* lasx_xvfrstp_h */

            case E_V32QImode:
              if (pattern160 (x2, 
E_V32QImode) != 0
                  || !
#line 2636 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1994; /* lasx_xvfrstp_b */

            default:
              return -1;
            }

        case 200:
          if (pattern143 (x2, 
E_V4DImode) != 0
              || !
#line 2647 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1995; /* lasx_xvshuf4i_d */

        case 203:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 2678 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2004; /* lasx_xvextrins_d */

            case 1:
              if (!
#line 2678 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2005; /* lasx_xvextrins_w */

            case 2:
              if (!
#line 2678 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2006; /* lasx_xvextrins_h */

            case 3:
              if (!
#line 2678 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2007; /* lasx_xvextrins_b */

            default:
              return -1;
            }

        case 236:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3249 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2080; /* lasx_xvsrlni_d_q */

            case 1:
              if (!
#line 3249 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2081; /* lasx_xvsrlni_w_d */

            case 2:
              if (!
#line 3249 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2082; /* lasx_xvsrlni_h_w */

            case 3:
              if (!
#line 3249 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2083; /* lasx_xvsrlni_b_h */

            default:
              return -1;
            }

        case 237:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3260 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2084; /* lasx_xvsrlrni_d_q */

            case 1:
              if (!
#line 3260 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2085; /* lasx_xvsrlrni_w_d */

            case 2:
              if (!
#line 3260 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2086; /* lasx_xvsrlrni_h_w */

            case 3:
              if (!
#line 3260 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2087; /* lasx_xvsrlrni_b_h */

            default:
              return -1;
            }

        case 238:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3271 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2088; /* lasx_xvssrlni_d_q */

            case 1:
              if (!
#line 3271 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2089; /* lasx_xvssrlni_w_d */

            case 2:
              if (!
#line 3271 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2090; /* lasx_xvssrlni_h_w */

            case 3:
              if (!
#line 3271 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2091; /* lasx_xvssrlni_b_h */

            default:
              return -1;
            }

        case 239:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3282 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2092; /* lasx_xvssrlni_du_q */

            case 1:
              if (!
#line 3282 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2093; /* lasx_xvssrlni_wu_d */

            case 2:
              if (!
#line 3282 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2094; /* lasx_xvssrlni_hu_w */

            case 3:
              if (!
#line 3282 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2095; /* lasx_xvssrlni_bu_h */

            default:
              return -1;
            }

        case 240:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3293 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2096; /* lasx_xvssrlrni_d_q */

            case 1:
              if (!
#line 3293 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2097; /* lasx_xvssrlrni_w_d */

            case 2:
              if (!
#line 3293 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2098; /* lasx_xvssrlrni_h_w */

            case 3:
              if (!
#line 3293 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2099; /* lasx_xvssrlrni_b_h */

            default:
              return -1;
            }

        case 241:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3304 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2100; /* lasx_xvssrlrni_du_q */

            case 1:
              if (!
#line 3304 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2101; /* lasx_xvssrlrni_wu_d */

            case 2:
              if (!
#line 3304 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2102; /* lasx_xvssrlrni_hu_w */

            case 3:
              if (!
#line 3304 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2103; /* lasx_xvssrlrni_bu_h */

            default:
              return -1;
            }

        case 242:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3315 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2104; /* lasx_xvsrani_d_q */

            case 1:
              if (!
#line 3315 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2105; /* lasx_xvsrani_w_d */

            case 2:
              if (!
#line 3315 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2106; /* lasx_xvsrani_h_w */

            case 3:
              if (!
#line 3315 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2107; /* lasx_xvsrani_b_h */

            default:
              return -1;
            }

        case 243:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3326 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2108; /* lasx_xvsrarni_d_q */

            case 1:
              if (!
#line 3326 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2109; /* lasx_xvsrarni_w_d */

            case 2:
              if (!
#line 3326 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2110; /* lasx_xvsrarni_h_w */

            case 3:
              if (!
#line 3326 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2111; /* lasx_xvsrarni_b_h */

            default:
              return -1;
            }

        case 244:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3337 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2112; /* lasx_xvssrani_d_q */

            case 1:
              if (!
#line 3337 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2113; /* lasx_xvssrani_w_d */

            case 2:
              if (!
#line 3337 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2114; /* lasx_xvssrani_h_w */

            case 3:
              if (!
#line 3337 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2115; /* lasx_xvssrani_b_h */

            default:
              return -1;
            }

        case 245:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3348 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2116; /* lasx_xvssrani_du_q */

            case 1:
              if (!
#line 3348 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2117; /* lasx_xvssrani_wu_d */

            case 2:
              if (!
#line 3348 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2118; /* lasx_xvssrani_hu_w */

            case 3:
              if (!
#line 3348 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2119; /* lasx_xvssrani_bu_h */

            default:
              return -1;
            }

        case 246:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3359 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2120; /* lasx_xvssrarni_d_q */

            case 1:
              if (!
#line 3359 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2121; /* lasx_xvssrarni_w_d */

            case 2:
              if (!
#line 3359 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2122; /* lasx_xvssrarni_h_w */

            case 3:
              if (!
#line 3359 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2123; /* lasx_xvssrarni_b_h */

            default:
              return -1;
            }

        case 247:
          switch (pattern146 (x2))
            {
            case 0:
              if (!
#line 3370 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2124; /* lasx_xvssrarni_du_q */

            case 1:
              if (!
#line 3370 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2125; /* lasx_xvssrarni_wu_d */

            case 2:
              if (!
#line 3370 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2126; /* lasx_xvssrarni_hu_w */

            case 3:
              if (!
#line 3370 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2127; /* lasx_xvssrarni_bu_h */

            default:
              return -1;
            }

        case 248:
          if (!const_uimm8_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8SImode:
              if (pattern58 (x2, 
E_V8SImode) != 0
                  || !
#line 3385 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2128; /* lasx_xvpermi_w */

            case E_V8SFmode:
              if (pattern58 (x2, 
E_V8SFmode) != 0
                  || !
#line 3385 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2129; /* lasx_xvpermi_w_f */

            default:
              return -1;
            }

        case 249:
          switch (GET_MODE (operands[0]))
            {
            case E_V4DImode:
              if (pattern162 (x2, 
E_V4DImode) != 0
                  || !
#line 3492 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2142; /* lasx_xvinsve0_d */

            case E_V4DFmode:
              if (pattern162 (x2, 
E_V4DFmode) != 0
                  || !
#line 3492 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2143; /* lasx_xvinsve0_d_f */

            case E_V8SImode:
              if (pattern163 (x2, 
E_V8SImode) != 0
                  || !
#line 3492 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2144; /* lasx_xvinsve0_w */

            case E_V8SFmode:
              if (pattern163 (x2, 
E_V8SFmode) != 0
                  || !
#line 3492 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2145; /* lasx_xvinsve0_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern5 (x3))
        {
        case 0:
          return 251; /* *rotrsi3 */

        case 1:
          if (!
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 252; /* *rotrdi3 */

        case 2:
          if (register_operand (operands[2], E_V2DImode)
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 619; /* vrotrv2di3 */
          if (!const_uimm6_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 630; /* rotrv2di3 */

        case 3:
          if (register_operand (operands[2], E_V4SImode)
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 620; /* vrotrv4si3 */
          if (!const_uimm5_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 634; /* rotrv4si3 */

        case 4:
          if (register_operand (operands[2], E_V8HImode)
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 621; /* vrotrv8hi3 */
          if (!const_uimm4_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 638; /* rotrv8hi3 */

        case 5:
          if (register_operand (operands[2], E_V16QImode)
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 622; /* vrotrv16qi3 */
          if (!const_uimm3_operand (operands[2], E_SImode)
              || !
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 642; /* rotrv16qi3 */

        case 6:
          if (register_operand (operands[2], E_V4DImode)
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 623; /* vrotrv4di3 */
          if (!const_uimm6_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 646; /* rotrv4di3 */

        case 7:
          if (register_operand (operands[2], E_V8SImode)
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 624; /* vrotrv8si3 */
          if (!const_uimm5_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 650; /* rotrv8si3 */

        case 8:
          if (register_operand (operands[2], E_V16HImode)
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 625; /* vrotrv16hi3 */
          if (!const_uimm4_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 654; /* rotrv16hi3 */

        case 9:
          if (register_operand (operands[2], E_V32QImode)
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 626; /* vrotrv32qi3 */
          if (!const_uimm3_operand (operands[2], E_SImode)
              || !(
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 658; /* rotrv32qi3 */

        default:
          return -1;
        }

    case BSWAP:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XWINT (x5, 0))
        {
        case 16L:
          if (pattern111 (x3, 
E_SImode) != 0)
            return -1;
          return 269; /* revb_2h */

        case 32L:
          if (pattern111 (x3, 
E_DImode) != 0
              || !
#line 3243 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 272; /* revb_2w */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern104 (x3, 
E_DFmode))
            {
            case 0:
              if (!
#line 1909 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 144; /* floatsidf2 */

            case 1:
              if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 145; /* floatdidf2 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern104 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 1927 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 146; /* floatsisf2 */

            case 1:
              if (!
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 147; /* floatdisf2 */

            default:
              return -1;
            }

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1139; /* floatv2div2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1140; /* floatv4siv4sf2 */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || !register_operand (operands[1], E_V4DImode)
              || !
#line 1231 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1743; /* floatv4div4df2 */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || !register_operand (operands[1], E_V8SImode)
              || !
#line 1231 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1744; /* floatv8siv8sf2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern93 (x3, 
E_V4SImode, 
E_V2DFmode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2490 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1420; /* vec_unpacks_float_hi_v4si */

        case 1:
          if (!
#line 2501 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1421; /* vec_unpacks_float_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      switch (pattern105 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 288; /* *sne_zero_sisi */

        case 1:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 289; /* *sne_zero_disi */

        case 2:
          if (!
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 290; /* *sne_zero_didi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern13 (x3))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 318; /* sne_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 332; /* sne_df_using_FCCmode */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 668; /* lsx_vfcmp_cune_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 678; /* lsx_vfcmp_cune_s */

        case 4:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 688; /* lasx_xvfcmp_cune_d */

        case 5:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 698; /* lasx_xvfcmp_cune_s */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case EH_RETURN:
      if (!
#line 3704 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(epilogue_completed))
        return NULL;
      return gen_split_25 (insn, operands);

    case PARALLEL:
    case UNSPEC:
    case UNSPEC_VOLATILE:
    case PREFETCH:
    case SET:
      switch (GET_CODE (x1))
        {
        case SET:
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case PARALLEL:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      operands[0] = x1;
      if (small_data_pattern (operands[0], E_VOIDmode)
          && 
#line 4388 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(reload_completed))
        return gen_split_27 (insn, operands);
      if (GET_CODE (x1) != SET)
        return NULL;
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case UNSPEC:
          if (XVECLEN (x3, 0) != 2)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 0)
            return NULL;
          x5 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != XOR
              || GET_MODE (x6) != E_DImode)
            return NULL;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != SUBREG
              || maybe_ne (SUBREG_BYTE (x7), 0)
              || GET_MODE (x7) != E_DImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return NULL;
          x9 = XEXP (x7, 0);
          operands[2] = x9;
          switch (XINT (x3, 1))
            {
            case 24:
              switch (pattern137 (x4))
                {
                case 0:
                  if (!(
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_28 (insn, operands);

                case 1:
                  if (!(
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_30 (insn, operands);

                case 2:
                  if (!(
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_32 (insn, operands);

                default:
                  return NULL;
                }

            case 25:
              switch (pattern137 (x4))
                {
                case 0:
                  if (!(
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_29 (insn, operands);

                case 1:
                  if (!(
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_31 (insn, operands);

                case 2:
                  if (!(
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()) && 
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return NULL;
                  return gen_split_33 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          switch (pattern101 (x3))
            {
            case 0:
              if (!(
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_38 (insn, operands);

            case 1:
              if (!(
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_40 (insn, operands);

            case 2:
              if (!(
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_42 (insn, operands);

            case 3:
              if (!((
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_44 (insn, operands);

            case 4:
              if (!((
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_46 (insn, operands);

            case 5:
              if (!((
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_48 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          switch (pattern101 (x3))
            {
            case 0:
              if (!(
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_39 (insn, operands);

            case 1:
              if (!(
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_41 (insn, operands);

            case 2:
              if (!(
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_43 (insn, operands);

            case 3:
              if (!((
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_45 (insn, operands);

            case 4:
              if (!((
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_47 (insn, operands);

            case 5:
              if (!((
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4617 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                return NULL;
              return gen_split_49 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          switch (GET_CODE (operands[1]))
            {
            case MEM:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && mem_simple_ldst_operand (operands[1], E_SImode)
                      && (
#line 4600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4604 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_34 (insn, operands);
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && mem_simple_ldst_operand (operands[1], E_DImode)
                      && ((
#line 4600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4604 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_35 (insn, operands);
                  break;

                case E_SFmode:
                  if (register_operand (operands[0], E_SFmode)
                      && mem_simple_ldst_operand (operands[1], E_SFmode)
                      && ((
#line 4600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)) && 
#line 4604 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_36 (insn, operands);
                  break;

                case E_DFmode:
                  if (register_operand (operands[0], E_DFmode)
                      && mem_simple_ldst_operand (operands[1], E_DFmode)
                      && ((
#line 4600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 4604 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_37 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (mem_simple_ldst_operand (operands[0], E_QImode)
                      && reg_or_0_operand (operands[1], E_QImode)
                      && (
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4629 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_50 (insn, operands);
                  break;

                case E_HImode:
                  if (mem_simple_ldst_operand (operands[0], E_HImode)
                      && reg_or_0_operand (operands[1], E_HImode)
                      && (
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4629 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_51 (insn, operands);
                  break;

                case E_SImode:
                  if (mem_simple_ldst_operand (operands[0], E_SImode)
                      && reg_or_0_operand (operands[1], E_SImode)
                      && (
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 4629 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_52 (insn, operands);
                  break;

                case E_DImode:
                  if (mem_simple_ldst_operand (operands[0], E_DImode)
                      && reg_or_0_operand (operands[1], E_DImode)
                      && ((
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 4629 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_53 (insn, operands);
                  break;

                case E_SFmode:
                  if (mem_simple_ldst_operand (operands[0], E_SFmode)
                      && reg_or_0_operand (operands[1], E_SFmode)
                      && ((
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)) && 
#line 4629 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_54 (insn, operands);
                  break;

                case E_DFmode:
                  if (mem_simple_ldst_operand (operands[0], E_DFmode)
                      && reg_or_0_operand (operands[1], E_DFmode)
                      && ((
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)) && 
#line 4629 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( true)))
                    return gen_split_55 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[0], E_V2DImode)
                  || !move_operand (operands[1], E_V2DImode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_56 (insn, operands);

            case E_V4SImode:
              if (!nonimmediate_operand (operands[0], E_V4SImode)
                  || !move_operand (operands[1], E_V4SImode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_57 (insn, operands);

            case E_V8HImode:
              if (!nonimmediate_operand (operands[0], E_V8HImode)
                  || !move_operand (operands[1], E_V8HImode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_58 (insn, operands);

            case E_V16QImode:
              if (!nonimmediate_operand (operands[0], E_V16QImode)
                  || !move_operand (operands[1], E_V16QImode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_59 (insn, operands);

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[0], E_V2DFmode)
                  || !move_operand (operands[1], E_V2DFmode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_60 (insn, operands);

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[0], E_V4SFmode)
                  || !move_operand (operands[1], E_V4SFmode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_61 (insn, operands);

            case E_V4DImode:
              if (!nonimmediate_operand (operands[0], E_V4DImode)
                  || !move_operand (operands[1], E_V4DImode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_62 (insn, operands);

            case E_V8SImode:
              if (!nonimmediate_operand (operands[0], E_V8SImode)
                  || !move_operand (operands[1], E_V8SImode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_63 (insn, operands);

            case E_V16HImode:
              if (!nonimmediate_operand (operands[0], E_V16HImode)
                  || !move_operand (operands[1], E_V16HImode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_64 (insn, operands);

            case E_V32QImode:
              if (!nonimmediate_operand (operands[0], E_V32QImode)
                  || !move_operand (operands[1], E_V32QImode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_65 (insn, operands);

            case E_V4DFmode:
              if (!nonimmediate_operand (operands[0], E_V4DFmode)
                  || !move_operand (operands[1], E_V4DFmode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_66 (insn, operands);

            case E_V8SFmode:
              if (!nonimmediate_operand (operands[0], E_V8SFmode)
                  || !move_operand (operands[1], E_V8SFmode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 45 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_67 (insn, operands);

            case E_V1TImode:
              if (!nonimmediate_operand (operands[0], E_V1TImode)
                  || !move_operand (operands[1], E_V1TImode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
                return NULL;
              return gen_split_68 (insn, operands);

            case E_V2TImode:
              if (!nonimmediate_operand (operands[0], E_V2TImode)
                  || !move_operand (operands[1], E_V2TImode)
                  || !(
#line 210 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(reload_completed && loongarch_split_move_p (operands[0], operands[1])) && 
#line 185 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
                return NULL;
              return gen_split_69 (insn, operands);

            default:
              return NULL;
            }

        case FIX:
          switch (pattern18 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return NULL;
              return gen_split_70 (insn, operands);

            case 1:
              if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return NULL;
              return gen_split_71 (insn, operands);

            case 2:
              if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return NULL;
              return gen_split_72 (insn, operands);

            case 3:
              if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return NULL;
              return gen_split_73 (insn, operands);

            default:
              return NULL;
            }

        case VEC_SELECT:
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != PARALLEL
              || XVECLEN (x10, 0) != 1)
            return NULL;
          x11 = XVECEXP (x10, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          switch (pattern133 (x3))
            {
            case 0:
              if (!(
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX) && 
#line 377 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
( reload_completed)))
                return NULL;
              return gen_split_74 (insn, operands);

            case 1:
              if (!(
#line 626 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LSX) && 
#line 628 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
( reload_completed)))
                return NULL;
              return gen_split_78 (insn, operands);

            case 2:
              if (!(
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX) && 
#line 377 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
( reload_completed)))
                return NULL;
              return gen_split_75 (insn, operands);

            case 3:
              if (!(
#line 626 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LSX) && 
#line 628 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
( reload_completed)))
                return NULL;
              return gen_split_79 (insn, operands);

            default:
              return NULL;
            }

        case VEC_CONCAT:
          x12 = XEXP (x3, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              operands[1] = x12;
              if (!register_operand (operands[1], E_DFmode)
                  || !register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode)
                return NULL;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!register_operand (operands[2], E_DFmode)
                  || !(
#line 1926 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX) && 
#line 1928 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
( reload_completed)))
                return NULL;
              return gen_split_76 (insn, operands);

            case VEC_CONCAT:
              if (pattern94 (x3) != 0
                  || !(
#line 1949 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX) && 
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
( reload_completed)))
                return NULL;
              return gen_split_77 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
