/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern0 (x3, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern0 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 5;

    case E_V4DImode:
      if (pattern0 (x3, 
E_V4DImode) != 0)
        return -1;
      return 6;

    case E_V8SImode:
      if (pattern0 (x3, 
E_V8SImode) != 0)
        return -1;
      return 7;

    case E_V16HImode:
      if (pattern0 (x3, 
E_V16HImode) != 0)
        return -1;
      return 8;

    case E_V32QImode:
      if (pattern0 (x3, 
E_V32QImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern29 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i4)
      || GET_MODE (x1) != i4)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i4
      || pattern26 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern36 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 2L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3L)
        return -1;
      return 0;

    case 0L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 1L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !register_operand (operands[1], E_V4DFmode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !register_operand (operands[1], E_V8SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_uimm3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern61 (x3, 
E_V2DImode, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern61 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern61 (x3, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 2;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i4
      || GET_MODE (x3) != i3
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern100 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!mem_simple_ldst_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!mem_simple_ldst_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!mem_simple_ldst_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return pattern108 (x1); /* [-1, 6] */
}

int
pattern117 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !register_operand (operands[2], E_V2DFmode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode)
          || !reg_or_vector_same_simm5_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern145 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern150 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 64
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 65
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 67
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 68
      || GET_MODE (x11) != E_SImode)
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 69
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 70
      || GET_MODE (x15) != E_SImode)
    return -1;
  x16 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 71
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 1
      || GET_MODE (x19) != E_SImode)
    return -1;
  return 0;
}

int
pattern190 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_FCCmode
      || !register_operand (operands[1], E_FCCmode)
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern197 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_exp_2_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[3] = x2;
  if (!const_0_to_3_operand (operands[3], E_VOIDmode))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  if (!const_0_to_3_operand (operands[4], E_VOIDmode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  operands[5] = x4;
  if (!const_0_to_3_operand (operands[5], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  operands[6] = x5;
  x6 = XVECEXP (x1, 0, 5);
  operands[7] = x6;
  if (!const_4_to_7_operand (operands[7], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x1, 0, 6);
  operands[8] = x7;
  if (!const_4_to_7_operand (operands[8], E_VOIDmode))
    return -1;
  x8 = XVECEXP (x1, 0, 7);
  operands[9] = x8;
  if (!const_4_to_7_operand (operands[9], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern221 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 8);
  if (XWINT (x3, 0) != 12L)
    return -1;
  x4 = XVECEXP (x2, 0, 9);
  if (XWINT (x4, 0) != 28L)
    return -1;
  x5 = XVECEXP (x2, 0, 10);
  if (XWINT (x5, 0) != 13L)
    return -1;
  x6 = XVECEXP (x2, 0, 11);
  if (XWINT (x6, 0) != 29L)
    return -1;
  x7 = XVECEXP (x2, 0, 12);
  if (XWINT (x7, 0) != 14L)
    return -1;
  x8 = XVECEXP (x2, 0, 13);
  if (XWINT (x8, 0) != 30L)
    return -1;
  x9 = XVECEXP (x2, 0, 14);
  if (XWINT (x9, 0) != 15L)
    return -1;
  x10 = XVECEXP (x2, 0, 15);
  if (XWINT (x10, 0) != 31L
      || pattern205 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern51 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 559; /* lsx_vfrintrp_d */

    case 1:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 564; /* lsx_vfrintrp_s */

    case 2:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 569; /* lasx_xvfrintrp_d */

    case 3:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 574; /* lasx_xvfrintrp_s */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V8SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !nonimmediate_operand (operands[1], E_V8SImode)
          || !
#line 481 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1542; /* lasx_xvperm_w */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || !
#line 481 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1543; /* lasx_xvperm_w_f */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  switch (pattern136 (x5))
    {
    case 0:
      return 446; /* loongarch_crc_w_b_w */

    case 1:
      return 448; /* loongarch_crc_w_h_w */

    case 2:
      return 450; /* loongarch_crc_w_w_w */

    case 3:
      if (
#line 401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return 452; /* loongarch_crc_w_d_w */
      break;

    default:
      break;
    }
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern138 (x2))
    {
    case 0:
      if (!
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 462; /* *crc_combine */

    case 1:
      if (!
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 464; /* *crc_combine */

    case 2:
      if (!
#line 4571 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && loongarch_pre_reload_split ()))
        return -1;
      return 466; /* *crc_combine */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1853; /* lasx_xvsrlr_d */

    case 1:
      if (!
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1854; /* lasx_xvsrlr_w */

    case 2:
      if (!
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1855; /* lasx_xvsrlr_h */

    case 3:
      if (!
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1856; /* lasx_xvsrlr_b */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1694; /* lasx_xvbitclri_d */

    case 1:
      if (!
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1695; /* lasx_xvbitclri_w */

    case 2:
      if (!
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1696; /* lasx_xvbitclri_h */

    case 3:
      if (!
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1697; /* lasx_xvbitclri_b */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 1705 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1241; /* lsx_vsrar_d */

    case 1:
      if (!
#line 1705 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1242; /* lsx_vsrar_w */

    case 2:
      if (!
#line 1705 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1243; /* lsx_vsrar_h */

    case 3:
      if (!
#line 1705 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1244; /* lsx_vsrar_b */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 966 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1084; /* lsx_vavgr_u_du */

    case 1:
      if (!
#line 966 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1085; /* lsx_vavgr_u_wu */

    case 2:
      if (!
#line 966 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1086; /* lsx_vavgr_u_hu */

    case 3:
      if (!
#line 966 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1087; /* lsx_vavgr_u_bu */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V2DFmode) != 0
          || !
#line 544 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 963; /* lsx_vshuf_d_f */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V4SFmode) != 0
          || !
#line 544 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 964; /* lsx_vshuf_w_f */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V2DImode) != 0
          || !
#line 544 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 965; /* lsx_vshuf_d */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V4SImode) != 0
          || !
#line 544 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 966; /* lsx_vshuf_w */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern160 (x2, 
E_V8HImode) != 0
          || !
#line 544 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 967; /* lsx_vshuf_h */

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  if (XWINT (x4, 0) == 0L)
    {
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern133 (x2))
        {
        case 0:
          if (
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 938; /* lsx_vec_extract_d_f */
          break;

        case 1:
          if (
#line 626 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LSX))
            return 1568; /* vec_extractv4df_0 */
          break;

        case 2:
          if (
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 939; /* lsx_vec_extract_w_f */
          break;

        case 3:
          if (
#line 626 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LSX))
            return 1569; /* vec_extractv8sf_0 */
          break;

        default:
          break;
        }
    }
  x5 = XEXP (x1, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_V2DImode)
              || !const_0_or_1_operand (operands[2], E_VOIDmode)
              || !
#line 489 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 960; /* lsx_vpickve2gr_du */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          switch (pattern196 (x2, 
E_VOIDmode))
            {
            case 0:
              if (!
#line 499 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 962; /* lsx_vpickve2gr_d_f */

            case 1:
              if (!
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2152; /* lasx_xvpickve_d_f_scalar */

            default:
              return -1;
            }

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !register_operand (operands[1], E_V8SFmode)
              || !const_0_to_7_operand (operands[2], E_VOIDmode)
              || !
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2153; /* lasx_xvpickve_w_f_scalar */

        default:
          return -1;
        }

    case MEM:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case PLUS:
          if (GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[1] = x9;
          x6 = XEXP (x2, 0);
          operands[2] = x6;
          operands[3] = x4;
          switch (GET_MODE (x5))
            {
            case E_DImode:
              if (!aq8d_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_DImode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V2DImode:
                  if (!register_operand (operands[2], E_V2DImode)
                      || !const_0_or_1_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1442; /* lsx_vstelm_d_insn */

                case E_V4DImode:
                  if (!register_operand (operands[2], E_V4DImode)
                      || !const_0_to_3_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2132; /* lasx_xvstelm_d_insn */

                default:
                  return -1;
                }

            case E_SImode:
              if (!aq8w_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[2], E_V4SImode)
                      || !const_0_to_3_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1443; /* lsx_vstelm_w_insn */

                case E_V8SImode:
                  if (!register_operand (operands[2], E_V8SImode)
                      || !const_0_to_7_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2133; /* lasx_xvstelm_w_insn */

                default:
                  return -1;
                }

            case E_HImode:
              if (!aq8h_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_HImode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V8HImode:
                  if (!register_operand (operands[2], E_V8HImode)
                      || !const_uimm3_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1444; /* lsx_vstelm_h_insn */

                case E_V16HImode:
                  if (!register_operand (operands[2], E_V16HImode)
                      || !const_uimm4_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2134; /* lasx_xvstelm_h_insn */

                default:
                  return -1;
                }

            case E_QImode:
              if (!aq8b_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_QImode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V16QImode:
                  if (!register_operand (operands[2], E_V16QImode)
                      || !const_uimm4_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1445; /* lsx_vstelm_b_insn */

                case E_V32QImode:
                  if (!register_operand (operands[2], E_V32QImode)
                      || !const_uimm5_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2135; /* lasx_xvstelm_b_insn */

                default:
                  return -1;
                }

            case E_DFmode:
              if (!aq8d_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_DFmode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V2DFmode:
                  if (!register_operand (operands[2], E_V2DFmode)
                      || !const_0_or_1_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1446; /* lsx_vstelm_d_f_insn */

                case E_V4DFmode:
                  if (!register_operand (operands[2], E_V4DFmode)
                      || !const_0_to_3_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2136; /* lasx_xvstelm_d_f_insn */

                default:
                  return -1;
                }

            case E_SFmode:
              if (!aq8w_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x2) != E_SFmode)
                return -1;
              switch (GET_MODE (operands[2]))
                {
                case E_V4SFmode:
                  if (!register_operand (operands[2], E_V4SFmode)
                      || !const_0_to_3_operand (operands[3], E_VOIDmode)
                      || !
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1447; /* lsx_vstelm_w_f_insn */

                case E_V8SFmode:
                  if (!register_operand (operands[2], E_V8SFmode)
                      || !const_0_to_7_operand (operands[3], E_VOIDmode)
                      || !
#line 3464 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2137; /* lasx_xvstelm_w_f_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[0] = x7;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x6 = XEXP (x2, 0);
          operands[1] = x6;
          operands[2] = x4;
          switch (GET_MODE (x5))
            {
            case E_DImode:
              if (GET_MODE (x2) != E_DImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2DImode:
                  if (!register_operand (operands[1], E_V2DImode)
                      || !const_0_or_1_operand (operands[2], E_SImode)
                      || !
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1448; /* lsx_vstelm_d_insn_0 */

                case E_V4DImode:
                  if (!register_operand (operands[1], E_V4DImode)
                      || !const_0_to_3_operand (operands[2], E_SImode)
                      || !
#line 3478 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2138; /* lasx_xvstelm_d_insn_0 */

                default:
                  return -1;
                }

            case E_SImode:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !const_0_to_3_operand (operands[2], E_SImode)
                      || !
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1449; /* lsx_vstelm_w_insn_0 */

                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode)
                      || !const_0_to_7_operand (operands[2], E_SImode)
                      || !
#line 3478 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2140; /* lasx_xvstelm_w_insn_0 */

                default:
                  return -1;
                }

            case E_HImode:
              if (GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !const_uimm3_operand (operands[2], E_SImode)
                  || !
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1450; /* lsx_vstelm_h_insn_0 */

            case E_QImode:
              if (GET_MODE (x2) != E_QImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !const_uimm4_operand (operands[2], E_SImode)
                  || !
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1451; /* lsx_vstelm_b_insn_0 */

            case E_DFmode:
              switch (pattern196 (x2, 
E_SImode))
                {
                case 0:
                  if (!
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1452; /* lsx_vstelm_d_f_insn_0 */

                case 1:
                  if (!
#line 3478 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2139; /* lasx_xvstelm_d_f_insn_0 */

                default:
                  return -1;
                }

            case E_SFmode:
              if (GET_MODE (x2) != E_SFmode)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !const_0_to_3_operand (operands[2], E_SImode)
                      || !
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1453; /* lsx_vstelm_w_f_insn_0 */

                case E_V8SFmode:
                  if (!register_operand (operands[1], E_V8SFmode)
                      || !const_0_to_7_operand (operands[2], E_SImode)
                      || !
#line 3478 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2141; /* lasx_xvstelm_w_f_insn_0 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (register_operand (operands[1], E_SImode))
            {
              x6 = XEXP (x4, 1);
              operands[2] = x6;
              if (plus_si_extend_operand (operands[2], E_SImode)
                  && 
#line 795 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return 6; /* addsi3_extended */
            }
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          if (GET_MODE (x7) != E_DImode)
            return -1;
          switch (GET_CODE (x7))
            {
            case ASHIFT:
              if (pattern195 (x4) != 0
                  || !
#line 3119 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 258; /* *alslsi3_extend_subreg */

            case AND:
              if (pattern204 (x4) != 0
                  || !
#line 3175 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (true, operands[2], operands[3],
				       SImode)))
                return -1;
              return 266; /* and_alsl_reversesi_extended */

            case IOR:
              if (pattern204 (x4) != 0
                  || !
#line 3175 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)))
                return -1;
              return 267; /* ior_alsl_reversesi_extended */

            case XOR:
              if (pattern204 (x4) != 0
                  || !
#line 3175 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && loongarch_reassoc_shift_bitwise (false, operands[2], operands[3],
				       SImode)))
                return -1;
              return 268; /* xor_alsl_reversesi_extended */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          if (!const_immalsl_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 3105 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 256; /* *alslsi3_extend */

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 846 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 11; /* subsi3_extend */

    case MULT:
      if (pattern32 (x3) != 0
          || !
#line 882 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 16; /* mulsi3_extend */

    case DIV:
      if (pattern32 (x3) != 0
          || !
#line 1102 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && ISA_HAS_DIV32))
        return -1;
      return 37; /* divsi3_extended */

    case UDIV:
      if (pattern32 (x3) != 0
          || !
#line 1102 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && ISA_HAS_DIV32))
        return -1;
      return 38; /* udivsi3_extended */

    case MOD:
      if (pattern32 (x3) != 0
          || !
#line 1102 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && ISA_HAS_DIV32))
        return -1;
      return 39; /* modsi3_extended */

    case UMOD:
      if (pattern32 (x3) != 0
          || !
#line 1102 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && ISA_HAS_DIV32))
        return -1;
      return 40; /* umodsi3_extended */

    case UNSPEC:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (XINT (x4, 1) != 35)
            return -1;
          x9 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x9) != SUBREG
              || maybe_ne (SUBREG_BYTE (x9), 0)
              || GET_MODE (x9) != E_SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_DImode)
            return -1;
          switch (GET_CODE (x10))
            {
            case DIV:
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x10, 1);
              operands[2] = x12;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && !ISA_HAS_DIV32))
                return -1;
              return 41; /* divdi3_fake */

            case UDIV:
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x10, 1);
              operands[2] = x12;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && !ISA_HAS_DIV32))
                return -1;
              return 42; /* udivdi3_fake */

            case MOD:
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x10, 1);
              operands[2] = x12;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && !ISA_HAS_DIV32))
                return -1;
              return 43; /* moddi3_fake */

            case UMOD:
              x11 = XEXP (x10, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x12 = XEXP (x10, 1);
              operands[2] = x12;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 1122 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && !ISA_HAS_DIV32))
                return -1;
              return 44; /* umoddi3_fake */

            default:
              return -1;
            }

        case 2:
          x9 = XVECEXP (x4, 0, 0);
          operands[1] = x9;
          x13 = XVECEXP (x4, 0, 1);
          operands[2] = x13;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 24:
              switch (pattern191 ())
                {
                case 0:
                  if (!
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 454; /* loongarch_crc_w_b_w_extended */

                case 1:
                  if (!
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 456; /* loongarch_crc_w_h_w_extended */

                case 2:
                  if (!
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 458; /* loongarch_crc_w_w_w_extended */

                case 3:
                  if (!
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 460; /* loongarch_crc_w_d_w_extended */

                default:
                  return -1;
                }

            case 25:
              switch (pattern191 ())
                {
                case 0:
                  if (!
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 455; /* loongarch_crcc_w_b_w_extended */

                case 1:
                  if (!
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 457; /* loongarch_crcc_w_h_w_extended */

                case 2:
                  if (!
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 459; /* loongarch_crcc_w_w_w_extended */

                case 3:
                  if (!
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 461; /* loongarch_crcc_w_d_w_extended */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      if (pattern33 (x3) != 0
          || !
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 93; /* *negsi2_extended */

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern34 (x3))
        {
        case 0:
          if (nonimmediate_operand (operands[1], E_SImode)
              && 
#line 1844 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 133; /* extendsidi2 */
          if (!mem_simple_ldst_operand (operands[1], E_SImode)
              || !(
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 482; /* simple_load_sextsidi */

        case 1:
          if (nonimmediate_operand (operands[1], E_QImode)
              && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 135; /* extendqidi2 */
          if (!mem_simple_ldst_operand (operands[1], E_QImode)
              || !(
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 478; /* simple_load_sextqidi */

        case 2:
          if (nonimmediate_operand (operands[1], E_HImode)
              && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 137; /* extendhidi2 */
          if (!mem_simple_ldst_operand (operands[1], E_HImode)
              || !(
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 480; /* simple_load_sexthidi */

        case 3:
          if (nonimmediate_operand (operands[1], E_QImode))
            return 134; /* extendqisi2 */
          if (!mem_simple_ldst_operand (operands[1], E_QImode)
              || !
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
            return -1;
          return 472; /* simple_load_sextqisi */

        case 4:
          if (nonimmediate_operand (operands[1], E_HImode))
            return 136; /* extendhisi2 */
          if (!mem_simple_ldst_operand (operands[1], E_HImode)
              || !
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
            return -1;
          return 474; /* simple_load_sexthisi */

        case 5:
          if (!
#line 4613 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && la_opt_explicit_relocs == EXPLICIT_RELOCS_AUTO
   && (TARGET_CMODEL_NORMAL || TARGET_CMODEL_MEDIUM)))
            return -1;
          return 476; /* simple_load_sextsisi */

        case 6:
          return 138; /* extendqihi2 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern35 (x3) != 0
          || !
#line 3034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 248; /* ashlsi3_extend */

    case ASHIFTRT:
      if (pattern35 (x3) != 0
          || !
#line 3034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 249; /* ashrsi3_extend */

    case LSHIFTRT:
      if (pattern35 (x3) != 0
          || !
#line 3034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 250; /* lshrsi3_extend */

    case ROTATERT:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!arith_operand (operands[2], E_SImode)
              || !
#line 3058 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 253; /* rotrsi3_extend */

        case BSWAP:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 270; /* revb_2h_extend */

        default:
          return -1;
        }

    case BITREVERSE:
      if (pattern33 (x3) != 0
          || !
#line 4330 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 436; /* rbitsi_extended */

    case VEC_SELECT:
      switch (pattern42 (x3))
        {
        case 0:
          if (!
#line 468 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 952; /* lsx_vpickve2gr_h */

        case 1:
          if (!
#line 468 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 954; /* lsx_vpickve2gr_b */

        case 2:
          if (!
#line 479 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 956; /* lsx_vpickve2gr_w */

        case 3:
          if (!
#line 3148 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2067; /* lasx_xvpickve2gr_w */

        case 4:
          if (!
#line 479 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 958; /* lsx_vpickve2gr_w_f */

        case 5:
          if (!
#line 554 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1564; /* lasx_xvpickve2gr_d */

        case 6:
          if (!
#line 3009 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1473; /* vec_unpacks_hi_v16qi */

        case 7:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1925; /* vec_unpacks_lo_v16qi_internal */

        case 8:
          if (!
#line 2395 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1927; /* vec_unpacks_lo_v16hi */

        case 9:
          if (!
#line 2444 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1935; /* lasx_vext2xv_w_b */

        case 10:
          if (!
#line 3199 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2073; /* lasx_xvexth_w_h */

        case 11:
          if (!
#line 3021 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1475; /* vec_unpacks_hi_v8hi */

        case 12:
          if (!
#line 2407 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1929; /* vec_unpacks_lo_v8hi_internal */

        case 13:
          if (!
#line 2419 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1931; /* vec_unpacks_lo_v8si */

        case 14:
          if (!
#line 2456 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1937; /* lasx_vext2xv_d_h */

        case 15:
          if (!
#line 2468 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1939; /* lasx_vext2xv_d_b */

        case 16:
          if (!
#line 3211 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2075; /* lasx_xvexth_d_w */

        case 17:
          if (!
#line 3032 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1477; /* vec_unpacks_hi_v4si */

        case 18:
          if (!
#line 2430 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1933; /* vec_unpacks_lo_v4si_internal */

        case 19:
          if (!
#line 2367 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1923; /* vec_unpacks_lo_v32qi */

        case 20:
          if (!
#line 3185 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2071; /* lasx_xvexth_h_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern83 (x3))
        {
        case 0:
          if (
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return 102; /* one_cmplsi2 */
          if (!
#line 1588 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 104; /* *one_cmplsi2_internal */

        case 1:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 103; /* one_cmpldi2 */

        case 2:
          if (!
#line 713 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1022; /* one_cmplv2di2 */

        case 3:
          if (!
#line 713 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1023; /* one_cmplv4si2 */

        case 4:
          if (!
#line 713 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1024; /* one_cmplv8hi2 */

        case 5:
          if (!
#line 713 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1025; /* one_cmplv16qi2 */

        case 6:
          if (!
#line 851 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1624; /* one_cmplv4di2 */

        case 7:
          if (!
#line 851 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1625; /* one_cmplv8si2 */

        case 8:
          if (!
#line 851 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1626; /* one_cmplv16hi2 */

        case 9:
          if (!
#line 851 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1627; /* one_cmplv32qi2 */

        default:
          return -1;
        }

    case GE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 715; /* lsx_vfcmp_sult_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 719; /* lsx_vfcmp_sult_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 723; /* lasx_xvfcmp_sult_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 727; /* lasx_xvfcmp_sult_s */

        default:
          return -1;
        }

    case GT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 716; /* lsx_vfcmp_sule_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 720; /* lsx_vfcmp_sule_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 724; /* lasx_xvfcmp_sule_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 728; /* lasx_xvfcmp_sule_s */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 717; /* lsx_vfcmp_clt_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 721; /* lsx_vfcmp_clt_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 725; /* lasx_xvfcmp_clt_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 729; /* lasx_xvfcmp_clt_s */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 718; /* lsx_vfcmp_cle_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 722; /* lsx_vfcmp_cle_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 726; /* lasx_xvfcmp_cle_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 730; /* lasx_xvfcmp_cle_s */

        default:
          return -1;
        }

    case LE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 731; /* lsx_vfcmp_sugt_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 735; /* lsx_vfcmp_sugt_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 739; /* lasx_xvfcmp_sugt_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 743; /* lasx_xvfcmp_sugt_s */

        default:
          return -1;
        }

    case LT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 732; /* lsx_vfcmp_suge_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 736; /* lsx_vfcmp_suge_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 740; /* lasx_xvfcmp_suge_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 744; /* lasx_xvfcmp_suge_s */

        default:
          return -1;
        }

    case UNLE:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 733; /* lsx_vfcmp_cgt_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 737; /* lsx_vfcmp_cgt_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 741; /* lasx_xvfcmp_cgt_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 745; /* lasx_xvfcmp_cgt_s */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern92 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 734; /* lsx_vfcmp_cge_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 738; /* lsx_vfcmp_cge_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 742; /* lasx_xvfcmp_cge_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 746; /* lasx_xvfcmp_cge_s */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (pattern121 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 303; /* *sle_sisi */

        case 1:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 305; /* *sle_disi */

        case 2:
          if (!
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 307; /* *sle_didi */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_FCCmode:
          switch (pattern11 (x3))
            {
            case 0:
              if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 315; /* sle_sf_using_FCCmode */

            case 1:
              if (!
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 329; /* sle_df_using_FCCmode */

            default:
              return -1;
            }

        case E_V2DImode:
          switch (pattern117 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 665; /* lsx_vfcmp_sle_d */

            case 1:
              if (!
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1118; /* lsx_vsle_d */

            default:
              return -1;
            }

        case E_V4SImode:
          switch (pattern118 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 675; /* lsx_vfcmp_sle_s */

            case 1:
              if (!
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1123; /* lsx_vsle_w */

            default:
              return -1;
            }

        case E_V4DImode:
          switch (pattern119 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 685; /* lasx_xvfcmp_sle_d */

            case 1:
              if (!
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1722; /* lasx_xvsle_d */

            default:
              return -1;
            }

        case E_V8SImode:
          switch (pattern120 (x3))
            {
            case 0:
              if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 695; /* lasx_xvfcmp_sle_s */

            case 1:
              if (!
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1727; /* lasx_xvsle_w */

            default:
              return -1;
            }

        case E_V8HImode:
          if (pattern2 (x3, 
E_V8HImode) != 0
              || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1128; /* lsx_vsle_h */

        case E_V16QImode:
          if (pattern2 (x3, 
E_V16QImode) != 0
              || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1133; /* lsx_vsle_b */

        case E_V16HImode:
          if (pattern2 (x3, 
E_V16HImode) != 0
              || !
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1732; /* lasx_xvsle_h */

        case E_V32QImode:
          if (pattern2 (x3, 
E_V32QImode) != 0
              || !
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1737; /* lasx_xvsle_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern3 (x1))
    {
    case 0:
      if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 81; /* sminsf3 */

    case 1:
      if (!
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 82; /* smindf3 */

    case 2:
      if (!
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1155; /* sminv2df3 */

    case 3:
      if (!
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1156; /* sminv4sf3 */

    case 4:
      if (!
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1199; /* sminv2di3 */

    case 5:
      if (!
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1200; /* sminv4si3 */

    case 6:
      if (!
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1201; /* sminv8hi3 */

    case 7:
      if (!
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1202; /* sminv16qi3 */

    case 8:
      if (!
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1759; /* sminv4df3 */

    case 9:
      if (!
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1760; /* sminv8sf3 */

    case 10:
      if (!
#line 1759 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1803; /* sminv4di3 */

    case 11:
      if (!
#line 1759 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1804; /* sminv8si3 */

    case 12:
      if (!
#line 1759 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1805; /* sminv16hi3 */

    case 13:
      if (!
#line 1759 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1806; /* sminv32qi3 */

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 3:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != UNSPEC
          || pattern106 (x3) != 0)
        return NULL;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return NULL;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!symbolic_off64_or_reg_operand (operands[1], E_DImode))
        return NULL;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 2240 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_CMODEL_EXTREME) && 
#line 2265 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
( REG_P (operands[1]) && find_reg_note (insn, REG_UNUSED, operands[2]) != 0)))
        return NULL;
      return gen_split_13 (insn, operands);

    case 2:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != UNSPEC
          || XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 14)
        return NULL;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return NULL;
      x8 = XVECEXP (x2, 0, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_VOIDmode))
        return NULL;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      if (!scratch_operand (operands[1], E_VOIDmode)
          || !
#line 3729 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(reload_completed))
        return NULL;
      return gen_split_26 (insn, operands);

    default:
      return NULL;
    }
}
