/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_simm5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern16 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern16 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern16 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern16 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern16 (x3, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V8SImode:
      if (pattern16 (x3, 
E_V8SImode) != 0)
        return -1;
      return 5;

    case E_V16HImode:
      if (pattern16 (x3, 
E_V16HImode) != 0)
        return -1;
      return 6;

    case E_V32QImode:
      if (pattern16 (x3, 
E_V32QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case ZERO_EXTEND:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != VEC_SELECT)
        return -1;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          return pattern27 (x1, 
E_V2DImode, 
E_V1DImode, 
E_V1TImode); /* [-1, 0] */

        case E_V2DImode:
          if (pattern27 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern27 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern27 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V2TImode:
          if (pattern27 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V2TImode) != 0)
            return -1;
          return 4;

        case E_V4DImode:
          if (pattern27 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 5;

        case E_V8SImode:
          if (pattern27 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 6;

        case E_V16HImode:
          if (pattern27 (x1, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern30 (x1);
      if (res >= 0)
        return res + 8; /* [8, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern58 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern58 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern58 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern58 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern58 (x3, 
E_V4DImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern58 (x3, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V16HImode:
      if (pattern58 (x3, 
E_V16HImode) != 0)
        return -1;
      return 2;

    case E_V32QImode:
      if (pattern58 (x3, 
E_V32QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern85 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!non_volatile_mem_operand (operands[1], E_HImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!non_volatile_mem_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern105 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XWINT (x2, 0) != 0L)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern104 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !reg_or_0_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !reg_or_0_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  return 0;
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !and_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern139 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_0_or_1_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern58 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern58 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern58 (x1, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern58 (x1, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x4, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  return 0;
}

int
pattern193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern201 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 4)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (GET_MODE (x3) != E_SImode
          || !symbolic_operand (operands[0], E_SImode)
          || !(
#line 2748 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
        return -1;
      *pnum_clobbers = 9;
      return 210; /* got_load_tls_descsi */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode
          || !symbolic_operand (operands[0], E_DImode)
          || !(
#line 2748 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
        return -1;
      *pnum_clobbers = 9;
      return 211; /* got_load_tls_descdi */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      if (pattern139 (x3, 
E_V4DImode) != 0
          || !
#line 2165 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1881; /* lasx_xvrepl128vei_d */

    case E_V8SImode:
      if (pattern140 (x3, 
E_V8SImode) != 0
          || !
#line 2165 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1882; /* lasx_xvrepl128vei_w */

    case E_V16HImode:
      if (pattern70 (x3, 
E_V16HImode, 
E_V16HImode) != 0
          || !
#line 2165 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1883; /* lasx_xvrepl128vei_h */

    case E_V32QImode:
      if (pattern65 (x3, 
E_V32QImode) != 0
          || !
#line 2165 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1884; /* lasx_xvrepl128vei_b */

    case E_V4DFmode:
      if (pattern139 (x3, 
E_V4DFmode) != 0
          || !
#line 2165 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1885; /* lasx_xvrepl128vei_d_f */

    case E_V8SFmode:
      if (pattern140 (x3, 
E_V8SFmode) != 0
          || !
#line 2165 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1886; /* lasx_xvrepl128vei_w_f */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_uimm5_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern110 (x3))
    {
    case 0:
      if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1386; /* lsx_vbsll_d */

    case 1:
      if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1387; /* lsx_vbsll_w */

    case 2:
      if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1388; /* lsx_vbsll_h */

    case 3:
      if (!
#line 2257 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1389; /* lsx_vbsll_b */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern81 (x1))
    {
    case 0:
      if (!
#line 2667 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2000; /* lasx_xvbsll_d */

    case 1:
      if (!
#line 2667 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2001; /* lasx_xvbsll_w */

    case 2:
      if (!
#line 2667 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2002; /* lasx_xvbsll_h */

    case 3:
      if (!
#line 2667 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2003; /* lasx_xvbsll_b */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1713; /* lasx_xvbitset_d */

    case 1:
      if (!
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1714; /* lasx_xvbitset_w */

    case 2:
      if (!
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1715; /* lasx_xvbitset_h */

    case 3:
      if (!
#line 1180 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1716; /* lasx_xvbitset_b */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 2287 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1398; /* lsx_vsigncov_d */

    case 1:
      if (!
#line 2287 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1399; /* lsx_vsigncov_w */

    case 2:
      if (!
#line 2287 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1400; /* lsx_vsigncov_h */

    case 3:
      if (!
#line 2287 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1401; /* lsx_vsigncov_b */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 996 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1096; /* lsx_vbitrev_d */

    case 1:
      if (!
#line 996 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1097; /* lsx_vbitrev_w */

    case 2:
      if (!
#line 996 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1098; /* lsx_vbitrev_h */

    case 3:
      if (!
#line 996 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1099; /* lsx_vbitrev_b */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V2DImode, 
E_V4DImode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1558; /* lasx_vecinit_merge_v4di */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V4SImode, 
E_V8SImode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1559; /* lasx_vecinit_merge_v8si */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V8HImode, 
E_V16HImode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1560; /* lasx_vecinit_merge_v16hi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1561; /* lasx_vecinit_merge_v32qi */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1562; /* lasx_vecinit_merge_v4df */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern134 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
          || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1563; /* lasx_vecinit_merge_v8sf */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XVECEXP (x5, 0, 4);
  if (!const_4_to_7_operand (x7, E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_V8SImode)
          && pattern207 (x5) == 0
          && 
#line 2007 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])))
        return 1847; /* lasx_xvshuf4i_w_1 */
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      operands[3] = x7;
      x8 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XVECEXP (x5, 0, 2);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x5, 0, 3);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XVECEXP (x5, 0, 5);
      if (!rtx_equal_p (x11, operands[3]))
        return -1;
      x12 = XVECEXP (x5, 0, 6);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x13 = XVECEXP (x5, 0, 7);
      if (!rtx_equal_p (x13, operands[3])
          || !
#line 2142 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ((INTVAL (operands[3]) - INTVAL (operands[2])) == 4)))
        return -1;
      return 1879; /* lasx_xvrepl128vei_w_internal */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !nonimmediate_operand (operands[1], E_V8SFmode)
          || pattern207 (x5) != 0
          || !
#line 2007 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX
   && INTVAL (operands[2]) + 4 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 4 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 4 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 4 == INTVAL (operands[9])))
        return -1;
      return 1848; /* lasx_xvshuf4i_w_f_1 */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x3, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x3, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x3, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x3, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x3, 0, 0);
  switch (XWINT (x10, 0))
    {
    case 0L:
      x11 = XVECEXP (x3, 0, 1);
      switch (XWINT (x11, 0))
        {
        case 8L:
          switch (XWINT (x4, 0))
            {
            case 2L:
              if (XWINT (x5, 0) != 10L
                  || XWINT (x6, 0) != 4L
                  || XWINT (x7, 0) != 12L
                  || XWINT (x8, 0) != 6L
                  || XWINT (x9, 0) != 14L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern205 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                      || !
#line 1315 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1172; /* lsx_vpackev_h */

                case E_V8SImode:
                  if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                      || !
#line 1454 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1777; /* lasx_xvpackev_w */

                case E_V8SFmode:
                  if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                      || !
#line 1469 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1778; /* lasx_xvpackev_w_f */

                default:
                  return -1;
                }

            case 1L:
              if (XWINT (x5, 0) != 9L)
                return -1;
              switch (XWINT (x6, 0))
                {
                case 2L:
                  if (XWINT (x7, 0) != 10L
                      || XWINT (x8, 0) != 3L
                      || XWINT (x9, 0) != 11L
                      || pattern205 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                      || !
#line 1498 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1186; /* lsx_vilvl_h */

                case 4L:
                  if (XWINT (x7, 0) != 12L
                      || XWINT (x8, 0) != 5L
                      || XWINT (x9, 0) != 13L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8SImode:
                      if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                          || !
#line 1687 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                        return -1;
                      return 1791; /* lasx_xvilvl_w */

                    case E_V8SFmode:
                      if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                          || !
#line 1702 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                        return -1;
                      return 1792; /* lasx_xvilvl_w_f */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2L:
          if (XWINT (x4, 0) != 8L
              || XWINT (x5, 0) != 10L
              || XWINT (x6, 0) != 4L
              || XWINT (x7, 0) != 6L
              || XWINT (x8, 0) != 12L
              || XWINT (x9, 0) != 14L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8SImode:
              if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                  || !
#line 1860 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1825; /* lasx_xvpickev_w */

            case E_V8SFmode:
              if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                  || !
#line 1875 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1826; /* lasx_xvpickev_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4L:
      x11 = XVECEXP (x3, 0, 1);
      if (XWINT (x11, 0) != 12L
          || XWINT (x4, 0) != 5L
          || XWINT (x5, 0) != 13L
          || pattern216 (x3) != 0
          || pattern205 (x2, 
E_V8HImode, 
E_V16HImode) != 0
          || !
#line 1375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1176; /* lsx_vilvh_h */

    case 1L:
      if (XWINT (x5, 0) != 11L
          || XWINT (x6, 0) != 5L
          || XWINT (x9, 0) != 15L)
        return -1;
      x11 = XVECEXP (x3, 0, 1);
      switch (XWINT (x11, 0))
        {
        case 9L:
          if (XWINT (x4, 0) != 3L
              || XWINT (x7, 0) != 13L
              || XWINT (x8, 0) != 7L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern205 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                  || !
#line 1438 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1182; /* lsx_vpackod_h */

            case E_V8SImode:
              if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                  || !
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1787; /* lasx_xvpackod_w */

            case E_V8SFmode:
              if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                  || !
#line 1626 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1788; /* lasx_xvpackod_w_f */

            default:
              return -1;
            }

        case 3L:
          if (XWINT (x4, 0) != 9L
              || XWINT (x7, 0) != 7L
              || XWINT (x8, 0) != 13L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8SImode:
              if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
                  || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1829; /* lasx_xvpickod_w */

            case E_V8SFmode:
              if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
                  || !
#line 1951 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1830; /* lasx_xvpickod_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2L:
      x11 = XVECEXP (x3, 0, 1);
      if (XWINT (x11, 0) != 10L
          || XWINT (x4, 0) != 3L
          || XWINT (x5, 0) != 11L
          || pattern216 (x3) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SImode:
          if (pattern205 (x2, 
E_V8SImode, 
E_V16SImode) != 0
              || !
#line 1534 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1781; /* lasx_xvilvh_w */

        case E_V8SFmode:
          if (pattern205 (x2, 
E_V8SFmode, 
E_V16SFmode) != 0
              || !
#line 1534 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1782; /* lasx_xvilvh_w_f */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2; /* addsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 3; /* adddf3 */

        case E_SImode:
          if (pattern123 (x3) != 0)
            return -1;
          return 4; /* *addsi3 */

        case E_DImode:
          if (pattern124 (x3) != 0
              || !
#line 769 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 5; /* adddi3 */

        case E_V2DImode:
          if (pattern125 (x3, 
E_V2DImode) != 0
              || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 968; /* addv2di3 */

        case E_V4SImode:
          if (pattern125 (x3, 
E_V4SImode) != 0
              || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 969; /* addv4si3 */

        case E_V8HImode:
          if (pattern125 (x3, 
E_V8HImode) != 0
              || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 970; /* addv8hi3 */

        case E_V16QImode:
          if (pattern125 (x3, 
E_V16QImode) != 0
              || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 971; /* addv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 795 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1038; /* addv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 795 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1039; /* addv4sf3 */

        case E_V4DImode:
          if (pattern125 (x3, 
E_V4DImode) != 0
              || !
#line 680 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1570; /* addv4di3 */

        case E_V8SImode:
          if (pattern125 (x3, 
E_V8SImode) != 0
              || !
#line 680 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1571; /* addv8si3 */

        case E_V16HImode:
          if (pattern125 (x3, 
E_V16HImode) != 0
              || !
#line 680 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1572; /* addv16hi3 */

        case E_V32QImode:
          if (pattern125 (x3, 
E_V32QImode) != 0
              || !
#line 680 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1573; /* addv32qi3 */

        case E_V4DFmode:
          if (pattern0 (x3, 
E_V4DFmode) != 0
              || !
#line 936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1640; /* addv4df3 */

        case E_V8SFmode:
          if (pattern0 (x3, 
E_V8SFmode) != 0
              || !
#line 936 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1641; /* addv8sf3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern22 (x3))
        {
        case 0:
          if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (SImode, operands)))
            return -1;
          return 107; /* *bstrins_si_for_ior_mask */

        case 1:
          if (!(
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_pre_reload_split ()
   && loongarch_use_bstrins_for_ior_with_mask (DImode, operands)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 110; /* *bstrins_di_for_ior_mask */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[2] = x6;
      if (const_immalsl_operand (operands[2], E_VOIDmode))
        {
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern175 (x3, 
E_SImode) == 0)
                return 254; /* alslsi3 */
              break;

            case E_DImode:
              if (pattern175 (x3, 
E_DImode) == 0
                  && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return 255; /* alsldi3 */
              break;

            default:
              break;
            }
        }
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != LSHIFTRT)
        return -1;
      switch (pattern109 (x3))
        {
        case 0:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 425; /* *bytepick_d_1_rev */

        case 1:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 426; /* *bytepick_d_2_rev */

        case 2:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 427; /* *bytepick_d_3_rev */

        case 3:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 428; /* *bytepick_d_4_rev */

        case 4:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 429; /* *bytepick_d_5_rev */

        case 5:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 430; /* *bytepick_d_6_rev */

        case 6:
          if (!
#line 4296 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 431; /* *bytepick_d_7_rev */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern25 (x3))
        {
        case 0:
          return 384; /* *bytepick_w_1 */

        case 1:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 408; /* *bytepick_d_5 */

        case 2:
          return 385; /* *bytepick_w_2 */

        case 3:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 409; /* *bytepick_d_6 */

        case 4:
          return 386; /* *bytepick_w_3 */

        case 5:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 410; /* *bytepick_d_7 */

        case 6:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 404; /* *bytepick_d_1 */

        case 7:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 405; /* *bytepick_d_2 */

        case 8:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 406; /* *bytepick_d_3 */

        case 9:
          if (!
#line 4285 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 407; /* *bytepick_d_4 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern28 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 791; /* simd_addw_evod_v2di_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V2DImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 863; /* simd_haddw_v2di_s */

        case 1:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 797; /* simd_addw_evod_v4si_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4SImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 867; /* simd_haddw_v4si_s */

        case 2:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 803; /* simd_addw_evod_v8hi_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8HImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 871; /* simd_haddw_v8hi_s */

        case 3:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 809; /* simd_addw_evod_v16qi_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16QImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 875; /* simd_haddw_v16qi_s */

        case 4:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 815; /* simd_addw_evod_v4di_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4DImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 879; /* simd_haddw_v4di_s */

        case 5:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 821; /* simd_addw_evod_v8si_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8SImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 883; /* simd_haddw_v8si_s */

        case 6:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 827; /* simd_addw_evod_v16hi_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16HImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 887; /* simd_haddw_v16hi_s */

        case 7:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 833; /* simd_addw_evod_v32qi_s */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V32QImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 891; /* simd_haddw_v32qi_s */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x3))
        {
        case 0:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 794; /* simd_addw_evod_v2di_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V2DImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 864; /* simd_haddw_v2di_u */

        case 1:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 800; /* simd_addw_evod_v4si_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4SImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 868; /* simd_haddw_v4si_u */

        case 2:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 806; /* simd_addw_evod_v8hi_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8HImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 872; /* simd_haddw_v8hi_u */

        case 3:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return 812; /* simd_addw_evod_v16qi_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16QImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
            return -1;
          return 876; /* simd_haddw_v16qi_u */

        case 4:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 818; /* simd_addw_evod_v4di_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V4DImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 880; /* simd_haddw_v4di_u */

        case 5:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 824; /* simd_addw_evod_v8si_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V8SImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 884; /* simd_haddw_v8si_u */

        case 6:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 830; /* simd_addw_evod_v16hi_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V16HImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 888; /* simd_haddw_v16hi_u */

        case 7:
          x5 = XEXP (x3, 1);
          x8 = XEXP (x5, 0);
          x9 = XEXP (x8, 1);
          if (rtx_equal_p (x9, operands[3])
              && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return 836; /* simd_addw_evod_v32qi_u */
          operands[4] = x9;
          if (!vect_par_cnst_even_or_odd_half (operands[4], E_V32QImode)
              || !(
#line 742 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(!rtx_equal_p (operands[3], operands[4])) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
            return -1;
          return 892; /* simd_haddw_v32qi_u */

        case 8:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 839; /* simd_addw_evod_v2di_hetero */

        case 9:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 842; /* simd_addw_evod_v4si_hetero */

        case 10:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 845; /* simd_addw_evod_v8hi_hetero */

        case 11:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 848; /* simd_addw_evod_v16qi_hetero */

        case 12:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 851; /* simd_addw_evod_v4di_hetero */

        case 13:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 854; /* simd_addw_evod_v8si_hetero */

        case 14:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 857; /* simd_addw_evod_v16hi_hetero */

        case 15:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 860; /* simd_addw_evod_v32qi_hetero */

        default:
          return -1;
        }

    case MULT:
      return recog_1 (x1, insn, pnum_clobbers);

    case ABS:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != ABS)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern23 (x3, 
E_V2DImode) != 0
              || !
#line 894 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1052; /* lsx_vadda_d */

        case E_V4SImode:
          if (pattern23 (x3, 
E_V4SImode) != 0
              || !
#line 894 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1053; /* lsx_vadda_w */

        case E_V8HImode:
          if (pattern23 (x3, 
E_V8HImode) != 0
              || !
#line 894 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1054; /* lsx_vadda_h */

        case E_V16QImode:
          if (pattern23 (x3, 
E_V16QImode) != 0
              || !
#line 894 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1055; /* lsx_vadda_b */

        case E_V4DImode:
          if (pattern23 (x3, 
E_V4DImode) != 0
              || !
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1654; /* lasx_xvadda_d */

        case E_V8SImode:
          if (pattern23 (x3, 
E_V8SImode) != 0
              || !
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1655; /* lasx_xvadda_w */

        case E_V16HImode:
          if (pattern23 (x3, 
E_V16HImode) != 0
              || !
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1656; /* lasx_xvadda_h */

        case E_V32QImode:
          if (pattern23 (x3, 
E_V32QImode) != 0
              || !
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1657; /* lasx_xvadda_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern164 (x3, 
E_SFmode) != 0
                  || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 45; /* fmasf4 */

            case E_DFmode:
              if (pattern164 (x3, 
E_DFmode) != 0
                  || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 46; /* fmadf4 */

            case E_V2DFmode:
              if (pattern164 (x3, 
E_V2DFmode) != 0
                  || !
#line 850 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1046; /* fmav2df4 */

            case E_V4SFmode:
              if (pattern164 (x3, 
E_V4SFmode) != 0
                  || !
#line 850 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1047; /* fmav4sf4 */

            case E_V4DFmode:
              if (pattern164 (x3, 
E_V4DFmode) != 0
                  || !
#line 991 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1648; /* fmav4df4 */

            case E_V8SFmode:
              if (pattern164 (x3, 
E_V8SFmode) != 0
                  || !
#line 991 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1649; /* fmav8sf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern165 (x3, 
E_SFmode) != 0
                  || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 47; /* fmssf4 */

            case E_DFmode:
              if (pattern165 (x3, 
E_DFmode) != 0
                  || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 48; /* fmsdf4 */

            case E_V2DFmode:
              if (pattern165 (x3, 
E_V2DFmode) != 0
                  || !
#line 2376 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1406; /* fmsv2df4 */

            case E_V4SFmode:
              if (pattern165 (x3, 
E_V4SFmode) != 0
                  || !
#line 2376 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1407; /* fmsv4sf4 */

            case E_V4DFmode:
              if (pattern165 (x3, 
E_V4DFmode) != 0
                  || !
#line 2786 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2020; /* fmsv4df4 */

            case E_V8SFmode:
              if (pattern165 (x3, 
E_V8SFmode) != 0
                  || !
#line 2786 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2021; /* fmsv8sf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern166 (x3, 
E_SFmode) != 0
                  || !(
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 49; /* fnmasf4 */

            case E_DFmode:
              if (pattern166 (x3, 
E_DFmode) != 0
                  || !(
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 50; /* fnmadf4 */

            case E_V2DFmode:
              if (pattern166 (x3, 
E_V2DFmode) != 0
                  || !
#line 860 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1048; /* fnmav2df4 */

            case E_V4SFmode:
              if (pattern166 (x3, 
E_V4SFmode) != 0
                  || !
#line 860 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1049; /* fnmav4sf4 */

            case E_V4DFmode:
              if (pattern166 (x3, 
E_V4DFmode) != 0
                  || !
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1650; /* fnmav4df4 */

            case E_V8SFmode:
              if (pattern166 (x3, 
E_V8SFmode) != 0
                  || !
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1651; /* fnmav8sf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern167 (x3, 
E_SFmode) != 0
                  || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 51; /* fnmssf4 */

            case E_DFmode:
              if (pattern167 (x3, 
E_DFmode) != 0
                  || !(
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 52; /* fnmsdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (XVECLEN (x3, 0))
        {
        case 1:
          res = recog_77 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_78 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_79 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 32:
          res = recog_80 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 16:
          res = recog_81 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x4;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      operands[2] = x3;
      if (!par_const_vector_shf_set_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1685 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1237; /* lsx_vshuf4i_w */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1685 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1238; /* lsx_vshuf4i_h */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1685 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1239; /* lsx_vshuf4i_b */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 1685 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1240; /* lsx_vshuf4i_w_f */

        default:
          return -1;
        }

    case VEC_CONCAT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      switch (XVECLEN (x3, 0))
        {
        case 16:
          res = recog_82 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_84 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_85 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 2:
          res = recog_86 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 32:
          if (pattern154 (x3) == 0)
            {
              res = recog_87 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          break;

        default:
          break;
        }
      operands[3] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern168 (x2, 
E_V4DImode, 
E_V2DImode) != 0
              || !
#line 1632 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(GET_MODE_SIZE (DImode) != 8))
            return -1;
          return 1219; /* lsx_pick_evod_v2di */

        case E_V4SImode:
          if (pattern168 (x2, 
E_V8SImode, 
E_V4SImode) != 0
              || !
#line 1632 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(GET_MODE_SIZE (SImode) != 8))
            return -1;
          return 1220; /* lsx_pick_evod_v4si */

        case E_V8HImode:
          if (pattern168 (x2, 
E_V16HImode, 
E_V8HImode) != 0
              || !
#line 1632 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(GET_MODE_SIZE (HImode) != 8))
            return -1;
          return 1221; /* lsx_pick_evod_v8hi */

        case E_V16QImode:
          if (pattern168 (x2, 
E_V32QImode, 
E_V16QImode) != 0
              || !
#line 1632 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(GET_MODE_SIZE (QImode) != 8))
            return -1;
          return 1222; /* lsx_pick_evod_v16qi */

        case E_V2DFmode:
          if (pattern168 (x2, 
E_V4DFmode, 
E_V2DFmode) != 0
              || !
#line 1632 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(GET_MODE_SIZE (DFmode) != 8))
            return -1;
          return 1223; /* lsx_pick_evod_v2df */

        case E_V4SFmode:
          if (pattern168 (x2, 
E_V8SFmode, 
E_V4SFmode) != 0
              || !
#line 1632 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(GET_MODE_SIZE (SFmode) != 8))
            return -1;
          return 1224; /* lsx_pick_evod_v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1141; /* floatunsv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1142; /* floatunsv4siv4sf2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DImode)
          || !
#line 1241 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1745; /* floatunsv4div4df2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SImode)
          || !
#line 1241 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1746; /* floatunsv8siv8sf2 */

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 434; /* rbitsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 435; /* rbitdi */

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 437; /* rbitqi */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 3:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x5;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case UNSPEC:
              if (pattern106 (x6) != 0
                  || !register_operand (operands[0], E_DImode)
                  || !symbolic_off64_or_reg_operand (operands[1], E_DImode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_DImode)
                  || !
#line 2240 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_CMODEL_EXTREME))
                return -1;
              return 154; /* movdi_symbolic_off64 */

            case SET:
              x8 = XEXP (x6, 1);
              if (GET_CODE (x8) != UNSPEC_VOLATILE)
                return -1;
              x9 = XEXP (x6, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              switch (XVECLEN (x8, 0))
                {
                case 3:
                  if (XINT (x8, 1) != 41)
                    return -1;
                  x10 = XVECEXP (x8, 0, 0);
                  operands[2] = x10;
                  x11 = XVECEXP (x8, 0, 1);
                  operands[3] = x11;
                  x12 = XVECEXP (x8, 0, 2);
                  operands[4] = x12;
                  if (!const_int_operand (operands[4], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 0);
                  operands[5] = x7;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern215 (x8, 
E_SImode) != 0)
                        return -1;
                      return 521; /* atomic_cas_value_strongsi */

                    case E_DImode:
                      if (pattern215 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 522; /* atomic_cas_value_strongdi */

                    default:
                      return -1;
                    }

                case 5:
                  x10 = XVECEXP (x8, 0, 0);
                  operands[2] = x10;
                  x11 = XVECEXP (x8, 0, 1);
                  operands[3] = x11;
                  x12 = XVECEXP (x8, 0, 2);
                  operands[4] = x12;
                  x13 = XVECEXP (x8, 0, 3);
                  operands[5] = x13;
                  x14 = XVECEXP (x8, 0, 4);
                  operands[6] = x14;
                  if (!const_int_operand (operands[6], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 0);
                  operands[7] = x7;
                  switch (XINT (x8, 1))
                    {
                    case 41:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern217 (x8, 
E_SImode) != 0)
                            return -1;
                          return 527; /* atomic_cas_value_cmp_and_7_si */

                        case E_DImode:
                          if (pattern217 (x8, 
E_DImode) != 0
                              || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 528; /* atomic_cas_value_cmp_and_7_di */

                        default:
                          return -1;
                        }

                    case 49:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern217 (x8, 
E_SImode) != 0)
                            return -1;
                          return 541; /* atomic_cas_value_exchange_7_si */

                        case E_DImode:
                          if (pattern217 (x8, 
E_DImode) != 0
                              || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 542; /* atomic_cas_value_exchange_7_di */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CALL:
          x15 = XEXP (x5, 0);
          if (GET_CODE (x15) != MEM)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != CALL)
            return -1;
          x16 = XEXP (x8, 0);
          if (GET_CODE (x16) != MEM)
            return -1;
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 1
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x6, 0);
          if (!register_operand (x9, E_VOIDmode))
            return -1;
          x17 = XEXP (x15, 0);
          switch (GET_CODE (x17))
            {
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
              operands[1] = x17;
              if (!call_insn_operand (operands[1], E_VOIDmode)
                  || GET_MODE (x15) != E_SImode)
                return -1;
              x18 = XEXP (x5, 1);
              operands[2] = x18;
              operands[3] = x9;
              if (GET_MODE (x16) != E_SImode)
                return -1;
              x19 = XEXP (x16, 0);
              if (!rtx_equal_p (x19, operands[1]))
                return -1;
              x20 = XEXP (x8, 1);
              if (!rtx_equal_p (x20, operands[2]))
                return -1;
              return 369; /* call_value_multiple_internal */

            case UNSPEC:
              if (XVECLEN (x17, 0) != 2
                  || XINT (x17, 1) != 37)
                return -1;
              x19 = XEXP (x16, 0);
              if (GET_CODE (x19) != UNSPEC
                  || XVECLEN (x19, 0) != 2
                  || XINT (x19, 1) != 37)
                return -1;
              x21 = XVECEXP (x17, 0, 0);
              operands[1] = x21;
              x22 = XVECEXP (x17, 0, 1);
              operands[2] = x22;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              operands[4] = x9;
              x23 = XVECEXP (x19, 0, 0);
              if (!rtx_equal_p (x23, operands[1]))
                return -1;
              x24 = XVECEXP (x19, 0, 1);
              if (!rtx_equal_p (x24, operands[2]))
                return -1;
              x20 = XEXP (x8, 1);
              if (!rtx_equal_p (x20, operands[3]))
                return -1;
              switch (GET_MODE (x15))
                {
                case E_SImode:
                  if (pattern220 (x1, 
E_SImode) != 0
                      || !(
#line 4114 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  return 370; /* call_value_multiple_internal_1si */

                case E_DImode:
                  if (pattern220 (x1, 
E_DImode) != 0
                      || !(
#line 4114 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  return 371; /* call_value_multiple_internal_1di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case SET:
          return recog_133 (x1, insn, pnum_clobbers);

        case UNSPEC_VOLATILE:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern19 (x6) != 0)
            return -1;
          switch (XVECLEN (x2, 0))
            {
            case 1:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              x25 = XVECEXP (x2, 0, 0);
              operands[0] = x25;
              if (!const_uimm15_operand (operands[0], E_VOIDmode))
                return -1;
              switch (XINT (x2, 1))
                {
                case 2:
                  return 215; /* loongarch_ibar */

                case 1:
                  return 216; /* loongarch_dbar */

                case 18:
                  return 218; /* loongarch_syscall */

                case 19:
                  return 219; /* loongarch_break */

                default:
                  return -1;
                }

            case 2:
              x25 = XVECEXP (x2, 0, 0);
              operands[0] = x25;
              x26 = XVECEXP (x2, 0, 1);
              operands[1] = x26;
              switch (XINT (x2, 1))
                {
                case 7:
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_QImode:
                      if (!register_operand (operands[0], E_QImode))
                        return -1;
                      return 232; /* loongarch_iocsrwr_b */

                    case E_HImode:
                      if (!register_operand (operands[0], E_HImode))
                        return -1;
                      return 233; /* loongarch_iocsrwr_h */

                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      return 234; /* loongarch_iocsrwr_w */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 235; /* loongarch_iocsrwr_d */

                    default:
                      return -1;
                    }

                case 10:
                  if (!const_uimm5_operand (operands[1], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode)
                          || !
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                        return -1;
                      return 240; /* loongarch_ldpte_w */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 241; /* loongarch_ldpte_d */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 3:
              x25 = XVECEXP (x2, 0, 0);
              operands[0] = x25;
              x26 = XVECEXP (x2, 0, 1);
              operands[1] = x26;
              x27 = XVECEXP (x2, 0, 2);
              operands[2] = x27;
              switch (XINT (x2, 1))
                {
                case 8:
                  if (!const_uimm5_operand (operands[0], E_VOIDmode)
                      || !const_imm12_operand (operands[2], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_SImode:
                      if (!register_operand (operands[1], E_SImode)
                          || !
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                        return -1;
                      return 236; /* loongarch_cacop_w */

                    case E_DImode:
                      if (!register_operand (operands[1], E_DImode)
                          || !
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 237; /* loongarch_cacop_d */

                    default:
                      return -1;
                    }

                case 9:
                  if (!const_uimm5_operand (operands[2], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (x2))
                    {
                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode)
                          || !register_operand (operands[1], E_SImode)
                          || !
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                        return -1;
                      return 238; /* loongarch_lddir_w */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !register_operand (operands[1], E_DImode)
                          || !
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 239; /* loongarch_lddir_d */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case RETURN:
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case USE:
              x9 = XEXP (x6, 0);
              operands[0] = x9;
              if (!pmode_register_operand (operands[0], E_VOIDmode))
                return -1;
              return 348; /* return_internal */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x6, 0) != 1
                  || XINT (x6, 1) != 11)
                return -1;
              x28 = XVECEXP (x6, 0, 0);
              if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 350; /* loongarch_ertn */

            default:
              return -1;
            }

        case SIMPLE_RETURN:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x9 = XEXP (x6, 0);
          operands[0] = x9;
          if (!pmode_register_operand (operands[0], E_VOIDmode))
            return -1;
          return 349; /* simple_return_internal */

        case UNSPEC:
          if (XVECLEN (x2, 0) != 1
              || XINT (x2, 1) != 14)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x25 = XVECEXP (x2, 0, 0);
          operands[0] = x25;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !scratch_operand (operands[1], E_SImode)
                  || !
#line 3717 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(! TARGET_64BIT))
                return -1;
              return 352; /* eh_set_ra_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !scratch_operand (operands[1], E_DImode)
                  || !
#line 3723 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 353; /* eh_set_ra_di */

            default:
              return -1;
            }

        case CALL:
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern99 (x6) != 0)
            return -1;
          x29 = XEXP (x4, 0);
          switch (GET_CODE (x29))
            {
            case CONST:
            case REG:
            case SUBREG:
            case LABEL_REF:
            case SYMBOL_REF:
              operands[0] = x29;
              if (!call_insn_operand (operands[0], E_VOIDmode)
                  || GET_MODE (x4) != E_SImode)
                return -1;
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              return 363; /* call_internal */

            case LO_SUM:
              x30 = XEXP (x29, 0);
              operands[0] = x30;
              x31 = XEXP (x29, 1);
              operands[1] = x31;
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              switch (GET_MODE (x4))
                {
                case E_SImode:
                  if (GET_MODE (x29) != E_SImode
                      || !register_operand (operands[0], E_SImode)
                      || !symbolic_operand (operands[1], E_SImode)
                      || !(
#line 3990 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  return 364; /* call_internal_1si */

                case E_DImode:
                  if (GET_MODE (x29) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || !symbolic_operand (operands[1], E_DImode)
                      || !(
#line 3990 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  return 365; /* call_internal_1di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 10:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 18)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 4
          || pattern155 (x1) != 0)
        return -1;
      x32 = XVECEXP (x5, 0, 0);
      operands[0] = x32;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !symbolic_operand (operands[0], E_SImode)
              || !(
#line 2748 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
            return -1;
          return 210; /* got_load_tls_descsi */

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !symbolic_operand (operands[0], E_DImode)
              || !(
#line 2748 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
            return -1;
          return 211; /* got_load_tls_descdi */

        default:
          return -1;
        }

    case 11:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 19
          || GET_MODE (x5) != E_DImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 4
          || GET_MODE (x4) != E_DImode
          || pattern155 (x1) != 0)
        return -1;
      x33 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x33) != CLOBBER)
        return -1;
      x32 = XVECEXP (x5, 0, 0);
      operands[0] = x32;
      if (!symbolic_operand (operands[0], E_DImode))
        return -1;
      x34 = XEXP (x33, 0);
      operands[1] = x34;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_TLS_DESC && TARGET_CMODEL_EXTREME))
        return -1;
      return 212; /* got_load_tls_desc_off64 */

    case 4:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != UNSPEC_VOLATILE
          || XVECLEN (x8, 0) != 5)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x35 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x35) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x10 = XVECEXP (x8, 0, 0);
      operands[2] = x10;
      x11 = XVECEXP (x8, 0, 1);
      operands[3] = x11;
      x12 = XVECEXP (x8, 0, 2);
      operands[4] = x12;
      x13 = XVECEXP (x8, 0, 3);
      operands[5] = x13;
      x14 = XVECEXP (x8, 0, 4);
      operands[6] = x14;
      if (!const_int_operand (operands[6], E_SImode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[7] = x7;
      x36 = XEXP (x35, 0);
      operands[8] = x36;
      x9 = XEXP (x6, 0);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (XINT (x8, 1))
        {
        case 42:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 529; /* atomic_cas_value_add_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 530; /* atomic_cas_value_add_7_di */

            default:
              return -1;
            }

        case 43:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 531; /* atomic_cas_value_sub_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 532; /* atomic_cas_value_sub_7_di */

            default:
              return -1;
            }

        case 44:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 533; /* atomic_cas_value_and_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 534; /* atomic_cas_value_and_7_di */

            default:
              return -1;
            }

        case 45:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 535; /* atomic_cas_value_xor_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 536; /* atomic_cas_value_xor_7_di */

            default:
              return -1;
            }

        case 46:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 537; /* atomic_cas_value_or_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 538; /* atomic_cas_value_or_7_di */

            default:
              return -1;
            }

        case 47:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern219 (x8, 
E_SImode) != 0)
                return -1;
              return 539; /* atomic_cas_value_nand_7_si */

            case E_DImode:
              if (pattern219 (x8, 
E_DImode) != 0
                  || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 540; /* atomic_cas_value_nand_7_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
