/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern2 (x3, 
E_V2DImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern2 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V8HImode:
      if (pattern2 (x3, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V16QImode:
      if (pattern2 (x3, 
E_V16QImode) != 0)
        return -1;
      return 7;

    case E_V4DFmode:
      if (pattern0 (x3, 
E_V4DFmode) != 0)
        return -1;
      return 8;

    case E_V8SFmode:
      if (pattern0 (x3, 
E_V8SFmode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern2 (x3, 
E_V4DImode) != 0)
        return -1;
      return 10;

    case E_V8SImode:
      if (pattern2 (x3, 
E_V8SImode) != 0)
        return -1;
      return 11;

    case E_V16HImode:
      if (pattern2 (x3, 
E_V16HImode) != 0)
        return -1;
      return 12;

    case E_V32QImode:
      if (pattern2 (x3, 
E_V32QImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SIGN_EXTEND)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern27 (x1, 
E_V2DImode, 
E_V1DImode, 
E_V1TImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern27 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern27 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern27 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2TImode:
      if (pattern27 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V2TImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern27 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8SImode:
      if (pattern27 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 6;

    case E_V16HImode:
      if (pattern27 (x1, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!reg_or_0_operand (operands[2], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_uimm6_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const_uimm3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      return pattern64 (x3, 
E_V4DImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern68 (x3, 
E_V8SImode, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V16HImode:
      if (pattern69 (x3, 
E_V16HImode, 
E_V16HImode) != 0)
        return -1;
      return 2;

    case E_V32QImode:
      if (pattern66 (x3, 
E_V32QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern86 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 2;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode))
        return -1;
      return 3;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode))
        return -1;
      return 4;

    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern97 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern111 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !arith_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !plus_di_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_val_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (REGNO (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != XOR
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  return pattern137 (x2); /* [-1, 2] */
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1TImode:
      return pattern27 (x1, 
E_V2DImode, 
E_V1DImode, 
E_V1TImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern27 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern27 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern27 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2TImode:
      if (pattern27 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V2TImode) != 0)
        return -1;
      return 4;

    case E_V4DImode:
      if (pattern27 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 5;

    case E_V8SImode:
      if (pattern27 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 6;

    case E_V16HImode:
      if (pattern27 (x1, 
E_V32QImode, 
E_V16QImode, 
E_V16HImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode
      || !aq12h_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern194 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !const_vector_same_val_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!const_0_operand (operands[2], E_SImode))
    return -1;
  switch (XINT (x2, 1))
    {
    case 77:
      return pattern201 (); /* [-1, 5] */

    case 76:
      res = pattern201 ();
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    case 184:
      res = pattern202 ();
      if (res >= 0)
        return res + 12; /* [12, 17] */
      return -1;

    case 185:
      res = pattern202 ();
      if (res >= 0)
        return res + 18; /* [18, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (XWINT (x2, 0) != 6L)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (XWINT (x3, 0) != 14L)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (XWINT (x4, 0) != 7L)
    return -1;
  x5 = XVECEXP (x1, 0, 7);
  if (XWINT (x5, 0) != 15L)
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (pattern110 (x3))
    {
    case 0:
      if (!
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1394; /* lsx_vmskltz_d */

    case 1:
      if (!
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1395; /* lsx_vmskltz_w */

    case 2:
      if (!
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1396; /* lsx_vmskltz_h */

    case 3:
      if (!
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1397; /* lsx_vmskltz_b */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_uimm5_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2247 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1380; /* lsx_vbsrl_d */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 2247 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1381; /* lsx_vbsrl_w */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 2247 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1382; /* lsx_vbsrl_h */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 2247 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1383; /* lsx_vbsrl_b */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 2247 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1384; /* lsx_vbsrl_d_f */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2247 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1385; /* lsx_vbsrl_w_f */

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_lsx_branch_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern110 (x3))
    {
    case 0:
      if (!
#line 1006 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1100; /* lsx_vbitrevi_d */

    case 1:
      if (!
#line 1006 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1101; /* lsx_vbitrevi_w */

    case 2:
      if (!
#line 1006 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1102; /* lsx_vbitrevi_h */

    case 3:
      if (!
#line 1006 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1103; /* lsx_vbitrevi_b */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DFmode:
      if (pattern61 (x3, 
E_DFmode, 
E_V4DFmode) != 0
          || !
#line 1278 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1753; /* lasx_xvilvl_d_f_internal */

    case E_V8SFmode:
      if (pattern61 (x3, 
E_SFmode, 
E_V8SFmode) != 0
          || !
#line 1278 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1754; /* lasx_xvilvl_w_f_internal */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1086 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1678; /* lasx_xvavg_u_du */

    case 1:
      if (!
#line 1086 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1679; /* lasx_xvavg_u_wu */

    case 2:
      if (!
#line 1086 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1680; /* lasx_xvavg_u_hu */

    case 3:
      if (!
#line 1086 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1681; /* lasx_xvavg_u_bu */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (pattern61 (x3, 
E_DFmode, 
E_V2DFmode) != 0
          || !
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1149; /* lsx_vilvl_d_f_internal */

    case E_V4SFmode:
      if (pattern61 (x3, 
E_SFmode, 
E_V4SFmode) != 0
          || !
#line 1167 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1150; /* lsx_vilvl_w_f_internal */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 754; /* lsx_vfcmp_sune_d */

    case 1:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 762; /* lsx_vfcmp_sune_s */

    case 2:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 770; /* lasx_xvfcmp_sune_d */

    case 3:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 778; /* lasx_xvfcmp_sune_s */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern87 (x1, pnum_clobbers))
    {
    case 0:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern189 (x3, 
E_SImode))
            {
            case 0:
              if (!(
#line 2518 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
                return -1;
              return 166; /* *seleqsi_using_si */

            case 1:
              if (!(
#line 2518 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 170; /* *seleqsi_using_di */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern189 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 2518 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && ((((
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))))
                return -1;
              return 168; /* *seleqdi_using_si */

            case 1:
              if (!(
#line 2518 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 172; /* *seleqdi_using_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1288; /* lsx_bz_d */

    case 2:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1290; /* lsx_bz_w */

    case 3:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1292; /* lsx_bz_h */

    case 4:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1294; /* lsx_bz_b */

    case 5:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1296; /* lsx_bz_d_f */

    case 6:
      if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1298; /* lsx_bz_w_f */

    case 7:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1300; /* lsx_bz_v_d */

    case 8:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1302; /* lsx_bz_v_w */

    case 9:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1304; /* lsx_bz_v_h */

    case 10:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1306; /* lsx_bz_v_b */

    case 11:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1308; /* lsx_bz_v_d_f */

    case 12:
      if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      *pnum_clobbers = 1;
      return 1310; /* lsx_bz_v_w_f */

    case 13:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1899; /* lasx_xbz_d */

    case 14:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1901; /* lasx_xbz_w */

    case 15:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1903; /* lasx_xbz_h */

    case 16:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1905; /* lasx_xbz_b */

    case 17:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1907; /* lasx_xbz_d_f */

    case 18:
      if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1909; /* lasx_xbz_w_f */

    case 19:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1911; /* lasx_xbz_v_d */

    case 20:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1913; /* lasx_xbz_v_w */

    case 21:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1915; /* lasx_xbz_v_h */

    case 22:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1917; /* lasx_xbz_v_b */

    case 23:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1919; /* lasx_xbz_v_d_f */

    case 24:
      if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      *pnum_clobbers = 1;
      return 1921; /* lasx_xbz_v_w_f */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 1L:
      if (XWINT (x5, 0) != 3L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern205 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 1404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1179; /* lsx_vilvh_d */

        case E_V2DFmode:
          if (pattern205 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 1404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1180; /* lsx_vilvh_d_f */

        default:
          return -1;
        }

    case 0L:
      if (XWINT (x5, 0) != 2L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern205 (x2, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 1536 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1189; /* lsx_vilvl_d */

        case E_V2DFmode:
          if (pattern205 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1190; /* lsx_vilvl_d_f */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_DImode)
              && 
#line 1141 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1143; /* lsx_vreplgr2vr_d */
          if (!register_operand (operands[1], E_DImode)
              || !
#line 1774 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1275; /* lsx_vreplvei_d_scalar */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_SImode)
              && 
#line 1141 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1144; /* lsx_vreplgr2vr_w */
          if (!register_operand (operands[1], E_SImode)
              || !
#line 1774 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1276; /* lsx_vreplvei_w_scalar */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_HImode)
              && 
#line 1141 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1145; /* lsx_vreplgr2vr_h */
          if (!register_operand (operands[1], E_HImode)
              || !
#line 1774 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1277; /* lsx_vreplvei_h_scalar */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode)
            return -1;
          if (reg_or_0_operand (operands[1], E_QImode)
              && 
#line 1141 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return 1146; /* lsx_vreplgr2vr_b */
          if (!register_operand (operands[1], E_QImode)
              || !
#line 1774 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1278; /* lsx_vreplvei_b_scalar */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 1774 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1279; /* lsx_vreplvei_d_f_scalar */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 1774 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1280; /* lsx_vreplvei_w_f_scalar */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode
              || !reg_or_0_operand (operands[1], E_DImode)
              || !
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1747; /* lasx_xvreplgr2vr_d */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode
              || !reg_or_0_operand (operands[1], E_SImode)
              || !
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1748; /* lasx_xvreplgr2vr_w */

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !reg_or_0_operand (operands[1], E_HImode)
              || !
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1749; /* lasx_xvreplgr2vr_h */

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x3) != E_V32QImode
              || !reg_or_0_operand (operands[1], E_QImode)
              || !
#line 1251 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1750; /* lasx_xvreplgr2vr_b */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 2174 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1887; /* lasx_xvreplve0_d_f_scalar */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 2174 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1888; /* lasx_xvreplve0_w_f_scalar */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern182 (x3, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 1744 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1257; /* lsx_vreplve_d */

            case E_V4SImode:
              if (pattern182 (x3, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1258; /* lsx_vreplve_w */

            case E_V8HImode:
              if (pattern182 (x3, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1259; /* lsx_vreplve_h */

            case E_V16QImode:
              if (pattern182 (x3, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 1744 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1260; /* lsx_vreplve_b */

            case E_V2DFmode:
              if (pattern182 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 1744 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1261; /* lsx_vreplve_d_f */

            case E_V4SFmode:
              if (pattern182 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 1744 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1262; /* lsx_vreplve_w_f */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern180 (x3, 
E_V2DImode, 
E_DImode) == 0
                  && 
#line 1765 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1269; /* lsx_vreplvei_d */
              break;

            case E_V4SImode:
              if (pattern181 (x3, 
E_V4SImode, 
E_SImode) == 0
                  && 
#line 1765 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1270; /* lsx_vreplvei_w */
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x3) == E_V8HImode
                  && GET_MODE (x4) == E_HImode
                  && register_operand (operands[1], E_V8HImode)
                  && const_uimm3_operand (operands[2], E_VOIDmode)
                  && 
#line 1765 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1271; /* lsx_vreplvei_h */
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x3) == E_V16QImode
                  && GET_MODE (x4) == E_QImode
                  && register_operand (operands[1], E_V16QImode)
                  && const_uimm4_operand (operands[2], E_VOIDmode)
                  && 
#line 1765 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1272; /* lsx_vreplvei_b */
              break;

            case E_V2DFmode:
              if (pattern180 (x3, 
E_V2DFmode, 
E_DFmode) == 0
                  && 
#line 1765 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1273; /* lsx_vreplvei_d_f */
              break;

            case E_V4SFmode:
              if (pattern181 (x3, 
E_V4SFmode, 
E_SFmode) == 0
                  && 
#line 1765 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return 1274; /* lsx_vreplvei_w_f */
              break;

            default:
              break;
            }
          if (XWINT (x7, 0) != 0L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4DImode:
              if (pattern182 (x3, 
E_V4DImode, 
E_DImode) != 0
                  || !
#line 2091 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1871; /* lasx_xvreplve0_d */

            case E_V8SImode:
              if (pattern182 (x3, 
E_V8SImode, 
E_SImode) != 0
                  || !
#line 2091 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1872; /* lasx_xvreplve0_w */

            case E_V16HImode:
              if (pattern182 (x3, 
E_V16HImode, 
E_HImode) != 0
                  || !
#line 2091 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1873; /* lasx_xvreplve0_h */

            case E_V32QImode:
              if (pattern182 (x3, 
E_V32QImode, 
E_QImode) != 0
                  || !
#line 2091 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1874; /* lasx_xvreplve0_b */

            case E_V4DFmode:
              if (pattern182 (x3, 
E_V4DFmode, 
E_DFmode) != 0
                  || !
#line 2091 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1875; /* lasx_xvreplve0_d_f */

            case E_V8SFmode:
              if (pattern182 (x3, 
E_V8SFmode, 
E_SFmode) != 0
                  || !
#line 2091 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1876; /* lasx_xvreplve0_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MEM:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case PLUS:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern183 (x3, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1430; /* lsx_vldrepl_d_insn */

            case E_V4SImode:
              if (pattern184 (x3, 
E_SImode, 
E_V4SImode) != 0
                  || !
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1431; /* lsx_vldrepl_w_insn */

            case E_V8HImode:
              if (pattern185 (x3, 
E_V8HImode) != 0
                  || !
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1432; /* lsx_vldrepl_h_insn */

            case E_V16QImode:
              if (pattern186 (x3, 
E_V16QImode) != 0
                  || !
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1433; /* lsx_vldrepl_b_insn */

            case E_V2DFmode:
              if (pattern183 (x3, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1434; /* lsx_vldrepl_d_f_insn */

            case E_V4SFmode:
              if (pattern184 (x3, 
E_SFmode, 
E_V4SFmode) != 0
                  || !
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1435; /* lsx_vldrepl_w_f_insn */

            case E_V4DImode:
              if (pattern183 (x3, 
E_DImode, 
E_V4DImode) != 0
                  || !
#line 3075 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2044; /* lasx_xvldrepl_d_insn */

            case E_V8SImode:
              if (pattern184 (x3, 
E_SImode, 
E_V8SImode) != 0
                  || !
#line 3075 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2045; /* lasx_xvldrepl_w_insn */

            case E_V16HImode:
              if (pattern185 (x3, 
E_V16HImode) != 0
                  || !
#line 3075 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2046; /* lasx_xvldrepl_h_insn */

            case E_V32QImode:
              if (pattern186 (x3, 
E_V32QImode) != 0
                  || !
#line 3075 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2047; /* lasx_xvldrepl_b_insn */

            case E_V4DFmode:
              if (pattern183 (x3, 
E_DFmode, 
E_V4DFmode) != 0
                  || !
#line 3075 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2048; /* lasx_xvldrepl_d_f_insn */

            case E_V8SFmode:
              if (pattern184 (x3, 
E_SFmode, 
E_V8SFmode) != 0
                  || !
#line 3075 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2049; /* lasx_xvldrepl_w_f_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x3) != E_V2DImode
                  || GET_MODE (x4) != E_DImode
                  || !
#line 2611 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1436; /* lsx_vldrepl_d_insn_0 */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || GET_MODE (x4) != E_SImode
                  || !
#line 2611 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1437; /* lsx_vldrepl_w_insn_0 */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || GET_MODE (x4) != E_HImode
                  || !
#line 2611 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1438; /* lsx_vldrepl_h_insn_0 */

            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x3) != E_V16QImode
                  || GET_MODE (x4) != E_QImode
                  || !
#line 2611 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1439; /* lsx_vldrepl_b_insn_0 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || GET_MODE (x4) != E_DFmode
                  || !
#line 2611 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1440; /* lsx_vldrepl_d_f_insn_0 */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || GET_MODE (x4) != E_SFmode
                  || !
#line 2611 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1441; /* lsx_vldrepl_w_f_insn_0 */

            case E_V4DImode:
              if (!register_operand (operands[0], E_V4DImode)
                  || GET_MODE (x3) != E_V4DImode
                  || GET_MODE (x4) != E_DImode
                  || !
#line 3088 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2050; /* lasx_xvldrepl_d_insn_0 */

            case E_V8SImode:
              if (!register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x3) != E_V8SImode
                  || GET_MODE (x4) != E_SImode
                  || !
#line 3088 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2051; /* lasx_xvldrepl_w_insn_0 */

            case E_V16HImode:
              if (!register_operand (operands[0], E_V16HImode)
                  || GET_MODE (x3) != E_V16HImode
                  || GET_MODE (x4) != E_HImode
                  || !
#line 3088 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2052; /* lasx_xvldrepl_h_insn_0 */

            case E_V32QImode:
              if (!register_operand (operands[0], E_V32QImode)
                  || GET_MODE (x3) != E_V32QImode
                  || GET_MODE (x4) != E_QImode
                  || !
#line 3088 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2053; /* lasx_xvldrepl_b_insn_0 */

            case E_V4DFmode:
              if (!register_operand (operands[0], E_V4DFmode)
                  || GET_MODE (x3) != E_V4DFmode
                  || GET_MODE (x4) != E_DFmode
                  || !
#line 3088 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2054; /* lasx_xvldrepl_d_f_insn_0 */

            case E_V8SFmode:
              if (!register_operand (operands[0], E_V8SFmode)
                  || GET_MODE (x3) != E_V8SFmode
                  || GET_MODE (x4) != E_SFmode
                  || !
#line 3088 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 2055; /* lasx_xvldrepl_w_f_insn_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern112 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 140; /* fix_truncsfsi2 */

            case 1:
              if (!
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 142; /* fix_truncdfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern112 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 141; /* fix_truncsfdi2 */

            case 1:
              if (!(
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 143; /* fix_truncdfdi2 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 599; /* fix_truncv2dfv2di2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 600; /* fix_truncv4sfv4si2 */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode
              || !register_operand (operands[1], E_V4DFmode)
              || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 601; /* fix_truncv4dfv4di2 */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode
              || !register_operand (operands[1], E_V8SFmode)
              || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 602; /* fix_truncv8sfv8si2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      switch (XINT (x4, 1))
        {
        case 53:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 579; /* lsx_vftintrp_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 584; /* lsx_vftintrp_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 589; /* lasx_xvftintrp_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 594; /* lasx_xvftintrp_w_s */

            default:
              return -1;
            }

        case 54:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 580; /* lsx_vftintrz_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 585; /* lsx_vftintrz_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 590; /* lasx_xvftintrz_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 595; /* lasx_xvftintrz_w_s */

            default:
              return -1;
            }

        case 55:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 581; /* lsx_vftint_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 586; /* lsx_vftint_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 591; /* lasx_xvftint_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 596; /* lasx_xvftint_w_s */

            default:
              return -1;
            }

        case 56:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 582; /* lsx_vftintrm_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 587; /* lsx_vftintrm_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 592; /* lasx_xvftintrm_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 597; /* lasx_xvftintrm_w_s */

            default:
              return -1;
            }

        case 57:
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern150 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 583; /* lsx_vftintrne_l_d */

            case E_V4SImode:
              if (pattern150 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 588; /* lsx_vftintrne_w_s */

            case E_V4DImode:
              if (pattern150 (x3, 
E_V4DFmode, 
E_V4DImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 593; /* lasx_xvftintrne_l_d */

            case E_V8SImode:
              if (pattern150 (x3, 
E_V8SFmode, 
E_V8SImode) != 0
                  || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 598; /* lasx_xvftintrne_w_s */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern93 (x3, 
E_V4SFmode, 
E_V2DImode, 
E_V2SFmode))
        {
        case 0:
          if (!
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1422; /* vec_unpack_sfix_trunc_hi_v4sf */

        case 1:
          if (!
#line 2523 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1423; /* vec_unpack_sfix_trunc_lo_v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern153 (x3, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 302 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 935; /* vec_pack_trunc_v2di */

        case E_V8HImode:
          if (pattern153 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 302 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 936; /* vec_pack_trunc_v4si */

        case E_V16QImode:
          if (pattern153 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 302 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 937; /* vec_pack_trunc_v8hi */

        case E_V8SImode:
          if (pattern153 (x3, 
E_V4DImode, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 400 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1531; /* vec_pack_trunc_v4di */

        case E_V16HImode:
          if (pattern153 (x3, 
E_V8SImode, 
E_V8HImode, 
E_V16HImode) != 0
              || !
#line 400 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1532; /* vec_pack_trunc_v8si */

        case E_V32QImode:
          if (pattern153 (x3, 
E_V16HImode, 
E_V16QImode, 
E_V32QImode) != 0
              || !
#line 400 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1533; /* vec_pack_trunc_v16hi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != FLOAT_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern153 (x3, 
E_V2DFmode, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !
#line 1804 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1283; /* vec_pack_trunc_v2df */

        case E_V8SFmode:
          if (pattern153 (x3, 
E_V4DFmode, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 2213 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1892; /* vec_pack_trunc_v4df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern12 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 1926 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1312; /* vec_concatv2df */

        case E_V4DImode:
          if (pattern12 (x3, 
E_V2DImode, 
E_V4DImode) != 0
              || !
#line 467 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1536; /* vec_concatv4di */

        case E_V8SImode:
          if (pattern12 (x3, 
E_V4SImode, 
E_V8SImode) != 0
              || !
#line 467 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1537; /* vec_concatv8si */

        case E_V16HImode:
          if (pattern12 (x3, 
E_V8HImode, 
E_V16HImode) != 0
              || !
#line 467 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1538; /* vec_concatv16hi */

        case E_V32QImode:
          if (pattern12 (x3, 
E_V16QImode, 
E_V32QImode) != 0
              || !
#line 467 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1539; /* vec_concatv32qi */

        case E_V4DFmode:
          if (pattern12 (x3, 
E_V2DFmode, 
E_V4DFmode) != 0
              || !
#line 467 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1540; /* vec_concatv4df */

        case E_V8SFmode:
          if (pattern12 (x3, 
E_V4SFmode, 
E_V8SFmode) != 0
              || !
#line 467 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1541; /* vec_concatv8sf */

        default:
          return -1;
        }

    case VEC_CONCAT:
      if (pattern94 (x3) != 0
          || !
#line 1949 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1313; /* vec_concatv4sf */

    case FLOAT:
      if (pattern95 (x3, 
E_V2DImode, 
E_V4SFmode, 
E_V2SFmode, 
FLOAT) != 0
          || !
#line 2421 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1413; /* vec_packs_float_v2di */

    case FIX:
      if (pattern95 (x3, 
E_V2DFmode, 
E_V4SImode, 
E_V2SImode, 
FIX) != 0
          || !
#line 2431 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1414; /* vec_pack_sfix_trunc_v2df */

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern116 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 297; /* *slt_sisi */

        case 1:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 299; /* *slt_disi */

        default:
          return -1;
        }

    case E_DImode:
      if (pattern4 (x3, 
E_DImode) != 0
          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 301; /* *slt_didi */

    case E_FCCmode:
      switch (pattern11 (x3))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 314; /* slt_sf_using_FCCmode */

        case 1:
          if (!
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 328; /* slt_df_using_FCCmode */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern117 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 664; /* lsx_vfcmp_slt_d */

        case 1:
          if (!
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1120; /* lsx_vslt_d */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern118 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 674; /* lsx_vfcmp_slt_s */

        case 1:
          if (!
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1125; /* lsx_vslt_w */

        default:
          return -1;
        }

    case E_V4DImode:
      switch (pattern119 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 684; /* lasx_xvfcmp_slt_d */

        case 1:
          if (!
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1724; /* lasx_xvslt_d */

        default:
          return -1;
        }

    case E_V8SImode:
      switch (pattern120 (x3))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 694; /* lasx_xvfcmp_slt_s */

        case 1:
          if (!
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1729; /* lasx_xvslt_w */

        default:
          return -1;
        }

    case E_V8HImode:
      if (pattern2 (x3, 
E_V8HImode) != 0
          || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1130; /* lsx_vslt_h */

    case E_V16QImode:
      if (pattern2 (x3, 
E_V16QImode) != 0
          || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1135; /* lsx_vslt_b */

    case E_V16HImode:
      if (pattern2 (x3, 
E_V16HImode) != 0
          || !
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1734; /* lasx_xvslt_h */

    case E_V32QImode:
      if (pattern2 (x3, 
E_V32QImode) != 0
          || !
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1739; /* lasx_xvslt_b */

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern3 (x1))
    {
    case 0:
      if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 79; /* smaxsf3 */

    case 1:
      if (!
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 80; /* smaxdf3 */

    case 2:
      if (!
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1151; /* smaxv2df3 */

    case 3:
      if (!
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1152; /* smaxv4sf3 */

    case 4:
      if (!
#line 1557 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1191; /* smaxv2di3 */

    case 5:
      if (!
#line 1557 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1192; /* smaxv4si3 */

    case 6:
      if (!
#line 1557 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1193; /* smaxv8hi3 */

    case 7:
      if (!
#line 1557 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1194; /* smaxv16qi3 */

    case 8:
      if (!
#line 1287 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1755; /* smaxv4df3 */

    case 9:
      if (!
#line 1287 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1756; /* smaxv8sf3 */

    case 10:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1795; /* smaxv4di3 */

    case 11:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1796; /* smaxv8si3 */

    case 12:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1797; /* smaxv16hi3 */

    case 13:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1798; /* smaxv32qi3 */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode))
            {
              if (peep2_current_count >= 3
                  && pattern174 (x3, 
E_SImode) == 0
                  && 
#line 1654 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(peep2_reg_dead_p (3, operands[0])))
                {
                  *pmatch_len_ = 2;
                  res = gen_peephole2_1 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (non_volatile_mem_operand (operands[1], E_SImode))
                {
                  x5 = XEXP (x3, 0);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_SImode))
                    {
                      x6 = XEXP (x3, 1);
                      operands[3] = x6;
                      if (non_volatile_mem_operand (operands[3], E_SImode)
                          && 
#line 4421 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SImode, true)))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_4 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          if (!memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 4434 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SImode, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_DImode:
          if (peep2_current_count < 3
              || !register_operand (operands[0], E_DImode)
              || pattern174 (x3, 
E_DImode) != 0
              || !(
#line 1654 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(peep2_reg_dead_p (3, operands[0])) && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_2 (insn, operands);

        case E_HImode:
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (register_operand (operands[2], E_HImode)
              && register_operand (operands[0], E_HImode)
              && non_volatile_mem_operand (operands[1], E_HImode))
            {
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              if (non_volatile_mem_operand (operands[3], E_HImode)
                  && 
#line 4421 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_3 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_HImode)
              || !memory_operand (operands[0], E_HImode)
              || !register_operand (operands[1], E_HImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_HImode)
              || !
#line 4434 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_7 (insn, operands);

        case E_SFmode:
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_SFmode)
              && non_volatile_mem_operand (operands[1], E_SFmode))
            {
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              if (non_volatile_mem_operand (operands[3], E_SFmode)
                  && (
#line 4421 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SFmode, true)) && 
#line 381 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_5 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_SFmode)
              || !memory_operand (operands[0], E_SFmode)
              || !register_operand (operands[1], E_SFmode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_SFmode)
              || !(
#line 4434 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SFmode, false)) && 
#line 381 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_9 (insn, operands);

        case E_DFmode:
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (register_operand (operands[2], E_DFmode)
              && register_operand (operands[0], E_DFmode)
              && non_volatile_mem_operand (operands[1], E_DFmode))
            {
              x6 = XEXP (x3, 1);
              operands[3] = x6;
              if (non_volatile_mem_operand (operands[3], E_DFmode)
                  && (
#line 4421 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, DFmode, true)) && 
#line 382 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_6 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_DFmode)
              || !memory_operand (operands[0], E_DFmode)
              || !register_operand (operands[1], E_DFmode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_DFmode)
              || !(
#line 4434 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, DFmode, false)) && 
#line 382 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_10 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (pattern107 (x4, 
SIGN_EXTEND) != 0
          || !
#line 4466 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    case ZERO_EXTEND:
      if (pattern107 (x4, 
ZERO_EXTEND) != 0
          || !
#line 4466 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_12 (insn, operands);

    case VEC_DUPLICATE:
      if (GET_MODE (x4) != E_V2DImode
          || !register_operand (operands[0], E_V2DImode))
        return NULL;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_MERGE
          || GET_MODE (x6) != E_V2DImode)
        return NULL;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != VEC_DUPLICATE
          || GET_MODE (x8) != E_V2DImode)
        return NULL;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2DImode))
        return NULL;
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!register_operand (operands[3], E_DImode))
        return NULL;
      x10 = XEXP (x6, 1);
      operands[4] = x10;
      if (!register_operand (operands[4], E_V2DImode))
        return NULL;
      x11 = XEXP (x6, 2);
      operands[5] = x11;
      if (!const_int_operand (operands[5], E_VOIDmode)
          || !
#line 3216 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(operands[0] == operands[2] &&
   operands[1] == operands[3] &&
   operands[2] == operands[4] &&
   INTVAL (operands[5]) == 2))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_13 (insn, operands);

    default:
      return NULL;
    }
}
