/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return pattern5 (x3); /* [-1, 9] */

    case PLUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern6 (x3, 
E_V2DImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern7 (x3, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V8HImode:
          if (pattern8 (x3, 
E_V8HImode) != 0)
            return -1;
          return 12;

        case E_V16QImode:
          if (pattern9 (x3, 
E_V16QImode) != 0)
            return -1;
          return 13;

        case E_V4DImode:
          if (pattern6 (x3, 
E_V4DImode) != 0)
            return -1;
          return 14;

        case E_V8SImode:
          if (pattern7 (x3, 
E_V8SImode) != 0)
            return -1;
          return 15;

        case E_V16HImode:
          if (pattern8 (x3, 
E_V16HImode) != 0)
            return -1;
          return 16;

        case E_V32QImode:
          if (pattern9 (x3, 
E_V32QImode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 1:
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode)
            return -1;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !const_uimm3_operand (operands[2], E_VOIDmode))
                return -1;
              return 0;

            case E_QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !const_uimm4_operand (operands[2], E_VOIDmode))
                return -1;
              return 1;

            case E_SImode:
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !const_0_to_3_operand (operands[2], E_VOIDmode))
                    return -1;
                  return 2;

                case E_V8SImode:
                  if (!register_operand (operands[1], E_V8SImode)
                      || !const_0_to_7_operand (operands[2], E_VOIDmode))
                    return -1;
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_SFmode:
          if (pattern36 (x1, 
E_V4SFmode, 
E_SFmode) != 0)
            return -1;
          return 4;

        case E_DImode:
          if (pattern36 (x1, 
E_V4DImode, 
E_DImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 8:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 8L:
          if (XWINT (x6, 0) != 9L
              || XWINT (x7, 0) != 10L
              || XWINT (x8, 0) != 11L
              || pattern38 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L
              || XWINT (x9, 0) != 4L
              || XWINT (x10, 0) != 5L
              || XWINT (x11, 0) != 6L
              || XWINT (x12, 0) != 7L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern37 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
                return -1;
              return 7;

            case E_V8SImode:
              if (!register_operand (operands[0], E_V8SImode)
                  || GET_MODE (x1) != E_V8SImode)
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V8HImode:
                  if (!register_operand (operands[1], E_V16HImode))
                    return -1;
                  return 8;

                case E_V8QImode:
                  if (!register_operand (operands[1], E_V32QImode))
                    return -1;
                  return 9;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4L:
          if (XWINT (x6, 0) != 5L
              || XWINT (x7, 0) != 6L
              || XWINT (x8, 0) != 7L
              || pattern38 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V8SImode) != 0)
            return -1;
          return 10;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      switch (XWINT (x5, 0))
        {
        case 4L:
          if (XWINT (x6, 0) != 5L
              || pattern39 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern37 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
                return -1;
              return 12;

            case E_V4DImode:
              if (!register_operand (operands[0], E_V4DImode)
                  || GET_MODE (x1) != E_V4DImode)
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V8SImode))
                    return -1;
                  return 13;

                case E_V4HImode:
                  if (!register_operand (operands[1], E_V16HImode))
                    return -1;
                  return 14;

                case E_V4QImode:
                  if (!register_operand (operands[1], E_V32QImode))
                    return -1;
                  return 15;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2L:
          if (XWINT (x6, 0) != 3L
              || pattern39 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V4DImode) != 0)
            return -1;
          return 16;

        default:
          return -1;
        }

    case 2:
      res = pattern41 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode);
      if (res >= 0)
        return res + 17; /* [17, 18] */
      return -1;

    case 16:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x3, 0, 8);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x14 = XVECEXP (x3, 0, 9);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x3, 0, 10);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x3, 0, 11);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XVECEXP (x3, 0, 12);
      if (GET_CODE (x17) != CONST_INT)
        return -1;
      x18 = XVECEXP (x3, 0, 13);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x3, 0, 14);
      if (GET_CODE (x19) != CONST_INT)
        return -1;
      x20 = XVECEXP (x3, 0, 15);
      if (GET_CODE (x20) != CONST_INT
          || !register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0L:
          if (XWINT (x6, 0) != 1L
              || XWINT (x7, 0) != 2L
              || XWINT (x8, 0) != 3L
              || XWINT (x9, 0) != 4L
              || XWINT (x10, 0) != 5L
              || XWINT (x11, 0) != 6L
              || XWINT (x12, 0) != 7L
              || XWINT (x13, 0) != 8L
              || XWINT (x14, 0) != 9L
              || XWINT (x15, 0) != 10L
              || XWINT (x16, 0) != 11L
              || XWINT (x17, 0) != 12L
              || XWINT (x18, 0) != 13L
              || XWINT (x19, 0) != 14L
              || XWINT (x20, 0) != 15L)
            return -1;
          return 19;

        case 8L:
          if (XWINT (x6, 0) != 9L
              || XWINT (x7, 0) != 10L
              || XWINT (x8, 0) != 11L
              || XWINT (x9, 0) != 12L
              || XWINT (x10, 0) != 13L
              || XWINT (x11, 0) != 14L
              || XWINT (x12, 0) != 15L
              || XWINT (x13, 0) != 24L
              || XWINT (x14, 0) != 25L
              || XWINT (x15, 0) != 26L
              || XWINT (x16, 0) != 27L
              || XWINT (x17, 0) != 28L
              || XWINT (x18, 0) != 29L
              || XWINT (x19, 0) != 30L
              || XWINT (x20, 0) != 31L)
            return -1;
          return 20;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern181 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern192 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_exp_4_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern208 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x2, operands[2]))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (!rtx_equal_p (x3, operands[2]))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XVECEXP (x1, 0, 4);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 6);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XVECEXP (x1, 0, 7);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  return 0;
}

int
pattern218 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern51 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 562; /* lsx_vfrintrm_d */

    case 1:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 567; /* lsx_vfrintrm_s */

    case 2:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 572; /* lasx_xvfrintrm_d */

    case 3:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 577; /* lasx_xvfrintrm_s */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_uimm8_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !
#line 1990 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1843; /* lasx_xvshuf4i_w */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !
#line 1990 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1844; /* lasx_xvshuf4i_h */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !
#line 1990 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1845; /* lasx_xvshuf4i_b */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !
#line 1990 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1846; /* lasx_xvshuf4i_w_f */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern59 (x1))
    {
    case 0:
      if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 85; /* fminsf3 */

    case 1:
      if (!
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 86; /* fmindf3 */

    case 2:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 780; /* fminv2df3 */

    case 3:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 782; /* fminv4sf3 */

    case 4:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 784; /* fminv4df3 */

    case 5:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 786; /* fminv8sf3 */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16HImode:
      if (pattern61 (x3, 
E_V8SFmode, 
E_V16HImode) != 0
          || !
#line 2193 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1890; /* lasx_xvfcvt_h_s */

    case E_V8SFmode:
      if (pattern61 (x3, 
E_V4DFmode, 
E_V8SFmode) != 0
          || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1891; /* lasx_xvfcvt_s_d */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1702; /* lasx_xvbitrevi_d */

    case 1:
      if (!
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1703; /* lasx_xvbitrevi_w */

    case 2:
      if (!
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1704; /* lasx_xvbitrevi_h */

    case 3:
      if (!
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1705; /* lasx_xvbitrevi_b */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (pattern61 (x3, 
E_V4SFmode, 
E_V8HImode) != 0
          || !
#line 1784 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1281; /* lsx_vfcvt_h_s */

    case E_V4SFmode:
      if (pattern61 (x3, 
E_V2DFmode, 
E_V4SFmode) != 0
          || !
#line 1794 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1282; /* lsx_vfcvt_s_d */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern67 (x1))
    {
    case 0:
      if (!
#line 986 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1092; /* lsx_vbitclri_d */

    case 1:
      if (!
#line 986 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1093; /* lsx_vbitclri_w */

    case 2:
      if (!
#line 986 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1094; /* lsx_vbitclri_h */

    case 3:
      if (!
#line 986 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1095; /* lsx_vbitclri_b */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_uimm8_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      x2 = XEXP (x1, 1);
      if (pattern58 (x2, 
E_V4DImode) != 0
          || !
#line 527 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1552; /* lasx_xvpermi_q_v4di */

    case E_V8SImode:
      x2 = XEXP (x1, 1);
      if (pattern58 (x2, 
E_V8SImode) != 0
          || !
#line 527 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1553; /* lasx_xvpermi_q_v8si */

    case E_V16HImode:
      x2 = XEXP (x1, 1);
      if (pattern58 (x2, 
E_V16HImode) != 0
          || !
#line 527 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1554; /* lasx_xvpermi_q_v16hi */

    case E_V32QImode:
      x2 = XEXP (x1, 1);
      if (pattern58 (x2, 
E_V32QImode) != 0
          || !
#line 527 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1555; /* lasx_xvpermi_q_v32qi */

    case E_V4DFmode:
      x2 = XEXP (x1, 1);
      if (pattern58 (x2, 
E_V4DFmode) != 0
          || !
#line 527 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1556; /* lasx_xvpermi_q_v4df */

    case E_V8SFmode:
      x2 = XEXP (x1, 1);
      if (pattern58 (x2, 
E_V8SFmode) != 0
          || !
#line 527 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1557; /* lasx_xvpermi_q_v8sf */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      if (const_0_to_3_operand (operands[2], E_VOIDmode))
        {
          x7 = XVECEXP (x5, 0, 1);
          operands[3] = x7;
          if (const_0_to_3_operand (operands[3], E_VOIDmode))
            {
              x8 = XVECEXP (x5, 0, 2);
              operands[4] = x8;
              if (const_0_to_3_operand (operands[4], E_VOIDmode))
                {
                  x9 = XVECEXP (x5, 0, 3);
                  operands[5] = x9;
                  if (const_0_to_3_operand (operands[5], E_VOIDmode)
                      && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return 1550; /* lasx_xvpermi_d_v4di_1 */
                }
            }
        }
      if (!const_0_or_1_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      operands[3] = x8;
      if (!const_2_or_3_operand (operands[3], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x7, operands[2]))
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      if (!rtx_equal_p (x9, operands[3])
          || !
#line 2155 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX && ((INTVAL (operands[3]) - INTVAL (operands[2])) == 2)))
        return -1;
      return 1880; /* lasx_xvrepl128vei_d_internal */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !const_0_to_3_operand (operands[2], E_VOIDmode))
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      operands[3] = x7;
      if (!const_0_to_3_operand (operands[3], E_VOIDmode))
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      operands[4] = x8;
      if (!const_0_to_3_operand (operands[4], E_VOIDmode))
        return -1;
      x9 = XVECEXP (x5, 0, 3);
      operands[5] = x9;
      if (!const_0_to_3_operand (operands[5], E_VOIDmode)
          || !
#line 506 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1551; /* lasx_xvpermi_d_v4df_1 */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern154 (x3) != 0)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  switch (XWINT (x4, 0))
    {
    case 0L:
      x5 = XVECEXP (x3, 0, 1);
      switch (XWINT (x5, 0))
        {
        case 16L:
          x6 = XVECEXP (x3, 0, 2);
          switch (XWINT (x6, 0))
            {
            case 2L:
              x7 = XVECEXP (x3, 0, 3);
              if (XWINT (x7, 0) != 18L)
                return -1;
              x8 = XVECEXP (x3, 0, 4);
              if (XWINT (x8, 0) != 4L)
                return -1;
              x9 = XVECEXP (x3, 0, 5);
              if (XWINT (x9, 0) != 20L)
                return -1;
              x10 = XVECEXP (x3, 0, 6);
              if (XWINT (x10, 0) != 6L)
                return -1;
              x11 = XVECEXP (x3, 0, 7);
              if (XWINT (x11, 0) != 22L)
                return -1;
              x12 = XVECEXP (x3, 0, 8);
              if (XWINT (x12, 0) != 8L)
                return -1;
              x13 = XVECEXP (x3, 0, 9);
              if (XWINT (x13, 0) != 24L)
                return -1;
              x14 = XVECEXP (x3, 0, 10);
              if (XWINT (x14, 0) != 10L)
                return -1;
              x15 = XVECEXP (x3, 0, 11);
              if (XWINT (x15, 0) != 26L)
                return -1;
              x16 = XVECEXP (x3, 0, 12);
              if (XWINT (x16, 0) != 12L)
                return -1;
              x17 = XVECEXP (x3, 0, 13);
              if (XWINT (x17, 0) != 28L)
                return -1;
              x18 = XVECEXP (x3, 0, 14);
              if (XWINT (x18, 0) != 14L)
                return -1;
              x19 = XVECEXP (x3, 0, 15);
              if (XWINT (x19, 0) != 30L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern205 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                      || !
#line 1300 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1171; /* lsx_vpackev_b */

                case E_V16HImode:
                  if (pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                      || !
#line 1439 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1776; /* lasx_xvpackev_h */

                default:
                  return -1;
                }

            case 1L:
              x7 = XVECEXP (x3, 0, 3);
              if (XWINT (x7, 0) != 17L)
                return -1;
              x8 = XVECEXP (x3, 0, 4);
              if (XWINT (x8, 0) != 2L)
                return -1;
              x9 = XVECEXP (x3, 0, 5);
              if (XWINT (x9, 0) != 18L)
                return -1;
              x10 = XVECEXP (x3, 0, 6);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 7);
              if (XWINT (x11, 0) != 19L)
                return -1;
              x12 = XVECEXP (x3, 0, 8);
              switch (XWINT (x12, 0))
                {
                case 4L:
                  x13 = XVECEXP (x3, 0, 9);
                  if (XWINT (x13, 0) != 20L)
                    return -1;
                  x14 = XVECEXP (x3, 0, 10);
                  if (XWINT (x14, 0) != 5L)
                    return -1;
                  x15 = XVECEXP (x3, 0, 11);
                  if (XWINT (x15, 0) != 21L)
                    return -1;
                  x16 = XVECEXP (x3, 0, 12);
                  if (XWINT (x16, 0) != 6L)
                    return -1;
                  x17 = XVECEXP (x3, 0, 13);
                  if (XWINT (x17, 0) != 22L)
                    return -1;
                  x18 = XVECEXP (x3, 0, 14);
                  if (XWINT (x18, 0) != 7L)
                    return -1;
                  x19 = XVECEXP (x3, 0, 15);
                  if (XWINT (x19, 0) != 23L
                      || pattern205 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                      || !
#line 1483 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1185; /* lsx_vilvl_b */

                case 8L:
                  x13 = XVECEXP (x3, 0, 9);
                  if (XWINT (x13, 0) != 24L)
                    return -1;
                  x14 = XVECEXP (x3, 0, 10);
                  if (XWINT (x14, 0) != 9L)
                    return -1;
                  x15 = XVECEXP (x3, 0, 11);
                  if (XWINT (x15, 0) != 25L)
                    return -1;
                  x16 = XVECEXP (x3, 0, 12);
                  if (XWINT (x16, 0) != 10L)
                    return -1;
                  x17 = XVECEXP (x3, 0, 13);
                  if (XWINT (x17, 0) != 26L)
                    return -1;
                  x18 = XVECEXP (x3, 0, 14);
                  if (XWINT (x18, 0) != 11L)
                    return -1;
                  x19 = XVECEXP (x3, 0, 15);
                  if (XWINT (x19, 0) != 27L
                      || pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                      || !
#line 1672 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1790; /* lasx_xvilvl_h */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2L:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 4L)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 6L)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 16L)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 18L)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 20L)
            return -1;
          x11 = XVECEXP (x3, 0, 7);
          if (XWINT (x11, 0) != 22L)
            return -1;
          x12 = XVECEXP (x3, 0, 8);
          if (XWINT (x12, 0) != 8L)
            return -1;
          x13 = XVECEXP (x3, 0, 9);
          if (XWINT (x13, 0) != 10L)
            return -1;
          x14 = XVECEXP (x3, 0, 10);
          if (XWINT (x14, 0) != 12L)
            return -1;
          x15 = XVECEXP (x3, 0, 11);
          if (XWINT (x15, 0) != 14L)
            return -1;
          x16 = XVECEXP (x3, 0, 12);
          if (XWINT (x16, 0) != 24L)
            return -1;
          x17 = XVECEXP (x3, 0, 13);
          if (XWINT (x17, 0) != 26L)
            return -1;
          x18 = XVECEXP (x3, 0, 14);
          if (XWINT (x18, 0) != 28L)
            return -1;
          x19 = XVECEXP (x3, 0, 15);
          if (XWINT (x19, 0) != 30L
              || pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
              || !
#line 1845 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1824; /* lasx_xvpickev_h */

        default:
          return -1;
        }

    case 8L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 24L)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 9L)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 25L)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 10L)
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (XWINT (x9, 0) != 26L)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 11L)
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 27L
          || pattern221 (x2, 
E_V16QImode, 
E_V32QImode) != 0
          || !
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1175; /* lsx_vilvh_b */

    case 1L:
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 23L)
        return -1;
      x12 = XVECEXP (x3, 0, 8);
      if (XWINT (x12, 0) != 9L)
        return -1;
      x19 = XVECEXP (x3, 0, 15);
      if (XWINT (x19, 0) != 31L)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      switch (XWINT (x5, 0))
        {
        case 17L:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 3L)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 19L)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 5L)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 21L)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 7L)
            return -1;
          x13 = XVECEXP (x3, 0, 9);
          if (XWINT (x13, 0) != 25L)
            return -1;
          x14 = XVECEXP (x3, 0, 10);
          if (XWINT (x14, 0) != 11L)
            return -1;
          x15 = XVECEXP (x3, 0, 11);
          if (XWINT (x15, 0) != 27L)
            return -1;
          x16 = XVECEXP (x3, 0, 12);
          if (XWINT (x16, 0) != 13L)
            return -1;
          x17 = XVECEXP (x3, 0, 13);
          if (XWINT (x17, 0) != 29L)
            return -1;
          x18 = XVECEXP (x3, 0, 14);
          if (XWINT (x18, 0) != 15L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern205 (x2, 
E_V16QImode, 
E_V32QImode) != 0
                  || !
#line 1423 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1181; /* lsx_vpackod_b */

            case E_V16HImode:
              if (pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
                  || !
#line 1594 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1786; /* lasx_xvpackod_h */

            default:
              return -1;
            }

        case 3L:
          x6 = XVECEXP (x3, 0, 2);
          if (XWINT (x6, 0) != 5L)
            return -1;
          x7 = XVECEXP (x3, 0, 3);
          if (XWINT (x7, 0) != 7L)
            return -1;
          x8 = XVECEXP (x3, 0, 4);
          if (XWINT (x8, 0) != 17L)
            return -1;
          x9 = XVECEXP (x3, 0, 5);
          if (XWINT (x9, 0) != 19L)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (XWINT (x10, 0) != 21L)
            return -1;
          x13 = XVECEXP (x3, 0, 9);
          if (XWINT (x13, 0) != 11L)
            return -1;
          x14 = XVECEXP (x3, 0, 10);
          if (XWINT (x14, 0) != 13L)
            return -1;
          x15 = XVECEXP (x3, 0, 11);
          if (XWINT (x15, 0) != 15L)
            return -1;
          x16 = XVECEXP (x3, 0, 12);
          if (XWINT (x16, 0) != 25L)
            return -1;
          x17 = XVECEXP (x3, 0, 13);
          if (XWINT (x17, 0) != 27L)
            return -1;
          x18 = XVECEXP (x3, 0, 14);
          if (XWINT (x18, 0) != 29L
              || pattern205 (x2, 
E_V16HImode, 
E_V32HImode) != 0
              || !
#line 1921 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1828; /* lasx_xvpickod_h */

        default:
          return -1;
        }

    case 4L:
      x5 = XVECEXP (x3, 0, 1);
      if (XWINT (x5, 0) != 20L)
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (XWINT (x6, 0) != 5L)
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (XWINT (x7, 0) != 21L)
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (XWINT (x8, 0) != 6L)
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (XWINT (x9, 0) != 22L)
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (XWINT (x10, 0) != 7L)
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (XWINT (x11, 0) != 23L
          || pattern221 (x2, 
E_V16HImode, 
E_V32HImode) != 0
          || !
#line 1515 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1780; /* lasx_xvilvh_h */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FMA:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern176 (x3, 
E_SFmode) != 0
                      || !(
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 53; /* *fmasf4 */

                case E_DFmode:
                  if (pattern176 (x3, 
E_DFmode) != 0
                      || !(
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 54; /* *fmadf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern177 (x3, 
E_SFmode) != 0
                      || !(
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 55; /* *fmssf4 */

                case E_DFmode:
                  if (pattern177 (x3, 
E_DFmode) != 0
                      || !(
#line 1214 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 56; /* *fmsdf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern178 (x3, 
E_SFmode) != 0
                      || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 57; /* *fnmssf4 */

                case E_DFmode:
                  if (pattern178 (x3, 
E_DFmode) != 0
                      || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 58; /* *fnmsdf4 */

                case E_V2DFmode:
                  if (pattern178 (x3, 
E_V2DFmode) != 0
                      || !
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1410; /* vfnmaddv2df4_nmadd4 */

                case E_V4SFmode:
                  if (pattern178 (x3, 
E_V4SFmode) != 0
                      || !
#line 2401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1411; /* vfnmaddv4sf4_nmadd4 */

                case E_V4DFmode:
                  if (pattern178 (x3, 
E_V4DFmode) != 0
                      || !
#line 2811 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2024; /* xvfnmaddv4df4_nmadd4 */

                case E_V8SFmode:
                  if (pattern178 (x3, 
E_V8SFmode) != 0
                      || !
#line 2811 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2025; /* xvfnmaddv8sf4_nmadd4 */

                default:
                  return -1;
                }

            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern179 (x3, 
E_SFmode) != 0
                      || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 59; /* *fnmasf4 */

                case E_DFmode:
                  if (pattern179 (x3, 
E_DFmode) != 0
                      || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 60; /* *fnmadf4 */

                case E_V2DFmode:
                  if (pattern179 (x3, 
E_V2DFmode) != 0
                      || !
#line 2388 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1408; /* vfnmsubv2df4_nmsub4 */

                case E_V4SFmode:
                  if (pattern179 (x3, 
E_V4SFmode) != 0
                      || !
#line 2388 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                    return -1;
                  return 1409; /* vfnmsubv4sf4_nmsub4 */

                case E_V4DFmode:
                  if (pattern179 (x3, 
E_V4DFmode) != 0
                      || !
#line 2798 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2022; /* xvfnmsubv4df4_nmsub4 */

                case E_V8SFmode:
                  if (pattern179 (x3, 
E_V8SFmode) != 0
                      || !
#line 2798 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 2023; /* xvfnmsubv8sf4_nmsub4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 91; /* negsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 92; /* negdi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 94; /* negsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 95; /* negdf2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 787; /* negv2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 788; /* negv4sf2 */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x3) != E_V4DFmode
              || !register_operand (operands[1], E_V4DFmode)
              || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 789; /* negv4df2 */

        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x3) != E_V8SFmode
              || !register_operand (operands[1], E_V8SFmode)
              || !
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 790; /* negv8sf2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 2034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1324; /* vnegv2di2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 2034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1325; /* vnegv4si2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 2034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1326; /* vnegv8hi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2034 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1327; /* vnegv16qi2 */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x3) != E_V4DImode
              || !register_operand (operands[1], E_V4DImode)
              || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1951; /* negv4di2 */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x3) != E_V8SImode
              || !register_operand (operands[1], E_V8SImode)
              || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1952; /* negv8si2 */

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x3) != E_V16HImode
              || !register_operand (operands[1], E_V16HImode)
              || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1953; /* negv16hi2 */

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x3) != E_V32QImode
              || !register_operand (operands[1], E_V32QImode)
              || !
#line 2494 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1954; /* negv32qi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 12; /* mulsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 13; /* muldf3 */

        case E_SImode:
          if (pattern0 (x3, 
E_SImode) != 0)
            return -1;
          return 14; /* *mulsi3 */

        case E_DImode:
          if (pattern0 (x3, 
E_DImode) != 0
              || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 15; /* *muldi3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !
#line 596 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 976; /* mulv2di3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 596 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 977; /* mulv4si3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 596 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 978; /* mulv8hi3 */

        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 596 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 979; /* mulv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 813 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1042; /* mulv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 813 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1043; /* mulv4sf3 */

        case E_V4DImode:
          if (pattern0 (x3, 
E_V4DImode) != 0
              || !
#line 720 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1578; /* mulv4di3 */

        case E_V8SImode:
          if (pattern0 (x3, 
E_V8SImode) != 0
              || !
#line 720 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1579; /* mulv8si3 */

        case E_V16HImode:
          if (pattern0 (x3, 
E_V16HImode) != 0
              || !
#line 720 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1580; /* mulv16hi3 */

        case E_V32QImode:
          if (pattern0 (x3, 
E_V32QImode) != 0
              || !
#line 720 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1581; /* mulv32qi3 */

        case E_V4DFmode:
          if (pattern0 (x3, 
E_V4DFmode) != 0
              || !
#line 954 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1644; /* mulv4df3 */

        case E_V8SFmode:
          if (pattern0 (x3, 
E_V8SFmode) != 0
              || !
#line 954 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1645; /* mulv8sf3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 949 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 19; /* mulsidi3_64bit */

        case VEC_SELECT:
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != VEC_SELECT)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          switch (pattern158 (x3))
            {
            case 0:
              if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 793; /* simd_mulw_evod_v2di_s */

            case 1:
              if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 799; /* simd_mulw_evod_v4si_s */

            case 2:
              if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 805; /* simd_mulw_evod_v8hi_s */

            case 3:
              if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                return -1;
              return 811; /* simd_mulw_evod_v16qi_s */

            case 4:
              if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 817; /* simd_mulw_evod_v4di_s */

            case 5:
              if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 823; /* simd_mulw_evod_v8si_s */

            case 6:
              if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 829; /* simd_mulw_evod_v16hi_s */

            case 7:
              if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                return -1;
              return 835; /* simd_mulw_evod_v32qi_s */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 949 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 20; /* umulsidi3_64bit */

        case VEC_SELECT:
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x5, 0);
              if (GET_CODE (x7) != VEC_SELECT)
                return -1;
              switch (pattern158 (x3))
                {
                case 0:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 796; /* simd_mulw_evod_v2di_u */

                case 1:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 802; /* simd_mulw_evod_v4si_u */

                case 2:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 808; /* simd_mulw_evod_v8hi_u */

                case 3:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 814; /* simd_mulw_evod_v16qi_u */

                case 4:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 820; /* simd_mulw_evod_v4di_u */

                case 5:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 826; /* simd_mulw_evod_v8si_u */

                case 6:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 832; /* simd_mulw_evod_v16hi_u */

                case 7:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 838; /* simd_mulw_evod_v32qi_u */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern30 (x3))
                {
                case 0:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 841; /* simd_mulw_evod_v2di_hetero */

                case 1:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 844; /* simd_mulw_evod_v4si_hetero */

                case 2:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 847; /* simd_mulw_evod_v8hi_hetero */

                case 3:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
                    return -1;
                  return 850; /* simd_mulw_evod_v16qi_hetero */

                case 4:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 853; /* simd_mulw_evod_v4di_hetero */

                case 5:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 856; /* simd_mulw_evod_v8si_hetero */

                case 6:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 859; /* simd_mulw_evod_v16hi_hetero */

                case 7:
                  if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
                    return -1;
                  return 862; /* simd_mulw_evod_v32qi_hetero */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern10 (x1))
    {
    case 0:
      return 244; /* *lshrsi3 */

    case 1:
      if (!
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 247; /* *lshrdi3 */

    case 2:
      if (const_uimm6_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 629; /* lshrv2di3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V2DImode)
          || !
#line 723 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1026; /* vlshrv2di3 */

    case 3:
      if (const_uimm5_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 633; /* lshrv4si3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V4SImode)
          || !
#line 723 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1027; /* vlshrv4si3 */

    case 4:
      if (const_uimm4_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 637; /* lshrv8hi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V8HImode)
          || !
#line 723 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1028; /* vlshrv8hi3 */

    case 5:
      if (const_uimm3_operand (operands[2], E_SImode)
          && 
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return 641; /* lshrv16qi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V16QImode)
          || !
#line 723 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1029; /* vlshrv16qi3 */

    case 6:
      if (const_uimm6_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 645; /* lshrv4di3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V4DImode)
          || !
#line 862 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1628; /* vlshrv4di3 */

    case 7:
      if (const_uimm5_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 649; /* lshrv8si3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V8SImode)
          || !
#line 862 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1629; /* vlshrv8si3 */

    case 8:
      if (const_uimm4_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 653; /* lshrv16hi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V16HImode)
          || !
#line 862 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1630; /* vlshrv16hi3 */

    case 9:
      if (const_uimm3_operand (operands[2], E_SImode)
          && (
#line 429 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return 657; /* lshrv32qi3 */
      if (!reg_or_vector_same_uimm_operand (operands[2], E_V32QImode)
          || !
#line 862 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1631; /* vlshrv32qi3 */

    case 10:
      if (!(
#line 954 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 920; /* simd_lshr_imm_round_v2di */

    case 11:
      if (!(
#line 954 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 922; /* simd_lshr_imm_round_v4si */

    case 12:
      if (!(
#line 954 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 924; /* simd_lshr_imm_round_v8hi */

    case 13:
      if (!(
#line 954 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX)))
        return -1;
      return 926; /* simd_lshr_imm_round_v16qi */

    case 14:
      if (!(
#line 954 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 928; /* simd_lshr_imm_round_v4di */

    case 15:
      if (!(
#line 954 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 930; /* simd_lshr_imm_round_v8si */

    case 16:
      if (!(
#line 954 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 932; /* simd_lshr_imm_round_v16hi */

    case 17:
      if (!(
#line 954 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
((HOST_WIDE_INT_1U << UINTVAL (operands[3]) >> 1)
   == UINTVAL (CONST_VECTOR_ELT (operands[2], 0))) && 
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX)))
        return -1;
      return 934; /* simd_lshr_imm_round_v32qi */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (pattern121 (x3))
        {
        case 0:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 304; /* *sleu_sisi */

        case 1:
          if (!
#line 389 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 306; /* *sleu_disi */

        case 2:
          if (!
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 308; /* *sleu_didi */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern16 (x3, 
E_V2DImode) != 0
              || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1119; /* lsx_vsle_du */

        case E_V4SImode:
          if (pattern16 (x3, 
E_V4SImode) != 0
              || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1124; /* lsx_vsle_wu */

        case E_V8HImode:
          if (pattern16 (x3, 
E_V8HImode) != 0
              || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1129; /* lsx_vsle_hu */

        case E_V16QImode:
          if (pattern16 (x3, 
E_V16QImode) != 0
              || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1134; /* lsx_vsle_bu */

        case E_V4DImode:
          if (pattern16 (x3, 
E_V4DImode) != 0
              || !
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1723; /* lasx_xvsle_du */

        case E_V8SImode:
          if (pattern16 (x3, 
E_V8SImode) != 0
              || !
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1728; /* lasx_xvsle_wu */

        case E_V16HImode:
          if (pattern16 (x3, 
E_V16HImode) != 0
              || !
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1733; /* lasx_xvsle_hu */

        case E_V32QImode:
          if (pattern16 (x3, 
E_V32QImode) != 0
              || !
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1738; /* lasx_xvsle_bu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PC:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 341; /* tablejumpsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 342; /* tablejumpdi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x8;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern200 (
E_HImode) != 0
                  || !
#line 4401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(reload_completed))
                return -1;
              return 440; /* *join2_load_storehi */

            case E_SImode:
              if (pattern200 (
E_SImode) != 0
                  || !
#line 4401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(reload_completed))
                return -1;
              return 441; /* *join2_load_storesi */

            case E_SFmode:
              if (pattern200 (
E_SFmode) != 0
                  || !(
#line 4401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(reload_completed) && 
#line 381 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 442; /* *join2_load_storesf */

            case E_DFmode:
              if (pattern200 (
E_DFmode) != 0
                  || !(
#line 4401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(reload_completed) && 
#line 382 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 443; /* *join2_load_storedf */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          x5 = XEXP (x4, 0);
          if (!rtx_equal_p (x5, operands[1]))
            return -1;
          switch (XVECLEN (x8, 0))
            {
            case 2:
              if (XINT (x8, 1) != 48)
                return -1;
              x9 = XVECEXP (x8, 0, 1);
              operands[3] = x9;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x10 = XVECEXP (x8, 0, 0);
              switch (GET_CODE (x10))
                {
                case PLUS:
                  x11 = XEXP (x10, 1);
                  operands[2] = x11;
                  x12 = XEXP (x10, 0);
                  if (!rtx_equal_p (x12, operands[1]))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern210 (x8, 
E_SImode) != 0)
                        return -1;
                      return 509; /* atomic_fetch_addsi */

                    case E_DImode:
                      if (pattern210 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 513; /* atomic_fetch_adddi */

                    case E_QImode:
                      if (pattern210 (x8, 
E_QImode) != 0
                          || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                        return -1;
                      return 543; /* atomic_fetch_addqi_short */

                    case E_HImode:
                      if (pattern210 (x8, 
E_HImode) != 0
                          || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                        return -1;
                      return 544; /* atomic_fetch_addhi_short */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern211 (x8))
                    {
                    case 0:
                      return 510; /* atomic_fetch_orsi */

                    case 1:
                      if (!
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 514; /* atomic_fetch_ordi */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern211 (x8))
                    {
                    case 0:
                      return 511; /* atomic_fetch_xorsi */

                    case 1:
                      if (!
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 515; /* atomic_fetch_xordi */

                    default:
                      return -1;
                    }

                case AND:
                  switch (pattern211 (x8))
                    {
                    case 0:
                      return 512; /* atomic_fetch_andsi */

                    case 1:
                      if (!
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 516; /* atomic_fetch_anddi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 3:
              if (XINT (x8, 1) != 41)
                return -1;
              x10 = XVECEXP (x8, 0, 0);
              operands[2] = x10;
              x9 = XVECEXP (x8, 0, 1);
              operands[3] = x9;
              x13 = XVECEXP (x8, 0, 2);
              operands[4] = x13;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern214 (x8, 
E_SImode) != 0)
                    return -1;
                  if (pnum_clobbers != NULL)
                    {
                      *pnum_clobbers = 1;
                      return 521; /* atomic_cas_value_strongsi */
                    }
                  if (!
#line 293 "../../gcc-15.0.1-20250313/gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS))
                    return -1;
                  return 525; /* atomic_cas_value_strongsi_amcas */

                case E_DImode:
                  if (pattern214 (x8, 
E_DImode) != 0)
                    return -1;
                  if (pnum_clobbers != NULL
                      && 
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    {
                      *pnum_clobbers = 1;
                      return 522; /* atomic_cas_value_strongdi */
                    }
                  if (!(
#line 293 "../../gcc-15.0.1-20250313/gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS) && 
#line 401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                    return -1;
                  return 526; /* atomic_cas_value_strongdi_amcas */

                case E_QImode:
                  if (pattern214 (x8, 
E_QImode) != 0
                      || !
#line 293 "../../gcc-15.0.1-20250313/gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS))
                    return -1;
                  return 523; /* atomic_cas_value_strongqi_amcas */

                case E_HImode:
                  if (pattern214 (x8, 
E_HImode) != 0
                      || !
#line 293 "../../gcc-15.0.1-20250313/gcc/config/loongarch/sync.md"
(ISA_HAS_LAMCAS))
                    return -1;
                  return 524; /* atomic_cas_value_stronghi_amcas */

                default:
                  return -1;
                }

            case 5:
              if (pnum_clobbers == NULL)
                return -1;
              x10 = XVECEXP (x8, 0, 0);
              operands[2] = x10;
              x9 = XVECEXP (x8, 0, 1);
              operands[3] = x9;
              x13 = XVECEXP (x8, 0, 2);
              operands[4] = x13;
              x14 = XVECEXP (x8, 0, 3);
              operands[5] = x14;
              x15 = XVECEXP (x8, 0, 4);
              operands[6] = x15;
              if (!const_int_operand (operands[6], E_SImode))
                return -1;
              switch (XINT (x8, 1))
                {
                case 41:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 1;
                      return 527; /* atomic_cas_value_cmp_and_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 1;
                      return 528; /* atomic_cas_value_cmp_and_7_di */

                    default:
                      return -1;
                    }

                case 42:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 529; /* atomic_cas_value_add_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 530; /* atomic_cas_value_add_7_di */

                    default:
                      return -1;
                    }

                case 43:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 531; /* atomic_cas_value_sub_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 532; /* atomic_cas_value_sub_7_di */

                    default:
                      return -1;
                    }

                case 44:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 533; /* atomic_cas_value_and_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 534; /* atomic_cas_value_and_7_di */

                    default:
                      return -1;
                    }

                case 45:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 535; /* atomic_cas_value_xor_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 536; /* atomic_cas_value_xor_7_di */

                    default:
                      return -1;
                    }

                case 46:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 537; /* atomic_cas_value_or_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 538; /* atomic_cas_value_or_7_di */

                    default:
                      return -1;
                    }

                case 47:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 2;
                      return 539; /* atomic_cas_value_nand_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 2;
                      return 540; /* atomic_cas_value_nand_7_di */

                    default:
                      return -1;
                    }

                case 49:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern218 (x8, 
E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 1;
                      return 541; /* atomic_cas_value_exchange_7_si */

                    case E_DImode:
                      if (pattern218 (x8, 
E_DImode) != 0
                          || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 1;
                      return 542; /* atomic_cas_value_exchange_7_di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
