/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern4 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 2;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 3;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 5;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode))
        return -1;
      return 6;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode))
        return -1;
      return 7;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode))
        return -1;
      return 8;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 4);
  if (XWINT (x4, 0) != 12L)
    return -1;
  x5 = XVECEXP (x3, 0, 5);
  if (XWINT (x5, 0) != 13L)
    return -1;
  x6 = XVECEXP (x3, 0, 6);
  if (XWINT (x6, 0) != 14L)
    return -1;
  x7 = XVECEXP (x3, 0, 7);
  if (XWINT (x7, 0) != 15L
      || pattern37 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern44 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern43 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern43 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern43 (x1, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern43 (x1, 
E_V16QImode) != 0)
        return -1;
      return 3;

    case E_V4DImode:
      if (pattern43 (x1, 
E_V4DImode) != 0)
        return -1;
      return 4;

    case E_V8SImode:
      if (pattern43 (x1, 
E_V8SImode) != 0)
        return -1;
      return 5;

    case E_V16HImode:
      if (pattern43 (x1, 
E_V16HImode) != 0)
        return -1;
      return 6;

    case E_V32QImode:
      if (pattern43 (x1, 
E_V32QImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case USE:
      x5 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          return pattern57 (x3, 
E_SFmode); /* [-1, 0] */

        case E_DFmode:
          if (pattern57 (x3, 
E_DFmode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern58 (x3, 
E_V2DFmode) != 0)
            return -1;
          return 2;

        case E_V4SFmode:
          if (pattern58 (x3, 
E_V4SFmode) != 0)
            return -1;
          return 3;

        case E_V4DFmode:
          if (pattern58 (x3, 
E_V4DFmode) != 0)
            return -1;
          return 4;

        case E_V8SFmode:
          if (pattern58 (x3, 
E_V8SFmode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_uimm5_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern80 (x3); /* [-1, 3] */
}

int
pattern87 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 0;

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x4, 0) != 1)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XVECEXP (x4, 0, 0);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_0_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x6, 0);
      operands[0] = x10;
      switch (XINT (x4, 1))
        {
        case 77:
          res = pattern85 ();
          if (res >= 0)
            return res + 1; /* [1, 6] */
          return -1;

        case 76:
          res = pattern85 ();
          if (res >= 0)
            return res + 7; /* [7, 12] */
          return -1;

        case 184:
          res = pattern86 ();
          if (res >= 0)
            return res + 13; /* [13, 18] */
          return -1;

        case 185:
          res = pattern86 ();
          if (res >= 0)
            return res + 19; /* [19, 24] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern107 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!non_volatile_mem_operand (operands[1], E_HImode))
    return -1;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[3] = x6;
  if (!non_volatile_mem_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DFmode)
          || !register_operand (operands[2], E_V4DFmode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode)
          || !reg_or_vector_same_simm5_operand (operands[2], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_1_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern134 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_0_to_7_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern147 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CONST_INT)
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CONST_INT)
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x11) != CONST_INT)
    return -1;
  x12 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x12) != CONST_INT)
    return -1;
  x13 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x13) != CONST_INT)
    return -1;
  x14 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x14) != CONST_INT)
    return -1;
  x15 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x15) != CONST_INT)
    return -1;
  x16 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x16) != CONST_INT)
    return -1;
  x17 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x17) != CONST_INT)
    return -1;
  return 0;
}

int
pattern177 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern184 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aq12w_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!const_immalsl_operand (operands[2], E_VOIDmode))
    return -1;
  x7 = XEXP (x2, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern210 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern217 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1)
      || !scratch_operand (operands[7], i1))
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern51 (x1))
    {
    case 0:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 563; /* lsx_vfrintrne_d */

    case 1:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
        return -1;
      return 568; /* lsx_vfrintrne_s */

    case 2:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 573; /* lasx_xvfrintrne_d */

    case 3:
      if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
        return -1;
      return 578; /* lasx_xvfrintrne_s */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern50 (x1))
    {
    case 0:
      if (!(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (9 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && 
#line 409 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 198; /* lrintsfsi2 */

    case 1:
      if (!(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (9 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && (
#line 409 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))))
        return -1;
      return 204; /* lrintdfsi2 */

    case 2:
      if (!(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (9 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && (
#line 410 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))))
        return -1;
      return 201; /* lrintsfdi2 */

    case 3:
      if (!(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT &&
   (9 == UNSPEC_FTINT
    || flag_fp_int_builtin_inexact
    || !flag_trapping_math)) && 
#line 410 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
        return -1;
      return 207; /* lrintdfdi2 */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_uimm8_operand (operands[2], E_SImode))
    return -1;
  switch (pattern141 (x3))
    {
    case 0:
      if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1544; /* lasx_xvpermi_d_v4di */

    case 1:
      if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1545; /* lasx_xvpermi_d_v8si */

    case 2:
      if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1546; /* lasx_xvpermi_d_v16hi */

    case 3:
      if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1547; /* lasx_xvpermi_d_v32qi */

    case 4:
      if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1548; /* lasx_xvpermi_d_v4df */

    case 5:
      if (!
#line 493 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1549; /* lasx_xvpermi_d_v8sf */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 1980 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1839; /* lasx_xvsat_u_du */

    case 1:
      if (!
#line 1980 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1840; /* lasx_xvsat_u_wu */

    case 2:
      if (!
#line 1980 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1841; /* lasx_xvsat_u_hu */

    case 3:
      if (!
#line 1980 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1842; /* lasx_xvsat_u_bu */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1686; /* lasx_xvavgr_u_du */

    case 1:
      if (!
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1687; /* lasx_xvavgr_u_wu */

    case 2:
      if (!
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1688; /* lasx_xvavgr_u_hu */

    case 3:
      if (!
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1689; /* lasx_xvavgr_u_bu */

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern67 (x1))
    {
    case 0:
      if (!
#line 1665 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1229; /* lsx_vsat_s_d */

    case 1:
      if (!
#line 1665 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1230; /* lsx_vsat_s_w */

    case 2:
      if (!
#line 1665 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1231; /* lsx_vsat_s_h */

    case 3:
      if (!
#line 1665 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1232; /* lsx_vsat_s_b */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 946 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1076; /* lsx_vavg_u_du */

    case 1:
      if (!
#line 946 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1077; /* lsx_vavg_u_wu */

    case 2:
      if (!
#line 946 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1078; /* lsx_vavg_u_hu */

    case 3:
      if (!
#line 946 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1079; /* lsx_vavg_u_bu */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 12:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern134 (x2, 
E_SImode, 
E_SFmode) != 0
              || !
#line 1370 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 71; /* ldexpsf3 */

        case E_DFmode:
          if (pattern134 (x2, 
E_DImode, 
E_DFmode) != 0
              || !(
#line 1370 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return -1;
          return 72; /* ldexpdf3 */

        default:
          return -1;
        }

    case 7:
      return recog_26 (x1, insn, pnum_clobbers);

    case 8:
      return recog_25 (x1, insn, pnum_clobbers);

    case 30:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern135 (x2, 
E_SImode) != 0
              || !
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 192; /* ori_l_lo12si */

        case E_DImode:
          if (pattern135 (x2, 
E_DImode) != 0
              || !
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 193; /* ori_l_lo12di */

        default:
          return -1;
        }

    case 32:
      if (pattern60 (x1) != 0
          || !
#line 2694 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 194; /* lui_h_lo20 */

    case 33:
      if (pattern60 (x1) != 0
          || !
#line 2704 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 195; /* lui_h_hi12 */

    case 20:
      return recog_18 (x1, insn, pnum_clobbers);

    case 24:
      return recog_21 (x1, insn, pnum_clobbers);

    case 25:
      return recog_22 (x1, insn, pnum_clobbers);

    case 58:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 747; /* lsx_vfcmp_caf_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 755; /* lsx_vfcmp_caf_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 763; /* lasx_xvfcmp_caf_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 771; /* lasx_xvfcmp_caf_s */

        default:
          return -1;
        }

    case 59:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 748; /* lsx_vfcmp_saf_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 756; /* lsx_vfcmp_saf_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 764; /* lasx_xvfcmp_saf_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 772; /* lasx_xvfcmp_saf_s */

        default:
          return -1;
        }

    case 60:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 749; /* lsx_vfcmp_seq_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 757; /* lsx_vfcmp_seq_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 765; /* lasx_xvfcmp_seq_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 773; /* lasx_xvfcmp_seq_s */

        default:
          return -1;
        }

    case 61:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 750; /* lsx_vfcmp_sun_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 758; /* lsx_vfcmp_sun_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 766; /* lasx_xvfcmp_sun_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 774; /* lasx_xvfcmp_sun_s */

        default:
          return -1;
        }

    case 62:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 751; /* lsx_vfcmp_sueq_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 759; /* lsx_vfcmp_sueq_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 767; /* lasx_xvfcmp_sueq_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 775; /* lasx_xvfcmp_sueq_s */

        default:
          return -1;
        }

    case 63:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 752; /* lsx_vfcmp_cne_d */

        case 1:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 760; /* lsx_vfcmp_cne_s */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 768; /* lasx_xvfcmp_cne_d */

        case 3:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 776; /* lasx_xvfcmp_cne_s */

        default:
          return -1;
        }

    case 64:
      return recog_65 (x1, insn, pnum_clobbers);

    case 65:
      return recog_64 (x1, insn, pnum_clobbers);

    case 66:
      return recog_63 (x1, insn, pnum_clobbers);

    case 67:
      return recog_62 (x1, insn, pnum_clobbers);

    case 68:
      return recog_61 (x1, insn, pnum_clobbers);

    case 69:
      return recog_60 (x1, insn, pnum_clobbers);

    case 70:
      return recog_59 (x1, insn, pnum_clobbers);

    case 71:
      return recog_58 (x1, insn, pnum_clobbers);

    case 72:
      return recog_57 (x1, insn, pnum_clobbers);

    case 73:
      return recog_28 (x1, insn, pnum_clobbers);

    case 74:
      return recog_56 (x1, insn, pnum_clobbers);

    case 75:
      return recog_54 (x1, insn, pnum_clobbers);

    case 156:
      return recog_55 (x1, insn, pnum_clobbers);

    case 87:
      return recog_53 (x1, insn, pnum_clobbers);

    case 88:
      return recog_52 (x1, insn, pnum_clobbers);

    case 89:
      return recog_51 (x1, insn, pnum_clobbers);

    case 90:
      return recog_50 (x1, insn, pnum_clobbers);

    case 157:
      return recog_17 (x1, insn, pnum_clobbers);

    case 79:
      return recog_49 (x1, insn, pnum_clobbers);

    case 94:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 2062 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1330; /* lsx_vsllwil_s_d_w */

        case 1:
          if (!
#line 2062 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1331; /* lsx_vsllwil_s_w_h */

        case 2:
          if (!
#line 2062 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1332; /* lsx_vsllwil_s_h_b */

        default:
          return -1;
        }

    case 95:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 2072 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1333; /* lsx_vsllwil_u_du_wu */

        case 1:
          if (!
#line 2072 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1334; /* lsx_vsllwil_u_wu_hu */

        case 2:
          if (!
#line 2072 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1335; /* lsx_vsllwil_u_hu_bu */

        default:
          return -1;
        }

    case 96:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2082 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1336; /* lsx_vsran_w_d */

        case 1:
          if (!
#line 2082 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1337; /* lsx_vsran_h_w */

        case 2:
          if (!
#line 2082 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1338; /* lsx_vsran_b_h */

        default:
          return -1;
        }

    case 97:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2092 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1339; /* lsx_vssran_s_w_d */

        case 1:
          if (!
#line 2092 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1340; /* lsx_vssran_s_h_w */

        case 2:
          if (!
#line 2092 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1341; /* lsx_vssran_s_b_h */

        default:
          return -1;
        }

    case 98:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2102 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1342; /* lsx_vssran_u_wu_d */

        case 1:
          if (!
#line 2102 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1343; /* lsx_vssran_u_hu_w */

        case 2:
          if (!
#line 2102 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1344; /* lsx_vssran_u_bu_h */

        default:
          return -1;
        }

    case 99:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1345; /* lsx_vsrain_w */

        case 1:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1346; /* lsx_vsrain_h */

        case 2:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1347; /* lsx_vsrain_b */

        default:
          return -1;
        }

    case 100:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 2123 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1348; /* lsx_vsrains_s_w */

        case 1:
          if (!
#line 2123 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1349; /* lsx_vsrains_s_h */

        case 2:
          if (!
#line 2123 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1350; /* lsx_vsrains_s_b */

        default:
          return -1;
        }

    case 101:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 2134 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1351; /* lsx_vsrains_u_w */

        case 1:
          if (!
#line 2134 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1352; /* lsx_vsrains_u_h */

        case 2:
          if (!
#line 2134 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1353; /* lsx_vsrains_u_b */

        default:
          return -1;
        }

    case 102:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2144 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1354; /* lsx_vsrarn_w_d */

        case 1:
          if (!
#line 2144 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1355; /* lsx_vsrarn_h_w */

        case 2:
          if (!
#line 2144 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1356; /* lsx_vsrarn_b_h */

        default:
          return -1;
        }

    case 126:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2154 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1357; /* lsx_vssrarn_s_w_d */

        case 1:
          if (!
#line 2154 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1358; /* lsx_vssrarn_s_h_w */

        case 2:
          if (!
#line 2154 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1359; /* lsx_vssrarn_s_b_h */

        default:
          return -1;
        }

    case 127:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2164 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1360; /* lsx_vssrarn_u_wu_d */

        case 1:
          if (!
#line 2164 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1361; /* lsx_vssrarn_u_hu_w */

        case 2:
          if (!
#line 2164 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1362; /* lsx_vssrarn_u_bu_h */

        default:
          return -1;
        }

    case 103:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2174 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1363; /* lsx_vsrln_w_d */

        case 1:
          if (!
#line 2174 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1364; /* lsx_vsrln_h_w */

        case 2:
          if (!
#line 2174 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1365; /* lsx_vsrln_b_h */

        default:
          return -1;
        }

    case 128:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2184 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1366; /* lsx_vssrln_u_wu_d */

        case 1:
          if (!
#line 2184 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1367; /* lsx_vssrln_u_hu_w */

        case 2:
          if (!
#line 2184 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1368; /* lsx_vssrln_u_bu_h */

        default:
          return -1;
        }

    case 104:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2194 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1369; /* lsx_vsrlrn_w_d */

        case 1:
          if (!
#line 2194 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1370; /* lsx_vsrlrn_h_w */

        case 2:
          if (!
#line 2194 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1371; /* lsx_vsrlrn_b_h */

        default:
          return -1;
        }

    case 105:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2204 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1372; /* lsx_vssrlrn_u_wu_d */

        case 1:
          if (!
#line 2204 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1373; /* lsx_vssrlrn_u_hu_w */

        case 2:
          if (!
#line 2204 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1374; /* lsx_vssrlrn_u_bu_h */

        default:
          return -1;
        }

    case 109:
      return recog_14 (x1, insn, pnum_clobbers);

    case 110:
      return recog_27 (x1, insn, pnum_clobbers);

    case 113:
      return recog_48 (x1, insn, pnum_clobbers);

    case 114:
      if (pattern74 (x1, 
E_V2DFmode, 
E_V4SImode) != 0
          || !
#line 2411 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1412; /* lsx_vftint_w_d */

    case 115:
      if (pattern74 (x1, 
E_V2DFmode, 
E_V4SImode) != 0
          || !
#line 2441 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1415; /* lsx_vftintrp_w_d */

    case 116:
      if (pattern74 (x1, 
E_V2DFmode, 
E_V4SImode) != 0
          || !
#line 2451 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1416; /* lsx_vftintrm_w_d */

    case 117:
      if (pattern74 (x1, 
E_V2DFmode, 
E_V4SImode) != 0
          || !
#line 2461 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1417; /* lsx_vftintrne_w_d */

    case 129:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2690 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1454; /* lsx_vssrln_w_d */

        case 1:
          if (!
#line 2690 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1455; /* lsx_vssrln_h_w */

        case 2:
          if (!
#line 2690 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1456; /* lsx_vssrln_b_h */

        default:
          return -1;
        }

    case 130:
      switch (pattern72 (x1))
        {
        case 0:
          if (!
#line 2701 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1457; /* lsx_vssrlrn_w_d */

        case 1:
          if (!
#line 2701 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1458; /* lsx_vssrlrn_h_w */

        case 2:
          if (!
#line 2701 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1459; /* lsx_vssrlrn_b_h */

        default:
          return -1;
        }

    case 136:
      if (pattern75 (x1) != 0
          || !
#line 2967 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1469; /* lsx_vadd_q */

    case 137:
      if (pattern75 (x1) != 0
          || !
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1470; /* lsx_vsub_q */

    case 225:
      return recog_19 (x1, insn, pnum_clobbers);

    case 227:
      return recog_24 (x1, insn, pnum_clobbers);

    case 158:
      return recog_47 (x1, insn, pnum_clobbers);

    case 159:
      return recog_46 (x1, insn, pnum_clobbers);

    case 160:
      return recog_45 (x1, insn, pnum_clobbers);

    case 161:
      return recog_44 (x1, insn, pnum_clobbers);

    case 162:
      return recog_43 (x1, insn, pnum_clobbers);

    case 163:
      return recog_42 (x1, insn, pnum_clobbers);

    case 164:
      return recog_41 (x1, insn, pnum_clobbers);

    case 165:
      return recog_40 (x1, insn, pnum_clobbers);

    case 166:
      return recog_39 (x1, insn, pnum_clobbers);

    case 167:
      return recog_38 (x1, insn, pnum_clobbers);

    case 258:
      return recog_37 (x1, insn, pnum_clobbers);

    case 177:
      return recog_36 (x1, insn, pnum_clobbers);

    case 178:
      return recog_35 (x1, insn, pnum_clobbers);

    case 200:
      return recog_15 (x1, insn, pnum_clobbers);

    case 180:
      return recog_34 (x1, insn, pnum_clobbers);

    case 181:
      return recog_33 (x1, insn, pnum_clobbers);

    case 179:
      return recog_16 (x1, insn, pnum_clobbers);

    case 169:
      return recog_31 (x1, insn, pnum_clobbers);

    case 186:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2504 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1955; /* lasx_xvsllwil_s_d_w */

        case 1:
          if (!
#line 2504 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1956; /* lasx_xvsllwil_s_w_h */

        case 2:
          if (!
#line 2504 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1957; /* lasx_xvsllwil_s_h_b */

        default:
          return -1;
        }

    case 187:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2514 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1958; /* lasx_xvsllwil_u_du_wu */

        case 1:
          if (!
#line 2514 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1959; /* lasx_xvsllwil_u_wu_hu */

        case 2:
          if (!
#line 2514 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1960; /* lasx_xvsllwil_u_hu_bu */

        default:
          return -1;
        }

    case 188:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2524 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1961; /* lasx_xvsran_w_d */

        case 1:
          if (!
#line 2524 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1962; /* lasx_xvsran_h_w */

        case 2:
          if (!
#line 2524 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1963; /* lasx_xvsran_b_h */

        default:
          return -1;
        }

    case 189:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2534 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1964; /* lasx_xvssran_s_w_d */

        case 1:
          if (!
#line 2534 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1965; /* lasx_xvssran_s_h_w */

        case 2:
          if (!
#line 2534 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1966; /* lasx_xvssran_s_b_h */

        default:
          return -1;
        }

    case 190:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2544 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1967; /* lasx_xvssran_u_wu_d */

        case 1:
          if (!
#line 2544 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1968; /* lasx_xvssran_u_hu_w */

        case 2:
          if (!
#line 2544 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1969; /* lasx_xvssran_u_bu_h */

        default:
          return -1;
        }

    case 191:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2554 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1970; /* lasx_xvsrarn_w_d */

        case 1:
          if (!
#line 2554 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1971; /* lasx_xvsrarn_h_w */

        case 2:
          if (!
#line 2554 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1972; /* lasx_xvsrarn_b_h */

        default:
          return -1;
        }

    case 192:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2564 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1973; /* lasx_xvssrarn_s_w_d */

        case 1:
          if (!
#line 2564 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1974; /* lasx_xvssrarn_s_h_w */

        case 2:
          if (!
#line 2564 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1975; /* lasx_xvssrarn_s_b_h */

        default:
          return -1;
        }

    case 193:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2574 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1976; /* lasx_xvssrarn_u_wu_d */

        case 1:
          if (!
#line 2574 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1977; /* lasx_xvssrarn_u_hu_w */

        case 2:
          if (!
#line 2574 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1978; /* lasx_xvssrarn_u_bu_h */

        default:
          return -1;
        }

    case 194:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2584 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1979; /* lasx_xvsrln_w_d */

        case 1:
          if (!
#line 2584 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1980; /* lasx_xvsrln_h_w */

        case 2:
          if (!
#line 2584 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1981; /* lasx_xvsrln_b_h */

        default:
          return -1;
        }

    case 195:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2594 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1982; /* lasx_xvssrln_u_wu_d */

        case 1:
          if (!
#line 2594 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1983; /* lasx_xvssrln_u_hu_w */

        case 2:
          if (!
#line 2594 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1984; /* lasx_xvssrln_u_bu_h */

        default:
          return -1;
        }

    case 196:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2604 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1985; /* lasx_xvsrlrn_w_d */

        case 1:
          if (!
#line 2604 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1986; /* lasx_xvsrlrn_h_w */

        case 2:
          if (!
#line 2604 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1987; /* lasx_xvsrlrn_b_h */

        default:
          return -1;
        }

    case 197:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2614 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1988; /* lasx_xvssrlrn_u_wu_d */

        case 1:
          if (!
#line 2614 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1989; /* lasx_xvssrlrn_u_hu_w */

        case 2:
          if (!
#line 2614 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1990; /* lasx_xvssrlrn_u_bu_h */

        default:
          return -1;
        }

    case 201:
      return recog_32 (x1, insn, pnum_clobbers);

    case 202:
      return recog_30 (x1, insn, pnum_clobbers);

    case 205:
      return recog_29 (x1, insn, pnum_clobbers);

    case 206:
      if (pattern74 (x1, 
E_V4DFmode, 
E_V8SImode) != 0
          || !
#line 2821 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2026; /* lasx_xvftint_w_d */

    case 207:
      if (pattern82 (x1, 
E_V8SFmode) != 0
          || !
#line 2844 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2027; /* lasx_xvffint_s_l */

    case 208:
      if (pattern74 (x1, 
E_V4DFmode, 
E_V8SImode) != 0
          || !
#line 2867 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2028; /* lasx_xvftintrz_w_d */

    case 209:
      if (pattern74 (x1, 
E_V4DFmode, 
E_V8SImode) != 0
          || !
#line 2877 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2029; /* lasx_xvftintrp_w_d */

    case 210:
      if (pattern74 (x1, 
E_V4DFmode, 
E_V8SImode) != 0
          || !
#line 2887 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2030; /* lasx_xvftintrm_w_d */

    case 211:
      if (pattern74 (x1, 
E_V4DFmode, 
E_V8SImode) != 0
          || !
#line 2897 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2031; /* lasx_xvftintrne_w_d */

    case 228:
      if (pattern82 (x1, 
E_V4DImode) != 0
          || !
#line 3103 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2056; /* lasx_xvadd_q */

    case 229:
      if (pattern82 (x1, 
E_V4DImode) != 0
          || !
#line 3115 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2057; /* lasx_xvsub_q */

    case 251:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2058; /* lasx_xvssrln_w_d */

        case 1:
          if (!
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2059; /* lasx_xvssrln_h_w */

        case 2:
          if (!
#line 3126 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2060; /* lasx_xvssrln_b_h */

        default:
          return -1;
        }

    case 230:
      return recog_23 (x1, insn, pnum_clobbers);

    case 250:
      return recog_20 (x1, insn, pnum_clobbers);

    case 252:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 3534 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2154; /* lasx_xvssrlrn_w_d */

        case 1:
          if (!
#line 3534 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2155; /* lasx_xvssrlrn_h_w */

        case 2:
          if (!
#line 3534 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 2156; /* lasx_xvssrlrn_b_h */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 67; /* abssf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 68; /* absdf2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2026 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1320; /* absv2di2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 2026 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1321; /* absv4si2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 2026 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1322; /* absv8hi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 2026 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1323; /* absv16qi2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 2348 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1402; /* absv2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2356 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
        return -1;
      return 1403; /* absv4sf2 */

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x3) != E_V4DImode
          || !register_operand (operands[1], E_V4DImode)
          || !
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1947; /* absv4di2 */

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x3) != E_V8SImode
          || !register_operand (operands[1], E_V8SImode)
          || !
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1948; /* absv8si2 */

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x3) != E_V16HImode
          || !register_operand (operands[1], E_V16HImode)
          || !
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1949; /* absv16hi2 */

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x3) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !
#line 2486 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 1950; /* absv32qi2 */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x3) != E_V4DFmode
          || !register_operand (operands[1], E_V4DFmode)
          || !
#line 2758 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2016; /* absv4df2 */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x3) != E_V8SFmode
          || !register_operand (operands[1], E_V8SFmode)
          || !
#line 2766 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
        return -1;
      return 2017; /* absv8sf2 */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 23; /* *divsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 24; /* *divdf3 */

        case E_DImode:
          if (pattern0 (x3, 
E_DImode) != 0
              || !
#line 421 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 29; /* *divdi3 */

        case E_SImode:
          if (pattern0 (x3, 
E_SImode) != 0
              || !
#line 422 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT || ISA_HAS_DIV32))
            return -1;
          return 33; /* *divsi3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !
#line 625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 988; /* divv2di3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 989; /* divv4si3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 990; /* divv8hi3 */

        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 625 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 991; /* divv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 840 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1044; /* *divv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 840 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1045; /* *divv4sf3 */

        case E_V4DImode:
          if (pattern0 (x3, 
E_V4DImode) != 0
              || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1590; /* divv4di3 */

        case E_V8SImode:
          if (pattern0 (x3, 
E_V8SImode) != 0
              || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1591; /* divv8si3 */

        case E_V16HImode:
          if (pattern0 (x3, 
E_V16HImode) != 0
              || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1592; /* divv16hi3 */

        case E_V32QImode:
          if (pattern0 (x3, 
E_V32QImode) != 0
              || !
#line 751 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1593; /* divv32qi3 */

        case E_V4DFmode:
          if (pattern0 (x3, 
E_V4DFmode) != 0
              || !
#line 981 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1646; /* *divv4df3 */

        case E_V8SFmode:
          if (pattern0 (x3, 
E_V8SFmode) != 0
              || !
#line 981 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1647; /* *divv8sf3 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern128 (x3, 
E_SFmode) != 0
              || !
#line 404 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 25; /* *recipsf3 */

        case E_DFmode:
          if (pattern128 (x3, 
E_DFmode) != 0
              || !
#line 405 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 26; /* *recipdf3 */

        case E_V2DFmode:
          if (pattern129 (x3, 
E_V2DFmode) != 0
              || !
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1159; /* recipv2df3 */

        case E_V4SFmode:
          if (pattern129 (x3, 
E_V4SFmode) != 0
              || !
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
            return -1;
          return 1160; /* recipv4sf3 */

        case E_V4DFmode:
          if (pattern129 (x3, 
E_V4DFmode) != 0
              || !
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1763; /* recipv4df3 */

        case E_V8SFmode:
          if (pattern129 (x3, 
E_V8SFmode) != 0
              || !
#line 1329 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
            return -1;
          return 1764; /* recipv8sf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 1881 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 139; /* extendsfdf2 */

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          switch (pattern41 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode))
            {
            case 0:
              if (!
#line 1824 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1285; /* vec_unpacks_hi_v4sf */

            case 1:
              if (!
#line 1844 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1287; /* vec_unpacks_lo_v4sf */

            default:
              return -1;
            }

        case 4:
          x7 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x8) != CONST_INT)
            return -1;
          x9 = XVECEXP (x5, 0, 2);
          if (GET_CODE (x9) != CONST_INT)
            return -1;
          x10 = XVECEXP (x5, 0, 3);
          if (GET_CODE (x10) != CONST_INT
              || pattern37 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_V4DFmode) != 0)
            return -1;
          switch (XWINT (x7, 0))
            {
            case 2L:
              if (XWINT (x8, 0) != 3L
                  || XWINT (x9, 0) != 6L
                  || XWINT (x10, 0) != 7L
                  || !
#line 2237 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1894; /* lasx_xvfcvth_d_s */

            case 4L:
              if (XWINT (x8, 0) != 5L
                  || XWINT (x9, 0) != 6L
                  || XWINT (x10, 0) != 7L
                  || !
#line 2251 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1895; /* lasx_xvfcvth_d_insn */

            case 0L:
              if (XWINT (x8, 0) != 1L)
                return -1;
              switch (XWINT (x9, 0))
                {
                case 4L:
                  if (XWINT (x10, 0) != 5L
                      || !
#line 2275 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1897; /* lasx_xvfcvtl_d_s */

                case 2L:
                  if (XWINT (x10, 0) != 3L
                      || !
#line 2289 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                    return -1;
                  return 1898; /* lasx_xvfcvtl_d_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x5;
      if (!call_insn_operand (operands[1], E_VOIDmode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (
#line 3867 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
        return 357; /* sibcall_value_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 366; /* call_value_internal */

    case LO_SUM:
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !symbolic_operand (operands[2], E_SImode))
            return -1;
          if ((
#line 3894 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
            return 358; /* sibcall_value_internal_1si */
          if (pnum_clobbers == NULL
              || !(
#line 4068 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
            return -1;
          *pnum_clobbers = 1;
          return 367; /* call_value_internal_1si */

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !symbolic_operand (operands[2], E_DImode))
            return -1;
          if ((
#line 3894 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
            return 359; /* sibcall_value_internal_1di */
          if (pnum_clobbers == NULL
              || !(
#line 4068 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 368; /* call_value_internal_1di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 2:
          if (XINT (x3, 1) != 39
              || GET_MODE (x3) != E_DImode)
            return -1;
          x5 = XVECEXP (x3, 0, 1);
          if (GET_CODE (x5) != PC)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC
              || XVECLEN (x7, 0) != 2
              || XINT (x7, 1) != 40
              || GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XVECEXP (x7, 0, 1);
          if (GET_CODE (x8) != PC
              || !register_operand (operands[0], E_DImode))
            return -1;
          x9 = XVECEXP (x3, 0, 0);
          operands[2] = x9;
          x10 = XEXP (x6, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x11 = XVECEXP (x7, 0, 0);
          if (!rtx_equal_p (x11, operands[2])
              || !
#line 2278 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_ABI_LP64 && la_opt_explicit_relocs != EXPLICIT_RELOCS_NONE))
            return -1;
          return 155; /* la_pcrel64_two_parts */

        case 1:
          if (XINT (x3, 1) != 52
              || GET_MODE (x3) != E_BLKmode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x9 = XVECEXP (x3, 0, 0);
          if (!rtx_equal_p (x9, operands[0]))
            return -1;
          return 490; /* mem_thread_fence_1 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (pattern122 (x1) != 0)
            return -1;
          switch (XINT (x3, 1))
            {
            case 3:
              if (!const_uimm14_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  return 222; /* loongarch_csrrd_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 223; /* loongarch_csrrd_d */

                default:
                  return -1;
                }

            case 6:
              if (!register_operand (operands[1], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (!register_operand (operands[0], E_QImode)
                      || GET_MODE (x3) != E_QImode)
                    return -1;
                  return 228; /* loongarch_iocsrrd_b */

                case E_HImode:
                  if (!register_operand (operands[0], E_HImode)
                      || GET_MODE (x3) != E_HImode)
                    return -1;
                  return 229; /* loongarch_iocsrrd_h */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  return 230; /* loongarch_iocsrrd_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !
#line 401 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 231; /* loongarch_iocsrrd_d */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x9 = XVECEXP (x3, 0, 0);
          operands[1] = x9;
          switch (XINT (x3, 1))
            {
            case 4:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern19 (x6) != 0)
                return -1;
              x5 = XVECEXP (x3, 0, 1);
              operands[2] = x5;
              if (!const_uimm14_operand (operands[2], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode
                      || !register_operand (operands[1], E_SImode))
                    return -1;
                  return 224; /* loongarch_csrwr_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !register_operand (operands[1], E_DImode)
                      || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 225; /* loongarch_csrwr_d */

                default:
                  return -1;
                }

            case 49:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              x5 = XVECEXP (x3, 0, 1);
              operands[3] = x5;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x7 = XEXP (x6, 1);
              operands[2] = x7;
              x10 = XEXP (x6, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern209 (x3, 
E_SImode) != 0)
                    return -1;
                  return 517; /* atomic_exchangesi */

                case E_DImode:
                  if (pattern209 (x3, 
E_DImode) != 0
                      || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 518; /* atomic_exchangedi */

                case E_QImode:
                  if (pattern209 (x3, 
E_QImode) != 0
                      || !
#line 233 "../../gcc-15.0.1-20250313/gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                    return -1;
                  return 519; /* atomic_exchangeqi_short */

                case E_HImode:
                  if (pattern209 (x3, 
E_HImode) != 0
                      || !
#line 233 "../../gcc-15.0.1-20250313/gcc/config/loongarch/sync.md"
(ISA_HAS_LAM_BH))
                    return -1;
                  return 520; /* atomic_exchangehi_short */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          if (XINT (x3, 1) != 5
              || pattern122 (x1) != 0)
            return -1;
          x5 = XVECEXP (x3, 0, 1);
          operands[2] = x5;
          x12 = XVECEXP (x3, 0, 2);
          operands[3] = x12;
          if (!const_uimm14_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern213 (x3, 
E_SImode) != 0)
                return -1;
              return 226; /* loongarch_csrxchg_w */

            case E_DImode:
              if (pattern213 (x3, 
E_DImode) != 0
                  || !
#line 375 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 227; /* loongarch_csrxchg_d */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      return recog_132 (x1, insn, pnum_clobbers);

    case CALL:
      x13 = XEXP (x3, 0);
      if (GET_CODE (x13) != MEM)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x14;
          if (!call_insn_operand (operands[1], E_VOIDmode)
              || GET_MODE (x13) != E_SImode)
            return -1;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case SET:
              x7 = XEXP (x6, 1);
              if (GET_CODE (x7) != CALL)
                return -1;
              x16 = XEXP (x7, 0);
              if (GET_CODE (x16) != MEM
                  || GET_MODE (x16) != E_SImode)
                return -1;
              x10 = XEXP (x6, 0);
              operands[3] = x10;
              if (!register_operand (operands[3], E_VOIDmode))
                return -1;
              x17 = XEXP (x16, 0);
              if (!rtx_equal_p (x17, operands[1]))
                return -1;
              x18 = XEXP (x7, 1);
              if (!rtx_equal_p (x18, operands[2]))
                return -1;
              if (
#line 3905 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
                return 360; /* sibcall_value_multiple_internal */
              if (pnum_clobbers == NULL)
                return -1;
              *pnum_clobbers = 1;
              return 369; /* call_value_multiple_internal */

            case CLOBBER:
              x10 = XEXP (x6, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 1
                  || GET_MODE (x10) != E_SImode)
                return -1;
              return 366; /* call_value_internal */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x14, 0) != 2)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != CALL)
            return -1;
          x16 = XEXP (x7, 0);
          if (GET_CODE (x16) != MEM)
            return -1;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != UNSPEC
              || XVECLEN (x17, 0) != 2)
            return -1;
          x19 = XVECEXP (x14, 0, 0);
          operands[1] = x19;
          x20 = XVECEXP (x14, 0, 1);
          operands[2] = x20;
          x15 = XEXP (x3, 1);
          operands[3] = x15;
          x10 = XEXP (x6, 0);
          operands[4] = x10;
          if (!register_operand (operands[4], E_VOIDmode))
            return -1;
          x21 = XVECEXP (x17, 0, 0);
          if (!rtx_equal_p (x21, operands[1]))
            return -1;
          x22 = XVECEXP (x17, 0, 1);
          if (!rtx_equal_p (x22, operands[2]))
            return -1;
          x18 = XEXP (x7, 1);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          switch (XINT (x14, 1))
            {
            case 36:
              if (XINT (x17, 1) != 36)
                return -1;
              switch (GET_MODE (x13))
                {
                case E_SImode:
                  if (pattern220 (x1, 
E_SImode) != 0
                      || !(
#line 3938 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  return 361; /* sibcall_value_multiple_internal_1si */

                case E_DImode:
                  if (pattern220 (x1, 
E_DImode) != 0
                      || !(
#line 3938 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  return 362; /* sibcall_value_multiple_internal_1di */

                default:
                  return -1;
                }

            case 37:
              if (pnum_clobbers == NULL
                  || XINT (x17, 1) != 37)
                return -1;
              switch (GET_MODE (x13))
                {
                case E_SImode:
                  if (pattern220 (x1, 
E_SImode) != 0
                      || !(
#line 4114 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 370; /* call_value_multiple_internal_1si */

                case E_DImode:
                  if (pattern220 (x1, 
E_DImode) != 0
                      || !(
#line 4114 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 371; /* call_value_multiple_internal_1di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LO_SUM:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern99 (x6) != 0)
            return -1;
          x23 = XEXP (x14, 0);
          operands[1] = x23;
          x24 = XEXP (x14, 1);
          operands[2] = x24;
          x15 = XEXP (x3, 1);
          operands[3] = x15;
          switch (GET_MODE (x13))
            {
            case E_SImode:
              if (GET_MODE (x14) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !symbolic_operand (operands[2], E_SImode)
                  || !(
#line 4068 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return -1;
              return 367; /* call_value_internal_1si */

            case E_DImode:
              if (GET_MODE (x14) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !symbolic_operand (operands[2], E_DImode)
                  || !(
#line 4068 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 386 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return -1;
              return 368; /* call_value_internal_1di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern96 (x1, 
SIGN_EXTEND) != 0
          || !
#line 4447 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(reload_completed))
        return -1;
      return 444; /* *join2_loadhi */

    case ZERO_EXTEND:
      if (pattern96 (x1, 
ZERO_EXTEND) != 0
          || !
#line 4447 "../../gcc-15.0.1-20250313/gcc/config/loongarch/loongarch.md"
(reload_completed))
        return -1;
      return 445; /* *join2_loadhi */

    case SMUL_HIGHPART:
      switch (pattern98 (x1, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 603; /* smulv2di3_highpart */

        case 1:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 605; /* smulv4si3_highpart */

        case 2:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 607; /* smulv8hi3_highpart */

        case 3:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 609; /* smulv16qi3_highpart */

        case 4:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 611; /* smulv4di3_highpart */

        case 5:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 613; /* smulv8si3_highpart */

        case 6:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 615; /* smulv16hi3_highpart */

        case 7:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 617; /* smulv32qi3_highpart */

        default:
          return -1;
        }

    case UMUL_HIGHPART:
      switch (pattern98 (x1, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 604; /* umulv2di3_highpart */

        case 1:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 606; /* umulv4si3_highpart */

        case 2:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 608; /* umulv8hi3_highpart */

        case 3:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LSX))
            return -1;
          return 610; /* umulv16qi3_highpart */

        case 4:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 612; /* umulv4di3_highpart */

        case 5:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 614; /* umulv8si3_highpart */

        case 6:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 616; /* umulv16hi3_highpart */

        case 7:
          if (!
#line 39 "../../gcc-15.0.1-20250313/gcc/config/loongarch/simd.md"
(ISA_HAS_LASX))
            return -1;
          return 618; /* umulv32qi3_highpart */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x15 = XEXP (x3, 1);
      if (GET_CODE (x15) != LABEL_REF)
        return -1;
      x25 = XEXP (x3, 2);
      if (GET_CODE (x25) != PC)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PC)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x26 = XEXP (x15, 0);
      operands[0] = x26;
      x10 = XEXP (x6, 0);
      operands[3] = x10;
      if (!scratch_operand (operands[3], E_FCCmode))
        return -1;
      x13 = XEXP (x3, 0);
      switch (GET_CODE (x13))
        {
        case EQ:
          switch (pattern203 (x13))
            {
            case 0:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1288; /* lsx_bz_d */

            case 1:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1290; /* lsx_bz_w */

            case 2:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1292; /* lsx_bz_h */

            case 3:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1294; /* lsx_bz_b */

            case 4:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1296; /* lsx_bz_d_f */

            case 5:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1298; /* lsx_bz_w_f */

            case 6:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1300; /* lsx_bz_v_d */

            case 7:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1302; /* lsx_bz_v_w */

            case 8:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1304; /* lsx_bz_v_h */

            case 9:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1306; /* lsx_bz_v_b */

            case 10:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1308; /* lsx_bz_v_d_f */

            case 11:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1310; /* lsx_bz_v_w_f */

            case 12:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1899; /* lasx_xbz_d */

            case 13:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1901; /* lasx_xbz_w */

            case 14:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1903; /* lasx_xbz_h */

            case 15:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1905; /* lasx_xbz_b */

            case 16:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1907; /* lasx_xbz_d_f */

            case 17:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1909; /* lasx_xbz_w_f */

            case 18:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1911; /* lasx_xbz_v_d */

            case 19:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1913; /* lasx_xbz_v_w */

            case 20:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1915; /* lasx_xbz_v_h */

            case 21:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1917; /* lasx_xbz_v_b */

            case 22:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1919; /* lasx_xbz_v_d_f */

            case 23:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1921; /* lasx_xbz_v_w_f */

            default:
              return -1;
            }

        case NE:
          switch (pattern203 (x13))
            {
            case 0:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1289; /* lsx_bnz_d */

            case 1:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1291; /* lsx_bnz_w */

            case 2:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1293; /* lsx_bnz_h */

            case 3:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1295; /* lsx_bnz_b */

            case 4:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1297; /* lsx_bnz_d_f */

            case 5:
              if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1299; /* lsx_bnz_w_f */

            case 6:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1301; /* lsx_bnz_v_d */

            case 7:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1303; /* lsx_bnz_v_w */

            case 8:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1305; /* lsx_bnz_v_h */

            case 9:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1307; /* lsx_bnz_v_b */

            case 10:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1309; /* lsx_bnz_v_d_f */

            case 11:
              if (!
#line 1896 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lsx.md"
(ISA_HAS_LSX))
                return -1;
              return 1311; /* lsx_bnz_v_w_f */

            case 12:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1900; /* lasx_xbnz_d */

            case 13:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1902; /* lasx_xbnz_w */

            case 14:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1904; /* lasx_xbnz_h */

            case 15:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1906; /* lasx_xbnz_b */

            case 16:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1908; /* lasx_xbnz_d_f */

            case 17:
              if (!
#line 2325 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1910; /* lasx_xbnz_w_f */

            case 18:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1912; /* lasx_xbnz_v_d */

            case 19:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1914; /* lasx_xbnz_v_w */

            case 20:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1916; /* lasx_xbnz_v_h */

            case 21:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1918; /* lasx_xbnz_v_b */

            case 22:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1920; /* lasx_xbnz_v_d_f */

            case 23:
              if (!
#line 2344 "../../gcc-15.0.1-20250313/gcc/config/loongarch/lasx.md"
(ISA_HAS_LASX))
                return -1;
              return 1922; /* lasx_xbnz_v_w_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
