/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      return 0;

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern11 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1)
      || !general_src_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !general_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !general_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_XFmode:
      if (!nonimmediate_operand (operands[0], E_XFmode)
          || GET_MODE (x1) != E_XFmode
          || !general_operand (operands[1], E_XFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XWINT (x2, 0))
    {
    case 0L:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x3;
          if (!movsi_const0_operand (operands[0], E_SImode))
            return -1;
          if (
#line 867 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TUNE_68000_10))
            return 51; /* *movsi_const0_68000_10 */
          if (
#line 880 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TUNE_68040_60))
            return 52; /* *movsi_const0_68040_60 */
          if (!
#line 898 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!(TUNE_68000_10 || TUNE_68040_60)))
            return -1;
          return 53; /* *movsi_const0 */

        case ZERO_EXTRACT:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XEXP (x3, 0);
          operands[0] = x4;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) == CONST_INT)
            {
              res = recog_5 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (!memory_operand (operands[0], E_QImode))
            return -1;
          operands[1] = x5;
          if (!nonmemory_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x3, 2);
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode)
              || !
#line 5649 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD))
            return -1;
          return 370; /* *insv_bfclr_mem */

        default:
          return -1;
        }

    case -1L:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != ZERO_EXTRACT
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!memory_operand (operands[0], E_QImode)
              || !general_operand (operands[1], E_SImode)
              || !general_operand (operands[2], E_SImode)
              || !
#line 5659 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD))
            return -1;
          return 371; /* *insv_bfset_mem */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !const_int_operand (operands[1], E_SImode)
              || !const_int_operand (operands[2], E_SImode)
              || !
#line 5727 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD && IN_RANGE (INTVAL (operands[2]), 0, 31)))
            return -1;
          return 376; /* *insv_bfset_reg */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      if (register_operand (operands[1], E_SImode)
          && register_operand (operands[0], E_SImode)
          && const_int_operand (operands[2], E_SImode)
          && 
#line 3661 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
        return 245; /* *andsi3_split */
      if (!general_operand (operands[1], E_SImode)
          || !not_sp_operand (operands[0], E_SImode)
          || !general_src_operand (operands[2], E_SImode))
        return -1;
      if (
#line 3670 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return 246; /* andsi3_internal */
      if (!
#line 3680 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
        return -1;
      return 247; /* andsi3_5200 */

    case ROTATE:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != AND
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 31]
          || !register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 358; /* *bclrdreg */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (memory_src_operand (operands[1], E_QImode)
      && XWINT (x3, 0) == 32L)
    {
      x5 = XEXP (x2, 2);
      operands[2] = x5;
      if (const_int_operand (operands[2], E_SImode)
          && 
#line 5563 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[2]) % 8) == 0
   && ! mode_dependent_address_p (XEXP (operands[1], 0),
                                  MEM_ADDR_SPACE (operands[1]))))
        return 365; /* *extv_32_mem */
    }
  if (!register_operand (operands[1], E_SImode))
    return -1;
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  if (
#line 5579 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && IN_RANGE (INTVAL (operands[3]), 0, 31)
   && (INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16)
   && INTVAL (operands[3]) % INTVAL (operands[2]) == 0))
    return 366; /* *extv_8_16_reg */
  if (!
#line 5699 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD && IN_RANGE (INTVAL (operands[3]), 0, 31)))
    return -1;
  return 373; /* *extv_bfexts_reg */
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          operands[1] = x3;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern10 (x2, 
E_SImode) != 0)
                return -1;
              if (
#line 3890 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 265; /* xorsi3_internal */
              if (!
#line 3900 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
                return -1;
              return 266; /* xorsi3_5200 */

            case E_HImode:
              if (pattern10 (x2, 
E_HImode) != 0
                  || !
#line 3910 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 267; /* xorhi3 */

            case E_QImode:
              if (pattern10 (x2, 
E_QImode) != 0
                  || !
#line 3934 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 270; /* xorqi3 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          switch (pattern0 (x2))
            {
            case 0:
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (general_operand (operands[1], E_HImode)
                  && rtx_equal_p (x3, operands[0])
                  && 
#line 3918 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 268; /* *m68k.md:3914 */
              operands[1] = x3;
              if (!general_operand (operands[1], E_HImode)
                  || !rtx_equal_p (x5, operands[0])
                  || !
#line 3926 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 269; /* *m68k.md:3922 */

            case 1:
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (general_operand (operands[1], E_QImode)
                  && rtx_equal_p (x3, operands[0])
                  && 
#line 3942 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 271; /* *m68k.md:3938 */
              operands[1] = x3;
              if (!general_operand (operands[1], E_QImode)
                  || !rtx_equal_p (x5, operands[0])
                  || !
#line 3950 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 272; /* *m68k.md:3946 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern3 (x1) != 0)
        return -1;
      return 357; /* *bchgdreg */

    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!nonmemory_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!nonmemory_operand (operands[2], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x9 = XEXP (x3, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return -1;
      x10 = XEXP (x3, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x3, 2);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 5636 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[3]) == -1
       || (GET_CODE (operands[1]) == CONST_INT
           && (~ INTVAL (operands[3]) & ((1 << INTVAL (operands[1]))- 1)) == 0))))
        return -1;
      return 369; /* *insv_bfchg_mem */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (memory_operand (operands[0], E_SImode)
      && const_int_operand (operands[1], E_SImode)
      && 
#line 6350 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(GET_CODE (XEXP (operands[0], 0)) != PRE_DEC
   && INTVAL (operands[1]) != 0
   && IN_RANGE (INTVAL (operands[1]), -0x80, 0x7f)
   && !valid_mov3q_const (INTVAL (operands[1]))))
    {
      *pmatch_len_ = 0;
      res = gen_peephole2_5 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 2
      || !register_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != IF_THEN_ELSE)
    return NULL;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != PC)
    return NULL;
  x6 = XEXP (x4, 1);
  if (!pc_or_label_operand (x6, E_VOIDmode))
    return NULL;
  operands[3] = x6;
  if (addq_subq_operand (operands[1], E_SImode))
    {
      x7 = XEXP (x4, 0);
      if (equality_comparison_operator (x7, E_VOIDmode))
        {
          operands[5] = x7;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (register_operand (operands[2], E_SImode))
            {
              x9 = XEXP (x4, 2);
              operands[4] = x9;
              if (pc_or_label_operand (operands[4], E_VOIDmode))
                {
                  x10 = XEXP (x7, 1);
                  if (rtx_equal_p (x10, operands[0])
                      && 
#line 6771 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])
   && (operands[3] == pc_rtx || operands[4] == pc_rtx)
   && DATA_REG_P (operands[2])
   && !rtx_equal_p (operands[0], operands[2])))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_14 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  operands[4] = x6;
  if (!pow2_m1_operand (operands[1], E_SImode))
    return NULL;
  x9 = XEXP (x4, 2);
  operands[5] = x9;
  if (!pc_or_label_operand (operands[5], E_VOIDmode))
    return NULL;
  x7 = XEXP (x4, 0);
  switch (GET_CODE (x7))
    {
    case GTU:
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return NULL;
      x10 = XEXP (x7, 1);
      operands[3] = x10;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 6789 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(INTVAL (operands[1]) <= 255
   && operands[0] == operands[3]
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])
   && (operands[4] == pc_rtx || operands[5] == pc_rtx)
   && (optimize_size || TUNE_68040_60)
   && DATA_REG_P (operands[2])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_15 (insn, operands);

    case LEU:
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return NULL;
      x10 = XEXP (x7, 1);
      operands[3] = x10;
      if (!register_operand (operands[3], E_SImode)
          || !
#line 6827 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(INTVAL (operands[1]) <= 255
   && operands[0] == operands[3]
   && peep2_reg_dead_p (2, operands[0])
   && peep2_reg_dead_p (2, operands[2])
   && (operands[4] == pc_rtx || operands[5] == pc_rtx)
   && (optimize_size || TUNE_68040_60)
   && DATA_REG_P (operands[2])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_17 (insn, operands);

    default:
      return NULL;
    }
}
