/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      return 0;

    case STRICT_LOW_PART:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      res = pattern0 (x3);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern15 (x1, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern15 (x1, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_XFmode:
      if (pattern15 (x1, 
E_XFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern25 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!fp_src_operand (operands[1], E_SFmode)
          || !fp_src_operand (operands[2], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!fp_src_operand (operands[1], E_DFmode)
          || !fp_src_operand (operands[2], E_DFmode))
        return -1;
      return 1;

    case E_XFmode:
      if (!fp_src_operand (operands[1], E_XFmode)
          || !fp_src_operand (operands[2], E_XFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      switch (XWINT (x4, 0))
        {
        case 63L:
          if (pnum_clobbers == NULL
              || !nonimmediate_operand (operands[0], E_DImode)
              || !general_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x2, 1);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          *pnum_clobbers = 1;
          return 143; /* adddi_lshrdi_63 */

        case 32L:
          x7 = XEXP (x2, 1);
          operands[2] = x7;
          if (general_operand (operands[2], E_DImode)
              && nonimmediate_operand (operands[0], E_DImode)
              && general_operand (operands[1], E_DImode)
              && 
#line 2349 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return 145; /* *adddi_dilshr32 */
          if (!register_operand (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 2363 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
            return -1;
          return 146; /* *adddi_dilshr32_cf */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!general_operand (operands[2], E_DImode))
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x6) != E_DImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!general_operand (operands[1], E_HImode)
              || !
#line 2334 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          *pnum_clobbers = 1;
          return 144; /* adddi_sexthishl32 */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x6;
          if (!general_operand (operands[1], E_DImode))
            return -1;
          return 147; /* adddi_dishl32 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x5 = XEXP (x1, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern12 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 148; /* adddi3 */

            case 1:
              if (!
#line 2574 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 153; /* addhi3 */

            case 2:
              if (!
#line 2731 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 156; /* addqi3 */

            case 3:
              if (
#line 2835 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 168; /* addsf3_68881 */
              if (!
#line 2848 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 171; /* addsf3_cf */

            case 4:
              if (
#line 2835 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 169; /* adddf3_68881 */
              if (!
#line 2848 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 172; /* adddf3_cf */

            case 5:
              if (!
#line 2835 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 170; /* addxf3_68881 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          x9 = XEXP (x5, 0);
          operands[0] = x9;
          switch (pattern0 (x2))
            {
            case 0:
              x7 = XEXP (x2, 1);
              operands[1] = x7;
              if (general_src_operand (operands[1], E_HImode)
                  && rtx_equal_p (x3, operands[0])
                  && 
#line 2633 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 154; /* *m68k.md:2629 */
              operands[1] = x3;
              if (!general_src_operand (operands[1], E_HImode)
                  || !rtx_equal_p (x7, operands[0])
                  || !
#line 2682 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 155; /* *m68k.md:2678 */

            case 1:
              x7 = XEXP (x2, 1);
              operands[1] = x7;
              if (general_src_operand (operands[1], E_QImode)
                  && rtx_equal_p (x3, operands[0])
                  && 
#line 2755 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 157; /* *m68k.md:2751 */
              operands[1] = x3;
              if (!general_src_operand (operands[1], E_QImode)
                  || !rtx_equal_p (x7, operands[0])
                  || !
#line 2778 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 158; /* *m68k.md:2774 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern14 (x2))
        {
        case 0:
          if (general_operand (operands[2], E_SImode)
              && 
#line 2808 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 159; /* addsf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 2817 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 162; /* addsf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 2826 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 165; /* addsf3_floatqi_68881 */

        case 1:
          if (general_operand (operands[2], E_SImode)
              && 
#line 2808 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 160; /* adddf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 2817 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 163; /* adddf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 2826 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 166; /* adddf3_floatqi_68881 */

        case 2:
          if (general_operand (operands[2], E_SImode)
              && 
#line 2808 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 161; /* addxf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 2817 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 164; /* addxf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 2826 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 167; /* addxf3_floatqi_68881 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case FLOAT:
      switch (pattern16 (x3))
        {
        case 0:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3457 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 225; /* divsf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3468 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 228; /* divsf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3479 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 231; /* divsf3_floatqi_68881 */

        case 1:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3457 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 226; /* divdf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3468 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 229; /* divdf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3479 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 232; /* divdf3_floatqi_68881 */

        case 2:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3457 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 227; /* divxf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3468 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 230; /* divxf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3479 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 233; /* divxf3_floatqi_68881 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern10 (x3, 
E_SFmode) != 0)
            return -1;
          if (
#line 3490 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 234; /* divsf3_68881 */
          if (!
#line 3505 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 237; /* divsf3_cf */

        case E_DFmode:
          if (pattern10 (x3, 
E_DFmode) != 0)
            return -1;
          if (
#line 3490 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 235; /* divdf3_68881 */
          if (!
#line 3505 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 238; /* divdf3_cf */

        case E_XFmode:
          if (pattern10 (x3, 
E_XFmode) != 0
              || !
#line 3490 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 236; /* divxf3_68881 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
