/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !general_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !general_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_XFmode:
      if (!nonimmediate_operand (operands[0], E_XFmode)
          || GET_MODE (x3) != E_XFmode
          || !general_operand (operands[1], E_XFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !register_operand (operands[1], E_SImode)
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern26 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          if (general_src_operand (operands[1], E_QImode))
            return 91; /* extendqidi2 */
          if (general_src_operand (operands[1], E_HImode))
            return 92; /* extendhidi2 */
          if (pnum_clobbers == NULL
              || !nonimmediate_src_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 93; /* extendsidi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 97; /* extendqihi2 */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!general_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      return 94; /* extendplussidi */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!general_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      return 149; /* addsi_lshrsi_31 */

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (pattern19 (x2))
        {
        case 0:
          if (
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(! TARGET_COLDFIRE))
            return 150; /* *addsi3_internal */
          if (!
#line 2517 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
            return -1;
          return 151; /* *addsi3_5200 */

        case 1:
          if (!
#line 2567 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 152; /* *m68k.md:2562 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case LABEL_REF:
          x6 = XEXP (x2, 2);
          if (GET_CODE (x6) != PC)
            return -1;
          if (pnum_clobbers != NULL)
            {
              operands[1] = x3;
              operands[2] = x4;
              if (nonimmediate_operand (operands[2], E_DImode))
                {
                  x7 = XEXP (x3, 1);
                  operands[3] = x7;
                  if (general_operand (operands[3], E_DImode))
                    {
                      x8 = XEXP (x5, 0);
                      operands[4] = x8;
                      *pnum_clobbers = 2;
                      return 5; /* cbranchdi4_insn */
                    }
                }
            }
          operands[0] = x3;
          operands[1] = x4;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          x8 = XEXP (x5, 0);
          operands[3] = x8;
          switch (pattern26 ())
            {
            case 0:
              if (general_operand (operands[2], E_QImode)
                  && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 6; /* cbranchqi4_insn */
              if (!const0_operand (operands[2], E_QImode)
                  || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
                return -1;
              return 12; /* cbranchqi4_insn_cf */

            case 1:
              if (general_operand (operands[2], E_HImode)
                  && 
#line 510 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 7; /* cbranchhi4_insn */
              if (!const0_operand (operands[2], E_HImode)
                  || !
#line 540 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
                return -1;
              return 13; /* cbranchhi4_insn_cf */

            case 2:
              if (
#line 510 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 8; /* cbranchsi4_insn */
              if (!
#line 540 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
                return -1;
              return 14; /* cbranchsi4_insn_cf */

            default:
              return -1;
            }

        case PC:
          x6 = XEXP (x2, 2);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          operands[0] = x3;
          operands[1] = x4;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          x9 = XEXP (x6, 0);
          operands[3] = x9;
          switch (pattern26 ())
            {
            case 0:
              if (general_operand (operands[2], E_QImode)
                  && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 9; /* cbranchqi4_insn_rev */
              if (!const0_operand (operands[2], E_QImode)
                  || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
                return -1;
              return 15; /* cbranchqi4_insn_cf_rev */

            case 1:
              if (general_operand (operands[2], E_HImode)
                  && 
#line 525 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 10; /* cbranchhi4_insn_rev */
              if (!const0_operand (operands[2], E_HImode)
                  || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
                return -1;
              return 16; /* cbranchhi4_insn_cf_rev */

            case 2:
              if (
#line 525 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 11; /* cbranchsi4_insn_rev */
              if (!
#line 555 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
                return -1;
              return 17; /* cbranchsi4_insn_cf_rev */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      operands[0] = x3;
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x11 = XEXP (x4, 1);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x4, 2);
      operands[3] = x12;
      if (!general_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[4] = x8;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!memory_operand (operands[1], E_QImode)
              || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && (!REG_P (operands[1]) || !CONST_INT_P (operands[3])
       || IN_RANGE (INTVAL (operands[3]), 0, 31))))
            return -1;
          return 28; /* cbranch_bftstqi_insn */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && (!REG_P (operands[1]) || !CONST_INT_P (operands[3])
       || IN_RANGE (INTVAL (operands[3]), 0, 31))))
            return -1;
          return 29; /* cbranch_bftstsi_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case IF_THEN_ELSE:
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x5 = XEXP (x3, 2);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case EQ:
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          if (!general_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x10, 0);
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_SImode))
            return -1;
          return 3; /* beq0_di */

        case NE:
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          x10 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x10))
            {
            case CLOBBER:
              if (!general_operand (operands[0], E_DImode))
                return -1;
              x12 = XEXP (x10, 0);
              operands[2] = x12;
              if (!scratch_operand (operands[2], E_SImode))
                return -1;
              return 4; /* bne0_di */

            case SET:
              x13 = XEXP (x10, 1);
              if (GET_CODE (x13) != PLUS)
                return -1;
              x14 = XEXP (x13, 1);
              if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
                return -1;
              x15 = XEXP (x13, 0);
              if (!rtx_equal_p (x15, operands[0]))
                return -1;
              x12 = XEXP (x10, 0);
              if (!rtx_equal_p (x12, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (!nonimmediate_operand (operands[0], E_HImode)
                      || GET_MODE (x13) != E_HImode
                      || !
#line 5870 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                    return -1;
                  return 386; /* *dbne_hi */

                case E_SImode:
                  if (!nonimmediate_operand (operands[0], E_SImode)
                      || GET_MODE (x13) != E_SImode
                      || !
#line 5889 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                    return -1;
                  return 387; /* *dbne_si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GE:
          x11 = XEXP (x8, 0);
          if (GET_CODE (x11) != PLUS)
            return -1;
          x16 = XEXP (x11, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != SET)
            return -1;
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != PLUS)
            return -1;
          x14 = XEXP (x13, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
            return -1;
          x17 = XEXP (x11, 0);
          operands[0] = x17;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0]))
            return -1;
          x12 = XEXP (x10, 0);
          if (!rtx_equal_p (x12, operands[0]))
            return -1;
          switch (GET_MODE (x11))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x13) != E_HImode
                  || !
#line 5911 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE && find_reg_note (insn, REG_NONNEG, 0)))
                return -1;
              return 388; /* *dbge_hi */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x13) != E_SImode
                  || !
#line 5945 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE && find_reg_note (insn, REG_NONNEG, 0)))
                return -1;
              return 389; /* *dbge_si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!nonimmediate_src_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x10, 0);
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 93; /* extendsidi2 */

    case PLUS:
      x8 = XEXP (x3, 0);
      switch (GET_CODE (x8))
        {
        case LSHIFTRT:
          if (GET_MODE (x8) != E_DImode
              || pattern21 (x1, 
63) != 0)
            return -1;
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          if (!general_operand (operands[1], E_DImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x10, 0);
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_SImode))
            return -1;
          x4 = XEXP (x3, 1);
          if (!rtx_equal_p (x4, operands[1]))
            return -1;
          return 143; /* adddi_lshrdi_63 */

        case ASHIFT:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x11 = XEXP (x8, 0);
          if (GET_CODE (x11) != SIGN_EXTEND
              || GET_MODE (x11) != E_DImode
              || pattern21 (x1, 
32) != 0)
            return -1;
          x17 = XEXP (x11, 0);
          operands[1] = x17;
          if (!general_operand (operands[1], E_HImode))
            return -1;
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          if (!general_operand (operands[2], E_DImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x10, 0);
          operands[3] = x12;
          if (!scratch_operand (operands[3], E_SImode)
              || !
#line 2334 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 144; /* adddi_sexthishl32 */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x8;
          if (!general_operand (operands[1], E_DImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          if (!general_operand (operands[2], E_DImode))
            return -1;
          x12 = XEXP (x10, 0);
          operands[3] = x12;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          return 148; /* adddi3 */

        case PC:
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != PC)
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != USE)
            return -1;
          x12 = XEXP (x10, 0);
          if (GET_CODE (x12) != LABEL_REF
              || GET_MODE (x3) != E_SImode)
            return -1;
          x18 = XEXP (x12, 0);
          operands[1] = x18;
          x4 = XEXP (x3, 1);
          switch (GET_CODE (x4))
            {
            case REG:
            case SUBREG:
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 5826 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_LONG_JUMP_TABLE_OFFSETS))
                return -1;
              return 384; /* *tablejump_pcrel_si */

            case SIGN_EXTEND:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x7 = XEXP (x4, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_HImode)
                  || !
#line 5840 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_LONG_JUMP_TABLE_OFFSETS))
                return -1;
              return 385; /* *tablejump_pcrel_hi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!general_operand (operands[1], E_DImode))
        return -1;
      x12 = XEXP (x10, 0);
      operands[3] = x12;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case ASHIFT:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x7 = XEXP (x4, 0);
          if (GET_CODE (x7) != SIGN_EXTEND
              || GET_MODE (x7) != E_DImode)
            return -1;
          x19 = XEXP (x4, 1);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x20 = XEXP (x7, 0);
          operands[2] = x20;
          if (!general_operand (operands[2], E_HImode)
              || !
#line 2865 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 173; /* subdi_sexthishl32 */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x4;
          if (!general_operand (operands[2], E_DImode))
            return -1;
          return 175; /* subdi3 */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x13 = XEXP (x10, 1);
      if (GET_CODE (x13) != TRUNCATE
          || GET_MODE (x13) != E_SImode)
        return -1;
      x15 = XEXP (x13, 0);
      if (GET_CODE (x15) != LSHIFTRT
          || GET_MODE (x15) != E_DImode)
        return -1;
      x21 = XEXP (x15, 0);
      if (GET_CODE (x21) != MULT
          || GET_MODE (x21) != E_DImode)
        return -1;
      x22 = XEXP (x15, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      x12 = XEXP (x10, 0);
      operands[3] = x12;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x23 = XEXP (x21, 0);
      if (GET_MODE (x23) != E_DImode)
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
        case MEM:
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          x24 = XEXP (x21, 1);
          if (GET_MODE (x24) != E_DImode)
            return -1;
          switch (GET_CODE (x23))
            {
            case ZERO_EXTEND:
              if (GET_CODE (x24) != ZERO_EXTEND)
                return -1;
              x25 = XEXP (x23, 0);
              if (!rtx_equal_p (x25, operands[1]))
                return -1;
              x26 = XEXP (x24, 0);
              if (!rtx_equal_p (x26, operands[2])
                  || !
#line 3200 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TUNE_68060 && !TARGET_COLDFIRE))
                return -1;
              return 203; /* *m68k.md:3192 */

            case SIGN_EXTEND:
              if (GET_CODE (x24) != SIGN_EXTEND)
                return -1;
              x25 = XEXP (x23, 0);
              if (!rtx_equal_p (x25, operands[1]))
                return -1;
              x26 = XEXP (x24, 0);
              if (!rtx_equal_p (x26, operands[2])
                  || !
#line 3239 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TUNE_68060 && !TARGET_COLDFIRE))
                return -1;
              return 205; /* *m68k.md:3231 */

            default:
              return -1;
            }

        case CONST_INT:
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x24 = XEXP (x21, 1);
          if (!rtx_equal_p (x24, operands[2]))
            return -1;
          switch (GET_CODE (x23))
            {
            case ZERO_EXTEND:
              x25 = XEXP (x23, 0);
              if (!rtx_equal_p (x25, operands[1])
                  || !
#line 3215 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TUNE_68060 && !TARGET_COLDFIRE
   && (unsigned) INTVAL (operands[2]) <= 0x7fffffff))
                return -1;
              return 204; /* *m68k.md:3207 */

            case SIGN_EXTEND:
              x25 = XEXP (x23, 0);
              if (!rtx_equal_p (x25, operands[1])
                  || !
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TUNE_68060 && !TARGET_COLDFIRE))
                return -1;
              return 206; /* *m68k.md:3242 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != LSHIFTRT
          || GET_MODE (x8) != E_DImode)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != MULT
          || GET_MODE (x11) != E_DImode)
        return -1;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x17 = XEXP (x11, 0);
      if (GET_MODE (x17) != E_DImode)
        return -1;
      x12 = XEXP (x10, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_CODE (x17))
        {
        case ZERO_EXTEND:
          x27 = XEXP (x17, 0);
          operands[2] = x27;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x16 = XEXP (x11, 1);
          switch (GET_CODE (x16))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x16) != E_DImode)
                return -1;
              x28 = XEXP (x16, 0);
              operands[3] = x28;
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !
#line 3286 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TUNE_68060 && !TARGET_COLDFIRE))
                return -1;
              return 207; /* *m68k.md:3278 */

            case CONST_INT:
            case CONST_DOUBLE:
              operands[3] = x16;
              if (!const_uint32_operand (operands[3], E_DImode)
                  || !
#line 3297 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TUNE_68060 && !TARGET_COLDFIRE))
                return -1;
              return 208; /* const_umulsi3_highpart */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x27 = XEXP (x17, 0);
          operands[2] = x27;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x16 = XEXP (x11, 1);
          switch (GET_CODE (x16))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x16) != E_DImode)
                return -1;
              x28 = XEXP (x16, 0);
              operands[3] = x28;
              if (!nonimmediate_operand (operands[3], E_SImode)
                  || !
#line 3329 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TUNE_68060 && !TARGET_COLDFIRE))
                return -1;
              return 209; /* *m68k.md:3321 */

            case CONST_INT:
              operands[3] = x16;
              if (!const_sint32_operand (operands[3], E_DImode)
                  || !
#line 3340 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TUNE_68060 && !TARGET_COLDFIRE))
                return -1;
              return 210; /* const_smulsi3_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      switch (pattern8 (x1, 
MOD))
        {
        case 0:
          if (
#line 3532 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_CF_HWDIV))
            return 239; /* *m68k.md:3526 */
          if (!
#line 3550 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020))
            return -1;
          return 240; /* *m68k.md:3544 */

        case 1:
          if (!
#line 3606 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE || TARGET_CF_HWDIV))
            return -1;
          return 243; /* divmodhi4 */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern8 (x1, 
UMOD))
        {
        case 0:
          if (
#line 3574 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_CF_HWDIV))
            return 241; /* *m68k.md:3568 */
          if (!
#line 3592 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TARGET_COLDFIRE))
            return -1;
          return 242; /* *m68k.md:3586 */

        case 1:
          if (!
#line 3624 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE || TARGET_CF_HWDIV))
            return -1;
          return 244; /* udivmodhi4 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != SIGN_EXTEND
          || GET_MODE (x8) != E_DImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!general_operand (operands[1], E_HImode))
        return -1;
      x12 = XEXP (x10, 0);
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 305; /* ashldi_sexthi */

    case ASHIFTRT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!nonimmediate_src_operand (operands[1], E_DImode))
        return -1;
      x12 = XEXP (x10, 0);
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 322; /* *ashrdi_const32_mem */

    case REG:
    case SUBREG:
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != USE)
        return -1;
      x12 = XEXP (x10, 0);
      if (GET_CODE (x12) != LABEL_REF)
        return -1;
      x18 = XEXP (x12, 0);
      operands[1] = x18;
      return 383; /* *tablejump_internal */

    default:
      return -1;
    }
}
