/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != AND
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 31])
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x2, 1);
  operands[2] = x9;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!general_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[2] = x3;
      if (!general_src_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!nonimmediate_src_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SUBREG:
      if (known_eq (SUBREG_BYTE (x2), 6)
          && GET_MODE (x2) == E_HImode)
        {
          x3 = XEXP (x2, 0);
          if (GET_CODE (x3) == ASHIFTRT
              && GET_MODE (x3) == E_DImode)
            {
              x4 = XEXP (x3, 1);
              if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 32])
                {
                  x5 = XEXP (x1, 0);
                  operands[0] = x5;
                  if (nonimmediate_operand (operands[0], E_HImode))
                    {
                      x6 = XEXP (x3, 0);
                      operands[1] = x6;
                      if (general_operand (operands[1], E_DImode))
                        return 318; /* subreghi1ashrdi_const32 */
                    }
                }
            }
        }
      break;

    case LABEL_REF:
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) == PC)
        {
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          return 382; /* jump */
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  if (!general_src_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  if (
#line 996 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE && reload_completed))
    return 54; /* *movsi_m68k */
  if (!
#line 1009 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
    return -1;
  return 55; /* *movsi_m68k2 */
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!nonimmediate_src_operand (operands[1], E_HImode))
        return -1;
      if (
#line 1959 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(ISA_HAS_MVS_MVZ))
        return 95; /* *cfv4_extendhisi2 */
      if (!
#line 1967 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!ISA_HAS_MVS_MVZ))
        return -1;
      return 96; /* *68k_extendhisi2 */

    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      if (
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(ISA_HAS_MVS_MVZ))
        return 98; /* *cfv4_extendqisi2 */
      if (!
#line 1996 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 || (TARGET_COLDFIRE && !ISA_HAS_MVS_MVZ)))
        return -1;
      return 99; /* *68k_extendqisi2 */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!general_operand (operands[0], E_DImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  switch (GET_CODE (x3))
    {
    case EQ:
      *pnum_clobbers = 1;
      return 3; /* beq0_di */

    case NE:
      *pnum_clobbers = 1;
      return 4; /* bne0_di */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  if (ordered_comparison_operator (operands[1], E_QImode))
    {
      res = recog_21 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!m68k_cstore_comparison_operator (operands[1], E_QImode))
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!fp_src_operand (operands[2], E_SFmode))
        return -1;
      if (fp_src_operand (operands[3], E_SFmode)
          && 
#line 815 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_HARD_FLOAT && !(TUNE_68060 || TARGET_COLDFIRE_FPU)
   && (register_operand (operands[2], SFmode)
       || register_operand (operands[3], SFmode)
       || const0_operand (operands[3], SFmode))))
        return 44; /* cstoresf4_insn_68881 */
      if (!const0_operand (operands[3], E_SFmode)
          || !
#line 832 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_HARD_FLOAT && TARGET_COLDFIRE_FPU))
        return -1;
      return 47; /* cstoresf4_insn_cf */

    case E_DFmode:
      if (!fp_src_operand (operands[2], E_DFmode))
        return -1;
      if (fp_src_operand (operands[3], E_DFmode)
          && 
#line 815 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_HARD_FLOAT && !(TUNE_68060 || TARGET_COLDFIRE_FPU)
   && (register_operand (operands[2], DFmode)
       || register_operand (operands[3], DFmode)
       || const0_operand (operands[3], DFmode))))
        return 45; /* cstoredf4_insn_68881 */
      if (!const0_operand (operands[3], E_DFmode)
          || !
#line 832 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_HARD_FLOAT && TARGET_COLDFIRE_FPU))
        return -1;
      return 48; /* cstoredf4_insn_cf */

    case E_XFmode:
      if (!fp_src_operand (operands[2], E_XFmode))
        return -1;
      if (fp_src_operand (operands[3], E_XFmode)
          && (
#line 815 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_HARD_FLOAT && !(TUNE_68060 || TARGET_COLDFIRE_FPU)
   && (register_operand (operands[2], XFmode)
       || register_operand (operands[3], XFmode)
       || const0_operand (operands[3], XFmode))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881)))
        return 46; /* cstorexf4_insn_68881 */
      if (!const0_operand (operands[3], E_XFmode)
          || !(
#line 832 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_HARD_FLOAT && TARGET_COLDFIRE_FPU) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881)))
        return -1;
      return 49; /* cstorexf4_insn_cf */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
    case ZERO_EXTEND:
      operands[2] = x3;
      if (extend_operator (operands[2], E_DImode)
          && pattern17 (x1, 
E_SImode) == 0)
        return 304; /* ashldi_extsi */
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SIGN_EXTEND
          || GET_MODE (x3) != E_DImode
          || pattern17 (x1, 
E_HImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 305; /* ashldi_sexthi */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == CONST_INT)
        {
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          switch (XWINT (x4, 0))
            {
            case 1L:
              if (register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && register_operand (operands[1], E_DImode)
                  && 
#line 4452 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 306; /* *ashldi3_const1 */
              break;

            case 32L:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && nonimmediate_operand (operands[1], E_DImode))
                return 307; /* *ashldi3_const32 */
              break;

            case 16L:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && register_operand (operands[1], E_SImode)
                  && 
#line 4626 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TUNE_68060))
                return 309; /* ashlsi_16 */
              break;

            default:
              break;
            }
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern23 (x2) == 0
                  && 
#line 4599 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE
    && ((INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 3)
	|| INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16
	|| (INTVAL (operands[2]) > 32 && INTVAL (operands[2]) <= 63))))
                return 308; /* *ashldi3 */
              break;

            case E_SImode:
              if (pattern22 (x2) == 0
                  && 
#line 4638 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TUNE_68000_10
   && INTVAL (operands[2]) > 16
   && INTVAL (operands[2]) <= 24))
                return 310; /* ashlsi_17_24 */
              break;

            default:
              break;
            }
        }
      x5 = XEXP (x1, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern5 (x1))
            {
            case 0:
              return 311; /* ashlsi3 */

            case 1:
              if (!
#line 4665 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 312; /* ashlhi3 */

            case 2:
              if (!
#line 4681 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 314; /* ashlqi3 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          switch (pattern6 (x1))
            {
            case 0:
              if (!
#line 4673 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 313; /* *m68k.md:4669 */

            case 1:
              if (!
#line 4689 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 315; /* *m68k.md:4685 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!general_operand (operands[1], E_DFmode))
            return NULL;
          if (push_operand (operands[0], E_DFmode)
              && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
( reload_completed && (extract_constrain_insn_cached (insn), which_alternative == 1)))
            return gen_split_1 (insn, operands);
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || !(
#line 1397 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE && !TARGET_COLDFIRE_FPU) && 
#line 1399 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
( reload_completed)))
            return NULL;
          return gen_split_3 (insn, operands);

        case E_DImode:
          if (!push_operand (operands[0], E_DImode)
              || !general_operand (operands[1], E_DImode)
              || !
#line 311 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
( reload_completed))
            return NULL;
          return gen_split_2 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (GET_CODE (operands[0]))
        {
        case MEM:
          if (register_operand (operands[1], E_VOIDmode))
            {
              if (post_inc_operand (operands[0], E_VOIDmode)
                  && (
#line 1693 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(GET_MODE_CLASS (GET_MODE (operands[0])) == MODE_INT &&
   GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT &&
   GET_MODE_SIZE (GET_MODE (operands[0])) == GET_MODE_SIZE (GET_MODE (operands[1])) * 2) && 
#line 1697 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
( 1)))
                return gen_split_4 (insn, operands);
              if (pre_dec_operand (operands[0], E_VOIDmode)
                  && (
#line 1709 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
((GET_MODE (operands[0]) != HImode || XEXP (XEXP (operands[0], 0), 0) != stack_pointer_rtx) &&
   GET_MODE_CLASS (GET_MODE (operands[0])) == MODE_INT &&
   GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_INT &&
   GET_MODE_SIZE (GET_MODE (operands[0])) == GET_MODE_SIZE (GET_MODE (operands[1])) * 2) && 
#line 1714 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
( 1)))
                return gen_split_5 (insn, operands);
            }
          break;

        case REG:
        case SUBREG:
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x3) == E_DImode)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (nonimmediate_src_operand (operands[1], E_QImode))
                    return gen_split_6 (insn, operands);
                  break;

                case E_HImode:
                  if (nonimmediate_src_operand (operands[1], E_HImode))
                    return gen_split_7 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        default:
          break;
        }
      if (nonimmediate_src_operand (operands[1], E_SImode)
          && nonimmediate_operand (operands[0], E_DImode)
          && GET_MODE (x3) == E_DImode
          && (
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(GET_CODE (operands[0]) != MEM || GET_CODE (operands[1]) != MEM) && 
#line 1768 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
( 1)))
        return gen_split_8 (insn, operands);
      if (!nonimmediate_src_operand (operands[1], E_VOIDmode)
          || !register_operand (operands[0], E_VOIDmode))
        return NULL;
      if (
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!ISA_HAS_MVS_MVZ
   && reload_completed
   && reg_mentioned_p (operands[0], operands[1])))
        return gen_split_9 (insn, operands);
      if (!
#line 1837 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!ISA_HAS_MVS_MVZ && reload_completed))
        return NULL;
      return gen_split_10 (insn, operands);

    case PLUS:
      if (GET_MODE (x3) != E_SImode
          || !nonimmediate_operand (operands[0], E_SImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!general_operand (operands[1], E_SImode))
        return NULL;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_src_operand (operands[2], E_SImode)
          || !(
#line 2517 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE) && 
#line 2551 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
( reload_completed && (extract_constrain_insn_cached (insn), which_alternative == 5) && !operands_match_p (operands[0], operands[1]))))
        return NULL;
      return gen_split_11 (insn, operands);

    case ASHIFT:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return NULL;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
        case ZERO_EXTEND:
          operands[2] = x4;
          if (!extend_operator (operands[2], E_DImode)
              || XWINT (x5, 0) != 32L
              || !nonimmediate_operand (operands[0], E_DImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!general_operand (operands[1], E_SImode)
              || !
#line 4418 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
( reload_completed))
            return NULL;
          return gen_split_12 (insn, operands);

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          switch (XWINT (x5, 0))
            {
            case 2L:
              if (register_operand (operands[0], E_DImode)
                  && register_operand (operands[1], E_DImode)
                  && 
#line 4459 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
                return gen_split_13 (insn, operands);
              break;

            case 3L:
              if (register_operand (operands[0], E_DImode)
                  && register_operand (operands[1], E_DImode)
                  && 
#line 4470 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
                return gen_split_14 (insn, operands);
              break;

            case 8L:
              if (register_operand (operands[0], E_DImode)
                  && register_operand (operands[1], E_DImode)
                  && 
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
                return gen_split_15 (insn, operands);
              break;

            case 16L:
              if (register_operand (operands[0], E_DImode)
                  && register_operand (operands[1], E_DImode)
                  && 
#line 4499 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
                return gen_split_16 (insn, operands);
              break;

            case 32L:
              if (nonimmediate_operand (operands[1], E_DImode))
                {
                  if (pre_dec_operand (operands[0], E_DImode)
                      && 
#line 4517 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed))
                    return gen_split_17 (insn, operands);
                  if (post_inc_operand (operands[0], E_DImode)
                      && 
#line 4529 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed))
                    return gen_split_18 (insn, operands);
                  if (nonimmediate_operand (operands[0], E_DImode)
                      && 
#line 4543 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
( reload_completed))
                    return gen_split_19 (insn, operands);
                }
              break;

            default:
              break;
            }
          if (!register_operand (operands[1], E_DImode)
              || !register_operand (operands[0], E_DImode))
            return NULL;
          operands[2] = x5;
          if (const_int_operand (operands[2], E_VOIDmode)
              && 
#line 4552 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE
   && INTVAL (operands[2]) > 32 && INTVAL (operands[2]) <= 40))
            return gen_split_20 (insn, operands);
          if (XWINT (x5, 0) == 48L
              && 
#line 4567 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
            return gen_split_21 (insn, operands);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 4583 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE
   && INTVAL (operands[2]) > 40 && INTVAL (operands[2]) <= 63))
            return NULL;
          return gen_split_22 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      switch (XWINT (x5, 0))
        {
        case 2L:
          if (!
#line 4752 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
            return NULL;
          return gen_split_23 (insn, operands);

        case 3L:
          if (!
#line 4763 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
            return NULL;
          return gen_split_24 (insn, operands);

        case 8L:
          if (!
#line 4774 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
            return NULL;
          return gen_split_25 (insn, operands);

        case 16L:
          if (!
#line 4790 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
            return NULL;
          return gen_split_26 (insn, operands);

        case 63L:
          if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
            return NULL;
          return gen_split_27 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (XWINT (x5, 0))
        {
        case 2L:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && 
#line 4991 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
            return gen_split_28 (insn, operands);
          break;

        case 3L:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && 
#line 5002 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
            return gen_split_29 (insn, operands);
          break;

        case 8L:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && 
#line 5013 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
            return gen_split_30 (insn, operands);
          break;

        case 16L:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && 
#line 5029 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE))
            return gen_split_31 (insn, operands);
          break;

        case 32L:
          if (nonimmediate_operand (operands[1], E_DImode))
            {
              if (pre_dec_operand (operands[0], E_DImode)
                  && 
#line 5047 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed))
                return gen_split_32 (insn, operands);
              if (post_inc_operand (operands[0], E_DImode)
                  && 
#line 5059 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed))
                return gen_split_33 (insn, operands);
              if (nonimmediate_operand (operands[0], E_DImode)
                  && 
#line 5071 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed))
                return gen_split_34 (insn, operands);
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode))
        return NULL;
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode)
          && 
#line 5087 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE
   && INTVAL (operands[2]) > 32 && INTVAL (operands[2]) <= 40))
        return gen_split_35 (insn, operands);
      if (XWINT (x5, 0) == 48L
          && 
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed))
        return gen_split_36 (insn, operands);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 5118 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(reload_completed && !TARGET_COLDFIRE
   && INTVAL (operands[2]) > 40 && INTVAL (operands[2]) <= 62))
        return NULL;
      return gen_split_37 (insn, operands);

    default:
      return NULL;
    }
}
