/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern15 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x6) != E_DImode)
            return -1;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          if (!general_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!general_operand (operands[2], E_HImode)
              || !
#line 2865 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          *pnum_clobbers = 1;
          return 173; /* subdi_sexthishl32 */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x6;
          if (!general_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x2, 0);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          return 174; /* subdi_dishl32 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x5 = XEXP (x1, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern12 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 175; /* subdi3 */

            case 1:
              if (!
#line 3000 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 178; /* subhi3 */

            case 2:
              if (!
#line 3016 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 180; /* subqi3 */

            case 3:
              if (
#line 3066 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 191; /* subsf3_68881 */
              if (!
#line 3079 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 194; /* subsf3_cf */

            case 4:
              if (
#line 3066 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
                return 192; /* subdf3_68881 */
              if (!
#line 3079 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return -1;
              return 195; /* subdf3_cf */

            case 5:
              if (!
#line 3066 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 193; /* subxf3_68881 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          x9 = XEXP (x5, 0);
          operands[0] = x9;
          operands[1] = x3;
          x7 = XEXP (x2, 0);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !general_src_operand (operands[1], E_HImode)
                  || !
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 179; /* *m68k.md:3004 */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !general_src_operand (operands[1], E_QImode)
                  || !
#line 3024 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 181; /* *m68k.md:3020 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      switch (pattern16 (x2))
        {
        case 0:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3039 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 182; /* subsf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3048 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 185; /* subsf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3057 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 188; /* subsf3_floatqi_68881 */

        case 1:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3039 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 183; /* subdf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3048 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 186; /* subdf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3057 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 189; /* subdf3_floatqi_68881 */

        case 2:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3039 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 184; /* subxf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3048 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 187; /* subxf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3057 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 190; /* subxf3_floatqi_68881 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) == CONST_INT)
    {
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (XWINT (x3, 0))
        {
        case 1L:
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && register_operand (operands[1], E_DImode)
              && 
#line 4982 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return 331; /* *lshrdi3_const1 */
          break;

        case 32L:
          if (nonimmediate_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && general_operand (operands[1], E_DImode))
            return 332; /* *lshrdi_const32 */
          break;

        case 63L:
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && register_operand (operands[1], E_DImode))
            return 333; /* *lshrdi_const63 */
          break;

        case 31L:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && register_operand (operands[1], E_SImode))
            return 335; /* lshrsi_31 */
          break;

        case 16L:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && register_operand (operands[1], E_SImode)
              && 
#line 5179 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TUNE_68060))
            return 336; /* lshrsi_16 */
          break;

        default:
          break;
        }
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern23 (x2) == 0
              && 
#line 5141 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
((!TARGET_COLDFIRE
    && ((INTVAL (operands[2]) >= 2 && INTVAL (operands[2]) <= 3)
	 || INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16
	 || (INTVAL (operands[2]) > 32 && INTVAL (operands[2]) <= 63)))))
            return 334; /* *lshrdi3_const */
          break;

        case E_SImode:
          if (pattern22 (x2) == 0
              && 
#line 5190 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TUNE_68000_10
   && INTVAL (operands[2]) > 16
   && INTVAL (operands[2]) <= 24))
            return 337; /* lshrsi_17_24 */
          break;

        default:
          break;
        }
    }
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern5 (x1))
        {
        case 0:
          return 338; /* lshrsi3 */

        case 1:
          if (!
#line 5213 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 339; /* lshrhi3 */

        case 2:
          if (!
#line 5229 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 341; /* lshrqi3 */

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 5221 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 340; /* *m68k.md:5217 */

        case 1:
          if (!
#line 5237 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 342; /* *m68k.md:5233 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_38 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_36 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_37 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[0] = x1;
          x2 = XVECEXP (x1, 0, 0);
          operands[1] = x2;
          if (
#line 6159 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(m68k_movem_pattern_p (operands[0], NULL, 0, true)))
            return 399; /* *m68k_store_multiple */
          if (GET_CODE (x2) == SET
              && pattern9 (x2) == 0
              && 
#line 6169 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(m68k_movem_pattern_p (operands[0], operands[1], INTVAL (operands[3]), true)))
            return 400; /* *m68k_store_multiple_automod */
          operands[1] = x2;
          if (
#line 6176 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(m68k_movem_pattern_p (operands[0], NULL, 0, false)))
            return 401; /* *m68k_load_multiple */
          if (GET_CODE (x2) == SET
              && pattern9 (x2) == 0
              && 
#line 6186 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(m68k_movem_pattern_p (operands[0], operands[1],
			 INTVAL (operands[3]), false)))
            return 402; /* *m68k_load_multiple_automod */
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != SET)
            return -1;
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case PLUS:
              if (GET_MODE (x5) != E_SImode)
                return -1;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 15
                  || GET_MODE (x6) != E_SImode)
                return -1;
              x7 = XEXP (x5, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x8 = XEXP (x3, 0);
              if (GET_CODE (x8) != MEM
                  || GET_MODE (x8) != E_SImode)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != PLUS
                  || GET_MODE (x9) != E_SImode)
                return -1;
              x10 = XEXP (x9, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 15
                  || GET_MODE (x10) != E_SImode)
                return -1;
              x11 = XEXP (x9, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x12 = XEXP (x4, 1);
              if (GET_CODE (x12) != PLUS
                  || GET_MODE (x12) != E_SImode)
                return -1;
              x13 = XEXP (x12, 0);
              if (GET_CODE (x13) != REG
                  || REGNO (x13) != 15
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x4, 0);
              if (GET_CODE (x14) != REG
                  || REGNO (x14) != 15
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x15 = XEXP (x2, 0);
              operands[0] = x15;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x16 = XEXP (x12, 1);
              operands[1] = x16;
              if (!const_int_operand (operands[1], E_SImode))
                return -1;
              x17 = XEXP (x3, 1);
              if (!rtx_equal_p (x17, operands[0])
                  || !
#line 6216 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 || INTVAL (operands[1]) >= -0x8004))
                return -1;
              return 403; /* *link */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x5, 0) != 3
                  || XINT (x5, 1) != 1)
                return -1;
              x17 = XEXP (x3, 1);
              if (GET_CODE (x17) != UNSPEC_VOLATILE
                  || XVECLEN (x17, 0) != 3
                  || XINT (x17, 1) != 2)
                return -1;
              x12 = XEXP (x4, 1);
              if (GET_CODE (x12) != UNSPEC_VOLATILE
                  || XVECLEN (x12, 0) != 3
                  || XINT (x12, 1) != 2
                  || GET_MODE (x12) != E_QImode)
                return -1;
              x15 = XEXP (x2, 0);
              operands[1] = x15;
              x18 = XVECEXP (x5, 0, 0);
              operands[2] = x18;
              x19 = XVECEXP (x5, 0, 1);
              operands[3] = x19;
              x20 = XVECEXP (x5, 0, 2);
              operands[4] = x20;
              x14 = XEXP (x4, 0);
              operands[0] = x14;
              if (!register_operand (operands[0], E_QImode))
                return -1;
              x21 = XVECEXP (x17, 0, 0);
              if (!rtx_equal_p (x21, operands[2]))
                return -1;
              x22 = XVECEXP (x17, 0, 1);
              if (!rtx_equal_p (x22, operands[3]))
                return -1;
              x23 = XVECEXP (x17, 0, 2);
              if (!rtx_equal_p (x23, operands[4]))
                return -1;
              x8 = XEXP (x3, 0);
              if (!rtx_equal_p (x8, operands[2]))
                return -1;
              x24 = XVECEXP (x12, 0, 0);
              if (!rtx_equal_p (x24, operands[2]))
                return -1;
              x25 = XVECEXP (x12, 0, 1);
              if (!rtx_equal_p (x25, operands[3]))
                return -1;
              x26 = XVECEXP (x12, 0, 2);
              if (!rtx_equal_p (x26, operands[4]))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (pattern27 (x1, 
E_QImode) != 0
                      || !
#line 54 "../../gcc-15.0.1-20250313/gcc/config/m68k/sync.md"
(TARGET_CAS))
                    return -1;
                  return 427; /* atomic_compare_and_swapqi_1 */

                case E_HImode:
                  if (pattern27 (x1, 
E_HImode) != 0
                      || !
#line 54 "../../gcc-15.0.1-20250313/gcc/config/m68k/sync.md"
(TARGET_CAS))
                    return -1;
                  return 428; /* atomic_compare_and_swaphi_1 */

                case E_SImode:
                  if (pattern27 (x1, 
E_SImode) != 0
                      || !
#line 54 "../../gcc-15.0.1-20250313/gcc/config/m68k/sync.md"
(TARGET_CAS))
                    return -1;
                  return 429; /* atomic_compare_and_swapsi_1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != SET)
            return -1;
          x15 = XEXP (x2, 0);
          operands[0] = x15;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case MEM:
              if (GET_MODE (x5) != E_SImode)
                return -1;
              x17 = XEXP (x3, 1);
              if (GET_CODE (x17) != PLUS
                  || GET_MODE (x17) != E_SImode)
                return -1;
              x27 = XEXP (x17, 1);
              if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return -1;
              x8 = XEXP (x3, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 15
                  || GET_MODE (x8) != E_SImode
                  || !register_operand (operands[0], E_SImode))
                return -1;
              x6 = XEXP (x5, 0);
              if (!rtx_equal_p (x6, operands[0]))
                return -1;
              x28 = XEXP (x17, 0);
              if (!rtx_equal_p (x28, operands[0]))
                return -1;
              return 404; /* *unlink */

            case UNSPEC_VOLATILE:
              if (XVECLEN (x5, 0) != 1
                  || XINT (x5, 1) != 3
                  || GET_MODE (x5) != E_QImode)
                return -1;
              x17 = XEXP (x3, 1);
              if (GET_CODE (x17) != UNSPEC_VOLATILE
                  || XVECLEN (x17, 0) != 1
                  || XINT (x17, 1) != 4
                  || GET_MODE (x17) != E_QImode
                  || !register_operand (operands[0], E_QImode))
                return -1;
              x18 = XVECEXP (x5, 0, 0);
              operands[1] = x18;
              if (!memory_operand (operands[1], E_QImode))
                return -1;
              x21 = XVECEXP (x17, 0, 0);
              if (!rtx_equal_p (x21, operands[1]))
                return -1;
              x8 = XEXP (x3, 0);
              if (!rtx_equal_p (x8, operands[1])
                  || !
#line 79 "../../gcc-15.0.1-20250313/gcc/config/m68k/sync.md"
(ISA_HAS_TAS))
                return -1;
              return 430; /* atomic_test_and_set_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x29 = XEXP (x1, 0);
      if (GET_CODE (x29) != MEM
          || GET_MODE (x29) != E_QImode)
        return -1;
      x30 = XEXP (x29, 0);
      operands[0] = x30;
      x31 = XEXP (x1, 1);
      operands[1] = x31;
      if (!general_operand (operands[1], E_SImode))
        return -1;
      if (sibcall_operand (operands[0], E_SImode)
          && 
#line 5965 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(SIBLING_CALL_P (insn)))
        return 390; /* *sibcall */
      if (!call_operand (operands[0], E_SImode)
          || !
#line 6003 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!SIBLING_CALL_P (insn)))
        return -1;
      return 392; /* *call */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 396; /* blockage */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 397; /* nop */

    case RETURN:
      return 398; /* *return */

    case TRAP_IF:
      x29 = XEXP (x1, 0);
      switch (GET_CODE (x29))
        {
        case CONST_INT:
          if (XWINT (x29, 0) != -1L)
            return -1;
          x31 = XEXP (x1, 1);
          if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
            return -1;
          return 418; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[0] = x29;
          if (!ordered_comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x30 = XEXP (x29, 0);
          operands[1] = x30;
          x32 = XEXP (x29, 1);
          operands[2] = x32;
          x31 = XEXP (x1, 1);
          operands[3] = x31;
          if (!const1_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !general_operand (operands[2], E_QImode))
                return -1;
              if (
#line 6643 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TARGET_COLDFIRE))
                return 419; /* ctrapqi4 */
              if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_COLDFIRE))
                return -1;
              return 422; /* ctrapqi4_cf */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !general_operand (operands[2], E_HImode))
                return -1;
              if (
#line 6643 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TARGET_COLDFIRE))
                return 420; /* ctraphi4 */
              if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_COLDFIRE))
                return -1;
              return 423; /* ctraphi4_cf */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !general_operand (operands[2], E_SImode))
                return -1;
              if (
#line 6643 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && !TARGET_COLDFIRE))
                return 421; /* ctrapsi4 */
              if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_COLDFIRE))
                return -1;
              return 424; /* ctrapsi4_cf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 4)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 426; /* ib */

    default:
      return -1;
    }
}
