/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern4 (x3, 
E_SImode); /* [-1, 0] */

    case E_HImode:
      if (pattern4 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_QImode:
      if (pattern4 (x3, 
E_QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern13 (x1, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern13 (x1, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_XFmode:
      if (pattern13 (x1, 
E_XFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) == 1L)
    {
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) == MINUS
          && GET_MODE (x4) == E_SImode)
        {
          x5 = XEXP (x4, 0);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 7]
              && memory_operand (operands[0], E_QImode))
            {
              x6 = XEXP (x4, 1);
              switch (GET_CODE (x6))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[1] = x6;
                  if (general_operand (operands[1], E_SImode))
                    return 359; /* bclrmemqi */
                  break;

                case SIGN_EXTEND:
                case ZERO_EXTEND:
                  operands[2] = x6;
                  if (extend_operator (operands[2], E_SImode))
                    {
                      x7 = XEXP (x6, 0);
                      operands[1] = x7;
                      if (general_operand (operands[1], E_VOIDmode))
                        return 360; /* *bclrmemqi_ext */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  operands[1] = x3;
  if (!const_int_operand (operands[1], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 2);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_SImode)
      || !
#line 5717 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD && IN_RANGE (INTVAL (operands[2]), 0, 31)))
    return -1;
  return 375; /* *insv_bfclr_reg */
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode
      || !nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!nonimmediate_src_operand (operands[2], E_HImode))
            return -1;
          return 197; /* mulhisi3 */

        case CONST_INT:
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 3119 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(INTVAL (operands[2]) >= -0x8000 && INTVAL (operands[2]) <= 0x7fff))
            return -1;
          return 198; /* *mulhisisi3_s */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      if (!general_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (general_src_operand (operands[2], E_SImode)
          && 
#line 3138 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020))
        return 199; /* *mulsi3_68020 */
      if (!general_operand (operands[2], E_SImode)
          || !
#line 3147 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
        return -1;
      return 200; /* *mulsi3_cf */

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!nonimmediate_src_operand (operands[2], E_HImode))
            return -1;
          return 201; /* umulhisi3 */

        case CONST_INT:
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 3170 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) <= 0xffff))
            return -1;
          return 202; /* *mulhisisi3_z */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (memory_src_operand (operands[1], E_QImode)
      && XWINT (x3, 0) == 32L)
    {
      x5 = XEXP (x2, 2);
      operands[2] = x5;
      if (const_int_operand (operands[2], E_SImode)
          && 
#line 5521 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && (INTVAL (operands[2]) % 8) == 0
   && ! mode_dependent_address_p (XEXP (operands[1], 0),
                                  MEM_ADDR_SPACE (operands[1]))))
        return 363; /* *extzv_32_mem */
    }
  if (!register_operand (operands[1], E_SImode))
    return -1;
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  if (
#line 5537 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD
   && IN_RANGE (INTVAL (operands[3]), 0, 31)
   && (INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16)
   && INTVAL (operands[3]) % INTVAL (operands[2]) == 0))
    return 364; /* *extzv_8_16_reg */
  if (!
#line 5707 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD && IN_RANGE (INTVAL (operands[3]), 0, 31)))
    return -1;
  return 374; /* *extv_bfextu_reg */
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern1 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DImode
              || !general_operand (operands[1], E_DImode))
            return -1;
          if (
#line 3971 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return 273; /* negdi2_internal */
          if (!
#line 3988 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
            return -1;
          return 274; /* negdi2_5200 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_SImode
              || !general_operand (operands[1], E_SImode))
            return -1;
          if (
#line 4009 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return 275; /* negsi2_internal */
          if (!
#line 4017 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
            return -1;
          return 276; /* negsi2_5200 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_HImode
              || !general_operand (operands[1], E_HImode)
              || !
#line 4025 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 277; /* neghi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_QImode
              || !general_operand (operands[1], E_QImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 279; /* negqi2 */

        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_SFmode
              || !general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 4146 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 281; /* negsf2_68881 */
          if (!
#line 4161 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 284; /* negsf2_cf */

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_DFmode
              || !general_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 4146 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 282; /* negdf2_68881 */
          if (!
#line 4161 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 285; /* negdf2_cf */

        case E_XFmode:
          if (!nonimmediate_operand (operands[0], E_XFmode))
            return -1;
          x2 = XEXP (x1, 1);
          if (GET_MODE (x2) != E_XFmode
              || !general_operand (operands[1], E_XFmode)
              || !
#line 4146 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 283; /* negxf2_68881 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 4032 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return -1;
      return 278; /* *m68k.md:4029 */

    case 2:
      if (!
#line 4046 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return -1;
      return 280; /* *m68k.md:4043 */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case IF_THEN_ELSE:
      x7 = XEXP (x6, 0);
      if (!ordered_comparison_operator (x7, E_VOIDmode))
        return -1;
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x9 = XEXP (x6, 2);
      if (GET_CODE (x9) != PC)
        return -1;
      x10 = XEXP (x2, 0);
      if (GET_CODE (x10) != PC)
        return -1;
      x11 = XEXP (x7, 0);
      operands[2] = x11;
      if (!nonimmediate_operand (operands[2], E_DImode))
        return -1;
      x12 = XEXP (x7, 1);
      operands[3] = x12;
      if (!general_operand (operands[3], E_DImode))
        return -1;
      x13 = XEXP (x8, 0);
      operands[4] = x13;
      x14 = XEXP (x3, 0);
      operands[0] = x14;
      if (!scratch_operand (operands[0], E_DImode))
        return -1;
      operands[5] = x5;
      return 5; /* cbranchdi4_insn */

    case FIX:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != FIX
          || GET_MODE (x7) != E_DFmode)
        return -1;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      x11 = XEXP (x7, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      x14 = XEXP (x3, 0);
      operands[2] = x14;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !
#line 2173 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881 && TUNE_68040))
            return -1;
          return 120; /* fix_truncdfsi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881 && TUNE_68040))
            return -1;
          return 121; /* fix_truncdfhi2 */

        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !
#line 2193 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881 && TUNE_68040))
            return -1;
          return 122; /* fix_truncdfqi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
