/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode
          || !general_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x4) != E_QImode
          || !general_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!general_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!general_operand (operands[1], E_DFmode))
        return -1;
      if (push_operand (operands[0], E_DFmode))
        return 1; /* *movdf_internal */
      if (!nonimmediate_operand (operands[0], E_DFmode))
        return -1;
      if (
#line 1361 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return 69; /* *m68k.md:1356 */
      if (
#line 1397 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE && !TARGET_COLDFIRE_FPU))
        return 70; /* movdf_cf_soft */
      if (!
#line 1409 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
        return -1;
      return 71; /* movdf_cf_hard */

    case E_DImode:
      if (!general_operand (operands[1], E_DImode))
        return -1;
      if (push_operand (operands[0], E_DImode))
        return 2; /* pushdi */
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      if (
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return 75; /* *m68k.md:1569 */
      if (!
#line 1612 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
        return -1;
      return 76; /* *m68k.md:1609 */

    case E_SImode:
      if (!push_operand (operands[0], E_SImode)
          || !const_int_operand (operands[1], E_SImode)
          || !
#line 847 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(INTVAL (operands[1]) >= -0x8000 && INTVAL (operands[1]) < 0x8000))
        return -1;
      return 50; /* pushexthisi_const */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode))
        return -1;
      if (general_src_operand (operands[1], E_HImode)
          && 
#line 1088 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return 58; /* *m68k.md:1085 */
      if (!general_operand (operands[1], E_HImode)
          || !
#line 1098 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
        return -1;
      return 59; /* *m68k.md:1095 */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_src_operand (operands[1], E_QImode))
        return -1;
      if (
#line 1134 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return 62; /* *m68k.md:1131 */
      if (!
#line 1141 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
        return -1;
      return 63; /* *m68k.md:1138 */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode))
        return -1;
      if (
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return 66; /* *m68k.md:1210 */
      if (
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE && !TARGET_COLDFIRE_FPU))
        return 67; /* movsf_cf_soft */
      if (!
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
        return -1;
      return 68; /* movsf_cf_hard */

    case E_XFmode:
      if (!nonimmediate_operand (operands[0], E_XFmode)
          || !nonimmediate_operand (operands[1], E_XFmode))
        return -1;
      if (
#line 1479 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
        return 72; /* *m68k.md:1476 */
      if (
#line 1519 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(! TARGET_68881 && ! TARGET_COLDFIRE))
        return 73; /* *m68k.md:1516 */
      if (!
#line 1558 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(! TARGET_68881 && TARGET_COLDFIRE))
        return -1;
      return 74; /* *m68k.md:1555 */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers != NULL)
    {
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!equality_comparison_operator (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x8 = XEXP (x2, 2);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  x10 = XEXP (x7, 0);
  operands[3] = x10;
  x11 = XEXP (x4, 2);
  switch (GET_CODE (x11))
    {
    case MINUS:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XEXP (x11, 1);
      operands[2] = x13;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      switch (XWINT (x12, 0))
        {
        case 7L:
          if (!memory_src_operand (operands[1], E_QImode))
            return -1;
          return 24; /* cbranchsi4_btst_mem_insn */

        case 31L:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 621 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!(CONST_INT_P (operands[1]) && !IN_RANGE (INTVAL (operands[1]), 0, 31))))
            return -1;
          return 25; /* cbranchsi4_btst_reg_insn */

        default:
          return -1;
        }

    case CONST_INT:
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!memory_operand (operands[1], E_QImode)
              || !
#line 639 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE && (unsigned) INTVAL (operands[2]) < 8))
            return -1;
          return 26; /* cbranchsi4_btst_mem_insn_1 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 656 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!(REG_P (operands[1]) && !IN_RANGE (INTVAL (operands[2]), 0, 31))))
            return -1;
          return 27; /* cbranchsi4_btst_reg_insn_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          if (!general_operand (operands[1], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern24 (x2, 
E_DImode) != 0
                  || !
#line 3747 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 254; /* iordi_zext */

            case E_SImode:
              if (pattern24 (x2, 
E_SImode) != 0
                  || !
#line 3862 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 264; /* iorsi_zext */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || !nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || !general_operand (operands[1], E_HImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!general_operand (operands[2], E_SImode))
            return -1;
          return 263; /* iorsi_zexthi_ashl16 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          res = recog_23 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case STRICT_LOW_PART:
          x9 = XEXP (x4, 0);
          operands[0] = x9;
          switch (pattern0 (x2))
            {
            case 0:
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (general_src_operand (operands[1], E_HImode)
                  && rtx_equal_p (x3, operands[0])
                  && 
#line 3805 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 258; /* *m68k.md:3801 */
              operands[1] = x3;
              if (general_src_operand (operands[1], E_HImode)
                  && rtx_equal_p (x6, operands[0])
                  && 
#line 3812 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 259; /* *m68k.md:3808 */
              break;

            case 1:
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (general_src_operand (operands[1], E_QImode)
                  && rtx_equal_p (x3, operands[0])
                  && 
#line 3828 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 261; /* *m68k.md:3824 */
              operands[1] = x3;
              if (general_src_operand (operands[1], E_QImode)
                  && rtx_equal_p (x6, operands[0])
                  && 
#line 3836 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 262; /* *m68k.md:3832 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 3)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != ASHIFT
          || GET_MODE (x5) != E_SImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      operands[0] = x4;
      if (!memory_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      x11 = XEXP (x5, 1);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x11;
          if (!general_operand (operands[1], E_SImode))
            return -1;
          return 354; /* bsetmemqi */

        case SIGN_EXTEND:
        case ZERO_EXTEND:
          operands[2] = x11;
          if (!extend_operator (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x11, 0);
          operands[1] = x12;
          if (!general_operand (operands[1], E_VOIDmode))
            return -1;
          return 355; /* *bsetmemqi_ext */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern3 (x1) != 0)
        return -1;
      return 356; /* *bsetdreg */

    default:
      return -1;
    }
}
