/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x2, 0);
  operands[3] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x3, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern7 (x1, 
E_SImode); /* [-1, 0] */

    case E_HImode:
      if (pattern7 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!general_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!general_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_XFmode:
      if (!general_operand (operands[1], E_XFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) == CONST_INT)
    {
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  operands[1] = x4;
  if (!nonmemory_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode)
      || !
#line 5688 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD))
    return -1;
  return 372; /* *insv_bfins_mem */
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern11 (x3, 
E_HImode) != 0)
            return -1;
          return 196; /* mulhi3 */

        case E_DFmode:
          if (pattern10 (x3, 
E_DFmode) != 0)
            return -1;
          if (
#line 3393 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 220; /* muldf_68881 */
          if (!
#line 3435 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 224; /* fmuldf3_cf */

        case E_SFmode:
          if (pattern10 (x3, 
E_SFmode) != 0)
            return -1;
          if (
#line 3411 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 221; /* mulsf_68881 */
          if (!
#line 3435 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 223; /* fmulsf3_cf */

        case E_XFmode:
          if (!nonimmediate_operand (operands[0], E_XFmode)
              || GET_MODE (x3) != E_XFmode
              || !nonimmediate_operand (operands[1], E_XFmode)
              || !nonimmediate_operand (operands[2], E_XFmode)
              || !
#line 3426 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 222; /* mulxf3_68881 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern14 (x3))
        {
        case 0:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3354 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 211; /* mulsf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3367 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 214; /* mulsf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3380 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 217; /* mulsf3_floatqi_68881 */

        case 1:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3354 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 212; /* muldf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3367 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 215; /* muldf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3380 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 218; /* muldf3_floatqi_68881 */

        case 2:
          if (general_operand (operands[2], E_SImode)
              && 
#line 3354 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 213; /* mulxf3_floatsi_68881 */
          if (general_operand (operands[2], E_HImode)
              && 
#line 3367 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 216; /* mulxf3_floathi_68881 */
          if (!general_operand (operands[2], E_QImode)
              || !
#line 3380 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 219; /* mulxf3_floatqi_68881 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (XWINT (x5, 0))
    {
    case 16L:
      if (register_operand (operands[0], E_SImode)
          && GET_MODE (x3) == E_SImode
          && register_operand (operands[1], E_SImode)
          && 
#line 4699 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TUNE_68060))
        return 316; /* ashrsi_16 */
      break;

    case 1L:
      if (register_operand (operands[0], E_DImode)
          && GET_MODE (x3) == E_DImode
          && register_operand (operands[1], E_DImode)
          && 
#line 4742 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
        return 320; /* *ashrdi3_const1 */
      break;

    case 32L:
      if (GET_MODE (x3) == E_DImode
          && nonimmediate_src_operand (operands[1], E_DImode))
        {
          if (register_operand (operands[0], E_DImode))
            return 321; /* *ashrdi_const32 */
          if (pnum_clobbers != NULL
              && memory_operand (operands[0], E_DImode))
            {
              *pnum_clobbers = 1;
              return 322; /* *ashrdi_const32_mem */
            }
        }
      break;

    default:
      break;
    }
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern22 (x3) == 0
          && 
#line 4708 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TUNE_68000_10
   && INTVAL (operands[2]) > 16
   && INTVAL (operands[2]) <= 24))
        return 317; /* *m68k.md:4704 */
      break;

    case E_DImode:
      if (pattern23 (x3) == 0
          && 
#line 4848 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE
    && ((INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 3)
	|| INTVAL (operands[2]) == 8 || INTVAL (operands[2]) == 16
	|| INTVAL (operands[2]) == 31
	|| (INTVAL (operands[2]) > 32 && INTVAL (operands[2]) <= 63))))
        return 323; /* ashrdi_const */
      break;

    default:
      break;
    }
  if (!register_operand (operands[1], E_SImode)
      || XWINT (x5, 0) != 31L
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 324; /* ashrsi_31 */
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      if (general_operand (operands[1], E_SImode))
        {
          if (
#line 2109 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 105; /* floatsisf2_68881 */
          if (
#line 2116 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return 108; /* floatsisf2_cf */
        }
      if (general_operand (operands[1], E_HImode))
        {
          if (
#line 2130 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 110; /* floathisf2_68881 */
          if (
#line 2137 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return 113; /* floathisf2_cf */
        }
      if (!general_operand (operands[1], E_QImode))
        return -1;
      if (
#line 2151 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
        return 115; /* floatqisf2_68881 */
      if (!
#line 2158 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
        return -1;
      return 118; /* floatqisf2_cf */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode)
        return -1;
      if (general_operand (operands[1], E_SImode))
        {
          if (
#line 2109 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 106; /* floatsidf2_68881 */
          if (
#line 2116 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return 109; /* floatsidf2_cf */
        }
      if (general_operand (operands[1], E_HImode))
        {
          if (
#line 2130 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 111; /* floathidf2_68881 */
          if (
#line 2137 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return 114; /* floathidf2_cf */
        }
      if (!general_operand (operands[1], E_QImode))
        return -1;
      if (
#line 2151 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
        return 116; /* floatqidf2_68881 */
      if (!
#line 2158 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
        return -1;
      return 119; /* floatqidf2_cf */

    case E_XFmode:
      if (!nonimmediate_operand (operands[0], E_XFmode)
          || GET_MODE (x3) != E_XFmode)
        return -1;
      if (general_operand (operands[1], E_SImode)
          && 
#line 2109 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
        return 107; /* floatsixf2_68881 */
      if (general_operand (operands[1], E_HImode)
          && 
#line 2130 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
        return 112; /* floathixf2_68881 */
      if (!general_operand (operands[1], E_QImode)
          || !
#line 2151 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
        return -1;
      return 117; /* floatqixf2_68881 */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_32 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != PC)
            return -1;
          switch (GET_CODE (x3))
            {
            case NE:
            case EQ:
              res = recog_19 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          if (ordered_comparison_operator (x3, E_VOIDmode))
            {
              res = recog_20 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x3;
          if (!comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case LABEL_REF:
              x8 = XEXP (x2, 2);
              if (GET_CODE (x8) != PC)
                return -1;
              x9 = XEXP (x7, 0);
              operands[3] = x9;
              switch (pattern25 ())
                {
                case 0:
                  if (
#line 745 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)
       || const0_operand (operands[2], SFmode))))
                    return 32; /* cbranchsf4_insn_68881 */
                  if (!
#line 763 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)
       || const0_operand (operands[2], SFmode))))
                    return -1;
                  return 35; /* cbranchsf4_insn_cf */

                case 1:
                  if (
#line 745 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], DFmode)
       || register_operand (operands[2], DFmode)
       || const0_operand (operands[2], DFmode))))
                    return 33; /* cbranchdf4_insn_68881 */
                  if (!
#line 763 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], DFmode)
       || register_operand (operands[2], DFmode)
       || const0_operand (operands[2], DFmode))))
                    return -1;
                  return 36; /* cbranchdf4_insn_cf */

                case 2:
                  if ((
#line 745 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], XFmode)
       || register_operand (operands[2], XFmode)
       || const0_operand (operands[2], XFmode))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return 34; /* cbranchxf4_insn_68881 */
                  if (!(
#line 763 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], XFmode)
       || register_operand (operands[2], XFmode)
       || const0_operand (operands[2], XFmode))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return -1;
                  return 37; /* cbranchxf4_insn_cf */

                default:
                  return -1;
                }

            case PC:
              x8 = XEXP (x2, 2);
              if (GET_CODE (x8) != LABEL_REF)
                return -1;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              switch (pattern25 ())
                {
                case 0:
                  if (
#line 781 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)
       || const0_operand (operands[2], SFmode))))
                    return 38; /* cbranchsf4_insn_rev_68881 */
                  if (!
#line 799 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], SFmode)
       || register_operand (operands[2], SFmode)
       || const0_operand (operands[2], SFmode))))
                    return -1;
                  return 41; /* cbranchsf4_insn_rev_cf */

                case 1:
                  if (
#line 781 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], DFmode)
       || register_operand (operands[2], DFmode)
       || const0_operand (operands[2], DFmode))))
                    return 39; /* cbranchdf4_insn_rev_68881 */
                  if (!
#line 799 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], DFmode)
       || register_operand (operands[2], DFmode)
       || const0_operand (operands[2], DFmode))))
                    return -1;
                  return 42; /* cbranchdf4_insn_rev_cf */

                case 2:
                  if ((
#line 781 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881
   && (register_operand (operands[1], XFmode)
       || register_operand (operands[2], XFmode)
       || const0_operand (operands[2], XFmode))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return 40; /* cbranchxf4_insn_rev_68881 */
                  if (!(
#line 799 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU
   && (register_operand (operands[1], XFmode)
       || register_operand (operands[2], XFmode)
       || const0_operand (operands[2], XFmode))) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return -1;
                  return 43; /* cbranchxf4_insn_rev_cf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_QImode))
        {
          res = recog_22 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !ordered_comparison_operator (x2, E_VOIDmode))
        return -1;
      operands[1] = x2;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!general_operand (operands[2], E_DImode))
        return -1;
      x7 = XEXP (x2, 1);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          if (
#line 5755 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(! TARGET_COLDFIRE))
            return 378; /* scc0_di */
          if (
#line 5764 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
            return 379; /* scc0_di_5200 */
        }
      operands[3] = x7;
      if (!general_operand (operands[3], E_DImode))
        return -1;
      if (
#line 5774 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(! TARGET_COLDFIRE))
        return 380; /* scc_di */
      if (!
#line 5784 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
        return -1;
      return 381; /* scc_di_5200 */

    case TRUNCATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          if (general_src_operand (operands[1], E_SImode)
              && 
#line 1632 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return 78; /* truncsiqi2 */
          if (!general_src_operand (operands[1], E_HImode)
              || !
#line 1650 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 79; /* trunchiqi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !general_src_operand (operands[1], E_SImode)
              || !
#line 1673 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 80; /* truncsihi2 */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 2013 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 100; /* *m68k.md:2009 */
          if (!
#line 2039 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 101; /* extendsfdf2_cf */

        case E_XFmode:
          if (!nonimmediate_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!general_operand (operands[1], E_SFmode)
                  || !
#line 6524 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 408; /* extendsfxf2 */

            case E_DFmode:
              if (!general_operand (operands[1], E_DFmode)
                  || !
#line 6553 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 409; /* extenddfxf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!general_operand (operands[1], E_DFmode))
                return -1;
              if (
#line 2067 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881 && TARGET_68040))
                return 102; /* *m68k.md:2063 */
              if (
#line 2078 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
                return 103; /* truncdfsf2_cf */
              if (!
#line 2088 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 104; /* *truncdfsf2_68881 */

            case E_XFmode:
              if (!general_operand (operands[1], E_XFmode)
                  || !
#line 6600 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
                return -1;
              return 411; /* truncxfsf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !general_operand (operands[1], E_XFmode)
              || !
#line 6585 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 410; /* truncxfdf2 */

        default:
          return -1;
        }

    case FLOAT:
      return recog_34 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_27 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_35 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_28 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_30 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_29 (x1, insn, pnum_clobbers);

    case SQRT:
      switch (pattern2 (x1))
        {
        case 0:
          if (
#line 4184 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 286; /* sqrtsf2_68881 */
          if (!
#line 4195 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 289; /* sqrtsf2_cf */

        case 1:
          if (
#line 4184 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 287; /* sqrtdf2_68881 */
          if (!
#line 4195 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 290; /* sqrtdf2_cf */

        case 2:
          if (!
#line 4184 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 288; /* sqrtxf2_68881 */

        default:
          return -1;
        }

    case ABS:
      switch (pattern2 (x1))
        {
        case 0:
          if (
#line 4299 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 291; /* abssf2_68881 */
          if (!
#line 4314 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 294; /* abssf2_cf */

        case 1:
          if (
#line 4299 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return 292; /* absdf2_68881 */
          if (!
#line 4314 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE_FPU))
            return -1;
          return 295; /* absdf2_cf */

        case 2:
          if (!
#line 4299 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881))
            return -1;
          return 293; /* absxf2_68881 */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (general_operand (operands[1], E_SImode)
          && 
#line 4341 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD))
        return 296; /* *clzsi2_68k */
      if (!register_operand (operands[1], E_SImode)
          || !
#line 4348 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(ISA_HAS_FF1))
        return -1;
      return 297; /* *clzsi2_cf */

    case NOT:
      switch (pattern1 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !general_operand (operands[1], E_SImode))
                return -1;
              if (
#line 4369 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return 298; /* one_cmplsi2_internal */
              if (!
#line 4376 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_COLDFIRE))
                return -1;
              return 299; /* one_cmplsi2_5200 */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !general_operand (operands[1], E_HImode)
                  || !
#line 4383 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 300; /* one_cmplhi2 */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !general_operand (operands[1], E_QImode)
                  || !
#line 4397 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 302; /* one_cmplqi2 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4390 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 301; /* *m68k.md:4387 */

        case 2:
          if (!
#line 4404 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
            return -1;
          return 303; /* *m68k.md:4401 */

        default:
          return -1;
        }

    case ASHIFT:
      return recog_31 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      x7 = XEXP (x2, 1);
      if (GET_CODE (x7) == CONST_INT)
        {
          res = recog_24 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern5 (x1))
            {
            case 0:
              return 325; /* ashrsi3 */

            case 1:
              if (!
#line 4911 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 326; /* ashrhi3 */

            case 2:
              if (!
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 328; /* ashrqi3 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          switch (pattern6 (x1))
            {
            case 0:
              if (!
#line 4919 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 327; /* *m68k.md:4915 */

            case 1:
              if (!
#line 4935 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 329; /* *m68k.md:4931 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      return recog_33 (x1, insn, pnum_clobbers);

    case ROTATE:
      if (GET_MODE (x2) == E_SImode)
        {
          x7 = XEXP (x2, 1);
          if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 16])
            {
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              if (register_operand (operands[0], E_SImode))
                {
                  x3 = XEXP (x2, 0);
                  operands[1] = x3;
                  if (register_operand (operands[1], E_SImode))
                    return 343; /* rotlsi_16 */
                }
            }
        }
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern5 (x1))
            {
            case 0:
              if (!
#line 5256 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 344; /* rotlsi3 */

            case 1:
              if (!
#line 5274 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 345; /* rotlhi3 */

            case 2:
              if (!
#line 5306 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 347; /* rotlqi3 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          switch (pattern6 (x1))
            {
            case 0:
              if (!
#line 5290 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 346; /* *rotlhi3_lowpart */

            case 1:
              if (!
#line 5322 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 348; /* *rotlqi3_lowpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ROTATERT:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern5 (x1))
            {
            case 0:
              if (!
#line 5338 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 349; /* rotrsi3 */

            case 1:
              if (!
#line 5346 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 350; /* rotrhi3 */

            case 2:
              if (!
#line 5360 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 352; /* rotrqi3 */

            default:
              return -1;
            }

        case STRICT_LOW_PART:
          switch (pattern6 (x1))
            {
            case 0:
              if (!
#line 5353 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 351; /* rotrhi_lowpart */

            case 1:
              if (!
#line 5368 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!TARGET_COLDFIRE))
                return -1;
              return 353; /* *m68k.md:5364 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          res = recog_25 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      if (!nonmemory_operand (operands[3], E_SImode)
          || !
#line 5625 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD))
        return -1;
      return 368; /* *extzv_bfextu_mem */

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          res = recog_26 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      if (!nonmemory_operand (operands[3], E_SImode)
          || !
#line 5609 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68020 && TARGET_BITFIELD))
        return -1;
      return 367; /* *extv_bfexts_mem */

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      if (sibcall_operand (operands[1], E_SImode)
          && 
#line 5983 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(SIBLING_CALL_P (insn)))
        return 391; /* *sibcall_value */
      if (non_symbolic_call_operand (operands[1], E_SImode)
          && 
#line 6026 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!SIBLING_CALL_P (insn)))
        return 393; /* *non_symbolic_call_value */
      if (!symbolic_operand (operands[1], E_SImode))
        return -1;
      if (
#line 6036 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!SIBLING_CALL_P (insn) && m68k_symbolic_call_var == M68K_SYMBOLIC_CALL_JSR))
        return 394; /* *symbolic_call_value_jsr */
      if (!
#line 6049 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(!SIBLING_CALL_P (insn)
   && (m68k_symbolic_call_var == M68K_SYMBOLIC_CALL_BSR_C
       || m68k_symbolic_call_var == M68K_SYMBOLIC_CALL_BSR_P)))
        return -1;
      return 395; /* *symbolic_call_value_bsr */

    case UNSPEC:
      switch (XVECLEN (x2, 0))
        {
        case 1:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (XINT (x2, 1))
            {
            case 3:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              x11 = XVECEXP (x2, 0, 0);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !register_operand (operands[0], E_SImode))
                return -1;
              return 405; /* load_got */

            case 1:
              switch (pattern18 (x2))
                {
                case 0:
                  if (!
#line 6607 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations))
                    return -1;
                  return 412; /* sinsf2 */

                case 1:
                  if (!
#line 6607 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations))
                    return -1;
                  return 413; /* sindf2 */

                case 2:
                  if (!(
#line 6607 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return -1;
                  return 414; /* sinxf2 */

                default:
                  return -1;
                }

            case 2:
              switch (pattern18 (x2))
                {
                case 0:
                  if (!
#line 6619 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations))
                    return -1;
                  return 415; /* cossf2 */

                case 1:
                  if (!
#line 6619 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations))
                    return -1;
                  return 416; /* cosdf2 */

                case 2:
                  if (!(
#line 6619 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881 && flag_unsafe_math_optimizations) && 
#line 278 "../../gcc-15.0.1-20250313/gcc/config/m68k/m68k.md"
(TARGET_68881)))
                    return -1;
                  return 417; /* cosxf2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          if (XINT (x2, 1) != 5
              || GET_MODE (x2) != E_BLKmode)
            return -1;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_BLKmode)
            return -1;
          x12 = XEXP (x4, 0);
          if (GET_CODE (x12) != SCRATCH)
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x13 = XVECEXP (x2, 0, 1);
          operands[1] = x13;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 425; /* stack_tie */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
