/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!arith_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_6 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case UNSPEC:
              if (XVECLEN (x2, 0) != 1
                  || XINT (x2, 1) != 0)
                return -1;
              x3 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x3) != CLOBBER)
                return -1;
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != MEM
                  || GET_MODE (x4) != E_BLKmode)
                return -1;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != SCRATCH)
                return -1;
              x6 = XVECEXP (x2, 0, 0);
              operands[0] = x6;
              if (!const_int_operand (operands[0], E_SImode)
                  || !
#line 519 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_PREFETCH))
                return -1;
              return 13; /* iprefetch */

            case SET:
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case IF_THEN_ELSE:
                  x8 = XEXP (x7, 0);
                  if (!cmp_op (x8, E_SImode))
                    return -1;
                  operands[0] = x8;
                  x9 = XEXP (x7, 1);
                  if (GET_CODE (x9) != LABEL_REF)
                    return -1;
                  x10 = XEXP (x7, 2);
                  if (GET_CODE (x10) != PC
                      || pattern4 (x1, 
18, 
PC) != 0)
                    return -1;
                  x11 = XEXP (x8, 0);
                  operands[1] = x11;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x12 = XEXP (x8, 1);
                  operands[2] = x12;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 0);
                  operands[3] = x13;
                  return 67; /* branch_compare */

                case REG:
                case SUBREG:
                  operands[0] = x7;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x14 = XEXP (x2, 0);
                  if (GET_CODE (x14) != PC)
                    return -1;
                  x3 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x3) != USE)
                    return -1;
                  x4 = XEXP (x3, 0);
                  if (GET_CODE (x4) != LABEL_REF)
                    return -1;
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  return 70; /* tablejump_internal1 */

                case PLUS:
                  if (GET_MODE (x7) != E_SImode)
                    return -1;
                  x9 = XEXP (x7, 1);
                  if (GET_CODE (x9) != LABEL_REF
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x14 = XEXP (x2, 0);
                  if (GET_CODE (x14) != PC)
                    return -1;
                  x3 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x3) != USE)
                    return -1;
                  x4 = XEXP (x3, 0);
                  if (GET_CODE (x4) != LABEL_REF
                      || GET_MODE (x4) != E_SImode)
                    return -1;
                  x8 = XEXP (x7, 0);
                  operands[0] = x8;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x13 = XEXP (x9, 0);
                  operands[1] = x13;
                  x5 = XEXP (x4, 0);
                  if (!rtx_equal_p (x5, operands[1])
                      || !
#line 1886 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(NEXT_INSN (as_a <rtx_insn *> (operands[1])) != 0
  && GET_CODE (PATTERN (NEXT_INSN (as_a <rtx_insn *> (operands[1])))) == ADDR_DIFF_VEC
  && flag_pic))
                    return -1;
                  return 71; /* *microblaze.md:1881 */

                case CALL:
                  x8 = XEXP (x7, 0);
                  if (GET_CODE (x8) != MEM)
                    return -1;
                  x3 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x3) != CLOBBER)
                    return -1;
                  x14 = XEXP (x2, 0);
                  operands[0] = x14;
                  if (!register_operand (operands[0], E_VOIDmode))
                    return -1;
                  x11 = XEXP (x8, 0);
                  operands[1] = x11;
                  if (!call_insn_operand (operands[1], E_VOIDmode))
                    return -1;
                  x9 = XEXP (x7, 1);
                  operands[2] = x9;
                  x4 = XEXP (x3, 0);
                  operands[3] = x4;
                  if (!register_operand (operands[3], E_SImode))
                    return -1;
                  return 80; /* call_value_intern */

                default:
                  return -1;
                }

            case RETURN:
              x3 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x3) != USE)
                return -1;
              x4 = XEXP (x3, 0);
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 74; /* return_internal */

            case SIMPLE_RETURN:
              x3 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x3) != USE)
                return -1;
              x4 = XEXP (x3, 0);
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 75; /* simple_return_internal */

            case CALL:
              if (pattern4 (x1, 
15, 
MEM) != 0)
                return -1;
              x14 = XEXP (x2, 0);
              x15 = XEXP (x14, 0);
              operands[0] = x15;
              if (!call_insn_simple_operand (operands[0], E_VOIDmode))
                return -1;
              x7 = XEXP (x2, 1);
              operands[1] = x7;
              return 78; /* call_internal1 */

            default:
              return -1;
            }

        case 3:
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          x16 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x16) != USE)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case CALL:
              x14 = XEXP (x2, 0);
              if (GET_CODE (x14) != MEM)
                return -1;
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != REG
                  || REGNO (x4) != 15
                  || GET_MODE (x4) != E_SImode)
                return -1;
              x17 = XEXP (x16, 0);
              if (GET_CODE (x17) != REG
                  || REGNO (x17) != 20
                  || GET_MODE (x17) != E_SImode)
                return -1;
              x15 = XEXP (x14, 0);
              operands[0] = x15;
              if (!call_insn_plt_operand (operands[0], E_SImode))
                return -1;
              x7 = XEXP (x2, 1);
              operands[1] = x7;
              if (!
#line 2108 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(flag_pic))
                return -1;
              return 77; /* call_internal_plt */

            case SET:
              x7 = XEXP (x2, 1);
              if (GET_CODE (x7) != CALL)
                return -1;
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != MEM)
                return -1;
              x14 = XEXP (x2, 0);
              operands[0] = x14;
              if (!register_operand (operands[0], E_VOIDmode))
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              if (!call_insn_plt_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x7, 1);
              operands[2] = x9;
              x4 = XEXP (x3, 0);
              operands[3] = x4;
              if (!register_operand (operands[3], E_SImode))
                return -1;
              x17 = XEXP (x16, 0);
              operands[4] = x17;
              if (!register_operand (operands[4], E_SImode)
                  || !
#line 2217 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(flag_pic))
                return -1;
              return 79; /* call_value_intern_plt */

            default:
              return -1;
            }

        case 9:
          x18 = XVECEXP (x1, 0, 8);
          if (GET_CODE (x18) != CLOBBER
              || pattern5 (x1) != 0)
            return -1;
          x19 = XEXP (x18, 0);
          operands[8] = x19;
          if (!scratch_operand (operands[8], E_SImode))
            return -1;
          return 86; /* atomic_compare_and_swapsi */

        case 8:
          if (pnum_clobbers == NULL
              || pattern5 (x1) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 86; /* atomic_compare_and_swapsi */

        default:
          return -1;
        }

    case RETURN:
      return 72; /* *return */

    case SIMPLE_RETURN:
      return 73; /* *simple_return */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 0)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 76; /* blockage */

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x20 = XEXP (x1, 0);
      if (GET_CODE (x20) != MEM)
        return -1;
      x21 = XEXP (x20, 0);
      operands[0] = x21;
      if (!call_insn_simple_operand (operands[0], E_VOIDmode))
        return -1;
      x22 = XEXP (x1, 1);
      operands[1] = x22;
      *pnum_clobbers = 1;
      return 78; /* call_internal1 */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 81; /* nop */

    case TRAP_IF:
      x20 = XEXP (x1, 0);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XEXP (x1, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 82; /* trap */

    default:
      return -1;
    }
}
