/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && register_operand (operands[1], E_SImode)
              && 
#line 365 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_REORDER))
            return 1; /* bswapsi2 */
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && GET_MODE (x2) == E_HImode
              && register_operand (operands[1], E_HImode)
              && 
#line 372 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_REORDER))
            return 2; /* bswaphi2 */
          break;

        default:
          break;
        }
      break;

    case PLUS:
      switch (pattern1 (x1))
        {
        case 0:
          if (
#line 396 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT))
            return 3; /* addsf3 */
          break;

        case 1:
          if (reg_or_0_operand (operands[1], E_SImode)
              && arith_plus_operand (operands[2], E_SImode))
            return 10; /* addsi3 */
          break;

        case 2:
          return 11; /* adddi3 */

        default:
          break;
        }
      break;

    case MINUS:
      switch (pattern1 (x1))
        {
        case 0:
          if (
#line 406 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT))
            return 4; /* subsf3 */
          break;

        case 1:
          if (arith_operand (operands[1], E_SImode)
              && arith_operand (operands[2], E_SImode))
            return 12; /* subsi3 */
          break;

        case 2:
          return 14; /* subdi3 */

        default:
          break;
        }
      break;

    case MULT:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case DIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x2, 
E_SFmode) == 0
              && 
#line 427 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT))
            return 6; /* divsf3 */
          break;

        case E_SImode:
          if (pattern0 (x2, 
E_SImode) == 0
              && 
#line 664 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_DIV))
            return 22; /* divsi3_internal */
          break;

        default:
          break;
        }
      break;

    case SQRT:
      if (GET_MODE (x2) == E_SFmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SFmode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_SFmode)
                  && 
#line 436 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT_SQRT))
                return 7; /* sqrtsf2 */
            }
        }
      break;

    case FLOAT:
      if (GET_MODE (x2) == E_SFmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SFmode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_SImode)
                  && 
#line 445 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT_CONVERT))
                return 8; /* floatsisf2 */
            }
        }
      break;

    case FIX:
      if (GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_SFmode)
                  && 
#line 454 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT_CONVERT))
                return 9; /* fix_truncsfsi2 */
            }
        }
      break;

    case TRUNCATE:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UDIV:
      if (GET_MODE (x2) == E_SImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_SImode))
            {
              x4 = XEXP (x2, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_SImode))
                {
                  x5 = XEXP (x2, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_SImode)
                      && 
#line 676 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_DIV))
                    return 23; /* udivsi3 */
                }
            }
        }
      break;

    case NEG:
      switch (pattern2 (x1))
        {
        case 0:
          return 24; /* negsi2 */

        case 1:
          return 25; /* negdi2 */

        default:
          break;
        }
      break;

    case NOT:
      switch (pattern2 (x1))
        {
        case 0:
          return 26; /* one_cmplsi2 */

        case 1:
          return 27; /* *one_cmpldi2 */

        default:
          break;
        }
      break;

    case AND:
      if (pattern3 (x1) == 0)
        return 28; /* andsi3 */
      break;

    case IOR:
      if (pattern3 (x1) == 0)
        return 29; /* iorsi3 */
      break;

    case XOR:
      if (pattern3 (x1) == 0)
        return 30; /* xorsi3 */
      break;

    case ZERO_EXTEND:
      res = recog_3 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SIGN_EXTEND:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x3;
          operands[1] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && general_operand (operands[1], E_DImode))
                return 37; /* *movdi_internal */
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && register_operand (operands[1], E_SImode)
                  && 
#line 1006 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(microblaze_is_interrupt_variant ()))
                return 38; /* movsi_status */
              if (nonimmediate_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && 
#line 1019 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
((register_operand (operands[0], SImode) && 
           (GET_CODE (operands[1]) == CONST_INT && 
                 (INTVAL (operands[1]) <= 32767 && INTVAL (operands[1]) >= -32768)))))
                return 39; /* *movsi_internal3 */
              break;

            case E_HImode:
              if (nonimmediate_operand (operands[0], E_HImode)
                  && general_operand (operands[1], E_HImode))
                return 42; /* *movhi_internal2 */
              break;

            case E_QImode:
              if (nonimmediate_operand (operands[0], E_QImode)
                  && general_operand (operands[1], E_QImode))
                return 43; /* *movqi_internal2 */
              break;

            case E_SFmode:
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && general_operand (operands[1], E_SFmode)
                  && 
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
((register_operand (operands[0], SFmode)
       || register_operand (operands[1], SFmode)
       || operands[1] == CONST0_RTX (SFmode))))
                return 45; /* *movsf_internal */
              break;

            case E_DFmode:
              if (nonimmediate_operand (operands[0], E_DFmode)
                  && general_operand (operands[1], E_DFmode))
                return 46; /* *movdf_internal */
              break;

            default:
              break;
            }
          break;

        case PC:
          operands[0] = x2;
          if (register_operand (operands[0], E_SImode))
            return 69; /* indirect_jump_internal1 */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) == LABEL_REF
          && GET_CODE (x3) == PC)
        {
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 68; /* jump */
        }
      break;

    case IF_THEN_ELSE:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  operands[1] = x2;
  if (call_insn_operand (operands[1], E_SImode)
      && register_operand (operands[0], E_SImode)
      && 
#line 1034 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
((register_operand (operands[0], Pmode) && 
           PLT_ADDR_P (operands[1]))))
    return 40; /* *movsi_internal5_pltop */
  if (move_src_operand (operands[1], E_SImode)
      && nonimmediate_operand (operands[0], E_SImode))
    return 41; /* *movsi_internal2 */
  switch (GET_CODE (x2))
    {
    case BSWAP:
      if (GET_MODE (x2) != E_SImode
          || !reg_or_mem_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!reg_or_mem_operand (operands[1], E_SFmode)
          || !
#line 1166 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_REORDER))
        return -1;
      return 44; /* movsi4_rev */

    case ASHIFT:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 1326 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
((operands[2] == const1_rtx)))
            return 47; /* *ashlsi3_byone */
          if (
#line 1338 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_BARREL_SHIFT))
            return 48; /* ashlsi3_bshift */
        }
      if (immediate_operand (operands[2], E_SImode))
        {
          if (
#line 1353 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL 
   && ((1 << INTVAL (operands[2])) <= 32767 && (1 << INTVAL (operands[2])) >= -32768)))
            return 49; /* *ashlsi3_with_mul_delay */
          if (
#line 1366 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(!TARGET_SOFT_MUL))
            return 50; /* *ashlsi3_with_mul_nodelay */
          if (
#line 1378 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
((INTVAL (operands[2]) > 5 && optimize_size)))
            return 51; /* *ashlsi3_with_size_opt */
          if (
#line 1399 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
((INTVAL (operands[2]) > 17 && !optimize_size)))
            return 52; /* *ashlsi3_with_rotate */
          return 53; /* *ashlsi_inline */
        }
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 54; /* *ashlsi_reg */

    case ASHIFTRT:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 1487 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
((operands[2] == const1_rtx)))
            return 55; /* *ashrsi3_byone */
          if (
#line 1499 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_BARREL_SHIFT))
            return 56; /* *ashrsi3_bshift */
        }
      if (immediate_operand (operands[2], E_SImode))
        return 57; /* *ashrsi_inline */
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 58; /* *ashrsi_reg */

    case LSHIFTRT:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (arith_operand (operands[2], E_SImode))
        {
          if (
#line 1576 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
((operands[2] == const1_rtx)))
            return 59; /* *lshrsi3_byone */
          if (
#line 1588 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_BARREL_SHIFT))
            return 60; /* *lshrsi3_bshift */
        }
      if (immediate_operand (operands[2], E_SImode))
        return 61; /* *lshrsi_inline */
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 62; /* *lshrsi_reg */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (GET_MODE (x2) == E_SImode)
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_SImode))
                {
                  switch (GET_CODE (x2))
                    {
                    case EQ:
                      if (
#line 1659 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_PATTERN_COMPARE))
                        return 63; /* seq_internal_pat */
                      break;

                    case NE:
                      if (
#line 1671 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_PATTERN_COMPARE))
                        return 64; /* sne_internal_pat */
                      break;

                    default:
                      break;
                    }
                }
            }
        }
      operands[1] = x2;
      if (!ordered_comparison_operator (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SFmode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!register_operand (operands[3], E_SFmode)
          || !
#line 1686 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 65; /* cstoresf4 */

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 101:
          return 83; /* set_got */

        case 107:
          return 84; /* set_text */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 2339 "../../gcc-15.0.1-20250313/gcc/config/microblaze/microblaze.md"
(TARGET_HAS_CLZ))
        return -1;
      return 85; /* clzsi2 */

    default:
      return -1;
    }
}
