/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_uimm5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern0 (x1, 
E_V4HImode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern46 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], i1))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], i2))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2SFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2SFmode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern75 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_uimm3_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern80 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[1], E_V2DImode))
        return -1;
      return 2;

    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 3;

    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 4;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  return pattern89 (x1); /* [-1, 1] */
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !lo_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 183
      || GET_MODE (x2) != E_CCDSPmode)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_CCDSPmode)
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!muldiv_target_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_TImode:
      if (!muldiv_target_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 1;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, unsigned int i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1)
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !const_1_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL)
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != VEC_SELECT)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL)
    return -1;
  x10 = XEXP (x2, 1);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != VEC_SELECT)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != PARALLEL)
    return -1;
  x14 = XEXP (x10, 1);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != VEC_SELECT)
    return -1;
  x16 = XEXP (x15, 1);
  if (GET_CODE (x16) != PARALLEL)
    return -1;
  x17 = XEXP (x5, 0);
  operands[2] = x17;
  x18 = XEXP (x8, 0);
  operands[3] = x18;
  x19 = XEXP (x12, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  x20 = XEXP (x15, 0);
  if (!rtx_equal_p (x20, operands[3]))
    return -1;
  switch (XVECLEN (x6, 0))
    {
    case 2:
      x21 = XVECEXP (x6, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x6, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x9, 0) != 2)
        return -1;
      x23 = XVECEXP (x9, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x9, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x13, 0) != 2)
        return -1;
      x25 = XVECEXP (x13, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XVECEXP (x13, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || XVECLEN (x16, 0) != 2)
        return -1;
      x27 = XVECEXP (x16, 0, 0);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x16, 0, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || pattern145 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 0;

    case 4:
      x21 = XVECEXP (x6, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x6, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x29 = XVECEXP (x6, 0, 2);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x30 = XVECEXP (x6, 0, 3);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x9, 0) != 4)
        return -1;
      x23 = XVECEXP (x9, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x9, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x31 = XVECEXP (x9, 0, 2);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x32 = XVECEXP (x9, 0, 3);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x13, 0) != 4)
        return -1;
      x25 = XVECEXP (x13, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XVECEXP (x13, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x33 = XVECEXP (x13, 0, 2);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x34 = XVECEXP (x13, 0, 3);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || XVECLEN (x16, 0) != 4)
        return -1;
      x27 = XVECEXP (x16, 0, 0);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x16, 0, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x35 = XVECEXP (x16, 0, 2);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x36 = XVECEXP (x16, 0, 3);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern145 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case 8:
      x21 = XVECEXP (x6, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x6, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x29 = XVECEXP (x6, 0, 2);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x30 = XVECEXP (x6, 0, 3);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x37 = XVECEXP (x6, 0, 4);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x38 = XVECEXP (x6, 0, 5);
      if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x39 = XVECEXP (x6, 0, 6);
      if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x40 = XVECEXP (x6, 0, 7);
      if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x9, 0) != 8)
        return -1;
      x23 = XVECEXP (x9, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x9, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x31 = XVECEXP (x9, 0, 2);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x32 = XVECEXP (x9, 0, 3);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x41 = XVECEXP (x9, 0, 4);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x42 = XVECEXP (x9, 0, 5);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x43 = XVECEXP (x9, 0, 6);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x44 = XVECEXP (x9, 0, 7);
      if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x13, 0) != 8)
        return -1;
      x25 = XVECEXP (x13, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XVECEXP (x13, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x33 = XVECEXP (x13, 0, 2);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x34 = XVECEXP (x13, 0, 3);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x45 = XVECEXP (x13, 0, 4);
      if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x46 = XVECEXP (x13, 0, 5);
      if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x47 = XVECEXP (x13, 0, 6);
      if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x48 = XVECEXP (x13, 0, 7);
      if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || XVECLEN (x16, 0) != 8)
        return -1;
      x27 = XVECEXP (x16, 0, 0);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x16, 0, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x35 = XVECEXP (x16, 0, 2);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x36 = XVECEXP (x16, 0, 3);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x49 = XVECEXP (x16, 0, 4);
      if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x50 = XVECEXP (x16, 0, 5);
      if (x50 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x51 = XVECEXP (x16, 0, 6);
      if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x52 = XVECEXP (x16, 0, 7);
      if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || pattern145 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern260 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      operands[4] = x2;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[0]))
        return -1;
      return 0;

    case MINUS:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      operands[4] = x2;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[0]))
        return -1;
      return 1;

    case IOR:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      operands[4] = x2;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[0]))
        return -1;
      return 2;

    case XOR:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      operands[4] = x2;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[0]))
        return -1;
      return 3;

    case AND:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      operands[4] = x2;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[0]))
        return -1;
      return 4;

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[4] = x1;
      if (!reg_or_0_operand (operands[4], E_SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (pattern149 (x3, 
E_DFmode, 
E_SImode) != 0
          || !(
#line 5576 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 891 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
        return -1;
      return 414; /* mthc1df */

    case E_DImode:
      if (pattern149 (x3, 
E_DImode, 
E_SImode) != 0
          || !(
#line 5576 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 892 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
        return -1;
      return 415; /* mthc1di */

    case E_V2SFmode:
      if (pattern149 (x3, 
E_V2SFmode, 
E_SImode) != 0
          || !(
#line 5576 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 893 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_PAIRED_SINGLE_FLOAT)))
        return -1;
      return 416; /* mthc1v2sf */

    case E_V2SImode:
      if (pattern149 (x3, 
E_V2SImode, 
E_SImode) != 0
          || !(
#line 5576 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
        return -1;
      return 417; /* mthc1v2si */

    case E_V4HImode:
      if (pattern149 (x3, 
E_V4HImode, 
E_SImode) != 0
          || !(
#line 5576 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 895 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
        return -1;
      return 418; /* mthc1v4hi */

    case E_V8QImode:
      if (pattern149 (x3, 
E_V8QImode, 
E_SImode) != 0
          || !(
#line 5576 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 896 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
        return -1;
      return 419; /* mthc1v8qi */

    case E_TFmode:
      if (pattern149 (x3, 
E_TFmode, 
E_DImode) != 0
          || !(
#line 5576 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 897 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_FLOAT64)))
        return -1;
      return 420; /* mthc1tf */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 28)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern174 (x2, 
E_SImode) != 0
          || !(
#line 5708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_CPRESTORE_DIRECTIVE) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
        return -1;
      return 439; /* cprestore_si */

    case E_DImode:
      if (pattern174 (x2, 
E_DImode) != 0
          || !(
#line 5708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_CPRESTORE_DIRECTIVE) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
        return -1;
      return 440; /* cprestore_di */

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 2565 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1680; /* msa_srari_d */

    case 1:
      if (!
#line 2565 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1681; /* msa_srari_w */

    case 2:
      if (!
#line 2565 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1682; /* msa_srari_h */

    case 3:
      if (!
#line 2565 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1683; /* msa_srari_b */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1396; /* msa_bclri_d */

    case 1:
      if (!
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1397; /* msa_bclri_w */

    case 2:
      if (!
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1398; /* msa_bclri_h */

    case 3:
      if (!
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1399; /* msa_bclri_b */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      switch (pattern158 (x2, 
E_SFmode))
        {
        case 0:
          if (!(
#line 5078 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && (((
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
            return -1;
          return 341; /* *lwxc1_si */

        case 1:
          if (!(
#line 5078 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && (((
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
            return -1;
          return 344; /* *lwxc1_di */

        default:
          return -1;
        }

    case E_DFmode:
      switch (pattern158 (x2, 
E_DFmode))
        {
        case 0:
          if (!(
#line 5078 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && (((
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
            return -1;
          return 342; /* *ldxc1_si */

        case 1:
          if (!(
#line 5078 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && (((
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
            return -1;
          return 345; /* *ldxc1_di */

        default:
          return -1;
        }

    case E_V2SFmode:
      switch (pattern158 (x2, 
E_V2SFmode))
        {
        case 0:
          if (!(
#line 5078 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && (((
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
            return -1;
          return 343; /* *ldxc1_si */

        case 1:
          if (!(
#line 5078 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LXC1_SXC1) && (((
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
            return -1;
          return 346; /* *ldxc1_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          res = recog_50 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case UNSPEC:
          res = recog_51 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case EQ:
          switch (pattern81 (x1))
            {
            case 0:
              if (!
#line 6238 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_BBIT && UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)))
                return -1;
              return 495; /* *branch_bit0si */

            case 1:
              if (!(
#line 6238 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_BBIT && UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 497; /* *branch_bit0di */

            case 2:
              if (!
#line 6258 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_BBIT && UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)))
                return -1;
              return 499; /* *branch_bit0si_inverted */

            case 3:
              if (!(
#line 6258 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_BBIT && UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 501; /* *branch_bit0di_inverted */

            case 4:
              x5 = XEXP (x3, 1);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XEXP (x1, 0);
              operands[0] = x6;
              x7 = XEXP (x2, 1);
              operands[2] = x7;
              x8 = XEXP (x2, 2);
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  switch (pattern212 (x2, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 7556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEL
   && (register_operand (operands[2], SImode)
       != register_operand (operands[3], SImode))))
                        return -1;
                      return 738; /* *seleqsi_using_si */

                    case 1:
                      if (!(
#line 7556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEL
   && (register_operand (operands[2], SImode)
       != register_operand (operands[3], SImode))) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                        return -1;
                      return 742; /* *seleqsi_using_di */

                    default:
                      return -1;
                    }

                case E_DImode:
                  switch (pattern212 (x2, 
E_DImode))
                    {
                    case 0:
                      if (!(
#line 7556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEL
   && (register_operand (operands[2], DImode)
       != register_operand (operands[3], DImode))) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                        return -1;
                      return 740; /* *seleqdi_using_si */

                    case 1:
                      if (!(
#line 7556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEL
   && (register_operand (operands[2], DImode)
       != register_operand (operands[3], DImode))) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                        return -1;
                      return 744; /* *seleqdi_using_di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 5:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1742; /* msa_bz_d_f */

            case 6:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1744; /* msa_bz_w_f */

            case 7:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1746; /* msa_bz_d */

            case 8:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1748; /* msa_bz_w */

            case 9:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1750; /* msa_bz_h */

            case 10:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1752; /* msa_bz_b */

            case 11:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1754; /* msa_bz_v_d_f */

            case 12:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1756; /* msa_bz_v_w_f */

            case 13:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1758; /* msa_bz_v_d */

            case 14:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1760; /* msa_bz_v_w */

            case 15:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1762; /* msa_bz_v_h */

            case 16:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1764; /* msa_bz_v_b */

            default:
              return -1;
            }

        case NE:
          switch (pattern81 (x1))
            {
            case 0:
              if (!
#line 6238 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_BBIT && UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)))
                return -1;
              return 496; /* *branch_bit1si */

            case 1:
              if (!(
#line 6238 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_BBIT && UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 498; /* *branch_bit1di */

            case 2:
              if (!
#line 6258 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_BBIT && UINTVAL (operands[2]) < GET_MODE_BITSIZE (SImode)))
                return -1;
              return 500; /* *branch_bit1si_inverted */

            case 3:
              if (!(
#line 6258 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_BBIT && UINTVAL (operands[2]) < GET_MODE_BITSIZE (DImode)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 502; /* *branch_bit1di_inverted */

            case 4:
              x5 = XEXP (x3, 1);
              if (GET_CODE (x5) != CONST_INT)
                return -1;
              switch (XWINT (x5, 0))
                {
                case 0L:
                  x7 = XEXP (x2, 1);
                  switch (GET_CODE (x7))
                    {
                    case CONST_INT:
                    case CONST_DOUBLE:
                    case CONST_VECTOR:
                    case REG:
                    case SUBREG:
                      operands[2] = x7;
                      x6 = XEXP (x1, 0);
                      operands[0] = x6;
                      x8 = XEXP (x2, 2);
                      operands[3] = x8;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          switch (pattern212 (x2, 
E_SImode))
                            {
                            case 0:
                              if (!
#line 7556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEL
   && (register_operand (operands[2], SImode)
       != register_operand (operands[3], SImode))))
                                return -1;
                              return 739; /* *selnesi_using_si */

                            case 1:
                              if (!(
#line 7556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEL
   && (register_operand (operands[2], SImode)
       != register_operand (operands[3], SImode))) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                                return -1;
                              return 743; /* *selnesi_using_di */

                            default:
                              return -1;
                            }

                        case E_DImode:
                          switch (pattern212 (x2, 
E_DImode))
                            {
                            case 0:
                              if (!(
#line 7556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEL
   && (register_operand (operands[2], DImode)
       != register_operand (operands[3], DImode))) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                                return -1;
                              return 741; /* *selnedi_using_si */

                            case 1:
                              if (!(
#line 7556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEL
   && (register_operand (operands[2], DImode)
       != register_operand (operands[3], DImode))) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                                return -1;
                              return 745; /* *selnedi_using_di */

                            default:
                              return -1;
                            }

                        case E_SFmode:
                          if (pattern233 (x2, 
E_SFmode) != 0
                              || !(
#line 7576 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEL && ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                            return -1;
                          return 746; /* *selsf */

                        case E_DFmode:
                          if (pattern233 (x2, 
E_DFmode) != 0
                              || !(
#line 7576 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEL && ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                            return -1;
                          return 747; /* *seldf */

                        default:
                          return -1;
                        }

                    case LABEL_REF:
                      switch (pattern185 (x1))
                        {
                        case 0:
                          if (!
#line 572 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
                            return -1;
                          return 894; /* bc1any4t */

                        case 1:
                          if (!
#line 594 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
                            return -1;
                          return 896; /* bc1any2t */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case -1L:
                  x7 = XEXP (x2, 1);
                  if (GET_CODE (x7) != LABEL_REF)
                    return -1;
                  switch (pattern185 (x1))
                    {
                    case 0:
                      if (!
#line 583 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
                        return -1;
                      return 895; /* bc1any4f */

                    case 1:
                      if (!
#line 605 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
                        return -1;
                      return 897; /* bc1any2f */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 5:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1743; /* msa_bnz_d_f */

            case 6:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1745; /* msa_bnz_w_f */

            case 7:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1747; /* msa_bnz_d */

            case 8:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1749; /* msa_bnz_w */

            case 9:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1751; /* msa_bnz_h */

            case 10:
              if (!
#line 2776 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1753; /* msa_bnz_b */

            case 11:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1755; /* msa_bnz_v_d_f */

            case 12:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1757; /* msa_bnz_v_w_f */

            case 13:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1759; /* msa_bnz_v_d */

            case 14:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1761; /* msa_bnz_v_w */

            case 15:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1763; /* msa_bnz_v_h */

            case 16:
              if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1765; /* msa_bnz_v_b */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      operands[1] = x3;
      if (order_operator (operands[1], E_VOIDmode))
        {
          res = recog_52 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (GET_CODE (x3))
        {
        case LT:
          switch (pattern84 (x1))
            {
            case 0:
              if (!(
#line 8027 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 783; /* fmin_a_sf */

            case 1:
              if (!(
#line 8027 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 784; /* fmin_a_df */

            case 2:
              if (!
#line 1778 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1552; /* msa_fmin_a_d */

            case 3:
              if (!
#line 1778 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1553; /* msa_fmin_a_w */

            case 4:
              if (!
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1618; /* msa_min_a_d */

            case 5:
              if (!
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1619; /* msa_min_a_w */

            case 6:
              if (!
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1620; /* msa_min_a_h */

            case 7:
              if (!
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1621; /* msa_min_a_b */

            default:
              return -1;
            }

        case GT:
          switch (pattern84 (x1))
            {
            case 0:
              if (!(
#line 8039 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 785; /* fmax_a_sf */

            case 1:
              if (!(
#line 8039 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 786; /* fmax_a_df */

            case 2:
              if (!
#line 1757 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1548; /* msa_fmax_a_d */

            case 3:
              if (!
#line 1757 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1549; /* msa_fmax_a_w */

            case 4:
              if (!
#line 2243 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1606; /* msa_max_a_d */

            case 5:
              if (!
#line 2243 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1607; /* msa_max_a_w */

            case 6:
              if (!
#line 2243 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1608; /* msa_max_a_h */

            case 7:
              if (!
#line 2243 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1609; /* msa_max_a_b */

            default:
              return -1;
            }

        case GE:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 182
              || GET_MODE (x4) != E_CCDSPmode)
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) != PC)
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!
#line 1154 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
            return -1;
          return 1018; /* mips_bposge */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x3;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x2, 1);
      operands[2] = x7;
      x8 = XEXP (x2, 2);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern109 (x2, 
E_SImode))
            {
            case 0:
              if (reg_or_0_operand (operands[2], E_SImode)
                  && reg_or_0_operand (operands[3], E_SImode)
                  && 
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE))
                return 722; /* movsi_on_si_ne */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_SImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_SImode)
                  || !
#line 7524 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE))
                return -1;
              return 726; /* movsi_on_si_ne_mips16e2 */

            case 1:
              if (reg_or_0_operand (operands[2], E_SImode)
                  && reg_or_0_operand (operands[3], E_SImode)
                  && (
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 724; /* movsi_on_di_ne */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_SImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_SImode)
                  || !(
#line 7524 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 728; /* movsi_on_di_ne_mips16e2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern109 (x2, 
E_DImode))
            {
            case 0:
              if (reg_or_0_operand (operands[2], E_DImode)
                  && reg_or_0_operand (operands[3], E_DImode)
                  && (
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 723; /* movdi_on_si_ne */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_DImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_DImode)
                  || !(
#line 7524 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 727; /* movdi_on_si_ne_mips16e2 */

            case 1:
              if (reg_or_0_operand (operands[2], E_DImode)
                  && reg_or_0_operand (operands[3], E_DImode)
                  && (
#line 7511 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 725; /* movdi_on_di_ne */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_DImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_DImode)
                  || !(
#line 7524 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 729; /* movdi_on_di_ne_mips16e2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern179 (x3, 
E_SFmode) != 0)
                return -1;
              if ((
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 84; /* *fmasf4_madd3 */
              if ((
#line 2593 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 87; /* *fmasf4_madd4 */
              if (!(
#line 2603 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADDF) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 90; /* *fmasf4_maddf */

            case E_DFmode:
              if (pattern179 (x3, 
E_DFmode) != 0)
                return -1;
              if ((
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 85; /* *fmadf4_madd3 */
              if ((
#line 2593 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 88; /* *fmadf4_madd4 */
              if (!(
#line 2603 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADDF) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 91; /* *fmadf4_maddf */

            case E_V2SFmode:
              if (pattern179 (x3, 
E_V2SFmode) != 0)
                return -1;
              if ((
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return 86; /* *fmav2sf4_madd3 */
              if ((
#line 2593 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return 89; /* *fmav2sf4_madd4 */
              if (!(
#line 2603 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADDF) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 92; /* *fmav2sf4_maddf */

            case E_V2DFmode:
              if (pattern179 (x3, 
E_V2DFmode) != 0
                  || !
#line 979 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1346; /* fmav2df4 */

            case E_V4SFmode:
              if (pattern179 (x3, 
E_V4SFmode) != 0
                  || !
#line 979 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1347; /* fmav4sf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern180 (x3, 
E_SFmode) != 0)
                return -1;
              if ((
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 93; /* *fmssf4_msub3 */
              if (!(
#line 2637 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 96; /* *fmssf4_msub4 */

            case E_DFmode:
              if (pattern180 (x3, 
E_DFmode) != 0)
                return -1;
              if ((
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 94; /* *fmsdf4_msub3 */
              if (!(
#line 2637 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 97; /* *fmsdf4_msub4 */

            case E_V2SFmode:
              if (pattern180 (x3, 
E_V2SFmode) != 0)
                return -1;
              if ((
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return 95; /* *fmsv2sf4_msub3 */
              if (!(
#line 2637 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 98; /* *fmsv2sf4_msub4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern181 (x3, 
E_SFmode) != 0)
                return -1;
              if ((
#line 2661 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3 && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 99; /* *fnmasf4_nmsub3 */
              if (!(
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4 && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 102; /* *fnmasf4_nmsub4 */

            case E_DFmode:
              if (pattern181 (x3, 
E_DFmode) != 0)
                return -1;
              if ((
#line 2661 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3 && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 100; /* *fnmadf4_nmsub3 */
              if (!(
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4 && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 103; /* *fnmadf4_nmsub4 */

            case E_V2SFmode:
              if (pattern181 (x3, 
E_V2SFmode) != 0)
                return -1;
              if ((
#line 2661 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3 && !HONOR_SIGNED_ZEROS (V2SFmode)) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return 101; /* *fnmav2sf4_nmsub3 */
              if (!(
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4 && !HONOR_SIGNED_ZEROS (V2SFmode)) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 104; /* *fnmav2sf4_nmsub4 */

            case E_V2DFmode:
              if (pattern181 (x3, 
E_V2DFmode) != 0
                  || !
#line 989 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1348; /* fnmav2df4 */

            case E_V4SFmode:
              if (pattern181 (x3, 
E_V4SFmode) != 0
                  || !
#line 989 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1349; /* fnmav4sf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern182 (x3, 
E_SFmode) != 0)
                return -1;
              if ((
#line 2697 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3 && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 105; /* *fnmssf4_nmadd3 */
              if (!(
#line 2708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4 && !HONOR_SIGNED_ZEROS (SFmode)) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 108; /* *fnmssf4_nmadd4 */

            case E_DFmode:
              if (pattern182 (x3, 
E_DFmode) != 0)
                return -1;
              if ((
#line 2697 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3 && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 106; /* *fnmsdf4_nmadd3 */
              if (!(
#line 2708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4 && !HONOR_SIGNED_ZEROS (DFmode)) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 109; /* *fnmsdf4_nmadd4 */

            case E_V2SFmode:
              if (pattern182 (x3, 
E_V2SFmode) != 0)
                return -1;
              if ((
#line 2697 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD3 && !HONOR_SIGNED_ZEROS (V2SFmode)) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return 107; /* *fnmsv2sf4_nmadd3 */
              if (!(
#line 2708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FUSED_MADD4 && !HONOR_SIGNED_ZEROS (V2SFmode)) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 110; /* *fnmsv2sf4_nmadd4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case TRUNCATE:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != ASHIFT
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!const_arith_operand (operands[2], E_DImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (!const_arith_operand (operands[3], E_DImode)
          || !
#line 3603 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
((ISA_HAS_EXTS && TARGET_64BIT
    && UINTVAL (operands[2]) < 32 && UINTVAL (operands[3]) < 32
    && UINTVAL (operands[3]) >= UINTVAL (operands[2]))))
        return -1;
      return 216; /* *mips.md:3596 */

    case REG:
    case SUBREG:
      switch (pattern23 (x3))
        {
        case 0:
          if (
#line 5860 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 452; /* *ashrsi3 */
          if (!
#line 5891 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 461; /* *ashrsi3_mips16 */

        case 1:
          if ((
#line 5860 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 455; /* *ashrdi3 */
          if (!
#line 5935 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16))
            return -1;
          return 466; /* *ashrdi3_mips16 */

        case 2:
          if (!
#line 577 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1195; /* ashrv2si3 */

        case 3:
          if (!
#line 577 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1196; /* ashrv4hi3 */

        case 4:
          if (!
#line 912 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1330; /* vashrv2di3 */

        case 5:
          if (!
#line 912 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1331; /* vashrv4si3 */

        case 6:
          if (!
#line 912 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1332; /* vashrv8hi3 */

        case 7:
          if (!
#line 912 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1333; /* vashrv16qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern79 (x3))
        {
        case 0:
          if (!
#line 3169 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CLZ_CLO))
            return -1;
          return 169; /* clzsi2 */

        case 1:
          if (!(
#line 3169 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CLZ_CLO) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 170; /* clzdi2 */

        case 2:
          if (!
#line 2358 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1642; /* clzv2di2 */

        case 3:
          if (!
#line 2358 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1643; /* clzv4si2 */

        case 4:
          if (!
#line 2358 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1644; /* clzv8hi2 */

        case 5:
          if (!
#line 2358 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1645; /* clzv16qi2 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern115 (x3, 
E_SImode) != 0
              || !
#line 3178 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CLZ_CLO))
            return -1;
          return 171; /* *closi2 */

        case E_DImode:
          if (pattern115 (x3, 
E_DImode) != 0
              || !(
#line 3178 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CLZ_CLO) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 172; /* *clodi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_103 (x1, insn, pnum_clobbers);

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x7 = XEXP (x2, 1);
      operands[1] = x7;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case CLOBBER:
          if (pattern220 (x1) != 0
              || !call_insn_operand (operands[0], E_VOIDmode)
              || !
#line 7201 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_SPLIT_CALLS))
            return -1;
          return 691; /* call_split */

        case CONST_INT:
          if (XWINT (x8, 0) != 1L
              || REGNO (x5) != 31
              || !const_call_insn_operand (operands[0], E_VOIDmode))
            return -1;
          return 692; /* call_internal_direct */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 2
          || XINT (x2, 1) != 13
          || GET_MODE (x2) != E_SImode)
        return -1;
      x9 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 4
          || GET_MODE (x9) != E_SImode
          || pattern127 (x1, 
31, 
25) != 0)
        return -1;
      x10 = XVECEXP (x2, 0, 0);
      operands[0] = x10;
      if (call_insn_operand (operands[0], E_SImode))
        {
          x8 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x8, 0);
          if (GET_MODE (x11) == E_SImode)
            {
              x4 = XVECEXP (x1, 0, 2);
              x5 = XEXP (x4, 0);
              if (GET_MODE (x5) == E_SImode
                  && (
#line 7883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
                return 767; /* mips_set_fcsr_mips16_si */
            }
        }
      if (!call_insn_operand (operands[0], E_DImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x8, 0);
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode
          || !(
#line 7883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
        return -1;
      return 768; /* mips_set_fcsr_mips16_di */

    case RETURN:
      x8 = XVECEXP (x1, 0, 1);
      if (pattern25 (x8, 
USE) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x12 = XEXP (x4, 1);
      if (GET_CODE (x12) != PLUS
          || GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != REG
          || REGNO (x13) != 29
          || GET_MODE (x13) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 29
          || GET_MODE (x5) != E_SImode)
        return -1;
      x14 = XEXP (x12, 1);
      operands[0] = x14;
      if (!uw5_operand (operands[0], E_VOIDmode)
          || !
#line 104 "../../gcc-15.0.1-20250313/gcc/config/mips/micromips.md"
(TARGET_MICROMIPS))
        return -1;
      return 1123; /* jraddiusp */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (pattern15 (x2, 
157, 
2) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCDSPmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 182
      || GET_MODE (x4) != E_CCDSPmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || pattern130 (x5, 
183, 
157, 
2) != 0)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (pattern221 (x7, 
157, 
2, 
UNSPEC) != 0)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != E_CCDSPmode)
    return -1;
  x9 = XEXP (x7, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 184
      || GET_MODE (x9) != E_CCDSPmode)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != UNSPEC
      || XVECLEN (x11, 0) != 2
      || XINT (x11, 1) != 157
      || GET_MODE (x11) != E_CCDSPmode)
    return -1;
  x12 = XEXP (x10, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 185
      || GET_MODE (x12) != E_CCDSPmode)
    return -1;
  x13 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x13) != SET)
    return -1;
  x14 = XEXP (x13, 1);
  if (GET_CODE (x14) != UNSPEC
      || XVECLEN (x14, 0) != 2
      || XINT (x14, 1) != 157
      || GET_MODE (x14) != E_CCDSPmode)
    return -1;
  x15 = XEXP (x13, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 186
      || GET_MODE (x15) != E_CCDSPmode)
    return -1;
  x16 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x16) != SET)
    return -1;
  x17 = XEXP (x16, 1);
  if (GET_CODE (x17) != UNSPEC
      || XVECLEN (x17, 0) != 2
      || XINT (x17, 1) != 157
      || GET_MODE (x17) != E_CCDSPmode)
    return -1;
  x18 = XEXP (x16, 0);
  if (GET_CODE (x18) != REG
      || REGNO (x18) != 187
      || GET_MODE (x18) != E_CCDSPmode)
    return -1;
  x19 = XVECEXP (x3, 0, 0);
  operands[0] = x19;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x20 = XVECEXP (x3, 0, 1);
  operands[1] = x20;
  if (!const_uimm6_operand (operands[1], E_SImode))
    return -1;
  x21 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x21, operands[0]))
    return -1;
  x22 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x22, operands[1]))
    return -1;
  x23 = XVECEXP (x8, 0, 0);
  if (!rtx_equal_p (x23, operands[0]))
    return -1;
  x24 = XVECEXP (x8, 0, 1);
  if (!rtx_equal_p (x24, operands[1]))
    return -1;
  x25 = XVECEXP (x11, 0, 0);
  if (!rtx_equal_p (x25, operands[0]))
    return -1;
  x26 = XVECEXP (x11, 0, 1);
  if (!rtx_equal_p (x26, operands[1]))
    return -1;
  x27 = XVECEXP (x14, 0, 0);
  if (!rtx_equal_p (x27, operands[0]))
    return -1;
  x28 = XVECEXP (x14, 0, 1);
  if (!rtx_equal_p (x28, operands[1]))
    return -1;
  x29 = XVECEXP (x17, 0, 0);
  if (!rtx_equal_p (x29, operands[0]))
    return -1;
  x30 = XVECEXP (x17, 0, 1);
  if (!rtx_equal_p (x30, operands[1])
      || !
#line 1058 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
    return -1;
  return 992; /* mips_wrdsp */
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!d_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XEXP (x3, 1);
          if (!const_int_operand (x4, E_SImode))
            return NULL;
          operands[1] = x4;
          x5 = XEXP (x3, 0);
          if (rtx_equal_p (x5, operands[0])
              && 
#line 1336 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) > 0x7f
	&& INTVAL (operands[1]) <= 0x7f + 0x7f)
       || (INTVAL (operands[1]) < - 0x80
	   && INTVAL (operands[1]) >= - 0x80 - 0x80))))
            return gen_split_1 (insn, operands);
          operands[2] = x4;
          operands[1] = x5;
          if (!d_operand (operands[1], E_SImode)
              || !
#line 1362 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && REGNO (operands[0]) != REGNO (operands[1])
   && ((INTVAL (operands[2]) > 0x7
	&& INTVAL (operands[2]) <= 0x7 + 0x7f)
       || (INTVAL (operands[2]) < - 0x8
	   && INTVAL (operands[2]) >= - 0x8 - 0x80))))
            return NULL;
          return gen_split_2 (insn, operands);

        case E_DImode:
          if (!d_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return NULL;
          x4 = XEXP (x3, 1);
          if (!const_int_operand (x4, E_DImode))
            return NULL;
          operands[1] = x4;
          x5 = XEXP (x3, 0);
          if (rtx_equal_p (x5, operands[0])
              && 
#line 1389 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && TARGET_64BIT && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) > 0xf
	&& INTVAL (operands[1]) <= 0xf + 0xf)
       || (INTVAL (operands[1]) < - 0x10
	   && INTVAL (operands[1]) >= - 0x10 - 0x10))))
            return gen_split_3 (insn, operands);
          operands[2] = x4;
          operands[1] = x5;
          if (!d_operand (operands[1], E_DImode)
              || !
#line 1415 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && TARGET_64BIT && reload_completed && !TARGET_DEBUG_D_MODE
   && REGNO (operands[0]) != REGNO (operands[1])
   && ((INTVAL (operands[2]) > 0x7
	&& INTVAL (operands[2]) <= 0x7 + 0xf)
       || (INTVAL (operands[2]) < - 0x8
	   && INTVAL (operands[2]) >= - 0x8 - 0x10))))
            return NULL;
          return gen_split_4 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          if (pattern32 (x3) != 0
              || !(
#line 1457 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16) && 
#line 1459 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
            return NULL;
          return gen_split_5 (insn, operands);

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x5;
          switch (pattern101 (x3))
            {
            case 0:
              if (!(
#line 3813 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 3818 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && register_operand (operands[1], VOIDmode))))
                return NULL;
              return gen_split_25 (insn, operands);

            case 1:
              if (!((
#line 3846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 3850 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
                return NULL;
              return gen_split_27 (insn, operands);

            case 2:
              if (!((
#line 3846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 3850 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
                return NULL;
              return gen_split_29 (insn, operands);

            case 3:
              if (!(
#line 3846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 3850 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
                return NULL;
              return gen_split_26 (insn, operands);

            case 4:
              if (!(
#line 3846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 3850 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
                return NULL;
              return gen_split_28 (insn, operands);

            case 5:
              if (!(
#line 3891 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 3895 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
                return NULL;
              return gen_split_30 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          switch (pattern34 (x3))
            {
            case 0:
              if (!(
#line 3925 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS) && 
#line 3927 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_31 (insn, operands);

            case 1:
              if (!(
#line 3925 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS) && 
#line 3927 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_32 (insn, operands);

            case 2:
              if (!(
#line 3945 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS) && 
#line 3947 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_33 (insn, operands);

            case 3:
              if (!(
#line 3945 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS) && 
#line 3947 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_34 (insn, operands);

            case 4:
              if (!(
#line 3965 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS) && 
#line 3967 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_35 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !(
#line 3651 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !ISA_HAS_EXT_INS) && 
#line 3655 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && REG_P (operands[1]))))
        return NULL;
      return gen_split_23 (insn, operands);

    case AND:
      if (GET_MODE (x3) != E_DImode)
        return NULL;
      x4 = XEXP (x3, 1);
      if (GET_CODE (x4) != CONST_INT
          || XWINT (x4, 0) != 4294967295L
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 3681 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !ISA_HAS_EXT_INS && reload_completed))
        return NULL;
      return gen_split_24 (insn, operands);

    case LO_SUM:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern132 (x3, 
E_SImode) != 0
              || !((
#line 4733 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 4735 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
            return NULL;
          return gen_split_42 (insn, operands);

        case E_DImode:
          if (pattern132 (x3, 
E_DImode) != 0
              || !((
#line 4733 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 4735 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
            return NULL;
          return gen_split_43 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x3))
        {
        case HIGH:
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x3) == E_DImode)
                {
                  if (register_operand (operands[0], E_DImode)
                      && absolute_symbolic_operand (operands[1], E_DImode)
                      && (
#line 4619 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && ABI_HAS_64BIT_SYMBOLS) && 
#line 4621 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( epilogue_completed)))
                    return gen_split_36 (insn, operands);
                  if (d_operand (operands[0], E_DImode)
                      && symbolic_operand_with_high (operands[1], E_DImode)
                      && (
#line 4700 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !ISA_HAS_MIPS16E2) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
                    return gen_split_39 (insn, operands);
                  if (register_operand (operands[0], E_DImode))
                    {
                      if (got_disp_operand (operands[1], E_DImode)
                          && ((
#line 4717 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 4719 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                        return gen_split_41 (insn, operands);
                      if (got_page_ofst_operand (operands[1], E_DImode)
                          && ((
#line 4760 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_hi_p[SYMBOL_GOT_PAGE_OFST]) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 4762 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                        return gen_split_47 (insn, operands);
                    }
                }
              break;

            case E_SImode:
              if (GET_MODE (x3) == E_SImode)
                {
                  if (d_operand (operands[0], E_SImode)
                      && symbolic_operand_with_high (operands[1], E_SImode)
                      && (
#line 4700 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !ISA_HAS_MIPS16E2) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
                    return gen_split_38 (insn, operands);
                  if (register_operand (operands[0], E_SImode))
                    {
                      if (got_disp_operand (operands[1], E_SImode)
                          && ((
#line 4717 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 4719 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                        return gen_split_40 (insn, operands);
                      if (got_page_ofst_operand (operands[1], E_SImode)
                          && ((
#line 4760 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_hi_p[SYMBOL_GOT_PAGE_OFST]) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 4762 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                        return gen_split_46 (insn, operands);
                    }
                }
              break;

            default:
              break;
            }
          break;

        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case MEM:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case CONST_INT:
          operands[1] = x3;
          if (const_int_operand (operands[1], E_SImode)
              && d_operand (operands[0], E_SImode)
              && 
#line 5049 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[1]) >= 0x100
   && INTVAL (operands[1]) <= 0xff + 0x7f))
            return gen_split_56 (insn, operands);
          break;

        default:
          break;
        }
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (nonimmediate_operand (operands[0], E_DImode)
              && move_operand (operands[1], E_DImode)
              && 
#line 5409 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)))
            return gen_split_59 (insn, operands);
          break;

        case E_DFmode:
          if (nonimmediate_operand (operands[0], E_DFmode)
              && move_operand (operands[1], E_DFmode)
              && 
#line 5409 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)))
            return gen_split_60 (insn, operands);
          break;

        case E_V2SFmode:
          if (nonimmediate_operand (operands[0], E_V2SFmode)
              && move_operand (operands[1], E_V2SFmode)
              && (
#line 5409 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)) && 
#line 864 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return gen_split_61 (insn, operands);
          break;

        case E_V2SImode:
          if (nonimmediate_operand (operands[0], E_V2SImode)
              && move_operand (operands[1], E_V2SImode)
              && (
#line 5409 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)) && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI)))
            return gen_split_62 (insn, operands);
          break;

        case E_V4HImode:
          if (nonimmediate_operand (operands[0], E_V4HImode)
              && move_operand (operands[1], E_V4HImode)
              && (
#line 5409 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)) && 
#line 866 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI)))
            return gen_split_63 (insn, operands);
          break;

        case E_V8QImode:
          if (nonimmediate_operand (operands[0], E_V8QImode)
              && move_operand (operands[1], E_V8QImode)
              && (
#line 5409 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)) && 
#line 867 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI)))
            return gen_split_64 (insn, operands);
          break;

        case E_TImode:
          if (nonimmediate_operand (operands[0], E_TImode)
              && move_operand (operands[1], E_TImode)
              && 
#line 5419 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)))
            return gen_split_65 (insn, operands);
          break;

        case E_TFmode:
          if (nonimmediate_operand (operands[0], E_TFmode)
              && move_operand (operands[1], E_TFmode)
              && 
#line 5419 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && mips_split_move_insn_p (operands[0], operands[1], insn)))
            return gen_split_66 (insn, operands);
          break;

        default:
          break;
        }
      if (!const_int_operand (operands[1], E_VOIDmode)
          || !d_operand (operands[0], E_VOIDmode)
          || !
#line 5431 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && INTVAL (operands[1]) < 0))
        return NULL;
      return gen_split_67 (insn, operands);

    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          if (XINT (x3, 1) != 21)
            return NULL;
          switch (pattern106 (x3))
            {
            case 0:
              if (!((
#line 5604 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_NEWABI) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 5606 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                return NULL;
              return gen_split_68 (insn, operands);

            case 1:
              if (!((
#line 5604 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_NEWABI) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 5606 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                return NULL;
              return gen_split_69 (insn, operands);

            case 2:
              if (!((
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_RTP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 5649 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                return NULL;
              return gen_split_72 (insn, operands);

            case 3:
              if (!((
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_RTP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 5649 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                return NULL;
              return gen_split_73 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          switch (XINT (x3, 1))
            {
            case 21:
              switch (pattern39 (x3))
                {
                case 0:
                  if (!((
#line 5621 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_ABSOLUTE) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 5623 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                    return NULL;
                  return gen_split_70 (insn, operands);

                case 1:
                  if (!((
#line 5621 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_ABSOLUTE) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 5623 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                    return NULL;
                  return gen_split_71 (insn, operands);

                default:
                  return NULL;
                }

            case 22:
              switch (pattern41 (x3))
                {
                case 0:
                  if (!((
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 5670 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                    return NULL;
                  return gen_split_74 (insn, operands);

                case 1:
                  if (!((
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 5670 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( mips_must_initialize_gp_p ())))
                    return NULL;
                  return gen_split_75 (insn, operands);

                default:
                  return NULL;
                }

            case 23:
              switch (pattern113 (x3))
                {
                case 0:
                  if (!
#line 6983 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_must_initialize_gp_p ()))
                    return NULL;
                  return gen_split_90 (insn, operands);

                case 1:
                  if (!(
#line 6983 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_must_initialize_gp_p ()) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_91 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern27 (x3))
        {
        case 0:
          if (!
#line 5967 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16))
            return NULL;
          return gen_split_78 (insn, operands);

        case 1:
          if (!(
#line 5967 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_81 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern27 (x3))
        {
        case 0:
          if (!
#line 5967 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16))
            return NULL;
          return gen_split_79 (insn, operands);

        case 1:
          if (!(
#line 5967 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_82 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern26 (x3, 
E_SImode) != 0
                  || !
#line 5967 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16))
                return NULL;
              return gen_split_80 (insn, operands);

            case E_DImode:
              if (pattern26 (x3, 
E_DImode) != 0
                  || !(
#line 5967 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && INTVAL (operands[2]) > 8
   && INTVAL (operands[2]) <= 16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_83 (insn, operands);

            default:
              return NULL;
            }

        case SUBREG:
        case MEM:
          if (!memory_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !immediate_operand (operands[2], E_SImode)
              || !(
#line 5986 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 5988 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( 1)))
            return NULL;
          return gen_split_84 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (pattern2 (x3))
        {
        case 0:
          if (!(
#line 6022 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_WSBH && ISA_HAS_ROR) && 
#line 6024 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( 1)))
            return NULL;
          return gen_split_85 (insn, operands);

        case 1:
          if (!(
#line 6033 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && ISA_HAS_WSBH) && 
#line 6035 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( 1)))
            return NULL;
          return gen_split_86 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
