/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern8 (x3); /* [-1, 5] */
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern10 (x3, 
E_V2DImode) != 0)
        return -1;
      return 5;

    case E_V4SImode:
      if (pattern10 (x3, 
E_V4SImode) != 0)
        return -1;
      return 6;

    case E_V8HImode:
      if (pattern10 (x3, 
E_V8HImode) != 0)
        return -1;
      return 7;

    case E_V16QImode:
      if (pattern10 (x3, 
E_V16QImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 0;

        case E_HImode:
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 2;

        case E_HImode:
          return 3;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern50 (x2, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern50 (x2, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern53 (x3, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern53 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern53 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern53 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!reg_or_0_operand (operands[2], E_V2HImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!reg_or_0_operand (operands[3], E_V2HImode))
    return -1;
  return 0;
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTRACT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 2);
      operands[2] = x9;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x10 = XEXP (x2, 1);
      switch (GET_CODE (x10))
        {
        case LABEL_REF:
          x11 = XEXP (x2, 2);
          if (GET_CODE (x11) != PC)
            return -1;
          x12 = XEXP (x10, 0);
          operands[0] = x12;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode))
                return -1;
              return 0;

            case E_DImode:
              if (!register_operand (operands[1], E_DImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case PC:
          x11 = XEXP (x2, 2);
          if (GET_CODE (x11) != LABEL_REF)
            return -1;
          x13 = XEXP (x11, 0);
          operands[0] = x13;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode))
                return -1;
              return 2;

            case E_DImode:
              if (!register_operand (operands[1], E_DImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      return 4;

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1)
        return -1;
      x10 = XEXP (x2, 1);
      if (GET_CODE (x10) != LABEL_REF)
        return -1;
      x11 = XEXP (x2, 2);
      if (GET_CODE (x11) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC
          || GET_MODE (x4) != E_SImode)
        return -1;
      x14 = XVECEXP (x4, 0, 0);
      operands[1] = x14;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!const_0_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x10, 0);
      operands[0] = x12;
      switch (XINT (x4, 1))
        {
        case 246:
          res = pattern80 ();
          if (res >= 0)
            return res + 5; /* [5, 10] */
          return -1;

        case 245:
          res = pattern80 ();
          if (res >= 0)
            return res + 11; /* [11, 16] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern129 (rtx x1, int i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_ximm5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[3] = x3;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_1_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern166 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 67
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_V8HImode)
          || !const_uimm3_operand (operands[2], E_VOIDmode))
        return -1;
      return 0;

    case E_QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !const_uimm4_operand (operands[2], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_0_or_1_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern182 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern191 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[2]))
    return -1;
  return 0;
}

int
pattern197 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_0_operand (operands[1], i1)
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[2]))
    return -1;
  return 0;
}

int
pattern201 (rtx x1, int *pnum_clobbers, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCDSPmode
      || pattern199 (x4, 
E_SImode, 
185) != 0)
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!cprestore_save_slot_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 31
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 28)
    return -1;
  return 0;
}

int
pattern224 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !reg_or_vector_same_val_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern232 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern236 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern236 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern246 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !mem_noofs_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern252 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern252 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern258 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x1, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          if (
#line 3651 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !ISA_HAS_EXT_INS))
            return 217; /* *zero_extendsidi2 */
          if (!
#line 3667 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && ISA_HAS_EXT_INS))
            return -1;
          return 218; /* *zero_extendsidi2_dext */

        case E_QImode:
          if (nonimmediate_operand (operands[1], E_QImode)
              && (
#line 3707 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 220; /* *zero_extendqidi2 */
          if (register_operand (operands[1], E_QImode)
              && (
#line 3719 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MIPS16E) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 224; /* *zero_extendqidi2_mips16e */
          if (!memory_operand (operands[1], E_QImode)
              || !(
#line 3728 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 228; /* *zero_extendqidi2_mips16 */

        case E_HImode:
          if (nonimmediate_operand (operands[1], E_HImode)
              && (
#line 3707 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 222; /* *zero_extendhidi2 */
          if (register_operand (operands[1], E_HImode)
              && (
#line 3719 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MIPS16E) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 226; /* *zero_extendhidi2_mips16e */
          if (!memory_operand (operands[1], E_HImode)
              || !(
#line 3728 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 230; /* *zero_extendhidi2_mips16 */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (nonimmediate_operand (operands[1], E_QImode)
              && 
#line 3707 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 219; /* *zero_extendqisi2 */
          if (register_operand (operands[1], E_QImode)
              && 
#line 3719 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MIPS16E))
            return 223; /* *zero_extendqisi2_mips16e */
          if (!memory_operand (operands[1], E_QImode)
              || !
#line 3728 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 227; /* *zero_extendqisi2_mips16 */

        case E_HImode:
          if (nonimmediate_operand (operands[1], E_HImode)
              && 
#line 3707 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 221; /* *zero_extendhisi2 */
          if (register_operand (operands[1], E_HImode)
              && 
#line 3719 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MIPS16E))
            return 225; /* *zero_extendhisi2_mips16e */
          if (!memory_operand (operands[1], E_HImode)
              || !
#line 3728 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 229; /* *zero_extendhisi2_mips16 */

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      if (nonimmediate_operand (operands[1], E_QImode)
          && 
#line 3749 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
        return 231; /* *zero_extendqihi2 */
      if (!memory_operand (operands[1], E_QImode)
          || !
#line 3759 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
        return -1;
      return 232; /* *zero_extendqihi2_mips16 */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 2595 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1692; /* msa_subs_s_d */

    case 1:
      if (!
#line 2595 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1693; /* msa_subs_s_w */

    case 2:
      if (!
#line 2595 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1694; /* msa_subs_s_h */

    case 3:
      if (!
#line 2595 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1695; /* msa_subs_s_b */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (pattern64 (x3, 
E_V4SFmode, 
E_V8HImode) != 0
          || !
#line 1853 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1568; /* msa_ftq_h */

    case E_V4SImode:
      if (pattern64 (x3, 
E_V2DFmode, 
E_V4SImode) != 0
          || !
#line 1864 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1569; /* msa_ftq_w */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      if (absolute_symbolic_operand (operands[1], E_DImode)
          && 
#line 4619 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && ABI_HAS_64BIT_SYMBOLS))
        return 298; /* *lea_high64 */
      if (got_disp_operand (operands[1], E_DImode)
          && (
#line 4717 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
        return 303; /* *xgot_hidi */
      if (!got_page_ofst_operand (operands[1], E_DImode)
          || !(
#line 4760 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_hi_p[SYMBOL_GOT_PAGE_OFST]) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
        return -1;
      return 309; /* *got_pagedi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (got_disp_operand (operands[1], E_SImode)
          && (
#line 4717 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && TARGET_XGOT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
        return 302; /* *xgot_hisi */
      if (!got_page_ofst_operand (operands[1], E_SImode)
          || !(
#line 4760 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_hi_p[SYMBOL_GOT_PAGE_OFST]) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
        return -1;
      return 308; /* *got_pagesi */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (pattern160 (x3))
    {
    case 0:
      if (!
#line 6113 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
        return -1;
      return 483; /* *branch_ordersi */

    case 1:
      if (!(
#line 6113 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return -1;
      return 484; /* *branch_orderdi */

    case 2:
      if (!
#line 6127 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
        return -1;
      return 485; /* *branch_ordersi_inverted */

    case 3:
      if (!(
#line 6127 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return -1;
      return 486; /* *branch_orderdi_inverted */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  switch (XVECLEN (x6, 0))
    {
    case 2:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      operands[3] = x7;
      if (const_0_or_1_operand (operands[3], E_SImode)
          && pattern213 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0)
        {
          x8 = XVECEXP (x6, 0, 1);
          operands[4] = x8;
          if (const_2_or_3_operand (operands[4], E_SImode)
              && 
#line 100 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return 865; /* vec_perm_const_ps */
        }
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      switch (XWINT (x7, 0))
        {
        case 1L:
          if (XWINT (x8, 0) != 3L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern213 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !
#line 678 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1210; /* loongson_punpckhwd */

            case E_V2DImode:
              if (pattern213 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                  || !
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1590; /* msa_ilvl_d */

            case E_V2DFmode:
              if (pattern213 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !
#line 2065 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1591; /* msa_ilvl_d_f */

            default:
              return -1;
            }

        case 0L:
          if (XWINT (x8, 0) != 2L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern213 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !
#line 756 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1216; /* loongson_punpcklwd */

            case E_V2DImode:
              if (pattern213 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                  || !
#line 2197 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1600; /* msa_ilvr_d */

            case E_V2DFmode:
              if (pattern213 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !
#line 2209 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1601; /* msa_ilvr_d_f */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x6, 0, 2);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x6, 0, 3);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      switch (XWINT (x7, 0))
        {
        case 4L:
          if (XWINT (x8, 0) != 1L
              || XWINT (x9, 0) != 2L
              || XWINT (x10, 0) != 3L
              || pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 324 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1173; /* loongson_pinsrh_0 */

        case 0L:
          switch (XWINT (x8, 0))
            {
            case 4L:
              switch (XWINT (x9, 0))
                {
                case 2L:
                  switch (XWINT (x10, 0))
                    {
                    case 3L:
                      if (pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                          || !
#line 336 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return -1;
                      return 1174; /* loongson_pinsrh_1 */

                    case 6L:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_V4SImode:
                          if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                              || !
#line 1968 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                            return -1;
                          return 1584; /* msa_ilvev_w */

                        case E_V4SFmode:
                          if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                              || !
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                            return -1;
                          return 1585; /* msa_ilvev_w_f */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1L:
                  if (XWINT (x10, 0) != 5L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4HImode:
                      if (pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                          || !
#line 731 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return -1;
                      return 1214; /* loongson_punpcklhw */

                    case E_V4SImode:
                      if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                          || !
#line 2172 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return -1;
                      return 1598; /* msa_ilvr_w */

                    case E_V4SFmode:
                      if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                          || !
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return -1;
                      return 1599; /* msa_ilvr_w_f */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 1L:
              if (pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0)
                return -1;
              switch (XWINT (x9, 0))
                {
                case 4L:
                  switch (XWINT (x10, 0))
                    {
                    case 3L:
                      if (!
#line 348 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return -1;
                      return 1175; /* loongson_pinsrh_2 */

                    case 5L:
                      if (!
#line 782 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return -1;
                      return 1218; /* *loongson_punpcklwd_hi */

                    default:
                      return -1;
                    }

                case 2L:
                  if (XWINT (x10, 0) != 4L
                      || !
#line 360 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1176; /* loongson_pinsrh_3 */

                default:
                  return -1;
                }

            case 2L:
              if (XWINT (x9, 0) != 4L
                  || XWINT (x10, 0) != 6L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 2416 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1652; /* msa_pckev_w */

                case E_V4SFmode:
                  if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 2429 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1653; /* msa_pckev_w_f */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2L:
          if (XWINT (x10, 0) != 7L)
            return -1;
          switch (XWINT (x8, 0))
            {
            case 6L:
              if (XWINT (x9, 0) != 3L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4HImode:
                  if (pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                      || !
#line 653 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1208; /* loongson_punpckhhw */

                case E_V4SImode:
                  if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 2028 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1588; /* msa_ilvl_w */

                case E_V4SFmode:
                  if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 2041 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1589; /* msa_ilvl_w_f */

                default:
                  return -1;
                }

            case 3L:
              if (XWINT (x9, 0) != 6L
                  || pattern213 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !
#line 704 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                return -1;
              return 1212; /* loongson_punpckhwd_hi */

            default:
              return -1;
            }

        case 1L:
          if (XWINT (x10, 0) != 7L)
            return -1;
          switch (XWINT (x8, 0))
            {
            case 5L:
              if (XWINT (x9, 0) != 3L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1594; /* msa_ilvod_w */

                case E_V4SFmode:
                  if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 2125 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1595; /* msa_ilvod_w_f */

                default:
                  return -1;
                }

            case 3L:
              if (XWINT (x9, 0) != 5L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern213 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 2476 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1656; /* msa_pckod_w */

                case E_V4SFmode:
                  if (pattern213 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 2489 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1657; /* msa_pckod_w_f */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 8:
      if (pattern161 (x6) != 0)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      switch (XWINT (x7, 0))
        {
        case 4L:
          x11 = XVECEXP (x6, 0, 7);
          if (XWINT (x11, 0) != 15L)
            return -1;
          x8 = XVECEXP (x6, 0, 1);
          switch (XWINT (x8, 0))
            {
            case 12L:
              x9 = XVECEXP (x6, 0, 2);
              if (XWINT (x9, 0) != 5L)
                return -1;
              x10 = XVECEXP (x6, 0, 3);
              if (XWINT (x10, 0) != 13L)
                return -1;
              x12 = XVECEXP (x6, 0, 4);
              if (XWINT (x12, 0) != 6L)
                return -1;
              x13 = XVECEXP (x6, 0, 5);
              if (XWINT (x13, 0) != 14L)
                return -1;
              x14 = XVECEXP (x6, 0, 6);
              if (XWINT (x14, 0) != 7L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (pattern213 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                      || !
#line 641 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1207; /* loongson_punpckhbh */

                case E_V8HImode:
                  if (pattern213 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                      || !
#line 2015 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1587; /* msa_ilvl_h */

                default:
                  return -1;
                }

            case 5L:
              x14 = XVECEXP (x6, 0, 6);
              if (XWINT (x14, 0) != 14L
                  || pattern213 (x2, 
E_V8QImode, 
E_V16QImode) != 0)
                return -1;
              x9 = XVECEXP (x6, 0, 2);
              switch (XWINT (x9, 0))
                {
                case 12L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 13L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 6L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 7L
                      || !
#line 667 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1209; /* loongson_punpckhhw_qi */

                case 6L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 7L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 12L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 13L
                      || !
#line 692 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1211; /* loongson_punpckhwd_qi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0L:
          x8 = XVECEXP (x6, 0, 1);
          switch (XWINT (x8, 0))
            {
            case 8L:
              x9 = XVECEXP (x6, 0, 2);
              switch (XWINT (x9, 0))
                {
                case 1L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 9L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 2L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 10L)
                    return -1;
                  x14 = XVECEXP (x6, 0, 6);
                  if (XWINT (x14, 0) != 3L)
                    return -1;
                  x11 = XVECEXP (x6, 0, 7);
                  if (XWINT (x11, 0) != 11L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8QImode:
                      if (pattern213 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                          || !
#line 719 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return -1;
                      return 1213; /* loongson_punpcklbh */

                    case E_V8HImode:
                      if (pattern213 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                          || !
#line 2159 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return -1;
                      return 1597; /* msa_ilvr_h */

                    default:
                      return -1;
                    }

                case 2L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 10L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 4L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 12L)
                    return -1;
                  x14 = XVECEXP (x6, 0, 6);
                  if (XWINT (x14, 0) != 6L)
                    return -1;
                  x11 = XVECEXP (x6, 0, 7);
                  if (XWINT (x11, 0) != 14L
                      || pattern213 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                      || !
#line 1955 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return -1;
                  return 1583; /* msa_ilvev_h */

                default:
                  return -1;
                }

            case 1L:
              x14 = XVECEXP (x6, 0, 6);
              if (XWINT (x14, 0) != 10L)
                return -1;
              x11 = XVECEXP (x6, 0, 7);
              if (XWINT (x11, 0) != 11L
                  || pattern213 (x2, 
E_V8QImode, 
E_V16QImode) != 0)
                return -1;
              x9 = XVECEXP (x6, 0, 2);
              switch (XWINT (x9, 0))
                {
                case 8L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 9L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 2L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 3L
                      || !
#line 745 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1215; /* *loongson_punpcklhw_qi */

                case 2L:
                  x10 = XVECEXP (x6, 0, 3);
                  if (XWINT (x10, 0) != 3L)
                    return -1;
                  x12 = XVECEXP (x6, 0, 4);
                  if (XWINT (x12, 0) != 8L)
                    return -1;
                  x13 = XVECEXP (x6, 0, 5);
                  if (XWINT (x13, 0) != 9L
                      || !
#line 770 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                    return -1;
                  return 1217; /* *loongson_punpcklwd_qi */

                default:
                  return -1;
                }

            case 2L:
              x9 = XVECEXP (x6, 0, 2);
              if (XWINT (x9, 0) != 4L)
                return -1;
              x10 = XVECEXP (x6, 0, 3);
              if (XWINT (x10, 0) != 6L)
                return -1;
              x12 = XVECEXP (x6, 0, 4);
              if (XWINT (x12, 0) != 8L)
                return -1;
              x13 = XVECEXP (x6, 0, 5);
              if (XWINT (x13, 0) != 10L)
                return -1;
              x14 = XVECEXP (x6, 0, 6);
              if (XWINT (x14, 0) != 12L)
                return -1;
              x11 = XVECEXP (x6, 0, 7);
              if (XWINT (x11, 0) != 14L
                  || pattern213 (x2, 
E_V8HImode, 
E_V16HImode) != 0
                  || !
#line 2403 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1651; /* msa_pckev_h */

            default:
              return -1;
            }

        case 1L:
          x11 = XVECEXP (x6, 0, 7);
          if (XWINT (x11, 0) != 15L
              || pattern213 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
            return -1;
          x8 = XVECEXP (x6, 0, 1);
          switch (XWINT (x8, 0))
            {
            case 9L:
              x9 = XVECEXP (x6, 0, 2);
              if (XWINT (x9, 0) != 3L)
                return -1;
              x10 = XVECEXP (x6, 0, 3);
              if (XWINT (x10, 0) != 11L)
                return -1;
              x12 = XVECEXP (x6, 0, 4);
              if (XWINT (x12, 0) != 5L)
                return -1;
              x13 = XVECEXP (x6, 0, 5);
              if (XWINT (x13, 0) != 13L)
                return -1;
              x14 = XVECEXP (x6, 0, 6);
              if (XWINT (x14, 0) != 7L
                  || !
#line 2099 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1593; /* msa_ilvod_h */

            case 3L:
              if (pattern263 (x6) != 0
                  || !
#line 2463 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1655; /* msa_pckod_h */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 16:
      return recog_53 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0)
            return -1;
          if ((
#line 1554 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_4300_MUL_FIX) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return 29; /* *mulsf3 */
          if (!(
#line 1567 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_4300_MUL_FIX) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 31; /* *mulsf3_r4300 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0)
            return -1;
          if ((
#line 1554 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_4300_MUL_FIX) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return 30; /* *muldf3 */
          if (!(
#line 1567 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_4300_MUL_FIX) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 32; /* *muldf3_r4300 */

        case E_V2SFmode:
          if (pattern0 (x3, 
E_V2SFmode) != 0
              || !
#line 1577 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return -1;
          return 33; /* mulv2sf3 */

        case E_SImode:
          if (GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          if (register_operand (operands[0], E_SImode))
            {
              if (
#line 1659 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6MUL))
                return 34; /* mulsi3_mul3_nohilo */
              if (pnum_clobbers != NULL
                  && 
#line 1676 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MUL3))
                {
                  *pnum_clobbers = 1;
                  return 36; /* mulsi3_mul3 */
                }
            }
          if (muldiv_target_operand (operands[0], E_SImode)
              && 
#line 1714 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MULT && !TARGET_FIX_R4000))
            return 38; /* mulsi3_internal */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_SImode)
              || !
#line 1724 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MULT && TARGET_FIX_R4000))
            return -1;
          *pnum_clobbers = 1;
          return 40; /* mulsi3_r4000 */

        case E_DImode:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          if (register_operand (operands[0], E_DImode))
            {
              if ((
#line 1659 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DMUL) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 35; /* muldi3_mul3_nohilo */
              if (pnum_clobbers != NULL
                  && (
#line 1676 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DMUL3) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 37; /* muldi3_mul3 */
                }
            }
          if (muldiv_target_operand (operands[0], E_DImode)
              && (
#line 1714 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DMULT && !TARGET_FIX_R4000) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 39; /* muldi3_internal */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DImode)
              || !(
#line 1724 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DMULT && TARGET_FIX_R4000) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 41; /* muldi3_r4000 */

        case E_V4HImode:
          if (pattern0 (x3, 
E_V4HImode) != 0
              || !
#line 502 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1186; /* mulv4hi3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !
#line 770 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1282; /* mulv2di3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 770 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1283; /* mulv4si3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 770 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1284; /* mulv8hi3 */

        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 770 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1285; /* mulv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 960 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1342; /* mulv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 960 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1343; /* mulv4sf3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern36 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (muldiv_target_operand (operands[0], E_DImode)
              && 
#line 2123 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && (!TARGET_FIX_R4000 || ISA_HAS_DSP) && ISA_HAS_MULT))
            return 51; /* mulsidi3_32bit */
          if (!register_operand (operands[0], E_DImode))
            return -1;
          if (pnum_clobbers != NULL)
            {
              if (
#line 2138 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_FIX_R4000 && !ISA_HAS_DSP && ISA_HAS_MULT))
                {
                  *pnum_clobbers = 1;
                  return 53; /* mulsidi3_32bit_r4000 */
                }
              if (
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT))
                {
                  *pnum_clobbers = 2;
                  return 55; /* mulsidi3_64bit */
                }
              if (
#line 2229 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DMUL3))
                {
                  *pnum_clobbers = 1;
                  return 59; /* mulsidi3_64bit_dmul */
                }
            }
          if (!
#line 2238 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_R6DMUL))
            return -1;
          return 60; /* mulsidi3_64bit_r6dmul */

        case 1:
          if (muldiv_target_operand (operands[0], E_TImode)
              && 
#line 2510 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_FIX_R4000
   && !(SIGN_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
            return 77; /* mulditi3_internal */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || !
#line 2522 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && TARGET_FIX_R4000
   && !(SIGN_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
            return -1;
          *pnum_clobbers = 1;
          return 79; /* mulditi3_r4000 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern36 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (muldiv_target_operand (operands[0], E_DImode)
              && 
#line 2123 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && (!TARGET_FIX_R4000 || ISA_HAS_DSP) && ISA_HAS_MULT))
            return 52; /* umulsidi3_32bit */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DImode))
            return -1;
          if (
#line 2138 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_FIX_R4000 && !ISA_HAS_DSP && ISA_HAS_MULT))
            {
              *pnum_clobbers = 1;
              return 54; /* umulsidi3_32bit_r4000 */
            }
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT))
            return -1;
          *pnum_clobbers = 2;
          return 56; /* umulsidi3_64bit */

        case 1:
          if (muldiv_target_operand (operands[0], E_TImode)
              && 
#line 2510 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_FIX_R4000
   && !(ZERO_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
            return 78; /* umulditi3_internal */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || !
#line 2522 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && TARGET_FIX_R4000
   && !(ZERO_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)))
            return -1;
          *pnum_clobbers = 1;
          return 80; /* umulditi3_r4000 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern121 (x3, 
E_SImode))
        {
        case 0:
          if (
#line 6372 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 547; /* *slt_sisi */
          if (!
#line 6381 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 555; /* *slt_sisi_mips16 */

        case 1:
          if ((
#line 6372 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 549; /* *slt_disi */
          if (!(
#line 6381 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 557; /* *slt_disi_mips16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern121 (x3, 
E_DImode))
        {
        case 0:
          if ((
#line 6372 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 551; /* *slt_sidi */
          if (!(
#line 6381 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 559; /* *slt_sidi_mips16 */

        case 1:
          if ((
#line 6372 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 553; /* *slt_didi */
          if (!(
#line 6381 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 561; /* *slt_didi_mips16 */

        default:
          return -1;
        }

    case E_CCmode:
      switch (pattern5 (x3, 
E_CCmode))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 584; /* slt_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 591; /* slt_df_using_cc */

        default:
          return -1;
        }

    case E_CCEmode:
      switch (pattern5 (x3, 
E_CCEmode))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 598; /* slt_sf_using_cce */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 605; /* slt_df_using_cce */

        default:
          return -1;
        }

    case E_CCFmode:
      switch (pattern5 (x3, 
E_CCFmode))
        {
        case 0:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 612; /* slt_sf_using_ccf */

        case 1:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 622; /* slt_df_using_ccf */

        default:
          return -1;
        }

    case E_V2DImode:
      switch (pattern122 (x3))
        {
        case 0:
          if (!
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1447; /* msa_clt_s_d */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1493; /* msa_fclt_d */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern123 (x3))
        {
        case 0:
          if (!
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1452; /* msa_clt_s_w */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1502; /* msa_fclt_w */

        default:
          return -1;
        }

    case E_V8HImode:
      if (pattern10 (x3, 
E_V8HImode) != 0
          || !
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1457; /* msa_clt_s_h */

    case E_V16QImode:
      if (pattern10 (x3, 
E_V16QImode) != 0
          || !
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1462; /* msa_clt_s_b */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !
#line 4004 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))
        return -1;
      return 264; /* extendsfdf2 */

    case VEC_SELECT:
      if (GET_MODE (x4) != E_V2SFmode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 2)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      switch (XWINT (x6, 0))
        {
        case 2L:
          if (XWINT (x7, 0) != 3L
              || !
#line 2735 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1739; /* msa_fexupl_d */

        case 0L:
          if (XWINT (x7, 0) != 1L
              || !
#line 2755 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1741; /* msa_fexupr_d */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_95 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode)
          || !(
#line 3153 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (SFmode)) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 166; /* abssf2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode)
          || !(
#line 3153 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (DFmode)) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
        return -1;
      return 167; /* absdf2 */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 3153 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (V2SFmode)) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
        return -1;
      return 168; /* absv2sf2 */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      if (pattern87 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      x12 = XEXP (x4, 0);
      operands[5] = x12;
      if (!scratch_operand (operands[5], E_SImode))
        return -1;
      if (
#line 1785 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MADD_MSUB && !TARGET_MIPS16))
        return 42; /* *mul_acc_si */
      if (!
#line 1808 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS3900 && !TARGET_MIPS16))
        return -1;
      return 43; /* *mul_acc_si_r3900 */

    case MINUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != MULT
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode)
          || pattern238 (x1) != 0)
        return -1;
      if (
#line 1888 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MACC && !ISA_HAS_MSAC))
        return 46; /* *msac_using_macc */
      if (!
#line 2031 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MADD_MSUB))
        return -1;
      return 49; /* *mul_sub_si */

    case MULT:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x12 = XEXP (x4, 0);
      if (!scratch_operand (x12, E_DImode))
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (pattern163 (x1, 
SIGN_EXTEND) != 0
              || !
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT))
            return -1;
          return 55; /* mulsidi3_64bit */

        case ZERO_EXTEND:
          if (pattern163 (x1, 
ZERO_EXTEND) != 0
              || !
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT))
            return -1;
          return 56; /* umulsidi3_64bit */

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_V2HImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != SET)
            return -1;
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != UNSPEC
              || pattern130 (x10, 
185, 
175, 
2) != 0
              || !register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode)
            return -1;
          x9 = XEXP (x3, 1);
          operands[2] = x9;
          if (!register_operand (operands[2], E_V2HImode))
            return -1;
          operands[3] = x12;
          x14 = XVECEXP (x13, 0, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x15, operands[2])
              || !
#line 230 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1031; /* mulv2hi3 */

        default:
          return -1;
        }

    case DIV:
      switch (pattern97 (x1, 
MOD))
        {
        case 0:
          if (!
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DIV && !TARGET_FIX_VR4120 && TARGET_MIPS16))
            return -1;
          return 137; /* divmodsi4_mips16 */

        case 1:
          if (!(
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DDIV && !TARGET_FIX_VR4120 && TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 138; /* divmoddi4_mips16 */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern97 (x1, 
UMOD))
        {
        case 0:
          if (!
#line 2989 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DIV && TARGET_MIPS16))
            return -1;
          return 141; /* udivmodsi4_mips16 */

        case 1:
          if (!(
#line 2989 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DDIV && TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 142; /* udivmoddi4_mips16 */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x12 = XEXP (x4, 0);
          operands[3] = x12;
          switch (XINT (x3, 1))
            {
            case 55:
              x16 = XVECEXP (x3, 0, 1);
              if (GET_CODE (x16) != LABEL_REF)
                return -1;
              x5 = XEXP (x2, 0);
              if (GET_CODE (x5) != PC)
                return -1;
              x10 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x10) != CLOBBER)
                return -1;
              x17 = XVECEXP (x3, 0, 0);
              operands[0] = x17;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x18 = XEXP (x16, 0);
              operands[1] = x18;
              x11 = XEXP (x10, 0);
              operands[2] = x11;
              switch (GET_MODE (x3))
                {
                case E_SImode:
                  if (!scratch_operand (operands[2], E_SImode)
                      || !scratch_operand (operands[3], E_SImode)
                      || !(
#line 6643 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16_SHORT_JUMP_TABLES) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
                    return -1;
                  return 660; /* casesi_internal_mips16_si */

                case E_DImode:
                  if (!scratch_operand (operands[2], E_DImode)
                      || !scratch_operand (operands[3], E_DImode)
                      || !(
#line 6643 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16_SHORT_JUMP_TABLES) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
                    return -1;
                  return 661; /* casesi_internal_mips16_di */

                default:
                  return -1;
                }

            case 119:
              if (pattern164 (x1, 
119, 
E_V2HImode, 
E_V4QImode) != 0
                  || !
#line 487 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 950; /* mips_muleu_s_ph_qbl */

            case 120:
              if (pattern164 (x1, 
120, 
E_V2HImode, 
E_V4QImode) != 0
                  || !
#line 500 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 951; /* mips_muleu_s_ph_qbr */

            case 121:
              if (pattern164 (x1, 
121, 
E_V2HImode, 
E_V2HImode) != 0
                  || !
#line 514 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 952; /* mips_mulq_rs_ph */

            case 122:
              if (pattern164 (x1, 
122, 
E_SImode, 
E_V2HImode) != 0
                  || !
#line 528 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 953; /* mips_muleq_s_w_phl */

            case 123:
              if (pattern164 (x1, 
123, 
E_SImode, 
E_V2HImode) != 0
                  || !
#line 541 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 954; /* mips_muleq_s_w_phr */

            case 176:
              if (pattern165 (x1, 
E_V2HImode, 
176) != 0
                  || !
#line 243 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              return 1032; /* mips_mul_s_ph */

            case 177:
              if (pattern165 (x1, 
E_SImode, 
177) != 0
                  || !
#line 256 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              return 1033; /* mips_mulq_rs_w */

            case 178:
              if (pattern165 (x1, 
E_V2HImode, 
178) != 0
                  || !
#line 269 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              return 1034; /* mips_mulq_s_ph */

            case 179:
              if (pattern165 (x1, 
E_SImode, 
179) != 0
                  || !
#line 282 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              return 1035; /* mips_mulq_s_w */

            default:
              return -1;
            }

        case 1:
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || pattern127 (x1, 
31, 
25) != 0)
            return -1;
          x17 = XVECEXP (x3, 0, 0);
          operands[0] = x17;
          switch (XINT (x3, 1))
            {
            case 34:
              if (REGNO (x5) != 3)
                return -1;
              switch (GET_MODE (x5))
                {
                case E_SImode:
                  if (pattern251 (x1, 
E_SImode) != 0
                      || !(
#line 7812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
                    return -1;
                  return 761; /* *tls_get_tp_mips16_call_si */

                case E_DImode:
                  if (pattern251 (x1, 
E_DImode) != 0
                      || !(
#line 7812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
                    return -1;
                  return 762; /* *tls_get_tp_mips16_call_di */

                default:
                  return -1;
                }

            case 12:
              if (GET_MODE (x3) != E_SImode
                  || REGNO (x5) != 2
                  || GET_MODE (x5) != E_SImode)
                return -1;
              if (call_insn_operand (operands[0], E_SImode))
                {
                  x10 = XVECEXP (x1, 0, 1);
                  x11 = XEXP (x10, 0);
                  if (GET_MODE (x11) == E_SImode)
                    {
                      x4 = XVECEXP (x1, 0, 2);
                      x12 = XEXP (x4, 0);
                      if (GET_MODE (x12) == E_SImode
                          && (
#line 7853 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
                        return 764; /* mips_get_fcsr_mips16_si */
                    }
                }
              if (!call_insn_operand (operands[0], E_DImode))
                return -1;
              x10 = XVECEXP (x1, 0, 1);
              x11 = XEXP (x10, 0);
              if (GET_MODE (x11) != E_DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 2);
              x12 = XEXP (x4, 0);
              if (GET_MODE (x12) != E_DImode
                  || !(
#line 7853 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 765; /* mips_get_fcsr_mips16_di */

            default:
              return -1;
            }

        case 3:
          if (XINT (x3, 1) != 154
              || pattern128 (x3) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          if (pattern129 (x10, 
154, 
E_CCDSPmode, 
UNSPEC) != 0)
            return -1;
          x13 = XEXP (x10, 1);
          x19 = XVECEXP (x13, 0, 2);
          if (GET_CODE (x19) != REG
              || REGNO (x19) != 182
              || GET_MODE (x19) != E_CCDSPmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 182
              || GET_MODE (x11) != E_CCDSPmode)
            return -1;
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != SET)
            return -1;
          x20 = XEXP (x4, 1);
          if (GET_CODE (x20) != UNSPEC
              || XVECLEN (x20, 0) != 2
              || XINT (x20, 1) != 154
              || GET_MODE (x20) != E_CCDSPmode)
            return -1;
          x12 = XEXP (x4, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 187
              || GET_MODE (x12) != E_CCDSPmode)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x17 = XVECEXP (x3, 0, 0);
          operands[1] = x17;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x16 = XVECEXP (x3, 0, 1);
          operands[2] = x16;
          if (!arith_operand (operands[2], E_SImode))
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          x21 = XVECEXP (x20, 0, 0);
          if (!rtx_equal_p (x21, operands[1]))
            return -1;
          x22 = XVECEXP (x20, 0, 1);
          if (!rtx_equal_p (x22, operands[2])
              || !
#line 995 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
            return -1;
          return 989; /* mips_extpdp */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x12 = XEXP (x4, 0);
      if (GET_CODE (x12) != REG
          || GET_MODE (x12) != E_SImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x10 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x10))
        {
        case CLOBBER:
          if (pattern220 (x1) != 0
              || !call_insn_operand (operands[1], E_VOIDmode)
              || !
#line 7279 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_SPLIT_CALLS))
            return -1;
          return 695; /* call_value_split */

        case CONST_INT:
          if (XWINT (x10, 0) != 1L
              || REGNO (x12) != 31
              || !const_call_insn_operand (operands[1], E_VOIDmode))
            return -1;
          return 696; /* call_value_internal_direct */

        case SET:
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != CALL)
            return -1;
          x23 = XEXP (x13, 0);
          if (GET_CODE (x23) != MEM
              || GET_MODE (x23) != E_SImode
              || REGNO (x12) != 31
              || pattern218 (x10) != 0)
            return -1;
          return 698; /* call_value_multiple_internal */

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      operands[1] = x3;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (pattern129 (x10, 
69, 
E_SImode, 
UNSPEC_VOLATILE) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x10, 1);
      x14 = XVECEXP (x13, 0, 0);
      operands[2] = x14;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x15 = XVECEXP (x13, 0, 1);
      operands[3] = x15;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x12 = XEXP (x4, 0);
      operands[5] = x12;
      if (!scratch_operand (operands[5], E_SImode))
        return -1;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x19 = XVECEXP (x13, 0, 2);
      switch (pattern260 (x19))
        {
        case 0:
          if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 802; /* sync_old_add_12 */

        case 1:
          if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 803; /* sync_old_sub_12 */

        case 2:
          if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 804; /* sync_old_ior_12 */

        case 3:
          if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 805; /* sync_old_xor_12 */

        case 4:
          if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 806; /* sync_old_and_12 */

        case 5:
          if (!
#line 307 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 813; /* sync_old_nand_12 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x13 = XEXP (x10, 1);
      if (GET_CODE (x13) != UNSPEC_VOLATILE
          || XVECLEN (x13, 0) != 1)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != UNSPEC_VOLATILE
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x17 = XVECEXP (x3, 0, 0);
      operands[1] = x17;
      x24 = XVECEXP (x4, 0, 0);
      operands[3] = x24;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 74:
          if (XINT (x13, 1) != 74
              || XINT (x4, 1) != 74)
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          operands[2] = x14;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern261 (x1, 
E_SImode) != 0
                  || !
#line 639 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC && !ISA_HAS_SWAP))
                return -1;
              return 854; /* atomic_exchangesi_llsc */

            case E_DImode:
              if (pattern261 (x1, 
E_DImode) != 0
                  || !(
#line 639 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC && !ISA_HAS_SWAP) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 855; /* atomic_exchangedi_llsc */

            default:
              return -1;
            }

        case 75:
          if (XINT (x13, 1) != 75)
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          if (GET_CODE (x14) != PLUS
              || XINT (x4, 1) != 75)
            return -1;
          x25 = XEXP (x14, 1);
          operands[2] = x25;
          x26 = XEXP (x14, 0);
          if (!rtx_equal_p (x26, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern262 (x1, 
E_SImode) != 0
                  || !
#line 696 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC && !ISA_HAS_LDADD))
                return -1;
              return 858; /* atomic_fetch_addsi_llsc */

            case E_DImode:
              if (pattern262 (x1, 
E_DImode) != 0
                  || !(
#line 696 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC && !ISA_HAS_LDADD) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 859; /* atomic_fetch_adddi_llsc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_MULT:
      x10 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x13 = XEXP (x10, 1);
      if (GET_CODE (x13) != UNSPEC
          || pattern130 (x10, 
185, 
121, 
2) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x12 = XEXP (x4, 0);
      operands[3] = x12;
      if (!scratch_operand (operands[3], E_DImode))
        return -1;
      switch (pattern250 (x1))
        {
        case 0:
          if (!
#line 41 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
            return -1;
          return 1114; /* ssmulv2hq3 */

        case 1:
          if (!
#line 41 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSP))
            return -1;
          return 1115; /* ssmulhq3 */

        case 2:
          if (!
#line 42 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-fixed.md"
(ISA_HAS_DSPR2))
            return -1;
          return 1116; /* ssmulsq3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
