/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!cprestore_load_slot_operand (operands[0], i1)
      || GET_CODE (x1) != REG
      || REGNO (x1) != 76
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern28 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern36 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (GET_MODE (x1) != E_DImode
          || pattern35 (x1, 
E_SImode, 
E_DImode) != 0)
        return -1;
      return 0;

    case E_TImode:
      if (GET_MODE (x1) != E_TImode
          || pattern35 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!reg_or_0_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern53 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern53 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern77 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern72 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern72 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_CCFmode:
      return pattern5 (x1, 
E_CCFmode); /* [-1, 1] */

    case E_V2DImode:
      if (pattern6 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern6 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!non_volatile_mem_operand (operands[1], E_HImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!non_volatile_mem_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return pattern102 (x3); /* [-1, 1] */

        case E_HImode:
          res = pattern102 (x3);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          res = pattern102 (x3);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_HImode:
          res = pattern102 (x3);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case E_SImode:
          res = pattern102 (x3);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !uns_arith_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern124 (x3, 
E_DImode, 
E_SImode); /* [-1, 0] */

    case E_TImode:
      if (pattern124 (x3, 
E_TImode, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i1)
    return -1;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern148 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern153 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !reg_or_vector_same_val_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern159 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern173 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern179 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern184 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern190 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_CCDSPmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 185
      || GET_MODE (x4) != E_CCDSPmode)
    return -1;
  x5 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      return pattern189 (x8, 
E_SImode); /* [-1, 0] */

    case E_V2HImode:
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      if (pattern189 (x8, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      if (pattern189 (x8, 
E_V4QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern212 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern221 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern226 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_CCmode:
      if (!register_operand (operands[1], E_CCmode))
        return -1;
      return 2;

    case E_CCEmode:
      if (!register_operand (operands[1], E_CCEmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !uns_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  if (!rtx_equal_p (x9, operands[3]))
    return -1;
  return 0;
}

int
pattern251 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !call_insn_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern257 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != i1
      || !register_operand (operands[0], E_DQmode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_DQmode)
    return -1;
  return 0;
}

int
pattern264 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[4] = x5;
  if (!reg_or_0_operand (operands[4], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XVECEXP (x8, 0, 3);
  if (!rtx_equal_p (x9, operands[4]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern147 (x3))
        {
        case 0:
          if (!(
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 891 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 421; /* mfhc1df */

        case 1:
          if (!(
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 892 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 422; /* mfhc1di */

        case 2:
          if (!(
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 893 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 423; /* mfhc1v2sf */

        case 3:
          if (!(
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 424; /* mfhc1v2si */

        case 4:
          if (!(
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 895 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 425; /* mfhc1v4hi */

        case 5:
          if (!(
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 896 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 426; /* mfhc1v8qi */

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_TFmode)
          || !(
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_MXHC1) && 
#line 897 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_FLOAT64)))
        return -1;
      return 427; /* mfhc1tf */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !reg_or_0_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode)
          || !
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT))
        return -1;
      return 390; /* mthisi_di */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode)
        return -1;
      if (reg_or_0_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_SImode)
          && 
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))
        return 391; /* mthisi_ti */
      if (!reg_or_0_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode)
          || !
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))
        return -1;
      return 392; /* mthidi_ti */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_msa_branch_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern114 (x3))
    {
    case 0:
      if (!
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1428; /* msa_bnegi_d */

    case 1:
      if (!
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1429; /* msa_bnegi_w */

    case 2:
      if (!
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1430; /* msa_bnegi_h */

    case 3:
      if (!
#line 1206 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1431; /* msa_bnegi_b */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1662; /* msa_sat_s_d */

    case 1:
      if (!
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1663; /* msa_sat_s_w */

    case 2:
      if (!
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1664; /* msa_sat_s_h */

    case 3:
      if (!
#line 2507 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1665; /* msa_sat_s_b */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 1085 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1384; /* msa_aver_s_d */

    case 1:
      if (!
#line 1085 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1385; /* msa_aver_s_w */

    case 2:
      if (!
#line 1085 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1386; /* msa_aver_s_h */

    case 3:
      if (!
#line 1085 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1387; /* msa_aver_s_b */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case LABEL_REF:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != PC)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!equality_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x8 = XEXP (x3, 0);
      operands[0] = x8;
      switch (pattern225 ())
        {
        case 0:
          if (!(
#line 6079 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF)))
            return -1;
          return 477; /* *branch_fp_cc */

        case 1:
          if (!(
#line 6079 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF)))
            return -1;
          return 478; /* *branch_fp_cce */

        case 2:
          if (!(
#line 6079 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF)))
            return -1;
          return 479; /* *branch_fp_ccf */

        default:
          return -1;
        }

    case PC:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != LABEL_REF)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!equality_operator (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      x9 = XEXP (x4, 0);
      operands[0] = x9;
      switch (pattern225 ())
        {
        case 0:
          if (!(
#line 6095 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF)))
            return -1;
          return 480; /* *branch_fp_inverted_cc */

        case 1:
          if (!(
#line 6095 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF)))
            return -1;
          return 481; /* *branch_fp_inverted_cce */

        case 2:
          if (!(
#line 6095 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF)))
            return -1;
          return 482; /* *branch_fp_inverted_ccf */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x3;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x2, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      x4 = XEXP (x2, 2);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern227 (x2, 
E_SImode))
            {
            case 0:
              if (reg_or_0_operand (operands[2], E_SImode)
                  && reg_or_0_operand (operands[3], E_SImode)
                  && 
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE))
                return 706; /* movsi_on_si */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_SImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_SImode)
                  || !
#line 7495 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE))
                return -1;
              return 714; /* movsi_on_si_mips16e2 */

            case 1:
              if (reg_or_0_operand (operands[2], E_SImode)
                  && reg_or_0_operand (operands[3], E_SImode)
                  && (
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 836 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 708; /* movsi_on_di */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_SImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_SImode)
                  || !(
#line 7495 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 836 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 716; /* movsi_on_di_mips16e2 */

            case 2:
              if (reg_or_0_operand (operands[2], E_SImode)
                  && reg_or_0_operand (operands[3], E_SImode)
                  && (
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)))
                return 710; /* movsi_on_cc */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_SImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_SImode)
                  || !(
#line 7495 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)))
                return -1;
              return 718; /* movsi_on_cc_mips16e2 */

            case 3:
              if (reg_or_0_operand (operands[2], E_SImode)
                  && reg_or_0_operand (operands[3], E_SImode)
                  && (
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 840 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)))
                return 712; /* movsi_on_cce */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_SImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_SImode)
                  || !(
#line 7495 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 840 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)))
                return -1;
              return 720; /* movsi_on_cce_mips16e2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern227 (x2, 
E_DImode))
            {
            case 0:
              if (reg_or_0_operand (operands[2], E_DImode)
                  && reg_or_0_operand (operands[3], E_DImode)
                  && (
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 707; /* movdi_on_si */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_DImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_DImode)
                  || !(
#line 7495 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 715; /* movdi_on_si_mips16e2 */

            case 1:
              if (reg_or_0_operand (operands[2], E_DImode)
                  && reg_or_0_operand (operands[3], E_DImode)
                  && (
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 709; /* movdi_on_di */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_DImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_DImode)
                  || !(
#line 7495 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 717; /* movdi_on_di_mips16e2 */

            case 2:
              if (reg_or_0_operand (operands[2], E_DImode)
                  && reg_or_0_operand (operands[3], E_DImode)
                  && (
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && (((
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))))
                return 711; /* movdi_on_cc */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_DImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_DImode)
                  || !(
#line 7495 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && (((
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))))
                return -1;
              return 719; /* movdi_on_cc_mips16e2 */

            case 3:
              if (reg_or_0_operand (operands[2], E_DImode)
                  && reg_or_0_operand (operands[3], E_DImode)
                  && (
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && ISA_HAS_CONDMOVE) && (((
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 840 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))))
                return 713; /* movdi_on_cce */
              if (!reg_or_0_operand_mips16e2 (operands[2], E_DImode)
                  || !reg_or_0_operand_mips16e2 (operands[3], E_DImode)
                  || !(
#line 7495 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2 && ISA_HAS_CONDMOVE) && (((
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 840 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))))
                return -1;
              return 721; /* movdi_on_cce_mips16e2 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern228 (x2, 
E_SFmode))
            {
            case 0:
              if (!(
#line 7542 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 730; /* *movsf_on_si */

            case 1:
              if (!(
#line 7542 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 836 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))))
                return -1;
              return 732; /* *movsf_on_di */

            case 2:
              if (!(
#line 7542 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))))
                return -1;
              return 734; /* *movsf_on_cc */

            case 3:
              if (!(
#line 7542 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 840 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))))
                return -1;
              return 736; /* *movsf_on_cce */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern228 (x2, 
E_DFmode))
            {
            case 0:
              if (!(
#line 7542 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 731; /* *movdf_on_si */

            case 1:
              if (!(
#line 7542 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT) && 
#line 836 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))))
                return -1;
              return 733; /* *movdf_on_di */

            case 2:
              if (!(
#line 7542 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT) && 
#line 837 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))))
                return -1;
              return 735; /* *movdf_on_cc */

            case 3:
              if (!(
#line 7542 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_CONDMOVE) && (((
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT) && 
#line 840 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				   && !TARGET_LOONGSON_2EF
				   && !TARGET_MIPS5900)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))))
                return -1;
              return 737; /* *movdf_on_cce */

            default:
              return -1;
            }

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x2) != E_V2SFmode
              || !register_operand (operands[2], E_V2SFmode)
              || !register_operand (operands[3], E_V2SFmode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_SImode:
              if (!equality_operator (operands[4], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 52 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
                return -1;
              return 862; /* *movcc_v2sf_si */

            case E_DImode:
              if (!equality_operator (operands[4], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 52 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 863; /* *movcc_v2sf_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern32 (x3) != 0)
        return -1;
      if (
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
        return 17; /* *addsi3_extended */
      if (!
#line 1457 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16))
        return -1;
      return 18; /* *addsi3_extended_mips16 */

    case MINUS:
      if (pattern33 (x3, 
E_SImode, 
E_DImode) != 0)
        return -1;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 1530 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))
        return -1;
      return 28; /* *subsi3_extended */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern101 (x3))
        {
        case 0:
          if (
#line 3813 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))
            return 238; /* extendsidi2 */
          break;

        case 1:
          if ((
#line 3835 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MIPS16E) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 240; /* *extendqidi2_mips16e */
          if ((
#line 3846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 244; /* *extendqidi2 */
          if ((
#line 3865 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEB_SEH) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 248; /* *extendqidi2_seb */
          break;

        case 2:
          if ((
#line 3835 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MIPS16E) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 242; /* *extendhidi2_mips16e */
          if ((
#line 3846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 246; /* *extendhidi2 */
          if ((
#line 3865 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEB_SEH) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 250; /* *extendhidi2_seh */
          break;

        case 3:
          if (
#line 3835 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MIPS16E))
            return 239; /* *extendqisi2_mips16e */
          if (
#line 3846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E))
            return 243; /* *extendqisi2 */
          if (
#line 3865 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEB_SEH))
            return 247; /* *extendqisi2_seb */
          break;

        case 4:
          if (
#line 3835 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MIPS16E))
            return 241; /* *extendhisi2_mips16e */
          if (
#line 3846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E))
            return 245; /* *extendhisi2 */
          if (
#line 3865 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEB_SEH))
            return 249; /* *extendhisi2_seh */
          break;

        case 5:
          if (
#line 3880 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MIPS16E))
            return 251; /* *extendqihi2_mips16e */
          if (
#line 3891 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_SEB_SEH && !GENERATE_MIPS16E))
            return 252; /* *extendqihi2 */
          if (
#line 3911 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEB_SEH))
            return 253; /* *extendqihi2_seb */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != MEM)
        return -1;
      switch (pattern103 (x3))
        {
        case 0:
          if (!(
#line 1098 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBX) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 994; /* mips_lbx_extsi_si */

        case 1:
          if (!(
#line 1098 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBX) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 1002; /* mips_lbx_extsi_di */

        case 2:
          if (!(
#line 1098 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHX) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 998; /* mips_lhx_extsi_si */

        case 3:
          if (!(
#line 1098 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHX) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 1006; /* mips_lhx_extsi_di */

        case 4:
          if (!(
#line 1098 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBX) && (((
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
            return -1;
          return 996; /* mips_lbx_extdi_si */

        case 5:
          if (!(
#line 1098 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LBX) && (((
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
            return -1;
          return 1004; /* mips_lbx_extdi_di */

        case 6:
          if (!(
#line 1098 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHX) && (((
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
            return -1;
          return 1000; /* mips_lhx_extdi_si */

        case 7:
          if (!(
#line 1098 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LHX) && (((
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
            return -1;
          return 1008; /* mips_lhx_extdi_di */

        case 8:
          if (!(
#line 1141 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LWX && TARGET_64BIT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 1014; /* *mips_lwx_si_ext */

        case 9:
          if (!(
#line 1141 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LWX && TARGET_64BIT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 1016; /* *mips_lwx_di_ext */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern34 (x3))
        {
        case 0:
          if (
#line 3925 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS))
            return 254; /* *extenddi_truncateqi */
          if (!(
#line 3984 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 260; /* *extenddi_truncateqi_exts */

        case 1:
          if (
#line 3925 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS))
            return 255; /* *extenddi_truncatehi */
          if (!(
#line 3984 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 262; /* *extenddi_truncatehi_exts */

        case 2:
          if (
#line 3945 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS))
            return 256; /* *extendsi_truncateqi */
          if (!
#line 3984 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS))
            return -1;
          return 259; /* *extendsi_truncateqi_exts */

        case 3:
          if (
#line 3945 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS))
            return 257; /* *extendsi_truncatehi */
          if (!
#line 3984 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS))
            return -1;
          return 261; /* *extendsi_truncatehi_exts */

        case 4:
          if (
#line 3965 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && !ISA_HAS_EXTS))
            return 258; /* *extendhi_truncateqi */
          if (!
#line 3996 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXTS))
            return -1;
          return 263; /* *extendhi_truncateqi_exts */

        default:
          return -1;
        }

    case IOR:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_CODE (x6))
        {
        case AND:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SUBREG
              || maybe_ne (SUBREG_BYTE (x7), 0)
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != CONST_INT
              || XWINT (x8, 0) != 16777215L
              || pattern239 (x5, 
E_SImode, 
ASHIFT) != 0)
            return -1;
          x9 = XEXP (x5, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 24])
            return -1;
          x10 = XEXP (x5, 0);
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (!rtx_equal_p (x12, operands[0])
              || !
#line 4428 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXT_INS))
            return -1;
          return 280; /* *insqisi_extended */

        case ASHIFT:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SUBREG
              || maybe_ne (SUBREG_BYTE (x7), 0)
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || pattern239 (x5, 
E_HImode, 
ZERO_EXTEND) != 0)
            return -1;
          x12 = XEXP (x7, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          x10 = XEXP (x5, 0);
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[0])
              || !
#line 4440 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16 && ISA_HAS_EXT_INS))
            return -1;
          return 281; /* *inshisi_extended */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern32 (x3) != 0
          || !
#line 5877 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
        return -1;
      return 457; /* *ashlsi3_extend */

    case ASHIFTRT:
      if (pattern32 (x3) != 0
          || !
#line 5877 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
        return -1;
      return 458; /* *ashrsi3_extend */

    case LSHIFTRT:
      if (pattern32 (x3) != 0
          || !
#line 5877 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
        return -1;
      return 459; /* *lshrsi3_extend */

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x13 = XVECEXP (x5, 0, 0);
      operands[2] = x13;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern169 (x3))
            {
            case 0:
              if (!
#line 546 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1249; /* msa_copy_s_h */

            case 1:
              if (!
#line 546 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1251; /* msa_copy_s_b */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !const_0_to_3_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !
#line 568 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA && TARGET_64BIT))
                return -1;
              return 1254; /* msa_copy_s_w_64bit */

            case E_SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !
#line 568 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA && TARGET_64BIT))
                return -1;
              return 1255; /* msa_copy_s_w_f_64bit */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 2066 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MULS))
            return -1;
          *pnum_clobbers = 1;
          return 50; /* *muls */

        case SIGN_EXTEND:
          if (pattern104 (x3, 
SIGN_EXTEND) != 0
              || !
#line 2250 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && ISA_HAS_MULS))
            return -1;
          return 61; /* *muls_di */

        case ZERO_EXTEND:
          if (pattern104 (x3, 
ZERO_EXTEND) != 0
              || !
#line 2250 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && ISA_HAS_MULS))
            return -1;
          return 62; /* *mulsu_di */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern38 (x3))
        {
        case 0:
          if (!(
#line 2753 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 117; /* *nmadd4sf */

        case 1:
          if (!(
#line 2753 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 118; /* *nmadd4df */

        case 2:
          if (!(
#line 2753 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 119; /* *nmadd4v2sf */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern38 (x3))
        {
        case 0:
          if (!(
#line 2764 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 120; /* *nmsub4sf */

        case 1:
          if (!(
#line 2764 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 121; /* *nmsub4df */

        case 2:
          if (!(
#line 2764 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 122; /* *nmsub4v2sf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 178; /* negsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 3249 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_MIPS16))
            return -1;
          return 179; /* negdi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !(
#line 3262 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (SFmode)) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 180; /* negsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !(
#line 3262 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (DFmode)) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 181; /* negdf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 3262 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_abs == MIPS_IEEE_754_2008 || !HONOR_NANS (V2SFmode)) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 182; /* negv2sf2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1260; /* negv2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1261; /* negv4sf2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (pattern6 (x3, 
E_SFmode, 
E_V2SFmode) != 0
              || !
#line 258 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return -1;
          return 866; /* vec_concatv2sf */

        case E_V2SImode:
          if (pattern6 (x3, 
E_SImode, 
E_V2SImode) != 0
              || !
#line 148 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1133; /* *vec_concatv2si */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SS_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (pattern162 (x3, 
E_V2SImode, 
E_V2HImode, 
E_V4HImode) != 0
              || !
#line 162 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1134; /* vec_pack_ssat_v2si */

        case E_V8QImode:
          if (pattern162 (x3, 
E_V4HImode, 
E_V4QImode, 
E_V8QImode) != 0
              || !
#line 162 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1135; /* vec_pack_ssat_v4hi */

        default:
          return -1;
        }

    case US_TRUNCATE:
      if (pattern86 (x3, 
E_V4HImode, 
E_V8QImode, 
E_V4QImode, 
US_TRUNCATE) != 0
          || !
#line 174 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1136; /* vec_pack_usat_v4hi */

    case TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern162 (x3, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 255 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1230; /* vec_pack_trunc_v2di */

        case E_V8HImode:
          if (pattern162 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 255 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1231; /* vec_pack_trunc_v4si */

        case E_V16QImode:
          if (pattern162 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 255 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1232; /* vec_pack_trunc_v8hi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (pattern86 (x3, 
E_V2DFmode, 
E_V4SFmode, 
E_V2SFmode, 
FLOAT_TRUNCATE) != 0
          || !
#line 2715 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1737; /* vec_pack_trunc_v2df */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 1L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern109 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 6363 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
                return -1;
              return 539; /* *sge_sisi */

            case 1:
              if (!(
#line 6363 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 541; /* *sge_disi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern109 (x3, 
E_DImode))
            {
            case 0:
              if (!(
#line 6363 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 543; /* *sge_sidi */

            case 1:
              if (!(
#line 6363 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 545; /* *sge_didi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern8 (x3))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 627; /* sge_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 631; /* sge_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 635; /* sge_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 639; /* sge_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 643; /* sge_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 647; /* sge_df_using_ccf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern131 (x1) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!const_call_insn_operand (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!
#line 7235 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_SPLIT_CALLS))
        return -1;
      return 693; /* call_direct_split */

    case SET:
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case CALL:
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_SImode
              || pattern131 (x1) != 0)
            return -1;
          switch (pattern223 (x1))
            {
            case 0:
              if (!
#line 7313 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_SPLIT_CALLS))
                return -1;
              return 697; /* call_value_direct_split */

            case 1:
              if (!
#line 7351 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_SPLIT_CALLS))
                return -1;
              return 699; /* call_value_multiple_split */

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern98 (x1) != 0)
            return -1;
          switch (pattern253 (x1))
            {
            case 0:
              if (!(
#line 7793 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
                return -1;
              return 759; /* tls_get_tp_mips16_si */

            case 1:
              if (!(
#line 7793 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 760; /* tls_get_tp_mips16_di */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 73)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (pattern126 (x4, 
73) != 0)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (pattern221 (x8, 
73, 
3, 
UNSPEC_VOLATILE) != 0)
            return -1;
          x9 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x9) != UNSPEC_VOLATILE
              || XVECLEN (x9, 0) != 3
              || XINT (x9, 1) != 73)
            return -1;
          x10 = XVECEXP (x6, 0, 0);
          operands[2] = x10;
          x11 = XVECEXP (x6, 0, 1);
          operands[3] = x11;
          x12 = XEXP (x4, 0);
          operands[1] = x12;
          x13 = XEXP (x8, 1);
          x14 = XVECEXP (x13, 0, 2);
          operands[4] = x14;
          x15 = XVECEXP (x9, 0, 0);
          operands[5] = x15;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x16 = XVECEXP (x9, 0, 1);
          operands[6] = x16;
          if (!const_int_operand (operands[6], E_SImode))
            return -1;
          x17 = XVECEXP (x9, 0, 2);
          operands[7] = x17;
          if (!const_int_operand (operands[7], E_SImode))
            return -1;
          x18 = XEXP (x4, 1);
          x19 = XVECEXP (x18, 0, 0);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          x20 = XVECEXP (x13, 0, 0);
          if (!rtx_equal_p (x20, operands[2]))
            return -1;
          x21 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x21, operands[3]))
            return -1;
          x22 = XEXP (x8, 0);
          if (!rtx_equal_p (x22, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern265 (x1, 
E_SImode) != 0
                  || !
#line 594 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 852; /* atomic_compare_and_swapsi */

            case E_DImode:
              if (pattern265 (x1, 
E_DImode) != 0
                  || !(
#line 594 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 853; /* atomic_compare_and_swapdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return NULL;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!d_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !const_int_operand (operands[1], E_DImode)
          || !
#line 4932 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16 && reload_completed
   && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x10)
       || (INTVAL (operands[1]) >= 32 * 8
	   && INTVAL (operands[1]) <= 31 * 8 + 0x8)
       || (INTVAL (operands[1]) >= 0
	   && INTVAL (operands[1]) < 32 * 8
	   && (INTVAL (operands[1]) & 7) != 0))))
        return NULL;
      return gen_split_54 (insn, operands);

    case E_SImode:
      if (pattern167 (x2, 
E_SImode) != 0
          || !
#line 5011 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x80)
       || (INTVAL (operands[1]) >= 32 * 4
	   && INTVAL (operands[1]) <= 31 * 4 + 0x7c)
       || (INTVAL (operands[1]) >= 0
	   && INTVAL (operands[1]) < 32 * 4
	   && (INTVAL (operands[1]) & 3) != 0))))
        return NULL;
      return gen_split_55 (insn, operands);

    case E_HImode:
      if (pattern167 (x2, 
E_HImode) != 0
          || !
#line 5152 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x80)
       || (INTVAL (operands[1]) >= 32 * 2
	   && INTVAL (operands[1]) <= 31 * 2 + 0x7e)
       || (INTVAL (operands[1]) >= 0
	   && INTVAL (operands[1]) < 32 * 2
	   && (INTVAL (operands[1]) & 1) != 0))))
        return NULL;
      return gen_split_57 (insn, operands);

    case E_QImode:
      if (pattern167 (x2, 
E_QImode) != 0
          || !
#line 5228 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && reload_completed && !TARGET_DEBUG_D_MODE
   && ((INTVAL (operands[1]) < 0
	&& INTVAL (operands[1]) >= -0x80)
       || (INTVAL (operands[1]) >= 32
	   && INTVAL (operands[1]) <= 31 + 0x7f))))
        return NULL;
      return gen_split_58 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 24)
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return NULL;
  x5 = XVECEXP (x3, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  switch (pattern209 (x1))
    {
    case 0:
      if (!(
#line 5689 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_must_initialize_gp_p ()) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
        return NULL;
      return gen_split_76 (insn, operands);

    case 1:
      if (!(
#line 5689 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_must_initialize_gp_p ()) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
        return NULL;
      return gen_split_77 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 3:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x2) != CLOBBER)
        return NULL;
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x4 = XEXP (x3, 0);
          operands[0] = x4;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case PLUS:
              if (pattern87 (x1) != 0
                  || !d_operand (operands[0], E_SImode))
                return NULL;
              x6 = XEXP (x5, 0);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (!d_operand (operands[1], E_SImode))
                return NULL;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              if (!d_operand (operands[2], E_SImode))
                return NULL;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!d_operand (operands[3], E_SImode))
                return NULL;
              x10 = XVECEXP (x1, 0, 1);
              x11 = XEXP (x10, 0);
              operands[4] = x11;
              if (!lo_operand (operands[4], E_SImode))
                return NULL;
              x12 = XEXP (x2, 0);
              operands[5] = x12;
              if (!d_operand (operands[5], E_SImode)
                  || !
#line 1832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed))
                return NULL;
              return gen_split_6 (insn, operands);

            case MINUS:
              if (GET_MODE (x5) != E_SImode)
                return NULL;
              x9 = XEXP (x5, 1);
              if (GET_CODE (x9) != MULT
                  || GET_MODE (x9) != E_SImode)
                return NULL;
              x10 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x10) != CLOBBER)
                return NULL;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              if (register_operand (operands[1], E_SImode)
                  && register_operand (operands[0], E_SImode)
                  && pattern238 (x1) == 0
                  && (
#line 1888 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MACC && !ISA_HAS_MSAC) && 
#line 1890 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return gen_split_7 (insn, operands);
              if (!d_operand (operands[1], E_SImode)
                  || !d_operand (operands[0], E_SImode))
                return NULL;
              x13 = XEXP (x9, 0);
              operands[2] = x13;
              if (!d_operand (operands[2], E_SImode))
                return NULL;
              x14 = XEXP (x9, 1);
              operands[3] = x14;
              if (!d_operand (operands[3], E_SImode))
                return NULL;
              x11 = XEXP (x10, 0);
              operands[4] = x11;
              if (!lo_operand (operands[4], E_SImode))
                return NULL;
              x12 = XEXP (x2, 0);
              operands[5] = x12;
              if (!d_operand (operands[5], E_SImode)
                  || !
#line 2054 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed))
                return NULL;
              return gen_split_8 (insn, operands);

            case MULT:
              if (GET_MODE (x5) != E_DImode)
                return NULL;
              x10 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x10) != CLOBBER
                  || !register_operand (operands[0], E_DImode))
                return NULL;
              x6 = XEXP (x5, 0);
              if (GET_MODE (x6) != E_DImode)
                return NULL;
              x9 = XEXP (x5, 1);
              if (GET_MODE (x9) != E_DImode)
                return NULL;
              x11 = XEXP (x10, 0);
              operands[3] = x11;
              if (!scratch_operand (operands[3], E_TImode))
                return NULL;
              x12 = XEXP (x2, 0);
              operands[4] = x12;
              if (!scratch_operand (operands[4], E_DImode))
                return NULL;
              switch (GET_CODE (x6))
                {
                case SIGN_EXTEND:
                  if (GET_CODE (x9) != SIGN_EXTEND)
                    return NULL;
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (!register_operand (operands[1], E_SImode))
                    return NULL;
                  x13 = XEXP (x9, 0);
                  operands[2] = x13;
                  if (!register_operand (operands[2], E_SImode)
                      || !(
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT) && 
#line 2153 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                    return NULL;
                  return gen_split_9 (insn, operands);

                case ZERO_EXTEND:
                  if (GET_CODE (x9) != ZERO_EXTEND)
                    return NULL;
                  x7 = XEXP (x6, 0);
                  operands[1] = x7;
                  if (!register_operand (operands[1], E_SImode))
                    return NULL;
                  x13 = XEXP (x9, 0);
                  operands[2] = x13;
                  if (!register_operand (operands[2], E_SImode)
                      || !(
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000 && !ISA_HAS_DMUL3
   && !TARGET_MIPS16 && ISA_HAS_MULT) && 
#line 2153 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                    return NULL;
                  return gen_split_10 (insn, operands);

                default:
                  return NULL;
                }

            case DIV:
              switch (pattern133 (x1, 
MOD))
                {
                case 0:
                  if (!(
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DIV && !TARGET_FIX_VR4120 && TARGET_MIPS16) && 
#line 2931 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( cse_not_expected)))
                    return NULL;
                  return gen_split_17 (insn, operands);

                case 1:
                  if (!((
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DDIV && !TARGET_FIX_VR4120 && TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 2931 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( cse_not_expected)))
                    return NULL;
                  return gen_split_18 (insn, operands);

                default:
                  return NULL;
                }

            case UDIV:
              switch (pattern133 (x1, 
UMOD))
                {
                case 0:
                  if (!
#line 2991 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(cse_not_expected))
                    return NULL;
                  return gen_split_21 (insn, operands);

                case 1:
                  if (!(
#line 2991 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(cse_not_expected) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_22 (insn, operands);

                default:
                  return NULL;
                }

            case CALL:
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != MEM
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              x12 = XEXP (x2, 0);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 31
                  || GET_MODE (x12) != E_SImode)
                return NULL;
              switch (pattern223 (x1))
                {
                case 0:
                  if (!
#line 7296 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && TARGET_SPLIT_CALLS))
                    return NULL;
                  return gen_split_95 (insn, operands);

                case 1:
                  if (!
#line 7332 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && TARGET_SPLIT_CALLS))
                    return NULL;
                  return gen_split_96 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case CALL:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x12 = XEXP (x2, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 31
              || GET_MODE (x12) != E_SImode)
            return NULL;
          x15 = XEXP (x4, 0);
          operands[0] = x15;
          if (!const_call_insn_operand (operands[0], E_VOIDmode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!
#line 7220 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && TARGET_SPLIT_CALLS))
            return NULL;
          return gen_split_93 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x3 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x3))
        {
        case SET:
          x4 = XEXP (x3, 0);
          operands[0] = x4;
          res = split_6 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != CLOBBER)
            return NULL;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case UNSPEC_VOLATILE:
              if (XVECLEN (x5, 0) != 1
                  || XINT (x5, 1) != 26)
                return NULL;
              x16 = XVECEXP (x5, 0, 0);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || GET_CODE (x4) != REG
                  || REGNO (x4) != 28)
                return NULL;
              switch (pattern210 (x1))
                {
                case 0:
                  if (!((
#line 6966 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_CALL_CLOBBERED_GP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 6968 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( epilogue_completed)))
                    return NULL;
                  return gen_split_88 (insn, operands);

                case 1:
                  if (!((
#line 6966 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_CALL_CLOBBERED_GP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 6968 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( epilogue_completed)))
                    return NULL;
                  return gen_split_89 (insn, operands);

                default:
                  return NULL;
                }

            case CALL:
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != MEM
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != REG
                  || REGNO (x11) != 31
                  || GET_MODE (x11) != E_SImode)
                return NULL;
              operands[0] = x4;
              if (!register_operand (operands[0], E_VOIDmode))
                return NULL;
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (!call_insn_operand (operands[1], E_VOIDmode))
                return NULL;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (!
#line 7263 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && TARGET_SPLIT_CALLS))
                return NULL;
              return gen_split_94 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 27)
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x10) != CLOBBER)
            return NULL;
          x17 = XVECEXP (x3, 0, 0);
          operands[0] = x17;
          if (!register_operand (operands[0], E_VOIDmode))
            return NULL;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!scratch_operand (operands[1], E_VOIDmode)
              || !
#line 6929 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed))
            return NULL;
          return gen_split_87 (insn, operands);

        case CALL:
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          if (pattern25 (x10, 
CLOBBER) != 0)
            return NULL;
          x15 = XEXP (x4, 0);
          operands[0] = x15;
          if (!call_insn_operand (operands[0], E_VOIDmode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!
#line 7188 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed && TARGET_SPLIT_CALLS))
            return NULL;
          return gen_split_92 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
