/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  return pattern2 (x3); /* [-1, 1] */
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern0 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 31
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern31 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL)
    return -1;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  switch (XVECLEN (x4, 0))
    {
    case 8:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x14 = XVECEXP (x4, 0, 4);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x15 = XVECEXP (x4, 0, 5);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x16 = XVECEXP (x4, 0, 6);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x17 = XVECEXP (x4, 0, 7);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || XVECLEN (x7, 0) != 8)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x22 = XVECEXP (x7, 0, 4);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x23 = XVECEXP (x7, 0, 5);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x24 = XVECEXP (x7, 0, 6);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x25 = XVECEXP (x7, 0, 7);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || pattern30 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 0;

    case 4:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x12 = XVECEXP (x4, 0, 2);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x13 = XVECEXP (x4, 0, 3);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || XVECLEN (x7, 0) != 4)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x20 = XVECEXP (x7, 0, 2);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x21 = XVECEXP (x7, 0, 3);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || pattern30 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case 2:
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XVECEXP (x4, 0, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || XVECLEN (x7, 0) != 2)
        return -1;
      x18 = XVECEXP (x7, 0, 0);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x7, 0, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || pattern30 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern88 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern88 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x7, 1);
  if (GET_MODE (x10) != i2)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != i1)
    return -1;
  return 0;
}

int
pattern111 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode
      || !muldiv_target_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  if (!muldiv_target_operand (operands[3], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern121 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !arith_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, unsigned int i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != i3
      || XINT (x2, 1) != i2
      || GET_MODE (x2) != E_CCDSPmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_CCDSPmode)
    return -1;
  return 0;
}

int
pattern141 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !and_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern145 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i3))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x8 = XEXP (x2, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i2)
    return -1;
  x11 = XEXP (x8, 1);
  if (GET_MODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern164 (rtx x1, int i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 185
      || GET_MODE (x6) != E_CCDSPmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], i2))
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], i3))
    return -1;
  x9 = XVECEXP (x3, 0, 1);
  operands[2] = x9;
  if (!register_operand (operands[2], E_V2HImode)
      || !scratch_operand (operands[3], E_DImode))
    return -1;
  x10 = XVECEXP (x5, 0, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XVECEXP (x5, 0, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern178 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_0_or_1_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern193 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[2]))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V2HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 185
      || GET_MODE (x6) != E_CCDSPmode
      || !register_operand (operands[0], E_V2HImode)
      || pattern197 (x5, 
E_V2HImode) != 0)
    return -1;
  return 0;
}

int
pattern207 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !const_0_to_3_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern213 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!call_insn_operand (operands[1], E_VOIDmode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  if (!register_operand (operands[3], E_VOIDmode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !equality_operator (operands[4], E_VOIDmode))
    return -1;
  return pattern226 (); /* [-1, 3] */
}

int
pattern229 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_exp_2_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern238 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern249 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HQmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      return pattern92 (x7, 
E_HQmode); /* [-1, 0] */

    case E_SQmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_SQmode) != 0)
        return -1;
      return 1;

    case E_HAmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_HAmode) != 0)
        return -1;
      return 2;

    case E_SAmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_SAmode) != 0)
        return -1;
      return 3;

    case E_V2HQmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_V2HQmode) != 0)
        return -1;
      return 4;

    case E_V2HAmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_V2HAmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCV2mode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_CCV2mode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case UNORDERED:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 880; /* sunordered_ps */

    case UNEQ:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 881; /* suneq_ps */

    case UNLT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 882; /* sunlt_ps */

    case UNLE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 883; /* sunle_ps */

    case EQ:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 884; /* seq_ps */

    case LT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 885; /* slt_ps */

    case LE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 545 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 886; /* sle_ps */

    case ORDERED:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !(
#line 545 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 1019 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF)))
        return -1;
      return 887; /* sordered_ps */

    case LTGT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !(
#line 545 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 1020 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF)))
        return -1;
      return 888; /* sltgt_ps */

    case NE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !(
#line 545 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 1021 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF)))
        return -1;
      return 889; /* sne_ps */

    case GE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 890; /* sge_ps */

    case GT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 891; /* sgt_ps */

    case UNGE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 892; /* sunge_ps */

    case UNGT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_V2SFmode)
          || !
#line 556 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 893; /* sungt_ps */

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 20:
      return recog_6 (x1, insn, pnum_clobbers);

    case 35:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!d_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !symbolic_operand_with_high (operands[1], E_SImode)
              || !
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))
            return -1;
          return 300; /* *unshifted_high */

        case E_DImode:
          if (!d_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !symbolic_operand_with_high (operands[1], E_DImode)
              || !
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))
            return -1;
          return 301; /* *unshifted_high */

        default:
          return -1;
        }

    case 18:
      switch (pattern40 (x1))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!hilo_operand (operands[1], E_DImode)
                  || !
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT))
                return -1;
              return 387; /* mfhisi_di */

            case E_TImode:
              if (!hilo_operand (operands[1], E_TImode)
                  || !
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))
                return -1;
              return 388; /* mfhisi_ti */

            default:
              return -1;
            }

        case 1:
          if (!hilo_operand (operands[1], E_TImode)
              || !
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))
            return -1;
          return 389; /* mfhidi_ti */

        default:
          return -1;
        }

    case 7:
      return recog_5 (x1, insn, pnum_clobbers);

    case 10:
      return recog_7 (x1, insn, pnum_clobbers);

    case 21:
      switch (pattern40 (x1))
        {
        case 0:
          if (!(
#line 5621 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_ABSOLUTE) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 430; /* loadgp_absolute_si */

        case 1:
          if (!(
#line 5621 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_ABSOLUTE) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 431; /* loadgp_absolute_di */

        default:
          return -1;
        }

    case 22:
      switch (pattern42 (x1))
        {
        case 0:
          if (!(
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 435; /* copygp_mips16_si */

        case 1:
          if (!(
#line 5668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 436; /* copygp_mips16_di */

        default:
          return -1;
        }

    case 47:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_BLKmode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != SCRATCH
          || !
#line 5796 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CACHE))
        return -1;
      return 450; /* r10k_cache_barrier */

    case 4:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 6044 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_WSBH))
        return -1;
      return 474; /* wsbh */

    case 5:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6051 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && ISA_HAS_WSBH))
        return -1;
      return 475; /* dsbh */

    case 6:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6058 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && ISA_HAS_WSBH))
        return -1;
      return 476; /* dshd */

    case 23:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (pattern113 (x2))
        {
        case 0:
          return 681; /* move_gpsi */

        case 1:
          if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))
            return -1;
          return 682; /* move_gpdi */

        default:
          return -1;
        }

    case 30:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 79
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 79
          || GET_MODE (x3) != E_SImode
          || !
#line 7062 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_USE_GOT))
        return -1;
      return 686; /* update_got_version */

    case 34:
      return recog_4 (x1, insn, pnum_clobbers);

    case 12:
      return recog_9 (x1, insn, pnum_clobbers);

    case 16:
      switch (pattern43 (x1))
        {
        case 0:
          if (!(
#line 8049 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FRINT) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 787; /* rintsf2 */

        case 1:
          if (!(
#line 8049 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FRINT) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 788; /* rintdf2 */

        default:
          return -1;
        }

    case 17:
      switch (pattern43 (x1))
        {
        case 0:
          if (!(
#line 8059 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FCLASS) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 789; /* fclass_sf */

        case 1:
          if (!(
#line 8059 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FCLASS) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 790; /* fclass_df */

        default:
          return -1;
        }

    case 72:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0])
          || !
#line 56 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_SYNC))
        return -1;
      return 791; /* *memory_barrier */

    case 81:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode)
          || !
#line 378 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
        return -1;
      return 870; /* mips_cvt_pw_ps */

    case 82:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode)
          || !
#line 388 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
        return -1;
      return 871; /* mips_cvt_ps_pw */

    case 84:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode)
          || !
#line 424 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
        return -1;
      return 873; /* *mips_abs_ps */

    case 90:
      return recog_3 (x1, insn, pnum_clobbers);

    case 85:
      switch (pattern44 (x1))
        {
        case 0:
          if (!(
#line 668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 900; /* mips_rsqrt1_s */

        case 1:
          if (!(
#line 668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 901; /* mips_rsqrt1_d */

        case 2:
          if (!(
#line 668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 902; /* mips_rsqrt1_ps */

        default:
          return -1;
        }

    case 87:
      switch (pattern44 (x1))
        {
        case 0:
          if (!(
#line 687 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 906; /* mips_recip1_s */

        case 1:
          if (!(
#line 687 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 907; /* mips_recip1_d */

        case 2:
          if (!(
#line 687 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 908; /* mips_recip1_ps */

        default:
          return -1;
        }

    case 98:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 218 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 925; /* mips_raddu_w_qb */

    case 104:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2HImode)
          || !
#line 288 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 932; /* mips_preceq_w_phl */

    case 105:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2HImode)
          || !
#line 297 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 933; /* mips_preceq_w_phr */

    case 106:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 307 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 934; /* mips_precequ_ph_qbl */

    case 107:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 316 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 935; /* mips_precequ_ph_qbr */

    case 108:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 325 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 936; /* mips_precequ_ph_qbla */

    case 109:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 334 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 937; /* mips_precequ_ph_qbra */

    case 110:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 344 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 938; /* mips_preceu_ph_qbl */

    case 111:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 353 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 939; /* mips_preceu_ph_qbr */

    case 112:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 362 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 940; /* mips_preceu_ph_qbla */

    case 113:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4QImode)
          || !
#line 371 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 941; /* mips_preceu_ph_qbra */

    case 137:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 744 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 968; /* mips_bitrev */

    case 139:
      if (GET_MODE (x2) != E_V4QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!arith_operand (operands[1], E_SImode)
          || !
#line 767 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 970; /* mips_repl_qb */

    case 140:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_imm10_operand (operands[1], E_SImode)
          || !
#line 784 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 971; /* mips_repl_ph */

    case 213:
      return recog_8 (x1, insn, pnum_clobbers);

    case 215:
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8QImode)
          || !
#line 473 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1183; /* loongson_pmovmskb */

    case 220:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !
#line 531 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1189; /* loongson_biadd */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !
#line 539 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1190; /* reduc_uplus_v8qi */

        default:
          return -1;
        }

    case 250:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1560 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1482; /* msa_fclass_d */

        case 1:
          if (!
#line 1560 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1483; /* msa_fclass_w */

        default:
          return -1;
        }

    case 256:
      switch (pattern46 (x1, 
E_V4SImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 1688 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1534; /* msa_ffql_d */

        case 1:
          if (!
#line 1688 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1535; /* msa_ffql_w */

        default:
          return -1;
        }

    case 257:
      switch (pattern46 (x1, 
E_V4SImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 1698 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1536; /* msa_ffqr_d */

        case 1:
          if (!
#line 1698 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1537; /* msa_ffqr_w */

        default:
          return -1;
        }

    case 258:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 1736 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1544; /* msa_flog2_d */

        case 1:
          if (!
#line 1736 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1545; /* msa_flog2_w */

        default:
          return -1;
        }

    case 259:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 1787 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1554; /* msa_frcp_d */

        case 1:
          if (!
#line 1787 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1555; /* msa_frcp_w */

        default:
          return -1;
        }

    case 260:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 1796 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1556; /* msa_frint_d */

        case 1:
          if (!
#line 1796 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1557; /* msa_frint_w */

        default:
          return -1;
        }

    case 261:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 1805 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1558; /* msa_frsqrt_d */

        case 1:
          if (!
#line 1805 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1559; /* msa_frsqrt_w */

        default:
          return -1;
        }

    case 273:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1814 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1560; /* msa_ftint_s_d */

        case 1:
          if (!
#line 1814 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1561; /* msa_ftint_s_w */

        default:
          return -1;
        }

    case 274:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 1824 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1562; /* msa_ftint_u_d */

        case 1:
          if (!
#line 1824 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1563; /* msa_ftint_u_w */

        default:
          return -1;
        }

    case 282:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (pattern114 (x2))
        {
        case 0:
          if (!
#line 2350 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1638; /* msa_nloc_d */

        case 1:
          if (!
#line 2350 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1639; /* msa_nloc_w */

        case 2:
          if (!
#line 2350 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1640; /* msa_nloc_h */

        case 3:
          if (!
#line 2350 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1641; /* msa_nloc_b */

        default:
          return -1;
        }

    case 288:
      switch (pattern46 (x1, 
E_DFmode, 
E_SFmode))
        {
        case 0:
          if (!
#line 2677 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1732; /* msa_splati_d_f_scalar */

        case 1:
          if (!
#line 2677 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1733; /* msa_splati_w_f_scalar */

        default:
          return -1;
        }

    case 254:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1738; /* msa_fexupl_w */

    case 255:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2744 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1740; /* msa_fexupr_w */

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      return recog_54 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
      operands[1] = x5;
      if (XVECLEN (x3, 0) == 1)
        {
          x6 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x6) == CONST_INT)
            {
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern206 (x2, 
E_V2SFmode, 
E_SFmode) == 0
                      && 
#line 277 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
                    return 867; /* vec_extractv2sfsf */
                  break;

                case E_SImode:
                  if (pattern207 (x2, 
E_V4SImode, 
E_SImode) == 0
                      && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return 1256; /* msa_copy_s_w */
                  break;

                case E_DImode:
                  if (pattern206 (x2, 
E_V2DImode, 
E_DImode) == 0
                      && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return 1258; /* msa_copy_s_d */
                  break;

                default:
                  break;
                }
              if (XWINT (x6, 0) == 0L)
                {
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x2) == E_SImode
                          && register_operand (operands[1], E_V2SImode)
                          && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return 1227; /* vec_loongson_extract_lo_v2si */
                      break;

                    case E_HImode:
                      if (register_operand (operands[0], E_HImode)
                          && GET_MODE (x2) == E_HImode
                          && register_operand (operands[1], E_V4HImode)
                          && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return 1228; /* vec_loongson_extract_lo_v4hi */
                      break;

                    case E_QImode:
                      if (register_operand (operands[0], E_QImode)
                          && GET_MODE (x2) == E_QImode
                          && register_operand (operands[1], E_V8QImode)
                          && 
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
                        return 1229; /* vec_loongson_extract_lo_v8qi */
                      break;

                    case E_DFmode:
                      if (register_operand (operands[0], E_DFmode)
                          && GET_MODE (x2) == E_DFmode
                          && register_operand (operands[1], E_V2DFmode)
                          && 
#line 369 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return 1233; /* msa_vec_extract_d_f */
                      break;

                    case E_SFmode:
                      if (register_operand (operands[0], E_SFmode)
                          && GET_MODE (x2) == E_SFmode
                          && register_operand (operands[1], E_V4SFmode)
                          && 
#line 369 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return 1234; /* msa_vec_extract_w_f */
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern207 (x2, 
E_V4SFmode, 
E_SFmode) == 0
                      && 
#line 578 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return 1257; /* msa_copy_s_w_f */
                  break;

                case E_DFmode:
                  if (pattern206 (x2, 
E_V2DFmode, 
E_DFmode) == 0
                      && 
#line 588 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                    return 1259; /* msa_copy_s_d_f */
                  break;

                default:
                  break;
                }
            }
        }
      operands[2] = x3;
      if (!par_const_vector_shf_set_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1670; /* msa_shf_d_f */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1671; /* msa_shf_w_f */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1672; /* msa_shf_d */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1673; /* msa_shf_w */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x2) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1674; /* msa_shf_h */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1675; /* msa_shf_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !(
#line 2843 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_FIX_SB1 || flag_unsafe_math_optimizations) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 129; /* *divsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))
            return -1;
          return 130; /* *divdf3 */

        case E_V2SFmode:
          if (pattern0 (x3, 
E_V2SFmode) != 0
              || !(
#line 2843 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_SB1 && (!TARGET_FIX_SB1 || flag_unsafe_math_optimizations)) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 131; /* *divv2sf3 */

        case E_SImode:
          if (pattern0 (x3, 
E_SImode) != 0
              || !
#line 3044 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DIV))
            return -1;
          return 149; /* divsi3 */

        case E_DImode:
          if (pattern0 (x3, 
E_DImode) != 0
              || !(
#line 3044 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DDIV) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 151; /* divdi3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !
#line 799 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1294; /* divv2di3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 799 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1295; /* divv4si3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 799 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1296; /* divv8hi3 */

        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 799 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1297; /* divv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 969 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1344; /* divv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 969 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1345; /* divv4sf3 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern151 (x3, 
E_SFmode) != 0
                  || !(
#line 2861 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (SFmode) && flag_unsafe_math_optimizations) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 132; /* *recipsf3 */

            case E_DFmode:
              if (pattern151 (x3, 
E_DFmode) != 0
                  || !(
#line 2861 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (DFmode) && flag_unsafe_math_optimizations) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 133; /* *recipdf3 */

            case E_V2SFmode:
              if (pattern151 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2861 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (V2SFmode) && flag_unsafe_math_optimizations) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 134; /* *recipv2sf3 */

            default:
              return -1;
            }

        case SQRT:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern152 (x3, 
E_SFmode) != 0
                  || !(
#line 3103 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (SFmode) && flag_unsafe_math_optimizations) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 160; /* *rsqrtsfa */

            case E_DFmode:
              if (pattern152 (x3, 
E_DFmode) != 0
                  || !(
#line 3103 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (DFmode) && flag_unsafe_math_optimizations) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 161; /* *rsqrtdfa */

            case E_V2SFmode:
              if (pattern152 (x3, 
E_V2SFmode) != 0
                  || !(
#line 3103 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FP_RECIP_RSQRT (V2SFmode) && flag_unsafe_math_optimizations) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 162; /* *rsqrtv2sfa */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) == 0L)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern109 (x3, 
E_SImode))
                {
                case 0:
                  if (
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE))
                    return 515; /* *sne_zero_sisi */
                  break;

                case 1:
                  if ((
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 516; /* *sne_zero_disi */
                  break;

                default:
                  break;
                }
              break;

            case E_DImode:
              switch (pattern109 (x3, 
E_DImode))
                {
                case 0:
                  if ((
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 517; /* *sne_zero_sidi */
                  break;

                case 1:
                  if ((
#line 6323 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 518; /* *sne_zero_didi */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      break;

    case REG:
    case SUBREG:
      switch (pattern85 (x3))
        {
        case 0:
          if (((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return 616; /* sne_sf_using_ccf */
          break;

        case 1:
          if (((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return 626; /* sne_df_using_ccf */
          break;

        case 2:
          if (
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return 1491; /* msa_fcne_d */
          break;

        case 3:
          if (
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return 1500; /* msa_fcne_w */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern120 (x3, 
E_SImode))
        {
        case 0:
          if (!
#line 6333 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE))
            return -1;
          return 519; /* *sne_sisi_sne */

        case 1:
          if (!(
#line 6333 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 520; /* *sne_disi_sne */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern120 (x3, 
E_DImode))
        {
        case 0:
          if (!(
#line 6333 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 521; /* *sne_sidi_sne */

        case 1:
          if (!(
#line 6333 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 522; /* *sne_didi_sne */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case PC:
      x4 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x4))
        {
        case SET:
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))
                return -1;
              return 656; /* indirect_jump_and_restore_si */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !register_operand (operands[0], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))
                return -1;
              return 657; /* indirect_jump_and_restore_di */

            default:
              return -1;
            }

        case USE:
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != LABEL_REF)
            return -1;
          x5 = XEXP (x2, 1);
          operands[0] = x5;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))
                return -1;
              return 658; /* tablejump_si */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))
                return -1;
              return 659; /* tablejump_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          operands[3] = x7;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (pattern232 (
E_HImode) != 0
                  || !
#line 7894 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS && reload_completed))
                return -1;
              return 769; /* *join2_load_storehi */

            case E_SImode:
              if (pattern232 (
E_SImode) != 0
                  || !
#line 7894 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS && reload_completed))
                return -1;
              return 770; /* *join2_load_storesi */

            case E_SFmode:
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && nonimmediate_operand (operands[1], E_SFmode)
                  && nonimmediate_operand (operands[2], E_SFmode)
                  && nonimmediate_operand (operands[3], E_SFmode)
                  && (
#line 7894 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS && reload_completed) && 
#line 822 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 771; /* *join2_load_storesf */
              if (!register_operand (operands[0], E_SFmode)
                  || !movep_src_operand (operands[1], E_SFmode))
                return -1;
              switch (pattern222 ())
                {
                case 0:
                  if (!
#line 127 "../../gcc-15.0.1-20250313/gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_movep_target_p (operands[0], operands[2])))
                    return -1;
                  return 1126; /* *movepsfsi */

                case 1:
                  if (!
#line 127 "../../gcc-15.0.1-20250313/gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_movep_target_p (operands[0], operands[2])))
                    return -1;
                  return 1127; /* *movepsfsf */

                default:
                  return -1;
                }

            case E_DFmode:
              if (pattern232 (
E_DFmode) != 0
                  || !(
#line 7894 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS && reload_completed) && 
#line 823 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				      && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 772; /* *join2_load_storedf */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          x6 = XEXP (x4, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 2:
              if (XINT (x7, 1) != 64)
                return -1;
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern245 (x7, 
E_SImode) != 0
                      || !
#line 67 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                    return -1;
                  return 792; /* sync_compare_and_swapsi */

                case E_DImode:
                  if (pattern245 (x7, 
E_DImode) != 0
                      || !(
#line 67 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return -1;
                  return 793; /* sync_compare_and_swapdi */

                default:
                  return -1;
                }

            case 4:
              if (XINT (x7, 1) != 65
                  || GET_MODE (x7) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || !memory_operand (operands[1], E_SImode))
                return -1;
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!register_operand (operands[3], E_SImode))
                return -1;
              x11 = XVECEXP (x7, 0, 2);
              operands[4] = x11;
              if (!reg_or_0_operand (operands[4], E_SImode))
                return -1;
              x12 = XVECEXP (x7, 0, 3);
              operands[5] = x12;
              if (!reg_or_0_operand (operands[5], E_SImode)
                  || !
#line 99 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 794; /* compare_and_swap_12 */

            case 3:
              if (!register_operand (operands[0], E_SImode)
                  || !memory_operand (operands[1], E_SImode)
                  || GET_MODE (x7) != E_SImode)
                return -1;
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!register_operand (operands[3], E_SImode))
                return -1;
              switch (XINT (x7, 1))
                {
                case 69:
                  if (pnum_clobbers == NULL)
                    return -1;
                  x11 = XVECEXP (x7, 0, 2);
                  switch (pattern260 (x11))
                    {
                    case 0:
                      if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                        return -1;
                      *pnum_clobbers = 1;
                      return 802; /* sync_old_add_12 */

                    case 1:
                      if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                        return -1;
                      *pnum_clobbers = 1;
                      return 803; /* sync_old_sub_12 */

                    case 2:
                      if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                        return -1;
                      *pnum_clobbers = 1;
                      return 804; /* sync_old_ior_12 */

                    case 3:
                      if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                        return -1;
                      *pnum_clobbers = 1;
                      return 805; /* sync_old_xor_12 */

                    case 4:
                      if (!
#line 186 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                        return -1;
                      *pnum_clobbers = 1;
                      return 806; /* sync_old_and_12 */

                    case 5:
                      if (!
#line 307 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                        return -1;
                      *pnum_clobbers = 1;
                      return 813; /* sync_old_nand_12 */

                    default:
                      return -1;
                    }

                case 71:
                  x11 = XVECEXP (x7, 0, 2);
                  operands[4] = x11;
                  if (!reg_or_0_operand (operands[4], E_SImode)
                      || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                    return -1;
                  return 851; /* test_and_set_12 */

                default:
                  return -1;
                }

            case 1:
              switch (XINT (x7, 1))
                {
                case 66:
                  x9 = XVECEXP (x7, 0, 0);
                  switch (GET_CODE (x9))
                    {
                    case PLUS:
                      x13 = XEXP (x9, 1);
                      operands[2] = x13;
                      x14 = XEXP (x9, 0);
                      if (!rtx_equal_p (x14, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern247 (x7, 
E_SImode) != 0
                              || !
#line 383 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                            return -1;
                          return 817; /* sync_old_addsi */

                        case E_DImode:
                          if (pattern247 (x7, 
E_DImode) != 0
                              || !(
#line 383 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                            return -1;
                          return 818; /* sync_old_adddi */

                        default:
                          return -1;
                        }

                    case MINUS:
                      x13 = XEXP (x9, 1);
                      operands[2] = x13;
                      x14 = XEXP (x9, 0);
                      if (!rtx_equal_p (x14, operands[1]))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern248 (x7, 
E_SImode) != 0
                              || !
#line 398 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                            return -1;
                          return 819; /* sync_old_subsi */

                        case E_DImode:
                          if (pattern248 (x7, 
E_DImode) != 0
                              || !(
#line 398 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                            return -1;
                          return 820; /* sync_old_subdi */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern235 (x7))
                        {
                        case 0:
                          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                            return -1;
                          return 831; /* sync_old_iorsi */

                        case 1:
                          if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                            return -1;
                          return 834; /* sync_old_iordi */

                        default:
                          return -1;
                        }

                    case XOR:
                      switch (pattern235 (x7))
                        {
                        case 0:
                          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                            return -1;
                          return 832; /* sync_old_xorsi */

                        case 1:
                          if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                            return -1;
                          return 835; /* sync_old_xordi */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern235 (x7))
                        {
                        case 0:
                          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                            return -1;
                          return 833; /* sync_old_andsi */

                        case 1:
                          if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                            return -1;
                          return 836; /* sync_old_anddi */

                        default:
                          return -1;
                        }

                    case CONST_INT:
                    case REG:
                    case SUBREG:
                      switch (pattern237 (x7))
                        {
                        case 0:
                          if (!
#line 497 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                            return -1;
                          return 845; /* sync_old_nandsi */

                        case 1:
                          if (!(
#line 497 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                            return -1;
                          return 846; /* sync_old_nanddi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 67:
                  x9 = XVECEXP (x7, 0, 0);
                  switch (GET_CODE (x9))
                    {
                    case IOR:
                      switch (pattern235 (x7))
                        {
                        case 0:
                          if (!
#line 472 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                            return -1;
                          return 837; /* sync_new_iorsi */

                        case 1:
                          if (!(
#line 472 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                            return -1;
                          return 840; /* sync_new_iordi */

                        default:
                          return -1;
                        }

                    case XOR:
                      switch (pattern235 (x7))
                        {
                        case 0:
                          if (!
#line 472 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                            return -1;
                          return 838; /* sync_new_xorsi */

                        case 1:
                          if (!(
#line 472 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                            return -1;
                          return 841; /* sync_new_xordi */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern235 (x7))
                        {
                        case 0:
                          if (!
#line 472 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                            return -1;
                          return 839; /* sync_new_andsi */

                        case 1:
                          if (!(
#line 472 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                            return -1;
                          return 842; /* sync_new_anddi */

                        default:
                          return -1;
                        }

                    case CONST_INT:
                    case REG:
                    case SUBREG:
                      switch (pattern237 (x7))
                        {
                        case 0:
                          if (!
#line 511 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                            return -1;
                          return 847; /* sync_new_nandsi */

                        case 1:
                          if (!(
#line 511 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                            return -1;
                          return 848; /* sync_new_nanddi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 70:
                  x9 = XVECEXP (x7, 0, 0);
                  operands[2] = x9;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern244 (x7, 
E_SImode) != 0
                          || !
#line 526 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                        return -1;
                      return 849; /* sync_lock_test_and_setsi */

                    case E_DImode:
                      if (pattern244 (x7, 
E_DImode) != 0
                          || !(
#line 526 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                        return -1;
                      return 850; /* sync_lock_test_and_setdi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
