/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return pattern4 (); /* [-1, 1] */
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_simm5_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern18 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 69
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != ABS)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern28 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern28 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern28 (x1, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern28 (x1, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern41 (x3); /* [-1, 1] */
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern64 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!reg_or_0_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_CCV4mode)
      || GET_MODE (x1) != E_CCV4mode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_V2SFmode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V2SFmode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], E_V2SFmode))
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  operands[4] = x5;
  if (!register_operand (operands[4], E_V2SFmode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  operands[5] = x6;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  switch (XINT (x1, 1))
    {
    case 77:
      return 0;

    case 79:
      return 1;

    default:
      return -1;
    }
}

int
pattern88 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern97 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return pattern96 (x1); /* [-1, 1] */
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_val_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !got_disp_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern149 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern162 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || pattern35 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern167 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!d_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !const_int_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern171 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL)
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != VEC_SELECT)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL)
    return -1;
  x10 = XEXP (x2, 1);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != VEC_SELECT)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != PARALLEL)
    return -1;
  x14 = XEXP (x10, 1);
  if (GET_CODE (x14) != i1)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != VEC_SELECT)
    return -1;
  x16 = XEXP (x15, 1);
  if (GET_CODE (x16) != PARALLEL)
    return -1;
  x17 = XEXP (x5, 0);
  operands[2] = x17;
  x18 = XEXP (x8, 0);
  operands[3] = x18;
  x19 = XEXP (x12, 0);
  if (!rtx_equal_p (x19, operands[2]))
    return -1;
  x20 = XEXP (x15, 0);
  if (!rtx_equal_p (x20, operands[3]))
    return -1;
  switch (XVECLEN (x6, 0))
    {
    case 2:
      x21 = XVECEXP (x6, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x6, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x9, 0) != 2)
        return -1;
      x23 = XVECEXP (x9, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x9, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
          || XVECLEN (x13, 0) != 2)
        return -1;
      x25 = XVECEXP (x13, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XVECEXP (x13, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || XVECLEN (x16, 0) != 2)
        return -1;
      x27 = XVECEXP (x16, 0, 0);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x16, 0, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
          || pattern170 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 0;

    case 4:
      x21 = XVECEXP (x6, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x6, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x29 = XVECEXP (x6, 0, 2);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x30 = XVECEXP (x6, 0, 3);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x9, 0) != 4)
        return -1;
      x23 = XVECEXP (x9, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x9, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x31 = XVECEXP (x9, 0, 2);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x32 = XVECEXP (x9, 0, 3);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 6]
          || XVECLEN (x13, 0) != 4)
        return -1;
      x25 = XVECEXP (x13, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XVECEXP (x13, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x33 = XVECEXP (x13, 0, 2);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x34 = XVECEXP (x13, 0, 3);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || XVECLEN (x16, 0) != 4)
        return -1;
      x27 = XVECEXP (x16, 0, 0);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x16, 0, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x35 = XVECEXP (x16, 0, 2);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x36 = XVECEXP (x16, 0, 3);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || pattern170 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case 8:
      x21 = XVECEXP (x6, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x22 = XVECEXP (x6, 0, 1);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x29 = XVECEXP (x6, 0, 2);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x30 = XVECEXP (x6, 0, 3);
      if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x37 = XVECEXP (x6, 0, 4);
      if (x37 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x38 = XVECEXP (x6, 0, 5);
      if (x38 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x39 = XVECEXP (x6, 0, 6);
      if (x39 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x40 = XVECEXP (x6, 0, 7);
      if (x40 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x9, 0) != 8)
        return -1;
      x23 = XVECEXP (x9, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x9, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x31 = XVECEXP (x9, 0, 2);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x32 = XVECEXP (x9, 0, 3);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x41 = XVECEXP (x9, 0, 4);
      if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x42 = XVECEXP (x9, 0, 5);
      if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x43 = XVECEXP (x9, 0, 6);
      if (x43 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x44 = XVECEXP (x9, 0, 7);
      if (x44 != const_int_rtx[MAX_SAVED_CONST_INT + 14]
          || XVECLEN (x13, 0) != 8)
        return -1;
      x25 = XVECEXP (x13, 0, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XVECEXP (x13, 0, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x33 = XVECEXP (x13, 0, 2);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x34 = XVECEXP (x13, 0, 3);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x45 = XVECEXP (x13, 0, 4);
      if (x45 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x46 = XVECEXP (x13, 0, 5);
      if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x47 = XVECEXP (x13, 0, 6);
      if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x48 = XVECEXP (x13, 0, 7);
      if (x48 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || XVECLEN (x16, 0) != 8)
        return -1;
      x27 = XVECEXP (x16, 0, 0);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x28 = XVECEXP (x16, 0, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x35 = XVECEXP (x16, 0, 2);
      if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x36 = XVECEXP (x16, 0, 3);
      if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x49 = XVECEXP (x16, 0, 4);
      if (x49 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x50 = XVECEXP (x16, 0, 5);
      if (x50 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x51 = XVECEXP (x16, 0, 6);
      if (x51 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x52 = XVECEXP (x16, 0, 7);
      if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
          || pattern170 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1720; /* msa_splat_d_f */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1721; /* msa_splat_w_f */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1722; /* msa_splat_d */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1723; /* msa_splat_w */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1724; /* msa_splat_h */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1725; /* msa_splat_b */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 463 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 948; /* mips_shra_r_w */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode)
          || !
#line 463 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 949; /* mips_shra_r_ph */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1696; /* msa_subs_u_d */

    case 1:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1697; /* msa_subs_u_w */

    case 2:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1698; /* msa_subs_u_h */

    case 3:
      if (!
#line 2605 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1699; /* msa_subs_u_b */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (pattern150 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1640 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1528; /* msa_fexp2_d */

    case E_V4SFmode:
      if (pattern150 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 1640 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1529; /* msa_fexp2_w */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 0:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!memory_operand (operands[2], E_QImode))
        return -1;
      switch (pattern39 (x2))
        {
        case 0:
          if (!
#line 4523 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
((!TARGET_MIPS16 || ISA_HAS_MIPS16E2)
    && mips_mem_fits_mode_p (SImode, operands[1])))
            return -1;
          return 286; /* mov_lwl */

        case 1:
          if (!(
#line 4523 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
((!TARGET_MIPS16 || ISA_HAS_MIPS16E2)
    && mips_mem_fits_mode_p (DImode, operands[1])) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 287; /* mov_ldl */

        default:
          return -1;
        }

    case 2:
      return recog_15 (x1, insn, pnum_clobbers);

    case 32:
      switch (pattern49 (x1))
        {
        case 0:
          if (!
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))
            return -1;
          return 310; /* load_gotsi */

        case 1:
          if (!
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))
            return -1;
          return 311; /* load_gotdi */

        default:
          return -1;
        }

    case 19:
      return recog_14 (x1, insn, pnum_clobbers);

    case 8:
      return recog_12 (x1, insn, pnum_clobbers);

    case 9:
      return recog_13 (x1, insn, pnum_clobbers);

    case 11:
      return recog_11 (x1, insn, pnum_clobbers);

    case 21:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern106 (x2))
        {
        case 0:
          if (!(
#line 5604 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_NEWABI) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 428; /* loadgp_newabi_si */

        case 1:
          if (!(
#line 5604 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_NEWABI) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 429; /* loadgp_newabi_di */

        case 2:
          if (!(
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_RTP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
            return -1;
          return 433; /* loadgp_rtp_si */

        case 3:
          if (!(
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_current_loadgp_style () == LOADGP_RTP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
            return -1;
          return 434; /* loadgp_rtp_di */

        default:
          return -1;
        }

    case 25:
      return recog_18 (x1, insn, pnum_clobbers);

    case 46:
      return recog_17 (x1, insn, pnum_clobbers);

    case 55:
      return recog_19 (x1, insn, pnum_clobbers);

    case 14:
      switch (pattern51 (x1))
        {
        case 0:
          if (!(
#line 8005 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 779; /* fminsf3 */

        case 1:
          if (!(
#line 8005 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 780; /* fmindf3 */

        default:
          return -1;
        }

    case 15:
      switch (pattern51 (x1))
        {
        case 0:
          if (!(
#line 8015 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 781; /* fmaxsf3 */

        case 1:
          if (!(
#line 8015 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 782; /* fmaxdf3 */

        default:
          return -1;
        }

    case 80:
      if (pattern52 (x1, 
E_V2SFmode) != 0
          || !
#line 356 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
        return -1;
      return 869; /* mips_addr_ps */

    case 83:
      if (pattern52 (x1, 
E_V2SFmode) != 0
          || !
#line 399 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D))
        return -1;
      return 872; /* mips_mulr_ps */

    case 86:
      switch (pattern54 (x1))
        {
        case 0:
          if (!(
#line 678 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 903; /* mips_rsqrt2_s */

        case 1:
          if (!(
#line 678 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 904; /* mips_rsqrt2_d */

        case 2:
          if (!(
#line 678 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 905; /* mips_rsqrt2_ps */

        default:
          return -1;
        }

    case 88:
      switch (pattern54 (x1))
        {
        case 0:
          if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 909; /* mips_recip2_s */

        case 1:
          if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 910; /* mips_recip2_d */

        case 2:
          if (!(
#line 697 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 911; /* mips_recip2_ps */

        default:
          return -1;
        }

    case 97:
      if (pattern55 (x1, 
E_SImode) != 0
          || !
#line 208 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 924; /* mips_modsub */

    case 100:
      if (pattern56 (x1, 
E_V2HImode, 
E_V4QImode) != 0
          || !
#line 241 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 928; /* mips_precrq_qb_ph */

    case 101:
      if (GET_MODE (x2) != E_V2HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 251 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 929; /* mips_precrq_ph_w */

    case 116:
      if (pattern57 (x1, 
E_V4QImode) != 0
          || !
#line 426 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 946; /* mips_shrl_qb */

    case 117:
      if (pattern57 (x1, 
E_V2HImode) != 0
          || !
#line 445 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 947; /* mips_shra_ph */

    case 118:
      return recog_16 (x1, insn, pnum_clobbers);

    case 144:
      if (pattern56 (x1, 
E_V4QImode, 
E_SImode) != 0
          || !
#line 831 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 978; /* mips_cmpgu_eq_qb */

    case 145:
      if (pattern56 (x1, 
E_V4QImode, 
E_SImode) != 0
          || !
#line 841 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 979; /* mips_cmpgu_lt_qb */

    case 146:
      if (pattern56 (x1, 
E_V4QImode, 
E_SImode) != 0
          || !
#line 851 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 980; /* mips_cmpgu_le_qb */

    case 148:
      if (pattern52 (x1, 
E_V2HImode) != 0
          || !
#line 874 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
        return -1;
      return 983; /* mips_packrl_ph */

    case 155:
      if (pattern57 (x1, 
E_DImode) != 0
          || !
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP && !TARGET_64BIT))
        return -1;
      return 990; /* mips_shilo */

    case 162:
      if (pattern58 (x1, 
E_V4QImode) != 0
          || !
#line 112 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1022; /* mips_adduh_qb */

    case 163:
      if (pattern58 (x1, 
E_V4QImode) != 0
          || !
#line 122 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1023; /* mips_adduh_r_qb */

    case 183:
      if (GET_MODE (x2) != E_V4QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_or_0_operand (operands[1], E_V2HImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!reg_or_0_operand (operands[2], E_V2HImode)
          || !
#line 304 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1037; /* mips_precr_qb_ph */

    case 187:
      if (pattern59 (x1, 
E_V4QImode) != 0
          || !
#line 359 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1041; /* mips_shra_qb */

    case 188:
      if (pattern59 (x1, 
E_V4QImode) != 0
          || !
#line 378 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1042; /* mips_shra_r_qb */

    case 189:
      if (pattern59 (x1, 
E_V2HImode) != 0
          || !
#line 396 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1043; /* mips_shrl_ph */

    case 192:
      if (pattern58 (x1, 
E_V4QImode) != 0
          || !
#line 438 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1046; /* mips_subuh_qb */

    case 193:
      if (pattern58 (x1, 
E_V4QImode) != 0
          || !
#line 448 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1047; /* mips_subuh_r_qb */

    case 194:
      if (pattern58 (x1, 
E_V2HImode) != 0
          || !
#line 458 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1048; /* mips_addqh_ph */

    case 195:
      if (pattern58 (x1, 
E_V2HImode) != 0
          || !
#line 468 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1049; /* mips_addqh_r_ph */

    case 196:
      if (pattern58 (x1, 
E_SImode) != 0
          || !
#line 478 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1050; /* mips_addqh_w */

    case 197:
      if (pattern58 (x1, 
E_SImode) != 0
          || !
#line 488 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1051; /* mips_addqh_r_w */

    case 198:
      if (pattern58 (x1, 
E_V2HImode) != 0
          || !
#line 498 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1052; /* mips_subqh_ph */

    case 199:
      if (pattern58 (x1, 
E_V2HImode) != 0
          || !
#line 508 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1053; /* mips_subqh_r_ph */

    case 200:
      if (pattern58 (x1, 
E_SImode) != 0
          || !
#line 518 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1054; /* mips_subqh_w */

    case 201:
      if (pattern58 (x1, 
E_SImode) != 0
          || !
#line 528 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
        return -1;
      return 1055; /* mips_subqh_r_w */

    case 225:
      if (pattern52 (x1, 
E_DImode) != 0
          || !
#line 198 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1140; /* loongson_paddd */

    case 208:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (pattern53 (x2, 
E_V4HImode) != 0
              || !
#line 281 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1164; /* loongson_pavgh */

        case E_V8QImode:
          if (pattern53 (x2, 
E_V8QImode) != 0
              || !
#line 281 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1165; /* loongson_pavgb */

        default:
          return -1;
        }

    case 209:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 291 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1166; /* loongson_pcmpeqw */

        case 1:
          if (!
#line 291 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1167; /* loongson_pcmpeqh */

        case 2:
          if (!
#line 291 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1168; /* loongson_pcmpeqb */

        default:
          return -1;
        }

    case 210:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 301 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1169; /* loongson_pcmpgtw */

        case 1:
          if (!
#line 301 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1170; /* loongson_pcmpgth */

        case 2:
          if (!
#line 301 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1171; /* loongson_pcmpgtb */

        default:
          return -1;
        }

    case 211:
      if (pattern55 (x1, 
E_V4HImode) != 0
          || !
#line 311 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1172; /* loongson_pextrh */

    case 214:
      if (pattern56 (x1, 
E_V4HImode, 
E_V2SImode) != 0
          || !
#line 393 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1178; /* loongson_pmaddhw */

    case 216:
      if (pattern52 (x1, 
E_V4HImode) != 0
          || !
#line 483 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1184; /* umulv4hi3_highpart */

    case 217:
      if (pattern52 (x1, 
E_V4HImode) != 0
          || !
#line 493 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1185; /* smulv4hi3_highpart */

    case 218:
      if (pattern56 (x1, 
E_V2SImode, 
E_DImode) != 0
          || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1187; /* loongson_pmuluw */

    case 219:
      if (pattern52 (x1, 
E_V8QImode) != 0
          || !
#line 522 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1188; /* loongson_pasubub */

    case 221:
      if (pattern56 (x1, 
E_V8QImode, 
E_V4HImode) != 0
          || !
#line 549 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1191; /* loongson_psadbh */

    case 222:
      if (pattern55 (x1, 
E_V4HImode) != 0
          || !
#line 559 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1192; /* loongson_pshufh */

    case 226:
      if (pattern52 (x1, 
E_DImode) != 0
          || !
#line 608 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1202; /* loongson_psubd */

    case 227:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1219; /* vec_shl_v2si */

        case 1:
          if (!
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1220; /* vec_shl_v4hi */

        case 2:
          if (!
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1221; /* vec_shl_v8qi */

        case 3:
          if (!
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1222; /* vec_shl_di */

        default:
          return -1;
        }

    case 228:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 837 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1223; /* vec_shr_v2si */

        case 1:
          if (!
#line 837 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1224; /* vec_shr_v4hi */

        case 2:
          if (!
#line 837 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1225; /* vec_shr_v8qi */

        case 3:
          if (!
#line 837 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1226; /* vec_shr_di */

        default:
          return -1;
        }

    case 229:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1368; /* msa_asub_s_d */

        case 1:
          if (!
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1369; /* msa_asub_s_w */

        case 2:
          if (!
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1370; /* msa_asub_s_h */

        case 3:
          if (!
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1371; /* msa_asub_s_b */

        default:
          return -1;
        }

    case 230:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 1055 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1372; /* msa_asub_u_d */

        case 1:
          if (!
#line 1055 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1373; /* msa_asub_u_w */

        case 2:
          if (!
#line 1055 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1374; /* msa_asub_u_h */

        case 3:
          if (!
#line 1055 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1375; /* msa_asub_u_b */

        default:
          return -1;
        }

    case 231:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1376; /* msa_ave_s_d */

        case 1:
          if (!
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1377; /* msa_ave_s_w */

        case 2:
          if (!
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1378; /* msa_ave_s_h */

        case 3:
          if (!
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1379; /* msa_ave_s_b */

        default:
          return -1;
        }

    case 232:
      switch (pattern62 (x1))
        {
        case 0:
          if (!
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1380; /* msa_ave_u_d */

        case 1:
          if (!
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1381; /* msa_ave_u_w */

        case 2:
          if (!
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1382; /* msa_ave_u_h */

        case 3:
          if (!
#line 1075 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1383; /* msa_ave_u_b */

        default:
          return -1;
        }

    case 233:
      return recog_39 (x1, insn, pnum_clobbers);

    case 234:
      return recog_38 (x1, insn, pnum_clobbers);

    case 235:
      return recog_37 (x1, insn, pnum_clobbers);

    case 236:
      return recog_36 (x1, insn, pnum_clobbers);

    case 241:
      return recog_35 (x1, insn, pnum_clobbers);

    case 242:
      return recog_20 (x1, insn, pnum_clobbers);

    case 243:
      return recog_34 (x1, insn, pnum_clobbers);

    case 244:
      return recog_32 (x1, insn, pnum_clobbers);

    case 249:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1570 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1484; /* msa_fcaf_d */

        case 1:
          if (!
#line 1570 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1485; /* msa_fcaf_w */

        default:
          return -1;
        }

    case 251:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1580 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1486; /* msa_fcune_d */

        case 1:
          if (!
#line 1580 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1487; /* msa_fcune_w */

        default:
          return -1;
        }

    case 262:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1506; /* msa_fsaf_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1517; /* msa_fsaf_w */

        default:
          return -1;
        }

    case 271:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1507; /* msa_fsun_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1518; /* msa_fsun_w */

        default:
          return -1;
        }

    case 267:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1508; /* msa_fsor_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1519; /* msa_fsor_w */

        default:
          return -1;
        }

    case 263:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1509; /* msa_fseq_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1520; /* msa_fseq_w */

        default:
          return -1;
        }

    case 266:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1510; /* msa_fsne_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1521; /* msa_fsne_w */

        default:
          return -1;
        }

    case 268:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1511; /* msa_fsueq_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1522; /* msa_fsueq_w */

        default:
          return -1;
        }

    case 272:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1512; /* msa_fsune_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1523; /* msa_fsune_w */

        default:
          return -1;
        }

    case 269:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1513; /* msa_fsule_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1524; /* msa_fsule_w */

        default:
          return -1;
        }

    case 270:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1514; /* msa_fsult_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1525; /* msa_fsult_w */

        default:
          return -1;
        }

    case 264:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1515; /* msa_fsle_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1526; /* msa_fsle_w */

        default:
          return -1;
        }

    case 265:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1516; /* msa_fslt_d */

        case 1:
          if (!
#line 1630 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1527; /* msa_fslt_w */

        default:
          return -1;
        }

    case 253:
      return recog_31 (x1, insn, pnum_clobbers);

    case 275:
      return recog_33 (x1, insn, pnum_clobbers);

    case 280:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 2331 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1634; /* msa_mul_q_w */

        case 1:
          if (!
#line 2331 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1635; /* msa_mul_q_h */

        default:
          return -1;
        }

    case 281:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 2341 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1636; /* msa_mulr_q_w */

        case 1:
          if (!
#line 2341 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1637; /* msa_mulr_q_h */

        default:
          return -1;
        }

    case 283:
      return recog_30 (x1, insn, pnum_clobbers);

    case 284:
      return recog_29 (x1, insn, pnum_clobbers);

    case 289:
      return recog_28 (x1, insn, pnum_clobbers);

    case 290:
      return recog_27 (x1, insn, pnum_clobbers);

    case 291:
      return recog_26 (x1, insn, pnum_clobbers);

    case 292:
      return recog_25 (x1, insn, pnum_clobbers);

    case 293:
      return recog_24 (x1, insn, pnum_clobbers);

    case 294:
      return recog_23 (x1, insn, pnum_clobbers);

    case 295:
      return recog_22 (x1, insn, pnum_clobbers);

    case 296:
      return recog_21 (x1, insn, pnum_clobbers);

    case 287:
      return recog_10 (x1, insn, pnum_clobbers);

    case 252:
      if (pattern56 (x1, 
E_V4SFmode, 
E_V8HImode) != 0
          || !
#line 2705 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1736; /* msa_fexdo_h */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !reg_or_0_operand (operands[1], E_DFmode)
              || !
#line 1708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1538; /* msa_fill_d_f */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !reg_or_0_operand (operands[1], E_SFmode)
              || !
#line 1708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1539; /* msa_fill_w_f */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !reg_or_0_operand (operands[1], E_DImode)
              || !
#line 1708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1540; /* msa_fill_d */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !reg_or_0_operand (operands[1], E_SImode)
              || !
#line 1708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1541; /* msa_fill_w */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !reg_or_0_operand (operands[1], E_HImode)
              || !
#line 1708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1542; /* msa_fill_h */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !reg_or_0_operand (operands[1], E_QImode)
              || !
#line 1708 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1543; /* msa_fill_b */

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern187 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1726; /* msa_splati_d_f */

        case E_V4SFmode:
          if (pattern188 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 2668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1727; /* msa_splati_w_f */

        case E_V2DImode:
          if (pattern187 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1728; /* msa_splati_d */

        case E_V4SImode:
          if (pattern188 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1729; /* msa_splati_w */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || GET_MODE (x4) != E_HImode
              || !register_operand (operands[1], E_V8HImode)
              || !const_uimm3_operand (operands[2], E_VOIDmode)
              || !
#line 2668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1730; /* msa_splati_h */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || GET_MODE (x4) != E_QImode
              || !register_operand (operands[1], E_V16QImode)
              || !const_uimm4_operand (operands[2], E_VOIDmode)
              || !
#line 2668 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1731; /* msa_splati_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (register_operand (operands[1], E_SImode)
          && arith_operand (operands[2], E_SImode))
        {
          if (
#line 5860 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 453; /* *lshrsi3 */
          if (
#line 5891 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return 462; /* *lshrsi3_mips16 */
        }
      if (!memory_operand (operands[1], E_SImode)
          || !immediate_operand (operands[2], E_SImode)
          || !
#line 5986 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
        return -1;
      return 468; /* *mips.md:5982 */

    case E_DImode:
      if (pattern20 (x3) != 0)
        return -1;
      if ((
#line 5860 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return 456; /* *lshrdi3 */
      if (!
#line 5950 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16))
        return -1;
      return 467; /* *lshrdi3_mips16 */

    case E_V2SImode:
      if (pattern21 (x3, 
E_V2SImode) != 0
          || !
#line 586 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1197; /* lshrv2si3 */

    case E_V4HImode:
      if (pattern21 (x3, 
E_V4HImode) != 0
          || !
#line 586 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1198; /* lshrv4hi3 */

    case E_V2DImode:
      if (pattern22 (x3, 
E_V2DImode) != 0
          || !
#line 897 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1326; /* vlshrv2di3 */

    case E_V4SImode:
      if (pattern22 (x3, 
E_V4SImode) != 0
          || !
#line 897 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1327; /* vlshrv4si3 */

    case E_V8HImode:
      if (pattern22 (x3, 
E_V8HImode) != 0
          || !
#line 897 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1328; /* vlshrv8hi3 */

    case E_V16QImode:
      if (pattern22 (x3, 
E_V16QImode) != 0
          || !
#line 897 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1329; /* vlshrv16qi3 */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern142 (x3, 
E_SImode))
            {
            case 0:
              if (
#line 6391 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
                return 564; /* *sleu_sisi */
              if (!
#line 6403 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
                return -1;
              return 572; /* *sleu_sisi_mips16 */

            case 1:
              if ((
#line 6391 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 566; /* *sleu_disi */
              if (!(
#line 6403 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 574; /* *sleu_disi_mips16 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern142 (x3, 
E_DImode))
            {
            case 0:
              if ((
#line 6391 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 568; /* *sleu_sidi */
              if (!(
#line 6403 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 576; /* *sleu_sidi_mips16 */

            case 1:
              if ((
#line 6391 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return 570; /* *sleu_didi */
              if (!(
#line 6403 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 578; /* *sleu_didi_mips16 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern12 (x3, 
E_V2DImode) != 0
              || !
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1446; /* msa_cle_u_d */

        case E_V4SImode:
          if (pattern12 (x3, 
E_V4SImode) != 0
              || !
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1451; /* msa_cle_u_w */

        case E_V8HImode:
          if (pattern12 (x3, 
E_V8HImode) != 0
              || !
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1456; /* msa_cle_u_h */

        case E_V16QImode:
          if (pattern12 (x3, 
E_V16QImode) != 0
              || !
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1461; /* msa_cle_u_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !
#line 6015 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_WSBH))
        return -1;
      return 471; /* bswaphi2 */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 6022 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_WSBH && ISA_HAS_ROR))
        return -1;
      return 472; /* bswapsi2 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 6033 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && ISA_HAS_WSBH))
        return -1;
      return 473; /* bswapdi2 */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case MULT:
      if (GET_MODE (x5) != E_SImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (!register_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      if (!register_operand (x7, E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case CLOBBER:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x6;
          operands[3] = x7;
          x10 = XEXP (x8, 0);
          operands[4] = x10;
          if (!scratch_operand (operands[4], E_SImode)
              || !
#line 1867 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MSAC))
            return -1;
          return 45; /* *msac */

        case SET:
          x11 = XEXP (x8, 1);
          if (GET_CODE (x11) != MINUS
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x11, 1);
          if (GET_CODE (x12) != MULT
              || GET_MODE (x12) != E_SImode
              || !muldiv_target_operand (operands[0], E_SImode))
            return -1;
          operands[1] = x6;
          operands[2] = x7;
          x10 = XEXP (x8, 0);
          operands[3] = x10;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[0]))
            return -1;
          x13 = XEXP (x11, 0);
          if (!rtx_equal_p (x13, operands[0]))
            return -1;
          x14 = XEXP (x12, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x12, 1);
          if (!rtx_equal_p (x15, operands[2])
              || !
#line 1930 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MSAC && reload_completed))
            return -1;
          return 48; /* *msac2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x5;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x11 = XEXP (x8, 1);
      switch (GET_CODE (x11))
        {
        case UNSPEC_VOLATILE:
          if (XVECLEN (x11, 0) != 1
              || XINT (x11, 1) != 67)
            return -1;
          x16 = XVECEXP (x11, 0, 0);
          if (GET_CODE (x16) != MINUS)
            return -1;
          x17 = XEXP (x16, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x18 = XEXP (x16, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern254 (x1, 
E_SImode) != 0
                  || !
#line 429 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 823; /* sync_new_subsi */

            case E_DImode:
              if (pattern254 (x1, 
E_DImode) != 0
                  || !(
#line 429 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 824; /* sync_new_subdi */

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern130 (x8, 
185, 
93, 
2) != 0)
            return -1;
          x16 = XVECEXP (x11, 0, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          x19 = XVECEXP (x11, 0, 1);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2HImode:
              if (pattern92 (x4, 
E_V2HImode) != 0
                  || !
#line 158 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 917; /* subv2hi3 */

            case E_V4QImode:
              if (pattern92 (x4, 
E_V4QImode) != 0
                  || !
#line 158 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                return -1;
              return 918; /* subv4qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[1])
          || !
#line 7723 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(operands[1] == stack_pointer_rtx
   && mips16e_save_restore_pattern_p (operands[0], INTVAL (operands[2]), NULL)))
        return -1;
      return 754; /* *mips16e_save_restore */

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x4;
      if (register_operand (operands[2], E_SImode)
          && memory_operand (operands[1], E_SImode)
          && 
#line 24 "../../gcc-15.0.1-20250313/gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_save_restore_pattern_p (true, operands[0])))
        return 1119; /* *store_word_multiple */
      if (!memory_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_SImode)
          || !
#line 35 "../../gcc-15.0.1-20250313/gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_save_restore_pattern_p (false, operands[0])))
        return -1;
      return 1120; /* *load_word_multiple */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && got_disp_operand (operands[1], E_SImode)
          && ((
#line 4747 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_p[SYMBOL_GOT_DISP]) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
        return gen_split_44 (insn, operands);
      break;

    case E_DImode:
      if (register_operand (operands[0], E_DImode)
          && got_disp_operand (operands[1], E_DImode)
          && ((
#line 4747 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_EXPLICIT_RELOCS && !mips_split_p[SYMBOL_GOT_DISP]) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 4749 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
        return gen_split_45 (insn, operands);
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != CONST)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 28)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!d_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !
#line 4825 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && TARGET_USE_GOT && reload_completed))
        return NULL;
      return gen_split_48 (insn, operands);

    case E_DImode:
      if (!d_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !(
#line 4825 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && TARGET_USE_GOT && reload_completed) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return NULL;
      return gen_split_49 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LSHIFTRT)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MULT)
    return NULL;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != CONST_INT)
    return NULL;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return NULL;
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XEXP (x5, 0);
  switch (GET_CODE (x9))
    {
    case SIGN_EXTEND:
      switch (pattern216 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!(
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MULT && !ISA_HAS_MULHI && !TARGET_MIPS16) && 
#line 2331 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && !TARGET_FIX_R4000)))
            return NULL;
          return gen_split_11 (insn, operands);

        case 1:
          if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_MIPS16
   && !(SIGN_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)) && 
#line 2447 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && !TARGET_FIX_R4000)))
            return NULL;
          return gen_split_13 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern216 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!(
#line 2329 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MULT && !ISA_HAS_MULHI && !TARGET_MIPS16) && 
#line 2331 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && !TARGET_FIX_R4000)))
            return NULL;
          return gen_split_12 (insn, operands);

        case 1:
          if (!(
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DMULT
   && !TARGET_MIPS16
   && !(ZERO_EXTEND == ZERO_EXTEND && TARGET_FIX_VR4120)) && 
#line 2447 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed && !TARGET_FIX_R4000)))
            return NULL;
          return gen_split_14 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      res = split_3 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case PARALLEL:
      res = split_7 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  operands[0] = x1;
  if (small_data_pattern (operands[0], E_VOIDmode)
      && 
#line 7706 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed))
    return gen_split_97 (insn, operands);
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (pattern15 (x2, 
34, 
1) != 0
              || pattern134 (x1) != 0)
            return NULL;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          switch (pattern217 (x1))
            {
            case 0:
              if (!((
#line 7748 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(HAVE_AS_TLS && !TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_98 (insn, operands);

            case 1:
              if (!((
#line 7748 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(HAVE_AS_TLS && !TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_99 (insn, operands);

            default:
              return NULL;
            }

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != UNSPEC
              || pattern98 (x1) != 0)
            return NULL;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          switch (pattern253 (x1))
            {
            case 0:
              if (!((
#line 7793 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 7795 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_100 (insn, operands);

            case 1:
              if (!((
#line 7793 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(HAVE_AS_TLS && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 7795 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return NULL;
              return gen_split_101 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SET:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x1, 1);
      switch (GET_CODE (x6))
        {
        case UNSPEC:
          if (XVECLEN (x6, 0) != 5)
            return NULL;
          switch (pattern78 (x6))
            {
            case 0:
              if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
( reload_completed)))
                return NULL;
              return gen_split_102 (insn, operands);

            case 1:
              if (!(
#line 486 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
(TARGET_HARD_FLOAT && TARGET_MIPS3D) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-ps-3d.md"
( reload_completed)))
                return NULL;
              return gen_split_103 (insn, operands);

            default:
              return NULL;
            }

        case VEC_SELECT:
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != PARALLEL
              || XVECLEN (x7, 0) != 1)
            return NULL;
          x8 = XVECEXP (x7, 0, 0);
          if (GET_CODE (x8) != CONST_INT)
            return NULL;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          if (XWINT (x8, 0) == 0L)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_DFmode:
                  if (register_operand (operands[0], E_DFmode)
                      && GET_MODE (x6) == E_DFmode
                      && register_operand (operands[1], E_V2DFmode)
                      && (
#line 369 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA) && 
#line 371 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
( reload_completed)))
                    return gen_split_104 (insn, operands);
                  break;

                case E_SFmode:
                  if (register_operand (operands[0], E_SFmode)
                      && GET_MODE (x6) == E_SFmode
                      && register_operand (operands[1], E_V4SFmode)
                      && (
#line 369 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA) && 
#line 371 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
( reload_completed)))
                    return gen_split_105 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          operands[2] = x8;
          if (!const_0_or_1_operand (operands[2], E_VOIDmode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x6) != E_DImode
                  || !register_operand (operands[1], E_V2DImode)
                  || !
#line 595 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_108 (insn, operands);

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x6) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 595 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_109 (insn, operands);

            default:
              return NULL;
            }

        case VEC_MERGE:
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != VEC_DUPLICATE)
            return NULL;
          x10 = XEXP (x9, 0);
          operands[1] = x10;
          x7 = XEXP (x6, 1);
          operands[2] = x7;
          x11 = XEXP (x6, 2);
          operands[3] = x11;
          if (!const_exp_2_operand (operands[3], E_VOIDmode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern186 (x6, 
E_DImode, 
E_V2DImode) != 0
                  || !register_operand (operands[2], E_V2DImode)
                  || !
#line 504 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_106 (insn, operands);

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x6) != E_V2DFmode
                  || GET_MODE (x9) != E_V2DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !register_operand (operands[2], E_V2DFmode)
                  || !
#line 504 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_107 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (!nonimmediate_operand (operands[0], E_V2DFmode)
                  || !move_operand (operands[1], E_V2DFmode)
                  || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_110 (insn, operands);

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[0], E_V4SFmode)
                  || !move_operand (operands[1], E_V4SFmode)
                  || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_111 (insn, operands);

            case E_V2DImode:
              if (!nonimmediate_operand (operands[0], E_V2DImode)
                  || !move_operand (operands[1], E_V2DImode)
                  || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_112 (insn, operands);

            case E_V4SImode:
              if (!nonimmediate_operand (operands[0], E_V4SImode)
                  || !move_operand (operands[1], E_V4SImode)
                  || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_113 (insn, operands);

            case E_V8HImode:
              if (!nonimmediate_operand (operands[0], E_V8HImode)
                  || !move_operand (operands[1], E_V8HImode)
                  || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_114 (insn, operands);

            case E_V16QImode:
              if (!nonimmediate_operand (operands[0], E_V16QImode)
                  || !move_operand (operands[1], E_V16QImode)
                  || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA
   && mips_split_move_insn_p (operands[0], operands[1], insn)))
                return NULL;
              return gen_split_115 (insn, operands);

            default:
              return NULL;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x6) != E_V2DImode
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 1725 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_116 (insn, operands);

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x6) != E_V2DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 1725 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(reload_completed && ISA_HAS_MSA && !TARGET_64BIT))
                return NULL;
              return gen_split_117 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
