/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_CCmode:
      return pattern5 (x3, 
E_CCmode); /* [-1, 1] */

    case E_CCEmode:
      res = pattern5 (x3, 
E_CCEmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_CCFmode:
      res = pattern5 (x3, 
E_CCFmode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case E_V2DImode:
      if (pattern6 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern6 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !reg_or_vector_same_uimm6_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern30 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern37 (x1, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern37 (x1, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern37 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern53 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern53 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern53 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !const_uimm6_operand (operands[2], E_VOIDmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !const_uimm5_operand (operands[2], E_VOIDmode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !const_uimm4_operand (operands[2], E_VOIDmode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !const_uimm3_operand (operands[2], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  return pattern82 (x2, 
i1); /* [-1, 0] */
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x6, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x10, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern95 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern95 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern105 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !symbol_ref_operand (operands[1], i1)
      || !symbol_ref_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern118 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern118 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 3)
    return -1;
  return 0;
}

int
pattern143 (rtx x1, machine_mode i1, unsigned int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != i4
      || XINT (x5, 1) != i3
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != i2
      || GET_MODE (x6) != E_CCDSPmode
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern154 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case LABEL_REF:
      x3 = XEXP (x1, 2);
      if (GET_CODE (x3) != PC)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      return pattern159 (); /* [-1, 1] */

    case PC:
      x3 = XEXP (x1, 2);
      if (GET_CODE (x3) != LABEL_REF)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      res = pattern159 ();
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[3], i3))
    return -1;
  x8 = XEXP (x2, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i2)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x8, 1);
  if (GET_MODE (x11) != i2)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != i1)
    return -1;
  return 0;
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_CCV4mode:
      if (!register_operand (operands[1], E_CCV4mode))
        return -1;
      return 0;

    case E_CCV2mode:
      if (!register_operand (operands[1], E_CCV2mode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || !register_operand (operands[1], E_DImode)
      || !arith_operand (operands[2], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x3, operands[2]))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != E_CCDSPmode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern197 (x3, 
i1); /* [-1, 0] */
}

int
pattern205 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
      if (XWINT (x7, 0) != 1L
          || !const_call_insn_operand (operands[1], E_VOIDmode))
        return -1;
      return 0;

    case SET:
      if (pattern219 (x7) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CCFmode
      || !register_operand (operands[1], E_CCFmode)
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1, int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XVECLEN (x5, 0) != 3
      || XINT (x5, 1) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (REGNO (x6) != 185
      || !register_operand (operands[0], E_DImode)
      || !register_operand (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || pattern241 (x1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern252 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !call_insn_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern259 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || !register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  return pattern193 (x3, 
i1, 
E_SImode); /* [-1, 0] */
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode
      || GET_MODE (x3) != E_QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (SUBREG_BYTE (x3))
    {
    case 3:
      if (!
#line 1474 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_BADDU && BYTES_BIG_ENDIAN))
        return -1;
      return 19; /* *baddu_si_eb */

    case 0:
      if (!
#line 1484 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_BADDU && !BYTES_BIG_ENDIAN))
        return -1;
      return 20; /* *baddu_si_el */

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  if (call_insn_operand (operands[0], E_SImode)
      && (
#line 7853 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
    {
      *pnum_clobbers = 2;
      return 764; /* mips_get_fcsr_mips16_si */
    }
  if (!call_insn_operand (operands[0], E_DImode)
      || !(
#line 7853 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT_ABI && TARGET_MIPS16) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
    return -1;
  *pnum_clobbers = 2;
  return 765; /* mips_get_fcsr_mips16_di */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      switch (pattern147 (x3))
        {
        case 0:
          if (!(
#line 5561 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 891 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 407; /* store_worddf */

        case 1:
          if (!(
#line 5561 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 892 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 408; /* store_worddi */

        case 2:
          if (!(
#line 5561 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 893 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_PAIRED_SINGLE_FLOAT)))
            return -1;
          return 409; /* store_wordv2sf */

        case 3:
          if (!(
#line 5561 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 894 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 410; /* store_wordv2si */

        case 4:
          if (!(
#line 5561 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 895 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 411; /* store_wordv4hi */

        case 5:
          if (!(
#line 5561 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 896 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT && TARGET_LOONGSON_MMI)))
            return -1;
          return 412; /* store_wordv8qi */

        default:
          return -1;
        }

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_TFmode)
          || !(
#line 5561 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT) && 
#line 897 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_FLOAT64)))
        return -1;
      return 413; /* store_wordtf */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 2585 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1688; /* msa_srlri_d */

    case 1:
      if (!
#line 2585 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1689; /* msa_srlri_w */

    case 2:
      if (!
#line 2585 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1690; /* msa_srlri_h */

    case 3:
      if (!
#line 2585 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1691; /* msa_srlri_b */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 1230 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1436; /* msa_bset_d */

    case 1:
      if (!
#line 1230 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1437; /* msa_bset_w */

    case 2:
      if (!
#line 1230 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1438; /* msa_bset_h */

    case 3:
      if (!
#line 1230 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1439; /* msa_bset_b */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode)
          || !
#line 4477 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_use_ins_ext_p (operands[0], INTVAL (operands[1]),
		       INTVAL (operands[2]))))
        return -1;
      return 282; /* *insvsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode)
          || !(
#line 4477 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_use_ins_ext_p (operands[0], INTVAL (operands[1]),
		       INTVAL (operands[2]))) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return -1;
      return 283; /* *insvdi */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_49 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  operands[1] = x3;
  if (!equality_operator (operands[1], E_VOIDmode))
    return -1;
  operands[3] = x4;
  switch (pattern160 (x2))
    {
    case 0:
      if (
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
        return 487; /* *branch_equalitysi */
      break;

    case 1:
      if ((
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return 488; /* *branch_equalitydi */
      break;

    case 2:
      if (
#line 6157 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
        return 489; /* *branch_equalitysi_inverted */
      break;

    case 3:
      if ((
#line 6157 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
        return 490; /* *branch_equalitydi_inverted */
      break;

    default:
      break;
    }
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !
#line 6173 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 491; /* *branch_equalitysi_mips16 */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6173 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 492; /* *branch_equalitydi_mips16 */

        default:
          return -1;
        }

    case PC:
      x8 = XEXP (x2, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      switch (GET_MODE (operands[2]))
        {
        case E_SImode:
          if (!register_operand (operands[2], E_SImode)
              || !
#line 6187 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 493; /* *branch_equalitysi_mips16_inverted */

        case E_DImode:
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6187 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 494; /* *branch_equalitydi_mips16_inverted */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern0 (x3, 
E_SFmode) != 0
              || !
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 10; /* addsf3 */

        case E_DFmode:
          if (pattern0 (x3, 
E_DFmode) != 0
              || !
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))
            return -1;
          return 11; /* adddf3 */

        case E_V2SFmode:
          if (pattern0 (x3, 
E_V2SFmode) != 0
              || !
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT))
            return -1;
          return 12; /* addv2sf3 */

        case E_SImode:
          if (pattern19 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 13; /* *addsi3 */
          if (!
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 15; /* *addsi3_mips16 */

        case E_DImode:
          if (pattern19 (x3, 
E_DImode) != 0)
            return -1;
          if ((
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 14; /* *adddi3 */
          if (!(
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 16; /* *adddi3_mips16 */

        case E_QQmode:
          if (pattern0 (x3, 
E_QQmode) != 0)
            return -1;
          return 1062; /* addqq3 */

        case E_HQmode:
          if (pattern0 (x3, 
E_HQmode) != 0)
            return -1;
          return 1063; /* addhq3 */

        case E_SQmode:
          if (pattern0 (x3, 
E_SQmode) != 0)
            return -1;
          return 1064; /* addsq3 */

        case E_DQmode:
          if (pattern0 (x3, 
E_DQmode) != 0
              || !
#line 22 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
            return -1;
          return 1065; /* adddq3 */

        case E_UQQmode:
          if (pattern0 (x3, 
E_UQQmode) != 0)
            return -1;
          return 1066; /* adduqq3 */

        case E_UHQmode:
          if (pattern0 (x3, 
E_UHQmode) != 0)
            return -1;
          return 1067; /* adduhq3 */

        case E_USQmode:
          if (pattern0 (x3, 
E_USQmode) != 0)
            return -1;
          return 1068; /* addusq3 */

        case E_UDQmode:
          if (pattern0 (x3, 
E_UDQmode) != 0
              || !
#line 23 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
            return -1;
          return 1069; /* addudq3 */

        case E_HAmode:
          if (pattern0 (x3, 
E_HAmode) != 0)
            return -1;
          return 1070; /* addha3 */

        case E_SAmode:
          if (pattern0 (x3, 
E_SAmode) != 0)
            return -1;
          return 1071; /* addsa3 */

        case E_DAmode:
          if (pattern0 (x3, 
E_DAmode) != 0
              || !
#line 24 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
            return -1;
          return 1072; /* addda3 */

        case E_UHAmode:
          if (pattern0 (x3, 
E_UHAmode) != 0)
            return -1;
          return 1073; /* adduha3 */

        case E_USAmode:
          if (pattern0 (x3, 
E_USAmode) != 0)
            return -1;
          return 1074; /* addusa3 */

        case E_UDAmode:
          if (pattern0 (x3, 
E_UDAmode) != 0
              || !
#line 25 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-fixed.md"
(TARGET_64BIT))
            return -1;
          return 1075; /* adduda3 */

        case E_V2SImode:
          if (pattern0 (x3, 
E_V2SImode) != 0
              || !
#line 183 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1137; /* addv2si3 */

        case E_V4HImode:
          if (pattern0 (x3, 
E_V4HImode) != 0
              || !
#line 183 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1138; /* addv4hi3 */

        case E_V8QImode:
          if (pattern0 (x3, 
E_V8QImode) != 0
              || !
#line 183 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1139; /* addv8qi3 */

        case E_V2DImode:
          if (pattern136 (x3, 
E_V2DImode) != 0
              || !
#line 730 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1274; /* addv2di3 */

        case E_V4SImode:
          if (pattern136 (x3, 
E_V4SImode) != 0
              || !
#line 730 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1275; /* addv4si3 */

        case E_V8HImode:
          if (pattern136 (x3, 
E_V8HImode) != 0
              || !
#line 730 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1276; /* addv8hi3 */

        case E_V16QImode:
          if (pattern136 (x3, 
E_V16QImode) != 0
              || !
#line 730 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1277; /* addv16qi3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 942 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1338; /* addv2df3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !
#line 942 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1339; /* addv4sf3 */

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              if (pnum_clobbers != NULL)
                {
                  x5 = XEXP (x3, 1);
                  operands[3] = x5;
                  if (register_operand (operands[3], E_SImode))
                    {
                      if (
#line 1785 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(GENERATE_MADD_MSUB && !TARGET_MIPS16))
                        {
                          *pnum_clobbers = 2;
                          return 42; /* *mul_acc_si */
                        }
                      if (
#line 1808 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS3900 && !TARGET_MIPS16))
                        {
                          *pnum_clobbers = 2;
                          return 43; /* *mul_acc_si_r3900 */
                        }
                      if (
#line 1845 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MACC))
                        {
                          *pnum_clobbers = 1;
                          return 44; /* *macc */
                        }
                    }
                }
              x5 = XEXP (x3, 1);
              if (!rtx_equal_p (x5, operands[0])
                  || !
#line 2538 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MAD))
                return -1;
              return 81; /* madsi */

            case E_SFmode:
              if (pattern144 (x3, 
E_SFmode) != 0
                  || !(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 111; /* *madd4sf */

            case E_DFmode:
              if (pattern144 (x3, 
E_DFmode) != 0
                  || !(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 882 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 112; /* *madd4df */

            case E_V2SFmode:
              if (pattern144 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2724 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_UNFUSED_MADD4) && 
#line 883 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_PAIRED_SINGLE_FLOAT)))
                return -1;
              return 113; /* *madd4v2sf */

            case E_V2DImode:
              if (pattern144 (x3, 
E_V2DImode) != 0
                  || !
#line 780 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1286; /* msa_maddv_d */

            case E_V4SImode:
              if (pattern144 (x3, 
E_V4SImode) != 0
                  || !
#line 780 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1287; /* msa_maddv_w */

            case E_V8HImode:
              if (pattern144 (x3, 
E_V8HImode) != 0
                  || !
#line 780 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1288; /* msa_maddv_h */

            case E_V16QImode:
              if (pattern144 (x3, 
E_V16QImode) != 0
                  || !
#line 780 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1289; /* msa_maddv_b */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern100 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 2552 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
((TARGET_MAD || ISA_HAS_MACC || GENERATE_MADD_MSUB || ISA_HAS_DSP)
   && !TARGET_64BIT))
                return -1;
              return 82; /* maddsidi4 */

            case 1:
              if (!
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1464; /* msa_dotp_s_d */

            case 2:
              if (!
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1466; /* msa_dotp_s_w */

            case 3:
              if (!
#line 1363 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1468; /* msa_dotp_s_h */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern100 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 2552 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
((TARGET_MAD || ISA_HAS_MACC || GENERATE_MADD_MSUB || ISA_HAS_DSP)
   && !TARGET_64BIT))
                return -1;
              return 83; /* umaddsidi4 */

            case 1:
              if (!
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1465; /* msa_dotp_u_d */

            case 2:
              if (!
#line 1327 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1467; /* msa_dotp_u_w */

            case 3:
              if (!
#line 1363 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1469; /* msa_dotp_u_h */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!const_immlsa_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern168 (x3, 
E_SImode) != 0
              || !
#line 5908 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LSA))
            return -1;
          return 463; /* lsa */

        case E_DImode:
          if (pattern168 (x3, 
E_DImode) != 0
              || !(
#line 5908 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DLSA) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 464; /* dlsa */

        default:
          return -1;
        }

    case ABS:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1352; /* msa_add_a_d */

        case 1:
          if (!
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1353; /* msa_add_a_w */

        case 2:
          if (!
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1354; /* msa_add_a_h */

        case 3:
          if (!
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1355; /* msa_add_a_b */

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != MULT)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != MULT)
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          switch (pattern146 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 1389 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1470; /* msa_dpadd_s_d */

            case 1:
              if (!
#line 1419 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1472; /* msa_dpadd_s_w */

            case 2:
              if (!
#line 1457 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1474; /* msa_dpadd_s_h */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern146 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 1389 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1471; /* msa_dpadd_u_d */

            case 1:
              if (!
#line 1419 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1473; /* msa_dpadd_u_w */

            case 2:
              if (!
#line 1457 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1475; /* msa_dpadd_u_h */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (!
#line 1887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1570; /* msa_hadd_s_h */

        case 1:
          if (!
#line 1905 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1574; /* msa_hadd_s_w */

        case 2:
          if (!
#line 1921 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1578; /* msa_hadd_s_d */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (!
#line 1887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1571; /* msa_hadd_u_h */

        case 1:
          if (!
#line 1905 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1575; /* msa_hadd_u_w */

        case 2:
          if (!
#line 1921 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1579; /* msa_hadd_u_d */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          if (uns_arith_operand (operands[2], E_SImode))
            {
              if (
#line 3432 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
                return 189; /* *iorsi3 */
              if (
#line 3445 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MIPS16E2))
                return 191; /* *iorsi3_mips16_asmacro */
            }
          if (!register_operand (operands[2], E_SImode)
              || !
#line 3457 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_MIPS16E2))
            return -1;
          return 192; /* *iorsi3_mips16 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (uns_arith_operand (operands[2], E_DImode)
              && (
#line 3432 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 190; /* *iordi3 */
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 3457 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_MIPS16E2) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 193; /* *iordi3_mips16 */

        case E_V2SImode:
          if (pattern0 (x3, 
E_V2SImode) != 0
              || !
#line 244 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1152; /* iorv2si3 */

        case E_V4HImode:
          if (pattern0 (x3, 
E_V4HImode) != 0
              || !
#line 244 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1153; /* iorv4hi3 */

        case E_V8QImode:
          if (pattern0 (x3, 
E_V8QImode) != 0
              || !
#line 244 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1154; /* iorv8qi3 */

        case E_V2DImode:
          if (pattern117 (x3, 
E_V2DImode) != 0
              || !
#line 849 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1314; /* iorv2di3 */

        case E_V4SImode:
          if (pattern117 (x3, 
E_V4SImode) != 0
              || !
#line 849 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1315; /* iorv4si3 */

        case E_V8HImode:
          if (pattern117 (x3, 
E_V8HImode) != 0
              || !
#line 849 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1316; /* iorv8hi3 */

        case E_V16QImode:
          if (pattern117 (x3, 
E_V16QImode) != 0
              || !
#line 849 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1317; /* iorv16qi3 */

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != AND)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != NOT)
            return -1;
          x8 = XEXP (x4, 1);
          operands[3] = x8;
          x9 = XEXP (x5, 1);
          operands[1] = x9;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern224 (x3, 
E_V2DImode) != 0
                  || !
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1416; /* msa_bmnz_d */

            case E_V4SImode:
              if (pattern224 (x3, 
E_V4SImode) != 0
                  || !
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1417; /* msa_bmnz_w */

            case E_V8HImode:
              if (pattern224 (x3, 
E_V8HImode) != 0
                  || !
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1418; /* msa_bmnz_h */

            case E_V16QImode:
              if (pattern224 (x3, 
E_V16QImode) != 0
                  || !
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1419; /* msa_bmnz_b */

            default:
              return -1;
            }

        case NOT:
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DImode:
              if (pattern156 (x3, 
E_V2DImode) != 0)
                return -1;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              if (reg_or_vector_same_val_operand (operands[3], E_V2DImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_V2DImode))
                    {
                      x9 = XEXP (x5, 1);
                      if (rtx_equal_p (x9, operands[3])
                          && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return 1420; /* msa_bmz_d */
                    }
                }
              operands[1] = x11;
              if (!register_operand (operands[1], E_V2DImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!reg_or_vector_same_val_operand (operands[3], E_V2DImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[1])
                  || !
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1432; /* msa_bsel_d */

            case E_V4SImode:
              if (pattern156 (x3, 
E_V4SImode) != 0)
                return -1;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              if (reg_or_vector_same_val_operand (operands[3], E_V4SImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_V4SImode))
                    {
                      x9 = XEXP (x5, 1);
                      if (rtx_equal_p (x9, operands[3])
                          && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return 1421; /* msa_bmz_w */
                    }
                }
              operands[1] = x11;
              if (!register_operand (operands[1], E_V4SImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!reg_or_vector_same_val_operand (operands[3], E_V4SImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[1])
                  || !
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1433; /* msa_bsel_w */

            case E_V8HImode:
              if (pattern156 (x3, 
E_V8HImode) != 0)
                return -1;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              if (reg_or_vector_same_val_operand (operands[3], E_V8HImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_V8HImode))
                    {
                      x9 = XEXP (x5, 1);
                      if (rtx_equal_p (x9, operands[3])
                          && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return 1422; /* msa_bmz_h */
                    }
                }
              operands[1] = x11;
              if (!register_operand (operands[1], E_V8HImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!reg_or_vector_same_val_operand (operands[3], E_V8HImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[1])
                  || !
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1434; /* msa_bsel_h */

            case E_V16QImode:
              if (pattern156 (x3, 
E_V16QImode) != 0)
                return -1;
              x11 = XEXP (x6, 0);
              operands[3] = x11;
              if (reg_or_vector_same_val_operand (operands[3], E_V16QImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (register_operand (operands[1], E_V16QImode))
                    {
                      x9 = XEXP (x5, 1);
                      if (rtx_equal_p (x9, operands[3])
                          && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                        return 1423; /* msa_bmz_b */
                    }
                }
              operands[1] = x11;
              if (!register_operand (operands[1], E_V16QImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!reg_or_vector_same_val_operand (operands[3], E_V16QImode))
                return -1;
              x7 = XEXP (x5, 0);
              if (!rtx_equal_p (x7, operands[1])
                  || !
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1435; /* msa_bsel_b */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) == 0L)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern109 (x3, 
E_SImode))
                {
                case 0:
                  if (
#line 6292 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE))
                    return 503; /* *seq_zero_sisi */
                  if (
#line 6301 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_SEQ_SNE))
                    return 507; /* *seq_zero_sisi_mips16 */
                  break;

                case 1:
                  if ((
#line 6292 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 504; /* *seq_zero_disi */
                  if ((
#line 6301 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 508; /* *seq_zero_disi_mips16 */
                  break;

                default:
                  break;
                }
              break;

            case E_DImode:
              switch (pattern109 (x3, 
E_DImode))
                {
                case 0:
                  if ((
#line 6292 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 505; /* *seq_zero_sidi */
                  if ((
#line 6301 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 509; /* *seq_zero_sidi_mips16 */
                  break;

                case 1:
                  if ((
#line 6292 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 506; /* *seq_zero_didi */
                  if ((
#line 6301 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16 && !ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return 510; /* *seq_zero_didi_mips16 */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      break;

    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_CCmode:
          switch (pattern5 (x3, 
E_CCmode))
            {
            case 0:
              if (((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 583; /* seq_sf_using_cc */
              break;

            case 1:
              if (((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 590; /* seq_df_using_cc */
              break;

            default:
              break;
            }
          break;

        case E_CCEmode:
          switch (pattern5 (x3, 
E_CCEmode))
            {
            case 0:
              if (((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 597; /* seq_sf_using_cce */
              break;

            case 1:
              if (((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 604; /* seq_df_using_cce */
              break;

            default:
              break;
            }
          break;

        case E_CCFmode:
          switch (pattern5 (x3, 
E_CCFmode))
            {
            case 0:
              if (((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
                return 611; /* seq_sf_using_ccf */
              break;

            case 1:
              if (((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
                return 621; /* seq_df_using_ccf */
              break;

            default:
              break;
            }
          break;

        case E_V2DImode:
          switch (pattern122 (x3))
            {
            case 0:
              if (
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return 1444; /* msa_ceq_d */
              break;

            case 1:
              if (
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return 1490; /* msa_fceq_d */
              break;

            default:
              break;
            }
          break;

        case E_V4SImode:
          switch (pattern123 (x3))
            {
            case 0:
              if (
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return 1449; /* msa_ceq_w */
              break;

            case 1:
              if (
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return 1499; /* msa_fceq_w */
              break;

            default:
              break;
            }
          break;

        case E_V8HImode:
          if (pattern10 (x3, 
E_V8HImode) == 0
              && 
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return 1454; /* msa_ceq_h */
          break;

        case E_V16QImode:
          if (pattern10 (x3, 
E_V16QImode) == 0
              && 
#line 1273 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return 1459; /* msa_ceq_b */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern120 (x3, 
E_SImode))
        {
        case 0:
          if (!
#line 6311 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE))
            return -1;
          return 511; /* *seq_sisi_seq */

        case 1:
          if (!(
#line 6311 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 512; /* *seq_disi_seq */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern120 (x3, 
E_DImode))
        {
        case 0:
          if (!(
#line 6311 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 513; /* *seq_sidi_seq */

        case 1:
          if (!(
#line 6311 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SEQ_SNE) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 514; /* *seq_didi_seq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern109 (x3, 
E_SImode))
        {
        case 0:
          if (reg_or_0_operand (operands[2], E_SImode)
              && 
#line 6345 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 524; /* *sgtu_sisi */
          if (!register_operand (operands[2], E_SImode)
              || !
#line 6354 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 532; /* *sgtu_sisi_mips16 */

        case 1:
          if (reg_or_0_operand (operands[2], E_DImode)
              && (
#line 6345 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 526; /* *sgtu_disi */
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6354 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 534; /* *sgtu_disi_mips16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern109 (x3, 
E_DImode))
        {
        case 0:
          if (reg_or_0_operand (operands[2], E_SImode)
              && (
#line 6345 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 528; /* *sgtu_sidi */
          if (!register_operand (operands[2], E_SImode)
              || !(
#line 6354 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 536; /* *sgtu_sidi_mips16 */

        case 1:
          if (reg_or_0_operand (operands[2], E_DImode)
              && (
#line 6345 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 530; /* *sgtu_didi */
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6354 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 538; /* *sgtu_didi_mips16 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case MULT:
      if (GET_MODE (x5) != E_SImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x8))
        {
        case CLOBBER:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[4] = x10;
          if (!scratch_operand (operands[4], E_SImode)
              || !
#line 1845 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MACC))
            return -1;
          return 44; /* *macc */

        case SET:
          x11 = XEXP (x8, 1);
          if (GET_CODE (x11) != PLUS
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != MULT
              || GET_MODE (x12) != E_SImode
              || !muldiv_target_operand (operands[0], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[3] = x10;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (!rtx_equal_p (x9, operands[0]))
            return -1;
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x14 = XEXP (x12, 1);
          if (!rtx_equal_p (x14, operands[2]))
            return -1;
          x15 = XEXP (x11, 1);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MACC && reload_completed))
            return -1;
          return 47; /* *macc2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      x11 = XEXP (x8, 1);
      switch (GET_CODE (x11))
        {
        case UNSPEC_VOLATILE:
          if (pattern166 (x11, 
E_DImode) != 0
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !memory_operand (operands[1], E_DImode)
              || pattern258 (x8, 
E_DImode) != 0
              || !(
#line 413 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 822; /* sync_new_adddi */

        case UNSPEC:
          if (XVECLEN (x11, 0) != 2)
            return -1;
          x10 = XEXP (x8, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 185
              || GET_MODE (x10) != E_CCDSPmode
              || GET_MODE (x11) != E_CCDSPmode)
            return -1;
          x16 = XVECEXP (x11, 0, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          x17 = XVECEXP (x11, 0, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (XINT (x11, 1))
            {
            case 91:
              switch (GET_MODE (operands[0]))
                {
                case E_V2HImode:
                  if (pattern92 (x4, 
E_V2HImode) != 0
                      || !
#line 134 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                    return -1;
                  return 912; /* addv2hi3 */

                case E_V4QImode:
                  if (pattern92 (x4, 
E_V4QImode) != 0
                      || !
#line 134 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_DSP))
                    return -1;
                  return 913; /* addv4qi3 */

                default:
                  return -1;
                }

            case 160:
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x4) != E_V2HImode
                  || !reg_or_0_operand (operands[1], E_V2HImode)
                  || !reg_or_0_operand (operands[2], E_V2HImode)
                  || !
#line 90 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dspr2.md"
(ISA_HAS_DSPR2))
                return -1;
              return 1020; /* mips_addu_ph */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      return recog_57 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_61 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_69 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_59 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_64 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_71 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_55 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_63 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_68 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_73 (x1, insn, pnum_clobbers);

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 3044 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DIV))
            return -1;
          return 150; /* udivsi3 */

        case 1:
          if (!(
#line 3044 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DDIV) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 152; /* udivdi3 */

        case 2:
          if (!
#line 808 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1298; /* udivv2di3 */

        case 3:
          if (!
#line 808 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1299; /* udivv4si3 */

        case 4:
          if (!
#line 808 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1300; /* udivv8hi3 */

        case 5:
          if (!
#line 808 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1301; /* udivv16qi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 3060 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DIV))
            return -1;
          return 153; /* modsi3 */

        case 1:
          if (!(
#line 3060 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DDIV) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 155; /* moddi3 */

        case 2:
          if (!
#line 817 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1302; /* modv2di3 */

        case 3:
          if (!
#line 817 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1303; /* modv4si3 */

        case 4:
          if (!
#line 817 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1304; /* modv8hi3 */

        case 5:
          if (!
#line 817 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1305; /* modv16qi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 3060 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DIV))
            return -1;
          return 154; /* umodsi3 */

        case 1:
          if (!(
#line 3060 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_LOONGSON_2EF || TARGET_LOONGSON_EXT || ISA_HAS_R6DDIV) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 156; /* umoddi3 */

        case 2:
          if (!
#line 826 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1306; /* umodv2di3 */

        case 3:
          if (!
#line 826 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1307; /* umodv4si3 */

        case 4:
          if (!
#line 826 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1308; /* umodv8hi3 */

        case 5:
          if (!
#line 826 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1309; /* umodv16qi3 */

        default:
          return -1;
        }

    case SQRT:
      return recog_77 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_95 (x1, insn, pnum_clobbers);

    case CLZ:
      return recog_94 (x1, insn, pnum_clobbers);

    case CTZ:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern2 (x2))
        {
        case 0:
          if (!
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CTZ_CTO))
            return -1;
          return 173; /* ctzsi2 */

        case 1:
          if (!(
#line 3194 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CTZ_CTO) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 174; /* ctzdi2 */

        default:
          return -1;
        }

    case POPCOUNT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern79 (x2))
            {
            case 0:
              if (!
#line 3211 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_POP))
                return -1;
              return 175; /* popcountsi2 */

            case 1:
              if (!(
#line 3211 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_POP) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 176; /* popcountdi2 */

            case 2:
              if (!
#line 2497 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1658; /* popcountv2di2 */

            case 3:
              if (!
#line 2497 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1659; /* popcountv4si2 */

            case 4:
              if (!
#line 2497 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1660; /* popcountv8hi2 */

            case 5:
              if (!
#line 2497 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
                return -1;
              return 1661; /* popcountv16qi2 */

            default:
              return -1;
            }

        case TRUNCATE:
          if (pattern33 (x2, 
E_DImode, 
E_SImode) != 0
              || !
#line 3221 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_POP && TARGET_64BIT))
            return -1;
          return 177; /* *popcountdi2_trunc */

        default:
          return -1;
        }

    case NOT:
      return recog_74 (x1, insn, pnum_clobbers);

    case AND:
      return recog_67 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_62 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_83 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 3529 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT))
        return -1;
      return 200; /* truncdfsf2 */

    case ASHIFTRT:
      return recog_84 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_89 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_88 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_91 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 4364 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_EXTS && UINTVAL (operands[2]) <= 32))
            return -1;
          return 275; /* *extvsi */

        case 1:
          if (!(
#line 4364 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_EXTS && UINTVAL (operands[2]) <= 32) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 276; /* *extvdi */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 4402 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_use_ins_ext_p (operands[1], INTVAL (operands[2]),
		       INTVAL (operands[3]))))
            return -1;
          return 277; /* *extzvsi */

        case 1:
          if (!(
#line 4402 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_use_ins_ext_p (operands[1], INTVAL (operands[2]),
		       INTVAL (operands[3]))) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 278; /* *extzvdi */

        default:
          return -1;
        }

    case LO_SUM:
      return recog_85 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_58 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_60 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern23 (x2))
        {
        case 0:
          if (
#line 5860 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 451; /* *ashlsi3 */
          if (!
#line 5891 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 460; /* *ashlsi3_mips16 */

        case 1:
          if ((
#line 5860 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 454; /* *ashldi3 */
          if (!
#line 5919 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && TARGET_MIPS16))
            return -1;
          return 465; /* *ashldi3_mips16 */

        case 2:
          if (!
#line 568 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1193; /* ashlv2si3 */

        case 3:
          if (!
#line 568 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1194; /* ashlv4hi3 */

        case 4:
          if (!
#line 927 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1334; /* vashlv2di3 */

        case 5:
          if (!
#line 927 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1335; /* vashlv4si3 */

        case 6:
          if (!
#line 927 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1336; /* vashlv8hi3 */

        case 7:
          if (!
#line 927 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1337; /* vashlv16qi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      return recog_79 (x1, insn, pnum_clobbers);

    case ROTATERT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!arith_operand (operands[2], E_SImode))
        return -1;
      switch (pattern2 (x2))
        {
        case 0:
          if (!
#line 6001 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_ROR))
            return -1;
          return 469; /* rotrsi3 */

        case 1:
          if (!(
#line 6001 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_ROR) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 470; /* rotrdi3 */

        default:
          return -1;
        }

    case BSWAP:
      return recog_93 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_56 (x1, insn, pnum_clobbers);

    case EQ:
      return recog_72 (x1, insn, pnum_clobbers);

    case NE:
      return recog_82 (x1, insn, pnum_clobbers);

    case GT:
      return recog_78 (x1, insn, pnum_clobbers);

    case GTU:
      return recog_87 (x1, insn, pnum_clobbers);

    case GE:
      return recog_90 (x1, insn, pnum_clobbers);

    case GEU:
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern109 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 6363 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
                return -1;
              return 540; /* *sgeu_sisi */

            case 1:
              if (!(
#line 6363 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 542; /* *sgeu_disi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern109 (x2, 
E_DImode))
            {
            case 0:
              if (!(
#line 6363 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 544; /* *sgeu_sidi */

            case 1:
              if (!(
#line 6363 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 546; /* *sgeu_didi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LT:
      return recog_76 (x1, insn, pnum_clobbers);

    case LTU:
      return recog_86 (x1, insn, pnum_clobbers);

    case LE:
      return recog_75 (x1, insn, pnum_clobbers);

    case LEU:
      return recog_81 (x1, insn, pnum_clobbers);

    case UNORDERED:
      switch (pattern7 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 579; /* sunordered_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 586; /* sunordered_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 593; /* sunordered_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 600; /* sunordered_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 607; /* sunordered_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 617; /* sunordered_df_using_ccf */

        case 6:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1488; /* msa_fcun_d */

        case 7:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1497; /* msa_fcun_w */

        default:
          return -1;
        }

    case UNEQ:
      switch (pattern7 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 580; /* suneq_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 587; /* suneq_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 594; /* suneq_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 601; /* suneq_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 608; /* suneq_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 618; /* suneq_df_using_ccf */

        case 6:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1494; /* msa_fcueq_d */

        case 7:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1503; /* msa_fcueq_w */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern7 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 581; /* sunlt_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 588; /* sunlt_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 595; /* sunlt_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 602; /* sunlt_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 609; /* sunlt_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 619; /* sunlt_df_using_ccf */

        case 6:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1496; /* msa_fcult_d */

        case 7:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1505; /* msa_fcult_w */

        default:
          return -1;
        }

    case UNLE:
      switch (pattern7 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 582; /* sunle_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 589; /* sunle_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 596; /* sunle_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 603; /* sunle_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 610; /* sunle_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 620; /* sunle_df_using_ccf */

        case 6:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1495; /* msa_fcule_d */

        case 7:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1504; /* msa_fcule_w */

        default:
          return -1;
        }

    case ORDERED:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern85 (x2))
        {
        case 0:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 614; /* sordered_sf_using_ccf */

        case 1:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 624; /* sordered_df_using_ccf */

        case 2:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1489; /* msa_fcor_d */

        case 3:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1498; /* msa_fcor_w */

        default:
          return -1;
        }

    case LTGT:
      if (GET_MODE (x2) != E_CCFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_CCFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (pattern4 ())
        {
        case 0:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 615; /* sltgt_sf_using_ccf */

        case 1:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 625; /* sltgt_df_using_ccf */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern9 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 629; /* sunge_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 633; /* sunge_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 637; /* sunge_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 641; /* sunge_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 645; /* sunge_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 649; /* sunge_df_using_ccf */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern9 (x1))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 630; /* sungt_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 634; /* sungt_df_using_cc */

        case 2:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 638; /* sungt_sf_using_cce */

        case 3:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 642; /* sungt_df_using_cce */

        case 4:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 646; /* sungt_sf_using_ccf */

        case 5:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 650; /* sungt_df_using_ccf */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!call_insn_operand (operands[1], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (
#line 7115 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_SIBCALLS && SIBLING_CALL_P (insn)))
        return 688; /* sibcall_value_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 694; /* call_value_internal */

    case SMIN:
      switch (pattern11 (x1))
        {
        case 0:
          if (!(
#line 7986 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 775; /* sminsf3 */

        case 1:
          if (!(
#line 7986 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 776; /* smindf3 */

        case 2:
          if (!
#line 444 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1181; /* sminv4hi3 */

        case 3:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1550; /* sminv2df3 */

        case 4:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1551; /* sminv4sf3 */

        case 5:
          if (!
#line 2286 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1622; /* sminv2di3 */

        case 6:
          if (!
#line 2286 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1623; /* sminv4si3 */

        case 7:
          if (!
#line 2286 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1624; /* sminv8hi3 */

        case 8:
          if (!
#line 2286 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1625; /* sminv16qi3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern11 (x1))
        {
        case 0:
          if (!(
#line 7995 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 777; /* smaxsf3 */

        case 1:
          if (!(
#line 7995 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_FMIN_FMAX) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 778; /* smaxdf3 */

        case 2:
          if (!
#line 415 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1179; /* smaxv4hi3 */

        case 3:
          if (!
#line 1745 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1546; /* smaxv2df3 */

        case 4:
          if (!
#line 1745 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1547; /* smaxv4sf3 */

        case 5:
          if (!
#line 2252 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1610; /* smaxv2di3 */

        case 6:
          if (!
#line 2252 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1611; /* smaxv4si3 */

        case 7:
          if (!
#line 2252 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1612; /* smaxv8hi3 */

        case 8:
          if (!
#line 2252 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1613; /* smaxv16qi3 */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_65 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_80 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      return recog_92 (x1, insn, pnum_clobbers);

    case US_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern24 (x2))
        {
        case 0:
          if (!
#line 216 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1143; /* usaddv4hi3 */

        case 1:
          if (!
#line 216 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1144; /* usaddv8qi3 */

        case 2:
          if (!
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1364; /* usaddv2di3 */

        case 3:
          if (!
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1365; /* usaddv4si3 */

        case 4:
          if (!
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1366; /* usaddv8hi3 */

        case 5:
          if (!
#line 1035 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1367; /* usaddv16qi3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 435 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1180; /* umaxv8qi3 */

        case 1:
          if (!
#line 2263 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1614; /* umaxv2di3 */

        case 2:
          if (!
#line 2263 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1615; /* umaxv4si3 */

        case 3:
          if (!
#line 2263 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1616; /* umaxv8hi3 */

        case 4:
          if (!
#line 2263 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1617; /* umaxv16qi3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 464 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1182; /* uminv8qi3 */

        case 1:
          if (!
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1626; /* uminv2di3 */

        case 2:
          if (!
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1627; /* uminv4si3 */

        case 3:
          if (!
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1628; /* uminv8hi3 */

        case 4:
          if (!
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1629; /* uminv16qi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 617 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1203; /* sssubv4hi3 */

        case 1:
          if (!
#line 617 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1204; /* sssubv8qi3 */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 626 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1205; /* ussubv4hi3 */

        case 1:
          if (!
#line 626 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
            return -1;
          return 1206; /* ussubv8qi3 */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_66 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1674 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1532; /* floatunsv2div2df2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1674 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1533; /* floatunsv4siv4sf2 */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_70 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1842 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1566; /* fixuns_truncv2dfv2di2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 1842 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1567; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
