/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_CCmode:
      return pattern5 (x1, 
E_CCmode); /* [-1, 1] */

    case E_CCEmode:
      res = pattern5 (x1, 
E_CCEmode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case E_CCFmode:
      res = pattern5 (x1, 
E_CCFmode);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!non_volatile_mem_operand (operands[1], E_HImode))
    return -1;
  x5 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x6, 0);
  operands[3] = x8;
  if (!non_volatile_mem_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern33 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !register_operand (operands[2], E_V2DImode)
          || !const_uimm6_operand (operands[3], E_VOIDmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !register_operand (operands[2], E_V4SImode)
          || !const_uimm5_operand (operands[3], E_VOIDmode))
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern74 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V16QImode:
      if (pattern75 (x3, 
E_V16QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_CCDSPmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 185
      || GET_MODE (x4) != E_CCDSPmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_UQQmode:
      return pattern92 (x7, 
E_UQQmode); /* [-1, 0] */

    case E_UHQmode:
      if (pattern92 (x7, 
E_UHQmode) != 0)
        return -1;
      return 1;

    case E_UHAmode:
      if (pattern92 (x7, 
E_UHAmode) != 0)
        return -1;
      return 2;

    case E_V4UQQmode:
      if (pattern92 (x7, 
E_V4UQQmode) != 0)
        return -1;
      return 3;

    case E_V2UHQmode:
      if (pattern92 (x7, 
E_V2UHQmode) != 0)
        return -1;
      return 4;

    case E_V2UHAmode:
      if (pattern92 (x7, 
E_V2UHAmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  return pattern89 (x1); /* [-1, 1] */
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !move_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !move_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode)
          || !reg_or_vector_same_simm5_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !register_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  return pattern96 (x1); /* [-1, 1] */
}

int
pattern139 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 32L:
      return pattern138 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case 64L:
      if (pattern138 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern163 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_TImode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!cprestore_save_slot_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_int_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern180 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern186 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern192 (rtx x1, int i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 185
      || GET_MODE (x6) != E_CCDSPmode
      || !register_operand (operands[0], i2)
      || pattern191 (x5, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern200 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 3
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CCDSPmode)
    return -1;
  x6 = XVECEXP (x5, 0, 2);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 186
      || GET_MODE (x6) != E_CCDSPmode
      || pattern199 (x4, 
E_V4QImode, 
186) != 0)
    return -1;
  return 0;
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  switch (GET_MODE (x5))
    {
    case E_SImode:
      x6 = XEXP (x4, 1);
      if (GET_MODE (x6) != E_SImode
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x6 = XEXP (x4, 1);
      if (GET_MODE (x6) != E_DImode
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != CALL)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode
      || pattern218 (x1) != 0)
    return -1;
  return 0;
}

int
pattern222 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !movep_src_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !movep_src_operand (operands[3], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_exp_4_operand (operands[3], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern239 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !arith_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern250 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2HQmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      return pattern92 (x7, 
E_V2HQmode); /* [-1, 0] */

    case E_HQmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_HQmode) != 0)
        return -1;
      return 1;

    case E_SQmode:
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      if (pattern92 (x7, 
E_SQmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_MODE (x6) != i1
      || !arith_operand (operands[2], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case MULT:
      if (GET_MODE (x4) != E_DImode
          || !muldiv_target_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_MODE (x6) != E_DImode)
        return -1;
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x6) != SIGN_EXTEND)
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 2218 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000))
            return -1;
          return 57; /* mulsidi3_64bit_hilo */

        case ZERO_EXTEND:
          if (GET_CODE (x6) != ZERO_EXTEND)
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 2218 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT && !TARGET_FIX_R4000))
            return -1;
          return 58; /* umulsidi3_64bit_hilo */

        default:
          return -1;
        }

    case DIV:
      switch (pattern112 (x3))
        {
        case 0:
          if (!(
#line 3033 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DIV) && 
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT)))
            return -1;
          return 143; /* divmodsi4_hilo_di */

        case 1:
          if (!(
#line 3033 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DIV) && 
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 145; /* divmodsi4_hilo_ti */

        case 2:
          if (!(
#line 3033 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DDIV) && 
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 147; /* divmoddi4_hilo_ti */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern112 (x3))
        {
        case 0:
          if (!(
#line 3033 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DIV) && 
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_64BIT)))
            return -1;
          return 144; /* udivmodsi4_hilo_di */

        case 1:
          if (!(
#line 3033 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DIV) && 
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 146; /* udivmodsi4_hilo_ti */

        case 2:
          if (!(
#line 3033 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DDIV) && 
#line 828 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 148; /* udivmoddi4_hilo_ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!const_int_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!address_operand (operands[1], E_QImode)
      || !
#line 5785 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CACHE))
    return -1;
  return 449; /* mips_cache */
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 2615 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1700; /* msa_subsuu_s_d */

    case 1:
      if (!
#line 2615 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1701; /* msa_subsuu_s_w */

    case 2:
      if (!
#line 2615 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1702; /* msa_subsuu_s_h */

    case 3:
      if (!
#line 2615 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1703; /* msa_subsuu_s_b */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern63 (x1))
    {
    case 0:
      if (!
#line 2517 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1666; /* msa_sat_u_d */

    case 1:
      if (!
#line 2517 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1667; /* msa_sat_u_w */

    case 2:
      if (!
#line 2517 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1668; /* msa_sat_u_h */

    case 3:
      if (!
#line 2517 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1669; /* msa_sat_u_b */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern62 (x1))
    {
    case 0:
      if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1388; /* msa_aver_u_d */

    case 1:
      if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1389; /* msa_aver_u_w */

    case 2:
      if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1390; /* msa_aver_u_h */

    case 3:
      if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1391; /* msa_aver_u_b */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case MULT:
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern205 (x3, 
E_SImode))
            {
            case 0:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
                return -1;
              return 353; /* *lwxs */

            case 1:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 354; /* *lwxs */

            default:
              return -1;
            }

        case E_V2HImode:
          switch (pattern205 (x3, 
E_V2HImode))
            {
            case 0:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 852 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
                return -1;
              return 355; /* *lwxs */

            case 1:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 852 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
                return -1;
              return 356; /* *lwxs */

            default:
              return -1;
            }

        case E_V4QImode:
          switch (pattern205 (x3, 
E_V4QImode))
            {
            case 0:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 853 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
                return -1;
              return 357; /* *lwxs */

            case 1:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 853 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
                return -1;
              return 358; /* *lwxs */

            default:
              return -1;
            }

        case E_V2HQmode:
          switch (pattern205 (x3, 
E_V2HQmode))
            {
            case 0:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 854 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
                return -1;
              return 359; /* *lwxs */

            case 1:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 854 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
                return -1;
              return 360; /* *lwxs */

            default:
              return -1;
            }

        case E_V2UHQmode:
          switch (pattern205 (x3, 
E_V2UHQmode))
            {
            case 0:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 855 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
                return -1;
              return 361; /* *lwxs */

            case 1:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 855 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
                return -1;
              return 362; /* *lwxs */

            default:
              return -1;
            }

        case E_V2HAmode:
          switch (pattern205 (x3, 
E_V2HAmode))
            {
            case 0:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 856 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
                return -1;
              return 363; /* *lwxs */

            case 1:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 856 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
                return -1;
              return 364; /* *lwxs */

            default:
              return -1;
            }

        case E_V2UHAmode:
          switch (pattern205 (x3, 
E_V2UHAmode))
            {
            case 0:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 857 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
                return -1;
              return 365; /* *lwxs */

            case 1:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 857 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
                return -1;
              return 366; /* *lwxs */

            default:
              return -1;
            }

        case E_V4QQmode:
          switch (pattern205 (x3, 
E_V4QQmode))
            {
            case 0:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 858 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
                return -1;
              return 367; /* *lwxs */

            case 1:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 858 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
                return -1;
              return 368; /* *lwxs */

            default:
              return -1;
            }

        case E_V4UQQmode:
          switch (pattern205 (x3, 
E_V4UQQmode))
            {
            case 0:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 859 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
                return -1;
              return 369; /* *lwxs */

            case 1:
              if (!(
#line 5102 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_LWXS) && ((((
#line 859 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_DSP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
                return -1;
              return 370; /* *lwxs */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x6;
      switch (pattern158 (x3, 
E_DImode))
        {
        case 0:
          if (!(
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LDX) && (((
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))))
            return -1;
          return 1011; /* mips_ldx_si */

        case 1:
          if (!(
#line 1131 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-dsp.md"
(ISA_HAS_LDX) && (((
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))))
            return -1;
          return 1013; /* mips_ldx_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 43:
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (pattern39 (x2))
            {
            case 0:
              if (!(
#line 5763 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SYNCI) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
                return -1;
              return 445; /* rdhwr_synci_step_si */

            case 1:
              if (!(
#line 5763 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_SYNCI) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 446; /* rdhwr_synci_step_di */

            default:
              return -1;
            }

        case 52:
          switch (pattern42 (x1))
            {
            case 0:
              if (!
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))
                return -1;
              return 674; /* mips_rdpgpr_si */

            case 1:
              if (!
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))
                return -1;
              return 675; /* mips_rdpgpr_di */

            default:
              return -1;
            }

        case 53:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 676; /* cop0_move */

        case 26:
          if (pnum_clobbers == NULL)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG)
            return -1;
          switch (pattern137 (x1, 
28))
            {
            case 0:
              if (!(
#line 6966 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_CALL_CLOBBERED_GP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
                return -1;
              *pnum_clobbers = 1;
              return 679; /* restore_gp_si */

            case 1:
              if (!(
#line 6966 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_CALL_CLOBBERED_GP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              *pnum_clobbers = 1;
              return 680; /* restore_gp_di */

            default:
              return -1;
            }

        case 29:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 79
              || GET_MODE (x4) != E_SImode
              || !
#line 7055 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_USE_GOT))
            return -1;
          return 685; /* set_got_version */

        case 12:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 7843 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 763; /* *mips_get_fcsr */

        case 66:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case PLUS:
              x5 = XEXP (x3, 1);
              operands[1] = x5;
              x6 = XEXP (x3, 0);
              if (!rtx_equal_p (x6, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern183 (x2, 
E_SImode) != 0
                      || !
#line 114 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                    return -1;
                  return 795; /* sync_addsi */

                case E_DImode:
                  if (pattern183 (x2, 
E_DImode) != 0
                      || !(
#line 114 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return -1;
                  return 796; /* sync_adddi */

                default:
                  return -1;
                }

            case MINUS:
              x5 = XEXP (x3, 1);
              operands[1] = x5;
              x6 = XEXP (x3, 0);
              if (!rtx_equal_p (x6, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern184 (x2, 
E_SImode) != 0
                      || !
#line 368 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                    return -1;
                  return 815; /* sync_subsi */

                case E_DImode:
                  if (pattern184 (x2, 
E_DImode) != 0
                      || !(
#line 368 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return -1;
                  return 816; /* sync_subdi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern119 (x2))
                {
                case 0:
                  if (!
#line 443 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                    return -1;
                  return 825; /* sync_iorsi */

                case 1:
                  if (!(
#line 443 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return -1;
                  return 828; /* sync_iordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern119 (x2))
                {
                case 0:
                  if (!
#line 443 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                    return -1;
                  return 826; /* sync_xorsi */

                case 1:
                  if (!(
#line 443 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return -1;
                  return 829; /* sync_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern119 (x2))
                {
                case 0:
                  if (!
#line 443 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                    return -1;
                  return 827; /* sync_andsi */

                case 1:
                  if (!(
#line 443 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return -1;
                  return 830; /* sync_anddi */

                default:
                  return -1;
                }

            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x3;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!memory_operand (operands[0], E_SImode)
                      || GET_MODE (x2) != E_SImode
                      || !uns_arith_operand (operands[1], E_SImode)
                      || !
#line 484 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                    return -1;
                  return 843; /* sync_nandsi */

                case E_DImode:
                  if (!memory_operand (operands[0], E_DImode)
                      || GET_MODE (x2) != E_DImode
                      || !uns_arith_operand (operands[1], E_DImode)
                      || !(
#line 484 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                    return -1;
                  return 844; /* sync_nanddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 247:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!const_uimm5_operand (operands[1], E_VOIDmode)
              || !
#line 2686 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1734; /* msa_cfcmsa */

        default:
          return -1;
        }

    case 2:
      if (XINT (x2, 1) != 56)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      x7 = XVECEXP (x2, 0, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern53 (x2, 
E_SImode) != 0
              || !
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode))
            return -1;
          return 663; /* probe_stack_range_si */

        case E_DImode:
          if (pattern53 (x2, 
E_DImode) != 0
              || !
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode))
            return -1;
          return 664; /* probe_stack_range_di */

        default:
          return -1;
        }

    case 3:
      if (pattern18 (x1, pnum_clobbers) != 0)
        return -1;
      x8 = XVECEXP (x2, 0, 2);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (GET_CODE (x8))
        {
        case PLUS:
          x9 = XEXP (x8, 1);
          operands[3] = x9;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[0])
              || !
#line 145 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          *pnum_clobbers = 1;
          return 797; /* sync_add_12 */

        case MINUS:
          x9 = XEXP (x8, 1);
          operands[3] = x9;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[0])
              || !
#line 145 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          *pnum_clobbers = 1;
          return 798; /* sync_sub_12 */

        case IOR:
          x9 = XEXP (x8, 1);
          operands[3] = x9;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[0])
              || !
#line 145 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          *pnum_clobbers = 1;
          return 799; /* sync_ior_12 */

        case XOR:
          x9 = XEXP (x8, 1);
          operands[3] = x9;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[0])
              || !
#line 145 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          *pnum_clobbers = 1;
          return 800; /* sync_xor_12 */

        case AND:
          x9 = XEXP (x8, 1);
          operands[3] = x9;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[0])
              || !
#line 145 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          *pnum_clobbers = 1;
          return 801; /* sync_and_12 */

        default:
          return -1;
        }

    case 4:
      if (pattern18 (x1, pnum_clobbers) != 0)
        return -1;
      x11 = XVECEXP (x2, 0, 3);
      operands[3] = x11;
      if (!reg_or_0_operand (operands[3], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 2);
      if (!rtx_equal_p (x8, operands[0])
          || !
#line 268 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
        return -1;
      *pnum_clobbers = 1;
      return 812; /* sync_nand_12 */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_DUPLICATE)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x2) != E_V2DFmode
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[2], E_V2DFmode)
              || !const_exp_2_operand (operands[3], E_VOIDmode))
            return -1;
          if (reg_or_0_operand (operands[1], E_DFmode)
              && 
#line 484 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return 1235; /* msa_insert_d_f */
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 535 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1247; /* msa_insve_d_f_scalar */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[2], E_V4SFmode)
              || !const_exp_4_operand (operands[3], E_VOIDmode))
            return -1;
          if (reg_or_0_operand (operands[1], E_SFmode)
              && 
#line 484 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return 1236; /* msa_insert_w_f */
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 535 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1248; /* msa_insve_w_f_scalar */

        case E_V2DImode:
          if (pattern186 (x2, 
E_DImode, 
E_V2DImode) != 0
              || !register_operand (operands[2], E_V2DImode)
              || !const_exp_2_operand (operands[3], E_VOIDmode)
              || !
#line 484 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1237; /* msa_insert_d */

        case E_V4SImode:
          if (pattern186 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !register_operand (operands[2], E_V4SImode)
              || !const_exp_4_operand (operands[3], E_VOIDmode)
              || !
#line 484 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1238; /* msa_insert_w */

        case E_V8HImode:
          if (pattern186 (x2, 
E_HImode, 
E_V8HImode) != 0
              || !register_operand (operands[2], E_V8HImode)
              || !const_exp_8_operand (operands[3], E_VOIDmode)
              || !
#line 484 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1239; /* msa_insert_h */

        case E_V16QImode:
          if (pattern186 (x2, 
E_QImode, 
E_V16QImode) != 0
              || !register_operand (operands[2], E_V16QImode)
              || !const_exp_16_operand (operands[3], E_VOIDmode)
              || !
#line 484 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1240; /* msa_insert_b */

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XVECEXP (x8, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DFmode:
          if (pattern229 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 522 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1241; /* msa_insve_d_f */

        case E_V4SFmode:
          if (pattern230 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !
#line 522 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1242; /* msa_insve_w_f */

        case E_V2DImode:
          if (pattern229 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 522 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1243; /* msa_insve_d */

        case E_V4SImode:
          if (pattern230 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 522 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1244; /* msa_insve_w */

        case E_V8HImode:
          if (pattern231 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !register_operand (operands[2], E_V8HImode)
              || !const_exp_8_operand (operands[3], E_VOIDmode)
              || !
#line 522 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1245; /* msa_insve_h */

        case E_V16QImode:
          if (pattern231 (x2, 
E_V16QImode, 
E_QImode) != 0
              || !register_operand (operands[2], E_V16QImode)
              || !const_exp_16_operand (operands[3], E_VOIDmode)
              || !
#line 522 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
            return -1;
          return 1246; /* msa_insve_b */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 183; /* one_cmplsi2 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))
        return -1;
      return 184; /* one_cmpldi2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 271 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1161; /* one_cmplv2si2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 271 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1162; /* one_cmplv4hi2 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 271 "../../gcc-15.0.1-20250313/gcc/config/mips/loongson-mmi.md"
(TARGET_HARD_FLOAT && TARGET_LOONGSON_MMI))
        return -1;
      return 1163; /* one_cmplv8qi2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1322; /* one_cmplv2di2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1323; /* one_cmplv4si2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1324; /* one_cmplv8hi2 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1325; /* one_cmplv16qi2 */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern109 (x3, 
E_SImode))
        {
        case 0:
          if (reg_or_0_operand (operands[2], E_SImode)
              && 
#line 6345 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16))
            return 523; /* *sgt_sisi */
          if (!register_operand (operands[2], E_SImode)
              || !
#line 6354 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16))
            return -1;
          return 531; /* *sgt_sisi_mips16 */

        case 1:
          if (reg_or_0_operand (operands[2], E_DImode)
              && (
#line 6345 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 525; /* *sgt_disi */
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6354 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 533; /* *sgt_disi_mips16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern109 (x3, 
E_DImode))
        {
        case 0:
          if (reg_or_0_operand (operands[2], E_SImode)
              && (
#line 6345 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 527; /* *sgt_sidi */
          if (!register_operand (operands[2], E_SImode)
              || !(
#line 6354 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 535; /* *sgt_sidi_mips16 */

        case 1:
          if (reg_or_0_operand (operands[2], E_DImode)
              && (
#line 6345 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return 529; /* *sgt_didi */
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 6354 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_MIPS16) && 
#line 816 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return -1;
          return 537; /* *sgt_didi_mips16 */

        default:
          return -1;
        }

    case E_CCmode:
      switch (pattern5 (x3, 
E_CCmode))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 628; /* sgt_sf_using_cc */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 632; /* sgt_df_using_cc */

        default:
          return -1;
        }

    case E_CCEmode:
      switch (pattern5 (x3, 
E_CCEmode))
        {
        case 0:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 636; /* sgt_sf_using_cce */

        case 1:
          if (!((
#line 846 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 640; /* sgt_df_using_cce */

        default:
          return -1;
        }

    case E_CCFmode:
      switch (pattern5 (x3, 
E_CCFmode))
        {
        case 0:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)) && 
#line 886 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
            return -1;
          return 644; /* sgt_sf_using_ccf */

        case 1:
          if (!((
#line 847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_CCF) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)) && 
#line 887 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT)))
            return -1;
          return 648; /* sgt_df_using_ccf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern108 (x3, 
E_SImode))
        {
        case 0:
          if (
#line 4032 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT && ISA_HAS_TRUNC_W))
            return 265; /* fix_truncdfsi2_insn */
          if (pnum_clobbers == NULL
              || !
#line 4042 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_DOUBLE_FLOAT && !ISA_HAS_TRUNC_W))
            return -1;
          *pnum_clobbers = 1;
          return 266; /* fix_truncdfsi2_macro */

        case 1:
          if (
#line 4069 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && ISA_HAS_TRUNC_W))
            return 267; /* fix_truncsfsi2_insn */
          if (pnum_clobbers == NULL
              || !
#line 4079 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && !ISA_HAS_TRUNC_W))
            return -1;
          *pnum_clobbers = 1;
          return 268; /* fix_truncsfsi2_macro */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern108 (x3, 
E_DImode))
        {
        case 0:
          if (!
#line 4095 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT64 && TARGET_DOUBLE_FLOAT))
            return -1;
          return 269; /* fix_truncdfdi2 */

        case 1:
          if (!
#line 4105 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT && TARGET_FLOAT64 && TARGET_DOUBLE_FLOAT))
            return -1;
          return 270; /* fix_truncsfdi2 */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1833 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1564; /* fix_truncv2dfv2di2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 1833 "../../gcc-15.0.1-20250313/gcc/config/mips/mips-msa.md"
(ISA_HAS_MSA))
        return -1;
      return 1565; /* fix_truncv4sfv4si2 */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 26:
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 28)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          switch (pattern210 (x1))
            {
            case 0:
              if (!(
#line 6966 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_CALL_CLOBBERED_GP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
                return -1;
              return 679; /* restore_gp_si */

            case 1:
              if (!(
#line 6966 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_CALL_CLOBBERED_GP) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
                return -1;
              return 680; /* restore_gp_di */

            default:
              return -1;
            }

        case 74:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern126 (x6, 
74) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x7 = XEXP (x6, 1);
          x8 = XVECEXP (x7, 0, 0);
          operands[2] = x8;
          x9 = XEXP (x6, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern246 (x1, 
E_SImode) != 0
                  || !
#line 655 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(ISA_HAS_SWAP))
                return -1;
              return 856; /* atomic_exchangesi_swap */

            case E_DImode:
              if (pattern246 (x1, 
E_DImode) != 0
                  || !(
#line 655 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(ISA_HAS_SWAP) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 857; /* atomic_exchangedi_swap */

            default:
              return -1;
            }

        case 75:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE
              || XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 75)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          if (GET_CODE (x8) != PLUS)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          x11 = XEXP (x8, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x9 = XEXP (x6, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern256 (x1, 
E_SImode) != 0
                  || !
#line 714 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(ISA_HAS_LDADD))
                return -1;
              return 860; /* atomic_fetch_addsi_ldadd */

            case E_DImode:
              if (pattern256 (x1, 
E_DImode) != 0
                  || !(
#line 714 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(ISA_HAS_LDADD) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
                return -1;
              return 861; /* atomic_fetch_adddi_ldadd */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 69
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XVECEXP (x3, 0, 1);
      operands[2] = x12;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x13 = XVECEXP (x3, 0, 2);
      if (GET_MODE (x13) != E_SImode)
        return -1;
      x9 = XEXP (x6, 0);
      operands[4] = x9;
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      switch (GET_CODE (x13))
        {
        case PLUS:
          x14 = XEXP (x13, 1);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 145 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 797; /* sync_add_12 */

        case MINUS:
          x14 = XEXP (x13, 1);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 145 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 798; /* sync_sub_12 */

        case IOR:
          x14 = XEXP (x13, 1);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 145 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 799; /* sync_ior_12 */

        case XOR:
          x14 = XEXP (x13, 1);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 145 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 800; /* sync_xor_12 */

        case AND:
          x14 = XEXP (x13, 1);
          operands[3] = x14;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x15 = XEXP (x13, 0);
          if (!rtx_equal_p (x15, operands[0])
              || !
#line 145 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 801; /* sync_and_12 */

        default:
          return -1;
        }

    case 4:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x12 = XVECEXP (x3, 0, 1);
      operands[2] = x12;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 68:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE
              || XVECLEN (x7, 0) != 4
              || XINT (x7, 1) != 68
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode)
              || pattern241 (x1, 
E_SImode) != 0)
            return -1;
          x9 = XEXP (x6, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x16 = XVECEXP (x3, 0, 3);
          switch (GET_CODE (x16))
            {
            case PLUS:
              if (pattern264 (x1) != 0
                  || !
#line 232 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 807; /* sync_new_add_12 */

            case MINUS:
              if (pattern264 (x1) != 0
                  || !
#line 232 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 808; /* sync_new_sub_12 */

            case IOR:
              if (pattern264 (x1) != 0
                  || !
#line 232 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 809; /* sync_new_ior_12 */

            case XOR:
              if (pattern264 (x1) != 0
                  || !
#line 232 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 810; /* sync_new_xor_12 */

            case AND:
              if (pattern264 (x1) != 0
                  || !
#line 232 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 811; /* sync_new_and_12 */

            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case REG:
            case SUBREG:
              operands[4] = x16;
              if (!reg_or_0_operand (operands[4], E_SImode))
                return -1;
              x17 = XVECEXP (x7, 0, 3);
              if (!rtx_equal_p (x17, operands[4])
                  || !
#line 351 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
                return -1;
              return 814; /* sync_new_nand_12 */

            default:
              return -1;
            }

        case 69:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER
              || !memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          x16 = XVECEXP (x3, 0, 3);
          operands[3] = x16;
          if (!reg_or_0_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x13 = XVECEXP (x3, 0, 2);
          if (!rtx_equal_p (x13, operands[0])
              || !
#line 268 "../../gcc-15.0.1-20250313/gcc/config/mips/sync.md"
(GENERATE_LL_SC))
            return -1;
          return 812; /* sync_nand_12 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case TRUNCATE:
      res = split_4 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case DIV:
      switch (pattern110 (x1, 
MOD))
        {
        case 0:
          if ((
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DIV && !TARGET_FIX_VR4120 && !TARGET_MIPS16) && 
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
            return gen_split_15 (insn, operands);
          break;

        case 1:
          if (((
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_DDIV && !TARGET_FIX_VR4120 && !TARGET_MIPS16) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)) && 
#line 2905 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
            return gen_split_16 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case UDIV:
      switch (pattern110 (x1, 
UMOD))
        {
        case 0:
          if (
#line 2970 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed))
            return gen_split_19 (insn, operands);
          break;

        case 1:
          if ((
#line 2970 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(reload_completed) && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT)))
            return gen_split_20 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x3;
      if (absolute_symbolic_operand (operands[1], E_DImode))
        {
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) == CLOBBER
              && register_operand (operands[0], E_DImode))
            {
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              if (scratch_operand (operands[2], E_DImode)
                  && (
#line 4673 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(!TARGET_MIPS16
   && TARGET_EXPLICIT_RELOCS
   && ABI_HAS_64BIT_SYMBOLS
   && cse_not_expected) && 
#line 4678 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
( reload_completed)))
                return gen_split_37 (insn, operands);
            }
        }
      break;

    case CONST_INT:
      operands[1] = x3;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) == CLOBBER)
        {
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && splittable_const_int_operand (operands[1], E_SImode)
                  && register_operand (operands[2], E_SImode))
                return gen_split_50 (insn, operands);
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && splittable_const_int_operand (operands[1], E_DImode)
                  && register_operand (operands[2], E_DImode)
                  && 
#line 812 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_64BIT))
                return gen_split_51 (insn, operands);
              break;

            default:
              break;
            }
        }
      break;

    case UNSPEC:
      res = split_5 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return NULL;
  operands[1] = x3;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !register_operand (operands[2], E_SImode)
          || !(
#line 4847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == SImode)))
        return NULL;
      return gen_split_52 (insn, operands);

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !register_operand (operands[2], E_DImode)
          || !(
#line 4847 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(mips_split_symbol (operands[2], operands[1], MAX_MACHINE_MODE, NULL)) && 
#line 832 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(Pmode == DImode)))
        return NULL;
      return gen_split_53 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!d_operand (operands[2], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return NULL;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return NULL;
  x6 = XEXP (x4, 1);
  if (!macc_msac_operand (x6, E_SImode))
    return NULL;
  x7 = XEXP (x5, 0);
  switch (GET_CODE (x7))
    {
    case REG:
      if (!rtx_equal_p (x7, operands[1]))
        return NULL;
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      if (!d_operand (operands[3], E_SImode))
        return NULL;
      operands[4] = x6;
      if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MUL3 && peep2_reg_dead_p (2, operands[1])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_4 (insn, operands);

    case SCRATCH:
      if (peep2_current_count < 3
          || GET_MODE (x7) != E_SImode)
        return NULL;
      operands[3] = x6;
      x8 = XEXP (x4, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return NULL;
      x9 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x9) != SET)
        return NULL;
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      if (!d_operand (operands[4], E_SImode))
        return NULL;
      x11 = XEXP (x9, 1);
      if (!rtx_equal_p (x11, operands[1])
          || !
#line 2011 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ISA_HAS_MUL3 && peep2_reg_dead_p (3, operands[1])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_5 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  x4 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pattern211 (
E_HImode) != 0
          || !
#line 7928 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_7 (insn, operands);

    case E_SImode:
      if (!non_volatile_mem_operand (operands[1], E_SImode)
          || !non_volatile_mem_operand (operands[3], E_SImode))
        return NULL;
      if (register_operand (operands[0], E_SImode)
          && register_operand (operands[2], E_SImode)
          && 
#line 7928 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, SImode, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_8 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!d_operand (operands[0], E_SImode)
          || !d_operand (operands[2], E_SImode)
          || !
#line 48 "../../gcc-15.0.1-20250313/gcc/config/mips/micromips.md"
(TARGET_MICROMIPS
   && umips_load_store_pair_p (true, operands)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_17 (insn, operands);

    case E_SFmode:
      if (pattern211 (
E_SFmode) != 0
          || !(
#line 7928 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, SFmode, true)) && 
#line 822 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_9 (insn, operands);

    case E_DFmode:
      if (pattern211 (
E_DFmode) != 0
          || !(
#line 7928 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(ENABLE_LD_ST_PAIRS
   && mips_load_store_bonding_p (operands, DFmode, true)) && 
#line 823 "../../gcc-15.0.1-20250313/gcc/config/mips/mips.md"
(TARGET_HARD_FLOAT
				      && TARGET_DOUBLE_FLOAT)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_10 (insn, operands);

    default:
      return NULL;
    }
}
