/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MINUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LTU
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern24 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MULT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x6 = XEXP (x3, 0);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x4, 0);
  if (!rtx_equal_p (x7, operands[3]))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x4;
      if (!nonmemory_operand (operands[2], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (pattern9 (x6, 
E_CCmode, 
51) != 0)
        return -1;
      switch (pattern20 (x5))
        {
        case 0:
          return 12; /* *adddi3_degenerate */

        case 1:
          return 17; /* *subdi3_degenerate */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (pattern9 (x6, 
E_CCmode, 
51) != 0)
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case SET:
          x9 = XEXP (x5, 1);
          if (GET_CODE (x9) != TRUNCATE
              || GET_MODE (x9) != E_SImode)
            return -1;
          switch (pattern25 (x5))
            {
            case 0:
              return 19; /* mulsidi3_internal */

            case 1:
              return 20; /* umulsidi3_internal */

            default:
              return -1;
            }

        case CLOBBER:
          if (!reg_or_am33_const_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          if (!scratch_operand (operands[1], E_SImode))
            return -1;
          return 21; /* *mulsi3 */

        default:
          return -1;
        }

    case UDIV:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode
          || pattern18 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 22; /* *udivmodsi4 */

    case DIV:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_SImode
          || pattern19 (x1) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 24; /* *divmodsi4 */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 2
          || GET_MODE (x4) != E_SImode)
        return -1;
      x11 = XVECEXP (x4, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern4 (x5, 
E_SImode, 
50) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (pattern9 (x6, 
E_CCmode, 
51) != 0)
        return -1;
      return 70; /* mn10300_load_pic0 */

    default:
      return -1;
    }
}
