/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[0] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 51
      || GET_MODE (x3) != i2
      || !register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[3] = x1;
      if (!register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case NEG:
      if (GET_MODE (x1) != E_SFmode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      if (!register_operand (operands[3], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          switch (GET_CODE (x3))
            {
            case CONST_INT:
              if (XWINT (x3, 0) == 0L)
                {
                  x4 = XVECEXP (x1, 0, 1);
                  if (pattern4 (x4, 
E_CCmode, 
51) == 0)
                    {
                      x5 = XEXP (x2, 0);
                      operands[0] = x5;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_QImode:
                          if (register_operand (operands[0], E_QImode))
                            return 5; /* *movqi_clr */
                          break;

                        case E_HImode:
                          if (register_operand (operands[0], E_HImode))
                            return 6; /* *movhi_clr */
                          break;

                        case E_SImode:
                          if (register_operand (operands[0], E_SImode))
                            return 7; /* *movsi_clr */
                          break;

                        default:
                          break;
                        }
                    }
                }
              break;

            case REG:
            case SUBREG:
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                {
                  x5 = XEXP (x2, 0);
                  if (GET_CODE (x5) == PC)
                    {
                      x4 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x4) == USE)
                        {
                          x6 = XEXP (x4, 0);
                          if (GET_CODE (x6) == LABEL_REF)
                            {
                              x7 = XEXP (x6, 0);
                              operands[1] = x7;
                              return 43; /* tablejump */
                            }
                        }
                    }
                }
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          switch (pattern20 (x4))
            {
            case 0:
              *pnum_clobbers = 1;
              return 12; /* *adddi3_degenerate */

            case 1:
              *pnum_clobbers = 1;
              return 17; /* *subdi3_degenerate */

            default:
              return -1;
            }

        case PLUS:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              switch (pattern11 (x1, pnum_clobbers))
                {
                case 0:
                  return 8; /* addsi3 */

                case 1:
                  if (!
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 58; /* addsf3 */

                case 2:
                  x4 = XVECEXP (x1, 0, 1);
                  x9 = XEXP (x4, 1);
                  if (pattern15 (x9) != 0
                      || !register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  operands[2] = x8;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x10 = XEXP (x3, 1);
                  operands[3] = x10;
                  if (!nonmemory_operand (operands[3], E_SImode))
                    return -1;
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (!register_operand (operands[1], E_SImode)
                      || pattern28 (x9) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 11; /* adddi3_internal */

                default:
                  return -1;
                }

            case PLUS:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              x11 = XEXP (x8, 0);
              if (GET_CODE (x11) != LTU
                  || GET_MODE (x11) != E_SImode)
                return -1;
              x12 = XEXP (x11, 0);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 51
                  || GET_MODE (x12) != E_CCmode)
                return -1;
              x13 = XEXP (x11, 1);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER
                  || pattern12 (x1, 
E_SImode, 
E_CCmode) != 0)
                return -1;
              x14 = XEXP (x8, 1);
              operands[1] = x14;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!reg_or_am33_const_operand (operands[2], E_SImode)
                  || !
#line 625 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed))
                return -1;
              return 10; /* addc_internal */

            default:
              return -1;
            }

        case COMPARE:
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 51)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (pattern22 (x1, 
PLUS) != 0
                  || !
#line 601 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNCmode)))
                return -1;
              return 9; /* *addsi3_flags */

            case MINUS:
              if (pattern22 (x1, 
MINUS) != 0
                  || !
#line 799 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNCmode)))
                return -1;
              return 14; /* *subsi3_flags */

            case AND:
              if (pattern22 (x1, 
AND) != 0
                  || !
#line 1205 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNmode)))
                return -1;
              return 26; /* *andsi3_flags */

            case IOR:
              if (pattern22 (x1, 
IOR) != 0
                  || !
#line 1292 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNmode)))
                return -1;
              return 28; /* *iorsi3_flags */

            case XOR:
              if (pattern22 (x1, 
XOR) != 0
                  || !
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNmode)))
                return -1;
              return 30; /* *xorsi3_flags */

            case NOT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              x10 = XEXP (x3, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || GET_CODE (x9) != NOT)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x15 = XEXP (x9, 0);
              if (!rtx_equal_p (x15, operands[1])
                  || !
#line 1355 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed && mn10300_match_ccmode (insn, CCZNmode)))
                return -1;
              return 32; /* *one_cmplsi2_flags */

            case REG:
            case SUBREG:
              operands[2] = x8;
              if (!register_operand (operands[2], E_SImode)
                  || GET_CODE (x9) != UNSPEC
                  || XVECLEN (x9, 0) != 3
                  || XINT (x9, 1) != 8
                  || GET_MODE (x5) != E_CCmode
                  || GET_MODE (x3) != E_CCmode)
                return -1;
              x10 = XEXP (x3, 1);
              operands[3] = x10;
              if (!liw_operand (operands[3], E_VOIDmode))
                return -1;
              x16 = XVECEXP (x9, 0, 1);
              operands[1] = x16;
              if (!liw_operand (operands[1], E_VOIDmode))
                return -1;
              x17 = XVECEXP (x9, 0, 2);
              operands[4] = x17;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x18 = XVECEXP (x9, 0, 0);
              if (!rtx_equal_p (x18, operands[0])
                  || !
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_ALLOW_LIW))
                return -1;
              return 73; /* cmp_liw */

            default:
              return -1;
            }

        case MINUS:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              switch (pattern11 (x1, pnum_clobbers))
                {
                case 0:
                  return 13; /* subsi3 */

                case 1:
                  if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 59; /* subsf3 */

                case 2:
                  x4 = XVECEXP (x1, 0, 1);
                  x9 = XEXP (x4, 1);
                  if (pattern17 (x9) != 0
                      || !register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  operands[2] = x8;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x10 = XEXP (x3, 1);
                  operands[4] = x10;
                  if (!nonmemory_operand (operands[4], E_SImode))
                    return -1;
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (!register_operand (operands[1], E_SImode)
                      || pattern27 (x9) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 16; /* subdi3_internal */

                default:
                  return -1;
                }

            case MINUS:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              x10 = XEXP (x3, 1);
              if (GET_CODE (x10) != GEU
                  || GET_MODE (x10) != E_SImode)
                return -1;
              x19 = XEXP (x10, 0);
              if (GET_CODE (x19) != REG
                  || REGNO (x19) != 51
                  || GET_MODE (x19) != E_CCmode)
                return -1;
              x20 = XEXP (x10, 1);
              if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER
                  || pattern12 (x1, 
E_SImode, 
E_CCmode) != 0)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x14 = XEXP (x8, 1);
              operands[2] = x14;
              if (!reg_or_am33_const_operand (operands[2], E_SImode)
                  || !
#line 825 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed))
                return -1;
              return 15; /* subc_internal */

            default:
              return -1;
            }

        case NEG:
          if (pattern5 (x1) != 0)
            return -1;
          return 18; /* negsi2 */

        case MULT:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x4 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x4))
            {
            case SET:
              if (pnum_clobbers == NULL)
                return -1;
              x9 = XEXP (x4, 1);
              if (GET_CODE (x9) != TRUNCATE
                  || GET_MODE (x9) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x8 = XEXP (x3, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_SImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[3] = x10;
              switch (pattern25 (x4))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 19; /* mulsidi3_internal */

                case 1:
                  *pnum_clobbers = 1;
                  return 20; /* umulsidi3_internal */

                default:
                  return -1;
                }

            case CLOBBER:
              if (pattern12 (x1, 
E_SFmode, 
E_CC_FLOATmode) != 0)
                return -1;
              x8 = XEXP (x3, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_SFmode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!nonmemory_operand (operands[2], E_SFmode)
                  || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              return 60; /* mulsf3 */

            default:
              return -1;
            }

        case AND:
          if (pattern6 (x1) != 0)
            return -1;
          return 25; /* andsi3 */

        case IOR:
          if (pattern6 (x1) != 0)
            return -1;
          return 27; /* iorsi3 */

        case XOR:
          if (pattern6 (x1) != 0)
            return -1;
          return 29; /* xorsi3 */

        case NOT:
          if (pattern5 (x1) != 0)
            return -1;
          return 31; /* one_cmplsi2 */

        case ASHIFT:
          if (pattern7 (x1) != 0)
            return -1;
          return 51; /* ashlsi3 */

        case LSHIFTRT:
          if (pattern7 (x1) != 0)
            return -1;
          return 52; /* lshrsi3 */

        case ASHIFTRT:
          if (pattern7 (x1) != 0)
            return -1;
          return 53; /* ashrsi3 */

        case UNSPEC:
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (XVECLEN (x3, 0))
            {
            case 2:
              if (XINT (x3, 1) != 7)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (pattern4 (x4, 
E_CCmode, 
51) != 0)
                return -1;
              x21 = XVECEXP (x3, 0, 0);
              operands[1] = x21;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x22 = XVECEXP (x3, 0, 1);
              operands[2] = x22;
              if (!nonmemory_operand (operands[2], E_SImode)
                  || !
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33))
                return -1;
              return 54; /* *bsch */

            case 1:
              if (XINT (x3, 1) != 2)
                return -1;
              x21 = XVECEXP (x3, 0, 0);
              if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x6 = XEXP (x4, 0);
              switch (GET_CODE (x6))
                {
                case REG:
                  if (REGNO (x6) != 51
                      || GET_MODE (x6) != E_CCmode
                      || !
#line 2089 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33))
                    return -1;
                  return 69; /* am33_load_pic */

                case MEM:
                  if (pnum_clobbers == NULL
                      || pattern23 (x6) != 0)
                    return -1;
                  *pnum_clobbers = 2;
                  return 71; /* mn10300_load_pic1 */

                default:
                  return -1;
                }

            case 3:
              if (XINT (x3, 1) != 8)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x22 = XVECEXP (x3, 0, 1);
              if (!liw_operand (x22, E_VOIDmode))
                return -1;
              x23 = XVECEXP (x3, 0, 2);
              operands[4] = x23;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              x21 = XVECEXP (x3, 0, 0);
              if (!rtx_equal_p (x21, operands[0]))
                return -1;
              x9 = XEXP (x4, 1);
              switch (GET_CODE (x9))
                {
                case UNSPEC:
                  if (XVECLEN (x9, 0) != 3
                      || XINT (x9, 1) != 8
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  operands[2] = x22;
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x16 = XVECEXP (x9, 0, 1);
                  operands[3] = x16;
                  if (!liw_operand (operands[3], E_VOIDmode))
                    return -1;
                  x17 = XVECEXP (x9, 0, 2);
                  operands[5] = x17;
                  if (!const_int_operand (operands[5], E_SImode))
                    return -1;
                  x18 = XVECEXP (x9, 0, 0);
                  if (!rtx_equal_p (x18, operands[1])
                      || !
#line 2146 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_ALLOW_LIW))
                    return -1;
                  return 72; /* liw */

                case COMPARE:
                  if (GET_MODE (x9) != E_CCmode)
                    return -1;
                  x6 = XEXP (x4, 0);
                  if (GET_CODE (x6) != REG
                      || REGNO (x6) != 51
                      || GET_MODE (x6) != E_CCmode)
                    return -1;
                  operands[1] = x22;
                  x15 = XEXP (x9, 0);
                  operands[2] = x15;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x24 = XEXP (x9, 1);
                  operands[3] = x24;
                  if (!liw_operand (operands[3], E_VOIDmode)
                      || !
#line 2178 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_ALLOW_LIW))
                    return -1;
                  return 74; /* liw_cmp */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case DIV:
          if (pattern8 (x1) != 0)
            return -1;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case CONST_DOUBLE:
              operands[2] = x8;
              if (!const_1f_operand (operands[2], E_SFmode))
                return -1;
              x10 = XEXP (x3, 1);
              if (GET_CODE (x10) != SQRT
                  || GET_MODE (x10) != E_SFmode)
                return -1;
              x19 = XEXP (x10, 0);
              operands[1] = x19;
              if (!register_operand (operands[1], E_SFmode)
                  || !
#line 1888 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              return 57; /* rsqrtsf2 */

            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!register_operand (operands[1], E_SFmode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[2] = x10;
              if (!nonmemory_operand (operands[2], E_SFmode)
                  || !
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              return 61; /* divsf3 */

            default:
              return -1;
            }

        case FMA:
          if (pattern8 (x1) != 0)
            return -1;
          x10 = XEXP (x3, 1);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SFmode))
            return -1;
          x8 = XEXP (x3, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!register_operand (operands[1], E_SFmode))
                return -1;
              x25 = XEXP (x3, 2);
              switch (pattern26 (x25))
                {
                case 0:
                  if (!
#line 1972 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 62; /* fmasf4 */

                case 1:
                  if (!
#line 1985 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 63; /* fmssf4 */

                default:
                  return -1;
                }

            case NEG:
              if (GET_MODE (x8) != E_SFmode)
                return -1;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              if (!register_operand (operands[1], E_SFmode))
                return -1;
              x25 = XEXP (x3, 2);
              switch (pattern26 (x25))
                {
                case 0:
                  if (!
#line 1998 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 64; /* fnmasf4 */

                case 1:
                  if (!
#line 2011 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                    return -1;
                  return 65; /* fnmssf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x8 = XEXP (x3, 0);
          if (!comparison_operator (x8, E_VOIDmode))
            return -1;
          operands[0] = x8;
          x11 = XEXP (x8, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 51)
            return -1;
          x14 = XEXP (x8, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x3, 1);
          if (GET_CODE (x10) != LABEL_REF)
            return -1;
          x25 = XEXP (x3, 2);
          if (GET_CODE (x25) != PC)
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != UNSPEC
              || XVECLEN (x4, 0) != 1
              || XINT (x4, 1) != 9)
            return -1;
          x26 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x26) != CONST_INT)
            return -1;
          x19 = XEXP (x10, 0);
          operands[1] = x19;
          switch (XWINT (x26, 0))
            {
            case 1L:
              if (GET_MODE (x11) != E_CCmode
                  || !
#line 2204 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33 && TARGET_ALLOW_SETLB))
                return -1;
              return 76; /* Lcc */

            case 2L:
              if (GET_MODE (x11) != E_CC_FLOATmode
                  || !
#line 2215 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2 && TARGET_ALLOW_SETLB))
                return -1;
              return 77; /* FLcc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[0] = x6;
      if (!const_int_operand (operands[0], E_SImode))
        return -1;
      return 67; /* return_ret */

    default:
      return -1;
    }
}
