/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 51
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

int
pattern13 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern22 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x7, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x7, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x3;
          operands[1] = x2;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (nonimmediate_operand (operands[0], E_QImode)
                  && general_operand (operands[1], E_QImode)
                  && 
#line 244 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
((register_operand (operands[0], QImode)
    || register_operand (operands[1], QImode))))
                return 1; /* *movqi_internal */
              break;

            case E_HImode:
              if (nonimmediate_operand (operands[0], E_HImode)
                  && general_operand (operands[1], E_HImode)
                  && 
#line 292 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
((register_operand (operands[0], HImode)
    || register_operand (operands[1], HImode))))
                return 2; /* *movhi_internal */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && general_operand (operands[1], E_SImode)
                  && 
#line 435 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(register_operand (operands[0], SImode)
   || register_operand (operands[1], SImode)))
                return 3; /* *movsi_internal */
              break;

            case E_SFmode:
              if (nonimmediate_operand (operands[0], E_SFmode)
                  && general_operand (operands[1], E_SFmode)
                  && 
#line 506 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2
   && (register_operand (operands[0], SFmode)
       || register_operand (operands[1], SFmode))))
                return 4; /* *movsf_internal */
              break;

            default:
              break;
            }
          break;

        case PC:
          operands[0] = x2;
          if (register_operand (operands[0], E_SImode))
            return 42; /* indirect_jump */
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case CONST_INT:
          if (pnum_clobbers == NULL
              || XWINT (x2, 0) != 0L)
            return -1;
          switch (pattern2 (x3))
            {
            case 0:
              *pnum_clobbers = 1;
              return 5; /* *movqi_clr */

            case 1:
              *pnum_clobbers = 1;
              return 6; /* *movhi_clr */

            case 2:
              *pnum_clobbers = 1;
              return 7; /* *movsi_clr */

            default:
              return -1;
            }

        case LABEL_REF:
          if (GET_CODE (x3) != PC)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          return 41; /* jump */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern13 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 8; /* addsi3 */

            case E_SFmode:
              if (pattern13 (x2, 
E_SFmode) != 0
                  || !
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 58; /* addsf3 */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != LTU
              || GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 51
              || GET_MODE (x7) != E_CCmode)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x9 = XEXP (x4, 1);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || !reg_or_am33_const_operand (operands[2], E_SImode)
              || !
#line 625 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 10; /* addc_internal */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern13 (x2, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 13; /* subsi3 */

            case E_SFmode:
              if (pattern13 (x2, 
E_SFmode) != 0
                  || !
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 59; /* subsf3 */

            default:
              return -1;
            }

        case MINUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != GEU
              || GET_MODE (x5) != E_SImode)
            return -1;
          x10 = XEXP (x5, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 51
              || GET_MODE (x10) != E_CCmode)
            return -1;
          x11 = XEXP (x5, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (!reg_or_am33_const_operand (operands[2], E_SImode)
              || !
#line 825 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 15; /* subc_internal */

        default:
          return -1;
        }

    case NEG:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 18; /* negsi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 1863 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
            return -1;
          return 56; /* negsf2 */

        default:
          return -1;
        }

    case MULT:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!reg_or_am33_const_operand (operands[3], E_SImode))
            return -1;
          *pnum_clobbers = 2;
          return 21; /* *mulsi3 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SFmode)
              || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
            return -1;
          *pnum_clobbers = 1;
          return 60; /* mulsf3 */

        default:
          return -1;
        }

    case UNSPEC:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          switch (XINT (x2, 1))
            {
            case 6:
              x12 = XVECEXP (x2, 0, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              return 23; /* ext_internal */

            case 2:
              if (pnum_clobbers == NULL)
                return -1;
              x12 = XVECEXP (x2, 0, 0);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              if (
#line 2089 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33))
                {
                  *pnum_clobbers = 1;
                  return 69; /* am33_load_pic */
                }
              *pnum_clobbers = 2;
              return 70; /* mn10300_load_pic0 */

            default:
              return -1;
            }

        case 2:
          if (pnum_clobbers == NULL
              || XINT (x2, 1) != 7)
            return -1;
          x12 = XVECEXP (x2, 0, 0);
          operands[1] = x12;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x13 = XVECEXP (x2, 0, 1);
          operands[2] = x13;
          if (!nonmemory_operand (operands[2], E_SImode)
              || !
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33))
            return -1;
          *pnum_clobbers = 1;
          return 54; /* *bsch */

        default:
          return -1;
        }

    case AND:
      if (pattern0 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 25; /* andsi3 */

    case IOR:
      if (pattern0 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 27; /* iorsi3 */

    case XOR:
      if (pattern0 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 29; /* xorsi3 */

    case NOT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 31; /* one_cmplsi2 */

    case IF_THEN_ELSE:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          x14 = XEXP (x2, 2);
          if (GET_CODE (x14) != PC)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != PC)
            return -1;
          switch (GET_CODE (x4))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
              res = recog_1 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) == REG)
            {
              operands[2] = x6;
              if (int_mode_flags (operands[2], E_VOIDmode))
                {
                  x9 = XEXP (x4, 1);
                  if (x9 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    {
                      x5 = XEXP (x2, 1);
                      if (GET_CODE (x5) == LABEL_REF)
                        {
                          operands[0] = x4;
                          if (comparison_operator (operands[0], E_VOIDmode))
                            {
                              x10 = XEXP (x5, 0);
                              operands[1] = x10;
                              if (
#line 1424 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed))
                                return 35; /* *integer_conditional_branch */
                            }
                        }
                    }
                }
              if (REGNO (x6) == 51
                  && GET_MODE (x6) == E_CC_FLOATmode)
                {
                  x9 = XEXP (x4, 1);
                  if (x9 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    {
                      x5 = XEXP (x2, 1);
                      if (GET_CODE (x5) == LABEL_REF)
                        {
                          operands[0] = x4;
                          if (comparison_operator (operands[0], E_VOIDmode))
                            {
                              x10 = XEXP (x5, 0);
                              operands[1] = x10;
                              if (
#line 1501 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2 && reload_completed))
                                return 40; /* *float_conditional_branch */
                            }
                        }
                    }
                }
            }
          if (!ordered_comparison_operator (x4, E_VOIDmode))
            return -1;
          operands[3] = x4;
          operands[0] = x6;
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[1] = x9;
          if (!nonmemory_operand (operands[1], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!label_ref_operand (operands[2], E_VOIDmode)
              || !
#line 1476 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
            return -1;
          return 38; /* *cbranchsf4_cmp */

        default:
          return -1;
        }

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 51)
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[0] = x4;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (nonmemory_operand (operands[1], E_SImode)
              && register_operand (operands[0], E_SImode)
              && 
#line 1397 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed))
            return 34; /* cmpsi */
          if (!nonmemory_operand (operands[1], E_SFmode)
              || GET_MODE (x3) != E_CC_FLOATmode
              || GET_MODE (x2) != E_CC_FLOATmode
              || !register_operand (operands[0], E_SFmode)
              || !
#line 1489 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2 && reload_completed))
            return -1;
          return 39; /* *am33_cmpsf */

        case AND:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CCZNmode
              || GET_MODE (x2) != E_CCZNmode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          operands[1] = x9;
          if (!immediate_operand (operands[1], E_SImode)
              || !
#line 1452 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed))
            return -1;
          return 37; /* *btstsi */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!call_address_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      return 45; /* call_value_internal */

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 47; /* zero_extendqisi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 48; /* zero_extendhisi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 49; /* extendqisi2 */

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 50; /* extendhisi2 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern1 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 51; /* ashlsi3 */

    case LSHIFTRT:
      if (pattern1 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 52; /* lshrsi3 */

    case ASHIFTRT:
      if (pattern1 (x1, pnum_clobbers) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 53; /* ashrsi3 */

    case ABS:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 1852 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
        return -1;
      return 55; /* abssf2 */

    case DIV:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_DOUBLE:
          operands[2] = x4;
          if (!const_1f_operand (operands[2], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != SQRT
              || GET_MODE (x5) != E_SFmode)
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 1888 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
            return -1;
          *pnum_clobbers = 1;
          return 57; /* rsqrtsf2 */

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (!nonmemory_operand (operands[2], E_SFmode)
              || !
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
            return -1;
          *pnum_clobbers = 1;
          return 61; /* divsf3 */

        default:
          return -1;
        }

    case FMA:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          x14 = XEXP (x2, 2);
          switch (pattern21 (x14))
            {
            case 0:
              if (!
#line 1972 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 62; /* fmasf4 */

            case 1:
              if (!
#line 1985 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 63; /* fmssf4 */

            default:
              return -1;
            }

        case NEG:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          x14 = XEXP (x2, 2);
          switch (pattern21 (x14))
            {
            case 0:
              if (!
#line 1998 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 64; /* fnmasf4 */

            case 1:
              if (!
#line 2011 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(TARGET_AM33_2))
                return -1;
              *pnum_clobbers = 1;
              return 65; /* fnmssf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
