/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 51
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MOD
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x2, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  operands[4] = x10;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  return 0;
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != SET)
            return NULL;
          x4 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x4) != CLOBBER
              || pattern3 (x1) != 0)
            return NULL;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          if (GET_MODE (x6) != E_SImode)
            return NULL;
          x7 = XEXP (x4, 0);
          operands[6] = x7;
          if (!scratch_operand (operands[6], E_SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          switch (GET_CODE (x8))
            {
            case PLUS:
              if (GET_CODE (x6) != PLUS)
                return NULL;
              x9 = XEXP (x6, 0);
              if (pattern14 (x9) != 0)
                return NULL;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (!nonmemory_operand (operands[3], E_SImode)
                  || pattern28 (x6) != 0
                  || !
#line 676 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed))
                return NULL;
              return gen_split_1 (insn, operands);

            case MINUS:
              if (GET_CODE (x6) != MINUS
                  || pattern16 (x6) != 0)
                return NULL;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x11 = XEXP (x8, 1);
              operands[4] = x11;
              if (!nonmemory_operand (operands[4], E_SImode)
                  || pattern27 (x6) != 0
                  || !
#line 877 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed))
                return NULL;
              return gen_split_3 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != SET)
            return NULL;
          x4 = XVECEXP (x1, 0, 2);
          if (pattern9 (x4, 
E_CCmode, 
51) != 0)
            return NULL;
          x12 = XEXP (x2, 0);
          operands[0] = x12;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          operands[2] = x8;
          if (!nonmemory_operand (operands[2], E_SImode))
            return NULL;
          switch (pattern20 (x3))
            {
            case 0:
              return gen_split_2 (insn, operands);

            case 1:
              return gen_split_4 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (pattern4 (x3, 
E_CCmode, 
51) != 0)
            return NULL;
          x12 = XEXP (x2, 0);
          operands[0] = x12;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (GET_MODE (x8) != E_SImode)
            return NULL;
          switch (GET_CODE (x8))
            {
            case NEG:
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_SImode)
                  || !
#line 970 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
( reload_completed))
                return NULL;
              return gen_split_5 (insn, operands);

            case AND:
              x11 = XEXP (x8, 1);
              if (GET_CODE (x11) != CONST_INT)
                return NULL;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (register_operand (operands[1], E_SImode))
                {
                  switch (XWINT (x11, 0))
                    {
                    case 255L:
                      return gen_split_6 (insn, operands);

                    case 65535L:
                      return gen_split_7 (insn, operands);

                    default:
                      break;
                    }
                }
              operands[1] = x11;
              if (!const_int_operand (operands[1], E_SImode)
                  || !rtx_equal_p (x10, operands[0])
                  || !
#line 1246 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed
   && REGNO_DATA_P (true_regnum (operands[0]), 1)
   && mn10300_split_and_operand_count (operands[1]) != 0))
                return NULL;
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SET:
      x13 = XEXP (x1, 1);
      if (GET_CODE (x13) != IF_THEN_ELSE)
        return NULL;
      x14 = XEXP (x13, 0);
      switch (GET_CODE (x14))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[3] = x14;
          if (ordered_comparison_operator (operands[3], E_VOIDmode))
            {
              res = split_1 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          if (!CCZN_comparison_operator (operands[3], E_VOIDmode))
            return NULL;
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != AND
              || GET_MODE (x15) != E_SImode)
            return NULL;
          x16 = XEXP (x14, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x17 = XEXP (x13, 2);
          if (GET_CODE (x17) != PC)
            return NULL;
          x18 = XEXP (x1, 0);
          if (GET_CODE (x18) != PC)
            return NULL;
          x19 = XEXP (x15, 0);
          operands[0] = x19;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x20 = XEXP (x15, 1);
          operands[1] = x20;
          if (!immediate_operand (operands[1], E_SImode))
            return NULL;
          x21 = XEXP (x13, 1);
          operands[2] = x21;
          if (!label_ref_operand (operands[2], E_VOIDmode)
              || !
#line 1439 "../../gcc-15.0.1-20250313/gcc/config/mn10300/mn10300.md"
(reload_completed))
            return NULL;
          return gen_split_10 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
