/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SFmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 51
      || GET_MODE (x5) != E_CC_FLOATmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SFmode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != LTU
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case ASHIFTRT:
      return pattern24 (x4, 
SIGN_EXTEND); /* [-1, 0] */

    case LSHIFTRT:
      if (pattern24 (x4, 
ZERO_EXTEND) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET
      || pattern3 (x1) != 0)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (pattern15 (x5) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (!nonmemory_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      x11 = XEXP (x10, 1);
      operands[4] = x11;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x12 = XEXP (x5, 1);
      operands[5] = x12;
      if (!reg_or_am33_const_operand (operands[5], E_SImode))
        return -1;
      x13 = XEXP (x6, 0);
      operands[6] = x13;
      if (!scratch_operand (operands[6], E_SImode))
        return -1;
      x14 = XEXP (x10, 0);
      x15 = XEXP (x14, 0);
      x16 = XEXP (x15, 0);
      if (!rtx_equal_p (x16, operands[2]))
        return -1;
      x17 = XEXP (x15, 1);
      if (!rtx_equal_p (x17, operands[3]))
        return -1;
      x18 = XEXP (x14, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      return 11; /* adddi3_internal */

    case MINUS:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (pattern17 (x5) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[4] = x8;
      if (!nonmemory_operand (operands[4], E_SImode))
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      x14 = XEXP (x10, 0);
      operands[3] = x14;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x11 = XEXP (x10, 1);
      operands[5] = x11;
      if (!reg_or_am33_const_operand (operands[5], E_SImode))
        return -1;
      x13 = XEXP (x6, 0);
      operands[6] = x13;
      if (!scratch_operand (operands[6], E_SImode))
        return -1;
      x12 = XEXP (x5, 1);
      x19 = XEXP (x12, 0);
      if (!rtx_equal_p (x19, operands[2]))
        return -1;
      x20 = XEXP (x12, 1);
      if (!rtx_equal_p (x20, operands[4]))
        return -1;
      return 16; /* subdi3_internal */

    case UDIV:
      if (pattern18 (x1) != 0)
        return -1;
      return 22; /* *udivmodsi4 */

    case DIV:
      if (pattern19 (x1) != 0)
        return -1;
      return 24; /* *divmodsi4 */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 2)
        return -1;
      x21 = XVECEXP (x3, 0, 0);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x9 = XEXP (x4, 0);
      if (GET_CODE (x9) != MEM
          || pattern23 (x9) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (pattern9 (x6, 
E_SImode, 
50) != 0)
        return -1;
      return 71; /* mn10300_load_pic1 */

    default:
      return -1;
    }
}
