/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!reg_or_u6_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 1; /* nop */

    case SET:
      return recog_2 (x1, insn, pnum_clobbers);

    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case SIMPLE_RETURN:
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != USE)
            return -1;
          x4 = XEXP (x3, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          return 80; /* *simple_return */

        case SET:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case UNSPEC:
              if (pattern9 (x5, 
E_SImode, 
0) != 0)
                return -1;
              x3 = XVECEXP (x1, 0, 1);
              if (pattern10 (x3) != 0)
                return -1;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              return 82; /* set_got */

            case PLUS:
              if (GET_MODE (x5) != E_SImode)
                return -1;
              x3 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x3) != CLOBBER)
                return -1;
              x4 = XEXP (x3, 0);
              if (GET_CODE (x4) != MEM
                  || GET_MODE (x4) != E_BLKmode)
                return -1;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != SCRATCH)
                return -1;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x8 = XEXP (x5, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (!reg_or_s16_operand (operands[2], E_SImode)
                  || !
#line 738 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
(reload_completed))
                return -1;
              return 83; /* frame_addsi3 */

            case UNSPEC_VOLATILE:
              if (pattern9 (x5, 
E_BImode, 
2) != 0)
                return -1;
              x6 = XEXP (x2, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 34
                  || GET_MODE (x6) != E_BImode)
                return -1;
              x3 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x3) != SET)
                return -1;
              x4 = XEXP (x3, 0);
              operands[0] = x4;
              if (!memory_operand (operands[0], E_SImode))
                return -1;
              x10 = XEXP (x3, 1);
              operands[1] = x10;
              if (!reg_or_0_operand (operands[1], E_SImode))
                return -1;
              return 86; /* store_conditional_si */

            case CALL:
              x8 = XEXP (x5, 0);
              if (GET_CODE (x8) != MEM
                  || GET_MODE (x8) != E_SImode)
                return -1;
              x3 = XVECEXP (x1, 0, 1);
              if (pattern10 (x3) != 0)
                return -1;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x11 = XEXP (x8, 0);
              operands[1] = x11;
              if (!call_insn_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (!
#line 994 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
(!SIBLING_CALL_P (insn)))
                return -1;
              return 89; /* *call_value */

            default:
              return -1;
            }

        case CALL:
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_SImode)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (pattern10 (x3) != 0)
            return -1;
          x12 = XEXP (x6, 0);
          operands[0] = x12;
          if (!call_insn_operand (operands[0], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
(!SIBLING_CALL_P (insn)))
            return -1;
          return 87; /* *call */

        default:
          return -1;
        }

    case CALL:
      x13 = XEXP (x1, 0);
      if (GET_CODE (x13) != MEM
          || GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XEXP (x13, 0);
      operands[0] = x14;
      if (!call_insn_operand (operands[0], E_SImode))
        return -1;
      x15 = XEXP (x1, 1);
      operands[1] = x15;
      if (pnum_clobbers != NULL
          && 
#line 974 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
(!SIBLING_CALL_P (insn)))
        {
          *pnum_clobbers = 1;
          return 87; /* *call */
        }
      if (!
#line 983 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
(SIBLING_CALL_P (insn)))
        return -1;
      return 88; /* *sibcall */

    default:
      return -1;
    }
}
