/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!reg_or_u16_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      if (!general_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[0], E_DImode)
          || !(
#line 351 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
(register_operand (operands[0], DImode)
   || reg_or_0_operand (operands[1], DImode)) && 
#line 354 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
( 1)))
        return NULL;
      return gen_split_1 (insn, operands);

    case NE:
    case EQ:
      operands[1] = x3;
      if (pattern7 (operands[1]) != 0
          || !register_operand (operands[0], E_SImode)
          || !
#line 524 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
(reload_completed))
        return NULL;
      return gen_split_2 (insn, operands);

    case IF_THEN_ELSE:
      x4 = XEXP (x3, 0);
      if (!equality_comparison_operator (x4, E_VOIDmode))
        return NULL;
      operands[3] = x4;
      if (pattern8 (x4) != 0)
        return NULL;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (pattern12 (x3))
        {
        case 0:
          if (!
#line 557 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
(!TARGET_CMOV))
            return NULL;
          return gen_split_3 (insn, operands);

        case 1:
          if (!
#line 557 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
(!TARGET_CMOV))
            return NULL;
          return gen_split_4 (insn, operands);

        case 2:
          if (!
#line 557 "../../gcc-15.0.1-20250313/gcc/config/or1k/or1k.md"
(!TARGET_CMOV))
            return NULL;
          return gen_split_5 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
