/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !shift_count_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_V1QImode:
      return pattern12 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern12 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern12 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern12 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern12 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern12 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern12 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern12 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern12 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (x2, E_V1SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1SImode)
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (x2, E_V2SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (x2, E_V4SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (x2, E_V1DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1DImode)
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (x2, E_V2DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V2DImode)
        return -1;
      return 13;

    case E_V1TImode:
      if (!register_operand (x2, E_V1TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_V1TImode)
        return -1;
      return 14;

    case E_TImode:
      if (!register_operand (x2, E_TImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TImode)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern30 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern30 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCRAWmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  return 0;
}

int
pattern37 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern44 (rtx x1, int i1, int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i3
      || XVECLEN (x2, 0) != i2
      || XINT (x2, 1) != i1)
    return -1;
  return 0;
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x1) != E_TImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, int *pnum_clobbers, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern65 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern0 (x1, 
E_V1SFmode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern0 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern0 (x1, 
E_V1DFmode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern0 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 18;

    case E_V1TFmode:
      if (pattern0 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 19;

    case E_V1TImode:
      if (pattern0 (x1, 
E_V1TImode) != 0)
        return -1;
      return 20;

    case E_TImode:
      if (pattern0 (x1, 
E_TImode) != 0)
        return -1;
      return 21;

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_DImode) != 0)
        return -1;
      return 22;

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_HImode) != 0)
        return -1;
      return 23;

    case E_QImode:
      if (pnum_clobbers == NULL
          || pattern64 (x1, 
E_QImode) != 0)
        return -1;
      return 24;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern115 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern115 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern121 (x5, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern121 (x5, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_HImode:
      if (pattern121 (x5, 
E_HImode) != 0)
        return -1;
      return 2;

    case E_QImode:
      if (pattern121 (x5, 
E_QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern148 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != ASHIFT
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 0)
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x6, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x9 = XEXP (x5, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x10 = XEXP (x3, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x11) != SET)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != i1
      || GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != SIGN_EXTEND
      || GET_MODE (x13) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  x14 = XEXP (x7, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x15 = XEXP (x11, 0);
  operands[0] = x15;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x16 = XEXP (x13, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  return 0;
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  return pattern170 (); /* [-1, 1] */
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !memory_operand (operands[2], E_HImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern208 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern236 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern242 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !const0_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern249 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !s390_slb_comparison (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern268 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern276 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !general_operand (operands[2], i1)
      || pattern282 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern293 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (1));
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != i1
      || GET_MODE (x10) != E_BLKmode)
    return -1;
  x11 = XEXP (x9, 0);
  operands[3] = x11;
  x12 = XEXP (x10, 1);
  operands[4] = x12;
  if (!memory_operand (operands[4], E_BLKmode))
    return -1;
  x13 = XVECEXP (x8, 0, 1);
  x14 = XEXP (x13, 0);
  operands[5] = x14;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern25 (x1, 
E_CCZmode) != 0
      || !const_int_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !(
#line 3798 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 1893; /* *TDC_insn_tf */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || !(
#line 3798 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 745 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1894; /* *TDC_insn_fprx2 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || !
#line 3798 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1895; /* *TDC_insn_df */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !
#line 3798 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 1896; /* *TDC_insn_sf */

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || !(
#line 3798 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1897; /* *TDC_insn_td */

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || !(
#line 3798 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 746 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1898; /* *TDC_insn_dd */

    case E_SDmode:
      if (!register_operand (operands[0], E_SDmode)
          || !(
#line 3798 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 1899; /* *TDC_insn_sd */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || pattern35 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SFmode)
          || !(
#line 1927 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 405; /* *vftciv4sf_cconly */

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 1927 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
        return -1;
      *pnum_clobbers = 1;
      return 406; /* *vftciv2df_cconly */

    case E_V1TFmode:
      if (!register_operand (operands[1], E_V1TFmode)
          || !(
#line 1927 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 407; /* *vftciv1tf_cconly */

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !(
#line 1927 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      *pnum_clobbers = 1;
      return 408; /* *vftcitf_cconly */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XINT (x3, 1))
    {
    case 73:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern19 (x3, 
E_V8HImode) != 0
              || !
#line 402 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 33; /* vec_zpermv8hi */

        case E_V4SImode:
          if (pattern19 (x3, 
E_V4SImode) != 0
              || !
#line 402 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 34; /* vec_zpermv4si */

        case E_V4SFmode:
          if (pattern19 (x3, 
E_V4SFmode) != 0
              || !(
#line 402 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 44 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 35; /* vec_zpermv4sf */

        case E_V2DImode:
          if (pattern19 (x3, 
E_V2DImode) != 0
              || !
#line 402 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 36; /* vec_zpermv2di */

        case E_V2DFmode:
          if (pattern19 (x3, 
E_V2DFmode) != 0
              || !
#line 402 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 37; /* vec_zpermv2df */

        case E_V16QImode:
          if (pattern19 (x3, 
E_V16QImode) != 0
              || !
#line 763 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 647; /* vec_permv16qi */

        default:
          return -1;
        }

    case 83:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 677 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 116; /* vacq */

    case 84:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 690 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 117; /* vacccq */

    case 90:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern53 (x3, 
E_V8HImode, 
E_V16QImode) != 0
              || !
#line 870 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 144; /* vec_gfmsum_accumv16qi */

        case E_V4SImode:
          if (pattern53 (x3, 
E_V4SImode, 
E_V8HImode) != 0
              || !
#line 870 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 145; /* vec_gfmsum_accumv8hi */

        case E_V2DImode:
          if (pattern53 (x3, 
E_V2DImode, 
E_V4SImode) != 0
              || !
#line 870 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 146; /* vec_gfmsum_accumv4si */

        default:
          return -1;
        }

    case 91:
      if (pattern50 (x3, 
E_V2DImode) != 0
          || !
#line 880 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 147; /* vec_gfmsum_accum_128 */

    case 54:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 902 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 148; /* vec_vmalv16qi */

        case 1:
          if (!
#line 902 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 149; /* vec_vmalv8hi */

        case 2:
          if (!
#line 902 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 150; /* vec_vmalv4si */

        case 3:
          if (!(
#line 902 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 151; /* vec_vmalv2di */

        case 4:
          if (!(
#line 902 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 152; /* vec_vmalv1ti */

        case 5:
          if (!(
#line 902 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 153; /* vec_vmalti */

        default:
          return -1;
        }

    case 55:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 915 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 154; /* vec_vmahv16qi */

        case 1:
          if (!
#line 915 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 155; /* vec_vmahv8hi */

        case 2:
          if (!
#line 915 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 156; /* vec_vmahv4si */

        case 3:
          if (!(
#line 915 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 157; /* vec_vmahv2di */

        case 4:
          if (!(
#line 915 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 158; /* vec_vmahv1ti */

        case 5:
          if (!(
#line 915 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 159; /* vec_vmahti */

        default:
          return -1;
        }

    case 56:
      switch (pattern52 (x3))
        {
        case 0:
          if (!
#line 926 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 160; /* vec_vmalhv16qi */

        case 1:
          if (!
#line 926 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 161; /* vec_vmalhv8hi */

        case 2:
          if (!
#line 926 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 162; /* vec_vmalhv4si */

        case 3:
          if (!(
#line 926 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 163; /* vec_vmalhv2di */

        case 4:
          if (!(
#line 926 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 164; /* vec_vmalhv1ti */

        case 5:
          if (!(
#line 926 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 165; /* vec_vmalhti */

        default:
          return -1;
        }

    case 57:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 939 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 166; /* vec_vmaev16qi */

        case 1:
          if (!
#line 939 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 167; /* vec_vmaev8hi */

        case 2:
          if (!
#line 939 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 168; /* vec_vmaev4si */

        case 3:
          if (!(
#line 939 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 169; /* vec_vmaev2di */

        default:
          return -1;
        }

    case 58:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 950 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 170; /* vec_vmalev16qi */

        case 1:
          if (!
#line 950 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 171; /* vec_vmalev8hi */

        case 2:
          if (!
#line 950 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 172; /* vec_vmalev4si */

        case 3:
          if (!(
#line 950 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 173; /* vec_vmalev2di */

        default:
          return -1;
        }

    case 59:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 963 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 174; /* vec_vmaov16qi */

        case 1:
          if (!
#line 963 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 175; /* vec_vmaov8hi */

        case 2:
          if (!
#line 963 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 176; /* vec_vmaov4si */

        case 3:
          if (!(
#line 963 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 177; /* vec_vmaov2di */

        default:
          return -1;
        }

    case 60:
      switch (pattern54 (x3))
        {
        case 0:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 178; /* vec_vmalov16qi */

        case 1:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 179; /* vec_vmalov8hi */

        case 2:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 180; /* vec_vmalov4si */

        case 3:
          if (!(
#line 974 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 54 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 181; /* vec_vmalov2di */

        default:
          return -1;
        }

    case 99:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 237; /* vec_sldv16qi */

        case 1:
          if (!
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 238; /* vec_sldv8hi */

        case 2:
          if (!
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 239; /* vec_sldv4si */

        case 3:
          if (!
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 240; /* vec_sldv2di */

        case 4:
          if (!
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 241; /* vec_sldv1ti */

        case 5:
          if (!
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 242; /* vec_sldti */

        case 6:
          if (!
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 243; /* vec_sldv2df */

        case 7:
          if (!(
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 244; /* vec_sldv4sf */

        case 8:
          if (!(
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 245; /* vec_sldv1tf */

        case 9:
          if (!(
#line 1072 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 246; /* vec_sldtf */

        default:
          return -1;
        }

    case 100:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 247; /* vec_sldbv16qi */

        case 1:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 248; /* vec_sldbv8hi */

        case 2:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 249; /* vec_sldbv4si */

        case 3:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 250; /* vec_sldbv2di */

        case 4:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 251; /* vec_sldbv1ti */

        case 5:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 252; /* vec_sldbti */

        case 6:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 253; /* vec_sldbv2df */

        case 7:
          if (!(
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 254; /* vec_sldbv4sf */

        case 8:
          if (!(
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 255; /* vec_sldbv1tf */

        case 9:
          if (!(
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 256; /* vec_sldbtf */

        default:
          return -1;
        }

    case 101:
      switch (pattern55 (x3))
        {
        case 0:
          if (!
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 257; /* vec_srdbv16qi */

        case 1:
          if (!
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 258; /* vec_srdbv8hi */

        case 2:
          if (!
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 259; /* vec_srdbv4si */

        case 3:
          if (!
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 260; /* vec_srdbv2di */

        case 4:
          if (!
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 261; /* vec_srdbv1ti */

        case 5:
          if (!
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 262; /* vec_srdbti */

        case 6:
          if (!
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
            return -1;
          return 263; /* vec_srdbv2df */

        case 7:
          if (!(
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 264; /* vec_srdbv4sf */

        case 8:
          if (!(
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 34 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 265; /* vec_srdbv1tf */

        case 9:
          if (!(
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 35 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 266; /* vec_srdbtf */

        default:
          return -1;
        }

    case 107:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 1179 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 343; /* vsbiq */

    case 108:
      if (pattern50 (x3, 
E_TImode) != 0
          || !
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 344; /* vsbcbiq */

    case 110:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern19 (x3, 
E_V16QImode) != 0
              || !
#line 1284 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 359; /* vfaev16qi */

        case E_V8HImode:
          if (pattern19 (x3, 
E_V8HImode) != 0
              || !
#line 1284 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 360; /* vfaev8hi */

        case E_V4SImode:
          if (pattern19 (x3, 
E_V4SImode) != 0
              || !
#line 1284 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 361; /* vfaev4si */

        default:
          return -1;
        }

    case 112:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1384 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 365; /* vfeev16qi */

        case 1:
          if (!
#line 1384 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 366; /* vfeev8hi */

        case 2:
          if (!
#line 1384 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 367; /* vfeev4si */

        case 3:
          if (!
#line 1395 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 368; /* vfeezv16qi */

        case 4:
          if (!
#line 1395 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 369; /* vfeezv8hi */

        case 5:
          if (!
#line 1395 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 370; /* vfeezv4si */

        default:
          return -1;
        }

    case 114:
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 371; /* vfenev16qi */

        case 1:
          if (!
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 372; /* vfenev8hi */

        case 2:
          if (!
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 373; /* vfenev4si */

        case 3:
          if (!
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 374; /* vfenezv16qi */

        case 4:
          if (!
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 375; /* vfenezv8hi */

        case 5:
          if (!
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 376; /* vfenezv4si */

        default:
          return -1;
        }

    case 122:
      if (pattern57 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1712 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 392; /* vcdgb */

    case 123:
      if (pattern57 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
          || !
#line 1744 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 393; /* vcdlgb */

    case 124:
      if (pattern57 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1775 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 394; /* vcgdb */

    case 125:
      if (pattern57 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 1808 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) != 2 && UINTVAL (operands[3]) <= 7))
        return -1;
      return 395; /* vclgdb */

    case 126:
      return recog_15 (x1, insn, pnum_clobbers);

    case 128:
      if (pattern57 (x3, 
E_V4SFmode, 
E_V2DFmode) != 0
          || !
#line 1889 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 404; /* vflrd */

    case 132:
      switch (pattern58 (x3))
        {
        case 0:
          if (!
#line 2146 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 473; /* vfminv4sf */

        case 1:
          if (!
#line 2146 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 474; /* vfminv2df */

        case 2:
          if (!
#line 2146 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 475; /* vfminv1tf */

        case 3:
          if (!
#line 2146 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 476; /* vfmintf */

        default:
          return -1;
        }

    case 133:
      switch (pattern58 (x3))
        {
        case 0:
          if (!
#line 2156 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 477; /* vfmaxv4sf */

        case 1:
          if (!
#line 2156 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 478; /* vfmaxv2df */

        case 2:
          if (!
#line 2156 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 479; /* vfmaxv1tf */

        case 3:
          if (!
#line 2156 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
            return -1;
          return 480; /* vfmaxtf */

        default:
          return -1;
        }

    case 92:
      return recog_14 (x1, insn, pnum_clobbers);

    case 140:
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[0], E_V8HImode))
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      if (!const_mask_operand (operands[3], E_QImode)
          || !
#line 2245 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 503; /* vcrnfs_v8hi */

    case 134:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern51 (x3, 
E_V16QImode) != 0
              || !
#line 2274 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 506; /* vblendv16qi */

        case E_V8HImode:
          if (pattern51 (x3, 
E_V8HImode) != 0
              || !
#line 2274 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 507; /* vblendv8hi */

        case E_V4SImode:
          if (pattern51 (x3, 
E_V4SImode) != 0
              || !
#line 2274 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 508; /* vblendv4si */

        case E_V2DImode:
          if (pattern51 (x3, 
E_V2DImode) != 0
              || !
#line 2274 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 509; /* vblendv2di */

        case E_V2DFmode:
          if (pattern153 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2274 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 510; /* vblendv2df */

        case E_V1TImode:
          if (pattern51 (x3, 
E_V1TImode) != 0
              || !
#line 2274 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 511; /* vblendv1ti */

        case E_TImode:
          if (pattern51 (x3, 
E_TImode) != 0
              || !
#line 2274 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE3))
            return -1;
          return 512; /* vblendti */

        case E_V4SFmode:
          if (pattern153 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
              || !(
#line 2274 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE3) && 
#line 47 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 513; /* vblendv4sf */

        case E_V1TFmode:
          if (pattern153 (x3, 
E_V1TImode, 
E_V1TFmode) != 0
              || !(
#line 2274 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE3) && 
#line 47 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 514; /* vblendv1tf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2638 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1502; /* zero_extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2638 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1504; /* zero_extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2638 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1506; /* zero_extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2638 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1508; /* zero_extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2638 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1510; /* zero_extendv4hiv4si2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5326 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2036; /* *zero_extendqihi2_64 */
          if (!
#line 5334 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2037; /* *zero_extendqihi2_31 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 2694 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1513; /* vec_unpacku_hi_v16qi */

        case 1:
          if (!
#line 2705 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1514; /* vec_unpacku_lo_v16qi */

        case 2:
          if (!
#line 2741 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1517; /* vec_unpacku_hi_v8hi */

        case 3:
          if (!
#line 2751 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1518; /* vec_unpacku_lo_v8hi */

        case 4:
          if (!
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1521; /* vec_unpacku_hi_v4si */

        case 5:
          if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1522; /* vec_unpacku_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case GTU:
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_53 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_DImode)
          && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2298; /* *sconddi */
        }
      if (!s390_slb_comparison (operands[1], E_DImode)
          || !
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2300; /* *sconddi_neg */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_SImode))
        {
          *pnum_clobbers = 1;
          return 2299; /* *scondsi */
        }
      if (!s390_slb_comparison (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 2301; /* *scondsi_neg */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      return recog_22 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_23 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 816; /* iorv1qi3 */
          break;

        case 1:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 817; /* iorv2qi3 */
          break;

        case 2:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 818; /* iorv4qi3 */
          break;

        case 3:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 819; /* iorv8qi3 */
          break;

        case 4:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 820; /* iorv16qi3 */
          break;

        case 5:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 821; /* iorv1hi3 */
          break;

        case 6:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 822; /* iorv2hi3 */
          break;

        case 7:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 823; /* iorv4hi3 */
          break;

        case 8:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 824; /* iorv8hi3 */
          break;

        case 9:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 825; /* iorv1si3 */
          break;

        case 10:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 826; /* iorv2si3 */
          break;

        case 11:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 827; /* iorv4si3 */
          break;

        case 12:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 828; /* iorv1di3 */
          break;

        case 13:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 829; /* iorv2di3 */
          break;

        case 14:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 830; /* iorv1sf3 */
          break;

        case 15:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 831; /* iorv2sf3 */
          break;

        case 16:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 832; /* iorv4sf3 */
          break;

        case 17:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 833; /* iorv1df3 */
          break;

        case 18:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 834; /* iorv2df3 */
          break;

        case 19:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 835; /* iorv1tf3 */
          break;

        case 20:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 836; /* iorv1ti3 */
          break;

        case 21:
          if (
#line 1276 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 837; /* iorti3 */
          break;

        case 22:
          if (
#line 8363 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2364; /* *iordi3 */
            }
          break;

        case 23:
          if (
#line 8500 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2369; /* *iorhi3_zarch */
            }
          if (
#line 8516 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2370; /* *iorhi3_esa */
            }
          break;

        case 24:
          if (
#line 8543 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2371; /* *iorqi3_zarch */
            }
          if (
#line 8561 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2372; /* *iorqi3_esa */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern131 (x3) == 0
          && 
#line 4785 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 1996; /* *rosbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      if (
#line 8444 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        {
          *pnum_clobbers = 1;
          return 2367; /* *iorsi3_zarch */
        }
      if (!
#line 8472 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2368; /* *iorsi3_esa */

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1577; /* *vevalv1qi_iorior */

        case 1:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1586; /* *vevalv2qi_iorior */

        case 2:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1595; /* *vevalv4qi_iorior */

        case 3:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1604; /* *vevalv8qi_iorior */

        case 4:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1613; /* *vevalv16qi_iorior */

        case 5:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1622; /* *vevalv1hi_iorior */

        case 6:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1631; /* *vevalv2hi_iorior */

        case 7:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1640; /* *vevalv4hi_iorior */

        case 8:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1649; /* *vevalv8hi_iorior */

        case 9:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1658; /* *vevalv1si_iorior */

        case 10:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1667; /* *vevalv2si_iorior */

        case 11:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1676; /* *vevalv4si_iorior */

        case 12:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1685; /* *vevalv1di_iorior */

        case 13:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1694; /* *vevalv2di_iorior */

        case 14:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1703; /* *vevalv1ti_iorior */

        case 15:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1712; /* *vevalti_iorior */

        default:
          return -1;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1578; /* *vevalv1qi_iorxor */

        case 1:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1587; /* *vevalv2qi_iorxor */

        case 2:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1596; /* *vevalv4qi_iorxor */

        case 3:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1605; /* *vevalv8qi_iorxor */

        case 4:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1614; /* *vevalv16qi_iorxor */

        case 5:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1623; /* *vevalv1hi_iorxor */

        case 6:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1632; /* *vevalv2hi_iorxor */

        case 7:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1641; /* *vevalv4hi_iorxor */

        case 8:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1650; /* *vevalv8hi_iorxor */

        case 9:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1659; /* *vevalv1si_iorxor */

        case 10:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1668; /* *vevalv2si_iorxor */

        case 11:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1677; /* *vevalv4si_iorxor */

        case 12:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1686; /* *vevalv1di_iorxor */

        case 13:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1695; /* *vevalv2di_iorxor */

        case 14:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1704; /* *vevalv1ti_iorxor */

        case 15:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1713; /* *vevalti_iorxor */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern31 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4746 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1988; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4746 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              *pnum_clobbers = 1;
              return 1990; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case MOD:
              if (pattern132 (x3, 
DIV) != 0
                  || pattern203 (x3) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x8, 1);
              switch (GET_CODE (x11))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[2] = x11;
                  if (!general_operand (operands[2], E_DImode))
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (!rtx_equal_p (x12, operands[2])
                      || !
#line 7663 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2329; /* divmodtidi3 */

                case SIGN_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (GET_CODE (x12) != SIGN_EXTEND
                      || GET_MODE (x12) != E_DImode)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[2] = x13;
                  if (!nonimmediate_operand (operands[2], E_SImode))
                    return -1;
                  x14 = XEXP (x12, 0);
                  if (!rtx_equal_p (x14, operands[2])
                      || !
#line 7681 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2330; /* divmodtisi3 */

                default:
                  return -1;
                }

            case TRUNCATE:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != TRUNCATE)
                return -1;
              x15 = XEXP (x8, 0);
              switch (GET_CODE (x15))
                {
                case UMOD:
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != ZERO_EXTEND)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != UDIV)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != ZERO_EXTEND)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2]))
                    return -1;
                  switch (XWINT (x7, 0))
                    {
                    case 64L:
                      if (pattern269 (x3, 
E_TImode, 
E_DImode) != 0
                          || !
#line 7742 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2331; /* udivmodtidi3 */

                    case 32L:
                      if (pattern269 (x3, 
E_DImode, 
E_SImode) != 0
                          || !
#line 7862 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                        return -1;
                      return 2333; /* udivmoddisi3 */

                    default:
                      return -1;
                    }

                case MOD:
                  if (GET_MODE (x15) != E_DImode)
                    return -1;
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != SIGN_EXTEND
                      || GET_MODE (x16) != E_DImode
                      || XWINT (x7, 0) != 32L)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != DIV
                      || GET_MODE (x10) != E_DImode)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != SIGN_EXTEND
                      || GET_MODE (x17) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode
                      || GET_MODE (x6) != E_DImode
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  if (!nonimmediate_operand (operands[2], E_SImode)
                      || GET_MODE (x5) != E_DImode
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2])
                      || !
#line 7801 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return -1;
                  return 2332; /* divmoddisi3 */

                default:
                  return -1;
                }

            case CLZ:
              if (pnum_clobbers == NULL
                  || pattern132 (x3, 
XOR) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x12 = XEXP (x9, 1);
              if (GET_CODE (x12) != LSHIFTRT)
                return -1;
              x22 = XEXP (x12, 1);
              if (GET_CODE (x22) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x22), 4)
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XEXP (x22, 0);
              if (GET_CODE (x23) != CLZ
                  || GET_MODE (x23) != E_DImode
                  || pattern203 (x3) != 0)
                return -1;
              x14 = XEXP (x12, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x24 = XEXP (x23, 0);
              if (!rtx_equal_p (x24, operands[1])
                  || !
#line 9620 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2500; /* clztidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4765 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1992; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4765 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1994; /* *rosbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern167 (x3, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2208 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 496; /* *vec_extract_bswap_elemv8hi */

        case E_SImode:
          if (pattern167 (x3, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2208 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 497; /* *vec_extract_bswap_elemv4si */

        case E_SFmode:
          if (pattern167 (x3, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2208 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 498; /* *vec_extract_bswap_elemv4sf */

        case E_DImode:
          if (pattern167 (x3, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2208 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 499; /* *vec_extract_bswap_elemv2di */

        case E_DFmode:
          if (pattern167 (x3, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2208 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 500; /* *vec_extract_bswap_elemv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!memory_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 3350 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1568; /* *vstbrv8hi */

        case E_V4SImode:
          if (!memory_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 3350 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1569; /* *vstbrv4si */

        case E_V2DImode:
          if (!memory_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 3350 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1570; /* *vstbrv2di */

        case E_V1TImode:
          if (!memory_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !
#line 3350 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1571; /* *vstbrv1ti */

        case E_TImode:
          if (!memory_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !
#line 3350 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1572; /* *vstbrti */

        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !nonimmediate_operand (operands[1], E_DImode)
              || !
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2631; /* bswapdi2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 2632; /* bswapsi2 */

        case E_HImode:
          if (!nonimmediate_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2633; /* bswaphi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_CONCAT:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_CONCAT)
        return -1;
      x7 = XEXP (x6, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern168 (x3, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 599 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 619; /* *vec_vllezlfv4si */

        case E_V4SFmode:
          if (pattern168 (x3, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
              || !
#line 599 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 620; /* *vec_vllezlfv4sf */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2DImode:
          if (pattern108 (x3, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 2416 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1404; /* *vec_load_pairv2di */

        case E_V2DFmode:
          if (pattern108 (x3, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 2416 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1405; /* *vec_load_pairv2df */

        default:
          return -1;
        }

    case TRUNCATE:
      switch (pattern33 (x3, 
TRUNCATE))
        {
        case 0:
          if (!
#line 2604 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1492; /* vec_pack_trunc_v8hi */

        case 1:
          if (!
#line 2604 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1493; /* vec_pack_trunc_v4si */

        case 2:
          if (!
#line 2604 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1494; /* vec_pack_trunc_v2di */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      switch (pattern33 (x3, 
SS_TRUNCATE))
        {
        case 0:
          if (!
#line 2616 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1495; /* vec_pack_ssat_v8hi */

        case 1:
          if (!
#line 2616 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1496; /* vec_pack_ssat_v4si */

        case 2:
          if (!
#line 2616 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1497; /* vec_pack_ssat_v2di */

        default:
          return -1;
        }

    case US_TRUNCATE:
      switch (pattern33 (x3, 
US_TRUNCATE))
        {
        case 0:
          if (!
#line 2628 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1498; /* vec_pack_usat_v8hi */

        case 1:
          if (!
#line 2628 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1499; /* vec_pack_usat_v4si */

        case 2:
          if (!
#line 2628 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1500; /* vec_pack_usat_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != NEG)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (pattern239 (x1))
        {
        case 0:
          if (!(
#line 9108 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2418; /* *negdi2_cc */

        case 1:
          if (!
#line 9108 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2419; /* *negsi2_cc */

        default:
          return -1;
        }

    case CLOBBER:
      switch (pattern192 (x1))
        {
        case 0:
          if (!(
#line 9119 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2420; /* *negdi2_cconly */

        case 1:
          if (!
#line 9119 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
            return -1;
          return 2421; /* *negsi2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PLUS)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 1);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  x12 = XEXP (x6, 0);
  operands[2] = x12;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonimmediate_operand (operands[2], E_SImode)
          || GET_MODE (x7) != E_SImode)
        return -1;
      *pnum_clobbers = 2;
      return 2538; /* doloop_si64 */

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonimmediate_operand (operands[2], E_DImode)
          || GET_MODE (x7) != E_DImode
          || !
#line 10248 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 2;
      return 2539; /* doloop_di */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (SUBREG_BYTE (x4))
    {
    case 0:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case ROTATE:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XEXP (x3, 1);
          operands[3] = x8;
          if (!contiguous_bitmask_operand (operands[3], E_DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_int_operand (operands[2], E_SImode))
                return -1;
              if (
#line 4372 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1933; /* *risbg_and_subregdi_rotr */
              if (!
#line 4385 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1939; /* *risbg_and_subregdi_rotl */

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_int_operand (operands[2], E_HImode))
                return -1;
              if (
#line 4372 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1935; /* *risbg_and_subregdi_rotr */
              if (!
#line 4385 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1941; /* *risbg_and_subregdi_rotl */

            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !const_int_operand (operands[2], E_QImode))
                return -1;
              if (
#line 4372 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && (UINTVAL (operands[3])
       < (HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)))))
                return 1937; /* *risbg_and_subregdi_rotr */
              if (!
#line 4385 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && !(UINTVAL (operands[3])
	& ((HOST_WIDE_INT_1U << (UINTVAL (operands[2]) & 0x3f)) - 1))))
                return -1;
              return 1943; /* *risbg_and_subregdi_rotl */

            default:
              return -1;
            }

        case SUBREG:
        case MEM:
          operands[1] = x5;
          if (!memory_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != CONST_INT
              || XWINT (x8, 0) != 2147483647L
              || !
#line 5170 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2021; /* *llgt_sidi_split */

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      if (!contiguous_bitmask_nowrap_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!nonzero_shift_count_operand (operands[2], E_DImode)
              || !
#line 4595 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          return 1971; /* *trunc_sidi_and_subreg_lshrt_clobbercc */

        case ZERO_EXTRACT:
          x7 = XEXP (x5, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x5, 2);
          operands[2] = x9;
          if (!nonzero_shift_count_operand (operands[2], E_SImode)
              || !
#line 4609 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
            return -1;
          return 1973; /* *trunc_sidi_and_subreg_ze_clobbercc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (XINT (x3, 1))
        {
        case 69:
          switch (pattern143 (x1, 
68))
            {
            case 0:
              if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 24; /* *vec_packs_ccv8hi */

            case 1:
              if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 25; /* *vec_packs_ccv4si */

            case 2:
              if (!
#line 312 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 26; /* *vec_packs_ccv2di */

            default:
              return -1;
            }

        case 72:
          switch (pattern143 (x1, 
71))
            {
            case 0:
              if (!
#line 387 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 30; /* *vec_packsu_ccv8hi */

            case 1:
              if (!
#line 387 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 31; /* *vec_packsu_ccv4si */

            case 2:
              if (!
#line 387 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 32; /* *vec_packsu_ccv2di */

            default:
              return -1;
            }

        case 130:
          if (GET_MODE (x3) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 33
              || GET_MODE (x6) != E_CCRAWmode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER
              || !const_int_operand (operands[2], E_HImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[0], E_V4SImode)
                  || !(
#line 1927 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 405; /* *vftciv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[0], E_V2DImode)
                  || !
#line 1927 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 406; /* *vftciv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[0], E_V1TImode)
                  || !(
#line 1927 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 407; /* *vftciv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[0], E_TImode)
                  || !(
#line 1927 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 408; /* *vftcitf_cconly */

            default:
              return -1;
            }

        case 129:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern44 (x7, 
130, 
2, 
UNSPEC) != 0)
            return -1;
          x9 = XEXP (x7, 1);
          if (GET_MODE (x9) != E_CCRAWmode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!const_int_operand (operands[2], E_HImode))
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (!rtx_equal_p (x11, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !register_operand (operands[1], E_V4SFmode)
                  || !(
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 409; /* vftciv4sf */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")))
                return -1;
              return 410; /* vftciv2df */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || GET_MODE (x3) != E_V1TFmode
                  || !register_operand (operands[1], E_V1TFmode)
                  || !(
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 411; /* vftciv1tf */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || GET_MODE (x3) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[2]), 'J', "J")) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 412; /* vftcitf */

            default:
              return -1;
            }

        case 1:
          if (pattern38 (x1) != 0
              || !s_operand (operands[1], E_BLKmode)
              || !const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              return 1917; /* *sethighpartsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              if (
#line 4257 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 1918; /* *sethighpartdi_64 */
              if (!
#line 4267 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return -1;
              return 1919; /* *sethighpartdi_31 */

            default:
              return -1;
            }

        case 46:
          if (pattern102 (x1) != 0
              || !address_operand (operands[1], E_VOIDmode)
              || !immediate_operand (operands[2], E_SImode)
              || !
#line 12547 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 2660; /* lcbb */

        default:
          return -1;
        }

    case 3:
      if (pattern68 (x1, 
3) != 0
          || !const_mask_operand (operands[3], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 110:
          switch (pattern281 (x1, 
111))
            {
            case 0:
              if (!
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 362; /* *vfaesv16qi */

            case 1:
              if (!
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 363; /* *vfaesv8hi */

            case 2:
              if (!
#line 1311 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 364; /* *vfaesv4si */

            default:
              return -1;
            }

        case 112:
          switch (pattern281 (x1, 
113))
            {
            case 0:
              if (!
#line 2444 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1407; /* vec_vfeesv16qi */

            case 1:
              if (!
#line 2444 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1408; /* vec_vfeesv8hi */

            case 2:
              if (!
#line 2444 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1409; /* vec_vfeesv4si */

            default:
              return -1;
            }

        case 114:
          switch (pattern281 (x1, 
115))
            {
            case 0:
              if (!
#line 2470 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1410; /* vec_vfenesv16qi */

            case 1:
              if (!
#line 2470 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1411; /* vec_vfenesv8hi */

            case 2:
              if (!
#line 2470 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1412; /* vec_vfenesv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x6 = XEXP (x2, 0);
      operands[0] = x6;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 116:
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x9 = XEXP (x7, 1);
          if (pattern152 (x9, 
E_CCRAWmode, 
117, 
UNSPEC, 
1) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 33
              || GET_MODE (x8) != E_CCRAWmode)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x3) != E_V16QImode
                  || !register_operand (operands[1], E_V16QImode)
                  || !
#line 1513 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 380; /* *vistrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || !register_operand (operands[1], E_V8HImode)
                  || !
#line 1513 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 381; /* *vistrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || !register_operand (operands[1], E_V4SImode)
                  || !
#line 1513 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 382; /* *vistrsv4si */

            default:
              return -1;
            }

        case 4:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern89 (x7) != 0
              || !register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_CCUmode))
            return -1;
          return 1913; /* cmpint */

        case 37:
          x7 = XVECEXP (x1, 0, 1);
          if (pattern89 (x7) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !(
#line 12113 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 792 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2637; /* *popcountdi_z196 */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 12113 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2638; /* *popcountsi_z196 */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !
#line 12113 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2639; /* *popcounthi_z196 */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x3) != E_QImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 12113 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
                return -1;
              return 2640; /* *popcountqi_z196 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (pattern68 (x1, 
4) != 0)
        return -1;
      x13 = XVECEXP (x3, 0, 3);
      operands[4] = x13;
      if (!const_mask_operand (operands[4], E_QImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 1);
      x10 = XVECEXP (x9, 0, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XVECEXP (x9, 0, 1);
      if (!rtx_equal_p (x11, operands[2]))
        return -1;
      x12 = XVECEXP (x9, 0, 2);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x14 = XVECEXP (x9, 0, 3);
      if (!rtx_equal_p (x14, operands[4]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 118:
          if (XINT (x9, 1) != 119)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern295 (x3, 
E_V16QImode) != 0
                  || !
#line 1570 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 386; /* *vstrcsv16qi */

            case E_V8HImode:
              if (pattern295 (x3, 
E_V8HImode) != 0
                  || !
#line 1570 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 387; /* *vstrcsv8hi */

            case E_V4SImode:
              if (pattern295 (x3, 
E_V4SImode) != 0
                  || !
#line 1570 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 388; /* *vstrcsv4si */

            default:
              return -1;
            }

        case 120:
          if (GET_MODE (x3) != E_V16QImode
              || XINT (x9, 1) != 121
              || !register_operand (operands[0], E_V16QImode)
              || !register_operand (operands[3], E_V16QImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !register_operand (operands[2], E_V16QImode)
                  || !
#line 1691 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 389; /* vec_vstrsv16qi */

            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !register_operand (operands[2], E_V8HImode)
                  || !
#line 1691 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 390; /* vec_vstrsv8hi */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !register_operand (operands[2], E_V4SImode)
                  || !
#line 1691 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 391; /* vec_vstrsv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (register_operand (operands[0], E_V16QImode)
          && register_operand (operands[1], E_V16QImode)
          && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_1 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V16QImode)
          && general_operand (operands[1], E_V16QImode))
        {
          if (
#line 313 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 0)))
            return gen_split_10 (insn, operands);
          if (
#line 327 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V16QImode, 1)))
            return gen_split_19 (insn, operands);
        }
      if (!register_operand (operands[0], E_V16QImode)
          || !memory_operand (operands[1], E_V16QImode)
          || !
#line 347 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_28 (insn, operands);

    case E_V8HImode:
      if (register_operand (operands[0], E_V8HImode)
          && register_operand (operands[1], E_V8HImode)
          && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_2 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V8HImode)
          && general_operand (operands[1], E_V8HImode))
        {
          if (
#line 313 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 0)))
            return gen_split_11 (insn, operands);
          if (
#line 327 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V8HImode, 1)))
            return gen_split_20 (insn, operands);
        }
      if (!register_operand (operands[0], E_V8HImode)
          || !memory_operand (operands[1], E_V8HImode)
          || !
#line 347 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_29 (insn, operands);

    case E_V4SImode:
      if (register_operand (operands[0], E_V4SImode)
          && register_operand (operands[1], E_V4SImode)
          && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_3 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && general_operand (operands[1], E_V4SImode))
        {
          if (
#line 313 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 0)))
            return gen_split_12 (insn, operands);
          if (
#line 327 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SImode, 1)))
            return gen_split_21 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SImode)
          || !memory_operand (operands[1], E_V4SImode)
          || !
#line 347 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_30 (insn, operands);

    case E_V4SFmode:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_4 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V4SFmode)
          && general_operand (operands[1], E_V4SFmode))
        {
          if (
#line 313 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 0)))
            return gen_split_13 (insn, operands);
          if (
#line 327 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V4SFmode, 1)))
            return gen_split_22 (insn, operands);
        }
      if (!register_operand (operands[0], E_V4SFmode)
          || !memory_operand (operands[1], E_V4SFmode)
          || !
#line 347 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_31 (insn, operands);

    case E_V2DImode:
      if (register_operand (operands[0], E_V2DImode)
          && register_operand (operands[1], E_V2DImode)
          && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_5 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DImode)
          && general_operand (operands[1], E_V2DImode))
        {
          if (
#line 313 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 0)))
            return gen_split_14 (insn, operands);
          if (
#line 327 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DImode, 1)))
            return gen_split_23 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DImode)
          || !memory_operand (operands[1], E_V2DImode)
          || !
#line 347 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_32 (insn, operands);

    case E_V2DFmode:
      if (register_operand (operands[0], E_V2DFmode)
          && register_operand (operands[1], E_V2DFmode)
          && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_6 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V2DFmode)
          && general_operand (operands[1], E_V2DFmode))
        {
          if (
#line 313 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 0)))
            return gen_split_15 (insn, operands);
          if (
#line 327 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V2DFmode, 1)))
            return gen_split_24 (insn, operands);
        }
      if (!register_operand (operands[0], E_V2DFmode)
          || !memory_operand (operands[1], E_V2DFmode)
          || !
#line 347 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_33 (insn, operands);

    case E_V1TImode:
      if (register_operand (operands[0], E_V1TImode)
          && register_operand (operands[1], E_V1TImode)
          && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_7 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TImode)
          && general_operand (operands[1], E_V1TImode))
        {
          if (
#line 313 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 0)))
            return gen_split_16 (insn, operands);
          if (
#line 327 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TImode, 1)))
            return gen_split_25 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TImode)
          || !memory_operand (operands[1], E_V1TImode)
          || !
#line 347 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_34 (insn, operands);

    case E_V1TFmode:
      if (register_operand (operands[0], E_V1TFmode)
          && register_operand (operands[1], E_V1TFmode)
          && 
#line 293 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])))
        return gen_split_8 (insn, operands);
      if (nonimmediate_operand (operands[0], E_V1TFmode)
          && general_operand (operands[1], E_V1TFmode))
        {
          if (
#line 313 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 0)))
            return gen_split_17 (insn, operands);
          if (
#line 327 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], V1TFmode, 1)))
            return gen_split_26 (insn, operands);
        }
      if (!register_operand (operands[0], E_V1TFmode)
          || !memory_operand (operands[1], E_V1TFmode)
          || !
#line 347 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_35 (insn, operands);

    case E_TFmode:
      if (register_operand (operands[0], E_TFmode)
          && register_operand (operands[1], E_TFmode)
          && (
#line 293 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && GENERAL_REG_P (operands[0]) && VECTOR_REG_P (operands[1])) && 
#line 95 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return gen_split_9 (insn, operands);
      if (nonimmediate_operand (operands[0], E_TFmode)
          && general_operand (operands[1], E_TFmode))
        {
          if ((
#line 313 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 0)) && 
#line 95 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_18 (insn, operands);
          if ((
#line 327 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(reload_completed
   && s390_split_ok_p (operands[0], operands[1], TFmode, 1)) && 
#line 95 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return gen_split_27 (insn, operands);
        }
      if (!register_operand (operands[0], E_TFmode)
          || !memory_operand (operands[1], E_TFmode)
          || !(
#line 347 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 95 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_36 (insn, operands);

    case E_TImode:
      if (nonimmediate_operand (operands[0], E_TImode)
          && general_operand (operands[1], E_TImode))
        {
          if (
#line 1789 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 0)))
            return gen_split_286 (insn, operands);
          if (
#line 1803 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && s390_split_ok_p (operands[0], operands[1], TImode, 1)))
            return gen_split_287 (insn, operands);
        }
      if (!register_operand (operands[0], E_TImode))
        return NULL;
      if (memory_operand (operands[1], E_TImode)
          && 
#line 1820 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !VECTOR_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return gen_split_288 (insn, operands);
      if (!register_operand (operands[1], E_TImode)
          || !
#line 1838 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VX && reload_completed
   && GENERAL_REG_P (operands[0])
   && VECTOR_REG_P (operands[1])))
        return NULL;
      return gen_split_289 (insn, operands);

    case E_DImode:
      if (register_operand (operands[0], E_DImode))
        {
          if (register_operand (operands[1], E_DImode))
            {
              if (
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && dead_or_set_p (insn, operands[1])))
                return gen_split_292 (insn, operands);
              if (
#line 2196 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && ACCESS_REG_P (operands[0]) && reload_completed
   && !dead_or_set_p (insn, operands[1])))
                return gen_split_293 (insn, operands);
            }
          if (memory_operand (operands[1], E_DImode)
              && 
#line 2234 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed && TARGET_Z10
   && larl_operand (XEXP (operands[1], 0), SImode)))
            return gen_split_294 (insn, operands);
        }
      if (nonimmediate_operand (operands[0], E_DImode)
          && general_operand (operands[1], E_DImode))
        {
          if (
#line 2247 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 0)))
            return gen_split_295 (insn, operands);
          if (
#line 2263 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DImode)
   && !s_operand (operands[1], DImode)
   && s390_split_ok_p (operands[0], operands[1], DImode, 1)))
            return gen_split_296 (insn, operands);
        }
      if (!register_operand (operands[0], E_DImode)
          || !memory_operand (operands[1], E_DImode)
          || !
#line 2279 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_297 (insn, operands);

    case E_FPRX2mode:
      if (nonimmediate_operand (operands[0], E_FPRX2mode)
          && general_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2822 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 0)) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_300 (insn, operands);
          if ((
#line 2838 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], FPRX2mode)
   && !s_operand (operands[1], FPRX2mode)
   && s390_split_ok_p (operands[0], operands[1], FPRX2mode, 1)) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_303 (insn, operands);
        }
      if (register_operand (operands[0], E_FPRX2mode)
          && memory_operand (operands[1], E_FPRX2mode))
        {
          if ((
#line 2854 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_306 (insn, operands);
          if ((
#line 2870 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return gen_split_309 (insn, operands);
        }
      if (!memory_operand (operands[0], E_FPRX2mode)
          || !register_operand (operands[1], E_FPRX2mode)
          || !(
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])) && 
#line 761 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
        return NULL;
      return gen_split_312 (insn, operands);

    case E_TDmode:
      if (nonimmediate_operand (operands[0], E_TDmode)
          && general_operand (operands[1], E_TDmode))
        {
          if (
#line 2822 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 0)))
            return gen_split_301 (insn, operands);
          if (
#line 2838 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], TDmode)
   && !s_operand (operands[1], TDmode)
   && s390_split_ok_p (operands[0], operands[1], TDmode, 1)))
            return gen_split_304 (insn, operands);
        }
      if (register_operand (operands[0], E_TDmode)
          && memory_operand (operands[1], E_TDmode))
        {
          if (
#line 2854 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && reload_completed
   && GENERAL_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
            return gen_split_307 (insn, operands);
          if (
#line 2870 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[1])
   && FP_REG_P (operands[0])))
            return gen_split_310 (insn, operands);
        }
      if (!memory_operand (operands[0], E_TDmode)
          || !register_operand (operands[1], E_TDmode)
          || !
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed && offsettable_memref_p (operands[0])
   && FP_REG_P (operands[1])))
        return NULL;
      return gen_split_313 (insn, operands);

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && general_operand (operands[1], E_DFmode))
        {
          if (
#line 2994 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 0)))
            return gen_split_314 (insn, operands);
          if (
#line 3010 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DFmode)
   && !s_operand (operands[1], DFmode)
   && s390_split_ok_p (operands[0], operands[1], DFmode, 1)))
            return gen_split_316 (insn, operands);
        }
      if (!register_operand (operands[0], E_DFmode)
          || !memory_operand (operands[1], E_DFmode)
          || !
#line 3026 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_318 (insn, operands);

    case E_DDmode:
      if (nonimmediate_operand (operands[0], E_DDmode)
          && general_operand (operands[1], E_DDmode))
        {
          if (
#line 2994 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 0)))
            return gen_split_315 (insn, operands);
          if (
#line 3010 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !s_operand (operands[0], DDmode)
   && !s_operand (operands[1], DDmode)
   && s390_split_ok_p (operands[0], operands[1], DDmode, 1)))
            return gen_split_317 (insn, operands);
        }
      if (!register_operand (operands[0], E_DDmode)
          || !memory_operand (operands[1], E_DDmode)
          || !
#line 3026 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && reload_completed
   && !FP_REG_P (operands[0])
   && !s_operand (operands[1], VOIDmode)))
        return NULL;
      return gen_split_319 (insn, operands);

    case E_QImode:
      if (!memory_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode)
          || !
#line 3116 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed))
        return NULL;
      return gen_split_320 (insn, operands);

    default:
      return NULL;
    }
}
