/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern22 (x3, 
E_V16QImode); /* [-1, 2] */

    case E_V8HImode:
      res = pattern22 (x3, 
E_V8HImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4SImode:
      res = pattern22 (x3, 
E_V4SImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case E_V2DImode:
      res = pattern22 (x3, 
E_V2DImode);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    case E_V1TImode:
      res = pattern22 (x3, 
E_V1TImode);
      if (res >= 0)
        return res + 12; /* [12, 14] */
      return -1;

    case E_TImode:
      res = pattern22 (x3, 
E_TImode);
      if (res >= 0)
        return res + 15; /* [15, 17] */
      return -1;

    case E_V4SFmode:
      res = pattern22 (x3, 
E_V4SFmode);
      if (res >= 0)
        return res + 18; /* [18, 20] */
      return -1;

    case E_V2DFmode:
      res = pattern22 (x3, 
E_V2DFmode);
      if (res >= 0)
        return res + 21; /* [21, 23] */
      return -1;

    case E_V1TFmode:
      res = pattern22 (x3, 
E_V1TFmode);
      if (res >= 0)
        return res + 24; /* [24, 26] */
      return -1;

    case E_TFmode:
      res = pattern22 (x3, 
E_TFmode);
      if (res >= 0)
        return res + 27; /* [27, 29] */
      return -1;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 33
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern52 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern51 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern51 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern51 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern51 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern60 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !nonimmediate_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern85 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern95 (x5); /* [-1, 1] */
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  return 0;
}

int
pattern115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1)
      || !contiguous_bitmask_nowrap_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 33
      || GET_MODE (x8) != E_CCmode
      || !nonimmediate_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x10 = XEXP (x5, 2);
  operands[2] = x10;
  if (!immediate_operand (operands[2], E_DImode))
    return -1;
  x11 = XEXP (x3, 1);
  operands[3] = x11;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      switch (GET_MODE (x1))
        {
        case E_DImode:
          if (pattern133 (x1, 
E_DImode) != 0)
            return -1;
          return 2;

        case E_SImode:
          if (pattern133 (x1, 
E_SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern149 (x1); /* [-1, 5] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          switch (GET_MODE (x6))
            {
            case E_DImode:
              if (!immediate_operand (operands[2], E_DImode))
                return -1;
              return 6;

            case E_SImode:
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 8;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 9;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 10;

        case E_TDmode:
          if (!register_operand (operands[1], E_TDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 11;

        case E_DDmode:
          if (!register_operand (operands[1], E_DDmode)
              || GET_MODE (x6) != E_SImode
              || !immediate_operand (operands[2], E_SImode))
            return -1;
          return 12;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern177 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          return pattern176 (x3, 
E_TFmode); /* [-1, 0] */

        case E_FPRX2mode:
          if (pattern176 (x3, 
E_FPRX2mode) != 0)
            return -1;
          return 1;

        case E_DFmode:
          if (pattern176 (x3, 
E_DFmode) != 0)
            return -1;
          return 2;

        case E_SFmode:
          if (pattern176 (x3, 
E_SFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !const0_operand (operands[2], E_TFmode)
              || !scratch_operand (operands[0], E_TFmode))
            return -1;
          return 4;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || !const0_operand (operands[2], E_FPRX2mode)
              || !scratch_operand (operands[0], E_FPRX2mode))
            return -1;
          return 5;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !const0_operand (operands[2], E_DFmode)
              || !scratch_operand (operands[0], E_DFmode))
            return -1;
          return 6;

        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !const0_operand (operands[2], E_SFmode)
              || !scratch_operand (operands[0], E_SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern218 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern217 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern217 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern238 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern243 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern252 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern269 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[2], i2))
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern285 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern298 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1213; /* vec_widen_umult_odd_v1qi */

    case 1:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1214; /* vec_widen_umult_odd_v2qi */

    case 2:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1215; /* vec_widen_umult_odd_v4qi */

    case 3:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1216; /* vec_widen_umult_odd_v8qi */

    case 4:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1217; /* vec_widen_umult_odd_v16qi */

    case 5:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1218; /* vec_widen_umult_odd_v1hi */

    case 6:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1219; /* vec_widen_umult_odd_v2hi */

    case 7:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1220; /* vec_widen_umult_odd_v4hi */

    case 8:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1221; /* vec_widen_umult_odd_v8hi */

    case 9:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1222; /* vec_widen_umult_odd_v1si */

    case 10:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1223; /* vec_widen_umult_odd_v2si */

    case 11:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1224; /* vec_widen_umult_odd_v4si */

    case 12:
      if (!
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1225; /* vec_widen_umult_odd_v1di */

    case 13:
      if (!(
#line 1747 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1226; /* vec_widen_umult_odd_v2di */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case BSWAP:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern183 (x2, 
E_V8HImode, 
E_HImode) != 0
              || !
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
            return -1;
          return 481; /* *vec_set_bswap_elemv8hi */

        case E_V4SImode:
          if (pattern183 (x2, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 482; /* *vec_set_bswap_elemv4si */

        case E_V4SFmode:
          if (pattern183 (x2, 
E_V4SFmode, 
E_SFmode) != 0
              || !(
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 483; /* *vec_set_bswap_elemv4sf */

        case E_V2DImode:
          if (pattern183 (x2, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 484; /* *vec_set_bswap_elemv2di */

        case E_V2DFmode:
          if (pattern183 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 485; /* *vec_set_bswap_elemv2df */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      x6 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x6;
          if (!nonmemory_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern199 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1QImode))))
                return -1;
              return 543; /* *vec_setv1qi */

            case E_V2QImode:
              if (pattern199 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2QImode))))
                return -1;
              return 544; /* *vec_setv2qi */

            case E_V4QImode:
              if (pattern199 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4QImode))))
                return -1;
              return 545; /* *vec_setv4qi */

            case E_V8QImode:
              if (pattern199 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8QImode))))
                return -1;
              return 546; /* *vec_setv8qi */

            case E_V16QImode:
              if (pattern199 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V16QImode))))
                return -1;
              return 547; /* *vec_setv16qi */

            case E_V1HImode:
              if (pattern199 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1HImode))))
                return -1;
              return 548; /* *vec_setv1hi */

            case E_V2HImode:
              if (pattern199 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2HImode))))
                return -1;
              return 549; /* *vec_setv2hi */

            case E_V4HImode:
              if (pattern199 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4HImode))))
                return -1;
              return 550; /* *vec_setv4hi */

            case E_V8HImode:
              if (pattern199 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode))))
                return -1;
              return 551; /* *vec_setv8hi */

            case E_V1SImode:
              if (pattern199 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SImode))))
                return -1;
              return 552; /* *vec_setv1si */

            case E_V2SImode:
              if (pattern199 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SImode))))
                return -1;
              return 553; /* *vec_setv2si */

            case E_V4SImode:
              if (pattern199 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode))))
                return -1;
              return 554; /* *vec_setv4si */

            case E_V1DImode:
              if (pattern199 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DImode))))
                return -1;
              return 555; /* *vec_setv1di */

            case E_V2DImode:
              if (pattern199 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode))))
                return -1;
              return 556; /* *vec_setv2di */

            case E_V1SFmode:
              if (pattern199 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1SFmode))))
                return -1;
              return 557; /* *vec_setv1sf */

            case E_V2SFmode:
              if (pattern199 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2SFmode))))
                return -1;
              return 558; /* *vec_setv2sf */

            case E_V4SFmode:
              if (pattern199 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode))))
                return -1;
              return 559; /* *vec_setv4sf */

            case E_V1DFmode:
              if (pattern199 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V1DFmode))))
                return -1;
              return 560; /* *vec_setv1df */

            case E_V2DFmode:
              if (pattern199 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 520 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
   && (!CONST_INT_P (operands[2])
       || UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode))))
                return -1;
              return 561; /* *vec_setv2df */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern199 (x2, 
E_V1QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 562; /* *vec_setv1qi_plus */

            case E_V2QImode:
              if (pattern199 (x2, 
E_V2QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 563; /* *vec_setv2qi_plus */

            case E_V4QImode:
              if (pattern199 (x2, 
E_V4QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 564; /* *vec_setv4qi_plus */

            case E_V8QImode:
              if (pattern199 (x2, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 565; /* *vec_setv8qi_plus */

            case E_V16QImode:
              if (pattern199 (x2, 
E_V16QImode, 
E_QImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 566; /* *vec_setv16qi_plus */

            case E_V1HImode:
              if (pattern199 (x2, 
E_V1HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 567; /* *vec_setv1hi_plus */

            case E_V2HImode:
              if (pattern199 (x2, 
E_V2HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 568; /* *vec_setv2hi_plus */

            case E_V4HImode:
              if (pattern199 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 569; /* *vec_setv4hi_plus */

            case E_V8HImode:
              if (pattern199 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 570; /* *vec_setv8hi_plus */

            case E_V1SImode:
              if (pattern199 (x2, 
E_V1SImode, 
E_SImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 571; /* *vec_setv1si_plus */

            case E_V2SImode:
              if (pattern199 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 572; /* *vec_setv2si_plus */

            case E_V4SImode:
              if (pattern199 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 573; /* *vec_setv4si_plus */

            case E_V1DImode:
              if (pattern199 (x2, 
E_V1DImode, 
E_DImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 574; /* *vec_setv1di_plus */

            case E_V2DImode:
              if (pattern199 (x2, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 575; /* *vec_setv2di_plus */

            case E_V1SFmode:
              if (pattern199 (x2, 
E_V1SFmode, 
E_SFmode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 576; /* *vec_setv1sf_plus */

            case E_V2SFmode:
              if (pattern199 (x2, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 577; /* *vec_setv2sf_plus */

            case E_V4SFmode:
              if (pattern199 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 578; /* *vec_setv4sf_plus */

            case E_V1DFmode:
              if (pattern199 (x2, 
E_V1DFmode, 
E_DFmode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 579; /* *vec_setv1df_plus */

            case E_V2DFmode:
              if (pattern199 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 580; /* *vec_setv2df_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == EQ)
    {
      res = recog_30 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x3;
  if (!s390_signed_integer_comparison (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) == PC)
    {
      x8 = XEXP (x2, 2);
      switch (pattern172 (x8))
        {
        case 0:
          if ((
#line 1695 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 1805; /* *icmp_and_br_signed_di */
            }
          break;

        case 1:
          if (
#line 1695 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            {
              *pnum_clobbers = 1;
              return 1806; /* *icmp_and_br_signed_si */
            }
          break;

        default:
          break;
        }
    }
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  switch (pattern171 (x2))
    {
    case 0:
      if (!(
#line 1637 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1801; /* *cmp_and_br_signed_di */

    case 1:
      if (!
#line 1637 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
        return -1;
      *pnum_clobbers = 1;
      return 1802; /* *cmp_and_br_signed_si */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x4, 1);
  operands[5] = x5;
  if (!const_int_operand (operands[5], E_VOIDmode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 2);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (pattern233 (x3, 
E_DImode) != 0
          || !(
#line 7363 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2305; /* *movdicc */

    case E_SImode:
      if (pattern233 (x3, 
E_SImode) != 0
          || !
#line 7363 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      return 2306; /* *movsicc */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      if (!
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1295; /* *vec_cmpgtv1qiv1qi_nocc */

    case 1:
      if (!
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1298; /* *vec_cmpgtv2qiv2qi_nocc */

    case 2:
      if (!
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1301; /* *vec_cmpgtv4qiv4qi_nocc */

    case 3:
      if (!
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1304; /* *vec_cmpgtv8qiv8qi_nocc */

    case 4:
      if (!
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1307; /* *vec_cmpgtv16qiv16qi_nocc */

    case 5:
      if (!
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1310; /* *vec_cmpgtv1hiv1hi_nocc */

    case 6:
      if (!
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1313; /* *vec_cmpgtv2hiv2hi_nocc */

    case 7:
      if (!
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1316; /* *vec_cmpgtv4hiv4hi_nocc */

    case 8:
      if (!
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1319; /* *vec_cmpgtv8hiv8hi_nocc */

    case 9:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1SImode)
              && 
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1322; /* *vec_cmpgtv1siv1si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1SFmode))
        return -1;
      if (
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1376; /* *vec_cmpgtv1sf_signaling_nocc */
      if (!(
#line 2285 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1383; /* *vec_cmpgtv1sf_signaling_finite_nocc */

    case 10:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2SImode)
              && 
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1325; /* *vec_cmpgtv2siv2si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2SFmode))
        return -1;
      if (
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1377; /* *vec_cmpgtv2sf_signaling_nocc */
      if (!(
#line 2285 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1384; /* *vec_cmpgtv2sf_signaling_finite_nocc */

    case 11:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V4SImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V4SImode)
              && 
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1328; /* *vec_cmpgtv4siv4si_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V4SFmode))
        return -1;
      if (
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1378; /* *vec_cmpgtv4sf_signaling_nocc */
      if (!(
#line 2285 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1385; /* *vec_cmpgtv4sf_signaling_finite_nocc */

    case 12:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1DImode)
              && 
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1331; /* *vec_cmpgtv1div1di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V1DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V1DFmode))
        return -1;
      if (
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1379; /* *vec_cmpgtv1df_signaling_nocc */
      if (!
#line 2285 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1386; /* *vec_cmpgtv1df_signaling_finite_nocc */

    case 13:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V2DImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V2DImode)
              && 
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return 1334; /* *vec_cmpgtv2div2di_nocc */
        }
      operands[0] = x2;
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V2DFmode))
        return -1;
      if (
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1380; /* *vec_cmpgtv2df_signaling_nocc */
      if (!
#line 2285 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1387; /* *vec_cmpgtv2df_signaling_finite_nocc */

    case 14:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_V1TImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_V1TImode)
              && (
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return 1337; /* *vec_cmpgtv1tiv1ti_nocc */
        }
      operands[0] = x2;
      switch (pattern110 (x3))
        {
        case 0:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
            return -1;
          return 1344; /* *vec_cmpgtv1tiv1ti_nocc_emu */

        case 1:
          if (
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1381; /* *vec_cmpgtv1tf_signaling_nocc */
          if (!(
#line 2285 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1388; /* *vec_cmpgtv1tf_signaling_finite_nocc */

        default:
          return -1;
        }

    case 15:
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      x3 = XEXP (x1, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_TImode))
        {
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (register_operand (operands[1], E_TImode)
              && (
#line 2120 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return 1340; /* *vec_cmpgttiti_nocc */
        }
      operands[0] = x2;
      switch (pattern111 (x3))
        {
        case 0:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
            return -1;
          return 1345; /* *vec_cmpgttiti_nocc_emu */

        case 1:
          if (
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1382; /* *vec_cmpgttf_signaling_nocc */
          if (!(
#line 2285 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1389; /* *vec_cmpgttf_signaling_finite_nocc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern0 (x3, 
E_V16QImode) != 0
              || !
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 716; /* mulv16qi3 */

        case E_V8HImode:
          if (pattern0 (x3, 
E_V8HImode) != 0
              || !
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 717; /* mulv8hi3 */

        case E_V4SImode:
          if (pattern0 (x3, 
E_V4SImode) != 0
              || !
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 718; /* mulv4si3 */

        case E_V2DImode:
          if (pattern0 (x3, 
E_V2DImode) != 0
              || !(
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 719; /* mulv2di3 */

        case E_V1TImode:
          if (pattern0 (x3, 
E_V1TImode) != 0
              || !(
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 720; /* mulv1ti3 */

        case E_TImode:
          if (pattern0 (x3, 
E_TImode) != 0
              || !(
#line 1146 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 52 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 721; /* multi3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !(
#line 1885 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1235; /* mulv4sf3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 1885 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1236; /* mulv2df3 */

        case E_V1TFmode:
          if (pattern0 (x3, 
E_V1TFmode) != 0
              || !(
#line 1885 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1237; /* mulv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 1885 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1238; /* multf3_vr */
          if (!nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 7573 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2319; /* multf3_fpr */

        case E_FPRX2mode:
          if (pattern174 (x3, 
E_FPRX2mode) != 0
              || !(
#line 7573 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2320; /* mulfprx23 */

        case E_DFmode:
          if (pattern174 (x3, 
E_DFmode) != 0
              || !
#line 7573 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2321; /* muldf3 */

        case E_SFmode:
          if (pattern174 (x3, 
E_SFmode) != 0
              || !
#line 7573 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2322; /* mulsf3 */

        case E_TDmode:
          if (pattern174 (x3, 
E_TDmode) != 0
              || !(
#line 7573 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2323; /* multd3 */

        case E_DDmode:
          if (pattern174 (x3, 
E_DDmode) != 0
              || !(
#line 7573 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2324; /* muldd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_TImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_TImode
          || !register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (nonimmediate_operand (operands[2], E_DImode)
          && register_operand (operands[1], E_DImode)
          && 
#line 7426 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z14))
        return 2309; /* mulditi3 */
      if (!register_operand (operands[2], E_DImode)
          || !nonimmediate_operand (operands[1], E_DImode)
          || !
#line 7439 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z14))
        return -1;
      return 2310; /* mulditi3_2 */

    case ZERO_EXTEND:
      if (pattern113 (x3, 
E_DImode, 
E_TImode) != 0
          || !
#line 779 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2317; /* umulditi3 */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 738; /* negv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 739; /* negv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 740; /* negv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 741; /* negv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 742; /* negv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 743; /* negv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 744; /* negv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 745; /* negv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 746; /* negv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 747; /* negv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 748; /* negv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 749; /* negv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 750; /* negv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1190 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 751; /* negv2di2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 1972 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1263; /* negv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 1972 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1264; /* negv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 1972 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1265; /* negv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1972 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1266; /* negv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1972 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1267; /* negv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 1972 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1268; /* negv1tf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if ((
#line 1972 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1269; /* negtf2_vr */
          if ((
#line 9249 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2433; /* *negtf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9261 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2439; /* *negtf2 */

        case E_DImode:
          if (pattern83 (x3, pnum_clobbers, 
E_DImode) != 0)
            return -1;
          if (
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 2422; /* *negdi2 */
            }
          if (!
#line 9138 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2424; /* *negdi2_31 */

        case E_SImode:
          if (pattern83 (x3, pnum_clobbers, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 2423; /* *negsi2 */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || GET_MODE (x3) != E_FPRX2mode
              || !register_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 9249 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2434; /* *negfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9261 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2440; /* *negfprx22 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 9249 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2435; /* *negdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9261 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2441; /* *negdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 9249 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2436; /* *negsf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9261 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2442; /* *negsf2 */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_TDmode)
              || !(
#line 9249 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2437; /* *negtd2_nocc */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_DDmode)
              || !(
#line 9249 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2438; /* *negdd2_nocc */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern156 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1255; /* neg_fmav4sf4 */

            case E_V2DFmode:
              if (pattern156 (x3, 
E_V2DFmode) != 0
                  || !
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1256; /* neg_fmav2df4 */

            case E_V1TFmode:
              if (pattern156 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1257; /* neg_fmav1tf4 */

            case E_TFmode:
              if (pattern156 (x3, 
E_TFmode) != 0
                  || !(
#line 1953 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1258; /* neg_fmatf4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern157 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1259; /* neg_fmsv4sf4 */

            case E_V2DFmode:
              if (pattern157 (x3, 
E_V2DFmode) != 0
                  || !
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1260; /* neg_fmsv2df4 */

            case E_V1TFmode:
              if (pattern157 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1261; /* neg_fmsv1tf4 */

            case E_TFmode:
              if (pattern157 (x3, 
E_TFmode) != 0
                  || !(
#line 1964 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1262; /* neg_fmstf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V1SFmode:
              if (pattern109 (x3, 
E_V1SFmode) != 0
                  || !(
#line 2000 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1277; /* negabsv1sf2 */

            case E_V2SFmode:
              if (pattern109 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2000 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1278; /* negabsv2sf2 */

            case E_V4SFmode:
              if (pattern109 (x3, 
E_V4SFmode) != 0
                  || !(
#line 2000 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1279; /* negabsv4sf2 */

            case E_V1DFmode:
              if (pattern109 (x3, 
E_V1DFmode) != 0
                  || !
#line 2000 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1280; /* negabsv1df2 */

            case E_V2DFmode:
              if (pattern109 (x3, 
E_V2DFmode) != 0
                  || !
#line 2000 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1281; /* negabsv2df2 */

            case E_V1TFmode:
              if (pattern109 (x3, 
E_V1TFmode) != 0
                  || !(
#line 2000 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1282; /* negabsv1tf2 */

            case E_TFmode:
              if (pattern109 (x3, 
E_TFmode) != 0)
                return -1;
              if ((
#line 2000 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1283; /* negabstf2 */
              if ((
#line 9513 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2485; /* *negabstf2_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9524 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2491; /* *negabstf2 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern109 (x3, 
E_DImode) != 0
                  || !
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2475; /* *negabsdi2 */

            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern109 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2476; /* *negabssi2 */

            case E_FPRX2mode:
              if (pattern109 (x3, 
E_FPRX2mode) != 0)
                return -1;
              if ((
#line 9513 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2486; /* *negabsfprx22_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9524 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2492; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern109 (x3, 
E_DFmode) != 0)
                return -1;
              if (
#line 9513 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2487; /* *negabsdf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9524 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2493; /* *negabsdf2 */

            case E_SFmode:
              if (pattern109 (x3, 
E_SFmode) != 0)
                return -1;
              if (
#line 9513 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2488; /* *negabssf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9524 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2494; /* *negabssf2 */

            case E_TDmode:
              if (pattern109 (x3, 
E_TDmode) != 0
                  || !(
#line 9513 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2489; /* *negabstd2_nocc */

            case E_DDmode:
              if (pattern109 (x3, 
E_DDmode) != 0
                  || !(
#line 9513 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2490; /* *negabsdd2_nocc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9444 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2470; /* *negabsdi2_sign */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern66 (x3, 
E_SImode) != 0
          || !
#line 9096 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2417; /* *negdi2_sign */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0
          || !
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 722; /* divv4si3 */

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0
          || !
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 723; /* divv2di3 */

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0
          || !
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 724; /* divv1ti3 */

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0
          || !
#line 1155 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
        return -1;
      return 725; /* divti3 */

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0
          || !(
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1239; /* divv4sf3 */

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0
          || !
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1240; /* divv2df3 */

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0
          || !(
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1241; /* divv1tf3 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      if (register_operand (operands[2], E_TFmode)
          && (
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1242; /* divtf3_vr */
      if (!general_operand (operands[2], E_TFmode)
          || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2334; /* divtf3_fpr */

    case E_FPRX2mode:
      if (pattern85 (x3, 
E_FPRX2mode) != 0
          || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2335; /* divfprx23 */

    case E_DFmode:
      if (pattern85 (x3, 
E_DFmode) != 0
          || !
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2336; /* divdf3 */

    case E_SFmode:
      if (pattern85 (x3, 
E_SFmode) != 0
          || !
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2337; /* divsf3 */

    case E_TDmode:
      if (pattern85 (x3, 
E_TDmode) != 0
          || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2338; /* divtd3 */

    case E_DDmode:
      if (pattern85 (x3, 
E_DDmode) != 0
          || !(
#line 7878 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2339; /* divdd3 */

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  switch (XINT (x2, 1))
    {
    case 8:
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 36)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 36)
        return -1;
      return 2580; /* *set_tp */

    case 7:
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 11747 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(GET_MODE (operands[0]) == Pmode))
        return -1;
      return 2614; /* main_pool */

    case 18:
      if (pattern35 (x1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[0] = x3;
      if (!const_int_operand (operands[0], E_VOIDmode)
          || !
#line 12434 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
        return -1;
      return 2651; /* *tbeginc_1 */

    case 19:
      if (GET_MODE (x2) != E_CCRAWmode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 33
          || GET_MODE (x4) != E_CCRAWmode
          || !
#line 12451 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2652; /* *tend_1 */

    case 21:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 12491 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2655; /* etnd */

    case 22:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_DImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12501 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HTM))
        return -1;
      return 2656; /* ntstg */

    case 25:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || !
#line 12536 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2659; /* efpc */

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x3, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) == E_CCL1mode)
    {
      x9 = XEXP (x7, 1);
      if (GET_MODE (x9) == E_CCL1mode)
        {
          x10 = XEXP (x9, 1);
          if (rtx_equal_p (x10, operands[1]))
            {
              x11 = XEXP (x9, 0);
              switch (GET_MODE (x11))
                {
                case E_DImode:
                  if (pattern275 (x3, 
E_DImode) == 0
                      && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2199; /* adddi3_carry1_cc */
                  break;

                case E_SImode:
                  if (pattern275 (x3, 
E_SImode) == 0)
                    return 2200; /* addsi3_carry1_cc */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x9 = XEXP (x7, 1);
  x11 = XEXP (x9, 0);
  switch (GET_MODE (x11))
    {
    case E_DImode:
      if (pattern254 (x1, 
E_DImode) != 0
          || !(
#line 6276 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2203; /* *adddi3_carry2_cc */

    case E_SImode:
      if (pattern254 (x1, 
E_SImode) != 0
          || !
#line 6276 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 2204; /* *addsi3_carry2_cc */

    case E_TFmode:
      if (pattern255 (x1, 
E_TFmode) != 0
          || !(
#line 6503 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2226; /* *addtf3_cc */

    case E_FPRX2mode:
      if (pattern255 (x1, 
E_FPRX2mode) != 0
          || !(
#line 6503 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2227; /* *addfprx23_cc */

    case E_DFmode:
      if (pattern255 (x1, 
E_DFmode) != 0
          || !
#line 6503 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 2228; /* *adddf3_cc */

    case E_SFmode:
      if (pattern255 (x1, 
E_SFmode) != 0
          || !
#line 6503 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
        return -1;
      return 2229; /* *addsf3_cc */

    case E_TDmode:
      if (pattern255 (x1, 
E_TDmode) != 0
          || !(
#line 6503 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2230; /* *addtd3_cc */

    case E_DDmode:
      if (pattern255 (x1, 
E_DDmode) != 0
          || !(
#line 6503 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
        return -1;
      return 2231; /* *adddd3_cc */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (pattern89 (x4) != 0)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[3] = x9;
      if (!nonimmediate_operand (operands[3], E_DImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 4826 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
        return -1;
      return 1998; /* *insv_rnsbg_noshift */

    case SUBREG:
    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_BLKmode)
        return -1;
      x9 = XEXP (x8, 1);
      operands[1] = x9;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 8258 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      *pnum_clobbers = 1;
      return 2361; /* *nc */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (pattern214 (x3, 
E_TImode) != 0
              || !
#line 6065 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2190; /* *addti3 */

        case E_DImode:
          if (pattern121 (x3, 
E_DImode) != 0)
            return -1;
          if (
#line 6156 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2195; /* *adddi3_31z */
          if (!
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2197; /* *adddi3 */

        case E_SImode:
          if (pattern121 (x3, 
E_SImode) != 0)
            return -1;
          return 2198; /* *addsi3 */

        case E_TFmode:
          if (pattern214 (x3, 
E_TFmode) != 0
              || !(
#line 6483 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2220; /* addtf3_fpr */

        case E_FPRX2mode:
          if (pattern214 (x3, 
E_FPRX2mode) != 0
              || !(
#line 6483 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2221; /* addfprx23 */

        case E_DFmode:
          if (pattern214 (x3, 
E_DFmode) != 0
              || !
#line 6483 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2222; /* adddf3 */

        case E_SFmode:
          if (pattern214 (x3, 
E_SFmode) != 0
              || !
#line 6483 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2223; /* addsf3 */

        case E_TDmode:
          if (pattern214 (x3, 
E_TDmode) != 0
              || !(
#line 6483 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2224; /* addtd3 */

        case E_DDmode:
          if (pattern214 (x3, 
E_DDmode) != 0
              || !(
#line 6483 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2225; /* adddd3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (general_operand (operands[2], E_SImode)
              && 
#line 6105 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2191; /* *adddi3_sign */
          if (!memory_operand (operands[2], E_HImode)
              || !
#line 6391 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z14))
            return -1;
          return 2215; /* *adddi3_sign */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || !memory_operand (operands[2], E_HImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 2196; /* *addsi3_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6144 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2194; /* *adddi3_zero */

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern247 (x3, 
E_DImode) != 0
              || !
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2290; /* *adddi3_alc */

        case E_SImode:
          if (pattern247 (x3, 
E_SImode) != 0)
            return -1;
          return 2291; /* *addsi3_alc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  if (!permute_pattern_operand (x5, E_V16QImode))
    return -1;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case UNSPEC:
      switch (XVECLEN (x7, 0))
        {
        case 1:
          if (XINT (x7, 1) != 62)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern223 (x6, 
E_HImode, 
E_V8HImode) != 0
                  || !
#line 191 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 11; /* *vec_insert_and_zero_bswapv8hi */

            case E_V4SImode:
              if (pattern223 (x6, 
E_SImode, 
E_V4SImode) != 0
                  || !
#line 191 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 12; /* *vec_insert_and_zero_bswapv4si */

            case E_V4SFmode:
              if (pattern223 (x6, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 191 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2) && 
#line 44 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 13; /* *vec_insert_and_zero_bswapv4sf */

            case E_V2DImode:
              if (pattern223 (x6, 
E_DImode, 
E_V2DImode) != 0
                  || !
#line 191 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 14; /* *vec_insert_and_zero_bswapv2di */

            case E_V2DFmode:
              if (pattern223 (x6, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 191 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2))
                return -1;
              return 15; /* *vec_insert_and_zero_bswapv2df */

            default:
              return -1;
            }

        case 3:
          if (XINT (x7, 1) != 92)
            return -1;
          x9 = XVECEXP (x7, 0, 2);
          if (GET_CODE (x9) != BSWAP)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          x10 = XVECEXP (x7, 0, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x9, 0);
          operands[3] = x11;
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern260 (x6, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V8HImode)))
                return -1;
              return 486; /* *vec_set_bswap_vecv8hi */

            case E_V4SImode:
              if (pattern260 (x6, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 487; /* *vec_set_bswap_vecv4si */

            case E_V4SFmode:
              if (pattern260 (x6, 
E_V4SFmode, 
E_SFmode) != 0
                  || !(
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 44 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 488; /* *vec_set_bswap_vecv4sf */

            case E_V2DImode:
              if (pattern260 (x6, 
E_V2DImode, 
E_DImode) != 0
                  || !
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 489; /* *vec_set_bswap_vecv2di */

            case E_V2DFmode:
              if (pattern260 (x6, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE2 && UINTVAL (operands[2]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 490; /* *vec_set_bswap_vecv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x12 = XEXP (x7, 0);
      operands[1] = x12;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern190 (x6, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 633; /* *vec_splats_bswap_vecv8hi */

        case E_V4SImode:
          if (pattern190 (x6, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 634; /* *vec_splats_bswap_vecv4si */

        case E_V4SFmode:
          if (pattern190 (x6, 
E_SFmode, 
E_V4SFmode) != 0
              || !(
#line 634 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2) && 
#line 44 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 635; /* *vec_splats_bswap_vecv4sf */

        case E_V2DImode:
          if (pattern190 (x6, 
E_DImode, 
E_V2DImode) != 0
              || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 636; /* *vec_splats_bswap_vecv2di */

        case E_V2DFmode:
          if (pattern190 (x6, 
E_DFmode, 
E_V2DFmode) != 0
              || !
#line 634 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 637; /* *vec_splats_bswap_vecv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      operands[2] = x5;
      switch (pattern164 (x6))
        {
        case 0:
          if (!
#line 3330 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1559; /* *bswapv8hi */

        case 1:
          if (!
#line 3330 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1560; /* *bswapv4si */

        case 2:
          if (!
#line 3330 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1561; /* *bswapv4sf */

        case 3:
          if (!
#line 3330 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1562; /* *bswapv2di */

        case 4:
          if (!
#line 3330 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1563; /* *bswapv2df */

        case 5:
          if (!
#line 3330 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1564; /* *bswapv1ti */

        case 6:
          if (!
#line 3330 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1565; /* *bswapv1tf */

        case 7:
          if (!
#line 3330 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1566; /* *bswapti */

        case 8:
          if (!
#line 3330 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE2))
            return -1;
          return 1567; /* *bswaptf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_111 (x1, insn, pnum_clobbers);

    case CLOBBER:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      switch (pattern126 (x1))
        {
        case 0:
          if (!
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1884; /* *movstr */

        case 1:
          if (!
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1885; /* *movstr */

        case 2:
          if (!(
#line 3951 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1902; /* *setmem_long */

        case 3:
          if (!(
#line 3951 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1903; /* *setmem_long */

        case 4:
          if (!
#line 3979 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1906; /* *setmem_long_31z */

        case 5:
          if (!(
#line 3964 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1904; /* *setmem_long_and */

        case 6:
          if (!(
#line 3964 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1905; /* *setmem_long_and */

        case 7:
          if (!
#line 3991 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1907; /* *setmem_long_and_31z */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern14 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      x3 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x3, 1);
      operands[0] = x9;
      x10 = XEXP (x6, 0);
      operands[1] = x10;
      x11 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
          if (XWINT (x11, 0) != 0L)
            return -1;
          if (larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10609 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2556; /* casesi_jump_via_inlinethunkdi_z10 */
          if (!larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10609 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2557; /* casesi_jump_via_inlinethunksi_z10 */

        case REG:
        case SUBREG:
          operands[3] = x11;
          if (register_operand (operands[3], E_DImode)
              && larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10626 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2558; /* casesi_jump_via_inlinethunkdi */
          if (!register_operand (operands[3], E_SImode)
              || !larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10626 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2559; /* casesi_jump_via_inlinethunksi */

        default:
          return -1;
        }

    case CALL:
      x12 = XEXP (x2, 0);
      if (GET_CODE (x12) != MEM
          || GET_MODE (x12) != E_QImode
          || pattern15 (x1, 
CLOBBER) != 0)
        return -1;
      x13 = XEXP (x12, 0);
      operands[0] = x13;
      x14 = XEXP (x2, 1);
      operands[1] = x14;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 10931 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2572; /* *basr_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 10931 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2573; /* *basr_via_thunksi */

        default:
          return -1;
        }

    case RETURN:
      if (pattern15 (x1, 
USE) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 11869 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2621; /* returndi_prez10 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 11869 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2622; /* returnsi_prez10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_119 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_109 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_112 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_113 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_114 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_115 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 34:
          res = recog_116 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 18:
          if (pattern6 (x1, 
19, 
E_DFmode, 
18, 
17) == 0
              && pattern298 (x1, 
23, 
E_DFmode, 
22, 
21, 
20) == 0
              && pattern299 (x1, 
27, 
E_DFmode, 
26, 
25, 
24) == 0
              && pattern300 (x1, 
E_DFmode, 
31, 
30, 
29, 
28) == 0)
            {
              x2 = XVECEXP (x1, 0, 0);
              x3 = XEXP (x2, 1);
              x4 = XVECEXP (x3, 0, 0);
              operands[0] = x4;
              if (const_int_operand (operands[0], E_VOIDmode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (memory_operand (operands[1], E_BLKmode))
                    {
                      x7 = XEXP (x5, 1);
                      x8 = XVECEXP (x7, 0, 0);
                      if (rtx_equal_p (x8, operands[0])
                          && 
#line 12405 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
                        return 2649; /* tbegin_1 */
                    }
                }
            }
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[0] = x1;
          res = recog_117 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 3:
              if (XINT (x7, 1) != 9)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (pattern180 (x10) != 0)
                return -1;
              x11 = XVECEXP (x7, 0, 1);
              operands[2] = x11;
              x12 = XVECEXP (x7, 0, 2);
              operands[3] = x12;
              x8 = XVECEXP (x7, 0, 0);
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x13 = XEXP (x10, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x13, 1);
              if (!rtx_equal_p (x15, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern279 (x7, 
E_DImode) != 0)
                    return -1;
                  if (
#line 11345 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return 2592; /* *atomic_compare_and_swapdi_1 */
                  if (!
#line 11363 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2593; /* *atomic_compare_and_swapdi_2 */

                case E_SImode:
                  if (pattern279 (x7, 
E_SImode) != 0
                      || !
#line 11384 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2594; /* *atomic_compare_and_swapsi_3 */

                default:
                  return -1;
                }

            case 1:
              if (XINT (x7, 1) != 10)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x10) != CLOBBER)
                return -1;
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 33
                  || GET_MODE (x16) != E_CCmode)
                return -1;
              x8 = XVECEXP (x7, 0, 0);
              switch (GET_CODE (x8))
                {
                case AND:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2595; /* atomic_fetch_anddi_iaf */

                    case 1:
                      if (!
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2599; /* atomic_fetch_andsi_iaf */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2596; /* atomic_fetch_ordi_iaf */

                    case 1:
                      if (!
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2600; /* atomic_fetch_orsi_iaf */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2597; /* atomic_fetch_xordi_iaf */

                    case 1:
                      if (!
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2601; /* atomic_fetch_xorsi_iaf */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2598; /* atomic_fetch_adddi_iaf */

                    case 1:
                      if (!
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2602; /* atomic_fetch_addsi_iaf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          if (pnum_clobbers != NULL)
            {
              res = recog_118 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 15
              || GET_MODE (x9) != E_DImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x17 = XEXP (x6, 0);
          if (GET_CODE (x17) != SCRATCH)
            return -1;
          x3 = XEXP (x2, 1);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode)
              || !
#line 11996 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2629; /* stack_restore_from_fpr */

        default:
          return -1;
        }

    case TRAP_IF:
      x18 = XEXP (x1, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XEXP (x1, 0);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 1L)
            return -1;
          return 2525; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[0] = x19;
          if (s390_comparison (operands[0], E_VOIDmode))
            {
              x20 = XEXP (x19, 1);
              if (x20 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x21 = XEXP (x19, 0);
                  operands[1] = x21;
                  if (cc_reg_operand (operands[1], E_VOIDmode))
                    return 2526; /* condtrap */
                }
            }
          x21 = XEXP (x19, 0);
          operands[1] = x21;
          x20 = XEXP (x19, 1);
          operands[2] = x20;
          if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && nonmemory_operand (operands[2], E_DImode)
                      && (
#line 9964 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2527; /* *cmp_and_trap_signed_intdi */
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && nonmemory_operand (operands[2], E_SImode)
                      && 
#line 9964 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
                    return 2528; /* *cmp_and_trap_signed_intsi */
                  break;

                default:
                  break;
                }
            }
          if (!s390_unsigned_integer_comparison (operands[0], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !general_operand (operands[2], E_DImode)
                  || !(
#line 9978 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2529; /* *cmp_and_trap_unsigned_intdi */

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !general_operand (operands[2], E_SImode)
                  || !
#line 9978 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 2530; /* *cmp_and_trap_unsigned_intsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 0:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2560; /* blockage */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2604; /* nop_lr0 */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2605; /* nop_lr1 */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2606; /* nop_2_byte */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2607; /* nop_4_byte */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2608; /* nop_6_byte */

            case 6:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!consttable_operand (operands[0], E_VOIDmode))
                return -1;
              return 2609; /* *pool_entry */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2610; /* pool_align */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != CONST_INT)
                return -1;
              switch (XWINT (x2, 0))
                {
                case 1L:
                  return 2611; /* pool_section_start */

                case 0L:
                  return 2612; /* pool_section_end */

                default:
                  return -1;
                }

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2616; /* pool */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x2))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[0] = x2;
                  if (!nonmemory_operand (operands[0], E_SImode)
                      || !
#line 12474 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HTM))
                    return -1;
                  return 2653; /* *tabort_1 */

                case PLUS:
                  if (GET_MODE (x2) != E_SImode)
                    return -1;
                  x9 = XEXP (x2, 0);
                  operands[0] = x9;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x3 = XEXP (x2, 1);
                  operands[1] = x3;
                  if (!const_int_operand (operands[1], E_SImode)
                      || !
#line 12482 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HTM && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[1]), 'J', "J")))
                    return -1;
                  return 2654; /* *tabort_1_plus */

                default:
                  return -1;
                }

            case 24:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 12530 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2658; /* sfpc */

            case 27:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2665; /* osc_break */

            default:
              return -1;
            }

        case 3:
          if (XINT (x1, 1) != 23)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 12520 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
((TARGET_ZEC12 || TARGET_HTM) && INTVAL (operands[2]) < 16))
            return -1;
          return 2657; /* *ppa */

        default:
          return -1;
        }

    case CALL:
      x19 = XEXP (x1, 0);
      if (GET_CODE (x19) != MEM
          || GET_MODE (x19) != E_QImode)
        return -1;
      x18 = XEXP (x1, 1);
      if (!const_int_operand (x18, E_VOIDmode))
        return -1;
      x21 = XEXP (x19, 0);
      switch (GET_CODE (x21))
        {
        case REG:
          if (REGNO (x21) != 1)
            return -1;
          operands[0] = x18;
          if (!
#line 10738 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (PATTERN (insn), 0), 0)) == Pmode))
            return -1;
          return 2561; /* *sibcall_br */

        case CONST:
        case SYMBOL_REF:
          operands[0] = x21;
          if (!bras_sym_operand (operands[0], E_VOIDmode))
            return -1;
          operands[1] = x18;
          if (
#line 10767 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2562; /* *sibcall_brc */
          if (!
#line 10775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2563; /* *sibcall_brcl */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 2603; /* nop */

    case RETURN:
      if (!
#line 11794 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
        return -1;
      return 2617; /* return */

    case SIMPLE_RETURN:
      if (!
#line 11794 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
        return -1;
      return 2618; /* simple_return */

    case PREFETCH:
      x19 = XEXP (x1, 0);
      operands[0] = x19;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x18 = XEXP (x1, 1);
      operands[1] = x18;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x22 = XEXP (x1, 2);
      operands[2] = x22;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 12008 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      return 2630; /* prefetch */

    default:
      return -1;
    }
}
