/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 16
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 17
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 16
      || GET_MODE (x8) != i2)
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != i4
      || GET_MODE (x10) != i2)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != i3
      || GET_MODE (x12) != i2)
    return -1;
  x13 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x13) != CLOBBER)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != i1)
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern19 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern19 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern19 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern19 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern19 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern19 (x3, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          if (!register_operand (operands[1], E_V1QImode)
              || !register_operand (operands[2], E_V1QImode))
            return -1;
          return 0;

        case E_V2QImode:
          if (!register_operand (operands[1], E_V2QImode)
              || !register_operand (operands[2], E_V2QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V2HImode:
      if (pattern16 (x3, 
E_V4QImode, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern16 (x3, 
E_V8QImode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern16 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          if (!register_operand (operands[1], E_V1HImode)
              || !register_operand (operands[2], E_V1HImode))
            return -1;
          return 5;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2HImode)
              || !register_operand (operands[2], E_V2HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V2SImode:
      if (pattern16 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern16 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          if (!register_operand (operands[1], E_V1SImode)
              || !register_operand (operands[2], E_V1SImode))
            return -1;
          return 9;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern16 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 11;

    case E_V1TImode:
      if (pattern16 (x3, 
E_V1DImode, 
E_V1TImode) != 0)
        return -1;
      return 12;

    case E_TImode:
      if (pattern16 (x3, 
E_V2DImode, 
E_TImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern19 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern19 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern19 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern19 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern19 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern19 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern19 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern19 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    case E_V1TFmode:
      if (pattern19 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern19 (x1, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCUmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCUmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          return 1;

        case E_QImode:
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern97 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern123 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  switch (GET_CODE (x3))
    {
    case MEM:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 32)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_BLKmode)
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 0
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      x11 = XEXP (x2, 0);
      x12 = XEXP (x11, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 0);
      operands[3] = x13;
      x14 = XEXP (x4, 0);
      operands[0] = x14;
      x15 = XEXP (x6, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x16 = XEXP (x7, 0);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_DImode:
          return pattern123 (x5, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern123 (x5, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 6)
        return -1;
      x17 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x11 = XEXP (x2, 0);
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != SUBREG)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      x18 = XEXP (x12, 0);
      operands[3] = x18;
      x14 = XEXP (x4, 0);
      operands[1] = x14;
      x19 = XEXP (x17, 0);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      x20 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x20))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
        case PLUS:
          operands[2] = x20;
          switch (SUBREG_BYTE (x17))
            {
            case 8:
              if (pattern124 (x2, 
E_TImode, 
0, 
E_DImode) != 0)
                return -1;
              return 2;

            case 4:
              if (pattern124 (x2, 
E_DImode, 
0, 
E_SImode) != 0)
                return -1;
              return 3;

            case 12:
              if (pattern124 (x2, 
E_TImode, 
4, 
E_SImode) != 0)
                return -1;
              return 4;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x21 = XEXP (x20, 0);
          operands[2] = x21;
          if (!setmem_operand (operands[2], E_QImode))
            return -1;
          switch (SUBREG_BYTE (x17))
            {
            case 8:
              if (pattern125 (x2, 
E_TImode, 
0, 
E_DImode) != 0)
                return -1;
              return 5;

            case 4:
              if (pattern125 (x2, 
E_DImode, 
0, 
E_SImode) != 0)
                return -1;
              return 6;

            case 12:
              if (pattern125 (x2, 
E_TImode, 
4, 
E_SImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern170 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 2;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !immediate_operand (operands[1], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (!s_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !immediate_operand (operands[1], E_SImode))
            return -1;
          return 1;

        case E_HImode:
          if (!s_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !immediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      if (!memory_operand (operands[1], E_VOIDmode)
          || !memory_operand (operands[0], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern215 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern215 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  operands[3] = x1;
  if (!const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !scratch_operand (operands[2], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!bras_sym_operand (operands[0], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x12 = XEXP (x2, 0);
  switch (GET_MODE (x12))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern292 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern299 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 9);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 10);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XVECEXP (x1, 0, 12);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i2)
    return -1;
  x10 = XVECEXP (x1, 0, 13);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i1)
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1199; /* vec_widen_smult_odd_v1qi */

    case 1:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1200; /* vec_widen_smult_odd_v2qi */

    case 2:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1201; /* vec_widen_smult_odd_v4qi */

    case 3:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1202; /* vec_widen_smult_odd_v8qi */

    case 4:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1203; /* vec_widen_smult_odd_v16qi */

    case 5:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1204; /* vec_widen_smult_odd_v1hi */

    case 6:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1205; /* vec_widen_smult_odd_v2hi */

    case 7:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1206; /* vec_widen_smult_odd_v4hi */

    case 8:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1207; /* vec_widen_smult_odd_v8hi */

    case 9:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1208; /* vec_widen_smult_odd_v1si */

    case 10:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1209; /* vec_widen_smult_odd_v2si */

    case 11:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1210; /* vec_widen_smult_odd_v4si */

    case 12:
      if (!
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1211; /* vec_widen_smult_odd_v1di */

    case 13:
      if (!(
#line 1737 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1212; /* vec_widen_smult_odd_v2di */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x2) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode)
          || !(
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 396; /* vec_fpintv1sf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !(
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 397; /* vec_fpintv2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 398; /* vec_fpintv4sf */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x2) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode)
          || !
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 399; /* vec_fpintv1df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 400; /* vec_fpintv2df */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 401; /* vec_fpintv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x2) != E_TFmode
          || !register_operand (operands[1], E_TFmode)
          || !(
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 402; /* vec_fpinttf */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      res = recog_24 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      switch (GET_MODE (x4))
        {
        case E_DImode:
          if (!general_operand (x3, E_DImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_DImode))
            {
              if (
#line 1264 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode) && TARGET_ZARCH))
                return 1757; /* *cmpdi_cct */
              if ((
#line 1352 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1764; /* *cmpdi_ccs */
              if (
#line 1417 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode) && TARGET_ZARCH))
                return 1770; /* *cmpdi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 6862 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2257; /* *subdi3_cconly2 */

        case E_SImode:
          if (!general_operand (x3, E_SImode))
            return -1;
          operands[1] = x3;
          operands[0] = x4;
          if (nonimmediate_operand (operands[0], E_SImode))
            {
              if (
#line 1278 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCTmode)))
                return 1758; /* *cmpsi_cct */
              if (
#line 1352 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1765; /* *cmpsi_ccs */
              if (
#line 1436 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)))
                return 1771; /* *cmpsi_ccu */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x3;
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 6862 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL3mode)))
            return -1;
          *pnum_clobbers = 1;
          return 2258; /* *subsi3_cconly2 */

        case E_HImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_HImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_HImode)
              || !
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], HImode)))
            return -1;
          return 1772; /* *cmphi_ccu */

        case E_QImode:
          operands[0] = x4;
          if (!nonimmediate_operand (operands[0], E_QImode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_QImode)
              || !
#line 1472 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && !register_operand (operands[1], QImode)))
            return -1;
          return 1773; /* *cmpqi_ccu */

        case E_TFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TFmode))
            return -1;
          operands[1] = x3;
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1787; /* *cmptf_ccs */
          if (register_operand (operands[1], E_TFmode)
              && 
#line 1593 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_VXE))
            return 1793; /* *cmptf_ccs */
          if (general_operand (operands[1], E_TFmode)
              && (
#line 1604 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 1794; /* *cmptf_ccsfps */
          if (!register_operand (operands[1], E_TFmode)
              || !
#line 1619 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_VXE))
            return -1;
          return 1800; /* *cmptf_ccsfps */

        case E_FPRX2mode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_FPRX2mode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 1788; /* *cmpfprx2_ccs */
          if (!(
#line 1604 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 1795; /* *cmpfprx2_ccsfps */

        case E_DFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1789; /* *cmpdf_ccs */
          if (!
#line 1604 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1796; /* *cmpdf_ccsfps */

        case E_SFmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_SFmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT))
            return 1790; /* *cmpsf_ccs */
          if (!
#line 1604 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT))
            return -1;
          return 1797; /* *cmpsf_ccsfps */

        case E_TDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_TDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_TDmode))
            return -1;
          if ((
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1791; /* *cmptd_ccs */
          if (!(
#line 1604 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1798; /* *cmptd_ccsfps */

        case E_DDmode:
          operands[0] = x4;
          if (!register_operand (operands[0], E_DDmode))
            return -1;
          operands[1] = x3;
          if (!general_operand (operands[1], E_DDmode))
            return -1;
          if ((
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return 1792; /* *cmpdd_ccs */
          if (!(
#line 1604 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSFPSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 1799; /* *cmpdd_ccsfps */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[1], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !general_operand (operands[2], E_DImode)
              || !(
#line 6354 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2211; /* *adddi3_cconly2 */

        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !general_operand (operands[2], E_SImode)
              || !
#line 6354 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2212; /* *addsi3_cconly2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_25 (x1, insn, pnum_clobbers);

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (x3))
            {
            case E_QImode:
              if (memory_operand (operands[0], E_QImode)
                  && immediate_operand (operands[1], E_QImode)
                  && immediate_operand (operands[2], E_QImode)
                  && 
#line 1013 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], false))))
                return 1733; /* *tmqi_mem */
              break;

            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && immediate_operand (operands[1], E_DImode)
                  && immediate_operand (operands[2], E_DImode)
                  && 
#line 1027 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], DImode, HImode, 0) >= 0))
                return 1734; /* *tmdi_reg */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && immediate_operand (operands[1], E_SImode)
                  && immediate_operand (operands[2], E_SImode)
                  && 
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, s390_tm_ccmode (operands[1], operands[2], true))
   && s390_single_part (operands[1], SImode, HImode, 0) >= 0))
                return 1735; /* *tmsi_reg */
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[1] = x4;
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x5;
          switch (pattern155 (x3))
            {
            case 0:
              if (!
#line 7932 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], DImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2341; /* *anddi3_cconly */

            case 1:
              if (!
#line 8060 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)
   /* Do not steal TM patterns.  */
   && s390_single_part (operands[2], SImode, HImode, 0) < 0))
                return -1;
              *pnum_clobbers = 1;
              return 2352; /* *andsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x2, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern134 (x3))
            {
            case 0:
              if (!(
#line 8595 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2377; /* *andcdi_cconly */

            case 1:
              if (!
#line 8595 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2379; /* *andcsi_cconly */

            case 2:
              if (!(
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2389; /* *nordi_cconly */

            case 3:
              if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2391; /* *norsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !register_operand (operands[0], E_DImode)
                  || !
#line 1297 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_ZARCH))
                return -1;
              return 1759; /* *cmpdi_ccs_sign */

            case E_HImode:
              if (!memory_operand (operands[1], E_HImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !(
#line 1337 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1762; /* *cmpdi_ccs_signhi_rl */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 1337 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode) && TARGET_Z10))
                    return -1;
                  return 1763; /* *cmpdi_ccs_signhi_rl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case E_SImode:
          if (!memory_operand (operands[1], E_HImode)
              || !register_operand (operands[0], E_SImode)
              || !
#line 1313 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSRmode)))
            return -1;
          return 1760; /* *cmpsi_ccs_sign */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) == MEM
          && GET_MODE (x4) == E_HImode)
        {
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          switch (GET_MODE (x3))
            {
            case E_SImode:
              if (register_operand (operands[0], E_SImode))
                {
                  if (larl_operand (operands[1], E_SImode)
                      && 
#line 1375 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1766; /* *cmpsi_ccu_zerohi_rlsi */
                  if (larl_operand (operands[1], E_DImode)
                      && 
#line 1388 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10))
                    return 1768; /* *cmpsi_ccu_zerohi_rldi */
                }
              break;

            case E_DImode:
              if (larl_operand (operands[1], E_DImode)
                  && register_operand (operands[0], E_DImode)
                  && (
#line 1388 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCURmode) && TARGET_Z10) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1767; /* *cmpdi_ccu_zerohi_rldi */
              break;

            default:
              break;
            }
        }
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 1400 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCURmode) && TARGET_ZARCH))
        return -1;
      return 1769; /* *cmpdi_ccu_zero */

    case IOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != AND
              || GET_MODE (x5) != E_DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!contiguous_bitmask_operand (operands[2], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (!nonimmediate_operand (operands[3], E_DImode))
            return -1;
          x10 = XEXP (x5, 1);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_DImode)
              || !
#line 4533 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && s390_match_ccmode (insn, CCSmode)
   && INTVAL (operands[2]) == ~INTVAL (operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 1959; /* *insv_z10_noshift_cconly */

        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x4;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (pattern155 (x3))
            {
            case 0:
              if (!
#line 8346 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2363; /* *iordi3_cconly */

            case 1:
              if (!
#line 8428 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2366; /* *iorsi3_cconly */

            default:
              return -1;
            }

        case NOT:
          switch (pattern134 (x3))
            {
            case 0:
              if (!(
#line 8595 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2378; /* *orcdi_cconly */

            case 1:
              if (!
#line 8595 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2380; /* *orcsi_cconly */

            case 2:
              if (!(
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 2390; /* *nanddi_cconly */

            case 3:
              if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
                return -1;
              *pnum_clobbers = 1;
              return 2392; /* *nandsi_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      return recog_26 (x1, insn, pnum_clobbers);

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x2, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (!general_operand (operands[2], E_SImode)
              || !
#line 6679 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2241; /* *subdi3_zero_cconly */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x6, operands[1]))
                return -1;
              switch (pattern188 (x3))
                {
                case 0:
                  if (!(
#line 6793 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2249; /* *subdi3_borrow_cconly */

                case 1:
                  if (!
#line 6793 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL2mode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2250; /* *subsi3_borrow_cconly */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  switch (pattern188 (x3))
                    {
                    case 0:
                      if ((
#line 6845 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        {
                          *pnum_clobbers = 1;
                          return 2255; /* *subdi3_cconly */
                        }
                      break;

                    case 1:
                      if (
#line 6845 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
                        {
                          *pnum_clobbers = 1;
                          return 2256; /* *subsi3_cconly */
                        }
                      break;

                    default:
                      break;
                    }
                }
              operands[3] = x6;
              switch (GET_MODE (x3))
                {
                case E_TFmode:
                  if (!nonimmediate_operand (operands[1], E_TFmode)
                      || !general_operand (operands[2], E_TFmode)
                      || !const0_operand (operands[3], E_TFmode)
                      || !(
#line 6964 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2274; /* *subtf3_cconly */

                case E_FPRX2mode:
                  if (!nonimmediate_operand (operands[1], E_FPRX2mode)
                      || !general_operand (operands[2], E_FPRX2mode)
                      || !const0_operand (operands[3], E_FPRX2mode)
                      || !(
#line 6964 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 748 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2275; /* *subfprx23_cconly */

                case E_DFmode:
                  if (!nonimmediate_operand (operands[1], E_DFmode)
                      || !general_operand (operands[2], E_DFmode)
                      || !const0_operand (operands[3], E_DFmode)
                      || !
#line 6964 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2276; /* *subdf3_cconly */

                case E_SFmode:
                  if (!nonimmediate_operand (operands[1], E_SFmode)
                      || !general_operand (operands[2], E_SFmode)
                      || !const0_operand (operands[3], E_SFmode)
                      || !
#line 6964 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2277; /* *subsf3_cconly */

                case E_TDmode:
                  if (!nonimmediate_operand (operands[1], E_TDmode)
                      || !general_operand (operands[2], E_TDmode)
                      || !const0_operand (operands[3], E_TDmode)
                      || !(
#line 6964 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2278; /* *subtd3_cconly */

                case E_DDmode:
                  if (!nonimmediate_operand (operands[1], E_DDmode)
                      || !general_operand (operands[2], E_DDmode)
                      || !const0_operand (operands[3], E_DDmode)
                      || !(
#line 6964 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 2279; /* *subdd3_cconly */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern155 (x3))
        {
        case 0:
          if (!
#line 8771 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode) && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2401; /* *xordi3_cconly */

        case 1:
          if (!
#line 8838 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2404; /* *xorsi3_cconly */

        default:
          return -1;
        }

    case NOT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != XOR)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[2], E_DImode)
              || !(
#line 9049 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2412; /* *nxordi_cconly */

        case E_SImode:
          if (GET_MODE (x4) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !register_operand (operands[2], E_SImode)
              || !
#line 9049 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2413; /* *nxorsi_cconly */

        default:
          return -1;
        }

    case NEG:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XEXP (x2, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x3))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && (
#line 9119 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2420; /* *negdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 9119 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2421; /* *negsi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          switch (pattern135 (x3))
            {
            case 0:
              if (!(
#line 9240 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2429; /* *negtf2_cconly */

            case 1:
              if (!(
#line 9240 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2430; /* *negfprx22_cconly */

            case 2:
              if (!
#line 9240 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2431; /* *negdf2_cconly */

            case 3:
              if (!
#line 9240 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2432; /* *negsf2_cconly */

            default:
              return -1;
            }

        case ABS:
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x6 = XEXP (x2, 1);
          if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              switch (GET_MODE (x3))
                {
                case E_DImode:
                  if (GET_MODE (x4) == E_DImode
                      && register_operand (operands[1], E_DImode)
                      && (
#line 9467 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    {
                      *pnum_clobbers = 1;
                      return 2473; /* *negabsdi2_cconly */
                    }
                  break;

                case E_SImode:
                  if (GET_MODE (x4) == E_SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 9467 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                    {
                      *pnum_clobbers = 1;
                      return 2474; /* *negabssi2_cconly */
                    }
                  break;

                default:
                  break;
                }
            }
          operands[2] = x6;
          switch (GET_MODE (x3))
            {
            case E_TFmode:
              if (GET_MODE (x4) != E_TFmode
                  || !register_operand (operands[1], E_TFmode)
                  || !const0_operand (operands[2], E_TFmode)
                  || !(
#line 9504 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2481; /* *negabstf2_cconly */

            case E_FPRX2mode:
              if (GET_MODE (x4) != E_FPRX2mode
                  || !register_operand (operands[1], E_FPRX2mode)
                  || !const0_operand (operands[2], E_FPRX2mode)
                  || !(
#line 9504 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2482; /* *negabsfprx22_cconly */

            case E_DFmode:
              if (GET_MODE (x4) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !const0_operand (operands[2], E_DFmode)
                  || !
#line 9504 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2483; /* *negabsdf2_cconly */

            case E_SFmode:
              if (GET_MODE (x4) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !const0_operand (operands[2], E_SFmode)
                  || !
#line 9504 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2484; /* *negabssf2_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x6 = XEXP (x2, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          switch (GET_MODE (x3))
            {
            case E_DImode:
              if (register_operand (operands[1], E_DImode)
                  && (
#line 9320 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2447; /* *absdi2_cconly */
                }
              break;

            case E_SImode:
              if (register_operand (operands[1], E_SImode)
                  && 
#line 9320 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCAmode)))
                {
                  *pnum_clobbers = 1;
                  return 2448; /* *abssi2_cconly */
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x6;
      switch (pattern135 (x3))
        {
        case 0:
          if (!(
#line 9365 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2455; /* *abstf2_cconly */

        case 1:
          if (!(
#line 9365 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2456; /* *absfprx22_cconly */

        case 2:
          if (!
#line 9365 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2457; /* *absdf2_cconly */

        case 3:
          if (!
#line 9365 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2458; /* *abssf2_cconly */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!shift_count_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          if ((
#line 45 "../../gcc-15.0.1-20250313/gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 9727 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2511; /* *ashrdi3_31_cconly */
            }
          if (!(
#line 45 "../../gcc-15.0.1-20250313/gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2514; /* *ashrdi3_cconly */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 45 "../../gcc-15.0.1-20250313/gcc/config/s390/subst.md"
(s390_match_ccmode(insn, CCSmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2517; /* *ashrsi3_cconly */

        default:
          return -1;
        }

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12095 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15 && s390_match_ccmode(insn, CCTmode)))
        return -1;
      *pnum_clobbers = 1;
      return 2635; /* *popcountdi_z15_cconly */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 3);
      operands[4] = x4;
      switch (XINT (x2, 1))
        {
        case 61:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!memory_operand (operands[3], E_BLKmode)
              || !const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern19 (x2, 
E_V4SImode) != 0
                  || !
#line 83 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SImode)))
                return -1;
              return 1; /* vec_gather_elementv4si */

            case E_V2DImode:
              if (pattern19 (x2, 
E_V2DImode) != 0
                  || !
#line 83 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DImode)))
                return -1;
              return 2; /* vec_gather_elementv2di */

            case E_V2DFmode:
              if (pattern198 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 83 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V2DFmode)))
                return -1;
              return 3; /* vec_gather_elementv2df */

            case E_V4SFmode:
              if (pattern198 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 83 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[4]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
                return -1;
              return 4; /* vec_gather_elementv4sf */

            default:
              return -1;
            }

        case 96:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 203; /* verimv16qi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 204; /* verimv8hi */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 205; /* verimv4si */

            case E_V2DImode:
              if (pattern51 (x2, 
E_V2DImode) != 0
                  || !
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 206; /* verimv2di */

            default:
              return -1;
            }

        case 131:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2DImode))
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_V2DImode))
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || GET_MODE (x2) != E_V16QImode
                  || !register_operand (operands[3], E_V16QImode)
                  || !
#line 1258 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 357; /* vec_msumv2di */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
                return -1;
              return 358; /* vmslg */

            default:
              return -1;
            }

        case 118:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_mask_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 383; /* vstrcv16qi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 384; /* vstrcv8hi */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 385; /* vstrcv4si */

            default:
              return -1;
            }

        case 135:
          x5 = XVECEXP (x2, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x2, 0, 1);
          operands[2] = x6;
          x7 = XVECEXP (x2, 0, 2);
          operands[3] = x7;
          if (!const_int_operand (operands[4], E_QImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern51 (x2, 
E_V1QImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1717; /* vevalv1qi */

            case E_V2QImode:
              if (pattern51 (x2, 
E_V2QImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1718; /* vevalv2qi */

            case E_V4QImode:
              if (pattern51 (x2, 
E_V4QImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1719; /* vevalv4qi */

            case E_V8QImode:
              if (pattern51 (x2, 
E_V8QImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1720; /* vevalv8qi */

            case E_V16QImode:
              if (pattern51 (x2, 
E_V16QImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1721; /* vevalv16qi */

            case E_V1HImode:
              if (pattern51 (x2, 
E_V1HImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1722; /* vevalv1hi */

            case E_V2HImode:
              if (pattern51 (x2, 
E_V2HImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1723; /* vevalv2hi */

            case E_V4HImode:
              if (pattern51 (x2, 
E_V4HImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1724; /* vevalv4hi */

            case E_V8HImode:
              if (pattern51 (x2, 
E_V8HImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1725; /* vevalv8hi */

            case E_V1SImode:
              if (pattern51 (x2, 
E_V1SImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1726; /* vevalv1si */

            case E_V2SImode:
              if (pattern51 (x2, 
E_V2SImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1727; /* vevalv2si */

            case E_V4SImode:
              if (pattern51 (x2, 
E_V4SImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1728; /* vevalv4si */

            case E_V1DImode:
              if (pattern51 (x2, 
E_V1DImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1729; /* vevalv1di */

            case E_V2DImode:
              if (pattern51 (x2, 
E_V2DImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1730; /* vevalv2di */

            case E_V1TImode:
              if (pattern51 (x2, 
E_V1TImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1731; /* vevalv1ti */

            case E_TImode:
              if (pattern51 (x2, 
E_TImode) != 0
                  || !
#line 3421 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
                return -1;
              return 1732; /* vevalti */

            default:
              return -1;
            }

        case 31:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x5 = XVECEXP (x2, 0, 0);
          operands[2] = x5;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!immediate_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern251 (x2, 
E_DImode) != 0
                  || !
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1880; /* *strlendi */

            case E_SImode:
              if (pattern251 (x2, 
E_SImode) != 0
                  || !
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              *pnum_clobbers = 2;
              return 1881; /* *strlensi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      return recog_17 (x1, insn, pnum_clobbers);

    case 2:
      return recog_16 (x1, insn, pnum_clobbers);

    case 3:
      return recog_18 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
              || pattern140 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode) != 0
              || !
#line 2810 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1523; /* *vec_extendv4sf */

        case 1:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern140 (x3, 
E_V2DFmode, 
E_V1DFmode, 
E_V1TFmode) != 0
              || !
#line 2854 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1524; /* *vec_extendv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (register_operand (operands[1], E_DFmode)
                  && 
#line 3177 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
                return 1558; /* extenddftf2_vr */
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 5781 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || TFmode != DFmode || DFmode != SFmode)) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2096; /* *extenddftf2 */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 5781 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || TFmode != DFmode || SFmode != SFmode)) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2100; /* *extendsftf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode))
                return -1;
              if (
#line 5769 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
                return 2095; /* *extendsfdf2_z13 */
              if (!
#line 5781 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || DFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 2102; /* *extendsfdf2 */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !
#line 5781 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || DFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 2098; /* *extenddfdf2 */

            default:
              return -1;
            }

        case E_FPRX2mode:
          switch (pattern87 (x3, 
E_FPRX2mode))
            {
            case 0:
              if (!(
#line 5781 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || DFmode != SFmode)) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2097; /* *extenddffprx22 */

            case 1:
              if (!(
#line 5781 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || SFmode != SFmode)) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2101; /* *extendsffprx22 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern87 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5781 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || SFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 2099; /* *extenddfsf2 */

            case 1:
              if (!
#line 5781 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || SFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 2103; /* *extendsfsf2 */

            default:
              return -1;
            }

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5803 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2104; /* extendddtd2 */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_SDmode)
              || !
#line 5811 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2105; /* extendsddd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 953; /* ctzv1qi2 */

    case 1:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 954; /* ctzv2qi2 */

    case 2:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 955; /* ctzv4qi2 */

    case 3:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 956; /* ctzv8qi2 */

    case 4:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 957; /* ctzv16qi2 */

    case 5:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 958; /* ctzv1hi2 */

    case 6:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 959; /* ctzv2hi2 */

    case 7:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 960; /* ctzv4hi2 */

    case 8:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 961; /* ctzv8hi2 */

    case 9:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 962; /* ctzv1si2 */

    case 10:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 963; /* ctzv2si2 */

    case 11:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 964; /* ctzv4si2 */

    case 12:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 965; /* ctzv1di2 */

    case 13:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 966; /* ctzv2di2 */

    case 14:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 967; /* ctzv1sf2 */

    case 15:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 968; /* ctzv2sf2 */

    case 16:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 969; /* ctzv4sf2 */

    case 17:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 970; /* ctzv1df2 */

    case 18:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 971; /* ctzv2df2 */

    case 19:
      if (!
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 972; /* ctzv1tf2 */

    case 20:
      if (!(
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 973; /* ctzv1ti2 */

    case 21:
      if (!(
#line 1445 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 974; /* ctzti2 */

    case 22:
      if (!
#line 9633 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
        return -1;
      return 2501; /* ctzdi2 */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x8, 1);
  x11 = XEXP (x10, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      if (pattern290 (x10, 
E_DImode) != 0
          || !
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2533; /* *brx_stage1_di */

    case E_SImode:
      if (pattern290 (x10, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2534; /* *brx_stage1_si */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pattern121 (x3, 
E_HImode) != 0)
        return -1;
      if (
#line 8146 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2355; /* *andhi3_zarch */
      if (!
#line 8163 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2356; /* *andhi3_esa */

    case E_QImode:
      if (pattern121 (x3, 
E_QImode) != 0)
        return -1;
      if (
#line 8191 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2357; /* *andqi3_zarch */
      if (!
#line 8208 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2358; /* *andqi3_esa */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case STRICT_LOW_PART:
      if (pattern90 (x1) != 0
          || !subreg_register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_HImode))
        return -1;
      return 1856; /* movstricthi */

    case SUBREG:
    case MEM:
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 3106 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1873; /* *mvc */

    case ZERO_EXTRACT:
      if (pattern90 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[3], E_DImode)
              || !(
#line 4479 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1951; /* *insvdi_clobbercc */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || !
#line 4479 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
            return -1;
          return 1953; /* *insvsi_clobbercc */

        default:
          return -1;
        }

    case PC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 1)
        return -1;
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !(
#line 10412 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2544; /* indirect_jump_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !(
#line 10412 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2545; /* indirect_jump_via_thunksi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern193 (x6))
    {
    case 0:
      if (!(
#line 4313 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 1921; /* *extzvdi_clobbercc */

    case 1:
      if (!
#line 4313 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      return 1923; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern93 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              x9 = XEXP (x6, 2);
              operands[5] = x9;
              if (!const_int_operand (operands[5], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern278 (x4, 
E_DImode) != 0
                      || !
#line 4345 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1927; /* *risbg_ior_and_sr_zedi */

                case E_SImode:
                  if (pattern278 (x4, 
E_SImode) != 0
                      || !
#line 4345 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1929; /* *risbg_ior_and_sr_zesi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern263 (x4, 
E_DImode) != 0
                      || !(
#line 4495 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1955; /* *insvdi_clobbercc_noshift */

                case E_SImode:
                  if (pattern263 (x4, 
E_SImode) != 0
                      || !
#line 4495 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return -1;
                  return 1957; /* *insvsi_clobbercc_noshift */

                default:
                  return -1;
                }

            case ASHIFT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern264 (x4, 
E_DImode) != 0
                      || !(
#line 4549 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1961; /* *insvdi_clobbercc_appendbitsleft */

                case E_SImode:
                  if (pattern264 (x4, 
E_SImode) != 0
                      || !
#line 4549 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return -1;
                  return 1963; /* *insvsi_clobbercc_appendbitsleft */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern265 (x4, 
E_DImode) != 0
                      || !(
#line 4564 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1965; /* *risbg_di_ior_and_lshiftrt */

                case E_SImode:
                  if (pattern265 (x4, 
E_SImode) != 0
                      || !
#line 4564 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return -1;
                  return 1967; /* *risbg_si_ior_and_lshiftrt */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 4)
                  && GET_MODE (x6) == E_SImode)
                {
                  x7 = XEXP (x6, 0);
                  if (GET_CODE (x7) == LSHIFTRT
                      && GET_MODE (x7) == E_DImode
                      && pattern228 (x4, 
E_SImode) == 0
                      && const_int_operand (operands[2], E_SImode))
                    {
                      x10 = XEXP (x7, 0);
                      operands[3] = x10;
                      if (register_operand (operands[3], E_DImode))
                        {
                          x11 = XEXP (x7, 1);
                          operands[4] = x11;
                          if (nonzero_shift_count_operand (operands[4], E_DImode)
                              && 
#line 4581 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
                            return 1969; /* *risbg_sidi_ior_and_lshiftrt */
                        }
                    }
                }
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern250 (x4, 
E_DImode) != 0
                      || !(
#line 4678 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1974; /* *rosbg_di_noshift */

                case E_SImode:
                  if (pattern250 (x4, 
E_SImode) != 0
                      || !
#line 4678 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  return 1976; /* *rosbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (!
#line 4693 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1978; /* *rosbg_di_rotl */

        case 2:
          if (!(
#line 4708 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1980; /* *rosbg_di_srl_bitmask */

        case 3:
          if (!
#line 4708 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1982; /* *rosbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4728 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1984; /* *rosbg_di_sll_bitmask */

        case 5:
          if (!
#line 4728 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 1986; /* *rosbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern89 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern95 (x4))
            {
            case 0:
              if (!(
#line 4746 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1988; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4746 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1990; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x13) != E_TImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != CLZ
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x5, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND
              || GET_MODE (x6) != E_TImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != XOR
              || GET_MODE (x7) != E_DImode)
            return -1;
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != LSHIFTRT)
            return -1;
          x16 = XEXP (x11, 1);
          if (GET_CODE (x16) != SUBREG
              || maybe_ne (SUBREG_BYTE (x16), 4)
              || GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != CLZ
              || GET_MODE (x17) != E_DImode
              || !register_operand (operands[0], E_TImode)
              || GET_MODE (x4) != E_TImode
              || GET_MODE (x5) != E_TImode)
            return -1;
          x18 = XEXP (x14, 0);
          operands[1] = x18;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x19 = XEXP (x11, 0);
          operands[2] = x19;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x20 = XEXP (x17, 0);
          if (!rtx_equal_p (x20, operands[1])
              || !
#line 9620 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
            return -1;
          return 2500; /* clztidi2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4765 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1992; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4765 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1994; /* *rosbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern119 (x1) == 0
          && 
#line 4785 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10))
        return 1996; /* *rosbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern120 (x1) == 0
          && 
#line 8668 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2399; /* *oc */
        }
      operands[1] = x5;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 8363 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2364; /* *iordi3 */

        case 1:
          if (
#line 8444 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2367; /* *iorsi3_zarch */
          if (!
#line 8472 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2368; /* *iorsi3_esa */

        case 2:
          if (
#line 8500 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2369; /* *iorhi3_zarch */
          if (!
#line 8516 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2370; /* *iorhi3_esa */

        case 3:
          if (
#line 8543 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2371; /* *iorqi3_zarch */
          if (!
#line 8561 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2372; /* *iorqi3_esa */

        default:
          return -1;
        }

    case NOT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern89 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern241 (x4, 
E_DImode) != 0
                  || !(
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2382; /* *orcdi */

            case E_SImode:
              if (pattern241 (x4, 
E_SImode) != 0
                  || !
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2384; /* *orcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern216 (x4))
            {
            case 0:
              if (!(
#line 8645 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2394; /* *nanddi */

            case 1:
              if (!
#line 8645 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2396; /* *nandsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_118 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern44 (x2, 
10, 
1, 
UNSPEC_VOLATILE) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XVECEXP (x7, 0, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2595; /* atomic_fetch_anddi_iaf */

        case 1:
          if (!
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2599; /* atomic_fetch_andsi_iaf */

        default:
          return -1;
        }

    case IOR:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2596; /* atomic_fetch_ordi_iaf */

        case 1:
          if (!
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2600; /* atomic_fetch_orsi_iaf */

        default:
          return -1;
        }

    case XOR:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2597; /* atomic_fetch_xordi_iaf */

        case 1:
          if (!
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2601; /* atomic_fetch_xorsi_iaf */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern218 (x7))
        {
        case 0:
          if (!(
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2598; /* atomic_fetch_adddi_iaf */

        case 1:
          if (!
#line 11424 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2602; /* atomic_fetch_addsi_iaf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_144 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_153 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_162 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_171 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_180 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_189 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_207 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_216 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_225 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_234 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_243 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_252 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_261 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_270 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_279 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_145 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_154 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_163 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_181 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_190 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_208 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_217 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_226 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_235 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_244 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_253 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_262 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_271 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_280 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_146 (insn, operands);

        case 1:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_155 (insn, operands);

        case 2:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_164 (insn, operands);

        case 3:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_173 (insn, operands);

        case 4:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_182 (insn, operands);

        case 5:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_191 (insn, operands);

        case 6:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_209 (insn, operands);

        case 8:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_218 (insn, operands);

        case 9:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_227 (insn, operands);

        case 10:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_236 (insn, operands);

        case 11:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_245 (insn, operands);

        case 12:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_254 (insn, operands);

        case 13:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_263 (insn, operands);

        case 14:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_272 (insn, operands);

        case 15:
          if (!(
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3402 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_281 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != ASHIFT)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x9 = XEXP (x5, 1);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern181 (x3, 
E_DImode) != 0
              || !(
#line 4624 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return NULL;
          return gen_split_342 (insn, operands);

        case E_SImode:
          if (pattern181 (x3, 
E_SImode) != 0
              || !
#line 4624 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
            return NULL;
          return gen_split_343 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_BLKmode)
      || !memory_operand (operands[1], E_BLKmode))
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (pattern197 (x4, 
2) != 0)
    return NULL;
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!memory_operand (operands[3], E_BLKmode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!memory_operand (operands[4], E_BLKmode))
    return NULL;
  x8 = XVECEXP (x4, 0, 1);
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !
#line 3135 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(((INTVAL (operands[2]) > 16 && INTVAL (operands[5]) > 16)
    || (INTVAL (operands[2]) + INTVAL (operands[5]) <= 16))
   && s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_18 (insn, operands);
}
