/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x1) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x1) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x1) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x1) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x1) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x1) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x1) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_DImode:
      if (pattern10 (x1, 
E_DImode) != 0)
        return -1;
      return 14;

    case E_SImode:
      if (pattern10 (x1, 
E_SImode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  switch (XVECLEN (x4, 0))
    {
    case 16:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
        return -1;
      x11 = XVECEXP (x4, 0, 4);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
        return -1;
      x12 = XVECEXP (x4, 0, 5);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
        return -1;
      x13 = XVECEXP (x4, 0, 6);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
        return -1;
      x14 = XVECEXP (x4, 0, 7);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x15 = XVECEXP (x4, 0, 8);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
        return -1;
      x16 = XVECEXP (x4, 0, 9);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x17 = XVECEXP (x4, 0, 10);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x18 = XVECEXP (x4, 0, 11);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x19 = XVECEXP (x4, 0, 12);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x20 = XVECEXP (x4, 0, 13);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x21 = XVECEXP (x4, 0, 14);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XVECEXP (x4, 0, 15);
      if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != USE
          || !nonimmediate_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !nonimmediate_operand (operands[1], E_V16QImode))
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!permute_pattern_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case 4:
      x7 = XVECEXP (x4, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x4, 0, 3);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x23 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x23) != CLOBBER)
        return -1;
      x24 = XEXP (x23, 0);
      operands[2] = x24;
      if (!scratch_operand (operands[2], E_V2DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!nonimmediate_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 1;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 26)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 1)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != LABEL_REF)
    return -1;
  x10 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != USE)
    return -1;
  return 0;
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern91 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern91 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SUBREG)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG)
    return -1;
  return 0;
}

int
pattern107 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern113 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != i2
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern121 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  if (maybe_ne (SUBREG_BYTE (x5), i2)
      || GET_MODE (x5) != i3
      || !register_operand (operands[0], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x6) != i3
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (XWINT (x5, 0) != 64L)
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_DImode)
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != SIGN_EXTEND)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x4, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x5, 0);
  operands[2] = x12;
  x13 = XEXP (x8, 0);
  operands[0] = x13;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x7, 1);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XEXP (x9, 0);
  if (!rtx_equal_p (x16, operands[1]))
    return -1;
  x17 = XEXP (x9, 1);
  if (!rtx_equal_p (x17, operands[2]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_TImode:
      return 0;

    case E_DImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern169 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern187 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern198 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_TImode)
      || GET_MODE (x1) != E_TImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_TImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_TImode)
    return -1;
  return 0;
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern220 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern228 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern255 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  if (!const0_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!nonimmediate_operand (operands[0], E_V8HImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_V8HImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_V2DImode))
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern297 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 207; /* vec_sllv16qiv16qi */

    case 1:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 217; /* vec_sllv16qiv8hi */

    case 2:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 227; /* vec_sllv16qiv4si */

    case 3:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 208; /* vec_sllv8hiv16qi */

    case 4:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 218; /* vec_sllv8hiv8hi */

    case 5:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 228; /* vec_sllv8hiv4si */

    case 6:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 209; /* vec_sllv4siv16qi */

    case 7:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 219; /* vec_sllv4siv8hi */

    case 8:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 229; /* vec_sllv4siv4si */

    case 9:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 210; /* vec_sllv2div16qi */

    case 10:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 220; /* vec_sllv2div8hi */

    case 11:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 230; /* vec_sllv2div4si */

    case 12:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 211; /* vec_sllv1tiv16qi */

    case 13:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 221; /* vec_sllv1tiv8hi */

    case 14:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 231; /* vec_sllv1tiv4si */

    case 15:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 212; /* vec_slltiv16qi */

    case 16:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 222; /* vec_slltiv8hi */

    case 17:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 232; /* vec_slltiv4si */

    case 18:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 213; /* vec_sllv4sfv16qi */

    case 19:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 223; /* vec_sllv4sfv8hi */

    case 20:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 233; /* vec_sllv4sfv4si */

    case 21:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 214; /* vec_sllv2dfv16qi */

    case 22:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 224; /* vec_sllv2dfv8hi */

    case 23:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 234; /* vec_sllv2dfv4si */

    case 24:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 215; /* vec_sllv1tfv16qi */

    case 25:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 225; /* vec_sllv1tfv8hi */

    case 26:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 235; /* vec_sllv1tfv4si */

    case 27:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 216; /* vec_slltfv16qi */

    case 28:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 226; /* vec_slltfv8hi */

    case 29:
      if (!
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 236; /* vec_slltfv4si */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern130 (x2, 
E_V1QImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 794; /* notandv1qi3 */

        case E_V2QImode:
          if (pattern130 (x2, 
E_V2QImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 795; /* notandv2qi3 */

        case E_V4QImode:
          if (pattern130 (x2, 
E_V4QImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 796; /* notandv4qi3 */

        case E_V8QImode:
          if (pattern130 (x2, 
E_V8QImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 797; /* notandv8qi3 */

        case E_V16QImode:
          if (pattern130 (x2, 
E_V16QImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 798; /* notandv16qi3 */

        case E_V1HImode:
          if (pattern130 (x2, 
E_V1HImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 799; /* notandv1hi3 */

        case E_V2HImode:
          if (pattern130 (x2, 
E_V2HImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 800; /* notandv2hi3 */

        case E_V4HImode:
          if (pattern130 (x2, 
E_V4HImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 801; /* notandv4hi3 */

        case E_V8HImode:
          if (pattern130 (x2, 
E_V8HImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 802; /* notandv8hi3 */

        case E_V1SImode:
          if (pattern130 (x2, 
E_V1SImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 803; /* notandv1si3 */

        case E_V2SImode:
          if (pattern130 (x2, 
E_V2SImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 804; /* notandv2si3 */

        case E_V4SImode:
          if (pattern130 (x2, 
E_V4SImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 805; /* notandv4si3 */

        case E_V1DImode:
          if (pattern130 (x2, 
E_V1DImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 806; /* notandv1di3 */

        case E_V2DImode:
          if (pattern130 (x2, 
E_V2DImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 807; /* notandv2di3 */

        case E_V1SFmode:
          if (pattern130 (x2, 
E_V1SFmode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 808; /* notandv1sf3 */

        case E_V2SFmode:
          if (pattern130 (x2, 
E_V2SFmode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 809; /* notandv2sf3 */

        case E_V4SFmode:
          if (pattern130 (x2, 
E_V4SFmode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 810; /* notandv4sf3 */

        case E_V1DFmode:
          if (pattern130 (x2, 
E_V1DFmode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 811; /* notandv1df3 */

        case E_V2DFmode:
          if (pattern130 (x2, 
E_V2DFmode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 812; /* notandv2df3 */

        case E_V1TFmode:
          if (pattern130 (x2, 
E_V1TFmode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 813; /* notandv1tf3 */

        case E_V1TImode:
          if (pattern130 (x2, 
E_V1TImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 814; /* notandv1ti3 */

        case E_TImode:
          if (pattern130 (x2, 
E_TImode) != 0
              || !
#line 1266 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 815; /* notandti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern130 (x2, 
E_DImode) != 0
              || !(
#line 8645 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2394; /* *nanddi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern130 (x2, 
E_SImode) != 0
              || !
#line 8645 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2396; /* *nandsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern81 (x2, 
E_V1QImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 838; /* ior_notv1qi3 */

        case E_V2QImode:
          if (pattern81 (x2, 
E_V2QImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 839; /* ior_notv2qi3 */

        case E_V4QImode:
          if (pattern81 (x2, 
E_V4QImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 840; /* ior_notv4qi3 */

        case E_V8QImode:
          if (pattern81 (x2, 
E_V8QImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 841; /* ior_notv8qi3 */

        case E_V16QImode:
          if (pattern81 (x2, 
E_V16QImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 842; /* ior_notv16qi3 */

        case E_V1HImode:
          if (pattern81 (x2, 
E_V1HImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 843; /* ior_notv1hi3 */

        case E_V2HImode:
          if (pattern81 (x2, 
E_V2HImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 844; /* ior_notv2hi3 */

        case E_V4HImode:
          if (pattern81 (x2, 
E_V4HImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 845; /* ior_notv4hi3 */

        case E_V8HImode:
          if (pattern81 (x2, 
E_V8HImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 846; /* ior_notv8hi3 */

        case E_V1SImode:
          if (pattern81 (x2, 
E_V1SImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 847; /* ior_notv1si3 */

        case E_V2SImode:
          if (pattern81 (x2, 
E_V2SImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 848; /* ior_notv2si3 */

        case E_V4SImode:
          if (pattern81 (x2, 
E_V4SImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 849; /* ior_notv4si3 */

        case E_V1DImode:
          if (pattern81 (x2, 
E_V1DImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 850; /* ior_notv1di3 */

        case E_V2DImode:
          if (pattern81 (x2, 
E_V2DImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 851; /* ior_notv2di3 */

        case E_V1SFmode:
          if (pattern81 (x2, 
E_V1SFmode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 852; /* ior_notv1sf3 */

        case E_V2SFmode:
          if (pattern81 (x2, 
E_V2SFmode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 853; /* ior_notv2sf3 */

        case E_V4SFmode:
          if (pattern81 (x2, 
E_V4SFmode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 854; /* ior_notv4sf3 */

        case E_V1DFmode:
          if (pattern81 (x2, 
E_V1DFmode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 855; /* ior_notv1df3 */

        case E_V2DFmode:
          if (pattern81 (x2, 
E_V2DFmode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 856; /* ior_notv2df3 */

        case E_V1TFmode:
          if (pattern81 (x2, 
E_V1TFmode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 857; /* ior_notv1tf3 */

        case E_V1TImode:
          if (pattern81 (x2, 
E_V1TImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 858; /* ior_notv1ti3 */

        case E_TImode:
          if (pattern81 (x2, 
E_TImode) != 0
              || !
#line 1286 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 859; /* ior_notti3 */

        case E_DImode:
          if (pattern82 (x2, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2382; /* *orcdi */

        case E_SImode:
          if (pattern82 (x2, pnum_clobbers, 
E_SImode) != 0
              || !
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2384; /* *orcsi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!nonzero_shift_count_operand (operands[4], E_DImode))
    return -1;
  if (
#line 4327 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return 1924; /* *extzvdi_nocc_lshiftrt */
  if (pnum_clobbers == NULL
      || !
#line 4327 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && 64 - UINTVAL (operands[4]) >= UINTVAL (operands[1])))
    return -1;
  *pnum_clobbers = 1;
  return 1925; /* *extzvdi_clobbercc_lshiftrt */
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!s390_unsigned_integer_comparison (x3, E_VOIDmode))
    return -1;
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      switch (pattern171 (x2))
        {
        case 0:
          if (!(
#line 1665 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1803; /* *cmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1665 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1804; /* *cmp_and_br_unsigned_si */

        default:
          return -1;
        }

    case PC:
      x8 = XEXP (x2, 2);
      switch (pattern172 (x8))
        {
        case 0:
          if (!(
#line 1723 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1807; /* *icmp_and_br_unsigned_di */

        case 1:
          if (!
#line 1723 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && !TARGET_AVOID_CMP_AND_BRANCH))
            return -1;
          *pnum_clobbers = 1;
          return 1808; /* *icmp_and_br_unsigned_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      if ((
#line 4313 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return 1920; /* *extzvdi_nocc */
      if (pnum_clobbers == NULL
          || !(
#line 4313 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 1921; /* *extzvdi_clobbercc */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 4313 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return 1922; /* *extzvsi_nocc */
      if (pnum_clobbers == NULL
          || !
#line 4313 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      *pnum_clobbers = 1;
      return 1923; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SImode:
      if (pattern108 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1390; /* *vec_cmpgev1sf_signaling_nocc */
      if (!(
#line 2302 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1397; /* *vec_cmpgev1sf_signaling_finite_nocc */

    case E_V2SImode:
      if (pattern108 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1391; /* *vec_cmpgev2sf_signaling_nocc */
      if (!(
#line 2302 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1398; /* *vec_cmpgev2sf_signaling_finite_nocc */

    case E_V4SImode:
      if (pattern108 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1392; /* *vec_cmpgev4sf_signaling_nocc */
      if (!(
#line 2302 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1399; /* *vec_cmpgev4sf_signaling_finite_nocc */

    case E_V1DImode:
      if (pattern108 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1393; /* *vec_cmpgev1df_signaling_nocc */
      if (!
#line 2302 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1400; /* *vec_cmpgev1df_signaling_finite_nocc */

    case E_V2DImode:
      if (pattern108 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1394; /* *vec_cmpgev2df_signaling_nocc */
      if (!
#line 2302 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK))
        return -1;
      return 1401; /* *vec_cmpgev2df_signaling_finite_nocc */

    case E_V1TImode:
      if (pattern108 (x3, 
E_V1TFmode, 
E_V1TImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1395; /* *vec_cmpgev1tf_signaling_nocc */
      if (!(
#line 2302 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1402; /* *vec_cmpgev1tf_signaling_finite_nocc */

    case E_TImode:
      if (pattern108 (x3, 
E_TFmode, 
E_TImode) != 0)
        return -1;
      if (
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
        return 1396; /* *vec_cmpgetf_signaling_nocc */
      if (!(
#line 2302 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_NONSIGNALING_VECTOR_COMPARE_OK) && 
#line 76 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1403; /* *vec_cmpgetf_signaling_finite_nocc */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NOT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern173 (x2, 
E_V16QImode) != 0
              || !
#line 704 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 118; /* vec_andcv16qi3 */

        case E_V8HImode:
          if (pattern173 (x2, 
E_V8HImode) != 0
              || !
#line 704 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 119; /* vec_andcv8hi3 */

        case E_V4SImode:
          if (pattern173 (x2, 
E_V4SImode) != 0
              || !
#line 704 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 120; /* vec_andcv4si3 */

        case E_V2DImode:
          if (pattern173 (x2, 
E_V2DImode) != 0
              || !
#line 704 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 121; /* vec_andcv2di3 */

        case E_V2DFmode:
          if (pattern173 (x2, 
E_V2DFmode) != 0
              || !
#line 704 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 122; /* vec_andcv2df3 */

        case E_V1TImode:
          if (pattern173 (x2, 
E_V1TImode) != 0
              || !
#line 704 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 123; /* vec_andcv1ti3 */

        case E_TImode:
          if (pattern173 (x2, 
E_TImode) != 0
              || !
#line 704 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 124; /* vec_andcti3 */

        case E_V4SFmode:
          if (pattern173 (x2, 
E_V4SFmode) != 0
              || !(
#line 704 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 125; /* vec_andcv4sf3 */

        case E_V1TFmode:
          if (pattern173 (x2, 
E_V1TFmode) != 0
              || !(
#line 704 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 126; /* vec_andcv1tf3 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x1, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V1QImode:
              if (pattern0 (x2, 
E_V1QImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 772; /* andv1qi3 */

            case E_V2QImode:
              if (pattern0 (x2, 
E_V2QImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 773; /* andv2qi3 */

            case E_V4QImode:
              if (pattern0 (x2, 
E_V4QImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 774; /* andv4qi3 */

            case E_V8QImode:
              if (pattern0 (x2, 
E_V8QImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 775; /* andv8qi3 */

            case E_V16QImode:
              if (pattern0 (x2, 
E_V16QImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 776; /* andv16qi3 */

            case E_V1HImode:
              if (pattern0 (x2, 
E_V1HImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 777; /* andv1hi3 */

            case E_V2HImode:
              if (pattern0 (x2, 
E_V2HImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 778; /* andv2hi3 */

            case E_V4HImode:
              if (pattern0 (x2, 
E_V4HImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 779; /* andv4hi3 */

            case E_V8HImode:
              if (pattern0 (x2, 
E_V8HImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 780; /* andv8hi3 */

            case E_V1SImode:
              if (pattern0 (x2, 
E_V1SImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 781; /* andv1si3 */

            case E_V2SImode:
              if (pattern0 (x2, 
E_V2SImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 782; /* andv2si3 */

            case E_V4SImode:
              if (pattern0 (x2, 
E_V4SImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 783; /* andv4si3 */

            case E_V1DImode:
              if (pattern0 (x2, 
E_V1DImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 784; /* andv1di3 */

            case E_V2DImode:
              if (pattern0 (x2, 
E_V2DImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 785; /* andv2di3 */

            case E_V1SFmode:
              if (pattern0 (x2, 
E_V1SFmode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 786; /* andv1sf3 */

            case E_V2SFmode:
              if (pattern0 (x2, 
E_V2SFmode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 787; /* andv2sf3 */

            case E_V4SFmode:
              if (pattern0 (x2, 
E_V4SFmode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 788; /* andv4sf3 */

            case E_V1DFmode:
              if (pattern0 (x2, 
E_V1DFmode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 789; /* andv1df3 */

            case E_V2DFmode:
              if (pattern0 (x2, 
E_V2DFmode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 790; /* andv2df3 */

            case E_V1TFmode:
              if (pattern0 (x2, 
E_V1TFmode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 791; /* andv1tf3 */

            case E_V1TImode:
              if (pattern0 (x2, 
E_V1TImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 792; /* andv1ti3 */

            case E_TImode:
              if (pattern0 (x2, 
E_TImode) != 0
                  || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 793; /* andti3 */

            case E_HImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_HImode) != 0)
                return -1;
              if (
#line 8146 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2355; /* *andhi3_zarch */
                }
              if (!
#line 8163 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2356; /* *andhi3_esa */

            case E_QImode:
              if (pnum_clobbers == NULL
                  || pattern64 (x2, 
E_QImode) != 0)
                return -1;
              if (
#line 8191 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                {
                  *pnum_clobbers = 1;
                  return 2357; /* *andqi3_zarch */
                }
              if (!
#line 8208 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
                return -1;
              *pnum_clobbers = 1;
              return 2358; /* *andqi3_esa */

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          if (pnum_clobbers == NULL
              || pattern141 (x1) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (!nonimmediate_operand (operands[3], E_DImode)
              || !rtx_equal_p (x3, operands[0])
              || !
#line 4826 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[1]) + INTVAL (operands[2]) == 64))
            return -1;
          *pnum_clobbers = 1;
          return 1998; /* *insv_rnsbg_noshift */

        default:
          return -1;
        }

    case GE:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != GE)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      x8 = XEXP (x6, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XEXP (x6, 1);
      if (!rtx_equal_p (x9, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern222 (x2, 
E_V1SImode, 
E_V1SFmode) != 0
              || !
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1369; /* *vec_cmpeqv1sf_signaling_nocc */

        case E_V2SImode:
          if (pattern222 (x2, 
E_V2SImode, 
E_V2SFmode) != 0
              || !
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1370; /* *vec_cmpeqv2sf_signaling_nocc */

        case E_V4SImode:
          if (pattern222 (x2, 
E_V4SImode, 
E_V4SFmode) != 0
              || !
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1371; /* *vec_cmpeqv4sf_signaling_nocc */

        case E_V1DImode:
          if (pattern222 (x2, 
E_V1DImode, 
E_V1DFmode) != 0
              || !
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1372; /* *vec_cmpeqv1df_signaling_nocc */

        case E_V2DImode:
          if (pattern222 (x2, 
E_V2DImode, 
E_V2DFmode) != 0
              || !
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1373; /* *vec_cmpeqv2df_signaling_nocc */

        case E_V1TImode:
          if (pattern222 (x2, 
E_V1TImode, 
E_V1TFmode) != 0
              || !
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1374; /* *vec_cmpeqv1tf_signaling_nocc */

        case E_TImode:
          if (pattern222 (x2, 
E_TImode, 
E_TFmode) != 0
              || !
#line 2268 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1375; /* *vec_cmpeqtf_signaling_nocc */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1573; /* *vevalv1qi_andand */

        case 1:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1582; /* *vevalv2qi_andand */

        case 2:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1591; /* *vevalv4qi_andand */

        case 3:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1600; /* *vevalv8qi_andand */

        case 4:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1609; /* *vevalv16qi_andand */

        case 5:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1618; /* *vevalv1hi_andand */

        case 6:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1627; /* *vevalv2hi_andand */

        case 7:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1636; /* *vevalv4hi_andand */

        case 8:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1645; /* *vevalv8hi_andand */

        case 9:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1654; /* *vevalv1si_andand */

        case 10:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1663; /* *vevalv2si_andand */

        case 11:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1672; /* *vevalv4si_andand */

        case 12:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1681; /* *vevalv1di_andand */

        case 13:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1690; /* *vevalv2di_andand */

        case 14:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1699; /* *vevalv1ti_andand */

        case 15:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1708; /* *vevalti_andand */

        default:
          return -1;
        }

    case IOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1574; /* *vevalv1qi_andior */

        case 1:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1583; /* *vevalv2qi_andior */

        case 2:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1592; /* *vevalv4qi_andior */

        case 3:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1601; /* *vevalv8qi_andior */

        case 4:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1610; /* *vevalv16qi_andior */

        case 5:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1619; /* *vevalv1hi_andior */

        case 6:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1628; /* *vevalv2hi_andior */

        case 7:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1637; /* *vevalv4hi_andior */

        case 8:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1646; /* *vevalv8hi_andior */

        case 9:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1655; /* *vevalv1si_andior */

        case 10:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1664; /* *vevalv2si_andior */

        case 11:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1673; /* *vevalv4si_andior */

        case 12:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1682; /* *vevalv1di_andior */

        case 13:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1691; /* *vevalv2di_andior */

        case 14:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1700; /* *vevalv1ti_andior */

        case 15:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1709; /* *vevalti_andior */

        default:
          return -1;
        }

    case XOR:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1575; /* *vevalv1qi_andxor */

        case 1:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1584; /* *vevalv2qi_andxor */

        case 2:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1593; /* *vevalv4qi_andxor */

        case 3:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1602; /* *vevalv8qi_andxor */

        case 4:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1611; /* *vevalv16qi_andxor */

        case 5:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1620; /* *vevalv1hi_andxor */

        case 6:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1629; /* *vevalv2hi_andxor */

        case 7:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1638; /* *vevalv4hi_andxor */

        case 8:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1647; /* *vevalv8hi_andxor */

        case 9:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1656; /* *vevalv1si_andxor */

        case 10:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1665; /* *vevalv2si_andxor */

        case 11:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1674; /* *vevalv4si_andxor */

        case 12:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1683; /* *vevalv1di_andxor */

        case 13:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1692; /* *vevalv2di_andxor */

        case 14:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1701; /* *vevalv1ti_andxor */

        case 15:
          if (!
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1710; /* *vevalti_andxor */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_DImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (GET_CODE (x10) != PLUS
          || GET_MODE (x10) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x10, 1);
      operands[2] = x12;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XWINT (x7, 0))
        {
        case 1L:
          if (XWINT (x6, 0) != 8589934590L
              || !
#line 2116 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1829; /* *llxah_displacement_index */

        case 2L:
          if (XWINT (x6, 0) != 17179869180L
              || !
#line 2116 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1830; /* *llxaf_displacement_index */

        case 3L:
          if (XWINT (x6, 0) != 34359738360L
              || !
#line 2116 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1831; /* *llxag_displacement_index */

        case 4L:
          if (XWINT (x6, 0) != 68719476720L
              || !
#line 2116 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1832; /* *llxaq_displacement_index */

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || pattern141 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0])
          || !
#line 4843 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
        return -1;
      *pnum_clobbers = 1;
      return 1999; /* *insv_rnsbg_srl */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern11 (x3))
        {
        case 0:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
            return 989; /* *ashlv1qi3 */
          if (!register_operand (operands[2], E_V1QImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1045; /* vashlv1qi3 */

        case 1:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
            return 993; /* *ashlv2qi3 */
          if (!register_operand (operands[2], E_V2QImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1046; /* vashlv2qi3 */

        case 2:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
            return 997; /* *ashlv4qi3 */
          if (!register_operand (operands[2], E_V4QImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1047; /* vashlv4qi3 */

        case 3:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
            return 1001; /* *ashlv8qi3 */
          if (!register_operand (operands[2], E_V8QImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1048; /* vashlv8qi3 */

        case 4:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
            return 1005; /* *ashlv16qi3 */
          if (!register_operand (operands[2], E_V16QImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1049; /* vashlv16qi3 */

        case 5:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
            return 1009; /* *ashlv1hi3 */
          if (!register_operand (operands[2], E_V1HImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1050; /* vashlv1hi3 */

        case 6:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
            return 1013; /* *ashlv2hi3 */
          if (!register_operand (operands[2], E_V2HImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1051; /* vashlv2hi3 */

        case 7:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
            return 1017; /* *ashlv4hi3 */
          if (!register_operand (operands[2], E_V4HImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1052; /* vashlv4hi3 */

        case 8:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
            return 1021; /* *ashlv8hi3 */
          if (!register_operand (operands[2], E_V8HImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1053; /* vashlv8hi3 */

        case 9:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
            return 1025; /* *ashlv1si3 */
          if (!register_operand (operands[2], E_V1SImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1054; /* vashlv1si3 */

        case 10:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
            return 1029; /* *ashlv2si3 */
          if (!register_operand (operands[2], E_V2SImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1055; /* vashlv2si3 */

        case 11:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
            return 1033; /* *ashlv4si3 */
          if (!register_operand (operands[2], E_V4SImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1056; /* vashlv4si3 */

        case 12:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
            return 1037; /* *ashlv1di3 */
          if (!register_operand (operands[2], E_V1DImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1057; /* vashlv1di3 */

        case 13:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1516 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
            return 1041; /* *ashlv2di3 */
          if (!register_operand (operands[2], E_V2DImode)
              || !
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1058; /* vashlv2di3 */

        case 14:
          if (
#line 9686 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2504; /* *ashldi3_31 */
          if (!
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2506; /* *ashldi3 */

        case 15:
          return 2508; /* *ashlsi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x5, 0))
            {
            case 1L:
              if (!
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1812; /* *lxah_index */

            case 2L:
              if (!
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1813; /* *lxaf_index */

            case 3L:
              if (!
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1814; /* *lxag_index */

            case 4L:
              if (!
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT))
                return -1;
              return 1815; /* *lxaq_index */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          switch (XWINT (x5, 0))
            {
            case 1L:
              if (!
#line 2069 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1816; /* *lxah_displacement_index */

            case 2L:
              if (!
#line 2069 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1817; /* *lxaf_displacement_index */

            case 3L:
              if (!
#line 2069 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1818; /* *lxag_displacement_index */

            case 4L:
              if (!
#line 2069 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ARCH15 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1819; /* *lxaq_displacement_index */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !(
#line 1916 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1243; /* sqrtv4sf2 */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 1916 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1244; /* sqrtv2df2 */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode)
          || !(
#line 1916 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 1245; /* sqrtv1tf2 */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      if (register_operand (operands[1], E_TFmode)
          && (
#line 1916 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
        return 1246; /* sqrttf2_vr */
      if (!general_operand (operands[1], E_TFmode)
          || !(
#line 9545 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_VXE)))
        return -1;
      return 2495; /* sqrttf2_fpr */

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x3) != E_FPRX2mode
          || !general_operand (operands[1], E_FPRX2mode)
          || !(
#line 9545 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 755 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 2496; /* sqrtfprx22 */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !general_operand (operands[1], E_DFmode)
          || !
#line 9545 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2497; /* sqrtdf2 */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !general_operand (operands[1], E_SFmode)
          || !
#line 9545 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 2498; /* sqrtsf2 */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_CCVEQmode:
          x6 = XEXP (x4, 1);
          if (GET_MODE (x6) != E_CCVEQmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || !register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[2], E_V16QImode)
                  || !
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 413; /* *vec_cmpeqv16qi_cconly */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || !register_operand (operands[1], E_V8HImode)
                  || !scratch_operand (operands[2], E_V8HImode)
                  || !
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 416; /* *vec_cmpeqv8hi_cconly */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || !register_operand (operands[1], E_V4SImode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 419; /* *vec_cmpeqv4si_cconly */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || !register_operand (operands[1], E_V2DImode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 422; /* *vec_cmpeqv2di_cconly */

            case E_V1TImode:
              if (!register_operand (operands[0], E_V1TImode)
                  || !register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 425; /* *vec_cmpeqv1ti_cconly */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 428; /* *vec_cmpeqti_cconly */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !(
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 449; /* *vec_cmpeqv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 450; /* *vec_cmpeqv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 451; /* *vec_cmpeqv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 452; /* *vec_cmpeqtf_cconly */

            default:
              return -1;
            }

        case E_CCVIHmode:
          x6 = XEXP (x4, 1);
          switch (pattern234 (x6, 
E_CCVIHmode))
            {
            case 0:
              if (!
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 414; /* *vec_cmphv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 417; /* *vec_cmphv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 420; /* *vec_cmphv4si_cconly */

            case 3:
              if (!
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 423; /* *vec_cmphv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 426; /* *vec_cmphv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 429; /* *vec_cmphti_cconly */

            default:
              return -1;
            }

        case E_CCVIHUmode:
          x6 = XEXP (x4, 1);
          switch (pattern234 (x6, 
E_CCVIHUmode))
            {
            case 0:
              if (!
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 415; /* *vec_cmphlv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 418; /* *vec_cmphlv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 421; /* *vec_cmphlv4si_cconly */

            case 3:
              if (!
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 424; /* *vec_cmphlv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 427; /* *vec_cmphlv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 430; /* *vec_cmphlti_cconly */

            default:
              return -1;
            }

        case E_CCVFHmode:
          x6 = XEXP (x4, 1);
          switch (pattern235 (x6, 
E_CCVFHmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 453; /* *vec_cmphv4sf_cconly */

            case 1:
              if (!
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 454; /* *vec_cmphv2df_cconly */

            case 2:
              if (!(
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 455; /* *vec_cmphv1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 456; /* *vec_cmphtf_cconly */

            default:
              return -1;
            }

        case E_CCVFHEmode:
          x6 = XEXP (x4, 1);
          switch (pattern235 (x6, 
E_CCVFHEmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 457; /* *vec_cmphev4sf_cconly */

            case 1:
              if (!
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 458; /* *vec_cmphev2df_cconly */

            case 2:
              if (!(
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 459; /* *vec_cmphev1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 460; /* *vec_cmphetf_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case EQ:
          if (pattern236 (x1, 
E_CCVEQmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern273 (x7, 
E_V16QImode) != 0
                  || !
#line 2030 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 431; /* *vec_cmpeqv16qi_cc */

            case E_V8HImode:
              if (pattern273 (x7, 
E_V8HImode) != 0
                  || !
#line 2030 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 432; /* *vec_cmpeqv8hi_cc */

            case E_V4SImode:
              if (pattern273 (x7, 
E_V4SImode) != 0
                  || !
#line 2030 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 433; /* *vec_cmpeqv4si_cc */

            case E_V2DImode:
              if (pattern273 (x7, 
E_V2DImode) != 0
                  || !
#line 2030 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 434; /* *vec_cmpeqv2di_cc */

            case E_V1TImode:
              if (pattern273 (x7, 
E_V1TImode) != 0
                  || !(
#line 2030 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 435; /* *vec_cmpeqv1ti_cc */

            case E_TImode:
              if (pattern273 (x7, 
E_TImode) != 0
                  || !(
#line 2030 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 436; /* *vec_cmpeqti_cc */

            case E_V4SFmode:
              if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 461; /* *vec_cmpeqv4sf_cc */

            case E_V2DFmode:
              if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 462; /* *vec_cmpeqv2df_cc */

            case E_V1TFmode:
              if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 463; /* *vec_cmpeqv1tf_cc */

            case E_TFmode:
              if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 464; /* *vec_cmpeqtf_cc */

            default:
              return -1;
            }

        case GT:
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_CCVIHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVIHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern273 (x7, 
E_V16QImode) != 0
                      || !
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 437; /* *vec_cmphv16qi_cc */

                case E_V8HImode:
                  if (pattern273 (x7, 
E_V8HImode) != 0
                      || !
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 438; /* *vec_cmphv8hi_cc */

                case E_V4SImode:
                  if (pattern273 (x7, 
E_V4SImode) != 0
                      || !
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 439; /* *vec_cmphv4si_cc */

                case E_V2DImode:
                  if (pattern273 (x7, 
E_V2DImode) != 0
                      || !
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 440; /* *vec_cmphv2di_cc */

                case E_V1TImode:
                  if (pattern273 (x7, 
E_V1TImode) != 0
                      || !(
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 441; /* *vec_cmphv1ti_cc */

                case E_TImode:
                  if (pattern273 (x7, 
E_TImode) != 0
                      || !(
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 442; /* *vec_cmphti_cc */

                default:
                  return -1;
                }

            case E_CCVFHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVFHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !(
#line 2124 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 465; /* *vec_cmphv4sf_cc */

                case E_V2DFmode:
                  if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !
#line 2124 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 466; /* *vec_cmphv2df_cc */

                case E_V1TFmode:
                  if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                      || !(
#line 2124 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 467; /* *vec_cmphv1tf_cc */

                case E_TFmode:
                  if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                      || !(
#line 2124 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 468; /* *vec_cmphtf_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GTU:
          if (pattern236 (x1, 
E_CCVIHUmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern273 (x7, 
E_V16QImode) != 0
                  || !
#line 2050 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 443; /* *vec_cmphlv16qi_cc */

            case E_V8HImode:
              if (pattern273 (x7, 
E_V8HImode) != 0
                  || !
#line 2050 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 444; /* *vec_cmphlv8hi_cc */

            case E_V4SImode:
              if (pattern273 (x7, 
E_V4SImode) != 0
                  || !
#line 2050 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 445; /* *vec_cmphlv4si_cc */

            case E_V2DImode:
              if (pattern273 (x7, 
E_V2DImode) != 0
                  || !
#line 2050 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 446; /* *vec_cmphlv2di_cc */

            case E_V1TImode:
              if (pattern273 (x7, 
E_V1TImode) != 0
                  || !(
#line 2050 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 447; /* *vec_cmphlv1ti_cc */

            case E_TImode:
              if (pattern273 (x7, 
E_TImode) != 0
                  || !(
#line 2050 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 448; /* *vec_cmphlti_cc */

            default:
              return -1;
            }

        case GE:
          if (pattern236 (x1, 
E_CCVFHEmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2135 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 469; /* *vec_cmphev4sf_cc */

            case E_V2DFmode:
              if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2135 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 470; /* *vec_cmphev2df_cc */

            case E_V1TFmode:
              if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2135 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 471; /* *vec_cmphev1tf_cc */

            case E_TFmode:
              if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2135 "../../gcc-15.0.1-20250313/gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 472; /* *vec_cmphetf_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case USE:
      if (!memory_operand (operands[0], E_BLKmode)
          || !memory_operand (operands[1], E_BLKmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 1493 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1774; /* *clc */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (pnum_clobbers == NULL
              || pattern98 (x4) != 0)
            return -1;
          switch (pattern258 (x1))
            {
            case 0:
              if (!(
#line 3691 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1888; /* *cpymem_long */

            case 1:
              if (!(
#line 3691 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1889; /* *cpymem_long */

            case 2:
              if (!
#line 3704 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 1890; /* *cpymem_long_31z */

            default:
              return -1;
            }

        case COMPARE:
          if (GET_MODE (x9) != E_CCUmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SUBREG)
            return -1;
          x12 = XEXP (x9, 1);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != SUBREG)
            return -1;
          x14 = XEXP (x4, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 33
              || GET_MODE (x14) != E_CCUmode)
            return -1;
          x15 = XEXP (x11, 0);
          operands[2] = x15;
          x16 = XEXP (x13, 0);
          operands[3] = x16;
          x17 = XEXP (x5, 0);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x6, 0);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          switch (SUBREG_BYTE (x11))
            {
            case 0:
              if (maybe_ne (SUBREG_BYTE (x13), 0))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_TImode:
                  if (pattern296 (x9, 
E_TImode, 
E_DImode) != 0
                      || !(
#line 4144 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT)))
                    return -1;
                  return 1910; /* *cmpmem_long */

                case E_DImode:
                  if (pattern296 (x9, 
E_DImode, 
E_SImode) != 0
                      || !(
#line 4144 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                    return -1;
                  return 1911; /* *cmpmem_long */

                default:
                  return -1;
                }

            case 4:
              if (GET_MODE (x11) != E_SImode
                  || maybe_ne (SUBREG_BYTE (x13), 4)
                  || GET_MODE (x13) != E_SImode
                  || !register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !register_operand (operands[2], E_TImode)
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 4157 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1912; /* *cmpmem_long_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x19 = XEXP (x2, 1);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 0L)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != USE
              || pattern103 (x1) != 0
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x14 = XEXP (x4, 0);
          operands[2] = x14;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x5, 0);
          operands[3] = x17;
          switch (GET_MODE (operands[3]))
            {
            case E_DImode:
              if (!scratch_operand (operands[3], E_DImode)
                  || !(
#line 3842 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1900; /* *clrmem_short */

            case E_SImode:
              if (!scratch_operand (operands[3], E_SImode)
                  || !(
#line 3842 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1901; /* *clrmem_short */

            default:
              return -1;
            }

        case LABEL_REF:
          if (pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[2] = x20;
          switch (pattern272 (x1))
            {
            case 0:
              if (!
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2661; /* split_stack_calldi */

            case 1:
              if (!
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2662; /* split_stack_callsi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != LABEL_REF)
            return -1;
          x22 = XEXP (x19, 2);
          if (GET_CODE (x22) != PC
              || pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[5] = x20;
          x23 = XEXP (x21, 0);
          operands[2] = x23;
          switch (pattern272 (x1))
            {
            case 0:
              if (!
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2663; /* split_stack_cond_calldi */

            case 1:
              if (!
#line 775 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2664; /* split_stack_cond_callsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 2);
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case EQ:
      switch (pattern101 (x3))
        {
        case 0:
          if (const0_operand (operands[1], E_V1QImode)
              && all_ones_operand (operands[2], E_V1QImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_56 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1QImode)
              || !const0_operand (operands[2], E_V1QImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_75 (insn, operands);

        case 1:
          if (const0_operand (operands[1], E_V2QImode)
              && all_ones_operand (operands[2], E_V2QImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_57 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2QImode)
              || !const0_operand (operands[2], E_V2QImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_76 (insn, operands);

        case 2:
          if (const0_operand (operands[1], E_V4QImode)
              && all_ones_operand (operands[2], E_V4QImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_58 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4QImode)
              || !const0_operand (operands[2], E_V4QImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_77 (insn, operands);

        case 3:
          if (const0_operand (operands[1], E_V8QImode)
              && all_ones_operand (operands[2], E_V8QImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_59 (insn, operands);
          if (!all_ones_operand (operands[1], E_V8QImode)
              || !const0_operand (operands[2], E_V8QImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_78 (insn, operands);

        case 4:
          if (const0_operand (operands[1], E_V16QImode)
              && all_ones_operand (operands[2], E_V16QImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_60 (insn, operands);
          if (!all_ones_operand (operands[1], E_V16QImode)
              || !const0_operand (operands[2], E_V16QImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_79 (insn, operands);

        case 5:
          if (const0_operand (operands[1], E_V1HImode)
              && all_ones_operand (operands[2], E_V1HImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_61 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1HImode)
              || !const0_operand (operands[2], E_V1HImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_80 (insn, operands);

        case 6:
          if (const0_operand (operands[1], E_V2HImode)
              && all_ones_operand (operands[2], E_V2HImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_62 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2HImode)
              || !const0_operand (operands[2], E_V2HImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_81 (insn, operands);

        case 7:
          if (const0_operand (operands[1], E_V4HImode)
              && all_ones_operand (operands[2], E_V4HImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_63 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4HImode)
              || !const0_operand (operands[2], E_V4HImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_82 (insn, operands);

        case 8:
          if (const0_operand (operands[1], E_V8HImode)
              && all_ones_operand (operands[2], E_V8HImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_64 (insn, operands);
          if (!all_ones_operand (operands[1], E_V8HImode)
              || !const0_operand (operands[2], E_V8HImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_83 (insn, operands);

        case 9:
          if (const0_operand (operands[1], E_V1SImode)
              && all_ones_operand (operands[2], E_V1SImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_65 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1SImode)
              || !const0_operand (operands[2], E_V1SImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_84 (insn, operands);

        case 10:
          if (const0_operand (operands[1], E_V2SImode)
              && all_ones_operand (operands[2], E_V2SImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_66 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2SImode)
              || !const0_operand (operands[2], E_V2SImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_85 (insn, operands);

        case 11:
          if (const0_operand (operands[1], E_V4SImode)
              && all_ones_operand (operands[2], E_V4SImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_67 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4SImode)
              || !const0_operand (operands[2], E_V4SImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_86 (insn, operands);

        case 12:
          if (const0_operand (operands[1], E_V1DImode)
              && all_ones_operand (operands[2], E_V1DImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_68 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1DImode)
              || !const0_operand (operands[2], E_V1DImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_87 (insn, operands);

        case 13:
          if (const0_operand (operands[1], E_V2DImode)
              && all_ones_operand (operands[2], E_V2DImode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_69 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V2DImode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_88 (insn, operands);

        case 14:
          if (const0_operand (operands[1], E_V1SFmode)
              && all_ones_operand (operands[2], E_V1SFmode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_70 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1SFmode)
              || !const0_operand (operands[2], E_V1SFmode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_89 (insn, operands);

        case 15:
          if (const0_operand (operands[1], E_V2SFmode)
              && all_ones_operand (operands[2], E_V2SFmode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_71 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2SFmode)
              || !const0_operand (operands[2], E_V2SFmode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_90 (insn, operands);

        case 16:
          if (const0_operand (operands[1], E_V4SFmode)
              && all_ones_operand (operands[2], E_V4SFmode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_72 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4SFmode)
              || !const0_operand (operands[2], E_V4SFmode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_91 (insn, operands);

        case 17:
          if (const0_operand (operands[1], E_V1DFmode)
              && all_ones_operand (operands[2], E_V1DFmode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_73 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1DFmode)
              || !const0_operand (operands[2], E_V1DFmode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_92 (insn, operands);

        case 18:
          if (const0_operand (operands[1], E_V2DFmode)
              && all_ones_operand (operands[2], E_V2DFmode)
              && 
#line 2498 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_74 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2DFmode)
              || !const0_operand (operands[2], E_V2DFmode)
              || !
#line 2512 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_93 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      return split_2 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_7 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_6 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case VEC_SELECT:
              if (GET_MODE (x4) != E_V8HImode)
                return NULL;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != PARALLEL
                  || XVECLEN (x5, 0) != 8)
                return NULL;
              x6 = XVECEXP (x5, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return NULL;
              x7 = XVECEXP (x5, 0, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
                return NULL;
              x8 = XVECEXP (x5, 0, 2);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
                return NULL;
              x9 = XVECEXP (x5, 0, 3);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return NULL;
              x10 = XVECEXP (x5, 0, 4);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              x11 = XVECEXP (x5, 0, 5);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
                return NULL;
              x12 = XVECEXP (x5, 0, 6);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x13 = XVECEXP (x5, 0, 7);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x14 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x14) != CLOBBER
                  || pattern266 (x1) != 0
                  || !(
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1043 "../../gcc-15.0.1-20250313/gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
                return NULL;
              return gen_split_45 (insn, operands);

            case IF_THEN_ELSE:
              x15 = XEXP (x4, 0);
              if (!s390_brx_operator (x15, E_VOIDmode))
                return NULL;
              operands[6] = x15;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != PLUS)
                return NULL;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != LABEL_REF)
                return NULL;
              x17 = XEXP (x4, 2);
              if (GET_CODE (x17) != PC)
                return NULL;
              x18 = XEXP (x2, 0);
              if (GET_CODE (x18) != PC)
                return NULL;
              x14 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x14) != SET)
                return NULL;
              x19 = XEXP (x14, 1);
              if (GET_CODE (x19) != PLUS)
                return NULL;
              switch (pattern230 (x1))
                {
                case 0:
                  if (!(
#line 10026 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress) && 
#line 768 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return NULL;
                  return gen_split_385 (insn, operands);

                case 1:
                  if (!
#line 10026 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress))
                    return NULL;
                  return gen_split_386 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x20 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x20) != CLOBBER)
            return NULL;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case SUBREG:
            case MEM:
              if (pattern74 (x1) != 0)
                return NULL;
              switch (pattern196 (x1))
                {
                case 0:
                  if (!
#line 3598 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_321 (insn, operands);

                case 1:
                  if (!
#line 3610 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_322 (insn, operands);

                case 2:
                  if (!
#line 3624 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return NULL;
                  return gen_split_323 (insn, operands);

                case 3:
                  if (!
#line 3638 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_324 (insn, operands);

                default:
                  return NULL;
                }

            case COMPARE:
              if (pattern73 (x1) != 0)
                return NULL;
              switch (pattern196 (x1))
                {
                case 0:
                  if (!
#line 4048 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 1:
                  if (!
#line 4061 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_331 (insn, operands);

                case 2:
                  if (!
#line 4076 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return NULL;
                  return gen_split_332 (insn, operands);

                case 3:
                  if (!
#line 4091 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_333 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              switch (pattern78 (x1))
                {
                case 0:
                  if (!(
#line 10064 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10073 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_387 (insn, operands);

                case 1:
                  if (!(
#line 10150 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 10159 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_389 (insn, operands);

                case 2:
                  if (!(
#line 10107 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10116 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_388 (insn, operands);

                case 3:
                  if (!
#line 10215 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2]))))
                    return NULL;
                  return gen_split_390 (insn, operands);

                case 4:
                  if (!(
#line 10248 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10257 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2])))))
                    return NULL;
                  return gen_split_391 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x14 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x14) != USE)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != USE
              || pattern103 (x1) != 0)
            return NULL;
          switch (GET_CODE (operands[1]))
            {
            case CONST_INT:
              if (!const_int_operand (operands[1], E_VOIDmode))
                return NULL;
              x20 = XVECEXP (x1, 0, 3);
              x21 = XEXP (x20, 0);
              if (GET_CODE (x21) != SCRATCH)
                return NULL;
              x22 = XEXP (x3, 0);
              operands[2] = x22;
              if (!immediate_operand (operands[2], E_VOIDmode)
                  || !
#line 3854 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_326 (insn, operands);

            case REG:
            case SUBREG:
              if (!register_operand (operands[1], E_VOIDmode))
                return NULL;
              x22 = XEXP (x3, 0);
              switch (GET_CODE (x22))
                {
                case SUBREG:
                case MEM:
                  operands[2] = x22;
                  if (!memory_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x20 = XVECEXP (x1, 0, 3);
                  x21 = XEXP (x20, 0);
                  if (GET_CODE (x21) != SCRATCH
                      || !
#line 3868 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_327 (insn, operands);

                case CONST:
                  if (GET_MODE (x22) != E_BLKmode)
                    return NULL;
                  x23 = XEXP (x22, 0);
                  if (GET_CODE (x23) != UNSPEC
                      || XVECLEN (x23, 0) != 1
                      || XINT (x23, 1) != 17
                      || GET_MODE (x23) != E_BLKmode)
                    return NULL;
                  x24 = XVECEXP (x23, 0, 0);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return NULL;
                  x20 = XVECEXP (x1, 0, 3);
                  x21 = XEXP (x20, 0);
                  switch (GET_CODE (x21))
                    {
                    case SCRATCH:
                      if (!
#line 3884 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                        return NULL;
                      return gen_split_328 (insn, operands);

                    case REG:
                    case SUBREG:
                      operands[2] = x21;
                      if (!register_operand (operands[2], E_VOIDmode)
                          || !
#line 3900 "../../gcc-15.0.1-20250313/gcc/config/s390/s390.md"
(reload_completed))
                        return NULL;
                      return gen_split_329 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
