/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern2 (x3); /* [-1, 5] */
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern15 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != LSHIFTRT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_CCmode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_MODE (x6) != E_CCXmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 2
      || XINT (x4, 1) != 19)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[3] = x6;
  if (!tld_symbolic_operand (operands[3], E_VOIDmode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_QImode)
        return -1;
      return pattern61 (x3); /* [-1, 1] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          res = pattern61 (x3);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case E_HImode:
          res = pattern61 (x3);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_DImode
          || !register_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          return 6;

        case E_HImode:
          return 7;

        case E_SImode:
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern88 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CCmode
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_SImode)
      || pattern87 (x1) != 0)
    return -1;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern111 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern121 (rtx x1, rtx_code i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != LTU
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XEXP (x1, 1);
  if (GET_CODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern138 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern144 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !arith_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2
      || !cc_arith_not_operator (operands[3], i1))
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !arith_operand (operands[1], i1)
      || !register_or_zero_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || !cc_arith_not_operator (operands[4], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x3, 0);
  operands[3] = x9;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !arith5_operand (operands[2], E_SImode)
          || !
#line 1529 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CBCOND))
        return -1;
      return 107; /* *cbcond_sp32 */

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !arith5_operand (operands[2], E_DImode)
          || !
#line 1542 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_CBCOND))
        return -1;
      return 108; /* *cbcond_sp64 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && input_operand (operands[1], E_QImode)
          && 
#line 1623 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((register_operand (operands[0], QImode)
    || register_or_zero_operand (operands[1], QImode))))
        return 113; /* *movqi_insn */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && input_operand (operands[1], E_HImode)
          && 
#line 1645 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((register_operand (operands[0], HImode)
    || register_or_zero_operand (operands[1], HImode))))
        return 114; /* *movhi_insn */
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && input_operand (operands[1], E_SImode)
          && 
#line 1676 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(register_operand (operands[0], SImode)
   || register_or_zero_or_all_ones_operand (operands[1], SImode)))
        return 116; /* *movsi_insn */
      break;

    case E_DImode:
      if (nonimmediate_operand (operands[0], E_DImode)
          && input_operand (operands[1], E_DImode))
        {
          if (
#line 1835 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32
   && (register_operand (operands[0], DImode)
       || register_or_zero_operand (operands[1], DImode))))
            return 124; /* *movdi_insn_sp32 */
          if (
#line 1866 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && (register_operand (operands[0], DImode)
       || register_or_zero_or_all_ones_operand (operands[1], DImode))))
            return 125; /* *movdi_insn_sp64 */
        }
      break;

    case E_TImode:
      if (nonimmediate_operand (operands[0], E_TImode)
          && input_operand (operands[1], E_TImode))
        {
          if (
#line 2214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && !TARGET_HARD_QUAD
   && (register_operand (operands[0], TImode)
       || register_or_zero_operand (operands[1], TImode))))
            return 148; /* *movti_insn_sp64 */
          if (
#line 2225 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && TARGET_HARD_QUAD
   && (register_operand (operands[0], TImode)
       || register_or_zero_operand (operands[1], TImode))))
            return 149; /* *movti_insn_sp64_hq */
        }
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && input_operand (operands[1], E_SFmode)
          && 
#line 2370 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((register_operand (operands[0], SFmode)
    || register_or_zero_or_all_ones_operand (operands[1], SFmode))))
        return 150; /* *movsf_insn */
      break;

    case E_DFmode:
      if (nonimmediate_operand (operands[0], E_DFmode)
          && input_operand (operands[1], E_DFmode))
        {
          if (
#line 2464 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32
   && (register_operand (operands[0], DFmode)
       || register_or_zero_or_all_ones_operand (operands[1], DFmode))))
            return 153; /* *movdf_insn_sp32 */
          if (
#line 2492 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && (register_operand (operands[0], DFmode)
       || register_or_zero_or_all_ones_operand (operands[1], DFmode))))
            return 154; /* *movdf_insn_sp64 */
        }
      break;

    case E_TFmode:
      if (nonimmediate_operand (operands[0], E_TFmode)
          && input_operand (operands[1], E_TFmode))
        {
          if (
#line 2639 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32
   && (register_operand (operands[0], TFmode)
       || register_or_zero_operand (operands[1], TFmode))))
            return 155; /* *movtf_insn_sp32 */
          if (
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && !TARGET_HARD_QUAD
   && (register_operand (operands[0], TFmode)
       || register_or_zero_operand (operands[1], TFmode))))
            return 156; /* *movtf_insn_sp64 */
          if (
#line 2660 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && TARGET_HARD_QUAD
   && (register_operand (operands[0], TFmode)
       || register_or_zero_operand (operands[1], TFmode))))
            return 157; /* *movtf_insn_sp64_hq */
        }
      break;

    case E_V1SImode:
      if (nonimmediate_operand (operands[0], E_V1SImode)
          && input_operand (operands[1], E_V1SImode)
          && 
#line 8445 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (register_operand (operands[0], V1SImode)
       || register_or_zero_or_all_ones_operand (operands[1], V1SImode))))
        return 528; /* *movv1si_insn */
      break;

    case E_V2HImode:
      if (nonimmediate_operand (operands[0], E_V2HImode)
          && input_operand (operands[1], E_V2HImode)
          && 
#line 8445 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (register_operand (operands[0], V2HImode)
       || register_or_zero_or_all_ones_operand (operands[1], V2HImode))))
        return 529; /* *movv2hi_insn */
      break;

    case E_V4QImode:
      if (nonimmediate_operand (operands[0], E_V4QImode)
          && input_operand (operands[1], E_V4QImode)
          && 
#line 8445 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (register_operand (operands[0], V4QImode)
       || register_or_zero_or_all_ones_operand (operands[1], V4QImode))))
        return 530; /* *movv4qi_insn */
      break;

    case E_V1DImode:
      if (nonimmediate_operand (operands[0], E_V1DImode)
          && input_operand (operands[1], E_V1DImode))
        {
          if (
#line 8467 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH64
   && (register_operand (operands[0], V1DImode)
       || register_or_zero_or_all_ones_operand (operands[1], V1DImode))))
            return 531; /* *movv1di_insn_sp64 */
          if (
#line 8492 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH32
   && (register_operand (operands[0], V1DImode)
       || register_or_zero_or_all_ones_operand (operands[1], V1DImode))))
            return 535; /* *movv1di_insn_sp32 */
        }
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && input_operand (operands[1], E_V2SImode))
        {
          if (
#line 8467 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH64
   && (register_operand (operands[0], V2SImode)
       || register_or_zero_or_all_ones_operand (operands[1], V2SImode))))
            return 532; /* *movv2si_insn_sp64 */
          if (
#line 8492 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH32
   && (register_operand (operands[0], V2SImode)
       || register_or_zero_or_all_ones_operand (operands[1], V2SImode))))
            return 536; /* *movv2si_insn_sp32 */
        }
      break;

    case E_V4HImode:
      if (nonimmediate_operand (operands[0], E_V4HImode)
          && input_operand (operands[1], E_V4HImode))
        {
          if (
#line 8467 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH64
   && (register_operand (operands[0], V4HImode)
       || register_or_zero_or_all_ones_operand (operands[1], V4HImode))))
            return 533; /* *movv4hi_insn_sp64 */
          if (
#line 8492 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH32
   && (register_operand (operands[0], V4HImode)
       || register_or_zero_or_all_ones_operand (operands[1], V4HImode))))
            return 537; /* *movv4hi_insn_sp32 */
        }
      break;

    case E_V8QImode:
      if (nonimmediate_operand (operands[0], E_V8QImode)
          && input_operand (operands[1], E_V8QImode))
        {
          if (
#line 8467 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH64
   && (register_operand (operands[0], V8QImode)
       || register_or_zero_or_all_ones_operand (operands[1], V8QImode))))
            return 534; /* *movv8qi_insn_sp64 */
          if (
#line 8492 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && TARGET_ARCH32
   && (register_operand (operands[0], V8QImode)
       || register_or_zero_or_all_ones_operand (operands[1], V8QImode))))
            return 538; /* *movv8qi_insn_sp32 */
        }
      break;

    default:
      break;
    }
  operands[0] = x2;
  res = recog_10 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[0] = x3;
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (pnum_clobbers == NULL
          || maybe_ne (SUBREG_BYTE (x2), 4)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != LSHIFTRT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != SIGN_EXTEND
          || GET_MODE (x7) != E_DImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[3] = x10;
      if (!small_int_operand (operands[3], E_SImode)
          || !
#line 4795 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
        return -1;
      *pnum_clobbers = 1;
      return 271; /* *sparc.md:4787 */

    case MEM:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != PLUS)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 19)
        return -1;
      x11 = XVECEXP (x5, 0, 0);
      operands[2] = x11;
      x12 = XVECEXP (x5, 0, 1);
      operands[3] = x12;
      if (!tld_symbolic_operand (operands[3], E_VOIDmode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[1] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          switch (pattern133 (x2, 
E_QImode))
            {
            case 0:
              if (!(
#line 8091 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 492; /* *tldo_ldubsi */

            case 1:
              if (!(
#line 8091 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 493; /* *tldo_ldubdi */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern133 (x2, 
E_HImode))
            {
            case 0:
              if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 504; /* *tldo_lduhsi */

            case 1:
              if (!(
#line 8178 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 505; /* *tldo_lduhdi */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern133 (x2, 
E_SImode))
            {
            case 0:
              if (!(
#line 8240 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 512; /* *tldo_lduwsi */

            case 1:
              if (!(
#line 8240 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 513; /* *tldo_lduwdi */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[2], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 8275 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 516; /* *tldo_ldx_sp64 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x2) != 102
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return -1;
      if (
#line 8831 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH64))
        return 645; /* *rdgsr_sp64 */
      if (pnum_clobbers == NULL
          || !
#line 8839 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH32))
        return -1;
      *pnum_clobbers = 1;
      return 646; /* rdgsr_v8plus */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x3) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !small_int_operand (operands[2], E_HImode))
                return -1;
              return 115; /* *movhi_lo_sum */

            case E_DImode:
              if (pattern28 (x3, 
E_DImode) != 0
                  || !
#line 5424 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 306; /* iordi3 */

            case E_SImode:
              if (pattern28 (x3, 
E_SImode) != 0)
                return -1;
              return 307; /* iorsi3 */

            case E_V1SImode:
              if (pattern10 (x3, 
E_V1SImode) != 0
                  || !
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 547; /* iorv1si3 */

            case E_V2HImode:
              if (pattern10 (x3, 
E_V2HImode) != 0
                  || !
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 550; /* iorv2hi3 */

            case E_V4QImode:
              if (pattern10 (x3, 
E_V4QImode) != 0
                  || !
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 553; /* iorv4qi3 */

            case E_V1DImode:
              if (pattern10 (x3, 
E_V1DImode) != 0
                  || !
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 556; /* iorv1di3 */

            case E_V2SImode:
              if (pattern10 (x3, 
E_V2SImode) != 0
                  || !
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 559; /* iorv2si3 */

            case E_V4HImode:
              if (pattern10 (x3, 
E_V4HImode) != 0
                  || !
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 562; /* iorv4hi3 */

            case E_V8QImode:
              if (pattern10 (x3, 
E_V8QImode) != 0
                  || !
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 565; /* iorv8qi3 */

            default:
              return -1;
            }

        case NOT:
          switch (pattern54 (x3))
            {
            case 0:
              if (!
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 610; /* *ior_not2v1si_vis */

            case 1:
              if (!
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 612; /* *ior_not2v2hi_vis */

            case 2:
              if (!
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 614; /* *ior_not2v4qi_vis */

            case 3:
              if (!
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 616; /* *ior_not2v1di_vis */

            case 4:
              if (!
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 618; /* *ior_not2v2si_vis */

            case 5:
              if (!
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 620; /* *ior_not2v4hi_vis */

            case 6:
              if (!
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 622; /* *ior_not2v8qi_vis */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern56 (x3))
            {
            case 0:
              if (!
#line 5450 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 308; /* *or_not_di_sp64 */

            case 1:
              return 309; /* *or_not_si */

            case 2:
              if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 596; /* *ior_not1v1si_vis */

            case 3:
              if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 598; /* *ior_not1v2hi_vis */

            case 4:
              if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 600; /* *ior_not1v4qi_vis */

            case 5:
              if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 602; /* *ior_not1v1di_vis */

            case 6:
              if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 604; /* *ior_not1v2si_vis */

            case 7:
              if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 606; /* *ior_not1v4hi_vis */

            case 8:
              if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 608; /* *ior_not1v8qi_vis */

            default:
              return -1;
            }

        case NOT:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V1SImode:
              if (pattern77 (x3, 
E_V1SImode) != 0
                  || !
#line 8624 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 589; /* *nandv1si_vis */

            case E_V2HImode:
              if (pattern77 (x3, 
E_V2HImode) != 0
                  || !
#line 8624 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 590; /* *nandv2hi_vis */

            case E_V4QImode:
              if (pattern77 (x3, 
E_V4QImode) != 0
                  || !
#line 8624 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 591; /* *nandv4qi_vis */

            case E_V1DImode:
              if (pattern77 (x3, 
E_V1DImode) != 0
                  || !
#line 8624 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 592; /* *nandv1di_vis */

            case E_V2SImode:
              if (pattern77 (x3, 
E_V2SImode) != 0
                  || !
#line 8624 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 593; /* *nandv2si_vis */

            case E_V4HImode:
              if (pattern77 (x3, 
E_V4HImode) != 0
                  || !
#line 8624 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 594; /* *nandv4hi_vis */

            case E_V8QImode:
              if (pattern77 (x3, 
E_V8QImode) != 0
                  || !
#line 8624 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 595; /* *nandv8qi_vis */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_SImode))
    {
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != COMPARE)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  operands[1] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern136 (x2, 
E_CCmode, 
E_SImode) != 0)
        return -1;
      return 349; /* *cmp_cc_set */

    case E_DImode:
      if (pattern136 (x2, 
E_CCXmode, 
E_DImode) != 0
          || !
#line 6008 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 350; /* *cmp_ccx_set64 */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_44 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return recog_43 (x1, insn, pnum_clobbers);

        case 3:
          x2 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x2) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x3))
            {
            case SET:
              x4 = XEXP (x2, 0);
              if (!scratch_operand (x4, E_SImode))
                return -1;
              x5 = XEXP (x3, 1);
              switch (GET_CODE (x5))
                {
                case MULT:
                  if (GET_MODE (x5) != E_DImode)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x6) != CLOBBER)
                    return -1;
                  x7 = XEXP (x3, 0);
                  operands[0] = x7;
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  x8 = XEXP (x5, 0);
                  operands[1] = x8;
                  if (!arith_operand (operands[1], E_DImode))
                    return -1;
                  x9 = XEXP (x5, 1);
                  operands[2] = x9;
                  if (!arith_operand (operands[2], E_DImode))
                    return -1;
                  x10 = XEXP (x6, 0);
                  operands[3] = x10;
                  if (!scratch_operand (operands[3], E_SImode))
                    return -1;
                  operands[4] = x4;
                  if (!
#line 4619 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                    return -1;
                  return 262; /* muldi3_v8plus */

                case TRUNCATE:
                  if (pattern52 (x1, 
E_TImode) != 0)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  x10 = XEXP (x6, 0);
                  operands[3] = x10;
                  if (!scratch_operand (operands[3], E_SImode))
                    return -1;
                  operands[4] = x4;
                  x8 = XEXP (x5, 0);
                  switch (GET_CODE (x8))
                    {
                    case LSHIFTRT:
                      x11 = XEXP (x8, 1);
                      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
                        return -1;
                      x12 = XEXP (x8, 0);
                      if (GET_MODE (x12) != E_TImode)
                        return -1;
                      switch (GET_CODE (x12))
                        {
                        case MULT:
                          if (pattern135 (x12, 
E_TImode, 
ZERO_EXTEND) != 0)
                            return -1;
                          x13 = XEXP (x12, 0);
                          x14 = XEXP (x13, 0);
                          operands[1] = x14;
                          if (!arith_operand (operands[1], E_DImode))
                            return -1;
                          x15 = XEXP (x12, 1);
                          x16 = XEXP (x15, 0);
                          operands[2] = x16;
                          if (!arith_operand (operands[2], E_DImode)
                              || !
#line 5064 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
                            return -1;
                          return 286; /* umulxhi_v8plus */

                        case UNSPEC:
                          if (XVECLEN (x12, 0) != 2
                              || XINT (x12, 1) != 58)
                            return -1;
                          x17 = XVECEXP (x12, 0, 0);
                          if (GET_CODE (x17) != ZERO_EXTEND
                              || GET_MODE (x17) != E_TImode)
                            return -1;
                          x18 = XVECEXP (x12, 0, 1);
                          if (GET_CODE (x18) != ZERO_EXTEND
                              || GET_MODE (x18) != E_TImode)
                            return -1;
                          x19 = XEXP (x17, 0);
                          operands[1] = x19;
                          if (!arith_operand (operands[1], E_DImode))
                            return -1;
                          x20 = XEXP (x18, 0);
                          operands[2] = x20;
                          if (!arith_operand (operands[2], E_DImode)
                              || !
#line 5150 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
                            return -1;
                          return 290; /* xmulxhi_v8plus */

                        default:
                          return -1;
                        }

                    case UNSPEC:
                      if (XVECLEN (x8, 0) != 2
                          || XINT (x8, 1) != 58)
                        return -1;
                      x21 = XVECEXP (x8, 0, 0);
                      if (GET_CODE (x21) != ZERO_EXTEND
                          || GET_MODE (x21) != E_TImode)
                        return -1;
                      x22 = XVECEXP (x8, 0, 1);
                      if (GET_CODE (x22) != ZERO_EXTEND
                          || GET_MODE (x22) != E_TImode)
                        return -1;
                      x23 = XEXP (x21, 0);
                      operands[1] = x23;
                      if (!arith_operand (operands[1], E_DImode))
                        return -1;
                      x24 = XEXP (x22, 0);
                      operands[2] = x24;
                      if (!arith_operand (operands[2], E_DImode)
                          || !
#line 5104 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
                        return -1;
                      return 288; /* xmulx_v8plus */

                    default:
                      return -1;
                    }

                case COMPARE:
                  if (GET_MODE (x5) != E_CCmode)
                    return -1;
                  x8 = XEXP (x5, 0);
                  if (GET_CODE (x8) != DIV
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x9 = XEXP (x5, 1);
                  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                      || pattern72 (x1, 
SET, 
E_CCmode, 
100) != 0)
                    return -1;
                  x6 = XVECEXP (x1, 0, 1);
                  x25 = XEXP (x6, 1);
                  if (GET_CODE (x25) != DIV
                      || GET_MODE (x25) != E_SImode)
                    return -1;
                  x12 = XEXP (x8, 0);
                  operands[1] = x12;
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x11 = XEXP (x8, 1);
                  operands[2] = x11;
                  if (!arith_operand (operands[2], E_SImode))
                    return -1;
                  x10 = XEXP (x6, 0);
                  operands[0] = x10;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  operands[3] = x4;
                  x26 = XEXP (x25, 0);
                  if (!rtx_equal_p (x26, operands[1]))
                    return -1;
                  x27 = XEXP (x25, 1);
                  if (!rtx_equal_p (x27, operands[2])
                      || !
#line 5240 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_DEPRECATED_V8_INSNS))
                    return -1;
                  return 294; /* *cmp_sdiv_cc_set */

                case UNSPEC:
                  if (XVECLEN (x5, 0) != 2
                      || XINT (x5, 1) != 43
                      || pattern71 (x1) != 0)
                    return -1;
                  operands[2] = x4;
                  if (!
#line 8400 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                    return -1;
                  return 526; /* stack_protect_test32 */

                default:
                  return -1;
                }

            case CALL:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != MEM
                  || GET_MODE (x7) != E_SImode)
                return -1;
              x4 = XEXP (x2, 0);
              if (GET_CODE (x4) != REG
                  || REGNO (x4) != 15
                  || GET_MODE (x4) != E_SImode)
                return -1;
              x28 = XEXP (x7, 0);
              operands[0] = x28;
              x5 = XEXP (x3, 1);
              operands[1] = x5;
              x6 = XVECEXP (x1, 0, 1);
              operands[2] = x6;
              if (!immediate_operand (operands[2], E_VOIDmode))
                return -1;
              if (address_operand (operands[0], E_SImode)
                  && 
#line 6970 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) > 0))
                return 417; /* *call_address_struct_value_sp32 */
              if (symbolic_operand (operands[0], E_SImode)
                  && 
#line 6986 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) > 0))
                return 418; /* *call_symbolic_struct_value_sp32 */
              if (address_operand (operands[0], E_SImode)
                  && 
#line 7002 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) < 0))
                return 419; /* *call_address_untyped_struct_value_sp32 */
              if (!symbolic_operand (operands[0], E_SImode)
                  || !
#line 7015 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) < 0))
                return -1;
              return 420; /* *call_symbolic_untyped_struct_value_sp32 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x29 = XEXP (x1, 0);
      if (GET_CODE (x29) != MEM)
        return -1;
      x30 = XEXP (x29, 0);
      operands[0] = x30;
      x31 = XEXP (x1, 1);
      operands[1] = x31;
      switch (GET_MODE (x29))
        {
        case E_SImode:
          if (address_operand (operands[0], E_SImode)
              && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            {
              *pnum_clobbers = 1;
              return 413; /* *call_addresssi */
            }
          if (!symbolic_operand (operands[0], E_SImode)
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 1;
          return 415; /* *call_symbolicsi */

        case E_DImode:
          if (address_operand (operands[0], E_DImode)
              && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            {
              *pnum_clobbers = 1;
              return 414; /* *call_addressdi */
            }
          if (!symbolic_operand (operands[0], E_DImode)
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          *pnum_clobbers = 1;
          return 416; /* *call_symbolicdi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x1, 0) != 1)
        return -1;
      switch (XINT (x1, 1))
        {
        case 4:
          x3 = XVECEXP (x1, 0, 0);
          operands[0] = x3;
          if (!arith_operand (operands[0], E_VOIDmode)
              || !
#line 7155 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(!TARGET_FLAT))
            return -1;
          return 429; /* window_save */

        case 0:
          x3 = XVECEXP (x1, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 432; /* blockage */

        case 1:
          x3 = XVECEXP (x1, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 7270 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9))
            return -1;
          return 435; /* speculation_barrier */

        case 3:
          x3 = XVECEXP (x1, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 442; /* flush_register_windows */

        case 5:
          x3 = XVECEXP (x1, 0, 0);
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!memory_operand (operands[0], E_SImode)
                  || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                return -1;
              return 443; /* flushsi */

            case E_DImode:
              if (!memory_operand (operands[0], E_DImode)
                  || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 444; /* flushdi */

            default:
              return -1;
            }

        case 9:
          x3 = XVECEXP (x1, 0, 0);
          operands[0] = x3;
          if (!memory_operand (operands[0], E_SImode)
              || !
#line 7472 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 445; /* ldfsr */

        default:
          return -1;
        }

    case EH_RETURN:
      return 430; /* eh_return_internal */

    case RETURN:
      return 431; /* *return_internal */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 2
          || XINT (x1, 1) != 1
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 7347 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
        return -1;
      return 438; /* update_return */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 439; /* nop */

    case PREFETCH:
      x29 = XEXP (x1, 0);
      operands[0] = x29;
      x31 = XEXP (x1, 1);
      operands[1] = x31;
      if (const_int_operand (operands[1], E_DImode)
          && address_operand (operands[0], E_DImode))
        {
          x32 = XEXP (x1, 2);
          operands[2] = x32;
          if (const_int_operand (operands[2], E_DImode))
            return 455; /* prefetch_64 */
        }
      if (!const_int_operand (operands[1], E_SImode)
          || !address_operand (operands[0], E_SImode))
        return -1;
      x32 = XEXP (x1, 2);
      operands[2] = x32;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 456; /* prefetch_32 */

    case TRAP_IF:
      x29 = XEXP (x1, 0);
      switch (GET_CODE (x29))
        {
        case CONST_INT:
          if (XWINT (x29, 0) != 1L)
            return -1;
          x31 = XEXP (x1, 1);
          if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          return 457; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[0] = x29;
          if (!icc_comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != REG
              || REGNO (x30) != 100)
            return -1;
          x33 = XEXP (x29, 1);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x31 = XEXP (x1, 1);
          operands[1] = x31;
          if (!arith_operand (operands[1], E_SImode))
            return -1;
          switch (GET_MODE (x30))
            {
            case E_CCmode:
              return 458; /* *trapsi_insn */

            case E_CCXmode:
              if (!
#line 7920 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9))
                return -1;
              return 459; /* *trapdi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
