/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode)
          || !register_operand (operands[2], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode)
          || !register_operand (operands[2], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!icc_register_operand (operands[1], E_VOIDmode))
    return -1;
  return pattern17 (x1); /* [-1, 1] */
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern22 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern22 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_CCmode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_CCXmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return pattern17 (x1); /* [-1, 1] */
}

int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!icc_register_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern58 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern58 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode))
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  if (!symbolic_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern74 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XEXP (x1, 0);
  switch (GET_MODE (x6))
    {
    case E_CCVmode:
      return 0;

    case E_CCXVmode:
      return 1;

    default:
      return -1;
    }
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !arith_add_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (pattern10 (x1, 
E_TFmode) != 0)
        return -1;
      return 2;

    case E_DFmode:
      if (pattern10 (x1, 
E_DFmode) != 0)
        return -1;
      return 3;

    case E_SFmode:
      if (pattern10 (x1, 
E_SFmode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (pattern10 (x1, 
E_V1SImode) != 0)
        return -1;
      return 5;

    case E_V2SImode:
      if (pattern10 (x1, 
E_V2SImode) != 0)
        return -1;
      return 6;

    case E_V2HImode:
      if (pattern10 (x1, 
E_V2HImode) != 0)
        return -1;
      return 7;

    case E_V4HImode:
      if (pattern10 (x1, 
E_V4HImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (pattern10 (x1, 
E_V1DImode) != 0)
        return -1;
      return 9;

    case E_V8QImode:
      if (pattern10 (x1, 
E_V8QImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern117 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern124 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || !arith_add_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern133 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !arith_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_SImode
      || pattern159 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_CCFPEmode:
      switch (pattern73 (x3, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 695 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 5; /* *cmpsf_fpe */

        case 1:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 6; /* *cmpdf_fpe */

        case 2:
          if (!
#line 720 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 7; /* *cmptf_fpe */

        default:
          return -1;
        }

    case E_CCFPmode:
      switch (pattern73 (x3, 
E_CCFPmode))
        {
        case 0:
          if (!
#line 732 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 8; /* *cmpsf_fp */

        case 1:
          if (!
#line 744 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 9; /* *cmpdf_fp */

        case 2:
          if (!
#line 757 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 10; /* *cmptf_fp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !immediate_operand (operands[1], E_SImode)
              || !
#line 1704 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(!flag_pic))
            return -1;
          return 118; /* *movsi_high */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          if (medium_pic_operand (operands[1], E_DImode)
              && 
#line 1976 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((TARGET_CM_MEDLOW || TARGET_CM_EMBMEDANY) && flag_pic && check_pic (1)))
            return 131; /* *sethi_di_medlow_embmedany_pic */
          if (!symbolic_operand (operands[1], E_DImode)
              || !
#line 1982 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_MEDLOW && !flag_pic))
            return -1;
          return 132; /* *sethi_di_medlow */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !fp_const_high_losum_operand (operands[1], E_SFmode))
            return -1;
          return 152; /* *movsf_high */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          switch (XINT (x4, 1))
            {
            case 0:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!
#line 1726 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(flag_pic && check_pic (1)))
                    return -1;
                  return 120; /* movsi_high_pic */

                case 1:
                  if (!
#line 1947 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && flag_pic && check_pic (1)))
                    return -1;
                  return 129; /* movdi_high_pic */

                default:
                  return -1;
                }

            case 5:
              if (pattern69 (x3) != 0
                  || !
#line 1996 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_MEDMID && !flag_pic))
                return -1;
              return 134; /* seth44 */

            case 7:
              if (pattern69 (x3) != 0
                  || !
#line 2018 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_MEDANY && !flag_pic))
                return -1;
              return 137; /* sethh */

            case 8:
              if (pattern69 (x3) != 0
                  || !
#line 2025 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_MEDANY && !flag_pic))
                return -1;
              return 138; /* setlm */

            case 9:
              if (GET_MODE (x4) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return -1;
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!data_segment_operand (operands[1], E_DImode)
                  || !
#line 2047 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 141; /* embmedany_sethi */

            case 10:
              if (pattern70 (x3) != 0
                  || !
#line 2068 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 144; /* embmedany_textuhi */

            case 11:
              if (pattern70 (x3) != 0
                  || !
#line 2075 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 145; /* embmedany_texthi */

            case 17:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tgd_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!(
#line 7931 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 460; /* tgd_hi22si */

                case 1:
                  if (!(
#line 7931 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 461; /* tgd_hi22di */

                default:
                  return -1;
                }

            case 18:
              x5 = XVECEXP (x4, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!(
#line 7967 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 468; /* tldm_hi22si */

                case 1:
                  if (!(
#line 7967 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 469; /* tldm_hi22di */

                default:
                  return -1;
                }

            case 19:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tld_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!(
#line 8001 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 476; /* tldo_hix22si */

                case 1:
                  if (!(
#line 8001 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 477; /* tldo_hix22di */

                default:
                  return -1;
                }

            case 20:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tie_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!(
#line 8025 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 482; /* tie_hi22si */

                case 1:
                  if (!(
#line 8025 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 483; /* tie_hi22di */

                default:
                  return -1;
                }

            case 21:
              x5 = XVECEXP (x4, 0, 0);
              operands[1] = x5;
              if (!tle_symbolic_operand (operands[1], E_VOIDmode))
                return -1;
              switch (pattern17 (x3))
                {
                case 0:
                  if (!(
#line 8073 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 488; /* tle_hix22si */

                case 1:
                  if (!(
#line 8073 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 489; /* tle_hix22di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          if (XINT (x4, 1) != 4)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          x6 = XVECEXP (x4, 0, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern98 (x3, 
E_SImode) != 0
                  || !
#line 1782 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(flag_pic))
                return -1;
              return 122; /* *movsi_high_pic_label_ref */

            case E_DImode:
              if (pattern98 (x3, 
E_DImode) != 0
                  || !
#line 1916 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && flag_pic))
                return -1;
              return 126; /* *movdi_high_pic_label_ref */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern67 (x3, 
E_DImode) != 0
              || !
#line 5502 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 312; /* *xor_not_di_sp64 */

        case E_SImode:
          if (pattern67 (x3, 
E_SImode) != 0)
            return -1;
          return 313; /* *xor_not_si */

        case E_V1SImode:
          if (pattern30 (x3, 
E_V1SImode) != 0
              || !
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 570; /* *not_xorv1si3 */

        case E_V2HImode:
          if (pattern30 (x3, 
E_V2HImode) != 0
              || !
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 573; /* *not_xorv2hi3 */

        case E_V4QImode:
          if (pattern30 (x3, 
E_V4QImode) != 0
              || !
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 576; /* *not_xorv4qi3 */

        case E_V1DImode:
          if (pattern30 (x3, 
E_V1DImode) != 0
              || !
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 579; /* *not_xorv1di3 */

        case E_V2SImode:
          if (pattern30 (x3, 
E_V2SImode) != 0
              || !
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 582; /* *not_xorv2si3 */

        case E_V4HImode:
          if (pattern30 (x3, 
E_V4HImode) != 0
              || !
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 585; /* *not_xorv4hi3 */

        case E_V8QImode:
          if (pattern30 (x3, 
E_V8QImode) != 0
              || !
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 588; /* *not_xorv8qi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !arith_operand (operands[1], E_DImode)
              || !
#line 5949 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 343; /* one_cmpldi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !arith_operand (operands[1], E_SImode))
            return -1;
          return 344; /* one_cmplsi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 8652 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 624; /* one_cmplv1si2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 8652 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 625; /* one_cmplv2hi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 8652 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 626; /* one_cmplv4qi2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 8652 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 627; /* one_cmplv1di2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 8652 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 628; /* one_cmplv2si2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 8652 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 629; /* one_cmplv4hi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 8652 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 630; /* one_cmplv8qi2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern31 (x3))
        {
        case 0:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 568; /* *not_iorv1si3 */

        case 1:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 571; /* *not_iorv2hi3 */

        case 2:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 574; /* *not_iorv4qi3 */

        case 3:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 577; /* *not_iorv1di3 */

        case 4:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 580; /* *not_iorv2si3 */

        case 5:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 583; /* *not_iorv4hi3 */

        case 6:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 586; /* *not_iorv8qi3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern31 (x3))
        {
        case 0:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 569; /* *not_andv1si3 */

        case 1:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 572; /* *not_andv2hi3 */

        case 2:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 575; /* *not_andv4qi3 */

        case 3:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 578; /* *not_andv1di3 */

        case 4:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 581; /* *not_andv2si3 */

        case 5:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 584; /* *not_andv4hi3 */

        case 6:
          if (!
#line 8614 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 587; /* *not_andv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pnum_clobbers == NULL
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !input_operand (operands[2], E_SImode)
          || !
#line 5183 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((TARGET_V8 || TARGET_DEPRECATED_V8_INSNS) && TARGET_ARCH32))
        return -1;
      *pnum_clobbers = 1;
      return 291; /* divsi3_sp32 */

    case E_DImode:
      if (pattern32 (x3, 
E_DImode) != 0
          || !
#line 5228 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 293; /* divdi3 */

    case E_TFmode:
      if (pattern10 (x3, 
E_TFmode) != 0
          || !
#line 6212 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
        return -1;
      return 370; /* *divtf3_hq */

    case E_DFmode:
      if (pattern10 (x3, 
E_DFmode) != 0)
        return -1;
      if (
#line 6227 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
        return 371; /* *divdf3_nofix */
      if (!
#line 6236 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && sparc_fix_ut699))
        return -1;
      return 372; /* *divdf3_fix */

    case E_SFmode:
      if (pattern10 (x3, 
E_SFmode) != 0
          || !
#line 6246 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
        return -1;
      return 373; /* divsf3 */

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != 255L)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != ZERO_EXTEND)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != SUBREG
      || maybe_ne (SUBREG_BYTE (x8), 0)
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x2, 0);
  switch (GET_MODE (x11))
    {
    case E_CCmode:
      if (pattern143 (x1, 
E_SImode, 
E_CCmode) != 0)
        return -1;
      return 184; /* *cmp_zero_extendqisi2_andcc_set */

    case E_CCXmode:
      if (pattern143 (x1, 
E_DImode, 
E_CCXmode) != 0
          || !
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 188; /* *cmp_zero_extendqidi2_andcc_set */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pattern52 (x1, 
E_DImode) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 4670 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 264; /* mulsidi3_v8plus */

        case CONST_INT:
          operands[2] = x8;
          if (!small_int_operand (operands[2], E_DImode)
              || !
#line 4682 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 265; /* const_mulsidi3_v8plus */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 4872 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 275; /* umulsidi3_v8plus */

        case CONST_INT:
          operands[2] = x8;
          if (!uns_small_int_operand (operands[2], E_DImode)
              || !
#line 4936 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 280; /* const_umulsidi3_v8plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case NEG:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NE:
          switch (pattern48 (x3))
            {
            case 0:
              if (!(
#line 864 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_SUBXC) && 
#line 866 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                return NULL;
              return gen_split_9 (insn, operands);

            case 1:
              if (!((
#line 864 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 866 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                return NULL;
              return gen_split_10 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          switch (pattern48 (x3))
            {
            case 0:
              if (!(
#line 931 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64) && 
#line 933 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                return NULL;
              return gen_split_19 (insn, operands);

            case 1:
              if (!(
#line 931 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64) && 
#line 933 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                return NULL;
              return gen_split_20 (insn, operands);

            default:
              return NULL;
            }

        case REG:
        case SUBREG:
          switch (pattern14 (x3))
            {
            case 0:
              if (!(
#line 6266 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 6268 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_83 (insn, operands);

            case 1:
              if (!(
#line 6307 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9) && 
#line 6309 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_84 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (register_operand (operands[1], E_DImode))
        {
          switch (GET_CODE (x3))
            {
            case NE:
              switch (pattern4 (x3))
                {
                case 0:
                  if ((
#line 837 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_VIS3) && 
#line 839 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                    return gen_split_5 (insn, operands);
                  break;

                case 1:
                  if (((
#line 837 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 839 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                    return gen_split_6 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            case EQ:
              switch (pattern4 (x3))
                {
                case 0:
                  if ((
#line 917 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64) && 
#line 919 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                    return gen_split_17 (insn, operands);
                  break;

                case 1:
                  if ((
#line 917 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64) && 
#line 919 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( !reg_overlap_mentioned_p (operands[1], operands[0]))))
                    return gen_split_18 (insn, operands);
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      operands[1] = x3;
      operands[2] = x4;
      if (!icc_register_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !icc_comparison_operator (operands[1], E_SImode)
              || !
#line 1350 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9
   /* 64-bit LTU is better implemented using addxc with VIS3.  */
   && !(GET_CODE (operands[1]) == LTU
	&& (GET_MODE (operands[2]) == CCXmode
	    || GET_MODE (operands[2]) == CCXCmode)
	&& TARGET_VIS3)
   /* 32-bit LTU/GEU are better implemented using addx/subx.  */
   && !((GET_CODE (operands[1]) == LTU || GET_CODE (operands[1]) == GEU)
	&& (GET_MODE (operands[2]) == CCmode
	    || GET_MODE (operands[2]) == CCCmode))))
            return NULL;
          return gen_split_41 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !icc_comparison_operator (operands[1], E_DImode)
              || !(
#line 1350 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9
   /* 64-bit LTU is better implemented using addxc with VIS3.  */
   && !(GET_CODE (operands[1]) == LTU
	&& (GET_MODE (operands[2]) == CCXmode
	    || GET_MODE (operands[2]) == CCXCmode)
	&& TARGET_VIS3)
   /* 32-bit LTU/GEU are better implemented using addx/subx.  */
   && !((GET_CODE (operands[1]) == LTU || GET_CODE (operands[1]) == GEU)
	&& (GET_MODE (operands[2]) == CCmode
	    || GET_MODE (operands[2]) == CCCmode))) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return NULL;
          return gen_split_42 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && const_int_operand (operands[1], E_DImode)
              && 
#line 2118 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && ((GET_CODE (operands[0]) == REG
        && SPARC_INT_REG_P (REGNO (operands[0])))
       || (GET_CODE (operands[0]) == SUBREG
           && GET_CODE (SUBREG_REG (operands[0])) == REG
           && SPARC_INT_REG_P (REGNO (SUBREG_REG (operands[0])))))))
            return gen_split_43 (insn, operands);
          if (!memory_operand (operands[0], E_DImode)
              || !const_zero_operand (operands[1], E_DImode)
              || !
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
	   && !mem_min_alignment (operands[0], 8)))
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_47 (insn, operands);

        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || !const_zero_operand (operands[1], E_TImode)
              || !
#line 2278 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed))
            return NULL;
          return gen_split_49 (insn, operands);

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !fp_const_high_losum_operand (operands[1], E_SFmode)
              || !
#line 2446 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(REG_P (operands[0]) && SPARC_INT_REG_P (REGNO (operands[0]))))
            return NULL;
          return gen_split_52 (insn, operands);

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode))
            {
              if (const_double_operand (operands[1], E_DFmode)
                  && 
#line 2517 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && REG_P (operands[0])
   && SPARC_INT_REG_P (REGNO (operands[0]))
   && !const_zero_operand (operands[1], GET_MODE (operands[0]))))
                return gen_split_53 (insn, operands);
              if (const_zero_operand (operands[1], E_DFmode)
                  && 
#line 2561 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && ((GET_CODE (operands[0]) == REG
	&& SPARC_INT_REG_P (REGNO (operands[0])))
       || (GET_CODE (operands[0]) == SUBREG
	   && GET_CODE (SUBREG_REG (operands[0])) == REG
	   && SPARC_INT_REG_P (REGNO (SUBREG_REG (operands[0])))))))
                return gen_split_54 (insn, operands);
            }
          if (!memory_operand (operands[0], E_DFmode)
              || !const_zero_operand (operands[1], E_DFmode)
              || !
#line 2615 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
	   && !mem_min_alignment (operands[0], 8)))
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_58 (insn, operands);

        case E_TFmode:
          if (!nonimmediate_operand (operands[0], E_TFmode)
              || !const_zero_operand (operands[1], E_TFmode)
              || !
#line 2714 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed))
            return NULL;
          return gen_split_60 (insn, operands);

        case E_V1DImode:
          if (!memory_operand (operands[0], E_V1DImode)
              || !const_zero_operand (operands[1], E_V1DImode)
              || !
#line 8558 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_100 (insn, operands);

        case E_V2SImode:
          if (!memory_operand (operands[0], E_V2SImode)
              || !const_zero_operand (operands[1], E_V2SImode)
              || !
#line 8558 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_101 (insn, operands);

        case E_V4HImode:
          if (!memory_operand (operands[0], E_V4HImode)
              || !const_zero_operand (operands[1], E_V4HImode)
              || !
#line 8558 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_102 (insn, operands);

        case E_V8QImode:
          if (!memory_operand (operands[0], E_V8QImode)
              || !const_zero_operand (operands[1], E_V8QImode)
              || !
#line 8558 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && !mem_min_alignment (operands[0], 8)
   && offsettable_memref_p (operands[0])))
            return NULL;
          return gen_split_103 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (register_operand (operands[0], E_DImode))
            {
              if (register_operand (operands[1], E_DImode)
                  && 
#line 2146 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
           && sparc_split_reg_reg_legitimate (operands[0], operands[1])))))
                return gen_split_44 (insn, operands);
              if (memory_operand (operands[1], E_DImode)
                  && 
#line 2161 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_45 (insn, operands);
            }
          if (!memory_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 2173 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_46 (insn, operands);

        case E_TImode:
          if (register_operand (operands[0], E_TImode))
            {
              if (register_operand (operands[1], E_TImode)
                  && 
#line 2243 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && ((TARGET_FPU
        && !TARGET_HARD_QUAD)
       || (!fp_register_operand (operands[0], TImode)
           && !fp_register_operand (operands[1], TImode)))))
                return gen_split_48 (insn, operands);
              if (memory_operand (operands[1], E_TImode)
                  && 
#line 2306 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && offsettable_memref_p (operands[1])
   && (!TARGET_HARD_QUAD
       || !fp_register_operand (operands[0], TImode))))
                return gen_split_50 (insn, operands);
            }
          if (!memory_operand (operands[0], E_TImode)
              || !register_operand (operands[1], E_TImode)
              || !
#line 2340 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && offsettable_memref_p (operands[0])
   && (!TARGET_HARD_QUAD
       || !fp_register_operand (operands[1], TImode))))
            return NULL;
          return gen_split_51 (insn, operands);

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode))
            {
              if (register_operand (operands[1], E_DFmode)
                  && 
#line 2578 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && (!TARGET_V9
       || (TARGET_ARCH32
	   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))))
                return gen_split_55 (insn, operands);
              if (memory_operand (operands[1], E_DFmode)
                  && 
#line 2591 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_56 (insn, operands);
            }
          if (!memory_operand (operands[0], E_DFmode)
              || !register_operand (operands[1], E_DFmode)
              || !
#line 2603 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_57 (insn, operands);

        case E_TFmode:
          if (register_operand (operands[0], E_TFmode))
            {
              if (register_operand (operands[1], E_TFmode)
                  && 
#line 2678 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && (TARGET_ARCH32
       || (TARGET_FPU
           && !TARGET_HARD_QUAD)
       || (!fp_register_operand (operands[0], TFmode)
           && !fp_register_operand (operands[1], TFmode)))))
                return gen_split_59 (insn, operands);
              if (memory_operand (operands[1], E_TFmode)
                  && 
#line 2742 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((reload_completed
    && offsettable_memref_p (operands[1])
    && (TARGET_ARCH32
	|| !TARGET_HARD_QUAD
	|| !fp_register_operand (operands[0], TFmode)))))
                return gen_split_61 (insn, operands);
            }
          if (!memory_operand (operands[0], E_TFmode)
              || !register_operand (operands[1], E_TFmode)
              || !
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((reload_completed
    && offsettable_memref_p (operands[0])
    && (TARGET_ARCH32
	|| !TARGET_HARD_QUAD
	|| !fp_register_operand (operands[1], TFmode)))))
            return NULL;
          return gen_split_62 (insn, operands);

        case E_V1DImode:
          if (register_operand (operands[0], E_V1DImode))
            {
              if (register_operand (operands[1], E_V1DImode)
                  && 
#line 8519 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_88 (insn, operands);
              if (memory_operand (operands[1], E_V1DImode)
                  && 
#line 8532 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_92 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V1DImode)
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 8545 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_96 (insn, operands);

        case E_V2SImode:
          if (register_operand (operands[0], E_V2SImode))
            {
              if (register_operand (operands[1], E_V2SImode)
                  && 
#line 8519 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_89 (insn, operands);
              if (memory_operand (operands[1], E_V2SImode)
                  && 
#line 8532 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_93 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V2SImode)
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 8545 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_97 (insn, operands);

        case E_V4HImode:
          if (register_operand (operands[0], E_V4HImode))
            {
              if (register_operand (operands[1], E_V4HImode)
                  && 
#line 8519 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_90 (insn, operands);
              if (memory_operand (operands[1], E_V4HImode)
                  && 
#line 8532 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_94 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V4HImode)
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 8545 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_98 (insn, operands);

        case E_V8QImode:
          if (register_operand (operands[0], E_V8QImode))
            {
              if (register_operand (operands[1], E_V8QImode)
                  && 
#line 8519 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_reg_legitimate (operands[0], operands[1])))
                return gen_split_91 (insn, operands);
              if (memory_operand (operands[1], E_V8QImode)
                  && 
#line 8532 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[0], operands[1])))
                return gen_split_95 (insn, operands);
            }
          if (!memory_operand (operands[0], E_V8QImode)
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 8545 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(reload_completed
   && TARGET_VIS
   && TARGET_ARCH32
   && sparc_split_reg_mem_legitimate (operands[1], operands[0])))
            return NULL;
          return gen_split_99 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      if (GET_MODE (x3) != E_TFmode)
        return NULL;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[1] = x4;
          if (icc_or_fcc_comparison_operator (operands[1], E_VOIDmode))
            {
              x6 = XEXP (x4, 1);
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  && register_operand (operands[0], E_TFmode))
                {
                  x7 = XEXP (x4, 0);
                  operands[2] = x7;
                  if (icc_or_fcc_register_operand (operands[2], E_VOIDmode))
                    {
                      x5 = XEXP (x3, 1);
                      operands[3] = x5;
                      if (register_operand (operands[3], E_TFmode))
                        {
                          x8 = XEXP (x3, 2);
                          operands[4] = x8;
                          if (register_operand (operands[4], E_TFmode)
                              && (
#line 2928 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 2930 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                            return gen_split_63 (insn, operands);
                        }
                    }
                }
            }
          if (!v9_register_comparison_operator (operands[1], E_VOIDmode))
            return NULL;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_TFmode))
            return NULL;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_DImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_TFmode))
            return NULL;
          x8 = XEXP (x3, 2);
          operands[4] = x8;
          if (!register_operand (operands[4], E_TFmode)
              || !(
#line 2968 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 2970 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_64 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !(
#line 3147 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3149 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_65 (insn, operands);

        case PLUS:
          if (pattern51 (x4, 
PLUS) != 0)
            return NULL;
          x7 = XEXP (x4, 0);
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!arith_operand (operands[2], E_SImode)
              || !(
#line 3917 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3919 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_69 (insn, operands);

        case MINUS:
          if (pattern51 (x4, 
MINUS) != 0)
            return NULL;
          x7 = XEXP (x4, 0);
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_or_zero_operand (operands[1], E_SImode))
            return NULL;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!arith_operand (operands[2], E_SImode)
              || !(
#line 4332 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4334 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_74 (insn, operands);

        default:
          return NULL;
        }

    case ABS:
      switch (pattern14 (x3))
        {
        case 0:
          if (!(
#line 6370 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD) && 
#line 6372 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_85 (insn, operands);

        case 1:
          if (!(
#line 6411 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9) && 
#line 6413 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
            return NULL;
          return gen_split_86 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
