/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern10 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern10 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern10 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !register_or_zero_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern28 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !arith_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_CCmode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || GET_MODE (x1) != E_CCXmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LTU
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCCmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern68 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_SImode)
      || !register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern79 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern86 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern94 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !symbolic_operand (operands[1], i1)
      || !call_address_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern101 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  return pattern36 (x6); /* [-1, 1] */
}

int
pattern109 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern116 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_or_zero_operand (operands[0], i1)
      || !arith_add_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern134 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !symbolic_operand (operands[1], i1)
      || !call_address_operand (operands[2], i1)
      || !const_int_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_CCVmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_CCVmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_DImode:
          return 0;

        case E_SImode:
          return 1;

        default:
          return -1;
        }

    case E_CCXVmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_CCXVmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern158 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!arith_add_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 23:
      if (pattern19 (x1, 
E_V4HImode, 
E_V4QImode) != 0
          || !
#line 8664 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 631; /* fpack16_vis */

    case 25:
      if (pattern19 (x1, 
E_V2SImode, 
E_V2HImode) != 0
          || !
#line 8674 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 632; /* fpackfix_vis */

    case 59:
      if (pattern20 (x1, 
E_V4QImode) != 0
          || !
#line 8721 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 636; /* fmul8x16_vis */

    case 27:
      if (pattern21 (x1, 
E_V4HImode) != 0
          || !
#line 8731 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 637; /* fmul8x16au_vis */

    case 28:
      if (pattern21 (x1, 
E_V4HImode) != 0
          || !
#line 8741 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 638; /* fmul8x16al_vis */

    case 60:
      if (pattern20 (x1, 
E_V8QImode) != 0
          || !
#line 8751 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 639; /* fmul8sux16_vis */

    case 29:
      if (pattern20 (x1, 
E_V8QImode) != 0
          || !
#line 8761 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 640; /* fmul8ulx16_vis */

    case 61:
      if (pattern21 (x1, 
E_V2SImode) != 0
          || !
#line 8771 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 641; /* fmuld8sux16_vis */

    case 30:
      if (pattern21 (x1, 
E_V2SImode) != 0
          || !
#line 8781 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
        return -1;
      return 642; /* fmuld8ulx16_vis */

    case 39:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9057 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 704; /* array8si_vis */

        case 1:
          if (!(
#line 9057 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 705; /* array8di_vis */

        default:
          return -1;
        }

    case 40:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9066 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 706; /* array16si_vis */

        case 1:
          if (!(
#line 9066 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 707; /* array16di_vis */

        default:
          return -1;
        }

    case 41:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9075 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 708; /* array32si_vis */

        case 1:
          if (!(
#line 9075 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 709; /* array32di_vis */

        default:
          return -1;
        }

    case 44:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9132 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 716; /* edge8nsi_vis */

        case 1:
          if (!(
#line 9132 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 717; /* edge8ndi_vis */

        default:
          return -1;
        }

    case 45:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9141 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 718; /* edge8lnsi_vis */

        case 1:
          if (!(
#line 9141 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 719; /* edge8lndi_vis */

        default:
          return -1;
        }

    case 46:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9150 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 720; /* edge16nsi_vis */

        case 1:
          if (!(
#line 9150 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 721; /* edge16ndi_vis */

        default:
          return -1;
        }

    case 47:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9159 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 722; /* edge16lnsi_vis */

        case 1:
          if (!(
#line 9159 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 723; /* edge16lndi_vis */

        default:
          return -1;
        }

    case 48:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9168 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 724; /* edge32nsi_vis */

        case 1:
          if (!(
#line 9168 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 725; /* edge32ndi_vis */

        default:
          return -1;
        }

    case 49:
      switch (pattern23 (x1))
        {
        case 0:
          if (!(
#line 9177 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 726; /* edge32lnsi_vis */

        case 1:
          if (!(
#line 9177 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 727; /* edge32lndi_vis */

        default:
          return -1;
        }

    case 51:
      if (pattern24 (x1) != 0)
        return -1;
      if (register_or_zero_operand (operands[0], E_SImode)
          && (
#line 9187 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
        return 728; /* cmask8si_vis */
      if (!register_or_zero_operand (operands[0], E_DImode)
          || !(
#line 9187 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return -1;
      return 729; /* cmask8di_vis */

    case 52:
      if (pattern24 (x1) != 0)
        return -1;
      if (register_or_zero_operand (operands[0], E_SImode)
          && (
#line 9197 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
        return 730; /* cmask16si_vis */
      if (!register_or_zero_operand (operands[0], E_DImode)
          || !(
#line 9197 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return -1;
      return 731; /* cmask16di_vis */

    case 53:
      if (pattern24 (x1) != 0)
        return -1;
      if (register_or_zero_operand (operands[0], E_SImode)
          && (
#line 9207 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
        return 732; /* cmask32si_vis */
      if (!register_or_zero_operand (operands[0], E_DImode)
          || !(
#line 9207 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return -1;
      return 733; /* cmask32di_vis */

    case 54:
      if (pattern20 (x1, 
E_V4HImode) != 0
          || !
#line 9217 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
        return -1;
      return 734; /* fchksm16_vis */

    case 55:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V8QImode))
        return -1;
      switch (pattern4 (x2))
        {
        case 0:
          if (!(
#line 9244 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 743; /* pdistnsi_vis */

        case 1:
          if (!(
#line 9244 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 744; /* pdistndi_vis */

        default:
          return -1;
        }

    case 56:
      switch (pattern26 (x1))
        {
        case 0:
          if (!
#line 9409 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 781; /* fhaddsf_vis */

        case 1:
          if (!
#line 9418 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 782; /* fhadddf_vis */

        default:
          return -1;
        }

    case 57:
      switch (pattern26 (x1))
        {
        case 0:
          if (!
#line 9428 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 783; /* fhsubsf_vis */

        case 1:
          if (!
#line 9437 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 784; /* fhsubdf_vis */

        default:
          return -1;
        }

    case 65:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !imm5_operand_dictunpack8 (operands[2], E_SImode)
              || !
#line 9474 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B))
            return -1;
          return 787; /* dictunpack8 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x2) != E_V4HImode
              || !imm5_operand_dictunpack16 (operands[2], E_SImode)
              || !
#line 9474 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B))
            return -1;
          return 788; /* dictunpack16 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x2) != E_V2SImode
              || !imm5_operand_dictunpack32 (operands[2], E_SImode)
              || !
#line 9474 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B))
            return -1;
          return 789; /* dictunpack32 */

        default:
          return -1;
        }

    case 66:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XVECEXP (x2, 0, 1);
      operands[3] = x5;
      if (!imm2_operand (operands[3], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case EQ:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 790; /* fpcmpeq8sishl */

            case 1:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 794; /* fpcmpeq16sishl */

            case 2:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 798; /* fpcmpeq32sishl */

            case 3:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 802; /* fpcmpeq8dishl */

            case 4:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 806; /* fpcmpeq16dishl */

            case 5:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 810; /* fpcmpeq32dishl */

            default:
              return -1;
            }

        case NE:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 791; /* fpcmpne8sishl */

            case 1:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 795; /* fpcmpne16sishl */

            case 2:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 799; /* fpcmpne32sishl */

            case 3:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 803; /* fpcmpne8dishl */

            case 4:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 807; /* fpcmpne16dishl */

            case 5:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 811; /* fpcmpne32dishl */

            default:
              return -1;
            }

        case LE:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 792; /* fpcmple8sishl */

            case 1:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 796; /* fpcmple16sishl */

            case 2:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 800; /* fpcmple32sishl */

            case 3:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 804; /* fpcmple8dishl */

            case 4:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 808; /* fpcmple16dishl */

            case 5:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 812; /* fpcmple32dishl */

            default:
              return -1;
            }

        case GT:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 793; /* fpcmpgt8sishl */

            case 1:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 797; /* fpcmpgt16sishl */

            case 2:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 801; /* fpcmpgt32sishl */

            case 3:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 805; /* fpcmpgt8dishl */

            case 4:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 809; /* fpcmpgt16dishl */

            case 5:
              if (!(
#line 9486 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 813; /* fpcmpgt32dishl */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 67:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XVECEXP (x2, 0, 1);
      operands[3] = x5;
      if (!imm2_operand (operands[3], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x4))
        {
        case LEU:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 814; /* fpcmpule8sishl */

            case 1:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 816; /* fpcmpule16sishl */

            case 2:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 818; /* fpcmpule32sishl */

            case 3:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 820; /* fpcmpule8dishl */

            case 4:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 822; /* fpcmpule16dishl */

            case 5:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 824; /* fpcmpule32dishl */

            default:
              return -1;
            }

        case GTU:
          switch (pattern76 (x2))
            {
            case 0:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 815; /* fpcmpugt8sishl */

            case 1:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 817; /* fpcmpugt16sishl */

            case 2:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 819; /* fpcmpugt32sishl */

            case 3:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 821; /* fpcmpugt8dishl */

            case 4:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 823; /* fpcmpugt16dishl */

            case 5:
              if (!(
#line 9497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 825; /* fpcmpugt32dishl */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 15:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[1] = x5;
      if (zero_or_v7_operand (operands[1], E_SImode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          if (rtx_equal_p (x4, operands[0]))
            return 838; /* *membar_empty */
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 8L:
          if (
#line 63 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_V8))
            return 839; /* *membar_storestore */
          break;

        case 2L:
          if (
#line 71 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_V8))
            return 840; /* membar_storeload */
          break;

        default:
          break;
        }
      operands[1] = x5;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      if (
#line 89 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_V8))
        return 841; /* *membar_v8 */
      if (!
#line 105 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_V9))
        return -1;
      return 842; /* *membar */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
      if (XWINT (x4, 0) != 0L
          || !memory_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!memory_operand (operands[1], E_SImode))
        return NULL;
      if (
#line 7638 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9
   && mems_ok_for_ldd_peep (operands[0], operands[1], NULL_RTX)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_1 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (!
#line 7650 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9
   && mems_ok_for_ldd_peep (operands[1], operands[0], NULL_RTX)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_2 (insn, operands);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode))
            {
              if (memory_operand (operands[1], E_SImode))
                {
                  x6 = XEXP (x3, 0);
                  operands[2] = x6;
                  if (register_operand (operands[2], E_SImode))
                    {
                      x5 = XEXP (x3, 1);
                      operands[3] = x5;
                      if (memory_operand (operands[3], E_SImode)
                          && 
#line 7662 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[0], operands[2]) 
   && mems_ok_for_ldd_peep (operands[1], operands[3], operands[0])))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_3 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
              if (register_operand (operands[1], E_SImode)
                  && pattern89 (x3, 
E_SImode, 
E_CCmode) == 0
                  && 
#line 7771 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((rtx_equal_p (operands[2], operands[0])
    || rtx_equal_p (operands[2], operands[1]))
    && !SPARC_FP_REG_P (REGNO (operands[0]))
    && !SPARC_FP_REG_P (REGNO (operands[1]))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_11 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (memory_operand (operands[2], E_SImode)
              && memory_operand (operands[0], E_SImode)
              && register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (register_operand (operands[3], E_SImode)
                  && 
#line 7675 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[1], operands[3]) 
   && mems_ok_for_ldd_peep (operands[0], operands[2], NULL_RTX)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_4 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (register_operand (operands[2], E_SImode)
              && register_operand (operands[0], E_SImode)
              && memory_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (memory_operand (operands[3], E_SImode)
                  && 
#line 7714 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[2], operands[0]) 
  && mems_ok_for_ldd_peep (operands[3], operands[1], operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_7 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_SImode)
              || !memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode)
              || !
#line 7727 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[3], operands[1]) 
  && mems_ok_for_ldd_peep (operands[2], operands[0], NULL_RTX)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_SFmode:
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_SFmode)
              && memory_operand (operands[1], E_SFmode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (memory_operand (operands[3], E_SFmode)
                  && 
#line 7688 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[0], operands[2]) 
   && mems_ok_for_ldd_peep (operands[1], operands[3], operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_5 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (memory_operand (operands[2], E_SFmode)
              && memory_operand (operands[0], E_SFmode)
              && register_operand (operands[1], E_SFmode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (register_operand (operands[3], E_SFmode)
                  && 
#line 7701 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[1], operands[3]) 
  && mems_ok_for_ldd_peep (operands[0], operands[2], NULL_RTX)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_6 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (register_operand (operands[2], E_SFmode)
              && register_operand (operands[0], E_SFmode)
              && memory_operand (operands[1], E_SFmode))
            {
              x5 = XEXP (x3, 1);
              operands[3] = x5;
              if (memory_operand (operands[3], E_SFmode)
                  && 
#line 7740 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[2], operands[0]) 
  && mems_ok_for_ldd_peep (operands[3], operands[1], operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_9 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!memory_operand (operands[2], E_SFmode)
              || !memory_operand (operands[0], E_SFmode)
              || !register_operand (operands[1], E_SFmode))
            return NULL;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SFmode)
              || !
#line 7753 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(registers_ok_for_ldd_peep (operands[3], operands[1]) 
  && mems_ok_for_ldd_peep (operands[2], operands[0], NULL_RTX)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_10 (insn, operands);

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || pattern89 (x3, 
E_DImode, 
E_CCXmode) != 0
              || !
#line 7786 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && (rtx_equal_p (operands[2], operands[0])
       || rtx_equal_p (operands[2], operands[1]))
   && !SPARC_FP_REG_P (REGNO (operands[0]))
   && !SPARC_FP_REG_P (REGNO (operands[1]))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_12 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 15
          || GET_MODE (x4) != E_BLKmode)
        return NULL;
      x7 = XVECEXP (x4, 0, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_SImode))
        return NULL;
      x8 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x8, operands[0]))
        return NULL;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 15
          || GET_MODE (x5) != E_BLKmode)
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      x9 = XVECEXP (x5, 0, 1);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_SImode))
        return NULL;
      x10 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_13 (insn, operands);

    default:
      return NULL;
    }
}
