/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern0 (x3, pnum_clobbers, 
E_SImode); /* [-1, 1] */

        case E_DImode:
          res = pattern0 (x3, pnum_clobbers, 
E_DImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern2 (x3);
      if (res >= 0)
        return res + 4; /* [4, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern19 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 102
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SImode:
      return pattern30 (x1, 
E_V1SImode); /* [-1, 0] */

    case E_V2HImode:
      if (pattern30 (x1, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern30 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V1DImode:
      if (pattern30 (x1, 
E_V1DImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern30 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4HImode:
      if (pattern30 (x1, 
E_V4HImode) != 0)
        return -1;
      return 5;

    case E_V8QImode:
      if (pattern30 (x1, 
E_V8QImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_MODE (x7) != E_CCmode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_MODE (x7) != E_CCXmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!symbolic_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern75 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode)
          || !register_operand (operands[2], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode)
          || !register_operand (operands[2], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode)
      || !register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x7, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  return 0;
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern105 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern112 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_MODE (x7) != E_CCmode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_MODE (x7) != E_CCXmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != NEG)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern153 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern162 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CCCmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CCCmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NEG:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return -1;
      switch (GET_CODE (x5))
        {
        case GEU:
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!icc_register_operand (operands[1], E_VOIDmode)
              || !
#line 1141 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && (GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode)))
            return -1;
          return 59; /* *neg_sgeusidi */

        case LTU:
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!icc_register_operand (operands[1], E_VOIDmode)
              || !
#line 1217 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && (GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode)))
            return -1;
          return 74; /* *neg_sltusidi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern60 (x3))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (memory_operand (operands[1], E_HImode))
                return 193; /* *sign_extendhisi2_insn */
              break;

            case E_QImode:
              if (memory_operand (operands[1], E_QImode))
                return 195; /* *sign_extendqisi2_insn */
              break;

            default:
              break;
            }
          break;

        case 1:
          if (memory_operand (operands[1], E_QImode))
            return 194; /* *sign_extendqihi2_insn */
          break;

        case 2:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (memory_operand (operands[1], E_QImode)
                  && 
#line 3405 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return 196; /* *sign_extendqidi2_insn */
              break;

            case E_HImode:
              if (memory_operand (operands[1], E_HImode)
                  && 
#line 3436 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return 197; /* *sign_extendhidi2_insn */
              break;

            default:
              break;
            }
          if (input_operand (operands[1], E_SImode)
              && 
#line 3450 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return 198; /* *sign_extendsidi2_insn */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != MEM)
        return -1;
      switch (pattern62 (x3))
        {
        case 0:
          if (!(
#line 8130 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 498; /* *tldo_ldsb1si */

        case 1:
          if (!(
#line 8130 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 499; /* *tldo_ldsb1di */

        case 2:
          if (!(
#line 8142 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 500; /* *tldo_ldsb2si */

        case 3:
          if (!(
#line 8142 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 501; /* *tldo_ldsb2di */

        case 4:
          if (!(
#line 8204 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 508; /* *tldo_ldsh1si */

        case 5:
          if (!(
#line 8204 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 509; /* *tldo_ldsh1di */

        case 6:
          if (!
#line 8167 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 503; /* *tldo_ldsb3_sp64 */

        case 7:
          if (!
#line 8229 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 511; /* *tldo_ldsh2_sp64 */

        case 8:
          if (!
#line 8264 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 515; /* *tldo_ldsw1_sp64 */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern50 (x3) != 0
          || !
#line 6591 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 394; /* *ashrsi3_extend0 */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case LSHIFTRT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MULT:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_DImode
                  || GET_MODE (x6) != E_DImode)
                return -1;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x9 = XEXP (x6, 1);
              switch (GET_CODE (x9))
                {
                case SIGN_EXTEND:
                  if (pnum_clobbers != NULL
                      && GET_MODE (x9) == E_DImode)
                    {
                      x10 = XEXP (x9, 0);
                      operands[2] = x10;
                      if (register_operand (operands[2], E_SImode))
                        {
                          operands[3] = x5;
                          if (small_int_operand (operands[3], E_SImode)
                              && 
#line 4779 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                            {
                              *pnum_clobbers = 1;
                              return 270; /* smulsi3_highpart_v8plus */
                            }
                        }
                    }
                  if (GET_MODE (x9) != E_DImode
                      || XWINT (x5, 0) != 32L)
                    return -1;
                  x10 = XEXP (x9, 0);
                  operands[2] = x10;
                  if (!register_operand (operands[2], E_SImode)
                      || !
#line 4824 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
                    return -1;
                  return 273; /* *smulsi3_highpart_sp32 */

                case CONST_INT:
                  if (pnum_clobbers != NULL)
                    {
                      operands[2] = x9;
                      if (small_int_operand (operands[2], E_DImode))
                        {
                          operands[3] = x5;
                          if (small_int_operand (operands[3], E_SImode)
                              && 
#line 4810 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                            {
                              *pnum_clobbers = 1;
                              return 272; /* const_smulsi3_highpart_v8plus */
                            }
                        }
                    }
                  operands[2] = x9;
                  if (!small_int_operand (operands[2], E_DImode)
                      || XWINT (x5, 0) != 32L
                      || !
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
                    return -1;
                  return 274; /* const_smulsi3_highpart */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              x9 = XEXP (x6, 1);
              switch (GET_CODE (x9))
                {
                case ZERO_EXTEND:
                  if (pnum_clobbers != NULL
                      && GET_MODE (x9) == E_DImode
                      && pattern106 (x3, 
E_DImode, 
E_SImode) == 0
                      && register_operand (operands[1], E_SImode))
                    {
                      x10 = XEXP (x9, 0);
                      operands[2] = x10;
                      if (register_operand (operands[2], E_SImode))
                        {
                          operands[3] = x5;
                          if (small_int_operand (operands[3], E_SImode)
                              && 
#line 4981 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                            {
                              *pnum_clobbers = 1;
                              return 281; /* umulsi3_highpart_v8plus */
                            }
                        }
                    }
                  x10 = XEXP (x9, 0);
                  operands[2] = x10;
                  switch (XWINT (x5, 0))
                    {
                    case 32L:
                      if (pattern107 (x3) != 0
                          || GET_MODE (x9) != E_DImode
                          || !register_operand (operands[2], E_SImode)
                          || !
#line 5010 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
                        return -1;
                      return 283; /* *umulsi3_highpart_sp32 */

                    case 64L:
                      if (pattern106 (x3, 
E_TImode, 
E_DImode) != 0
                          || !arith_operand (operands[1], E_DImode)
                          || GET_MODE (x9) != E_TImode
                          || !arith_operand (operands[2], E_DImode))
                        return -1;
                      if (
#line 5051 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH64))
                        return 285; /* *umulxhi_sp64 */
                      if (pnum_clobbers == NULL
                          || !
#line 5064 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
                        return -1;
                      *pnum_clobbers = 2;
                      return 286; /* umulxhi_v8plus */

                    default:
                      return -1;
                    }

                case CONST_INT:
                  if (pnum_clobbers != NULL)
                    {
                      operands[2] = x9;
                      if (uns_small_int_operand (operands[2], E_DImode)
                          && pattern107 (x3) == 0)
                        {
                          operands[3] = x5;
                          if (small_int_operand (operands[3], E_SImode)
                              && 
#line 4996 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                            {
                              *pnum_clobbers = 1;
                              return 282; /* const_umulsi3_highpart_v8plus */
                            }
                        }
                    }
                  operands[2] = x9;
                  if (!uns_small_int_operand (operands[2], E_DImode)
                      || XWINT (x5, 0) != 32L
                      || pattern107 (x3) != 0
                      || !
#line 5022 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
                    return -1;
                  return 284; /* const_umulsi3_highpart */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 2
              || XINT (x6, 1) != 58
              || GET_MODE (x6) != E_TImode)
            return -1;
          x11 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x11) != ZERO_EXTEND
              || GET_MODE (x11) != E_TImode)
            return -1;
          x12 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x12) != ZERO_EXTEND
              || GET_MODE (x12) != E_TImode
              || XWINT (x5, 0) != 64L
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_TImode)
            return -1;
          x13 = XEXP (x11, 0);
          operands[1] = x13;
          if (!arith_operand (operands[1], E_DImode))
            return -1;
          x14 = XEXP (x12, 0);
          operands[2] = x14;
          if (!arith_operand (operands[2], E_DImode))
            return -1;
          if (
#line 5136 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH64))
            return 289; /* *xmulxhi_sp64 */
          if (pnum_clobbers == NULL
              || !
#line 5150 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 2;
          return 290; /* xmulxhi_v8plus */

        case PLUS:
          if (GET_MODE (x6) != E_V4SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != E_V4SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != ZERO_EXTEND
              || GET_MODE (x8) != E_V4SImode)
            return -1;
          x15 = XEXP (x7, 1);
          if (GET_CODE (x15) != ZERO_EXTEND
              || GET_MODE (x15) != E_V4SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != CONST_VECTOR
              || XVECLEN (x9, 0) != 4
              || GET_MODE (x9) != E_V4SImode)
            return -1;
          x16 = XVECEXP (x9, 0, 0);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x17 = XVECEXP (x9, 0, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x18 = XVECEXP (x9, 0, 2);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x19 = XVECEXP (x9, 0, 3);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XWINT (x5, 0) != 1L
              || !register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || GET_MODE (x4) != E_V4SImode)
            return -1;
          x20 = XEXP (x8, 0);
          operands[1] = x20;
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          x21 = XEXP (x15, 0);
          operands[2] = x21;
          if (!register_operand (operands[2], E_V4HImode)
              || !
#line 9262 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 745; /* fmean16_vis */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 58
          || GET_MODE (x4) != E_TImode)
        return -1;
      x22 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x22) != ZERO_EXTEND
          || GET_MODE (x22) != E_TImode)
        return -1;
      x23 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x23) != ZERO_EXTEND
          || GET_MODE (x23) != E_TImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x24 = XEXP (x22, 0);
      operands[1] = x24;
      if (!arith_operand (operands[1], E_DImode))
        return -1;
      x25 = XEXP (x23, 0);
      operands[2] = x25;
      if (!arith_operand (operands[2], E_DImode))
        return -1;
      if (
#line 5092 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH64))
        return 287; /* *xmulx_sp64 */
      if (pnum_clobbers == NULL
          || !
#line 5104 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
        return -1;
      *pnum_clobbers = 2;
      return 288; /* xmulx_v8plus */

    case POPCOUNT:
      if (pattern27 (x3, 
E_DImode, 
E_SImode) != 0
          || !
#line 7538 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH64))
        return -1;
      return 449; /* *popcountsi_sp64 */

    case CLZ:
      if (pattern27 (x3, 
E_DImode, 
E_SImode) != 0
          || !
#line 7610 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH64))
        return -1;
      return 453; /* *clzsi_sp64 */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (address_operand (operands[1], E_SImode)
              && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            {
              *pnum_clobbers = 1;
              return 421; /* *call_value_addresssi */
            }
          if (!symbolic_operand (operands[1], E_SImode)
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 1;
          return 423; /* *call_value_symbolicsi */

        case E_DImode:
          if (address_operand (operands[1], E_DImode)
              && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            {
              *pnum_clobbers = 1;
              return 422; /* *call_value_addressdi */
            }
          if (!symbolic_operand (operands[1], E_DImode)
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          *pnum_clobbers = 1;
          return 424; /* *call_value_symbolicdi */

        default:
          return -1;
        }

    case UNSPEC:
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          if (XINT (x5, 1) != 17)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          x8 = XVECEXP (x5, 0, 1);
          operands[2] = x8;
          if (!tgd_symbolic_operand (operands[2], E_VOIDmode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          switch (pattern108 (x3))
            {
            case 0:
              if (!(
#line 7958 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              *pnum_clobbers = 1;
              return 466; /* tgd_callsi */

            case 1:
              if (!(
#line 7958 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              *pnum_clobbers = 1;
              return 467; /* tgd_calldi */

            default:
              return -1;
            }

        case 1:
          if (XINT (x5, 1) != 18)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          operands[1] = x7;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          switch (pattern108 (x3))
            {
            case 0:
              if (!(
#line 7991 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              *pnum_clobbers = 1;
              return 474; /* tldm_callsi */

            case 1:
              if (!(
#line 7991 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              *pnum_clobbers = 1;
              return 475; /* tldm_calldi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_36 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case UNSPEC:
          if (XVECLEN (x7, 0) != 2
              || XINT (x7, 1) != 63)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != MINUS
              || pattern142 (x1) != 0)
            return -1;
          switch (pattern145 (x2))
            {
            case 0:
              if (pattern157 (x1) != 0
                  || !
#line 4298 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                return -1;
              return 242; /* subvdi4_sp32 */

            case 1:
              if (!register_or_zero_operand (operands[1], E_SImode)
                  || pattern158 (x1, 
E_SImode) != 0)
                return -1;
              return 256; /* *cmp_ccv_minus_set */

            case 2:
              if (!register_or_zero_operand (operands[1], E_DImode)
                  || pattern158 (x1, 
E_DImode) != 0
                  || !
#line 4540 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 257; /* *cmp_ccxv_minus_set */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 1);
          switch (GET_CODE (x9))
            {
            case MINUS:
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x9, 1);
              if (!rtx_equal_p (x11, operands[2]))
                return -1;
              x12 = XEXP (x2, 0);
              switch (GET_MODE (x12))
                {
                case E_CCNZmode:
                  if (pattern149 (x1, 
E_SImode, 
E_CCNZmode) != 0)
                    return -1;
                  return 249; /* *cmp_ccnz_minus_set */

                case E_CCXNZmode:
                  if (pattern149 (x1, 
E_DImode, 
E_CCXNZmode) != 0
                      || !
#line 4453 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 250; /* *cmp_ccxnz_minus_set */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x9, 0) != 2)
                return -1;
              x12 = XEXP (x2, 0);
              if (GET_MODE (x12) != E_CCNZmode
                  || GET_MODE (x3) != E_CCNZmode)
                return -1;
              x13 = XVECEXP (x9, 0, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return -1;
              x14 = XVECEXP (x9, 0, 1);
              if (!rtx_equal_p (x14, operands[2]))
                return -1;
              switch (XINT (x9, 1))
                {
                case 33:
                  switch (GET_MODE (x4))
                    {
                    case E_SImode:
                      if (pattern156 (x9, 
E_SImode) != 0
                          || !(
#line 8926 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 656; /* edge8si_vis */

                    case E_DImode:
                      if (pattern156 (x9, 
E_DImode) != 0
                          || !(
#line 8926 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                        return -1;
                      return 657; /* edge8di_vis */

                    default:
                      return -1;
                    }

                case 34:
                  switch (GET_MODE (x4))
                    {
                    case E_SImode:
                      if (pattern156 (x9, 
E_SImode) != 0
                          || !(
#line 8937 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 658; /* edge8lsi_vis */

                    case E_DImode:
                      if (pattern156 (x9, 
E_DImode) != 0
                          || !(
#line 8937 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                        return -1;
                      return 659; /* edge8ldi_vis */

                    default:
                      return -1;
                    }

                case 35:
                  switch (GET_MODE (x4))
                    {
                    case E_SImode:
                      if (pattern156 (x9, 
E_SImode) != 0
                          || !(
#line 8948 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 660; /* edge16si_vis */

                    case E_DImode:
                      if (pattern156 (x9, 
E_DImode) != 0
                          || !(
#line 8948 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                        return -1;
                      return 661; /* edge16di_vis */

                    default:
                      return -1;
                    }

                case 36:
                  switch (GET_MODE (x4))
                    {
                    case E_SImode:
                      if (pattern156 (x9, 
E_SImode) != 0
                          || !(
#line 8959 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 662; /* edge16lsi_vis */

                    case E_DImode:
                      if (pattern156 (x9, 
E_DImode) != 0
                          || !(
#line 8959 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                        return -1;
                      return 663; /* edge16ldi_vis */

                    default:
                      return -1;
                    }

                case 37:
                  switch (GET_MODE (x4))
                    {
                    case E_SImode:
                      if (pattern156 (x9, 
E_SImode) != 0
                          || !(
#line 8970 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 664; /* edge32si_vis */

                    case E_DImode:
                      if (pattern156 (x9, 
E_DImode) != 0
                          || !(
#line 8970 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                        return -1;
                      return 665; /* edge32di_vis */

                    default:
                      return -1;
                    }

                case 38:
                  switch (GET_MODE (x4))
                    {
                    case E_SImode:
                      if (pattern156 (x9, 
E_SImode) != 0
                          || !(
#line 8981 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 666; /* edge32lsi_vis */

                    case E_DImode:
                      if (pattern156 (x9, 
E_DImode) != 0
                          || !(
#line 8981 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                        return -1;
                      return 667; /* edge32ldi_vis */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pattern100 (x3, 
E_CCmode, 
MINUS, 
63) != 0)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 1);
      if (pattern160 (x9, 
E_CCmode, 
MINUS) != 0)
        return -1;
      x12 = XEXP (x2, 0);
      if (GET_MODE (x12) != E_CCVmode
          || GET_MODE (x3) != E_CCVmode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x15 = XEXP (x5, 0);
      operands[1] = x15;
      if (!register_or_zero_operand (operands[1], E_SImode))
        return -1;
      x16 = XEXP (x5, 1);
      operands[2] = x16;
      if (!arith_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_SImode)
          || pattern163 (x1) != 0)
        return -1;
      return 258; /* *cmp_ccv_minus_sltu_set */

    default:
      return -1;
    }
}
