/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern10 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern10 (x3, 
E_V8QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V2HImode))
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern32 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern10 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern10 (x1, 
E_V2SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern44 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V1SImode:
      return pattern53 (x1, 
E_V1SImode); /* [-1, 0] */

    case E_V2HImode:
      if (pattern53 (x1, 
E_V2HImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern53 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V1DImode:
      if (pattern53 (x1, 
E_V1DImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern53 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4HImode:
      if (pattern53 (x1, 
E_V4HImode) != 0)
        return -1;
      return 5;

    case E_V8QImode:
      if (pattern53 (x1, 
E_V8QImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern73 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!fcc_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !register_operand (operands[2], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !register_operand (operands[2], E_DFmode))
        return -1;
      return 1;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !register_operand (operands[2], E_TFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern92 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2
      || !cc_arith_operator (operands[2], i1)
      || !arith_operand (operands[0], i1)
      || !arith_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern96 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern108 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !symbolic_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !symbolic_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_or_zero_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !arith10_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern137 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2
      || !register_or_zero_operand (operands[1], i1)
      || !arith_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2
      || !cc_arith_operator (operands[3], i1)
      || !arith_operand (operands[1], i1)
      || !arith_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || !cc_arith_operator (operands[4], i1))
    return -1;
  return 0;
}

int
pattern152 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != LTU
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, E_DImode))
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case LABEL_REF:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      operands[0] = x3;
      operands[1] = x4;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!
#line 1557 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 109; /* *normal_int_branch_sp64 */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[3] = x5;
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      operands[1] = x3;
      operands[2] = x4;
      x6 = XEXP (x2, 2);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern128 (x2, 
E_QImode) != 0
              || !
#line 2847 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 162; /* *movqi_cc_reg_sp64 */

        case E_HImode:
          if (pattern128 (x2, 
E_HImode) != 0
              || !
#line 2847 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 163; /* *movhi_cc_reg_sp64 */

        case E_SImode:
          if (pattern128 (x2, 
E_SImode) != 0
              || !
#line 2847 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 164; /* *movsi_cc_reg_sp64 */

        case E_DImode:
          if (pattern128 (x2, 
E_DImode) != 0
              || !
#line 2847 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 165; /* *movdi_cc_reg_sp64 */

        case E_SFmode:
          if (pattern127 (x2, 
E_SFmode) != 0
              || !
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_FPU))
            return -1;
          return 167; /* *movsf_cc_reg_sp64 */

        case E_DFmode:
          if (pattern127 (x2, 
E_DFmode) != 0
              || !
#line 2894 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_FPU))
            return -1;
          return 169; /* movdf_cc_reg_sp64 */

        case E_TFmode:
          if (pattern127 (x2, 
E_TFmode) != 0
              || !
#line 2917 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 171; /* *movtf_cc_reg_hq_sp64 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern28 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 4579 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL))
            return 259; /* *mulsi3_sp32 */
          if (!
#line 4587 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 260; /* *mulsi3_sp64 */

        case E_DImode:
          if (pattern28 (x3, 
E_DImode) != 0)
            return -1;
          if (
#line 4608 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return 261; /* *muldi3_sp64 */
          if (pnum_clobbers == NULL
              || !
#line 4619 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          *pnum_clobbers = 2;
          return 262; /* muldi3_v8plus */

        case E_TFmode:
          if (pattern10 (x3, 
E_TFmode) != 0
              || !
#line 6090 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 357; /* *multf3_hq */

        case E_DFmode:
          if (pattern10 (x3, 
E_DFmode) != 0
              || !
#line 6098 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 358; /* muldf3 */

        case E_SFmode:
          if (pattern10 (x3, 
E_SFmode) != 0
              || !
#line 6107 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 359; /* mulsf3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern27 (x3, 
E_SImode, 
E_DImode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 4670 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            {
              *pnum_clobbers = 1;
              return 264; /* mulsidi3_v8plus */
            }
          if (
#line 4693 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
            return 266; /* *mulsidi3_sp32 */
          if (!
#line 4710 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_DEPRECATED_V8_INSNS && TARGET_ARCH64))
            return -1;
          return 267; /* *mulsidi3_sp64 */

        case CONST_INT:
          operands[2] = x5;
          if (!small_int_operand (operands[2], E_DImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 4682 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            {
              *pnum_clobbers = 1;
              return 265; /* const_mulsidi3_v8plus */
            }
          if (
#line 4720 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
            return 268; /* const_mulsidi3_sp32 */
          if (!
#line 4737 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_DEPRECATED_V8_INSNS && TARGET_ARCH64))
            return -1;
          return 269; /* const_mulsidi3_sp64 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern27 (x3, 
E_SImode, 
E_DImode) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 4872 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            {
              *pnum_clobbers = 1;
              return 275; /* umulsidi3_v8plus */
            }
          if (
#line 4883 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
            return 276; /* *umulsidi3_sp32 */
          if (!
#line 4900 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_DEPRECATED_V8_INSNS && TARGET_ARCH64))
            return -1;
          return 277; /* *umulsidi3_sp64 */

        case CONST_INT:
          operands[2] = x5;
          if (!uns_small_int_operand (operands[2], E_DImode))
            return -1;
          if (
#line 4910 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_HARD_MUL32))
            return 278; /* const_umulsidi3_sp32 */
          if (
#line 4927 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_DEPRECATED_V8_INSNS && TARGET_ARCH64))
            return 279; /* const_umulsidi3_sp64 */
          if (pnum_clobbers == NULL
              || !
#line 4936 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          *pnum_clobbers = 1;
          return 280; /* const_umulsidi3_v8plus */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != FLOAT_EXTEND)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (pattern86 (x3, 
E_SFmode, 
E_DFmode) != 0
              || !
#line 6187 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FSMULD))
            return -1;
          return 368; /* *muldf3_extend */

        case E_TFmode:
          if (pattern86 (x3, 
E_DFmode, 
E_TFmode) != 0
              || !
#line 6196 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((TARGET_V8 || TARGET_V9) && TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 369; /* *multf3_extend */

        default:
          return -1;
        }

    case NEG:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern55 (x3, 
E_SFmode) != 0
                  || !
#line 9380 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 778; /* *nmulsf3 */

            case E_DFmode:
              if (pattern55 (x3, 
E_DFmode) != 0
                  || !
#line 9388 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 779; /* *nmuldf3 */

            default:
              return -1;
            }

        case FLOAT_EXTEND:
          if (GET_MODE (x7) != E_DFmode)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != FLOAT_EXTEND
              || GET_MODE (x5) != E_DFmode
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || GET_MODE (x4) != E_DFmode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_SFmode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SFmode)
              || !
#line 9399 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 780; /* *nmuldf3_extend */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case HIGH:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !immediate_operand (operands[2], E_SImode)
              || !
#line 1698 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(!flag_pic))
            return -1;
          return 117; /* *movsi_lo_sum */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (symbolic_operand (operands[2], E_DImode))
            {
              if (
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_MEDLOW && !flag_pic))
                return 133; /* *losum_di_medlow */
              if (
#line 2011 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_MEDMID && !flag_pic))
                return 136; /* setl44 */
              if (
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_MEDANY && !flag_pic))
                return 140; /* setlo */
            }
          if (data_segment_operand (operands[2], E_DImode)
              && 
#line 2054 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
            return 142; /* embmedany_losum */
          if (!text_segment_operand (operands[2], E_DImode)
              || !
#line 2090 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
            return -1;
          return 147; /* embmedany_textlo */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !fp_const_high_losum_operand (operands[2], E_SFmode))
            return -1;
          return 151; /* *movsf_lo_sum */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x5, 0))
        {
        case 1:
          switch (XINT (x5, 1))
            {
            case 0:
              x6 = XVECEXP (x5, 0, 0);
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern85 (x3, 
E_SImode) != 0
                      || !
#line 1714 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(flag_pic))
                    return -1;
                  return 119; /* movsi_lo_sum_pic */

                case E_DImode:
                  if (pattern85 (x3, 
E_DImode) != 0
                      || !
#line 1935 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && flag_pic))
                    return -1;
                  return 128; /* movdi_lo_sum_pic */

                default:
                  return -1;
                }

            case 6:
              if (pattern66 (x3) != 0
                  || !
#line 2004 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_MEDMID && !flag_pic))
                return -1;
              return 135; /* setm44 */

            case 13:
              if (pattern66 (x3) != 0
                  || !
#line 2033 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_MEDANY && !flag_pic))
                return -1;
              return 139; /* sethm */

            case 12:
              if (GET_MODE (x5) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x6 = XVECEXP (x5, 0, 0);
              operands[2] = x6;
              if (!text_segment_operand (operands[2], E_DImode)
                  || !
#line 2083 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
                return -1;
              return 146; /* embmedany_textulo */

            case 17:
              x6 = XVECEXP (x5, 0, 0);
              operands[2] = x6;
              if (!tgd_symbolic_operand (operands[2], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern58 (x3, 
E_SImode) != 0
                      || !(
#line 7939 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 462; /* tgd_lo10si */

                case E_DImode:
                  if (pattern58 (x3, 
E_DImode) != 0
                      || !(
#line 7939 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 463; /* tgd_lo10di */

                default:
                  return -1;
                }

            case 18:
              x6 = XVECEXP (x5, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern58 (x3, 
E_SImode) != 0
                      || !(
#line 7974 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 470; /* tldm_lo10si */

                case E_DImode:
                  if (pattern58 (x3, 
E_DImode) != 0
                      || !(
#line 7974 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 471; /* tldm_lo10di */

                default:
                  return -1;
                }

            case 19:
              x6 = XVECEXP (x5, 0, 0);
              operands[2] = x6;
              if (!tld_symbolic_operand (operands[2], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern58 (x3, 
E_SImode) != 0
                      || !(
#line 8009 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 478; /* tldo_lox10si */

                case E_DImode:
                  if (pattern58 (x3, 
E_DImode) != 0
                      || !(
#line 8009 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 479; /* tldo_lox10di */

                default:
                  return -1;
                }

            case 20:
              x6 = XVECEXP (x5, 0, 0);
              operands[2] = x6;
              if (!tie_symbolic_operand (operands[2], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern58 (x3, 
E_SImode) != 0
                      || !(
#line 8033 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 484; /* tie_lo10si */

                case E_DImode:
                  if (pattern58 (x3, 
E_DImode) != 0
                      || !(
#line 8033 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 485; /* tie_lo10di */

                default:
                  return -1;
                }

            case 21:
              x6 = XVECEXP (x5, 0, 0);
              operands[2] = x6;
              if (!tle_symbolic_operand (operands[2], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern58 (x3, 
E_SImode) != 0
                      || !(
#line 8081 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 490; /* tle_lox10si */

                case E_DImode:
                  if (pattern58 (x3, 
E_DImode) != 0
                      || !(
#line 8081 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 491; /* tle_lox10di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          if (XINT (x5, 1) != 4)
            return -1;
          x6 = XVECEXP (x5, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x5, 0, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern95 (x3, 
E_SImode) != 0
                  || !
#line 1790 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(flag_pic))
                return -1;
              return 123; /* *movsi_lo_sum_pic_label_ref */

            case E_DImode:
              if (pattern95 (x3, 
E_DImode) != 0
                  || !
#line 1924 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && flag_pic))
                return -1;
              return 127; /* *movdi_lo_sum_pic_label_ref */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FIX:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern57 (x3, 
E_SImode))
            {
            case 0:
              if (!
#line 3662 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 213; /* fix_truncsfsi2 */

            case 1:
              if (!
#line 3670 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 214; /* fix_truncdfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern57 (x3, 
E_DImode))
            {
            case 0:
              if (!
#line 3700 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 216; /* fix_truncsfdi2 */

            case 1:
              if (!
#line 3714 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 217; /* fix_truncdfdi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      switch (pattern4 (x3))
        {
        case 0:
          if (!
#line 3685 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 215; /* *fix_trunctfsi2_hq */

        case 1:
          if (!
#line 3734 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 218; /* *fix_trunctfdi2_hq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case ZERO_EXTEND:
      return recog_35 (x1, insn, pnum_clobbers);

    case AND:
    case IOR:
    case XOR:
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_CODE (x7))
        {
        case AND:
        case IOR:
          res = recog_33 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case AND:
        case IOR:
        case XOR:
          operands[4] = x9;
          operands[3] = x7;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          x11 = XEXP (x7, 1);
          operands[2] = x11;
          x12 = XEXP (x9, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x9, 1);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_CCmode:
              if (pattern146 (x6, 
E_SImode, 
E_CCmode) != 0
                  || !
#line 5544 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_CODE (operands[3]) == GET_CODE (operands[4])))
                return -1;
              return 316; /* *cmp_cc_arith_op_set */

            case E_CCXmode:
              if (pattern146 (x6, 
E_DImode, 
E_CCXmode) != 0
                  || !
#line 5557 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && GET_CODE (operands[3]) == GET_CODE (operands[4])))
                return -1;
              return 317; /* *cmp_ccx_arith_op_set */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      if (GET_CODE (x7) == SUBREG)
        {
          res = recog_34 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x7;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != MINUS)
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XEXP (x9, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_CCCmode:
          if (GET_MODE (x6) != E_CCCmode
              || !register_operand (operands[1], E_DImode)
              || !arith_double_operand (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x9) != E_DImode
              || !
#line 4258 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return -1;
          return 241; /* usubvdi4_sp32 */

        case E_CCmode:
          if (pattern137 (x1, 
E_SImode, 
E_CCmode) != 0)
            return -1;
          return 251; /* *cmpsi_set */

        case E_CCXmode:
          if (pattern137 (x1, 
E_DImode, 
E_CCXmode) != 0
              || !
#line 4473 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 252; /* *cmpdi_set */

        default:
          return -1;
        }

    case PLUS:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          x11 = XEXP (x7, 1);
          operands[2] = x11;
          x12 = XEXP (x9, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x9, 1);
          if (!rtx_equal_p (x13, operands[2]))
            return -1;
          x8 = XEXP (x6, 1);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCCmode:
                  if (GET_MODE (x6) != E_CCCmode)
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_DImode:
                      if (!register_operand (operands[1], E_DImode)
                          || !arith_double_operand (operands[2], E_DImode)
                          || !register_operand (operands[0], E_DImode)
                          || GET_MODE (x9) != E_DImode
                          || !
#line 3844 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                        return -1;
                      return 220; /* uaddvdi4_sp32 */

                    case E_SImode:
                      if (pattern147 (x9, 
E_SImode) != 0)
                        return -1;
                      return 232; /* *cmp_ccc_plus_set */

                    default:
                      return -1;
                    }

                case E_CCXCmode:
                  if (pattern148 (x1, 
E_DImode, 
E_CCXCmode) != 0
                      || !
#line 4073 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 233; /* *cmp_ccxc_plus_set */

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x8, 0) != 2
                  || XINT (x8, 1) != 62)
                return -1;
              x14 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XVECEXP (x8, 0, 1);
              if (!rtx_equal_p (x15, operands[2]))
                return -1;
              switch (pattern145 (x2))
                {
                case 0:
                  if (pattern157 (x1) != 0
                      || !
#line 3882 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                    return -1;
                  return 221; /* addvdi4_sp32 */

                case 1:
                  if (!register_operand (operands[1], E_SImode)
                      || pattern158 (x1, 
E_SImode) != 0)
                    return -1;
                  return 237; /* *cmp_ccv_plus_set */

                case 2:
                  if (!register_operand (operands[1], E_DImode)
                      || pattern158 (x1, 
E_DImode) != 0
                      || !
#line 4136 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 238; /* *cmp_ccxv_plus_set */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x8, 0) != 0L)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCNZmode:
                  if (pattern148 (x1, 
E_SImode, 
E_CCNZmode) != 0)
                    return -1;
                  return 228; /* *cmp_ccnz_plus_set */

                case E_CCXNZmode:
                  if (pattern148 (x1, 
E_DImode, 
E_CCXNZmode) != 0
                      || !
#line 4033 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 229; /* *cmp_ccxnz_plus_set */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (pattern100 (x6, 
E_CCCmode, 
PLUS, 
62) != 0
              || pattern159 (x9, 
E_CCCmode, 
PLUS) != 0
              || pattern161 (x2) != 0)
            return -1;
          x16 = XEXP (x10, 1);
          operands[2] = x16;
          if (!arith_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x9) != E_SImode
              || pattern163 (x1) != 0)
            return -1;
          return 239; /* *cmp_ccv_plus_sltu_set */

        default:
          return -1;
        }

    case MINUS:
      return recog_36 (x1, insn, pnum_clobbers);

    case MULT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != MULT
          || GET_MODE (x9) != E_SImode
          || GET_MODE (x3) != E_CCmode
          || GET_MODE (x6) != E_CCmode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!arith_operand (operands[1], E_SImode)
          || pattern87 (x1) != 0
          || !
#line 4633 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_SPARCLITE || TARGET_DEPRECATED_V8_INSNS))
        return -1;
      return 263; /* *cmp_mul_set */

    case DIV:
      if (pnum_clobbers == NULL
          || pattern88 (x1, 
DIV) != 0
          || !
#line 5240 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_DEPRECATED_V8_INSNS))
        return -1;
      *pnum_clobbers = 1;
      return 294; /* *cmp_sdiv_cc_set */

    case UDIV:
      if (pattern88 (x1, 
UDIV) != 0
          || !
#line 5329 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8 || TARGET_DEPRECATED_V8_INSNS))
        return -1;
      return 298; /* *cmp_udiv_cc_set */

    case NOT:
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case XOR:
          if (XWINT (x8, 0) != 0L)
            return -1;
          x9 = XEXP (x4, 1);
          if (GET_CODE (x9) != NOT)
            return -1;
          x12 = XEXP (x9, 0);
          if (GET_CODE (x12) != XOR)
            return -1;
          x17 = XEXP (x10, 0);
          operands[1] = x17;
          x16 = XEXP (x10, 1);
          operands[2] = x16;
          x18 = XEXP (x12, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          x19 = XEXP (x12, 1);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_CCmode:
              if (pattern150 (x1, 
E_SImode, 
E_CCmode) != 0)
                return -1;
              return 320; /* *cmp_cc_xor_not_set */

            case E_CCXmode:
              if (pattern150 (x1, 
E_DImode, 
E_CCXmode) != 0
                  || !
#line 5601 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 321; /* *cmp_ccx_xor_not_set */

            default:
              return -1;
            }

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x10;
          switch (XWINT (x8, 0))
            {
            case -1L:
              x9 = XEXP (x4, 1);
              if (GET_CODE (x9) != NEG)
                return -1;
              x12 = XEXP (x9, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCCmode:
                  if (GET_MODE (x6) != E_CCCmode)
                    return -1;
                  switch (GET_MODE (x7))
                    {
                    case E_DImode:
                      if (!register_operand (operands[1], E_DImode)
                          || !register_operand (operands[0], E_DImode)
                          || GET_MODE (x9) != E_DImode
                          || !
#line 5734 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                        return -1;
                      return 327; /* unegvdi3_sp32 */

                    case E_SImode:
                      if (!register_operand (operands[1], E_SImode)
                          || !register_operand (operands[0], E_SImode)
                          || GET_MODE (x9) != E_SImode)
                        return -1;
                      return 335; /* *cmp_ccc_neg_set */

                    default:
                      return -1;
                    }

                case E_CCXCmode:
                  if (pattern143 (x1, 
E_DImode, 
E_CCXCmode) != 0
                      || !
#line 5874 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 336; /* *cmp_ccxc_neg_set */

                default:
                  return -1;
                }

            case 0L:
              x9 = XEXP (x4, 1);
              if (GET_CODE (x9) != NOT)
                return -1;
              x12 = XEXP (x9, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCmode:
                  if (pattern144 (x1, 
E_SImode, 
E_CCmode) != 0)
                    return -1;
                  return 347; /* *cmp_cc_set_not */

                case E_CCXmode:
                  if (pattern144 (x1, 
E_DImode, 
E_CCXmode) != 0
                      || !
#line 5990 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 348; /* *cmp_ccx_set_not */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != NEG)
        return -1;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[1] = x10;
          x12 = XEXP (x9, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x8 = XEXP (x6, 1);
          switch (GET_CODE (x8))
            {
            case UNSPEC:
              if (XVECLEN (x8, 0) != 1
                  || XINT (x8, 1) != 64)
                return -1;
              x14 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              switch (pattern145 (x2))
                {
                case 0:
                  if (pattern153 (x1, 
E_DImode) != 0
                      || !
#line 5763 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                    return -1;
                  return 328; /* negvdi3_sp32 */

                case 1:
                  if (pattern153 (x1, 
E_SImode) != 0)
                    return -1;
                  return 340; /* *cmp_ccv_neg_set */

                case 2:
                  if (pattern153 (x1, 
E_DImode) != 0
                      || !
#line 5926 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 341; /* *cmp_ccxv_neg_set */

                default:
                  return -1;
                }

            case CONST_INT:
              if (XWINT (x8, 0) != 0L)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_CCNZmode:
                  if (pattern143 (x1, 
E_SImode, 
E_CCNZmode) != 0)
                    return -1;
                  return 333; /* *cmp_ccnz_neg_set */

                case E_CCXNZmode:
                  if (pattern143 (x1, 
E_DImode, 
E_CCXNZmode) != 0
                      || !
#line 5854 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 334; /* *cmp_ccxnz_neg_set */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          x16 = XEXP (x10, 1);
          if (pattern122 (x16) != 0)
            return -1;
          x8 = XEXP (x6, 1);
          if (pattern123 (x8, 
E_SImode, 
64, 
1) != 0)
            return -1;
          x14 = XVECEXP (x8, 0, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x20 = XEXP (x14, 1);
          if (GET_CODE (x20) != LTU
              || GET_MODE (x20) != E_SImode)
            return -1;
          x21 = XEXP (x20, 0);
          if (GET_CODE (x21) != REG
              || REGNO (x21) != 100
              || GET_MODE (x21) != E_CCCmode)
            return -1;
          x22 = XEXP (x20, 1);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x12 = XEXP (x9, 0);
          if (GET_CODE (x12) != PLUS
              || GET_MODE (x12) != E_SImode)
            return -1;
          x19 = XEXP (x12, 1);
          if (GET_CODE (x19) != LTU
              || GET_MODE (x19) != E_SImode)
            return -1;
          x23 = XEXP (x19, 0);
          if (GET_CODE (x23) != REG
              || REGNO (x23) != 100
              || GET_MODE (x23) != E_CCCmode)
            return -1;
          x24 = XEXP (x19, 1);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern161 (x2) != 0
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x9) != E_SImode)
            return -1;
          x25 = XEXP (x14, 0);
          if (!rtx_equal_p (x25, operands[1]))
            return -1;
          x18 = XEXP (x12, 0);
          if (!rtx_equal_p (x18, operands[1]))
            return -1;
          return 342; /* *cmp_ccv_neg_sltu_set */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x11 = XEXP (x7, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x6, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != ASHIFT
          || GET_MODE (x9) != E_SImode)
        return -1;
      x13 = XEXP (x9, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_MODE (x3) != E_CCNZmode
          || GET_MODE (x6) != E_CCNZmode)
        return -1;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x9, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      return 392; /* *cmp_ccnz_set_ashift_1 */

    default:
      return -1;
    }
}
