/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!icc_register_operand (operands[1], E_VOIDmode))
    return -1;
  return pattern4 (x2); /* [-1, 1] */
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern10 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern10 (x3, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V2HImode:
      if (pattern10 (x3, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V1SImode:
      if (pattern10 (x3, 
E_V1SImode) != 0)
        return -1;
      return 3;

    case E_V8QImode:
      if (pattern10 (x3, 
E_V8QImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern25 (x3, 
E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern25 (x3, 
E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case NE:
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern37 (x1, 
E_SImode); /* [-1, 1] */

        case E_DImode:
          res = pattern37 (x1, 
E_DImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case EQ:
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode)
          || GET_MODE (x3) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || GET_MODE (x7) != E_SImode)
            return -1;
          return 4;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || GET_MODE (x7) != E_DImode)
            return -1;
          return 5;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode
          || GET_MODE (x3) != E_CCmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode)
          || !register_operand (operands[2], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode)
          || !register_operand (operands[2], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern75 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern75 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern89 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode
      || !register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[2], E_SImode)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[2], E_DImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern147 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !arith_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern151 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !register_or_zero_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern159 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != LTU
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern96 (x3, 
E_SImode))
            {
            case 0:
              *pnum_clobbers = 1;
              return 31; /* *plus_snesisi_zero */

            case 1:
              if (!
#line 981 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3))
                return -1;
              *pnum_clobbers = 1;
              return 35; /* *plus_snedisi_zero */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern96 (x3, 
E_DImode))
            {
            case 0:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              *pnum_clobbers = 1;
              return 32; /* *plus_snesidi_zero */

            case 1:
              if (!(
#line 981 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              *pnum_clobbers = 1;
              return 36; /* *plus_snedidi_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case NE:
          if (pnum_clobbers == NULL)
            return -1;
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern115 (x3, 
E_SImode))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 33; /* *plus_plus_snesisi_zero */

                case 1:
                  if (!
#line 997 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3))
                    return -1;
                  *pnum_clobbers = 1;
                  return 37; /* *plus_plus_snedisi_zero */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern115 (x3, 
E_DImode))
                {
                case 0:
                  if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 34; /* *plus_plus_snesidi_zero */

                case 1:
                  if (!(
#line 997 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 38; /* *plus_plus_snedidi_zero */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LTU:
          x8 = XEXP (x6, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x6, 0);
          operands[3] = x9;
          if (!icc_register_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern116 (x3, 
E_SImode) != 0)
                return -1;
              if (arith_operand (operands[2], E_SImode)
                  && 
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode))
                return 55; /* *plus_plus_sltusi */
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3
   && (GET_MODE (operands[3]) == CCXmode || GET_MODE (operands[3]) == CCXCmode)))
                return -1;
              return 68; /* *plus_plus_sltusi_vis3 */

            case E_DImode:
              if (pattern116 (x3, 
E_DImode) != 0)
                return -1;
              if (arith_operand (operands[2], E_DImode)
                  && (
#line 1125 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return 56; /* *plus_plus_sltudi */
              if (!register_operand (operands[2], E_DImode)
                  || !(
#line 1189 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3
   && (GET_MODE (operands[3]) == CCXmode || GET_MODE (operands[3]) == CCXCmode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 69; /* *plus_plus_sltudi_vis3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != LTU)
            return -1;
          x10 = XEXP (x7, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          x11 = XEXP (x7, 0);
          operands[3] = x11;
          if (!icc_register_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern129 (x3, 
E_SImode) != 0)
                return -1;
              if (arith_operand (operands[2], E_SImode)
                  && 
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode))
                return 62; /* *addxsi */
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3
   && (GET_MODE (operands[3]) == CCXmode || GET_MODE (operands[3]) == CCXCmode)))
                return -1;
              return 70; /* *addxcsi */

            case E_DImode:
              if (pattern129 (x3, 
E_DImode) != 0)
                return -1;
              if (arith_operand (operands[2], E_DImode)
                  && (
#line 1161 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return 63; /* *addxdi */
              if (!register_operand (operands[2], E_DImode)
                  || !(
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3
   && (GET_MODE (operands[3]) == CCXmode || GET_MODE (operands[3]) == CCXCmode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 71; /* *addxcdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern109 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 47; /* *plus_seqsisi_zero */

        case E_DImode:
          if (pattern109 (x3, 
E_DImode) != 0
              || !
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          *pnum_clobbers = 1;
          return 48; /* *plus_seqsidi_zero */

        default:
          return -1;
        }

    case LTU:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!icc_register_operand (operands[2], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (pattern17 (x3))
        {
        case 0:
          if (arith_operand (operands[1], E_SImode)
              && 
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
            return 53; /* *plus_sltusi */
          if (!register_operand (operands[1], E_SImode)
              || !
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3
   && (GET_MODE (operands[2]) == CCXmode || GET_MODE (operands[2]) == CCXCmode)))
            return -1;
          return 66; /* *plus_sltusi_vis3 */

        case 1:
          if (arith_operand (operands[1], E_DImode)
              && (
#line 1115 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return 54; /* *plus_sltudi */
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 1178 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3
   && (GET_MODE (operands[2]) == CCXmode || GET_MODE (operands[2]) == CCXCmode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 67; /* *plus_sltudi_vis3 */

        default:
          return -1;
        }

    case GEU:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!icc_register_operand (operands[2], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern97 (x3, 
E_SImode) != 0
              || !
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
            return -1;
          return 85; /* *plus_sgeusi */

        case E_DImode:
          if (pattern97 (x3, 
E_DImode) != 0
              || !(
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 86; /* *plus_sgeudi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x7;
          switch (pattern80 (x3))
            {
            case 0:
              if (pnum_clobbers != NULL
                  && arith_double_operand (operands[2], E_DImode)
                  && 
#line 3816 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                {
                  *pnum_clobbers = 1;
                  return 219; /* adddi3_sp32 */
                }
              if (!arith_add_operand (operands[2], E_DImode)
                  || !
#line 3952 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 224; /* *adddi3_sp64 */

            case 1:
              return 225; /* addsi3 */

            case 2:
              if (!
#line 6026 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 351; /* *addtf3_hq */

            case 3:
              if (!
#line 6034 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 352; /* adddf3 */

            case 4:
              if (!
#line 6043 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 353; /* addsf3 */

            case 5:
              if (!
#line 8588 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 539; /* addv1si3 */

            case 6:
              if (!
#line 8588 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 541; /* addv2si3 */

            case 7:
              if (!
#line 8588 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 543; /* addv2hi3 */

            case 8:
              if (!
#line 8588 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 545; /* addv4hi3 */

            case 9:
              if (!
#line 9271 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B))
                return -1;
              return 746; /* fpadd64_vis */

            case 10:
              if (!
#line 9280 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
                return -1;
              return 748; /* addv8qi3 */

            default:
              return -1;
            }

        case UNSPEC:
          switch (XVECLEN (x7, 0))
            {
            case 2:
              x12 = XVECEXP (x7, 0, 0);
              operands[2] = x12;
              x13 = XVECEXP (x7, 0, 1);
              operands[3] = x13;
              switch (XINT (x7, 1))
                {
                case 17:
                  if (!tgd_symbolic_operand (operands[3], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern110 (x3, 
E_SImode) != 0
                          || !(
#line 7948 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 464; /* tgd_addsi */

                    case E_DImode:
                      if (pattern110 (x3, 
E_DImode) != 0
                          || !(
#line 7948 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                        return -1;
                      return 465; /* tgd_adddi */

                    default:
                      return -1;
                    }

                case 19:
                  if (!tld_symbolic_operand (operands[3], E_VOIDmode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern110 (x3, 
E_SImode) != 0
                          || !(
#line 8018 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 480; /* tldo_addsi */

                    case E_DImode:
                      if (pattern110 (x3, 
E_DImode) != 0
                          || !(
#line 8018 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                        return -1;
                      return 481; /* tldo_adddi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 1:
              if (XINT (x7, 1) != 18)
                return -1;
              x12 = XVECEXP (x7, 0, 0);
              operands[2] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern110 (x3, 
E_SImode) != 0
                      || !(
#line 7982 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 472; /* tldm_addsi */

                case E_DImode:
                  if (pattern110 (x3, 
E_DImode) != 0
                      || !(
#line 7982 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 473; /* tldm_adddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || pattern27 (x3, 
E_SImode, 
E_DImode) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 3932 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
        return -1;
      *pnum_clobbers = 1;
      return 223; /* *adddi3_extend_sp32 */

    case MULT:
      x7 = XEXP (x3, 1);
      operands[3] = x7;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          if (!arith_operand (operands[2], E_SImode)
              || !register_operand (operands[3], E_SImode)
              || !
#line 5351 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_SPARCLET))
            return -1;
          return 299; /* *smacsi */

        case SIGN_EXTEND:
          if (pattern68 (x3, 
SIGN_EXTEND) != 0
              || !
#line 5362 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_SPARCLET))
            return -1;
          return 300; /* *smacdi */

        case ZERO_EXTEND:
          if (pattern68 (x3, 
ZERO_EXTEND) != 0
              || !
#line 5373 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_SPARCLET))
            return -1;
          return 301; /* *umacdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_CONCAT
      || GET_MODE (x3) != E_V8QImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 8)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x9 = XVECEXP (x4, 0, 4);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x10 = XVECEXP (x4, 0, 5);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x11 = XVECEXP (x4, 0, 6);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x12 = XVECEXP (x4, 0, 7);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x13 = XEXP (x1, 0);
  operands[0] = x13;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x14 = XEXP (x3, 0);
  operands[1] = x14;
  if (!register_operand (operands[1], E_V4QImode))
    return -1;
  x15 = XEXP (x3, 1);
  operands[2] = x15;
  if (!register_operand (operands[2], E_V4QImode)
      || !
#line 8709 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
    return -1;
  return 635; /* fpmerge_vis */
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      if (XINT (x3, 1) != 2)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern25 (x3, 
E_SImode) != 0
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return -1;
          return 436; /* probe_stack_rangesi */

        case E_DImode:
          if (pattern25 (x3, 
E_DImode) != 0
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 437; /* probe_stack_rangedi */

        default:
          return -1;
        }

    case 1:
      if (XINT (x3, 1) != 10
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !memory_operand (operands[0], E_SImode)
          || !
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
        return -1;
      return 446; /* stfsr */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case NE:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 100)
        return -1;
      switch (pattern102 (x1))
        {
        case 0:
          return 31; /* *plus_snesisi_zero */

        case 1:
          if (!
#line 981 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3))
            return -1;
          return 35; /* *plus_snedisi_zero */

        case 2:
          if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 32; /* *plus_snesidi_zero */

        case 3:
          if (!(
#line 981 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 36; /* *plus_snedidi_zero */

        default:
          return -1;
        }

    case PLUS:
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != NE)
        return -1;
      x10 = XEXP (x9, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 100)
        return -1;
      switch (pattern113 (x1))
        {
        case 0:
          return 33; /* *plus_plus_snesisi_zero */

        case 1:
          if (!
#line 997 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3))
            return -1;
          return 37; /* *plus_plus_snedisi_zero */

        case 2:
          if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 34; /* *plus_plus_snesidi_zero */

        case 3:
          if (!(
#line 997 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 38; /* *plus_plus_snedidi_zero */

        default:
          return -1;
        }

    case EQ:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (pattern81 (x7) != 0)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x4, 1);
      operands[2] = x11;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern140 (x4, 
E_SImode) != 0)
            return -1;
          return 47; /* *plus_seqsisi_zero */

        case E_DImode:
          if (pattern140 (x4, 
E_DImode) != 0
              || !
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 48; /* *plus_seqsidi_zero */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      operands[1] = x5;
      x11 = XEXP (x4, 1);
      operands[2] = x11;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 100
              || GET_MODE (x8) != E_CCmode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !arith_double_operand (operands[2], E_DImode)
              || !
#line 3816 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return -1;
          return 219; /* adddi3_sp32 */

        case SET:
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != ZERO_EXTRACT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x12 = XEXP (x8, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 102
              || GET_MODE (x12) != E_DImode)
            return -1;
          x13 = XEXP (x8, 1);
          if (GET_CODE (x13) != CONST_INT)
            return -1;
          x14 = XEXP (x8, 2);
          if (GET_CODE (x14) != CONST_INT)
            return -1;
          x15 = XEXP (x7, 1);
          if (GET_MODE (x15) != E_DImode)
            return -1;
          switch (GET_CODE (x15))
            {
            case ZERO_EXTEND:
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != PLUS
                  || GET_MODE (x16) != E_SImode
                  || pattern155 (x1, 
E_SImode) != 0)
                return -1;
              switch (XWINT (x13, 0))
                {
                case 3L:
                  if (XWINT (x14, 0) != 0L
                      || !
#line 8866 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                    return -1;
                  return 651; /* alignaddrsi_vis */

                case 32L:
                  if (XWINT (x14, 0) != 32L
                      || !
#line 9095 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                    return -1;
                  return 711; /* bmasksi_vis */

                default:
                  return -1;
                }

            case PLUS:
              if (pattern151 (x4, 
E_DImode) != 0)
                return -1;
              x16 = XEXP (x15, 0);
              if (!rtx_equal_p (x16, operands[1]))
                return -1;
              x17 = XEXP (x15, 1);
              if (!rtx_equal_p (x17, operands[2]))
                return -1;
              switch (XWINT (x13, 0))
                {
                case 3L:
                  if (XWINT (x14, 0) != 0L
                      || !
#line 8877 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                    return -1;
                  return 652; /* alignaddrdi_vis */

                case 32L:
                  if (XWINT (x14, 0) != 32L
                      || !
#line 9085 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2 && TARGET_ARCH64))
                    return -1;
                  return 710; /* bmaskdi_vis */

                default:
                  return -1;
                }

            case XOR:
              x17 = XEXP (x15, 1);
              if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
                  || XWINT (x13, 0) != 3L
                  || XWINT (x14, 0) != 0L)
                return -1;
              x16 = XEXP (x15, 0);
              if (GET_MODE (x16) != E_DImode)
                return -1;
              switch (GET_CODE (x16))
                {
                case ZERO_EXTEND:
                  x18 = XEXP (x16, 0);
                  if (GET_CODE (x18) != PLUS
                      || GET_MODE (x18) != E_SImode
                      || pattern151 (x4, 
E_SImode) != 0)
                    return -1;
                  x19 = XEXP (x18, 0);
                  if (!rtx_equal_p (x19, operands[1]))
                    return -1;
                  x20 = XEXP (x18, 1);
                  if (!rtx_equal_p (x20, operands[2])
                      || !
#line 8889 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                    return -1;
                  return 653; /* alignaddrlsi_vis */

                case PLUS:
                  if (pattern155 (x1, 
E_DImode) != 0
                      || !
#line 8901 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                    return -1;
                  return 654; /* alignaddrldi_vis */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (pattern81 (x7) != 0
          || pattern103 (x4) != 0
          || !
#line 3932 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
        return -1;
      return 223; /* *adddi3_extend_sp32 */

    default:
      return -1;
    }
}
