/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  return 0;
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 102
      || GET_MODE (x2) != E_DImode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1DImode:
      return pattern25 (x1, 
E_V1DImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern25 (x1, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern25 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern25 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1, rtx_code i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern78 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern90 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], i1)
      || !arith_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern97 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_or_zero_operand (operands[0], i1)
      || !arith_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2
      || !cc_arith_not_operator (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !arith_operand (operands[0], i1)
      || !register_or_zero_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !scratch_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern126 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !arith11_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern135 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern141 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern150 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_or_zero_operand (operands[1], i1)
      || !arith_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x5, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x10, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case MEM:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != PLUS)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 19)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x4, 0, 1);
      operands[3] = x6;
      if (!tld_symbolic_operand (operands[3], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (x2))
        {
        case E_QImode:
          switch (pattern132 (x3, 
E_QImode))
            {
            case 0:
              if (!(
#line 8286 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 517; /* *tldo_stbsi */

            case 1:
              if (!(
#line 8286 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 518; /* *tldo_stbdi */

            default:
              return -1;
            }

        case E_HImode:
          switch (pattern132 (x3, 
E_HImode))
            {
            case 0:
              if (!(
#line 8296 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 519; /* *tldo_sthsi */

            case 1:
              if (!(
#line 8296 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 520; /* *tldo_sthdi */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern132 (x3, 
E_SImode))
            {
            case 0:
              if (!(
#line 8306 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 521; /* *tldo_stwsi */

            case 1:
              if (!(
#line 8306 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 522; /* *tldo_stwdi */

            default:
              return -1;
            }

        case E_DImode:
          if (GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[2], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || !
#line 8316 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 523; /* *tldo_stx_sp64 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x2) != 102
          || GET_MODE (x2) != E_DImode
          || !arith_operand (operands[0], E_DImode))
        return -1;
      if (
#line 8799 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH64))
        return 643; /* *wrgsr_sp64 */
      if (pnum_clobbers == NULL
          || !
#line 8807 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH32))
        return -1;
      *pnum_clobbers = 1;
      return 644; /* wrgsr_v8plus */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          switch (pattern29 (x3))
            {
            case 0:
              if (
#line 5384 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return 302; /* anddi3 */
              break;

            case 1:
              return 303; /* andsi3 */

            case 2:
              if (
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 548; /* andv1si3 */
              break;

            case 3:
              if (
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 551; /* andv2hi3 */
              break;

            case 4:
              if (
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 554; /* andv4qi3 */
              break;

            case 5:
              if (
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 557; /* andv1di3 */
              break;

            case 6:
              if (
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 560; /* andv2si3 */
              break;

            case 7:
              if (
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 563; /* andv4hi3 */
              break;

            case 8:
              if (
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 566; /* andv8qi3 */
              break;

            default:
              break;
            }
          break;

        case NOT:
          switch (pattern54 (x3))
            {
            case 0:
              if (
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 611; /* *and_not2v1si_vis */
              break;

            case 1:
              if (
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 613; /* *and_not2v2hi_vis */
              break;

            case 2:
              if (
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 615; /* *and_not2v4qi_vis */
              break;

            case 3:
              if (
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 617; /* *and_not2v1di_vis */
              break;

            case 4:
              if (
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 619; /* *and_not2v2si_vis */
              break;

            case 5:
              if (
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 621; /* *and_not2v4hi_vis */
              break;

            case 6:
              if (
#line 8644 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return 623; /* *and_not2v8qi_vis */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_SImode
          || pattern99 (x3) != 0)
        return -1;
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode)
          || !
#line 6701 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && (unsigned HOST_WIDE_INT) INTVAL (operands[3]) == 0xffffffff))
        return -1;
      return 401; /* *lshrsi3_extend1 */

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern56 (x3))
        {
        case 0:
          if (!
#line 5410 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 304; /* *and_not_di_sp64 */

        case 1:
          return 305; /* *and_not_si */

        case 2:
          if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 597; /* *and_not1v1si_vis */

        case 3:
          if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 599; /* *and_not1v2hi_vis */

        case 4:
          if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 601; /* *and_not1v4qi_vis */

        case 5:
          if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 603; /* *and_not1v1di_vis */

        case 6:
          if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 605; /* *and_not1v2si_vis */

        case 7:
          if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 607; /* *and_not1v4hi_vis */

        case 8:
          if (!
#line 8635 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 609; /* *and_not1v8qi_vis */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (XINT (x2, 1))
        {
        case 2:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern94 (x2, 
E_SImode) != 0
                  || !(
#line 1598 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(REGNO (operands[0]) == INTVAL (operands[3])) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              *pnum_clobbers = 1;
              return 111; /* load_pcrel_symsi */

            case E_DImode:
              if (pattern94 (x2, 
E_DImode) != 0
                  || !(
#line 1598 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(REGNO (operands[0]) == INTVAL (operands[3])) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              *pnum_clobbers = 1;
              return 112; /* load_pcrel_symdi */

            default:
              return -1;
            }

        case 14:
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!symbolic_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern25 (x2, 
E_SImode) != 0
                  || !
#line 1741 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(flag_pic && check_pic (1)))
                return -1;
              return 121; /* movsi_pic_gotdata_op */

            case E_DImode:
              if (pattern25 (x2, 
E_DImode) != 0
                  || !
#line 1962 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && flag_pic && check_pic (1)))
                return -1;
              return 130; /* movdi_pic_gotdata_op */

            default:
              return -1;
            }

        case 20:
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!tie_symbolic_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern25 (x2, 
E_SImode) != 0
                  || !
#line 8043 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH32))
                return -1;
              return 486; /* tie_ld32 */

            case E_DImode:
              if (pattern25 (x2, 
E_DImode) != 0
                  || !
#line 8055 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
                return -1;
              return 487; /* tie_ld64 */

            default:
              return -1;
            }

        case 24:
          if (GET_MODE (x2) != E_V8QImode)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 102
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_V8QImode)
              || !register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V8QImode)
              || !
#line 8685 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 633; /* fpack32_vis */

        case 31:
          switch (pattern63 (x2))
            {
            case 0:
              if (!
#line 8854 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 647; /* faligndatav1di_vis */

            case 1:
              if (!
#line 8854 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 648; /* faligndatav2si_vis */

            case 2:
              if (!
#line 8854 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 649; /* faligndatav4hi_vis */

            case 3:
              if (!
#line 8854 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 650; /* faligndatav8qi_vis */

            default:
              return -1;
            }

        case 32:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_V8QImode)
              || !register_operand (operands[2], E_V8QImode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!register_operand (operands[3], E_DImode)
              || !
#line 8912 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 655; /* pdist_vis */

        case 50:
          switch (pattern63 (x2))
            {
            case 0:
              if (!
#line 9105 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 712; /* bshufflev1di_vis */

            case 1:
              if (!
#line 9105 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 713; /* bshufflev2si_vis */

            case 2:
              if (!
#line 9105 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 714; /* bshufflev4hi_vis */

            case 3:
              if (!
#line 9105 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS2))
                return -1;
              return 715; /* bshufflev8qi_vis */

            default:
              return -1;
            }

        case 68:
          switch (pattern65 (x2))
            {
            case 0:
              if (!(
#line 9510 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 826; /* fpcmpde8sishl */

            case 1:
              if (!(
#line 9510 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 827; /* fpcmpde16sishl */

            case 2:
              if (!(
#line 9510 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 828; /* fpcmpde32sishl */

            case 3:
              if (!(
#line 9510 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 829; /* fpcmpde8dishl */

            case 4:
              if (!(
#line 9510 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 830; /* fpcmpde16dishl */

            case 5:
              if (!(
#line 9510 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 831; /* fpcmpde32dishl */

            default:
              return -1;
            }

        case 69:
          switch (pattern65 (x2))
            {
            case 0:
              if (!(
#line 9524 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 832; /* fpcmpur8sishl */

            case 1:
              if (!(
#line 9524 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 833; /* fpcmpur16sishl */

            case 2:
              if (!(
#line 9524 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                return -1;
              return 834; /* fpcmpur32sishl */

            case 3:
              if (!(
#line 9524 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 835; /* fpcmpur8dishl */

            case 4:
              if (!(
#line 9524 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 836; /* fpcmpur16dishl */

            case 5:
              if (!(
#line 9524 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4B) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 837; /* fpcmpur32dishl */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (XINT (x2, 1))
        {
        case 9:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 2061 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CM_EMBMEDANY && !flag_pic))
            return -1;
          return 143; /* embmedany_brsum */

        case 3:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          if (
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return 433; /* *frame_blockagesi */
          if (!
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 434; /* *frame_blockagedi */

        case 26:
          if (GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[0], E_V4HImode)
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 8694 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 634; /* fexpand_vis */

        case 16:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && memory_operand (operands[1], E_DImode)
              && 
#line 144 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_ARCH32))
            return 843; /* atomic_loaddi_1 */
          if (!memory_operand (operands[0], E_DImode)
              || !register_or_v9_zero_operand (operands[1], E_DImode)
              || !
#line 172 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_ARCH32))
            return -1;
          return 844; /* atomic_storedi_1 */

        default:
          return -1;
        }

    case 2:
      return recog_6 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) == AND)
    {
      res = recog_32 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[3] = x4;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  switch (GET_CODE (x7))
    {
    case AND:
    case IOR:
      operands[4] = x7;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != NOT)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x11 = XEXP (x8, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XEXP (x7, 1);
      if (!rtx_equal_p (x12, operands[2]))
        return -1;
      x13 = XEXP (x2, 0);
      switch (GET_MODE (x13))
        {
        case E_CCmode:
          if (pattern154 (x1, 
E_SImode, 
E_CCmode) != 0
              || !
#line 5634 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_CODE (operands[3]) == GET_CODE (operands[4])))
            return -1;
          return 324; /* *cmp_cc_arith_op_not_set */

        case E_CCXmode:
          if (pattern154 (x1, 
E_DImode, 
E_CCXmode) != 0
              || !
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && GET_CODE (operands[3]) == GET_CODE (operands[4])))
            return -1;
          return 325; /* *cmp_ccx_arith_op_not_set */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 8)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x5, 0, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern138 (x5, 
E_SImode) != 0)
        return -1;
      if (
#line 216 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_V9 && (SImode != DImode || TARGET_ARCH64)))
        return 845; /* *atomic_compare_and_swapsi_1 */
      if (!
#line 228 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_LEON3))
        return -1;
      return 847; /* atomic_compare_and_swap_leon3_1 */

    case E_DImode:
      if (pattern138 (x5, 
E_DImode) != 0)
        return -1;
      if ((
#line 216 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_V9 && (DImode != DImode || TARGET_ARCH64)) && 
#line 23 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_ARCH64 || TARGET_V8PLUS)))
        return 846; /* *atomic_compare_and_swapdi_1 */
      if (!
#line 249 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(TARGET_V8PLUS))
        return -1;
      return 848; /* *atomic_compare_and_swapdi_v8plus */

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      if (XVECLEN (x1, 0) != 2)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case NE:
          switch (pattern35 (x1))
            {
            case 0:
              return gen_split_1 (insn, operands);

            case 1:
              if (!(
#line 852 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 854 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_7 (insn, operands);

            case 2:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_2 (insn, operands);

            case 3:
              if (!((
#line 852 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 854 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_8 (insn, operands);

            default:
              return NULL;
            }

        case NEG:
          switch (pattern38 (x1))
            {
            case 0:
              return gen_split_3 (insn, operands);

            case 1:
              if (!(
#line 879 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_11 (insn, operands);

            case 2:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_4 (insn, operands);

            case 3:
              if (!((
#line 879 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_12 (insn, operands);

            case 4:
              return gen_split_15 (insn, operands);

            case 5:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_16 (insn, operands);

            case 6:
              if (!(
#line 5714 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 5716 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_80 (insn, operands);

            default:
              return NULL;
            }

        case EQ:
          switch (pattern39 (x1))
            {
            case 0:
              return gen_split_13 (insn, operands);

            case 1:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_14 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 100)
            return NULL;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case NE:
              x8 = XEXP (x7, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              switch (pattern102 (x1))
                {
                case 0:
                  return gen_split_21 (insn, operands);

                case 1:
                  if (!(
#line 981 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                    return NULL;
                  return gen_split_25 (insn, operands);

                case 2:
                  if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return NULL;
                  return gen_split_22 (insn, operands);

                case 3:
                  if (!((
#line 981 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 983 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                    return NULL;
                  return gen_split_26 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              x9 = XEXP (x7, 0);
              if (GET_CODE (x9) != NE)
                return NULL;
              x10 = XEXP (x9, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              switch (pattern113 (x1))
                {
                case 0:
                  return gen_split_23 (insn, operands);

                case 1:
                  if (!(
#line 997 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 999 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                    return NULL;
                  return gen_split_27 (insn, operands);

                case 2:
                  if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return NULL;
                  return gen_split_24 (insn, operands);

                case 3:
                  if (!((
#line 997 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 999 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                    return NULL;
                  return gen_split_28 (insn, operands);

                default:
                  return NULL;
                }

            case EQ:
              x8 = XEXP (x7, 1);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_SImode))
                return NULL;
              x11 = XEXP (x3, 1);
              operands[2] = x11;
              if (GET_MODE (x5) != E_CCmode)
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern140 (x3, 
E_SImode) != 0)
                    return NULL;
                  return gen_split_37 (insn, operands);

                case E_DImode:
                  if (pattern140 (x3, 
E_DImode) != 0
                      || !
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return NULL;
                  return gen_split_38 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_DImode)
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode)
                return NULL;
              x11 = XEXP (x3, 1);
              operands[2] = x11;
              if (!arith_double_operand (operands[2], E_DImode)
                  || GET_MODE (x5) != E_CCmode
                  || !(
#line 3816 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3818 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_66 (insn, operands);

            case ZERO_EXTEND:
              if (GET_MODE (x7) != E_DImode
                  || pattern103 (x3) != 0
                  || GET_MODE (x5) != E_CCmode
                  || !(
#line 3932 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3934 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_70 (insn, operands);

            default:
              return NULL;
            }

        case MINUS:
          switch (pattern46 (x1))
            {
            case 0:
              return gen_split_29 (insn, operands);

            case 1:
              if (!(
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 1047 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_33 (insn, operands);

            case 2:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_30 (insn, operands);

            case 3:
              if (!((
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 1047 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_34 (insn, operands);

            case 4:
              return gen_split_39 (insn, operands);

            case 5:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_40 (insn, operands);

            case 6:
              if (!(
#line 4232 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4234 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_71 (insn, operands);

            case 7:
              if (!(
#line 4347 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4349 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_75 (insn, operands);

            case 8:
              return gen_split_31 (insn, operands);

            case 9:
              if (!(
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 1063 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_35 (insn, operands);

            case 10:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return NULL;
              return gen_split_32 (insn, operands);

            case 11:
              if (!((
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)) && 
#line 1063 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( 1)))
                return NULL;
              return gen_split_36 (insn, operands);

            default:
              return NULL;
            }

        case COMPARE:
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 100)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x5 = XEXP (x4, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_DImode))
            return NULL;
          x12 = XEXP (x4, 1);
          if (GET_MODE (x12) != E_DImode)
            return NULL;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case PLUS:
              if (GET_MODE (x7) != E_DImode
                  || GET_CODE (x12) != PLUS)
                return NULL;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x8 = XEXP (x7, 1);
              operands[2] = x8;
              if (!arith_double_operand (operands[2], E_DImode))
                return NULL;
              x13 = XEXP (x12, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return NULL;
              x14 = XEXP (x12, 1);
              if (!rtx_equal_p (x14, operands[2]))
                return NULL;
              x11 = XEXP (x3, 1);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x11, operands[1])
                      || GET_MODE (x6) != E_CCCmode
                      || GET_MODE (x3) != E_CCCmode
                      || !(
#line 3844 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3846 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                    return NULL;
                  return gen_split_67 (insn, operands);

                case UNSPEC:
                  if (XVECLEN (x11, 0) != 2
                      || XINT (x11, 1) != 62
                      || GET_MODE (x11) != E_DImode
                      || GET_MODE (x6) != E_CCVmode
                      || GET_MODE (x3) != E_CCVmode)
                    return NULL;
                  x15 = XVECEXP (x11, 0, 0);
                  if (!rtx_equal_p (x15, operands[1]))
                    return NULL;
                  x16 = XVECEXP (x11, 0, 1);
                  if (!rtx_equal_p (x16, operands[2])
                      || !(
#line 3882 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 3884 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                    return NULL;
                  return gen_split_68 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_DImode)
                  || GET_CODE (x12) != MINUS
                  || GET_MODE (x6) != E_CCCmode
                  || GET_MODE (x3) != E_CCCmode)
                return NULL;
              x11 = XEXP (x3, 1);
              operands[2] = x11;
              if (!arith_double_operand (operands[2], E_DImode))
                return NULL;
              x13 = XEXP (x12, 0);
              if (!rtx_equal_p (x13, operands[1]))
                return NULL;
              x14 = XEXP (x12, 1);
              if (!rtx_equal_p (x14, operands[2])
                  || !(
#line 4258 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4260 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_72 (insn, operands);

            case MINUS:
              if (GET_MODE (x7) != E_DImode)
                return NULL;
              x11 = XEXP (x3, 1);
              if (pattern123 (x11, 
E_DImode, 
63, 
2) != 0
                  || GET_CODE (x12) != MINUS
                  || GET_MODE (x6) != E_CCVmode
                  || GET_MODE (x3) != E_CCVmode)
                return NULL;
              x9 = XEXP (x7, 0);
              operands[1] = x9;
              if (!register_operand (operands[1], E_DImode))
                return NULL;
              x8 = XEXP (x7, 1);
              operands[2] = x8;
              if (!arith_double_operand (operands[2], E_DImode)
                  || pattern142 (x1) != 0
                  || !(
#line 4298 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_73 (insn, operands);

            case NOT:
              if (GET_MODE (x7) != E_DImode)
                return NULL;
              x11 = XEXP (x3, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
                  || pattern131 (x1, 
E_CCCmode) != 0)
                return NULL;
              x13 = XEXP (x12, 0);
              if (!rtx_equal_p (x13, operands[1])
                  || !(
#line 5734 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 5736 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_81 (insn, operands);

            case NEG:
              if (GET_MODE (x7) != E_DImode)
                return NULL;
              x11 = XEXP (x3, 1);
              if (pattern123 (x11, 
E_DImode, 
64, 
1) != 0
                  || pattern131 (x1, 
E_CCVmode) != 0)
                return NULL;
              x15 = XVECEXP (x11, 0, 0);
              if (!rtx_equal_p (x15, operands[1]))
                return NULL;
              x13 = XEXP (x12, 0);
              if (!rtx_equal_p (x13, operands[1])
                  || !(
#line 5763 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32) && 
#line 5765 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
( reload_completed)))
                return NULL;
              return gen_split_82 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          if (pattern47 (x1) != 0)
            return NULL;
          return gen_split_76 (insn, operands);

        case IOR:
          if (pattern47 (x1) != 0)
            return NULL;
          return gen_split_77 (insn, operands);

        case XOR:
          if (pattern47 (x1) != 0)
            return NULL;
          return gen_split_78 (insn, operands);

        case NOT:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != XOR
              || GET_MODE (x7) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x7, 1);
          operands[2] = x8;
          if (!const_compl_high_operand (operands[2], E_SImode))
            return NULL;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return NULL;
          return gen_split_79 (insn, operands);

        default:
          return NULL;
        }

    case SET:
      return split_1 (x1, insn);

    case EH_RETURN:
      if (!
#line 7194 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(epilogue_completed))
        return NULL;
      return gen_split_87 (insn, operands);

    default:
      return NULL;
    }
}
