/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x2, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  if (!small_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern28 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern28 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_V1SImode:
      if (pattern10 (x1, 
E_V1SImode) != 0)
        return -1;
      return 2;

    case E_V2HImode:
      if (pattern10 (x1, 
E_V2HImode) != 0)
        return -1;
      return 3;

    case E_V4QImode:
      if (pattern10 (x1, 
E_V4QImode) != 0)
        return -1;
      return 4;

    case E_V1DImode:
      if (pattern10 (x1, 
E_V1DImode) != 0)
        return -1;
      return 5;

    case E_V2SImode:
      if (pattern10 (x1, 
E_V2SImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern10 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8QImode:
      if (pattern10 (x1, 
E_V8QImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      x8 = XEXP (x6, 1);
      switch (GET_CODE (x8))
        {
        case NE:
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x7;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              return pattern43 (x1, 
E_SImode); /* [-1, 1] */

            case E_DImode:
              res = pattern43 (x1, 
E_DImode);
              if (res >= 0)
                return res + 2; /* [2, 3] */
              return -1;

            default:
              return -1;
            }

        case EQ:
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x7;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern44 (x6, 
E_SImode) != 0)
                return -1;
              return 4;

            case E_DImode:
              if (pattern44 (x6, 
E_DImode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x8;
          if (!arith_double_operand (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode)
            return -1;
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          return 6;

        case ZERO_EXTEND:
          if (GET_MODE (x8) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode)
            return -1;
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_SImode)
              || GET_MODE (x3) != E_CCmode)
            return -1;
          return 7;

        default:
          return -1;
        }

    case MINUS:
      x11 = XEXP (x7, 1);
      if (GET_CODE (x11) != NE)
        return -1;
      x12 = XEXP (x11, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x7, 0);
      operands[2] = x13;
      x14 = XEXP (x11, 0);
      operands[1] = x14;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          res = pattern45 (x1, 
E_SImode);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case E_DImode:
          res = pattern45 (x1, 
E_DImode);
          if (res >= 0)
            return res + 10; /* [10, 11] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern101 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern101 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  x8 = XEXP (x3, 1);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern112 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern112 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1, machine_mode i1, int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != i3
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern129 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern139 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode
          || !symbolic_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_MODE (x7) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode
          || !symbolic_operand (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_MODE (x7) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_or_zero_operand (operands[1], i1)
      || !register_or_zero_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_CCVmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CCVmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NE:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x4;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern111 (x3, 
E_SImode))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 39; /* *minus_snesisi_zero */

                case 1:
                  if (!
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 43; /* *minus_snedisi_zero */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern111 (x3, 
E_DImode))
                {
                case 0:
                  if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 40; /* *minus_snesidi_zero */

                case 1:
                  if (!(
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 44; /* *minus_snedidi_zero */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case EQ:
          if (pnum_clobbers == NULL)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[2] = x4;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern117 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 49; /* *minus_seqsisi_zero */

            case E_DImode:
              if (pattern117 (x3, 
E_DImode) != 0
                  || !
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              *pnum_clobbers = 1;
              return 50; /* *minus_seqsidi_zero */

            default:
              return -1;
            }

        case GEU:
          switch (pattern59 (x3))
            {
            case 0:
              if (!
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
                return -1;
              return 60; /* *minus_sgeusi */

            case 1:
              if (!(
#line 1151 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 61; /* *minus_sgeudi */

            default:
              return -1;
            }

        case LTU:
          switch (pattern59 (x3))
            {
            case 0:
              if (
#line 1245 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
                return 79; /* *minus_sltusi */
              if (!
#line 1319 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[2]) == CCXmode || GET_MODE (operands[2]) == CCXCmode)))
                return -1;
              return 95; /* *minus_sltusi_subxc */

            case 1:
              if ((
#line 1245 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return 80; /* *minus_sltudi */
              if (!(
#line 1319 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[2]) == CCXmode || GET_MODE (operands[2]) == CCXCmode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 96; /* *minus_sltudi_subxc */

            default:
              return -1;
            }

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          operands[1] = x4;
          switch (pattern80 (x3))
            {
            case 0:
              if (pnum_clobbers != NULL
                  && arith_double_operand (operands[2], E_DImode)
                  && 
#line 4232 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                {
                  *pnum_clobbers = 1;
                  return 240; /* subdi3_sp32 */
                }
              if (!arith_add_operand (operands[2], E_DImode)
                  || !
#line 4366 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 245; /* *subdi3_sp64 */

            case 1:
              return 246; /* subsi3 */

            case 2:
              if (!
#line 6058 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 354; /* *subtf3_hq */

            case 3:
              if (!
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 355; /* subdf3 */

            case 4:
              if (!
#line 6075 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 356; /* subsf3 */

            case 5:
              if (!
#line 8588 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 540; /* subv1si3 */

            case 6:
              if (!
#line 8588 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 542; /* subv2si3 */

            case 7:
              if (!
#line 8588 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 544; /* subv2hi3 */

            case 8:
              if (!
#line 8588 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
                return -1;
              return 546; /* subv4hi3 */

            case 9:
              if (!
#line 9271 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B))
                return -1;
              return 747; /* fpsub64_vis */

            case 10:
              if (!
#line 9280 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
                return -1;
              return 749; /* subv8qi3 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 4347 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 1;
          return 244; /* *subdi3_extend_sp32 */

        default:
          return -1;
        }

    case MINUS:
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case NE:
          if (pnum_clobbers == NULL)
            return -1;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x4, 0);
          operands[2] = x10;
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern118 (x3, 
E_SImode))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 41; /* *minus_minus_snesisi_zero */

                case 1:
                  if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC))
                    return -1;
                  *pnum_clobbers = 1;
                  return 45; /* *minus_minus_snedisi_zero */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern118 (x3, 
E_DImode))
                {
                case 0:
                  if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  *pnum_clobbers = 1;
                  return 42; /* *minus_minus_snesidi_zero */

                case 1:
                  if (!(
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 46; /* *minus_minus_snedidi_zero */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LTU:
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x4, 0);
          operands[1] = x10;
          x11 = XEXP (x8, 0);
          operands[3] = x11;
          if (!icc_register_operand (operands[3], E_VOIDmode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern119 (x3, 
E_SImode) != 0)
                return -1;
              if (arith_operand (operands[2], E_SImode)
                  && 
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode))
                return 81; /* *minus_minus_sltusi */
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[3]) == CCXmode || GET_MODE (operands[3]) == CCXCmode)))
                return -1;
              return 97; /* *minus_minus_sltusi_subxc */

            case E_DImode:
              if (pattern119 (x3, 
E_DImode) != 0)
                return -1;
              if (arith_operand (operands[2], E_DImode)
                  && (
#line 1255 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return 82; /* *minus_minus_sltudi */
              if (!register_operand (operands[2], E_DImode)
                  || !(
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[3]) == CCXmode || GET_MODE (operands[3]) == CCXCmode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 98; /* *minus_minus_sltudi_subxc */

            default:
              return -1;
            }

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x8;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != LTU)
            return -1;
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x4, 0);
          operands[1] = x10;
          x7 = XEXP (x5, 0);
          operands[3] = x7;
          if (!icc_register_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern130 (x3, 
E_SImode) != 0)
                return -1;
              if (arith_operand (operands[2], E_SImode)
                  && 
#line 1281 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode))
                return 87; /* *subxsi */
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[3]) == CCXmode || GET_MODE (operands[3]) == CCXCmode)))
                return -1;
              return 99; /* *subxcsi */

            case E_DImode:
              if (pattern130 (x3, 
E_DImode) != 0)
                return -1;
              if (arith_operand (operands[2], E_DImode)
                  && (
#line 1281 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[3]) == CCmode || GET_MODE (operands[3]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return 88; /* *subxdi */
              if (!register_operand (operands[2], E_DImode)
                  || !(
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[3]) == CCXmode || GET_MODE (operands[3]) == CCXCmode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 100; /* *subxcdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != LTU)
        return -1;
      x12 = XEXP (x10, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x13 = XEXP (x10, 0);
      operands[2] = x13;
      if (!icc_register_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern93 (x3, 
E_SImode) != 0)
            return -1;
          if (arith_operand (operands[1], E_SImode)
              && 
#line 1227 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
            return 75; /* *minus_neg_sltusi */
          if (!register_operand (operands[1], E_SImode)
              || !
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[2]) == CCXmode || GET_MODE (operands[2]) == CCXCmode)))
            return -1;
          return 91; /* *minus_neg_sltusi_subxc */

        case E_DImode:
          if (pattern93 (x3, 
E_DImode) != 0)
            return -1;
          if (arith_operand (operands[1], E_DImode)
              && (
#line 1227 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return 76; /* *minus_neg_sltudi */
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 1299 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[2]) == CCXmode || GET_MODE (operands[2]) == CCXCmode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 92; /* *minus_neg_sltudi_subxc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern33 (x3))
        {
        case 0:
          return 393; /* ashrsi3 */

        case 1:
          if (register_operand (operands[1], E_DImode)
              && 
#line 6648 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return 397; /* *ashrdi3_sp64 */
          if (pnum_clobbers != NULL
              && arith_operand (operands[1], E_DImode)
              && 
#line 6661 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            {
              *pnum_clobbers = 1;
              return 398; /* ashrdi3_v8plus */
            }
          break;

        case 2:
          if (
#line 9234 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return 738; /* vashrv4hi3 */
          break;

        case 3:
          if (
#line 9234 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return 742; /* vashrv2si3 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 4)
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (!small_int_operand (x6, E_SImode))
        return -1;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x7 = XEXP (x5, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          operands[2] = x6;
          if (!
#line 6768 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && (unsigned HOST_WIDE_INT) INTVAL (operands[2]) < 32))
            return -1;
          return 405; /* *sparc.md:6763 */

        case ASHIFTRT:
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (!small_int_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x6;
          if (!
#line 6792 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2]) >= 32
   && (unsigned HOST_WIDE_INT) INTVAL (operands[3]) < 32
   && (unsigned HOST_WIDE_INT) (INTVAL (operands[2]) + INTVAL (operands[3])) < 64))
            return -1;
          return 407; /* *sparc.md:6787 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SUBREG
          || maybe_ne (SUBREG_BYTE (x5), 0)
          || GET_MODE (x5) != E_DImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!small_int_operand (operands[2], E_SImode)
          || !
#line 6607 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && INTVAL (operands[2]) >= 32 && INTVAL (operands[2]) < 64))
        return -1;
      return 395; /* *ashrsi3_extend1 */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern3 (x1, pnum_clobbers))
    {
    case 0:
      *pnum_clobbers = 1;
      return 11; /* *snesisi_zero */

    case 1:
      if (
#line 837 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_VIS3))
        return 15; /* *snedisi_zero */
      if (pnum_clobbers == NULL
          || !
#line 852 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3))
        return -1;
      *pnum_clobbers = 1;
      return 17; /* *snedisi_zero_vis3 */

    case 2:
      if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      *pnum_clobbers = 1;
      return 12; /* *snesidi_zero */

    case 3:
      if ((
#line 837 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return 16; /* *snedidi_zero */
      if (pnum_clobbers == NULL
          || !(
#line 852 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return -1;
      *pnum_clobbers = 1;
      return 18; /* *snedidi_zero_vis3 */

    case 4:
      if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (NE == EQ || NE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
        return -1;
      return 669; /* fpcmpne8si_vis */

    case 5:
      if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (NE == EQ || NE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
        return -1;
      return 673; /* fpcmpne16si_vis */

    case 6:
      if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (NE == EQ || NE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
        return -1;
      return 677; /* fpcmpne32si_vis */

    case 7:
      if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (NE == EQ || NE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return -1;
      return 681; /* fpcmpne8di_vis */

    case 8:
      if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (NE == EQ || NE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return -1;
      return 685; /* fpcmpne16di_vis */

    case 9:
      if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (NE == EQ || NE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
        return -1;
      return 689; /* fpcmpne32di_vis */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case NE:
          switch (pattern35 (x1))
            {
            case 0:
              return 11; /* *snesisi_zero */

            case 1:
              if (!
#line 852 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3))
                return -1;
              return 17; /* *snedisi_zero_vis3 */

            case 2:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 12; /* *snesidi_zero */

            case 3:
              if (!(
#line 852 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 18; /* *snedidi_zero_vis3 */

            default:
              return -1;
            }

        case NEG:
          switch (pattern38 (x1))
            {
            case 0:
              return 13; /* *neg_snesisi_zero */

            case 1:
              if (!
#line 879 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC))
                return -1;
              return 21; /* *neg_snedisi_zero_subxc */

            case 2:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 14; /* *neg_snesidi_zero */

            case 3:
              if (!(
#line 879 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 22; /* *neg_snedidi_zero_subxc */

            case 4:
              return 25; /* *neg_seqsisi_zero */

            case 5:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 26; /* *neg_seqsidi_zero */

            case 6:
              if (!
#line 5714 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                return -1;
              return 326; /* negdi2_sp32 */

            default:
              return -1;
            }

        case EQ:
          switch (pattern39 (x1))
            {
            case 0:
              return 23; /* *seqsisi_zero */

            case 1:
              if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 24; /* *seqsidi_zero */

            default:
              return -1;
            }

        case UNSPEC:
          switch (XVECLEN (x3, 0))
            {
            case 3:
              if (XINT (x3, 1) != 2)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 15)
                return -1;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x7 = XVECEXP (x3, 0, 0);
              operands[1] = x7;
              x8 = XVECEXP (x3, 0, 1);
              operands[2] = x8;
              x9 = XVECEXP (x3, 0, 2);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern134 (x1, 
E_SImode) != 0
                      || !(
#line 1598 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(REGNO (operands[0]) == INTVAL (operands[3])) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                    return -1;
                  return 111; /* load_pcrel_symsi */

                case E_DImode:
                  if (pattern134 (x1, 
E_DImode) != 0
                      || !(
#line 1598 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(REGNO (operands[0]) == INTVAL (operands[3])) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return -1;
                  return 112; /* load_pcrel_symdi */

                default:
                  return -1;
                }

            case 1:
              if (XINT (x3, 1) != 42)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x10 = XEXP (x4, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              x7 = XVECEXP (x3, 0, 0);
              operands[1] = x7;
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern120 (x3, 
E_SImode) != 0
                      || !
#line 8344 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                    return -1;
                  return 524; /* stack_protect_set32 */

                case E_DImode:
                  if (pattern120 (x3, 
E_DImode) != 0
                      || !
#line 8359 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return -1;
                  return 525; /* stack_protect_set64 */

                default:
                  return -1;
                }

            case 2:
              if (XINT (x3, 1) != 43)
                return -1;
              if (pnum_clobbers != NULL
                  && pattern71 (x1) == 0
                  && 
#line 8400 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                {
                  *pnum_clobbers = 1;
                  return 526; /* stack_protect_test32 */
                }
              if (GET_MODE (x3) != E_DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != SET)
                return -1;
              x10 = XEXP (x4, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              x7 = XVECEXP (x3, 0, 0);
              operands[1] = x7;
              if (!memory_operand (operands[1], E_DImode))
                return -1;
              x8 = XVECEXP (x3, 0, 1);
              operands[2] = x8;
              if (!memory_operand (operands[2], E_DImode))
                return -1;
              x5 = XEXP (x4, 0);
              operands[3] = x5;
              if (!scratch_operand (operands[3], E_DImode)
                  || !
#line 8411 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 527; /* stack_protect_test64 */

            default:
              return -1;
            }

        case COMPARE:
          return recog_42 (x1, insn, pnum_clobbers);

        case TRUNCATE:
          if (pattern40 (x3) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          x12 = XEXP (x11, 0);
          x13 = XEXP (x12, 0);
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x11, 1);
          operands[3] = x14;
          if (!small_int_operand (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[4] = x5;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          switch (GET_CODE (x13))
            {
            case SIGN_EXTEND:
              x15 = XEXP (x13, 0);
              operands[1] = x15;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x16 = XEXP (x12, 1);
              switch (GET_CODE (x16))
                {
                case SIGN_EXTEND:
                  if (GET_MODE (x16) != E_DImode)
                    return -1;
                  x17 = XEXP (x16, 0);
                  operands[2] = x17;
                  if (!register_operand (operands[2], E_SImode)
                      || !
#line 4779 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                    return -1;
                  return 270; /* smulsi3_highpart_v8plus */

                case CONST_INT:
                  operands[2] = x16;
                  if (!small_int_operand (operands[2], E_DImode)
                      || !
#line 4810 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                    return -1;
                  return 272; /* const_smulsi3_highpart_v8plus */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              x15 = XEXP (x13, 0);
              operands[1] = x15;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x16 = XEXP (x12, 1);
              switch (GET_CODE (x16))
                {
                case ZERO_EXTEND:
                  if (GET_MODE (x16) != E_DImode)
                    return -1;
                  x17 = XEXP (x16, 0);
                  operands[2] = x17;
                  if (!register_operand (operands[2], E_SImode)
                      || !
#line 4981 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                    return -1;
                  return 281; /* umulsi3_highpart_v8plus */

                case CONST_INT:
                  operands[2] = x16;
                  if (!uns_small_int_operand (operands[2], E_DImode)
                      || !
#line 4996 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
                    return -1;
                  return 282; /* const_umulsi3_highpart_v8plus */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case DIV:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x3, 1);
          operands[2] = x18;
          if (!input_operand (operands[2], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x4))
            {
            case CLOBBER:
              x5 = XEXP (x4, 0);
              operands[3] = x5;
              if (!scratch_operand (operands[3], E_SImode)
                  || !
#line 5183 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((TARGET_V8 || TARGET_DEPRECATED_V8_INSNS) && TARGET_ARCH32))
                return -1;
              return 291; /* divsi3_sp32 */

            case USE:
              x5 = XEXP (x4, 0);
              operands[3] = x5;
              if (!register_operand (operands[3], E_SImode)
                  || !
#line 5219 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_DEPRECATED_V8_INSNS && TARGET_ARCH64))
                return -1;
              return 292; /* divsi3_sp64 */

            default:
              return -1;
            }

        case ASHIFT:
          if (pattern41 (x1) != 0
              || !
#line 6548 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 390; /* ashldi3_v8plus */

        case ASHIFTRT:
          if (pattern41 (x1) != 0
              || !
#line 6661 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 398; /* ashrdi3_v8plus */

        case LSHIFTRT:
          if (pattern41 (x1) != 0
              || !
#line 6756 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          return 404; /* lshrdi3_v8plus */

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          switch (GET_CODE (x3))
            {
            case PLUS:
              res = recog_37 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case MINUS:
              switch (pattern46 (x1))
                {
                case 0:
                  return 39; /* *minus_snesisi_zero */

                case 1:
                  if (
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC))
                    return 43; /* *minus_snedisi_zero */
                  break;

                case 2:
                  if (
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return 40; /* *minus_snesidi_zero */
                  break;

                case 3:
                  if ((
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return 44; /* *minus_snedidi_zero */
                  break;

                case 4:
                  return 49; /* *minus_seqsisi_zero */

                case 5:
                  if (
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return 50; /* *minus_seqsidi_zero */
                  break;

                case 6:
                  if (
#line 4232 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                    return 240; /* subdi3_sp32 */
                  break;

                case 7:
                  if (
#line 4347 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                    return 244; /* *subdi3_extend_sp32 */
                  break;

                case 8:
                  return 41; /* *minus_minus_snesisi_zero */

                case 9:
                  if (
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC))
                    return 45; /* *minus_minus_snedisi_zero */
                  break;

                case 10:
                  if (
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                    return 42; /* *minus_minus_snesidi_zero */
                  break;

                case 11:
                  if ((
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                    return 46; /* *minus_minus_snedidi_zero */
                  break;

                default:
                  break;
                }
              break;

            case MULT:
              res = recog_38 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CONST_INT:
            case REG:
            case SUBREG:
              x6 = XEXP (x2, 0);
              operands[0] = x6;
              res = recog_40 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              operands[0] = x3;
              if (arith_operand (operands[0], E_DImode)
                  && pattern72 (x1, 
CLOBBER, 
E_DImode, 
102) == 0)
                {
                  x4 = XVECEXP (x1, 0, 1);
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (scratch_operand (operands[1], E_SImode)
                      && 
#line 8807 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH32))
                    return 644; /* wrgsr_v8plus */
                }
              if (GET_CODE (x3) == REG
                  && REGNO (x3) == 102
                  && GET_MODE (x3) == E_DImode)
                {
                  x4 = XVECEXP (x1, 0, 1);
                  if (GET_CODE (x4) == CLOBBER)
                    {
                      operands[0] = x6;
                      if (register_operand (operands[0], E_DImode))
                        {
                          x5 = XEXP (x4, 0);
                          operands[1] = x5;
                          if (scratch_operand (operands[1], E_SImode)
                              && 
#line 8839 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS && TARGET_ARCH32))
                            return 646; /* rdgsr_v8plus */
                        }
                    }
                }
              break;

            case MEM:
              res = recog_41 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[0] = x3;
          x6 = XEXP (x2, 0);
          if (GET_CODE (x6) != PC)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != USE)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != LABEL_REF)
            return -1;
          x19 = XEXP (x5, 0);
          operands[1] = x19;
          if (address_operand (operands[0], E_SImode)
              && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return 411; /* *tablejumpsi */
          if (!address_operand (operands[0], E_DImode)
              || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 412; /* *tablejumpdi */

        case CALL:
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x12 = XEXP (x11, 0);
          switch (GET_CODE (x12))
            {
            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_POLY_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
            case LABEL_REF:
            case SYMBOL_REF:
            case PLUS:
            case MINUS:
            case MULT:
            case AND:
            case SIGN_EXTEND:
            case ZERO_EXTEND:
            case HIGH:
              operands[1] = x12;
              x18 = XEXP (x3, 1);
              operands[2] = x18;
              x4 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x4))
                {
                case CLOBBER:
                  x5 = XEXP (x4, 0);
                  if (GET_CODE (x5) != REG
                      || REGNO (x5) != 15)
                    return -1;
                  switch (GET_MODE (x11))
                    {
                    case E_SImode:
                      if (GET_MODE (x5) != E_SImode)
                        return -1;
                      if (address_operand (operands[1], E_SImode)
                          && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                        return 421; /* *call_value_addresssi */
                      if (!symbolic_operand (operands[1], E_SImode)
                          || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                        return -1;
                      return 423; /* *call_value_symbolicsi */

                    case E_DImode:
                      if (GET_MODE (x5) != E_DImode)
                        return -1;
                      if (address_operand (operands[1], E_DImode)
                          && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                        return 422; /* *call_value_addressdi */
                      if (!symbolic_operand (operands[1], E_DImode)
                          || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                        return -1;
                      return 424; /* *call_value_symbolicdi */

                    default:
                      return -1;
                    }

                case RETURN:
                  switch (GET_MODE (x11))
                    {
                    case E_SImode:
                      if (!symbolic_operand (operands[1], E_SImode)
                          || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                        return -1;
                      return 427; /* *sibcall_value_symbolicsi */

                    case E_DImode:
                      if (!symbolic_operand (operands[1], E_DImode)
                          || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                        return -1;
                      return 428; /* *sibcall_value_symbolicdi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case UNSPEC:
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return -1;
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 15
                  || !register_operand (operands[0], E_VOIDmode))
                return -1;
              switch (XVECLEN (x12, 0))
                {
                case 2:
                  if (XINT (x12, 1) != 17)
                    return -1;
                  x20 = XVECEXP (x12, 0, 0);
                  operands[1] = x20;
                  x21 = XVECEXP (x12, 0, 1);
                  operands[2] = x21;
                  if (!tgd_symbolic_operand (operands[2], E_VOIDmode))
                    return -1;
                  x18 = XEXP (x3, 1);
                  operands[3] = x18;
                  switch (pattern139 (x1))
                    {
                    case 0:
                      if (!(
#line 7958 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 466; /* tgd_callsi */

                    case 1:
                      if (!(
#line 7958 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                        return -1;
                      return 467; /* tgd_calldi */

                    default:
                      return -1;
                    }

                case 1:
                  if (XINT (x12, 1) != 18)
                    return -1;
                  x20 = XVECEXP (x12, 0, 0);
                  operands[1] = x20;
                  x18 = XEXP (x3, 1);
                  operands[2] = x18;
                  switch (pattern139 (x1))
                    {
                    case 0:
                      if (!(
#line 7991 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
                        return -1;
                      return 474; /* tldm_callsi */

                    case 1:
                      if (!(
#line 7991 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                        return -1;
                      return 475; /* tldm_calldi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case POPCOUNT:
          if (pattern42 (x1) != 0
              || !
#line 7509 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH32))
            return -1;
          return 448; /* popcountdi_v8plus */

        case CLZ:
          if (pattern42 (x1) != 0
              || !
#line 7576 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
            return -1;
          return 452; /* clzdi_v8plus */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x3, 0) != 1)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return -1;
          x6 = XEXP (x2, 0);
          operands[0] = x6;
          x7 = XVECEXP (x3, 0, 0);
          operands[1] = x7;
          x5 = XEXP (x4, 0);
          if (!rtx_equal_p (x5, operands[1]))
            return -1;
          switch (XINT (x3, 1))
            {
            case 7:
              if (GET_MODE (x3) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || !memory_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 286 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
((TARGET_V8 || TARGET_V9) && !sparc_fix_ut699))
                return -1;
              return 849; /* swapsi */

            case 6:
              if (GET_MODE (x3) != E_QImode)
                return -1;
              x10 = XEXP (x4, 1);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + -1]
                  || !register_operand (operands[0], E_QImode)
                  || !memory_operand (operands[1], E_QImode)
                  || !
#line 325 "../../gcc-15.0.1-20250313/gcc/config/sparc/sync.md"
(!sparc_fix_ut699))
                return -1;
              return 850; /* ldstub */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM)
        return -1;
      x22 = XEXP (x6, 0);
      operands[0] = x22;
      x3 = XEXP (x2, 1);
      operands[1] = x3;
      x4 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x4))
        {
        case CLOBBER:
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 15)
            return -1;
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (GET_MODE (x5) != E_SImode)
                return -1;
              if (address_operand (operands[0], E_SImode)
                  && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                return 413; /* *call_addresssi */
              if (!symbolic_operand (operands[0], E_SImode)
                  || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                return -1;
              return 415; /* *call_symbolicsi */

            case E_DImode:
              if (GET_MODE (x5) != E_DImode)
                return -1;
              if (address_operand (operands[0], E_DImode)
                  && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return 414; /* *call_addressdi */
              if (!symbolic_operand (operands[0], E_DImode)
                  || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 416; /* *call_symbolicdi */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x4;
          if (!immediate_operand (operands[2], E_VOIDmode)
              || GET_MODE (x6) != E_SImode)
            return -1;
          if (address_operand (operands[0], E_SImode)
              && 
#line 6970 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) > 0))
            {
              *pnum_clobbers = 1;
              return 417; /* *call_address_struct_value_sp32 */
            }
          if (symbolic_operand (operands[0], E_SImode)
              && 
#line 6986 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) > 0))
            {
              *pnum_clobbers = 1;
              return 418; /* *call_symbolic_struct_value_sp32 */
            }
          if (address_operand (operands[0], E_SImode)
              && 
#line 7002 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) < 0))
            {
              *pnum_clobbers = 1;
              return 419; /* *call_address_untyped_struct_value_sp32 */
            }
          if (!symbolic_operand (operands[0], E_SImode)
              || !
#line 7015 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32 && GET_CODE (operands[2]) == CONST_INT && INTVAL (operands[2]) < 0))
            return -1;
          *pnum_clobbers = 1;
          return 420; /* *call_symbolic_untyped_struct_value_sp32 */

        case RETURN:
          switch (GET_MODE (x6))
            {
            case E_SImode:
              if (!symbolic_operand (operands[0], E_SImode)
                  || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
                return -1;
              return 425; /* *sibcall_symbolicsi */

            case E_DImode:
              if (!symbolic_operand (operands[0], E_DImode)
                  || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
                return -1;
              return 426; /* *sibcall_symbolicdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}
