/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern16 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern15 (x1, pnum_clobbers, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern15 (x1, pnum_clobbers, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  return pattern36 (x6); /* [-1, 1] */
}

int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!arith_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[3] = x2;
  if (!imm2_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern64 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern64 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!text_segment_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern93 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern100 (rtx x1, machine_mode i1, rtx_code i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != LTU
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 2
      || XINT (x7, 1) != i3
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (GET_CODE (x8) != i2
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XVECEXP (x7, 0, 1);
  if (GET_CODE (x9) != LTU
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 100
      || GET_MODE (x10) != i1)
    return -1;
  x11 = XEXP (x9, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != LTU
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CCCmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern130 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_or_zero_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern140 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern148 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  return pattern147 (x6, 
i1); /* [-1, 0] */
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_DImode)
      || !arith_double_operand (operands[2], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != E_DImode)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (icc_comparison_operator (operands[0], E_VOIDmode))
    {
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) == REG
          && REGNO (x4) == 100)
        {
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) == PC)
            {
              x6 = XEXP (x2, 1);
              switch (GET_CODE (x6))
                {
                case LABEL_REF:
                  x7 = XEXP (x2, 2);
                  if (GET_CODE (x7) == PC)
                    {
                      x8 = XEXP (x6, 0);
                      operands[1] = x8;
                      return 101; /* *normal_branch */
                    }
                  break;

                case PC:
                  x7 = XEXP (x2, 2);
                  if (GET_CODE (x7) == LABEL_REF)
                    {
                      x9 = XEXP (x7, 0);
                      operands[1] = x9;
                      return 102; /* *inverted_branch */
                    }
                  break;

                default:
                  break;
                }
            }
        }
    }
  if (!v9_register_comparison_operator (operands[0], E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x2, 2);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x9 = XEXP (x7, 0);
  operands[2] = x9;
  if (!
#line 1573 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
    return -1;
  return 110; /* *inverted_int_branch_sp64 */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern60 (x3))
        {
        case 0:
          if (memory_operand (operands[1], E_HImode))
            return 174; /* *zero_extendhisi2_insn */
          if (input_operand (operands[1], E_QImode)
              && 
#line 3066 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_CODE (operands[1]) != CONST_INT))
            return 176; /* *zero_extendqisi2_insn */
          break;

        case 1:
          if (input_operand (operands[1], E_QImode)
              && 
#line 3049 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_CODE (operands[1]) != CONST_INT))
            return 175; /* *zero_extendqihi2_insn */
          break;

        case 2:
          if (input_operand (operands[1], E_QImode)
              && 
#line 3083 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && GET_CODE (operands[1]) != CONST_INT))
            return 177; /* *zero_extendqidi2_insn */
          if (memory_operand (operands[1], E_HImode)
              && 
#line 3117 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return 178; /* *zero_extendhidi2_insn */
          if (input_operand (operands[1], E_SImode)
              && 
#line 3134 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && GET_CODE (operands[1]) != CONST_INT))
            return 179; /* *zero_extendsidi2_insn_sp64 */
          if (register_operand (operands[1], E_SImode)
              && 
#line 3147 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            return 180; /* *zero_extendsidi2_insn_sp32 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != MEM)
        return -1;
      switch (pattern62 (x3))
        {
        case 0:
          if (!(
#line 8104 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 494; /* *tldo_ldub1si */

        case 1:
          if (!(
#line 8104 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 495; /* *tldo_ldub1di */

        case 2:
          if (!(
#line 8117 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 496; /* *tldo_ldub2si */

        case 3:
          if (!(
#line 8117 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 497; /* *tldo_ldub2di */

        case 4:
          if (!(
#line 8191 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 506; /* *tldo_lduh1si */

        case 5:
          if (!(
#line 8191 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 507; /* *tldo_lduh1di */

        case 6:
          if (!
#line 8154 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 502; /* *tldo_ldub3_sp64 */

        case 7:
          if (!
#line 8216 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 510; /* *tldo_lduh2_sp64 */

        case 8:
          if (!
#line 8252 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_TLS && TARGET_ARCH64))
            return -1;
          return 514; /* *tldo_lduw1_sp64 */

        default:
          return -1;
        }

    case PLUS:
      if (pattern51 (x4, 
PLUS) != 0
          || pattern99 (x3) != 0
          || !
#line 3917 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
        return -1;
      return 222; /* *addx_extend_sp32 */

    case MINUS:
      if (pattern51 (x4, 
MINUS) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_or_zero_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!arith_operand (operands[2], E_SImode)
          || !
#line 4332 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
        return -1;
      return 243; /* *subx_extend_sp32 */

    case LSHIFTRT:
      if (pattern50 (x3) != 0
          || !
#line 6685 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 400; /* *lshrsi3_extend0 */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
      switch (pattern16 (x3, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 13; /* *neg_snesisi_zero */

        case 1:
          if (
#line 864 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_SUBXC))
            return 19; /* *neg_snedisi_zero */
          if (pnum_clobbers == NULL
              || !
#line 879 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC))
            return -1;
          *pnum_clobbers = 1;
          return 21; /* *neg_snedisi_zero_subxc */

        case 2:
          if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          *pnum_clobbers = 1;
          return 14; /* *neg_snesidi_zero */

        case 3:
          if ((
#line 864 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && !TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return 20; /* *neg_snedidi_zero */
          if (pnum_clobbers == NULL
              || !(
#line 879 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          *pnum_clobbers = 1;
          return 22; /* *neg_snedidi_zero_subxc */

        default:
          return -1;
        }

    case EQ:
      switch (pattern16 (x3, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 25; /* *neg_seqsisi_zero */

        case 1:
          if (!
#line 931 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 29; /* *neg_seqdisi_zero */

        case 2:
          if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          *pnum_clobbers = 1;
          return 26; /* *neg_seqsidi_zero */

        case 3:
          if (!
#line 931 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 30; /* *neg_seqdidi_zero */

        default:
          return -1;
        }

    case GEU:
      switch (pattern18 (x3))
        {
        case 0:
          if (!
#line 1133 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
            return -1;
          return 57; /* *neg_sgeusi */

        case 1:
          if (!(
#line 1133 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 58; /* *neg_sgeudi */

        default:
          return -1;
        }

    case LTU:
      switch (pattern18 (x3))
        {
        case 0:
          if (
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
            return 72; /* *neg_sltusi */
          if (!
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[1]) == CCXmode || GET_MODE (operands[1]) == CCXCmode)))
            return -1;
          return 89; /* *neg_sltusi_subxc */

        case 1:
          if ((
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return 73; /* *neg_sltudi */
          if (!(
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[1]) == CCXmode || GET_MODE (operands[1]) == CCXCmode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 90; /* *neg_sltudi_subxc */

        default:
          return -1;
        }

    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case LTU:
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!icc_register_operand (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern93 (x3, 
E_SImode) != 0)
                return -1;
              if (arith_operand (operands[1], E_SImode)
                  && 
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode))
                return 77; /* *neg_plus_sltusi */
              if (!register_operand (operands[1], E_SImode)
                  || !
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[2]) == CCXmode || GET_MODE (operands[2]) == CCXCmode)))
                return -1;
              return 93; /* *neg_plus_sltusi_subxc */

            case E_DImode:
              if (pattern93 (x3, 
E_DImode) != 0)
                return -1;
              if (arith_operand (operands[1], E_DImode)
                  && (
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[2]) == CCmode || GET_MODE (operands[2]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return 78; /* *neg_plus_sltudi */
              if (!register_operand (operands[1], E_DImode)
                  || !(
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_SUBXC
   && (GET_MODE (operands[2]) == CCXmode || GET_MODE (operands[2]) == CCXCmode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
                return -1;
              return 94; /* *neg_plus_sltudi_subxc */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern30 (x3, 
E_SFmode) != 0
                  || !
#line 9363 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 776; /* *naddsf3 */

            case E_DFmode:
              if (pattern30 (x3, 
E_DFmode) != 0
                  || !
#line 9371 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
                return -1;
              return 777; /* *nadddf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (pnum_clobbers != NULL
              && 
#line 5714 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
            {
              *pnum_clobbers = 1;
              return 326; /* negdi2_sp32 */
            }
          if (!
#line 5789 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 329; /* *negdi2_sp64 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 330; /* negsi2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if (
#line 6259 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return 374; /* *negtf2_hq */
          if (!
#line 6266 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD))
            return -1;
          return 375; /* *negtf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 6307 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9))
            return 376; /* *negdf2_notv9 */
          if (!
#line 6342 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_V9))
            return -1;
          return 377; /* *negdf2_v9 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 6350 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 378; /* negsf2 */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x9 = XEXP (x4, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern82 (x3, 
E_DFmode) != 0
                  || !
#line 6134 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 362; /* *nfmadf4 */

            case E_SFmode:
              if (pattern82 (x3, 
E_SFmode) != 0
                  || !
#line 6170 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 366; /* *nfmasf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern83 (x3, 
E_DFmode) != 0
                  || !
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 363; /* *nfmsdf4 */

            case E_SFmode:
              if (pattern83 (x3, 
E_SFmode) != 0
                  || !
#line 6179 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 367; /* *nfmssf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 56)
        return -1;
      x11 = XVECEXP (x4, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x4, 0, 1);
      operands[2] = x12;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern84 (x3, 
E_SFmode) != 0
              || !
#line 9447 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 785; /* fnhaddsf_vis */

        case E_DFmode:
          if (pattern84 (x3, 
E_DFmode) != 0
              || !
#line 9456 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 786; /* fnhadddf_vis */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (pattern33 (x3))
    {
    case 0:
      return 399; /* lshrsi3 */

    case 1:
      if (register_operand (operands[1], E_DImode)
          && 
#line 6743 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return 403; /* *lshrdi3_sp64 */
      if (pnum_clobbers != NULL
          && arith_operand (operands[1], E_DImode)
          && 
#line 6756 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
        {
          *pnum_clobbers = 1;
          return 404; /* lshrdi3_v8plus */
        }
      break;

    case 2:
      if (
#line 9234 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
        return 737; /* vlshrv4hi3 */
      break;

    case 3:
      if (
#line 9234 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
        return 741; /* vlshrv2si3 */
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_SImode)
      || GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode
      || GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (!small_int_operand (x6, E_SImode))
    return -1;
  switch (GET_CODE (x5))
    {
    case ASHIFTRT:
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      operands[2] = x6;
      if (!
#line 6780 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && (unsigned HOST_WIDE_INT) INTVAL (operands[2]) < 32))
        return -1;
      return 406; /* *sparc.md:6775 */

    case LSHIFTRT:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!small_int_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x6;
      if (!
#line 6808 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64
   && (unsigned HOST_WIDE_INT) INTVAL (operands[2]) >= 32
   && (unsigned HOST_WIDE_INT) INTVAL (operands[3]) < 32
   && (unsigned HOST_WIDE_INT) (INTVAL (operands[2]) + INTVAL (operands[3])) < 64))
        return -1;
      return 408; /* *sparc.md:6803 */

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != SUBREG
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_MODE (x7) != E_CCmode
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x10 = XEXP (x6, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  switch (SUBREG_BYTE (x8))
    {
    case 3:
      if (maybe_ne (SUBREG_BYTE (x6), 3)
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 190; /* *cmp_siqi_trunc_set */

    case 7:
      if (maybe_ne (SUBREG_BYTE (x6), 7)
          || !register_operand (operands[1], E_DImode)
          || !
#line 3266 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 192; /* *cmp_diqi_trunc_set */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 4)
      || pattern40 (x3) != 0)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (pattern135 (x5, 
E_DImode, 
SIGN_EXTEND) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x5, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x5, 1);
  x10 = XEXP (x9, 0);
  operands[2] = x10;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x11 = XEXP (x4, 1);
  operands[3] = x11;
  if (!small_int_operand (operands[3], E_SImode))
    return -1;
  x12 = XEXP (x6, 0);
  operands[4] = x12;
  if (!scratch_operand (operands[4], E_SImode)
      || !
#line 4795 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
    return -1;
  return 271; /* *sparc.md:4787 */
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case COMPARE:
      return recog_16 (x1, insn, pnum_clobbers);

    case NE:
      return recog_29 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_18 (x1, insn, pnum_clobbers);

    case EQ:
      switch (pattern3 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 23; /* *seqsisi_zero */

        case 1:
          if (!
#line 917 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 27; /* *seqdisi_zero */

        case 2:
          if (!
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          *pnum_clobbers = 1;
          return 24; /* *seqsidi_zero */

        case 3:
          if (!
#line 917 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 28; /* *seqdidi_zero */

        case 4:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 668; /* fpcmpeq8si_vis */

        case 5:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 672; /* fpcmpeq16si_vis */

        case 6:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 676; /* fpcmpeq32si_vis */

        case 7:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 680; /* fpcmpeq8di_vis */

        case 8:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 684; /* fpcmpeq16di_vis */

        case 9:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (EQ == EQ || EQ == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 688; /* fpcmpeq32di_vis */

        default:
          return -1;
        }

    case LTU:
      switch (pattern5 (x1))
        {
        case 0:
          if (
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
            return 51; /* *sltusi_insn */
          if (!
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3
   && (GET_MODE (operands[1]) == CCXmode || GET_MODE (operands[1]) == CCXCmode)))
            return -1;
          return 64; /* *sltusi_insn_vis3 */

        case 1:
          if ((
#line 1106 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return 52; /* *sltudi_insn */
          if (!(
#line 1168 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && TARGET_VIS3
   && (GET_MODE (operands[1]) == CCXmode || GET_MODE (operands[1]) == CCXCmode)) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 65; /* *sltudi_insn_vis3 */

        default:
          return -1;
        }

    case GEU:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode))
            return -1;
          return 83; /* *sgeusi_insn */

        case 1:
          if (!(
#line 1262 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(GET_MODE (operands[1]) == CCmode || GET_MODE (operands[1]) == CCCmode) && 
#line 215 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 84; /* *sgeudi_insn */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_27 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_19 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_22 (x1, insn, pnum_clobbers);

    case LO_SUM:
      return recog_20 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 3503 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 201; /* extendsfdf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x2) != E_TFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode)
                  || !
#line 3517 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 202; /* *extendsftf2_hq */

            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 3530 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 203; /* *extenddftf2_hq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 3537 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 204; /* truncdfsf2 */

            case E_TFmode:
              if (!register_operand (operands[1], E_TFmode)
                  || !
#line 3552 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 205; /* *trunctfsf2_hq */

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || !
#line 3565 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 206; /* *trunctfdf2_hq */

        default:
          return -1;
        }

    case FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          switch (pattern49 (x2, 
E_SFmode))
            {
            case 0:
              if (!
#line 3575 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 207; /* floatsisf2 */

            case 1:
              if (!
#line 3612 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 210; /* floatdisf2 */

            default:
              return -1;
            }

        case E_DFmode:
          switch (pattern49 (x2, 
E_DFmode))
            {
            case 0:
              if (!
#line 3583 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
                return -1;
              return 208; /* floatsidf2 */

            case 1:
              if (!
#line 3626 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU))
                return -1;
              return 211; /* floatdidf2 */

            default:
              return -1;
            }

        case E_TFmode:
          switch (pattern49 (x2, 
E_TFmode))
            {
            case 0:
              if (!
#line 3597 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 209; /* *floatsitf2_hq */

            case 1:
              if (!
#line 3646 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V9 && TARGET_FPU && TARGET_HARD_QUAD))
                return -1;
              return 212; /* *floatditf2_hq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FIX:
      return recog_31 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_17 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_28 (x1, insn, pnum_clobbers);

    case UDIV:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode)
              || !input_operand (operands[2], E_SImode))
            return -1;
          if (
#line 5270 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
((TARGET_V8 || TARGET_DEPRECATED_V8_INSNS) && TARGET_ARCH32))
            return 295; /* udivsi3_sp32 */
          if (!
#line 5309 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_DEPRECATED_V8_INSNS && TARGET_ARCH64))
            return -1;
          return 296; /* udivsi3_sp64 */

        case E_DImode:
          if (pattern32 (x2, 
E_DImode) != 0
              || !
#line 5318 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 297; /* udivdi3 */

        default:
          return -1;
        }

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern29 (x2))
        {
        case 0:
          if (!
#line 5464 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return -1;
          return 310; /* xordi3 */

        case 1:
          return 311; /* xorsi3 */

        case 2:
          if (!
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 549; /* xorv1si3 */

        case 3:
          if (!
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 552; /* xorv2hi3 */

        case 4:
          if (!
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 555; /* xorv4qi3 */

        case 5:
          if (!
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 558; /* xorv1di3 */

        case 6:
          if (!
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 561; /* xorv2si3 */

        case 7:
          if (!
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 564; /* xorv4hi3 */

        case 8:
          if (!
#line 8605 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS))
            return -1;
          return 567; /* xorv8qi3 */

        default:
          return -1;
        }

    case NOT:
      return recog_21 (x1, insn, pnum_clobbers);

    case FMA:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = XEXP (x2, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern78 (x2, 
E_DFmode) != 0
                  || !
#line 6116 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 360; /* fmadf4 */

            case E_SFmode:
              if (pattern78 (x2, 
E_SFmode) != 0
                  || !
#line 6152 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 364; /* fmasf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern79 (x2, 
E_DFmode) != 0
                  || !
#line 6125 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 361; /* fmsdf4 */

            case E_SFmode:
              if (pattern79 (x2, 
E_SFmode) != 0
                  || !
#line 6161 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FMAF))
                return -1;
              return 365; /* fmssf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      switch (pattern6 (x1))
        {
        case 0:
          if (
#line 6363 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return 379; /* *abstf2_hq */
          if (!
#line 6370 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_HARD_QUAD))
            return -1;
          return 380; /* *abstf2 */

        case 1:
          if (
#line 6411 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !TARGET_V9))
            return 381; /* *absdf2_notv9 */
          if (!
#line 6446 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_V9))
            return -1;
          return 382; /* *absdf2_v9 */

        case 2:
          if (!
#line 6454 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU))
            return -1;
          return 383; /* abssf2 */

        default:
          return -1;
        }

    case SQRT:
      switch (pattern6 (x1))
        {
        case 0:
          if (!
#line 6467 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && TARGET_HARD_QUAD))
            return -1;
          return 384; /* *sqrttf2_hq */

        case 1:
          if (
#line 6480 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
            return 385; /* *sqrtdf2_nofix */
          if (!
#line 6488 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && sparc_fix_ut699))
            return -1;
          return 386; /* *sqrtdf2_fix */

        case 2:
          if (!
#line 6497 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_FPU && !sparc_fix_ut699))
            return -1;
          return 387; /* sqrtsf2 */

        default:
          return -1;
        }

    case ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern33 (x2))
        {
        case 0:
          return 388; /* ashlsi3 */

        case 1:
          if (register_operand (operands[1], E_DImode)
              && 
#line 6535 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
            return 389; /* *ashldi3_sp64 */
          if (pnum_clobbers == NULL
              || !arith_operand (operands[1], E_DImode)
              || !
#line 6548 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_V8PLUS))
            return -1;
          *pnum_clobbers = 1;
          return 390; /* ashldi3_v8plus */

        case 2:
          if (!
#line 9234 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 735; /* vashlv4hi3 */

        case 3:
          if (!
#line 9234 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 739; /* vashlv2si3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_23 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      if (pattern7 (x1) != 0
          || !
#line 6622 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && INTVAL (operands[2]) > 0 && INTVAL (operands[2]) <= 32))
        return -1;
      return 396; /* *ashrsi3_extend2 */

    case LSHIFTRT:
      return recog_25 (x1, insn, pnum_clobbers);

    case ZERO_EXTRACT:
      if (pattern7 (x1) != 0
          || !
#line 6717 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64 && INTVAL (operands[2]) > 0 && INTVAL (operands[2]) <= 32))
        return -1;
      return 402; /* *lshrsi3_extend2 */

    case CALL:
      return recog_24 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_30 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case PLUS:
          res = recog_7 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MINUS:
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SIGN_EXTEND:
          res = recog_9 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          res = recog_11 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case HIGH:
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case ZERO_EXTEND:
          res = recog_13 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MULT:
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_15 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case LABEL_REF:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              if (
#line 6828 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(!TARGET_CBCOND))
                return 409; /* *jump_ubranch */
              if (
#line 6836 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_CBCOND))
                return 410; /* *jump_cbcond */
            }
          break;

        default:
          break;
        }
      operands[0] = x2;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != PC)
        return -1;
      if (address_operand (operands[0], E_SImode)
          && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32))
        return 440; /* *branchsi */
      if (!address_operand (operands[0], E_DImode)
          || !
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64))
        return -1;
      return 441; /* *branchdi */

    case POPCOUNT:
      switch (pattern8 (x1))
        {
        case 0:
          if (
#line 7502 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH64))
            return 447; /* *popcountdi_sp64 */
          if (pnum_clobbers == NULL
              || !
#line 7509 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 1;
          return 448; /* popcountdi_v8plus */

        case 1:
          if (!
#line 7544 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_POPC && TARGET_ARCH32))
            return -1;
          return 450; /* popcountsi_v8plus */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern8 (x1))
        {
        case 0:
          if (
#line 7568 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH64))
            return 451; /* *clzdi_sp64 */
          if (pnum_clobbers == NULL
              || !
#line 7576 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
            return -1;
          *pnum_clobbers = 1;
          return 452; /* clzdi_v8plus */

        case 1:
          if (!
#line 7617 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3 && TARGET_ARCH32))
            return -1;
          return 454; /* clzsi_v8plus */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_26 (x1, insn, pnum_clobbers);

    case LE:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 670; /* fpcmple8si_vis */

        case 1:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 674; /* fpcmple16si_vis */

        case 2:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 678; /* fpcmple32si_vis */

        case 3:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 682; /* fpcmple8di_vis */

        case 4:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 686; /* fpcmple16di_vis */

        case 5:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (LE == EQ || LE == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 690; /* fpcmple32di_vis */

        default:
          return -1;
        }

    case GT:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 671; /* fpcmpgt8si_vis */

        case 1:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 675; /* fpcmpgt16si_vis */

        case 2:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 679; /* fpcmpgt32si_vis */

        case 3:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V8QImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 683; /* fpcmpgt8di_vis */

        case 4:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V4HImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 687; /* fpcmpgt16di_vis */

        case 5:
          if (!(
#line 8994 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS
   && (V2SImode != V8QImode
       || (TARGET_VIS3B && (GT == EQ || GT == NE))
       || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 691; /* fpcmpgt32di_vis */

        default:
          return -1;
        }

    case LEU:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V8QImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 692; /* fpcmpule8si_vis */

        case 1:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V4HImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 694; /* fpcmpule16si_vis */

        case 2:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V2SImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 696; /* fpcmpule32si_vis */

        case 3:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V8QImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 698; /* fpcmpule8di_vis */

        case 4:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V4HImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 700; /* fpcmpule16di_vis */

        case 5:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V2SImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 702; /* fpcmpule32di_vis */

        default:
          return -1;
        }

    case GTU:
      switch (pattern9 (x1))
        {
        case 0:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V8QImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 693; /* fpcmpugt8si_vis */

        case 1:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V4HImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 695; /* fpcmpugt16si_vis */

        case 2:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V2SImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH32)))
            return -1;
          return 697; /* fpcmpugt32si_vis */

        case 3:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V8QImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 699; /* fpcmpugt8di_vis */

        case 4:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V4HImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 701; /* fpcmpugt16di_vis */

        case 5:
          if (!(
#line 9021 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3B && (V2SImode == V8QImode || TARGET_VIS4)) && 
#line 214 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_ARCH64)))
            return -1;
          return 703; /* fpcmpugt32di_vis */

        default:
          return -1;
        }

    case SS_ASHIFT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (pattern10 (x2, 
E_V4HImode) != 0
              || !
#line 9234 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 736; /* vssashlv4hi3 */

        case E_V2SImode:
          if (pattern10 (x2, 
E_V2SImode) != 0
              || !
#line 9234 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 740; /* vssashlv2si3 */

        default:
          return -1;
        }

    case SS_PLUS:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 9296 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 750; /* ssaddv4hi3 */

        case 1:
          if (!
#line 9296 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 752; /* ssaddv2si3 */

        case 2:
          if (!
#line 9296 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 754; /* ssaddv2hi3 */

        case 3:
          if (!
#line 9296 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 756; /* ssaddv1si3 */

        case 4:
          if (!
#line 9338 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 770; /* ssaddv8qi3 */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 9296 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 751; /* sssubv4hi3 */

        case 1:
          if (!
#line 9296 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 753; /* sssubv2si3 */

        case 2:
          if (!
#line 9296 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 755; /* sssubv2hi3 */

        case 3:
          if (!
#line 9296 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS3))
            return -1;
          return 757; /* sssubv1si3 */

        case 4:
          if (!
#line 9338 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 771; /* sssubv8qi3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern12 (x1))
        {
        case 0:
          if (!
#line 9312 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 758; /* minv8qi3 */

        case 1:
          if (!
#line 9312 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 760; /* minv4hi3 */

        case 2:
          if (!
#line 9312 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 762; /* minv2si3 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern12 (x1))
        {
        case 0:
          if (!
#line 9312 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 759; /* maxv8qi3 */

        case 1:
          if (!
#line 9312 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 761; /* maxv4hi3 */

        case 2:
          if (!
#line 9312 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 763; /* maxv2si3 */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern12 (x1))
        {
        case 0:
          if (!
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 764; /* minuv8qi3 */

        case 1:
          if (!
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 766; /* minuv4hi3 */

        case 2:
          if (!
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 768; /* minuv2si3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern12 (x1))
        {
        case 0:
          if (!
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 765; /* maxuv8qi3 */

        case 1:
          if (!
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 767; /* maxuv4hi3 */

        case 2:
          if (!
#line 9327 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 769; /* maxuv2si3 */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 9354 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 772; /* usaddv4hi3 */

        case 1:
          if (!
#line 9354 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 774; /* usaddv8qi3 */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 9354 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 773; /* ussubv4hi3 */

        case 1:
          if (!
#line 9354 "../../gcc-15.0.1-20250313/gcc/config/sparc/sparc.md"
(TARGET_VIS4))
            return -1;
          return 775; /* ussubv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
