/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SFmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      return 1;

    case MULT:
      if (GET_MODE (x4) != E_SFmode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!fix_scaling_operand (operands[2], E_SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case LT:
      operands[3] = x3;
      if (branch_operator (operands[3], E_VOIDmode)
          && pattern12 (x1) == 0
          && branch_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x2, 1);
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          return 84; /* *btrue */
        }
      operands[4] = x3;
      if (branch_operator (operands[4], E_VOIDmode))
        {
          res = recog_4 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!boolean_operator (x3, E_VOIDmode))
        return -1;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          switch (XWINT (x7, 0))
            {
            case -2147483648L:
              x4 = XEXP (x2, 1);
              if (GET_CODE (x4) != LABEL_REF)
                return -1;
              x8 = XEXP (x2, 2);
              if (GET_CODE (x8) != PC)
                return -1;
              x9 = XEXP (x1, 0);
              if (GET_CODE (x9) != PC)
                return -1;
              operands[2] = x3;
              operands[0] = x6;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!
#line 1977 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_ABS))
                return -1;
              return 85; /* *btrue_INT_MIN */

            case 0L:
              if (!register_operand (x6, E_CCmode))
                return -1;
              x4 = XEXP (x2, 1);
              switch (GET_CODE (x4))
                {
                case REG:
                case SUBREG:
                  operands[2] = x4;
                  x9 = XEXP (x1, 0);
                  operands[0] = x9;
                  operands[4] = x3;
                  operands[1] = x6;
                  switch (pattern20 (x2))
                    {
                    case 0:
                      if (!
#line 2472 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_BOOLEANS))
                        return -1;
                      return 100; /* movsicc_internal1 */

                    case 1:
                      if (!
#line 2503 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_BOOLEANS))
                        return -1;
                      return 102; /* movsfcc_internal1 */

                    default:
                      return -1;
                    }

                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) != PC)
                    return -1;
                  x9 = XEXP (x1, 0);
                  if (GET_CODE (x9) != PC)
                    return -1;
                  operands[2] = x3;
                  operands[0] = x6;
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (!
#line 3026 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_BOOLEANS))
                    return -1;
                  return 132; /* *booltrue */

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) != LABEL_REF)
                    return -1;
                  x9 = XEXP (x1, 0);
                  if (GET_CODE (x9) != PC)
                    return -1;
                  operands[2] = x3;
                  operands[0] = x6;
                  x10 = XEXP (x8, 0);
                  operands[1] = x10;
                  if (!
#line 3044 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_BOOLEANS))
                    return -1;
                  return 133; /* *boolfalse */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ZERO_EXTRACT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x11 = XEXP (x6, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x1, 0);
          if (GET_CODE (x9) != PC)
            return -1;
          operands[3] = x3;
          x12 = XEXP (x6, 0);
          operands[0] = x12;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x13 = XEXP (x6, 2);
          operands[1] = x13;
          if (!arith_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          return 87; /* *bittrue */

        case AND:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != LABEL_REF)
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x9 = XEXP (x1, 0);
          if (GET_CODE (x9) != PC)
            return -1;
          x11 = XEXP (x6, 1);
          operands[1] = x11;
          x12 = XEXP (x6, 0);
          switch (GET_CODE (x12))
            {
            case REG:
            case SUBREG:
              operands[0] = x12;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              switch (GET_CODE (operands[1]))
                {
                case REG:
                case SUBREG:
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 1);
                  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  operands[3] = x3;
                  x5 = XEXP (x4, 0);
                  operands[2] = x5;
                  return 88; /* *masktrue */

                case CONST_INT:
                  operands[4] = x3;
                  x7 = XEXP (x3, 1);
                  operands[2] = x7;
                  if (!const_int_operand (operands[2], E_SImode))
                    return -1;
                  x5 = XEXP (x4, 0);
                  operands[3] = x5;
                  if (const_int_operand (operands[1], E_SImode))
                    {
                      if (
#line 2153 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[1]) + 1), 17, 31)
   /* && (~INTVAL (operands[1]) & INTVAL (operands[2])) == 0  // can be omitted */
   && xtensa_b4const_or_zero (INTVAL (operands[2]) << (32 - floor_log2 (INTVAL (operands[1]) + 1)))))
                        return 91; /* *masktrue_const_pow2_minus_one */
                      if (
#line 2193 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (-INTVAL (operands[1])), 1, 30)
   /* && (~INTVAL (operands[1]) & INTVAL (operands[2])) == 0  // can be omitted */
   && xtensa_b4const_or_zero (INTVAL (operands[2]) >> floor_log2 (-INTVAL (operands[1])))))
                        return 92; /* *masktrue_const_negative_pow2 */
                    }
                  if (!shifted_mask_operand (operands[1], E_SImode)
                      || !
#line 2228 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(/* (INTVAL (operands[2]) & ((1 << ctz_hwi (INTVAL (operands[1]))) - 1)) == 0  // can be omitted
   && */ xtensa_b4const_or_zero ((uint32_t)INTVAL (operands[2]) >> ctz_hwi (INTVAL (operands[1])))))
                    return -1;
                  return 93; /* *masktrue_const_shifted_mask */

                default:
                  return -1;
                }

            case NOT:
              if (GET_MODE (x12) != E_SImode)
                return -1;
              x7 = XEXP (x3, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              operands[3] = x3;
              x14 = XEXP (x12, 0);
              operands[0] = x14;
              if (!register_operand (operands[0], E_SImode))
                return -1;
              x5 = XEXP (x4, 0);
              operands[2] = x5;
              switch (GET_CODE (operands[1]))
                {
                case REG:
                case SUBREG:
                  if (!register_operand (operands[1], E_SImode))
                    return -1;
                  return 89; /* *masktrue_bitcmpl */

                case CONST_INT:
                  if (!const_int_operand (operands[1], E_SImode)
                      || !
#line 2100 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(exact_log2 (INTVAL (operands[1])) < 0))
                    return -1;
                  return 90; /* *masktrue_const_bitcmpl */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[3] = x3;
      if (!ubranch_operator (operands[3], E_VOIDmode)
          || pattern12 (x1) != 0
          || !ubranch_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      return 86; /* *ubtrue */

    default:
      return -1;
    }
}
