/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_CCmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SFmode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SFmode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (XWINT (x3, 0) != 0L)
    return -1;
  operands[3] = x1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern11 (x2))
            {
            case 0:
              return 4; /* subsi3 */

            case 1:
              if (!
#line 319 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 6; /* subsf3 */

            default:
              return -1;
            }

        case MULT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != SIGN_EXTEND
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SIGN_EXTEND
              || GET_MODE (x6) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_HImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[3] = x8;
          if (!register_operand (operands[3], E_HImode)
              || !
#line 421 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MAC16))
            return -1;
          return 13; /* mulsubhisi */

        default:
          return -1;
        }

    case CONST_INT:
      if (!const_int_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 272 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(xtensa_simm8 (-INTVAL (operands[1]))
   || xtensa_simm8x256 (-INTVAL (operands[1]))))
        return -1;
      return 5; /* *subsi3_from_const */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case TRUNCATE:
      return recog_11 (x1, insn, pnum_clobbers);

    case MULT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 381 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MUL32))
                return -1;
              return 9; /* mulsi3 */

            case 1:
              if (!
#line 431 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 14; /* mulsf3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern7 (x2, 
SIGN_EXTEND) != 0
              || !
#line 393 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MUL16 || TARGET_MAC16))
            return -1;
          return 10; /* mulhisi3 */

        case ZERO_EXTEND:
          if (pattern7 (x2, 
ZERO_EXTEND) != 0
              || !
#line 393 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MUL16 || TARGET_MAC16))
            return -1;
          return 11; /* umulhisi3 */

        case FLOAT:
          if (pattern8 (x2) != 0
              || !
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 59; /* *floatsisf2_scaled */

        case UNSIGNED_FLOAT:
          if (pattern8 (x2) != 0
              || !
#line 1194 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 60; /* *floatunssisf2_scaled */

        default:
          return -1;
        }

    case FMA:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SFmode))
        return -1;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 442 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 15; /* fmasf4 */

        case NEG:
          if (GET_MODE (x4) != E_SFmode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 454 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 16; /* fnmasf4 */

        default:
          return -1;
        }

    case DIV:
      if (pattern0 (x1) != 0
          || !
#line 467 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DIV32))
        return -1;
      return 17; /* divsi3 */

    case UDIV:
      if (pattern0 (x1) != 0
          || !
#line 477 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DIV32))
        return -1;
      return 18; /* udivsi3 */

    case MOD:
      if (pattern0 (x1) != 0
          || !
#line 490 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DIV32))
        return -1;
      return 19; /* modsi3 */

    case UMOD:
      if (pattern0 (x1) != 0
          || !
#line 500 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DIV32))
        return -1;
      return 20; /* umodsi3 */

    case ABS:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_ABS))
            return -1;
          return 21; /* abssi2 */

        case 1:
          if (!
#line 521 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 22; /* abssf2 */

        default:
          return -1;
        }

    case UMIN:
      if (pattern0 (x1) != 0
          || !
#line 534 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX))
        return -1;
      return 24; /* uminsi3 */

    case UMAX:
      if (pattern0 (x1) != 0
          || !
#line 534 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX))
        return -1;
      return 26; /* umaxsi3 */

    case SMIN:
    case SMAX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (GET_MODE (x2) == E_SImode)
        {
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (register_operand (operands[1], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_SImode))
                {
                  switch (GET_CODE (x2))
                    {
                    case SMIN:
                      if (
#line 534 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX))
                        return 23; /* sminsi3 */
                      break;

                    case SMAX:
                      if (
#line 534 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX))
                        return 25; /* smaxsi3 */
                      break;

                    default:
                      break;
                    }
                }
            }
        }
      x4 = XEXP (x2, 0);
      if (!xtensa_sminmax_operator (x4, E_SImode))
        return -1;
      operands[4] = x4;
      operands[5] = x2;
      if (!xtensa_sminmax_operator (operands[5], E_SImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 550 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MINMAX && TARGET_CLAMPS
   && INTVAL (operands[2]) + INTVAL (operands[3]) == -1
   && ((GET_CODE (operands[5]) == SMIN && GET_CODE (operands[4]) == SMAX
	&& IN_RANGE (exact_log2 (-INTVAL (operands[2])), 7, 22))
       || (GET_CODE (operands[5]) == SMAX && GET_CODE (operands[4]) == SMIN
	   && IN_RANGE (exact_log2 (-INTVAL (operands[3])), 7, 22)))))
        return -1;
      return 27; /* *xtensa_clamps */

    case CLRSB:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 573 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_NSA))
        return -1;
      return 28; /* clrsbsi2 */

    case CLZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 582 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_NSA))
        return -1;
      return 29; /* clzsi2 */

    case BSWAP:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          *pnum_clobbers = 1;
          return 30; /* bswaphi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 651 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize > 1 && !optimize_size))
            return -1;
          *pnum_clobbers = 1;
          return 31; /* bswapsi2_internal */

        default:
          return -1;
        }

    case NEG:
      switch (pattern1 (x1))
        {
        case 0:
          return 32; /* negsi2 */

        case 1:
          if (!
#line 728 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 34; /* negsf2 */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 33; /* one_cmplsi2 */

    case AND:
      return recog_10 (x1, insn, pnum_clobbers);

    case XOR:
      if (pattern0 (x1) != 0)
        return -1;
      return 41; /* xorsi3_internal */

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmed_operand (operands[1], E_HImode))
            return -1;
          return 43; /* zero_extendhisi2 */

        case E_QImode:
          if (!nonimmed_operand (operands[1], E_QImode))
            return -1;
          return 44; /* zero_extendqisi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!sext_operand (operands[1], E_HImode))
            return -1;
          return 45; /* extendhisi2_internal */

        case E_QImode:
          if (!register_operand (operands[1], E_QImode)
              || !
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_SEXT))
            return -1;
          return 46; /* extendqisi2_internal */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!sext_fldsz_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      if (!lsbitnum_operand (operands[3], E_SImode)
          || !
#line 1037 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_SEXT))
        return -1;
      return 47; /* extvsi_internal */

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!extui_fldsz_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 2);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      return 48; /* extzvsi_internal */

    case FIX:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1150 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 51; /* fix_truncsfsi2 */

        case 1:
          if (!
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 53; /* *fix_truncsfsi2_2x */

        case 2:
          if (!
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 55; /* *fix_truncsfsi2_scaled */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1150 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 52; /* fixuns_truncsfsi2 */

        case 1:
          if (!
#line 1160 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 54; /* *fixuns_truncsfsi2_2x */

        case 2:
          if (!
#line 1170 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 56; /* *fixuns_truncsfsi2_scaled */

        default:
          return -1;
        }

    case FLOAT:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 57; /* floatsisf2 */

    case UNSIGNED_FLOAT:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 58; /* floatunssisf2 */

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
      return recog_7 (x1, insn, pnum_clobbers);

    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      return recog_9 (x1, insn, pnum_clobbers);

    case PLUS:
    case MINUS:
    case IOR:
      return recog_6 (x1, insn, pnum_clobbers);

    case ROTATE:
      if (pattern3 (x1) != 0)
        return -1;
      return 82; /* rotlsi3 */

    case ROTATERT:
      if (pattern3 (x1) != 0)
        return -1;
      return 83; /* rotrsi3 */

    case IF_THEN_ELSE:
      return recog_5 (x1, insn, pnum_clobbers);

    case LT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern10 (x2, 
E_SImode) != 0
              || !
#line 2394 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_SALT))
            return -1;
          return 97; /* salt */

        case E_CCmode:
          if (!register_operand (operands[0], E_CCmode)
              || GET_MODE (x2) != E_CCmode
              || !register_operand (operands[1], E_SFmode)
              || !register_operand (operands[2], E_SFmode)
              || !
#line 2519 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 104; /* slt_sf */

        default:
          return -1;
        }

    case LTU:
      if (pattern0 (x1) != 0
          || !
#line 2404 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_SALT))
        return -1;
      return 98; /* saltu */

    case NE:
    case EQ:
      return recog_8 (x1, insn, pnum_clobbers);

    case LE:
      if (pattern4 (x1) != 0
          || !
#line 2519 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 105; /* sle_sf */

    case UNEQ:
      if (pattern4 (x1) != 0
          || !
#line 2519 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 106; /* suneq_sf */

    case UNLT:
      if (pattern4 (x1) != 0
          || !
#line 2519 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 107; /* sunlt_sf */

    case UNLE:
      if (pattern4 (x1) != 0
          || !
#line 2519 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 108; /* sunle_sf */

    case UNORDERED:
      if (pattern4 (x1) != 0
          || !
#line 2519 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 109; /* sunordered_sf */

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST:
        case REG:
        case SYMBOL_REF:
          operands[1] = x7;
          if (!call_insn_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_VOIDmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          if (
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!SIBLING_CALL_P (insn)))
            return 114; /* call_value_internal */
          if (GET_MODE (x4) != E_SImode
              || !
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!TARGET_WINDOWED_ABI && SIBLING_CALL_P (insn)))
            return -1;
          return 116; /* sibcall_value_internal */

        case UNSPEC:
          if (XVECLEN (x7, 0) != 2
              || XINT (x7, 1) != 7
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode)
            return -1;
          x9 = XVECEXP (x7, 0, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x7, 0, 1);
          operands[2] = x10;
          if (!tls_symbol_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR && HAVE_AS_TLS))
            return -1;
          return 131; /* tls_call */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 1:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 1
              || GET_MODE (x3) != E_SImode)
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[0] = x11;
          if (!const_int_operand (operands[0], E_SImode))
            return -1;
          return 117; /* entry */

        case 4:
          if (pnum_clobbers == NULL)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG
              || REGNO (x3) != 0
              || GET_MODE (x3) != E_SImode)
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[0] = x11;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          *pnum_clobbers = 1;
          return 120; /* eh_set_a0_windowed */

        case 0:
          if (pattern13 (x1) != 0)
            return -1;
          return 125; /* set_frame_ptr */

        case 2:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (!mem_operand (operands[0], E_SImode))
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 3083 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_RELEASE_SYNC))
            return -1;
          return 135; /* sync_lock_releasesi */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 1)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 12:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[1] = x11;
          return 123; /* *frame_blockage */

        case 8:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_SImode)
              || !
#line 2964 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR))
            return -1;
          return 127; /* get_thread_pointersi */

        case 5:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[1] = x11;
          if (!tls_symbol_operand (operands[1], E_SImode)
              || !
#line 2983 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR && HAVE_AS_TLS))
            return -1;
          return 129; /* tls_func */

        case 6:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          operands[1] = x11;
          if (!tls_symbol_operand (operands[1], E_SImode)
              || !
#line 2993 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_THREADPTR && HAVE_AS_TLS))
            return -1;
          return 130; /* tls_arg */

        case 9:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x11 = XVECEXP (x2, 0, 0);
          if (!rtx_equal_p (x11, operands[0]))
            return -1;
          return 134; /* *memory_barrier */

        default:
          return -1;
        }

    case GE:
      if (pattern5 (x1) != 0)
        return -1;
      return 138; /* *signed_ge_zero */

    default:
      return -1;
    }
}
