/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[1] = x8;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      res = recog_1 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_2 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!addsub_operator (x2, E_SImode)
      || !register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      operands[4] = x2;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      if (!addsubx_operand (operands[3], E_SImode)
          || !
#line 192 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_ADDX))
        return -1;
      return 2; /* *addsubx */

    case AND:
      x5 = XEXP (x3, 0);
      if (!logical_shift_operator (x5, E_SImode))
        return -1;
      operands[6] = x5;
      operands[5] = x2;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[4] = x6;
      if (!const_int_operand (operands[4], E_SImode)
          || !
#line 1119 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_ADDX
   && IN_RANGE (exact_log2 (INTVAL (operands[4])), 1, 3)))
        return -1;
      return 50; /* *extzvsi-1bit_addsubx */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PLUS
          || GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      if (!register_operand (x6, E_SFmode))
        return -1;
      x7 = XEXP (x3, 0);
      switch (GET_CODE (x7))
        {
        case PLUS:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x7, 0);
          operands[0] = x8;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[1] = x9;
          if (!fpmem_offset_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x6;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[0]))
            return -1;
          x11 = XEXP (x5, 1);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x4, 0);
          if (!rtx_equal_p (x12, operands[0])
              || !
#line 1503 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && !TARGET_HARD_FLOAT_POSTINC))
            return -1;
          return 67; /* *ssiu */

        case REG:
        case SUBREG:
          operands[0] = x7;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          operands[1] = x6;
          x11 = XEXP (x5, 1);
          operands[2] = x11;
          if (!fpmem_offset_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x5, 0);
          if (!rtx_equal_p (x10, operands[0]))
            return -1;
          x12 = XEXP (x4, 0);
          if (!rtx_equal_p (x12, operands[0])
              || !
#line 1535 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_HARD_FLOAT && TARGET_HARD_FLOAT_POSTINC))
            return -1;
          return 69; /* *ssip */

        default:
          return -1;
        }

    case PC:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x12 = XEXP (x4, 0);
      if (GET_CODE (x12) != LABEL_REF)
        return -1;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x12, 0);
      operands[1] = x13;
      return 112; /* tablejump_internal */

    default:
      return -1;
    }
}
