/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  return 0;
}

int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != AND
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ASHIFT
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  return 0;
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != NEG
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != AND
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != ASHIFT
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  operands[7] = x1;
  operands[5] = x2;
  x11 = XEXP (x4, 0);
  operands[2] = x11;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[4] = x12;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  operands[6] = x6;
  x13 = XEXP (x6, 0);
  operands[3] = x13;
  x14 = XEXP (x9, 0);
  if (!rtx_equal_p (x14, operands[2]))
    return -1;
  x15 = XEXP (x8, 1);
  if (!rtx_equal_p (x15, operands[4]))
    return -1;
  return 0;
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LSHIFTRT
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XEXP (x4, 1);
  if (GET_MODE (x8) != E_DImode)
    return -1;
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x8) != SIGN_EXTEND)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 371 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MUL32_HIGH))
        return -1;
      return 7; /* mulsi3_highpart */

    case ZERO_EXTEND:
      if (GET_CODE (x8) != ZERO_EXTEND)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 371 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_MUL32_HIGH))
        return -1;
      return 8; /* umulsi3_highpart */

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return NULL;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      if (GET_MODE (x4) != E_SImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 755 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ()))
        return NULL;
      return gen_split_4 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return NULL;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_SImode))
        {
          if ((
#line 773 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[2]) + 1), 17, 31)) && 
#line 775 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( 1)))
            return gen_split_5 (insn, operands);
          if ((
#line 797 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (-INTVAL (operands[2])), 12, 31)) && 
#line 799 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( 1)))
            return gen_split_6 (insn, operands);
        }
      if (!shifted_mask_operand (operands[2], E_SImode)
          || !(
#line 817 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(! xtensa_simm12b (INTVAL (operands[2]))) && 
#line 819 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( 1)))
        return NULL;
      return gen_split_7 (insn, operands);

    case ASHIFT:
    case LSHIFTRT:
      if (pattern14 (x2) != 0
          || !(
#line 1086 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(exact_log2 (INTVAL (operands[3])) > 0) && 
#line 1088 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( 1)))
        return NULL;
      return gen_split_9 (insn, operands);

    default:
      return NULL;
    }
}
