/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SFmode
      || !register_operand (operands[0], E_SFmode)
      || GET_MODE (x1) != E_SFmode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!float_scaling_operand (operands[2], E_SFmode))
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern10 (x1, 
E_SImode); /* [-1, 0] */

    case E_SFmode:
      if (pattern10 (x1, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[3] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern19 (x1, 
E_SImode); /* [-1, 0] */

    case E_SFmode:
      if (pattern19 (x1, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) == E_SImode)
    {
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (register_operand (operands[1], E_SImode))
        {
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (arith_operand (operands[2], E_SImode))
            {
              switch (GET_CODE (x3))
                {
                case ASHIFT:
                  return 71; /* ashlsi3_internal */

                case ASHIFTRT:
                  return 72; /* ashrsi3 */

                case LSHIFTRT:
                  return 73; /* lshrsi3 */

                default:
                  break;
                }
            }
        }
    }
  if (!xtensa_shift_per_byte_operator (x3, E_SImode))
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case ASHIFT:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      operands[3] = x3;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize))
        return -1;
      return 74; /* *shift_per_byte */

    case AND:
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != ASHIFT
          || GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      operands[4] = x3;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x5, 1);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 1722 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && (INTVAL (operands[3]) & 0x1f) == 3 << 3))
        return -1;
      return 75; /* *shift_per_byte_omit_AND_0 */

    case NEG:
      x7 = XEXP (x5, 0);
      if (pattern16 (x7) != 0)
        return -1;
      operands[4] = x3;
      x9 = XEXP (x7, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x7, 1);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_SImode)
          || !
#line 1743 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && (INTVAL (operands[3]) & 0x1f) == 3 << 3))
        return -1;
      return 76; /* *shift_per_byte_omit_AND_1 */

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      switch (GET_CODE (x2))
        {
        case NOT:
          if (GET_MODE (x2) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x2, 0);
                  operands[1] = x4;
                  if (register_operand (operands[1], E_SImode)
                      && 
#line 709 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ()))
                    return gen_split_3 (insn, operands);
                }
            }
          break;

        case AND:
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case IOR:
          if (GET_MODE (x2) == E_SImode)
            {
              x4 = XEXP (x2, 0);
              if (GET_CODE (x4) == AND
                  && GET_MODE (x4) == E_SImode)
                {
                  x5 = XEXP (x2, 1);
                  if (GET_CODE (x5) == AND
                      && GET_MODE (x5) == E_SImode)
                    {
                      x3 = XEXP (x1, 0);
                      operands[0] = x3;
                      if (register_operand (operands[0], E_SImode)
                          && pattern18 (x2) == 0
                          && (
#line 897 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && INTVAL (operands[3]) + INTVAL (operands[4]) == -1
   && (exact_log2 (INTVAL (operands[3]) + 1) > 16
       || exact_log2 (INTVAL (operands[4]) + 1) > 16)) && 
#line 902 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
                        return gen_split_8 (insn, operands);
                    }
                }
            }
          break;

        case PLUS:
        case MINUS:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x2;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmed_operand (operands[0], E_DImode)
                  && move_operand (operands[1], E_DImode)
                  && (
#line 1242 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DImode)
   || register_operand (operands[1], DImode)) && 
#line 1245 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( reload_completed)))
                return gen_split_11 (insn, operands);
              if (register_operand (operands[0], E_DImode)
                  && const_int_operand (operands[1], E_DImode)
                  && 
#line 1260 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!TARGET_CONST16
   && ! xtensa_split1_finished_p ()))
                return gen_split_12 (insn, operands);
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && const_int_operand (operands[1], E_SImode)
                  && 
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!TARGET_CONST16 && !TARGET_AUTO_LITPOOLS
   && ! xtensa_split1_finished_p ()
   && ! xtensa_simm12b (INTVAL (operands[1]))))
                return gen_split_13 (insn, operands);
              break;

            case E_HImode:
              if (register_operand (operands[0], E_HImode)
                  && const_int_operand (operands[1], E_HImode)
                  && 
#line 1309 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!TARGET_CONST16 && !TARGET_AUTO_LITPOOLS
   && ! xtensa_split1_finished_p ()
   && ! xtensa_simm12b (INTVAL (operands[1]))))
                return gen_split_14 (insn, operands);
              break;

            case E_DFmode:
              if (nonimmed_operand (operands[0], E_DFmode)
                  && move_operand (operands[1], E_DFmode)
                  && (
#line 1588 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(register_operand (operands[0], DFmode)
   || register_operand (operands[1], DFmode)) && 
#line 1591 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( reload_completed)))
                return gen_split_21 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case IF_THEN_ELSE:
          res = split_3 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      operands[1] = x2;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode))
            {
              if (constantpool_operand (operands[1], E_SImode)
                  && 
#line 1321 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && reload_completed))
                return gen_split_15 (insn, operands);
              if (const_int_operand (operands[1], E_SImode)
                  && 
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && reload_completed
   && !TARGET_CONST16 && TARGET_AUTO_LITPOOLS
   && ! xtensa_simm12b (INTVAL (operands[1]))))
                return gen_split_17 (insn, operands);
            }
          break;

        case E_HImode:
          if (register_operand (operands[0], E_HImode))
            {
              if (constantpool_operand (operands[1], E_HImode)
                  && 
#line 1321 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && reload_completed))
                return gen_split_16 (insn, operands);
              if (const_int_operand (operands[1], E_HImode)
                  && 
#line 1332 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && reload_completed
   && !TARGET_CONST16 && TARGET_AUTO_LITPOOLS
   && ! xtensa_simm12b (INTVAL (operands[1]))))
                return gen_split_18 (insn, operands);
            }
          break;

        case E_SFmode:
          if (register_operand (operands[0], E_SFmode))
            {
              if (constantpool_operand (operands[1], E_VOIDmode)
                  && 
#line 1548 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && reload_completed))
                return gen_split_19 (insn, operands);
              if (const_double_operand (operands[1], E_VOIDmode)
                  && 
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && reload_completed
   && !TARGET_CONST16 && TARGET_AUTO_LITPOOLS))
                return gen_split_20 (insn, operands);
            }
          break;

        default:
          break;
        }
      switch (GET_CODE (x2))
        {
        case ASHIFT:
        case ASHIFTRT:
        case LSHIFTRT:
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          if (GET_CODE (x2) == ASHIFT
              && GET_MODE (x2) == E_SImode)
            {
              x5 = XEXP (x2, 1);
              if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  && 
#line 1659 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_DENSITY))
                return gen_split_22 (insn, operands);
            }
          operands[4] = x2;
          if (!xtensa_shift_per_byte_operator (operands[4], E_SImode))
            return NULL;
          x5 = XEXP (x2, 1);
          if (GET_MODE (x5) != E_SImode)
            return NULL;
          switch (GET_CODE (x5))
            {
            case AND:
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != ASHIFT
                  || GET_MODE (x6) != E_SImode)
                return NULL;
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              x8 = XEXP (x6, 0);
              operands[2] = x8;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x9 = XEXP (x5, 1);
              operands[3] = x9;
              if (!const_int_operand (operands[3], E_SImode)
                  || !(
#line 1722 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && (INTVAL (operands[3]) & 0x1f) == 3 << 3) && 
#line 1725 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( 1)))
                return NULL;
              return gen_split_23 (insn, operands);

            case NEG:
              x6 = XEXP (x5, 0);
              if (pattern16 (x6) != 0)
                return NULL;
              x8 = XEXP (x6, 0);
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!register_operand (operands[2], E_SImode))
                return NULL;
              x7 = XEXP (x6, 1);
              operands[3] = x7;
              if (!const_int_operand (operands[3], E_SImode)
                  || !(
#line 1743 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && (INTVAL (operands[3]) & 0x1f) == 3 << 3) && 
#line 1746 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( can_create_pseudo_p ())))
                return NULL;
              return gen_split_24 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
        case IOR:
          if (!xtensa_bit_join_operator (x2, E_SImode))
            return NULL;
          x4 = XEXP (x2, 0);
          if (!logical_shift_operator (x4, E_SImode))
            return NULL;
          x5 = XEXP (x2, 1);
          if (!logical_shift_operator (x5, E_SImode))
            return NULL;
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x12 = XEXP (x4, 1);
          if (GET_MODE (x12) != E_SImode)
            return NULL;
          x6 = XEXP (x5, 0);
          if (!register_operand (x6, E_SImode))
            return NULL;
          switch (GET_CODE (x12))
            {
            case NEG:
              operands[6] = x2;
              operands[4] = x4;
              x13 = XEXP (x12, 0);
              operands[3] = x13;
              if (!register_operand (operands[3], E_SImode))
                return NULL;
              operands[5] = x5;
              operands[2] = x6;
              x9 = XEXP (x5, 1);
              if (!rtx_equal_p (x9, operands[3])
                  || !(
#line 1793 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && xtensa_shlrd_which_direction (operands[5], operands[4]) != UNKNOWN) && 
#line 1796 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( 1)))
                return NULL;
              return gen_split_25 (insn, operands);

            case AND:
              if (pattern21 (x2) != 0
                  || !(
#line 1875 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(!optimize_debug && optimize
   && xtensa_shlrd_which_direction (operands[5], operands[6]) != UNKNOWN
   && (INTVAL (operands[4]) & 0x1f) == 3 << 3) && 
#line 1879 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( 1)))
                return NULL;
              return gen_split_26 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC_VOLATILE:
          if (XVECLEN (x2, 0) != 1
              || XINT (x2, 1) != 0
              || GET_MODE (x2) != E_SImode
              || pattern13 (x1) != 0
              || !
#line 2933 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(reload_completed && !frame_pointer_needed))
            return NULL;
          return gen_split_36 (insn, operands);

        case AND:
          if (GET_MODE (x2) != E_SImode)
            return NULL;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != PLUS
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x12 = XEXP (x4, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return NULL;
          x5 = XEXP (x2, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
            return NULL;
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 3172 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(can_create_pseudo_p ()))
            return NULL;
          return gen_split_37 (insn, operands);

        case GE:
          if (pattern5 (x1) != 0)
            return NULL;
          return gen_split_38 (insn, operands);

        case NE:
        case EQ:
          x5 = XEXP (x2, 1);
          if (GET_CODE (x5) != CONST_INT)
            return NULL;
          if (XWINT (x5, 0) == 0L
              && GET_CODE (x2) == EQ
              && GET_MODE (x2) == E_SImode)
            {
              operands[0] = x3;
              if (register_operand (operands[0], E_SImode))
                {
                  x4 = XEXP (x2, 0);
                  operands[1] = x4;
                  if (register_operand (operands[1], E_SImode)
                      && (
#line 3214 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_NSA) && 
#line 3216 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( 1)))
                    return gen_split_39 (insn, operands);
                }
            }
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode)
              || !boolean_operator (x2, E_SImode))
            return NULL;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case AND:
              if (pattern15 (x2) != 0
                  || !(
#line 3270 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(IN_RANGE (exact_log2 (INTVAL (operands[2]) + 1), 17, 31)
   || IN_RANGE (exact_log2 (-INTVAL (operands[2])), 1, 30)) && 
#line 3273 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( 1)))
                return NULL;
              return gen_split_41 (insn, operands);

            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_SImode)
                  || XWINT (x5, 0) != -2147483648L)
                return NULL;
              operands[2] = x2;
              if (!(
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_ABS) && 
#line 3300 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( 1)))
                return NULL;
              return gen_split_42 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 4:
          if (pattern6 (x1) != 0)
            return NULL;
          x14 = XVECEXP (x1, 0, 0);
          x15 = XEXP (x14, 1);
          x16 = XEXP (x15, 0);
          x17 = XEXP (x16, 0);
          operands[0] = x17;
          if (!nonimmediate_operand (operands[0], E_SImode))
            return NULL;
          x18 = XEXP (x15, 1);
          x19 = XEXP (x18, 0);
          operands[1] = x19;
          x20 = XVECEXP (x1, 0, 1);
          x21 = XEXP (x20, 0);
          operands[2] = x21;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return NULL;
          x22 = XVECEXP (x1, 0, 3);
          x23 = XEXP (x22, 0);
          operands[3] = x23;
          if (!scratch_operand (operands[3], E_VOIDmode))
            return NULL;
          x24 = XEXP (x20, 1);
          x25 = XEXP (x24, 0);
          if (!rtx_equal_p (x25, operands[0])
              || !
#line 2333 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(TARGET_LOOPS && optimize && reload_completed))
            return NULL;
          return gen_split_33 (insn, operands);

        case 2:
          x20 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x20) != CLOBBER)
            return NULL;
          x21 = XEXP (x20, 0);
          if (!scratch_operand (x21, E_SImode))
            return NULL;
          x14 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x14))
            {
            case SET:
              x15 = XEXP (x14, 1);
              switch (GET_CODE (x15))
                {
                case UNSPEC_VOLATILE:
                  if (pattern9 (x14) != 0)
                    return NULL;
                  x26 = XVECEXP (x15, 0, 0);
                  operands[0] = x26;
                  if (!register_operand (operands[0], E_SImode))
                    return NULL;
                  operands[1] = x21;
                  if (!
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(reload_completed))
                    return NULL;
                  return gen_split_34 (insn, operands);

                case NE:
                case EQ:
                  operands[2] = x15;
                  if (!boolean_operator (operands[2], E_SImode))
                    return NULL;
                  x18 = XEXP (x15, 1);
                  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return NULL;
                  x27 = XEXP (x14, 0);
                  operands[0] = x27;
                  if (!register_operand (operands[0], E_SImode))
                    return NULL;
                  x16 = XEXP (x15, 0);
                  operands[1] = x16;
                  if (!register_operand (operands[1], E_SImode))
                    return NULL;
                  operands[3] = x21;
                  if (!
#line 3235 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
( reload_completed))
                    return NULL;
                  return gen_split_40 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x14, 0) != 1
                  || XINT (x14, 1) != 4)
                return NULL;
              x28 = XVECEXP (x14, 0, 0);
              operands[0] = x28;
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              operands[1] = x21;
              if (!
#line 2845 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(reload_completed))
                return NULL;
              return gen_split_35 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case CLOBBER:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode)
          || !
#line 3354 "../../gcc-15.0.1-20250313/gcc/config/xtensa/xtensa.md"
(HARD_REGISTER_P (operands[0])
   && COMPLEX_MODE_P (GET_MODE (operands[0]))))
        return NULL;
      return gen_split_43 (insn, operands);

    default:
      return NULL;
    }
}
