/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case TRUNCATE:
      return 0;

    case MINUS:
      res = pattern4 (x3);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case CONST_VECTOR:
    case CONST:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern5 (x3, 
E_V8QImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern5 (x3, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4HImode:
          if (pattern5 (x3, 
E_V4HImode) != 0)
            return -1;
          return 5;

        case E_V8HImode:
          if (pattern5 (x3, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case E_V2SImode:
          if (pattern5 (x3, 
E_V2SImode) != 0)
            return -1;
          return 7;

        case E_V4SImode:
          if (pattern5 (x3, 
E_V4SImode) != 0)
            return -1;
          return 8;

        case E_V2DImode:
          if (pattern5 (x3, 
E_V2DImode) != 0)
            return -1;
          return 9;

        case E_VNx16QImode:
          if (pattern5 (x3, 
E_VNx16QImode) != 0)
            return -1;
          return 10;

        case E_VNx8QImode:
          if (pattern5 (x3, 
E_VNx8QImode) != 0)
            return -1;
          return 11;

        case E_VNx4QImode:
          if (pattern5 (x3, 
E_VNx4QImode) != 0)
            return -1;
          return 12;

        case E_VNx2QImode:
          if (pattern5 (x3, 
E_VNx2QImode) != 0)
            return -1;
          return 13;

        case E_VNx8HImode:
          if (pattern5 (x3, 
E_VNx8HImode) != 0)
            return -1;
          return 14;

        case E_VNx4HImode:
          if (pattern5 (x3, 
E_VNx4HImode) != 0)
            return -1;
          return 15;

        case E_VNx2HImode:
          if (pattern5 (x3, 
E_VNx2HImode) != 0)
            return -1;
          return 16;

        case E_VNx4SImode:
          if (pattern5 (x3, 
E_VNx4SImode) != 0)
            return -1;
          return 17;

        case E_VNx2SImode:
          if (pattern5 (x3, 
E_VNx2SImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern5 (x3, 
E_VNx2DImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_uminmax_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 5
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  if (!aarch64_call_insn_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XVECEXP (x4, 0, 0);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 2;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 4;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    case E_VNx8SFmode:
      if (!aligned_register_operand (operands[0], E_VNx8SFmode)
          || GET_MODE (x3) != E_VNx8SFmode
          || !aligned_register_operand (operands[1], E_VNx8SFmode))
        return -1;
      return 8;

    case E_VNx16SFmode:
      if (!aligned_register_operand (operands[0], E_VNx16SFmode)
          || GET_MODE (x3) != E_VNx16SFmode
          || !aligned_register_operand (operands[1], E_VNx16SFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 5;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 6;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 7;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 8;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern99 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          return pattern77 (x3, 
E_V8QImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern77 (x3, 
E_V16QImode) != 0)
            return -1;
          return 1;

        case E_V4HImode:
          if (pattern77 (x3, 
E_V4HImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern77 (x3, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V2SImode:
          if (pattern77 (x3, 
E_V2SImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern77 (x3, 
E_V4SImode) != 0)
            return -1;
          return 5;

        case E_V2DImode:
          if (pattern77 (x3, 
E_V2DImode) != 0)
            return -1;
          return 6;

        case E_DImode:
          if (pattern77 (x3, 
E_DImode) != 0)
            return -1;
          return 7;

        case E_VNx32QImode:
          if (pattern78 (x3, 
E_VNx32QImode) != 0)
            return -1;
          return 8;

        case E_VNx16HImode:
          if (pattern78 (x3, 
E_VNx16HImode) != 0)
            return -1;
          return 9;

        case E_VNx8SImode:
          if (pattern78 (x3, 
E_VNx8SImode) != 0)
            return -1;
          return 10;

        case E_VNx4DImode:
          if (pattern78 (x3, 
E_VNx4DImode) != 0)
            return -1;
          return 11;

        case E_VNx64QImode:
          if (pattern78 (x3, 
E_VNx64QImode) != 0)
            return -1;
          return 12;

        case E_VNx32HImode:
          if (pattern78 (x3, 
E_VNx32HImode) != 0)
            return -1;
          return 13;

        case E_VNx16SImode:
          if (pattern78 (x3, 
E_VNx16SImode) != 0)
            return -1;
          return 14;

        case E_VNx8DImode:
          if (pattern78 (x3, 
E_VNx8DImode) != 0)
            return -1;
          return 15;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx32QImode:
          if (pattern79 (x3, 
E_VNx16QImode, 
E_VNx32QImode) != 0)
            return -1;
          return 16;

        case E_VNx16HImode:
          if (pattern79 (x3, 
E_VNx8HImode, 
E_VNx16HImode) != 0)
            return -1;
          return 17;

        case E_VNx8SImode:
          if (pattern79 (x3, 
E_VNx4SImode, 
E_VNx8SImode) != 0)
            return -1;
          return 18;

        case E_VNx4DImode:
          if (pattern79 (x3, 
E_VNx2DImode, 
E_VNx4DImode) != 0)
            return -1;
          return 19;

        case E_VNx64QImode:
          if (pattern79 (x3, 
E_VNx16QImode, 
E_VNx64QImode) != 0)
            return -1;
          return 20;

        case E_VNx32HImode:
          if (pattern79 (x3, 
E_VNx8HImode, 
E_VNx32HImode) != 0)
            return -1;
          return 21;

        case E_VNx16SImode:
          if (pattern79 (x3, 
E_VNx4SImode, 
E_VNx16SImode) != 0)
            return -1;
          return 22;

        case E_VNx8DImode:
          if (pattern79 (x3, 
E_VNx2DImode, 
E_VNx8DImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  return pattern135 (x2); /* [-1, 1] */
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern146 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_si (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern162 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern158 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern158 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern159 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern159 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern160 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern160 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern161 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_DImode:
      if (pattern161 (x3, 
E_DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern177 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[2], E_VNx16BImode)
              || !register_operand (operands[3], E_VNx16QImode))
            return -1;
          return 0;

        case E_VNx8BImode:
          if (!register_operand (operands[2], E_VNx8BImode)
              || !register_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx4BImode:
          if (!register_operand (operands[2], E_VNx4BImode)
              || !register_operand (operands[3], E_VNx4QImode))
            return -1;
          return 2;

        case E_VNx2BImode:
          if (!register_operand (operands[2], E_VNx2BImode)
              || !register_operand (operands[3], E_VNx2QImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_HImode:
      res = pattern173 (x3, 
E_VNx8HImode, 
E_VNx4HImode, 
E_VNx2HImode, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    case E_SImode:
      res = pattern174 (x3, 
E_VNx4SImode, 
E_VNx2SImode, 
E_SImode);
      if (res >= 0)
        return res + 7; /* [7, 8] */
      return -1;

    case E_DImode:
      if (pattern175 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 9;

    case E_HFmode:
      res = pattern173 (x3, 
E_VNx8HFmode, 
E_VNx4HFmode, 
E_VNx2HFmode, 
E_HFmode);
      if (res >= 0)
        return res + 10; /* [10, 12] */
      return -1;

    case E_BFmode:
      res = pattern173 (x3, 
E_VNx8BFmode, 
E_VNx4BFmode, 
E_VNx2BFmode, 
E_BFmode);
      if (res >= 0)
        return res + 13; /* [13, 15] */
      return -1;

    case E_SFmode:
      res = pattern174 (x3, 
E_VNx4SFmode, 
E_VNx2SFmode, 
E_SFmode);
      if (res >= 0)
        return res + 16; /* [16, 17] */
      return -1;

    case E_DFmode:
      if (pattern175 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_DFmode) != 0)
        return -1;
      return 18;

    case E_VNx16QImode:
      if (pattern176 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
        return -1;
      return 19;

    case E_VNx8QImode:
      if (pattern176 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 20;

    case E_VNx4QImode:
      if (pattern176 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 21;

    case E_VNx2QImode:
      if (pattern176 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 22;

    case E_VNx8HImode:
      if (pattern176 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 23;

    case E_VNx4HImode:
      if (pattern176 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 24;

    case E_VNx2HImode:
      if (pattern176 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 25;

    case E_VNx4SImode:
      if (pattern176 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 26;

    case E_VNx2SImode:
      if (pattern176 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 27;

    case E_VNx2DImode:
      if (pattern176 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 28;

    case E_VNx8HFmode:
      if (pattern176 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 29;

    case E_VNx4HFmode:
      if (pattern176 (x3, 
E_VNx4HFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 30;

    case E_VNx2HFmode:
      if (pattern176 (x3, 
E_VNx2HFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 31;

    case E_VNx8BFmode:
      if (pattern176 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 32;

    case E_VNx4BFmode:
      if (pattern176 (x3, 
E_VNx4BFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 33;

    case E_VNx2BFmode:
      if (pattern176 (x3, 
E_VNx2BFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 34;

    case E_VNx4SFmode:
      if (pattern176 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 35;

    case E_VNx2SFmode:
      if (pattern176 (x3, 
E_VNx2SFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 36;

    case E_VNx2DFmode:
      if (pattern176 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 37;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[1] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[1], E_VNx8SFmode))
            return -1;
          return 0;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[1], E_VNx16SFmode))
            return -1;
          return 1;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[1], E_VNx4DFmode))
            return -1;
          return 2;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[1], E_VNx8DFmode))
            return -1;
          return 3;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[1], E_VNx16HFmode))
            return -1;
          return 4;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[1], E_VNx32HFmode))
            return -1;
          return 5;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[1], E_VNx16BFmode))
            return -1;
          return 6;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[1], E_VNx32BFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[2] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[2], E_VNx8SFmode))
            return -1;
          return 8;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[2], E_VNx16SFmode))
            return -1;
          return 9;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[2], E_VNx4DFmode))
            return -1;
          return 10;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[2], E_VNx8DFmode))
            return -1;
          return 11;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[2], E_VNx16HFmode))
            return -1;
          return 12;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[2], E_VNx32HFmode))
            return -1;
          return 13;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[2], E_VNx16BFmode))
            return -1;
          return 14;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[2], E_VNx32BFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern262 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern267 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SImode:
      return pattern265 (x2, 
E_VNx16QImode, 
E_VNx4BImode, 
E_VNx4SImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern265 (x2, 
E_VNx8HImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern276 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_ldff1_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 0;

    case E_VNx1TImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern282 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1)
      || !aarch64_plus_immediate (operands[3], i1))
    return -1;
  return 0;
}

int
pattern294 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern298 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern306 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern310 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_simd_shll_imm_vec (operands[2], i1))
    return -1;
  return 0;
}

int
pattern316 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern320 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern319 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern319 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern319 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return 3;

        case E_V8HImode:
          return 4;

        case E_V4SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern327 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_rshift_imm (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern332 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return pattern331 (x3); /* [-1, 4] */
}

int
pattern336 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx8HImode))
    return -1;
  x2 = XEXP (x1, 0);
  switch (XINT (x2, 1))
    {
    case 169:
      operands[5] = x1;
      x3 = XVECEXP (x2, 0, 0);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 1);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      operands[4] = x5;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x4 = XVECEXP (x2, 0, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      operands[3] = x1;
      x3 = XVECEXP (x2, 0, 0);
      operands[4] = x3;
      x5 = XVECEXP (x2, 0, 2);
      operands[2] = x5;
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern346 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_imm24 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern351 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !aarch64_sync_memory_operand (operands[1], i1)
      || !aarch64_logical_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern357 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  return pattern356 (x5); /* [-1, 0] */
}

int
pattern362 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  x12 = XVECEXP (x3, 0, 2);
  operands[3] = x12;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[4] = x13;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return pattern361 (x1); /* [-1, 3] */
}

int
pattern370 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern369 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern369 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern375 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern383 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 0);
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      x8 = XEXP (x3, 1);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern381 (x1, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern381 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        case E_V2DImode:
          if (pattern381 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != VEC_SELECT)
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x10 = XEXP (x5, 1);
      operands[3] = x10;
      x11 = XEXP (x6, 0);
      operands[2] = x11;
      x12 = XEXP (x6, 1);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x13 = XEXP (x7, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x7, 1);
      if (!rtx_equal_p (x14, operands[3]))
        return -1;
      x15 = XEXP (x8, 0);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x8, 1);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern382 (x1, 
E_V8QImode, 
E_V16QImode, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V4SImode:
          if (pattern382 (x1, 
E_V4HImode, 
E_V8HImode, 
E_V4SImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern382 (x1, 
E_V2SImode, 
E_V4SImode, 
E_V2DImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern402 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return pattern400 (x1); /* [-1, 15] */

    case ABS:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ABS)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (pattern401 (x1, 
E_V4HFmode, 
E_V4HImode) != 0)
            return -1;
          return 16;

        case E_V8HImode:
          if (pattern401 (x1, 
E_V8HFmode, 
E_V8HImode) != 0)
            return -1;
          return 17;

        case E_V2SImode:
          if (pattern401 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 18;

        case E_V4SImode:
          if (pattern401 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 19;

        case E_V2DImode:
          if (pattern401 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
            return -1;
          return 20;

        case E_HImode:
          if (pattern401 (x1, 
E_HFmode, 
E_HImode) != 0)
            return -1;
          return 21;

        case E_SImode:
          if (pattern401 (x1, 
E_SFmode, 
E_SImode) != 0)
            return -1;
          return 22;

        case E_DImode:
          if (pattern401 (x1, 
E_DFmode, 
E_DImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern413 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern417 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern417 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern417 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern417 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return 3;

        case E_V8HImode:
          return 4;

        case E_V4SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern431 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern437 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V8QImode))
    return -1;
  return 0;
}

int
pattern442 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_int_rnd_operand (operands[4], i2)
      || !aarch64_simd_shift_imm_vec_si (operands[3], i1)
      || !register_operand (operands[1], E_V2SImode))
    return -1;
  return 0;
}

int
pattern449 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern31 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern31 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern31 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern31 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern31 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern31 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern31 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_HImode:
      if (pattern31 (x1, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_QImode:
      if (pattern31 (x1, 
E_QImode) != 0)
        return -1;
      return 8;

    case E_SImode:
      if (pattern445 (x1, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      return 9;

    case E_DImode:
      if (pattern445 (x1, pnum_clobbers, 
E_DImode) != 0)
        return -1;
      return 10;

    case E_VNx16QImode:
      if (pattern448 (x1, 
E_VNx16QImode) != 0)
        return -1;
      return 11;

    case E_VNx8HImode:
      if (pattern448 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 12;

    case E_VNx4SImode:
      if (pattern448 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 13;

    case E_VNx2DImode:
      if (pattern448 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern467 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4DImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 4;

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern481 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_vsb_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      return pattern484 (x1, 
E_VNx4SImode, 
E_VNx4BImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern484 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern484 (x1, 
E_V4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern484 (x1, 
E_V2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern491 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 1;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern498 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern504 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern503 (x1, 
E_V4SImode, 
E_V16QImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern503 (x1, 
E_VNx4SImode, 
E_VNx16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern512 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x3, 1);
  if (!rtx_equal_p (x8, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern511 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern511 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern511 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern511 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern511 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern511 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern522 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern532 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern420 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern420 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern420 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern420 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern420 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern538 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern545 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HImode)
      || GET_MODE (x1) != E_V8HImode
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V4HImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  return pattern544 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern553 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern558 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern557 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern557 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern557 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern568 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

int
pattern572 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern571 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern571 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern571 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern571 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern582 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125
      || GET_MODE (x1) != E_VNx2DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_VNx2DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != TRUNCATE
      || GET_MODE (x3) != E_VNx2SImode)
    return -1;
  return 0;
}

int
pattern587 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_logical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern592 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[3], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8BImode)
          || !memory_operand (operands[1], E_VNx8QImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !memory_operand (operands[1], E_VNx4QImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx4QImode))
        return -1;
      return 1;

    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2QImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx2QImode))
        return -1;
      return 2;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4BImode)
          || !memory_operand (operands[1], E_VNx4HImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx4HImode))
        return -1;
      return 3;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2HImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx2HImode))
        return -1;
      return 4;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2BImode)
          || !memory_operand (operands[1], E_VNx2SImode)
          || !aarch64_maskload_else_operand (operands[4], E_VNx2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern609 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125
      || GET_MODE (x1) != E_VNx2DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_VNx2DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != TRUNCATE
      || GET_MODE (x3) != E_VNx2SImode)
    return -1;
  return 0;
}

int
pattern613 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      return pattern484 (x1, 
E_VNx4SImode, 
E_VNx4BImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern484 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern619 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return pattern308 (); /* [-1, 2] */
}

int
pattern624 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern631 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern636 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || !register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[3] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern643 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern651 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = XEXP (x2, 1);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern650 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern650 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern650 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern650 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern650 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern650 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern663 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern671 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern669 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern669 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern669 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern676 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern681 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_one (operands[3], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern686 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !aarch64_simd_raddsubhn_imm_vec (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[4], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern693 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 3
      || XINT (x6, 1) != i1)
    return -1;
  x7 = XVECEXP (x6, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_VNx16BImode))
    return -1;
  x9 = XVECEXP (x3, 0, 1);
  operands[2] = x9;
  x10 = XEXP (x5, 0);
  operands[1] = x10;
  x11 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x11, operands[3]))
    return -1;
  x12 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern692 (x1, 
E_VNx16QImode, 
E_VNx32QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern692 (x1, 
E_VNx8HImode, 
E_VNx16HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern692 (x1, 
E_VNx4SImode, 
E_VNx8SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern692 (x1, 
E_VNx2DImode, 
E_VNx4DImode) != 0)
        return -1;
      return 3;

    case E_VNx8BFmode:
      if (pattern692 (x1, 
E_VNx8BFmode, 
E_VNx16BFmode) != 0)
        return -1;
      return 4;

    case E_VNx8HFmode:
      if (pattern692 (x1, 
E_VNx8HFmode, 
E_VNx16HFmode) != 0)
        return -1;
      return 5;

    case E_VNx4SFmode:
      if (pattern692 (x1, 
E_VNx4SFmode, 
E_VNx8SFmode) != 0)
        return -1;
      return 6;

    case E_VNx2DFmode:
      if (pattern692 (x1, 
E_VNx2DFmode, 
E_VNx4DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern711 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern710 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern710 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern710 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern710 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern710 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern710 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern710 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern710 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern710 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern710 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern723 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_mem_pair_lanes_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_stp_reg_operand (operands[1], i1)
      || !aarch64_stp_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern726 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], E_VNx8BImode)
      || !aarch64_sve_ld1ro_operand_h (operands[1], E_OImode))
    return -1;
  return 0;
}

int
pattern729 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern735 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!aarch64_shift_imm_si (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern740 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern743 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern752 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern755 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern761 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_even_or_odd_half (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern769 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern763 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern763 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern763 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern763 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V8BFmode:
      if (pattern763 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern763 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern780 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XEXP (x5, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  x11 = XEXP (x1, 1);
  operands[4] = x11;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern779 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern779 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern779 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern794 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_arith_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern798 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern806 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!aarch64_shift_imm_si (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern815 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_reg_or_zero (operands[1], i1)
      || !aarch64_borrow_operation (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern822 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case VEC_SELECT:
      x2 = XEXP (x1, 0);
      operands[3] = x2;
      x3 = XEXP (x1, 1);
      operands[5] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          return 0;

        case E_V4SFmode:
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != VEC_SELECT
          || GET_MODE (x2) != E_HFmode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XVECEXP (x4, 0, 0);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          return 2;

        case E_V4SFmode:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern837 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_lshift_imm (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern845 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case VEC_SELECT:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 1)
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[2] = x2;
      return 1;

    default:
      return -1;
    }
}

int
pattern852 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern851 (x1, 
E_VNx8HFmode); /* [-1, 2] */

    case E_VNx4SFmode:
      res = pattern851 (x1, 
E_VNx4SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DFmode:
      res = pattern851 (x1, 
E_VNx2DFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern863 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_general_reg (operands[0], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern869 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern877 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern883 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (!aarch64_sync_memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!aarch64_sync_memory_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!aarch64_sync_memory_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern888 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[4], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern892 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          return pattern891 (x1, 
E_V4SImode, 
E_HImode, 
E_SImode, 
E_V8HImode, 
E_V4HImode); /* [-1, 0] */

        case E_V2DImode:
          if (pattern891 (x1, 
E_V2DImode, 
E_SImode, 
E_DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 1)
        return -1;
      x7 = XEXP (x5, 0);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 0);
      operands[5] = x8;
      if (!immediate_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V4SImode)
            return -1;
          x9 = XEXP (x2, 0);
          if (GET_MODE (x9) != E_V4SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V4HImode
              || !register_operand (operands[2], E_V8HImode)
              || !vect_par_cnst_hi_half (operands[3], E_V8HImode)
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_V4SImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_V4HImode:
              if (!register_operand (operands[4], E_V4HImode))
                return -1;
              return 2;

            case E_V8HImode:
              if (!register_operand (operands[4], E_V8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x2) != E_V2DImode)
            return -1;
          x9 = XEXP (x2, 0);
          if (GET_MODE (x9) != E_V2DImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V2SImode
              || !register_operand (operands[2], E_V4SImode)
              || !vect_par_cnst_hi_half (operands[3], E_V4SImode)
              || GET_MODE (x3) != E_V2DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_SImode
              || !register_operand (operands[1], E_V2DImode))
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_V2SImode:
              if (!register_operand (operands[4], E_V2SImode))
                return -1;
              return 4;

            case E_V4SImode:
              if (!register_operand (operands[4], E_V4SImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern931 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern936 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  operands[5] = x1;
  if (!memory_operand (operands[5], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!register_operand (operands[6], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[7] = x4;
  if (!memory_operand (operands[7], i1))
    return -1;
  return 0;
}

int
pattern939 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 2);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern947 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern952 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern958 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i5
      || !register_operand (operands[2], i4)
      || !vect_par_cnst_hi_half (operands[3], i4))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern968 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern973 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern980 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern986 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 40
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern990 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_V8QImode:
      if (!memory_operand (operands[2], E_V8QImode)
          || !register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!memory_operand (operands[2], E_V4HImode)
          || !register_operand (operands[3], E_V4HImode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!memory_operand (operands[2], E_V4HFmode)
          || !register_operand (operands[3], E_V4HFmode))
        return -1;
      return 2;

    case E_V2SImode:
      if (!memory_operand (operands[2], E_V2SImode)
          || !register_operand (operands[3], E_V2SImode))
        return -1;
      return 3;

    case E_V2SFmode:
      if (!memory_operand (operands[2], E_V2SFmode)
          || !register_operand (operands[3], E_V2SFmode))
        return -1;
      return 4;

    case E_DFmode:
      if (!memory_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern1001 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1007 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[3], E_V4BFmode))
        return -1;
      return 0;

    case E_V8BFmode:
      if (!register_operand (operands[3], E_V8BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1015 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern341 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1022 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1030 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i3)
      || !vect_par_cnst_even_or_odd_half (operands[3], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !vect_par_cnst_even_or_odd_half (operands[4], i2)
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1038 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x2, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 2);
  operands[1] = x7;
  x8 = XEXP (x1, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1037 (); /* [-1, 3] */

    case E_DImode:
      res = pattern1037 ();
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1049 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_maxmin_immediate (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1057 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1061 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      return pattern1048 (x1); /* [-1, 6] */

    case 1L:
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      res = pattern1048 (x1);
      if (res >= 0)
        return res + 7; /* [7, 13] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1067 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1073 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1081 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i3)
      || !vect_par_cnst_even_or_odd_half (operands[3], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !vect_par_cnst_even_or_odd_half (operands[4], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1096 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (maybe_ne (SUBREG_BYTE (x4), 0))
    return -1;
  x5 = XEXP (x4, 0);
  if (!aarch64_sve_ptrue_svpattern_immediate (x5, E_VNx16BImode))
    return -1;
  operands[1] = x5;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != 128
      || GET_MODE (x6) != E_VNx16BImode)
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[3] = x8;
  x9 = XVECEXP (x6, 0, 0);
  operands[4] = x9;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 1);
  operands[5] = x10;
  x11 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x11))
    {
    case SET:
      x12 = XEXP (x11, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_VNx16BImode))
        return -1;
      x13 = XEXP (x11, 1);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      return pattern1095 (x4); /* [-1, 2] */

    case CLOBBER:
      x12 = XEXP (x11, 0);
      operands[0] = x12;
      if (!scratch_operand (operands[0], E_VNx16BImode))
        return -1;
      res = pattern1095 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1110 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !aarch64_simd_reg_or_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1115 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1120 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1124 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern851 (x1, 
E_VNx8HFmode); /* [-1, 2] */

    case E_VNx4SFmode:
      res = pattern851 (x1, 
E_VNx4SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DFmode:
      res = pattern851 (x1, 
E_VNx2DFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1134 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[4] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          return pattern1140 (x1, 
E_VNx8BImode, 
E_VNx8HFmode); /* [-1, 0] */

        case E_VNx4BImode:
          if (pattern1140 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 1;

        case E_VNx2BImode:
          if (pattern1140 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case NOT:
      x4 = XEXP (x3, 0);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern1141 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 3;

        case E_VNx4BImode:
          if (pattern1141 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 4;

        case E_VNx2BImode:
          if (pattern1141 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1165 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !memory_operand (operands[3], i1)
      || pattern936 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern1169 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1177 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_int_rnd_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1188 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  x10 = XEXP (x8, 1);
  operands[3] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x4, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  return pattern1187 (x1); /* [-1, 1] */
}

int
pattern1193 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1199 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1198 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1198 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1198 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1198 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1211 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !vect_par_cnst_even_or_odd_half (operands[3], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !vect_par_cnst_even_or_odd_half (operands[4], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  return pattern1155 (x8, 
i1); /* [-1, 0] */
}

int
pattern1228 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1235 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1242 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i4)
      || GET_MODE (x1) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_int_rnd_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1250 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case SET:
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 3
          || XINT (x7, 1) != i1)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x9 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x9, operands[4]))
        return -1;
      x10 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x10, operands[5]))
        return -1;
      x11 = XVECEXP (x7, 0, 2);
      if (!rtx_equal_p (x11, operands[6]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[6], E_VNx16BImode)
              || !register_operand (operands[0], E_VNx16BImode)
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          return 0;

        case E_VNx8BImode:
          if (!register_operand (operands[6], E_VNx8BImode)
              || !register_operand (operands[0], E_VNx8BImode)
              || GET_MODE (x7) != E_VNx8BImode)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (!register_operand (operands[6], E_VNx4BImode)
              || !register_operand (operands[0], E_VNx4BImode)
              || GET_MODE (x7) != E_VNx4BImode)
            return -1;
          return 2;

        case E_VNx2BImode:
          if (!register_operand (operands[6], E_VNx2BImode)
              || !register_operand (operands[0], E_VNx2BImode)
              || GET_MODE (x7) != E_VNx2BImode)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[6], E_VNx16BImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 4;

        case E_VNx8BImode:
          if (!register_operand (operands[6], E_VNx8BImode)
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          return 5;

        case E_VNx4BImode:
          if (!register_operand (operands[6], E_VNx4BImode)
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          return 6;

        case E_VNx2BImode:
          if (!register_operand (operands[6], E_VNx2BImode)
              || !scratch_operand (operands[0], E_VNx2BImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1286 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1293 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1303 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1307 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_gather_scale_operand_h (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 5);
  operands[7] = x2;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          return pattern1311 (x1); /* [-1, 7] */

        case TRUNCATE:
          if (GET_MODE (x5) != E_VNx2SImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_VNx2DImode))
            return -1;
          res = pattern1310 (x1);
          if (res >= 0)
            return res + 8; /* [8, 15] */
          return -1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      res = pattern1311 (x1);
      if (res >= 0)
        return res + 16; /* [16, 23] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1325 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[2], E_VNx32QImode)
          || !aligned_register_operand (operands[3], E_VNx32QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[2], E_VNx64QImode)
          || !aligned_register_operand (operands[3], E_VNx64QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1331 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4QImode))
        return -1;
      return 0;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4HImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4HImode))
        return -1;
      return 1;

    case E_VNx4SImode:
      if (!register_operand (operands[2], E_VNx4SImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1340 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1)
      || pattern1338 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1345 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_gather_scale_operand_d (operands[4], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode)
        return -1;
      return 0;

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x1) != E_VNx2DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1352 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[3], E_V4HFmode)
          || !aarch64_imm2 (operands[5], E_SImode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!register_operand (operands[3], E_V8HFmode)
          || !aarch64_lane_imm3 (operands[5], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1357 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[2], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode
          || !register_operand (operands[3], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[2], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode
          || !register_operand (operands[3], E_VNx8BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[2], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode
          || !register_operand (operands[3], E_VNx8HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[2], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode
          || !register_operand (operands[3], E_VNx8HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1369 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case EQ:
      switch (pattern719 (x2, pnum_clobbers))
        {
        case 0:
          x7 = XEXP (x6, 1);
          operands[1] = x7;
          x8 = XEXP (x3, 0);
          operands[2] = x8;
          switch (pattern702 (x3))
            {
            case 0:
              if ((
#line 908 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)))
                return 20; /* *compare_condjumpsi */
              break;

            case 1:
              if ((
#line 908 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 164 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)))
                return 24; /* *compare_condjumpsi */
              break;

            case 2:
              if ((
#line 908 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)))
                return 22; /* *compare_condjumpdi */
              break;

            case 3:
              if ((
#line 908 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 164 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)))
                return 26; /* *compare_condjumpdi */
              break;

            default:
              break;
            }
          if (XWINT (x7, 0) != 0L)
            return -1;
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                return -1;
              return 35; /* aarch64_cbeqsi1 */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                return -1;
              return 37; /* aarch64_cbeqdi1 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 39; /* aarch64_tbeqqisi */

        case 2:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 43; /* aarch64_tbeqhisi */

        case 3:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 47; /* aarch64_tbeqsisi */

        case 4:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 51; /* aarch64_tbeqdisi */

        case 5:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 41; /* aarch64_tbeqqidi */

        case 6:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 45; /* aarch64_tbeqhidi */

        case 7:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 49; /* aarch64_tbeqsidi */

        case 8:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 53; /* aarch64_tbeqdidi */

        default:
          return -1;
        }

    case NE:
      switch (pattern719 (x2, pnum_clobbers))
        {
        case 0:
          x7 = XEXP (x6, 1);
          operands[1] = x7;
          x8 = XEXP (x3, 0);
          operands[2] = x8;
          switch (pattern702 (x3))
            {
            case 0:
              if ((
#line 908 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)))
                return 21; /* *compare_condjumpsi */
              break;

            case 1:
              if ((
#line 908 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), SImode)
   && !aarch64_plus_operand (operands[1], SImode)
   && !reload_completed) && 
#line 164 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)))
                return 25; /* *compare_condjumpsi */
              break;

            case 2:
              if ((
#line 908 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode)))
                return 23; /* *compare_condjumpdi */
              break;

            case 3:
              if ((
#line 908 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[1]), DImode)
   && !aarch64_plus_operand (operands[1], DImode)
   && !reload_completed) && 
#line 164 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode)))
                return 27; /* *compare_condjumpdi */
              break;

            default:
              break;
            }
          if (XWINT (x7, 0) != 0L)
            return -1;
          operands[1] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                return -1;
              return 36; /* aarch64_cbnesi1 */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 1124 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
                return -1;
              return 38; /* aarch64_cbnedi1 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 40; /* aarch64_tbneqisi */

        case 2:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 44; /* aarch64_tbnehisi */

        case 3:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 48; /* aarch64_tbnesisi */

        case 4:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 52; /* aarch64_tbnedisi */

        case 5:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 42; /* aarch64_tbneqidi */

        case 6:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 46; /* aarch64_tbnehidi */

        case 7:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 50; /* aarch64_tbnesidi */

        case 8:
          if (!
#line 1171 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 54; /* aarch64_tbnedidi */

        default:
          return -1;
        }

    case LT:
      switch (pattern720 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 55; /* *cbltqi1 */

        case 1:
          if (!
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 57; /* *cblthi1 */

        case 2:
          if (!
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 59; /* *cbltsi1 */

        case 3:
          if (!
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 61; /* *cbltdi1 */

        default:
          return -1;
        }

    case GE:
      switch (pattern720 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 56; /* *cbgeqi1 */

        case 1:
          if (!
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 58; /* *cbgehi1 */

        case 2:
          if (!
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 60; /* *cbgesi1 */

        case 3:
          if (!
#line 1207 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_track_speculation))
            return -1;
          *pnum_clobbers = 1;
          return 62; /* *cbgedi1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern377 (x3))
    {
    case 0:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5599; /* *aarch64_sve_reinterpretvnx16qi */

    case 1:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5600; /* *aarch64_sve_reinterpretvnx8qi */

    case 2:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5601; /* *aarch64_sve_reinterpretvnx4qi */

    case 3:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5602; /* *aarch64_sve_reinterpretvnx2qi */

    case 4:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5603; /* *aarch64_sve_reinterpretvnx8hi */

    case 5:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5604; /* *aarch64_sve_reinterpretvnx4hi */

    case 6:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5605; /* *aarch64_sve_reinterpretvnx2hi */

    case 7:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5606; /* *aarch64_sve_reinterpretvnx4si */

    case 8:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5607; /* *aarch64_sve_reinterpretvnx2si */

    case 9:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5608; /* *aarch64_sve_reinterpretvnx2di */

    case 10:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5609; /* *aarch64_sve_reinterpretvnx8hf */

    case 11:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5610; /* *aarch64_sve_reinterpretvnx4hf */

    case 12:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5611; /* *aarch64_sve_reinterpretvnx2hf */

    case 13:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5612; /* *aarch64_sve_reinterpretvnx8bf */

    case 14:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5613; /* *aarch64_sve_reinterpretvnx4bf */

    case 15:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5614; /* *aarch64_sve_reinterpretvnx2bf */

    case 16:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5615; /* *aarch64_sve_reinterpretvnx4sf */

    case 17:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5616; /* *aarch64_sve_reinterpretvnx2sf */

    case 18:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5617; /* *aarch64_sve_reinterpretvnx2df */

    case 19:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5618; /* *aarch64_sve_reinterpretvnx32qi */

    case 20:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5619; /* *aarch64_sve_reinterpretvnx16hi */

    case 21:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5620; /* *aarch64_sve_reinterpretvnx8si */

    case 22:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5621; /* *aarch64_sve_reinterpretvnx4di */

    case 23:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5622; /* *aarch64_sve_reinterpretvnx16bf */

    case 24:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5623; /* *aarch64_sve_reinterpretvnx16hf */

    case 25:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5624; /* *aarch64_sve_reinterpretvnx8sf */

    case 26:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5625; /* *aarch64_sve_reinterpretvnx4df */

    case 27:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5626; /* *aarch64_sve_reinterpretvnx48qi */

    case 28:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5627; /* *aarch64_sve_reinterpretvnx24hi */

    case 29:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5628; /* *aarch64_sve_reinterpretvnx12si */

    case 30:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5629; /* *aarch64_sve_reinterpretvnx6di */

    case 31:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5630; /* *aarch64_sve_reinterpretvnx24bf */

    case 32:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5631; /* *aarch64_sve_reinterpretvnx24hf */

    case 33:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5632; /* *aarch64_sve_reinterpretvnx12sf */

    case 34:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5633; /* *aarch64_sve_reinterpretvnx6df */

    case 35:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5634; /* *aarch64_sve_reinterpretvnx64qi */

    case 36:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5635; /* *aarch64_sve_reinterpretvnx32hi */

    case 37:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5636; /* *aarch64_sve_reinterpretvnx16si */

    case 38:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5637; /* *aarch64_sve_reinterpretvnx8di */

    case 39:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5638; /* *aarch64_sve_reinterpretvnx32bf */

    case 40:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5639; /* *aarch64_sve_reinterpretvnx32hf */

    case 41:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5640; /* *aarch64_sve_reinterpretvnx16sf */

    case 42:
      if (!
#line 812 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5641; /* *aarch64_sve_reinterpretvnx8df */

    default:
      return -1;
    }
}

 int
recog_38 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern55 (x1))
    {
    case 0:
      if (!(
#line 6843 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 899; /* roundevenhf2 */

    case 1:
      if (!
#line 6843 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 906; /* roundevensf2 */

    case 2:
      if (!
#line 6843 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 913; /* roundevendf2 */

    case 3:
      if (!(
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2496; /* roundevenv4hf2 */

    case 4:
      if (!(
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2511; /* roundevenv8hf2 */

    case 5:
      if (!
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2524; /* roundevenv2sf2 */

    case 6:
      if (!
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2539; /* roundevenv4sf2 */

    case 7:
      if (!
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2546; /* roundevenv2df2 */

    case 8:
      if (!
#line 700 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11450; /* roundevenvnx8sf2 */

    case 9:
      if (!
#line 700 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11454; /* roundevenvnx16sf2 */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_BFmode:
      if (!register_operand (operands[0], E_BFmode)
          || GET_MODE (x3) != E_BFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 9995 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_FP))
        return -1;
      return 5276; /* aarch64_bfcvtbf */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_BFmode)
          || !
#line 10023 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_FP))
        return -1;
      return 5280; /* aarch64_bfcvtsf */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern54 (x1))
    {
    case 0:
      if (!(
#line 6843 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 900; /* nearbyinthf2 */

    case 1:
      if (!
#line 6843 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 907; /* nearbyintsf2 */

    case 2:
      if (!
#line 6843 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 914; /* nearbyintdf2 */

    case 3:
      if (!(
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2499; /* nearbyintv4hf2 */

    case 4:
      if (!(
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2512; /* nearbyintv8hf2 */

    case 5:
      if (!
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2527; /* nearbyintv2sf2 */

    case 6:
      if (!
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2540; /* nearbyintv4sf2 */

    case 7:
      if (!
#line 3005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2547; /* nearbyintv2df2 */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      switch (XINT (x4, 1))
        {
        case 316:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern876 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
                return -1;
              return 6911; /* aarch64_pred_revbvnx16qi */

            case E_VNx8HImode:
              if (pattern876 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
                return -1;
              return 6914; /* aarch64_pred_revbvnx8hi */

            case E_VNx4SImode:
              if (pattern876 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
                return -1;
              return 6917; /* aarch64_pred_revbvnx4si */

            case E_VNx2DImode:
              if (pattern876 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
                return -1;
              return 6920; /* aarch64_pred_revbvnx2di */

            default:
              return -1;
            }

        case 318:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern876 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
                return -1;
              return 6912; /* aarch64_pred_revhvnx16qi */

            case E_VNx8HImode:
              if (pattern876 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
                return -1;
              return 6915; /* aarch64_pred_revhvnx8hi */

            case E_VNx4SImode:
              if (pattern876 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
                return -1;
              return 6918; /* aarch64_pred_revhvnx4si */

            case E_VNx2DImode:
              if (pattern876 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
                return -1;
              return 6921; /* aarch64_pred_revhvnx2di */

            default:
              return -1;
            }

        case 319:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern876 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
                return -1;
              return 6913; /* aarch64_pred_revwvnx16qi */

            case E_VNx8HImode:
              if (pattern876 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
                return -1;
              return 6916; /* aarch64_pred_revwvnx8hi */

            case E_VNx4SImode:
              if (pattern876 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
                return -1;
              return 6919; /* aarch64_pred_revwvnx4si */

            case E_VNx2DImode:
              if (pattern876 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3277 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
                return -1;
              return 6922; /* aarch64_pred_revwvnx2di */

            default:
              return -1;
            }

        case 320:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              switch (pattern943 (x2, 
E_VNx16QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 8))
                    return -1;
                  return 6923; /* aarch64_sve_revbhw_vnx16qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 8))
                    return -1;
                  return 6942; /* aarch64_sve_revbhw_vnx16qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 8))
                    return -1;
                  return 6961; /* aarch64_sve_revbhw_vnx16qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx8QImode:
              switch (pattern943 (x2, 
E_VNx8QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6924; /* aarch64_sve_revbhw_vnx8qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6943; /* aarch64_sve_revbhw_vnx8qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6962; /* aarch64_sve_revbhw_vnx8qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4QImode:
              switch (pattern943 (x2, 
E_VNx4QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6925; /* aarch64_sve_revbhw_vnx4qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6944; /* aarch64_sve_revbhw_vnx4qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6963; /* aarch64_sve_revbhw_vnx4qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2QImode:
              switch (pattern943 (x2, 
E_VNx2QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6926; /* aarch64_sve_revbhw_vnx2qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6945; /* aarch64_sve_revbhw_vnx2qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6964; /* aarch64_sve_revbhw_vnx2qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx8HImode:
              switch (pattern943 (x2, 
E_VNx8HImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6927; /* aarch64_sve_revbhw_vnx8hivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6946; /* aarch64_sve_revbhw_vnx8hivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6965; /* aarch64_sve_revbhw_vnx8hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4HImode:
              switch (pattern943 (x2, 
E_VNx4HImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6928; /* aarch64_sve_revbhw_vnx4hivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6947; /* aarch64_sve_revbhw_vnx4hivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6966; /* aarch64_sve_revbhw_vnx4hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2HImode:
              switch (pattern943 (x2, 
E_VNx2HImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6929; /* aarch64_sve_revbhw_vnx2hivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6948; /* aarch64_sve_revbhw_vnx2hivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6967; /* aarch64_sve_revbhw_vnx2hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4SImode:
              switch (pattern943 (x2, 
E_VNx4SImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6930; /* aarch64_sve_revbhw_vnx4sivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6949; /* aarch64_sve_revbhw_vnx4sivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6968; /* aarch64_sve_revbhw_vnx4sivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2SImode:
              switch (pattern943 (x2, 
E_VNx2SImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6931; /* aarch64_sve_revbhw_vnx2sivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6950; /* aarch64_sve_revbhw_vnx2sivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6969; /* aarch64_sve_revbhw_vnx2sivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2DImode:
              switch (pattern943 (x2, 
E_VNx2DImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6932; /* aarch64_sve_revbhw_vnx2divnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6951; /* aarch64_sve_revbhw_vnx2divnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6970; /* aarch64_sve_revbhw_vnx2divnx2bi */

                default:
                  return -1;
                }

            case E_VNx8HFmode:
              switch (pattern943 (x2, 
E_VNx8HFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6933; /* aarch64_sve_revbhw_vnx8hfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6952; /* aarch64_sve_revbhw_vnx8hfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6971; /* aarch64_sve_revbhw_vnx8hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4HFmode:
              switch (pattern943 (x2, 
E_VNx4HFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6934; /* aarch64_sve_revbhw_vnx4hfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6953; /* aarch64_sve_revbhw_vnx4hfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6972; /* aarch64_sve_revbhw_vnx4hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2HFmode:
              switch (pattern943 (x2, 
E_VNx2HFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6935; /* aarch64_sve_revbhw_vnx2hfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6954; /* aarch64_sve_revbhw_vnx2hfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6973; /* aarch64_sve_revbhw_vnx2hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx8BFmode:
              switch (pattern943 (x2, 
E_VNx8BFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6936; /* aarch64_sve_revbhw_vnx8bfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6955; /* aarch64_sve_revbhw_vnx8bfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6974; /* aarch64_sve_revbhw_vnx8bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4BFmode:
              switch (pattern943 (x2, 
E_VNx4BFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6937; /* aarch64_sve_revbhw_vnx4bfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6956; /* aarch64_sve_revbhw_vnx4bfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6975; /* aarch64_sve_revbhw_vnx4bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2BFmode:
              switch (pattern943 (x2, 
E_VNx2BFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6938; /* aarch64_sve_revbhw_vnx2bfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6957; /* aarch64_sve_revbhw_vnx2bfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6976; /* aarch64_sve_revbhw_vnx2bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4SFmode:
              switch (pattern943 (x2, 
E_VNx4SFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6939; /* aarch64_sve_revbhw_vnx4sfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6958; /* aarch64_sve_revbhw_vnx4sfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6977; /* aarch64_sve_revbhw_vnx4sfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2SFmode:
              switch (pattern943 (x2, 
E_VNx2SFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6940; /* aarch64_sve_revbhw_vnx2sfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6959; /* aarch64_sve_revbhw_vnx2sfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6978; /* aarch64_sve_revbhw_vnx2sfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2DFmode:
              switch (pattern943 (x2, 
E_VNx2DFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6941; /* aarch64_sve_revbhw_vnx2dfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6960; /* aarch64_sve_revbhw_vnx2dfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6979; /* aarch64_sve_revbhw_vnx2dfvnx2bi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 26:
          if (pattern867 (x2) != 0
              || !
#line 3465 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12667; /* aarch64_pred_urecpevnx4si */

        case 111:
          if (pattern867 (x2) != 0
              || !
#line 3465 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12668; /* aarch64_pred_ursqrtevnx4si */

        case 317:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern995 (x2, 
E_VNx16QImode) != 0
                  || !
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12818; /* aarch64_pred_revdvnx16qi */

            case E_VNx8HImode:
              if (pattern995 (x2, 
E_VNx8HImode) != 0
                  || !
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12819; /* aarch64_pred_revdvnx8hi */

            case E_VNx4SImode:
              if (pattern995 (x2, 
E_VNx4SImode) != 0
                  || !
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12820; /* aarch64_pred_revdvnx4si */

            case E_VNx2DImode:
              if (pattern995 (x2, 
E_VNx2DImode) != 0
                  || !
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12821; /* aarch64_pred_revdvnx2di */

            case E_VNx8BFmode:
              if (pattern995 (x2, 
E_VNx8BFmode) != 0
                  || !
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12822; /* aarch64_pred_revdvnx8bf */

            case E_VNx8HFmode:
              if (pattern995 (x2, 
E_VNx8HFmode) != 0
                  || !
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12823; /* aarch64_pred_revdvnx8hf */

            case E_VNx4SFmode:
              if (pattern995 (x2, 
E_VNx4SFmode) != 0
                  || !
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12824; /* aarch64_pred_revdvnx4sf */

            case E_VNx2DFmode:
              if (pattern995 (x2, 
E_VNx2DFmode) != 0
                  || !
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12825; /* aarch64_pred_revdvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_60 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern106 (x1))
    {
    case 0:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4850; /* aarch64_trn1v8qi */

    case 1:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4864; /* aarch64_trn1v16qi */

    case 2:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4874; /* aarch64_trn1v4hi */

    case 3:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4888; /* aarch64_trn1v8hi */

    case 4:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4898; /* aarch64_trn1v2si */

    case 5:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4912; /* aarch64_trn1v4si */

    case 6:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4918; /* aarch64_trn1v2di */

    case 7:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4928; /* aarch64_trn1v4hf */

    case 8:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4942; /* aarch64_trn1v8hf */

    case 9:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4952; /* aarch64_trn1v4bf */

    case 10:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4966; /* aarch64_trn1v8bf */

    case 11:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4976; /* aarch64_trn1v2sf */

    case 12:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4990; /* aarch64_trn1v4sf */

    case 13:
      if (!
#line 8634 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4996; /* aarch64_trn1v2df */

    case 14:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10533; /* aarch64_sve_trn1vnx16qi */

    case 15:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10543; /* aarch64_sve_trn1vnx8qi */

    case 16:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10553; /* aarch64_sve_trn1vnx4qi */

    case 17:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10563; /* aarch64_sve_trn1vnx2qi */

    case 18:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10573; /* aarch64_sve_trn1vnx8hi */

    case 19:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10583; /* aarch64_sve_trn1vnx4hi */

    case 20:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10593; /* aarch64_sve_trn1vnx2hi */

    case 21:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10603; /* aarch64_sve_trn1vnx4si */

    case 22:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10613; /* aarch64_sve_trn1vnx2si */

    case 23:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10623; /* aarch64_sve_trn1vnx2di */

    case 24:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10633; /* aarch64_sve_trn1vnx8hf */

    case 25:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10643; /* aarch64_sve_trn1vnx4hf */

    case 26:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10653; /* aarch64_sve_trn1vnx2hf */

    case 27:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10663; /* aarch64_sve_trn1vnx8bf */

    case 28:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10673; /* aarch64_sve_trn1vnx4bf */

    case 29:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10683; /* aarch64_sve_trn1vnx2bf */

    case 30:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10693; /* aarch64_sve_trn1vnx4sf */

    case 31:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10703; /* aarch64_sve_trn1vnx2sf */

    case 32:
      if (!
#line 9215 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10713; /* aarch64_sve_trn1vnx2df */

    case 33:
      if (!
#line 9284 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10794; /* aarch64_sve_trn1vnx16bi */

    case 34:
      if (!
#line 9284 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10800; /* aarch64_sve_trn1vnx8bi */

    case 35:
      if (!
#line 9284 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10806; /* aarch64_sve_trn1vnx4bi */

    case 36:
      if (!
#line 9284 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10812; /* aarch64_sve_trn1vnx2bi */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      switch (pattern724 (x3, 
E_V8QImode))
        {
        case 0:
          if (!
#line 8525 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4827; /* aarch64_qtbl1v8qi */

        case 1:
          if (!
#line 8548 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4831; /* aarch64_qtbl2v8qi */

        case 2:
          if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4835; /* aarch64_qtbl3v8qi */

        case 3:
          if (!
#line 8594 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4839; /* aarch64_qtbl4v8qi */

        default:
          return -1;
        }

    case E_V16QImode:
      switch (pattern724 (x3, 
E_V16QImode))
        {
        case 0:
          if (!
#line 8525 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4828; /* aarch64_qtbl1v16qi */

        case 1:
          if (!
#line 8548 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4832; /* aarch64_qtbl2v16qi */

        case 2:
          if (!
#line 8571 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4836; /* aarch64_qtbl3v16qi */

        case 3:
          if (!
#line 8594 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4840; /* aarch64_qtbl4v16qi */

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (pattern77 (x3, 
E_VNx16QImode) != 0
          || !
#line 9093 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10457; /* aarch64_sve_tblvnx16qi */

    case E_VNx8HImode:
      if (pattern77 (x3, 
E_VNx8HImode) != 0
          || !
#line 9093 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10459; /* aarch64_sve_tblvnx8hi */

    case E_VNx4SImode:
      if (pattern77 (x3, 
E_VNx4SImode) != 0
          || !
#line 9093 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10461; /* aarch64_sve_tblvnx4si */

    case E_VNx2DImode:
      if (pattern77 (x3, 
E_VNx2DImode) != 0
          || !
#line 9093 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10463; /* aarch64_sve_tblvnx2di */

    case E_VNx8BFmode:
      if (pattern116 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !
#line 9093 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10465; /* aarch64_sve_tblvnx8bf */

    case E_VNx8HFmode:
      if (pattern116 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !
#line 9093 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10467; /* aarch64_sve_tblvnx8hf */

    case E_VNx4SFmode:
      if (pattern116 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !
#line 9093 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10469; /* aarch64_sve_tblvnx4sf */

    case E_VNx2DFmode:
      if (pattern116 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !
#line 9093 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10471; /* aarch64_sve_tblvnx2df */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern104 (x1))
    {
    case 0:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3709; /* aarch64_uqshlv8qi */

    case 1:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3719; /* aarch64_uqshlv16qi */

    case 2:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3725; /* aarch64_uqshlv4hi */

    case 3:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3735; /* aarch64_uqshlv8hi */

    case 4:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3741; /* aarch64_uqshlv2si */

    case 5:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3751; /* aarch64_uqshlv4si */

    case 6:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3755; /* aarch64_uqshlv2di */

    case 7:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3759; /* aarch64_uqshlqi */

    case 8:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3763; /* aarch64_uqshlhi */

    case 9:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3767; /* aarch64_uqshlsi */

    case 10:
      if (!
#line 6521 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3773; /* aarch64_uqshldi */

    case 11:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3862; /* aarch64_uqshl_nv8qi */

    case 12:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3865; /* aarch64_uqshl_nv16qi */

    case 13:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3868; /* aarch64_uqshl_nv4hi */

    case 14:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3871; /* aarch64_uqshl_nv8hi */

    case 15:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3874; /* aarch64_uqshl_nv2si */

    case 16:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3877; /* aarch64_uqshl_nv4si */

    case 17:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3880; /* aarch64_uqshl_nv2di */

    case 18:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3883; /* aarch64_uqshl_nqi */

    case 19:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3886; /* aarch64_uqshl_nhi */

    case 20:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3889; /* aarch64_uqshl_nsi */

    case 21:
      if (!
#line 6668 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3892; /* aarch64_uqshl_ndi */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern114 (x1))
    {
    case 0:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6532; /* extract_last_vnx16qi */

    case 1:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6534; /* extract_last_vnx8qi */

    case 2:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6536; /* extract_last_vnx4qi */

    case 3:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6538; /* extract_last_vnx2qi */

    case 4:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6540; /* extract_last_vnx8hi */

    case 5:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6542; /* extract_last_vnx4hi */

    case 6:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6544; /* extract_last_vnx2hi */

    case 7:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6546; /* extract_last_vnx4si */

    case 8:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6548; /* extract_last_vnx2si */

    case 9:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6550; /* extract_last_vnx2di */

    case 10:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6552; /* extract_last_vnx8hf */

    case 11:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6554; /* extract_last_vnx4hf */

    case 12:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6556; /* extract_last_vnx2hf */

    case 13:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6558; /* extract_last_vnx8bf */

    case 14:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6560; /* extract_last_vnx4bf */

    case 15:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6562; /* extract_last_vnx2bf */

    case 16:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6564; /* extract_last_vnx4sf */

    case 17:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6566; /* extract_last_vnx2sf */

    case 18:
      if (!
#line 3112 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6568; /* extract_last_vnx2df */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern379 (x3))
    {
    case 0:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5580; /* *aarch64_sve_movvnx16qi_subreg_be */

    case 1:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5581; /* *aarch64_sve_movvnx8qi_subreg_be */

    case 2:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5582; /* *aarch64_sve_movvnx4qi_subreg_be */

    case 3:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5583; /* *aarch64_sve_movvnx2qi_subreg_be */

    case 4:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5584; /* *aarch64_sve_movvnx8hi_subreg_be */

    case 5:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5585; /* *aarch64_sve_movvnx4hi_subreg_be */

    case 6:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5586; /* *aarch64_sve_movvnx2hi_subreg_be */

    case 7:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5587; /* *aarch64_sve_movvnx4si_subreg_be */

    case 8:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5588; /* *aarch64_sve_movvnx2si_subreg_be */

    case 9:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5589; /* *aarch64_sve_movvnx2di_subreg_be */

    case 10:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5590; /* *aarch64_sve_movvnx8hf_subreg_be */

    case 11:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5591; /* *aarch64_sve_movvnx4hf_subreg_be */

    case 12:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5592; /* *aarch64_sve_movvnx2hf_subreg_be */

    case 13:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5593; /* *aarch64_sve_movvnx8bf_subreg_be */

    case 14:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5594; /* *aarch64_sve_movvnx4bf_subreg_be */

    case 15:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5595; /* *aarch64_sve_movvnx2bf_subreg_be */

    case 16:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5596; /* *aarch64_sve_movvnx4sf_subreg_be */

    case 17:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5597; /* *aarch64_sve_movvnx2sf_subreg_be */

    case 18:
      if (!
#line 776 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
        return -1;
      return 5598; /* *aarch64_sve_movvnx2df_subreg_be */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern91 (x1))
    {
    case 0:
      if (!
#line 1800 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2129; /* aarch64_sminpv8qi */

    case 1:
      if (!
#line 1800 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2135; /* aarch64_sminpv16qi */

    case 2:
      if (!
#line 1800 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2145; /* aarch64_sminpv4hi */

    case 3:
      if (!
#line 1800 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2151; /* aarch64_sminpv8hi */

    case 4:
      if (!
#line 1800 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2161; /* aarch64_sminpv2si */

    case 5:
      if (!
#line 1800 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2167; /* aarch64_sminpv4si */

    case 6:
      if (!
#line 8983 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10414; /* aarch64_pred_reduc_smin_vnx16qi */

    case 7:
      if (!
#line 8983 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10421; /* aarch64_pred_reduc_smin_vnx8hi */

    case 8:
      if (!
#line 8983 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10428; /* aarch64_pred_reduc_smin_vnx4si */

    case 9:
      if (!
#line 8983 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10435; /* aarch64_pred_reduc_smin_vnx2di */

    default:
      return -1;
    }
}

 int
recog_126 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern118 (x1))
    {
    case 0:
      if (!
#line 6579 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9018; /* *xorvnx8hf3 */

    case 1:
      if (!
#line 6579 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9021; /* *xorvnx4hf3 */

    case 2:
      if (!
#line 6579 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9024; /* *xorvnx2hf3 */

    case 3:
      if (!
#line 6579 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9027; /* *xorvnx8bf3 */

    case 4:
      if (!
#line 6579 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9030; /* *xorvnx4bf3 */

    case 5:
      if (!
#line 6579 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9033; /* *xorvnx2bf3 */

    case 6:
      if (!
#line 6579 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9036; /* *xorvnx4sf3 */

    case 7:
      if (!
#line 6579 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9039; /* *xorvnx2sf3 */

    case 8:
      if (!
#line 6579 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9042; /* *xorvnx2df3 */

    default:
      return -1;
    }
}

 int
recog_137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern122 (x1))
    {
    case 0:
      if (!
#line 9227 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10723; /* aarch64_sve_trn1qvnx16qi */

    case 1:
      if (!
#line 9227 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10729; /* aarch64_sve_trn1qvnx8hi */

    case 2:
      if (!
#line 9227 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10735; /* aarch64_sve_trn1qvnx4si */

    case 3:
      if (!
#line 9227 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10741; /* aarch64_sve_trn1qvnx2di */

    case 4:
      if (!
#line 9227 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10747; /* aarch64_sve_trn1qvnx8bf */

    case 5:
      if (!
#line 9227 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10753; /* aarch64_sve_trn1qvnx8hf */

    case 6:
      if (!
#line 9227 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10759; /* aarch64_sve_trn1qvnx4sf */

    case 7:
      if (!
#line 9227 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10765; /* aarch64_sve_trn1qvnx2df */

    default:
      return -1;
    }
}

 int
recog_147 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern92 (x1))
    {
    case 0:
      if (!(
#line 1811 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2168; /* aarch64_smax_nanpv4hf */

    case 1:
      if (!(
#line 1811 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2180; /* aarch64_smax_nanpv8hf */

    case 2:
      if (!
#line 1811 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2184; /* aarch64_smax_nanpv2sf */

    case 3:
      if (!
#line 1811 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2196; /* aarch64_smax_nanpv4sf */

    case 4:
      if (!
#line 1811 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2200; /* aarch64_smax_nanpv2df */

    case 5:
      if (!
#line 9027 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10440; /* aarch64_pred_reduc_smax_nan_vnx8hf */

    case 6:
      if (!
#line 9027 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10445; /* aarch64_pred_reduc_smax_nan_vnx4sf */

    case 7:
      if (!
#line 9027 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10450; /* aarch64_pred_reduc_smax_nan_vnx2df */

    default:
      return -1;
    }
}

 int
recog_158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern137 (x2, 
84, 
E_VNx16QImode) != 0)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[1], E_VNx16BFmode)
          || !
#line 3387 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
        return -1;
      return 12655; /* aarch64_sve2_fp8_cvtnvnx16bf */

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[1], E_VNx16HFmode)
          || !
#line 3387 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8))
        return -1;
      return 12656; /* aarch64_sve2_fp8_cvtnvnx16hf */

    default:
      return -1;
    }
}

 int
recog_167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern87 (x1))
    {
    case 0:
      if (!(
#line 10034 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5282; /* aarch64_faminv4hf */

    case 1:
      if (!(
#line 10034 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5284; /* aarch64_faminv8hf */

    case 2:
      if (!
#line 10034 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5286; /* aarch64_faminv2sf */

    case 3:
      if (!
#line 10034 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5288; /* aarch64_faminv4sf */

    case 4:
      if (!
#line 10034 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FAMINMAX))
        return -1;
      return 5290; /* aarch64_faminv2df */

    default:
      return -1;
    }
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern140 (x1))
    {
    case 0:
      if (!
#line 3723 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12775; /* aarch64_pred_reduc_smaxqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12783; /* aarch64_pred_reduc_smaxqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12791; /* aarch64_pred_reduc_smaxqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12799; /* aarch64_pred_reduc_smaxqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern120 (x1))
    {
    case 0:
      if (!
#line 8983 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10412; /* aarch64_pred_reduc_ior_vnx16qi */

    case 1:
      if (!
#line 8983 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10419; /* aarch64_pred_reduc_ior_vnx8hi */

    case 2:
      if (!
#line 8983 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10426; /* aarch64_pred_reduc_ior_vnx4si */

    case 3:
      if (!
#line 8983 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10433; /* aarch64_pred_reduc_ior_vnx2di */

    default:
      return -1;
    }
}

 int
recog_197 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0L:
      res = recog_193 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case 1L:
      x5 = XVECEXP (x3, 0, 2);
      operands[2] = x5;
      switch (pattern871 (x2))
        {
        case 0:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 3732 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7261; /* *cond_absvnx8hf_2_strict */
          operands[3] = x6;
          if (aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
              && 
#line 3781 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return 7327; /* *cond_absvnx8hf_any_strict */
          break;

        case 1:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 3732 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7272; /* *cond_absvnx4sf_2_strict */
          operands[3] = x6;
          if (aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
              && 
#line 3781 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return 7338; /* *cond_absvnx4sf_any_strict */
          break;

        case 2:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 3732 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7283; /* *cond_absvnx2df_2_strict */
          operands[3] = x6;
          if (aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
              && 
#line 3781 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
            return 7349; /* *cond_absvnx2df_any_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[4] = x4;
  if (aarch64_sve_gp_strictness (operands[4], E_SImode))
    {
      res = recog_194 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 4
      || XINT (x5, 1) != 393)
    return -1;
  x7 = XVECEXP (x5, 0, 2);
  operands[2] = x7;
  x8 = XVECEXP (x5, 0, 3);
  operands[3] = x8;
  x6 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x6, operands[3]))
    {
      res = recog_195 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[4] = x6;
  if (XWINT (x4, 0) == 0L)
    {
      x9 = XVECEXP (x5, 0, 1);
      if (x9 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x10 = XVECEXP (x3, 0, 0);
          operands[5] = x10;
          x11 = XVECEXP (x5, 0, 0);
          operands[6] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1305 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) == 0
                  && 
#line 6408 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return 9003; /* *aarch64_cond_abdvnx8hf_any_relaxed */
              break;

            case E_VNx4SFmode:
              if (pattern1305 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) == 0
                  && 
#line 6408 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return 9004; /* *aarch64_cond_abdvnx4sf_any_relaxed */
              break;

            case E_VNx2DFmode:
              if (pattern1305 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) == 0
                  && 
#line 6408 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return 9005; /* *aarch64_cond_abdvnx2df_any_relaxed */
              break;

            default:
              break;
            }
        }
    }
  operands[5] = x4;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x9 = XVECEXP (x5, 0, 1);
  operands[6] = x9;
  if (!aarch64_sve_gp_strictness (operands[6], E_SImode))
    return -1;
  switch (pattern1306 (x2))
    {
    case 0:
      if (!
#line 6456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 9006; /* *aarch64_cond_abdvnx8hf_any_strict */

    case 1:
      if (!
#line 6456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 9007; /* *aarch64_cond_abdvnx4sf_any_strict */

    case 2:
      if (!
#line 6456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 9008; /* *aarch64_cond_abdvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_213 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1242 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11829; /* *cond_sqshlvnx4si_2 */
    }
  if (register_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1269 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11837; /* *cond_sqshlvnx4si_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1294 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11845; /* *cond_sqshlvnx4si_any */
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11700; /* *cond_urhaddvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11743; /* *cond_urhaddvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11783; /* *cond_urhaddvnx4si_any */
}

 int
recog_230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11686; /* *cond_uhsubvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11731; /* *cond_uhsubvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11771; /* *cond_uhsubvnx8hi_any */
}

 int
recog_240 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11706; /* *cond_srhaddvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11748; /* *cond_srhaddvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11788; /* *cond_srhaddvnx2di_any */
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11680; /* *cond_shsubvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11726; /* *cond_shsubvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11766; /* *cond_shsubvnx8hi_any */
}

 int
recog_260 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1061 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8535; /* *cond_fmin_nanvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8681; /* *cond_fmin_nanvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8785; /* *cond_fmin_nanvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8548; /* *cond_fmin_nanvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8694; /* *cond_fmin_nanvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8798; /* *cond_fmin_nanvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8561; /* *cond_fmin_nanvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8707; /* *cond_fmin_nanvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8811; /* *cond_fmin_nanvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8574; /* *cond_fmin_nanvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8720; /* *cond_fmin_nanvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8824; /* *cond_fmin_nanvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8635; /* *cond_fmin_nanvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8885; /* *cond_fmin_nanvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8642; /* *cond_fmin_nanvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8892; /* *cond_fmin_nanvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8649; /* *cond_fmin_nanvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8899; /* *cond_fmin_nanvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8587; /* *cond_fmin_nanvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8733; /* *cond_fmin_nanvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8837; /* *cond_fmin_nanvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8600; /* *cond_fmin_nanvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8746; /* *cond_fmin_nanvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8850; /* *cond_fmin_nanvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8613; /* *cond_fmin_nanvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8759; /* *cond_fmin_nanvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8863; /* *cond_fmin_nanvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8626; /* *cond_fmin_nanvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8772; /* *cond_fmin_nanvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8876; /* *cond_fmin_nanvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8656; /* *cond_fmin_nanvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8906; /* *cond_fmin_nanvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8663; /* *cond_fmin_nanvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8913; /* *cond_fmin_nanvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8670; /* *cond_fmin_nanvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8920; /* *cond_fmin_nanvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1126 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9265; /* *cond_fnmsvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9293; /* *cond_fnmsvnx8hf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9325; /* *cond_fnmsvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9269; /* *cond_fnmsvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9297; /* *cond_fnmsvnx4sf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9329; /* *cond_fnmsvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9273; /* *cond_fnmsvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9301; /* *cond_fnmsvnx2df_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9333; /* *cond_fnmsvnx2df_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7554 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9289; /* *cond_fnmsvnx8bf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9321; /* *cond_fnmsvnx8bf_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9277; /* *cond_fnmsvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9309; /* *cond_fnmsvnx8hf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9341; /* *cond_fnmsvnx8hf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9281; /* *cond_fnmsvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9313; /* *cond_fnmsvnx4sf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9345; /* *cond_fnmsvnx4sf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9285; /* *cond_fnmsvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9317; /* *cond_fnmsvnx2df_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9349; /* *cond_fnmsvnx2df_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7578 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9305; /* *cond_fnmsvnx8bf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7646 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9337; /* *cond_fnmsvnx8bf_any_strict */

    default:
      return -1;
    }
}

 int
recog_275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern484 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7481; /* *cond_ashlvnx16qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7651; /* *cond_ashlvnx16qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7821; /* *cond_ashlvnx16qi_any */

        case E_VNx8QImode:
          if (pattern484 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7498; /* *cond_ashlvnx8qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7668; /* *cond_ashlvnx8qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7838; /* *cond_ashlvnx8qi_any */

        case E_VNx4QImode:
          if (pattern484 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7515; /* *cond_ashlvnx4qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7685; /* *cond_ashlvnx4qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7855; /* *cond_ashlvnx4qi_any */

        case E_VNx2QImode:
          if (pattern484 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7532; /* *cond_ashlvnx2qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7702; /* *cond_ashlvnx2qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7872; /* *cond_ashlvnx2qi_any */

        case E_VNx8HImode:
          if (pattern484 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7549; /* *cond_ashlvnx8hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7719; /* *cond_ashlvnx8hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7889; /* *cond_ashlvnx8hi_any */

        case E_VNx4HImode:
          if (pattern484 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7566; /* *cond_ashlvnx4hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7736; /* *cond_ashlvnx4hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7906; /* *cond_ashlvnx4hi_any */

        case E_VNx2HImode:
          if (pattern484 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7583; /* *cond_ashlvnx2hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7753; /* *cond_ashlvnx2hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7923; /* *cond_ashlvnx2hi_any */

        case E_VNx4SImode:
          if (pattern484 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7600; /* *cond_ashlvnx4si_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7770; /* *cond_ashlvnx4si_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7940; /* *cond_ashlvnx4si_any */

        case E_VNx2SImode:
          if (pattern484 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7617; /* *cond_ashlvnx2si_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7787; /* *cond_ashlvnx2si_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7957; /* *cond_ashlvnx2si_any */

        case E_VNx2DImode:
          if (pattern484 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7634; /* *cond_ashlvnx2di_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7804; /* *cond_ashlvnx2di_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7974; /* *cond_ashlvnx2di_any */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1001 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8290; /* *cond_ashlvnx16qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8320; /* *cond_ashlvnx16qi_any_const */

        case E_VNx8QImode:
          if (pattern1001 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8293; /* *cond_ashlvnx8qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8323; /* *cond_ashlvnx8qi_any_const */

        case E_VNx4QImode:
          if (pattern1001 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8296; /* *cond_ashlvnx4qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8326; /* *cond_ashlvnx4qi_any_const */

        case E_VNx2QImode:
          if (pattern1001 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8299; /* *cond_ashlvnx2qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8329; /* *cond_ashlvnx2qi_any_const */

        case E_VNx8HImode:
          if (pattern1001 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8302; /* *cond_ashlvnx8hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8332; /* *cond_ashlvnx8hi_any_const */

        case E_VNx4HImode:
          if (pattern1001 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8305; /* *cond_ashlvnx4hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8335; /* *cond_ashlvnx4hi_any_const */

        case E_VNx2HImode:
          if (pattern1001 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8308; /* *cond_ashlvnx2hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8338; /* *cond_ashlvnx2hi_any_const */

        case E_VNx4SImode:
          if (pattern1001 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8311; /* *cond_ashlvnx4si_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8341; /* *cond_ashlvnx4si_any_const */

        case E_VNx2SImode:
          if (pattern1001 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8314; /* *cond_ashlvnx2si_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8344; /* *cond_ashlvnx2si_any_const */

        case E_VNx2DImode:
          if (pattern1001 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8317; /* *cond_ashlvnx2di_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8347; /* *cond_ashlvnx2di_any_const */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x4, 1))
        {
        case 316:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1059 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
                return -1;
              return 6980; /* cond_revbvnx16qi */

            case E_VNx8HImode:
              if (pattern1059 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
                return -1;
              return 6983; /* cond_revbvnx8hi */

            case E_VNx4SImode:
              if (pattern1059 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
                return -1;
              return 6986; /* cond_revbvnx4si */

            case E_VNx2DImode:
              if (pattern1059 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
                return -1;
              return 6989; /* cond_revbvnx2di */

            default:
              return -1;
            }

        case 318:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1059 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
                return -1;
              return 6981; /* cond_revhvnx16qi */

            case E_VNx8HImode:
              if (pattern1059 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
                return -1;
              return 6984; /* cond_revhvnx8hi */

            case E_VNx4SImode:
              if (pattern1059 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
                return -1;
              return 6987; /* cond_revhvnx4si */

            case E_VNx2DImode:
              if (pattern1059 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
                return -1;
              return 6990; /* cond_revhvnx2di */

            default:
              return -1;
            }

        case 319:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1059 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
                return -1;
              return 6982; /* cond_revwvnx16qi */

            case E_VNx8HImode:
              if (pattern1059 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
                return -1;
              return 6985; /* cond_revwvnx8hi */

            case E_VNx4SImode:
              if (pattern1059 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
                return -1;
              return 6988; /* cond_revwvnx4si */

            case E_VNx2DImode:
              if (pattern1059 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
                return -1;
              return 6991; /* cond_revwvnx2di */

            default:
              return -1;
            }

        case 317:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1120 (x2, 
E_VNx16QImode) != 0
                  || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12826; /* cond_revdvnx16qi */

            case E_VNx8HImode:
              if (pattern1120 (x2, 
E_VNx8HImode) != 0
                  || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12827; /* cond_revdvnx8hi */

            case E_VNx4SImode:
              if (pattern1120 (x2, 
E_VNx4SImode) != 0
                  || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12828; /* cond_revdvnx4si */

            case E_VNx2DImode:
              if (pattern1120 (x2, 
E_VNx2DImode) != 0
                  || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12829; /* cond_revdvnx2di */

            case E_VNx8BFmode:
              if (pattern1120 (x2, 
E_VNx8BFmode) != 0
                  || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12830; /* cond_revdvnx8bf */

            case E_VNx8HFmode:
              if (pattern1120 (x2, 
E_VNx8HFmode) != 0
                  || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12831; /* cond_revdvnx8hf */

            case E_VNx4SFmode:
              if (pattern1120 (x2, 
E_VNx4SFmode) != 0
                  || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12832; /* cond_revdvnx4sf */

            case E_VNx2DFmode:
              if (pattern1120 (x2, 
E_VNx2DFmode) != 0
                  || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12833; /* cond_revdvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      return recog_269 (x1, insn, pnum_clobbers);

    case 2:
      switch (XINT (x4, 1))
        {
        case 321:
          switch (pattern875 (x2))
            {
            case 0:
              if (!
#line 4552 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8134; /* *cond_smulhvnx16qi_2 */

            case 1:
              if (!
#line 4552 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8136; /* *cond_smulhvnx8hi_2 */

            case 2:
              if (!
#line 4552 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8138; /* *cond_smulhvnx4si_2 */

            case 3:
              if (!
#line 4552 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8140; /* *cond_smulhvnx2di_2 */

            case 4:
              if (!
#line 4570 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8142; /* *cond_smulhvnx16qi_z */

            case 5:
              if (!
#line 4570 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8144; /* *cond_smulhvnx8hi_z */

            case 6:
              if (!
#line 4570 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8146; /* *cond_smulhvnx4si_z */

            case 7:
              if (!
#line 4570 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8148; /* *cond_smulhvnx2di_z */

            default:
              return -1;
            }

        case 322:
          switch (pattern875 (x2))
            {
            case 0:
              if (!
#line 4552 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8135; /* *cond_umulhvnx16qi_2 */

            case 1:
              if (!
#line 4552 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8137; /* *cond_umulhvnx8hi_2 */

            case 2:
              if (!
#line 4552 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8139; /* *cond_umulhvnx4si_2 */

            case 3:
              if (!
#line 4552 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8141; /* *cond_umulhvnx2di_2 */

            case 4:
              if (!
#line 4570 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8143; /* *cond_umulhvnx16qi_z */

            case 5:
              if (!
#line 4570 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8145; /* *cond_umulhvnx8hi_z */

            case 6:
              if (!
#line 4570 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8147; /* *cond_umulhvnx4si_z */

            case 7:
              if (!
#line 4570 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8149; /* *cond_umulhvnx2di_z */

            default:
              return -1;
            }

        case 400:
          switch (pattern878 (x2))
            {
            case 0:
              if (!
#line 5008 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8359; /* *cond_lslvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8362; /* *cond_lslvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8365; /* *cond_lslvnx4si_m */

            case 3:
              if (!
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8368; /* *cond_lslvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8371; /* *cond_lslvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8374; /* *cond_lslvnx4si_z */

            default:
              return -1;
            }

        case 401:
          switch (pattern878 (x2))
            {
            case 0:
              if (!
#line 5008 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8360; /* *cond_asrvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8363; /* *cond_asrvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8366; /* *cond_asrvnx4si_m */

            case 3:
              if (!
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8369; /* *cond_asrvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8372; /* *cond_asrvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8375; /* *cond_asrvnx4si_z */

            default:
              return -1;
            }

        case 402:
          switch (pattern878 (x2))
            {
            case 0:
              if (!
#line 5008 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8361; /* *cond_lsrvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8364; /* *cond_lsrvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8367; /* *cond_lsrvnx4si_m */

            case 3:
              if (!
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8370; /* *cond_lsrvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8373; /* *cond_lsrvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8376; /* *cond_lsrvnx4si_z */

            default:
              return -1;
            }

        case 125:
          return recog_253 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case 4:
      return recog_268 (x1, insn, pnum_clobbers);

    case 5:
      return recog_267 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_291 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern610 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6738; /* *cond_qabsvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !(
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6828; /* *cond_qabsvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6747; /* *cond_qabsvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !(
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6837; /* *cond_qabsvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6756; /* *cond_qabsvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !(
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6846; /* *cond_qabsvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6765; /* *cond_qabsvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !(
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6855; /* *cond_qabsvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6774; /* *cond_qabsvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !(
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6864; /* *cond_qabsvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6783; /* *cond_qabsvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !(
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6873; /* *cond_qabsvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6792; /* *cond_qabsvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !(
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6882; /* *cond_qabsvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6801; /* *cond_qabsvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !(
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6891; /* *cond_qabsvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6810; /* *cond_qabsvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !(
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6900; /* *cond_qabsvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6819; /* *cond_qabsvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !(
#line 3250 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2762 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6909; /* *cond_qabsvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern801 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6287; /* maskstorevnx16qivnx16bi */

        case E_VNx8QImode:
          if (pattern801 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6288; /* maskstorevnx8qivnx8bi */

        case E_VNx4QImode:
          if (pattern801 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6289; /* maskstorevnx4qivnx4bi */

        case E_VNx2QImode:
          if (pattern801 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6290; /* maskstorevnx2qivnx2bi */

        case E_VNx8HImode:
          if (pattern801 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6291; /* maskstorevnx8hivnx8bi */

        case E_VNx4HImode:
          if (pattern801 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6292; /* maskstorevnx4hivnx4bi */

        case E_VNx2HImode:
          if (pattern801 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6293; /* maskstorevnx2hivnx2bi */

        case E_VNx4SImode:
          if (pattern801 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6294; /* maskstorevnx4sivnx4bi */

        case E_VNx2SImode:
          if (pattern801 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6295; /* maskstorevnx2sivnx2bi */

        case E_VNx2DImode:
          if (pattern801 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6296; /* maskstorevnx2divnx2bi */

        case E_VNx8HFmode:
          if (pattern801 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6297; /* maskstorevnx8hfvnx8bi */

        case E_VNx4HFmode:
          if (pattern801 (x3, 
E_VNx4HFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6298; /* maskstorevnx4hfvnx4bi */

        case E_VNx2HFmode:
          if (pattern801 (x3, 
E_VNx2HFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6299; /* maskstorevnx2hfvnx2bi */

        case E_VNx8BFmode:
          if (pattern801 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6300; /* maskstorevnx8bfvnx8bi */

        case E_VNx4BFmode:
          if (pattern801 (x3, 
E_VNx4BFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6301; /* maskstorevnx4bfvnx4bi */

        case E_VNx2BFmode:
          if (pattern801 (x3, 
E_VNx2BFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6302; /* maskstorevnx2bfvnx2bi */

        case E_VNx4SFmode:
          if (pattern801 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6303; /* maskstorevnx4sfvnx4bi */

        case E_VNx2SFmode:
          if (pattern801 (x3, 
E_VNx2SFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6304; /* maskstorevnx2sfvnx2bi */

        case E_VNx2DFmode:
          if (pattern801 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6305; /* maskstorevnx2dfvnx2bi */

        default:
          return -1;
        }

    case TRUNCATE:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8QImode:
          if (pattern869 (x3, 
E_VNx8QImode, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 2349 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6330; /* aarch64_store_truncvnx8qivnx8hi */

        case E_VNx4QImode:
          if (pattern869 (x3, 
E_VNx4QImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2362 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6331; /* aarch64_store_truncvnx4qivnx4si */

        case E_VNx4HImode:
          if (pattern869 (x3, 
E_VNx4HImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2362 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6332; /* aarch64_store_truncvnx4hivnx4si */

        case E_VNx2QImode:
          if (pattern869 (x3, 
E_VNx2QImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6333; /* aarch64_store_truncvnx2qivnx2di */

        case E_VNx2HImode:
          if (pattern869 (x3, 
E_VNx2HImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6334; /* aarch64_store_truncvnx2hivnx2di */

        case E_VNx2SImode:
          if (pattern869 (x3, 
E_VNx2SImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6335; /* aarch64_store_truncvnx2sivnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  if (!aarch64_sve_gp_strictness (x5, E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[2] = x6;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern166 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !
#line 3676 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7195; /* aarch64_pred_absvnx8hf */

        case E_VNx4SFmode:
          if (pattern166 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !
#line 3676 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7206; /* aarch64_pred_absvnx4sf */

        case E_VNx2DFmode:
          if (pattern166 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !
#line 3676 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7217; /* aarch64_pred_absvnx2df */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 4
          || XINT (x6, 1) != 393)
        return -1;
      x7 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      operands[4] = x5;
      x8 = XVECEXP (x6, 0, 2);
      operands[2] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[3] = x9;
      switch (XWINT (x7, 0))
        {
        case 0L:
          x10 = XVECEXP (x6, 0, 0);
          operands[5] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1228 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !
#line 6230 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8985; /* *aarch64_pred_abdvnx8hf_relaxed */

            case E_VNx4SFmode:
              if (pattern1228 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !
#line 6230 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8986; /* *aarch64_pred_abdvnx4sf_relaxed */

            case E_VNx2DFmode:
              if (pattern1228 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !
#line 6230 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8987; /* *aarch64_pred_abdvnx2df_relaxed */

            default:
              return -1;
            }

        case 1L:
          x10 = XVECEXP (x6, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1228 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !
#line 6253 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8988; /* *aarch64_pred_abdvnx8hf_strict */

            case E_VNx4SFmode:
              if (pattern1228 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !
#line 6253 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8989; /* *aarch64_pred_abdvnx4sf_strict */

            case E_VNx2DFmode:
              if (pattern1228 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !
#line 6253 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8990; /* *aarch64_pred_abdvnx2df_strict */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9978; /* while_ugesivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9988; /* while_ugedivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9998; /* while_ugesivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10008; /* while_ugedivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10018; /* while_ugesivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10028; /* while_ugedivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10038; /* while_ugesivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10048; /* while_ugedivnx2bi */

    default:
      return -1;
    }
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[2], E_V1DImode)
          || !
#line 7896 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4589; /* aarch64_vec_ldap1_lanesv1di_lanesi */

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[2], E_V1DFmode)
          || !
#line 7896 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4590; /* aarch64_vec_ldap1_lanesv1df_lanedf */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[2], E_V2DImode)
          || !
#line 7896 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4591; /* aarch64_vec_ldap1_lanesv2di_lanedi */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[2], E_V2DFmode)
          || !
#line 7896 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_RCPC3))
        return -1;
      return 4592; /* aarch64_vec_ldap1_lanesv2df_lanedf */

    default:
      return -1;
    }
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern188 (x1))
    {
    case 0:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11311; /* aarch64_st1vnx32qi */

    case 1:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11313; /* aarch64_st1vnx16hi */

    case 2:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11315; /* aarch64_st1vnx8si */

    case 3:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11317; /* aarch64_st1vnx4di */

    case 4:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11319; /* aarch64_st1vnx16bf */

    case 5:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11321; /* aarch64_st1vnx16hf */

    case 6:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11323; /* aarch64_st1vnx8sf */

    case 7:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11325; /* aarch64_st1vnx4df */

    case 8:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11327; /* aarch64_st1vnx64qi */

    case 9:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11329; /* aarch64_st1vnx32hi */

    case 10:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11331; /* aarch64_st1vnx16si */

    case 11:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11333; /* aarch64_st1vnx8di */

    case 12:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11335; /* aarch64_st1vnx32bf */

    case 13:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11337; /* aarch64_st1vnx32hf */

    case 14:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11339; /* aarch64_st1vnx16sf */

    case 15:
      if (!
#line 480 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11341; /* aarch64_st1vnx8df */

    default:
      return -1;
    }
}

 int
recog_339 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1065 (x2))
        {
        case 0:
          if (!
#line 914 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13329; /* aarch64_sme_readvnx4di */

        case 1:
          if (!
#line 914 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13330; /* aarch64_sme_readvnx8di */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_0_to_7_operand (operands[2], E_SImode))
        return -1;
      switch (pattern1065 (x2))
        {
        case 0:
          if (!
#line 926 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13331; /* *aarch64_sme_readvnx4di_plus */

        case 1:
          if (!
#line 926 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13332; /* *aarch64_sme_readvnx8di_plus */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_347 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern805 (x3, 
E_VNx16QImode) != 0
          || !
#line 2003 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12059; /* aarch64_sve_srivnx16qi */

    case E_VNx8HImode:
      if (pattern805 (x3, 
E_VNx8HImode) != 0
          || !
#line 2003 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12061; /* aarch64_sve_srivnx8hi */

    case E_VNx4SImode:
      if (pattern805 (x3, 
E_VNx4SImode) != 0
          || !
#line 2003 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12063; /* aarch64_sve_srivnx4si */

    case E_VNx2DImode:
      if (pattern805 (x3, 
E_VNx2DImode) != 0
          || !
#line 2003 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12065; /* aarch64_sve_srivnx2di */

    default:
      return -1;
    }
}

 int
recog_353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (pattern881 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 3530 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12671; /* aarch64_pred_flogbvnx8hf */

    case E_VNx4SImode:
      if (pattern881 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 3530 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12672; /* aarch64_pred_flogbvnx4sf */

    case E_VNx2DImode:
      if (pattern881 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 3530 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12673; /* aarch64_pred_flogbvnx2df */

    default:
      return -1;
    }
}

 int
recog_361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      if (!
#line 3016 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12567; /* aarch64_sve_cmla180vnx16qi */

    case 1:
      if (!
#line 3016 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12575; /* aarch64_sve_cmla180vnx8hi */

    case 2:
      if (!
#line 3016 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12583; /* aarch64_sve_cmla180vnx4si */

    case 3:
      if (!
#line 3016 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12591; /* aarch64_sve_cmla180vnx2di */

    case 4:
      if (!
#line 3033 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12599; /* aarch64_cmla180_lane_vnx8hi */

    case 5:
      if (!
#line 3033 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12607; /* aarch64_cmla180_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern203 (x1))
    {
    case 0:
      if (!
#line 3096 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12616; /* aarch64_sve_cdot270vnx4si */

    case 1:
      if (!
#line 3096 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12620; /* aarch64_sve_cdot270vnx2di */

    case 2:
      if (!
#line 3113 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12624; /* aarch64_cdot270_lane_vnx4si */

    case 3:
      if (!
#line 3113 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12628; /* aarch64_cdot270_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!
#line 2821 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12498; /* aarch64_pred_sminpvnx16qi */

    case 1:
      if (!
#line 2821 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12503; /* aarch64_pred_sminpvnx8hi */

    case 2:
      if (!
#line 2821 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12508; /* aarch64_pred_sminpvnx4si */

    case 3:
      if (!
#line 2821 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12513; /* aarch64_pred_sminpvnx2di */

    default:
      return -1;
    }
}

 int
recog_383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      if (!
#line 1451 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11875; /* aarch64_sve_adclbvnx16qi */

    case 1:
      if (!
#line 1451 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11883; /* aarch64_sve_adclbvnx8hi */

    case 2:
      if (!
#line 1451 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11891; /* aarch64_sve_adclbvnx4si */

    case 3:
      if (!
#line 1451 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11899; /* aarch64_sve_adclbvnx2di */

    default:
      return -1;
    }
}

 int
recog_391 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 2);
  operands[2] = x8;
  switch (GET_MODE (x3))
    {
    case E_VNx16BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10140; /* while_wrsivnx16bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10150; /* while_wrdivnx16bi_ptest */

    case E_VNx8BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10160; /* while_wrsivnx8bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10170; /* while_wrdivnx8bi_ptest */

    case E_VNx4BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10180; /* while_wrsivnx4bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10190; /* while_wrdivnx4bi_ptest */

    case E_VNx2BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10200; /* while_wrsivnx2bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10210; /* while_wrdivnx2bi_ptest */

    default:
      return -1;
    }
}

 int
recog_401 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern227 (x1))
    {
    case 0:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13201; /* aarch64_sme_read_horvnx32qivnx32qi */

    case 1:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13203; /* aarch64_sme_read_horvnx16hivnx16hi */

    case 2:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13205; /* aarch64_sme_read_horvnx8sivnx8si */

    case 3:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13207; /* aarch64_sme_read_horvnx4divnx4di */

    case 4:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13209; /* aarch64_sme_read_horvnx16bfvnx16bf */

    case 5:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13211; /* aarch64_sme_read_horvnx16hfvnx16hf */

    case 6:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13213; /* aarch64_sme_read_horvnx8sfvnx8sf */

    case 7:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13215; /* aarch64_sme_read_horvnx4dfvnx4df */

    case 8:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13217; /* aarch64_sme_read_horvnx64qivnx64qi */

    case 9:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13219; /* aarch64_sme_read_horvnx32hivnx32hi */

    case 10:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13221; /* aarch64_sme_read_horvnx16sivnx16si */

    case 11:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13223; /* aarch64_sme_read_horvnx8divnx8di */

    case 12:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13225; /* aarch64_sme_read_horvnx32bfvnx32bf */

    case 13:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13227; /* aarch64_sme_read_horvnx32hfvnx32hf */

    case 14:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13229; /* aarch64_sme_read_horvnx16sfvnx16sf */

    case 15:
      if (!
#line 827 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13231; /* aarch64_sme_read_horvnx8dfvnx8df */

    case 16:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 8))
        return -1;
      return 13233; /* *aarch64_sme_read_horvnx32qivnx32qi_plus */

    case 17:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13235; /* *aarch64_sme_read_horvnx16hivnx16hi_plus */

    case 18:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13237; /* *aarch64_sme_read_horvnx8sivnx8si_plus */

    case 19:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13239; /* *aarch64_sme_read_horvnx4divnx4di_plus */

    case 20:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13241; /* *aarch64_sme_read_horvnx16bfvnx16bf_plus */

    case 21:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13243; /* *aarch64_sme_read_horvnx16hfvnx16hf_plus */

    case 22:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13245; /* *aarch64_sme_read_horvnx8sfvnx8sf_plus */

    case 23:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13247; /* *aarch64_sme_read_horvnx4dfvnx4df_plus */

    case 24:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 8))
        return -1;
      return 13249; /* *aarch64_sme_read_horvnx64qivnx64qi_plus */

    case 25:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13251; /* *aarch64_sme_read_horvnx32hivnx32hi_plus */

    case 26:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13253; /* *aarch64_sme_read_horvnx16sivnx16si_plus */

    case 27:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13255; /* *aarch64_sme_read_horvnx8divnx8di_plus */

    case 28:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13257; /* *aarch64_sme_read_horvnx32bfvnx32bf_plus */

    case 29:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13259; /* *aarch64_sme_read_horvnx32hfvnx32hf_plus */

    case 30:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13261; /* *aarch64_sme_read_horvnx16sfvnx16sf_plus */

    case 31:
      if (!
#line 844 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13263; /* *aarch64_sme_read_horvnx8dfvnx8df_plus */

    default:
      return -1;
    }
}

 int
recog_415 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern220 (x1))
    {
    case 0:
      if (!
#line 8512 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10215; /* aarch64_pred_fcmltvnx8hf */

    case 1:
      if (!
#line 8512 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10221; /* aarch64_pred_fcmltvnx4sf */

    case 2:
      if (!
#line 8512 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10227; /* aarch64_pred_fcmltvnx2df */

    case 3:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 2);
      x4 = XVECEXP (x3, 0, 1);
      if (XWINT (x4, 0) == 0L)
        {
          switch (pattern1263 (x2))
            {
            case 0:
              if (
#line 8785 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10298; /* *aarch64_pred_facltvnx8hf_relaxed */
              break;

            case 1:
              if (
#line 8785 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10302; /* *aarch64_pred_facltvnx4sf_relaxed */
              break;

            case 2:
              if (
#line 8785 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10306; /* *aarch64_pred_facltvnx2df_relaxed */
              break;

            default:
              break;
            }
        }
      operands[5] = x4;
      switch (pattern1264 (x2))
        {
        case 0:
          if (!
#line 8811 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10310; /* *aarch64_pred_facltvnx8hf_strict */

        case 1:
          if (!
#line 8811 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10314; /* *aarch64_pred_facltvnx4sf_strict */

        case 2:
          if (!
#line 8811 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10318; /* *aarch64_pred_facltvnx2df_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern951 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 6494 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9009; /* aarch64_pred_mulvnx8hf */

    case E_VNx4SFmode:
      if (pattern951 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 6494 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9010; /* aarch64_pred_mulvnx4sf */

    case E_VNx2DFmode:
      if (pattern951 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 6494 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9011; /* aarch64_pred_mulvnx2df */

    case E_VNx8BFmode:
      if (pattern208 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1347 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
        return -1;
      return 11854; /* aarch64_pred_mulvnx8bf */

    default:
      return -1;
    }
}

 int
recog_429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern254 (x1))
    {
    case 0:
      if (!
#line 1429 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13742; /* aarch64_sme_umlsvnx4sivnx16qi */

    case 1:
      if (!
#line 1429 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13746; /* aarch64_sme_umlsvnx4sivnx8hi */

    case 2:
      if (!
#line 1459 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13758; /* aarch64_sme_umlsvnx4sivnx32qi */

    case 3:
      if (!
#line 1459 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13762; /* aarch64_sme_umlsvnx4sivnx64qi */

    case 4:
      if (!
#line 1459 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13766; /* aarch64_sme_umlsvnx4sivnx16hi */

    case 5:
      if (!
#line 1459 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13770; /* aarch64_sme_umlsvnx4sivnx32hi */

    case 6:
      if (!
#line 1557 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13870; /* aarch64_sme_umlsvnx2divnx8hi */

    case 7:
      if (!
#line 1587 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13878; /* aarch64_sme_umlsvnx2divnx16hi */

    case 8:
      if (!
#line 1587 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13882; /* aarch64_sme_umlsvnx2divnx32hi */

    case 9:
      if (!
#line 1490 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13790; /* aarch64_sme_single_umlsvnx4sivnx32qi */

    case 10:
      if (!
#line 1490 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13794; /* aarch64_sme_single_umlsvnx4sivnx64qi */

    case 11:
      if (!
#line 1490 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13798; /* aarch64_sme_single_umlsvnx4sivnx16hi */

    case 12:
      if (!
#line 1490 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13802; /* aarch64_sme_single_umlsvnx4sivnx32hi */

    case 13:
      if (!
#line 1618 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13894; /* aarch64_sme_single_umlsvnx2divnx16hi */

    case 14:
      if (!
#line 1618 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13898; /* aarch64_sme_single_umlsvnx2divnx32hi */

    case 15:
      if (!
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13822; /* aarch64_sme_lane_umlsvnx4sivnx16qi */

    case 16:
      if (!
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13826; /* aarch64_sme_lane_umlsvnx4sivnx32qi */

    case 17:
      if (!
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13830; /* aarch64_sme_lane_umlsvnx4sivnx64qi */

    case 18:
      if (!
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13834; /* aarch64_sme_lane_umlsvnx4sivnx8hi */

    case 19:
      if (!
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13838; /* aarch64_sme_lane_umlsvnx4sivnx16hi */

    case 20:
      if (!
#line 1524 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13842; /* aarch64_sme_lane_umlsvnx4sivnx32hi */

    case 21:
      if (!
#line 1652 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13910; /* aarch64_sme_lane_umlsvnx2divnx8hi */

    case 22:
      if (!
#line 1652 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13914; /* aarch64_sme_lane_umlsvnx2divnx16hi */

    case 23:
      if (!
#line 1652 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13918; /* aarch64_sme_lane_umlsvnx2divnx32hi */

    case 24:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx16QImode)
          && register_operand (operands[3], E_VNx16QImode)
          && 
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13750; /* *aarch64_sme_umlsvnx4sivnx16qi_plus */
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13754; /* *aarch64_sme_umlsvnx4sivnx8hi_plus */
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          switch (pattern1325 ())
            {
            case 0:
              if (
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13774; /* *aarch64_sme_umlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13778; /* *aarch64_sme_umlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1326 ())
        {
        case 0:
          if (!
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13782; /* *aarch64_sme_umlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13786; /* *aarch64_sme_umlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 25:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1571 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return 13874; /* *aarch64_sme_umlsvnx2divnx8hi_plus */
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1326 ())
        {
        case 0:
          if (!
#line 1601 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13886; /* *aarch64_sme_umlsvnx2divnx16hi_plus */

        case 1:
          if (!
#line 1601 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13890; /* *aarch64_sme_umlsvnx2divnx32hi_plus */

        default:
          return -1;
        }

    case 26:
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1327 (x3))
            {
            case 0:
              if (
#line 1505 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13806; /* *aarch64_sme_single_umlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1505 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13810; /* *aarch64_sme_single_umlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern253 (x3))
        {
        case 0:
          if (!
#line 1505 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13814; /* *aarch64_sme_single_umlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1505 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13818; /* *aarch64_sme_single_umlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 27:
      if (!
#line 1633 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13902; /* *aarch64_sme_single_umlsvnx2divnx16hi_plus */

    case 28:
      if (!
#line 1633 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13906; /* *aarch64_sme_single_umlsvnx2divnx32hi_plus */

    case 29:
      if (register_operand (operands[3], E_VNx16QImode))
        {
          if (const_0_to_12_step_4_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_VNx16QImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              if (GET_MODE (x3) == E_VNx16QImode
                  && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13846; /* *aarch64_sme_lane_umlsvnx4sivnx16qi */
            }
          if (const_0_to_4_step_4_operand (operands[1], E_SImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              switch (pattern1365 (x3))
                {
                case 0:
                  if (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13850; /* *aarch64_sme_lane_umlsvnx4sivnx32qi */
                  break;

                case 1:
                  if (
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13854; /* *aarch64_sme_lane_umlsvnx4sivnx64qi */
                  break;

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[3], E_VNx8HImode))
        return -1;
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return 13858; /* *aarch64_sme_lane_umlsvnx4sivnx8hi */
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1366 (x3))
        {
        case 0:
          if (!
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13862; /* *aarch64_sme_lane_umlsvnx4sivnx16hi */

        case 1:
          if (!
#line 1541 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13866; /* *aarch64_sme_lane_umlsvnx4sivnx32hi */

        default:
          return -1;
        }

    case 30:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1669 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return 13922; /* *aarch64_sme_lane_umlsvnx2divnx8hi */
        }
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1366 (x3))
        {
        case 0:
          if (!
#line 1669 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13926; /* *aarch64_sme_lane_umlsvnx2divnx16hi */

        case 1:
          if (!
#line 1669 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13930; /* *aarch64_sme_lane_umlsvnx2divnx32hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern262 (x2, 
89, 
E_V8DImode, 
94) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 2L:
      switch (pattern1230 (x2))
        {
        case 0:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14157; /* aarch64_sme_lut2vnx16qi */

        case 1:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14159; /* aarch64_sme_lut2vnx8hi */

        case 2:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14161; /* aarch64_sme_lut2vnx4si */

        case 3:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14163; /* aarch64_sme_lut2vnx8bf */

        case 4:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14165; /* aarch64_sme_lut2vnx8hf */

        case 5:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14167; /* aarch64_sme_lut2vnx4sf */

        case 6:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 8 == 8)))
            return -1;
          return 14169; /* aarch64_sme_lut2vnx32qi */

        case 7:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14171; /* aarch64_sme_lut2vnx16hi */

        case 8:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 32 == 8)))
            return -1;
          return 14173; /* aarch64_sme_lut2vnx8si */

        case 9:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14175; /* aarch64_sme_lut2vnx16bf */

        case 10:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14177; /* aarch64_sme_lut2vnx16hf */

        case 11:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 32 == 8)))
            return -1;
          return 14179; /* aarch64_sme_lut2vnx8sf */

        case 12:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 8 == 8)))
            return -1;
          return 14181; /* aarch64_sme_lut2vnx64qi */

        case 13:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14183; /* aarch64_sme_lut2vnx32hi */

        case 14:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 32 == 8)))
            return -1;
          return 14185; /* aarch64_sme_lut2vnx16si */

        case 15:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14187; /* aarch64_sme_lut2vnx32bf */

        case 16:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14189; /* aarch64_sme_lut2vnx32hf */

        case 17:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 32 == 8)))
            return -1;
          return 14191; /* aarch64_sme_lut2vnx16sf */

        default:
          return -1;
        }

    case 4L:
      switch (pattern1230 (x2))
        {
        case 0:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14158; /* aarch64_sme_lut4vnx16qi */

        case 1:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14160; /* aarch64_sme_lut4vnx8hi */

        case 2:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14162; /* aarch64_sme_lut4vnx4si */

        case 3:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14164; /* aarch64_sme_lut4vnx8bf */

        case 4:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14166; /* aarch64_sme_lut4vnx8hf */

        case 5:
          if (!
#line 2150 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14168; /* aarch64_sme_lut4vnx4sf */

        case 6:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 8 == 8)))
            return -1;
          return 14170; /* aarch64_sme_lut4vnx32qi */

        case 7:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14172; /* aarch64_sme_lut4vnx16hi */

        case 8:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 32 == 8)))
            return -1;
          return 14174; /* aarch64_sme_lut4vnx8si */

        case 9:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14176; /* aarch64_sme_lut4vnx16bf */

        case 10:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14178; /* aarch64_sme_lut4vnx16hf */

        case 11:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 32 == 8)))
            return -1;
          return 14180; /* aarch64_sme_lut4vnx8sf */

        case 12:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 8 == 8)))
            return -1;
          return 14182; /* aarch64_sme_lut4vnx64qi */

        case 13:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14184; /* aarch64_sme_lut4vnx32hi */

        case 14:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 32 == 8)))
            return -1;
          return 14186; /* aarch64_sme_lut4vnx16si */

        case 15:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14188; /* aarch64_sme_lut4vnx32bf */

        case 16:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14190; /* aarch64_sme_lut4vnx32hf */

        case 17:
          if (!
#line 2163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 32 == 8)))
            return -1;
          return 14192; /* aarch64_sme_lut4vnx16sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_448 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 162:
      if (pattern53 (x1, 
84) != 0
          || !aarch64_reg_or_zero (operands[0], E_DImode)
          || !
#line 1920 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FP8))
        return -1;
      return 84; /* aarch64_write_fpmr */

    case 82:
      if (GET_MODE (x2) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 6114 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 761; /* *aarch64_sisd_neg_qi */

    case 36:
      return recog_52 (x1, insn, pnum_clobbers);

    case 34:
      return recog_40 (x1, insn, pnum_clobbers);

    case 32:
      return recog_39 (x1, insn, pnum_clobbers);

    case 33:
      return recog_38 (x1, insn, pnum_clobbers);

    case 31:
      return recog_51 (x1, insn, pnum_clobbers);

    case 35:
      return recog_50 (x1, insn, pnum_clobbers);

    case 30:
      return recog_37 (x1, insn, pnum_clobbers);

    case 39:
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != MEM)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LO_SUM)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern865 (x2, 
E_SImode) != 0
              || !
#line 168 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
            return -1;
          return 1127; /* ldr_got_small_28k_si */

        case E_DImode:
          if (pattern865 (x2, 
E_DImode) != 0
              || !
#line 168 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
            return -1;
          return 1128; /* ldr_got_small_28k_di */

        default:
          return -1;
        }

    case 41:
      return recog_49 (x1, insn, pnum_clobbers);

    case 97:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1133; /* aarch64_load_tp_hard */

    case 40:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!aarch64_tls_ie_symref (operands[1], E_VOIDmode))
        return -1;
      switch (pattern42 (x2))
        {
        case 0:
          if (!
#line 168 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
            return -1;
          return 1136; /* tlsie_small_si */

        case 1:
          if (!
#line 168 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
            return -1;
          return 1137; /* tlsie_small_di */

        default:
          return -1;
        }

    case 101:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1146; /* tlsle32_si */

        case 1:
          if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1147; /* tlsle32_di */

        default:
          return -1;
        }

    case 102:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1148; /* tlsle48_si */

        case 1:
          if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1149; /* tlsle48_di */

        default:
          return -1;
        }

    case 21:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 7889 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_JSCVT))
        return -1;
      *pnum_clobbers = 1;
      return 1155; /* aarch64_fjcvtzs */

    case 114:
      if (pattern44 (x1, 
30, 
E_DImode) != 0)
        return -1;
      return 1164; /* xpaclri */

    case 107:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      switch (pattern42 (x2))
        {
        case 0:
          if (!(
#line 8021 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(aarch64_stack_protector_guard != SSP_GLOBAL) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
            return -1;
          return 1169; /* reg_stack_protect_address_si */

        case 1:
          if (!(
#line 8021 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(aarch64_stack_protector_guard != SSP_GLOBAL) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
            return -1;
          return 1170; /* reg_stack_protect_address_di */

        default:
          return -1;
        }

    case 22:
      switch (pattern57 (x1))
        {
        case 0:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1200; /* aarch64_frint32zv2sf */

        case 1:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1204; /* aarch64_frint32zv4sf */

        case 2:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1208; /* aarch64_frint32zv2df */

        case 3:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1212; /* aarch64_frint32zdf */

        case 4:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1216; /* aarch64_frint32zsf */

        default:
          return -1;
        }

    case 23:
      switch (pattern57 (x1))
        {
        case 0:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1201; /* aarch64_frint32xv2sf */

        case 1:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1205; /* aarch64_frint32xv4sf */

        case 2:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1209; /* aarch64_frint32xv2df */

        case 3:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1213; /* aarch64_frint32xdf */

        case 4:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1217; /* aarch64_frint32xsf */

        default:
          return -1;
        }

    case 24:
      switch (pattern57 (x1))
        {
        case 0:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1202; /* aarch64_frint64zv2sf */

        case 1:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1206; /* aarch64_frint64zv4sf */

        case 2:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1210; /* aarch64_frint64zv2df */

        case 3:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1214; /* aarch64_frint64zdf */

        case 4:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1218; /* aarch64_frint64zsf */

        default:
          return -1;
        }

    case 25:
      switch (pattern57 (x1))
        {
        case 0:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2SFmode) && !TARGET_SIMD)))
            return -1;
          return 1203; /* aarch64_frint64xv2sf */

        case 1:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V4SFmode) && !TARGET_SIMD)))
            return -1;
          return 1207; /* aarch64_frint64xv4sf */

        case 2:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (V2DFmode) && !TARGET_SIMD)))
            return -1;
          return 1211; /* aarch64_frint64xv2df */

        case 3:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (DFmode) && !TARGET_SIMD)))
            return -1;
          return 1215; /* aarch64_frint64xdf */

        case 4:
          if (!
#line 8311 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FRINT && TARGET_FLOAT
   && !(VECTOR_MODE_P (SFmode) && !TARGET_SIMD)))
            return -1;
          return 1219; /* aarch64_frint64xsf */

        default:
          return -1;
        }

    case 179:
      if (pattern58 (x2, 
E_CCmode, 
66, 
E_DImode) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1237; /* aarch64_save_nzcv */

    case 180:
      if (pattern41 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      return 1238; /* aarch64_restore_nzcv */

    case 111:
      return recog_16 (x1, insn, pnum_clobbers);

    case 187:
      return recog_28 (x1, insn, pnum_clobbers);

    case 203:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DImode)
          || !
#line 2691 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2405; /* aarch64_fnegv2di2 */

    case 588:
      return recog_48 (x1, insn, pnum_clobbers);

    case 205:
      return recog_15 (x1, insn, pnum_clobbers);

    case 202:
      return recog_47 (x1, insn, pnum_clobbers);

    case 208:
      switch (pattern59 (x1))
        {
        case 0:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2846; /* aarch64_reduc_umax_internalv8qi */

        case 1:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2850; /* aarch64_reduc_umax_internalv16qi */

        case 2:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2854; /* aarch64_reduc_umax_internalv4hi */

        case 3:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2858; /* aarch64_reduc_umax_internalv8hi */

        case 4:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2862; /* aarch64_reduc_umax_internalv4si */

        case 5:
          if (!
#line 3687 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2866; /* aarch64_reduc_umax_internalv2si */

        default:
          return -1;
        }

    case 209:
      switch (pattern59 (x1))
        {
        case 0:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2847; /* aarch64_reduc_umin_internalv8qi */

        case 1:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2851; /* aarch64_reduc_umin_internalv16qi */

        case 2:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2855; /* aarch64_reduc_umin_internalv4hi */

        case 3:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2859; /* aarch64_reduc_umin_internalv8hi */

        case 4:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2863; /* aarch64_reduc_umin_internalv4si */

        case 5:
          if (!
#line 3687 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2867; /* aarch64_reduc_umin_internalv2si */

        default:
          return -1;
        }

    case 206:
      switch (pattern59 (x1))
        {
        case 0:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2848; /* aarch64_reduc_smax_internalv8qi */

        case 1:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2852; /* aarch64_reduc_smax_internalv16qi */

        case 2:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2856; /* aarch64_reduc_smax_internalv4hi */

        case 3:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2860; /* aarch64_reduc_smax_internalv8hi */

        case 4:
          if (!
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2864; /* aarch64_reduc_smax_internalv4si */

        case 5:
          if (!
#line 3687 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2868; /* aarch64_reduc_smax_internalv2si */

        default:
          return -1;
        }

    case 207:
      return recog_57 (x1, insn, pnum_clobbers);

    case 198:
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2870; /* aarch64_reduc_smax_nan_internalv4hf */

        case 1:
          if (!(
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2874; /* aarch64_reduc_smax_nan_internalv8hf */

        case 2:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2878; /* aarch64_reduc_smax_nan_internalv2sf */

        case 3:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2882; /* aarch64_reduc_smax_nan_internalv4sf */

        case 4:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2886; /* aarch64_reduc_smax_nan_internalv2df */

        default:
          return -1;
        }

    case 201:
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2871; /* aarch64_reduc_smin_nan_internalv4hf */

        case 1:
          if (!(
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2875; /* aarch64_reduc_smin_nan_internalv8hf */

        case 2:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2879; /* aarch64_reduc_smin_nan_internalv2sf */

        case 3:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2883; /* aarch64_reduc_smin_nan_internalv4sf */

        case 4:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2887; /* aarch64_reduc_smin_nan_internalv2df */

        default:
          return -1;
        }

    case 197:
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2872; /* aarch64_reduc_smax_internalv4hf */

        case 1:
          if (!(
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2876; /* aarch64_reduc_smax_internalv8hf */

        case 2:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2880; /* aarch64_reduc_smax_internalv2sf */

        case 3:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2884; /* aarch64_reduc_smax_internalv4sf */

        case 4:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2888; /* aarch64_reduc_smax_internalv2df */

        default:
          return -1;
        }

    case 200:
      switch (pattern60 (x1))
        {
        case 0:
          if (!(
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2873; /* aarch64_reduc_smin_internalv4hf */

        case 1:
          if (!(
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2877; /* aarch64_reduc_smin_internalv8hf */

        case 2:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2881; /* aarch64_reduc_smin_internalv2sf */

        case 3:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2885; /* aarch64_reduc_smin_internalv4sf */

        case 4:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2889; /* aarch64_reduc_smin_internalv2df */

        default:
          return -1;
        }

    case 51:
      return recog_27 (x1, insn, pnum_clobbers);

    case 53:
      return recog_19 (x1, insn, pnum_clobbers);

    case 91:
      return recog_14 (x1, insn, pnum_clobbers);

    case 54:
      return recog_26 (x1, insn, pnum_clobbers);

    case 56:
      return recog_18 (x1, insn, pnum_clobbers);

    case 92:
      return recog_13 (x1, insn, pnum_clobbers);

    case 57:
      return recog_25 (x1, insn, pnum_clobbers);

    case 59:
      return recog_17 (x1, insn, pnum_clobbers);

    case 93:
      return recog_12 (x1, insn, pnum_clobbers);

    case 46:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      return recog_9 (x1, insn, pnum_clobbers);

    case 86:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      return recog_10 (x1, insn, pnum_clobbers);

    case 52:
      return recog_24 (x1, insn, pnum_clobbers);

    case 55:
      return recog_23 (x1, insn, pnum_clobbers);

    case 58:
      return recog_22 (x1, insn, pnum_clobbers);

    case 254:
      return recog_33 (x1, insn, pnum_clobbers);

    case 255:
      return recog_31 (x1, insn, pnum_clobbers);

    case 256:
      return recog_32 (x1, insn, pnum_clobbers);

    case 27:
      return recog_20 (x1, insn, pnum_clobbers);

    case 29:
      return recog_36 (x1, insn, pnum_clobbers);

    case 26:
      return recog_46 (x1, insn, pnum_clobbers);

    case 257:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 8922 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5175; /* aarch64_crypto_aesev16qi */

        case 1:
          if (!
#line 4147 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 12979; /* aarch64_sve2_aese */

        default:
          return -1;
        }

    case 258:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 8922 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5176; /* aarch64_crypto_aesdv16qi */

        case 1:
          if (!
#line 4147 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 12980; /* aarch64_sve2_aesd */

        default:
          return -1;
        }

    case 259:
      switch (pattern65 (x1, 
257))
        {
        case 0:
          if (!
#line 8931 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5177; /* aarch64_crypto_aesmcv16qi */

        case 1:
          if (!
#line 4158 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 12981; /* aarch64_sve2_aesmc */

        case 2:
          if (!
#line 8950 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES
   && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 5179; /* *aarch64_crypto_aese_fused */

        case 3:
          if (!
#line 4177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 12983; /* *aarch64_sve2_aese_fused */

        default:
          return -1;
        }

    case 260:
      switch (pattern65 (x1, 
258))
        {
        case 0:
          if (!
#line 8931 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES))
            return -1;
          return 5178; /* aarch64_crypto_aesimcv16qi */

        case 1:
          if (!
#line 4158 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES))
            return -1;
          return 12982; /* aarch64_sve2_aesimc */

        case 2:
          if (!
#line 8971 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_AES
   && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 5180; /* *aarch64_crypto_aesd_fused */

        case 3:
          if (!
#line 4192 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_AES && aarch64_fusion_enabled_p (AARCH64_FUSE_AES_AESMC)))
            return -1;
          return 12984; /* *aarch64_sve2_aesd_fused */

        default:
          return -1;
        }

    case 264:
      return recog_35 (x1, insn, pnum_clobbers);

    case 585:
      return recog_30 (x1, insn, pnum_clobbers);

    case 587:
      return recog_45 (x1, insn, pnum_clobbers);

    case 586:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8BFmode)
          || !
#line 10014 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
        return -1;
      return 5279; /* aarch64_vbfcvt_highv8bf */

    case 153:
      return recog_21 (x1, insn, pnum_clobbers);

    case 159:
      if (pattern44 (x1, 
86, 
E_VNx16BImode) != 0
          || !
#line 1257 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5737; /* aarch64_update_ffrt */

    case 325:
      return recog_34 (x1, insn, pnum_clobbers);

    case 77:
      return recog_11 (x1, insn, pnum_clobbers);

    case 129:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 9370 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10834; /* aarch64_sve_sunpkhi_vnx16qi */

        case 1:
          if (!
#line 9370 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10838; /* aarch64_sve_sunpkhi_vnx8hi */

        case 2:
          if (!
#line 9370 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10842; /* aarch64_sve_sunpkhi_vnx4si */

        default:
          return -1;
        }

    case 130:
      return recog_56 (x1, insn, pnum_clobbers);

    case 131:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 9370 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10836; /* aarch64_sve_sunpklo_vnx16qi */

        case 1:
          if (!
#line 9370 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10840; /* aarch64_sve_sunpklo_vnx8hi */

        case 2:
          if (!
#line 9370 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10844; /* aarch64_sve_sunpklo_vnx4si */

        default:
          return -1;
        }

    case 132:
      return recog_55 (x1, insn, pnum_clobbers);

    case 613:
      return recog_29 (x1, insn, pnum_clobbers);

    case 611:
      return recog_54 (x1, insn, pnum_clobbers);

    case 482:
      return recog_53 (x1, insn, pnum_clobbers);

    case 528:
      switch (pattern70 (x1))
        {
        case 0:
          if (!
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12367; /* aarch64_sve_sqxtnbvnx8hi */

        case 1:
          if (!
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12370; /* aarch64_sve_sqxtnbvnx4si */

        case 2:
          if (!
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12373; /* aarch64_sve_sqxtnbvnx2di */

        default:
          return -1;
        }

    case 530:
      switch (pattern70 (x1))
        {
        case 0:
          if (!
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12368; /* aarch64_sve_sqxtunbvnx8hi */

        case 1:
          if (!
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12371; /* aarch64_sve_sqxtunbvnx4si */

        case 2:
          if (!
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12374; /* aarch64_sve_sqxtunbvnx2di */

        default:
          return -1;
        }

    case 565:
      switch (pattern70 (x1))
        {
        case 0:
          if (!
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12369; /* aarch64_sve_uqxtnbvnx8hi */

        case 1:
          if (!
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12372; /* aarch64_sve_uqxtnbvnx4si */

        case 2:
          if (!
#line 2627 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12375; /* aarch64_sve_uqxtnbvnx2di */

        default:
          return -1;
        }

    case 617:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12385; /* aarch64_sve_sqcvtvnx16qivnx16si */

        case 1:
          if (!
#line 3727 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12391; /* aarch64_sve_sqcvtvnx8hivnx8si */

        case 2:
          if (!
#line 2675 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12397; /* aarch64_sve_sqcvtvnx8hivnx8di */

        default:
          return -1;
        }

    case 618:
      switch (pattern71 (x1))
        {
        case 0:
          if (!(
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3728 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12386; /* aarch64_sve_sqcvtnvnx16qivnx16si */

        case 1:
          if (!
#line 3728 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12392; /* aarch64_sve_sqcvtnvnx8hivnx8si */

        case 2:
          if (!(
#line 2675 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3728 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12398; /* aarch64_sve_sqcvtnvnx8hivnx8di */

        default:
          return -1;
        }

    case 619:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12387; /* aarch64_sve_sqcvtuvnx16qivnx16si */

        case 1:
          if (!
#line 3729 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12393; /* aarch64_sve_sqcvtuvnx8hivnx8si */

        case 2:
          if (!
#line 2675 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12399; /* aarch64_sve_sqcvtuvnx8hivnx8di */

        default:
          return -1;
        }

    case 620:
      switch (pattern71 (x1))
        {
        case 0:
          if (!(
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3730 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12388; /* aarch64_sve_sqcvtunvnx16qivnx16si */

        case 1:
          if (!
#line 3730 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12394; /* aarch64_sve_sqcvtunvnx8hivnx8si */

        case 2:
          if (!(
#line 2675 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3730 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12400; /* aarch64_sve_sqcvtunvnx8hivnx8di */

        default:
          return -1;
        }

    case 626:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12389; /* aarch64_sve_uqcvtvnx16qivnx16si */

        case 1:
          if (!
#line 3731 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12395; /* aarch64_sve_uqcvtvnx8hivnx8si */

        case 2:
          if (!
#line 2675 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12401; /* aarch64_sve_uqcvtvnx8hivnx8di */

        default:
          return -1;
        }

    case 627:
      switch (pattern71 (x1))
        {
        case 0:
          if (!(
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3732 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12390; /* aarch64_sve_uqcvtnvnx16qivnx16si */

        case 1:
          if (!
#line 3732 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12396; /* aarch64_sve_uqcvtnvnx8hivnx8si */

        case 2:
          if (!(
#line 2675 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 3732 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2)))
            return -1;
          return 12402; /* aarch64_sve_uqcvtnvnx8hivnx8di */

        default:
          return -1;
        }

    case 604:
      if (GET_MODE (x2) != E_VNx8SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!aligned_register_operand (operands[0], E_VNx8SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx8HFmode)
          || !
#line 3348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME_F16F16))
        return -1;
      return 12650; /* aarch64_sve_cvtlvnx8sf */

    case 605:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!aligned_register_operand (operands[1], E_VNx8SFmode))
        return -1;
      switch (pattern135 (x2))
        {
        case 0:
          if (!
#line 3377 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12653; /* aarch64_sve_cvtnvnx8bf */

        case 1:
          if (!
#line 3377 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12654; /* aarch64_sve_cvtnvnx8hf */

        default:
          return -1;
        }

    case 576:
      return recog_44 (x1, insn, pnum_clobbers);

    case 574:
      return recog_43 (x1, insn, pnum_clobbers);

    case 577:
      return recog_42 (x1, insn, pnum_clobbers);

    case 575:
      return recog_41 (x1, insn, pnum_clobbers);

    case 683:
      if (pattern44 (x1, 
67, 
E_DImode) != 0)
        return -1;
      return 12989; /* aarch64_update_vg */

    case 694:
      if (pattern53 (x1, 
88) != 0
          || !memory_operand (operands[0], E_V16QImode))
        return -1;
      return 12998; /* aarch64_setup_local_tpidr2 */

    case 696:
      if (pattern44 (x1, 
87, 
E_DImode) != 0)
        return -1;
      return 13006; /* aarch64_start_private_za_call */

    case 697:
      if (pattern44 (x1, 
87, 
E_DImode) != 0)
        return -1;
      return 13007; /* aarch64_end_private_za_call */

    default:
      return -1;
    }
}

 int
recog_465 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (aarch64_comparison_operation (operands[2], E_VOIDmode))
    {
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && GET_MODE (x2) == E_SImode
              && register_operand (operands[1], E_SImode))
            return 473; /* *csinc2si_insn */
          break;

        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && register_operand (operands[1], E_DImode))
            return 474; /* *csinc2di_insn */
          break;

        default:
          break;
        }
    }
  if (GET_CODE (x3) != EQ)
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x3, 1);
      operands[3] = x8;
      x4 = XEXP (x2, 1);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern955 (x2, 
E_V8QImode) != 0
              || !
#line 7331 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4211; /* aarch64_cmtstv8qi */

        case E_V16QImode:
          if (pattern955 (x2, 
E_V16QImode) != 0
              || !
#line 7331 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4214; /* aarch64_cmtstv16qi */

        case E_V4HImode:
          if (pattern955 (x2, 
E_V4HImode) != 0
              || !
#line 7331 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4215; /* aarch64_cmtstv4hi */

        case E_V8HImode:
          if (pattern955 (x2, 
E_V8HImode) != 0
              || !
#line 7331 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4218; /* aarch64_cmtstv8hi */

        case E_V2SImode:
          if (pattern955 (x2, 
E_V2SImode) != 0
              || !
#line 7331 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4219; /* aarch64_cmtstv2si */

        case E_V4SImode:
          if (pattern955 (x2, 
E_V4SImode) != 0
              || !
#line 7331 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4222; /* aarch64_cmtstv4si */

        case E_V2DImode:
          if (pattern955 (x2, 
E_V2DImode) != 0
              || !
#line 7331 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4223; /* aarch64_cmtstv2di */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x5;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern894 (x2, 
E_V8QImode) != 0
              || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4224; /* *aarch64_cmtst_same_v8qi */

        case E_V16QImode:
          if (pattern894 (x2, 
E_V16QImode) != 0
              || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4227; /* *aarch64_cmtst_same_v16qi */

        case E_V4HImode:
          if (pattern894 (x2, 
E_V4HImode) != 0
              || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4228; /* *aarch64_cmtst_same_v4hi */

        case E_V8HImode:
          if (pattern894 (x2, 
E_V8HImode) != 0
              || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4231; /* *aarch64_cmtst_same_v8hi */

        case E_V2SImode:
          if (pattern894 (x2, 
E_V2SImode) != 0
              || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4232; /* *aarch64_cmtst_same_v2si */

        case E_V4SImode:
          if (pattern894 (x2, 
E_V4SImode) != 0
              || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4235; /* *aarch64_cmtst_same_v4si */

        case E_V2DImode:
          if (pattern894 (x2, 
E_V2DImode) != 0
              || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4236; /* *aarch64_cmtst_same_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_470 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x2, 
E_SImode) == 0)
            return 377; /* mulsi3 */
          break;

        case E_DImode:
          if (pattern31 (x2, 
E_DImode) == 0)
            return 378; /* muldi3 */
          break;

        case E_HFmode:
          if (pattern31 (x2, 
E_HFmode) == 0
              && (
#line 7280 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return 1063; /* mulhf3 */
          break;

        case E_SFmode:
          if (pattern31 (x2, 
E_SFmode) == 0
              && 
#line 7280 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1064; /* mulsf3 */
          break;

        case E_DFmode:
          if (pattern31 (x2, 
E_DFmode) == 0
              && 
#line 7280 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1065; /* muldf3 */
          break;

        case E_V8QImode:
          if (pattern31 (x2, 
E_V8QImode) == 0
              && 
#line 364 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1379; /* mulv8qi3 */
          break;

        case E_V16QImode:
          if (pattern31 (x2, 
E_V16QImode) == 0
              && 
#line 364 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1382; /* mulv16qi3 */
          break;

        case E_V4HImode:
          if (pattern31 (x2, 
E_V4HImode) == 0
              && 
#line 364 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1383; /* mulv4hi3 */
          break;

        case E_V8HImode:
          if (pattern31 (x2, 
E_V8HImode) == 0
              && 
#line 364 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1386; /* mulv8hi3 */
          break;

        case E_V2SImode:
          if (pattern31 (x2, 
E_V2SImode) == 0
              && 
#line 364 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1387; /* mulv2si3 */
          break;

        case E_V4SImode:
          if (pattern31 (x2, 
E_V4SImode) == 0
              && 
#line 364 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1390; /* mulv4si3 */
          break;

        case E_V4HFmode:
          if (pattern31 (x2, 
E_V4HFmode) == 0
              && (
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2378; /* mulv4hf3 */
          break;

        case E_V8HFmode:
          if (pattern31 (x2, 
E_V8HFmode) == 0
              && (
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2381; /* mulv8hf3 */
          break;

        case E_V2SFmode:
          if (pattern31 (x2, 
E_V2SFmode) == 0
              && 
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2382; /* mulv2sf3 */
          break;

        case E_V4SFmode:
          if (pattern31 (x2, 
E_V4SFmode) == 0
              && 
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2385; /* mulv4sf3 */
          break;

        case E_V2DFmode:
          if (pattern31 (x2, 
E_V2DFmode) == 0
              && 
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2386; /* mulv2df3 */
          break;

        case E_VNx8BFmode:
          if (pattern31 (x2, 
E_VNx8BFmode) == 0
              && (
#line 5372 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return 8501; /* *post_ra_fmulvnx8bf3 */
          break;

        case E_VNx8HFmode:
          if (pattern31 (x2, 
E_VNx8HFmode) == 0
              && 
#line 5372 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 8504; /* *post_ra_fmulvnx8hf3 */
          break;

        case E_VNx4SFmode:
          if (pattern31 (x2, 
E_VNx4SFmode) == 0
              && 
#line 5372 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 8507; /* *post_ra_fmulvnx4sf3 */
          break;

        case E_VNx2DFmode:
          if (pattern31 (x2, 
E_VNx2DFmode) == 0
              && 
#line 5372 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 8510; /* *post_ra_fmulvnx2df3 */
          break;

        default:
          break;
        }
      break;

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern313 (x2, 
E_VNx16QImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7419; /* *post_ra_mulvnx16qi3 */
          break;

        case E_VNx8QImode:
          if (pattern313 (x2, 
E_VNx8QImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7424; /* *post_ra_mulvnx8qi3 */
          break;

        case E_VNx4QImode:
          if (pattern313 (x2, 
E_VNx4QImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7429; /* *post_ra_mulvnx4qi3 */
          break;

        case E_VNx2QImode:
          if (pattern313 (x2, 
E_VNx2QImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7434; /* *post_ra_mulvnx2qi3 */
          break;

        case E_VNx8HImode:
          if (pattern313 (x2, 
E_VNx8HImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7439; /* *post_ra_mulvnx8hi3 */
          break;

        case E_VNx4HImode:
          if (pattern313 (x2, 
E_VNx4HImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7444; /* *post_ra_mulvnx4hi3 */
          break;

        case E_VNx2HImode:
          if (pattern313 (x2, 
E_VNx2HImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7449; /* *post_ra_mulvnx2hi3 */
          break;

        case E_VNx4SImode:
          if (pattern313 (x2, 
E_VNx4SImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7454; /* *post_ra_mulvnx4si3 */
          break;

        case E_VNx2SImode:
          if (pattern313 (x2, 
E_VNx2SImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7459; /* *post_ra_mulvnx2si3 */
          break;

        case E_VNx2DImode:
          if (pattern313 (x2, 
E_VNx2DImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7464; /* *post_ra_mulvnx2di3 */
          break;

        case E_V2DImode:
          if (pattern313 (x2, 
E_V2DImode) == 0
              && 
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return 7469; /* *post_ra_mulv2di3 */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern652 (x2, 
E_VNx16QImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11612; /* *aarch64_mul_unpredicated_vnx16qi */

    case E_VNx8QImode:
      if (pattern652 (x2, 
E_VNx8QImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11613; /* *aarch64_mul_unpredicated_vnx8qi */

    case E_VNx4QImode:
      if (pattern652 (x2, 
E_VNx4QImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11614; /* *aarch64_mul_unpredicated_vnx4qi */

    case E_VNx2QImode:
      if (pattern652 (x2, 
E_VNx2QImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11615; /* *aarch64_mul_unpredicated_vnx2qi */

    case E_VNx8HImode:
      if (pattern652 (x2, 
E_VNx8HImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11616; /* *aarch64_mul_unpredicated_vnx8hi */

    case E_VNx4HImode:
      if (pattern652 (x2, 
E_VNx4HImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11617; /* *aarch64_mul_unpredicated_vnx4hi */

    case E_VNx2HImode:
      if (pattern652 (x2, 
E_VNx2HImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11618; /* *aarch64_mul_unpredicated_vnx2hi */

    case E_VNx4SImode:
      if (pattern652 (x2, 
E_VNx4SImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11619; /* *aarch64_mul_unpredicated_vnx4si */

    case E_VNx2SImode:
      if (pattern652 (x2, 
E_VNx2SImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11620; /* *aarch64_mul_unpredicated_vnx2si */

    case E_VNx2DImode:
      if (pattern652 (x2, 
E_VNx2DImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11621; /* *aarch64_mul_unpredicated_vnx2di */

    case E_V2DImode:
      if (pattern652 (x2, 
E_V2DImode) != 0
          || !
#line 859 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11622; /* *aarch64_mul_unpredicated_v2di */

    default:
      return -1;
    }
}

 int
recog_477 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 2);
  operands[1] = x6;
  switch (GET_MODE (x3))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !const_int_operand (operands[1], E_SImode)
          || !const_int_operand (operands[2], E_SImode)
          || !
#line 1663 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[1]) < GET_MODE_BITSIZE (SImode)
   && UINTVAL (operands[1]) % 16 == 0))
        return -1;
      return 71; /* insv_immsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !const_int_operand (operands[1], E_DImode)
          || !const_int_operand (operands[2], E_DImode)
          || !
#line 1663 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[1]) < GET_MODE_BITSIZE (DImode)
   && UINTVAL (operands[1]) % 16 == 0))
        return -1;
      return 72; /* insv_immdi */

    default:
      return -1;
    }
}

 int
recog_479 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x4, 1);
          switch (GET_CODE (x7))
            {
            case SIGN_EXTEND:
              switch (pattern817 (x2))
                {
                case 0:
                  if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3082; /* *aarch64_shaddv8qi_insn */

                case 1:
                  if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3094; /* *aarch64_shaddv16qi_insn */

                case 2:
                  if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3098; /* *aarch64_shaddv4hi_insn */

                case 3:
                  if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3110; /* *aarch64_shaddv8hi_insn */

                case 4:
                  if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3114; /* *aarch64_shaddv2si_insn */

                case 5:
                  if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3126; /* *aarch64_shaddv4si_insn */

                default:
                  return -1;
                }

            case CONST_INT:
            case CONST_WIDE_INT:
            case CONST_VECTOR:
              switch (pattern756 (x2))
                {
                case 0:
                  if (pattern1015 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 6600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3794; /* aarch64_srshr_nv8qi_insn */

                case 1:
                  if (pattern1015 (x2, 
E_V16QImode, 
E_V16HImode) != 0
                      || !
#line 6600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3800; /* aarch64_srshr_nv16qi_insn */

                case 2:
                  if (pattern1016 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 6600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3802; /* aarch64_srshr_nv4hi_insn */

                case 3:
                  if (pattern1016 (x2, 
E_V8HImode, 
E_V8SImode) != 0
                      || !
#line 6600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3808; /* aarch64_srshr_nv8hi_insn */

                case 4:
                  if (pattern1017 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                      || !
#line 6600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3810; /* aarch64_srshr_nv2si_insn */

                case 5:
                  if (pattern1017 (x2, 
E_V4SImode, 
E_V4DImode) != 0
                      || !
#line 6600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3816; /* aarch64_srshr_nv4si_insn */

                case 6:
                  if (pattern1018 (x2) != 0
                      || !
#line 6600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3818; /* aarch64_srshr_nv2di_insn */

                case 7:
                  if (!
#line 6600 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2])))
                    return -1;
                  return 3820; /* aarch64_srshr_ndi_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != ZERO_EXTEND)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          switch (pattern817 (x2))
            {
            case 0:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3088; /* *aarch64_uhaddv8qi_insn */

            case 1:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3096; /* *aarch64_uhaddv16qi_insn */

            case 2:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3104; /* *aarch64_uhaddv4hi_insn */

            case 3:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3112; /* *aarch64_uhaddv8hi_insn */

            case 4:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3120; /* *aarch64_uhaddv2si_insn */

            case 5:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3128; /* *aarch64_uhaddv4si_insn */

            default:
              return -1;
            }

        case PLUS:
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern819 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3130; /* *aarch64_srhaddv8qi_insn */

                case 1:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3136; /* *aarch64_srhaddv16qi_insn */

                case 2:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3138; /* *aarch64_srhaddv4hi_insn */

                case 3:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3144; /* *aarch64_srhaddv8hi_insn */

                case 4:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3146; /* *aarch64_srhaddv2si_insn */

                case 5:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3152; /* *aarch64_srhaddv4si_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern819 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3133; /* *aarch64_urhaddv8qi_insn */

                case 1:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3137; /* *aarch64_urhaddv16qi_insn */

                case 2:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3141; /* *aarch64_urhaddv4hi_insn */

                case 3:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3145; /* *aarch64_urhaddv8hi_insn */

                case 4:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3149; /* *aarch64_urhaddv2si_insn */

                case 5:
                  if (!
#line 4836 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3153; /* *aarch64_urhaddv4si_insn */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x6;
              x8 = XEXP (x5, 1);
              operands[2] = x8;
              switch (pattern904 (x2))
                {
                case 0:
                  if (!
#line 4864 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3172; /* aarch64_raddhnv8hi_insn */

                case 1:
                  if (!
#line 4864 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3178; /* aarch64_raddhnv4si_insn */

                case 2:
                  if (!
#line 4864 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3184; /* aarch64_raddhnv2di_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern964 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4850 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3154; /* aarch64_addhnv8hi_insn */

            case E_V4HImode:
              if (pattern964 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4850 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3160; /* aarch64_addhnv4si_insn */

            case E_V2SImode:
              if (pattern964 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4850 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3166; /* aarch64_addhnv2di_insn */

            default:
              return -1;
            }

        case MINUS:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          x7 = XEXP (x4, 1);
          operands[3] = x7;
          switch (pattern904 (x2))
            {
            case 0:
              if (!
#line 4864 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3175; /* aarch64_rsubhnv8hi_insn */

            case 1:
              if (!
#line 4864 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3181; /* aarch64_rsubhnv4si_insn */

            case 2:
              if (!
#line 4864 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3187; /* aarch64_rsubhnv2di_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          switch (pattern759 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3085; /* *aarch64_shsubv8qi_insn */

            case 1:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3095; /* *aarch64_shsubv16qi_insn */

            case 2:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3101; /* *aarch64_shsubv4hi_insn */

            case 3:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3111; /* *aarch64_shsubv8hi_insn */

            case 4:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3117; /* *aarch64_shsubv2si_insn */

            case 5:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3127; /* *aarch64_shsubv4si_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern759 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3091; /* *aarch64_uhsubv8qi_insn */

            case 1:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3097; /* *aarch64_uhsubv16qi_insn */

            case 2:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3107; /* *aarch64_uhsubv4hi_insn */

            case 3:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3113; /* *aarch64_uhsubv8hi_insn */

            case 4:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3123; /* *aarch64_uhsubv2si_insn */

            case 5:
              if (!
#line 4819 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3129; /* *aarch64_uhsubv4si_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern964 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4850 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3157; /* aarch64_subhnv8hi_insn */

            case E_V4HImode:
              if (pattern964 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4850 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3163; /* aarch64_subhnv4si_insn */

            case E_V2SImode:
              if (pattern964 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4850 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3169; /* aarch64_subhnv2di_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern345 (x2))
        {
        case 0:
          if (!
#line 6693 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
            return -1;
          return 3911; /* *aarch64_sshrn_nv8hi_insn */

        case 1:
          if (!
#line 6693 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
            return -1;
          return 3929; /* *aarch64_sshrn_nv4si_insn */

        case 2:
          if (!
#line 6693 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
            return -1;
          return 3947; /* *aarch64_sshrn_nv2di_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_486 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern424 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1355; /* addv8qi3_vec_concatz_be */

        case E_V8HImode:
          if (pattern424 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1359; /* addv4hi3_vec_concatz_be */

        case E_V4SImode:
          if (pattern424 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 346 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1363; /* addv2si3_vec_concatz_be */

        case E_V8HFmode:
          if (pattern424 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2362; /* addv4hf3_vec_concatz_be */

        case E_V4SFmode:
          if (pattern424 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2366; /* addv2sf3_vec_concatz_be */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1420; /* aarch64_fcmla0v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1436; /* aarch64_fcmla0v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 408:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1423; /* aarch64_fcmla90v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1439; /* aarch64_fcmla90v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 409:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1426; /* aarch64_fcmla180v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1442; /* aarch64_fcmla180v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 410:
              switch (pattern829 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 458 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1429; /* aarch64_fcmla270v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 458 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1445; /* aarch64_fcmla270v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 279:
              if (pattern830 (x2) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1512; /* sdot_prodv2siv8qi_vec_concatz_be */

            case 280:
              if (pattern830 (x2) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 577 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                return -1;
              return 1515; /* udot_prodv2siv8qi_vec_concatz_be */

            case 573:
              if (pattern830 (x2) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 591 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                return -1;
              return 1520; /* usdot_prodv2siv8qi_vec_concatz_be */

            default:
              return -1;
            }

        case 3:
          x5 = XEXP (x2, 0);
          operands[5] = x5;
          x7 = XVECEXP (x4, 0, 0);
          operands[2] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[3] = x8;
          x9 = XVECEXP (x4, 0, 2);
          operands[4] = x9;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          switch (XINT (x4, 1))
            {
            case 407:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1456; /* aarch64_fcmla_lane0v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1492; /* aarch64_fcmla_laneq0v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1472; /* aarch64_fcmla_lane0v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 408:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1459; /* aarch64_fcmla_lane90v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1495; /* aarch64_fcmla_laneq90v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1475; /* aarch64_fcmla_lane90v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 409:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1462; /* aarch64_fcmla_lane180v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1498; /* aarch64_fcmla_laneq180v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1478; /* aarch64_fcmla_lane180v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 410:
              switch (pattern1079 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 471 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 1465; /* aarch64_fcmla_lane270v4hf_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 486 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1501; /* aarch64_fcmla_laneq270v4hf_vec_concatz_be */

                case 2:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 471 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
                    return -1;
                  return 1481; /* aarch64_fcmla_lane270v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case 279:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1524; /* aarch64_sdot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 622 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1532; /* aarch64_sdot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            case 280:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 606 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1527; /* aarch64_udot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 622 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD)))
                    return -1;
                  return 1535; /* aarch64_udot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            case 573:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1540; /* aarch64_usdot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1548; /* aarch64_usdot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            case 578:
              switch (pattern1080 (x2))
                {
                case 0:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1543; /* aarch64_sudot_lanev8qi_vec_concatz_be */

                case 1:
                  if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 640 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM)))
                    return -1;
                  return 1551; /* aarch64_sudot_laneqv8qi_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x10 = XEXP (x4, 0);
      if (GET_CODE (x10) != VEC_SELECT)
        return -1;
      x11 = XEXP (x4, 1);
      if (GET_CODE (x11) != VEC_SELECT)
        return -1;
      x5 = XEXP (x2, 0);
      operands[5] = x5;
      x12 = XEXP (x10, 1);
      operands[3] = x12;
      x13 = XEXP (x11, 1);
      operands[4] = x13;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x14 = XEXP (x10, 0);
      switch (GET_CODE (x14))
        {
        case SIGN_EXTEND:
          switch (pattern1082 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1703; /* *aarch64_sadalpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1711; /* *aarch64_sadalpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1721; /* *aarch64_sadalpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1082 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1706; /* *aarch64_uadalpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1714; /* *aarch64_uadalpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 1724; /* *aarch64_uadalpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x2, 0);
      operands[4] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SMAX:
          switch (pattern832 (x2, 
SMIN))
            {
            case 0:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1727; /* aarch64_sabav8qi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1735; /* aarch64_sabav4hi_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1743; /* aarch64_sabav2si_vec_concatz_be */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern832 (x2, 
UMIN))
            {
            case 0:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1730; /* aarch64_uabav8qi_vec_concatz_be */

            case 1:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1738; /* aarch64_uabav4hi_vec_concatz_be */

            case 2:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1104 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1746; /* aarch64_uabav2si_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          operands[2] = x10;
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1019 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1636 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2002; /* aarch64_mlav8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern1019 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1636 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2006; /* aarch64_mlav4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern1019 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1636 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2010; /* aarch64_mlav2si_vec_concatz_be */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x14 = XEXP (x10, 0);
          switch (GET_CODE (x14))
            {
            case VEC_SELECT:
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != PARALLEL
                  || XVECLEN (x15, 0) != 1)
                return -1;
              x5 = XEXP (x2, 0);
              operands[5] = x5;
              x16 = XEXP (x14, 0);
              operands[1] = x16;
              x17 = XVECEXP (x15, 0, 0);
              operands[2] = x17;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x4, 1);
              operands[3] = x11;
              x6 = XEXP (x3, 1);
              operands[4] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1238 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4HImode:
                      if (!register_operand (operands[1], E_V4HImode)
                          || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1651 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2014; /* *aarch64_mla_eltv4hi_vec_concatz_be */

                    case E_V8HImode:
                      if (!register_operand (operands[1], E_V8HImode)
                          || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1669 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2022; /* *aarch64_mla_elt_to_128v4hi_vec_concatz_be */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  if (pattern1238 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V2SImode:
                      if (!register_operand (operands[1], E_V2SImode)
                          || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1651 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2018; /* *aarch64_mla_eltv2si_vec_concatz_be */

                    case E_V4SImode:
                      if (!register_operand (operands[1], E_V4SImode)
                          || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1669 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2026; /* *aarch64_mla_elt_to_128v2si_vec_concatz_be */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x14;
              x5 = XEXP (x2, 0);
              operands[4] = x5;
              x11 = XEXP (x4, 1);
              operands[2] = x11;
              x6 = XEXP (x3, 1);
              operands[1] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1083 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2030; /* aarch64_mla_nv4hi_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1083 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2034; /* aarch64_mla_nv2si_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          switch (pattern762 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2796; /* *aarch64_saddlpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2804; /* *aarch64_saddlpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2814; /* *aarch64_saddlpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern762 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2799; /* *aarch64_uaddlpv8qi_vec_concatz_be_insn */

            case 1:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2807; /* *aarch64_uaddlpv4hi_vec_concatz_be_insn */

            case 2:
              if (!(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3540 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3]))))
                return -1;
              return 2817; /* *aarch64_uaddlpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        case VEC_CONCAT:
          x18 = XEXP (x6, 0);
          if (GET_CODE (x18) != VEC_CONCAT)
            return -1;
          x5 = XEXP (x2, 0);
          operands[5] = x5;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x19 = XEXP (x6, 1);
          operands[4] = x19;
          x20 = XEXP (x18, 0);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x21 = XEXP (x18, 1);
          if (!rtx_equal_p (x21, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1239 (x2, 
E_V16QImode, 
E_V8QImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7484 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4373; /* aarch64_addpv8qi_vec_concatz_be_insn */

            case E_V8HImode:
              if (pattern1239 (x2, 
E_V8HImode, 
E_V4HImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7484 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4376; /* aarch64_addpv4hi_vec_concatz_be_insn */

            case E_V4SImode:
              if (pattern1239 (x2, 
E_V4SImode, 
E_V2SImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7484 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4]))))
                return -1;
              return 4379; /* aarch64_addpv2si_vec_concatz_be_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EQ:
      x10 = XEXP (x4, 0);
      switch (GET_CODE (x10))
        {
        case AND:
          x5 = XEXP (x2, 0);
          operands[5] = x5;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x6 = XEXP (x3, 1);
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1084 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7331 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4213; /* aarch64_cmtstv8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern1084 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7331 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4217; /* aarch64_cmtstv4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern1084 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7331 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4221; /* aarch64_cmtstv2si_vec_concatz_be */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x10;
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          x11 = XEXP (x4, 1);
          operands[2] = x11;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1020 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4226; /* *aarch64_cmtst_same_v8qi_vec_concatz_be */

            case E_V8HImode:
              if (pattern1020 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4230; /* *aarch64_cmtst_same_v4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern1020 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 4234; /* *aarch64_cmtst_same_v2si_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_502 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern917 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2855 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2416; /* fmav4hf4_vec_concatz_le */

        case E_V4SFmode:
          if (pattern917 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2855 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2420; /* fmav2sf4_vec_concatz_le */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case VEC_SELECT:
          if (GET_MODE (x8) != E_SFmode)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 1
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x3) != E_V2SFmode
              || GET_MODE (x4) != E_V2SFmode)
            return -1;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          x11 = XVECEXP (x9, 0, 0);
          operands[2] = x11;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          x6 = XEXP (x3, 2);
          operands[4] = x6;
          if (!register_operand (operands[4], E_V2SFmode))
            return -1;
          x7 = XEXP (x2, 1);
          operands[5] = x7;
          if (!aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2SFmode:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2425; /* *aarch64_fma4_eltv2sf_vec_concatz_le */

            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2430; /* *aarch64_fma4_elt_to_128v2sf_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x8;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          x6 = XEXP (x3, 2);
          operands[3] = x6;
          x7 = XEXP (x2, 1);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern974 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2434; /* *aarch64_fma4_elt_from_dupv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern974 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2438; /* *aarch64_fma4_elt_from_dupv2si_vec_concatz_le */

            case E_V8HFmode:
              if (pattern974 (x2, 
E_V4HFmode, 
E_HFmode, 
E_V8HFmode) != 0
                  || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2442; /* *aarch64_fma4_elt_from_dupv4hf_vec_concatz_le */

            case E_V4SFmode:
              if (pattern974 (x2, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2901 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2446; /* *aarch64_fma4_elt_from_dupv2sf_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          x6 = XEXP (x3, 2);
          operands[3] = x6;
          x7 = XEXP (x2, 1);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern975 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2928 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2452; /* fnmav4hf4_vec_concatz_le */

            case E_V4SFmode:
              if (pattern975 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2928 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2456; /* fnmav2sf4_vec_concatz_le */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x12 = XEXP (x5, 0);
          switch (GET_CODE (x12))
            {
            case VEC_SELECT:
              if (GET_MODE (x12) != E_SFmode)
                return -1;
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != PARALLEL
                  || XVECLEN (x13, 0) != 1
                  || !register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || GET_MODE (x3) != E_V2SFmode
                  || GET_MODE (x4) != E_V2SFmode)
                return -1;
              x8 = XEXP (x4, 0);
              operands[3] = x8;
              if (!register_operand (operands[3], E_V2SFmode)
                  || GET_MODE (x5) != E_V2SFmode)
                return -1;
              x14 = XEXP (x12, 0);
              operands[1] = x14;
              x15 = XVECEXP (x13, 0, 0);
              operands[2] = x15;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x6 = XEXP (x3, 2);
              operands[4] = x6;
              if (!register_operand (operands[4], E_V2SFmode))
                return -1;
              x7 = XEXP (x2, 1);
              operands[5] = x7;
              if (!aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V2SFmode)
                      || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2943 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2461; /* *aarch64_fnma4_eltv2sf_vec_concatz_le */

                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2961 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2466; /* *aarch64_fnma4_elt_to_128v2sf_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x12;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              x6 = XEXP (x3, 2);
              operands[3] = x6;
              x7 = XEXP (x2, 1);
              operands[4] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1035 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                      || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2470; /* *aarch64_fnma4_elt_from_dupv4hi_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1035 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                      || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2474; /* *aarch64_fnma4_elt_from_dupv2si_vec_concatz_le */

                case E_V8HFmode:
                  if (pattern1035 (x2, 
E_V4HFmode, 
E_HFmode, 
E_V8HFmode) != 0
                      || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 2478; /* *aarch64_fnma4_elt_from_dupv4hf_vec_concatz_le */

                case E_V4SFmode:
                  if (pattern1035 (x2, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
                      || !(
#line 28 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2977 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2482; /* *aarch64_fnma4_elt_from_dupv2sf_vec_concatz_le */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_506 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case LABEL_REF:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              return 6; /* jump */
            }
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
          switch (GET_CODE (x2))
            {
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
              res = recog_476 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CONST_INT:
              res = recog_477 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x2;
          if (aarch64_movti_operand (operands[1], E_TImode))
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (nonimmediate_operand (operands[0], E_TImode)
                  && 
#line 1710 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], TImode)
    || aarch64_reg_or_zero (operands[1], TImode))))
                return 75; /* *movti_aarch64 */
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (register_operand (operands[0], E_VNx16QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16QImode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx16QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx16QImode)))))
            return 5542; /* *aarch64_sve_movvnx16qi_no_ldr_str */
          break;

        case E_VNx8QImode:
          if (register_operand (operands[0], E_VNx8QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8QImode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8QImode)))))
            return 5543; /* *aarch64_sve_movvnx8qi_no_ldr_str */
          break;

        case E_VNx4QImode:
          if (register_operand (operands[0], E_VNx4QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4QImode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4QImode)))))
            return 5544; /* *aarch64_sve_movvnx4qi_no_ldr_str */
          break;

        case E_VNx2QImode:
          if (register_operand (operands[0], E_VNx2QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2QImode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2QImode)))))
            return 5545; /* *aarch64_sve_movvnx2qi_no_ldr_str */
          break;

        case E_VNx8HImode:
          if (register_operand (operands[0], E_VNx8HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8HImode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8HImode)))))
            return 5546; /* *aarch64_sve_movvnx8hi_no_ldr_str */
          break;

        case E_VNx4HImode:
          if (register_operand (operands[0], E_VNx4HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4HImode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4HImode)))))
            return 5547; /* *aarch64_sve_movvnx4hi_no_ldr_str */
          break;

        case E_VNx2HImode:
          if (register_operand (operands[0], E_VNx2HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2HImode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2HImode)))))
            return 5548; /* *aarch64_sve_movvnx2hi_no_ldr_str */
          break;

        case E_VNx4SImode:
          if (register_operand (operands[0], E_VNx4SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4SImode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4SImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4SImode)))))
            return 5549; /* *aarch64_sve_movvnx4si_no_ldr_str */
          break;

        case E_VNx2SImode:
          if (register_operand (operands[0], E_VNx2SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2SImode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2SImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2SImode)))))
            return 5550; /* *aarch64_sve_movvnx2si_no_ldr_str */
          break;

        case E_VNx2DImode:
          if (register_operand (operands[0], E_VNx2DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2DImode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2DImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2DImode)))))
            return 5551; /* *aarch64_sve_movvnx2di_no_ldr_str */
          break;

        case E_VNx8HFmode:
          if (register_operand (operands[0], E_VNx8HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8HFmode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8HFmode)))))
            return 5552; /* *aarch64_sve_movvnx8hf_no_ldr_str */
          break;

        case E_VNx4HFmode:
          if (register_operand (operands[0], E_VNx4HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4HFmode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4HFmode)))))
            return 5553; /* *aarch64_sve_movvnx4hf_no_ldr_str */
          break;

        case E_VNx2HFmode:
          if (register_operand (operands[0], E_VNx2HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2HFmode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2HFmode)))))
            return 5554; /* *aarch64_sve_movvnx2hf_no_ldr_str */
          break;

        case E_VNx8BFmode:
          if (register_operand (operands[0], E_VNx8BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8BFmode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8BFmode)))))
            return 5555; /* *aarch64_sve_movvnx8bf_no_ldr_str */
          break;

        case E_VNx4BFmode:
          if (register_operand (operands[0], E_VNx4BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4BFmode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4BFmode)))))
            return 5556; /* *aarch64_sve_movvnx4bf_no_ldr_str */
          break;

        case E_VNx2BFmode:
          if (register_operand (operands[0], E_VNx2BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2BFmode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2BFmode)))))
            return 5557; /* *aarch64_sve_movvnx2bf_no_ldr_str */
          break;

        case E_VNx4SFmode:
          if (register_operand (operands[0], E_VNx4SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4SFmode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4SFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4SFmode)))))
            return 5558; /* *aarch64_sve_movvnx4sf_no_ldr_str */
          break;

        case E_VNx2SFmode:
          if (register_operand (operands[0], E_VNx2SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2SFmode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2SFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2SFmode)))))
            return 5559; /* *aarch64_sve_movvnx2sf_no_ldr_str */
          break;

        case E_VNx2DFmode:
          if (register_operand (operands[0], E_VNx2DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2DFmode)
              && 
#line 711 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2DFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2DFmode)))))
            return 5560; /* *aarch64_sve_movvnx2df_no_ldr_str */
          break;

        case E_VNx32QImode:
          if (register_operand (operands[0], E_VNx32QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32QImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5666; /* *aarch64_sve_movvnx32qi_be */
          break;

        case E_VNx16HImode:
          if (register_operand (operands[0], E_VNx16HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16HImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5667; /* *aarch64_sve_movvnx16hi_be */
          break;

        case E_VNx8SImode:
          if (register_operand (operands[0], E_VNx8SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8SImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5668; /* *aarch64_sve_movvnx8si_be */
          break;

        case E_VNx4DImode:
          if (register_operand (operands[0], E_VNx4DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4DImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5669; /* *aarch64_sve_movvnx4di_be */
          break;

        case E_VNx16BFmode:
          if (register_operand (operands[0], E_VNx16BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16BFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5670; /* *aarch64_sve_movvnx16bf_be */
          break;

        case E_VNx16HFmode:
          if (register_operand (operands[0], E_VNx16HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16HFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5671; /* *aarch64_sve_movvnx16hf_be */
          break;

        case E_VNx8SFmode:
          if (register_operand (operands[0], E_VNx8SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8SFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5672; /* *aarch64_sve_movvnx8sf_be */
          break;

        case E_VNx4DFmode:
          if (register_operand (operands[0], E_VNx4DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4DFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5673; /* *aarch64_sve_movvnx4df_be */
          break;

        case E_VNx48QImode:
          if (register_operand (operands[0], E_VNx48QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx48QImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5674; /* *aarch64_sve_movvnx48qi_be */
          break;

        case E_VNx24HImode:
          if (register_operand (operands[0], E_VNx24HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24HImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5675; /* *aarch64_sve_movvnx24hi_be */
          break;

        case E_VNx12SImode:
          if (register_operand (operands[0], E_VNx12SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx12SImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5676; /* *aarch64_sve_movvnx12si_be */
          break;

        case E_VNx6DImode:
          if (register_operand (operands[0], E_VNx6DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx6DImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5677; /* *aarch64_sve_movvnx6di_be */
          break;

        case E_VNx24BFmode:
          if (register_operand (operands[0], E_VNx24BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24BFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5678; /* *aarch64_sve_movvnx24bf_be */
          break;

        case E_VNx24HFmode:
          if (register_operand (operands[0], E_VNx24HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24HFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5679; /* *aarch64_sve_movvnx24hf_be */
          break;

        case E_VNx12SFmode:
          if (register_operand (operands[0], E_VNx12SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx12SFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5680; /* *aarch64_sve_movvnx12sf_be */
          break;

        case E_VNx6DFmode:
          if (register_operand (operands[0], E_VNx6DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx6DFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5681; /* *aarch64_sve_movvnx6df_be */
          break;

        case E_VNx64QImode:
          if (register_operand (operands[0], E_VNx64QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx64QImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5682; /* *aarch64_sve_movvnx64qi_be */
          break;

        case E_VNx32HImode:
          if (register_operand (operands[0], E_VNx32HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32HImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5683; /* *aarch64_sve_movvnx32hi_be */
          break;

        case E_VNx16SImode:
          if (register_operand (operands[0], E_VNx16SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16SImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5684; /* *aarch64_sve_movvnx16si_be */
          break;

        case E_VNx8DImode:
          if (register_operand (operands[0], E_VNx8DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8DImode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5685; /* *aarch64_sve_movvnx8di_be */
          break;

        case E_VNx32BFmode:
          if (register_operand (operands[0], E_VNx32BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32BFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5686; /* *aarch64_sve_movvnx32bf_be */
          break;

        case E_VNx32HFmode:
          if (register_operand (operands[0], E_VNx32HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32HFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5687; /* *aarch64_sve_movvnx32hf_be */
          break;

        case E_VNx16SFmode:
          if (register_operand (operands[0], E_VNx16SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16SFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5688; /* *aarch64_sve_movvnx16sf_be */
          break;

        case E_VNx8DFmode:
          if (register_operand (operands[0], E_VNx8DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8DFmode)
              && 
#line 865 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5689; /* *aarch64_sve_movvnx8df_be */
          break;

        case E_VNx16BImode:
          if (nonimmediate_operand (operands[0], E_VNx16BImode)
              && aarch64_mov_operand (operands[1], E_VNx16BImode)
              && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16BImode)
       || register_operand (operands[1], VNx16BImode))))
            return 5714; /* *aarch64_sve_movvnx16bi */
          break;

        case E_VNx8BImode:
          if (nonimmediate_operand (operands[0], E_VNx8BImode)
              && aarch64_mov_operand (operands[1], E_VNx8BImode)
              && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8BImode)
       || register_operand (operands[1], VNx8BImode))))
            return 5715; /* *aarch64_sve_movvnx8bi */
          break;

        case E_VNx4BImode:
          if (nonimmediate_operand (operands[0], E_VNx4BImode)
              && aarch64_mov_operand (operands[1], E_VNx4BImode)
              && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4BImode)
       || register_operand (operands[1], VNx4BImode))))
            return 5716; /* *aarch64_sve_movvnx4bi */
          break;

        case E_VNx2BImode:
          if (nonimmediate_operand (operands[0], E_VNx2BImode)
              && aarch64_mov_operand (operands[1], E_VNx2BImode)
              && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2BImode)
       || register_operand (operands[1], VNx2BImode))))
            return 5717; /* *aarch64_sve_movvnx2bi */
          break;

        case E_VNx32BImode:
          if (nonimmediate_operand (operands[0], E_VNx32BImode)
              && aarch64_mov_operand (operands[1], E_VNx32BImode)
              && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 5726; /* movvnx32bi */
          break;

        case E_VNx64BImode:
          if (nonimmediate_operand (operands[0], E_VNx64BImode)
              && aarch64_mov_operand (operands[1], E_VNx64BImode)
              && 
#line 1079 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 5727; /* movvnx64bi */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) == REG
          && GET_MODE (x2) == E_VNx16BImode)
        {
          switch (REGNO (x2))
            {
            case 85:
              if (GET_CODE (x3) == REG
                  && REGNO (x3) == 86
                  && GET_MODE (x3) == E_VNx16BImode
                  && 
#line 1141 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 5730; /* aarch64_copy_ffr_to_ffrt */
              break;

            case 86:
              operands[0] = x3;
              if (register_operand (operands[0], E_VNx16BImode)
                  && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 5731; /* aarch64_rdffr */
              break;

            default:
              break;
            }
        }
      operands[1] = x2;
      operands[0] = x3;
      res = recog_478 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && GET_CODE (x3) == REG
          && REGNO (x3) == 90
          && GET_MODE (x3) == E_DImode)
        return 12999; /* aarch64_clear_tpidr2 */
      break;

    case TRUNCATE:
      res = recog_480 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!subreg_lowpart_operator (x2, E_DImode))
    return -1;
  switch (pattern29 (x1))
    {
    case 0:
      if (!
#line 6461 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(8 <= 8
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 844; /* *aarch64_bfidiqi_subreg_8 */

    case 1:
      if (!
#line 6461 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(8 <= 16
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 845; /* *aarch64_bfidihi_subreg_8 */

    case 2:
      if (!
#line 6461 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(8 <= 32
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 847; /* *aarch64_bfidisi_subreg_8 */

    case 3:
      if (!
#line 6461 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
        return -1;
      return 846; /* *aarch64_bfidihi_subreg_16 */

    case 4:
      if (!
#line 6461 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
        return -1;
      return 848; /* *aarch64_bfidisi_subreg_16 */

    case 5:
      if (!
#line 6461 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(32 <= 32
   && multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 64))
        return -1;
      return 849; /* *aarch64_bfidisi_subreg_32 */

    default:
      return -1;
    }
}

 int
recog_515 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_483 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          switch (GET_CODE (operands[0]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (register_operand (operands[0], E_V8QImode)
                      && GET_MODE (x3) == E_V8QImode
                      && register_operand (operands[1], E_QImode)
                      && 
#line 97 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1245; /* aarch64_simd_dupv8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[0], E_V16QImode)
                      && GET_MODE (x3) == E_V16QImode
                      && register_operand (operands[1], E_QImode)
                      && 
#line 97 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1246; /* aarch64_simd_dupv16qi */
                  break;

                case E_V4HImode:
                  if (register_operand (operands[0], E_V4HImode)
                      && GET_MODE (x3) == E_V4HImode
                      && register_operand (operands[1], E_HImode)
                      && 
#line 97 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1247; /* aarch64_simd_dupv4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[0], E_V8HImode)
                      && GET_MODE (x3) == E_V8HImode
                      && register_operand (operands[1], E_HImode)
                      && 
#line 97 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1248; /* aarch64_simd_dupv8hi */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[0], E_V2SImode)
                      && GET_MODE (x3) == E_V2SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 97 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1249; /* aarch64_simd_dupv2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[0], E_V4SImode)
                      && GET_MODE (x3) == E_V4SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 97 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1250; /* aarch64_simd_dupv4si */
                  break;

                case E_V2DImode:
                  if (register_operand (operands[0], E_V2DImode)
                      && GET_MODE (x3) == E_V2DImode
                      && register_operand (operands[1], E_DImode)
                      && 
#line 97 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1251; /* aarch64_simd_dupv2di */
                  break;

                case E_V4HFmode:
                  if (register_operand (operands[0], E_V4HFmode)
                      && GET_MODE (x3) == E_V4HFmode
                      && register_operand (operands[1], E_HFmode)
                      && 
#line 108 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1252; /* aarch64_simd_dupv4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[0], E_V8HFmode)
                      && GET_MODE (x3) == E_V8HFmode
                      && register_operand (operands[1], E_HFmode)
                      && 
#line 108 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1253; /* aarch64_simd_dupv8hf */
                  break;

                case E_V2SFmode:
                  if (register_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x3) == E_V2SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 108 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1254; /* aarch64_simd_dupv2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[0], E_V4SFmode)
                      && GET_MODE (x3) == E_V4SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 108 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1255; /* aarch64_simd_dupv4sf */
                  break;

                case E_V2DFmode:
                  if (register_operand (operands[0], E_V2DFmode)
                      && GET_MODE (x3) == E_V2DFmode
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 108 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1256; /* aarch64_simd_dupv2df */
                  break;

                case E_V4BFmode:
                  if (register_operand (operands[0], E_V4BFmode)
                      && GET_MODE (x3) == E_V4BFmode
                      && register_operand (operands[1], E_BFmode)
                      && 
#line 108 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1257; /* aarch64_simd_dupv4bf */
                  break;

                case E_V8BFmode:
                  if (register_operand (operands[0], E_V8BFmode)
                      && GET_MODE (x3) == E_V8BFmode
                      && register_operand (operands[1], E_BFmode)
                      && 
#line 108 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1258; /* aarch64_simd_dupv8bf */
                  break;

                default:
                  break;
                }
              break;

            case MEM:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2SImode)
                      && GET_MODE (x3) == E_V2SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1311; /* aarch64_simd_stpv2si */
                  break;

                case E_V2SFmode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x3) == E_V2SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1312; /* aarch64_simd_stpv2sf */
                  break;

                case E_V2DImode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2DImode)
                      && GET_MODE (x3) == E_V2DImode
                      && register_operand (operands[1], E_DImode)
                      && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1313; /* aarch64_simd_stpv2di */
                  break;

                case E_V2DFmode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2DFmode)
                      && GET_MODE (x3) == E_V2DFmode
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 237 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1314; /* aarch64_simd_stpv2df */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (register_operand (operands[0], E_V8QImode)
                  && GET_MODE (x3) == E_V8QImode
                  && aarch64_simd_struct_operand (operands[1], E_QImode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5124; /* *aarch64_simd_ld1rv8qi */
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x3) == E_V16QImode
                  && aarch64_simd_struct_operand (operands[1], E_QImode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5125; /* *aarch64_simd_ld1rv16qi */
              break;

            case E_V4HImode:
              if (register_operand (operands[0], E_V4HImode)
                  && GET_MODE (x3) == E_V4HImode
                  && aarch64_simd_struct_operand (operands[1], E_HImode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5126; /* *aarch64_simd_ld1rv4hi */
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x3) == E_V8HImode
                  && aarch64_simd_struct_operand (operands[1], E_HImode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5127; /* *aarch64_simd_ld1rv8hi */
              break;

            case E_V2SImode:
              if (register_operand (operands[0], E_V2SImode)
                  && GET_MODE (x3) == E_V2SImode
                  && aarch64_simd_struct_operand (operands[1], E_SImode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5128; /* *aarch64_simd_ld1rv2si */
              break;

            case E_V4SImode:
              if (register_operand (operands[0], E_V4SImode)
                  && GET_MODE (x3) == E_V4SImode
                  && aarch64_simd_struct_operand (operands[1], E_SImode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5129; /* *aarch64_simd_ld1rv4si */
              break;

            case E_V2DImode:
              if (register_operand (operands[0], E_V2DImode)
                  && GET_MODE (x3) == E_V2DImode
                  && aarch64_simd_struct_operand (operands[1], E_DImode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5130; /* *aarch64_simd_ld1rv2di */
              break;

            case E_V4HFmode:
              if (register_operand (operands[0], E_V4HFmode)
                  && GET_MODE (x3) == E_V4HFmode
                  && aarch64_simd_struct_operand (operands[1], E_HFmode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5131; /* *aarch64_simd_ld1rv4hf */
              break;

            case E_V8HFmode:
              if (register_operand (operands[0], E_V8HFmode)
                  && GET_MODE (x3) == E_V8HFmode
                  && aarch64_simd_struct_operand (operands[1], E_HFmode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5132; /* *aarch64_simd_ld1rv8hf */
              break;

            case E_V4BFmode:
              if (register_operand (operands[0], E_V4BFmode)
                  && GET_MODE (x3) == E_V4BFmode
                  && aarch64_simd_struct_operand (operands[1], E_BFmode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5133; /* *aarch64_simd_ld1rv4bf */
              break;

            case E_V8BFmode:
              if (register_operand (operands[0], E_V8BFmode)
                  && GET_MODE (x3) == E_V8BFmode
                  && aarch64_simd_struct_operand (operands[1], E_BFmode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5134; /* *aarch64_simd_ld1rv8bf */
              break;

            case E_V2SFmode:
              if (register_operand (operands[0], E_V2SFmode)
                  && GET_MODE (x3) == E_V2SFmode
                  && aarch64_simd_struct_operand (operands[1], E_SFmode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5135; /* *aarch64_simd_ld1rv2sf */
              break;

            case E_V4SFmode:
              if (register_operand (operands[0], E_V4SFmode)
                  && GET_MODE (x3) == E_V4SFmode
                  && aarch64_simd_struct_operand (operands[1], E_SFmode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5136; /* *aarch64_simd_ld1rv4sf */
              break;

            case E_V2DFmode:
              if (register_operand (operands[0], E_V2DFmode)
                  && GET_MODE (x3) == E_V2DFmode
                  && aarch64_simd_struct_operand (operands[1], E_DFmode)
                  && 
#line 8817 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5137; /* *aarch64_simd_ld1rv2df */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      return recog_482 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      return recog_468 (x1, insn, pnum_clobbers);

    case MINUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern814 (x3, 
E_SImode) != 0)
                return -1;
              return 331; /* *subsi3_carryin */

            case E_DImode:
              if (pattern814 (x3, 
E_DImode) != 0)
                return -1;
              return 332; /* *subdi3_carryin */

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[3] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern815 (x3, 
E_SImode) != 0)
                return -1;
              return 334; /* *subsi3_carryin_alt */

            case E_DImode:
              if (pattern815 (x3, 
E_DImode) != 0)
                return -1;
              return 335; /* *subdi3_carryin_alt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern649 (x3, 
E_SImode) != 0)
            return -1;
          return 355; /* *ngcsi */

        case E_DImode:
          if (pattern649 (x3, 
E_DImode) != 0)
            return -1;
          return 356; /* *ngcdi */

        default:
          return -1;
        }

    case UMAX:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[2]))
        {
        case CONST_POLY_INT:
          x7 = XEXP (x3, 1);
          if (!rtx_equal_p (x7, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern816 (x3, 
E_SImode) != 0
                  || !
#line 4986 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_SVE))
                return -1;
              return 492; /* aarch64_uqdecsi */

            case E_DImode:
              if (pattern816 (x3, 
E_DImode) != 0
                  || !
#line 4986 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_SVE))
                return -1;
              return 493; /* aarch64_uqdecdi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != UMIN)
            return -1;
          switch (pattern651 (x3))
            {
            case 0:
              if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1644; /* aarch64_uabdv8qi */

            case 1:
              if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1648; /* aarch64_uabdv16qi */

            case 2:
              if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1652; /* aarch64_uabdv4hi */

            case 3:
              if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1656; /* aarch64_uabdv8hi */

            case 4:
              if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1660; /* aarch64_uabdv2si */

            case 5:
              if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1664; /* aarch64_uabdv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT
          || XWINT (x6, 0) != 72057594037927935L)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != AND
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != CONST_INT
          || XWINT (x8, 0) != 72057594037927935L
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 8426 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
        return -1;
      return 1229; /* subp */

    case SMAX:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != SMIN)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (pattern651 (x3))
        {
        case 0:
          if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1641; /* aarch64_sabdv8qi */

        case 1:
          if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1647; /* aarch64_sabdv16qi */

        case 2:
          if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1649; /* aarch64_sabdv4hi */

        case 3:
          if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1655; /* aarch64_sabdv8hi */

        case 4:
          if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1657; /* aarch64_sabdv2si */

        case 5:
          if (!
#line 822 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1663; /* aarch64_sabdv4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern297 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
              && 
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3011; /* aarch64_ssublv16qi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
              || !
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3023; /* aarch64_ssublv16qi_lo_internal */

        case 1:
          if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
              && 
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3015; /* aarch64_ssublv8hi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
              || !
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3027; /* aarch64_ssublv8hi_lo_internal */

        case 2:
          if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
              && 
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3019; /* aarch64_ssublv4si_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
              || !
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3031; /* aarch64_ssublv4si_lo_internal */

        case 3:
          if (!
#line 4601 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3035; /* aarch64_ssublv8qi */

        case 4:
          if (!
#line 4601 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3039; /* aarch64_ssublv4hi */

        case 5:
          if (!
#line 4601 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3043; /* aarch64_ssublv2si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern297 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
              && 
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3013; /* aarch64_usublv16qi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
              || !
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3025; /* aarch64_usublv16qi_lo_internal */

        case 1:
          if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
              && 
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3017; /* aarch64_usublv8hi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
              || !
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3029; /* aarch64_usublv8hi_lo_internal */

        case 2:
          if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
              && 
#line 4481 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3021; /* aarch64_usublv4si_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
              || !
#line 4494 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3033; /* aarch64_usublv4si_lo_internal */

        case 3:
          if (!
#line 4601 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3037; /* aarch64_usublv8qi */

        case 4:
          if (!
#line 4601 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3041; /* aarch64_usublv4hi */

        case 5:
          if (!
#line 4601 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3045; /* aarch64_usublv2si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 125)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 2
          || XINT (x7, 1) != 125)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      operands[1] = x10;
      x11 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      switch (GET_CODE (x12))
        {
        case SMAX:
          switch (pattern1009 (x3, 
SMIN))
            {
            case 0:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8018; /* aarch64_pred_sabdvnx16qi */

            case 1:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8020; /* aarch64_pred_sabdvnx8qi */

            case 2:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8022; /* aarch64_pred_sabdvnx4qi */

            case 3:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8024; /* aarch64_pred_sabdvnx2qi */

            case 4:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8026; /* aarch64_pred_sabdvnx8hi */

            case 5:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8028; /* aarch64_pred_sabdvnx4hi */

            case 6:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8030; /* aarch64_pred_sabdvnx2hi */

            case 7:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8032; /* aarch64_pred_sabdvnx4si */

            case 8:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8034; /* aarch64_pred_sabdvnx2si */

            case 9:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8036; /* aarch64_pred_sabdvnx2di */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern1009 (x3, 
UMIN))
            {
            case 0:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8019; /* aarch64_pred_uabdvnx16qi */

            case 1:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8021; /* aarch64_pred_uabdvnx8qi */

            case 2:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8023; /* aarch64_pred_uabdvnx4qi */

            case 3:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8025; /* aarch64_pred_uabdvnx2qi */

            case 4:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8027; /* aarch64_pred_uabdvnx8hi */

            case 5:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8029; /* aarch64_pred_uabdvnx4hi */

            case 6:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8031; /* aarch64_pred_uabdvnx2hi */

            case 7:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8033; /* aarch64_pred_uabdvnx4si */

            case 8:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8035; /* aarch64_pred_uabdvnx2si */

            case 9:
              if (!
#line 4300 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8037; /* aarch64_pred_uabdvnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_530 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (XVECLEN (x3, 0) == 1)
    {
      res = recog_484 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V16QImode)
          && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1315; /* aarch64_simd_mov_from_v16qilow */
      if (!vect_par_cnst_hi_half (operands[2], E_V16QImode)
          || !
#line 314 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1321; /* aarch64_simd_mov_from_v16qihigh */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V8HImode)
          && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1316; /* aarch64_simd_mov_from_v8hilow */
      if (!vect_par_cnst_hi_half (operands[2], E_V8HImode)
          || !
#line 314 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1322; /* aarch64_simd_mov_from_v8hihigh */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V4SImode)
          && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1317; /* aarch64_simd_mov_from_v4silow */
      if (!vect_par_cnst_hi_half (operands[2], E_V4SImode)
          || !
#line 314 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1323; /* aarch64_simd_mov_from_v4sihigh */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V8HFmode)
          && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1318; /* aarch64_simd_mov_from_v8hflow */
      if (!vect_par_cnst_hi_half (operands[2], E_V8HFmode)
          || !
#line 314 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1324; /* aarch64_simd_mov_from_v8hfhigh */

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x2) != E_V4BFmode
          || !register_operand (operands[1], E_V8BFmode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V8BFmode)
          && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1319; /* aarch64_simd_mov_from_v8bflow */
      if (!vect_par_cnst_hi_half (operands[2], E_V8BFmode)
          || !
#line 314 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1325; /* aarch64_simd_mov_from_v8bfhigh */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      if (vect_par_cnst_lo_half (operands[2], E_V4SFmode)
          && 
#line 295 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return 1320; /* aarch64_simd_mov_from_v4sflow */
      if (!vect_par_cnst_hi_half (operands[2], E_V4SFmode)
          || !
#line 314 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
        return -1;
      return 1326; /* aarch64_simd_mov_from_v4sfhigh */

    case E_V16QImode:
      if (pattern666 (x2, 
E_VNx16QImode, 
E_V16QImode) != 0
          || !
#line 11152 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V16QImode) - 1)))
        return -1;
      return 11130; /* aarch64_sve_get_neonq_vnx16qi */

    case E_V8HImode:
      if (pattern666 (x2, 
E_VNx8HImode, 
E_V8HImode) != 0
          || !
#line 11152 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HImode) - 1)))
        return -1;
      return 11131; /* aarch64_sve_get_neonq_vnx8hi */

    case E_V4SImode:
      if (pattern666 (x2, 
E_VNx4SImode, 
E_V4SImode) != 0
          || !
#line 11152 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SImode) - 1)))
        return -1;
      return 11132; /* aarch64_sve_get_neonq_vnx4si */

    case E_V2DImode:
      if (pattern666 (x2, 
E_VNx2DImode, 
E_V2DImode) != 0
          || !
#line 11152 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DImode) - 1)))
        return -1;
      return 11133; /* aarch64_sve_get_neonq_vnx2di */

    case E_V8BFmode:
      if (pattern666 (x2, 
E_VNx8BFmode, 
E_V8BFmode) != 0
          || !
#line 11152 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8BFmode) - 1)))
        return -1;
      return 11134; /* aarch64_sve_get_neonq_vnx8bf */

    case E_V8HFmode:
      if (pattern666 (x2, 
E_VNx8HFmode, 
E_V8HFmode) != 0
          || !
#line 11152 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HFmode) - 1)))
        return -1;
      return 11135; /* aarch64_sve_get_neonq_vnx8hf */

    case E_V4SFmode:
      if (pattern666 (x2, 
E_VNx4SFmode, 
E_V4SFmode) != 0
          || !
#line 11152 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SFmode) - 1)))
        return -1;
      return 11136; /* aarch64_sve_get_neonq_vnx4sf */

    case E_V2DFmode:
      if (pattern666 (x2, 
E_VNx2DFmode, 
E_V2DFmode) != 0
          || !
#line 11152 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DFmode) - 1)))
        return -1;
      return 11137; /* aarch64_sve_get_neonq_vnx2df */

    default:
      return -1;
    }
}

 int
recog_535 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern36 (x3))
    {
    case 0:
      if (!
#line 7384 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
        return -1;
      return 1084; /* *aarch64_umaxsi3_cssc */

    case 1:
      if (!
#line 7384 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
        return -1;
      return 1088; /* *aarch64_umaxdi3_cssc */

    case 2:
      if (!
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2078; /* umaxv8qi3 */

    case 3:
      if (!
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2086; /* umaxv16qi3 */

    case 4:
      if (!
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2094; /* umaxv4hi3 */

    case 5:
      if (!
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2102; /* umaxv8hi3 */

    case 6:
      if (!
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2110; /* umaxv2si3 */

    case 7:
      if (!
#line 1754 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2118; /* umaxv4si3 */

    case 8:
      if (!
#line 735 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11458; /* *umaxvnx32qi3 */

    case 9:
      if (!
#line 735 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11462; /* *umaxvnx16hi3 */

    case 10:
      if (!
#line 735 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11466; /* *umaxvnx8si3 */

    case 11:
      if (!
#line 735 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11470; /* *umaxvnx4di3 */

    case 12:
      if (!
#line 735 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11474; /* *umaxvnx64qi3 */

    case 13:
      if (!
#line 735 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11478; /* *umaxvnx32hi3 */

    case 14:
      if (!
#line 735 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11482; /* *umaxvnx16si3 */

    case 15:
      if (!
#line 735 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11486; /* *umaxvnx8di3 */

    case 16:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7422; /* *post_ra_umaxvnx16qi3 */

    case 17:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7427; /* *post_ra_umaxvnx8qi3 */

    case 18:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7432; /* *post_ra_umaxvnx4qi3 */

    case 19:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7437; /* *post_ra_umaxvnx2qi3 */

    case 20:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7442; /* *post_ra_umaxvnx8hi3 */

    case 21:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7447; /* *post_ra_umaxvnx4hi3 */

    case 22:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7452; /* *post_ra_umaxvnx2hi3 */

    case 23:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7457; /* *post_ra_umaxvnx4si3 */

    case 24:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7462; /* *post_ra_umaxvnx2si3 */

    case 25:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7467; /* *post_ra_umaxvnx2di3 */

    case 26:
      if (!
#line 3975 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 7472; /* *post_ra_umaxv2di3 */

    case 27:
      if (!
#line 745 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11491; /* aarch64_sve_single_umaxvnx32qi */

    case 28:
      if (!
#line 745 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11496; /* aarch64_sve_single_umaxvnx16hi */

    case 29:
      if (!
#line 745 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11501; /* aarch64_sve_single_umaxvnx8si */

    case 30:
      if (!
#line 745 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11506; /* aarch64_sve_single_umaxvnx4di */

    case 31:
      if (!
#line 745 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11511; /* aarch64_sve_single_umaxvnx64qi */

    case 32:
      if (!
#line 745 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11516; /* aarch64_sve_single_umaxvnx32hi */

    case 33:
      if (!
#line 745 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11521; /* aarch64_sve_single_umaxvnx16si */

    case 34:
      if (!
#line 745 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11526; /* aarch64_sve_single_umaxvnx8di */

    default:
      return -1;
    }
}

 int
recog_549 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10160; /* while_wrsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10170; /* while_wrdivnx8bi_ptest */
}

 int
recog_553 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10080; /* *while_wrsivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10090; /* *while_wrdivnx8bi_cc */
}

 int
recog_557 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10159; /* while_rwsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10169; /* while_rwdivnx8bi_ptest */
}

 int
recog_565 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10158; /* while_ugesivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10168; /* while_ugedivnx8bi_ptest */
}

 int
recog_574 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10137; /* while_ugtsivnx16bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10147; /* while_ugtdivnx16bi_ptest */
}

 int
recog_584 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10096; /* *while_gtsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10106; /* *while_gtdivnx4bi_cc */
}

 int
recog_594 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10055; /* *while_gesivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10065; /* *while_gedivnx16bi_cc */
}

 int
recog_604 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern689 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9977; /* while_ugtsivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9987; /* while_ugtdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9997; /* while_ugtsivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10007; /* while_ugtdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10017; /* while_ugtsivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10027; /* while_ugtdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10037; /* while_ugtsivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10047; /* while_ugtdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_609 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 1);
          switch (GET_CODE (x10))
            {
            case PLUS:
              switch (pattern1253 (x1))
                {
                case 0:
                  return 125; /* addsi3_compare0 */

                case 1:
                  return 126; /* adddi3_compare0 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1191 (x1, 
PLUS) != 0
                  || !aarch64_plus_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_DImode))
                return -1;
              x11 = XEXP (x10, 0);
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              x13 = XEXP (x11, 1);
              if (!rtx_equal_p (x13, operands[2]))
                return -1;
              return 127; /* *addsi3_compare0_uxtw */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Cmode
              || GET_MODE (x3) != E_CC_Cmode)
            return -1;
          switch (pattern1253 (x1))
            {
            case 0:
              return 130; /* addsi3_compareC */

            case 1:
              return 131; /* adddi3_compareC */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x14 = XEXP (x5, 0);
      operands[1] = x14;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          operands[2] = x6;
          if (pattern1100 (x2) != 0)
            return -1;
          switch (pattern1270 (x1))
            {
            case 0:
              if (pattern1339 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 136; /* addsi3_compareV_imm */

            case 1:
              if (pattern1339 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 137; /* adddi3_compareV_imm */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern1100 (x2) != 0)
            return -1;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          switch (pattern1270 (x1))
            {
            case 0:
              if (pattern1340 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 138; /* addsi3_compareV */

            case 1:
              if (pattern1340 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 139; /* adddi3_compareV */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          switch (pattern1255 (x1))
            {
            case 0:
              return 152; /* *adds_extendqi_si */

            case 1:
              return 156; /* *adds_extendhi_si */

            case 2:
              return 160; /* *adds_extendsi_si */

            case 3:
              return 154; /* *adds_extendqi_di */

            case 4:
              return 158; /* *adds_extendhi_di */

            case 5:
              return 162; /* *adds_extendsi_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern920 (x1, 
ASHIFT) != 0)
        return -1;
      x16 = XEXP (x5, 1);
      operands[2] = x16;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x13 = XEXP (x11, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      x17 = XEXP (x10, 1);
      if (!rtx_equal_p (x17, operands[3]))
        return -1;
      x14 = XEXP (x5, 0);
      switch (GET_CODE (x14))
        {
        case REG:
        case SUBREG:
          operands[1] = x14;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (pattern922 (x1))
            {
            case 0:
              return 140; /* *adds_shift_imm_si */

            case 1:
              return 143; /* *adds_shift_imm_di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern1302 (x1, 
SIGN_EXTEND))
            {
            case 0:
              return 176; /* *adds_extendqi_shift_si */

            case 1:
              return 180; /* *adds_extendhi_shift_si */

            case 2:
              return 184; /* *adds_extendsi_shift_si */

            case 3:
              return 178; /* *adds_extendqi_shift_di */

            case 4:
              return 182; /* *adds_extendhi_shift_di */

            case 5:
              return 186; /* *adds_extendsi_shift_di */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1302 (x1, 
ZERO_EXTEND))
            {
            case 0:
              return 177; /* *adds_zero_extendqi_shift_si */

            case 1:
              return 181; /* *adds_zero_extendhi_shift_si */

            case 2:
              return 185; /* *adds_zero_extendsi_shift_si */

            case 3:
              return 179; /* *adds_zero_extendqi_shift_di */

            case 4:
              return 183; /* *adds_zero_extendhi_shift_di */

            case 5:
              return 187; /* *adds_zero_extendsi_shift_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern924 (x1, 
ASHIFTRT))
        {
        case 0:
          return 141; /* *adds_shift_imm_si */

        case 1:
          return 144; /* *adds_shift_imm_di */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern924 (x1, 
LSHIFTRT))
        {
        case 0:
          return 142; /* *adds_shift_imm_si */

        case 1:
          return 145; /* *adds_shift_imm_di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern920 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      x14 = XEXP (x5, 0);
      operands[1] = x14;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (pattern1255 (x1))
        {
        case 0:
          return 153; /* *adds_zero_extendqi_si */

        case 1:
          return 157; /* *adds_zero_extendhi_si */

        case 2:
          return 161; /* *adds_zero_extendsi_si */

        case 3:
          return 155; /* *adds_zero_extendqi_di */

        case 4:
          return 159; /* *adds_zero_extendhi_di */

        case 5:
          return 163; /* *adds_zero_extendsi_di */

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x5;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_ADCmode
              || GET_MODE (x3) != E_CC_ADCmode)
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x7 = XEXP (x3, 1);
          operands[4] = x7;
          if (!const_scalar_int_operand (operands[4], E_VOIDmode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1314 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 3153 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[4], DImode)
   == (wi::shwi (1, DImode) << (unsigned) GET_MODE_BITSIZE (SImode))))
                return -1;
              return 254; /* *addsi3_carryinC_zero */

            case E_TImode:
              if (pattern1314 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 3153 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[4], TImode)
   == (wi::shwi (1, TImode) << (unsigned) GET_MODE_BITSIZE (DImode))))
                return -1;
              return 255; /* *adddi3_carryinC_zero */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Vmode
              || GET_MODE (x3) != E_CC_Vmode)
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x19 = XEXP (x18, 0);
          operands[3] = x19;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1341 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 258; /* *addsi3_carryinV_zero */

            case E_TImode:
              if (pattern1341 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 259; /* *adddi3_carryinV_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != PLUS)
        return -1;
      x14 = XEXP (x5, 0);
      operands[3] = x14;
      x16 = XEXP (x5, 1);
      switch (GET_CODE (x16))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_ADCmode
              || GET_MODE (x3) != E_CC_ADCmode)
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x7 = XEXP (x3, 1);
          operands[5] = x7;
          if (!const_scalar_int_operand (operands[5], E_VOIDmode))
            return -1;
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1349 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 3173 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[5], DImode)
   == (wi::shwi (1, DImode) << (unsigned) GET_MODE_BITSIZE (SImode))))
                return -1;
              return 256; /* *addsi3_carryinC */

            case E_TImode:
              if (pattern1349 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 3173 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[5], TImode)
   == (wi::shwi (1, TImode) << (unsigned) GET_MODE_BITSIZE (DImode))))
                return -1;
              return 257; /* *adddi3_carryinC */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SIGN_EXTEND)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS)
            return -1;
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Vmode
              || GET_MODE (x3) != E_CC_Vmode)
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x22 = XEXP (x19, 0);
          operands[4] = x22;
          x23 = XEXP (x19, 1);
          if (!rtx_equal_p (x23, operands[1]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[2]))
            return -1;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[4]))
            return -1;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1367 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 260; /* *addsi3_carryinV */

            case E_TImode:
              if (pattern1367 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 261; /* *adddi3_carryinV */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_616 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x4, 1))
        {
        case 17:
          if (pattern781 (x1) != 0
              || !
#line 8323 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1220; /* tstart */

        case 157:
          if (pattern781 (x1) != 0
              || !
#line 8332 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1221; /* ttest */

        case 20:
          if (pattern782 (x1, 
20) != 0
              || !
#line 8359 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_RNG))
            return -1;
          return 1224; /* aarch64_rndr */

        case 21:
          if (pattern782 (x1, 
21) != 0
              || !
#line 8369 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_RNG))
            return -1;
          return 1225; /* aarch64_rndrrs */

        case 66:
          if (pattern783 (x1, 
65) != 0
              || !
#line 8490 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1234; /* st64bv */

        case 68:
          if (pattern783 (x1, 
67) != 0
              || !
#line 8502 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1235; /* st64bv0 */

        case 23:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE
              || XINT (x7, 1) != 23
              || !register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (XVECLEN (x7, 0))
            {
            case 2:
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_QImode)
                      || GET_MODE (x7) != E_QImode
                      || !aarch64_reg_or_zero (operands[2], E_QImode))
                    return -1;
                  return 5528; /* aarch64_store_exclusiveqi */

                case E_HImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_HImode)
                      || GET_MODE (x7) != E_HImode
                      || !aarch64_reg_or_zero (operands[2], E_HImode))
                    return -1;
                  return 5529; /* aarch64_store_exclusivehi */

                case E_SImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_SImode)
                      || GET_MODE (x7) != E_SImode
                      || !aarch64_reg_or_zero (operands[2], E_SImode))
                    return -1;
                  return 5530; /* aarch64_store_exclusivesi */

                case E_DImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_DImode)
                      || GET_MODE (x7) != E_DImode
                      || !aarch64_reg_or_zero (operands[2], E_DImode))
                    return -1;
                  return 5531; /* aarch64_store_exclusivedi */

                default:
                  return -1;
                }

            case 3:
              if (GET_MODE (x7) != E_TImode
                  || !aarch64_sync_memory_operand (operands[1], E_TImode))
                return -1;
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              if (!aarch64_reg_or_zero (operands[2], E_DImode))
                return -1;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!aarch64_reg_or_zero (operands[3], E_DImode))
                return -1;
              x11 = XVECEXP (x7, 0, 2);
              operands[4] = x11;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              return 5532; /* aarch64_store_exclusive_pair */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      operands[1] = x12;
      x13 = XVECEXP (x4, 0, 2);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      x5 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      switch (XINT (x4, 1))
        {
        case 32:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1157 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5403; /* aarch64_atomic_iorqi_lse */

            case E_HImode:
              if (pattern1157 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5407; /* aarch64_atomic_iorhi_lse */

            case E_SImode:
              if (pattern1157 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5411; /* aarch64_atomic_iorsi_lse */

            case E_DImode:
              if (pattern1157 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5415; /* aarch64_atomic_iordi_lse */

            default:
              return -1;
            }

        case 33:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1157 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5404; /* aarch64_atomic_bicqi_lse */

            case E_HImode:
              if (pattern1157 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5408; /* aarch64_atomic_bichi_lse */

            case E_SImode:
              if (pattern1157 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5412; /* aarch64_atomic_bicsi_lse */

            case E_DImode:
              if (pattern1157 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5416; /* aarch64_atomic_bicdi_lse */

            default:
              return -1;
            }

        case 34:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1157 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5405; /* aarch64_atomic_xorqi_lse */

            case E_HImode:
              if (pattern1157 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5409; /* aarch64_atomic_xorhi_lse */

            case E_SImode:
              if (pattern1157 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5413; /* aarch64_atomic_xorsi_lse */

            case E_DImode:
              if (pattern1157 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5417; /* aarch64_atomic_xordi_lse */

            default:
              return -1;
            }

        case 35:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1157 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5406; /* aarch64_atomic_addqi_lse */

            case E_HImode:
              if (pattern1157 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5410; /* aarch64_atomic_addhi_lse */

            case E_SImode:
              if (pattern1157 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5414; /* aarch64_atomic_addsi_lse */

            case E_DImode:
              if (pattern1157 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc-15.0.1-20250313/gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5418; /* aarch64_atomic_adddi_lse */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 22
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern784 (x6, 
E_DImode, 
22, 
2, 
UNSPEC_VOLATILE) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      if (!aarch64_sync_memory_operand (operands[2], E_TImode))
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 1);
      x9 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x10, operands[3]))
        return -1;
      return 5527; /* aarch64_load_exclusive_pair */

    default:
      return -1;
    }
}

 int
recog_623 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC_VOLATILE:
      return recog_514 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (aarch64_comparison_operator (x3, E_VOIDmode))
            {
              res = recog_1 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) == CONST_INT)
            {
              res = recog_2 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x3;
          if (!aarch64_comparison_operation (operands[1], E_VOIDmode))
            return -1;
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case PLUS:
              x7 = XEXP (x6, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return -1;
              switch (pattern585 (x2))
                {
                case 0:
                  return 475; /* csinc3si_insn */

                case 1:
                  return 476; /* csinc3di_insn */

                default:
                  return -1;
                }

            case NOT:
              switch (pattern585 (x2))
                {
                case 0:
                  return 477; /* *csinv3si_insn */

                case 1:
                  return 478; /* *csinv3di_insn */

                default:
                  return -1;
                }

            case NEG:
              switch (pattern585 (x2))
                {
                case 0:
                  return 481; /* csneg3si_insn */

                case 1:
                  return 482; /* csneg3di_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (GET_MODE (x6) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode)
                return -1;
              x8 = XEXP (x6, 0);
              switch (GET_CODE (x8))
                {
                case REG:
                case SUBREG:
                  operands[2] = x8;
                  if (!register_operand (operands[2], E_SImode))
                    return -1;
                  x9 = XEXP (x2, 2);
                  if (GET_CODE (x9) != ZERO_EXTEND
                      || GET_MODE (x9) != E_DImode)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_MODE (x10) != E_SImode)
                    return -1;
                  switch (GET_CODE (x10))
                    {
                    case NEG:
                      x11 = XEXP (x10, 0);
                      operands[3] = x11;
                      if (!register_operand (operands[3], E_SImode))
                        return -1;
                      return 483; /* *csinv3_uxtw_insn1 */

                    case NOT:
                      x11 = XEXP (x10, 0);
                      operands[3] = x11;
                      if (!register_operand (operands[3], E_SImode))
                        return -1;
                      return 484; /* *csinv3_uxtw_insn1 */

                    default:
                      return -1;
                    }

                case NEG:
                  switch (pattern939 (x2))
                    {
                    case 0:
                      return 485; /* *csinv3_uxtw_insn2 */

                    case 1:
                      return 487; /* *csinv3_uxtw_insn3 */

                    default:
                      return -1;
                    }

                case NOT:
                  switch (pattern939 (x2))
                    {
                    case 0:
                      return 486; /* *csinv3_uxtw_insn2 */

                    case 1:
                      return 488; /* *csinv3_uxtw_insn3 */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      return recog_512 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_511 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_522 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_507 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_510 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_518 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_521 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_529 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_534 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_509 (x1, insn, pnum_clobbers);

    case DIV:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x2, 
E_SImode) != 0)
            return -1;
          return 399; /* divsi3 */

        case E_DImode:
          if (pattern31 (x2, 
E_DImode) != 0)
            return -1;
          return 401; /* divdi3 */

        case E_HFmode:
          if (pattern31 (x2, 
E_HFmode) != 0
              || !(
#line 7321 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return -1;
          return 1070; /* *divhf3 */

        case E_SFmode:
          if (pattern31 (x2, 
E_SFmode) != 0
              || !
#line 7321 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1071; /* *divsf3 */

        case E_DFmode:
          if (pattern31 (x2, 
E_DFmode) != 0
              || !
#line 7321 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1072; /* *divdf3 */

        case E_V4HFmode:
          if (pattern31 (x2, 
E_V4HFmode) != 0
              || !(
#line 2674 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2387; /* *divv4hf3 */

        case E_V8HFmode:
          if (pattern31 (x2, 
E_V8HFmode) != 0
              || !(
#line 2674 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2390; /* *divv8hf3 */

        case E_V2SFmode:
          if (pattern31 (x2, 
E_V2SFmode) != 0
              || !
#line 2674 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2391; /* *divv2sf3 */

        case E_V4SFmode:
          if (pattern31 (x2, 
E_V4SFmode) != 0
              || !
#line 2674 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2394; /* *divv4sf3 */

        case E_V2DFmode:
          if (pattern31 (x2, 
E_V2DFmode) != 0
              || !
#line 2674 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2395; /* *divv2df3 */

        default:
          return -1;
        }

    case UDIV:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern31 (x2, 
E_SImode) != 0)
            return -1;
          return 400; /* udivsi3 */

        case E_DImode:
          if (pattern31 (x2, 
E_DImode) != 0)
            return -1;
          return 402; /* udivdi3 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      x6 = XEXP (x2, 1);
      if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          x3 = XEXP (x2, 0);
          operands[2] = x3;
          if (cc_register (operands[2], E_VOIDmode))
            {
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (register_operand (operands[0], E_QImode)
                      && aarch64_comparison_operator_mode (operands[1], E_QImode))
                    return 441; /* aarch64_cstoreqi */
                  break;

                case E_HImode:
                  if (register_operand (operands[0], E_HImode)
                      && aarch64_comparison_operator_mode (operands[1], E_HImode))
                    return 442; /* aarch64_cstorehi */
                  break;

                case E_SImode:
                  if (register_operand (operands[0], E_SImode)
                      && aarch64_comparison_operator_mode (operands[1], E_SImode))
                    return 443; /* aarch64_cstoresi */
                  break;

                case E_DImode:
                  if (register_operand (operands[0], E_DImode)
                      && aarch64_comparison_operator_mode (operands[1], E_DImode))
                    return 444; /* aarch64_cstoredi */
                  break;

                default:
                  break;
                }
            }
        }
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      operands[2] = x6;
      switch (GET_CODE (x2))
        {
        case EQ:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern754 (x2, 
E_SImode) != 0
                  || !
#line 4461 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 445; /* *compare_cstoresi_insn */

            case E_DImode:
              if (pattern754 (x2, 
E_DImode) != 0
                  || !
#line 4461 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 447; /* *compare_cstoredi_insn */

            default:
              return -1;
            }

        case NE:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern754 (x2, 
E_SImode) != 0
                  || !
#line 4461 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), SImode)
   && !aarch64_plus_operand (operands[2], SImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 446; /* *compare_cstoresi_insn */

            case E_DImode:
              if (pattern754 (x2, 
E_DImode) != 0
                  || !
#line 4461 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(!aarch64_move_imm (INTVAL (operands[2]), DImode)
   && !aarch64_plus_operand (operands[2], DImode)
   && !reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 448; /* *compare_cstoredi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case XOR:
      return recog_524 (x1, insn, pnum_clobbers);

    case AND:
      return recog_508 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_523 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern0 (x1))
        {
        case 0:
          return 688; /* clzsi2 */

        case 1:
          return 689; /* clzdi2 */

        case 2:
          if (!
#line 3557 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2830; /* clzv8qi2 */

        case 3:
          if (!
#line 3557 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2833; /* clzv16qi2 */

        case 4:
          if (!
#line 3557 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2834; /* clzv4hi2 */

        case 5:
          if (!
#line 3557 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2837; /* clzv8hi2 */

        case 6:
          if (!
#line 3557 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2838; /* clzv2si2 */

        case 7:
          if (!
#line 3557 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2841; /* clzv4si2 */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 5543 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 690; /* *aarch64_popcountsi2_cssc_insn */

        case 1:
          if (!
#line 5543 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 691; /* *aarch64_popcountdi2_cssc_insn */

        case 2:
          if (!
#line 3565 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2842; /* popcountv8qi2 */

        case 3:
          if (!
#line 3565 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2845; /* popcountv16qi2 */

        default:
          return -1;
        }

    case CLRSB:
      switch (pattern0 (x1))
        {
        case 0:
          return 692; /* clrsbsi2 */

        case 1:
          return 693; /* clrsbdi2 */

        case 2:
          if (!
#line 3549 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2818; /* clrsbv8qi2 */

        case 3:
          if (!
#line 3549 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2821; /* clrsbv16qi2 */

        case 4:
          if (!
#line 3549 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2822; /* clrsbv4hi2 */

        case 5:
          if (!
#line 3549 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2825; /* clrsbv8hi2 */

        case 6:
          if (!
#line 3549 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2826; /* clrsbv2si2 */

        case 7:
          if (!
#line 3549 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2829; /* clrsbv4si2 */

        default:
          return -1;
        }

    case BITREVERSE:
      switch (pattern1 (x1))
        {
        case 0:
          return 694; /* aarch64_rbitsi */

        case 1:
          return 695; /* aarch64_rbitdi */

        case 2:
          if (!
#line 380 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1396; /* aarch64_rbitv8qi */

        case 3:
          if (!
#line 380 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1399; /* aarch64_rbitv16qi */

        default:
          return -1;
        }

    case CTZ:
      switch (pattern3 (x1))
        {
        case 0:
          return 696; /* ctzsi2 */

        case 1:
          return 697; /* ctzdi2 */

        default:
          return -1;
        }

    case ASHIFT:
      return recog_533 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_538 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_539 (x1, insn, pnum_clobbers);

    case ROTATERT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      if (subreg_lowpart_operator (x6, E_VOIDmode))
        {
          operands[4] = x6;
          switch (pattern524 (x2))
            {
            case 0:
              if (
#line 5858 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0))
                return 721; /* *aarch64_rotr_reg_si3_mask1 */
              break;

            case 1:
              if (
#line 5858 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0))
                return 726; /* *aarch64_rotr_reg_di3_mask1 */
              break;

            case 2:
              if (
#line 5922 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 743; /* *aarch64_rotr_reg_di3_mask2 */
              break;

            case 3:
              if (
#line 5870 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)))
                return 731; /* *aarch64_rotr_reg_si3_neg_mask2 */
              break;

            case 4:
              if (
#line 5870 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 736; /* *aarch64_rotr_reg_di3_neg_mask2 */
              break;

            default:
              break;
            }
        }
      operands[2] = x6;
      switch (pattern416 (x2))
        {
        case 0:
          return 762; /* *rorsi3_insn */

        case 1:
          return 763; /* *rordi3_insn */

        default:
          return -1;
        }

    case ROTATE:
      return recog_532 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      switch (pattern527 (x2))
        {
        case 0:
          if (!
#line 6333 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
            return -1;
          return 814; /* *extvsi */

        case 1:
          if (!
#line 6333 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (DImode) - 1)))
            return -1;
          return 816; /* *extvdi */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      res = recog_475 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (XWINT (x6, 0) != 64L
          || GET_CODE (x9) != CONST_INT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (XWINT (x9, 0))
        {
        case 0L:
          switch (pattern902 ())
            {
            case 0:
              if (!
#line 7585 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1112; /* aarch64_movdi_tilow */

            case 1:
              if (!
#line 7585 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1113; /* aarch64_movdi_tflow */

            case 2:
              if (!
#line 7585 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1114; /* aarch64_movdi_tdlow */

            default:
              return -1;
            }

        case 64L:
          switch (pattern902 ())
            {
            case 0:
              if (!
#line 7595 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1115; /* aarch64_movdi_tihigh */

            case 1:
              if (!
#line 7595 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1116; /* aarch64_movdi_tfhigh */

            case 2:
              if (!
#line 7595 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (reload_completed || reload_in_progress)))
                return -1;
              return 1117; /* aarch64_movdi_tdhigh */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case TRUNCATE:
    case HIGH:
      return recog_506 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_540 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_526 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_525 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_513 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_536 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      return recog_543 (x1, insn, pnum_clobbers);

    case FLOAT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 7107 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1025; /* floatsisf2 */

        case 1:
          if (!
#line 7118 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1029; /* floatdisf2 */

        case 2:
          if (!
#line 7107 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1027; /* floatdidf2 */

        case 3:
          if (!
#line 7118 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1031; /* floatsidf2 */

        case 4:
          if (!
#line 7133 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1033; /* aarch64_fp16_floatsihf2 */

        case 5:
          if (!
#line 7133 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1035; /* aarch64_fp16_floatdihf2 */

        case 6:
          if (!
#line 3043 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
            return -1;
          return 2612; /* floathihf2 */

        case 7:
          if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2620; /* floatv4hiv4hf2 */

        case 8:
          if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2622; /* floatv8hiv8hf2 */

        case 9:
          if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2624; /* floatv2siv2sf2 */

        case 10:
          if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2626; /* floatv4siv4sf2 */

        case 11:
          if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2628; /* floatv2div2df2 */

        case 12:
          if (!
#line 3424 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12659; /* floatvnx8sivnx8sf2 */

        case 13:
          if (!
#line 3424 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12661; /* floatvnx16sivnx16sf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern13 (x1))
        {
        case 0:
          if (!
#line 7107 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1026; /* floatunssisf2 */

        case 1:
          if (!
#line 7118 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1030; /* floatunsdisf2 */

        case 2:
          if (!
#line 7107 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1028; /* floatunsdidf2 */

        case 3:
          if (!
#line 7118 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1032; /* floatunssidf2 */

        case 4:
          if (!
#line 7133 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1034; /* aarch64_fp16_floatunssihf2 */

        case 5:
          if (!
#line 7133 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
            return -1;
          return 1036; /* aarch64_fp16_floatunsdihf2 */

        case 6:
          if (!
#line 3043 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
            return -1;
          return 2613; /* floatunshihf2 */

        case 7:
          if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2621; /* floatunsv4hiv4hf2 */

        case 8:
          if (!(
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2623; /* floatunsv8hiv8hf2 */

        case 9:
          if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2625; /* floatunsv2siv2sf2 */

        case 10:
          if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2627; /* floatunsv4siv4sf2 */

        case 11:
          if (!
#line 3095 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2629; /* floatunsv2div2df2 */

        case 12:
          if (!
#line 3424 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12660; /* floatunsvnx8sivnx8sf2 */

        case 13:
          if (!
#line 3424 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 12662; /* floatunsvnx16sivnx16sf2 */

        default:
          return -1;
        }

    case SQRT:
      return recog_537 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_527 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_520 (x1, insn, pnum_clobbers);

    case UMAX:
      return recog_535 (x1, insn, pnum_clobbers);

    case UMIN:
      return recog_531 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (!aarch64_valid_symref (operands[2], E_VOIDmode))
        return -1;
      switch (pattern2 (x2))
        {
        case 0:
          if (!
#line 163 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == SImode || Pmode == SImode))
            return -1;
          return 1125; /* add_losym_si */

        case 1:
          if (!
#line 164 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(ptr_mode == DImode || Pmode == DImode))
            return -1;
          return 1126; /* add_losym_di */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_515 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_530 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_505 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_516 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      return recog_517 (x1, insn, pnum_clobbers);

    case US_PLUS:
      return recog_542 (x1, insn, pnum_clobbers);

    case SS_MINUS:
      return recog_519 (x1, insn, pnum_clobbers);

    case US_MINUS:
      return recog_541 (x1, insn, pnum_clobbers);

    case SS_TRUNCATE:
      return recog_545 (x1, insn, pnum_clobbers);

    case US_TRUNCATE:
      return recog_544 (x1, insn, pnum_clobbers);

    case SS_NEG:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3402; /* aarch64_sqnegv8qi */

        case 1:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3408; /* aarch64_sqnegv16qi */

        case 2:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3410; /* aarch64_sqnegv4hi */

        case 3:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3416; /* aarch64_sqnegv8hi */

        case 4:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3418; /* aarch64_sqnegv2si */

        case 5:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3424; /* aarch64_sqnegv4si */

        case 6:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3426; /* aarch64_sqnegv2di */

        case 7:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3428; /* aarch64_sqnegqi */

        case 8:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3430; /* aarch64_sqneghi */

        case 9:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3432; /* aarch64_sqnegsi */

        case 10:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3434; /* aarch64_sqnegdi */

        default:
          return -1;
        }

    case SS_ABS:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3405; /* aarch64_sqabsv8qi */

        case 1:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3409; /* aarch64_sqabsv16qi */

        case 2:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3413; /* aarch64_sqabsv4hi */

        case 3:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3417; /* aarch64_sqabsv8hi */

        case 4:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3421; /* aarch64_sqabsv2si */

        case 5:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3425; /* aarch64_sqabsv4si */

        case 6:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3427; /* aarch64_sqabsv2di */

        case 7:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3429; /* aarch64_sqabsqi */

        case 8:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3431; /* aarch64_sqabshi */

        case 9:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3433; /* aarch64_sqabssi */

        case 10:
          if (!
#line 5542 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3437; /* aarch64_sqabsdi */

        default:
          return -1;
        }

    case SS_ASHIFT:
      return recog_528 (x1, insn, pnum_clobbers);

    case VEC_SERIES:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern561 (x2, 
E_QImode, 
E_VNx16QImode) != 0
              || !
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6479; /* vec_seriesvnx16qi */

        case E_VNx8QImode:
          if (pattern561 (x2, 
E_QImode, 
E_VNx8QImode) != 0
              || !
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6480; /* vec_seriesvnx8qi */

        case E_VNx4QImode:
          if (pattern561 (x2, 
E_QImode, 
E_VNx4QImode) != 0
              || !
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6481; /* vec_seriesvnx4qi */

        case E_VNx2QImode:
          if (pattern561 (x2, 
E_QImode, 
E_VNx2QImode) != 0
              || !
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6482; /* vec_seriesvnx2qi */

        case E_VNx8HImode:
          if (pattern561 (x2, 
E_HImode, 
E_VNx8HImode) != 0
              || !
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6483; /* vec_seriesvnx8hi */

        case E_VNx4HImode:
          if (pattern561 (x2, 
E_HImode, 
E_VNx4HImode) != 0
              || !
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6484; /* vec_seriesvnx4hi */

        case E_VNx2HImode:
          if (pattern561 (x2, 
E_HImode, 
E_VNx2HImode) != 0
              || !
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6485; /* vec_seriesvnx2hi */

        case E_VNx4SImode:
          if (pattern561 (x2, 
E_SImode, 
E_VNx4SImode) != 0
              || !
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6486; /* vec_seriesvnx4si */

        case E_VNx2SImode:
          if (pattern561 (x2, 
E_SImode, 
E_VNx2SImode) != 0
              || !
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6487; /* vec_seriesvnx2si */

        case E_VNx2DImode:
          if (pattern561 (x2, 
E_DImode, 
E_VNx2DImode) != 0
              || !
#line 2903 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6488; /* vec_seriesvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_48 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2841 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2883 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2923 (insn, operands);
}

 rtx_insn *
split_54 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2816 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2862 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2902 (insn, operands);
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1050 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1682 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1755 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1807 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1695 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1768 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1820 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1708 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1781 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1833 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1721 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1794 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1846 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1728 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1905 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1735 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1912 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1742 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1919 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1859 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1872 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1885 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1898 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1926 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1933 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1940 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_64 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1050 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1675 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1748 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1800 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1688 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1761 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1813 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1701 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1774 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1826 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1714 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1787 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1839 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1723 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1900 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1730 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1907 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1737 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1914 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1852 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1865 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1878 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1891 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1921 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1928 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1935 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_71 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern710 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1255 (insn, operands);

        case E_VNx8QImode:
          if (pattern710 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1272 (insn, operands);

        case E_VNx4QImode:
          if (pattern710 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1289 (insn, operands);

        case E_VNx2QImode:
          if (pattern710 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1306 (insn, operands);

        case E_VNx8HImode:
          if (pattern710 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1323 (insn, operands);

        case E_VNx4HImode:
          if (pattern710 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1340 (insn, operands);

        case E_VNx2HImode:
          if (pattern710 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1357 (insn, operands);

        case E_VNx4SImode:
          if (pattern710 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1374 (insn, operands);

        case E_VNx2SImode:
          if (pattern710 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1391 (insn, operands);

        case E_VNx2DImode:
          if (pattern710 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1408 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1053 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4807 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1499 (insn, operands);

        case E_VNx8QImode:
          if (pattern1053 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4807 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1500 (insn, operands);

        case E_VNx4QImode:
          if (pattern1053 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4807 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1501 (insn, operands);

        case E_VNx2QImode:
          if (pattern1053 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4807 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1502 (insn, operands);

        case E_VNx8HImode:
          if (pattern1053 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4807 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1503 (insn, operands);

        case E_VNx4HImode:
          if (pattern1053 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4807 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1504 (insn, operands);

        case E_VNx2HImode:
          if (pattern1053 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4807 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1505 (insn, operands);

        case E_VNx4SImode:
          if (pattern1053 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4807 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1506 (insn, operands);

        case E_VNx2SImode:
          if (pattern1053 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4807 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1507 (insn, operands);

        case E_VNx2DImode:
          if (pattern1053 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4807 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1508 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_74 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (XINT (x3, 1))
    {
    case 299:
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          return split_69 (x1, insn);

        case PLUS:
          return split_73 (x1, insn);

        case MINUS:
          return split_70 (x1, insn);

        case MULT:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1247 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1264 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1281 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1298 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1315 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1332 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1349 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1366 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1383 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1400 (insn, operands);

            default:
              return NULL;
            }

        case SMAX:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1248 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1265 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1282 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1299 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1316 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1333 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1350 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1367 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1384 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1401 (insn, operands);

            default:
              return NULL;
            }

        case UMAX:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1249 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1266 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1283 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1300 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1317 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1334 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1351 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1368 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1385 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1402 (insn, operands);

            default:
              return NULL;
            }

        case SMIN:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1250 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1267 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1284 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1301 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1318 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1335 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1352 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1369 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1386 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1403 (insn, operands);

            default:
              return NULL;
            }

        case UMIN:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1251 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1268 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1285 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1302 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1319 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1336 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1353 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1370 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1387 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1404 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          return split_72 (x1, insn);

        case ASHIFTRT:
          switch (pattern713 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1253 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1270 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1287 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1304 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1321 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1338 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1355 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1372 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1389 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1406 (insn, operands);

            case 10:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1540 (insn, operands);

            case 11:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1543 (insn, operands);

            case 12:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1546 (insn, operands);

            case 13:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1549 (insn, operands);

            case 14:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1552 (insn, operands);

            case 15:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1555 (insn, operands);

            case 16:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1558 (insn, operands);

            case 17:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1561 (insn, operands);

            case 18:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1564 (insn, operands);

            case 19:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1567 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern713 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1254 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1271 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1288 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1305 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1322 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1339 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1356 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1373 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1390 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1407 (insn, operands);

            case 10:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1541 (insn, operands);

            case 11:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1544 (insn, operands);

            case 12:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1547 (insn, operands);

            case 13:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1550 (insn, operands);

            case 14:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1553 (insn, operands);

            case 15:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1556 (insn, operands);

            case 16:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1559 (insn, operands);

            case 17:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1562 (insn, operands);

            case 18:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1565 (insn, operands);

            case 19:
              if (!(
#line 4954 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1568 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          return split_71 (x1, insn);

        case IOR:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1256 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1273 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1290 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1307 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1324 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1341 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1358 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1375 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1392 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1409 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1257 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1274 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1291 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1308 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1325 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1342 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1359 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1376 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1393 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1410 (insn, operands);

            default:
              return NULL;
            }

        case SS_PLUS:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1258 (insn, operands);

            case 1:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1275 (insn, operands);

            case 2:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1292 (insn, operands);

            case 3:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1309 (insn, operands);

            case 4:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1326 (insn, operands);

            case 5:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1343 (insn, operands);

            case 6:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1360 (insn, operands);

            case 7:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1377 (insn, operands);

            case 8:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1394 (insn, operands);

            case 9:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1411 (insn, operands);

            default:
              return NULL;
            }

        case US_PLUS:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1259 (insn, operands);

            case 1:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1276 (insn, operands);

            case 2:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1293 (insn, operands);

            case 3:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1310 (insn, operands);

            case 4:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1327 (insn, operands);

            case 5:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1344 (insn, operands);

            case 6:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1361 (insn, operands);

            case 7:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1378 (insn, operands);

            case 8:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1395 (insn, operands);

            case 9:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1412 (insn, operands);

            default:
              return NULL;
            }

        case SS_MINUS:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1260 (insn, operands);

            case 1:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1277 (insn, operands);

            case 2:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1294 (insn, operands);

            case 3:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1311 (insn, operands);

            case 4:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1328 (insn, operands);

            case 5:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1345 (insn, operands);

            case 6:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1362 (insn, operands);

            case 7:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1379 (insn, operands);

            case 8:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1396 (insn, operands);

            case 9:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1413 (insn, operands);

            default:
              return NULL;
            }

        case US_MINUS:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1261 (insn, operands);

            case 1:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1278 (insn, operands);

            case 2:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1295 (insn, operands);

            case 3:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1312 (insn, operands);

            case 4:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1329 (insn, operands);

            case 5:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1346 (insn, operands);

            case 6:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1363 (insn, operands);

            case 7:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1380 (insn, operands);

            case 8:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1397 (insn, operands);

            case 9:
              if (!((
#line 4039 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../gcc-15.0.1-20250313/gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1414 (insn, operands);

            default:
              return NULL;
            }

        case DIV:
          switch (pattern714 (x3))
            {
            case 0:
              if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4689 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1485 (insn, operands);

            case 1:
              if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4689 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1487 (insn, operands);

            default:
              return NULL;
            }

        case UDIV:
          switch (pattern714 (x3))
            {
            case 0:
              if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4689 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1486 (insn, operands);

            case 1:
              if (!(
#line 4679 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4689 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1488 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 351:
      x6 = XVECEXP (x3, 0, 2);
      if (pattern490 (x6, 
393) != 0)
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[2] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1228 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !(
#line 6230 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6235 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          return gen_split_1977 (insn, operands);

        case E_VNx4SFmode:
          if (pattern1228 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !(
#line 6230 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6235 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          return gen_split_1978 (insn, operands);

        case E_VNx2DFmode:
          if (pattern1228 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !(
#line 6230 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6235 "../../gcc-15.0.1-20250313/gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          return gen_split_1979 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
