/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != UNSPEC_VOLATILE
      || XVECLEN (x4, 0) != 2
      || XINT (x4, 1) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern10 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern10 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern10 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V8BFmode:
      if (pattern10 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 3;

    case E_V4SImode:
      if (pattern10 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern10 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern10 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 100
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x9 = XEXP (x3, 0);
  operands[1] = x9;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x11 = XEXP (x4, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[4] = x12;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i2))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    case E_V2DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[2], E_V16QImode)
          || !s_register_operand (operands[3], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !mve_imm_7 (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !mve_imm_15 (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !mve_imm_31 (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern41 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 3;

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    case E_V2DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4x16QImode:
      return 0;

    case E_V4x8HImode:
      return 1;

    case E_V4x4SImode:
      return 2;

    case E_V4x8HFmode:
      return 3;

    case E_V4x4SFmode:
      return 4;

    default:
      return -1;
    }
}

int
pattern177 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return pattern115 (x3); /* [-1, 2] */
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern40 (x3, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern40 (x3, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern38 (x3, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern38 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 2);
  operands[3] = x8;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern205 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !mve_imm_16 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern206 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern223 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern216 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern216 (x3, 
E_V4BImode, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XVECEXP (x3, 0, 5);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x10 = XVECEXP (x3, 0, 6);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x11 = XVECEXP (x3, 0, 7);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x12 = XEXP (x1, 1);
  x13 = XEXP (x12, 1);
  if (XVECLEN (x13, 0) != 8)
    return -1;
  x14 = XVECEXP (x13, 0, 0);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x15 = XVECEXP (x13, 0, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x16 = XVECEXP (x13, 0, 2);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x17 = XVECEXP (x13, 0, 3);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x18 = XVECEXP (x13, 0, 4);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x19 = XVECEXP (x13, 0, 5);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x20 = XVECEXP (x13, 0, 6);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x21 = XVECEXP (x13, 0, 7);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
      || pattern237 (x1, 
E_V8QImode, 
E_V16QImode) != 0)
    return -1;
  return 0;
}

int
pattern259 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!cc_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!mem_noofs_operand (operands[2], E_QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QImode
          || !s_register_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!mem_noofs_operand (operands[2], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HImode
          || !s_register_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  return 0;
}

int
pattern272 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !reg_or_zero_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern281 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 19)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  return pattern21 (x1); /* [-1, 3] */
}

int
pattern293 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern292 (x1); /* [-1, 3] */
}

int
pattern296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_V4HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XEXP (x5, 2);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != ZERO_EXTRACT
      || GET_MODE (x8) != E_V4HImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x10 = XEXP (x8, 2);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != ZERO_EXTRACT
      || GET_MODE (x11) != E_V4HImode)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x11, 2);
  if (GET_CODE (x13) != CONST_INT
      || !register_operand (operands[0], E_V2SImode)
      || !register_operand (operands[1], E_V2SImode))
    return -1;
  x14 = XEXP (x2, 0);
  operands[2] = x14;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x15 = XEXP (x8, 0);
  operands[3] = x15;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x16 = XEXP (x5, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  x17 = XEXP (x11, 0);
  if (!rtx_equal_p (x17, operands[3]))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0L:
      if (XWINT (x7, 0) != 32L)
        return -1;
      switch (XWINT (x10, 0))
        {
        case 0L:
          if (XWINT (x13, 0) != 32L)
            return -1;
          return 0;

        case 16L:
          if (XWINT (x13, 0) != 48L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 16L:
      if (XWINT (x7, 0) != 48L)
        return -1;
      switch (XWINT (x10, 0))
        {
        case 0L:
          if (XWINT (x13, 0) != 32L)
            return -1;
          return 2;

        case 16L:
          if (XWINT (x13, 0) != 48L)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern333 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[4] = x9;
  if (!mve_imm_selective_upto_8 (operands[4], E_SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  operands[5] = x10;
  x11 = XEXP (x2, 0);
  operands[2] = x11;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x12 = XEXP (x3, 1);
  operands[6] = x12;
  if (!immediate_operand (operands[6], E_SImode))
    return -1;
  x13 = XEXP (x3, 0);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern332 (x6, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern332 (x6, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern332 (x6, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern352 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i2)
      || !s_register_operand (operands[3], i2)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern358 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  if (!s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern367 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern373 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern380 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V4HImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_V4HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 4)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x11 = XEXP (x3, 1);
  if (GET_CODE (x11) != i1
      || GET_MODE (x11) != E_V4HImode)
    return -1;
  x12 = XEXP (x11, 1);
  if (GET_CODE (x12) != VEC_SELECT
      || GET_MODE (x12) != E_V4HImode)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != PARALLEL
      || XVECLEN (x13, 0) != 4)
    return -1;
  x14 = XVECEXP (x13, 0, 0);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x15 = XVECEXP (x13, 0, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x16 = XVECEXP (x13, 0, 2);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x17 = XVECEXP (x13, 0, 3);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x18 = XEXP (x3, 2);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x19 = XEXP (x1, 0);
  operands[3] = x19;
  x20 = XEXP (x19, 0);
  operands[4] = x20;
  if (!register_operand (operands[0], E_V4HImode)
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x21 = XEXP (x4, 0);
  operands[1] = x21;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x22 = XEXP (x5, 0);
  operands[2] = x22;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x23 = XEXP (x11, 0);
  if (!rtx_equal_p (x23, operands[1]))
    return -1;
  x24 = XEXP (x12, 0);
  if (!rtx_equal_p (x24, operands[2]))
    return -1;
  return 0;
}

int
pattern413 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x5, 1);
  switch (XVECLEN (x8, 0))
    {
    case 4:
      x9 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x8, 0, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x8, 0, 2);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x8, 0, 3);
      if (GET_CODE (x12) != CONST_INT
          || !register_operand (operands[0], E_V4HImode)
          || GET_MODE (x5) != E_V4HImode
          || GET_MODE (x6) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      switch (XWINT (x9, 0))
        {
        case 4L:
          if (XWINT (x10, 0) != 5L
              || XWINT (x11, 0) != 6L
              || XWINT (x12, 0) != 7L)
            return -1;
          return 0;

        case 0L:
          if (XWINT (x10, 0) != 1L
              || XWINT (x11, 0) != 2L
              || XWINT (x12, 0) != 3L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 2:
      x9 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x8, 0, 1);
      if (GET_CODE (x10) != CONST_INT
          || !register_operand (operands[0], E_V2SImode)
          || GET_MODE (x5) != E_V2SImode
          || GET_MODE (x6) != E_V4SImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      switch (XWINT (x9, 0))
        {
        case 2L:
          if (XWINT (x10, 0) != 3L)
            return -1;
          return 2;

        case 0L:
          if (XWINT (x10, 0) != 1L)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 1:
      x9 = XVECEXP (x8, 0, 0);
      if (GET_CODE (x9) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || GET_MODE (x6) != E_V2DImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      switch (XWINT (x9, 0))
        {
        case 1L:
          return 4;

        case 0L:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern455 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode
      || !s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_DImode
      || !s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern466 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern473 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!const_double_vcvt_power_of_two_reciprocal (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || GET_MODE (x2) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x2) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern487 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
      || !register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern497 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT
      || XWINT (x2, 0) != 32768L)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT
      || XWINT (x3, 0) != 32768L)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != 32768L)
    return -1;
  return 0;
}

int
pattern504 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_OImode:
      if (!s_register_operand (operands[1], E_OImode)
          || GET_MODE (x1) != i1)
        return -1;
      return 0;

    case E_XImode:
      if (!s_register_operand (operands[1], E_XImode)
          || GET_MODE (x1) != i2)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern514 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!mem_noofs_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !reg_or_int_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern523 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !arm_general_register_operand (operands[0], E_SImode)
      || !arm_general_register_operand (operands[1], i1)
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern532 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V8HImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern547 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (!logical_binary_operator (x3, E_SImode))
    return -1;
  operands[9] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[5] = x8;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_SImode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[7] = x10;
  if (!s_register_operand (operands[7], E_SImode))
    return -1;
  return 0;
}

int
pattern569 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern576 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern582 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern591 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !s_register_operand (operands[2], i3))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern599 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MULT
      || GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern609 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  return pattern608 (x5, 
i1, 
i2); /* [-1, 0] */
}

int
pattern618 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern626 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  return 0;
}

int
pattern631 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !vpr_register_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern638 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  return 0;
}

int
pattern640 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  return 0;
}

int
pattern646 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

int
pattern650 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x9, 1);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  x16 = XEXP (x4, 1);
  x17 = XVECEXP (x16, 0, 0);
  switch (XWINT (x17, 0))
    {
    case 0L:
      x18 = XEXP (x11, 1);
      x19 = XVECEXP (x18, 0, 0);
      if (XWINT (x19, 0) != 2L)
        return -1;
      x20 = XEXP (x7, 1);
      x21 = XVECEXP (x20, 0, 0);
      switch (XWINT (x21, 0))
        {
        case 0L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 2L)
            return -1;
          return 0;

        case 1L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 3L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 1L:
      x18 = XEXP (x11, 1);
      x19 = XVECEXP (x18, 0, 0);
      if (XWINT (x19, 0) != 3L)
        return -1;
      x20 = XEXP (x7, 1);
      x21 = XVECEXP (x20, 0, 0);
      switch (XWINT (x21, 0))
        {
        case 0L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 2L)
            return -1;
          return 2;

        case 1L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 3L)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (pattern289 (x2, 
E_CC_NZmode) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != XOR
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != E_CC_NZmode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  operands[0] = x9;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x4, 1);
  if (!rtx_equal_p (x11, operands[2])
      || !
#line 3871 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return -1;
  return 114; /* *xorsi3_compare0 */
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case NE:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 2);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          operands[3] = x7;
          if (const_int_operand (operands[3], E_SImode)
              && pattern527 (x1) == 0
              && 
#line 3116 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)))
            return 94; /* *ne_zeroextractsi */
          if (XWINT (x7, 0) != 0L
              || pattern527 (x1) != 0
              || !
#line 3154 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 95; /* *ne_zeroextractsi_shifted */

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 1769 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 986; /* *cstoresi_ne0_thumb1_insn */

        default:
          return -1;
        }

    case EQ:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      if (!s_register_operand (operands[2], E_SImode)
          || !
#line 1756 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 985; /* *cstoresi_eq0_thumb1_insn */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[6] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  if (!arm_add_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x3, 2);
  operands[1] = x9;
  if (!arm_rhs_operand (operands[1], E_SImode)
      || !
#line 10874 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
    return -1;
  return 352; /* *ifcompare_plus_move */
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[2] = x6;
      if (ldrd_strd_offset_operand (operands[2], E_SImode))
        {
          res = recog_21 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x6, 0) != -4L)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode
          || !s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x8, 0);
      if (!rtx_equal_p (x11, operands[1])
          || !
#line 12751 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[0], operands[2],
                                  operands[1], -4, false, true))))
        return -1;
      return 425; /* *thumb2_ldrd_base_neg */

    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != PLUS
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
          || !s_register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x11, 0);
      if (!rtx_equal_p (x13, operands[1])
          || !
#line 12738 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[0], operands[2],
                                  operands[1], 0, false, true))))
        return -1;
      return 424; /* *thumb2_ldrd_base */

    case UNSPEC:
      if (XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 2
          || GET_MODE (x5) != E_SImode)
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || !register_operand (operands[0], E_SImode))
        return -1;
      x15 = XVECEXP (x5, 0, 0);
      operands[2] = x15;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XVECEXP (x5, 0, 2);
      operands[3] = x16;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!scratch_operand (operands[1], E_SImode)
          || !
#line 274 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      return 1015; /* tls_load_dot_plus_four */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  x9 = XVECEXP (x6, 0, 0);
  operands[2] = x9;
  switch (XINT (x3, 1))
    {
    case 22:
      if (XINT (x6, 1) != 22)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!mem_noofs_operand (operands[1], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !s_register_operand (operands[2], E_QImode)
              || !
#line 557 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3177; /* arm_store_exclusiveqi */

        case E_HImode:
          if (!mem_noofs_operand (operands[1], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !s_register_operand (operands[2], E_HImode)
              || !
#line 557 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3178; /* arm_store_exclusivehi */

        case E_SImode:
          if (!mem_noofs_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !s_register_operand (operands[2], E_SImode)
              || !
#line 557 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3179; /* arm_store_exclusivesi */

        case E_DImode:
          if (!mem_noofs_operand (operands[1], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !s_register_operand (operands[2], E_DImode)
              || !
#line 557 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3180; /* arm_store_exclusivedi */

        default:
          return -1;
        }

    case 24:
      if (XINT (x6, 1) != 24)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!mem_noofs_operand (operands[1], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !s_register_operand (operands[2], E_DImode)
              || !
#line 580 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQEXD && ARM_DOUBLEWORD_ALIGN))
            return -1;
          return 3181; /* arm_store_release_exclusivedi */

        case E_QImode:
          if (!mem_noofs_operand (operands[1], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !s_register_operand (operands[2], E_QImode)
              || !
#line 595 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
            return -1;
          return 3182; /* arm_store_release_exclusiveqi */

        case E_HImode:
          if (!mem_noofs_operand (operands[1], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !s_register_operand (operands[2], E_HImode)
              || !
#line 595 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
            return -1;
          return 3183; /* arm_store_release_exclusivehi */

        case E_SImode:
          if (!mem_noofs_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !s_register_operand (operands[2], E_SImode)
              || !
#line 595 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
            return -1;
          return 3184; /* arm_store_release_exclusivesi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_33 (x1, insn, pnum_clobbers);

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XEXP (x2, 0);
      switch (pattern6 (x4))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (
#line 8714 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 290; /* *call_reg_armv5 */
                }
              if (
#line 8724 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 291; /* *call_reg_arm */
                }
            }
          if (
#line 8853 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !SIBLING_CALL_P (insn)
   && (GET_CODE (operands[0]) == SYMBOL_REF)
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[0]))))
            {
              *pnum_clobbers = 1;
              return 294; /* *call_symbol */
            }
          if (register_operand (operands[0], E_SImode))
            {
              if (
#line 1870 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 991; /* *call_reg_thumb1_v5 */
                }
              if (
#line 1893 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 993; /* *call_reg_thumb1 */
                }
            }
          if (
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[0]))))
            {
              *pnum_clobbers = 1;
              return 997; /* *call_insn */
            }
          if (!s_register_operand (operands[0], E_SImode)
              || !
#line 534 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1025; /* *call_reg_thumb2 */

        case 1:
          x7 = XVECEXP (x4, 0, 0);
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) == REG
              && REGNO (x8) == 4
              && GET_MODE (x8) == E_SImode)
            {
              x5 = XEXP (x2, 1);
              operands[0] = x5;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (
#line 1882 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && use_cmse && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 992; /* *nonsecure_call_reg_thumb1_v5 */
                }
            }
          operands[0] = x8;
          if (s_register_operand (operands[0], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              x6 = XEXP (x3, 0);
              operands[2] = x6;
              if (
#line 545 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && TARGET_HAVE_FPCXT_CMSE))
                {
                  *pnum_clobbers = 1;
                  return 1026; /* *nonsecure_call_reg_thumb2_fpcxt */
                }
            }
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 4
              || GET_MODE (x8) != E_SImode)
            return -1;
          x5 = XEXP (x2, 1);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!
#line 557 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && !TARGET_HAVE_FPCXT_CMSE))
            return -1;
          *pnum_clobbers = 1;
          return 1027; /* *nonsecure_call_reg_thumb2 */

        default:
          return -1;
        }

    case RETURN:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x9 = XEXP (x3, 1);
      if (pattern16 (x9, 
POST_INC, 
MEM, 
E_SImode) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 15
          || GET_MODE (x6) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!s_register_operand (operands[0], E_SImode)
          || !
#line 12016 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
        return -1;
      return 389; /* *ldr_with_return */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x2, 0))
        {
        case 1:
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          switch (XINT (x2, 1))
            {
            case 16:
              x12 = XVECEXP (x2, 0, 0);
              operands[0] = x12;
              if (!s_register_operand (operands[0], E_SImode))
                return -1;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (!scratch_operand (operands[1], E_SImode))
                return -1;
              if (
#line 12275 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 404; /* arm_eh_return */
              if (
#line 2096 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return 1005; /* thumb_eh_return */
              if (!
#line 1239 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return -1;
              return 1051; /* thumb2_eh_return */

            case 54:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              x12 = XVECEXP (x2, 0, 0);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XEXP (x3, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 100
                  || GET_MODE (x6) != E_CCmode
                  || !
#line 1699 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse))
                return -1;
              return 1070; /* *clear_apsr */

            default:
              return -1;
            }

        case 6:
          if (pattern17 (x1, 
E_SImode) != 0)
            return -1;
          x13 = XVECEXP (x2, 0, 4);
          operands[4] = x13;
          if (!immediate_operand (operands[4], E_SImode))
            return -1;
          x14 = XVECEXP (x2, 0, 5);
          operands[5] = x14;
          if (!immediate_operand (operands[5], E_SImode))
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x3, 0);
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          switch (XINT (x2, 1))
            {
            case 43:
              if (!
#line 13007 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCR)))
                return -1;
              return 505; /* arm_mcr */

            case 44:
              if (!
#line 13007 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCR2)))
                return -1;
              return 506; /* arm_mcr2 */

            default:
              return -1;
            }

        case 4:
          if (pattern17 (x1, 
E_DImode) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x3, 0);
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          switch (XINT (x2, 1))
            {
            case 47:
              if (!
#line 13044 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCRR)))
                return -1;
              return 509; /* arm_mcrr */

            case 48:
              if (!
#line 13044 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCRR2)))
                return -1;
              return 510; /* arm_mcrr2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  switch (pattern299 (x1))
    {
    case 0:
      if (pattern389 (x1) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      x8 = XEXP (x2, 1);
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[4] = x9;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x3, 1);
          x11 = XEXP (x10, 0);
          x12 = XEXP (x11, 1);
          if (XWINT (x12, 0) != 4L)
            return -1;
          x13 = XEXP (x4, 1);
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          x17 = XEXP (x14, 0);
          if (!rtx_equal_p (x17, operands[4]))
            return -1;
          if (arm_hard_general_register_operand (operands[1], E_SImode)
              && arm_hard_general_register_operand (operands[2], E_SImode)
              && arm_hard_general_register_operand (operands[3], E_SImode)
              && 
#line 477 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
            return 456; /* *ldm3_ */
          if (!low_register_operand (operands[1], E_SImode)
              || !low_register_operand (operands[2], E_SImode)
              || !low_register_operand (operands[3], E_SImode)
              || !
#line 492 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 3))
            return -1;
          return 457; /* *thumb_ldm3_ia */

        case PLUS:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x18 = XEXP (x9, 1);
          if (GET_CODE (x18) != CONST_INT
              || !arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x19 = XEXP (x9, 0);
          operands[4] = x19;
          if (!s_register_operand (operands[4], E_SImode)
              || !arm_hard_general_register_operand (operands[2], E_SImode)
              || !arm_hard_general_register_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x3, 1);
          x11 = XEXP (x10, 0);
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          switch (XWINT (x18, 0))
            {
            case 4L:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != 8L)
                return -1;
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              if (pattern626 (x14, 
12) != 0
                  || !
#line 582 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 463; /* *ldm3_ib */

            case -8L:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -4L)
                return -1;
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[4])
                  || !
#line 643 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 467; /* *ldm3_da */

            case -12L:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -8L)
                return -1;
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              if (pattern626 (x14, 
-4) != 0
                  || !
#line 704 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 471; /* *ldm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern452 (x1) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x4, 1);
      operands[3] = x13;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      x20 = XEXP (x5, 0);
      switch (GET_CODE (x20))
        {
        case REG:
        case SUBREG:
          operands[4] = x20;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          x21 = XEXP (x6, 0);
          x22 = XEXP (x21, 1);
          if (XWINT (x22, 0) != 4L)
            return -1;
          x7 = XEXP (x4, 0);
          x23 = XEXP (x7, 0);
          if (GET_CODE (x23) != PLUS
              || GET_MODE (x23) != E_SImode)
            return -1;
          x24 = XEXP (x23, 1);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[4]))
            return -1;
          x26 = XEXP (x23, 0);
          if (!rtx_equal_p (x26, operands[4])
              || !
#line 537 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
            return -1;
          return 460; /* *stm3_ */

        case PLUS:
          if (GET_MODE (x20) != E_SImode)
            return -1;
          x27 = XEXP (x20, 1);
          if (GET_CODE (x27) != CONST_INT)
            return -1;
          x28 = XEXP (x20, 0);
          operands[4] = x28;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          x21 = XEXP (x6, 0);
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[4]))
            return -1;
          switch (XWINT (x27, 0))
            {
            case 4L:
              x22 = XEXP (x21, 1);
              if (XWINT (x22, 0) != 8L)
                return -1;
              x7 = XEXP (x4, 0);
              x23 = XEXP (x7, 0);
              if (pattern629 (x23, 
12) != 0
                  || !
#line 613 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 465; /* *stm3_ib */

            case -8L:
              x22 = XEXP (x21, 1);
              if (XWINT (x22, 0) != -4L)
                return -1;
              x7 = XEXP (x4, 0);
              x23 = XEXP (x7, 0);
              if (!rtx_equal_p (x23, operands[4])
                  || !
#line 673 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 469; /* *stm3_da */

            case -12L:
              x22 = XEXP (x21, 1);
              if (XWINT (x22, 0) != -8L)
                return -1;
              x7 = XEXP (x4, 0);
              x23 = XEXP (x7, 0);
              if (pattern629 (x23, 
-4) != 0
                  || !
#line 735 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 473; /* *stm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      x9 = XEXP (x8, 0);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x29 = XEXP (x8, 1);
      switch (XWINT (x29, 0))
        {
        case 8L:
          switch (pattern496 (x3))
            {
            case 0:
              x13 = XEXP (x4, 1);
              if (GET_CODE (x13) != MEM
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != PLUS
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != CONST_INT
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              x17 = XEXP (x14, 0);
              if (!rtx_equal_p (x17, operands[3]))
                return -1;
              x10 = XEXP (x3, 1);
              x11 = XEXP (x10, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x11, operands[3])
                      || XWINT (x15, 0) != 4L)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && 
#line 880 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return 477; /* *ldm2_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !
#line 894 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 478; /* *thumb_ldm2_ia_update */

                case PLUS:
                  if (GET_MODE (x11) != E_SImode)
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x15, 0) != 8L
                      || !arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode))
                    return -1;
                  x16 = XEXP (x11, 0);
                  if (!rtx_equal_p (x16, operands[3])
                      || !
#line 957 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 483; /* *ldm2_ib_update */

                default:
                  return -1;
                }

            case 1:
              x7 = XEXP (x4, 0);
              if (pattern453 (x7) != 0)
                return -1;
              x23 = XEXP (x7, 0);
              x24 = XEXP (x23, 1);
              if (GET_CODE (x24) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x4, 1);
              operands[2] = x13;
              x26 = XEXP (x23, 0);
              if (!rtx_equal_p (x26, operands[3]))
                return -1;
              x6 = XEXP (x3, 0);
              x21 = XEXP (x6, 0);
              switch (GET_CODE (x21))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x21, operands[3])
                      || XWINT (x24, 0) != 4L)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && 
#line 917 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return 480; /* *stm2_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !
#line 930 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 481; /* *thumb_stm2_ia_update */

                case PLUS:
                  if (GET_MODE (x21) != E_SImode)
                    return -1;
                  x22 = XEXP (x21, 1);
                  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x24, 0) != 8L
                      || !arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode))
                    return -1;
                  x25 = XEXP (x21, 0);
                  if (!rtx_equal_p (x25, operands[3])
                      || !
#line 981 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 485; /* *stm2_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -8L:
          x10 = XEXP (x3, 1);
          switch (GET_CODE (x10))
            {
            case MEM:
              if (pattern389 (x1) != 0
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x10, 0);
              x16 = XEXP (x11, 0);
              if (!rtx_equal_p (x16, operands[3]))
                return -1;
              x12 = XEXP (x11, 1);
              switch (XWINT (x12, 0))
                {
                case -4L:
                  x13 = XEXP (x4, 1);
                  x14 = XEXP (x13, 0);
                  if (!rtx_equal_p (x14, operands[3])
                      || !
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 487; /* *ldm2_da_update */

                case -8L:
                  x13 = XEXP (x4, 1);
                  x14 = XEXP (x13, 0);
                  if (GET_CODE (x14) != PLUS
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x15 = XEXP (x14, 1);
                  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x17 = XEXP (x14, 0);
                  if (!rtx_equal_p (x17, operands[3])
                      || !
#line 1059 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 491; /* *ldm2_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x10;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern452 (x1) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x4, 1);
              operands[2] = x13;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x6 = XEXP (x3, 0);
              x21 = XEXP (x6, 0);
              x25 = XEXP (x21, 0);
              if (!rtx_equal_p (x25, operands[3]))
                return -1;
              x22 = XEXP (x21, 1);
              switch (XWINT (x22, 0))
                {
                case -4L:
                  x7 = XEXP (x4, 0);
                  x23 = XEXP (x7, 0);
                  if (!rtx_equal_p (x23, operands[3])
                      || !
#line 1031 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 489; /* *stm2_da_update */

                case -8L:
                  x7 = XEXP (x4, 0);
                  x23 = XEXP (x7, 0);
                  if (GET_CODE (x23) != PLUS
                      || GET_MODE (x23) != E_SImode)
                    return -1;
                  x24 = XEXP (x23, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x26 = XEXP (x23, 0);
                  if (!rtx_equal_p (x26, operands[3])
                      || !
#line 1083 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 493; /* *stm2_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (pattern391 (x3, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3155 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4829; /* mve_vstrq_p_v16qi */

    case E_V8HImode:
      if (pattern391 (x3, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3155 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4830; /* mve_vstrq_p_v8hi */

    case E_V4SImode:
      if (pattern391 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3155 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4831; /* mve_vstrq_p_v4si */

    case E_V8HFmode:
      if (pattern391 (x3, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 3155 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4832; /* mve_vstrq_p_v8hf */

    case E_V4SFmode:
      if (pattern391 (x3, 
E_V4BImode, 
E_V4SFmode) != 0
          || !
#line 3155 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4833; /* mve_vstrq_p_v4sf */

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V2SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[2]))
    {
    case E_V8QImode:
      if (!register_operand (operands[2], E_V8QImode)
          || !register_operand (operands[3], E_V8QImode)
          || !
#line 1728 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 683; /* iwmmxt_wsadb */

    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode)
          || !register_operand (operands[3], E_V4HImode)
          || !
#line 1740 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 684; /* iwmmxt_wsadh */

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (!
#line 2155 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1574; /* neon_vmlsv8qi_unspec */

    case 1:
      if (!
#line 2155 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1575; /* neon_vmlsv16qi_unspec */

    case 2:
      if (!
#line 2155 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1576; /* neon_vmlsv4hi_unspec */

    case 3:
      if (!
#line 2155 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1577; /* neon_vmlsv8hi_unspec */

    case 4:
      if (!
#line 2155 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1578; /* neon_vmlsv2si_unspec */

    case 5:
      if (!
#line 2155 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1579; /* neon_vmlsv4si_unspec */

    case 6:
      if (!
#line 2155 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1580; /* neon_vmlsv2sf_unspec */

    case 7:
      if (!
#line 2155 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1581; /* neon_vmlsv4sf_unspec */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern70 (x1))
    {
    case 0:
      if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4142; /* mve_vpselq_uv16qi */

    case 1:
      if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4144; /* mve_vpselq_uv8hi */

    case 2:
      if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4146; /* mve_vpselq_uv4si */

    case 3:
      if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4148; /* mve_vpselq_uv2di */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!neon_struct_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2650; /* neon_vst1v8qi */

    case E_V16QImode:
      if (!neon_struct_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2651; /* neon_vst1v16qi */

    case E_V4HImode:
      if (!neon_struct_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2652; /* neon_vst1v4hi */

    case E_V8HImode:
      if (!neon_struct_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2653; /* neon_vst1v8hi */

    case E_V2SImode:
      if (!neon_struct_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2654; /* neon_vst1v2si */

    case E_V4SImode:
      if (!neon_struct_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2655; /* neon_vst1v4si */

    case E_V4HFmode:
      if (!neon_struct_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2656; /* neon_vst1v4hf */

    case E_V8HFmode:
      if (!neon_struct_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2657; /* neon_vst1v8hf */

    case E_V4BFmode:
      if (!neon_struct_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !s_register_operand (operands[1], E_V4BFmode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2658; /* neon_vst1v4bf */

    case E_V8BFmode:
      if (!neon_struct_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !s_register_operand (operands[1], E_V8BFmode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2659; /* neon_vst1v8bf */

    case E_V2SFmode:
      if (!neon_struct_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2660; /* neon_vst1v2sf */

    case E_V4SFmode:
      if (!neon_struct_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2661; /* neon_vst1v4sf */

    case E_DImode:
      if (!neon_struct_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !s_register_operand (operands[1], E_DImode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2662; /* neon_vst1di */

    case E_V2DImode:
      if (!neon_struct_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V2DImode)
          || !
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2663; /* neon_vst1v2di */

    default:
      return -1;
    }
}

 int
recog_124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern369 (x2, 
E_V8QImode, 
E_V8HImode) != 0
          || !
#line 3179 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4834; /* mve_vstrq_truncate_v8qi */

    case E_V4QImode:
      if (pattern369 (x2, 
E_V4QImode, 
E_V4SImode) != 0
          || !
#line 3179 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4835; /* mve_vstrq_truncate_v4qi */

    case E_V4HImode:
      if (pattern369 (x2, 
E_V4HImode, 
E_V4SImode) != 0
          || !
#line 3179 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4836; /* mve_vstrq_truncate_v4hi */

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!guard_addr_operand (operands[1], E_SImode))
    return -1;
  *pnum_clobbers = 2;
  return 308; /* *stack_protect_combined_set_insn */
}

 int
recog_138 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern162 (x1, 
E_OImode) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!neon_struct_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V8QImode
          || !
#line 6116 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2930; /* neon_vld4_dupv8qi */

    case E_V4HImode:
      if (!neon_struct_operand (operands[1], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V4HImode
          || !
#line 6116 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2931; /* neon_vld4_dupv4hi */

    case E_V4HFmode:
      if (!neon_struct_operand (operands[1], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V4HFmode
          || !
#line 6116 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2932; /* neon_vld4_dupv4hf */

    case E_V4BFmode:
      if (!neon_struct_operand (operands[1], E_V4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V4BFmode
          || !(
#line 6116 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2933; /* neon_vld4_dupv4bf */

    case E_V4SImode:
      if (!neon_struct_operand (operands[1], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V2SImode
          || !
#line 6116 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2934; /* neon_vld4_dupv2si */

    case E_V4SFmode:
      if (!neon_struct_operand (operands[1], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_V2SFmode
          || !
#line 6116 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2935; /* neon_vld4_dupv2sf */

    case E_OImode:
      if (!neon_struct_operand (operands[1], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_DImode
          || !
#line 6116 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2936; /* neon_vld4_dupdi */

    default:
      return -1;
    }
}

 int
recog_143 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      if (!vpr_register_operand (operands[0], E_V16BImode)
          || GET_MODE (x3) != E_V16BImode
          || !vpr_register_operand (operands[2], E_V16BImode)
          || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3778; /* mve_vctp8q_mv16bi */

    case E_V8BImode:
      if (!vpr_register_operand (operands[0], E_V8BImode)
          || GET_MODE (x3) != E_V8BImode
          || !vpr_register_operand (operands[2], E_V8BImode)
          || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3779; /* mve_vctp16q_mv8bi */

    case E_V4BImode:
      if (!vpr_register_operand (operands[0], E_V4BImode)
          || GET_MODE (x3) != E_V4BImode
          || !vpr_register_operand (operands[2], E_V4BImode)
          || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3780; /* mve_vctp32q_mv4bi */

    case E_V2QImode:
      if (!vpr_register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !vpr_register_operand (operands[2], E_V2QImode)
          || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3781; /* mve_vctp64q_mv2qi */

    default:
      return -1;
    }
}

 int
recog_149 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern162 (x1, 
E_EImode) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_BLKmode:
      if (!neon_struct_operand (operands[1], E_BLKmode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5784 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2862; /* neon_vld3_dupv8qi */

        case E_V4HImode:
          if (!
#line 5784 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2863; /* neon_vld3_dupv4hi */

        case E_V4HFmode:
          if (!
#line 5784 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2864; /* neon_vld3_dupv4hf */

        case E_V4BFmode:
          if (!(
#line 5784 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2865; /* neon_vld3_dupv4bf */

        case E_V2SImode:
          if (!
#line 5784 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2866; /* neon_vld3_dupv2si */

        case E_V2SFmode:
          if (!
#line 5784 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2867; /* neon_vld3_dupv2sf */

        default:
          return -1;
        }

    case E_EImode:
      if (!neon_struct_operand (operands[1], E_EImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_DImode
          || !
#line 5784 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2868; /* neon_vld3_dupdi */

    default:
      return -1;
    }
}

 int
recog_157 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0
          || !
#line 1351 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1435; /* neon_vpadd_internalv8qi */

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0
          || !
#line 1351 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1436; /* neon_vpadd_internalv4hi */

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0
          || !
#line 1351 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1437; /* neon_vpadd_internalv2si */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 1351 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1438; /* neon_vpadd_internalv2sf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 1366 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1439; /* neon_vpaddv4hf */

    default:
      return -1;
    }
}

 int
recog_165 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2346; /* neon_vrshru_nv8qi */

    case 1:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2350; /* neon_vrshru_nv16qi */

    case 2:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2354; /* neon_vrshru_nv4hi */

    case 3:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2358; /* neon_vrshru_nv8hi */

    case 4:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2362; /* neon_vrshru_nv2si */

    case 5:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2366; /* neon_vrshru_nv4si */

    case 6:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2370; /* neon_vrshru_ndi */

    case 7:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2374; /* neon_vrshru_nv2di */

    default:
      return -1;
    }
}

 int
recog_175 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2280; /* neon_vshluv8qi */

    case 1:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2284; /* neon_vshluv16qi */

    case 2:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2288; /* neon_vshluv4hi */

    case 3:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2292; /* neon_vshluv8hi */

    case 4:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2296; /* neon_vshluv2si */

    case 5:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2300; /* neon_vshluv4si */

    case 6:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2304; /* neon_vshludi */

    case 7:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2308; /* neon_vshluv2di */

    default:
      return -1;
    }
}

 int
recog_185 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1508; /* neon_vqaddsv8qi */

    case 1:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1510; /* neon_vqaddsv16qi */

    case 2:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1512; /* neon_vqaddsv4hi */

    case 3:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1514; /* neon_vqaddsv8hi */

    case 4:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1516; /* neon_vqaddsv2si */

    case 5:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1518; /* neon_vqaddsv4si */

    case 6:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1520; /* neon_vqaddsdi */

    case 7:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1522; /* neon_vqaddsv2di */

    default:
      return -1;
    }
}

 int
recog_196 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern131 (x1))
    {
    case 0:
      if (!
#line 939 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1383; /* ashlv8qi3_signed */

    case 1:
      if (!
#line 939 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1384; /* ashlv16qi3_signed */

    case 2:
      if (!
#line 939 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1385; /* ashlv4hi3_signed */

    case 3:
      if (!
#line 939 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1386; /* ashlv8hi3_signed */

    case 4:
      if (!
#line 939 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1387; /* ashlv2si3_signed */

    case 5:
      if (!
#line 939 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1388; /* ashlv4si3_signed */

    case 6:
      if (!
#line 939 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1389; /* ashlv2di3_signed */

    default:
      return -1;
    }
}

 int
recog_207 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern147 (x1))
    {
    case 0:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1885; /* neon_vpadalsv8qi */

    case 1:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1887; /* neon_vpadalsv16qi */

    case 2:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1889; /* neon_vpadalsv4hi */

    case 3:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1891; /* neon_vpadalsv8hi */

    case 4:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1893; /* neon_vpadalsv2si */

    case 5:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1895; /* neon_vpadalsv4si */

    default:
      return -1;
    }
}

 int
recog_217 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1486; /* neon_vhaddsv8qi */

    case 1:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1490; /* neon_vhaddsv16qi */

    case 2:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1494; /* neon_vhaddsv4hi */

    case 3:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1498; /* neon_vhaddsv8hi */

    case 4:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1502; /* neon_vhaddsv2si */

    case 5:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1506; /* neon_vhaddsv4si */

    default:
      return -1;
    }
}

 int
recog_228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 2516 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1759; /* neon_vcalev2sf_insn_unspec */

    case 1:
      if (!
#line 2516 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1763; /* neon_vcalev4sf_insn_unspec */

    case 2:
      if (!
#line 2557 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1775; /* neon_vcalev8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2557 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1779; /* neon_vcalev4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_238 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern132 (x1))
    {
    case 0:
      if (!
#line 1389 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1444; /* neon_vpsmaxv8qi */

    case 1:
      if (!
#line 1389 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1445; /* neon_vpsmaxv4hi */

    case 2:
      if (!
#line 1389 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1446; /* neon_vpsmaxv2si */

    case 3:
      if (!
#line 1389 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1447; /* neon_vpsmaxv2sf */

    default:
      return -1;
    }
}

 int
recog_248 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern232 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 3480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4895; /* mve_vldrq_gather_offset_z_v16qi */

    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4896; /* mve_vldrq_gather_offset_z_v8hi */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4897; /* mve_vldrq_gather_offset_z_v4si */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8HFmode) != 0
          || !
#line 3480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4898; /* mve_vldrq_gather_offset_z_v8hf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V4BImode, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 3480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4899; /* mve_vldrq_gather_offset_z_v4sf */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V2QImode, 
E_V2DImode) != 0
          || !
#line 3480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4900; /* mve_vldrq_gather_offset_z_v2di */

    default:
      return -1;
    }
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_ccde2_operand (operands[4], E_SImode))
    return -1;
  switch (pattern426 (x3))
    {
    case 0:
      if (!
#line 4562 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 145; /* arm_cx2asi */

    case 1:
      if (!
#line 4562 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 146; /* arm_cx2adi */

    default:
      return -1;
    }
}

 int
recog_268 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != PC)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != NEG
          || GET_MODE (x7) != E_SImode)
        return -1;
      operands[0] = x5;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      x10 = XEXP (x9, 0);
      operands[3] = x10;
      if (!
#line 1308 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 977; /* *negated_cbranchsi4 */

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x5;
      x12 = XEXP (x6, 0);
      operands[1] = x12;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      x10 = XEXP (x9, 0);
      operands[3] = x10;
      if (XWINT (x11, 0) == 1L)
        {
          x13 = XEXP (x6, 2);
          operands[2] = x13;
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 1347 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            {
              *pnum_clobbers = 1;
              return 978; /* *tbit_cbranch */
            }
        }
      x13 = XEXP (x6, 2);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 1392 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      *pnum_clobbers = 1;
      return 979; /* *tlobits_cbranch */

    case AND:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[3] = x5;
      x12 = XEXP (x6, 0);
      operands[0] = x12;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x6, 1);
      operands[1] = x11;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      if (!
#line 1435 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 980; /* *tstsi3_cbranch */

    default:
      return -1;
    }
}

 int
recog_275 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!arm_general_register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 2);
  operands[3] = x5;
  if (!reg_or_zero_operand (operands[3], E_SImode))
    return -1;
  switch (GET_CODE (x4))
    {
    case NOT:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_COND_ARITH))
        return -1;
      return 1040; /* *thumb2_csinv */

    case PLUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 981 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_COND_ARITH))
        return -1;
      return 1041; /* *thumb2_csinc */

    case NEG:
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 995 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_COND_ARITH))
        return -1;
      return 1042; /* *thumb2_csneg */

    default:
      return -1;
    }
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      res = recog_269 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (arm_comparison_operator (x3, E_VOIDmode))
    {
      res = recog_274 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[1] = x3;
  if (arm_comparison_operation (operands[1], E_VOIDmode))
    {
      res = recog_275 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      res = recog_276 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL
      && pattern269 (x1) == 0
      && 
#line 10807 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
    {
      *pnum_clobbers = 1;
      return 351; /* movcond */
    }
  operands[3] = x3;
  if (arm_comparison_operator (operands[3], E_VOIDmode))
    {
      res = recog_277 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (pnum_clobbers != NULL
      && pattern269 (x1) == 0
      && 
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
    {
      *pnum_clobbers = 1;
      return 1043; /* *thumb2_movcond */
    }
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != LABEL_REF)
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  operands[0] = x3;
  x8 = XEXP (x3, 0);
  operands[1] = x8;
  if (s_register_operand (operands[1], E_SImode))
    {
      if (equality_operator (operands[0], E_VOIDmode)
          && x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x9 = XEXP (x5, 0);
          operands[2] = x9;
          if (
#line 1108 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && TARGET_HAVE_CBZ))
            return 974; /* thumb1_cbz */
        }
      if (arm_comparison_operator (operands[0], E_VOIDmode))
        {
          operands[2] = x4;
          if (thumb1_cmp_operand (operands[2], E_SImode))
            {
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (
#line 1191 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return 975; /* cbranchsi4_insn */
            }
        }
    }
  if (pnum_clobbers == NULL
      || !s_register_operand (x8, E_SImode))
    return -1;
  operands[1] = x8;
  operands[4] = x3;
  if (arm_comparison_operator (operands[4], E_VOIDmode))
    {
      operands[2] = x4;
      if (thumb1_cmpneg_operand (operands[2], E_SImode))
        {
          x9 = XEXP (x5, 0);
          operands[3] = x9;
          if (
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            {
              *pnum_clobbers = 1;
              return 976; /* cbranchsi4_scratch */
            }
        }
    }
  operands[0] = x8;
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XEXP (x5, 0);
  operands[1] = x9;
  switch (GET_CODE (x3))
    {
    case EQ:
      if (!
#line 1467 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1064; /* *thumb2_cbz */

    case NE:
      if (!
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1065; /* *thumb2_cbnz */

    default:
      return -1;
    }
}

 int
recog_281 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      switch (XINT (x3, 1))
        {
        case 378:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1940; /* neon_vcmla0v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1944; /* neon_vcmla0v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4233; /* mve_vcmlaq_fv8hf */

            case 2:
              if (!
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1948; /* neon_vcmla0v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1952; /* neon_vcmla0v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4237; /* mve_vcmlaq_fv4sf */

            default:
              return -1;
            }

        case 379:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1941; /* neon_vcmla90v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1945; /* neon_vcmla90v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4234; /* mve_vcmlaq_rot90_fv8hf */

            case 2:
              if (!
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1949; /* neon_vcmla90v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1953; /* neon_vcmla90v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4238; /* mve_vcmlaq_rot90_fv4sf */

            default:
              return -1;
            }

        case 380:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1942; /* neon_vcmla180v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1946; /* neon_vcmla180v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4235; /* mve_vcmlaq_rot180_fv8hf */

            case 2:
              if (!
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1950; /* neon_vcmla180v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1954; /* neon_vcmla180v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4239; /* mve_vcmlaq_rot180_fv4sf */

            default:
              return -1;
            }

        case 381:
          switch (pattern463 (x2))
            {
            case 0:
              if (!(
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1943; /* neon_vcmla270v4hf */

            case 1:
              if (register_operand (operands[0], E_V8HFmode)
                  && register_operand (operands[1], E_V8HFmode)
                  && register_operand (operands[2], E_V8HFmode)
                  && register_operand (operands[3], E_V8HFmode)
                  && (
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return 1947; /* neon_vcmla270v8hf */
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || !reg_or_zero_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode)
                  || !s_register_operand (operands[3], E_V8HFmode)
                  || !
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4236; /* mve_vcmlaq_rot270_fv8hf */

            case 2:
              if (!
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1951; /* neon_vcmla270v2sf */

            case 3:
              if (register_operand (operands[0], E_V4SFmode)
                  && register_operand (operands[1], E_V4SFmode)
                  && register_operand (operands[2], E_V4SFmode)
                  && register_operand (operands[3], E_V4SFmode)
                  && 
#line 2902 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return 1955; /* neon_vcmla270v4sf */
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || !reg_or_zero_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode)
                  || !s_register_operand (operands[3], E_V4SFmode)
                  || !
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 4240; /* mve_vcmlaq_rot270_fv4sf */

            default:
              return -1;
            }

        case 370:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              if (pattern484 (x2, 
E_V4BFmode, 
E_V2SFmode) != 0
                  || !
#line 6646 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                return -1;
              return 3027; /* neon_vbfdotv2sf */

            case E_V4SFmode:
              if (pattern484 (x2, 
E_V8BFmode, 
E_V4SFmode) != 0
                  || !
#line 6646 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                return -1;
              return 3028; /* neon_vbfdotv4sf */

            default:
              return -1;
            }

        case 394:
          if (pattern464 (x2) != 0
              || !
#line 6770 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3042; /* neon_vmmlav8bf */

        case 395:
          if (pattern464 (x2) != 0
              || !
#line 6781 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3043; /* neon_vfmabv8bf */

        case 396:
          if (pattern464 (x2) != 0
              || !
#line 6781 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3044; /* neon_vfmatv8bf */

        default:
          return -1;
        }

    case 3:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[4] = x6;
      switch (XINT (x3, 1))
        {
        case 378:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1956; /* neon_vcmla_lane0v4hf */

            case 1:
              if (!
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1976; /* neon_vcmla_laneq0v4hf */

            case 2:
              if (!(
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1960; /* neon_vcmla_lane0v8hf */

            case 3:
              if (!
#line 2944 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1980; /* neon_vcmlaq_lane0v8hf */

            case 4:
              if (!
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1964; /* neon_vcmla_lane0v2sf */

            case 5:
              if (!
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1972; /* neon_vcmla_laneq0v2sf */

            case 6:
              if (!
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1968; /* neon_vcmla_lane0v4sf */

            case 7:
              if (!
#line 2944 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1984; /* neon_vcmlaq_lane0v4sf */

            default:
              return -1;
            }

        case 379:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1957; /* neon_vcmla_lane90v4hf */

            case 1:
              if (!
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1977; /* neon_vcmla_laneq90v4hf */

            case 2:
              if (!(
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1961; /* neon_vcmla_lane90v8hf */

            case 3:
              if (!
#line 2944 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1981; /* neon_vcmlaq_lane90v8hf */

            case 4:
              if (!
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1965; /* neon_vcmla_lane90v2sf */

            case 5:
              if (!
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1973; /* neon_vcmla_laneq90v2sf */

            case 6:
              if (!
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1969; /* neon_vcmla_lane90v4sf */

            case 7:
              if (!
#line 2944 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1985; /* neon_vcmlaq_lane90v4sf */

            default:
              return -1;
            }

        case 380:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1958; /* neon_vcmla_lane180v4hf */

            case 1:
              if (!
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1978; /* neon_vcmla_laneq180v4hf */

            case 2:
              if (!(
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1962; /* neon_vcmla_lane180v8hf */

            case 3:
              if (!
#line 2944 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1982; /* neon_vcmlaq_lane180v8hf */

            case 4:
              if (!
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1966; /* neon_vcmla_lane180v2sf */

            case 5:
              if (!
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1974; /* neon_vcmla_laneq180v2sf */

            case 6:
              if (!
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1970; /* neon_vcmla_lane180v4sf */

            case 7:
              if (!
#line 2944 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1986; /* neon_vcmlaq_lane180v4sf */

            default:
              return -1;
            }

        case 381:
          switch (pattern485 (x2))
            {
            case 0:
              if (!(
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1959; /* neon_vcmla_lane270v4hf */

            case 1:
              if (!
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1979; /* neon_vcmla_laneq270v4hf */

            case 2:
              if (!(
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
                return -1;
              return 1963; /* neon_vcmla_lane270v8hf */

            case 3:
              if (!
#line 2944 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1983; /* neon_vcmlaq_lane270v8hf */

            case 4:
              if (!
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1967; /* neon_vcmla_lane270v2sf */

            case 5:
              if (!
#line 2929 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1975; /* neon_vcmla_laneq270v2sf */

            case 6:
              if (!
#line 2914 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1971; /* neon_vcmla_lane270v4sf */

            case 7:
              if (!
#line 2944 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
                return -1;
              return 1987; /* neon_vcmlaq_lane270v4sf */

            default:
              return -1;
            }

        case 370:
          if (!immediate_operand (operands[4], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              switch (pattern534 (x2, 
E_V4BFmode, 
E_V2SFmode))
                {
                case 0:
                  if (!
#line 6659 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3029; /* neon_vbfdot_lanev4bfv2sf */

                case 1:
                  if (!
#line 6672 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3031; /* neon_vbfdot_lanev8bfv2sf */

                default:
                  return -1;
                }

            case E_V4SFmode:
              switch (pattern534 (x2, 
E_V8BFmode, 
E_V4SFmode))
                {
                case 0:
                  if (!
#line 6659 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3030; /* neon_vbfdot_lanev4bfv4sf */

                case 1:
                  if (!
#line 6672 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 3032; /* neon_vbfdot_lanev8bfv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 395:
          if (pattern486 (x2) != 0
              || !
#line 6793 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3045; /* neon_vfmab_lanev8bf */

        case 396:
          if (pattern486 (x2) != 0
              || !
#line 6793 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3046; /* neon_vfmat_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_292 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!nonmemory_operand (operands[2], E_SImode)
          || !
#line 66 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 942; /* *thumb1_addsi3 */

    case MINUS:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!reg_or_int_operand (operands[2], E_SImode)
          || !
#line 146 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 944; /* thumb1_subsi3_insn */

    case AND:
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 192 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 947; /* *thumb1_andsi3_insn */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!arm_comparison_operator (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!cc_register (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          if (!s_register_operand (operands[3], E_SImode)
              || !
#line 618 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          return 1032; /* *thumb2_and_scc */

        default:
          return -1;
        }

    case IOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          if (!register_operand (operands[1], E_SImode)
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 949; /* *thumb1_iorsi3_insn */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!arm_comparison_operator (x3, E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          if (!cc_register (x6, E_VOIDmode))
            return -1;
          operands[2] = x6;
          operands[1] = x3;
          x4 = XEXP (x2, 1);
          operands[3] = x4;
          if (s_register_operand (operands[3], E_SImode)
              && 
#line 646 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it))
            return 1033; /* *thumb2_ior_scc */
          operands[3] = x6;
          operands[2] = x3;
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 677 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it))
            return -1;
          return 1034; /* *thumb2_ior_scc_strict_it */

        default:
          return -1;
        }

    case XOR:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 264 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 950; /* *thumb1_xorsi3_insn */

    default:
      return -1;
    }
}

 int
recog_295 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  if (register_operand (operands[0], E_SImode))
    {
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (register_operand (operands[1], E_V8QImode)
              && 
#line 725 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 588; /* iwmmxt_textrmub */
          break;

        case E_HImode:
          if (register_operand (operands[1], E_V4HImode)
              && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 590; /* iwmmxt_textrmuh */
          break;

        default:
          break;
        }
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  switch (pattern469 (x3))
    {
    case 0:
      if (!
#line 3252 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2044; /* neon_vget_lanev8qi_zext_internal */

    case 1:
      if (
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2053; /* neon_vget_lanev16qi_zext_internal */
      if (!
#line 4212 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))))
        return -1;
      return 5020; /* *mve_vec_extract_zext_internalv16qi */

    case 2:
      if (!
#line 3252 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2045; /* neon_vget_lanev4hi_zext_internal */

    case 3:
      if (
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2054; /* neon_vget_lanev8hi_zext_internal */
      if (!
#line 4212 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 5021; /* *mve_vec_extract_zext_internalv8hi */

    case 4:
      if (!
#line 3252 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2046; /* neon_vget_lanev2si_zext_internal */

    case 5:
      if (
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return 2056; /* neon_vget_lanev4si_zext_internal */
      if (!
#line 4212 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
        return -1;
      return 5022; /* *mve_vec_extract_zext_internalv4si */

    case 6:
      if (!
#line 3252 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2047; /* neon_vget_lanev2sf_zext_internal */

    case 7:
      if (!
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2057; /* neon_vget_lanev4sf_zext_internal */

    case 8:
      if (!
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2055; /* neon_vget_lanev8hf_zext_internal */

    default:
      return -1;
    }
}

 int
recog_298 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFTRT
      || GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_TImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_CONCAT
      || GET_MODE (x5) != E_V16QImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != MULT
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != ZERO_EXTRACT
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x9 = XEXP (x7, 2);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x6, 1);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
      || !register_operand (operands[0], E_V8QImode))
    return -1;
  x11 = XEXP (x5, 0);
  operands[1] = x11;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x12 = XEXP (x5, 1);
  operands[2] = x12;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  x13 = XEXP (x7, 0);
  operands[3] = x13;
  if (register_operand (operands[3], E_SImode)
      && 
#line 1656 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
    return 678; /* iwmmxt_walignr */
  if (GET_CODE (x13) != REG
      || GET_MODE (x13) != E_SImode)
    return -1;
  switch (REGNO (x13))
    {
    case 96:
      if (!
#line 1671 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 679; /* iwmmxt_walignr0 */

    case 97:
      if (!
#line 1686 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 680; /* iwmmxt_walignr1 */

    case 98:
      if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 681; /* iwmmxt_walignr2 */

    case 99:
      if (!
#line 1716 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 682; /* iwmmxt_walignr3 */

    default:
      return -1;
    }
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == ZERO_EXTRACT
          && GET_MODE (x3) == E_SImode)
        {
          x4 = XEXP (x3, 0);
          operands[0] = x4;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (XWINT (x2, 0) == 0L)
                {
                  x5 = XEXP (x3, 1);
                  operands[1] = x5;
                  if (const_int_M_operand (operands[1], E_SImode))
                    {
                      x6 = XEXP (x3, 2);
                      operands[2] = x6;
                      if (const_int_M_operand (operands[2], E_SImode)
                          && 
#line 3500 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch_thumb2))
                        return 98; /* insv_zero */
                    }
                }
              x5 = XEXP (x3, 1);
              if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 16])
                {
                  x6 = XEXP (x3, 2);
                  if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 16])
                    {
                      operands[1] = x2;
                      if (const_int_operand (operands[1], E_SImode)
                          && 
#line 12371 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_HAVE_MOVT))
                        return 410; /* *arm_movtas_ze */
                    }
                }
            }
        }
      break;

    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTRACT:
          if (pattern247 (x3) == 0)
            {
              operands[3] = x2;
              if (s_register_operand (operands[3], E_SImode)
                  && 
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch_thumb2))
                return 99; /* insv_t2 */
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x3;
          if (nonimmediate_soft_df_operand (operands[0], E_DFmode))
            {
              operands[1] = x2;
              if (soft_df_operand (operands[1], E_DFmode)
                  && 
#line 7627 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
                return 271; /* *movdf_soft_insn */
            }
          break;

        case PC:
          operands[0] = x2;
          if (s_register_operand (operands[0], E_SImode)
              && 
#line 9629 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 315; /* *arm_indirect_jump */
          if (memory_operand (operands[0], E_SImode)
              && 
#line 9638 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 316; /* *load_indirect_jump */
          if (register_operand (operands[0], E_SImode))
            {
              if (
#line 2018 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return 1000; /* *thumb1_indirect_jump */
              if (
#line 604 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1031; /* *thumb2_indirect_jump */
            }
          break;

        default:
          break;
        }
      break;

    case LABEL_REF:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == PC)
        {
          x7 = XEXP (x2, 0);
          operands[0] = x7;
          if (
#line 8591 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 288; /* *arm_jump */
          if (
#line 1845 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 990; /* *thumb_jump */
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (nonimmediate_di_operand (operands[0], E_DImode)
          && di_operand (operands[1], E_DImode)
          && 
#line 6345 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !(TARGET_HARD_FLOAT)
   && !(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT)
   && !TARGET_IWMMXT
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
        return 255; /* *arm_movdi */
      break;

    case E_SImode:
      if (nonimmediate_operand (operands[0], E_SImode)
          && general_operand (operands[1], E_SImode)
          && 
#line 6557 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
        return 257; /* *arm_movsi_insn */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode)
          && 
#line 7212 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM
   && arm_arch4 && !TARGET_HARD_FLOAT
   && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
        return 265; /* *movhi_insn_arch4 */
      if (s_register_operand (operands[0], E_HImode)
          && arm_rhs_operand (operands[1], E_HImode)
          && 
#line 7239 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_HARD_FLOAT))
        return 266; /* *movhi_bytes */
      break;

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && general_operand (operands[1], E_QImode)
          && 
#line 7356 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (   register_operand (operands[0], QImode)
       || register_operand (operands[1], QImode))))
        return 267; /* *arm_movqi_insn */
      break;

    case E_HFmode:
      if (nonimmediate_operand (operands[0], E_HFmode)
          && general_operand (operands[1], E_HFmode)
          && 
#line 7403 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
        return 268; /* *arm32_movhf */
      break;

    case E_BFmode:
      if (nonimmediate_operand (operands[0], E_BFmode)
          && general_operand (operands[1], E_BFmode)
          && 
#line 7403 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
        return 269; /* *arm32_movbf */
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode)
          && general_operand (operands[1], E_SFmode)
          && 
#line 7502 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE
   && (!MEM_P (operands[0])
       || register_operand (operands[1], SFmode))))
        return 270; /* *arm_movsf_soft_insn */
      break;

    default:
      break;
    }
  operands[0] = x3;
  if (cc_register (operands[0], E_VOIDmode)
      && rtx_equal_p (x2, operands[0])
      && 
#line 7942 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return 276; /* *deleted_compare */
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (nonimmediate_di_operand (operands[0], E_DImode)
          && di_operand (operands[1], E_DImode))
        {
          if (
#line 103 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
            return 537; /* *iwmmxt_arm_movdi */
          if (
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_VFP_BASE
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))
   && !((TARGET_NEON || TARGET_HAVE_MVE) && CONST_INT_P (operands[1])
       && simd_immediate_valid_for_move (operands[1], DImode, NULL, NULL))))
            return 767; /* *movdi_vfp */
        }
      break;

    case E_V2SImode:
      if (nonimmediate_operand (operands[0], E_V2SImode)
          && general_operand (operands[1], E_V2SImode)
          && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 540; /* movv2si_internal */
      break;

    case E_V4HImode:
      if (nonimmediate_operand (operands[0], E_V4HImode)
          && general_operand (operands[1], E_V4HImode)
          && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 541; /* movv4hi_internal */
      break;

    case E_V8QImode:
      if (nonimmediate_operand (operands[0], E_V8QImode)
          && general_operand (operands[1], E_V8QImode)
          && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 542; /* movv8qi_internal */
      break;

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode))
        {
          if (
#line 29 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 753; /* *arm_movhi_vfp */
          if (
#line 80 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 754; /* *thumb2_movhi_vfp */
          if (
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 759; /* *arm_movhi_fp16 */
          if (
#line 185 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 760; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V16BImode:
      if (nonimmediate_operand (operands[0], E_V16BImode)
          && general_operand (operands[1], E_V16BImode))
        {
          if (
#line 80 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))))
            return 755; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode))))
            return 761; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V8BImode:
      if (nonimmediate_operand (operands[0], E_V8BImode)
          && general_operand (operands[1], E_V8BImode))
        {
          if (
#line 80 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))))
            return 756; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode))))
            return 762; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V4BImode:
      if (nonimmediate_operand (operands[0], E_V4BImode)
          && general_operand (operands[1], E_V4BImode))
        {
          if (
#line 80 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode))))
            return 757; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode))))
            return 763; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_V2QImode:
      if (nonimmediate_operand (operands[0], E_V2QImode)
          && general_operand (operands[1], E_V2QImode))
        {
          if (
#line 80 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode))))
            return 758; /* *thumb2_movhi_vfp */
          if (
#line 185 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode))))
            return 764; /* *thumb2_movhi_fp16 */
        }
      break;

    case E_HFmode:
      if (nonimmediate_operand (operands[0], E_HFmode)
          && general_operand (operands[1], E_HFmode))
        {
          if (
#line 407 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
            return 768; /* *movhf_vfp_hf16 */
          if (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT && TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
            return 770; /* *movhf_vfp_neon */
          if (
#line 544 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT
   && !TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
            return 772; /* *movhf_vfp */
        }
      break;

    case E_BFmode:
      if (nonimmediate_operand (operands[0], E_BFmode)
          && general_operand (operands[1], E_BFmode))
        {
          if (
#line 407 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
            return 769; /* *movbf_vfp_bf16 */
          if (
#line 488 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT && TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
            return 771; /* *movbf_vfp_neon */
          if (
#line 544 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && TARGET_HARD_FLOAT
   && !TARGET_NEON_FP16
   && !TARGET_VFP_FP16INST
   && (   s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode))))
            return 773; /* *movbf_vfp */
        }
      break;

    case E_SFmode:
      if (nonimmediate_operand (operands[0], E_SFmode))
        {
          if (general_operand (operands[1], E_SFmode)
              && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode))))
            return 774; /* *movsf_vfp */
          if (hard_sf_operand (operands[1], E_SFmode)
              && 
#line 636 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode))))
            return 775; /* *thumb2_movsf_vfp */
        }
      break;

    case E_DFmode:
      if (nonimmediate_soft_df_operand (operands[0], E_DFmode))
        {
          if (soft_df_operand (operands[1], E_DFmode)
              && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
            return 776; /* *movdf_vfp */
          if (hard_df_operand (operands[1], E_DFmode)
              && 
#line 725 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
            return 777; /* *thumb2_movdf_vfp */
        }
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case MEM:
      if (pattern248 (x2, 
8) == 0
          && register_operand (operands[0], E_SImode))
        {
          x7 = XEXP (x2, 0);
          x8 = XVECEXP (x7, 0, 0);
          operands[1] = x8;
          if (register_operand (operands[1], E_SImode))
            {
              x9 = XVECEXP (x7, 0, 2);
              operands[2] = x9;
              if (
#line 6771 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 263; /* tls_load_dot_plus_eight */
            }
        }
      break;

    case CONST_VECTOR:
      res = recog_297 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SUBREG:
      res = recog_298 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (nonimmediate_operand (operands[0], E_SImode))
    {
      operands[1] = x2;
      if (general_operand (operands[1], E_SImode))
        {
          if (
#line 158 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
            return 538; /* *iwmmxt_movsi_insn */
          if (
#line 238 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SImode)
       || s_register_operand (operands[1], SImode))))
            return 765; /* *arm_movsi_vfp */
          if (
#line 283 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SImode)
       || s_register_operand (operands[1], SImode))))
            return 766; /* *thumb2_movsi_vfp */
        }
    }
  if (GET_CODE (x2) == REG
      && REGNO (x2) == 101
      && GET_CODE (x3) == REG
      && REGNO (x3) == 100
      && 
#line 1637 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
    return 855; /* *movcc_vfp */
  operands[1] = x2;
  res = recog_299 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[0] = x3;
  if (GET_MODE (x2) == E_SImode)
    {
      switch (GET_CODE (x2))
        {
        case REG:
          if (REGNO (x2) == 15
              && s_register_operand (operands[0], E_SImode)
              && 
#line 2075 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 1003; /* *thumb1_movpc_insn */
          break;

        case MEM:
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) == POST_INC
              && GET_MODE (x7) == E_SImode)
            {
              x10 = XEXP (x7, 0);
              if (GET_CODE (x10) == REG
                  && REGNO (x10) == 13
                  && GET_MODE (x10) == E_SImode
                  && low_register_operand (operands[0], E_SImode)
                  && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && (reload_in_progress || reload_completed)))
                return 1013; /* *thumb2_pop_single */
            }
          break;

        default:
          break;
        }
    }
  operands[1] = x2;
  if (general_operand (operands[1], E_SImode)
      && nonimmediate_operand (operands[0], E_SImode)
      && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
    return 1014; /* *thumb2_movsi_insn */
  if (pnum_clobbers != NULL
      && const_int_operand (operands[1], E_SImode)
      && low_register_operand (operands[0], E_SImode)
      && 
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
    {
      *pnum_clobbers = 1;
      return 1056; /* *thumb2_movsi_shortim */
    }
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], E_SImode)
      || GET_CODE (x2) != MEM
      || pattern248 (x2, 
4) != 0)
    return -1;
  x7 = XEXP (x2, 0);
  x8 = XVECEXP (x7, 0, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x7, 0, 2);
  operands[3] = x9;
  if (!
#line 274 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
    return -1;
  *pnum_clobbers = 1;
  return 1015; /* tls_load_dot_plus_four */
}

 int
recog_308 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case NE:
      res = recog_266 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case EQ:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3404; /* mve_vcmpeqq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3412; /* mve_vcmpeqq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3754; /* mve_vcmpeqq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3420; /* mve_vcmpeqq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3760; /* mve_vcmpeqq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3428; /* mve_vcmpeqq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3436; /* mve_vcmpeqq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3766; /* mve_vcmpeqq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3444; /* mve_vcmpeqq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3772; /* mve_vcmpeqq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case GE:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3405; /* mve_vcmpgeq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3413; /* mve_vcmpgeq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3755; /* mve_vcmpgeq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3421; /* mve_vcmpgeq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3761; /* mve_vcmpgeq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3429; /* mve_vcmpgeq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3437; /* mve_vcmpgeq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3767; /* mve_vcmpgeq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3445; /* mve_vcmpgeq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3773; /* mve_vcmpgeq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case GEU:
      switch (pattern236 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3406; /* mve_vcmpcsq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3414; /* mve_vcmpcsq_v8hi */
          break;

        case 2:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3422; /* mve_vcmpcsq_v4si */
          break;

        case 3:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3430; /* mve_vcmpcsq_n_v16qi */
          break;

        case 4:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3438; /* mve_vcmpcsq_n_v8hi */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3446; /* mve_vcmpcsq_n_v4si */
          break;

        default:
          break;
        }
      break;

    case GT:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3407; /* mve_vcmpgtq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3415; /* mve_vcmpgtq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3756; /* mve_vcmpgtq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3423; /* mve_vcmpgtq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3762; /* mve_vcmpgtq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3431; /* mve_vcmpgtq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3439; /* mve_vcmpgtq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3768; /* mve_vcmpgtq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3447; /* mve_vcmpgtq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3774; /* mve_vcmpgtq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case GTU:
      switch (pattern236 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3408; /* mve_vcmphiq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3416; /* mve_vcmphiq_v8hi */
          break;

        case 2:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3424; /* mve_vcmphiq_v4si */
          break;

        case 3:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3432; /* mve_vcmphiq_n_v16qi */
          break;

        case 4:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3440; /* mve_vcmphiq_n_v8hi */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3448; /* mve_vcmphiq_n_v4si */
          break;

        default:
          break;
        }
      break;

    case LE:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3409; /* mve_vcmpleq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3417; /* mve_vcmpleq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3757; /* mve_vcmpleq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3425; /* mve_vcmpleq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3763; /* mve_vcmpleq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3433; /* mve_vcmpleq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3441; /* mve_vcmpleq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3769; /* mve_vcmpleq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3449; /* mve_vcmpleq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3775; /* mve_vcmpleq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    case LT:
      switch (pattern235 (x3))
        {
        case 0:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3410; /* mve_vcmpltq_v16qi */
          break;

        case 1:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3418; /* mve_vcmpltq_v8hi */
          break;

        case 2:
          if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3758; /* mve_vcmpltq_fv8hf */
          break;

        case 3:
          if (
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3426; /* mve_vcmpltq_v4si */
          break;

        case 4:
          if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3764; /* mve_vcmpltq_fv4sf */
          break;

        case 5:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3434; /* mve_vcmpltq_n_v16qi */
          break;

        case 6:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3442; /* mve_vcmpltq_n_v8hi */
          break;

        case 7:
          if (
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3770; /* mve_vcmpltq_n_fv8hf */
          break;

        case 8:
          if (
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3450; /* mve_vcmpltq_n_v4si */
          break;

        case 9:
          if (
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return 3776; /* mve_vcmpltq_n_fv4sf */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  operands[1] = x3;
  if (arm_comparison_operator_mode (operands[1], E_SImode))
    {
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x5 = XEXP (x3, 0);
          operands[2] = x5;
          if (cc_register (operands[2], E_VOIDmode)
              && 
#line 8092 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 279; /* *mov_scc */
        }
    }
  if (pnum_clobbers != NULL
      && arm_comparison_operator (operands[1], E_SImode))
    {
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (s_register_operand (operands[2], E_SImode))
        {
          x4 = XEXP (x3, 1);
          operands[3] = x4;
          if (arm_add_operand (operands[3], E_SImode)
              && 
#line 9952 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            {
              *pnum_clobbers = 1;
              return 336; /* *compare_scc */
            }
        }
    }
  if (GET_CODE (x3) == LTU
      && GET_MODE (x3) == E_SImode)
    {
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (s_register_operand (operands[1], E_SImode))
        {
          x4 = XEXP (x3, 1);
          operands[2] = x4;
          if (thumb1_cmp_operand (operands[2], E_SImode)
              && 
#line 1789 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 988; /* cstoresi_ltu_thumb1 */
        }
    }
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  operands[1] = x3;
  if (!arm_comparison_operator_mode (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[2] = x5;
  if (!cc_register (operands[2], E_VOIDmode)
      || !
#line 326 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
    return -1;
  return 1018; /* *thumb2_mov_scc */
}

 int
recog_317 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      return recog_263 (x1, insn, pnum_clobbers);

    case 1:
      return recog_265 (x1, insn, pnum_clobbers);

    case 2:
      return recog_262 (x1, insn, pnum_clobbers);

    case 4:
      return recog_264 (x1, insn, pnum_clobbers);

    case 5:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (XINT (x2, 1))
        {
        case 103:
          if (!const_int_coproc_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x7 = XVECEXP (x2, 0, 3);
          operands[4] = x7;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x8 = XVECEXP (x2, 0, 4);
          operands[5] = x8;
          if (!const_int_ccde3_operand (operands[5], E_SImode))
            return -1;
          switch (pattern426 (x2))
            {
            case 0:
              if (!
#line 4587 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CDE))
                return -1;
              return 149; /* arm_cx3asi */

            case 1:
              if (!
#line 4587 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CDE))
                return -1;
              return 150; /* arm_cx3adi */

            default:
              return -1;
            }

        case 115:
          switch (pattern302 (x2))
            {
            case 0:
              if (!
#line 446 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 716; /* iwmmxt_wqmiabb */

            case 1:
              if (!
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 717; /* iwmmxt_wqmiabt */

            case 2:
              if (!
#line 472 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 718; /* iwmmxt_wqmiatb */

            case 3:
              if (!
#line 485 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 719; /* iwmmxt_wqmiatt */

            default:
              return -1;
            }

        case 114:
          switch (pattern302 (x2))
            {
            case 0:
              if (!
#line 498 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 720; /* iwmmxt_wqmiabbn */

            case 1:
              if (!
#line 511 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 721; /* iwmmxt_wqmiabtn */

            case 2:
              if (!
#line 524 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 722; /* iwmmxt_wqmiatbn */

            case 3:
              if (!
#line 537 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 723; /* iwmmxt_wqmiattn */

            default:
              return -1;
            }

        case 105:
          if (!const_int_coproc_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          x7 = XVECEXP (x2, 0, 3);
          operands[4] = x7;
          x8 = XVECEXP (x2, 0, 4);
          operands[5] = x8;
          switch (GET_CODE (operands[4]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern512 (x2, 
E_SImode) != 0
                      || !
#line 2251 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
                    return -1;
                  return 939; /* arm_vcx3asi */

                case E_DImode:
                  if (pattern512 (x2, 
E_DImode) != 0
                      || !
#line 2251 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
                    return -1;
                  return 940; /* arm_vcx3adi */

                case E_V16QImode:
                  if (pattern482 (x2) != 0
                      || !register_operand (operands[4], E_V16QImode)
                      || !const_int_mve_cde3_operand (operands[5], E_SImode)
                      || !
#line 4500 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
                    return -1;
                  return 5054; /* arm_vcx3qav16qi */

                default:
                  return -1;
                }

            case CONST_INT:
              if (!const_int_mve_cde2_operand (operands[4], E_SImode)
                  || pattern482 (x2) != 0
                  || !vpr_register_operand (operands[5], E_V16BImode)
                  || !
#line 4528 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
                return -1;
              return 5058; /* arm_vcx2qa_p_v16qi */

            default:
              return -1;
            }

        case 104:
          if (GET_MODE (x2) != E_V16QImode
              || !register_operand (operands[0], E_V16QImode)
              || !const_int_coproc_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V16QImode))
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          operands[3] = x6;
          if (!register_operand (operands[3], E_V16QImode))
            return -1;
          x7 = XVECEXP (x2, 0, 3);
          operands[4] = x7;
          if (!const_int_mve_cde2_operand (operands[4], E_SImode))
            return -1;
          x8 = XVECEXP (x2, 0, 4);
          operands[5] = x8;
          if (!vpr_register_operand (operands[5], E_V16BImode)
              || !
#line 4528 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
            return -1;
          return 5057; /* arm_vcx2q_p_v16qi */

        default:
          return -1;
        }

    case 6:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!const_int_coproc_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      if (!register_operand (operands[4], E_V16QImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[5] = x8;
      if (!const_int_mve_cde3_operand (operands[5], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 5);
      operands[6] = x9;
      if (!vpr_register_operand (operands[6], E_V16BImode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 104:
          if (!
#line 4544 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
            return -1;
          return 5059; /* arm_vcx3q_p_v16qi */

        case 105:
          if (!
#line 4544 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
            return -1;
          return 5060; /* arm_vcx3qa_p_v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode))
        return -1;
      if (
#line 208 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
        return 539; /* *cond_iwmmxt_movsi_insn */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6557 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode)))))
        return -1;
      return 6562; /* *p *arm_movsi_insn */

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode)
          && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7212 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM
   && arm_arch4 && !TARGET_HARD_FLOAT
   && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6565; /* *p *movhi_insn_arch4 */
      if (s_register_operand (operands[0], E_HImode)
          && arm_rhs_operand (operands[1], E_HImode)
          && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7239 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !TARGET_HARD_FLOAT)))
        return 6566; /* *p *movhi_bytes */
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 29 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6887; /* *p *arm_movhi_vfp */
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6888; /* *p *thumb2_movhi_vfp */
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_VFP_FP16INST
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6893; /* *p *arm_movhi_fp16 */
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode)))))
        return 6894; /* *p *thumb2_movhi_fp16 */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
  && (register_operand (operands[0], HImode)
     || register_operand (operands[1], HImode)))))
        return -1;
      return 6978; /* *p *thumb2_movhi_insn */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7356 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (   register_operand (operands[0], QImode)
       || register_operand (operands[1], QImode)))))
        return -1;
      return 6567; /* *p *arm_movqi_insn */

    case E_HFmode:
      if (!nonimmediate_operand (operands[0], E_HFmode)
          || !general_operand (operands[1], E_HFmode))
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7403 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode)))))
        return 6568; /* *p *arm32_movhf */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 407 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode)))))
        return -1;
      return 6902; /* *p *movhf_vfp_hf16 */

    case E_BFmode:
      if (!nonimmediate_operand (operands[0], E_BFmode)
          || !general_operand (operands[1], E_BFmode))
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7403 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !TARGET_HARD_FLOAT
   && !TARGET_HAVE_MVE
   && (	  s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode)))))
        return 6569; /* *p *arm32_movbf */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 407 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT
   && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
   && (s_register_operand (operands[0], BFmode)
       || s_register_operand (operands[1], BFmode)))))
        return -1;
      return 6903; /* *p *movbf_vfp_bf16 */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode))
        return -1;
      if (general_operand (operands[1], E_SFmode))
        {
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7502 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE
   && (!MEM_P (operands[0])
       || register_operand (operands[1], SFmode)))))
            return 6570; /* *p *arm_movsf_soft_insn */
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode)))))
            return 6904; /* *p *movsf_vfp */
        }
      if (!hard_sf_operand (operands[1], E_SFmode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 636 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SFmode)
       || s_register_operand (operands[1], SFmode)))))
        return -1;
      return 6905; /* *p *thumb2_movsf_vfp */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6674; /* *p movv2si_internal */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6675; /* *p movv4hi_internal */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 229 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6676; /* *p movv8qi_internal */

    case E_V16BImode:
      if (!nonimmediate_operand (operands[0], E_V16BImode)
          || !general_operand (operands[1], E_V16BImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode)))))
        return 6889; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V16BImode)
       || register_operand (operands[1], V16BImode)))))
        return -1;
      return 6895; /* *p *thumb2_movhi_fp16 */

    case E_V8BImode:
      if (!nonimmediate_operand (operands[0], E_V8BImode)
          || !general_operand (operands[1], E_V8BImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode)))))
        return 6890; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V8BImode)
       || register_operand (operands[1], V8BImode)))))
        return -1;
      return 6896; /* *p *thumb2_movhi_fp16 */

    case E_V4BImode:
      if (!nonimmediate_operand (operands[0], E_V4BImode)
          || !general_operand (operands[1], E_V4BImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode)))))
        return 6891; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V4BImode)
       || register_operand (operands[1], V4BImode)))))
        return -1;
      return 6897; /* *p *thumb2_movhi_fp16 */

    case E_V2QImode:
      if (!nonimmediate_operand (operands[0], E_V2QImode)
          || !general_operand (operands[1], E_V2QImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 80 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
  && !TARGET_VFP_FP16INST
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode)))))
        return 6892; /* *p *thumb2_movhi_vfp */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 185 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && (TARGET_VFP_FP16INST || TARGET_HAVE_MVE)
  && (register_operand (operands[0], V2QImode)
       || register_operand (operands[1], V2QImode)))))
        return -1;
      return 6898; /* *p *thumb2_movhi_fp16 */

    case E_DImode:
      if (!nonimmediate_di_operand (operands[0], E_DImode)
          || !di_operand (operands[1], E_DImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_VFP_BASE
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))
   && !((TARGET_NEON || TARGET_HAVE_MVE) && CONST_INT_P (operands[1])
       && simd_immediate_valid_for_move (operands[1], DImode, NULL, NULL)))))
        return -1;
      return 6901; /* *p *movdi_vfp */

    case E_DFmode:
      if (!nonimmediate_soft_df_operand (operands[0], E_DFmode)
          || !soft_df_operand (operands[1], E_DFmode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode)))))
        return -1;
      return 6906; /* *p *movdf_vfp */

    default:
      return -1;
    }
}

 int
recog_342 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_DUPLICATE:
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      x9 = XEXP (x4, 2);
      operands[3] = x9;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x10 = XEXP (x5, 0);
      switch (GET_CODE (x10))
        {
        case TRUNCATE:
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern584 (x4, 
E_V8QImode, 
E_QImode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 676 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6719; /* *p iwmmxt_tinsrb */

            case E_V4HImode:
              if (pattern584 (x4, 
E_V4HImode, 
E_HImode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 693 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6720; /* *p iwmmxt_tinsrh */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x10;
          if (!nonimmediate_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_V2SImode)
              || GET_MODE (x4) != E_V2SImode
              || GET_MODE (x5) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 710 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6721; /* *p iwmmxt_tinsrw */

        default:
          return -1;
        }

    case VEC_SELECT:
      x12 = XEXP (x5, 1);
      if (GET_CODE (x12) != PARALLEL)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x13 = XEXP (x8, 1);
      if (GET_CODE (x13) != PARALLEL)
        return -1;
      x9 = XEXP (x4, 2);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      x14 = XEXP (x8, 0);
      operands[2] = x14;
      switch (XVECLEN (x12, 0))
        {
        case 8:
          if (pattern585 (x12) != 0)
            return -1;
          x15 = XVECEXP (x12, 0, 4);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x16 = XVECEXP (x12, 0, 5);
          if (GET_CODE (x16) != CONST_INT)
            return -1;
          x17 = XVECEXP (x12, 0, 6);
          if (GET_CODE (x17) != CONST_INT)
            return -1;
          x18 = XVECEXP (x12, 0, 7);
          if (GET_CODE (x18) != CONST_INT
              || pattern605 (x13, 
8) != 0)
            return -1;
          x19 = XVECEXP (x13, 0, 4);
          if (GET_CODE (x19) != CONST_INT)
            return -1;
          x20 = XVECEXP (x13, 0, 5);
          if (GET_CODE (x20) != CONST_INT)
            return -1;
          x21 = XVECEXP (x13, 0, 6);
          if (GET_CODE (x21) != CONST_INT)
            return -1;
          x22 = XVECEXP (x13, 0, 7);
          if (GET_CODE (x22) != CONST_INT
              || XWINT (x9, 0) != 85L
              || pattern618 (x4, 
E_V8QImode) != 0)
            return -1;
          x23 = XVECEXP (x12, 0, 0);
          switch (XWINT (x23, 0))
            {
            case 4L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 0L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 5L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 1L
                  || XWINT (x15, 0) != 6L
                  || XWINT (x16, 0) != 2L
                  || XWINT (x17, 0) != 7L
                  || XWINT (x18, 0) != 3L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 0L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 4L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 1L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 5L
                  || XWINT (x19, 0) != 2L
                  || XWINT (x20, 0) != 6L
                  || XWINT (x21, 0) != 3L
                  || XWINT (x22, 0) != 7L
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6755; /* *p iwmmxt_wunpckihb */

            case 0L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 4L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 1L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 5L
                  || XWINT (x15, 0) != 2L
                  || XWINT (x16, 0) != 6L
                  || XWINT (x17, 0) != 3L
                  || XWINT (x18, 0) != 7L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 4L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 0L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 5L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 1L
                  || XWINT (x19, 0) != 6L
                  || XWINT (x20, 0) != 2L
                  || XWINT (x21, 0) != 7L
                  || XWINT (x22, 0) != 3L
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1093 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6758; /* *p iwmmxt_wunpckilb */

            default:
              return -1;
            }

        case 4:
          if (pattern585 (x12) != 0
              || pattern605 (x13, 
4) != 0
              || XWINT (x9, 0) != 5L
              || pattern618 (x4, 
E_V4HImode) != 0)
            return -1;
          x23 = XVECEXP (x12, 0, 0);
          switch (XWINT (x23, 0))
            {
            case 2L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 0L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 3L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 1L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 0L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 2L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 1L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 3L
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6756; /* *p iwmmxt_wunpckihh */

            case 0L:
              x24 = XVECEXP (x12, 0, 1);
              if (XWINT (x24, 0) != 2L)
                return -1;
              x25 = XVECEXP (x12, 0, 2);
              if (XWINT (x25, 0) != 1L)
                return -1;
              x26 = XVECEXP (x12, 0, 3);
              if (XWINT (x26, 0) != 3L)
                return -1;
              x27 = XVECEXP (x13, 0, 0);
              if (XWINT (x27, 0) != 2L)
                return -1;
              x28 = XVECEXP (x13, 0, 1);
              if (XWINT (x28, 0) != 0L)
                return -1;
              x29 = XVECEXP (x13, 0, 2);
              if (XWINT (x29, 0) != 3L)
                return -1;
              x30 = XVECEXP (x13, 0, 3);
              if (XWINT (x30, 0) != 1L
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6759; /* *p iwmmxt_wunpckilh */

            default:
              return -1;
            }

        case 2:
          x23 = XVECEXP (x12, 0, 0);
          if (GET_CODE (x23) != CONST_INT)
            return -1;
          x24 = XVECEXP (x12, 0, 1);
          if (GET_CODE (x24) != CONST_INT
              || XVECLEN (x13, 0) != 2)
            return -1;
          x27 = XVECEXP (x13, 0, 0);
          if (GET_CODE (x27) != CONST_INT)
            return -1;
          x28 = XVECEXP (x13, 0, 1);
          if (GET_CODE (x28) != CONST_INT
              || XWINT (x9, 0) != 1L
              || pattern618 (x4, 
E_V2SImode) != 0)
            return -1;
          switch (XWINT (x23, 0))
            {
            case 1L:
              if (XWINT (x24, 0) != 0L
                  || XWINT (x27, 0) != 0L
                  || XWINT (x28, 0) != 1L
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6757; /* *p iwmmxt_wunpckihw */

            case 0L:
              if (XWINT (x24, 0) != 1L
                  || XWINT (x27, 0) != 1L
                  || XWINT (x28, 0) != 0L
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6760; /* *p iwmmxt_wunpckilw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_MINUS:
      if (pattern380 (x1, 
SS_PLUS) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 81 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6827; /* *p iwmmxt_waddsubhx */

    case SS_PLUS:
      if (pattern380 (x1, 
SS_MINUS) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 99 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6828; /* *p iwmmxt_wsubaddhx */

    default:
      return -1;
    }
}

 int
recog_346 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) != E_SImode
          || REGNO (x3) != 100)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[1] = x9;
      if (!arm_add_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
          if (XWINT (x10, 0) == 0L
              && GET_MODE (x3) == E_CC_NZmode
              && GET_MODE (x4) == E_CC_NZmode
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1142 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM)))
            return 6395; /* *p *addsi3_compare0_scratch */
          break;

        case REG:
        case SUBREG:
          if (rtx_equal_p (x10, operands[0])
              && GET_MODE (x3) == E_CC_Cmode
              && GET_MODE (x4) == E_CC_Cmode
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1293 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return 6397; /* *p *compare_addsi2_op0 */
          break;

        default:
          break;
        }
      if (GET_MODE (x3) != E_CC_Cmode
          || GET_MODE (x4) != E_CC_Cmode
          || !rtx_equal_p (x10, operands[1])
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1316 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6398; /* *p *compare_addsi2_op1 */

    case NEG:
      if (GET_MODE (x5) != E_SImode
          || REGNO (x3) != 100
          || GET_MODE (x3) != E_CC_Zmode
          || GET_MODE (x4) != E_CC_Zmode)
        return -1;
      x10 = XEXP (x4, 1);
      if (!s_register_operand (x10, E_SImode))
        return -1;
      x8 = XEXP (x5, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[0] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          operands[1] = x10;
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1157 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6396; /* *p *compare_negsi_si */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[1] = x8;
          if (!shift_operator (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[4] = x6;
          x7 = XEXP (x6, 0);
          operands[5] = x7;
          x11 = XEXP (x8, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x8, 1);
          operands[3] = x12;
          if (!shift_amount_operand (operands[3], E_SImode))
            return -1;
          operands[0] = x10;
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7925 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6572; /* *p *arm_cmpsi_negshiftsi_si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || REGNO (x3) != 100
          || GET_MODE (x3) != E_CC_NZmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (GET_MODE (x4) != E_CC_NZmode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[1] = x9;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x13 = XEXP (x5, 2);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3092 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
  && (INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) < 32
      && INTVAL (operands[1]) > 0 
      && INTVAL (operands[1]) + (INTVAL (operands[2]) & 1) <= 8
      && INTVAL (operands[1]) + INTVAL (operands[2]) <= 32))))
        return -1;
      return 6439; /* *p *zeroextractsi_compare0_scratch */

    case REG:
    case SUBREG:
      operands[0] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
          if (XWINT (x10, 0) == 0L
              && REGNO (x3) == 100
              && GET_MODE (x3) == E_CC_Zmode)
            {
              x6 = XEXP (x1, 0);
              operands[1] = x6;
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (GET_MODE (x4) == E_CC_Zmode
                  && s_register_operand (operands[0], E_QImode)
                  && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5832 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return 6489; /* *p *compareqi_eq0 */
            }
          break;

        case CONST_DOUBLE:
        case REG:
        case SUBREG:
          res = recog_333 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (!s_register_operand (operands[0], E_SImode)
          || REGNO (x3) != 100
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (GET_MODE (x4) != E_CCmode)
        return -1;
      operands[1] = x10;
      if (!arm_add_operand (operands[1], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 7877 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6571; /* *p *arm_cmpsi_insn */

    default:
      return -1;
    }
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5179 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6479; /* *p *arm_negsi2 */

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x4) != E_SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 890 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6909; /* *p *negsf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x4) != E_DFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 901 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6910; /* *p *negdf2_vfp */

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x9 = XEXP (x5, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern524 (x4, 
E_SFmode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6920; /* *p *negmulsf3_vfp */

        case E_DFmode:
          if (pattern524 (x4, 
E_DFmode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6922; /* *p *negmuldf3_vfp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != FIX)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      x7 = XEXP (x1, 0);
      operands[2] = x7;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (GET_MODE (x4))
        {
        case E_SFmode:
          if (!s_register_operand (operands[1], E_SFmode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1512 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6945; /* *p *truncsisf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[1], E_DFmode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1521 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6946; /* *p *truncsidf2_vfp */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x6) != E_SFmode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (GET_MODE (x4) != E_SFmode)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SFmode))
        return -1;
      x10 = XEXP (x6, 1);
      operands[2] = x10;
      if (!const_double_vcvt_power_of_two (operands[2], E_VOIDmode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1895 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math)))
        return -1;
      return 6967; /* *p *combine_vcvtf2i */

    default:
      return -1;
    }
}

 int
recog_367 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (s_register_operand (x4, E_SImode))
    {
      res = recog_366 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC)
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XVECEXP (x7, 0, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 15
      || GET_MODE (x8) != E_SImode)
    return -1;
  switch (XVECLEN (x5, 0))
    {
    case 1:
      x9 = XVECEXP (x5, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XEXP (x1, 0);
      operands[0] = x10;
      x11 = XEXP (x10, 0);
      operands[1] = x11;
      switch (XINT (x5, 1))
        {
        case 116:
          if (XINT (x7, 1) != 116)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2SImode:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 868 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6875; /* *p iwmmxt_tandcv2si3 */

            case E_V4HImode:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 868 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6876; /* *p iwmmxt_tandcv4hi3 */

            case E_V8QImode:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 868 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6877; /* *p iwmmxt_tandcv8qi3 */

            default:
              return -1;
            }

        case 117:
          if (XINT (x7, 1) != 117)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2SImode:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 878 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6878; /* *p iwmmxt_torcv2si3 */

            case E_V4HImode:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 878 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6879; /* *p iwmmxt_torcv4hi3 */

            case E_V8QImode:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 878 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6880; /* *p iwmmxt_torcv8qi3 */

            default:
              return -1;
            }

        case 118:
          if (XINT (x7, 1) != 118)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_V2SImode:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 888 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6881; /* *p iwmmxt_torvscv2si3 */

            case E_V4HImode:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 888 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6882; /* *p iwmmxt_torvscv4hi3 */

            case E_V8QImode:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 888 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6883; /* *p iwmmxt_torvscv8qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x5, 1) != 119)
        return -1;
      x9 = XVECEXP (x5, 0, 0);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XINT (x7, 1) != 119)
        return -1;
      x10 = XEXP (x1, 0);
      operands[1] = x10;
      x11 = XEXP (x10, 0);
      operands[2] = x11;
      x12 = XVECEXP (x5, 0, 1);
      operands[0] = x12;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      switch (GET_MODE (x5))
        {
        case E_V2SImode:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 899 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6884; /* *p iwmmxt_textrcv2si3 */

        case E_V4HImode:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 899 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6885; /* *p iwmmxt_textrcv4hi3 */

        case E_V8QImode:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 899 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6886; /* *p iwmmxt_textrcv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_34 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_37 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_38 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_39 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          res = recog_40 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_41 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          res = recog_42 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[0] = x1;
      if (XVECLEN (operands[0], 0) >= 2)
        {
          res = recog_43 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 4)
        {
          res = recog_44 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 5)
        {
          res = recog_45 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 3)
        {
          res = recog_46 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 2)
        {
          res = recog_47 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 1
          && load_multiple_operation (operands[0], E_VOIDmode))
        {
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) == SET)
            {
              x3 = XEXP (x2, 1);
              if (GET_CODE (x3) == MEM
                  && GET_MODE (x3) == E_SImode)
                {
                  x4 = XEXP (x2, 0);
                  operands[2] = x4;
                  if (s_register_operand (operands[2], E_SImode))
                    {
                      x5 = XEXP (x3, 0);
                      operands[1] = x5;
                      if (s_register_operand (operands[1], E_SImode)
                          && 
#line 12828 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
                        return 494; /* *load_multiple */
                    }
                }
            }
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != PLUS
              || GET_MODE (x3) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != MEM
              || GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x9) != SET)
            return -1;
          x10 = XEXP (x9, 0);
          if (pattern453 (x10) != 0)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x3, 1);
          operands[2] = x11;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x6, 1);
          operands[3] = x12;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          x14 = XEXP (x13, 1);
          operands[5] = x14;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x15 = XEXP (x9, 1);
          operands[4] = x15;
          if (!register_operand (operands[4], E_SImode))
            return -1;
          x16 = XEXP (x8, 0);
          if (!rtx_equal_p (x16, operands[0]))
            return -1;
          x17 = XEXP (x8, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x13, 0);
          if (!rtx_equal_p (x18, operands[0])
              || !
#line 316 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && INTVAL (operands[5]) == INTVAL (operands[2]) + 4))
            return -1;
          return 1017; /* *thumb2_storewb_pairsi */

        case 4:
          if (pattern0 (x1, 
18) != 0
              || pattern257 (x1) != 0)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          if (!mem_noofs_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x6, 1);
          x19 = XVECEXP (x12, 0, 0);
          operands[2] = x19;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x20 = XVECEXP (x12, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x21 = XVECEXP (x1, 0, 3);
          x22 = XEXP (x21, 0);
          operands[4] = x22;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1])
              || !
#line 301 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3095; /* atomic_exchangesi */

        case 2:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x12 = XEXP (x6, 1);
          if (GET_CODE (x12) != UNSPEC_VOLATILE
              || XVECLEN (x12, 0) != 2)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          if (!mem_noofs_operand (operands[1], E_SImode)
              || GET_MODE (x12) != E_SImode)
            return -1;
          x20 = XVECEXP (x12, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          switch (XINT (x12, 1))
            {
            case 18:
              x19 = XVECEXP (x12, 0, 0);
              operands[2] = x19;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 301 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3095; /* atomic_exchangesi */

            case 19:
              x19 = XVECEXP (x12, 0, 0);
              if (GET_MODE (x19) != E_SImode)
                return -1;
              switch (pattern579 (x19))
                {
                case 0:
                  if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3131; /* atomic_fetch_addsi */

                case 1:
                  if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3132; /* atomic_fetch_subsi */

                case 2:
                  if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3133; /* atomic_fetch_orsi */

                case 3:
                  if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3134; /* atomic_fetch_xorsi */

                case 4:
                  if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3135; /* atomic_fetch_andsi */

                case 5:
                  if (!
#line 432 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3143; /* atomic_fetch_nandsi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 5:
          if (pattern0 (x1, 
19) != 0)
            return -1;
          x9 = XVECEXP (x1, 0, 2);
          if (pattern318 (x9, 
E_CCmode, 
100) != 0)
            return -1;
          x21 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x21) != CLOBBER)
            return -1;
          x23 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x23) != CLOBBER)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          if (!mem_noofs_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          x12 = XEXP (x6, 1);
          x19 = XVECEXP (x12, 0, 0);
          if (GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XVECEXP (x12, 0, 1);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x22 = XEXP (x21, 0);
          operands[4] = x22;
          if (!scratch_operand (operands[4], E_SImode))
            return -1;
          x24 = XEXP (x23, 0);
          operands[5] = x24;
          if (!scratch_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          switch (pattern579 (x19))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3131; /* atomic_fetch_addsi */

            case 1:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3132; /* atomic_fetch_subsi */

            case 2:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3133; /* atomic_fetch_orsi */

            case 3:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3134; /* atomic_fetch_xorsi */

            case 4:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3135; /* atomic_fetch_andsi */

            case 5:
              if (!
#line 432 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3143; /* atomic_fetch_nandsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      return recog_376 (x1, insn, pnum_clobbers);

    case RETURN:
      if (!
#line 9022 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && USE_RETURN_INSN (FALSE)))
        return -1;
      return 298; /* *arm_return */

    case SIMPLE_RETURN:
      if (
#line 9083 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
        return 303; /* *arm_simple_return */
      if (
#line 1210 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !IS_CMSE_ENTRY (arm_current_func_type ())))
        return 1049; /* *thumb2_return */
      if (!
#line 1218 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && IS_CMSE_ENTRY (arm_current_func_type ())))
        return -1;
      return 1050; /* *thumb2_cmse_entry_return */

    case UNSPEC_VOLATILE:
      return recog_377 (x1, insn, pnum_clobbers);

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 317; /* nop */

    case TRAP_IF:
      x25 = XEXP (x1, 0);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x26 = XEXP (x1, 1);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 318; /* trap */

    case PREFETCH:
      x25 = XEXP (x1, 0);
      operands[0] = x25;
      if (!address_operand (operands[0], E_SImode))
        return -1;
      x26 = XEXP (x1, 1);
      operands[1] = x26;
      x27 = XEXP (x1, 2);
      operands[2] = x27;
      if (!
#line 12229 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch5te))
        return -1;
      return 402; /* prefetch */

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 4
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 403; /* force_register_use */

    case COND_EXEC:
      x25 = XEXP (x1, 0);
      if (!arm_comparison_operator (x25, E_VOIDmode))
        return -1;
      x28 = XEXP (x25, 1);
      if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x29 = XEXP (x25, 0);
      if (!cc_register (x29, E_VOIDmode))
        return -1;
      x26 = XEXP (x1, 1);
      switch (GET_CODE (x26))
        {
        case SET:
          return recog_375 (x1, insn, pnum_clobbers);

        case PARALLEL:
          if (XVECLEN (x26, 0) == 2)
            {
              res = recog_369 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x26;
          if (XVECLEN (operands[0], 0) >= 2)
            {
              res = recog_370 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 4)
            {
              res = recog_371 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 5)
            {
              res = recog_372 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 3)
            {
              res = recog_373 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) >= 2)
            {
              res = recog_374 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XVECLEN (operands[0], 0) < 1)
            return -1;
          x30 = XVECEXP (x26, 0, 0);
          switch (GET_CODE (x30))
            {
            case SET:
              x31 = XEXP (x30, 1);
              switch (GET_CODE (x31))
                {
                case MEM:
                  if (GET_MODE (x31) != E_SImode)
                    return -1;
                  operands[3] = x25;
                  operands[4] = x29;
                  if (!load_multiple_operation (operands[0], E_VOIDmode))
                    return -1;
                  x32 = XEXP (x30, 0);
                  operands[2] = x32;
                  if (!s_register_operand (operands[2], E_SImode))
                    return -1;
                  x33 = XEXP (x31, 0);
                  operands[1] = x33;
                  if (!s_register_operand (operands[1], E_SImode)
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12828 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed)))
                    return -1;
                  return 6666; /* *p *load_multiple */

                case CONST_INT:
                  if (XWINT (x31, 0) != 0L)
                    return -1;
                  operands[2] = x25;
                  operands[3] = x29;
                  if (!clear_multiple_operation (operands[0], E_VOIDmode))
                    return -1;
                  x32 = XEXP (x30, 0);
                  operands[1] = x32;
                  if (!register_operand (operands[1], E_SImode)
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1711 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse && reload_completed)))
                    return -1;
                  return 6995; /* *p *clear_multiple */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x30, 0) != 1
                  || XINT (x30, 1) != 55)
                return -1;
              x34 = XVECEXP (x30, 0, 0);
              if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              operands[1] = x25;
              operands[2] = x29;
              if (!clear_vfp_multiple_operation (operands[0], E_VOIDmode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1688 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse && reload_completed)))
                return -1;
              return 6957; /* *p *clear_vfp_multiple */

            default:
              return -1;
            }

        case RETURN:
          operands[0] = x25;
          operands[1] = x29;
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9022 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && USE_RETURN_INSN (FALSE))))
            return -1;
          return 6574; /* *p *arm_return */

        case SIMPLE_RETURN:
          operands[0] = x25;
          operands[1] = x29;
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9083 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM)))
            return -1;
          return 6575; /* *p *arm_simple_return */

        case UNSPEC_VOLATILE:
          if (XVECLEN (x26, 0) != 1
              || XINT (x26, 1) != 56)
            return -1;
          x30 = XVECEXP (x26, 0, 0);
          if (GET_CODE (x30) != MEM
              || GET_MODE (x30) != E_BLKmode)
            return -1;
          operands[1] = x25;
          operands[2] = x29;
          x32 = XEXP (x30, 0);
          operands[0] = x32;
          if (!s_register_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1725 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(use_cmse && reload_completed)))
            return -1;
          return 6958; /* *p lazy_store_multiple_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
