/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || !const_double_operand (operands[1], E_DFmode)
          || !s_register_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !s_register_operand (operands[2], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XEXP (x5, 0);
  if (GET_CODE (x9) != MEM
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != MEM
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != PLUS
      || GET_MODE (x14) != E_SImode)
    return -1;
  x15 = XEXP (x14, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x16 = XEXP (x12, 0);
  if (GET_CODE (x16) != MEM
      || GET_MODE (x16) != E_SImode)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != PLUS
      || GET_MODE (x17) != E_SImode)
    return -1;
  x18 = XEXP (x17, 1);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x19 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x19) != SET)
    return -1;
  x20 = XEXP (x19, 1);
  if (GET_CODE (x20) != PLUS
      || GET_MODE (x20) != E_SImode)
    return -1;
  x21 = XEXP (x20, 1);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x22 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x22) != SET)
    return -1;
  x23 = XEXP (x22, 1);
  if (GET_CODE (x23) != PLUS
      || GET_MODE (x23) != E_SImode)
    return -1;
  x24 = XEXP (x23, 1);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  return 0;
}

int
pattern53 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern51 (x3, 
E_V8BImode, 
i1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern51 (x3, 
E_V4BImode, 
i2, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x3, 
E_V16BImode, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x3, 
E_V8BImode, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern51 (x3, 
E_V4BImode, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern54 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern55 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !mve_imm_32 (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!vpr_register_operand (operands[3], E_V4BImode))
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!s_register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern106 (x3); /* [-1, 2] */
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != XOR
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  return 0;
}

int
pattern118 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern117 (x3, 
i1, 
i2); /* [-1, 1] */
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern128 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 2;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 6;

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern40 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern40 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern40 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return 0;

        case E_DImode:
          return 1;

        case E_V16QImode:
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
      if (!const_int_mve_cde1_operand (operands[3], E_SImode)
          || !register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[2], E_V16QImode)
          || !vpr_register_operand (operands[4], E_V16BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern211 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i3)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern216 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern216 (x3, 
E_V16BImode, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern216 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern234 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern148 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern148 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern148 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern248 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 2
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (XINT (x2, 1))
    {
    case 33:
      return pattern250 (x1); /* [-1, 1] */

    case 34:
      res = pattern250 (x1);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case 37:
      res = pattern250 (x1);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case 356:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    case 357:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 8;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    case 359:
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern251 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern251 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern267 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern277 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern277 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || GET_MODE (x2) != E_V4HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!s_register_operand (operands[1], E_V4HImode)
              || !reg_or_zero_operand (operands[2], E_V4HImode))
            return -1;
          return 2;

        case E_V4HFmode:
          if (!s_register_operand (operands[1], E_V4HFmode)
              || !reg_or_zero_operand (operands[2], E_V4HFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!s_register_operand (operands[1], E_V8HImode)
              || !reg_or_zero_operand (operands[2], E_V8HImode))
            return -1;
          return 4;

        case E_V8HFmode:
          if (!s_register_operand (operands[1], E_V8HFmode)
              || !reg_or_zero_operand (operands[2], E_V8HFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!s_register_operand (operands[1], E_V2SImode)
              || !reg_or_zero_operand (operands[2], E_V2SImode))
            return -1;
          return 6;

        case E_V2SFmode:
          if (!s_register_operand (operands[1], E_V2SFmode)
              || !reg_or_zero_operand (operands[2], E_V2SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!s_register_operand (operands[1], E_V4SImode)
              || !reg_or_zero_operand (operands[2], E_V4SImode))
            return -1;
          return 8;

        case E_V4SFmode:
          if (!s_register_operand (operands[1], E_V4SFmode)
              || !reg_or_zero_operand (operands[2], E_V4SFmode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern316 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x6) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x6) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern327 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern332 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !vpr_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern337 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 101
      || GET_MODE (x6) != E_SImode
      || pattern335 (x1) != 0)
    return -1;
  return 0;
}

int
pattern345 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 32L:
      return 0;

    case 16L:
      if (pattern344 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern354 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern359 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!s_register_operand (x3, i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (!s_register_operand (x4, i1))
    return -1;
  return 0;
}

int
pattern368 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern374 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      return 0;

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[4] = x6;
      if (!shift_operator (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x1, 0);
      operands[5] = x7;
      x8 = XEXP (x7, 0);
      operands[6] = x8;
      return 1;

    default:
      return -1;
    }
}

int
pattern389 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern396 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !neon_inv_logic_op2 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern402 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern409 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern419 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode
      || !arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern430 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mve_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i3)
      || !vpr_register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern438 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MULT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern446 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern454 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_MODE (x5) != E_CC_Vmode
      || GET_MODE (x2) != E_CC_Vmode)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern463 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern462 (x1, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (GET_MODE (x1) != E_V8HFmode)
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern462 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (GET_MODE (x1) != E_V4SFmode)
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern478 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern318 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern484 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern493 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != COND_EXEC)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != NE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != COND_EXEC)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != EQ)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 100
      || GET_MODE (x10) != E_CCmode)
    return -1;
  x11 = XEXP (x9, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x8, 1);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XEXP (x12, 0);
  if (!rtx_equal_p (x14, operands[0]))
    return -1;
  return 0;
}

int
pattern515 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !s_register_operand (operands[3], i2)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !arm_low_register_operand (operands[0], E_DImode)
      || !arm_low_register_operand (operands[1], E_DImode)
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern531 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XVECEXP (x9, 0, 2);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return pattern530 (x1); /* [-1, 3] */
}

int
pattern542 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern548 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != i1
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case CLOBBER:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern557 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern563 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern573 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern579 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case MINUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 1;

    case IOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 2;

    case XOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 3;

    case AND:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 4;

    case NOT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != AND
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern608 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[2], i1)
      || !vpr_register_operand (operands[4], i2)
      || !s_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern615 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode)
      || pattern614 (x1) != 0)
    return -1;
  return 0;
}

int
pattern623 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_DImode)
      || !mem_noofs_operand (operands[1], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode
      || !s_register_operand (operands[2], E_DImode)
      || !scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern630 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2SImode)
      || GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V4SImode)
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_V4SImode)
    return -1;
  x7 = XEXP (x1, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != E_V4SImode)
    return -1;
  x10 = XEXP (x7, 1);
  x11 = XEXP (x10, 0);
  if (GET_MODE (x11) != E_V4SImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      return 0;

    case ZERO_EXTEND:
      return 1;

    default:
      return -1;
    }
}

int
pattern641 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 4);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern652 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x9, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  res = recog_4 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  operands[1] = x5;
  operands[3] = x4;
  if (!shift_operator (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x7))
    {
    case SET:
      x8 = XEXP (x7, 1);
      switch (GET_CODE (x8))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (!rtx_equal_p (x8, operands[3]))
            return -1;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!s_register_operand (operands[0], E_SImode)
              || !
#line 4771 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 152; /* *shiftsi3_compare0 */

        default:
          return -1;
        }

    case CLOBBER:
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!scratch_operand (operands[0], E_SImode)
          || !
#line 4785 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 153; /* *shiftsi3_compare0_scratch */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      operands[5] = x5;
      if (!minmax_operator (operands[5], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 100
          || GET_MODE (x6) != E_CCmode)
        return -1;
      operands[4] = x4;
      if (!shiftable_operator (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      if (!arm_rhs_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 4256 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1]) && !arm_restrict_it))
        return -1;
      return 125; /* *minmax_arithsi */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[4] = x5;
      if (!arm_comparison_operator (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 100
          || GET_MODE (x6) != E_CCmode)
        return -1;
      operands[5] = x4;
      if (!shiftable_operator (operands[5], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      if (!arm_rhs_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 10110 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
        return 338; /* *cond_arith */
      if (!
#line 756 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it))
        return -1;
      return 1036; /* *thumb2_cond_arith */

    case REG:
    case SUBREG:
    case MEM:
      operands[2] = x5;
      if (memory_operand (operands[2], E_SImode))
        {
          operands[1] = x4;
          if (shiftable_operator (operands[1], E_SImode))
            {
              x9 = XEXP (x4, 1);
              operands[3] = x9;
              if (memory_operand (operands[3], E_SImode))
                {
                  x6 = XEXP (x2, 0);
                  operands[4] = x6;
                  if (scratch_operand (operands[4], E_SImode)
                      && 
#line 11472 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && adjacent_mem_locations (operands[2], operands[3])))
                    return 380; /* *arith_adjacentmem */
                }
            }
        }
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 100
          || GET_MODE (x6) != E_CCmode)
        return -1;
      operands[3] = x4;
      if (!thumb_16bit_operator (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      if (!s_register_operand (operands[2], E_SImode)
          || !
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && GET_CODE(operands[3]) != PLUS
   && GET_CODE(operands[3]) != MINUS))
        return -1;
      return 1052; /* *thumb2_alusi3_short */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (pattern16 (x3, 
PLUS, 
MEM, 
E_SImode) != 0
      || !s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x2, 0);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 1);
  operands[4] = x10;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x11 = XEXP (x9, 0);
  if (!rtx_equal_p (x11, operands[1])
      || !
#line 12723 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && ((INTVAL (operands[2]) + 4) == INTVAL (operands[4]))
     && (operands_ok_ldrd_strd (operands[0], operands[3],
                                  operands[1], INTVAL (operands[2]),
                                  false, true))))
    return -1;
  return 423; /* *thumb2_ldrd */
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 1);
  if (!s_register_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x4, 1);
  if (!s_register_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x3, 0);
  switch (GET_CODE (x8))
    {
    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      operands[1] = x9;
      if (ldrd_strd_offset_operand (operands[1], E_SImode))
        {
          res = recog_24 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x9, 0) != -4L)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      operands[1] = x6;
      operands[2] = x7;
      x11 = XEXP (x5, 0);
      if (!rtx_equal_p (x11, operands[0])
          || !
#line 12793 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[1], operands[2],
                                  operands[0], -4, false, false))))
        return -1;
      return 428; /* *thumb2_strd_base_neg */

    case REG:
    case SUBREG:
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x11 = XEXP (x5, 0);
      if (GET_CODE (x11) != PLUS
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      operands[1] = x6;
      operands[2] = x7;
      x13 = XEXP (x11, 0);
      if (!rtx_equal_p (x13, operands[0])
          || !
#line 12780 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[1], operands[2],
                                  operands[0], 0, false, false))))
        return -1;
      return 427; /* *thumb2_strd_base */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case PLUS:
      res = recog_11 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MINUS:
      res = recog_12 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case IOR:
      switch (pattern294 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 10494 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_OR_Y)
       != CCmode)))
            return 344; /* *ior_scc_scc */
          break;

        case 1:
          if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3147; /* atomic_or_fetchqi */
            }
          break;

        case 2:
          if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3152; /* atomic_or_fetchhi */
            }
          break;

        case 3:
          if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3157; /* atomic_or_fetchsi */
            }
          break;

        case 4:
          if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3162; /* atomic_or_fetchdi */
            }
          break;

        default:
          break;
        }
      break;

    case AND:
      switch (pattern294 (x1, pnum_clobbers))
        {
        case 0:
          if (
#line 10556 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       != CCmode)))
            return 346; /* *and_scc_scc */
          if (
#line 10624 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       == CCmode)))
            return 348; /* *and_scc_scc_nodom */
          break;

        case 1:
          if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3149; /* atomic_and_fetchqi */
            }
          break;

        case 2:
          if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3154; /* atomic_and_fetchhi */
            }
          break;

        case 3:
          if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3159; /* atomic_and_fetchsi */
            }
          break;

        case 4:
          if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            {
              *pnum_clobbers = 2;
              return 3164; /* atomic_and_fetchdi */
            }
          break;

        default:
          break;
        }
      break;

    case XOR:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern295 (x5, pnum_clobbers) == 0)
        {
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          switch (pattern291 (x1))
            {
            case 0:
              if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                {
                  *pnum_clobbers = 2;
                  return 3148; /* atomic_xor_fetchqi */
                }
              break;

            case 1:
              if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                {
                  *pnum_clobbers = 2;
                  return 3153; /* atomic_xor_fetchhi */
                }
              break;

            case 2:
              if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                {
                  *pnum_clobbers = 2;
                  return 3158; /* atomic_xor_fetchsi */
                }
              break;

            case 3:
              if (
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                {
                  *pnum_clobbers = 2;
                  return 3163; /* atomic_xor_fetchdi */
                }
              break;

            default:
              break;
            }
        }
      break;

    default:
      break;
    }
  if (s_register_operand (operands[0], E_SImode))
    {
      res = recog_13 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x7 = XEXP (x5, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 100
      || GET_MODE (x7) != E_CCmode)
    return -1;
  switch (GET_CODE (x4))
    {
    case PLUS:
    case AND:
      operands[5] = x4;
      if (shiftable_operator_strict_it (operands[5], E_SImode))
        {
          x6 = XEXP (x4, 0);
          if (arm_comparison_operator (x6, E_SImode))
            {
              operands[4] = x6;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x8 = XEXP (x6, 0);
                  operands[2] = x8;
                  if (s_register_operand (operands[2], E_SImode))
                    {
                      x9 = XEXP (x6, 1);
                      operands[3] = x9;
                      if (arm_rhs_operand (operands[3], E_SImode))
                        {
                          x10 = XEXP (x4, 1);
                          operands[1] = x10;
                          if (s_register_operand (operands[1], E_SImode)
                              && 
#line 798 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it))
                            return 1037; /* *thumb2_cond_arith_strict_it */
                        }
                    }
                }
            }
        }
      if (GET_CODE (x4) != PLUS
          || GET_MODE (x4) != E_SImode
          || !low_register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!low_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!low_reg_or_int_operand (operands[2], E_SImode)
          || !
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
        return -1;
      return 1057; /* *thumb2_addsi_short */

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !low_register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!low_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!low_register_operand (operands[2], E_SImode)
          || !
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
        return -1;
      return 1058; /* *thumb2_subsi_short */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || pattern24 (x1) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x6) != CLOBBER
      || pattern641 (x1) != 0)
    return -1;
  x7 = XEXP (x4, 0);
  operands[4] = x7;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  operands[5] = x8;
  if (!scratch_operand (operands[5], E_SImode))
    return -1;
  x9 = XEXP (x6, 0);
  operands[6] = x9;
  if (!scratch_operand (operands[6], E_SImode)
      || pattern653 (x1) != 0
      || !
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
    return -1;
  return 972; /* cpymem12b */
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 0
              || GET_MODE (x3) != E_BLKmode)
            return -1;
          operands[2] = x1;
          if (!multi_register_push (operands[2], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          x5 = XVECEXP (x3, 0, 0);
          operands[1] = x5;
          if (s_register_operand (operands[1], E_SImode)
              && push_mult_memory_operand (operands[0], E_BLKmode))
            return 384; /* *push_multi */
          if (!vfp_register_operand (operands[1], E_DFmode)
              || !memory_operand (operands[0], E_BLKmode)
              || !
#line 2026 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_VFP_BASE))
            return -1;
          return 890; /* *push_multi_vfp */

        case CONST_INT:
          if (XWINT (x3, 0) != 0L)
            return -1;
          operands[0] = x1;
          if (!clear_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 1711 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse && reload_completed))
            return -1;
          return 1071; /* *clear_multiple */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 55)
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[0] = x1;
      if (!clear_vfp_multiple_operation (operands[0], E_VOIDmode)
          || !
#line 1688 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse && reload_completed))
        return -1;
      return 858; /* *clear_vfp_multiple */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x2, 0);
  operands[5] = x9;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[5]))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 16L:
      switch (pattern496 (x5))
        {
        case 0:
          if (pattern578 (x1) != 0)
            return -1;
          x11 = XEXP (x8, 1);
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != PLUS
              || GET_MODE (x12) != E_SImode)
            return -1;
          x13 = XEXP (x12, 1);
          if (GET_CODE (x13) != CONST_INT
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x16 = XEXP (x7, 0);
          operands[3] = x16;
          x17 = XEXP (x8, 0);
          operands[4] = x17;
          x18 = XEXP (x6, 1);
          x19 = XEXP (x18, 0);
          x20 = XEXP (x19, 0);
          if (!rtx_equal_p (x20, operands[5]))
            return -1;
          x21 = XEXP (x7, 1);
          x22 = XEXP (x21, 0);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          x24 = XEXP (x12, 0);
          if (!rtx_equal_p (x24, operands[5]))
            return -1;
          switch (pattern633 (x1))
            {
            case 0:
              x25 = XEXP (x5, 1);
              x26 = XEXP (x25, 0);
              if (!rtx_equal_p (x26, operands[5]))
                return -1;
              x27 = XEXP (x19, 1);
              if (XWINT (x27, 0) != 4L)
                return -1;
              x28 = XEXP (x22, 1);
              if (XWINT (x28, 0) != 8L
                  || XWINT (x13, 0) != 12L)
                return -1;
              if (arm_hard_general_register_operand (operands[1], E_SImode)
                  && arm_hard_general_register_operand (operands[2], E_SImode)
                  && arm_hard_general_register_operand (operands[3], E_SImode)
                  && arm_hard_general_register_operand (operands[4], E_SImode)
                  && 
#line 74 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5))
                return 439; /* *ldm4_ia_update */
              if (!low_register_operand (operands[1], E_SImode)
                  || !low_register_operand (operands[2], E_SImode)
                  || !low_register_operand (operands[3], E_SImode)
                  || !low_register_operand (operands[4], E_SImode)
                  || !
#line 94 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 440; /* *thumb_ldm4_ia_update */

            case 1:
              if (XWINT (x13, 0) != 16L
                  || !arm_hard_general_register_operand (operands[1], E_SImode)
                  || !arm_hard_general_register_operand (operands[2], E_SImode)
                  || !arm_hard_general_register_operand (operands[3], E_SImode)
                  || !arm_hard_general_register_operand (operands[4], E_SImode))
                return -1;
              x25 = XEXP (x5, 1);
              x26 = XEXP (x25, 0);
              x29 = XEXP (x26, 0);
              if (!rtx_equal_p (x29, operands[5])
                  || !
#line 181 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 445; /* *ldm4_ib_update */

            default:
              return -1;
            }

        case 1:
          if (pattern590 (x1) != 0)
            return -1;
          x17 = XEXP (x8, 0);
          x30 = XEXP (x17, 0);
          if (GET_CODE (x30) != PLUS
              || GET_MODE (x30) != E_SImode)
            return -1;
          x31 = XEXP (x30, 1);
          if (GET_CODE (x31) != CONST_INT
              || !store_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x18 = XEXP (x6, 1);
          operands[2] = x18;
          x21 = XEXP (x7, 1);
          operands[3] = x21;
          x11 = XEXP (x8, 1);
          operands[4] = x11;
          x15 = XEXP (x6, 0);
          x32 = XEXP (x15, 0);
          x33 = XEXP (x32, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x16 = XEXP (x7, 0);
          x34 = XEXP (x16, 0);
          x35 = XEXP (x34, 0);
          if (!rtx_equal_p (x35, operands[5]))
            return -1;
          x36 = XEXP (x30, 0);
          if (!rtx_equal_p (x36, operands[5]))
            return -1;
          switch (pattern635 (x1))
            {
            case 0:
              x14 = XEXP (x5, 0);
              x37 = XEXP (x14, 0);
              if (!rtx_equal_p (x37, operands[5]))
                return -1;
              x38 = XEXP (x32, 1);
              if (XWINT (x38, 0) != 4L)
                return -1;
              x39 = XEXP (x34, 1);
              if (XWINT (x39, 0) != 8L
                  || XWINT (x31, 0) != 12L)
                return -1;
              if (arm_hard_general_register_operand (operands[1], E_SImode)
                  && arm_hard_general_register_operand (operands[2], E_SImode)
                  && arm_hard_general_register_operand (operands[3], E_SImode)
                  && arm_hard_general_register_operand (operands[4], E_SImode)
                  && 
#line 125 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5))
                return 442; /* *stm4_ia_update */
              if (!low_register_operand (operands[1], E_SImode)
                  || !low_register_operand (operands[2], E_SImode)
                  || !low_register_operand (operands[3], E_SImode)
                  || !low_register_operand (operands[4], E_SImode)
                  || !
#line 142 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 443; /* *thumb_stm4_ia_update */

            case 1:
              if (XWINT (x31, 0) != 16L
                  || !arm_hard_general_register_operand (operands[1], E_SImode)
                  || !arm_hard_general_register_operand (operands[2], E_SImode)
                  || !arm_hard_general_register_operand (operands[3], E_SImode)
                  || !arm_hard_general_register_operand (operands[4], E_SImode))
                return -1;
              x14 = XEXP (x5, 0);
              x37 = XEXP (x14, 0);
              x40 = XEXP (x37, 0);
              if (!rtx_equal_p (x40, operands[5])
                  || !
#line 213 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 447; /* *stm4_ib_update */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case -16L:
      x25 = XEXP (x5, 1);
      switch (GET_CODE (x25))
        {
        case MEM:
          if (pattern367 (x25) != 0
              || pattern578 (x1) != 0
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x14 = XEXP (x5, 0);
          operands[1] = x14;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x16 = XEXP (x7, 0);
          operands[3] = x16;
          if (!arm_hard_general_register_operand (operands[3], E_SImode))
            return -1;
          x17 = XEXP (x8, 0);
          operands[4] = x17;
          if (!arm_hard_general_register_operand (operands[4], E_SImode))
            return -1;
          x26 = XEXP (x25, 0);
          x29 = XEXP (x26, 0);
          if (!rtx_equal_p (x29, operands[5]))
            return -1;
          x18 = XEXP (x6, 1);
          x19 = XEXP (x18, 0);
          x20 = XEXP (x19, 0);
          if (!rtx_equal_p (x20, operands[5]))
            return -1;
          x21 = XEXP (x7, 1);
          x22 = XEXP (x21, 0);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          x41 = XEXP (x26, 1);
          switch (XWINT (x41, 0))
            {
            case -12L:
              x27 = XEXP (x19, 1);
              if (XWINT (x27, 0) != -8L)
                return -1;
              x28 = XEXP (x22, 1);
              if (XWINT (x28, 0) != -4L)
                return -1;
              x11 = XEXP (x8, 1);
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[5])
                  || !
#line 251 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 449; /* *ldm4_da_update */

            case -16L:
              x27 = XEXP (x19, 1);
              if (XWINT (x27, 0) != -12L)
                return -1;
              x28 = XEXP (x22, 1);
              if (XWINT (x28, 0) != -8L)
                return -1;
              x11 = XEXP (x8, 1);
              x12 = XEXP (x11, 0);
              if (GET_CODE (x12) != PLUS
                  || GET_MODE (x12) != E_SImode)
                return -1;
              x13 = XEXP (x12, 1);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x24 = XEXP (x12, 0);
              if (!rtx_equal_p (x24, operands[5])
                  || !
#line 323 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 453; /* *ldm4_db_update */

            default:
              return -1;
            }

        case REG:
          operands[1] = x25;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x5, 0);
          if (pattern423 (x14) != 0
              || pattern590 (x1) != 0
              || !store_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x18 = XEXP (x6, 1);
          operands[2] = x18;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x21 = XEXP (x7, 1);
          operands[3] = x21;
          if (!arm_hard_general_register_operand (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x8, 1);
          operands[4] = x11;
          if (!arm_hard_general_register_operand (operands[4], E_SImode))
            return -1;
          x37 = XEXP (x14, 0);
          x40 = XEXP (x37, 0);
          if (!rtx_equal_p (x40, operands[5]))
            return -1;
          x15 = XEXP (x6, 0);
          x32 = XEXP (x15, 0);
          x33 = XEXP (x32, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x16 = XEXP (x7, 0);
          x34 = XEXP (x16, 0);
          x35 = XEXP (x34, 0);
          if (!rtx_equal_p (x35, operands[5]))
            return -1;
          x42 = XEXP (x37, 1);
          switch (XWINT (x42, 0))
            {
            case -12L:
              x38 = XEXP (x32, 1);
              if (XWINT (x38, 0) != -8L)
                return -1;
              x39 = XEXP (x34, 1);
              if (XWINT (x39, 0) != -4L)
                return -1;
              x17 = XEXP (x8, 0);
              x30 = XEXP (x17, 0);
              if (!rtx_equal_p (x30, operands[5])
                  || !
#line 283 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 451; /* *stm4_da_update */

            case -16L:
              x38 = XEXP (x32, 1);
              if (XWINT (x38, 0) != -12L)
                return -1;
              x39 = XEXP (x34, 1);
              if (XWINT (x39, 0) != -8L)
                return -1;
              x17 = XEXP (x8, 0);
              x30 = XEXP (x17, 0);
              if (GET_CODE (x30) != PLUS
                  || GET_MODE (x30) != E_SImode)
                return -1;
              x31 = XEXP (x30, 1);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x36 = XEXP (x30, 0);
              if (!rtx_equal_p (x36, operands[5])
                  || !
#line 355 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5))
                return -1;
              return 455; /* *stm4_db_update */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  switch (GET_CODE (x2))
    {
    case MULT:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      if (
#line 162 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch6))
        return 945; /* *thumb_mulsi3 */
      if (!
#line 175 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch6))
        return -1;
      return 946; /* *thumb_mulsi3_v6 */

    case ASHIFT:
      if (!nonmemory_operand (operands[2], E_SImode)
          || !
#line 275 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 951; /* *thumb1_ashlsi3 */

    case ASHIFTRT:
      if (!nonmemory_operand (operands[2], E_SImode)
          || !
#line 285 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 952; /* *thumb1_ashrsi3 */

    case LSHIFTRT:
      if (!nonmemory_operand (operands[2], E_SImode)
          || !
#line 295 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 953; /* *thumb1_lshrsi3 */

    case ROTATERT:
      if (!register_operand (operands[2], E_SImode)
          || !
#line 305 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 954; /* *thumb1_rotrsi3 */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern32 (x3, 
E_V8QImode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2265; /* neon_vbslv8qi_internal */

    case E_V16QImode:
      if (pattern32 (x3, 
E_V16QImode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2266; /* neon_vbslv16qi_internal */

    case E_V4HImode:
      if (pattern32 (x3, 
E_V4HImode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2267; /* neon_vbslv4hi_internal */

    case E_V8HImode:
      if (pattern32 (x3, 
E_V8HImode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2268; /* neon_vbslv8hi_internal */

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2269; /* neon_vbslv2si_internal */

    case E_V4SImode:
      if (pattern32 (x3, 
E_V4SImode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2270; /* neon_vbslv4si_internal */

    case E_V4HFmode:
      if (pattern32 (x3, 
E_V4HFmode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2271; /* neon_vbslv4hf_internal */

    case E_V8HFmode:
      if (pattern32 (x3, 
E_V8HFmode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2272; /* neon_vbslv8hf_internal */

    case E_V4BFmode:
      if (pattern32 (x3, 
E_V4BFmode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2273; /* neon_vbslv4bf_internal */

    case E_V8BFmode:
      if (pattern32 (x3, 
E_V8BFmode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2274; /* neon_vbslv8bf_internal */

    case E_V2SFmode:
      if (pattern32 (x3, 
E_V2SFmode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2275; /* neon_vbslv2sf_internal */

    case E_V4SFmode:
      if (pattern32 (x3, 
E_V4SFmode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2276; /* neon_vbslv4sf_internal */

    case E_DImode:
      if (pattern32 (x3, 
E_DImode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2277; /* neon_vbsldi_internal */

    case E_V2DImode:
      if (pattern32 (x3, 
E_V2DImode) != 0
          || !
#line 4483 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2278; /* neon_vbslv2di_internal */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern89 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      switch (pattern507 ())
        {
        case 0:
          if (!
#line 3661 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
            return -1;
          return 4930; /* mve_vstrq_scatter_shifted_offset_v8hi */

        case 1:
          if (!
#line 3661 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
            return -1;
          return 4932; /* mve_vstrq_scatter_shifted_offset_v8hf */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern508 ())
        {
        case 0:
          if (!
#line 3661 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4931; /* mve_vstrq_scatter_shifted_offset_v4si */

        case 1:
          if (!
#line 3661 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4933; /* mve_vstrq_scatter_shifted_offset_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[1], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !
#line 3661 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4934; /* mve_vstrq_scatter_shifted_offset_v2di */

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4655 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2469; /* neon_vsri_nv8qi */

    case 1:
      if (!
#line 4655 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2470; /* neon_vsri_nv16qi */

    case 2:
      if (!
#line 4655 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2471; /* neon_vsri_nv4hi */

    case 3:
      if (!
#line 4655 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2472; /* neon_vsri_nv8hi */

    case 4:
      if (!
#line 4655 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2473; /* neon_vsri_nv2si */

    case 5:
      if (!
#line 4655 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2474; /* neon_vsri_nv4si */

    case 6:
      if (!
#line 4655 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2475; /* neon_vsri_ndi */

    case 7:
      if (!
#line 4655 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2476; /* neon_vsri_nv2di */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern44 (x1, 
E_XImode, 
E_OImode))
    {
    case 0:
      if (!
#line 5122 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2617; /* neon_vld1x4qbv16qi */

    case 1:
      if (!
#line 5122 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2618; /* neon_vld1x4qbv8hi */

    case 2:
      if (!
#line 5122 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2619; /* neon_vld1x4qbv8hf */

    case 3:
      if (!(
#line 5122 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2620; /* neon_vld1x4qbv8bf */

    case 4:
      if (!
#line 5122 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2621; /* neon_vld1x4qbv4si */

    case 5:
      if (!
#line 5122 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2622; /* neon_vld1x4qbv4sf */

    case 6:
      if (!
#line 5122 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2623; /* neon_vld1x4qbv2di */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern42 (x1))
    {
    case 0:
      if (!
#line 3965 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2194; /* neon_vqdmulh_lanev8hi */

    case 1:
      if (!
#line 3965 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2196; /* neon_vqdmulh_lanev4si */

    case 2:
      if (!
#line 3979 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2198; /* neon_vqdmulh_lanev4hi */

    case 3:
      if (!
#line 3979 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2200; /* neon_vqdmulh_lanev2si */

    default:
      return -1;
    }
}

 int
recog_107 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 6691 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 3033; /* neon_vbfcvtv4sfv4bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 6691 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 3034; /* neon_vbfcvtv4sfv8bf */

    case E_BFmode:
      if (!register_operand (operands[0], E_BFmode)
          || GET_MODE (x3) != E_BFmode
          || !register_operand (operands[1], E_SFmode)
          || !
#line 6710 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_FP))
        return -1;
      return 3036; /* neon_vbfcvtsf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4BFmode:
          if (!register_operand (operands[1], E_V4BFmode)
              || !
#line 6719 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3037; /* neon_vbfcvtv4bf */

        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !
#line 6719 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
            return -1;
          return 3038; /* neon_vbfcvtv8bf */

        default:
          return -1;
        }

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_BFmode)
          || !
#line 6760 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_FP))
        return -1;
      return 3040; /* neon_vbfcvtbf_cvtmodev2si */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 6760 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_FP))
        return -1;
      return 3041; /* neon_vbfcvtbf_cvtmodesf */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 24 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 687; /* iwmmxt_wabsv2si3 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 24 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 688; /* iwmmxt_wabsv4hi3 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 24 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 689; /* iwmmxt_wabsv8qi3 */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern105 (x1))
    {
    case 0:
      if (!
#line 3729 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2113; /* neon_vcvtuv2sf */

    case 1:
      if (!
#line 3729 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2115; /* neon_vcvtuv4sf */

    case 2:
      if (!
#line 3738 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2117; /* neon_vcvtuv2si */

    case 3:
      if (!
#line 3738 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2119; /* neon_vcvtuv4si */

    case 4:
      if (!
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2123; /* neon_vcvtuv4hi */

    case 5:
      if (!
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2125; /* neon_vcvtuv8hi */

    case 6:
      if (!
#line 3778 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2127; /* neon_vcvtuv8hf */

    case 7:
      if (!
#line 3778 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2129; /* neon_vcvtuv4hf */

    default:
      return -1;
    }
}

 int
recog_131 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 852 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1341; /* neon_vrsqrtev8hf */

    case 1:
      if (!
#line 852 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1342; /* neon_vrsqrtev4hf */

    case 2:
      if (!
#line 3213 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2036; /* neon_vrsqrtev2si */

    case 3:
      if (!
#line 3213 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2037; /* neon_vrsqrtev2sf */

    case 4:
      if (!
#line 3213 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2038; /* neon_vrsqrtev4si */

    case 5:
      if (!
#line 3213 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2039; /* neon_vrsqrtev4sf */

    default:
      return -1;
    }
}

 int
recog_142 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern149 (x1))
    {
    case 0:
      if (!(
#line 2891 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return -1;
      return 1932; /* neon_vcadd90v4hf */

    case 1:
      if (register_operand (operands[0], E_V8HFmode)
          && register_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && (
#line 2891 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return 1934; /* neon_vcadd90v8hf */
      if (!s_register_operand (operands[0], E_V8HFmode)
          || !s_register_operand (operands[1], E_V8HFmode)
          || !s_register_operand (operands[2], E_V8HFmode)
          || !
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3742; /* mve_vcaddq_rot90_fv8hf */

    case 2:
      if (!
#line 2891 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return -1;
      return 1936; /* neon_vcadd90v2sf */

    case 3:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 2891 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return 1938; /* neon_vcadd90v4sf */
      if (!s_register_operand (operands[0], E_V4SFmode)
          || !s_register_operand (operands[1], E_V4SFmode)
          || !s_register_operand (operands[2], E_V4SFmode)
          || !
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3748; /* mve_vcaddq_rot90_fv4sf */

    case 4:
      if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3566; /* mve_vcaddq_rot90_v16qi */

    case 5:
      if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3570; /* mve_vcaddq_rot90_v8hi */

    case 6:
      if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3574; /* mve_vcaddq_rot90_v4si */

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern157 (x1))
    {
    case 0:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2720; /* neon_vst1x3qbv8qi */

    case 1:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2721; /* neon_vst1x3qbv16qi */

    case 2:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2722; /* neon_vst1x3qbv4hi */

    case 3:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2723; /* neon_vst1x3qbv8hi */

    case 4:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2724; /* neon_vst1x3qbv2si */

    case 5:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2725; /* neon_vst1x3qbv4si */

    case 6:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2726; /* neon_vst1x3qbv4hf */

    case 7:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2727; /* neon_vst1x3qbv8hf */

    case 8:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2728; /* neon_vst1x3qbv4bf */

    case 9:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2729; /* neon_vst1x3qbv8bf */

    case 10:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2730; /* neon_vst1x3qbv2sf */

    case 11:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2731; /* neon_vst1x3qbv4sf */

    case 12:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2732; /* neon_vst1x3qbdi */

    case 13:
      if (!
#line 5298 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2733; /* neon_vst1x3qbv2di */

    default:
      return -1;
    }
}

 int
recog_154 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern165 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V16QImode, 
E_V4x16QImode) != 0
          || !
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x16QImode))))
        return -1;
      return 3256; /* mve_vst4qv16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HImode, 
E_V4x8HImode) != 0
          || !
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x8HImode))))
        return -1;
      return 3257; /* mve_vst4qv8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SImode, 
E_V4x4SImode) != 0
          || !
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x4SImode))))
        return -1;
      return 3258; /* mve_vst4qv4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HFmode, 
E_V4x8HFmode) != 0
          || !
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x8HFmode))))
        return -1;
      return 3259; /* mve_vst4qv8hf */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SFmode, 
E_V4x4SFmode) != 0
          || !
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x4SFmode))))
        return -1;
      return 3260; /* mve_vst4qv4sf */

    default:
      return -1;
    }
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !
#line 527 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3370; /* mve_vcreateq_fv8hf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !
#line 527 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3371; /* mve_vcreateq_fv4sf */

    default:
      return -1;
    }
}

 int
recog_166 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2345; /* neon_vrshrs_nv8qi */

    case 1:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2349; /* neon_vrshrs_nv16qi */

    case 2:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2353; /* neon_vrshrs_nv4hi */

    case 3:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2357; /* neon_vrshrs_nv8hi */

    case 4:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2361; /* neon_vrshrs_nv2si */

    case 5:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2365; /* neon_vrshrs_nv4si */

    case 6:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2369; /* neon_vrshrs_ndi */

    case 7:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2373; /* neon_vrshrs_nv2di */

    default:
      return -1;
    }
}

 int
recog_177 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern150 (x1))
    {
    case 0:
      if (!
#line 3788 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2131; /* neon_vcvtu_nv2sf */

    case 1:
      if (!
#line 3788 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2133; /* neon_vcvtu_nv4sf */

    case 2:
      if (!
#line 3802 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2135; /* neon_vcvtu_nv8hf */

    case 3:
      if (!
#line 3802 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2137; /* neon_vcvtu_nv4hf */

    case 4:
      if (!
#line 3815 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2139; /* neon_vcvtu_nv2si */

    case 5:
      if (!
#line 3815 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2141; /* neon_vcvtu_nv4si */

    case 6:
      if (!
#line 3829 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2143; /* neon_vcvtu_nv4hi */

    case 7:
      if (!
#line 3829 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2145; /* neon_vcvtu_nv8hi */

    default:
      return -1;
    }
}

 int
recog_187 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern163 (x1, 
E_OImode))
    {
    case 0:
      if (!
#line 6173 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2938; /* neon_vst4v8qi */

    case 1:
      if (!
#line 6173 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2939; /* neon_vst4v4hi */

    case 2:
      if (!
#line 6173 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2940; /* neon_vst4v4hf */

    case 3:
      if (!(
#line 6173 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2941; /* neon_vst4v4bf */

    case 4:
      if (!
#line 6173 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2942; /* neon_vst4v2si */

    case 5:
      if (!
#line 6173 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2943; /* neon_vst4v2sf */

    case 6:
      if (!
#line 6173 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2944; /* neon_vst4di */

    default:
      return -1;
    }
}

 int
recog_197 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern130 (x1))
    {
    case 0:
      if (!
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 919; /* neon_vmaxnmhf */

    case 1:
      if (!
#line 2106 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
        return -1;
      return 921; /* fmaxsf3 */

    case 2:
      if (!(
#line 2106 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
        return -1;
      return 923; /* fmaxdf3 */

    case 3:
      if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1861; /* neon_vmaxnmv8hf */

    case 4:
      if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1863; /* neon_vmaxnmv4hf */

    case 5:
      if (!
#line 2736 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
        return -1;
      return 1865; /* neon_vmaxnmv2sf */

    case 6:
      if (!
#line 2736 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
        return -1;
      return 1867; /* neon_vmaxnmv4sf */

    default:
      return -1;
    }
}

 int
recog_208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern146 (x1))
    {
    case 0:
      if (!
#line 2713 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1860; /* neon_vpminfv4hf */

    case 1:
      if (!
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1899; /* neon_vpminsv8qi */

    case 2:
      if (!
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1903; /* neon_vpminsv4hi */

    case 3:
      if (!
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1907; /* neon_vpminsv2si */

    case 4:
      if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1910; /* neon_vpminfv2sf */

    case 5:
      if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1912; /* neon_vpminfv4sf */

    default:
      return -1;
    }
}

 int
recog_218 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1485; /* neon_vrhadduv8qi */

    case 1:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1489; /* neon_vrhadduv16qi */

    case 2:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1493; /* neon_vrhadduv4hi */

    case 3:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1497; /* neon_vrhadduv8hi */

    case 4:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1501; /* neon_vrhadduv2si */

    case 5:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1505; /* neon_vrhadduv4si */

    default:
      return -1;
    }
}

 int
recog_230 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern144 (x1))
    {
    case 0:
      if (!
#line 2516 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1757; /* neon_vcagev2sf_insn_unspec */

    case 1:
      if (!
#line 2516 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1761; /* neon_vcagev4sf_insn_unspec */

    case 2:
      if (!
#line 2557 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1773; /* neon_vcagev8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2557 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1777; /* neon_vcagev4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_240 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode)
      || !
#line 780 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
    return -1;
  return 593; /* iwmmxt_wshufh */
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern231 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      switch (pattern533 ())
        {
        case 0:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
            return -1;
          return 4936; /* mve_vstrq_scatter_shifted_offset_p_v8hi */

        case 1:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
            return -1;
          return 4938; /* mve_vstrq_scatter_shifted_offset_p_v8hf */

        default:
          return -1;
        }

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode))
        return -1;
      switch (pattern552 ())
        {
        case 0:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4937; /* mve_vstrq_scatter_shifted_offset_p_v4si */

        case 1:
          if (!
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4939; /* mve_vstrq_scatter_shifted_offset_p_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[1], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !vpr_register_operand (operands[3], E_V2QImode)
          || !
#line 3699 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4940; /* mve_vstrq_scatter_shifted_offset_p_v2di */

    default:
      return -1;
    }
}

 int
recog_257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!const_int_ccde3_operand (operands[4], E_SImode))
    return -1;
  switch (pattern393 (x3))
    {
    case 0:
      if (!
#line 4574 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 147; /* arm_cx3si */

    case 1:
      if (!
#line 4574 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 148; /* arm_cx3di */

    default:
      return -1;
    }
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 30:
      if (pattern94 (x2, 
104, 
E_CCmode) != 0)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode)
          || !
#line 4419 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM_QBIT))
        return -1;
      return 131; /* arm_get_apsr */

    case 25:
      return recog_123 (x1, insn, pnum_clobbers);

    case 26:
      return recog_113 (x1, insn, pnum_clobbers);

    case 45:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 6056 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 190; /* arm_sxtb16 */

    case 46:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 6056 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 191; /* arm_uxtb16 */

    case 1:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (
#line 6711 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && flag_pic))
        return 259; /* pic_load_addr_32bit */
      if (!
#line 6727 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_THUMB1 && flag_pic))
        return -1;
      return 260; /* pic_load_addr_thumb1 */

    case 38:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_SImode)
          || !
#line 9262 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 306; /* probe_stack */

    case 40:
      return recog_133 (x1, insn, pnum_clobbers);

    case 22:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 12201 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2))
        return -1;
      return 400; /* arm_rbit */

    case 17:
      return recog_116 (x1, insn, pnum_clobbers);

    case 15:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode)
          || !
#line 560 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 577; /* iwmmxt_clrdi */

    case 8:
      switch (pattern95 (x1, 
E_SImode))
        {
        case 0:
          if (!
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 671; /* iwmmxt_tmovmskb */

        case 1:
          if (!
#line 1588 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 672; /* iwmmxt_tmovmskh */

        case 2:
          if (!
#line 1597 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 673; /* iwmmxt_tmovmskw */

        default:
          return -1;
        }

    case 7:
      switch (pattern95 (x1, 
E_DImode))
        {
        case 0:
          if (!
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 674; /* iwmmxt_waccb */

        case 1:
          if (!
#line 1615 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 675; /* iwmmxt_wacch */

        case 2:
          if (!
#line 1624 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 676; /* iwmmxt_waccw */

        default:
          return -1;
        }

    case 16:
      return recog_111 (x1, insn, pnum_clobbers);

    case 109:
      return recog_115 (x1, insn, pnum_clobbers);

    case 108:
      return recog_132 (x1, insn, pnum_clobbers);

    case 363:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 788; /* neon_vrndhf */

        case 1:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1329; /* neon_vrndv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1335; /* neon_vrndv4hf */

        default:
          return -1;
        }

    case 364:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 789; /* neon_vrndahf */

        case 1:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1330; /* neon_vrndav8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1336; /* neon_vrndav4hf */

        default:
          return -1;
        }

    case 366:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 790; /* neon_vrndmhf */

        case 1:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1331; /* neon_vrndmv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1337; /* neon_vrndmv4hf */

        default:
          return -1;
        }

    case 367:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 791; /* neon_vrndnhf */

        case 1:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1332; /* neon_vrndnv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1338; /* neon_vrndnv4hf */

        default:
          return -1;
        }

    case 368:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 792; /* neon_vrndphf */

        case 1:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1333; /* neon_vrndpv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1339; /* neon_vrndpv4hf */

        default:
          return -1;
        }

    case 369:
      switch (pattern96 (x1))
        {
        case 0:
          if (!
#line 971 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 793; /* neon_vrndxhf */

        case 1:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1334; /* neon_vrndxv8hf */

        case 2:
          if (!
#line 842 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1340; /* neon_vrndxv4hf */

        default:
          return -1;
        }

    case 365:
      if (GET_MODE (x2) != E_HFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_HFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_HFmode)
          || !
#line 982 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 794; /* neon_vrndihf */

    case 181:
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 1907 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 874; /* neon_vcvthshf */

        case 1:
          if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 876; /* neon_vcvthssi */

        default:
          return -1;
        }

    case 182:
      switch (pattern97 (x1))
        {
        case 0:
          if (!
#line 1907 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 875; /* neon_vcvthuhf */

        case 1:
          if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 877; /* neon_vcvthusi */

        default:
          return -1;
        }

    case 183:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 882; /* neon_vcvtahssi */

        case 1:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2146; /* neon_vcvtasv8hf */

        case 2:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2154; /* neon_vcvtasv4hf */

        default:
          return -1;
        }

    case 184:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 883; /* neon_vcvtahusi */

        case 1:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2147; /* neon_vcvtauv8hf */

        case 2:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2155; /* neon_vcvtauv4hf */

        default:
          return -1;
        }

    case 185:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 884; /* neon_vcvtmhssi */

        case 1:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2148; /* neon_vcvtmsv8hf */

        case 2:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2156; /* neon_vcvtmsv4hf */

        default:
          return -1;
        }

    case 186:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 885; /* neon_vcvtmhusi */

        case 1:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2149; /* neon_vcvtmuv8hf */

        case 2:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2157; /* neon_vcvtmuv4hf */

        default:
          return -1;
        }

    case 187:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 886; /* neon_vcvtnhssi */

        case 1:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2150; /* neon_vcvtnsv8hf */

        case 2:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2158; /* neon_vcvtnsv4hf */

        default:
          return -1;
        }

    case 188:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 887; /* neon_vcvtnhusi */

        case 1:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2151; /* neon_vcvtnuv8hf */

        case 2:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2159; /* neon_vcvtnuv4hf */

        default:
          return -1;
        }

    case 189:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 888; /* neon_vcvtphssi */

        case 1:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2152; /* neon_vcvtpsv8hf */

        case 2:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2160; /* neon_vcvtpsv4hf */

        default:
          return -1;
        }

    case 190:
      switch (pattern98 (x1))
        {
        case 0:
          if (!
#line 2014 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 889; /* neon_vcvtphusi */

        case 1:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2153; /* neon_vcvtpuv8hf */

        case 2:
          if (!
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 2161; /* neon_vcvtpuv4hf */

        default:
          return -1;
        }

    case 32:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 891; /* btruncsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 897; /* btruncdf2 */

        default:
          return -1;
        }

    case 33:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 892; /* ceilsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 898; /* ceildf2 */

        default:
          return -1;
        }

    case 34:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 893; /* floorsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 899; /* floordf2 */

        default:
          return -1;
        }

    case 35:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 894; /* nearbyintsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 900; /* nearbyintdf2 */

        default:
          return -1;
        }

    case 36:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 895; /* rintsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 901; /* rintdf2 */

        default:
          return -1;
        }

    case 37:
      switch (pattern99 (x1))
        {
        case 0:
          if (!
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 896; /* roundsf2 */

        case 1:
          if (!(
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 902; /* rounddf2 */

        default:
          return -1;
        }

    case 106:
      if (pattern100 (x1, 
E_SImode, 
14) != 0
          || !
#line 1832 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_32BIT && TARGET_HAVE_LOB))
        return -1;
      return 1076; /* dls_insn */

    case 352:
      return recog_103 (x1, insn, pnum_clobbers);

    case 356:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1219; /* neon_vrintpv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1225; /* neon_vrintpv4sf */

        default:
          return -1;
        }

    case 355:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1220; /* neon_vrintzv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1226; /* neon_vrintzv4sf */

        default:
          return -1;
        }

    case 357:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1221; /* neon_vrintmv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1227; /* neon_vrintmv4sf */

        default:
          return -1;
        }

    case 358:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1222; /* neon_vrintxv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1228; /* neon_vrintxv4sf */

        default:
          return -1;
        }

    case 359:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1223; /* neon_vrintav2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1229; /* neon_vrintav4sf */

        default:
          return -1;
        }

    case 360:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1224; /* neon_vrintnv2sf */

        case 1:
          if (!
#line 699 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1230; /* neon_vrintnv4sf */

        default:
          return -1;
        }

    case 298:
      return recog_131 (x1, insn, pnum_clobbers);

    case 145:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !
#line 968 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1397; /* neon_load_count */

    case 250:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V2DImode)
          || !
#line 1236 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
        return -1;
      return 1434; /* arm_reduc_plus_internal_v2di */

    case 251:
      return recog_129 (x1, insn, pnum_clobbers);

    case 252:
      return recog_130 (x1, insn, pnum_clobbers);

    case 261:
      return recog_128 (x1, insn, pnum_clobbers);

    case 277:
      return recog_127 (x1, insn, pnum_clobbers);

    case 170:
      return recog_126 (x1, insn, pnum_clobbers);

    case 293:
      return recog_125 (x1, insn, pnum_clobbers);

    case 173:
      return recog_122 (x1, insn, pnum_clobbers);

    case 174:
      return recog_121 (x1, insn, pnum_clobbers);

    case 172:
      return recog_120 (x1, insn, pnum_clobbers);

    case 240:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3852 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2162; /* neon_vmovnv8hi */

        case 1:
          if (!
#line 3852 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2163; /* neon_vmovnv4si */

        case 2:
          if (!
#line 3852 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2164; /* neon_vmovnv2di */

        default:
          return -1;
        }

    case 274:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2165; /* neon_vqmovnsv8hi */

        case 1:
          if (!
#line 3861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2167; /* neon_vqmovnsv4si */

        case 2:
          if (!
#line 3861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2169; /* neon_vqmovnsv2di */

        default:
          return -1;
        }

    case 275:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2166; /* neon_vqmovnuv8hi */

        case 1:
          if (!
#line 3861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2168; /* neon_vqmovnuv4si */

        case 2:
          if (!
#line 3861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2170; /* neon_vqmovnuv2di */

        default:
          return -1;
        }

    case 276:
      switch (pattern107 (x1))
        {
        case 0:
          if (!
#line 3870 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2171; /* neon_vqmovunv8hi */

        case 1:
          if (!
#line 3870 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2172; /* neon_vqmovunv4si */

        case 2:
          if (!
#line 3870 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2173; /* neon_vqmovunv2di */

        default:
          return -1;
        }

    case 238:
      switch (pattern109 (x1))
        {
        case 0:
          if (!
#line 3879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2174; /* neon_vmovlsv8qi */

        case 1:
          if (!
#line 3879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2176; /* neon_vmovlsv4hi */

        case 2:
          if (!
#line 3879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2178; /* neon_vmovlsv2si */

        default:
          return -1;
        }

    case 239:
      switch (pattern109 (x1))
        {
        case 0:
          if (!
#line 3879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2175; /* neon_vmovluv8qi */

        case 1:
          if (!
#line 3879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2177; /* neon_vmovluv4hi */

        case 2:
          if (!
#line 3879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2179; /* neon_vmovluv2si */

        default:
          return -1;
        }

    case 297:
      return recog_106 (x1, insn, pnum_clobbers);

    case 296:
      return recog_112 (x1, insn, pnum_clobbers);

    case 295:
      return recog_119 (x1, insn, pnum_clobbers);

    case 198:
      return recog_105 (x1, insn, pnum_clobbers);

    case 319:
      return recog_104 (x1, insn, pnum_clobbers);

    case 392:
      return recog_107 (x1, insn, pnum_clobbers);

    case 393:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8BFmode)
          || !
#line 6728 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 3039; /* neon_vbfcvt_highv8bf */

    case 132:
      switch (pattern110 (x1, 
130))
        {
        case 0:
          if (!
#line 27 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 3047; /* crypto_aesmc */

        case 1:
          if (!
#line 144 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO
   && arm_fusion_enabled_p (tune_params::FUSE_AES_AESMC)))
            return -1;
          return 3056; /* *aarch32_crypto_aese_fused */

        default:
          return -1;
        }

    case 131:
      switch (pattern110 (x1, 
129))
        {
        case 0:
          if (!
#line 27 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
            return -1;
          return 3048; /* crypto_aesimc */

        case 1:
          if (!
#line 183 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO
   && arm_fusion_enabled_p (tune_params::FUSE_AES_AESMC)))
            return -1;
          return 3058; /* *aarch32_crypto_aesd_fused */

        default:
          return -1;
        }

    case 129:
      if (pattern111 (x1) != 0
          || !
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3049; /* *crypto_aesd_insn */

    case 130:
      if (pattern111 (x1) != 0
          || !
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3050; /* *crypto_aese_insn */

    case 133:
      return recog_110 (x1, insn, pnum_clobbers);

    case 137:
      return recog_118 (x1, insn, pnum_clobbers);

    case 24:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0])
          || !
#line 49 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_MEMORY_BARRIER))
        return -1;
      return 3071; /* *memory_barrier */

    case 399:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3261; /* mve_vrndq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3267; /* mve_vrndq_fv4sf */

        default:
          return -1;
        }

    case 403:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3262; /* mve_vrndaq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3268; /* mve_vrndaq_fv4sf */

        default:
          return -1;
        }

    case 402:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3263; /* mve_vrndmq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3269; /* mve_vrndmq_fv4sf */

        default:
          return -1;
        }

    case 401:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3264; /* mve_vrndnq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3270; /* mve_vrndnq_fv4sf */

        default:
          return -1;
        }

    case 400:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3265; /* mve_vrndpq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3271; /* mve_vrndpq_fv4sf */

        default:
          return -1;
        }

    case 398:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3266; /* mve_vrndxq_fv8hf */

        case 1:
          if (!
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3272; /* mve_vrndxq_fv4sf */

        default:
          return -1;
        }

    case 404:
      switch (pattern113 (x1))
        {
        case 0:
          if (!
#line 174 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3273; /* mve_vrev64q_fv8hf */

        case 1:
          if (!
#line 174 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3274; /* mve_vrev64q_fv4sf */

        default:
          return -1;
        }

    case 406:
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V8HFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V8HFmode)
          || !
#line 204 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3279; /* mve_vrev32q_fv8hf */

    case 408:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V8HFmode)
          || !
#line 220 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3280; /* mve_vcvtbq_f32_f16v4sf */

    case 407:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V8HFmode)
          || !
#line 220 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3281; /* mve_vcvttq_f32_f16v4sf */

    case 409:
      switch (pattern114 (x1))
        {
        case 0:
          if (!
#line 235 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3282; /* mve_vcvtq_to_f_sv8hf */

        case 1:
          if (!
#line 235 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3284; /* mve_vcvtq_to_f_sv4sf */

        default:
          return -1;
        }

    case 411:
      switch (pattern114 (x1))
        {
        case 0:
          if (!
#line 235 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3283; /* mve_vcvtq_to_f_uv8hf */

        case 1:
          if (!
#line 235 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3285; /* mve_vcvtq_to_f_uv4sf */

        default:
          return -1;
        }

    case 419:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3286; /* mve_vrev64q_sv16qi */

        case 1:
          if (!
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3288; /* mve_vrev64q_sv8hi */

        case 2:
          if (!
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3290; /* mve_vrev64q_sv4si */

        default:
          return -1;
        }

    case 420:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3287; /* mve_vrev64q_uv16qi */

        case 1:
          if (!
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3289; /* mve_vrev64q_uv8hi */

        case 2:
          if (!
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3291; /* mve_vrev64q_uv4si */

        default:
          return -1;
        }

    case 433:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 265 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3292; /* mve_vcvtq_from_f_sv8hi */

        case 1:
          if (!
#line 265 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3294; /* mve_vcvtq_from_f_sv4si */

        default:
          return -1;
        }

    case 434:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 265 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3293; /* mve_vcvtq_from_f_uv8hi */

        case 1:
          if (!
#line 265 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3295; /* mve_vcvtq_from_f_uv4si */

        default:
          return -1;
        }

    case 424:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3308; /* mve_vclsq_sv16qi */

        case 1:
          if (!
#line 339 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3311; /* mve_vclsq_sv8hi */

        case 2:
          if (!
#line 339 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3314; /* mve_vclsq_sv4si */

        default:
          return -1;
        }

    case 421:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3309; /* mve_vqabsq_sv16qi */

        case 1:
          if (!
#line 339 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3312; /* mve_vqabsq_sv8hi */

        case 2:
          if (!
#line 339 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3315; /* mve_vqabsq_sv4si */

        default:
          return -1;
        }

    case 410:
      switch (pattern116 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3310; /* mve_vqnegq_sv16qi */

        case 1:
          if (!
#line 339 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3313; /* mve_vqnegq_sv8hi */

        case 2:
          if (!
#line 339 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3316; /* mve_vqnegq_sv4si */

        default:
          return -1;
        }

    case 426:
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3317; /* mve_vaddvq_uv16qi */

        case 1:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3319; /* mve_vaddvq_uv8hi */

        case 2:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3321; /* mve_vaddvq_uv4si */

        default:
          return -1;
        }

    case 425:
      switch (pattern119 (x1))
        {
        case 0:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3318; /* mve_vaddvq_sv16qi */

        case 1:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3320; /* mve_vaddvq_sv8hi */

        case 2:
          if (!
#line 354 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3322; /* mve_vaddvq_sv4si */

        default:
          return -1;
        }

    case 427:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 370 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3323; /* mve_vrev32q_uv16qi */

        case 1:
          if (!
#line 370 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3325; /* mve_vrev32q_uv8hi */

        default:
          return -1;
        }

    case 428:
      switch (pattern120 (x1))
        {
        case 0:
          if (!
#line 370 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3324; /* mve_vrev32q_sv16qi */

        case 1:
          if (!
#line 370 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3326; /* mve_vrev32q_sv8hi */

        default:
          return -1;
        }

    case 431:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3327; /* mve_vmovlbq_sv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3331; /* mve_vmovlbq_sv8hi */

        default:
          return -1;
        }

    case 432:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3328; /* mve_vmovlbq_uv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3332; /* mve_vmovlbq_uv8hi */

        default:
          return -1;
        }

    case 429:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3329; /* mve_vmovltq_uv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3333; /* mve_vmovltq_uv8hi */

        default:
          return -1;
        }

    case 430:
      switch (pattern118 (x1, 
E_V16QImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 386 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3330; /* mve_vmovltq_sv16qi */

        case 1:
          if (!
#line 386 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3334; /* mve_vmovltq_sv8hi */

        default:
          return -1;
        }

    case 417:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3335; /* mve_vcvtaq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3343; /* mve_vcvtaq_sv4si */

        default:
          return -1;
        }

    case 418:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3336; /* mve_vcvtaq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3344; /* mve_vcvtaq_uv4si */

        default:
          return -1;
        }

    case 439:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3337; /* mve_vcvtmq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3345; /* mve_vcvtmq_sv4si */

        default:
          return -1;
        }

    case 440:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3338; /* mve_vcvtmq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3346; /* mve_vcvtmq_uv4si */

        default:
          return -1;
        }

    case 437:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3339; /* mve_vcvtnq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3347; /* mve_vcvtnq_sv4si */

        default:
          return -1;
        }

    case 438:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3340; /* mve_vcvtnq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3348; /* mve_vcvtnq_uv4si */

        default:
          return -1;
        }

    case 435:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3341; /* mve_vcvtpq_sv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3349; /* mve_vcvtpq_sv4si */

        default:
          return -1;
        }

    case 436:
      switch (pattern118 (x1, 
E_V8HFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3342; /* mve_vcvtpq_uv8hi */

        case 1:
          if (!
#line 404 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3350; /* mve_vcvtpq_uv4si */

        default:
          return -1;
        }

    case 416:
      switch (pattern121 (x1))
        {
        case 0:
          if (!
#line 419 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3351; /* mve_vmvnq_n_uv8hi */

        case 1:
          if (!
#line 419 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3353; /* mve_vmvnq_n_uv4si */

        default:
          return -1;
        }

    case 415:
      switch (pattern121 (x1))
        {
        case 0:
          if (!
#line 419 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3352; /* mve_vmvnq_n_sv8hi */

        case 1:
          if (!
#line 419 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3354; /* mve_vmvnq_n_sv4si */

        default:
          return -1;
        }

    case 413:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V16QImode)
          || !
#line 434 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3355; /* mve_vrev16q_uv16qi */

    case 412:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V16QImode)
          || !
#line 434 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3356; /* mve_vrev16q_sv16qi */

    case 441:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V4SImode)
          || !
#line 449 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3357; /* mve_vaddlvq_uv4si */

    case 414:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_V4SImode)
          || !
#line 449 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3358; /* mve_vaddlvq_sv4si */

    case 442:
      return recog_114 (x1, insn, pnum_clobbers);

    case 448:
      if (GET_MODE (x2) != E_V16BImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vpr_register_operand (operands[0], E_V16BImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vpr_register_operand (operands[1], E_V16BImode)
          || !
#line 480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3363; /* mve_vpnotv16bi */

    case 1019:
      return recog_109 (x1, insn, pnum_clobbers);

    case 1021:
      return recog_124 (x1, insn, pnum_clobbers);

    case 1005:
      return recog_108 (x1, insn, pnum_clobbers);

    case 1007:
      return recog_117 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_304 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_DUPLICATE:
      x5 = XEXP (x3, 2);
      if (!immediate_operand (x5, E_SImode))
        return -1;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case TRUNCATE:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!nonimmediate_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern470 (x3, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 676 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 585; /* iwmmxt_tinsrb */

            case E_V4HImode:
              if (pattern470 (x3, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 693 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 586; /* iwmmxt_tinsrh */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (GET_MODE (x3) != E_V2SImode
                  || GET_MODE (x4) != E_V2SImode
                  || !nonimmediate_operand (x6, E_SImode))
                return -1;
              operands[2] = x6;
              if (register_operand (operands[0], E_V2SImode))
                {
                  x8 = XEXP (x3, 1);
                  operands[1] = x8;
                  if (register_operand (operands[1], E_V2SImode))
                    {
                      operands[3] = x5;
                      if (
#line 710 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                        return 587; /* iwmmxt_tinsrw */
                    }
                }
              operands[1] = x6;
              if (!s_register_operand (operands[0], E_V2SImode))
                return -1;
              x8 = XEXP (x3, 1);
              operands[3] = x8;
              if (!s_register_operand (operands[3], E_V2SImode))
                return -1;
              operands[2] = x5;
              if (!
#line 324 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1139; /* vec_setv2si_internal */

            case E_V8QImode:
              if (pattern360 (x3, 
E_V8QImode, 
E_QImode) != 0
                  || !
#line 324 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1135; /* vec_setv8qi_internal */

            case E_V4HImode:
              if (pattern360 (x3, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 324 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1136; /* vec_setv4hi_internal */

            case E_V4HFmode:
              if (pattern360 (x3, 
E_V4HFmode, 
E_HFmode) != 0
                  || !
#line 324 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1137; /* vec_setv4hf_internal */

            case E_V4BFmode:
              if (pattern360 (x3, 
E_V4BFmode, 
E_BFmode) != 0
                  || !
#line 324 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1138; /* vec_setv4bf_internal */

            case E_V2SFmode:
              if (pattern360 (x3, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 324 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1140; /* vec_setv2sf_internal */

            case E_V16QImode:
              if (pattern360 (x3, 
E_V16QImode, 
E_QImode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1141; /* vec_setv16qi_internal */
              if (!
#line 4234 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
                return -1;
              return 5023; /* mve_vec_setv16qi_internal */

            case E_V8HImode:
              if (pattern360 (x3, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1142; /* vec_setv8hi_internal */
              if (!
#line 4234 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
                return -1;
              return 5024; /* mve_vec_setv8hi_internal */

            case E_V8HFmode:
              if (pattern360 (x3, 
E_V8HFmode, 
E_HFmode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1143; /* vec_setv8hf_internal */
              if (!
#line 4234 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
                return -1;
              return 5025; /* mve_vec_setv8hf_internal */

            case E_V4SImode:
              if (pattern360 (x3, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1144; /* vec_setv4si_internal */
              if (!
#line 4234 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 5026; /* mve_vec_setv4si_internal */

            case E_V4SFmode:
              if (pattern360 (x3, 
E_V4SFmode, 
E_SFmode) != 0)
                return -1;
              if (
#line 345 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1145; /* vec_setv4sf_internal */
              if (!
#line 4234 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 5027; /* mve_vec_setv4sf_internal */

            case E_V2DImode:
              if (pattern360 (x3, 
E_V2DImode, 
E_DImode) != 0)
                return -1;
              if (
#line 374 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1146; /* vec_setv2di_internal */
              if (!
#line 4253 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5028; /* mve_vec_setv2di_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x4, 1);
      if (GET_CODE (x9) != PARALLEL)
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x10 = XEXP (x8, 1);
      if (GET_CODE (x10) != PARALLEL)
        return -1;
      x5 = XEXP (x3, 2);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x11 = XEXP (x8, 0);
      operands[2] = x11;
      switch (XVECLEN (x9, 0))
        {
        case 8:
          if (pattern471 (x9) != 0)
            return -1;
          x12 = XVECEXP (x9, 0, 4);
          if (GET_CODE (x12) != CONST_INT)
            return -1;
          x13 = XVECEXP (x9, 0, 5);
          if (GET_CODE (x13) != CONST_INT)
            return -1;
          x14 = XVECEXP (x9, 0, 6);
          if (GET_CODE (x14) != CONST_INT)
            return -1;
          x15 = XVECEXP (x9, 0, 7);
          if (GET_CODE (x15) != CONST_INT
              || pattern553 (x10, 
8) != 0)
            return -1;
          x16 = XVECEXP (x10, 0, 4);
          if (GET_CODE (x16) != CONST_INT)
            return -1;
          x17 = XVECEXP (x10, 0, 5);
          if (GET_CODE (x17) != CONST_INT)
            return -1;
          x18 = XVECEXP (x10, 0, 6);
          if (GET_CODE (x18) != CONST_INT)
            return -1;
          x19 = XVECEXP (x10, 0, 7);
          if (GET_CODE (x19) != CONST_INT
              || XWINT (x5, 0) != 85L
              || pattern582 (x3, 
E_V8QImode) != 0)
            return -1;
          x20 = XVECEXP (x9, 0, 0);
          switch (XWINT (x20, 0))
            {
            case 4L:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 0L)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 5L)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 1L
                  || XWINT (x12, 0) != 6L
                  || XWINT (x13, 0) != 2L
                  || XWINT (x14, 0) != 7L
                  || XWINT (x15, 0) != 3L)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 0L)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 4L)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 1L)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 5L
                  || XWINT (x16, 0) != 2L
                  || XWINT (x17, 0) != 6L
                  || XWINT (x18, 0) != 3L
                  || XWINT (x19, 0) != 7L
                  || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 621; /* iwmmxt_wunpckihb */

            case 0L:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 4L)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 1L)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 5L
                  || XWINT (x12, 0) != 2L
                  || XWINT (x13, 0) != 6L
                  || XWINT (x14, 0) != 3L
                  || XWINT (x15, 0) != 7L)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 4L)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 0L)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 5L)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 1L
                  || XWINT (x16, 0) != 6L
                  || XWINT (x17, 0) != 2L
                  || XWINT (x18, 0) != 7L
                  || XWINT (x19, 0) != 3L
                  || !
#line 1093 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 624; /* iwmmxt_wunpckilb */

            default:
              return -1;
            }

        case 4:
          if (pattern471 (x9) != 0
              || pattern553 (x10, 
4) != 0
              || XWINT (x5, 0) != 5L
              || pattern582 (x3, 
E_V4HImode) != 0)
            return -1;
          x20 = XVECEXP (x9, 0, 0);
          switch (XWINT (x20, 0))
            {
            case 2L:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 0L)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 3L)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 1L)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 0L)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 2L)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 1L)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 3L
                  || !
#line 1049 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 622; /* iwmmxt_wunpckihh */

            case 0L:
              x21 = XVECEXP (x9, 0, 1);
              if (XWINT (x21, 0) != 2L)
                return -1;
              x22 = XVECEXP (x9, 0, 2);
              if (XWINT (x22, 0) != 1L)
                return -1;
              x23 = XVECEXP (x9, 0, 3);
              if (XWINT (x23, 0) != 3L)
                return -1;
              x24 = XVECEXP (x10, 0, 0);
              if (XWINT (x24, 0) != 2L)
                return -1;
              x25 = XVECEXP (x10, 0, 1);
              if (XWINT (x25, 0) != 0L)
                return -1;
              x26 = XVECEXP (x10, 0, 2);
              if (XWINT (x26, 0) != 3L)
                return -1;
              x27 = XVECEXP (x10, 0, 3);
              if (XWINT (x27, 0) != 1L
                  || !
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 625; /* iwmmxt_wunpckilh */

            default:
              return -1;
            }

        case 2:
          x20 = XVECEXP (x9, 0, 0);
          if (GET_CODE (x20) != CONST_INT)
            return -1;
          x21 = XVECEXP (x9, 0, 1);
          if (GET_CODE (x21) != CONST_INT
              || XVECLEN (x10, 0) != 2)
            return -1;
          x24 = XVECEXP (x10, 0, 0);
          if (GET_CODE (x24) != CONST_INT)
            return -1;
          x25 = XVECEXP (x10, 0, 1);
          if (GET_CODE (x25) != CONST_INT
              || XWINT (x5, 0) != 1L
              || pattern582 (x3, 
E_V2SImode) != 0)
            return -1;
          switch (XWINT (x20, 0))
            {
            case 1L:
              if (XWINT (x21, 0) != 0L
                  || XWINT (x24, 0) != 0L
                  || XWINT (x25, 0) != 1L
                  || !
#line 1065 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 623; /* iwmmxt_wunpckihw */

            case 0L:
              if (XWINT (x21, 0) != 1L
                  || XWINT (x24, 0) != 1L
                  || XWINT (x25, 0) != 0L
                  || !
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 626; /* iwmmxt_wunpckilw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SS_MINUS:
      if (pattern249 (x3, 
SS_PLUS) != 0
          || !
#line 81 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 693; /* iwmmxt_waddsubhx */

    case SS_PLUS:
      if (pattern249 (x3, 
SS_MINUS) != 0
          || !
#line 99 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 694; /* iwmmxt_wsubaddhx */

    default:
      return -1;
    }
}

 int
recog_311 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case SMAX:
      res = recog_279 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SMIN:
      res = recog_280 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case UMAX:
      switch (pattern240 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 4170 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            {
              *pnum_clobbers = 1;
              return 122; /* *arm_umaxsi3 */
            }
          break;

        case 1:
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 913 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 606; /* *umaxv2si3_iwmmxt */
          if (s_register_operand (operands[0], E_V2SImode)
              && s_register_operand (operands[1], E_V2SImode)
              && s_register_operand (operands[2], E_V2SImode)
              && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1353; /* *umaxv2si3_neon */
          break;

        case 2:
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 913 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 607; /* *umaxv4hi3_iwmmxt */
          if (s_register_operand (operands[0], E_V4HImode)
              && s_register_operand (operands[1], E_V4HImode)
              && s_register_operand (operands[2], E_V4HImode)
              && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1351; /* *umaxv4hi3_neon */
          break;

        case 3:
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 913 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 608; /* *umaxv8qi3_iwmmxt */
          if (s_register_operand (operands[0], E_V8QImode)
              && s_register_operand (operands[1], E_V8QImode)
              && s_register_operand (operands[2], E_V8QImode)
              && 
#line 870 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1349; /* *umaxv8qi3_neon */
          break;

        case 4:
          if (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1350; /* *umaxv16qi3_neon */
          if (
#line 916 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3618; /* mve_vmaxq_uv16qi */
          break;

        case 5:
          if (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1352; /* *umaxv8hi3_neon */
          if (
#line 916 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3622; /* mve_vmaxq_uv8hi */
          break;

        case 6:
          if (
#line 870 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1354; /* *umaxv4si3_neon */
          if (
#line 916 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3626; /* mve_vmaxq_uv4si */
          break;

        case 7:
          if (
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1420; /* quad_halves_umaxv4si */
          break;

        case 8:
          if (
#line 1157 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1428; /* quad_halves_umaxv8hi */
          break;

        case 9:
          if (
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1433; /* quad_halves_umaxv16qi */
          break;

        default:
          break;
        }
      break;

    case UMIN:
      switch (pattern240 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 4203 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            {
              *pnum_clobbers = 1;
              return 123; /* *arm_uminsi3 */
            }
          break;

        case 1:
          if (register_operand (operands[0], E_V2SImode)
              && register_operand (operands[1], E_V2SImode)
              && register_operand (operands[2], E_V2SImode)
              && 
#line 933 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 612; /* *uminv2si3_iwmmxt */
          if (s_register_operand (operands[0], E_V2SImode)
              && s_register_operand (operands[1], E_V2SImode)
              && s_register_operand (operands[2], E_V2SImode)
              && 
#line 861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1347; /* *uminv2si3_neon */
          break;

        case 2:
          if (register_operand (operands[0], E_V4HImode)
              && register_operand (operands[1], E_V4HImode)
              && register_operand (operands[2], E_V4HImode)
              && 
#line 933 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 613; /* *uminv4hi3_iwmmxt */
          if (s_register_operand (operands[0], E_V4HImode)
              && s_register_operand (operands[1], E_V4HImode)
              && s_register_operand (operands[2], E_V4HImode)
              && 
#line 861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1345; /* *uminv4hi3_neon */
          break;

        case 3:
          if (register_operand (operands[0], E_V8QImode)
              && register_operand (operands[1], E_V8QImode)
              && register_operand (operands[2], E_V8QImode)
              && 
#line 933 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return 614; /* *uminv8qi3_iwmmxt */
          if (s_register_operand (operands[0], E_V8QImode)
              && s_register_operand (operands[1], E_V8QImode)
              && s_register_operand (operands[2], E_V8QImode)
              && 
#line 861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1343; /* *uminv8qi3_neon */
          break;

        case 4:
          if (
#line 861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1344; /* *uminv16qi3_neon */
          if (
#line 916 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3620; /* mve_vminq_uv16qi */
          break;

        case 5:
          if (
#line 861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1346; /* *uminv8hi3_neon */
          if (
#line 916 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3624; /* mve_vminq_uv8hi */
          break;

        case 6:
          if (
#line 861 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1348; /* *uminv4si3_neon */
          if (
#line 916 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return 3628; /* mve_vminq_uv4si */
          break;

        case 7:
          if (
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1419; /* quad_halves_uminv4si */
          break;

        case 8:
          if (
#line 1157 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1427; /* quad_halves_uminv8hi */
          break;

        case 9:
          if (
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1432; /* quad_halves_uminv16qi */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (s_register_operand (operands[2], E_SImode)
      && memory_operand (operands[0], E_SImode))
    {
      operands[3] = x3;
      if (minmax_operator (operands[3], E_SImode)
          && 
#line 4227 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && optimize_function_for_size_p (cfun) && !arm_restrict_it))
        {
          *pnum_clobbers = 1;
          return 124; /* *store_minmaxsi */
        }
    }
  if (!arm_rhs_operand (operands[2], E_SImode)
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  switch (GET_CODE (x3))
    {
    case SMAX:
      if (!
#line 34 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1007; /* *thumb2_smaxsi3 */

    case SMIN:
      if (!
#line 55 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1008; /* *thumb2_sminsi3 */

    case UMAX:
      if (!
#line 76 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1009; /* *thumb32_umaxsi3 */

    case UMIN:
      if (!
#line 97 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1010; /* *thumb2_uminsi3 */

    default:
      return -1;
    }
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!
#line 4360 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
        return -1;
      return 127; /* arm_qadd_insn */

    case 1:
      if (register_operand (operands[0], E_V8QImode)
          && register_operand (operands[1], E_V8QImode)
          && register_operand (operands[2], E_V8QImode)
          && 
#line 351 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 555; /* ssaddv8qi3 */
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !s_register_operand (operands[2], E_V8QImode)
          || !
#line 1429 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1454; /* *ss_addv8qi_neon */

    case 2:
      if (register_operand (operands[0], E_V4HImode)
          && register_operand (operands[1], E_V4HImode)
          && register_operand (operands[2], E_V4HImode)
          && 
#line 361 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 556; /* ssaddv4hi3 */
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !s_register_operand (operands[2], E_V4HImode)
          || !
#line 1429 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1455; /* *ss_addv4hi_neon */

    case 3:
      if (register_operand (operands[0], E_V2SImode)
          && register_operand (operands[1], E_V2SImode)
          && register_operand (operands[2], E_V2SImode)
          && 
#line 371 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 557; /* ssaddv2si3 */
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !s_register_operand (operands[2], E_V2SImode)
          || !
#line 1429 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1456; /* *ss_addv2si_neon */

    case 4:
      if (!
#line 1429 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1457; /* *ss_addv2sf_neon */

    case 5:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3204; /* *arm_ssaddv4qq3 */

    case 6:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3205; /* *arm_ssaddv2hq3 */

    case 7:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3206; /* *arm_ssaddqq3 */

    case 8:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3207; /* *arm_ssaddhq3 */

    case 9:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3208; /* *arm_ssaddv2ha3 */

    case 10:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3209; /* *arm_ssaddha3 */

    case 11:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 3210; /* *arm_ssaddsq3 */

    case 12:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 3211; /* *arm_ssaddsa3 */

    default:
      return -1;
    }
}

 int
recog_320 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern4 (x1))
    {
    case 0:
      if (register_operand (operands[0], E_V8QImode)
          && register_operand (operands[1], E_V8QImode)
          && register_operand (operands[2], E_V8QImode)
          && 
#line 451 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 567; /* ussubv8qi3 */
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !s_register_operand (operands[2], E_V8QImode)
          || !
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1466; /* *us_subv8qi_neon */

    case 1:
      if (register_operand (operands[0], E_V4HImode)
          && register_operand (operands[1], E_V4HImode)
          && register_operand (operands[2], E_V4HImode)
          && 
#line 461 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 568; /* ussubv4hi3 */
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !s_register_operand (operands[2], E_V4HImode)
          || !
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1467; /* *us_subv4hi_neon */

    case 2:
      if (register_operand (operands[0], E_V2SImode)
          && register_operand (operands[1], E_V2SImode)
          && register_operand (operands[2], E_V2SImode)
          && 
#line 471 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 569; /* ussubv2si3 */
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !s_register_operand (operands[2], E_V2SImode)
          || !
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1468; /* *us_subv2si_neon */

    case 3:
      if (!
#line 1456 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1469; /* *us_subv2sf_neon */

    case 4:
      if (!
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3225; /* ussubv4uqq3 */

    case 5:
      if (!
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3226; /* ussubv2uhq3 */

    case 6:
      if (!
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3227; /* ussubuqq3 */

    case 7:
      if (!
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3228; /* ussubuhq3 */

    case 8:
      if (!
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3229; /* ussubv2uha3 */

    case 9:
      if (!
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD))
        return -1;
      return 3230; /* ussubuha3 */

    default:
      return -1;
    }
}

 int
recog_327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[1] = x7;
  if (!const_int_M_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 2);
  operands[2] = x8;
  if (!const_int_M_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x2, 1);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_SImode)
      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3524 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch_thumb2)))
    return -1;
  return 6441; /* *p insv_t2 */
}

 int
recog_330 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  switch (XVECLEN (x6, 0))
    {
    case 8:
      if (pattern472 (x6, 
E_V8QImode) != 0)
        return -1;
      x7 = XVECEXP (x6, 0, 4);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x6, 0, 5);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x6, 0, 6);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x6, 0, 7);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !s_register_operand (operands[0], E_V8QImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 574 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6712; /* *p iwmmxt_clrv8qi */

    case 4:
      if (pattern472 (x6, 
E_V4HImode) != 0
          || !s_register_operand (operands[0], E_V4HImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 584 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6713; /* *p iwmmxt_clrv4hi */

    case 2:
      if (GET_MODE (x6) != E_V2SImode)
        return -1;
      x11 = XVECEXP (x6, 0, 0);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x12 = XVECEXP (x6, 0, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V2SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 593 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6714; /* *p iwmmxt_clrv2si */

    default:
      return -1;
    }
}

 int
recog_334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x5) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode)
            return -1;
          operands[3] = x7;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2292 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2)))
            return -1;
          return 6414; /* *p *mls */

        case E_SFmode:
          if (pattern555 (x5, 
E_SFmode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1279 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6927; /* *p *mulsf3negsfaddsf_vfp */

        case E_DFmode:
          if (pattern555 (x5, 
E_DFmode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1290 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6928; /* *p *fmuldf3negdfadddf_vfp */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern540 (x6, 
E_SImode) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (pattern627 (x6))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 794 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6870; /* *p iwmmxt_wmiawbbn */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 807 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6871; /* *p iwmmxt_wmiawbtn */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 820 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6872; /* *p iwmmxt_wmiawtbn */

        case 3:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 833 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6873; /* *p iwmmxt_wmiawttn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case MINUS:
      if (GET_MODE (x5) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x8 = XEXP (x1, 0);
              operands[4] = x8;
              x9 = XEXP (x8, 0);
              operands[5] = x9;
              if (!reg_or_int_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[3] = x10;
              if (!arm_borrow_operation (operands[3], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1697 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6403; /* *p subsi3_carryin */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[2] = x7;
              if (!shift_operator (operands[2], E_SImode))
                return -1;
              x8 = XEXP (x1, 0);
              operands[6] = x8;
              x9 = XEXP (x8, 0);
              operands[7] = x9;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x11 = XEXP (x7, 0);
              operands[3] = x11;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x12 = XEXP (x7, 1);
              operands[4] = x12;
              if (!shift_amount_operand (operands[4], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[5] = x10;
              if (!arm_borrow_operation (operands[5], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1831 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6407; /* *p *subsi3_carryin_shift */

            case GEU:
            case LTU:
              operands[5] = x7;
              if (!arm_borrow_operation (operands[5], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              if (!shift_operator (x10, E_SImode))
                return -1;
              operands[2] = x10;
              x8 = XEXP (x1, 0);
              operands[6] = x8;
              x9 = XEXP (x8, 0);
              operands[7] = x9;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x13 = XEXP (x10, 0);
              operands[3] = x13;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x14 = XEXP (x10, 1);
              operands[4] = x14;
              if (!shift_amount_operand (operands[4], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1848 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6408; /* *p *subsi3_carryin_shift_alt */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[2] = x6;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x1, 0);
          operands[6] = x8;
          x9 = XEXP (x8, 0);
          operands[7] = x9;
          x15 = XEXP (x6, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x16 = XEXP (x6, 1);
          operands[4] = x16;
          if (!shift_amount_operand (operands[4], E_SImode))
            return -1;
          x7 = XEXP (x5, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[5] = x10;
              if (!arm_borrow_operation (operands[5], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1866 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM)))
                return -1;
              return 6409; /* *p *rsbsi3_carryin_shift */

            case GEU:
            case LTU:
              operands[5] = x7;
              if (!arm_borrow_operation (operands[5], E_SImode))
                return -1;
              x10 = XEXP (x4, 1);
              operands[1] = x10;
              if (!s_register_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1881 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM)))
                return -1;
              return 6410; /* *p *rsbsi3_carryin_shift_alt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[1] = x5;
      if (!arm_carry_operation (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x1, 0);
      operands[3] = x8;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1714 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM)))
        return -1;
      return 6404; /* *p rsbsi_carryin_reg */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x10;
          x8 = XEXP (x1, 0);
          operands[3] = x8;
          x9 = XEXP (x8, 0);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!s_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !reg_or_int_operand (operands[1], E_SImode)
                  || !reg_or_int_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2020 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6411; /* *p *arm_subsi3_insn */

            case E_V2SImode:
              if (pattern311 (x4, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 411 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6695; /* *p *subv2si3_iwmmxt */

            case E_V4HImode:
              if (pattern311 (x4, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 411 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6696; /* *p *subv4hi3_iwmmxt */

            case E_V8QImode:
              if (pattern311 (x4, 
E_V8QImode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 411 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6697; /* *p *subv8qi3_iwmmxt */

            case E_SFmode:
              if (pattern310 (x4, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1038 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
                return -1;
              return 6913; /* *p *subsf3_vfp */

            case E_DFmode:
              if (pattern310 (x4, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1048 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                return -1;
              return 6914; /* *p *subdf3_vfp */

            case E_QQmode:
              if (pattern310 (x4, 
E_QQmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7026; /* *p subqq3 */

            case E_HQmode:
              if (pattern310 (x4, 
E_HQmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7027; /* *p subhq3 */

            case E_SQmode:
              if (pattern310 (x4, 
E_SQmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7028; /* *p subsq3 */

            case E_UQQmode:
              if (pattern310 (x4, 
E_UQQmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7029; /* *p subuqq3 */

            case E_UHQmode:
              if (pattern310 (x4, 
E_UHQmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7030; /* *p subuhq3 */

            case E_USQmode:
              if (pattern310 (x4, 
E_USQmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7031; /* *p subusq3 */

            case E_HAmode:
              if (pattern310 (x4, 
E_HAmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7032; /* *p subha3 */

            case E_SAmode:
              if (pattern310 (x4, 
E_SAmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7033; /* *p subsa3 */

            case E_UHAmode:
              if (pattern310 (x4, 
E_UHAmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7034; /* *p subuha3 */

            case E_USAmode:
              if (pattern310 (x4, 
E_USAmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 84 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT)))
                return -1;
              return 7035; /* *p subusa3 */

            case E_V4QQmode:
              if (pattern310 (x4, 
E_V4QQmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
                return -1;
              return 7036; /* *p *arm_subv4qq3 */

            case E_V2HQmode:
              if (pattern310 (x4, 
E_V2HQmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
                return -1;
              return 7037; /* *p *arm_subv2hq3 */

            case E_V2HAmode:
              if (pattern310 (x4, 
E_V2HAmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 105 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_GE_BITS_READ)))
                return -1;
              return 7038; /* *p *arm_subv2ha3 */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (GET_CODE (x10) == MULT)
            {
              res = recog_334 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[2] = x10;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x1, 0);
          operands[5] = x8;
          x9 = XEXP (x8, 0);
          operands[6] = x9;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          x13 = XEXP (x10, 0);
          operands[3] = x13;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x14 = XEXP (x10, 1);
          operands[4] = x14;
          if (!shift_amount_operand (operands[4], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9767 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6589; /* *p *sub_shiftsi */

        case PLUS:
          if (pattern438 (x10) != 0)
            return -1;
          x13 = XEXP (x10, 0);
          x17 = XEXP (x13, 0);
          x18 = XEXP (x17, 0);
          if (GET_CODE (x18) != VEC_SELECT
              || GET_MODE (x18) != E_HImode)
            return -1;
          x19 = XEXP (x18, 1);
          if (GET_CODE (x19) != PARALLEL
              || XVECLEN (x19, 0) != 1)
            return -1;
          x20 = XVECEXP (x19, 0, 0);
          if (GET_CODE (x20) != CONST_INT)
            return -1;
          x21 = XEXP (x13, 1);
          if (pattern600 (x21, 
E_HImode, 
E_DImode, 
SIGN_EXTEND) != 0)
            return -1;
          x22 = XEXP (x21, 0);
          x23 = XEXP (x22, 1);
          if (GET_CODE (x23) != PARALLEL
              || XVECLEN (x23, 0) != 1)
            return -1;
          x24 = XVECEXP (x23, 0, 0);
          if (GET_CODE (x24) != CONST_INT)
            return -1;
          x14 = XEXP (x10, 1);
          if (pattern583 (x14) != 0)
            return -1;
          x25 = XEXP (x14, 0);
          x26 = XEXP (x25, 0);
          if (GET_CODE (x26) != VEC_SELECT
              || GET_MODE (x26) != E_HImode)
            return -1;
          x27 = XEXP (x26, 1);
          if (GET_CODE (x27) != PARALLEL
              || XVECLEN (x27, 0) != 1)
            return -1;
          x28 = XVECEXP (x27, 0, 0);
          if (GET_CODE (x28) != CONST_INT)
            return -1;
          x29 = XEXP (x14, 1);
          if (GET_CODE (x29) != SIGN_EXTEND
              || GET_MODE (x29) != E_DImode)
            return -1;
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != VEC_SELECT
              || GET_MODE (x30) != E_HImode)
            return -1;
          x31 = XEXP (x30, 1);
          if (GET_CODE (x31) != PARALLEL
              || XVECLEN (x31, 0) != 1)
            return -1;
          x32 = XVECEXP (x31, 0, 0);
          if (GET_CODE (x32) != CONST_INT)
            return -1;
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 0);
          operands[5] = x9;
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          switch (pattern656 (x10))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6862; /* *p iwmmxt_wmiabbn */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 681 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6863; /* *p iwmmxt_wmiabtn */

            case 2:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 705 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6864; /* *p iwmmxt_wmiatbn */

            case 3:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 729 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6865; /* *p iwmmxt_wmiattn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 0);
          operands[5] = x9;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          switch (GET_CODE (operands[3]))
            {
            case CONST_INT:
              if (!power_of_two_operand (operands[3], E_SImode)
                  || !s_register_operand (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || GET_MODE (x5) != E_SImode
                  || !s_register_operand (operands[2], E_SImode)
                  || !s_register_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9686 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6580; /* *p *rsb_multsi */

            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern569 (x4, 
E_SFmode) != 0
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1245 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
                    return -1;
                  return 6925; /* *p *mulsf3subsf_vfp */

                case E_DFmode:
                  if (pattern569 (x4, 
E_DFmode) != 0
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1256 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                    return -1;
                  return 6926; /* *p *muldf3subdf_vfp */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          if (pattern406 (x5, 
2, 
0) != 0)
            return -1;
          x7 = XEXP (x5, 1);
          x12 = XEXP (x7, 1);
          x33 = XVECEXP (x12, 0, 0);
          if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x34 = XVECEXP (x12, 0, 1);
          if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x10 = XEXP (x4, 1);
          if (pattern599 (x10, 
3, 
1) != 0)
            return -1;
          x14 = XEXP (x10, 1);
          if (GET_CODE (x14) != VEC_SELECT
              || GET_MODE (x14) != E_V2SImode)
            return -1;
          x29 = XEXP (x14, 1);
          if (GET_CODE (x29) != PARALLEL
              || XVECLEN (x29, 0) != 2)
            return -1;
          x35 = XVECEXP (x29, 0, 0);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x36 = XVECEXP (x29, 0, 1);
          if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          switch (pattern636 (x1))
            {
            case 0:
              if (pattern652 (x4, 
SIGN_EXTEND) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 232 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6835; /* *p iwmmxt_wmaddsn */

            case 1:
              if (pattern652 (x4, 
ZERO_EXTEND) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 251 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6836; /* *p iwmmxt_wmaddun */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x1, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 0);
          operands[5] = x9;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern556 (x4, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1316 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
                return -1;
              return 6929; /* *p *mulsf3negsfsubsf_vfp */

            case E_DFmode:
              if (pattern556 (x4, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1328 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                return -1;
              return 6930; /* *p *muldf3negdfsubdf_vfp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x5;
      if (pattern407 (x1) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9700 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT)))
        return -1;
      return 6585; /* *p *rsb_shiftsi */

    default:
      return -1;
    }
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!register_operand (operands[1], E_V2SImode)
          || XVECLEN (x4, 0) != 1)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x9 = XVECEXP (x4, 0, 0);
      operands[2] = x9;
      if (!immediate_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 770 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6726; /* *p iwmmxt_textrmw */

    case ZERO_EXTEND:
      switch (pattern413 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1141 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6761; /* *p iwmmxt_wunpckehub */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6767; /* *p iwmmxt_wunpckelub */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1152 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6762; /* *p iwmmxt_wunpckehuh */

        case 3:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6768; /* *p iwmmxt_wunpckeluh */

        case 4:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6763; /* *p iwmmxt_wunpckehuw */

        case 5:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1231 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6769; /* *p iwmmxt_wunpckeluw */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern413 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1175 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6764; /* *p iwmmxt_wunpckehsb */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1243 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6770; /* *p iwmmxt_wunpckelsb */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1186 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6765; /* *p iwmmxt_wunpckehsh */

        case 3:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1254 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6771; /* *p iwmmxt_wunpckelsh */

        case 4:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1197 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6766; /* *p iwmmxt_wunpckehsw */

        case 5:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1265 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6772; /* *p iwmmxt_wunpckelsw */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_365 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[5] = x6;
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  x8 = XVECEXP (x2, 0, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x12 = XEXP (x8, 1);
  operands[2] = x12;
  x13 = XEXP (x5, 1);
  operands[3] = x13;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x14 = XEXP (x3, 1);
  operands[4] = x14;
  x15 = XEXP (x5, 0);
  if (!rtx_equal_p (x15, operands[0])
      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12765 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && ((INTVAL (operands[1]) + 4) == INTVAL (operands[3]))
     && (operands_ok_ldrd_strd (operands[2], operands[4],
                                  operands[0], INTVAL (operands[1]),
                                  false, false)))))
    return -1;
  return 6613; /* *p *thumb2_strd */
}

 int
recog_371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x6) != SET)
    return -1;
  switch (pattern443 (x2))
    {
    case 0:
      if (pattern545 (x2) != 0)
        return -1;
      x7 = XEXP (x1, 0);
      operands[6] = x7;
      x8 = XEXP (x7, 0);
      operands[7] = x8;
      if (pattern606 (operands[0]) != 0)
        return -1;
      x9 = XEXP (x6, 0);
      operands[4] = x9;
      if (!arm_hard_general_register_operand (operands[4], E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[5] = x11;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x4, 1);
          x13 = XEXP (x12, 0);
          x14 = XEXP (x13, 1);
          if (XWINT (x14, 0) != 4L)
            return -1;
          x15 = XEXP (x5, 1);
          x16 = XEXP (x15, 0);
          x17 = XEXP (x16, 1);
          if (XWINT (x17, 0) != 8L)
            return -1;
          x18 = XEXP (x6, 1);
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XEXP (x19, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x23 = XEXP (x19, 0);
          if (!rtx_equal_p (x23, operands[5])
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 37 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
            return -1;
          return 6618; /* *p *ldm4_ */

        case PLUS:
          if (GET_MODE (x11) != E_SImode)
            return -1;
          x24 = XEXP (x11, 1);
          if (GET_CODE (x24) != CONST_INT)
            return -1;
          x25 = XEXP (x11, 0);
          operands[5] = x25;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x4, 1);
          x13 = XEXP (x12, 0);
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x15 = XEXP (x5, 1);
          x16 = XEXP (x15, 0);
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          switch (XWINT (x24, 0))
            {
            case 4L:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != 8L)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != 12L)
                return -1;
              x18 = XEXP (x6, 1);
              x19 = XEXP (x18, 0);
              if (pattern654 (x19, 
16) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6622; /* *p *ldm4_ib */

            case -12L:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -8L)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -4L)
                return -1;
              x18 = XEXP (x6, 1);
              x19 = XEXP (x18, 0);
              if (!rtx_equal_p (x19, operands[5])
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 231 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6626; /* *p *ldm4_da */

            case -16L:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -12L)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -8L)
                return -1;
              x18 = XEXP (x6, 1);
              x19 = XEXP (x18, 0);
              if (pattern654 (x19, 
-4) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 302 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6630; /* *p *ldm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern572 (x2) != 0)
        return -1;
      x7 = XEXP (x1, 0);
      operands[6] = x7;
      x8 = XEXP (x7, 0);
      operands[7] = x8;
      if (!store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x4, 1);
      operands[2] = x12;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x15 = XEXP (x5, 1);
      operands[3] = x15;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x18 = XEXP (x6, 1);
      operands[4] = x18;
      if (!arm_hard_general_register_operand (operands[4], E_SImode))
        return -1;
      x26 = XEXP (x3, 0);
      x27 = XEXP (x26, 0);
      switch (GET_CODE (x27))
        {
        case REG:
        case SUBREG:
          operands[5] = x27;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x28 = XEXP (x4, 0);
          x29 = XEXP (x28, 0);
          x30 = XEXP (x29, 1);
          if (XWINT (x30, 0) != 4L)
            return -1;
          x31 = XEXP (x5, 0);
          x32 = XEXP (x31, 0);
          x33 = XEXP (x32, 1);
          if (XWINT (x33, 0) != 8L)
            return -1;
          x9 = XEXP (x6, 0);
          x34 = XEXP (x9, 0);
          if (GET_CODE (x34) != PLUS
              || GET_MODE (x34) != E_SImode)
            return -1;
          x35 = XEXP (x34, 1);
          if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x36 = XEXP (x29, 0);
          if (!rtx_equal_p (x36, operands[5]))
            return -1;
          x37 = XEXP (x32, 0);
          if (!rtx_equal_p (x37, operands[5]))
            return -1;
          x38 = XEXP (x34, 0);
          if (!rtx_equal_p (x38, operands[5])
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 108 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
            return -1;
          return 6620; /* *p *stm4_ */

        case PLUS:
          if (GET_MODE (x27) != E_SImode)
            return -1;
          x39 = XEXP (x27, 1);
          if (GET_CODE (x39) != CONST_INT)
            return -1;
          x40 = XEXP (x27, 0);
          operands[5] = x40;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x28 = XEXP (x4, 0);
          x29 = XEXP (x28, 0);
          x36 = XEXP (x29, 0);
          if (!rtx_equal_p (x36, operands[5]))
            return -1;
          x31 = XEXP (x5, 0);
          x32 = XEXP (x31, 0);
          x37 = XEXP (x32, 0);
          if (!rtx_equal_p (x37, operands[5]))
            return -1;
          switch (XWINT (x39, 0))
            {
            case 4L:
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != 8L)
                return -1;
              x33 = XEXP (x32, 1);
              if (XWINT (x33, 0) != 12L)
                return -1;
              x9 = XEXP (x6, 0);
              x34 = XEXP (x9, 0);
              if (pattern655 (x34, 
16) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 196 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6624; /* *p *stm4_ib */

            case -12L:
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -8L)
                return -1;
              x33 = XEXP (x32, 1);
              if (XWINT (x33, 0) != -4L)
                return -1;
              x9 = XEXP (x6, 0);
              x34 = XEXP (x9, 0);
              if (!rtx_equal_p (x34, operands[5])
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 266 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6628; /* *p *stm4_da */

            case -16L:
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -12L)
                return -1;
              x33 = XEXP (x32, 1);
              if (XWINT (x33, 0) != -8L)
                return -1;
              x9 = XEXP (x6, 0);
              x34 = XEXP (x9, 0);
              if (pattern655 (x34, 
-4) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 338 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                return -1;
              return 6632; /* *p *stm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x7 = XEXP (x1, 0);
      operands[5] = x7;
      x8 = XEXP (x7, 0);
      operands[6] = x8;
      x26 = XEXP (x3, 0);
      operands[4] = x26;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[4]))
        return -1;
      x41 = XEXP (x10, 1);
      switch (XWINT (x41, 0))
        {
        case 12L:
          switch (pattern597 (x4))
            {
            case 0:
              if (pattern544 (x2) != 0)
                return -1;
              x18 = XEXP (x6, 1);
              x19 = XEXP (x18, 0);
              if (GET_CODE (x19) != PLUS
                  || GET_MODE (x19) != E_SImode)
                return -1;
              x20 = XEXP (x19, 1);
              if (GET_CODE (x20) != CONST_INT
                  || pattern634 (operands[0]) != 0)
                return -1;
              x15 = XEXP (x5, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x23 = XEXP (x19, 0);
              if (!rtx_equal_p (x23, operands[4]))
                return -1;
              switch (pattern647 (x2))
                {
                case 0:
                  x12 = XEXP (x4, 1);
                  x13 = XEXP (x12, 0);
                  if (!rtx_equal_p (x13, operands[4]))
                    return -1;
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != 4L
                      || XWINT (x20, 0) != 8L
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6635; /* *p *ldm3_ia_update */

                case 1:
                  x12 = XEXP (x4, 1);
                  x13 = XEXP (x12, 0);
                  x21 = XEXP (x13, 0);
                  if (!rtx_equal_p (x21, operands[4])
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 600 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6639; /* *p *ldm3_ib_update */

                default:
                  return -1;
                }

            case 1:
              if (pattern571 (x2) != 0)
                return -1;
              x9 = XEXP (x6, 0);
              x34 = XEXP (x9, 0);
              if (GET_CODE (x34) != PLUS
                  || GET_MODE (x34) != E_SImode)
                return -1;
              x35 = XEXP (x34, 1);
              if (GET_CODE (x35) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x5, 1);
              operands[2] = x15;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x18 = XEXP (x6, 1);
              operands[3] = x18;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x31 = XEXP (x5, 0);
              x32 = XEXP (x31, 0);
              x37 = XEXP (x32, 0);
              if (!rtx_equal_p (x37, operands[4]))
                return -1;
              x38 = XEXP (x34, 0);
              if (!rtx_equal_p (x38, operands[4]))
                return -1;
              switch (pattern649 (x2))
                {
                case 0:
                  x28 = XEXP (x4, 0);
                  x29 = XEXP (x28, 0);
                  if (!rtx_equal_p (x29, operands[4]))
                    return -1;
                  x33 = XEXP (x32, 1);
                  if (XWINT (x33, 0) != 4L
                      || XWINT (x35, 0) != 8L
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 552 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6637; /* *p *stm3_ia_update */

                case 1:
                  x28 = XEXP (x4, 0);
                  x29 = XEXP (x28, 0);
                  x36 = XEXP (x29, 0);
                  if (!rtx_equal_p (x36, operands[4])
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 628 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6641; /* *p *stm3_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -12L:
          x12 = XEXP (x4, 1);
          switch (GET_CODE (x12))
            {
            case MEM:
              if (pattern545 (x2) != 0
                  || pattern634 (operands[0]) != 0)
                return -1;
              x13 = XEXP (x12, 0);
              x21 = XEXP (x13, 0);
              if (!rtx_equal_p (x21, operands[4]))
                return -1;
              x15 = XEXP (x5, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x14 = XEXP (x13, 1);
              switch (XWINT (x14, 0))
                {
                case -8L:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -4L)
                    return -1;
                  x18 = XEXP (x6, 1);
                  x19 = XEXP (x18, 0);
                  if (!rtx_equal_p (x19, operands[4])
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 660 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6643; /* *p *ldm3_da_update */

                case -12L:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -8L)
                    return -1;
                  x18 = XEXP (x6, 1);
                  x19 = XEXP (x18, 0);
                  if (GET_CODE (x19) != PLUS
                      || GET_MODE (x19) != E_SImode)
                    return -1;
                  x20 = XEXP (x19, 1);
                  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x23 = XEXP (x19, 0);
                  if (!rtx_equal_p (x23, operands[4])
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 722 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6647; /* *p *ldm3_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x12;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern572 (x2) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x5, 1);
              operands[2] = x15;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x18 = XEXP (x6, 1);
              operands[3] = x18;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x28 = XEXP (x4, 0);
              x29 = XEXP (x28, 0);
              x36 = XEXP (x29, 0);
              if (!rtx_equal_p (x36, operands[4]))
                return -1;
              x31 = XEXP (x5, 0);
              x32 = XEXP (x31, 0);
              x37 = XEXP (x32, 0);
              if (!rtx_equal_p (x37, operands[4]))
                return -1;
              x30 = XEXP (x29, 1);
              switch (XWINT (x30, 0))
                {
                case -8L:
                  x33 = XEXP (x32, 1);
                  if (XWINT (x33, 0) != -4L)
                    return -1;
                  x9 = XEXP (x6, 0);
                  x34 = XEXP (x9, 0);
                  if (!rtx_equal_p (x34, operands[4])
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 688 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6645; /* *p *stm3_da_update */

                case -12L:
                  x33 = XEXP (x32, 1);
                  if (XWINT (x33, 0) != -8L)
                    return -1;
                  x9 = XEXP (x6, 0);
                  x34 = XEXP (x9, 0);
                  if (GET_CODE (x34) != PLUS
                      || GET_MODE (x34) != E_SImode)
                    return -1;
                  x35 = XEXP (x34, 1);
                  if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x38 = XEXP (x34, 0);
                  if (!rtx_equal_p (x38, operands[4])
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 750 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4)))
                    return -1;
                  return 6649; /* *p *stm3_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3)
    return NULL;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return NULL;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern26 (x1, 
E_CCmode) != 0)
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (pattern493 (x5) != 0)
    return NULL;
  if (
#line 9990 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch5t && TARGET_32BIT && peep2_regno_dead_p (3, CC_REGNUM)))
    {
      *pmatch_len_ = 2;
      res = gen_peephole2_8 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (!
#line 10007 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && peep2_regno_dead_p (3, CC_REGNUM)))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_9 (insn, operands);
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (arm_general_register_operand (operands[1], E_SImode))
    {
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == COMPARE
          && GET_MODE (x4) == E_CCmode)
        {
          x5 = XEXP (x4, 1);
          if (x5 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x6 = XEXP (x2, 0);
              if (GET_CODE (x6) == REG
                  && REGNO (x6) == 100
                  && GET_MODE (x6) == E_CCmode)
                {
                  x7 = XEXP (x4, 0);
                  if (rtx_equal_p (x7, operands[1])
                      && 
#line 11577 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_12 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
        }
    }
  operands[2] = x3;
  if (!memory_operand (operands[2], E_SImode))
    return NULL;
  x6 = XEXP (x2, 0);
  operands[1] = x6;
  if (!arm_general_register_operand (operands[1], E_SImode))
    return NULL;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!memory_operand (operands[3], E_SImode)
      || !
#line 36 "../../gcc-15.0.1-20250313/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_13 (insn, operands);
}

 rtx_insn *
peephole2_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  if (!memory_operand (operands[4], E_SImode))
    return NULL;
  x3 = XEXP (x1, 1);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 0);
  operands[6] = x8;
  if (!memory_operand (operands[6], E_SImode))
    return NULL;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x10 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x10) != SET)
    return NULL;
  x11 = XEXP (x10, 0);
  operands[7] = x11;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  x12 = XEXP (x10, 1);
  operands[3] = x12;
  if (!s_register_operand (operands[3], E_SImode))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_23 (insn, operands);
}

 rtx_insn *
peephole2_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 8)
    return NULL;
  x2 = XEXP (x1, 1);
  operands[8] = x2;
  x3 = PATTERN (peep2_next_insn (2));
  x4 = XEXP (x3, 0);
  if (!s_register_operand (x4, E_SImode))
    return NULL;
  x5 = XEXP (x3, 1);
  if (!const_int_operand (x5, E_SImode))
    return NULL;
  x6 = PATTERN (peep2_next_insn (4));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = PATTERN (peep2_next_insn (5));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 0);
  if (!memory_operand (x8, E_SImode))
    return NULL;
  x9 = PATTERN (peep2_next_insn (6));
  if (GET_CODE (x9) != SET)
    return NULL;
  x10 = PATTERN (peep2_next_insn (7));
  if (GET_CODE (x10) != SET)
    return NULL;
  x11 = XEXP (x10, 0);
  operands[7] = x11;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  x12 = PATTERN (peep2_next_insn (1));
  x13 = XEXP (x12, 1);
  switch (GET_CODE (x13))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x13, operands[0]))
        return NULL;
      x14 = XEXP (x12, 0);
      operands[4] = x14;
      if (!memory_operand (operands[4], E_SImode))
        return NULL;
      operands[1] = x4;
      operands[9] = x5;
      x15 = PATTERN (peep2_next_insn (3));
      x16 = XEXP (x15, 0);
      operands[5] = x16;
      if (!memory_operand (operands[5], E_SImode))
        return NULL;
      x17 = XEXP (x15, 1);
      if (!rtx_equal_p (x17, operands[1]))
        return NULL;
      x18 = XEXP (x6, 0);
      operands[2] = x18;
      if (!s_register_operand (operands[2], E_SImode))
        return NULL;
      x19 = XEXP (x6, 1);
      operands[10] = x19;
      if (!const_int_operand (operands[10], E_SImode))
        return NULL;
      operands[6] = x8;
      x20 = XEXP (x7, 1);
      if (!rtx_equal_p (x20, operands[2]))
        return NULL;
      x21 = XEXP (x9, 0);
      operands[3] = x21;
      if (!s_register_operand (operands[3], E_SImode))
        return NULL;
      x22 = XEXP (x9, 1);
      operands[11] = x22;
      if (!const_int_operand (operands[11], E_SImode))
        return NULL;
      x23 = XEXP (x10, 1);
      if (!rtx_equal_p (x23, operands[3]))
        return NULL;
      *pmatch_len_ = 7;
      return gen_peephole2_21 (insn, operands);

    case CONST_INT:
      operands[9] = x13;
      if (!const_int_operand (operands[9], E_SImode))
        return NULL;
      x14 = XEXP (x12, 0);
      operands[1] = x14;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      operands[2] = x4;
      operands[10] = x5;
      x15 = PATTERN (peep2_next_insn (3));
      x16 = XEXP (x15, 0);
      operands[3] = x16;
      if (!s_register_operand (operands[3], E_SImode))
        return NULL;
      x17 = XEXP (x15, 1);
      operands[11] = x17;
      if (!const_int_operand (operands[11], E_SImode))
        return NULL;
      x18 = XEXP (x6, 0);
      operands[4] = x18;
      if (!memory_operand (operands[4], E_SImode))
        return NULL;
      x19 = XEXP (x6, 1);
      if (!rtx_equal_p (x19, operands[0]))
        return NULL;
      operands[5] = x8;
      x20 = XEXP (x7, 1);
      if (!rtx_equal_p (x20, operands[1]))
        return NULL;
      x21 = XEXP (x9, 0);
      operands[6] = x21;
      if (!memory_operand (operands[6], E_SImode))
        return NULL;
      x22 = XEXP (x9, 1);
      if (!rtx_equal_p (x22, operands[2]))
        return NULL;
      x23 = XEXP (x10, 1);
      if (!rtx_equal_p (x23, operands[3]))
        return NULL;
      *pmatch_len_ = 7;
      return gen_peephole2_22 (insn, operands);

    default:
      return NULL;
    }
}
