/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern10 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern16 (rtx x1, rtx_code i1, rtx_code i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != i3)
    return -1;
  return 0;
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  switch (GET_CODE (x4))
    {
    case MEM:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      return 0;

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 39)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (GET_MODE (x1) != E_V4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      return 0;

    case E_V2SImode:
      if (GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[1] = x2;
      return 1;

    case E_DImode:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern27 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern27 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern27 (x1, 
E_V8HImode) != 0)
        return -1;
      return 5;

    case E_V4SImode:
      if (pattern27 (x1, 
E_V4SImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern38 (x3, 
E_V4HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern38 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8BImode:
      return pattern49 (x3, 
E_V8BImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4BImode:
      if (pattern49 (x3, 
E_V4BImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern54 (x3, 
E_V8HImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern55 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern51 (x3, 
E_V16BImode, 
E_V16QImode, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern51 (x3, 
E_V8BImode, 
E_V8HImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern51 (x3, 
E_V4BImode, 
E_V4SImode, 
E_SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern76 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern59 (x3, 
E_V8BImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern59 (x3, 
E_V4BImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern51 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern51 (x3, 
E_V4BImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 3;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 4;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern41 (x3, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern41 (x3, 
E_SFmode) != 0)
        return -1;
      return 1;

    case E_DFmode:
      if (pattern41 (x3, 
E_DFmode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 4;

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 5;

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 8;

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !mve_imm_8 (operands[2], E_SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (pattern166 (x3, 
E_V8HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern167 (x3, 
E_V4SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern183 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern40 (x3, 
E_V8HFmode, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern40 (x3, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern192 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arm_low_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!arm_low_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern201 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !mve_imm_16 (operands[3], E_SImode)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], E_V4SImode)
      || !mve_imm_32 (operands[3], E_SImode)
      || !vpr_register_operand (operands[4], E_V4BImode))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern211 (x3, 
E_V16BImode, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern211 (x3, 
E_V8BImode, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern211 (x3, 
E_V4BImode, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern223 (x3, 
E_V16BImode, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern223 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern235 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BImode:
          return pattern233 (x1, 
E_V16QImode, 
E_V16BImode); /* [-1, 0] */

        case E_V8BImode:
          if (!vpr_register_operand (operands[0], E_V8BImode)
              || GET_MODE (x1) != E_V8BImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!s_register_operand (operands[1], E_V8HImode)
                  || !s_register_operand (operands[2], E_V8HImode))
                return -1;
              return 1;

            case E_V8HFmode:
              if (!s_register_operand (operands[1], E_V8HFmode)
                  || !s_register_operand (operands[2], E_V8HFmode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case E_V4BImode:
          if (!vpr_register_operand (operands[0], E_V4BImode)
              || GET_MODE (x1) != E_V4BImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!s_register_operand (operands[1], E_V4SImode)
                  || !s_register_operand (operands[2], E_V4SImode))
                return -1;
              return 3;

            case E_V4SFmode:
              if (!s_register_operand (operands[1], E_V4SFmode)
                  || !s_register_operand (operands[2], E_V4SFmode))
                return -1;
              return 4;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BImode:
          if (pattern234 (x1, 
E_QImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 5;

        case E_V8BImode:
          if (!vpr_register_operand (operands[0], E_V8BImode)
              || GET_MODE (x1) != E_V8BImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!s_register_operand (operands[1], E_V8HImode)
                  || GET_MODE (x3) != E_V8HImode
                  || !s_register_operand (operands[2], E_HImode))
                return -1;
              return 6;

            case E_V8HFmode:
              if (!s_register_operand (operands[1], E_V8HFmode)
                  || GET_MODE (x3) != E_V8HFmode
                  || !s_register_operand (operands[2], E_HFmode))
                return -1;
              return 7;

            default:
              return -1;
            }

        case E_V4BImode:
          if (!vpr_register_operand (operands[0], E_V4BImode)
              || GET_MODE (x1) != E_V4BImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!s_register_operand (operands[1], E_V4SImode)
                  || GET_MODE (x3) != E_V4SImode
                  || !s_register_operand (operands[2], E_SImode))
                return -1;
              return 8;

            case E_V4SFmode:
              if (!s_register_operand (operands[1], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !s_register_operand (operands[2], E_SFmode))
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern274 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x2) != E_SImode
              || !s_register_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_HImode:
              if (!s_register_operand (operands[1], E_HImode))
                return -1;
              return 0;

            case E_QImode:
              if (!s_register_operand (operands[1], E_QImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V8HImode:
          if (pattern272 (x1, 
E_V8HImode, 
E_V8QImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (pattern272 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 3;

        case E_V2DImode:
          if (pattern272 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern273 (x1, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode) != 0)
            return -1;
          return 5;

        case E_V4SImode:
          if (pattern273 (x1, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
            return -1;
          return 6;

        case E_V2DImode:
          if (pattern273 (x1, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern299 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != MEM)
        return -1;
      return 0;

    case REG:
      operands[1] = x3;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern306 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  if (!arm_comparison_operator (operands[3], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  if (!arm_comparison_operator (x3, E_SImode))
    return -1;
  operands[6] = x3;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!arm_add_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  if (!s_register_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[5] = x7;
  if (!arm_add_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern321 (rtx x1, machine_mode i1, rtx_code i2, machine_mode i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 28
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 104
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 104
      || GET_MODE (x7) != E_CCmode
      || !s_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XVECEXP (x3, 0, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 1);
  operands[2] = x9;
  return 0;
}

int
pattern338 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern342 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[1], E_SImode)
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern354 (x1, 
E_V2SImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern354 (x1, 
E_V4SImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern364 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 28
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 104
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 104
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x3, 0, 0);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x10 = XVECEXP (x3, 0, 1);
  operands[2] = x10;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x11 = XVECEXP (x3, 0, 2);
  operands[3] = x11;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern382 (rtx x1, rtx_code i1, rtx_code i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != i3)
    return -1;
  return 0;
}

int
pattern387 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (XWINT (x5, 0) != 0L)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  x7 = XEXP (x3, 2);
  if (GET_CODE (x7) != PC)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  return pattern256 (x9); /* [-1, 0] */
}

int
pattern393 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern401 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern408 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x5) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 0;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x5) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern423 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern428 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !const_int_vcde2_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern435 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern441 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern311 (x3, 
E_V2SImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern311 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern311 (x3, 
E_V8QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern452 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern462 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern469 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!s_register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_HImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!s_register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8HImode:
          if (!s_register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_SImode:
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!s_register_operand (operands[1], E_V2SImode))
            return -1;
          return 4;

        case E_V4SImode:
          if (!s_register_operand (operands[1], E_V4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_SFmode:
      switch (GET_MODE (operands[1]))
        {
        case E_V2SFmode:
          if (!s_register_operand (operands[1], E_V2SFmode))
            return -1;
          return 6;

        case E_V4SFmode:
          if (!s_register_operand (operands[1], E_V4SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    case E_HFmode:
      if (!s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern500 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!neon_struct_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  return 0;
}

int
pattern505 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!neon_struct_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  return pattern504 (x2, 
i1, 
i2); /* [-1, 1] */
}

int
pattern512 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !const_int_vcde3_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern521 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !arm_general_register_operand (operands[0], E_SImode)
      || !arm_general_register_operand (operands[1], E_SImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern529 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !mem_noofs_operand (operands[1], i1)
      || !reg_or_int_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern538 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern549 (rtx x1, machine_mode i1, unsigned int i2, int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != i3
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern560 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern568 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern567 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern567 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || !mem_noofs_operand (operands[1], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !s_register_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern583 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MULT
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern588 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != i2
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != i1
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      return 0;

    case CLOBBER:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern600 (rtx x1, machine_mode i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != VEC_SELECT
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern607 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[6] = x6;
  if (!const_int_operand (operands[6], E_SImode))
    return -1;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x2, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x2, 2);
  operands[4] = x9;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern620 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_V2SImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!register_operand (operands[3], E_V2SImode))
    return -1;
  x8 = XEXP (x3, 1);
  x9 = XVECEXP (x8, 0, 0);
  switch (XWINT (x9, 0))
    {
    case 0L:
      x10 = XEXP (x6, 1);
      x11 = XVECEXP (x10, 0, 0);
      switch (XWINT (x11, 0))
        {
        case 0L:
          return 0;

        case 1L:
          return 1;

        default:
          return -1;
        }

    case 1L:
      x10 = XEXP (x6, 1);
      x11 = XVECEXP (x10, 0, 0);
      switch (XWINT (x11, 0))
        {
        case 0L:
          return 2;

        case 1L:
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern636 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  if (!register_operand (operands[0], E_V2SImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_V2SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_V2SImode)
    return -1;
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != E_V4SImode)
    return -1;
  x9 = XEXP (x6, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != E_V4SImode)
    return -1;
  x11 = XEXP (x5, 1);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != E_V4SImode)
    return -1;
  x14 = XEXP (x11, 1);
  x15 = XEXP (x14, 0);
  if (GET_MODE (x15) != E_V4SImode)
    return -1;
  switch (GET_CODE (x8))
    {
    case SIGN_EXTEND:
      return 0;

    case ZERO_EXTEND:
      return 1;

    default:
      return -1;
    }
}

int
pattern648 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!store_multiple_operation (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  if (!arm_hard_general_register_operand (operands[2], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 1);
  operands[3] = x5;
  if (!arm_hard_general_register_operand (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  x7 = XEXP (x6, 1);
  operands[4] = x7;
  if (!arm_hard_general_register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern656 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x9, 1);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  x16 = XEXP (x4, 1);
  x17 = XVECEXP (x16, 0, 0);
  switch (XWINT (x17, 0))
    {
    case 0L:
      x18 = XEXP (x11, 1);
      x19 = XVECEXP (x18, 0, 0);
      if (XWINT (x19, 0) != 2L)
        return -1;
      x20 = XEXP (x7, 1);
      x21 = XVECEXP (x20, 0, 0);
      switch (XWINT (x21, 0))
        {
        case 0L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 2L)
            return -1;
          return 0;

        case 1L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 3L)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 1L:
      x18 = XEXP (x11, 1);
      x19 = XVECEXP (x18, 0, 0);
      if (XWINT (x19, 0) != 3L)
        return -1;
      x20 = XEXP (x7, 1);
      x21 = XVECEXP (x20, 0, 0);
      switch (XWINT (x21, 0))
        {
        case 0L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 2L)
            return -1;
          return 2;

        case 1L:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 3L)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MULT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (pattern386 (x5, 
MULT, 
E_DImode, 
LSHIFTRT, 
TRUNCATE) != 0)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  operands[1] = x10;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x6, 0);
  x12 = XEXP (x11, 0);
  if (GET_MODE (x12) != E_DImode)
    return -1;
  x13 = XEXP (x11, 1);
  if (GET_MODE (x13) != E_DImode)
    return -1;
  switch (GET_CODE (x12))
    {
    case SIGN_EXTEND:
      if (GET_CODE (x13) != SIGN_EXTEND)
        return -1;
      x14 = XEXP (x12, 0);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[3])
          || !
#line 2444 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 67; /* smull */

    case ZERO_EXTEND:
      if (GET_CODE (x13) != ZERO_EXTEND)
        return -1;
      x14 = XEXP (x12, 0);
      if (!rtx_equal_p (x14, operands[2]))
        return -1;
      x15 = XEXP (x13, 0);
      if (!rtx_equal_p (x15, operands[3])
          || !
#line 2444 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 68; /* umull */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  switch (GET_CODE (x4))
    {
    case NE:
      res = recog_17 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case EQ:
      if (pattern387 (x1) == 0)
        {
          x6 = XEXP (x4, 0);
          operands[0] = x6;
          if (s_register_operand (operands[0], E_SImode))
            {
              x7 = XEXP (x3, 1);
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (
#line 1467 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1064; /* *thumb2_cbz */
            }
        }
      break;

    default:
      break;
    }
  if (XWINT (x5, 0) != 0L)
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x9 = XEXP (x3, 2);
  if (GET_CODE (x9) != PC)
    return -1;
  x10 = XEXP (x2, 0);
  if (GET_CODE (x10) != PC
      || !equality_operator (x4, E_VOIDmode))
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x12) != CLOBBER)
        return -1;
      operands[0] = x4;
      x13 = XEXP (x6, 0);
      operands[1] = x13;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      x14 = XEXP (x12, 0);
      operands[4] = x14;
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      if (XWINT (x11, 0) == 1L)
        {
          x15 = XEXP (x6, 2);
          operands[2] = x15;
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 1347 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 978; /* *tbit_cbranch */
        }
      x15 = XEXP (x6, 2);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[2] = x11;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 1392 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 979; /* *tlobits_cbranch */

    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x12 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x12) != SET)
        return -1;
      x16 = XEXP (x12, 1);
      if (GET_CODE (x16) != PLUS
          || GET_MODE (x16) != E_SImode)
        return -1;
      x17 = XEXP (x16, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      operands[3] = x4;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      x14 = XEXP (x12, 0);
      operands[0] = x14;
      if (!thumb_cbrch_target_operand (operands[0], E_SImode))
        return -1;
      x18 = XEXP (x16, 0);
      if (!rtx_equal_p (x18, operands[2])
          || !
#line 1474 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      *pnum_clobbers = 1;
      return 981; /* *cbranchne_decr1 */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x2, 1);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x4, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2083; /* *neon_vswpv8qi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2084; /* *neon_vswpv16qi */

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2085; /* *neon_vswpv4hi */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2086; /* *neon_vswpv8hi */

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2087; /* *neon_vswpv2si */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2088; /* *neon_vswpv4si */

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || !s_register_operand (operands[1], E_V4HFmode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2089; /* *neon_vswpv4hf */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2090; /* *neon_vswpv8hf */

    case E_V4BFmode:
      if (!s_register_operand (operands[0], E_V4BFmode)
          || !s_register_operand (operands[1], E_V4BFmode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2091; /* *neon_vswpv4bf */

    case E_V8BFmode:
      if (!s_register_operand (operands[0], E_V8BFmode)
          || !s_register_operand (operands[1], E_V8BFmode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2092; /* *neon_vswpv8bf */

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || !s_register_operand (operands[1], E_V2SFmode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2093; /* *neon_vswpv2sf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2094; /* *neon_vswpv4sf */

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || !s_register_operand (operands[1], E_DImode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2095; /* *neon_vswpdi */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || !s_register_operand (operands[1], E_V2DImode)
          || !
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
        return -1;
      return 2096; /* *neon_vswpv2di */

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (s_register_operand (operands[0], E_SImode))
    {
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) == E_SImode)
        {
          x5 = XEXP (x4, 1);
          operands[2] = x5;
          switch (GET_CODE (x4))
            {
            case SMAX:
              x6 = XEXP (x4, 0);
              switch (GET_CODE (x6))
                {
                case REG:
                case SUBREG:
                  if (pattern419 (x1) == 0
                      && 
#line 4088 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                    return 119; /* *arm_smax_insn */
                  break;

                case SMIN:
                  if (pattern420 (x1) == 0
                      && 
#line 4477 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[2], operands[1], NULL, NULL)))
                    return 136; /* satsi_smax_setq */
                  break;

                default:
                  break;
                }
              break;

            case SMIN:
              x6 = XEXP (x4, 0);
              switch (GET_CODE (x6))
                {
                case REG:
                case SUBREG:
                  if (pattern419 (x1) == 0
                      && 
#line 4138 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                    return 121; /* *arm_smin_insn */
                  break;

                case SMAX:
                  if (pattern420 (x1) == 0
                      && 
#line 4477 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL)))
                    return 134; /* satsi_smin_setq */
                  break;

                default:
                  break;
                }
              break;

            case UMAX:
              if (pattern388 (x1) == 0
                  && 
#line 4170 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 122; /* *arm_umaxsi3 */
              break;

            case UMIN:
              if (pattern388 (x1) == 0
                  && 
#line 4203 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 123; /* *arm_uminsi3 */
              break;

            default:
              break;
            }
        }
    }
  if (memory_operand (operands[0], E_SImode))
    {
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) == CLOBBER)
        {
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) == REG
              && REGNO (x8) == 100
              && GET_MODE (x8) == E_CCmode)
            {
              x4 = XEXP (x2, 1);
              operands[3] = x4;
              if (minmax_operator (operands[3], E_SImode))
                {
                  x6 = XEXP (x4, 0);
                  operands[1] = x6;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x5 = XEXP (x4, 1);
                      operands[2] = x5;
                      if (s_register_operand (operands[2], E_SImode)
                          && 
#line 4227 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && optimize_function_for_size_p (cfun) && !arm_restrict_it))
                        return 124; /* *store_minmaxsi */
                    }
                }
            }
        }
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (pattern256 (x7) != 0)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (x4))
    {
    case SMAX:
      if (!
#line 34 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      return 1007; /* *thumb2_smaxsi3 */

    case SMIN:
      if (!
#line 55 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      return 1008; /* *thumb2_sminsi3 */

    case UMAX:
      if (!
#line 76 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      return 1009; /* *thumb32_umaxsi3 */

    case UMIN:
      if (!
#line 97 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      return 1010; /* *thumb2_uminsi3 */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 17
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern287 (x1, 
CLOBBER, 
E_SImode, 
0) != 0
          || pattern478 (x1, 
E_SImode, 
14, 
9) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (pattern589 (x5, 
E_SImode, 
12) != 0)
        return -1;
      x6 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 100
          || GET_MODE (x7) != E_CCmode
          || !
#line 12314 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_SOFT_TP && TARGET_FDPIC))
        return -1;
      return 407; /* load_tp_soft_fdpic */

    case MEM:
      if (pnum_clobbers != NULL
          && pattern24 (x1) == 0
          && pattern641 (x1) == 0
          && pattern653 (x1) == 0
          && 
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        {
          *pnum_clobbers = 3;
          return 972; /* cpymem12b */
        }
      operands[1] = x3;
      if (pattern12 (x1) != 0)
        return -1;
      switch (pattern565 (x1))
        {
        case 0:
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 1);
          switch (pattern617 (x9))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3121; /* atomic_fetch_addqi */

            case 1:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3126; /* atomic_fetch_addhi */

            case 2:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3136; /* atomic_fetch_adddi */

            default:
              return -1;
            }

        case 1:
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 1);
          switch (pattern617 (x9))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3122; /* atomic_fetch_subqi */

            case 1:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3127; /* atomic_fetch_subhi */

            case 2:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3137; /* atomic_fetch_subdi */

            default:
              return -1;
            }

        case 2:
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 1);
          switch (pattern617 (x9))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3123; /* atomic_fetch_orqi */

            case 1:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3128; /* atomic_fetch_orhi */

            case 2:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3138; /* atomic_fetch_ordi */

            default:
              return -1;
            }

        case 3:
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 1);
          switch (pattern617 (x9))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3124; /* atomic_fetch_xorqi */

            case 1:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3129; /* atomic_fetch_xorhi */

            case 2:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3139; /* atomic_fetch_xordi */

            default:
              return -1;
            }

        case 4:
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 1);
          switch (pattern617 (x9))
            {
            case 0:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3125; /* atomic_fetch_andqi */

            case 1:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3130; /* atomic_fetch_andhi */

            case 2:
              if (!
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3140; /* atomic_fetch_anddi */

            default:
              return -1;
            }

        case 5:
          x8 = XVECEXP (x1, 0, 1);
          x9 = XEXP (x8, 1);
          x10 = XVECEXP (x9, 0, 0);
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != AND)
            return -1;
          x12 = XEXP (x11, 1);
          operands[2] = x12;
          x13 = XEXP (x11, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern622 (x9, 
E_QImode) != 0
                  || !
#line 432 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3141; /* atomic_fetch_nandqi */

            case E_HImode:
              if (pattern622 (x9, 
E_HImode) != 0
                  || !
#line 432 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3142; /* atomic_fetch_nandhi */

            case E_DImode:
              if (pattern623 (x9) != 0
                  || !
#line 432 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              return 3144; /* atomic_fetch_nanddi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      x14 = XEXP (x3, 0);
      if (GET_CODE (x14) != LEU)
        return -1;
      x15 = XEXP (x3, 1);
      if (pattern266 (x15) != 0)
        return -1;
      x16 = XEXP (x15, 0);
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != LABEL_REF
          || GET_MODE (x17) != E_SImode)
        return -1;
      x18 = XEXP (x3, 2);
      if (GET_CODE (x18) != LABEL_REF
          || GET_MODE (x18) != E_SImode)
        return -1;
      x19 = XEXP (x2, 0);
      if (GET_CODE (x19) != PC
          || pattern551 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != LABEL_REF
          || GET_MODE (x7) != E_SImode)
        return -1;
      x20 = XEXP (x14, 0);
      operands[0] = x20;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x21 = XEXP (x14, 1);
      operands[1] = x21;
      if (!arm_rhs_operand (operands[1], E_SImode))
        return -1;
      x22 = XEXP (x17, 0);
      operands[2] = x22;
      x23 = XEXP (x18, 0);
      operands[3] = x23;
      x24 = XVECEXP (x1, 0, 2);
      x25 = XEXP (x24, 0);
      operands[4] = x25;
      if (!scratch_operand (operands[4], E_SImode))
        return -1;
      x26 = XEXP (x5, 0);
      operands[5] = x26;
      if (!scratch_operand (operands[5], E_SImode))
        return -1;
      x27 = XEXP (x16, 0);
      x28 = XEXP (x27, 0);
      if (!rtx_equal_p (x28, operands[0]))
        return -1;
      x29 = XEXP (x7, 0);
      if (!rtx_equal_p (x29, operands[2])
          || !
#line 1201 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && flag_pic))
        return -1;
      return 1048; /* *thumb2_casesi_internal_pic */

    default:
      return -1;
    }
}

 int
recog_48 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CC_NZmode
      || GET_MODE (x2) != E_CC_NZmode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  if (
#line 2333 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6))
    {
      *pnum_clobbers = 1;
      return 61; /* *mulsi_compare0_scratch */
    }
  if (!
#line 2346 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6 && optimize_size))
    return -1;
  *pnum_clobbers = 1;
  return 62; /* *mulsi_compare0_scratch_v6 */
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != 100
      || GET_MODE (x4) != E_CC_Zmode
      || GET_MODE (x2) != E_CC_Zmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!s_register_operand (operands[0], E_QImode)
          || !
#line 5832 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 182; /* *compareqi_eq0 */

    case E_DImode:
      if (pnum_clobbers == NULL
          || !s_register_operand (operands[0], E_DImode)
          || !
#line 1724 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      *pnum_clobbers = 1;
      return 984; /* *thumb_cmpdi_zero */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_DImode
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x6) != E_DImode
              || pattern454 (x1) != 0)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[0]))
            return -1;
          x11 = XEXP (x9, 1);
          if (!rtx_equal_p (x11, operands[1])
              || !
#line 1007 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 9; /* *addsi3_compareV_reg_nosum */

        case CONST_INT:
          operands[1] = x6;
          if (!arm_addimm_operand (operands[1], E_VOIDmode)
              || pattern454 (x1) != 0)
            return -1;
          x8 = XEXP (x3, 1);
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          if (!rtx_equal_p (x10, operands[0]))
            return -1;
          x11 = XEXP (x9, 1);
          if (!rtx_equal_p (x11, operands[1])
              || !
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && INTVAL (operands[1]) == ARM_SIGN_EXTEND (INTVAL (operands[1]))))
            return -1;
          return 12; /* addsi3_compareV_imm_nosum */

        case GEU:
        case LTU:
          if (pnum_clobbers == NULL)
            return -1;
          operands[3] = x6;
          if (!arm_borrow_operation (operands[3], E_DImode)
              || GET_MODE (x2) != E_CC_SWPmode
              || GET_MODE (x3) != E_CC_SWPmode)
            return -1;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[1] = x8;
          if (!arm_immediate_operand (operands[1], E_VOIDmode)
              || !
#line 2128 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 50; /* rscsi3_CC_NVout_scratch */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[0] = x5;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      if (!arm_add_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          if (XWINT (x8, 0) == 0L
              && GET_MODE (x2) == E_CC_NZmode
              && GET_MODE (x3) == E_CC_NZmode)
            {
              if (
#line 1142 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 14; /* *addsi3_compare0_scratch */
              if (
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1060; /* *thumb2_addsi3_compare0_scratch */
            }
          break;

        case REG:
        case SUBREG:
          if (rtx_equal_p (x8, operands[0])
              && GET_MODE (x2) == E_CC_Cmode
              && GET_MODE (x3) == E_CC_Cmode
              && 
#line 1293 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 19; /* *compare_addsi2_op0 */
          break;

        default:
          break;
        }
      if (GET_MODE (x2) != E_CC_Cmode
          || GET_MODE (x3) != E_CC_Cmode
          || !rtx_equal_p (x8, operands[1])
          || !
#line 1316 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 20; /* *compare_addsi2_op1 */

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_DImode
          || pattern390 (x1, 
E_CC_SWPmode, 
E_DImode) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!arm_borrow_operation (operands[3], E_DImode))
        return -1;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      if (!arm_immediate_operand (operands[1], E_VOIDmode)
          || !
#line 2128 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 51; /* rscsi3_CC_Bout_scratch */

    case MULT:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_SImode)
        return -1;
      x8 = XEXP (x3, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern390 (x1, 
E_CC_NZmode, 
E_SImode) != 0)
        return -1;
      x13 = XEXP (x5, 1);
      operands[1] = x13;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      if (
#line 2395 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6))
        {
          *pnum_clobbers = 1;
          return 65; /* *mulsi3addsi_compare0_scratch */
        }
      if (!
#line 2410 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6 && optimize_size))
        return -1;
      *pnum_clobbers = 1;
      return 66; /* *mulsi3addsi_compare0_scratch_v6 */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern429 (x3, 
E_V8QImode, 
E_QImode) != 0
          || !
#line 5143 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2624; /* neon_vld1_lanev8qi */

    case E_V4HImode:
      if (pattern429 (x3, 
E_V4HImode, 
E_HImode) != 0
          || !
#line 5143 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2625; /* neon_vld1_lanev4hi */

    case E_V4HFmode:
      if (pattern429 (x3, 
E_V4HFmode, 
E_HFmode) != 0
          || !
#line 5143 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2626; /* neon_vld1_lanev4hf */

    case E_V4BFmode:
      if (pattern429 (x3, 
E_V4BFmode, 
E_BFmode) != 0
          || !
#line 5143 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2627; /* neon_vld1_lanev4bf */

    case E_V2SImode:
      if (pattern429 (x3, 
E_V2SImode, 
E_SImode) != 0
          || !
#line 5143 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2628; /* neon_vld1_lanev2si */

    case E_V2SFmode:
      if (pattern429 (x3, 
E_V2SFmode, 
E_SFmode) != 0
          || !
#line 5143 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2629; /* neon_vld1_lanev2sf */

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !neon_struct_operand (operands[1], E_DImode)
          || !s_register_operand (operands[2], E_DImode)
          || !
#line 5143 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2630; /* neon_vld1_lanedi */

    case E_V16QImode:
      if (pattern429 (x3, 
E_V16QImode, 
E_QImode) != 0
          || !
#line 5164 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2631; /* neon_vld1_lanev16qi */

    case E_V8HImode:
      if (pattern429 (x3, 
E_V8HImode, 
E_HImode) != 0
          || !
#line 5164 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2632; /* neon_vld1_lanev8hi */

    case E_V8HFmode:
      if (pattern429 (x3, 
E_V8HFmode, 
E_HFmode) != 0
          || !
#line 5164 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2633; /* neon_vld1_lanev8hf */

    case E_V8BFmode:
      if (pattern429 (x3, 
E_V8BFmode, 
E_BFmode) != 0
          || !
#line 5164 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2634; /* neon_vld1_lanev8bf */

    case E_V4SImode:
      if (pattern429 (x3, 
E_V4SImode, 
E_SImode) != 0
          || !
#line 5164 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2635; /* neon_vld1_lanev4si */

    case E_V4SFmode:
      if (pattern429 (x3, 
E_V4SFmode, 
E_SFmode) != 0
          || !
#line 5164 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2636; /* neon_vld1_lanev4sf */

    case E_V2DImode:
      if (pattern429 (x3, 
E_V2DImode, 
E_DImode) != 0
          || !
#line 5164 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2637; /* neon_vld1_lanev2di */

    default:
      return -1;
    }
}

 int
recog_67 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern45 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x2 = XEXP (x1, 1);
      if (pattern500 (x2, 
E_TImode, 
E_HImode) != 0
          || !
#line 5587 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2821; /* neon_vst2_lanev8qi */

    case E_SImode:
      x2 = XEXP (x1, 1);
      switch (pattern502 (x2, 
E_V4HImode, 
E_V8HImode, 
E_SImode))
        {
        case 0:
          if (!
#line 5587 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2822; /* neon_vst2_lanev4hi */

        case 1:
          if (!
#line 5611 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2827; /* neon_vst2_lanev8hi */

        default:
          return -1;
        }

    case E_SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern502 (x2, 
E_V4HFmode, 
E_V8HFmode, 
E_SFmode))
        {
        case 0:
          if (!
#line 5587 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2823; /* neon_vst2_lanev4hf */

        case 1:
          if (!
#line 5611 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2828; /* neon_vst2_lanev8hf */

        default:
          return -1;
        }

    case E_BFmode:
      x2 = XEXP (x1, 1);
      switch (pattern502 (x2, 
E_V4BFmode, 
E_V8BFmode, 
E_BFmode))
        {
        case 0:
          if (!
#line 5587 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2824; /* neon_vst2_lanev4bf */

        case 1:
          if (!(
#line 5611 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2831; /* neon_vst2_lanev8bf */

        default:
          return -1;
        }

    case E_V2SImode:
      x2 = XEXP (x1, 1);
      switch (pattern503 (x2, 
E_V2SImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 5587 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2825; /* neon_vst2_lanev2si */

        case 1:
          if (!
#line 5611 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2829; /* neon_vst2_lanev4si */

        default:
          return -1;
        }

    case E_V2SFmode:
      x2 = XEXP (x1, 1);
      switch (pattern503 (x2, 
E_V2SFmode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 5587 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2826; /* neon_vst2_lanev2sf */

        case 1:
          if (!
#line 5611 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2830; /* neon_vst2_lanev4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern427 (x3, 
E_SImode) != 0
          || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 931; /* arm_vcx1asi */

    case E_DImode:
      if (pattern427 (x3, 
E_DImode) != 0
          || !
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 932; /* arm_vcx1adi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[2], E_V16QImode)
          || !const_int_mve_cde1_operand (operands[3], E_SImode)
          || !
#line 4448 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5050; /* arm_vcx1qav16qi */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern33 (x1))
    {
    case 0:
      if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1560; /* neon_vmlav8qi_unspec */

    case 1:
      if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1561; /* neon_vmlav16qi_unspec */

    case 2:
      if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1562; /* neon_vmlav4hi_unspec */

    case 3:
      if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1563; /* neon_vmlav8hi_unspec */

    case 4:
      if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1564; /* neon_vmlav2si_unspec */

    case 5:
      if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1565; /* neon_vmlav4si_unspec */

    case 6:
      if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1566; /* neon_vmlav2sf_unspec */

    case 7:
      if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1567; /* neon_vmlav4sf_unspec */

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern70 (x1))
    {
    case 0:
      if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4141; /* mve_vpselq_sv16qi */

    case 1:
      if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4143; /* mve_vpselq_sv8hi */

    case 2:
      if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4145; /* mve_vpselq_sv4si */

    case 3:
      if (!
#line 1918 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4147; /* mve_vpselq_sv2di */

    default:
      return -1;
    }
}

 int
recog_105 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !neon_struct_operand (operands[1], E_V8QImode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2526; /* neon_vld1v8qi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !neon_struct_operand (operands[1], E_V16QImode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2527; /* neon_vld1v16qi */

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !neon_struct_operand (operands[1], E_V4HImode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2528; /* neon_vld1v4hi */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !neon_struct_operand (operands[1], E_V8HImode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2529; /* neon_vld1v8hi */

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !neon_struct_operand (operands[1], E_V2SImode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2530; /* neon_vld1v2si */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !neon_struct_operand (operands[1], E_V4SImode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2531; /* neon_vld1v4si */

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !neon_struct_operand (operands[1], E_V4HFmode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2532; /* neon_vld1v4hf */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !neon_struct_operand (operands[1], E_V8HFmode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2533; /* neon_vld1v8hf */

    case E_V4BFmode:
      if (!s_register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !neon_struct_operand (operands[1], E_V4BFmode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2534; /* neon_vld1v4bf */

    case E_V8BFmode:
      if (!s_register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !neon_struct_operand (operands[1], E_V8BFmode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2535; /* neon_vld1v8bf */

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !neon_struct_operand (operands[1], E_V2SFmode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2536; /* neon_vld1v2sf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !neon_struct_operand (operands[1], E_V4SFmode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2537; /* neon_vld1v4sf */

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !neon_struct_operand (operands[1], E_DImode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2538; /* neon_vld1di */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !neon_struct_operand (operands[1], E_V2DImode)
          || !
#line 5004 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2539; /* neon_vld1v2di */

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 3195 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2030; /* neon_vrecpev8hf */

    case 1:
      if (!
#line 3195 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2031; /* neon_vrecpev4hf */

    case 2:
      if (!
#line 3204 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2032; /* neon_vrecpev2si */

    case 3:
      if (!
#line 3204 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2033; /* neon_vrecpev2sf */

    case 4:
      if (!
#line 3204 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2034; /* neon_vrecpev4si */

    case 5:
      if (!
#line 3204 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2035; /* neon_vrecpev4sf */

    default:
      return -1;
    }
}

 int
recog_134 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!neon_struct_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[1], E_V8QImode)
              || !
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2762; /* neon_vst1_lanev8qi */

        case E_V16QImode:
          if (!s_register_operand (operands[1], E_V16QImode)
              || !
#line 5396 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2769; /* neon_vst1_lanev16qi */

        default:
          return -1;
        }

    case E_HImode:
      if (!neon_struct_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!s_register_operand (operands[1], E_V4HImode)
              || !
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2763; /* neon_vst1_lanev4hi */

        case E_V8HImode:
          if (!s_register_operand (operands[1], E_V8HImode)
              || !
#line 5396 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2770; /* neon_vst1_lanev8hi */

        default:
          return -1;
        }

    case E_HFmode:
      if (!neon_struct_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!s_register_operand (operands[1], E_V4HFmode)
              || !
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2764; /* neon_vst1_lanev4hf */

        case E_V8HFmode:
          if (!s_register_operand (operands[1], E_V8HFmode)
              || !
#line 5396 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2771; /* neon_vst1_lanev8hf */

        default:
          return -1;
        }

    case E_BFmode:
      if (!neon_struct_operand (operands[0], E_BFmode)
          || GET_MODE (x3) != E_BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4BFmode:
          if (!s_register_operand (operands[1], E_V4BFmode)
              || !
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2765; /* neon_vst1_lanev4bf */

        case E_V8BFmode:
          if (!s_register_operand (operands[1], E_V8BFmode)
              || !
#line 5396 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2772; /* neon_vst1_lanev8bf */

        default:
          return -1;
        }

    case E_SImode:
      if (!neon_struct_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!s_register_operand (operands[1], E_V2SImode)
              || !
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2766; /* neon_vst1_lanev2si */

        case E_V4SImode:
          if (!s_register_operand (operands[1], E_V4SImode)
              || !
#line 5396 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2773; /* neon_vst1_lanev4si */

        default:
          return -1;
        }

    case E_SFmode:
      if (!neon_struct_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SFmode:
          if (!s_register_operand (operands[1], E_V2SFmode)
              || !
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2767; /* neon_vst1_lanev2sf */

        case E_V4SFmode:
          if (!s_register_operand (operands[1], E_V4SFmode)
              || !
#line 5396 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2774; /* neon_vst1_lanev4sf */

        default:
          return -1;
        }

    case E_DImode:
      if (!neon_struct_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!s_register_operand (operands[1], E_DImode)
              || !
#line 5375 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2768; /* neon_vst1_lanedi */

        case E_V2DImode:
          if (!s_register_operand (operands[1], E_V2DImode)
              || !
#line 5396 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2775; /* neon_vst1_lanev2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V16QImode, 
E_V2x16QImode) != 0
          || !
#line 4100 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x16QImode))))
        return -1;
      return 5001; /* mve_vld2qv16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V8HImode, 
E_V2x8HImode) != 0
          || !
#line 4100 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HImode))))
        return -1;
      return 5002; /* mve_vld2qv8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V4SImode, 
E_V2x4SImode) != 0
          || !
#line 4100 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SImode))))
        return -1;
      return 5003; /* mve_vld2qv4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V8HFmode, 
E_V2x8HFmode) != 0
          || !
#line 4100 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HFmode))))
        return -1;
      return 5004; /* mve_vld2qv8hf */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V4SFmode, 
E_V2x4SFmode) != 0
          || !
#line 4100 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SFmode))))
        return -1;
      return 5005; /* mve_vld2qv4sf */

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern145 (x1))
    {
    case 0:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1827; /* neon_vmaxsv8qi */

    case 1:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1831; /* neon_vmaxsv16qi */

    case 2:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1835; /* neon_vmaxsv4hi */

    case 3:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1839; /* neon_vmaxsv8hi */

    case 4:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1843; /* neon_vmaxsv2si */

    case 5:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1847; /* neon_vmaxsv4si */

    case 6:
      if (!
#line 2691 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1851; /* neon_vmaxfv2sf */

    case 7:
      if (!
#line 2691 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1853; /* neon_vmaxfv4sf */

    case 8:
      if (!
#line 2702 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1855; /* neon_vmaxfv8hf */

    case 9:
      if (!
#line 2702 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1857; /* neon_vmaxfv4hf */

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2343; /* neon_vshrs_nv8qi */

    case 1:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2347; /* neon_vshrs_nv16qi */

    case 2:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2351; /* neon_vshrs_nv4hi */

    case 3:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2355; /* neon_vshrs_nv8hi */

    case 4:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2359; /* neon_vshrs_nv2si */

    case 5:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2363; /* neon_vshrs_nv4si */

    case 6:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2367; /* neon_vshrs_ndi */

    case 7:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2371; /* neon_vshrs_nv2di */

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern150 (x1))
    {
    case 0:
      if (!
#line 3788 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2130; /* neon_vcvts_nv2sf */

    case 1:
      if (!
#line 3788 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2132; /* neon_vcvts_nv4sf */

    case 2:
      if (!
#line 3802 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2134; /* neon_vcvts_nv8hf */

    case 3:
      if (!
#line 3802 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2136; /* neon_vcvts_nv4hf */

    case 4:
      if (!
#line 3815 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2138; /* neon_vcvts_nv2si */

    case 5:
      if (!
#line 3815 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2140; /* neon_vcvts_nv4si */

    case 6:
      if (!
#line 3829 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2142; /* neon_vcvts_nv4hi */

    case 7:
      if (!
#line 3829 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2144; /* neon_vcvts_nv8hi */

    default:
      return -1;
    }
}

 int
recog_189 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern163 (x1, 
E_EImode))
    {
    case 0:
      if (!
#line 5837 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2870; /* neon_vst3v8qi */

    case 1:
      if (!
#line 5837 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2871; /* neon_vst3v4hi */

    case 2:
      if (!
#line 5837 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2872; /* neon_vst3v4hf */

    case 3:
      if (!(
#line 5837 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2873; /* neon_vst3v4bf */

    case 4:
      if (!
#line 5837 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2874; /* neon_vst3v2si */

    case 5:
      if (!
#line 5837 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2875; /* neon_vst3v2sf */

    case 6:
      if (!
#line 5837 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2876; /* neon_vst3di */

    default:
      return -1;
    }
}

 int
recog_199 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (pattern115 (x3))
    {
    case 0:
      if (!mve_imm_7 (operands[2], E_SImode)
          || !
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3725; /* mve_vqshluq_n_sv16qi */

    case 1:
      if (!mve_imm_15 (operands[2], E_SImode)
          || !
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3726; /* mve_vqshluq_n_sv8hi */

    case 2:
      if (!mve_imm_31 (operands[2], E_SImode)
          || !
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3727; /* mve_vqshluq_n_sv4si */

    default:
      return -1;
    }
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern147 (x1))
    {
    case 0:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1886; /* neon_vpadaluv8qi */

    case 1:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1888; /* neon_vpadaluv16qi */

    case 2:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1890; /* neon_vpadaluv4hi */

    case 3:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1892; /* neon_vpadaluv8hi */

    case 4:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1894; /* neon_vpadaluv2si */

    case 5:
      if (!
#line 2777 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1896; /* neon_vpadaluv4si */

    default:
      return -1;
    }
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1487; /* neon_vhadduv8qi */

    case 1:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1491; /* neon_vhadduv16qi */

    case 2:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1495; /* neon_vhadduv4hi */

    case 3:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1499; /* neon_vhadduv8hi */

    case 4:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1503; /* neon_vhadduv2si */

    case 5:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1507; /* neon_vhadduv4si */

    default:
      return -1;
    }
}

 int
recog_226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V8BFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V8BFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8BFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4SFmode)
      || !
#line 6701 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
    return -1;
  return 3035; /* neon_vbfcvtv4sf_highv8bf */
}

 int
recog_232 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1710; /* neon_vcltv2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1715; /* neon_vcltv4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1730; /* neon_vcltv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1735; /* neon_vcltv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_242 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!ssat16_imm (operands[2], E_SImode)
      || !
#line 6166 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
    return -1;
  return 250; /* arm_ssat16_insn */
}

 int
recog_252 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern90 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 2);
  switch (pattern509 (x4))
    {
    case 0:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !vpr_register_operand (operands[3], E_V8BImode)
          || !
#line 3395 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 4877; /* mve_vstrq_truncate_scatter_offset_p_v8qi */

    case 1:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_V4QImode:
          if (!
#line 3395 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4878; /* mve_vstrq_truncate_scatter_offset_p_v4qi */

        case E_V4HImode:
          if (!
#line 3395 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4879; /* mve_vstrq_truncate_scatter_offset_p_v4hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern198 (x1))
    {
    case 0:
      if (!
#line 4027 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2210; /* neon_vmla_lanev4hi */

    case 1:
      if (!
#line 4027 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2211; /* neon_vmla_lanev2si */

    case 2:
      if (!
#line 4027 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2212; /* neon_vmla_lanev2sf */

    case 3:
      if (!
#line 4045 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2213; /* neon_vmla_lanev8hi */

    case 4:
      if (!
#line 4045 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2214; /* neon_vmla_lanev4si */

    case 5:
      if (!
#line 4045 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2215; /* neon_vmla_lanev4sf */

    default:
      return -1;
    }
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 79:
      if (pattern29 (x1) != 0
          || !
#line 2792 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
        return -1;
      return 86; /* arm_smlawb_insn */

    case 80:
      if (pattern29 (x1) != 0
          || !
#line 2792 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
        return -1;
      return 88; /* arm_smlawt_insn */

    case 103:
      return recog_102 (x1, insn, pnum_clobbers);

    case 102:
      return recog_95 (x1, insn, pnum_clobbers);

    case 74:
      if (pattern29 (x1) != 0
          || !
#line 6077 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 221; /* arm_usada8 */

    case 75:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 222; /* arm_smlald */

    case 76:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 223; /* arm_smlaldx */

    case 77:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 224; /* arm_smlsld */

    case 78:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 225; /* arm_smlsldx */

    case 94:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 238; /* arm_smlad_insn */

    case 95:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 240; /* arm_smladx_insn */

    case 96:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 242; /* arm_smlsd_insn */

    case 97:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 244; /* arm_smlsdx_insn */

    case 81:
      return recog_90 (x1, insn, pnum_clobbers);

    case 2:
      return recog_93 (x1, insn, pnum_clobbers);

    case 17:
      return recog_94 (x1, insn, pnum_clobbers);

    case 11:
      if (pattern31 (x1) != 0
          || !
#line 518 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 573; /* iwmmxt_wmacs */

    case 12:
      if (pattern31 (x1) != 0
          || !
#line 539 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 575; /* iwmmxt_wmacu */

    case 9:
      return recog_77 (x1, insn, pnum_clobbers);

    case 105:
      return recog_76 (x1, insn, pnum_clobbers);

    case 104:
      return recog_75 (x1, insn, pnum_clobbers);

    case 223:
      return recog_86 (x1, insn, pnum_clobbers);

    case 225:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1568; /* neon_vmlalsv8qi */

        case 1:
          if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1570; /* neon_vmlalsv4hi */

        case 2:
          if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1572; /* neon_vmlalsv2si */

        default:
          return -1;
        }

    case 226:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1569; /* neon_vmlaluv8qi */

        case 1:
          if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1571; /* neon_vmlaluv4hi */

        case 2:
          if (!
#line 2126 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1573; /* neon_vmlaluv2si */

        default:
          return -1;
        }

    case 229:
      return recog_85 (x1, insn, pnum_clobbers);

    case 231:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1582; /* neon_vmlslsv8qi */

        case 1:
          if (!
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1584; /* neon_vmlslsv4hi */

        case 2:
          if (!
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1586; /* neon_vmlslsv2si */

        default:
          return -1;
        }

    case 232:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1583; /* neon_vmlsluv8qi */

        case 1:
          if (!
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1585; /* neon_vmlsluv4hi */

        case 2:
          if (!
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1587; /* neon_vmlsluv2si */

        default:
          return -1;
        }

    case 361:
      return recog_101 (x1, insn, pnum_clobbers);

    case 362:
      return recog_100 (x1, insn, pnum_clobbers);

    case 264:
      switch (pattern37 (x1))
        {
        case 0:
          if (!
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1604; /* neon_vqdmlalv4hi */

        case 1:
          if (!
#line 2203 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1605; /* neon_vqdmlalv2si */

        default:
          return -1;
        }

    case 266:
      switch (pattern37 (x1))
        {
        case 0:
          if (!
#line 2214 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1606; /* neon_vqdmlslv4hi */

        case 1:
          if (!
#line 2214 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1607; /* neon_vqdmlslv2si */

        default:
          return -1;
        }

    case 245:
      return recog_68 (x1, insn, pnum_clobbers);

    case 246:
      switch (pattern39 (x1))
        {
        case 0:
          if (!
#line 3937 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2188; /* neon_vmulls_lanev4hi */

        case 1:
          if (!
#line 3937 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2190; /* neon_vmulls_lanev2si */

        default:
          return -1;
        }

    case 247:
      switch (pattern39 (x1))
        {
        case 0:
          if (!
#line 3937 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2189; /* neon_vmullu_lanev4hi */

        case 1:
          if (!
#line 3937 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2191; /* neon_vmullu_lanev2si */

        default:
          return -1;
        }

    case 273:
      switch (pattern39 (x1))
        {
        case 0:
          if (!
#line 3951 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2192; /* neon_vqdmull_lanev4hi */

        case 1:
          if (!
#line 3951 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2193; /* neon_vqdmull_lanev2si */

        default:
          return -1;
        }

    case 269:
      return recog_98 (x1, insn, pnum_clobbers);

    case 271:
      return recog_99 (x1, insn, pnum_clobbers);

    case 191:
      return recog_61 (x1, insn, pnum_clobbers);

    case 160:
      return recog_62 (x1, insn, pnum_clobbers);

    case 314:
      return recog_84 (x1, insn, pnum_clobbers);

    case 315:
      return recog_83 (x1, insn, pnum_clobbers);

    case 316:
      return recog_82 (x1, insn, pnum_clobbers);

    case 317:
      return recog_81 (x1, insn, pnum_clobbers);

    case 318:
      return recog_79 (x1, insn, pnum_clobbers);

    case 313:
      return recog_80 (x1, insn, pnum_clobbers);

    case 344:
      return recog_70 (x1, insn, pnum_clobbers);

    case 200:
      return recog_89 (x1, insn, pnum_clobbers);

    case 202:
      return recog_88 (x1, insn, pnum_clobbers);

    case 203:
      return recog_60 (x1, insn, pnum_clobbers);

    case 326:
      return recog_67 (x1, insn, pnum_clobbers);

    case 209:
      return recog_92 (x1, insn, pnum_clobbers);

    case 330:
      return recog_64 (x1, insn, pnum_clobbers);

    case 214:
      return recog_91 (x1, insn, pnum_clobbers);

    case 334:
      return recog_66 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3062; /* crypto_sha1su0 */

    case 140:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3063; /* crypto_sha256h */

    case 141:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3064; /* crypto_sha256h2 */

    case 143:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3065; /* crypto_sha256su1 */

    case 134:
      if (pattern48 (x1) != 0
          || !
#line 295 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && INTVAL (operands[4]) == NEON_ENDIAN_LANE_N (V2SImode, 0)))
        return -1;
      return 3068; /* crypto_sha1c_lb */

    case 135:
      if (pattern48 (x1) != 0
          || !
#line 295 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && INTVAL (operands[4]) == NEON_ENDIAN_LANE_N (V2SImode, 0)))
        return -1;
      return 3069; /* crypto_sha1m_lb */

    case 136:
      if (pattern48 (x1) != 0
          || !
#line 295 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO && INTVAL (operands[4]) == NEON_ENDIAN_LANE_N (V2SImode, 0)))
        return -1;
      return 3070; /* crypto_sha1p_lb */

    case 611:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3875; /* mve_vcmpeqq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3881; /* mve_vcmpeqq_m_fv4sf */

        default:
          return -1;
        }

    case 712:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3876; /* mve_vcmpgeq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3882; /* mve_vcmpgeq_m_fv4sf */

        default:
          return -1;
        }

    case 724:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3877; /* mve_vcmpgtq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3883; /* mve_vcmpgtq_m_fv4sf */

        default:
          return -1;
        }

    case 741:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3878; /* mve_vcmpleq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3884; /* mve_vcmpleq_m_fv4sf */

        default:
          return -1;
        }

    case 725:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3879; /* mve_vcmpltq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3885; /* mve_vcmpltq_m_fv4sf */

        default:
          return -1;
        }

    case 736:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3880; /* mve_vcmpneq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3886; /* mve_vcmpneq_m_fv4sf */

        default:
          return -1;
        }

    case 612:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3887; /* mve_vcvtaq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3895; /* mve_vcvtaq_m_sv4si */

        default:
          return -1;
        }

    case 613:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3888; /* mve_vcvtaq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3896; /* mve_vcvtaq_m_uv4si */

        default:
          return -1;
        }

    case 804:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3889; /* mve_vcvtmq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3897; /* mve_vcvtmq_m_sv4si */

        default:
          return -1;
        }

    case 805:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3890; /* mve_vcvtmq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3898; /* mve_vcvtmq_m_uv4si */

        default:
          return -1;
        }

    case 806:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3891; /* mve_vcvtnq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3899; /* mve_vcvtnq_m_sv4si */

        default:
          return -1;
        }

    case 810:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3892; /* mve_vcvtnq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3900; /* mve_vcvtnq_m_uv4si */

        default:
          return -1;
        }

    case 807:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3893; /* mve_vcvtpq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3901; /* mve_vcvtpq_m_sv4si */

        default:
          return -1;
        }

    case 808:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3894; /* mve_vcvtpq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3902; /* mve_vcvtpq_m_uv4si */

        default:
          return -1;
        }

    case 614:
      switch (pattern53 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3903; /* mve_vcvtq_m_to_f_sv8hf */

        case 1:
          if (!
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3905; /* mve_vcvtq_m_to_f_sv4sf */

        default:
          return -1;
        }

    case 615:
      switch (pattern53 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3904; /* mve_vcvtq_m_to_f_uv8hf */

        case 1:
          if (!
#line 1592 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3906; /* mve_vcvtq_m_to_f_uv4sf */

        default:
          return -1;
        }

    case 617:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3907; /* mve_vqrshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3927; /* mve_vqrshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 616:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3908; /* mve_vqrshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3928; /* mve_vqrshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 777:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3909; /* mve_vqrshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3929; /* mve_vqrshrntq_n_sv4si */

        default:
          return -1;
        }

    case 776:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3910; /* mve_vqrshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3930; /* mve_vqrshrntq_n_uv4si */

        default:
          return -1;
        }

    case 618:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3911; /* mve_vqrshrunbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3931; /* mve_vqrshrunbq_n_sv4si */

        default:
          return -1;
        }

    case 720:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3912; /* mve_vqrshruntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3932; /* mve_vqrshruntq_n_sv4si */

        default:
          return -1;
        }

    case 785:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3913; /* mve_vqshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3933; /* mve_vqshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 784:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3914; /* mve_vqshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3934; /* mve_vqshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 796:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3915; /* mve_vqshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3935; /* mve_vqshrntq_n_sv4si */

        default:
          return -1;
        }

    case 795:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3916; /* mve_vqshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3936; /* mve_vqshrntq_n_uv4si */

        default:
          return -1;
        }

    case 719:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3917; /* mve_vqshrunbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3937; /* mve_vqshrunbq_n_sv4si */

        default:
          return -1;
        }

    case 727:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3918; /* mve_vqshruntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3938; /* mve_vqshruntq_n_sv4si */

        default:
          return -1;
        }

    case 788:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3919; /* mve_vrshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3939; /* mve_vrshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 789:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3920; /* mve_vrshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3940; /* mve_vrshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 771:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3921; /* mve_vrshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3941; /* mve_vrshrntq_n_sv4si */

        default:
          return -1;
        }

    case 770:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3922; /* mve_vrshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3942; /* mve_vrshrntq_n_uv4si */

        default:
          return -1;
        }

    case 787:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3923; /* mve_vshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3943; /* mve_vshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 786:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3924; /* mve_vshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3944; /* mve_vshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 798:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3925; /* mve_vshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3945; /* mve_vshrntq_n_sv4si */

        default:
          return -1;
        }

    case 799:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3926; /* mve_vshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3946; /* mve_vshrntq_n_uv4si */

        default:
          return -1;
        }

    case 619:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3947; /* mve_vrmlaldavhaq_sv4si */

    case 624:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3948; /* mve_vrmlaldavhaq_uv4si */

    case 715:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3949; /* mve_vrmlaldavhaxq_sv4si */

    case 733:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3950; /* mve_vrmlsldavhaq_sv4si */

    case 734:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3951; /* mve_vrmlsldavhaxq_sv4si */

    case 620:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1658 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3952; /* mve_vabavq_sv16qi */

        case 1:
          if (!
#line 1658 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3954; /* mve_vabavq_sv8hi */

        case 2:
          if (!
#line 1658 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3956; /* mve_vabavq_sv4si */

        default:
          return -1;
        }

    case 621:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1658 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3953; /* mve_vabavq_uv16qi */

        case 1:
          if (!
#line 1658 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3955; /* mve_vabavq_uv8hi */

        case 2:
          if (!
#line 1658 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3957; /* mve_vabavq_uv4si */

        default:
          return -1;
        }

    case 625:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3964; /* mve_vabsq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3971; /* mve_vabsq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3978; /* mve_vabsq_m_sv4si */

        default:
          return -1;
        }

    case 628:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3965; /* mve_vclsq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3972; /* mve_vclsq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3979; /* mve_vclsq_m_sv4si */

        default:
          return -1;
        }

    case 629:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3966; /* mve_vclzq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3973; /* mve_vclzq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3980; /* mve_vclzq_m_sv4si */

        default:
          return -1;
        }

    case 630:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3967; /* mve_vclzq_m_uv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3974; /* mve_vclzq_m_uv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3981; /* mve_vclzq_m_uv4si */

        default:
          return -1;
        }

    case 678:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3968; /* mve_vnegq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3975; /* mve_vnegq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3982; /* mve_vnegq_m_sv4si */

        default:
          return -1;
        }

    case 681:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3969; /* mve_vqabsq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3976; /* mve_vqabsq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3983; /* mve_vqabsq_m_sv4si */

        default:
          return -1;
        }

    case 684:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3970; /* mve_vqnegq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3977; /* mve_vqnegq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3984; /* mve_vqnegq_m_sv4si */

        default:
          return -1;
        }

    case 626:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 1718 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3985; /* mve_vaddvaq_p_sv16qi */

        case 1:
          if (!
#line 1718 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3987; /* mve_vaddvaq_p_sv8hi */

        case 2:
          if (!
#line 1718 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3989; /* mve_vaddvaq_p_sv4si */

        default:
          return -1;
        }

    case 627:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 1718 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3986; /* mve_vaddvaq_p_uv16qi */

        case 1:
          if (!
#line 1718 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3988; /* mve_vaddvaq_p_uv8hi */

        case 2:
          if (!
#line 1718 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3990; /* mve_vaddvaq_p_uv4si */

        default:
          return -1;
        }

    case 631:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3991; /* mve_vcmpcsq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4001; /* mve_vcmpcsq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4011; /* mve_vcmpcsq_m_n_uv4si */

        default:
          return -1;
        }

    case 633:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3992; /* mve_vcmpeqq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4002; /* mve_vcmpeqq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4012; /* mve_vcmpeqq_m_n_sv4si */

        default:
          return -1;
        }

    case 634:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3993; /* mve_vcmpeqq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4003; /* mve_vcmpeqq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4013; /* mve_vcmpeqq_m_n_uv4si */

        default:
          return -1;
        }

    case 637:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3994; /* mve_vcmpgeq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4004; /* mve_vcmpgeq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4014; /* mve_vcmpgeq_m_n_sv4si */

        default:
          return -1;
        }

    case 639:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3995; /* mve_vcmpgtq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4005; /* mve_vcmpgtq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4015; /* mve_vcmpgtq_m_n_sv4si */

        default:
          return -1;
        }

    case 641:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3996; /* mve_vcmphiq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4006; /* mve_vcmphiq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4016; /* mve_vcmphiq_m_n_uv4si */

        default:
          return -1;
        }

    case 643:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3997; /* mve_vcmpleq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4007; /* mve_vcmpleq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4017; /* mve_vcmpleq_m_n_sv4si */

        default:
          return -1;
        }

    case 645:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3998; /* mve_vcmpltq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4008; /* mve_vcmpltq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4018; /* mve_vcmpltq_m_n_sv4si */

        default:
          return -1;
        }

    case 647:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3999; /* mve_vcmpneq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4009; /* mve_vcmpneq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4019; /* mve_vcmpneq_m_n_sv4si */

        default:
          return -1;
        }

    case 648:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4000; /* mve_vcmpneq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4010; /* mve_vcmpneq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4020; /* mve_vcmpneq_m_n_uv4si */

        default:
          return -1;
        }

    case 632:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4021; /* mve_vcmpcsq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4031; /* mve_vcmpcsq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4041; /* mve_vcmpcsq_m_uv4si */

        default:
          return -1;
        }

    case 635:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4022; /* mve_vcmpeqq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4032; /* mve_vcmpeqq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4042; /* mve_vcmpeqq_m_sv4si */

        default:
          return -1;
        }

    case 636:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4023; /* mve_vcmpeqq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4033; /* mve_vcmpeqq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4043; /* mve_vcmpeqq_m_uv4si */

        default:
          return -1;
        }

    case 638:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4024; /* mve_vcmpgeq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4034; /* mve_vcmpgeq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4044; /* mve_vcmpgeq_m_sv4si */

        default:
          return -1;
        }

    case 640:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4025; /* mve_vcmpgtq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4035; /* mve_vcmpgtq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4045; /* mve_vcmpgtq_m_sv4si */

        default:
          return -1;
        }

    case 642:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4026; /* mve_vcmphiq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4036; /* mve_vcmphiq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4046; /* mve_vcmphiq_m_uv4si */

        default:
          return -1;
        }

    case 644:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4027; /* mve_vcmpleq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4037; /* mve_vcmpleq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4047; /* mve_vcmpleq_m_sv4si */

        default:
          return -1;
        }

    case 646:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4028; /* mve_vcmpltq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4038; /* mve_vcmpltq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4048; /* mve_vcmpltq_m_sv4si */

        default:
          return -1;
        }

    case 649:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4029; /* mve_vcmpneq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4039; /* mve_vcmpneq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4049; /* mve_vcmpneq_m_sv4si */

        default:
          return -1;
        }

    case 650:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4030; /* mve_vcmpneq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4040; /* mve_vcmpneq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4050; /* mve_vcmpneq_m_uv4si */

        default:
          return -1;
        }

    case 651:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1783 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4051; /* mve_vdupq_m_n_sv16qi */

        case 1:
          if (!
#line 1783 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4053; /* mve_vdupq_m_n_sv8hi */

        case 2:
          if (!
#line 1783 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4055; /* mve_vdupq_m_n_sv4si */

        default:
          return -1;
        }

    case 652:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1783 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4052; /* mve_vdupq_m_n_uv16qi */

        case 1:
          if (!
#line 1783 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4054; /* mve_vdupq_m_n_uv8hi */

        case 2:
          if (!
#line 1783 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4056; /* mve_vdupq_m_n_uv4si */

        default:
          return -1;
        }

    case 657:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1801 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4057; /* mve_vmaxaq_m_sv16qi */

        case 1:
          if (!
#line 1801 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4059; /* mve_vmaxaq_m_sv8hi */

        case 2:
          if (!
#line 1801 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4061; /* mve_vmaxaq_m_sv4si */

        default:
          return -1;
        }

    case 661:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1801 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4058; /* mve_vminaq_m_sv16qi */

        case 1:
          if (!
#line 1801 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4060; /* mve_vminaq_m_sv8hi */

        case 2:
          if (!
#line 1801 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4062; /* mve_vminaq_m_sv4si */

        default:
          return -1;
        }

    case 658:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4063; /* mve_vmaxavq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4069; /* mve_vmaxavq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4075; /* mve_vmaxavq_p_sv4si */

        default:
          return -1;
        }

    case 659:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4064; /* mve_vmaxvq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4070; /* mve_vmaxvq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4076; /* mve_vmaxvq_p_sv4si */

        default:
          return -1;
        }

    case 660:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4065; /* mve_vmaxvq_p_uv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4071; /* mve_vmaxvq_p_uv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4077; /* mve_vmaxvq_p_uv4si */

        default:
          return -1;
        }

    case 662:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4066; /* mve_vminavq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4072; /* mve_vminavq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4078; /* mve_vminavq_p_sv4si */

        default:
          return -1;
        }

    case 663:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4067; /* mve_vminvq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4073; /* mve_vminvq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4079; /* mve_vminvq_p_sv4si */

        default:
          return -1;
        }

    case 664:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4068; /* mve_vminvq_p_uv16qi */

        case 1:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4074; /* mve_vminvq_p_uv8hi */

        case 2:
          if (!
#line 1821 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4080; /* mve_vminvq_p_uv4si */

        default:
          return -1;
        }

    case 665:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4081; /* mve_vmladavaq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4086; /* mve_vmladavaq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4091; /* mve_vmladavaq_sv4si */

        default:
          return -1;
        }

    case 666:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4082; /* mve_vmladavaq_uv16qi */

        case 1:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4087; /* mve_vmladavaq_uv8hi */

        case 2:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4092; /* mve_vmladavaq_uv4si */

        default:
          return -1;
        }

    case 709:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4083; /* mve_vmlsdavaxq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4088; /* mve_vmlsdavaxq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4093; /* mve_vmlsdavaxq_sv4si */

        default:
          return -1;
        }

    case 710:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4084; /* mve_vmlsdavaq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4089; /* mve_vmlsdavaq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4094; /* mve_vmlsdavaq_sv4si */

        default:
          return -1;
        }

    case 711:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4085; /* mve_vmladavaxq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4090; /* mve_vmladavaxq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4095; /* mve_vmladavaxq_sv4si */

        default:
          return -1;
        }

    case 667:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4096; /* mve_vmladavq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4101; /* mve_vmladavq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4106; /* mve_vmladavq_p_sv4si */

        default:
          return -1;
        }

    case 668:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4097; /* mve_vmladavq_p_uv16qi */

        case 1:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4102; /* mve_vmladavq_p_uv8hi */

        case 2:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4107; /* mve_vmladavq_p_uv4si */

        default:
          return -1;
        }

    case 669:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4098; /* mve_vmladavxq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4103; /* mve_vmladavxq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4108; /* mve_vmladavxq_p_sv4si */

        default:
          return -1;
        }

    case 674:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4099; /* mve_vmlsdavq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4104; /* mve_vmlsdavq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4109; /* mve_vmlsdavq_p_sv4si */

        default:
          return -1;
        }

    case 675:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4100; /* mve_vmlsdavxq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4105; /* mve_vmlsdavxq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4110; /* mve_vmlsdavxq_p_sv4si */

        default:
          return -1;
        }

    case 670:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4111; /* mve_vmlaq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4119; /* mve_vmlaq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4127; /* mve_vmlaq_n_sv4si */

        default:
          return -1;
        }

    case 671:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4112; /* mve_vmlaq_n_uv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4120; /* mve_vmlaq_n_uv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4128; /* mve_vmlaq_n_uv4si */

        default:
          return -1;
        }

    case 672:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4113; /* mve_vmlasq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4121; /* mve_vmlasq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4129; /* mve_vmlasq_n_sv4si */

        default:
          return -1;
        }

    case 673:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4114; /* mve_vmlasq_n_uv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4122; /* mve_vmlasq_n_uv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4130; /* mve_vmlasq_n_uv4si */

        default:
          return -1;
        }

    case 682:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4115; /* mve_vqdmlahq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4123; /* mve_vqdmlahq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4131; /* mve_vqdmlahq_n_sv4si */

        default:
          return -1;
        }

    case 683:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4116; /* mve_vqdmlashq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4124; /* mve_vqdmlashq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4132; /* mve_vqdmlashq_n_sv4si */

        default:
          return -1;
        }

    case 687:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4117; /* mve_vqrdmlahq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4125; /* mve_vqrdmlahq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4133; /* mve_vqrdmlahq_n_sv4si */

        default:
          return -1;
        }

    case 688:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4118; /* mve_vqrdmlashq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4126; /* mve_vqrdmlashq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4134; /* mve_vqrdmlashq_n_sv4si */

        default:
          return -1;
        }

    case 676:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4135; /* mve_vmvnq_m_sv16qi */

        case 1:
          if (!
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4137; /* mve_vmvnq_m_sv8hi */

        case 2:
          if (!
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4139; /* mve_vmvnq_m_sv4si */

        default:
          return -1;
        }

    case 677:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4136; /* mve_vmvnq_m_uv16qi */

        case 1:
          if (!
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4138; /* mve_vmvnq_m_uv8hi */

        case 2:
          if (!
#line 1901 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4140; /* mve_vmvnq_m_uv4si */

        default:
          return -1;
        }

    case 679:
      return recog_97 (x1, insn, pnum_clobbers);

    case 680:
      return recog_96 (x1, insn, pnum_clobbers);

    case 708:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4149; /* mve_vqdmladhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4157; /* mve_vqdmladhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4165; /* mve_vqdmladhq_sv4si */

        default:
          return -1;
        }

    case 707:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4150; /* mve_vqdmladhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4158; /* mve_vqdmladhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4166; /* mve_vqdmladhxq_sv4si */

        default:
          return -1;
        }

    case 706:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4151; /* mve_vqdmlsdhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4159; /* mve_vqdmlsdhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4167; /* mve_vqdmlsdhq_sv4si */

        default:
          return -1;
        }

    case 705:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4152; /* mve_vqdmlsdhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4160; /* mve_vqdmlsdhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4168; /* mve_vqdmlsdhxq_sv4si */

        default:
          return -1;
        }

    case 685:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4153; /* mve_vqrdmladhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4161; /* mve_vqrdmladhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4169; /* mve_vqrdmladhq_sv4si */

        default:
          return -1;
        }

    case 686:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4154; /* mve_vqrdmladhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4162; /* mve_vqrdmladhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4170; /* mve_vqrdmladhxq_sv4si */

        default:
          return -1;
        }

    case 689:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4155; /* mve_vqrdmlsdhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4163; /* mve_vqrdmlsdhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4171; /* mve_vqrdmlsdhq_sv4si */

        default:
          return -1;
        }

    case 690:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4156; /* mve_vqrdmlsdhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4164; /* mve_vqrdmlsdhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4172; /* mve_vqrdmlsdhxq_sv4si */

        default:
          return -1;
        }

    case 691:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4173; /* mve_vqrshlq_m_n_sv16qi */

        case 1:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4177; /* mve_vqrshlq_m_n_sv8hi */

        case 2:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4181; /* mve_vqrshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 692:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4174; /* mve_vqrshlq_m_n_uv16qi */

        case 1:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4178; /* mve_vqrshlq_m_n_uv8hi */

        case 2:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4182; /* mve_vqrshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 697:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4175; /* mve_vrshlq_m_n_sv16qi */

        case 1:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4179; /* mve_vrshlq_m_n_sv8hi */

        case 2:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4183; /* mve_vrshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 698:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4176; /* mve_vrshlq_m_n_uv16qi */

        case 1:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4180; /* mve_vrshlq_m_n_uv8hi */

        case 2:
          if (!
#line 1960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4184; /* mve_vrshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 693:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4185; /* mve_vqshlq_m_r_sv16qi */

        case 1:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4189; /* mve_vqshlq_m_r_sv8hi */

        case 2:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4193; /* mve_vqshlq_m_r_sv4si */

        default:
          return -1;
        }

    case 694:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4186; /* mve_vqshlq_m_r_uv16qi */

        case 1:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4190; /* mve_vqshlq_m_r_uv8hi */

        case 2:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4194; /* mve_vqshlq_m_r_uv4si */

        default:
          return -1;
        }

    case 699:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4187; /* mve_vshlq_m_r_sv16qi */

        case 1:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4191; /* mve_vshlq_m_r_sv8hi */

        case 2:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4195; /* mve_vshlq_m_r_sv4si */

        default:
          return -1;
        }

    case 700:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4188; /* mve_vshlq_m_r_uv16qi */

        case 1:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4192; /* mve_vshlq_m_r_uv8hi */

        case 2:
          if (!
#line 1978 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4196; /* mve_vshlq_m_r_uv4si */

        default:
          return -1;
        }

    case 695:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1995 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4197; /* mve_vrev64q_m_sv16qi */

        case 1:
          if (!
#line 1995 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4199; /* mve_vrev64q_m_sv8hi */

        case 2:
          if (!
#line 1995 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4201; /* mve_vrev64q_m_sv4si */

        default:
          return -1;
        }

    case 696:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1995 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4198; /* mve_vrev64q_m_uv16qi */

        case 1:
          if (!
#line 1995 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4200; /* mve_vrev64q_m_uv8hi */

        case 2:
          if (!
#line 1995 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4202; /* mve_vrev64q_m_uv4si */

        default:
          return -1;
        }

    case 701:
      switch (pattern74 (x1))
        {
        case 0:
          if (!
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4203; /* mve_vsliq_n_sv16qi */

        case 1:
          if (!
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4205; /* mve_vsliq_n_sv8hi */

        case 2:
          if (!
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4207; /* mve_vsliq_n_sv4si */

        default:
          return -1;
        }

    case 702:
      switch (pattern74 (x1))
        {
        case 0:
          if (!
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4204; /* mve_vsliq_n_uv16qi */

        case 1:
          if (!
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4206; /* mve_vsliq_n_uv8hi */

        case 2:
          if (!
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4208; /* mve_vsliq_n_uv4si */

        default:
          return -1;
        }

    case 703:
      switch (pattern75 (x1))
        {
        case 0:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4209; /* mve_vsriq_n_sv16qi */

        case 1:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4211; /* mve_vsriq_n_sv8hi */

        case 2:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4213; /* mve_vsriq_n_sv4si */

        default:
          return -1;
        }

    case 704:
      switch (pattern75 (x1))
        {
        case 0:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4210; /* mve_vsriq_n_uv16qi */

        case 1:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4212; /* mve_vsriq_n_uv8hi */

        case 2:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4214; /* mve_vsriq_n_uv4si */

        default:
          return -1;
        }

    case 728:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4215; /* mve_vabsq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4223; /* mve_vabsq_m_fv4sf */

        default:
          return -1;
        }

    case 750:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4216; /* mve_vnegq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4224; /* mve_vnegq_m_fv4sf */

        default:
          return -1;
        }

    case 737:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4217; /* mve_vrndaq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4225; /* mve_vrndaq_m_fv4sf */

        default:
          return -1;
        }

    case 751:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4218; /* mve_vrndmq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4226; /* mve_vrndmq_m_fv4sf */

        default:
          return -1;
        }

    case 754:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4219; /* mve_vrndnq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4227; /* mve_vrndnq_m_fv4sf */

        default:
          return -1;
        }

    case 738:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4220; /* mve_vrndpq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4228; /* mve_vrndpq_m_fv4sf */

        default:
          return -1;
        }

    case 761:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4221; /* mve_vrndq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4229; /* mve_vrndq_m_fv4sf */

        default:
          return -1;
        }

    case 743:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4222; /* mve_vrndxq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4230; /* mve_vrndxq_m_fv4sf */

        default:
          return -1;
        }

    case 817:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 2070 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4231; /* mve_vaddlvaq_p_uv4si */

    case 739:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 2070 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4232; /* mve_vaddlvaq_p_sv4si */

    case 759:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4241; /* mve_vcmpeqq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4247; /* mve_vcmpeqq_m_n_fv4sf */

        default:
          return -1;
        }

    case 753:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4242; /* mve_vcmpgeq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4248; /* mve_vcmpgeq_m_n_fv4sf */

        default:
          return -1;
        }

    case 713:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4243; /* mve_vcmpgtq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4249; /* mve_vcmpgtq_m_n_fv4sf */

        default:
          return -1;
        }

    case 752:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4244; /* mve_vcmpleq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4250; /* mve_vcmpleq_m_n_fv4sf */

        default:
          return -1;
        }

    case 735:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4245; /* mve_vcmpltq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4251; /* mve_vcmpltq_m_n_fv4sf */

        default:
          return -1;
        }

    case 756:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4246; /* mve_vcmpneq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4252; /* mve_vcmpneq_m_n_fv4sf */

        default:
          return -1;
        }

    case 800:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 2130 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4253; /* mve_vcvtbq_m_f16_f32v8hf */

    case 802:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 2130 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4254; /* mve_vcvttq_m_f16_f32v8hf */

    case 801:
      if (pattern77 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4SFmode) != 0
          || !
#line 2148 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4255; /* mve_vcvtbq_m_f32_f16v4sf */

    case 803:
      if (pattern77 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4SFmode) != 0
          || !
#line 2148 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4256; /* mve_vcvttq_m_f32_f16v4sf */

    case 723:
      switch (pattern53 (x1, 
E_HFmode, 
E_SFmode))
        {
        case 0:
          if (!
#line 2165 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4257; /* mve_vdupq_m_n_fv8hf */

        case 1:
          if (!
#line 2165 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4258; /* mve_vdupq_m_n_fv4sf */

        default:
          return -1;
        }

    case 717:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4259; /* mve_vfmaq_fv8hf */

        case 1:
          if (!
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4261; /* mve_vfmaq_fv4sf */

        default:
          return -1;
        }

    case 744:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4260; /* mve_vfmsq_fv8hf */

        case 1:
          if (!
#line 2183 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4262; /* mve_vfmsq_fv4sf */

        default:
          return -1;
        }

    case 730:
      switch (pattern80 (x1))
        {
        case 0:
          if (!
#line 2201 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4263; /* mve_vfmaq_n_fv8hf */

        case 1:
          if (!
#line 2201 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4265; /* mve_vfmaq_n_fv4sf */

        default:
          return -1;
        }

    case 722:
      switch (pattern80 (x1))
        {
        case 0:
          if (!
#line 2201 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4264; /* mve_vfmasq_n_fv8hf */

        case 1:
          if (!
#line 2201 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4266; /* mve_vfmasq_n_fv4sf */

        default:
          return -1;
        }

    case 760:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2219 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4267; /* mve_vmaxnmaq_m_fv8hf */

        case 1:
          if (!
#line 2219 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4269; /* mve_vmaxnmaq_m_fv4sf */

        default:
          return -1;
        }

    case 721:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2219 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4268; /* mve_vminnmaq_m_fv8hf */

        case 1:
          if (!
#line 2219 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4270; /* mve_vminnmaq_m_fv4sf */

        default:
          return -1;
        }

    case 729:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4271; /* mve_vmaxnmavq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4275; /* mve_vmaxnmavq_p_fv4sf */

        default:
          return -1;
        }

    case 746:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4272; /* mve_vmaxnmvq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4276; /* mve_vmaxnmvq_p_fv4sf */

        default:
          return -1;
        }

    case 755:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4273; /* mve_vminnmavq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4277; /* mve_vminnmavq_p_fv4sf */

        default:
          return -1;
        }

    case 745:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4274; /* mve_vminnmvq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4278; /* mve_vminnmvq_p_fv4sf */

        default:
          return -1;
        }

    case 782:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4279; /* mve_vmlaldavaq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4284; /* mve_vmlaldavaq_sv4si */

        default:
          return -1;
        }

    case 783:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4280; /* mve_vmlaldavaq_uv8hi */

        case 1:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4285; /* mve_vmlaldavaq_uv4si */

        default:
          return -1;
        }

    case 797:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4281; /* mve_vmlaldavaxq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4286; /* mve_vmlaldavaxq_sv4si */

        default:
          return -1;
        }

    case 718:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4282; /* mve_vmlsldavaq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4287; /* mve_vmlsldavaq_sv4si */

        default:
          return -1;
        }

    case 742:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4283; /* mve_vmlsldavaxq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4288; /* mve_vmlsldavaxq_sv4si */

        default:
          return -1;
        }

    case 763:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4289; /* mve_vmlaldavq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4294; /* mve_vmlaldavq_p_sv4si */

        default:
          return -1;
        }

    case 762:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4290; /* mve_vmlaldavq_p_uv8hi */

        case 1:
          if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4295; /* mve_vmlaldavq_p_uv4si */

        default:
          return -1;
        }

    case 790:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4291; /* mve_vmlaldavxq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4296; /* mve_vmlaldavxq_p_sv4si */

        default:
          return -1;
        }

    case 714:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4292; /* mve_vmlsldavq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4297; /* mve_vmlsldavq_p_sv4si */

        default:
          return -1;
        }

    case 716:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4293; /* mve_vmlsldavxq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4298; /* mve_vmlsldavxq_p_sv4si */

        default:
          return -1;
        }

    case 780:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4299; /* mve_vmovlbq_m_uv16qi */

        case 1:
          if (!
#line 2298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4303; /* mve_vmovlbq_m_uv8hi */

        default:
          return -1;
        }

    case 781:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4300; /* mve_vmovlbq_m_sv16qi */

        case 1:
          if (!
#line 2298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4304; /* mve_vmovlbq_m_sv8hi */

        default:
          return -1;
        }

    case 766:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4301; /* mve_vmovltq_m_uv16qi */

        case 1:
          if (!
#line 2298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4305; /* mve_vmovltq_m_uv8hi */

        default:
          return -1;
        }

    case 767:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4302; /* mve_vmovltq_m_sv16qi */

        case 1:
          if (!
#line 2298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4306; /* mve_vmovltq_m_sv8hi */

        default:
          return -1;
        }

    case 769:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4307; /* mve_vmovnbq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4317; /* mve_vmovnbq_m_sv4si */

        default:
          return -1;
        }

    case 768:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4308; /* mve_vmovnbq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4318; /* mve_vmovnbq_m_uv4si */

        default:
          return -1;
        }

    case 779:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4309; /* mve_vmovntq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4319; /* mve_vmovntq_m_sv4si */

        default:
          return -1;
        }

    case 778:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4310; /* mve_vmovntq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4320; /* mve_vmovntq_m_uv4si */

        default:
          return -1;
        }

    case 764:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4311; /* mve_vqmovnbq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4321; /* mve_vqmovnbq_m_sv4si */

        default:
          return -1;
        }

    case 765:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4312; /* mve_vqmovnbq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4322; /* mve_vqmovnbq_m_uv4si */

        default:
          return -1;
        }

    case 792:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4313; /* mve_vqmovntq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4323; /* mve_vqmovntq_m_sv4si */

        default:
          return -1;
        }

    case 791:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4314; /* mve_vqmovntq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4324; /* mve_vqmovntq_m_uv4si */

        default:
          return -1;
        }

    case 740:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4315; /* mve_vqmovunbq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4325; /* mve_vqmovunbq_m_sv4si */

        default:
          return -1;
        }

    case 748:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4316; /* mve_vqmovuntq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4326; /* mve_vqmovuntq_m_sv4si */

        default:
          return -1;
        }

    case 793:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2337 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4327; /* mve_vmvnq_m_n_uv8hi */

        case 1:
          if (!
#line 2337 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4329; /* mve_vmvnq_m_n_uv4si */

        default:
          return -1;
        }

    case 794:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2337 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4328; /* mve_vmvnq_m_n_sv8hi */

        case 1:
          if (!
#line 2337 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4330; /* mve_vmvnq_m_n_sv4si */

        default:
          return -1;
        }

    case 609:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4331; /* mve_vbicq_m_n_sv8hi */

        case 1:
          if (!
#line 2355 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4335; /* mve_vbicq_m_n_sv4si */

        default:
          return -1;
        }

    case 610:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4332; /* mve_vbicq_m_n_uv8hi */

        case 1:
          if (!
#line 2355 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4336; /* mve_vbicq_m_n_uv4si */

        default:
          return -1;
        }

    case 772:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4333; /* mve_vorrq_m_n_sv8hi */

        case 1:
          if (!
#line 2355 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4337; /* mve_vorrq_m_n_sv4si */

        default:
          return -1;
        }

    case 773:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4334; /* mve_vorrq_m_n_uv8hi */

        case 1:
          if (!
#line 2355 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4338; /* mve_vorrq_m_n_uv4si */

        default:
          return -1;
        }

    case 747:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2372 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4339; /* mve_vpselq_fv8hf */

        case 1:
          if (!
#line 2372 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4340; /* mve_vpselq_fv4sf */

        default:
          return -1;
        }

    case 732:
      if (pattern86 (x1, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 2389 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4341; /* mve_vrev32q_m_fv8hf */

    case 774:
      switch (pattern87 (x1))
        {
        case 0:
          if (!
#line 2406 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4342; /* mve_vrev32q_m_sv16qi */

        case 1:
          if (!
#line 2406 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4344; /* mve_vrev32q_m_sv8hi */

        default:
          return -1;
        }

    case 775:
      switch (pattern87 (x1))
        {
        case 0:
          if (!
#line 2406 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4343; /* mve_vrev32q_m_uv16qi */

        case 1:
          if (!
#line 2406 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4345; /* mve_vrev32q_m_uv8hi */

        default:
          return -1;
        }

    case 749:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2423 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4346; /* mve_vrev64q_m_fv8hf */

        case 1:
          if (!
#line 2423 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4347; /* mve_vrev64q_m_fv4sf */

        default:
          return -1;
        }

    case 757:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4348; /* mve_vrmlaldavhq_p_sv4si */

    case 816:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4349; /* mve_vrmlaldavhq_p_uv4si */

    case 758:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4350; /* mve_vrmlaldavhxq_p_sv4si */

    case 726:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4351; /* mve_vrmlsldavhq_p_sv4si */

    case 731:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4352; /* mve_vrmlsldavhxq_p_sv4si */

    case 811:
      if (pattern86 (x1, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 2479 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4357; /* mve_vrev16q_m_sv16qi */

    case 812:
      if (pattern86 (x1, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 2479 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4358; /* mve_vrev16q_m_uv16qi */

    case 814:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 2496 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4359; /* mve_vcvtq_m_from_f_uv8hi */

        case 1:
          if (!
#line 2496 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4361; /* mve_vcvtq_m_from_f_uv4si */

        default:
          return -1;
        }

    case 815:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 2496 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4360; /* mve_vcvtq_m_from_f_sv8hi */

        case 1:
          if (!
#line 2496 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4362; /* mve_vcvtq_m_from_f_sv4si */

        default:
          return -1;
        }

    case 1020:
      return recog_71 (x1, insn, pnum_clobbers);

    case 1022:
      return recog_78 (x1, insn, pnum_clobbers);

    case 1001:
      return recog_69 (x1, insn, pnum_clobbers);

    case 1003:
      return recog_87 (x1, insn, pnum_clobbers);

    case 999:
      return recog_74 (x1, insn, pnum_clobbers);

    case 1009:
      return recog_63 (x1, insn, pnum_clobbers);

    case 1014:
      return recog_73 (x1, insn, pnum_clobbers);

    case 1015:
      return recog_65 (x1, insn, pnum_clobbers);

    case 1025:
      return recog_72 (x1, insn, pnum_clobbers);

    case 1027:
      if (pattern93 (x1) != 0
          || !
#line 3678 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4935; /* mve_vstrq_truncate_scatter_shifted_offset_v4si */

    default:
      return -1;
    }
}

 int
recog_350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 25
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      operands[1] = x8;
      if (!mem_and_no_t1_wback_op (operands[1], E_HImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5046 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(unaligned_access)))
        return -1;
      return 6472; /* *p unaligned_loadhiu */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5688 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6)))
            return 6483; /* *p *arm_zero_extendhisi2 */
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5699 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return 6484; /* *p *arm_zero_extendhisi2_v6 */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6)))
            return -1;
          return 6980; /* *p *thumb2_zero_extendhisi2_v6 */

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5757 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6)))
            return 6486; /* *p *arm_zero_extendqisi2 */
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5769 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return 6487; /* *p *arm_zero_extendqisi2_v6 */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1120 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6)))
            return -1;
          return 6981; /* *p thumb2_zero_extendqisi2_v6 */

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x5, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      switch (pattern543 (x5))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 725 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6722; /* *p iwmmxt_textrmub */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 747 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6724; /* *p iwmmxt_textrmuh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_358 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern312 (x1))
    {
    case 0:
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4360 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
        return 6456; /* *p arm_qadd_insn */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4360 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ)))
        return -1;
      return 6457; /* *p arm_qadd_setq_insn */

    case 1:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 351 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6689; /* *p ssaddv8qi3 */

    case 2:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 361 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6690; /* *p ssaddv4hi3 */

    case 3:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 371 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6691; /* *p ssaddv2si3 */

    case 4:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7018; /* *p *arm_ssaddv4qq3 */

    case 5:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7019; /* *p *arm_ssaddv2hq3 */

    case 6:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7020; /* *p *arm_ssaddqq3 */

    case 7:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7021; /* *p *arm_ssaddhq3 */

    case 8:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7022; /* *p *arm_ssaddv2ha3 */

    case 9:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
        return -1;
      return 7023; /* *p *arm_ssaddha3 */

    case 10:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return -1;
      return 7024; /* *p *arm_ssaddsq3 */

    case 11:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 75 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return -1;
      return 7025; /* *p *arm_ssaddsa3 */

    default:
      return -1;
    }
}

 int
recog_374 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case MEM:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != MEM
          || pattern546 (x8) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x4, 0);
      operands[2] = x10;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x7, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x8, 0);
          x13 = XEXP (x12, 1);
          if (XWINT (x13, 0) != 4L)
            return -1;
          x14 = XEXP (x12, 0);
          if (!rtx_equal_p (x14, operands[3])
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 855 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6650; /* *p *ldm2_ */

        case PLUS:
          if (GET_MODE (x11) != E_SImode)
            return -1;
          x15 = XEXP (x11, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x16 = XEXP (x11, 0);
          operands[3] = x16;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x8, 0);
          x14 = XEXP (x12, 0);
          if (!rtx_equal_p (x14, operands[3]))
            return -1;
          switch (XWINT (x15, 0))
            {
            case 4L:
              x13 = XEXP (x12, 1);
              if (XWINT (x13, 0) != 8L
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 942 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6654; /* *p *ldm2_ib */

            case -8L:
              x13 = XEXP (x12, 1);
              if (XWINT (x13, 0) != -4L
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1044 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6662; /* *p *ldm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
      operands[1] = x7;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x3, 0);
      if (GET_CODE (x9) != MEM
          || GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x4, 0);
      if (pattern573 (x10) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x17 = XEXP (x9, 0);
      switch (GET_CODE (x17))
        {
        case REG:
        case SUBREG:
          operands[3] = x17;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x18 = XEXP (x10, 0);
          x19 = XEXP (x18, 1);
          if (XWINT (x19, 0) != 4L)
            return -1;
          x20 = XEXP (x18, 0);
          if (!rtx_equal_p (x20, operands[3])
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 904 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6652; /* *p *stm2_ */

        case PLUS:
          if (GET_MODE (x17) != E_SImode)
            return -1;
          x21 = XEXP (x17, 1);
          if (GET_CODE (x21) != CONST_INT)
            return -1;
          x22 = XEXP (x17, 0);
          operands[3] = x22;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x18 = XEXP (x10, 0);
          x20 = XEXP (x18, 0);
          if (!rtx_equal_p (x20, operands[3]))
            return -1;
          switch (XWINT (x21, 0))
            {
            case 4L:
              x19 = XEXP (x18, 1);
              if (XWINT (x19, 0) != 8L
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6656; /* *p *stm2_ib */

            case -8L:
              x19 = XEXP (x18, 1);
              if (XWINT (x19, 0) != -4L
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1070 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 2)))
                return -1;
              return 6664; /* *p *stm2_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (arm_general_register_operand (operands[0], E_DImode)
              && arm_general_register_operand (operands[1], E_DImode)
              && 
#line 6424 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_54 (insn, operands);
          break;

        case E_DFmode:
          if (arm_general_register_operand (operands[0], E_DFmode)
              && arm_general_register_operand (operands[1], E_DFmode)
              && 
#line 6424 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_55 (insn, operands);
          break;

        case E_V8QImode:
          if (arm_general_register_operand (operands[0], E_V8QImode)
              && arm_general_register_operand (operands[1], E_V8QImode)
              && 
#line 6424 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_56 (insn, operands);
          break;

        case E_V4HImode:
          if (arm_general_register_operand (operands[0], E_V4HImode)
              && arm_general_register_operand (operands[1], E_V4HImode)
              && 
#line 6424 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_57 (insn, operands);
          break;

        case E_V4BFmode:
          if (arm_general_register_operand (operands[0], E_V4BFmode)
              && arm_general_register_operand (operands[1], E_V4BFmode)
              && 
#line 6424 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_58 (insn, operands);
          break;

        case E_V4HFmode:
          if (arm_general_register_operand (operands[0], E_V4HFmode)
              && arm_general_register_operand (operands[1], E_V4HFmode)
              && 
#line 6424 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_59 (insn, operands);
          break;

        case E_V2SImode:
          if (arm_general_register_operand (operands[0], E_V2SImode)
              && arm_general_register_operand (operands[1], E_V2SImode)
              && 
#line 6424 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_60 (insn, operands);
          break;

        case E_V2SFmode:
          if (arm_general_register_operand (operands[0], E_V2SFmode)
              && arm_general_register_operand (operands[1], E_V2SFmode)
              && 
#line 6424 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_EITHER && reload_completed))
            return gen_split_61 (insn, operands);
          break;

        case E_EImode:
          if (s_register_operand (operands[0], E_EImode)
              && s_register_operand (operands[1], E_EImode)
              && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
            return gen_split_152 (insn, operands);
          break;

        case E_OImode:
          if (s_register_operand (operands[0], E_OImode)
              && s_register_operand (operands[1], E_OImode)
              && 
#line 220 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed))
            return gen_split_153 (insn, operands);
          break;

        case E_V2x16QImode:
          if (s_register_operand (operands[0], E_V2x16QImode)
              && s_register_operand (operands[1], E_V2x16QImode)
              && (
#line 220 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 157 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_154 (insn, operands);
          break;

        case E_V2x8HImode:
          if (s_register_operand (operands[0], E_V2x8HImode)
              && s_register_operand (operands[1], E_V2x8HImode)
              && (
#line 220 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 158 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_155 (insn, operands);
          break;

        case E_V2x4SImode:
          if (s_register_operand (operands[0], E_V2x4SImode)
              && s_register_operand (operands[1], E_V2x4SImode)
              && (
#line 220 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 159 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_156 (insn, operands);
          break;

        case E_V2x8HFmode:
          if (s_register_operand (operands[0], E_V2x8HFmode)
              && s_register_operand (operands[1], E_V2x8HFmode)
              && (
#line 220 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 160 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_157 (insn, operands);
          break;

        case E_V2x4SFmode:
          if (s_register_operand (operands[0], E_V2x4SFmode)
              && s_register_operand (operands[1], E_V2x4SFmode)
              && (
#line 220 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)&& reload_completed) && 
#line 161 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_158 (insn, operands);
          break;

        case E_CImode:
          if (s_register_operand (operands[0], E_CImode)
              && s_register_operand (operands[1], E_CImode)
              && 
#line 239 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && reload_completed))
            return gen_split_159 (insn, operands);
          break;

        case E_XImode:
          if (s_register_operand (operands[0], E_XImode)
              && s_register_operand (operands[1], E_XImode)
              && 
#line 261 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed))
            return gen_split_160 (insn, operands);
          break;

        case E_V4x16QImode:
          if (s_register_operand (operands[0], E_V4x16QImode)
              && s_register_operand (operands[1], E_V4x16QImode)
              && (
#line 261 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 166 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_161 (insn, operands);
          break;

        case E_V4x8HImode:
          if (s_register_operand (operands[0], E_V4x8HImode)
              && s_register_operand (operands[1], E_V4x8HImode)
              && (
#line 261 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 167 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_162 (insn, operands);
          break;

        case E_V4x4SImode:
          if (s_register_operand (operands[0], E_V4x4SImode)
              && s_register_operand (operands[1], E_V4x4SImode)
              && (
#line 261 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 168 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
            return gen_split_163 (insn, operands);
          break;

        case E_V4x8HFmode:
          if (s_register_operand (operands[0], E_V4x8HFmode)
              && s_register_operand (operands[1], E_V4x8HFmode)
              && (
#line 261 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 169 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_164 (insn, operands);
          break;

        case E_V4x4SFmode:
          if (s_register_operand (operands[0], E_V4x4SFmode)
              && s_register_operand (operands[1], E_V4x4SFmode)
              && (
#line 261 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE) && reload_completed) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
            return gen_split_165 (insn, operands);
          break;

        default:
          break;
        }
      break;

    case MEM:
      if (GET_MODE (x2) == E_DImode)
        {
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) == PLUS
              && GET_MODE (x4) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (s_register_operand (operands[0], E_DImode))
                {
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x6 = XEXP (x4, 1);
                      operands[2] = x6;
                      if (s_register_operand (operands[2], E_SImode)
                          && 
#line 6454 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD
  && reg_overlap_mentioned_p (operands[0], operands[1])
  && reg_overlap_mentioned_p (operands[0], operands[2])))
                        return gen_split_62 (insn, operands);
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (arm_general_register_operand (operands[0], E_SImode)
      && general_operand (operands[1], E_SImode)
      && 
#line 6638 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_USE_MOVT && GET_CODE (operands[1]) == SYMBOL_REF
   && !target_word_relocations
   && !arm_tls_referenced_p (operands[1])))
    return gen_split_65 (insn, operands);
  if (register_operand (operands[0], E_SImode)
      && const_int_operand (operands[1], E_SImode))
    {
      if (
#line 767 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && satisfies_constraint_J (operands[1])))
        return gen_split_126 (insn, operands);
      if (
#line 780 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && satisfies_constraint_K (operands[1])
   && !(TARGET_HAVE_MOVT && satisfies_constraint_j (operands[1]))))
        return gen_split_127 (insn, operands);
      if (
#line 808 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && satisfies_constraint_Pe (operands[1])
   && !(TARGET_HAVE_MOVT && satisfies_constraint_j (operands[1]))))
        return gen_split_128 (insn, operands);
      if (
#line 823 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && arm_disable_literal_pool
   && GET_CODE (operands[1]) == CONST_INT
   && !TARGET_HAVE_MOVT
   && !satisfies_constraint_K (operands[1])))
        return gen_split_129 (insn, operands);
    }
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return NULL;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return NULL;
  x6 = XEXP (x4, 1);
  if (pattern317 (x6, 
1) != 0)
    return NULL;
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return NULL;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return NULL;
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  if (!
#line 6674 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(flag_pic))
    return NULL;
  return gen_split_66 (insn, operands);
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return NULL;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x7 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x7) != SET)
    return NULL;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != SIGN_EXTEND
      || GET_MODE (x8) != E_SImode)
    return NULL;
  x9 = XEXP (x7, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], E_SImode))
    return NULL;
  x10 = XEXP (x8, 0);
  operands[4] = x10;
  if (!memory_operand (operands[4], E_QImode)
      || !
#line 565 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (XEXP (operands[4], 0)) == PLUS
   && rtx_equal_p (operands[0], XEXP (XEXP (operands[4], 0), 0))
   && rtx_equal_p (operands[2], XEXP (XEXP (operands[4], 0), 1))
   && (peep2_reg_dead_p (3, operands[0])
       || rtx_equal_p (operands[0], operands[3]))
   && (peep2_reg_dead_p (3, operands[2])
       || rtx_equal_p (operands[2], operands[3]))))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_36 (insn, operands);
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 3)
    return NULL;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != 100
      || GET_MODE (x2) != E_CCmode)
    return NULL;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CCmode
      || !register_operand (operands[1], E_SImode))
    return NULL;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  if (pattern493 (x5) != 0)
    return NULL;
  if (
#line 10029 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch5t && TARGET_32BIT && peep2_regno_dead_p (3, CC_REGNUM)
  && !(TARGET_THUMB2 && optimize_insn_for_size_p ())))
    {
      *pmatch_len_ = 2;
      res = gen_peephole2_10 (insn, operands);
      if (res != NULL_RTX)
        return res;
    }
  if (!
#line 10050 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && peep2_regno_dead_p (3, CC_REGNUM)))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_11 (insn, operands);
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (arm_general_register_operand (operands[0], E_SImode))
    {
      res = peephole2_4 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x2 = XEXP (x1, 1);
  if (!memory_operand (x2, E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != PARALLEL)
    return NULL;
  if (XVECLEN (x3, 0) == 3)
    {
      res = peephole2_5 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (XVECLEN (x3, 0) != 2)
    return NULL;
  operands[3] = x2;
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != SET)
    return NULL;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x7 = XEXP (x4, 1);
  operands[4] = x7;
  if (!memory_operand (operands[4], E_SImode))
    return NULL;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x9 = XEXP (x5, 1);
  operands[5] = x9;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_25 (insn, operands);
}

 rtx_insn *
peephole2_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  res = peephole2_8 (x1, insn, pmatch_len_);
  if (res != NULL_RTX)
    return res;
  if (peep2_current_count >= 4)
    {
      res = peephole2_9 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x3 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x3) != SET)
    return NULL;
  operands[0] = x2;
  if (s_register_operand (operands[0], E_SImode))
    {
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      if (memory_operand (operands[3], E_SImode))
        {
          x5 = PATTERN (peep2_next_insn (1));
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (s_register_operand (operands[1], E_SImode))
            {
              x7 = XEXP (x5, 1);
              operands[4] = x7;
              if (memory_operand (operands[4], E_SImode))
                {
                  x8 = XEXP (x3, 0);
                  operands[2] = x8;
                  if (s_register_operand (operands[2], E_SImode))
                    {
                      x9 = XEXP (x3, 1);
                      operands[5] = x9;
                      if (memory_operand (operands[5], E_SImode))
                        {
                          *pmatch_len_ = 2;
                          res = gen_peephole2_24 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
        }
    }
  operands[3] = x2;
  if (!memory_operand (operands[3], E_SImode))
    return NULL;
  x4 = XEXP (x1, 1);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (1));
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  if (!memory_operand (operands[4], E_SImode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x8 = XEXP (x3, 0);
  operands[5] = x8;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x9 = XEXP (x3, 1);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  *pmatch_len_ = 2;
  return gen_peephole2_28 (insn, operands);
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != CONST_INT)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (arm_general_register_operand (operands[0], E_SImode))
        {
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          if (arm_general_register_operand (operands[1], E_SImode))
            {
              operands[2] = x3;
              if (const_int_operand (operands[2], E_SImode)
                  && 
#line 928 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT &&
   !(const_ok_for_arm (INTVAL (operands[2]))
     || const_ok_for_arm (-INTVAL (operands[2])))
    && const_ok_for_arm (~INTVAL (operands[2]))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_1 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      if (peep2_current_count < 2
          || peep2_current_count < 3)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (register_operand (operands[2], E_SImode)
          && register_operand (operands[0], E_SImode))
        {
          res = peephole2_1 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      if (!cc_register (operands[2], E_VOIDmode)
          || XWINT (x3, 0) != -1L
          || !arm_general_register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != COMPARE)
        return NULL;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return NULL;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x11 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x11) != SET)
        return NULL;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != IF_THEN_ELSE)
        return NULL;
      x13 = XEXP (x12, 0);
      if (!equality_operator (x13, E_VOIDmode))
        return NULL;
      operands[3] = x13;
      x14 = XEXP (x13, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x15 = XEXP (x11, 0);
      if (GET_CODE (x15) != PC)
        return NULL;
      x16 = XEXP (x12, 1);
      operands[4] = x16;
      x17 = XEXP (x12, 2);
      operands[5] = x17;
      x18 = XEXP (x13, 0);
      if (!rtx_equal_p (x18, operands[2])
          || !
#line 1216 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && peep2_reg_dead_p (3, operands[2])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_4 (insn, operands);

    case COMPARE:
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          if (GET_MODE (x5) != E_DImode)
            return NULL;
          x19 = XEXP (x5, 0);
          if (GET_CODE (x19) != SIGN_EXTEND
              || GET_MODE (x19) != E_DImode)
            return NULL;
          x3 = XEXP (x2, 1);
          if (pattern321 (x3, 
E_SImode, 
PLUS, 
E_DImode, 
SIGN_EXTEND) != 0
              || pattern26 (x1, 
E_CC_Vmode) != 0)
            return NULL;
          x20 = XEXP (x19, 0);
          operands[0] = x20;
          if (!low_register_operand (operands[0], E_SImode))
            return NULL;
          x21 = XEXP (x5, 1);
          operands[1] = x21;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return NULL;
          x22 = XEXP (x3, 0);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[0]))
            return NULL;
          x24 = XEXP (x22, 1);
          if (!rtx_equal_p (x24, operands[1]))
            return NULL;
          if (
#line 1088 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_THUMB2
   && satisfies_constraint_Pd (operands[1])))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_2 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_THUMB2
   && dead_or_set_p (peep2_next_insn (0), operands[0])
   && satisfies_constraint_Py (operands[1])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_3 (insn, operands);

        case REG:
        case SUBREG:
          if (peep2_current_count >= 2)
            {
              res = peephole2_2 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG)
            return NULL;
          if (peep2_current_count >= 2)
            {
              res = peephole2_3 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[0] = x4;
          if (!cc_register (operands[0], E_CCmode)
              || GET_MODE (x2) != E_CCmode
              || !low_register_operand (operands[1], E_SImode))
            return NULL;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          if (
#line 1341 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && peep2_reg_dead_p (1, operands[1])
   && satisfies_constraint_Pw (operands[2])))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_41 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!
#line 1355 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && satisfies_constraint_Px (operands[2])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_42 (insn, operands);

        case ZERO_EXTRACT:
          if (peep2_current_count < 2
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != CONST_INT)
            return NULL;
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!cc_register (operands[0], E_CC_NZmode)
              || GET_MODE (x2) != E_CC_NZmode)
            return NULL;
          x19 = XEXP (x5, 0);
          operands[1] = x19;
          if (!low_register_operand (operands[1], E_SImode))
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != SET)
            return NULL;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != IF_THEN_ELSE)
            return NULL;
          x10 = XEXP (x8, 0);
          if (!equality_operator (x10, E_CC_NZmode))
            return NULL;
          operands[4] = x10;
          x25 = XEXP (x10, 1);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != PC)
            return NULL;
          x9 = XEXP (x8, 1);
          operands[5] = x9;
          x26 = XEXP (x8, 2);
          operands[6] = x26;
          x27 = XEXP (x10, 0);
          if (!rtx_equal_p (x27, operands[0]))
            return NULL;
          if (XWINT (x21, 0) == 1L)
            {
              x28 = XEXP (x5, 2);
              operands[2] = x28;
              if (const_int_operand (operands[2], E_SImode)
                  && 
#line 1566 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && (INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) < 32)
   && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_43 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x28 = XEXP (x5, 2);
          if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          operands[2] = x21;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 1595 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && (INTVAL (operands[2]) > 0 && INTVAL (operands[2]) < 32)
   && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_44 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!arm_general_register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!const_int_operand (operands[1], E_SImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 2051 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !const_ok_for_arm (INTVAL (operands[1]))
   && const_ok_for_arm (~INTVAL (operands[1]))))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_5 (insn, operands);

    case IOR:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!arm_general_register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 3766 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM
   && !const_ok_for_arm (INTVAL (operands[2]))
   && const_ok_for_arm (~INTVAL (operands[2]))))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_6 (insn, operands);

    case UNSPEC:
      if (peep2_current_count < 2
          || XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 2
          || GET_MODE (x2) != E_SImode)
        return NULL;
      x29 = XVECEXP (x2, 0, 1);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x30 = XVECEXP (x2, 0, 0);
      operands[3] = x30;
      if (!register_operand (operands[3], E_SImode))
        return NULL;
      x31 = XVECEXP (x2, 0, 2);
      operands[1] = x31;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!arm_general_register_operand (operands[2], E_SImode))
        return NULL;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 6793 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_7 (insn, operands);

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x1, 0);
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (peep2_current_count < 2)
            return NULL;
          operands[0] = x4;
          res = peephole2_6 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != SET)
            return NULL;
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode))
            {
              operands[0] = x2;
              if (arm_general_register_operand (operands[0], E_SImode))
                {
                  x7 = XEXP (x6, 0);
                  operands[3] = x7;
                  if (memory_operand (operands[3], E_SImode))
                    {
                      x8 = XEXP (x6, 1);
                      operands[1] = x8;
                      if (arm_general_register_operand (operands[1], E_SImode)
                          && 
#line 49 "../../gcc-15.0.1-20250313/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_14 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          if (peep2_current_count >= 3)
            {
              res = peephole2_10 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[0] = x4;
          if (pattern322 (x2) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_29 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode))
            {
              operands[0] = x2;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x7 = XEXP (x6, 0);
                  operands[3] = x7;
                  if (memory_operand (operands[3], E_SImode))
                    {
                      x8 = XEXP (x6, 1);
                      operands[1] = x8;
                      if (s_register_operand (operands[1], E_SImode))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_32 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          if (peep2_current_count < 3)
            return NULL;
          operands[0] = x4;
          if (pattern322 (x2) != 0)
            return NULL;
          x11 = PATTERN (peep2_next_insn (2));
          switch (GET_CODE (x11))
            {
            case PARALLEL:
              if (pattern566 (x11) != 0
                  || !s_register_operand (operands[4], E_SImode))
                return NULL;
              x32 = XVECEXP (x11, 0, 0);
              x33 = XEXP (x32, 1);
              x34 = XEXP (x33, 0);
              operands[6] = x34;
              if (!s_register_operand (operands[6], E_SImode))
                return NULL;
              x35 = XEXP (x33, 1);
              operands[7] = x35;
              if (!s_register_operand (operands[7], E_SImode)
                  || !
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(((((REGNO (operands[6]) == REGNO (operands[0]))
         && (REGNO (operands[7]) == REGNO (operands[1])))
      || ((REGNO (operands[7]) == REGNO (operands[0]))
         && (REGNO (operands[6]) == REGNO (operands[1]))))
    && (peep2_regno_dead_p (3, REGNO (operands[0]))
      || (REGNO (operands[0]) == REGNO (operands[4])))
    && (peep2_regno_dead_p (3, REGNO (operands[1]))
      || (REGNO (operands[1]) == REGNO (operands[4]))))))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_33 (insn, operands);

            case SET:
              x12 = XEXP (x11, 1);
              if (!commutative_binary_operator (x12, E_SImode))
                return NULL;
              operands[5] = x12;
              x15 = XEXP (x11, 0);
              operands[4] = x15;
              if (!s_register_operand (operands[4], E_SImode))
                return NULL;
              x13 = XEXP (x12, 0);
              operands[6] = x13;
              if (!s_register_operand (operands[6], E_SImode))
                return NULL;
              x16 = XEXP (x12, 1);
              operands[7] = x16;
              if (!s_register_operand (operands[7], E_SImode)
                  || !
#line 1188 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(((((REGNO (operands[6]) == REGNO (operands[0]))
         && (REGNO (operands[7]) == REGNO (operands[1])))
      || ((REGNO (operands[7]) == REGNO (operands[0]))
         && (REGNO (operands[6]) == REGNO (operands[1]))))
    && (peep2_regno_dead_p (3, REGNO (operands[0]))
      || (REGNO (operands[0]) == REGNO (operands[4])))
    && (peep2_regno_dead_p (3, REGNO (operands[1]))
      || (REGNO (operands[1]) == REGNO (operands[4]))))))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_34 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          operands[0] = x4;
          operands[1] = x2;
          if (memory_operand (operands[1], E_DImode)
              && low_register_operand (operands[0], E_DImode)
              && 
#line 663 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[1], 0), SImode)
   && !reg_overlap_mentioned_p (XEXP (operands[1], 0), operands[0])
   && peep2_reg_dead_p (1, XEXP (operands[1], 0))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_37 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!low_register_operand (operands[1], E_DImode)
              || !memory_operand (operands[0], E_DImode)
              || !
#line 679 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[0], 0), SImode)
   && peep2_reg_dead_p (1, XEXP (operands[0], 0))
   /* The low register in the transfer list may overlap the address,
      but the second cannot.  */
   && REGNO (XEXP (operands[0], 0)) != (REGNO (operands[1]) + 1)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_39 (insn, operands);

        case E_DFmode:
          operands[0] = x4;
          operands[1] = x2;
          if (memory_operand (operands[1], E_DFmode)
              && low_register_operand (operands[0], E_DFmode)
              && 
#line 663 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[1], 0), SImode)
   && !reg_overlap_mentioned_p (XEXP (operands[1], 0), operands[0])
   && peep2_reg_dead_p (1, XEXP (operands[1], 0))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_38 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!low_register_operand (operands[1], E_DFmode)
              || !memory_operand (operands[0], E_DFmode)
              || !
#line 679 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[0], 0), SImode)
   && peep2_reg_dead_p (1, XEXP (operands[0], 0))
   /* The low register in the transfer list may overlap the address,
      but the second cannot.  */
   && REGNO (XEXP (operands[0], 0)) != (REGNO (operands[1]) + 1)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_40 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (peep2_current_count < 2
          || !const_int_operand (x2, E_SImode))
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (peep2_current_count >= 3)
        {
          res = peephole2_14 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      if (!low_register_operand (operands[0], E_SImode))
        return NULL;
      operands[1] = x2;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != PLUS
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 13
          || GET_MODE (x9) != E_SImode)
        return NULL;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[0])
          || !
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && UINTVAL (operands[1]) < 1024
   && (UINTVAL (operands[1]) & 3) == 0))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_35 (insn, operands);

    default:
      return NULL;
    }
}
