/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1 (x3, 
E_SImode); /* [-1, 0] */

    case E_V8QImode:
      if (GET_MODE (x3) != E_V8QImode)
        return -1;
      return 1;

    case E_V4HImode:
      if (GET_MODE (x3) != E_V4HImode)
        return -1;
      return 2;

    case E_V2SImode:
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 3;

    case E_V2SFmode:
      if (pattern1 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 4;

    case E_V4QQmode:
      if (pattern1 (x3, 
E_V4QQmode) != 0)
        return -1;
      return 5;

    case E_V2HQmode:
      if (pattern1 (x3, 
E_V2HQmode) != 0)
        return -1;
      return 6;

    case E_QQmode:
      if (pattern1 (x3, 
E_QQmode) != 0)
        return -1;
      return 7;

    case E_HQmode:
      if (pattern1 (x3, 
E_HQmode) != 0)
        return -1;
      return 8;

    case E_V2HAmode:
      if (pattern1 (x3, 
E_V2HAmode) != 0)
        return -1;
      return 9;

    case E_HAmode:
      if (pattern1 (x3, 
E_HAmode) != 0)
        return -1;
      return 10;

    case E_SQmode:
      if (pattern1 (x3, 
E_SQmode) != 0)
        return -1;
      return 11;

    case E_SAmode:
      if (pattern1 (x3, 
E_SAmode) != 0)
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XEXP (x5, 0);
  if (GET_CODE (x9) != MEM
      || GET_MODE (x9) != E_SImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != PLUS
      || GET_MODE (x10) != E_SImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (GET_CODE (x13) != PLUS
      || GET_MODE (x13) != E_SImode)
    return -1;
  x14 = XEXP (x13, 1);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x15 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x15) != SET)
    return -1;
  x16 = XEXP (x15, 1);
  if (GET_CODE (x16) != PLUS
      || GET_MODE (x16) != E_SImode)
    return -1;
  x17 = XEXP (x16, 1);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  return 0;
}

int
pattern46 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i2))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    default:
      return -1;
    }
}

int
pattern59 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern67 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !vpr_register_operand (operands[3], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !vpr_register_operand (operands[3], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern82 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!s_register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !s_register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern108 (x3); /* [-1, 2] */
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern112 (x3); /* [-1, 1] */
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern124 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 13
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 14
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 12
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern135 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern38 (x3, 
i1, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern38 (x3, 
i2, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern38 (x3, 
i3, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern143 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern142 (x3, 
E_V2SFmode, 
E_V2SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern142 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern142 (x3, 
E_V8HFmode, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern142 (x3, 
E_V4HFmode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return pattern108 (x3); /* [-1, 2] */
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_OImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], E_OImode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_XImode))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    case E_V2DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern167 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !mve_imm_32 (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!vpr_register_operand (operands[2], E_V4BImode))
    return -1;
  return 0;
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return pattern115 (x3); /* [-1, 2] */
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern40 (x3, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern40 (x3, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arm_general_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!arm_general_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern205 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || !s_register_operand (operands[1], E_V16QImode)
      || !s_register_operand (operands[2], i2)
      || !mve_imm_8 (operands[3], E_SImode)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !s_register_operand (operands[3], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  return pattern214 (x3); /* [-1, 2] */
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern205 (x3, 
E_V8BImode, 
E_V8HImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern201 (x3, 
E_V4BImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern230 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern211 (x3, 
E_V8BImode, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern211 (x3, 
E_V4BImode, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern244 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern245 (x1, 
E_QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern245 (x1, 
E_HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern245 (x1, 
E_SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern253 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern258 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1
      || pattern257 (x1) != 0)
    return -1;
  return 0;
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mem_noofs_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_int_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!mem_noofs_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !reg_or_int_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case MULT:
    case ASHIFT:
    case ASHIFTRT:
      if (!sat_shift_operator (operands[3], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[4] = x6;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[5] = x7;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern289 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern295 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC_VOLATILE
      || XVECLEN (x2, 0) != 3
      || XINT (x2, 1) != 19)
    return -1;
  return 0;
}

int
pattern300 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!arm_comparison_operator (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  if (!cc_register (operands[2], E_VOIDmode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern311 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern318 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  operands[2] = x1;
  if (!memory_operand (operands[2], E_SImode))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!memory_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern329 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern336 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern335 (x1) != 0)
    return -1;
  return 0;
}

int
pattern343 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x3, 0);
  operands[3] = x8;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern342 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern342 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern342 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern356 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4SImode
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], E_V16QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  return 0;
}

int
pattern366 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 4)
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (XVECLEN (x6, 0) != 3
      || XINT (x6, 1) != i1
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XVECEXP (x6, 0, 1);
  if (GET_CODE (x7) != SUBREG
      || maybe_ne (SUBREG_BYTE (x7), 4)
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  x9 = XVECEXP (x3, 0, 0);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  operands[3] = x10;
  if (!s_register_operand (operands[3], E_DImode))
    return -1;
  x11 = XVECEXP (x3, 0, 2);
  operands[4] = x11;
  if (!mve_imm_selective_upto_8 (operands[4], E_SImode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[1] = x12;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x13 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x13, operands[2]))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[3]))
    return -1;
  x15 = XVECEXP (x6, 0, 2);
  if (!rtx_equal_p (x15, operands[4]))
    return -1;
  return pattern329 (x3); /* [-1, 2] */
}

int
pattern388 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode)
      || !arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern395 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern406 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_V2SImode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 2)
    return -1;
  return 0;
}

int
pattern415 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_OImode:
      if (!s_register_operand (operands[1], E_OImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern421 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern433 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern442 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  return 0;
}

int
pattern448 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MINUS
      || GET_MODE (x7) != E_SImode
      || pattern447 (x1, 
E_DImode, 
E_CC_Vmode) != 0)
    return -1;
  return 0;
}

int
pattern459 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mve_struct_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern467 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern471 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern481 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const_int_vcde2_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern485 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x1) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !s_register_operand (operands[2], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!s_register_operand (operands[3], E_V4HFmode))
            return -1;
          return 0;

        case E_V8HFmode:
          if (!s_register_operand (operands[3], E_V8HFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !s_register_operand (operands[2], E_V8HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V8HFmode:
          if (!s_register_operand (operands[3], E_V8HFmode))
            return -1;
          return 2;

        case E_V4HFmode:
          if (!s_register_operand (operands[3], E_V4HFmode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x1) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !s_register_operand (operands[2], E_V2SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V2SFmode:
          if (!s_register_operand (operands[3], E_V2SFmode))
            return -1;
          return 4;

        case E_V4SFmode:
          if (!s_register_operand (operands[3], E_V4SFmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !s_register_operand (operands[2], E_V4SFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4SFmode:
          if (!s_register_operand (operands[3], E_V4SFmode))
            return -1;
          return 6;

        case E_V2SFmode:
          if (!s_register_operand (operands[3], E_V2SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern539 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != VEC_SELECT
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern545 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern544 (x1) != 0)
    return -1;
  return 0;
}

int
pattern555 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern566 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (!commutative_binary_operator (x3, E_SImode))
    return -1;
  operands[5] = x3;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[4] = x6;
  return 0;
}

int
pattern577 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XVECEXP (x8, 0, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!guard_addr_operand (operands[1], E_SImode))
    return -1;
  x11 = XEXP (x5, 1);
  x12 = XEXP (x11, 0);
  operands[2] = x12;
  x13 = XVECEXP (x1, 0, 1);
  x14 = XEXP (x13, 0);
  operands[3] = x14;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  x15 = XVECEXP (x1, 0, 2);
  x16 = XEXP (x15, 0);
  operands[4] = x16;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern594 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern604 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern611 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_int_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern619 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern632 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern631 (x5, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern631 (x5, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern642 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!load_multiple_operation (operands[0], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!arm_hard_general_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!arm_hard_general_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!arm_hard_general_register_operand (operands[3], E_SImode))
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!arm_hard_general_register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern653 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  x13 = XEXP (x9, 0);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 1);
  x18 = XEXP (x17, 0);
  if (!rtx_equal_p (x18, operands[2]))
    return -1;
  x19 = XVECEXP (x1, 0, 4);
  x20 = XEXP (x19, 1);
  x21 = XEXP (x20, 0);
  if (!rtx_equal_p (x21, operands[3]))
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != SIGN_EXTEND
          || pattern448 (x1) != 0)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern615 (x1) != 0
          || !
#line 1669 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 27; /* subvsi3 */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (pattern448 (x1) != 0
              || !arm_immediate_operand (operands[1], E_VOIDmode)
              || pattern615 (x1) != 0
              || !
#line 1686 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 28; /* subvsi3_imm1 */

        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!arm_rhs_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern447 (x1, 
E_SImode, 
E_CC_NZmode) != 0
              || !arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x10, 0);
          operands[0] = x11;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          x13 = XEXP (x12, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x14 = XEXP (x12, 1);
          if (!rtx_equal_p (x14, operands[2])
              || !
#line 2067 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 46; /* subsi3_compare0 */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[2] = x7;
          if (!shift_operator (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x4, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || GET_MODE (x3) != E_CC_NZmode
              || GET_MODE (x4) != E_CC_NZmode
              || GET_MODE (x5) != E_SImode
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x7, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x16 = XEXP (x7, 1);
          operands[4] = x16;
          if (!shift_amount_operand (operands[4], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 1);
          switch (pattern548 (x10, 
MINUS))
            {
            case 0:
              x12 = XEXP (x10, 1);
              x14 = XEXP (x12, 1);
              switch (GET_CODE (x14))
                {
                case MULT:
                case ASHIFT:
                case ROTATE:
                case ASHIFTRT:
                case LSHIFTRT:
                case ROTATERT:
                  if (!rtx_equal_p (x14, operands[2]))
                    return -1;
                  x11 = XEXP (x10, 0);
                  operands[0] = x11;
                  if (!s_register_operand (operands[0], E_SImode))
                    return -1;
                  x13 = XEXP (x12, 0);
                  if (!rtx_equal_p (x13, operands[1])
                      || !
#line 9786 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 332; /* *sub_shiftsi_compare0 */

                default:
                  return -1;
                }

            case 1:
              if (!
#line 9802 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 333; /* *sub_shiftsi_compare0_scratch */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != SIGN_EXTEND
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (pattern477 (x9, 
MINUS) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (pattern418 (x10, 
MINUS) != 0
          || GET_MODE (x3) != E_CC_Vmode
          || GET_MODE (x4) != E_CC_Vmode
          || GET_MODE (x5) != E_DImode)
        return -1;
      x17 = XEXP (x8, 0);
      operands[1] = x17;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[4] = x7;
      if (!arm_borrow_operation (operands[4], E_DImode))
        return -1;
      x18 = XEXP (x9, 0);
      x19 = XEXP (x18, 1);
      operands[3] = x19;
      if (!arm_borrow_operation (operands[3], E_SImode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x20 = XEXP (x18, 0);
      x21 = XEXP (x20, 0);
      if (!rtx_equal_p (x21, operands[1]))
        return -1;
      x12 = XEXP (x10, 1);
      x13 = XEXP (x12, 0);
      x22 = XEXP (x13, 0);
      if (!rtx_equal_p (x22, operands[1]))
        return -1;
      x14 = XEXP (x12, 1);
      if (!rtx_equal_p (x14, operands[3]))
        return -1;
      x23 = XEXP (x6, 1);
      switch (GET_CODE (x23))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x23) != E_DImode)
            return -1;
          x24 = XEXP (x23, 0);
          operands[2] = x24;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x25 = XEXP (x20, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XEXP (x13, 1);
          if (!rtx_equal_p (x26, operands[2])
              || !
#line 2185 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 54; /* subvsi3_borrow */

        case CONST_INT:
          operands[2] = x23;
          if (!arm_adcimm_operand (operands[2], E_VOIDmode))
            return -1;
          x25 = XEXP (x20, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          x26 = XEXP (x13, 1);
          if (!rtx_equal_p (x26, operands[2])
              || !
#line 2206 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && INTVAL (operands[2]) == ARM_SIGN_EXTEND (INTVAL (operands[2]))))
            return -1;
          return 55; /* subvsi3_borrow_imm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_27 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case MEM:
      res = recog_25 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) == USE)
        {
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) == LABEL_REF)
            {
              x6 = XEXP (x2, 1);
              operands[0] = x6;
              if (register_operand (operands[0], E_SImode))
                {
                  x7 = XEXP (x5, 0);
                  operands[1] = x7;
                  if (
#line 2086 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                    return 1004; /* *thumb1_tablejump */
                }
            }
        }
      break;

    case REG:
    case SUBREG:
      res = recog_26 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x6 = XEXP (x2, 1);
  if (GET_CODE (x6) != SUBREG
      || maybe_ne (SUBREG_BYTE (x6), 0)
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x8 = XEXP (x6, 0);
  if (GET_CODE (x8) != UNSPEC
      || pattern287 (x1, 
UNSPEC, 
E_CCmode, 
100) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x4, 0) != 1
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x9 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 15
      || GET_MODE (x9) != E_SImode)
    return -1;
  switch (XVECLEN (x8, 0))
    {
    case 1:
      x10 = XVECEXP (x8, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x8, 1))
        {
        case 116:
          if (XINT (x4, 1) != 116)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 868 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 741; /* iwmmxt_tandcv2si3 */

            case E_V4HImode:
              if (!
#line 868 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 742; /* iwmmxt_tandcv4hi3 */

            case E_V8QImode:
              if (!
#line 868 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 743; /* iwmmxt_tandcv8qi3 */

            default:
              return -1;
            }

        case 117:
          if (XINT (x4, 1) != 117)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 878 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 744; /* iwmmxt_torcv2si3 */

            case E_V4HImode:
              if (!
#line 878 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 745; /* iwmmxt_torcv4hi3 */

            case E_V8QImode:
              if (!
#line 878 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 746; /* iwmmxt_torcv8qi3 */

            default:
              return -1;
            }

        case 118:
          if (XINT (x4, 1) != 118)
            return -1;
          switch (GET_MODE (x8))
            {
            case E_V2SImode:
              if (!
#line 888 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 747; /* iwmmxt_torvscv2si3 */

            case E_V4HImode:
              if (!
#line 888 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 748; /* iwmmxt_torvscv4hi3 */

            case E_V8QImode:
              if (!
#line 888 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 749; /* iwmmxt_torvscv8qi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x8, 1) != 119)
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || XINT (x4, 1) != 119)
        return -1;
      x11 = XVECEXP (x8, 0, 1);
      operands[0] = x11;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      switch (GET_MODE (x8))
        {
        case E_V2SImode:
          if (!
#line 899 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 750; /* iwmmxt_textrcv2si3 */

        case E_V4HImode:
          if (!
#line 899 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 751; /* iwmmxt_textrcv4hi3 */

        case E_V8QImode:
          if (!
#line 899 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 752; /* iwmmxt_textrcv8qi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case COMPARE:
      return recog_29 (x1, insn, pnum_clobbers);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      return recog_31 (x1, insn, pnum_clobbers);

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (s_register_operand (operands[0], E_SImode))
        {
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!low_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern296 (x5) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!low_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      if (low_reg_or_int_operand (operands[2], E_SImode))
        {
          operands[3] = x3;
          if (shift_operator (operands[3], E_SImode)
              && 
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && ((GET_CODE(operands[3]) != ROTATE && GET_CODE(operands[3]) != ROTATERT)
       || REG_P (operands[2]))))
            return 1053; /* *thumb2_shiftsi3_short */
        }
      if (!low_register_operand (operands[2], E_SImode)
          || GET_CODE (x3) != MULT
          || GET_MODE (x3) != E_SImode
          || !
#line 1429 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size && reload_completed))
        return -1;
      return 1061; /* *thumb2_mulsi_short */

    case TRUNCATE:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != MULT
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x6, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (GET_MODE (x10) != E_DImode)
        return -1;
      x11 = XEXP (x8, 1);
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x5, 0);
      operands[3] = x12;
      if (!scratch_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x10))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2515 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 71; /* *smull_high */

        case ZERO_EXTEND:
          if (GET_CODE (x11) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x10, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x14 = XEXP (x11, 0);
          operands[2] = x14;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2515 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 72; /* *umull_high */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_28 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      x7 = XEXP (x3, 1);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_16 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!arm_comparison_operator (operands[1], E_SImode)
          || pattern255 (x1) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      operands[3] = x7;
      if (!arm_add_operand (operands[3], E_SImode)
          || !
#line 9952 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 336; /* *compare_scc */

    case IF_THEN_ELSE:
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          switch (GET_CODE (x6))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              res = recog_20 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[5] = x6;
          if (!comparison_operator (operands[5], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != PLUS
              || GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER
              || pattern450 (x1) != 0
              || pattern575 (x3) != 0
              || !
#line 10767 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 350; /* movcond_addsi */

        default:
          return -1;
        }

    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      return recog_32 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      if (pattern13 (x1) != 0
          || !
#line 4360 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
        return -1;
      return 128; /* arm_qadd_setq_insn */

    case SS_MINUS:
      if (pattern13 (x1) != 0
          || !
#line 4360 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
        return -1;
      return 130; /* arm_qsub_setq_insn */

    case ABS:
      if (pattern14 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x5, 0);
      if (GET_CODE (x12) == REG
          && REGNO (x12) == 100
          && GET_MODE (x12) == E_CCmode)
        {
          if (
#line 5255 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 171; /* *arm_abssi2 */
          if (
#line 117 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return 1011; /* *thumb2_abssi2 */
        }
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode)
          || !
#line 334 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 957; /* *thumb1_abssi2 */

    case NEG:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case ABS:
          if (GET_MODE (x6) != E_SImode
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) == REG
              && REGNO (x12) == 100
              && GET_MODE (x12) == E_CCmode)
            {
              if (
#line 5319 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 172; /* *arm_neg_abssi2 */
              if (
#line 170 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return 1012; /* *thumb2_neg_abssi2 */
            }
          operands[2] = x12;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 349 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 958; /* *thumb1_neg_abssi2 */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[3] = x6;
          if (!arm_comparison_operator (operands[3], E_VOIDmode)
              || pattern385 (x1) != 0)
            return -1;
          if (
#line 10692 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 349; /* *negscc */
          if (!
#line 899 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
            return -1;
          return 1039; /* *thumb2_negscc */

        case REG:
        case SUBREG:
          operands[1] = x6;
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 100
              || GET_MODE (x12) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 315 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return -1;
              return 955; /* *thumb1_negdi2 */

            case E_SImode:
              if (!low_register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !low_register_operand (operands[1], E_SImode)
                  || !
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
                return -1;
              return 1067; /* *thumb2_negsi2_short */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      switch (pattern18 (x2))
        {
        case 0:
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          x12 = XEXP (x5, 0);
          operands[3] = x12;
          if (s_register_operand (operands[1], E_SImode))
            {
              if (
#line 8826 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 292; /* *call_value_reg_armv5 */
                }
              if (
#line 8837 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 293; /* *call_value_reg_arm */
                }
            }
          if (
#line 8877 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && !SIBLING_CALL_P (insn)
   && (GET_CODE (operands[1]) == SYMBOL_REF)
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[1]))))
            {
              *pnum_clobbers = 1;
              return 295; /* *call_value_symbol */
            }
          if (register_operand (operands[1], E_SImode))
            {
              if (
#line 1914 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch5t))
                {
                  *pnum_clobbers = 1;
                  return 994; /* *call_value_reg_thumb1_v5 */
                }
              if (
#line 1940 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch5t))
                {
                  *pnum_clobbers = 1;
                  return 996; /* *call_value_reg_thumb1 */
                }
            }
          if (
#line 1974 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (operands[1]) == SYMBOL_REF
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[1]))))
            {
              *pnum_clobbers = 1;
              return 998; /* *call_value_insn */
            }
          if (!register_operand (operands[1], E_SImode)
              || !
#line 569 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1028; /* *call_value_reg_thumb2 */

        case 1:
          x6 = XEXP (x3, 0);
          x15 = XVECEXP (x6, 0, 0);
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) == REG
              && REGNO (x16) == 4
              && GET_MODE (x16) == E_SImode)
            {
              x7 = XEXP (x3, 1);
              operands[1] = x7;
              x12 = XEXP (x5, 0);
              operands[2] = x12;
              if (
#line 1928 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && use_cmse))
                {
                  *pnum_clobbers = 1;
                  return 995; /* *nonsecure_call_value_reg_thumb1_v5 */
                }
            }
          operands[1] = x16;
          if (register_operand (operands[1], E_SImode))
            {
              x7 = XEXP (x3, 1);
              operands[2] = x7;
              x12 = XEXP (x5, 0);
              operands[3] = x12;
              if (
#line 582 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && TARGET_HAVE_FPCXT_CMSE))
                {
                  *pnum_clobbers = 1;
                  return 1029; /* *nonsecure_call_value_reg_thumb2_fpcxt */
                }
            }
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 4
              || GET_MODE (x16) != E_SImode)
            return -1;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          x12 = XEXP (x5, 0);
          operands[2] = x12;
          if (!
#line 595 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && !TARGET_HAVE_FPCXT_CMSE))
            return -1;
          *pnum_clobbers = 1;
          return 1030; /* *nonsecure_call_value_reg_thumb2 */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern296 (x5) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x3, 2);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 11839 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      return 382; /* *sign_extract_onebit */

    case NOT:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTRACT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x9 = XEXP (x6, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern256 (x5) != 0
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x6, 2);
          operands[2] = x18;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 11857 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 383; /* *not_signextract_onebit */

        case REG:
          operands[1] = x6;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (pattern256 (x5) != 0
              || !low_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !
#line 1512 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1066; /* *thumb2_one_cmplsi2_short */

        case AND:
          x5 = XVECEXP (x1, 0, 1);
          if (pattern295 (x5, pnum_clobbers) != 0)
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          x19 = XEXP (x5, 1);
          x20 = XVECEXP (x19, 0, 2);
          operands[3] = x20;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern530 (x1))
            {
            case 0:
              if (!
#line 483 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3165; /* atomic_nand_fetchqi */

            case 1:
              if (!
#line 483 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3166; /* atomic_nand_fetchhi */

            case 2:
              if (!
#line 483 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3167; /* atomic_nand_fetchsi */

            case 3:
              if (!
#line 483 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                return -1;
              *pnum_clobbers = 2;
              return 3168; /* atomic_nand_fetchdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (GET_CODE (x3))
        {
        case MEM:
          res = recog_23 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          res = recog_27 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (memory_operand (operands[2], E_SImode))
        {
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) == SET)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x12 = XEXP (x5, 0);
                  operands[1] = x12;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x19 = XEXP (x5, 1);
                      operands[3] = x19;
                      if (memory_operand (operands[3], E_SImode)
                          && 
#line 164 "../../gcc-15.0.1-20250313/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, true)))
                        return 435; /* *arm_ldrd */
                    }
                }
            }
        }
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!memory_operand (operands[2], E_SImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[3] = x12;
      if (!memory_operand (operands[3], E_SImode))
        return -1;
      x19 = XEXP (x5, 1);
      operands[1] = x19;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, false)))
        return -1;
      return 436; /* *arm_strd */

    case CONST_DOUBLE:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 2142 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !arm_const_double_rtx (operands[1])
   && !(TARGET_VFP_DOUBLE && vfp3_const_double_rtx (operands[1]))))
            return -1;
          return 927; /* no_literal_pool_df_immediate */

        case 1:
          if (!
#line 2169 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !vfp3_const_double_rtx (operands[1])))
            return -1;
          return 928; /* no_literal_pool_sf_immediate */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[2] = x12;
      if (!scratch_operand (operands[2], E_SImode)
          || !
#line 446 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 963; /* thumb1_extendhisi2 */

    case CONST_INT:
      operands[1] = x3;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern256 (x5) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!low_register_operand (operands[0], E_QImode)
              || !const_int_operand (operands[1], E_QImode)
              || !
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1054; /* *thumb2_movqi_shortim */

        case E_HImode:
          if (!low_register_operand (operands[0], E_HImode)
              || !const_int_operand (operands[1], E_HImode)
              || !
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1055; /* *thumb2_movhi_shortim */

        case E_SImode:
          if (!low_register_operand (operands[0], E_SImode)
              || !const_int_operand (operands[1], E_SImode)
              || !
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          return 1056; /* *thumb2_movsi_shortim */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_30 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern92 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !s_register_operand (operands[2], E_V8HImode)
          || !
#line 3581 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4916; /* mve_vldrq_gather_shifted_offset_v8hi */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !s_register_operand (operands[2], E_V4SImode)
          || !
#line 3581 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4917; /* mve_vldrq_gather_shifted_offset_v4si */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !s_register_operand (operands[2], E_V8HImode)
          || !
#line 3581 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4918; /* mve_vldrq_gather_shifted_offset_v8hf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !s_register_operand (operands[2], E_V4SImode)
          || !
#line 3581 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4919; /* mve_vldrq_gather_shifted_offset_v4sf */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !s_register_operand (operands[2], E_V2DImode)
          || !
#line 3581 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4920; /* mve_vldrq_gather_shifted_offset_v2di */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern89 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !
#line 3331 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4862; /* mve_vstrq_scatter_offset_v16qi */

    case E_V8HImode:
      switch (pattern507 ())
        {
        case 0:
          if (!
#line 3331 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
            return -1;
          return 4863; /* mve_vstrq_scatter_offset_v8hi */

        case 1:
          if (!
#line 3331 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
            return -1;
          return 4865; /* mve_vstrq_scatter_offset_v8hf */

        default:
          return -1;
        }

    case E_V4SImode:
      switch (pattern508 ())
        {
        case 0:
          if (!
#line 3331 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
            return -1;
          return 4864; /* mve_vstrq_scatter_offset_v4si */

        case 1:
          if (!
#line 3331 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
            return -1;
          return 4866; /* mve_vstrq_scatter_offset_v4sf */

        default:
          return -1;
        }

    case E_V2DImode:
      if (!s_register_operand (operands[1], E_V2DImode)
          || !s_register_operand (operands[2], E_V2DImode)
          || !
#line 3331 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4867; /* mve_vstrq_scatter_offset_v2di */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2439; /* neon_vrsras_nv8qi */

    case 1:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2443; /* neon_vrsras_nv16qi */

    case 2:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2447; /* neon_vrsras_nv4hi */

    case 3:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2451; /* neon_vrsras_nv8hi */

    case 4:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2455; /* neon_vrsras_nv2si */

    case 5:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2459; /* neon_vrsras_nv4si */

    case 6:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2463; /* neon_vrsras_ndi */

    case 7:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2467; /* neon_vrsras_nv2di */

    default:
      return -1;
    }
}

 int
recog_91 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern46 (x1, 
E_XImode, 
E_OImode))
    {
    case 0:
      if (!
#line 6036 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2913; /* neon_vld4qbv16qi */

    case 1:
      if (!
#line 6036 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2914; /* neon_vld4qbv8hi */

    case 2:
      if (!
#line 6036 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2915; /* neon_vld4qbv8hf */

    case 3:
      if (!(
#line 6036 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2916; /* neon_vld4qbv8bf */

    case 4:
      if (!
#line 6036 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2917; /* neon_vld4qbv4si */

    case 5:
      if (!
#line 6036 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2918; /* neon_vld4qbv4sf */

    default:
      return -1;
    }
}

 int
recog_99 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern42 (x1))
    {
    case 0:
      if (!
#line 3965 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2195; /* neon_vqrdmulh_lanev8hi */

    case 1:
      if (!
#line 3965 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2197; /* neon_vqrdmulh_lanev4si */

    case 2:
      if (!
#line 3979 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2199; /* neon_vqrdmulh_lanev4hi */

    case 3:
      if (!
#line 3979 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2201; /* neon_vqrdmulh_lanev2si */

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !mve_memory_operand (operands[1], E_V16QImode)
          || !
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4840; /* mve_vldrq_v16qi */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !mve_memory_operand (operands[1], E_V8HImode)
          || !
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4841; /* mve_vldrq_v8hi */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !mve_memory_operand (operands[1], E_V4SImode)
          || !
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4842; /* mve_vldrq_v4si */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !mve_memory_operand (operands[1], E_V8HFmode)
          || !
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4843; /* mve_vldrq_v8hf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !mve_memory_operand (operands[1], E_V4SFmode)
          || !
#line 3229 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4844; /* mve_vldrq_v4sf */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!memory_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !s_register_operand (operands[1], E_DImode)
          || !
#line 5061 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_LDRD))
        return -1;
      return 161; /* unaligned_storedi */

    case E_SImode:
      if (!mem_and_no_t1_wback_op (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_SImode)
          || !
#line 5072 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(unaligned_access))
        return -1;
      return 162; /* unaligned_storesi */

    case E_HImode:
      if (!mem_and_no_t1_wback_op (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !s_register_operand (operands[1], E_HImode)
          || !
#line 5087 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(unaligned_access))
        return -1;
      return 163; /* unaligned_storehi */

    case E_V8QImode:
      if (!memory_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 30 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1077; /* unaligned_storev8qi */

    default:
      return -1;
    }
}

 int
recog_122 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern105 (x1))
    {
    case 0:
      if (!
#line 3729 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2112; /* neon_vcvtsv2sf */

    case 1:
      if (!
#line 3729 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2114; /* neon_vcvtsv4sf */

    case 2:
      if (!
#line 3738 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2116; /* neon_vcvtsv2si */

    case 3:
      if (!
#line 3738 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2118; /* neon_vcvtsv4si */

    case 4:
      if (!
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2122; /* neon_vcvtsv4hi */

    case 5:
      if (!
#line 3767 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2124; /* neon_vcvtsv8hi */

    case 6:
      if (!
#line 3778 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2126; /* neon_vcvtsv8hf */

    case 7:
      if (!
#line 3778 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 2128; /* neon_vcvtsv4hf */

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (pattern392 (x2, 
E_V4HImode) != 0
          || !
#line 111 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 695; /* addcv4hi3 */

    case E_V2SImode:
      if (pattern392 (x2, 
E_V2SImode) != 0
          || !
#line 111 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 696; /* addcv2si3 */

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern159 (x1))
    {
    case 0:
      if (!s_register_operand (operands[0], E_TImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_TImode
          || !neon_struct_operand (operands[1], E_TImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5428 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2776; /* neon_vld2v8qi */

        case E_V4HImode:
          if (!
#line 5428 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2777; /* neon_vld2v4hi */

        case E_V4HFmode:
          if (!
#line 5428 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2778; /* neon_vld2v4hf */

        case E_V4BFmode:
          if (!(
#line 5428 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2779; /* neon_vld2v4bf */

        case E_V2SImode:
          if (!
#line 5428 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2780; /* neon_vld2v2si */

        case E_V2SFmode:
          if (!
#line 5428 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2781; /* neon_vld2v2sf */

        case E_DImode:
          if (!
#line 5428 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2782; /* neon_vld2di */

        default:
          return -1;
        }

    case 1:
      if (!s_register_operand (operands[0], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_OImode
          || !neon_struct_operand (operands[1], E_OImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V16QImode:
          if (!
#line 5446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2783; /* neon_vld2v16qi */

        case E_V8HImode:
          if (!
#line 5446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2784; /* neon_vld2v8hi */

        case E_V8HFmode:
          if (!
#line 5446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2785; /* neon_vld2v8hf */

        case E_V8BFmode:
          if (!(
#line 5446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2786; /* neon_vld2v8bf */

        case E_V4SImode:
          if (!
#line 5446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2787; /* neon_vld2v4si */

        case E_V4SFmode:
          if (!
#line 5446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2788; /* neon_vld2v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_148 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !const_int_vcde1_operand (operands[2], E_SImode)
          || !
#line 2192 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 929; /* arm_vcx1si */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !const_int_vcde1_operand (operands[2], E_SImode)
          || !
#line 2192 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 930; /* arm_vcx1di */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !const_int_mve_cde1_operand (operands[2], E_SImode)
          || !
#line 4436 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5049; /* arm_vcx1qv16qi */

    default:
      return -1;
    }
}

 int
recog_152 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V16QImode, 
E_V2x16QImode) != 0
          || !
#line 4072 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x16QImode))))
        return -1;
      return 4996; /* mve_vst2qv16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HImode, 
E_V2x8HImode) != 0
          || !
#line 4072 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HImode))))
        return -1;
      return 4997; /* mve_vst2qv8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SImode, 
E_V2x4SImode) != 0
          || !
#line 4072 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SImode))))
        return -1;
      return 4998; /* mve_vst2qv4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V8HFmode, 
E_V2x8HFmode) != 0
          || !
#line 4072 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x8HFmode))))
        return -1;
      return 4999; /* mve_vst2qv8hf */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern459 (x2, 
E_V4SFmode, 
E_V2x4SFmode) != 0
          || !
#line 4072 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V2x4SFmode))))
        return -1;
      return 5000; /* mve_vst2qv4sf */

    default:
      return -1;
    }
}

 int
recog_159 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      switch (pattern346 (x3))
        {
        case 0:
          if (!
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4856; /* mve_vldrq_z_extend_v8qis */

        case 1:
          if (!
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4858; /* mve_vldrq_z_extend_v4qis */

        case 2:
          if (!
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4860; /* mve_vldrq_z_extend_v4his */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern346 (x3))
        {
        case 0:
          if (!
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4857; /* mve_vldrq_z_extend_v8qiu */

        case 1:
          if (!
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4859; /* mve_vldrq_z_extend_v4qiu */

        case 2:
          if (!
#line 3298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4861; /* mve_vldrq_z_extend_v4hiu */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2314; /* neon_vqrshluv8qi */

    case 1:
      if (!
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2318; /* neon_vqrshluv16qi */

    case 2:
      if (!
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2322; /* neon_vqrshluv4hi */

    case 3:
      if (!
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2326; /* neon_vqrshluv8hi */

    case 4:
      if (!
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2330; /* neon_vqrshluv2si */

    case 5:
      if (!
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2334; /* neon_vqrshluv4si */

    case 6:
      if (!
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2338; /* neon_vqrshludi */

    case 7:
      if (!
#line 4520 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2342; /* neon_vqrshluv2di */

    default:
      return -1;
    }
}

 int
recog_179 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 2807 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1913; /* neon_vrecpsv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 2807 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1914; /* neon_vrecpsv4sf */

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0
          || !
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1915; /* neon_vrecpsv8hf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1916; /* neon_vrecpsv4hf */

    default:
      return -1;
    }
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern160 (x1, 
E_OImode))
    {
    case 0:
      if (!
#line 5982 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2900; /* neon_vld4v8qi */

    case 1:
      if (!
#line 5982 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2901; /* neon_vld4v4hi */

    case 2:
      if (!
#line 5982 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2902; /* neon_vld4v4hf */

    case 3:
      if (!(
#line 5982 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2903; /* neon_vld4v4bf */

    case 4:
      if (!
#line 5982 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2904; /* neon_vld4v2si */

    case 5:
      if (!
#line 5982 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2905; /* neon_vld4v2sf */

    case 6:
      if (!
#line 5982 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2906; /* neon_vld4di */

    default:
      return -1;
    }
}

 int
recog_198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern130 (x1))
    {
    case 0:
      if (!
#line 2095 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 920; /* neon_vminnmhf */

    case 1:
      if (!
#line 2106 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
        return -1;
      return 922; /* fminsf3 */

    case 2:
      if (!(
#line 2106 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
        return -1;
      return 924; /* fmindf3 */

    case 3:
      if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1862; /* neon_vminnmv8hf */

    case 4:
      if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1864; /* neon_vminnmv4hf */

    case 5:
      if (!
#line 2736 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
        return -1;
      return 1866; /* neon_vminnmv2sf */

    case 6:
      if (!
#line 2736 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
        return -1;
      return 1868; /* neon_vminnmv4sf */

    default:
      return -1;
    }
}

 int
recog_209 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1830; /* neon_vminuv8qi */

    case 1:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1834; /* neon_vminuv16qi */

    case 2:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1838; /* neon_vminuv4hi */

    case 3:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1842; /* neon_vminuv8hi */

    case 4:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1846; /* neon_vminuv2si */

    case 5:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1850; /* neon_vminuv4si */

    default:
      return -1;
    }
}

 int
recog_219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1484; /* neon_vrhaddsv8qi */

    case 1:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1488; /* neon_vrhaddsv16qi */

    case 2:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1492; /* neon_vrhaddsv4hi */

    case 3:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1496; /* neon_vrhaddsv8hi */

    case 4:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1500; /* neon_vrhaddsv2si */

    case 5:
      if (!
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1504; /* neon_vrhaddsv4si */

    default:
      return -1;
    }
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1711; /* neon_vclev2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1716; /* neon_vclev4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1731; /* neon_vclev8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1736; /* neon_vclev4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!usat16_imm (operands[2], E_SImode)
      || !
#line 6166 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
    return -1;
  return 252; /* arm_usat16_insn */
}

 int
recog_250 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (pattern232 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3622 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4923; /* mve_vldrq_gather_shifted_offset_z_v8hi */

    case E_V4SImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3622 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4924; /* mve_vldrq_gather_shifted_offset_z_v4si */

    case E_V8HFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V8BImode, 
E_V8HImode, 
E_V8HFmode) != 0
          || !
#line 3622 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4925; /* mve_vldrq_gather_shifted_offset_z_v8hf */

    case E_V4SFmode:
      x2 = XEXP (x1, 1);
      if (pattern511 (x2, 
E_V4BImode, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 3622 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4926; /* mve_vldrq_gather_shifted_offset_z_v4sf */

    case E_V2DImode:
      x2 = XEXP (x1, 1);
      if (pattern510 (x2, 
E_V2QImode, 
E_V2DImode) != 0
          || !
#line 3622 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4927; /* mve_vldrq_gather_shifted_offset_z_v2di */

    default:
      return -1;
    }
}

 int
recog_258 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (pattern213 (x3, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 3070 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4802; /* mve_vbrsrq_m_n_fv8hf */

    case E_V4SFmode:
      if (pattern213 (x3, 
E_V4BImode, 
E_V4SFmode) != 0
          || !
#line 3070 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4803; /* mve_vbrsrq_m_n_fv4sf */

    default:
      return -1;
    }
}

 int
recog_266 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 2);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      operands[3] = x4;
      if (const_int_operand (operands[3], E_SImode)
          && pattern394 (x2) == 0
          && 
#line 3116 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)))
        {
          *pnum_clobbers = 1;
          return 94; /* *ne_zeroextractsi */
        }
      if (XWINT (x4, 0) != 0L
          || pattern394 (x2) != 0
          || !
#line 3154 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 95; /* *ne_zeroextractsi_shifted */

    case REG:
    case SUBREG:
      switch (pattern235 (x2))
        {
        case 0:
          if (!
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3411; /* mve_vcmpneq_v16qi */

        case 1:
          if (!
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3419; /* mve_vcmpneq_v8hi */

        case 2:
          if (!
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3759; /* mve_vcmpneq_fv8hf */

        case 3:
          if (!
#line 641 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3427; /* mve_vcmpneq_v4si */

        case 4:
          if (!
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3765; /* mve_vcmpneq_fv4sf */

        case 5:
          if (!
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3435; /* mve_vcmpneq_n_v16qi */

        case 6:
          if (!
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3443; /* mve_vcmpneq_n_v8hi */

        case 7:
          if (!
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3771; /* mve_vcmpneq_n_fv8hf */

        case 8:
          if (!
#line 657 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3451; /* mve_vcmpneq_n_v4si */

        case 9:
          if (!
#line 1240 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3777; /* mve_vcmpneq_n_fv4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_276 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (!cc_register (x4, E_VOIDmode))
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case LABEL_REF:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      operands[1] = x3;
      if (!arm_comparison_operator (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x4;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!
#line 7974 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 277; /* arm_cond_branch */

    case PC:
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC
          || !arm_comparison_operator (x3, E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 2);
      switch (GET_CODE (x6))
        {
        case LABEL_REF:
          operands[1] = x3;
          operands[2] = x4;
          x9 = XEXP (x6, 0);
          operands[0] = x9;
          if (!
#line 8027 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 278; /* *arm_cond_branch_reversed */

        case RETURN:
          operands[0] = x3;
          operands[1] = x4;
          if (!
#line 9065 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM  && USE_RETURN_INSN (TRUE)))
            return -1;
          return 301; /* *cond_return_inverted */

        case SIMPLE_RETURN:
          operands[0] = x3;
          operands[1] = x4;
          if (!
#line 9065 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM  && use_simple_return_p ()))
            return -1;
          return 302; /* *cond_simple_return_inverted */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      x7 = XEXP (x1, 0);
      operands[0] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !s_register_operand (x5, E_SFmode))
            return -1;
          operands[3] = x5;
          operands[1] = x3;
          if (arm_vsel_comparison_operator (operands[1], E_VOIDmode))
            {
              operands[2] = x4;
              x6 = XEXP (x2, 2);
              operands[4] = x6;
              if (s_register_operand (operands[4], E_SFmode)
                  && 
#line 8443 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
                return 283; /* *cmovsf */
            }
          operands[1] = x5;
          operands[3] = x3;
          if (!arm_comparison_operator (operands[3], E_VOIDmode))
            return -1;
          operands[4] = x4;
          x6 = XEXP (x2, 2);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_SFmode))
            return -1;
          if (
#line 8570 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && TARGET_SOFT_FLOAT))
            return 287; /* *movsfcc_soft_insn */
          if (
#line 780 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT))
            return 778; /* *movsfcc_vfp */
          if (
#line 803 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE && !arm_restrict_it))
            return 779; /* *thumb2_movsfcc_vfp */
          if (!
#line 520 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_SOFT_FLOAT && !TARGET_HAVE_MVE))
            return -1;
          return 1024; /* *thumb2_movsfcc_soft_insn */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !s_register_operand (x5, E_DFmode))
            return -1;
          operands[3] = x5;
          operands[1] = x3;
          if (arm_vsel_comparison_operator (operands[1], E_VOIDmode))
            {
              operands[2] = x4;
              x6 = XEXP (x2, 2);
              operands[4] = x6;
              if (s_register_operand (operands[4], E_DFmode)
                  && (
#line 8443 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return 284; /* *cmovdf */
            }
          operands[1] = x5;
          operands[3] = x3;
          if (!arm_comparison_operator (operands[3], E_VOIDmode))
            return -1;
          operands[4] = x4;
          x6 = XEXP (x2, 2);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_DFmode))
            return -1;
          if (
#line 826 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return 780; /* *movdfcc_vfp */
          if (!
#line 849 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE && TARGET_VFP_DOUBLE
   && !arm_restrict_it))
            return -1;
          return 781; /* *thumb2_movdfcc_vfp */

        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode)
            return -1;
          operands[1] = x3;
          if (!arm_vsel_comparison_operator (operands[1], E_VOIDmode))
            return -1;
          operands[2] = x4;
          operands[3] = x5;
          if (!s_register_operand (operands[3], E_HFmode))
            return -1;
          x6 = XEXP (x2, 2);
          operands[4] = x6;
          if (!s_register_operand (operands[4], E_HFmode)
              || !
#line 8474 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 285; /* *cmovhf */

        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[3] = x3;
          if (!arm_comparison_operator (operands[3], E_VOIDmode))
            return -1;
          operands[4] = x4;
          operands[1] = x5;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x2, 2);
          operands[2] = x6;
          if (!arm_not_operand (operands[2], E_SImode)
              || !
#line 8506 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 286; /* *movsicc_insn */

        default:
          return -1;
        }

    case RETURN:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      operands[0] = x3;
      if (!arm_comparison_operator (operands[0], E_VOIDmode))
        return -1;
      operands[1] = x4;
      if (!
#line 9043 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM   && USE_RETURN_INSN (TRUE)))
        return -1;
      return 299; /* *cond_return */

    case SIMPLE_RETURN:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x1, 0);
      if (GET_CODE (x7) != PC)
        return -1;
      operands[0] = x3;
      if (!arm_comparison_operator (operands[0], E_VOIDmode))
        return -1;
      operands[1] = x4;
      if (!
#line 9043 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM   && use_simple_return_p ()))
        return -1;
      return 300; /* *cond_simple_return */

    default:
      return -1;
    }
}

 int
recog_283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!s_register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              operands[3] = x4;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              operands[2] = x6;
              if (!s_register_operand (operands[2], E_SImode)
                  || !s_register_operand (operands[1], E_SImode)
                  || !
#line 2279 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 57; /* *mla */

            case E_HFmode:
              if (pattern395 (x2, 
E_HFmode) != 0
                  || !
#line 1200 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 813; /* *mulsf3addhf_vfp */

            case E_SFmode:
              if (pattern395 (x2, 
E_SFmode) != 0
                  || !
#line 1211 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 814; /* *mulsf3addsf_vfp */

            case E_DFmode:
              if (pattern395 (x2, 
E_DFmode) != 0
                  || !
#line 1222 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 815; /* *muldf3adddf_vfp */

            case E_V8QImode:
              if (pattern395 (x2, 
E_V8QImode) != 0
                  || !
#line 588 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8QI_ARITH))
                return -1;
              return 1189; /* mulv8qi3addv8qi_neon */

            case E_V16QImode:
              if (pattern395 (x2, 
E_V16QImode) != 0
                  || !
#line 588 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V16QI_ARITH))
                return -1;
              return 1190; /* mulv16qi3addv16qi_neon */

            case E_V4HImode:
              if (pattern395 (x2, 
E_V4HImode) != 0
                  || !
#line 588 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HI_ARITH))
                return -1;
              return 1191; /* mulv4hi3addv4hi_neon */

            case E_V8HImode:
              if (pattern395 (x2, 
E_V8HImode) != 0
                  || !
#line 588 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HI_ARITH))
                return -1;
              return 1192; /* mulv8hi3addv8hi_neon */

            case E_V2SImode:
              if (pattern395 (x2, 
E_V2SImode) != 0
                  || !
#line 588 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SI_ARITH))
                return -1;
              return 1193; /* mulv2si3addv2si_neon */

            case E_V4SImode:
              if (pattern395 (x2, 
E_V4SImode) != 0
                  || !
#line 588 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SI_ARITH))
                return -1;
              return 1194; /* mulv4si3addv4si_neon */

            case E_V2SFmode:
              if (pattern395 (x2, 
E_V2SFmode) != 0
                  || !
#line 588 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
                return -1;
              return 1195; /* mulv2sf3addv2sf_neon */

            case E_V4SFmode:
              if (pattern395 (x2, 
E_V4SFmode) != 0
                  || !
#line 588 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
                return -1;
              return 1196; /* mulv4sf3addv4sf_neon */

            case E_V8HFmode:
              if (pattern395 (x2, 
E_V8HFmode) != 0
                  || !
#line 601 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH))
                return -1;
              return 1197; /* mulv8hf3addv8hf_neon */

            case E_V4HFmode:
              if (pattern395 (x2, 
E_V4HFmode) != 0
                  || !
#line 601 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH))
                return -1;
              return 1198; /* mulv4hf3addv4hf_neon */

            default:
              return -1;
            }

        case CONST_INT:
          operands[3] = x6;
          if (!power_of_two_operand (operands[3], E_SImode)
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          operands[2] = x4;
          if (!s_register_operand (operands[2], E_SImode)
              || !s_register_operand (operands[1], E_SImode)
              || !
#line 9686 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 319; /* *add_multsi */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_HImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_HImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern535 (x2, 
E_SImode) != 0
                  || !
#line 2603 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
                return -1;
              return 77; /* *arm_maddhisi4 */

            case E_DImode:
              if (pattern535 (x2, 
E_DImode) != 0
                  || !
#line 2747 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 83; /* maddhidi4 */

            default:
              return -1;
            }

        case ASHIFTRT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || !s_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          if (!s_register_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_DImode
              || !s_register_operand (operands[3], E_DImode))
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[2] = x8;
              if (!s_register_operand (operands[2], E_HImode)
                  || !
#line 2763 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 84; /* *maddhidi4tb */

            case ASHIFTRT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              x11 = XEXP (x8, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x12 = XEXP (x8, 0);
              operands[2] = x12;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 85; /* *maddhidi4tt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x13 = XEXP (x4, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      switch (GET_CODE (x6))
        {
        case SIGN_EXTEND:
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_HImode)
              || !
#line 2650 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
            return -1;
          return 79; /* maddhisi4tb */

        case ASHIFTRT:
          x14 = XEXP (x6, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2699 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
            return -1;
          return 81; /* maddhisi4tt */

        default:
          return -1;
        }

    case VEC_SELECT:
      if (pattern303 (x3, 
3, 
1) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      x14 = XEXP (x6, 1);
      x15 = XVECEXP (x14, 0, 0);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x14, 0, 1);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x5 = XEXP (x2, 1);
      if (pattern580 (x5, 
E_V2SImode, 
VEC_SELECT, 
MULT) != 0)
        return -1;
      x17 = XEXP (x5, 0);
      x18 = XEXP (x17, 1);
      if (GET_CODE (x18) != PARALLEL
          || XVECLEN (x18, 0) != 2)
        return -1;
      x19 = XVECEXP (x18, 0, 0);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XVECEXP (x18, 0, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x21 = XEXP (x5, 1);
      if (GET_CODE (x21) != VEC_SELECT
          || GET_MODE (x21) != E_V2SImode)
        return -1;
      x22 = XEXP (x21, 1);
      if (GET_CODE (x22) != PARALLEL
          || XVECLEN (x22, 0) != 2)
        return -1;
      x23 = XVECEXP (x22, 0, 0);
      if (GET_CODE (x23) != CONST_INT)
        return -1;
      x24 = XVECEXP (x22, 0, 1);
      if (GET_CODE (x24) != CONST_INT)
        return -1;
      switch (pattern630 (x2))
        {
        case 0:
          switch (pattern643 (x2, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 1454 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 663; /* iwmmxt_wmadds */

            case 1:
              if (!
#line 194 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 699; /* iwmmxt_wmaddsx */

            default:
              return -1;
            }

        case 1:
          switch (pattern643 (x2, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 1473 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 664; /* iwmmxt_wmaddu */

            case 1:
              if (!
#line 213 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 700; /* iwmmxt_wmaddux */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_288 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CONST_INT:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
          operands[2] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern371 (x2) != 0
                  || !
#line 3023 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 90; /* *arm_andsi3_insn */

            case E_DImode:
              if (pattern347 (x2, 
E_DImode) != 0
                  || !
#line 83 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 535; /* iwmmxt_anddi3 */

            case E_V2SImode:
              if (GET_MODE (x2) != E_V2SImode)
                return -1;
              if (register_operand (operands[0], E_V2SImode)
                  && register_operand (operands[1], E_V2SImode)
                  && register_operand (operands[2], E_V2SImode)
                  && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 543; /* *andv2si3_iwmmxt */
              if (!s_register_operand (operands[0], E_V2SImode)
                  || !s_register_operand (operands[1], E_V2SImode)
                  || !neon_inv_logic_op2 (operands[2], E_V2SImode)
                  || !
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1258; /* andv2si3_neon */

            case E_V4HImode:
              if (GET_MODE (x2) != E_V4HImode)
                return -1;
              if (register_operand (operands[0], E_V4HImode)
                  && register_operand (operands[1], E_V4HImode)
                  && register_operand (operands[2], E_V4HImode)
                  && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 544; /* *andv4hi3_iwmmxt */
              if (!s_register_operand (operands[0], E_V4HImode)
                  || !s_register_operand (operands[1], E_V4HImode)
                  || !neon_inv_logic_op2 (operands[2], E_V4HImode)
                  || !
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1256; /* andv4hi3_neon */

            case E_V8QImode:
              if (GET_MODE (x2) != E_V8QImode)
                return -1;
              if (register_operand (operands[0], E_V8QImode)
                  && register_operand (operands[1], E_V8QImode)
                  && register_operand (operands[2], E_V8QImode)
                  && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 545; /* *andv8qi3_iwmmxt */
              if (!s_register_operand (operands[0], E_V8QImode)
                  || !s_register_operand (operands[1], E_V8QImode)
                  || !neon_inv_logic_op2 (operands[2], E_V8QImode)
                  || !
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1254; /* andv8qi3_neon */

            case E_V16QImode:
              if (pattern396 (x2, 
E_V16QImode) != 0)
                return -1;
              if (
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1255; /* andv16qi3_neon */
              if (!
#line 759 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3554; /* mve_vandq_uv16qi */

            case E_V8HImode:
              if (pattern396 (x2, 
E_V8HImode) != 0)
                return -1;
              if (
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1257; /* andv8hi3_neon */
              if (!
#line 759 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3555; /* mve_vandq_uv8hi */

            case E_V4SImode:
              if (pattern396 (x2, 
E_V4SImode) != 0)
                return -1;
              if (
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1259; /* andv4si3_neon */
              if (!
#line 759 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3556; /* mve_vandq_uv4si */

            case E_V4HFmode:
              if (pattern396 (x2, 
E_V4HFmode) != 0
                  || !
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1260; /* andv4hf3_neon */

            case E_V8HFmode:
              if (!s_register_operand (operands[0], E_V8HFmode)
                  || GET_MODE (x2) != E_V8HFmode
                  || !s_register_operand (operands[1], E_V8HFmode))
                return -1;
              if (neon_inv_logic_op2 (operands[2], E_V8HFmode)
                  && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1261; /* andv8hf3_neon */
              if (!s_register_operand (operands[2], E_V8HFmode)
                  || !
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3738; /* mve_vandq_fv8hf */

            case E_V2SFmode:
              if (pattern396 (x2, 
E_V2SFmode) != 0
                  || !
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1262; /* andv2sf3_neon */

            case E_V4SFmode:
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x2) != E_V4SFmode
                  || !s_register_operand (operands[1], E_V4SFmode))
                return -1;
              if (neon_inv_logic_op2 (operands[2], E_V4SFmode)
                  && 
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1263; /* andv4sf3_neon */
              if (!s_register_operand (operands[2], E_V4SFmode)
                  || !
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3739; /* mve_vandq_fv4sf */

            case E_V2DImode:
              if (pattern396 (x2, 
E_V2DImode) != 0
                  || !
#line 749 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1264; /* andv2di3_neon */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x4) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 94 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 536; /* iwmmxt_nanddi3 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode)
                return -1;
              if (s_register_operand (operands[0], E_SImode))
                {
                  operands[2] = x6;
                  if (s_register_operand (operands[2], E_SImode))
                    {
                      x4 = XEXP (x2, 1);
                      operands[1] = x4;
                      if (s_register_operand (operands[1], E_SImode)
                          && 
#line 3605 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                        return 104; /* andsi_notsi_si */
                    }
                }
              if (!register_operand (operands[0], E_SImode))
                return -1;
              operands[1] = x6;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (!register_operand (operands[2], E_SImode)
                  || !
#line 235 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return -1;
              return 948; /* thumb1_bicsi3 */

            case E_V8QImode:
              if (pattern358 (x2, 
E_V8QImode) != 0
                  || !
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1276; /* bicv8qi3_neon */

            case E_V16QImode:
              if (pattern358 (x2, 
E_V16QImode) != 0)
                return -1;
              if (
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1277; /* bicv16qi3_neon */
              if (!
#line 786 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3557; /* mve_vbicq_uv16qi */

            case E_V4HImode:
              if (pattern358 (x2, 
E_V4HImode) != 0
                  || !
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1278; /* bicv4hi3_neon */

            case E_V8HImode:
              if (pattern358 (x2, 
E_V8HImode) != 0)
                return -1;
              if (
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1279; /* bicv8hi3_neon */
              if (!
#line 786 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3558; /* mve_vbicq_uv8hi */

            case E_V2SImode:
              if (pattern358 (x2, 
E_V2SImode) != 0
                  || !
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1280; /* bicv2si3_neon */

            case E_V4SImode:
              if (pattern358 (x2, 
E_V4SImode) != 0)
                return -1;
              if (
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1281; /* bicv4si3_neon */
              if (!
#line 786 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3559; /* mve_vbicq_uv4si */

            case E_V4HFmode:
              if (pattern358 (x2, 
E_V4HFmode) != 0
                  || !
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1282; /* bicv4hf3_neon */

            case E_V8HFmode:
              if (pattern359 (x2, 
E_V8HFmode) != 0)
                return -1;
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              operands[2] = x6;
              if (
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1283; /* bicv8hf3_neon */
              operands[2] = x4;
              operands[1] = x6;
              if (!
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3740; /* mve_vbicq_fv8hf */

            case E_V2SFmode:
              if (pattern358 (x2, 
E_V2SFmode) != 0
                  || !
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1284; /* bicv2sf3_neon */

            case E_V4SFmode:
              if (pattern359 (x2, 
E_V4SFmode) != 0)
                return -1;
              x4 = XEXP (x2, 1);
              operands[1] = x4;
              operands[2] = x6;
              if (
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return 1285; /* bicv4sf3_neon */
              operands[2] = x4;
              operands[1] = x6;
              if (!
#line 1192 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
                return -1;
              return 3741; /* mve_vbicq_fv4sf */

            case E_V2DImode:
              if (pattern358 (x2, 
E_V2DImode) != 0
                  || !
#line 775 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 1286; /* bicv2di3_neon */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[4] = x6;
          if (!shift_operator (operands[4], E_SImode)
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          if (!shift_amount_operand (operands[3], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 3617 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 105; /* andsi_not_shiftsi_si */

        default:
          return -1;
        }

    case IOR:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != NOT
          || GET_MODE (x4) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      if (!arm_rhs_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!arm_rhs_operand (operands[3], E_SImode)
          || !
#line 3910 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 116; /* *andsi_iorsi3_notsi */

    case MULT:
      if (pattern275 (x2) != 0
          || !
#line 9686 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 323; /* *and_multsi */

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x3;
      if (pattern304 (x2) != 0
          || !
#line 9700 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT))
        return -1;
      return 328; /* *and_shiftsi */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      if (pattern305 (x2) == 0
          && 
#line 9815 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
        return 334; /* *and_scc */
      if (pnum_clobbers == NULL
          || pattern306 (x2) != 0)
        return -1;
      if (
#line 10556 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       != CCmode)))
        {
          *pnum_clobbers = 1;
          return 346; /* *and_scc_scc */
        }
      if (!
#line 10624 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       == CCmode)))
        return -1;
      *pnum_clobbers = 1;
      return 348; /* *and_scc_scc_nodom */

    default:
      return -1;
    }
}

 int
recog_301 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      switch (XINT (x2, 1))
        {
        case 52:
          if (pattern100 (x1, 
E_CCmode, 
104) != 0
              || !
#line 4429 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM_QBIT))
            return -1;
          return 132; /* arm_set_apsr */

        case 45:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 12302 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_HARD_TP))
            return -1;
          return 406; /* reload_tp_hard */

        case 53:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_MODE (x5) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          switch (GET_CODE (x5))
            {
            case POST_DEC:
              x6 = XEXP (x5, 0);
              operands[0] = x6;
              if (!s_register_operand (operands[0], E_SImode)
                  || !
#line 1647 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse))
                return -1;
              return 856; /* push_fpsysreg_insn */

            case POST_INC:
              x6 = XEXP (x5, 0);
              operands[0] = x6;
              if (!s_register_operand (operands[0], E_SImode)
                  || !
#line 1666 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HAVE_FPCXT_CMSE && use_cmse))
                return -1;
              return 857; /* pop_fpsysreg_insn */

            default:
              return -1;
            }

        case 29:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 2124 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_BASE))
            return -1;
          return 926; /* get_fpscr */

        case 26:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !mem_and_no_t1_wback_op (operands[1], E_QImode))
                return -1;
              return 3072; /* arm_atomic_loadqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !mem_and_no_t1_wback_op (operands[1], E_HImode))
                return -1;
              return 3073; /* arm_atomic_loadhi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !mem_and_no_t1_wback_op (operands[1], E_SImode))
                return -1;
              return 3074; /* arm_atomic_loadsi */

            default:
              return -1;
            }

        case 25:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !arm_sync_memory_operand (operands[1], E_QImode)
                  || !
#line 79 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3075; /* arm_atomic_load_acquireqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !arm_sync_memory_operand (operands[1], E_HImode)
                  || !
#line 79 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3076; /* arm_atomic_load_acquirehi */

            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !arm_sync_memory_operand (operands[1], E_SImode)
                  || !
#line 79 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3077; /* arm_atomic_load_acquiresi */

            default:
              return -1;
            }

        case 28:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!mem_and_no_t1_wback_op (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !register_operand (operands[1], E_QImode))
                return -1;
              return 3078; /* arm_atomic_storeqi */

            case E_HImode:
              if (!mem_and_no_t1_wback_op (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 3079; /* arm_atomic_storehi */

            case E_SImode:
              if (!mem_and_no_t1_wback_op (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 3080; /* arm_atomic_storesi */

            default:
              return -1;
            }

        case 27:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!arm_sync_memory_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !register_operand (operands[1], E_QImode)
                  || !
#line 97 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3081; /* arm_atomic_store_releaseqi */

            case E_HImode:
              if (!arm_sync_memory_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !register_operand (operands[1], E_HImode)
                  || !
#line 97 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3082; /* arm_atomic_store_releasehi */

            case E_SImode:
              if (!arm_sync_memory_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 97 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3083; /* arm_atomic_store_releasesi */

            default:
              return -1;
            }

        case 21:
          if (GET_MODE (x2) != E_DImode)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[1] = x3;
          if (!arm_ldrd_memory_operand (operands[1], E_DImode)
              || !
#line 166 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(ARM_DOUBLEWORD_ALIGN && TARGET_HAVE_LPAE))
            return -1;
          return 3084; /* arm_atomic_loaddi2_ldrd */

        case 20:
          switch (pattern241 (x1))
            {
            case 0:
              if (!
#line 519 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX))
                return -1;
              return 3173; /* arm_load_exclusivesi */

            case 1:
              if (!
#line 537 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD))
                return -1;
              return 3175; /* arm_load_exclusivedi */

            default:
              return -1;
            }

        case 23:
          switch (pattern241 (x1))
            {
            case 0:
              if (!
#line 528 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
                return -1;
              return 3174; /* arm_load_acquire_exclusivesi */

            case 1:
              if (!
#line 546 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQEXD && ARM_DOUBLEWORD_ALIGN))
                return -1;
              return 3176; /* arm_load_acquire_exclusivedi */

            default:
              return -1;
            }

        case 120:
          if (pattern94 (x2, 
101, 
E_SImode) != 0)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 3969 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4978; /* get_fpscr_nzcvqc */

        case 31:
          if (GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 101
              || GET_MODE (x4) != E_SImode)
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          operands[0] = x3;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 3977 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4979; /* set_fpscr_nzcvqc */

        case 61:
          if (pattern100 (x1, 
E_SImode, 
14) != 0
              || !
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5075; /* dlstp8_insn */

        case 62:
          if (pattern100 (x1, 
E_SImode, 
14) != 0
              || !
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5076; /* dlstp16_insn */

        case 63:
          if (pattern100 (x1, 
E_SImode, 
14) != 0
              || !
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5077; /* dlstp32_insn */

        case 64:
          if (pattern100 (x1, 
E_SImode, 
14) != 0
              || !
#line 4702 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5078; /* dlstp64_insn */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 32:
          if (pattern128 (x1, 
E_SImode) != 0
              || !
#line 9273 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 307; /* probe_stack_range */

        case 58:
          if (pattern124 (x1) != 0
              || !
#line 13108 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch8m_main))
            return -1;
          return 515; /* pacbti_nop */

        case 13:
          switch (pattern242 (x1))
            {
            case 0:
              if (!
#line 802 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 594; /* eqv8qi3 */

            case 1:
              if (!
#line 813 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 595; /* eqv4hi3 */

            case 2:
              if (!
#line 825 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 596; /* eqv2si3 */

            default:
              return -1;
            }

        case 14:
          switch (pattern242 (x1))
            {
            case 0:
              if (!
#line 836 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 597; /* gtuv8qi3 */

            case 1:
              if (!
#line 847 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 598; /* gtuv4hi3 */

            case 2:
              if (!
#line 858 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 599; /* gtuv2si3 */

            default:
              return -1;
            }

        case 15:
          switch (pattern242 (x1))
            {
            case 0:
              if (!
#line 869 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 600; /* gtv8qi3 */

            case 1:
              if (!
#line 880 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 601; /* gtv4hi3 */

            case 2:
              if (!
#line 891 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 602; /* gtv2si3 */

            default:
              return -1;
            }

        case 19:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          x7 = XVECEXP (x2, 0, 1);
          operands[2] = x7;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x3))
            {
            case PLUS:
              switch (pattern399 (x2))
                {
                case 0:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3097; /* atomic_addqi */

                case 1:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3102; /* atomic_addhi */

                case 2:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3107; /* atomic_addsi */

                case 3:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3112; /* atomic_adddi */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern399 (x2))
                {
                case 0:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3098; /* atomic_subqi */

                case 1:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3103; /* atomic_subhi */

                case 2:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3108; /* atomic_subsi */

                case 3:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3113; /* atomic_subdi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern399 (x2))
                {
                case 0:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3099; /* atomic_orqi */

                case 1:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3104; /* atomic_orhi */

                case 2:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3109; /* atomic_orsi */

                case 3:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3114; /* atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern399 (x2))
                {
                case 0:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3100; /* atomic_xorqi */

                case 1:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3105; /* atomic_xorhi */

                case 2:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3110; /* atomic_xorsi */

                case 3:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3115; /* atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern399 (x2))
                {
                case 0:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3101; /* atomic_andqi */

                case 1:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3106; /* atomic_andhi */

                case 2:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3111; /* atomic_andsi */

                case 3:
                  if (!
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3116; /* atomic_anddi */

                default:
                  return -1;
                }

            case NOT:
              x8 = XEXP (x3, 0);
              if (GET_CODE (x8) != AND)
                return -1;
              x9 = XEXP (x8, 1);
              operands[1] = x9;
              x10 = XEXP (x8, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern514 (x2, 
E_QImode) != 0
                      || !
#line 366 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3117; /* atomic_nandqi */

                case E_HImode:
                  if (pattern514 (x2, 
E_HImode) != 0
                      || !
#line 366 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3118; /* atomic_nandhi */

                case E_SImode:
                  if (pattern514 (x2, 
E_SImode) != 0
                      || !
#line 366 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3119; /* atomic_nandsi */

                case E_DImode:
                  if (!mem_noofs_operand (operands[0], E_DImode)
                      || GET_MODE (x2) != E_DImode
                      || GET_MODE (x3) != E_DImode
                      || GET_MODE (x8) != E_DImode
                      || !s_register_operand (operands[1], E_DImode)
                      || !
#line 366 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3120; /* atomic_nanddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      if (pattern9 (x1, 
E_SImode) != 0)
        return -1;
      x11 = XVECEXP (x2, 0, 3);
      operands[4] = x11;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      x12 = XVECEXP (x2, 0, 4);
      operands[5] = x12;
      if (!immediate_operand (operands[5], E_SImode))
        return -1;
      switch (XINT (x2, 1))
        {
        case 45:
          if (!
#line 13026 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MRC)))
            return -1;
          return 507; /* arm_mrc */

        case 46:
          if (!
#line 13026 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MRC2)))
            return -1;
          return 508; /* arm_mrc2 */

        default:
          return -1;
        }

    case 3:
      if (pattern9 (x1, 
E_DImode) != 0)
        return -1;
      switch (XINT (x2, 1))
        {
        case 49:
          if (!
#line 13059 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MRRC)))
            return -1;
          return 511; /* arm_mrrc */

        case 50:
          if (!
#line 13059 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MRRC2)))
            return -1;
          return 512; /* arm_mrrc2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_309 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (s_register_operand (operands[0], E_SImode)
              && s_register_operand (operands[1], E_SImode)
              && 
#line 5179 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 168; /* *arm_negsi2 */
          if (register_operand (operands[0], E_SImode)
              && register_operand (operands[1], E_SImode)
              && 
#line 324 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 956; /* *thumb1_negsi2 */
          if (pnum_clobbers == NULL
              || !low_register_operand (operands[0], E_SImode)
              || !low_register_operand (operands[1], E_SImode)
              || !
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1067; /* *thumb2_negsi2_short */

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !
#line 890 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 784; /* *negsf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !
#line 901 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 785; /* *negdf2_vfp */

        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x3) != E_HFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !
#line 949 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 787; /* neghf2 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 315 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          *pnum_clobbers = 1;
          return 955; /* *thumb1_negdi2 */

        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_V8QImode)
              || !
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1317; /* neon_negv8qi2 */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !s_register_operand (operands[1], E_V16QImode))
            return -1;
          if (
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1318; /* neon_negv16qi2 */
          if (!
#line 280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3297; /* mve_vnegq_sv16qi */

        case E_V4HImode:
          if (!s_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_V4HImode)
              || !
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1319; /* neon_negv4hi2 */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !s_register_operand (operands[1], E_V8HImode))
            return -1;
          if (
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1320; /* neon_negv8hi2 */
          if (!
#line 280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3299; /* mve_vnegq_sv8hi */

        case E_V2SImode:
          if (!s_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_V2SImode)
              || !
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1321; /* neon_negv2si2 */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !s_register_operand (operands[1], E_V4SImode))
            return -1;
          if (
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1322; /* neon_negv4si2 */
          if (!
#line 280 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3301; /* mve_vnegq_sv4si */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !s_register_operand (operands[1], E_V2SFmode)
              || !
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1323; /* neon_negv2sf2 */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !s_register_operand (operands[1], E_V4SFmode))
            return -1;
          if (
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1324; /* neon_negv4sf2 */
          if (!
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3278; /* mve_vnegq_fv4sf */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !s_register_operand (operands[1], E_V8HFmode))
            return -1;
          if (
#line 822 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return 1326; /* neon_negv8hf2 */
          if (!
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3276; /* mve_vnegq_fv8hf */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !s_register_operand (operands[1], E_V4HFmode)
              || !
#line 822 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1328; /* neon_negv4hf2 */

        default:
          return -1;
        }

    case ABS:
      if (pnum_clobbers == NULL
          || pattern244 (x3, 
E_SImode) != 0)
        return -1;
      if (
#line 5319 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
        {
          *pnum_clobbers = 1;
          return 172; /* *arm_neg_abssi2 */
        }
      if (
#line 349 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        {
          *pnum_clobbers = 1;
          return 958; /* *thumb1_neg_abssi2 */
        }
      if (!
#line 170 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      *pnum_clobbers = 1;
      return 1012; /* *thumb2_neg_abssi2 */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_296 (x1, insn, pnum_clobbers);

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (pattern281 (x3, 
E_HFmode) != 0
              || !
#line 1143 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 808; /* *negmulhf3_vfp */

        case E_SFmode:
          if (pattern281 (x3, 
E_SFmode) != 0
              || !
#line 1163 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 810; /* *negmulsf3_vfp */

        case E_DFmode:
          if (pattern281 (x3, 
E_DFmode) != 0
              || !
#line 1184 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 812; /* *negmuldf3_vfp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_313 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[3] = x4;
      if (!shift_operator (operands[3], E_SImode)
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!shift_amount_operand (operands[2], E_SImode)
          || !
#line 4797 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 154; /* *not_shiftsi */

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          if (s_register_operand (operands[0], E_SImode)
              && s_register_operand (operands[1], E_SImode)
              && 
#line 5402 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return 173; /* *arm_one_cmplsi2 */
          if (register_operand (operands[0], E_SImode)
              && register_operand (operands[1], E_SImode)
              && 
#line 363 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return 959; /* *thumb1_one_cmplsi2 */
          if (pnum_clobbers == NULL
              || !low_register_operand (operands[0], E_SImode)
              || !low_register_operand (operands[1], E_SImode)
              || !
#line 1512 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1066; /* *thumb2_one_cmplsi2_short */

        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_V8QImode)
              || !
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1298; /* one_cmplv8qi2_neon */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !s_register_operand (operands[1], E_V16QImode))
            return -1;
          if (
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1299; /* one_cmplv16qi2_neon */
          if (!
#line 294 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3302; /* mve_vmvnq_uv16qi */

        case E_V4HImode:
          if (!s_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_V4HImode)
              || !
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1300; /* one_cmplv4hi2_neon */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !s_register_operand (operands[1], E_V8HImode))
            return -1;
          if (
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1301; /* one_cmplv8hi2_neon */
          if (!
#line 294 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3303; /* mve_vmvnq_uv8hi */

        case E_V2SImode:
          if (!s_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_V2SImode)
              || !
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1302; /* one_cmplv2si2_neon */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !s_register_operand (operands[1], E_V4SImode))
            return -1;
          if (
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1303; /* one_cmplv4si2_neon */
          if (!
#line 294 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3304; /* mve_vmvnq_uv4si */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !s_register_operand (operands[1], E_V4HFmode)
              || !
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1304; /* one_cmplv4hf2_neon */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode
              || !s_register_operand (operands[1], E_V8HFmode)
              || !
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1305; /* one_cmplv8hf2_neon */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !s_register_operand (operands[1], E_V2SFmode)
              || !
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1306; /* one_cmplv2sf2_neon */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !s_register_operand (operands[1], E_V4SFmode)
              || !
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1307; /* one_cmplv4sf2_neon */

        case E_V2DImode:
          if (!s_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !s_register_operand (operands[1], E_V2DImode)
              || !
#line 792 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1308; /* one_cmplv2di2_neon */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x4;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!cc_register (operands[2], E_VOIDmode))
        return -1;
      if (s_register_operand (operands[0], E_SImode))
        {
          if (arm_comparison_operator (operands[1], E_SImode)
              && 
#line 8138 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 282; /* *mov_notscc */
          if (arm_comparison_operator_mode (operands[1], E_SImode)
              && 
#line 396 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !arm_restrict_it))
            return 1021; /* *thumb2_mov_notscc */
        }
      if (!low_register_operand (operands[0], E_SImode)
          || !arm_comparison_operator_mode (operands[1], E_SImode)
          || !
#line 416 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it))
        return -1;
      return 1022; /* *thumb2_mov_notscc_strict_it */

    case SIGN_EXTRACT:
      if (pnum_clobbers == NULL
          || pattern267 (x3, 
1) != 0)
        return -1;
      x7 = XEXP (x4, 2);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 11857 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
        return -1;
      *pnum_clobbers = 1;
      return 383; /* *not_signextract_onebit */

    default:
      return -1;
    }
}

 int
recog_319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern2 (x1))
    {
    case 0:
      if (!
#line 4360 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
        return -1;
      return 129; /* arm_qsub_insn */

    case 1:
      if (register_operand (operands[0], E_V8QImode)
          && register_operand (operands[1], E_V8QImode)
          && register_operand (operands[2], E_V8QImode)
          && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 564; /* sssubv8qi3 */
      if (!s_register_operand (operands[0], E_V8QImode)
          || !s_register_operand (operands[1], E_V8QImode)
          || !s_register_operand (operands[2], E_V8QImode)
          || !
#line 1447 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1462; /* *ss_subv8qi_neon */

    case 2:
      if (register_operand (operands[0], E_V4HImode)
          && register_operand (operands[1], E_V4HImode)
          && register_operand (operands[2], E_V4HImode)
          && 
#line 431 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 565; /* sssubv4hi3 */
      if (!s_register_operand (operands[0], E_V4HImode)
          || !s_register_operand (operands[1], E_V4HImode)
          || !s_register_operand (operands[2], E_V4HImode)
          || !
#line 1447 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1463; /* *ss_subv4hi_neon */

    case 3:
      if (register_operand (operands[0], E_V2SImode)
          && register_operand (operands[1], E_V2SImode)
          && register_operand (operands[2], E_V2SImode)
          && 
#line 441 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 566; /* sssubv2si3 */
      if (!s_register_operand (operands[0], E_V2SImode)
          || !s_register_operand (operands[1], E_V2SImode)
          || !s_register_operand (operands[2], E_V2SImode)
          || !
#line 1447 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1464; /* *ss_subv2si_neon */

    case 4:
      if (!
#line 1447 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1465; /* *ss_subv2sf_neon */

    case 5:
      if (!
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3231; /* *arm_sssubv4qq3 */

    case 6:
      if (!
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3232; /* *arm_sssubv2hq3 */

    case 7:
      if (!
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3233; /* *arm_sssubqq3 */

    case 8:
      if (!
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3234; /* *arm_sssubhq3 */

    case 9:
      if (!
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3235; /* *arm_sssubv2ha3 */

    case 10:
      if (!
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0))
        return -1;
      return 3236; /* *arm_sssubha3 */

    case 11:
      if (!
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 3237; /* *arm_sssubsq3 */

    case 12:
      if (!
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 3238; /* *arm_sssubsa3 */

    default:
      return -1;
    }
}

 int
recog_325 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FIX:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      switch (GET_MODE (x4))
        {
        case E_SFmode:
          if (!s_register_operand (operands[1], E_SFmode)
              || !
#line 1531 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 845; /* fixuns_truncsfsi2 */

        case E_DFmode:
          if (!s_register_operand (operands[1], E_DFmode)
              || !
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 846; /* fixuns_truncdfsi2 */

        default:
          return -1;
        }

    case UNSPEC:
      switch (pattern252 (x3))
        {
        case 0:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 906; /* lceilusfsi2 */

        case 1:
          if (!(
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 912; /* lceiludfsi2 */

        case 2:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 907; /* lfloorusfsi2 */

        case 3:
          if (!(
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 913; /* lfloorudfsi2 */

        case 4:
          if (!
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 ))
            return -1;
          return 908; /* lroundusfsi2 */

        case 5:
          if (!(
#line 2053 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
            return -1;
          return 914; /* lroundudfsi2 */

        case 6:
          if (!
#line 717 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1234; /* neon_vcvtpuv2sfv2si */

        case 7:
          if (!
#line 717 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1240; /* neon_vcvtpuv4sfv4si */

        case 8:
          if (!
#line 717 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1235; /* neon_vcvtmuv2sfv2si */

        case 9:
          if (!
#line 717 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1241; /* neon_vcvtmuv4sfv4si */

        case 10:
          if (!
#line 717 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1236; /* neon_vcvtauv2sfv2si */

        case 11:
          if (!
#line 717 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_VFP5))
            return -1;
          return 1242; /* neon_vcvtauv4sfv4si */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern253 (x3))
        {
        case 0:
          if (!
#line 3720 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2110; /* fixuns_truncv2sfv2si2 */

        case 1:
          if (!
#line 3720 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2111; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  switch (XINT (x5, 1))
    {
    case 47:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6498; /* *p arm_qadd8 */

    case 48:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6499; /* *p arm_qsub8 */

    case 49:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6500; /* *p arm_shadd8 */

    case 50:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6501; /* *p arm_shsub8 */

    case 51:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6502; /* *p arm_uhadd8 */

    case 52:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6503; /* *p arm_uhsub8 */

    case 53:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6504; /* *p arm_uqadd8 */

    case 54:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6505; /* *p arm_uqsub8 */

    case 55:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6506; /* *p arm_qadd16 */

    case 56:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6507; /* *p arm_qasx */

    case 57:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6508; /* *p arm_qsax */

    case 58:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6509; /* *p arm_qsub16 */

    case 59:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6510; /* *p arm_shadd16 */

    case 60:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6511; /* *p arm_shasx */

    case 61:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6512; /* *p arm_shsax */

    case 62:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6513; /* *p arm_shsub16 */

    case 63:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6514; /* *p arm_uhadd16 */

    case 64:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6515; /* *p arm_uhasx */

    case 65:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6516; /* *p arm_uhsax */

    case 66:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6517; /* *p arm_uhsub16 */

    case 67:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6518; /* *p arm_uqadd16 */

    case 68:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6519; /* *p arm_uqasx */

    case 69:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6520; /* *p arm_uqsax */

    case 70:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6521; /* *p arm_uqsub16 */

    case 71:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6522; /* *p arm_smusd */

    case 72:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6523; /* *p arm_smusdx */

    case 43:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6524; /* *p arm_sxtab16 */

    case 44:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6525; /* *p arm_uxtab16 */

    case 73:
      if (pattern517 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
        return -1;
      return 6526; /* *p arm_usad8 */

    case 98:
      if (pattern517 (x5) != 0)
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6552; /* *p arm_smuad_insn */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6553; /* *p arm_smuad_setq_insn */

    case 99:
      if (pattern517 (x5) != 0)
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6554; /* *p arm_smuadx_insn */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6139 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6555; /* *p arm_smuadx_setq_insn */

    case 100:
      if (GET_MODE (x5) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || !s_register_operand (operands[1], E_SImode)
          || !ssat16_imm (operands[2], E_SImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6556; /* *p arm_ssat16_insn */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6557; /* *p arm_ssat16_setq_insn */

    case 101:
      if (GET_MODE (x5) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || !s_register_operand (operands[1], E_SImode)
          || !usat16_imm (operands[2], E_SImode))
        return -1;
      if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return 6558; /* *p arm_usat16_insn */
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6166 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
        return -1;
      return 6559; /* *p arm_usat16_setq_insn */

    case 13:
      if (pattern518 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 528 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6708; /* *p iwmmxt_wmacsz */

    case 14:
      if (pattern518 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 549 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6710; /* *p iwmmxt_wmacuz */

    case 6:
      if (GET_MODE (x5) != E_V4HImode
          || !register_operand (operands[0], E_V4HImode)
          || !register_operand (operands[1], E_V4HImode)
          || !immediate_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6727; /* *p iwmmxt_wshufh */

    case 10:
      if (GET_MODE (x5) != E_V2SImode
          || !register_operand (operands[0], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!register_operand (operands[1], E_V8QImode)
              || !register_operand (operands[2], E_V8QImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1750 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6819; /* *p iwmmxt_wsadbz */

        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !register_operand (operands[2], E_V4HImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1760 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6820; /* *p iwmmxt_wsadhz */

        default:
          return -1;
        }

    case 113:
      if (pattern519 (x5, 
E_V4HImode) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 371 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6844; /* *p iwmmxt_wqmulm */

    case 112:
      if (pattern519 (x5, 
E_V2SImode) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 381 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6845; /* *p iwmmxt_wqmulwm */

    case 111:
      if (pattern519 (x5, 
E_V4HImode) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 391 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6846; /* *p iwmmxt_wqmulmr */

    case 110:
      if (pattern519 (x5, 
E_V2SImode) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 401 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6847; /* *p iwmmxt_wqmulwmr */

    case 1069:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4274 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7055; /* *p mve_uqrshll_sat64_di */

    case 1070:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4274 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7056; /* *p mve_uqrshll_sat48_di */

    case 1071:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4286 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7057; /* *p mve_sqrshrl_sat64_di */

    case 1072:
      if (pattern520 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4286 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7058; /* *p mve_sqrshrl_sat48_di */

    case 1068:
      if (pattern521 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7059; /* *p mve_uqrshl_si */

    case 1067:
      if (pattern521 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4310 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7060; /* *p mve_sqrshr_si */

    case 1066:
      if (pattern522 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7062; /* *p mve_urshrl_di */

    case 1065:
      if (pattern523 (x5, 
E_SImode) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4356 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7064; /* *p mve_urshr_si */

    case 1064:
      if (pattern523 (x5, 
E_DImode) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7066; /* *p mve_srshr_si */

    case 1063:
      if (pattern522 (x5) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4391 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 7067; /* *p mve_srshrl_di */

    default:
      return -1;
    }
}

 int
recog_345 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case SS_TRUNCATE:
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != SS_TRUNCATE)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      switch (pattern492 (x6))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 946 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6749; /* *p iwmmxt_wpackhss */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 957 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6750; /* *p iwmmxt_wpackwss */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 968 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6751; /* *p iwmmxt_wpackdss */

        default:
          return -1;
        }

    case US_TRUNCATE:
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[1] = x9;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != US_TRUNCATE)
            return -1;
          switch (pattern492 (x6))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 979 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6752; /* *p iwmmxt_wpackhus */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 990 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6753; /* *p iwmmxt_wpackwus */

            case 2:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6754; /* *p iwmmxt_wpackdus */

            default:
              return -1;
            }

        case SS_PLUS:
          if (GET_MODE (x9) != E_V4HImode)
            return -1;
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ZERO_EXTEND
              || GET_MODE (x10) != E_V4HImode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != VEC_SELECT
              || GET_MODE (x11) != E_V4QImode)
            return -1;
          x12 = XEXP (x11, 1);
          if (GET_CODE (x12) != PARALLEL
              || XVECLEN (x12, 0) != 4)
            return -1;
          x13 = XVECEXP (x12, 0, 0);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x14 = XVECEXP (x12, 0, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x15 = XVECEXP (x12, 0, 2);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x16 = XVECEXP (x12, 0, 3);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != CONST_VECTOR
              || XVECLEN (x8, 0) != 4
              || GET_MODE (x8) != E_V4QImode)
            return -1;
          x17 = XVECEXP (x8, 0, 0);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x18 = XVECEXP (x8, 0, 1);
          if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x19 = XVECEXP (x8, 0, 2);
          if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x20 = XVECEXP (x8, 0, 3);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_V8QImode)
              || GET_MODE (x6) != E_V8QImode
              || GET_MODE (x7) != E_V4QImode)
            return -1;
          x21 = XEXP (x9, 0);
          operands[1] = x21;
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          x22 = XEXP (x11, 0);
          operands[2] = x22;
          if (!register_operand (operands[2], E_V8QImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 433 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6849; /* *p iwmmxt_waddbhusl */

        default:
          return -1;
        }

    case CONST_VECTOR:
      if (XVECLEN (x7, 0) != 4
          || GET_MODE (x7) != E_V4QImode)
        return -1;
      x23 = XVECEXP (x7, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x24 = XVECEXP (x7, 0, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x25 = XVECEXP (x7, 0, 2);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x26 = XVECEXP (x7, 0, 3);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != US_TRUNCATE
          || GET_MODE (x8) != E_V4QImode)
        return -1;
      x27 = XEXP (x8, 0);
      if (GET_CODE (x27) != SS_PLUS
          || GET_MODE (x27) != E_V4HImode)
        return -1;
      x28 = XEXP (x27, 1);
      if (pattern600 (x28, 
E_V4QImode, 
E_V4HImode, 
ZERO_EXTEND) != 0)
        return -1;
      x29 = XEXP (x28, 0);
      x30 = XEXP (x29, 1);
      if (GET_CODE (x30) != PARALLEL
          || XVECLEN (x30, 0) != 4)
        return -1;
      x31 = XVECEXP (x30, 0, 0);
      if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x32 = XVECEXP (x30, 0, 1);
      if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x33 = XVECEXP (x30, 0, 2);
      if (x33 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x34 = XVECEXP (x30, 0, 3);
      if (x34 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || !register_operand (operands[0], E_V8QImode)
          || GET_MODE (x6) != E_V8QImode)
        return -1;
      x35 = XEXP (x27, 0);
      operands[1] = x35;
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      x36 = XEXP (x29, 0);
      operands[2] = x36;
      if (!register_operand (operands[2], E_V8QImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 417 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6848; /* *p iwmmxt_waddbhusm */

    default:
      return -1;
    }
}

 int
recog_349 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          switch (pattern377 (x4))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3023 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6438; /* *p *arm_andsi3_insn */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 83 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6672; /* *p iwmmxt_anddi3 */

            case 2:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6677; /* *p *andv2si3_iwmmxt */

            case 3:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6678; /* *p *andv4hi3_iwmmxt */

            case 4:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 308 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6679; /* *p *andv8qi3_iwmmxt */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x8) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_DImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 94 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6673; /* *p iwmmxt_nanddi3 */

        default:
          return -1;
        }

    case NOT:
      switch (pattern374 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3605 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6446; /* *p andsi_notsi_si */

        case 1:
          x10 = XEXP (x5, 0);
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!shift_amount_operand (operands[3], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3617 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6447; /* *p andsi_not_shiftsi_si */

        default:
          return -1;
        }

    case IOR:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != NOT
          || GET_MODE (x8) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[1] = x10;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[2] = x13;
      if (!arm_rhs_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!arm_rhs_operand (operands[3], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3910 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6452; /* *p *andsi_iorsi3_notsi */

    case MULT:
      if (pattern375 (x1) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9686 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6583; /* *p *and_multsi */

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x5;
      if (pattern407 (x1) != 0
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9700 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT)))
        return -1;
      return 6588; /* *p *and_shiftsi */

    default:
      return -1;
    }
}

 int
recog_363 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[5] = x6;
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  x8 = XVECEXP (x2, 0, 0);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XEXP (x3, 0);
  operands[3] = x12;
  x13 = XEXP (x5, 1);
  operands[4] = x13;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x14 = XEXP (x5, 0);
  if (!rtx_equal_p (x14, operands[1])
      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12723 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && ((INTVAL (operands[2]) + 4) == INTVAL (operands[4]))
     && (operands_ok_ldrd_strd (operands[0], operands[3],
                                  operands[1], INTVAL (operands[2]),
                                  false, true)))))
    return -1;
  return 6610; /* *p *thumb2_ldrd */
}

 int
recog_369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x3, 1);
      switch (GET_CODE (x4))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          res = recog_360 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x4) != MULT
              || GET_MODE (x4) != E_SImode
              || pattern442 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!low_register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!low_register_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1429 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size && reload_completed)))
            return -1;
          return 6989; /* *p *thumb2_mulsi_short */

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (s_register_operand (operands[0], E_SImode))
            {
              res = recog_362 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (!low_register_operand (operands[0], E_SImode)
              || pattern442 (x1) != 0
              || GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_CODE (x4))
            {
            case PLUS:
              if (!low_reg_or_int_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6987; /* *p *thumb2_addsi_short */

            case MINUS:
              if (!low_register_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6988; /* *p *thumb2_subsi_short */

            default:
              return -1;
            }

        case TRUNCATE:
          if (pattern381 (x4, 
E_DImode, 
MULT, 
LSHIFTRT, 
E_SImode) != 0)
            return -1;
          x7 = XEXP (x4, 0);
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x11 = XEXP (x5, 0);
          operands[5] = x11;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          x13 = XEXP (x12, 0);
          if (GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x12, 1);
          if (GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x10, 0);
          operands[3] = x15;
          if (!scratch_operand (operands[3], E_SImode))
            return -1;
          switch (GET_CODE (x13))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x14) != SIGN_EXTEND)
                return -1;
              x16 = XEXP (x13, 0);
              operands[1] = x16;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[2] = x17;
              if (!s_register_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2515 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6419; /* *p *smull_high */

            case ZERO_EXTEND:
              if (GET_CODE (x14) != ZERO_EXTEND)
                return -1;
              x16 = XEXP (x13, 0);
              operands[1] = x16;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              x17 = XEXP (x14, 0);
              operands[2] = x17;
              if (!s_register_operand (operands[2], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2515 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6420; /* *p *umull_high */

            default:
              return -1;
            }

        case COMPARE:
          if (pattern381 (x4, 
E_SImode, 
NOT, 
AND, 
E_CC_NZmode) != 0)
            return -1;
          x7 = XEXP (x4, 0);
          x12 = XEXP (x7, 0);
          x13 = XEXP (x12, 0);
          if (!shift_operator (x13, E_SImode))
            return -1;
          operands[0] = x13;
          x8 = XEXP (x4, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 100
              || GET_MODE (x6) != E_CC_NZmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[5] = x5;
          x11 = XEXP (x5, 0);
          operands[6] = x11;
          x16 = XEXP (x13, 0);
          operands[1] = x16;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x18 = XEXP (x13, 1);
          operands[2] = x18;
          if (!shift_amount_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[3] = x9;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          switch (GET_CODE (x10))
            {
            case CLOBBER:
              x15 = XEXP (x10, 0);
              operands[4] = x15;
              if (!scratch_operand (operands[4], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3637 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6448; /* *p andsi_not_shiftsi_si_scc_no_reuse */

            case SET:
              x19 = XEXP (x10, 1);
              if (pattern382 (x19, 
NOT, 
AND, 
E_SImode) != 0)
                return -1;
              x20 = XEXP (x19, 0);
              x21 = XEXP (x20, 0);
              switch (GET_CODE (x21))
                {
                case MULT:
                case ASHIFT:
                case ROTATE:
                case ASHIFTRT:
                case LSHIFTRT:
                case ROTATERT:
                  if (!rtx_equal_p (x21, operands[0]))
                    return -1;
                  x15 = XEXP (x10, 0);
                  operands[4] = x15;
                  if (!s_register_operand (operands[4], E_SImode))
                    return -1;
                  x22 = XEXP (x19, 1);
                  if (!rtx_equal_p (x22, operands[3])
                      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3661 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                    return -1;
                  return 6449; /* *p andsi_not_shiftsi_si_scc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ABS:
          if (GET_MODE (x4) != E_SImode
              || pattern363 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5255 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM)))
            return 6480; /* *p *arm_abssi2 */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 117 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2)))
            return -1;
          return 6974; /* *p *thumb2_abssi2 */

        case NEG:
          if (GET_MODE (x4) != E_SImode
              || pattern414 (x1) != 0)
            return -1;
          x7 = XEXP (x4, 0);
          switch (GET_CODE (x7))
            {
            case ABS:
              if (GET_MODE (x7) != E_SImode
                  || !s_register_operand (operands[0], E_SImode))
                return -1;
              x12 = XEXP (x7, 0);
              operands[1] = x12;
              if (!s_register_operand (operands[1], E_SImode))
                return -1;
              if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5319 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM)))
                return 6481; /* *p *arm_neg_abssi2 */
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 170 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2)))
                return -1;
              return 6975; /* *p *thumb2_neg_abssi2 */

            case REG:
              operands[1] = x7;
              if (!low_register_operand (operands[1], E_SImode)
                  || !low_register_operand (operands[0], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1523 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6991; /* *p *thumb2_negsi2_short */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 2)
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x10) != SET)
            return -1;
          x19 = XEXP (x10, 1);
          if (GET_CODE (x19) != UNSPEC
              || XVECLEN (x19, 0) != 1
              || XINT (x19, 1) != 29
              || GET_MODE (x19) != E_CCmode)
            return -1;
          x23 = XVECEXP (x19, 0, 0);
          if (GET_CODE (x23) != REG
              || REGNO (x23) != 105
              || GET_MODE (x23) != E_CCmode)
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != REG
              || REGNO (x15) != 105
              || GET_MODE (x15) != E_CCmode)
            return -1;
          x5 = XEXP (x1, 0);
          operands[3] = x5;
          x11 = XEXP (x5, 0);
          operands[4] = x11;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode)
            return -1;
          x24 = XVECEXP (x4, 0, 0);
          operands[1] = x24;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x25 = XVECEXP (x4, 0, 1);
          operands[2] = x25;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 82:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6532; /* *p arm_sadd8 */

            case 83:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6533; /* *p arm_ssub8 */

            case 84:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6534; /* *p arm_uadd8 */

            case 85:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6535; /* *p arm_usub8 */

            case 86:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6536; /* *p arm_sadd16 */

            case 87:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6537; /* *p arm_sasx */

            case 88:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6538; /* *p arm_ssax */

            case 89:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6539; /* *p arm_ssub16 */

            case 90:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6540; /* *p arm_uadd16 */

            case 91:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6541; /* *p arm_uasx */

            case 92:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6542; /* *p arm_usax */

            case 93:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
                return -1;
              return 6543; /* *p arm_usub16 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          switch (GET_CODE (x4))
            {
            case MEM:
              res = recog_364 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case REG:
            case SUBREG:
              res = recog_367 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode))
            {
              res = recog_368 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[0] = x4;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x10 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x10) != SET)
            return -1;
          x5 = XEXP (x1, 0);
          operands[4] = x5;
          x11 = XEXP (x5, 0);
          operands[5] = x11;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (!memory_operand (operands[2], E_SImode))
            return -1;
          x15 = XEXP (x10, 0);
          operands[3] = x15;
          if (!memory_operand (operands[3], E_SImode))
            return -1;
          x19 = XEXP (x10, 1);
          operands[1] = x19;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM && reload_completed
  && valid_operands_ldrd_strd (operands, false))))
            return -1;
          return 6617; /* *p *arm_strd */

        case CONST_INT:
          operands[1] = x4;
          if (pattern414 (x1) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!low_register_operand (operands[0], E_QImode)
                  || !const_int_operand (operands[1], E_QImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6984; /* *p *thumb2_movqi_shortim */

            case E_HImode:
              if (!low_register_operand (operands[0], E_HImode)
                  || !const_int_operand (operands[1], E_HImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6985; /* *p *thumb2_movhi_shortim */

            case E_SImode:
              if (!low_register_operand (operands[0], E_SImode)
                  || !const_int_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
                return -1;
              return 6986; /* *p *thumb2_movsi_shortim */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x4) != E_SImode
              || pattern363 (x1) != 0)
            return -1;
          x6 = XEXP (x3, 0);
          operands[0] = x6;
          if (!low_register_operand (operands[0], E_SImode))
            return -1;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!low_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1512 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed)))
            return -1;
          return 6990; /* *p *thumb2_one_cmplsi2_short */

        default:
          return -1;
        }

    case RETURN:
      x10 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x10) != SET)
        return -1;
      x19 = XEXP (x10, 1);
      if (pattern382 (x19, 
POST_INC, 
MEM, 
E_SImode) != 0)
        return -1;
      x15 = XEXP (x10, 0);
      if (GET_CODE (x15) != REG
          || REGNO (x15) != 15
          || GET_MODE (x15) != E_SImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[1] = x5;
      x11 = XEXP (x5, 0);
      operands[2] = x11;
      x20 = XEXP (x19, 0);
      x21 = XEXP (x20, 0);
      operands[0] = x21;
      if (!s_register_operand (operands[0], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12016 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
        return -1;
      return 6594; /* *p *ldr_with_return */

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 54
          || GET_MODE (x3) != E_SImode)
        return -1;
      x26 = XVECEXP (x3, 0, 0);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x2, 0, 1);
      if (pattern474 (x10) != 0)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1699 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse)))
        return -1;
      return 6994; /* *p *clear_apsr */

    default:
      return -1;
    }
}

 rtx_insn *
peephole2_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!arm_general_register_operand (operands[1], E_SImode))
    return NULL;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!memory_operand (operands[3], E_SImode))
    return NULL;
  x5 = PATTERN (peep2_next_insn (2));
  switch (GET_CODE (x5))
    {
    case SET:
      x6 = XEXP (x5, 1);
      if (!commutative_binary_operator (x6, E_SImode))
        return NULL;
      operands[5] = x6;
      x7 = XEXP (x5, 0);
      operands[4] = x7;
      if (!arm_general_register_operand (operands[4], E_SImode))
        return NULL;
      x8 = XEXP (x6, 0);
      operands[6] = x8;
      if (!arm_general_register_operand (operands[6], E_VOIDmode))
        return NULL;
      x9 = XEXP (x6, 1);
      operands[7] = x9;
      if (!arm_general_register_operand (operands[7], E_VOIDmode)
          || !
#line 109 "../../gcc-15.0.1-20250313/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM
   && (  ((rtx_equal_p(operands[0], operands[6])) && (rtx_equal_p(operands[1], operands[7])))
	||((rtx_equal_p(operands[0], operands[7])) && (rtx_equal_p(operands[1], operands[6]))))
   && (peep2_reg_dead_p (3, operands[0]) || rtx_equal_p (operands[0], operands[4]))
   && (peep2_reg_dead_p (3, operands[1]) || rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_17 (insn, operands);

    case PARALLEL:
      if (pattern566 (x5) != 0
          || !arm_general_register_operand (operands[4], E_SImode))
        return NULL;
      x10 = XVECEXP (x5, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      operands[6] = x12;
      if (!arm_general_register_operand (operands[6], E_VOIDmode))
        return NULL;
      x13 = XEXP (x11, 1);
      operands[7] = x13;
      if (!arm_general_register_operand (operands[7], E_VOIDmode)
          || !
#line 134 "../../gcc-15.0.1-20250313/gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD && TARGET_ARM
   && (  ((rtx_equal_p(operands[0], operands[6])) && (rtx_equal_p(operands[1], operands[7])))
       ||((rtx_equal_p(operands[0], operands[7])) && (rtx_equal_p(operands[1], operands[6]))))
   && (peep2_reg_dead_p (3, operands[0]) || rtx_equal_p (operands[0], operands[4]))
   && (peep2_reg_dead_p (3, operands[1]) || rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_18 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 6)
    return NULL;
  if (peep2_current_count >= 7)
    {
      res = peephole2_12 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  x2 = XEXP (x1, 1);
  operands[6] = x2;
  x3 = PATTERN (peep2_next_insn (2));
  x4 = XEXP (x3, 0);
  if (!s_register_operand (x4, E_SImode))
    return NULL;
  x5 = XEXP (x3, 1);
  if (!const_int_operand (x5, E_SImode))
    return NULL;
  x6 = PATTERN (peep2_next_insn (3));
  x7 = XEXP (x6, 0);
  if (!memory_operand (x7, E_SImode))
    return NULL;
  x8 = PATTERN (peep2_next_insn (4));
  if (GET_CODE (x8) != SET)
    return NULL;
  x9 = PATTERN (peep2_next_insn (5));
  if (GET_CODE (x9) != SET)
    return NULL;
  x10 = XEXP (x9, 0);
  operands[5] = x10;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x11 = PATTERN (peep2_next_insn (1));
  x12 = XEXP (x11, 1);
  switch (GET_CODE (x12))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x12, operands[0]))
        return NULL;
      x13 = XEXP (x11, 0);
      operands[3] = x13;
      if (!memory_operand (operands[3], E_SImode))
        return NULL;
      operands[1] = x4;
      operands[7] = x5;
      operands[4] = x7;
      x14 = XEXP (x6, 1);
      if (!rtx_equal_p (x14, operands[1]))
        return NULL;
      x15 = XEXP (x8, 0);
      operands[2] = x15;
      if (!s_register_operand (operands[2], E_SImode))
        return NULL;
      x16 = XEXP (x8, 1);
      operands[8] = x16;
      if (!const_int_operand (operands[8], E_SImode))
        return NULL;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[2]))
        return NULL;
      *pmatch_len_ = 5;
      return gen_peephole2_26 (insn, operands);

    case CONST_INT:
      operands[7] = x12;
      if (!const_int_operand (operands[7], E_SImode))
        return NULL;
      x13 = XEXP (x11, 0);
      operands[1] = x13;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      operands[2] = x4;
      operands[8] = x5;
      operands[3] = x7;
      x14 = XEXP (x6, 1);
      if (!rtx_equal_p (x14, operands[0]))
        return NULL;
      x15 = XEXP (x8, 0);
      operands[4] = x15;
      if (!memory_operand (operands[4], E_SImode))
        return NULL;
      x16 = XEXP (x8, 1);
      if (!rtx_equal_p (x16, operands[1]))
        return NULL;
      x17 = XEXP (x9, 1);
      if (!rtx_equal_p (x17, operands[2]))
        return NULL;
      *pmatch_len_ = 5;
      return gen_peephole2_27 (insn, operands);

    default:
      return NULL;
    }
}
