/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (GET_MODE (x3) != E_V8QImode)
        return -1;
      return 0;

    case E_V4HImode:
      if (GET_MODE (x3) != E_V4HImode)
        return -1;
      return 1;

    case E_V2SImode:
      if (GET_MODE (x3) != E_V2SImode)
        return -1;
      return 2;

    case E_V2SFmode:
      if (pattern1 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 3;

    case E_V4UQQmode:
      if (pattern1 (x3, 
E_V4UQQmode) != 0)
        return -1;
      return 4;

    case E_V2UHQmode:
      if (pattern1 (x3, 
E_V2UHQmode) != 0)
        return -1;
      return 5;

    case E_UQQmode:
      if (pattern1 (x3, 
E_UQQmode) != 0)
        return -1;
      return 6;

    case E_UHQmode:
      if (pattern1 (x3, 
E_UHQmode) != 0)
        return -1;
      return 7;

    case E_V2UHAmode:
      if (pattern1 (x3, 
E_V2UHAmode) != 0)
        return -1;
      return 8;

    case E_UHAmode:
      if (pattern1 (x3, 
E_UHAmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 19)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return pattern21 (x1); /* [-1, 3] */
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern35 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern34 (x3, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern34 (x3, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern34 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern45 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern52 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern51 (x3, 
i1, 
i2, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern51 (x3, 
i3, 
i4, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      return pattern49 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8BImode:
      if (pattern49 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4BImode:
      if (pattern49 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern72 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern72 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern72 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !vpr_register_operand (operands[3], E_V8BImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern110 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != i1
          || GET_MODE (x4) != E_V16QImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != XOR
          || GET_MODE (x5) != E_V16QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern123 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern132 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern141 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern38 (x3, 
i1, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern38 (x3, 
i2, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern148 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (GET_MODE (x3) != E_V8HFmode)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern148 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 5;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  return 0;
}

int
pattern166 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !mve_imm_16 (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern171 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern166 (x3, 
E_V8HFmode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern167 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!arm_low_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!arm_low_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[2], E_V16QImode)
          || !s_register_operand (operands[3], E_V16QImode)
          || !vpr_register_operand (operands[4], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode)
          || !vpr_register_operand (operands[4], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern220 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode)
          || !vpr_register_operand (operands[4], E_V4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern237 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i2))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern245 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !const_neon_scalar_shift_amount_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!const_int_M_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 2);
  operands[2] = x4;
  if (!const_int_M_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[2] = x8;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern261 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!arm_add_operand (operands[3], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_CC_Zmode:
          return pattern259 (x1, 
E_CC_Zmode); /* [-1, 1] */

        case E_SImode:
          res = pattern259 (x1, 
E_SImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case MEM:
      operands[2] = x3;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_CC_Zmode:
          res = pattern260 (x1, 
E_CC_Zmode);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_SImode:
          res = pattern260 (x1, 
E_SImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern275 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!power_of_two_operand (operands[3], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return pattern278 (x1); /* [-1, 9] */

    case ABS:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ABS)
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          if (pattern279 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          return 10;

        case E_V4SImode:
          if (pattern279 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          return 11;

        case E_V8HImode:
          if (pattern279 (x1, 
E_V8HFmode, 
E_V8HImode) != 0)
            return -1;
          return 12;

        case E_V4HImode:
          if (pattern279 (x1, 
E_V4HFmode, 
E_V4HImode) != 0)
            return -1;
          return 13;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern294 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[3] = x4;
      if (!arm_comparison_operator (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      if (!arm_comparison_operator (x5, E_SImode))
        return -1;
      operands[6] = x5;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 100
          || GET_MODE (x7) != E_CCmode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || pattern290 (x3) != 0)
        return -1;
      return 0;

    case MEM:
      res = pattern293 (x1, pnum_clobbers);
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern307 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern311 (x6, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern311 (x6, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern311 (x6, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V4UQQmode:
      if (pattern310 (x6, 
E_V4UQQmode) != 0)
        return -1;
      return 3;

    case E_V2UHQmode:
      if (pattern310 (x6, 
E_V2UHQmode) != 0)
        return -1;
      return 4;

    case E_UQQmode:
      if (pattern310 (x6, 
E_UQQmode) != 0)
        return -1;
      return 5;

    case E_UHQmode:
      if (pattern310 (x6, 
E_UHQmode) != 0)
        return -1;
      return 6;

    case E_V2UHAmode:
      if (pattern310 (x6, 
E_V2UHAmode) != 0)
        return -1;
      return 7;

    case E_UHAmode:
      if (pattern310 (x6, 
E_UHAmode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern330 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  operands[3] = x7;
  if (!mve_imm_selective_upto_8 (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x2, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[4] = x9;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  return pattern329 (x5); /* [-1, 2] */
}

int
pattern344 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern353 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern352 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern352 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern352 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern361 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != ASHIFT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != ZERO_EXTEND
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (!subreg_lowpart_operator (x5, E_VOIDmode))
    return -1;
  operands[5] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x2, 1);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[4] = x9;
  if (!s_register_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern379 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x1, 0);
      operands[4] = x8;
      x9 = XEXP (x8, 0);
      operands[5] = x9;
      return 0;

    case MULT:
    case ASHIFT:
    case ASHIFTRT:
      if (!sat_shift_operator (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x1, 0);
      operands[6] = x8;
      x9 = XEXP (x8, 0);
      operands[7] = x9;
      x10 = XEXP (x5, 0);
      operands[4] = x10;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[5] = x11;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern397 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern404 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern411 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 2);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern418 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern426 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !s_register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !s_register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern437 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != SIGN_EXTEND
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern445 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!guard_addr_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!scratch_operand (operands[2], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern464 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode
      || !register_operand (operands[0], E_V4SFmode)
      || GET_MODE (x1) != E_V4SFmode
      || !register_operand (operands[1], E_V4SFmode)
      || !register_operand (operands[2], E_V8BFmode)
      || !register_operand (operands[3], E_V8BFmode))
    return -1;
  return 0;
}

int
pattern472 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern483 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !const_int_vcde3_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern492 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern491 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern491 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern491 (x1, 
E_DImode, 
E_SImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern499 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != 2147483648L)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CONST_INT
      || XWINT (x6, 0) != 2147483648L)
    return -1;
  x7 = XEXP (x2, 1);
  if (XWINT (x7, 0) != 32L
      || pattern498 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
    return -1;
  return 0;
}

int
pattern510 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern516 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !s_register_operand (operands[2], i2))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern515 (x4, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern528 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 14
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern534 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[3], E_V4BFmode))
        return -1;
      return 0;

    case E_V8BFmode:
      if (!register_operand (operands[3], E_V8BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern544 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern556 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern567 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern574 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MINUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern578 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern595 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT
      || XWINT (x5, 0) != 2147483648L)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CONST_INT
      || XWINT (x6, 0) != 2147483648L)
    return -1;
  x7 = XEXP (x2, 1);
  if (XWINT (x7, 0) != 32L
      || pattern594 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
    return -1;
  return 0;
}

int
pattern603 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 14
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x5, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x9, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern624 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern635 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern647 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern655 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MULT
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  switch (pattern548 (x6, 
MULT))
    {
    case 0:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      x9 = XEXP (x8, 0);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XEXP (x8, 1);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      if (
#line 2306 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6))
        return 59; /* *mulsi3_compare0 */
      if (!
#line 2320 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6 && optimize_size))
        return -1;
      return 60; /* *mulsi3_compare0_v6 */

    case 1:
      if (
#line 2333 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch6))
        return 61; /* *mulsi_compare0_scratch */
      if (!
#line 2346 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6 && optimize_size))
        return -1;
      return 62; /* *mulsi_compare0_scratch_v6 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER
          || pattern385 (x1) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      if (!arm_carry_operation (operands[3], E_SImode)
          || !
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 25; /* *addsi3_carryin_clobercc */

    case MULT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (!s_register_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[4] = x7;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x8 = XEXP (x5, 1);
          if (pattern386 (x8, 
LSHIFTRT, 
E_SImode, 
TRUNCATE, 
PLUS) != 0)
            return -1;
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != PLUS
              || GET_MODE (x11) != E_DImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != MULT
              || GET_MODE (x12) != E_DImode)
            return -1;
          x13 = XEXP (x11, 1);
          if (GET_CODE (x13) != ZERO_EXTEND
              || GET_MODE (x13) != E_DImode)
            return -1;
          x14 = XEXP (x10, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
            return -1;
          x15 = XEXP (x4, 1);
          operands[5] = x15;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          operands[1] = x6;
          x16 = XEXP (x5, 0);
          operands[2] = x16;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x17 = XEXP (x12, 0);
          if (GET_MODE (x17) != E_DImode)
            return -1;
          x18 = XEXP (x12, 1);
          if (GET_MODE (x18) != E_DImode)
            return -1;
          x19 = XEXP (x8, 1);
          operands[3] = x19;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x20 = XEXP (x13, 0);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          switch (GET_CODE (x17))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x18) != SIGN_EXTEND)
                return -1;
              x21 = XEXP (x17, 0);
              if (!rtx_equal_p (x21, operands[4]))
                return -1;
              x22 = XEXP (x18, 0);
              if (!rtx_equal_p (x22, operands[5])
                  || !
#line 2485 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 69; /* smlal */

            case ZERO_EXTEND:
              if (GET_CODE (x18) != ZERO_EXTEND)
                return -1;
              x21 = XEXP (x17, 0);
              if (!rtx_equal_p (x21, operands[4]))
                return -1;
              x22 = XEXP (x18, 0);
              if (!rtx_equal_p (x22, operands[5])
                  || !
#line 2485 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 70; /* umlal */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x15 = XEXP (x4, 1);
          if (GET_CODE (x15) != SIGN_EXTEND
              || GET_MODE (x15) != E_SImode
              || pattern549 (x5, 
E_CCmode, 
104, 
28) != 0)
            return -1;
          x23 = XEXP (x7, 0);
          operands[1] = x23;
          if (!s_register_operand (operands[1], E_HImode))
            return -1;
          x24 = XEXP (x15, 0);
          operands[2] = x24;
          if (!s_register_operand (operands[2], E_HImode))
            return -1;
          operands[3] = x6;
          if (!
#line 2618 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
            return -1;
          return 78; /* arm_smlabb_setq */

        case ASHIFTRT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x25 = XEXP (x7, 1);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || pattern549 (x5, 
E_CCmode, 
104, 
28) != 0)
            return -1;
          x23 = XEXP (x7, 0);
          operands[1] = x23;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x4, 1);
          if (GET_MODE (x15) != E_SImode)
            return -1;
          operands[3] = x6;
          switch (GET_CODE (x15))
            {
            case SIGN_EXTEND:
              x24 = XEXP (x15, 0);
              operands[2] = x24;
              if (!s_register_operand (operands[2], E_HImode)
                  || !
#line 2666 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 80; /* arm_smlatb_setq */

            case ASHIFTRT:
              x26 = XEXP (x15, 1);
              if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
                return -1;
              x24 = XEXP (x15, 0);
              operands[2] = x24;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 2716 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 82; /* arm_smlatt_setq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (pattern256 (x5) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 52 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 941; /* *thumb1_adddi3 */

    case MEM:
      switch (pattern293 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3145; /* atomic_add_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3150; /* atomic_add_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3155; /* atomic_add_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3160; /* atomic_add_fetchdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 100)
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case REG:
        case SUBREG:
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (GET_MODE (x5) != E_CCmode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != MINUS
          || GET_MODE (x8) != E_SImode
          || GET_MODE (x3) != E_CCmode)
        return -1;
      operands[1] = x4;
      if (!arm_rhs_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x6;
      if (!arm_rhs_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[1]))
        return -1;
      x11 = XEXP (x8, 1);
      if (!rtx_equal_p (x11, operands[2])
          || !
#line 2082 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 47; /* subsi3_compare */

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode
          || pattern287 (x1, 
CLOBBER, 
E_CC_NVmode, 
100) != 0
          || GET_MODE (x3) != E_CC_NVmode)
        return -1;
      x12 = XEXP (x4, 0);
      operands[1] = x12;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case PLUS:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x13 = XEXP (x6, 0);
          operands[3] = x13;
          if (!arm_borrow_operation (operands[3], E_DImode))
            return -1;
          x14 = XEXP (x6, 1);
          switch (GET_CODE (x14))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              operands[2] = x15;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 1763 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 33; /* cmpsi3_carryin_CC_NVout */

            case CONST_INT:
              operands[2] = x14;
              if (!arm_adcimm_operand (operands[2], E_DImode)
                  || !
#line 1780 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 35; /* cmpsi3_imm_carryin_CC_NVout */

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[2] = x6;
          if (!arm_borrow_operation (operands[2], E_DImode)
              || !
#line 1795 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 37; /* cmpsi3_0_carryin_CC_NVout */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 100
          || GET_MODE (x5) != E_CC_Bmode
          || GET_MODE (x3) != E_CC_Bmode)
        return -1;
      x12 = XEXP (x4, 0);
      operands[1] = x12;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case PLUS:
          if (GET_MODE (x6) != E_DImode)
            return -1;
          x13 = XEXP (x6, 0);
          if (!arm_borrow_operation (x13, E_DImode))
            return -1;
          x14 = XEXP (x6, 1);
          switch (GET_CODE (x14))
            {
            case ZERO_EXTEND:
              if (GET_MODE (x14) != E_DImode)
                return -1;
              x15 = XEXP (x14, 0);
              operands[2] = x15;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x7))
                {
                case CLOBBER:
                  operands[3] = x13;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!scratch_operand (operands[0], E_SImode)
                      || !
#line 1763 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 34; /* cmpsi3_carryin_CC_Bout */

                case SET:
                  x8 = XEXP (x7, 1);
                  if (pattern574 (x8) != 0)
                    return -1;
                  operands[4] = x13;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!s_register_operand (operands[0], E_SImode))
                    return -1;
                  x11 = XEXP (x8, 1);
                  x16 = XEXP (x11, 0);
                  operands[3] = x16;
                  if (!arm_borrow_operation (operands[3], E_SImode))
                    return -1;
                  x10 = XEXP (x8, 0);
                  if (!rtx_equal_p (x10, operands[1]))
                    return -1;
                  x17 = XEXP (x11, 1);
                  if (!rtx_equal_p (x17, operands[2])
                      || !
#line 2145 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 52; /* usubvsi3_borrow */

                default:
                  return -1;
                }

            case CONST_INT:
              x7 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x7))
                {
                case CLOBBER:
                  operands[3] = x13;
                  operands[2] = x14;
                  if (!arm_adcimm_operand (operands[2], E_DImode))
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!scratch_operand (operands[0], E_SImode)
                      || !
#line 1780 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 36; /* cmpsi3_imm_carryin_CC_Bout */

                case SET:
                  x8 = XEXP (x7, 1);
                  if (pattern574 (x8) != 0)
                    return -1;
                  operands[5] = x13;
                  operands[3] = x14;
                  if (!const_int_operand (operands[3], E_DImode))
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!s_register_operand (operands[0], E_SImode))
                    return -1;
                  x11 = XEXP (x8, 1);
                  x16 = XEXP (x11, 0);
                  operands[4] = x16;
                  if (!arm_borrow_operation (operands[4], E_SImode))
                    return -1;
                  x17 = XEXP (x11, 1);
                  operands[2] = x17;
                  if (!arm_adcimm_operand (operands[2], E_SImode))
                    return -1;
                  x10 = XEXP (x8, 0);
                  if (!rtx_equal_p (x10, operands[1])
                      || !
#line 2162 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (UINTVAL (operands[2]) & 0xffffffff) == UINTVAL (operands[3])))
                    return -1;
                  return 53; /* usubvsi3_borrow_imm */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[2] = x6;
          if (!arm_borrow_operation (operands[2], E_DImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 1795 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 38; /* cmpsi3_0_carryin_CC_Bout */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 100)
        return -1;
      x12 = XEXP (x4, 0);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[2] = x12;
          if (s_register_operand (operands[2], E_SImode))
            {
              res = recog_3 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          operands[1] = x12;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          switch (XWINT (x6, 0))
            {
            case -1L:
              if (pattern417 (x1, 
E_CC_RSBmode, 
NEG) != 0)
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              if (!s_register_operand (operands[0], E_SImode))
                return -1;
              x8 = XEXP (x7, 1);
              x10 = XEXP (x8, 0);
              if (!rtx_equal_p (x10, operands[1])
                  || !
#line 5197 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 169; /* negsi2_0compare */

            case 0L:
              if (GET_MODE (x5) != E_CC_NZmode
                  || GET_MODE (x3) != E_CC_NZmode)
                return -1;
              x7 = XVECEXP (x1, 0, 1);
              switch (pattern548 (x7, 
NOT))
                {
                case 0:
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!s_register_operand (operands[0], E_SImode))
                    return -1;
                  x8 = XEXP (x7, 1);
                  x10 = XEXP (x8, 0);
                  if (!rtx_equal_p (x10, operands[1])
                      || !
#line 5417 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 174; /* *notsi_compare0 */

                case 1:
                  if (!
#line 5428 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 175; /* *notsi_compare0_scratch */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[3] = x12;
          if (!shift_operator (operands[3], E_SImode)
              || XWINT (x6, 0) != 0L
              || GET_MODE (x5) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          x18 = XEXP (x12, 0);
          operands[1] = x18;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x19 = XEXP (x12, 1);
          operands[2] = x19;
          if (!shift_amount_operand (operands[2], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          switch (pattern548 (x7, 
NOT))
            {
            case 0:
              x8 = XEXP (x7, 1);
              x10 = XEXP (x8, 0);
              switch (GET_CODE (x10))
                {
                case MULT:
                case ASHIFT:
                case ROTATE:
                case ASHIFTRT:
                case LSHIFTRT:
                case ROTATERT:
                  if (!rtx_equal_p (x10, operands[3]))
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!s_register_operand (operands[0], E_SImode)
                      || !
#line 4813 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                    return -1;
                  return 155; /* *not_shiftsi_compare0 */

                default:
                  return -1;
                }

            case 1:
              if (!
#line 4828 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 156; /* *not_shiftsi_compare0_scratch */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern288 (x2) != 0)
        return -1;
      x12 = XEXP (x4, 0);
      if (s_register_operand (x12, E_SImode))
        {
          res = recog_5 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_CODE (x4) != MULT
          || GET_MODE (x4) != E_SImode)
        return -1;
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x20 = XEXP (x4, 1);
      operands[2] = x20;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (pattern548 (x7, 
MULT))
        {
        case 0:
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x7, 1);
          x10 = XEXP (x8, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x11 = XEXP (x8, 1);
          if (!rtx_equal_p (x11, operands[2])
              || !
#line 1443 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size))
            return -1;
          return 1062; /* *thumb2_mulsi_short_compare0 */

        case 1:
          if (!
#line 1455 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && optimize_size))
            return -1;
          return 1063; /* *thumb2_mulsi_short_compare0_scratch */

        default:
          return -1;
        }

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      switch (GET_CODE (x4))
        {
        case PLUS:
          res = recog_6 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MINUS:
          res = recog_7 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_8 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case IOR:
          res = recog_9 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case XOR:
          res = recog_10 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x4;
      if (!shiftable_operator (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x4, 0);
      if (!shift_operator (x12, E_SImode))
        return -1;
      operands[3] = x12;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern288 (x2) != 0)
        return -1;
      x18 = XEXP (x12, 0);
      operands[4] = x18;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x19 = XEXP (x12, 1);
      operands[5] = x19;
      if (!shift_amount_operand (operands[5], E_SImode))
        return -1;
      x20 = XEXP (x4, 1);
      operands[2] = x20;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case SET:
          x8 = XEXP (x7, 1);
          switch (GET_CODE (x8))
            {
            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x9 = XEXP (x7, 0);
              operands[0] = x9;
              if (!s_register_operand (operands[0], E_SImode)
                  || !
#line 9737 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 329; /* *arith_shiftsi_compare0 */

            default:
              return -1;
            }

        case CLOBBER:
          x9 = XEXP (x7, 0);
          operands[0] = x9;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 9754 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 330; /* *arith_shiftsi_compare0_scratch */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case CONST_INT:
      if (pnum_clobbers == NULL
          || XWINT (x7, 0) != 0L
          || GET_MODE (x2) != E_CC_NZmode
          || GET_MODE (x3) != E_CC_NZmode
          || !arm_rhs_operand (operands[2], E_SImode)
          || !
#line 4785 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      *pnum_clobbers = 1;
      return 153; /* *shiftsi3_compare0_scratch */

    case REG:
    case SUBREG:
      operands[0] = x7;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_CC_SWPmode
          || GET_MODE (x3) != E_CC_SWPmode
          || !shift_amount_operand (operands[2], E_SImode)
          || !
#line 7911 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 274; /* *cmpsi_shiftsi_swp */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  switch (REGNO (x4))
    {
    case 100:
      switch (GET_MODE (x4))
        {
        case E_CCFPmode:
          switch (pattern362 (x2, 
E_CCFPmode))
            {
            case 0:
              if (!
#line 1749 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 861; /* *cmpsf_split_vfp */

            case 1:
              if (!
#line 1779 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 863; /* *cmpdf_split_vfp */

            default:
              return -1;
            }

        case E_CCFPEmode:
          switch (pattern362 (x2, 
E_CCFPEmode))
            {
            case 0:
              if (!
#line 1764 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 862; /* *cmpsf_trap_split_vfp */

            case 1:
              if (!
#line 1794 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 864; /* *cmpdf_trap_split_vfp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 101:
      switch (GET_MODE (x4))
        {
        case E_CCFPmode:
          switch (pattern362 (x2, 
E_CCFPmode))
            {
            case 0:
              if (!
#line 1815 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 865; /* *cmpsf_vfp */

            case 1:
              if (!
#line 1839 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 867; /* *cmpdf_vfp */

            default:
              return -1;
            }

        case E_CCFPEmode:
          switch (pattern362 (x2, 
E_CCFPEmode))
            {
            case 0:
              if (!
#line 1827 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
                return -1;
              return 866; /* *cmpsf_trap_vfp */

            case 1:
              if (!
#line 1851 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 868; /* *cmpdf_trap_vfp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      if (!arm_rhs_operand (operands[2], E_SImode)
          || !
#line 3797 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      *pnum_clobbers = 1;
      return 112; /* *iorsi3_compare0_scratch */

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern341 (x1) != 0
          || !
#line 10415 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 343; /* *cmp_ior */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          operands[2] = x3;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 2261 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 56; /* *mul */

        case E_V4HImode:
          if (GET_MODE (x2) != E_V4HImode)
            return -1;
          operands[1] = x3;
          if (register_operand (operands[1], E_V4HImode)
              && register_operand (operands[0], E_V4HImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (register_operand (operands[2], E_V4HImode)
                  && 
#line 481 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 570; /* *mulv4hi3_iwmmxt */
            }
          if (!s_register_operand (operands[1], E_V4HImode)
              || !s_register_operand (operands[0], E_V4HImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!s_register_operand (operands[2], E_V4HImode)
              || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HI_ARITH))
            return -1;
          return 1183; /* *mulv4hi3_neon */

        case E_V2SImode:
          if (GET_MODE (x2) != E_V2SImode)
            return -1;
          operands[1] = x3;
          if (register_operand (operands[1], E_V2SImode)
              && register_operand (operands[0], E_V2SImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (register_operand (operands[2], E_V2SImode)
                  && 
#line 361 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
                return 709; /* iwmmxt_wmulwl */
            }
          if (!s_register_operand (operands[1], E_V2SImode)
              || !s_register_operand (operands[0], E_V2SImode))
            return -1;
          x4 = XEXP (x2, 1);
          operands[2] = x4;
          if (!s_register_operand (operands[2], E_V2SImode)
              || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SI_ARITH))
            return -1;
          return 1185; /* *mulv2si3_neon */

        case E_HFmode:
          if (pattern300 (x2, 
E_HFmode) != 0
              || !
#line 1103 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 804; /* mulhf3 */

        case E_SFmode:
          if (pattern300 (x2, 
E_SFmode) != 0
              || !
#line 1113 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 805; /* *mulsf3_vfp */

        case E_DFmode:
          if (pattern300 (x2, 
E_DFmode) != 0
              || !
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 806; /* *muldf3_vfp */

        case E_V8QImode:
          if (pattern300 (x2, 
E_V8QImode) != 0
              || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8QI_ARITH))
            return -1;
          return 1181; /* *mulv8qi3_neon */

        case E_V16QImode:
          if (pattern300 (x2, 
E_V16QImode) != 0)
            return -1;
          if (
#line 543 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V16QI_ARITH))
            return 1182; /* *mulv16qi3_neon */
          if (!
#line 991 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3676; /* mve_vmulqv16qi */

        case E_V8HImode:
          if (pattern300 (x2, 
E_V8HImode) != 0)
            return -1;
          if (
#line 543 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HI_ARITH))
            return 1184; /* *mulv8hi3_neon */
          if (!
#line 991 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3679; /* mve_vmulqv8hi */

        case E_V4SImode:
          if (pattern300 (x2, 
E_V4SImode) != 0)
            return -1;
          if (
#line 543 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SI_ARITH))
            return 1186; /* *mulv4si3_neon */
          if (!
#line 991 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3682; /* mve_vmulqv4si */

        case E_V2SFmode:
          if (pattern300 (x2, 
E_V2SFmode) != 0
              || !
#line 543 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH))
            return -1;
          return 1187; /* *mulv2sf3_neon */

        case E_V4SFmode:
          if (pattern300 (x2, 
E_V4SFmode) != 0)
            return -1;
          if (
#line 543 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return 1188; /* *mulv4sf3_neon */
          if (!
#line 1399 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3837; /* mve_vmulq_fv4sf */

        case E_V8HFmode:
          if (pattern300 (x2, 
E_V8HFmode) != 0)
            return -1;
          if (
#line 1635 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return 1534; /* neon_vmulfv8hf */
          if (!
#line 1399 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3834; /* mve_vmulq_fv8hf */

        case E_V4HFmode:
          if (pattern300 (x2, 
E_V4HFmode) != 0
              || !
#line 1635 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
            return -1;
          return 1535; /* neon_vmulfv4hf */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case SIGN_EXTEND:
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern424 (x2) != 0
                      || GET_MODE (x4) != E_SImode
                      || !s_register_operand (operands[2], E_HImode)
                      || !
#line 2528 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                    return -1;
                  return 73; /* mulhisi3 */

                case E_V8HImode:
                  if (pattern425 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                      || !
#line 6506 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 3004; /* neon_vec_smult_v8qi */

                case E_V4SImode:
                  if (pattern425 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 6506 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 3006; /* neon_vec_smult_v4hi */

                case E_V2DImode:
                  if (pattern425 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                      || !
#line 6506 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 3008; /* neon_vec_smult_v2si */

                default:
                  return -1;
                }

            case ASHIFTRT:
              if (GET_MODE (x4) != E_SImode)
                return -1;
              x7 = XEXP (x4, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
                  || pattern424 (x2) != 0)
                return -1;
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 2554 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
                return -1;
              return 75; /* *mulhisi3bt */

            default:
              return -1;
            }

        case VEC_SELECT:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != SIGN_EXTEND)
            return -1;
          switch (pattern343 (x2))
            {
            case 0:
              if (vect_par_constant_low (operands[2], E_V16QImode)
                  && 
#line 6366 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2980; /* neon_vec_smult_lo_v16qi */
              if (!vect_par_constant_high (operands[2], E_V16QImode)
                  || !
#line 6400 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2986; /* neon_vec_smult_hi_v16qi */

            case 1:
              if (vect_par_constant_low (operands[2], E_V8HImode)
                  && 
#line 6366 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2982; /* neon_vec_smult_lo_v8hi */
              if (!vect_par_constant_high (operands[2], E_V8HImode)
                  || !
#line 6400 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2988; /* neon_vec_smult_hi_v8hi */

            case 2:
              if (vect_par_constant_low (operands[2], E_V4SImode)
                  && 
#line 6366 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2984; /* neon_vec_smult_lo_v4si */
              if (!vect_par_constant_high (operands[2], E_V4SImode)
                  || !
#line 6400 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2990; /* neon_vec_smult_hi_v4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern267 (x2, 
16) != 0)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_CODE (x4))
        {
        case SIGN_EXTEND:
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_HImode)
              || !
#line 2541 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
            return -1;
          return 74; /* *mulhisi3tb */

        case ASHIFTRT:
          x7 = XEXP (x4, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 2568 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY))
            return -1;
          return 76; /* *mulhisi3tt */

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (pattern368 (x2, 
E_HFmode) != 0
              || !
#line 1133 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST && !flag_rounding_math))
            return -1;
          return 807; /* *mulsf3neghf_vfp */

        case E_SFmode:
          if (pattern368 (x2, 
E_SFmode) != 0
              || !
#line 1153 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && !flag_rounding_math))
            return -1;
          return 809; /* *mulsf3negsf_vfp */

        case E_DFmode:
          if (pattern368 (x2, 
E_DFmode) != 0
              || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE
  && !flag_rounding_math))
            return -1;
          return 811; /* *muldf3negdf_vfp */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern268 (x2))
        {
        case 0:
          if (!
#line 1865 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math))
            return -1;
          return 869; /* *combine_vcvt_f32_u32 */

        case 1:
          if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math
  && !TARGET_VFP_SINGLE))
            return -1;
          return 871; /* *combine_vcvt_f64_u32 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern268 (x2))
        {
        case 0:
          if (!
#line 1865 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math))
            return -1;
          return 870; /* *combine_vcvt_f32_s32 */

        case 1:
          if (!
#line 1878 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math
  && !TARGET_VFP_SINGLE))
            return -1;
          return 872; /* *combine_vcvt_f64_s32 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != ZERO_EXTEND)
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          switch (pattern343 (x2))
            {
            case 0:
              if (vect_par_constant_low (operands[2], E_V16QImode)
                  && 
#line 6366 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2981; /* neon_vec_umult_lo_v16qi */
              if (!vect_par_constant_high (operands[2], E_V16QImode)
                  || !
#line 6400 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2987; /* neon_vec_umult_hi_v16qi */

            case 1:
              if (vect_par_constant_low (operands[2], E_V8HImode)
                  && 
#line 6366 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2983; /* neon_vec_umult_lo_v8hi */
              if (!vect_par_constant_high (operands[2], E_V8HImode)
                  || !
#line 6400 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2989; /* neon_vec_umult_hi_v8hi */

            case 2:
              if (vect_par_constant_low (operands[2], E_V4SImode)
                  && 
#line 6366 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return 2985; /* neon_vec_umult_lo_v4si */
              if (!vect_par_constant_high (operands[2], E_V4SImode)
                  || !
#line 6400 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
                return -1;
              return 2991; /* neon_vec_umult_hi_v4si */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern425 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                  || !
#line 6506 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 3005; /* neon_vec_umult_v8qi */

            case E_V4SImode:
              if (pattern425 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                  || !
#line 6506 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 3007; /* neon_vec_umult_v4hi */

            case E_V2DImode:
              if (pattern425 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                  || !
#line 6506 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                return -1;
              return 3009; /* neon_vec_umult_v2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (register_operand (operands[0], E_SImode)
      && 
#line 12292 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_HARD_TP))
    return 405; /* load_tp_hard */
  if (pnum_clobbers == NULL
      || GET_CODE (x4) != REG
      || REGNO (x4) != 0
      || GET_MODE (x4) != E_SImode)
    return -1;
  if (
#line 12314 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_SOFT_TP && TARGET_FDPIC))
    {
      *pnum_clobbers = 4;
      return 407; /* load_tp_soft_fdpic */
    }
  if (!
#line 12326 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_SOFT_TP && !TARGET_FDPIC))
    return -1;
  *pnum_clobbers = 3;
  return 408; /* load_tp_soft */
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !memory_operand (operands[1], E_DImode)
          || !
#line 5005 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && TARGET_LDRD))
        return -1;
      return 157; /* unaligned_loaddi */

    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !mem_and_no_t1_wback_op (operands[1], E_SImode)
          || !
#line 5016 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(unaligned_access))
        return -1;
      return 158; /* unaligned_loadsi */

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2767 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1874; /* neon_vpaddluv8qi */

    case 1:
      if (!
#line 2767 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1876; /* neon_vpaddluv16qi */

    case 2:
      if (!
#line 2767 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1878; /* neon_vpaddluv4hi */

    case 3:
      if (!
#line 2767 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1880; /* neon_vpaddluv8hi */

    case 4:
      if (!
#line 2767 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1882; /* neon_vpaddluv2si */

    case 5:
      if (!
#line 2767 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1884; /* neon_vpaddluv4si */

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern149 (x1))
    {
    case 0:
      if (!(
#line 2891 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 189 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return -1;
      return 1933; /* neon_vcadd270v4hf */

    case 1:
      if (register_operand (operands[0], E_V8HFmode)
          && register_operand (operands[1], E_V8HFmode)
          && register_operand (operands[2], E_V8HFmode)
          && (
#line 2891 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX) && 
#line 190 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_NEON_FP16INST)))
        return 1935; /* neon_vcadd270v8hf */
      if (!s_register_operand (operands[0], E_V8HFmode)
          || !s_register_operand (operands[1], E_V8HFmode)
          || !s_register_operand (operands[2], E_V8HFmode)
          || !
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3743; /* mve_vcaddq_rot270_fv8hf */

    case 2:
      if (!
#line 2891 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return -1;
      return 1937; /* neon_vcadd270v2sf */

    case 3:
      if (register_operand (operands[0], E_V4SFmode)
          && register_operand (operands[1], E_V4SFmode)
          && register_operand (operands[2], E_V4SFmode)
          && 
#line 2891 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_COMPLEX))
        return 1939; /* neon_vcadd270v4sf */
      if (!s_register_operand (operands[0], E_V4SFmode)
          || !s_register_operand (operands[1], E_V4SFmode)
          || !s_register_operand (operands[2], E_V4SFmode)
          || !
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3749; /* mve_vcaddq_rot270_fv4sf */

    case 4:
      if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3567; /* mve_vcaddq_rot270_v16qi */

    case 5:
      if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3571; /* mve_vcaddq_rot270_v8hi */

    case 6:
      if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3575; /* mve_vcaddq_rot270_v4si */

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[2], E_V8QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[1], E_V8QImode)
              || !
#line 4682 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2485; /* neon_vtbl1v8qi */

        case E_TImode:
          if (!s_register_operand (operands[1], E_TImode)
              || !
#line 4692 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2486; /* neon_vtbl2v8qi */

        case E_EImode:
          if (!s_register_operand (operands[1], E_EImode)
              || !
#line 4713 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2487; /* neon_vtbl3v8qi */

        case E_OImode:
          if (!s_register_operand (operands[1], E_OImode)
              || !
#line 4735 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2488; /* neon_vtbl4v8qi */

        default:
          return -1;
        }

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (pattern415 ())
        {
        case 0:
          if (!
#line 4759 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2489; /* neon_vtbl1v16qi */

        case 1:
          if (!
#line 4790 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2490; /* neon_vtbl2v16qi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern165 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V16QImode, 
E_V4x16QImode) != 0
          || !
#line 4128 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x16QImode))))
        return -1;
      return 5006; /* mve_vld4qv16qi */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V8HImode, 
E_V4x8HImode) != 0
          || !
#line 4128 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x8HImode))))
        return -1;
      return 5007; /* mve_vld4qv8hi */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V4SImode, 
E_V4x4SImode) != 0
          || !
#line 4128 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x4SImode))))
        return -1;
      return 5008; /* mve_vld4qv4si */

    case 3:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V8HFmode, 
E_V4x8HFmode) != 0
          || !
#line 4128 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x8HFmode))))
        return -1;
      return 5009; /* mve_vld4qv8hf */

    case 4:
      x2 = XEXP (x1, 1);
      if (pattern460 (x2, 
E_V4SFmode, 
E_V4x4SFmode) != 0
          || !
#line 4128 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_STRUCT_MODE (V4x4SFmode))))
        return -1;
      return 5010; /* mve_vld4qv4sf */

    default:
      return -1;
    }
}

 int
recog_158 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (pattern41 (x3, 
E_HFmode) != 0
          || !
#line 1602 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 852; /* neon_vrsqrtshf */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 2828 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1917; /* neon_vrsqrtsv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 2828 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1918; /* neon_vrsqrtsv4sf */

    case E_V8HFmode:
      if (pattern41 (x3, 
E_V8HFmode) != 0
          || !
#line 2839 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1919; /* neon_vrsqrtsv8hf */

    case E_V4HFmode:
      if (pattern41 (x3, 
E_V4HFmode) != 0
          || !
#line 2839 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1920; /* neon_vrsqrtsv4hf */

    default:
      return -1;
    }
}

 int
recog_167 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2344; /* neon_vshru_nv8qi */

    case 1:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2348; /* neon_vshru_nv16qi */

    case 2:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2352; /* neon_vshru_nv4hi */

    case 3:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2356; /* neon_vshru_nv8hi */

    case 4:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2360; /* neon_vshru_nv2si */

    case 5:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2364; /* neon_vshru_nv4si */

    case 6:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2368; /* neon_vshru_ndi */

    case 7:
      if (!
#line 4531 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2372; /* neon_vshru_nv2di */

    default:
      return -1;
    }
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2279; /* neon_vshlsv8qi */

    case 1:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2283; /* neon_vshlsv16qi */

    case 2:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2287; /* neon_vshlsv4hi */

    case 3:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2291; /* neon_vshlsv8hi */

    case 4:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2295; /* neon_vshlsv2si */

    case 5:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2299; /* neon_vshlsv4si */

    case 6:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2303; /* neon_vshlsdi */

    case 7:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2307; /* neon_vshlsv2di */

    default:
      return -1;
    }
}

 int
recog_186 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V2SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode)
          || !register_operand (operands[2], E_V8QImode)
          || !
#line 1750 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 685; /* iwmmxt_wsadbz */

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode)
          || !register_operand (operands[2], E_V4HImode)
          || !
#line 1760 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 686; /* iwmmxt_wsadhz */

    default:
      return -1;
    }
}

 int
recog_195 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern131 (x1))
    {
    case 0:
      if (!
#line 952 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1390; /* ashlv8qi3_unsigned */

    case 1:
      if (!
#line 952 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1391; /* ashlv16qi3_unsigned */

    case 2:
      if (!
#line 952 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1392; /* ashlv4hi3_unsigned */

    case 3:
      if (!
#line 952 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1393; /* ashlv8hi3_unsigned */

    case 4:
      if (!
#line 952 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1394; /* ashlv2si3_unsigned */

    case 5:
      if (!
#line 952 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1395; /* ashlv4si3_unsigned */

    case 6:
      if (!
#line 952 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1396; /* ashlv2di3_unsigned */

    default:
      return -1;
    }
}

 int
recog_205 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern161 (x1, 
E_EImode, 
E_CImode))
    {
    case 0:
      if (!
#line 5687 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2839; /* neon_vld3qav16qi */

    case 1:
      if (!
#line 5687 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2840; /* neon_vld3qav8hi */

    case 2:
      if (!
#line 5687 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2841; /* neon_vld3qav8hf */

    case 3:
      if (!(
#line 5687 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2842; /* neon_vld3qav8bf */

    case 4:
      if (!
#line 5687 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2843; /* neon_vld3qav4si */

    case 5:
      if (!
#line 5687 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2844; /* neon_vld3qav4sf */

    default:
      return -1;
    }
}

 int
recog_215 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1649; /* neon_vhsubsv8qi */

    case 1:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1651; /* neon_vhsubsv16qi */

    case 2:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1653; /* neon_vhsubsv4hi */

    case 3:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1655; /* neon_vhsubsv8hi */

    case 4:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1657; /* neon_vhsubsv2si */

    case 5:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1659; /* neon_vhsubsv4si */

    default:
      return -1;
    }
}

 int
recog_225 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1))
    {
    case 0:
      if (!
#line 542 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3372; /* mve_vcreateq_uv16qi */

    case 1:
      if (!
#line 542 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3374; /* mve_vcreateq_uv8hi */

    case 2:
      if (!
#line 542 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3376; /* mve_vcreateq_uv4si */

    case 3:
      if (!
#line 542 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3378; /* mve_vcreateq_uv2di */

    default:
      return -1;
    }
}

 int
recog_234 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1709; /* neon_vcgev2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1714; /* neon_vcgev4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1729; /* neon_vcgev8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1734; /* neon_vcgev4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_244 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern200 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_OImode:
      if (!s_register_operand (operands[0], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_OImode
          || !s_register_operand (operands[2], E_OImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!neon_struct_operand (operands[1], E_SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8QImode
              || !
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2919; /* neon_vld4_lanev8qi */

        case E_V4HImode:
          if (!neon_struct_operand (operands[1], E_V4HImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4HImode
              || !
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2920; /* neon_vld4_lanev4hi */

        case E_V4HFmode:
          if (!neon_struct_operand (operands[1], E_V4HFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4HFmode
              || !
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2921; /* neon_vld4_lanev4hf */

        case E_V4BFmode:
          if (!neon_struct_operand (operands[1], E_V4BFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4BFmode
              || !
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2922; /* neon_vld4_lanev4bf */

        case E_V4SImode:
          if (!neon_struct_operand (operands[1], E_V4SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V2SImode
              || !
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2923; /* neon_vld4_lanev2si */

        case E_V4SFmode:
          if (!neon_struct_operand (operands[1], E_V4SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V2SFmode
              || !
#line 6060 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2924; /* neon_vld4_lanev2sf */

        default:
          return -1;
        }

    case E_XImode:
      if (!s_register_operand (operands[0], E_XImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_XImode
          || !s_register_operand (operands[2], E_XImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!neon_struct_operand (operands[1], E_V4HImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8HImode
              || !
#line 6087 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2925; /* neon_vld4_lanev8hi */

        case E_V4HFmode:
          if (!neon_struct_operand (operands[1], E_V4HFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8HFmode
              || !
#line 6087 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2926; /* neon_vld4_lanev8hf */

        case E_V4SImode:
          if (!neon_struct_operand (operands[1], E_V4SImode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4SImode
              || !
#line 6087 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2927; /* neon_vld4_lanev4si */

        case E_V4SFmode:
          if (!neon_struct_operand (operands[1], E_V4SFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V4SFmode
              || !
#line 6087 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2928; /* neon_vld4_lanev4sf */

        case E_V4BFmode:
          if (!neon_struct_operand (operands[1], E_V4BFmode))
            return -1;
          x3 = XVECEXP (x2, 0, 3);
          if (GET_MODE (x3) != E_V8BFmode
              || !(
#line 6087 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2929; /* neon_vld4_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[6] = x4;
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x4, 1);
  operands[5] = x6;
  x7 = XEXP (x3, 1);
  operands[3] = x7;
  if (!arm_add_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x2, 2);
  operands[1] = x8;
  if (!arm_rhs_operand (operands[1], E_SImode)
      || !
#line 10874 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
    return -1;
  *pnum_clobbers = 1;
  return 352; /* *ifcompare_plus_move */
}

 int
recog_272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      x7 = XEXP (x6, 0);
      if (!s_register_operand (x7, E_SImode))
        return -1;
      operands[2] = x7;
      if (GET_CODE (x6) == PLUS
          && GET_MODE (x6) == E_SImode)
        {
          operands[4] = x3;
          x8 = XEXP (x3, 0);
          operands[5] = x8;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          if (arm_add_operand (operands[3], E_SImode))
            {
              x10 = XEXP (x2, 2);
              operands[1] = x10;
              if (arm_rhs_operand (operands[1], E_SImode)
                  && 
#line 10890 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 353; /* *if_plus_move */
            }
        }
      operands[5] = x3;
      operands[6] = x6;
      if (!shiftable_operator (operands[6], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      if (!arm_rhs_operand (x9, E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          operands[7] = x10;
          if (!shiftable_operator (operands[7], E_SImode))
            return -1;
          x8 = XEXP (x3, 0);
          operands[8] = x8;
          operands[1] = x7;
          operands[2] = x9;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[4] = x12;
          if (!arm_rhs_operand (operands[4], E_SImode)
              || !
#line 10979 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 357; /* *if_arith_arith */

        case NOT:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          x8 = XEXP (x3, 0);
          operands[4] = x8;
          operands[2] = x7;
          operands[3] = x9;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode)
              || !
#line 11377 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 375; /* *if_arith_not */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[1] = x6;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case PLUS:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          operands[4] = x3;
          x8 = XEXP (x3, 0);
          operands[5] = x8;
          if (!arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_add_operand (operands[3], E_SImode)
              || !
#line 10933 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 355; /* *if_move_plus */

        case NOT:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          operands[4] = x3;
          x8 = XEXP (x3, 0);
          operands[3] = x8;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          if (arm_not_operand (operands[1], E_SImode)
              && 
#line 11142 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 363; /* *if_move_not */
          if (!arm_rhs_operand (operands[1], E_SImode)
              || !
#line 11821 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 381; /* *cond_move_not */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[4] = x10;
          if (!shift_operator (operands[4], E_SImode))
            return -1;
          operands[5] = x3;
          x8 = XEXP (x3, 0);
          operands[6] = x8;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_rhs_operand (operands[3], E_SImode)
              || !
#line 11257 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 369; /* *if_move_shift */

        case NEG:
          if (GET_MODE (x10) != E_SImode)
            return -1;
          operands[4] = x3;
          x8 = XEXP (x3, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 11443 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 379; /* *if_move_neg */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (!s_register_operand (x7, E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x10;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          operands[4] = x3;
          x8 = XEXP (x3, 0);
          operands[3] = x8;
          operands[2] = x7;
          if (!
#line 11177 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 365; /* *if_not_move */

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          operands[6] = x10;
          if (!shiftable_operator (operands[6], E_SImode))
            return -1;
          operands[5] = x3;
          x8 = XEXP (x3, 0);
          operands[4] = x8;
          operands[1] = x7;
          x11 = XEXP (x10, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[3] = x12;
          if (!arm_rhs_operand (operands[3], E_SImode)
              || !
#line 11343 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 373; /* *if_not_arith */

        default:
          return -1;
        }

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      if (!shift_operator (x6, E_SImode))
        return -1;
      operands[5] = x3;
      x7 = XEXP (x6, 0);
      if (!s_register_operand (x7, E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      if (!arm_rhs_operand (x9, E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      switch (GET_CODE (x10))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x10;
          if (!arm_not_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x3, 0);
          operands[6] = x8;
          operands[4] = x6;
          operands[2] = x7;
          operands[3] = x9;
          if (!
#line 11214 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 367; /* *if_shift_move */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[7] = x10;
          if (!shift_operator (operands[7], E_SImode))
            return -1;
          x8 = XEXP (x3, 0);
          operands[8] = x8;
          operands[6] = x6;
          operands[1] = x7;
          operands[2] = x9;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[4] = x12;
          if (!arm_rhs_operand (operands[4], E_SImode)
              || !
#line 11304 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 371; /* *if_shift_shift */

        default:
          return -1;
        }

    case NEG:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      operands[4] = x3;
      x8 = XEXP (x3, 0);
      operands[3] = x8;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x10 = XEXP (x2, 2);
      operands[1] = x10;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 11407 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && !TARGET_COND_ARITH))
        return -1;
      return 377; /* *if_neg_move */

    default:
      return -1;
    }
}

 int
recog_284 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
      return recog_282 (x1, insn, pnum_clobbers);

    case PLUS:
      if (GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          if (arm_carry_operation (operands[3], E_SImode))
            {
              if (arm_not_operand (operands[2], E_SImode)
                  && 
#line 1338 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return 21; /* addsi3_carryin */
              if (pnum_clobbers != NULL
                  && arm_rhs_operand (operands[2], E_SImode)
                  && 
#line 1405 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                {
                  *pnum_clobbers = 1;
                  return 25; /* *addsi3_carryin_clobercc */
                }
            }
          if (!s_register_operand (operands[2], E_SImode)
              || GET_CODE (x6) != GEU
              || GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[4] = x8;
          if (!thumb1_cmp_operand (operands[4], E_SImode)
              || !
#line 1807 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 989; /* thumb1_addsi3_addgeu */

        case GEU:
        case LTU:
          operands[3] = x4;
          if (!arm_carry_operation (operands[3], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          if (!arm_not_operand (operands[2], E_SImode)
              || !
#line 1369 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 23; /* *addsi3_carryin_alt2 */

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (!shift_operator (x4, E_SImode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!s_register_operand (x9, E_SImode))
            return -1;
          x10 = XEXP (x4, 1);
          if (!shift_amount_operand (x10, E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case GEU:
            case LTU:
              operands[5] = x5;
              if (!arm_carry_operation (operands[5], E_SImode))
                return -1;
              operands[2] = x4;
              operands[3] = x9;
              operands[4] = x10;
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              if (!s_register_operand (operands[1], E_SImode)
                  || !
#line 1390 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
                return -1;
              return 24; /* *addsi3_carryin_shift */

            case NOT:
              if (GET_MODE (x5) != E_SImode)
                return -1;
              operands[3] = x4;
              operands[1] = x9;
              operands[2] = x10;
              x11 = XEXP (x5, 0);
              operands[4] = x11;
              if (!s_register_operand (operands[4], E_SImode))
                return -1;
              x6 = XEXP (x2, 1);
              operands[5] = x6;
              if (!arm_carry_operation (operands[5], E_SImode)
                  || !
#line 1749 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 32; /* add_not_shift_cin */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          operands[3] = x5;
          if (!arm_carry_operation (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[2] = x6;
          if (!arm_rhs_operand (operands[2], E_SImode)
              || !
#line 1729 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM || (TARGET_THUMB2 && !CONST_INT_P (operands[2]))))
            return -1;
          return 31; /* *add_not_cin */

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x3;
      if (!arm_carry_operation (operands[2], E_SImode)
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!arm_not_operand (operands[1], E_SImode)
          || !
#line 1356 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 22; /* add0si3_carryin */

    case MULT:
      return recog_283 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      switch (pattern274 (x2))
        {
        case 0:
          if (!
#line 5711 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
            return -1;
          return 178; /* *arm_zero_extendhisi2addsi */

        case 1:
          if (!
#line 5781 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
            return -1;
          return 181; /* *arm_zero_extendqisi2addsi */

        case 2:
          if (!
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1413; /* widen_usumv8qi3 */

        case 3:
          if (!
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1414; /* widen_usumv4hi3 */

        case 4:
          if (!
#line 1111 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1415; /* widen_usumv2si3 */

        case 5:
          if (vect_par_constant_low (operands[2], E_V16QImode)
              && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1407; /* vec_sel_widen_usum_lov16qiv8qi3 */
          if (!vect_par_constant_high (operands[2], E_V16QImode)
              || !
#line 1099 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1410; /* vec_sel_widen_usum_hiv16qiv8qi3 */

        case 6:
          if (vect_par_constant_low (operands[2], E_V8HImode)
              && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1408; /* vec_sel_widen_usum_lov8hiv4hi3 */
          if (!vect_par_constant_high (operands[2], E_V8HImode)
              || !
#line 1099 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1411; /* vec_sel_widen_usum_hiv8hiv4hi3 */

        case 7:
          if (vect_par_constant_low (operands[2], E_V4SImode)
              && 
#line 1084 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1409; /* vec_sel_widen_usum_lov4siv2si3 */
          if (!vect_par_constant_high (operands[2], E_V4SImode)
              || !
#line 1099 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1412; /* vec_sel_widen_usum_hiv4siv2si3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern274 (x2))
        {
        case 0:
          if (!
#line 5952 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
            return -1;
          return 185; /* *arm_extendhisi2addsi */

        case 1:
          if (!
#line 6046 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
            return -1;
          return 189; /* *arm_extendqisi2addsi */

        case 2:
          if (!
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1404; /* widen_ssumv8qi3 */

        case 3:
          if (!
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1405; /* widen_ssumv4hi3 */

        case 4:
          if (!
#line 1042 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1406; /* widen_ssumv2si3 */

        case 5:
          if (vect_par_constant_low (operands[2], E_V16QImode)
              && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1398; /* vec_sel_widen_ssum_lov16qiv8qi3 */
          if (!vect_par_constant_high (operands[2], E_V16QImode)
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1401; /* vec_sel_widen_ssum_hiv16qiv8qi3 */

        case 6:
          if (vect_par_constant_low (operands[2], E_V8HImode)
              && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1399; /* vec_sel_widen_ssum_lov8hiv4hi3 */
          if (!vect_par_constant_high (operands[2], E_V8HImode)
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1402; /* vec_sel_widen_ssum_hiv8hiv4hi3 */

        case 7:
          if (vect_par_constant_low (operands[2], E_V4SImode)
              && 
#line 1014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return 1400; /* vec_sel_widen_ssum_lov4siv2si3 */
          if (!vect_par_constant_high (operands[2], E_V4SImode)
              || !
#line 1029 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1403; /* vec_sel_widen_ssum_hiv4siv2si3 */

        default:
          return -1;
        }

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x3;
      if (pattern304 (x2) != 0
          || !
#line 9700 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT))
        return -1;
      return 324; /* *add_shiftsi */

    case VEC_SELECT:
      switch (pattern271 (x2))
        {
        case 0:
          if (!
#line 1129 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1416; /* quad_halves_plusv4si */

        case 1:
          if (!
#line 1142 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH))
            return -1;
          return 1421; /* quad_halves_plusv4sf */

        case 2:
          if (!
#line 1157 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1424; /* quad_halves_plusv8hi */

        case 3:
          if (!
#line 1176 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1429; /* quad_halves_plusv16qi */

        default:
          return -1;
        }

    case EQ:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != AND)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern465 (x2, 
E_V8QImode) != 0
              || !
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1781; /* neon_vtst_combinev8qi */

        case E_V16QImode:
          if (pattern465 (x2, 
E_V16QImode) != 0
              || !
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1782; /* neon_vtst_combinev16qi */

        case E_V4HImode:
          if (pattern465 (x2, 
E_V4HImode) != 0
              || !
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1783; /* neon_vtst_combinev4hi */

        case E_V8HImode:
          if (pattern465 (x2, 
E_V8HImode) != 0
              || !
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1784; /* neon_vtst_combinev8hi */

        case E_V2SImode:
          if (pattern465 (x2, 
E_V2SImode) != 0
              || !
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1785; /* neon_vtst_combinev2si */

        case E_V4SImode:
          if (pattern465 (x2, 
E_V4SImode) != 0
              || !
#line 2583 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1786; /* neon_vtst_combinev4si */

        default:
          return -1;
        }

    case UNSPEC:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          switch (XINT (x3, 1))
            {
            case 149:
              switch (pattern351 (x2))
                {
                case 0:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1809; /* neon_vabasv8qi */

                case 1:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1811; /* neon_vabasv16qi */

                case 2:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1813; /* neon_vabasv4hi */

                case 3:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1815; /* neon_vabasv8hi */

                case 4:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1817; /* neon_vabasv2si */

                case 5:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1819; /* neon_vabasv4si */

                default:
                  return -1;
                }

            case 150:
              switch (pattern351 (x2))
                {
                case 0:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1810; /* neon_vabauv8qi */

                case 1:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1812; /* neon_vabauv16qi */

                case 2:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1814; /* neon_vabauv4hi */

                case 3:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1816; /* neon_vabauv8hi */

                case 4:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1818; /* neon_vabauv2si */

                case 5:
                  if (!
#line 2634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1820; /* neon_vabauv4si */

                default:
                  return -1;
                }

            case 151:
              switch (pattern353 (x2))
                {
                case 0:
                  if (!
#line 2645 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1821; /* neon_vabalsv8qi */

                case 1:
                  if (!
#line 2645 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1823; /* neon_vabalsv4hi */

                case 2:
                  if (!
#line 2645 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1825; /* neon_vabalsv2si */

                default:
                  return -1;
                }

            case 152:
              switch (pattern353 (x2))
                {
                case 0:
                  if (!
#line 2645 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1822; /* neon_vabaluv8qi */

                case 1:
                  if (!
#line 2645 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1824; /* neon_vabaluv4hi */

                case 2:
                  if (!
#line 2645 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
                    return -1;
                  return 1826; /* neon_vabaluv2si */

                default:
                  return -1;
                }

            case 370:
              switch (pattern355 (x2))
                {
                case 0:
                  if (!
#line 2999 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                    return -1;
                  return 1988; /* sdot_prodv2siv8qi */

                case 1:
                  if (!
#line 2999 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                    return -1;
                  return 1990; /* sdot_prodv4siv16qi */

                default:
                  return -1;
                }

            case 371:
              switch (pattern355 (x2))
                {
                case 0:
                  if (!
#line 2999 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                    return -1;
                  return 1989; /* udot_prodv2siv8qi */

                case 1:
                  if (!
#line 2999 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                    return -1;
                  return 1991; /* udot_prodv4siv16qi */

                default:
                  return -1;
                }

            case 372:
              x12 = XVECEXP (x3, 0, 0);
              operands[2] = x12;
              x13 = XVECEXP (x3, 0, 1);
              operands[3] = x13;
              x6 = XEXP (x2, 1);
              operands[1] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (pattern466 (x2, 
E_V2SImode, 
E_V8QImode) != 0
                      || !
#line 3024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                    return -1;
                  return 1992; /* neon_usdotv2siv8qi */

                case E_V4SImode:
                  if (pattern466 (x2, 
E_V4SImode, 
E_V16QImode) != 0
                      || !
#line 3024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                    return -1;
                  return 1993; /* neon_usdotv4siv16qi */

                default:
                  return -1;
                }

            case 389:
              if (pattern356 (x2) != 0
                  || !
#line 6634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                return -1;
              return 3024; /* neon_smmlav16qi */

            case 390:
              if (pattern356 (x2) != 0
                  || !
#line 6634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                return -1;
              return 3025; /* neon_ummlav16qi */

            case 391:
              if (pattern356 (x2) != 0
                  || !
#line 6634 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                return -1;
              return 3026; /* neon_usmmlav16qi */

            default:
              return -1;
            }

        case 3:
          x12 = XVECEXP (x3, 0, 0);
          operands[2] = x12;
          x13 = XVECEXP (x3, 0, 1);
          operands[3] = x13;
          x14 = XVECEXP (x3, 0, 2);
          operands[4] = x14;
          if (!immediate_operand (operands[4], E_SImode))
            return -1;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (XINT (x3, 1))
            {
            case 370:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  switch (pattern513 (x2, 
E_V2SImode, 
E_V8QImode))
                    {
                    case 0:
                      if (!
#line 3039 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1994; /* neon_sdot_lanev8qi */

                    case 1:
                      if (!
#line 3054 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1998; /* neon_sdot_laneqv8qi */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  switch (pattern513 (x2, 
E_V4SImode, 
E_V16QImode))
                    {
                    case 0:
                      if (!
#line 3039 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1996; /* neon_sdot_lanev16qi */

                    case 1:
                      if (!
#line 3054 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 2000; /* neon_sdot_laneqv16qi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 371:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  switch (pattern513 (x2, 
E_V2SImode, 
E_V8QImode))
                    {
                    case 0:
                      if (!
#line 3039 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1995; /* neon_udot_lanev8qi */

                    case 1:
                      if (!
#line 3054 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1999; /* neon_udot_laneqv8qi */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  switch (pattern513 (x2, 
E_V4SImode, 
E_V16QImode))
                    {
                    case 0:
                      if (!
#line 3039 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 1997; /* neon_udot_lanev16qi */

                    case 1:
                      if (!
#line 3054 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_DOTPROD))
                        return -1;
                      return 2001; /* neon_udot_laneqv16qi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 372:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  switch (pattern513 (x2, 
E_V2SImode, 
E_V8QImode))
                    {
                    case 0:
                      if (!
#line 3082 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2002; /* neon_usdot_lanev8qi */

                    case 1:
                      if (!
#line 3097 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2006; /* neon_usdot_laneqv8qi */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  switch (pattern513 (x2, 
E_V4SImode, 
E_V16QImode))
                    {
                    case 0:
                      if (!
#line 3082 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2004; /* neon_usdot_lanev16qi */

                    case 1:
                      if (!
#line 3097 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2008; /* neon_usdot_laneqv16qi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 373:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  switch (pattern513 (x2, 
E_V2SImode, 
E_V8QImode))
                    {
                    case 0:
                      if (!
#line 3082 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2003; /* neon_sudot_lanev8qi */

                    case 1:
                      if (!
#line 3097 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2007; /* neon_sudot_laneqv8qi */

                    default:
                      return -1;
                    }

                case E_V4SImode:
                  switch (pattern513 (x2, 
E_V4SImode, 
E_V16QImode))
                    {
                    case 0:
                      if (!
#line 3082 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2005; /* neon_sudot_lanev16qi */

                    case 1:
                      if (!
#line 3097 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_I8MM))
                        return -1;
                      return 2009; /* neon_sudot_laneqv16qi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode))
        return -1;
      if (
#line 615 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
        return 965; /* *thumb1_movdi_insn */
      if (!
#line 41 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], DImode)
       || register_operand (operands[1], DImode))))
        return -1;
      return 1084; /* *neon_movdi */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode)
          || !
#line 697 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode))))
        return -1;
      return 966; /* *thumb1_movsi_insn */

    case E_HImode:
      if (nonimmediate_operand (operands[0], E_HImode)
          && general_operand (operands[1], E_HImode))
        {
          if (
#line 838 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], HImode)
       || register_operand (operands[1], HImode))))
            return 967; /* *thumb1_movhi_insn */
          if (
#line 289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2
  && (register_operand (operands[0], HImode)
     || register_operand (operands[1], HImode))))
            return 1016; /* *thumb2_movhi_insn */
        }
      if (pnum_clobbers == NULL
          || !low_register_operand (operands[0], E_HImode)
          || !const_int_operand (operands[1], E_HImode)
          || !
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 1055; /* *thumb2_movhi_shortim */

    case E_QImode:
      if (nonimmediate_operand (operands[0], E_QImode)
          && general_operand (operands[1], E_QImode)
          && 
#line 895 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], QImode)
       || register_operand (operands[1], QImode))))
        return 968; /* *thumb1_movqi_insn */
      if (pnum_clobbers == NULL
          || !low_register_operand (operands[0], E_QImode)
          || !const_int_operand (operands[1], E_QImode)
          || !
#line 1289 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 1054; /* *thumb2_movqi_shortim */

    case E_HFmode:
      if (!nonimmediate_operand (operands[0], E_HFmode)
          || !general_operand (operands[1], E_HFmode)
          || !
#line 913 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (	  s_register_operand (operands[0], HFmode)
       || s_register_operand (operands[1], HFmode))))
        return -1;
      return 969; /* *thumb1_movhf */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode)
          || !
#line 969 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], SFmode)
       || register_operand (operands[1], SFmode))))
        return -1;
      return 970; /* *thumb1_movsf_insn */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 993 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (   register_operand (operands[0], DFmode)
       || register_operand (operands[1], DFmode))))
        return -1;
      return 971; /* *thumb_movdf_insn */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 41 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V8QImode)
       || register_operand (operands[1], V8QImode))))
        return -1;
      return 1078; /* *neon_movv8qi */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 41 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V4HImode)
       || register_operand (operands[1], V4HImode))))
        return -1;
      return 1079; /* *neon_movv4hi */

    case E_V4HFmode:
      if (!nonimmediate_operand (operands[0], E_V4HFmode)
          || !general_operand (operands[1], E_V4HFmode)
          || !
#line 41 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V4HFmode)
       || register_operand (operands[1], V4HFmode))))
        return -1;
      return 1080; /* *neon_movv4hf */

    case E_V4BFmode:
      if (!nonimmediate_operand (operands[0], E_V4BFmode)
          || !general_operand (operands[1], E_V4BFmode)
          || !
#line 41 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V4BFmode)
       || register_operand (operands[1], V4BFmode))))
        return -1;
      return 1081; /* *neon_movv4bf */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 41 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[1], V2SImode))))
        return -1;
      return 1082; /* *neon_movv2si */

    case E_V2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !general_operand (operands[1], E_V2SFmode)
          || !
#line 41 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[1], V2SFmode))))
        return -1;
      return 1083; /* *neon_movv2sf */

    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !general_operand (operands[1], E_V16QImode))
        return -1;
      if (
#line 88 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[1], V16QImode))))
        return 1085; /* *neon_movv16qi */
      if (!
#line 23 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3243; /* mve_movv16qi */

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !general_operand (operands[1], E_V8HImode))
        return -1;
      if (
#line 88 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[1], V8HImode))))
        return 1086; /* *neon_movv8hi */
      if (!
#line 23 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3244; /* mve_movv8hi */

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !general_operand (operands[1], E_V8HFmode))
        return -1;
      if (
#line 88 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[1], V8HFmode))))
        return 1087; /* *neon_movv8hf */
      if (!
#line 23 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3248; /* mve_movv8hf */

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !general_operand (operands[1], E_V8BFmode)
          || !
#line 88 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[1], V8BFmode))))
        return -1;
      return 1088; /* *neon_movv8bf */

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !general_operand (operands[1], E_V4SImode))
        return -1;
      if (
#line 88 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[1], V4SImode))))
        return 1089; /* *neon_movv4si */
      if (!
#line 23 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3245; /* mve_movv4si */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !general_operand (operands[1], E_V4SFmode))
        return -1;
      if (
#line 88 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[1], V4SFmode))))
        return 1090; /* *neon_movv4sf */
      if (!
#line 23 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3249; /* mve_movv4sf */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode))
        return -1;
      if (
#line 88 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[1], V2DImode))))
        return 1091; /* *neon_movv2di */
      if (!
#line 23 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3246; /* mve_movv2di */

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || !general_operand (operands[1], E_TImode))
        return -1;
      if (
#line 88 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON
   && (register_operand (operands[0], TImode)
       || register_operand (operands[1], TImode))))
        return 1092; /* *neon_movti */
      if (!
#line 23 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3247; /* mve_movti */

    case E_EImode:
      if (!nonimmediate_operand (operands[0], E_EImode)
          || !general_operand (operands[1], E_EImode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], EImode)
       || register_operand (operands[1], EImode))) && 
#line 141 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(!TARGET_HAVE_MVE)))
        return -1;
      return 1093; /* *neon_movei */

    case E_OImode:
      if (!nonimmediate_operand (operands[0], E_OImode)
          || !general_operand (operands[1], E_OImode)
          || !
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], OImode)
       || register_operand (operands[1], OImode))))
        return -1;
      return 1094; /* *neon_movoi */

    case E_CImode:
      if (!nonimmediate_operand (operands[0], E_CImode)
          || !general_operand (operands[1], E_CImode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], CImode)
       || register_operand (operands[1], CImode))) && 
#line 142 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(!TARGET_HAVE_MVE)))
        return -1;
      return 1095; /* *neon_movci */

    case E_XImode:
      if (!nonimmediate_operand (operands[0], E_XImode)
          || !general_operand (operands[1], E_XImode)
          || !
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], XImode)
       || register_operand (operands[1], XImode))))
        return -1;
      return 1096; /* *neon_movxi */

    case E_V2x16QImode:
      if (!nonimmediate_operand (operands[0], E_V2x16QImode)
          || !general_operand (operands[1], E_V2x16QImode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V2x16QImode)
       || register_operand (operands[1], V2x16QImode))) && 
#line 143 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1097; /* *neon_movv2x16qi */

    case E_V2x8HImode:
      if (!nonimmediate_operand (operands[0], E_V2x8HImode)
          || !general_operand (operands[1], E_V2x8HImode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V2x8HImode)
       || register_operand (operands[1], V2x8HImode))) && 
#line 144 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1098; /* *neon_movv2x8hi */

    case E_V2x4SImode:
      if (!nonimmediate_operand (operands[0], E_V2x4SImode)
          || !general_operand (operands[1], E_V2x4SImode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V2x4SImode)
       || register_operand (operands[1], V2x4SImode))) && 
#line 145 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1099; /* *neon_movv2x4si */

    case E_V2x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V2x8HFmode)
          || !general_operand (operands[1], E_V2x8HFmode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V2x8HFmode)
       || register_operand (operands[1], V2x8HFmode))) && 
#line 146 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
        return -1;
      return 1100; /* *neon_movv2x8hf */

    case E_V2x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V2x4SFmode)
          || !general_operand (operands[1], E_V2x4SFmode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V2x4SFmode)
       || register_operand (operands[1], V2x4SFmode))) && 
#line 147 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
        return -1;
      return 1101; /* *neon_movv2x4sf */

    case E_V4x16QImode:
      if (!nonimmediate_operand (operands[0], E_V4x16QImode)
          || !general_operand (operands[1], E_V4x16QImode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V4x16QImode)
       || register_operand (operands[1], V4x16QImode))) && 
#line 148 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1102; /* *neon_movv4x16qi */

    case E_V4x8HImode:
      if (!nonimmediate_operand (operands[0], E_V4x8HImode)
          || !general_operand (operands[1], E_V4x8HImode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V4x8HImode)
       || register_operand (operands[1], V4x8HImode))) && 
#line 149 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1103; /* *neon_movv4x8hi */

    case E_V4x4SImode:
      if (!nonimmediate_operand (operands[0], E_V4x4SImode)
          || !general_operand (operands[1], E_V4x4SImode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V4x4SImode)
       || register_operand (operands[1], V4x4SImode))) && 
#line 150 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE)))
        return -1;
      return 1104; /* *neon_movv4x4si */

    case E_V4x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V4x8HFmode)
          || !general_operand (operands[1], E_V4x8HFmode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V4x8HFmode)
       || register_operand (operands[1], V4x8HFmode))) && 
#line 151 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
        return -1;
      return 1105; /* *neon_movv4x8hf */

    case E_V4x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4SFmode)
          || !general_operand (operands[1], E_V4x4SFmode)
          || !(
#line 184 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
((TARGET_NEON || TARGET_HAVE_MVE)
   && (register_operand (operands[0], V4x4SFmode)
       || register_operand (operands[1], V4x4SFmode))) && 
#line 152 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_HAVE_MVE_FLOAT)))
        return -1;
      return 1106; /* *neon_movv4x4sf */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !general_operand (operands[1], E_V2DFmode)
          || !
#line 23 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE || TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3250; /* mve_movv2df */

    default:
      return -1;
    }
}

 int
recog_305 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern401 (x3, 
E_HFmode) != 0
                  || !
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 825; /* fmahf4 */

            case E_SFmode:
              if (pattern401 (x3, 
E_SFmode) != 0
                  || !
#line 1365 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA ))
                return -1;
              return 826; /* fmasf4 */

            case E_DFmode:
              if (pattern401 (x3, 
E_DFmode) != 0
                  || !(
#line 1365 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return -1;
              return 827; /* fmadf4 */

            case E_V2SFmode:
              if (pattern401 (x3, 
E_V2SFmode) != 0)
                return -1;
              if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH && TARGET_FMA))
                return 1207; /* fmav2sf4 */
              if (!
#line 639 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FMA))
                return -1;
              return 1209; /* fmav2sf4_intrinsic */

            case E_V4SFmode:
              if (pattern401 (x3, 
E_V4SFmode) != 0)
                return -1;
              if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH && TARGET_FMA))
                return 1208; /* fmav4sf4 */
              if (!
#line 639 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FMA))
                return -1;
              return 1210; /* fmav4sf4_intrinsic */

            case E_V8HFmode:
              if (pattern401 (x3, 
E_V8HFmode) != 0
                  || !
#line 650 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V8HF_ARITH))
                return -1;
              return 1211; /* fmav8hf4 */

            case E_V4HFmode:
              if (pattern401 (x3, 
E_V4HFmode) != 0
                  || !
#line 650 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4HF_ARITH))
                return -1;
              return 1212; /* fmav4hf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern402 (x3, 
E_HFmode) != 0
                  || !
#line 1412 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 831; /* *fnmsubhf4 */

            case E_SFmode:
              if (pattern402 (x3, 
E_SFmode) != 0
                  || !
#line 1423 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA ))
                return -1;
              return 832; /* *fnmsubsf4 */

            case E_DFmode:
              if (pattern402 (x3, 
E_DFmode) != 0
                  || !(
#line 1423 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return -1;
              return 833; /* *fnmsubdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern403 (x3, 
E_HFmode) != 0
                  || !
#line 1377 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 828; /* fmsubhf4_fp16 */

            case E_SFmode:
              if (pattern403 (x3, 
E_SFmode) != 0
                  || !
#line 1401 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA ))
                return -1;
              return 829; /* *fmsubsf4 */

            case E_DFmode:
              if (pattern403 (x3, 
E_DFmode) != 0
                  || !(
#line 1401 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return -1;
              return 830; /* *fmsubdf4 */

            case E_V2SFmode:
              if (pattern403 (x3, 
E_V2SFmode) != 0)
                return -1;
              if (
#line 660 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V2SF_ARITH && TARGET_FMA))
                return 1213; /* *fmsubv2sf4 */
              if (!
#line 671 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FMA))
                return -1;
              return 1215; /* fmsubv2sf4_intrinsic */

            case E_V4SFmode:
              if (pattern403 (x3, 
E_V4SFmode) != 0)
                return -1;
              if (
#line 660 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(ARM_HAVE_NEON_V4SF_ARITH && TARGET_FMA))
                return 1214; /* *fmsubv4sf4 */
              if (!
#line 671 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FMA))
                return -1;
              return 1216; /* fmsubv4sf4_intrinsic */

            case E_V8HFmode:
              if (pattern403 (x3, 
E_V8HFmode) != 0
                  || !
#line 682 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
                return -1;
              return 1217; /* fmsubv8hf4_intrinsic */

            case E_V4HFmode:
              if (pattern403 (x3, 
E_V4HFmode) != 0
                  || !
#line 682 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
                return -1;
              return 1218; /* fmsubv4hf4_intrinsic */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern404 (x3, 
E_HFmode) != 0
                  || !
#line 1434 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
                return -1;
              return 834; /* *fnmaddhf4 */

            case E_SFmode:
              if (pattern404 (x3, 
E_SFmode) != 0
                  || !
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA ))
                return -1;
              return 835; /* *fnmaddsf4 */

            case E_DFmode:
              if (pattern404 (x3, 
E_DFmode) != 0
                  || !(
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE)))
                return -1;
              return 836; /* *fnmadddf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != FLOAT_EXTEND)
        return -1;
      x6 = XEXP (x3, 2);
      operands[1] = x6;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case VEC_SELECT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          x10 = XEXP (x8, 1);
          operands[4] = x10;
          x11 = XEXP (x5, 0);
          switch (pattern405 (x11))
            {
            case 0:
              if (pattern516 (x3, 
E_V2SFmode, 
E_V4HFmode, 
E_V2HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V4HFmode)
                  && vect_par_constant_low (operands[5], E_V4HFmode)
                  && 
#line 1738 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return 1536; /* vfmal_lowv2sf_intrinsic */
              if (!vect_par_constant_high (operands[4], E_V4HFmode)
                  || !vect_par_constant_high (operands[5], E_V4HFmode)
                  || !
#line 1773 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return -1;
              return 1540; /* vfmal_highv2sf_intrinsic */

            case 1:
              if (pattern516 (x3, 
E_V4SFmode, 
E_V8HFmode, 
E_V4HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V8HFmode)
                  && vect_par_constant_low (operands[5], E_V8HFmode)
                  && 
#line 1738 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return 1537; /* vfmal_lowv4sf_intrinsic */
              if (!vect_par_constant_high (operands[4], E_V8HFmode)
                  || !vect_par_constant_high (operands[5], E_V8HFmode)
                  || !
#line 1773 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return -1;
              return 1541; /* vfmal_highv4sf_intrinsic */

            case 2:
              if (pattern587 (x3, 
E_V2SFmode, 
E_V2HFmode, 
E_V4HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V4HFmode))
                {
                  switch (GET_MODE (operands[3]))
                    {
                    case E_V4HFmode:
                      if (s_register_operand (operands[3], E_V4HFmode)
                          && 
#line 1828 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1544; /* vfmal_lane_lowv2sf_intrinsic */
                      break;

                    case E_V8HFmode:
                      if (s_register_operand (operands[3], E_V8HFmode)
                          && 
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1546; /* vfmal_lane_lowv8hfv2sf_intrinsic */
                      break;

                    default:
                      break;
                    }
                }
              if (!vect_par_constant_high (operands[4], E_V4HFmode))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V8HFmode:
                  if (!s_register_operand (operands[3], E_V8HFmode)
                      || !
#line 1921 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1548; /* vfmal_lane_highv8hfv2sf_intrinsic */

                case E_V4HFmode:
                  if (!s_register_operand (operands[3], E_V4HFmode)
                      || !
#line 1950 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1550; /* vfmal_lane_highv2sf_intrinsic */

                default:
                  return -1;
                }

            case 3:
              if (pattern587 (x3, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V8HFmode))
                {
                  switch (GET_MODE (operands[3]))
                    {
                    case E_V8HFmode:
                      if (s_register_operand (operands[3], E_V8HFmode)
                          && 
#line 1828 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1545; /* vfmal_lane_lowv4sf_intrinsic */
                      break;

                    case E_V4HFmode:
                      if (s_register_operand (operands[3], E_V4HFmode)
                          && 
#line 1884 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1547; /* vfmal_lane_lowv4hfv4sf_intrinsic */
                      break;

                    default:
                      break;
                    }
                }
              if (!vect_par_constant_high (operands[4], E_V8HFmode))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V4HFmode:
                  if (!s_register_operand (operands[3], E_V4HFmode)
                      || !
#line 1921 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1549; /* vfmal_lane_highv4hfv4sf_intrinsic */

                case E_V8HFmode:
                  if (!s_register_operand (operands[3], E_V8HFmode)
                      || !
#line 1950 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1551; /* vfmal_lane_highv4sf_intrinsic */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case NEG:
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != VEC_SELECT)
            return -1;
          x12 = XEXP (x9, 0);
          operands[2] = x12;
          x13 = XEXP (x9, 1);
          operands[4] = x13;
          x11 = XEXP (x5, 0);
          switch (pattern405 (x11))
            {
            case 0:
              if (pattern537 (x3, 
E_V2SFmode, 
E_V4HFmode, 
E_V2HFmode) != 0)
                return -1;
              if (vect_par_constant_high (operands[4], E_V4HFmode)
                  && vect_par_constant_high (operands[5], E_V4HFmode)
                  && 
#line 1756 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return 1538; /* vfmsl_highv2sf_intrinsic */
              if (!vect_par_constant_low (operands[4], E_V4HFmode)
                  || !vect_par_constant_low (operands[5], E_V4HFmode)
                  || !
#line 1791 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return -1;
              return 1542; /* vfmsl_lowv2sf_intrinsic */

            case 1:
              if (pattern537 (x3, 
E_V4SFmode, 
E_V8HFmode, 
E_V4HFmode) != 0)
                return -1;
              if (vect_par_constant_high (operands[4], E_V8HFmode)
                  && vect_par_constant_high (operands[5], E_V8HFmode)
                  && 
#line 1756 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return 1539; /* vfmsl_highv4sf_intrinsic */
              if (!vect_par_constant_low (operands[4], E_V8HFmode)
                  || !vect_par_constant_low (operands[5], E_V8HFmode)
                  || !
#line 1791 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                return -1;
              return 1543; /* vfmsl_lowv4sf_intrinsic */

            case 2:
              if (pattern591 (x3, 
E_V2SFmode, 
E_V2HFmode, 
E_V4HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V4HFmode))
                {
                  switch (GET_MODE (operands[3]))
                    {
                    case E_V4HFmode:
                      if (s_register_operand (operands[3], E_V4HFmode)
                          && 
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1552; /* vfmsl_lane_lowv2sf_intrinsic */
                      break;

                    case E_V8HFmode:
                      if (s_register_operand (operands[3], E_V8HFmode)
                          && 
#line 2019 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1554; /* vfmsl_lane_lowv8hfv2sf_intrinsic */
                      break;

                    default:
                      break;
                    }
                }
              if (!vect_par_constant_high (operands[4], E_V4HFmode))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V8HFmode:
                  if (!s_register_operand (operands[3], E_V8HFmode)
                      || !
#line 2057 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1556; /* vfmsl_lane_highv8hfv2sf_intrinsic */

                case E_V4HFmode:
                  if (!s_register_operand (operands[3], E_V4HFmode)
                      || !
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1558; /* vfmsl_lane_highv2sf_intrinsic */

                default:
                  return -1;
                }

            case 3:
              if (pattern591 (x3, 
E_V4SFmode, 
E_V4HFmode, 
E_V8HFmode) != 0)
                return -1;
              if (vect_par_constant_low (operands[4], E_V8HFmode))
                {
                  switch (GET_MODE (operands[3]))
                    {
                    case E_V8HFmode:
                      if (s_register_operand (operands[3], E_V8HFmode)
                          && 
#line 1981 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1553; /* vfmsl_lane_lowv4sf_intrinsic */
                      break;

                    case E_V4HFmode:
                      if (s_register_operand (operands[3], E_V4HFmode)
                          && 
#line 2019 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                        return 1555; /* vfmsl_lane_lowv4hfv4sf_intrinsic */
                      break;

                    default:
                      break;
                    }
                }
              if (!vect_par_constant_high (operands[4], E_V8HFmode))
                return -1;
              switch (GET_MODE (operands[3]))
                {
                case E_V4HFmode:
                  if (!s_register_operand (operands[3], E_V4HFmode)
                      || !
#line 2057 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1557; /* vfmsl_lane_highv4hfv4sf_intrinsic */

                case E_V8HFmode:
                  if (!s_register_operand (operands[3], E_V8HFmode)
                      || !
#line 2087 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_FP16FML))
                    return -1;
                  return 1559; /* vfmsl_lane_highv4sf_intrinsic */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_316 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SS_TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SS_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern309 (x3))
        {
        case 0:
          if (!
#line 946 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 615; /* iwmmxt_wpackhss */

        case 1:
          if (!
#line 957 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 616; /* iwmmxt_wpackwss */

        case 2:
          if (!
#line 968 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 617; /* iwmmxt_wpackdss */

        default:
          return -1;
        }

    case US_TRUNCATE:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != US_TRUNCATE)
            return -1;
          switch (pattern309 (x3))
            {
            case 0:
              if (!
#line 979 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 618; /* iwmmxt_wpackhus */

            case 1:
              if (!
#line 990 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 619; /* iwmmxt_wpackwus */

            case 2:
              if (!
#line 1001 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return -1;
              return 620; /* iwmmxt_wpackdus */

            default:
              return -1;
            }

        case SS_PLUS:
          if (GET_MODE (x6) != E_V4HImode)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != ZERO_EXTEND
              || GET_MODE (x7) != E_V4HImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != VEC_SELECT
              || GET_MODE (x8) != E_V4QImode)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 4)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x12 = XVECEXP (x9, 0, 2);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x13 = XVECEXP (x9, 0, 3);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST_VECTOR
              || XVECLEN (x5, 0) != 4
              || pattern472 (x5, 
E_V4QImode) != 0
              || !register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || GET_MODE (x4) != E_V4QImode)
            return -1;
          x14 = XEXP (x6, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          x15 = XEXP (x8, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_V8QImode)
              || !
#line 433 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
            return -1;
          return 715; /* iwmmxt_waddbhusl */

        default:
          return -1;
        }

    case CONST_VECTOR:
      if (XVECLEN (x4, 0) != 4
          || GET_MODE (x4) != E_V4QImode)
        return -1;
      x16 = XVECEXP (x4, 0, 0);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x17 = XVECEXP (x4, 0, 1);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x18 = XVECEXP (x4, 0, 2);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x4, 0, 3);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x3, 1);
      if (pattern321 (x5, 
E_V4HImode, 
SS_PLUS, 
E_V4QImode, 
US_TRUNCATE) != 0)
        return -1;
      x20 = XEXP (x5, 0);
      x21 = XEXP (x20, 1);
      if (pattern536 (x21, 
E_V4QImode, 
E_V4HImode, 
ZERO_EXTEND) != 0)
        return -1;
      x22 = XEXP (x21, 0);
      x23 = XEXP (x22, 1);
      if (GET_CODE (x23) != PARALLEL
          || XVECLEN (x23, 0) != 4)
        return -1;
      x24 = XVECEXP (x23, 0, 0);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x25 = XVECEXP (x23, 0, 1);
      if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x26 = XVECEXP (x23, 0, 2);
      if (x26 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x27 = XVECEXP (x23, 0, 3);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || !register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode)
        return -1;
      x28 = XEXP (x20, 0);
      operands[1] = x28;
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      x29 = XEXP (x22, 0);
      operands[2] = x29;
      if (!register_operand (operands[2], E_V8QImode)
          || !
#line 417 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 714; /* iwmmxt_waddbhusm */

    case REG:
    case SUBREG:
      switch (pattern11 (x3))
        {
        case 0:
          if (!
#line 3660 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2097; /* neon_vcombinev8qi */

        case 1:
          if (!
#line 3660 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2098; /* neon_vcombinev4hi */

        case 2:
          if (!
#line 3660 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2099; /* neon_vcombinev4hf */

        case 3:
          if (!
#line 3660 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2100; /* neon_vcombinev4bf */

        case 4:
          if (!
#line 3660 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2101; /* neon_vcombinev2si */

        case 5:
          if (!
#line 3660 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2102; /* neon_vcombinev2sf */

        case 6:
          if (!
#line 3660 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2103; /* neon_vcombinedi */

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != TRUNCATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x20 = XEXP (x5, 0);
      operands[2] = x20;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern308 (x3, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
              || !
#line 6580 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3010; /* vec_pack_trunc_v8hi */

        case E_V8HImode:
          if (pattern308 (x3, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
              || !
#line 6580 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3011; /* vec_pack_trunc_v4si */

        case E_V4SImode:
          if (pattern308 (x3, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
              || !
#line 6580 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN))
            return -1;
          return 3012; /* vec_pack_trunc_v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !s_register_operand (operands[1], E_SImode)
          || !
#line 12384 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch6))
        return -1;
      return 411; /* *arm_rev */

    case E_HImode:
      if (!s_register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !s_register_operand (operands[1], E_HImode)
          || !
#line 12569 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch6))
        return -1;
      return 413; /* *arm_rev16 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 2865 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1927; /* neon_bswapv4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 2865 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1928; /* neon_bswapv8hi */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 2865 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1929; /* neon_bswapv2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 2865 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1930; /* neon_bswapv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2865 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1931; /* neon_bswapv2di */

    default:
      return -1;
    }
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_V8QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFTRT
      || GET_MODE (x4) != E_TImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SUBREG
      || maybe_ne (SUBREG_BYTE (x5), 0)
      || GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_CONCAT
      || GET_MODE (x6) != E_V16QImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != MULT
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != ZERO_EXTRACT
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x10 = XEXP (x8, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XEXP (x7, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x12 = XEXP (x2, 0);
  operands[0] = x12;
  if (!register_operand (operands[0], E_V8QImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[1] = x13;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x14 = XEXP (x6, 1);
  operands[2] = x14;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  x15 = XEXP (x1, 0);
  operands[4] = x15;
  x16 = XEXP (x15, 0);
  operands[5] = x16;
  x17 = XEXP (x8, 0);
  operands[3] = x17;
  if (register_operand (operands[3], E_SImode)
      && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1656 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
    return 6812; /* *p iwmmxt_walignr */
  if (GET_CODE (x17) != REG)
    return -1;
  operands[3] = x15;
  operands[4] = x16;
  if (GET_MODE (x17) != E_SImode)
    return -1;
  switch (REGNO (x17))
    {
    case 96:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1671 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6813; /* *p iwmmxt_walignr0 */

    case 97:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1686 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6814; /* *p iwmmxt_walignr1 */

    case 98:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1701 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6815; /* *p iwmmxt_walignr2 */

    case 99:
      if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1716 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6816; /* *p iwmmxt_walignr3 */

    default:
      return -1;
    }
}

 int
recog_338 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 3:
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      switch (XINT (x4, 1))
        {
        case 79:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2792 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
            return 6434; /* *p arm_smlawb_insn */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2792 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ)))
            return -1;
          return 6435; /* *p arm_smlawb_setq_insn */

        case 80:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2792 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
            return 6436; /* *p arm_smlawt_insn */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2792 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ)))
            return -1;
          return 6437; /* *p arm_smlawt_setq_insn */

        case 74:
          if (pattern439 (x1, 
E_SImode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6077 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6527; /* *p arm_usada8 */

        case 75:
          if (pattern439 (x1, 
E_DImode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6088 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6528; /* *p arm_smlald */

        case 76:
          if (pattern439 (x1, 
E_DImode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6088 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6529; /* *p arm_smlaldx */

        case 77:
          if (pattern439 (x1, 
E_DImode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6088 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6530; /* *p arm_smlsld */

        case 78:
          if (pattern439 (x1, 
E_DImode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6088 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6531; /* *p arm_smlsldx */

        case 94:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
            return 6544; /* *p arm_smlad_insn */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
            return -1;
          return 6545; /* *p arm_smlad_setq_insn */

        case 95:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
            return 6546; /* *p arm_smladx_insn */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
            return -1;
          return 6547; /* *p arm_smladx_setq_insn */

        case 96:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
            return 6548; /* *p arm_smlsd_insn */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
            return -1;
          return 6549; /* *p arm_smlsd_setq_insn */

        case 97:
          if (pattern439 (x1, 
E_SImode) != 0)
            return -1;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
            return 6550; /* *p arm_smlsdx_insn */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ)))
            return -1;
          return 6551; /* *p arm_smlsdx_setq_insn */

        case 81:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 105
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          if (!s_register_operand (operands[0], E_SImode)
              || !s_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          operands[2] = x9;
          if (!s_register_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6560; /* *p arm_sel */

        case 2:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x1, 0);
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          if (!register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          x6 = XVECEXP (x4, 0, 2);
          operands[2] = x6;
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6755 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM)))
            return -1;
          return 6563; /* *p pic_add_dot_plus_eight */

        case 11:
          if (pattern440 (x1) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 518 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6707; /* *p iwmmxt_wmacs */

        case 12:
          if (pattern440 (x1) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 539 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6709; /* *p iwmmxt_wmacu */

        case 9:
          if (GET_MODE (x4) != E_V2SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          if (!register_operand (operands[0], E_V2SImode)
              || !register_operand (operands[1], E_V2SImode))
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          operands[2] = x9;
          x6 = XVECEXP (x4, 0, 2);
          operands[3] = x6;
          switch (GET_MODE (operands[2]))
            {
            case E_V8QImode:
              if (!register_operand (operands[2], E_V8QImode)
                  || !register_operand (operands[3], E_V8QImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1728 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6817; /* *p iwmmxt_wsadb */

            case E_V4HImode:
              if (!register_operand (operands[2], E_V4HImode)
                  || !register_operand (operands[3], E_V4HImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1740 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6818; /* *p iwmmxt_wsadh */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      switch (XINT (x4, 1))
        {
        case 30:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 104
              || GET_MODE (x5) != E_CCmode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[1] = x7;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4419 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM_QBIT)))
            return -1;
          return 6460; /* *p arm_get_apsr */

        case 25:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!mem_and_no_t1_wback_op (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5016 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(unaligned_access)))
            return -1;
          return 6470; /* *p unaligned_loadsi */

        case 26:
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!mem_and_no_t1_wback_op (operands[0], E_SImode)
                  || GET_MODE (x4) != E_SImode
                  || !s_register_operand (operands[1], E_SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5072 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(unaligned_access)))
                return -1;
              return 6473; /* *p unaligned_storesi */

            case E_HImode:
              if (!mem_and_no_t1_wback_op (operands[0], E_HImode)
                  || GET_MODE (x4) != E_HImode
                  || !s_register_operand (operands[1], E_HImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5087 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(unaligned_access)))
                return -1;
              return 6474; /* *p unaligned_storehi */

            default:
              return -1;
            }

        case 45:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6056 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6496; /* *p arm_sxtb16 */

        case 46:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6056 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD)))
            return -1;
          return 6497; /* *p arm_uxtb16 */

        case 38:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x1, 0);
          operands[1] = x7;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!memory_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9262 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6576; /* *p probe_stack */

        case 22:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12201 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2)))
            return -1;
          return 6596; /* *p arm_rbit */

        case 17:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x1, 0);
          operands[1] = x7;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!register_operand (operands[0], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12292 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_HARD_TP)))
            return -1;
          return 6597; /* *p load_tp_hard */

        case 15:
          if (GET_MODE (x4) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x7 = XEXP (x1, 0);
          operands[1] = x7;
          x8 = XEXP (x7, 0);
          operands[2] = x8;
          if (!register_operand (operands[0], E_DImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 560 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6711; /* *p iwmmxt_clrdi */

        case 8:
          switch (pattern409 (x1, 
E_SImode))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1579 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6805; /* *p iwmmxt_tmovmskb */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1588 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6806; /* *p iwmmxt_tmovmskh */

            case 2:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1597 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6807; /* *p iwmmxt_tmovmskw */

            default:
              return -1;
            }

        case 7:
          switch (pattern409 (x1, 
E_DImode))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1606 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6808; /* *p iwmmxt_waccb */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1615 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6809; /* *p iwmmxt_wacch */

            case 2:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1624 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6810; /* *p iwmmxt_waccw */

            default:
              return -1;
            }

        case 16:
          if (GET_MODE (x4) != E_V8QImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != SUBREG
              || maybe_ne (SUBREG_BYTE (x5), 0)
              || GET_MODE (x5) != E_V8QImode)
            return -1;
          x10 = XEXP (x5, 0);
          if (GET_CODE (x10) != ASHIFTRT
              || GET_MODE (x10) != E_TImode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SUBREG
              || maybe_ne (SUBREG_BYTE (x11), 0)
              || GET_MODE (x11) != E_TImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != VEC_CONCAT
              || GET_MODE (x12) != E_V16QImode)
            return -1;
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != MULT
              || GET_MODE (x13) != E_SImode)
            return -1;
          x14 = XEXP (x13, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x1, 0);
          operands[4] = x7;
          x8 = XEXP (x7, 0);
          operands[5] = x8;
          if (!register_operand (operands[0], E_V8QImode))
            return -1;
          x15 = XEXP (x12, 0);
          operands[1] = x15;
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          x16 = XEXP (x12, 1);
          operands[2] = x16;
          if (!register_operand (operands[2], E_V8QImode))
            return -1;
          x17 = XEXP (x13, 0);
          operands[3] = x17;
          if (!immediate_operand (operands[3], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1641 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6811; /* *p iwmmxt_waligni */

        case 109:
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (!register_operand (operands[0], E_V2SImode)
                  || GET_MODE (x4) != E_V2SImode
                  || !register_operand (operands[1], E_V2SImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 24 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6821; /* *p iwmmxt_wabsv2si3 */

            case E_V4HImode:
              if (!register_operand (operands[0], E_V4HImode)
                  || GET_MODE (x4) != E_V4HImode
                  || !register_operand (operands[1], E_V4HImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 24 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6822; /* *p iwmmxt_wabsv4hi3 */

            case E_V8QImode:
              if (!register_operand (operands[0], E_V8QImode)
                  || GET_MODE (x4) != E_V8QImode
                  || !register_operand (operands[1], E_V8QImode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 24 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6823; /* *p iwmmxt_wabsv8qi3 */

            default:
              return -1;
            }

        case 108:
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != PLUS)
            return -1;
          x7 = XEXP (x1, 0);
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x18 = XEXP (x5, 1);
          operands[2] = x18;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern557 (x4, 
E_V4HImode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 111 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6829; /* *p addcv4hi3 */

            case E_V2SImode:
              if (pattern557 (x4, 
E_V2SImode) != 0
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 111 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6830; /* *p addcv2si3 */

            default:
              return -1;
            }

        case 32:
          switch (pattern410 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 )))
                return -1;
              return 6968; /* *p btruncsf2 */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6971; /* *p btruncdf2 */

            default:
              return -1;
            }

        case 35:
          switch (pattern410 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 )))
                return -1;
              return 6969; /* *p nearbyintsf2 */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6972; /* *p nearbyintdf2 */

            default:
              return -1;
            }

        case 36:
          switch (pattern410 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 )))
                return -1;
              return 6970; /* *p rintsf2 */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 2040 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_HARD_FLOAT && TARGET_VFP5 && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6973; /* *p rintdf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_336 (x1, insn, pnum_clobbers);

    case 5:
      x9 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x9) != ZERO_EXTRACT
          || GET_MODE (x9) != E_V4HImode)
        return -1;
      x19 = XEXP (x9, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x20 = XEXP (x9, 2);
      if (GET_CODE (x20) != CONST_INT)
        return -1;
      x6 = XVECEXP (x4, 0, 2);
      if (GET_CODE (x6) != ZERO_EXTRACT
          || GET_MODE (x6) != E_V4HImode)
        return -1;
      x21 = XEXP (x6, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x22 = XEXP (x6, 2);
      if (GET_CODE (x22) != CONST_INT)
        return -1;
      x23 = XVECEXP (x4, 0, 3);
      if (GET_CODE (x23) != ZERO_EXTRACT
          || GET_MODE (x23) != E_V4HImode)
        return -1;
      x24 = XEXP (x23, 1);
      if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x25 = XEXP (x23, 2);
      if (GET_CODE (x25) != CONST_INT)
        return -1;
      x26 = XVECEXP (x4, 0, 4);
      if (GET_CODE (x26) != ZERO_EXTRACT
          || GET_MODE (x26) != E_V4HImode)
        return -1;
      x27 = XEXP (x26, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x28 = XEXP (x26, 2);
      if (GET_CODE (x28) != CONST_INT)
        return -1;
      x7 = XEXP (x1, 0);
      operands[4] = x7;
      x8 = XEXP (x7, 0);
      operands[5] = x8;
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x4) != E_V2SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      x29 = XEXP (x9, 0);
      operands[2] = x29;
      if (!register_operand (operands[2], E_V4HImode))
        return -1;
      x30 = XEXP (x23, 0);
      operands[3] = x30;
      if (!register_operand (operands[3], E_V4HImode))
        return -1;
      x31 = XEXP (x6, 0);
      if (!rtx_equal_p (x31, operands[2]))
        return -1;
      x32 = XEXP (x26, 0);
      if (!rtx_equal_p (x32, operands[3]))
        return -1;
      switch (XINT (x4, 1))
        {
        case 115:
          switch (pattern639 (x4))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 446 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6850; /* *p iwmmxt_wqmiabb */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6851; /* *p iwmmxt_wqmiabt */

            case 2:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 472 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6852; /* *p iwmmxt_wqmiatb */

            case 3:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 485 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6853; /* *p iwmmxt_wqmiatt */

            default:
              return -1;
            }

        case 114:
          switch (pattern639 (x4))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 498 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6854; /* *p iwmmxt_wqmiabbn */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 511 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6855; /* *p iwmmxt_wqmiabtn */

            case 2:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 524 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6856; /* *p iwmmxt_wqmiatbn */

            case 3:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 537 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6857; /* *p iwmmxt_wqmiattn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  if (s_register_operand (operands[0], E_SImode))
    {
      res = recog_359 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!low_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x4, 0, 1);
  if (pattern474 (x7) != 0)
    return -1;
  x8 = XEXP (x5, 1);
  operands[3] = x8;
  if (!shift_operator (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!low_register_operand (operands[1], E_SImode))
    return -1;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  if (!low_reg_or_int_operand (operands[2], E_SImode)
      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && ((GET_CODE(operands[3]) != ROTATE && GET_CODE(operands[3]) != ROTATERT)
       || REG_P (operands[2])))))
    return -1;
  return 6983; /* *p *thumb2_shiftsi3_short */
}

 int
recog_366 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x5, 1);
  if (!s_register_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  switch (GET_CODE (x8))
    {
    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      operands[1] = x9;
      if (ldrd_strd_offset_operand (operands[1], E_SImode))
        {
          res = recog_365 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x9, 0) != -4L)
        return -1;
      x10 = XEXP (x1, 0);
      operands[3] = x10;
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      x12 = XEXP (x8, 0);
      operands[0] = x12;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x13 = XEXP (x3, 1);
      operands[1] = x13;
      operands[2] = x7;
      x14 = XEXP (x6, 0);
      if (!rtx_equal_p (x14, operands[0])
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12793 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[1], operands[2],
                                  operands[0], -4, false, false)))))
        return -1;
      return 6615; /* *p *thumb2_strd_base_neg */

    case REG:
    case SUBREG:
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x14 = XEXP (x6, 0);
      if (GET_CODE (x14) != PLUS
          || GET_MODE (x14) != E_SImode)
        return -1;
      x15 = XEXP (x14, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x10 = XEXP (x1, 0);
      operands[3] = x10;
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      x13 = XEXP (x3, 1);
      operands[1] = x13;
      operands[2] = x7;
      x16 = XEXP (x14, 0);
      if (!rtx_equal_p (x16, operands[0])
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12780 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[1], operands[2],
                                  operands[0], 0, false, false)))))
        return -1;
      return 6614; /* *p *thumb2_strd_base */

    default:
      return -1;
    }
}

 int
recog_376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case COMPARE:
      return recog_306 (x1, insn, pnum_clobbers);

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      return recog_307 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_300 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_317 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_308 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          switch (GET_CODE (x3))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              res = recog_278 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[5] = x3;
          if (!comparison_operator (operands[5], E_VOIDmode))
            return -1;
          x4 = XEXP (x3, 0);
          if (GET_CODE (x4) != PLUS
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XEXP (x1, 0);
          operands[0] = x6;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[3] = x7;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x4, 1);
          operands[4] = x8;
          if (!arm_add_operand (operands[4], E_SImode))
            return -1;
          x9 = XEXP (x2, 1);
          operands[1] = x9;
          if (!arm_rhs_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x2, 2);
          operands[2] = x10;
          if (!arm_rhs_operand (operands[2], E_SImode)
              || !
#line 10767 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 350; /* movcond_addsi */

        default:
          return -1;
        }

    case SMIN:
    case SMAX:
    case UMIN:
    case UMAX:
      return recog_311 (x1, insn, pnum_clobbers);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      switch (GET_CODE (x2))
        {
        case PLUS:
          res = recog_284 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case MINUS:
          res = recog_287 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case AND:
          res = recog_288 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case IOR:
          res = recog_289 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case XOR:
          res = recog_290 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_291 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_MODE (x2) == E_SImode)
        {
          res = recog_292 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL)
        return -1;
      if (s_register_operand (operands[0], E_SImode))
        {
          res = recog_293 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (GET_CODE (x2))
        {
        case PLUS:
        case AND:
          operands[5] = x2;
          if (shiftable_operator_strict_it (operands[5], E_SImode))
            {
              x3 = XEXP (x2, 0);
              if (arm_comparison_operator (x3, E_SImode))
                {
                  operands[4] = x3;
                  if (s_register_operand (operands[0], E_SImode))
                    {
                      x4 = XEXP (x3, 0);
                      operands[2] = x4;
                      if (s_register_operand (operands[2], E_SImode))
                        {
                          x5 = XEXP (x3, 1);
                          operands[3] = x5;
                          if (arm_rhs_operand (operands[3], E_SImode))
                            {
                              x9 = XEXP (x2, 1);
                              operands[1] = x9;
                              if (s_register_operand (operands[1], E_SImode)
                                  && 
#line 798 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it))
                                {
                                  *pnum_clobbers = 1;
                                  return 1037; /* *thumb2_cond_arith_strict_it */
                                }
                            }
                        }
                    }
                }
            }
          if (GET_CODE (x2) != PLUS
              || GET_MODE (x2) != E_SImode
              || !low_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 0);
          operands[1] = x3;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x2, 1);
          operands[2] = x9;
          if (!low_reg_or_int_operand (operands[2], E_SImode)
              || !
#line 1301 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1057; /* *thumb2_addsi_short */

        case MINUS:
          if (GET_MODE (x2) != E_SImode
              || !low_register_operand (operands[0], E_SImode))
            return -1;
          x3 = XEXP (x2, 0);
          operands[1] = x3;
          if (!low_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x2, 1);
          operands[2] = x9;
          if (!low_register_operand (operands[2], E_SImode)
              || !
#line 1330 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1058; /* *thumb2_subsi_short */

        default:
          return -1;
        }

    case SS_PLUS:
      return recog_318 (x1, insn, pnum_clobbers);

    case SS_MINUS:
      return recog_319 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_301 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_313 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_315 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_312 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      operands[2] = x9;
      if (pattern276 (x1) == 0
          && 
#line 5104 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && IN_RANGE (INTVAL (operands[3]), 0, 31)
   && IN_RANGE (INTVAL (operands[2]), 1, 32 - INTVAL (operands[3]))))
        return 164; /* *extv_reg */
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      switch (XWINT (x9, 0))
        {
        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          x10 = XEXP (x2, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 11839 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          *pnum_clobbers = 1;
          return 382; /* *sign_extract_onebit */

        case 8L:
          x10 = XEXP (x2, 2);
          if (GET_CODE (x10) != CONST_INT)
            return -1;
          switch (XWINT (x10, 0))
            {
            case 8L:
              if (!
#line 12688 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                return -1;
              return 420; /* *arm_signextractsi2_8_8 */

            case 16L:
              if (!
#line 12698 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                return -1;
              return 421; /* *arm_signextractsi2_8_16 */

            default:
              return -1;
            }

        case 16L:
          x10 = XEXP (x2, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || !
#line 12708 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
            return -1;
          return 422; /* *arm_signextractsi2_16_8 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x9 = XEXP (x2, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      operands[2] = x9;
      if (pattern276 (x1) == 0
          && 
#line 5118 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && IN_RANGE (INTVAL (operands[3]), 0, 31)
   && IN_RANGE (INTVAL (operands[2]), 1, 32 - INTVAL (operands[3]))))
        return 165; /* extzv_t2 */
      x10 = XEXP (x2, 2);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      switch (XWINT (x9, 0))
        {
        case 8L:
          switch (XWINT (x10, 0))
            {
            case 8L:
              if (!
#line 12655 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                return -1;
              return 417; /* *arm_zeroextractsi2_8_8 */

            case 16L:
              if (!
#line 12665 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
                return -1;
              return 418; /* *arm_zeroextractsi2_8_16 */

            default:
              return -1;
            }

        case 16L:
          if (XWINT (x10, 0) != 8L
              || !
#line 12675 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6))
            return -1;
          return 419; /* *arm_zeroextractsi2_16_8 */

        default:
          return -1;
        }

    case DIV:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1 (x2, 
E_SImode) != 0
              || !
#line 5133 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_IDIV))
            return -1;
          return 166; /* divsi3 */

        case E_HFmode:
          if (pattern1 (x2, 
E_HFmode) != 0
              || !
#line 1064 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 801; /* divhf3 */

        case E_SFmode:
          if (pattern1 (x2, 
E_SFmode) != 0
              || !
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 802; /* *divsf3_vfp */

        case E_DFmode:
          if (pattern1 (x2, 
E_DFmode) != 0
              || !
#line 1088 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 803; /* *divdf3_vfp */

        default:
          return -1;
        }

    case UDIV:
      if (pattern3 (x1, 
E_SImode) != 0
          || !
#line 5146 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_IDIV))
        return -1;
      return 167; /* udivsi3 */

    case NEG:
      return recog_309 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_310 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_302 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      if (!general_operand (operands[2], E_SImode)
          || !
#line 6544 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_HAVE_MOVT && arm_valid_symbolic_address_p (operands[2])))
        return -1;
      return 256; /* *arm_movt */

    case CLZ:
      return recog_322 (x1, insn, pnum_clobbers);

    case CTZ:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 12213 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch_thumb2))
        return -1;
      return 401; /* ctzsi2 */

    case BSWAP:
      return recog_324 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_303 (x1, insn, pnum_clobbers);

    case US_PLUS:
      return recog_321 (x1, insn, pnum_clobbers);

    case US_MINUS:
      return recog_320 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_304 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_314 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_316 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_305 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!s_register_operand (operands[1], E_SFmode)
                  || !
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
                return -1;
              return 837; /* *extendsfdf2_vfp */

            case E_HFmode:
              if (!s_register_operand (operands[1], E_HFmode)
                  || !
#line 1494 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_FP16_TO_DOUBLE))
                return -1;
              return 841; /* *extendhfdf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !
#line 1476 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && (TARGET_FP16 || TARGET_VFP_FP16INST)))
            return -1;
          return 839; /* extendhfsf2 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !
#line 1467 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 838; /* *truncdfsf2_vfp */

        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!s_register_operand (operands[1], E_DFmode)
                  || !
#line 1485 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_FP16_TO_DOUBLE))
                return -1;
              return 840; /* *truncdfhf2 */

            case E_SFmode:
              if (!s_register_operand (operands[1], E_SFmode)
                  || !
#line 1503 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && (TARGET_FP16 || TARGET_VFP_FP16INST)))
                return -1;
              return 842; /* truncsfhf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FIX:
      return recog_323 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_325 (x1, insn, pnum_clobbers);

    case FLOAT:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1550 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 847; /* *floatsisf2_vfp */

        case 1:
          if (!
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 848; /* *floatsidf2_vfp */

        case 2:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !flag_rounding_math))
            return -1;
          return 2104; /* floatv2siv2sf2 */

        case 3:
          if (!
#line 3696 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !flag_rounding_math))
            return -1;
          return 2105; /* floatv4siv4sf2 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 1569 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 849; /* floatunssisf2 */

        case 1:
          if (!
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 850; /* floatunssidf2 */

        case 2:
          if (!
#line 3704 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !flag_rounding_math))
            return -1;
          return 2106; /* floatunsv2siv2sf2 */

        case 3:
          if (!
#line 3704 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && !flag_rounding_math))
            return -1;
          return 2107; /* floatunsv4siv4sf2 */

        default:
          return -1;
        }

    case SQRT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x2) != E_HFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !
#line 1590 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
            return -1;
          return 851; /* neon_vsqrthf */

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !s_register_operand (operands[1], E_SFmode)
              || !
#line 1614 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT))
            return -1;
          return 853; /* *sqrtsf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !
#line 1624 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE))
            return -1;
          return 854; /* *sqrtdf2_vfp */

        default:
          return -1;
        }

    case POPCOUNT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x2) != E_V8QImode
              || !s_register_operand (operands[1], E_V8QImode)
              || !
#line 3177 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2028; /* popcountv8qi2 */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode
              || !s_register_operand (operands[1], E_V16QImode)
              || !
#line 3177 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2029; /* popcountv16qi2 */

        default:
          return -1;
        }

    case SS_MULT:
      if (pnum_clobbers == NULL
          || pattern3 (x1, 
E_SAmode) != 0
          || !
#line 264 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ))
        return -1;
      *pnum_clobbers = 3;
      return 3239; /* *arm_ssmulsa3 */

    case US_MULT:
      if (pnum_clobbers == NULL
          || pattern3 (x1, 
E_USAmode) != 0
          || !
#line 336 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ))
        return -1;
      *pnum_clobbers = 3;
      return 3240; /* *arm_usmulusa3 */

    case SS_TRUNCATE:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (!sat_shift_operator (x3, E_SImode))
        return -1;
      operands[1] = x3;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!immediate_operand (operands[3], E_SImode)
          || !
#line 481 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ))
        return -1;
      return 3241; /* arm_ssatsihi_shift */

    case US_TRUNCATE:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!s_register_operand (operands[0], E_HImode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 490 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 3242; /* arm_usatsihi */

    case US_ASHIFT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!arm_low_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !arm_low_register_operand (operands[1], E_DImode)
              || !
#line 4321 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5035; /* mve_uqshll_di */

        case E_SImode:
          if (!arm_general_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !arm_general_register_operand (operands[1], E_SImode)
              || !
#line 4344 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5037; /* mve_uqshl_si */

        default:
          return -1;
        }

    case SS_ASHIFT:
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x9 = XEXP (x2, 1);
      operands[2] = x9;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!arm_general_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !arm_general_register_operand (operands[1], E_DImode)
              || !
#line 4367 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5039; /* mve_sqshl_si */

        case E_DImode:
          if (!arm_low_register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !arm_low_register_operand (operands[1], E_DImode)
              || !
#line 4402 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 5042; /* mve_sqshll_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
