/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !s_register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern19 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern19 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern19 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode))
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 1);
      if (GET_MODE (x8) != E_DImode
          || !mem_noofs_operand (operands[1], E_DImode)
          || !s_register_operand (operands[2], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern34 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern41 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern62 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !s_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern72 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8BImode:
      return pattern62 (x3, 
E_V8BImode, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4BImode:
      if (pattern62 (x3, 
E_V4BImode, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern72 (x3, 
E_V8BImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern72 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_V8QImode:
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !imm_lshift_or_reg_neon (operands[2], i1))
    return -1;
  return 0;
}

int
pattern129 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != FIX
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != FIX
      || GET_MODE (x4) != E_SFmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != FLOAT_EXTEND
      || GET_MODE (x5) != E_SFmode)
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_HFmode))
    return -1;
  x8 = XVECEXP (x2, 0, 1);
  operands[2] = x8;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern142 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i1)
      || !reg_or_zero_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern40 (x3, 
E_V8QImode, 
E_V4HImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern40 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern40 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern40 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 3;

    case E_DImode:
      if (pattern40 (x3, 
E_V2SImode, 
E_DImode) != 0)
        return -1;
      return 4;

    case E_V2DImode:
      if (pattern40 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_OImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern164 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], i2))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode)
          || !vpr_register_operand (operands[2], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode)
          || !vpr_register_operand (operands[2], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode)
          || !vpr_register_operand (operands[2], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern191 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x16QImode:
      return 0;

    case E_V2x8HImode:
      return 1;

    case E_V2x4SImode:
      return 2;

    case E_V2x8HFmode:
      return 3;

    case E_V2x4SFmode:
      return 4;

    default:
      return -1;
    }
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !mve_imm_7 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V16BImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !mve_imm_15 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !mve_imm_31 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V4BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern226 (x3, 
E_V8BImode, 
E_HImode, 
E_V8HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern226 (x3, 
E_V4BImode, 
E_SImode, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern236 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BImode:
          return pattern233 (x1, 
E_V16QImode, 
E_V16BImode); /* [-1, 0] */

        case E_V8BImode:
          if (pattern233 (x1, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 1;

        case E_V4BImode:
          if (pattern233 (x1, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16BImode:
          if (pattern234 (x1, 
E_QImode, 
E_V16QImode, 
E_V16BImode) != 0)
            return -1;
          return 3;

        case E_V8BImode:
          if (pattern234 (x1, 
E_HImode, 
E_V8HImode, 
E_V8BImode) != 0)
            return -1;
          return 4;

        case E_V4BImode:
          if (pattern234 (x1, 
E_SImode, 
E_V4SImode, 
E_V4BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern251 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern255 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!cc_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!s_register_operand (operands[1], E_SImode)
          || !mem_noofs_operand (operands[2], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !arm_add_operand (operands[3], E_SImode)
          || !s_register_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!s_register_operand (operands[1], E_DImode)
          || !mem_noofs_operand (operands[2], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_DImode
          || !cmpdi_operand (operands[3], E_DImode)
          || !s_register_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  if (!arm_comparison_operator (operands[5], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x2) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[3] = x5;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[4] = x6;
  if (!arm_add_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!arm_rhs_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x2, 2);
  operands[2] = x8;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern285 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XINT (x1, 1) != 40
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CC_NZmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_CC_NZmode)
    return -1;
  return 0;
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 19)
    return -1;
  return pattern291 (x1); /* [-1, 3] */
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != 41
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern303 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL
      || XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != VEC_SELECT
      || GET_MODE (x6) != E_V2SImode)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != PARALLEL
      || XVECLEN (x7, 0) != 2)
    return -1;
  return 0;
}

int
pattern309 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern308 (x1, 
E_V4HImode, 
E_V4QImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern308 (x1, 
E_V2SImode, 
E_V2HImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern308 (x1, 
E_DImode, 
E_SImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern319 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern318 (x4, 
E_CCmode, 
100); /* [-1, 0] */
}

int
pattern324 (rtx x1, int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != i4
      || GET_MODE (x6) != i3
      || pattern323 (x1, 
i2, 
i3, 
i4) != 0)
    return -1;
  return 0;
}

int
pattern334 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  return 0;
}

int
pattern339 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[4] = x9;
  if (!mve_imm_32 (operands[4], E_SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  operands[5] = x10;
  x11 = XEXP (x2, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  x14 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x14, operands[4]))
    return -1;
  x15 = XVECEXP (x3, 0, 3);
  if (!rtx_equal_p (x15, operands[5]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern338 (x6, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern338 (x6, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern338 (x6, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[2] = x5;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !mve_memory_operand (operands[1], i2)
      || !vpr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern376 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode)
      || !reg_or_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern381 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i4)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern386 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern399 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern398 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern398 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern398 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (!mem_noofs_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !s_register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern412 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  switch (XWINT (x8, 0))
    {
    case 8L:
      x9 = XEXP (x6, 2);
      switch (XWINT (x9, 0))
        {
        case 8L:
          return 0;

        case 16L:
          return 1;

        default:
          return -1;
        }

    case 16L:
      x9 = XEXP (x6, 2);
      if (XWINT (x9, 0) != 8L)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern424 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !s_register_operand (operands[1], E_HImode))
    return -1;
  return 0;
}

int
pattern432 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!arm_rhs_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern440 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[4] = x4;
  x5 = XEXP (x4, 0);
  operands[5] = x5;
  if (!register_operand (operands[0], E_DImode)
      || !register_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x7 = XVECEXP (x3, 0, 2);
  operands[3] = x7;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  return 0;
}

int
pattern450 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != E_SImode)
    return -1;
  return 0;
}

int
pattern460 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !mve_struct_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern468 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern477 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern482 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || !register_operand (operands[2], E_V16QImode)
      || !register_operand (operands[3], E_V16QImode))
    return -1;
  return 0;
}

int
pattern489 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern495 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (XWINT (x5, 0) != 0L)
    return -1;
  x6 = XEXP (x3, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER
      || pattern450 (x1) != 0)
    return -1;
  return 0;
}

int
pattern501 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!s_register_operand (operands[1], E_TImode)
          || GET_MODE (x1) != i1)
        return -1;
      return 0;

    case E_OImode:
      if (!s_register_operand (operands[1], E_OImode)
          || GET_MODE (x1) != i2)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern511 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern520 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !arm_low_register_operand (operands[0], E_DImode)
      || !arm_low_register_operand (operands[1], E_DImode)
      || !register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern527 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern537 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !s_register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x1, 1);
  return pattern515 (x5, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern546 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern553 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  return 0;
}

int
pattern562 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern572 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern571 (x1) != 0)
    return -1;
  return 0;
}

int
pattern580 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern587 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !s_register_operand (operands[2], i3))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern596 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 28
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 104
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 104
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x1, 0);
  operands[4] = x7;
  x8 = XEXP (x7, 0);
  operands[5] = x8;
  x9 = XVECEXP (x2, 0, 0);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern612 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_DImode)
      || !mem_noofs_operand (operands[1], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_DImode
      || !s_register_operand (operands[2], E_DImode)
      || !scratch_operand (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern621 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern633 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern645 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

int
pattern649 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8L)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode)
      || pattern417 (x1, 
E_CCmode, 
MINUS) != 0)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[2])
      || !
#line 1654 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
    return -1;
  return 26; /* subsi3_compare1 */
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode)
          || pattern288 (x2) != 0)
        return -1;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      if (!arm_rhs_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      switch (pattern548 (x8, 
IOR))
        {
        case 0:
          x9 = XEXP (x8, 0);
          operands[0] = x9;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[1]))
            return -1;
          x12 = XEXP (x10, 1);
          if (!rtx_equal_p (x12, operands[2])
              || !
#line 3782 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 111; /* *iorsi3_compare0 */

        case 1:
          if (!
#line 3797 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          return 112; /* *iorsi3_compare0_scratch */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern384 (x1, 
IOR) != 0
          || !
#line 10530 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 345; /* *ior_scc_scc_cmp */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTRACT:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[3] = x6;
      if (const_int_operand (operands[3], E_SImode)
          && pattern495 (x1) == 0)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (s_register_operand (operands[1], E_SImode))
            {
              x8 = XEXP (x5, 1);
              operands[2] = x8;
              if (const_int_operand (operands[2], E_SImode))
                {
                  x9 = XEXP (x3, 1);
                  operands[4] = x9;
                  if (arm_not_operand (operands[4], E_SImode)
                      && 
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)
   && !reg_overlap_mentioned_p (operands[0], operands[4])))
                    return 96; /* *ite_ne_zeroextractsi */
                }
            }
        }
      if (XWINT (x6, 0) != 0L
          || pattern495 (x1) != 0)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!arm_not_operand (operands[3], E_SImode)
          || !
#line 3221 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !reg_overlap_mentioned_p (operands[0], operands[3])))
        return -1;
      return 97; /* *ite_ne_zeroextractsi_shifted */

    case REG:
    case SUBREG:
      operands[0] = x5;
      if (s_register_operand (operands[0], E_SImode)
          && pattern387 (x1) == 0)
        {
          x9 = XEXP (x3, 1);
          x10 = XEXP (x9, 0);
          operands[1] = x10;
          if (
#line 1491 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return 1065; /* *thumb2_cbnz */
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x5) != REG
          || REGNO (x5) != 14
          || GET_MODE (x5) != E_SImode)
        return -1;
      x11 = XEXP (x4, 1);
      if (XWINT (x11, 0) != 1L)
        return -1;
      x9 = XEXP (x3, 1);
      if (GET_CODE (x9) != LABEL_REF)
        return -1;
      x12 = XEXP (x3, 2);
      if (GET_CODE (x12) != PC)
        return -1;
      x13 = XEXP (x2, 0);
      if (GET_CODE (x13) != PC)
        return -1;
      x14 = XVECEXP (x1, 0, 1);
      if (pattern528 (x14) != 0)
        return -1;
      x15 = XEXP (x14, 1);
      x16 = XEXP (x15, 1);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return -1;
      x17 = XEXP (x14, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 14
          || GET_MODE (x17) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      if (!
#line 1771 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_32BIT && TARGET_HAVE_LOB))
        return -1;
      *pnum_clobbers = 1;
      return 1075; /* *doloop_end_internal */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x9 = XEXP (x5, 1);
  operands[2] = x9;
  x10 = XEXP (x4, 1);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XEXP (x2, 1);
  operands[4] = x11;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[0])
      || !
#line 12765 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && ((INTVAL (operands[1]) + 4) == INTVAL (operands[3]))
     && (operands_ok_ldrd_strd (operands[2], operands[4],
                                  operands[0], INTVAL (operands[1]),
                                  false, false))))
    return -1;
  return 426; /* *thumb2_strd */
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC)
        return -1;
      switch (XINT (x3, 1))
        {
        case 79:
          if (pattern364 (x1) != 0
              || !
#line 2792 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
            return -1;
          return 87; /* arm_smlawb_setq_insn */

        case 80:
          if (pattern364 (x1) != 0
              || !
#line 2792 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ))
            return -1;
          return 89; /* arm_smlawt_setq_insn */

        case 94:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 239; /* arm_smlad_setq_insn */

        case 95:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 241; /* arm_smladx_setq_insn */

        case 96:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 243; /* arm_smlsd_setq_insn */

        case 97:
          if (pattern364 (x1) != 0
              || !
#line 6111 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && ARM_Q_BIT_READ))
            return -1;
          return 245; /* arm_smlsdx_setq_insn */

        case 622:
          switch (pattern365 (x1, 
622))
            {
            case 0:
              if (!
#line 1679 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3958; /* mve_vshlcq_sv16qi */

            case 1:
              if (!
#line 1679 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3960; /* mve_vshlcq_sv8hi */

            case 2:
              if (!
#line 1679 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3962; /* mve_vshlcq_sv4si */

            default:
              return -1;
            }

        case 623:
          switch (pattern365 (x1, 
623))
            {
            case 0:
              if (!
#line 1679 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3959; /* mve_vshlcq_uv16qi */

            case 1:
              if (!
#line 1679 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3961; /* mve_vshlcq_uv8hi */

            case 2:
              if (!
#line 1679 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 3963; /* mve_vshlcq_uv4si */

            default:
              return -1;
            }

        case 1035:
          switch (pattern366 (x1, 
1035))
            {
            case 0:
              if (!
#line 3769 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4954; /* mve_viwdupq_wb_uv16qi_insn */

            case 1:
              if (!
#line 3769 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4956; /* mve_viwdupq_wb_uv8hi_insn */

            case 2:
              if (!
#line 3769 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4958; /* mve_viwdupq_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1031:
          switch (pattern366 (x1, 
1031))
            {
            case 0:
              if (!
#line 3769 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4955; /* mve_vdwdupq_wb_uv16qi_insn */

            case 1:
              if (!
#line 3769 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4957; /* mve_vdwdupq_wb_uv8hi_insn */

            case 2:
              if (!
#line 3769 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4959; /* mve_vdwdupq_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1037:
          if (pattern334 (x2) != 0
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1037)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!mve_vldrd_immediate (operands[2], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          switch (pattern586 (x4))
            {
            case 0:
              switch (pattern616 (x5))
                {
                case 0:
                  if (!
#line 3891 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                    return -1;
                  return 4966; /* mve_vstrq_scatter_base_wb_v4si */

                case 1:
                  if (!
#line 3891 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                    return -1;
                  return 4967; /* mve_vstrq_scatter_base_wb_v4sf */

                default:
                  return -1;
                }

            case 1:
              if (!s_register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x5) != E_V2DImode
                  || !
#line 3891 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4968; /* mve_vstrq_scatter_base_wb_v2di */

            default:
              return -1;
            }

        case 1039:
          x8 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != SCRATCH
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1039)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x6 = XVECEXP (x3, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!mve_vldrd_immediate (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          x12 = XVECEXP (x5, 0, 0);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          x13 = XVECEXP (x5, 0, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern602 (x1, 
E_V4SImode) != 0
                  || !
#line 3937 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 4972; /* mve_vldrq_gather_base_wb_v4si */

            case E_V4SFmode:
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || !s_register_operand (operands[2], E_V4SImode)
                  || !s_register_operand (operands[1], E_V4SImode)
                  || GET_MODE (x5) != E_V4SImode
                  || !
#line 3937 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 4973; /* mve_vldrq_gather_base_wb_v4sf */

            case E_V2DImode:
              if (pattern602 (x1, 
E_V2DImode) != 0
                  || !
#line 3937 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4974; /* mve_vldrq_gather_base_wb_v2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_15 (x1, insn, pnum_clobbers);

    case 1:
      if (XINT (x3, 1) != 40
          || GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x6) == MEM
          && GET_MODE (x6) == E_SImode)
        {
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) == CLOBBER)
            {
              x14 = XEXP (x6, 0);
              operands[1] = x14;
              if (register_operand (operands[1], E_SImode))
                {
                  x11 = XEXP (x4, 0);
                  if (rtx_equal_p (x11, operands[1]))
                    return 309; /* *stack_protect_set_insn */
                }
            }
        }
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      operands[1] = x6;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!scratch_operand (operands[2], E_SImode))
        return -1;
      return 312; /* stack_protect_set_tls */

    case 4:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      switch (XINT (x3, 1))
        {
        case 1034:
          switch (pattern333 (x1, 
PLUS))
            {
            case 0:
              if (!
#line 3750 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4948; /* mve_vidupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3750 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4950; /* mve_vidupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3750 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4952; /* mve_vidupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1030:
          switch (pattern333 (x1, 
MINUS))
            {
            case 0:
              if (!
#line 3750 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4949; /* mve_vddupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3750 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4951; /* mve_vddupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3750 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4953; /* mve_vddupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1038:
          if (pattern334 (x2) != 0)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1038)
            return -1;
          x6 = XVECEXP (x3, 0, 0);
          operands[1] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          if (!mve_vldrd_immediate (operands[2], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[3] = x8;
          x15 = XVECEXP (x3, 0, 3);
          operands[4] = x15;
          switch (pattern586 (x4))
            {
            case 0:
              if (!vpr_register_operand (operands[4], E_V4BImode))
                return -1;
              switch (pattern616 (x5))
                {
                case 0:
                  if (!
#line 3915 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                    return -1;
                  return 4969; /* mve_vstrq_scatter_base_wb_p_v4si */

                case 1:
                  if (!
#line 3915 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                    return -1;
                  return 4970; /* mve_vstrq_scatter_base_wb_p_v4sf */

                default:
                  return -1;
                }

            case 1:
              if (!vpr_register_operand (operands[4], E_V2QImode)
                  || !s_register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x5) != E_V2DImode
                  || !
#line 3915 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4971; /* mve_vstrq_scatter_base_wb_p_v2di */

            default:
              return -1;
            }

        case 1040:
          x15 = XVECEXP (x3, 0, 3);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_BLKmode)
            return -1;
          x16 = XEXP (x15, 0);
          if (GET_CODE (x16) != SCRATCH)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 1040)
            return -1;
          x10 = XEXP (x2, 0);
          operands[0] = x10;
          x6 = XVECEXP (x3, 0, 0);
          operands[2] = x6;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!mve_vldrd_immediate (operands[3], E_SImode))
            return -1;
          x8 = XVECEXP (x3, 0, 2);
          operands[4] = x8;
          x11 = XEXP (x4, 0);
          operands[1] = x11;
          x12 = XVECEXP (x5, 0, 0);
          if (!rtx_equal_p (x12, operands[2]))
            return -1;
          x13 = XVECEXP (x5, 0, 1);
          if (!rtx_equal_p (x13, operands[3]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SImode:
              if (pattern609 (x1, 
E_V4SImode, 
E_V4BImode) != 0
                  || !
#line 3960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
                return -1;
              return 4975; /* mve_vldrq_gather_base_wb_z_v4si */

            case E_V4SFmode:
              if (!s_register_operand (operands[0], E_V4SFmode)
                  || GET_MODE (x3) != E_V4SFmode
                  || pattern608 (x5, 
E_V4SImode, 
E_V4BImode) != 0
                  || !
#line 3960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
                return -1;
              return 4976; /* mve_vldrq_gather_base_wb_z_v4sf */

            case E_V2DImode:
              if (pattern609 (x1, 
E_V2DImode, 
E_V2QImode) != 0
                  || !
#line 3960 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
                return -1;
              return 4977; /* mve_vldrq_gather_base_wb_z_v2di */

            default:
              return -1;
            }

        case 1054:
          if (pattern336 (x1, 
1054) != 0
              || !
#line 4015 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4984; /* mve_vadciq_m_uv4si */

        case 1056:
          if (pattern336 (x1, 
1056) != 0
              || !
#line 4015 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4985; /* mve_vadciq_m_sv4si */

        case 1047:
          if (pattern336 (x1, 
1047) != 0
              || !
#line 4015 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4986; /* mve_vsbciq_m_uv4si */

        case 1048:
          if (pattern336 (x1, 
1048) != 0
              || !
#line 4015 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4987; /* mve_vsbciq_m_sv4si */

        case 1042:
          if (pattern337 (x1, 
1042) != 0
              || !
#line 4056 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4992; /* mve_vadcq_m_uv4si */

        case 1044:
          if (pattern337 (x1, 
1044) != 0
              || !
#line 4056 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4993; /* mve_vadcq_m_sv4si */

        case 1051:
          if (pattern337 (x1, 
1051) != 0
              || !
#line 4056 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4994; /* mve_vsbcq_m_uv4si */

        case 1052:
          if (pattern337 (x1, 
1052) != 0
              || !
#line 4056 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4995; /* mve_vsbcq_m_sv4si */

        case 1061:
          switch (pattern339 (x1, 
1061))
            {
            case 0:
              if (!
#line 4423 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5043; /* mve_vshlcq_m_sv16qi */

            case 1:
              if (!
#line 4423 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5045; /* mve_vshlcq_m_sv8hi */

            case 2:
              if (!
#line 4423 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5047; /* mve_vshlcq_m_sv4si */

            default:
              return -1;
            }

        case 1060:
          switch (pattern339 (x1, 
1060))
            {
            case 0:
              if (!
#line 4423 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5044; /* mve_vshlcq_m_uv16qi */

            case 1:
              if (!
#line 4423 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5046; /* mve_vshlcq_m_uv8hi */

            case 2:
              if (!
#line 4423 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 5048; /* mve_vshlcq_m_uv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 5:
      x8 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x8) != SUBREG
          || maybe_ne (SUBREG_BYTE (x8), 4)
          || GET_MODE (x8) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 5
          || GET_MODE (x5) != E_SImode)
        return -1;
      x17 = XVECEXP (x5, 0, 2);
      if (GET_CODE (x17) != SUBREG
          || maybe_ne (SUBREG_BYTE (x17), 4)
          || GET_MODE (x17) != E_SImode)
        return -1;
      x10 = XEXP (x2, 0);
      operands[0] = x10;
      x6 = XVECEXP (x3, 0, 0);
      operands[1] = x6;
      x7 = XVECEXP (x3, 0, 1);
      operands[3] = x7;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x9 = XEXP (x8, 0);
      operands[4] = x9;
      if (!s_register_operand (operands[4], E_DImode))
        return -1;
      x15 = XVECEXP (x3, 0, 3);
      operands[5] = x15;
      if (!mve_imm_selective_upto_8 (operands[5], E_SImode))
        return -1;
      x18 = XVECEXP (x3, 0, 4);
      operands[6] = x18;
      x11 = XEXP (x4, 0);
      operands[2] = x11;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x12 = XVECEXP (x5, 0, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      x13 = XVECEXP (x5, 0, 1);
      if (!rtx_equal_p (x13, operands[3]))
        return -1;
      x19 = XEXP (x17, 0);
      if (!rtx_equal_p (x19, operands[4]))
        return -1;
      x20 = XVECEXP (x5, 0, 3);
      if (!rtx_equal_p (x20, operands[5]))
        return -1;
      x21 = XVECEXP (x5, 0, 4);
      if (!rtx_equal_p (x21, operands[6]))
        return -1;
      switch (XINT (x3, 1))
        {
        case 1036:
          switch (pattern632 (x1, 
1036))
            {
            case 0:
              if (!
#line 3793 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4960; /* mve_viwdupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3793 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4962; /* mve_viwdupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3793 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4964; /* mve_viwdupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        case 1032:
          switch (pattern632 (x1, 
1032))
            {
            case 0:
              if (!
#line 3793 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4961; /* mve_vdwdupq_m_wb_uv16qi_insn */

            case 1:
              if (!
#line 3793 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4963; /* mve_vdwdupq_m_wb_uv8hi_insn */

            case 2:
              if (!
#line 3793 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
                return -1;
              return 4965; /* mve_vdwdupq_m_wb_uv4si_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_53 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (pnum_clobbers == NULL)
        return -1;
      operands[0] = x5;
      if (!s_register_operand (operands[0], E_SImode)
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      if (!arm_not_operand (operands[1], E_SImode)
          || !
#line 3076 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      *pnum_clobbers = 1;
      return 92; /* *andsi3_compare0_scratch */

    case NOT:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_SImode
          || pattern26 (x1, 
E_CC_NZmode) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      if (!s_register_operand (x6, E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[0] = x7;
          if (!shift_operator (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x7, 1);
          operands[2] = x9;
          if (!shift_amount_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x6;
          if (!
#line 3637 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 106; /* andsi_not_shiftsi_si_scc_no_reuse */

        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          operands[1] = x6;
          if (!
#line 3691 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
            return -1;
          *pnum_clobbers = 1;
          return 109; /* *andsi_notsi_si_compare0_scratch */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (pattern341 (x1) != 0
          || !
#line 10330 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 342; /* *cmp_and */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1340 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 648; /* ashlv4hi3_iwmmxt */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1424 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 660; /* ashlv4hi3_di */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (imm_or_reg_operand (operands[2], E_SImode)
          && 
#line 1340 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return 649; /* ashlv2si3_iwmmxt */
      if (!imm_or_reg_operand (operands[2], E_DImode)
          || !
#line 1424 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 661; /* ashlv2si3_di */

    case E_DImode:
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      if (register_operand (operands[0], E_DImode))
        {
          x3 = XEXP (x2, 0);
          operands[1] = x3;
          if (register_operand (operands[1], E_DImode))
            {
              x4 = XEXP (x2, 1);
              operands[2] = x4;
              if (imm_or_reg_operand (operands[2], E_SImode)
                  && 
#line 1340 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 650; /* ashldi3_iwmmxt */
              if (imm_or_reg_operand (operands[2], E_DImode)
                  && 
#line 1424 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
                return 662; /* ashldi3_di */
            }
        }
      if (!arm_general_register_operand (operands[0], E_DImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!arm_reg_or_long_shift_imm (operands[1], E_SImode))
        return -1;
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[0])
          || !
#line 1749 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE))
        return -1;
      return 1073; /* thumb2_lsll */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], E_BLKmode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_EImode:
      if (!s_register_operand (operands[1], E_EImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5921 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2889; /* neon_vst3_lanev8qi */

        case E_V4HImode:
          if (!
#line 5921 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2890; /* neon_vst3_lanev4hi */

        case E_V4HFmode:
          if (!
#line 5921 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2891; /* neon_vst3_lanev4hf */

        case E_V4BFmode:
          if (!
#line 5921 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2892; /* neon_vst3_lanev4bf */

        case E_V2SImode:
          if (!
#line 5921 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2893; /* neon_vst3_lanev2si */

        case E_V2SFmode:
          if (!
#line 5921 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2894; /* neon_vst3_lanev2sf */

        default:
          return -1;
        }

    case E_CImode:
      if (!s_register_operand (operands[1], E_CImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!
#line 5947 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2895; /* neon_vst3_lanev8hi */

        case E_V8HFmode:
          if (!
#line 5947 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2896; /* neon_vst3_lanev8hf */

        case E_V4SImode:
          if (!
#line 5947 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2897; /* neon_vst3_lanev4si */

        case E_V4SFmode:
          if (!
#line 5947 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2898; /* neon_vst3_lanev4sf */

        case E_V8BFmode:
          if (!(
#line 5947 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2899; /* neon_vst3_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern72 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3558 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4913; /* mve_vldrq_gather_base_z_v4si */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode)
          || !
#line 3558 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4914; /* mve_vldrq_gather_base_z_v4sf */

    case E_V2DImode:
      if (pattern72 (x3, 
E_V2QImode, 
E_V2DImode) != 0
          || !
#line 3558 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4915; /* mve_vldrq_gather_base_z_v2di */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4669 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2477; /* neon_vsli_nv8qi */

    case 1:
      if (!
#line 4669 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2478; /* neon_vsli_nv16qi */

    case 2:
      if (!
#line 4669 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2479; /* neon_vsli_nv4hi */

    case 3:
      if (!
#line 4669 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2480; /* neon_vsli_nv8hi */

    case 4:
      if (!
#line 4669 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2481; /* neon_vsli_nv2si */

    case 5:
      if (!
#line 4669 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2482; /* neon_vsli_nv4si */

    case 6:
      if (!
#line 4669 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2483; /* neon_vsli_ndi */

    case 7:
      if (!
#line 4669 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2484; /* neon_vsli_nv2di */

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern44 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5065 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2589; /* neon_vld1x3qbv16qi */

    case 1:
      if (!
#line 5065 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2590; /* neon_vld1x3qbv8hi */

    case 2:
      if (!
#line 5065 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2591; /* neon_vld1x3qbv8hf */

    case 3:
      if (!(
#line 5065 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2592; /* neon_vld1x3qbv8bf */

    case 4:
      if (!
#line 5065 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2593; /* neon_vld1x3qbv4si */

    case 5:
      if (!
#line 5065 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2594; /* neon_vld1x3qbv4sf */

    case 6:
      if (!
#line 5065 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2595; /* neon_vld1x3qbv2di */

    default:
      return -1;
    }
}

 int
recog_100 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern36 (x1))
    {
    case 0:
      if (!
#line 2192 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1597; /* neon_vqrdmlshv4hi */

    case 1:
      if (!
#line 2192 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1599; /* neon_vqrdmlshv2si */

    case 2:
      if (!
#line 2192 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1601; /* neon_vqrdmlshv8hi */

    case 3:
      if (!
#line 2192 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_RDMA))
        return -1;
      return 1603; /* neon_vqrdmlshv4si */

    default:
      return -1;
    }
}

 int
recog_109 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!mve_memory_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 3130 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode))))
        return -1;
      return 4824; /* mve_vstrq_v16qi */

    case E_V8HImode:
      if (!mve_memory_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 3130 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode))))
        return -1;
      return 4825; /* mve_vstrq_v8hi */

    case E_V4SImode:
      if (!mve_memory_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 3130 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4826; /* mve_vstrq_v4si */

    case E_V8HFmode:
      if (!mve_memory_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 3130 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode))))
        return -1;
      return 4827; /* mve_vstrq_v8hf */

    case E_V4SFmode:
      if (!mve_memory_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 3130 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4828; /* mve_vstrq_v4sf */

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16BImode:
      if (!vpr_register_operand (operands[0], E_V16BImode)
          || GET_MODE (x3) != E_V16BImode
          || !
#line 465 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3359; /* mve_vctp8qv16bi */

    case E_V8BImode:
      if (!vpr_register_operand (operands[0], E_V8BImode)
          || GET_MODE (x3) != E_V8BImode
          || !
#line 465 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3360; /* mve_vctp16qv8bi */

    case E_V4BImode:
      if (!vpr_register_operand (operands[0], E_V4BImode)
          || GET_MODE (x3) != E_V4BImode
          || !
#line 465 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3361; /* mve_vctp32qv4bi */

    case E_V2QImode:
      if (!vpr_register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !
#line 465 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3362; /* mve_vctp64qv2qi */

    default:
      return -1;
    }
}

 int
recog_120 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4HFmode)
          || !
#line 3747 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FP16))
        return -1;
      return 2120; /* neon_vcvtv4sfv4hf */

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 3756 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON && TARGET_FP16))
        return -1;
      return 2121; /* neon_vcvtv4hfv4sf */

    default:
      return -1;
    }
}

 int
recog_128 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern104 (x1))
    {
    case 0:
      if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1921; /* neon_vqabsv8qi */

    case 1:
      if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1922; /* neon_vqabsv16qi */

    case 2:
      if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1923; /* neon_vqabsv4hi */

    case 3:
      if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1924; /* neon_vqabsv8hi */

    case 4:
      if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1925; /* neon_vqabsv2si */

    case 5:
      if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1926; /* neon_vqabsv4si */

    default:
      return -1;
    }
}

 int
recog_137 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (!s_register_operand (operands[0], E_TImode)
          || GET_MODE (x2) != E_TImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!neon_struct_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_V8QImode
              || !
#line 5509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2800; /* neon_vld2_dupv8qi */

        case E_SImode:
          if (!neon_struct_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_V4HImode
              || !
#line 5509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2801; /* neon_vld2_dupv4hi */

        case E_SFmode:
          if (!neon_struct_operand (operands[1], E_SFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !
#line 5509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2802; /* neon_vld2_dupv4hf */

        case E_BFmode:
          if (!neon_struct_operand (operands[1], E_BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !(
#line 5509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2803; /* neon_vld2_dupv4bf */

        case E_V2SImode:
          if (!neon_struct_operand (operands[1], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !
#line 5509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2804; /* neon_vld2_dupv2si */

        case E_V2SFmode:
          if (!neon_struct_operand (operands[1], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !
#line 5509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2805; /* neon_vld2_dupv2sf */

        case E_V2DImode:
          if (!neon_struct_operand (operands[1], E_V2DImode)
              || GET_MODE (x3) != E_DImode
              || !
#line 5509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2806; /* neon_vld2_dupdi */

        default:
          return -1;
        }

    case E_OImode:
      if (pattern458 (x2, 
E_OImode) != 0
          || !
#line 5527 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 2807; /* neon_vld2_dupv8bf */

    case E_CImode:
      if (pattern458 (x2, 
E_CImode) != 0
          || !
#line 5810 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 2869; /* neon_vld3_dupv8bf */

    case E_XImode:
      if (pattern458 (x2, 
E_XImode) != 0
          || !
#line 6145 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_BF16_SIMD))
        return -1;
      return 2937; /* neon_vld4_dupv8bf */

    default:
      return -1;
    }
}

 int
recog_146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern157 (x1))
    {
    case 0:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2706; /* neon_vst1x3qav8qi */

    case 1:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2707; /* neon_vst1x3qav16qi */

    case 2:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2708; /* neon_vst1x3qav4hi */

    case 3:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2709; /* neon_vst1x3qav8hi */

    case 4:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2710; /* neon_vst1x3qav2si */

    case 5:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2711; /* neon_vst1x3qav4si */

    case 6:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2712; /* neon_vst1x3qav4hf */

    case 7:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2713; /* neon_vst1x3qav8hf */

    case 8:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2714; /* neon_vst1x3qav4bf */

    case 9:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2715; /* neon_vst1x3qav8bf */

    case 10:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2716; /* neon_vst1x3qav2sf */

    case 11:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2717; /* neon_vst1x3qav4sf */

    case 12:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2718; /* neon_vst1x3qadi */

    case 13:
      if (!
#line 5281 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2719; /* neon_vst1x3qav2di */

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern145 (x1))
    {
    case 0:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1829; /* neon_vminsv8qi */

    case 1:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1833; /* neon_vminsv16qi */

    case 2:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1837; /* neon_vminsv4hi */

    case 3:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1841; /* neon_vminsv8hi */

    case 4:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1845; /* neon_vminsv2si */

    case 5:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1849; /* neon_vminsv4si */

    case 6:
      if (!
#line 2691 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1852; /* neon_vminfv2sf */

    case 7:
      if (!
#line 2691 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1854; /* neon_vminfv4sf */

    case 8:
      if (!
#line 2702 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1856; /* neon_vminfv8hf */

    case 9:
      if (!
#line 2702 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1858; /* neon_vminfv4hf */

    default:
      return -1;
    }
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4586 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2399; /* neon_vshl_nv8qi */

    case 1:
      if (!
#line 4586 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2400; /* neon_vshl_nv16qi */

    case 2:
      if (!
#line 4586 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2401; /* neon_vshl_nv4hi */

    case 3:
      if (!
#line 4586 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2402; /* neon_vshl_nv8hi */

    case 4:
      if (!
#line 4586 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2403; /* neon_vshl_nv2si */

    case 5:
      if (!
#line 4586 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2404; /* neon_vshl_nv4si */

    case 6:
      if (!
#line 4586 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2405; /* neon_vshl_ndi */

    case 7:
      if (!
#line 4586 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2406; /* neon_vshl_nv2di */

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2281; /* neon_vrshlsv8qi */

    case 1:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2285; /* neon_vrshlsv16qi */

    case 2:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2289; /* neon_vrshlsv4hi */

    case 3:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2293; /* neon_vrshlsv8hi */

    case 4:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2297; /* neon_vrshlsv2si */

    case 5:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2301; /* neon_vrshlsv4si */

    case 6:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2305; /* neon_vrshlsdi */

    case 7:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2309; /* neon_vrshlsv2di */

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1509; /* neon_vqadduv8qi */

    case 1:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1511; /* neon_vqadduv16qi */

    case 2:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1513; /* neon_vqadduv4hi */

    case 3:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1515; /* neon_vqadduv8hi */

    case 4:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1517; /* neon_vqadduv2si */

    case 5:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1519; /* neon_vqadduv4si */

    case 6:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1521; /* neon_vqaddudi */

    case 7:
      if (!
#line 1600 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1523; /* neon_vqadduv2di */

    default:
      return -1;
    }
}

 int
recog_194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1, 
E_EImode, 
E_CImode))
    {
    case 0:
      if (!
#line 5047 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2582; /* neon_vld1x3qav16qi */

    case 1:
      if (!
#line 5047 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2583; /* neon_vld1x3qav8hi */

    case 2:
      if (!
#line 5047 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2584; /* neon_vld1x3qav8hf */

    case 3:
      if (!(
#line 5047 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2585; /* neon_vld1x3qav8bf */

    case 4:
      if (!
#line 5047 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2586; /* neon_vld1x3qav4si */

    case 5:
      if (!
#line 5047 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2587; /* neon_vld1x3qav4sf */

    case 6:
      if (!
#line 5047 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2588; /* neon_vld1x3qav2di */

    default:
      return -1;
    }
}

 int
recog_204 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2877; /* neon_vst3qav16qi */

    case 1:
      if (!
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2878; /* neon_vst3qav8hi */

    case 2:
      if (!
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2879; /* neon_vst3qav8hf */

    case 3:
      if (!(
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2880; /* neon_vst3qav8bf */

    case 4:
      if (!
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2881; /* neon_vst3qav4si */

    case 5:
      if (!
#line 5879 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2882; /* neon_vst3qav4sf */

    default:
      return -1;
    }
}

 int
recog_214 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1650; /* neon_vhsubuv8qi */

    case 1:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1652; /* neon_vhsubuv16qi */

    case 2:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1654; /* neon_vhsubuv4hi */

    case 3:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1656; /* neon_vhsubuv8hi */

    case 4:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1658; /* neon_vhsubuv2si */

    case 5:
      if (!
#line 2303 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1660; /* neon_vhsubuv4si */

    default:
      return -1;
    }
}

 int
recog_224 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1))
    {
    case 0:
      if (!
#line 542 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3373; /* mve_vcreateq_sv16qi */

    case 1:
      if (!
#line 542 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3375; /* mve_vcreateq_sv8hi */

    case 2:
      if (!
#line 542 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3377; /* mve_vcreateq_sv4si */

    case 3:
      if (!
#line 542 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3379; /* mve_vcreateq_sv2di */

    default:
      return -1;
    }
}

 int
recog_233 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1708; /* neon_vcgtv2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1713; /* neon_vcgtv4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1728; /* neon_vcgtv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1733; /* neon_vcgtv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_243 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!const_int_coproc_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_ccde1_operand (operands[2], E_SImode))
    return -1;
  switch (pattern393 (x3))
    {
    case 0:
      if (!
#line 4528 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 139; /* arm_cx1si */

    case 1:
      if (!
#line 4528 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CDE))
        return -1;
      return 140; /* arm_cx1di */

    default:
      return -1;
    }
}

 int
recog_253 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern196 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      if (pattern483 (x2, 
E_SImode) != 0
          || !
#line 2238 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 937; /* arm_vcx3si */

    case 1:
      x2 = XEXP (x1, 1);
      if (pattern483 (x2, 
E_DImode) != 0
          || !
#line 2238 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_CDE && (TARGET_ARM_FP || TARGET_HAVE_MVE)))
        return -1;
      return 938; /* arm_vcx3di */

    case 2:
      x2 = XEXP (x1, 1);
      if (pattern482 (x2) != 0
          || !const_int_mve_cde3_operand (operands[4], E_SImode)
          || !
#line 4486 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5053; /* arm_vcx3qv16qi */

    case 3:
      if (!
#line 4513 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_CDE && TARGET_HAVE_MVE))
        return -1;
      return 5055; /* arm_vcx1q_p_v16qi */

    default:
      return -1;
    }
}

 int
recog_255 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern198 (x1))
    {
    case 0:
      if (!
#line 4093 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2222; /* neon_vmls_lanev4hi */

    case 1:
      if (!
#line 4093 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2223; /* neon_vmls_lanev2si */

    case 2:
      if (!
#line 4093 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2224; /* neon_vmls_lanev2sf */

    case 3:
      if (!
#line 4111 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2225; /* neon_vmls_lanev8hi */

    case 4:
      if (!
#line 4111 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2226; /* neon_vmls_lanev4si */

    case 5:
      if (!
#line 4111 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2227; /* neon_vmls_lanev4sf */

    default:
      return -1;
    }
}

 int
recog_262 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 102:
      return recog_243 (x1, insn, pnum_clobbers);

    case 47:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 192; /* arm_qadd8 */

    case 48:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 193; /* arm_qsub8 */

    case 49:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 194; /* arm_shadd8 */

    case 50:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 195; /* arm_shsub8 */

    case 51:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 196; /* arm_uhadd8 */

    case 52:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 197; /* arm_uhsub8 */

    case 53:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 198; /* arm_uqadd8 */

    case 54:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 199; /* arm_uqsub8 */

    case 55:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 200; /* arm_qadd16 */

    case 56:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 201; /* arm_qasx */

    case 57:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 202; /* arm_qsax */

    case 58:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 203; /* arm_qsub16 */

    case 59:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 204; /* arm_shadd16 */

    case 60:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 205; /* arm_shasx */

    case 61:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 206; /* arm_shsax */

    case 62:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 207; /* arm_shsub16 */

    case 63:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 208; /* arm_uhadd16 */

    case 64:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 209; /* arm_uhasx */

    case 65:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 210; /* arm_uhsax */

    case 66:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 211; /* arm_uhsub16 */

    case 67:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 212; /* arm_uqadd16 */

    case 68:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 213; /* arm_uqasx */

    case 69:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 214; /* arm_uqsax */

    case 70:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 215; /* arm_uqsub16 */

    case 71:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 216; /* arm_smusd */

    case 72:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 217; /* arm_smusdx */

    case 43:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 218; /* arm_sxtab16 */

    case 44:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 219; /* arm_uxtab16 */

    case 73:
      if (pattern122 (x1) != 0
          || !
#line 6066 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 220; /* arm_usad8 */

    case 98:
      if (pattern122 (x1) != 0
          || !
#line 6139 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 246; /* arm_smuad_insn */

    case 99:
      if (pattern122 (x1) != 0
          || !
#line 6139 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 248; /* arm_smuadx_insn */

    case 100:
      return recog_242 (x1, insn, pnum_clobbers);

    case 101:
      return recog_241 (x1, insn, pnum_clobbers);

    case 27:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!
#line 6690 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(flag_pic))
        return -1;
      return 258; /* pic_load_addr_unified */

    case 42:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 289; /* restore_pic_register_after_call */

    case 3:
      return recog_223 (x1, insn, pnum_clobbers);

    case 123:
      if (pattern123 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 429; /* arm_crc32b */

    case 124:
      if (pattern123 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 430; /* arm_crc32h */

    case 125:
      if (pattern122 (x1) != 0
          || !
#line 12806 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 431; /* arm_crc32w */

    case 126:
      if (pattern123 (x1, 
E_QImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 432; /* arm_crc32cb */

    case 127:
      if (pattern123 (x1, 
E_HImode, 
E_SImode) != 0
          || !
#line 12806 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 433; /* arm_crc32ch */

    case 128:
      if (pattern122 (x1) != 0
          || !
#line 12806 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_CRC32))
        return -1;
      return 434; /* arm_crc32cw */

    case 107:
      if (pattern124 (x1) != 0
          || !
#line 13100 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch8m_main))
        return -1;
      return 514; /* pac_nop */

    case 462:
      return recog_222 (x1, insn, pnum_clobbers);

    case 463:
      return recog_221 (x1, insn, pnum_clobbers);

    case 13:
      if (pattern127 (x1, 
E_V4HImode, 
E_DImode) != 0
          || !
#line 528 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 574; /* iwmmxt_wmacsz */

    case 14:
      if (pattern127 (x1, 
E_V4HImode, 
E_DImode) != 0
          || !
#line 549 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 576; /* iwmmxt_wmacuz */

    case 6:
      return recog_240 (x1, insn, pnum_clobbers);

    case 10:
      return recog_186 (x1, insn, pnum_clobbers);

    case 113:
      if (pattern128 (x1, 
E_V4HImode) != 0
          || !
#line 371 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 710; /* iwmmxt_wqmulm */

    case 112:
      if (pattern128 (x1, 
E_V2SImode) != 0
          || !
#line 381 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 711; /* iwmmxt_wqmulwm */

    case 111:
      if (pattern128 (x1, 
E_V4HImode) != 0
          || !
#line 391 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 712; /* iwmmxt_wqmulmr */

    case 110:
      if (pattern128 (x1, 
E_V2SImode) != 0
          || !
#line 401 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 713; /* iwmmxt_wqmulwmr */

    case 299:
      return recog_158 (x1, insn, pnum_clobbers);

    case 179:
      if (pattern129 (x1) != 0
          || !
#line 1982 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 880; /* neon_vcvths_nsi_unspec */

    case 180:
      if (pattern129 (x1) != 0
          || !
#line 1982 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_VFP_FP16INST))
        return -1;
      return 881; /* neon_vcvthu_nsi_unspec */

    case 219:
      return recog_197 (x1, insn, pnum_clobbers);

    case 222:
      return recog_198 (x1, insn, pnum_clobbers);

    case 104:
      return recog_148 (x1, insn, pnum_clobbers);

    case 21:
      return recog_220 (x1, insn, pnum_clobbers);

    case 121:
      return recog_196 (x1, insn, pnum_clobbers);

    case 122:
      return recog_195 (x1, insn, pnum_clobbers);

    case 250:
      return recog_157 (x1, insn, pnum_clobbers);

    case 258:
      return recog_239 (x1, insn, pnum_clobbers);

    case 257:
      return recog_238 (x1, insn, pnum_clobbers);

    case 260:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 1402 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1448; /* neon_vpuminv8qi */

        case 1:
          if (!
#line 1402 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1449; /* neon_vpuminv4hi */

        case 2:
          if (!
#line 1402 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1450; /* neon_vpuminv2si */

        default:
          return -1;
        }

    case 259:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 1412 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1451; /* neon_vpumaxv8qi */

        case 1:
          if (!
#line 1412 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1452; /* neon_vpumaxv4hi */

        case 2:
          if (!
#line 1412 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1453; /* neon_vpumaxv2si */

        default:
          return -1;
        }

    case 153:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 1555 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1470; /* neon_vaddv2sf_unspec */

        case 1:
          if (!
#line 1555 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1471; /* neon_vaddv4sf_unspec */

        default:
          return -1;
        }

    case 156:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 1568 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1472; /* neon_vaddlsv8qi */

        case 1:
          if (!
#line 1568 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1474; /* neon_vaddlsv4hi */

        case 2:
          if (!
#line 1568 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1476; /* neon_vaddlsv2si */

        default:
          return -1;
        }

    case 157:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 1568 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1473; /* neon_vaddluv8qi */

        case 1:
          if (!
#line 1568 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1475; /* neon_vaddluv4hi */

        case 2:
          if (!
#line 1568 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1477; /* neon_vaddluv2si */

        default:
          return -1;
        }

    case 158:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1478; /* neon_vaddwsv8qi */

        case 1:
          if (!
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1480; /* neon_vaddwsv4hi */

        case 2:
          if (!
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1482; /* neon_vaddwsv2si */

        default:
          return -1;
        }

    case 159:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1479; /* neon_vaddwuv8qi */

        case 1:
          if (!
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1481; /* neon_vaddwuv4hi */

        case 2:
          if (!
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1483; /* neon_vaddwuv2si */

        default:
          return -1;
        }

    case 194:
      return recog_219 (x1, insn, pnum_clobbers);

    case 195:
      return recog_218 (x1, insn, pnum_clobbers);

    case 192:
      return recog_217 (x1, insn, pnum_clobbers);

    case 193:
      return recog_216 (x1, insn, pnum_clobbers);

    case 262:
      return recog_185 (x1, insn, pnum_clobbers);

    case 263:
      return recog_184 (x1, insn, pnum_clobbers);

    case 154:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1524; /* neon_vaddhnv8hi */

        case 1:
          if (!
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1526; /* neon_vaddhnv4si */

        case 2:
          if (!
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1528; /* neon_vaddhnv2di */

        default:
          return -1;
        }

    case 155:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1525; /* neon_vraddhnv8hi */

        case 1:
          if (!
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1527; /* neon_vraddhnv4si */

        case 2:
          if (!
#line 1610 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1529; /* neon_vraddhnv2di */

        default:
          return -1;
        }

    case 241:
      return recog_183 (x1, insn, pnum_clobbers);

    case 268:
      return recog_237 (x1, insn, pnum_clobbers);

    case 270:
      return recog_236 (x1, insn, pnum_clobbers);

    case 243:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2224 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1608; /* neon_vmullsv8qi */

        case 1:
          if (!
#line 2224 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1611; /* neon_vmullsv4hi */

        case 2:
          if (!
#line 2224 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1614; /* neon_vmullsv2si */

        default:
          return -1;
        }

    case 244:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2224 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1609; /* neon_vmulluv8qi */

        case 1:
          if (!
#line 2224 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1612; /* neon_vmulluv4hi */

        case 2:
          if (!
#line 2224 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1615; /* neon_vmulluv2si */

        default:
          return -1;
        }

    case 242:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2224 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1610; /* neon_vmullpv8qi */

        case 1:
          if (!
#line 2224 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1613; /* neon_vmullpv4hi */

        case 2:
          if (!
#line 2224 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1616; /* neon_vmullpv2si */

        default:
          return -1;
        }

    case 272:
      switch (pattern141 (x1, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2234 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1617; /* neon_vqdmullv4hi */

        case 1:
          if (!
#line 2234 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1618; /* neon_vqdmullv2si */

        default:
          return -1;
        }

    case 336:
      switch (pattern134 (x1))
        {
        case 0:
          if (!
#line 2260 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1619; /* neon_vsubv2sf_unspec */

        case 1:
          if (!
#line 2260 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1620; /* neon_vsubv4sf_unspec */

        default:
          return -1;
        }

    case 339:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2273 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1621; /* neon_vsublsv8qi */

        case 1:
          if (!
#line 2273 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1623; /* neon_vsublsv4hi */

        case 2:
          if (!
#line 2273 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1625; /* neon_vsublsv2si */

        default:
          return -1;
        }

    case 340:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2273 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1622; /* neon_vsubluv8qi */

        case 1:
          if (!
#line 2273 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1624; /* neon_vsubluv4hi */

        case 2:
          if (!
#line 2273 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1626; /* neon_vsubluv2si */

        default:
          return -1;
        }

    case 341:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 2283 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1627; /* neon_vsubwsv8qi */

        case 1:
          if (!
#line 2283 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1629; /* neon_vsubwsv4hi */

        case 2:
          if (!
#line 2283 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1631; /* neon_vsubwsv2si */

        default:
          return -1;
        }

    case 342:
      switch (pattern136 (x1))
        {
        case 0:
          if (!
#line 2283 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1628; /* neon_vsubwuv8qi */

        case 1:
          if (!
#line 2283 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1630; /* neon_vsubwuv4hi */

        case 2:
          if (!
#line 2283 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1632; /* neon_vsubwuv2si */

        default:
          return -1;
        }

    case 291:
      return recog_182 (x1, insn, pnum_clobbers);

    case 292:
      return recog_181 (x1, insn, pnum_clobbers);

    case 196:
      return recog_215 (x1, insn, pnum_clobbers);

    case 197:
      return recog_214 (x1, insn, pnum_clobbers);

    case 337:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 2313 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1661; /* neon_vsubhnv8hi */

        case 1:
          if (!
#line 2313 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1663; /* neon_vsubhnv4si */

        case 2:
          if (!
#line 2313 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1665; /* neon_vsubhnv2di */

        default:
          return -1;
        }

    case 338:
      switch (pattern139 (x1))
        {
        case 0:
          if (!
#line 2313 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1662; /* neon_vrsubhnv8hi */

        case 1:
          if (!
#line 2313 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1664; /* neon_vrsubhnv4si */

        case 2:
          if (!
#line 2313 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1666; /* neon_vrsubhnv2di */

        default:
          return -1;
        }

    case 165:
      return recog_235 (x1, insn, pnum_clobbers);

    case 168:
      return recog_233 (x1, insn, pnum_clobbers);

    case 166:
      return recog_234 (x1, insn, pnum_clobbers);

    case 354:
      return recog_232 (x1, insn, pnum_clobbers);

    case 353:
      return recog_231 (x1, insn, pnum_clobbers);

    case 161:
      return recog_230 (x1, insn, pnum_clobbers);

    case 162:
      return recog_229 (x1, insn, pnum_clobbers);

    case 163:
      return recog_228 (x1, insn, pnum_clobbers);

    case 164:
      return recog_227 (x1, insn, pnum_clobbers);

    case 149:
      return recog_213 (x1, insn, pnum_clobbers);

    case 150:
      return recog_212 (x1, insn, pnum_clobbers);

    case 148:
      return recog_180 (x1, insn, pnum_clobbers);

    case 151:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2623 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1803; /* neon_vabdlsv8qi */

        case 1:
          if (!
#line 2623 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1805; /* neon_vabdlsv4hi */

        case 2:
          if (!
#line 2623 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1807; /* neon_vabdlsv2si */

        default:
          return -1;
        }

    case 152:
      switch (pattern135 (x1, 
E_V8QImode, 
E_V4HImode, 
E_V2SImode))
        {
        case 0:
          if (!
#line 2623 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1804; /* neon_vabdluv8qi */

        case 1:
          if (!
#line 2623 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1806; /* neon_vabdluv4hi */

        case 2:
          if (!
#line 2623 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1808; /* neon_vabdluv2si */

        default:
          return -1;
        }

    case 217:
      return recog_156 (x1, insn, pnum_clobbers);

    case 218:
      return recog_211 (x1, insn, pnum_clobbers);

    case 220:
      return recog_155 (x1, insn, pnum_clobbers);

    case 221:
      return recog_209 (x1, insn, pnum_clobbers);

    case 253:
      return recog_210 (x1, insn, pnum_clobbers);

    case 255:
      return recog_208 (x1, insn, pnum_clobbers);

    case 248:
      return recog_207 (x1, insn, pnum_clobbers);

    case 249:
      return recog_206 (x1, insn, pnum_clobbers);

    case 254:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1898; /* neon_vpmaxuv8qi */

        case 1:
          if (!
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1902; /* neon_vpmaxuv4hi */

        case 2:
          if (!
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1906; /* neon_vpmaxuv2si */

        default:
          return -1;
        }

    case 256:
      switch (pattern133 (x1))
        {
        case 0:
          if (!
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1900; /* neon_vpminuv8qi */

        case 1:
          if (!
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1904; /* neon_vpminuv4hi */

        case 2:
          if (!
#line 2787 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1908; /* neon_vpminuv2si */

        default:
          return -1;
        }

    case 294:
      return recog_179 (x1, insn, pnum_clobbers);

    case 376:
      return recog_142 (x1, insn, pnum_clobbers);

    case 377:
      return recog_141 (x1, insn, pnum_clobbers);

    case 175:
      return recog_178 (x1, insn, pnum_clobbers);

    case 176:
      return recog_177 (x1, insn, pnum_clobbers);

    case 300:
      return recog_176 (x1, insn, pnum_clobbers);

    case 301:
      return recog_175 (x1, insn, pnum_clobbers);

    case 302:
      return recog_174 (x1, insn, pnum_clobbers);

    case 303:
      return recog_173 (x1, insn, pnum_clobbers);

    case 278:
      return recog_172 (x1, insn, pnum_clobbers);

    case 279:
      return recog_171 (x1, insn, pnum_clobbers);

    case 280:
      return recog_170 (x1, insn, pnum_clobbers);

    case 281:
      return recog_169 (x1, insn, pnum_clobbers);

    case 307:
      return recog_168 (x1, insn, pnum_clobbers);

    case 308:
      return recog_167 (x1, insn, pnum_clobbers);

    case 309:
      return recog_166 (x1, insn, pnum_clobbers);

    case 310:
      return recog_165 (x1, insn, pnum_clobbers);

    case 311:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4545 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2375; /* neon_vshrn_nv8hi */

        case 1:
          if (!
#line 4545 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2377; /* neon_vshrn_nv4si */

        case 2:
          if (!
#line 4545 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2379; /* neon_vshrn_nv2di */

        default:
          return -1;
        }

    case 312:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4545 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2376; /* neon_vrshrn_nv8hi */

        case 1:
          if (!
#line 4545 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2378; /* neon_vrshrn_nv4si */

        case 2:
          if (!
#line 4545 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2380; /* neon_vrshrn_nv2di */

        default:
          return -1;
        }

    case 285:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2381; /* neon_vqshrns_nv8hi */

        case 1:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2385; /* neon_vqshrns_nv4si */

        case 2:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2389; /* neon_vqshrns_nv2di */

        default:
          return -1;
        }

    case 286:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2382; /* neon_vqshrnu_nv8hi */

        case 1:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2386; /* neon_vqshrnu_nv4si */

        case 2:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2390; /* neon_vqshrnu_nv2di */

        default:
          return -1;
        }

    case 287:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2383; /* neon_vqrshrns_nv8hi */

        case 1:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2387; /* neon_vqrshrns_nv4si */

        case 2:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2391; /* neon_vqrshrns_nv2di */

        default:
          return -1;
        }

    case 288:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2384; /* neon_vqrshrnu_nv8hi */

        case 1:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2388; /* neon_vqrshrnu_nv4si */

        case 2:
          if (!
#line 4559 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2392; /* neon_vqrshrnu_nv2di */

        default:
          return -1;
        }

    case 289:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2393; /* neon_vqshrun_nv8hi */

        case 1:
          if (!
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2395; /* neon_vqshrun_nv4si */

        case 2:
          if (!
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2397; /* neon_vqshrun_nv2di */

        default:
          return -1;
        }

    case 290:
      switch (pattern152 (x1))
        {
        case 0:
          if (!
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2394; /* neon_vqrshrun_nv8hi */

        case 1:
          if (!
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2396; /* neon_vqrshrun_nv4si */

        case 2:
          if (!
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2398; /* neon_vqrshrun_nv2di */

        default:
          return -1;
        }

    case 306:
      return recog_164 (x1, insn, pnum_clobbers);

    case 282:
      return recog_163 (x1, insn, pnum_clobbers);

    case 283:
      return recog_162 (x1, insn, pnum_clobbers);

    case 284:
      return recog_161 (x1, insn, pnum_clobbers);

    case 304:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2431; /* neon_vshlls_nv8qi */

        case 1:
          if (!
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2433; /* neon_vshlls_nv4hi */

        case 2:
          if (!
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2435; /* neon_vshlls_nv2si */

        default:
          return -1;
        }

    case 305:
      switch (pattern153 (x1))
        {
        case 0:
          if (!
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2432; /* neon_vshllu_nv8qi */

        case 1:
          if (!
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2434; /* neon_vshllu_nv4hi */

        case 2:
          if (!
#line 4625 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2436; /* neon_vshllu_nv2si */

        default:
          return -1;
        }

    case 343:
      return recog_144 (x1, insn, pnum_clobbers);

    case 171:
      if (pattern154 (x1, 
E_V16QImode, 
E_OImode) != 0
          || !
#line 4825 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2491; /* neon_vcombinev16qi */

    case 198:
      return recog_136 (x1, insn, pnum_clobbers);

    case 199:
      return recog_194 (x1, insn, pnum_clobbers);

    case 201:
      return recog_193 (x1, insn, pnum_clobbers);

    case 319:
      return recog_135 (x1, insn, pnum_clobbers);

    case 320:
      return recog_146 (x1, insn, pnum_clobbers);

    case 321:
      return recog_145 (x1, insn, pnum_clobbers);

    case 322:
      return recog_192 (x1, insn, pnum_clobbers);

    case 323:
      return recog_191 (x1, insn, pnum_clobbers);

    case 324:
      return recog_134 (x1, insn, pnum_clobbers);

    case 204:
      return recog_140 (x1, insn, pnum_clobbers);

    case 205:
      return recog_137 (x1, insn, pnum_clobbers);

    case 325:
      return recog_139 (x1, insn, pnum_clobbers);

    case 207:
      return recog_190 (x1, insn, pnum_clobbers);

    case 208:
      return recog_205 (x1, insn, pnum_clobbers);

    case 210:
      return recog_149 (x1, insn, pnum_clobbers);

    case 327:
      return recog_189 (x1, insn, pnum_clobbers);

    case 328:
      return recog_204 (x1, insn, pnum_clobbers);

    case 329:
      return recog_203 (x1, insn, pnum_clobbers);

    case 212:
      return recog_188 (x1, insn, pnum_clobbers);

    case 213:
      return recog_202 (x1, insn, pnum_clobbers);

    case 215:
      return recog_138 (x1, insn, pnum_clobbers);

    case 331:
      return recog_187 (x1, insn, pnum_clobbers);

    case 332:
      return recog_201 (x1, insn, pnum_clobbers);

    case 333:
      return recog_200 (x1, insn, pnum_clobbers);

    case 393:
      return recog_226 (x1, insn, pnum_clobbers);

    case 139:
      if (pattern128 (x1, 
E_V4SImode) != 0
          || !
#line 213 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3060; /* crypto_sha1su1 */

    case 142:
      if (pattern128 (x1, 
E_V4SImode) != 0
          || !
#line 213 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3061; /* crypto_sha256su0 */

    case 144:
      if (pattern127 (x1, 
E_DImode, 
E_TImode) != 0
          || !
#line 262 "../../gcc-15.0.1-20250313/gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3067; /* crypto_vmullp64 */

    case 397:
      return recog_154 (x1, insn, pnum_clobbers);

    case 452:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      switch (pattern112 (x2))
        {
        case 0:
          if (!
#line 496 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3364; /* mve_vbrsrq_n_fv8hf */

        case 1:
          if (!
#line 496 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3365; /* mve_vbrsrq_n_fv4sf */

        default:
          return -1;
        }

    case 450:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3366; /* mve_vcvtq_n_to_f_sv8hf */

        case 1:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3368; /* mve_vcvtq_n_to_f_sv4sf */

        default:
          return -1;
        }

    case 451:
      switch (pattern168 (x1))
        {
        case 0:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3367; /* mve_vcvtq_n_to_f_uv8hf */

        case 1:
          if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3369; /* mve_vcvtq_n_to_f_uv4sf */

        default:
          return -1;
        }

    case 449:
      return recog_160 (x1, insn, pnum_clobbers);

    case 454:
      return recog_225 (x1, insn, pnum_clobbers);

    case 455:
      return recog_224 (x1, insn, pnum_clobbers);

    case 496:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3380; /* mve_vrshrq_n_sv16qi */

        case 1:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3384; /* mve_vrshrq_n_sv8hi */

        case 2:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3388; /* mve_vrshrq_n_sv4si */

        default:
          return -1;
        }

    case 533:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3381; /* mve_vrshrq_n_uv16qi */

        case 1:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3385; /* mve_vrshrq_n_uv8hi */

        case 2:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3389; /* mve_vrshrq_n_uv4si */

        default:
          return -1;
        }

    case 456:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3382; /* mve_vshrq_n_sv16qi */

        case 1:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3386; /* mve_vshrq_n_sv8hi */

        case 2:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3390; /* mve_vshrq_n_sv4si */

        default:
          return -1;
        }

    case 457:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3383; /* mve_vshrq_n_uv16qi */

        case 1:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3387; /* mve_vshrq_n_uv8hi */

        case 2:
          if (!
#line 559 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3391; /* mve_vshrq_n_uv4si */

        default:
          return -1;
        }

    case 458:
      switch (pattern171 (x1))
        {
        case 0:
          if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3398; /* mve_vcvtq_n_from_f_sv8hi */

        case 1:
          if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3400; /* mve_vcvtq_n_from_f_sv4si */

        default:
          return -1;
        }

    case 459:
      switch (pattern171 (x1))
        {
        case 0:
          if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3399; /* mve_vcvtq_n_from_f_uv8hi */

        case 1:
          if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3401; /* mve_vcvtq_n_from_f_uv4si */

        default:
          return -1;
        }

    case 460:
      if (pattern172 (x1) != 0
          || !
#line 626 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3402; /* mve_vaddlvq_p_sv4si */

    case 461:
      if (pattern172 (x1) != 0
          || !
#line 626 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3403; /* mve_vaddlvq_p_uv4si */

    case 464:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3452; /* mve_vabdq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3476; /* mve_vabdq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3500; /* mve_vabdq_sv4si */

        default:
          return -1;
        }

    case 501:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3453; /* mve_vabdq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3477; /* mve_vabdq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3501; /* mve_vabdq_uv4si */

        default:
          return -1;
        }

    case 469:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3454; /* mve_vhaddq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3478; /* mve_vhaddq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3502; /* mve_vhaddq_sv4si */

        default:
          return -1;
        }

    case 506:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3455; /* mve_vhaddq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3479; /* mve_vhaddq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3503; /* mve_vhaddq_uv4si */

        default:
          return -1;
        }

    case 471:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3456; /* mve_vhsubq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3480; /* mve_vhsubq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3504; /* mve_vhsubq_sv4si */

        default:
          return -1;
        }

    case 508:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3457; /* mve_vhsubq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3481; /* mve_vhsubq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3505; /* mve_vhsubq_uv4si */

        default:
          return -1;
        }

    case 478:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3458; /* mve_vmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3482; /* mve_vmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3506; /* mve_vmulhq_sv4si */

        default:
          return -1;
        }

    case 515:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3459; /* mve_vmulhq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3483; /* mve_vmulhq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3507; /* mve_vmulhq_uv4si */

        default:
          return -1;
        }

    case 483:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3460; /* mve_vqaddq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3484; /* mve_vqaddq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3508; /* mve_vqaddq_sv4si */

        default:
          return -1;
        }

    case 520:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3461; /* mve_vqaddq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3485; /* mve_vqaddq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3509; /* mve_vqaddq_uv4si */

        default:
          return -1;
        }

    case 548:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3462; /* mve_vqdmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3486; /* mve_vqdmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3510; /* mve_vqdmulhq_sv4si */

        default:
          return -1;
        }

    case 550:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3463; /* mve_vqrdmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3487; /* mve_vqrdmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3511; /* mve_vqrdmulhq_sv4si */

        default:
          return -1;
        }

    case 485:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3464; /* mve_vqrshlq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3488; /* mve_vqrshlq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3512; /* mve_vqrshlq_sv4si */

        default:
          return -1;
        }

    case 522:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3465; /* mve_vqrshlq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3489; /* mve_vqrshlq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3513; /* mve_vqrshlq_uv4si */

        default:
          return -1;
        }

    case 487:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3466; /* mve_vqshlq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3490; /* mve_vqshlq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3514; /* mve_vqshlq_sv4si */

        default:
          return -1;
        }

    case 524:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3467; /* mve_vqshlq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3491; /* mve_vqshlq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3515; /* mve_vqshlq_uv4si */

        default:
          return -1;
        }

    case 490:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3468; /* mve_vqsubq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3492; /* mve_vqsubq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3516; /* mve_vqsubq_sv4si */

        default:
          return -1;
        }

    case 527:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3469; /* mve_vqsubq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3493; /* mve_vqsubq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3517; /* mve_vqsubq_uv4si */

        default:
          return -1;
        }

    case 492:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3470; /* mve_vrhaddq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3494; /* mve_vrhaddq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3518; /* mve_vrhaddq_sv4si */

        default:
          return -1;
        }

    case 529:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3471; /* mve_vrhaddq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3495; /* mve_vrhaddq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3519; /* mve_vrhaddq_uv4si */

        default:
          return -1;
        }

    case 493:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3472; /* mve_vrmulhq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3496; /* mve_vrmulhq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3520; /* mve_vrmulhq_sv4si */

        default:
          return -1;
        }

    case 530:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3473; /* mve_vrmulhq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3497; /* mve_vrmulhq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3521; /* mve_vrmulhq_uv4si */

        default:
          return -1;
        }

    case 494:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3474; /* mve_vrshlq_sv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3498; /* mve_vrshlq_sv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3522; /* mve_vrshlq_sv4si */

        default:
          return -1;
        }

    case 531:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3475; /* mve_vrshlq_uv16qi */

        case 1:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3499; /* mve_vrshlq_uv8hi */

        case 2:
          if (!
#line 689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3523; /* mve_vrshlq_uv4si */

        default:
          return -1;
        }

    case 465:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3524; /* mve_vaddq_n_sv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3530; /* mve_vaddq_n_sv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3536; /* mve_vaddq_n_sv4si */

        default:
          return -1;
        }

    case 502:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3525; /* mve_vaddq_n_uv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3531; /* mve_vaddq_n_uv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3537; /* mve_vaddq_n_uv4si */

        default:
          return -1;
        }

    case 482:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3526; /* mve_vmulq_n_sv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3532; /* mve_vmulq_n_sv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3538; /* mve_vmulq_n_sv4si */

        default:
          return -1;
        }

    case 519:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3527; /* mve_vmulq_n_uv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3533; /* mve_vmulq_n_uv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3539; /* mve_vmulq_n_uv4si */

        default:
          return -1;
        }

    case 500:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3528; /* mve_vsubq_n_sv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3534; /* mve_vsubq_n_sv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3540; /* mve_vsubq_n_sv4si */

        default:
          return -1;
        }

    case 537:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3529; /* mve_vsubq_n_uv16qi */

        case 1:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3535; /* mve_vsubq_n_uv8hi */

        case 2:
          if (!
#line 707 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3541; /* mve_vsubq_n_uv4si */

        default:
          return -1;
        }

    case 466:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 723 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3542; /* mve_vaddvaq_sv16qi */

        case 1:
          if (!
#line 723 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3544; /* mve_vaddvaq_sv8hi */

        case 2:
          if (!
#line 723 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3546; /* mve_vaddvaq_sv4si */

        default:
          return -1;
        }

    case 503:
      switch (pattern175 (x1))
        {
        case 0:
          if (!
#line 723 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3543; /* mve_vaddvaq_uv16qi */

        case 1:
          if (!
#line 723 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3545; /* mve_vaddvaq_uv8hi */

        case 2:
          if (!
#line 723 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3547; /* mve_vaddvaq_uv4si */

        default:
          return -1;
        }

    case 504:
      switch (pattern176 (x1))
        {
        case 0:
          if (!
#line 740 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3548; /* mve_vaddvq_p_uv16qi */

        case 1:
          if (!
#line 740 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3550; /* mve_vaddvq_p_uv8hi */

        case 2:
          if (!
#line 740 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3552; /* mve_vaddvq_p_uv4si */

        default:
          return -1;
        }

    case 467:
      switch (pattern176 (x1))
        {
        case 0:
          if (!
#line 740 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3549; /* mve_vaddvq_p_sv16qi */

        case 1:
          if (!
#line 740 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3551; /* mve_vaddvq_p_sv8hi */

        case 2:
          if (!
#line 740 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3553; /* mve_vaddvq_p_sv4si */

        default:
          return -1;
        }

    case 505:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3560; /* mve_vbrsrq_n_uv16qi */

        case 1:
          if (!
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3562; /* mve_vbrsrq_n_uv8hi */

        case 2:
          if (!
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3564; /* mve_vbrsrq_n_uv4si */

        default:
          return -1;
        }

    case 468:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3561; /* mve_vbrsrq_n_sv16qi */

        case 1:
          if (!
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3563; /* mve_vbrsrq_n_sv8hi */

        case 2:
          if (!
#line 811 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3565; /* mve_vbrsrq_n_sv4si */

        default:
          return -1;
        }

    case 539:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3568; /* mve_vhcaddq_rot90_sv16qi */

        case 1:
          if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3572; /* mve_vhcaddq_rot90_sv8hi */

        case 2:
          if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3576; /* mve_vhcaddq_rot90_sv4si */

        default:
          return -1;
        }

    case 538:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3569; /* mve_vhcaddq_rot270_sv16qi */

        case 1:
          if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3573; /* mve_vhcaddq_rot270_sv8hi */

        case 2:
          if (!
#line 830 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3577; /* mve_vhcaddq_rot270_sv4si */

        default:
          return -1;
        }

    case 470:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3581; /* mve_vhaddq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3591; /* mve_vhaddq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3601; /* mve_vhaddq_n_sv4si */

        default:
          return -1;
        }

    case 507:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3582; /* mve_vhaddq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3592; /* mve_vhaddq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3602; /* mve_vhaddq_n_uv4si */

        default:
          return -1;
        }

    case 472:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3583; /* mve_vhsubq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3593; /* mve_vhsubq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3603; /* mve_vhsubq_n_sv4si */

        default:
          return -1;
        }

    case 509:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3584; /* mve_vhsubq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3594; /* mve_vhsubq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3604; /* mve_vhsubq_n_uv4si */

        default:
          return -1;
        }

    case 484:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3585; /* mve_vqaddq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3595; /* mve_vqaddq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3605; /* mve_vqaddq_n_sv4si */

        default:
          return -1;
        }

    case 521:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3586; /* mve_vqaddq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3596; /* mve_vqaddq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3606; /* mve_vqaddq_n_uv4si */

        default:
          return -1;
        }

    case 547:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3587; /* mve_vqdmulhq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3597; /* mve_vqdmulhq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3607; /* mve_vqdmulhq_n_sv4si */

        default:
          return -1;
        }

    case 549:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3588; /* mve_vqrdmulhq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3598; /* mve_vqrdmulhq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3608; /* mve_vqrdmulhq_n_sv4si */

        default:
          return -1;
        }

    case 491:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3589; /* mve_vqsubq_n_sv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3599; /* mve_vqsubq_n_sv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3609; /* mve_vqsubq_n_sv4si */

        default:
          return -1;
        }

    case 528:
      switch (pattern174 (x1))
        {
        case 0:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3590; /* mve_vqsubq_n_uv16qi */

        case 1:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3600; /* mve_vqsubq_n_uv8hi */

        case 2:
          if (!
#line 883 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3610; /* mve_vqsubq_n_uv4si */

        default:
          return -1;
        }

    case 540:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 900 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3611; /* mve_vmaxaq_sv16qi */

        case 1:
          if (!
#line 900 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3613; /* mve_vmaxaq_sv8hi */

        case 2:
          if (!
#line 900 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3615; /* mve_vmaxaq_sv4si */

        default:
          return -1;
        }

    case 542:
      switch (pattern173 (x1))
        {
        case 0:
          if (!
#line 900 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3612; /* mve_vminaq_sv16qi */

        case 1:
          if (!
#line 900 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3614; /* mve_vminaq_sv8hi */

        case 2:
          if (!
#line 900 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3616; /* mve_vminaq_sv4si */

        default:
          return -1;
        }

    case 541:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3629; /* mve_vmaxavq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3635; /* mve_vmaxavq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3641; /* mve_vmaxavq_sv4si */

        default:
          return -1;
        }

    case 474:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3630; /* mve_vmaxvq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3636; /* mve_vmaxvq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3642; /* mve_vmaxvq_sv4si */

        default:
          return -1;
        }

    case 511:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3631; /* mve_vmaxvq_uv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3637; /* mve_vmaxvq_uv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3643; /* mve_vmaxvq_uv4si */

        default:
          return -1;
        }

    case 543:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3632; /* mve_vminavq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3638; /* mve_vminavq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3644; /* mve_vminavq_sv4si */

        default:
          return -1;
        }

    case 476:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3633; /* mve_vminvq_sv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3639; /* mve_vminvq_sv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3645; /* mve_vminvq_sv4si */

        default:
          return -1;
        }

    case 513:
      switch (pattern178 (x1))
        {
        case 0:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3634; /* mve_vminvq_uv16qi */

        case 1:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3640; /* mve_vminvq_uv8hi */

        case 2:
          if (!
#line 936 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3646; /* mve_vminvq_uv4si */

        default:
          return -1;
        }

    case 477:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3647; /* mve_vmladavq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3652; /* mve_vmladavq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3657; /* mve_vmladavq_sv4si */

        default:
          return -1;
        }

    case 514:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3648; /* mve_vmladavq_uv16qi */

        case 1:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3653; /* mve_vmladavq_uv8hi */

        case 2:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3658; /* mve_vmladavq_uv4si */

        default:
          return -1;
        }

    case 544:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3649; /* mve_vmladavxq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3654; /* mve_vmladavxq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3659; /* mve_vmladavxq_sv4si */

        default:
          return -1;
        }

    case 545:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3650; /* mve_vmlsdavq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3655; /* mve_vmlsdavq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3660; /* mve_vmlsdavq_sv4si */

        default:
          return -1;
        }

    case 546:
      switch (pattern179 (x1))
        {
        case 0:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3651; /* mve_vmlsdavxq_sv16qi */

        case 1:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3656; /* mve_vmlsdavxq_sv8hi */

        case 2:
          if (!
#line 956 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3661; /* mve_vmlsdavxq_sv4si */

        default:
          return -1;
        }

    case 516:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3662; /* mve_vmullbq_int_uv16qi */

        case 1:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3666; /* mve_vmullbq_int_uv8hi */

        case 2:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3670; /* mve_vmullbq_int_uv4si */

        default:
          return -1;
        }

    case 479:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3663; /* mve_vmullbq_int_sv16qi */

        case 1:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3667; /* mve_vmullbq_int_sv8hi */

        case 2:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3671; /* mve_vmullbq_int_sv4si */

        default:
          return -1;
        }

    case 517:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3664; /* mve_vmulltq_int_uv16qi */

        case 1:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3668; /* mve_vmulltq_int_uv8hi */

        case 2:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3672; /* mve_vmulltq_int_uv4si */

        default:
          return -1;
        }

    case 480:
      switch (pattern135 (x1, 
E_V16QImode, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3665; /* mve_vmulltq_int_sv16qi */

        case 1:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3669; /* mve_vmulltq_int_sv8hi */

        case 2:
          if (!
#line 974 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3673; /* mve_vmulltq_int_sv4si */

        default:
          return -1;
        }

    case 486:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3689; /* mve_vqrshlq_n_sv16qi */

        case 1:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3693; /* mve_vqrshlq_n_sv8hi */

        case 2:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3697; /* mve_vqrshlq_n_sv4si */

        default:
          return -1;
        }

    case 523:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3690; /* mve_vqrshlq_n_uv16qi */

        case 1:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3694; /* mve_vqrshlq_n_uv8hi */

        case 2:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3698; /* mve_vqrshlq_n_uv4si */

        default:
          return -1;
        }

    case 495:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3691; /* mve_vrshlq_n_sv16qi */

        case 1:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3695; /* mve_vrshlq_n_sv8hi */

        case 2:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3699; /* mve_vrshlq_n_sv4si */

        default:
          return -1;
        }

    case 532:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3692; /* mve_vrshlq_n_uv16qi */

        case 1:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3696; /* mve_vrshlq_n_uv8hi */

        case 2:
          if (!
#line 1061 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3700; /* mve_vrshlq_n_uv4si */

        default:
          return -1;
        }

    case 488:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3701; /* mve_vqshlq_n_sv16qi */

        case 1:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3705; /* mve_vqshlq_n_sv8hi */

        case 2:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3709; /* mve_vqshlq_n_sv4si */

        default:
          return -1;
        }

    case 525:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3702; /* mve_vqshlq_n_uv16qi */

        case 1:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3706; /* mve_vqshlq_n_uv8hi */

        case 2:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3710; /* mve_vqshlq_n_uv4si */

        default:
          return -1;
        }

    case 497:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3703; /* mve_vshlq_n_sv16qi */

        case 1:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3707; /* mve_vshlq_n_sv8hi */

        case 2:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3711; /* mve_vshlq_n_sv4si */

        default:
          return -1;
        }

    case 534:
      switch (pattern180 (x1))
        {
        case 0:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3704; /* mve_vshlq_n_uv16qi */

        case 1:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3708; /* mve_vshlq_n_uv8hi */

        case 2:
          if (!
#line 1078 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3712; /* mve_vshlq_n_uv4si */

        default:
          return -1;
        }

    case 489:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3713; /* mve_vqshlq_r_sv16qi */

        case 1:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3717; /* mve_vqshlq_r_sv8hi */

        case 2:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3721; /* mve_vqshlq_r_sv4si */

        default:
          return -1;
        }

    case 526:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3714; /* mve_vqshlq_r_uv16qi */

        case 1:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3718; /* mve_vqshlq_r_uv8hi */

        case 2:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3722; /* mve_vqshlq_r_uv4si */

        default:
          return -1;
        }

    case 498:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3715; /* mve_vshlq_r_sv16qi */

        case 1:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3719; /* mve_vshlq_r_sv8hi */

        case 2:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3723; /* mve_vshlq_r_sv4si */

        default:
          return -1;
        }

    case 535:
      switch (pattern177 (x1))
        {
        case 0:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3716; /* mve_vshlq_r_uv16qi */

        case 1:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3720; /* mve_vshlq_r_uv8hi */

        case 2:
          if (!
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3724; /* mve_vshlq_r_uv4si */

        default:
          return -1;
        }

    case 551:
      return recog_199 (x1, insn, pnum_clobbers);

    case 554:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3728; /* mve_vabdq_fv8hf */

        case 1:
          if (!
#line 1127 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3729; /* mve_vabdq_fv4sf */

        default:
          return -1;
        }

    case 568:
      if (pattern123 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1143 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3730; /* mve_vaddlvaq_sv4si */

    case 567:
      if (pattern123 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1143 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3731; /* mve_vaddlvaq_uv4si */

    case 555:
      switch (pattern182 (x1))
        {
        case 0:
          if (!
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3732; /* mve_vaddq_n_fv8hf */

        case 1:
          if (!
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3735; /* mve_vaddq_n_fv4sf */

        default:
          return -1;
        }

    case 565:
      switch (pattern182 (x1))
        {
        case 0:
          if (!
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3733; /* mve_vmulq_n_fv8hf */

        case 1:
          if (!
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3736; /* mve_vmulq_n_fv4sf */

        default:
          return -1;
        }

    case 453:
      switch (pattern182 (x1))
        {
        case 0:
          if (!
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3734; /* mve_vsubq_n_fv8hf */

        case 1:
          if (!
#line 1162 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3737; /* mve_vsubq_n_fv4sf */

        default:
          return -1;
        }

    case 384:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3744; /* mve_vcmulq_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3750; /* mve_vcmulq_fv4sf */

        default:
          return -1;
        }

    case 385:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3745; /* mve_vcmulq_rot90_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3751; /* mve_vcmulq_rot90_fv4sf */

        default:
          return -1;
        }

    case 386:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3746; /* mve_vcmulq_rot180_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3752; /* mve_vcmulq_rot180_fv4sf */

        default:
          return -1;
        }

    case 387:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3747; /* mve_vcmulq_rot270_fv8hf */

        case 1:
          if (!
#line 1209 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3753; /* mve_vcmulq_rot270_fv4sf */

        default:
          return -1;
        }

    case 443:
      return recog_143 (x1, insn, pnum_clobbers);

    case 571:
      if (pattern123 (x1, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 1274 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3782; /* mve_vcvtbq_f16_f32v8hf */

    case 572:
      if (pattern123 (x1, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 1274 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 3783; /* mve_vcvttq_f16_f32v8hf */

    case 556:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3786; /* mve_vmaxnmaq_fv8hf */

        case 1:
          if (!
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3788; /* mve_vmaxnmaq_fv4sf */

        default:
          return -1;
        }

    case 560:
      switch (pattern181 (x1))
        {
        case 0:
          if (!
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3787; /* mve_vminnmaq_fv8hf */

        case 1:
          if (!
#line 1306 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3789; /* mve_vminnmaq_fv4sf */

        default:
          return -1;
        }

    case 557:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3790; /* mve_vmaxnmavq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3794; /* mve_vmaxnmavq_fv4sf */

        default:
          return -1;
        }

    case 559:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3791; /* mve_vmaxnmvq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3795; /* mve_vmaxnmvq_fv4sf */

        default:
          return -1;
        }

    case 561:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3792; /* mve_vminnmavq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3796; /* mve_vminnmavq_fv4sf */

        default:
          return -1;
        }

    case 563:
      switch (pattern183 (x1))
        {
        case 0:
          if (!
#line 1325 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3793; /* mve_vminnmvq_fv8hf */

        case 1:
          if (!
#line 1325 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3797; /* mve_vminnmvq_fv4sf */

        default:
          return -1;
        }

    case 575:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3802; /* mve_vmlaldavq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3807; /* mve_vmlaldavq_sv4si */

        default:
          return -1;
        }

    case 573:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3803; /* mve_vmlaldavq_uv8hi */

        case 1:
          if (!
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3808; /* mve_vmlaldavq_uv4si */

        default:
          return -1;
        }

    case 574:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3804; /* mve_vmlaldavxq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3809; /* mve_vmlaldavxq_sv4si */

        default:
          return -1;
        }

    case 576:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3805; /* mve_vmlsldavq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3810; /* mve_vmlsldavq_sv4si */

        default:
          return -1;
        }

    case 577:
      switch (pattern184 (x1))
        {
        case 0:
          if (!
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3806; /* mve_vmlsldavxq_sv8hi */

        case 1:
          if (!
#line 1360 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3811; /* mve_vmlsldavxq_sv4si */

        default:
          return -1;
        }

    case 579:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3812; /* mve_vmovnbq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3822; /* mve_vmovnbq_sv4si */

        default:
          return -1;
        }

    case 578:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3813; /* mve_vmovnbq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3823; /* mve_vmovnbq_uv4si */

        default:
          return -1;
        }

    case 581:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3814; /* mve_vmovntq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3824; /* mve_vmovntq_sv4si */

        default:
          return -1;
        }

    case 580:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3815; /* mve_vmovntq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3825; /* mve_vmovntq_uv4si */

        default:
          return -1;
        }

    case 589:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3816; /* mve_vqmovnbq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3826; /* mve_vqmovnbq_sv4si */

        default:
          return -1;
        }

    case 588:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3817; /* mve_vqmovnbq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3827; /* mve_vqmovnbq_uv4si */

        default:
          return -1;
        }

    case 600:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3818; /* mve_vqmovntq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3828; /* mve_vqmovntq_sv4si */

        default:
          return -1;
        }

    case 599:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3819; /* mve_vqmovntq_uv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3829; /* mve_vqmovntq_uv4si */

        default:
          return -1;
        }

    case 590:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3820; /* mve_vqmovunbq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3830; /* mve_vqmovunbq_sv4si */

        default:
          return -1;
        }

    case 591:
      switch (pattern185 (x1))
        {
        case 0:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3821; /* mve_vqmovuntq_sv8hi */

        case 1:
          if (!
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3831; /* mve_vqmovuntq_sv4si */

        default:
          return -1;
        }

    case 570:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3842; /* mve_vbicq_n_sv8hi */

        case 1:
          if (!
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3846; /* mve_vbicq_n_sv4si */

        default:
          return -1;
        }

    case 569:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3843; /* mve_vbicq_n_uv8hi */

        case 1:
          if (!
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3847; /* mve_vbicq_n_uv4si */

        default:
          return -1;
        }

    case 582:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3844; /* mve_vorrq_n_sv8hi */

        case 1:
          if (!
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3848; /* mve_vorrq_n_sv4si */

        default:
          return -1;
        }

    case 583:
      switch (pattern186 (x1))
        {
        case 0:
          if (!
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3845; /* mve_vorrq_n_uv8hi */

        case 1:
          if (!
#line 1446 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3849; /* mve_vorrq_n_uv4si */

        default:
          return -1;
        }

    case 584:
      switch (pattern188 (x1))
        {
        case 0:
          if (!
#line 1463 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3850; /* mve_vqdmullbq_n_sv8hi */

        case 1:
          if (!
#line 1463 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3852; /* mve_vqdmullbq_n_sv4si */

        default:
          return -1;
        }

    case 586:
      switch (pattern188 (x1))
        {
        case 0:
          if (!
#line 1463 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3851; /* mve_vqdmulltq_n_sv8hi */

        case 1:
          if (!
#line 1463 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3853; /* mve_vqdmulltq_n_sv4si */

        default:
          return -1;
        }

    case 585:
      switch (pattern141 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3854; /* mve_vqdmullbq_sv8hi */

        case 1:
          if (!
#line 1480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3856; /* mve_vqdmullbq_sv4si */

        default:
          return -1;
        }

    case 587:
      switch (pattern141 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3855; /* mve_vqdmulltq_sv8hi */

        case 1:
          if (!
#line 1480 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3857; /* mve_vqdmulltq_sv4si */

        default:
          return -1;
        }

    case 606:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3858; /* mve_vrmlaldavhq_sv4si */

    case 605:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3859; /* mve_vrmlaldavhq_uv4si */

    case 592:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3860; /* mve_vrmlaldavhxq_sv4si */

    case 593:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3861; /* mve_vrmlsldavhq_sv4si */

    case 594:
      if (pattern154 (x1, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 1499 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3862; /* mve_vrmlsldavhxq_sv4si */

    case 601:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3863; /* mve_vshllbq_n_sv16qi */

        case 1:
          if (!
#line 1517 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3867; /* mve_vshllbq_n_sv8hi */

        default:
          return -1;
        }

    case 602:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3864; /* mve_vshllbq_n_uv16qi */

        case 1:
          if (!
#line 1517 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3868; /* mve_vshllbq_n_uv8hi */

        default:
          return -1;
        }

    case 604:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3865; /* mve_vshlltq_n_sv16qi */

        case 1:
          if (!
#line 1517 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3869; /* mve_vshlltq_n_sv8hi */

        default:
          return -1;
        }

    case 603:
      switch (pattern189 (x1))
        {
        case 0:
          if (!
#line 1517 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3866; /* mve_vshlltq_n_uv16qi */

        case 1:
          if (!
#line 1517 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3870; /* mve_vshlltq_n_uv8hi */

        default:
          return -1;
        }

    case 608:
      switch (pattern190 (x1))
        {
        case 0:
          if (!
#line 1534 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3871; /* mve_vmullbq_poly_pv16qi */

        case 1:
          if (!
#line 1534 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3873; /* mve_vmullbq_poly_pv8hi */

        default:
          return -1;
        }

    case 607:
      switch (pattern190 (x1))
        {
        case 0:
          if (!
#line 1534 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3872; /* mve_vmulltq_poly_pv16qi */

        case 1:
          if (!
#line 1534 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3874; /* mve_vmulltq_poly_pv8hi */

        default:
          return -1;
        }

    case 1006:
      return recog_153 (x1, insn, pnum_clobbers);

    case 1008:
      return recog_159 (x1, insn, pnum_clobbers);

    case 1013:
      return recog_147 (x1, insn, pnum_clobbers);

    case 1059:
      return recog_152 (x1, insn, pnum_clobbers);

    case 1057:
      return recog_150 (x1, insn, pnum_clobbers);

    case 1058:
      return recog_151 (x1, insn, pnum_clobbers);

    case 1069:
      if (pattern192 (x1) != 0
          || !
#line 4274 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5029; /* mve_uqrshll_sat64_di */

    case 1070:
      if (pattern192 (x1) != 0
          || !
#line 4274 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5030; /* mve_uqrshll_sat48_di */

    case 1071:
      if (pattern192 (x1) != 0
          || !
#line 4286 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5031; /* mve_sqrshrl_sat64_di */

    case 1072:
      if (pattern192 (x1) != 0
          || !
#line 4286 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5032; /* mve_sqrshrl_sat48_di */

    case 1068:
      if (pattern193 (x1) != 0
          || !
#line 4298 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5033; /* mve_uqrshl_si */

    case 1067:
      if (pattern193 (x1) != 0
          || !
#line 4310 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5034; /* mve_sqrshr_si */

    case 1066:
      if (pattern194 (x1) != 0
          || !
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5036; /* mve_urshrl_di */

    case 1065:
      if (pattern195 (x1, 
E_SImode) != 0
          || !
#line 4356 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5038; /* mve_urshr_si */

    case 1064:
      if (pattern195 (x1, 
E_DImode) != 0
          || !
#line 4379 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5040; /* mve_srshr_si */

    case 1063:
      if (pattern194 (x1) != 0
          || !
#line 4391 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 5041; /* mve_srshrl_di */

    default:
      return -1;
    }
}

 int
recog_353 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      res = recog_326 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_327 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x4 = XEXP (x1, 0);
      operands[1] = x4;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x2, 1);
      operands[0] = x6;
      if (s_register_operand (operands[0], E_SImode)
          && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9629 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM)))
        return 6577; /* *p *arm_indirect_jump */
      if (memory_operand (operands[0], E_SImode)
          && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9638 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM)))
        return 6578; /* *p *load_indirect_jump */
      break;

    default:
      break;
    }
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
      res = recog_328 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case MEM:
      res = recog_329 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LABEL_REF:
      if (GET_CODE (x3) == PC)
        {
          x4 = XEXP (x1, 0);
          operands[1] = x4;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 8591 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return 6573; /* *p *arm_jump */
        }
      break;

    case CONST_VECTOR:
      res = recog_330 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SUBREG:
      res = recog_331 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  operands[1] = x6;
  if (general_operand (operands[1], E_SImode))
    {
      x4 = XEXP (x1, 0);
      operands[2] = x4;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      operands[0] = x3;
      if (nonimmediate_operand (operands[0], E_SImode))
        {
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_ARM && TARGET_HARD_FLOAT
   && (   s_register_operand (operands[0], SImode)
       || s_register_operand (operands[1], SImode)))))
            return 6899; /* *p *arm_movsi_vfp */
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_THUMB2 && TARGET_VFP_BASE
   && (   s_register_operand (operands[0], SImode)
       || s_register_operand (operands[1], SImode)))))
            return 6900; /* *p *thumb2_movsi_vfp */
        }
    }
  operands[0] = x3;
  if (low_register_operand (operands[0], E_SImode)
      && GET_CODE (x6) == MEM
      && pattern357 (x6, 
REG, 
E_SImode, 
POST_INC) == 0)
    {
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) == 13
          && GET_MODE (x8) == E_SImode)
        {
          x4 = XEXP (x1, 0);
          operands[1] = x4;
          x5 = XEXP (x4, 0);
          operands[2] = x5;
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 223 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && (reload_in_progress || reload_completed))))
            return 6976; /* *p *thumb2_pop_single */
        }
    }
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  operands[1] = x6;
  if (!general_operand (operands[1], E_SImode)
      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 238 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_IWMMXT && !TARGET_HARD_FLOAT
   && (   register_operand (operands[0], SImode)
       || register_operand (operands[1], SImode)))))
    return -1;
  return 6977; /* *p *thumb2_movsi_insn */
}

 int
recog_364 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_SImode)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  if (!s_register_operand (x8, E_SImode))
    return -1;
  x9 = XEXP (x4, 0);
  switch (GET_CODE (x9))
    {
    case PLUS:
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      operands[2] = x10;
      if (ldrd_strd_offset_operand (operands[2], E_SImode))
        {
          res = recog_363 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x10, 0) != -4L)
        return -1;
      x11 = XEXP (x1, 0);
      operands[3] = x11;
      x12 = XEXP (x11, 0);
      operands[4] = x12;
      x13 = XEXP (x9, 0);
      operands[1] = x13;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x8;
      x14 = XEXP (x6, 0);
      if (!rtx_equal_p (x14, operands[1])
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12751 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[0], operands[2],
                                  operands[1], -4, false, true)))))
        return -1;
      return 6612; /* *p *thumb2_ldrd_base_neg */

    case REG:
    case SUBREG:
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x14 = XEXP (x6, 0);
      if (GET_CODE (x14) != PLUS
          || GET_MODE (x14) != E_SImode)
        return -1;
      x15 = XEXP (x14, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x11 = XEXP (x1, 0);
      operands[3] = x11;
      x12 = XEXP (x11, 0);
      operands[4] = x12;
      operands[2] = x8;
      x16 = XEXP (x14, 0);
      if (!rtx_equal_p (x16, operands[1])
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12738 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[0], operands[2],
                                  operands[1], 0, false, true)))))
        return -1;
      return 6611; /* *p *thumb2_ldrd_base */

    default:
      return -1;
    }
}

 int
recog_375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_353 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_341 (x1, insn, pnum_clobbers);

    case COMPARE:
      return recog_346 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_340 (x1, insn, pnum_clobbers);

    case MULT:
    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      return recog_344 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_338 (x1, insn, pnum_clobbers);

    case AND:
      return recog_349 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_343 (x1, insn, pnum_clobbers);

    case XOR:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern378 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
                return -1;
              return 6451; /* *p *arm_xorsi3 */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 72 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6671; /* *p iwmmxt_xordi3 */

            case 2:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 328 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6683; /* *p *xorv2si3_iwmmxt */

            case 3:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 328 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6684; /* *p *xorv4hi3_iwmmxt */

            case 4:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 328 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6685; /* *p *xorv8qi3_iwmmxt */

            default:
              return -1;
            }

        case MULT:
          if (pattern375 (x1) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9686 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6582; /* *p *eor_multsi */

        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[2] = x5;
          if (pattern407 (x1) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9700 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT)))
            return -1;
          return 6587; /* *p *eor_shiftsi */

        default:
          return -1;
        }

    case SMAX:
      return recog_355 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_356 (x1, insn, pnum_clobbers);

    case SS_PLUS:
      return recog_358 (x1, insn, pnum_clobbers);

    case SS_MINUS:
      switch (pattern312 (x1))
        {
        case 0:
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4360 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ)))
            return 6458; /* *p arm_qsub_insn */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4360 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && ARM_Q_BIT_READ)))
            return -1;
          return 6459; /* *p arm_qsub_setq_insn */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 421 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6698; /* *p sssubv8qi3 */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 431 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6699; /* *p sssubv4hi3 */

        case 3:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 441 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6700; /* *p sssubv2si3 */

        case 4:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
            return -1;
          return 7045; /* *p *arm_sssubv4qq3 */

        case 5:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
            return -1;
          return 7046; /* *p *arm_sssubv2hq3 */

        case 6:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
            return -1;
          return 7047; /* *p *arm_sssubqq3 */

        case 7:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
            return -1;
          return 7048; /* *p *arm_sssubhq3 */

        case 8:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
            return -1;
          return 7049; /* *p *arm_sssubv2ha3 */

        case 9:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !0)))
            return -1;
          return 7050; /* *p *arm_sssubha3 */

        case 10:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
            return -1;
          return 7051; /* *p *arm_sssubsq3 */

        case 11:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 135 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
            return -1;
          return 7052; /* *p *arm_sssubsa3 */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_347 (x1, insn, pnum_clobbers);

    case NOT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          operands[3] = x5;
          if (!shift_operator (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[4] = x6;
          x7 = XEXP (x6, 0);
          operands[5] = x7;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x5, 1);
          operands[2] = x9;
          if (!shift_amount_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4797 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6469; /* *p *not_shiftsi */

        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x6 = XEXP (x1, 0);
          operands[2] = x6;
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5402 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6482; /* *p *arm_one_cmplsi2 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_348 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_350 (x1, insn, pnum_clobbers);

    case SIGN_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XEXP (x3, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      operands[2] = x10;
      if (pattern411 (x1) == 0
          && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5104 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && IN_RANGE (INTVAL (operands[3]), 0, 31)
   && IN_RANGE (INTVAL (operands[2]), 1, 32 - INTVAL (operands[3])))))
        return 6475; /* *p *extv_reg */
      x11 = XEXP (x3, 2);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      switch (pattern412 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12688 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return -1;
          return 6607; /* *p *arm_signextractsi2_8_8 */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12698 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return -1;
          return 6608; /* *p *arm_signextractsi2_8_16 */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12708 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return -1;
          return 6609; /* *p *arm_signextractsi2_16_8 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x10 = XEXP (x3, 1);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      operands[2] = x10;
      if (pattern411 (x1) == 0
          && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5118 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch_thumb2
   && IN_RANGE (INTVAL (operands[3]), 0, 31)
   && IN_RANGE (INTVAL (operands[2]), 1, 32 - INTVAL (operands[3])))))
        return 6476; /* *p extzv_t2 */
      x11 = XEXP (x3, 2);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      switch (pattern412 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12655 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return -1;
          return 6604; /* *p *arm_zeroextractsi2_8_8 */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12665 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return -1;
          return 6605; /* *p *arm_zeroextractsi2_8_16 */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12675 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
            return -1;
          return 6606; /* *p *arm_zeroextractsi2_16_8 */

        default:
          return -1;
        }

    case DIV:
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern310 (x3, 
E_SImode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5133 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_IDIV)))
            return -1;
          return 6477; /* *p divsi3 */

        case E_SFmode:
          if (pattern310 (x3, 
E_SFmode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1077 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6915; /* *p *divsf3_vfp */

        case E_DFmode:
          if (pattern310 (x3, 
E_DFmode) != 0
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1088 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6916; /* *p *divdf3_vfp */

        default:
          return -1;
        }

    case UDIV:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5146 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_IDIV)))
        return -1;
      return 6478; /* *p udivsi3 */

    case NEG:
      return recog_354 (x1, insn, pnum_clobbers);

    case LO_SUM:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!nonimmediate_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!general_operand (operands[2], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6544 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_HAVE_MOVT && arm_valid_symbolic_address_p (operands[2]))))
        return -1;
      return 6561; /* *p *arm_movt */

    case CLZ:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12193 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch5t)))
        return -1;
      return 6595; /* *p clzsi2 */

    case BSWAP:
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12384 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch6)))
            return -1;
          return 6599; /* *p *arm_rev */

        case E_HImode:
          if (!s_register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !s_register_operand (operands[1], E_HImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12569 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_arch6)))
            return -1;
          return 6601; /* *p *arm_rev16 */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_QImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 33 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6667; /* *p tbcstv8qi */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_HImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 42 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6668; /* *p tbcstv4hi */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 51 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6669; /* *p tbcstv2si */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern313 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 381 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6692; /* *p usaddv8qi3 */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 391 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6693; /* *p usaddv4hi3 */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 401 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6694; /* *p usaddv2si3 */

        case 3:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 55 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7012; /* *p usaddv4uqq3 */

        case 4:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 55 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7013; /* *p usaddv2uhq3 */

        case 5:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 55 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7014; /* *p usadduqq3 */

        case 6:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 55 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7015; /* *p usadduhq3 */

        case 7:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 55 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7016; /* *p usaddv2uha3 */

        case 8:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 55 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7017; /* *p usadduha3 */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern313 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 451 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6701; /* *p ussubv8qi3 */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 461 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6702; /* *p ussubv4hi3 */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 471 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6703; /* *p ussubv2si3 */

        case 3:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7039; /* *p ussubv4uqq3 */

        case 4:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7040; /* *p ussubv2uhq3 */

        case 5:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7041; /* *p ussubuqq3 */

        case 6:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7042; /* *p ussubuhq3 */

        case 7:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7043; /* *p ussubv2uha3 */

        case 8:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 115 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD)))
            return -1;
          return 7044; /* *p ussubuha3 */

        default:
          return -1;
        }

    case TRUNCATE:
      return recog_339 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_342 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_352 (x1, insn, pnum_clobbers);

    case UMAX:
      switch (pattern314 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 913 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6740; /* *p *umaxv2si3_iwmmxt */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 913 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6741; /* *p *umaxv4hi3_iwmmxt */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 913 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6742; /* *p *umaxv8qi3_iwmmxt */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern314 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 933 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6746; /* *p *uminv2si3_iwmmxt */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 933 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6747; /* *p *uminv4hi3_iwmmxt */

        case 2:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 933 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6748; /* *p *uminv8qi3_iwmmxt */

        default:
          return -1;
        }

    case VEC_CONCAT:
      return recog_345 (x1, insn, pnum_clobbers);

    case ABS:
      switch (pattern315 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 872 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6907; /* *p *abssf2_vfp */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 881 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6908; /* *p *absdf2_vfp */

        default:
          return -1;
        }

    case FMA:
      return recog_351 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!s_register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!s_register_operand (operands[1], E_SFmode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1458 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
                return -1;
              return 6939; /* *p *extendsfdf2_vfp */

            case E_HFmode:
              if (!s_register_operand (operands[1], E_HFmode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1494 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_FP16_TO_DOUBLE)))
                return -1;
              return 6943; /* *p *extendhfdf2 */

            default:
              return -1;
            }

        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !s_register_operand (operands[1], E_HFmode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1476 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && (TARGET_FP16 || TARGET_VFP_FP16INST))))
            return -1;
          return 6941; /* *p extendhfsf2 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!s_register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !s_register_operand (operands[1], E_DFmode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1467 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6940; /* *p *truncdfsf2_vfp */

        case E_HFmode:
          if (!s_register_operand (operands[0], E_HFmode)
              || GET_MODE (x3) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!s_register_operand (operands[1], E_DFmode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1485 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_FP16_TO_DOUBLE)))
                return -1;
              return 6942; /* *p *truncdfhf2 */

            case E_SFmode:
              if (!s_register_operand (operands[1], E_SFmode)
                  || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1503 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && (TARGET_FP16 || TARGET_VFP_FP16INST))))
                return -1;
              return 6944; /* *p truncsfhf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FIX:
      return recog_357 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != FIX)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      switch (GET_MODE (x5))
        {
        case E_SFmode:
          if (!s_register_operand (operands[1], E_SFmode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1531 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6947; /* *p fixuns_truncsfsi2 */

        case E_DFmode:
          if (!s_register_operand (operands[1], E_DFmode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1540 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6948; /* *p fixuns_truncdfsi2 */

        default:
          return -1;
        }

    case FLOAT:
      switch (pattern316 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1550 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6949; /* *p *floatsisf2_vfp */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1559 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6950; /* *p *floatsidf2_vfp */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      switch (pattern316 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1569 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6951; /* *p floatunssisf2 */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1578 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6952; /* *p floatunssidf2 */

        default:
          return -1;
        }

    case SQRT:
      switch (pattern315 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1614 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6953; /* *p *sqrtsf2_vfp */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1624 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6954; /* *p *sqrtdf2_vfp */

        default:
          return -1;
        }

    case SS_TRUNCATE:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (!sat_shift_operator (x5, E_SImode))
        return -1;
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[4] = x6;
      x7 = XEXP (x6, 0);
      operands[5] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_HImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x5, 1);
      operands[3] = x9;
      if (!immediate_operand (operands[3], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 481 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ)))
        return -1;
      return 7053; /* *p arm_ssatsihi_shift */

    case US_TRUNCATE:
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!s_register_operand (operands[0], E_HImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode)
          || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 490 "../../gcc-15.0.1-20250313/gcc/config/arm/arm-fixed.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ)))
        return -1;
      return 7054; /* *p arm_usatsihi */

    case US_ASHIFT:
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!arm_low_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !arm_low_register_operand (operands[1], E_DImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4321 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
            return -1;
          return 7061; /* *p mve_uqshll_di */

        case E_SImode:
          if (!arm_general_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !arm_general_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4344 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
            return -1;
          return 7063; /* *p mve_uqshl_si */

        default:
          return -1;
        }

    case SS_ASHIFT:
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!arm_general_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !arm_general_register_operand (operands[1], E_DImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4367 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
            return -1;
          return 7065; /* *p mve_sqshl_si */

        case E_DImode:
          if (!arm_low_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !arm_low_register_operand (operands[1], E_DImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4402 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE)))
            return -1;
          return 7068; /* *p mve_sqshll_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
