/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CC_NZmode
      || GET_MODE (x2) != E_CC_NZmode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[0] = x6;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !mem_noofs_operand (operands[1], i1)
      || !reg_or_int_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern27 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!imm_for_neon_rshift_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern32 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern32 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern32 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern32 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern32 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2SFmode:
      if (pattern32 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern32 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern49 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern68 (x3, 
E_QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern68 (x3, 
E_HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern68 (x3, 
E_SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern32 (x3, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern32 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern59 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern59 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != TRUNCATE
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  return 0;
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !s_register_operand (operands[1], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern127 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern40 (x3, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern40 (x3, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern40 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern38 (x3, 
E_V2SFmode, 
E_V2SImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern38 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern38 (x3, 
E_V8HFmode, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern38 (x3, 
E_V4HFmode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      return 0;

    case E_OImode:
      return 1;

    case E_EImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!neon_struct_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V8QImode:
      return 0;

    case E_V4HImode:
      return 1;

    case E_V4HFmode:
      return 2;

    case E_V4BFmode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V2SFmode:
      return 5;

    case E_DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern173 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern41 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern41 (x3, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  return pattern117 (x3, 
E_V16QImode, 
E_V8HImode); /* [-1, 1] */
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern68 (x3, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern68 (x3, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern32 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern208 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern201 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern206 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern216 (x3, 
E_V16BImode, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern216 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern216 (x3, 
E_V4BImode, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern209 (x3, 
E_V8BImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern209 (x3, 
E_V4BImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern240 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 1);
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pnum_clobbers == NULL
              || !s_register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !arm_rhs_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_V2SImode:
          if (GET_MODE (x1) != E_V2SImode)
            return -1;
          return 1;

        case E_V4HImode:
          if (GET_MODE (x1) != E_V4HImode)
            return -1;
          return 2;

        case E_V8QImode:
          if (GET_MODE (x1) != E_V8QImode)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern1 (x1, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V8HImode:
          if (pattern1 (x1, 
E_V8HImode) != 0)
            return -1;
          return 5;

        case E_V4SImode:
          if (pattern1 (x1, 
E_V4SImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    case VEC_SELECT:
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != PARALLEL)
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_CODE (x3) != VEC_SELECT)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 0);
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x8 = XVECEXP (x4, 0, 0);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XVECEXP (x4, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || XVECLEN (x5, 0) != 2)
            return -1;
          x10 = XVECEXP (x5, 0, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x11 = XVECEXP (x5, 0, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || pattern237 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        case 4:
          if (pattern238 (x1) != 0)
            return -1;
          return 8;

        case 8:
          if (pattern239 (x1) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern265 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (XVECLEN (x6, 0))
    {
    case 1:
      if (XINT (x6, 1) != 17)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != SET)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x9) != SET)
        return -1;
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != UNSPEC_VOLATILE
          || XVECLEN (x10, 0) != 5
          || XINT (x10, 1) != 17)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      x12 = XVECEXP (x10, 0, 0);
      operands[3] = x12;
      x13 = XVECEXP (x10, 0, 1);
      operands[4] = x13;
      x14 = XVECEXP (x10, 0, 2);
      operands[5] = x14;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      x15 = XVECEXP (x10, 0, 3);
      operands[6] = x15;
      if (!const_int_operand (operands[6], E_SImode))
        return -1;
      x16 = XVECEXP (x10, 0, 4);
      operands[7] = x16;
      if (!const_int_operand (operands[7], E_SImode))
        return -1;
      operands[8] = x5;
      return pattern261 (x1); /* [-1, 7] */

    case 2:
      if (XINT (x6, 1) != 19)
        return -1;
      x8 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 100
          || GET_MODE (x11) != E_CCmode)
        return -1;
      x9 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x9) != CLOBBER)
        return -1;
      x17 = XVECEXP (x6, 0, 1);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x18 = XEXP (x9, 0);
      operands[3] = x18;
      operands[4] = x5;
      x7 = XVECEXP (x6, 0, 0);
      switch (GET_CODE (x7))
        {
        case PLUS:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case MINUS:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        case IOR:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 16; /* [16, 19] */
          return -1;

        case XOR:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 20; /* [20, 23] */
          return -1;

        case AND:
          res = pattern263 (x6);
          if (res >= 0)
            return res + 24; /* [24, 27] */
          return -1;

        case NOT:
          x19 = XEXP (x7, 0);
          if (GET_CODE (x19) != AND)
            return -1;
          x20 = XEXP (x19, 1);
          operands[1] = x20;
          x21 = XEXP (x19, 0);
          if (!rtx_equal_p (x21, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern264 (x6, 
E_QImode) != 0)
                return -1;
              return 28;

            case E_HImode:
              if (pattern264 (x6, 
E_HImode) != 0)
                return -1;
              return 29;

            case E_SImode:
              if (pattern264 (x6, 
E_SImode) != 0)
                return -1;
              return 30;

            case E_DImode:
              if (!mem_noofs_operand (operands[0], E_DImode)
                  || GET_MODE (x6) != E_DImode
                  || GET_MODE (x7) != E_DImode
                  || GET_MODE (x19) != E_DImode
                  || !s_register_operand (operands[1], E_DImode)
                  || !scratch_operand (operands[3], E_DImode))
                return -1;
              return 31;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SImode:
      return pattern311 (x6, 
E_V2SImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern311 (x6, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V8QImode:
      if (pattern311 (x6, 
E_V8QImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2
      || !s_register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XVECEXP (x5, 0, 0);
  operands[1] = x6;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern331 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_V4SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
      || pattern323 (x1, 
E_V4SImode, 
E_SImode, 
101) != 0)
    return -1;
  return 0;
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[4] = x4;
  if (!arm_comparison_operator (operands[4], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 1);
  if (!arm_comparison_operator (x5, E_SImode))
    return -1;
  operands[5] = x5;
  return pattern340 (x1); /* [-1, 0] */
}

int
pattern347 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern350 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern350 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern350 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern350 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern350 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern350 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern365 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[4] = x9;
  if (!mve_imm_32 (operands[4], E_SImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[1] = x10;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x11 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  x13 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x13, operands[4]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x6) != E_V16QImode
          || !s_register_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x6) != E_V8HImode
          || !s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x6) != E_V4SImode
          || !s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern390 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!shift_nomul_operator (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[5] = x2;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!shift_amount_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x5, 1);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern416 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern425 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern307 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern431 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[1] = x1;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != i1
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != XOR
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[2] = x4;
      if (!register_operand (operands[2], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern456 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !neon_struct_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_MODE (x2))
    {
    case E_V8QImode:
      return 0;

    case E_V16QImode:
      return 1;

    case E_V4HImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V4HFmode:
      return 6;

    case E_V8HFmode:
      return 7;

    case E_V4BFmode:
      return 8;

    case E_V8BFmode:
      return 9;

    case E_V2SFmode:
      return 10;

    case E_V4SFmode:
      return 11;

    case E_DImode:
      return 12;

    case E_V2DImode:
      return 13;

    default:
      return -1;
    }
}

int
pattern470 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern480 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern479 (x1) != 0)
    return -1;
  return 0;
}

int
pattern488 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern494 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (3));
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  if (!memory_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!memory_operand (operands[2], E_SImode))
        return -1;
      x6 = PATTERN (peep2_next_insn (2));
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      return 0;

    case CONST_INT:
      operands[5] = x4;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern507 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[1], E_V8HImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!s_register_operand (operands[2], E_V8HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern517 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[0], E_SImode)
      || !s_register_operand (operands[1], E_SImode)
      || !s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern524 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern533 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[1], E_V8HImode)
      || !vpr_register_operand (operands[3], E_V8BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!s_register_operand (operands[2], E_V8HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern540 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  return pattern539 (x7, 
i1); /* [-1, 0] */
}

int
pattern552 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vpr_register_operand (operands[3], E_V4BImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[2], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern561 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern570 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern584 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern590 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern602 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern610 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[3] = x1;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case ASHIFTRT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern622 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !reg_or_int_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern629 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  return 0;
}

int
pattern637 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 1);
  x14 = XEXP (x13, 0);
  if (!rtx_equal_p (x14, operands[3]))
    return -1;
  return 0;
}

int
pattern644 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x9, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

int
pattern654 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CC_RSBmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_CC_RSBmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case SET:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!arm_immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 1);
      if (!rtx_equal_p (x10, operands[2])
          || !
#line 2101 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && ~UINTVAL (operands[1]) == UINTVAL (operands[3])))
        return -1;
      return 48; /* rsb_imm_compare */

    case CLOBBER:
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!arm_not_immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!scratch_operand (operands[0], E_SImode)
          || !
#line 2113 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 49; /* rsb_imm_compare_scratch */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern256 (x5) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case SMIN:
        case SMAX:
        case UMIN:
        case UMAX:
          operands[4] = x6;
          if (!minmax_operator (operands[4], E_SImode)
              || pattern550 (x3) != 0
              || !
#line 4301 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1])
   && !(arm_restrict_it && CONST_INT_P (operands[3]))))
            return -1;
          return 126; /* *minmax_arithsi_non_canon */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[4] = x6;
          if (!arm_comparison_operator (operands[4], E_SImode)
              || pattern550 (x3) != 0)
            return -1;
          if (
#line 10136 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return 339; /* *cond_sub */
          if (!
#line 868 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          return 1038; /* *thumb2_cond_sub */

        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 132 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 943; /* *thumb_subdi3 */

        default:
          return -1;
        }

    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern292 (x1))
        {
        case 0:
          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3146; /* atomic_sub_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3151; /* atomic_sub_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3156; /* atomic_sub_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3161; /* atomic_sub_fetchdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!arm_comparison_operator (x4, E_VOIDmode))
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (!s_register_operand (x5, E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x7;
          if (pattern449 (x1) != 0)
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x8;
              if (!arm_rhs_operand (operands[2], E_SImode))
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              if (
#line 10807 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 351; /* movcond */
              if (!
#line 1012 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
                return -1;
              return 1043; /* *thumb2_movcond */

            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (arm_add_operand (operands[3], E_SImode)
                  && GET_CODE (x8) == PLUS
                  && GET_MODE (x8) == E_SImode
                  && 
#line 10917 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return 354; /* *ifcompare_move_plus */
              if (!arm_rhs_operand (operands[3], E_SImode))
                return -1;
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode)
                  || !
#line 11061 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 360; /* *ifcompare_move_arith */

            case NOT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 11128 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 362; /* *ifcompare_move_not */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[7] = x8;
              if (!shift_operator (operands[7], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !
#line 11241 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 368; /* *ifcompare_move_shift */

            case NEG:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 11429 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 378; /* *ifcompare_move_neg */

            default:
              return -1;
            }

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          if (pattern449 (x1) != 0)
            return -1;
          x9 = XEXP (x4, 1);
          operands[5] = x9;
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!shiftable_operator (x7, E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x13 = XEXP (x7, 1);
          if (!arm_rhs_operand (x13, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode))
                return -1;
              operands[9] = x4;
              operands[5] = x5;
              operands[6] = x9;
              operands[8] = x7;
              operands[1] = x12;
              operands[2] = x13;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[4] = x11;
              if (!arm_rhs_operand (operands[4], E_SImode)
                  || !
#line 10962 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 356; /* *ifcompare_arith_arith */

            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              operands[6] = x4;
              operands[2] = x5;
              operands[3] = x9;
              operands[7] = x7;
              operands[4] = x12;
              operands[5] = x13;
              if (!
#line 10996 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 358; /* *ifcompare_arith_move */

            case NOT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              operands[5] = x9;
              operands[7] = x7;
              operands[2] = x12;
              operands[3] = x13;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (!s_register_operand (operands[1], E_SImode)
                  || !
#line 11361 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 374; /* *ifcompare_arith_not */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x7) != E_SImode
              || pattern449 (x1) != 0)
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              operands[2] = x12;
              if (!
#line 11163 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 364; /* *ifcompare_not_move */

            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              operands[1] = x12;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !
#line 11327 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 372; /* *ifcompare_not_arith */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (!shift_operator (x7, E_SImode)
              || pattern449 (x1) != 0)
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x13 = XEXP (x7, 1);
          if (!arm_rhs_operand (x13, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              operands[7] = x7;
              operands[2] = x12;
              operands[3] = x13;
              if (!
#line 11198 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 366; /* *ifcompare_shift_move */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[9] = x8;
              if (!shift_operator (operands[9], E_SImode))
                return -1;
              operands[7] = x4;
              operands[5] = x5;
              x9 = XEXP (x4, 1);
              operands[6] = x9;
              operands[8] = x7;
              operands[1] = x12;
              operands[2] = x13;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[4] = x11;
              if (!arm_rhs_operand (operands[4], E_SImode)
                  || !
#line 11286 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 370; /* *ifcompare_shift_shift */

            default:
              return -1;
            }

        case NEG:
          if (GET_MODE (x7) != E_SImode
              || pattern450 (x1) != 0)
            return -1;
          operands[5] = x4;
          operands[3] = x5;
          x9 = XEXP (x4, 1);
          operands[4] = x9;
          if (!arm_add_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          operands[2] = x12;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          operands[1] = x8;
          if (!arm_not_operand (operands[1], E_SImode)
              || !
#line 11393 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 376; /* *ifcompare_neg_move */

        case LABEL_REF:
          x8 = XEXP (x3, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x14 = XEXP (x2, 0);
          if (GET_CODE (x14) != PC)
            return -1;
          operands[4] = x4;
          operands[1] = x5;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (!thumb1_cmpneg_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          operands[3] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 1271 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 976; /* cbranchsi4_scratch */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x14 = XEXP (x2, 0);
      if (GET_CODE (x14) != PC)
        return -1;
      x16 = XEXP (x5, 0);
      if (!s_register_operand (x16, E_SImode))
        return -1;
      x17 = XEXP (x5, 1);
      if (!reg_or_int_operand (x17, E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case SET:
          if (pnum_clobbers == NULL)
            return -1;
          x18 = XEXP (x6, 1);
          if (GET_CODE (x18) != PLUS
              || GET_MODE (x18) != E_SImode)
            return -1;
          operands[4] = x4;
          operands[2] = x16;
          operands[3] = x17;
          x12 = XEXP (x7, 0);
          operands[5] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!thumb_cbrch_target_operand (operands[0], E_SImode))
            return -1;
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[3])
              || !
#line 1582 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[4]) == EQ
       || GET_CODE (operands[4]) == NE
       || GET_CODE (operands[4]) == GE
       || GET_CODE (operands[4]) == LT)))
            return -1;
          *pnum_clobbers = 1;
          return 982; /* *addsi3_cbranch */

        case CLOBBER:
          operands[3] = x4;
          operands[1] = x16;
          operands[2] = x17;
          x12 = XEXP (x7, 0);
          operands[4] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 1661 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[3]) == EQ
       || GET_CODE (operands[3]) == NE
       || GET_CODE (operands[3]) == GE
       || GET_CODE (operands[3]) == LT)))
            return -1;
          return 983; /* *addsi3_cbranch_scratch */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != SET)
    return -1;
  switch (pattern299 (x1))
    {
    case 0:
      if (pattern422 (x1) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      x9 = XEXP (x5, 0);
      operands[4] = x9;
      x10 = XEXP (x2, 1);
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[5] = x11;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x3, 1);
          x13 = XEXP (x12, 0);
          x14 = XEXP (x13, 1);
          if (XWINT (x14, 0) != 4L)
            return -1;
          x15 = XEXP (x4, 1);
          x16 = XEXP (x15, 0);
          x17 = XEXP (x16, 1);
          if (XWINT (x17, 0) != 8L)
            return -1;
          x18 = XEXP (x5, 1);
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XEXP (x19, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x23 = XEXP (x19, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          if (arm_hard_general_register_operand (operands[1], E_SImode)
              && arm_hard_general_register_operand (operands[2], E_SImode)
              && arm_hard_general_register_operand (operands[3], E_SImode)
              && arm_hard_general_register_operand (operands[4], E_SImode)
              && 
#line 37 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
            return 437; /* *ldm4_ */
          if (!low_register_operand (operands[1], E_SImode)
              || !low_register_operand (operands[2], E_SImode)
              || !low_register_operand (operands[3], E_SImode)
              || !low_register_operand (operands[4], E_SImode)
              || !
#line 55 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
            return -1;
          return 438; /* *thumb_ldm4_ia */

        case PLUS:
          if (GET_MODE (x11) != E_SImode)
            return -1;
          x24 = XEXP (x11, 1);
          if (GET_CODE (x24) != CONST_INT
              || !arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x25 = XEXP (x11, 0);
          operands[5] = x25;
          if (!s_register_operand (operands[5], E_SImode)
              || !arm_hard_general_register_operand (operands[2], E_SImode)
              || !arm_hard_general_register_operand (operands[3], E_SImode)
              || !arm_hard_general_register_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x3, 1);
          x13 = XEXP (x12, 0);
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x15 = XEXP (x4, 1);
          x16 = XEXP (x15, 0);
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          switch (XWINT (x24, 0))
            {
            case 4L:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != 8L)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != 12L)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (pattern645 (x19, 
16) != 0
                  || !
#line 160 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 444; /* *ldm4_ib */

            case -12L:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -8L)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -4L)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (!rtx_equal_p (x19, operands[5])
                  || !
#line 231 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 448; /* *ldm4_da */

            case -16L:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -12L)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -8L)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (pattern645 (x19, 
-4) != 0
                  || !
#line 302 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 452; /* *ldm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern480 (x1) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x15 = XEXP (x4, 1);
      operands[3] = x15;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x18 = XEXP (x5, 1);
      operands[4] = x18;
      if (!arm_hard_general_register_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      x26 = XEXP (x6, 0);
      switch (GET_CODE (x26))
        {
        case REG:
        case SUBREG:
          operands[5] = x26;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x3, 0);
          x27 = XEXP (x7, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != 4L)
            return -1;
          x8 = XEXP (x4, 0);
          x29 = XEXP (x8, 0);
          x30 = XEXP (x29, 1);
          if (XWINT (x30, 0) != 8L)
            return -1;
          x9 = XEXP (x5, 0);
          x31 = XEXP (x9, 0);
          if (GET_CODE (x31) != PLUS
              || GET_MODE (x31) != E_SImode)
            return -1;
          x32 = XEXP (x31, 1);
          if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x33 = XEXP (x27, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x34 = XEXP (x29, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          x35 = XEXP (x31, 0);
          if (!rtx_equal_p (x35, operands[5])
              || !
#line 108 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
            return -1;
          return 441; /* *stm4_ */

        case PLUS:
          if (GET_MODE (x26) != E_SImode)
            return -1;
          x36 = XEXP (x26, 1);
          if (GET_CODE (x36) != CONST_INT)
            return -1;
          x37 = XEXP (x26, 0);
          operands[5] = x37;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x3, 0);
          x27 = XEXP (x7, 0);
          x33 = XEXP (x27, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x8 = XEXP (x4, 0);
          x29 = XEXP (x8, 0);
          x34 = XEXP (x29, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          switch (XWINT (x36, 0))
            {
            case 4L:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != 8L)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != 12L)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (pattern646 (x31, 
16) != 0
                  || !
#line 196 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 446; /* *stm4_ib */

            case -12L:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != -8L)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -4L)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (!rtx_equal_p (x31, operands[5])
                  || !
#line 266 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 450; /* *stm4_da */

            case -16L:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != -12L)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -8L)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (pattern646 (x31, 
-4) != 0
                  || !
#line 338 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 454; /* *stm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XEXP (x2, 0);
      operands[4] = x6;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x10 = XEXP (x2, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[4]))
        return -1;
      x38 = XEXP (x10, 1);
      switch (XWINT (x38, 0))
        {
        case 12L:
          switch (pattern496 (x3))
            {
            case 0:
              if (pattern421 (x1) != 0)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (GET_CODE (x19) != PLUS
                  || GET_MODE (x19) != E_SImode)
                return -1;
              x20 = XEXP (x19, 1);
              if (GET_CODE (x20) != CONST_INT
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x23 = XEXP (x19, 0);
              if (!rtx_equal_p (x23, operands[4]))
                return -1;
              switch (pattern633 (x1))
                {
                case 0:
                  x12 = XEXP (x3, 1);
                  x13 = XEXP (x12, 0);
                  if (!rtx_equal_p (x13, operands[4]))
                    return -1;
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != 4L
                      || XWINT (x20, 0) != 8L)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && arm_hard_general_register_operand (operands[3], E_SImode)
                      && 
#line 508 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return 458; /* *ldm3_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !low_register_operand (operands[3], E_SImode)
                      || !
#line 525 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 459; /* *thumb_ldm3_ia_update */

                case 1:
                  if (!arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode)
                      || !arm_hard_general_register_operand (operands[3], E_SImode))
                    return -1;
                  x12 = XEXP (x3, 1);
                  x13 = XEXP (x12, 0);
                  x21 = XEXP (x13, 0);
                  if (!rtx_equal_p (x21, operands[4])
                      || !
#line 600 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 464; /* *ldm3_ib_update */

                default:
                  return -1;
                }

            case 1:
              if (pattern479 (x1) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (GET_CODE (x31) != PLUS
                  || GET_MODE (x31) != E_SImode)
                return -1;
              x32 = XEXP (x31, 1);
              if (GET_CODE (x32) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x4, 1);
              operands[2] = x15;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              x8 = XEXP (x4, 0);
              x29 = XEXP (x8, 0);
              x34 = XEXP (x29, 0);
              if (!rtx_equal_p (x34, operands[4]))
                return -1;
              x35 = XEXP (x31, 0);
              if (!rtx_equal_p (x35, operands[4]))
                return -1;
              switch (pattern635 (x1))
                {
                case 0:
                  x7 = XEXP (x3, 0);
                  x27 = XEXP (x7, 0);
                  if (!rtx_equal_p (x27, operands[4]))
                    return -1;
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != 4L
                      || XWINT (x32, 0) != 8L)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && arm_hard_general_register_operand (operands[3], E_SImode)
                      && 
#line 552 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return 461; /* *stm3_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !low_register_operand (operands[3], E_SImode)
                      || !
#line 567 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 462; /* *thumb_stm3_ia_update */

                case 1:
                  if (!arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode)
                      || !arm_hard_general_register_operand (operands[3], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 0);
                  x27 = XEXP (x7, 0);
                  x33 = XEXP (x27, 0);
                  if (!rtx_equal_p (x33, operands[4])
                      || !
#line 628 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 466; /* *stm3_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -12L:
          x12 = XEXP (x3, 1);
          switch (GET_CODE (x12))
            {
            case MEM:
              if (pattern422 (x1) != 0
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x13 = XEXP (x12, 0);
              x21 = XEXP (x13, 0);
              if (!rtx_equal_p (x21, operands[4]))
                return -1;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x14 = XEXP (x13, 1);
              switch (XWINT (x14, 0))
                {
                case -8L:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -4L)
                    return -1;
                  x18 = XEXP (x5, 1);
                  x19 = XEXP (x18, 0);
                  if (!rtx_equal_p (x19, operands[4])
                      || !
#line 660 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 468; /* *ldm3_da_update */

                case -12L:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -8L)
                    return -1;
                  x18 = XEXP (x5, 1);
                  x19 = XEXP (x18, 0);
                  if (GET_CODE (x19) != PLUS
                      || GET_MODE (x19) != E_SImode)
                    return -1;
                  x20 = XEXP (x19, 1);
                  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x23 = XEXP (x19, 0);
                  if (!rtx_equal_p (x23, operands[4])
                      || !
#line 722 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 472; /* *ldm3_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x12;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern480 (x1) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x4, 1);
              operands[2] = x15;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x7 = XEXP (x3, 0);
              x27 = XEXP (x7, 0);
              x33 = XEXP (x27, 0);
              if (!rtx_equal_p (x33, operands[4]))
                return -1;
              x8 = XEXP (x4, 0);
              x29 = XEXP (x8, 0);
              x34 = XEXP (x29, 0);
              if (!rtx_equal_p (x34, operands[4]))
                return -1;
              x28 = XEXP (x27, 1);
              switch (XWINT (x28, 0))
                {
                case -8L:
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != -4L)
                    return -1;
                  x9 = XEXP (x5, 0);
                  x31 = XEXP (x9, 0);
                  if (!rtx_equal_p (x31, operands[4])
                      || !
#line 688 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 470; /* *stm3_da_update */

                case -12L:
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != -8L)
                    return -1;
                  x9 = XEXP (x5, 0);
                  x31 = XEXP (x9, 0);
                  if (GET_CODE (x31) != PLUS
                      || GET_MODE (x31) != E_SImode)
                    return -1;
                  x32 = XEXP (x31, 1);
                  if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x35 = XEXP (x31, 0);
                  if (!rtx_equal_p (x35, operands[4])
                      || !
#line 750 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 474; /* *stm3_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_81 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2440; /* neon_vrsrau_nv8qi */

    case 1:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2444; /* neon_vrsrau_nv16qi */

    case 2:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2448; /* neon_vrsrau_nv4hi */

    case 3:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2452; /* neon_vrsrau_nv8hi */

    case 4:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2456; /* neon_vrsrau_nv2si */

    case 5:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2460; /* neon_vrsrau_nv4si */

    case 6:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2464; /* neon_vrsrau_ndi */

    case 7:
      if (!
#line 4641 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2468; /* neon_vrsrau_nv2di */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 105
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode)
      || !
#line 6194 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
    return -1;
  return 254; /* arm_sel */
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern46 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5707 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2845; /* neon_vld3qbv16qi */

    case 1:
      if (!
#line 5707 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2846; /* neon_vld3qbv8hi */

    case 2:
      if (!
#line 5707 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2847; /* neon_vld3qbv8hf */

    case 3:
      if (!(
#line 5707 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2848; /* neon_vld3qbv8bf */

    case 4:
      if (!
#line 5707 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2849; /* neon_vld3qbv4si */

    case 5:
      if (!
#line 5707 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2850; /* neon_vld3qbv4sf */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2248; /* neon_vrev64v8qi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2249; /* neon_vrev64v16qi */

    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2250; /* neon_vrev64v4hi */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2251; /* neon_vrev64v8hi */

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2252; /* neon_vrev64v2si */

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2253; /* neon_vrev64v4si */

    case E_V4HFmode:
      if (!s_register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2254; /* neon_vrev64v4hf */

    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2255; /* neon_vrev64v8hf */

    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2256; /* neon_vrev64v2sf */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2257; /* neon_vrev64v4sf */

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V2DImode)
          || !
#line 4446 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2258; /* neon_vrev64v2di */

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!s_register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 4464 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2263; /* neon_vrev16v8qi */

    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 4464 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2264; /* neon_vrev16v16qi */

    default:
      return -1;
    }
}

 int
recog_127 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern104 (x1))
    {
    case 0:
      if (!
#line 3152 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2010; /* neon_vqnegv8qi */

    case 1:
      if (!
#line 3152 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2011; /* neon_vqnegv16qi */

    case 2:
      if (!
#line 3152 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2012; /* neon_vqnegv4hi */

    case 3:
      if (!
#line 3152 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2013; /* neon_vqnegv8hi */

    case 4:
      if (!
#line 3152 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2014; /* neon_vqnegv2si */

    case 5:
      if (!
#line 3152 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2015; /* neon_vqnegv4si */

    default:
      return -1;
    }
}

 int
recog_136 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern155 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      switch (pattern456 (x2, 
E_TImode))
        {
        case 0:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2540; /* neon_vld1_x2v8qi */

        case 1:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2542; /* neon_vld1_x2v16qi */

        case 2:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2544; /* neon_vld1_x2v4hi */

        case 3:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2546; /* neon_vld1_x2v8hi */

        case 4:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2548; /* neon_vld1_x2v2si */

        case 5:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2550; /* neon_vld1_x2v4si */

        case 6:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2552; /* neon_vld1_x2v4hf */

        case 7:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2554; /* neon_vld1_x2v8hf */

        case 8:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2556; /* neon_vld1_x2v4bf */

        case 9:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2558; /* neon_vld1_x2v8bf */

        case 10:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2560; /* neon_vld1_x2v2sf */

        case 11:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2562; /* neon_vld1_x2v4sf */

        case 12:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2564; /* neon_vld1_x2di */

        case 13:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2566; /* neon_vld1_x2v2di */

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      switch (pattern456 (x2, 
E_OImode))
        {
        case 0:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2541; /* neon_vld1q_x2v8qi */

        case 1:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2543; /* neon_vld1q_x2v16qi */

        case 2:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2545; /* neon_vld1q_x2v4hi */

        case 3:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2547; /* neon_vld1q_x2v8hi */

        case 4:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2549; /* neon_vld1q_x2v2si */

        case 5:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2551; /* neon_vld1q_x2v4si */

        case 6:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2553; /* neon_vld1q_x2v4hf */

        case 7:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2555; /* neon_vld1q_x2v8hf */

        case 8:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2557; /* neon_vld1q_x2v4bf */

        case 9:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2559; /* neon_vld1q_x2v8bf */

        case 10:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2561; /* neon_vld1q_x2v2sf */

        case 11:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2563; /* neon_vld1q_x2v4sf */

        case 12:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2565; /* neon_vld1q_x2di */

        case 13:
          if (!
#line 5014 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2567; /* neon_vld1q_x2v2di */

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 1);
      switch (pattern456 (x2, 
E_EImode))
        {
        case 0:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2568; /* neon_vld1_x3v8qi */

        case 1:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2569; /* neon_vld1_x3v16qi */

        case 2:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2570; /* neon_vld1_x3v4hi */

        case 3:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2571; /* neon_vld1_x3v8hi */

        case 4:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2572; /* neon_vld1_x3v2si */

        case 5:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2573; /* neon_vld1_x3v4si */

        case 6:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2574; /* neon_vld1_x3v4hf */

        case 7:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2575; /* neon_vld1_x3v8hf */

        case 8:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2576; /* neon_vld1_x3v4bf */

        case 9:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2577; /* neon_vld1_x3v8bf */

        case 10:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2578; /* neon_vld1_x3v2sf */

        case 11:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2579; /* neon_vld1_x3v4sf */

        case 12:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2580; /* neon_vld1_x3di */

        case 13:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2581; /* neon_vld1_x3v2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_163 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4599 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2407; /* neon_vqshl_s_nv8qi */

    case 1:
      if (!
#line 4599 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2409; /* neon_vqshl_s_nv16qi */

    case 2:
      if (!
#line 4599 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2411; /* neon_vqshl_s_nv4hi */

    case 3:
      if (!
#line 4599 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2413; /* neon_vqshl_s_nv8hi */

    case 4:
      if (!
#line 4599 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2415; /* neon_vqshl_s_nv2si */

    case 5:
      if (!
#line 4599 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2417; /* neon_vqshl_s_nv4si */

    case 6:
      if (!
#line 4599 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2419; /* neon_vqshl_s_ndi */

    case 7:
      if (!
#line 4599 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2421; /* neon_vqshl_s_nv2di */

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2282; /* neon_vrshluv8qi */

    case 1:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2286; /* neon_vrshluv16qi */

    case 2:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2290; /* neon_vrshluv4hi */

    case 3:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2294; /* neon_vrshluv8hi */

    case 4:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2298; /* neon_vrshluv2si */

    case 5:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2302; /* neon_vrshluv4si */

    case 6:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2306; /* neon_vrshludi */

    case 7:
      if (!
#line 4509 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2310; /* neon_vrshluv2di */

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0
          || !
#line 1621 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1530; /* neon_vmulpv8qi */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0
          || !
#line 1621 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1531; /* neon_vmulpv16qi */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 1621 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1532; /* neon_vmulfv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 1621 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1533; /* neon_vmulfv4sf */

    default:
      return -1;
    }
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern158 (x1))
    {
    case 0:
      if (!
#line 5355 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2755; /* neon_vst1x4qbv16qi */

    case 1:
      if (!
#line 5355 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2756; /* neon_vst1x4qbv8hi */

    case 2:
      if (!
#line 5355 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2757; /* neon_vst1x4qbv8hf */

    case 3:
      if (!(
#line 5355 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2758; /* neon_vst1x4qbv8bf */

    case 4:
      if (!
#line 5355 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2759; /* neon_vst1x4qbv4si */

    case 5:
      if (!
#line 5355 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2760; /* neon_vst1x4qbv4sf */

    case 6:
      if (!
#line 5355 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2761; /* neon_vst1x4qbv2di */

    default:
      return -1;
    }
}

 int
recog_201 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1, 
E_XImode, 
E_OImode))
    {
    case 0:
      if (!
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2945; /* neon_vst4qav16qi */

    case 1:
      if (!
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2946; /* neon_vst4qav8hi */

    case 2:
      if (!
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2947; /* neon_vst4qav8hf */

    case 3:
      if (!(
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2948; /* neon_vst4qav8bf */

    case 4:
      if (!
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2949; /* neon_vst4qav4si */

    case 5:
      if (!
#line 6206 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2950; /* neon_vst4qav4sf */

    default:
      return -1;
    }
}

 int
recog_211 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1828; /* neon_vmaxuv8qi */

    case 1:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1832; /* neon_vmaxuv16qi */

    case 2:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1836; /* neon_vmaxuv4hi */

    case 3:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1840; /* neon_vmaxuv8hi */

    case 4:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1844; /* neon_vmaxuv2si */

    case 5:
      if (!
#line 2681 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1848; /* neon_vmaxuv4si */

    default:
      return -1;
    }
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern126 (x1))
    {
    case 0:
      if (!
#line 365 "../../gcc-15.0.1-20250313/gcc/config/arm/vec-common.md"
(ARM_HAVE_V8QI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 519; /* mve_vshlq_uv8qi */

    case 1:
      if (!
#line 365 "../../gcc-15.0.1-20250313/gcc/config/arm/vec-common.md"
(ARM_HAVE_V16QI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 521; /* mve_vshlq_uv16qi */

    case 2:
      if (!
#line 365 "../../gcc-15.0.1-20250313/gcc/config/arm/vec-common.md"
(ARM_HAVE_V4HI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 523; /* mve_vshlq_uv4hi */

    case 3:
      if (!
#line 365 "../../gcc-15.0.1-20250313/gcc/config/arm/vec-common.md"
(ARM_HAVE_V8HI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 525; /* mve_vshlq_uv8hi */

    case 4:
      if (!
#line 365 "../../gcc-15.0.1-20250313/gcc/config/arm/vec-common.md"
(ARM_HAVE_V2SI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 527; /* mve_vshlq_uv2si */

    case 5:
      if (!
#line 365 "../../gcc-15.0.1-20250313/gcc/config/arm/vec-common.md"
(ARM_HAVE_V4SI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 529; /* mve_vshlq_uv4si */

    default:
      return -1;
    }
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1707; /* neon_vceqv2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1712; /* neon_vceqv4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1727; /* neon_vceqv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1732; /* neon_vceqv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_246 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], E_BLKmode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 2);
  operands[3] = x8;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_EImode:
      if (!s_register_operand (operands[0], E_EImode)
          || GET_MODE (x2) != E_EImode
          || !s_register_operand (operands[2], E_EImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5730 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2851; /* neon_vld3_lanev8qi */

        case E_V4HImode:
          if (!
#line 5730 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2852; /* neon_vld3_lanev4hi */

        case E_V4HFmode:
          if (!
#line 5730 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2853; /* neon_vld3_lanev4hf */

        case E_V4BFmode:
          if (!
#line 5730 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2854; /* neon_vld3_lanev4bf */

        case E_V2SImode:
          if (!
#line 5730 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2855; /* neon_vld3_lanev2si */

        case E_V2SFmode:
          if (!
#line 5730 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2856; /* neon_vld3_lanev2sf */

        default:
          return -1;
        }

    case E_CImode:
      if (!s_register_operand (operands[0], E_CImode)
          || GET_MODE (x2) != E_CImode
          || !s_register_operand (operands[2], E_CImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!
#line 5756 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2857; /* neon_vld3_lanev8hi */

        case E_V8HFmode:
          if (!
#line 5756 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2858; /* neon_vld3_lanev8hf */

        case E_V4SImode:
          if (!
#line 5756 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2859; /* neon_vld3_lanev4si */

        case E_V4SFmode:
          if (!
#line 5756 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2860; /* neon_vld3_lanev4sf */

        case E_V8BFmode:
          if (!(
#line 5756 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2861; /* neon_vld3_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 103:
      return recog_259 (x1, insn, pnum_clobbers);

    case 102:
      return recog_257 (x1, insn, pnum_clobbers);

    case 105:
      return recog_254 (x1, insn, pnum_clobbers);

    case 104:
      return recog_253 (x1, insn, pnum_clobbers);

    case 361:
      return recog_261 (x1, insn, pnum_clobbers);

    case 362:
      return recog_260 (x1, insn, pnum_clobbers);

    case 224:
      return recog_256 (x1, insn, pnum_clobbers);

    case 227:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4063 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2216; /* neon_vmlals_lanev4hi */

        case 1:
          if (!
#line 4063 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2218; /* neon_vmlals_lanev2si */

        default:
          return -1;
        }

    case 228:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4063 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2217; /* neon_vmlalu_lanev4hi */

        case 1:
          if (!
#line 4063 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2219; /* neon_vmlalu_lanev2si */

        default:
          return -1;
        }

    case 265:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4078 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2220; /* neon_vqdmlal_lanev4hi */

        case 1:
          if (!
#line 4078 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2221; /* neon_vqdmlal_lanev2si */

        default:
          return -1;
        }

    case 230:
      return recog_255 (x1, insn, pnum_clobbers);

    case 233:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4129 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2228; /* neon_vmlsls_lanev4hi */

        case 1:
          if (!
#line 4129 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2230; /* neon_vmlsls_lanev2si */

        default:
          return -1;
        }

    case 234:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4129 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2229; /* neon_vmlslu_lanev4hi */

        case 1:
          if (!
#line 4129 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2231; /* neon_vmlslu_lanev2si */

        default:
          return -1;
        }

    case 267:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4144 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2232; /* neon_vqdmlsl_lanev4hi */

        case 1:
          if (!
#line 4144 "../../gcc-15.0.1-20250313/gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2233; /* neon_vqdmlsl_lanev2si */

        default:
          return -1;
        }

    case 206:
      return recog_245 (x1, insn, pnum_clobbers);

    case 211:
      return recog_246 (x1, insn, pnum_clobbers);

    case 216:
      return recog_244 (x1, insn, pnum_clobbers);

    case 809:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 2462 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4353; /* mve_vcvtq_m_n_from_f_sv8hi */

        case 1:
          if (!
#line 2462 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4355; /* mve_vcvtq_m_n_from_f_sv4si */

        default:
          return -1;
        }

    case 818:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 2462 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4354; /* mve_vcvtq_m_n_from_f_uv8hi */

        case 1:
          if (!
#line 2462 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4356; /* mve_vcvtq_m_n_from_f_uv4si */

        default:
          return -1;
        }

    case 820:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2514 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4363; /* mve_vabavq_p_sv16qi */

        case 1:
          if (!
#line 2514 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4365; /* mve_vabavq_p_sv8hi */

        case 2:
          if (!
#line 2514 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4367; /* mve_vabavq_p_sv4si */

        default:
          return -1;
        }

    case 821:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2514 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4364; /* mve_vabavq_p_uv16qi */

        case 1:
          if (!
#line 2514 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4366; /* mve_vabavq_p_uv8hi */

        case 2:
          if (!
#line 2514 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4368; /* mve_vabavq_p_uv4si */

        default:
          return -1;
        }

    case 819:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2532 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4369; /* mve_vqshluq_m_n_sv16qi */

        case 1:
          if (!
#line 2532 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4370; /* mve_vqshluq_m_n_sv8hi */

        case 2:
          if (!
#line 2532 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4371; /* mve_vqshluq_m_n_sv4si */

        default:
          return -1;
        }

    case 824:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4372; /* mve_vsriq_m_n_sv16qi */

        case 1:
          if (!
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4374; /* mve_vsriq_m_n_sv8hi */

        case 2:
          if (!
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4376; /* mve_vsriq_m_n_sv4si */

        default:
          return -1;
        }

    case 825:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4373; /* mve_vsriq_m_n_uv16qi */

        case 1:
          if (!
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4375; /* mve_vsriq_m_n_uv8hi */

        case 2:
          if (!
#line 2550 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4377; /* mve_vsriq_m_n_uv4si */

        default:
          return -1;
        }

    case 828:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 2568 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4378; /* mve_vcvtq_m_n_to_f_uv8hf */

        case 1:
          if (!
#line 2568 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4380; /* mve_vcvtq_m_n_to_f_uv4sf */

        default:
          return -1;
        }

    case 829:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 2568 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4379; /* mve_vcvtq_m_n_to_f_sv8hf */

        case 1:
          if (!
#line 2568 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4381; /* mve_vcvtq_m_n_to_f_sv4sf */

        default:
          return -1;
        }

    case 552:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4382; /* mve_vabdq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4420; /* mve_vabdq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4458; /* mve_vabdq_m_sv4si */

        default:
          return -1;
        }

    case 553:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4383; /* mve_vabdq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4421; /* mve_vabdq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4459; /* mve_vabdq_m_uv4si */

        default:
          return -1;
        }

    case 842:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4384; /* mve_vhaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4422; /* mve_vhaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4460; /* mve_vhaddq_m_sv4si */

        default:
          return -1;
        }

    case 838:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4385; /* mve_vhaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4423; /* mve_vhaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4461; /* mve_vhaddq_m_uv4si */

        default:
          return -1;
        }

    case 924:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4386; /* mve_vhsubq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4424; /* mve_vhsubq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4462; /* mve_vhsubq_m_sv4si */

        default:
          return -1;
        }

    case 925:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4387; /* mve_vhsubq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4425; /* mve_vhsubq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4463; /* mve_vhsubq_m_uv4si */

        default:
          return -1;
        }

    case 876:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4388; /* mve_vmaxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4426; /* mve_vmaxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4464; /* mve_vmaxq_m_sv4si */

        default:
          return -1;
        }

    case 856:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4389; /* mve_vmaxq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4427; /* mve_vmaxq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4465; /* mve_vmaxq_m_uv4si */

        default:
          return -1;
        }

    case 884:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4390; /* mve_vminq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4428; /* mve_vminq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4466; /* mve_vminq_m_sv4si */

        default:
          return -1;
        }

    case 885:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4391; /* mve_vminq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4429; /* mve_vminq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4467; /* mve_vminq_m_uv4si */

        default:
          return -1;
        }

    case 891:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4392; /* mve_vmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4430; /* mve_vmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4468; /* mve_vmulhq_m_sv4si */

        default:
          return -1;
        }

    case 892:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4393; /* mve_vmulhq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4431; /* mve_vmulhq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4469; /* mve_vmulhq_m_uv4si */

        default:
          return -1;
        }

    case 831:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4394; /* mve_vqaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4432; /* mve_vqaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4470; /* mve_vqaddq_m_sv4si */

        default:
          return -1;
        }

    case 830:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4395; /* mve_vqaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4433; /* mve_vqaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4471; /* mve_vqaddq_m_uv4si */

        default:
          return -1;
        }

    case 942:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4396; /* mve_vqdmladhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4434; /* mve_vqdmladhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4472; /* mve_vqdmladhq_m_sv4si */

        default:
          return -1;
        }

    case 933:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4397; /* mve_vqdmladhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4435; /* mve_vqdmladhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4473; /* mve_vqdmladhxq_m_sv4si */

        default:
          return -1;
        }

    case 938:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4398; /* mve_vqdmlsdhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4436; /* mve_vqdmlsdhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4474; /* mve_vqdmlsdhq_m_sv4si */

        default:
          return -1;
        }

    case 939:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4399; /* mve_vqdmlsdhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4437; /* mve_vqdmlsdhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4475; /* mve_vqdmlsdhxq_m_sv4si */

        default:
          return -1;
        }

    case 931:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4400; /* mve_vqdmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4438; /* mve_vqdmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4476; /* mve_vqdmulhq_m_sv4si */

        default:
          return -1;
        }

    case 941:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4401; /* mve_vqrdmladhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4439; /* mve_vqrdmladhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4477; /* mve_vqrdmladhq_m_sv4si */

        default:
          return -1;
        }

    case 930:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4402; /* mve_vqrdmladhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4440; /* mve_vqrdmladhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4478; /* mve_vqrdmladhxq_m_sv4si */

        default:
          return -1;
        }

    case 928:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4403; /* mve_vqrdmlsdhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4441; /* mve_vqrdmlsdhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4479; /* mve_vqrdmlsdhq_m_sv4si */

        default:
          return -1;
        }

    case 929:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4404; /* mve_vqrdmlsdhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4442; /* mve_vqrdmlsdhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4480; /* mve_vqrdmlsdhxq_m_sv4si */

        default:
          return -1;
        }

    case 934:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4405; /* mve_vqrdmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4443; /* mve_vqrdmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4481; /* mve_vqrdmulhq_m_sv4si */

        default:
          return -1;
        }

    case 860:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4406; /* mve_vqrshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4444; /* mve_vqrshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4482; /* mve_vqrshlq_m_sv4si */

        default:
          return -1;
        }

    case 881:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4407; /* mve_vqrshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4445; /* mve_vqrshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4483; /* mve_vqrshlq_m_uv4si */

        default:
          return -1;
        }

    case 912:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4408; /* mve_vqshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4446; /* mve_vqshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4484; /* mve_vqshlq_m_sv4si */

        default:
          return -1;
        }

    case 911:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4409; /* mve_vqshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4447; /* mve_vqshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4485; /* mve_vqshlq_m_uv4si */

        default:
          return -1;
        }

    case 846:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4410; /* mve_vqsubq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4448; /* mve_vqsubq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4486; /* mve_vqsubq_m_sv4si */

        default:
          return -1;
        }

    case 845:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4411; /* mve_vqsubq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4449; /* mve_vqsubq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4487; /* mve_vqsubq_m_uv4si */

        default:
          return -1;
        }

    case 864:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4412; /* mve_vrhaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4450; /* mve_vrhaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4488; /* mve_vrhaddq_m_sv4si */

        default:
          return -1;
        }

    case 862:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4413; /* mve_vrhaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4451; /* mve_vrhaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4489; /* mve_vrhaddq_m_uv4si */

        default:
          return -1;
        }

    case 883:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4414; /* mve_vrmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4452; /* mve_vrmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4490; /* mve_vrmulhq_m_sv4si */

        default:
          return -1;
        }

    case 882:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4415; /* mve_vrmulhq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4453; /* mve_vrmulhq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4491; /* mve_vrmulhq_m_uv4si */

        default:
          return -1;
        }

    case 869:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4416; /* mve_vrshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4454; /* mve_vrshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4492; /* mve_vrshlq_m_sv4si */

        default:
          return -1;
        }

    case 870:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4417; /* mve_vrshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4455; /* mve_vrshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4493; /* mve_vrshlq_m_uv4si */

        default:
          return -1;
        }

    case 822:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4418; /* mve_vshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4456; /* mve_vshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4494; /* mve_vshlq_m_sv4si */

        default:
          return -1;
        }

    case 823:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4419; /* mve_vshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4457; /* mve_vshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4495; /* mve_vshlq_m_uv4si */

        default:
          return -1;
        }

    case 873:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4496; /* mve_vaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4502; /* mve_vaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4508; /* mve_vaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 874:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4497; /* mve_vaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4503; /* mve_vaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4509; /* mve_vaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 852:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4498; /* mve_vmulq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4504; /* mve_vmulq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4510; /* mve_vmulq_m_n_sv4si */

        default:
          return -1;
        }

    case 841:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4499; /* mve_vmulq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4505; /* mve_vmulq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4511; /* mve_vmulq_m_n_uv4si */

        default:
          return -1;
        }

    case 833:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4500; /* mve_vsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4506; /* mve_vsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4512; /* mve_vsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 834:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4501; /* mve_vsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4507; /* mve_vsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4513; /* mve_vsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 918:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4514; /* mve_vaddq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4520; /* mve_vaddq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4526; /* mve_vaddq_m_sv4si */

        default:
          return -1;
        }

    case 897:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4515; /* mve_vaddq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4521; /* mve_vaddq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4527; /* mve_vaddq_m_uv4si */

        default:
          return -1;
        }

    case 865:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4516; /* mve_vmulq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4522; /* mve_vmulq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4528; /* mve_vmulq_m_sv4si */

        default:
          return -1;
        }

    case 866:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4517; /* mve_vmulq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4523; /* mve_vmulq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4529; /* mve_vmulq_m_uv4si */

        default:
          return -1;
        }

    case 827:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4518; /* mve_vsubq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4524; /* mve_vsubq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4530; /* mve_vsubq_m_sv4si */

        default:
          return -1;
        }

    case 826:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4519; /* mve_vsubq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4525; /* mve_vsubq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4531; /* mve_vsubq_m_uv4si */

        default:
          return -1;
        }

    case 888:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4532; /* mve_vandq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4542; /* mve_vandq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4552; /* mve_vandq_m_sv4si */

        default:
          return -1;
        }

    case 887:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4533; /* mve_vandq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4543; /* mve_vandq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4553; /* mve_vandq_m_uv4si */

        default:
          return -1;
        }

    case 840:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4534; /* mve_vbicq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4544; /* mve_vbicq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4554; /* mve_vbicq_m_sv4si */

        default:
          return -1;
        }

    case 839:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4535; /* mve_vbicq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4545; /* mve_vbicq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4555; /* mve_vbicq_m_uv4si */

        default:
          return -1;
        }

    case 922:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4536; /* mve_veorq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4546; /* mve_veorq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4556; /* mve_veorq_m_sv4si */

        default:
          return -1;
        }

    case 923:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4537; /* mve_veorq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4547; /* mve_veorq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4557; /* mve_veorq_m_uv4si */

        default:
          return -1;
        }

    case 915:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4538; /* mve_vornq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4548; /* mve_vornq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4558; /* mve_vornq_m_sv4si */

        default:
          return -1;
        }

    case 914:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4539; /* mve_vornq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4549; /* mve_vornq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4559; /* mve_vornq_m_uv4si */

        default:
          return -1;
        }

    case 878:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4540; /* mve_vorrq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4550; /* mve_vorrq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4560; /* mve_vorrq_m_sv4si */

        default:
          return -1;
        }

    case 879:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4541; /* mve_vorrq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4551; /* mve_vorrq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4561; /* mve_vorrq_m_uv4si */

        default:
          return -1;
        }

    case 902:
      switch (pattern215 (x1))
        {
        case 0:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4562; /* mve_vbrsrq_m_n_uv16qi */

        case 1:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4564; /* mve_vbrsrq_m_n_uv8hi */

        case 2:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4566; /* mve_vbrsrq_m_n_uv4si */

        default:
          return -1;
        }

    case 835:
      switch (pattern215 (x1))
        {
        case 0:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4563; /* mve_vbrsrq_m_n_sv16qi */

        case 1:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4565; /* mve_vbrsrq_m_n_sv8hi */

        case 2:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4567; /* mve_vbrsrq_m_n_sv4si */

        default:
          return -1;
        }

    case 927:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4568; /* mve_vhcaddq_rot90_m_sv16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4572; /* mve_vhcaddq_rot90_m_sv8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4576; /* mve_vhcaddq_rot90_m_sv4si */

        default:
          return -1;
        }

    case 937:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4569; /* mve_vhcaddq_rot270_m_sv16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4573; /* mve_vhcaddq_rot270_m_sv8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4577; /* mve_vhcaddq_rot270_m_sv4si */

        default:
          return -1;
        }

    case 913:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4570; /* mve_vcaddq_rot90_m_v16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4574; /* mve_vcaddq_rot90_m_v8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4578; /* mve_vcaddq_rot90_m_v4si */

        default:
          return -1;
        }

    case 859:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4571; /* mve_vcaddq_rot270_m_v16qi */

        case 1:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4575; /* mve_vcaddq_rot270_m_v8hi */

        case 2:
          if (!
#line 2710 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4579; /* mve_vcaddq_rot270_m_v4si */

        default:
          return -1;
        }

    case 919:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4580; /* mve_vhaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4598; /* mve_vhaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4616; /* mve_vhaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 926:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4581; /* mve_vhaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4599; /* mve_vhaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4617; /* mve_vhaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 889:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4582; /* mve_vhsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4600; /* mve_vhsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4618; /* mve_vhsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 890:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4583; /* mve_vhsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4601; /* mve_vhsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4619; /* mve_vhsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 844:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4584; /* mve_vmlaq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4602; /* mve_vmlaq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4620; /* mve_vmlaq_m_n_sv4si */

        default:
          return -1;
        }

    case 847:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4585; /* mve_vmlaq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4603; /* mve_vmlaq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4621; /* mve_vmlaq_m_n_uv4si */

        default:
          return -1;
        }

    case 855:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4586; /* mve_vmlasq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4604; /* mve_vmlasq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4622; /* mve_vmlasq_m_n_sv4si */

        default:
          return -1;
        }

    case 854:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4587; /* mve_vmlasq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4605; /* mve_vmlasq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4623; /* mve_vmlasq_m_n_uv4si */

        default:
          return -1;
        }

    case 906:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4588; /* mve_vqdmlahq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4606; /* mve_vqdmlahq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4624; /* mve_vqdmlahq_m_n_sv4si */

        default:
          return -1;
        }

    case 867:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4589; /* mve_vqdmlashq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4607; /* mve_vqdmlashq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4625; /* mve_vqdmlashq_m_n_sv4si */

        default:
          return -1;
        }

    case 877:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4590; /* mve_vqrdmlahq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4608; /* mve_vqrdmlahq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4626; /* mve_vqrdmlahq_m_n_sv4si */

        default:
          return -1;
        }

    case 868:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4591; /* mve_vqrdmlashq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4609; /* mve_vqrdmlashq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4627; /* mve_vqrdmlashq_m_n_sv4si */

        default:
          return -1;
        }

    case 899:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4592; /* mve_vqaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4610; /* mve_vqaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4628; /* mve_vqaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 921:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4593; /* mve_vqaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4611; /* mve_vqaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4629; /* mve_vqaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 849:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4594; /* mve_vqsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4612; /* mve_vqsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4630; /* mve_vqsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 848:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4595; /* mve_vqsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4613; /* mve_vqsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4631; /* mve_vqsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 936:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4596; /* mve_vqdmulhq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4614; /* mve_vqdmulhq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4632; /* mve_vqdmulhq_m_n_sv4si */

        default:
          return -1;
        }

    case 966:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4597; /* mve_vqrdmulhq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4615; /* mve_vqrdmulhq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4633; /* mve_vqrdmulhq_m_n_sv4si */

        default:
          return -1;
        }

    case 909:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4634; /* mve_vmladavaq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4639; /* mve_vmladavaq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4644; /* mve_vmladavaq_p_sv4si */

        default:
          return -1;
        }

    case 908:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4635; /* mve_vmladavaq_p_uv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4640; /* mve_vmladavaq_p_uv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4645; /* mve_vmladavaq_p_uv4si */

        default:
          return -1;
        }

    case 935:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4636; /* mve_vmlsdavaxq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4641; /* mve_vmlsdavaxq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4646; /* mve_vmlsdavaxq_p_sv4si */

        default:
          return -1;
        }

    case 940:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4637; /* mve_vmlsdavaq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4642; /* mve_vmlsdavaq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4647; /* mve_vmlsdavaq_p_sv4si */

        default:
          return -1;
        }

    case 932:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4638; /* mve_vmladavaxq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4643; /* mve_vmladavaxq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4648; /* mve_vmladavaxq_p_sv4si */

        default:
          return -1;
        }

    case 893:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4649; /* mve_vmullbq_int_m_uv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4653; /* mve_vmullbq_int_m_uv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4657; /* mve_vmullbq_int_m_uv4si */

        default:
          return -1;
        }

    case 894:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4650; /* mve_vmullbq_int_m_sv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4654; /* mve_vmullbq_int_m_sv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4658; /* mve_vmullbq_int_m_sv4si */

        default:
          return -1;
        }

    case 851:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4651; /* mve_vmulltq_int_m_uv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4655; /* mve_vmulltq_int_m_uv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4659; /* mve_vmulltq_int_m_uv4si */

        default:
          return -1;
        }

    case 850:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4652; /* mve_vmulltq_int_m_sv16qi */

        case 1:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4656; /* mve_vmulltq_int_m_sv8hi */

        case 2:
          if (!
#line 2780 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4660; /* mve_vmulltq_int_m_sv4si */

        default:
          return -1;
        }

    case 916:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4661; /* mve_vqshlq_m_n_sv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4665; /* mve_vqshlq_m_n_sv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4669; /* mve_vqshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 917:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4662; /* mve_vqshlq_m_n_uv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4666; /* mve_vqshlq_m_n_uv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4670; /* mve_vqshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 904:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4663; /* mve_vshlq_m_n_sv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4667; /* mve_vshlq_m_n_sv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4671; /* mve_vshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 907:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4664; /* mve_vshlq_m_n_uv16qi */

        case 1:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4668; /* mve_vshlq_m_n_uv8hi */

        case 2:
          if (!
#line 2799 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4672; /* mve_vshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 832:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4673; /* mve_vrshrq_m_n_sv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4677; /* mve_vrshrq_m_n_sv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4681; /* mve_vrshrq_m_n_sv4si */

        default:
          return -1;
        }

    case 871:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4674; /* mve_vrshrq_m_n_uv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4678; /* mve_vrshrq_m_n_uv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4682; /* mve_vrshrq_m_n_uv4si */

        default:
          return -1;
        }

    case 896:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4675; /* mve_vshrq_m_n_sv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4679; /* mve_vshrq_m_n_sv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4683; /* mve_vshrq_m_n_sv4si */

        default:
          return -1;
        }

    case 863:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4676; /* mve_vshrq_m_n_uv16qi */

        case 1:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4680; /* mve_vshrq_m_n_uv8hi */

        case 2:
          if (!
#line 2818 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4684; /* mve_vshrq_m_n_uv4si */

        default:
          return -1;
        }

    case 898:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4685; /* mve_vsliq_m_n_uv16qi */

        case 1:
          if (!
#line 2836 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4687; /* mve_vsliq_m_n_uv8hi */

        case 2:
          if (!
#line 2836 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4689; /* mve_vsliq_m_n_uv4si */

        default:
          return -1;
        }

    case 910:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4686; /* mve_vsliq_m_n_sv16qi */

        case 1:
          if (!
#line 2836 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4688; /* mve_vsliq_m_n_sv8hi */

        case 2:
          if (!
#line 2836 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4690; /* mve_vsliq_m_n_sv4si */

        default:
          return -1;
        }

    case 944:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4691; /* mve_vmlaldavaq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4696; /* mve_vmlaldavaq_p_sv4si */

        default:
          return -1;
        }

    case 943:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4692; /* mve_vmlaldavaq_p_uv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4697; /* mve_vmlaldavaq_p_uv4si */

        default:
          return -1;
        }

    case 962:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4693; /* mve_vmlaldavaxq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4698; /* mve_vmlaldavaxq_p_sv4si */

        default:
          return -1;
        }

    case 968:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4694; /* mve_vmlsldavaq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4699; /* mve_vmlsldavaq_p_sv4si */

        default:
          return -1;
        }

    case 969:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4695; /* mve_vmlsldavaxq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4700; /* mve_vmlsldavaxq_p_sv4si */

        default:
          return -1;
        }

    case 946:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4701; /* mve_vqrshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4721; /* mve_vqrshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 945:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4702; /* mve_vqrshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4722; /* mve_vqrshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 947:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4703; /* mve_vqrshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4723; /* mve_vqrshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 963:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4704; /* mve_vqrshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4724; /* mve_vqrshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 976:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4705; /* mve_vqrshrunbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4725; /* mve_vqrshrunbq_m_n_sv4si */

        default:
          return -1;
        }

    case 983:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4706; /* mve_vqrshruntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4726; /* mve_vqrshruntq_m_n_sv4si */

        default:
          return -1;
        }

    case 949:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4707; /* mve_vqshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4727; /* mve_vqshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 948:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4708; /* mve_vqshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4728; /* mve_vqshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 950:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4709; /* mve_vqshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4729; /* mve_vqshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 964:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4710; /* mve_vqshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4730; /* mve_vqshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 977:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4711; /* mve_vqshrunbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4731; /* mve_vqshrunbq_m_n_sv4si */

        default:
          return -1;
        }

    case 978:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4712; /* mve_vqshruntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4732; /* mve_vqshruntq_m_n_sv4si */

        default:
          return -1;
        }

    case 952:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4713; /* mve_vrshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4733; /* mve_vrshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 951:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4714; /* mve_vrshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4734; /* mve_vrshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 965:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4715; /* mve_vrshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4735; /* mve_vrshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 953:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4716; /* mve_vrshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4736; /* mve_vrshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 958:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4717; /* mve_vshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4737; /* mve_vshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 959:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4718; /* mve_vshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4738; /* mve_vshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 960:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4719; /* mve_vshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4739; /* mve_vshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 961:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4720; /* mve_vshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4740; /* mve_vshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 967:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4741; /* mve_vrmlaldavhaq_p_sv4si */

    case 979:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4742; /* mve_vrmlaldavhaq_p_uv4si */

    case 980:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4743; /* mve_vrmlaldavhaxq_p_sv4si */

    case 981:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4744; /* mve_vrmlsldavhaq_p_sv4si */

    case 982:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4745; /* mve_vrmlsldavhaxq_p_sv4si */

    case 954:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4746; /* mve_vshllbq_m_n_uv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4750; /* mve_vshllbq_m_n_uv8hi */

        default:
          return -1;
        }

    case 955:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4747; /* mve_vshllbq_m_n_sv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4751; /* mve_vshllbq_m_n_sv8hi */

        default:
          return -1;
        }

    case 956:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4748; /* mve_vshlltq_m_n_uv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4752; /* mve_vshlltq_m_n_uv8hi */

        default:
          return -1;
        }

    case 957:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4749; /* mve_vshlltq_m_n_sv16qi */

        case 1:
          if (!
#line 2926 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4753; /* mve_vshlltq_m_n_sv8hi */

        default:
          return -1;
        }

    case 970:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 2945 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4754; /* mve_vmullbq_poly_m_pv16qi */

        case 1:
          if (!
#line 2945 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4756; /* mve_vmullbq_poly_m_pv8hi */

        default:
          return -1;
        }

    case 971:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 2945 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4755; /* mve_vmulltq_poly_m_pv16qi */

        case 1:
          if (!
#line 2945 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4757; /* mve_vmulltq_poly_m_pv8hi */

        default:
          return -1;
        }

    case 972:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 2964 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4758; /* mve_vqdmullbq_m_n_sv8hi */

        case 1:
          if (!
#line 2964 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4760; /* mve_vqdmullbq_m_n_sv4si */

        default:
          return -1;
        }

    case 974:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 2964 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4759; /* mve_vqdmulltq_m_n_sv8hi */

        case 1:
          if (!
#line 2964 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4761; /* mve_vqdmulltq_m_n_sv4si */

        default:
          return -1;
        }

    case 973:
      switch (pattern228 (x1))
        {
        case 0:
          if (!
#line 2983 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4762; /* mve_vqdmullbq_m_sv8hi */

        case 1:
          if (!
#line 2983 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4764; /* mve_vqdmullbq_m_sv4si */

        default:
          return -1;
        }

    case 975:
      switch (pattern228 (x1))
        {
        case 0:
          if (!
#line 2983 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4763; /* mve_vqdmulltq_m_sv8hi */

        case 1:
          if (!
#line 2983 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4765; /* mve_vqdmulltq_m_sv4si */

        default:
          return -1;
        }

    case 901:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4766; /* mve_vabdq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4774; /* mve_vabdq_m_fv4sf */

        default:
          return -1;
        }

    case 920:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4767; /* mve_vaddq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4775; /* mve_vaddq_m_fv4sf */

        default:
          return -1;
        }

    case 992:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4768; /* mve_vfmaq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4776; /* mve_vfmaq_m_fv4sf */

        default:
          return -1;
        }

    case 995:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4769; /* mve_vfmsq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4777; /* mve_vfmsq_m_fv4sf */

        default:
          return -1;
        }

    case 996:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4770; /* mve_vmaxnmq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4778; /* mve_vmaxnmq_m_fv4sf */

        default:
          return -1;
        }

    case 997:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4771; /* mve_vminnmq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4779; /* mve_vminnmq_m_fv4sf */

        default:
          return -1;
        }

    case 861:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4772; /* mve_vmulq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4780; /* mve_vmulq_m_fv4sf */

        default:
          return -1;
        }

    case 998:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4773; /* mve_vsubq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4781; /* mve_vsubq_m_fv4sf */

        default:
          return -1;
        }

    case 872:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4782; /* mve_vaddq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4787; /* mve_vaddq_m_n_fv4sf */

        default:
          return -1;
        }

    case 993:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4783; /* mve_vfmaq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4788; /* mve_vfmaq_m_n_fv4sf */

        default:
          return -1;
        }

    case 994:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4784; /* mve_vfmasq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4789; /* mve_vfmasq_m_n_fv4sf */

        default:
          return -1;
        }

    case 853:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4785; /* mve_vmulq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4790; /* mve_vmulq_m_n_fv4sf */

        default:
          return -1;
        }

    case 836:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4786; /* mve_vsubq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4791; /* mve_vsubq_m_n_fv4sf */

        default:
          return -1;
        }

    case 886:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4792; /* mve_vandq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4797; /* mve_vandq_m_fv4sf */

        default:
          return -1;
        }

    case 837:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4793; /* mve_vbicq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4798; /* mve_vbicq_m_fv4sf */

        default:
          return -1;
        }

    case 903:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4794; /* mve_veorq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4799; /* mve_veorq_m_fv4sf */

        default:
          return -1;
        }

    case 843:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4795; /* mve_vornq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4800; /* mve_vornq_m_fv4sf */

        default:
          return -1;
        }

    case 880:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4796; /* mve_vorrq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4801; /* mve_vorrq_m_fv4sf */

        default:
          return -1;
        }

    case 900:
      return recog_258 (x1, insn, pnum_clobbers);

    case 895:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4804; /* mve_vcaddq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4810; /* mve_vcaddq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 858:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4805; /* mve_vcaddq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4811; /* mve_vcaddq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 988:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4806; /* mve_vcmulq_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4812; /* mve_vcmulq_m_fv4sf */

        default:
          return -1;
        }

    case 991:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4807; /* mve_vcmulq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4813; /* mve_vcmulq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 989:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4808; /* mve_vcmulq_rot180_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4814; /* mve_vcmulq_rot180_m_fv4sf */

        default:
          return -1;
        }

    case 990:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4809; /* mve_vcmulq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4815; /* mve_vcmulq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 984:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4816; /* mve_vcmlaq_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4820; /* mve_vcmlaq_m_fv4sf */

        default:
          return -1;
        }

    case 987:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4817; /* mve_vcmlaq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4821; /* mve_vcmlaq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 985:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4818; /* mve_vcmlaq_rot180_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4822; /* mve_vcmlaq_rot180_m_fv4sf */

        default:
          return -1;
        }

    case 986:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4819; /* mve_vcmlaq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4823; /* mve_vcmlaq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 1002:
      return recog_247 (x1, insn, pnum_clobbers);

    case 1004:
      return recog_252 (x1, insn, pnum_clobbers);

    case 1010:
      return recog_248 (x1, insn, pnum_clobbers);

    case 1000:
      return recog_251 (x1, insn, pnum_clobbers);

    case 1016:
      return recog_250 (x1, insn, pnum_clobbers);

    case 1026:
      return recog_249 (x1, insn, pnum_clobbers);

    case 1028:
      if (pattern93 (x1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 3);
      operands[3] = x3;
      if (!vpr_register_operand (operands[3], E_V8BImode)
          || !
#line 3717 "../../gcc-15.0.1-20250313/gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4941; /* mve_vstrq_truncate_scatter_shifted_offset_p_v4si */

    default:
      return -1;
    }
}

 int
recog_344 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case MULT:
      res = recog_335 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ROTATERT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1277 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6773; /* *p rorv4hi3 */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1361 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6785; /* *p rorv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1277 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6774; /* *p rorv2si3 */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1361 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6786; /* *p rorv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1277 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6775; /* *p rordi3 */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1361 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6787; /* *p rordi3_di */
          break;

        default:
          break;
        }
      break;

    case ASHIFTRT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6776; /* *p ashrv4hi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6788; /* *p ashrv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6777; /* *p ashrv2si3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6789; /* *p ashrv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1298 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6778; /* *p ashrdi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1382 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6790; /* *p ashrdi3_di */
          break;

        default:
          break;
        }
      if (GET_MODE (x4) == E_DImode)
        {
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              if (arm_reg_or_long_shift_imm (operands[1], E_SImode))
                {
                  x8 = XEXP (x4, 0);
                  if (rtx_equal_p (x8, operands[0])
                      && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1741 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE)))
                    return 6996; /* *p thumb2_asrl */
                }
            }
        }
      break;

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1319 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6779; /* *p lshrv4hi3_iwmmxt */
          if (register_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6791; /* *p lshrv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1319 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6780; /* *p lshrv2si3_iwmmxt */
          if (register_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6792; /* *p lshrv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1319 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6781; /* *p lshrdi3_iwmmxt */
          if (register_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1403 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6793; /* *p lshrdi3_di */
          break;

        default:
          break;
        }
      if (GET_MODE (x4) == E_DImode)
        {
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              if (long_shift_imm (operands[1], E_SImode))
                {
                  x8 = XEXP (x4, 0);
                  if (rtx_equal_p (x8, operands[0])
                      && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1757 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE)))
                    return 6998; /* *p thumb2_lsrl */
                }
            }
        }
      break;

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      switch (pattern408 (x1))
        {
        case 0:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1340 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6782; /* *p ashlv4hi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1424 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6794; /* *p ashlv4hi3_di */
          break;

        case 1:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1340 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6783; /* *p ashlv2si3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1424 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6795; /* *p ashlv2si3_di */
          break;

        case 2:
          if (imm_or_reg_operand (operands[2], E_SImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1340 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6784; /* *p ashldi3_iwmmxt */
          if (imm_or_reg_operand (operands[2], E_DImode)
              && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1424 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return 6796; /* *p ashldi3_di */
          break;

        default:
          break;
        }
      if (GET_MODE (x4) == E_DImode)
        {
          operands[2] = x5;
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          if (arm_general_register_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x4, 1);
              operands[1] = x7;
              if (arm_reg_or_long_shift_imm (operands[1], E_SImode))
                {
                  x8 = XEXP (x4, 0);
                  if (rtx_equal_p (x8, operands[0])
                      && (
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1749 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_HAVE_MVE)))
                    return 6997; /* *p thumb2_lsll */
                }
            }
        }
      break;

    default:
      break;
    }
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  operands[4] = x5;
  x6 = XEXP (x5, 0);
  operands[5] = x6;
  operands[3] = x4;
  if (!shift_operator (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!reg_or_int_operand (operands[2], E_SImode)
      || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4753 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
    return -1;
  return 6468; /* *p *arm_shiftsi3 */
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          if (XWINT (x6, 0) != 0L)
            return -1;
          x7 = XEXP (x1, 0);
          operands[2] = x7;
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode
              || !s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4127 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6455; /* *p *smin_0 */

        case REG:
        case SUBREG:
          switch (pattern441 (x1))
            {
            case 0:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6743; /* *p *sminv2si3_iwmmxt */

            case 1:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6744; /* *p *sminv4hi3_iwmmxt */

            case 2:
              if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 923 "../../gcc-15.0.1-20250313/gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
                return -1;
              return 6745; /* *p *sminv8qi3_iwmmxt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern379 (x1))
        {
        case 0:
          if ((
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4477 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return 6462; /* *p satsi_smin */
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4477 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return -1;
          return 6463; /* *p satsi_smin_setq */

        case 1:
          if (!(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 4503 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6 && !ARM_Q_BIT_READ
   && arm_sat_operator_match (operands[1], operands[2], NULL, NULL))))
            return -1;
          return 6466; /* *p *satsi_smin_shift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XEXP (x1, 0);
      operands[4] = x5;
      x6 = XEXP (x5, 0);
      operands[5] = x6;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case PLUS:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          operands[3] = x11;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[1])
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11940 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
            return -1;
          return 6591; /* *p *load_multiple_with_writeback */

        case MEM:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x12 = XEXP (x7, 0);
          if (GET_CODE (x12) != PLUS
              || GET_MODE (x12) != E_SImode)
            return -1;
          x14 = XEXP (x12, 1);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x8 = XEXP (x3, 1);
          if (GET_CODE (x8) != MEM
              || GET_MODE (x8) != E_SImode
              || !load_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x15 = XEXP (x12, 0);
          operands[3] = x15;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x11 = XEXP (x3, 0);
          operands[2] = x11;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[3])
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 993 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6658; /* *p *ldm2_da */

        case REG:
          operands[1] = x7;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x9 = XEXP (x4, 0);
          if (GET_CODE (x9) != MEM
              || GET_MODE (x9) != E_SImode)
            return -1;
          x16 = XEXP (x9, 0);
          if (GET_CODE (x16) != PLUS
              || GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x16, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
            return -1;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != MEM
              || GET_MODE (x11) != E_SImode
              || !store_multiple_operation (operands[0], E_VOIDmode))
            return -1;
          x18 = XEXP (x16, 0);
          operands[3] = x18;
          if (!s_register_operand (operands[3], E_SImode))
            return -1;
          x8 = XEXP (x3, 1);
          operands[2] = x8;
          if (!arm_hard_general_register_operand (operands[2], E_SImode))
            return -1;
          x19 = XEXP (x11, 0);
          if (!rtx_equal_p (x19, operands[3])
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1018 "../../gcc-15.0.1-20250313/gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 2)))
            return -1;
          return 6660; /* *p *stm2_da */

        default:
          return -1;
        }

    case RETURN:
      x5 = XEXP (x1, 0);
      operands[3] = x5;
      x6 = XEXP (x5, 0);
      operands[4] = x6;
      if (!pop_multiple_return (operands[0], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (GET_CODE (x8))
        {
        case PLUS:
          x11 = XEXP (x3, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x20 = XEXP (x8, 1);
          operands[2] = x20;
          if (!const_int_I_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[1])
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11971 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
            return -1;
          return 6592; /* *p *pop_multiple_with_writeback_and_return */

        case MEM:
          x11 = XEXP (x3, 0);
          operands[2] = x11;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x8, 0);
          operands[1] = x13;
          if (!s_register_operand (operands[1], E_SImode)
              || !(
#line 12240 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11994 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed))))
            return -1;
          return 6593; /* *p *pop_multiple_with_return */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_1 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      if (XWINT (x2, 0) == 0L)
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == ZERO_EXTRACT
              && pattern247 (x3) == 0)
            return gen_split_13 (insn, operands);
        }
      operands[1] = x2;
      if (const_int_operand (operands[1], E_SImode))
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (arm_general_register_operand (operands[0], E_SImode)
              && 
#line 6577 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
((TARGET_32BIT || TARGET_HAVE_MOVT)
  && (!(const_ok_for_arm (INTVAL (operands[1]))
        || const_ok_for_arm (~INTVAL (operands[1]))))))
            return gen_split_63 (insn, operands);
        }
      break;

    case CONST:
      if (GET_MODE (x2) == E_SImode)
        {
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) == PLUS
              && GET_MODE (x4) == E_SImode)
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (arm_general_register_operand (operands[0], E_SImode))
                {
                  x5 = XEXP (x4, 0);
                  operands[1] = x5;
                  if (general_operand (operands[1], E_SImode))
                    {
                      x6 = XEXP (x4, 1);
                      operands[2] = x6;
                      if (const_int_operand (operands[2], E_SImode)
                          && 
#line 6606 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_THUMB
   && TARGET_HAVE_MOVT
   && arm_disable_literal_pool
   && reload_completed
   && GET_CODE (operands[1]) == SYMBOL_REF))
                        return gen_split_64 (insn, operands);
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!arm_general_register_operand (operands[0], E_DImode))
        return NULL;
      if (immediate_operand (operands[1], E_DImode)
          && 
#line 6378 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_40 (insn, operands);
      if (const_double_operand (operands[1], E_DImode)
          && 
#line 6408 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_47 (insn, operands);
      if (!immediate_operand (operands[1], E_DImode)
          || !
#line 752 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_119 (insn, operands);

    case E_DFmode:
      if (arm_general_register_operand (operands[0], E_DFmode))
        {
          if (immediate_operand (operands[1], E_DFmode)
              && 
#line 6378 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
            return gen_split_41 (insn, operands);
          if (const_double_operand (operands[1], E_DFmode)
              && 
#line 6408 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
            return gen_split_48 (insn, operands);
        }
      if (s_register_operand (operands[0], E_DFmode)
          && const_double_operand (operands[1], E_DFmode)
          && 
#line 7658 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_disable_literal_pool && TARGET_SOFT_FLOAT))
        return gen_split_70 (insn, operands);
      if (!arm_general_register_operand (operands[0], E_DFmode)
          || !immediate_operand (operands[1], E_DFmode)
          || !
#line 752 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_120 (insn, operands);

    case E_V8QImode:
      if (!arm_general_register_operand (operands[0], E_V8QImode))
        return NULL;
      if (immediate_operand (operands[1], E_V8QImode)
          && 
#line 6378 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_42 (insn, operands);
      if (const_double_operand (operands[1], E_V8QImode)
          && 
#line 6408 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_49 (insn, operands);
      if (!immediate_operand (operands[1], E_V8QImode)
          || !
#line 752 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_121 (insn, operands);

    case E_V4HImode:
      if (!arm_general_register_operand (operands[0], E_V4HImode))
        return NULL;
      if (immediate_operand (operands[1], E_V4HImode)
          && 
#line 6378 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_43 (insn, operands);
      if (const_double_operand (operands[1], E_V4HImode)
          && 
#line 6408 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_50 (insn, operands);
      if (!immediate_operand (operands[1], E_V4HImode)
          || !
#line 752 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_122 (insn, operands);

    case E_V4HFmode:
      if (!arm_general_register_operand (operands[0], E_V4HFmode))
        return NULL;
      if (immediate_operand (operands[1], E_V4HFmode)
          && 
#line 6378 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_44 (insn, operands);
      if (const_double_operand (operands[1], E_V4HFmode)
          && 
#line 6408 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_51 (insn, operands);
      if (!immediate_operand (operands[1], E_V4HFmode)
          || !
#line 752 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_123 (insn, operands);

    case E_V2SImode:
      if (!arm_general_register_operand (operands[0], E_V2SImode))
        return NULL;
      if (immediate_operand (operands[1], E_V2SImode)
          && 
#line 6378 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_45 (insn, operands);
      if (const_double_operand (operands[1], E_V2SImode)
          && 
#line 6408 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_52 (insn, operands);
      if (!immediate_operand (operands[1], E_V2SImode)
          || !
#line 752 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_124 (insn, operands);

    case E_V2SFmode:
      if (!arm_general_register_operand (operands[0], E_V2SFmode))
        return NULL;
      if (immediate_operand (operands[1], E_V2SFmode)
          && 
#line 6378 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && reload_completed
   && (arm_disable_literal_pool
       || (arm_const_double_inline_cost (operands[1])
	   <= arm_max_const_double_inline_cost ()))))
        return gen_split_46 (insn, operands);
      if (const_double_operand (operands[1], E_V2SFmode)
          && 
#line 6408 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed
   && arm_const_double_by_parts (operands[1])))
        return gen_split_53 (insn, operands);
      if (!immediate_operand (operands[1], E_V2SFmode)
          || !
#line 752 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed && !satisfies_constraint_J (operands[1])))
        return NULL;
      return gen_split_125 (insn, operands);

    case E_SFmode:
      if (arm_general_register_operand (operands[0], E_SFmode)
          && immediate_operand (operands[1], E_SFmode)
          && 
#line 7487 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_EITHER
   && reload_completed
   && CONST_DOUBLE_P (operands[1])))
        return gen_split_68 (insn, operands);
      if (!s_register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 7531 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(arm_disable_literal_pool && TARGET_SOFT_FLOAT))
        return NULL;
      return gen_split_69 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case PLUS:
      res = split_4 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case AND:
    case IOR:
    case XOR:
      res = split_6 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    default:
      break;
    }
  if (!shiftable_operator_strict_it (x3, E_SImode))
    return NULL;
  operands[5] = x3;
  x4 = XEXP (x3, 0);
  if (!arm_comparison_operator (x4, E_SImode))
    return NULL;
  operands[4] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return NULL;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  if (!arm_rhs_operand (operands[3], E_SImode))
    return NULL;
  x9 = XEXP (x3, 1);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode)
      || !(
#line 798 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_restrict_it) && 
#line 800 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
( reload_completed)))
    return NULL;
  return gen_split_149 (insn, operands);
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != NE)
    return NULL;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 2);
  if (GET_CODE (x6) != CONST_INT)
    return NULL;
  operands[3] = x6;
  if (const_int_operand (operands[3], E_SImode))
    {
      x7 = XEXP (x3, 2);
      if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          if (s_register_operand (operands[1], E_SImode))
            {
              x9 = XEXP (x5, 1);
              operands[2] = x9;
              if (const_int_operand (operands[2], E_SImode))
                {
                  x10 = XEXP (x3, 1);
                  operands[4] = x10;
                  if (arm_not_operand (operands[4], E_SImode)
                      && 
#line 3189 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)
   && !reg_overlap_mentioned_p (operands[0], operands[4])))
                    return gen_split_9 (insn, operands);
                }
            }
        }
    }
  if (XWINT (x6, 0) != 0L)
    return NULL;
  x7 = XEXP (x3, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x9 = XEXP (x5, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_SImode))
    return NULL;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!arm_not_operand (operands[3], E_SImode)
      || !
#line 3223 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM && !reg_overlap_mentioned_p (operands[0], operands[3])))
    return NULL;
  return gen_split_10 (insn, operands);
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_11 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_10 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != UNSPEC
              || XVECLEN (x3, 0) != 1
              || pattern285 (x3) != 0)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != CLOBBER
              || pattern451 (x1) != 0
              || !
#line 9306 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(reload_completed))
            return NULL;
          return gen_split_75 (insn, operands);

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x6 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x3 = XEXP (x2, 1);
          switch (GET_CODE (x3))
            {
            case IF_THEN_ELSE:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != EQ)
                return NULL;
              x8 = XEXP (x7, 1);
              if (pattern297 (x8) != 0)
                return NULL;
              x9 = XEXP (x3, 1);
              if (GET_CODE (x9) != LABEL_REF)
                return NULL;
              x10 = XEXP (x3, 2);
              if (GET_CODE (x10) != PC)
                return NULL;
              x11 = XEXP (x2, 0);
              if (GET_CODE (x11) != PC)
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x4) != CLOBBER)
                return NULL;
              x5 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x5) != CLOBBER
                  || pattern577 (x1) != 0
                  || !
#line 9395 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(reload_completed))
                return NULL;
              return gen_split_76 (insn, operands);

            case UNSPEC_VOLATILE:
              switch (pattern265 (x1))
                {
                case 0:
                  if (!((
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_177 (insn, operands);

                case 1:
                  if (!((
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_179 (insn, operands);

                case 2:
                  if (!((
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_178 (insn, operands);

                case 3:
                  if (!((
#line 250 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 252 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_180 (insn, operands);

                case 4:
                  if (!((
#line 281 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_181 (insn, operands);

                case 5:
                  if (!((
#line 281 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_32BIT)) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_183 (insn, operands);

                case 6:
                  if (!((
#line 281 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_182 (insn, operands);

                case 7:
                  if (!((
#line 281 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 57 "../../gcc-15.0.1-20250313/gcc/config/arm/iterators.md"
(TARGET_THUMB1)) && 
#line 283 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_184 (insn, operands);

                case 8:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_189 (insn, operands);

                case 9:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_194 (insn, operands);

                case 10:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_199 (insn, operands);

                case 11:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_204 (insn, operands);

                case 12:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_190 (insn, operands);

                case 13:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_195 (insn, operands);

                case 14:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_200 (insn, operands);

                case 15:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_205 (insn, operands);

                case 16:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_191 (insn, operands);

                case 17:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_196 (insn, operands);

                case 18:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_201 (insn, operands);

                case 19:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_206 (insn, operands);

                case 20:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_192 (insn, operands);

                case 21:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_197 (insn, operands);

                case 22:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_202 (insn, operands);

                case 23:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_207 (insn, operands);

                case 24:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_193 (insn, operands);

                case 25:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_198 (insn, operands);

                case 26:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_203 (insn, operands);

                case 27:
                  if (!(
#line 342 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 344 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_208 (insn, operands);

                case 28:
                  if (!(
#line 366 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_209 (insn, operands);

                case 29:
                  if (!(
#line 366 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_210 (insn, operands);

                case 30:
                  if (!(
#line 366 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_211 (insn, operands);

                case 31:
                  if (!(
#line 366 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 368 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_212 (insn, operands);

                default:
                  return NULL;
                }

            case MEM:
              operands[1] = x3;
              if (pattern319 (x1, 
18, 
2) != 0)
                return NULL;
              x11 = XEXP (x2, 0);
              operands[0] = x11;
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              x13 = XVECEXP (x12, 0, 0);
              operands[2] = x13;
              x14 = XVECEXP (x12, 0, 1);
              operands[3] = x14;
              if (!const_int_operand (operands[3], E_SImode))
                return NULL;
              x15 = XEXP (x6, 0);
              operands[4] = x15;
              if (!scratch_operand (operands[4], E_SImode))
                return NULL;
              x16 = XEXP (x4, 0);
              if (!rtx_equal_p (x16, operands[1]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern576 (x12, 
E_QImode) != 0
                      || !(
#line 301 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_185 (insn, operands);

                case E_HImode:
                  if (pattern576 (x12, 
E_HImode) != 0
                      || !(
#line 301 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_186 (insn, operands);

                case E_SImode:
                  if (pattern576 (x12, 
E_SImode) != 0
                      || !(
#line 301 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_187 (insn, operands);

                case E_DImode:
                  if (pattern576 (x12, 
E_DImode) != 0
                      || !(
#line 301 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 303 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_188 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_237 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_242 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_247 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_252 (insn, operands);

                default:
                  return NULL;
                }

            case MINUS:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_238 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_243 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_248 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_253 (insn, operands);

                default:
                  return NULL;
                }

            case IOR:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_239 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_244 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_249 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_254 (insn, operands);

                default:
                  return NULL;
                }

            case XOR:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_240 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_245 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_250 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_255 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              switch (pattern286 (x1))
                {
                case 0:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_241 (insn, operands);

                case 1:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_246 (insn, operands);

                case 2:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_251 (insn, operands);

                case 3:
                  if (!(
#line 457 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 459 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_256 (insn, operands);

                default:
                  return NULL;
                }

            case NOT:
              x7 = XEXP (x3, 0);
              if (GET_CODE (x7) != AND
                  || pattern319 (x1, 
19, 
3) != 0)
                return NULL;
              switch (pattern531 (x1))
                {
                case 0:
                  if (!(
#line 483 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_257 (insn, operands);

                case 1:
                  if (!(
#line 483 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_258 (insn, operands);

                case 2:
                  if (!(
#line 483 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_259 (insn, operands);

                case 3:
                  if (!(
#line 483 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 485 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_260 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET
              || pattern12 (x1) != 0)
            return NULL;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          switch (pattern565 (x1))
            {
            case 0:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_213 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_218 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_223 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_228 (insn, operands);

                default:
                  return NULL;
                }

            case 1:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_214 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_219 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_224 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_229 (insn, operands);

                default:
                  return NULL;
                }

            case 2:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_215 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_220 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_225 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_230 (insn, operands);

                default:
                  return NULL;
                }

            case 3:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_216 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_221 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_226 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_231 (insn, operands);

                default:
                  return NULL;
                }

            case 4:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              switch (pattern613 (x12))
                {
                case 0:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_217 (insn, operands);

                case 1:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_222 (insn, operands);

                case 2:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_227 (insn, operands);

                case 3:
                  if (!(
#line 406 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 408 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_232 (insn, operands);

                default:
                  return NULL;
                }

            case 5:
              x4 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x4, 1);
              x13 = XVECEXP (x12, 0, 0);
              x17 = XEXP (x13, 0);
              if (GET_CODE (x17) != AND)
                return NULL;
              x18 = XEXP (x17, 1);
              operands[2] = x18;
              x19 = XEXP (x17, 0);
              if (!rtx_equal_p (x19, operands[1]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (pattern622 (x12, 
E_QImode) != 0
                      || !(
#line 432 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_233 (insn, operands);

                case E_HImode:
                  if (pattern622 (x12, 
E_HImode) != 0
                      || !(
#line 432 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_234 (insn, operands);

                case E_SImode:
                  if (pattern622 (x12, 
E_SImode) != 0
                      || !(
#line 432 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_235 (insn, operands);

                case E_DImode:
                  if (pattern623 (x12) != 0
                      || !(
#line 432 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER) && 
#line 434 "../../gcc-15.0.1-20250313/gcc/config/arm/sync.md"
( reload_completed)))
                    return NULL;
                  return gen_split_236 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case COND_EXEC:
      x20 = XEXP (x1, 0);
      if (!arm_comparison_operator (x20, E_VOIDmode))
        return NULL;
      x21 = XEXP (x20, 1);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x22 = XEXP (x20, 0);
      if (!cc_register (x22, E_VOIDmode))
        return NULL;
      x23 = XEXP (x1, 1);
      switch (GET_CODE (x23))
        {
        case SET:
          x24 = XEXP (x23, 1);
          switch (GET_CODE (x24))
            {
            case PLUS:
              if (pattern320 (x1) != 0
                  || !
#line 962 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_op (INTVAL (operands[2]), PLUS)
   && (reload_completed || !arm_eliminable_register (operands[1]))))
                return NULL;
              return gen_split_261 (insn, operands);

            case MINUS:
              if (GET_MODE (x24) != E_SImode)
                return NULL;
              operands[3] = x20;
              operands[4] = x22;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x26 = XEXP (x24, 0);
              operands[1] = x26;
              if (!reg_or_int_operand (operands[1], E_SImode))
                return NULL;
              x27 = XEXP (x24, 1);
              operands[2] = x27;
              if (!reg_or_int_operand (operands[2], E_SImode)
                  || !(
#line 2020 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 2031 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
( (CONST_INT_P (operands[1])
       && !const_ok_for_arm (INTVAL (operands[1]))))))
                return NULL;
              return gen_split_262 (insn, operands);

            case AND:
              if (GET_MODE (x24) != E_SImode)
                return NULL;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x26 = XEXP (x24, 0);
              switch (GET_CODE (x26))
                {
                case REG:
                case SUBREG:
                  operands[1] = x26;
                  if (!s_register_operand (operands[1], E_SImode))
                    return NULL;
                  operands[3] = x20;
                  operands[4] = x22;
                  x27 = XEXP (x24, 1);
                  operands[2] = x27;
                  if (!reg_or_int_operand (operands[2], E_SImode)
                      || !
#line 3031 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
	|| const_ok_for_arm (~INTVAL (operands[2]))
	|| (arm_arch_thumb2
	    && satisfies_constraint_Dj (operands[2])
	    && (rtx_equal_p (operands[0], operands[1])
		|| !reload_completed)))))
                    return NULL;
                  return gen_split_263 (insn, operands);

                case IOR:
                  if (GET_MODE (x26) != E_SImode)
                    return NULL;
                  x27 = XEXP (x24, 1);
                  if (GET_CODE (x27) != NOT
                      || GET_MODE (x27) != E_SImode)
                    return NULL;
                  operands[4] = x20;
                  operands[5] = x22;
                  x28 = XEXP (x26, 0);
                  operands[1] = x28;
                  if (!s_register_operand (operands[1], E_SImode))
                    return NULL;
                  x29 = XEXP (x26, 1);
                  operands[2] = x29;
                  if (!arm_rhs_operand (operands[2], E_SImode))
                    return NULL;
                  x30 = XEXP (x27, 0);
                  operands[3] = x30;
                  if (!arm_rhs_operand (operands[3], E_SImode)
                      || !(
#line 3910 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 3912 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
( reload_completed)))
                    return NULL;
                  return gen_split_267 (insn, operands);

                default:
                  return NULL;
                }

            case CONST_INT:
              if (XWINT (x24, 0) != 0L)
                return NULL;
              x25 = XEXP (x23, 0);
              if (GET_CODE (x25) != ZERO_EXTRACT
                  || GET_MODE (x25) != E_SImode)
                return NULL;
              operands[3] = x20;
              operands[4] = x22;
              x31 = XEXP (x25, 0);
              operands[0] = x31;
              if (!s_register_operand (operands[0], E_SImode))
                return NULL;
              x32 = XEXP (x25, 1);
              operands[1] = x32;
              if (!const_int_M_operand (operands[1], E_SImode))
                return NULL;
              x33 = XEXP (x25, 2);
              operands[2] = x33;
              if (!const_int_M_operand (operands[2], E_SImode))
                return NULL;
              return gen_split_264 (insn, operands);

            case IOR:
              if (pattern320 (x1) != 0
                  || !
#line 3744 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !(const_ok_for_arm (INTVAL (operands[2]))
        || (TARGET_THUMB2 && const_ok_for_arm (~INTVAL (operands[2]))))))
                return NULL;
              return gen_split_265 (insn, operands);

            case XOR:
              if (pattern320 (x1) != 0
                  || !
#line 3849 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_32BIT
   && CONST_INT_P (operands[2])
   && !const_ok_for_arm (INTVAL (operands[2]))))
                return NULL;
              return gen_split_266 (insn, operands);

            case NEG:
              if (GET_MODE (x24) != E_DFmode)
                return NULL;
              operands[2] = x20;
              operands[3] = x22;
              x25 = XEXP (x23, 0);
              operands[0] = x25;
              if (!s_register_operand (operands[0], E_DFmode))
                return NULL;
              x26 = XEXP (x24, 0);
              operands[1] = x26;
              if (!s_register_operand (operands[1], E_DFmode)
                  || !
#line 906 "../../gcc-15.0.1-20250313/gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE && reload_completed
   && arm_general_register_operand (operands[0], DFmode)))
                return NULL;
              return gen_split_270 (insn, operands);

            default:
              return NULL;
            }

        case PARALLEL:
          if (XVECLEN (x23, 0) != 2)
            return NULL;
          x34 = XVECEXP (x23, 0, 0);
          if (GET_CODE (x34) != SET
              || pattern363 (x1) != 0)
            return NULL;
          x35 = XEXP (x34, 0);
          operands[0] = x35;
          if (!s_register_operand (operands[0], E_SImode))
            return NULL;
          x36 = XEXP (x34, 1);
          if (GET_MODE (x36) != E_SImode)
            return NULL;
          switch (GET_CODE (x36))
            {
            case ABS:
              x37 = XEXP (x36, 0);
              operands[1] = x37;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 5255 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5257 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_268 (insn, operands);
              if (!(
#line 117 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 122 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_271 (insn, operands);

            case NEG:
              x37 = XEXP (x36, 0);
              if (GET_CODE (x37) != ABS
                  || GET_MODE (x37) != E_SImode)
                return NULL;
              x38 = XEXP (x37, 0);
              operands[1] = x38;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              if ((
#line 5319 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5321 "../../gcc-15.0.1-20250313/gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_269 (insn, operands);
              if (!(
#line 170 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 175 "../../gcc-15.0.1-20250313/gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_272 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
