/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_PSImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[3] = x7;
  x8 = XEXP (x1, 1);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern10 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern10 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern10 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern10 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x3);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 23
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 1)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24)
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 26
      || GET_MODE (x13) != E_HImode)
    return -1;
  x14 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 30
      || GET_MODE (x15) != E_HImode)
    return -1;
  x16 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 0
      || GET_MODE (x17) != E_QImode)
    return -1;
  x18 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 24
      || GET_MODE (x19) != E_HImode)
    return -1;
  x20 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 23
      || GET_MODE (x21) != E_QImode)
    return -1;
  x22 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != MEM
      || GET_MODE (x23) != E_QImode)
    return -1;
  x24 = XVECEXP (x9, 0, 0);
  operands[0] = x24;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x25 = XEXP (x23, 0);
  operands[1] = x25;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x11))
    {
    case E_QImode:
      return 0;

    case E_HImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern53 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 16
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 18)
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode
          || GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode
          || GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode
          || GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      return pattern67 (x1); /* [-1, 6] */

    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 26
          || GET_MODE (x6) != E_QImode
          || GET_MODE (x4) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 7;

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      res = pattern68 (x1);
      if (res >= 0)
        return res + 8; /* [8, 14] */
      return -1;

    default:
      return -1;
    }
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  return 0;
}

int
pattern96 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  return 0;
}

int
pattern104 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_QImode)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern109 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != REG)
    return -1;
  x11 = XEXP (x7, 0);
  if (GET_CODE (x11) != REG)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG)
    return -1;
  x14 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG)
    return -1;
  x16 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG)
    return -1;
  switch (REGNO (x4))
    {
    case 24:
      return 0;

    case 22:
      return 1;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[3] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x1) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || GET_MODE (x3) != E_QImode
              || !register_operand (operands[2], E_QImode)
              || !const7_operand (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !register_operand (operands[2], E_HImode)
              || !const15_operand (operands[3], E_QImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x1) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || !register_operand (operands[2], E_PSImode)
              || !const23_operand (operands[3], E_QImode))
            return -1;
          return 2;

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[2], E_SImode)
              || !const31_operand (operands[3], E_QImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !register_operand (operands[1], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[2], E_QImode)
              || !const15_operand (operands[3], E_QImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x1) != E_PSImode
              || !register_operand (operands[1], E_PSImode)
              || GET_MODE (x3) != E_PSImode
              || GET_MODE (x5) != E_PSImode
              || !const23_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x5) != E_SImode
              || !const31_operand (operands[3], E_QImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_QImode:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              return 7;

            case E_HImode:
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 8;

            case E_PSImode:
              if (!register_operand (operands[2], E_PSImode))
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern153 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  if (REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_PSImode))
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!const_int_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern162 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XINT (x2, 1) != 1
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 28
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 28
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PLUS
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 28
      || GET_MODE (x10) != E_HImode)
    return -1;
  x11 = XEXP (x8, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 32
      || GET_MODE (x11) != E_HImode)
    return -1;
  return 0;
}

int
pattern174 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 22
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 18
      || GET_MODE (x5) != E_PSImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22
      || GET_MODE (x6) != E_PSImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != i1
      || GET_MODE (x8) != E_PSImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 22
      || GET_MODE (x9) != E_PSImode)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 18
      || GET_MODE (x10) != E_PSImode)
    return -1;
  x11 = XEXP (x7, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 18
      || GET_MODE (x11) != E_PSImode)
    return -1;
  x12 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 21
      || GET_MODE (x13) != E_QImode
      || pattern173 (x1, 
E_QImode, 
26, 
25) != 0)
    return -1;
  return 0;
}

int
pattern186 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (XWINT (x6, 0) != 8L)
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode
      || GET_MODE (x3) != E_HImode
      || GET_MODE (x4) != E_HImode)
    return -1;
  x8 = XEXP (x4, 0);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x10 = XEXP (x5, 0);
  operands[2] = x10;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern200 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != IF_THEN_ELSE)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  return 0;
}

int
pattern205 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern212 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  return 0;
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case MEM:
      if (GET_MODE (x1) != E_QImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      if (!low_io_address_operand (operands[0], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[0] = x1;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern222 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || !register_operand (operands[3], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern227 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_UQQmode:
      return pattern99 (x1, 
E_UQQmode); /* [-1, 0] */

    case E_UHQmode:
      if (pattern99 (x1, 
E_UHQmode) != 0)
        return -1;
      return 1;

    case E_UHAmode:
      if (pattern99 (x1, 
E_UHAmode) != 0)
        return -1;
      return 2;

    case E_USAmode:
      if (pattern99 (x1, 
E_USAmode) != 0)
        return -1;
      return 3;

    case E_USQmode:
      if (pattern99 (x1, 
E_USQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTEND
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != NOT
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 18
      || GET_MODE (x10) != E_DImode)
    return -1;
  x11 = XEXP (x2, 0);
  operands[0] = x11;
  if (!pseudo_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x12 = XEXP (x6, 0);
  operands[1] = x12;
  if (!pseudo_register_operand (operands[1], E_HImode))
    return -1;
  x13 = XEXP (x3, 1);
  operands[2] = x13;
  if (!pseudo_register_or_const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern238 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 26
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern171 (x5); /* [-1, 10] */
}

int
pattern246 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern260 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_SAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_SAmode)
        return -1;
      return 0;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_USAmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_USAmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern271 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 26)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 24)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22
      || GET_MODE (x7) != E_HImode)
    return -1;
  return pattern230 (x2); /* [-1, 3] */
}

int
pattern275 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XEXP (x5, 1);
  if (GET_CODE (x8) != i1
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 26
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x4, 1);
  if (XWINT (x10, 0) != 16L)
    return -1;
  x11 = XEXP (x2, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24
      || GET_MODE (x11) != E_HImode)
    return -1;
  x12 = XVECEXP (x1, 0, 1);
  x13 = XEXP (x12, 0);
  if (REGNO (x13) != 22
      || GET_MODE (x13) != E_HImode
      || GET_MODE (x3) != E_HImode
      || GET_MODE (x4) != E_SImode
      || GET_MODE (x5) != E_SImode)
    return -1;
  return 0;
}

int
pattern283 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x1, 0);
  if (REGNO (x5) != i2
      || GET_MODE (x5) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_MODE (x6) != i1
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern294 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != i4)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 24)
    return -1;
  return pattern265 (x1, 
i1, 
i2, 
i3); /* [-1, 3] */
}

int
pattern301 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !const_int_operand (operands[1], i1)
      || GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 3)
    return -1;
  return pattern300 (x1, 
i1); /* [-1, 2] */
}

int
pattern304 (rtx x1, machine_mode i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PARALLEL
      || XVECLEN (x1, 0) != 2
      || pattern303 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern307 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != PARALLEL
      || XVECLEN (x2, 0) != 2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != COMPARE
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  return 0;
}

int
pattern316 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!l_register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!l_register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!l_register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22
      || GET_MODE (x5) != E_SImode
      || pattern297 (x1, 
E_QImode, 
26, 
22) != 0)
    return -1;
  return 0;
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 25
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  return pattern133 (x6); /* [-1, 1] */
}

int
pattern328 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i3
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2
      || GET_MODE (x7) != E_HImode
      || pattern129 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern334 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern338 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[2] = x1;
  if (!const_operand (operands[2], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern337 (x3); /* [-1, 0] */
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern348 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (REGNO (x3))
    {
    case 18:
      if (GET_MODE (x3) != E_SImode
          || pattern347 (x1, 
E_SImode, 
30, 
E_HImode, 
26) != 0)
        return -1;
      return 0;

    case 21:
      if (GET_MODE (x3) != E_QImode
          || pattern347 (x1, 
E_PSImode, 
26, 
E_QImode, 
25) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern355 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i2
      || pattern131 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern361 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i3
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != i2
      || pattern131 (x1, 
i1) != 0)
    return -1;
  return 0;
}

int
pattern365 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  if (!const0_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XEXP (x2, 1);
  return pattern335 (x3); /* [-1, 1] */
}

int
pattern370 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != LABEL_REF)
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return 0;

    case E_PSImode:
      return 1;

    case E_SImode:
      return 2;

    default:
      return -1;
    }
}

int
pattern378 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      return pattern376 (x6, 
E_HImode); /* [-1, 5] */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || !const0_operand (operands[3], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern377 (x6, 
E_QImode);
          if (res >= 0)
            return res + 6; /* [6, 11] */
          return -1;

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern377 (x6, 
E_HImode);
          if (res >= 0)
            return res + 12; /* [12, 17] */
          return -1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || !const0_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern377 (x6, 
E_QImode);
          if (res >= 0)
            return res + 18; /* [18, 23] */
          return -1;

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern377 (x6, 
E_HImode);
          if (res >= 0)
            return res + 24; /* [24, 29] */
          return -1;

        case E_PSImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern377 (x6, 
E_PSImode);
          if (res >= 0)
            return res + 30; /* [30, 35] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern178 (x3, 
E_QImode) != 0)
        return -1;
      if (
#line 2200 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 300; /* *mulqi3_enh_split */
      if (pnum_clobbers == NULL
          || !
#line 2213 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 301; /* *mulqi3_enh */

    case E_HImode:
      if (pattern178 (x3, 
E_HImode) != 0)
        return -1;
      if (
#line 3268 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 537; /* *mulhi3_enh_split */
      if (pnum_clobbers == NULL
          || !
#line 3281 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 538; /* *mulhi3_enh */

    case E_SImode:
      if (pattern179 (x3, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      if (pseudo_register_or_const_int_operand (operands[2], E_SImode)
          && 
#line 3398 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        {
          *pnum_clobbers = 2;
          return 541; /* *mulsi3 */
        }
      if (!pseudo_register_operand (operands[2], E_SImode)
          || !
#line 3434 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 542; /* *mulsi3_pr118012 */

    case E_PSImode:
      if (pattern179 (x3, pnum_clobbers, 
E_PSImode) != 0
          || !pseudo_register_or_const_int_operand (operands[2], E_PSImode)
          || !
#line 4192 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 601; /* *mulpsi3 */

    case E_QQmode:
      if (pattern178 (x3, 
E_QQmode) != 0)
        return -1;
      if (
#line 296 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
        return 3053; /* mulqq3_enh */
      if (pnum_clobbers == NULL
          || !
#line 309 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3054; /* *mulqq3_enh */

    case E_UQQmode:
      if (pattern178 (x3, 
E_UQQmode) != 0)
        return -1;
      if (
#line 317 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
        return 3055; /* muluqq3_enh */
      if (pnum_clobbers == NULL
          || !
#line 330 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3056; /* *muluqq3_enh */

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != ZERO_EXTEND)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_QImode
          || REGNO (x6) != 24
          || pattern283 (x1, 
E_HImode, 
24, 
E_QImode) != 0)
        return -1;
      if (
#line 2432 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
        {
          *pnum_clobbers = 2;
          return 476; /* *umulqihi3.call_split */
        }
      if (!
#line 2449 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 477; /* *umulqihi3.call */

    case 18:
      if (GET_MODE (x4) != E_SImode
          || REGNO (x6) != 22
          || pattern283 (x1, 
E_DImode, 
18, 
E_SImode) != 0)
        return -1;
      if (
#line 675 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
        {
          *pnum_clobbers = 2;
          return 3338; /* umulsidi3_insn */
        }
      if (!
#line 693 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 3340; /* *umulsidi3_insn */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x2, 1);
  switch (pattern244 (x4, pnum_clobbers))
    {
    case 0:
      if (s8_operand (operands[2], E_HImode)
          && 
#line 2989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 521; /* *mulsqihi3.sconst */
        }
      if (u8_operand (operands[2], E_HImode)
          && 
#line 3025 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 524; /* *mulsqihi3.uconst */
        }
      if (!o8_operand (operands[2], E_HImode)
          || !
#line 3043 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      *pnum_clobbers = 1;
      return 525; /* *mulsqihi3.oconst */

    case 1:
      if (
#line 3144 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 531; /* mulsqihi3 */
      if (pnum_clobbers == NULL
          || !
#line 3157 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 532; /* *mulsqihi3 */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern49 (x3, 
E_QImode) != 0)
        return -1;
      return 661; /* *ashlqi3_split */

    case E_QQmode:
      if (pattern49 (x3, 
E_QQmode) != 0)
        return -1;
      return 662; /* *ashlqq3_split */

    case E_UQQmode:
      if (pattern49 (x3, 
E_UQQmode) != 0)
        return -1;
      return 663; /* *ashluqq3_split */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 667; /* ashlhi3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 692; /* *ashlhi3_const */

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 668; /* ashlhq3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 693; /* *ashlhq3_const */

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 669; /* ashluhq3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 694; /* *ashluhq3_const */

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 670; /* ashlha3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 695; /* *ashlha3_const */

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 671; /* ashluha3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 696; /* *ashluha3_const */

    case E_SImode:
      if (pattern49 (x3, 
E_SImode) != 0)
        return -1;
      return 682; /* ashlsi3 */

    case E_SQmode:
      if (pattern49 (x3, 
E_SQmode) != 0)
        return -1;
      return 683; /* ashlsq3 */

    case E_USQmode:
      if (pattern49 (x3, 
E_USQmode) != 0)
        return -1;
      return 684; /* ashlusq3 */

    case E_SAmode:
      if (pattern49 (x3, 
E_SAmode) != 0)
        return -1;
      return 685; /* ashlsa3 */

    case E_USAmode:
      if (pattern49 (x3, 
E_USAmode) != 0)
        return -1;
      return 686; /* ashlusa3 */

    case E_PSImode:
      if (pattern50 (x3, pnum_clobbers, 
E_QImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 702; /* *ashlpsi3_split */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (pattern83 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      operands[0] = x3;
      switch (pattern247 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && nonmemory_operand (operands[2], E_QImode))
                return 878; /* cbranchqi4_insn */
              break;

            case E_QQmode:
              if (register_operand (operands[1], E_QQmode)
                  && nonmemory_operand (operands[2], E_QQmode))
                return 879; /* cbranchqq4_insn */
              break;

            case E_UQQmode:
              if (register_operand (operands[1], E_UQQmode)
                  && nonmemory_operand (operands[2], E_UQQmode))
                return 880; /* cbranchuqq4_insn */
              break;

            case E_SImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SImode)
                  && nonmemory_operand (operands[2], E_SImode))
                {
                  *pnum_clobbers = 1;
                  return 881; /* cbranchsi4_insn */
                }
              break;

            case E_SQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SQmode)
                  && nonmemory_operand (operands[2], E_SQmode))
                {
                  *pnum_clobbers = 1;
                  return 882; /* cbranchsq4_insn */
                }
              break;

            case E_USQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_USQmode)
                  && nonmemory_operand (operands[2], E_USQmode))
                {
                  *pnum_clobbers = 1;
                  return 883; /* cbranchusq4_insn */
                }
              break;

            case E_SAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SAmode)
                  && nonmemory_operand (operands[2], E_SAmode))
                {
                  *pnum_clobbers = 1;
                  return 884; /* cbranchsa4_insn */
                }
              break;

            case E_USAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_USAmode)
                  && nonmemory_operand (operands[2], E_USAmode))
                {
                  *pnum_clobbers = 1;
                  return 885; /* cbranchusa4_insn */
                }
              break;

            case E_PSImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_PSImode)
                  && nonmemory_operand (operands[2], E_PSImode))
                {
                  *pnum_clobbers = 1;
                  return 886; /* cbranchpsi4_insn */
                }
              break;

            case E_HImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HImode)
                  && nonmemory_operand (operands[2], E_HImode))
                {
                  *pnum_clobbers = 1;
                  return 887; /* cbranchhi4_insn */
                }
              break;

            case E_HQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HQmode)
                  && nonmemory_operand (operands[2], E_HQmode))
                {
                  *pnum_clobbers = 1;
                  return 888; /* cbranchhq4_insn */
                }
              break;

            case E_UHQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_UHQmode)
                  && nonmemory_operand (operands[2], E_UHQmode))
                {
                  *pnum_clobbers = 1;
                  return 889; /* cbranchuhq4_insn */
                }
              break;

            case E_HAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HAmode)
                  && nonmemory_operand (operands[2], E_HAmode))
                {
                  *pnum_clobbers = 1;
                  return 890; /* cbranchha4_insn */
                }
              break;

            case E_UHAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_UHAmode)
                  && nonmemory_operand (operands[2], E_UHAmode))
                {
                  *pnum_clobbers = 1;
                  return 891; /* cbranchuha4_insn */
                }
              break;

            default:
              break;
            }
          break;

        case 1:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return 904; /* *cbranchhi.sign_extendqi.0 */
          break;

        case 2:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return 906; /* *cbranchpsi.sign_extendqi.0 */
          break;

        case 3:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return 910; /* *cbranchpsi.sign_extendhi.0 */
          break;

        case 4:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return 908; /* *cbranchsi.sign_extendqi.0 */
          break;

        case 5:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return 912; /* *cbranchsi.sign_extendhi.0 */
          break;

        case 6:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return 914; /* *cbranchsi.sign_extendpsi.0 */
          break;

        case 7:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return 905; /* *cbranchhi.zero_extendqi.0 */
          break;

        case 8:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return 907; /* *cbranchpsi.zero_extendqi.0 */
          break;

        case 9:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return 911; /* *cbranchpsi.zero_extendhi.0 */
          break;

        case 10:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return 909; /* *cbranchsi.zero_extendqi.0 */
          break;

        case 11:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return 913; /* *cbranchsi.zero_extendhi.0 */
          break;

        case 12:
          if (
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return 915; /* *cbranchsi.zero_extendpsi.0 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != REG)
        return -1;
      switch (REGNO (x4))
        {
        case 36:
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          switch (GET_MODE (x4))
            {
            case E_CCmode:
              if (!
#line 7780 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 966; /* branch */

            case E_CCNmode:
              if (!
#line 7780 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 967; /* branch_N */

            case E_CCZNmode:
              if (!
#line 7780 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 968; /* branch_ZN */

            default:
              return -1;
            }

        case 18:
          operands[0] = x3;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
              if (REGNO (x5) != 10)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              switch (pattern317 (x3))
                {
                case 0:
                  if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3251; /* cbranch_di2_split */

                case 1:
                  if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3252; /* cbranch_dq2_split */

                case 2:
                  if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3253; /* cbranch_udq2_split */

                case 3:
                  if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3254; /* cbranch_da2_split */

                case 4:
                  if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3255; /* cbranch_uda2_split */

                case 5:
                  if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3256; /* cbranch_ta2_split */

                case 6:
                  if (!
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3257; /* cbranch_uta2_split */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (pattern284 (x3) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (!
#line 529 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                return -1;
              return 3265; /* cbranch_const8_di2_split */

            case CONST_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (!const_operand (operands[1], E_DImode)
                      || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3267; /* cbranch_const_di2_split */

                case E_DQmode:
                  if (!const_operand (operands[1], E_DQmode)
                      || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3268; /* cbranch_const_dq2_split */

                case E_UDQmode:
                  if (!const_operand (operands[1], E_UDQmode)
                      || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3269; /* cbranch_const_udq2_split */

                case E_DAmode:
                  if (!const_operand (operands[1], E_DAmode)
                      || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3270; /* cbranch_const_da2_split */

                case E_UDAmode:
                  if (!const_operand (operands[1], E_UDAmode)
                      || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3271; /* cbranch_const_uda2_split */

                case E_TAmode:
                  if (!const_operand (operands[1], E_TAmode)
                      || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3272; /* cbranch_const_ta2_split */

                case E_UTAmode:
                  if (!const_operand (operands[1], E_UTAmode)
                      || !
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3273; /* cbranch_const_uta2_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern219 (x2))
        {
        case 0:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return -1;
          return 892; /* *cbranchhi.sign_extendqi.0 */

        case 1:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return -1;
          return 894; /* *cbranchpsi.sign_extendqi.0 */

        case 2:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return -1;
          return 898; /* *cbranchpsi.sign_extendhi.0 */

        case 3:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return -1;
          return 896; /* *cbranchsi.sign_extendqi.0 */

        case 4:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return -1;
          return 900; /* *cbranchsi.sign_extendhi.0 */

        case 5:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return -1;
          return 902; /* *cbranchsi.sign_extendpsi.0 */

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern219 (x2))
        {
        case 0:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return -1;
          return 893; /* *cbranchhi.zero_extendqi.0 */

        case 1:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return -1;
          return 895; /* *cbranchpsi.zero_extendqi.0 */

        case 2:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return -1;
          return 899; /* *cbranchpsi.zero_extendhi.0 */

        case 3:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return -1;
          return 897; /* *cbranchsi.zero_extendqi.0 */

        case 4:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return -1;
          return 901; /* *cbranchsi.zero_extendhi.0 */

        case 5:
          if (!
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return -1;
          return 903; /* *cbranchsi.zero_extendpsi.0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG)
        return -1;
      switch (pattern53 (x1))
        {
        case 0:
          if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3284; /* rotldi3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3312; /* *rotldi3_insn */

        case 1:
          if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3288; /* rotldq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3316; /* *rotldq3_insn */

        case 2:
          if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3292; /* rotludq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3320; /* *rotludq3_insn */

        case 3:
          if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3296; /* rotlda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3324; /* *rotlda3_insn */

        case 4:
          if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3300; /* rotluda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3328; /* *rotluda3_insn */

        case 5:
          if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3304; /* rotlta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3332; /* *rotlta3_insn */

        case 6:
          if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3308; /* rotluta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3336; /* *rotluta3_insn */

        default:
          return -1;
        }

    case CONST_INT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      switch (XWINT (x3, 0))
        {
        case 1L:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode)
              || !
#line 8971 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1014; /* *mask1_0x01 */

        case -2L:
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case AND:
              if (GET_MODE (x5) != E_QImode)
                return -1;
              x6 = XEXP (x5, 1);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return -1;
              x7 = XEXP (x5, 0);
              operands[1] = x7;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1018; /* mask1_0xfe_split */

            case REG:
            case SUBREG:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode)
                  || !
#line 9047 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 1019; /* *mask1_0xfe */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 258; /* *subhi3.sign_extend.qi */

        case 1:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 260; /* *subpsi3.sign_extend.qi */

        case 2:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 264; /* *subpsi3.sign_extend.hi */

        case 3:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 262; /* *subsi3.sign_extend.qi */

        case 4:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 266; /* *subsi3.sign_extend.hi */

        case 5:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 268; /* *subsi3.sign_extend.psi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 259; /* *subhi3.zero_extend.qi */

        case 1:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 261; /* *subpsi3.zero_extend.qi */

        case 2:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 265; /* *subpsi3.zero_extend.hi */

        case 3:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 263; /* *subsi3.zero_extend.qi */

        case 4:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 267; /* *subsi3.zero_extend.hi */

        case 5:
          if (!
#line 2029 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 269; /* *subsi3.zero_extend.psi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_PSImode:
              if (pattern309 (x3, 
E_PSImode) == 0
                  && 
#line 2083 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 273; /* *subpsi3 */
              break;

            case E_QImode:
              if (pattern296 (x3, 
E_QImode) == 0
                  && 
#line 2110 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 277; /* *subqi3 */
              break;

            case E_QQmode:
              if (pattern296 (x3, 
E_QQmode) == 0
                  && 
#line 2110 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 278; /* *subqq3 */
              break;

            case E_UQQmode:
              if (pattern296 (x3, 
E_UQQmode) == 0
                  && 
#line 2110 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 279; /* *subuqq3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern296 (x3, 
E_HImode) != 0)
            return -1;
          return 280; /* subhi3 */

        case E_HQmode:
          if (pattern296 (x3, 
E_HQmode) != 0)
            return -1;
          return 281; /* subhq3 */

        case E_UHQmode:
          if (pattern296 (x3, 
E_UHQmode) != 0)
            return -1;
          return 282; /* subuhq3 */

        case E_HAmode:
          if (pattern296 (x3, 
E_HAmode) != 0)
            return -1;
          return 283; /* subha3 */

        case E_UHAmode:
          if (pattern296 (x3, 
E_UHAmode) != 0)
            return -1;
          return 284; /* subuha3 */

        case E_SImode:
          if (pattern296 (x3, 
E_SImode) != 0)
            return -1;
          return 290; /* subsi3 */

        case E_SQmode:
          if (pattern296 (x3, 
E_SQmode) != 0)
            return -1;
          return 291; /* subsq3 */

        case E_USQmode:
          if (pattern296 (x3, 
E_USQmode) != 0)
            return -1;
          return 292; /* subusq3 */

        case E_SAmode:
          if (pattern296 (x3, 
E_SAmode) != 0)
            return -1;
          return 293; /* subsa3 */

        case E_USAmode:
          if (pattern296 (x3, 
E_USAmode) != 0)
            return -1;
          return 294; /* subusa3 */

        default:
          return -1;
        }

    case GE:
      switch (pattern209 (x1))
        {
        case 0:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 348; /* *subqi3.ge0 */

        case 1:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 356; /* *subqi3.ge0 */

        case 2:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 364; /* *subqi3.ge0 */

        case 3:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 372; /* *subqi3.ge0 */

        case 4:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 350; /* *subhi3.ge0 */

        case 5:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 358; /* *subhi3.ge0 */

        case 6:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 366; /* *subhi3.ge0 */

        case 7:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 374; /* *subhi3.ge0 */

        case 8:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 352; /* *subpsi3.ge0 */

        case 9:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 360; /* *subpsi3.ge0 */

        case 10:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 368; /* *subpsi3.ge0 */

        case 11:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 376; /* *subpsi3.ge0 */

        case 12:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 354; /* *subsi3.ge0 */

        case 13:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 362; /* *subsi3.ge0 */

        case 14:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 370; /* *subsi3.ge0 */

        case 15:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 378; /* *subsi3.ge0 */

        default:
          return -1;
        }

    case LT:
      switch (pattern209 (x1))
        {
        case 0:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 349; /* *subqi3.lt0 */

        case 1:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 357; /* *subqi3.lt0 */

        case 2:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 365; /* *subqi3.lt0 */

        case 3:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 373; /* *subqi3.lt0 */

        case 4:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 351; /* *subhi3.lt0 */

        case 5:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 359; /* *subhi3.lt0 */

        case 6:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 367; /* *subhi3.lt0 */

        case 7:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 375; /* *subhi3.lt0 */

        case 8:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 353; /* *subpsi3.lt0 */

        case 9:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 361; /* *subpsi3.lt0 */

        case 10:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 369; /* *subpsi3.lt0 */

        case 11:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 377; /* *subpsi3.lt0 */

        case 12:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 355; /* *subsi3.lt0 */

        case 13:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 363; /* *subsi3.lt0 */

        case 14:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 371; /* *subsi3.lt0 */

        case 15:
          if (!
#line 2365 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 379; /* *subsi3.lt0 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      switch (pattern223 (x3))
        {
        case 0:
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 36
                  || GET_MODE (x7) != E_CCmode
                  || !
#line 2628 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 493; /* *msubqi4 */

            case CONST_INT:
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2657 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 495; /* *msubqi4.const */

            default:
              return -1;
            }

        case 1:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              if (pattern350 (x1) != 0
                  || !
#line 2740 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 502; /* *msubqihi4 */

            case ZERO_EXTEND:
              if (pattern350 (x1) != 0
                  || !
#line 2806 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              return 511; /* *sumsubqihi4 */

            case CONST_INT:
              operands[2] = x8;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode))
                return -1;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2872 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 515; /* *msubqihi4.sconst */
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2963 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              return 520; /* *sumsubqihi4.uconst */

            default:
              return -1;
            }

        case 2:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              if (pattern350 (x1) != 0
                  || !
#line 2740 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 503; /* *umsubqihi4 */

            case SIGN_EXTEND:
              if (pattern350 (x1) != 0
                  || !
#line 2806 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              return 510; /* *usmsubqihi4 */

            case CONST_INT:
              operands[2] = x8;
              if (!u8_operand (operands[2], E_HImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2872 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 516; /* *umsubqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern210 (x3) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!scratch_operand (operands[4], E_QImode))
        return -1;
      x9 = XEXP (x4, 0);
      switch (pattern340 (x9))
        {
        case 0:
          if (!
#line 2895 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 517; /* *umsubqihi4.uconst.ashift */

        case 1:
          if (!
#line 2919 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 518; /* *msubqihi4.sconst.ashift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ZERO_EXTEND
          || GET_MODE (x6) != E_HImode
          || pattern156 (x1, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 1778 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 192; /* *udiff_widenqihi3 */

    case REG:
    case SUBREG:
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      res = recog_43 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || pattern190 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
          switch (pattern318 (x3))
            {
            case 0:
              if (!
#line 224 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3180; /* *subdi3_insn */

            case 1:
              if (!
#line 224 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3181; /* *subdq3_insn */

            case 2:
              if (!
#line 224 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3182; /* *subudq3_insn */

            case 3:
              if (!
#line 224 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3183; /* *subda3_insn */

            case 4:
              if (!
#line 224 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3184; /* *subuda3_insn */

            case 5:
              if (!
#line 224 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3185; /* *subta3_insn */

            case 6:
              if (!
#line 224 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3186; /* *subuta3_insn */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
          switch (pattern319 (x3))
            {
            case 0:
              if (!
#line 249 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3194; /* *subdi3_const_insn */

            case 1:
              if (!
#line 249 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3195; /* *subdq3_const_insn */

            case 2:
              if (!
#line 249 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3196; /* *subudq3_const_insn */

            case 3:
              if (!
#line 249 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3197; /* *subda3_const_insn */

            case 4:
              if (!
#line 249 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3198; /* *subuda3_const_insn */

            case 5:
              if (!
#line 249 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3199; /* *subta3_const_insn */

            case 6:
              if (!
#line 249 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3200; /* *subuta3_const_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) != 22)
        return -1;
      x9 = XVECEXP (x1, 0, 3);
      x10 = XEXP (x9, 0);
      if (REGNO (x10) != 36
          || GET_MODE (x10) != E_CCmode)
        return -1;
      switch (pattern326 (x1))
        {
        case 0:
          if (!
#line 3325 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 540; /* *mulhi3_call */

        case 1:
          if (!
#line 394 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3058; /* *mulqq3.call */

        default:
          return -1;
        }

    case 22:
      if (REGNO (x4) != 18
          || REGNO (x5) != 22)
        return -1;
      x9 = XVECEXP (x1, 0, 3);
      x10 = XEXP (x9, 0);
      if (GET_MODE (x10) != E_HImode)
        return -1;
      switch (pattern348 (x1))
        {
        case 0:
          if (!
#line 3726 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY))
            return -1;
          return 565; /* *mulsi3_call_pr118012_split */

        case 1:
          if (!
#line 4244 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 604; /* *mulpsi3.libgcc_split */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case SUBREG:
        case MEM:
          switch (pattern159 (x1))
            {
            case 0:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 68; /* fxloadqi_A */

            case 1:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 69; /* fxloadqq_A */

            case 2:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 70; /* fxloaduqq_A */

            case 3:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 71; /* fxloadhi_A */

            case 4:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 72; /* fxloadhq_A */

            case 5:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 73; /* fxloaduhq_A */

            case 6:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 74; /* fxloadha_A */

            case 7:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 75; /* fxloaduha_A */

            case 8:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 76; /* fxloadsi_A */

            case 9:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 77; /* fxloadsq_A */

            case 10:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 78; /* fxloadusq_A */

            case 11:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 79; /* fxloadsa_A */

            case 12:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 80; /* fxloadusa_A */

            case 13:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 81; /* fxloadsf_A */

            case 14:
              if (!
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))))
                return -1;
              return 82; /* fxloadpsi_A */

            default:
              return -1;
            }

        case MULT:
          if (pattern160 (x1) != 0)
            return -1;
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG)
                return -1;
              x8 = XEXP (x5, 1);
              if (GET_CODE (x8) != ZERO_EXTEND)
                return -1;
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG)
                return -1;
              x10 = XEXP (x2, 0);
              if (GET_CODE (x10) != REG)
                return -1;
              x11 = XEXP (x4, 0);
              if (REGNO (x11) != 36
                  || GET_MODE (x11) != E_CCmode)
                return -1;
              switch (pattern254 (x1))
                {
                case 0:
                  if (!
#line 2449 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                    return -1;
                  return 477; /* *umulqihi3.call */

                case 1:
                  if (!
#line 693 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
                    return -1;
                  return 3340; /* *umulsidi3_insn */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              if (GET_CODE (x6) == REG)
                {
                  res = recog_74 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              operands[1] = x6;
              if (!pseudo_register_operand (operands[1], E_SImode)
                  || pattern297 (x1, 
E_HImode, 
30, 
26) != 0)
                return -1;
              x11 = XEXP (x4, 0);
              if (REGNO (x11) != 18
                  || GET_MODE (x11) != E_DImode)
                return -1;
              x10 = XEXP (x2, 0);
              operands[0] = x10;
              if (!pseudo_register_operand (operands[0], E_SImode)
                  || GET_MODE (x5) != E_SImode)
                return -1;
              x8 = XEXP (x5, 1);
              operands[2] = x8;
              if (!pseudo_register_operand (operands[2], E_SImode)
                  || !
#line 3434 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed))
                return -1;
              return 542; /* *mulsi3_pr118012 */

            case SIGN_EXTEND:
              if (GET_MODE (x6) != E_DImode)
                return -1;
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 18
                  || pattern286 (x5, 
E_SImode, 
22, 
E_DImode) != 0)
                return -1;
              x10 = XEXP (x2, 0);
              if (GET_CODE (x10) != REG
                  || pattern249 (x1, 
26, 
E_DImode, 
18, 
E_HImode) != 0
                  || pattern229 (x1, 
E_DImode, 
E_CCmode, 
36, 
30) != 0
                  || !
#line 693 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
                return -1;
              return 3339; /* *mulsidi3_insn */

            default:
              return -1;
            }

        case DIV:
          x12 = XEXP (x3, 0);
          if (GET_CODE (x12) != REG)
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) == REG)
            {
              res = recog_75 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (REGNO (x11) != 26
              || pattern232 (x1, 
MOD) != 0)
            return -1;
          return 606; /* divmodpsi4 */

        case UDIV:
          x12 = XEXP (x3, 0);
          if (GET_CODE (x12) != REG)
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) == REG)
            {
              res = recog_76 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (REGNO (x11) != 26
              || pattern232 (x1, 
UMOD) != 0)
            return -1;
          return 609; /* udivmodpsi4 */

        case UNSPEC:
          if (pattern110 (x1) != 0)
            return -1;
          x11 = XEXP (x4, 0);
          if (x11 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              res = recog_77 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x13 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x13) != REG
              || pattern313 (x1) != 0
              || !
#line 7960 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL))
            return -1;
          return 976; /* *tablejump.3byte-pc_split */

        case TRUNCATE:
          if (GET_MODE (x5) != E_HImode)
            return -1;
          x10 = XEXP (x2, 0);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 24
              || GET_MODE (x10) != E_HImode)
            return -1;
          x14 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != REG
              || REGNO (x15) != 22
              || GET_MODE (x15) != E_QImode)
            return -1;
          x12 = XEXP (x3, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 26
              || GET_MODE (x12) != E_QImode)
            return -1;
          x11 = XEXP (x4, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 36
              || GET_MODE (x11) != E_CCmode)
            return -1;
          x6 = XEXP (x5, 0);
          switch (pattern341 (x6))
            {
            case 0:
              if (!
#line 9483 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1046; /* *ctzsihi2.libgcc */

            case 1:
              if (!
#line 9555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1050; /* *ffssihi2.libgcc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pnum_clobbers == NULL
              || pattern138 (x1) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          x12 = XEXP (x3, 0);
          if (GET_MODE (x12) != E_HImode)
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          if (pattern198 (x4, 
E_HImode, 
26, 
USE) != 0)
            return -1;
          x14 = XVECEXP (x1, 0, 1);
          operands[0] = x14;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x16 = XEXP (x3, 1);
          x17 = XEXP (x16, 1);
          operands[1] = x17;
          if (!immediate_operand (operands[1], E_HImode))
            return -1;
          *pnum_clobbers = 2;
          return 996; /* call_prologue_saves */

        case 2:
          x14 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x14) != SET)
            return -1;
          x18 = XEXP (x14, 1);
          if (GET_CODE (x18) != UNSPEC_VOLATILE
              || XVECLEN (x18, 0) != 1)
            return -1;
          x4 = XVECEXP (x1, 0, 3);
          if (pattern198 (x4, 
E_CCmode, 
36, 
CLOBBER) != 0)
            return -1;
          x19 = XVECEXP (x2, 0, 0);
          operands[0] = x19;
          switch (XINT (x2, 1))
            {
            case 3:
              if (pattern267 (x1) != 0
                  || !
#line 8668 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_gasisr_prologues))
                return -1;
              return 998; /* *gasisr */

            case 10:
              switch (pattern235 (x1))
                {
                case 0:
                  if (!
#line 8759 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 1004; /* *delay_cycles_1 */

                case 1:
                  if (!
#line 8793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 1006; /* *delay_cycles_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  if (pattern115 (x3) != 0)
    return NULL;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return NULL;
  x8 = XEXP (x3, 1);
  switch (pattern268 (x8))
    {
    case 0:
      if (!(
#line 2533 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2535 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_275 (insn, operands);

    case 1:
      if (!(
#line 2557 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2559 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_276 (insn, operands);

    case 2:
      if (!(
#line 3196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3198 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_309 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return NULL;
  operands[2] = x3;
  if (pattern152 (x1) == 0
      && 
#line 5019 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
    return gen_split_396 (insn, operands);
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (XWINT (x3, 0))
    {
    case 1L:
      switch (pattern188 (x2))
        {
        case 0:
          if (!
#line 5092 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_397 (insn, operands);

        case 1:
          if (!
#line 5134 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_399 (insn, operands);

        case 2:
          if (!
#line 5176 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_401 (insn, operands);

        default:
          return NULL;
        }

    case 15L:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !
#line 5113 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_398 (insn, operands);

    case 23L:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !
#line 5155 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_400 (insn, operands);

    case 31L:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !
#line 5197 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_402 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1395 (insn, operands);

    case 1:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1396 (insn, operands);

    case 2:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1397 (insn, operands);

    case 3:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1398 (insn, operands);

    case 4:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1399 (insn, operands);

    case 5:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1400 (insn, operands);

    case 6:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1401 (insn, operands);

    case 7:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1402 (insn, operands);

    case 8:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1403 (insn, operands);

    case 9:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1404 (insn, operands);

    case 10:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1405 (insn, operands);

    case 11:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1406 (insn, operands);

    case 12:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1407 (insn, operands);

    case 13:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1408 (insn, operands);

    case 14:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1409 (insn, operands);

    case 15:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1410 (insn, operands);

    case 16:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1411 (insn, operands);

    case 17:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1412 (insn, operands);

    case 18:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != QQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1413 (insn, operands);

    case 19:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1414 (insn, operands);

    case 20:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1415 (insn, operands);

    case 21:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1416 (insn, operands);

    case 22:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1417 (insn, operands);

    case 23:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1418 (insn, operands);

    case 24:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1419 (insn, operands);

    case 25:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1420 (insn, operands);

    case 26:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1421 (insn, operands);

    case 27:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1422 (insn, operands);

    case 28:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1423 (insn, operands);

    case 29:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1424 (insn, operands);

    case 30:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1425 (insn, operands);

    case 31:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1426 (insn, operands);

    case 32:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1427 (insn, operands);

    case 33:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1428 (insn, operands);

    case 34:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1429 (insn, operands);

    case 35:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1430 (insn, operands);

    case 36:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1431 (insn, operands);

    case 37:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UQQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1432 (insn, operands);

    case 38:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1433 (insn, operands);

    case 39:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1434 (insn, operands);

    case 40:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1435 (insn, operands);

    case 41:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1436 (insn, operands);

    case 42:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1437 (insn, operands);

    case 43:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1438 (insn, operands);

    case 44:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1439 (insn, operands);

    case 45:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1440 (insn, operands);

    case 46:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1441 (insn, operands);

    case 47:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1442 (insn, operands);

    case 48:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1443 (insn, operands);

    case 49:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1444 (insn, operands);

    case 50:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1445 (insn, operands);

    case 51:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1446 (insn, operands);

    case 52:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1447 (insn, operands);

    case 53:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1448 (insn, operands);

    case 54:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1449 (insn, operands);

    case 55:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1450 (insn, operands);

    case 56:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != HQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1451 (insn, operands);

    case 57:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1452 (insn, operands);

    case 58:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1453 (insn, operands);

    case 59:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1454 (insn, operands);

    case 60:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1455 (insn, operands);

    case 61:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1456 (insn, operands);

    case 62:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1457 (insn, operands);

    case 63:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1458 (insn, operands);

    case 64:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1459 (insn, operands);

    case 65:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1460 (insn, operands);

    case 66:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1461 (insn, operands);

    case 67:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1462 (insn, operands);

    case 68:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1463 (insn, operands);

    case 69:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1464 (insn, operands);

    case 70:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1465 (insn, operands);

    case 71:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1466 (insn, operands);

    case 72:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1467 (insn, operands);

    case 73:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1468 (insn, operands);

    case 74:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1469 (insn, operands);

    case 75:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UHQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1470 (insn, operands);

    case 76:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1471 (insn, operands);

    case 77:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1472 (insn, operands);

    case 78:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1473 (insn, operands);

    case 79:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1474 (insn, operands);

    case 80:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1475 (insn, operands);

    case 81:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1476 (insn, operands);

    case 82:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1477 (insn, operands);

    case 83:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1478 (insn, operands);

    case 84:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1479 (insn, operands);

    case 85:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1480 (insn, operands);

    case 86:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1481 (insn, operands);

    case 87:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1482 (insn, operands);

    case 88:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1483 (insn, operands);

    case 89:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1484 (insn, operands);

    case 90:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1485 (insn, operands);

    case 91:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1486 (insn, operands);

    case 92:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1487 (insn, operands);

    case 93:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1488 (insn, operands);

    case 94:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != HAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1489 (insn, operands);

    case 95:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1490 (insn, operands);

    case 96:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1491 (insn, operands);

    case 97:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1492 (insn, operands);

    case 98:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1493 (insn, operands);

    case 99:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1494 (insn, operands);

    case 100:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1495 (insn, operands);

    case 101:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1496 (insn, operands);

    case 102:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1497 (insn, operands);

    case 103:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1498 (insn, operands);

    case 104:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1499 (insn, operands);

    case 105:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1500 (insn, operands);

    case 106:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1501 (insn, operands);

    case 107:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1502 (insn, operands);

    case 108:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1503 (insn, operands);

    case 109:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1504 (insn, operands);

    case 110:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1505 (insn, operands);

    case 111:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1506 (insn, operands);

    case 112:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1507 (insn, operands);

    case 113:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UHAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1508 (insn, operands);

    case 114:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1509 (insn, operands);

    case 115:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1510 (insn, operands);

    case 116:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1511 (insn, operands);

    case 117:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1512 (insn, operands);

    case 118:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1513 (insn, operands);

    case 119:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1514 (insn, operands);

    case 120:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1515 (insn, operands);

    case 121:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1516 (insn, operands);

    case 122:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1517 (insn, operands);

    case 123:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1518 (insn, operands);

    case 124:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1519 (insn, operands);

    case 125:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1520 (insn, operands);

    case 126:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1521 (insn, operands);

    case 127:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1522 (insn, operands);

    case 128:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1523 (insn, operands);

    case 129:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1524 (insn, operands);

    case 130:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1525 (insn, operands);

    case 131:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1526 (insn, operands);

    case 132:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != SQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1527 (insn, operands);

    case 133:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1528 (insn, operands);

    case 134:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1529 (insn, operands);

    case 135:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1530 (insn, operands);

    case 136:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1531 (insn, operands);

    case 137:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1532 (insn, operands);

    case 138:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1533 (insn, operands);

    case 139:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1534 (insn, operands);

    case 140:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1535 (insn, operands);

    case 141:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1536 (insn, operands);

    case 142:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1537 (insn, operands);

    case 143:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1538 (insn, operands);

    case 144:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1539 (insn, operands);

    case 145:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1540 (insn, operands);

    case 146:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1541 (insn, operands);

    case 147:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1542 (insn, operands);

    case 148:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1543 (insn, operands);

    case 149:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1544 (insn, operands);

    case 150:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1545 (insn, operands);

    case 151:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != USQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1546 (insn, operands);

    case 152:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1547 (insn, operands);

    case 153:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1548 (insn, operands);

    case 154:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1549 (insn, operands);

    case 155:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1550 (insn, operands);

    case 156:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1551 (insn, operands);

    case 157:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1552 (insn, operands);

    case 158:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1553 (insn, operands);

    case 159:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1554 (insn, operands);

    case 160:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1555 (insn, operands);

    case 161:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1556 (insn, operands);

    case 162:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1557 (insn, operands);

    case 163:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1558 (insn, operands);

    case 164:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1559 (insn, operands);

    case 165:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1560 (insn, operands);

    case 166:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1561 (insn, operands);

    case 167:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1562 (insn, operands);

    case 168:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1563 (insn, operands);

    case 169:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1564 (insn, operands);

    case 170:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != SAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1565 (insn, operands);

    case 171:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1566 (insn, operands);

    case 172:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1567 (insn, operands);

    case 173:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1568 (insn, operands);

    case 174:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1569 (insn, operands);

    case 175:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1570 (insn, operands);

    case 176:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1571 (insn, operands);

    case 177:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1572 (insn, operands);

    case 178:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1573 (insn, operands);

    case 179:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1574 (insn, operands);

    case 180:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1575 (insn, operands);

    case 181:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1576 (insn, operands);

    case 182:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1577 (insn, operands);

    case 183:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1578 (insn, operands);

    case 184:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1579 (insn, operands);

    case 185:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1580 (insn, operands);

    case 186:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1581 (insn, operands);

    case 187:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1582 (insn, operands);

    case 188:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1583 (insn, operands);

    case 189:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != USAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1584 (insn, operands);

    case 190:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1585 (insn, operands);

    case 191:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1586 (insn, operands);

    case 192:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1587 (insn, operands);

    case 193:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1588 (insn, operands);

    case 194:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1589 (insn, operands);

    case 195:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1590 (insn, operands);

    case 196:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1591 (insn, operands);

    case 197:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1592 (insn, operands);

    case 198:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1593 (insn, operands);

    case 199:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1594 (insn, operands);

    case 200:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1595 (insn, operands);

    case 201:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1596 (insn, operands);

    case 202:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1597 (insn, operands);

    case 203:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1598 (insn, operands);

    case 204:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1599 (insn, operands);

    case 205:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1600 (insn, operands);

    case 206:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1601 (insn, operands);

    case 207:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1602 (insn, operands);

    case 208:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != DQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1603 (insn, operands);

    case 209:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1604 (insn, operands);

    case 210:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1605 (insn, operands);

    case 211:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1606 (insn, operands);

    case 212:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1607 (insn, operands);

    case 213:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1608 (insn, operands);

    case 214:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1609 (insn, operands);

    case 215:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1610 (insn, operands);

    case 216:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1611 (insn, operands);

    case 217:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1612 (insn, operands);

    case 218:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1613 (insn, operands);

    case 219:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1614 (insn, operands);

    case 220:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1615 (insn, operands);

    case 221:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1616 (insn, operands);

    case 222:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1617 (insn, operands);

    case 223:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1618 (insn, operands);

    case 224:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1619 (insn, operands);

    case 225:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1620 (insn, operands);

    case 226:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1621 (insn, operands);

    case 227:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UDQmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1622 (insn, operands);

    case 228:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1623 (insn, operands);

    case 229:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1624 (insn, operands);

    case 230:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1625 (insn, operands);

    case 231:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1626 (insn, operands);

    case 232:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1627 (insn, operands);

    case 233:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1628 (insn, operands);

    case 234:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1629 (insn, operands);

    case 235:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1630 (insn, operands);

    case 236:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1631 (insn, operands);

    case 237:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1632 (insn, operands);

    case 238:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1633 (insn, operands);

    case 239:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1634 (insn, operands);

    case 240:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1635 (insn, operands);

    case 241:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1636 (insn, operands);

    case 242:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1637 (insn, operands);

    case 243:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1638 (insn, operands);

    case 244:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1639 (insn, operands);

    case 245:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1640 (insn, operands);

    case 246:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != DAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1641 (insn, operands);

    case 247:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1642 (insn, operands);

    case 248:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1643 (insn, operands);

    case 249:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1644 (insn, operands);

    case 250:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1645 (insn, operands);

    case 251:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1646 (insn, operands);

    case 252:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1647 (insn, operands);

    case 253:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1648 (insn, operands);

    case 254:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1649 (insn, operands);

    case 255:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1650 (insn, operands);

    case 256:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1651 (insn, operands);

    case 257:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1652 (insn, operands);

    case 258:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1653 (insn, operands);

    case 259:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1654 (insn, operands);

    case 260:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1655 (insn, operands);

    case 261:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1656 (insn, operands);

    case 262:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1657 (insn, operands);

    case 263:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1658 (insn, operands);

    case 264:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1659 (insn, operands);

    case 265:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UDAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1660 (insn, operands);

    case 266:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1661 (insn, operands);

    case 267:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1662 (insn, operands);

    case 268:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1663 (insn, operands);

    case 269:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1664 (insn, operands);

    case 270:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1665 (insn, operands);

    case 271:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1666 (insn, operands);

    case 272:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1667 (insn, operands);

    case 273:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1668 (insn, operands);

    case 274:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1669 (insn, operands);

    case 275:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1670 (insn, operands);

    case 276:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1671 (insn, operands);

    case 277:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1672 (insn, operands);

    case 278:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1673 (insn, operands);

    case 279:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1674 (insn, operands);

    case 280:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1675 (insn, operands);

    case 281:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1676 (insn, operands);

    case 282:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1677 (insn, operands);

    case 283:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1678 (insn, operands);

    case 284:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != TAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1679 (insn, operands);

    case 285:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1680 (insn, operands);

    case 286:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1681 (insn, operands);

    case 287:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1682 (insn, operands);

    case 288:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1683 (insn, operands);

    case 289:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1684 (insn, operands);

    case 290:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1685 (insn, operands);

    case 291:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1686 (insn, operands);

    case 292:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1687 (insn, operands);

    case 293:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1688 (insn, operands);

    case 294:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1689 (insn, operands);

    case 295:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1690 (insn, operands);

    case 296:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1691 (insn, operands);

    case 297:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1692 (insn, operands);

    case 298:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1693 (insn, operands);

    case 299:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1694 (insn, operands);

    case 300:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1695 (insn, operands);

    case 301:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1696 (insn, operands);

    case 302:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1697 (insn, operands);

    case 303:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UTAmode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1698 (insn, operands);

    case 304:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1699 (insn, operands);

    case 305:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1700 (insn, operands);

    case 306:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1701 (insn, operands);

    case 307:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1702 (insn, operands);

    case 308:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1703 (insn, operands);

    case 309:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1704 (insn, operands);

    case 310:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1705 (insn, operands);

    case 311:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1706 (insn, operands);

    case 312:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1707 (insn, operands);

    case 313:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1708 (insn, operands);

    case 314:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1709 (insn, operands);

    case 315:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1710 (insn, operands);

    case 316:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1711 (insn, operands);

    case 317:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1712 (insn, operands);

    case 318:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1713 (insn, operands);

    case 319:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1714 (insn, operands);

    case 320:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1715 (insn, operands);

    case 321:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1716 (insn, operands);

    case 322:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != QImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1717 (insn, operands);

    case 323:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1718 (insn, operands);

    case 324:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1719 (insn, operands);

    case 325:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1720 (insn, operands);

    case 326:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1721 (insn, operands);

    case 327:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1722 (insn, operands);

    case 328:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1723 (insn, operands);

    case 329:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1724 (insn, operands);

    case 330:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1725 (insn, operands);

    case 331:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1726 (insn, operands);

    case 332:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1727 (insn, operands);

    case 333:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1728 (insn, operands);

    case 334:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1729 (insn, operands);

    case 335:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1730 (insn, operands);

    case 336:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1731 (insn, operands);

    case 337:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1732 (insn, operands);

    case 338:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1733 (insn, operands);

    case 339:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1734 (insn, operands);

    case 340:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1735 (insn, operands);

    case 341:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != HImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1736 (insn, operands);

    case 342:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1737 (insn, operands);

    case 343:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1738 (insn, operands);

    case 344:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1739 (insn, operands);

    case 345:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1740 (insn, operands);

    case 346:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1741 (insn, operands);

    case 347:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1742 (insn, operands);

    case 348:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1743 (insn, operands);

    case 349:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1744 (insn, operands);

    case 350:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1745 (insn, operands);

    case 351:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1746 (insn, operands);

    case 352:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1747 (insn, operands);

    case 353:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1748 (insn, operands);

    case 354:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1749 (insn, operands);

    case 355:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1750 (insn, operands);

    case 356:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1751 (insn, operands);

    case 357:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1752 (insn, operands);

    case 358:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1753 (insn, operands);

    case 359:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1754 (insn, operands);

    case 360:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != SImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1755 (insn, operands);

    case 361:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1756 (insn, operands);

    case 362:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1757 (insn, operands);

    case 363:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1758 (insn, operands);

    case 364:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1759 (insn, operands);

    case 365:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1760 (insn, operands);

    case 366:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1761 (insn, operands);

    case 367:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1762 (insn, operands);

    case 368:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1763 (insn, operands);

    case 369:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1764 (insn, operands);

    case 370:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1765 (insn, operands);

    case 371:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1766 (insn, operands);

    case 372:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1767 (insn, operands);

    case 373:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1768 (insn, operands);

    case 374:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1769 (insn, operands);

    case 375:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1770 (insn, operands);

    case 376:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1771 (insn, operands);

    case 377:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1772 (insn, operands);

    case 378:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1773 (insn, operands);

    case 379:
      if (!(
#line 86 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != DImode) && 
#line 88 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1774 (insn, operands);

    default:
      return NULL;
    }
}
