/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x3) != E_QQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 0;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 1;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 2;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 3;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 4;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 5;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 6;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 7;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 8;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 9;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 10;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 11;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 12;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 13;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 14;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 15;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 16;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 17;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x3) != E_UQQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 19;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 20;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 21;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 22;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 23;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 24;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 25;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 26;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 27;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 28;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 29;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 30;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 31;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 32;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 33;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 36;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 38;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 39;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 40;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 41;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 42;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 43;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 44;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 45;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 46;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 47;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 48;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 49;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 50;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 51;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 52;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 53;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 54;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 55;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 57;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 58;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 59;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 60;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 61;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 62;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 63;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 64;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 65;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 66;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 67;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 68;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 69;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 70;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 71;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 72;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 73;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 74;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 75;

        default:
          return -1;
        }

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 76;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 77;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 78;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 79;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 80;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 81;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 82;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 83;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 84;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 85;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 86;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 87;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 88;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 89;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 90;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 91;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 92;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 93;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 95;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 96;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 97;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 98;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 99;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 100;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 101;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 102;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 103;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 104;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 105;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 106;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 107;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 108;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 109;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 110;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 111;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 112;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x3) != E_SQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 114;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 115;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 116;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 117;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 118;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 119;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 120;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 121;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 122;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 123;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 124;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 125;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 126;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 127;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 128;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 129;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 130;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 131;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 132;

        default:
          return -1;
        }

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x3) != E_USQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 133;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 134;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 135;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 136;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 137;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 138;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 139;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 140;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 141;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 142;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 143;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 144;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 145;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 146;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 147;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 148;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 149;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 150;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 151;

        default:
          return -1;
        }

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x3) != E_SAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 152;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 153;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 154;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 155;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 156;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 157;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 158;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 159;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 160;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 161;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 162;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 163;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 164;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 165;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 166;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 167;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 168;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 169;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 170;

        default:
          return -1;
        }

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x3) != E_USAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 171;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 172;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 173;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 174;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 175;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 176;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 177;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 178;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 179;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 180;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 181;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 182;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 183;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 184;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 185;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 186;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 187;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 188;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 189;

        default:
          return -1;
        }

    case E_DQmode:
      if (!register_operand (operands[0], E_DQmode)
          || GET_MODE (x3) != E_DQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 190;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 191;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 192;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 193;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 194;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 195;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 196;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 197;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 198;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 199;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 200;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 201;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 202;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 203;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 204;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 205;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 206;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 207;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 208;

        default:
          return -1;
        }

    case E_UDQmode:
      if (!register_operand (operands[0], E_UDQmode)
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 209;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 210;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 211;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 212;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 213;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 214;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 215;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 216;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 217;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 218;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 219;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 220;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 221;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 222;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 223;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 224;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 225;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 226;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 227;

        default:
          return -1;
        }

    case E_DAmode:
      if (!register_operand (operands[0], E_DAmode)
          || GET_MODE (x3) != E_DAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 228;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 229;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 230;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 231;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 232;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 233;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 234;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 235;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 236;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 237;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 238;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 239;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 240;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 241;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 242;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 243;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 244;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 245;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 246;

        default:
          return -1;
        }

    case E_UDAmode:
      if (!register_operand (operands[0], E_UDAmode)
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 247;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 248;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 249;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 250;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 251;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 252;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 253;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 254;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 255;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 256;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 257;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 258;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 259;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 260;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 261;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 262;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 263;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 264;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 265;

        default:
          return -1;
        }

    case E_TAmode:
      if (!register_operand (operands[0], E_TAmode)
          || GET_MODE (x3) != E_TAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 266;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 267;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 268;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 269;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 270;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 271;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 272;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 273;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 274;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 275;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 276;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 277;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 278;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 279;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 280;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 281;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 282;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 283;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 284;

        default:
          return -1;
        }

    case E_UTAmode:
      if (!register_operand (operands[0], E_UTAmode)
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 285;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 286;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 287;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 288;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 289;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 290;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 291;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 292;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 293;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 294;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 295;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 296;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 297;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 298;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 299;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 300;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 301;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 302;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 303;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 304;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 305;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 306;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 307;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 308;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 309;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 310;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 311;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 312;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 313;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 314;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 315;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 316;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 317;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 318;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 319;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 320;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 321;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 322;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 323;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 324;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 325;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 326;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 327;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 328;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 329;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 330;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 331;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 332;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 333;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 334;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 335;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 336;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 337;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 338;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 339;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 340;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 341;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 342;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 343;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 344;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 345;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 346;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 347;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 348;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 349;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 350;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 351;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 352;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 353;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 354;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 355;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 356;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 357;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 358;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 359;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 360;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 361;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 362;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 363;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 364;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 365;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 366;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 367;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 368;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 369;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 370;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 371;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 372;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 373;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 374;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 375;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 376;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 377;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 378;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 379;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (pattern72 (x1, pnum_clobbers))
        {
        case 0:
          return 626; /* iorqi3 */

        case 1:
          *pnum_clobbers = 1;
          return 628; /* iorhi3 */

        case 2:
          *pnum_clobbers = 1;
          return 630; /* iorpsi3 */

        case 3:
          *pnum_clobbers = 1;
          return 632; /* iorsi3 */

        default:
          return -1;
        }

    case MEM:
      if (pattern40 (x1) != 0
          || !single_one_operand (operands[1], E_QImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 981; /* *sbi */

    case AND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          operands[2] = x6;
          res = recog_17 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (XWINT (x6, 0) != 127L)
            return -1;
          x7 = XEXP (x2, 1);
          if (GET_CODE (x7) != ASHIFT
              || GET_MODE (x7) != E_QImode)
            return -1;
          x8 = XEXP (x7, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || pattern205 (x2, 
E_QImode) != 0)
            return -1;
          return 1075; /* *movbitqi.7 */

        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1273; /* *pixop-to-skip.qi */

            case 1:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1285; /* *pixop-to-skip.qi */

            case 2:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1297; /* *pixop-to-skip.qi */

            case 3:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1309; /* *pixop-to-skip.qi */

            case 4:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1276; /* *pixop-to-skip.hi */

            case 5:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1288; /* *pixop-to-skip.hi */

            case 6:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1300; /* *pixop-to-skip.hi */

            case 7:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1312; /* *pixop-to-skip.hi */

            case 8:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1279; /* *pixop-to-skip.psi */

            case 9:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1291; /* *pixop-to-skip.psi */

            case 10:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1303; /* *pixop-to-skip.psi */

            case 11:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1315; /* *pixop-to-skip.psi */

            case 12:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1282; /* *pixop-to-skip.si */

            case 13:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1294; /* *pixop-to-skip.si */

            case 14:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1306; /* *pixop-to-skip.si */

            case 15:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1318; /* *pixop-to-skip.si */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1405; /* *shl.and-to-skip.hi */

            case 1:
              if (!
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1408; /* *shl.and-to-skip.psi */

            case 2:
              if (!
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1411; /* *shl.and-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern74 (x2))
        {
        case 0:
          if (!
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1093; /* *iorhi.lshiftrt */

        case 1:
          if (!
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1097; /* *iorpsi.lshiftrt */

        case 2:
          if (!
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1101; /* *iorsi.lshiftrt */

        case 3:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1117; /* *iorhiqi.lshiftrt */

        case 4:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1121; /* *iorpsiqi.lshiftrt */

        case 5:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1129; /* *iorpsihi.lshiftrt */

        case 6:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1125; /* *iorsiqi.lshiftrt */

        case 7:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1133; /* *iorsihi.lshiftrt */

        case 8:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1137; /* *iorsipsi.lshiftrt */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern76 (x2))
        {
        case 0:
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (pattern42 (x2))
            {
            case 0:
              if (
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
                return 1095; /* *iorhi.ashift */
              break;

            case 1:
              if (
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
                return 1099; /* *iorpsi.ashift */
              break;

            case 2:
              if (
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
                return 1103; /* *iorsi.ashift */
              break;

            default:
              break;
            }
          if (XWINT (x6, 0) != 8L
              || pattern206 (x2) != 0
              || !
#line 10259 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1144; /* *iorhi3.ashift8-reg.zerox */

        case 1:
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (pattern44 (x2))
            {
            case 0:
              if (
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
                return 1119; /* *iorhiqi.ashift */
              break;

            case 1:
              if (
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
                return 1123; /* *iorpsiqi.ashift */
              break;

            case 2:
              if (
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
                return 1131; /* *iorpsihi.ashift */
              break;

            case 3:
              if (
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
                return 1127; /* *iorsiqi.ashift */
              break;

            case 4:
              if (
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
                return 1135; /* *iorsihi.ashift */
              break;

            case 5:
              if (
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
                return 1139; /* *iorsipsi.ashift */
              break;

            default:
              break;
            }
          if (XWINT (x6, 0) != 8L)
            return -1;
          switch (pattern217 (x2))
            {
            case 0:
              if (!
#line 10210 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize))
                return -1;
              return 1141; /* *iorhi3.ashift8-ext.zerox */

            case 1:
              if (!
#line 10243 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize))
                return -1;
              return 1143; /* *iorhi3.ashift8-ext.reg */

            default:
              return -1;
            }

        case 2:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1371; /* *shl.ext.and1-to-skip.hi */

        case 3:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1377; /* *shl.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1389; /* *shl.ext.and1-to-skip.psi */

        case 5:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1383; /* *shl.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1395; /* *shl.ext.and1-to-skip.si */

        case 7:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1401; /* *shl.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10210 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1140; /* *iorhi3.ashift8-ext.zerox */

        case 9:
          if (!
#line 10243 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize))
            return -1;
          return 1142; /* *iorhi3.ashift8-ext.reg */

        case 10:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1370; /* *shl.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1376; /* *shl.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1388; /* *shl.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1382; /* *shl.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1394; /* *shl.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1400; /* *shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern3 (x2))
        {
        case 0:
          return 1105; /* *iorhiqi.0 */

        case 1:
          return 1107; /* *iorpsiqi.0 */

        case 2:
          return 1111; /* *iorpsihi.0 */

        case 3:
          return 1109; /* *iorsiqi.0 */

        case 4:
          return 1113; /* *iorsihi.0 */

        case 5:
          return 1115; /* *iorsipsi.0 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern80 (x2))
        {
        case 0:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1321; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1324; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1327; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1330; /* *mul.and1-to-skip.si */

        case 4:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1334; /* *mul.ext.and1-to-skip.hi */

        case 5:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1340; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1352; /* *mul.ext.and1-to-skip.psi */

        case 7:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1346; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1358; /* *mul.ext.and1-to-skip.si */

        case 9:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1364; /* *mul.ext.and1-to-skip.si */

        case 10:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1335; /* *mul.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1341; /* *mul.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1353; /* *mul.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1347; /* *mul.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1359; /* *mul.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1365; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) == REG)
    {
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) == REG
      && REGNO (x6) == 30)
    {
      switch (pattern239 (x6))
        {
        case 0:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 35; /* fxmovqi_A */
          break;

        case 1:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 36; /* fxmovqq_A */
          break;

        case 2:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 37; /* fxmovuqq_A */
          break;

        case 3:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 38; /* fxmovhi_A */
          break;

        case 4:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 39; /* fxmovhq_A */
          break;

        case 5:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 40; /* fxmovuhq_A */
          break;

        case 6:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 41; /* fxmovha_A */
          break;

        case 7:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 42; /* fxmovuha_A */
          break;

        case 8:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 43; /* fxmovsi_A */
          break;

        case 9:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 44; /* fxmovsq_A */
          break;

        case 10:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 45; /* fxmovusq_A */
          break;

        case 11:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 46; /* fxmovsa_A */
          break;

        case 12:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 47; /* fxmovusa_A */
          break;

        case 13:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 48; /* fxmovsf_A */
          break;

        case 14:
          if (
#line 594 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
            return 49; /* fxmovpsi_A */
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 876 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 119; /* *reload_inqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 876 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 120; /* *reload_inqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 876 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 121; /* *reload_inuqq */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 138; /* *reload_inpsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 141; /* *reload_insi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 142; /* *reload_insi */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 143; /* *reload_insi */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 144; /* *reload_insi */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 145; /* *reload_insi */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1274 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 159; /* *reload_insf */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern93 (x1))
    {
    case 0:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode
   && reload_completed))
        return -1;
      return 1853; /* *fractuqqqq2 */

    case 1:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != QQmode
   && reload_completed))
        return -1;
      return 1854; /* *fracthqqq2 */

    case 2:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode
   && reload_completed))
        return -1;
      return 1855; /* *fractuhqqq2 */

    case 3:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != QQmode
   && reload_completed))
        return -1;
      return 1856; /* *fracthaqq2 */

    case 4:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode
   && reload_completed))
        return -1;
      return 1857; /* *fractuhaqq2 */

    case 5:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != QQmode
   && reload_completed))
        return -1;
      return 1858; /* *fractsqqq2 */

    case 6:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != QQmode
   && reload_completed))
        return -1;
      return 1859; /* *fractusqqq2 */

    case 7:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != QQmode
   && reload_completed))
        return -1;
      return 1860; /* *fractsaqq2 */

    case 8:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != QQmode
   && reload_completed))
        return -1;
      return 1861; /* *fractusaqq2 */

    case 9:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != QQmode
   && reload_completed))
        return -1;
      return 1862; /* *fractdqqq2 */

    case 10:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode
   && reload_completed))
        return -1;
      return 1863; /* *fractudqqq2 */

    case 11:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != QQmode
   && reload_completed))
        return -1;
      return 1864; /* *fractdaqq2 */

    case 12:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode
   && reload_completed))
        return -1;
      return 1865; /* *fractudaqq2 */

    case 13:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != QQmode
   && reload_completed))
        return -1;
      return 1866; /* *fracttaqq2 */

    case 14:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode
   && reload_completed))
        return -1;
      return 1867; /* *fractutaqq2 */

    case 15:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != QQmode
   && reload_completed))
        return -1;
      return 1868; /* *fractqiqq2 */

    case 16:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != QQmode
   && reload_completed))
        return -1;
      return 1869; /* *fracthiqq2 */

    case 17:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != QQmode
   && reload_completed))
        return -1;
      return 1870; /* *fractsiqq2 */

    case 18:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != QQmode
   && reload_completed))
        return -1;
      return 1871; /* *fractdiqq2 */

    case 19:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode
   && reload_completed))
        return -1;
      return 1872; /* *fractqquqq2 */

    case 20:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode
   && reload_completed))
        return -1;
      return 1873; /* *fracthquqq2 */

    case 21:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode
   && reload_completed))
        return -1;
      return 1874; /* *fractuhquqq2 */

    case 22:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode
   && reload_completed))
        return -1;
      return 1875; /* *fracthauqq2 */

    case 23:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode
   && reload_completed))
        return -1;
      return 1876; /* *fractuhauqq2 */

    case 24:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode
   && reload_completed))
        return -1;
      return 1877; /* *fractsquqq2 */

    case 25:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode
   && reload_completed))
        return -1;
      return 1878; /* *fractusquqq2 */

    case 26:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode
   && reload_completed))
        return -1;
      return 1879; /* *fractsauqq2 */

    case 27:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode
   && reload_completed))
        return -1;
      return 1880; /* *fractusauqq2 */

    case 28:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode
   && reload_completed))
        return -1;
      return 1881; /* *fractdquqq2 */

    case 29:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode
   && reload_completed))
        return -1;
      return 1882; /* *fractudquqq2 */

    case 30:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode
   && reload_completed))
        return -1;
      return 1883; /* *fractdauqq2 */

    case 31:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode
   && reload_completed))
        return -1;
      return 1884; /* *fractudauqq2 */

    case 32:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode
   && reload_completed))
        return -1;
      return 1885; /* *fracttauqq2 */

    case 33:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode
   && reload_completed))
        return -1;
      return 1886; /* *fractutauqq2 */

    case 34:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UQQmode
   && reload_completed))
        return -1;
      return 1887; /* *fractqiuqq2 */

    case 35:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UQQmode
   && reload_completed))
        return -1;
      return 1888; /* *fracthiuqq2 */

    case 36:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UQQmode
   && reload_completed))
        return -1;
      return 1889; /* *fractsiuqq2 */

    case 37:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UQQmode
   && reload_completed))
        return -1;
      return 1890; /* *fractdiuqq2 */

    case 38:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != HQmode
   && reload_completed))
        return -1;
      return 1891; /* *fractqqhq2 */

    case 39:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode
   && reload_completed))
        return -1;
      return 1892; /* *fractuqqhq2 */

    case 40:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode
   && reload_completed))
        return -1;
      return 1893; /* *fractuhqhq2 */

    case 41:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != HQmode
   && reload_completed))
        return -1;
      return 1894; /* *fracthahq2 */

    case 42:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode
   && reload_completed))
        return -1;
      return 1895; /* *fractuhahq2 */

    case 43:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != HQmode
   && reload_completed))
        return -1;
      return 1896; /* *fractsqhq2 */

    case 44:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != HQmode
   && reload_completed))
        return -1;
      return 1897; /* *fractusqhq2 */

    case 45:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != HQmode
   && reload_completed))
        return -1;
      return 1898; /* *fractsahq2 */

    case 46:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != HQmode
   && reload_completed))
        return -1;
      return 1899; /* *fractusahq2 */

    case 47:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != HQmode
   && reload_completed))
        return -1;
      return 1900; /* *fractdqhq2 */

    case 48:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode
   && reload_completed))
        return -1;
      return 1901; /* *fractudqhq2 */

    case 49:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != HQmode
   && reload_completed))
        return -1;
      return 1902; /* *fractdahq2 */

    case 50:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode
   && reload_completed))
        return -1;
      return 1903; /* *fractudahq2 */

    case 51:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != HQmode
   && reload_completed))
        return -1;
      return 1904; /* *fracttahq2 */

    case 52:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode
   && reload_completed))
        return -1;
      return 1905; /* *fractutahq2 */

    case 53:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != HQmode
   && reload_completed))
        return -1;
      return 1906; /* *fractqihq2 */

    case 54:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != HQmode
   && reload_completed))
        return -1;
      return 1907; /* *fracthihq2 */

    case 55:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != HQmode
   && reload_completed))
        return -1;
      return 1908; /* *fractsihq2 */

    case 56:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != HQmode
   && reload_completed))
        return -1;
      return 1909; /* *fractdihq2 */

    case 57:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode
   && reload_completed))
        return -1;
      return 1910; /* *fractqquhq2 */

    case 58:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode
   && reload_completed))
        return -1;
      return 1911; /* *fractuqquhq2 */

    case 59:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode
   && reload_completed))
        return -1;
      return 1912; /* *fracthquhq2 */

    case 60:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode
   && reload_completed))
        return -1;
      return 1913; /* *fracthauhq2 */

    case 61:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode
   && reload_completed))
        return -1;
      return 1914; /* *fractuhauhq2 */

    case 62:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode
   && reload_completed))
        return -1;
      return 1915; /* *fractsquhq2 */

    case 63:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode
   && reload_completed))
        return -1;
      return 1916; /* *fractusquhq2 */

    case 64:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode
   && reload_completed))
        return -1;
      return 1917; /* *fractsauhq2 */

    case 65:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode
   && reload_completed))
        return -1;
      return 1918; /* *fractusauhq2 */

    case 66:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode
   && reload_completed))
        return -1;
      return 1919; /* *fractdquhq2 */

    case 67:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode
   && reload_completed))
        return -1;
      return 1920; /* *fractudquhq2 */

    case 68:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode
   && reload_completed))
        return -1;
      return 1921; /* *fractdauhq2 */

    case 69:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode
   && reload_completed))
        return -1;
      return 1922; /* *fractudauhq2 */

    case 70:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode
   && reload_completed))
        return -1;
      return 1923; /* *fracttauhq2 */

    case 71:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode
   && reload_completed))
        return -1;
      return 1924; /* *fractutauhq2 */

    case 72:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UHQmode
   && reload_completed))
        return -1;
      return 1925; /* *fractqiuhq2 */

    case 73:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UHQmode
   && reload_completed))
        return -1;
      return 1926; /* *fracthiuhq2 */

    case 74:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UHQmode
   && reload_completed))
        return -1;
      return 1927; /* *fractsiuhq2 */

    case 75:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UHQmode
   && reload_completed))
        return -1;
      return 1928; /* *fractdiuhq2 */

    case 76:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != HAmode
   && reload_completed))
        return -1;
      return 1929; /* *fractqqha2 */

    case 77:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode
   && reload_completed))
        return -1;
      return 1930; /* *fractuqqha2 */

    case 78:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != HAmode
   && reload_completed))
        return -1;
      return 1931; /* *fracthqha2 */

    case 79:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode
   && reload_completed))
        return -1;
      return 1932; /* *fractuhqha2 */

    case 80:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode
   && reload_completed))
        return -1;
      return 1933; /* *fractuhaha2 */

    case 81:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != HAmode
   && reload_completed))
        return -1;
      return 1934; /* *fractsqha2 */

    case 82:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != HAmode
   && reload_completed))
        return -1;
      return 1935; /* *fractusqha2 */

    case 83:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != HAmode
   && reload_completed))
        return -1;
      return 1936; /* *fractsaha2 */

    case 84:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != HAmode
   && reload_completed))
        return -1;
      return 1937; /* *fractusaha2 */

    case 85:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != HAmode
   && reload_completed))
        return -1;
      return 1938; /* *fractdqha2 */

    case 86:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode
   && reload_completed))
        return -1;
      return 1939; /* *fractudqha2 */

    case 87:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != HAmode
   && reload_completed))
        return -1;
      return 1940; /* *fractdaha2 */

    case 88:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode
   && reload_completed))
        return -1;
      return 1941; /* *fractudaha2 */

    case 89:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != HAmode
   && reload_completed))
        return -1;
      return 1942; /* *fracttaha2 */

    case 90:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode
   && reload_completed))
        return -1;
      return 1943; /* *fractutaha2 */

    case 91:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != HAmode
   && reload_completed))
        return -1;
      return 1944; /* *fractqiha2 */

    case 92:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != HAmode
   && reload_completed))
        return -1;
      return 1945; /* *fracthiha2 */

    case 93:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != HAmode
   && reload_completed))
        return -1;
      return 1946; /* *fractsiha2 */

    case 94:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != HAmode
   && reload_completed))
        return -1;
      return 1947; /* *fractdiha2 */

    case 95:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode
   && reload_completed))
        return -1;
      return 1948; /* *fractqquha2 */

    case 96:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode
   && reload_completed))
        return -1;
      return 1949; /* *fractuqquha2 */

    case 97:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode
   && reload_completed))
        return -1;
      return 1950; /* *fracthquha2 */

    case 98:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode
   && reload_completed))
        return -1;
      return 1951; /* *fractuhquha2 */

    case 99:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode
   && reload_completed))
        return -1;
      return 1952; /* *fracthauha2 */

    case 100:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode
   && reload_completed))
        return -1;
      return 1953; /* *fractsquha2 */

    case 101:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode
   && reload_completed))
        return -1;
      return 1954; /* *fractusquha2 */

    case 102:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode
   && reload_completed))
        return -1;
      return 1955; /* *fractsauha2 */

    case 103:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode
   && reload_completed))
        return -1;
      return 1956; /* *fractusauha2 */

    case 104:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode
   && reload_completed))
        return -1;
      return 1957; /* *fractdquha2 */

    case 105:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode
   && reload_completed))
        return -1;
      return 1958; /* *fractudquha2 */

    case 106:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode
   && reload_completed))
        return -1;
      return 1959; /* *fractdauha2 */

    case 107:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode
   && reload_completed))
        return -1;
      return 1960; /* *fractudauha2 */

    case 108:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode
   && reload_completed))
        return -1;
      return 1961; /* *fracttauha2 */

    case 109:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode
   && reload_completed))
        return -1;
      return 1962; /* *fractutauha2 */

    case 110:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UHAmode
   && reload_completed))
        return -1;
      return 1963; /* *fractqiuha2 */

    case 111:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UHAmode
   && reload_completed))
        return -1;
      return 1964; /* *fracthiuha2 */

    case 112:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UHAmode
   && reload_completed))
        return -1;
      return 1965; /* *fractsiuha2 */

    case 113:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UHAmode
   && reload_completed))
        return -1;
      return 1966; /* *fractdiuha2 */

    case 114:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != SQmode
   && reload_completed))
        return -1;
      return 1967; /* *fractqqsq2 */

    case 115:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode
   && reload_completed))
        return -1;
      return 1968; /* *fractuqqsq2 */

    case 116:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != SQmode
   && reload_completed))
        return -1;
      return 1969; /* *fracthqsq2 */

    case 117:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode
   && reload_completed))
        return -1;
      return 1970; /* *fractuhqsq2 */

    case 118:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != SQmode
   && reload_completed))
        return -1;
      return 1971; /* *fracthasq2 */

    case 119:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode
   && reload_completed))
        return -1;
      return 1972; /* *fractuhasq2 */

    case 120:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != SQmode
   && reload_completed))
        return -1;
      return 1973; /* *fractusqsq2 */

    case 121:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != SQmode
   && reload_completed))
        return -1;
      return 1974; /* *fractsasq2 */

    case 122:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != SQmode
   && reload_completed))
        return -1;
      return 1975; /* *fractusasq2 */

    case 123:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != SQmode
   && reload_completed))
        return -1;
      return 1976; /* *fractdqsq2 */

    case 124:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode
   && reload_completed))
        return -1;
      return 1977; /* *fractudqsq2 */

    case 125:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != SQmode
   && reload_completed))
        return -1;
      return 1978; /* *fractdasq2 */

    case 126:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode
   && reload_completed))
        return -1;
      return 1979; /* *fractudasq2 */

    case 127:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != SQmode
   && reload_completed))
        return -1;
      return 1980; /* *fracttasq2 */

    case 128:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode
   && reload_completed))
        return -1;
      return 1981; /* *fractutasq2 */

    case 129:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != SQmode
   && reload_completed))
        return -1;
      return 1982; /* *fractqisq2 */

    case 130:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != SQmode
   && reload_completed))
        return -1;
      return 1983; /* *fracthisq2 */

    case 131:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != SQmode
   && reload_completed))
        return -1;
      return 1984; /* *fractsisq2 */

    case 132:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != SQmode
   && reload_completed))
        return -1;
      return 1985; /* *fractdisq2 */

    case 133:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != USQmode
   && reload_completed))
        return -1;
      return 1986; /* *fractqqusq2 */

    case 134:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode
   && reload_completed))
        return -1;
      return 1987; /* *fractuqqusq2 */

    case 135:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != USQmode
   && reload_completed))
        return -1;
      return 1988; /* *fracthqusq2 */

    case 136:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode
   && reload_completed))
        return -1;
      return 1989; /* *fractuhqusq2 */

    case 137:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != USQmode
   && reload_completed))
        return -1;
      return 1990; /* *fracthausq2 */

    case 138:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode
   && reload_completed))
        return -1;
      return 1991; /* *fractuhausq2 */

    case 139:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != USQmode
   && reload_completed))
        return -1;
      return 1992; /* *fractsqusq2 */

    case 140:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != USQmode
   && reload_completed))
        return -1;
      return 1993; /* *fractsausq2 */

    case 141:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != USQmode
   && reload_completed))
        return -1;
      return 1994; /* *fractusausq2 */

    case 142:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != USQmode
   && reload_completed))
        return -1;
      return 1995; /* *fractdqusq2 */

    case 143:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode
   && reload_completed))
        return -1;
      return 1996; /* *fractudqusq2 */

    case 144:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != USQmode
   && reload_completed))
        return -1;
      return 1997; /* *fractdausq2 */

    case 145:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode
   && reload_completed))
        return -1;
      return 1998; /* *fractudausq2 */

    case 146:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != USQmode
   && reload_completed))
        return -1;
      return 1999; /* *fracttausq2 */

    case 147:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode
   && reload_completed))
        return -1;
      return 2000; /* *fractutausq2 */

    case 148:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != USQmode
   && reload_completed))
        return -1;
      return 2001; /* *fractqiusq2 */

    case 149:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != USQmode
   && reload_completed))
        return -1;
      return 2002; /* *fracthiusq2 */

    case 150:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != USQmode
   && reload_completed))
        return -1;
      return 2003; /* *fractsiusq2 */

    case 151:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != USQmode
   && reload_completed))
        return -1;
      return 2004; /* *fractdiusq2 */

    case 152:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != SAmode
   && reload_completed))
        return -1;
      return 2005; /* *fractqqsa2 */

    case 153:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode
   && reload_completed))
        return -1;
      return 2006; /* *fractuqqsa2 */

    case 154:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != SAmode
   && reload_completed))
        return -1;
      return 2007; /* *fracthqsa2 */

    case 155:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode
   && reload_completed))
        return -1;
      return 2008; /* *fractuhqsa2 */

    case 156:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != SAmode
   && reload_completed))
        return -1;
      return 2009; /* *fracthasa2 */

    case 157:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode
   && reload_completed))
        return -1;
      return 2010; /* *fractuhasa2 */

    case 158:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != SAmode
   && reload_completed))
        return -1;
      return 2011; /* *fractsqsa2 */

    case 159:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != SAmode
   && reload_completed))
        return -1;
      return 2012; /* *fractusqsa2 */

    case 160:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != SAmode
   && reload_completed))
        return -1;
      return 2013; /* *fractusasa2 */

    case 161:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != SAmode
   && reload_completed))
        return -1;
      return 2014; /* *fractdqsa2 */

    case 162:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode
   && reload_completed))
        return -1;
      return 2015; /* *fractudqsa2 */

    case 163:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != SAmode
   && reload_completed))
        return -1;
      return 2016; /* *fractdasa2 */

    case 164:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode
   && reload_completed))
        return -1;
      return 2017; /* *fractudasa2 */

    case 165:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != SAmode
   && reload_completed))
        return -1;
      return 2018; /* *fracttasa2 */

    case 166:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode
   && reload_completed))
        return -1;
      return 2019; /* *fractutasa2 */

    case 167:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != SAmode
   && reload_completed))
        return -1;
      return 2020; /* *fractqisa2 */

    case 168:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != SAmode
   && reload_completed))
        return -1;
      return 2021; /* *fracthisa2 */

    case 169:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != SAmode
   && reload_completed))
        return -1;
      return 2022; /* *fractsisa2 */

    case 170:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != SAmode
   && reload_completed))
        return -1;
      return 2023; /* *fractdisa2 */

    case 171:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != USAmode
   && reload_completed))
        return -1;
      return 2024; /* *fractqqusa2 */

    case 172:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode
   && reload_completed))
        return -1;
      return 2025; /* *fractuqqusa2 */

    case 173:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != USAmode
   && reload_completed))
        return -1;
      return 2026; /* *fracthqusa2 */

    case 174:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode
   && reload_completed))
        return -1;
      return 2027; /* *fractuhqusa2 */

    case 175:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != USAmode
   && reload_completed))
        return -1;
      return 2028; /* *fracthausa2 */

    case 176:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode
   && reload_completed))
        return -1;
      return 2029; /* *fractuhausa2 */

    case 177:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != USAmode
   && reload_completed))
        return -1;
      return 2030; /* *fractsqusa2 */

    case 178:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != USAmode
   && reload_completed))
        return -1;
      return 2031; /* *fractusqusa2 */

    case 179:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != USAmode
   && reload_completed))
        return -1;
      return 2032; /* *fractsausa2 */

    case 180:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != USAmode
   && reload_completed))
        return -1;
      return 2033; /* *fractdqusa2 */

    case 181:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode
   && reload_completed))
        return -1;
      return 2034; /* *fractudqusa2 */

    case 182:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != USAmode
   && reload_completed))
        return -1;
      return 2035; /* *fractdausa2 */

    case 183:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode
   && reload_completed))
        return -1;
      return 2036; /* *fractudausa2 */

    case 184:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != USAmode
   && reload_completed))
        return -1;
      return 2037; /* *fracttausa2 */

    case 185:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode
   && reload_completed))
        return -1;
      return 2038; /* *fractutausa2 */

    case 186:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != USAmode
   && reload_completed))
        return -1;
      return 2039; /* *fractqiusa2 */

    case 187:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != USAmode
   && reload_completed))
        return -1;
      return 2040; /* *fracthiusa2 */

    case 188:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != USAmode
   && reload_completed))
        return -1;
      return 2041; /* *fractsiusa2 */

    case 189:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != USAmode
   && reload_completed))
        return -1;
      return 2042; /* *fractdiusa2 */

    case 190:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != DQmode
   && reload_completed))
        return -1;
      return 2043; /* *fractqqdq2 */

    case 191:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode
   && reload_completed))
        return -1;
      return 2044; /* *fractuqqdq2 */

    case 192:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != DQmode
   && reload_completed))
        return -1;
      return 2045; /* *fracthqdq2 */

    case 193:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode
   && reload_completed))
        return -1;
      return 2046; /* *fractuhqdq2 */

    case 194:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != DQmode
   && reload_completed))
        return -1;
      return 2047; /* *fracthadq2 */

    case 195:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode
   && reload_completed))
        return -1;
      return 2048; /* *fractuhadq2 */

    case 196:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != DQmode
   && reload_completed))
        return -1;
      return 2049; /* *fractsqdq2 */

    case 197:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != DQmode
   && reload_completed))
        return -1;
      return 2050; /* *fractusqdq2 */

    case 198:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != DQmode
   && reload_completed))
        return -1;
      return 2051; /* *fractsadq2 */

    case 199:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != DQmode
   && reload_completed))
        return -1;
      return 2052; /* *fractusadq2 */

    case 200:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode
   && reload_completed))
        return -1;
      return 2053; /* *fractudqdq2 */

    case 201:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != DQmode
   && reload_completed))
        return -1;
      return 2054; /* *fractdadq2 */

    case 202:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode
   && reload_completed))
        return -1;
      return 2055; /* *fractudadq2 */

    case 203:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != DQmode
   && reload_completed))
        return -1;
      return 2056; /* *fracttadq2 */

    case 204:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode
   && reload_completed))
        return -1;
      return 2057; /* *fractutadq2 */

    case 205:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != DQmode
   && reload_completed))
        return -1;
      return 2058; /* *fractqidq2 */

    case 206:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != DQmode
   && reload_completed))
        return -1;
      return 2059; /* *fracthidq2 */

    case 207:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != DQmode
   && reload_completed))
        return -1;
      return 2060; /* *fractsidq2 */

    case 208:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != DQmode
   && reload_completed))
        return -1;
      return 2061; /* *fractdidq2 */

    case 209:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode
   && reload_completed))
        return -1;
      return 2062; /* *fractqqudq2 */

    case 210:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode
   && reload_completed))
        return -1;
      return 2063; /* *fractuqqudq2 */

    case 211:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode
   && reload_completed))
        return -1;
      return 2064; /* *fracthqudq2 */

    case 212:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode
   && reload_completed))
        return -1;
      return 2065; /* *fractuhqudq2 */

    case 213:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode
   && reload_completed))
        return -1;
      return 2066; /* *fracthaudq2 */

    case 214:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode
   && reload_completed))
        return -1;
      return 2067; /* *fractuhaudq2 */

    case 215:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode
   && reload_completed))
        return -1;
      return 2068; /* *fractsqudq2 */

    case 216:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode
   && reload_completed))
        return -1;
      return 2069; /* *fractusqudq2 */

    case 217:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode
   && reload_completed))
        return -1;
      return 2070; /* *fractsaudq2 */

    case 218:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode
   && reload_completed))
        return -1;
      return 2071; /* *fractusaudq2 */

    case 219:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode
   && reload_completed))
        return -1;
      return 2072; /* *fractdqudq2 */

    case 220:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode
   && reload_completed))
        return -1;
      return 2073; /* *fractdaudq2 */

    case 221:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode
   && reload_completed))
        return -1;
      return 2074; /* *fractudaudq2 */

    case 222:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode
   && reload_completed))
        return -1;
      return 2075; /* *fracttaudq2 */

    case 223:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode
   && reload_completed))
        return -1;
      return 2076; /* *fractutaudq2 */

    case 224:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UDQmode
   && reload_completed))
        return -1;
      return 2077; /* *fractqiudq2 */

    case 225:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UDQmode
   && reload_completed))
        return -1;
      return 2078; /* *fracthiudq2 */

    case 226:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UDQmode
   && reload_completed))
        return -1;
      return 2079; /* *fractsiudq2 */

    case 227:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UDQmode
   && reload_completed))
        return -1;
      return 2080; /* *fractdiudq2 */

    case 228:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != DAmode
   && reload_completed))
        return -1;
      return 2081; /* *fractqqda2 */

    case 229:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode
   && reload_completed))
        return -1;
      return 2082; /* *fractuqqda2 */

    case 230:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != DAmode
   && reload_completed))
        return -1;
      return 2083; /* *fracthqda2 */

    case 231:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode
   && reload_completed))
        return -1;
      return 2084; /* *fractuhqda2 */

    case 232:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != DAmode
   && reload_completed))
        return -1;
      return 2085; /* *fracthada2 */

    case 233:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode
   && reload_completed))
        return -1;
      return 2086; /* *fractuhada2 */

    case 234:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != DAmode
   && reload_completed))
        return -1;
      return 2087; /* *fractsqda2 */

    case 235:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != DAmode
   && reload_completed))
        return -1;
      return 2088; /* *fractusqda2 */

    case 236:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != DAmode
   && reload_completed))
        return -1;
      return 2089; /* *fractsada2 */

    case 237:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != DAmode
   && reload_completed))
        return -1;
      return 2090; /* *fractusada2 */

    case 238:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != DAmode
   && reload_completed))
        return -1;
      return 2091; /* *fractdqda2 */

    case 239:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode
   && reload_completed))
        return -1;
      return 2092; /* *fractudqda2 */

    case 240:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode
   && reload_completed))
        return -1;
      return 2093; /* *fractudada2 */

    case 241:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != DAmode
   && reload_completed))
        return -1;
      return 2094; /* *fracttada2 */

    case 242:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode
   && reload_completed))
        return -1;
      return 2095; /* *fractutada2 */

    case 243:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != DAmode
   && reload_completed))
        return -1;
      return 2096; /* *fractqida2 */

    case 244:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != DAmode
   && reload_completed))
        return -1;
      return 2097; /* *fracthida2 */

    case 245:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != DAmode
   && reload_completed))
        return -1;
      return 2098; /* *fractsida2 */

    case 246:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != DAmode
   && reload_completed))
        return -1;
      return 2099; /* *fractdida2 */

    case 247:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode
   && reload_completed))
        return -1;
      return 2100; /* *fractqquda2 */

    case 248:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode
   && reload_completed))
        return -1;
      return 2101; /* *fractuqquda2 */

    case 249:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode
   && reload_completed))
        return -1;
      return 2102; /* *fracthquda2 */

    case 250:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode
   && reload_completed))
        return -1;
      return 2103; /* *fractuhquda2 */

    case 251:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode
   && reload_completed))
        return -1;
      return 2104; /* *fracthauda2 */

    case 252:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode
   && reload_completed))
        return -1;
      return 2105; /* *fractuhauda2 */

    case 253:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode
   && reload_completed))
        return -1;
      return 2106; /* *fractsquda2 */

    case 254:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode
   && reload_completed))
        return -1;
      return 2107; /* *fractusquda2 */

    case 255:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode
   && reload_completed))
        return -1;
      return 2108; /* *fractsauda2 */

    case 256:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode
   && reload_completed))
        return -1;
      return 2109; /* *fractusauda2 */

    case 257:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode
   && reload_completed))
        return -1;
      return 2110; /* *fractdquda2 */

    case 258:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode
   && reload_completed))
        return -1;
      return 2111; /* *fractudquda2 */

    case 259:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode
   && reload_completed))
        return -1;
      return 2112; /* *fractdauda2 */

    case 260:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode
   && reload_completed))
        return -1;
      return 2113; /* *fracttauda2 */

    case 261:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode
   && reload_completed))
        return -1;
      return 2114; /* *fractutauda2 */

    case 262:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UDAmode
   && reload_completed))
        return -1;
      return 2115; /* *fractqiuda2 */

    case 263:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UDAmode
   && reload_completed))
        return -1;
      return 2116; /* *fracthiuda2 */

    case 264:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UDAmode
   && reload_completed))
        return -1;
      return 2117; /* *fractsiuda2 */

    case 265:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UDAmode
   && reload_completed))
        return -1;
      return 2118; /* *fractdiuda2 */

    case 266:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != TAmode
   && reload_completed))
        return -1;
      return 2119; /* *fractqqta2 */

    case 267:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode
   && reload_completed))
        return -1;
      return 2120; /* *fractuqqta2 */

    case 268:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != TAmode
   && reload_completed))
        return -1;
      return 2121; /* *fracthqta2 */

    case 269:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode
   && reload_completed))
        return -1;
      return 2122; /* *fractuhqta2 */

    case 270:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != TAmode
   && reload_completed))
        return -1;
      return 2123; /* *fracthata2 */

    case 271:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode
   && reload_completed))
        return -1;
      return 2124; /* *fractuhata2 */

    case 272:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != TAmode
   && reload_completed))
        return -1;
      return 2125; /* *fractsqta2 */

    case 273:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != TAmode
   && reload_completed))
        return -1;
      return 2126; /* *fractusqta2 */

    case 274:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != TAmode
   && reload_completed))
        return -1;
      return 2127; /* *fractsata2 */

    case 275:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != TAmode
   && reload_completed))
        return -1;
      return 2128; /* *fractusata2 */

    case 276:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != TAmode
   && reload_completed))
        return -1;
      return 2129; /* *fractdqta2 */

    case 277:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode
   && reload_completed))
        return -1;
      return 2130; /* *fractudqta2 */

    case 278:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != TAmode
   && reload_completed))
        return -1;
      return 2131; /* *fractdata2 */

    case 279:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode
   && reload_completed))
        return -1;
      return 2132; /* *fractudata2 */

    case 280:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode
   && reload_completed))
        return -1;
      return 2133; /* *fractutata2 */

    case 281:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != TAmode
   && reload_completed))
        return -1;
      return 2134; /* *fractqita2 */

    case 282:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != TAmode
   && reload_completed))
        return -1;
      return 2135; /* *fracthita2 */

    case 283:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != TAmode
   && reload_completed))
        return -1;
      return 2136; /* *fractsita2 */

    case 284:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != TAmode
   && reload_completed))
        return -1;
      return 2137; /* *fractdita2 */

    case 285:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode
   && reload_completed))
        return -1;
      return 2138; /* *fractqquta2 */

    case 286:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode
   && reload_completed))
        return -1;
      return 2139; /* *fractuqquta2 */

    case 287:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode
   && reload_completed))
        return -1;
      return 2140; /* *fracthquta2 */

    case 288:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode
   && reload_completed))
        return -1;
      return 2141; /* *fractuhquta2 */

    case 289:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode
   && reload_completed))
        return -1;
      return 2142; /* *fracthauta2 */

    case 290:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode
   && reload_completed))
        return -1;
      return 2143; /* *fractuhauta2 */

    case 291:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode
   && reload_completed))
        return -1;
      return 2144; /* *fractsquta2 */

    case 292:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode
   && reload_completed))
        return -1;
      return 2145; /* *fractusquta2 */

    case 293:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode
   && reload_completed))
        return -1;
      return 2146; /* *fractsauta2 */

    case 294:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode
   && reload_completed))
        return -1;
      return 2147; /* *fractusauta2 */

    case 295:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode
   && reload_completed))
        return -1;
      return 2148; /* *fractdquta2 */

    case 296:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode
   && reload_completed))
        return -1;
      return 2149; /* *fractudquta2 */

    case 297:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode
   && reload_completed))
        return -1;
      return 2150; /* *fractdauta2 */

    case 298:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode
   && reload_completed))
        return -1;
      return 2151; /* *fractudauta2 */

    case 299:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode
   && reload_completed))
        return -1;
      return 2152; /* *fracttauta2 */

    case 300:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != UTAmode
   && reload_completed))
        return -1;
      return 2153; /* *fractqiuta2 */

    case 301:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != UTAmode
   && reload_completed))
        return -1;
      return 2154; /* *fracthiuta2 */

    case 302:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != UTAmode
   && reload_completed))
        return -1;
      return 2155; /* *fractsiuta2 */

    case 303:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != UTAmode
   && reload_completed))
        return -1;
      return 2156; /* *fractdiuta2 */

    case 304:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != QImode
   && reload_completed))
        return -1;
      return 2157; /* *fractqqqi2 */

    case 305:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != QImode
   && reload_completed))
        return -1;
      return 2158; /* *fractuqqqi2 */

    case 306:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != QImode
   && reload_completed))
        return -1;
      return 2159; /* *fracthqqi2 */

    case 307:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != QImode
   && reload_completed))
        return -1;
      return 2160; /* *fractuhqqi2 */

    case 308:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != QImode
   && reload_completed))
        return -1;
      return 2161; /* *fracthaqi2 */

    case 309:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != QImode
   && reload_completed))
        return -1;
      return 2162; /* *fractuhaqi2 */

    case 310:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != QImode
   && reload_completed))
        return -1;
      return 2163; /* *fractsqqi2 */

    case 311:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != QImode
   && reload_completed))
        return -1;
      return 2164; /* *fractusqqi2 */

    case 312:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != QImode
   && reload_completed))
        return -1;
      return 2165; /* *fractsaqi2 */

    case 313:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != QImode
   && reload_completed))
        return -1;
      return 2166; /* *fractusaqi2 */

    case 314:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != QImode
   && reload_completed))
        return -1;
      return 2167; /* *fractdqqi2 */

    case 315:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != QImode
   && reload_completed))
        return -1;
      return 2168; /* *fractudqqi2 */

    case 316:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != QImode
   && reload_completed))
        return -1;
      return 2169; /* *fractdaqi2 */

    case 317:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != QImode
   && reload_completed))
        return -1;
      return 2170; /* *fractudaqi2 */

    case 318:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != QImode
   && reload_completed))
        return -1;
      return 2171; /* *fracttaqi2 */

    case 319:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != QImode
   && reload_completed))
        return -1;
      return 2172; /* *fractutaqi2 */

    case 320:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != QImode
   && reload_completed))
        return -1;
      return 2173; /* *fracthiqi2 */

    case 321:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != QImode
   && reload_completed))
        return -1;
      return 2174; /* *fractsiqi2 */

    case 322:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != QImode
   && reload_completed))
        return -1;
      return 2175; /* *fractdiqi2 */

    case 323:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != HImode
   && reload_completed))
        return -1;
      return 2176; /* *fractqqhi2 */

    case 324:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != HImode
   && reload_completed))
        return -1;
      return 2177; /* *fractuqqhi2 */

    case 325:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != HImode
   && reload_completed))
        return -1;
      return 2178; /* *fracthqhi2 */

    case 326:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != HImode
   && reload_completed))
        return -1;
      return 2179; /* *fractuhqhi2 */

    case 327:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != HImode
   && reload_completed))
        return -1;
      return 2180; /* *fracthahi2 */

    case 328:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != HImode
   && reload_completed))
        return -1;
      return 2181; /* *fractuhahi2 */

    case 329:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != HImode
   && reload_completed))
        return -1;
      return 2182; /* *fractsqhi2 */

    case 330:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != HImode
   && reload_completed))
        return -1;
      return 2183; /* *fractusqhi2 */

    case 331:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != HImode
   && reload_completed))
        return -1;
      return 2184; /* *fractsahi2 */

    case 332:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != HImode
   && reload_completed))
        return -1;
      return 2185; /* *fractusahi2 */

    case 333:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != HImode
   && reload_completed))
        return -1;
      return 2186; /* *fractdqhi2 */

    case 334:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != HImode
   && reload_completed))
        return -1;
      return 2187; /* *fractudqhi2 */

    case 335:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != HImode
   && reload_completed))
        return -1;
      return 2188; /* *fractdahi2 */

    case 336:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != HImode
   && reload_completed))
        return -1;
      return 2189; /* *fractudahi2 */

    case 337:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != HImode
   && reload_completed))
        return -1;
      return 2190; /* *fracttahi2 */

    case 338:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != HImode
   && reload_completed))
        return -1;
      return 2191; /* *fractutahi2 */

    case 339:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != HImode
   && reload_completed))
        return -1;
      return 2192; /* *fractqihi2 */

    case 340:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != HImode
   && reload_completed))
        return -1;
      return 2193; /* *fractsihi2 */

    case 341:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != HImode
   && reload_completed))
        return -1;
      return 2194; /* *fractdihi2 */

    case 342:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != SImode
   && reload_completed))
        return -1;
      return 2195; /* *fractqqsi2 */

    case 343:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != SImode
   && reload_completed))
        return -1;
      return 2196; /* *fractuqqsi2 */

    case 344:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != SImode
   && reload_completed))
        return -1;
      return 2197; /* *fracthqsi2 */

    case 345:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != SImode
   && reload_completed))
        return -1;
      return 2198; /* *fractuhqsi2 */

    case 346:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != SImode
   && reload_completed))
        return -1;
      return 2199; /* *fracthasi2 */

    case 347:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != SImode
   && reload_completed))
        return -1;
      return 2200; /* *fractuhasi2 */

    case 348:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != SImode
   && reload_completed))
        return -1;
      return 2201; /* *fractsqsi2 */

    case 349:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != SImode
   && reload_completed))
        return -1;
      return 2202; /* *fractusqsi2 */

    case 350:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != SImode
   && reload_completed))
        return -1;
      return 2203; /* *fractsasi2 */

    case 351:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != SImode
   && reload_completed))
        return -1;
      return 2204; /* *fractusasi2 */

    case 352:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != SImode
   && reload_completed))
        return -1;
      return 2205; /* *fractdqsi2 */

    case 353:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != SImode
   && reload_completed))
        return -1;
      return 2206; /* *fractudqsi2 */

    case 354:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != SImode
   && reload_completed))
        return -1;
      return 2207; /* *fractdasi2 */

    case 355:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != SImode
   && reload_completed))
        return -1;
      return 2208; /* *fractudasi2 */

    case 356:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != SImode
   && reload_completed))
        return -1;
      return 2209; /* *fracttasi2 */

    case 357:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != SImode
   && reload_completed))
        return -1;
      return 2210; /* *fractutasi2 */

    case 358:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != SImode
   && reload_completed))
        return -1;
      return 2211; /* *fractqisi2 */

    case 359:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != SImode
   && reload_completed))
        return -1;
      return 2212; /* *fracthisi2 */

    case 360:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DImode != SImode
   && reload_completed))
        return -1;
      return 2213; /* *fractdisi2 */

    case 361:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QQmode != DImode
   && reload_completed))
        return -1;
      return 2214; /* *fractqqdi2 */

    case 362:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UQQmode != DImode
   && reload_completed))
        return -1;
      return 2215; /* *fractuqqdi2 */

    case 363:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HQmode != DImode
   && reload_completed))
        return -1;
      return 2216; /* *fracthqdi2 */

    case 364:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHQmode != DImode
   && reload_completed))
        return -1;
      return 2217; /* *fractuhqdi2 */

    case 365:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HAmode != DImode
   && reload_completed))
        return -1;
      return 2218; /* *fracthadi2 */

    case 366:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UHAmode != DImode
   && reload_completed))
        return -1;
      return 2219; /* *fractuhadi2 */

    case 367:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SQmode != DImode
   && reload_completed))
        return -1;
      return 2220; /* *fractsqdi2 */

    case 368:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USQmode != DImode
   && reload_completed))
        return -1;
      return 2221; /* *fractusqdi2 */

    case 369:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SAmode != DImode
   && reload_completed))
        return -1;
      return 2222; /* *fractsadi2 */

    case 370:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(USAmode != DImode
   && reload_completed))
        return -1;
      return 2223; /* *fractusadi2 */

    case 371:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DQmode != DImode
   && reload_completed))
        return -1;
      return 2224; /* *fractdqdi2 */

    case 372:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDQmode != DImode
   && reload_completed))
        return -1;
      return 2225; /* *fractudqdi2 */

    case 373:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(DAmode != DImode
   && reload_completed))
        return -1;
      return 2226; /* *fractdadi2 */

    case 374:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UDAmode != DImode
   && reload_completed))
        return -1;
      return 2227; /* *fractudadi2 */

    case 375:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(TAmode != DImode
   && reload_completed))
        return -1;
      return 2228; /* *fracttadi2 */

    case 376:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(UTAmode != DImode
   && reload_completed))
        return -1;
      return 2229; /* *fractutadi2 */

    case 377:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(QImode != DImode
   && reload_completed))
        return -1;
      return 2230; /* *fractqidi2 */

    case 378:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(HImode != DImode
   && reload_completed))
        return -1;
      return 2231; /* *fracthidi2 */

    case 379:
      if (!
#line 75 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(SImode != DImode
   && reload_completed))
        return -1;
      return 2232; /* *fractsidi2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      switch (pattern65 (x3))
        {
        case 0:
          if (!
#line 1543 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_98 (insn, operands);

        case 1:
          if (!
#line 8900 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_628 (insn, operands);

        case 2:
          if (!
#line 686 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 3:
          if (!
#line 686 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1831 (insn, operands);

        case 4:
          if (!
#line 686 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1832 (insn, operands);

        case 5:
          if (!
#line 686 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1833 (insn, operands);

        case 6:
          if (!
#line 686 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1834 (insn, operands);

        case 7:
          if (!
#line 686 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1835 (insn, operands);

        case 8:
          if (!
#line 686 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1836 (insn, operands);

        case 9:
          if (!
#line 686 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1837 (insn, operands);

        case 10:
          if (!
#line 686 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1838 (insn, operands);

        case 11:
          if (!
#line 686 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1839 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_QImode))
        return NULL;
      switch (XINT (x3, 1))
        {
        case 3:
          if (!(
#line 9698 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9700 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_653 (insn, operands);

        case 4:
          if (!(
#line 9770 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9772 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_655 (insn, operands);

        case 5:
          if (!(
#line 9842 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9844 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_657 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return NULL;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return NULL;
      operands[2] = x6;
      if (const_2_to_6_operand (operands[2], E_HImode)
          && register_operand (operands[0], E_HImode)
          && GET_MODE (x4) == E_HImode)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (register_operand (operands[1], E_QImode))
            {
              x8 = XVECEXP (x1, 0, 1);
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              if (scratch_operand (operands[3], E_QImode)
                  && (
#line 3087 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3089 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_304 (insn, operands);
            }
        }
      if (XWINT (x6, 0) != 7L
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return NULL;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x8 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!scratch_operand (operands[2], E_QImode)
          || !(
#line 3105 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3107 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_305 (insn, operands);

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode
          || pattern213 (x1) != 0
          || !(
#line 3123 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_306 (insn, operands);

    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern242 (x1))
            {
            case 0:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_437 (insn, operands);
              break;

            case 1:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_440 (insn, operands);
              break;

            case 2:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3l (operands[2])))
                return gen_split_443 (insn, operands);
              break;

            case 3:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_446 (insn, operands);
              break;

            case 4:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_449 (insn, operands);
              break;

            case 5:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_452 (insn, operands);
              break;

            case 6:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return gen_split_455 (insn, operands);
              break;

            case 7:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_458 (insn, operands);
              break;

            case 8:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_461 (insn, operands);
              break;

            case 9:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_464 (insn, operands);
              break;

            case 10:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return gen_split_467 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern243 (x1) != 0
          || !
#line 5707 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_501 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode
      || !d_register_operand (operands[0], E_QImode))
    return NULL;
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_QImode))
    return NULL;
  x5 = XEXP (x3, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return NULL;
  x6 = PATTERN (peep2_next_insn (1));
  if (pattern304 (x6, 
E_QImode, 
AND) != 0)
    return NULL;
  x7 = XVECEXP (x6, 0, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return NULL;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return NULL;
  x11 = XEXP (x7, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_42 (insn, operands);
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (peep2_current_count < 2
      || peep2_current_count < 3)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 0);
  if (pattern307 (x5) != 0)
    return NULL;
  x6 = PATTERN (peep2_next_insn (1));
  switch (pattern371 (x6))
    {
    case 0:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_HImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern382 (x12, 
E_HImode))
        {
        case 0:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_134 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_135 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_136 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_137 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_138 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], HImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_139 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern383 (x12, 
E_HImode))
        {
        case 0:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_170 (insn, operands);

        case 1:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_171 (insn, operands);

        case 2:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_172 (insn, operands);

        case 3:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_173 (insn, operands);

        case 4:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_174 (insn, operands);

        case 5:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_175 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_PSImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern382 (x12, 
E_PSImode))
        {
        case 0:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_140 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_141 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_142 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_143 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_144 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], PSImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_145 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern383 (x12, 
E_PSImode))
        {
        case 0:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_176 (insn, operands);

        case 1:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_177 (insn, operands);

        case 2:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_178 (insn, operands);

        case 3:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_179 (insn, operands);

        case 4:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_180 (insn, operands);

        case 5:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_181 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      x8 = XEXP (x7, 1);
      x9 = XEXP (x8, 1);
      if (!const0_operand (x9, E_SImode))
        return NULL;
      operands[3] = x9;
      x10 = PATTERN (peep2_next_insn (2));
      x11 = XEXP (x10, 1);
      x12 = XEXP (x11, 0);
      switch (pattern382 (x12, 
E_SImode))
        {
        case 0:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_146 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_147 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_148 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_149 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_150 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 7241 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   // Needs a const or a d-reg.
   && (REG_P (operands[1]) || d_register_operand (operands[0], SImode))
   && peep2_regno_dead_p (3, REG_CC)))
            {
              *pmatch_len_ = 2;
              res = gen_peephole2_151 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
      operands[4] = x9;
      switch (pattern383 (x12, 
E_SImode))
        {
        case 0:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_182 (insn, operands);

        case 1:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_183 (insn, operands);

        case 2:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_184 (insn, operands);

        case 3:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_185 (insn, operands);

        case 4:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_186 (insn, operands);

        case 5:
          if (!
#line 7304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_187 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return peephole2_6 (x1, insn, pmatch_len_);

        case 3:
          if (peep2_current_count < 2)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 2);
          if (pattern107 (x4) != 0)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 2)
            return NULL;
          x7 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x7) != SET)
            return NULL;
          x8 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x8) != CLOBBER)
            return NULL;
          x9 = XEXP (x2, 1);
          switch (GET_CODE (x9))
            {
            case CONST_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
              operands[1] = x9;
              x10 = XEXP (x3, 0);
              operands[2] = x10;
              if (!d_register_operand (operands[2], E_QImode))
                return NULL;
              x11 = XEXP (x7, 1);
              if (GET_CODE (x11) != PLUS)
                return NULL;
              x12 = XEXP (x8, 0);
              if (GET_CODE (x12) != REG
                  || REGNO (x12) != 36
                  || GET_MODE (x12) != E_CCmode)
                return NULL;
              x13 = XEXP (x7, 0);
              operands[3] = x13;
              x14 = XEXP (x11, 0);
              if (!rtx_equal_p (x14, operands[3]))
                return NULL;
              x15 = XEXP (x11, 1);
              if (!rtx_equal_p (x15, operands[0]))
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern372 (x11, 
E_HImode) != 0
                      || !
#line 1885 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_37 (insn, operands);

                case E_HQmode:
                  if (pattern372 (x11, 
E_HQmode) != 0
                      || !
#line 1885 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_38 (insn, operands);

                case E_UHQmode:
                  if (pattern372 (x11, 
E_UHQmode) != 0
                      || !
#line 1885 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_39 (insn, operands);

                case E_HAmode:
                  if (pattern372 (x11, 
E_HAmode) != 0
                      || !
#line 1885 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_40 (insn, operands);

                case E_UHAmode:
                  if (pattern372 (x11, 
E_UHAmode) != 0
                      || !
#line 1885 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_reg_dead_p (2, operands[0])))
                    return NULL;
                  *pmatch_len_ = 1;
                  return gen_peephole2_41 (insn, operands);

                default:
                  return NULL;
                }

            case PLUS:
              if (peep2_current_count < 3)
                return NULL;
              x16 = XEXP (x9, 1);
              operands[1] = x16;
              x10 = XEXP (x3, 0);
              operands[3] = x10;
              if (!scratch_or_dreg_operand (operands[3], E_QImode))
                return NULL;
              x17 = XEXP (x9, 0);
              if (pattern360 (x17) != 0)
                return NULL;
              x12 = XEXP (x8, 0);
              if (GET_CODE (x12) != SCRATCH
                  || GET_MODE (x12) != E_QImode)
                return NULL;
              x11 = XEXP (x7, 1);
              x15 = XEXP (x11, 1);
              operands[4] = x15;
              x14 = XEXP (x11, 0);
              switch (pattern370 (x14))
                {
                case 0:
                  switch (pattern379 (x9, 
E_HImode))
                    {
                    case 0:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_152 (insn, operands);

                    case 1:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_153 (insn, operands);

                    case 2:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_154 (insn, operands);

                    case 3:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_155 (insn, operands);

                    case 4:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_156 (insn, operands);

                    case 5:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_157 (insn, operands);

                    default:
                      return NULL;
                    }

                case 1:
                  switch (pattern379 (x9, 
E_PSImode))
                    {
                    case 0:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_158 (insn, operands);

                    case 1:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_159 (insn, operands);

                    case 2:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_160 (insn, operands);

                    case 3:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_161 (insn, operands);

                    case 4:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_162 (insn, operands);

                    case 5:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_163 (insn, operands);

                    default:
                      return NULL;
                    }

                case 2:
                  switch (pattern379 (x9, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (EQ == GE || EQ == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_164 (insn, operands);

                    case 1:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (NE == GE || NE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_165 (insn, operands);

                    case 2:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GE == GE || GE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_166 (insn, operands);

                    case 3:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LT == GE || LT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_167 (insn, operands);

                    case 4:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (GT == GE || GT == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_168 (insn, operands);

                    case 5:
                      if (!
#line 7269 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(// Multi-byte reg-reg additions only set the N flag.
   (LE == GE || LE == LT || ! REG_P (operands[1]))
   && peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_169 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case MINUS:
              if (peep2_current_count < 3)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != SCRATCH
                  || GET_MODE (x10) != E_QImode)
                return NULL;
              x16 = XEXP (x9, 1);
              operands[1] = x16;
              x17 = XEXP (x9, 0);
              if (pattern360 (x17) != 0
                  || pattern369 (x6) != 0)
                return NULL;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  switch (pattern380 (x9, 
E_HImode))
                    {
                    case 0:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_188 (insn, operands);

                    case 1:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_189 (insn, operands);

                    case 2:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_190 (insn, operands);

                    case 3:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_191 (insn, operands);

                    case 4:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_192 (insn, operands);

                    case 5:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_193 (insn, operands);

                    default:
                      return NULL;
                    }

                case E_SImode:
                  switch (pattern380 (x9, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_194 (insn, operands);

                    case 1:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_195 (insn, operands);

                    case 2:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_196 (insn, operands);

                    case 3:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_197 (insn, operands);

                    case 4:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_198 (insn, operands);

                    case 5:
                      if (!
#line 7374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_199 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case ASHIFT:
              if (peep2_current_count < 3)
                return NULL;
              x16 = XEXP (x9, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x10 = XEXP (x3, 0);
              operands[3] = x10;
              if (!scratch_operand (operands[3], E_QImode))
                return NULL;
              x17 = XEXP (x9, 0);
              if (!rtx_equal_p (x17, operands[0]))
                return NULL;
              x11 = XEXP (x7, 1);
              if (GET_CODE (x11) != COMPARE
                  || GET_MODE (x11) != E_CCmode)
                return NULL;
              x15 = XEXP (x11, 1);
              if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x13 = XEXP (x7, 0);
              if (GET_CODE (x13) != REG
                  || REGNO (x13) != 36
                  || GET_MODE (x13) != E_CCmode)
                return NULL;
              switch (pattern371 (x6))
                {
                case 0:
                  switch (pattern381 (x9, 
E_HImode))
                    {
                    case 0:
                      if (!
#line 7508 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_278 (insn, operands);

                    case 1:
                      if (!
#line 7508 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_279 (insn, operands);

                    default:
                      return NULL;
                    }

                case 1:
                  switch (pattern381 (x9, 
E_PSImode))
                    {
                    case 0:
                      if (!
#line 7508 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_280 (insn, operands);

                    case 1:
                      if (!
#line 7508 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_281 (insn, operands);

                    default:
                      return NULL;
                    }

                case 2:
                  switch (pattern381 (x9, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 7508 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_282 (insn, operands);

                    case 1:
                      if (!
#line 7508 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
                        return NULL;
                      *pmatch_len_ = 2;
                      return gen_peephole2_283 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SET:
      if (peep2_current_count < 2)
        return NULL;
      x18 = XEXP (x1, 1);
      if (GET_CODE (x18) != COMPARE
          || pattern21 (x1) != 0)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern200 (x6) != 0)
        return NULL;
      x19 = XEXP (x18, 0);
      switch (GET_MODE (x19))
        {
        case E_QImode:
          if (!register_operand (x19, E_QImode))
            return NULL;
          operands[0] = x19;
          x20 = XEXP (x18, 1);
          switch (pattern336 (x20, 
E_QImode))
            {
            case 0:
              if (
#line 7725 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_290 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7725 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_291 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x19;
          if (pattern338 (x20, 
E_QImode) != 0
              || !
#line 10339 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_316 (insn, operands);

        case E_QQmode:
          if (!register_operand (x19, E_QQmode))
            return NULL;
          operands[0] = x19;
          x20 = XEXP (x18, 1);
          switch (pattern336 (x20, 
E_QQmode))
            {
            case 0:
              if (
#line 7725 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_292 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7725 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_293 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x19;
          if (pattern338 (x20, 
E_QQmode) != 0
              || !
#line 10339 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_317 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
