/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return 0;

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      return 1;

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[1] = x6;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x7 = XEXP (x3, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
                  || !register_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || GET_MODE (x3) != E_HImode
                  || GET_MODE (x5) != E_HImode)
                return -1;
              x8 = XEXP (x2, 1);
              operands[2] = x8;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              return 2;

            case AND:
              res = pattern2 (x2);
              if (res >= 0)
                return res + 3; /* [3, 8] */
              return -1;

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != AND)
            return -1;
          res = pattern2 (x2);
          if (res >= 0)
            return res + 9; /* [9, 14] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      res = pattern3 (x2);
      if (res >= 0)
        return res + 15; /* [15, 20] */
      return -1;

    case LSHIFTRT:
      res = pattern5 (x1);
      if (res >= 0)
        return res + 21; /* [21, 30] */
      return -1;

    case ASHIFTRT:
      res = pattern5 (x1);
      if (res >= 0)
        return res + 31; /* [31, 40] */
      return -1;

    case GE:
      res = pattern8 (x1);
      if (res >= 0)
        return res + 41; /* [41, 56] */
      return -1;

    case LT:
      res = pattern8 (x1);
      if (res >= 0)
        return res + 57; /* [57, 72] */
      return -1;

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          return 73;

        case SIGN_EXTEND:
          return 74;

        case ZERO_EXTEND:
          return 75;

        case AND:
          return 76;

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTRACT:
          res = pattern11 (x2);
          if (res >= 0)
            return res + 77; /* [77, 92] */
          return -1;

        case ASHIFT:
          res = pattern12 (x2);
          if (res >= 0)
            return res + 93; /* [93, 95] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_PSImode
          || !register_operand (operands[2], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[2], E_SImode))
        return -1;
      res = pattern4 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern57 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i1
      || GET_MODE (x4) != i2)
    return -1;
  return 0;
}

int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 24:
      if (REGNO (x2) != 24)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_HQmode:
          if (GET_MODE (x3) != E_HQmode
              || GET_MODE (x4) != E_HQmode)
            return -1;
          return 0;

        case E_HAmode:
          if (GET_MODE (x3) != E_HAmode
              || GET_MODE (x4) != E_HAmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (REGNO (x2) != 22)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SAmode:
          if (GET_MODE (x3) != E_SAmode
              || GET_MODE (x4) != E_SAmode)
            return -1;
          return 2;

        case E_SQmode:
          if (GET_MODE (x3) != E_SQmode
              || GET_MODE (x4) != E_SQmode)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != AND
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  if (!const_8_16_24_operand (operands[3], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          return pattern41 (x1, 
E_HImode); /* [-1, 0] */

        case E_PSImode:
          if (pattern41 (x1, 
E_PSImode) != 0)
            return -1;
          return 1;

        case E_SImode:
          if (pattern41 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      res = pattern43 (x1);
      if (res >= 0)
        return res + 3; /* [3, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return 0;

    case SIGN_EXTEND:
      return 1;

    case ZERO_EXTEND:
      return 2;

    default:
      return -1;
    }
}

int
pattern85 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x4, 2);
  operands[1] = x7;
  if (!const_0_to_7_operand (operands[1], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x9 = XEXP (x3, 1);
  operands[4] = x9;
  if (!const_int_operand (operands[4], E_QImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[3] = x10;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  return 0;
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  return pattern100 (x1); /* [-1, 2] */
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (SUBREG_BYTE (x1))
    {
    case 0:
      x2 = XEXP (x1, 0);
      switch (GET_CODE (x2))
        {
        case ASHIFT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 0;

            case ZERO_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1;

            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_HImode)
                  || !nonimmediate_operand (operands[0], E_QImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case ASHIFTRT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != CONST_INT
              || XWINT (x4, 0) != 128L)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != AND
              || GET_MODE (x3) != E_QImode)
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case ZERO_EXTRACT:
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_0_to_15_operand (operands[2], E_QImode))
                return -1;
              return 4;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !const_0_to_23_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_0_to_31_operand (operands[2], E_QImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != LO_SUM
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nonmemory_operand (operands[1], E_QImode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QQmode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QQmode))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, unsigned int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != i2)
    return -1;
  return 0;
}

int
pattern147 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!memory_operand (operands[0], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!memory_operand (operands[0], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!memory_operand (operands[0], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!memory_operand (operands[0], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!memory_operand (operands[0], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!memory_operand (operands[0], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!memory_operand (operands[0], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!memory_operand (operands[0], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!memory_operand (operands[0], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!memory_operand (operands[0], E_USAmode))
        return -1;
      return 12;

    case E_SFmode:
      if (!memory_operand (operands[0], E_SFmode))
        return -1;
      return 13;

    case E_PSImode:
      if (!memory_operand (operands[0], E_PSImode))
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern163 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 36
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern167 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern166 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern166 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern166 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern166 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern173 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern176 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || !register_operand (operands[3], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_PSImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_MODE (x4))
    {
    case E_QImode:
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_HImode:
      operands[2] = x4;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern189 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x1, 1);
  operands[1] = x4;
  switch (GET_MODE (x2))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_QImode)
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (!register_operand (operands[0], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[0], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x5) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x7) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x5) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x7) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x7) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || GET_MODE (x5) != E_UDQmode)
            return -1;
          return 0;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || GET_MODE (x5) != E_UDAmode)
            return -1;
          return 1;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || GET_MODE (x5) != E_UTAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || !const_operand (operands[0], E_UDQmode))
            return -1;
          return 3;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || !const_operand (operands[0], E_UDAmode))
            return -1;
          return 4;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || !const_operand (operands[0], E_UTAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern240 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern244 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  operands[2] = x1;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      if (pnum_clobbers == NULL)
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern249 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i1
      || GET_MODE (x5) != i4)
    return -1;
  return 0;
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern251 (x8, 
E_SImode); /* [-1, 0] */

    case E_PSImode:
      if (pattern251 (x8, 
E_PSImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern259 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x11;
      return pattern256 (); /* [-1, 1] */

    case SIGN_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern258 (x12);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern258 (x12);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern277 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XEXP (x3, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_SQmode:
      if (!register_operand (operands[1], E_SQmode)
          || !nonmemory_operand (operands[2], E_SQmode))
        return -1;
      return 1;

    case E_USQmode:
      if (!register_operand (operands[1], E_USQmode)
          || !nonmemory_operand (operands[2], E_USQmode))
        return -1;
      return 2;

    case E_SAmode:
      if (!register_operand (operands[1], E_SAmode)
          || !nonmemory_operand (operands[2], E_SAmode))
        return -1;
      return 3;

    case E_USAmode:
      if (!register_operand (operands[1], E_USAmode)
          || !nonmemory_operand (operands[2], E_USAmode))
        return -1;
      return 4;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !nonmemory_operand (operands[2], E_PSImode))
        return -1;
      return 5;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !nonmemory_operand (operands[2], E_HImode))
        return -1;
      return 6;

    case E_HQmode:
      if (!register_operand (operands[1], E_HQmode)
          || !nonmemory_operand (operands[2], E_HQmode))
        return -1;
      return 7;

    case E_UHQmode:
      if (!register_operand (operands[1], E_UHQmode)
          || !nonmemory_operand (operands[2], E_UHQmode))
        return -1;
      return 8;

    case E_HAmode:
      if (!register_operand (operands[1], E_HAmode)
          || !nonmemory_operand (operands[2], E_HAmode))
        return -1;
      return 9;

    case E_UHAmode:
      if (!register_operand (operands[1], E_UHAmode)
          || !nonmemory_operand (operands[2], E_UHAmode))
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern298 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!l_register_operand (operands[2], i1))
    return -1;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x3, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 3);
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_QImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[0] = x11;
  return 0;
}

int
pattern321 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_QQmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 23
      || GET_MODE (x5) != E_QQmode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 24
      || GET_MODE (x7) != E_HImode
      || GET_MODE (x3) != E_QQmode)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_MODE (x8) != E_QQmode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != E_QImode)
    return -1;
  return 0;
}

int
pattern330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  return pattern329 (x1); /* [-1, 2] */
}

int
pattern337 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!ordered_comparison_operator (x2, E_VOIDmode))
    return -1;
  operands[0] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  return 0;
}

int
pattern343 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern350 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern356 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 18)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22)
    return -1;
  x8 = XEXP (x6, 1);
  if (REGNO (x8) != 18)
    return -1;
  x9 = XEXP (x2, 0);
  switch (REGNO (x9))
    {
    case 22:
      if (GET_MODE (x9) != E_PSImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (REGNO (x10) != 18
          || GET_MODE (x10) != E_PSImode)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      if (REGNO (x12) != 21
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 0);
      if (REGNO (x14) != 25
          || GET_MODE (x14) != E_QImode
          || pattern355 (x1, 
E_PSImode, 
E_QImode, 
26) != 0)
        return -1;
      return 0;

    case 18:
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (REGNO (x10) != 22
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      if (REGNO (x12) != 26
          || GET_MODE (x12) != E_HImode)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 0);
      if (REGNO (x14) != 30
          || GET_MODE (x14) != E_HImode
          || pattern355 (x1, 
E_SImode, 
E_CCmode, 
36) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern374 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern379 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonmemory_operand (operands[1], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case EQ:
      return pattern375 (x4); /* [-1, 0] */

    case NE:
      if (pattern375 (x4) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern375 (x4) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern375 (x4) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern375 (x4) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern375 (x4) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern64 (x3))
    {
    case 0:
      if (
#line 843 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode)))
        return 113; /* movqi_insn_split */
      if (pnum_clobbers == NULL
          || !
#line 857 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 116; /* movqi_insn */

    case 1:
      if (
#line 843 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode)))
        return 114; /* movqq_insn_split */
      if (pnum_clobbers == NULL
          || !
#line 857 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 117; /* movqq_insn */

    case 2:
      if (
#line 843 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode)))
        return 115; /* movuqq_insn_split */
      if (pnum_clobbers == NULL
          || !
#line 857 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 118; /* movuqq_insn */

    case 3:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !nox_general_operand (operands[1], E_HImode))
        return -1;
      if (
#line 954 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], HImode)
   || reg_or_0_operand (operands[1], HImode)))
        return 128; /* *movhi_split */
      if (pnum_clobbers == NULL
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 133; /* *movhi */

    case 4:
      if (
#line 954 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], HQmode)
   || reg_or_0_operand (operands[1], HQmode)))
        return 129; /* *movhq_split */
      if (pnum_clobbers == NULL
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], HQmode)
    || reg_or_0_operand (operands[1], HQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 134; /* *movhq */

    case 5:
      if (
#line 954 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], UHQmode)
   || reg_or_0_operand (operands[1], UHQmode)))
        return 130; /* *movuhq_split */
      if (pnum_clobbers == NULL
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], UHQmode)
    || reg_or_0_operand (operands[1], UHQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 135; /* *movuhq */

    case 6:
      if (
#line 954 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], HAmode)
   || reg_or_0_operand (operands[1], HAmode)))
        return 131; /* *movha_split */
      if (pnum_clobbers == NULL
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], HAmode)
    || reg_or_0_operand (operands[1], HAmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 136; /* *movha */

    case 7:
      if (
#line 954 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], UHAmode)
   || reg_or_0_operand (operands[1], UHAmode)))
        return 132; /* *movuha_split */
      if (pnum_clobbers == NULL
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], UHAmode)
    || reg_or_0_operand (operands[1], UHAmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 137; /* *movuha */

    case 8:
      if (!nonimmediate_operand (operands[0], E_PSImode)
          || !nox_general_operand (operands[1], E_PSImode))
        return -1;
      if (
#line 1126 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], PSImode)
   || register_operand (operands[1], PSImode)
   || const0_rtx == operands[1]))
        return 139; /* *movpsi_split */
      if (pnum_clobbers == NULL
          || !
#line 1139 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], PSImode)
    || register_operand (operands[1], PSImode)
    || const0_rtx == operands[1])
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 140; /* *movpsi */

    case 9:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nox_general_operand (operands[1], E_SImode))
        return -1;
      if (
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], SImode)
   || reg_or_0_operand (operands[1], SImode)))
        return 146; /* *movsi_split */
      if (pnum_clobbers == NULL
          || !
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 151; /* *movsi */

    case 10:
      if (!nonimmediate_operand (operands[0], E_SQmode)
          || !nox_general_operand (operands[1], E_SQmode))
        return -1;
      if (
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], SQmode)
   || reg_or_0_operand (operands[1], SQmode)))
        return 147; /* *movsq_split */
      if (pnum_clobbers == NULL
          || !
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], SQmode)
    || reg_or_0_operand (operands[1], SQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 152; /* *movsq */

    case 11:
      if (!nonimmediate_operand (operands[0], E_USQmode)
          || !nox_general_operand (operands[1], E_USQmode))
        return -1;
      if (
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], USQmode)
   || reg_or_0_operand (operands[1], USQmode)))
        return 148; /* *movusq_split */
      if (pnum_clobbers == NULL
          || !
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], USQmode)
    || reg_or_0_operand (operands[1], USQmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 153; /* *movusq */

    case 12:
      if (!nonimmediate_operand (operands[0], E_SAmode)
          || !nox_general_operand (operands[1], E_SAmode))
        return -1;
      if (
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], SAmode)
   || reg_or_0_operand (operands[1], SAmode)))
        return 149; /* *movsa_split */
      if (pnum_clobbers == NULL
          || !
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], SAmode)
    || reg_or_0_operand (operands[1], SAmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 154; /* *movsa */

    case 13:
      if (!nonimmediate_operand (operands[0], E_USAmode)
          || !nox_general_operand (operands[1], E_USAmode))
        return -1;
      if (
#line 1187 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], USAmode)
   || reg_or_0_operand (operands[1], USAmode)))
        return 150; /* *movusa_split */
      if (pnum_clobbers == NULL
          || !
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], USAmode)
    || reg_or_0_operand (operands[1], USAmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 155; /* *movusa */

    case 14:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !nox_general_operand (operands[1], E_SFmode))
        return -1;
      if (
#line 1235 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(register_operand (operands[0], SFmode)
   || reg_or_0_operand (operands[1], SFmode)))
        return 157; /* *movsf_split */
      if (pnum_clobbers == NULL
          || !
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 158; /* *movsf */

    default:
      return -1;
    }
}

 int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ASHIFT:
          if (GET_MODE (x4) != E_QImode
              || pattern272 (x2) != 0
              || GET_MODE (x3) != E_QImode)
            return -1;
          x5 = XEXP (x4, 0);
          operands[3] = x5;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[4] = x6;
          if (!const_0_to_7_operand (operands[4], E_QImode))
            return -1;
          x7 = XEXP (x3, 1);
          operands[5] = x7;
          if (!single_one_operand (operands[5], E_QImode)
              || !
#line 9900 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[4]) == exact_log2 (~INTVAL (operands[2]) & 0xff)
   && INTVAL (operands[4]) == exact_log2 (INTVAL (operands[5]) & 0xff)))
            return -1;
          return 1069; /* *movbitqi.1-6.a */

        case REG:
        case SUBREG:
          operands[3] = x4;
          x7 = XEXP (x3, 1);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern308 (x2, 
E_QImode) != 0
                  || !
#line 9927 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(GET_MODE_MASK(QImode)
   == (GET_MODE_MASK(QImode) & (INTVAL(operands[2]) ^ INTVAL(operands[4])))))
                return -1;
              return 1071; /* *movbitqi.0-6 */

            case E_HImode:
              if (pattern308 (x2, 
E_HImode) != 0
                  || !
#line 9927 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(GET_MODE_MASK(HImode)
   == (GET_MODE_MASK(HImode) & (INTVAL(operands[2]) ^ INTVAL(operands[4])))))
                return -1;
              return 1072; /* *movbithi.0-6 */

            case E_PSImode:
              if (pattern308 (x2, 
E_PSImode) != 0
                  || !
#line 9927 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(GET_MODE_MASK(PSImode)
   == (GET_MODE_MASK(PSImode) & (INTVAL(operands[2]) ^ INTVAL(operands[4])))))
                return -1;
              return 1073; /* *movbitpsi.0-6 */

            case E_SImode:
              if (pattern308 (x2, 
E_SImode) != 0
                  || !
#line 9927 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(GET_MODE_MASK(SImode)
   == (GET_MODE_MASK(SImode) & (INTVAL(operands[2]) ^ INTVAL(operands[4])))))
                return -1;
              return 1074; /* *movbitsi.0-6 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != AND
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern272 (x2) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[4] = x7;
      if (!const_0_to_7_operand (operands[4], E_QImode)
          || !
#line 9916 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[4]) == exact_log2 (~INTVAL (operands[2]) & 0xff)))
        return -1;
      return 1070; /* *movbitqi.1-6.b */

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      return recog_7 (x1, insn, pnum_clobbers);

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern3 (x2))
            {
            case 0:
              return 180; /* *addhi3_zero_extend_split */

            case 1:
              return 226; /* *addpsi3.zero_extend.qi_split */

            case 2:
              return 230; /* *addpsi3.zero_extend.hi_split */

            case 3:
              return 228; /* *addsi3.zero_extend.qi_split */

            case 4:
              return 232; /* *addsi3.zero_extend.hi_split */

            case 5:
              return 234; /* *addsi3.zero_extend.psi_split */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST:
        case SYMBOL_REF:
          operands[2] = x3;
          if (pattern175 (x2) != 0)
            return -1;
          if (const_m255_to_m1_operand (operands[2], E_HImode))
            return 184; /* *addhi3_zero_extend.const_split */
          if (!const_0mod256_operand (operands[2], E_HImode))
            return -1;
          return 186; /* *aligned_add_symbol */

        case ZERO_EXTEND:
          if (pattern149 (x2) != 0)
            return -1;
          return 189; /* *usum_widenqihi3_split */

        default:
          return -1;
        }

    case 2:
      return 187; /* *addhi3_zero_extend.ashift1.split */

    case 3:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1369; /* *shl.ext.and1-to-skip.hi */

    case 4:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1375; /* *shl.ext.and1-to-skip.psi */

    case 5:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1387; /* *shl.ext.and1-to-skip.psi */

    case 6:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1381; /* *shl.ext.and1-to-skip.si */

    case 7:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1393; /* *shl.ext.and1-to-skip.si */

    case 8:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1399; /* *shl.ext.and1-to-skip.si */

    case 9:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1368; /* *shl.ext.and1-to-skip.hi */

    case 10:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1374; /* *shl.ext.and1-to-skip.psi */

    case 11:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1386; /* *shl.ext.and1-to-skip.psi */

    case 12:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1380; /* *shl.ext.and1-to-skip.si */

    case 13:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1392; /* *shl.ext.and1-to-skip.si */

    case 14:
      if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1398; /* *shl.ext.and1-to-skip.si */

    case 15:
      return 224; /* *addhi3.sign_extend.qi_split */

    case 16:
      return 225; /* *addpsi3.sign_extend.qi_split */

    case 17:
      return 229; /* *addpsi3.sign_extend.hi_split */

    case 18:
      return 227; /* *addsi3.sign_extend.qi_split */

    case 19:
      return 231; /* *addsi3.sign_extend.hi_split */

    case 20:
      return 233; /* *addsi3.sign_extend.psi_split */

    case 21:
      return 316; /* *addqi3.msbit_split */

    case 22:
      return 318; /* *addhi3.msbit_split */

    case 23:
      return 320; /* *addpsi3.msbit_split */

    case 24:
      return 322; /* *addsi3.msbit_split */

    case 25:
      return 324; /* *addhi3.sex.msbit_split */

    case 26:
      return 326; /* *addpsi3.sex.msbit_split */

    case 27:
      return 330; /* *addpsi3.sex.msbit_split */

    case 28:
      return 328; /* *addsi3.sex.msbit_split */

    case 29:
      return 332; /* *addsi3.sex.msbit_split */

    case 30:
      return 334; /* *addsi3.sex.msbit_split */

    case 31:
      return 317; /* *addqi3.msbit_split */

    case 32:
      return 319; /* *addhi3.msbit_split */

    case 33:
      return 321; /* *addpsi3.msbit_split */

    case 34:
      return 323; /* *addsi3.msbit_split */

    case 35:
      return 325; /* *addhi3.sex.msbit_split */

    case 36:
      return 327; /* *addpsi3.sex.msbit_split */

    case 37:
      return 331; /* *addpsi3.sex.msbit_split */

    case 38:
      return 329; /* *addsi3.sex.msbit_split */

    case 39:
      return 333; /* *addsi3.sex.msbit_split */

    case 40:
      return 335; /* *addsi3.sex.msbit_split */

    case 41:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 380; /* *addqi3.ge0 */
        }
      return 412; /* *addqi3.ge0_split */

    case 42:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 388; /* *addqi3.ge0 */
        }
      return 420; /* *addqi3.ge0_split */

    case 43:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 396; /* *addqi3.ge0 */
        }
      return 428; /* *addqi3.ge0_split */

    case 44:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 404; /* *addqi3.ge0 */
        }
      return 436; /* *addqi3.ge0_split */

    case 45:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 382; /* *addhi3.ge0 */
        }
      return 414; /* *addhi3.ge0_split */

    case 46:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 390; /* *addhi3.ge0 */
        }
      return 422; /* *addhi3.ge0_split */

    case 47:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 398; /* *addhi3.ge0 */
        }
      return 430; /* *addhi3.ge0_split */

    case 48:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 406; /* *addhi3.ge0 */
        }
      return 438; /* *addhi3.ge0_split */

    case 49:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 384; /* *addpsi3.ge0 */
        }
      return 416; /* *addpsi3.ge0_split */

    case 50:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 392; /* *addpsi3.ge0 */
        }
      return 424; /* *addpsi3.ge0_split */

    case 51:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 400; /* *addpsi3.ge0 */
        }
      return 432; /* *addpsi3.ge0_split */

    case 52:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 408; /* *addpsi3.ge0 */
        }
      return 440; /* *addpsi3.ge0_split */

    case 53:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 386; /* *addsi3.ge0 */
        }
      return 418; /* *addsi3.ge0_split */

    case 54:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 394; /* *addsi3.ge0 */
        }
      return 426; /* *addsi3.ge0_split */

    case 55:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 402; /* *addsi3.ge0 */
        }
      return 434; /* *addsi3.ge0_split */

    case 56:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 410; /* *addsi3.ge0 */
        }
      return 442; /* *addsi3.ge0_split */

    case 57:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 381; /* *addqi3.lt0 */
        }
      return 413; /* *addqi3.lt0_split */

    case 58:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 389; /* *addqi3.lt0 */
        }
      return 421; /* *addqi3.lt0_split */

    case 59:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 397; /* *addqi3.lt0 */
        }
      return 429; /* *addqi3.lt0_split */

    case 60:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 405; /* *addqi3.lt0 */
        }
      return 437; /* *addqi3.lt0_split */

    case 61:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 383; /* *addhi3.lt0 */
        }
      return 415; /* *addhi3.lt0_split */

    case 62:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 391; /* *addhi3.lt0 */
        }
      return 423; /* *addhi3.lt0_split */

    case 63:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 399; /* *addhi3.lt0 */
        }
      return 431; /* *addhi3.lt0_split */

    case 64:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 407; /* *addhi3.lt0 */
        }
      return 439; /* *addhi3.lt0_split */

    case 65:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 385; /* *addpsi3.lt0 */
        }
      return 417; /* *addpsi3.lt0_split */

    case 66:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 393; /* *addpsi3.lt0 */
        }
      return 425; /* *addpsi3.lt0_split */

    case 67:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 401; /* *addpsi3.lt0 */
        }
      return 433; /* *addpsi3.lt0_split */

    case 68:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 409; /* *addpsi3.lt0 */
        }
      return 441; /* *addpsi3.lt0_split */

    case 69:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 387; /* *addsi3.lt0 */
        }
      return 419; /* *addsi3.lt0_split */

    case 70:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 395; /* *addsi3.lt0 */
        }
      return 427; /* *addsi3.lt0_split */

    case 71:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 403; /* *addsi3.lt0 */
        }
      return 435; /* *addsi3.lt0_split */

    case 72:
      if (pnum_clobbers != NULL
          && 
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 411; /* *addsi3.lt0 */
        }
      return 443; /* *addsi3.lt0_split */

    case 73:
      x2 = XEXP (x1, 1);
      if (pattern114 (x2, 
E_QImode) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x3 = XEXP (x2, 1);
      operands[3] = x3;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          if (
#line 2587 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 490; /* *maddqi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2602 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 491; /* *maddqi4 */

        case CONST_INT:
          if (pnum_clobbers == NULL
              || !const_int_operand (operands[2], E_QImode)
              || !
#line 2640 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 494; /* *maddqi4.const */

        default:
          return -1;
        }

    case 74:
      x2 = XEXP (x1, 1);
      switch (pattern116 (x2))
        {
        case 0:
          if (!register_operand (operands[3], E_HImode))
            return -1;
          x4 = XEXP (x2, 0);
          x5 = XEXP (x4, 1);
          switch (GET_CODE (x5))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x5) != E_HImode)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2696 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 496; /* *maddqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2711 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 498; /* *maddqihi4 */

            case ZERO_EXTEND:
              if (GET_MODE (x5) != E_HImode)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2754 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return 505; /* *sumsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              *pnum_clobbers = 1;
              return 507; /* *sumsubqihi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x5;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2850 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 513; /* *maddqihi4.sconst */
                }
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2942 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 519; /* *sumaddqihi4.uconst */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1332; /* *mul.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1338; /* *mul.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1350; /* *mul.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1344; /* *mul.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1356; /* *mul.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1362; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case 75:
      x2 = XEXP (x1, 1);
      switch (pattern117 (x2))
        {
        case 0:
          if (
#line 2696 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 497; /* *umaddqihi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2711 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 499; /* *umaddqihi4 */

        case 1:
          if (
#line 2754 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
            return 504; /* *usmsubqihi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
            return -1;
          *pnum_clobbers = 1;
          return 506; /* *usmsubqihi4 */

        case 2:
          x4 = XEXP (x2, 0);
          x5 = XEXP (x4, 1);
          if (XWINT (x5, 0) == 2L)
            {
              x3 = XEXP (x2, 1);
              operands[2] = x3;
              if (
#line 2827 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!reload_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
                return 512; /* *umaddqihi4.2 */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          if (!u8_operand (operands[2], E_HImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[3] = x3;
          if (!
#line 2850 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 514; /* *umaddqihi4.uconst */

        case 3:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1333; /* *mul.ext.and1-to-skip.hi */

        case 4:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1339; /* *mul.ext.and1-to-skip.psi */

        case 5:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1351; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1345; /* *mul.ext.and1-to-skip.si */

        case 7:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1357; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1363; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case 76:
      x2 = XEXP (x1, 1);
      switch (pattern118 (x2))
        {
        case 0:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1320; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1323; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1326; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1329; /* *mul.and1-to-skip.si */

        default:
          return -1;
        }

    case 77:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1272; /* *pixop-to-skip.qi */

    case 78:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1284; /* *pixop-to-skip.qi */

    case 79:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1296; /* *pixop-to-skip.qi */

    case 80:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1308; /* *pixop-to-skip.qi */

    case 81:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1275; /* *pixop-to-skip.hi */

    case 82:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1287; /* *pixop-to-skip.hi */

    case 83:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1299; /* *pixop-to-skip.hi */

    case 84:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1311; /* *pixop-to-skip.hi */

    case 85:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1278; /* *pixop-to-skip.psi */

    case 86:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1290; /* *pixop-to-skip.psi */

    case 87:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1302; /* *pixop-to-skip.psi */

    case 88:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1314; /* *pixop-to-skip.psi */

    case 89:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1281; /* *pixop-to-skip.si */

    case 90:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1293; /* *pixop-to-skip.si */

    case 91:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1305; /* *pixop-to-skip.si */

    case 92:
      if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1317; /* *pixop-to-skip.si */

    case 93:
      if (!
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1404; /* *shl.and-to-skip.hi */

    case 94:
      if (!
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1407; /* *shl.and-to-skip.psi */

    case 95:
      if (!
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1410; /* *shl.and-to-skip.si */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_CCNmode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != E_CCNmode)
    return -1;
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  switch (GET_MODE (x8))
    {
    case E_HImode:
      if (pattern354 (x3, 
E_HImode) != 0
          || !
#line 7532 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 937; /* *ashift.for.ccn.hi */

    case E_PSImode:
      if (pattern354 (x3, 
E_PSImode) != 0
          || !
#line 7532 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 938; /* *ashift.for.ccn.psi */

    case E_SImode:
      if (pattern354 (x3, 
E_SImode) != 0
          || !
#line 7532 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 939; /* *ashift.for.ccn.si */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || pattern190 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
          switch (pattern318 (x3))
            {
            case 0:
              if (!
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3150; /* *adddi3_insn */

            case 1:
              if (!
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3151; /* *adddq3_insn */

            case 2:
              if (!
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3152; /* *addudq3_insn */

            case 3:
              if (!
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3153; /* *addda3_insn */

            case 4:
              if (!
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3154; /* *adduda3_insn */

            case 5:
              if (!
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3155; /* *addta3_insn */

            case 6:
              if (!
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3156; /* *adduta3_insn */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern285 (x6, 
E_QImode, 
26, 
E_DImode) != 0)
            return -1;
          x7 = XEXP (x3, 0);
          if (GET_MODE (x7) != E_DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_DImode
              || !
#line 135 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3158; /* *adddi3_const8_insn */

        case CONST_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
          switch (pattern319 (x3))
            {
            case 0:
              if (!
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3166; /* *adddi3_const_insn */

            case 1:
              if (!
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3167; /* *adddq3_const_insn */

            case 2:
              if (!
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3168; /* *addudq3_const_insn */

            case 3:
              if (!
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3169; /* *addda3_const_insn */

            case 4:
              if (!
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3170; /* *adduda3_const_insn */

            case 5:
              if (!
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3171; /* *addta3_const_insn */

            case 6:
              if (!
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
                return -1;
              return 3172; /* *adduta3_const_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 36
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern273 (x4))
            {
            case 0:
              if (!
#line 1644 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 181; /* *addhi3_zero_extend */

            case 1:
              if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 237; /* *addpsi3.zero_extend.qi */

            case 2:
              if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2
   && (3 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 241; /* *addpsi3.zero_extend.hi */

            case 3:
              if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 239; /* *addsi3.zero_extend.qi */

            case 4:
              if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 243; /* *addsi3.zero_extend.hi */

            case 5:
              if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3
   && (4 > 2 || ZERO_EXTEND == SIGN_EXTEND)))
                return -1;
              return 245; /* *addsi3.zero_extend.psi */

            default:
              return -1;
            }

        case CONST_INT:
          operands[2] = x6;
          if (!const_m255_to_m1_operand (operands[2], E_HImode)
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_QImode)
              || !
#line 1688 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 185; /* *addhi3_zero_extend.const */

        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || !register_operand (operands[1], E_QImode))
            return -1;
          x10 = XEXP (x6, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 1757 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 190; /* *usum_widenqihi3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND
          || GET_MODE (x9) != E_HImode)
        return -1;
      x11 = XEXP (x5, 1);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || pattern156 (x1, 
E_HImode) != 0)
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 1729 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 188; /* *addhi3_zero_extend.ashift1 */

    case SIGN_EXTEND:
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 36
          || GET_MODE (x8) != E_CCmode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern273 (x4))
        {
        case 0:
          if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1
   && (2 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 235; /* *addhi3.sign_extend.qi */

        case 1:
          if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 236; /* *addpsi3.sign_extend.qi */

        case 2:
          if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2
   && (3 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 240; /* *addpsi3.sign_extend.hi */

        case 3:
          if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 238; /* *addsi3.sign_extend.qi */

        case 4:
          if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 242; /* *addsi3.sign_extend.hi */

        case 5:
          if (!
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3
   && (4 > 2 || SIGN_EXTEND == SIGN_EXTEND)))
            return -1;
          return 244; /* *addsi3.sign_extend.psi */

        default:
          return -1;
        }

    case GE:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 380; /* *addqi3.ge0 */

        case 1:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 388; /* *addqi3.ge0 */

        case 2:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 396; /* *addqi3.ge0 */

        case 3:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 404; /* *addqi3.ge0 */

        case 4:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 382; /* *addhi3.ge0 */

        case 5:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 390; /* *addhi3.ge0 */

        case 6:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 398; /* *addhi3.ge0 */

        case 7:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 406; /* *addhi3.ge0 */

        case 8:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 384; /* *addpsi3.ge0 */

        case 9:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 392; /* *addpsi3.ge0 */

        case 10:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 400; /* *addpsi3.ge0 */

        case 11:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 408; /* *addpsi3.ge0 */

        case 12:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 386; /* *addsi3.ge0 */

        case 13:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 394; /* *addsi3.ge0 */

        case 14:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 402; /* *addsi3.ge0 */

        case 15:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 410; /* *addsi3.ge0 */

        default:
          return -1;
        }

    case LT:
      switch (pattern155 (x1))
        {
        case 0:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 381; /* *addqi3.lt0 */

        case 1:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 389; /* *addqi3.lt0 */

        case 2:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 397; /* *addqi3.lt0 */

        case 3:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 405; /* *addqi3.lt0 */

        case 4:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 383; /* *addhi3.lt0 */

        case 5:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 391; /* *addhi3.lt0 */

        case 6:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 399; /* *addhi3.lt0 */

        case 7:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 407; /* *addhi3.lt0 */

        case 8:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 385; /* *addpsi3.lt0 */

        case 9:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 393; /* *addpsi3.lt0 */

        case 10:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 401; /* *addpsi3.lt0 */

        case 11:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 409; /* *addpsi3.lt0 */

        case 12:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 387; /* *addsi3.lt0 */

        case 13:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 395; /* *addsi3.lt0 */

        case 14:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 403; /* *addsi3.lt0 */

        case 15:
          if (!
#line 2381 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 411; /* *addsi3.lt0 */

        default:
          return -1;
        }

    case MULT:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x9 = XEXP (x5, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          if (pattern220 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          operands[2] = x11;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x8 = XEXP (x2, 0);
              if (GET_CODE (x8) != REG
                  || REGNO (x8) != 36
                  || GET_MODE (x8) != E_CCmode
                  || !
#line 2602 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 491; /* *maddqi4 */

            case CONST_INT:
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2640 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 494; /* *maddqi4.const */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern221 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          switch (GET_CODE (x11))
            {
            case SIGN_EXTEND:
              if (pattern342 (x1) != 0
                  || !
#line 2711 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 498; /* *maddqihi4 */

            case ZERO_EXTEND:
              if (pattern342 (x1) != 0
                  || !
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              return 507; /* *sumsubqihi4 */

            case CONST_INT:
              operands[2] = x11;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode))
                return -1;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2850 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 513; /* *maddqihi4.sconst */
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2942 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              return 519; /* *sumaddqihi4.uconst */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (pattern221 (x4) != 0)
            return -1;
          x11 = XEXP (x5, 1);
          switch (GET_CODE (x11))
            {
            case ZERO_EXTEND:
              if (pattern342 (x1) != 0
                  || !
#line 2711 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 499; /* *umaddqihi4 */

            case SIGN_EXTEND:
              if (pattern342 (x1) != 0
                  || !
#line 2771 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              return 506; /* *usmsubqihi4 */

            case CONST_INT:
              operands[2] = x11;
              if (!u8_operand (operands[2], E_HImode))
                return -1;
              x8 = XEXP (x2, 0);
              operands[4] = x8;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2850 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 514; /* *umaddqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != LO_SUM
      || GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 23
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 30
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x9) != UNSPEC
      || XVECLEN (x9, 0) != 1
      || XINT (x9, 1) != 1)
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x10) != USE)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 24
      || pattern27 (x1) != 0)
    return -1;
  x12 = XVECEXP (x1, 0, 6);
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 24
      || GET_MODE (x13) != E_HImode)
    return -1;
  x14 = XVECEXP (x1, 0, 7);
  if (pattern374 (x14, 
E_QImode, 
23) != 0)
    return -1;
  x15 = XVECEXP (x1, 0, 8);
  if (GET_CODE (x15) != CLOBBER)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != MEM
      || GET_MODE (x16) != E_QImode)
    return -1;
  x17 = XVECEXP (x1, 0, 9);
  if (GET_CODE (x17) != CLOBBER)
    return -1;
  x18 = XEXP (x17, 0);
  if (GET_CODE (x18) != REG
      || REGNO (x18) != 36
      || GET_MODE (x18) != E_CCmode)
    return -1;
  x19 = XVECEXP (x9, 0, 0);
  operands[0] = x19;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x20 = XEXP (x16, 0);
  operands[1] = x20;
  if (!io_address_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x11))
    {
    case E_QImode:
      if (!
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 166; /* *cpymemx_qi */

    case E_HImode:
      if (!
#line 1407 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 167; /* *cpymemx_hi */

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_90 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_73 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_78 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_85 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 7:
          res = recog_86 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 8:
          if (pattern28 (x1) == 0)
            {
              x2 = XVECEXP (x1, 0, 7);
              if (pattern374 (x2, 
E_CCmode, 
36) == 0)
                {
                  switch (pattern373 (x1))
                    {
                    case 0:
                      if (
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                        return 162; /* *cpymem_qi */
                      break;

                    case 1:
                      if (
#line 1342 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                        return 163; /* *cpymem_hi */
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case 9:
          switch (pattern29 (x1))
            {
            case 0:
              return 164; /* cpymemx_qi */

            case 1:
              return 165; /* cpymemx_hi */

            default:
              break;
            }
          break;

        case 10:
          res = recog_87 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_88 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_89 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) < 6)
        return -1;
      operands[0] = x1;
      if (!set_some_operation (operands[0], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE
          || pattern164 (x1, 
USE) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x5) != SET)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!dreg_or_0_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XVECEXP (x1, 0, 2);
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      operands[4] = x11;
      if (!const_int_operand (operands[4], E_QImode))
        return -1;
      x12 = XEXP (x5, 0);
      operands[5] = x12;
      if (!register_operand (operands[5], E_QImode))
        return -1;
      x13 = XEXP (x5, 1);
      operands[6] = x13;
      if (!const_int_operand (operands[6], E_QImode)
          || !
#line 1220 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 156; /* set_some */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 972; /* nop */

    case RETURN:
      if (
#line 8676 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed && avr_simple_epilogue ()))
        return 999; /* return */
      if (
#line 8682 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && !(cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1000; /* return_from_epilogue */
      if (
#line 8691 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && (cfun->machine->is_interrupt || cfun->machine->is_signal)
   && !cfun->machine->is_naked))
        return 1001; /* return_from_interrupt_epilogue */
      if (!
#line 8700 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && cfun->machine
   && cfun->machine->is_naked))
        return -1;
      return 1002; /* return_from_naked_epilogue */

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  if (!register_operand (operands[0], E_HImode))
    return NULL;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return NULL;
  x5 = XEXP (x3, 1);
  switch (pattern268 (x5))
    {
    case 0:
      if (!(
#line 2460 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2462 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_271 (insn, operands);

    case 1:
      if (!(
#line 2508 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2510 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_274 (insn, operands);

    case 2:
      if (!(
#line 3144 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3146 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_307 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern180 (x2) != 0
              || !(
#line 2460 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2462 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_PSImode:
          switch (pattern181 (x2))
            {
            case 0:
              if (!(
#line 4103 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4105 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_353 (insn, operands);

            case 1:
              if (!(
#line 4130 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4132 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_354 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x3) != E_HImode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_QImode)
          || !(
#line 2483 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2485 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_273 (insn, operands);

    case REG:
    case SUBREG:
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode)
        return NULL;
      x4 = XEXP (x2, 0);
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 3169 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3171 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_308 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_7 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern83 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern247 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && nonmemory_operand (operands[2], E_QImode)
                  && 
#line 6989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_569 (insn, operands);
              break;

            case E_QQmode:
              if (register_operand (operands[1], E_QQmode)
                  && nonmemory_operand (operands[2], E_QQmode)
                  && 
#line 6989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_570 (insn, operands);
              break;

            case E_UQQmode:
              if (register_operand (operands[1], E_UQQmode)
                  && nonmemory_operand (operands[2], E_UQQmode)
                  && 
#line 6989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return gen_split_571 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case 1:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_595 (insn, operands);
          break;

        case 2:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_597 (insn, operands);
          break;

        case 3:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_601 (insn, operands);
          break;

        case 4:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_599 (insn, operands);
          break;

        case 5:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_603 (insn, operands);
          break;

        case 6:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_605 (insn, operands);
          break;

        case 7:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_596 (insn, operands);
          break;

        case 8:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_598 (insn, operands);
          break;

        case 9:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_602 (insn, operands);
          break;

        case 10:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_600 (insn, operands);
          break;

        case 11:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_604 (insn, operands);
          break;

        case 12:
          if ((
#line 7122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7125 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_606 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 18)
        return NULL;
      x5 = XEXP (x2, 1);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 10)
            return NULL;
          switch (pattern317 (x3))
            {
            case 0:
              if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1904 (insn, operands);

            case 1:
              if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1905 (insn, operands);

            case 2:
              if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1906 (insn, operands);

            case 3:
              if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1907 (insn, operands);

            case 4:
              if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1908 (insn, operands);

            case 5:
              if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1909 (insn, operands);

            case 6:
              if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 502 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1910 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern284 (x3) != 0
              || !(
#line 529 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 531 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1911 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      x2 = XEXP (x1, 1);
      switch (pattern219 (x2))
        {
        case 0:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_583 (insn, operands);

        case 1:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_585 (insn, operands);

        case 2:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_589 (insn, operands);

        case 3:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_587 (insn, operands);

        case 4:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_591 (insn, operands);

        case 5:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_593 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x2 = XEXP (x1, 1);
      switch (pattern219 (x2))
        {
        case 0:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 2 > 1) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_584 (insn, operands);

        case 1:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 1) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_586 (insn, operands);

        case 2:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 3 > 2) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_590 (insn, operands);

        case 3:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 1) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_588 (insn, operands);

        case 4:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 2) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_592 (insn, operands);

        case 5:
          if (!(
#line 7091 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && 4 > 3) && 
#line 7094 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_594 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (pattern141 (x3) != 0
          || !
#line 4627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_371 (insn, operands);

    case LSHIFTRT:
      switch (pattern74 (x3))
        {
        case 0:
          if (!(
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10149 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_668 (insn, operands);

        case 1:
          if (!(
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10149 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_672 (insn, operands);

        case 2:
          if (!(
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10149 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_676 (insn, operands);

        case 3:
          if (!(
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_692 (insn, operands);

        case 4:
          if (!(
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_696 (insn, operands);

        case 5:
          if (!(
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_704 (insn, operands);

        case 6:
          if (!(
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_700 (insn, operands);

        case 7:
          if (!(
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_708 (insn, operands);

        case 8:
          if (!(
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_712 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern76 (x3))
        {
        case 0:
          x5 = XEXP (x4, 1);
          operands[3] = x5;
          switch (pattern42 (x3))
            {
            case 0:
              if ((
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15) && 
#line 10149 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_670 (insn, operands);
              break;

            case 1:
              if ((
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23) && 
#line 10149 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_674 (insn, operands);
              break;

            case 2:
              if ((
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31) && 
#line 10149 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_678 (insn, operands);
              break;

            default:
              break;
            }
          if (XWINT (x5, 0) != 8L
              || pattern206 (x3) != 0
              || !(
#line 10259 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize) && 
#line 10261 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_719 (insn, operands);

        case 1:
          x5 = XEXP (x4, 1);
          operands[3] = x5;
          switch (pattern44 (x3))
            {
            case 0:
              if ((
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_694 (insn, operands);
              break;

            case 1:
              if ((
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_698 (insn, operands);
              break;

            case 2:
              if ((
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_706 (insn, operands);
              break;

            case 3:
              if ((
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_702 (insn, operands);
              break;

            case 4:
              if ((
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_710 (insn, operands);
              break;

            case 5:
              if ((
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31) && 
#line 10196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return gen_split_714 (insn, operands);
              break;

            default:
              break;
            }
          if (XWINT (x5, 0) != 8L)
            return NULL;
          switch (pattern217 (x3))
            {
            case 0:
              if (!(
#line 10210 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize) && 
#line 10212 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_716 (insn, operands);

            case 1:
              if (!(
#line 10243 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize) && 
#line 10245 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_718 (insn, operands);

            default:
              return NULL;
            }

        case 2:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_913 (insn, operands);

        case 3:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_919 (insn, operands);

        case 4:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_931 (insn, operands);

        case 5:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_925 (insn, operands);

        case 6:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_937 (insn, operands);

        case 7:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_943 (insn, operands);

        case 8:
          if (!(
#line 10210 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize) && 
#line 10212 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_715 (insn, operands);

        case 9:
          if (!(
#line 10243 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize) && 
#line 10245 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_717 (insn, operands);

        case 10:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_912 (insn, operands);

        case 11:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_918 (insn, operands);

        case 12:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_930 (insn, operands);

        case 13:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_924 (insn, operands);

        case 14:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_936 (insn, operands);

        case 15:
          if (!(
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_942 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern3 (x3))
        {
        case 0:
          if (!(
#line 10170 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1) && 
#line 10172 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_680 (insn, operands);

        case 1:
          if (!(
#line 10170 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1) && 
#line 10172 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_682 (insn, operands);

        case 2:
          if (!(
#line 10170 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2) && 
#line 10172 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_686 (insn, operands);

        case 3:
          if (!(
#line 10170 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1) && 
#line 10172 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_684 (insn, operands);

        case 4:
          if (!(
#line 10170 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2) && 
#line 10172 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_688 (insn, operands);

        case 5:
          if (!(
#line 10170 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3) && 
#line 10172 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_690 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x3))
            {
            case 0:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_815 (insn, operands);

            case 1:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_827 (insn, operands);

            case 2:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_839 (insn, operands);

            case 3:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_851 (insn, operands);

            case 4:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_818 (insn, operands);

            case 5:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_830 (insn, operands);

            case 6:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_842 (insn, operands);

            case 7:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_854 (insn, operands);

            case 8:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_821 (insn, operands);

            case 9:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_833 (insn, operands);

            case 10:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_845 (insn, operands);

            case 11:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_857 (insn, operands);

            case 12:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_824 (insn, operands);

            case 13:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_836 (insn, operands);

            case 14:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_848 (insn, operands);

            case 15:
              if (!(
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_860 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern12 (x3))
            {
            case 0:
              if (!(
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_947 (insn, operands);

            case 1:
              if (!(
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_950 (insn, operands);

            case 2:
              if (!(
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed) && 
#line 10813 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_953 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      switch (pattern80 (x3))
        {
        case 0:
          if (!(
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_863 (insn, operands);

        case 1:
          if (!(
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_866 (insn, operands);

        case 2:
          if (!(
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_869 (insn, operands);

        case 3:
          if (!(
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10755 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_872 (insn, operands);

        case 4:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_876 (insn, operands);

        case 5:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_882 (insn, operands);

        case 6:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_894 (insn, operands);

        case 7:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_888 (insn, operands);

        case 8:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_900 (insn, operands);

        case 9:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_906 (insn, operands);

        case 10:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_877 (insn, operands);

        case 11:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_883 (insn, operands);

        case 12:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_895 (insn, operands);

        case 13:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_889 (insn, operands);

        case 14:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_901 (insn, operands);

        case 15:
          if (!(
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_907 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ASHIFT:
      if (pattern46 (x1) != 0
          || !
#line 5738 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_502 (insn, operands);

    case REG:
    case SUBREG:
      switch (pattern47 (x1))
        {
        case 0:
          if (!
#line 6567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_556 (insn, operands);

        case 1:
          if (!
#line 6583 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_557 (insn, operands);

        case 2:
          if (!
#line 6614 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_559 (insn, operands);

        case 3:
          if (!
#line 6598 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_558 (insn, operands);

        case 4:
          if (!
#line 6648 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_561 (insn, operands);

        case 5:
          if (!
#line 6664 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_562 (insn, operands);

        case 6:
          if (!
#line 6677 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_563 (insn, operands);

        case 7:
          if (!
#line 6693 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_564 (insn, operands);

        case 8:
          if (!
#line 6709 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_565 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x3) != E_QImode
          || pattern35 (x1, 
E_QImode, 
24) != 0
          || !
#line 9211 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_639 (insn, operands);

    case POPCOUNT:
      if (GET_MODE (x3) != E_QImode
          || pattern34 (x1, 
E_HImode, 
24) != 0)
        return NULL;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (register_operand (operands[0], E_QImode)
          && (
#line 9272 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 9274 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return gen_split_641 (insn, operands);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24
          || GET_MODE (x4) != E_QImode)
        return NULL;
      return gen_split_645 (insn, operands);

    case ZERO_EXTRACT:
      switch (pattern48 (x1))
        {
        case 0:
          if (!(
#line 10603 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10605 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_764 (insn, operands);

        case 1:
          if (!(
#line 10603 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10605 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_765 (insn, operands);

        case 2:
          if (!(
#line 10603 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10605 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_766 (insn, operands);

        case 3:
          if (!(
#line 10603 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10605 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_767 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (pattern142 (x3))
    {
    case 0:
      if (
#line 5766 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_503 (insn, operands);
      break;

    case 1:
      if (
#line 5766 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_504 (insn, operands);
      break;

    case 2:
      if (
#line 5766 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_505 (insn, operands);
      break;

    case 3:
      if (
#line 5793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_506 (insn, operands);
      break;

    case 4:
      if (
#line 5793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_507 (insn, operands);
      break;

    case 5:
      if (
#line 5793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_508 (insn, operands);
      break;

    case 6:
      if (
#line 5793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_509 (insn, operands);
      break;

    case 7:
      if (
#line 5793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_510 (insn, operands);
      break;

    case 8:
      if (
#line 5856 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_512 (insn, operands);
      break;

    case 9:
      if (
#line 5856 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_513 (insn, operands);
      break;

    case 10:
      if (
#line 5856 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_514 (insn, operands);
      break;

    case 11:
      if (
#line 5856 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_515 (insn, operands);
      break;

    case 12:
      if (
#line 5856 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_516 (insn, operands);
      break;

    default:
      break;
    }
  if (GET_CODE (x4) != REG)
    return NULL;
  switch (pattern53 (x1))
    {
    case 0:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1920 (insn, operands);

    case 1:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1924 (insn, operands);

    case 2:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1928 (insn, operands);

    case 3:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1932 (insn, operands);

    case 4:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1936 (insn, operands);

    case 5:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1940 (insn, operands);

    case 6:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1944 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return NULL;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return NULL;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_DImode)
    return NULL;
  x8 = XVECEXP (x1, 0, 0);
  x9 = XEXP (x8, 0);
  operands[0] = x9;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return NULL;
  x10 = XEXP (x8, 1);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!pseudo_register_operand (operands[1], E_SImode))
    return NULL;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  if (!pseudo_register_operand (operands[2], E_SImode)
      || !(
#line 3434 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed) && 
#line 3439 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
    return NULL;
  return gen_split_313 (insn, operands);
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return NULL;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22)
    return NULL;
  switch (pattern326 (x1))
    {
    case 0:
      if (!(
#line 3310 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 3312 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_311 (insn, operands);

    case 1:
      if (!(
#line 377 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL) && 
#line 379 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1807 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_33 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_31 (x1, insn);

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 1);
          switch (GET_CODE (x5))
            {
            case SUBREG:
            case MEM:
              switch (pattern159 (x1))
                {
                case 0:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_32 (insn, operands);

                case 1:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_33 (insn, operands);

                case 2:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_34 (insn, operands);

                case 3:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_35 (insn, operands);

                case 4:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_36 (insn, operands);

                case 5:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_37 (insn, operands);

                case 6:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_38 (insn, operands);

                case 7:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_39 (insn, operands);

                case 8:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_40 (insn, operands);

                case 9:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_41 (insn, operands);

                case 10:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_42 (insn, operands);

                case 11:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_43 (insn, operands);

                case 12:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_44 (insn, operands);

                case 13:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_45 (insn, operands);

                case 14:
                  if (!(
#line 669 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true))) && 
#line 674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_46 (insn, operands);

                default:
                  return NULL;
                }

            case MULT:
              if (GET_MODE (x5) == E_SImode)
                {
                  res = split_28 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) != REG
                  || pattern139 (x2) != 0
                  || pattern160 (x1) != 0)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_MODE (x7) != E_HImode)
                return NULL;
              switch (pattern348 (x1))
                {
                case 0:
                  if (!(
#line 3726 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY) && 
#line 3730 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                    return NULL;
                  return gen_split_336 (insn, operands);

                case 1:
                  if (!(
#line 4244 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4246 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                    return NULL;
                  return gen_split_358 (insn, operands);

                default:
                  return NULL;
                }

            case DIV:
              x8 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x8) != SET)
                return NULL;
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != MOD)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return NULL;
              x6 = XEXP (x5, 0);
              if (GET_CODE (x6) == REG)
                {
                  res = split_29 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              if (REGNO (x7) != 26
                  || GET_MODE (x7) != E_QImode
                  || REGNO (x10) != 18
                  || GET_MODE (x10) != E_DImode
                  || pattern324 (x1) != 0)
                return NULL;
              return gen_split_359 (insn, operands);

            case UDIV:
              x8 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x8) != SET)
                return NULL;
              x9 = XEXP (x8, 1);
              if (GET_CODE (x9) != UMOD)
                return NULL;
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              if (REGNO (x10) == 26
                  && GET_MODE (x10) == E_HImode)
                {
                  x6 = XEXP (x5, 0);
                  if (GET_CODE (x6) == REG
                      && pattern282 (x1) == 0)
                    {
                      x7 = XEXP (x4, 0);
                      if (GET_CODE (x7) == REG)
                        {
                          switch (REGNO (x6))
                            {
                            case 24:
                              if (pattern359 (x1, 
E_HImode, 
E_QImode, 
21, 
24, 
22) == 0
                                  && 
#line 4052 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                                return gen_split_352 (insn, operands);
                              break;

                            case 22:
                              if (pattern359 (x1, 
E_SImode, 
E_HImode, 
30, 
22, 
18) == 0
                                  && 
#line 4451 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                                return gen_split_366 (insn, operands);
                              break;

                            default:
                              break;
                            }
                        }
                    }
                }
              if (REGNO (x10) != 18
                  || GET_MODE (x10) != E_DImode)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 26
                  || GET_MODE (x7) != E_QImode
                  || pattern324 (x1) != 0)
                return NULL;
              return gen_split_361 (insn, operands);

            case UNSPEC:
              if (pattern110 (x1) != 0)
                return NULL;
              x7 = XEXP (x4, 0);
              if (x7 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x11 = XVECEXP (x5, 0, 0);
                  operands[0] = x11;
                  if (register_operand (operands[0], E_HImode))
                    {
                      x8 = XVECEXP (x1, 0, 1);
                      x12 = XEXP (x8, 0);
                      x13 = XEXP (x12, 0);
                      operands[1] = x13;
                      x10 = XEXP (x3, 0);
                      operands[2] = x10;
                      if (scratch_operand (operands[2], E_HImode)
                          && (
#line 7924 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL) && 
#line 7926 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                        return gen_split_616 (insn, operands);
                    }
                }
              x11 = XVECEXP (x5, 0, 0);
              if (GET_CODE (x11) != REG
                  || pattern313 (x1) != 0
                  || !(
#line 7960 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL) && 
#line 7962 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_617 (insn, operands);

            default:
              return NULL;
            }

        case 3:
          return split_32 (x1, insn);

        case 7:
          if (pattern28 (x1) != 0)
            return NULL;
          switch (pattern373 (x1))
            {
            case 0:
              if (!
#line 1319 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_92 (insn, operands);

            case 1:
              if (!
#line 1319 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_93 (insn, operands);

            default:
              return NULL;
            }

        case 9:
          switch (pattern29 (x1))
            {
            case 0:
              if (!
#line 1375 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_94 (insn, operands);

            case 1:
              if (!
#line 1375 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_95 (insn, operands);

            default:
              return NULL;
            }

        case 5:
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x14 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x14) != CLOBBER)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x5 = XEXP (x2, 1);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                  if (XWINT (x5, 0) != 0L
                      || pattern161 (x1) != 0)
                    return NULL;
                  switch (pattern276 (x1))
                    {
                    case 0:
                      if (!
#line 1454 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                        return NULL;
                      return gen_split_96 (insn, operands);

                    case 1:
                      if (!
#line 1485 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                        return NULL;
                      return gen_split_97 (insn, operands);

                    default:
                      return NULL;
                    }

                case DIV:
                  if (pattern174 (x1, 
MOD) != 0
                      || !
#line 4304 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_360 (insn, operands);

                case UDIV:
                  if (pattern174 (x1, 
UMOD) != 0
                      || !
#line 4353 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_362 (insn, operands);

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (pattern146 (x1, 
3) != 0
                  || pattern237 (x1) != 0
                  || !
#line 8811 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_626 (insn, operands);

            default:
              return NULL;
            }

        case 6:
          x8 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x8) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x14 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x14) != CLOBBER)
            return NULL;
          x15 = XVECEXP (x1, 0, 5);
          if (GET_CODE (x15) != CLOBBER)
            return NULL;
          x2 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x2))
            {
            case SET:
              x10 = XEXP (x3, 0);
              if (GET_CODE (x10) != REG)
                return NULL;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return NULL;
              x16 = XEXP (x14, 0);
              if (GET_CODE (x16) != REG)
                return NULL;
              x17 = XEXP (x15, 0);
              if (GET_CODE (x17) != REG)
                return NULL;
              x18 = XEXP (x2, 0);
              operands[0] = x18;
              x12 = XEXP (x8, 0);
              operands[3] = x12;
              x5 = XEXP (x2, 1);
              switch (GET_CODE (x5))
                {
                case DIV:
                  switch (pattern332 (x1, 
MOD))
                    {
                    case 0:
                      return gen_split_345 (insn, operands);

                    case 1:
                      return gen_split_349 (insn, operands);

                    case 2:
                      return gen_split_363 (insn, operands);

                    default:
                      return NULL;
                    }

                case UDIV:
                  switch (pattern332 (x1, 
UMOD))
                    {
                    case 0:
                      return gen_split_347 (insn, operands);

                    case 1:
                      return gen_split_351 (insn, operands);

                    case 2:
                      return gen_split_365 (insn, operands);

                    default:
                      return NULL;
                    }

                default:
                  return NULL;
                }

            case UNSPEC_VOLATILE:
              if (XVECLEN (x2, 0) != 2
                  || XINT (x2, 1) != 10)
                return NULL;
              x19 = XVECEXP (x2, 0, 1);
              if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return NULL;
              x9 = XEXP (x8, 1);
              if (pattern94 (x9) != 0
                  || pattern333 (x1) != 0
                  || !
#line 8854 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_627 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x4;
      res = peephole2_1 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
      if (peep2_current_count < 2
          || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern197 (x1) != 0)
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (pattern304 (x5, 
E_QImode, 
IOR) != 0)
        return NULL;
      x6 = XVECEXP (x5, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 1);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x9 = XEXP (x7, 0);
      if (!rtx_equal_p (x9, operands[0]))
        return NULL;
      x10 = XEXP (x6, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_308 (insn, operands);

    case REG:
      return peephole2_5 (x1, insn, pmatch_len_);

    case PLUS:
    case MINUS:
    case AND:
    case IOR:
    case XOR:
    case ASHIFT:
    case ASHIFTRT:
    case LSHIFTRT:
      x11 = XEXP (x3, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 36
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XEXP (x2, 0);
      operands[0] = x12;
      switch (GET_CODE (x4))
        {
        case AND:
          res = peephole2_2 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case ASHIFT:
          x13 = XEXP (x4, 1);
          switch (GET_CODE (x13))
            {
            case REG:
            case SUBREG:
              operands[1] = x13;
              if (register_operand (operands[1], E_QImode)
                  && register_operand (operands[0], E_HImode)
                  && GET_MODE (x4) == E_HImode)
                {
                  x14 = XEXP (x4, 0);
                  if (rtx_equal_p (x14, operands[0]))
                    {
                      *pmatch_len_ = 0;
                      res = gen_peephole2_85 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
              break;

            case CONST_INT:
              x14 = XEXP (x4, 0);
              if (rtx_equal_p (x14, operands[0]))
                {
                  switch (XWINT (x13, 0))
                    {
                    case 4L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_86 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_87 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_88 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 5L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_89 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_90 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_91 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 6L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_92 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_93 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_94 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
              operands[2] = x13;
              switch (pattern306 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_97 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_100 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_103 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_106 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_109 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_112 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_115 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_118 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_121 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_124 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case LSHIFTRT:
          x13 = XEXP (x4, 1);
          if (GET_CODE (x13) == CONST_INT)
            {
              operands[2] = x13;
              switch (pattern306 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_95 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_98 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_101 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_104 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_107 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_110 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_113 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_116 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_119 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_122 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
              x14 = XEXP (x4, 0);
              if (rtx_equal_p (x14, operands[0]))
                {
                  switch (XWINT (x13, 0))
                    {
                    case 4L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_125 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_126 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_127 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 5L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_128 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_129 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_130 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    case 6L:
                      switch (pattern316 (x4))
                        {
                        case 0:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_131 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 1:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_132 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        case 2:
                          *pmatch_len_ = 0;
                          res = gen_peephole2_133 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                          break;

                        default:
                          break;
                        }
                      break;

                    default:
                      break;
                    }
                }
            }
          break;

        case ASHIFTRT:
          x14 = XEXP (x4, 0);
          operands[1] = x14;
          x13 = XEXP (x4, 1);
          operands[2] = x13;
          if (const_int_operand (operands[2], E_QImode))
            {
              switch (pattern305 (x4))
                {
                case 0:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_96 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 1:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_99 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 2:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_102 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 3:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_105 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 4:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_108 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 5:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_111 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 6:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_114 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 7:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_117 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 8:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_120 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                case 9:
                  *pmatch_len_ = 0;
                  res = gen_peephole2_123 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                  break;

                default:
                  break;
                }
            }
          break;

        case PLUS:
          res = peephole2_3 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        case MINUS:
          res = peephole2_4 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (peep2_current_count < 2
          || peep2_current_count < 3
          || !register_operand (operands[0], E_QImode))
        return NULL;
      operands[2] = x4;
      if (!op8_ZN_operator (operands[2], E_QImode))
        return NULL;
      x13 = XEXP (x4, 1);
      operands[1] = x13;
      x14 = XEXP (x4, 0);
      if (!rtx_equal_p (x14, operands[0]))
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x5) != SET)
        return NULL;
      x15 = XEXP (x5, 1);
      if (GET_CODE (x15) != COMPARE
          || GET_MODE (x15) != E_CCmode)
        return NULL;
      x16 = XEXP (x5, 0);
      if (GET_CODE (x16) != REG
          || REGNO (x16) != 36
          || GET_MODE (x16) != E_CCmode)
        return NULL;
      x17 = XEXP (x15, 1);
      operands[4] = x17;
      if (!const0_operand (operands[4], E_QImode))
        return NULL;
      x18 = XEXP (x15, 0);
      if (!rtx_equal_p (x18, operands[0]))
        return NULL;
      x19 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x19) != SET)
        return NULL;
      x20 = XEXP (x19, 1);
      if (GET_CODE (x20) != IF_THEN_ELSE)
        return NULL;
      x21 = XEXP (x20, 1);
      if (GET_CODE (x21) != LABEL_REF)
        return NULL;
      x22 = XEXP (x20, 2);
      if (GET_CODE (x22) != PC)
        return NULL;
      x23 = XEXP (x19, 0);
      if (GET_CODE (x23) != PC)
        return NULL;
      x24 = XEXP (x21, 0);
      operands[3] = x24;
      x25 = XEXP (x20, 0);
      switch (GET_CODE (x25))
        {
        case EQ:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_284 (insn, operands);

        case NE:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_285 (insn, operands);

        case GE:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_286 (insn, operands);

        case LT:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_287 (insn, operands);

        case GT:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_288 (insn, operands);

        case LE:
          if (pattern375 (x25) != 0
              || !
#line 7557 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (3, REG_CC)))
            return NULL;
          *pmatch_len_ = 2;
          return gen_peephole2_289 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (peep2_current_count < 2
          || pattern98 (x2, 
36, 
E_CCmode) != 0)
        return NULL;
      x11 = XEXP (x3, 0);
      operands[3] = x11;
      if (!scratch_operand (operands[3], E_QImode))
        return NULL;
      x5 = PATTERN (peep2_next_insn (1));
      if (pattern200 (x5) != 0)
        return NULL;
      x14 = XEXP (x4, 0);
      switch (GET_MODE (x14))
        {
        case E_HImode:
          if (!register_operand (x14, E_HImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_HImode))
            {
            case 0:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_294 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_295 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_HImode) != 0
              || !
#line 10299 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_309 (insn, operands);

        case E_SImode:
          if (!register_operand (x14, E_SImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_SImode))
            {
            case 0:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_296 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_297 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_SImode) != 0
              || !
#line 10299 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_310 (insn, operands);

        case E_PSImode:
          if (!register_operand (x14, E_PSImode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_PSImode))
            {
            case 0:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_298 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_299 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_PSImode) != 0
              || !
#line 10299 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_311 (insn, operands);

        case E_HQmode:
          if (!register_operand (x14, E_HQmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_HQmode))
            {
            case 0:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_300 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_301 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_HQmode) != 0
              || !
#line 10299 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_312 (insn, operands);

        case E_HAmode:
          if (!register_operand (x14, E_HAmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_HAmode))
            {
            case 0:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_302 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_303 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_HAmode) != 0
              || !
#line 10299 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_313 (insn, operands);

        case E_SQmode:
          if (!register_operand (x14, E_SQmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_SQmode))
            {
            case 0:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_304 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_305 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_SQmode) != 0
              || !
#line 10299 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_314 (insn, operands);

        case E_SAmode:
          if (!register_operand (x14, E_SAmode))
            return NULL;
          operands[0] = x14;
          x13 = XEXP (x4, 1);
          switch (pattern365 (x13, 
E_SAmode))
            {
            case 0:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_306 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 7750 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_307 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
          operands[1] = x14;
          if (pattern366 (x13, 
E_SAmode) != 0
              || !
#line 10299 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(peep2_regno_dead_p (2, REG_CC)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_315 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
