/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern4 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  x7 = XEXP (x1, 1);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_HImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_PSImode)
          || !register_operand (operands[3], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[4], E_QImode)
          || !single_one_operand (operands[2], E_SImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 30
      || GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != MEM
      || GET_MODE (x5) != E_BLKmode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != UNSPEC
      || XVECLEN (x7, 0) != 1
      || XINT (x7, 1) != 1)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != USE
      || pattern27 (x1) != 0)
    return -1;
  return 0;
}

int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern32 (x2, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern32 (x2, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern32 (x2, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern32 (x2, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern44 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!const_8_16_24_operand (operands[3], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  return pattern43 (x1); /* [-1, 5] */
}

int
pattern48 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || GET_MODE (x5) != E_UDQmode)
            return -1;
          return 0;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || GET_MODE (x5) != E_UDAmode)
            return -1;
          return 1;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || GET_MODE (x5) != E_UTAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || !const_operand (operands[0], E_UDQmode))
            return -1;
          return 3;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || !const_operand (operands[0], E_UDAmode))
            return -1;
          return 4;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || !const_operand (operands[0], E_UTAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      operands[2] = x2;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[2] = x1;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !nonmemory_operand (operands[2], E_HImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_PSImode
          || !nonmemory_operand (operands[2], E_PSImode))
        return -1;
      x4 = XEXP (x3, 0);
      res = pattern0 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      res = pattern1 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern91 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LO_SUM
      || GET_MODE (x3) != E_PSImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 21
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22)
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  return pattern101 (x1); /* [-1, 2] */
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  operands[1] = x1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !memory_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !memory_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !memory_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !memory_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !memory_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !memory_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !memory_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !memory_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !memory_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !memory_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !memory_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !memory_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !memory_operand (operands[1], E_SFmode))
        return -1;
      return 13;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !memory_operand (operands[1], E_PSImode))
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode
      || GET_MODE (x3) != E_QImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  switch (SUBREG_BYTE (x3))
    {
    case 0:
      return pattern127 (x4); /* [-1, 2] */

    case 1:
      res = pattern127 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case 2:
      res = pattern127 (x4);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    case 3:
      res = pattern127 (x4);
      if (res >= 0)
        return res + 9; /* [9, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 24:
      if (REGNO (x3) != 24)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_HQmode:
          if (GET_MODE (x6) != E_HQmode
              || GET_MODE (x7) != E_HQmode)
            return -1;
          return 0;

        case E_HAmode:
          if (GET_MODE (x6) != E_HAmode
              || GET_MODE (x7) != E_HAmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 22:
      if (REGNO (x3) != 22)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_SAmode:
          if (GET_MODE (x6) != E_SAmode
              || GET_MODE (x7) != E_SAmode)
            return -1;
          return 2;

        case E_SQmode:
          if (GET_MODE (x6) != E_SQmode
              || GET_MODE (x7) != E_SQmode)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern151 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 26
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x2, 1);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_SImode
      || pattern150 (x1, 
E_SImode, 
22) != 0)
    return -1;
  return 0;
}

int
pattern156 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  return 0;
}

int
pattern164 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  return pattern163 (x4); /* [-1, 0] */
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!reg_or_low_io_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!reg_or_low_io_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!reg_or_low_io_operand (operands[1], E_PSImode)
              || !const_0_to_23_operand (operands[2], E_QImode))
            return -1;
          return 2;

        case E_SImode:
          if (!reg_or_low_io_operand (operands[1], E_SImode)
              || !const_0_to_31_operand (operands[2], E_QImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode))
            return -1;
          return 4;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern183 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (pnum_clobbers == NULL
          || !pseudo_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_SImode
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          res = pattern182 (
E_QImode);
          if (res >= 0)
            return res + 1; /* [1, 2] */
          return -1;

        case E_HImode:
          res = pattern182 (
E_HImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern196 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_QImode)
    return -1;
  return 0;
}

int
pattern202 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_QImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_HImode))
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  return 0;
}

int
pattern214 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  switch (REGNO (x7))
    {
    case 22:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x5, 1);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 24
          || GET_MODE (x9) != E_QImode
          || pattern253 (x1, 
E_HImode, 
22, 
E_QImode, 
21, 
24) != 0)
        return -1;
      return 0;

    case 18:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x5, 1);
      x9 = XEXP (x8, 0);
      if (REGNO (x9) != 22
          || GET_MODE (x9) != E_SImode
          || pattern253 (x1, 
E_DImode, 
30, 
E_HImode, 
26, 
18) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern264 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern230 (x4); /* [-1, 3] */
}

int
pattern269 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x3, 1);
  if (REGNO (x5) != 22
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x2, 0);
  if (REGNO (x6) != 24
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  if (REGNO (x8) != 22
      || GET_MODE (x8) != E_QImode
      || GET_MODE (x3) != E_QImode)
    return -1;
  return 0;
}

int
pattern278 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18)
    return -1;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      if (!const_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_DQmode:
      if (!const_operand (operands[1], E_DQmode))
        return -1;
      return 1;

    case E_UDQmode:
      if (!const_operand (operands[1], E_UDQmode))
        return -1;
      return 2;

    case E_DAmode:
      if (!const_operand (operands[1], E_DAmode))
        return -1;
      return 3;

    case E_UDAmode:
      if (!const_operand (operands[1], E_UDAmode))
        return -1;
      return 4;

    case E_TAmode:
      if (!const_operand (operands[1], E_TAmode))
        return -1;
      return 5;

    case E_UTAmode:
      if (!const_operand (operands[1], E_UTAmode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern286 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SIGN_EXTEND
      || pattern285 (x4, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 1);
  switch (GET_CODE (x9))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || GET_MODE (x7) != E_SImode)
            return -1;
          return pattern256 (); /* [-1, 1] */

        case E_PSImode:
          if (!pseudo_register_operand (operands[0], E_PSImode)
              || GET_MODE (x6) != E_PSImode
              || GET_MODE (x7) != E_PSImode
              || !pseudo_register_operand (operands[1], E_QImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_PSImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      res = pattern291 (x6);
      if (res >= 0)
        return res + 3; /* [3, 6] */
      return -1;

    case ZERO_EXTEND:
      res = pattern291 (x6);
      if (res >= 0)
        return res + 7; /* [7, 10] */
      return -1;

    default:
      return -1;
    }
}

int
pattern311 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  if (!const_8_16_24_operand (operands[1], E_QImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != 10)
    return -1;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DQmode
          || GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDQmode
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DAmode
          || GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDAmode
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_TAmode
          || GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UTAmode
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern331 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 22
      || GET_MODE (x6) != E_PSImode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 18
      || GET_MODE (x7) != E_PSImode)
    return -1;
  x8 = XEXP (x4, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 22
      || GET_MODE (x8) != E_PSImode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 22
      || GET_MODE (x11) != E_PSImode)
    return -1;
  x12 = XEXP (x10, 1);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != 18
      || GET_MODE (x12) != E_PSImode)
    return -1;
  x13 = XEXP (x9, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 18
      || GET_MODE (x13) != E_PSImode)
    return -1;
  x14 = XVECEXP (x1, 0, 2);
  x15 = XEXP (x14, 0);
  if (REGNO (x15) != 21
      || GET_MODE (x15) != E_QImode)
    return -1;
  x16 = XVECEXP (x1, 0, 3);
  x17 = XEXP (x16, 0);
  if (REGNO (x17) != 25
      || GET_MODE (x17) != E_QImode)
    return -1;
  x18 = XVECEXP (x1, 0, 5);
  x19 = XEXP (x18, 0);
  if (REGNO (x19) != 36
      || GET_MODE (x19) != E_CCmode
      || GET_MODE (x5) != E_PSImode
      || GET_MODE (x10) != E_PSImode)
    return -1;
  return 0;
}

int
pattern351 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      return 2;

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      return 3;

    case E_HQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      return 4;

    case E_UHQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      return 5;

    case E_HAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      return 6;

    case E_UHAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      return 7;

    case E_SImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      return 8;

    case E_SQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SQmode)
        return -1;
      return 9;

    case E_USQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USQmode)
        return -1;
      return 10;

    case E_SAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SAmode)
        return -1;
      return 11;

    case E_USAmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_USAmode)
        return -1;
      return 12;

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      return 13;

    case E_PSImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern373 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  if (!const_int_operand (operands[0], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 6);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern383 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern375 (x1); /* [-1, 0] */

    case NE:
      if (pattern375 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern375 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern375 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern375 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern375 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      res = recog_6 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTEND:
      if (pattern66 (x1) == 0)
        return 182; /* *addhi3_zero_extend1_split */
      break;

    default:
      break;
    }
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern69 (x1))
    {
    case 0:
      if (
#line 101 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3143; /* adddi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3150; /* *adddi3_insn */

    case 1:
      if (
#line 101 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3144; /* adddq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3151; /* *adddq3_insn */

    case 2:
      if (
#line 101 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3145; /* addudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3152; /* *addudq3_insn */

    case 3:
      if (
#line 101 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3146; /* addda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3153; /* *addda3_insn */

    case 4:
      if (
#line 101 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3147; /* adduda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3154; /* *adduda3_insn */

    case 5:
      if (
#line 101 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3148; /* addta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3155; /* *addta3_insn */

    case 6:
      if (
#line 101 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3149; /* adduta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 114 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3156; /* *adduta3_insn */

    case 7:
      if (
#line 122 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3157; /* adddi3_const8_insn */
      if (pnum_clobbers == NULL
          || !
#line 135 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3158; /* *adddi3_const8_insn */

    case 8:
      if (
#line 147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3159; /* adddi3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3166; /* *adddi3_const_insn */

    case 9:
      if (
#line 147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3160; /* adddq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3167; /* *adddq3_const_insn */

    case 10:
      if (
#line 147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3161; /* addudq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3168; /* *addudq3_const_insn */

    case 11:
      if (
#line 147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3162; /* addda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3169; /* *addda3_const_insn */

    case 12:
      if (
#line 147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3163; /* adduda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3170; /* *adduda3_const_insn */

    case 13:
      if (
#line 147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3164; /* addta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3171; /* *addta3_const_insn */

    case 14:
      if (
#line 147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
        return 3165; /* adduta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 161 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)
   && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3172; /* *adduta3_const_insn */

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      if (pattern202 (x2) != 0)
        return -1;
      if (
#line 2533 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 486; /* *osmulqihi3_split */
      if (pnum_clobbers == NULL
          || !
#line 2546 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 487; /* *osmulqihi3 */

    case ZERO_EXTEND:
      if (pattern202 (x2) != 0)
        return -1;
      if (
#line 2557 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 488; /* *oumulqihi3_split */
      if (pnum_clobbers == NULL
          || !
#line 2570 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 489; /* *oumulqihi3 */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          if (
#line 3196 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 535; /* muloqihi3 */
          if (pnum_clobbers == NULL
              || !
#line 3209 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 536; /* *muloqihi3 */

        case E_SImode:
          if (pnum_clobbers == NULL
              || !pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x5) != E_HImode
              || !pseudo_register_operand (operands[1], E_HImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_SImode)
              || !
#line 3589 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 547; /* *mulohisi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (pattern152 (x1) == 0)
    return 642; /* *rotlqi3_split */
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (XWINT (x3, 0))
    {
    case 1L:
      switch (pattern188 (x2))
        {
        case 0:
          return 644; /* *rotlhi2.1_split */

        case 1:
          return 648; /* *rotlpsi2.1_split */

        case 2:
          return 652; /* *rotlsi2.1_split */

        default:
          break;
        }
      break;

    case 15L:
      if (register_operand (operands[0], E_HImode)
          && GET_MODE (x2) == E_HImode
          && register_operand (operands[1], E_HImode))
        return 646; /* *rotlhi2.15_split */
      break;

    case 23L:
      if (register_operand (operands[0], E_PSImode)
          && GET_MODE (x2) == E_PSImode
          && register_operand (operands[1], E_PSImode))
        return 650; /* *rotlpsi2.23_split */
      break;

    case 31L:
      if (register_operand (operands[0], E_SImode)
          && GET_MODE (x2) == E_SImode
          && register_operand (operands[1], E_SImode))
        return 654; /* *rotlsi2.31_split */
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      if (
#line 5227 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
        {
          *pnum_clobbers = 1;
          return 656; /* *rotwhi */
        }
      if (!
#line 5250 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 658; /* *rotbhi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      if (
#line 5227 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16))
        {
          *pnum_clobbers = 1;
          return 657; /* *rotwsi */
        }
      if (!
#line 5250 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 660; /* *rotbsi */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !
#line 5250 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))))
        return -1;
      *pnum_clobbers = 1;
      return 659; /* *rotbpsi */

    default:
      return -1;
    }
}

 int
recog_25 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern178 (x2, 
E_QImode) == 0)
            return 634; /* xorqi3 */
          break;

        case E_HImode:
          if (pnum_clobbers != NULL
              && pattern58 (x2, 
E_HImode) == 0)
            {
              *pnum_clobbers = 1;
              return 636; /* xorhi3 */
            }
          break;

        case E_PSImode:
          if (pattern50 (x2, pnum_clobbers, 
E_PSImode) == 0)
            {
              *pnum_clobbers = 1;
              return 638; /* xorpsi3 */
            }
          break;

        case E_SImode:
          if (pnum_clobbers != NULL
              && pattern58 (x2, 
E_SImode) == 0)
            {
              *pnum_clobbers = 1;
              return 640; /* xorsi3 */
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!register_operand (operands[2], E_QImode)
          || x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x8 = XEXP (x4, 2);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return -1;
      return 1087; /* *insv.xor1-bit.0_split */

    case LSHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern74 (x2))
        {
        case 0:
          if (!
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1092; /* *xorhi.lshiftrt */

        case 1:
          if (!
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1096; /* *xorpsi.lshiftrt */

        case 2:
          if (!
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1100; /* *xorsi.lshiftrt */

        case 3:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1116; /* *xorhiqi.lshiftrt */

        case 4:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1120; /* *xorpsiqi.lshiftrt */

        case 5:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1128; /* *xorpsihi.lshiftrt */

        case 6:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1124; /* *xorsiqi.lshiftrt */

        case 7:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1132; /* *xorsihi.lshiftrt */

        case 8:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1136; /* *xorsipsi.lshiftrt */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern45 (x1))
        {
        case 0:
          if (!
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 15))
            return -1;
          return 1094; /* *xorhi.ashift */

        case 1:
          if (!
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 23))
            return -1;
          return 1098; /* *xorpsi.ashift */

        case 2:
          if (!
#line 10147 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[3]) <= 31))
            return -1;
          return 1102; /* *xorsi.ashift */

        case 3:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1
   && INTVAL (operands[3]) <= 15))
            return -1;
          return 1118; /* *xorhiqi.ashift */

        case 4:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1122; /* *xorpsiqi.ashift */

        case 5:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2
   && INTVAL (operands[3]) <= 23))
            return -1;
          return 1130; /* *xorpsihi.ashift */

        case 6:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1126; /* *xorsiqi.ashift */

        case 7:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1134; /* *xorsihi.ashift */

        case 8:
          if (!
#line 10193 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3
   && INTVAL (operands[3]) <= 31))
            return -1;
          return 1138; /* *xorsipsi.ashift */

        case 9:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1373; /* *shl.ext.and1-to-skip.hi */

        case 10:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1379; /* *shl.ext.and1-to-skip.psi */

        case 11:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1391; /* *shl.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1385; /* *shl.ext.and1-to-skip.si */

        case 13:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1397; /* *shl.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1403; /* *shl.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1372; /* *shl.ext.and1-to-skip.hi */

        case 16:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1378; /* *shl.ext.and1-to-skip.psi */

        case 17:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1390; /* *shl.ext.and1-to-skip.psi */

        case 18:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1384; /* *shl.ext.and1-to-skip.si */

        case 19:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1396; /* *shl.ext.and1-to-skip.si */

        case 20:
          if (!
#line 10789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1402; /* *shl.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 0);
      operands[1] = x9;
      switch (pattern3 (x2))
        {
        case 0:
          return 1104; /* *xorhiqi.0 */

        case 1:
          return 1106; /* *xorpsiqi.0 */

        case 2:
          return 1110; /* *xorpsihi.0 */

        case 3:
          return 1108; /* *xorsiqi.0 */

        case 4:
          return 1112; /* *xorsihi.0 */

        case 5:
          return 1114; /* *xorsipsi.0 */

        default:
          return -1;
        }

    case AND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x9 = XEXP (x3, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTRACT:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1274; /* *pixop-to-skip.qi */

            case 1:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1286; /* *pixop-to-skip.qi */

            case 2:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1298; /* *pixop-to-skip.qi */

            case 3:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1310; /* *pixop-to-skip.qi */

            case 4:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1277; /* *pixop-to-skip.hi */

            case 5:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1289; /* *pixop-to-skip.hi */

            case 6:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1301; /* *pixop-to-skip.hi */

            case 7:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1313; /* *pixop-to-skip.hi */

            case 8:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1280; /* *pixop-to-skip.psi */

            case 9:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1292; /* *pixop-to-skip.psi */

            case 10:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1304; /* *pixop-to-skip.psi */

            case 11:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1316; /* *pixop-to-skip.psi */

            case 12:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1283; /* *pixop-to-skip.si */

            case 13:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1295; /* *pixop-to-skip.si */

            case 14:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1307; /* *pixop-to-skip.si */

            case 15:
              if (!
#line 10727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
                return -1;
              return 1319; /* *pixop-to-skip.si */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern12 (x2))
            {
            case 0:
              if (!
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1406; /* *shl.and-to-skip.hi */

            case 1:
              if (!
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1409; /* *shl.and-to-skip.psi */

            case 2:
              if (!
#line 10808 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
                return -1;
              return 1412; /* *shl.and-to-skip.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern80 (x2))
        {
        case 0:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1322; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1325; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1328; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10752 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1331; /* *mul.and1-to-skip.si */

        case 4:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1336; /* *mul.ext.and1-to-skip.hi */

        case 5:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1342; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1354; /* *mul.ext.and1-to-skip.psi */

        case 7:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1348; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1360; /* *mul.ext.and1-to-skip.si */

        case 9:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1366; /* *mul.ext.and1-to-skip.si */

        case 10:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1337; /* *mul.ext.and1-to-skip.hi */

        case 11:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1343; /* *mul.ext.and1-to-skip.psi */

        case 12:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1355; /* *mul.ext.and1-to-skip.psi */

        case 13:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1349; /* *mul.ext.and1-to-skip.si */

        case 14:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1361; /* *mul.ext.and1-to-skip.si */

        case 15:
          if (!
#line 10769 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1367; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern61 (x3))
    {
    case 0:
      return 3014; /* ussubuqq3 */

    case 1:
      return 3016; /* ussubuhq3 */

    case 2:
      return 3018; /* ussubuha3 */

    case 3:
      return 3020; /* ussubusa3 */

    case 4:
      return 3022; /* ussubusq3 */

    default:
      break;
    }
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  switch (pattern62 (x1))
    {
    case 0:
      if (
#line 361 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3226; /* ussubudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3232; /* *ussubudq3_insn */

    case 1:
      if (
#line 361 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3228; /* ussubuda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3234; /* *ussubuda3_insn */

    case 2:
      if (
#line 361 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3230; /* ussubuta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3236; /* *ussubuta3_insn */

    case 3:
      if (
#line 382 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3238; /* ussubudq3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3244; /* *ussubudq3_const_insn */

    case 4:
      if (
#line 382 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3240; /* ussubuda3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3246; /* *ussubuda3_const_insn */

    case 5:
      if (
#line 382 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3242; /* ussubuta3_const_insn */
      if (pnum_clobbers == NULL
          || !
#line 395 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3248; /* *ussubuta3_const_insn */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern289 (x3) != 0
              || GET_MODE (x4) != E_HImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 481; /* umulqihi3 */

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode)
            return -1;
          x8 = XEXP (x3, 0);
          if (GET_MODE (x8) != E_PSImode
              || GET_MODE (x4) != E_PSImode)
            return -1;
          x9 = XEXP (x8, 0);
          switch (GET_MODE (x9))
            {
            case E_QImode:
              operands[1] = x9;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_HImode)
                  || !
#line 4116 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 597; /* *umulqihipsi3 */

            case E_HImode:
              operands[2] = x9;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              if (!register_operand (operands[1], E_QImode)
                  || !
#line 4143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 599; /* *umulhiqipsi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern211 (x1) != 0
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 2496 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 483; /* *usmulqihi3 */

    case CONST_INT:
      operands[2] = x4;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      if (u8_operand (operands[2], E_HImode)
          && 
#line 2989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 522; /* *muluqihi3.uconst */
      if (!s8_operand (operands[2], E_HImode)
          || !
#line 3007 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 523; /* *muluqihi3.sconst */

    case REG:
    case SUBREG:
      if (pattern212 (x1) != 0
          || pattern289 (x3) != 0
          || !
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 534; /* *muluqihi3 */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !nonmemory_operand (operands[1], E_HImode)
          || !
#line 6814 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 864; /* cmphi3 */

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !nonmemory_operand (operands[1], E_HQmode)
          || !
#line 6814 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 865; /* cmphq3 */

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !nonmemory_operand (operands[1], E_UHQmode)
          || !
#line 6814 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 866; /* cmpuhq3 */

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !nonmemory_operand (operands[1], E_HAmode)
          || !
#line 6814 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 867; /* cmpha3 */

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !nonmemory_operand (operands[1], E_UHAmode)
          || !
#line 6814 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 868; /* cmpuha3 */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !nonmemory_operand (operands[1], E_PSImode)
          || !
#line 6849 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 869; /* *cmppsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !nonmemory_operand (operands[1], E_SImode)
          || !
#line 6881 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 870; /* *cmpsi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !nonmemory_operand (operands[1], E_SQmode)
          || !
#line 6881 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 871; /* *cmpsq */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !nonmemory_operand (operands[1], E_USQmode)
          || !
#line 6881 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 872; /* *cmpusq */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !nonmemory_operand (operands[1], E_SAmode)
          || !
#line 6881 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 873; /* *cmpsa */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !nonmemory_operand (operands[1], E_USAmode)
          || !
#line 6881 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 874; /* *cmpusa */

    default:
      return -1;
    }
}

 int
recog_59 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 36
          && GET_MODE (x6) == E_CCmode)
        {
          x7 = XEXP (x3, 0);
          operands[0] = x7;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern309 (x4, 
E_QImode) == 0
                  && 
#line 2213 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 301; /* *mulqi3_enh */
              break;

            case E_HImode:
              if (pattern309 (x4, 
E_HImode) == 0
                  && 
#line 3281 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return 538; /* *mulhi3_enh */
              break;

            case E_QQmode:
              if (pattern309 (x4, 
E_QQmode) == 0
                  && 
#line 309 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3054; /* *mulqq3_enh */
              break;

            case E_UQQmode:
              if (pattern309 (x4, 
E_UQQmode) == 0
                  && 
#line 330 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return 3056; /* *muluqq3_enh */
              break;

            default:
              break;
            }
        }
      if (GET_CODE (x5) != REG)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG
          || GET_CODE (x6) != REG)
        return -1;
      switch (REGNO (x5))
        {
        case 24:
          if (pattern269 (x1) != 0
              || !
#line 2234 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            return -1;
          return 302; /* *mulqi3_call_split */

        case 22:
          if (pattern270 (x1) != 0
              || !
#line 3710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 564; /* *mulsi3_call_split */

        case 18:
          switch (pattern271 (x1))
            {
            case 0:
              if (!
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3059; /* *mulhq3.call_split */

            case 1:
              if (!
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3060; /* *muluhq3.call_split */

            case 2:
              if (!
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3061; /* *mulha3.call_split */

            case 3:
              if (!
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return -1;
              return 3062; /* *muluha3.call_split */

            default:
              return -1;
            }

        case 16:
          if (REGNO (x8) != 20
              || REGNO (x7) != 24
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern260 (x3))
            {
            case 0:
              if (!
#line 481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3069; /* *mulsa3.call */

            case 1:
              if (!
#line 481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 3070; /* *mulusa3.call */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x5) == E_HImode)
        {
          res = recog_44 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          if (pattern286 (x4, 
E_HImode, 
26, 
E_SImode) != 0
              || pattern287 (x3, 
E_SImode, 
22) != 0
              || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 570; /* *mulhisi3_call */

        case 26:
          if (pattern288 (x3, 
E_SImode, 
22, 
18, 
E_HImode) != 0
              || !
#line 3854 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 580; /* *mulshisi3_call */

        case 25:
          if (pattern288 (x3, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
              || !
#line 4233 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 603; /* *mulsqipsi3.libgcc */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      res = recog_45 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != REG
          || GET_CODE (x7) != REG
          || REGNO (x7) != 22
          || GET_MODE (x7) != E_SImode)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x9) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_SImode)
        return -1;
      switch (REGNO (x9))
        {
        case 18:
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 571; /* *umulhisi3_call */

            case SIGN_EXTEND:
              x10 = XEXP (x8, 0);
              if (GET_CODE (x10) != REG
                  || REGNO (x10) != 26
                  || GET_MODE (x10) != E_HImode
                  || !
#line 3833 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 577; /* *usmulhisi3_call */

            default:
              return -1;
            }

        case 26:
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 18
              || !
#line 3854 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 581; /* *muluhisi3_call */

        default:
          return -1;
        }

    case NOT:
      x9 = XEXP (x5, 0);
      if (GET_CODE (x9) != ZERO_EXTEND)
        return -1;
      x11 = XEXP (x9, 0);
      if (GET_CODE (x11) != NOT)
        return -1;
      if (GET_MODE (x11) == E_QImode)
        {
          res = recog_46 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (GET_MODE (x11) != E_HImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 26
          || GET_MODE (x12) != E_HImode)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 18
          || GET_MODE (x8) != E_SImode
          || pattern143 (x1, 
36, 
E_CCmode, 
E_SImode, 
22) != 0
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x9) != E_SImode
          || !
#line 3875 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 583; /* *mulohisi3_call */

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case LSHIFTRT:
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != MULT)
        return -1;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern274 (x1, 
SIGN_EXTEND) == 0
              && 
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 306; /* *smulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern275 (x1, 
SIGN_EXTEND) != 0
              || !
#line 3795 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 572; /* *smulhi3_highpart_call_split */

        case ZERO_EXTEND:
          if (GET_MODE (x9) == E_HImode
              && pattern274 (x1, 
ZERO_EXTEND) == 0
              && 
#line 2277 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return 307; /* *umulqi3_highpart */
          if (GET_MODE (x9) != E_SImode
              || pattern275 (x1, 
ZERO_EXTEND) != 0
              || !
#line 3795 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 573; /* *umulhi3_highpart_call_split */

        default:
          return -1;
        }

    case PARITY:
      if (pattern192 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9238 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1030; /* *paritysihi2.libgcc */

    case POPCOUNT:
      if (pattern192 (x1, 
E_CCmode, 
36) != 0
          || !
#line 9314 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1035; /* *popcountsi2.libgcc */

    case CLZ:
      if (pattern192 (x1, 
E_QImode, 
26) != 0)
        return -1;
      return 1041; /* *clzsihi2.libgcc_split */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PARITY
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  if (REGNO (x6) == 24
      && GET_MODE (x6) == E_HImode)
    {
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (register_operand (operands[0], E_HImode))
        {
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          if (register_operand (operands[1], E_QImode)
              && 
#line 9150 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!reload_completed))
            return 1023; /* *parityqihi2.1 */
        }
    }
  if (REGNO (x6) != 36
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x8 = XEXP (x4, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 24
      || GET_MODE (x8) != E_QImode)
    return -1;
  x7 = XEXP (x2, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 24
      || GET_MODE (x7) != E_HImode
      || !
#line 9220 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
    return -1;
  return 1028; /* *parityqihi2.libgcc */
}

 int
recog_75 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern231 (x1, 
MOD))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != MOD)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 22)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern362 (x1))
        {
        case 0:
          return 585; /* *divmodqi4_call_split */

        case 1:
          return 591; /* *divmodhi4_call_split */

        default:
          return -1;
        }

    case 1:
      switch (pattern312 (x1))
        {
        case 0:
          if (!
#line 625 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3100; /* *divsa3.call */

        case 1:
          if (!
#line 625 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3102; /* *divusa3.call */

        default:
          return -1;
        }

    case 2:
      return 613; /* *divmodsi4_call_split */

    case 3:
      if (!
#line 577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3088; /* *divhq3.call */

    case 4:
      if (!
#line 577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3090; /* *divuhq3.call */

    case 5:
      if (!
#line 577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3092; /* *divha3.call */

    case 6:
      if (!
#line 577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3094; /* *divuha3.call */

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 0);
  switch (REGNO (x6))
    {
    case 24:
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) != 22)
        return -1;
      switch (REGNO (x4))
        {
        case 22:
          if (REGNO (x5) != 24)
            return -1;
          x9 = XVECEXP (x1, 0, 2);
          x10 = XEXP (x9, 0);
          switch (REGNO (x10))
            {
            case 36:
              if (pattern343 (x1, 
E_QImode, 
E_CCmode) != 0
                  || !
#line 2247 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                return -1;
              return 303; /* *mulqi3_call */

            case 21:
              if (pattern343 (x1, 
E_HImode, 
E_QImode) != 0
                  || !
#line 3310 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                return -1;
              return 539; /* *mulhi3_call_split */

            default:
              return -1;
            }

        case 25:
          if (pattern325 (x1) != 0
              || !
#line 377 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL))
            return -1;
          return 3057; /* *mulqq3.call_split */

        default:
          return -1;
        }

    case 22:
      if (GET_MODE (x6) != E_SImode
          || REGNO (x4) != 18
          || GET_MODE (x4) != E_SImode
          || REGNO (x5) != 22
          || GET_MODE (x5) != E_SImode
          || pattern344 (x1, 
E_CCmode, 
36, 
E_HImode, 
26) != 0
          || GET_MODE (x3) != E_SImode
          || !
#line 3745 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 566; /* *mulsi3_call */

    case 18:
      switch (pattern294 (x1, 
E_CCmode, 
36, 
22, 
26))
        {
        case 0:
          if (!
#line 440 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3063; /* *mulhq3.call */

        case 1:
          if (!
#line 440 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3064; /* *muluhq3.call */

        case 2:
          if (!
#line 440 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3065; /* *mulha3.call */

        case 3:
          if (!
#line 440 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 3066; /* *muluha3.call */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_84 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (pattern95 (x2) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 21
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      switch (pattern363 (x1))
        {
        case 0:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 83; /* fxload_qi_libgcc */

        case 1:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 84; /* fxload_qq_libgcc */

        case 2:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 85; /* fxload_uqq_libgcc */

        case 3:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 86; /* fxload_hi_libgcc */

        case 4:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 87; /* fxload_hq_libgcc */

        case 5:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 88; /* fxload_uhq_libgcc */

        case 6:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 89; /* fxload_ha_libgcc */

        case 7:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 90; /* fxload_uha_libgcc */

        case 8:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 91; /* fxload_si_libgcc */

        case 9:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 92; /* fxload_sq_libgcc */

        case 10:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 93; /* fxload_usq_libgcc */

        case 11:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 94; /* fxload_sa_libgcc */

        case 12:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 95; /* fxload_usa_libgcc */

        case 13:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 96; /* fxload_sf_libgcc */

        case 14:
          if (!
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)))
            return -1;
          return 97; /* fxload_psi_libgcc */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_79 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern161 (x1) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          *pnum_clobbers = 2;
          return 168; /* *clrmemqi_split */

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          *pnum_clobbers = 2;
          return 170; /* *clrmemhi_split */

        default:
          return -1;
        }

    case PLUS:
      return recog_83 (x1, insn, pnum_clobbers);

    case MINUS:
      if (pattern96 (x1) != 0
          || !scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern296 (x3, 
E_HImode) != 0
              || !
#line 2143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 285; /* *subhi3 */

        case E_HQmode:
          if (pattern296 (x3, 
E_HQmode) != 0
              || !
#line 2143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 286; /* *subhq3 */

        case E_UHQmode:
          if (pattern296 (x3, 
E_UHQmode) != 0
              || !
#line 2143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 287; /* *subuhq3 */

        case E_HAmode:
          if (pattern296 (x3, 
E_HAmode) != 0
              || !
#line 2143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 288; /* *subha3 */

        case E_UHAmode:
          if (pattern296 (x3, 
E_UHAmode) != 0
              || !
#line 2143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 289; /* *subuha3 */

        case E_SImode:
          if (pattern296 (x3, 
E_SImode) != 0
              || !
#line 2173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 295; /* *subsi3 */

        case E_SQmode:
          if (pattern296 (x3, 
E_SQmode) != 0
              || !
#line 2173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 296; /* *subsq3 */

        case E_USQmode:
          if (pattern296 (x3, 
E_USQmode) != 0
              || !
#line 2173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 297; /* *subusq3 */

        case E_SAmode:
          if (pattern296 (x3, 
E_SAmode) != 0
              || !
#line 2173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 298; /* *subsa3 */

        case E_USAmode:
          if (pattern296 (x3, 
E_USAmode) != 0
              || !
#line 2173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 299; /* *subusa3 */

        default:
          return -1;
        }

    case MULT:
      return recog_81 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      if (pattern98 (x2, 
24, 
E_HImode) != 0
          || pattern97 (x1) != 0)
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_MODE (x10) != E_SImode)
        return -1;
      switch (GET_CODE (x10))
        {
        case LSHIFTRT:
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != MULT
              || GET_MODE (x11) != E_SImode)
            return -1;
          x12 = XEXP (x10, 1);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || pattern344 (x1, 
E_CCmode, 
36, 
E_HImode, 
22) != 0)
            return -1;
          switch (pattern346 (x11))
            {
            case 0:
              if (!
#line 3812 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 574; /* *smulhi3_highpart_call */

            case 1:
              if (!
#line 3812 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 575; /* *umulhi3_highpart_call */

            default:
              return -1;
            }

        case CLZ:
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 22
              || GET_MODE (x11) != E_SImode
              || pattern344 (x1, 
E_CCmode, 
36, 
E_QImode, 
26) != 0
              || !
#line 9411 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1042; /* *clzsihi2.libgcc */

        case CTZ:
          if (pattern322 (x1) != 0)
            return -1;
          return 1045; /* *ctzsihi2.libgcc_split */

        case FFS:
          if (pattern322 (x1) != 0)
            return -1;
          return 1049; /* *ffssihi2.libgcc_split */

        default:
          return -1;
        }

    case UDIV:
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x13 = XEXP (x3, 1);
      if (GET_CODE (x13) != REG)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG)
        return -1;
      switch (REGNO (x10))
        {
        case 24:
          switch (pattern263 (x1))
            {
            case 0:
              return 588; /* *udivmodqi4_call_split */

            case 1:
              return 3095; /* *udivsa3.call_split */

            case 2:
              return 3097; /* *udivusa3.call_split */

            default:
              return -1;
            }

        case 25:
          if (REGNO (x13) != 22
              || REGNO (x8) != 24)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return -1;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (pattern323 (x1))
            {
            case 0:
              if (!
#line 529 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3075; /* *udivqq3.call */

            case 1:
              if (!
#line 529 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3077; /* *udivuqq3.call */

            default:
              return -1;
            }

        case 26:
          switch (pattern266 (x1))
            {
            case 0:
              return 3079; /* *udivhq3.call_split */

            case 1:
              return 3081; /* *udivuhq3.call_split */

            case 2:
              return 3083; /* *udivha3.call_split */

            case 3:
              return 3085; /* *udivuha3.call_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern102 (x1))
        {
        case 0:
          if (!
#line 4517 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 621; /* *andhi3 */

        case 1:
          if (!
#line 4551 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 623; /* *andpsi3 */

        case 2:
          if (!
#line 4586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 625; /* *andsi3 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern102 (x1))
        {
        case 0:
          if (!
#line 4665 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 629; /* *iorhi3 */

        case 1:
          if (!
#line 4697 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 631; /* *iorpsi3 */

        case 2:
          if (!
#line 4729 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 633; /* *iorsi3 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern102 (x1))
        {
        case 0:
          if (!
#line 4786 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 637; /* *xorhi3 */

        case 1:
          if (!
#line 4816 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 639; /* *xorpsi3 */

        case 2:
          if (!
#line 4848 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 641; /* *xorsi3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern96 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern104 (x3, 
E_HImode) != 0
              || !
#line 5567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 692; /* *ashlhi3_const */

        case E_HQmode:
          if (pattern104 (x3, 
E_HQmode) != 0
              || !
#line 5567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 693; /* *ashlhq3_const */

        case E_UHQmode:
          if (pattern104 (x3, 
E_UHQmode) != 0
              || !
#line 5567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 694; /* *ashluhq3_const */

        case E_HAmode:
          if (pattern104 (x3, 
E_HAmode) != 0
              || !
#line 5567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 695; /* *ashlha3_const */

        case E_UHAmode:
          if (pattern104 (x3, 
E_UHAmode) != 0
              || !
#line 5567 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 696; /* *ashluha3_const */

        case E_SImode:
          if (pattern105 (x3, 
E_SImode) != 0
              || !
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 697; /* *ashlsi3_const */

        case E_SQmode:
          if (pattern105 (x3, 
E_SQmode) != 0
              || !
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 698; /* *ashlsq3_const */

        case E_USQmode:
          if (pattern105 (x3, 
E_USQmode) != 0
              || !
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 699; /* *ashlusq3_const */

        case E_SAmode:
          if (pattern105 (x3, 
E_SAmode) != 0
              || !
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 700; /* *ashlsa3_const */

        case E_USAmode:
          if (pattern105 (x3, 
E_USAmode) != 0
              || !
#line 5665 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 701; /* *ashlusa3_const */

        case E_PSImode:
          if (pattern103 (x3) != 0
              || !
#line 5723 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 703; /* *ashlpsi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern106 (x1))
        {
        case 0:
          if (!
#line 5840 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 722; /* *ashrpsi3 */

        case 1:
          if (!
#line 5887 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 733; /* *ashrhi3_const */

        case 2:
          if (!
#line 5887 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 734; /* *ashrhq3_const */

        case 3:
          if (!
#line 5887 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 735; /* *ashruhq3_const */

        case 4:
          if (!
#line 5887 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 736; /* *ashrha3_const */

        case 5:
          if (!
#line 5887 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 737; /* *ashruha3_const */

        case 6:
          if (!
#line 5905 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 738; /* *ashrsi3_const */

        case 7:
          if (!
#line 5905 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 739; /* *ashrsq3_const */

        case 8:
          if (!
#line 5905 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 740; /* *ashrusq3_const */

        case 9:
          if (!
#line 5905 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 741; /* *ashrsa3_const */

        case 10:
          if (!
#line 5905 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 742; /* *ashrusa3_const */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern106 (x1))
        {
        case 0:
          if (!
#line 6040 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 760; /* *lshrpsi3 */

        case 1:
          if (!
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 771; /* *lshrhi3_const */

        case 2:
          if (!
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 772; /* *lshrhq3_const */

        case 3:
          if (!
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 773; /* *lshruhq3_const */

        case 4:
          if (!
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 774; /* *lshrha3_const */

        case 5:
          if (!
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 775; /* *lshruha3_const */

        case 6:
          if (!
#line 6160 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 776; /* *lshrsi3_const */

        case 7:
          if (!
#line 6160 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 777; /* *lshrsq3_const */

        case 8:
          if (!
#line 6160 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 778; /* *lshrusq3_const */

        case 9:
          if (!
#line 6160 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 779; /* *lshrsa3_const */

        case 10:
          if (!
#line 6160 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 780; /* *lshrusa3_const */

        default:
          return -1;
        }

    case COMPARE:
      return recog_82 (x1, insn, pnum_clobbers);

    case CLZ:
      if (pattern108 (x1) != 0
          || !
#line 9390 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1040; /* *clzhi2.libgcc */

    case CTZ:
      if (pattern108 (x1) != 0
          || !
#line 9459 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1044; /* *ctzhi2.libgcc */

    case FFS:
      if (pattern108 (x1) != 0
          || !
#line 9531 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1048; /* *ffshi2.libgcc */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2)
        return -1;
      x14 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x14) != REG)
        return -1;
      x15 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x15) != REG
          || GET_MODE (x15) != E_QImode)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      if (pattern107 (x6) != 0)
        return -1;
      switch (pattern281 (x1))
        {
        case 0:
          if (!
#line 9739 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1060; /* *fmul.call */

        case 1:
          if (!
#line 9811 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1064; /* *fmuls.call */

        case 2:
          if (!
#line 9883 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          return 1068; /* *fmulsu.call */

        case 3:
          if (!
#line 729 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3125; /* *roundqq3.libgcc */

        case 4:
          if (!
#line 729 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3126; /* *rounduqq3.libgcc */

        case 5:
          if (!
#line 755 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3131; /* *roundhq3.libgcc */

        case 6:
          if (!
#line 755 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3132; /* *rounduhq3.libgcc */

        case 7:
          if (!
#line 755 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3133; /* *roundha3.libgcc */

        case 8:
          if (!
#line 755 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3134; /* *rounduha3.libgcc */

        case 9:
          if (!
#line 781 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3139; /* *roundsq3.libgcc */

        case 10:
          if (!
#line 781 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3140; /* *roundusq3.libgcc */

        case 11:
          if (!
#line 781 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3141; /* *roundsa3.libgcc */

        case 12:
          if (!
#line 781 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3142; /* *roundusa3.libgcc */

        default:
          return -1;
        }

    case DIV:
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      x13 = XEXP (x3, 1);
      if (GET_CODE (x13) != REG)
        return -1;
      x8 = XEXP (x2, 0);
      if (GET_CODE (x8) != REG
          || pattern97 (x1) != 0)
        return -1;
      switch (REGNO (x10))
        {
        case 25:
          if (REGNO (x13) != 22
              || REGNO (x8) != 24)
            return -1;
          switch (pattern323 (x1))
            {
            case 0:
              if (!
#line 529 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3076; /* *divqq3.call */

            case 1:
              if (!
#line 529 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(reload_completed))
                return -1;
              return 3078; /* *divuqq3.call */

            default:
              return -1;
            }

        case 26:
          switch (pattern294 (x1, 
E_QImode, 
21, 
26, 
22))
            {
            case 0:
              return 3080; /* *divhq3.call_split */

            case 1:
              return 3082; /* *divuhq3.call_split */

            case 2:
              return 3084; /* *divha3.call_split */

            case 3:
              return 3086; /* *divuha3.call_split */

            default:
              return -1;
            }

        case 24:
          if (REGNO (x13) != 18
              || REGNO (x8) != 22)
            return -1;
          switch (pattern262 (x1))
            {
            case 0:
              return 3096; /* *divsa3.call_split */

            case 1:
              return 3098; /* *divusa3.call_split */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern39 (x1))
        {
        case 0:
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || !
#line 3065 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_303 (insn, operands);

        case 1:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_987 (insn, operands);

        case 2:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_989 (insn, operands);

        case 3:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_993 (insn, operands);

        case 4:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_991 (insn, operands);

        case 5:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_995 (insn, operands);

        case 6:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_997 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) == CONST_INT
          && rtx_equal_p (x3, operands[0]))
        {
          switch (XWINT (x4, 0))
            {
            case 4L:
              switch (pattern165 (x2))
                {
                case 0:
                  return gen_split_408 (insn, operands);

                case 1:
                  return gen_split_409 (insn, operands);

                case 2:
                  return gen_split_410 (insn, operands);

                default:
                  break;
                }
              break;

            case 5L:
              switch (pattern165 (x2))
                {
                case 0:
                  return gen_split_411 (insn, operands);

                case 1:
                  return gen_split_412 (insn, operands);

                case 2:
                  return gen_split_413 (insn, operands);

                default:
                  break;
                }
              break;

            case 6L:
              switch (pattern165 (x2))
                {
                case 0:
                  return gen_split_414 (insn, operands);

                case 1:
                  return gen_split_415 (insn, operands);

                case 2:
                  return gen_split_416 (insn, operands);

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      operands[1] = x3;
      operands[2] = x4;
      switch (pattern142 (x2))
        {
        case 0:
          if (
#line 5321 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_417 (insn, operands);
          break;

        case 1:
          if (
#line 5321 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_418 (insn, operands);
          break;

        case 2:
          if (
#line 5321 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_419 (insn, operands);
          break;

        case 3:
          if (
#line 5348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_420 (insn, operands);
          break;

        case 4:
          if (
#line 5348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_421 (insn, operands);
          break;

        case 5:
          if (
#line 5348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_422 (insn, operands);
          break;

        case 6:
          if (
#line 5348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_423 (insn, operands);
          break;

        case 7:
          if (
#line 5348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_424 (insn, operands);
          break;

        case 8:
          if (
#line 5464 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_430 (insn, operands);
          break;

        case 9:
          if (
#line 5464 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_431 (insn, operands);
          break;

        case 10:
          if (
#line 5464 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_432 (insn, operands);
          break;

        case 11:
          if (
#line 5464 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_433 (insn, operands);
          break;

        case 12:
          if (
#line 5464 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_434 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG)
        return NULL;
      switch (pattern53 (x1))
        {
        case 0:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1919 (insn, operands);

        case 1:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1923 (insn, operands);

        case 2:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1927 (insn, operands);

        case 3:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1931 (insn, operands);

        case 4:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1935 (insn, operands);

        case 5:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1939 (insn, operands);

        case 6:
          if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1943 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (XWINT (x3, 0) != 1L
          || pattern71 (x1) != 0
          || !
#line 8960 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_629 (insn, operands);

    case ZERO_EXTEND:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != AND)
        return NULL;
      x7 = XEXP (x6, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern38 (x2))
        {
        case 0:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_988 (insn, operands);

        case 1:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_990 (insn, operands);

        case 2:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_994 (insn, operands);

        case 3:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_992 (insn, operands);

        case 4:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_996 (insn, operands);

        case 5:
          if (!(
#line 10882 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10886 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_998 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (pattern141 (x3) == 0
          && 
#line 4477 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_367 (insn, operands);
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0)
          || GET_MODE (x4) != E_QImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      switch (pattern204 (x3))
        {
        case 0:
          if (!(
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_768 (insn, operands);

        case 1:
          if (!(
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_770 (insn, operands);

        case 2:
          if (!(
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_772 (insn, operands);

        case 3:
          if (!(
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_769 (insn, operands);

        case 4:
          if (!(
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_771 (insn, operands);

        case 5:
          if (!(
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_773 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern73 (x3))
        {
        case 0:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_752 (insn, operands);

        case 1:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_755 (insn, operands);

        case 2:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_758 (insn, operands);

        case 3:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_761 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern73 (x3))
        {
        case 0:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_753 (insn, operands);

        case 1:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_756 (insn, operands);

        case 2:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_759 (insn, operands);

        case 3:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_762 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern73 (x3))
        {
        case 0:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_754 (insn, operands);

        case 1:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_757 (insn, operands);

        case 2:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_760 (insn, operands);

        case 3:
          if (!
#line 10577 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_763 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      switch (pattern125 (x3))
        {
        case 0:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_999 (insn, operands);

        case 1:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1003 (insn, operands);

        case 2:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1007 (insn, operands);

        case 3:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1011 (insn, operands);

        case 4:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1000 (insn, operands);

        case 5:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1004 (insn, operands);

        case 6:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1008 (insn, operands);

        case 7:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1012 (insn, operands);

        case 8:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1001 (insn, operands);

        case 9:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1005 (insn, operands);

        case 10:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1009 (insn, operands);

        case 11:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1013 (insn, operands);

        case 12:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1002 (insn, operands);

        case 13:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1006 (insn, operands);

        case 14:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1010 (insn, operands);

        case 15:
          if (!(
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10912 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_1014 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == CONST_INT)
    {
      x5 = XEXP (x3, 0);
      if (rtx_equal_p (x5, operands[0]))
        {
          switch (XWINT (x4, 0))
            {
            case 4L:
              switch (pattern165 (x3))
                {
                case 0:
                  return gen_split_517 (insn, operands);

                case 1:
                  return gen_split_518 (insn, operands);

                case 2:
                  return gen_split_519 (insn, operands);

                default:
                  break;
                }
              break;

            case 5L:
              switch (pattern165 (x3))
                {
                case 0:
                  return gen_split_520 (insn, operands);

                case 1:
                  return gen_split_521 (insn, operands);

                case 2:
                  return gen_split_522 (insn, operands);

                default:
                  break;
                }
              break;

            case 6L:
              if (d_register_operand (operands[0], E_QImode)
                  && GET_MODE (x3) == E_QImode)
                return gen_split_523 (insn, operands);
              break;

            default:
              break;
            }
        }
    }
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  operands[2] = x4;
  switch (pattern142 (x3))
    {
    case 0:
      if (
#line 5971 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_524 (insn, operands);
      break;

    case 1:
      if (
#line 5971 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_525 (insn, operands);
      break;

    case 2:
      if (
#line 5971 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_526 (insn, operands);
      break;

    case 3:
      if (
#line 5997 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_527 (insn, operands);
      break;

    case 4:
      if (
#line 5997 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_528 (insn, operands);
      break;

    case 5:
      if (
#line 5997 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_529 (insn, operands);
      break;

    case 6:
      if (
#line 5997 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_530 (insn, operands);
      break;

    case 7:
      if (
#line 5997 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_531 (insn, operands);
      break;

    case 8:
      if (
#line 6056 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_533 (insn, operands);
      break;

    case 9:
      if (
#line 6056 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_534 (insn, operands);
      break;

    case 10:
      if (
#line 6056 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_535 (insn, operands);
      break;

    case 11:
      if (
#line 6056 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_536 (insn, operands);
      break;

    case 12:
      if (
#line 6056 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_537 (insn, operands);
      break;

    default:
      break;
    }
  if (reg_or_low_io_operand (operands[1], E_QImode)
      && x4 == const_int_rtx[MAX_SAVED_CONST_INT + 7]
      && register_operand (operands[0], E_QImode)
      && GET_MODE (x3) == E_QImode
      && (
#line 10555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10557 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
    return gen_split_751 (insn, operands);
  if (GET_CODE (x5) != REG)
    return NULL;
  switch (pattern53 (x1))
    {
    case 0:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1921 (insn, operands);

    case 1:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1925 (insn, operands);

    case 2:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1929 (insn, operands);

    case 3:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1933 (insn, operands);

    case 4:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1937 (insn, operands);

    case 5:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1941 (insn, operands);

    case 6:
      if (!(
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
        return NULL;
      return gen_split_1945 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (!scratch_operand (x5, E_QImode))
    return NULL;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern295 (x6, 
E_HImode) != 0
              || !
#line 1902 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_114 (insn, operands);

        case E_HQmode:
          if (pattern295 (x6, 
E_HQmode) != 0
              || !
#line 1902 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_115 (insn, operands);

        case E_UHQmode:
          if (pattern295 (x6, 
E_UHQmode) != 0
              || !
#line 1902 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_116 (insn, operands);

        case E_HAmode:
          if (pattern295 (x6, 
E_HAmode) != 0
              || !
#line 1902 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_117 (insn, operands);

        case E_UHAmode:
          if (pattern295 (x6, 
E_UHAmode) != 0
              || !
#line 1902 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_118 (insn, operands);

        case E_SImode:
          if (pattern99 (x6, 
E_SImode) != 0
              || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_119 (insn, operands);

        case E_SQmode:
          if (pattern99 (x6, 
E_SQmode) != 0
              || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_120 (insn, operands);

        case E_USQmode:
          if (pattern99 (x6, 
E_USQmode) != 0
              || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_121 (insn, operands);

        case E_SAmode:
          if (pattern99 (x6, 
E_SAmode) != 0
              || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_122 (insn, operands);

        case E_USAmode:
          if (pattern99 (x6, 
E_USAmode) != 0
              || !
#line 1936 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_123 (insn, operands);

        case E_PSImode:
          if (pattern99 (x6, 
E_PSImode) != 0
              || !
#line 2046 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_147 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      x8 = XEXP (x6, 1);
      operands[3] = x8;
      operands[4] = x5;
      x10 = XEXP (x7, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          if (pattern220 (x6) != 0
              || !const_int_operand (operands[2], E_QImode)
              || !register_operand (operands[3], E_QImode)
              || !(
#line 2640 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_279 (insn, operands);

        case SIGN_EXTEND:
          if (pattern221 (x6) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2850 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2852 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_290 (insn, operands);
          if (!u8_operand (operands[2], E_HImode)
              || !(
#line 2942 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)) && 
#line 2945 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_296 (insn, operands);

        case ZERO_EXTEND:
          if (GET_MODE (x10) != E_HImode
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x6) != E_HImode
              || GET_MODE (x7) != E_HImode)
            return NULL;
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!register_operand (operands[1], E_QImode)
              || !u8_operand (operands[2], E_HImode)
              || !register_operand (operands[3], E_HImode)
              || !(
#line 2850 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2852 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_291 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_31 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return NULL;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return split_24 (x1, insn);

    case PLUS:
      return split_25 (x1, insn);

    case MINUS:
      return split_26 (x1, insn);

    case MULT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != REG)
            return NULL;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x3, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          switch (REGNO (x5))
            {
            case 24:
              if (pattern269 (x1) != 0
                  || !(
#line 2234 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2236 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_163 (insn, operands);

            case 22:
              if (pattern270 (x1) != 0
                  || !(
#line 3710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3712 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_335 (insn, operands);

            case 18:
              switch (pattern271 (x1))
                {
                case 0:
                  if (!(
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1808 (insn, operands);

                case 1:
                  if (!(
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1809 (insn, operands);

                case 2:
                  if (!(
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1810 (insn, operands);

                case 3:
                  if (!(
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 427 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
                    return NULL;
                  return gen_split_1811 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (pattern169 (x1) != 0)
            return NULL;
          if (s8_operand (operands[2], E_HImode)
              && (
#line 2989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2991 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_298 (insn, operands);
          if (u8_operand (operands[2], E_HImode)
              && (
#line 3025 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3027 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_301 (insn, operands);
          if (!o8_operand (operands[2], E_HImode)
              || !(
#line 3043 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3045 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_302 (insn, operands);

        case ZERO_EXTEND:
          if (pattern169 (x1) != 0)
            return NULL;
          if (u8_operand (operands[2], E_HImode)
              && (
#line 2989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2991 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_299 (insn, operands);
          if (!s8_operand (operands[2], E_HImode)
              || !(
#line 3007 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3009 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_300 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      return split_27 (x1, insn);

    case TRUNCATE:
      if (pattern98 (x2, 
24, 
E_HImode) != 0)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode)
        return NULL;
      switch (GET_CODE (x5))
        {
        case LSHIFTRT:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != MULT
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x10 = XEXP (x5, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
              || REGNO (x8) != 22
              || GET_MODE (x8) != E_HImode)
            return NULL;
          switch (pattern346 (x9))
            {
            case 0:
              if (!(
#line 3795 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3797 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_339 (insn, operands);

            case 1:
              if (!(
#line 3795 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3797 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_340 (insn, operands);

            default:
              return NULL;
            }

        case CLZ:
          x9 = XEXP (x5, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 22
              || GET_MODE (x9) != E_SImode
              || REGNO (x8) != 26
              || GET_MODE (x8) != E_QImode
              || !
#line 9400 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_647 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 4504 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_368 (insn, operands);

        case 1:
          if (!
#line 4538 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_369 (insn, operands);

        case 2:
          if (!
#line 4573 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_370 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 4652 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_372 (insn, operands);

        case 1:
          if (!
#line 4684 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_373 (insn, operands);

        case 2:
          if (!
#line 4716 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_374 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern101 (x1))
        {
        case 0:
          if (!
#line 4773 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_376 (insn, operands);

        case 1:
          if (!
#line 4803 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_377 (insn, operands);

        case 2:
          if (!
#line 4835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_378 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return NULL;
      switch (pattern241 (x1))
        {
        case 0:
          if ((
#line 5227 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 2 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5232 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_403 (insn, operands);
          if (!(
#line 5250 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 2 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5256 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_405 (insn, operands);

        case 1:
          if (!(
#line 5227 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MOVW
   && CONST_INT_P (operands[2])
   && 4 % 2 == 0
   && 0 == INTVAL (operands[2]) % 16) && 
#line 5232 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_404 (insn, operands);

        case 2:
          if (!(
#line 5250 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 4 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5256 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_407 (insn, operands);

        case 3:
          if (!(
#line 5250 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(CONST_INT_P (operands[2])
   && (8 == INTVAL (operands[2]) % 16
       || ((!AVR_HAVE_MOVW
            || 3 % 2 != 0)
           && 0 == INTVAL (operands[2]) % 16))) && 
#line 5256 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_406 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern242 (x1))
            {
            case 0:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_435 (insn, operands);
              break;

            case 1:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_438 (insn, operands);
              break;

            case 2:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return gen_split_441 (insn, operands);
              break;

            case 3:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_444 (insn, operands);
              break;

            case 4:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_447 (insn, operands);
              break;

            case 5:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_450 (insn, operands);
              break;

            case 6:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return gen_split_453 (insn, operands);
              break;

            case 7:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_456 (insn, operands);
              break;

            case 8:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_459 (insn, operands);
              break;

            case 9:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_462 (insn, operands);
              break;

            case 10:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return gen_split_465 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern243 (x1) != 0
          || !
#line 6024 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_532 (insn, operands);

    case ASHIFTRT:
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (const_int_operand (operands[2], E_QImode))
        {
          switch (pattern242 (x1))
            {
            case 0:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_436 (insn, operands);
              break;

            case 1:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_439 (insn, operands);
              break;

            case 2:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return gen_split_442 (insn, operands);
              break;

            case 3:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_445 (insn, operands);
              break;

            case 4:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_448 (insn, operands);
              break;

            case 5:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_451 (insn, operands);
              break;

            case 6:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return gen_split_454 (insn, operands);
              break;

            case 7:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_457 (insn, operands);
              break;

            case 8:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_460 (insn, operands);
              break;

            case 9:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_463 (insn, operands);
              break;

            case 10:
              if (
#line 5586 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return gen_split_466 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!nonmemory_operand (operands[2], E_QImode)
          || pattern243 (x1) != 0
          || !
#line 5824 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_511 (insn, operands);

    case LO_SUM:
      if (GET_MODE (x4) != E_PSImode
          || pattern158 (x1) != 0
          || !
#line 6629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return NULL;
      return gen_split_560 (insn, operands);

    case COMPARE:
      if (GET_MODE (x4) != E_CCmode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != LSHIFTRT)
        return NULL;
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 36
          || GET_MODE (x7) != E_CCmode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != SCRATCH
          || GET_MODE (x8) != E_QImode)
        return NULL;
      switch (pattern311 (x5))
        {
        case 0:
          if (!(
#line 6903 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed) && 
#line 6907 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_566 (insn, operands);

        case 1:
          if (!(
#line 6903 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed) && 
#line 6907 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_567 (insn, operands);

        case 2:
          if (!(
#line 6903 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed) && 
#line 6907 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_568 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      x5 = XEXP (x4, 0);
      if (!ordered_comparison_operator (x5, E_VOIDmode))
        return NULL;
      operands[0] = x5;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != LABEL_REF)
        return NULL;
      x11 = XEXP (x4, 2);
      if (GET_CODE (x11) != PC)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != PC)
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      switch (pattern277 (x1))
        {
        case 0:
          if (
#line 7011 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_572 (insn, operands);
          break;

        case 1:
          if (
#line 7011 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_573 (insn, operands);
          break;

        case 2:
          if (
#line 7011 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_574 (insn, operands);
          break;

        case 3:
          if (
#line 7011 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_575 (insn, operands);
          break;

        case 4:
          if (
#line 7011 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_576 (insn, operands);
          break;

        case 5:
          if (
#line 7038 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_577 (insn, operands);
          break;

        case 6:
          if (
#line 7066 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_578 (insn, operands);
          break;

        case 7:
          if (
#line 7066 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_579 (insn, operands);
          break;

        case 8:
          if (
#line 7066 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_580 (insn, operands);
          break;

        case 9:
          if (
#line 7066 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_581 (insn, operands);
          break;

        case 10:
          if (
#line 7066 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return gen_split_582 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x9) != REG)
        return NULL;
      switch (pattern278 (x1))
        {
        case 0:
          if (!(
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1912 (insn, operands);

        case 1:
          if (!(
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1913 (insn, operands);

        case 2:
          if (!(
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1914 (insn, operands);

        case 3:
          if (!(
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1915 (insn, operands);

        case 4:
          if (!(
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1916 (insn, operands);

        case 5:
          if (!(
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1917 (insn, operands);

        case 6:
          if (!(
#line 555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)) && 
#line 558 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1918 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24)
        return NULL;
      switch (pattern214 (x1))
        {
        case 0:
          if (!(
#line 9135 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9137 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_635 (insn, operands);

        case 1:
          if (!(
#line 9164 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9166 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_637 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PARITY
          || GET_MODE (x5) != E_QImode)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_HImode)
        return NULL;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode))
        return NULL;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode)
          || !(
#line 9150 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 9152 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_636 (insn, operands);

    case CLZ:
      if (pattern144 (x1) != 0
          || !
#line 9379 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_646 (insn, operands);

    case CTZ:
      if (pattern144 (x1) != 0
          || !
#line 9448 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_648 (insn, operands);

    case FFS:
      if (pattern144 (x1) != 0
          || !
#line 9520 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_650 (insn, operands);

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return NULL;
      x12 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x12) != REG)
        return NULL;
      x13 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x13) != REG
          || GET_MODE (x13) != E_QImode)
        return NULL;
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      x8 = XEXP (x3, 0);
      if (GET_CODE (x8) != REG)
        return NULL;
      switch (pattern281 (x1))
        {
        case 0:
          if (!(
#line 9724 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9726 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_654 (insn, operands);

        case 1:
          if (!(
#line 9796 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9798 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_656 (insn, operands);

        case 2:
          if (!(
#line 9868 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 9870 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_658 (insn, operands);

        case 3:
          if (!
#line 716 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1840 (insn, operands);

        case 4:
          if (!
#line 716 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1841 (insn, operands);

        case 5:
          if (!
#line 742 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1842 (insn, operands);

        case 6:
          if (!
#line 742 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1843 (insn, operands);

        case 7:
          if (!
#line 742 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1844 (insn, operands);

        case 8:
          if (!
#line 742 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1845 (insn, operands);

        case 9:
          if (!
#line 768 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1846 (insn, operands);

        case 10:
          if (!
#line 768 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1847 (insn, operands);

        case 11:
          if (!
#line 768 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1848 (insn, operands);

        case 12:
          if (!
#line 768 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1849 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern145 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1814 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1816 (insn, operands);

        default:
          return NULL;
        }

    case DIV:
      switch (pattern145 (x1))
        {
        case 0:
          if (!
#line 516 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1815 (insn, operands);

        case 1:
          if (!
#line 516 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1817 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
