/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonmemory_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return pattern9 (); /* [-1, 3] */
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!combine_pseudo_register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  switch (REGNO (x3))
    {
    case 25:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_QQmode:
          if (GET_MODE (x2) != E_QQmode
              || GET_MODE (x3) != E_QQmode
              || GET_MODE (x4) != E_QQmode)
            return -1;
          return 0;

        case E_UQQmode:
          if (GET_MODE (x2) != E_UQQmode
              || GET_MODE (x3) != E_UQQmode
              || GET_MODE (x4) != E_UQQmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 26:
      res = pattern24 (x1, 
22);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case 24:
      if (REGNO (x4) != 18)
        return -1;
      res = pattern25 (x1, 
22);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || pattern34 (x1, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern38 (x3);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x2);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 6;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 7;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern59 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      return pattern58 (x1, 
E_QQmode); /* [-1, 0] */

    case E_HQmode:
      if (pattern58 (x1, 
E_HQmode) != 0)
        return -1;
      return 1;

    case E_HAmode:
      if (pattern58 (x1, 
E_HAmode) != 0)
        return -1;
      return 2;

    case E_SAmode:
      if (pattern58 (x1, 
E_SAmode) != 0)
        return -1;
      return 3;

    case E_SQmode:
      if (pattern58 (x1, 
E_SQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern65 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (XINT (x1, 1))
    {
    case 0:
      if (GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != MEM
          || GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case 6:
      if (GET_MODE (x1) != E_QImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[1] = x2;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      operands[3] = x5;
      if (!nonmemory_operand (operands[3], E_QImode))
        return -1;
      return 1;

    case 7:
      x5 = XVECEXP (x1, 0, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[1] = x2;
      x3 = XVECEXP (x1, 0, 1);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_QQmode:
          if (!register_operand (operands[0], E_QQmode)
              || GET_MODE (x1) != E_QQmode
              || !register_operand (operands[1], E_QQmode))
            return -1;
          return 2;

        case E_HQmode:
          if (!register_operand (operands[0], E_HQmode)
              || GET_MODE (x1) != E_HQmode
              || !register_operand (operands[1], E_HQmode))
            return -1;
          return 3;

        case E_HAmode:
          if (!register_operand (operands[0], E_HAmode)
              || GET_MODE (x1) != E_HAmode
              || !register_operand (operands[1], E_HAmode))
            return -1;
          return 4;

        case E_SAmode:
          if (!register_operand (operands[0], E_SAmode)
              || GET_MODE (x1) != E_SAmode
              || !register_operand (operands[1], E_SAmode))
            return -1;
          return 5;

        case E_SQmode:
          if (!register_operand (operands[0], E_SQmode)
              || GET_MODE (x1) != E_SQmode
              || !register_operand (operands[1], E_SQmode))
            return -1;
          return 6;

        case E_UQQmode:
          if (!register_operand (operands[0], E_UQQmode)
              || GET_MODE (x1) != E_UQQmode
              || !register_operand (operands[1], E_UQQmode))
            return -1;
          return 7;

        case E_UHQmode:
          if (!register_operand (operands[0], E_UHQmode)
              || GET_MODE (x1) != E_UHQmode
              || !register_operand (operands[1], E_UHQmode))
            return -1;
          return 8;

        case E_UHAmode:
          if (!register_operand (operands[0], E_UHAmode)
              || GET_MODE (x1) != E_UHAmode
              || !register_operand (operands[1], E_UHAmode))
            return -1;
          return 9;

        case E_USAmode:
          if (!register_operand (operands[0], E_USAmode)
              || GET_MODE (x1) != E_USAmode
              || !register_operand (operands[1], E_USAmode))
            return -1;
          return 10;

        case E_USQmode:
          if (!register_operand (operands[0], E_USQmode)
              || GET_MODE (x1) != E_USQmode
              || !register_operand (operands[1], E_USQmode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern93 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x6) != E_QQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 0;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 1;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 2;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 3;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 4;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 5;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 6;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 7;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 8;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 9;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 10;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 11;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 12;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 13;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 14;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 15;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 16;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 17;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x6) != E_UQQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 19;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 20;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 21;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 22;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 23;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 24;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 25;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 26;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 27;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 28;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 29;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 30;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 31;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 32;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 33;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 36;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x6) != E_HQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 38;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 39;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 40;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 41;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 42;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 43;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 44;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 45;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 46;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 47;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 48;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 49;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 50;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 51;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 52;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 53;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 54;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 55;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x6) != E_UHQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 57;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 58;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 59;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 60;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 61;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 62;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 63;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 64;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 65;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 66;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 67;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 68;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 69;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 70;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 71;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 72;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 73;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 74;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 75;

        default:
          return -1;
        }

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x6) != E_HAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 76;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 77;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 78;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 79;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 80;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 81;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 82;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 83;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 84;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 85;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 86;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 87;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 88;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 89;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 90;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 91;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 92;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 93;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x6) != E_UHAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 95;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 96;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 97;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 98;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 99;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 100;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 101;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 102;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 103;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 104;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 105;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 106;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 107;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 108;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 109;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 110;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 111;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 112;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x6) != E_SQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 114;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 115;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 116;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 117;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 118;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 119;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 120;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 121;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 122;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 123;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 124;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 125;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 126;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 127;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 128;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 129;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 130;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 131;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 132;

        default:
          return -1;
        }

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x6) != E_USQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 133;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 134;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 135;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 136;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 137;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 138;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 139;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 140;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 141;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 142;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 143;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 144;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 145;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 146;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 147;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 148;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 149;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 150;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 151;

        default:
          return -1;
        }

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x6) != E_SAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 152;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 153;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 154;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 155;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 156;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 157;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 158;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 159;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 160;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 161;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 162;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 163;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 164;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 165;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 166;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 167;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 168;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 169;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 170;

        default:
          return -1;
        }

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x6) != E_USAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 171;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 172;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 173;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 174;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 175;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 176;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 177;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 178;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 179;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 180;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 181;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 182;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 183;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 184;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 185;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 186;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 187;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 188;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 189;

        default:
          return -1;
        }

    case E_DQmode:
      if (!register_operand (operands[0], E_DQmode)
          || GET_MODE (x6) != E_DQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 190;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 191;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 192;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 193;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 194;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 195;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 196;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 197;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 198;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 199;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 200;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 201;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 202;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 203;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 204;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 205;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 206;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 207;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 208;

        default:
          return -1;
        }

    case E_UDQmode:
      if (!register_operand (operands[0], E_UDQmode)
          || GET_MODE (x6) != E_UDQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 209;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 210;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 211;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 212;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 213;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 214;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 215;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 216;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 217;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 218;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 219;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 220;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 221;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 222;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 223;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 224;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 225;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 226;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 227;

        default:
          return -1;
        }

    case E_DAmode:
      if (!register_operand (operands[0], E_DAmode)
          || GET_MODE (x6) != E_DAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 228;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 229;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 230;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 231;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 232;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 233;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 234;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 235;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 236;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 237;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 238;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 239;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 240;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 241;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 242;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 243;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 244;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 245;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 246;

        default:
          return -1;
        }

    case E_UDAmode:
      if (!register_operand (operands[0], E_UDAmode)
          || GET_MODE (x6) != E_UDAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 247;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 248;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 249;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 250;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 251;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 252;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 253;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 254;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 255;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 256;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 257;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 258;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 259;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 260;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 261;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 262;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 263;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 264;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 265;

        default:
          return -1;
        }

    case E_TAmode:
      if (!register_operand (operands[0], E_TAmode)
          || GET_MODE (x6) != E_TAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 266;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 267;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 268;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 269;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 270;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 271;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 272;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 273;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 274;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 275;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 276;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 277;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 278;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 279;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 280;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 281;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 282;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 283;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 284;

        default:
          return -1;
        }

    case E_UTAmode:
      if (!register_operand (operands[0], E_UTAmode)
          || GET_MODE (x6) != E_UTAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 285;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 286;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 287;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 288;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 289;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 290;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 291;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 292;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 293;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 294;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 295;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 296;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 297;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 298;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 299;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 300;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 301;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 302;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 303;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x6) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 304;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 305;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 306;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 307;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 308;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 309;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 310;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 311;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 312;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 313;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 314;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 315;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 316;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 317;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 318;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 319;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 320;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 321;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 322;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x6) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 323;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 324;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 325;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 326;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 327;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 328;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 329;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 330;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 331;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 332;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 333;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 334;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 335;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 336;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 337;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 338;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 339;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 340;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 341;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 342;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 343;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 344;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 345;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 346;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 347;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 348;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 349;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 350;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 351;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 352;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 353;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 354;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 355;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 356;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 357;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 358;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 359;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 360;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 361;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 362;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 363;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 364;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 365;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 366;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 367;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 368;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 369;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 370;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 371;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 372;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 373;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 374;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 375;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 376;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 377;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 378;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 379;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      switch (pattern51 (x1, pnum_clobbers))
        {
        case 0:
          return 743; /* *lshrqi3_split */

        case 1:
          return 744; /* *lshrqq3_split */

        case 2:
          return 745; /* *lshruqq3_split */

        case 3:
          if (nop_general_operand (operands[2], E_QImode))
            return 749; /* lshrhi3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 771; /* *lshrhi3_const */
            }
          break;

        case 4:
          if (nop_general_operand (operands[2], E_QImode))
            return 750; /* lshrhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 772; /* *lshrhq3_const */
            }
          break;

        case 5:
          if (nop_general_operand (operands[2], E_QImode))
            return 751; /* lshruhq3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 773; /* *lshruhq3_const */
            }
          break;

        case 6:
          if (nop_general_operand (operands[2], E_QImode))
            return 752; /* lshrha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 774; /* *lshrha3_const */
            }
          break;

        case 7:
          if (nop_general_operand (operands[2], E_QImode))
            return 753; /* lshruha3 */
          if (pnum_clobbers != NULL
              && const_int_operand (operands[2], E_QImode)
              && 
#line 6143 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            {
              *pnum_clobbers = 2;
              return 775; /* *lshruha3_const */
            }
          break;

        case 8:
          *pnum_clobbers = 1;
          return 759; /* lshrpsi3 */

        case 9:
          return 761; /* lshrsi3 */

        case 10:
          return 762; /* lshrsq3 */

        case 11:
          return 763; /* lshrusq3 */

        case 12:
          return 764; /* lshrsa3 */

        case 13:
          return 765; /* lshrusa3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      if (pattern52 (x1) == 0)
        return 1082; /* *insv.shiftrt */
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) == E_QImode)
    {
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 7])
        {
          operands[0] = x2;
          if (register_operand (operands[0], E_QImode))
            {
              x5 = XEXP (x3, 0);
              operands[1] = x5;
              if (reg_or_low_io_operand (operands[1], E_QImode)
                  && 
#line 10555 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
                return 1181; /* *extzv.io.lsr7 */
            }
        }
    }
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  switch (pattern53 (x1))
    {
    case 0:
      if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3283; /* lshrdi3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3311; /* *lshrdi3_insn */

    case 1:
      if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3287; /* lshrdq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3315; /* *lshrdq3_insn */

    case 2:
      if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3291; /* lshrudq3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3319; /* *lshrudq3_insn */

    case 3:
      if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3295; /* lshrda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3323; /* *lshrda3_insn */

    case 4:
      if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3299; /* lshruda3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3327; /* *lshruda3_insn */

    case 5:
      if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3303; /* lshrta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3331; /* *lshrta3_insn */

    case 6:
      if (
#line 629 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3307; /* lshruta3_insn */
      if (pnum_clobbers == NULL
          || !
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3335; /* *lshruta3_insn */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (pattern72 (x1, pnum_clobbers))
        {
        case 0:
          return 618; /* andqi3 */

        case 1:
          *pnum_clobbers = 1;
          return 620; /* andhi3 */

        case 2:
          *pnum_clobbers = 1;
          return 622; /* andpsi3 */

        case 3:
          *pnum_clobbers = 1;
          return 624; /* andsi3 */

        default:
          break;
        }
      if (GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern204 (x2))
        {
        case 0:
          if (!
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1210; /* *extract.subreg.bit */

        case 1:
          if (!
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1212; /* *extract.subreg.bit */

        case 2:
          if (!
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1214; /* *extract.subreg.bit */

        case 3:
          if (!
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1211; /* *extract.subreg.bit */

        case 4:
          if (!
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1213; /* *extract.subreg.bit */

        case 5:
          if (!
#line 10627 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1215; /* *extract.subreg.bit */

        default:
          return -1;
        }

    case MEM:
      if (pattern40 (x1) != 0
          || !single_zero_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      return 980; /* *cbi */

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern73 (x2))
        {
        case 0:
          return 1182; /* *insv.any_shift.qi_split */

        case 1:
          return 1185; /* *insv.any_shift.hi_split */

        case 2:
          return 1188; /* *insv.any_shift.psi_split */

        case 3:
          return 1191; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern73 (x2))
        {
        case 0:
          return 1183; /* *insv.any_shift.qi_split */

        case 1:
          return 1186; /* *insv.any_shift.hi_split */

        case 2:
          return 1189; /* *insv.any_shift.psi_split */

        case 3:
          return 1192; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern73 (x2))
        {
        case 0:
          return 1184; /* *insv.any_shift.qi_split */

        case 1:
          return 1187; /* *insv.any_shift.hi_split */

        case 2:
          return 1190; /* *insv.any_shift.psi_split */

        case 3:
          return 1193; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern125 (x2))
        {
        case 0:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1457; /* *map.and1-to-skip.qi */

        case 1:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1461; /* *map.and1-to-skip.qi */

        case 2:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1465; /* *map.and1-to-skip.qi */

        case 3:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1469; /* *map.and1-to-skip.qi */

        case 4:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1458; /* *map.and1-to-skip.hi */

        case 5:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1462; /* *map.and1-to-skip.hi */

        case 6:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1466; /* *map.and1-to-skip.hi */

        case 7:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1470; /* *map.and1-to-skip.hi */

        case 8:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1459; /* *map.and1-to-skip.psi */

        case 9:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1463; /* *map.and1-to-skip.psi */

        case 10:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1467; /* *map.and1-to-skip.psi */

        case 11:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1471; /* *map.and1-to-skip.psi */

        case 12:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1460; /* *map.and1-to-skip.si */

        case 13:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1464; /* *map.and1-to-skip.si */

        case 14:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1468; /* *map.and1-to-skip.si */

        case 15:
          if (!
#line 10909 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1472; /* *map.and1-to-skip.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pattern156 (x1, 
E_HImode) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x8 = XEXP (x3, 1);
  switch (GET_CODE (x8))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 2546 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 487; /* *osmulqihi3 */

    case ZERO_EXTEND:
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 2570 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 489; /* *oumulqihi3 */

    case REG:
    case SUBREG:
      operands[2] = x8;
      if (!register_operand (operands[2], E_HImode)
          || !
#line 3209 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 536; /* *muloqihi3 */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern224 (x1))
        {
        case 0:
          if (
#line 5777 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 708; /* *ashrqi3 */
          break;

        case 1:
          if (
#line 5777 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 709; /* *ashrqq3 */
          break;

        case 2:
          if (
#line 5777 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 710; /* *ashruqq3 */
          break;

        case 3:
          if (
#line 5809 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 716; /* *ashrhi3 */
          break;

        case 4:
          if (
#line 5809 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 717; /* *ashrhq3 */
          break;

        case 5:
          if (
#line 5809 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 718; /* *ashruhq3 */
          break;

        case 6:
          if (
#line 5809 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 719; /* *ashrha3 */
          break;

        case 7:
          if (
#line 5809 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 720; /* *ashruha3 */
          break;

        case 8:
          if (
#line 5869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 728; /* *ashrsi3 */
          break;

        case 9:
          if (
#line 5869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 729; /* *ashrsq3 */
          break;

        case 10:
          if (
#line 5869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 730; /* *ashrusq3 */
          break;

        case 11:
          if (
#line 5869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 731; /* *ashrsa3 */
          break;

        case 12:
          if (
#line 5869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 732; /* *ashrusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      if (pattern103 (x3) != 0)
        return -1;
      return 721; /* ashrpsi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_SImode) != 0
          || !
#line 5905 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 738; /* *ashrsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_SQmode) != 0
          || !
#line 5905 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 739; /* *ashrsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_USQmode) != 0
          || !
#line 5905 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 740; /* *ashrusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_SAmode) != 0
          || !
#line 5905 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 741; /* *ashrsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_USAmode) != 0
          || !
#line 5905 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 742; /* *ashrusa3_const */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36)
    return -1;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[0] = x5;
      res = recog_51 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 18)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER
          || GET_MODE (x3) != E_CCmode
          || GET_MODE (x4) != E_CCmode)
        return -1;
      x7 = XEXP (x4, 1);
      operands[0] = x7;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      switch (GET_MODE (x5))
        {
        case E_DImode:
          if (!const_operand (operands[0], E_DImode)
              || !
#line 576 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3274; /* compare_const_di2 */

        case E_DQmode:
          if (!const_operand (operands[0], E_DQmode)
              || !
#line 576 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3275; /* compare_const_dq2 */

        case E_UDQmode:
          if (!const_operand (operands[0], E_UDQmode)
              || !
#line 576 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3276; /* compare_const_udq2 */

        case E_DAmode:
          if (!const_operand (operands[0], E_DAmode)
              || !
#line 576 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3277; /* compare_const_da2 */

        case E_UDAmode:
          if (!const_operand (operands[0], E_UDAmode)
              || !
#line 576 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3278; /* compare_const_uda2 */

        case E_TAmode:
          if (!const_operand (operands[0], E_TAmode)
              || !
#line 576 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3279; /* compare_const_ta2 */

        case E_UTAmode:
          if (!const_operand (operands[0], E_UTAmode)
              || !
#line 576 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(reload_completed
   && avr_have_dimode
   && !s8_operand (operands[0], VOIDmode)))
            return -1;
          return 3280; /* compare_const_uta2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case CLOBBER:
          x8 = XEXP (x6, 0);
          if (GET_CODE (x8) != SCRATCH
              || GET_MODE (x8) != E_QImode
              || GET_MODE (x3) != E_CCmode
              || GET_MODE (x4) != E_CCmode)
            return -1;
          switch (pattern311 (x5))
            {
            case 0:
              if (!
#line 6903 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 875; /* *cmphi_lsr */

            case 1:
              if (!
#line 6903 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 876; /* *cmppsi_lsr */

            case 2:
              if (!
#line 6903 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 877; /* *cmpsi_lsr */

            default:
              return -1;
            }

        case SET:
          x9 = XEXP (x6, 1);
          if (GET_CODE (x9) != LSHIFTRT
              || GET_MODE (x9) != E_QImode
              || GET_MODE (x3) != E_CCZNmode
              || GET_MODE (x4) != E_CCZNmode
              || GET_MODE (x5) != E_QImode
              || pattern320 (x1) != 0
              || !
#line 7601 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 947; /* *op8.for.cczn.lshiftrt */

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != PLUS)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (x3))
        {
        case E_CCZNmode:
          if (GET_MODE (x4) != E_CCZNmode)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern327 (x1, pnum_clobbers, 
E_HImode) != 0
                  || !
#line 7329 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 916; /* *add.for.cczn.hi */

            case E_PSImode:
              if (pattern327 (x1, pnum_clobbers, 
E_PSImode) != 0
                  || !
#line 7329 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 917; /* *add.for.cczn.psi */

            case E_SImode:
              if (pattern327 (x1, pnum_clobbers, 
E_SImode) != 0
                  || !
#line 7329 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 918; /* *add.for.cczn.si */

            case E_QImode:
              if (!register_operand (operands[3], E_QImode))
                return -1;
              x11 = XEXP (x5, 1);
              operands[4] = x11;
              if (!nonmemory_operand (operands[4], E_QImode)
                  || !register_operand (operands[0], E_QImode)
                  || GET_MODE (x9) != E_QImode)
                return -1;
              x12 = XEXP (x9, 0);
              operands[1] = x12;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x13 = XEXP (x9, 1);
              operands[2] = x13;
              if (!nonmemory_operand (operands[2], E_QImode)
                  || !
#line 7601 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 940; /* *op8.for.cczn.plus */

            default:
              return -1;
            }

        case E_CCNmode:
          if (pnum_clobbers == NULL
              || GET_MODE (x4) != E_CCNmode)
            return -1;
          x11 = XEXP (x5, 1);
          operands[1] = x11;
          x12 = XEXP (x9, 0);
          operands[4] = x12;
          x13 = XEXP (x9, 1);
          operands[5] = x13;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern352 (x9, 
E_HImode) != 0
                  || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 919; /* *add.for.ccn.hi */

            case E_PSImode:
              if (pattern352 (x9, 
E_PSImode) != 0
                  || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 920; /* *add.for.ccn.psi */

            case E_SImode:
              if (pattern352 (x9, 
E_SImode) != 0
                  || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 921; /* *add.for.ccn.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != MINUS
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      x11 = XEXP (x5, 1);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[4] = x11;
          x13 = XEXP (x9, 1);
          operands[2] = x13;
          switch (GET_MODE (x5))
            {
            case E_HImode:
              if (pattern353 (x9, 
E_HImode) != 0
                  || !
#line 7464 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 922; /* *sub.for.cczn.hi */

            case E_PSImode:
              if (pattern353 (x9, 
E_PSImode) != 0
                  || !
#line 7464 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 923; /* *sub.for.cczn.psi */

            case E_SImode:
              if (pattern353 (x9, 
E_SImode) != 0
                  || !
#line 7464 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 924; /* *sub.for.cczn.si */

            case E_QImode:
              if (pattern353 (x9, 
E_QImode) != 0
                  || !
#line 7601 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 941; /* *op8.for.cczn.minus */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern339 (x1, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return -1;
              return 925; /* *sub-extendqi.for.cczn.hi */

            case 1:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return -1;
              return 927; /* *sub-extendqi.for.cczn.psi */

            case 2:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return -1;
              return 931; /* *sub-extendhi.for.cczn.psi */

            case 3:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return -1;
              return 929; /* *sub-extendqi.for.cczn.si */

            case 4:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return -1;
              return 933; /* *sub-extendhi.for.cczn.si */

            case 5:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return -1;
              return 935; /* *sub-extendpsi.for.cczn.si */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern339 (x1, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
                return -1;
              return 926; /* *sub-extendqi.for.cczn.hi */

            case 1:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
                return -1;
              return 928; /* *sub-extendqi.for.cczn.psi */

            case 2:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
                return -1;
              return 932; /* *sub-extendhi.for.cczn.psi */

            case 3:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
                return -1;
              return 930; /* *sub-extendqi.for.cczn.si */

            case 4:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
                return -1;
              return 934; /* *sub-extendhi.for.cczn.si */

            case 5:
              if (!
#line 7480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
                return -1;
              return 936; /* *sub-extendpsi.for.cczn.si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x11 = XEXP (x5, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != ASHIFT)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (XWINT (x11, 0) == 1L)
        {
          res = recog_52 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!register_operand (operands[1], E_QImode)
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode
          || GET_MODE (x5) != E_QImode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x11;
      if (!const_1_to_3_operand (operands[4], E_QImode)
          || !register_operand (operands[0], E_QImode)
          || GET_MODE (x9) != E_QImode)
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!const_1_to_3_operand (operands[2], E_QImode)
          || !
#line 7601 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 945; /* *op8.for.cczn.ashift */

    case AND:
      if (pattern195 (x1, 
AND) != 0
          || !
#line 7601 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 942; /* *op8.for.cczn.and */

    case IOR:
      if (pattern195 (x1, 
IOR) != 0
          || !
#line 7601 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 943; /* *op8.for.cczn.ior */

    case XOR:
      if (pattern196 (x1, 
XOR) != 0
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode)
        return -1;
      x10 = XEXP (x5, 0);
      operands[3] = x10;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[4] = x11;
      if (!register_operand (operands[4], E_QImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x9 = XEXP (x6, 1);
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 7601 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 944; /* *op8.for.cczn.xor */

    case ASHIFTRT:
      if (pattern196 (x1, 
ASHIFTRT) != 0
          || GET_MODE (x3) != E_CCZNmode
          || GET_MODE (x4) != E_CCZNmode
          || pattern320 (x1) != 0
          || !
#line 7601 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 946; /* *op8.for.cczn.ashiftrt */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x4, 0);
  operands[3] = x10;
  x11 = XEXP (x4, 1);
  operands[1] = x11;
  x12 = XEXP (x7, 0);
  operands[0] = x12;
  x13 = XEXP (x8, 0);
  operands[4] = x13;
  x14 = XEXP (x8, 1);
  operands[5] = x14;
  x15 = XEXP (x9, 0);
  operands[2] = x15;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_CCZNmode:
      if (GET_MODE (x3) != E_CCZNmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern368 (x8, 
E_HImode) != 0
              || !
#line 7329 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 916; /* *add.for.cczn.hi */

        case E_PSImode:
          if (pattern368 (x8, 
E_PSImode) != 0
              || !
#line 7329 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 917; /* *add.for.cczn.psi */

        case E_SImode:
          if (pattern368 (x8, 
E_SImode) != 0
              || !
#line 7329 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 918; /* *add.for.cczn.si */

        default:
          return -1;
        }

    case E_CCNmode:
      if (GET_MODE (x3) != E_CCNmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern352 (x8, 
E_HImode) != 0
              || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 919; /* *add.for.ccn.hi */

        case E_PSImode:
          if (pattern352 (x8, 
E_PSImode) != 0
              || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 920; /* *add.for.ccn.psi */

        case E_SImode:
          if (pattern352 (x8, 
E_SImode) != 0
              || !
#line 7348 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 921; /* *add.for.ccn.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_84 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pnum_clobbers == NULL
              || pattern162 (x1) != 0)
            return -1;
          x4 = XEXP (x3, 1);
          x5 = XEXP (x4, 1);
          operands[0] = x5;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          x7 = XEXP (x6, 1);
          x8 = XEXP (x7, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          *pnum_clobbers = 2;
          return 997; /* epilogue_restores */

        case 2:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != UNSPEC_VOLATILE
              || XVECLEN (x4, 0) != 1)
            return -1;
          x9 = XVECEXP (x2, 0, 0);
          operands[0] = x9;
          switch (XINT (x2, 1))
            {
            case 3:
              if (pnum_clobbers == NULL
                  || pattern267 (x1) != 0
                  || !
#line 8668 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_gasisr_prologues))
                return -1;
              *pnum_clobbers = 1;
              return 998; /* *gasisr */

            case 10:
              switch (pattern235 (x1))
                {
                case 0:
                  return 1003; /* delay_cycles_1 */

                case 1:
                  return 1005; /* delay_cycles_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L
              || pattern161 (x1) != 0
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern276 (x1))
            {
            case 0:
              if (!
#line 1471 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 169; /* *clrmemqi */

            case 1:
              if (!
#line 1505 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 171; /* *clrmemhi */

            default:
              return -1;
            }

        case DIV:
          if (pattern215 (x1, 
MOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern330 (x1))
            {
            case 0:
              return 584; /* divmodqi4 */

            case 1:
              return 590; /* divmodhi4 */

            case 2:
              return 612; /* divmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern331 (x1) != 0
              || !
#line 4319 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 608; /* *divmodpsi4_call */

        case UDIV:
          if (pattern215 (x1, 
UMOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern330 (x1))
            {
            case 0:
              return 587; /* udivmodqi4 */

            case 1:
              return 593; /* udivmodhi4 */

            case 2:
              return 615; /* udivmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern331 (x1) != 0
              || !
#line 4368 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 611; /* *udivmodpsi4_call */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (pattern138 (x1) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          x11 = XEXP (x10, 0);
          if (GET_MODE (x11) != E_HImode)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != USE
              || pattern357 (x1, 
E_CCmode, 
36) != 0)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          operands[0] = x12;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x13 = XEXP (x10, 1);
          x14 = XEXP (x13, 1);
          operands[1] = x14;
          if (!immediate_operand (operands[1], E_HImode))
            return -1;
          return 996; /* call_prologue_saves */

        case 2:
          if (XINT (x4, 1) != 10)
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x16 = XEXP (x12, 1);
          if (GET_CODE (x16) != UNSPEC_VOLATILE
              || XVECLEN (x16, 0) != 1
              || XINT (x16, 1) != 6
              || GET_MODE (x16) != E_BLKmode)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != CLOBBER
              || pattern236 (x1) != 0)
            return -1;
          switch (XWINT (x15, 0))
            {
            case 3L:
              x6 = XEXP (x3, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 36
                  || GET_MODE (x6) != E_CCmode
                  || !
#line 8832 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1008; /* *delay_cycles_3 */

            case 4L:
              x6 = XEXP (x3, 0);
              operands[5] = x6;
              if (!scratch_operand (operands[5], E_QImode))
                return -1;
              return 1009; /* delay_cycles_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern119 (x2))
        {
        case 0:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_135 (insn, operands);

        case 1:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_137 (insn, operands);

        case 2:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_141 (insn, operands);

        case 3:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_139 (insn, operands);

        case 4:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_143 (insn, operands);

        case 5:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_145 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern119 (x2))
        {
        case 0:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_136 (insn, operands);

        case 1:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_138 (insn, operands);

        case 2:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_142 (insn, operands);

        case 3:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_140 (insn, operands);

        case 4:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_144 (insn, operands);

        case 5:
          if (!(
#line 2010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2012 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_146 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_PSImode:
          if (pattern178 (x2, 
E_PSImode) != 0
              || !
#line 2072 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_148 (insn, operands);

        case E_QImode:
          if (pattern201 (x2, 
E_QImode) != 0
              || !
#line 2099 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_149 (insn, operands);

        case E_QQmode:
          if (pattern201 (x2, 
E_QQmode) != 0
              || !
#line 2099 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_150 (insn, operands);

        case E_UQQmode:
          if (pattern201 (x2, 
E_UQQmode) != 0
              || !
#line 2099 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_151 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern120 (x2))
        {
        case 0:
          if (!
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_166 (insn, operands);

        case 1:
          if (!
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_168 (insn, operands);

        case 2:
          if (!
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_170 (insn, operands);

        case 3:
          if (!
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 5:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 6:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 8:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 9:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_204 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern120 (x2))
        {
        case 0:
          if (!
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_167 (insn, operands);

        case 1:
          if (!
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_169 (insn, operands);

        case 2:
          if (!
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_171 (insn, operands);

        case 3:
          if (!
#line 2294 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_173 (insn, operands);

        case 4:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 5:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 6:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_201 (insn, operands);

        case 7:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 8:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_203 (insn, operands);

        case 9:
          if (!(
#line 2345 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2347 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_205 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      switch (pattern122 (x2))
        {
        case 0:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_238 (insn, operands);

        case 1:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_246 (insn, operands);

        case 2:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_254 (insn, operands);

        case 3:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_262 (insn, operands);

        case 4:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_240 (insn, operands);

        case 5:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_248 (insn, operands);

        case 6:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_256 (insn, operands);

        case 7:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_264 (insn, operands);

        case 8:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_242 (insn, operands);

        case 9:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_250 (insn, operands);

        case 10:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_258 (insn, operands);

        case 11:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_266 (insn, operands);

        case 12:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_244 (insn, operands);

        case 13:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_252 (insn, operands);

        case 14:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_260 (insn, operands);

        case 15:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_268 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      switch (pattern122 (x2))
        {
        case 0:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_239 (insn, operands);

        case 1:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_247 (insn, operands);

        case 2:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_255 (insn, operands);

        case 3:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_263 (insn, operands);

        case 4:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_241 (insn, operands);

        case 5:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_249 (insn, operands);

        case 6:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_257 (insn, operands);

        case 7:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_265 (insn, operands);

        case 8:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_243 (insn, operands);

        case 9:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_251 (insn, operands);

        case 10:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_259 (insn, operands);

        case 11:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_267 (insn, operands);

        case 12:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_245 (insn, operands);

        case 13:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_253 (insn, operands);

        case 14:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_261 (insn, operands);

        case 15:
          if (!
#line 2417 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_269 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pattern176 (x2) != 0
              || !register_operand (operands[2], E_QImode)
              || !(
#line 2613 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_278 (insn, operands);

        case SIGN_EXTEND:
          if (pattern199 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_283 (insn, operands);

            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_288 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (pattern199 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2727 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_284 (insn, operands);

            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2789 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2793 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_287 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern178 (x2, 
E_QImode) == 0
              && (
#line 2200 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2202 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_162 (insn, operands);
          break;

        case E_HImode:
          if (pattern178 (x2, 
E_HImode) == 0
              && (
#line 3268 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3270 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_310 (insn, operands);
          break;

        case E_QQmode:
          if (pattern178 (x2, 
E_QQmode) == 0
              && (
#line 296 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 298 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return gen_split_1805 (insn, operands);
          break;

        case E_UQQmode:
          if (pattern178 (x2, 
E_UQQmode) == 0
              && (
#line 317 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 319 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return gen_split_1806 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 16
          || GET_CODE (x5) != REG
          || REGNO (x5) != 20
          || GET_CODE (x4) != REG)
        return NULL;
      switch (pattern25 (x1, 
24))
        {
        case 0:
          if (!(
#line 468 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return NULL;
          return gen_split_1812 (insn, operands);

        case 1:
          if (!(
#line 468 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 470 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return NULL;
          return gen_split_1813 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (register_operand (operands[1], E_QImode))
            {
              res = split_3 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          if (GET_CODE (x6) != REG)
            return NULL;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG)
            return NULL;
          switch (REGNO (x6))
            {
            case 18:
              if (GET_MODE (x6) != E_HImode)
                return NULL;
              x5 = XEXP (x2, 1);
              if (GET_CODE (x5) != SIGN_EXTEND
                  || pattern238 (x5, 
E_HImode, 
E_SImode) != 0
                  || pattern184 (x1, 
E_SImode, 
22) != 0
                  || !(
#line 3770 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3772 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_337 (insn, operands);

            case 26:
              if (pattern185 (x1, 
E_SImode, 
22, 
18, 
E_HImode) != 0
                  || !(
#line 3841 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_342 (insn, operands);

            case 25:
              if (pattern185 (x1, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
                  || !(
#line 4220 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4222 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_357 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_975 (insn, operands);

        case 2:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_977 (insn, operands);

        case 3:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_981 (insn, operands);

        case 4:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_979 (insn, operands);

        case 5:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_983 (insn, operands);

        case 6:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_985 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG)
            return NULL;
          switch (pattern123 (x1))
            {
            case 0:
              if (!(
#line 3770 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3772 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_338 (insn, operands);

            case 1:
              if (!(
#line 3820 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3822 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_341 (insn, operands);

            case 2:
              if (!(
#line 3841 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3843 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_343 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_976 (insn, operands);

        case 2:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_978 (insn, operands);

        case 3:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_982 (insn, operands);

        case 4:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_980 (insn, operands);

        case 5:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_984 (insn, operands);

        case 6:
          if (!(
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10869 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_986 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTEND)
        return NULL;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != NOT)
        return NULL;
      if (GET_MODE (x7) == E_QImode)
        {
          res = split_5 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (GET_MODE (x7) != E_HImode
          || pattern151 (x1) != 0
          || !(
#line 3862 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3864 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_344 (insn, operands);

    case AND:
      switch (pattern33 (x1))
        {
        case 0:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_955 (insn, operands);

        case 1:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_959 (insn, operands);

        case 2:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_963 (insn, operands);

        case 3:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_967 (insn, operands);

        case 4:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_956 (insn, operands);

        case 5:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_960 (insn, operands);

        case 6:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_964 (insn, operands);

        case 7:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_968 (insn, operands);

        case 8:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_957 (insn, operands);

        case 9:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_961 (insn, operands);

        case 10:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_965 (insn, operands);

        case 11:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_969 (insn, operands);

        case 12:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_958 (insn, operands);

        case 13:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_962 (insn, operands);

        case 14:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_966 (insn, operands);

        case 15:
          if (!(
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10838 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_970 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern17 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern81 (x1))
        {
        case 0:
          if (
#line 6218 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_540 (insn, operands);
          break;

        case 1:
          if (
#line 6254 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_542 (insn, operands);
          break;

        case 2:
          if (
#line 6274 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_543 (insn, operands);
          break;

        case 3:
          if (
#line 6295 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_544 (insn, operands);
          break;

        case 4:
          if (
#line 6329 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_545 (insn, operands);
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern82 (x1))
            {
            case 0:
              if (!(
#line 10542 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10544 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_747 (insn, operands);

            case 1:
              if (!(
#line 10542 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10544 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_748 (insn, operands);

            case 2:
              if (!(
#line 10542 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10544 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_749 (insn, operands);

            case 3:
              if (!(
#line 10542 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10544 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_750 (insn, operands);

            default:
              return NULL;
            }

        case REG:
          if (REGNO (x3) != 18
              || GET_MODE (x3) != E_DImode
              || pattern34 (x1, 
E_DImode, 
18) != 0
              || !(
#line 421 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 423 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1903 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!
#line 6236 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_541 (insn, operands);

    case 2:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_790 (insn, operands);

    case 3:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_791 (insn, operands);

    case 4:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_792 (insn, operands);

    case 5:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_793 (insn, operands);

    case 6:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_794 (insn, operands);

    case 7:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_795 (insn, operands);

    case 8:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_796 (insn, operands);

    case 9:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_797 (insn, operands);

    case 10:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_802 (insn, operands);

    case 11:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_803 (insn, operands);

    case 12:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_804 (insn, operands);

    case 13:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_805 (insn, operands);

    case 14:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_798 (insn, operands);

    case 15:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_799 (insn, operands);

    case 16:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_800 (insn, operands);

    case 17:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_801 (insn, operands);

    case 18:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_806 (insn, operands);

    case 19:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_807 (insn, operands);

    case 20:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_808 (insn, operands);

    case 21:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_809 (insn, operands);

    case 22:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_810 (insn, operands);

    case 23:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_811 (insn, operands);

    case 24:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_812 (insn, operands);

    case 25:
      if (!(
#line 10670 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10674 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_813 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      switch (pattern86 (x1))
        {
        case 0:
          if (!(
#line 10128 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))) && 
#line 10130 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_666 (insn, operands);

        case 1:
          if (!(
#line 10504 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && ((1 << INTVAL (operands[3])) & INTVAL (operands[2])) != 0) && 
#line 10507 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_742 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern168 (x2))
        {
        case 0:
          if (
#line 10382 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_720 (insn, operands);
          break;

        case 1:
          if (
#line 10382 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_721 (insn, operands);
          break;

        case 2:
          if (
#line 10382 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_722 (insn, operands);
          break;

        case 3:
          if (
#line 10382 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_723 (insn, operands);
          break;

        case 4:
          return gen_split_724 (insn, operands);

        case 5:
          return gen_split_725 (insn, operands);

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG)
        return NULL;
      switch (pattern128 (x1))
        {
        case 0:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_730 (insn, operands);

        case 1:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_734 (insn, operands);

        case 2:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_738 (insn, operands);

        case 3:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_731 (insn, operands);

        case 4:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_735 (insn, operands);

        case 5:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_739 (insn, operands);

        case 6:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_732 (insn, operands);

        case 7:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_736 (insn, operands);

        case 8:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_740 (insn, operands);

        case 9:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_733 (insn, operands);

        case 10:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_737 (insn, operands);

        case 11:
          if (!(
#line 10481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10487 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_741 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      if (pattern87 (x1) != 0
          || !
#line 10436 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_726 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG)
        return NULL;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case MEM:
          if (pattern95 (x3) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 21
              || GET_MODE (x7) != E_QImode)
            return NULL;
          switch (pattern363 (x1))
            {
            case 0:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_47 (insn, operands);

            case 1:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_48 (insn, operands);

            case 2:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_49 (insn, operands);

            case 3:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_50 (insn, operands);

            case 4:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_51 (insn, operands);

            case 5:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_52 (insn, operands);

            case 6:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_53 (insn, operands);

            case 7:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_54 (insn, operands);

            case 8:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_55 (insn, operands);

            case 9:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_56 (insn, operands);

            case 10:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_57 (insn, operands);

            case 11:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_58 (insn, operands);

            case 12:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_59 (insn, operands);

            case 13:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_60 (insn, operands);

            case 14:
              if (!(
#line 710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 713 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x5, 0);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) == REG)
                {
                  switch (pattern255 (x1))
                    {
                    case 0:
                      if ((
#line 2432 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2434 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed)))
                        return gen_split_270 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 675 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL) && 
#line 678 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                        return gen_split_1948 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (GET_MODE (x8) != E_SImode)
                return NULL;
              switch (pattern259 (x1))
                {
                case 0:
                  if (!(
#line 3478 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_314 (insn, operands);

                case 1:
                  if (!(
#line 3478 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3480 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_315 (insn, operands);

                case 2:
                  if (!(
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_320 (insn, operands);

                case 3:
                  if (!(
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_328 (insn, operands);

                case 4:
                  if (!(
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_324 (insn, operands);

                case 5:
                  if (!(
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_332 (insn, operands);

                case 6:
                  if (!(
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_322 (insn, operands);

                case 7:
                  if (!(
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 8:
                  if (!(
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_326 (insn, operands);

                case 9:
                  if (!(
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_334 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              if (GET_CODE (x8) == REG
                  && REGNO (x8) == 24)
                {
                  res = split_30 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              operands[1] = x8;
              switch (pattern252 (x1))
                {
                case 0:
                  if (!(
#line 3398 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3400 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_312 (insn, operands);

                case 1:
                  if (!(
#line 4192 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 4194 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_356 (insn, operands);

                default:
                  return NULL;
                }

            case SIGN_EXTEND:
              if (REGNO (x7) != 26
                  || GET_MODE (x7) != E_HImode)
                return NULL;
              if (REGNO (x4) == 18)
                {
                  switch (pattern292 (x1))
                    {
                    case 0:
                      if ((
#line 3530 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3532 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_316 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 3530 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3532 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_317 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 4173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 4175 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_355 (insn, operands);
                      break;

                    case 3:
                      if ((
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_319 (insn, operands);
                      break;

                    case 4:
                      if ((
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_327 (insn, operands);
                      break;

                    case 5:
                      if ((
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_323 (insn, operands);
                      break;

                    case 6:
                      if ((
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_331 (insn, operands);
                      break;

                    case 7:
                      if ((
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_321 (insn, operands);
                      break;

                    case 8:
                      if ((
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_329 (insn, operands);
                      break;

                    case 9:
                      if ((
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_325 (insn, operands);
                      break;

                    case 10:
                      if ((
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3643 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_333 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG
                  || pattern293 (x1) != 0
                  || !(
#line 675 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL) && 
#line 678 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1947 (insn, operands);

            case NOT:
              if (pattern233 (x1) != 0
                  || !(
#line 3589 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3591 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_318 (insn, operands);

            default:
              return NULL;
            }

        case UDIV:
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != REG)
            return NULL;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG)
            return NULL;
          switch (REGNO (x8))
            {
            case 24:
              switch (pattern263 (x1))
                {
                case 0:
                  if (!
#line 3962 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_348 (insn, operands);

                case 1:
                  if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1826 (insn, operands);

                case 2:
                  if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1828 (insn, operands);

                default:
                  return NULL;
                }

            case 26:
              switch (pattern266 (x1))
                {
                case 0:
                  if (!
#line 562 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1818 (insn, operands);

                case 1:
                  if (!
#line 562 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1820 (insn, operands);

                case 2:
                  if (!
#line 562 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1822 (insn, operands);

                case 3:
                  if (!
#line 562 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1824 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case XOR:
          switch (pattern170 (x1))
            {
            case 0:
              if (!
#line 4910 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_387 (insn, operands);

            case 1:
              if (!
#line 4910 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_390 (insn, operands);

            case 2:
              if (!
#line 4910 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_393 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern170 (x1))
            {
            case 0:
              if (!
#line 4910 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_388 (insn, operands);

            case 1:
              if (!
#line 4910 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_391 (insn, operands);

            case 2:
              if (!
#line 4910 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_394 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern170 (x1))
            {
            case 0:
              if (!
#line 4910 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_389 (insn, operands);

            case 1:
              if (!
#line 4910 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_392 (insn, operands);

            case 2:
              if (!
#line 4910 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_395 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern172 (x1))
            {
            case 0:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_468 (insn, operands);

            case 1:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_471 (insn, operands);

            case 2:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return NULL;
              return gen_split_474 (insn, operands);

            case 3:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_477 (insn, operands);

            case 4:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_480 (insn, operands);

            case 5:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_483 (insn, operands);

            case 6:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_486 (insn, operands);

            case 7:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_489 (insn, operands);

            case 8:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_492 (insn, operands);

            case 9:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_495 (insn, operands);

            case 10:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_498 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern172 (x1))
            {
            case 0:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_469 (insn, operands);

            case 1:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_472 (insn, operands);

            case 2:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return NULL;
              return gen_split_475 (insn, operands);

            case 3:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_478 (insn, operands);

            case 4:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_481 (insn, operands);

            case 5:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_484 (insn, operands);

            case 6:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_487 (insn, operands);

            case 7:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_490 (insn, operands);

            case 8:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_493 (insn, operands);

            case 9:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_496 (insn, operands);

            case 10:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_499 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern172 (x1))
            {
            case 0:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_470 (insn, operands);

            case 1:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_473 (insn, operands);

            case 2:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3l (operands[2])))
                return NULL;
              return gen_split_476 (insn, operands);

            case 3:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_479 (insn, operands);

            case 4:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_482 (insn, operands);

            case 5:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_485 (insn, operands);

            case 6:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_488 (insn, operands);

            case 7:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_491 (insn, operands);

            case 8:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_494 (insn, operands);

            case 9:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_497 (insn, operands);

            case 10:
              if (!
#line 5615 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_500 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          if (pattern98 (x3, 
24, 
E_HImode) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || pattern297 (x1, 
E_QImode, 
26, 
22) != 0)
            return NULL;
          x8 = XEXP (x5, 0);
          switch (pattern341 (x8))
            {
            case 0:
              if (!
#line 9470 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_649 (insn, operands);

            case 1:
              if (!
#line 9542 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_651 (insn, operands);

            default:
              return NULL;
            }

        case DIV:
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != REG)
            return NULL;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern91 (x6, 
26, 
E_HImode) != 0)
            return NULL;
          switch (REGNO (x8))
            {
            case 26:
              if (REGNO (x10) != 22
                  || REGNO (x11) != 24)
                return NULL;
              switch (pattern264 (x1, 
E_QImode, 
21))
                {
                case 0:
                  if (!
#line 562 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1819 (insn, operands);

                case 1:
                  if (!
#line 562 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1821 (insn, operands);

                case 2:
                  if (!
#line 562 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1823 (insn, operands);

                case 3:
                  if (!
#line 562 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1825 (insn, operands);

                default:
                  return NULL;
                }

            case 24:
              if (REGNO (x10) != 18
                  || REGNO (x11) != 22)
                return NULL;
              switch (pattern261 (x1))
                {
                case 0:
                  if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1827 (insn, operands);

                case 1:
                  if (!
#line 610 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1829 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 10)
        return NULL;
      x12 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x12) != CONST_INT)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return NULL;
      x13 = XEXP (x6, 1);
      if (pattern94 (x13) != 0)
        return NULL;
      x14 = XVECEXP (x3, 0, 0);
      operands[0] = x14;
      switch (pattern234 (x1))
        {
        case 0:
          if (!
#line 8742 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_624 (insn, operands);

        case 1:
          if (!
#line 8774 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_625 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
