/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern7 (x2, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern7 (x2, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern7 (x2, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern7 (x2, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return 0;

    case SIGN_EXTEND:
      if (pattern16 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case ZERO_EXTEND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 2);
      operands[2] = x8;
      if (!const0_operand (operands[2], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode)
            return -1;
          res = pattern9 ();
          if (res >= 0)
            return res + 2; /* [2, 5] */
          return -1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x2) != E_PSImode
              || GET_MODE (x3) != E_PSImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 6; /* [6, 9] */
              return -1;

            case E_HImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 10; /* [10, 13] */
              return -1;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 14; /* [14, 17] */
              return -1;

            case E_HImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 18; /* [18, 21] */
              return -1;

            case E_PSImode:
              res = pattern9 ();
              if (res >= 0)
                return res + 22; /* [22, 25] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_PSImode
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x2, 0);
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x2, 0);
      res = pattern30 (x3);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != AND
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_UQQmode:
      return pattern58 (x1, 
E_UQQmode); /* [-1, 0] */

    case E_UHQmode:
      if (pattern58 (x1, 
E_UHQmode) != 0)
        return -1;
      return 1;

    case E_UHAmode:
      if (pattern58 (x1, 
E_UHAmode) != 0)
        return -1;
      return 2;

    case E_USAmode:
      if (pattern58 (x1, 
E_USAmode) != 0)
        return -1;
      return 3;

    case E_USQmode:
      if (pattern58 (x1, 
E_USQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern67 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (REGNO (x3) != 10)
    return -1;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || GET_MODE (x3) != E_DImode)
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DQmode
          || GET_MODE (x3) != E_DQmode)
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDQmode
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DAmode
          || GET_MODE (x3) != E_DAmode)
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDAmode
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_TAmode
          || GET_MODE (x3) != E_TAmode)
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UTAmode
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern79 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  return pattern78 (x1); /* [-1, 5] */
}

int
pattern84 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != LABEL_REF)
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != PC)
    return -1;
  x6 = XEXP (x2, 0);
  switch (GET_CODE (x6))
    {
    case NE:
    case EQ:
      operands[0] = x6;
      if (!eqne_operator (operands[0], E_VOIDmode))
        return -1;
      x7 = XEXP (x3, 0);
      operands[3] = x7;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case ZERO_EXTRACT:
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x10 = XEXP (x8, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          x11 = XEXP (x8, 0);
          switch (GET_CODE (x11))
            {
            case REG:
            case SUBREG:
              operands[1] = x11;
              if (!register_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 0;

                case E_HImode:
                  return 1;

                case E_PSImode:
                  return 2;

                case E_SImode:
                  return 3;

                case E_DImode:
                  return 4;

                default:
                  return -1;
                }

            case MEM:
              if (GET_MODE (x11) != E_QImode)
                return -1;
              x12 = XEXP (x11, 0);
              operands[1] = x12;
              switch (GET_MODE (x8))
                {
                case E_QImode:
                  return 5;

                case E_HImode:
                  return 6;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case AND:
          x11 = XEXP (x8, 0);
          operands[1] = x11;
          x9 = XEXP (x8, 1);
          operands[2] = x9;
          switch (GET_MODE (x8))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode)
                  || !single_one_operand (operands[2], E_QImode))
                return -1;
              return 7;

            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !single_one_operand (operands[2], E_HImode))
                return -1;
              return 8;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !single_one_operand (operands[2], E_PSImode))
                return -1;
              return 9;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !single_one_operand (operands[2], E_SImode))
                return -1;
              return 10;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GE:
    case LT:
      return 11;

    default:
      return -1;
    }
}

int
pattern115 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x3) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern129 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !pseudo_register_operand (operands[1], i1)
      || !pseudo_register_operand (operands[2], i1)
      || !pseudo_register_operand (operands[3], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern134 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 25
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  return pattern133 (x4); /* [-1, 1] */
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XINT (x2, 1) != 0
      || GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MINUS
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 32
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 32)
    return -1;
  return 0;
}

int
pattern145 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 25)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22)
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 24)
    return -1;
  return pattern134 (x1); /* [-1, 1] */
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  x9 = XEXP (x4, 0);
  operands[1] = x9;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern154 (x3, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern154 (x3, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern154 (x3, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern154 (x3, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!d_register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode)
        return -1;
      return 0;

    case E_QQmode:
      if (!d_register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode)
        return -1;
      return 1;

    case E_UQQmode:
      if (!d_register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern170 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 1);
  operands[1] = x9;
  x10 = XEXP (x8, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x8) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x8) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern187 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 18
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_CODE (x7) != i1
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 26
      || GET_MODE (x8) != E_HImode)
    return -1;
  x9 = XEXP (x3, 1);
  if (XWINT (x9, 0) != 16L
      || pattern150 (x1, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern193 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x5) != E_QImode
          || GET_MODE (x6) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x5) != E_HImode
          || GET_MODE (x6) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x5) != E_PSImode
          || GET_MODE (x6) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode)
          || !single_one_operand (operands[3], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern217 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  return pattern75 (x4); /* [-1, 1] */
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern226 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || GET_MODE (x5) != E_DQmode)
            return -1;
          return 0;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || GET_MODE (x5) != E_DAmode)
            return -1;
          return 1;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || GET_MODE (x5) != E_TAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || !const_operand (operands[0], E_DQmode))
            return -1;
          return 3;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || !const_operand (operands[0], E_DAmode))
            return -1;
          return 4;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || !const_operand (operands[0], E_TAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 6
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER
      || pattern236 (x1) != 0)
    return -1;
  return 0;
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_PSImode
      || !register_operand (operands[1], E_PSImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern253 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i5
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i4
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != i2)
    return -1;
  x8 = XEXP (x2, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern263 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UMOD
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_QImode)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 22
          || GET_MODE (x9) != E_QImode)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 25
          || GET_MODE (x10) != E_QImode)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      if (REGNO (x12) != 23
          || GET_MODE (x12) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      x13 = XEXP (x3, 0);
      if (GET_MODE (x13) != E_QImode)
        return -1;
      return 0;

    case 18:
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 22)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      res = pattern262 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern280 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (REGNO (x4))
    {
    case 22:
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 22)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_QQmode:
          if (GET_MODE (x3) != E_QQmode
              || GET_MODE (x4) != E_QQmode
              || GET_MODE (x7) != E_QQmode)
            return -1;
          return 0;

        case E_UQQmode:
          if (GET_MODE (x3) != E_UQQmode
              || GET_MODE (x4) != E_UQQmode
              || GET_MODE (x7) != E_UQQmode)
            return -1;
          return 1;

        case E_HQmode:
          if (GET_MODE (x3) != E_HQmode
              || GET_MODE (x4) != E_HQmode
              || GET_MODE (x7) != E_HQmode)
            return -1;
          return 2;

        case E_UHQmode:
          if (GET_MODE (x3) != E_UHQmode
              || GET_MODE (x4) != E_UHQmode
              || GET_MODE (x7) != E_UHQmode)
            return -1;
          return 3;

        case E_HAmode:
          if (GET_MODE (x3) != E_HAmode
              || GET_MODE (x4) != E_HAmode
              || GET_MODE (x7) != E_HAmode)
            return -1;
          return 4;

        case E_UHAmode:
          if (GET_MODE (x3) != E_UHAmode
              || GET_MODE (x4) != E_UHAmode
              || GET_MODE (x7) != E_UHAmode)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 18:
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 22)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 18)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_SQmode:
          if (GET_MODE (x3) != E_SQmode
              || GET_MODE (x4) != E_SQmode
              || GET_MODE (x7) != E_SQmode)
            return -1;
          return 6;

        case E_USQmode:
          if (GET_MODE (x3) != E_USQmode
              || GET_MODE (x4) != E_USQmode
              || GET_MODE (x7) != E_USQmode)
            return -1;
          return 7;

        case E_SAmode:
          if (GET_MODE (x3) != E_SAmode
              || GET_MODE (x4) != E_SAmode
              || GET_MODE (x7) != E_SAmode)
            return -1;
          return 8;

        case E_USAmode:
          if (GET_MODE (x3) != E_USAmode
              || GET_MODE (x4) != E_USAmode
              || GET_MODE (x7) != E_USAmode)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 26
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 30
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != 36
      || GET_MODE (x9) != E_CCmode)
    return -1;
  return pattern260 (x2); /* [-1, 1] */
}

int
pattern320 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!const_1_to_3_operand (operands[4], E_QImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  if (!const_1_to_3_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!pseudo_register_operand (operands[0], E_PSImode))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_PSImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!pseudo_register_operand (operands[1], E_PSImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  if (!pseudo_register_operand (operands[2], E_PSImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!pseudo_register_operand (operands[3], E_PSImode))
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != E_PSImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x9, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case GE:
      return pattern334 (x4); /* [-1, 0] */

    case LT:
      if (pattern334 (x4) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern341 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_CODE (x1))
    {
    case CTZ:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 22
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case FFS:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != REG
          || REGNO (x2) != 22
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern347 (rtx x1, machine_mode i1, unsigned int i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i2)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x8, 1);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern354 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern360 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!rtx_equal_p (x1, operands[0]))
    return -1;
  x2 = PATTERN (peep2_next_insn (1));
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != COMPARE
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  return 0;
}

int
pattern364 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (!d_register_operand (operands[0], i1)
      || !l_register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  x4 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 2)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 1);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_CODE (x2))
    {
    case XOR:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 0;

    case IOR:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 1;

    case AND:
      x10 = XEXP (x2, 1);
      operands[2] = x10;
      if (!const_operand (operands[2], i1))
        return -1;
      x11 = XEXP (x2, 0);
      if (!rtx_equal_p (x11, operands[0]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern382 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[1], i1))
    return -1;
  switch (GET_CODE (x1))
    {
    case EQ:
      return pattern375 (x1); /* [-1, 0] */

    case NE:
      if (pattern375 (x1) != 0)
        return -1;
      return 1;

    case GE:
      if (pattern375 (x1) != 0)
        return -1;
      return 2;

    case LT:
      if (pattern375 (x1) != 0)
        return -1;
      return 3;

    case GT:
      if (pattern375 (x1) != 0)
        return -1;
      return 4;

    case LE:
      if (pattern375 (x1) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

 int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QImode:
      if (pattern113 (x1, 
E_QImode) != 0)
        return -1;
      return 174; /* addqi3 */

    case E_QQmode:
      if (pattern113 (x1, 
E_QQmode) != 0)
        return -1;
      return 175; /* addqq3 */

    case E_UQQmode:
      if (pattern113 (x1, 
E_UQQmode) != 0)
        return -1;
      return 176; /* adduqq3 */

    case E_HImode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HImode)
        return -1;
      operands[1] = x2;
      if (stack_register_operand (operands[1], E_HImode))
        {
          x4 = XEXP (x3, 0);
          operands[2] = x4;
          if (stack_register_operand (operands[2], E_HImode))
            {
              x5 = XEXP (x3, 1);
              operands[0] = x5;
              if (avr_sp_immediate_operand (operands[0], E_HImode))
                return 193; /* *addhi3_sp */
            }
        }
      operands[0] = x2;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_HImode))
        return 194; /* *addhi3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_HImode))
        return -1;
      *pnum_clobbers = 1;
      return 204; /* addhi3_clobber */

    case E_HQmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_HQmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HQmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HQmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_HQmode))
        return 195; /* *addhq3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_HQmode))
        return -1;
      *pnum_clobbers = 1;
      return 205; /* addhq3_clobber */

    case E_UHQmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_UHQmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHQmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_UHQmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_UHQmode))
        return 196; /* *adduhq3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_UHQmode))
        return -1;
      *pnum_clobbers = 1;
      return 206; /* adduhq3_clobber */

    case E_HAmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_HAmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_HAmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HAmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_HAmode))
        return 197; /* *addha3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_HAmode))
        return -1;
      *pnum_clobbers = 1;
      return 207; /* addha3_clobber */

    case E_UHAmode:
      operands[0] = x2;
      if (!register_operand (operands[0], E_UHAmode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UHAmode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_UHAmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (nonmemory_or_const_operand (operands[2], E_UHAmode))
        return 198; /* *adduha3_split */
      if (pnum_clobbers == NULL
          || !const_operand (operands[2], E_UHAmode))
        return -1;
      *pnum_clobbers = 1;
      return 208; /* adduha3_clobber */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern113 (x1, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 214; /* addsi3 */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern113 (x1, 
E_SQmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 215; /* addsq3 */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern113 (x1, 
E_USQmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 216; /* addusq3 */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern113 (x1, 
E_SAmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 217; /* addsa3 */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern113 (x1, 
E_USAmode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 218; /* addusa3 */

    case E_PSImode:
      if (pnum_clobbers == NULL
          || pattern113 (x1, 
E_PSImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 270; /* addpsi3 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  switch (pattern244 (x5, pnum_clobbers))
    {
    case 0:
      if (u8_operand (operands[2], E_HImode)
          && 
#line 2989 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 522; /* *muluqihi3.uconst */
        }
      if (!s8_operand (operands[2], E_HImode)
          || !
#line 3007 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      *pnum_clobbers = 1;
      return 523; /* *muluqihi3.sconst */

    case 1:
      if (
#line 3169 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 533; /* muluqihi3 */
      if (pnum_clobbers == NULL
          || !
#line 3182 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 534; /* *muluqihi3 */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern183 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 2460 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 478; /* mulqihi3_split */
          if (pnum_clobbers == NULL
              || !
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 480; /* mulqihi3 */

        case 1:
          if (!
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 548; /* *ssmulqiqisi3 */

        case 2:
          if (!
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 556; /* *ssmulqihisi3 */

        case 3:
          if (!
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 552; /* *ssmulhiqisi3 */

        case 4:
          if (!
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 560; /* *ssmulhihisi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern183 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 2508 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 484; /* *sumulqihi3_split */
          if (pnum_clobbers == NULL
              || !
#line 2521 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 485; /* *sumulqihi3 */

        case 1:
          if (!
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 550; /* *sumulqiqisi3 */

        case 2:
          if (!
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 558; /* *sumulqihisi3 */

        case 3:
          if (!
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 554; /* *sumulhiqisi3 */

        case 4:
          if (!
#line 3641 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 562; /* *sumulhihisi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case REG:
    case SUBREG:
      if (register_operand (operands[0], E_HImode))
        {
          res = recog_13 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!pseudo_register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_MODE (x5) != E_SImode
              || !pseudo_register_or_const_int_operand (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (!pseudo_register_operand (operands[1], E_QImode)
                  || !
#line 3530 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 545; /* *mulsqisi3 */

            case E_HImode:
              if (!pseudo_register_operand (operands[1], E_HImode)
                  || !
#line 3530 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 546; /* *mulshisi3 */

            default:
              return -1;
            }

        case E_PSImode:
          if (!pseudo_register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode)
            return -1;
          x5 = XEXP (x3, 0);
          if (GET_MODE (x5) != E_PSImode
              || !pseudo_register_operand (operands[1], E_QImode)
              || !pseudo_register_or_const_int_operand (operands[2], E_PSImode)
              || !
#line 4173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 600; /* *mulsqipsi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 22:
      if (pnum_clobbers == NULL
          || pattern153 (x1, 
E_SImode, 
22) != 0
          || !
#line 6306 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed
   && optimize_size))
        return -1;
      *pnum_clobbers = 1;
      return 794; /* *negsi2.libgcc */

    case 18:
      if (pattern153 (x1, 
E_DImode, 
18) != 0)
        return -1;
      if (
#line 421 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
        return 3249; /* negdi2_insn */
      if (pnum_clobbers == NULL
          || !
#line 432 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3250; /* *negdi2_insn */

    default:
      return -1;
    }
}

 int
recog_23 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      res = recog_9 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x3) != REG)
        return -1;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != REG)
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != REG)
        return -1;
      switch (REGNO (x3))
        {
        case 24:
          if (pnum_clobbers == NULL)
            return -1;
          switch (REGNO (x4))
            {
            case 22:
              if (REGNO (x5) != 24)
                return -1;
              switch (GET_MODE (x5))
                {
                case E_QImode:
                  if (GET_MODE (x2) != E_QImode
                      || GET_MODE (x3) != E_QImode
                      || GET_MODE (x4) != E_QImode)
                    return -1;
                  if (
#line 2234 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                    {
                      *pnum_clobbers = 1;
                      return 302; /* *mulqi3_call_split */
                    }
                  if (!
#line 2247 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                    return -1;
                  *pnum_clobbers = 2;
                  return 303; /* *mulqi3_call */

                case E_HImode:
                  if (GET_MODE (x2) != E_HImode
                      || GET_MODE (x3) != E_HImode
                      || GET_MODE (x4) != E_HImode)
                    return -1;
                  if (
#line 3310 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
                    {
                      *pnum_clobbers = 2;
                      return 539; /* *mulhi3_call_split */
                    }
                  if (!
#line 3325 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
                    return -1;
                  *pnum_clobbers = 3;
                  return 540; /* *mulhi3_call */

                default:
                  return -1;
                }

            case 25:
              if (GET_MODE (x4) != E_QQmode
                  || pattern184 (x1, 
E_QQmode, 
23) != 0)
                return -1;
              if (
#line 377 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 2;
                  return 3057; /* *mulqq3.call_split */
                }
              if (!
#line 394 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 3;
              return 3058; /* *mulqq3.call */

            default:
              return -1;
            }

        case 22:
          if (pnum_clobbers == NULL
              || REGNO (x4) != 18
              || REGNO (x5) != 22)
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (GET_MODE (x2) != E_SImode
                  || GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode)
                return -1;
              if (
#line 3710 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 564; /* *mulsi3_call_split */
                }
              if (
#line 3726 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY))
                {
                  *pnum_clobbers = 3;
                  return 565; /* *mulsi3_call_pr118012_split */
                }
              if (
#line 3745 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                {
                  *pnum_clobbers = 2;
                  return 566; /* *mulsi3_call */
                }
              if (!
#line 3757 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && reload_completed))
                return -1;
              *pnum_clobbers = 4;
              return 567; /* *mulsi3_call_pr118012 */

            case E_PSImode:
              if (GET_MODE (x2) != E_PSImode
                  || GET_MODE (x3) != E_PSImode
                  || GET_MODE (x4) != E_PSImode)
                return -1;
              if (
#line 4244 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 3;
                  return 604; /* *mulpsi3.libgcc_split */
                }
              if (!
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 4;
              return 605; /* *mulpsi3.libgcc */

            default:
              return -1;
            }

        case 18:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern24 (x1, 
26))
            {
            case 0:
              if (
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3059; /* *mulhq3.call_split */
                }
              if (!
#line 440 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3063; /* *mulhq3.call */

            case 1:
              if (
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3060; /* *muluhq3.call_split */
                }
              if (!
#line 440 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3064; /* *muluhq3.call */

            case 2:
              if (
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3061; /* *mulha3.call_split */
                }
              if (!
#line 440 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3065; /* *mulha3.call */

            case 3:
              if (
#line 425 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 3062; /* *muluha3.call_split */
                }
              if (!
#line 440 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 2;
              return 3066; /* *muluha3.call */

            default:
              return -1;
            }

        case 16:
          if (REGNO (x4) != 20)
            return -1;
          switch (pattern25 (x1, 
24))
            {
            case 0:
              if (
#line 468 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return 3067; /* *mulsa3.call_split */
              if (pnum_clobbers == NULL
                  || !
#line 481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 3069; /* *mulsa3.call */

            case 1:
              if (
#line 468 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
                return 3068; /* *mulusa3.call_split */
              if (pnum_clobbers == NULL
                  || !
#line 481 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 3070; /* *mulusa3.call */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          if (pnum_clobbers != NULL)
            {
              res = recog_10 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          res = recog_12 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG)
            return -1;
          switch (pattern123 (x1))
            {
            case 0:
              if (
#line 3770 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 569; /* *umulhisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 571; /* *umulhisi3_call */

            case 1:
              if (
#line 3820 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 576; /* *usmulhisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3833 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 577; /* *usmulhisi3_call */

            case 2:
              if (
#line 3841 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 579; /* *muluhisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3854 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 581; /* *muluhisi3_call */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1434; /* *map.mul.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1436; /* *map.mul.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1440; /* *map.mul.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1438; /* *map.mul.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1442; /* *map.mul.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1444; /* *map.mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          res = recog_14 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (GET_CODE (x6) != REG)
            return -1;
          x5 = XEXP (x1, 0);
          if (GET_CODE (x5) != REG)
            return -1;
          switch (REGNO (x6))
            {
            case 18:
              x4 = XEXP (x2, 1);
              if (GET_CODE (x4) != SIGN_EXTEND)
                return -1;
              x7 = XEXP (x4, 0);
              if (GET_CODE (x7) != REG)
                return -1;
              switch (REGNO (x7))
                {
                case 26:
                  if (pattern245 (x1, 
E_SImode, 
E_HImode, 
22) != 0)
                    return -1;
                  if (
#line 3770 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                    return 568; /* *mulhisi3_call_split */
                  if (pnum_clobbers == NULL
                      || !
#line 3783 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                    return -1;
                  *pnum_clobbers = 1;
                  return 570; /* *mulhisi3_call */

                case 22:
                  if (pnum_clobbers == NULL
                      || pattern245 (x1, 
E_DImode, 
E_SImode, 
18) != 0)
                    return -1;
                  if (
#line 675 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
                    {
                      *pnum_clobbers = 2;
                      return 3337; /* mulsidi3_insn */
                    }
                  if (!
#line 693 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
                    return -1;
                  *pnum_clobbers = 3;
                  return 3339; /* *mulsidi3_insn */

                default:
                  return -1;
                }

            case 26:
              if (pattern185 (x1, 
E_SImode, 
22, 
18, 
E_HImode) != 0)
                return -1;
              if (
#line 3841 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 578; /* *mulshisi3_call_split */
              if (pnum_clobbers == NULL
                  || !
#line 3854 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 580; /* *mulshisi3_call */

            case 25:
              if (pattern185 (x1, 
E_PSImode, 
18, 
22, 
E_QImode) != 0)
                return -1;
              if (
#line 4220 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 602; /* *mulsqipsi3.libgcc_split */
              if (pnum_clobbers == NULL
                  || !
#line 4233 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 603; /* *mulsqipsi3.libgcc */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1433; /* *map.mul.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1435; /* *map.mul.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1439; /* *map.mul.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1437; /* *map.mul.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1441; /* *map.mul.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10865 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1443; /* *map.mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTEND)
        return -1;
      x8 = XEXP (x6, 0);
      if (GET_CODE (x8) != NOT)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      res = recog_15 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_MODE (x8) != E_HImode
          || pattern151 (x1) != 0)
        return -1;
      if (
#line 3862 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 582; /* *mulohisi3_call_split */
      if (pnum_clobbers == NULL
          || !
#line 3875 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 583; /* *mulohisi3_call */

    case AND:
      switch (pattern33 (x1))
        {
        case 0:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1413; /* *map.mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1417; /* *map.mul.and1-to-skip.qi */

        case 2:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1421; /* *map.mul.and1-to-skip.qi */

        case 3:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1425; /* *map.mul.and1-to-skip.qi */

        case 4:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1414; /* *map.mul.and1-to-skip.hi */

        case 5:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1418; /* *map.mul.and1-to-skip.hi */

        case 6:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1422; /* *map.mul.and1-to-skip.hi */

        case 7:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1426; /* *map.mul.and1-to-skip.hi */

        case 8:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1415; /* *map.mul.and1-to-skip.psi */

        case 9:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1419; /* *map.mul.and1-to-skip.psi */

        case 10:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1423; /* *map.mul.and1-to-skip.psi */

        case 11:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1427; /* *map.mul.and1-to-skip.psi */

        case 12:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1416; /* *map.mul.and1-to-skip.si */

        case 13:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1420; /* *map.mul.and1-to-skip.si */

        case 14:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1424; /* *map.mul.and1-to-skip.si */

        case 15:
          if (!
#line 10835 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1428; /* *map.mul.and1-to-skip.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern99 (x4, 
E_QImode) == 0
                  && 
#line 1585 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 177; /* *addqi3 */
              break;

            case E_QQmode:
              if (pattern99 (x4, 
E_QQmode) == 0
                  && 
#line 1585 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 178; /* *addqq3 */
              break;

            case E_UQQmode:
              if (pattern99 (x4, 
E_UQQmode) == 0
                  && 
#line 1585 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 179; /* *adduqq3 */
              break;

            case E_HImode:
              if (pattern296 (x4, 
E_HImode) == 0
                  && 
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 199; /* *addhi3 */
              break;

            case E_HQmode:
              if (pattern296 (x4, 
E_HQmode) == 0
                  && 
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 200; /* *addhq3 */
              break;

            case E_UHQmode:
              if (pattern296 (x4, 
E_UHQmode) == 0
                  && 
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 201; /* *adduhq3 */
              break;

            case E_HAmode:
              if (pattern296 (x4, 
E_HAmode) == 0
                  && 
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 202; /* *addha3 */
              break;

            case E_UHAmode:
              if (pattern296 (x4, 
E_UHAmode) == 0
                  && 
#line 1843 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
                return 203; /* *adduha3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern295 (x4, 
E_HImode) != 0)
            return -1;
          return 204; /* addhi3_clobber */

        case E_HQmode:
          if (pattern295 (x4, 
E_HQmode) != 0)
            return -1;
          return 205; /* addhq3_clobber */

        case E_UHQmode:
          if (pattern295 (x4, 
E_UHQmode) != 0)
            return -1;
          return 206; /* adduhq3_clobber */

        case E_HAmode:
          if (pattern295 (x4, 
E_HAmode) != 0)
            return -1;
          return 207; /* addha3_clobber */

        case E_UHAmode:
          if (pattern295 (x4, 
E_UHAmode) != 0)
            return -1;
          return 208; /* adduha3_clobber */

        case E_SImode:
          if (pattern99 (x4, 
E_SImode) != 0)
            return -1;
          return 214; /* addsi3 */

        case E_SQmode:
          if (pattern99 (x4, 
E_SQmode) != 0)
            return -1;
          return 215; /* addsq3 */

        case E_USQmode:
          if (pattern99 (x4, 
E_USQmode) != 0)
            return -1;
          return 216; /* addusq3 */

        case E_SAmode:
          if (pattern99 (x4, 
E_SAmode) != 0)
            return -1;
          return 217; /* addsa3 */

        case E_USAmode:
          if (pattern99 (x4, 
E_USAmode) != 0)
            return -1;
          return 218; /* addusa3 */

        case E_PSImode:
          if (pattern99 (x4, 
E_PSImode) != 0)
            return -1;
          return 270; /* addpsi3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern211 (x1) != 0
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 1667 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 183; /* *addhi3_zero_extend1 */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (nop_general_operand (operands[2], E_QImode))
    {
      switch (pattern224 (x1))
        {
        case 0:
          if (
#line 5982 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 746; /* *lshrqi3 */
          break;

        case 1:
          if (
#line 5982 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 747; /* *lshrqq3 */
          break;

        case 2:
          if (
#line 5982 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 748; /* *lshruqq3 */
          break;

        case 3:
          if (
#line 6010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 754; /* *lshrhi3 */
          break;

        case 4:
          if (
#line 6010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 755; /* *lshrhq3 */
          break;

        case 5:
          if (
#line 6010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 756; /* *lshruhq3 */
          break;

        case 6:
          if (
#line 6010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 757; /* *lshrha3 */
          break;

        case 7:
          if (
#line 6010 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 758; /* *lshruha3 */
          break;

        case 8:
          if (
#line 6069 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 766; /* *lshrsi3 */
          break;

        case 9:
          if (
#line 6069 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 767; /* *lshrsq3 */
          break;

        case 10:
          if (
#line 6069 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 768; /* *lshrusq3 */
          break;

        case 11:
          if (
#line 6069 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 769; /* *lshrsa3 */
          break;

        case 12:
          if (
#line 6069 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 770; /* *lshrusa3 */
          break;

        default:
          break;
        }
    }
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_PSImode:
      if (pattern103 (x3) != 0)
        return -1;
      return 759; /* lshrpsi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_SImode) != 0
          || !
#line 6160 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 776; /* *lshrsi3_const */

    case E_SQmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_SQmode) != 0
          || !
#line 6160 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 777; /* *lshrsq3_const */

    case E_USQmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_USQmode) != 0
          || !
#line 6160 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 778; /* *lshrusq3_const */

    case E_SAmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_SAmode) != 0
          || !
#line 6160 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 779; /* *lshrsa3_const */

    case E_USAmode:
      if (pnum_clobbers == NULL
          || pattern105 (x3, 
E_USAmode) != 0
          || !
#line 6160 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 780; /* *lshrusa3_const */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) == MEM)
    {
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  operands[0] = x4;
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !nox_general_operand (operands[1], E_QImode)
          || !
#line 857 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))
   && reload_completed))
        return -1;
      return 116; /* movqi_insn */

    case E_QQmode:
      if (!nonimmediate_operand (operands[0], E_QQmode)
          || !nox_general_operand (operands[1], E_QQmode)
          || !
#line 857 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode))
   && reload_completed))
        return -1;
      return 117; /* movqq_insn */

    case E_UQQmode:
      if (!nonimmediate_operand (operands[0], E_UQQmode)
          || !nox_general_operand (operands[1], E_UQQmode)
          || !
#line 857 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode))
   && reload_completed))
        return -1;
      return 118; /* movuqq_insn */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !nox_general_operand (operands[1], E_HImode)
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))
   && reload_completed))
        return -1;
      return 133; /* *movhi */

    case E_HQmode:
      if (!nonimmediate_operand (operands[0], E_HQmode)
          || !nox_general_operand (operands[1], E_HQmode)
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], HQmode)
    || reg_or_0_operand (operands[1], HQmode))
   && reload_completed))
        return -1;
      return 134; /* *movhq */

    case E_UHQmode:
      if (!nonimmediate_operand (operands[0], E_UHQmode)
          || !nox_general_operand (operands[1], E_UHQmode)
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], UHQmode)
    || reg_or_0_operand (operands[1], UHQmode))
   && reload_completed))
        return -1;
      return 135; /* *movuhq */

    case E_HAmode:
      if (!nonimmediate_operand (operands[0], E_HAmode)
          || !nox_general_operand (operands[1], E_HAmode)
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], HAmode)
    || reg_or_0_operand (operands[1], HAmode))
   && reload_completed))
        return -1;
      return 136; /* *movha */

    case E_UHAmode:
      if (!nonimmediate_operand (operands[0], E_UHAmode)
          || !nox_general_operand (operands[1], E_UHAmode)
          || !
#line 966 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], UHAmode)
    || reg_or_0_operand (operands[1], UHAmode))
   && reload_completed))
        return -1;
      return 137; /* *movuha */

    case E_PSImode:
      if (!nonimmediate_operand (operands[0], E_PSImode)
          || !nox_general_operand (operands[1], E_PSImode)
          || !
#line 1139 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], PSImode)
    || register_operand (operands[1], PSImode)
    || const0_rtx == operands[1])
   && reload_completed))
        return -1;
      return 140; /* *movpsi */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nox_general_operand (operands[1], E_SImode)
          || !
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && reload_completed))
        return -1;
      return 151; /* *movsi */

    case E_SQmode:
      if (!nonimmediate_operand (operands[0], E_SQmode)
          || !nox_general_operand (operands[1], E_SQmode)
          || !
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], SQmode)
    || reg_or_0_operand (operands[1], SQmode))
   && reload_completed))
        return -1;
      return 152; /* *movsq */

    case E_USQmode:
      if (!nonimmediate_operand (operands[0], E_USQmode)
          || !nox_general_operand (operands[1], E_USQmode)
          || !
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], USQmode)
    || reg_or_0_operand (operands[1], USQmode))
   && reload_completed))
        return -1;
      return 153; /* *movusq */

    case E_SAmode:
      if (!nonimmediate_operand (operands[0], E_SAmode)
          || !nox_general_operand (operands[1], E_SAmode)
          || !
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], SAmode)
    || reg_or_0_operand (operands[1], SAmode))
   && reload_completed))
        return -1;
      return 154; /* *movsa */

    case E_USAmode:
      if (!nonimmediate_operand (operands[0], E_USAmode)
          || !nox_general_operand (operands[1], E_USAmode)
          || !
#line 1199 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], USAmode)
    || reg_or_0_operand (operands[1], USAmode))
   && reload_completed))
        return -1;
      return 155; /* *movusa */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !nox_general_operand (operands[1], E_SFmode)
          || !
#line 1247 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && reload_completed))
        return -1;
      return 158; /* *movsf */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      if (XWINT (x6, 0) == 1L)
        {
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) == REG
              && REGNO (x9) == 36
              && GET_MODE (x9) == E_CCmode
              && 
#line 3076 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return 527; /* *ashiftqihi2.signx.1 */
        }
      x9 = XEXP (x2, 0);
      if (!scratch_operand (x9, E_QImode))
        return -1;
      operands[3] = x9;
      operands[2] = x6;
      if (const_2_to_6_operand (operands[2], E_HImode)
          && 
#line 3087 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 528; /* *ashifthi3.signx.const */
      operands[2] = x9;
      if (XWINT (x6, 0) != 7L
          || !
#line 3105 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 529; /* *ashifthi3.signx.const7 */

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (pattern213 (x1) != 0
          || !
#line 3123 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 530; /* *ashifthi3.zerox.const */

    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_47 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3309; /* *ashldi3_insn */

        case 1:
          if (!
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3313; /* *ashldq3_insn */

        case 2:
          if (!
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3317; /* *ashludq3_insn */

        case 3:
          if (!
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3321; /* *ashlda3_insn */

        case 4:
          if (!
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3325; /* *ashluda3_insn */

        case 5:
          if (!
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3329; /* *ashlta3_insn */

        case 6:
          if (!
#line 642 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3333; /* *ashluta3_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern90 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode)
          || !
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 807; /* *extendqihi2 */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!combine_pseudo_register_operand (operands[1], E_QImode)
              || !
#line 6468 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 809; /* *extendqipsi2 */

        case E_HImode:
          if (!combine_pseudo_register_operand (operands[1], E_HImode)
              || !
#line 6510 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 813; /* *extendhipsi2 */

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!combine_pseudo_register_operand (operands[1], E_QImode)
              || !
#line 6489 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 811; /* *extendqisi2 */

        case E_HImode:
          if (!combine_pseudo_register_operand (operands[1], E_HImode)
              || !
#line 6531 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 815; /* *extendhisi2 */

        case E_PSImode:
          if (!combine_pseudo_register_operand (operands[1], E_PSImode)
              || !
#line 6552 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 817; /* *extendpsisi2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_77 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 2);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  if (!scratch_operand (operands[2], E_HImode))
    return -1;
  if (
#line 7924 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL))
    return 974; /* *tablejump_split */
  if (pnum_clobbers == NULL
      || !
#line 7945 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL && reload_completed))
    return -1;
  *pnum_clobbers = 1;
  return 975; /* *tablejump */
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (pattern107 (x3) != 0)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x2, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || !const_operand (operands[1], E_QImode)
          || !
#line 876 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 119; /* *reload_inqi */

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || !const_operand (operands[1], E_QQmode)
          || !
#line 876 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 120; /* *reload_inqq */

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || !const_operand (operands[1], E_UQQmode)
          || !
#line 876 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 121; /* *reload_inuqq */

    case E_HImode:
      if (!l_register_operand (operands[0], E_HImode)
          || !immediate_operand (operands[1], E_HImode)
          || !
#line 941 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 123; /* *reload_inhi */

    case E_HQmode:
      if (!l_register_operand (operands[0], E_HQmode)
          || !immediate_operand (operands[1], E_HQmode)
          || !
#line 941 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 124; /* *reload_inhq */

    case E_UHQmode:
      if (!l_register_operand (operands[0], E_UHQmode)
          || !immediate_operand (operands[1], E_UHQmode)
          || !
#line 941 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 125; /* *reload_inuhq */

    case E_HAmode:
      if (!l_register_operand (operands[0], E_HAmode)
          || !immediate_operand (operands[1], E_HAmode)
          || !
#line 941 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 126; /* *reload_inha */

    case E_UHAmode:
      if (!l_register_operand (operands[0], E_UHAmode)
          || !immediate_operand (operands[1], E_UHAmode)
          || !
#line 941 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 127; /* *reload_inuha */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !immediate_operand (operands[1], E_PSImode)
          || !
#line 1116 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 138; /* *reload_inpsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !immediate_operand (operands[1], E_SImode)
          || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 141; /* *reload_insi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !immediate_operand (operands[1], E_SQmode)
          || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 142; /* *reload_insi */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !immediate_operand (operands[1], E_USQmode)
          || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 143; /* *reload_insi */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !immediate_operand (operands[1], E_SAmode)
          || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 144; /* *reload_insi */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !immediate_operand (operands[1], E_USAmode)
          || !
#line 1173 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 145; /* *reload_insi */

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || !const_double_operand (operands[1], E_SFmode)
          || !
#line 1274 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 159; /* *reload_insf */

    default:
      return -1;
    }
}

 int
recog_86 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x6))
    {
    case SET:
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 30
          || GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != MEM
          || GET_MODE (x9) != E_BLKmode)
        return -1;
      x10 = XEXP (x9, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 26
          || GET_MODE (x10) != E_HImode)
        return -1;
      x11 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x11) != UNSPEC
          || XVECLEN (x11, 0) != 1
          || XINT (x11, 1) != 1)
        return -1;
      x12 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x12) != USE
          || pattern357 (x1, 
E_QImode, 
0) != 0)
        return -1;
      switch (pattern373 (x1))
        {
        case 0:
          return 160; /* cpymem_qi */

        case 1:
          return 161; /* cpymem_hi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      if (pattern146 (x1, 
4) != 0)
        return -1;
      x11 = XVECEXP (x1, 0, 1);
      x13 = XEXP (x11, 1);
      if (GET_CODE (x13) != UNSPEC_VOLATILE
          || XVECLEN (x13, 0) != 1
          || XINT (x13, 1) != 6
          || GET_MODE (x13) != E_BLKmode)
        return -1;
      x12 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x12) != CLOBBER)
        return -1;
      x14 = XEXP (x5, 0);
      if (GET_CODE (x14) != REG
          || REGNO (x14) != 36
          || GET_MODE (x14) != E_CCmode
          || pattern333 (x1) != 0
          || !
#line 8877 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1010; /* *delay_cycles_4 */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_34 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 2
          || XINT (x2, 1) != 2
          || GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!stack_register_operand (operands[0], E_HImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_HImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      return 122; /* movhi_sp_r */

    case UNSPEC:
      return recog_26 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_21 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_30 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_23 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      return recog_35 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_27 (x1, insn, pnum_clobbers);

    case AND:
      return recog_33 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_24 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_25 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_32 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case ASHIFT:
          if (pattern46 (x1) != 0)
            return -1;
          return 704; /* *ashlqi.1.zextpsi_split */

        case REG:
        case SUBREG:
          switch (pattern47 (x1))
            {
            case 0:
              return 818; /* zero_extendqihi2 */

            case 1:
              return 819; /* zero_extendqipsi2 */

            case 2:
              return 821; /* zero_extendhipsi2 */

            case 3:
              return 820; /* zero_extendqisi2 */

            case 4:
              return 823; /* zero_extendhisi2 */

            case 5:
              return 824; /* zero_extendpsisi2 */

            case 6:
              return 825; /* zero_extendqidi2 */

            case 7:
              return 826; /* zero_extendhidi2 */

            case 8:
              return 827; /* zero_extendsidi2 */

            default:
              return -1;
            }

        case PARITY:
          if (pnum_clobbers != NULL
              && pattern16 (x1, 
E_QImode) == 0
              && 
#line 9150 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!reload_completed))
            {
              *pnum_clobbers = 1;
              return 1023; /* *parityqihi2.1 */
            }
          if (GET_MODE (x6) != E_QImode
              || pattern35 (x1, 
E_QImode, 
24) != 0)
            return -1;
          return 1027; /* *parityqihi2.libgcc_split */

        case POPCOUNT:
          if (GET_MODE (x6) != E_QImode
              || pattern34 (x1, 
E_HImode, 
24) != 0)
            return -1;
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          if (register_operand (operands[0], E_QImode)
              && 
#line 9272 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
            return 1031; /* *popcounthi2.split8 */
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 24
              || GET_MODE (x7) != E_QImode)
            return -1;
          return 1038; /* *popcountqihi2.libgcc */

        case ZERO_EXTRACT:
          switch (pattern48 (x1))
            {
            case 0:
              if (!
#line 10603 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
                return -1;
              return 1206; /* *extzv.qihi2 */

            case 1:
              if (!
#line 10603 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
                return -1;
              return 1207; /* *extzv.hihi2 */

            case 2:
              if (!
#line 10603 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
                return -1;
              return 1208; /* *extzv.psihi2 */

            case 3:
              if (!
#line 10603 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(! reload_completed))
                return -1;
              return 1209; /* *extzv.sihi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_29 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_28 (x1, insn, pnum_clobbers);

    case ABS:
      switch (pattern15 (x1))
        {
        case 0:
          return 781; /* absqi2 */

        case 1:
          return 783; /* abssf2 */

        default:
          return -1;
        }

    case NEG:
      return recog_31 (x1, insn, pnum_clobbers);

    case NOT:
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          switch (pattern54 (x1))
            {
            case 0:
              return 798; /* one_cmplqi2 */

            case 1:
              return 800; /* one_cmplhi2 */

            case 2:
              return 802; /* one_cmplpsi2 */

            case 3:
              return 804; /* one_cmplsi2 */

            case 4:
              x3 = XEXP (x1, 0);
              x8 = XEXP (x3, 2);
              operands[1] = x8;
              if (!const_0_to_7_operand (operands[1], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return -1;
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x9 = XEXP (x3, 0);
              switch (pattern216 (x9))
                {
                case 0:
                  return 1077; /* *insv.not.io */

                case 1:
                  return 1088; /* *insv.not-bit.0_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ROTATE:
          if (pattern55 (x1) != 0)
            return -1;
          return 1017; /* *avr.md:9016 */

        case ZERO_EXTRACT:
          if (pnum_clobbers == NULL
              || GET_MODE (x6) != E_QImode)
            return -1;
          x10 = XEXP (x6, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != ZERO_EXTRACT
              || GET_MODE (x3) != E_QImode)
            return -1;
          x11 = XEXP (x3, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x9 = XEXP (x3, 0);
          operands[0] = x9;
          if (!register_operand (operands[0], E_QImode))
            return -1;
          x8 = XEXP (x3, 2);
          operands[1] = x8;
          if (!const_0_to_7_operand (operands[1], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x12 = XEXP (x6, 2);
          operands[3] = x12;
          if (!const_0_to_7_operand (operands[3], E_QImode)
              || !
#line 10050 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 1084; /* insv_notbit */

        case LSHIFTRT:
          if (pattern56 (x1) != 0)
            return -1;
          return 1085; /* *insv.not-shiftrt_split */

        case ASHIFTRT:
          if (pattern56 (x1) != 0)
            return -1;
          return 1086; /* *insv.not-shiftrt_split */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern20 (x1))
        {
        case 0:
          return 806; /* extendqihi2 */

        case 1:
          return 808; /* extendqipsi2 */

        case 2:
          return 812; /* extendhipsi2 */

        case 3:
          return 810; /* extendqisi2 */

        case 4:
          return 814; /* extendhisi2 */

        case 5:
          return 816; /* extendpsisi2 */

        default:
          return -1;
        }

    case LO_SUM:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_PSImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_PSImode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_QImode))
        return -1;
      x13 = XEXP (x2, 1);
      operands[2] = x13;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      *pnum_clobbers = 1;
      return 822; /* n_extendhipsi2 */

    case COMPARE:
      return recog_22 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          if (ordered_comparison_operator (x6, E_VOIDmode))
            {
              res = recog_20 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x10 = XEXP (x6, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern84 (x1))
            {
            case 0:
              return 948; /* sbrx_branchqi_split */

            case 1:
              return 949; /* sbrx_branchhi_split */

            case 2:
              return 950; /* sbrx_branchpsi_split */

            case 3:
              return 951; /* sbrx_branchsi_split */

            case 4:
              return 952; /* sbrx_branchdi_split */

            case 5:
              if (low_io_address_operand (operands[1], E_VOIDmode))
                return 982; /* *sbix_branch_split */
              if (!high_io_address_operand (operands[1], E_VOIDmode))
                return -1;
              return 988; /* *sbix_branch_tmp_split */

            case 6:
              if (low_io_address_operand (operands[1], E_VOIDmode))
                return 983; /* *sbix_branch_split */
              if (!high_io_address_operand (operands[1], E_VOIDmode))
                return -1;
              return 989; /* *sbix_branch_tmp_split */

            case 7:
              return 958; /* *sbrx_and_branchqi_split */

            case 8:
              return 959; /* *sbrx_and_branchhi_split */

            case 9:
              return 960; /* *sbrx_and_branchpsi_split */

            case 10:
              return 961; /* *sbrx_and_branchsi_split */

            case 11:
              operands[0] = x6;
              if (gelt_operator (operands[0], E_VOIDmode))
                {
                  x7 = XEXP (x6, 0);
                  if (GET_CODE (x7) == MEM
                      && GET_MODE (x7) == E_QImode)
                    {
                      x14 = XEXP (x7, 0);
                      operands[1] = x14;
                      x13 = XEXP (x2, 1);
                      x15 = XEXP (x13, 0);
                      operands[2] = x15;
                      if (low_io_address_operand (operands[1], E_VOIDmode))
                        return 986; /* *sbix_branch_bit7_split */
                      if (high_io_address_operand (operands[1], E_VOIDmode))
                        return 992; /* *sbix_branch_tmp_bit7_split */
                    }
                }
              if (GET_CODE (x6) != GE)
                return -1;
              x7 = XEXP (x6, 0);
              operands[0] = x7;
              if (!register_operand (operands[0], E_QImode))
                return -1;
              x13 = XEXP (x2, 1);
              x15 = XEXP (x13, 0);
              operands[1] = x15;
              return 1020; /* *flash_segment1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ROTATERT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_QImode)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != CONST_INT
          || XWINT (x6, 0) != -128L)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x13 = XEXP (x2, 1);
      operands[1] = x13;
      if (!register_operand (operands[1], E_QImode)
          || !
#line 9004 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 1016; /* *mask1_0x80 */

    case PARITY:
      if (pnum_clobbers != NULL
          && GET_MODE (x2) == E_HImode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x6 = XEXP (x2, 0);
              operands[1] = x6;
              switch (GET_MODE (operands[1]))
                {
                case E_HImode:
                  if (register_operand (operands[1], E_HImode)
                      && 
#line 9135 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!reload_completed))
                    {
                      *pnum_clobbers = 1;
                      return 1022; /* *parityhi2 */
                    }
                  break;

                case E_QImode:
                  if (register_operand (operands[1], E_QImode)
                      && 
#line 9164 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(!reload_completed))
                    {
                      *pnum_clobbers = 1;
                      return 1024; /* *parityqihi2.2 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (GET_MODE (x2) != E_HImode
          || pattern57 (x1, 
24, 
E_HImode) != 0)
        return -1;
      return 1025; /* *parityhi2.libgcc_split */

    case POPCOUNT:
      switch (pattern22 (x1))
        {
        case 0:
          return 1032; /* *popcounthi2.libgcc_split */

        case 1:
          return 1036; /* *popcountqi2.libgcc_split */

        default:
          return -1;
        }

    case CLZ:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_HImode
          || pattern57 (x1, 
24, 
E_HImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 1039; /* *clzhi2.libgcc_split */

    case CTZ:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_HImode
          || pattern57 (x1, 
24, 
E_HImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 1043; /* *ctzhi2.libgcc_split */

    case FFS:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_HImode
          || pattern57 (x1, 
24, 
E_HImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 1047; /* *ffshi2.libgcc_split */

    case COPYSIGN:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      x13 = XEXP (x2, 1);
      operands[2] = x13;
      if (!nonmemory_operand (operands[2], E_SFmode))
        return -1;
      return 1051; /* copysignsf3 */

    case BSWAP:
      if (GET_MODE (x2) != E_SImode
          || pattern57 (x1, 
22, 
E_SImode) != 0)
        return -1;
      return 1052; /* *bswapsi2.libgcc_split */

    case SIGN_EXTRACT:
      x13 = XEXP (x2, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x2, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          x3 = XEXP (x1, 0);
          switch (GET_CODE (x3))
            {
            case ZERO_EXTRACT:
              if (pattern126 (x1) != 0)
                return -1;
              return 1080; /* *insv.extract */

            case REG:
            case SUBREG:
              operands[0] = x3;
              operands[1] = x6;
              switch (pattern167 (x2))
                {
                case 0:
                  return 1216; /* *sextr.qi.qi_split */

                case 1:
                  return 1220; /* *sextr.qi.hi_split */

                case 2:
                  return 1224; /* *sextr.qi.psi_split */

                case 3:
                  return 1228; /* *sextr.qi.si_split */

                case 4:
                  return 1217; /* *sextr.hi.qi_split */

                case 5:
                  return 1221; /* *sextr.hi.hi_split */

                case 6:
                  return 1225; /* *sextr.hi.psi_split */

                case 7:
                  return 1229; /* *sextr.hi.si_split */

                case 8:
                  return 1218; /* *sextr.psi.qi_split */

                case 9:
                  return 1222; /* *sextr.psi.hi_split */

                case 10:
                  return 1226; /* *sextr.psi.psi_split */

                case 11:
                  return 1230; /* *sextr.psi.si_split */

                case 12:
                  return 1219; /* *sextr.si.qi_split */

                case 13:
                  return 1223; /* *sextr.si.hi_split */

                case 14:
                  return 1227; /* *sextr.si.psi_split */

                case 15:
                  return 1231; /* *sextr.si.si_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case XOR:
          if (pattern85 (x1) != 0
              || !
#line 10128 "../../gcc-15.0.1-20250313/gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))))
            return -1;
          return 1090; /* *insv.xor-extract_split */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      return recog_36 (x1, insn, pnum_clobbers);

    case GE:
      if (GET_MODE (x2) != E_QImode)
        return -1;
      x13 = XEXP (x2, 1);
      if (x13 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && pattern88 (x1) == 0)
        return 1089; /* *insv.not-bit.7_split */
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern89 (x2))
        {
        case 0:
          return 1173; /* *extzvqi.ge */

        case 1:
          return 1174; /* *extzvhi.ge */

        case 2:
          return 1175; /* *extzvpsi.ge */

        case 3:
          return 1176; /* *extzvsi.ge */

        default:
          return -1;
        }

    case FRACT_CONVERT:
      switch (pattern23 (x1))
        {
        case 0:
          return 1473; /* fractuqqqq2 */

        case 1:
          return 1474; /* fracthqqq2 */

        case 2:
          return 1475; /* fractuhqqq2 */

        case 3:
          return 1476; /* fracthaqq2 */

        case 4:
          return 1477; /* fractuhaqq2 */

        case 5:
          return 1478; /* fractsqqq2 */

        case 6:
          return 1479; /* fractusqqq2 */

        case 7:
          return 1480; /* fractsaqq2 */

        case 8:
          return 1481; /* fractusaqq2 */

        case 9:
          return 1482; /* fractdqqq2 */

        case 10:
          return 1483; /* fractudqqq2 */

        case 11:
          return 1484; /* fractdaqq2 */

        case 12:
          return 1485; /* fractudaqq2 */

        case 13:
          return 1486; /* fracttaqq2 */

        case 14:
          return 1487; /* fractutaqq2 */

        case 15:
          return 1488; /* fractqiqq2 */

        case 16:
          return 1489; /* fracthiqq2 */

        case 17:
          return 1490; /* fractsiqq2 */

        case 18:
          return 1491; /* fractdiqq2 */

        case 19:
          return 1492; /* fractqquqq2 */

        case 20:
          return 1493; /* fracthquqq2 */

        case 21:
          return 1494; /* fractuhquqq2 */

        case 22:
          return 1495; /* fracthauqq2 */

        case 23:
          return 1496; /* fractuhauqq2 */

        case 24:
          return 1497; /* fractsquqq2 */

        case 25:
          return 1498; /* fractusquqq2 */

        case 26:
          return 1499; /* fractsauqq2 */

        case 27:
          return 1500; /* fractusauqq2 */

        case 28:
          return 1501; /* fractdquqq2 */

        case 29:
          return 1502; /* fractudquqq2 */

        case 30:
          return 1503; /* fractdauqq2 */

        case 31:
          return 1504; /* fractudauqq2 */

        case 32:
          return 1505; /* fracttauqq2 */

        case 33:
          return 1506; /* fractutauqq2 */

        case 34:
          return 1507; /* fractqiuqq2 */

        case 35:
          return 1508; /* fracthiuqq2 */

        case 36:
          return 1509; /* fractsiuqq2 */

        case 37:
          return 1510; /* fractdiuqq2 */

        case 38:
          return 1511; /* fractqqhq2 */

        case 39:
          return 1512; /* fractuqqhq2 */

        case 40:
          return 1513; /* fractuhqhq2 */

        case 41:
          return 1514; /* fracthahq2 */

        case 42:
          return 1515; /* fractuhahq2 */

        case 43:
          return 1516; /* fractsqhq2 */

        case 44:
          return 1517; /* fractusqhq2 */

        case 45:
          return 1518; /* fractsahq2 */

        case 46:
          return 1519; /* fractusahq2 */

        case 47:
          return 1520; /* fractdqhq2 */

        case 48:
          return 1521; /* fractudqhq2 */

        case 49:
          return 1522; /* fractdahq2 */

        case 50:
          return 1523; /* fractudahq2 */

        case 51:
          return 1524; /* fracttahq2 */

        case 52:
          return 1525; /* fractutahq2 */

        case 53:
          return 1526; /* fractqihq2 */

        case 54:
          return 1527; /* fracthihq2 */

        case 55:
          return 1528; /* fractsihq2 */

        case 56:
          return 1529; /* fractdihq2 */

        case 57:
          return 1530; /* fractqquhq2 */

        case 58:
          return 1531; /* fractuqquhq2 */

        case 59:
          return 1532; /* fracthquhq2 */

        case 60:
          return 1533; /* fracthauhq2 */

        case 61:
          return 1534; /* fractuhauhq2 */

        case 62:
          return 1535; /* fractsquhq2 */

        case 63:
          return 1536; /* fractusquhq2 */

        case 64:
          return 1537; /* fractsauhq2 */

        case 65:
          return 1538; /* fractusauhq2 */

        case 66:
          return 1539; /* fractdquhq2 */

        case 67:
          return 1540; /* fractudquhq2 */

        case 68:
          return 1541; /* fractdauhq2 */

        case 69:
          return 1542; /* fractudauhq2 */

        case 70:
          return 1543; /* fracttauhq2 */

        case 71:
          return 1544; /* fractutauhq2 */

        case 72:
          return 1545; /* fractqiuhq2 */

        case 73:
          return 1546; /* fracthiuhq2 */

        case 74:
          return 1547; /* fractsiuhq2 */

        case 75:
          return 1548; /* fractdiuhq2 */

        case 76:
          return 1549; /* fractqqha2 */

        case 77:
          return 1550; /* fractuqqha2 */

        case 78:
          return 1551; /* fracthqha2 */

        case 79:
          return 1552; /* fractuhqha2 */

        case 80:
          return 1553; /* fractuhaha2 */

        case 81:
          return 1554; /* fractsqha2 */

        case 82:
          return 1555; /* fractusqha2 */

        case 83:
          return 1556; /* fractsaha2 */

        case 84:
          return 1557; /* fractusaha2 */

        case 85:
          return 1558; /* fractdqha2 */

        case 86:
          return 1559; /* fractudqha2 */

        case 87:
          return 1560; /* fractdaha2 */

        case 88:
          return 1561; /* fractudaha2 */

        case 89:
          return 1562; /* fracttaha2 */

        case 90:
          return 1563; /* fractutaha2 */

        case 91:
          return 1564; /* fractqiha2 */

        case 92:
          return 1565; /* fracthiha2 */

        case 93:
          return 1566; /* fractsiha2 */

        case 94:
          return 1567; /* fractdiha2 */

        case 95:
          return 1568; /* fractqquha2 */

        case 96:
          return 1569; /* fractuqquha2 */

        case 97:
          return 1570; /* fracthquha2 */

        case 98:
          return 1571; /* fractuhquha2 */

        case 99:
          return 1572; /* fracthauha2 */

        case 100:
          return 1573; /* fractsquha2 */

        case 101:
          return 1574; /* fractusquha2 */

        case 102:
          return 1575; /* fractsauha2 */

        case 103:
          return 1576; /* fractusauha2 */

        case 104:
          return 1577; /* fractdquha2 */

        case 105:
          return 1578; /* fractudquha2 */

        case 106:
          return 1579; /* fractdauha2 */

        case 107:
          return 1580; /* fractudauha2 */

        case 108:
          return 1581; /* fracttauha2 */

        case 109:
          return 1582; /* fractutauha2 */

        case 110:
          return 1583; /* fractqiuha2 */

        case 111:
          return 1584; /* fracthiuha2 */

        case 112:
          return 1585; /* fractsiuha2 */

        case 113:
          return 1586; /* fractdiuha2 */

        case 114:
          return 1587; /* fractqqsq2 */

        case 115:
          return 1588; /* fractuqqsq2 */

        case 116:
          return 1589; /* fracthqsq2 */

        case 117:
          return 1590; /* fractuhqsq2 */

        case 118:
          return 1591; /* fracthasq2 */

        case 119:
          return 1592; /* fractuhasq2 */

        case 120:
          return 1593; /* fractusqsq2 */

        case 121:
          return 1594; /* fractsasq2 */

        case 122:
          return 1595; /* fractusasq2 */

        case 123:
          return 1596; /* fractdqsq2 */

        case 124:
          return 1597; /* fractudqsq2 */

        case 125:
          return 1598; /* fractdasq2 */

        case 126:
          return 1599; /* fractudasq2 */

        case 127:
          return 1600; /* fracttasq2 */

        case 128:
          return 1601; /* fractutasq2 */

        case 129:
          return 1602; /* fractqisq2 */

        case 130:
          return 1603; /* fracthisq2 */

        case 131:
          return 1604; /* fractsisq2 */

        case 132:
          return 1605; /* fractdisq2 */

        case 133:
          return 1606; /* fractqqusq2 */

        case 134:
          return 1607; /* fractuqqusq2 */

        case 135:
          return 1608; /* fracthqusq2 */

        case 136:
          return 1609; /* fractuhqusq2 */

        case 137:
          return 1610; /* fracthausq2 */

        case 138:
          return 1611; /* fractuhausq2 */

        case 139:
          return 1612; /* fractsqusq2 */

        case 140:
          return 1613; /* fractsausq2 */

        case 141:
          return 1614; /* fractusausq2 */

        case 142:
          return 1615; /* fractdqusq2 */

        case 143:
          return 1616; /* fractudqusq2 */

        case 144:
          return 1617; /* fractdausq2 */

        case 145:
          return 1618; /* fractudausq2 */

        case 146:
          return 1619; /* fracttausq2 */

        case 147:
          return 1620; /* fractutausq2 */

        case 148:
          return 1621; /* fractqiusq2 */

        case 149:
          return 1622; /* fracthiusq2 */

        case 150:
          return 1623; /* fractsiusq2 */

        case 151:
          return 1624; /* fractdiusq2 */

        case 152:
          return 1625; /* fractqqsa2 */

        case 153:
          return 1626; /* fractuqqsa2 */

        case 154:
          return 1627; /* fracthqsa2 */

        case 155:
          return 1628; /* fractuhqsa2 */

        case 156:
          return 1629; /* fracthasa2 */

        case 157:
          return 1630; /* fractuhasa2 */

        case 158:
          return 1631; /* fractsqsa2 */

        case 159:
          return 1632; /* fractusqsa2 */

        case 160:
          return 1633; /* fractusasa2 */

        case 161:
          return 1634; /* fractdqsa2 */

        case 162:
          return 1635; /* fractudqsa2 */

        case 163:
          return 1636; /* fractdasa2 */

        case 164:
          return 1637; /* fractudasa2 */

        case 165:
          return 1638; /* fracttasa2 */

        case 166:
          return 1639; /* fractutasa2 */

        case 167:
          return 1640; /* fractqisa2 */

        case 168:
          return 1641; /* fracthisa2 */

        case 169:
          return 1642; /* fractsisa2 */

        case 170:
          return 1643; /* fractdisa2 */

        case 171:
          return 1644; /* fractqqusa2 */

        case 172:
          return 1645; /* fractuqqusa2 */

        case 173:
          return 1646; /* fracthqusa2 */

        case 174:
          return 1647; /* fractuhqusa2 */

        case 175:
          return 1648; /* fracthausa2 */

        case 176:
          return 1649; /* fractuhausa2 */

        case 177:
          return 1650; /* fractsqusa2 */

        case 178:
          return 1651; /* fractusqusa2 */

        case 179:
          return 1652; /* fractsausa2 */

        case 180:
          return 1653; /* fractdqusa2 */

        case 181:
          return 1654; /* fractudqusa2 */

        case 182:
          return 1655; /* fractdausa2 */

        case 183:
          return 1656; /* fractudausa2 */

        case 184:
          return 1657; /* fracttausa2 */

        case 185:
          return 1658; /* fractutausa2 */

        case 186:
          return 1659; /* fractqiusa2 */

        case 187:
          return 1660; /* fracthiusa2 */

        case 188:
          return 1661; /* fractsiusa2 */

        case 189:
          return 1662; /* fractdiusa2 */

        case 190:
          return 1663; /* fractqqdq2 */

        case 191:
          return 1664; /* fractuqqdq2 */

        case 192:
          return 1665; /* fracthqdq2 */

        case 193:
          return 1666; /* fractuhqdq2 */

        case 194:
          return 1667; /* fracthadq2 */

        case 195:
          return 1668; /* fractuhadq2 */

        case 196:
          return 1669; /* fractsqdq2 */

        case 197:
          return 1670; /* fractusqdq2 */

        case 198:
          return 1671; /* fractsadq2 */

        case 199:
          return 1672; /* fractusadq2 */

        case 200:
          return 1673; /* fractudqdq2 */

        case 201:
          return 1674; /* fractdadq2 */

        case 202:
          return 1675; /* fractudadq2 */

        case 203:
          return 1676; /* fracttadq2 */

        case 204:
          return 1677; /* fractutadq2 */

        case 205:
          return 1678; /* fractqidq2 */

        case 206:
          return 1679; /* fracthidq2 */

        case 207:
          return 1680; /* fractsidq2 */

        case 208:
          return 1681; /* fractdidq2 */

        case 209:
          return 1682; /* fractqqudq2 */

        case 210:
          return 1683; /* fractuqqudq2 */

        case 211:
          return 1684; /* fracthqudq2 */

        case 212:
          return 1685; /* fractuhqudq2 */

        case 213:
          return 1686; /* fracthaudq2 */

        case 214:
          return 1687; /* fractuhaudq2 */

        case 215:
          return 1688; /* fractsqudq2 */

        case 216:
          return 1689; /* fractusqudq2 */

        case 217:
          return 1690; /* fractsaudq2 */

        case 218:
          return 1691; /* fractusaudq2 */

        case 219:
          return 1692; /* fractdqudq2 */

        case 220:
          return 1693; /* fractdaudq2 */

        case 221:
          return 1694; /* fractudaudq2 */

        case 222:
          return 1695; /* fracttaudq2 */

        case 223:
          return 1696; /* fractutaudq2 */

        case 224:
          return 1697; /* fractqiudq2 */

        case 225:
          return 1698; /* fracthiudq2 */

        case 226:
          return 1699; /* fractsiudq2 */

        case 227:
          return 1700; /* fractdiudq2 */

        case 228:
          return 1701; /* fractqqda2 */

        case 229:
          return 1702; /* fractuqqda2 */

        case 230:
          return 1703; /* fracthqda2 */

        case 231:
          return 1704; /* fractuhqda2 */

        case 232:
          return 1705; /* fracthada2 */

        case 233:
          return 1706; /* fractuhada2 */

        case 234:
          return 1707; /* fractsqda2 */

        case 235:
          return 1708; /* fractusqda2 */

        case 236:
          return 1709; /* fractsada2 */

        case 237:
          return 1710; /* fractusada2 */

        case 238:
          return 1711; /* fractdqda2 */

        case 239:
          return 1712; /* fractudqda2 */

        case 240:
          return 1713; /* fractudada2 */

        case 241:
          return 1714; /* fracttada2 */

        case 242:
          return 1715; /* fractutada2 */

        case 243:
          return 1716; /* fractqida2 */

        case 244:
          return 1717; /* fracthida2 */

        case 245:
          return 1718; /* fractsida2 */

        case 246:
          return 1719; /* fractdida2 */

        case 247:
          return 1720; /* fractqquda2 */

        case 248:
          return 1721; /* fractuqquda2 */

        case 249:
          return 1722; /* fracthquda2 */

        case 250:
          return 1723; /* fractuhquda2 */

        case 251:
          return 1724; /* fracthauda2 */

        case 252:
          return 1725; /* fractuhauda2 */

        case 253:
          return 1726; /* fractsquda2 */

        case 254:
          return 1727; /* fractusquda2 */

        case 255:
          return 1728; /* fractsauda2 */

        case 256:
          return 1729; /* fractusauda2 */

        case 257:
          return 1730; /* fractdquda2 */

        case 258:
          return 1731; /* fractudquda2 */

        case 259:
          return 1732; /* fractdauda2 */

        case 260:
          return 1733; /* fracttauda2 */

        case 261:
          return 1734; /* fractutauda2 */

        case 262:
          return 1735; /* fractqiuda2 */

        case 263:
          return 1736; /* fracthiuda2 */

        case 264:
          return 1737; /* fractsiuda2 */

        case 265:
          return 1738; /* fractdiuda2 */

        case 266:
          return 1739; /* fractqqta2 */

        case 267:
          return 1740; /* fractuqqta2 */

        case 268:
          return 1741; /* fracthqta2 */

        case 269:
          return 1742; /* fractuhqta2 */

        case 270:
          return 1743; /* fracthata2 */

        case 271:
          return 1744; /* fractuhata2 */

        case 272:
          return 1745; /* fractsqta2 */

        case 273:
          return 1746; /* fractusqta2 */

        case 274:
          return 1747; /* fractsata2 */

        case 275:
          return 1748; /* fractusata2 */

        case 276:
          return 1749; /* fractdqta2 */

        case 277:
          return 1750; /* fractudqta2 */

        case 278:
          return 1751; /* fractdata2 */

        case 279:
          return 1752; /* fractudata2 */

        case 280:
          return 1753; /* fractutata2 */

        case 281:
          return 1754; /* fractqita2 */

        case 282:
          return 1755; /* fracthita2 */

        case 283:
          return 1756; /* fractsita2 */

        case 284:
          return 1757; /* fractdita2 */

        case 285:
          return 1758; /* fractqquta2 */

        case 286:
          return 1759; /* fractuqquta2 */

        case 287:
          return 1760; /* fracthquta2 */

        case 288:
          return 1761; /* fractuhquta2 */

        case 289:
          return 1762; /* fracthauta2 */

        case 290:
          return 1763; /* fractuhauta2 */

        case 291:
          return 1764; /* fractsquta2 */

        case 292:
          return 1765; /* fractusquta2 */

        case 293:
          return 1766; /* fractsauta2 */

        case 294:
          return 1767; /* fractusauta2 */

        case 295:
          return 1768; /* fractdquta2 */

        case 296:
          return 1769; /* fractudquta2 */

        case 297:
          return 1770; /* fractdauta2 */

        case 298:
          return 1771; /* fractudauta2 */

        case 299:
          return 1772; /* fracttauta2 */

        case 300:
          return 1773; /* fractqiuta2 */

        case 301:
          return 1774; /* fracthiuta2 */

        case 302:
          return 1775; /* fractsiuta2 */

        case 303:
          return 1776; /* fractdiuta2 */

        case 304:
          return 1777; /* fractqqqi2 */

        case 305:
          return 1778; /* fractuqqqi2 */

        case 306:
          return 1779; /* fracthqqi2 */

        case 307:
          return 1780; /* fractuhqqi2 */

        case 308:
          return 1781; /* fracthaqi2 */

        case 309:
          return 1782; /* fractuhaqi2 */

        case 310:
          return 1783; /* fractsqqi2 */

        case 311:
          return 1784; /* fractusqqi2 */

        case 312:
          return 1785; /* fractsaqi2 */

        case 313:
          return 1786; /* fractusaqi2 */

        case 314:
          return 1787; /* fractdqqi2 */

        case 315:
          return 1788; /* fractudqqi2 */

        case 316:
          return 1789; /* fractdaqi2 */

        case 317:
          return 1790; /* fractudaqi2 */

        case 318:
          return 1791; /* fracttaqi2 */

        case 319:
          return 1792; /* fractutaqi2 */

        case 320:
          return 1793; /* fracthiqi2 */

        case 321:
          return 1794; /* fractsiqi2 */

        case 322:
          return 1795; /* fractdiqi2 */

        case 323:
          return 1796; /* fractqqhi2 */

        case 324:
          return 1797; /* fractuqqhi2 */

        case 325:
          return 1798; /* fracthqhi2 */

        case 326:
          return 1799; /* fractuhqhi2 */

        case 327:
          return 1800; /* fracthahi2 */

        case 328:
          return 1801; /* fractuhahi2 */

        case 329:
          return 1802; /* fractsqhi2 */

        case 330:
          return 1803; /* fractusqhi2 */

        case 331:
          return 1804; /* fractsahi2 */

        case 332:
          return 1805; /* fractusahi2 */

        case 333:
          return 1806; /* fractdqhi2 */

        case 334:
          return 1807; /* fractudqhi2 */

        case 335:
          return 1808; /* fractdahi2 */

        case 336:
          return 1809; /* fractudahi2 */

        case 337:
          return 1810; /* fracttahi2 */

        case 338:
          return 1811; /* fractutahi2 */

        case 339:
          return 1812; /* fractqihi2 */

        case 340:
          return 1813; /* fractsihi2 */

        case 341:
          return 1814; /* fractdihi2 */

        case 342:
          return 1815; /* fractqqsi2 */

        case 343:
          return 1816; /* fractuqqsi2 */

        case 344:
          return 1817; /* fracthqsi2 */

        case 345:
          return 1818; /* fractuhqsi2 */

        case 346:
          return 1819; /* fracthasi2 */

        case 347:
          return 1820; /* fractuhasi2 */

        case 348:
          return 1821; /* fractsqsi2 */

        case 349:
          return 1822; /* fractusqsi2 */

        case 350:
          return 1823; /* fractsasi2 */

        case 351:
          return 1824; /* fractusasi2 */

        case 352:
          return 1825; /* fractdqsi2 */

        case 353:
          return 1826; /* fractudqsi2 */

        case 354:
          return 1827; /* fractdasi2 */

        case 355:
          return 1828; /* fractudasi2 */

        case 356:
          return 1829; /* fracttasi2 */

        case 357:
          return 1830; /* fractutasi2 */

        case 358:
          return 1831; /* fractqisi2 */

        case 359:
          return 1832; /* fracthisi2 */

        case 360:
          return 1833; /* fractdisi2 */

        case 361:
          return 1834; /* fractqqdi2 */

        case 362:
          return 1835; /* fractuqqdi2 */

        case 363:
          return 1836; /* fracthqdi2 */

        case 364:
          return 1837; /* fractuhqdi2 */

        case 365:
          return 1838; /* fracthadi2 */

        case 366:
          return 1839; /* fractuhadi2 */

        case 367:
          return 1840; /* fractsqdi2 */

        case 368:
          return 1841; /* fractusqdi2 */

        case 369:
          return 1842; /* fractsadi2 */

        case 370:
          return 1843; /* fractusadi2 */

        case 371:
          return 1844; /* fractdqdi2 */

        case 372:
          return 1845; /* fractudqdi2 */

        case 373:
          return 1846; /* fractdadi2 */

        case 374:
          return 1847; /* fractudadi2 */

        case 375:
          return 1848; /* fracttadi2 */

        case 376:
          return 1849; /* fractutadi2 */

        case 377:
          return 1850; /* fractqidi2 */

        case 378:
          return 1851; /* fracthidi2 */

        case 379:
          return 1852; /* fractsidi2 */

        default:
          return -1;
        }

    case UNSIGNED_FRACT_CONVERT:
      switch (pattern23 (x1))
        {
        case 0:
          return 2233; /* fractunsuqqqq2 */

        case 1:
          return 2234; /* fractunshqqq2 */

        case 2:
          return 2235; /* fractunsuhqqq2 */

        case 3:
          return 2236; /* fractunshaqq2 */

        case 4:
          return 2237; /* fractunsuhaqq2 */

        case 5:
          return 2238; /* fractunssqqq2 */

        case 6:
          return 2239; /* fractunsusqqq2 */

        case 7:
          return 2240; /* fractunssaqq2 */

        case 8:
          return 2241; /* fractunsusaqq2 */

        case 9:
          return 2242; /* fractunsdqqq2 */

        case 10:
          return 2243; /* fractunsudqqq2 */

        case 11:
          return 2244; /* fractunsdaqq2 */

        case 12:
          return 2245; /* fractunsudaqq2 */

        case 13:
          return 2246; /* fractunstaqq2 */

        case 14:
          return 2247; /* fractunsutaqq2 */

        case 15:
          return 2248; /* fractunsqiqq2 */

        case 16:
          return 2249; /* fractunshiqq2 */

        case 17:
          return 2250; /* fractunssiqq2 */

        case 18:
          return 2251; /* fractunsdiqq2 */

        case 19:
          return 2252; /* fractunsqquqq2 */

        case 20:
          return 2253; /* fractunshquqq2 */

        case 21:
          return 2254; /* fractunsuhquqq2 */

        case 22:
          return 2255; /* fractunshauqq2 */

        case 23:
          return 2256; /* fractunsuhauqq2 */

        case 24:
          return 2257; /* fractunssquqq2 */

        case 25:
          return 2258; /* fractunsusquqq2 */

        case 26:
          return 2259; /* fractunssauqq2 */

        case 27:
          return 2260; /* fractunsusauqq2 */

        case 28:
          return 2261; /* fractunsdquqq2 */

        case 29:
          return 2262; /* fractunsudquqq2 */

        case 30:
          return 2263; /* fractunsdauqq2 */

        case 31:
          return 2264; /* fractunsudauqq2 */

        case 32:
          return 2265; /* fractunstauqq2 */

        case 33:
          return 2266; /* fractunsutauqq2 */

        case 34:
          return 2267; /* fractunsqiuqq2 */

        case 35:
          return 2268; /* fractunshiuqq2 */

        case 36:
          return 2269; /* fractunssiuqq2 */

        case 37:
          return 2270; /* fractunsdiuqq2 */

        case 38:
          return 2271; /* fractunsqqhq2 */

        case 39:
          return 2272; /* fractunsuqqhq2 */

        case 40:
          return 2273; /* fractunsuhqhq2 */

        case 41:
          return 2274; /* fractunshahq2 */

        case 42:
          return 2275; /* fractunsuhahq2 */

        case 43:
          return 2276; /* fractunssqhq2 */

        case 44:
          return 2277; /* fractunsusqhq2 */

        case 45:
          return 2278; /* fractunssahq2 */

        case 46:
          return 2279; /* fractunsusahq2 */

        case 47:
          return 2280; /* fractunsdqhq2 */

        case 48:
          return 2281; /* fractunsudqhq2 */

        case 49:
          return 2282; /* fractunsdahq2 */

        case 50:
          return 2283; /* fractunsudahq2 */

        case 51:
          return 2284; /* fractunstahq2 */

        case 52:
          return 2285; /* fractunsutahq2 */

        case 53:
          return 2286; /* fractunsqihq2 */

        case 54:
          return 2287; /* fractunshihq2 */

        case 55:
          return 2288; /* fractunssihq2 */

        case 56:
          return 2289; /* fractunsdihq2 */

        case 57:
          return 2290; /* fractunsqquhq2 */

        case 58:
          return 2291; /* fractunsuqquhq2 */

        case 59:
          return 2292; /* fractunshquhq2 */

        case 60:
          return 2293; /* fractunshauhq2 */

        case 61:
          return 2294; /* fractunsuhauhq2 */

        case 62:
          return 2295; /* fractunssquhq2 */

        case 63:
          return 2296; /* fractunsusquhq2 */

        case 64:
          return 2297; /* fractunssauhq2 */

        case 65:
          return 2298; /* fractunsusauhq2 */

        case 66:
          return 2299; /* fractunsdquhq2 */

        case 67:
          return 2300; /* fractunsudquhq2 */

        case 68:
          return 2301; /* fractunsdauhq2 */

        case 69:
          return 2302; /* fractunsudauhq2 */

        case 70:
          return 2303; /* fractunstauhq2 */

        case 71:
          return 2304; /* fractunsutauhq2 */

        case 72:
          return 2305; /* fractunsqiuhq2 */

        case 73:
          return 2306; /* fractunshiuhq2 */

        case 74:
          return 2307; /* fractunssiuhq2 */

        case 75:
          return 2308; /* fractunsdiuhq2 */

        case 76:
          return 2309; /* fractunsqqha2 */

        case 77:
          return 2310; /* fractunsuqqha2 */

        case 78:
          return 2311; /* fractunshqha2 */

        case 79:
          return 2312; /* fractunsuhqha2 */

        case 80:
          return 2313; /* fractunsuhaha2 */

        case 81:
          return 2314; /* fractunssqha2 */

        case 82:
          return 2315; /* fractunsusqha2 */

        case 83:
          return 2316; /* fractunssaha2 */

        case 84:
          return 2317; /* fractunsusaha2 */

        case 85:
          return 2318; /* fractunsdqha2 */

        case 86:
          return 2319; /* fractunsudqha2 */

        case 87:
          return 2320; /* fractunsdaha2 */

        case 88:
          return 2321; /* fractunsudaha2 */

        case 89:
          return 2322; /* fractunstaha2 */

        case 90:
          return 2323; /* fractunsutaha2 */

        case 91:
          return 2324; /* fractunsqiha2 */

        case 92:
          return 2325; /* fractunshiha2 */

        case 93:
          return 2326; /* fractunssiha2 */

        case 94:
          return 2327; /* fractunsdiha2 */

        case 95:
          return 2328; /* fractunsqquha2 */

        case 96:
          return 2329; /* fractunsuqquha2 */

        case 97:
          return 2330; /* fractunshquha2 */

        case 98:
          return 2331; /* fractunsuhquha2 */

        case 99:
          return 2332; /* fractunshauha2 */

        case 100:
          return 2333; /* fractunssquha2 */

        case 101:
          return 2334; /* fractunsusquha2 */

        case 102:
          return 2335; /* fractunssauha2 */

        case 103:
          return 2336; /* fractunsusauha2 */

        case 104:
          return 2337; /* fractunsdquha2 */

        case 105:
          return 2338; /* fractunsudquha2 */

        case 106:
          return 2339; /* fractunsdauha2 */

        case 107:
          return 2340; /* fractunsudauha2 */

        case 108:
          return 2341; /* fractunstauha2 */

        case 109:
          return 2342; /* fractunsutauha2 */

        case 110:
          return 2343; /* fractunsqiuha2 */

        case 111:
          return 2344; /* fractunshiuha2 */

        case 112:
          return 2345; /* fractunssiuha2 */

        case 113:
          return 2346; /* fractunsdiuha2 */

        case 114:
          return 2347; /* fractunsqqsq2 */

        case 115:
          return 2348; /* fractunsuqqsq2 */

        case 116:
          return 2349; /* fractunshqsq2 */

        case 117:
          return 2350; /* fractunsuhqsq2 */

        case 118:
          return 2351; /* fractunshasq2 */

        case 119:
          return 2352; /* fractunsuhasq2 */

        case 120:
          return 2353; /* fractunsusqsq2 */

        case 121:
          return 2354; /* fractunssasq2 */

        case 122:
          return 2355; /* fractunsusasq2 */

        case 123:
          return 2356; /* fractunsdqsq2 */

        case 124:
          return 2357; /* fractunsudqsq2 */

        case 125:
          return 2358; /* fractunsdasq2 */

        case 126:
          return 2359; /* fractunsudasq2 */

        case 127:
          return 2360; /* fractunstasq2 */

        case 128:
          return 2361; /* fractunsutasq2 */

        case 129:
          return 2362; /* fractunsqisq2 */

        case 130:
          return 2363; /* fractunshisq2 */

        case 131:
          return 2364; /* fractunssisq2 */

        case 132:
          return 2365; /* fractunsdisq2 */

        case 133:
          return 2366; /* fractunsqqusq2 */

        case 134:
          return 2367; /* fractunsuqqusq2 */

        case 135:
          return 2368; /* fractunshqusq2 */

        case 136:
          return 2369; /* fractunsuhqusq2 */

        case 137:
          return 2370; /* fractunshausq2 */

        case 138:
          return 2371; /* fractunsuhausq2 */

        case 139:
          return 2372; /* fractunssqusq2 */

        case 140:
          return 2373; /* fractunssausq2 */

        case 141:
          return 2374; /* fractunsusausq2 */

        case 142:
          return 2375; /* fractunsdqusq2 */

        case 143:
          return 2376; /* fractunsudqusq2 */

        case 144:
          return 2377; /* fractunsdausq2 */

        case 145:
          return 2378; /* fractunsudausq2 */

        case 146:
          return 2379; /* fractunstausq2 */

        case 147:
          return 2380; /* fractunsutausq2 */

        case 148:
          return 2381; /* fractunsqiusq2 */

        case 149:
          return 2382; /* fractunshiusq2 */

        case 150:
          return 2383; /* fractunssiusq2 */

        case 151:
          return 2384; /* fractunsdiusq2 */

        case 152:
          return 2385; /* fractunsqqsa2 */

        case 153:
          return 2386; /* fractunsuqqsa2 */

        case 154:
          return 2387; /* fractunshqsa2 */

        case 155:
          return 2388; /* fractunsuhqsa2 */

        case 156:
          return 2389; /* fractunshasa2 */

        case 157:
          return 2390; /* fractunsuhasa2 */

        case 158:
          return 2391; /* fractunssqsa2 */

        case 159:
          return 2392; /* fractunsusqsa2 */

        case 160:
          return 2393; /* fractunsusasa2 */

        case 161:
          return 2394; /* fractunsdqsa2 */

        case 162:
          return 2395; /* fractunsudqsa2 */

        case 163:
          return 2396; /* fractunsdasa2 */

        case 164:
          return 2397; /* fractunsudasa2 */

        case 165:
          return 2398; /* fractunstasa2 */

        case 166:
          return 2399; /* fractunsutasa2 */

        case 167:
          return 2400; /* fractunsqisa2 */

        case 168:
          return 2401; /* fractunshisa2 */

        case 169:
          return 2402; /* fractunssisa2 */

        case 170:
          return 2403; /* fractunsdisa2 */

        case 171:
          return 2404; /* fractunsqqusa2 */

        case 172:
          return 2405; /* fractunsuqqusa2 */

        case 173:
          return 2406; /* fractunshqusa2 */

        case 174:
          return 2407; /* fractunsuhqusa2 */

        case 175:
          return 2408; /* fractunshausa2 */

        case 176:
          return 2409; /* fractunsuhausa2 */

        case 177:
          return 2410; /* fractunssqusa2 */

        case 178:
          return 2411; /* fractunsusqusa2 */

        case 179:
          return 2412; /* fractunssausa2 */

        case 180:
          return 2413; /* fractunsdqusa2 */

        case 181:
          return 2414; /* fractunsudqusa2 */

        case 182:
          return 2415; /* fractunsdausa2 */

        case 183:
          return 2416; /* fractunsudausa2 */

        case 184:
          return 2417; /* fractunstausa2 */

        case 185:
          return 2418; /* fractunsutausa2 */

        case 186:
          return 2419; /* fractunsqiusa2 */

        case 187:
          return 2420; /* fractunshiusa2 */

        case 188:
          return 2421; /* fractunssiusa2 */

        case 189:
          return 2422; /* fractunsdiusa2 */

        case 190:
          return 2423; /* fractunsqqdq2 */

        case 191:
          return 2424; /* fractunsuqqdq2 */

        case 192:
          return 2425; /* fractunshqdq2 */

        case 193:
          return 2426; /* fractunsuhqdq2 */

        case 194:
          return 2427; /* fractunshadq2 */

        case 195:
          return 2428; /* fractunsuhadq2 */

        case 196:
          return 2429; /* fractunssqdq2 */

        case 197:
          return 2430; /* fractunsusqdq2 */

        case 198:
          return 2431; /* fractunssadq2 */

        case 199:
          return 2432; /* fractunsusadq2 */

        case 200:
          return 2433; /* fractunsudqdq2 */

        case 201:
          return 2434; /* fractunsdadq2 */

        case 202:
          return 2435; /* fractunsudadq2 */

        case 203:
          return 2436; /* fractunstadq2 */

        case 204:
          return 2437; /* fractunsutadq2 */

        case 205:
          return 2438; /* fractunsqidq2 */

        case 206:
          return 2439; /* fractunshidq2 */

        case 207:
          return 2440; /* fractunssidq2 */

        case 208:
          return 2441; /* fractunsdidq2 */

        case 209:
          return 2442; /* fractunsqqudq2 */

        case 210:
          return 2443; /* fractunsuqqudq2 */

        case 211:
          return 2444; /* fractunshqudq2 */

        case 212:
          return 2445; /* fractunsuhqudq2 */

        case 213:
          return 2446; /* fractunshaudq2 */

        case 214:
          return 2447; /* fractunsuhaudq2 */

        case 215:
          return 2448; /* fractunssqudq2 */

        case 216:
          return 2449; /* fractunsusqudq2 */

        case 217:
          return 2450; /* fractunssaudq2 */

        case 218:
          return 2451; /* fractunsusaudq2 */

        case 219:
          return 2452; /* fractunsdqudq2 */

        case 220:
          return 2453; /* fractunsdaudq2 */

        case 221:
          return 2454; /* fractunsudaudq2 */

        case 222:
          return 2455; /* fractunstaudq2 */

        case 223:
          return 2456; /* fractunsutaudq2 */

        case 224:
          return 2457; /* fractunsqiudq2 */

        case 225:
          return 2458; /* fractunshiudq2 */

        case 226:
          return 2459; /* fractunssiudq2 */

        case 227:
          return 2460; /* fractunsdiudq2 */

        case 228:
          return 2461; /* fractunsqqda2 */

        case 229:
          return 2462; /* fractunsuqqda2 */

        case 230:
          return 2463; /* fractunshqda2 */

        case 231:
          return 2464; /* fractunsuhqda2 */

        case 232:
          return 2465; /* fractunshada2 */

        case 233:
          return 2466; /* fractunsuhada2 */

        case 234:
          return 2467; /* fractunssqda2 */

        case 235:
          return 2468; /* fractunsusqda2 */

        case 236:
          return 2469; /* fractunssada2 */

        case 237:
          return 2470; /* fractunsusada2 */

        case 238:
          return 2471; /* fractunsdqda2 */

        case 239:
          return 2472; /* fractunsudqda2 */

        case 240:
          return 2473; /* fractunsudada2 */

        case 241:
          return 2474; /* fractunstada2 */

        case 242:
          return 2475; /* fractunsutada2 */

        case 243:
          return 2476; /* fractunsqida2 */

        case 244:
          return 2477; /* fractunshida2 */

        case 245:
          return 2478; /* fractunssida2 */

        case 246:
          return 2479; /* fractunsdida2 */

        case 247:
          return 2480; /* fractunsqquda2 */

        case 248:
          return 2481; /* fractunsuqquda2 */

        case 249:
          return 2482; /* fractunshquda2 */

        case 250:
          return 2483; /* fractunsuhquda2 */

        case 251:
          return 2484; /* fractunshauda2 */

        case 252:
          return 2485; /* fractunsuhauda2 */

        case 253:
          return 2486; /* fractunssquda2 */

        case 254:
          return 2487; /* fractunsusquda2 */

        case 255:
          return 2488; /* fractunssauda2 */

        case 256:
          return 2489; /* fractunsusauda2 */

        case 257:
          return 2490; /* fractunsdquda2 */

        case 258:
          return 2491; /* fractunsudquda2 */

        case 259:
          return 2492; /* fractunsdauda2 */

        case 260:
          return 2493; /* fractunstauda2 */

        case 261:
          return 2494; /* fractunsutauda2 */

        case 262:
          return 2495; /* fractunsqiuda2 */

        case 263:
          return 2496; /* fractunshiuda2 */

        case 264:
          return 2497; /* fractunssiuda2 */

        case 265:
          return 2498; /* fractunsdiuda2 */

        case 266:
          return 2499; /* fractunsqqta2 */

        case 267:
          return 2500; /* fractunsuqqta2 */

        case 268:
          return 2501; /* fractunshqta2 */

        case 269:
          return 2502; /* fractunsuhqta2 */

        case 270:
          return 2503; /* fractunshata2 */

        case 271:
          return 2504; /* fractunsuhata2 */

        case 272:
          return 2505; /* fractunssqta2 */

        case 273:
          return 2506; /* fractunsusqta2 */

        case 274:
          return 2507; /* fractunssata2 */

        case 275:
          return 2508; /* fractunsusata2 */

        case 276:
          return 2509; /* fractunsdqta2 */

        case 277:
          return 2510; /* fractunsudqta2 */

        case 278:
          return 2511; /* fractunsdata2 */

        case 279:
          return 2512; /* fractunsudata2 */

        case 280:
          return 2513; /* fractunsutata2 */

        case 281:
          return 2514; /* fractunsqita2 */

        case 282:
          return 2515; /* fractunshita2 */

        case 283:
          return 2516; /* fractunssita2 */

        case 284:
          return 2517; /* fractunsdita2 */

        case 285:
          return 2518; /* fractunsqquta2 */

        case 286:
          return 2519; /* fractunsuqquta2 */

        case 287:
          return 2520; /* fractunshquta2 */

        case 288:
          return 2521; /* fractunsuhquta2 */

        case 289:
          return 2522; /* fractunshauta2 */

        case 290:
          return 2523; /* fractunsuhauta2 */

        case 291:
          return 2524; /* fractunssquta2 */

        case 292:
          return 2525; /* fractunsusquta2 */

        case 293:
          return 2526; /* fractunssauta2 */

        case 294:
          return 2527; /* fractunsusauta2 */

        case 295:
          return 2528; /* fractunsdquta2 */

        case 296:
          return 2529; /* fractunsudquta2 */

        case 297:
          return 2530; /* fractunsdauta2 */

        case 298:
          return 2531; /* fractunsudauta2 */

        case 299:
          return 2532; /* fractunstauta2 */

        case 300:
          return 2533; /* fractunsqiuta2 */

        case 301:
          return 2534; /* fractunshiuta2 */

        case 302:
          return 2535; /* fractunssiuta2 */

        case 303:
          return 2536; /* fractunsdiuta2 */

        case 304:
          return 2537; /* fractunsqqqi2 */

        case 305:
          return 2538; /* fractunsuqqqi2 */

        case 306:
          return 2539; /* fractunshqqi2 */

        case 307:
          return 2540; /* fractunsuhqqi2 */

        case 308:
          return 2541; /* fractunshaqi2 */

        case 309:
          return 2542; /* fractunsuhaqi2 */

        case 310:
          return 2543; /* fractunssqqi2 */

        case 311:
          return 2544; /* fractunsusqqi2 */

        case 312:
          return 2545; /* fractunssaqi2 */

        case 313:
          return 2546; /* fractunsusaqi2 */

        case 314:
          return 2547; /* fractunsdqqi2 */

        case 315:
          return 2548; /* fractunsudqqi2 */

        case 316:
          return 2549; /* fractunsdaqi2 */

        case 317:
          return 2550; /* fractunsudaqi2 */

        case 318:
          return 2551; /* fractunstaqi2 */

        case 319:
          return 2552; /* fractunsutaqi2 */

        case 320:
          return 2553; /* fractunshiqi2 */

        case 321:
          return 2554; /* fractunssiqi2 */

        case 322:
          return 2555; /* fractunsdiqi2 */

        case 323:
          return 2556; /* fractunsqqhi2 */

        case 324:
          return 2557; /* fractunsuqqhi2 */

        case 325:
          return 2558; /* fractunshqhi2 */

        case 326:
          return 2559; /* fractunsuhqhi2 */

        case 327:
          return 2560; /* fractunshahi2 */

        case 328:
          return 2561; /* fractunsuhahi2 */

        case 329:
          return 2562; /* fractunssqhi2 */

        case 330:
          return 2563; /* fractunsusqhi2 */

        case 331:
          return 2564; /* fractunssahi2 */

        case 332:
          return 2565; /* fractunsusahi2 */

        case 333:
          return 2566; /* fractunsdqhi2 */

        case 334:
          return 2567; /* fractunsudqhi2 */

        case 335:
          return 2568; /* fractunsdahi2 */

        case 336:
          return 2569; /* fractunsudahi2 */

        case 337:
          return 2570; /* fractunstahi2 */

        case 338:
          return 2571; /* fractunsutahi2 */

        case 339:
          return 2572; /* fractunsqihi2 */

        case 340:
          return 2573; /* fractunssihi2 */

        case 341:
          return 2574; /* fractunsdihi2 */

        case 342:
          return 2575; /* fractunsqqsi2 */

        case 343:
          return 2576; /* fractunsuqqsi2 */

        case 344:
          return 2577; /* fractunshqsi2 */

        case 345:
          return 2578; /* fractunsuhqsi2 */

        case 346:
          return 2579; /* fractunshasi2 */

        case 347:
          return 2580; /* fractunsuhasi2 */

        case 348:
          return 2581; /* fractunssqsi2 */

        case 349:
          return 2582; /* fractunsusqsi2 */

        case 350:
          return 2583; /* fractunssasi2 */

        case 351:
          return 2584; /* fractunsusasi2 */

        case 352:
          return 2585; /* fractunsdqsi2 */

        case 353:
          return 2586; /* fractunsudqsi2 */

        case 354:
          return 2587; /* fractunsdasi2 */

        case 355:
          return 2588; /* fractunsudasi2 */

        case 356:
          return 2589; /* fractunstasi2 */

        case 357:
          return 2590; /* fractunsutasi2 */

        case 358:
          return 2591; /* fractunsqisi2 */

        case 359:
          return 2592; /* fractunshisi2 */

        case 360:
          return 2593; /* fractunsdisi2 */

        case 361:
          return 2594; /* fractunsqqdi2 */

        case 362:
          return 2595; /* fractunsuqqdi2 */

        case 363:
          return 2596; /* fractunshqdi2 */

        case 364:
          return 2597; /* fractunsuhqdi2 */

        case 365:
          return 2598; /* fractunshadi2 */

        case 366:
          return 2599; /* fractunsuhadi2 */

        case 367:
          return 2600; /* fractunssqdi2 */

        case 368:
          return 2601; /* fractunsusqdi2 */

        case 369:
          return 2602; /* fractunssadi2 */

        case 370:
          return 2603; /* fractunsusadi2 */

        case 371:
          return 2604; /* fractunsdqdi2 */

        case 372:
          return 2605; /* fractunsudqdi2 */

        case 373:
          return 2606; /* fractunsdadi2 */

        case 374:
          return 2607; /* fractunsudadi2 */

        case 375:
          return 2608; /* fractunstadi2 */

        case 376:
          return 2609; /* fractunsutadi2 */

        case 377:
          return 2610; /* fractunsqidi2 */

        case 378:
          return 2611; /* fractunshidi2 */

        case 379:
          return 2612; /* fractunssidi2 */

        default:
          return -1;
        }

    case SS_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern59 (x2))
        {
        case 0:
          return 2993; /* ssaddqq3 */

        case 1:
          return 2995; /* ssaddhq3 */

        case 2:
          return 2997; /* ssaddha3 */

        case 3:
          return 2999; /* ssaddsa3 */

        case 4:
          return 3001; /* ssaddsq3 */

        default:
          break;
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern60 (x1))
        {
        case 0:
          if (
#line 288 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3201; /* ssadddq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3207; /* *ssadddq3_insn */

        case 1:
          if (
#line 288 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3203; /* ssaddda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3209; /* *ssaddda3_insn */

        case 2:
          if (
#line 288 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3205; /* ssaddta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3211; /* *ssaddta3_insn */

        case 3:
          if (
#line 309 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3213; /* ssadddq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3219; /* *ssadddq3_const_insn */

        case 4:
          if (
#line 309 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3215; /* ssaddda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3221; /* *ssaddda3_const_insn */

        case 5:
          if (
#line 309 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3217; /* ssaddta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3223; /* *ssaddta3_const_insn */

        default:
          return -1;
        }

    case SS_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern59 (x2))
        {
        case 0:
          return 2994; /* sssubqq3 */

        case 1:
          return 2996; /* sssubhq3 */

        case 2:
          return 2998; /* sssubha3 */

        case 3:
          return 3000; /* sssubsa3 */

        case 4:
          return 3002; /* sssubsq3 */

        default:
          break;
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern60 (x1))
        {
        case 0:
          if (
#line 288 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3202; /* sssubdq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3208; /* *sssubdq3_insn */

        case 1:
          if (
#line 288 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3204; /* sssubda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3210; /* *sssubda3_insn */

        case 2:
          if (
#line 288 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3206; /* sssubta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 301 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3212; /* *sssubta3_insn */

        case 3:
          if (
#line 309 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3214; /* sssubdq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3220; /* *sssubdq3_const_insn */

        case 4:
          if (
#line 309 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3216; /* sssubda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3222; /* *sssubda3_const_insn */

        case 5:
          if (
#line 309 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3218; /* sssubta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 322 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3224; /* *sssubta3_const_insn */

        default:
          return -1;
        }

    case US_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern61 (x2))
        {
        case 0:
          return 3013; /* usadduqq3 */

        case 1:
          return 3015; /* usadduhq3 */

        case 2:
          return 3017; /* usadduha3 */

        case 3:
          return 3019; /* usaddusa3 */

        case 4:
          return 3021; /* usaddusq3 */

        default:
          break;
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern62 (x1))
        {
        case 0:
          if (
#line 361 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3225; /* usaddudq3_insn */
          if (pnum_clobbers == NULL
              || !
#line 374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3231; /* *usaddudq3_insn */

        case 1:
          if (
#line 361 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3227; /* usadduda3_insn */
          if (pnum_clobbers == NULL
              || !
#line 374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3233; /* *usadduda3_insn */

        case 2:
          if (
#line 361 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3229; /* usadduta3_insn */
          if (pnum_clobbers == NULL
              || !
#line 374 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3235; /* *usadduta3_insn */

        case 3:
          if (
#line 382 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3237; /* usaddudq3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 395 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3243; /* *usaddudq3_const_insn */

        case 4:
          if (
#line 382 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3239; /* usadduda3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 395 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3245; /* *usadduda3_const_insn */

        case 5:
          if (
#line 382 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
            return 3241; /* usadduta3_const_insn */
          if (pnum_clobbers == NULL
              || !
#line 395 "../../gcc-15.0.1-20250313/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 3247; /* *usadduta3_const_insn */

        default:
          return -1;
        }

    case US_MINUS:
      return recog_37 (x1, insn, pnum_clobbers);

    case SS_NEG:
      if (GET_MODE (x2) == E_QQmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_QQmode))
            {
              x6 = XEXP (x2, 0);
              operands[1] = x6;
              if (register_operand (operands[1], E_QQmode))
                return 3033; /* ssnegqq2 */
            }
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern63 (x1))
        {
        case 0:
          return 3038; /* *ssneghq2_split */

        case 1:
          return 3040; /* *ssnegha2_split */

        case 2:
          return 3046; /* *ssnegsa2_split */

        case 3:
          return 3048; /* *ssnegsq2_split */

        default:
          return -1;
        }

    case SS_ABS:
      if (GET_MODE (x2) == E_QQmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_QQmode))
            {
              x6 = XEXP (x2, 0);
              operands[1] = x6;
              if (register_operand (operands[1], E_QQmode))
                return 3035; /* ssabsqq2 */
            }
        }
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      switch (pattern63 (x1))
        {
        case 0:
          return 3037; /* *ssabshq2_split */

        case 1:
          return 3039; /* *ssabsha2_split */

        case 2:
          return 3045; /* *ssabssa2_split */

        case 3:
          return 3047; /* *ssabssq2_split */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern26 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 3071; /* *udivqq3.call_split */

        case 1:
          *pnum_clobbers = 1;
          return 3073; /* *udivuqq3.call_split */

        case 2:
          *pnum_clobbers = 2;
          return 3079; /* *udivhq3.call_split */

        case 3:
          *pnum_clobbers = 2;
          return 3081; /* *udivuhq3.call_split */

        case 4:
          *pnum_clobbers = 2;
          return 3083; /* *udivha3.call_split */

        case 5:
          *pnum_clobbers = 2;
          return 3085; /* *udivuha3.call_split */

        case 6:
          *pnum_clobbers = 2;
          return 3095; /* *udivsa3.call_split */

        case 7:
          *pnum_clobbers = 2;
          return 3097; /* *udivusa3.call_split */

        default:
          return -1;
        }

    case DIV:
      switch (pattern26 (x1, pnum_clobbers))
        {
        case 0:
          *pnum_clobbers = 1;
          return 3072; /* *divqq3.call_split */

        case 1:
          *pnum_clobbers = 1;
          return 3074; /* *divuqq3.call_split */

        case 2:
          *pnum_clobbers = 2;
          return 3080; /* *divhq3.call_split */

        case 3:
          *pnum_clobbers = 2;
          return 3082; /* *divuhq3.call_split */

        case 4:
          *pnum_clobbers = 2;
          return 3084; /* *divha3.call_split */

        case 5:
          *pnum_clobbers = 2;
          return 3086; /* *divuha3.call_split */

        case 6:
          *pnum_clobbers = 2;
          return 3096; /* *divsa3.call_split */

        case 7:
          *pnum_clobbers = 2;
          return 3098; /* *divusa3.call_split */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
