/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (XWINT (x2, 0))
    {
    case 0L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 2L)
        return -1;
      return 0;

    case 1L:
      x3 = XVECEXP (x1, 0, 1);
      if (XWINT (x3, 0) != 3L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern3 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern3 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern3 (x3, 
E_V16QImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern3 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!reg_or_cint_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern37 (rtx x1, machine_mode i1, int i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i2]
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern43 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern68 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      return pattern6 (x3, 
E_V4SImode); /* [-1, 1] */

    case 1:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          res = pattern67 (x1, 
E_DFmode);
          if (res >= 0)
            return res + 2; /* [2, 4] */
          return -1;

        case E_SFmode:
          res = pattern67 (x1, 
E_SFmode);
          if (res >= 0)
            return res + 5; /* [5, 7] */
          return -1;

        case E_IFmode:
          if (!gpc_reg_operand (operands[0], E_IFmode)
              || GET_MODE (x1) != E_IFmode
              || GET_MODE (x2) != E_SImode
              || !gpc_reg_operand (operands[1], E_V4SImode)
              || !const_0_to_3_operand (operands[2], E_QImode))
            return -1;
          return 8;

        case E_KFmode:
          res = pattern67 (x1, 
E_KFmode);
          if (res >= 0)
            return res + 9; /* [9, 11] */
          return -1;

        case E_TFmode:
          res = pattern67 (x1, 
E_TFmode);
          if (res >= 0)
            return res + 12; /* [12, 14] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern86 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !vector_shift_constant (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern91 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PARALLEL
      || XVECLEN (x5, 0) != 1)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!gpc_reg_operand (operands[1], E_V4SImode))
    return -1;
  x7 = XVECEXP (x5, 0, 0);
  operands[2] = x7;
  if (!const_0_to_3_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_V4SImode))
    return -1;
  x10 = XVECEXP (x1, 0, 2);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_DFmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      return 0;

    case E_IFmode:
      if (!gpc_reg_operand (operands[0], E_IFmode)
          || GET_MODE (x3) != E_IFmode)
        return -1;
      return 1;

    case E_KFmode:
      if (!gpc_reg_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode)
        return -1;
      return 2;

    case E_TFmode:
      if (!gpc_reg_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !reg_or_u_short_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !reg_or_u_short_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern122 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 1);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern41 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern132 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vsx_register_operand (operands[1], i1)
      || !vsx_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern136 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!cc_reg_operand (operands[0], E_CCmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!gpc_reg_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!gpc_reg_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      return pattern141 (x3, 
E_V4SFmode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern141 (x3, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !gpc_reg_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!gpc_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !gpc_reg_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (GET_MODE (x3) != E_V4SFmode)
        return -1;
      return 2;

    case E_V2DFmode:
      if (!vsx_register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !vsx_register_operand (operands[1], E_V2DFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern166 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_V16QImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!gpc_reg_operand (operands[1], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!vsx_register_operand (operands[0], E_V16QImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern174 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !scc_eq_operand (operands[2], i1)
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  switch (GET_MODE (x6))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !scratch_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !scratch_operand (operands[0], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern185 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x2, 0);
  operands[3] = x5;
  if (!cc_reg_operand (operands[3], E_CCmode)
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      if (!reg_or_cint_operand (operands[2], E_SImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          return pattern179 (x1); /* [-1, 1] */

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT)
            return -1;
          res = pattern183 (x1);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_DImode
          || GET_MODE (x6) != E_DImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      if (!reg_or_mem_operand (operands[1], E_SImode)
          || !u6bit_cint_operand (operands[2], E_DImode))
        return -1;
      x9 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x9))
        {
        case CLOBBER:
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!scratch_operand (operands[0], E_DImode))
            return -1;
          return 4;

        case SET:
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != ASHIFT
              || GET_MODE (x10) != E_DImode)
            return -1;
          x13 = XEXP (x10, 0);
          if (GET_CODE (x13) != SIGN_EXTEND
              || GET_MODE (x13) != E_DImode)
            return -1;
          x12 = XEXP (x9, 0);
          operands[0] = x12;
          if (!gpc_reg_operand (operands[0], E_DImode))
            return -1;
          x14 = XEXP (x13, 0);
          if (!rtx_equal_p (x14, operands[1]))
            return -1;
          x15 = XEXP (x10, 1);
          if (!rtx_equal_p (x15, operands[2]))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern214 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vsx_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern222 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 106
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i2
      || GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern239 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !altivec_register_operand (operands[0], i1)
      || !altivec_register_operand (operands[1], i1)
      || !altivec_register_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern248 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[4] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  switch (GET_CODE (x8))
    {
    case NOT:
      x9 = XEXP (x8, 0);
      operands[0] = x9;
      x10 = XEXP (x7, 1);
      switch (GET_CODE (x10))
        {
        case NOT:
          return pattern246 (x6); /* [-1, 23] */

        case REG:
        case SUBREG:
          res = pattern242 (x6);
          if (res >= 0)
            return res + 24; /* [24, 47] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern237 (x6);
      if (res >= 0)
        return res + 48; /* [48, 71] */
      return -1;

    default:
      return -1;
    }
}

int
pattern259 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern260 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !reg_or_cint_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern265 (rtx x1, machine_mode i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern272 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[0], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern279 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!altivec_register_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !altivec_register_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !altivec_register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !altivec_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern272 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern272 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern294 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DImode:
      return pattern293 (x1, 
E_V2DImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern293 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern303 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  return pattern301 (x5); /* [-1, 1] */
}

int
pattern310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern309 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern309 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern317 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!vlogical_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vlogical_operand (operands[1], i1)
      || !vlogical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern324 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !short_cint_operand (operands[2], i1)
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern330 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern339 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!vsx_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!vsx_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern350 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern354 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern354 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern361 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!int_reg_operand (operands[0], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  if (!cc_reg_operand (operands[2], E_CCmode))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern370 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || !boolean_or_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !logical_const_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern378 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern385 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!boolean_operator (operands[3], i1)
      || !gpc_reg_operand (operands[1], i1)
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[3], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[0], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != i1
      || !gpc_reg_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != NOT)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case NOT:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 1);
      switch (GET_CODE (x8))
        {
        case NOT:
          return pattern402 (x1); /* [-1, 11] */

        case REG:
        case SUBREG:
          res = pattern399 (x1);
          if (res >= 0)
            return res + 12; /* [12, 23] */
          return -1;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      res = pattern396 (x1);
      if (res >= 0)
        return res + 24; /* [24, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern416 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !gpc_reg_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[1], E_SImode)
          || !gpc_reg_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !gpc_reg_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern425 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern423 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern423 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern424 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern424 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern424 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern424 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern424 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern424 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern424 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern424 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern424 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern424 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern445 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern445 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern446 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern446 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern446 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern446 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern446 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern446 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern446 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern446 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern446 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern446 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern470 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], E_V4SFmode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 2);
  if (!const_0_to_3_operand (x4, E_QImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (!scratch_operand (x6, E_SImode))
    return -1;
  x7 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      if (!gpc_reg_operand (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 0;

    case CONST_DOUBLE:
      operands[2] = x7;
      if (!zero_fp_constant (operands[2], E_SFmode))
        return -1;
      operands[3] = x4;
      operands[4] = x6;
      return 1;

    case VEC_SELECT:
      if (GET_MODE (x7) != E_SFmode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!gpc_reg_operand (operands[2], E_V4SFmode))
        return -1;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_0_to_3_operand (operands[3], E_QImode))
        return -1;
      operands[4] = x4;
      operands[5] = x6;
      return 2;

    default:
      return -1;
    }
}

int
pattern492 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern501 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 3)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2)
    return -1;
  return 0;
}

int
pattern507 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern516 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_MODE (operands[3]))
    {
    case E_SImode:
      return pattern520 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern520 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern521 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern521 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern521 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern521 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern521 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern521 (x1, 
E_V2DImode) != 0)
        return -1;
      return 7;

    case E_V1TImode:
      if (pattern521 (x1, 
E_V1TImode) != 0)
        return -1;
      return 8;

    case E_TImode:
      if (pattern521 (x1, 
E_TImode) != 0)
        return -1;
      return 9;

    case E_KFmode:
      if (pattern521 (x1, 
E_KFmode) != 0)
        return -1;
      return 10;

    case E_TFmode:
      if (pattern521 (x1, 
E_TFmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern542 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern553 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!gpc_reg_operand (operands[1], i1)
      || !reg_or_short_operand (operands[2], i1)
      || !gpc_reg_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern561 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!vsx_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !gpc_reg_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !gpc_reg_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern568 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[4] = x3;
      if (!altivec_register_operand (operands[4], E_V4SImode))
        return -1;
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_V4SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != PLUS)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XVECEXP (x1, 0, 0);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_SImode:
          return pattern566 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern566 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case MEM:
      if (GET_MODE (x3) != E_V4SImode)
        return -1;
      x10 = XEXP (x3, 0);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x4 = XEXP (x2, 0);
      operands[2] = x4;
      if (!altivec_register_operand (operands[2], E_V4SImode))
        return -1;
      x11 = XEXP (x10, 0);
      operands[3] = x11;
      x12 = XEXP (x10, 1);
      operands[4] = x12;
      x8 = XVECEXP (x1, 0, 0);
      x9 = XEXP (x8, 0);
      switch (GET_MODE (x9))
        {
        case E_SImode:
          if (pattern567 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern567 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern602 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != i1)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != i1)
    return -1;
  x11 = XEXP (x9, 1);
  if (GET_CODE (x11) != i1)
    return -1;
  x12 = XEXP (x5, 0);
  x13 = XEXP (x12, 0);
  operands[1] = x13;
  if (!gpc_reg_operand (operands[1], E_HImode))
    return -1;
  x14 = XEXP (x6, 0);
  operands[2] = x14;
  if (!gpc_reg_operand (operands[2], E_HImode))
    return -1;
  x15 = XEXP (x10, 0);
  if (!rtx_equal_p (x15, operands[1]))
    return -1;
  x16 = XEXP (x11, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  return 0;
}

 int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case EQ:
      res = recog_7 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case LT:
      if (pattern48 (x1, 
E_CCmode, 
GT) == 0
          && 
#line 15710 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1208; /* setb_signed */
      break;

    case LTU:
      if (pattern48 (x1, 
E_CCUNSmode, 
GTU) == 0
          && 
#line 15723 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P9_MISC))
        return 1209; /* setb_unsigned */
      break;

    default:
      break;
    }
  operands[1] = x3;
  if (!scc_comparison_operator (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[4] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 2);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      switch (pattern456 (x2, 
E_SImode))
        {
        case 0:
          if (!
#line 5570 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 353; /* isel_cc_si */

        case 1:
          if (!
#line 5570 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL))
            return -1;
          return 355; /* isel_ccuns_si */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern456 (x2, 
E_DImode))
        {
        case 0:
          if (!(
#line 5570 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 354; /* isel_cc_di */

        case 1:
          if (!(
#line 5570 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ISEL) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 356; /* isel_ccuns_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case XOR:
      x6 = XEXP (x5, 0);
      operands[0] = x6;
      x7 = XEXP (x5, 1);
      operands[1] = x7;
      x8 = XEXP (x3, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          switch (pattern429 (x3))
            {
            case 0:
              if (!
#line 403 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2535; /* *fuse_eqv_and */

            case 1:
              if (!(
#line 403 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2536; /* *fuse_eqv_and */

            case 2:
              if (!
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2719; /* *fuse_veqv_vand */

            case 3:
              if (!
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2720; /* *fuse_veqv_vand */

            case 4:
              if (!
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2721; /* *fuse_veqv_vand */

            case 5:
              if (!
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2722; /* *fuse_veqv_vand */

            case 6:
              if (!
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2723; /* *fuse_veqv_vand */

            case 7:
              if (!
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2724; /* *fuse_veqv_vand */

            case 8:
              if (!
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2725; /* *fuse_veqv_vand */

            case 9:
              if (!
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2726; /* *fuse_veqv_vand */

            case 10:
              if (!(
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2727; /* *fuse_veqv_vand */

            case 11:
              if (!(
#line 1915 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2728; /* *fuse_veqv_vand */

            default:
              return -1;
            }

        case NOT:
          x9 = XEXP (x8, 0);
          operands[2] = x9;
          switch (GET_MODE (operands[3]))
            {
            case E_SImode:
              if (pattern272 (x3, 
E_SImode) != 0
                  || !
#line 583 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2555; /* *fuse_eqv_andc */

            case E_DImode:
              if (pattern272 (x3, 
E_DImode) != 0
                  || !(
#line 583 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return -1;
              *pnum_clobbers = 1;
              return 2556; /* *fuse_eqv_andc */

            case E_V4SImode:
              if (pattern273 (x3, 
E_V4SImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2799; /* *fuse_veqv_vandc */

            case E_V8HImode:
              if (pattern273 (x3, 
E_V8HImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2800; /* *fuse_veqv_vandc */

            case E_V16QImode:
              if (pattern273 (x3, 
E_V16QImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2801; /* *fuse_veqv_vandc */

            case E_V4SFmode:
              if (pattern273 (x3, 
E_V4SFmode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2802; /* *fuse_veqv_vandc */

            case E_V2DFmode:
              if (pattern273 (x3, 
E_V2DFmode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2803; /* *fuse_veqv_vandc */

            case E_V2DImode:
              if (pattern273 (x3, 
E_V2DImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2804; /* *fuse_veqv_vandc */

            case E_V1TImode:
              if (pattern273 (x3, 
E_V1TImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2805; /* *fuse_veqv_vandc */

            case E_TImode:
              if (pattern273 (x3, 
E_TImode) != 0
                  || !
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
                return -1;
              *pnum_clobbers = 1;
              return 2806; /* *fuse_veqv_vandc */

            case E_KFmode:
              if (pattern273 (x3, 
E_KFmode) != 0
                  || !(
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2807; /* *fuse_veqv_vandc */

            case E_TFmode:
              if (pattern273 (x3, 
E_TFmode) != 0
                  || !(
#line 2059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
                return -1;
              *pnum_clobbers = 1;
              return 2808; /* *fuse_veqv_vandc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      switch (pattern281 (x3))
        {
        case 0:
          if (!
#line 1015 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2603; /* *fuse_and_nor */

        case 1:
          if (!(
#line 1015 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2604; /* *fuse_and_nor */

        case 2:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3019; /* *fuse_vand_vnor */

        case 3:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3020; /* *fuse_vand_vnor */

        case 4:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3021; /* *fuse_vand_vnor */

        case 5:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3022; /* *fuse_vand_vnor */

        case 6:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3023; /* *fuse_vand_vnor */

        case 7:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3024; /* *fuse_vand_vnor */

        case 8:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3025; /* *fuse_vand_vnor */

        case 9:
          if (!
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3026; /* *fuse_vand_vnor */

        case 10:
          if (!(
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3027; /* *fuse_vand_vnor */

        case 11:
          if (!(
#line 2455 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3028; /* *fuse_vand_vnor */

        case 12:
          if (!
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2605; /* *fuse_andc_nor */

        case 13:
          if (!(
#line 1033 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2606; /* *fuse_andc_nor */

        case 14:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3029; /* *fuse_vandc_vnor */

        case 15:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3030; /* *fuse_vandc_vnor */

        case 16:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3031; /* *fuse_vandc_vnor */

        case 17:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3032; /* *fuse_vandc_vnor */

        case 18:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3033; /* *fuse_vandc_vnor */

        case 19:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3034; /* *fuse_vandc_vnor */

        case 20:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3035; /* *fuse_vandc_vnor */

        case 21:
          if (!
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3036; /* *fuse_vandc_vnor */

        case 22:
          if (!(
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3037; /* *fuse_vandc_vnor */

        case 23:
          if (!(
#line 2473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3038; /* *fuse_vandc_vnor */

        case 24:
          if (!
#line 1087 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2611; /* *fuse_nor_nor */

        case 25:
          if (!(
#line 1087 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2612; /* *fuse_nor_nor */

        case 26:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3059; /* *fuse_vnor_vnor */

        case 27:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3060; /* *fuse_vnor_vnor */

        case 28:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3061; /* *fuse_vnor_vnor */

        case 29:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3062; /* *fuse_vnor_vnor */

        case 30:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3063; /* *fuse_vnor_vnor */

        case 31:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3064; /* *fuse_vnor_vnor */

        case 32:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3065; /* *fuse_vnor_vnor */

        case 33:
          if (!
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3066; /* *fuse_vnor_vnor */

        case 34:
          if (!(
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3067; /* *fuse_vnor_vnor */

        case 35:
          if (!(
#line 2527 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3068; /* *fuse_vnor_vnor */

        default:
          return -1;
        }

    case NOT:
      switch (pattern284 (x3))
        {
        case 0:
          if (!
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2607; /* *fuse_eqv_nor */

        case 1:
          if (!(
#line 1051 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2608; /* *fuse_eqv_nor */

        case 2:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3039; /* *fuse_veqv_vnor */

        case 3:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3040; /* *fuse_veqv_vnor */

        case 4:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3041; /* *fuse_veqv_vnor */

        case 5:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3042; /* *fuse_veqv_vnor */

        case 6:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3043; /* *fuse_veqv_vnor */

        case 7:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3044; /* *fuse_veqv_vnor */

        case 8:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3045; /* *fuse_veqv_vnor */

        case 9:
          if (!
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3046; /* *fuse_veqv_vnor */

        case 10:
          if (!(
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3047; /* *fuse_veqv_vnor */

        case 11:
          if (!(
#line 2491 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3048; /* *fuse_veqv_vnor */

        default:
          return -1;
        }

    case IOR:
      switch (pattern285 (x3))
        {
        case 0:
          if (!
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2609; /* *fuse_nand_nor */

        case 1:
          if (!(
#line 1069 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2610; /* *fuse_nand_nor */

        case 2:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3049; /* *fuse_vnand_vnor */

        case 3:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3050; /* *fuse_vnand_vnor */

        case 4:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3051; /* *fuse_vnand_vnor */

        case 5:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3052; /* *fuse_vnand_vnor */

        case 6:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3053; /* *fuse_vnand_vnor */

        case 7:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3054; /* *fuse_vnand_vnor */

        case 8:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3055; /* *fuse_vnand_vnor */

        case 9:
          if (!
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3056; /* *fuse_vnand_vnor */

        case 10:
          if (!(
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3057; /* *fuse_vnand_vnor */

        case 11:
          if (!(
#line 2509 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3058; /* *fuse_vnand_vnor */

        case 12:
          if (!
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2615; /* *fuse_orc_nor */

        case 13:
          if (!(
#line 1123 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2616; /* *fuse_orc_nor */

        case 14:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3079; /* *fuse_vorc_vnor */

        case 15:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3080; /* *fuse_vorc_vnor */

        case 16:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3081; /* *fuse_vorc_vnor */

        case 17:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3082; /* *fuse_vorc_vnor */

        case 18:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3083; /* *fuse_vorc_vnor */

        case 19:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3084; /* *fuse_vorc_vnor */

        case 20:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3085; /* *fuse_vorc_vnor */

        case 21:
          if (!
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3086; /* *fuse_vorc_vnor */

        case 22:
          if (!(
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3087; /* *fuse_vorc_vnor */

        case 23:
          if (!(
#line 2563 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3088; /* *fuse_vorc_vnor */

        case 24:
          if (!
#line 1105 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2613; /* *fuse_or_nor */

        case 25:
          if (!(
#line 1105 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2614; /* *fuse_or_nor */

        case 26:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3069; /* *fuse_vor_vnor */

        case 27:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3070; /* *fuse_vor_vnor */

        case 28:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3071; /* *fuse_vor_vnor */

        case 29:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3072; /* *fuse_vor_vnor */

        case 30:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3073; /* *fuse_vor_vnor */

        case 31:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3074; /* *fuse_vor_vnor */

        case 32:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3075; /* *fuse_vor_vnor */

        case 33:
          if (!
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 3076; /* *fuse_vor_vnor */

        case 34:
          if (!(
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3077; /* *fuse_vor_vnor */

        case 35:
          if (!(
#line 2545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          *pnum_clobbers = 1;
          return 3078; /* *fuse_vor_vnor */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2619; /* *fuse_add_nor */

        case 1:
          if (!(
#line 1159 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2620; /* *fuse_add_nor */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern286 (x3))
        {
        case 0:
          if (!
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          *pnum_clobbers = 1;
          return 2621; /* *fuse_subf_nor */

        case 1:
          if (!(
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          *pnum_clobbers = 1;
          return 2622; /* *fuse_subf_nor */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_KFmode:
      if (!altivec_register_operand (operands[0], E_KFmode)
          || GET_MODE (x3) != E_KFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_KFmode:
          if (!altivec_register_operand (operands[1], E_KFmode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1670; /* xsiexpqpf_kf */

        case E_V1TImode:
          if (!altivec_register_operand (operands[1], E_V1TImode)
              || !altivec_register_operand (operands[2], E_V2DImode)
              || !(
#line 5251 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1672; /* xsiexpqp_kf_v2di */

        case E_TImode:
          if (!altivec_register_operand (operands[1], E_TImode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5251 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
            return -1;
          return 1673; /* xsiexpqp_kf_di */

        default:
          return -1;
        }

    case E_TFmode:
      if (!altivec_register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_TFmode:
          if (!altivec_register_operand (operands[1], E_TFmode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5239 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1671; /* xsiexpqpf_tf */

        case E_V1TImode:
          if (!altivec_register_operand (operands[1], E_V1TImode)
              || !altivec_register_operand (operands[2], E_V2DImode)
              || !(
#line 5251 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1674; /* xsiexpqp_tf_v2di */

        case E_TImode:
          if (!altivec_register_operand (operands[1], E_TImode)
              || !altivec_register_operand (operands[2], E_DImode)
              || !(
#line 5251 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
            return -1;
          return 1675; /* xsiexpqp_tf_di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_41 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_TFmode:
      if (pattern146 (x3, 
E_DFmode, 
E_TFmode) != 0)
        return -1;
      if ((
#line 14940 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_HARD_FLOAT) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return 1085; /* packtf_hard */
      if (!(
#line 14964 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TFmode) && TARGET_SOFT_FLOAT) && 
#line 543 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128)))
        return -1;
      return 1088; /* packtf_soft */

    case E_IFmode:
      if (pattern146 (x3, 
E_DFmode, 
E_IFmode) != 0
          || !(
#line 14940 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (IFmode) && TARGET_HARD_FLOAT) && 
#line 544 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
        return -1;
      return 1086; /* packif_hard */

    case E_TDmode:
      if (pattern146 (x3, 
E_DImode, 
E_TDmode) != 0
          || !(
#line 14940 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_2REG_P (TDmode) && TARGET_HARD_FLOAT) && 
#line 545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT)))
        return -1;
      return 1087; /* packtd_hard */

    case E_V1TImode:
      if (pattern146 (x3, 
E_DImode, 
E_V1TImode) != 0
          || !
#line 15007 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX))
        return -1;
      return 1091; /* packv1ti */

    case E_KFmode:
      if (pattern146 (x3, 
E_DImode, 
E_KFmode) != 0
          || !
#line 15007 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX))
        return -1;
      return 1092; /* packkf */

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (pattern132 (x3, 
E_V4SFmode) != 0
          || !
#line 5484 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1691; /* xviexpsp */

    case E_V2DFmode:
      if (pattern132 (x3, 
E_V2DFmode) != 0
          || !
#line 5484 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1692; /* xviexpdp */

    default:
      return -1;
    }
}

 int
recog_61 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!gpc_reg_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !gpc_reg_operand (operands[1], E_SImode)
          || !
#line 2547 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_CMPB && TARGET_POPCNTB))
        return -1;
      return 141; /* paritysi2_cmpb */

    case E_DImode:
      if (!gpc_reg_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !gpc_reg_operand (operands[1], E_DImode)
          || !(
#line 2547 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_CMPB && TARGET_POPCNTB) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
        return -1;
      return 142; /* paritydi2_cmpb */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 4410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2316; /* rs6000_vprtybv8hi2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 4410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2317; /* rs6000_vprtybv4si2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 4410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2318; /* rs6000_vprtybv2di2 */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 4410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2319; /* rs6000_vprtybv1ti2 */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode)
          || !
#line 4410 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P9_VECTOR))
        return -1;
      return 2320; /* rs6000_vprtybti2 */

    default:
      return -1;
    }
}

 int
recog_71 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1))
    {
    case 0:
      if (!
#line 6840 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 483; /* floorsf2 */

    case 1:
      if (!
#line 6840 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FPRND))
        return -1;
      return 484; /* floordf2 */

    case 2:
      if (!(
#line 15447 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
        return -1;
      return 1175; /* floorkf2 */

    case 3:
      if (!(
#line 15447 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
        return -1;
      return 1176; /* floortf2 */

    case 4:
      if (vsx_register_operand (operands[0], E_V4SFmode)
          && vsx_register_operand (operands[1], E_V4SFmode)
          && 
#line 2339 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
        return 1415; /* vsx_floorv4sf2 */
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 2589 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2107; /* *altivec_vrfim */

    case 5:
      if (!
#line 2339 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1416; /* vsx_floorv2df2 */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!base_reg_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !fusion_addis_mem_combo_load (operands[1], E_QImode)
          || !
#line 14733 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 1068; /* *fusion_gpr_load_qi */

    case E_HImode:
      if (!base_reg_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !fusion_addis_mem_combo_load (operands[1], E_HImode)
          || !
#line 14733 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION))
        return -1;
      return 1069; /* *fusion_gpr_load_hi */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!gpc_reg_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!gpc_reg_operand (operands[1], E_SFmode)
          || !
#line 6776 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
        return -1;
      return 473; /* lrintsfdi2 */

    case E_DFmode:
      if (!gpc_reg_operand (operands[1], E_DFmode)
          || !
#line 6776 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTID))
        return -1;
      return 474; /* lrintdfdi2 */

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V16QImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V16QImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!const_0_to_12_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !
#line 4423 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1565; /* vreplace_un_si */

    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !
#line 4423 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1566; /* vreplace_un_sf */

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !
#line 4423 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1567; /* vreplace_un_di */

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !
#line 4423 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1568; /* vreplace_un_df */

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 32:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (pattern292 (x2))
        {
        case 0:
          if (!
#line 2523 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB))
            return -1;
          return 137; /* popcntbsi2 */

        case 1:
          if (!(
#line 2523 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POPCNTB) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 138; /* popcntbdi2 */

        default:
          return -1;
        }

    case 50:
      return recog_61 (x1, insn, pnum_clobbers);

    case 33:
      return recog_77 (x1, insn, pnum_clobbers);

    case 46:
      return recog_76 (x1, insn, pnum_clobbers);

    case 85:
      return recog_74 (x1, insn, pnum_clobbers);

    case 54:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5861 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWAX))
        return -1;
      return 401; /* lfiwax */

    case 55:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!reg_or_indexed_operand (operands[1], E_SImode)
          || !
#line 5963 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_LFIWZX))
        return -1;
      return 410; /* lfiwzx */

    case 5:
      switch (pattern155 (x1, 
FIX))
        {
        case 0:
          if (!
#line 6669 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 464; /* fctiwz_sf */

        case 1:
          if (!
#line 6669 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 465; /* fctiwz_df */

        default:
          return -1;
        }

    case 56:
      switch (pattern155 (x1, 
UNSIGNED_FIX))
        {
        case 0:
          if (!
#line 6680 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 466; /* fctiwuz_sf */

        case 1:
          if (!
#line 6680 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && TARGET_FCTIWUZ))
            return -1;
          return 467; /* fctiwuz_df */

        default:
          return -1;
        }

    case 53:
      return recog_94 (x1, insn, pnum_clobbers);

    case 52:
      return recog_93 (x1, insn, pnum_clobbers);

    case 9:
      return recog_62 (x1, insn, pnum_clobbers);

    case 8:
      return recog_72 (x1, insn, pnum_clobbers);

    case 6:
      return recog_71 (x1, insn, pnum_clobbers);

    case 7:
      return recog_68 (x1, insn, pnum_clobbers);

    case 10:
      return recog_84 (x1, insn, pnum_clobbers);

    case 31:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_DImode)
          || !
#line 6880 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_PPC_GFXOPT))
        return -1;
      return 489; /* stfiwx */

    case 87:
      return recog_75 (x1, insn, pnum_clobbers);

    case 86:
      return recog_69 (x1, insn, pnum_clobbers);

    case 97:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 8733 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 597; /* xxspltidp_sf_internal */

        case 1:
          if (!
#line 8733 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 598; /* xxspltidp_df_internal */

        default:
          return -1;
        }

    case 98:
      switch (pattern157 (x1))
        {
        case 0:
          if (!
#line 8742 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 599; /* xxspltiw_sf_internal */

        case 1:
          if (!
#line 8742 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWER10))
            return -1;
          return 600; /* xxspltiw_df_internal */

        default:
          return -1;
        }

    case 60:
      return recog_88 (x1, insn, pnum_clobbers);

    case 62:
      return recog_73 (x1, insn, pnum_clobbers);

    case 64:
      return recog_63 (x1, insn, pnum_clobbers);

    case 15:
      return recog_87 (x1, insn, pnum_clobbers);

    case 2:
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 96
          || GET_MODE (x3) != E_SImode
          || !
#line 11135 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(DEFAULT_ABI == ABI_V4 && flag_pic == 1 && TARGET_32BIT))
        return -1;
      return 796; /* load_toc_v4_pic_si */

    case 73:
      return recog_83 (x1, insn, pnum_clobbers);

    case 83:
      return recog_82 (x1, insn, pnum_clobbers);

    case 84:
      return recog_92 (x1, insn, pnum_clobbers);

    case 36:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1214; /* *hwsync */

    case 37:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      return 1215; /* *lwsync */

    case 72:
      return recog_86 (x1, insn, pnum_clobbers);

    case 122:
      return recog_81 (x1, insn, pnum_clobbers);

    case 19:
      if (GET_MODE (x2) != E_CCmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!cc_reg_operand (operands[0], E_CCmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2214 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1391; /* *xvtlsbb_internal */

    case 124:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 2308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1404; /* vsx_xsrdpi */

        case 1:
          if (!
#line 2308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1405; /* vsx_xvrspi */

        case 2:
          if (!
#line 2308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1406; /* vsx_xvrdpi */

        default:
          return -1;
        }

    case 125:
      switch (pattern158 (x1))
        {
        case 0:
          if (!
#line 2316 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (DFmode)))
            return -1;
          return 1407; /* vsx_xsrdpic */

        case 1:
          if (!
#line 2316 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          return 1408; /* vsx_xvrspic */

        case 2:
          if (!
#line 2316 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          return 1409; /* vsx_xvrdpic */

        default:
          return -1;
        }

    case 107:
      return recog_66 (x1, insn, pnum_clobbers);

    case 108:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 2427 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1425; /* vsx_xvcvhpsp */

    case 143:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SFmode)
          || !
#line 2436 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
        return -1;
      return 1426; /* vsx_xvcvsphp */

    case 110:
      return recog_91 (x1, insn, pnum_clobbers);

    case 109:
      return recog_80 (x1, insn, pnum_clobbers);

    case 105:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2596 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1440; /* vsx_xvcvdpsxws */

    case 106:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DFmode)
          || !
#line 2604 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1441; /* vsx_xvcvdpuxws */

    case 113:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2612 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1442; /* vsx_xvcvsxdsp */

    case 114:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V2DImode)
          || !
#line 2620 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V2DFmode)))
        return -1;
      return 1443; /* vsx_xvcvuxdsp */

    case 111:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2661 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1448; /* vsx_xvcvsxwdp_df */

    case 112:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V4SImode)
          || !
#line 2669 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_VSX))
        return -1;
      return 1449; /* vsx_xvcvuxwdp_df */

    case 139:
      return recog_67 (x1, insn, pnum_clobbers);

    case 190:
      if (GET_MODE (x2) != E_TImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!gpc_reg_operand (operands[0], E_TImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!gpc_reg_operand (operands[1], E_TImode)
          || !
#line 5187 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1658; /* extendditi2_vector */

    case 146:
      return recog_90 (x1, insn, pnum_clobbers);

    case 147:
      return recog_89 (x1, insn, pnum_clobbers);

    case 155:
      switch (pattern159 (x1))
        {
        case 0:
          if (!
#line 5463 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1687; /* xvxexpsp */

        case 1:
          if (!
#line 5463 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1688; /* xvxexpdp */

        default:
          return -1;
        }

    case 156:
      switch (pattern159 (x1))
        {
        case 0:
          if (!
#line 5473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1689; /* xvxsigsp */

        case 1:
          if (!
#line 5473 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_P9_VECTOR))
            return -1;
          return 1690; /* xvxsigdp */

        default:
          return -1;
        }

    case 141:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1736; /* vsx_xvcvspbf16 */

    case 140:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!vsx_register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!vsx_register_operand (operands[1], E_V16QImode)
          || !
#line 6447 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1737; /* vsx_xvcvbf16spn */

    case 189:
      return recog_64 (x1, insn, pnum_clobbers);

    case 192:
      return recog_65 (x1, insn, pnum_clobbers);

    case 204:
      return recog_78 (x1, insn, pnum_clobbers);

    case 205:
      if (GET_MODE (x2) != E_V2DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!c32bit_cint_operand (operands[1], E_SImode)
          || !
#line 6628 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_POWER10))
        return -1;
      return 1777; /* xxspltidp_v2df_inst */

    case 356:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1920; /* vstrir_direct_v8hi */

        case 1:
          if (!
#line 907 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1921; /* vstrir_direct_v16qi */

        default:
          return -1;
        }

    case 357:
      switch (pattern160 (x1))
        {
        case 0:
          if (!
#line 959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1924; /* vstril_direct_v8hi */

        case 1:
          if (!
#line 959 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return -1;
          return 1925; /* vstril_direct_v16qi */

        default:
          return -1;
        }

    case 360:
      return recog_85 (x1, insn, pnum_clobbers);

    case 256:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2581 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2106; /* altivec_vrfin */

    case 261:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2112; /* altivec_vlogefp */

    case 262:
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V4SFmode)
          || !
#line 2643 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2113; /* altivec_vexptefp */

    case 264:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2693 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2126; /* altivec_vupkhsw */

        case 1:
          if (!
#line 2693 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2127; /* altivec_vupkhsh */

        case 2:
          if (!
#line 2693 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2128; /* altivec_vupkhsb */

        default:
          return -1;
        }

    case 266:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2706 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2129; /* altivec_vupkhsw_direct */

        case 1:
          if (!
#line 2706 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2130; /* altivec_vupkhsh_direct */

        case 2:
          if (!
#line 2706 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2131; /* altivec_vupkhsb_direct */

        default:
          return -1;
        }

    case 265:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2714 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2132; /* altivec_vupklsw */

        case 1:
          if (!
#line 2714 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2133; /* altivec_vupklsh */

        case 2:
          if (!
#line 2714 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2134; /* altivec_vupklsb */

        default:
          return -1;
        }

    case 267:
      switch (pattern161 (x1))
        {
        case 0:
          if (!
#line 2727 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return -1;
          return 2135; /* *altivec_vupklsw_direct */

        case 1:
          if (!
#line 2727 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return -1;
          return 2136; /* *altivec_vupklsh_direct */

        case 2:
          if (!
#line 2727 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return -1;
          return 2137; /* *altivec_vupklsb_direct */

        default:
          return -1;
        }

    case 268:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2735 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2138; /* altivec_vupkhpx */

    case 269:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V8HImode)
          || !
#line 2748 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2139; /* altivec_vupklpx */

    case 162:
      switch (pattern162 (x1))
        {
        case 0:
          if (!
#line 3020 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2167; /* altivec_lvsl_reg_si */

        case 1:
          if (!(
#line 3020 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2168; /* altivec_lvsl_reg_di */

        default:
          return -1;
        }

    case 276:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3028 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2169; /* altivec_lvsl_direct */

    case 163:
      switch (pattern162 (x1))
        {
        case 0:
          if (!
#line 3058 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
            return -1;
          return 2170; /* altivec_lvsr_reg_si */

        case 1:
          if (!(
#line 3058 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2171; /* altivec_lvsr_reg_di */

        default:
          return -1;
        }

    case 277:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_V16QImode)
          || !
#line 3066 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
        return -1;
      return 2172; /* altivec_lvsr_direct */

    case 281:
      return recog_70 (x1, insn, pnum_clobbers);

    case 301:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4247 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2293; /* altivec_lvlx */

    case 302:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4255 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2294; /* altivec_lvlxl */

    case 303:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4263 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2295; /* altivec_lvrx */

    case 304:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 4271 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && rs6000_cpu == PROCESSOR_CELL))
        return -1;
      return 2296; /* altivec_lvrxl */

    case 329:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V16QImode)
          || !
#line 4419 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
        return -1;
      return 2321; /* p8v_vgbbd */

    case 421:
      if (GET_MODE (x2) != E_XOmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 510 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2362; /* mma_xxmfacc */

    case 422:
      if (GET_MODE (x2) != E_XOmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!fpr_reg_operand (operands[0], E_XOmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!fpr_reg_operand (operands[1], E_XOmode)
          || !
#line 510 "../../gcc-15.0.1-20250313/gcc/config/rs6000/mma.md"
(TARGET_MMA))
        return -1;
      return 2363; /* mma_xxmtacc */

    case 424:
      if (GET_MODE (x2) != E_DDmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_DDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_SDmode)
          || !
#line 41 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], DDmode)
   || gpc_reg_operand (operands[1], SDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2423; /* movsd_store */

    case 423:
      if (GET_MODE (x2) != E_SDmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!nonimmediate_operand (operands[0], E_SDmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!input_operand (operands[1], E_DDmode)
          || !
#line 51 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
((gpc_reg_operand (operands[0], SDmode)
   || gpc_reg_operand (operands[1], DDmode))
   && TARGET_HARD_FLOAT))
        return -1;
      return 2424; /* movsd_load */

    case 437:
      return recog_79 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_130 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_123 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      switch (XVECLEN (x3, 0))
        {
        case 2:
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          x8 = XVECEXP (x3, 0, 0);
          operands[3] = x8;
          if (!const_0_to_1_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          operands[4] = x9;
          if (!const_2_to_3_operand (operands[4], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V2DFmode:
              if (pattern510 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                  || !
#line 3855 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DFmode)))
                return -1;
              return 1512; /* vsx_xxpermdi2_v2df_1 */

            case E_V2DImode:
              if (pattern510 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                  || !
#line 3855 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_MEM_VSX_P (V2DImode)))
                return -1;
              return 1513; /* vsx_xxpermdi2_v2di_1 */

            default:
              return -1;
            }

        case 16:
          if (pattern224 (x3) != 0
              || pattern537 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 16L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 17L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 18L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 19L)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 4L)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 20L)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 5L)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 21L)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 6L)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 22L)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 7L)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 23L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1177 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1958; /* altivec_vmrghb_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1351 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1968; /* altivec_vmrglb_direct_le */

            case 8L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 24L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 9L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 25L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 10L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 26L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 11L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 27L)
                return -1;
              x16 = XVECEXP (x3, 0, 8);
              if (XWINT (x16, 0) != 12L)
                return -1;
              x17 = XVECEXP (x3, 0, 9);
              if (XWINT (x17, 0) != 28L)
                return -1;
              x18 = XVECEXP (x3, 0, 10);
              if (XWINT (x18, 0) != 13L)
                return -1;
              x19 = XVECEXP (x3, 0, 11);
              if (XWINT (x19, 0) != 29L)
                return -1;
              x20 = XVECEXP (x3, 0, 12);
              if (XWINT (x20, 0) != 14L)
                return -1;
              x21 = XVECEXP (x3, 0, 13);
              if (XWINT (x21, 0) != 30L)
                return -1;
              x22 = XVECEXP (x3, 0, 14);
              if (XWINT (x22, 0) != 15L)
                return -1;
              x23 = XVECEXP (x3, 0, 15);
              if (XWINT (x23, 0) != 31L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1959; /* altivec_vmrghb_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1967; /* altivec_vmrglb_direct_be */

            default:
              return -1;
            }

        case 8:
          if (pattern225 (x3) != 0
              || pattern537 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 8L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 1L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 9L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 2L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 10L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 3L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 11L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[1] = x6;
              x7 = XEXP (x5, 1);
              operands[2] = x7;
              if (
#line 1224 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return 1960; /* altivec_vmrghh_direct_be */
              operands[2] = x6;
              operands[1] = x7;
              if (!
#line 1394 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return -1;
              return 1970; /* altivec_vmrglh_direct_le */

            case 4L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 12L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 5L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 13L)
                return -1;
              x12 = XVECEXP (x3, 0, 4);
              if (XWINT (x12, 0) != 6L)
                return -1;
              x13 = XVECEXP (x3, 0, 5);
              if (XWINT (x13, 0) != 14L)
                return -1;
              x14 = XVECEXP (x3, 0, 6);
              if (XWINT (x14, 0) != 7L)
                return -1;
              x15 = XVECEXP (x3, 0, 7);
              if (XWINT (x15, 0) != 15L)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              x7 = XEXP (x5, 1);
              operands[1] = x7;
              if (
#line 1238 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                return 1961; /* altivec_vmrghh_direct_le */
              operands[1] = x6;
              operands[2] = x7;
              if (!
#line 1380 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                return -1;
              return 1969; /* altivec_vmrglh_direct_be */

            default:
              return -1;
            }

        case 4:
          if (pattern226 (x3) != 0)
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          switch (XWINT (x8, 0))
            {
            case 0L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 4L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              switch (XWINT (x10, 0))
                {
                case 1L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 5L)
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SFmode:
                      if (pattern537 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1962; /* altivec_vmrghw_direct_v4sf_be */
                      if (
#line 1295 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                        return 1966; /* *altivec_vmrghsf */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1973; /* altivec_vmrglw_direct_v4sf_le */

                    case E_V4SImode:
                      if (pattern537 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                        return -1;
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      x6 = XEXP (x5, 0);
                      operands[1] = x6;
                      if (
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                        return 1963; /* altivec_vmrghw_direct_v4si_be */
                      operands[1] = x7;
                      operands[2] = x6;
                      if (!
#line 1437 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                        return -1;
                      return 1974; /* altivec_vmrglw_direct_v4si_le */

                    default:
                      return -1;
                    }

                case 2L:
                  x11 = XVECEXP (x3, 0, 3);
                  if (XWINT (x11, 0) != 6L)
                    return -1;
                  switch (pattern539 (x2))
                    {
                    case 0:
                      if (!
#line 1487 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1976; /* p8_vmrgew_v4sf */

                    case 1:
                      if (!
#line 1487 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                        return -1;
                      return 1977; /* p8_vmrgew_v4si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 2L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 6L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7L)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern537 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1964; /* altivec_vmrghw_direct_v4sf_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (
#line 1423 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return 1971; /* altivec_vmrglw_direct_v4sf_be */
                  if (!
#line 1451 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_MEM_ALTIVEC_P (V4SFmode)))
                    return -1;
                  return 1975; /* *altivec_vmrglsf */

                case E_V4SImode:
                  if (pattern537 (x2, 
E_V4SImode, 
E_V8SImode) != 0)
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[1] = x7;
                  x6 = XEXP (x5, 0);
                  operands[2] = x6;
                  if (
#line 1281 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && !BYTES_BIG_ENDIAN))
                    return 1965; /* altivec_vmrghw_direct_v4si_le */
                  operands[2] = x7;
                  operands[1] = x6;
                  if (!
#line 1423 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && BYTES_BIG_ENDIAN))
                    return -1;
                  return 1972; /* altivec_vmrglw_direct_v4si_be */

                default:
                  return -1;
                }

            case 1L:
              x9 = XVECEXP (x3, 0, 1);
              if (XWINT (x9, 0) != 5L)
                return -1;
              x10 = XVECEXP (x3, 0, 2);
              if (XWINT (x10, 0) != 3L)
                return -1;
              x11 = XVECEXP (x3, 0, 3);
              if (XWINT (x11, 0) != 7L)
                return -1;
              switch (pattern539 (x2))
                {
                case 0:
                  if (!
#line 1504 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1978; /* p8_vmrgow_v4sf */

                case 1:
                  if (!
#line 1504 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_P8_VECTOR))
                    return -1;
                  return 1979; /* p8_vmrgow_v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1641; /* *vsx_reduc_plus_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1644; /* *vsx_reduc_plus_v4sf_scalar */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1642; /* *vsx_reduc_smin_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1645; /* *vsx_reduc_smin_v4sf_scalar */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern176 (x2, pnum_clobbers))
        {
        case 0:
          if (!
#line 4997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V2DFmode)))
            return -1;
          *pnum_clobbers = 1;
          return 1643; /* *vsx_reduc_smax_v2df_scalar */

        case 1:
          if (!
#line 5024 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(BYTES_BIG_ENDIAN && VECTOR_UNIT_VSX_P (V4SFmode)))
            return -1;
          *pnum_clobbers = 3;
          return 1646; /* *vsx_reduc_smax_v4sf_scalar */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_140 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!gpc_reg_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          if (reg_or_mem_operand (operands[1], E_SFmode)
              && 
#line 5241 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && !HONOR_SNANS (SFmode)))
            return 328; /* *extendsfdf2_fpr */
          if (!gpc_reg_operand (operands[1], E_SFmode)
              || !
#line 5262 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT && HONOR_SNANS (SFmode)))
            return -1;
          return 329; /* *extendsfdf2_snan */

        case E_IFmode:
          switch (pattern205 (x3))
            {
            case 0:
              if (!(
#line 8930 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return -1;
              return 613; /* extenddfif2_vsx */

            case 1:
              if (!
#line 9461 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)))
                return -1;
              return 639; /* *extendtfif2_internal */

            default:
              return -1;
            }

        case E_TFmode:
          if (GET_MODE (x3) != E_TFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_TFmode))
            {
              switch (pattern316 ())
                {
                case 0:
                  if ((
#line 8930 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_LONG_DOUBLE_128 && TARGET_VSX) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                    return 614; /* extenddftf2_vsx */
                  break;

                case 1:
                  if (
#line 9448 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (IFmode)))
                    return 637; /* *extendiftf2_internal */
                  break;

                case 2:
                  if (
#line 9448 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)))
                    return 638; /* *extendkftf2_internal */
                  break;

                default:
                  break;
                }
            }
          if (altivec_register_operand (operands[0], E_TFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (altivec_register_operand (operands[1], E_SFmode)
                      && (
#line 15201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1122; /* extendsftf2_hw */
                  break;

                case E_DFmode:
                  if (altivec_register_operand (operands[1], E_DFmode)
                      && (
#line 15201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 635 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (TFmode))))
                    return 1124; /* extenddftf2_hw */
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_TFmode)
              || !vsx_register_operand (operands[1], E_KFmode)
              || !
#line 15211 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD))
            return -1;
          return 1125; /* *extendkftf2 */

        case E_KFmode:
          if (GET_MODE (x3) != E_KFmode)
            return -1;
          if (gpc_reg_operand (operands[0], E_KFmode)
              && gpc_reg_operand (operands[1], E_TFmode)
              && 
#line 9461 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE
    && FLOAT128_IBM_P (TFmode) == FLOAT128_IBM_P (KFmode)))
            return 640; /* *extendtfkf2_internal */
          if (altivec_register_operand (operands[0], E_KFmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_SFmode:
                  if (altivec_register_operand (operands[1], E_SFmode)
                      && (
#line 15201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1121; /* extendsfkf2_hw */
                  break;

                case E_DFmode:
                  if (altivec_register_operand (operands[1], E_DFmode)
                      && (
#line 15201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_HW) && 
#line 634 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IEEE_P (KFmode))))
                    return 1123; /* extenddfkf2_hw */
                  break;

                default:
                  break;
                }
            }
          if (!vsx_register_operand (operands[0], E_KFmode)
              || !vsx_register_operand (operands[1], E_TFmode)
              || !
#line 15227 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_FLOAT128_TYPE && TARGET_IEEEQUAD))
            return -1;
          return 1126; /* *extendtfkf2 */

        case E_DDmode:
          if (!gpc_reg_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !gpc_reg_operand (operands[1], E_SDmode)
              || !
#line 62 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2425; /* extendsddd2 */

        case E_TDmode:
          if (!gpc_reg_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !gpc_reg_operand (operands[1], E_DDmode)
              || !
#line 140 "../../gcc-15.0.1-20250313/gcc/config/rs6000/dfp.md"
(TARGET_DFP))
            return -1;
          return 2433; /* extendddtd2 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern7 (x3, 
E_V2DFmode))
        {
        case 0:
          if (!
#line 2371 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode) && BYTES_BIG_ENDIAN))
            return -1;
          return 1420; /* vsx_xvcvspdp_be */

        case 1:
          if (!
#line 2380 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(VECTOR_UNIT_VSX_P (V4SFmode) && !BYTES_BIG_ENDIAN))
            return -1;
          return 1421; /* vsx_xvcvspdp_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_151 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case SYMBOL_REF:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern123 (x3, 
E_SImode) == 0)
            return 275; /* rotlsi3 */
          break;

        case E_DImode:
          if (pattern123 (x3, 
E_DImode) == 0
              && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
            return 276; /* rotldi3 */
          break;

        case E_V4SImode:
          if (pattern3 (x3, 
E_V4SImode) == 0
              && 
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V4SImode)))
            return 2016; /* altivec_vrlw */
          break;

        case E_V8HImode:
          if (pattern3 (x3, 
E_V8HImode) == 0
              && 
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V8HImode)))
            return 2017; /* altivec_vrlh */
          break;

        case E_V16QImode:
          if (pattern3 (x3, 
E_V16QImode) == 0
              && 
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_ALTIVEC_P (V16QImode)))
            return 2018; /* altivec_vrlb */
          break;

        case E_V2DImode:
          if (pattern3 (x3, 
E_V2DImode) == 0
              && 
#line 1989 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(VECTOR_UNIT_P8_VECTOR_P (V2DImode)))
            return 2019; /* altivec_vrld */
          break;

        case E_V1TImode:
          if (pattern2 (x3, 
E_V1TImode) == 0
              && 
#line 1997 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_POWER10))
            return 2020; /* altivec_vrlq */
          break;

        default:
          break;
        }
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (!nonimmediate_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !input_operand (operands[1], E_V1TImode)
              || !
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return -1;
          return 1271; /* *vsx_le_permute_v1ti */

        case E_TImode:
          if (!nonimmediate_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !input_operand (operands[1], E_TImode)
              || !
#line 1003 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR))
            return -1;
          return 1272; /* *vsx_le_permute_ti */

        default:
          return -1;
        }

    case ROTATE:
      x6 = XEXP (x4, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      switch (pattern215 (x3))
        {
        case 0:
          if (!
#line 1021 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX))
            return -1;
          return 1273; /* *vsx_le_undo_permute_v1ti */

        case 1:
          if (!
#line 1021 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX))
            return -1;
          return 1274; /* *vsx_le_undo_permute_ti */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_160 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 98)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 98)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  x9 = XEXP (x8, 1);
  operands[2] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (pattern549 (x1, 
E_SImode) != 0)
        return -1;
      return 88; /* *addsi3_carry_in_internal */

    case E_DImode:
      if (pattern549 (x1, 
E_DImode) != 0
          || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
        return -1;
      return 89; /* *adddi3_carry_in_internal */

    default:
      return -1;
    }
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern198 (x1) != 0)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_DImode:
      if (!gpc_reg_operand (operands[3], E_DImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_SImode:
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_SImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern587 (x7, 
E_SImode) != 0
                  || !(
#line 10308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && (((((
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 709; /* *movsi_update2 */

            case E_DImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern587 (x7, 
E_DImode) != 0
                  || !(
#line 10308 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && !avoiding_indexed_address_p (DImode)) && (((((
#line 496 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 710; /* *movsi_update2 */

            default:
              return -1;
            }

        case E_HImode:
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_SImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern551 (x7, 
E_SImode) != 0
                  || !(
#line 10389 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))))
                return -1;
              return 721; /* *movhi_update3 */

            case E_DImode:
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 1);
              if (pattern551 (x7, 
E_DImode) != 0
                  || !(
#line 10389 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && (((((
#line 493 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))))
                return -1;
              return 723; /* *movhi_update3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_SImode:
      if (!gpc_reg_operand (operands[3], E_SImode))
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_SImode) != 0
              || !(
#line 10389 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            return -1;
          return 720; /* *movhi_update3 */

        case E_DImode:
          x6 = XVECEXP (x1, 0, 1);
          x7 = XEXP (x6, 1);
          if (pattern551 (x7, 
E_DImode) != 0
              || !(
#line 10389 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_UPDATE
   && !(avoiding_indexed_address_p (HImode)
	&& gpc_reg_operand (operands[2], Pmode))) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return -1;
          return 722; /* *movhi_update3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_169 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (pattern355 (x1))
        {
        case 0:
          if (!
#line 4472 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], SImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, SImode)))
            return -1;
          return 270; /* *iorsi_mask */

        case 1:
          if (!(
#line 4472 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!logical_const_operand (operands[2], DImode)
   && rs6000_is_valid_mask (operands[2], NULL, NULL, DImode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 271; /* *iordi_mask */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern252 (x4) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      switch (pattern526 (x1))
        {
        case 0:
          if (!
#line 4528 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 8))
            return -1;
          return 272; /* *rotldi3_insert_sf */

        case 1:
          if (!
#line 4528 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 16))
            return -1;
          return 273; /* *rotldi3_insert_sf */

        case 2:
          if (!
#line 4528 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64 && INTVAL (operands[2]) == 32))
            return -1;
          return 274; /* *rotldi3_insert_sf */

        default:
          return -1;
        }

    case NOT:
      return recog_163 (x1, insn, pnum_clobbers);

    case AND:
      switch (pattern247 (x1))
        {
        case 0:
          if (!
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2623; /* *fuse_and_or */

        case 1:
          if (!(
#line 1195 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2624; /* *fuse_and_or */

        case 2:
          if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3099; /* *fuse_vand_vor */

        case 3:
          if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3100; /* *fuse_vand_vor */

        case 4:
          if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3101; /* *fuse_vand_vor */

        case 5:
          if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3102; /* *fuse_vand_vor */

        case 6:
          if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3103; /* *fuse_vand_vor */

        case 7:
          if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3104; /* *fuse_vand_vor */

        case 8:
          if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3105; /* *fuse_vand_vor */

        case 9:
          if (!
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3106; /* *fuse_vand_vor */

        case 10:
          if (!(
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3107; /* *fuse_vand_vor */

        case 11:
          if (!(
#line 2599 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3108; /* *fuse_vand_vor */

        case 12:
          if (!
#line 1375 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2643; /* *fuse_and_orc */

        case 13:
          if (!(
#line 1375 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2644; /* *fuse_and_orc */

        case 14:
          if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3179; /* *fuse_vand_vorc */

        case 15:
          if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3180; /* *fuse_vand_vorc */

        case 16:
          if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3181; /* *fuse_vand_vorc */

        case 17:
          if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3182; /* *fuse_vand_vorc */

        case 18:
          if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3183; /* *fuse_vand_vorc */

        case 19:
          if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3184; /* *fuse_vand_vorc */

        case 20:
          if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3185; /* *fuse_vand_vorc */

        case 21:
          if (!
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3186; /* *fuse_vand_vorc */

        case 22:
          if (!(
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3187; /* *fuse_vand_vorc */

        case 23:
          if (!(
#line 2743 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3188; /* *fuse_vand_vorc */

        case 24:
          if (!
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2625; /* *fuse_andc_or */

        case 25:
          if (!(
#line 1213 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2626; /* *fuse_andc_or */

        case 26:
          if (!
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3109; /* *fuse_vandc_vor */

        case 27:
          if (!
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3110; /* *fuse_vandc_vor */

        case 28:
          if (!
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3111; /* *fuse_vandc_vor */

        case 29:
          if (!
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3112; /* *fuse_vandc_vor */

        case 30:
          if (!
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3113; /* *fuse_vandc_vor */

        case 31:
          if (!
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3114; /* *fuse_vandc_vor */

        case 32:
          if (!
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3115; /* *fuse_vandc_vor */

        case 33:
          if (!
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3116; /* *fuse_vandc_vor */

        case 34:
          if (!(
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3117; /* *fuse_vandc_vor */

        case 35:
          if (!(
#line 2617 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3118; /* *fuse_vandc_vor */

        case 36:
          if (!
#line 1393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2645; /* *fuse_andc_orc */

        case 37:
          if (!(
#line 1393 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2646; /* *fuse_andc_orc */

        case 38:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3189; /* *fuse_vandc_vorc */

        case 39:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3190; /* *fuse_vandc_vorc */

        case 40:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3191; /* *fuse_vandc_vorc */

        case 41:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3192; /* *fuse_vandc_vorc */

        case 42:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3193; /* *fuse_vandc_vorc */

        case 43:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3194; /* *fuse_vandc_vorc */

        case 44:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3195; /* *fuse_vandc_vorc */

        case 45:
          if (!
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3196; /* *fuse_vandc_vorc */

        case 46:
          if (!(
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3197; /* *fuse_vandc_vorc */

        case 47:
          if (!(
#line 2761 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3198; /* *fuse_vandc_vorc */

        case 48:
          if (!
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2631; /* *fuse_nor_or */

        case 49:
          if (!(
#line 1267 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2632; /* *fuse_nor_or */

        case 50:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3139; /* *fuse_vnor_vor */

        case 51:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3140; /* *fuse_vnor_vor */

        case 52:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3141; /* *fuse_vnor_vor */

        case 53:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3142; /* *fuse_vnor_vor */

        case 54:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3143; /* *fuse_vnor_vor */

        case 55:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3144; /* *fuse_vnor_vor */

        case 56:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3145; /* *fuse_vnor_vor */

        case 57:
          if (!
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3146; /* *fuse_vnor_vor */

        case 58:
          if (!(
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3147; /* *fuse_vnor_vor */

        case 59:
          if (!(
#line 2671 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3148; /* *fuse_vnor_vor */

        case 60:
          if (!
#line 1447 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2651; /* *fuse_nor_orc */

        case 61:
          if (!(
#line 1447 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2652; /* *fuse_nor_orc */

        case 62:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3219; /* *fuse_vnor_vorc */

        case 63:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3220; /* *fuse_vnor_vorc */

        case 64:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3221; /* *fuse_vnor_vorc */

        case 65:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3222; /* *fuse_vnor_vorc */

        case 66:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3223; /* *fuse_vnor_vorc */

        case 67:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3224; /* *fuse_vnor_vorc */

        case 68:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3225; /* *fuse_vnor_vorc */

        case 69:
          if (!
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3226; /* *fuse_vnor_vorc */

        case 70:
          if (!(
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3227; /* *fuse_vnor_vorc */

        case 71:
          if (!(
#line 2815 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3228; /* *fuse_vnor_vorc */

        default:
          return -1;
        }

    case IOR:
      switch (pattern248 (x1))
        {
        case 0:
          if (!
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2629; /* *fuse_nand_or */

        case 1:
          if (!(
#line 1249 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2630; /* *fuse_nand_or */

        case 2:
          if (!
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3129; /* *fuse_vnand_vor */

        case 3:
          if (!
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3130; /* *fuse_vnand_vor */

        case 4:
          if (!
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3131; /* *fuse_vnand_vor */

        case 5:
          if (!
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3132; /* *fuse_vnand_vor */

        case 6:
          if (!
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3133; /* *fuse_vnand_vor */

        case 7:
          if (!
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3134; /* *fuse_vnand_vor */

        case 8:
          if (!
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3135; /* *fuse_vnand_vor */

        case 9:
          if (!
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3136; /* *fuse_vnand_vor */

        case 10:
          if (!(
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3137; /* *fuse_vnand_vor */

        case 11:
          if (!(
#line 2653 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3138; /* *fuse_vnand_vor */

        case 12:
          if (!
#line 1429 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2649; /* *fuse_nand_orc */

        case 13:
          if (!(
#line 1429 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2650; /* *fuse_nand_orc */

        case 14:
          if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3209; /* *fuse_vnand_vorc */

        case 15:
          if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3210; /* *fuse_vnand_vorc */

        case 16:
          if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3211; /* *fuse_vnand_vorc */

        case 17:
          if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3212; /* *fuse_vnand_vorc */

        case 18:
          if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3213; /* *fuse_vnand_vorc */

        case 19:
          if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3214; /* *fuse_vnand_vorc */

        case 20:
          if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3215; /* *fuse_vnand_vorc */

        case 21:
          if (!
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3216; /* *fuse_vnand_vorc */

        case 22:
          if (!(
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3217; /* *fuse_vnand_vorc */

        case 23:
          if (!(
#line 2797 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3218; /* *fuse_vnand_vorc */

        case 24:
          if (!
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2635; /* *fuse_orc_or */

        case 25:
          if (!(
#line 1303 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2636; /* *fuse_orc_or */

        case 26:
          if (!
#line 2707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3159; /* *fuse_vorc_vor */

        case 27:
          if (!
#line 2707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3160; /* *fuse_vorc_vor */

        case 28:
          if (!
#line 2707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3161; /* *fuse_vorc_vor */

        case 29:
          if (!
#line 2707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3162; /* *fuse_vorc_vor */

        case 30:
          if (!
#line 2707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3163; /* *fuse_vorc_vor */

        case 31:
          if (!
#line 2707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3164; /* *fuse_vorc_vor */

        case 32:
          if (!
#line 2707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3165; /* *fuse_vorc_vor */

        case 33:
          if (!
#line 2707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3166; /* *fuse_vorc_vor */

        case 34:
          if (!(
#line 2707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3167; /* *fuse_vorc_vor */

        case 35:
          if (!(
#line 2707 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3168; /* *fuse_vorc_vor */

        case 36:
          if (!
#line 1483 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2655; /* *fuse_orc_orc */

        case 37:
          if (!(
#line 1483 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2656; /* *fuse_orc_orc */

        case 38:
          if (!
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3239; /* *fuse_vorc_vorc */

        case 39:
          if (!
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3240; /* *fuse_vorc_vorc */

        case 40:
          if (!
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3241; /* *fuse_vorc_vorc */

        case 41:
          if (!
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3242; /* *fuse_vorc_vorc */

        case 42:
          if (!
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3243; /* *fuse_vorc_vorc */

        case 43:
          if (!
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3244; /* *fuse_vorc_vorc */

        case 44:
          if (!
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3245; /* *fuse_vorc_vorc */

        case 45:
          if (!
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3246; /* *fuse_vorc_vorc */

        case 46:
          if (!(
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3247; /* *fuse_vorc_vorc */

        case 47:
          if (!(
#line 2851 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3248; /* *fuse_vorc_vorc */

        case 48:
          if (!
#line 1285 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2633; /* *fuse_or_or */

        case 49:
          if (!(
#line 1285 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2634; /* *fuse_or_or */

        case 50:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3149; /* *fuse_vor_vor */

        case 51:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3150; /* *fuse_vor_vor */

        case 52:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3151; /* *fuse_vor_vor */

        case 53:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3152; /* *fuse_vor_vor */

        case 54:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3153; /* *fuse_vor_vor */

        case 55:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3154; /* *fuse_vor_vor */

        case 56:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3155; /* *fuse_vor_vor */

        case 57:
          if (!
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3156; /* *fuse_vor_vor */

        case 58:
          if (!(
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3157; /* *fuse_vor_vor */

        case 59:
          if (!(
#line 2689 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3158; /* *fuse_vor_vor */

        case 60:
          if (!
#line 1465 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2653; /* *fuse_or_orc */

        case 61:
          if (!(
#line 1465 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2654; /* *fuse_or_orc */

        case 62:
          if (!
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3229; /* *fuse_vor_vorc */

        case 63:
          if (!
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3230; /* *fuse_vor_vorc */

        case 64:
          if (!
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3231; /* *fuse_vor_vorc */

        case 65:
          if (!
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3232; /* *fuse_vor_vorc */

        case 66:
          if (!
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3233; /* *fuse_vor_vorc */

        case 67:
          if (!
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3234; /* *fuse_vor_vorc */

        case 68:
          if (!
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3235; /* *fuse_vor_vorc */

        case 69:
          if (!
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3236; /* *fuse_vor_vorc */

        case 70:
          if (!(
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3237; /* *fuse_vor_vorc */

        case 71:
          if (!(
#line 2833 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3238; /* *fuse_vor_vorc */

        default:
          return -1;
        }

    case XOR:
      switch (pattern249 (x1))
        {
        case 0:
          if (!
#line 1321 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2637; /* *fuse_xor_or */

        case 1:
          if (!(
#line 1321 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2638; /* *fuse_xor_or */

        case 2:
          if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3169; /* *fuse_vxor_vor */

        case 3:
          if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3170; /* *fuse_vxor_vor */

        case 4:
          if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3171; /* *fuse_vxor_vor */

        case 5:
          if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3172; /* *fuse_vxor_vor */

        case 6:
          if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3173; /* *fuse_vxor_vor */

        case 7:
          if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3174; /* *fuse_vxor_vor */

        case 8:
          if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3175; /* *fuse_vxor_vor */

        case 9:
          if (!
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3176; /* *fuse_vxor_vor */

        case 10:
          if (!(
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3177; /* *fuse_vxor_vor */

        case 11:
          if (!(
#line 2725 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3178; /* *fuse_vxor_vor */

        case 12:
          if (!
#line 1501 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2657; /* *fuse_xor_orc */

        case 13:
          if (!(
#line 1501 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2658; /* *fuse_xor_orc */

        case 14:
          if (!
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3249; /* *fuse_vxor_vorc */

        case 15:
          if (!
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3250; /* *fuse_vxor_vorc */

        case 16:
          if (!
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3251; /* *fuse_vxor_vorc */

        case 17:
          if (!
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3252; /* *fuse_vxor_vorc */

        case 18:
          if (!
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3253; /* *fuse_vxor_vorc */

        case 19:
          if (!
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3254; /* *fuse_vxor_vorc */

        case 20:
          if (!
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3255; /* *fuse_vxor_vorc */

        case 21:
          if (!
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 3256; /* *fuse_vxor_vorc */

        case 22:
          if (!(
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 200 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (KFmode))))
            return -1;
          return 3257; /* *fuse_vxor_vorc */

        case 23:
          if (!(
#line 2869 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 201 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(FLOAT128_VECTOR_P (TFmode))))
            return -1;
          return 3258; /* *fuse_vxor_vorc */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern251 (x1))
        {
        case 0:
          if (!
#line 1339 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2639; /* *fuse_add_or */

        case 1:
          if (!(
#line 1339 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2640; /* *fuse_add_or */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern251 (x1))
        {
        case 0:
          if (!
#line 1357 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)))
            return -1;
          return 2641; /* *fuse_subf_or */

        case 1:
          if (!(
#line 1357 "../../gcc-15.0.1-20250313/gcc/config/rs6000/fusion.md"
((TARGET_P10_FUSION)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return -1;
          return 2642; /* *fuse_subf_or */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_193 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_186 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_188 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          if (pattern16 (x1) == 0
              && 
#line 6081 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_FCFID && TARGET_HARD_FLOAT))
            return 415; /* *floatsidf2_internal */
          break;

        case 5:
          res = recog_189 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_190 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 10:
          switch (pattern18 (x1))
            {
            case 0:
              if ((
#line 12723 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode))))
                return 882; /* *cmpif_internal2 */
              break;

            case 1:
              if ((
#line 12723 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 630 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (IFmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return 883; /* *cmpif_internal2 */
              break;

            case 2:
              if ((
#line 12723 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && 
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode))))
                return 884; /* *cmptf_internal2 */
              break;

            case 3:
              if ((
#line 12723 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_XL_COMPAT
   && TARGET_HARD_FLOAT && TARGET_LONG_DOUBLE_128) && (
#line 631 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(FLOAT128_IBM_P (TFmode)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return 885; /* *cmptf_internal2 */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[0] = x1;
      if (XVECLEN (operands[0], 0) >= 1)
        {
          res = recog_191 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) >= 4
          && any_parallel_operand (operands[0], E_VOIDmode))
        {
          res = recog_192 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XVECLEN (operands[0], 0) < 5
          || !any_parallel_operand (operands[0], E_VOIDmode))
        return -1;
      x2 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x2) != USE)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG)
        return -1;
      x4 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x5))
        {
        case RETURN:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 96)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != USE)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          x10 = XEXP (x4, 0);
          operands[2] = x10;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          switch (REGNO (x3))
            {
            case 11:
              switch (pattern565 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1028; /* *return_and_restore_gpregs_si_r11 */

                case 1:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1034; /* *return_and_restore_fpregs_si_r11 */

                case 2:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1029; /* *return_and_restore_gpregs_di_r11 */

                case 3:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1035; /* *return_and_restore_fpregs_di_r11 */

                default:
                  return -1;
                }

            case 12:
              switch (pattern565 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1030; /* *return_and_restore_gpregs_si_r12 */

                case 1:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1036; /* *return_and_restore_fpregs_si_r12 */

                case 2:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1031; /* *return_and_restore_gpregs_di_r12 */

                case 3:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1037; /* *return_and_restore_fpregs_di_r12 */

                default:
                  return -1;
                }

            case 1:
              switch (pattern565 (x1))
                {
                case 0:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1032; /* *return_and_restore_gpregs_si_r1 */

                case 1:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  return 1038; /* *return_and_restore_fpregs_si_r1 */

                case 2:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1033; /* *return_and_restore_gpregs_di_r1 */

                case 3:
                  if (!
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  return 1039; /* *return_and_restore_fpregs_di_r1 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CLOBBER:
          x12 = XEXP (x5, 0);
          if (GET_CODE (x12) != REG
              || REGNO (x12) != 96)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x3) != 0)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          switch (REGNO (x9))
            {
            case 11:
              switch (pattern568 (x1))
                {
                case 0:
                  if (!(
#line 461 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1811; /* *save_vregs_si_r11 */

                case 1:
                  if (!(
#line 461 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1812; /* *save_vregs_di_r11 */

                case 2:
                  if (!(
#line 487 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1815; /* *restore_vregs_si_r11 */

                case 3:
                  if (!(
#line 487 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1816; /* *restore_vregs_di_r11 */

                default:
                  return -1;
                }

            case 12:
              switch (pattern568 (x1))
                {
                case 0:
                  if (!(
#line 474 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1813; /* *save_vregs_si_r12 */

                case 1:
                  if (!(
#line 474 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1814; /* *save_vregs_di_r12 */

                case 2:
                  if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    return -1;
                  return 1817; /* *restore_vregs_si_r12 */

                case 3:
                  if (!(
#line 500 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    return -1;
                  return 1818; /* *restore_vregs_di_r12 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 15:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!u5bit_cint_operand (operands[0], E_SImode)
                  || !
#line 6511 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 459; /* rs6000_mtfsb0 */

            case 16:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!u5bit_cint_operand (operands[0], E_SImode)
                  || !
#line 6518 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 460; /* rs6000_mtfsb1 */

            case 0:
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 867; /* blockage */

            case 18:
              if (GET_MODE (x1) != E_BLKmode)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 989; /* speculation_barrier */

            case 4:
              if (pnum_clobbers == NULL)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1044; /* eh_set_lr_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1045; /* eh_set_lr_di */

                default:
                  return -1;
                }

            case 5:
              if (GET_MODE (x1) != E_BLKmode)
                return -1;
              x5 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                  if (XWINT (x5, 0) != 0L)
                    return -1;
                  return 1216; /* isync */

                case REG:
                case SUBREG:
                  if (pnum_clobbers == NULL)
                    return -1;
                  operands[0] = x5;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_QImode:
                      if (!register_operand (operands[0], E_QImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1217; /* loadsync_qi */

                    case E_HImode:
                      if (!register_operand (operands[0], E_HImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1218; /* loadsync_hi */

                    case E_SImode:
                      if (!register_operand (operands[0], E_SImode))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1219; /* loadsync_si */

                    case E_DImode:
                      if (!register_operand (operands[0], E_DImode)
                          || !
#line 111 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_POWERPC64))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1220; /* loadsync_di */

                    case E_TImode:
                      if (!register_operand (operands[0], E_TImode)
                          || !
#line 112 "../../gcc-15.0.1-20250313/gcc/config/rs6000/sync.md"
(TARGET_SYNC_TI))
                        return -1;
                      *pnum_clobbers = 1;
                      return 1221; /* loadsync_ti */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case 24:
              x5 = XVECEXP (x1, 0, 0);
              if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || !
#line 2951 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2161; /* altivec_dssall */

            case 25:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!immediate_operand (operands[0], E_QImode)
                  || !
#line 2958 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC))
                return -1;
              return 2162; /* altivec_dss */

            default:
              return -1;
            }

        case 2:
          switch (XINT (x1, 1))
            {
            case 17:
              x5 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x5) != REG
                  || REGNO (x5) != 0
                  || GET_MODE (x5) != E_SImode)
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 96
                  || GET_MODE (x6) != E_SImode)
                return -1;
              return 1050; /* split_stack_return */

            case 13:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 14688 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1066; /* rs6000_mtfsf */

            case 14:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!gpc_reg_operand (operands[1], E_DFmode)
                  || !
#line 14695 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1067; /* rs6000_mtfsf_hi */

            case 96:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              if (!int_reg_operand (operands[0], E_DImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!simple_offsettable_mem_operand (operands[1], E_DImode)
                  || !
#line 15858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(rs6000_rop_protect))
                return -1;
              return 1213; /* hashchk */

            case 39:
              x5 = XVECEXP (x1, 0, 0);
              operands[0] = x5;
              x6 = XVECEXP (x1, 0, 1);
              operands[1] = x6;
              if (!u10bit_cint_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!gpc_reg_operand (operands[0], E_SImode)
                      || !
#line 280 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM))
                    return -1;
                  return 2507; /* htm_mtspr_si */

                case E_DImode:
                  if (!gpc_reg_operand (operands[0], E_DImode)
                      || !(
#line 280 "../../gcc-15.0.1-20250313/gcc/config/rs6000/htm.md"
(TARGET_HTM) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                    return -1;
                  return 2508; /* htm_mtspr_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case RETURN:
      if (!
#line 13515 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(direct_return ()))
        return -1;
      return 977; /* return */

    case SIMPLE_RETURN:
      return 978; /* simple_return */

    case UNSPEC:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          x5 = XVECEXP (x1, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (XINT (x1, 1))
            {
            case 57:
              return 987; /* nop */

            case 58:
              return 988; /* group_ending_nop */

            default:
              return -1;
            }

        case 3:
          x5 = XVECEXP (x1, 0, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XVECEXP (x1, 0, 2);
          operands[2] = x8;
          if (!immediate_operand (operands[2], E_QImode))
            return -1;
          switch (XINT (x1, 1))
            {
            case 272:
              if (!
#line 2966 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2163; /* altivec_dst */

            case 273:
              if (!
#line 2974 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2164; /* altivec_dstt */

            case 274:
              if (!
#line 2982 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2165; /* altivec_dstst */

            case 275:
              if (!
#line 2990 "../../gcc-15.0.1-20250313/gcc/config/rs6000/altivec.md"
(TARGET_ALTIVEC && GET_MODE (operands[0]) == Pmode))
                return -1;
              return 2166; /* altivec_dststt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x13 = XEXP (x1, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x14 = XEXP (x1, 0);
      switch (GET_CODE (x14))
        {
        case CONST_INT:
          if (XWINT (x14, 0) != 1L)
            return -1;
          return 998; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
          operands[0] = x14;
          if (!ordered_comparison_operator (operands[0], E_VOIDmode))
            return -1;
          x15 = XEXP (x14, 0);
          operands[1] = x15;
          x16 = XEXP (x14, 1);
          operands[2] = x16;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !reg_or_short_operand (operands[2], E_SImode))
                return -1;
              return 999; /* *rs6000.md:13918 */

            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !reg_or_short_operand (operands[2], E_DImode)
                  || !
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return -1;
              return 1000; /* *rs6000.md:13918 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case EH_RETURN:
      return 1046; /* eh_return_internal */

    case PREFETCH:
      x14 = XEXP (x1, 0);
      operands[0] = x14;
      if (!indexed_or_indirect_address (operands[0], E_VOIDmode))
        return -1;
      x13 = XEXP (x1, 1);
      operands[1] = x13;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x17 = XEXP (x1, 2);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      return 1047; /* prefetch */

    default:
      return -1;
    }
}

 rtx_insn *
split_11 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case IOR:
      res = split_10 (x1, insn);
      if (res != NULL_RTX)
        return res;
      break;

    case XOR:
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern263 (x2))
            {
            case 0:
              return gen_split_86 (insn, operands);

            case 1:
              if (
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))
                return gen_split_88 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case AND:
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) == ASHIFT)
            {
              switch (pattern219 (x2))
                {
                case 0:
                  if ((
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 4336 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return gen_split_106 (insn, operands);
                  break;

                case 1:
                  if (((
#line 4333 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(INTVAL (operands[2]) > 0
   && INTVAL (operands[2]) == exact_log2 (UINTVAL (operands[4]) + 1)) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 4336 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
( 1)))
                    return gen_split_108 (insn, operands);
                  break;

                default:
                  break;
                }
            }
          break;

        case ASHIFT:
          switch (pattern207 (x2))
            {
            case 0:
              if (
#line 4348 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], SImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])))
                return gen_split_111 (insn, operands);
              break;

            case 1:
              if ((
#line 4348 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(nonzero_bits (operands[3], DImode)
   < HOST_WIDE_INT_1U << INTVAL (operands[2])) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
                return gen_split_114 (insn, operands);
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_TImode:
      if (pattern358 (
E_TImode) != 0
          || !
#line 7424 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
        return NULL;
      return gen_split_239 (insn, operands);

    case E_PTImode:
      if (pattern358 (
E_PTImode) != 0
          || !
#line 7424 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
        return NULL;
      return gen_split_240 (insn, operands);

    case E_V16QImode:
      if (pattern358 (
E_V16QImode) != 0
          || !(
#line 7424 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_241 (insn, operands);

    case E_V8HImode:
      if (pattern358 (
E_V8HImode) != 0
          || !(
#line 7424 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_242 (insn, operands);

    case E_V4SImode:
      if (pattern358 (
E_V4SImode) != 0
          || !(
#line 7424 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_243 (insn, operands);

    case E_V4SFmode:
      if (pattern358 (
E_V4SFmode) != 0
          || !(
#line 7424 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_244 (insn, operands);

    case E_V2DImode:
      if (pattern358 (
E_V2DImode) != 0
          || !(
#line 7424 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_245 (insn, operands);

    case E_V2DFmode:
      if (pattern358 (
E_V2DFmode) != 0
          || !(
#line 7424 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_246 (insn, operands);

    case E_V1TImode:
      if (pattern358 (
E_V1TImode) != 0
          || !(
#line 7424 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
        return NULL;
      return gen_split_247 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || GET_MODE (x4) != E_TImode)
            return NULL;
          if (vlogical_operand (operands[0], E_TImode)
              && vlogical_operand (operands[1], E_TImode)
              && vlogical_operand (operands[2], E_TImode)
              && 
#line 7582 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], TImode)))
            return gen_split_270 (insn, operands);
          if (!int_reg_operand (operands[0], E_TImode)
              || !int_reg_operand (operands[1], E_TImode)
              || !int_reg_operand (operands[2], E_TImode)
              || !
#line 7611 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR))
            return NULL;
          return gen_split_279 (insn, operands);

        case E_PTImode:
          if (GET_MODE (x3) != E_PTImode
              || GET_MODE (x4) != E_PTImode)
            return NULL;
          if (vlogical_operand (operands[0], E_PTImode)
              && vlogical_operand (operands[1], E_PTImode)
              && vlogical_operand (operands[2], E_PTImode)
              && 
#line 7582 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], PTImode)))
            return gen_split_271 (insn, operands);
          if (!int_reg_operand (operands[0], E_PTImode)
              || !int_reg_operand (operands[1], E_PTImode)
              || !int_reg_operand (operands[2], E_PTImode)
              || !
#line 7611 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && !TARGET_P8_VECTOR))
            return NULL;
          return gen_split_280 (insn, operands);

        case E_V16QImode:
          if (pattern317 (x3, 
E_V16QImode) != 0
              || !(
#line 7582 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_272 (insn, operands);

        case E_V8HImode:
          if (pattern317 (x3, 
E_V8HImode) != 0
              || !(
#line 7582 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_273 (insn, operands);

        case E_V4SImode:
          if (pattern317 (x3, 
E_V4SImode) != 0
              || !(
#line 7582 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_274 (insn, operands);

        case E_V4SFmode:
          if (pattern317 (x3, 
E_V4SFmode) != 0
              || !(
#line 7582 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_275 (insn, operands);

        case E_V2DImode:
          if (pattern317 (x3, 
E_V2DImode) != 0
              || !(
#line 7582 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_276 (insn, operands);

        case E_V2DFmode:
          if (pattern317 (x3, 
E_V2DFmode) != 0
              || !(
#line 7582 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_277 (insn, operands);

        case E_V1TImode:
          if (pattern317 (x3, 
E_V1TImode) != 0
              || !(
#line 7582 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR && reload_completed
   && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_278 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          if (!vlogical_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !vlogical_operand (operands[1], E_TImode)
              || !
#line 7639 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], TImode)))
            return NULL;
          return gen_split_281 (insn, operands);

        case E_PTImode:
          if (!vlogical_operand (operands[0], E_PTImode)
              || GET_MODE (x3) != E_PTImode
              || !vlogical_operand (operands[1], E_PTImode)
              || !
#line 7639 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], PTImode)))
            return NULL;
          return gen_split_282 (insn, operands);

        case E_V16QImode:
          if (!vlogical_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !vlogical_operand (operands[1], E_V16QImode)
              || !(
#line 7639 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V16QImode)) && 
#line 778 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_283 (insn, operands);

        case E_V8HImode:
          if (!vlogical_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !vlogical_operand (operands[1], E_V8HImode)
              || !(
#line 7639 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V8HImode)) && 
#line 779 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_284 (insn, operands);

        case E_V4SImode:
          if (!vlogical_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !vlogical_operand (operands[1], E_V4SImode)
              || !(
#line 7639 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SImode)) && 
#line 780 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_285 (insn, operands);

        case E_V4SFmode:
          if (!vlogical_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !vlogical_operand (operands[1], E_V4SFmode)
              || !(
#line 7639 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V4SFmode)) && 
#line 781 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_286 (insn, operands);

        case E_V2DImode:
          if (!vlogical_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !vlogical_operand (operands[1], E_V2DImode)
              || !(
#line 7639 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DImode)) && 
#line 782 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_287 (insn, operands);

        case E_V2DFmode:
          if (!vlogical_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !vlogical_operand (operands[1], E_V2DFmode)
              || !(
#line 7639 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V2DFmode)) && 
#line 783 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_288 (insn, operands);

        case E_V1TImode:
          if (!vlogical_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !vlogical_operand (operands[1], E_V1TImode)
              || !(
#line 7639 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(reload_completed && int_reg_operand (operands[0], V1TImode)) && 
#line 784 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_ALTIVEC)))
            return NULL;
          return gen_split_289 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x2) != SET)
    return NULL;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case DIV:
      switch (pattern119 (x1, 
MOD))
        {
        case 0:
          if (!
#line 3539 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_1 (insn, operands);

        case 1:
          if (!(
#line 3539 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_2 (insn, operands);

        default:
          return NULL;
        }

    case UDIV:
      switch (pattern119 (x1, 
UMOD))
        {
        case 0:
          if (!
#line 3561 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_3 (insn, operands);

        case 1:
          if (!(
#line 3561 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_MODULO
   && ! reg_mentioned_p (operands[0], operands[1])
   && ! reg_mentioned_p (operands[0], operands[2])
   && ! reg_mentioned_p (operands[3], operands[1])
   && ! reg_mentioned_p (operands[3], operands[2])) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_4 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (GET_MODE (x3) != E_CCmode)
        return NULL;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!cc_reg_operand (operands[2], E_CCmode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x2, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!int_reg_operand (operands[1], E_SImode)
              || !int_reg_operand (operands[0], E_SImode)
              || !(
#line 8059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        case E_DImode:
          if (!int_reg_operand (operands[1], E_DImode)
              || !int_reg_operand (operands[0], E_DImode)
              || !(
#line 8059 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_6 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case HIGH:
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_SImode:
          operands[0] = x5;
          operands[1] = x3;
          if (int_reg_operand (operands[1], E_SImode)
              && pattern361 (x2, 
E_SImode) == 0)
            {
              if ((
#line 8074 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_7 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if ((
#line 8074 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && ((
#line 513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64) && 
#line 475 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_POWERPC64))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_8 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (peep2_current_count >= 3)
            {
              res = peephole2_1 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          if (!fusion_gpr_addis (operands[1], E_SImode))
            return NULL;
          switch (pattern362 (x2, 
E_SImode))
            {
            case 0:
              if (!(
#line 14717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_14 (insn, operands);

            case 1:
              if (!(
#line 14717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_15 (insn, operands);

            case 2:
              if (!(
#line 14717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_16 (insn, operands);

            case 3:
              if (!(
#line 14717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && ((
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 484 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 484 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                return NULL;
              *pmatch_len_ = 1;
              return gen_peephole2_17 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          operands[0] = x5;
          operands[1] = x3;
          if (int_reg_operand (operands[1], E_DImode)
              && pattern361 (x2, 
E_DImode) == 0
              && (
#line 8074 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!cc_reg_not_cr0_operand (operands[2], CCmode)) && 
#line 513 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_9 (insn, operands);
              if (res != NULL_RTX)
                return res;
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (fusion_gpr_addis (operands[1], E_DImode))
            {
              switch (pattern362 (x2, 
E_DImode))
                {
                case 0:
                  if ((
#line 14717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_18 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 1:
                  if ((
#line 14717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_19 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 2:
                  if ((
#line 14717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_20 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                case 3:
                  if ((
#line 14717 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_FUSION
   && fusion_gpr_load_p (operands[0], operands[1], operands[2],
			 operands[3])) && ((
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 484 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 484 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_21 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  break;

                default:
                  break;
                }
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_DImode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_DImode)
              && simple_offsettable_mem_operand (operands[2], E_DImode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_26 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_27 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_DImode)
              || !altivec_register_operand (operands[2], E_DImode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_32 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64)) && 
#line 858 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_POWERPC64))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_33 (insn, operands);

        case E_DFmode:
          operands[0] = x5;
          if (pattern264 (x3, 
E_DFmode) == 0
              && 
#line 10545 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_VSX
   && peep2_reg_dead_p (2, operands[0])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_11 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_DFmode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_DFmode)
              && simple_offsettable_mem_operand (operands[2], E_DFmode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_22 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_23 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_DFmode)
              || !altivec_register_operand (operands[2], E_DFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_28 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && 
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_29 (insn, operands);

        case E_SFmode:
          operands[0] = x5;
          if (pattern264 (x3, 
E_SFmode) == 0
              && 
#line 10554 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(!TARGET_P8_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_12 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          if (!fpr_reg_operand (operands[1], E_SFmode))
            return NULL;
          operands[2] = x3;
          x7 = XEXP (x2, 0);
          operands[3] = x7;
          if (altivec_register_operand (operands[3], E_SFmode)
              && simple_offsettable_mem_operand (operands[2], E_SFmode))
            {
              x8 = XEXP (x2, 1);
              if (rtx_equal_p (x8, operands[1]))
                {
                  if ((
#line 14757 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_24 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                  if ((
#line 14757 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
                    {
                      *pmatch_len_ = 1;
                      res = gen_peephole2_25 (insn, operands);
                      if (res != NULL_RTX)
                        return res;
                    }
                }
            }
          if (!simple_offsettable_mem_operand (operands[3], E_SFmode)
              || !altivec_register_operand (operands[2], E_SFmode))
            return NULL;
          x8 = XEXP (x2, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return NULL;
          if ((
#line 14793 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_32BIT) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_30 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!(
#line 14793 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_VSX && !TARGET_P9_VECTOR && peep2_reg_dead_p (2, operands[1])) && (((
#line 512 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_64BIT) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR)) && 
#line 857 "../../gcc-15.0.1-20250313/gcc/config/rs6000/rs6000.md"
(TARGET_P8_VECTOR))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_31 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x8 = XEXP (x2, 1);
      if (GET_CODE (x8) != ROTATE)
        return NULL;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return NULL;
      x7 = XEXP (x2, 0);
      operands[2] = x7;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_V1TImode:
          if (!int_reg_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || GET_MODE (x8) != E_V1TImode)
            return NULL;
          if (memory_operand (operands[1], E_V1TImode)
              && int_reg_operand (operands[2], E_V1TImode)
              && 
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_34 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!int_reg_operand (operands[1], E_V1TImode)
              || !memory_operand (operands[2], E_V1TImode)
              || !
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_36 (insn, operands);

        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || GET_MODE (x8) != E_TImode)
            return NULL;
          if (int_reg_operand (operands[0], E_TImode))
            {
              if (memory_operand (operands[1], E_TImode)
                  && int_reg_operand (operands[2], E_TImode)
                  && 
#line 1095 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_35 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              if (int_reg_operand (operands[1], E_TImode)
                  && memory_operand (operands[2], E_TImode)
                  && 
#line 1107 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_37 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          if (!vsx_register_operand (operands[0], E_TImode)
              || !vsx_register_operand (operands[1], E_TImode)
              || !vsx_register_operand (operands[2], E_TImode)
              || !
#line 1121 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(!BYTES_BIG_ENDIAN && TARGET_VSX && !TARGET_P9_VECTOR
   && (rtx_equal_p (operands[0], operands[2])
       || peep2_reg_dead_p (2, operands[0]))))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_38 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (peep2_current_count < 3
          || peep2_current_count < 4
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x5 = XEXP (x1, 0);
      operands[2] = x5;
      if (!int_reg_operand (operands[2], E_DImode))
        return NULL;
      x6 = XEXP (x3, 0);
      operands[3] = x6;
      if (!vsx_register_operand (operands[3], E_SImode))
        return NULL;
      x7 = XEXP (x2, 0);
      operands[4] = x7;
      if (!int_reg_operand (operands[4], E_SImode))
        return NULL;
      x8 = XEXP (x2, 1);
      if (GET_MODE (x8) != E_SImode)
        return NULL;
      x11 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x11) != SET)
        return NULL;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != ASHIFT
          || GET_MODE (x12) != E_DImode)
        return NULL;
      x13 = XEXP (x12, 1);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return NULL;
      x14 = XEXP (x11, 0);
      operands[7] = x14;
      if (!int_reg_operand (operands[7], E_DImode))
        return NULL;
      x15 = XEXP (x12, 0);
      operands[8] = x15;
      if (!int_reg_operand (operands[8], E_DImode))
        return NULL;
      x16 = PATTERN (peep2_next_insn (3));
      if (GET_CODE (x16) != SET)
        return NULL;
      x17 = XEXP (x16, 1);
      if (GET_CODE (x17) != UNSPEC
          || XVECLEN (x17, 0) != 1
          || XINT (x17, 1) != 62
          || GET_MODE (x17) != E_SFmode)
        return NULL;
      x18 = XEXP (x16, 0);
      operands[9] = x18;
      if (!vsx_register_operand (operands[9], E_SFmode))
        return NULL;
      x19 = XVECEXP (x17, 0, 0);
      if (!rtx_equal_p (x19, operands[7]))
        return NULL;
      switch (GET_CODE (x8))
        {
        case AND:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_39 (insn, operands);

        case IOR:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_40 (insn, operands);

        case XOR:
          x10 = XEXP (x8, 0);
          operands[5] = x10;
          if (!int_reg_operand (operands[5], E_SImode))
            return NULL;
          x9 = XEXP (x8, 1);
          operands[6] = x9;
          if (!reg_or_cint_operand (operands[6], E_SImode)
              || !
#line 6343 "../../gcc-15.0.1-20250313/gcc/config/rs6000/vsx.md"
(TARGET_DIRECT_MOVE_64BIT
   /* The REG_P (xxx) tests prevents SUBREG's, which allows us to use REGNO
      to compare registers, when the mode is different.  */
   && REG_P (operands[SFBOOL_MFVSR_D]) && REG_P (operands[SFBOOL_BOOL_D])
   && REG_P (operands[SFBOOL_BOOL_A1]) && REG_P (operands[SFBOOL_SHL_D])
   && REG_P (operands[SFBOOL_SHL_A])   && REG_P (operands[SFBOOL_MTVSR_D])
   && (REG_P (operands[SFBOOL_BOOL_A2])
       || CONST_INT_P (operands[SFBOOL_BOOL_A2]))
   && (REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_MFVSR_D])
       || peep2_reg_dead_p (2, operands[SFBOOL_MFVSR_D]))
   && (REGNO (operands[SFBOOL_MFVSR_D]) == REGNO (operands[SFBOOL_BOOL_A1])
       || (REG_P (operands[SFBOOL_BOOL_A2])
	   && REGNO (operands[SFBOOL_MFVSR_D])
		== REGNO (operands[SFBOOL_BOOL_A2])))
   && REGNO (operands[SFBOOL_BOOL_D]) == REGNO (operands[SFBOOL_SHL_A])
   && (REGNO (operands[SFBOOL_SHL_D]) == REGNO (operands[SFBOOL_BOOL_D])
       || peep2_reg_dead_p (3, operands[SFBOOL_BOOL_D]))
   && peep2_reg_dead_p (4, operands[SFBOOL_SHL_D])))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_41 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
